
CREATE OR REPLACE TRIGGER ACTIONS_T BEFORE INSERT ON ACTIONS
FOR EACH ROW
WHEN (NEW.actionId IS NULL)
BEGIN
 SELECT ACTIONS_S.NEXTVAL INTO :NEW.actionId FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ALERTRUNTIME_T BEFORE INSERT ON ALERTRUNTIME
FOR EACH ROW
WHEN (NEW.ALERTID IS NULL)
BEGIN
 SELECT ALERTRUNTIME_S.NEXTVAL INTO :NEW.ALERTID FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ATOMICPARADIGM_T BEFORE INSERT ON ATOMICPARADIGM
FOR EACH ROW
WHEN (NEW.PARADIGMID IS NULL)
BEGIN
 SELECT ATOMICPARADIGM_S.NEXTVAL INTO :NEW.PARADIGMID FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ATOMICRUNTIME_T BEFORE INSERT ON ATOMICRUNTIME
FOR EACH ROW
WHEN (NEW.atomicId IS NULL)
BEGIN
 SELECT ATOMICRUNTIME_S.NEXTVAL INTO :NEW.atomicId FROM dual;
END;
/

CREATE OR REPLACE TRIGGER datasource_T BEFORE INSERT ON datasource
FOR EACH ROW
WHEN (NEW.id IS NULL)
BEGIN
 SELECT datasource_S.NEXTVAL INTO :NEW.id FROM dual;
END;
/

CREATE OR REPLACE TRIGGER EDGEPARADIGM_T BEFORE INSERT ON EDGEPARADIGM
FOR EACH ROW
WHEN (NEW.paradigmId IS NULL)
BEGIN
 SELECT EDGEPARADIGM_S.NEXTVAL INTO :NEW.paradigmId FROM dual;
END;
/

CREATE OR REPLACE TRIGGER EDGERUNTIME_T BEFORE INSERT ON EDGERUNTIME
FOR EACH ROW
WHEN (NEW.edgeId IS NULL)
BEGIN
 SELECT EDGERUNTIME_S.NEXTVAL INTO :NEW.edgeId FROM dual;
END;
/

CREATE OR REPLACE TRIGGER FILTERS_T BEFORE INSERT ON FILTERS
FOR EACH ROW
WHEN (NEW.filterId IS NULL)
BEGIN
 SELECT FILTERS_S.NEXTVAL INTO :NEW.filterId FROM dual;
END;
/

CREATE OR REPLACE TRIGGER FUNCTIONS_T BEFORE INSERT ON FUNCTIONS
FOR EACH ROW
WHEN (NEW.functionId IS NULL)
BEGIN
 SELECT FUNCTIONS_S.NEXTVAL INTO :NEW.functionId FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ROUTINEPARADIGM_T BEFORE INSERT ON ROUTINEPARADIGM
FOR EACH ROW
WHEN (NEW.paradigmId IS NULL)
BEGIN
 SELECT ROUTINEPARADIGM_S.NEXTVAL INTO :NEW.paradigmId FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ROUTINERUNTIME_T BEFORE INSERT ON ROUTINERUNTIME
FOR EACH ROW
WHEN (NEW.routineId IS NULL)
BEGIN
 SELECT ROUTINERUNTIME_S.NEXTVAL INTO :NEW.routineId FROM dual;
END;
/

CREATE OR REPLACE TRIGGER RULES_T BEFORE INSERT ON RULES
FOR EACH ROW
WHEN (NEW.ruleId IS NULL)
BEGIN
 SELECT RULES_S.NEXTVAL INTO :NEW.ruleId FROM dual;
END;
/

CREATE OR REPLACE TRIGGER TRANSACTIONPARADIGM_T BEFORE INSERT ON TRANSACTIONPARADIGM
FOR EACH ROW
WHEN (NEW.paradigmId IS NULL)
BEGIN
 SELECT TRANSACTIONPARADIGM_S.NEXTVAL INTO :NEW.paradigmId FROM dual;
END;
/

CREATE OR REPLACE TRIGGER TRANSACTIONRUNTIME_T BEFORE INSERT ON TRANSACTIONRUNTIME
FOR EACH ROW
WHEN (NEW.transactionId IS NULL)
BEGIN
 SELECT TRANSACTIONRUNTIME_S.NEXTVAL INTO :NEW.transactionId FROM dual;
END;
/

CREATE OR REPLACE TRIGGER TRANSACTIONAGGREGATIONDAILY_T BEFORE INSERT ON TRANSACTIONAGGREGATIONDAILY
FOR EACH ROW
WHEN (NEW.aggregationId IS NULL)
BEGIN
 SELECT TRANSACTIONAGGREGATIONDAILY_S.NEXTVAL INTO :NEW.aggregationId FROM dual;
END;
/

CREATE OR REPLACE TRIGGER TRANSACTIONAGGREGATIONHOURLY_T BEFORE INSERT ON TRANSACTIONAGGREGATIONHOURLY
FOR EACH ROW
WHEN (NEW.aggregationId IS NULL)
BEGIN
 SELECT TRANSACTIONAGGREGATIONHOURLY_S.NEXTVAL INTO :NEW.aggregationId FROM dual;
END;
/

CREATE OR REPLACE TRIGGER UIGLOBALPROPERTIES_T BEFORE INSERT ON UIGLOBALPROPERTIES
FOR EACH ROW
WHEN (NEW.propertyId IS NULL)
BEGIN
 SELECT UIGLOBALPROPERTIES_S.NEXTVAL INTO :NEW.propertyId FROM dual;
END;
/

CREATE OR REPLACE TRIGGER UIDEFAULTGLOBALPROPERTIES_T BEFORE INSERT ON UIDEFAULTGLOBALPROPERTIES
FOR EACH ROW
WHEN (NEW.propertyId IS NULL)
BEGIN
 SELECT UIDEFAULTGLOBALPROPERTIES_S.NEXTVAL INTO :NEW.propertyId FROM dual;
END;
/

CREATE OR REPLACE TRIGGER UIATOMICPARADIGMPROPERTIES_T BEFORE INSERT ON UIATOMICPARADIGMPROPERTIES
FOR EACH ROW
WHEN (NEW.propertyId IS NULL)
BEGIN
 SELECT UIATOMICPARADIGMPROPERTIES_S.NEXTVAL INTO :NEW.propertyId FROM dual;
END;
/

CREATE OR REPLACE TRIGGER UIROUTINEPARADIGMPROPERTIES_T BEFORE INSERT ON UIROUTINEPARADIGMPROPERTIES
FOR EACH ROW
WHEN (NEW.propertyId IS NULL)
BEGIN
 SELECT UIROUTINEPARADIGMPROPERTIES_S.NEXTVAL INTO :NEW.propertyId FROM dual;
END;
/

CREATE OR REPLACE TRIGGER UIEDGEPARADIGMPROPERTIES_T BEFORE INSERT ON UIEDGEPARADIGMPROPERTIES
FOR EACH ROW
WHEN (NEW.propertyId IS NULL)
BEGIN
 SELECT UIEDGEPARADIGMPROPERTIES_S.NEXTVAL INTO :NEW.propertyId FROM dual;
END;
/

CREATE OR REPLACE TRIGGER UITRANPARADIGMPROPERTIES_T BEFORE INSERT ON UITRANPARADIGMPROPERTIES
FOR EACH ROW
WHEN (NEW.propertyId IS NULL)
BEGIN
 SELECT UITRANPARADIGMPROPERTIES_S.NEXTVAL INTO :NEW.propertyId FROM dual;
END;
/

CREATE OR REPLACE TRIGGER SESSIONRUNTIME_T BEFORE INSERT ON SESSIONRUNTIME
FOR EACH ROW
WHEN (NEW.id IS NULL)
BEGIN
 SELECT SESSIONRUNTIME_S.NEXTVAL INTO :NEW.id FROM dual;
END;
/

CREATE OR REPLACE TRIGGER SESSIONSPARADIGM_T BEFORE INSERT ON SESSIONSPARADIGM
FOR EACH ROW
WHEN (NEW.id IS NULL)
BEGIN
 SELECT SESSIONSPARADIGM_S.NEXTVAL INTO :NEW.id FROM dual;
END;
/

CREATE OR REPLACE TRIGGER WORKSPACES_T BEFORE INSERT ON WORKSPACES
FOR EACH ROW
WHEN (NEW.id IS NULL)
BEGIN
 SELECT WORKSPACES_S.NEXTVAL INTO :NEW.id FROM dual;
END;
/

CREATE OR REPLACE TRIGGER FUNCTIONEDGE_T BEFORE INSERT ON FUNCTIONEDGE
FOR EACH ROW
WHEN (NEW.paradigmId IS NULL)
BEGIN
 SELECT FUNCTIONEDGE_S.NEXTVAL INTO :NEW.paradigmId FROM dual;
END;
/

CREATE OR REPLACE TRIGGER PARADIGMINFODETAILS_T BEFORE INSERT ON PARADIGMINFODETAILS
FOR EACH ROW
WHEN (NEW.infoId IS NULL)
BEGIN
 SELECT PARADIGMINFODETAILS_S.NEXTVAL INTO :NEW.infoId FROM dual;
END;
/

