INSERT INTO TransactionParadigmIdTemp
	SELECT ParadigmId FROM TransactionParadigm
	WHERE SystemState = 1 AND NOT ParadigmId IN (SELECT TransactionParadigmId FROM TransactionRuntime)

INSERT INTO EdgeParadigmIdTemp
	SELECT ParadigmId FROM EdgeParadigm
	WHERE TransactionParadigmId IN (SELECT * FROM TransactionParadigmIdTemp)
	
INSERT INTO RoutineParadigmIdTemp
	SELECT ParadigmId FROM EdgeParadigm
	WHERE TransactionParadigmId IN (SELECT * FROM TransactionParadigmIdTemp)
	
INSERT INTO ActionIdTemp
	SELECT ActionId FROM ActionToEdge WHERE EdgeParadigmId IN (Select * FROM EdgeParadigmIdTemp) UNION
	SELECT ActionId FROM ActionToTransaction WHERE TransactionParadigmId IN (Select * FROM TransactionParadigmIdTemp)

DELETE FROM ActionToEdge
	WHERE ActionId IN (SELECT * FROM ActionIdTemp)
	
DELETE FROM ActionToTransaction
	WHERE ActionId IN (SELECT * FROM ActionIdTemp)
	
DELETE FROM Actions
	WHERE ActionId IN (SELECT * FROM ActionIdTemp)
	
INSERT INTO FunctionIdTemp
	SELECT FunctionId FROM FunctionToEdge WHERE EdgeParadigmId IN (Select * FROM EdgeParadigmIdTemp)
	
DELETE FROM FunctionToEdge 
	WHERE FunctionId IN (SELECT * FROM FunctionIdTemp)
	
DELETE FROM Functions
	WHERE FunctionId IN (SELECT * FROM FunctionIdTemp)
	
INSERT INTO RuleIdTemp
	SELECT RuleId FROM RuleToEdge WHERE EdgeParadigmId IN (Select * FROM EdgeParadigmIdTemp) UNION
	SELECT RuleId FROM RuleToTransaction WHERE TransactionParadigmId IN (Select * FROM TransactionParadigmIdTemp)
	
DELETE FROM RoutineParadigm 
	WHERE ParadigmId IN (SELECT * FROM RoutineParadigmIdTemp)
	
DELETE FROM RuleToEdge
	WHERE RuleId IN (SELECT * FROM RuleIdTemp)
	
DELETE FROM RuleToTransaction
	WHERE RuleId IN (SELECT * FROM RuleIdTemp)
	
DELETE FROM Rules
	WHERE RuleId IN (SELECT * FROM RuleIdTemp)
	
DELETE FROM EdgeParadigm
	WHERE ParadigmId IN (SELECT * FROM EdgeParadigmIdTemp)

DELETE FROM TransactionParadigm
	WHERE ParadigmId IN (SELECT * FROM TransactionParadigmIdTemp)
	
DELETE FROM TransactionParadigmIdTemp

DELETE FROM EdgeParadigmIdTemp

DELETE FROM RoutineParadigmIdTemp

DELETE FROM ActionIdTemp

DELETE FROM FunctionIdTemp

DELETE FROM RuleIdTemp