
CREATE TABLE principals (
  principalId varchar(50) NOT NULL,
  principalName varchar(50) NOT NULL default '',
  description varchar(100) default '',
  principalType varchar(50) default '',  
  principalMode integer default 0,
  extraInfo varchar(50) default '',
  timeModified bigint default '0',
  principalState integer default 0,
  counter bigint default 0,
  PRIMARY KEY  (principalId)
);
CREATE TABLE userPasswords (
  principalId varchar(50) NOT NULL,
  password varchar(1000) NOT NULL default '',
  PRIMARY KEY  (principalId)
);
CREATE TABLE associatedGroups (
  principalId varchar(50) NOT NULL,
  groupId varchar(1000) NOT NULL default '',
  grouptype varchar(50) default '',
  PRIMARY KEY  (principalId,groupId,grouptype)
);

CREATE TABLE principalPolicy (
  principalId varchar(50) NOT NULL,
  policyId varchar(50) NOT NULL default '',
  PRIMARY KEY  (principalId)
);

CREATE TABLE policyActions (
  policyId varchar(50) NOT NULL,
  actionId varchar(50) NOT NULL default '',
  PRIMARY KEY  (policyId,actionId)
);
