SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT;
SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS;
SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION;
SET NAMES utf8;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE=NO_AUTO_VALUE_ON_ZERO */;

CREATE TABLE `actionidtemp` (
  `actionId` int(11) default NULL
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `actions` (
  `actionId` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `description` varchar(100) default NULL,
  `type` varchar(200) NOT NULL default '',
  `actionData` text,
  `systemState` int(11) default NULL,
  `counter` int(11) NOT NULL default '0',
  `timeModified` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`actionId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `actiontoedge` (
  `actionId` int(11) NOT NULL default '0',
  `edgeParadigmId` int(11) NOT NULL default '0',
  `statusDimID` int(11) NOT NULL default '0',
  `statusValueFrom` int(11) NOT NULL default '0',
  `statusValueTo` int(11) NOT NULL default '0',
  PRIMARY KEY  (`actionId`,`edgeParadigmId`,`statusDimID`,`statusValueFrom`,`statusValueTo`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `actiontoroutine` (
  `actionId` int(11) NOT NULL default '0',
  `routineParadigmId` int(11) NOT NULL default '0',
  `statusDimId` int(11) NOT NULL default '0',
  `statusValueFrom` int(11) NOT NULL default '0',
  `statusValueTo` int(11) NOT NULL default '0',
  PRIMARY KEY  (`actionId`,`routineParadigmId`,`statusDimId`,`statusValueFrom`,`statusValueTo`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `actiontotransaction` (
  `actionId` int(11) NOT NULL default '0',
  `transactionParadigmId` int(11) NOT NULL default '0',
  `statusDimId` int(11) NOT NULL default '0',
  `statusValueFrom` int(11) NOT NULL default '0',
  `statusValueTo` int(11) NOT NULL default '0',
  PRIMARY KEY  (`actionId`,`transactionParadigmId`,`statusDimId`,`statusValueFrom`,`statusValueTo`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `aggregationcleanidtemp` (
  `aggregationId` int(11) NOT NULL default '0'
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `alerthistory` (
  `alertId` bigint(20) NOT NULL default '0',
  `alertType` varchar(50) NOT NULL default '',
  `alertCreated` bigint(20) NOT NULL default '0',
  `alertData` text NOT NULL,
  `systemState` int(11) default NULL
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `alertruntime` (
  `alertId` bigint(20) NOT NULL auto_increment,
  `alertType` varchar(100) NOT NULL default '',
  `alertCreated` bigint(20) NOT NULL default '0',
  `alertData` text NOT NULL,
  `systemState` int(11) default NULL,
  PRIMARY KEY  (`alertId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `atomichistory` (
  `atomicId` bigint(20) NOT NULL default '0',
  `atomicParadigmId` int(11) NOT NULL default '0',
  `atomicData` text NOT NULL,
  `dataRef` VARCHAR(250),
  `metadata` text NOT NULL,
  `systemState` int(11) default NULL,
  PRIMARY KEY  (`atomicId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `atomicparadigm` (
  `paradigmId` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `description` varchar(100) default NULL,
  `dataSource` varchar(200) default NULL,
  `dataSourceFilter` varchar(200) default NULL,
  `Type` varchar(50) default NULL,
  `data` text,
  `systemState` int(11) default NULL,
  `counter` int(11) NOT NULL default '0',
  `timeModified` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`paradigmId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `atomicruntime` (
  `atomicId` bigint(20) NOT NULL auto_increment,
  `atomicParadigmId` int(11) NOT NULL default '0',
  `atomicData` text NOT NULL,
  `dataRef` VARCHAR(250),
  `metadata` text NOT NULL,
  `systemState` int(11) default NULL,
  PRIMARY KEY  (`atomicId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `datasource` (
  `id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `dsName` VARCHAR(45) NOT NULL,
  `dsDescription` VARCHAR(250),
  `dsNodeId` VARCHAR(45),
  `dsLbmId` VARCHAR(45) NOT NULL,
  `dsFilterId` VARCHAR(45),
  PRIMARY KEY(`id`)
)ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `dummyroutineruntime` (
  `routineKey` text,
  `routineParadigmId` int(11) NOT NULL default '0',
  `transactionRuntime` bigint(20) NOT NULL default '0',
  `systemState` int(11) default NULL
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `edgecleanidtemp` (
  `edgeId` bigint(20) NOT NULL default '0'
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `edgehistory` (
  `edgeId` bigint(20) NOT NULL default '0',
  `edgeParadigmId` int(11) NOT NULL default '0',
  `edgeType` varchar(50) NOT NULL default '',
  `transactionRuntimeId` bigint(20) default NULL,
  `runtimeSourceId` bigint(20) default NULL,
  `runtimeTargetId` bigint(20) default NULL,
  `systemState` int(11) default NULL,
  `edgeCount` int(11) NOT NULL default '1',
  PRIMARY KEY  (`edgeId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `edgeidtemp` (
  `edgeId` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`edgeId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `edgeparadigm` (
  `paradigmId` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `description` varchar(100) default NULL,
  `transactionParadigmId` int(11) NOT NULL default '0',
  `sourceParadigmId` int(11) NOT NULL default '0',
  `targetParadigmId` int(11) NOT NULL default '0',
  `type` varchar(50) NOT NULL default '',
  `systemState` int(11) default NULL,
  `counter` int(11) NOT NULL default '0',
  `timeModified` bigint(20) NOT NULL default '0',
  `edgeRepeat` int(11) NOT NULL default '1',
  `logicType` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`paradigmId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `edgeparadigmidtemp` (
  `paradigmId` int(11) default NULL
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `edgeruntime` (
  `edgeId` bigint(20) NOT NULL auto_increment,
  `edgeParadigmId` int(11) NOT NULL default '0',
  `edgeType` varchar(50) NOT NULL default '',
  `transactionRuntimeId` bigint(20) default NULL,
  `runtimeSourceId` bigint(20) default NULL,
  `runtimeTargetId` bigint(20) default NULL,
  `systemState` int(11) default NULL,
  `edgeCount` int(11) NOT NULL default '1',
  PRIMARY KEY  (`edgeId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `filters` (
  `filterId` int(11) NOT NULL auto_increment,
  `atomicParadigmId` int(11) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `description` varchar(100) default NULL,
  `type` varchar(50) NOT NULL default '',
  `data` text NOT NULL,
  `systemState` int(11) default NULL,
  `counter` int(11) NOT NULL default '0',
  `timeModified` bigint(20) NOT NULL default '0',
  `isStatusFilter` int(11) default NULL,
  `isDisplayFilter` int(11) default NULL,
  PRIMARY KEY  (`filterId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `functionidtemp` (
  `functionId` int(11) default NULL
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `functions` (
  `functionId` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `description` varchar(100) default NULL,
  `type` varchar(50) NOT NULL default '',
  `data` text NOT NULL,
  `systemState` int(11) default NULL,
  `counter` int(11) NOT NULL default '0',
  `timeModified` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`functionId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `functiontoedge` (
  `edgeParadigmId` int(11) NOT NULL default '0',
  `functionId` int(11) NOT NULL default '0'
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `routinecleanidtemp` (
  `routineRuntimeId` bigint(20) NOT NULL default '0',
  `atomicRuntimeId` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`routineRuntimeId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `routinehistory` (
  `routineId` bigint(20) NOT NULL default '0',
  `routineParadigmId` int(11) NOT NULL default '0',
  `transactionRuntimeId` bigint(20) default NULL,
  `atomicRuntimeId` bigint(20) NOT NULL default '0',
  `timeCreated` bigint(20) NOT NULL default '0',
  `systemState` int(11) default NULL,
  PRIMARY KEY  (`routineId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `routineidtemp` (
  `routineRuntimeId` bigint(20) NOT NULL default '0',
  `atomicRuntimeId` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`routineRuntimeId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `routineparadigm` (
  `paradigmId` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `description` varchar(100) default NULL,
  `atomicParadigmId` int(11) NOT NULL default '0',
  `transactionParadigmId` int(11) NOT NULL default '0',
  `systemState` int(11) default NULL,
  `counter` int(11) NOT NULL default '0',
  `timeModified` bigint(20) NOT NULL default '0',
  `logicType` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`paradigmId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `routineparadigmidtemp` (
  `paradigmId` int(11) default NULL
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `routineruntime` (
  `routineId` bigint(20) NOT NULL auto_increment,
  `routineParadigmId` int(11) NOT NULL default '0',
  `transactionRuntimeId` bigint(20) default NULL,
  `atomicRuntimeId` bigint(20) NOT NULL default '0',
  `routineKey` text,
  `timeCreated` bigint(20) NOT NULL default '0',
  `systemState` int(11) default NULL,
  PRIMARY KEY  (`routineId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `rules` (
  `ruleId` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `description` varchar(100) default NULL,
  `type` varchar(50) NOT NULL default '',
  `data` text NOT NULL,
  `systemState` int(11) default NULL,
  `counter` int(11) NOT NULL default '0',
  `timeModified` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`ruleId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `ruletoedge` (
  `ruleId` int(11) NOT NULL default '0',
  `edgeParadigmId` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ruleId`,`edgeParadigmId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `ruletotransaction` (
  `ruleId` int(11) NOT NULL default '0',
  `transactionParadigmId` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ruleId`,`transactionParadigmId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `statusaggregationdaily` (
  `aggregationId` int(11) NOT NULL default '0',
  `statusDimensionId` int(11) NOT NULL default '0',
  `statusValueId` int(11) NOT NULL default '0',
  `aggregationValue` int(11) NOT NULL default '0',
  PRIMARY KEY  (`aggregationId`,`statusDimensionId`,`statusValueId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `statusaggregationhourly` (
  `aggregationId` int(11) NOT NULL default '0',
  `statusDimensionId` int(11) NOT NULL default '0',
  `statusValueId` int(11) NOT NULL default '0',
  `aggregationValue` int(11) NOT NULL default '0',
  PRIMARY KEY  (`aggregationId`,`statusDimensionId`,`statusValueId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `statusdimension` (
  `statusId` int(11) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`statusId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `statustoedge` (
  `statusDimId` int(11) NOT NULL default '0',
  `edgeParadigmId` int(11) NOT NULL default '0',
  PRIMARY KEY  (`statusDimId`,`edgeParadigmId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `statustoedgehistory` (
  `edgeRuntimeId` bigint(20) NOT NULL default '0',
  `statusDimensionId` int(11) NOT NULL default '0',
  `statusValueId` int(11) NOT NULL default '0',
  PRIMARY KEY  (`edgeRuntimeId`,`statusDimensionId`,`statusValueId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `statustoedgeruntime` (
  `edgeRuntimeId` bigint(20) NOT NULL default '0',
  `statusDimensionId` int(11) NOT NULL default '0',
  `statusValueId` int(11) NOT NULL default '0',
  PRIMARY KEY  (`edgeRuntimeId`,`statusDimensionId`,`statusValueId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `statustoroutine` (
  `statusDimId` int(11) NOT NULL default '0',
  `routineParadigmId` int(11) NOT NULL default '0',
  PRIMARY KEY  (`statusDimId`,`routineParadigmId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `statustoroutinehistory` (
  `routineRuntimeId` bigint(20) NOT NULL default '0',
  `statusDimension` int(11) NOT NULL default '0',
  `statusValueId` int(11) NOT NULL default '0',
  PRIMARY KEY  (`routineRuntimeId`,`statusDimension`,`statusValueId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `statustoroutineruntime` (
  `routineRuntimeId` bigint(20) NOT NULL default '0',
  `statusDimension` int(11) NOT NULL default '0',
  `statusValueId` int(11) NOT NULL default '0',
  PRIMARY KEY  (`routineRuntimeId`,`statusDimension`,`statusValueId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `statustotransaction` (
  `statusId` int(11) NOT NULL default '0',
  `transactionParadigmId` int(11) NOT NULL default '0',
  PRIMARY KEY  (`statusId`,`transactionParadigmId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `statustotransactionhistory` (
  `transactionRuntimeId` bigint(20) NOT NULL default '0',
  `statusDimensionId` int(11) NOT NULL default '0',
  `statusValueId` int(11) NOT NULL default '0',
  PRIMARY KEY  (`transactionRuntimeId`,`statusDimensionId`,`statusValueId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `statustotransactionruntime` (
  `transactionRuntimeId` bigint(20) NOT NULL default '0',
  `statusDimensionId` int(11) NOT NULL default '0',
  `statusValueId` int(11) NOT NULL default '0',
  PRIMARY KEY  (`transactionRuntimeId`,`statusDimensionId`,`statusValueId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `statusvalues` (
  `statusDimId` int(11) NOT NULL default '0',
  `statusValueId` int(11) NOT NULL default '0',
  `statusValue` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`statusDimId`,`statusValueId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `transactionaggregationdaily` (
  `aggregationId` int(11) NOT NULL auto_increment,
  `startTime` bigint(20) NOT NULL default '0',
  `endTime` bigint(20) NOT NULL default '0',
  `transactionParadigmId` int(11) NOT NULL default '0',
  `type` int(11) NOT NULL default '0',
  PRIMARY KEY  (`aggregationId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `transactionaggregationhourly` (
  `aggregationId` int(11) NOT NULL auto_increment,
  `startTime` bigint(20) NOT NULL default '0',
  `endTime` bigint(20) NOT NULL default '0',
  `transactionParadigmId` int(11) NOT NULL default '0',
  `type` int(11) NOT NULL default '0',
  PRIMARY KEY  (`aggregationId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `transactioncleanidtemp` (
  `transactionId` bigint(20) NOT NULL default '0'
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `transactionerrorhistory` (
  `transactionId` bigint(20) NOT NULL default '0',
  `transactionParadigmId` int(11) NOT NULL default '0',
  `timeCreated` bigint(20) NOT NULL default '0',
  `timeModified` bigint(20) NOT NULL default '0',
  `systemState` int(11) default NULL,
  `applicationName` text,
  PRIMARY KEY  (`transactionId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `transactionfilters` (
  `transactionParadigmId` int(11) NOT NULL default '0',
  `routineParadigmId` int(11) NOT NULL default '0',
  `filterId` int(11) NOT NULL default '0',
  `isStatusFilter` int(11) default NULL,
  `isDisplayFilter` int(11) default NULL,
  PRIMARY KEY  (`transactionParadigmId`,`routineParadigmId`,`filterId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `transactionhistory` (
  `transactionId` bigint(20) NOT NULL default '0',
  `transactionParadigmId` int(11) NOT NULL default '0',
  `timeCreated` bigint(20) NOT NULL default '0',
  `timeModified` bigint(20) NOT NULL default '0',
  `systemState` int(11) default NULL,
  `applicationName` text,
  PRIMARY KEY  (`transactionId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `transactionidtemp` (
  `transactionId` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`transactionId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `transactionparadigm` (
  `paradigmId` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `description` varchar(100) default NULL,
  `systemState` int(11) default NULL,
  `counter` int(11) NOT NULL default '0',
  `timeModified` bigint(20) NOT NULL default '0',
  `applicationNameAtomicId` int(11) default NULL,
  `applicationNameAtomicIndex` int(11) default NULL,
  PRIMARY KEY  (`paradigmId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `transactionparadigmidtemp` (
  `paradigmId` int(11) default NULL
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `transactionparadigmpermissions` (
  `transactionParadigmId` int(11) NOT NULL default '0',
  `permissionType` varchar(20) NOT NULL default '',
  `entetyName` text NOT NULL
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `transactionruntime` (
  `transactionId` bigint(20) NOT NULL auto_increment,
  `transactionParadigmId` int(11) NOT NULL default '0',
  `timeCreated` bigint(20) NOT NULL default '0',
  `timeModified` bigint(20) NOT NULL default '0',
  `systemState` int(11) default NULL,
  `applicationName` text,
  PRIMARY KEY  (`transactionId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `uiatomicparadigmproperties` (
  `propertyId` int(11) NOT NULL auto_increment,
  `atomicParadigmId` int(11) default NULL,
  `globalPropertyId` int(11) default NULL,
  `propertyType` varchar(200) NOT NULL default '',
  `propertyName` varchar(200) NOT NULL default '',
  `propertyKey` varchar(200) NOT NULL default '',
  `propertyValue` text NOT NULL,
  PRIMARY KEY  (`propertyId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `uidefaultglobalproperties` (
  `propertyId` int(11) NOT NULL auto_increment,
  `propertyType` varchar(200) NOT NULL default '',
  `propertyName` varchar(200) NOT NULL default '',
  `propertyKey` varchar(200) NOT NULL default '',
  `propertyValue` text NOT NULL,
  PRIMARY KEY  (`propertyId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `uiedgeparadigmproperties` (
  `propertId` int(11) NOT NULL auto_increment,
  `edgeParadigmId` int(11) default NULL,
  `globalPropertyId` int(11) default NULL,
  `propertyType` varchar(200) NOT NULL default '',
  `propertyName` varchar(200) NOT NULL default '',
  `propertyKey` varchar(200) NOT NULL default '',
  `propertyValue` text NOT NULL,
  PRIMARY KEY  (`propertId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `uiglobalproperties` (
  `propertyId` int(11) NOT NULL auto_increment,
  `propertyType` varchar(200) NOT NULL default '',
  `propertyName` varchar(200) NOT NULL default '',
  `propertyKey` varchar(200) NOT NULL default '',
  `propertyValue` text NOT NULL,
  PRIMARY KEY  (`propertyId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `uiroutineparadigmproperties` (
  `propertyId` int(11) NOT NULL auto_increment,
  `routineParadigmId` int(11) default NULL,
  `globalPropertyId` int(11) default NULL,
  `propertyType` varchar(200) NOT NULL default '',
  `propertyName` varchar(200) NOT NULL default '',
  `propertyKey` varchar(200) NOT NULL default '',
  `propertyValue` text NOT NULL,
  PRIMARY KEY  (`propertyId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `uitranparadigmproperties` (
  `propertyId` int(11) NOT NULL auto_increment,
  `transactionParadigmId` int(11) default NULL,
  `globalPropertyId` int(11) default NULL,
  `propertyType` varchar(200) NOT NULL default '',
  `propertyName` varchar(200) NOT NULL default '',
  `propertyKey` varchar(200) NOT NULL default '',
  `propertyValue` text NOT NULL,
  PRIMARY KEY  (`propertyId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `sessionparadigmtoworkspace` (
  `workspaceId` int(10) unsigned NOT NULL auto_increment,
  `sessionParadigmId` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`workspaceId`,`sessionParadigmId`),
  KEY `FK_sessiontoworkspace_2` (`sessionParadigmId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `sessionruntime` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `sessionParadigmId` int(10) unsigned NOT NULL default '0',
  `startTime` bigint(20) unsigned NOT NULL default '0',
  `endTime` bigint(20) unsigned NOT NULL default '0',
  `state` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `sessionsparadigm` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(45) NOT NULL default '',
  `description` varchar(255) default NULL,
  `filter` text default NULL,
  `cronexp` varchar(50) default NULL,
  `timestamp` bigint(20) unsigned NOT NULL default '0',
  `state` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `transactiontosessionparadigm` (
  `transactionId` int(10) unsigned NOT NULL default '0',
  `sessionId` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`transactionId`,`sessionId`),
  KEY `FK_transactiontosession_1` (`sessionId`),
  CONSTRAINT `FK_transactiontosession_1` FOREIGN KEY (`sessionId`) REFERENCES `sessionsparadigm` (`id`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `transactiontosessionruntime` (
  `sessionRuntimeId` int(10) unsigned NOT NULL default '0',
  `transactionRuntimeId` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`sessionRuntimeId`,`transactionRuntimeId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `workspaces` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `woName` varchar(100) default NULL,
  `woDescription` varchar(255) NOT NULL default '',
  `timestamp` bigint(20) unsigned NOT NULL default '0',
  `state` int(10) unsigned default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `functionEdge` (
  `paradigmId` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `description` varchar(100) default NULL,
  `transactionParadigmId` int(11) NOT NULL default '0',
  `sourceParadigmId` int(11) NOT NULL default '0',
  `targetParadigmId` int(11) NOT NULL default '0',
  `type` varchar(50) NOT NULL default '',
  `systemState` int(11) default NULL,
  `counter` int(11) NOT NULL default '0',
  `timeModified` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`paradigmId`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;
CREATE TABLE `transactionSessionBrowsingData` (
  `transactionId` int(10) unsigned NOT NULL default '0',
  `sessionId` int(10) unsigned NOT NULL default '0',
  `dataType` int(10) unsigned NOT NULL default '0',
  `data` text default NULL,
  PRIMARY KEY  (`transactionId`,`sessionId`,`dataType`)
) ENGINE=MYISAM DEFAULT CHARSET=latin1;



/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT;*/
/*SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS;*/
/*SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION;*/
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;