if not exists (select * from statusDimension where statusId = 1)
INSERT INTO statusDimension (statusId,name) VALUES (1,'Topology')

if not exists (select * from statusDimension where statusId = 2)
INSERT INTO statusDimension (statusId,name) VALUES (2,'TransactionTime')

if not exists (select * from statusDimension where statusId = 3)
INSERT INTO statusDimension (statusId,name) VALUES (3,'EdgeTime')

if not exists (select * from statusDimension where statusId = 4)
INSERT INTO statusDimension (statusId,name) VALUES (4,'Flow')

if not exists (select * from statusDimension where statusId = 5)
INSERT INTO statusDimension (statusId,name) VALUES (5,'Data')



if not exists (select * from statusValues where statusDimId = 1 and statusValueId=1)
INSERT INTO statusValues (statusDimId,statusValueId,statusValue) VALUES (1,1,'Open')

if not exists (select * from statusValues where statusDimId = 1 and statusValueId=2)
INSERT INTO statusValues (statusDimId,statusValueId,statusValue) VALUES (1,2,'Close')

if not exists (select * from statusValues where statusDimId = 1 and statusValueId=3)
INSERT INTO statusValues (statusDimId,statusValueId,statusValue) VALUES (1,3,'Partial')

if not exists (select * from statusValues where statusDimId = 1 and statusValueId=4)
INSERT INTO statusValues (statusDimId,statusValueId,statusValue) VALUES (1,4,'Partial Close')

if not exists (select * from statusValues where statusDimId = 2 and statusValueId=0)
INSERT INTO statusValues (statusDimId,statusValueId,statusValue) VALUES (2,0,'None')

if not exists (select * from statusValues where statusDimId = 2 and statusValueId=1)
INSERT INTO statusValues (statusDimId,statusValueId,statusValue) VALUES (2,1,'Success')

if not exists (select * from statusValues where statusDimId = 2 and statusValueId=2)
INSERT INTO statusValues (statusDimId,statusValueId,statusValue) VALUES (2,2,'Failed')

if not exists (select * from statusValues where statusDimId = 2 and statusValueId=3)
INSERT INTO statusValues (statusDimId,statusValueId,statusValue) VALUES (2,3,'Warning')

if not exists (select * from statusValues where statusDimId = 3 and statusValueId=0)
INSERT INTO statusValues (statusDimId,statusValueId,statusValue) VALUES (3,0,'None')

if not exists (select * from statusValues where statusDimId = 3 and statusValueId=1)
INSERT INTO statusValues (statusDimId,statusValueId,statusValue) VALUES (3,1,'Success')

if not exists (select * from statusValues where statusDimId = 3 and statusValueId=2)
INSERT INTO statusValues (statusDimId,statusValueId,statusValue) VALUES (3,2,'Failed')

if not exists (select * from statusValues where statusDimId = 4 and statusValueId=0)
INSERT INTO statusValues (statusDimId,statusValueId,statusValue) VALUES (4,0,'None')

if not exists (select * from statusValues where statusDimId = 4 and statusValueId=1)
INSERT INTO statusValues (statusDimId,statusValueId,statusValue) VALUES (4,1,'OK')

if not exists (select * from statusValues where statusDimId = 4 and statusValueId=2)
INSERT INTO statusValues (statusDimId,statusValueId,statusValue) VALUES (4,2,'Error')

if not exists (select * from statusValues where statusDimId = 5 and statusValueId=1)
INSERT INTO statusValues (statusDimId,statusValueId,statusValue) VALUES (5,1,'OK')

if not exists (select * from statusValues where statusDimId = 5 and statusValueId=2)
INSERT INTO statusValues (statusDimId,statusValueId,statusValue) VALUES (5,2,'Error')



/** Insert default UI preferences **/
if not exists (select * from UIDefaultGlobalProperties where propertyType = 'Images' and propertyKey = 'transactionParadigm')
INSERT INTO UIDefaultGlobalProperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default transaction paradigm','transactionParadigm','logic/images/graph/transactionParadigm.gif')

if not exists (select * from UIDefaultGlobalProperties where propertyType = 'Images' and propertyKey = 'routineParadigm')
INSERT INTO UIDefaultGlobalProperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default routine paradigm','routineParadigm','logic/images/graph/routineParadigm.gif')

if not exists (select * from UIDefaultGlobalProperties where propertyType = 'Images' and propertyKey = 'transactionRuntime')
INSERT INTO UIDefaultGlobalProperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default transaction runtime','transactionRuntime','logic/images/graph/runtime/transactions/transactionRuntime.gif')

if not exists (select * from UIDefaultGlobalProperties where propertyType = 'Images' and propertyKey = 'routineRuntime')
INSERT INTO UIDefaultGlobalProperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default routine runtime','routineRuntime','logic/images/graph/runtime/routines/routineRuntime.gif')

if not exists (select * from UIDefaultGlobalProperties where propertyType = 'Images' and propertyKey = 'routineRuntimeError')
INSERT INTO UIDefaultGlobalProperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default routine runtime error','routineRuntimeError','logic/images/graph/runtime/routines/routineRuntimeError.gif')

if not exists (select * from UIDefaultGlobalProperties where propertyType = 'Images' and propertyKey = 'dummyRoutine')
INSERT INTO UIDefaultGlobalProperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default dummy routine','dummyRoutine','logic/images/graph/runtime/routines/routineDummy.gif')

if not exists (select * from UIDefaultGlobalProperties where propertyType = 'Images' and propertyKey = 'dummyRoutineError')
INSERT INTO uidefaultglobalproperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default dummy routine error','dummyRoutineError','logic/images/graph/runtime/routines/routineDummyError.gif');

if not exists (select * from UIDefaultGlobalProperties where propertyType = 'Images' and propertyKey = 'subTransactionRuntime')
INSERT INTO UIDefaultGlobalProperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default transaction runtime','subTransactionRuntime','logic/images/graph/runtime/transactions/subTransactionRuntime.gif')

if not exists (select * from UIDefaultGlobalProperties where propertyType = 'Images' and propertyKey = 'subTransactionRuntimeError')
INSERT INTO UIDefaultGlobalProperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default transaction runtime error','subTransactionRuntimeError','logic/images/graph/runtime/transactions/subTransactionRuntimeError.gif')

if not exists (select * from UIDefaultGlobalProperties where propertyType = 'Images' and propertyKey = 'dummySubTransaction')
INSERT INTO UIDefaultGlobalProperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default dummy transaction','dummySubTransaction','logic/images/graph/runtime/transactions/subTransactionDummy.gif')

if not exists (select * from UIDefaultGlobalProperties where propertyType = 'Images' and propertyKey = 'dummySubTransactionError')
INSERT INTO UIDefaultGlobalProperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default dummy transaction error','dummySubTransactionError','logic/images/graph/runtime/transactions/subTransactionDummyError.gif')


if not exists (select * from ParadigmInfoDetails where infoName = 'Global Algorithm' and infoKey = 'transactionAlgorithm')
INSERT INTO ParadigmInfoDetails (infoName,infoDesc,infoKey,infoValue,isDefault) VALUES ('Global Algorithm','','transactionAlgorithm','GlobalAlgorithm',1);

if not exists (select * from ParadigmInfoDetails where infoName = 'Linear Algorithm' and infoKey = 'transactionAlgorithm')
INSERT INTO ParadigmInfoDetails (infoName,infoDesc,infoKey,infoValue,isDefault) VALUES ('Linear Algorithm','','transactionAlgorithm','LinearAlgorithm',0);

/** Insert default online settings **/
INSERT INTO workspaces (woName,woDescription,timestamp,state) VALUES ('Monitoring','transaction monitoring, Do Not Delete','0','0');
/**UPDATE workspaces SET id='0' WHERE id='1';**/
INSERT INTO sessionsparadigm (name,description,filter,cronexp,timestamp,state,hoursToKeep) VALUES ('Monitor','monitor project, Do Not Delete',' ',' ','0','0','120');
/**UPDATE sessionsparadigm SET id='0' WHERE id='1';**/
INSERT INTO sessionruntime (sessionParadigmId,startTime,endTime,createdTime,state) VALUES ('0','0','0','0','0');
/**UPDATE sessionruntime SET id='0' WHERE id='1';**/
INSERT INTO sessionparadigmtoworkspace (workspaceId,sessionParadigmId) VALUES ('0','0');
UPDATE sessionparadigmtoworkspace SET workspaceId='0' WHERE workspaceId='1';


