<%@ page language="java"%><%@ page import="xpolog.eye.*"%><%@ page import="xpolog.eye.remote.*"%><%@ page import="xpolog.eye.data.index.*"%><%@ page import="java.io.*"%><%@ page import="java.util.*"%><%@ page import="xpolog.eye.data.*"%><%@ page import="xpolog.eye.data.RecordsResult"%><%@ page import="xpolog.eye.data.source.*"%><%@ page import="xpolog.eye.data.linear.*"%><%@ page import="xpolog.eye.common.JobStatus"%><%@ page import="java.util.zip.*"%><%@page import="xpolog.eye.data.aggregate.admin.LogAggregationConf"%><%@page import="xpolog.eye.data.aggregate.TimeFramesAggregatorResults"%><%@page import="xpolog.eye.data.aggregate.admin.AggregationHelper"%><%  
	final int OK_CODE = 0;
	final int ERROR_CODE = 1;
	//System.out.println("log api connection established");
	
	response.setHeader("Content-Type", "application/octet-stream");
	String logId = request.getParameter("logId").trim();
	String sessionId = request.getParameter("sessionId").trim();
	String command = request.getParameter("command").trim();
	String data = request.getParameter("data");
	data = data == null? "" : data.trim();
	String requestId = request.getParameter("requestId").trim();
	Object dataObj = null;
	
	RemoteSessionMgr sesMgr = RemoteSessionMgr.getInstance();
	//System.out.println("command: "+command);
	//System.out.println("req id: "+requestId);
	//System.out.println("logId: "+logId);
	
	
	if(requestId != null && !requestId.equals("") && sessionId != null) {
		Session s = sesMgr.getSession(sessionId);
		dataObj = s.getObject(requestId);
		//System.out.println("inside request obj " + dataObj);
		s.unregisterObject(requestId);
	}
	
	LogBrowsingManager lbm = null;
	SiteManagment mgmt = SiteManagment.getInstance();
	
	//prepare the output stream.
	ObjectOutputStream os = null;
	try {
		GZIPOutputStream gzos = new GZIPOutputStream(response.getOutputStream());
		os = new ObjectOutputStream(gzos);
		//os = new ObjectOutputStream(response.getOutputStream());
	}catch (Exception e) {
		//e.printStackTrace();
	}
	//check if register or unregister a session
	if(command != null && command.equals("registerSession")) {
			//System.out.println("inside register");
			try {
				Session sesToReg = new Session();
		
				String newSessionId = sesMgr.registerSession(sesToReg);
				//System.out.println("newSessionId: "+newSessionId);
				if(newSessionId != null) {
					os.writeInt(OK_CODE);
					os.writeObject(newSessionId);
				}else {
					os.writeInt(ERROR_CODE);
				}
			}catch(Exception e) {
				//e.printStackTrace();
				os.writeInt(ERROR_CODE);
			}
			os.flush();
			os.close();
			return;
		}else if(sessionId != null && command != null && command.equals("unregisterSession")) {
			try {
				boolean result = sesMgr.unregisterSsesion(sessionId);
				if(result) {
					os.writeInt(OK_CODE);
				}else {
					os.writeInt(ERROR_CODE);
				}
			}catch(Exception e) {
				os.writeInt(ERROR_CODE);
			}
			os.flush();
			os.close();
			return;
		}
	//System.out.println("session id: "+sessionId + " session: "+ sesMgr.getSession(sessionId));
	
	if(command != null && sessionId != null && logId != null && sessionId.length() > 0){		
		Session ses = (Session)sesMgr.getSession(sessionId);
		
		if (ses == null){
			ses = new Session();		
			sesMgr.registerSession(ses,sessionId);
		}
		//try to load the proper log.
		lbm = (LogBrowsingManager)ses.getObject(logId);
		if(lbm == null){
			lbm = mgmt.getLogBrowserManager(logId);
			//this is an important line it keeps the log synchronized with client proxy
			lbm.setUsingProxy(false);
			ses.registerObject(logId,lbm); 
		}
		try {
			if(command.equals("cancel")){
					lbm.getLinearDataBuilder().cancel();
					os.writeInt(OK_CODE);
			}else if(command.equals("getCurrentReference")) {
					DataReference dr = lbm.getLinearDataBuilder().getCurrentReference();
					os.writeInt(OK_CODE);
					os.writeObject(dr);
			}else if(command.equals("getDataBuilderReference")) {
					DataReference dr = lbm.getLinearDataBuilder().getDataBuilderReference();
					//System.out.println("object: " + dr);
					os.writeInt(OK_CODE);
					os.writeObject(dr);
			}else if(command.equals("getLinearRecords")) {
					LinearDataQuery dq = (LinearDataQuery)dataObj;
					//System.out.println("DATA QUERY: "+dq);
					lbm.updateSearchingQuery(dq);						
					RecordsResult rr = lbm.getLinearDataBuilder().getLinearRecords(dq);
					//System.out.println("REC: "+rr);
					os.writeInt(OK_CODE);
					os.writeObject(rr);
			}else if(command.equals("getRecords")) {
					DataQuery dq = (DataQuery)dataObj;
					System.out.println("getRecords " + dq);
					RecordsResult rr = lbm.getLinearDataBuilder().getRecords(dq);
					os.writeInt(OK_CODE);
					os.writeObject(rr);
			}else if(command.equals("getRecordsFromData")) {
					Object obj = dataObj;
					//System.out.println("getRecordsFromData " + obj);
					RecordsResult rr = lbm.getLinearDataBuilder().getRecordsFromData(obj);
					os.writeInt(OK_CODE);
					os.writeObject(rr);
			}else if(command.equals("getRecordsFromStringData")) {
					String str = (String)dataObj;
					//System.out.println("getRecordsFromStringData " + str);
					RecordsResult rr = lbm.getLinearDataBuilder().getRecordsFromStringData(str);
					os.writeInt(OK_CODE);
					os.writeObject(rr);
			}else if(command.equals("getRecordsFromStringDataWithRef")) {
				ArrayList list = (ArrayList)dataObj;
				String str = list == null ? null : (String)list.get(0);
				DataReference ref = list == null ? null : (DataReference)list.get(1);
				//System.out.println("getRecordsFromStringData " + str);
				RecordsResult rr = lbm.getLinearDataBuilder().getRecordsFromStringData(str,ref);
				os.writeInt(OK_CODE);
				os.writeObject(rr);
		  }else if(command.equals("goTo")) {
					DataReference dr = (DataReference)dataObj;
					lbm.getLinearDataBuilder().goTo(dr);
					os.writeInt(OK_CODE);
			}else if(command.equals("goToDataBuilderReference")) {
					DataReference dr = (DataReference)dataObj;
					lbm.getLinearDataBuilder().goToDataBuilderReference(dr);
					os.writeInt(OK_CODE);
			}else if(command.equals("reset")) {
					lbm.getLinearDataBuilder().reset();
					os.writeInt(OK_CODE);
			}else if(command.equals("next")) {
					DataSourceResult dsr = lbm.getLinearDataBuilder().getLinearDataSource().next();
					os.writeInt(OK_CODE);
					os.writeObject(dsr);
			}else if(command.equals("prev")) {
					DataSourceResult dsr = lbm.getLinearDataBuilder().getLinearDataSource().prev();
					os.writeInt(OK_CODE);
					os.writeObject(dsr);
			}else if(command.equals("update")) {
					lbm.getLinearDataBuilder().getLinearDataSource().update();
					os.writeInt(OK_CODE);
			}else if(command.equals("dispose")) {
			    if (lbm != null){
  					lbm.dispose();
  			  }
					os.writeInt(OK_CODE);
			}else if(command.equals("setTotalDataSource")) {
			
					lbm.getLinearDataBuilder().getLinearDataSource().setTotalDataSource(Integer.parseInt(data));
					os.writeInt(OK_CODE);
			}else if(command.equals("setDataViewMode")) {
					lbm.getLinearDataBuilder().getLinearDataSource().setDataViewMode(Integer.parseInt(data));
					os.writeInt(OK_CODE);	
			}else if(command.equals("getDataViewMode")) {
					int mode = lbm.getLinearDataBuilder().getLinearDataSource().getDataViewMode();
					os.writeInt(OK_CODE);
					os.writeObject(new Integer(mode));	
			}else if(command.equals("goToByRef")) {
					DataReference dr = (DataReference)dataObj;
					lbm.getLinearDataBuilder().getLinearDataSource().goToByRef(dr);
					os.writeInt(OK_CODE);
			}else if(command.equals("getRef")) {
					DataReference dr = lbm.getLinearDataBuilder().getLinearDataSource().getRef();
					os.writeInt(OK_CODE);
					os.writeObject(dr);
			}else if(command.equals("getMedianRef")) {
			    List list = (List)dataObj;
			    DataReference dr = null;
			    if (list != null && list.size() == 2){
					  dr = lbm.getLinearDataBuilder().getLinearDataSource().getMedianRef((DataReference)list.get(0),(DataReference)list.get(1));
					}
					os.writeInt(OK_CODE);
					os.writeObject(dr);
			}else if(command.equals("goStart")) {
					lbm.getLinearDataBuilder().getLinearDataSource().goStart();
					os.writeInt(OK_CODE);
			}else if(command.equals("goEnd")) {
					lbm.getLinearDataBuilder().getLinearDataSource().goEnd();
					os.writeInt(OK_CODE);
			}else if(command.equals("getDataRefComparator")) {
					Comparator comp = lbm.getLinearDataBuilder().getLinearDataSource().getDataRefComparator();
					os.writeInt(OK_CODE);
					os.writeObject(comp);
			}else if(command.equals("getDataReferenceBuilder")) {
					DataReferenceBuilder drb = lbm.getLinearDataBuilder().getLinearDataSource().getDataReferenceBuilder();
					os.writeInt(OK_CODE);
					os.writeObject(drb);
			}else if(command.equals("getJobStatus")) {
					JobStatus js = lbm.getLinearDataBuilder().getLinearDataSource().getJobStatus();
					os.writeInt(OK_CODE);
					os.writeObject(js);
			}else if(command.equals("getDataReference")) {
					DataReference js = lbm.getLinearDataBuilder().getLinearDataSource().getDataReferenceBuilder().getDataReference();
					os.writeInt(OK_CODE);
					os.writeObject(js);
			}else if(command.equals("getTitle")) {
					DataReferenceBuilder dref = lbm.getLinearDataBuilder().getLinearDataSource().getDataReferenceBuilder();
					String js = "";
					if(dref != null){
					  js = dref.getTitle();
					}
					os.writeInt(OK_CODE);
					os.writeObject(js);
			}else if(command.equals("search")) {
				SearchQuery query = (SearchQuery)dataObj;
				SearchResults result = SearchEngineManager.getInstance().getDefaultSearchAdapter().search(query);
				os.writeInt(OK_CODE);
				os.writeObject(result);	
			}else if(command.equals("isIndexed")) {				
				boolean result = lbm.isTextIndexed();
				os.writeInt(OK_CODE);
				os.writeObject(new Boolean(result));	
			}else if(command.equals("getAggResults")) {				
				LogAggregationConf conf = (LogAggregationConf)dataObj;
				TimeFramesAggregatorResults results = AggregationHelper.compute(conf);
				os.writeInt(OK_CODE);
				os.writeObject(results);	
			}else {
				//ERROR: command not valid.
				os.writeInt(ERROR_CODE);
				os.writeObject("ERROR: not valid command");
			}	
		}catch(Exception e) {
			e.printStackTrace();
			os.writeInt(ERROR_CODE);
		}
	}else {
		//ERROR: logId, sessionId, command are null, or sessionId not valid.
		os.writeInt(ERROR_CODE);
		os.writeObject("ERROR: logId, sessionId, command are null, or sessionId not valid");
	}
	os.flush();
	os.close();
%>