<%@ page language="java"%><%@ page import="xpolog.eye.*"%><%@ page import="xpolog.eye.site.*"%><%@ page import="xpolog.eye.data.index.*"%><%@ page import="xpolog.eye.admin.helpers.*"%><%@ page import="xpolog.eye.data.index.adapters.*"%><%@ page import="xpolog.eye.data.index.adapters.defaultadapter.*"%><%@ page import="java.io.*"%><%@ page import="java.util.*"%><%@ page import="xpolog.eye.data.source.*"%><%@ page import="xpolog.eye.security.*"%><%  
	
	String responseType = request.getParameter("responseType");
	String user = request.getParameter("user");
	String searchTerm = request.getParameter("searchTerm");
	String allWordsStr = request.getParameter("allWords");
	String applicationId = request.getParameter("applicationId");
	boolean allWords = (allWordsStr != null && allWordsStr.equals("true"));
	String matchWholeWordsOnlyStr = request.getParameter("matchWholeWordsOnly");
	boolean matchWholeWordsOnly = (matchWholeWordsOnlyStr != null && matchWholeWordsOnlyStr.equals("true"));
	if(user == null){
		user = "";
	}
	String password = request.getParameter("password");
	
	SiteManagment mgmt = SiteManagment.getInstance();
	
	UserSecurity userSec = null;
	try{
		if(WebSecurityManager.getInstance().isSecurityEnabled()){
			userSec = WebSecurityManager.getInstance().autenticate(user,password);
		}
	}catch(Exception e){}
	UserContext userContext = new UserContext();
	userContext.setUser(userSec);
	if (applicationId != null && applicationId.length() > 0){
		HashSet set = new HashSet();
		set.add(applicationId);
		userContext.setIncludeSet(set);
	}
	
	UserSearch userSearch = new UserSearch();
	userSearch.setSearchString(searchTerm);
	userSearch.setUserContext(userContext);
	userSearch.setLogs(null);
	userSearch.setOnlyIndexed(false);
	userSearch.setFindAllWords(allWords);
	userSearch.setMatchWholeWordsOnly(matchWholeWordsOnly);
	userSearch.doSearch();
	
	SearchResults results = userSearch.getResults();
	
	if (results == null){
	  results = new SearchResults();
	}
	
	if (responseType == null || responseType.length() == 0){
	  responseType = "xml";
	}
  //System.out.println("
  if(responseType.equalsIgnoreCase("xml")){
	  response.setHeader("Content-Type", "text/xml");
		String xmlStr = results.toXmlString();
		if(xmlStr != null){
			out.println(xmlStr);
			out.flush();
		}
	}else if(responseType.equalsIgnoreCase("serialize")){
		response.setHeader("Content-Type", "application/octet-stream");			
		ObjectOutputStream os = new ObjectOutputStream(response.getOutputStream());			
		os.writeObject(results);							
		os.flush();
	}

%>