<%@ page language="java"%>

<%@ page import="xpolog.eye.cloud.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.net.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	
	String name,description,host,port,userName,context,autoLogin,password,id;
	
	id = request.getParameter("id");
	name = request.getParameter("name");
	description = request.getParameter("description");
	host = request.getParameter("host");
	port = request.getParameter("port");
	autoLogin = request.getParameter("autoLogin");
	password = request.getParameter("password");
	userName = request.getParameter("username");
	context = request.getParameter("context");
	String conType = request.getParameter("conType"); 
	final String currentHost = request.getParameter("currentHost");

	String forwardURL = request.getParameter("forwardURL");
	
	ErrorModel errmodel = new ErrorModel(); 
	if(name == null || name.equals("")){
    	errmodel.addError("No Name was supplied.");
  	}

  	if(description == null || description.equals("")){
    	description = " ";
  	}
  	if(host == null || host.equals("")){
    	errmodel.addError("remote host was not supplied.");
  	}
  	
  	if(port == null || port.equals("")){
    	errmodel.addError("No port was supplied.");
  	}
  	if(context == null || context.equals("")){
    	context = "/";
  	}

	
  	if(userName == null || userName.equals("")){
  		if(autoLogin != null){
  			errmodel.addError("No user name was supplied.");
  		}else{
	   		userName = "";
    	}
  	}
  
  	
  	if(password == null || password.equals("")){
		password = "";
  	}
  	
  	if(errmodel.getErrorCount() != 0){
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
  	}
	
	
	
	XplgNode node = null;
	CloudMgr cldmgr = SiteManagment.getInstance().getCloudMgr();
	if(id != null){
		node = cldmgr.getNodeById(id);
		
	}
	if(node == null){
		node = new XplgNode();
	}
	
	node.setName(name);
	node.setHost(host);
	node.setPort(port);
	node.setSslport("30345");
	node.setContext(context);
	node.setPassword(password);
	node.setUserName(userName);
	node.setDescription(description);
	node.setContype(conType);
	if(autoLogin == null){
    	node.setAutoLogin(false);
  	}else{
  		node.setAutoLogin(true);
  	}
	
	boolean isNew = (node.getId() == null);
	cldmgr.addXplgNode(node);
	cldmgr.saveCloudData();
	if (isNew){
		cldmgr.addXplgNodeToMetaData(node.getId(),userContext);
	}
		
	String auditName = "";
	if(node != null) {
		auditName = node.getName();
	}
	  //audit
	  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	  			userContext, AuditConstants.CHANGE, "save/edit node", AuditConstants.NODES, "change node " + auditName);
	
	final XplgNode nd = node;
	final String cont = request.getContextPath();
	final int localPort = request.getServerPort();
	new Thread(new Runnable(){
			public void run(){
				CloudUtil.peformHandShake(nd,cont,currentHost,localPort); 
			}
		}).start();
	if(forwardURL != null  && forwardURL.length() > 0){		
		response.sendRedirect(BASE_DIRECTORY + forwardURL);
	}else{
		response.sendRedirect("cloudRefreshAll.jsp");
	}
%>