<%@ page language="java"%>

<%@ page import="java.util.ArrayList"%>
<%@ page import="java.util.Collections"%>
<%@ page import="java.util.Comparator"%>
<%@ page import="java.util.List"%>
<%@ page import="xpolog.eye.media.auth.win.WinAuthenticationAccountFilter"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.media.AddressFilter"%>
<%@ page import="xpolog.eye.media.AddressBook"%>
<%@ page import="xpolog.eye.media.snmp.SNMPAccountFilter"%>
<%@ page import="xpolog.eye.media.jms.JMSAccountFilter"%>
<%@ page import="xpolog.eye.media.sms.SmsAccountFilter"%>
<%@ page import="xpolog.eye.media.db.DBAccountFilter"%>
<%@ page import="xpolog.eye.media.mail.MailAccountFilter"%>
<%@ page import="xpolog.eye.media.fs.FSAccountFilter"%>
<%@ page import="xpolog.eye.media.telsh.TelnetAccountFilter"%>
<%@ page import="xpolog.eye.media.ftp.FTPAccountFilter"%>
<%@ page import="xpolog.eye.media.http.HttpAccountFilter"%>
<%@ page import="xpolog.eye.media.Account"%>
<%@ page import="xpolog.eye.media.remote.RemoteXplgAccountFilter"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
	
	String PREFIX = "PREFIX";
	String ACC_TYPE = "ACC_TYPE";
	String ACC_ID = "ACC_ID";
	String ACC_LIST_ID = "ACC_LIST_ID";
	String IS_ACC_CHANGED = "IS_ACC_CHANGED";
	
	String ACCOUNTS_LIST_PREFIX = request.getParameter(PREFIX);
	if (ACCOUNTS_LIST_PREFIX == null || ACCOUNTS_LIST_PREFIX.length() == 0){
		ACCOUNTS_LIST_PREFIX = "";
	}
	String accountType = request.getParameter(ACC_TYPE);
	if(accountType == null){
		accountType = "";
	}
	String accountId = request.getParameter(ACC_ID);
	if(accountId == null){
		accountId = "";
	}
	String accountListId = request.getParameter(ACC_LIST_ID);
	if(accountListId == null || accountListId.length() == 0) {
		accountListId = ACCOUNTS_LIST_PREFIX + "AccountsList";
	}
	
	String isAccountChangeStr = request.getParameter(IS_ACC_CHANGED);
	boolean isAccountChange = isAccountChangeStr != null && isAccountChangeStr.equals("true");
	
	String scriptsOnlyStr = request.getParameter("scriptsOnly");
	boolean scriptsOnly = scriptsOnlyStr != null && scriptsOnlyStr.equals("true");
	String noScriptsStr = request.getParameter("noScripts");
	boolean noScripts = noScriptsStr != null && noScriptsStr.equals("true");
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	AddressFilter filter = null;
	List filtersList = new ArrayList();
  if(accountType.length() > 0){
  	String[] accountTypes = null;
  	if(accountType.indexOf("|") == -1) {
  		accountTypes = new String[]{accountType};
  	}else {
  		accountTypes = accountType.split("\\|");
  	}
  	if(accountTypes != null) {
  		for(int i = 0; i < accountTypes.length; i++) {
  		  if(accountTypes[i].equals("http")){
			  	filter = new HttpAccountFilter();
			  }else if(accountTypes[i].equals("ftp")){
			  	filter = new FTPAccountFilter();
			  }else if(accountTypes[i].equals("ssh")){
			  	filter = new TelnetAccountFilter();
			  }else if(accountTypes[i].equals("fs")){
			  	filter = new FSAccountFilter();
			  }else if(accountTypes[i].equals("email")){
			  	filter = new MailAccountFilter();
			  }else if(accountTypes[i].equals("db")){
			  	filter = new DBAccountFilter();
			  }else if(accountTypes[i].equals("sms")){
			  	filter = new SmsAccountFilter();
			  }else if(accountTypes[i].equals("jms")){
				  	filter = new JMSAccountFilter();
			  }else if(accountTypes[i].equals("snmp")){
					filter = new SNMPAccountFilter();
			  }else if(accountTypes[i].equals("remote")){
					filter = new RemoteXplgAccountFilter();
			  }else if(accountTypes[i].equals("auth") || accountTypes[i].equals("winEvent")){
					filter = new WinAuthenticationAccountFilter();
			  }
			  if(filter != null) {
			  	filtersList.add(filter);
			  }
  		}
  	}
  }
  List list = null;
	if(filtersList.size() > 0){
		AddressBook adbook = AddressBook.getInstance();
	  for(int i = 0; i < filtersList.size(); i++) {
	  	filter = (AddressFilter)filtersList.get(i);
	  	List tmp = adbook.getAccountsByFilter(filter,userContext);
	  	if(list == null) {
	  		list = new ArrayList();
	  	}
	  	list.addAll(tmp);
		}
	  Collections.sort(list, new Comparator() {
	  	public int compare(Object o0, Object o1) {
	  		Account account0 = (Account)o0;
	  		Account account1 = (Account)o1;
	  		
	  		return account0.getAccountName().toLowerCase().compareTo(account1.getAccountName().toLowerCase());
	  	}
	  });
	}
  
  String onChangeAction = request.getParameter("ON_CHANGE_ACTION");
  if(onChangeAction == null) {
  	onChangeAction = "";
  }

%>
<%if(!noScripts) { %>

<script>
	function onChangeFunction() {
		if(typeof clearFormError == 'function') {
			changeAcc('<%=ACCOUNTS_LIST_PREFIX%>AccountsList', '<%=ACCOUNTS_LIST_PREFIX%>AccountIdErrorMsg');
		}
		<%=onChangeAction%>
	}
</script>
<%} %>
<%if(!scriptsOnly) { %>
	<%if(!accountType.equals("none")){ %>
	<select class="TEXTBOX" id="<%=accountListId%>" name="<%=accountListId%>" onChange="javascript:onChangeFunction()" >
		<option value="none"> -- Select Account -- </option>		
	<%if(list != null){
		for(int i = 0 ;i < list.size() ; i++){
	    Account acc = (Account)list.get(i);
	    String accId = acc == null ? "noId" : acc.getId();
	    String name = acc == null ? "" : acc.getAccountName();
	    if(!acc.isEnabled()) {
	    	name += " (disabled)";
	    }
	    String accSelected = (accId != null && acc.getId().equals(accountId)) ? " selected" : "";
	%>
		<option value="<%=accId%>" <%=accSelected%>><%=name%></option>	
	<%}}%>														
	</select>
	<%}else if(isAccountChange){%>
none
	<%}%>
<%}%>