<%@ page language="java"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = BASE_DIRECTORY;
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String divTitle = request.getParameter("title");
	if (divTitle == null){
		divTitle = "";
	}

	String pathToInclude = request.getParameter("includePath");
	if (pathToInclude == null){
		pathToInclude = "";
	}
	if(pathToInclude.length() >0){
		pathToInclude = BASE_DIRECTORY + pathToInclude;
	}
	String scrollHeight = "170px" , scrollWidth="170px";
  String divWidth = request.getParameter("width");
  if (divWidth == null || divWidth.length() == 0){
  	divWidth = "200px";
  }else{
  	try{
	  	int width = Integer.parseInt(divWidth.replaceAll("px",""));
	  	scrollWidth= String.valueOf(width - 50) + "px";
  	}catch(Exception e){
  		scrollWidth="170px";
	  }
  }
  String divHeight = request.getParameter("height");
  if (divHeight == null || divHeight.length() == 0){
  	divHeight = "200px";
  }else{
  	try{
	  	int height = Integer.parseInt(divHeight.replaceAll("px",""));
	  	scrollHeight= String.valueOf(height - 50) + "px";
  	}catch(Exception e){
  		scrollHeight="170px";
	  }
  }
  
  String zIndexStr = request.getParameter("zIndex");
  int zIndex = 110;
  if (zIndexStr != null && zIndexStr.length() > 0){ 
  	try{
  		zIndex = Integer.parseInt(zIndexStr);	  	
  	}catch(Exception e){  		
	  }
  }
  
  String[] actionsNamesArr = null;
  String[] actionsArr = null;
  String actionsNamesStr = request.getParameter("actionsNames");
  if (actionsNamesStr != null && actionsNamesStr.length() > 0){
  	actionsNamesArr = actionsNamesStr.split("#");
  }
  String actionsStr = request.getParameter("actions");
  if (actionsStr != null && actionsStr.length() > 0){
  	actionsArr = actionsStr.split("#");
  }
  boolean paramOk = (actionsNamesArr != null && actionsArr != null && actionsNamesArr.length == actionsArr.length);

  String position = request.getParameter("position");
  if (position == null || position.length() == 0){
  	position = "absolute";
  }
  
  String display = request.getParameter("display");
  if (display == null){
  	display = "none";
  }
  
  String left = request.getParameter("left");
  if (left == null || left.length() == 0){
  	left = "0";
  }
  
  String top = request.getParameter("top");
  if (top == null || top.length() == 0){
  	top = "0";
  }

  String bgcolor = request.getParameter("bgcolor");
  if (bgcolor == null || bgcolor.length() == 0){
  	bgcolor = "white";
  }
  boolean hidePadding = false;
  String hidePaddingStr = request.getParameter("hidePadding");
  hidePadding =  hidePaddingStr != null && hidePaddingStr.equalsIgnoreCase("true");

%>
<div id="adminGeneralDiv<%=suffix%>" style="position:<%=position%>;left:<%=left%>;top:<%=top%>;height:<%=divHeight%>;width:<%=divWidth%>;display:<%=display%>;z-index:<%=String.valueOf(zIndex)%>">


<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" bgcolor="<%=bgcolor%>">
			<tr height="8" style="font-size:1">
				<td width="5"><table border="0" width="5" cellspacing="0" height="8" cellpadding="0" background="<%=baseDirectory%>images/common/adminLeftTopDiv.gif"><tr><td><span style="font-size:2;">&nbsp;</span></td></tr></table></td>
				<td width="*"><table border="0" width="100%" cellspacing="0" height="8" cellpadding="0" background="<%=baseDirectory%>images/common/adminTopDiv.gif"><tr><td ><span style="font-size:2;">&nbsp;</span></td></tr></table></td>
				<td width="8"><table border="0" width="8" cellspacing="0" height="8" cellpadding="0" background="<%=baseDirectory%>images/common/adminRightTopDiv.gif"><tr><td><span style="font-size:2;">&nbsp;</span></td></tr></table></td>				
			</tr>
			<tr>
				<td width="5"><table border="0" width="5" cellspacing="0" height="100%" cellpadding="0" background="<%=baseDirectory%>images/common/adminLeftDiv.gif"><tr><td><span style="font-size:2;">&nbsp;</span></td></tr></table></td>
				<td width="*"><table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" ><tr><td style="padding-left:<%=hidePadding ? 0 : 30 %>px;padding-right:<%=hidePadding ? 0 : 30 %>px;padding-top:<%=hidePadding ? 0 : 15 %>px;padding-bottom:<%=hidePadding ? 0 : 5 %>px">
				
				
				
				
				<table border="0" width="100%" cellspacing="0" height="100%">			
		<%if(!hidePadding || divTitle.length() > 0){%>
			<tr style="font-size:1" height="3">
				<td>
						<table border="0" width="100%" cellspacing="0" height="100%">
								<tr align="left">
									<td id="generalDivTitle<%=suffix%>" class="HEADER"><%=divTitle%></td>				
								</tr>
						</table>												
				</td>				
			</tr>
			<tr style="font-size:1" height="3">
				<td>&nbsp;</td>				
			</tr>
			<%}%>
			<tr>
				<td>
				<div id="adminGeneralIncludeTD<%=suffix%>" style="padding-left:<%=hidePadding ? 0 : 10 %>px;height:<%=scrollHeight%>;overflow-y:auto">
					<%if(pathToInclude.length() > 0){ %>
						<jsp:include page="<%=pathToInclude%>" flush="true">
						<jsp:param name="base_directory" value="<%=baseDirectory%>"/> 
						</jsp:include>
					<%}%>	
					</div>
				</td>				
			</tr>			
			<%if(paramOk){%>
			<tr style="font-size:1" height="3">
				<td align="right" style="padding-right:<%=hidePadding ? 0 : 50 %>px;padding-bottom:<%=hidePadding ? 0 : 5 %>px">
					<div  id="adminGeneralCtrlButtonTD<%=suffix%>" >
						<table border="0" width="50" cellspacing="0" height="100%">
								<tr >									
									<%for(int i = 0;i < actionsNamesArr.length ; i++){ 
										String name = actionsNamesArr[i];
										String action = actionsArr[i];
									%>										
										<jsp:include page="ctrlButton.jsp" flush="true">
						<jsp:param name="base_directory" value="<%=baseDirectory%>"/>
						<jsp:param name="name" value="<%=name%>"/>
						<jsp:param name="action" value="<%=action%>"/> 
						</jsp:include>				
									<%}%>																		
								</tr>
						</table>		
					</div>											
				</td>				
			</tr>
			<%}%>
	</table>
				
				
				
				
				
				
				
				
				
				
				</td></tr></table></td>
				<td width="8" ><table border="0" width="8" cellspacing="0" height="100%" cellpadding="0" background="<%=baseDirectory%>images/common/adminRightDiv.gif"><tr><td><span style="font-size:2;">&nbsp;</span></td></tr></table></td>				
			</tr>
			<tr height="6" style="font-size:1">
				<td width="5"><table border="0" width="5" cellspacing="0" height="6" cellpadding="0" background="<%=baseDirectory%>images/common/adminLeftBottomDiv.gif"><tr><td><span style="font-size:2;">&nbsp;</span></td></tr></table></td>
				<td width="*"><table border="0" width="100%" cellspacing="0" height="6" cellpadding="0" background="<%=baseDirectory%>images/common/adminBottomDiv.gif"><tr><td ><span style="font-size:2;">&nbsp;</span></td></tr></table></td>
				<td width="8"><table border="0" width="8" cellspacing="0" height="6" cellpadding="0" background="<%=baseDirectory%>images/common/adminRightBottomDiv.gif"><tr><td><span style="font-size:2;">&nbsp;</span></td></tr></table></td>				
			</tr>
			
						
	</table>

</div>
<% if (!position.equals("relative")){ %>
<iframe id="adminGeneralDivFrame<%=suffix%>" src="<%=baseDirectory%>empty.html" style="position:<%=position%>;left:<%=left%>;top:<%=top%>;height:<%=divHeight%>;width:<%=divWidth%>;display:<%=display%>;z-index:<%=String.valueOf(zIndex - 10)%>" frameborder="0"></iframe>
<%} %> 
