<%@ page language="java"%>

<%@ page import="java.util.HashMap"%>

<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.search.ui.SearchViewHelper"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>

<%

String AUTO_COMPLETE_CACHE = "AutoCompleteCache";

UserContext userContext = UserEnvironment.getUserContext(request);
WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request, response, null, true)) {
  return;
}

StringBuffer result = new StringBuffer();

String type = request.getParameter("type");
String source = request.getParameter("source");
String query = request.getParameter("query");
if(type != null && type.length() > 0 && query != null && query.length() > 0) {
	HashMap autoCompelteCache = (HashMap)session.getAttribute(AUTO_COMPLETE_CACHE);
	UserContext ownerUserContext = null;
	if(source != null && source.length() > 0) {
		ownerUserContext = (UserContext)session.getAttribute(source + "_ownerUserContext");
	}
	
	String suggestions = "", data = "", inAutocomplete = "", autocompleteMiddle = "";
	if(type.equals("simpleSearch")) {
		
	}else if(type.equals("complexSearch")) {
		String caretPositionStr = request.getParameter("caretPosition");
		if(caretPositionStr != null && caretPositionStr.length() > 0) {
			int caretPosition = -1;
			try {
				caretPosition = Integer.parseInt(caretPositionStr);
				String[] autoCompleteString = SearchViewHelper.getAutoCompleteString(query, caretPosition, userContext, ownerUserContext, true, true, ",", "'", autoCompelteCache);
				suggestions = autoCompleteString[0];
				data = autoCompleteString[1];
				inAutocomplete = autoCompleteString[2];
				autocompleteMiddle = autoCompleteString[3];
				
				result.append("{query:'");
				String queryReturn = query;
				queryReturn = XpologUtil.replaceAll(queryReturn, "\\", "\\\\");
				queryReturn = XpologUtil.replaceAll(queryReturn, "'", SearchViewHelper.AUTO_COMPLETE_APOS_MASK);
				result.append(queryReturn);
				result.append("',suggestions:[");
				result.append(XpologUtil.replaceAll(suggestions, "\\", "\\\\"));
				result.append("],data:[");
				result.append(XpologUtil.replaceAll(data, "\\", "\\\\"));
				result.append("],inAutocomplete:'");
				result.append(inAutocomplete);
				result.append("',autocompleteMiddle:'");
				result.append(autocompleteMiddle);
				result.append("'}");
			}catch(Exception e) {
			}
		}
	}
}
//System.out.println(result);
response.setCharacterEncoding("UTF-8");
out.print(result);
out.flush();
%>