<%@ page language="java"%>

<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.controllers.*" %>
<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
  ErrorModel errmodel = null;
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  SiteWizardController control = env.getSiteWizardController();
  
  String cancelURL = request.getParameter("cancelURL");
  if (cancelURL == null || cancelURL.trim().length() == 0){
    cancelURL = "logEyePortal.jsp";
  }
  if (control != null){  	
  	cancelURL = "controllers/controllerCancel.jsp";      	
  }
  cancelURL = cancelURL.startsWith("javascript:") ? cancelURL : BASE_DIRECTORY + cancelURL;

  String okURL = request.getParameter("okURL");
  if (okURL == null || okURL.trim().length() == 0){
    //okURL = "javascript:history.go(-1)";
  }else {
     okURL = BASE_DIRECTORY + okURL;
  }
  
  String closeWindowStr = request.getParameter("closeWindow");
  boolean closeWindow = closeWindowStr!=null && closeWindowStr.equals("true");
  
  String caller = request.getParameter("caller");
  
  errmodel = (ErrorModel)env.getTempAttribute(SiteConstants.ERROR_OBJ_ATTRIBUTE);
  if (errmodel == null){
    errmodel = (ErrorModel)request.getSession().getAttribute(SiteConstants.ERROR_OBJ_ATTRIBUTE);
  }
  String[] errarr = null;

  if(errmodel == null){
    errarr = new String[1];
    errarr[0] = "No messages were found in session";
  }else{
    errarr = errmodel.getErrors();
    request.getSession().removeAttribute(SiteConstants.ERROR_OBJ_ATTRIBUTE);
  }
%>
<html>

<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>
<%
if ((okURL == null || okURL.trim().length() == 0)){
	if(caller != null && caller.equals(ProgressRunner.PROGRESS_RUNNER)){%>
		var okUrl = "javascript:history.go(-2)";
		var js = true;
	<%}else{%> 
		var okUrl = "javascript:history.go(-1)";
		var js = true;
	<%}%> 
<%}else{%>
	var okUrl = "<%=okURL%>";
	var js = false;
<%}%>

function doOk(){
	if (js){
		eval(okUrl);
	}else{
		document.location = okUrl;
	}
}
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access" style="padding:0;margin:0">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">System Notification</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Please take note to the following explanations and procedures</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <%
                  	for(int i=0;i<errarr.length;++i){
                  %>
                  <tr>
                    <td width="15%" height="22"><span class="REGULARTEXT"><%=errarr[i].length()>0 ? "- " + errarr[i] : "<br>"%></span></td>
                  </tr>
                  <%
                  	}
                  %>
                 </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="35%">&nbsp;</td>
			          <%if (!closeWindow){%>
                <td width="11%" align="center"><a href='<%=cancelURL%>' class="LINK">cancel</a></td>
                <td width="7%" align="center"><a href='javascript:doOk()' class="LINK">
                ok</a></td>
                <%} else {%>
                <td width="18%" align="center"><a href="javascript:window.close()" class="LINK">ok</a></td>
                <%}%>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>