<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@ page language="java" %> 

<%@page import="xpolog.config.Configuration"%>
<%@page import="xpolog.eye.snapshot.SnapshotManager"%>
<%@page import="xpolog.eye.snapshot.Snapshot"%>
<%@page import="xpolog.eye.data.log.LogRecord"%>
<%@page import="java.util.Iterator"%>
<%@page import="java.util.Collections"%>
<%@page import="java.util.LinkedList"%>
<%@page import="java.util.List"%>
<%@page import="xpolog.eye.data.Record"%>
<%@page import="xpolog.eye.data.RecordsMaskTableModel"%>
<%@page import="xpolog.eye.logview.LogViewContext"%>
<%@page import="xpolog.eye.LogBrowsingManager"%>
<%@page import="xpolog.eye.logview.LogViewQueryInfo"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
		final int MAX_RECORDS_SIZE = Configuration.getInstance().getPropertiesManager().getPropertyAsInt("snapshot.defaultMaxRowsToCopy",1000);

		final String DELIMITER = "#@#@";
		String ACTIVE_SNAPSHOT_MODE = "ACTIVE_SNAPSHOT_MODE";

		LogViewContext logcontext = (LogViewContext)request.getSession().getAttribute(LogViewContext.LOG_CONTEXT);
	  LogViewQueryInfo queryInfo = logcontext == null ? null : logcontext.query;
	  int leapsize =  queryInfo == null ? 25 : queryInfo.leapsize;

		LogBrowsingManager lbm = null;
		String errorMsg = "";
		//Getting the selected indexes list
		String snapId = request.getParameter("SNAPSHOT_ID");
		UserContext userContext = UserEnvironment.getUserContext(request);

/*
		//Snapshots lock check
		SnapshotManager snapMgr = SnapshotManager.getInstance();
		if(snapMgr.isSnapshotLocked(snapId,userContext)){
			errorMsg = "ActionDenied";
		}else{
			snapMgr.updateActiveSnapshotInfo(snapId,userContext);
		}
*/

		if(snapId != null && snapId.length() > 0){ // Get all lbm recoreds
			Snapshot snap = SnapshotManager.getInstance().getSnapshot(snapId);
			if(snap != null){
				lbm = snap.getLogView();
			}
		}else{
			lbm = logcontext == null ? null : logcontext.lbm;
		}
		// Get records by selected indexes from log viewer
	  String result = "";
		List selectedRowIndexes = new LinkedList();
		String selectedRowIndexStr = request.getParameter("selectedRowIndexArr");
		String[] selectedRowIndexArr = selectedRowIndexStr == null ? null : selectedRowIndexStr.split("#");
		for(int i = 0 ; selectedRowIndexArr != null && i < selectedRowIndexArr.length ; i++){
			int rowIndx = -1;
			try{
					rowIndx = Integer.parseInt(selectedRowIndexArr[i]);
					selectedRowIndexes.add(new Integer(rowIndx));
			}catch(Exception e){
				rowIndx = -1;
			}			
		}
		Collections.sort(selectedRowIndexes);			
	
		//Getting the dataRefs array from selected indexes.
	  List recList = new LinkedList();
	  Record rec = null;
		if(lbm == null ){
			errorMsg = "no lbm";
		}else if(errorMsg.length() == 0){
		  RecordsMaskTableModel RMModel = null; 
			boolean isOriginalData = lbm.isAddOrigDataToResult();
			if(!isOriginalData){
				lbm.setAddOrigDataToResult(true);
				leapsize = selectedRowIndexes.isEmpty() ? MAX_RECORDS_SIZE : leapsize; //if no selected index copy all records
				RMModel = lbm.getCurrentEntries(leapsize);
				if(lbm.getLogEyeModel() != null){
					lbm.getLogEyeModel().setRecordMaskModel(RMModel);
				}
				request.getSession().setAttribute(ACTIVE_SNAPSHOT_MODE,"true");
			}else{
				RMModel = lbm.getLogEyeModel() == null ? null : lbm.getLogEyeModel().getRecordsMaskTableModel() ; 
			}

		  if(RMModel != null){
				if(!selectedRowIndexes.isEmpty()){ //Get only selected records
					Iterator it = selectedRowIndexes.iterator();
			  	while(it.hasNext()){
						Integer selectedRowIndx = (Integer)it.next();
				  	rec = RMModel.getRecordAt(selectedRowIndx.intValue());
				  	if(rec != null && rec instanceof LogRecord){
				  		LogRecord logRecord = (LogRecord)rec;
				  		recList.add(logRecord.getOriginalData());
				  	}else{
				  		errorMsg = "no original data for log " + lbm.getName();
				  	}
					}
			  }else{ // Get All lbm recored (not more then MAX_RECORDS_SIZE limit)			  
			  	List recordsList  = RMModel.getRecords();
			  	Iterator _it = recordsList.iterator();
			  	while(_it.hasNext()){
			  		rec = (Record)_it.next();
				  	if(rec != null && rec instanceof LogRecord){
				  		LogRecord logRecord = (LogRecord)rec;
				  		recList.add(logRecord.getOriginalData());
				  	}
			  	}
			  }
		  }
		  if(errorMsg.length() == 0 && recList.size() > 0){
		  	Iterator it = recList.iterator();
		  	while(it.hasNext()){
		  		result += (String)it.next() + DELIMITER;
		  	}
		  }
		}
    response.setContentType("text/html;charset=UTF-8");
		out.write(errorMsg.length() > 0 ? errorMsg : result);
		out.flush();
		return;

%>