<%@ page language="java" %>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%! 

  DecimalFormat decFormat = new DecimalFormat("##.##");
  double KB = 1024.0;
  double MB = 1024.0*KB;
  
  String format = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
  SimpleDateFormat dateFormat = new SimpleDateFormat(format);

  void addChildsNodeDiv(File [] files,StringBuffer buffer, String parentKey,UserSecurity user){
  	SiteManagment mgmt = SiteManagment.getInstance();
  	String type = null;
    for (int i = 0; i < files.length; i++) {
   
     
     String key = files[i].getPath();
      String treeKey = parentKey + "_" + i;
      String parentNode = parentKey.equals("root") ? "tree.root" : "parent." + parentKey;
      
      String extraText = "";
      
      boolean selected = false;
      String chkKey = "files";
       
      if (files[i].isFile()){
      	long len = files[i].length();
      	String size = "";
      	if (len > MB){
      	  size = decFormat.format(len/MB) + " MB";
      	}else if (len > KB){
      	  size = decFormat.format(len/KB) + " KB";
      	}else {
      		size = decFormat.format(len/1.0) + " B";
      	}
      	
      	extraText = "(" + size + " , " + dateFormat.format(new Date(files[i].lastModified())) + ")";
        buffer.append("\nparent." + treeKey + " = parent.tree.addNode(" + parentNode + ",\"" + chkKey +"\",\"" + files[i].getPath().replace('\\','/') + "\",\"" + files[i].getName() + "\",\"" + "" + "\",'" + extraText + "'," + selected + ",false,false);");
      	//buffer.append("\nparent." + treeKey + " = parent.tree.addNode(eval(\"" + parentNode + "\"),\"\",\"\",\"" + files[i].getName() + "\",\"\",'',false,false,false);");
      }else {
        String actionUrl = "getbrowsefsAction.jsp?FILE_PATH=" + files[i].getPath().replace('\\','/') + "&treeKey=" + treeKey;
        buffer.append("\nparent." + treeKey + " = parent.tree.addRemoteNode(" + parentNode + ",\"" + chkKey +"\",\"" + files[i].getPath().replace('\\','/') + "\",\"" + files[i].getName() + "\",\"" + "" + "\",'" + extraText + "'," + selected + ",false,\"" + actionUrl + "\",\"actionResultFrame\");");
      }

    }
  }

  void addNANodeDiv(StringBuffer buffer, String parentKey,String message){
    String treeKey = parentKey + "_" + 0;
    String parentNode = "parent." + parentKey;
    buffer.append("\nparent." + treeKey + " = parent.tree.addNode(eval(\"" + parentNode + "\"),\"\",\"\",\"" + message + "\",\"\",'',false,false,false);");
  }
 %>
<%
	
	String filePath = request.getParameter("FILE_PATH");
	if (filePath== null || filePath.length() == 0){
	  return;
	}
	File f = new File(filePath);
  if (!f.exists() || !f.isDirectory()){
    return;
  }
	
	String treeKey = request.getParameter("treeKey");
  
	

 	UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  File [] files = f.listFiles();  
  Arrays.sort(files,new Comparator(){
      public int compare(Object o1,Object o2){
        File f1 = (File)o1;
        File f2 = (File)o2;
        if (f1.isDirectory()  && f2.isFile()){
          return -1;
        }else if (f2.isDirectory()  && f1.isFile()){
          return 1;
        }else {
          return f1.compareTo(f2);
        }
      }
    });

      StringBuffer buffer = new StringBuffer();	
	if (f == null){
	  addNANodeDiv(buffer,treeKey,"Not Available");
	}else if (files == null || files.length == 0){
	  addNANodeDiv(buffer,treeKey,"No Files");
        }else {
	  addChildsNodeDiv(files,buffer,treeKey,user);
	}
	String treecode = buffer.toString();
	
	%>
<html>
<body>
<%=treecode.replaceAll("\n","<br>")%>
<script>
<%=treecode%>
var n = eval("parent.<%=treeKey%>");
parent.selectTreeNode(n);
parent.writeExternalNode(n);


</script>

</body>
</html>