<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.data.filters.FilterField"%>
<%@ page import="xpolog.eye.data.filters.FilterManager"%>
<%@ page import="xpolog.eye.data.filters.StringFilter"%>
<%@ page import="xpolog.eye.util.WebUtil"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	StringBuffer errBuffer = new StringBuffer();
	String resultStr = null;
	String lbmId = request.getParameter("lbmId");
	LogBrowsingManager lbm = null;
	String useTempLbmStr = request.getParameter("useTempLbm");
	boolean useTempLbm = useTempLbmStr != null && useTempLbmStr.equals("true");
	if (useTempLbm){
		lbm = (LogBrowsingManager)request.getSession().getAttribute("TEMP_LBM");
	}

	if (lbm == null){
		try{
			lbm = SiteManagment.getInstance().getLogBrowserManager(lbmId);
		}catch(Exception e){
		}
		if (useTempLbm){
			request.getSession().setAttribute("TEMP_LBM",lbm);
		}
	}

	if (lbm == null){
		errBuffer.append("No log selected");
	}
	
	
	String filterText = request.getParameter("filterText");
	if (filterText == null || filterText.length() == 0){
		if (errBuffer.length() > 0){
			errBuffer.append("#");
		}
		errBuffer.append("No rule text was entered");
	}
	if (lbm != null && filterText != null && filterText.length() > 0){
		String filterRegExpStr = request.getParameter("filterRegExp");
		boolean filterRegExp = filterRegExpStr != null && filterRegExpStr.equals("true");
		StringFilter stringFilter = new StringFilter();
		FilterField ff = new FilterField();
		ff.setEntry(filterText);
		ff.setRegExp(filterRegExp);
		stringFilter.setForAllColumns();
		stringFilter.setField(ff);
		FilterCollection fc = new FilterCollection();
		fc.addFilter(stringFilter);
		String filterName = XpologUtil.removeSpecialCharecters(filterText,WebUtil.CHARECTERS_PATTERN," ");
		if (filterRegExp){
			filterName += " (regexp)";
		}
		fc.setName(filterName);
		FilterManager filterMgr = lbm.getFilterManager();
		filterMgr.addFilterCollection(fc);
		SiteAdministrator siteAdmin = SiteManagment.getAdminInstance();
		siteAdmin.addLogBrowser(lbm);
		resultStr = fc.getId();
	}else{
		resultStr = "FILTER_SAVE_ERROR#" + errBuffer.toString();
	}
	
	response.setContentType("text/xml");
	out.write(resultStr.trim());
	out.flush();
%>