<%@ page language="java"%><%@page import="org.w3c.dom.*"%><%@ page import="java.util.*"%><%@ page import="xpolog.eye.system.*"%><%@ page import="xpolog.eye.util.*"%><%@page import="xpolog.eye.site.UserEnvironment"%><%@page import="xpolog.eye.security.*"%><%@page import="xpolog.eye.site.UserProperties"%><%
  
  WebSecurityManager securityManager = WebSecurityManager.getInstance();
  if (!securityManager.checkForPermission(request,response,null,false)){
    return; 
  }

  String newOnlyStr = request.getParameter("newOnly");
	boolean newOnly = newOnlyStr != null && newOnlyStr.equals("true");
	
	String lastStr = request.getParameter("last");
	int last = -1;
	if (lastStr != null && lastStr.length() > 0){
		last = Integer.parseInt(lastStr);
	}
	
	String maxStr = request.getParameter("max");
	int max = -1;
	if (maxStr != null && maxStr.length() > 0){
		max = Integer.parseInt(maxStr);
	}
	
	String useTipsStr = request.getParameter("useTips");
	boolean useTips = useTipsStr != null && useTipsStr.equals("true");
	
	String addResultStr = request.getParameter("addResult");
	boolean addResult = addResultStr != null && addResultStr.equals("true");
	
	String relativeStr = request.getParameter("relative");
	boolean relative = relativeStr != null && relativeStr.equals("true");
	
	
	UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);

	long fromTime = -1;
	if (newOnly){
		Long fromTimeLong = (Long)request.getSession().getAttribute("systemMessages.fromTime");
		if (fromTimeLong != null){
			fromTime = fromTimeLong.longValue();
		}else {
			fromTime = System.currentTimeMillis() - 600000;
			request.getSession().setAttribute("systemMessages.fromTime",new Long(fromTime + 1));
			request.getSession().setAttribute("systemMessages.firstTime",new Long(fromTime));
		}
	}
	boolean isTip = false;
	XpoLogSystemMessages systemMessages = XpoLogSystemMnager.getInstance().getSystemMessages(); 
	List list = systemMessages.getSystemMessages(null,fromTime,-1,user == null || user.getUser() == null ? null : user.getUser().getName(),null);
	
	int numOfResult  = list == null ? 0 : list.size(); 
	if (last > 0 && list != null && list.size() > last){
		list = list.subList(list.size() - last,list.size());
	}else if (max > 0 && list != null && list.size() > max){
		list = list.subList(0,max);
	}else if (list == null || list.size() == 0){
		if (useTips){		  
			long time = -1;
			Long fromTimeLong = (Long)request.getSession().getAttribute("systemMessages.lastMessageTime");
			if (fromTimeLong != null){
				time = fromTimeLong.longValue();
			}
		  
		  if (time > 0 && ((System.currentTimeMillis() -  time) > XpoLogSystemMnager.getInstance().getConfig().getLastMessageTipDiff())){
				MessageTip tip = UserEnvironment.getUserEnvironment(request).getNextTip(null);
				if (tip != null){
					list.add(tip);
					isTip = true;
				}
		  }
		}
	}
	
	String baseUrl = "";
	if (!relative){
		String contextPath = request == null? null : request.getContextPath();
	   if (contextPath == null){
	     contextPath = "/logeye";
	   }
	   if (request != null){
	     String schema = request.getScheme();
	     String host = request.getServerName();    
	     int port = request.getServerPort();
	     if (schema != null && host != null && port >= 0){
	    	 baseUrl = schema + "://" + host + ":" + port + contextPath;
	    	 if (!baseUrl.endsWith("/")){
	    		 baseUrl += "/";
	    	 }
	     }	     
	   }
	}
	
	UserProperties userProp = UserEnvironment.getUserProp(request);
	boolean showBalloon = userProp.getPropertyAsBoolean("ui.userMessages.showUserMessagesPopup",true);
	Element elem = systemMessages.toRSSXML(showBalloon ? list : new ArrayList(),baseUrl);
	
	String result = "";
	if (elem != null){		
    if (addResult){
    	boolean showUserMessages = request.getSession().getAttribute("showUserMessages") != null;
    	if (!showUserMessages && numOfResult > 0){
    		request.getSession().setAttribute("showUserMessages","true");
    		showUserMessages = true;
    	}
    	Document doc = elem.getOwnerDocument();
    	Element e = doc.createElement("Root");
    	Element resultElem = doc.createElement("Result");
    	Element showUserMessagesElem = doc.createElement("showUserMessages");    	
    	XMLUtil.setElementValue(showUserMessagesElem,String.valueOf(showUserMessages));
    	resultElem.appendChild(showUserMessagesElem);
    	e.appendChild(resultElem);
    	e.appendChild(elem);
    	
    	elem = e;
			
		}
		result = XMLUtil.getXml(elem,true);
		
	}
	if (list != null && list.size() > 0){
		if (isTip){
			request.getSession().setAttribute("systemMessages.lastMessageTime",new Long(System.currentTimeMillis()));  		
		}else {
			SystemMessage message = (SystemMessage)list.get(list.size() - 1);
	  	fromTime = message.getTime();
		  request.getSession().setAttribute("systemMessages.fromTime",new Long(fromTime + 1));
		  request.getSession().setAttribute("systemMessages.lastMessageTime",new Long(System.currentTimeMillis()));
		}
		
	}else {
		if (request.getSession().getAttribute("systemMessages.lastMessageTime") == null){
			request.getSession().setAttribute("systemMessages.lastMessageTime",new Long(System.currentTimeMillis()));
		}
	}

	response.setContentType("text/xml");	
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");

	//System.out.println("result  = " + result);
	out.print(result);
	out.flush();
 %>