function init(){
	initTabs();
	initMenusAlerts();
	initMenusCustomProblems();
	initTables();
	
	loadCalendar();
}

function getCurrentObjectsQuery() {
	return "";
}

function saveDashboardAdministration() {
	beforeSaveMetricsSettings();
	var analyticsHDisplayName = "Analytics";
	if (analyticsH){
		analyticsHDisplayName = analyticsH;
	} 
	
	var q = getFormElementsQueryString(document.access);
	var url = "dashboardAdministrationAction.jsp?";
	sendAjaxRequest(url,function(req) {
    var xmldoc = req.responseXML.documentElement;
     var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
     if (result == "false"){
		  var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
   		var msg = "<ul>";
   		var errs = message.split("*;*");
   		for (var i=0; i<errs.length; i++){
   			msg = msg + "<li>" + errs[i] + "</li>";
   		}
   		msg = msg + "</ul>"

	    var msgWriter = new messageWriter("dashboardAdministrationMessage","Save " + analyticsHDisplayName + " Administration Error",BASE_DIRECTORY);
	    msgWriter.addAction("OK","javascript:hideLayer('dashboardAdministrationMessage')");  
	    msgWriter.showMessage(msg);
     }else{
    	 var params = xmldoc.getElementsByTagName('params')[0].firstChild.nodeValue;
    	 if(params) {
    		 var dataSourceChanged = params.split("*;*")[0];
    		 if(dataSourceChanged && dataSourceChanged == "true") {
				var msgWriter = new messageWriter("deleteMessage","Servers " + analyticsHDisplayName + " Data Delete Action",BASE_DIRECTORY);
				msgWriter.setYParent(document.getElementById("mygridLogs"),50);
			    msgWriter.addAction("Yes","javascript:hideLayer('deleteMessage');javascript:doDeleteAllServers()");
			    msgWriter.addAction("No","javascript:hideLayer('deleteMessage');onAfterSaveDashboardAdministration()");  
			    msgWriter.showMessage("Metrics data source has changed, do you wish to delete existing metrics analysis of <u>all servers</u>?");
			}else {
				onAfterSaveDashboardAdministration();
			}
    	 }else {
    		 onAfterSaveDashboardAdministration();
    	 }
     }


  }, 'POST', q);
}

function doDeleteAllServers() {
	var analyticsHDisplayName = "Analytics";
	if (analyticsH){
		analyticsHDisplayName = analyticsH;
	}
	var msgWriter = new messageWriter("deleteMessage","Servers " + analyticsHDisplayName + " Data Delete Action",BASE_DIRECTORY);
    msgWriter.showMessage("<nobr>Please wait while deleting all servers metrics analysis...</nobr>");
    var url = BASE_DIRECTORY + "dashboard/admin/dashboardAdministrationDeleteServerComputationAction.jsp?allServers=true";
	sendAjaxRequest(url,function(req) {
		hideLayer("deleteMessage");
		var xmldoc = req.responseXML.documentElement;
	    var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
	    if (result == "false"){
	    	var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
	   		var msg = "<ul>";
	   		var errs = message.split("*;*");
	   		for (var i=0; i<errs.length; i++){
	   			msg = msg + "<li>" + errs[i] + "</li>";
	   		}
	   		msg = msg + "</ul>"

		    var msgWriter = new messageWriter("deleteMessage","Servers " + analyticsHDisplayName + " Data Delete Error",BASE_DIRECTORY);
		    msgWriter.addAction("OK","javascript:hideLayer('deleteMessage')");  
		    msgWriter.showMessage(msg);
	    }else{
	    	onAfterSaveDashboardAdministration();
	    }
	});
}

function onAfterSaveDashboardAdministration() {
	document.location = "../view/dashboard.jsp?resetModel=true&preserveRunners=true";
}