<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.automation.tasks.mail.MailTask"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext"%>
<%@ page import="xpolog.eye.util.Constants"%>
<%@ page import="xpolog.eye.util.hosts.HostsManager"%>
<%@ page import="xpolog.eye.util.hosts.measurements.HostMeasurement"%>
<%@ page import="xpolog.eye.util.hosts.measurements.HostMeasurementConfiguration"%>
<%@ page import="xpolog.eye.util.hosts.measurements.HostMeasurementLogLocationInfo"%>
<%@ page import="xpolog.eye.util.DateUtil"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%

%>

<html>
<head>

	<META HTTP-EQUIV="Content-Language" CONTENT="en-us">
	<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
	<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
	<META HTTP-EQUIV="EXPIRES" CONTENT="0">
	
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxCalendar/codebase/dhtmlxcalendar.css" />
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/dhtmlxCalendar.css" />
	
	<jsp:include page="../../widgets/tabs/jsp/tabsHeaderIncluder.jsp" flush="true">
	  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	</jsp:include>
	<jsp:include page="../../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
		<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	</jsp:include>
	<jsp:include page="../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
		<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	</jsp:include>
	<jsp:include page="../../common/constants.jsp" flush="true"/>

	
	<%
	HostMeasurementConfiguration defaultMeasurementConfiguration = null;
	HostMeasurementLogLocationInfo measurementLogLocationInfo = null;
	String selectedLogId = null;
	String[] measurementTypes = HostMeasurement.getMeasurementTypes();
	for(int i = 0; i < measurementTypes.length; i++) {
		defaultMeasurementConfiguration = HostsManager.getInstance().getDefaultHostMeasurementConfiguration(measurementTypes[i]);
		measurementLogLocationInfo = defaultMeasurementConfiguration.getMeasurementLocationInfo();
		if(measurementLogLocationInfo != null) {
			selectedLogId = measurementLogLocationInfo.getLbmId();
		}
		if(selectedLogId == null) {
			selectedLogId = "";
		}
		
		String selectLogSuffix = measurementTypes[i];
	%>
	<jsp:include page="../../common/selectLogHeader.jsp" flush="true">
		<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		<jsp:param name="LBM_ID" value="<%=selectedLogId%>" />
		<jsp:param name="mode" value="logs" />
		<jsp:param name="treeOnly" value="true" />
		<jsp:param name="ignoreHeader" value="true" />
		<jsp:param name="allowNewLog" value="true" />
		<jsp:param name="logPopupMenu" value="true" />
		<jsp:param name="parameterName" value="Metrics log:" />
		<jsp:param name="openLinkName" value="select log" />
		<jsp:param name="showMonitorsModule" value="false" />
		<jsp:param name="showNewFilter" value="false" />
		<jsp:param name="paramNameWidth" value="150" />
		<jsp:param name="dummy" value="dummy" />
		<jsp:param name="suffix" value="<%=selectLogSuffix %>"/>
	</jsp:include>
	<%
	}
	%>
	
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/UIUtil.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/common/messages.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/view/dashboard.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/view/dashboardTooltips.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxCalendar/codebase/dhtmlxcommon.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxCalendar/codebase/dhtmlxcalendar.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/common/dashboardCalendarFunctions.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/admin/dashboardAdministration.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/admin/dashboardAdministrationGeneral.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/admin/dashboardAdministrationAlerts.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/admin/dashboardAdministrationMeasurementsSettings.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/admin/dashboardAdministrationCustomProblemsManagement.js"></script>
	
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/jquery/jquery.js"></script>
	
	<script>
	var BASE_DIRECTORY = "../../";
	
	var FIXED_INTERVAL_CUSTOM = "<%=DateUtil.FIXED_INTERVAL_CUSTOM %>"
	
	var MAIL_TASK_TYPE = "<%=MailTask.TYPE_MAIL%>";
	
	var ALERTS_XML_PAGE = "dashboard/admin/dashboardAdministrationGlobalAlertsXML.jsp?dataOnly=true";
	var ALLOW_EDIT_EXTERNAL_ALERTS = true;

	var MEASUREMENT_DATA_TYPE_NONE = '<%=HostMeasurementConfiguration.MEASUREMENT_DATA_TYPE_NONE %>';
	var MEASUREMENT_DATA_TYPE_INTERNAL = '<%=HostMeasurementConfiguration.MEASUREMENT_DATA_TYPE_INTERNAL %>';
	var MEASUREMENT_DATA_TYPE_EXTERNAL = '<%=HostMeasurementConfiguration.MEASUREMENT_DATA_TYPE_EXTERNAL %>';
	</script>
</head>

<body onLoad="javascript:init()" onUnload="destroyTables()" style="margin:0;padding:0;overflow:auto">
<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/tooltip/wz_tooltip.js"></script>
<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/tooltip/tip_balloon.js"></script>
<form AUTOCOMPLETE="OFF" id="access" name="access" style="margin:0;padding:0" method="POST">
<div id="dashboardCalendarDiv" class="XPOLOG_DHTMLX_CALENDAR_DIV">
	<table border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td id="dashboardCalendarTd"></td>
		</tr>
		<tr>
			<td>
				<table border="0" cellpadding="0" cellspacing="0">
					<tr height="10px">
						<td class="XPOLOG_DHTMLX_CALENDAR_DATE_CELL_TEXT XPOLOG_DHTMLX_CALENDAR_START_DATE_CELL">Start Date:</td>
						<td class="XPOLOG_DHTMLX_CALENDAR_DATE_LABEL" id="dashboardCalendarStartDateTd"></td>
						<td class="XPOLOG_DHTMLX_CALENDAR_DATE_CELL_TEXT XPOLOG_DHTMLX_CALENDAR_END_DATE_CELL">End Date:</td>
						<td class="XPOLOG_DHTMLX_CALENDAR_DATE_LABEL" id="dashboardCalendarEndDateTd"></td>
					</tr>
					<tr height="10px">
						<td class="XPOLOG_DHTMLX_CALENDAR_TIME_CELL_TEXT XPOLOG_DHTMLX_CALENDAR_START_TIME_CELL">Start Time:</td>
						<td class="XPOLOG_DHTMLX_CALENDAR_TIME_INPUT_CELL"><input type="text" id="calendarStartTime" name="calendarStartTime" maxlength="8" class="XPOLOG_DHTMLX_CALENDAR_TIME_INPUT" onChange="javascript:validateTimeFormat('calendarStartTime', 'Start Time')"></td>
						<td class="XPOLOG_DHTMLX_CALENDAR_TIME_CELL_TEXT XPOLOG_DHTMLX_CALENDAR_END_TIME_CELL">End Time:</td>
						<td class="XPOLOG_DHTMLX_CALENDAR_TIME_INPUT_CELL"><input type="text" id="calendarEndTime" name="calendarEndTime" maxlength="8" class="XPOLOG_DHTMLX_CALENDAR_TIME_INPUT" onChange="javascript:validateTimeFormat('calendarEndTime', 'End Time')"></td>
					</tr>
					<tr height="10px">
						<td id="dashboardCalendarErrorTd" class="XPOLOG_DHTMLX_CALENDAR_ERROR_CELL" colspan="4">&nbsp;</td>
					</tr>
				</table>
			</td>
		</tr>
		<tr>
			<td class="XPOLOG_DHTMLX_CALENDAR_BUTTONS_CELL">
				<a href="javascript:goDashboardCalendar()"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/calendarGo.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/calendarGoOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/calendarGo.gif')"></a>
				<a href="javascript:closeDashboardCalendar()"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/calendarClose.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/calendarCloseOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/calendarClose.gif')"></a>
			</td>
		</tr>
	</table>
</div>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="margin:0;padding:0">
	<tr height="10px">
		<td>
			<%
			String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);
			String headerTitle = analyticsH + " Settings";
			%>
			<jsp:include page="../../common/pageHeader.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="<%=headerTitle%>" />
			</jsp:include>											
		</td>
	</tr>
	<tr>
		<td width="100%" height="100%" valign="top">
			<table class="ADMIN_TABLE_DIV" border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="margin:0;padding:0;">
				<tr>
					<td class="ADMIN_MAIN_TD" valign="top" height="100%">
					<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
						<tr height="1">
							<td>&nbsp;</td>
						</tr>														
						<tr style="background-color:#A4A4A4">
							<td style="padding:8">
								<div id="tabbarDiv" style="width:100%;height:100%;"></div>
								<div id="generalDiv" style="display:none;height:100%;width:100%;overflow:auto" >
									<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
										<tr>
											<td style="padding:10px">
												<jsp:include page="dashboardAdministrationGeneral.jsp" flush="true">
													<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
												</jsp:include>
											</td>
										</tr>
									</table>
								</div>
								<div id="alertsDiv" style="display:none;height:100%;width:100%;overflow:auto" >
									<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
										<tr>
											<td style="padding:10px">
												<jsp:include page="dashboardAdministrationGlobalAlerts.jsp" flush="true">
													<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
												</jsp:include>
											</td>
										</tr>
									</table>
								</div>
								<div id="customProblemsDiv" style="display:none;height:100%;width:100%;overflow:auto" >
									<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
										<tr valign="top">
											<td style="padding:10px">
												<jsp:include page="dashboardAdministrationCustomProblemsManagement.jsp" flush="true">
													<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
												</jsp:include>
											</td>
										</tr>
									</table>
								</div>
								<div id="metricsDiv" style="display:none;height:100%;width:100%;overflow:auto" >
									<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
										<tr valign="top">
											<td style="padding:10px">
												<jsp:include page="dashboardAdministrationMeasurementsSettings.jsp" flush="true">
													<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
												</jsp:include>
											</td>
										</tr>
									</table>
								</div>
								<div id="advancedDiv" style="display:none;height:100%;width:100%;overflow:auto" >
									<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
										<tr>
											<td style="padding:10px">
												<jsp:include page="dashboardAdministrationAdvanced.jsp" flush="true">
													<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
												</jsp:include>
											</td>
										</tr>
									</table>
								</div>
								<%
								String[] tabIds = null;
						    String[] tabNames = null;
				    		
						    tabIds = new String[]{"generalDiv", "alertsDiv", "customProblemsDiv", "metricsDiv", "advancedDiv"};
				    		tabNames = new String[]{"General", "Global Alerts", "Problems Management", "Metrics", "Advanced"};
								
				    		request.setAttribute("tabIds", tabIds);
				    		request.setAttribute("tabNames", tabNames);
								%>
								<jsp:include page="../../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
									<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
							</td>
						</tr>
						<tr height="1">
							<td>&nbsp;</td>
						</tr>
					</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr height="10px">
		<td>
			<jsp:include page="../../common/buttonsFooter.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="Save#Cancel" />
				<jsp:param name="actions" value="javascript:saveDashboardAdministration()#dashboard/view/dashboard.jsp" />
			</jsp:include>											
		</td>
	</tr>
</table>
<div id="messageDiv" style="position:absolute;width:300;height:120;display:none;z-index=310">
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
		<tr height="20">
			<td align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
					<span class="PROGRESSTEXT" id="messageTitle"></span>
			</td>
		</tr>
		<tr height="*" style="padding:5">
			<td class="PROGRESSTEXT" id="messageText" align="center" style="padding-left:10;padding-right:10">	 
			</td>
		</tr>											
		<tr height="10">
			<td align="center" style="padding:5"><nobr>
				<a class="PROGRESSLINK" href="javascript:hideMessageDiv()"> close </a>
				</nobr>		  							
			</td>
		</tr>
	</table>
</div>
<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="suffix" value="MailAlert"/> 
	<jsp:param name="width" value="600px"/> 
	<jsp:param name="height" value="405px"/>
	<jsp:param name="title" value="Email Alert"/> 
	<jsp:param name="actionsNames" value="Save#Cancel"/> 
	<jsp:param name="actions" value="javascript:saveAlert('MailAlert')#javascript:closeAlertDiv('MailAlert')"/> 
</jsp:include>
<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="suffix" value="MailAlertPrecondition"/> 
	<jsp:param name="width" value="570px"/> 
	<jsp:param name="height" value="300px"/>
	<jsp:param name="title" value="XpoLog Center Mail Settings"/> 
	<jsp:param name="actionsNames" value="Save#Cancel"/> 
	<jsp:param name="actions" value="javascript:saveMailSettings()#javascript:closeAlertDiv('MailAlertPrecondition')"/> 
</jsp:include>

<%
for(int i = 0; i < measurementTypes.length; i++) {
	String suffix = "SelectLog" + measurementTypes[i];
	String actionsNames = "Close";
	String actions = "javascript:closeLogSelectionDiv" + measurementTypes[i] + "()";
%>
<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="title" value="Select Metrics Data Source"/> 
	<jsp:param name="suffix" value="<%=suffix %>"/> 
	<jsp:param name="width" value="650px"/> 
	<jsp:param name="height" value="300px"/> 
	<jsp:param name="actionsNames" value="<%=actionsNames %>"/> 
	<jsp:param name="actions" value="<%=actions %>"/> 
</jsp:include>
<%
}
%>

</form>
</body>
</html>