function openSeverityDiv() {
	var objectId = getFirstSelectedRow(mygridCustomProblems);
	if (objectId == "") {
		return;
	}
	var problemId = document.getElementById('problemId');
	if(problemId) {
		problemId.value = objectId;
		
		showGeneralAdminDiv('ChangeSeverity', 150, 100);
	}
}

function closeSeverityDiv() {
	showGeneralAdminDiv('ChangeSeverity');
}

function doChangeSeverity(severity) {
	var objectId = getFirstSelectedRow(mygridCustomProblems);
	if (objectId == "") {
		return;
	}
	
	doChangeSeverity0(objectId, 'changeSeverity', severity);
}

function doChangeSeverity1() {
	var problemId = document.getElementById('problemId');
	if(problemId) {
		var newSeverity = document.getElementById('newSeverity');
		doChangeSeverity0(problemId.value, 'changeSeverity', newSeverity.value, 'ChangeSeverity');
	}
}

function doChangeSeverity0(objectId, action, severity, divToHide) {
	var matchType = "0";
	/*if(PROBLEM_TYPE == '') {
		
	}else if(PROBLEM_TYPE == '') {
		
	}*/
	
	var weight = -1;
	if(severity == 'low') {
		weight = 1;
	}else if(severity == 'medium') {
		weight = 4;
	}else if(severity == 'high') {
		weight = 7;
	}if(severity == '-1') {
		weight = -1;
	}
	
	var problemId = mygridCustomProblems.getUserData(objectId,"problemId");
	var problemType = mygridCustomProblems.getUserData(objectId,"problemType");
	var problemTerm = mygridCustomProblems.getUserData(objectId,"problemTerm");
	var problemRisk = mygridCustomProblems.getUserData(objectId,"problemRisk");
	
	var params = "";
	params += "&action=" + action;
	params += "&uniqueId=" + objectId;
	params += "&id=" + problemId;
	params += "&type=" + problemType;
	params += "&term=" + problemTerm;
	params += "&matchType=" + matchType;
	params += "&weight=" + weight;
	params += "&defaultWeight=" + problemRisk;
	
	sendAjaxRequest("dashboardAdministrationCustomProblemsManagementAction.jsp", function(req){
		var xmldoc = req.responseXML.documentElement;
	    if(xmldoc) {
	    	var responseElement = xmldoc.getElementsByTagName("Response")[0];
			if(responseElement) {
				var status = responseElement.getAttribute("status");
				var message = responseElement.getAttribute("message");
				var showMessage = responseElement.getAttribute("showMessage");
				if(showMessage != null && showMessage == 'true') {
					if(message != null) {
						if(divToHide) {
							showGeneralAdminDiv(divToHide);
						}
						
						if(message == '') {
							message = 'Problem severity operations will take effect only in future analyses';
						}
						var msgWriter = new messageWriter('dashboardProblemActionsMessage', 'Problem Action Result', BASE_DIRECTORY);
						msgWriter.setYParent(document.getElementById('mygridCustomProblems'),-50);
						msgWriter.addAction("OK","javascript:hideLayer('dashboardProblemActionsMessage')");
						msgWriter.showMessage(message);
					}
				}else {
					if(divToHide) {
						showGeneralAdminDiv(divToHide);
					}
				}
				updateTableCustomProblems();
			}
		}
	}, 'POST', params);
}

function doExcludeFromAnalysis() {
	var objectId = getFirstSelectedRow(mygridCustomProblems);
	if (objectId == "") {
		return;
	}
	doChangeSeverity0(objectId, 'changeSeverity', '-1');
}

function doResetSeverity() {
	var objectId = getFirstSelectedRow(mygridCustomProblems);
	if (objectId == "") {
		return;
	}
	
	doChangeSeverity0(objectId, 'resetSeverity', '-1');
}