<%@ page language="java"%>

<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.logcollection.XpologCollectionUnitAdminRequest"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page import="xpolog.eye.util.hosts.HostsManager"%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	String host = request.getParameter("host");
	String deleteMetricsDataStr = request.getParameter("deleteMetricsData");
	boolean deleteMetricsData = deleteMetricsDataStr != null && deleteMetricsDataStr.equals("true");
	boolean success = true;
	String message = "";
	if (host != null) {
		//audit
		AuditManager.getInstance().write(
				AuditConstants.BASIC_AUDIT_LEVEL, userContext,
				AuditConstants.CHANGE, "remove server",
				AuditConstants.DASHBOARD, "remove server " + host);

		try {
			HostsManager.getInstance().deleteHost(host, deleteMetricsData);
			success = true;
		} catch (Exception e) {
			success = false;
			message = e.getMessage();
		}
	}else {
		message = "No server supplied, please try again";
	}
	String xml = GridModelActionsHelper.getResultXML(success, message);

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	
	out.write(xml);
	out.flush();
%>
