<%@ page language="java"%>

<%@ page import="xpolog.eye.Module"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.ui.grid.GridTable"%>
<%@ page import="xpolog.eye.site.ui.grid.GridTableModel"%>
<%@ page import="xpolog.eye.site.ui.grid.models.dashboard.ComputationApplicationsGridTableModel"%>
<%@ page import="xpolog.eye.site.ui.grid.models.dashboard.ComputationFoldersAndLogsGridTableModel"%>
<%@ page import="xpolog.eye.site.ui.grid.models.dashboard.ComputationServersGridTableModel"%>
<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, null, true)) {
		return;
	}

	UserContext userContext = UserEnvironment.getUserContext(request);
		
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = "../../";
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String parentId = null;
	String memberId = request.getParameter("memberId");
	if (memberId == null|| memberId.length() == 0){
		memberId = request.getParameter("id");
		if (memberId != null && memberId.length() > 0){
			parentId = memberId;
		}
	}

	String viewBy = request.getParameter("viewBy");
	if(viewBy == null || viewBy.equals("")) {
		viewBy = HealthViewContext.VIEW_BY_FOLDERS;
	}
	
	GridTableModel model = null;
	if(viewBy.equals(HealthViewContext.VIEW_BY_FOLDERS)) {
		/*Module mod = memberId == null || memberId.length() == 0 ? null : SiteManagment.getInstance().getModuleFromId(memberId);
		if (mod == null){
			mod = SiteManagment.getInstance().getModuleFromId(Module.ROOT_MODULE_ID);
		}*/
		ComputationFoldersAndLogsGridTableModel foldersAndLogsModel = new ComputationFoldersAndLogsGridTableModel();
		foldersAndLogsModel.setBaseDirectory(baseDirectory);
		foldersAndLogsModel.setUserContext(userContext);
		foldersAndLogsModel.setGridName("mygrid" + suffix);
		//foldersAndLogsModel.setRootModule(mod);
		foldersAndLogsModel.setParentId(parentId);
		foldersAndLogsModel.init();
		
		model = foldersAndLogsModel;
	}else if(viewBy.equals(HealthViewContext.VIEW_BY_APPLICATIONS)) {
		Module mod = memberId == null || memberId.length() == 0 ? null : SiteManagment.getInstance().getModuleFromId(memberId);
		if (mod == null){
			mod = SiteManagment.getInstance().getModuleFromId(Module.ROOT_MODULE_ID);
		}
		ComputationApplicationsGridTableModel foldersAndLogsModel = new ComputationApplicationsGridTableModel();
		foldersAndLogsModel.setBaseDirectory(baseDirectory);
		foldersAndLogsModel.setUserContext(userContext);
		foldersAndLogsModel.setGridName("mygrid" + suffix);
		foldersAndLogsModel.setParentId(parentId);
		foldersAndLogsModel.init();
		
		model = foldersAndLogsModel;
	}else if(viewBy.equals(HealthViewContext.VIEW_BY_SERVERS)) {
		/*Module mod = memberId == null || memberId.length() == 0 ? null : SiteManagment.getInstance().getModuleFromId(memberId);
		if (mod == null){
			mod = SiteManagment.getInstance().getModuleFromId(Module.ROOT_MODULE_ID);
		}*/
		ComputationServersGridTableModel foldersAndLogsModel = new ComputationServersGridTableModel();
		foldersAndLogsModel.setBaseDirectory(baseDirectory);
		foldersAndLogsModel.setUserContext(userContext);
		foldersAndLogsModel.setGridName("mygrid" + suffix);
		//foldersAndLogsModel.setRootModule(mod);
		foldersAndLogsModel.setParentId(parentId);
		foldersAndLogsModel.init();
		
		model = foldersAndLogsModel;
	}
	
	GridTable table = new GridTable(model);
	request.setAttribute("gridTable" + suffix,table);
	
	request.getRequestDispatcher(baseDirectory + "widgets/grid/jsp/initTableXML.jsp").forward(request, response);	
%>