<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.computation.conf.monitoring.MultiComputationVerifier"%>
<%@ page import="xpolog.eye.computation.conf.monitoring.MultiComputationVerifierBuilder"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.reports.health.ui.DashboardAlertsManager"%>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page import="xpolog.eye.util.Constants"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
String DASHBOARD_GLOBAL_VERIFIER_BUILDER = "DASHBOARD_GLOBAL_VERIFIER_BUILDER";

ErrorModel errmod = new ErrorModel();
ComputationConfiguration computationConfiguration = ComputationConfiguration.getInstance();

MultiComputationVerifierBuilder builder = (MultiComputationVerifierBuilder)session.getAttribute(DASHBOARD_GLOBAL_VERIFIER_BUILDER);
builder.updateBuilder();
MultiComputationVerifier objectVerifier = builder.getMultiComputationVerifier();
if(objectVerifier.hasOnlyExternalVerifiers()) {
	if(objectVerifier.hasOnlyEnabledVerifiers()) {
		computationConfiguration.removeVerifier(objectVerifier);
	}else {
		computationConfiguration.addVerifier(objectVerifier);
	}
}else {
	if(objectVerifier.getXplgObjectId().equals(DashboardAlertsManager.DASHBOARD_GLOBAL_VERIFIER_ID)) {
		DashboardAlertsManager.getInstance().setGlobalVerifier(objectVerifier);
		DashboardAlertsManager.getInstance().saveGlobalVerifier();
	}else {
		computationConfiguration.addVerifier(objectVerifier);
	}
}

String xml = "";
if(errmod != null && errmod.getErrorCount() > 0) {
	//errors
	String[] errors = errmod.getErrors();
	StringBuffer sb = new StringBuffer();
	for(int i = 0; i < errors.length; i++) {
		if(sb.length() > 0) {
			sb.append("*;*");
		}
		sb.append(errors[i]);
	}
	String message = sb.toString();
	xml = GridModelActionsHelper.getResultXML(false, message);
}else{
	String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);
	xml = GridModelActionsHelper.getResultXML(true, analyticsH + " Administration Saved");
}
response.setContentType("text/xml");
response.setHeader("Pragma-Control", "no-cache");
response.setHeader("Cache-Control", "no-cache");
response.setHeader("Expires", "0");
out.write(xml);
out.flush();
%>