<%@ page language="java"%>

<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.computation.conf.monitoring.MultiComputationVerifierBuilder"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.ui.grid.GridTable"%>
<%@ page import="xpolog.eye.site.ui.grid.models.dashboard.ComputationAlertsGridTableModel"%>
<%@ page import="xpolog.eye.site.*"%>

<%
	String DASHBOARD_GLOBAL_VERIFIER_BUILDER = "DASHBOARD_GLOBAL_VERIFIER_BUILDER";
	
	String objectId = request.getParameter("objectId");
	if(objectId == null) {
		objectId = "";
	}
	String objectType = request.getParameter("objectType");
	if(objectType == null) {
		objectType = "";
	}
	String parentType = null;
	String parentId = null;
	int index = objectId.indexOf("^");
	if(index != -1) {
		String parentTypeId = objectId.substring(0, index);
		objectId = objectId.substring(index + 1);
		index = parentTypeId.indexOf("-");
		if(index != -1) {
			parentType = parentTypeId.substring(0, index);
			parentId = parentTypeId.substring(index + 1);
		}
	}
	String key = objectType + "-" + objectId;
	
	String forceNewBuilderStr = request.getParameter("forceNewBuilder");
	boolean forceNewBuilder = forceNewBuilderStr != null && forceNewBuilderStr.equals("true");
	
	MultiComputationVerifierBuilder builder = (MultiComputationVerifierBuilder)session.getAttribute(DASHBOARD_GLOBAL_VERIFIER_BUILDER);
	if(builder == null || !key.equals(builder.getMultiComputationVerifier().getKey()) || forceNewBuilder) {
		ComputationConfiguration computationConfiguration = ComputationConfiguration.getInstance();
		builder = new MultiComputationVerifierBuilder();
		builder.setVerifier(computationConfiguration.getVerifierByKey(key));
		builder.updateFromVerifier();
		session.setAttribute(DASHBOARD_GLOBAL_VERIFIER_BUILDER, builder);
	}
	
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, null, true)) {
		return;
	}

	UserContext userContext = UserEnvironment.getUserContext(request);
	
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = "../../";
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	ComputationAlertsGridTableModel model = new ComputationAlertsGridTableModel();
	model.setBuilder(builder);
	model.setBaseDirectory(baseDirectory);
	model.setUserContext(userContext);
	model.setGridName("mygrid" + suffix);
	model.setShowIsExternalColumn(true);
	model.init();
	GridTable table = new GridTable(model);
	request.setAttribute("gridTable" + suffix,table);
	
	request.getRequestDispatcher(baseDirectory + "widgets/grid/jsp/initTableXML.jsp").forward(request, response);	
%>
