<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.managment.XpologManagment"%>
<%@ page import="xpolog.eye.reports.health.ui.DashboardAlertsManager"%>
<%@ page import="xpolog.eye.reports.health.ui.DashboardAlertsManagerQuery"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewResult"%>
<%@ page import="xpolog.eye.site.SiteUtil"%>
<%@ page import="xpolog.eye.util.Constants"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>

<%

String objectType = request.getParameter("objectType");
String objectTypeDisplay = request.getParameter("objectTypeDisplay");
String objectId = request.getParameter("objectId");
String objectName = request.getParameter("objectName");
String startTimeStr = request.getParameter("startTime");
long startTime = Long.parseLong(startTimeStr);
String endTimeStr = request.getParameter("endTime");
long endTime = Long.parseLong(endTimeStr);
String computationExecutionId = request.getParameter("computationExecutionId");
String computationSubExecutionId = request.getParameter("computationSubExecutionId");
String executionTimeStr = request.getParameter("executionTime");
String includeTopProblemsStr = request.getParameter("includeTopProblems");
boolean includeTopProblems = includeTopProblemsStr != null && includeTopProblemsStr.equals("true");
String isMailStr = request.getParameter("isMail");
boolean isMail = isMailStr != null && isMailStr.equals("true");
String customBody = request.getParameter("customBody");

String text = "Following is a list of most severe problems found for [XpoLogObjectTypeDisplay] [XpoLogObjectName] at [ExecutionTime]:";
if(objectId.equals(DashboardAlertsManager.DASHBOARD_GLOBAL_VERIFIER_ID)) {
	text = "Following is a list of most severe global problems found at [ExecutionTime]:";
}
text = XpologUtil.replaceAll(text, "[XpoLogObjectTypeDisplay]", objectTypeDisplay);
text = XpologUtil.replaceAll(text, "[XpoLogObjectName]", objectName);
text = XpologUtil.replaceAll(text, "[ExecutionTime]", executionTimeStr);

String url = SiteUtil.getApplicationRoot(request, true, true);
url += "componentAction.jsp?selectedCompId=" + XpologManagment.ANALYTICS_COMPONENT + "&forward=root.jsp?mainPage=dashboard/view/loadObjectDashboardModel.jsp%253F";
StringBuffer buffer = new StringBuffer();
buffer.append("objectType=");
buffer.append(objectType);
buffer.append("&objectId=");
buffer.append(objectId);
buffer.append("&startTime=");
buffer.append(startTime);
buffer.append("&endTime=");
buffer.append(endTime);
buffer.append("&computationExecutionId=");
buffer.append(computationExecutionId);
buffer.append("&computationSubExecutionId=");
buffer.append(computationSubExecutionId);
String queryString = buffer.toString();
queryString = XpologUtil.replaceAll(queryString, "&", "%26");
queryString = XpologUtil.replaceAll(queryString, "%", "%25");
url += queryString;

DashboardAlertsManager dashboardAlertsManager = DashboardAlertsManager.getInstance();
DashboardAlertsManagerQuery query = new DashboardAlertsManagerQuery();
query.setObjectType(objectType);
query.setObjectId(objectId);
query.setObjectName(objectName);
query.setStartTime(startTime);
query.setEndTime(endTime);
query.setComputationExecutionId(computationExecutionId);
query.setComputationSubExecutionId(computationSubExecutionId);

String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);

%>

<html>
<head>
	<META HTTP-EQUIV="Content-Language" CONTENT="en-us">
	<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
	<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
	<META HTTP-EQUIV="EXPIRES" CONTENT="0">

	<style>
		body {
			background-color: white;
			font-size: 11px;
			font-family: tahoma, verdana, helvetica;
			color: #000000;
			position: absolute;
			width: 100%;
			height: 100%;
			margin: 0px;
			overflow: auto;
		}
		
		.DASHBOARD_ALERT_EMAIL_BODY_TEXT {
			font-size: 13px;
			font-family: tahoma, verdana, helvetica;
			color: #000000;
			padding-top: 5px;
			padding-left: 5px;
		}
		
		td.empty {
			font-size: 2px;
		}
		
		.DASHBOARD_TOP_MESSAGES_SECTION_CELL {
			padding-top: 15px;
		}
		
		/* Title */
		.DASHBOARD_TOP_MESSAGES_TITLE_CELL_MAIL {
			padding-top: 5px;
			padding-bottom: 5px;
			background-color: #68727A;
		}
		
		.DASHBOARD_TOP_MESSAGES_TITLE_BIG {
			font-size: 15px;
			color: #FFFFFF;
			font-weight: 900;
			padding-left: 10px;
		}
		
		/* Table */
		.DASHBOARD_TOP_MESSAGES_REGULAR_ROW {
			background-color: #FFFFFF
		}
		.DASHBOARD_TOP_MESSAGES_COLORED_ROW {
			background-color: #F0F0F0
		}
		
		.DASHBOARD_TOP_MESSAGES_HIGHLIGHTED_ROW {
			background-color: #ACD2E4
		}
		
		.DASHBOARD_TOP_MESSAGES_GENERAL_CELL {
			font-size: 12px;
			border-top: 1px solid #E2E2E2;
			border-left: 1px solid #E2E2E2;
			padding-top: 6px;
			padding-bottom: 6px;
		}
		
		.DASHBOARD_TOP_MESSAGES_GENERAL_RIGHT_CELL {
			border-right: 1px solid #E2E2E2;
		}
		
		.DASHBOARD_TOP_MESSAGES_HEADER_CELL {
			color: #504C45;
			text-align: center;
			font-weight: 600;
		}
		
		.DASHBOARD_TOP_MESSAGES_CELL {
			color: #1A52AD;
			text-align: left;
			padding-left: 10px;
		}
		
		.DASHBOARD_TOP_MESSAGES_NUMERIC_CELL {
			color: #1A52AD;
			text-align: right;
			padding-right: 10px;
		}
		
		.DASHBOARD_TOP_MESSAGES_CELL_BOLD {
			font-weight: bold;
		}
		
		a.DASHBOARD_TOP_MESSAGES_CELL_LINK:link {color: #1A52AD; font-size: 12px; text-decoration: underline;}
		a.DASHBOARD_TOP_MESSAGES_CELL_LINK:visited {color: #1A52AD; font-size: 12px; text-decoration: underline;}
		a.DASHBOARD_TOP_MESSAGES_CELL_LINK:active {color: #1A52AD; font-size: 12px; text-decoration: underline;}
		a.DASHBOARD_TOP_MESSAGES_CELL_LINK:hover {color: #1A52AD; font-size: 12px; text-decoration: underline;}
		
		.DASHBOARD_TOP_MESSAGES_STATUS_CELL {
			padding-left: 5px;
			text-align: left;
			font-weight: bold;
		}
		
		.DASHBOARD_TOP_MESSAGES_STATUS_CELL_0 {
			color: #69B973;
		}
		
		.DASHBOARD_TOP_MESSAGES_STATUS_CELL_1 {
			color: #C8B131;
		}
		
		.DASHBOARD_TOP_MESSAGES_STATUS_CELL_2 {
			color: #D77B32;
		}
		
		.DASHBOARD_TOP_MESSAGES_STATUS_CELL_3 {
			color: #FD0A2C;
		}
		
		.DASHBOARD_TOP_MESSAGES_IMAGES_CELL {
			text-align: center;
			border-right: 1px solid #E2E2E2;
		}
		
		/* Footer */
		.DASHBOARD_TOP_MESSAGES_FOOTER_CELL_MAIL {
			padding-top: 5px;
			padding-bottom: 5px;
			background-color: #E2E2E2;
		}
	</style>
</head>
<body>
<table cellpadding="0" cellspacing="0" style="height:20px; width: 100%">
<%
if(customBody != null && customBody.length() > 0) {
	customBody = XpologUtil.replaceAll(customBody,"\n","<br>");
%>
	<tr height="10px">
		<td class="DASHBOARD_ALERT_EMAIL_BODY_TEXT">
			<%=customBody %>
			<br>
		</td>
	</tr>
<%
}
%>

<%
if(includeTopProblems) {
%>
	<tr height="10px">
		<td class="DASHBOARD_ALERT_EMAIL_BODY_TEXT">
			<%=text %>
		</td>
	</tr>
<%
}
%>
	<tr height="10px">
		<td class="DASHBOARD_ALERT_EMAIL_BODY_TEXT">
			To view XpoLog's <%=analyticsH %>, click <a href="<%=url %>">here</a>
		</td>
	</tr>
</table>
<%
if(includeTopProblems) {
	HealthViewResult result = dashboardAlertsManager.getHealthViewResult(query);
	if(result != null) {
		request.setAttribute("result", result);
		request.setAttribute("sortBy", HealthViewContext.SORT_BY_MAX_WEIGHT);
		request.setAttribute("name", objectName);
%>
	<jsp:include page="dashboardTopMessages.jsp" flush="true">
		<jsp:param name="getResultFromRequest" value="true" />
		<jsp:param name="isMail" value="<%=isMail %>" />
	</jsp:include>
<%
	}
}
%>
</body>
</html>