function openLogFromDashboard(baseDirectory,lbmId, filterId, isKnowledge, newWindow,obj,hideDashboardButton,modelSessionAttributeName) {		 
	var minDateString = document.getElementById("dashboardMinDateFullStr").value;
	var maxDateString = document.getElementById("dashboardMaxDateFullStr").value;
	if(minDateString && maxDateString) {
		openLogFromDashboard0(baseDirectory,lbmId, filterId, isKnowledge, minDateString, maxDateString, newWindow,obj,hideDashboardButton,modelSessionAttributeName);
	}
}

function openLogFromDashboard0(baseDirectory,lbmId, filterId, isKnowledge, startTime, endTime, newWindow,obj,hideDashboardButton,modelSessionAttributeName) {
	var y = -1;
	if (obj){
		y = findPosY(obj);
		if (y <= 0){
			y = -1;
		}else {
			y = y - 60;
		}
	}

	if (filterId == ""){
		filterId = "NO_FILTER";
	}
	var ind = lbmId.indexOf("@");
	if (ind != -1){
		lbmId = lbmId.substring(ind + 1, lbmId.length);
	}

	var msgWriter = new messageWriter("mygridShowLogMessage","Log View",baseDirectory);
	msgWriter.setYParent(document.getElementById("mygrid"),50);
	msgWriter.width = 200;
	msgWriter.height = 60;
	msgWriter.setPosition(-1,y);
	msgWriter.showMessage("Loading Log...");     

	var params = "lbmId=" + encode(lbmId) + "&filterId=" + encode(filterId) + "&isKnowledge=" + encode(isKnowledge) + "&DateMinimum=" +encode(startTime) + "&DateMaximum=" + encode(endTime) + "&Dates=TimeLimRadio&quickDateFilter=true&expandLogViewer=true&hideDashboardButton=" + hideDashboardButton + "&modelSessionAttributeName=" + modelSessionAttributeName;
	var page = baseDirectory + "common/showLog.jsp";
	sendAjaxRequest(page,function(req){
		hideLayer('mygridShowLogMessage');
		var xmldoc = req.responseXML.documentElement;
		if(xmldoc) {
			var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
			var message = xmldoc.getElementsByTagName('message')[0].text;
			if (result == "true"){		
				var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
	
				openShowLogWindow(baseDirectory + message,true,baseDirectory,y);        						              
			}else if (xmldoc.getElementsByTagName('message')[0].firstChild){
				var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
				msgWriter = new messageWriter("mygridShowLogMessage","Log View",baseDirectory);
				msgWriter.addAction("OK","javascript:hideLayer('mygridShowLogMessage')");    	  	
				msgWriter.setMsgClass("ERRORMESSAGE_LIGHT");
				msgWriter.setPosition(-1,y);
				msgWriter.showMessage(message);	                
			}
		}
	},'POST',params,true);
}


function openShowLogWindow(url,showMessage,baseDirectory,y){
	var winW = 1280, winH = 1024;
	var size = getWidthAndHeight();
	if (size && size.length == 2){
		winW = size[0];
		winH = size[1];
	}

	var windowName = isChrome() ? "" : "_new";
	newWindow = window.open(url,windowName,"height="+winH+",width="+winW+",resizable=yes,scrollbars=yes,status=yes,left=20,top=20");

	if(showMessage) {
		PopupWarning.init(baseDirectory);
		setTimeout("popupWait('" + url + "'," + showMessage + ",'" + baseDirectory + "'," + y + ")", 500);
	}else {
		afterPopupWait(url,showMessage,baseDirectory,y);
	}
	
}

function popupWait(url,showMessage,baseDirectory,y) {
	if(PopupWarning.is_running()) {
		setTimeout("popupWait('" + url + "'," + showMessage + ",'" + baseDirectory + "'," + y + ")", 500);
	}else {
		afterPopupWait(url,showMessage,baseDirectory,y);
	}
}

function afterPopupWait(url,showMessage,baseDirectory,y) {
	if(PopupWarning.is_blocked() && showMessage) {
		var message = "Pop-up blocked. To see this pop-up click Continue.";
		msgWriter = new messageWriter("mygridShowLogMessage","Log View",baseDirectory);
		msgWriter.addAction("Continue","javascript:openShowLogWindowContinue('" + url + "','" + baseDirectory + "'," + y + ")");
		msgWriter.addAction("Close","javascript:hideLayer('mygridShowLogMessage')");
		msgWriter.setMsgClass("ERRORMESSAGE_LIGHT");
		msgWriter.setPosition(-1,y);
		msgWriter.showMessage(message);
	}else {
		newWindow.focus();
	}
}
function openShowLogWindowContinue(url,baseDirectory,y){
	hideLayer('mygridShowLogMessage');
	openShowLogWindow(url,false,baseDirectory,y);
}
