<%@ page language="java"%>

<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewGraphQuery"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewGraphResult"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewHelper"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModelHelper"%>

<%@ page import="xpolog.eye.reports.health.ui.HealthViewResult"%>

<%!
static final String BASE_DIRECTORY = "../../";
static final int WIDE_GRAPH_WIDTH = 1000;
static final int NARROW_GRAPH_WIDTH = 850;
static final int STEP_GRAPH_WIDTH = 1024;
static final int TALL_GRAPH_HEIGHT = 270;
//static final int SHORT_GRAPH_HEIGHT = 180;
static final int SHORT_GRAPH_HEIGHT = 270; // leave height same as in high resolution for now
static final int STEP_GRAPH_HEIGHT = 768;
%>

<%
String HEALTH_VIEW_MODEL = "HealthViewModel";

HealthViewModel model = (HealthViewModel)session.getAttribute(HEALTH_VIEW_MODEL);
HealthViewResult currentResult = model.getCurrentResult();

String windowWidthStr = request.getParameter("windowWidth");
int windowWidth = windowWidthStr != null && windowWidthStr.length() > 0 ? Integer.parseInt(windowWidthStr) : -1;
//int graphWidth = windowWidth != -1 && windowWidth <= STEP_GRAPH_WIDTH ? NARROW_GRAPH_WIDTH : WIDE_GRAPH_WIDTH;
int graphWidth = windowWidth != -1 ? windowWidth : NARROW_GRAPH_WIDTH;
String windowHeightStr = request.getParameter("windowHeight");
int windowHeight = windowHeightStr != null && windowHeightStr.length() > 0 ? Integer.parseInt(windowHeightStr) : -1;
int graphHeight = windowHeight != -1 && windowHeight <= STEP_GRAPH_HEIGHT ? SHORT_GRAPH_HEIGHT : TALL_GRAPH_HEIGHT;

String graphMapName = "graphMap";
HealthViewGraphQuery graphQuery = new HealthViewGraphQuery(graphWidth, graphHeight, graphMapName);
graphQuery.setShowMeasurments(model.isShowMetrics());
HealthViewGraphResult graphResult = null;

String viewType = model.getViewType();
String viewGroupType = model.getViewGroupType();
boolean hasVisibleResultElements = HealthViewModelHelper.hasVisibleResultElements(currentResult);
if(viewType.equals(HealthViewContext.VIEW_TYPE_TOTAL)) {
	if(viewGroupType.equals(HealthViewContext.VIEW_GROUP_TYPE_SUMMARY)) {
		if(hasVisibleResultElements) {
			graphResult = HealthViewHelper.generateTotalSplitXYChart(currentResult, graphQuery);
		}else {
			graphResult = HealthViewHelper.generateTotalXYChart(currentResult, graphQuery);
		}
	}else if(viewGroupType.equals(HealthViewContext.VIEW_GROUP_TYPE_SPLIT)) {
		graphResult = HealthViewHelper.generateTotalSplitXYChart(currentResult, graphQuery);
	}
}else if(viewType.equals(HealthViewContext.VIEW_TYPE_RISK)) {
	if(viewGroupType.equals(HealthViewContext.VIEW_GROUP_TYPE_SUMMARY)) {
		if(hasVisibleResultElements) {
			graphResult = HealthViewHelper.generateRiskSplitXYChart(currentResult, graphQuery);
		}else {
			graphResult = HealthViewHelper.generateRiskXYChart(currentResult, graphQuery);
		}
	}else if(viewGroupType.equals(HealthViewContext.VIEW_GROUP_TYPE_SPLIT)) {
		graphResult = HealthViewHelper.generateRiskSplitXYChart(currentResult, graphQuery);
	}
}

String graphImagePath = BASE_DIRECTORY + graphResult.getImagePath();
String graphMap = graphResult.getMapStr();

boolean showZoomOut = model.getZoomInDateFilters().size() > 0;
%>

<form AUTOCOMPLETE="OFF" id="dashboardGraphForm" name="dashboardGraphForm" method="POST" class="DASHBOARD_FORM">
<div id="dashboardMapDiv" class="DASHBOARD_GRAPH_MAP_DIV">
<%=graphMap%>
</div>
<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
	<tr height="10px">
		<td>
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr>
					<td>
						<img border="0" id="graphImage" src="<%=graphImagePath%>" usemap="#<%=graphMapName%>">
					</td>
				</tr>
			</table>
		</td>
	</tr>
</table>
</form>