<%@ page language="java"%>

<%@ page import="java.util.List"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModelHelper"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewNode"%>

<%!
static final String BASE_DIRECTORY = "../../";
static final int maxNumberOfNodesInPath = Configuration.getInstance().getPropertiesManager().getPropertyAsInt("dashboard.UI.maxNumberOfNodesInPath", 4);

%>

<%
String HEALTH_VIEW_MODEL = "HealthViewModel";

HealthViewModel model = (HealthViewModel)session.getAttribute(HEALTH_VIEW_MODEL);

String showResetButtonStr = request.getParameter("showResetButton");
boolean showResetButton = showResetButtonStr != null && showResetButtonStr.equals("true");
String pathClassName = request.getParameter("pathClassName");
String pathSeparatorClassName = request.getParameter("pathSeparatorClassName");
%>
<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
	<tr>
		<%
		if(showResetButton) {
		%>
		<td class="DASHBOARD_RESET_MODEL_CELL">
			<a href="javascript:resetModel()" onMouseOver="javascript:showTooltip(dashboardTooltips['home'])" onMouseOut="javascript:hideTooltip()"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/resetModel.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/resetModelOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/resetModel.gif')"></a>
		</td>
		<%
		}
		%>
		<td>
		<%
		List nodesList = model.getNodesList();
		if(nodesList.size() > 1) {
			HealthViewNode node = (HealthViewNode)nodesList.get(1);
			String rootName = HealthViewModelHelper.getCurrentRootNodeName(node);
			String name = null;			
			for(int i = 0; i < nodesList.size() - 1; i++) {
				// limit the number of nodes to be shown in the path
				if(maxNumberOfNodesInPath != -1 && i > maxNumberOfNodesInPath - 1) {
		%>
					<span class="<%=pathSeparatorClassName %>">&gt;</span>
					<span class="<%=pathSeparatorClassName %>">...</span>
		<%
					break;
				}
				node = (HealthViewNode)nodesList.get(i);
				if(i > 0) {
					name = node.getName();
		%>
				<span class="<%=pathSeparatorClassName %>">&gt;</span>
		<%
				}else {
					name = rootName;
				}
		%>
			<a class="<%=pathClassName %>" href="javascript:setCurrentNode('<%=node.getId() %>')"><%=name %></a>
		<%
			}
			name = model.getCurrentNodeName();
		%>
			<span class="<%=pathSeparatorClassName %>">&gt;</span>
			<span class="<%=pathClassName %>"><%=name %></span>
		<%
		}else {
		%>
		&nbsp;
		<%
		}
		%>
		</td>
	</tr>
</table>