var dashboardTooltips = new Array();

dashboardTooltips['refreshData'] = "Refresh current view";
dashboardTooltips['dataGenerationInProgress'] = "Missing data is being completed";
dashboardTooltips['dataGenerationCompleted'] = "Data generation completed, click to refresh";
dashboardTooltips['home'] = "Default view";
dashboardTooltips['zoomOutCalendar'] = "Zoom out";
dashboardTooltips['zoomInCalendar'] = "Zoom in";
dashboardTooltips['openFixedIntervalsList'] = "Open list";
dashboardTooltips['openCalendar'] = "Open calendar";
dashboardTooltips['openFilterByDiv'] = "Open filter";
dashboardTooltips['openFilterByTypesList'] = "Open list";

dashboardTooltips['zoomInGraph'] = "Zoom into selected time slot";
dashboardTooltips['zoomOutGraph'] = "Zoom out to previous time slot";
dashboardTooltips['previousGraphTime'] = "Previous time slot";
dashboardTooltips['nextGraphTime'] = "Next time slot";

dashboardTooltips['nodesListUp'] = "View parent";
dashboardTooltips['selectMainTableNode'] = "Select";
dashboardTooltips['unselectMainTableNode'] = "Unselect";
dashboardTooltips['zoomIntoMainTableNode'] = "Drill down";
dashboardTooltips['emptyNode'] = "No results";
dashboardTooltips['showLog'] = "View in log";
dashboardTooltips['search'] = "Search results";

dashboardTooltips['zoomIntoTopMessagesNode'] = "View in log";

dashboardTooltips['openPoblemActions'] = "Customize problem severity";

function showMetricsRows(baseDir,suffix){
  var matricsRow = document.getElementById("row" + suffix + "_0");
  var img = document.getElementById("openRowsImg" + suffix);
  if (!img){
    return;
  }
  if (!matricsRow){
    img.src = baseDir + "images/dashboard/tooltip/close.gif";
  }else {
    if (matricsRow.style.display == "none"){
      var i = 0;
      while (matricsRow){
        matricsRow.style.display = "";        
        i++;
        matricsRow = document.getElementById("row" + suffix + "_" + i);
      } 
      img.src = baseDir + "images/dashboard/tooltip/open.gif";
    }else {
      var i = 0;
      while (matricsRow){
        matricsRow.style.display = "none";
        i++;
        matricsRow = document.getElementById("row" + suffix + "_" + i);
      } 
      img.src = baseDir + "images/dashboard/tooltip/close.gif";
    }
  }
}
