<%@ page language="java"%>

<%@ page import="java.text.NumberFormat"%>

<%@ page import="xpolog.eye.computation.ComputationResults"%>
<%@ page import="xpolog.eye.computation.TopComputationResult"%>
<%@ page import="xpolog.eye.reports.health.ui.DashboardAlertsManager"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModelHelper"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewResult"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewResultElement"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>

<%!
static final String BASE_DIRECTORY = "../../";

%>

<%
String HEALTH_VIEW_MODEL = "HealthViewModel";

String getResultFromRequestStr = request.getParameter("getResultFromRequest");
boolean getResultFromRequest = getResultFromRequestStr != null && getResultFromRequestStr.equals("true");
String isMailStr = request.getParameter("isMail");
boolean isMail = isMailStr != null && isMailStr.equals("true");

HealthViewModel model = null;
HealthViewResult currentResult = null;
String currentNodeName = "";
String sortBy = "";
TopComputationResult[] topResultsElements = null;
if(getResultFromRequest) {
	currentResult = (HealthViewResult)request.getAttribute("result");
	currentNodeName = (String)request.getAttribute("name");
	sortBy = (String)request.getAttribute("sortBy");
}else {
	model = (HealthViewModel)session.getAttribute(HEALTH_VIEW_MODEL);
	currentResult = model.getCurrentResult();
	currentNodeName = model.getCurrentNodeName();
	sortBy = model.getSortBy();
}
topResultsElements = currentResult.getRootNodeResultElement().getComputationResults().getTopResults();
int numberOfCurrentPageResultElements = currentResult.getCurrentPageResultElements().size();

boolean showSourceColumn = true;// (numberOfCurrentPageResultElements > 1 || isMail) && (!currentResult.getRootNode().getType().equals(XpoLogObjectTypes.LOG_TYPE));

NumberFormat numberFormat = NumberFormat.getNumberInstance();
numberFormat.setMaximumFractionDigits(2);

int maxProblemsInEmail = DashboardAlertsManager.MAX_PROBLEMS_IN_EMAIL;
%>

<form AUTOCOMPLETE="OFF" id="dashboardTopMessagesForm" name="dashboardTopMessagesForm" method="POST" class="DASHBOARD_FORM">
<table cellpadding="0" cellspacing="0" style="height:20px; width: 100%">
	<tr height="10px">
		<td class="DASHBOARD_TOP_MESSAGES_SECTION_CELL">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr height="10px">
					<td>
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td class="<%=isMail ? "DASHBOARD_TOP_MESSAGES_TITLE_CELL_MAIL" : "DASHBOARD_TOP_MESSAGES_TITLE_LEFT_CELL" %>">&nbsp;</td>
								<td class="<%=isMail ? "DASHBOARD_TOP_MESSAGES_TITLE_CELL_MAIL" : "DASHBOARD_TOP_MESSAGES_TITLE_CENTER_CELL" %>">
									<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
										<tr>
											<td class="DASHBOARD_TOP_MESSAGES_TITLE_BIG"><nobr><%=currentNodeName %>&nbsp;Most Severe Problems</nobr></td>
											<td class="empty">&nbsp;</td>
										</tr>
									</table>
								</td>
								<td class="<%=isMail ? "DASHBOARD_TOP_MESSAGES_TITLE_CELL_MAIL" : "DASHBOARD_TOP_MESSAGES_TITLE_RIGHT_CELL" %>">&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
				<%
				if(topResultsElements.length > 0) {
				%>
				<tr>
					<td>
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<%
								if(showSourceColumn) {
								%>
								<td class="DASHBOARD_TOP_MESSAGES_GENERAL_CELL DASHBOARD_TOP_MESSAGES_HEADER_CELL" style="width: 200px;">Source</td>
								<%
								}
								%>
								<td class="DASHBOARD_TOP_MESSAGES_GENERAL_CELL DASHBOARD_TOP_MESSAGES_HEADER_CELL">Problem</td>
								<td class="DASHBOARD_TOP_MESSAGES_GENERAL_CELL DASHBOARD_TOP_MESSAGES_HEADER_CELL" style="width: 100px;">Type</td>
								<td class="DASHBOARD_TOP_MESSAGES_GENERAL_CELL DASHBOARD_TOP_MESSAGES_HEADER_CELL" style="width: 120px;"># of Occurrences</td>
								<td class="DASHBOARD_TOP_MESSAGES_GENERAL_CELL DASHBOARD_TOP_MESSAGES_HEADER_CELL" style="width: 80px;">Severity</td>
								<td class="DASHBOARD_TOP_MESSAGES_GENERAL_CELL DASHBOARD_TOP_MESSAGES_HEADER_CELL DASHBOARD_TOP_MESSAGES_GENERAL_RIGHT_CELL" style="width: 40px;">&nbsp;</td>
							</tr>
							<%
							if(topResultsElements != null && topResultsElements.length > 0) {
								TopComputationResult topResults = null;
								String sourceId = null, parentName = null, id = null, idForJavaScript = null, name = null, type = null;
								String zoomInLink = null, zoomInMouseActionsString = null;
								long total;
								double risk;
								String riskText = null, riskTextClassName = null;
								String rowClassName = "";
								String rowId = "";
								int limit = topResultsElements.length;
								if(isMail && maxProblemsInEmail != -1 && topResultsElements.length > maxProblemsInEmail) {
									limit = maxProblemsInEmail;
								}
								for(int i = 0; i < limit; i++) {
									topResults = topResultsElements[i];
									sourceId = topResults.getSourcesStr(",");
									parentName = topResults.getParent() == null ? "N/A" : topResults.getParent().getName();
									id = topResults.getId();
									idForJavaScript = id;
									idForJavaScript = XpologUtil.updateAsHtmlString(idForJavaScript);
									idForJavaScript = XpologUtil.replaceAll(idForJavaScript, "'", "\\'");
									name = topResults.getName();
									name = XpologUtil.updateAsHtmlString(name);
									type = topResults.getType();
									total = topResults.getTotal();
									risk = topResults.getWeight();
									riskText = HealthViewModelHelper.getFormattedRisk(risk);
									
									if(risk > 0) {
										riskTextClassName = "DASHBOARD_TOP_MESSAGES_STATUS_CELL_" + HealthViewModelHelper.getRiskClassNameSuffix(risk);
									}else {
										riskTextClassName = "DASHBOARD_TOP_MESSAGES_STATUS_CELL_0";
									}
									rowId = "topMessagesRow_" + i;
									if(type.equals(XpoLogObjectTypes.FILTER_TYPE) ||
										 type.equals(XpoLogObjectTypes.KNOWLEDGE_TYPE)) {
											boolean isKnowledge = type.equals(XpoLogObjectTypes.KNOWLEDGE_TYPE);
											zoomInLink = "javascript:openLogFromDashboard('" + BASE_DIRECTORY + "','" + sourceId + "', '" + idForJavaScript + "', '" + isKnowledge + "', 'true',document.getElementById('" + rowId + "'),true,'HealthViewModel')";
											zoomInMouseActionsString = "onMouseOver=\"javascript:showTooltip(dashboardTooltips['zoomIntoTopMessagesNode'])\" onMouseOut=\"javascript:hideTooltip()\"";
									}else {
										zoomInLink = null;
										zoomInMouseActionsString = "";
									}
									boolean showProblemActionsLink = !isMail;
									boolean showZoomInLink = zoomInLink != null && !isMail;

									if(i % 2 == 0) {
										rowClassName = "DASHBOARD_TOP_MESSAGES_COLORED_ROW";
									}else {
										rowClassName = "DASHBOARD_TOP_MESSAGES_REGULAR_ROW";
									}
									
									
							%>
								<tr id="<%=rowId %>" class="<%=rowClassName %>" onMouseOver="javascript:setTopMessagesRowClass('<%=rowId %>', 'DASHBOARD_TOP_MESSAGES_HIGHLIGHTED_ROW')" onMouseOut="javascript:setTopMessagesRowClass('<%=rowId %>', '<%=rowClassName %>')">
									<%
									if(showSourceColumn) {
									%>
									<td class="DASHBOARD_TOP_MESSAGES_GENERAL_CELL DASHBOARD_TOP_MESSAGES_CELL"><%=parentName %></td>
									<%
									}
									%>
									<td class="DASHBOARD_TOP_MESSAGES_GENERAL_CELL DASHBOARD_TOP_MESSAGES_CELL">
									<%
									if(showZoomInLink) {
									%>
										<a href="<%=zoomInLink %>" class="DASHBOARD_TOP_MESSAGES_CELL_LINK" <%=zoomInMouseActionsString %>>
									<%
									}
									%>
										<%=name %>
									<%
									if(showZoomInLink) {
									%>
										</a>
									<%
									}
									%>
									</td>
									<td class="DASHBOARD_TOP_MESSAGES_GENERAL_CELL DASHBOARD_TOP_MESSAGES_CELL"><%=HealthViewModelHelper.getFormattedProblemType(type) %></td>
									<td class="DASHBOARD_TOP_MESSAGES_GENERAL_CELL DASHBOARD_TOP_MESSAGES_NUMERIC_CELL"><%=numberFormat.format(total) %></td>
									<td class="DASHBOARD_TOP_MESSAGES_GENERAL_CELL DASHBOARD_TOP_MESSAGES_STATUS_CELL <%=riskTextClassName %>"><%=riskText %></td>
									<td class="DASHBOARD_TOP_MESSAGES_GENERAL_CELL DASHBOARD_TOP_MESSAGES_IMAGES_CELL">
									<%
									if(showZoomInLink) {
									%>
										<a href="<%=zoomInLink %>" <%=zoomInMouseActionsString %> class="DASHBOARD_TOP_MESSAGES_IMAGE_LINK">
											<img src="<%=BASE_DIRECTORY %>images/dashboard/topMessages/tableRowZoom.gif" border="0" onMouseOver="javascript:setImageSource(this, 'topMessages/tableRowZoomOver.gif')" onMouseOut="javascript:setImageSource(this, 'topMessages/tableRowZoom.gif')">
										</a>
									<%
									}else {
									%>
									&nbsp;
									<%
									}
									if(showProblemActionsLink) {
									%>
										<span class="DASHBOARD_PROBLEM_ACTIONS_ARROW"><a id="<%=rowId %>_problemActionsMenuLinkTopMessages" href="javascript:openProblemActionsMenu(-180, 0, '<%=rowId %>_problemActionsMenuLinkTopMessages', '<%=idForJavaScript %>', '<%=name %>', '<%=type %>', '<%=risk %>', '<%=riskText %>')" onMouseOver="javascript:showTooltip(dashboardTooltips['openPoblemActions'])" onMouseOut="javascript:hideTooltip()" class="DASHBOARD_TOP_MESSAGES_IMAGE_LINK"><img src="<%=BASE_DIRECTORY %>images/dashboard/topMessages/problemActionsOpen.gif" border="0"></a></span>
									<%
									}
									%>
									</td>
								</tr>
							<%
								}
							}
							%>
						</table>
					</td>
				</tr>
				<%
				}else {
				%>
				<tr>
					<td>
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td class="DASHBOARD_TOP_MESSAGES_GENERAL_CELL DASHBOARD_TOP_MESSAGES_HEADER_CELL DASHBOARD_TOP_MESSAGES_GENERAL_RIGHT_CELL">No problems were found</td>
							</tr>
						</table>
					</td>
				</tr>
				<%
				}
				%>
				<tr>
					<td>
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td class="<%=isMail ? "DASHBOARD_TOP_MESSAGES_FOOTER_CELL_MAIL" : "DASHBOARD_TOP_MESSAGES_FOOTER_LEFT_CELL"%>">&nbsp;</td>
								<td class="<%=isMail ? "DASHBOARD_TOP_MESSAGES_FOOTER_CELL_MAIL" : "DASHBOARD_TOP_MESSAGES_FOOTER_CENTER_CELL"%>">&nbsp;</td>
								<td class="<%=isMail ? "DASHBOARD_TOP_MESSAGES_FOOTER_CELL_MAIL" : "DASHBOARD_TOP_MESSAGES_FOOTER_RIGHT_CELL"%>">&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td class="empty">&nbsp;</td>
	</tr>
</table>
</form>