
<%@page import="xpolog.eye.util.hosts.HostInfo"%>
<%@page import="xpolog.eye.util.hosts.HostsManager"%>
<%@page import="xpolog.eye.util.hosts.HostModuleMemberChecker"%>
<%@page import="xpolog.eye.reports.health.ui.HealthViewContextFilter"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext"%>
<%@ page import="xpolog.eye.admin.helpers.MergeAdminHelper"%>
<%@ page import="xpolog.eye.admin.builders.MergedLogBrowserBuilder"%>
<%@ page import="xpolog.eye.merge.MergedLogBrowserManager"%>
<%@ page import="xpolog.eye.site.ui.tree.ModuleMemberRenderer"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.util.*"%>

<%!

%>

<%
	String HEALTH_VIEW_MODEL = "HealthViewModel";

	HealthViewModel model = (HealthViewModel)session.getAttribute(HEALTH_VIEW_MODEL);
	
	SiteManagment mgmt = SiteManagment.getInstance();
	SiteAdministrator admin = SiteManagment.getAdminInstance();
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
	
	String filterByType = request.getParameter("filterByType");
	
	HashMap modulesMap = null, logsMap = null, selectedModules = null, selectedHosts = null;
	
	HealthViewContextFilter contextFilter = model.getContextFilter();
	if(contextFilter != null) {
		Set filterLogs = contextFilter.getLogs();
		if(filterLogs != null) {
			logsMap = new HashMap();
			
			Iterator it = filterLogs.iterator();
			String logId = null;
			while(it.hasNext()) {
				logId = (String)it.next();
				logsMap.put(logId, logId);
			}
		}
		Set filterModules = contextFilter.getModules();
		if(filterModules != null) {
			modulesMap = new HashMap();
			
			Iterator it = filterModules.iterator();
			String moduleId = null;
			while(it.hasNext()) {
				moduleId = (String)it.next();
				modulesMap.put(moduleId, moduleId);
			}
			if(selectedModules == null && !filterModules.isEmpty()) {
				selectedModules = new HashMap();
			}
		}
		Set filterHosts = contextFilter.getServers();
		if(filterHosts != null) {
			if(selectedHosts == null && !filterHosts.isEmpty()) {
				selectedHosts = new HashMap();
				Iterator it = filterHosts.iterator();
				String host = null;
				while(it.hasNext()) {
					host = (String)it.next();
					selectedHosts.put(host, host);
				}
			}
		}
	}
	ModuleMemberRenderer.addModuleMemberParents(modulesMap,logsMap);
	
	String treeXml = ""; 
	boolean treeNodeExists = false;
	
	String id = request.getParameter("id");
	String extId = null;
	if (id != null){
  	String type = null;
  	int ind = id.indexOf("-");
  	if (ind != -1){
  		type = id.substring(0, ind);
  		id = id.substring(ind+1);
  	}
  	ind = id.indexOf("@");
  	if(ind != -1) {
  		if(filterByType != null) {
  			extId = id.substring(0, ind);
  		}
  		id = id.substring(ind+1);
  	}
		curmod = SiteManagment.getInstance().getModuleFromId(id);
		treeNodeExists = true;
  }
	
	if (curmod != null){
		ModuleMemberRenderer renderer= new ModuleMemberRenderer(curmod, userContext, modulesMap, logsMap, true, false, treeNodeExists);
		if(selectedModules != null) {
			renderer.setSelectedModules(selectedModules);
		}
		if(selectedHosts != null) {
			renderer.setSelectedHosts(selectedHosts);
		}
		String[] logTypesToIgnore = new String[1];
		logTypesToIgnore[0] = MergedLogBrowserBuilder.MERGE_LOG_TYPE;
		renderer.setLogTypesToIgnore(logTypesToIgnore);
		renderer.setOnlyUseInDashboard(true);
		if(filterByType != null) {
			if(filterByType.equals(HealthViewContext.VIEW_BY_FOLDERS)) {
				treeXml = renderer.getTreeXML();
			}else if(filterByType.equals(HealthViewContext.VIEW_BY_APPLICATIONS)) {
				if(extId != null) {
					renderer.setExtIdToAppend(extId);
					renderer.setMod(curmod);
					treeXml = renderer.getTreeXML();
				}else {
					treeXml = renderer.getApplicationTreeXML(false, false);
				}
			}else if(filterByType.equals(HealthViewContext.VIEW_BY_SERVERS)) {
				renderer.setExtType(XpoLogObjectTypes.HOST_TYPE);
				if(extId != null) {
					renderer.setExtIdToAppend(extId);
					renderer.setMod(curmod);
					HostInfo hostInfo = HostsManager.getInstance().getHostInfo(extId);
					if(hostInfo != null) {
						HashMap map = new HashMap();
						map.put(extId, hostInfo);
						HostModuleMemberChecker checker = new HostModuleMemberChecker(map);
						checker.setCurrentHost(extId);
						renderer.setModuleMemberChecker(checker);
					}
					treeXml = renderer.getTreeXML();
				}else {
					treeXml = renderer.getHostsTreeXML(true);
				}
			}
		}
	}
	//System.out.println("***************************************");
	//System.out.println(treeXml);
	response.setContentType("text/xml");
	out.write(treeXml);
	out.flush();
%>