<%@ page language="java"%>

<%@ page import="java.text.NumberFormat"%>

<%@ page import="xpolog.eye.computation.ComputationResults"%>
<%@ page import="xpolog.eye.computation.impl.HostComputationResults"%>
<%@ page import="xpolog.eye.computation.MultiComputationResults"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewGraphTooltipQuery"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModelHelper"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewNode"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
String HEALTH_VIEW_MODEL = "HealthViewModel";

HealthViewModel model = (HealthViewModel)session.getAttribute(HEALTH_VIEW_MODEL);

String graphTypeStr = request.getParameter("graphType");
int graphType = HealthViewGraphTooltipQuery.GRAPH_TYPE_METRICS_CPU;
if(graphTypeStr != null && graphTypeStr.length() > 0) {
	try {
		graphType = Integer.parseInt(graphTypeStr);
	}catch(Exception e) {
	}
}

String hostMeasurementTypeStr = "";
if(graphType == HealthViewGraphTooltipQuery.GRAPH_TYPE_METRICS_CPU) {
	hostMeasurementTypeStr = HostCpu.HOST_CPU_TYPE;
}else if(graphType == HealthViewGraphTooltipQuery.GRAPH_TYPE_METRICS_MEMORY) {
	hostMeasurementTypeStr = HostMemory.HOST_MEMORY_TYPE;
}

String isEmbededStr = request.getParameter("isEmbeded");
boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");

MultiComputationResults tooltipResults = (MultiComputationResults)request.getAttribute("tooltipResults");
int numOfResults = tooltipResults.getMembersCount();
String name = tooltipResults.getName();
if(tooltipResults.getId().equals(HealthViewContext.ROOT_HOST_ID)) {
	name = "Servers";
}
if(graphType == HealthViewGraphTooltipQuery.GRAPH_TYPE_METRICS_CPU) {
	name += " Used CPU Metrics";
}else if(graphType == HealthViewGraphTooltipQuery.GRAPH_TYPE_METRICS_MEMORY) {
	name += " Used Memory Metrics";
}
String tooltipHeaderDateString = (String)request.getAttribute("tooltipHeaderDateString");
String startDateString = (String)request.getAttribute("startDateString");
startDateString += ":00";
String endDateString = (String)request.getAttribute("endDateString");
endDateString += ":00";
String bgSuffix = (String)request.getAttribute("bgSuffix");

HostComputationResults memberResults = null;

NumberFormat numberFormat = NumberFormat.getNumberInstance();
numberFormat.setMaximumFractionDigits(2);

if(isEmbeded) {
	out.print("<![CDATA[");
}
%>


<%@page import="xpolog.eye.util.hosts.measurements.computation.HostMeasurementTotals"%>
<%@page import="xpolog.eye.util.hosts.measurements.impl.HostCpu"%>
<%@page import="xpolog.eye.util.hosts.measurements.impl.HostMemory"%>
<%@page import="xpolog.eye.computation.impl.MultiHostComputationResults"%>
<%@page import="xpolog.eye.reports.health.ui.HealthViewHelper"%>
<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%" id="dashboardGraphTooltipTable">
	<tr height="6px">
		<td class="DASHBOARD_GRAPH_TOOLTIP_HEADER_LEFT_CELL_BG_<%=bgSuffix %>"></td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_TOP_FILLER_CELL_BG_<%=bgSuffix %>"></td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_HEADER_RIGHT_CELL_BG_<%=bgSuffix %>"></td>
	</tr>
	<tr height="10px">
		<td class="DASHBOARD_GRAPH_TOOLTIP_LEFT_FILLER_CELL_BG_<%=bgSuffix %>"></td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_FILLER_CELL_BG_<%=bgSuffix %> DASHBOARD_GRAPH_TOOLTIP_HEADER_CELL">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr>
					<td class="DASHBOARD_GRAPH_TOOLTIP_HEADER"><%=name %> Problems</td>
				</tr>
				<tr>
					<td class="DASHBOARD_GRAPH_TOOLTIP_HEADER"><%=tooltipHeaderDateString.toString() %></td>
				</tr>
			</table>
		</td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_RIGHT_FILLER_CELL_BG_<%=bgSuffix %>"></td>
	</tr>
	<tr height="*">
		<td class="DASHBOARD_GRAPH_TOOLTIP_LEFT_FILLER_CELL_BG_<%=bgSuffix %>"></td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_CENTER_CELL_BG_<%=bgSuffix %> DASHBOARD_GRAPH_TOOLTIP_BODY_CELL">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr height="10px">
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Name</td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Problems</td>
				<%if(hostMeasurementTypeStr.equals(HostCpu.HOST_CPU_TYPE)) { %>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Avg CPU</td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Max CPU</td>
				<%}else if(hostMeasurementTypeStr.equals(HostMemory.HOST_MEMORY_TYPE)) { %>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Avg Memory</td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Max Memory</td>
				<%} %>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Status</td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL"></td>
				</tr>
				<%
				HealthViewNode logNode = model.getLogNode();
				String memberId, memberName;
				String memberLink = null, zoomInMmouseActionsString = null, zoomInMmouseActionsStringMessage = null;
				long memberTotal, memberTotalProblems;
				HostMeasurementTotals measurementTotal;
				double average, max;
				double risk;
				String rowClassName = null;
				
				if(numOfResults > 0) {
					for(int i = 0; i < numOfResults; i++) {
						memberResults = (HostComputationResults)tooltipResults.getMembersResults()[i];
						
						memberId = memberResults.getId();
						memberName = memberResults.getName();
						memberName = HealthViewHelper.adjustTooltipName(memberName);
						
						String rowId = "tooltipRow_" + i;
						
						boolean showLink = model.getViewBy().equals(HealthViewContext.VIEW_BY_SERVERS) && 
						model.getCurrentResult().getRootNode().getId().equals(HealthViewContext.ROOT_NODE_ID);
						if(showLink) {
							memberLink = "javascript:zoomIntoElement('" + memberResults.getId() + "', '" + memberResults.getName() + "', '" + memberResults.getType() + "');hideDashboardGraphTooltip()";
							zoomInMmouseActionsStringMessage = "dashboardTooltips['zoomIntoMainTableNode']";
						}
						
						if(zoomInMmouseActionsStringMessage == null) {
							zoomInMmouseActionsString = "";
						}else {
							zoomInMmouseActionsString = "onMouseOver=\"javascript:showTooltip(" + zoomInMmouseActionsStringMessage + ")\" onMouseOut=\"javascript:hideTooltip()\"";
						}
						
						memberTotal = memberResults.getTotal();
						if(memberResults instanceof MultiHostComputationResults) {
							memberTotalProblems = ((MultiHostComputationResults)memberResults).getProblemsByGroupType(hostMeasurementTypeStr);
						}else {
							memberTotalProblems = memberResults.getSumOfProblems();
						}
						
						average = -1;
						max = -1;
						measurementTotal = memberResults.getHostMeasurementTotals(hostMeasurementTypeStr);
						if(measurementTotal != null) {
							average = measurementTotal.getValue();
							max = measurementTotal.getMaxValue();
						}
						
						if(i % 2 == 0) {
							rowClassName = "DASHBOARD_GRAPH_TOOLTIP_BODY_COLORED_ROW";
						}else {
							rowClassName = "DASHBOARD_GRAPH_TOOLTIP_BODY_REGULAR_ROW";
						}
				%>
					<tr class="<%=rowClassName %>" height="10px" id="<%=rowId%>">
				<%
							if(memberResults instanceof MultiHostComputationResults) {
								risk = ((MultiHostComputationResults)memberResults).getWeightByGroupType(hostMeasurementTypeStr);
							}else {
								risk = memberResults.getMaxWeight();
							}
							if(risk == -1) {
								risk = 0;
							}
				%>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_NAME_CELL">
				<%
						if(memberLink != null) {
				%>
							<a href="<%=memberLink %>" class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL_LINK" <%=zoomInMmouseActionsString %>>
				<%
						}
				%>
							<%=memberName %>
				<%
						if(memberLink != null) {
				%>
							</a>
				<%
						}
				%>
						</td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=numberFormat.format(memberTotalProblems) %></td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=average == -1 ? "N/A" : numberFormat.format(average) + "%" %></td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=max == -1 ? "N/A" : numberFormat.format(max) + "%" %></td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=HealthViewModelHelper.getFormattedRisk(risk) %></td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL">
				<%
							if(memberLink != null) {
				%>
							<a href="<%=memberLink %>" <%=zoomInMmouseActionsString %>><img src="<%=BASE_DIRECTORY %>images/dashboard/graph/tooltipZoom.gif" border="0" onMouseOver="javascript:setImageSource(this, 'graph/tooltipZoomOver.gif')" onMouseOut="javascript:setImageSource(this, 'graph/tooltipZoom.gif')"></a>
				<%
							}
				%>
						</td>
				<%
						}
				%>
					</tr>
				<%
				}
				%>
				<tr>
					<td class="empty">&nbsp;</td>
				</tr>
			</table>
		</td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_RIGHT_FILLER_CELL_BG_<%=bgSuffix %>"></td>
	</tr>
	<tr height="6px">
		<td class="DASHBOARD_GRAPH_TOOLTIP_FOOTER_LEFT_CELL_BG_<%=bgSuffix %>"></td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_BOTTOM_FILLER_CELL_BG_<%=bgSuffix %>">&nbsp;</td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_FOOTER_RIGHT_CELL_BG_<%=bgSuffix %>"></td>
	</tr>
</table>
<%
if(isEmbeded) {
	out.print("]]>");
}
%>