<%@ page language="java"%>

<%@ page import="java.text.NumberFormat"%>

<%@ page import="xpolog.eye.reports.health.ui.HealthViewHelper"%>

<%@ page import="xpolog.eye.computation.ComputationResults"%>
<%@ page import="xpolog.eye.computation.MultiComputationResults"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewGraphTooltipQuery"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModelHelper"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewNode"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
String HEALTH_VIEW_MODEL = "HealthViewModel";

HealthViewModel model = (HealthViewModel)session.getAttribute(HEALTH_VIEW_MODEL);

String isEmbededStr = request.getParameter("isEmbeded");
boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");

MultiComputationResults tooltipResults = (MultiComputationResults)request.getAttribute("tooltipResults");
int numOfResults = tooltipResults.getMembersCount();
String name = tooltipResults.getName();
if(tooltipResults.getId().equals(HealthViewContext.ROOT_NODE_ID)) {
	name = HealthViewModelHelper.getCurrentRootNodeName(model.getViewBy());
}
String tooltipHeaderDateString = (String)request.getAttribute("tooltipHeaderDateString");
String startDateString = (String)request.getAttribute("startDateString");
startDateString += ":00";
String endDateString = (String)request.getAttribute("endDateString");
endDateString += ":00";
String bgSuffix = (String)request.getAttribute("bgSuffix");

boolean rootIsLog = tooltipResults.getType().equals(XpoLogObjectTypes.LOG_TYPE);
Long rootTotalEventsLong = (Long)request.getAttribute("rootTotalEvents");
long rootTotalEvents = -1;
if(rootTotalEventsLong != null) {
	rootTotalEvents = rootTotalEventsLong.longValue();
	if(rootTotalEvents == -1) {
		rootTotalEvents = 0;
	}
}
ComputationResults memberResults = null;

NumberFormat numberFormat = NumberFormat.getNumberInstance();
numberFormat.setMaximumFractionDigits(2);

if(isEmbeded) {
	out.print("<![CDATA[");
}
%>

<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%" id="dashboardGraphTooltipTable">
	<tr height="6px">
		<td class="DASHBOARD_GRAPH_TOOLTIP_HEADER_LEFT_CELL_BG_<%=bgSuffix %>"></td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_TOP_FILLER_CELL_BG_<%=bgSuffix %>"></td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_HEADER_RIGHT_CELL_BG_<%=bgSuffix %>"></td>
	</tr>
	<tr height="10px">
		<td class="DASHBOARD_GRAPH_TOOLTIP_LEFT_FILLER_CELL_BG_<%=bgSuffix %>"></td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_FILLER_CELL_BG_<%=bgSuffix %> DASHBOARD_GRAPH_TOOLTIP_HEADER_CELL">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr>
					<td class="DASHBOARD_GRAPH_TOOLTIP_HEADER"><%=name %> Problems</td>
				</tr>
				<tr>
					<td class="DASHBOARD_GRAPH_TOOLTIP_HEADER"><%=tooltipHeaderDateString.toString() %></td>
				</tr>
			</table>
		</td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_RIGHT_FILLER_CELL_BG_<%=bgSuffix %>"></td>
	</tr>
	<tr height="*">
		<td class="DASHBOARD_GRAPH_TOOLTIP_LEFT_FILLER_CELL_BG_<%=bgSuffix %>"></td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_CENTER_CELL_BG_<%=bgSuffix %> DASHBOARD_GRAPH_TOOLTIP_BODY_CELL">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<%
				if(rootIsLog) {
					if(numOfResults > 0) {
				%>
					<tr height="10px">
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Name</td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Severity</td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Type</td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Problems</td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL"></td>
					</tr>
				<%
					}else {
				%>
					<tr height="10px">
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Name</td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Events</td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Problems</td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL"></td>
					</tr>
				<%
					}
				}else {
				%>
					<tr height="10px">
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Name</td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Events</td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Problems</td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">P</td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">A</td>
						<%if(false) { %>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">S</td>
						<%} %>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Status</td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL"></td>
					</tr>
				<%
				}
				HealthViewNode logNode = model.getLogNode();
				String memberId, memberIdForJavaScript = null, memberName, memberType;
				String memberLink = null, zoomInMmouseActionsString = null, zoomInMmouseActionsStringMessage = null;
				long memberTotal, memberTotalProblems, memberTotalFiltered, memberTotalKnowledge, memberTotalAnomaly;
				double risk;
				String rowClassName = null;
				
				if(numOfResults > 0) {
					for(int i = 0; i < numOfResults; i++) {
						memberResults = tooltipResults.getMembersResults()[i];
						
						memberId = memberResults.getId();
						memberIdForJavaScript = memberId;
						memberIdForJavaScript = XpologUtil.updateAsHtmlString(memberIdForJavaScript);
						memberIdForJavaScript = XpologUtil.replaceAll(memberIdForJavaScript, "'", "\\'");
						memberName = memberResults.getName();
						memberName = XpologUtil.updateAsHtmlString(memberName);
						memberName = HealthViewHelper.adjustTooltipName(memberName);
						memberType = memberResults.getType();
						
						String rowId = "tooltipRow_" + i;
						if(memberType.equals(XpoLogObjectTypes.FILTER_TYPE) ||
							 memberType.equals(XpoLogObjectTypes.KNOWLEDGE_TYPE)) {
							boolean isKnowledge = memberType.equals(XpoLogObjectTypes.KNOWLEDGE_TYPE);
							memberLink = "javascript:hideDashboardGraphTooltip();openLogFromDashboard0('" + BASE_DIRECTORY + "','" + logNode.getId() + "', '" + memberIdForJavaScript + "', '" + isKnowledge + "', '" + startDateString + "', '" + endDateString + "', 'true',document.getElementById('" + rowId + "'),true,'HealthViewModel')";
							zoomInMmouseActionsStringMessage = "dashboardTooltips['showLog']";
						}else if(memberType.equals(XpoLogObjectTypes.ANOMALY_TYPE)) {
							memberLink = null;
							zoomInMmouseActionsStringMessage = null;
						}else {
							memberLink = "javascript:zoomIntoElement('" + memberResults.getId() + "', '" + memberResults.getName() + "', '" + memberResults.getType() + "', " + memberResults.getStartTime() + ", " + memberResults.getEndTime() + ", " + model.getModelUpdateTime() + ");hideDashboardGraphTooltip()";
							zoomInMmouseActionsStringMessage = "dashboardTooltips['zoomIntoMainTableNode']";
						}
						if(zoomInMmouseActionsStringMessage == null) {
							zoomInMmouseActionsString = "";
						}else {
							zoomInMmouseActionsString = "onMouseOver=\"javascript:showTooltip(" + zoomInMmouseActionsStringMessage + ")\" onMouseOut=\"javascript:hideTooltip()\"";
						}
						
						memberTotal = memberResults.getTotal();
						memberTotalProblems = memberResults.getSumOfProblems();
						memberTotalFiltered = memberResults.getTotalFiltered();
						memberTotalKnowledge = memberResults.getTotalKnowledgeEvents();
						memberTotalAnomaly = memberResults.getTotalAnomalyEvents();
						
						if(i % 2 == 0) {
							rowClassName = "DASHBOARD_GRAPH_TOOLTIP_BODY_COLORED_ROW";
						}else {
							rowClassName = "DASHBOARD_GRAPH_TOOLTIP_BODY_REGULAR_ROW";
						}
				%>
					<tr class="<%=rowClassName %>" height="10px" id="<%=rowId%>">
				<%
						if(rootIsLog) {
							risk = memberResults.getWeight();
							if(risk == -1) {
								risk = 0;
							}
				%>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_NAME_CELL">
				<%
							if(memberLink != null) {
				%>
							<a href="<%=memberLink %>" class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL_LINK" <%=zoomInMmouseActionsString %>>
				<%
							}
				%>
							<%=memberName %>
				<%
							if(memberLink != null) {
				%>
							</a>
				<%
							}
				%>
						</td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=HealthViewModelHelper.getFormattedRisk(risk) %></td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=HealthViewModelHelper.getFormattedProblemType(memberType) %></td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=numberFormat.format(memberTotalProblems) %></td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL">
				<%
							if(memberLink != null) {
				%>
							<a href="<%=memberLink %>" <%=zoomInMmouseActionsString %>><img src="<%=BASE_DIRECTORY %>images/dashboard/graph/tooltipZoom.gif" border="0" onMouseOver="javascript:setImageSource(this, 'graph/tooltipZoomOver.gif')" onMouseOut="javascript:setImageSource(this, 'graph/tooltipZoom.gif')"></a>
				<%
							}
				%>
						</td>
				<%
						}else {
							risk = memberResults.getMaxWeight();
							if(risk == -1) {
								risk = 0;
							}
				%>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_NAME_CELL">
				<%
						if(memberLink != null) {
				%>
							<a href="<%=memberLink %>" class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL_LINK" <%=zoomInMmouseActionsString %>>
				<%
						}
				%>
							<%=memberName %>
				<%
						if(memberLink != null) {
				%>
							</a>
				<%
						}
				%>
						</td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=numberFormat.format(memberTotal) %></td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=numberFormat.format(memberTotalProblems) %></td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=numberFormat.format(memberTotalFiltered) %></td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=numberFormat.format(memberTotalKnowledge) %></td>
						<%if(false) { %>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=numberFormat.format(memberTotalAnomaly) %></td>
						<%} %>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=HealthViewModelHelper.getFormattedRisk(risk) %></td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL">
				<%
							if(memberLink != null) {
				%>
							<a href="<%=memberLink %>" <%=zoomInMmouseActionsString %>><img src="<%=BASE_DIRECTORY %>images/dashboard/graph/tooltipZoom.gif" border="0" onMouseOver="javascript:setImageSource(this, 'graph/tooltipZoomOver.gif')" onMouseOut="javascript:setImageSource(this, 'graph/tooltipZoom.gif')"></a>
				<%
							}
				%>
						</td>
				<%
						}
				%>
					</tr>
				<%
					}
				}else {
					if(rootIsLog) {
						rowClassName = "DASHBOARD_GRAPH_TOOLTIP_BODY_COLORED_ROW";
						memberLink = "javascript:hideDashboardGraphTooltip();openLogFromDashboard0('" + BASE_DIRECTORY + "','" + logNode.getId() + "', '', '', '" + startDateString + "', '" + endDateString + "', 'true',document.getElementById('rootIsLog'),true,'HealthViewModel')";
						zoomInMmouseActionsStringMessage = "dashboardTooltips['showLog']";
						zoomInMmouseActionsString = "onMouseOver=\"javascript:showTooltip(" + zoomInMmouseActionsStringMessage + ")\" onMouseOut=\"javascript:hideTooltip()\"";
						memberName = name;
						memberName = XpologUtil.updateAsHtmlString(memberName);
						memberName = HealthViewHelper.adjustTooltipName(memberName);
						
				%>
					<tr class="<%=rowClassName %>" height="10px" id="rootIsLog">
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_NAME_CELL">
				<%
							if(memberLink != null) {
				%>
							<a href="<%=memberLink %>" class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL_LINK" <%=zoomInMmouseActionsString %>>
				<%
							}
				%>
							<%=memberName %>
				<%
							if(memberLink != null) {
				%>
							</a>
				<%
							}
				%>
						</td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=numberFormat.format(rootTotalEvents) %></td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL">0</td>
						<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL">
				<%
							if(memberLink != null) {
				%>
							<a href="<%=memberLink %>" <%=zoomInMmouseActionsString %>><img src="<%=BASE_DIRECTORY %>images/dashboard/graph/tooltipZoom.gif" border="0" onMouseOver="javascript:setImageSource(this, 'graph/tooltipZoomOver.gif')" onMouseOut="javascript:setImageSource(this, 'graph/tooltipZoom.gif')"></a>
				<%
							}
				%>
						</td>
					</tr>
				<%
					}
				}
				%>
				<tr>
					<td class="empty">&nbsp;</td>
				</tr>
			</table>
		</td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_RIGHT_FILLER_CELL_BG_<%=bgSuffix %>"></td>
	</tr>
	<tr height="6px">
		<td class="DASHBOARD_GRAPH_TOOLTIP_FOOTER_LEFT_CELL_BG_<%=bgSuffix %>"></td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_BOTTOM_FILLER_CELL_BG_<%=bgSuffix %>">&nbsp;</td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_FOOTER_RIGHT_CELL_BG_<%=bgSuffix %>"></td>
	</tr>
</table>
<%
if(isEmbeded) {
	out.print("]]>");
}
%>