<%@ page language="java"%>

<%@ page import="java.text.NumberFormat"%>

<%@ page import="xpolog.eye.computation.impl.MultiHostComputationResults"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewGraphTooltipQuery"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModelHelper"%>
<%@ page import="xpolog.eye.util.hosts.measurements.computation.HostMeasurementTotals"%>
<%@ page import="xpolog.eye.util.hosts.measurements.impl.HostCpu"%>
<%@ page import="xpolog.eye.util.hosts.measurements.impl.HostDiskSpace"%>
<%@ page import="xpolog.eye.util.hosts.measurements.impl.HostMemory"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
String HEALTH_VIEW_MODEL = "HealthViewModel";

HealthViewModel model = (HealthViewModel)session.getAttribute(HEALTH_VIEW_MODEL);

String isEmbededStr = request.getParameter("isEmbeded");
boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");

MultiHostComputationResults tooltipResults = (MultiHostComputationResults)request.getAttribute("tooltipResults");
String name = tooltipResults.getName();
if(tooltipResults.getId().equals(HealthViewContext.ROOT_NODE_ID)) {
	name = HealthViewModelHelper.getCurrentRootNodeName(model.getViewBy());
}
String tooltipHeaderDateString = (String)request.getAttribute("tooltipHeaderDateString");
String startDateString = (String)request.getAttribute("startDateString");
startDateString += ":00";
String endDateString = (String)request.getAttribute("endDateString");
endDateString += ":00";
String bgSuffix = (String)request.getAttribute("bgSuffix");

NumberFormat numberFormat = NumberFormat.getNumberInstance();
numberFormat.setMaximumFractionDigits(2);

MultiHostComputationResults [] hostsResults =  new MultiHostComputationResults[0];
if (tooltipResults != null){
	if (tooltipResults.getType().equals(XpoLogObjectTypes.HOST_TYPE) || tooltipResults.getMembersCount() <= 1){
		hostsResults =  new MultiHostComputationResults[]{tooltipResults};
	}else {
		ComputationResults [] members = tooltipResults.getMembersResults();
		if (members != null){
			ArrayList list = new ArrayList();
			for(int i = 0; i < members.length;i++){
				if (members[i] instanceof MultiHostComputationResults){
					list.add(members[i]);
				}
			}
			hostsResults = (MultiHostComputationResults [])list.toArray(new MultiHostComputationResults[list.size()]);
		}
	}
}

if(isEmbeded) {
	out.print("<![CDATA[");
}
%>

<%@page import="xpolog.eye.XpoLogObjectTypes"%>
<%@page import="xpolog.eye.computation.ComputationResults"%>
<%@page import="java.util.ArrayList"%>
<%@page import="xpolog.eye.reports.ExecutionInfo"%>
<%@page import="xpolog.eye.util.hosts.HostsManager"%>
<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%" id="dashboardGraphTooltipTable">
	<tr height="6px">
		<td class="DASHBOARD_GRAPH_TOOLTIP_HEADER_LEFT_CELL_BG_<%=bgSuffix %>"></td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_TOP_FILLER_CELL_BG_<%=bgSuffix %>"></td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_HEADER_RIGHT_CELL_BG_<%=bgSuffix %>"></td>
	</tr>
	<tr height="10px">
		<td class="DASHBOARD_GRAPH_TOOLTIP_LEFT_FILLER_CELL_BG_<%=bgSuffix %>"></td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_FILLER_CELL_BG_<%=bgSuffix %> DASHBOARD_GRAPH_TOOLTIP_HEADER_CELL">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr>
					<td class="DASHBOARD_GRAPH_TOOLTIP_HEADER"><%=name %> Metrics</td>
				</tr>
				<tr>
					<td class="DASHBOARD_GRAPH_TOOLTIP_HEADER"><%=tooltipHeaderDateString.toString() %></td>
				</tr>
			</table>
		</td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_RIGHT_FILLER_CELL_BG_<%=bgSuffix %>"></td>
	</tr>
	<tr height="*">
		<td class="DASHBOARD_GRAPH_TOOLTIP_LEFT_FILLER_CELL_BG_<%=bgSuffix %>"></td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_CENTER_CELL_BG_<%=bgSuffix %> DASHBOARD_GRAPH_TOOLTIP_BODY_CELL">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr height="10px">						
				  <td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL" width="10">&nbsp;</td>							  
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Metrics Type</td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Problems</td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Severity</td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Average</td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL">Max</td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_HEADER_CELL"></td>
				</tr>
				<%
				HostsManager hostsMgr = HostsManager.getInstance();
				for (int k = 0; k < hostsResults.length;k++){
					tooltipResults = hostsResults[k];					
					MultiHostComputationResults tooltipHostResults = tooltipResults;
					if (tooltipHostResults.getType() != null && !tooltipHostResults.getType().equals(XpoLogObjectTypes.HOST_TYPE) && tooltipHostResults.getMembersCount() > 0 && tooltipHostResults.getMembersResults()[0] instanceof MultiHostComputationResults){
						tooltipHostResults = (MultiHostComputationResults)tooltipHostResults.getMembersResults()[0];
					}
				HostMeasurementTotals cpuMeasurementTotal = null, memoryMeasurementTotal = null, diskSpaceMeasurementTotal = null;
				HostMeasurementTotals [] diskSpaceMeasurementTotalArr = null;
				HostMeasurementTotals [] cpuMeasurementTotalArr = null;
				long cpuProblems = -1, memoryProblems = -1, diskSpaceProblems = -1;
				double cpuAvg = -1, cpuMax = -1, memoryAvg = -1, memoryMax = -1, diskSpaceAvg = -1, diskSpaceMax = -1;
				double cpuRisk = -1, memoryRisk = -1, diskSpaceRisk = -1;
				String cpuError = null, memoryError = null, diskSpaceError = null;
				String cpuErrorDesc = null, memoryErrorDesc = null, diskSpaceErrorDesc = null;
				String rowClassName = null;
				boolean ignoreHost = true;
				
				ExecutionInfo execInfo = tooltipResults.getExecutionInfo();
				String errorMessage = null;
				String errorMessageDesc = null;
				if (execInfo != null){
					errorMessage = execInfo.getErrorMessage(tooltipResults.getStartTime(),tooltipResults.getEndTime());											
					if (errorMessage != null && errorMessage.length() > 0){
						errorMessageDesc = hostsMgr.getErrorDescription(errorMessage);
					}
					
					if (errorMessage != null && errorMessage.length() > 0){
						errorMessage = hostsMgr.getErrorDisplayName(errorMessage);
					}
					if (errorMessage == errorMessageDesc){
						errorMessageDesc = null;
					}
					
					if (errorMessage != null && errorMessage.length() == 0){
						errorMessage = null;
					}
				}

				cpuMeasurementTotal = tooltipResults.getHostMeasurementTotals(HostCpu.HOST_CPU_TYPE);
				cpuMeasurementTotalArr = null;
				if(cpuMeasurementTotal != null) {
					cpuProblems = tooltipResults.getProblemsByGroupType(HostCpu.HOST_CPU_TYPE);
					cpuAvg = cpuMeasurementTotal.getValue();
					cpuMax = cpuMeasurementTotal.getMaxValue();
					cpuMeasurementTotalArr = tooltipResults.getHostMeasurementTotalsList(HostCpu.HOST_CPU_TYPE);
					ignoreHost = false;
				}else {
					cpuAvg = -1;
					cpuMax = -1;
					if (errorMessage != null){
						cpuError = errorMessage;
						cpuErrorDesc = errorMessageDesc;
						ignoreHost = false;
					}
				}
				cpuRisk = tooltipResults.getWeightByGroupType(HostCpu.HOST_CPU_TYPE);
				if(cpuRisk == -1) {
					cpuRisk = 0;
				}
				
				memoryMeasurementTotal = tooltipResults.getHostMeasurementTotals(HostMemory.HOST_MEMORY_TYPE);
				if(memoryMeasurementTotal != null) {
					memoryProblems = tooltipResults.getProblemsByGroupType(HostMemory.HOST_MEMORY_TYPE);
					memoryAvg = memoryMeasurementTotal.getValue();
					memoryMax = memoryMeasurementTotal.getMaxValue();
					ignoreHost = false;
				}else {
					memoryAvg = -1;
					memoryMax = -1;
					if (errorMessage != null){
						memoryError = errorMessage;
						memoryErrorDesc = errorMessageDesc;
						ignoreHost = false;
					}
				}
				memoryRisk = tooltipResults.getWeightByGroupType(HostMemory.HOST_MEMORY_TYPE);
				if(memoryRisk == -1) {
					memoryRisk = 0;
				}
				
				diskSpaceMeasurementTotal = tooltipResults.getHostMeasurementTotals(HostDiskSpace.HOST_DISK_SPACE_TYPE);
				diskSpaceMeasurementTotalArr = null;
				if(diskSpaceMeasurementTotal != null) {
					diskSpaceProblems = tooltipResults.getProblemsByGroupType(HostDiskSpace.HOST_DISK_SPACE_TYPE);
					diskSpaceAvg = diskSpaceMeasurementTotal.getValue();
					diskSpaceMax = diskSpaceMeasurementTotal.getMaxValue();
					diskSpaceMeasurementTotalArr = tooltipResults.getHostMeasurementTotalsList(HostDiskSpace.HOST_DISK_SPACE_TYPE);
					ignoreHost = false;
				}else {
					diskSpaceAvg = -1;
					diskSpaceMax = -1;
					if (errorMessage != null){
						diskSpaceError = errorMessage;
						diskSpaceErrorDesc = errorMessageDesc;
						ignoreHost = false;
					}
				}
				diskSpaceRisk = tooltipResults.getWeightByGroupType(HostDiskSpace.HOST_DISK_SPACE_TYPE);
				if(diskSpaceRisk == -1) {
					diskSpaceRisk = 0;
				}
				if (ignoreHost){
					continue;
				}
				String suffix = "Cpu_" + k;
			 if (hostsResults.length > 0){ %>
				<tr>
				  <td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_IMG_CELL">&nbsp;</td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_HOST_CELL" colspan="5">Server: <%=tooltipHostResults.getName()%></td>
				</tr>
				<%}
				if(cpuMeasurementTotal != null || cpuError != null) {
					// CPU
					rowClassName = "DASHBOARD_MAIN_TABLE_COLORED_ROW";
				%>
				<tr class="<%=rowClassName %>" height="10px">							 
				  <td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_IMG_CELL">
				  <%if(cpuErrorDesc != null || (cpuMeasurementTotalArr != null && cpuMeasurementTotalArr.length > 1)) { %>
				    <img id="openRowsImg<%=suffix%>" style="cursor:pointer;cursor:hand;" onClick="javascript:showMetricsRows('<%=BASE_DIRECTORY%>','<%=suffix%>')"
				    src="<%=BASE_DIRECTORY%>images/dashboard/tooltip/close.gif" >
					<% }else { %>
					&nbsp;
					<%} %>
				  </td>
				 <% if(cpuError != null) { %>
				 <td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_NAME_CELL" colspan="5">CPU Error - <%=cpuError%></td>
				 <%}else { %>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_NAME_CELL">CPU</td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=cpuProblems == -1 ? "N/A" : cpuProblems + "" %></td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=cpuRisk == -1 ? "N/A" : HealthViewModelHelper.getFormattedRisk(cpuRisk) %></td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=cpuAvg == -1 ? "N/A" : numberFormat.format(cpuAvg) + "%" %></td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=cpuMax == -1 ? "N/A" : numberFormat.format(cpuMax) + "%" %></td>
				</tr>
				<%
				 }
				}
				
				if(cpuErrorDesc != null) {
					// CPU List
					rowClassName = "DASHBOARD_MAIN_TABLE_COLORED_ROW";
				%>
				<tr class="<%=rowClassName %>" height="10px" id="row<%=suffix + "_0"%>" style="display:none">							
				  <td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_IMG_CELL">&nbsp;</td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_ERROR_DETAILS_CELL" colspan="5"><%=cpuErrorDesc%></td>
				</tr>
				<%
				}else if(cpuMeasurementTotalArr != null && cpuMeasurementTotalArr.length > 1) {
					// CPU List
					rowClassName = "DASHBOARD_MAIN_TABLE_COLORED_ROW";
					for (int i = 0; i < cpuMeasurementTotalArr.length;i++){
						double avg = cpuMeasurementTotalArr[i].getValue();
						double max = cpuMeasurementTotalArr[i].getMaxValue();
						String measurementName = cpuMeasurementTotalArr[i].getKey();
						if (measurementName.startsWith(HostCpu.HOST_CPU_TYPE + ":")){
							measurementName = measurementName.substring(HostCpu.HOST_CPU_TYPE.length() + 1);
						}
						
						if (measurementName.endsWith("_totals")){
							measurementName = measurementName.substring(0,measurementName.length() - 7);
						}
				%>
				<tr class="<%=rowClassName %>" height="10px" id="row<%=suffix + "_" +  i%>" style="display:none">							
				  <td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_IMG_CELL">&nbsp;</td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_NAME_CELL" colspan="3">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<%=measurementName%></td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=avg == -1 ? "N/A" : numberFormat.format(avg) + "%" %></td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=max == -1 ? "N/A" : numberFormat.format(max) + "%" %></td>
				</tr>
				<%
				}}
				suffix = "Memory_" + k;
				if(memoryMeasurementTotal != null  || memoryError != null) {
					// Memory
					rowClassName = "DASHBOARD_MAIN_TABLE_REGULAR_ROW";
				%>
				<tr class="<%=rowClassName %>" height="10px">													  
				  <td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_IMG_CELL">
				  <%if(memoryErrorDesc != null) { %>
				    <img id="openRowsImg<%=suffix%>" style="cursor:pointer;cursor:hand;" onClick="javascript:showMetricsRows('<%=BASE_DIRECTORY%>','<%=suffix%>')"
				    src="<%=BASE_DIRECTORY%>images/dashboard/tooltip/close.gif" >
					<% }else { %>
					&nbsp;
					<%} %>
				  </td>							 
				  							 
				 <% if(memoryError != null) { %>
				 <td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_NAME_CELL" colspan="5">Memory Error - <%=memoryError%></td>
				 <%}else { %>							  							 
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_NAME_CELL">Memory</td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=memoryProblems == -1 ? "N/A" : memoryProblems + "" %></td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=memoryRisk == -1 ? "N/A" : HealthViewModelHelper.getFormattedRisk(memoryRisk) %></td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=memoryAvg == -1 ? "N/A" : numberFormat.format(memoryAvg) + "%" %></td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=memoryMax == -1 ? "N/A" : numberFormat.format(memoryMax) + "%" %></td>
				</tr>							
				<%
				 }
				if(memoryErrorDesc != null) {
					rowClassName = "DASHBOARD_MAIN_TABLE_COLORED_ROW";
				%>
				<tr class="<%=rowClassName %>" height="10px" id="row<%=suffix + "_0"%>" style="display:none">							
				  <td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_IMG_CELL">&nbsp;</td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_ERROR_DETAILS_CELL" colspan="5"><%=memoryErrorDesc%></td>
				</tr>
				<%							
				 }
				}
				suffix = "DiskSpace_" + k;
				if(diskSpaceMeasurementTotal != null || diskSpaceError != null) {
					// Disk Space
					
					rowClassName = "DASHBOARD_MAIN_TABLE_COLORED_ROW";
				%>
				<tr class="<%=rowClassName %>" height="10px">							
				  <td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_IMG_CELL">
				  <%if(cpuErrorDesc != null || (diskSpaceMeasurementTotalArr != null && diskSpaceMeasurementTotalArr.length > 1)) { %>
				    <img id="openRowsImg<%=suffix%>" style="cursor:pointer;cursor:hand;" onClick="javascript:showMetricsRows('<%=BASE_DIRECTORY%>','<%=suffix%>')"
				    src="<%=BASE_DIRECTORY%>images/dashboard/tooltip/close.gif" >
					<% }else { %>
					&nbsp;
					<%} %>
				  </td>
				  <% if(diskSpaceError != null) { %>
				 <td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_NAME_CELL" colspan="5">Disk Space Error - <%=diskSpaceError%></td>
				 <%}else { %>							 
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_NAME_CELL">Disk Space</td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=diskSpaceProblems == -1 ? "N/A" : diskSpaceProblems + "" %></td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=diskSpaceRisk == -1 ? "N/A" : HealthViewModelHelper.getFormattedRisk(diskSpaceRisk) %></td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=diskSpaceAvg == -1 ? "N/A" : numberFormat.format(diskSpaceAvg) + "%" %></td>
					<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=diskSpaceMax == -1 ? "N/A" : numberFormat.format(diskSpaceMax) + "%" %></td>
				</tr>
				<%
				 }
				}
				%>
			<%
			if(diskSpaceErrorDesc != null) {
				// CPU List
				rowClassName = "DASHBOARD_MAIN_TABLE_COLORED_ROW";
			%>
			<tr class="<%=rowClassName %>" height="10px" id="row<%=suffix + "_0"%>" style="display:none">							
			  <td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_IMG_CELL">&nbsp;</td>
				<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_ERROR_DETAILS_CELL" colspan="5"><%=diskSpaceErrorDesc%></td>
			</tr>
			<%
			}
			if(diskSpaceMeasurementTotalArr != null && diskSpaceMeasurementTotalArr.length > 1) {
				// Disk Space
				rowClassName = "DASHBOARD_MAIN_TABLE_COLORED_ROW";
				for (int i = 0; i < diskSpaceMeasurementTotalArr.length;i++){
					double avg = diskSpaceMeasurementTotalArr[i].getValue();
					double max = diskSpaceMeasurementTotalArr[i].getMaxValue();
					String measurementName = diskSpaceMeasurementTotalArr[i].getKey();
					if (measurementName.startsWith(HostDiskSpace.HOST_DISK_SPACE_TYPE + ":")){
						measurementName = measurementName.substring(HostDiskSpace.HOST_DISK_SPACE_TYPE.length() + 1);
					}
					
					if (measurementName.endsWith("_totals")){
						measurementName = measurementName.substring(0,measurementName.length() - 7);
					}
			%>
			<tr class="<%=rowClassName %>" height="10px" id="row<%=suffix + "_" +  i%>" style="display:none">						
			  <td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_IMG_CELL">&nbsp;</td>
				<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_NAME_CELL" colspan="3">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<%=measurementName%></td>							
				<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=avg == -1 ? "N/A" : numberFormat.format(avg) + "%" %></td>
				<td class="DASHBOARD_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=max == -1 ? "N/A" : numberFormat.format(max) + "%" %></td>
			</tr>
			<tr>
					<td class="empty" colspan="6">&nbsp;</td>
				</tr>
				
				<% if (k < (hostsResults.length - 1)){ %>
				<tr>
					<td class="empty" colspan="6">&nbsp;</td>
				</tr>
				<%} %>
			<%
			}}}
			%>
				
				
			</table>
		</td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_RIGHT_FILLER_CELL_BG_<%=bgSuffix %>"></td>
	</tr>
	<tr height="6px">
		<td class="DASHBOARD_GRAPH_TOOLTIP_FOOTER_LEFT_CELL_BG_<%=bgSuffix %>"></td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_BOTTOM_FILLER_CELL_BG_<%=bgSuffix %>">&nbsp;</td>
		<td class="DASHBOARD_GRAPH_TOOLTIP_FOOTER_RIGHT_CELL_BG_<%=bgSuffix %>"></td>
	</tr>
</table>
<%
if(isEmbeded) {
	out.print("]]>");
}
%>