function xplgDoOnClick(id, type, casState) {
	this.menuLastClicked = id;
	// href
	var href = this.itemPull[this.idPrefix+id]["href_link"];
	var target = this.itemPull[this.idPrefix+id]["href_target"];
	if (href != null) {
		var mainFrm = getMainFrame();
		if (mainFrm){
			if(typeof mainFrm.allowResize == "boolean"){
				mainFrm.allowResize = false;
			}
		}
		var managementTD = document.getElementById("managementTD");
		if(managementTD) {
			if(href.indexOf("fullPage") != -1) {
				if(managementTD.style.display == "" || managementTD.style.display == "block") {
					managementTD.style.display = "none";
				}
			}else {
				if(managementTD.style.display == "none") {
					managementTD.style.display = "";
				}
			}
		}
		
		var form = document.createElement("FORM");
		
		var index = href.indexOf("?");
		var action = href;
		var queryString = null;
		if(index > -1) {
			action = href.substring(0, index);
			queryString = href.substring(index + 1, href.length);
		}
		form.action = action;
		if (queryString != null) {
			var remainder = null;
			var p = null;
			index = queryString.indexOf("%3F");
			if(index == -1) {
				p = String(queryString).split("&");
			}else {
				var subQueryString = queryString.substring(0, index);
				remainder = queryString.substring(index, queryString.length);
				remainder = remainder.replace("%3F", "?");
				remainder = remainder.replace("%26", "&");
				remainder = remainder.replace("%2526", "%26");
				p = String(subQueryString).split("&");
			}
			for (var q=0; q<p.length; q++) {
				var j = String(p[q]).split("=");
				var m = document.createElement("INPUT");
				m.type = "hidden";
				m.name = (j[0]||"");
				if(q == p.length - 1 && j[1] != null && remainder != null) {
					m.value = (j[1] + remainder);
				}else {
					m.value = (j[1]||"");
				}
				form.appendChild(m);
			}
		}
		if (target != null) { form.target = target; }
		form.style.display = "none";
		document.body.appendChild(form);
		form.submit();
		if (form != null) {
			document.body.removeChild(form);
			form = null;
		}
		return;
	}
	//
	// some fixes
	if (type.charAt(0)=="c") return; // can't click on complex item
	if (type.charAt(1)=="d") return; // can't click on disabled item
	if (type.charAt(2)=="s") return; // can't click on separator
	//		
	if (this.checkEvent("onClick")) {
		// this.callEvent("onClick", [id, type, this.contextMenuZoneId]);
		this._clearAndHide();
		if (this._isContextMenuVisible() && this.contextAutoHide) this._hideContextMenu();
		this.callEvent("onClick", [id, this.contextMenuZoneId, casState]);
	} else {
		if ((type.charAt(1) == "d") || (this.menuMode == "win" && type.charAt(2) == "t")) return;
				this._clearAndHide();
				if (this._isContextMenuVisible() && this.contextAutoHide) this._hideContextMenu();
			}
}

function updateDashboardsMenu() {
	sendAjaxRequest("portal/widgets/common/getPortalViews.jsp", function(req){
		var xmldoc = req.responseXML.documentElement;
		if(xmldoc) {
	    	var portalViewElements = xmldoc.getElementsByTagName("PortalView");
				if(portalViewElements) {
					menuObject.removeItem("dashboards");
					
					menuObject.addNewSibling(null, "dashboards", "Dashboards", false);
					var position = 0;
					for(var i = 0; i < portalViewElements.length; i++) {
						var id = portalViewElements[i].getAttribute("id");
						var name = portalViewElements[i].getAttribute("name");
						menuObject.addNewChild("dashboards", position++, "subdashboards" + id, name);
						menuObject.setHref("subdashboards" + id, "portal/widgets/view/widgetsPortalView.jsp?fullPage=true&selectedView=" + id, "main");
					}
					
					if(portalViewElements.length > 0) {
						menuObject.addNewSeparator("subdashboards" + portalViewElements[portalViewElements.length - 1].getAttribute("id"));
						position++;
					}
					
					menuObject.addNewChild("dashboards", position++, "subdashboardsAdd", "Add New Dashboard");
		        	menuObject.setHref("subdashboardsAdd", "portal/widgets/view/widgetsPortalView.jsp?fullPage=true&addNewDashboard=true", "main");
		        	
		        	menuObject.addNewChild("dashboards", position++, "subdashboardsManage", "Manage Dashboards");
		        	menuObject.setHref("subdashboardsManage", "portal/widgets/admin/portalViews.jsp?fullPage=true", "main");
				}
	    }
  });
}