<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.util.List"%>
<%@ page import="java.io.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.agg.result.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.audit.*"%>
<%@ page import="xpolog.eye.data.filters.*"%> 
<%@ page import="xpolog.eye.site.problem.*"%>
<%@ page import="xpolog.eye.site.problem.results.*"%>
<%@ page import="xpolog.eye.meta.MetaDataManager"%>
<%@ page import="xpolog.eye.meta.MetaData"%>


<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
	String CURRENT_LOG = "CURRENT_LOG";
	String ERROR_OBJ = "ERROR_OBJ";
	ErrorModel errmodel = new ErrorModel();
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	ProblemViewModel model = (ProblemViewModel)request.getSession().getAttribute(ProblemViewModel.PROBLEM_MODEL_TYPE);

	ProblemViewQuery query = model.getQuery();
	
	String logid = request.getParameter("logid");
	if (logid == null || logid.length() == 0){
		errmodel.addError("No log id supplied");
	}

	SiteManagment mgt = SiteManagment.getInstance();
	LogBrowsingManager lbm = null;
	try{
		lbm = mgt.getLogBrowserManager(logid);
	}catch(Exception e){
		errmodel.addError("Failed to get Log browsing manager for " + logid);
	}
	if (errmodel.getErrorCount() > 0){
		request.getSession().setAttribute(ERROR_OBJ, errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
	}

	if (query != null){
  	FilterCollection col = ProblemViewHelper.getFilterForLog(query,lbm);
  	if (col != null){
 	 	 lbm.getFilterManager().addFilterCollection(col);
 	  }
  }

	request.getSession().setAttribute(CURRENT_LOG, lbm);
	
	response.sendRedirect(BASE_DIRECTORY + "loggers/logview.jsp?logid="+logid+"&gotoMain=true&opdirect=START&calls=-1&timetamp=" + System.currentTimeMillis());
	
	%>