<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.audit.*"%>
<%@ page import="xpolog.eye.data.filters.*"%> 
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.ModuleMember"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.problem.*"%>
<%@ page import="xpolog.eye.site.problem.results.ProblemLogsResult"%>
<%@ page import="xpolog.eye.util.Constants"%>

<%@ page import="java.io.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.util.*"%>

<%!static final String BASE_DIRECTORY = "../";

	DecimalFormat decFormat = new DecimalFormat("##.##");

	String dateFormatStr = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat", "MM/dd/yyyy HH:mm:ss");

	SimpleDateFormat dateFormat = new SimpleDateFormat(dateFormatStr);

	String millisecondsSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator", ".");

	String dateFormatMS = dateFormatStr + millisecondsSeperator + "SSS";

	public String transformDateToString(Date d, long timeDiff) {
		if (d == null) {
			return null;
		}
		if (timeDiff != 0) {
			long time = d.getTime();
			d = ((Date) d.clone());
			d.setTime(time + timeDiff);
		}
		String format = "";
		if (d.getTime() % 1000 == 0) {
			format = dateFormatStr;
		} else {
			format = dateFormatMS;
		}
		String str = new SimpleDateFormat(format).format(d);
		return str;
	}%>
<%
	String ERROR_OBJ = "ERROR_OBJ";
	ErrorModel errmodel = new ErrorModel();
	UserContext userContext = UserEnvironment.getUserContext(request);
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  env.setUsePage("diagnostics/diagnosticsResult.jsp");

  WebSecurityManager securityManager = WebSecurityManager.getInstance();
	if (!securityManager.checkForPermission(request,response,null,true)){
	  return;
  }
  UserSecurity user = securityManager.getUserSecurity(request);
  List comps = SiteManagment.getInstance().getApplicationComponentsManager().getVisibleApplicationComponents(user);
  boolean dashboardEnabled = false;
  for(int i=0;i<comps.size();i++) {
	  ApplicationComponent comp = (ApplicationComponent)comps.get(i);
	  if(comp != null && comp.getName().equals(XpologManagment.ANALYTICS_COMPONENT) && comp.isVisible()) {
			dashboardEnabled = true;
  	  }
  }
  
	
	ProblemViewModel model = (ProblemViewModel)request.getSession().getAttribute(ProblemViewModel.PROBLEM_MODEL_TYPE);
	if (model == null){
		model = new ProblemViewModel();
	}

	if (model == null || model.getQuery() == null) {
		response.sendRedirect("diagnostics.jsp");
		return;
	}

	//audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
			userContext, AuditConstants.VIEW, "view system health",
			AuditConstants.REPORTS, "view system health");

	String timeStr = "";
	
	if (model.getQuery().getStartTime() > 0){
		if(model.getQuery().getEndTime() > 0) {
			timeStr += dateFormat.format(new Date(model.getQuery().getStartTime()));
		}else {
			timeStr += "From " + dateFormat.format(new Date(model.getQuery().getStartTime()));
		}
	}
	
	if (model.getQuery().getEndTime() > 0){
		if (model.getQuery().getStartTime() > 0) {
			timeStr += " - ";
		}else {
			timeStr += "Run Until ";
		}
		timeStr += dateFormat.format(new Date(model.getQuery().getEndTime()));
	}else if (model.getQuery().getStartTime() <= 0 ){
		timeStr += "Run without time limits";
	}
	
	ProblemLogsResult	logsResult = model == null ? null : (ProblemLogsResult)model.getResult(ProblemViewModel.LOGS_TYPE);
	ModuleMember[] members = logsResult == null ? null : logsResult.getMembers();
	
	String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);
	
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/calendar/calendar2.js"></script>
<!-- Date only with year scrolling -->
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/comps/jsdomenu.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/comps/slider.js" type="text/javascript" ></script>
<script src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script>
  
  baseDirectory = "<%=BASE_DIRECTORY%>";
  function selectChildren(id,len){
  	var cb = document.getElementById(id);
  	if (cb){
  		for (var i=0; i<len; i++){
  			var ccb = document.getElementById(id + "_" + i);
  			if (ccb){
  				ccb.checked = cb.checked;
  			}
  		}
  	}
  }

  function selectAll(){
  	var cb = document.getElementById("all");
  	if (cb){
  		var cbs = document.getElementsByTagName("input");
  		for (var i=0; i<cbs.length; i++){
  			var ccb = cbs[i];
  			if (ccb){
  				ccb.checked = cb.checked;
  			}
  		}
  	}
  }
  
  function showHideLogs(){
  	var d = document.getElementById("logsDiv");
  	if (d){
  		if (d.style.display == "none"){
  			d.style.display = "";
  			document.getElementById("xpologNodeImg").src = "<%=BASE_DIRECTORY%>images/tree/minusnode.gif";
  		}else{
  			d.style.display = "none";
  			document.getElementById("xpologNodeImg").src = "<%=BASE_DIRECTORY%>images/tree/plusnode.gif";
  		}
  	}
  }
  
  	function shownHidediv(targetDiv){
	 var d = document.getElementById(targetDiv);
	 if (!d){
	   return;
	  }      
	  show = d.style.display == "";
	  if(show){
	    d.style.display="none";   		
	  }else{
	    d.style.display="";
	  }
	    	
	}
</script>
</head>
<body>
<input type="hidden" name="test">
<table border="0" width="100%" cellspacing="0" height="100%"
	cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
	<tr>
		<td width="100%" height="100%" valign="top">
		<table border="0" width="100%" cellspacing="0" height="100%"
			cellpadding="0">
			<tr>
				<td valign="top" height="100%">
				<table border="0" cellpadding="0" cellspacing="0"
					style="border-collapse: collapse" width="100%">
					<tr>
					
					<tr width="100%"><td><table border="0" cellpadding="0" cellspacing="0"><tr>									
						<td style="padding-right:10"><img src="../images/ui/pathImg.gif" border="0"></td>
						<td width="100%"><span class="REPORT_TABLE_TEXT"><b>Problem Diagnostics Results</b></span></td>
						<td style="padding-right:15" align="right"><nobr><a href="diagnostics.jsp" class="PATH_LINK">Modify Process</a><span class="SMALLTEXT"> / </span><a href="diagnostics.jsp?new=true" class="PATH_LINK">Reset Process</a></nobr></td>
					</tr>
					<tr>
					  <td width="*" colspan="3" valign="bottom" align="left"
						style="padding-left:30"><span class="SMALLTEXT"><nobr><%=timeStr%></nobr></span>
					  </td>
					</tr>
					</table></td></tr>					
					<tr><td>&nbsp;</td></tr>
					<%if(dashboardEnabled){ %>
					<tr width="100%" bgcolor="#EDEAE9" height="25">
						<td>
						<table border="0" cellpadding="0" cellspacing="0" width="100%">
							<tr>
								<td height="25" style="padding-left:15"><a href="javascript:shownHidediv('healthDiv')" class="REPORT_HEADER_LINK">Problem <%=analyticsH %> Summary(+/-)</a></td>
								<td width="*">&nbsp;</td>
								<td width="50%"><a class="DIAGNOSTICS_LINK" target="root" href="<%=BASE_DIRECTORY%>componentAction.jsp?selectedCompId=<%=XpologManagment.ANALYTICS_COMPONENT %>&forward=root.jsp?mainPage=dashboard/view/loadObjectDashboardModel.jsp%253FobjectType=ROOT%2526objectId=rootNode%2526startTime=<%=model.getQuery().getStartTime()%>%2526endTime=<%=model.getQuery().getEndTime()%>">Go to <%=analyticsH %> >></a></td>
							</tr>
						</table>
						</td>
					</tr>					
					<tr>
						<td nowrap align="left" style="padding-top:10">
						<div id="healthDiv" style="display:">
						<%if (model.isContainsResult(ProblemViewModel.SYSTEM_HEALTH_TYPE)){ %>
						<jsp:include page="diagnosticsSystemHealthResult.jsp" flush="true">
							<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>" />
						</jsp:include>
						<%}else { %>
						  <span class="SMALLTEXT" style="padding-left:15"><nobr>No data available </nobr> </span>
						<%} %>
						</div>
						</td>
					</tr>
					<tr><td>&nbsp;</td></tr>
					<%} %>
									
					<tr width="100%" bgcolor="#EDEAE9" height="25">
						<td height="25" style="padding-left:15"><a href="javascript:shownHidediv('reportsDiv')" class="REPORT_HEADER_LINK">Problem Related Reports (+/-)</a></td>																
					</tr>									
					<tr>
						<td align="left" style="padding-top:10">
						<div id="reportsDiv" style="display:">						
						<%if (model.isContainsResult(ProblemViewModel.REPORTS_TYPE)){ %>
						<jsp:include page="diagnosticsReportsResult.jsp" flush="true">
							<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>" />
						</jsp:include>
						<%}else { 							
						%>
						  <span class="SMALLTEXT" style="padding-left:15"> <nobr>No data available </nobr> </span>
						<%} %>	
						</div>					
						</td>
					</tr>									
					<tr><td>&nbsp;</td></tr>
					<tr width="100%" bgcolor="#EDEAE9" height="25">
						<td>
						<table border="0" cellpadding="0" cellspacing="0" width="100%">
							<tr>
								<td height="25" style="padding-left:15"><a href="javascript:shownHidediv('logsDiv')" class="REPORT_HEADER_LINK">Problem Related Applications & Logs (+/-)</a></td>
								<td width="*">&nbsp;</td>
								<td width="50%">
									<%if (members != null && members.length > 0){%>
									<a class="DIAGNOSTICS_LINK" href="javascript:document.logsResultForm.submit()">Merge selected logs >></a>
									<%}else{%>
									&nbsp;
									<%}%>
								</td>
							</tr>
						</table>
						</td>
					</tr>					
					<tr>
						<td align="left" style="padding-top:10">
						<%if (model.isContainsResult(ProblemViewModel.LOGS_TYPE)){ %>
						<jsp:include page="diagnosticsLogsResult.jsp" flush="true">
							<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>" />
						</jsp:include>
						<%}else {							
						%>
						  <span class="SMALLTEXT" style="padding-left:15"> <nobr>No data available </nobr> </span>
						<%} %>
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
</table>
</body>
</html>