<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.util.List"%>
<%@ page import="java.io.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.awt.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.managment.XpologManagment"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.agg.result.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.audit.*"%>
<%@ page import="xpolog.eye.data.filters.*"%> 
<%@ page import="xpolog.eye.reports.health.ui.*"%>
<%@ page import="xpolog.eye.computation.*"%>
<%@ page import="xpolog.eye.computation.conf.*" %>
<%@ page import="xpolog.eye.reports.health.admin.HealthReport"%>
<%@ page import="xpolog.eye.site.problem.*"%>
<%@ page import="xpolog.eye.site.problem.results.*"%>


<%!static final String BASE_DIRECTORY = "../";

	DecimalFormat decFormat = new DecimalFormat("##.##");
	String dateFormatStr = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
	SimpleDateFormat dateFormat = new SimpleDateFormat(dateFormatStr);			
	String millisecondsSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator",".");
    String dateFormatMS = dateFormatStr+millisecondsSeperator+"SSS";

	  public String transformDateToString(Date d,long timeDiff){
	    if(d == null){
	      return null;
	    }
	    if (timeDiff != 0){
	     long time = d.getTime();
	  	 d = ((Date)d.clone());
	  	 d.setTime(time + timeDiff); 
	    }
	    String format = "";
	    if (d.getTime() % 1000 == 0){
	      format = dateFormatStr;
	    } else {
	      format = dateFormatMS;
	    }
	    String str = new SimpleDateFormat(format).format(d);
	    return str;
	   }
%>
<%
	
	String ERROR_OBJ = "ERROR_OBJ";
	String HEALTH_MODEL = "HealthViewModel";
	ErrorModel errmodel = new ErrorModel();
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	ProblemViewModel model = (ProblemViewModel)request.getSession().getAttribute(ProblemViewModel.PROBLEM_MODEL_TYPE);
	
	if (errmodel.getErrorCount() != 0) {
		request.getSession().setAttribute(ERROR_OBJ, errmodel);
		return;
	}
	ProblemSystemHealthResult	sysResult = model == null ? null : (ProblemSystemHealthResult)model.getResult(ProblemViewModel.SYSTEM_HEALTH_TYPE);
 
	Color [] colors = {Color.decode("#92b2d2"),Color.decode("#ffb636"),
			Color.decode("#9bc27d"),Color.decode("#ca9dd2"),Color.decode("#cdc780"),Color.decode("#d5948d"),
			Color.decode("#9cc2b5"),Color.decode("#fcd736"),Color.decode("#a792d3"),Color.decode("#7acb93"),
			Color.decode("#d4d2b7")};
	
	Color [] pieColors = {Color.decode("#A7FF9B"),Color.decode("#AABBFF"),Color.decode("#FEFE9E"),Color.decode("#FC9EB9"),Color.decode("#E5F3FE"),Color.decode("#EC7A70")};
	String piePath = BASE_DIRECTORY + "";
	
	String lineChartPath = BASE_DIRECTORY + "";
      
	
	Properties prop = Configuration.getInstance().getUIData();
		    String logoImg = prop.getProperty("report.agg.logo.image");
		    
		    
	HealthViewResult currResult = sysResult == null ? null : sysResult.getHealthResult(); 
	
	boolean showTotals = false;

	List resultElements = currResult == null ? null : currResult.getResultElements();
	long rootTotalProblems = 0;
	HealthViewResultElement resultElement = null;
	ComputationResults computationResults = null;
	List computationResultsList = new LinkedList();
	for(int i = 0; i < resultElements.size(); i++) {
		resultElement = (HealthViewResultElement)resultElements.get(i);
		computationResults = resultElement.getComputationResults();
		if (computationResults != null){
			computationResultsList.add(computationResults);
		}
	}

	ComputationResults[] results = (ComputationResults[])computationResultsList.toArray(new ComputationResults[computationResultsList.size()]);
	HealthViewGraphQuery healthViewGraphQuery = new HealthViewGraphQuery(700,120,null);
	healthViewGraphQuery.setGenerateImage(true);
	healthViewGraphQuery.setShowTooltip(false);
	healthViewGraphQuery.setShowZoom(false);

	HealthViewGraphResult graphResult = currResult == null ? new HealthViewGraphResult() : HealthViewHelper.generateRiskXYChart(currResult,healthViewGraphQuery);
	ComputationConfiguration computeConf = ComputationConfiguration.getInstance();  
	HealthConfig [] healthConfigs = computeConf.getHealthConfigs(); 		
	String graphPath = graphResult == null || graphResult.getImagePath() == null ? "" : BASE_DIRECTORY + graphResult.getImagePath();		 
	String graphMap = graphResult == null || graphResult.getImagePath() == null ? "" : graphResult.getMapStr();		 
	double maxYAxis = graphResult == null ? -1 : graphResult.getMaxYAxis();
	HealthViewLegend riskLegend = graphResult != null ? graphResult.getLegend() : null;
	
	HealthViewGraphResult graphTotalResult = currResult == null ? new HealthViewGraphResult() : HealthViewHelper.generateTotalXYChart(currResult,healthViewGraphQuery);
	String graphTotalPath = graphTotalResult == null || graphTotalResult.getImagePath() == null ? "" : BASE_DIRECTORY + graphTotalResult.getImagePath();		 
	String graphTotalMap = graphTotalResult == null || graphTotalResult.getImagePath() == null ? "" : graphTotalResult.getMapStr();		 
	double maxTotalYAxis = graphTotalResult == null ? -1 : graphTotalResult.getMaxYAxis();
	HealthViewLegend totalsLegend = graphTotalResult != null ? graphTotalResult.getLegend() : null;
	
	HealthViewModel healthViewModel = sysResult == null ? new HealthViewModel() : sysResult.getModel();
	if (healthViewModel == null){
		healthViewModel = new HealthViewModel();
	}else{
		sysResult.clearModel();
	}
	ComputationConfiguration compConfig = ComputationConfiguration.getInstance();
	DateFilter timeFilter = ComputationConfigurationHelper.getDefaultDisplayDateFilter(healthViewModel, computeConf);
	DateFilter df = (DateFilter)timeFilter.clone();
	if (timeFilter != null){
		df = (DateFilter)timeFilter.clone();
		df.updateMinTime();
	}
	healthViewModel.setTimeFilter(df);
	request.getSession().setAttribute(HEALTH_MODEL,healthViewModel);
	
			
	String timeStr = "";
	String currResultImage = "";
	String startTime = currResult != null ? dateFormat.format(new Date(currResult.getStartTime())) : "";
	String endTime = currResult != null ? dateFormat.format(new Date(currResult.getEndTime())) : "";
	if (currResult != null){
		timeStr = startTime;
		if (currResult.getStartTime() > 0  && currResult.getEndTime() > 0){
			timeStr += " - " + endTime;
		}
		//currResultImage = HealthViewHelper.getImageForComputationResult(currResult.getMaxWeight(),false);
	}
	//building the link to health console
 	ProblemViewQuery query = model.getQuery();
	String appsList = "";
 	if(query != null) {
 		HashSet appmembers = query.getApplications();
		int index;
		if (appmembers != null) {
			String[] appsArr = (String[])appmembers.toArray(new String[appmembers.size()]);
			for (int i = 0; i < appsArr.length; i++) {			
		    	index = appsArr[i].indexOf("-")+1;
		    	if (index == -1 || index == appsArr[i].length()-1){
		    		continue;
		    	}
		    	appsList += appsArr[i];	    	
		    	if( i < appsArr.length-1) {
		    		appsList += ",";
		    	}
			}
		}
	}
	%>



<script>
	function openSubEntries(id){
		var i = 0;
		if (document.getElementById(id+"_0").style.display == ""){
			while (true){
				var e = document.getElementById(id+"_"+i);
				if (e){
					e.style.display = "none";
				}else{
					break;
				}
				i++;
			}
			document.getElementById("img_"+id).src = "<%=BASE_DIRECTORY%>images/tree/plusnode.gif";
		}else{
			while (true){
				var e = document.getElementById(id+"_"+i);
				if (e){
					e.style.display = "";
				}else{
					break;
				}
				i++;
			}
			document.getElementById("img_"+id).src = "<%=BASE_DIRECTORY%>images/tree/minusnode.gif";
		}
	}
</script>

<script>  
  var menu_base_directory = "<%=BASE_DIRECTORY%>";
	baseDirectory = "<%=BASE_DIRECTORY%>";
</script>
<script>
	
		
	function go(totals){
		if (totals){
		  document.getElementById("riskDiv").style.display = "none";
		  document.getElementById("totalDiv").style.display = "";
		}else {
		  document.getElementById("riskDiv").style.display = "";
		  document.getElementById("totalDiv").style.display = "none";
		}
	}
	
	function goToHealth() {	
		var url = "<%=BASE_DIRECTORY%>componentAction.jsp?selectedCompId=<%=XpologManagment.ANALYTICS_COMPONENT %>&forward=root.jsp?mainPage=dashboard/view/loadObjectDashboardModel.jsp%253FobjectType=ROOT%2526objectId=rootNode%2526startTime=<%=currResult.getStartTime()%>%2526endTime=<%=currResult.getEndTime()%>";;
		document.healthform.action = url;
		document.healthform.submit();
	}

	
</script>
<form AUTOCOMPLETE="OFF" id="healthform" name="healthform" method="GET" target="root" style="padding:0;margin:0">

<table border="0" width="100%" cellspacing="0" height="100%"
	cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
	<tr>
		<td width="100%" height="100%" valign="top">
		<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
			<tr>
				<td valign="top" height="100%">
				<table border="0" cellpadding="0" cellspacing="0"
					style="border-collapse: collapse" width="100%">
					<tr>
						<td width="100%">						
						<div id="totalDiv">
						<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="100%">													
							<tr>
							  <td>&nbsp;</td>											
								<td <%= (graphTotalPath == null || graphTotalPath.length() == 0) ? "style=\"padding-top:20;padding-left:30\"" : ""%>>
									<%if (graphTotalPath != null && graphTotalPath.length() > 0) {%>
									<img border="0" id="graphTotalImg" src="<%=graphTotalPath%>" usemap="#total">
									<%}else{%>
									<span class="INFORMATIONMESSAGE">No data available</span>
									<%} %>
								</td>				
								<td style="padding-left:20">
									<%if (totalsLegend != null){
										totalsLegend.setBaseDir(BASE_DIRECTORY);
										totalsLegend.setTdCls("SMALLTEXT");
									%>
									<%=totalsLegend.getAsHtmlTable()%>
									<%}else{%>
									&nbsp;
									<%}%>
								</td>
							</tr>
						</table>
						</div>
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
</table>
</form>
