<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
  
  //update menu tree
  /*boolean refreshMenu = true;
  String ref = request.getHeader("referer");
  if(ref.indexOf("root.jsp") >= 0 || ref.indexOf("menu.jsp") >= 0){
  		refreshMenu = false;
  }*/
  
  String MODULE_ID = "MODULE_ID";
  String CURRENT_MODULE = "CURRENT_MODULE";
  String ERROR_OBJ = "ERROR_OBJ";
  String OP = "OP";
  String ADD = "ADD";
  String TYPE_LOG = "Log";

  SiteManagment mgmt = SiteManagment.getInstance();

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  UserContext userContext = UserEnvironment.getUserContext(request);

  Module[] mdarr = mgmt.getAllModules(userContext,true);
  
  if(mdarr == null || mdarr.length==0) {
	  ErrorModel errmodel = new ErrorModel();
	  errmodel.addError("No available Folders were found");
	  errmodel.addError("Please check your application constraints");
	  request.getSession().setAttribute(ERROR_OBJ,errmodel);
	  response.sendRedirect("errorpage.jsp");
	  return;
  }

  String modid = request.getParameter(MODULE_ID);
  String op = request.getParameter(OP);

  Module curmod = null;
  String parentModuleId = null;
  if((op == null) || !(op.equals(ADD))){
    if(modid == null || modid.trim().equals("")){
      modid = "";
      curmod = (Module)request.getSession().getAttribute(CURRENT_MODULE);
      if (curmod != null){
        modid = curmod.getId();
      }
    }

    if(modid != null && modid.length() > 0){
      try{
        curmod = mgmt.getModuleFromId(modid);
         Module parentMod = mgmt.getParentModule(modid);
         if (parentMod != null){
            boolean foundModule = false;
            for (int i = 0; i < mdarr.length; i++) {
              if (mdarr[i].getId().equals(parentMod.getId())){
                foundModule = true;
                parentModuleId = parentMod.getId();
                break;
              }
            }
            if (!foundModule){
              Module  [] tmp = new Module[mdarr.length + 1];
              System.arraycopy(mdarr,0,tmp,0,mdarr.length);
              mdarr = tmp;
              mdarr[mdarr.length - 1] = parentMod;
            }
          }
      }catch(Exception e){
        ErrorModel ermod = new ErrorModel();
        ermod.addError("Can not find the folder!");
        ermod.addError("It is probable that the folder was deleted by another user.");
        ermod.addError("You can refresh your browser in oreder to get an updated view.");
        request.getSession().setAttribute(ERROR_OBJ,ermod);
        response.sendRedirect("errorpage.jsp");
        return;
        //module does not exist
      }
    }
  }else {
    parentModuleId = request.getParameter("PARENT_MODULE");
    if (parentModuleId == null || parentModuleId.length() == 0){
      Module pmod = (Module)request.getSession().getAttribute(CURRENT_MODULE);
      if (pmod != null){
        parentModuleId = pmod.getId();
      }else {
        parentModuleId = null;
      }
    }
    
  }
  if(curmod == null){
    curmod = new Module();
    modid = "";
    request.getSession().setAttribute(CURRENT_MODULE,curmod);
  }else{
    request.getSession().setAttribute(CURRENT_MODULE,curmod);
  }
  String imd = curmod.getId();
  HashSet allChildren = curmod.getAllChildren(userContext);
  boolean notmodules = true;
  if(imd != null && imd.equalsIgnoreCase("rootModule")){
    notmodules = false;
  }
  boolean isLogRemovable = WebSecurityManager.getInstance().isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.REMOVE_LOG_PERMISSION);
  boolean isLogEditable = WebSecurityManager.getInstance().isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.EDIT_LOG_PERMISSION);
  boolean isModuleRemovable = WebSecurityManager.getInstance().isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.REMOVE_MODULE_PERMISSION);
  boolean isModuleEditable = WebSecurityManager.getInstance().isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.EDIT_MODULE_PERMISSION);
  boolean isEditable = mdarr.length > 0  && isModuleEditable;
  if(isEditable && userContext != null && imd != null && imd.length() > 0){
    isEditable = userContext.isModuleMemberEditable(imd);
  }
  
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<jsp:include page="../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script>

  //update menu
  <%//if(refreshMenu){%>
  	//refreshMenus();
  <%//}%>

  function operationOk(){
  	if (updateParentModule){
	  	updateParentModule(tree,"ParentModule");
	  }
  	//updateSelected();
    var path ="moduleaction.jsp?MODULE_ID=" + "<%=modid%>";
    path = path + "&MODULE_NAME=";
    path = path + document.access.ModuleName.value;
    path = path + "&" + "MODULE_OWNER=" + document.access.ModuleOwner.value;
    path = path + "&" + "MODULE_DESCRIPTION=" + document.access.ModuleDescription.value;
    <%
      if(notmodules){
    %>
        path = path + "&" + "MODULE_PARENT=" + document.access.ParentModule.value;
    <%
      }
    %>
    document.location = path;
  }
  
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access">
<input type="hidden" name="ParentModule">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
  <!--    <tr>
        <td valign="top" style="border-left: 1px solid #FF9900; border-right-width: 1; border-top-width: 1; border-bottom-width: 1" height="1">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="TOPLEFTBORDER " width="33%"  height="2"></td>
            <td class="TOPBORDER" width="33%" height="2"></td>
            <td class="TOPRIGHTBORDER"  width="34%" height="2"></td>
          </tr>
        </table>
        </td>
      </tr>-->
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Folder  <%=curmod.getName()%></span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">General</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">

                      <%
                        if(notmodules){
                      %>


                      <tr>
                      	<td colspan="2">
													<jsp:include page="../../common/selectParentModule.jsp" flush="true">
													<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
													<jsp:param name="PARENT_MODULE_ID" value="<%=parentModuleId%>" />
													<jsp:param name="MODULE_IDS_TO_IGNORE" value="<%=modid%>" />
													<jsp:param name="titleColWidth" value="15%" />
													</jsp:include>
                      	</td>
                      </tr>
                      <%
                        }
                      %>
                      <tr>
                        <td width="15%"><span class="REGULARTEXT">Name</span></td>
                        <td>
                        <input type="text" name="ModuleName" size="30" value="<%=curmod.getName()%>" class="TEXTBOX"></td>
                      </tr>
                      <tr>
                        <td><span class="REGULARTEXT">Owner</span></td>
                        <td>
                        <input type="text" name="ModuleOwner" size="30" value="<%=curmod.getOwner()%>" class="TEXTBOX"></td>
                      </tr>
                      <tr>
                        <td><span class="REGULARTEXT">Description</span></td>
                        <td>
                        <input type="text" name="ModuleDescription" size="53" value="<%=curmod.getDescription()%>" class="TEXTBOX"></td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td><span class="HEADER">Folder Members</span></td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr class="TABLES_HEADERS">
                        <td width="23%"><span class="REGULARTEXT">Name</span></td>
                        <td width="30%"><span class="REGULARTEXT">Description</span></td>
                        <td width="25%" class="REGULARTEXT">&nbsp;</td>
                        <td width="20%" class="REGULARTEXT">&nbsp;</td>
                      </tr>
                      <tr>
                        <td width="23%" class="SMALLTEXT">&nbsp;</td>
                        <td width="30%" class="SMALLTEXT">&nbsp;</td>
                        <td width="25%" class="SMALLTEXT">&nbsp;</td>
                        <td width="20%" class="SMALLTEXT">&nbsp;</td>
                      </tr>
                      <%
                        ModuleMember mem = null;
                        List mmber = curmod.getModuleMembers(userContext);
                        String id = null;
						String clas = "UNMARKITEM";
                        for(int i=0;i<mmber.size();++i){
                          mem = (ModuleMember)mmber.get(i);
                          id = mem.getId();
 						  if((i%2) == 0){
							clas = "UNMARKITEM";
						  }else{
							clas = "MARKITEM";
						  }
                      %>
                      <tr class="<%=clas%>">


                        <%
                          if(mem.getType().equalsIgnoreCase(TYPE_LOG)){
                        %>

			           <td width="23%"><a href="<%=BASE_DIRECTORY%>loggers/logview.jsp?logid=<%=id%>" class="LINK"><%=mem.getName()%></a></td>
                          <td width="30%"><span class="REGULARTEXT"><%=mem.getDescription()%>&nbsp;</span></td>
                          <td width="25%">
                          <%if (isLogEditable){%>
                          <a href="<%=BASE_DIRECTORY%>loggers/admin/logeditaction.jsp?LOG_ID=<%=id%>" class="LINK">edit</a>
                          <%}%>
                          <span class="REGULARTEXT">&nbsp;&nbsp;</span>
                           <%if (isLogRemovable){%>
                          <a href="<%=BASE_DIRECTORY%>loggers/admin/logremoveopcheck.jsp?LOG_ID=<%=id%>" class="LINK">delete</a>
                          <%}%>
                          </td>
                        <%
                          }else{
                        %>
			  <td width="23%"><a href="moduleadmin.jsp?MODULE_ID=<%=id%>" class="LINK"><%=mem.getName()%></a></td>
                          <td width="30%"><span class="REGULARTEXT"><%=mem.getDescription()%>&nbsp;</span></td>
                          <td width="25%">
                          <%if (isModuleEditable){%>
                          <a href="moduleadmin.jsp?MODULE_ID=<%=id%>" class="LINK">edit</a> 
                          <%}%>
                          <span class="REGULARTEXT">&nbsp;&nbsp;</span>
                          <%if (isModuleRemovable){%>
                          <a href="removeopcheck.jsp?MODULE_ID=<%=id%>" class="LINK">delete</a>
                          <%}%>
                          </td>
                        <%
                          }
                        %>

                        <td width="20%" class="REGULARTEXT">&nbsp;</td>
                       </tr>
                      <%}%>
                    </table>
                    </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <%
              if(notmodules){
            %>
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="35%">&nbsp;</td>
                    <td width="11%" align="center"><a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK">
                    cancel</a></td>
                    <td width="7%" align="center">
                     <%if (isEditable){ %>
                       <a href='javascript:operationOk()' class="LINK">save</a></td>
                      <%}else {%>
                        &nbsp;
                      <%}%>
                    <td width="27%">&nbsp;</td>
                    <td width="20%">&nbsp;</td>
                  </tr>
                </table>
              <%
                }
              %>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>

</body>

</html>