<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.knowledge.admin.*"%>
<%@ page import="xpolog.eye.knowledge.*"%>
<%@ page import="xpolog.eye.knowledge.common.*"%>
<%@ page import="xpolog.eye.knowledge.repository.*"%>

<%@ page import="java.util.*"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%

KnowledgePackageBuilder builder = (KnowledgePackageBuilder)request.getSession().getAttribute(KnowledgePackageBuilder.KNOWLEDGE_BUILDER_ATT);
if (builder == null){
	return;
}
  
KnowledgeRepository [] reps = builder.getAllRepositories();
KnowledgeRepository selRep = builder.getSelectedRepository();

int maxResults = -1;
  
%>
<script>

var selRow;

function selectRow(row){
  if (selRow){
    selRow.className='UNMARKITEM';
  }
  
  if (row){
    row.className='MARKITEM';
    selRow = row;
  }
}

var repChangeReq;
function repChange(){
  repChangeReq = GetXmlHttpObject();
  if (!repChangeReq) return;
  
  var combo = document.getElementById("repList");
  
  var repId;
  var selectedIndex = combo.selectedIndex;
  if (selectedIndex >= 0){
    repId = combo.options[selectedIndex].value;
  }else {
    return;
  }
  
  								 
  var url = "packageRepositoryTable.jsp?repId=" + repId;
  
  repChangeReq.onreadystatechange = repShowResult;
  repChangeReq.open('GET', url, true);
  repChangeReq.send(null); 
}

function repShowResult() {
      if (repChangeReq.readyState == 4) {
         if (repChangeReq.status == 200) {
            var result = repChangeReq.responseText;          
            document.getElementById('repTableDiv').innerHTML = result;            
         } else {
            alert('There was a problem with the repository request.');
         }
      }
   }


var repResultGetReq;
function repResultGet(index){
  repResultGetReq = GetXmlHttpObject();
  if (!repResultGetReq) return;
  					 
  var url = "packageRepositoryInfo.jsp?repRowIndex=" + index;
  
  repResultGetReq.onreadystatechange = repResultGetChange;
  repResultGetReq.open('GET', url, true);
  repResultGetReq.send(null); 
}

function repResultGetChange() {
      if (repResultGetReq.readyState == 4) {
         if (repResultGetReq.status == 200) {
            var result = repResultGetReq.responseText;          
            document.getElementById('repResultDiv').innerHTML = result;            
         } else {
            alert('There was a problem with the repository request.');
         }
      }
   }
   


function initRep(){
  var h = document.body.clientHeight;
  h = h - 350;
  document.getElementById("repTableDiv").style.height=h;
  repChange();
  repResultGet(-1);
}

initFunction[initFunction.length] = "initRep()";
</script>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
<tr><td style="padding-top:5"><span class=REGULARTEXT">Repository </span><select size="1" name="repList" id="repList" onChange="javascript:repChange()">
<%
   
	for (int i = 0; i < reps.length;i++) {
		KnowledgeRepository rep = reps[i];
		String sel = selRep == rep ? "selected" : "";
%>
<option value="<%=rep.getKey()%>" <%=sel%>><%=rep.getName()%></option>
<%} %>
</select>
			
  	  	</td></tr>
  	  	
  	  	<tr height="*" ><td style="padding-top:5">
  	  	<div style="overflow:auto; width:90%;height:100" id="repTableDiv">
  	  	
</div>
  	  	</td></tr>
  	  	
  	  	<tr height="10"><td style="padding-top:5">
  	  	<div id="repResultDiv">
  	  	
</div>
  	  	</td></tr>
  	  	
	     </table>
