<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.knowledge.admin.*"%>
<%@ page import="xpolog.eye.knowledge.*"%>
<%@ page import="xpolog.eye.knowledge.common.*"%>
<%@ page import="xpolog.eye.knowledge.repository.*"%>

<%@ page import="java.util.*"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%

KnowledgePackageBuilder builder = (KnowledgePackageBuilder)request.getSession().getAttribute(KnowledgePackageBuilder.KNOWLEDGE_BUILDER_ATT);
if (builder == null){
	return;
}
  
KnowledgeRepository selRep = builder.getSelectedRepository();
RepositoryResult [] results = selRep == null ? null : builder.getRepositoryResults(selRep,-1);
String indexStr = request.getParameter("repRowIndex");

int index = -1;
try {
	if (indexStr != null && indexStr.length() > 0){
		index = Integer.parseInt(indexStr);
	}
}catch (Exception e){}
RepositoryResult result = results == null || index == -1 || index >= results.length? null : results[index];
String name = result == null ? "" : result.getName();
String key = result == null ? "" : result.getKey();
String desc = result == null ? "" : result.getDescription().trim();

%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
<tr height="10" style="padding-top:10">
<td> 
<span class="REGULARTEXT">Key: </span>
</td>
<td><input type="text" size="100" name="repResultKey" value="<%=key%>">
</td>
</tr>
<tr height="10">
<td> 
<span class="REGULARTEXT">Name: </span>
</td>
<td><input type="text" size="100" name="repResultName" value="<%=name %>">
</td>
</tr>
<tr>
<td height="5"> 
<span class="REGULARTEXT">Desc: </span>
</td>
<td>
<textarea rows="5" cols="80"><%=desc%></textarea>
</td>
</tr>
</table>
