<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.knowledge.admin.*"%>
<%@ page import="xpolog.eye.knowledge.*"%>
<%@ page import="xpolog.eye.knowledge.common.*"%>
<%@ page import="xpolog.eye.knowledge.repository.*"%>

<%@ page import="java.util.*"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%

KnowledgePackageBuilder builder = (KnowledgePackageBuilder)request.getSession().getAttribute(KnowledgePackageBuilder.KNOWLEDGE_BUILDER_ATT);
if (builder == null){
	return;
}
  
KnowledgeRepository selRep = builder.getSelectedRepository();

int maxResults = 100;
RepositoryResult [] results = selRep == null ? null : builder.getRepositoryResults(selRep,-1);
String title = "";
if (results != null && results.length > 0){
	title = "(Results: ";
	if (maxResults > 0 && maxResults  < results.length){
		title += maxResults + " / ";
	}
	title += results.length  + " )";
}
%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
<tr class="TABLES_HEADERS" height="5">
<td><span class="REGULARTEXT">Name &nbsp;&nbsp;&nbsp;&nbsp;<%=title%></span></td>
<td><span class="REGULARTEXT">Risk</span></td>
<td><span class="REGULARTEXT">Confidence</span></td>
</tr>
<% if (selRep != null){
			int maxDesc = 80;	    
	    for (int i = 0; i < results.length && (maxResults == -1 || i < maxResults); i++){
	    	RepositoryResult result = results[i];
	    	String name = result.getName();
	    	String tooltip = null;
	    	if (name.length() > maxDesc){
	    		tooltip = name;
	    		name = name.substring(0,maxDesc) + "...";
	    	}
	%>
	<tr height="5" style="padding-top:2;" onClick="javascript:selectRow(this);repResultGet(<%=String.valueOf(i)%>)"   class="UNMARKITEM">
<td <%=(tooltip == null ? "" : "title=\"" + tooltip + "\"")%> onMouseOver="javascript:this.style.cursor='hand'" onMouseOut="javascript:this.style.cursor='default'"><span class="REGULARTEXT"><%=name %></span></td>
<td><select name="<%="risk_" + i%>" id="<%="risk_" + i%>">
<% for (int j = 1;j <= 10;j++){ %>
<option value="<%=String.valueOf(j)%>"><%=String.valueOf(j)%></option>
<%} %>
</select></td>
<td><select name="<%="confidence_" + i%>" id="<%="confidence_" + i%>">
<% for (int j = 1;j <= 10;j++){ %>
<option value="<%=String.valueOf(j)%>"><%=String.valueOf(j)%></option>
<%} %>
</select></td>
</tr>
<%}
}%>
<tr height="*">
                    <td >
                    &nbsp;</td>
                  </tr>
</table>
