<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.knowledge.*"%>
<%@ page import="xpolog.eye.knowledge.admin.*"%>
<%@ page import="xpolog.eye.knowledge.syntax.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%

KnowledgePackageBuilder builder = (KnowledgePackageBuilder)request.getSession().getAttribute(KnowledgePackageBuilder.KNOWLEDGE_BUILDER_ATT);
if (builder == null){
	return;
}
  SyntaxConfiguration [] configs = builder.getAllSyntaxConfigs();
  SyntaxConfiguration curConfig = builder.getSelectedSyntaxConfig();
  
%>

<script>
var syntaxAdpaterChangeReq;
function adapterChange(combo){
  syntaxAdpaterChangeReq = GetXmlHttpObject();
  if (!syntaxAdpaterChangeReq) return;
  
  var adapterId;
  var selectedIndex = combo.selectedIndex;
  if (selectedIndex >= 0){
    adapterId = combo.options[selectedIndex].value;
  }else {
    return;
  }
  
  								 
  var url = "syntaxAdapterChangeAction.jsp?adapterKey=" + adapterId;
  
  syntaxAdpaterChangeReq.onreadystatechange = syntaxChangeShowResult;
  syntaxAdpaterChangeReq.open('GET', url, true);
  syntaxAdpaterChangeReq.send(null); 
}

function syntaxChangeShowResult() {
      if (syntaxAdpaterChangeReq.readyState == 4) {
         if (syntaxAdpaterChangeReq.status == 200) {
            var result = syntaxAdpaterChangeReq.responseText;
            result = result.replace(/^\s+|\s+$/g, '') ;
            document.getElementById('adapterFile').value = result;  
            document.getElementById('syntaxResultText').innerHTML = "&nbsp;";          
         } else {
            alert('There was a problem with the request.');
         }
      }
   }
   
   var syntaxAdapterReq;
function adapterUpdate(op){
  syntaxAdapterReq = GetXmlHttpObject();
  if (!syntaxAdapterReq) return;
  
  var parameters = "op=" + op + "&xmlStr=" + encodeURI( document.getElementById("adapterFile").value);
  								 
  var url = "syntaxAdapterAction.jsp";
  
  syntaxAdapterReq.onreadystatechange = showSyntaxAdapterResult;
  syntaxAdapterReq.open('POST', url, true);
  syntaxAdapterReq.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  syntaxAdapterReq.setRequestHeader("Content-length", parameters.length);
  syntaxAdapterReq.setRequestHeader("Connection", "close");
  syntaxAdapterReq.send(parameters);
  
}

function showSyntaxAdapterResult() {
      if (syntaxAdapterReq.readyState == 4) {
         if (syntaxAdapterReq.status == 200) {           
            result = syntaxAdapterReq.responseText;
            result = result.replace(/^\s+|\s+$/g, '') ;
            document.getElementById('syntaxResultText').innerHTML = result;            
         } else {
            alert('There was a problem with the request.');
         }
      }
   }
   
   
   

</script>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">

<tr><td style="padding-top:5"><span class=REGULARTEXT">Adapter </span>
<select size="1" name="adapterList" id="adapterList" onChange="javascript:adapterChange(this)">
<%

	for (int i = 0; i < configs.length;i++) {	
		File f = configs[i].getConfigFile();
		if (f == null) continue;
		
%>
<option value="<%=configs[i].getConfigKey()%>"><%=configs[i].getConfigName()%></option>
<%} %>
</select>
			
  	  	</td></tr>
  	  	
<tr><td><span class="HEADER">Syntax configuration file</span></td></tr>  	    
  	  	<tr><td>
  	  	<% 
  	  	String text = builder.getSelectedSyntaxConfigText();
  	  	
  	  		  %>
  	  		<textarea class="TEXTBOX" wrap="on" rows="20" name="adapterFile" id="adapterFile" cols="120" style="font-size: 8pt"><%=text%></textarea>
  	  	</td></tr>
  	  	<tr><td><span class="HEADER">&nbsp;</span></td></tr> 
  	  	<tr><td><span class="SMALLTEXT" id="syntaxResultText">&nbsp;</span></td></tr>  	    
  	  	
  	  	<tr><td><a class="LINK" href="javascript:adapterUpdate('apply')" style="padding-left:300">Apply</a>&nbsp;&nbsp;<a class="LINK" href="javascript:adapterUpdate('save')" style="padding-left:10">save</a></td></tr>
	     </table>