<%@ page language="java"%>
<%@ page import="xpolog.eye.knowledge.admin.*"%>
<%@ page import="xpolog.eye.knowledge.common.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>

<%

  String exampleStr = request.getParameter("exampleText");
  KnowledgePackageBuilder builder = (KnowledgePackageBuilder)request.getSession().getAttribute(KnowledgePackageBuilder.KNOWLEDGE_BUILDER_ATT);
  
  String result = "";
  if (builder != null && exampleStr != null && exampleStr.length() > 0){
  	 builder.setExample(exampleStr.trim());
  	 KnowledgeResult [] results = builder.testExample();
  	 if (results.length == 0){
  		 result = "No Result";
  	 }else {
  		 StringBuffer buffer = new StringBuffer();
  		 for(int i = 0; i < results.length;i++){
  			 if (i > 0){
  				 buffer.append("\n***********************************************\n");  				 
  			 }
  			 buffer.append("key=").append(results[i].getKey()).append("\n");
  			 buffer.append("name=").append(results[i].getName()).append("\n");
  			 buffer.append("risk=").append(results[i].getRiskLevel()).append("\n");
  			 buffer.append("confidence=").append(results[i].getConfidenceLevel()).append("\n");
  			 buffer.append("desc=").append(results[i].getDescription()).append("\n");
  			 buffer.append("messages=").append(results[i].getMessageAsStr("\n")).append("\n");
  			 buffer.append("filters=").append(results[i].getFiltersAsStr("\n")).append("\n");
  		 }
  		 result = buffer.toString().trim();
  	 }
  }else {
  	result = "Missing parameters";
  }
  
  response.setContentType("text/html");
	out.write(result);
	out.flush();
%>