<%@ page language="java"%>

<%@ page import="java.util.List"%>
<%@ page import="xpolog.eye.media.auth.win.WinAuthenticationAccountFilter"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.media.AddressFilter"%>
<%@ page import="xpolog.eye.media.AddressBook"%>
<%@ page import="xpolog.eye.media.snmp.SNMPAccountFilter"%>
<%@ page import="xpolog.eye.media.jms.JMSAccountFilter"%>
<%@ page import="xpolog.eye.media.sms.SmsAccountFilter"%>
<%@ page import="xpolog.eye.media.db.DBAccountFilter"%>
<%@ page import="xpolog.eye.media.mail.MailAccountFilter"%>
<%@ page import="xpolog.eye.media.fs.FSAccountFilter"%>
<%@ page import="xpolog.eye.media.telsh.TelnetAccountFilter"%>
<%@ page import="xpolog.eye.media.ftp.FTPAccountFilter"%>
<%@ page import="xpolog.eye.media.http.HttpAccountFilter"%>
<%@ page import="xpolog.eye.media.Account"%>
<%@ page import="xpolog.eye.media.remote.RemoteXplgAccountFilter"%>


<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  //constants
  String ACC_TYPE = "ACC_TYPE";
//	String CHANGE_ACC_SELECTION = "ACC_TYPE";
	String ACC_ID = "ACC_ID";
	UserContext userContext = UserEnvironment.getUserContext(request);
	List list = null;
	AddressFilter filter = null;
	String selectedAccId = request.getParameter(ACC_ID);
	if(selectedAccId == null){
		selectedAccId = "";
	}
	String isAccountChangeStr = request.getParameter("IS_ACC_CHANGED");
	boolean isAccountChange = isAccountChangeStr != null && isAccountChangeStr.equals("true");
	String filterstr = request.getParameter(ACC_TYPE);
	if(filterstr == null){
		filterstr = "";
	}
  if(filterstr.length() > 0){
	  if(filterstr.equals("http")){
	  	filter = new HttpAccountFilter();
	  }else if(filterstr.equals("ftp")){
	  	filter = new FTPAccountFilter();
	  }else if(filterstr.equals("ssh") || filterstr.equals("syslog")){
	  	filter = new TelnetAccountFilter();
	  }else if(filterstr.equals("fs")){
	  	filter = new FSAccountFilter();
	  }else if(filterstr.equals("email")){
	  	filter = new MailAccountFilter();
	  }else if(filterstr.equals("db")){
	  	filter = new DBAccountFilter();
	  }else if(filterstr.equals("sms")){
	  	filter = new SmsAccountFilter();
	  }else if(filterstr.equals("jms")){
		  	filter = new JMSAccountFilter();
	  }else if(filterstr.equals("snmp")){
			filter = new SNMPAccountFilter();
	  }else if(filterstr.equals("remote")){
			filter = new RemoteXplgAccountFilter();
	  }else if(filterstr.equals("auth") || filterstr.equals("winEvent")){
			filter = new WinAuthenticationAccountFilter();
	  }
  }
  if(filter != null){
		AddressBook adbook = AddressBook.getInstance();
	  list = adbook.getAccountsByFilter(filter,userContext);
	}

%>
<%if(!filterstr.equals("none")){ %>
<select class="TEXTBOX" id="LogAdminAccList" name="LogAdminAccList" style="width:180;"  onChange="javascript:accountChanged('LogAdminAccList');" >
		<option value="none"> -- Account -- </option>		
	<%if(list != null){
		for(int i = 0 ;i < list.size() ; i++){
	    Account acc = (Account)list.get(i);
	    String accSelected = "";
	    String name = acc == null ? "" : acc.getAccountName();
	    String type = acc == null ? "" : acc.getType();
	    String accId = acc == null ? "noId" : acc.getId();
	    accSelected = (accId != null && acc.getId().equals(selectedAccId)) ? " selected" : "";
	%>
		<option value="<%=accId%>" <%=accSelected%>><%=name%></option>	
	<%}}%>														
</select>
<%}else if(isAccountChange){%>
none
<%}%>