<%@page import="xpolog.eye.logcollection.adapters.LogSourcePolicy"%>
<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.CollectionUnit"%>
<%@ page import="com.xpolog.logcollection.CollectionUnitsManager"%>
<%@ page import="com.xpolog.logcollection.LogCollectionManager"%>
<%@ page import="com.xpolog.logcollection.admin.CollectionUnitAdminStatus"%>
<%@ page import="com.xpolog.logcollection.admin.builders.CollectionAdapterBuilderWrapper"%>
<%@ page import="com.xpolog.logcollection.admin.builders.CollectionUnitBuilder"%>
<%@ page import="com.xpolog.logcollection.admin.helpers.LogCollectionHelper"%>
<%@ page import="com.xpolog.logcollection.data.writers.DbPacketWriter"%>
<%@ page import="com.xpolog.logcollection.data.writers.FilePacketWriter"%>
<%@ page import="com.xpolog.logcollection.data.writers.SshPacketWriter"%>
<%@ page import="com.xpolog.logcollection.locations.files.FileLocationInfo"%>
<%@ page import="com.xpolog.logcollection.security.LogCollectionSecurityManager"%>
<%@ page import="com.xpolog.logcollection.util.constants.Constants"%>

<%@ page import="xpolog.eye.audit.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.logcollection.XpologCollectionUnitAdminRequest"%>
<%@ page import="xpolog.eye.logcollection.admin.builders.LogCollectionAdapterBuilder"%>
<%@ page import="xpolog.eye.logcollection.admin.helpers.XpologCollectionAdminHelper"%>
<%@ page import="xpolog.eye.scheduler.XpoScheduledOperation"%>
<%@ page import="xpolog.eye.scheduler.ui.SchedulerHelper"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page import="xpolog.eye.util.*"%>

<%@ page import="java.util.LinkedList"%>
<%@ page import="java.util.List"%>

<%!static final String BASE_DIRECTORY = "../../../";%>

<%
	String ERROR_OBJ = "ERROR_OBJ";
	String CU_ID = "CU_ID";
  String BUILDER = "CURRENT_COLLECTION_UNIT_BUILDER";
  String CU_NAME = "logCollectionName";
  String CU_DESCRIPTION = "logCollectionDesc";
	String LBM_ID = "logs";
  String SUFFIX = "logCollectionAdmin";
	
  LogCollectionManager logCollectionMgr = LogCollectionManager.getInstance();
  CollectionUnitsManager cuMgr = logCollectionMgr.getCollectionUnitsManager();
 	
  String cuId = request.getParameter(CU_ID);
  String cuName = request.getParameter(CU_NAME);
  String cuDesc    = request.getParameter(CU_DESCRIPTION);
	String lbmId = request.getParameter(LBM_ID);
	String collectionPathChangeVerifierStr = request.getParameter("locationChanged");
	boolean locationChangeVerified = collectionPathChangeVerifierStr != null && collectionPathChangeVerifierStr.equals("true");
	String moveCollectedDataStr = request.getParameter("moveCollectedData");
	boolean moveCollectedData = moveCollectedDataStr != null && moveCollectedDataStr.equals("true");
	String updateStorageLogStr = request.getParameter("updateStorageLog");
	boolean updateStorageLog = true;//updateStorageLogStr != null && updateStorageLogStr.equals("true");
	String storageLbmId = request.getParameter("storageLbmId");
	//System.out.println("lbmId = " + lbmId);
	String filterId = null;
	String [] filtersArr = request.getParameterValues("filters");
	if (filtersArr != null){
		StringBuffer sb = new StringBuffer();
		for (int i = 0;i< filtersArr.length;i++){
			filterId = filtersArr[i];//f.substring(index+1);
			if (filterId.length() == 0){
				continue;
			}
			if (sb.length() > 0){
				sb.append(",");
			}
			sb.append(filterId);
		}
		filterId = sb.toString();
	}



  //verify data
  ErrorModel errmodel = new ErrorModel();
  
  if(cuName == null || cuName.trim().equals("")){
    errmodel.addError("No name was supplied.");
  }
  if(WebUtil.isContainSpecialCharecter(cuName)){
     errmodel.addError("The following charecters are prohibited in the name field: "+WebUtil.getSpecialCharectersList());
  }
  
	FilePacketWriter fileWriter = XpologCollectionAdminHelper.createFilePacketWriter(request,lbmId,SUFFIX,errmodel);
	DbPacketWriter dbWriter = XpologCollectionAdminHelper.createDbPacketWriter(request,lbmId,SUFFIX,errmodel);
	FilePacketWriter sshWriter = XpologCollectionAdminHelper.createFilePacketWriter(request,lbmId,SUFFIX,errmodel,SshPacketWriter.SSH_PACKET_WRITER_TYPE);
	LogSourcePolicy logSourcePolicy = XpologCollectionAdminHelper.getSourcePolicy(request,SUFFIX);

  CollectionUnit cu = null;
  if (cuId != null){
  	cu = cuMgr.getCollectionUnit(cuId);
  }

  CollectionUnitBuilder cuBuilder = (CollectionUnitBuilder)request.getSession().getAttribute(BUILDER);
  if (cuBuilder == null){
  	cuBuilder = new CollectionUnitBuilder();
  }

  CollectionAdapterBuilderWrapper caBuilderWrapper = cuBuilder.getCurrentCollectionAdapterBuilderWrapper();
  LogCollectionAdapterBuilder caBuilder;
  if (caBuilderWrapper != null){
  	caBuilder = (LogCollectionAdapterBuilder)caBuilderWrapper.getBuilder();
  }else{
  	caBuilder = new LogCollectionAdapterBuilder(); 
  	cuBuilder.addCaBuilder(caBuilder);
  }
  
	FilePacketWriter orgFileWriter = null;
	boolean collectionPathChanged = false;
	String previousChecksumAlgorithm = null;
	FileLocationInfo prevChecksumLocationInfo = null;
	if (caBuilder != null){
		List orgWriters = caBuilder.getWriters();
		if (orgWriters != null){
			for (int i=0; i<orgWriters.size(); i++){
				if (orgWriters.get(i) instanceof FilePacketWriter){
					orgFileWriter = (FilePacketWriter)orgWriters.get(i);
					FileLocationInfo locationInfo = fileWriter.getFileLocationInfo();
					FileLocationInfo orgLocationInfo = orgFileWriter.getFileLocationInfo();
					if (locationInfo != null && orgLocationInfo != null && !locationInfo.getPath().equals(orgLocationInfo.getPath())){
						collectionPathChanged = true;
					}
					previousChecksumAlgorithm = orgFileWriter.getCheckSumAlgorithm();
					prevChecksumLocationInfo = orgFileWriter.getChecksumLocationInfo();
					if (prevChecksumLocationInfo == null){
						prevChecksumLocationInfo = logCollectionMgr.getSystemMgr().getDefaultChecksumLocationInfo();
			  		if (prevChecksumLocationInfo == null){
			  			prevChecksumLocationInfo = new FileLocationInfo();
			  			prevChecksumLocationInfo.setPath(LogCollectionHelper.getCollectionInfosDirectory());
			  		}					
					}
					break;
				}
			}
		}
	}

	if(cu != null){
    cuBuilder.setCuID(cu.getId());
  }

  LinkedList writers = new LinkedList();
  boolean writerAdded = false;
  FileLocationInfo checksumLocationInfo = null;
  boolean checksumAdded = false;
  boolean checksumLocationUpdated = false;
  //add file writer
  if (fileWriter != null){
  	checksumLocationInfo = fileWriter.getChecksumLocationInfo();
  	if (checksumLocationInfo == null){
  		checksumLocationInfo = logCollectionMgr.getSystemMgr().getDefaultChecksumLocationInfo();
  		if (checksumLocationInfo == null){
  			checksumLocationInfo = new FileLocationInfo();
  			checksumLocationInfo.setPath(LogCollectionHelper.getCollectionInfosDirectory());
  		}
  	}
	  if (previousChecksumAlgorithm == null && fileWriter.getCheckSumAlgorithm() != null){
	  	checksumAdded = true;
	  }else{
	  	if (checksumLocationInfo != null){
	  		String checksumDir = checksumLocationInfo.getPath();
	  		String prevChecksumDir = prevChecksumLocationInfo != null ? prevChecksumLocationInfo.getPath() : null;
	  		if (checksumDir != null && prevChecksumDir != null && !checksumDir.equals(prevChecksumDir)){
	  			checksumLocationUpdated = true;
	  		}
	  	}
	  }
  	if (!collectionPathChanged || locationChangeVerified || checksumAdded || checksumLocationUpdated){
  	  writers.add(fileWriter);
  	  if (fileWriter.isActive()){
  	  	writerAdded = true;
  	  }
  	}
  }
  //add db writer
  if (dbWriter != null){
  	writers.add(dbWriter);
  	if (dbWriter.isActive()){
  		writerAdded = true;
	  }
  }
  //add ssh writer
  if (sshWriter != null){
  	writers.add(sshWriter);
  	if (sshWriter.isActive()){
  		writerAdded = true;
	  }
  }
  
  if (!writerAdded){
  	errmodel.addError("Please select a collection target");
  }
  
  //Update caBuilder with mail tasks
  XpologCollectionAdminHelper.updateBuilderTasksFromRequest(caBuilder,request,errmodel);
  
  
  //CollectionAdapter
  caBuilder.setWriters(writers);
  caBuilder.setLbmId(lbmId);
  caBuilder.setLbmFilterId(filterId);
  caBuilder.setStorageLbmId(storageLbmId);
  caBuilder.setSourcePolicy(logSourcePolicy);
  //CollectionUnit
  cuBuilder.setCuName(cuName);
  cuBuilder.setCuDescription(cuDesc);
  
  if (lbmId == null){
  	errmodel.addError("Please select a log to collect");
  }
  
	if (cuName == null || cuName.trim().equals("")){
		errmodel.addError("No Name was supplied.");
		errmodel.addErrorParam(CU_NAME);
	}else if(WebUtil.isContainSpecialCharecter(cuName)){
		errmodel.addError("The following charecters are prohibited in the name filed: "+WebUtil.getSpecialCharectersList());
		errmodel.addErrorParam(CU_NAME);
	}
	
	//scheduler
	XpoScheduledOperation opSched = null;
  try {
  	opSched = SchedulerHelper.getCollectionScheduledOperation(request,"LogCollectionSched",errmodel);
  	cuBuilder.setSchedOp(opSched);
  }catch (Exception e){
  	errmodel.addError("Invalid scheduler rule. Please make sure the scheduler rule is valid and try again");
  }
  
  if (errmodel.getErrorCount() == 0){
	  try{
	    //for configuration reasons
	    cuBuilder.updateBuilder();
	  }catch(Exception e){
	    errmodel.addError("Building log collectoin problem, please check your settings again.");
	    errmodel.addError(e.getMessage());
	  }
  }
  
	String xml = "";
  // save and audit
  if (errmodel.getErrorCount() == 0){
  	if (!locationChangeVerified && collectionPathChanged){
  		xml = GridModelActionsHelper.getResultXML(false, "CollectionPathChanged");
  	}else{
  		UserContext userContext = UserEnvironment.getUserContext(request);
  		AuditManager auditMgr = AuditManager.getInstance();
  		
  		cu = cuBuilder.getCu();
  		XpologCollectionUnitAdminRequest saveRequest = new XpologCollectionUnitAdminRequest(Constants.Actions.SAVE);
  		saveRequest.setMoveCollectedData(moveCollectedData);
  		saveRequest.setUpdateStorageLbmLocation(updateStorageLog);
  		saveRequest.setUserContext(userContext);
  		boolean disableIndexing = logSourcePolicy != null ? logSourcePolicy.isDisableIndexingOfSourceLogs() : false;
  		boolean disableDashboard = logSourcePolicy != null ? logSourcePolicy.isDisableDashboardForSourceLogs() : false;
  		saveRequest.setDisableIndexing(disableIndexing);
  		saveRequest.setDisableDashboard(disableDashboard);
  		cuMgr.saveCollectionUnit(cu,saveRequest);
  		CollectionUnitAdminStatus requestStatus = saveRequest.getStatus();
  		boolean error = requestStatus != null && requestStatus.isError();
  		if (error){
  			String[] msgs = requestStatus.getMessages();
  			if (msgs != null){
  				for (int i=0; i<msgs.length; i++){
  					errmodel.addError(msgs[i]);
  				}
  			}
  		}else{
    		auditMgr.write(AuditConstants.BASIC_AUDIT_LEVEL,
 	  		userContext, AuditConstants.CHANGE, "save/edit log collection ", AuditConstants.LOG_COLLECTION, "change the log collection " + cu.getName()); 
 	  		request.getSession().removeAttribute(BUILDER);
 	  		//update checksum location info if needed
  			String caId = caBuilder != null ? caBuilder.getCaID() : null;
  			if (caId != null && cu.getId() != null){
   	  		if (checksumAdded){
   	  			LogCollectionSecurityManager securityMgr = logCollectionMgr.getSystemMgr().getSecurityManager();
   	  			if (cu.getId() != null && caId != null){
   	  				securityMgr.addChecksumToIgnore(cu.getId() + caId);
   	  			}
   	  		}else if (checksumLocationUpdated){
   	  			LogCollectionHelper.moveWritersMetaData(prevChecksumLocationInfo,checksumLocationInfo,cu.getId(),caId);
   	  		}
  			}
 	  		
 	  		xml = GridModelActionsHelper.getResultXML(true, cu.getId());
  		}
  	}
  }
	if (errmodel.getErrorCount() > 0){
		String[] errors = errmodel.getErrors();
		StringBuffer sb = new StringBuffer();
		for (int i=0; i<errors.length; i++){
			if (sb.length() > 0){
				sb.append("*;*");
			}
			sb.append(errors[i]);
		}
		String message = sb.toString();
		//params
		String[] params = errmodel.getErrorParams();
		sb = new StringBuffer();
		for (int i=0; i<params.length; i++){
			if (sb.length() > 0){
				sb.append("*;*");
			}
			sb.append(params[i]);
		}
		String paramsList = sb.toString();
		xml = GridModelActionsHelper.getResultXML(false, message, paramsList);
  }
	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	out.write(xml);
	out.flush();
%>