<%@page import="xpolog.eye.util.XpologUtil"%>
<%@ page language="java"%>

<%@ page import="java.text.*"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.transform.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	String SHOW_DESC = "SHOW_DESC";
	String XPOLOG_SEL_COLS = "XPOLOG_SEL_COLS";
	String SQL_SEL_COLS = "SQL_SEL_COLS";
	String TABLE_NAME_TO_USE = "TABLE_NAME_TO_USE";
	String CREATE_TBL_CHECKED = "CREATE_TBL_CHECKED";
	String lbmId = request.getParameter("lbmId");
  
  //verify data
 	ErrorModel errmodel = new ErrorModel();

	String accId = request.getParameter("accId");
	String tableName = request.getParameter("tableName");
	String tableNameToUse = request.getParameter(TABLE_NAME_TO_USE);
	String create_table = request.getParameter(CREATE_TBL_CHECKED);
	String showTblDescStr = request.getParameter(SHOW_DESC);
  String xpologSelCols = request.getParameter(XPOLOG_SEL_COLS);
	String sqlSelCols = request.getParameter(SQL_SEL_COLS);
  String create_table_checked = "";

  boolean showTblDesc = false;
	if (showTblDescStr != null) {
		showTblDesc = showTblDescStr.equals("true");
	}
	  
	SiteManagment mgmt = SiteManagment.getInstance();
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  LogBrowsingManager lbm = null;
  ModuleMember mm = null;
  if (lbmId != null){
  	try{
  		mm = mgmt.getModuleMember(lbmId);
  		lbm = mgmt.getLogBrowserManager(lbmId,false,false,true);
  	}catch(Exception e){
  		errmodel.addError("Failed to load log " + (mm != null ? mm.getName() : ""));
  	}
  }
	if (tableNameToUse == null || tableNameToUse.equals("")){
		if (tableName != null){
			tableNameToUse = XpologUtil.replaceSpecialCharecters(tableName);
			tableNameToUse = tableNameToUse.replaceAll("\\s+","_");
		}else {
			tableNameToUse = "";
		}
	}
	
	SQLTransformer trans = (SQLTransformer)TransformationFactory.getTransformaerByType(TransformationFactory.TRAN_TYPE_SQL);
	DBMedia dbmed = new DBMedia();
	DBAccount dbac = accId != null ? (DBAccount)AddressBook.getInstance().getAccountById(accId) : null;
  RecordMask mask = null;
  CustomizationManager cuman = null;

  if(lbm != null && lbm.getId() != null){
		cuman = lbm.getCustomizationManager();
    mask = lbm.getRecordMask();
  }else{
  	errmodel.addError("Failed to fetch SQL queries");
  }
  
	int[] xpologColumnMap = null;
	StringBuffer xpologSelColsPattern = new StringBuffer();
	StringBuffer sqlSelColsPattern = new StringBuffer();
  if (xpologSelCols != null && !xpologSelCols.equals("")){
   	String[] colMapArr = xpologSelCols.split(",");
		xpologColumnMap = new int[colMapArr.length];
		xpologSelColsPattern.append('(');
		for (int i=0; i<colMapArr.length; i++) {
			xpologColumnMap[i] = Integer.parseInt(colMapArr[i]);
			if (i>0) xpologSelColsPattern.append(", ");
			xpologSelColsPattern.append("{"+colMapArr[i]+"}");
		}
		xpologSelColsPattern.append(')');
  }
	if (xpologColumnMap == null && mask != null) {
		xpologColumnMap = new int[mask.getCulomnsNumber()];
		xpologSelColsPattern.append('(');
		for (int i=0; i<mask.getCulomnsNumber(); i++) {
			int ic = cuman.getIndexFromCustomizedCol(i);
			xpologColumnMap[i] = ic;
			if (ic >= 0) {
				if (i>0) xpologSelColsPattern.append(", ");
				xpologSelColsPattern.append("{"+String.valueOf(ic)+"}");
			}
		}
		xpologSelColsPattern.append(')');
	}

	StringBuffer sb = new StringBuffer();
	String xml = "";
	String[][] dbTblDesc = null;
	int[] sqlColumnMap = (int[])request.getSession().getAttribute(SQL_SEL_COLS);
	if (!dbmed.connect(dbac)){
		errmodel.addError("Could not connect to database.");
		errmodel.addError("Please verify that the database is up and that the account settings are right");
	}
	if (errmodel.getErrorCount() > 0){
		String[] errors = errmodel.getErrors();
		for (int i=0; i<errors.length; i++){
			if (sb.length() > 0){
				sb.append("*;*");
			}
			sb.append(errors[i]);
		}
		String message = sb.toString();
		xml = GridModelActionsHelper.getResultXML(false, message);
	}else{
		dbTblDesc = dbmed.getTableDescription(tableName);
		if (dbTblDesc != null) {
			if (sqlSelCols != null && !sqlSelCols.equals("")){
				String[] colMapArr = sqlSelCols.split(",");
				sqlColumnMap = new int[colMapArr.length];
				sqlSelColsPattern.append('(');
				for (int i=0; i<colMapArr.length; i++) {
					sqlColumnMap[i] = Integer.parseInt(colMapArr[i]);
					if (i>0) sqlSelColsPattern.append(", ");
					sqlSelColsPattern.append("{"+colMapArr[i]+"}");
				}
				sqlSelColsPattern.append(')');
			}
			if (sqlColumnMap == null){
				sqlColumnMap = new int[dbTblDesc[0].length];
				sqlSelColsPattern.append('(');
				for (int i=0; i<dbTblDesc[0].length; i++) {
					sqlColumnMap[i] = i;
					if (i>0) sqlSelColsPattern.append(", ");
					sqlSelColsPattern.append("{"+String.valueOf(i)+"}");
				}
				sqlSelColsPattern.append(')');
			}
		}
		String queryPattern = "INSERT INTO {0} {1}VALUES {2}";
		String createPattern = "CREATE TABLE {0} ({2})";
		String stmtIntoColumns = "";
		if (sqlSelCols != null && dbTblDesc != null){
			stmtIntoColumns = MessageFormat.format(sqlSelColsPattern.toString(),(Object[])dbTblDesc[0]);
		}
		Object[] arrInsert = {tableNameToUse, stmtIntoColumns, xpologSelColsPattern.toString()};
		String insert = MessageFormat.format(queryPattern, arrInsert);
		DBManager dbman = new DBManager();
		dbman.setMedia(dbmed);
		dbman.setTrans(trans);
		dbman.setLogBrowsingManager(lbm);
		dbman.updateTransformer();
		String query = dbman.createInsertStatement(insert);
		String createStmt = dbman.createCreateStatement(insert);
		xml = "<root><result>true</result>";
		xml += "<tableName>" + tableNameToUse + "</tableName>";
		xml += "<insertStmt>" + query + "</insertStmt>";
		xml += "<createStmt>" + createStmt + "</createStmt>";
		xml += "</root>";
	}
	if (lbm != null){
		lbm.dispose();
	}
	
	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	//System.out.println(xml);
	out.write(xml);
	out.flush();%>
