<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.CollectionUnit"%>
<%@ page import="com.xpolog.logcollection.CollectionUnitsManager"%>
<%@ page import="com.xpolog.logcollection.LogCollectionManager"%>
<%@ page import="com.xpolog.logcollection.util.constants.Constants"%>

<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.logcollection.XpologCollectionUnitAdminRequest"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	//do whatever needed to remove the report
	String cuId = request.getParameter("cuId");
	String deleteStorageLogStr = request.getParameter("deleteStorageLog");
	boolean deleteStorageLog = deleteStorageLogStr != null && deleteStorageLogStr.equals("true");
	String deleteCollectedDataStr = request.getParameter("deleteCollectedData");
	boolean deleteCollectedData = deleteCollectedDataStr != null && deleteCollectedDataStr.equals("true");
	XpologCollectionUnitAdminRequest delRequest = new XpologCollectionUnitAdminRequest(Constants.Actions.DELETE);
	delRequest.setRemoveCollectedData(deleteCollectedData);
	delRequest.setRemoveStorageLbm(deleteStorageLog);
	boolean success = true;
	String message = "";
	if (cuId != null) {
		CollectionUnitsManager cuMgr = LogCollectionManager.getInstance().getCollectionUnitsManager();
		CollectionUnit cu = cuMgr.getCollectionUnit(cuId);;
		String name = "";
		if (cu != null) {
			name = cu.getName();
		}
		//audit
		AuditManager.getInstance().write(
				AuditConstants.BASIC_AUDIT_LEVEL, userContext,
				AuditConstants.CHANGE, "remove log collector",
				AuditConstants.LOG_COLLECTION, "remove log collector " + name);

		try {
			cuMgr.removeCollectionUnit(cuId,delRequest);
			success = true;
		} catch (Exception e) {
			ErrorModel.log.error("Failed to remove log collector " + name + " [" + cuId + "]", e);
			success = false;
			message = e.getMessage();
		}
	}else {
		message = "No log collector supplied, please try again";
	}
	String xml = GridModelActionsHelper.getResultXML(success, message);

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	
	out.write(xml);
	out.flush();
%>
