<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.admin.builders.CollectionAdapterBuilderWrapper"%>
<%@ page import="com.xpolog.logcollection.admin.builders.CollectionUnitBuilder"%>
<%@ page import="com.xpolog.logcollection.collection.CollectionHandlersManager"%>
<%@ page import="com.xpolog.logcollection.CollectionUnit"%>
<%@ page import="com.xpolog.logcollection.CollectionUnitsManager"%>
<%@ page import="com.xpolog.logcollection.LogCollectionManager"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.audit.*"%>
<%@ page import="xpolog.eye.data.util.FileFilterConfiguration"%>
<%@ page import="xpolog.eye.data.util.NameExpression"%>
<%@ page import="xpolog.eye.logcollection.adapters.DataSourceCollectionAdapter"%>
<%@ page import="xpolog.eye.logcollection.admin.builders.DefaultDSCollectionAdapterBuilder"%>
<%@ page import="xpolog.eye.logcollection.admin.builders.SshDSCollectionAdapterBuilder"%>
<%@ page import="xpolog.eye.logcollection.admin.helpers.DsColAdapterAdminHelper"%>
<%@ page import="xpolog.eye.media.Account"%>
<%@ page import="xpolog.eye.media.AddressBook"%>
<%@ page import="xpolog.eye.media.auth.AuthenticationAccount"%>
<%@ page import="xpolog.eye.media.Media"%>
<%@ page import="xpolog.eye.media.MediaManager"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.*"%>

<%@ page import="java.io.File"%>
<%@ page import="java.util.*"%>

<%!static final String BASE_DIRECTORY = "../../../";%>

<%@ include file="../fileFilterConfigurationAction.jsp"%>

<%
	String ERROR_OBJ = "ERROR_OBJ";
	String CU_ID = "CU_ID";
  String DS_TYPE = "DataSourceType";
  String BUILDER = "CURRENT_COLLECTION_UNIT_BUILDER";
  String CU_NAME = "CU_NAME";
  String CU_DESCRIPTION = "CU_DESCRIPTION";
  String LOG_LOCATION_PATH = "fullPath_";  
  String LOG_LOCATION_STATUS = "locationStatus_";    
  String LOCATIONS_CNTR = "locationCntr";
	String CA_ID = "CA_ID";
	String ACCOUNT_ID = "accountId";
	String REFRESH_RATE = "RefreshRate";
	String DOWNLOAD_FILES = "DownloadFiles";
	String AUTO_UPDATE = "AutoUpdate";
	String IS_DUPLICATE_MODE = "isDuplicateMode";
	
	File f = null;
 
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  LogCollectionManager logCollectionMgr = LogCollectionManager.getInstance();
  CollectionUnitsManager cuMgr = logCollectionMgr.getCollectionUnitsManager();
  CollectionHandlersManager chMgr = logCollectionMgr.getCollectionHandlersMgr();
 	
  String locationCntrStr = request.getParameter(LOCATIONS_CNTR);
  int locationsCntr = 0 ;
  try{
  	locationsCntr = Integer.parseInt(locationCntrStr);
  }catch(NumberFormatException e){
  	locationsCntr = 0;
  }
  String locationFullPath = "";
  String locationStatus = "";  
  NameExpression nameExpr = null;
  ArrayList nameExprList = new ArrayList();
  for(int i = 0 ; i < locationsCntr ; i++){
  	String pathParam = LOG_LOCATION_PATH + i;
  	String statusParam = LOG_LOCATION_STATUS + i;
  	locationFullPath = request.getParameter(pathParam);
  	if(locationFullPath != null && locationFullPath.length() > 0){
  		int indx = locationFullPath.lastIndexOf("/");
  		if(indx < 0){
  			indx = locationFullPath.lastIndexOf("\\");
  		}
  		String dir = locationFullPath.substring(0,indx + 1);	
  		String pattern = locationFullPath.substring(indx+1,locationFullPath.length());
  		locationStatus = request.getParameter(statusParam);
  		int dynmicState;
  		try{
  			dynmicState = (locationStatus != null && locationStatus.length() > 0) ? Integer.parseInt(locationStatus) : 0;
  		}catch(NumberFormatException e){
  			dynmicState = 0;
  	  }
  		nameExpr = new NameExpression();
  		nameExpr.setDirectory(dir);
  		nameExpr.setXpologNamePatternsStr(pattern);
  		nameExpr.setLogDynamicType(dynmicState);
  		nameExprList.add(nameExpr);
  	}
  }
	
  String cuId = request.getParameter(CU_ID);
  String caId = request.getParameter(CA_ID);
  String cuName = request.getParameter(CU_NAME);
  String cuDesc    = request.getParameter(CU_DESCRIPTION);
	ArrayList sourceList = new ArrayList();
	String aId = request.getParameter(ACCOUNT_ID);
	String refrate = request.getParameter(REFRESH_RATE);
	String downloadFilesString = request.getParameter(DOWNLOAD_FILES);
	String autoUpdateString = request.getParameter(AUTO_UPDATE);
  String isDuplicateModeStr = request.getParameter(IS_DUPLICATE_MODE);
  boolean isDuplicateMode = isDuplicateModeStr != null && isDuplicateModeStr.equals("true");
  String dynamicFiles = "on";//request.getParameter("dynamicFiles");
  String sortFilesStr = request.getParameter("sortFiles");
  boolean sortFilesByLastUpdate = true;//sortFilesStr != null && sortFilesStr.equals("byLastUpdate");
  String authAccId = request.getParameter("authAccId");
  
  String zippwd = request.getParameter("zippwd");
  String doSaveStr = request.getParameter("doSave");
  boolean doSave = doSaveStr != null && doSaveStr.length() > 0;
  
  String dsType = request.getParameter(DS_TYPE);
  
	String oldSourceListStr = request.getParameter("oldSourceList");	
	if(oldSourceListStr == null){
		oldSourceListStr = "";
	}

	//verify data
  ErrorModel errmodel = new ErrorModel();
  
  if(cuName == null || cuName.trim().equals("")){
    errmodel.addError("No name was supplied.");
  }
  if(WebUtil.isContainSpecialCharecter(cuName)){
     errmodel.addError("The following charecters are prohibited in the name field: "+WebUtil.getSpecialCharectersList());
  }
	if(nameExprList == null || nameExprList.size() == 0){
		errmodel.addError("please check log's path and pattern.");
	}
 	
	if (dsType != null && dsType.equals("ssh")){
	if (aId == null || aId.trim().equals("")) {
		errmodel.addError("No Account was supplied.");
	}
	}

	long refreshInterval = -1;
	try {
		refreshInterval = refrate == null ? -1 : Long.parseLong(refrate);
	}catch (Exception e) {
		errmodel.addError("Please supply a valid refresh rate.");
	}

	boolean downloadFiles = false;
	//if (downloadFilesString == null || !downloadFilesString.equals("true")) {
	//	downloadFiles = false;
	//}

	boolean autoUpdate = true;
	if (autoUpdateString == null || !autoUpdateString.equals("true")) {
		autoUpdate = false;
	}

	if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;

  }

	Account acc = AddressBook.getInstance().getAccountById(aId);

	FileFilterConfiguration fileFilterConfiguration = null;
	try {
		fileFilterConfiguration = createFileFilterConfiguration(request, response);
	}catch(Exception e) {
		errmodel.addError(e.getMessage());
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
	}


  CollectionUnit cu = null;
  DataSourceCollectionAdapter ca = null;
  if (cuId != null){
  	cu = cuMgr.getCollectionUnit(cuId);
  }

  CollectionUnitBuilder cuBuilder = (CollectionUnitBuilder)request.getSession().getAttribute(BUILDER);
  request.getSession().removeAttribute(BUILDER);
  if (cuBuilder == null){
  	cuBuilder = new CollectionUnitBuilder();
  }

  CollectionAdapterBuilderWrapper caBuilderWrapper = cuBuilder.getCurrentCollectionAdapterBuilderWrapper();
  SshDSCollectionAdapterBuilder caBuilder;
  if (caBuilderWrapper != null){
  	caBuilder = (SshDSCollectionAdapterBuilder)caBuilderWrapper.getBuilder();
  }else{
  	caBuilder = new SshDSCollectionAdapterBuilder(); 
  	cuBuilder.addCaBuilder(caBuilder);
    caBuilder.setDsType(dsType);
  }

  if(cu != null){
    cuBuilder.setCuID(cu.getId());
    
  }
  if (ca != null){
    caBuilder.setOnline(true);
		caBuilder.setUpdateLinesNumber(DsColAdapterAdminHelper.isUpdateLinesNumber(ca));
    caBuilder.setDataSourceFactory(DsColAdapterAdminHelper.dataSourceFactory(ca));
    caBuilder.setDynamicFiles(DsColAdapterAdminHelper.isDynamicFiles(ca));
    caBuilder.setSortByLastUpdate(DsColAdapterAdminHelper.isSortByLastUpdate(ca));
    caBuilder.setFileFilterConfiguration(fileFilterConfiguration);
		caBuilder.checkLocationsChanges(nameExprList,oldSourceListStr);
  }
  
  cuBuilder.setCuName(cuName);
  caBuilder.setNameExprList(nameExprList);
  cuBuilder.setCuDescription(cuDesc);
  caBuilder.setDynamicFiles(dynamicFiles != null && dynamicFiles.equalsIgnoreCase("on"));
  caBuilder.setSortByLastUpdate(sortFilesByLastUpdate);
  caBuilder.setFileFilterConfiguration(fileFilterConfiguration);

	Media med = MediaManager.newInstace().getMediaByAccount(acc);

	caBuilder.setMedia(med);
	caBuilder.setAccount(acc);
	if (refreshInterval != -1) {
		refreshInterval = refreshInterval * 1000 * 60;
	}
	caBuilder.setDownloadFiles(downloadFiles);
	caBuilder.setRefreshInterval(refreshInterval);
	caBuilder.setAutoUpdate(autoUpdate);
	caBuilder.setSourceLocationList(sourceList);
  
	caBuilder.setDuplicateMode(isDuplicateMode);
  
  try{
    //for configuration reasons
    cuBuilder.updateBuilder();
  }catch(Exception e){
    errmodel.addError("Building log problem,please check patterns and path again.");
    errmodel.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  
  //audit
    UserEnvironment env = UserEnvironment.getUserEnvironment(request);
    UserContext userContext = UserEnvironment.getUserContext(request);
    AuditManager auditMgr = AuditManager.getInstance();
    for(int i = 0 ;nameExprList != null &&  i < nameExprList.size() ; i++){    	
  	  auditMgr.write(AuditConstants.BASIC_AUDIT_LEVEL,
	  	userContext, AuditConstants.CHANGE, "create/edit log", AuditConstants.LOGS, "create/edit log " + cuName + " path - " + ((NameExpression)nameExprList.get(i)).getDirectory()+((NameExpression)nameExprList.get(i)).getXpologNamePatternsStr()); 
    }

  
  if (doSave){
    cuBuilder.updateBuilder();
  	cu = cuBuilder.getCu();
    cuMgr.saveCollectionUnit(cu);
    auditMgr.write(AuditConstants.BASIC_AUDIT_LEVEL,
  	userContext, AuditConstants.CHANGE, "save/edit log", AuditConstants.LOG_COLLECTION, "change the log " + cu.getName()); 
	  //env.setTempAttribute(SiteConstants.FORWARD_URL_ATTRIBUTE,"loggers/admin/logaddopok.jsp?removeLog=" + !builder.isLogCanBeUsed());
  	response.sendRedirect(BASE_DIRECTORY + "logcollection/logCollectionsView.jsp");
  	return;
  }
  
  String BASE_DIRECTORY = "../../";
  String [] pages = {"loggers/admin/logAdminGate.jsp?isPrevious=true&logType=file",
  			 "loggers/admin/logDataPattern.jsp",
  			 "loggers/admin/logFieldAdmin.jsp"};
  AdminUIController controller = new AdminUIController(pages);
  //builder.setUiController(controller);

  //request.getSession().setAttribute(MODULE_ID,modid);
  //request.getSession().setAttribute(BUILDER,builder);

  String forwardURL = request.getParameter("forwardURL");
  if (forwardURL != null && forwardURL.length() > 0){
  	String nextToken = forwardURL.indexOf("?") == -1 ? "?" : "&";
  	forwardURL = forwardURL + nextToken + "forwardURL=loggers/admin/logAdminGate.jsp";
  	response.sendRedirect(forwardURL);
  	return;
  }
  
  response.sendRedirect(BASE_DIRECTORY + controller.getForwardPage());
%>