<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.CollectionUnit"%>
<%@ page import="com.xpolog.logcollection.LogCollectionManager"%>
<%@ page import="xpolog.eye.error.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../../";
%>

<%
	String ERROR_OBJ = "ERROR_OBJ";
	ErrorModel errmodel = new ErrorModel();

	String op = request.getParameter("op");

	LogCollectionManager mgr = LogCollectionManager.getInstance();
	CollectionUnit cu = null;//mgr.getSystemMgr().getSystemSyslogCollectionUnit();

	if (cu == null) {
		errmodel.addError("No Internal Syslog Daemon is Available");
	}

	if (errmodel.getErrorCount() != 0) {
		request.getSession().setAttribute(ERROR_OBJ, errmodel);
		response.sendRedirect("../../../../common/errorpage.jsp");
		return;
	}
	
	cu.init();
	if (op != null){
		if (op.equals("start")){
			cu.start();
		}else if (op.equals("stop")){
			cu.stopAll();
			Thread.sleep(500);
		}
	}
	
	boolean isRunning = false;//mgr.getSystemMgr().isSyslogDaemonRunning();
	String syslogStatus = isRunning ? "STARTED" : "STOPPED";
	response.setContentType("text/xml");
	out.write(syslogStatus);
	out.flush();
	
%>


