<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.collection.adapters.services.syslog.kiwi.*"%>

<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.exe.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>


<%
	String scriptsOnlyStr = request.getParameter("scriptsOnly");
	boolean scriptsOnly = scriptsOnlyStr != null && scriptsOnlyStr.equals("true");
	
	String noScriptsStr = request.getParameter("noScripts");
	boolean noScripts = noScriptsStr != null && noScriptsStr.equals("true");
	
	String embeddedStr = request.getParameter("embedded");
	boolean embedded = embeddedStr != null && embeddedStr.equals("true");
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String logToFileActionLabel = request.getParameter("logToFileActionLabel");
	if (logToFileActionLabel == null || logToFileActionLabel.length() == 0){
		logToFileActionLabel = "Log To File";
	}
	String existingActionsLabel = request.getParameter("existingActionsLabel");
	if (existingActionsLabel == null || existingActionsLabel.length() == 0){
		existingActionsLabel = "Existing Batch Tasks";
	}
	
	String existingActionsNote = request.getParameter("existingActionsNote");
	if (existingActionsNote == null || existingActionsNote.length() == 0){
		existingActionsNote = "copy details from existing log to file action";
	}
	
	String logToFileActionsListStr = (String)request.getParameter("tasks");
	String[] logToFileActions = null;
	if (logToFileActionsListStr != null){
		logToFileActions = logToFileActionsListStr.split("#");
	}
	
	String onlyUpdateStr = request.getParameter("onlyUpdate");
	boolean onlyUpdate = onlyUpdateStr != null && onlyUpdateStr.equals("true");
	
	String ERROR_OBJ = "ERROR_OBJ";
	String SEQ = "seq";
	String KIWI_RULE = "KIWI_RULE";
	
	KiwiRule rule = (KiwiRule)request.getSession().getAttribute(KIWI_RULE);
	String seq = request.getParameter(SEQ);
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	String name = "";
	String logFilePath = null;
	int logFileFormat = 0;
	boolean enableLogFileRotation = false;
	int totalNumberOfLogFiles = 0;
	int maxLogFileSize = 0;
	int maxLogFileSizeUnitType = 0;
	int maxLogFileAge = 0;
	int maxLogFileAgeUnitType = 0;
	boolean rotateByFileSize = true;
	
	
	KiwiLogToFileAction action = null;
	if(seq != null){
		action = (KiwiLogToFileAction)rule.getDefaultSyslogAction(); 
	}else{
		seq = "";
	}
	if(action != null){
		name = action.getEntryName();
		logFilePath = action.getLogFilePath();
		logFileFormat = action.getLogFileFormat();
		enableLogFileRotation = action.isEnableLogFileRotation();
		totalNumberOfLogFiles = action.getTotalNumberOfLogFiles();
		maxLogFileSize = action.getMaxLogFileSize();
		maxLogFileSizeUnitType = action.getMaxLogFileSizeUnitType();
		maxLogFileAge = action.getMaxLogFileAge();
		maxLogFileAgeUnitType = action.getMaxLogFileAgeUnitType();
		rotateByFileSize = action.isRotateByFileSize();
		seq = action.getSeq();
	}
	
	HashMap lists = KiwiHelper.getListValues();
	
	String[] logFileFormats = lists != null ? (String[])lists.get(KiwiHelper.FILE_FORMAT_TYPE) : new String[0];
	String[] logFileSizeUnits = lists != null ? (String[])lists.get(KiwiHelper.FILE_SIZE_TYPE) : new String[0];
	String[] logFileAgeUnits = lists != null ? (String[])lists.get(KiwiHelper.FILE_AGE_TYPE) : new String[0];
	
%>

<%if (!embedded){%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<%} %>

<%if (!noScripts){%>
<script>
	function doSave(){
		document.access.action ="logToFileAction.jsp";
		document.access.submit();
	}
</script>
<%}%>
<%if (!embedded){%>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<%}%>
<%if (!scriptsOnly){%>
<%if (!onlyUpdate){%>
<input type="hidden" name="actionSeq<%=suffix%>" size="50" value="<%=seq%>">
<%}%>
<%if (!onlyUpdate){%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
		<td id="taskDescriptionTD<%=suffix%>">
<%}%>  
		<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
			<%if (!embedded){%>
			<tr>
				<td style="padding-bottom:10;"><span class="REGULARTEXT"><%=logToFileActionLabel%></span></td>
			</tr>
			<%}%>
			<%if (logToFileActions != null){%>
			<tr>
				<td>
					<span class="REGULARTEXT">
						<%=existingActionsLabel%>: 
						<select id="logToFileActions" name="logToFileActions" onChange="updateFromLogToFileAction()">
							<option value="">-- Select Log To File Action --</option>
							<%
							String t,tSeq,tName;
							int ind;
							for (int i=0; i<logToFileActions.length; i++){
								t = logToFileActions[i];
								ind = t.indexOf("^");
								if (ind != -1){
									tSeq = t.substring(0,ind);
									tName = t.substring(ind+1);
								}else{
									continue;
								}
							%>
							<option value="<%=tSeq%>"><%=tName%></option>
							<%}%>
						</select>
					</span>
				</td>
			</tr>
			<tr>
				<td style="padding-bottom:10;"><span class="SMALLTEXT"><%=existingActionsNote%></span></td>
			</tr>
			<%} %>

 			<tr>
				<td style="padding-top:10;padding-bottom:10;padding-left:30px;background-color:#E4E4E4">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" >
					<tr>
						<td>
							<span class="REGULARTEXT">Log To File Details</span>
						</td>
					</tr>
					<tr>
						<td style="padding-top:15px">
							<table border="0" cellpadding="0" cellspacing="0" width="100%" >
								<tr>
									<td width="100" nowrap><span class="REGULARTEXT">Name</span></td>
									<td width="*">
										<input class="TEXTBOX" type="text" name="name<%=suffix%>" size="50" value="<%=name%>">
									</td>
								</tr>
								<tr>
									<td nowrap><span class="REGULARTEXT">Path and File Name of Log File</span></td>
									<td>
										<input type="TEXT" class="TEXTBOX" name="logFilePath<%=suffix%>" id="logFilePath<%=suffix%>" onKeyPress="javascript:doOpenKiwiBrowser('logFilePath','<%=suffix%>',event);" size="50" value="<%=logFilePath != null ? logFilePath : ""%>" onClick="javascript:clearBgColor('logFilePath');">
										<span style="padding-left:5"><input type=button value="Browse" onClick="openKiwiBrowser('logFilePath','<%=suffix%>')">
									</td>
								</tr>
								<tr>
									<td><span class="REGULARTEXT">Log File Format</span></td>
									<td>
										<select class="TEXTBOX" name="logFileFormat<%=suffix%>">
											<%
											for (int i=0; i<logFileFormats.length; i++){
												String selected = "";
												if (i == logFileFormat){
													selected = "selected";
												}
											%>
												<option value="<%=i%>" ><%=logFileFormats[i]%></option>
											<%}%>
										</select>
									</td>
								</tr>
								<tr style="padding-top:10px">
									<td colspan="2"><span class="REGULARTEXT"><b>Log File Rotation</b></span></td>
								</tr>
								<tr>
									<td colspan="2">
										<input type="checkbox" name="enableRotation<%=suffix%>" <%=enableLogFileRotation ? "checked" : "" %> value="true">
										<span class="REGULARTEXT" style="padding-left:3px">Enable Log File Rotation</span>
									</td>
								</tr>
								<tr>
									<td><span class="REGULARTEXT">Total Number of Log Files</span></td>
									<td><input type="text" name="totalNumberOfLogFiles<%=suffix%>" size="5" value="<%=totalNumberOfLogFiles > 0 ? String.valueOf(totalNumberOfLogFiles) : ""%>"></td>
								</tr>
								<tr>
									<td>
										<input type="radio" name="maximumType<%=suffix%>" value="size" <%=rotateByFileSize ? "checked" : ""%>>
										<span class="REGULARTEXT" style="padding-left:3px">Maximum Log File Size </span>
									</td>
									<td>
										<input type="text" name="maxLogFileSize<%=suffix%>" size="5" value="<%=maxLogFileSize > 0 ? String.valueOf(maxLogFileSize) : ""%>">
										<select name="maxLogFileSizeUnit<%=suffix%>" class="TEXTBOX">
										<%
										for (int i=0; i<logFileSizeUnits.length; i++){
											String selected = "";
											if (i == maxLogFileSizeUnitType){
												selected = "selected";
											}
										%>
											<option value="<%=i%>" <%=selected%>><%=logFileSizeUnits[i]%></option> 
										<%}%>
										</select>
									</td>
								</tr>
								<tr>
									<td>
										<input type="radio" name="maximumType<%=suffix%>" value="age" <%=!rotateByFileSize ? "checked" : "" %>>
										<span class="REGULARTEXT" style="padding-left:3px">Maximum Log File Age </span>
									</td>
									<td>
										<input type="text" name="maxLogFileAge<%=suffix%>" size="5" value="<%=maxLogFileAge > 0 ? String.valueOf(maxLogFileAge) : ""%>">
										<select name="maxLogFileAgeUnit<%=suffix%>" class="TEXTBOX">
										<%
										for (int i=0; i<logFileAgeUnits.length; i++){
											String selected = "";
											if (i == maxLogFileAgeUnitType){
												selected = "selected";
											}
										%>
											<option value="<%=i%>" <%=selected%>><%=logFileAgeUnits[i]%></option> 
										<%}%>
										</select>
									</td>
								</tr>
							</table>
						</td>
					</tr>
					<%if (!embedded){ %>
					<tr>
						<td>
						<table border="0" cellpadding="0" cellspacing="0" width="101%" >
							<tr>
								<td width="25%">&nbsp;</td>
								<td width="13%">
								<p align="center">&nbsp;</td>
								<td width="11%"><a href="javascript:history.go(-1)" class="LINK">cancel</a></td>
								<td width="11%"><a href="javascript:doSave()" class="LINK">save</a></td>
								<td width="35%">&nbsp;</td>
							</tr>
						</table>
						</td>
					</tr>
					<%} %>
				</table>
				</td>
			</tr>
		</table>
<%if (!onlyUpdate){%>
		</td>
	</tr>
	<tr height="100%">
		<td>&nbsp;</td>
	</tr>
</table>
<%}%>
<%}%>
<%if (!embedded){%>
</form>
</body>
</html>
<%}%>