<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.collection.adapters.services.syslog.kiwi.*"%>

<%@ page import="xpolog.eye.error.ErrorModel"%>

<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	String KIWI_RULE = "KIWI_RULE";

	KiwiRule rule = (KiwiRule)request.getSession().getAttribute(KIWI_RULE);
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String prefix = request.getParameter("prefix");
	if (prefix == null){
		prefix = "";
	}
	
	String actionType = request.getParameter("actionType");
	
	ErrorModel errModel = new ErrorModel();
	KiwiAction action = null;
	if (actionType != null && actionType.equals("LogToFile")){
		action = KiwiHelper.createLogToFileAction(request,errModel);
	}
	
	String resultStr = "";
	if (action == null){
		if (errModel.getErrorCount() > 0){
			StringBuffer errBuffer = new StringBuffer();
			String[] errors = errModel.getErrors();
			for (int i=0; i<errors.length; i++){
				if (errBuffer.length() > 0){
					errBuffer.append("#");
				}
				errBuffer.append(errors[i]);
			}
			resultStr = "SAVE_RULE_ACTION_ERROR#" + errBuffer.toString();
		}else{
			resultStr = "SAVE_RULE_ACTION_ERROR#Failed to save rule action";
		}
	}else{
		rule.addAction(action);
		resultStr = action.getEntryName() + "*" + action.getSeq();
	}
	
	response.setContentType("text/xml");
	out.write(resultStr.trim());
	out.flush();
%>