<%@ page language="java"%>

<%@ page import="xpolog.eye.media.Account"%>
<%@ page import="xpolog.eye.media.AddressBook"%>

<%@ page import="com.xpolog.logcollection.collection.adapters.services.ServiceConfiguration"%>
<%@ page import="com.xpolog.logcollection.collection.adapters.services.syslog.SyslogConfData"%>
<%@ page import="com.xpolog.logcollection.collection.adapters.services.syslog.SyslogsManager"%>
<%@ page import="com.xpolog.logcollection.collection.adapters.services.syslog.syslogd.SyslogdHelper"%>
<%@ page import="com.xpolog.logcollection.locations.files.FileLocationInfo"%>
<%@ page import="com.xpolog.logcollection.locations.LocationInfo"%>
<%@ page import="com.xpolog.logcollection.locations.ssh.SSHLocationInfo"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
	String baseDirectory = request.getParameter(BASE_DIRECTORY);
	if(baseDirectory == null){
		baseDirectory = "../../../";
	}
	String accountId = request.getParameter("accountId");
	String syslogId = request.getParameter("syslogId");
	
	String headerTitle = "Add Syslog Collector";
	
	if (syslogId == null){
		syslogId = "";
	}else{
		request.getSession().setAttribute("syslogId",syslogId);
	}
	
	SyslogConfData confData = null;//syslogConf != null ? syslogConf.getSyslogConfData() : null;
	if (confData != null){
		request.getSession().setAttribute("SyslogConfData",confData);
	}
	
	Account account = accountId != null ? AddressBook.getInstance().getAccountById(accountId) : null;
	//String runCommand = "";
	String confPath = "";
	//SyslogConfData confData = null;
	if (false && account != null){
		SSHLocationInfo location = new SSHLocationInfo();
		location.setAccount(account);
		ServiceConfiguration syslogConfig = SyslogdHelper.getSyslogConfiguration(location);
		if (syslogConfig != null){
			confData = (SyslogConfData)syslogConfig.getConfData();
			if (confData != null){
				request.getSession().setAttribute("SyslogConfData",confData);
			}
			//runCommand = syslogConf.getRunCommand();
			LocationInfo confLocation = syslogConfig.getConfLocation();
			if (confLocation != null && confLocation instanceof FileLocationInfo){
				FileLocationInfo fli = (FileLocationInfo)confLocation;
				confPath = fli.getPath();
			}
		}
	}
	boolean canEditSelectors = false;
	if (accountId == null){
		accountId = "";
	}
%>
<table border="0" cellspacing="0" cellpadding="0" width="99%" height="100%">
	<%if (SyslogsManager.getInstance().hasSyslogWritePermissions()){%>
	<tr height="10">
		<td style="padding-top:10px">
		<table border="0" width="" cellspacing="0" width="100%" height="100%" cellpadding="0">
			<tr>
				<td>
					<jsp:include page="../../../common/ctrlButton.jsp" flush="true">
					<jsp:param name="base_directory" value="<%=baseDirectory%>"/>
					<jsp:param name="name" value="Create New Rule"/>
					<jsp:param name="action" value="javascript:addSyslogRule()"/> 
					<jsp:param name="buttonClass" value="BUTTON"/>
					</jsp:include>			
				</td>
				<td width="100%">
				<table border="0" width="100%" cellspacing="0" cellpadding="0">
					<tr>
						<td align="right">
							<a href="javascript:editRule()" class="BUTTON_MEDIUMLINK">edit</a>
							<a href="javascript:deleteRule('<%=syslogId%>')" class="BUTTON_MEDIUMLINK">remove</a>
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
	<%}%>
	<tr>
		<td style="padding-top:5">
			<jsp:include page="../../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
				<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
				<jsp:param name="initXML" value="logcollection/admin/syslog/syslogCollectionAdminXML.jsp?syslogId=<%=syslogId%>" />
				<jsp:param name="suffix" value="SyslogConfEntries" />
				<jsp:param name="noScripts" value="true" />
				<jsp:param name="recordsText" value="Syslog Rules" />
			</jsp:include>
		</td>
	</tr>
</table>

