<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.data.writers.SshPacketWriter"%>
<%@ page import="com.xpolog.logcollection.locations.files.FileLocationInfo"%>
<%@ page import="com.xpolog.logcollection.locations.files.patterns.DatePattern"%>
<%@ page import="com.xpolog.logcollection.locations.files.patterns.FileNamePattern"%>
<%@ page import="com.xpolog.logcollection.locations.files.patterns.FileSeqIdPattern"%>
<%@ page import="com.xpolog.logcollection.locations.LocationInfoConstraints"%>
<%@ page import="com.xpolog.logcollection.util.constants.Constants"%>

<%@ page import="xpolog.eye.media.Account"%>
<%@ page import="xpolog.eye.media.telsh.TelnetAccount"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.tools.XpologSystemInfo"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	String type = request.getParameter("type");
	if (type == null){
		type = "";
	}
	String writerType = null;
	if (writerType != null){
		suffix += writerType;
	}

	String prefix = request.getParameter("prefix");
	if (prefix == null){
		prefix = suffix;
	}else{
		prefix += writerType;
	}
	
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = BASE_DIRECTORY;
	}
	
		
	String locationIndexStr = request.getParameter("locationIndex");
	int locationIndex = 0;
	if (locationIndexStr != null && locationIndexStr.length() > 0){
		locationIndex = Integer.parseInt(locationIndexStr);
	}
	String collectionSettingsDesc = request.getParameter("collectionSettingsDesc");
	if (collectionSettingsDesc == null || collectionSettingsDesc.length() == 0){
		collectionSettingsDesc = "Collection Settings";
	}
	String targetFileDirDesc = request.getParameter("targetFileDirDesc");
	if (targetFileDirDesc == null || targetFileDirDesc.length() == 0){
		targetFileDirDesc = "Target Directory";
	}
	String locationInfoId = request.getParameter("locationInfoId");
	String showConstraintsStr = request.getParameter("showConstraints");
	boolean showConstraints = showConstraintsStr != null && showConstraintsStr.equals("true");
	String defaultLocationInfoId = request.getParameter("defaultLocationInfoId");
	String showDefaultStr = request.getParameter("showDefault");
	boolean showDefault = showDefaultStr != null && showDefaultStr.equals("true");
	String showCheckBoxStr = request.getParameter("showCheckBox");
	boolean showCheckBox = showCheckBoxStr != null && showCheckBoxStr.equals("true");
	String checkBoxDesc = request.getParameter("checkBoxDesc");
	if (checkBoxDesc == null || checkBoxDesc.length() == 0){
		checkBoxDesc = "Write to file";
	}
	String activeStr = request.getParameter("active");
	boolean active = activeStr != null && activeStr.equals("true");
	
	String targetId = request.getParameter("targetId");
	
	String scriptsOnlyStr = request.getParameter("scriptsOnly");
	boolean scriptsOnly = scriptsOnlyStr != null && scriptsOnlyStr.equals("true");
	
	String noScriptsStr = request.getParameter("noScripts");
	boolean noScripts = noScriptsStr != null && noScriptsStr.equals("true");
	
	FileLocationInfo fli = null;
	FileLocationInfo dfli = null;
	LocationInfoConstraints constraints = null;
	boolean useDefault = true;
	if (locationInfoId != null && locationInfoId.length() > 0){
		fli = (FileLocationInfo)request.getAttribute(locationInfoId);
		if (fli != null){
			fli = (FileLocationInfo)fli.clone();
			fli.init();
			String fliPath = fli.getPath(false,false); 
			useDefault = fliPath == null || fliPath.equals(FileLocationInfo.DEFAULT_COLLECTION_PATH);
			constraints = fli.getConstraints();
		}
		request.getSession().removeAttribute(locationInfoId);
	}
	
	Account defaultAcc = null;
	String defaultLocPath = null;
	if (/*showDefault && */defaultLocationInfoId != null && defaultLocationInfoId.length() > 0){
		dfli = (FileLocationInfo)request.getAttribute(defaultLocationInfoId);
		if (dfli != null){
			dfli = (FileLocationInfo)dfli.clone();
			dfli.init();
			defaultLocPath = dfli.getPath(false,false);
			defaultAcc = dfli.getAccount();
		}
		//if (fli == null){
		//	fli = dfli;
		//}
		request.getSession().removeAttribute(defaultLocationInfoId);
		//constraints = dfli.getConstraints();
	}
	
	if (locationInfoId == null){
		locationInfoId = "";
	}
	
  String displayAccDiv = "none";
  String displayLocationsDiv = "none";
  int locationsCntr = 1;
  String locationDesc = "Checksum Directory";
  String locationsPathsStr = "";
	String displayDefaultLocationDiv = "none";

	Account acc = null;
	String accId = "";
	String path = "";
	String fileNamePattern = "";
	String fileNamePatternSuffix = "";
	boolean useFileNamePattern = true;
	boolean useDatePattern = false;
	boolean useSeqPattern = false;
	boolean compress = false;
	int[] sizeUnits = Constants.InformationUnits.getInformationUnits();
	long maxSize = constraints != null ? constraints.getMaxSize() : -1;
	int sizeUnit = constraints != null ? constraints.getSizeType() : -1;
	double maxPercent = constraints != null ? constraints.getMaxPercent() : -1;
	if (fli != null){
		path = fli.getPath(false,false);
		displayLocationsDiv = "";
		fileNamePattern = fli.getFileNamePattern();
		fileNamePatternSuffix = fli.getFilePatternSuffix();
		useDatePattern = fli.hasPatternFromType(DatePattern.DATE_PATTERN_TYPE);
		useSeqPattern = fli.hasPatternFromType(FileSeqIdPattern.FILE_SEQ_ID_PATTERN_TYPE);
		useFileNamePattern = fli.hasPatternFromType(FileNamePattern.FILE_NAME_PATTERN_TYPE);
		compress = fli.isCompress();
		acc = fli.getAccount();
		if (acc != null){
			accId = acc.getId();
			displayAccDiv = "";
		}
	}
	if (path == null || path.equals(FileLocationInfo.DEFAULT_COLLECTION_PATH)){
		path = "";
	}
	if (path != null){
		locationsPathsStr = path;
	}
	if (fileNamePattern == null){
		fileNamePattern = "";
	}
	String maxSizeStr = maxSize > 0 ? String.valueOf(maxSize) : "";
	String maxPercentStr = maxPercent > 0 ? String.valueOf(maxPercent) : "";
	String datePatternChecked = useDatePattern ? "checked" : "";
	String seqPatternChecked = useSeqPattern ? "checked" : "";
	String namePatternChecked = useFileNamePattern ? "checked" : "";
	String compressChecked = compress ? "checked" : "";
	String activeChecked = active ? "checked" : "";
	String divStyle = active ? "" : "style=\"display:none;\"";
	
  UserContext userContext = UserEnvironment.getUserContext(request);
  String accountsListId = type != null && type.length() > 0 ? prefix + "AccountsList" : "";
  String locationType = "";
  if (acc != null){
  	locationType = acc.getType();
  }else if (path != null && path.length() > 0){
  	locationType = "local";
  }else{
  	displayDefaultLocationDiv = "";
  }
  if (locationType != null && locationType.equals("winAuthentication")){
  	locationType = "auth";
  }
  

%>

<%if (!noScripts){%>
<script>
var BASE_DIRECTORY = "<%=baseDirectory%>";
var CHECKSUM_PREFIX = "<%=prefix%>";
var LOCATIONS_CNTR = <%=locationsCntr%>;
var ON_CHANGE_ACTION = "updateHostFromAccount()";
var DISPLAY_ACCOUNTS_DIV = "<%=displayAccDiv%>";
var ACCOUNT_ID = "<%=accId == null && accId.length() > 0 ? "" : accId %>";

	function initChecksumLocation() {
		if(DISPLAY_ACCOUNTS_DIV == '' && ACCOUNT_ID == '') {
			changeChecksumLocationType(CHECKSUM_PREFIX,CHECKSUM_PREFIX + 'LogType',BASE_DIRECTORY)
		}
	}


	function showHideFileLocationInfoDiv(cb,divid){
		var d = document.getElementById(divid);
		if (divid && cb){
			if (cb.checked == true){
				d.style.display = "";
			}else{
				d.style.display = "none";
			}
		}
	}

	function openNewLocationAccountDiv(){
		openNewAccDiv('addAccDiv','ssh','','new','<%=prefix%>AccountsList','<%=baseDirectory%>');
	}

	function updateHostFromPath(){
		var p = eval("document.access." + CHECKSUM_PREFIX + "fullPath_0").value;
		if (p && p.indexOf("\\\\") == 0){
			s = p.substr(2);
			var endIndex1 = s.indexOf("\\");
			var endIndex2 = p.indexOf("/");
			var endIndex = 0;
			if (endIndex1 != -1 || endIndex2 != -1){
				if (endIndex1 != -1 && (endIndex2 < 0 || endIndex1+2 < endIndex2)){
					endIndex = endIndex1 + 2;
				}else{
					endIndex = endIndex2;
				}
				if (endIndex > 0){
					document.access.host.value = p.substring(2,endIndex);
				}
			}
		}else if(p == ""){
			document.access.host.value = "";
		}
	}
	
	function updateHostFromAccount(){
		var accountsList = document.getElementById(CHECKSUM_PREFIX+"AccountsList");
		if(accountsList) {
			var accountId = accountsList.options[accountsList.selectedIndex].value;
			document.getElementById('resultFrame').src="getHostNameAction.jsp?accountId="+accountId;
		}
	}
	
	function handleNewAcc(accId){
	  document.getElementById('resultFrame').src="getHostNameAction.jsp?accountId="+accId;
  }
	
	function updateHostName(hostName)	{
		document.access.host.value = hostName;
	}


</script>
<%}%>

<%if (!scriptsOnly){%>
<%if (targetId != null && targetId.length() > 0){%>
<input type="hidden" name="fileLocationTarget_<%=suffix%>" value="<%=targetId%>">
<%}%>
<%if (writerType != null && writerType.length() > 0){%>
<input type="hidden" name="LogType_<%=suffix%>" value="<%=writerType%>">
<%}%>
<input type="hidden" name="rootDir" id="rootDir">
<input type="hidden" name="host" id="host">
<input type="hidden" name="prefix" id="prefix" value="<%=prefix%>">
<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
	<%if (false && showDefault){%>
	<tr>
		<td>
		<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
			<%if (showCheckBox){%>
			<tr>
				<td style="padding-top:10px">
					<input type="hidden" name="fileLocationInfoCheckBox_<%=suffix%>" id="fileLocationInfoCheckBox_<%=suffix%>" value="true">
					<input type="checkbox" name="useFileLocationInfo_<%=suffix%>" id="useFileLocationInfo_<%=suffix%>" <%=activeChecked%> value="true" onclick="javascript:showHideChecksumFileLocationInfoDiv(this,'FileLocationInfoDiv_<%=suffix%>')">
				</td>
				<td style="padding-top:10px;padding-left:3px" width="100%">
					<span class="REGULARTEXT"><b><%=checkBoxDesc%></b></span>
				</td>
			</tr>
			<%}%>
			<%if (showCheckBox){%>
			<tr>
				<td>&nbsp;</td>
				<td>
				<div id="fileLocationInfoDiv_<%=suffix%>" <%=divStyle%>>
				<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
			<%}%>
			<tr>
				<td colspan="2" style="padding-top:5px;padding-left:5px">
					<span class="REGULARTEXT"><%=showCheckBox?"":"<b>"%><%=targetFileDirDesc%>:<%=showCheckBox?"":"</b>"%></span>
				</td>
			</tr>
			<tr>
				<td style="padding-top:5px"><input type="radio" name="infoType_<%=suffix%>" id="infoType_<%=suffix%>" value="default" <%=useDefault ? "checked" : ""%>></td>
				<td style="padding-top:5px">
					<%
					String defaultLocation = defaultLocPath != null ? defaultLocPath : null;
					if (defaultLocation != null && defaultAcc != null){
						String host = defaultAcc.getHost();
						if (host != null && host.length() > 0){
							defaultLocation = defaultLocation + "@" + host;
						}
					}
					%>
					<span class="REGULARTEXT">Default <%=defaultLocation != null ? "(" + defaultLocation + ")" : ""%></span>
				</td>
			</tr>

			<tr>
				<td><span class="REGULARTEXT"><nobr>Checksum File Location:&nbsp;</nobr></span></td>
				<td width="100%">
					<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
						<tr>
							<td>
								<select class="TEXTBOX" id="<%=prefix%>LogType" name="<%=prefix%>LogType" onChange="javascript:changeChecksumLocationType('<%=prefix %>',this.name,'<%=BASE_DIRECTORY%>');">
									<option value="none" <%=locationType.equals("none") ? "selected" : "" %>>-- Select Location --</option>														
									<option value="local" <%=locationType.equals("local") ? "selected" : "" %>>Local</option>
									<%if (XpologSystemInfo.isWindows()){%>														
									<option value="auth" <%=locationType.equals("auth") ? "selected" : "" %>>Windows Network</option>
									<%}%>
									<option value="ssh" <%=locationType.equals("ssh") ? "selected" : "" %>>Over SSH</option>
									
								</select>			
							</td>
						</tr>																																															
					</table>
				</td>
			</tr>

			<!--  Account Start -->
			<tr>
				<td colspan="2" width="100%" style="padding-top:5px">
					<div id="<%=prefix%>accountDiv" style="display:<%=displayAccDiv %>"> 			                   
					<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse">                                        
						<tr>
							<td width="25%"><span class="REGULARTEXT">Connection Details: </span></td>
							<td width="100px" style="padding-left:3px">
								<div id="<%=prefix%>accountsListDiv" style="display">
									<%
									String accountsListComboUrl = baseDirectory + "common/accountsListCombo.jsp";
									%>
									<jsp:include flush="true" page="<%=accountsListComboUrl%>">
										<jsp:param name="ACC_TYPE" value="<%=locationType%>"/>
										<jsp:param name="ACC_ID" value="<%=accId%>"/>
										<jsp:param name="CHANGE_ACC_SELECTION" value="false"/>
										<jsp:param name="ON_CHANGE_ACTION" value="updateHostFromAccount()"/>
										<jsp:param name="PREFIX" value="<%=prefix%>"/>
									</jsp:include> 																								
								</div>
							</td>
							<%if (userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){%>
					    <td width="6">&nbsp;</td>
							<td style="padding-left:5">
								<div id="<%=prefix%>newAccountDiv">
									<span class="SMALLTEXT"><a href="javascript:openNewLocationAccountDiv('<%=baseDirectory%>')" class="BUTTON_MEDIUMLINK">new</a></span>
								</div>	
							</td>
							<%} %>
							<td width="*">&nbsp;</td>
						</tr>
						<tr>
							<td width="23%" style="font-size:1px">&nbsp;</td>
							<td colspan="4">
								<div id="<%=prefix%>AccountIdErrorMsg" style="display:none;" class="ERROR_MSG">
							</div>
							</td>
						</tr>																																																																																																				
					</table>
					</div>  
				</td>
			</tr>
			<!-- Account end -->
			<tr>
				<td><input type="radio" name="infoType_<%=suffix%>" id="infoType_<%=suffix%>" value="manual" <%=!useDefault ? "checked" : ""%>></td>
				<td>
					<span class="REGULARTEXT">Custom </span>
					<input type="text" class="TEXTBOX" name="fullPath_<%=suffix%>" id="fullPath_<%=suffix%>" 
					onKeyPress="javascript:doOpenBrowser('fullPath_<%=locationIndex%>','<%=locationIndex%>',event);" onClick="clearBgColor('fullPath_<%=suffix%>');selectManual('<%=suffix%>')" onChange="javascript:clearErr('<%=suffix%>')" size="75" value="<%=path%>">
					<input type="button" id="fileBrowseButton_<%=suffix%>" value="Browse" style="padding-left:5px"  onClick="openBrowser('fullPath_<%=suffix%>','<%=accountsListId%>')">
				</td>
			</tr>
			<tr id="fullPath_<%=suffix%>ErrorMsgTR" style="display:none">
				<td>&nbsp;</td>
				<td>
					<div id="fullPath_<%=suffix%>ErrorMsg" class="ERROR_MSG">
					</div>
				</td>
			</tr>
			<%if (showCheckBox){%>
				</table>
				</div>
				</td>
			</tr>
			<%}%>
			
		</table>
		</td>
	</tr>
	<%}else{ // do not show default%>
	<%if (showCheckBox){%>
	<tr>
		<td style="padding-top:10px">
			<input type="hidden" name="fileLocationInfoCheckBox_<%=suffix%>" id="fileLocationInfoCheckBox_<%=suffix%>" value="true">
			<input type="checkbox" name="useFileLocationInfo_<%=suffix%>" id="useFileLocationInfo_<%=suffix%>" <%=activeChecked%> value="true" onclick="javascript:showHideChecksumFileLocationInfoDiv(this,'fileLocationInfoDiv_<%=suffix%>')">
		</td>
		<td style="padding-top:10px;padding-left:3px" width="100%">
			<span class="REGULARTEXT"><b><%=checkBoxDesc%></b></span>
		</td>
	</tr>
	<%}%>
	<%if (showCheckBox){%>
	<tr>
		<td>&nbsp;</td>
		<td>
		<div id="fileLocationInfoDiv_<%=suffix%>" <%=divStyle%>>
		<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
	<%}%>
	
			<tr>
				<td><span class="REGULARTEXT"><nobr>Checksum File Location:&nbsp;</nobr></span></td>
				<td width="100%">
					<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
						<tr>
							<td>
								<select class="TEXTBOX" id="<%=prefix%>LogType" name="<%=prefix%>LogType" onChange="javascript:changeChecksumLocationType('<%=prefix %>',this.name,'<%=baseDirectory%>');">
									<option value="none" <%=locationType.equals("none") ? "selected" : "" %>>Default Storage Path</option>														
									<option value="local" <%=locationType.equals("local") ? "selected" : "" %>>Local</option>
									<%if (XpologSystemInfo.isWindows()){%>														
									<option value="auth" <%=locationType.equals("auth") ? "selected" : "" %>>Windows Network</option>
									<%}%>
									<option value="ssh" <%=locationType.equals("ssh") ? "selected" : "" %>>Over SSH</option>
								</select>			
							</td>
							<td id="<%=prefix%>defaultLocation" width="100%" style="padding-left:5px;display:<%=displayDefaultLocationDiv%>">
							<%
							String defaultLocation = defaultLocPath != null ? defaultLocPath : null;
							if (defaultLocation != null && defaultAcc != null){
								String host = defaultAcc.getHost();
								if (host != null && host.length() > 0){
									defaultLocation = defaultLocation + "@" + host;
								}
							}
							%>
								<span class="REGULARTEXT"><%=defaultLocation != null ? "(" + defaultLocation + ")" : "&nbsp;"%></span>
							</td>
						</tr>																																															
					</table>
				</td>
			</tr>
	
	
	<!--  Account Start -->
	<tr>
		<td colspan="2" width="100%" style="padding-top:5px">
			<div id="<%=prefix%>accountDiv" style="display:<%=displayAccDiv %>"> 			                   
			<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse">                                        
				<tr>
					<td width="25%"><span class="REGULARTEXT">Connection Details: </span></td>
					<td width="100px" style="padding-left:3px">
						<div id="<%=prefix%>accountsListDiv" style="display">
							<%
							String accountsListComboUrl = baseDirectory + "common/accountsListCombo.jsp";
							%>
							<jsp:include flush="true" page="../../common/accountsListCombo.jsp">
								<jsp:param name="ACC_TYPE" value="<%=locationType%>"/>
								<jsp:param name="ACC_ID" value="<%=accId%>"/>
								<jsp:param name="CHANGE_ACC_SELECTION" value="false"/>
								<jsp:param name="ON_CHANGE_ACTION" value="updateHostFromAccount()"/>
								<jsp:param name="PREFIX" value="<%=prefix%>"/>
							</jsp:include> 																								
						</div>
					</td>
					<%if (userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){%>
			    <td width="6">&nbsp;</td>
					<td style="padding-left:5">
						<div id="<%=prefix%>newAccountDiv">
							<span class="SMALLTEXT"><a href="javascript:openNewChecksumLocationAccountDiv('<%=prefix%>','<%=baseDirectory%>')" class="BUTTON_MEDIUMLINK">new</a></span>
						</div>	
					</td>
					<%} %>
					<td width="*">&nbsp;</td>
				</tr>
				<tr>
					<td width="23%" style="font-size:1px">&nbsp;</td>
					<td colspan="4">
						<div id="<%=prefix%>AccountIdErrorMsg" style="display:none;" class="ERROR_MSG">
					</div>
					</td>
				</tr>																																																																																																				
			</table>
			</div>  
		</td>
	</tr>
	<!-- Account end -->
	<tr>
		<td colspan="2" style="padding-top:5px">
			<div id="<%=prefix%>locationPathsDiv" style="display:<%=displayLocationsDiv%>"> 
				<jsp:include flush="true" page="checksumLocationPath.jsp">
					<jsp:param name="baseDirectory" value="" />
					<jsp:param name="LOCATIONS_CNTR" value="<%=locationsCntr%>"/>
					<jsp:param name="LOCATION_DESC0" value="<%=locationDesc%>"/>
					<jsp:param name="LOCATIONS_PATH_ARR" value="<%=locationsPathsStr%>"/>
					<jsp:param name="PREFIX" value="<%=prefix%>"/>										
				</jsp:include>	                      
			</div>
		</td>
	</tr>
	
	<%if (showCheckBox){%>
		</table>
		</div>
		</td>
	</tr>
	<%}%>
	
	<%}%>
</table>
<%}%>