<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.collection.adapters.ReaderAdapter"%>
<%@ page import="com.xpolog.logcollection.collection.CollectionAdapter"%>
<%@ page import="com.xpolog.logcollection.collection.CollectionHandler"%>
<%@ page import="com.xpolog.logcollection.collection.CollectionHandlersManager"%>
<%@ page import="com.xpolog.logcollection.data.writers.FilePacketWriter"%>
<%@ page import="com.xpolog.logcollection.data.writers.PacketWriter"%>
<%@ page import="com.xpolog.logcollection.locations.files.FileLocationInfo"%>
<%@ page import="com.xpolog.logcollection.LogCollectionManager"%>
<%@ page import="com.xpolog.logcollection.system.LogCollectionSystemManager"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
	String systemStr = request.getParameter("system");
	boolean isSystem = systemStr != null && systemStr.equals("true");
	String chId = request.getParameter("chId");
	String caId = request.getParameter("caId");
	String writerId = request.getParameter("writerId");
	String locationIndexStr = request.getParameter("locationIndex");
	int locationIndex = 0;
	if (locationIndexStr != null && locationIndexStr.length() > 0){
		locationIndex = Integer.parseInt(locationIndexStr);
	}
	
	PacketWriter pw = null;
	if (isSystem){
		if (writerId != null){
			LogCollectionSystemManager mgr = LogCollectionManager.getInstance().getSystemMgr();
			if (mgr != null){
				pw = mgr.getPacketWriter(writerId);
			}
		}
	}else if (chId != null && chId.length() > 0 && caId != null && caId.length() > 0 &&
			writerId != null && writerId.length() > 0){
		CollectionHandlersManager chMgr = LogCollectionManager.getInstance().getCollectionHandlersMgr();
		CollectionHandler ch = chMgr.getCollectionHandler(chId);
		if (ch != null){
			CollectionAdapter ca = ch.getCollectionAdapterById(caId);
			if (ca != null && ca instanceof ReaderAdapter){
				pw = ((ReaderAdapter)ca).getWriterById(writerId);
			}
		}
	}
	
	FilePacketWriter fpw = null;
	if (pw != null && pw instanceof FilePacketWriter){
		fpw = (FilePacketWriter)pw;
	}
	
	FileLocationInfo fli = fpw != null ? fpw.getFileLocationInfo() : null;
	String path = "";
	String fileNamePattern = "";
	if (fli != null){
		path = fli.getPath();
		fileNamePattern = fli.getFileNamePattern();
	}
	if (path == null){
		path = "";
	}
	if (fileNamePattern == null){
		fileNamePattern = "";
	}
%>

<table>
	<tr>
		<td>
			<span class="REGULARTEXT">Target Files Directory: </span>
		</td>
		<td>
			<input type="TEXTBOX" class="TEXTBOX" name="fullPath_<%=locationIndex%>" id="fullPath_<%=locationIndex%>" onKeyPress="javascript:doOpenBrowser('fullPath_<%=locationIndex%>','<%=locationIndex%>',event);"size="75" value="<%=path%>" onClick="javascript:clearBgColor('fullPath_<%=locationIndex%>');">
		</td>			
		<td width="80"><input type=button id="fileBrowseButton_<%=locationIndex%>" value="Browse" onClick="openBrowser('fullPath_<%=locationIndex%>','<%=locationIndex%>')"></td>
	</tr>
	<tr>
		<td>
			<span class="REGULARTEXT">File Name Pattern: </span>
		</td>
		<td colspan="2">
			<input type="TEXTBOX" class="TEXTBOX" size="50" name="fileNamePattern_<%=locationIndex%>" id="fileNamePattern_<%=locationIndex%>" value="<%=fileNamePattern%>" onClick="javascript:clearBgColor('fileNamePattern_<%=locationIndex%>');">
		</td>
	</tr>
</table>