<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.LogCollectionManager"%>
<%@ page import="com.xpolog.logcollection.system.LogCollectionSystemManager"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.automation.*"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.data.index.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.scheduler.*"%>

<%@ page import="java.util.*"%>
<%
  final String BASE_DIRECTORY = "../../";
%>
<% 
	String ID = "ID";
	String ERROR_OBJ = "ERROR_OBJ";
  String SEARCH_ENG_MGR = "SEARCH_ENG_MGR";
  
  //site management
  LogCollectionSystemManager sysMgr = LogCollectionManager.getInstance().getSystemMgr();
  
	String jobId = sysMgr.getStorageHandlerJobId();
	String name = "";
	String description = "";
	String actionId = "";


	ActionJobBuilder job = null;
	boolean isActive = true;
 	if(jobId != null){
 		SchedulingMgr smgr = XpoLogScheduleFactory.getSchdulingManager();
 		XpoScheduledOperation op = smgr.getScheduedOp(jobId);
 		if (op != null){
 		  isActive = op.isActive();
 		}
		job = new ActionJobBuilder(op);
 		job.updateFromOp();
 		name = job.getName();
 		description = job.getDescription();
 		jobId = job.getId();
 		actionId = job.getActionId();
 	}else{
 		job = new ActionJobBuilder();
 	}
 	String state = job.getState();
 
	request.setAttribute("CURRENT_JOB",job);
	request.setAttribute("CURRENT_ID",jobId);
  request.setAttribute("suffix","sysStorageHandler");
%>
       
<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse;padding-top:5;" width="100%" >
  <tr>
    <td ><input type="checkbox" name="IndexSchedEnable" <%=isActive ? "checked" : ""%> ><span class="SMALLTEXT">Enable indexing scheduler.</span> </td>
  </tr>
  <tr>
    <td width="15%"> <span class="SMALLRTEXT">&nbsp;</span></td>
  </tr>
     <tr>
  <td><span class="REGULARTEXT"><%@ include file="../../scheduler/schedule.jsp"%></span></td>
  </tr>
  <tr>
    <td >
    <font size="2">&nbsp; </font>
    </td>
  </tr>
</table>                
