<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.locations.LocationInfo"%>
<%@ page import="com.xpolog.logcollection.locations.files.FileLocationInfo"%>
<%@ page import="com.xpolog.logcollection.LogCollectionManager"%>
<%@ page import="com.xpolog.logcollection.storage.StorageAdapter"%>
<%@ page import="com.xpolog.logcollection.storage.StorageHandler"%>
<%@ page import="com.xpolog.logcollection.system.LogCollectionSystemManager"%>

<%!static final String BASE_DIRECTORY = "../../";%>

<%
	String ARCHIVE_PATH_ID = "ArchivePathId";
	String SUFFIX = "archiveSettings";

	LogCollectionSystemManager sysMgr = LogCollectionManager.getInstance().getSystemMgr();
	StorageHandler storageHandler = sysMgr.getDefaultStorageHandler();
	FileLocationInfo archiveLocationInfo = null;
	if (storageHandler != null){
		StorageAdapter storageAdapter = storageHandler.getStorageAdapter();
		LocationInfo[] writeInfos = storageAdapter.getAllWriteSources();
		if (writeInfos != null && writeInfos.length > 0 && writeInfos[0] instanceof FileLocationInfo){
			archiveLocationInfo = (FileLocationInfo)writeInfos[0];
			if (archiveLocationInfo != null){
				request.setAttribute(ARCHIVE_PATH_ID,archiveLocationInfo);
			}
		}
	}
%>
<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
	<tr>
		<td style="padding-top:10px"><span class="HEADER">Archive Repository</span></td>
	</tr>
	<tr>
		<td style="vertical-align:top">
			<div id="defLocationDiv">
			<jsp:include page="../../logcollection/common/fileLocationInfo.jsp">
				<jsp:param name="locationInfoId" value="<%=ARCHIVE_PATH_ID%>"/>
				<jsp:param name="targetFileDirDesc" value="Archive Path"/>
				<jsp:param name="active" value="true"/>
				<jsp:param name="suffix" value="<%=SUFFIX%>"/>
			</jsp:include>
			</div>
		</td>
	</tr>
	<tr>
		<td>&nbsp;</td>
	</tr>
	<tr>
		<td width="100%" height="18"><span class="HEADER">Archiving Policy</span></td>
	</tr>
	<tr>
		<td>
			<div id="archivePolicyDiv">
			<jsp:include page="../../logcollection/common/archivePolicy.jsp">
				<jsp:param name="system" value="true"/>
			</jsp:include>
			</div>
		</td>
	</tr>
	<tr>
		<td style="padding-top:10px">
			<span class="HEADER">Archive Scheduler</span>
		</td>
	</tr>
	<tr>
		<td>
			<jsp:include page="logCollectionStorageScheduler.jsp"/>
		</td>
	</tr>
	<tr height="100%">
		<td>&nbsp;</td>
	</tr>
</table>