<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.audit.AuditConstants"%>
<%@page import="xpolog.eye.audit.AuditManager"%>
<%@page import="xpolog.eye.logcollection.admin.helpers.XpologCollectionAdminHelper"%>
<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.LogCollectionManager"%>
<%@ page import="com.xpolog.logcollection.admin.helpers.LogCollectionAdminHelper"%>
<%@ page import="com.xpolog.logcollection.collection.SourcePolicy"%>
<%@ page import="com.xpolog.logcollection.data.writers.FilePacketWriter"%>
<%@ page import="com.xpolog.logcollection.locations.files.FileLocationInfo"%>
<%@ page import="com.xpolog.logcollection.security.LogCollectionSecurityManager"%>
<%@ page import="com.xpolog.logcollection.storage.adapters.ZipStorageAdapter"%>
<%@ page import="com.xpolog.logcollection.storage.StorageAdapter"%>
<%@ page import="com.xpolog.logcollection.storage.StorageAdapterTask"%>
<%@ page import="com.xpolog.logcollection.storage.StorageFlow"%>
<%@ page import="com.xpolog.logcollection.storage.StorageHandler"%>
<%@ page import="com.xpolog.logcollection.storage.StoragePolicy"%>
<%@ page import="com.xpolog.logcollection.system.LogCollectionSystemManager"%>
<%@ page import="com.xpolog.logcollection.locations.LocationInfo"%>

<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.scheduler.ui.SchedulerHelper"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>

<%@ page import="java.util.ArrayList"%>
<%@	page import="java.util.List"%>

<%!static final String BASE_DIRECTORY = "../../";%>

<%
	String STORAGE_SETTINGS_SUFFIX = "storageSettings";
	String CHECKSUM_SETTINGS_SUFFIX = "storageSettingsChecksum";
	String ARCHIVE_SETTINGS_SUFFIX = "archiveSettings";

	LogCollectionSystemManager sysMgr = LogCollectionManager.getInstance().getSystemMgr();
	XpoQuartzSchedMgr schdMgr = (XpoQuartzSchedMgr)XpoLogScheduleFactory.getSchdulingManager();				

	ErrorModel errModel = new ErrorModel();

	FilePacketWriter orgFpw = (FilePacketWriter)sysMgr.getDefaultPacketWriter();
	FilePacketWriter fpw = new FilePacketWriter();
	String checkSumAlgorithm = request.getParameter("checkSumAlgorithm_"+STORAGE_SETTINGS_SUFFIX);
	if (checkSumAlgorithm != null && checkSumAlgorithm.length() > 0){
		fpw.setCheckSumAlgorithm(checkSumAlgorithm);
	}

	FileLocationInfo targetLocationInfo = LogCollectionAdminHelper.getFileLocationInfo(request,STORAGE_SETTINGS_SUFFIX);
	//if (targetLocationInfo != null){
	//	targetLocationInfo.setFileNamePattern("[FILE_NAME]");
	//}
	fpw.setLocationInfo(targetLocationInfo);
	if (orgFpw != null){
		fpw.setId(orgFpw.getId());
		fpw.setName(orgFpw.getName());
	}
	sysMgr.addWriter(fpw);
	
	SourcePolicy sourcePolicy = XpologCollectionAdminHelper.getSourcePolicy(request,STORAGE_SETTINGS_SUFFIX);
	sysMgr.setSourcePolicy(sourcePolicy);
	
	FileLocationInfo checksumLocationInfo = LogCollectionAdminHelper.getChecksumFileLocationInfo(request,CHECKSUM_SETTINGS_SUFFIX,errModel);
	sysMgr.setDefaultChecksumLocationInfo(checksumLocationInfo);
	
	String mailTo = request.getParameter("mailTo");
	sysMgr.setMailRecipients(mailTo);

	
	FileLocationInfo archiveLocationInfo = LogCollectionAdminHelper.getFileLocationInfo(request,ARCHIVE_SETTINGS_SUFFIX);;
	if (archiveLocationInfo != null){
		archiveLocationInfo.setFileNamePattern("[FILE_NAME].zip");
	}

	
	StorageHandler storageHandler = sysMgr.getDefaultStorageHandler();
	if (storageHandler == null){
		storageHandler = new StorageHandler();
		storageHandler.setId("systemStorageHandler");
		storageHandler.setName("System Storage Handler");
		StorageFlow flow = new StorageFlow();
		StorageAdapterTask task = new StorageAdapterTask();
		StorageAdapter adapter = new ZipStorageAdapter();
		adapter.setId("systemStorageTask");
		task.setAdapter(adapter);
		flow.setTasks(new StorageAdapterTask[]{task});
		storageHandler.setFlow(flow);
		sysMgr.addStorageHandler(storageHandler);
	}
	StorageAdapter storageAdapter = storageHandler.getStorageAdapter();
	StoragePolicy policy = LogCollectionAdminHelper.getStoragePolicy(request,null);
	if (storageAdapter != null){
		if (targetLocationInfo != null){
			storageAdapter.clearLocationInfos();
			archiveLocationInfo.setAction(LocationInfo.WRITE_ACTION);
			storageAdapter.addLocationInfo(archiveLocationInfo);
			//create read location info
			if (policy != null){
				if (policy.getArchiveFilesAge() > 0){
					FileLocationInfo read = (FileLocationInfo)targetLocationInfo.clone();
					read.setAction(LocationInfo.READ_ACTION);
					storageAdapter.addLocationInfo(read);
					//udpate archive location info
					if (policy.getDeleteFilesAge() > 0){
						FileLocationInfo delete = (FileLocationInfo)archiveLocationInfo.clone();
						delete.setAction(LocationInfo.DELETE_ACTION);
						storageAdapter.addLocationInfo(delete);
					}
				}else if (policy.getDeleteFilesAge() > 0){
					FileLocationInfo delete = (FileLocationInfo)targetLocationInfo.clone();
					delete.setAction(LocationInfo.DELETE_ACTION);
					storageAdapter.addLocationInfo(delete);
				}
			}
		}
		storageAdapter.setPolicy(policy);
	}
	
	//default collection scheduler
	XpoScheduledOperation job = SchedulerHelper.createScheduledOperation(request,"DefaultCollectionScheduler",errModel,false);
	if (job != null){
		List triggers = job.getTriggers();
		if (triggers != null && triggers.size() > 0){
			XpoCronTrigger trigger = (XpoCronTrigger)triggers.get(0);
			sysMgr.setTrigger(trigger);
		}
		//schdMgr.putXpoSysScheduledOp(job);
	}else{
		sysMgr.setTrigger(null);
	}
	
	
	
	//storage scheduler
	job = SchedulerHelper.createScheduledOperation(request,"StorageScheduler",errModel,false);
	if (job != null){
		boolean enableStorageSched = true;//enableStorageSchedStr != null && enableStorageSchedStr.equals("true"); 
		if (enableStorageSched) {
			job.setActive();
		} else {
			job.setSuspend();
		}
		schdMgr.putXpoSysScheduledOp(job);
	}else{
		XpoScheduledOperation schedOp = schdMgr.getScheduedOp(sysMgr.getStorageHandlerJobId());
		if (schedOp != null){
			schedOp.setSuspend();
			schdMgr.putXpoSysScheduledOp(schedOp);
		}
	}
	
	//security scheduler
	job = SchedulerHelper.createScheduledOperation(request,"CollectionSecurityScheduler",errModel,false);
	if (job != null){
		boolean enableSecuritySched = true;//enableStorageSchedStr != null && enableStorageSchedStr.equals("true"); 
		if (enableSecuritySched) {
			job.setActive();
		} else {
			job.setSuspend();
		}
		schdMgr.putXpoSysScheduledOp(job);
	}else{
		XpoScheduledOperation schedOp = schdMgr.getScheduedOp(LogCollectionSecurityManager.COLLECTION_SECURITY_JOB_ID);
		if (schedOp != null){
			schedOp.setSuspend();
			schdMgr.putXpoSysScheduledOp(schedOp);
		}
	}
	
	//security mail tasks
	ArrayList tasks = LogCollectionAdminHelper.getTasksFromRequest(request,errModel,"integrityErrorsMailTo");
	if (errModel.getErrorCount() == 0){
		sysMgr.getSecurityManager().setTasks(tasks);
	}
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
			userContext, AuditConstants.CHANGE, "Change the log collection settings", AuditConstants.LOG_COLLECTION, "Change the log collection settings"); 
	sysMgr.save();
	response.sendRedirect("logCollectionSettings.jsp");
%>
