<%@ page language="java" %> 

<%@page import="java.util.Collections"%>
<%@page import="java.util.LinkedList"%>
<%@page import="java.util.List"%>
<%@page import="xpolog.eye.issuetracking.ui.handlers.LogIssueUpdateHandler"%>
<%@page import="xpolog.eye.logview.LogViewContext"%>
<%@page import="xpolog.eye.site.SiteUtil"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
    UserEnvironment env = UserEnvironment.getUserEnvironment(request);
    LogViewContext logcontext = (LogViewContext)request.getSession().getAttribute(LogViewContext.LOG_CONTEXT);
    
    List selectedRowIndexes = new LinkedList();
		String selectedRowIndexStr = request.getParameter("selectedRowIndexArr");
		String[] selectedRowIndexArr = selectedRowIndexStr == null ? null : selectedRowIndexStr.split("#");
		for(int i = 0 ; selectedRowIndexArr != null && i < selectedRowIndexArr.length ; i++){
			int rowIndx = -1;
			try{
					rowIndx = Integer.parseInt(selectedRowIndexArr[i]);
					selectedRowIndexes.add(new Integer(rowIndx));
			}catch(Exception e){
				rowIndx = -1;
			}			
		}
		Collections.sort(selectedRowIndexes);			
	

		LogIssueUpdateHandler handler = new LogIssueUpdateHandler(logcontext == null ? null : logcontext.lbm,selectedRowIndexes);
		env.setGlobalAttribute("issueTrackingHandler",handler);
		
		if (logcontext != null && logcontext.lbm != null){			
				String template = "\n\nTo view the related log in XpoLog click here:\n";
				String url = SiteUtil.getApplicationRoot(request);
				url += "componentAction.jsp?selectedCompId=XpoLog&forward=root.jsp?mainPage=loggers/logview.jsp%253Flogid=" + logcontext.logId;
				template += url + "\n";
				handler.setDescriptionTemplate(template);
		}
		
		request.getRequestDispatcher(BASE_DIRECTORY + "tools/issuetracking/addIssueInfo.jsp").forward(request,response);
%>