<%@page import="xpolog.eye.admin.helpers.LogAdminHelper"%>
<%@page import="xpolog.eye.admin.helpers.IntervalAdminHelper"%>
<%@page import="xpolog.eye.admin.helpers.DatabaseAdminHelper"%>
<%@page import="xpolog.eye.data.util.NameExpression"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%
	String BASE_DIRECTORY = "../../../";

  String ERROR_OBJ = "ERROR_OBJ";
  String LOG_NAME = "LogName";
  String LOG_DESCRIPTION = "LogDescription";
  String REFRESH_RATE = "RefreshRate";
  String MODULE_ID = "ParentModule";
  String LOG_PATH = "LogPath";
  String LOG_DATA_PATTERN = "DataPattern";
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_TIME_ZONE = "TimeZone";
  String QUERY = "Query";
  String DB_ACCOUNT = "accountId";
  String AUTO_UPDATE = "AutoUpdate";
  String IS_DUPLICATE_MODE = "isDuplicateMode";
  String LOG_CHARSET = "charset";

  
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  String doSaveStr = request.getParameter("doSave");
  if (doSaveStr == null){
  	doSaveStr = "";
  }
  
  String modid      = request.getParameter(MODULE_ID);
  String parentApps = request.getParameter("parentApplication");
	HashSet applicationsIds = new HashSet();
  String[] appArr = null;
	if(parentApps != null && parentApps.length() >0){
		appArr = parentApps.split("#");
		for(int i = 0 ;	appArr != null &&  i < appArr.length ; i++){
			applicationsIds.add(appArr[i]);
		}		
	}  
  String logname = request.getParameter(LOG_NAME);
  String logdesc = request.getParameter(LOG_DESCRIPTION);
  String query = null;//request.getParameter(QUERY);
  String logdatapat = request.getParameter(LOG_DATA_PATTERN);
  String timeZoneId = request.getParameter(LOG_TIME_ZONE);
  String dbId = request.getParameter(DB_ACCOUNT);
  String refrate = request.getParameter(REFRESH_RATE);
  String charset = request.getParameter(LOG_CHARSET);
  String mediaType = "DBMedia";
  String autoUpdateString = request.getParameter(AUTO_UPDATE);
  String isDuplicateModeStr = request.getParameter(IS_DUPLICATE_MODE);
  boolean isDuplicateMode = isDuplicateModeStr != null && isDuplicateModeStr.equals("true");
  String isOnlineStr = request.getParameter("DownloadFiles");
  String seqIndexes = request.getParameter("seqIndexes");
  boolean isOnline = isOnlineStr != null && isOnlineStr.equalsIgnoreCase("false");
  
  String useUndexingStr = request.getParameter("useIndexing");
  boolean useIndexing = useUndexingStr != null && useUndexingStr.equalsIgnoreCase("true");
  
  HashSet collectionUnits = null;
  
  if (charset != null && charset.equals("default")){
    charset = null;
  }
	String logAdminScreenWidth = request.getParameter("LogAdminScreenWidth");
	if(logAdminScreenWidth == null || logAdminScreenWidth.length()==0){
		logAdminScreenWidth = "600";
	}
  request.getSession().setAttribute("LogAdminScreenWidth", logAdminScreenWidth);

  boolean isForward = true;
  int maxRows = 10000;
  boolean isUnique = false;
  boolean addDataBaseOID = false;
  
  //verify data
  ErrorModel errmodel = new ErrorModel();
  
  if(logname == null || logname.trim().equals("")){
    errmodel.addError("No name was supplied.");
  }

   if(WebUtil.isContainSpecialCharecter(logname)){
     errmodel.addError("The following characters are prohibited in the name field: "+WebUtil.getSpecialCharectersList());
  }
  
  if(modid == null || modid.trim().equals("")){
    errmodel.addError("No parent folder was selected. If no folder is available please check your permissions");
  }

  if(dbId == null || dbId.trim().equals("")){
    errmodel.addError("No Database account was supplied.");
  }

  long refreshInterval = -1;
	boolean autoUpdate = true;
	if (autoUpdateString == null || !autoUpdateString.equals("true")) {
		autoUpdate = false;
	}
  
	String op = request.getParameter("OP");
	if(op == null || op.length()==0){
		op = "ADD";
	}

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    String okURL = "loggers/admin/logAdminGate.jsp?isPrevious=true&logType=db" + "&OP=" + op;
    okURL = XpologUtil.replaceAll(okURL,"?","%3f"); 
    okURL = XpologUtil.replaceAll(okURL,"&","%26"); 
    String forwardURL = BASE_DIRECTORY + "common/errorpage.jsp?okURL=" + okURL;
    response.sendRedirect(forwardURL);
    return;
  }

  DBSimpleLogBuilder builder = null;
  try{
  	//Builder might be from different type (add log,next -> prev).
    builder = (DBSimpleLogBuilder)request.getSession().getAttribute(BUILDER);
  }catch(Exception e){
  	builder = null;
  }
  LogBrowsingManager lbm = null;
  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  if(lbm != null && !(lbm.getType().equals(DBSimpleLogBuilder.DB_LOG_TYPE) || lbm.getType().equals(OnlineDBSimpleLogBuilder.ONLINE_DB_LOG_TYPE) || 
								  		lbm.getType().equals(OnlineDBSimpleLogBuilder.ONLINE_DB_CACHE_LOG_TYPE))){
  	lbm = null;
  	request.getSession().removeAttribute(CURRENT_LOG);
  }
  if (lbm != null){
   	collectionUnits = lbm.getCollectionUnits();
    String type = lbm.getType();
    if (type.equals(OnlineDBSimpleLogBuilder.ONLINE_DB_LOG_TYPE) || type.equals(OnlineDBSimpleLogBuilder.ONLINE_DB_CACHE_LOG_TYPE)){
    	logdatapat = DatabaseAdminHelper.getXpologPattern(lbm);
    	//accId = DatabaseAdminHelper.getAccount(lbm).getId();
    	query = DatabaseAdminHelper.getQuery(lbm);
    	seqIndexes = DatabaseAdminHelper.getSequencesIndes(lbm);
    	isForward = DatabaseAdminHelper.isQueryForward(lbm);
    	maxRows = DatabaseAdminHelper.getMaxRows(lbm);
    	isUnique = DatabaseAdminHelper.isUnique(lbm);
    	addDataBaseOID = DatabaseAdminHelper.isAddDataBaseOID(lbm);
    }else {
    	logdatapat = LogAdminHelper.getXpologPattern(lbm);
      //selectedRefreshRate = IntervalAdminHelper.getIntervalRefresh(lbm,true);
      //isAutoUpdate = IntervalAdminHelper.isAutoUpdate(lbm);
      //accId = IntervalAdminHelper.getAccount(lbm).getId();
      query = IntervalAdminHelper.getSourceDirLocation(lbm);
    }
  }
  
  if (!isOnline){
    try{
  	  refreshInterval = Long.parseLong(refrate);
    }catch(Exception e){
  	  errmodel.addError("Please supply a valid refresh rate.");
    }
  }
  if (refreshInterval > 0){
    refreshInterval = refreshInterval * 1000 * 60;
  }
   
  if (builder == null || (builder.isOnline() != isOnline)){
  	if (builder != null){
  		
  	}
  	builder = (DBSimpleLogBuilder)LogBrowserBuilderFactory.getLogBroserBuilderByType(isOnline ? LogBrowserBuilderFactory.ONLINE_DB_TYPE : LogBrowserBuilderFactory.DB_TYPE);
  }
  builder.setOnline(isOnline);


  if(lbm != null){
    builder.setID(lbm.getId());
    builder.setHost(lbm.getHost());
    builder.setUseIndexing(lbm.isUseIndexing());
    builder.setUseIndexingForDateSearch(lbm.isUseIndexingForDateSearch());
    builder.setIndexNullValues(lbm.isIndexNullValues());
    builder.setUseWholeWords(lbm.isUseWholeWords());
		builder.setUseQuickFilter(lbm.isUseQuickFilter());
		builder.setComputeStatistics(lbm.isComputeStatistics());
  	builder.setUseInDashboard(lbm.isUseInDashboard());
  	builder.setUseInDashboardTask(lbm.isUseInDashboardTask());
    builder.setCollectionUnits(lbm.getCollectionUnits());
    builder.setScannerRoot(lbm.getScannerRoot());
  }
  
  ArrayList nameExprList = new ArrayList();
  NameExpression nameExpr = new NameExpression();
	nameExpr.setDirectory("./");
	nameExpr.setXpologNamePatternsStr("{string}");
	nameExpr.setLogDynamicType(0);
	nameExprList.add(nameExpr);
	
	if (!builder.isUpdatedFromLbm()){
	  builder.setRecordPattern(logdatapat);
	  builder.setSourceLocation(query);
	  builder.setSeqColumns(seqIndexes);
	  builder.setQueryForward(isForward);
	  builder.setMaxRows(maxRows);
	  //builder.setUseIndexing(useIndexing);
	  builder.setUnique(isUnique);
	  builder.setAddDataBaseOID(addDataBaseOID);
	  builder.setCharset(charset);
	  builder.setUpdatedFromLbm(true);
	}
  builder.setApplicationsIds(applicationsIds);	
	builder.setNameExprList(nameExprList);
  builder.setName(logname);
  builder.setLogsFileNamePattern("{string}");
  builder.setLogsDirectory("./");
  builder.setAutoUpdate(autoUpdate);
	builder.setRefreshInterval(refreshInterval);
  builder.setLogDescription(logdesc);
  builder.setTimeZoneId(timeZoneId);
  builder.setCollectionUnits(collectionUnits);

  DBAccount acc = (DBAccount)AddressBook.getInstance().getAccountById(dbId);

  builder.setAccount(acc);
  builder.setRefreshInterval(refreshInterval);
  builder.setAutoUpdate(autoUpdate);
  builder.setSourceLocation(query);
  if (builder.getMedia() != null){
  	((DBMedia)builder.getMedia()).setIsDuringAdministration(true);
  }

  boolean isNew = lbm == null || lbm.getId() == null;
  request.getSession().setAttribute("IS_NEW", Boolean.valueOf(isNew));

  try{
    //for configuration reasons
    builder.updateBuilder();
    
    
  }catch(Exception e){
    errmodel.addError("Building log problem,please check patterns and path again.");
    errmodel.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    String okURL = "loggers/admin/logAdminGate.jsp?isPrevious=true&logType=db" + "&OP=" + op;
    okURL = XpologUtil.replaceAll(okURL,"?","%3f"); 
    okURL = XpologUtil.replaceAll(okURL,"&","%26"); 
    String forwardURL = BASE_DIRECTORY + "common/errorpage.jsp?okURL=" + okURL;
    response.sendRedirect(forwardURL);
    return;
  }

  String [] pages = {"loggers/admin/logAdminGate.jsp?isPrevious=true&logType=db" + "&OP=" + op,
  		     "loggers/admin/database/DBLogDataPattern.jsp?OP=" + op,
  		     "loggers/admin/logFieldAdmin.jsp"};
  AdminUIController controller = new AdminUIController(pages);
  builder.setUiController(controller);
  
  builder.setDuplicateMode(isDuplicateMode);

  request.getSession().setAttribute("MODULE_ID",modid);
  request.getSession().setAttribute(BUILDER, builder);
  if (lbm != null){  	
  	response.sendRedirect("DBPresentStatusAction.jsp?doSave=" + doSaveStr + "&logdatapat=" + logdatapat);
  	return;
  }
  response.sendRedirect(BASE_DIRECTORY + controller.getForwardPage());

%>


