<%@ page language="java"%>

<%@ page import="xpolog.eye.LogBrowsingManager"%>
<%@ page import="xpolog.eye.admin.helpers.LogAdminHelper"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@page import="xpolog.eye.admin.helpers.XMLLogAdminHelper"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
String CURRENT_LOG = "CURRENT_LOG";

String fileSizeOp = "";
String fileSize = "";
String filesLimit = "";

DateFilter datefl = null;
long timeDiff = 0;
String timeunit = "";
String isTimeLim = "";
String daystatsel = "";
String minstatsel = "";
String hourstatsel = "selected";
String weekstatsel = "";
String monthstatsel = "";
boolean isLast = true;

LogBrowsingManager lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);

if(lbm != null) {
	String logType = request.getParameter("logType");
	if(logType != null && logType.length() > 0 && logType.equals("xmlLog")){
		fileSizeOp = XMLLogAdminHelper.getFileSizeOp(lbm);
	  fileSize = XMLLogAdminHelper.getFileSize(lbm);
	  filesLimit = XMLLogAdminHelper.getFilesLimit(lbm);
	  datefl = XMLLogAdminHelper.getDateFilter(lbm);
	}else{
		fileSizeOp = LogAdminHelper.getFileSizeOp(lbm);
	  fileSize = LogAdminHelper.getFileSize(lbm);
	  filesLimit = LogAdminHelper.getFilesLimit(lbm);
	  datefl = LogAdminHelper.getDateFilter(lbm);
	}

	if (datefl != null){	  		 
			hourstatsel = "";
			isLast = datefl.isLastOpType();
			isTimeLim = "checked";
			timeunit = String.valueOf(datefl.getTimeGap());
			if(datefl.isMonths()){
				monthstatsel = "selected";
			}else if(datefl.isWeeks()){
				weekstatsel = "selected";
			}else if(datefl.isDays()){
				daystatsel = "selected";      
			}else if(datefl.isHours()){
				hourstatsel = "selected";
			}else if(datefl.isMinutes()){
				minstatsel = "selected";
			}else {
				hourstatsel = "selected";
	    }
 	}
}
%>

<tr>
  <td><span class="HEADER">Files Filter</span></td>
</tr>
<tr>
	<td>
		<table border="0" width="100%" cellspacing="0" cellpadding="0">
			<tr>
				<td>
					<span class="REGULARTEXT">File Size&nbsp;</span>
					<select class="TEXTBOX" id="fileSizeOp" name="fileSizeOp">
						<%
						String[] operations = NumberFilter.getSupportedOperations();
						for (int i=0; i<operations.length; i++){
						%>
						<option value="<%=i%>" <%=fileSizeOp.equals(operations[i])?"selected":""%>><%=operations[i]%></option>
						<%
						}
						%>
					</select>
			    <input type="text" class="TEXTBOX" id="fileSize" name="fileSize" value="<%=fileSize %>"> <span class="REGULARTEXT">bytes</span>
				</td>
			</tr>
			<tr>
				<td colspan="2">
					<span class="SMALLTEXT">Files whose size is out of range will be ignored</span>
				</td>
			</tr>            			
			<tr style="padding-top:15"> 
				<td>
			   	<span class="REGULARTEXT">File date from the</span>
			  
					<input type="hidden" name="Dates" value="TimeUnitRadio">                           
					<select class="TEXTBOX" size="1" name="TimeOpType">
						<option value="1" <%=isLast?"selected":""%>>last</option>
						<option value="2" <%=!isLast?"selected":""%>>previous</option>
					</select>
					<input class="TEXTBOX" type="text" name="TimeText" size="3" value="<%=timeunit%>" onChange="javascript:isNumeric(this.value)">
					<select class="TEXTBOX" size="1" name="TimeUnit">
						<option value="minutes" <%=minstatsel%>>minutes</option>
						<option value="hours" <%=hourstatsel%>>hours</option>
						<option value="days" <%=daystatsel%>>days</option>
						<option value="weeks" <%=weekstatsel%>>weeks</option>
						<option value="months" <%=monthstatsel%>>months</option>
			    </select>
			  </td>
			</tr>
			<tr>
				<td colspan="2">
					<span class="SMALLTEXT">Outdated files will be ignored</span>
				</td>
			</tr>
			<tr style="padding-top:15"> 
				<td>
			   	<span class="REGULARTEXT">The last&nbsp;</span>
					<input class="TEXTBOX" type="text" name="filesLimit" size="3" value="<%=filesLimit%>" onChange="javascript:isNumeric(this.value)">
					<span class="REGULARTEXT">&nbsp;files</span>
			  </td>
			</tr>
		</table>
	</td>
</tr>