<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.http.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@page import="xpolog.eye.data.log.files.MultiFileLocationInfo"%>
<%@page import="xpolog.eye.data.util.NameExpression"%>
<%@page import="xpolog.eye.media.ftp.FTPAccountFilter"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  //constants
  String ERROR_OBJ = "ERROR_OBJ";
  String OP = "OP";
  String ADD = "ADD";
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_NAME = "LOG_NAME";
  String LOG_DESCRIPTION = "LOG_DESCRIPTION";
  String MODULE_ID = "MODULE_ID";
  String LOG_DIRECTORY = "LOG_DIRECTORY";
  String LOG_NAME_PATTERN = "LOG_NAME_PATTERN";
  String LOG_DATA_PATTERN = "LOG_DATA_PATTERN";
  String CURRENT_MODULE = "CURRENT_MODULE";
  String LOG_TIME_ZONE = "LOG_TIME_ZONE";

  //page data
  LogBrowsingManager lbm = null;
  String modid      = "";
  String logname    = "";
  String logdesc    = "";
  String logpath     = "";
  String tagName = "";
  ArrayList logpathList     = new ArrayList();
  String lognameexp = "";
  String logdatapat = "{string}";
  String accId = "";
  long refresh = -1;
  boolean isUsingDefaultTimeZone = true;
  TimeZone defaultZone = TimeZone.getDefault();
  String timeZoneId = defaultZone.getID();
  boolean isAutoUpdate = false;
  String selectedCharset = null;
  boolean sortByLastUpdate = true;

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  UserContext userContext = UserEnvironment.getUserContext(request);
  int numOfNameExpression = 1;
  ArrayList locationInfoList = new ArrayList();

  Module[] mdarr = mgmt.getAllModules(userContext,true);
  ModuleMember curmod = new ModuleMember();
  Module pmod = null;
  String backwardURL = null;
  //check state
  String op = request.getParameter(OP);
  if((op != null) && op.trim().equals(ADD)){
    //we are adding a new browser
    request.getSession().removeAttribute(CURRENT_LOG);
    backwardURL  = "../logAdminGate.jsp";
  }else{
  	XMLLogBrowserBuilder builder = (XMLLogBrowserBuilder)request.getSession().getAttribute(BUILDER);
    if (builder != null){
      lbm = builder.getLogBrowserManager();
    }
    if (lbm == null){
      String id = request.getParameter(LOG_ID);
      if((id != null) && !(id.trim().equals(""))){
        try{
          lbm = mgmt.getLogBrowserManager(id);
          request.getSession().setAttribute(CURRENT_LOG,lbm);
        }catch(Exception e){}
      }else{
        lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
      }
    }

    if(lbm != null){
        logname    = lbm.getName();
        logdesc    = lbm.getDescription();
        timeZoneId = lbm.getTimeZone().getID();
				selectedCharset = lbm.getCharset();
        isUsingDefaultTimeZone = lbm.isUsingDefaultTimeZone();
        List l = XMLLogAdminHelper.getLogFilesPattern(lbm);
        accId = IntervalAdminHelper.getAccount(lbm).getId();
        refresh = IntervalAdminHelper.getIntervalRefresh(lbm,true);
		  	logpathList = IntervalAdminHelper.getSourceDirLocationList(lbm);
        locationInfoList = XMLLogAdminHelper.getLogLocations(lbm);
        tagName = XMLLogAdminHelper.getTagName(lbm);
        curmod.setId(lbm.getId());
        curmod.setName(logname);
        curmod.setType("Log");
        curmod.setDescription(logdesc);
        isAutoUpdate = IntervalAdminHelper.isAutoUpdate(lbm);
        try{
          pmod = mgmt.getParentModule(lbm.getId());
          if (pmod != null){
            boolean foundModule = false;
            for (int i = 0; i < mdarr.length; i++) {
              if (mdarr[i].getId().equals(pmod.getId())){
                foundModule = true;
                break;
              }
            }
            if (!foundModule){
              Module  [] tmp = new Module[mdarr.length + 1];
              System.arraycopy(mdarr,0,tmp,0,mdarr.length);
              mdarr = tmp;
              mdarr[mdarr.length - 1] = pmod;
            }
          }
        }catch(Exception e){
        }
      }
  }

  if(pmod == null){
    pmod = (Module)request.getSession().getAttribute(CURRENT_MODULE);
    if(pmod == null){
      pmod = new Module();
      pmod.setId("");
    }
  }

  if (mdarr.length == 0){
    Module tmpMod = new Module();
    tmpMod.setId("");
    mdarr = new Module[] {tmpMod};
  }

  String[] timeZonesArr = TimeZone.getAvailableIDs();
  Arrays.sort(timeZonesArr);

	Map charsetMap = java.nio.charset.Charset.availableCharsets();
  String [] charsetArr = (String [])charsetMap.keySet().toArray(new String [charsetMap.size()]);  
  List list = AddressBook.getInstance().getAccountsByFilter(new FTPAccountFilter(),userContext);
  if(list.size() == 0) {
  	//No accounts defined in system
  	ErrorModel errmodel = new ErrorModel();
  	errmodel.addError("There is no FTP account defined, Please <a href=\"../../tools/addresses/ftp/accountFtp.jsp\">create FTP account</a> first.");
  	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("../errorpage.jsp");
    return;
  }

	int newPathIndx = locationInfoList.size() == 0 ? 1 : locationInfoList.size();
  String selected = "";
%>

<html>

<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/UIUtil.js"></script>
<script>

	var contextreq;
	var indx = "<%=newPathIndx%>";
	var counter =  indx;
	
	
	function shownHideAdv(){
		var vis = document.getElementById("advancedDiv").style.display == "";
		if(vis){
			document.getElementById("advancedDiv").style.display  = "none";		
		}else{
			document.getElementById("advancedDiv").style.display  = "";
		}	
	}
	
	function doNext(){   	  
		if (updateParentModule){
			updateParentModule(tree,"ParentModule");
		}
		document.access.numOfPaths.value = counter; 	  
		document.access.action = "xmlFtpLogAdminAction.jsp";
  	  document.access.submit();
	}
	
  function save(){
		if (updateParentModule){
			updateParentModule(tree,"ParentModule");
		}
		document.access.doSave.value = "true";
		document.access.action = "xmlFtpLogAdminAction.jsp";
	  document.access.numOfPaths.value = counter;
		document.access.submit();
	}

	function openBrowser(txtboxId,i){
		document.getElementById("advancedDiv").style.display  = "none";		
  	showHideLayerInMiddle(150,150);
		var rootDir = document.getElementById("FullPath_"+i).value;
		var accId = document.getElementById("authAccId").value;
		loadSysFilesTree(rootDir,txtboxId,accId);
	}
		
	function addNewLocation(){
			document.getElementById("allNewPaths").style.display = "";
		var allNewPathsDiv = document.getElementById("allNewPaths");
		var divIdName = "newPath"+indx+"Div";
		var newdiv = document.createElement('div');
		newdiv.setAttribute("id",divIdName);
		newdiv.innerHTML = "<tr><td>" +
											 "<table border=\"0\" cellspacing=\"3\" cellpadding=\"0\" width=\"800\"><tr><td width=\"75\"><span class=\"REGULARTEXT\">Log Path</span></td>" + 
	                     "<td width=\"425\"><input type=\"TEXTBOX\" class=\"TEXTBOX\"  name=\"FullPath_"+indx+"\" id=\"FullPath_"+indx+"\" size=\"80\" value=\"\"></td>" +
	                    "<td width=\"70\">" +
													"<select class=\"TEXTBOX\" name=\"LogState_"+indx+"\"   onChange=\"javascript:changeStatus(this.value,'" +indx+"')\">" +
															"<option value=\"online\" \"selected\">online</option>"+
															"<option value=\"offline\" >offline</option>"+
													"</select>"+
                          "</td>"+  
                          
                          "<td width=\"30\">"+                   
														"<img id=\"imgid_"+indx+"\"  style=\"cursor:pointer;\" onClick=\"javascript:showLogSettings(event,'" +indx+"','0')\" src=\"../../../images/slides/menuArrow.gif\" alt=\"Log dynamic type settings\" style=\"display:\">" +
                         "</td>"+                                                                                               	                    
	                     "<td colspan=\"2\" width=\"100\"><a id=\"removePath_"+indx+ "\" href=\"javascript:remove('newPath"+indx+"Div');\" class=\"SMALLLINK\">Remove</a></td>" +                    
	                     "</tr></td></tr>"
		allNewPathsDiv.appendChild(newdiv);
		indx = (indx-1+2);	
		counter = (counter-1+ 2);	
	}
	
	function remove(divNum){
	if(indx == 1){
		alert("Can't remove last path selection!.");
	}else{
	  var d = document.getElementById('allNewPaths');
		var olddiv = document.getElementById(divNum);
		if(!olddiv || !d ){
			alert("can't remove path	!");
		}else{			
			d.removeChild(olddiv);
			indx = indx -1;
		}
		}
	}
	
				function setDynamicType(indx,dynamicType){
			if(indx && indx != "" && dynamicType && dynamicType != ""){
				dynamicTypeArr += indx + "=" + dynamicType + ":" ;
			}
			document.access.dynamicTypeArr.value = dynamicTypeArr;
		} 
		
	function init(){
			<%for (int i=0; i<locationInfoList.size() ; i++){
  	  	MultiFileLocationInfo locationInfo = (MultiFileLocationInfo)locationInfoList.get(i);
  	  	NameExpression nameExpression = locationInfo.getNexpr();
		 		int logDynamicType = nameExpression.getLogDynamicType();		
			%>
				setDynamicType("<%=i%>","<%=logDynamicType%>");
			<%}%>
		}

</script>
</head>

<body onload="javascript:init()">
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<input type="hidden" name="numOfPaths" id="numOfPaths" value="<%=newPathIndx%>">
<input type="hidden" name="dynamicTypeArr" id="dynamicTypeArr">
<input type="hidden" name="doSave">
<input type="hidden" name="ParentModule">
 
 			<jsp:include page="../logDynamicSettings.jsp" flush="true">
			<jsp:param name="base_directory" value="<%=BASE_DIRECTORY%>"/> 
			</jsp:include>
 
 
<table border="0" width="92%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="800" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%" width="800">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="671" id="AutoNumber2">
              <tr>
                <td width="9" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="395" class="TOPBORDER">
                <span class="PAGEHEADER">Ftp Xml Log</span> </td>
                <td width="525" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="8">&nbsp;</td>
                <td width="393">&nbsp;</td>
                <td width="524">&nbsp;</td>
              </tr>
              <tr>
                <td width="8" >&nbsp;</td>
                <td colspan="2" width="919">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="374" id="AutoNumber3">
                  <tr>
                    <td width="800" height="18"><span class="HEADER">General</span></td>
                  </tr>
                  <tr>
                    <td width="800" height="18"></td>
                  </tr>
                  <tr>
                    <td width="800" height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      <tr>
                        <td colspan="2">
													<jsp:include page="../../../common/selectParentModule.jsp" flush="true">
													<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
													<jsp:param name="PARENT_MODULE_ID" value="<%=pmod.getId()%>" />
													</jsp:include>
                        </td>
                      </tr>
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Name</span></td>
                        <td width="89%">
                        <input type="text" class="TEXTBOX" name="LogName" size="60" value="<%=logname%>"></td>
                      </tr>
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Description&nbsp;</span></td>
                        <td width="89%">
                        <input type="text" class="TEXTBOX" name="LogDescription" size="60" value="<%=logdesc%>"></td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td width="800">&nbsp;</td>
                  </tr>
                  
                  
                  
                   <tr>
                    <td width="800">
                      <table border="0" width="800" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="23%"><span class="REGULARTEXT">Ftp
                            Account</span></td>
                          <td width="77%">
                        <select size="1" class="TEXTBOX" name="accountId" id="accountId">
                        <option value="">--- Select ftp account ---</option>
                            <%
                            	String accselected = "selected";
                            	String accunselected = "";
                            	String toGo = accunselected;
                            	Account account = null;
                            	for(int i=0;i<list.size();++i){
                            		account = (Account)list.get(i);
                            		if(account.getId().equals(accId)){
                            			toGo = accselected;
                            		}else{
                            			toGo = accunselected;
                            		}
                            %>
                            <option class="TEXTBOX" <%=toGo%> value=<%=account.getId()%>><%=account.getAccountName()%></option>
                            <%
                            	}
                            %>
                        </select> <a href="<%=BASE_DIRECTORY%>tools/addresses/ftp/accountFtp.jsp?OP=APP" class="LINK">new</a></td>
                          <td width="75"></td>
                        </tr>
                        <tr>
                          <td width="150"></td>
                          <td width="575"><span class="SMALLTEXT">Choose the Ftp account from where the log file will be downloaded.&nbsp;</span></td>
                          <td width="75"></td>
                        </tr>
                        </table>
                        </td>
                        </tr>
                          <tr>
                    <td width="800">&nbsp;</td>
                  </tr>
                  
                  
                  
                  <tr>
										<td width="800">
	                  <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
  		                <tr>
      		              <td width="111" height="21"><span class="HEADER">Ftp Location</span></td>
          		          <td colspan="2"><a id="AddNewLocation" href="javascript:addNewLocation();" class="SMALLLINK">Add New Location</a></td>
              		    </tr>
                  	</table>
                  	</td> 
                   </tr>     
                  <tr>
                    <td width="800"></td>
                  </tr>

                  <tr>
                  <td>
                  <table>
                        
                         <tr>
                    <td width="800">
                    <div id="allNewPaths" > 
                       
                     <%if((op != null) && (op.trim().equals(ADD))){%>               
                        <div id="path_Div">
	                      <table border="0" width="800" cellspacing="3" cellpadding="0">
                        <tr>
                          <td width="75"><span class="REGULARTEXT">Log Path</span></td>
                          <td width="425">
   			                      <input type="TEXTBOX" class="TEXTBOX"  name="FullPath_New" id="FullPath_New" size="80" value=""></td>
                          <td width="70">
															<select class="TEXTBOX" name="LogState_New" onChange="javascript:changeStatus(this.value,'new')">
																<option value="online" selected>online</option>														
																<option value="offline" >offline</option>
															</select>
                          </td>
                          <td width="30" >                   
                          		<img id="imgid_new" style="cursor:pointer;" onClick="javascript:showLogSettings(event,'new','0')" src="<%=BASE_DIRECTORY%>images/slides/menuArrow.gif" alt="Log dynamic type settings" style="display:">
                          </td>
                        	<td colspan="2" width="100"><a id="removePath_" href="javascript:remove('path_Div');" class="SMALLLINK">Remove</a></td>
                        </tr>
                        </table>
                        </div> 
                        
                      <%
                                                                   	  }else if(locationInfoList != null && locationInfoList.size() > 0){
                                                                   	  String fullPath = "",dir = "";
                                                                   	  int logDynamicType = 0;
                                                                   	  List namesList = null;
                                                                   	  for(int i =0 ; i < locationInfoList.size() ; i++){
                                                                   	  	MultiFileLocationInfo locationInfo = (MultiFileLocationInfo)locationInfoList.get(i);
                                                                   	  	NameExpression nameExpression = locationInfo.getNexpr();
                                                                   	  	if(logpathList != null && logpathList.size() > i){
                                                                   	  		dir = (String)logpathList.get(i);
                                                                   	  	}
                                               //                    	  	if(dir == null || dir.length() == 0){
                                               //	               		dir = nameExpression.getDirectory();
                                               //                   	  	}
                                               		               		logDynamicType = nameExpression.getLogDynamicType();
                                               		               		namesList = nameExpression.getXpologPatternList();
                                               		                    		    if (namesList.size() > 0){
                                               		                    		    	lognameexp = "";
                                               		                    		    	for (int j=0; j<namesList.size(); j++){
                                               		                    		    		lognameexp = lognameexp + (j > 0 ? "," : "") + (String)namesList.get(j);
                                               		                    		    	}
                                               		                    		    } 
                                               		                    		   if(dir.length() > 0 && (!dir.endsWith("/")&& !dir.endsWith("\\"))){
                                                   		                    		if(dir.indexOf("\\") > 0){
  		                                              		                    		dir+="\\";
                                                  		                    		}else{
    	                                              		                    		dir+="/";
                                                  		                    		}
                                                   		                    	}
                                                                  		    fullPath = dir + lognameexp;
                                                                  		    dir = "";
                                               %>  
                     <div id="path_<%=i%>Div">
                      <table border="0" width="800" cellspacing="3" cellpadding="0">                  
                      <tr>
                          <td width="75"><span class="REGULARTEXT">Log Path</span></td>
                          <td width="425">
		                      <input type="TEXTBOX" class="TEXTBOX"  name="FullPath_<%=i%>" id="FullPath_<%=i%>" size="80" value="<%=fullPath%>"></td>                    
														<td width="70">
															<select class="TEXTBOX" name="LogState_<%=i%>" onChange="javascript:changeStatus(this.value,'<%=i%>')">													
																<option value="online" <%= logDynamicType != 4 ? "selected" : "" %>>online</option>
																<option value="offline" <%= logDynamicType == 4 ? "selected" : "" %>>offline</option>
															</select>
													</td>													
                          <td width="30" >                   
                          		<img id="imgid_<%=i%>" style="cursor:pointer;" onClick="javascript:showLogSettings(event,'<%=i%>','<%=logDynamicType%>')" src="<%=BASE_DIRECTORY%>images/slides/menuArrow.gif" alt="Log dynamic type settings" style="display: <%=(logDynamicType != 4) ? "" : "none" %>">
                          </td>
                           <td colspan="2" width="100"><a id="removePath_<%=i%>" href="javascript:remove('path_<%=i%>Div');" class="SMALLLINK">Remove</a></td>
                        </tr>               
	                        </table>
                        </div>
                      <%} }%>
				          		</div>
				</td>
			</tr>
			<tr width="800">
			<td>
			 <table border="0" width="800" cellspacing="0" cellpadding="0">
			 	<tr>
			 	<td width="75">&nbsp;</td>
 				 	<td width="680"><span class="SMALLTEXT">The relative location for the log  on the web site. You can use file name<br>
 				 	pattern. e.g. "/host/.../log/my-app-{date,dd-MM-yyyy}.{string}.log. <a href=javascript:openHelp("<%=BASE_DIRECTORY%>","Pattern.htm") class="SMALLLINK">help</a></span></td>
 				 	<td width="5">&nbsp;</td>
 				 	<td width="5">&nbsp;</td>
 				 	<td width="15">&nbsp;</td>
 				 	<td width="20">&nbsp;</td>
			 	</tr>
			 	<tr><td>&nbsp;</td></tr>			 	
			 </table>
					</td>
			</tr>
                   	<tr>
			           		<td colspan="2">&nbsp;</td>
			           	</tr>	  
      
      <tr>

                    <td width="800">
                        <span class="HEADER">Record Tag Name</span>
                    </td>
                  </tr>


								<tr>
                    <td width="800">
                      <table border="0" width="800" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="62"><span class="REGULARTEXT">Tag name</span></td>

                          <td width="425">
                          <input class="TEXTBOX" type="text" name="tagName" size="30" value="<%=tagName%>"></td>
                          <td width="100">&nbsp;</td>
                          <td width="100">&nbsp;</td>
                        </tr>

                        <tr>
                          <td width="83"></td>
                        </tr>
                      </table>
                    </td>
                  </tr>   
                   	<tr>
			           		<td colspan="2">&nbsp;</td>
			           	</tr>	  
                 </table>
                </td>
               </tr>                  
                        
     <tr>
		 		<td colspan="2"><a id="AdvancedLink" href="javascript:shownHideAdv()" class="SMALLLINK">Advanced</a></td>
		 </tr>
		 <tr>
		    <td colspan="2">
		       <div id="advancedDiv" style="display:none">
		               <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">   
                      <tr>
                      	<td>
                      		<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">  
				                       <tr>
									                 <td width="150"><span class="REGULARTEXT">Refresh rate&nbsp;</span></td>
									                  <td width="574">
									           	         <select size="1" name="RefreshRate" id="RefreshRate">
									                      <option class="TEXTBOX" value="-1" <%=(refresh==-1) ? "selected":""%>>None</option>
									                       <%
									                      	for(int i=1;i<=5;++i){
									                        %>
									                        <option class="TEXTBOX" value="<%=String.valueOf(i)%>" <%=(refresh == i) ? "selected":""%> ><%=String.valueOf(i)%></option>
									                        <%
									                        	}
									                         %>
									                         <%
									                         	for(int i=10;i<=20;i=i+5){
									                          %>
									                         <option class="TEXTBOX" value="<%=String.valueOf(i)%>" <%=(refresh == i) ? "selected":""%> ><%=String.valueOf(i)%></option>
									                          <%
									                          	}
									                           %>
									                        </select>&nbsp; <span class="SMALLTEXT">minutes</span></td>
									                    <td width="76">&nbsp;</td>
									             </tr>
								               <tr>
								                    <td width="150">&nbsp;</td>
								                     <td width="574">
										                    <span class="SMALLTEXT">When viewing the log what is the interval of downloading the log file</span></td>
								                      <td width="76">&nbsp;</td>
								               </tr>				                                
				                       <tr>
				                          <td width="150"><span class="REGULARTEXT">Automatic data update&nbsp;</span></td>
				                          <td width="574">
				                       	    	<input type="checkBox" name="AutoUpdate" id="AutoUpdate" value="true" 
				                            	<%=isAutoUpdate ? " checked":""%>></input>
				                          	  <span class="SMALLTEXT">Select this option to update the viewed	data each time the log is being accessed</span>                       
				                          </td>
				                       </tr>		                       
                  		</table>
                  </td>
                  </tr>	
                  
							                <tr>
							                    <td width="800">&nbsp;</td>
				    		              </tr>
                  
                  
                 				 <jsp:include page="../fileFilterConfiguration.jsp" flush="true">
			                   	 <jsp:param name="logType" value="xmlLog" />
				                  </jsp:include>                       
		                  	   <tr>
							                    <td width="800">&nbsp;</td>
              					   </tr>                
                  
                  <tr>
                    <td width="800">
                        <span class="HEADER">Time Zone</span>
                    </td>
                  </tr>
                  <tr>
                    <td width="917">
                      <table border="0" width="800" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="170"><span class="REGULARTEXT">Log time zone</span></td>
                          <!--<td width="164"><font size="2">Data pattern</font></td>-->
                          <td width="630">
                          <select size="1" class="TEXTBOX" name="TimeZone" id="TimeZone">
                          <%
                            selected = "";
                            selected = isUsingDefaultTimeZone? "selected=\"true\"" : "";
                            %>
                             <option value="default" class="TEXTBOX" <%=selected%>>Default [<%=defaultZone.getID()%>]</option>
                            <%
                            for(int i=0;i<timeZonesArr.length;++i){
                              if(!isUsingDefaultTimeZone && timeZonesArr[i].equals(timeZoneId)){
                                selected = "selected=\"true\"";
                              }else{
                                selected = "";
                              }
                            %>
                            <option value="<%=timeZonesArr[i]%>" class="TEXTBOX" <%=selected%>><%=timeZonesArr[i]%></option>
                          <%}%>

                        </select></td>
                          <td width="83"></td>
                        </tr>
                        <tr>
                          <td width="190"></td>
                          <td width="664"><span class="SMALLTEXT">(if the log doesn't have a date field the time zone will be ignored).</span></td>
                          <td width="83"></td>
                        </tr>
                         <tr>
                          <td width="190"><textarea name="DataPattern" style="visibility:hidden" rows="1" cols="20"><%=logdatapat%></textarea></td>
                          <td width="664"></td>
                          <td width="83"></td>
                        </tr>
                        <tr>
                          <td width="150"></td>
                          <td width="550"> <!--<font size="1">Tools: <a href="http://">pattern
                            wizard,</a> <a href="http://">pattern verifier</a>.</font> --></td>
                          <td width="83"></td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                  
                  <tr>
                    <td width="800">
                        <span class="HEADER">Character Encoding</span>
                    </td>
                  </tr>
                  <tr>
                    <td width="800">
                      <table border="0" width="800" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="170"><span class="REGULARTEXT">Character set</span></td>
                          <td width="630">
                          <select size="1" class="TEXTBOX" name="charset" id="charset">
                          <%
                            selected = "";
                            selected = selectedCharset == null? "selected=\"true\"" : "";
                            %>
                             <option value="default" class="TEXTBOX" <%=selected%>>Default</option>
                            <%
                            for(int i=0;i<charsetArr.length;++i){
                              if(selectedCharset != null && charsetArr[i].equals(selectedCharset)){
                                selected = "selected=\"true\"";
                              }else{
                                selected = "";
                              }
                            %>
                            <option value="<%=charsetArr[i]%>" class="TEXTBOX" <%=selected%>><%=charsetArr[i]%></option>
                          <%}%>

                        </select></td>
                          <td width="83"></td>
                        </tr>
                        <tr>
                          <td width="170"></td>
                          <td width="630"><span class="SMALLTEXT">Use charset according the file encoding and machine charset support.</span></td>
                          <td width="83"></td>
                        </tr>
                                                
                      </table>
                    </td>
                  </tr>
		                                     
		                      </table>
		                      </div>
		                    </td>
		                  </tr>

                 			<tr>
                   			<td colspan="3">&nbsp;</td>
                 		</tr> 
                  
                  
                  
                  <tr>
                    <td width="800">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber17">
                      <tr>
                        <td width="20%">&nbsp;</td>
                        <td width="11%">
                        <p align="center"><a href="<%=BASE_DIRECTORY%>common/actions/cancelAction.jsp" class="LINK">cancel</a></td>
                        <% if (backwardURL != null){ %>
                        <td width="10%"><a href="<%=backwardURL%>" class="LINK">previous</a></td>
			<%}%>
                        <td width="3%"><a href="javascript:doNext()" class="LINK">next</a></td>
                      <td width="11%" align="center">
                        <% if(lbm != null){ %>
                        <a href="javascript:save()" class="LINK">save</a>
												<%}else{%>
												&nbsp;
												<%}%>
												</td>
                       <td width="32%">&nbsp;</td>

                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
              
      
      <tr>
        <td valign="bottom" height="5%" width="800">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>