<%@ page language="java"%>
 
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.data.log.external.IntervalDataSource"%>
<%@ page import="xpolog.eye.data.util.NameExpression"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@page import="xpolog.eye.admin.patterns.PatternAdminHelper"%>

<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%@ include file="../fileFilterConfigurationAction.jsp"%>


<%
  String ERROR_OBJ = "ERROR_OBJ";
  String LOG_NAME = "LogName";
  String LOG_DESCRIPTION = "LogDescription";
  String REFRESH_RATE = "RefreshRate";
  String PARENT_MODULE = "ParentModule";
  String HTTP_ACCOUNT = "accountId";
  String LOG_PATH = "LogPath";
  String LOG_DATA_PATTERN = "DataPattern";
  String LOG_ID = "LOG_ID";
  final String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_TIME_ZONE = "TimeZone";
  final String MODULE_ID = "MODULE_ID";
  String AUTO_UPDATE = "AutoUpdate";
  String NUM_OF_PATHS = "numOfPaths";
	String LOG_CHARSET = "charset";
	String IS_DUPLICATE_MODE = "isDuplicateMode";
 
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  final String modid      = request.getParameter(PARENT_MODULE);
  String parentApps = request.getParameter("parentApplication");
	HashSet applicationsIds = new HashSet();
  String[] appArr = null;
	if(parentApps != null && parentApps.length() >0){
		appArr = parentApps.split("#");
		for(int i = 0 ;	appArr != null &&  i < appArr.length ; i++){
			applicationsIds.add(appArr[i]);
		}		
	}  
  String logname    = request.getParameter(LOG_NAME);
  String logdesc    = request.getParameter(LOG_DESCRIPTION);
	ArrayList sourceList = new ArrayList();
  String logdatapat = request.getParameter(LOG_DATA_PATTERN);
  String timeZoneId = request.getParameter(LOG_TIME_ZONE);
  String httpId = request.getParameter(HTTP_ACCOUNT);
  String refrate = request.getParameter(REFRESH_RATE);
  String mediaType = "HttpMedia"; 
  String autoUpdateString = request.getParameter(AUTO_UPDATE);
  String charset    = request.getParameter(LOG_CHARSET);
  String isDuplicateModeStr = request.getParameter(IS_DUPLICATE_MODE);
  boolean isDuplicateMode = isDuplicateModeStr != null && isDuplicateModeStr.equals("true");
	String sortFilesStr = request.getParameter("sortFiles");
	boolean sortFilesByLastUpdate = sortFilesStr != null && sortFilesStr.equals("byLastUpdate");
  String dynamicFiles = request.getParameter("dynamicFiles");

	String op = request.getParameter("OP");
	if(op == null || op.length()==0){
		op = "ADD";
	}

	String logAdminScreenWidth = request.getParameter("LogAdminScreenWidth");
	if(logAdminScreenWidth == null || logAdminScreenWidth.length()==0){
		logAdminScreenWidth = "600px";
	}


	if (charset != null && charset.equals("default")){
  	 charset = null;
	}
  String LOG_LOCATION_PATH = "fullPath_";  
  String LOG_LOCATION_STATUS = "locationStatus_";    
  String LOCATIONS_CNTR = "locationCntr";
  String locationCntrStr      = request.getParameter(LOCATIONS_CNTR);
  int locationsCntr = 0 ;
  try{
  	locationsCntr = Integer.parseInt(locationCntrStr);
  }catch(NumberFormatException e){
  	locationsCntr = 0;
  }
  int fileBehavior = 0;
  String _fileBehavior = request.getParameter("fileBehavior");
  if(_fileBehavior != null && _fileBehavior.length() > 0){
		try{
			fileBehavior = Integer.parseInt(_fileBehavior);
		}catch(Exception e){
			fileBehavior = 0;
		}
  }
  String locationFullPath = "";
  String locationStatus = "";  
  NameExpression nameExpr = new NameExpression();
  ArrayList nameExprList = new ArrayList();
  for(int i = 0 ; i < locationsCntr ; i++){
  	String pathParam = LOG_LOCATION_PATH + i;
  	String statusParam = LOG_LOCATION_STATUS + i;
  	locationFullPath = request.getParameter(pathParam);
  	if(locationFullPath != null && locationFullPath.length() > 0){
  		int indx = locationFullPath.lastIndexOf("/");
  		if(indx < 0){
  			indx = locationFullPath.lastIndexOf("\\");
  		}
  		String dir = locationFullPath.substring(0,indx + 1);	
  		String pattern = locationFullPath.substring(indx+1,locationFullPath.length());
  		locationStatus = request.getParameter(statusParam);
  		int dynmicState;
  		try{
  			dynmicState = (locationStatus != null && locationStatus.length() > 0) ? Integer.parseInt(locationStatus) : 0;
  		}catch(NumberFormatException e){
  			dynmicState = 0;
  	  }
  		int dynmicStateToDisplay = dynmicState;
  		dynmicState = dynmicState < 0 ? fileBehavior : dynmicState;
  		nameExpr = new NameExpression();
  		nameExpr.setDirectory(dir);
  		nameExpr.setXpologNamePatternsStr(pattern);
  		nameExpr.setLogDynamicType(LogAdminHelper.convertToFileBehavior(dynmicState));
  		nameExpr.setLogDynamicTypeToDisplay(dynmicStateToDisplay);
  		nameExprList.add(nameExpr);
  	}
  }	

	
  //verify data
  ErrorModel errmodel = new ErrorModel();

  if(logname == null || logname.trim().equals("")){
    errmodel.addError("No name was supplied.");
  }
  if(WebUtil.isContainSpecialCharecter(logname)){
      errmodel.addError("The following characters are prohibited in the name field: "+WebUtil.getSpecialCharectersList());
  }
	if(nameExprList == null || nameExprList.size() == 0){
		errmodel.addError("please check log's path and pattern.");
	}
  String doSaveStr = request.getParameter("doSave");
  boolean doSave = doSaveStr != null && doSaveStr.length() > 0;

	if(logdatapat == null || logdatapat.trim().equals("")){
    errmodel.addError("No data pattern was supplied.");
  }

  if(modid == null || modid.trim().equals("")){
    errmodel.addError("No parent folder was selected. If no folder is available please check your permissions");
  }
  
  if(httpId == null || httpId.trim().equals("")){
    errmodel.addError("No Account was supplied.");
  }
  
  long refreshInterval = -1;
  try{
  	refreshInterval = Long.parseLong(refrate);
  }catch(Exception e){
  	errmodel.addError("Please supply a valid refresh rate.");
  }

  boolean autoUpdate = true;
  if (autoUpdateString == null || !autoUpdateString.equals("true")){
  	autoUpdate = false;
  }
  
  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("../errorpage.jsp");
    return;
  }

  FileFilterConfiguration fileFilterConfiguration = null;
	try {
		fileFilterConfiguration = createFileFilterConfiguration(request, response);
	}catch(Exception e) {
		errmodel.addError(e.getMessage());
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
	}
  LogBrowsingManager lbm = null;
  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  if(lbm != null && !lbm.getType().equals(HttpSimpleLogBuilder.HTTP_LOG_TYPE)){
	lbm = null;
  	request.getSession().removeAttribute(CURRENT_LOG);
  }

  final HttpSimpleLogBuilder builder = (HttpSimpleLogBuilder)LogBrowserBuilderFactory.getLogBroserBuilderByType(LogBrowserBuilderFactory.HTTP_LOG_TYPE);

  if(lbm != null){
    builder.setID(lbm.getId());
    builder.setIgnoreUnparsedRecords(LogAdminHelper.isIgnoreUnparsedRecords(lbm));
    builder.setUpdateLinesNumber(LogAdminHelper.isUpdateLinesNumber(lbm));
    logdatapat = LogAdminHelper.getXpologPattern(lbm);
  } 

  builder.setName(logname);
  builder.setApplicationsIds(applicationsIds);    
 	builder.setNameExprList(nameExprList);
  builder.setRecordPattern(logdatapat);
  builder.setLogDescription(logdesc);
  builder.setTimeZoneId(timeZoneId);
	builder.setCharset(charset);
	builder.setFileFilterConfiguration(fileFilterConfiguration);
  //builder.setDynamicFiles(dynamicFiles != null && dynamicFiles.equalsIgnoreCase("on"));
  builder.setFileBehavior(fileBehavior);
  builder.setSortByLastUpdate(sortFilesByLastUpdate);

  String [] pages = {"loggers/admin/logAdminGate.jsp?isPrevious=true&logType=http&OP=" + op,
  		     "loggers/admin/logDataPattern.jsp?OP=" + op + "&LogAdminScreenWidth=" + logAdminScreenWidth,
  		     "loggers/admin/logFieldAdmin.jsp"};
  AdminUIController controller = new AdminUIController(pages);
  builder.setUiController(controller);

  
  Media med = MediaManager.newInstace().getMediaByType(mediaType);
  
  Account acc = AddressBook.getInstance().getAccountById(httpId);
  
  builder.setMedia(med);
  builder.setAccount(acc);
  if(refreshInterval != -1){
  	refreshInterval = refreshInterval * 1000 * 60;
  }
  builder.setRefreshInterval(refreshInterval);
  builder.setAutoUpdate(autoUpdate);

  builder.setSourceLocationList(sourceList);
  
  builder.setDuplicateMode(isDuplicateMode);

  //audit
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  AuditManager auditMgr = AuditManager.getInstance();
  for(int i = 0 ;nameExprList != null &&  i < nameExprList.size() ; i++){    	
	  auditMgr.write(AuditConstants.BASIC_AUDIT_LEVEL,
  	userContext, AuditConstants.CHANGE, "create/edit log", AuditConstants.LOGS, "create/edit log " + logname + " path - " + ((NameExpression)nameExprList.get(i)).getDirectory()+((NameExpression)nameExprList.get(i)).getXpologNamePatternsStr()); 
  }
  
 	boolean isNew = lbm == null || lbm.getId() == null;
  
  if (doSave){
    builder.updateBuilder();
  
  	//save new log without setting pattern(gets first pattern from suggestion).
  	if(lbm == null && builder.getLogBrowserManager() != null){
  		String []events = LogAdminHelper.readLines(builder.getLogBrowserManager(),100);
			String xpoPattern = PatternAdminHelper.getFirstPattrernSuggestion(events);
			builder.setRecordPattern(xpoPattern);  		
			builder.updateBuilder();
  	}
  
  	lbm = builder.getLogBrowserManager();
  	LogBrowsingManager oldlbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  	if(oldlbm != null){
	  	lbm.setFilterManager(oldlbm.getFilterManager());
	    lbm.setRecordMask(oldlbm.getRecordMask());
	    LogAdminHelper.getLogRecordBuilder(lbm).setMergeColumns(LogAdminHelper.getMergeIndexing(oldlbm));   
	    lbm.setCustomizationManager(oldlbm.getCustomizationManager());
  	}
    Module parentmod = mgmt.getModuleFromId(modid);
    if(parentmod == null){
      parentmod = mgmt.getModuleFromId(modid);
    }
		IntervalDataSource ds = IntervalAdminHelper.getIntervalDataSource(lbm);
		if(ds != null) {
			ds.setLogBrowserId(lbm.getId());
		}
    builder.setDynamicFiles(LogAdminHelper.isDynamicFiles(lbm));				
	  LogAdminHelper.updateLogApplicationsMetas(lbm.getId(),applicationsIds);
	  
	  LogAdminHelperQuery reindexQuery = new LogAdminHelperQuery();
		reindexQuery.setLbm(lbm);
		reindexQuery.setHandleSortByLastUpdate(true);
		boolean shouldReindex = LogAdminHelper.shouldReindex(reindexQuery);
	  
	  String newId = admin.addLogBrowser(lbm,parentmod,userContext);
    if(isNew && newId != null && newId.length() > 0) {
	  	String[] lbmIds = new String[1];
	  	lbmIds[0] = lbm.getId();
	  	admin.generateLogData(lbmIds, userContext);
	  }
    request.getSession().setAttribute(CURRENT_LOG,lbm);
    
    if(shouldReindex) {
    	LogAdminHelper.reindexLog(userContext, lbm.getId());
    }
    
    auditMgr.write(AuditConstants.BASIC_AUDIT_LEVEL,
  	userContext, AuditConstants.CHANGE, "save/edit log", AuditConstants.LOGS, "change the log " + lbm.getName()); 
	  env.setTempAttribute(SiteConstants.FORWARD_URL_ATTRIBUTE,"loggers/admin/logaddopok.jsp?removeLog=" + !builder.isLogCanBeUsed());
  	response.sendRedirect(BASE_DIRECTORY + "common/actions/nextAction.jsp");
  	return;
  }
  request.getSession().setAttribute("IS_NEW", Boolean.valueOf(isNew));

  final UserEnvironment _env = UserEnvironment.getUserEnvironment(request);
  
  ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + controller.getForwardPage()) {
      public void run(HttpServletRequest request){
        try{
         //for configuration reasons
    	builder.updateBuilder();
        }catch(Exception e){
          errmodel.addError("Building log problem,please check patterns and path again.");
    	errmodel.addError(e.getMessage());
          createErrorRedirect(request,BASE_DIRECTORY);
        }
        request.getSession().setAttribute(MODULE_ID,modid);
  	request.getSession().setAttribute(BUILDER,builder);
  	  }
	 };
   _env.setProgressRunner(runner);
%>


<jsp:include page="../../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Processing"/>
 <jsp:param name="forceRedirect" value="true"/>
</jsp:include>