<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.AdministrationPermissions.ADD_LOG_PERMISSION,true)){
     return;
  }
  
  String BASE_DIR = "base_directory";
	String baseDir = request.getParameter(BASE_DIR);
	if (baseDir == null || baseDir.equals("")) {
		baseDir = "";
	}
  String ERROR_OBJ = "ERROR_OBJ";
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  Module[] mdarr = mgmt.getAllModules(userContext,true);  
  if(mdarr == null || mdarr.length==0) {
	  ErrorModel errmodel = new ErrorModel();
	  errmodel.addError("No available folders were found");
	  errmodel.addError("Please check your application constraints");
	  request.getSession().setAttribute(ERROR_OBJ,errmodel);
	  response.sendRedirect("errorpage.jsp");
	  return;
  }
  
  
  //remove the current log
  String CURRENT_LOG = "CURRENT_LOG";
  request.getSession().removeAttribute(CURRENT_LOG);
  
  String BUILDER = "CURRENT_LOG_BUILDER";
  request.getSession().removeAttribute(BUILDER);
  
  String parentModuleId = request.getParameter("PARENT_MODULE");
  if (parentModuleId != null && parentModuleId.length() > 0){
    try {
      Module parentModule = mgmt.getModuleFromId(parentModuleId);
      if (parentModule != null){
        request.getSession().setAttribute("CURRENT_MODULE",parentModule);
      }
    }catch (Exception e){}
    
  }
%>

<script>


	function go(){
		
		var locationPath = "";
		var logSource = document.getElementById("logsProtocols").value;
		var logType = document.getElementById("logsTypes").value;
		
		
	
		if(logSource == "logProtocolSelection"){
			alert("Please select log's protocol source.");
			return;
		}
		switch(logSource){
			case "WindowsEvent":
				locationPath = "winevent/winEventAdmin.jsp?OP=ADD";break;
			case "Merged":
				locationPath = "merge/logmergeadmin.jsp?OP=ADD";break;
			case "DB":
				locationPath = "database/addLogDB.jsp?OP=ADD";break;
			case "Remote":
				locationPath = "remote/logRemoteAdmin.jsp?OP=ADD";break;
			case "Manual":
				if(logType == "XML"){		
					locationPath = "xml/xmlLogAdmin.jsp?OP=ADD";
				}else{
					locationPath = "logadmin.jsp?OP=ADD";
				}
				break;	
			case "Ssh":
				if(logType == "XML"){		
					locationPath = "ssh/logSshAction.jsp?TYPE=XML&OP=ADD";
				}else{
					locationPath = "ssh/logSshAction.jsp?TYPE=MANUAL&OP=ADD";
				}
				break;	
		  case "Ftp":
				if(logType == "XML"){		
					locationPath = "xml/xmlLogAdmin.jsp?OP=ADD";
				}else{
					locationPath = "ftp/logFtpAction.jsp?TYPE=MANUAL&OP=ADD";
				}
				break;	
		  case "Http":
				if(logType == "XML"){		
					locationPath = "http/logHttpAction.jsp?TYPE=XML&OP=ADD";
				}else{
					locationPath = "http/logHttpAction.jsp?TYPE=MANUAL&OP=ADD";
				}
				break;	
		  case "Encrypt":
				if(logType == "XML"){		
					locationPath = "xml/xmlLogAdmin.jsp?OP=ADD&useZipPwd=true";
				}else{
					locationPath = "logadmin.jsp?OP=ADD&useZipPwd=true";
				}
				break;
		}	
			if(locationPath){
				close();
				locationPath = "loggers/admin/" + locationPath;
				document.location = locationPath;
			}else{
				alert("Please select log's source / type."); 
			}			
	}
	
	 function updateProtocol(protocol){
	  	if(protocol == "WindowsEvent" || protocol == "Merged" || protocol == "DB" || protocol == "Remote"){
				document.getElementById("logsTypes").disabled = true;			
			}else{
				document.getElementById("logsTypes").disabled = false;
		 }
	 }
	 
	 function close(){
	 	document.getElementById("addLogDiv").style.display = "none";
	 	document.getElementById("addLogframe").style.display = "none";	 		 	
		var protocolsElem = document.getElementById("logsProtocols");
		if(protocolsElem){
			protocolsElem.selectedIndex = 0;
		}
		var logsTypesElem = document.getElementById("logsTypes");
		if(logsTypesElem){
			logsTypesElem.selectedIndex = 0;
			logsTypesElem.disabled = false;
		}
	 }
	 
	
</script>
<div id="addLogDiv" style="position:absolute;height:250px;width:550px;display:none;z-index:110">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" bgcolor="white"  style="border: solid 2px;border-color:#CCCCCC">
  <tr>
  	  <td>	
 	 	  <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" >
  			<tr height="50px">
		  	  <td>	
		  	  &nbsp;
		      </td>
		   </tr>
		   <tr>
		  	  <td>	
		  	  	  <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" >
					  	<tr>
					  	  <td width="50px" height="100%">	
					 	 				&nbsp;
					      </td>
					      <td width="450px" height="100%">		
					 	 	<table  border="0" width="100%"  cellspacing="0" height="100%" cellpadding="0" bgcolor="#CCCCCC">							  
							  <tr>
							  	  <td width="111px">
							  	  		<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" >
							  	  			<tr>
							  	  				<td  height="43px">&nbsp;</td>
							  	  			</tr>
							  	  			<tr>
							  	  				<td  height="25px">
							  	  					<span style="font:arial;font-size:11;font-weight:bold;">&nbsp;&nbsp;Action: </span>
							  	  				</td>
							  	  			</tr>
							  	  			<tr>
							  	  				<td  height="100%">&nbsp;</td>
							  	  			</tr>
							  	  		</table>
							  	  </td>	
							  	  <td>	
							 	 		<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" align="center" valign="middle">
										  <tr>
										  	<td>&nbsp;</td>
										  	<td>&nbsp;</td>
										  </tr>
										  <tr>
										  	  <td width="100px">&nbsp;</td>	
										  	  <td width="80%">	
										 	 	<select size="1" style="width:280px" class="TEXTBOX" name="logsProtocols" id="logsProtocols" onChange="updateProtocol(this.value);">
										 	 		<option class="TEXTBOX" value="logProtocolSelection" selected> -- Protocol Source -- </option>
										 	 		<option class="TEXTBOX" value="Manual" >MANUAL</option>
										 	 		<option class="TEXTBOX" value="Ssh" >SSH</option>
										 	 		<option class="TEXTBOX" value="Ftp" >FTP</option>
										 	 		<option class="TEXTBOX" value="Http" >HTTP</option>
										 	 		<option class="TEXTBOX" value="DB" >DATABASE</option>
										 	 		<option class="TEXTBOX" value="Remote" >REMOTE</option>
										 	 		<option class="TEXTBOX" value="Merged" >MERGED LOGS</option>
										 	 		<option class="TEXTBOX" value="WindowsEvent" >WINDOWS EVENT LOG</option>
										 	 		<option class="TEXTBOX" value="Encrypt" >ENCRYPT ZIP</option>
										 	 	</select>
										      </td>
										  </tr>										  
										  <tr>
										    <td width="100px">&nbsp;</td>
										  	<td width="80%">	
										 	 	<select size="1" style="width:280px" class="TEXTBOX" name="logsTypes" id="logsTypes" >
										 	 		<option class="TEXTBOX" value="logsType" selected> -- Log Type -- </option>
										 	 		<option class="TEXTBOX" value="Text" >TEXT</option>
										 	 		<option class="TEXTBOX" value="XML" >XML</option>										 	 		
										 	 	</select>
										      </td>
										  </tr>
										  <tr>
										  	<td>&nbsp;</td>
										  </tr>
										</table>
							      </td>
							      <td width="3px">&nbsp;</td>
							      <td width="100px">
							  	  		<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" >
							  	  			<tr>
							  	  				<td  height="120px">&nbsp;</td>
							  	  			</tr>
							  	  			<tr>																					  	  			
							  	  				<td  height="20px">
							  	  					<span style="font:arial;font-size:12;font-weight:bold;"><a href="javascript:go()">go</a></span>
							  	  				</td>
						  	  					<td width="3px">&nbsp;</td>
							  	  				<td  height="100%">
							  	  				<span style="font:arial;font-size:12;font-weight:bold;"><a href="javascript:close()">close</a></span>
							  	  				</td>
							  	  			</tr>							  	  			
							  	  		</table>
							  	  </td>	
							  </tr>
							</table>
					      </td>		
					      <td width="50px">	
		  	  				&nbsp;
		      			</td>			      
					  </tr>
    			 </table>
		      </td>
		   </tr>
  			<tr width="100%" height="50px">
		  	  <td>	
		  	  		&nbsp;
		      </td>
		   </tr>		   
		 </table>
      </td>
  </tr>
</table>
</div>
<iframe id="addLogframe" src="<%=baseDir%>empty.html"  style="position:absolute;height:248px;width:548px;display:none;z-index:100" ></iframe> 
