<%@page import="xpolog.eye.merge.MergeCustomizationManager"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.linear.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.data.xml.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.log.files.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.menu.*" %>

<%

  String ERROR_OBJ = "ERROR_OBJ";
  String COL_INDEX = "COL_INDEX_";
  String CURRENT_LOG = "CURRENT_LOG";
  String COLOR_PARAM = "COLOR_PARAM_";
  String COLOR_PRIOR_NAME = "COLOR_PRIOR_NAME_";

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  UserContext userContext = UserEnvironment.getUserContext(request);
  LogBrowsingManager lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  CustomizationManager cuman = null;
  RecordMask mask = null;

  if(lbm == null){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("You must select a log first.");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  
  //lines number issue
  boolean lineNumberChanged = false;
  String logId = null;
  
  //statistics
  String computeStatisticsStr = request.getParameter("computeStatisticsStr");
  boolean computeStatistics = computeStatisticsStr != null && computeStatisticsStr.equalsIgnoreCase("on");
  lbm.setComputeStatistics(computeStatistics);
  
  LinearDataSource linearDS = lbm.getLinearDataBuilder().getLinearDataSource();
  MultiFilesDataSource ds = null;
  if(linearDS instanceof MultiFilesDataSource) {
      ds = (MultiFilesDataSource)linearDS;     
      String useIndexingStr = request.getParameter("useIndexingStr");
      boolean useIndexing = useIndexingStr != null && useIndexingStr.equalsIgnoreCase("true");
      lbm.setUseIndexing(useIndexing);
  	  String useIndexingForDateSearchStr = request.getParameter("useIndexingForDateSearchStr");
  	  boolean useIndexingForDateSearch = useIndexingForDateSearchStr != null && useIndexingForDateSearchStr.equalsIgnoreCase("true");
  	  lbm.setUseIndexingForDateSearch(useIndexingForDateSearch);
  }else if(linearDS instanceof XMLElementDataSource) {
      ds = ((XMLElementDataSource)linearDS).getDataSource();       
      String useIndexingStr = request.getParameter("useIndexingStr");
      boolean useIndexing = useIndexingStr != null && useIndexingStr.equalsIgnoreCase("true");
      lbm.setUseIndexing(useIndexing);
  	  String useIndexingForDateSearchStr = request.getParameter("useIndexingForDateSearchStr");
  	  boolean useIndexingForDateSearch = useIndexingForDateSearchStr != null && useIndexingForDateSearchStr.equalsIgnoreCase("true");
  	  lbm.setUseIndexingForDateSearch(useIndexingForDateSearch);
  }
  
  if (ds != null){
     String updateLinesNumberStr = request.getParameter("updateLinesNumberStr");
     boolean updateLinesNumber = updateLinesNumberStr != null && updateLinesNumberStr.equalsIgnoreCase("on");
     //clean the log from session and update ds only if changed
     if(ds.isUpdateLines() != updateLinesNumber) {
     	 lineNumberChanged = true;
      	logId = lbm.getId();
      	ds.setUpdateLines(updateLinesNumber);
       request.getSession().removeAttribute(CURRENT_LOG);
     }
   }
  
  
  String consolidationStr = request.getParameter("consolidationStr");
  boolean consolidation = consolidationStr != null && consolidationStr.equalsIgnoreCase("on");
  lbm.setConsolidation(consolidation);

  String singleZoomInStr = request.getParameter("singleZoomInStr");
  boolean singleZoomIn = singleZoomInStr != null && singleZoomInStr.equalsIgnoreCase("on");

  String[] selCols = request.getParameterValues("CustomizedColSelect");
   
  //search and filter issue
  String searchAndFilterDefStr = request.getParameter("searchAndFilterDefStr");
  boolean searchAndFilterDef = searchAndFilterDefStr != null && searchAndFilterDefStr.equalsIgnoreCase("on");
  if(searchAndFilterDef) {
  	searchAndFilterDefStr = "START";
  }else {
  	searchAndFilterDefStr = "CURRENT";
  }
  lbm.setSearchAndFilterDef(searchAndFilterDefStr);

  String quickFilterStr = request.getParameter("useQuickFilter");
  boolean useQuickFilter = quickFilterStr != null && quickFilterStr.equalsIgnoreCase("on");
  lbm.setUseQuickFilter(useQuickFilter);
  
  String wholeWordsStr = request.getParameter("useWholeWords");
  boolean useWholeWords = wholeWordsStr != null && wholeWordsStr.equalsIgnoreCase("on");
  lbm.setUseWholeWords(useWholeWords);
  
  cuman = lbm.getCustomizationManager();
  mask = lbm.getRecordMask();

  int[] indexs = new int[mask.getCulomnsNumber()];
  int[] cols = new int[mask.getCulomnsNumber()];
  String clp = null;
  boolean atLeatOne = false;
  if (selCols != null && selCols.length > 0){
	  for(int i=0;i<indexs.length;i++){
	    cols[i] = i;
	    indexs[i] = -1;
	    for (int j=0; j<selCols.length; j++){
	    	if (selCols[j].equals(String.valueOf(i))){
	    		indexs[i] = j;
	    		break;
	    	}
	    }
	    atLeatOne = true;
	  }
  }
  
  if(!atLeatOne){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("You must specify at least one visible column.");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect("errorpage.jsp");
    return;
  }

  cuman.setCustomizationColumns(cols,indexs);
  lbm.updateMappingFromCustomization();

	/*
  LinearDataBuilder linearDataBuilder = lbm.getLinearDataBuilder();
  if (linearDataBuilder instanceof DefaultLinearDataBuilder){
  	LinearRecordsBuilder recsBuilder = ((DefaultLinearDataBuilder)linearDataBuilder).getLinearRecordsBuilder();
	  LinearRecordBuilder recBuilder = recsBuilder.getLinearRecordBuilder();
	  if (recBuilder instanceof TransactionRecordBuilder){
	  	((TransactionRecordBuilder)recBuilder).setColsMapping(cuman.getIndexToPlace());
	  }else if(lbm instanceof TransactionMergedLogBrowserManager){
	  	((TransactionMergedLogBrowserManager)lbm).setLogColsMappings();
	  }
  }
  */
   
  //Priorities color handling if exsit
  String[] priorities = null;
  int cnum = mask.getCulomnsNumber();
  int pindex = -1;
  for(int i=0;i<cnum;++i){
    if((mask.getMaskColumn(i) instanceof PriorityMask)){
      pindex = i;
      priorities = ((PriorityMask)mask.getMaskColumn(i)).getPriorities();
      //must leave this place
     // priorities = new String[]{"DEBUG" ,"INFO","WARN" ,"ERROR" ,"FALSE"};
    }
  }

  if(priorities != null){
  	String usePriorityColorsStr = request.getParameter("usePriorityColors");
  	boolean usePriorityColors = usePriorityColorsStr != null && usePriorityColorsStr.equals("true");
    HashMap pToColor = new HashMap();
    String color = "";
    for(int i=0;i<priorities.length;++i){
      color = request.getParameter(COLOR_PRIOR_NAME + i);
      if(color == null){
        color = "";
      }
      pToColor.put(priorities[i],color);
    }
    cuman.setUsePriorityBgColor(usePriorityColors);
    cuman.setPriorityColorMap(pToColor);
    cuman.setPriorityIndex(pindex);
  }

  String startOperation = request.getParameter("startOperation");
  if (startOperation != null && startOperation.trim().length() > 0){
    cuman.setStartOperation(startOperation);
  }
  //set customization to work from private conf and not from global customization
  cuman.setUseGlobal(false);
  
  cuman.clearMenues("logDataCM");
  HashMap map = new HashMap();
  int count = 0;
  int total = 0;
  boolean clearSearchItems = true;
  String col = request.getParameter("contextSearchCol0");
  while (col != null && col.length() > 0){
  	String name = request.getParameter("contextSearchName" + count);
    String path = request.getParameter("contextSearchPath" + count);
    if (name == null || name.length() == 0 || path == null || path.length() == 0){
    	count++;
    	col = request.getParameter("contextSearchCol" + count);
    	continue;
    }
    
    MenuItem item = new MenuItem();
    item.id = "customSearch" + total++;
    item.name = name;
    item.link = path;
    item.target = "_new";
    item.componentsMask = MenuItem.ALL_MASK;
    PopupMenu menu = (PopupMenu)map.get(col);
    MenuGroup group = new MenuGroup();
    if (menu == null){
      menu = new PopupMenu();
      menu.setPopupId("logDataCM");
      map.put(col,menu);     
      group.id = "search";
      group.name = "Search";
      group.componentsMask = MenuItem.ALL_MASK;
      menu.addItem(group);
    }else {
    	group = (MenuGroup)menu.getItem("search");
    	
    }
    
    if (group != null){
    	if (clearSearchItems){
    		group.items.clear();
    		clearSearchItems = false;
    	}
    	group.items.add(item);
    }
    
  	count++;
  	col = request.getParameter("contextSearchCol" + count);
  }
  for (Iterator iter = map.keySet().iterator();iter.hasNext();){
  	String key = (String)iter.next();
  	int index = Integer.parseInt(key);
  	PopupMenu menu = (PopupMenu)map.get(key);
  	cuman.addPopupMenues(index,menu);
  }
  
  if (cuman instanceof MergeCustomizationManager){
  	MergeCustomizationManager mergeCuman = (MergeCustomizationManager)cuman;
  	mergeCuman.setZoomInToSingleLog(singleZoomIn);
  }
  
  UserSecurity security = WebSecurityManager.getInstance().getUserSecurity(request);
  if (security == null || security.isModuleMemberEditable(lbm.getId())){
    Module parent = mgmt.getParentModule(lbm.getId());
    admin.addLogBrowser(lbm,parent,userContext);
  }
  Integer calls = (Integer)request.getSession().getAttribute("callsPage");
  String calStr = "calls=";
  if (calls != null){
	calStr += calls.intValue() + 1;
  }

  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			userContext, AuditConstants.CHANGE, "save/edit log", AuditConstants.LOGS, "change customization of log " + lbm.getName());
  
  if(lineNumberChanged) {
  	response.sendRedirect("../logview.jsp?logid="+logId);
  }else {
  	response.sendRedirect("../logview.jsp");
  }
%>
