<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.merge.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="xpolog.eye.media.http.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.data.log.external.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.data.xml.*"%>
<%@ page import="xpolog.eye.media.ftp.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.remote.*"%>

<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
  //constants

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.AdministrationPermissions.EDIT_LOG_PERMISSION,true)){
     return;
  }
  SiteManagment mgmt = SiteManagment.getInstance();
  UserSecurity security = manager.getUserSecurity(request);
  String CURRENT_LOG = "CURRENT_LOG";
  String CURRENT_MODULE = "CURRENT_MODULE";
  String  LOG_ID = "LOG_ID";
  String ERROR_OBJ = "ERROR_OBJ";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String IS_DUPLICATE_MODE = "isDuplicateMode";
  
  request.getSession().removeAttribute(BUILDER);
   LogBrowsingManager lbm = null;
  String id = request.getParameter(LOG_ID);
  try{
	  if((id != null) && !(id.trim().equals(""))){
	    lbm = SiteManagment.getInstance().getLogBrowserManager(id);
	  }else{
	    lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
	  } 
  }catch(Exception e){
	  	ErrorModel ermod = new ErrorModel();
	    ermod.addError("XpoLog Failed to load log due to the following error:");
	    ermod.addError(e.getMessage());
        request.getSession().setAttribute(ERROR_OBJ,ermod);
        response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
        return;
  }
  

  if (lbm != null){
  	request.getSession().setAttribute(CURRENT_LOG,lbm);
    id = lbm.getId();
    if (id != null && id.length() > 0 && security != null && !security.isModuleMemberEditable(id)){
      response.sendRedirect(BASE_DIRECTORY + "security/common/operationDenied.jsp");
      return;
    }
    String modId = "";
    Module pmod = id != null ? mgmt.getParentModule(id) : null;
    if (pmod == null){
      pmod = (Module)request.getSession().getAttribute(CURRENT_MODULE);
    }
    if (pmod != null){
    	modId = pmod.getId();
    }
    
    
    request.getSession().setAttribute(CURRENT_LOG,lbm);
    request.getSession().removeAttribute("MODULE_ID");
    String type = lbm.getType();
    String dataType = "";
    DataSource dc1 = lbm.getDefaultLinearDataBuilder().getDataSource();
    DataSource dc = null;
    if(dc1 instanceof XMLElementDataSource){
    	dc = ((XMLElementDataSource)dc1).getDataSource();
    	dataType = "xml";
    }else{
    	dc = dc1;
    }
    
    String isDuplicateModeStr = request.getParameter(IS_DUPLICATE_MODE);
    boolean isDuplicateMode = isDuplicateModeStr != null && isDuplicateModeStr.equals("true");
     
    if(dc instanceof IntervalDataSource){
      if (type != null && type.equals(SQLLogSimpleBuilder.SQL_LOG_TYPE)) {
				type = "db";
      }
    	IntervalDataSource dct = (IntervalDataSource)dc;
    	Media media = dct.getPumperManager().getMedia();
    	if (media.getType().equals(DBMedia.DB_MEDIA_TYPE)){
				type = DBAccount.TYPE_DB;
    	}else if (media.getType().equals(HttpMedia.HTTP_MEDIA_TYPE)){
				type = HttpAccount.TYPE_HTTP;
    	}else if (media.getType().equals(FTPManager.FTP_MEDIA_TYPE)){
    		type = FTPAccount.TYPE_FTP;
    	}else if (media.getType().equals(TelShManager.SSH_MEDIA_TYPE)){
    		type = TelnetAccount.TYPE_SSH;
    	}
        //return;
   }
   if (type != null && type.length() > 0){
      if (type.equals(SimpleLogBrowserBuilder.SIMPLE_LOG_TYPE)){
      	if(LogAdminHelper.getAuthenticationAccount(lbm) != null){
        	type = "auth";
        }else{
        	type = "local";
        }
      }else if (type.equals(XMLLogBrowserBuilder.XML_LOG_TYPE) ){
					dataType = "xml";
					if(XMLLogAdminHelper.getAuthenticationAccount(lbm) != null){
	        	type = "auth";
	        }else{
	        	type = "local";
	        }
      }else if (type.equals(MergedLogBrowserBuilder.MERGE_LOG_TYPE)){
					type = "merge";
      }else if (type.equals(WinEventLogBuilder.EVENT_VIEWER_TYPE)) {
						type = "winEvent";	
	    }else if (type.equals(SshSimpleBuilder.SSH_LOG_TYPE) ){
	        type = "ssh";
    }else if (type.equals(OnlineDBSimpleLogBuilder.ONLINE_DB_LOG_TYPE) ||  type.equals(OnlineDBSimpleLogBuilder.ONLINE_DB_CACHE_LOG_TYPE)){
		      type = "db";
					dataType = "simple";
      }
   }

    if(lbm != null){
      request.getSession().setAttribute(CURRENT_LOG,lbm);
      if(lbm instanceof xpolog.eye.remote.ProxyLogBrowser){
					type = "remote";
      }
    }
    response.sendRedirect("logAdminGate.jsp?isDuplicateMode=" + isDuplicateMode + "&dataType=" + dataType + "&logType="  + type + "&OP=EDIT&PARENT_MODULE=" + modId);
    return;
 }

%>

<%@page import="xpolog.eye.admin.helpers.LogAdminHelper"%>
<%@page import="xpolog.eye.admin.helpers.XMLLogAdminHelper"%>
<body>
<script>
javascript:history.go(-1);
</script>
</body>
