<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.merge.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>

<%@ page import="java.util.*"%>
<%!static final String BASE_DIRECTORY = "../../../";

	//tree issues
	String getTreeDiv(Module node, UserContext userContext, HashMap modules,
			HashMap logs) {
		ArrayList list = new ArrayList();
		StringBuffer buffer = new StringBuffer();
		if (modules == null) {
			modules = new HashMap();
			getModulesFromLogs(node ,modules, logs);
		}

		if (node != null) {
			boolean selected = modules == null
					|| modules.containsKey(node.getId());
			String treeKey = "node" + node.getId() + "_0";
			String chkKey = node.getId().equals(Module.ROOT_MODULE_ID) ? "root"
					: "modules";
			buffer.append("\nvar " + treeKey + " = tree.addNode(tree.root,\""
					+ chkKey + "\",\"" + node.getId() + "\",\""
					+ node.getName() + "\",\"" + node.getDescription()
					+ "\",''," + selected + ",true);");
			addChildsNodeDiv(node, buffer, treeKey, userContext, modules, logs);
		}
		return buffer.toString();
	}

	void addChildsNodeDiv(ModuleMember node, StringBuffer buffer,
			String parentKey, UserContext userContext, HashMap modules, HashMap logs) {
		Module mod = null;
		if (node.getType().equals(Module.MODULE_TYPE)) {
			try {
				mod = SiteManagment.getInstance().getModuleFromId(node.getId());
			} catch (Exception e) {
				return;
			}
		} else {
			return;
		}
		List children = mod.getModuleMembers(userContext);
		SiteManagment mgmt = SiteManagment.getInstance();
		for (int i = 0; i < children.size(); i++) {
			ModuleMember child = (ModuleMember) children.get(i);
			//if it is a log - finding the type in order not to include db,http,merge.
			if (child.getType() != null && child.getType().equals("Log")) {
				try {
					//ignore logs without date or other merges
					LogBrowsingManager lbm = mgmt.getLogBrowserManager(child.getId(),false,true,true);
					if (lbm == null || lbm.getRecordMask().getDateColumnIndex() < 0	|| (lbm instanceof MergedLogBrowserManager)) {
						continue;
					}
				} catch (Exception e) {
					continue;
				}
			}

			String key = child.getId();
			String treeKey = parentKey + "_" + i;
			String parentNode = parentKey.equals("node") ? "tree.root"
					: parentKey;

			String extraText = "";

			boolean selected = false;
			String chkKey = "logs";
			if (child.getType().equals(Module.MODULE_TYPE)) {
				selected = modules == null
						|| modules.containsKey(child.getId());
				chkKey = "modules";
			} else {
				selected = logs == null || logs.containsKey(child.getId());
			}

			buffer.append("\nvar " + treeKey + " = tree.addNode(" + parentNode
					+ ",\"" + chkKey + "\",\"" + child.getId() + "\",\""
					+ child.getName() + "\",\"" + child.getDescription()
					+ "\",'" + extraText + "'," + selected + ",false);");
			addChildsNodeDiv(child, buffer, treeKey, userContext, modules, logs);

		}
	}

	//check which module should be selected
	void getModulesFromLogs(Module mod, HashMap mods, HashMap logs) {		
		List mem = mod.getModuleMembers();
		ModuleMember[] members = null;
		
			members = (ModuleMember[]) mem.toArray(new ModuleMember[mem.size()]);
		
		Module current = null;
		for (int i = 0; i < members.length; i++) {
			if (members[i].getType().equals(Module.MODULE_TYPE)) {
					try {
						current = SiteManagment.getInstance().getModuleFromId(members[i].getId());
					} catch (Exception e) {
						return;
					}				
				getModulesFromLogs(current, mods, logs);
			} else {
				if (logs.containsKey(members[i].getId())) {
					mods.put(mod.getId(), mod.getName());
					try {
						Module parentModule = SiteManagment.getInstance().getParentModule(mod.getId());					
						
						while(parentModule != null && !mods.containsKey(parentModule.getId())) {
							mods.put(parentModule.getId(),parentModule.getName());
							parentModule = SiteManagment.getInstance().getParentModule(parentModule.getId());
						}
					}catch(Exception e) {						
					}
					break;
				}
			}
		}
	}

	%>

<%//constants
			String OP = "OP";
			String ADD = "ADD";
			String LOG_ID = "LOG_ID";
			String BUILDER = "CURRENT_LOG_BUILDER";
			String CURRENT_LOG = "CURRENT_LOG";
			String LOG_NAME = "LOG_NAME";
			String LOG_DESCRIPTION = "LOG_DESCRIPTION";
			String MODULE_ID = "MODULE_ID";
			String CURRENT_MODULE = "CURRENT_MODULE";
			String LOG_TIME_ZONE = "LOG_TIME_ZONE";
			String LOG_INDEX_PARAM = "LOG_INDEX_"; //+ int for its index
			String TOTAL_LOG_TO_MERGE = "TOTAL_LOG_TO_MERGE";
			String emtpy = "";
			//page data
			String modid = emtpy;
			String logname = emtpy;
			String logdesc = emtpy;
			boolean isUsingDefaultTimeZone = true;
			TimeZone defaultZone = TimeZone.getDefault();
			String timeZoneId = defaultZone.getID();
			String selectedCharset = null;
			LogBrowsingManager[] mergedLogs = new LogBrowsingManager[0];
			HashMap merge = new HashMap();
			//site management
			SiteManagment mgmt = SiteManagment.getInstance();
			SiteAdministrator admin = SiteManagment.getAdminInstance();

			UserContext userContext = UserEnvironment.getUserContext(request);

			MergedLogBrowserManager lbm = null;

			String backwardURL = null;
			boolean isEdit = false;

			Module[] mdarr = mgmt.getAllModules(userContext, true);
			ModuleMember curmod = new ModuleMember();
			Module pmod = null;

			String addop = request.getParameter(OP);
			if (addop != null && addop.equalsIgnoreCase(ADD)) {
				request.getSession().removeAttribute(CURRENT_LOG);
				backwardURL = "../logAdminGate.jsp";
			} else {
				MergedLogBrowserBuilder builder = (MergedLogBrowserBuilder) request
						.getSession().getAttribute(BUILDER);
				if (builder != null) {
					lbm = builder.getMergeLogBrowser();
				}
				if (lbm == null) {
					Object tmp = request.getSession().getAttribute(CURRENT_LOG);
					if (tmp != null && tmp instanceof MergedLogBrowserManager) {
						lbm = (MergedLogBrowserManager) tmp;
					}
				}
				if (lbm != null) {
					logname = lbm.getName();
					logdesc = lbm.getDescription();
					timeZoneId = lbm.getTimeZone().getID();
					selectedCharset = lbm.getCharset();
					isUsingDefaultTimeZone = lbm.isUsingDefaultTimeZone();
					mergedLogs = lbm.getLogBrowsers();
					//check this part
					for (int i = 0; i < mergedLogs.length; ++i) {
						merge.put(mergedLogs[i].getId(), mergedLogs[i].getName());
					}
					isEdit = true;

					try {
						pmod = mgmt.getParentModule(lbm.getId());
					} catch (Exception e) {
					}
				}
			}

			//check state
			String op = request.getParameter(OP);
			if ((op != null) && op.trim().equals(ADD)) {
				//we are adding a new browser
				request.getSession().removeAttribute(CURRENT_LOG);
			} else {

			}
			if (pmod == null) {
				pmod = (Module) request.getSession().getAttribute(
						CURRENT_MODULE);
				if (pmod == null) {
					pmod = new Module();
					pmod.setId("");
				}
			}

			if (isEdit && pmod != null) {
				boolean foundModule = false;
				for (int i = 0; i < mdarr.length; i++) {
					if (mdarr[i].getId().equals(pmod.getId())) {
						foundModule = true;
						break;
					}
				}
				if (!foundModule) {
					Module[] tmparr = new Module[mdarr.length + 1];
					System.arraycopy(mdarr, 0, tmparr, 0, mdarr.length);
					mdarr = tmparr;
					mdarr[mdarr.length - 1] = pmod;
				}
			}

			if (mdarr.length == 0) {
				Module tmpMod = new Module();
				tmpMod.setId("");
				mdarr = new Module[] { tmpMod };
			}

			String[] timeZonesArr = TimeZone.getAvailableIDs();
			Arrays.sort(timeZonesArr);

			Map charsetMap = java.nio.charset.Charset.availableCharsets();
			String[] charsetArr = (String[]) charsetMap.keySet().toArray(
					new String[charsetMap.size()]);

			//tree issues

			String listTitle = "Logs to Merge";
			String listDesc = "Select the logs that will create the merged log. Only logs with date field can be merged.";
  String selected = "";
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script src="<%=BASE_DIRECTORY%>scripts/tree/rightClickMenu.js"></script>
<jsp:include page="../../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<script>
	  baseDirectory = "<%=BASE_DIRECTORY%>";
      function doNext(){
			if (updateParentModule){
				updateParentModule(modtree,"ParentModule");
			}
        //var path ="logmergeadminaction.jsp?MODULE_ID=" + document.access.ParentModule.options[document.access.ParentModule.selectedIndex].value;
        //path = path + "&" + "LOG_NAME=" + document.access.LogName.value;
        //path = path + "&" + "LOG_DESCRIPTION=" + document.access.LogDescription.value;
        //path = path + "&" + "LOG_TIME_ZONE=" + document.access.TimeZone.options[document.access.TimeZone.selectedIndex].value;
        //path = path + "&" + "LOG_CHARSET=" + document.access.charset.options[document.access.charset.selectedIndex].value;

        //var val = document.access.LogsToMerge.options.length;
        //path = path + "&" + "TOTAL_LOG_TO_MERGE=" + val;
        //var id = "";
        //for(var i=0;i<document.access.LogsToMerge.options.length;i++){
          //id = document.access.LogsToMerge.options[i].value;
          //path = path + "&LOG_INDEX_" + i + "=" + id;
          //document.access.LogsToMerge.options[i].selected = true;
        //}
        //document.location = path;
        updateSelected();
        document.access.action = "logmergeadminaction.jsp";
        document.access.submit();
      }


      function doAdd(){
        if(document.access.LogsList.selectedIndex == -1){
          return;
        }
        var name = document.access.LogsList.options[document.access.LogsList.selectedIndex].text;
        var value = document.access.LogsList.options[document.access.LogsList.selectedIndex].value;
        for(var i=0;i<document.access.LogsToMerge.options.length;i++){
          if(document.access.LogsToMerge.options[i].value == value){
            return;
          }
        }
        var option0 = new Option(name,value);
        document.access.LogsToMerge.options[document.access.LogsToMerge.options.length] = option0;
      }

    function doRemove(){
      if(document.access.LogsToMerge.selectedIndex == -1){
        return;
      }
      document.access.LogsToMerge.options[document.access.LogsToMerge.selectedIndex] = null;
    }

    function doUp(){
      if(document.access.LogsToMerge.selectedIndex == -1){
        return;
      }
      index = document.access.LogsToMerge.selectedIndex;
      if(index == 0){
      	return;
      }
      document.access.LogsToMerge.selectedIndex = index - 1;
      doDown();
      document.access.LogsToMerge.selectedIndex = index;
    }

	function doDown(){
      if(document.access.LogsToMerge.selectedIndex == -1){
        return;
      }
      index = document.access.LogsToMerge.selectedIndex;
      if(index == (document.access.LogsToMerge.options.length-1) || document.access.LogsToMerge.options.length == 1){
        return;
      }
	   options = new Array();
	   for(var i=0;i<document.access.LogsToMerge.options.length;i++){
      	  if(i == index){
      	  	option0 = new Option(document.access.LogsToMerge.options[i+1].text,document.access.LogsToMerge.options[i+1].value);
      		options[i] = option0;
      		option0 = new Option(document.access.LogsToMerge.options[i].text,document.access.LogsToMerge.options[i].value);
      		options[i+1] = option0;
      		i = i+1;
      	  }else{
      	    option0 = new Option(document.access.LogsToMerge.options[i].text,document.access.LogsToMerge.options[i].value);
      		 options[i] = option0;
      	  }
       }
       for(var i=0;i<options.length;i++){
      	   document.access.LogsToMerge.options[i] = null;
       }
       for(var i=0;i<options.length;i++){
      	  document.access.LogsToMerge.options[i] = options[i];
       }

       document.access.LogsToMerge.selectedIndex = index + 1;
    }
    
    //tree issues
    function markTreeNodeForExport(node){
		nodeCbx = document.getElementById("CheckBox_" + node.tree.name + "_" + node.index);
		if (!nodeCbx) return;
		if (node.selected == nodeCbx.checked) return;
			var selected = nodeCbx.checked;	
		if (this.onSelectMarkChilds){
    		markNodeChilds(node,selected);  
  		}else {
    		node.selected = selected;
  		}
  
  		if (this.onSelectMarkParents  && selected){
    	markNodeParentsToRoot(node.parent,selected);  
  		}
	}
	
	function updateSelected(){
		list = tree.getAllChecked();
		arr = list.split(",");
	 	var selectedLogsCombo = document.getElementById("logs");
	 	var selectedModulesCombo = document.getElementById("modules");
	 	var logsStr = "";
	 	var modsStr = "";
		for (var i=0; i<arr.length; i++){
			s = arr[i];
			ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				type = s.substring(0,ind);
				id = s.substring(ind+1,s.length);
				if (type == "<%=XpoLogObjectTypes.MODULE_TYPE%>"){
					if (modsStr != ""){
						modsStr += ",";
					}
					modsStr += id;
					if (tree.hasChildren(s) && (tree.hasChildren(s)+"") == "true"){
	 				modsStr += "*";
					}
				}else{
					if (logsStr != ""){
						logsStr += ",";
					}
					logsStr += id;
				}
			}
		}
		document.access.mods.value = modsStr;
		document.access.logs.value = logsStr;
	}
	
	
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="POST">
<input type="hidden" name="mods">
<input type="hidden" name="logs">
<input type="hidden" name="ParentModule">
<table border="0" width="92%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="848" id="AutoNumber2">
              <tr>
                <td width="9" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="395" class="TOPBORDER">
                <span class="PAGEHEADER">Merge Logs Admin</span></td>
                <td width="525" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="8">&nbsp;</td>
                <td width="393">&nbsp;</td>
                <td width="524">&nbsp;</td>
              </tr>
              <tr>
                <td width="8" >&nbsp;</td>
                <td colspan="2" width="919">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="603" id="AutoNumber3">
                  <tr>
                    <td width="800" height="18"><span class="HEADER">General</span></td>
                  </tr>
                  <tr>
                    <td width="800" height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      <tr>
                        <td colspan="2">
													<jsp:include page="../../../common/selectParentModule.jsp" flush="true">
													<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
													<jsp:param name="treeName" value="modtree" />
													<jsp:param name="PARENT_MODULE_ID" value="<%=pmod.getId()%>" />
													</jsp:include>
                        </td>
                      </tr>
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Name</span></td>
                        <td width="89%">
                        <input type="text" class="TEXTBOX" name="LogName" size="60" value="<%=logname%>"></td>
                      </tr>
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Description&nbsp;</span></td>
                        <td width="89%">
                        <input type="text" class="TEXTBOX" name="LogDescription" size="60" value="<%=logdesc%>"></td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td width="800">&nbsp;</td>
                  </tr><!--
                  <tr>
                    <td><b><i>Log context pattern</i></b></td>
                  </tr>-->
                  <tr>

                    <td width="800">
                        <span class="HEADER">Time Zone</span>
                    </td>
                  </tr>
                  <tr>
                    <td width="800">
                      <table border="0" width="800" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="190"><span class="REGULARTEXT">Log time zone</span></td>
                          <!--<td width="164"><font size="2">Data pattern</font></td>-->
                          <td width="600">
                          <select size="1" class="TEXTBOX" name="TimeZone" id="TimeZone">
                          <%selected = "";
			selected = isUsingDefaultTimeZone ? "selected=\"true\"" : "";

			%>
                             <option value="default" class="TEXTBOX" <%=selected%>>Default [<%=defaultZone.getID()%>]</option>
                            <%for (int i = 0; i < timeZonesArr.length; ++i) {
				if (!isUsingDefaultTimeZone
						&& timeZonesArr[i].equals(timeZoneId)) {
					selected = "selected=\"true\"";
				} else {
					selected = "";
				}

				%>
                            <option value="<%=timeZonesArr[i]%>" class="TEXTBOX" <%=selected%>><%=timeZonesArr[i]%></option>
                          <%}%>
                        </select></td>
                          <td width="50"></td>
                        </tr>
                        <tr>
                          <td width="190"></td>
                          <td width="600"></td>
                          <td width="50"></td>
                       </tr>
                      </table>
                    </td>
                  </tr>
                   <tr>                  
                    <td width="800">
                    &nbsp;&nbsp;</td>
                  </tr>
                  <tr>

                    <td width="800">
                        <span class="HEADER">Character Encoding</span>
                    </td>
                  </tr>
                  <tr>
                    <td width="917">
                      <table border="0" width="800" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="210"><span class="REGULARTEXT">Character set</span></td>
                          <td width="600">
                          <select size="1" class="TEXTBOX" name="charset" id="charset">
                          <%selected = "";
			selected = selectedCharset == null ? "selected=\"true\"" : "";

			%>
                             <option value="default" class="TEXTBOX" <%=selected%>>Default</option>
                            <%for (int i = 0; i < charsetArr.length; ++i) {
				if (selectedCharset != null
						&& charsetArr[i].equals(selectedCharset)) {
					selected = "selected=\"true\"";
				} else {
					selected = "";
				}

				%>
                            <option value="<%=charsetArr[i]%>" class="TEXTBOX" <%=selected%>><%=charsetArr[i]%></option>
                          <%}%>

                        </select></td>
                          <td width="50"></td>
                        </tr>
                        <tr>
                          <td width="190"></td>
                          <td width="664"><span class="SMALLTEXT">Use charset according the file encoding and machine charset support.</span></td>
                          <td width="83"></td>
                        </tr>
                                                
                      </table>
                    </td>
                  </tr>
                  
                  <!-- start -->
                  <tr>
                
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER"><%=listTitle%></span><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td>
                    <span class="REGULARTEXT"><%=listDesc%></span>
                    </td>
                  </tr>
									<tr>
										<td valign="top">
											<div id="loadingDiv" style="display:none">
												<span class="REGULARTEXT">Loading...</span>
											</div>
										</td>
									</tr>
                  <tr>
                    <td width="15%">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr>
                        <td class="REGULARTEXT">
		                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
													<tr>
														<td valign="top">
															<div id="treeboxbox_tree_1"></div>
														</td>
													</tr>
		                    </table>
                        </td>
                      </tr>
                    </table>
                    </td>
                  </tr>                  
                  <!-- end -->
                  <tr>
                    <td width="800">
                    </td>
                  </tr>
                  <tr>
                    <td width="800">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber17">
                      <tr>
                        <td width="20%">&nbsp;</td>
                        <td width="11%">
                        <p align="center"><a href="<%=BASE_DIRECTORY%>common/actions/cancelAction.jsp" class="LINK">cancel</a></td>
                         <%if (backwardURL != null) {
				%>
                        <td width="10%"><a href="<%=backwardURL%>" class="LINK">previous</a></td>
			<%}%>
                        <td width="16%"><a href="javascript:doNext()" class="LINK">next</a></td>
                        <td width="38%" >&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
 </td>
  </tr>
</table>
</form>
<script>
	tree=new dhtmlXTreeObject("treeboxbox_tree_1","100%","100%","0");
	tree.setImagePath("<%=BASE_DIRECTORY%>");
	tree.setIconSize(13,13);
	tree.enableTreeLines(false);
	tree.setOnLoadingStart(startLoading);
	tree.setOnLoadingEnd(endLoading);
	tree.enableCheckBoxes(1);
	tree.enableThreeStateCheckboxes(true);
	tree.setXMLAutoLoading("logmergeadminModuleTreeXML.jsp");
	tree.loadXML("logmergeadminModuleTreeXML.jsp<%=addop != null ? "?OP=" + addop : ""%>");
</script>
</body>

</html>