<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.merge.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="omega.ui.models.*"%>
<%@ page import="omega.ui.html.table.OHtmlTable"%>

<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  //constants
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String ERROR_OBJ = "ERROR_OBJ";

  //page data
  MergedLogBrowserManager lbm = null;
  String logname = "";

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  RecordMask mask = null;
  MergeCustomizationManager mcum = null;
  lbm = (MergedLogBrowserManager)request.getSession().getAttribute(CURRENT_LOG);
  MergedLogBrowserBuilder builder = (MergedLogBrowserBuilder)request.getSession().getAttribute(BUILDER);
  if(builder != null){
    lbm = builder.getMergeLogBrowser();
  }
  if(lbm == null){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("Please select log first.");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect("errorpage.jsp");
    return;
  }

  String backwardURL = null;
  AdminUIController controller = builder.getUiController();
  if (controller != null){
    controller.updatePageId("mergefieldadmin.jsp");
    backwardURL = BASE_DIRECTORY + controller.getBackwardPage();
  }

  mask = lbm.getRecordMask();
  mcum = (MergeCustomizationManager)lbm.getCustomizationManager();
  LogBrowsingManager[] logs = lbm.getLogBrowsers();
  int number = mask.getCulomnsNumber();

	//statistics
	boolean computeStatistics = lbm.isComputeStatistics();

  
  //log table example
  RecordsMaskTableModel model = lbm.getCurrentEntries(3);
  //workaround
  model = lbm.getCurrentEntries(3);
  String html = "";
  //html creation
  LogEyeModel lem = new LogEyeModel(BASE_DIRECTORY,lbm.getCustomizationManager(),model);
  OHtmlTable tab = new OHtmlTable(lem);

  LogEyeCellRenderer cr = new LogEyeCellRenderer(lem);
  LogEyeRowRenderer rr = new LogEyeRowRenderer(lem);
  tab.setRowRenderer(rr);
  tab.setCellRenderer(cr);
  tab.render();
  html = tab.getHtml();
  
  String charset = lbm.getCharset();
  if (charset != null){
    response.setContentType("text/html; charset=" + charset);
  }
%>




<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<jsp:include page="../../../scripts/dataview/dataView.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
</jsp:include>
<script>
	function doNext(){
          document.access.action="mergefieldadminaction.jsp";
          document.access.submit();
	}

        function openColorSelector(name){
          window.open('<%=BASE_DIRECTORY%>colorchooser/ColorChooser.jsp?TEXT_NAME=MergeColorField_' + name,'color','width=300,height=300,status=no,resizable=no,top=200,left=400,dependent=yes,alwaysRaised=yes');
        }

	function updateComputeStatistics(){
		var isChecked = document.getElementById("computeStatisticsStr").checked;
		for (var i = 0; i < <%=number%>; i++){
		  var statisticsDiv = document.getElementById("colStatistics" + i);
		  if(statisticsDiv){
		    if (isChecked){
		      statisticsDiv.style.visibility = "";
		    }else {
		      statisticsDiv.style.visibility = "hidden";
		    } 
		  }
		}
	}
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" name="access" id="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="859" id="AutoNumber2">
              <tr>
                <td width="10" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="364" class="TOPBORDER">
                <span class="PAGEHEADER">Merge Log field admin <%=logname%></span> </td>
                <td width="483" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="9">&nbsp;</td>
                <td width="362">&nbsp;</td>
                <td width="482">&nbsp;</td>
              </tr>
              <tr>
                <td width="9" >&nbsp;</td>
                <td colspan="2" width="846">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Generated table</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><%=html%></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                </table>
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="800" id="AutoNumber4">
                  <tr>
                    <td width="100%" height="18"><span class="HEADER">Filed specification</span></td>
                  </tr>

                  <tr>
                    <td width="100%" height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr class="TABLES_HEADERS">
                        <td width="4%"><span class="REGULARTEXT">&nbsp;</span></td>
                        <td width="25%"><span class="REGULARTEXT">Field Type</span></td>
                        <td width="31%"><span class="REGULARTEXT">Field Name</span></td>
                        <td width="40%" colspan="2"><span class="REGULARTEXT">&nbsp;</span></td>
                      </tr>
                      <tr>
                        <td colspan="5">&nbsp;</td>
                       </tr>

                      <%
                        String name = "";
                        String type = "";
                        String filedentry = "FieldNumber_";
                        int dateIndex = mask.getDateColumnIndex();
                        for(int i=0;i<number;++i){
                        	MaskColumn col = mask.getMaskColumn(i);
                          name = mask.getMaskColumn(i).getName();
                          type = mask.getMaskColumn(i).getType();
                      %>
                      <tr>
                        <td width="4%"><span class="REGULARTEXT"><%=String.valueOf(i+1)%>.</span></td>
                        <td width="25%"><span class="REGULARTEXT"><%=type%></span></td>
                        <td width="31%">
                          <input type="text" class="TEXTBOX" name="<%=String.valueOf(filedentry+i)%>" id="<%=String.valueOf(filedentry+i)%>" size="26" value="<%=name%>">
                        </td>
                        <td width="40%">
                        	<nobr>
                          <div id="colStatistics<%=String.valueOf(i)%>" <%=!computeStatistics?"style=\"visibility:hidden\"" : ""%>>
  													&nbsp;&nbsp;<input type="checkbox" name="useColStatistics<%=String.valueOf(i)%>" value="ON" <%=(mask.getMaskColumn(i).isUseInStatistics()? "checked" : "")%> >
                            <span class="SMALLTEXT">Compute statistics on this column&nbsp;</span>
                        	</div>
                        	</nobr>
                        </td>
                      </tr>
                      <%
                        }//for
                      %>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td><font size="1">&nbsp;</font></td>
                  </tr>
                  
                  <tr style="display:none">
                    <td>
                      <table border="0" width="100%" cellspacing="0" cellpadding="0">
                        <%
                          LogBrowsingManager logb = null;
                          String lname = "";
                          String logcolor = "";
                          String logid = "";
                          String MergeColorFieldName = "MergeColorField_";
                          DefaultColorConfig defc = Configuration.getInstance().getDefColorMgr();
                          String[] mc = defc.getDefMergeBgColors();
                          for(int i=0;i<logs.length;++i){
                            logb =  logs[i];
                            lname = logb.getName();
                            logid = logb.getId();
                            if(mcum.isExsitColor(logid)){
                              logcolor = mcum.getLogColor(logid);
                            }else{
                             if(i >= mc.length){
                              logcolor = mc[mc.length-1];
                             }else{
                              logcolor = mc[i];
                             }
                            }
                        %>
                        <tr>
                          <td width="21%"><span class="REGULARTEXT">For <%=lname%></span></td>
                          <td width="79%"><input type="text" class="REGULARTEXT" name="<%=MergeColorFieldName + logid%>" id="<%=MergeColorFieldName+logid%>" size="26" value="<%=logcolor%>">
                            <font size="1"><a href="javascript:openColorSelector('<%=logid%>')" class="SMALLLINK">&nbsp; pick background color</a></font></td>
                        </tr>
                        <%
                          }
                        %>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
									<tr>
										<td>
											<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
			                  <tr>
			                    <td><span class="HEADER">Statistics settings</span></td>
			                  </tr>                  
			                  <tr>
			                    <td><input id="computeStatisticsStr" name="computeStatisticsStr" type="checkbox"  <%=computeStatistics?"checked" : ""%>  onClick="javascript:updateComputeStatistics()"><span class="REGULARTEXT">Compute statistics</span><br><span class="SMALLTEXT">&nbsp;&nbsp;&nbsp;set this option to enable statistical evaluations on this log</span></td>
			                  </tr>                 
			                </table>
			              </td>
			            </tr>
                  <tr>
                    <td>&nbsp;
                    </td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber17">
                      <tr>
                        <td width="25%">&nbsp;</td>
                        <td width="13%">
                        <p align="center"><a href="<%=BASE_DIRECTORY%>common/actions/cancelAction.jsp" class="LINK">cancel</a></td>
                        <td width="12%"><a href="<%= backwardURL != null ? backwardURL : "javascript:history.go(-1)"%>" class="LINK">previous</a></td>
                        <td width="10%"><a href="javascript:doNext()" class="LINK">next</a></td>
                        <td width="35%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>