<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.merge.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>

<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  //constants
  String OP = "OP";
  String ADD = "ADD";
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_NAME = "LOG_NAME";
  String LOG_DESCRIPTION = "LOG_DESCRIPTION";
  String MODULE_ID = "MODULE_ID";
  String LOG_DIRECTORY = "LOG_DIRECTORY";
  String LOG_NAME_PATTERN = "LOG_NAME_PATTERN";
  String LOG_DATA_PATTERN = "LOG_DATA_PATTERN";
  String CURRENT_MODULE = "CURRENT_MODULE";
  String LOG_TIME_ZONE = "LOG_TIME_ZONE";

  //page data
  LogBrowsingManager lbm = null;
  String modid      = "";
  String logname    = "";
  String logdesc    = "";
  String logdir     = "";
  String lognameexp = "";
  String mergeId = null;

  boolean isUsingDefaultTimeZone = true;
  TimeZone defaultZone = TimeZone.getDefault();
  String timeZoneId = defaultZone.getID();
  String selectedCharset = null;

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  UserContext userContext = UserEnvironment.getUserContext(request);

  Module[] mdarr = mgmt.getAllModules(userContext,true);
  ModuleMember curmod = new ModuleMember();
  Module pmod = null;
  //check state
  String op = request.getParameter(OP);
  
  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  

  if(lbm != null && lbm instanceof MergedLogBrowserManager){        
     mergeId = lbm.getId();          
  }



  if(pmod == null){
    pmod = (Module)request.getSession().getAttribute(CURRENT_MODULE);
    if(pmod == null){
      pmod = new Module();
      pmod.setId("");
    }
  }

  if (mdarr.length == 0){
    Module tmpMod = new Module();
    tmpMod.setId("");
    mdarr = new Module[] {tmpMod};
  }


  String[] timeZonesArr = TimeZone.getAvailableIDs();
  Arrays.sort(timeZonesArr);
  
  Map charsetMap = java.nio.charset.Charset.availableCharsets();
  String [] charsetArr = (String [])charsetMap.keySet().toArray(new String [charsetMap.size()]);
  
  LogBrowsingManager[] lbarr = mgmt.getAllLogBrowsers();
  ArrayList list = new ArrayList(lbarr.length);
  for(int i=0;i < lbarr.length;++i){
    try{
	    if(lbarr[i] != null && lbarr[i] instanceof MergedLogBrowserManager){	     
	      if(userContext != null){
	        if(userContext.isModuleMemberVisible(lbarr[i].getId())){
	          list.add(lbarr[i]);
	        }
	      }else{
	        list.add(lbarr[i]);
	      }	      	      
	    }
	 }catch(Exception e){
	 	continue;
	 }
  }
  lbarr = new LogBrowsingManager[list.size()];
  lbarr = (LogBrowsingManager[])list.toArray(lbarr);
  
%>

<html>

<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>

<script>
	function doNext(){
    document.access.submit();
	}

</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" action="multiPatternConverterAction.jsp">
<table border="0" width="92%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="800" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%" width="800">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="671" id="AutoNumber2">
              <tr>
                <td width="9" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="395" class="TOPBORDER">
                <span class="PAGEHEADER">Merge to Multi Pattern converter</span> </td>
                <td width="525" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="8">&nbsp;</td>
                <td width="393">&nbsp;</td>
                <td width="524">&nbsp;</td>
              </tr>
              <tr>
                <td width="8" >&nbsp;</td>
                <td colspan="2" width="919">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="374" id="AutoNumber3">
                  <tr>
                    <td width="800" height="18"><span class="HEADER">General</span></td>
                  </tr>
                  <tr>
                    <td width="800" height="18"></td>
                  </tr>
                  <tr>
                    <td width="800" height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Parent folder</span></td>
                        <td width="89%">
                        <select size="1" class="TEXTBOX" name="ParentModule" id="ParentModule">
                          <%
                            String selected = "";
                            for(int i=0;i<mdarr.length;++i){
                              if(mdarr[i].getId().equals(pmod.getId())){
                                selected = "selected=\"true\"";
                              }else{
                                selected = "";
                              }
                            %>
                            <option class="TEXTBOX" value="<%=mdarr[i].getId()%>" <%=selected%>><%=mdarr[i].getName()%></option>
                          <%} %>
                        </select></td>
                      </tr>
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Name</span></td>
                        <td width="89%">
                        <input type="text" class="TEXTBOX" name="LogName" size="60" value="<%=logname%>"></td>
                      </tr>
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Description&nbsp;</span></td>
                        <td width="89%">
                        <input type="text" class="TEXTBOX" name="LogDescription" size="60" value="<%=logdesc%>"></td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td width="800">&nbsp;</td>
                  </tr>                             
                  <tr>

                    <td width="800">
                        <span class="HEADER">Time Zone</span>
                    </td>
                  </tr>
                  <tr>
                    <td width="917">
                      <table border="0" width="800" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="170"><span class="REGULARTEXT">Log time zone</span></td>
                          <!--<td width="164"><font size="2">Data pattern</font></td>-->
                          <td width="630">
                          <select size="1" class="TEXTBOX" name="TimeZone" id="TimeZone">
                          <%
                            selected = "";
                            selected = isUsingDefaultTimeZone? "selected=\"true\"" : "";
                            %>
                             <option value="default" class="TEXTBOX" <%=selected%>>Default [<%=defaultZone.getID()%>]</option>
                            <%
                            for(int i=0;i<timeZonesArr.length;++i){
                              if(!isUsingDefaultTimeZone && timeZonesArr[i].equals(timeZoneId)){
                                selected = "selected=\"true\"";
                              }else{
                                selected = "";
                              }
                            %>
                            <option value="<%=timeZonesArr[i]%>" class="TEXTBOX" <%=selected%>><%=timeZonesArr[i]%></option>
                          <%}%>

                        </select></td>
                          <td width="83"></td>
                        </tr>
                        <tr>
                          <td width="190"></td>
                          <td width="664"><span class="SMALLTEXT">(if the log doesn't have a date field the time zone will be ignored).</span></td>
                          <td width="83"></td>
                        </tr>                                                                        
                      </table>
                    </td>
                  </tr>
                   
                  <tr>

                    <td width="800">
                        <span class="HEADER">Character Encoding</span>
                    </td>
                  </tr>
                  <tr>
                    <td width="917">
                      <table border="0" width="800" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="225"><span class="REGULARTEXT">Character set</span></td>
                          <td width="550">
                          <select size="1" class="TEXTBOX" name="charset" id="charset">
                          <%
                            selected = "";
                            selected = selectedCharset == null? "selected=\"true\"" : "";
                            %>
                             <option value="default" class="TEXTBOX" <%=selected%>>Default</option>
                            <%
                            for(int i=0;i<charsetArr.length;++i){
                              if(selectedCharset != null && charsetArr[i].equals(selectedCharset)){
                                selected = "selected=\"true\"";
                              }else{
                                selected = "";
                              }
                            %>
                            <option value="<%=charsetArr[i]%>" class="TEXTBOX" <%=selected%>><%=charsetArr[i]%></option>
                          <%}%>

                        </select></td>
                          <td width="83"></td>
                        </tr>
                        <tr>
                          <td width="190"></td>
                          <td width="664"><span class="SMALLTEXT">Use charset according the file encoding and machine charset support.</span></td>
                          <td width="83"></td>
                        </tr>
                                                
                      </table>
                    </td>
                  </tr>
                  <tr>                  
                    <td width="800">
                    &nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td><span class="HEADER">Log Viewer Settings</span></td>
                  </tr>                  
                 <tr>
                    <td><input id="ignoreUnparsedRecords" name="ignoreUnparsedRecords" type="checkbox" ><span class="SMALLTEXT">Ignore unparsed records - when this option is checked you will see only records that fit the above pattern</span></td>
                  </tr>
                  <tr>
                    <td><input id="updateLinesNumberStr" name="updateLinesNumberStr" type="checkbox"  checked><span class="SMALLTEXT">Show lines number - when this option is checked you will be able to see the lines number <br>&nbsp;&nbsp;&nbsp;(Unchecked this will improve performance when going to the end of a log) </span></td>
                  </tr>
                  <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
                   <tr>

                    <td width="800">
                        <span class="HEADER">Merge Logs</span>
                    </td>
                  </tr>
                  <tr>
                    <td width="917">
                      <table border="0" width="800" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="225"><span class="REGULARTEXT">Merge Log</span></td>
                          <td width="550">
                          <select size="1" class="TEXTBOX" name="mergeLog" id="mergeLog">
                          <%
                            selected = "";                           
                            for(int i=0;i<lbarr.length;++i){
                              if((mergeId == null && i == 0) || (mergeId != null && lbarr[i].equals(mergeId))){
                                selected = "selected=\"true\"";
                              }else{
                                selected = "";
                              }
                            %>
                            <option value="<%=lbarr[i].getId()%>" class="TEXTBOX" <%=selected%>><%=lbarr[i].getName()%></option>
                          <%}%>

                        </select></td>
                          <td width="83"></td>
                        </tr>                                                                        
                      </table>
                    </td>
                  </tr>
                  <tr>                  
                    <td width="800">
                    &nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td width="800">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber17">
                      <tr>
                        <td width="20%">&nbsp;</td>
                        <td width="11%">
                        <p align="center"><a href="<%=BASE_DIRECTORY%>common/actions/cancelAction.jsp" class="LINK">cancel</a></td>                        
                        <td width="16%"><a href="javascript:doNext()" class="LINK">save</a></td>
                        <td width="38%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%" width="800">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>