<%@page import="xpolog.eye.admin.patterns.PatternAdminHelper"%>
<%@page import="xpolog.eye.admin.patterns.FieldBuilder"%>
<%@page import="xpolog.eye.admin.patterns.PatternBuilder"%>
<%@page import="java.util.List"%>
<%@page import="xpolog.eye.admin.patterns.PatternManager"%>
<%@page import="xpolog.eye.admin.builders.StringSimpleBuilder"%>
<%@ page language="java"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	String BASE_DIR = "base_directory";
	String PATTERN_INDX = "PATTERN_INDX";
  String STRING_BUILDER = "CURRENT_STRING_BUILDER";
	String FIELD_INDX = "FIELD_INDX";
	  
	String baseDir = request.getParameter(BASE_DIR);
	if (baseDir == null || baseDir.equals("")) {
		baseDir = BASE_DIRECTORY;
	}
  int pattIndx = 0 ;	
  int fieldIndx = 0 ;	
  String fieldIndxStr = request.getParameter(FIELD_INDX);
  try{
	  fieldIndx = Integer.parseInt(fieldIndxStr);
  }catch(Exception e){
	  fieldIndx = 0;
  }
  PatternManager mgr = null;
  StringSimpleBuilder builder = (StringSimpleBuilder)request.getSession().getAttribute(STRING_BUILDER);
	if(builder != null){
		mgr = builder.getPatternManager();
	}

	if(builder == null || mgr == null){
		out.write("error");
		out.flush();
		return;
	}
	String builderId = request.getParameter("BUILDER_ID");
	if(builderId == null){
		builderId = "";
	}
	pattIndx = mgr.getPatternIndexById(builderId);	
	List list = mgr.getFiledBuildersByPatternIndx(pattIndx);
	if(list == null){
		out.write("error");
		out.flush();
		return;
	}
  String builderToRemoveType = "";
  FieldBuilder builderToRemove = (FieldBuilder)list.get(fieldIndx);
  if(builderToRemove != null){
  	builderToRemoveType = builderToRemove.getType();  	
  }
	list.remove(fieldIndx);
	// update suggestion handler obj.
	PatternBuilder patternBuilder = (PatternBuilder)mgr.getPatternBuilders().get(pattIndx);
	if(patternBuilder != null && patternBuilder.getPattSuggestionHandler() != null){
		int currSuggestionPod = patternBuilder.getPattSuggestionHandler().getCurrFieldPos();
		currSuggestionPod = currSuggestionPod == -1 ? -1 : currSuggestionPod - 1;
		patternBuilder.getPattSuggestionHandler().setCurrFieldPos(currSuggestionPod);
	}
	if(builderToRemoveType.equals("block")){
		int indx = PatternAdminHelper.getFirstFieldIndexByType(list,"block");
		if(indx > 0 && indx < list.size()){
			list.remove(indx);
		}		
	}
	String xpoPattern = mgr.getPatternsAsString();
	//case remove last field from pattern
	if(xpoPattern == null || xpoPattern.length() == 0){
		xpoPattern = "{string:DUMMY}";
	}
	builder.setRecordPattern(xpoPattern);
	builder.updateBuilder();
	out.write("ok" + "#" + builderId + "#" + mgr.getPatternsAsString(pattIndx));
	out.flush();
	return;
%>