<%@page import="xpolog.eye.admin.patterns.DateFieldBuilder"%>
<%@page import="xpolog.eye.admin.builders.StringSimpleBuilder"%>
<%@ page language="java"%>
<%@page import="xpolog.eye.admin.patterns.PatternManager"%>
<%@page import="xpolog.eye.admin.patterns.FieldBuilder"%>
<%@page import="xpolog.eye.util.XpologUtil"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	String BASE_DIR = "base_directory";
	String PATTERN_INDX = "PATTERN_INDX";
  String STRING_BUILDER = "CURRENT_STRING_BUILDER";
	String FIELD_INDX = "FIELD_INDX";
	String IS_NEW_TYPE = "IS_NEW_TYPE";
	
	String pattern = "", locale = "" ,localeView = "" ,timeDiff = "",displayFormat = "";  
	
	String baseDir = request.getParameter(BASE_DIR);
	if (baseDir == null || baseDir.equals("")) {
		baseDir = BASE_DIRECTORY;
	}

	String isNewTypeStr = request.getParameter(IS_NEW_TYPE);
	boolean isNewType = isNewTypeStr != null && isNewTypeStr.equals("true") ;
	if(!isNewType){
			int pattIndx = 0 ;	
			String builderId = request.getParameter("BUILDER_ID");
			if(builderId == null){
				builderId = "";
			}

			int fieldIndx = 0 ;	
		  String fieldIndxStr = request.getParameter(FIELD_INDX);
		  try{
			  fieldIndx = Integer.parseInt(fieldIndxStr);
		  }catch(Exception e){
			  fieldIndx = 0;
		  }
		 
		  StringSimpleBuilder builder = (StringSimpleBuilder)request.getSession().getAttribute(STRING_BUILDER);
			if(builder != null){
				FieldBuilder fieldBuilder = null;
				if(fieldIndx >= 0){
					PatternManager mgr = builder.getPatternManager();
					if(mgr != null){
						pattIndx = mgr.getPatternIndexById(builderId);
						fieldBuilder = mgr.getFieldBuilder(pattIndx,fieldIndx);
						if(fieldBuilder != null && fieldBuilder instanceof DateFieldBuilder){
							DateFieldBuilder dateBuilder = (DateFieldBuilder)fieldBuilder;
							pattern = dateBuilder.getPattern();
							locale = dateBuilder.getLocale();
							localeView = dateBuilder.getLocaleView();
							timeDiff = dateBuilder.getTimeDiff();
							displayFormat = dateBuilder.getdisplayFormat();
						}
					}
				}
			}
	}else{
		pattern = request.getParameter("SUGGESTED_PATTERN");
		if(pattern == null){
			pattern = "";
		}		
	}
	pattern = XpologUtil.updateAsHtmlString(pattern);	
%>
<table border="0" width="100%" cellspacing="0" height="100%">    
			<tr>
					<td>
							<table border="0" width="100%" cellspacing="0" height="100%">    								
											<tr>
												<td width="30%">
														<span class="REGULARTEXT">Format</span>								
												</td>
												<td>		
													<input class="TEXTBOX" type="text" name="Pattern" id="PatternId" size="30" value="<%=pattern%>" >&nbsp;
														<jsp:include page="../../../../help/showHelp.jsp" flush="true">
						                       <jsp:param name="baseDirectory" value="../../" />
						                       <jsp:param name="helpMessageDetails" value="patterns-dateFormat" />
						                 </jsp:include>													
												</td>
											</tr>	
							</table>									
					</td>
			</tr>
												
			<tr style="font-size:1px" height="6px">
					<td>&nbsp;</td>
			</tr>	
			<tr style="font-size:1px" height="4px">
					<td align="left" style="padding-left:4"><a href="javascript:hideShowAdvance()" class="SMALLLINK">Advanced</a></td>
			</tr>
			<tr style="font-size:1px" height="6px">
					<td>&nbsp;</td>
			</tr>	
			
			<tr>
					<td>
							<table id="propertiesId" style="display:none" border="0" width="100%" cellspacing="0" height="100%">    								
								<tr>
									<td width="30%">
											<span class="REGULARTEXT">Display Format</span>								
									</td>
									<td>		
										<input class="TEXTBOX" type="text" name="displayFormat" id="displayFormat" size="30" value="<%=displayFormat%>" >&nbsp;
								<jsp:include page="../../../../help/showHelp.jsp" flush="true">
                       <jsp:param name="baseDirectory" value="../../" />
                       <jsp:param name="helpMessageDetails" value="patterns-dateDisplayFormat" />
                 </jsp:include>

									</td>									
								</tr>	
								<tr style="font-size:1px" height="8px">
										<td>&nbsp;</td>
								</tr>																							
								<tr>
									<td width="30%">
											<span class="REGULARTEXT">Time diff</span>								
									</td>
									<td>		
										<input class="TEXTBOX" type="text" name="timeDiff" id="timeDiff" size="30" value="<%=timeDiff%>" >&nbsp;
								<jsp:include page="../../../../help/showHelp.jsp" flush="true">
                       <jsp:param name="baseDirectory" value="../../" />
                       <jsp:param name="helpMessageDetails" value="patterns-dateTimeDiff" />
                 </jsp:include>
									</td>
								</tr>	
								<tr style="font-size:1px" height="8px">
										<td>&nbsp;</td>
								</tr>															
								<tr>
									<td width="30%">
											<span class="REGULARTEXT">Locale</span>								
									</td>
									<td>		
										<input class="TEXTBOX" type="text" name="Locale" id="Locale" size="30" value="<%=locale%>" >&nbsp;
								<jsp:include page="../../../../help/showHelp.jsp" flush="true">
                       <jsp:param name="baseDirectory" value="../../" />
                       <jsp:param name="helpMessageDetails" value="patterns-dateLocale" />
                 </jsp:include>
									</td>
								</tr>	
								<tr style="font-size:1px" height="8px">
										<td>&nbsp;</td>
								</tr>															
								<tr>
									<td width="30%">
											<span class="REGULARTEXT">Locale View</span>								
									</td>
									<td>		
										<input class="TEXTBOX" type="text" name="LocaleView" id="LocaleView" size="30" value="<%=localeView%>" >&nbsp;
												<jsp:include page="../../../../help/showHelp.jsp" flush="true">
        		               <jsp:param name="baseDirectory" value="../../" />
            		           <jsp:param name="helpMessageDetails" value="patterns-dateLocaleView" />
				                 </jsp:include>
									</td>
								</tr>	
								<tr style="font-size:1px" height="8px">
										<td>&nbsp;</td>
								</tr>	
							</table>									
					</td>
			</tr>
																						
</table>
