<%@ page language="java"%>
<%@page import="xpolog.eye.admin.patterns.PatternManager"%>
<%@page import="xpolog.eye.admin.patterns.FieldBuilder"%>
<%@page import="xpolog.eye.admin.builders.StringSimpleBuilder"%>
<%@page import="xpolog.eye.admin.patterns.ExpressionFieldBuilder"%>
<%@page import="xpolog.eye.util.XpologUtil"%>
 
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	String BASE_DIR = "base_directory";
  String STRING_BUILDER = "CURRENT_STRING_BUILDER";
	String FIELD_INDX = "FIELD_INDX";
	String IS_NEW_TYPE = "IS_NEW_TYPE";
	
	String expression = "";	
	String baseDir = request.getParameter(BASE_DIR);
	if (baseDir == null || baseDir.equals("")) {
		baseDir = BASE_DIRECTORY;
	}

	String isNewTypeStr = request.getParameter(IS_NEW_TYPE);
	boolean isNewType = isNewTypeStr != null && isNewTypeStr.equals("true") ;
	if(!isNewType){
		int pattIndx = 0 ;	
		String builderId = request.getParameter("BUILDER_ID");
		if(builderId == null){
			builderId = "";
		}

		
		  int fieldIndx = 0 ;	
		  String fieldIndxStr = request.getParameter(FIELD_INDX);
		  try{
			  fieldIndx = Integer.parseInt(fieldIndxStr);
		  }catch(Exception e){
			  fieldIndx = 0;
		  }
		 
		  StringSimpleBuilder builder = (StringSimpleBuilder)request.getSession().getAttribute(STRING_BUILDER);
			if(builder != null){
				FieldBuilder fieldBuilder = null;
				if(fieldIndx >= 0){
					PatternManager mgr = builder.getPatternManager();
					if(mgr != null){
						pattIndx = mgr.getPatternIndexById(builderId);
						fieldBuilder = mgr.getFieldBuilder(pattIndx,fieldIndx);
						if(fieldBuilder != null && fieldBuilder instanceof ExpressionFieldBuilder){
							ExpressionFieldBuilder expressionBuilder = (ExpressionFieldBuilder)fieldBuilder;
							expression = expressionBuilder.getExpression();
						}
					}
				}
			}
	}
	else{
		expression = request.getParameter("SUGGESTED_PATTERN");
		if(expression == null){
			expression = "";
		}		
	}
	expression = XpologUtil.updateAsHtmlString(expression);
	
%>
<table border="0" width="100%" cellspacing="0" height="100%">    
			<tr>
					<td>
							<table border="0" width="100%" cellspacing="0" height="100%">    								
											<tr>
												<td width="30%">
														<span class="REGULARTEXT">Expression</span>								
												</td>
												<td>		
													<input class="TEXTBOX" type="text" name="expression" id="expression" size="30" value="<%=expression%>" >&nbsp;
															<jsp:include page="../../../../help/showHelp.jsp" flush="true">
			        		               <jsp:param name="baseDirectory" value="../../" />
			            		           <jsp:param name="helpMessageDetails" value="patterns-functionExpression" />
							                 </jsp:include>
												</td>
											</tr>	
							</table>									
					</td>
			</tr>												
</table>
