<%@page import="xpolog.eye.admin.patterns.DateFieldBuilder"%>
<%@page import="xpolog.eye.admin.builders.StringSimpleBuilder"%>
<%@ page language="java"%>
<%@page import="xpolog.eye.admin.patterns.PatternManager"%>
<%@page import="xpolog.eye.admin.patterns.FieldBuilder"%>
<%@page import="xpolog.eye.admin.patterns.RegExpFieldBuilder"%>
<%@page import="xpolog.eye.util.XpologUtil"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	String BASE_DIR = "base_directory";
	String PATTERN_INDX = "PATTERN_INDX";
  String STRING_BUILDER = "CURRENT_STRING_BUILDER";
	String FIELD_INDX = "FIELD_INDX";
	String IS_NEW_TYPE = "IS_NEW_TYPE";
	
	String pattern = "", refName = "" ,refIndx = "" , columnType = ""; 
	boolean isMultiLine = false;
	
	String baseDir = request.getParameter(BASE_DIR);
	if (baseDir == null || baseDir.equals("")) {
		baseDir = BASE_DIRECTORY;
	}

	String isNewTypeStr = request.getParameter(IS_NEW_TYPE);
	boolean isNewType = isNewTypeStr != null && isNewTypeStr.equals("true") ;
	if(!isNewType){
		int pattIndx = 0 ;	
		String builderId = request.getParameter("BUILDER_ID");
		if(builderId == null){
			builderId = "";
		} 
		
		  int fieldIndx = 0 ;	
		  String fieldIndxStr = request.getParameter(FIELD_INDX);
		  try{
			  fieldIndx = Integer.parseInt(fieldIndxStr);
		  }catch(Exception e){
			  fieldIndx = 0;
		  }
		 
		  StringSimpleBuilder builder = (StringSimpleBuilder)request.getSession().getAttribute(STRING_BUILDER);
			if(builder != null){
				FieldBuilder fieldBuilder = null;
				if(fieldIndx >= 0){
					PatternManager mgr = builder.getPatternManager();
					if(mgr != null){
						pattIndx = mgr.getPatternIndexById(builderId);
						fieldBuilder = mgr.getFieldBuilder(pattIndx,fieldIndx);
						if(fieldBuilder != null && fieldBuilder instanceof RegExpFieldBuilder){
							RegExpFieldBuilder regexpBuilder = (RegExpFieldBuilder)fieldBuilder;
							pattern = regexpBuilder.getPattern();
							int _refIndx = regexpBuilder.getRefIndex();
							if(_refIndx < 0 ){
								refIndx = "";
								refName = regexpBuilder.getRefName();
							}else{
								refIndx = String.valueOf(regexpBuilder.getRefIndex());
								refName = "";								
							}
							columnType = regexpBuilder.getColumnType();
							isMultiLine = regexpBuilder.isMultiLine();
						}
					}
				}
			}
	}else{
		pattern = request.getParameter("SUGGESTED_PATTERN");
		if(pattern == null){
			pattern = "";
		}
		
	}
	pattern = XpologUtil.updateAsHtmlString(pattern);
%>
<table border="0" width="100%" cellspacing="0" height="100%">    
			<tr>
					<td>
							<table border="0" width="100%" cellspacing="0" height="100%">    								
											<tr>
												<td width="30%">
														<span class="REGULARTEXT">Ref Index</span>								
												</td>
												<td>		
													<input class="TEXTBOX" type="text" name="refIndx" id="refIndx" size="30" value="<%=refIndx%>">&nbsp;
															<jsp:include page="../../../../help/showHelp.jsp" flush="true">
			        		               <jsp:param name="baseDirectory" value="../../" />
			            		           <jsp:param name="helpMessageDetails" value="patterns-refIndx" />
							                 </jsp:include>
												</td>
											</tr>	
							</table>									
					</td>
			</tr>
						<tr style="font-size:1px" height="8px">
					<td>&nbsp;</td>
			</tr>			
						<tr>
					<td>
							<table border="0" width="100%" cellspacing="0" height="100%">    								
											<tr>
												<td width="30%">
														<span class="REGULARTEXT">Ref Name</span>								
												</td>
												<td>		
													<input class="TEXTBOX" type="text" name="refName" id="refName" size="30" value="<%=refName%>">&nbsp;
															<jsp:include page="../../../../help/showHelp.jsp" flush="true">
			        		               <jsp:param name="baseDirectory" value="../../" />
			            		           <jsp:param name="helpMessageDetails" value="patterns-refName" />
							                 </jsp:include>
												</td>
											</tr>	
							</table>									
					</td>
			</tr>
				<tr style="font-size:1px" height="8px">
					<td>&nbsp;</td>
			</tr>
						<tr>
					<td>
							<table border="0" width="100%" cellspacing="0" height="100%">    								
											<tr>
												<td width="30%">
														<span class="REGULARTEXT">Expression</span>								
												</td>
												<td>		
													<input class="TEXTBOX" type="text" name="Pattern" id="PatternId" size="30" value="<%=pattern%>" >&nbsp;
															<jsp:include page="../../../../help/showHelp.jsp" flush="true">
			        		               <jsp:param name="baseDirectory" value="../../" />
			            		           <jsp:param name="helpMessageDetails" value="patterns-regexpExpression" />
							                 </jsp:include>
												</td>
											</tr>	
							</table>									
					</td>
			</tr>
												
			<tr style="font-size:1px" height="6px">
					<td>&nbsp;</td>
			</tr>	
			<tr style="font-size:1px" height="4px">
					<td align="left" style="padding-left:4"><a href="javascript:hideShowAdvance()" class="SMALLLINK">Advanced</a></td>
			</tr>
			<tr style="font-size:1px" height="6px">
					<td>&nbsp;</td>
			</tr>	
			
			<tr>
					<td>
							<table id="propertiesId" style="display:none" border="0" width="100%" cellspacing="0" height="100%">    								
								
											<tr>
												<td width="30%">
														<span class="REGULARTEXT">Is Multi Line</span>								
												</td>
												<td>		
													<select class="TEXTBOX" size="1" id="isMultiLine" name="isMultiLine" class="TEXTBOX" style="width:100">
						                        <option value="true" <%=isMultiLine ? "selected" : ""%>>True</option>
						                        <option value="false" <%=!isMultiLine ? "selected" : ""%>>False</option>
													</select>&nbsp;
															<jsp:include page="../../../../help/showHelp.jsp" flush="true">
			        		               <jsp:param name="baseDirectory" value="../../" />
			            		           <jsp:param name="helpMessageDetails" value="patterns-isMultiLine" />
							                 </jsp:include>						                        						                        
												</td>
											</tr>	
								<tr style="font-size:1px" height="8px">
										<td>&nbsp;</td>
								</tr>	
																						
								<tr>
									<td width="30%">
											<span class="REGULARTEXT">Column Type</span>								
									</td>
									<td>		
										<input class="TEXTBOX" type="text" name="columnType" id="columnType" size="30" value="<%=columnType%>" >&nbsp;
															<jsp:include page="../../../../help/showHelp.jsp" flush="true">
			        		               <jsp:param name="baseDirectory" value="../../" />
			            		           <jsp:param name="helpMessageDetails" value="patterns-columnType" />
							                 </jsp:include>
									</td>
								</tr>	
								<tr style="font-size:1px" height="8px">
										<td>&nbsp;</td>
								</tr>															
							</table>									
					</td>
			</tr>
																						
</table>
