<%@ page language="java"%>	
<%@page import="java.util.List"%>
<%@page import="xpolog.eye.admin.patterns.PatternBuilder"%>
<%@page import="xpolog.eye.admin.patterns.PatternManager"%>
<%@page import="xpolog.eye.admin.builders.StringSimpleBuilder"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	String STRING_BUILDER = "CURRENT_STRING_BUILDER";
	String PATTERN = "PATTERN";
	String OP = "OP";
	
	String op = request.getParameter(OP) ;
	boolean isAddingNewPattern = op != null && op.equals("ADD_NEW_PATTERN");
	boolean isRemovePattern = op != null && op.equals("REMOVE_PATTERN");
	boolean isDuplicatePattern = op != null && op.equals("DUPLICATE");
	boolean isRefreshPattern = op != null && op.equals("REFRESH_PATTERN");
	boolean isMoveRight = op != null && op.equals("MOVE_RIGHT");
	boolean isMoveLeft = op != null && op.equals("MOVE_LEFT");

	String pattern = request.getParameter(PATTERN);
	if(pattern == null || pattern.length() == 0){
		pattern = "{string}";
	}
	
	String patternId = "";
	StringSimpleBuilder builder = (StringSimpleBuilder)request.getSession().getAttribute(STRING_BUILDER);
	if(builder != null){
		PatternManager mgr = builder.getPatternManager();
		if(isAddingNewPattern){			
			if(mgr != null){
				mgr.addNewPattern();
				pattern = mgr.getPatternsAsString();
			}
		}else{
			String builderId = request.getParameter("BUILDER_ID");
			if(builderId == null){
				builderId = "";
			}								
			if(mgr != null && isRemovePattern){
					mgr.removePatternBuilder(builderId);
				pattern = mgr.getPatternsAsString();
			}else if((mgr != null && isDuplicatePattern)){
				mgr.duplicatePatternBuilder(builderId);
			pattern = mgr.getPatternsAsString();
			}else if(isMoveRight || isMoveLeft){
				String direction = isMoveLeft ? "MOVE_LEFT" : "MOVE_RIGHT";
				int suc = mgr.movePattern(builderId,direction);
			pattern = mgr.getPatternsAsString();
				patternId = builderId;
			}
		}	

		builder.setRecordPattern(pattern);
		try{
		builder.updateBuilder();
		if(isAddingNewPattern || isDuplicatePattern){
			PatternBuilder patternBuilder = (PatternBuilder)builder.getPatternManager().getPatternBuilders().get(0);
			if(patternBuilder != null){
				patternId = patternBuilder.getId();
			}
		}else if(isRefreshPattern){
			List patternBuilderList = builder.getPatternManager().getPatternBuilders();
			for(int i = 0 ; patternBuilderList != null && i < patternBuilderList.size() ; i ++){
				PatternBuilder patternBuilder = (PatternBuilder)patternBuilderList.get(i);
				if(patternBuilder != null){
					if(i > 0){
						patternId += ",";
					}
					patternId += patternBuilder.getId();
				}
			}
		}
		}catch(Exception e){
			String msg = "<table><tr class=\"REGULARTEXT\"><td><span style=\"font-size: 8pt;color:red\" >";
			msg +=	e.getMessage();
			msg += "</span></td></tr></table>";
			out.write("error#" + msg);
			out.flush();
			return;
		}
		out.write("ok#" + patternId);
		out.flush();			
	}else{
		out.write("error");
		out.flush();
	}
%>

