<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.cloud.*"%>
<%@page import="xpolog.eye.remote.ProxyLogBrowser"%>
<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  //constants
  String OP = "OP";
  String ADD = "ADD"; 
  String EDIT = "EDIT"; 
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_NAME = "LOG_NAME";
  String LOG_DESCRIPTION = "LOG_DESCRIPTION";
  String MODULE_ID = "MODULE_ID";
  String CURRENT_MODULE = "CURRENT_MODULE";

  //page data
  LogBrowsingManager lbm = null;
  String modid      = "";
  String logname    = "";
  String remoteLogName    = "";
  String logdesc    = "";
  String hostAddr    = "";
  String hostPort    = "30303";
  String remoteLogId = "";
  String protocol = "http";
  String remEnId = "";
  String hostContext ="logeye";
  String userName ="";
  String password ="";
  
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  
  UserContext userContext = UserEnvironment.getUserContext(request);
  
  RemoteLogBuilder builder = (RemoteLogBuilder)request.getSession().getAttribute(BUILDER);
  if (builder == null){
    builder = (RemoteLogBuilder)LogBrowserBuilderFactory.getLogBroserBuilderByType(LogBrowserBuilderFactory.PROXY_TYPE);
    request.getSession().setAttribute(BUILDER,builder);
  }


  Module[] mdarr = mgmt.getAllModules(userContext,true);
  ModuleMember curmod = new ModuleMember();
  Module pmod = null;
  //check state
  String op = request.getParameter(OP);
  if((op != null) && op.trim().equals(ADD)){
    //we are adding a new browser
    request.getSession().removeAttribute(CURRENT_LOG);
  }else{
    String id = request.getParameter(LOG_ID);
    if((id != null) && !(id.trim().equals(""))){
      try{
        lbm = mgmt.getLogBrowserManager(id);
      }catch(Exception e){}
    }else{
      lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
    }

    if(lbm != null){
        request.getSession().setAttribute(CURRENT_LOG,lbm);
        logname    = lbm.getName();
        logdesc    = lbm.getDescription();
        hostAddr = RemoteAdminHelper.getHostAddress(lbm);
        hostPort = RemoteAdminHelper.getHostPort(lbm);
        remoteLogId = RemoteAdminHelper.getRemoteLogId(lbm);
        remEnId = RemoteAdminHelper.getEnterpriseNodeId(lbm); 
        protocol = RemoteAdminHelper.getProtocol(lbm);
        if((op != null) && op.trim().equals(EDIT)){
        	if(lbm instanceof ProxyLogBrowser){
       		LogBrowsingManager proxyLbm = ((ProxyLogBrowser)lbm).getLogBrowsingManager();
        		if(proxyLbm != null){
			       	remoteLogName = proxyLbm.getName();
        		}
        	}
        	remoteLogName = (remoteLogName.equals("")) ? "N/A" : remoteLogName;
        	userName = RemoteAdminHelper.getUserName(lbm);
        	password = RemoteAdminHelper.getPasswd(lbm);
        }
        
        

        curmod.setId(lbm.getId());
        curmod.setName(logname);
        curmod.setType("Log");
        curmod.setDescription(logdesc);
        try{
          pmod = mgmt.getParentModule(lbm.getId());
          if (pmod != null){
            boolean foundModule = false;
            for (int i = 0; i < mdarr.length; i++) {
              if (mdarr[i].getId().equals(pmod.getId())){
                foundModule = true;
                break;
              }
            }
            if (!foundModule){
              Module  [] tmp = new Module[mdarr.length + 1];
              System.arraycopy(mdarr,0,tmp,0,mdarr.length);
              mdarr = tmp;
              mdarr[mdarr.length - 1] = pmod;
            }
          }
        }catch(Exception e){
        }
      }
  }

  if(pmod == null){
    pmod = (Module)request.getSession().getAttribute(CURRENT_MODULE);
    if(pmod == null){
      pmod = new Module();
      pmod.setId("");
    }
  }

  if (mdarr.length == 0){
    Module tmpMod = new Module();
    tmpMod.setId("");
    mdarr = new Module[] {tmpMod};
  }
  
	CloudMgr cmgr =  mgmt.getCloudMgr();
	XplgNode[] nodesArr = cmgr.getAllXplgNodes();
	

	//initiliaze redio buttons in case EDIT log mode
	boolean isManualXplgNode = true;
	boolean isUsesPaswd = false;
	if((op != null) && op.trim().equals(EDIT)){
		//	determine which redio to check (manual or enterprise).
		for(int i=0;i<nodesArr.length;++i){
	       if(nodesArr[i].getId().equals(remEnId)){
			 isManualXplgNode = false;
		    break;
	       }
		}
		//determine which security information redio to check		
		isUsesPaswd = userName != null && !userName.equals("") &&  password != null && !password.equals("");

	}
	
  String selected = "";
%>


<html>

<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js"></script>
<jsp:include page="../../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<script>
	var xplgNodeId = "";

 	function dataLoad(){
		host = document.access.hostAddr.value;
		port = document.access.hostPort.value;
		context = document.access.hostContext.value;
		contype = "http";
		if(document.access.conType.options.length > 0){
		  contype = document.access.conType.options[document.access.conType.selectedIndex].value;
		}		
		path = "host="+host+"&port="+port+"&context="+context+ "&conType="+contype;
	    if(document.access.details.checked){
	    	user = document.access.userName.value;
	    	password = document.access.password.value;
	    	path = path + "&user="+user+"&password="+password;
	    }else if (document.access.none.checked){
	      path = path + "&user=&password=";
	    }
	    
	    if(document.access.ent.checked){
			  if(document.access.hostList.options.length > 0){
	    		nodeId = document.access.hostList.options[document.access.hostList.selectedIndex].value;
	    		path = path + "&nodeId="+nodeId;   		 
	    		if(nodeId == -1){
	    			alert('please specify location and security specification');
	    			return;
	    		}
	    		
	    	}
	    }
	    if(document.access.man.checked){
	    	
	    	if(host == "" || port == "" || context == ""){
		    	alert('please specify location and security specification');
		    	return;
	    	}
	    }
	    if(!(document.access.man.checked || document.access.ent.checked)){
	    	alert('please specify location and security specification');
		    return;
	    }

	    frames['dataFrame'].location = "logListAction.jsp?"+ path;
	}
	
	function checkRemoteClick(){
		if(document.access.man.checked){
			document.access.hostAddr.disabled = false;
			document.access.hostPort.disabled = false;
			document.access.hostContext.disabled = false;
			document.access.hostList.disabled = true;
			document.access.node.disabled = true;
			if(document.access.node.checked){
				
			}	
		}else if(document.access.ent.checked){
			document.access.hostAddr.disabled = true;
			document.access.hostPort.disabled = true;
			document.access.hostContext.disabled = true;
			document.access.hostList.disabled = false;
			document.access.node.disabled = false;
		}

	}

	function checkSecurityClick(){
		if(document.access.details.checked){
			document.access.userName.disabled = false;
			document.access.password.disabled = false;
		}else{
			document.access.userName.disabled = true;
			document.access.password.disabled = true;
		}
	}
	
 	function loadTree(){
	 	var t = getRadioValue();
	 	if (t == "enterprise"){
	 		document.access.hostAddr.value = "";
	 	}
		host = document.access.hostAddr.value;
		port = document.access.hostPort.value;
		context = document.access.hostContext.value;
		contype = "http";
		if(document.access.conType.options.length > 0){
		  contype = document.access.conType.options[document.access.conType.selectedIndex].value;
		}		
		path = "host="+host+"&port="+port+"&context="+context+ "&conType="+contype;
    if(document.access.details.checked){
    	user = document.access.userName.value;
    	password = document.access.password.value;
    	path = path + "&user="+user+"&password="+password;
    }else if (document.access.none.checked){
      path = path + "&user=&password=";
    }
    
    if(document.access.ent.checked){
		  if(document.access.hostList.options.length > 0){
    		nodeId = document.access.hostList.options[document.access.hostList.selectedIndex].value;
    		path = path + "&nodeId="+nodeId;   		 
    		if(nodeId == -1){
    			alert('please specify location and security specification');
    			return;
    		}
    		
    	}
    }
    if(document.access.man.checked){
     	if(host == "" || port == "" || context == ""){
	    	alert('please specify location and security specification');
	    	return;
    	}
    }
    if(!(document.access.man.checked || document.access.ent.checked)){
    	alert('please specify location and security specification');
	    return;
    }
    if (tree.htmlNode && tree.htmlNode.childNodes && tree.htmlNode.childNodes.length > 0){
    	tree.deleteItem(tree.htmlNode.childNodes[0].id);
    }
    tree.loadXML("logListAction.jsp?getModules=true&"+ path);
		tree.setXMLAutoLoading("logListAction.jsp?"+ path);
	}
	
	function getRadioValue(){
		for (var i=0; i < document.access.nodeConf.length; i++){
			if (document.access.nodeConf[i].checked){
				return document.access.nodeConf[i].value;
			}
		}
	}
	
	var removeBuilder = true;
	
	function doNext(){
		if (updateParentModule){
			updateParentModule(modtree,"ParentModule");
		}
		removeBuilder = false;
		updateSelected();
		document.access.submit();
	}
	
	function updateSelected(){
   	list = tree.getAllChecked(true);
   	arr = list.split(",");
    var logsStr = "";
    var modsStr = "";
   	for (var i=0; i<arr.length; i++){
   		s = arr[i];
   		ind = s.indexOf("-");
   		if (ind == -1){
   			continue;
   		}else{
   			type = s.substring(0,ind);
   			id = s.substring(ind+1,s.length);
   			if (type == "<%=XpoLogObjectTypes.MODULE_TYPE%>"){
   				if (modsStr != ""){
   					modsStr += ",";
   				}
   				modsStr += id;
   			}else{
   				if (logsStr != ""){
   					logsStr += ",";
   				}
   				logsStr += id;
   			}
   		}
   	}
   	document.access.mods.value = modsStr;
   	document.access.logs.value = logsStr;
   }
    
	function removeBuilderFromSession(){
		if (removeBuilder){
			doBackgroundAction("<%=BASE_DIRECTORY%>loggers/admin/remote/removeBuilder.jsp");
		}
	}	    


</script>
</head>

<body onLoad="javascript:checkRemoteClick()" onUnload="javascript:removeBuilderFromSession()">
	

<form AUTOCOMPLETE="OFF" id="access" name="access" action="remoteAdminAction.jsp">
<input type="hidden" name="cuurentRemoteLogId" value="<%=remoteLogId%>">
<input type="hidden" name="mods">
<input type="hidden" name="logs">
<input type="hidden" name="ParentModule">
<table border="0" width="92%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="800" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%" width="800">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" >
              <tr>
                <td width="9" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="395" class="TOPBORDER">
                <span class="PAGEHEADER">Remote Log</span> </td>
                <td width="525" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="8">&nbsp;</td>
                <td width="393">&nbsp;</td>
                <td width="524">&nbsp;</td>
              </tr>
              <tr>
                <td width="8" >&nbsp;</td>
                <td colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse">
                  <tr>
                    <td width="800"><span class="HEADER">General</span></td>
                  </tr>
                  <tr>
                    <td width="800" ></td>
                  </tr>
                  <tr>
                    <td width="800" height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
                      <tr>
                        <td colspan="2">
													<jsp:include page="../../../common/selectParentModule.jsp" flush="true">
													<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
													<jsp:param name="treeName" value="modtree" />
													<jsp:param name="PARENT_MODULE_ID" value="<%=pmod.getId()%>" />
													</jsp:include>
                        </td>
                      </tr>
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Name</span></td>
                        <td width="89%">
                        <input type="text" class="TEXTBOX" name="LogName" size="60" value="<%=logname%>">
                        </td>
                      </tr>
                      <tr>
                        <td><span class="REGULARTEXT">&nbsp;</span></td>
                        <td colspan="2"><span class="SMALLTEXT">If left empty, the remote log / folder names will be used</span></td>
                      </tr>
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Description&nbsp;</span></td>
                        <td width="89%">
                        <input type="text" class="TEXTBOX" name="LogDescription" size="60" value="<%=logdesc%>"></td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td width="800">&nbsp;</td>
                  </tr>
                  <tr>
                    <td width="800" height="21">
                    <span class="HEADER">Remote Information</span>
                    </td>
                  </tr>
                  <tr>
                    <td width="800">
                      <table border="0" width="100%" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="2%" nowrap></td>
                          <td width="50%"></td>
                          <td width="48%"></td>
                        </tr>
                        <tr>
                          <td width="2%" nowrap><span class="REGULARTEXT"><input type="radio" value="enterprise" name="nodeConf" id="ent" onClick="javascript:checkRemoteClick()" <%if(nodesArr.length == 0){%>diabled="true"<%}%> <%if(!isManualXplgNode){%>checked<%}%>></span></td>
                          <td width="50%"><span class="REGULARTEXT"><b>Enterprise XpoLog Node&nbsp;</b></span></td>
                          <td width="48%"></td>
                        </tr>
                        <tr>
                          <td width="2%" nowrap></td>
                          <td width="50%">
                            <table border="0" width="100%" cellspacing="0" cellpadding="0">
                              <tr>
                                <td width="50%"><span class="REGULARTEXT">Remote Host&nbsp;</span></td>
                                <td width="50%">
                                <select size="1" class="TEXTBOX" name="hostList" id="hostList">
                                <option class="TEXTBOX" value="-1">--Select xpolog node--</option>
                          <%
                            selected = "";
                            for(int i=0;i<nodesArr.length;++i){
                              if(nodesArr[i].getId().equals(remEnId)){
                                selected = "selected=\"true\"";
                              }else{
                                selected = "";
                              }
                            %>
                            <option class="TEXTBOX" value="<%=nodesArr[i].getId()%>" <%=selected%>><%=nodesArr[i].getName()%></option>
                          <%} %>
                        </select></td>
                              </tr>
                            </table>
                          </td>
                          <td width="48%"></td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td width="800">
                      <table border="0" width="800" cellspacing="0" cellpadding="0">                                                
                        <tr>
                          <td width="700" colspan="2">
                            <table border="0" width="100%" cellspacing="0" cellpadding="0">
                              <tr>
                                <td width="1%" nowrap><span class="REGULARTEXT"><input type="radio" value="manual" name="nodeConf" id="man"  onClick="javascript:checkRemoteClick()" <%if(isManualXplgNode){%>checked<%}%>></span></td>
                                <td width="33%"><b><span class="REGULARTEXT">Manual
                                  XpoLog Node&nbsp;
                                  </span></b></td>
                                <td width="48%"></td>
                              </tr>
                              <tr>
                                <td width="1%" nowrap></td>
                                <td width="81%" colspan="2">
                                  <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                    <tr>
                                      <td width="20%"><span class="REGULARTEXT">Host Address</span></td>
                                      <td width="33%" nowrap><input type="text" class="TEXTBOX" name="hostAddr" id="hostAddr" size="30" value="<%=hostAddr%>"></td>
                                      <td width="25%"></td>
                                    </tr>
                                    <tr>
                                      <td width="20%"></td>
                                      <td width="33%" nowrap><span class="SMALLTEXT"> XpoLog remote host address&nbsp;</span></td>
                                      <td width="25%"></td>
                                    </tr>
                                    <tr>
                                      <td width="20%"><span class="REGULARTEXT">Protocol</span></td>
                                      <td width="33%" nowrap>
                                      <select size="1" class="TEXTBOX" name="conType" id="conType">
                                      <option class="TEXTBOX" value="http" <%=protocol.equalsIgnoreCase("http")?"selected" : ""%>>HTTP</option>
                                      <option class="TEXTBOX" value="https" <%=protocol.equalsIgnoreCase("https")?"selected" : ""%>>HTTPS</option>
                                      </select>
                                      </td>
                                      <td width="25%"></td>
                                    </tr>
                                    <tr>
                                      <td width="20%"><span class="REGULARTEXT">Host Port</span></td>
                                      <td width="33%" nowrap><input type="text" class="TEXTBOX" name="hostPort" id="hostPort" size="30" value="<%=hostPort%>"></td>
                                      <td width="25%"></td>
                                    </tr>
                                    <tr>
                                      <td width="20%"></td>
                                      <td width="33%" nowrap><span class="SMALLTEXT">XpoLog remote port&nbsp;</span></td>
                                      <td width="25%"></td>
                                    </tr>
                                    <tr>
                                      <td width="20%"><span class="REGULARTEXT">Host Context</span></td>
                                      <td width="33%" nowrap><input type="text" class="TEXTBOX" name="hostContext" id="hostContext" size="30" value="<%=hostContext%>"></td>
                                      <td width="25%"></td>
                                    </tr>
                                    <tr>
                                      <td width="20%"></td>
                                      <td width="33%" nowrap><span class="SMALLTEXT">XpoLog context path (default: logeye)</span></td>
                                      <td width="25%"></td>
                                    </tr>
                                  </table>
                                </td>
                              </tr>
                            </table>
                          </td>
                          <td width="100"></td>
                        </tr>  
                        <tr>
                          <td></td>
                          <td></td>
                          <td></td>
                        </tr>
                        <tr>
                          <td colspan="2">
                    			<span class="HEADER">Security Information</span>
                          </td>
                          <td></td>
                        </tr>
                        <tr>
                          <td colspan="2">
                            <table border="0" width="100%" cellspacing="0" cellpadding="0">
                              <tr>
                                <td width="2%"><span class="REGULARTEXT"><input type="radio" value="none" id="none" name="security" onClick="javascript:checkSecurityClick()" <%if(!isUsesPaswd){%>checked<%}%> ></span></td>
                                <td width="33%" nowrap><span class="REGULARTEXT">No login required</span></td>
                                <td width="40%"></td>
                              </tr>
                              
                              	<tr>
                                	<td width="2%"><span class="REGULARTEXT"><input type="radio" value="node" id="node" name="security" onClick="javascript:checkSecurityClick()"></span></td>
                                	<td width="33%" nowrap><span class="REGULARTEXT">Login with node user settings</span></td>
                                	<td width="40%"></td>
                              	</tr>
                              
                              <tr>
                                <td width="2%"><span class="REGULARTEXT"><input type="radio" value="details" id="details" name="security" onClick="javascript:checkSecurityClick()" <%if(isUsesPaswd){%>checked<%}%>></span></td>
                                <td width="33%" nowrap><span class="REGULARTEXT">Login details</span></td>
                                <td width="40%"></td>
                              </tr>
                              <tr>
                                <td width="2%"></td>
                                <td width="67%" colspan="2" nowrap>
                                  <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                    <tr>
                                      <td width="33%"><span class="REGULARTEXT">User name</span></td>
                                      <td width="33%"><input type="text" class="TEXTBOX" name="userName" id="userName" size="30" value="<%=userName%>"></td>
                                      <td width="34%"></td>
                                    </tr>
                                    <tr>
                                      <td width="33%"><span class="REGULARTEXT">Password</span></td>
                                      <td width="33%"><input type="password" class="TEXTBOX" name="password" id="password" size="30" value="<%=password%>"></td>
                                      <td width="34%"></td>
                                    </tr>
                                    <tr>
                                      <td width="33%">&nbsp;</td>
                                      <td width="33%"></td>
                                      <td width="34%"></td>
                                    </tr>
                                  </table>
                                </td>
                              </tr>
                            </table>
                          </td>
                          <td>&nbsp;</td>
                        </tr>
                        <tr>
                          <td valign="top" nowrap>
                    			<span class="HEADER">Sources</span></td>
                          <td></td>
                          <td></td>
                        </tr>

                        <tr>
                          <td valign="top" nowrap></td>
                          <td></td>
                          <td></td>

                        </tr>
                        <tr>
                          <td valign="top" nowrap><span class="REGULARTEXT" colspan="3">Select Source</span>
                          <a href="javascript:loadTree()" class="LINK" style="padding-left:10">get logs and folders list</a>
                          </td>
                        </tr>

												<tr>
													<td valign="top" colspan="3">
														<div id="loadingDiv" style="display:none">
															<span class="REGULARTEXT">Loading...</span>
														</div>
													</td>
												</tr>

			                  <tr>
			                    <td width="15%" colspan="3">
			                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
														<tr>
															<td valign="top">
																<div id="treeboxbox_tree_1"></div>
															</td>
														</tr>
			                    </table>
			                    </td>
			                  </tr>
                        
                        <tr height="30">
                          <td colspan="3">
                          <span class="SMALLTEXT">Please select the folders and logs to add</span>
	                        </td>
                        </tr>
												<%if((op != null) && op.trim().equals(EDIT)){ %>
                       <tr>
                       <td>&nbsp;</td>
                       </tr>
                       <tr>
		                    <td colspan="3">
		                    	<span class="HEADER">Current Selected Log: </span>
	        	              <span class="REGULARTEXT"><b>&nbsp;<%=remoteLogName%></b></span>
	        	            </td>
                       </tr>
                          
                        <%} %>


                        
                      </table>
                    </td>
                  </tr>
                  <tr>                  
                    <td width="800">
                    &nbsp;</td>
                  </tr>
                  <tr>                  
                    <td>
                    <iframe name="dataFrame" style="visibility:hidden" src="" width="0" height="0"></iframe>
                    </td>
                  </tr>
                  <tr>
                    <td width="800">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
                      <tr>
                        <td width="20%">&nbsp;</td>
                        <td width="11%">
                        <p align="center"><a href="javascript:doNext();" class="LINK">save</a></td>
                        <td width="10%"><a href="<%=BASE_DIRECTORY%>common/actions/cancelAction.jsp" class="LINK">cancel</a></td>
                        <td width="16%">&nbsp;</td>
                        <td width="38%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%" width="800">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>

<script>
	tree=new dhtmlXTreeObject("treeboxbox_tree_1","100%","100%","0");
	tree.enableTreeLines(false);
	tree.setOnLoadingStart(startLoading);
	tree.setOnLoadingEnd(endLoading);
	tree.setImagePath("<%=BASE_DIRECTORY%>");
	tree.setIconSize(13,13);
	tree.enableCheckBoxes(1);
	tree.enableThreeStateCheckboxes(true);
</script>
</body>

</html>