<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.common.JobStatus"%>
<%@ page import="xpolog.eye.site.*" %>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  
  String BUILDER = "CURRENT_LOG_BUILDER";
  
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  SiteManagment mgmt = SiteManagment.getInstance();

  String modid = request.getParameter("ParentModule");

  final RemoteLogBuilder builder = (RemoteLogBuilder)request.getSession().getAttribute(BUILDER);
  
  JobStatus jobStatus = new JobStatus();
  env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, jobStatus); 
  builder.setStatus(jobStatus);
  

  if(modid == null || modid.trim().equals("")){
    modid = "rootModule";
  }
  Module parentmod = mgmt.getModuleFromId(modid);
  if(parentmod == null){
    modid = "rootModule";
    parentmod = mgmt.getModuleFromId(modid);
  }
  final Module parentModule = parentmod;
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			userContext, AuditConstants.CHANGE, "save/edit remote folder", AuditConstants.LOGS, "change the remote folder " + builder.getRemoteModuleId());
	ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "loggers/admin/remote/logaddopok.jsp") {
		public void run(HttpServletRequest request) {
      try{
      	Thread.sleep(500);
       	builder.save(parentModule);
      }catch(Exception e){
      	errmodel.addError("An error occured while creating folders, please try again");
      	createErrorRedirect(request, BASE_DIRECTORY);
    	}
		}
	};
	env.setProgressRunner(runner);
%>

<jsp:include page="../../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Processing"/>
 <jsp:param name="useStatus" value="true" />
</jsp:include>