<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="xpolog.eye.common.*"%> 
<%@ page import="omega.ui.models.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="omega.ui.html.table.OHtmlTable"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%> 
<%@ page import="java.sql.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  //constants
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String ERROR_OBJ = "ERROR_OBJ";
  String SQL_TO_VERIFY = "sqlQuery";
  String SELECTED_TABLE = "SelectedTable";
  
  String AdvancedPatternDefinitionLink = null;
  String logDataPattern = null;
  String verifyQuery = request.getParameter(SQL_TO_VERIFY);
  
  //page data
  LogBrowsingManager origLbm = null;
  LogBrowsingManager lbm = null;

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  origLbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  SQLLogSimpleBuilder builder = (SQLLogSimpleBuilder)request.getSession().getAttribute(BUILDER);
  
  if(builder == null){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("No builder exsited in session");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect("../errorpage.jsp");
    return;
  }

  String backwardURL = null;
  AdminUIController controller = builder.getUiController();
  if (controller != null){
    controller.updatePageId("SQLLogDataPattern.jsp");
    backwardURL = BASE_DIRECTORY + controller.getBackwardPage();
  }

  String userAgreed = request.getParameter("userAgreed");
  
  String showResultsStr = request.getParameter("showResults");
  boolean showResults = showResultsStr != null && showResultsStr.equals("true");
  
  RecordMask oldMask = null;
  String sql = null;
  String errorQuery = "";
  boolean queryOk = true;

  lbm = builder.getLogBrowserManager();	
  
  
  // create the tables names list

  DBAccount account = (DBAccount)builder.getAccount();
  DBMedia media = (DBMedia)builder.getMedia();
 
  boolean runLogBrowser = true;
  

  boolean isQueryIdentical = false;
  String query = "";
  
  if (!showResults){
    if(verifyQuery != null && !verifyQuery.equals("")) {
    	query = verifyQuery;
    }else {
  		query = builder.getQuery();
    }
    query = query.trim();
    if(query.equals(builder.getQuery())) { 
  	  isQueryIdentical = true; 
    }else {
      builder.setColumnsPattern(null);
    }
    builder.setQuery(query);

    logDataPattern =  isQueryIdentical? LogAdminHelper.getXpologPattern(lbm) : null;
    if(logDataPattern != null && !logDataPattern.equals("")) {
	  if(!logDataPattern.equals("{string}")){
		  builder.setRecordPattern(logDataPattern);
    	  builder.buildPatternFields();
  	  	  runLogBrowser = true;
  	  }
    }
  
    String[] pattern = builder.getColumnsPattern();
    String check = "";
    String fieldName = "";
    String patternFromFields = "";
  
  
    // check if there are null values and we are in edit
    check = request.getParameter("FieldPattren_0");
    //get the old pattern from the log
    //check if need to assamble new pattern
    if(pattern != null && pattern.length > 0 && check != null && !check.equals("")) {
	  for(int i=0; i<pattern.length; ++i) {
	  	fieldName = "FieldPattren_"+String.valueOf(i);
	  	check = "";
	  	check = request.getParameter(fieldName);
	  	if(check == null || check.equals("")) {
	  		pattern[i] = "{string}";
	  	}else {
	  		pattern[i] = check;
	  	}
	  }
	  builder.setColumnsPattern(pattern);
	  patternFromFields = builder.BuildColumnsPattern();
	  builder.setRecordPattern(patternFromFields);
    }
    if(isQueryIdentical){
    	if(logDataPattern.equals(builder.BuildColumnsPattern())){
  	    	oldMask = lbm.getRecordMask();
  	    }else{
  		  if(patternFromFields != null && !patternFromFields.equals("")) {
	  		builder.setRecordPattern(patternFromFields);
	  	    builder.buildPatternFields();
  	      }
  		} 
	}else{
  	
    }
    String maxRecordsToUseStr = request.getParameter("maxRecordsToUse");
    int maxRecordsToUse = builder.getMaxRecordsToUse();
    if (maxRecordsToUseStr != null){
      if (maxRecordsToUseStr.trim().length() > 0){
        try {
          maxRecordsToUse = Integer.parseInt(maxRecordsToUseStr);
          if (maxRecordsToUse < 0){
            maxRecordsToUse = builder.getMaxRecordsToUse();
          }
        }catch (Exception e){}
      }else {
        maxRecordsToUse = -1;
      }
    }
    builder.setMaxRecordsToUse(maxRecordsToUse);
    //check if memory problems will rise.
    int checkQuery = LogSQLAdminHelper.checkMemoryQuery(query);
  	if(((checkQuery > 0 && maxRecordsToUse > 10) || (checkQuery > 5 && maxRecordsToUse > 5) || (checkQuery > 0 && maxRecordsToUse == -1)) && userAgreed == null) {
  	   response.sendRedirect("askUserPermission.jsp?url=SQLLogDataPattern.jsp");
  	   return;
  	}
    try {
  	  //if query not valid default pattern exists
      builder.updateBuilder();
      builder.buildPatternFields();
      lbm = builder.getLogBrowserManager();
    
      //check if the query is executable
 	  if(!media.verifyQuery() || !media.isUpdateVerification()){
	    queryOk = false;
	  	errorQuery = media.getLastErrorMessage();
	  	runLogBrowser = false;
      }
    
    
      if (oldMask != null){
        builder.getLogBrowserManager().setRecordMask(oldMask);
      } 
    
    }catch(Exception e){
    	errorQuery = e.getMessage();
    	queryOk = false;
    }
  }else {
    query = builder.getQuery();
  }
  
  String html = "";
  runLogBrowser = runLogBrowser && queryOk;

  final UserEnvironment env = UserEnvironment.getUserEnvironment(request);
%>

<%
  if(runLogBrowser && !showResults){
	
	JobStatus status = lbm.getLinearDataBuilder().getLinearDataSource().getJobStatus(); 
	env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, status); 
	final LogBrowsingManager lbmRunner = lbm;
	
	ProgressRunner runner = new ProgressRunner("SQLLogDataPattern.jsp?showResults=true") {
 	 public void run(HttpServletRequest request){
    	 RecordsMaskTableModel model = lbmRunner.getFirstEntries(10);
    	 env.setTempAttribute("resultsModel", model); 
  	 }
	};
	env.setProgressRunner(runner);
  
%>
<jsp:include page="../../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Processing"/>
 <jsp:param name="useStatus" value="true"/>
 <jsp:param name="stopUrl" value="loggers/admin/common/adminPumperStopAction.jsp"/>
</jsp:include>
<%
    return;
  }else {
    if (showResults){
      RecordsMaskTableModel model = (RecordsMaskTableModel)env.getTempAttribute("resultsModel");
      if (model != null){
        //html creation
        LogEyeModel lem = new LogEyeModel(BASE_DIRECTORY,lbm.getCustomizationManager(),model);
        OHtmlTable tab =  new OHtmlTable(lem);
        LogEyeCellRenderer cr = new LogEyeCellRenderer(lem);
        LogEyeRowRenderer rr = new LogEyeRowRenderer(lem);
        tab.setRowRenderer(rr);
        tab.setCellRenderer(cr);
        tab.render();
        html = tab.getHtml();       
      }
    }
  }

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<jsp:include page="../../../scripts/dataview/dataView.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
</jsp:include>
<script language="javascript">
	function tableSelection(){
	    document.access.sqlQuery.value="";
  	    document.access.action = "SQLLogDataPattern.jsp";
  	    document.access.submit();
    }
	
	function doNext(){
    	document.access.action = "SQLLogDataPatternAction.jsp?isNext=true";
        document.access.submit();
	}
	   	 
   	function doVerify(){
        document.access.action = "SQLLogDataPattern.jsp";
  	    document.access.submit();
    }
    
    function doSave(){
        document.access.action = "SQLLogDataPatternAction.jsp?isNext=false";
  	    document.access.submit();
	}
   
    
    function shownHideAdv(){
    	show = document.getElementById("defShowLink").style.display == "";
    	if(show){
    		document.getElementById("advanced").style.display  = "";
    		document.getElementById("defShowLink").style.display="none";
    		document.getElementById("defHideLink").style.display="";    		
    	}else{
    		document.getElementById("advanced").style.display  = "none";
    		document.getElementById("defShowLink").style.display="";
    		document.getElementById("defHideLink").style.display="none";
    	}	
    }
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" name="access" id="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="9" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="425" class="TOPBORDER">
                <span class="PAGEHEADER">Database query administration</span></td>
                <td width="457" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>             
              <tr>
                <td width="8" >&nbsp;</td>
                <td colspan="2" width="881">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">                                   
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td><span class="HEADER">Logs Query</span></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">Here you need to specify the query you 
                    want XpoLog to execute on one or more of the choosen logs</span></td>
                  </tr>
                  <tr>
                    <td><textarea class="TEXTBOX" rows="3" id="sqlQuery" name="sqlQuery" cols="120" style="font-size: 8pt"><%=query%></textarea></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">example: SELECT * FROM TABLE1, TABLE2 &nbsp;&nbsp;&nbsp;</span></td>
                  </tr>
                  <tr>
                    <td>
                      <table border="0" width="602" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="260">&nbsp;</td>
                          <td width="250"><a href="javascript:doVerify()" class="LINK">verify query</a></td>
                          <td width="1"></td>                         
                        </tr>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td><span class="HEADER">Query verification status</span></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">Analysis result of the log lines with the
                      query</span></td>
                  </tr>
                  <tr>
                    <td>
                        <span class="REGULARTEXT">Query verification -
                        <%if(queryOk){%>
			 	<span class="OKMESSAGE">ok</span>
			<%}else{%>
                <span class="ERRORMESSAGE">error:
                        <%=errorQuery%></span>
			<%}%>
                        </span>
                    </td>
                  </tr>

                  <tr>
                    <td>&nbsp;</td>
                  </tr>

                  <tr>
                    <td><a href="javascript:shownHideAdv()" class="LINK"><div id="defShowLink">Show advanced Pattern Definition</div><div id="defHideLink" style="display:none">Hide advanced Pattern Definition</div></a></td>
                  </tr>

                  <tr>
                    <td><input type="hidden" name="isAdvOpen"/>
                    <div id="advanced" style="display:none">
                    
                      <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="700">
                        <tr>
                          <td width="33%"><span class="HEADER">Field Name </span></td>
                          <td width="33%"><span class="HEADER">Field Pattern
                          </span></td>
                          <td width="34%">&nbsp;</td>
                        </tr>
                        <%
                       	String[] patternForFields = builder.getColumnsPattern();
                       	String[] names = builder.buildColumnNameFromQuery();
                        if(names != null && patternForFields != null && names.length > 0 && patternForFields.length > 0 && query != "" && query != null && !query.equalsIgnoreCase(DBMedia.BASE_QUERY)) {
                        	for(int i=0;i<names.length;++i){
                        %>
                        <tr>                    
                          <td width="33%"><span class="REGULARTEXT"><%=names[i]%></span></td>                   
                          <td width="33%">
                          <input type="text" name="FieldPattren_<%=String.valueOf(i)%>" size="50" value="<%=patternForFields[i]%>"> </td> 
                          <td width="34%">&nbsp;</td>
                        </tr>
                        <%
                        	}//for
                        }//if
                        %>
                      </table>
                      <p align="center"><a href="javascript:doVerify()" class="LINK"> verify patterns and query</a><p>&nbsp;
                      
                      </div>
                      </td>
                  </tr>

                  <tr>
                    <td>&nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td><span class="HEADER">Preview settings</span></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT"></span></td>
                  </tr>
                  <tr>
                    <td>
                        <span class="REGULARTEXT">Use the first &nbsp;<input id="maxRecordsToUse" name="maxRecordsToUse" type="text" size="5" value="<%=builder.getMaxRecordsToUse() == -1 ? "" : String.valueOf(builder.getMaxRecordsToUse())%>"></input>&nbsp; of log records to show result.
                        </span>
                    </td>
                  </tr>

                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  
                  <tr>
                    <td><span class="HEADER">Log records analysis result&nbsp;&nbsp;</span></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">Here you can see the log lines after they
                      were analyzed using the data pattern</span></td>
                  </tr>
                  <tr>
                    <td><%=html%></td>
                  </tr>
                  <tr>
                    <td>&nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td>&nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="892" id="AutoNumber17">
                      <tr>
                        <td width="164">&nbsp;</td>
                        <td width="90">
                        <p align="center"><a href="<%=BASE_DIRECTORY%>common/actions/cancelAction.jsp" class="LINK">cancel</a></td>
                        <td width="91"><a href="<%= backwardURL != null ? backwardURL : "javascript:history.go(-1)"%>" class="LINK">previous</a></td>
                        <td width="94">
                          <p align="left"><a href="javascript:doNext()" class="LINK">next</a></p>
                        </td>
                        <td width="147"><a href="javascript:doSave()" class="LINK">save</a></td>
                        <td width="296">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>