<%@ page language="java"%>

<%@ page import="java.text.*"%>
<%@ page import="java.util.*"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.audit.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.data.log.external.*"%>
<%@ page import="xpolog.eye.data.util.FileFilterConfiguration"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@page import="xpolog.eye.data.util.NameExpression"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%@ include file="../fileFilterConfigurationAction.jsp"%>

<%
	String ERROR_OBJ = "ERROR_OBJ";
	String LOG_NAME = "LogName";
	String LOG_DESCRIPTION = "LogDescription";
	String REFRESH_RATE = "RefreshRate";
	String PARENT_MODULE = "ParentModule";
	String ACCOUNT_ID = "accountId";
	String LOG_PATH = "LogPath";
	String LOG_NAME_PAT = "LogNamePattern";
	String LOG_DATA_PATTERN = "DataPattern";
	String LOG_ID = "LOG_ID";
	final String BUILDER = "CURRENT_LOG_BUILDER";
	String CURRENT_LOG = "CURRENT_LOG";
	String LOG_TIME_ZONE = "TimeZone";
	String LOG_CHARSET = "charset";
	final String MODULE_ID = "MODULE_ID";
	String DOWNLOAD_FILES = "DownloadFiles";
	String AUTO_UPDATE = "AutoUpdate";
	String IS_DUPLICATE_MODE = "isDuplicateMode";
	String NUM_OF_PATHS = "numOfPaths";
  
	SiteManagment mgmt = SiteManagment.getInstance();
	SiteAdministrator admin = SiteManagment.getAdminInstance();

	final String modid = request.getParameter(PARENT_MODULE);
  String parentApps = request.getParameter("parentApplication");
	HashSet applicationsIds = new HashSet();
  String[] appArr = null;
	if(parentApps != null && parentApps.length() >0){
		appArr = parentApps.split("#");
		for(int i = 0 ;	appArr != null &&  i < appArr.length ; i++){
			applicationsIds.add(appArr[i]);
		}		
	}	
	String logname = request.getParameter(LOG_NAME);
	String logdesc = request.getParameter(LOG_DESCRIPTION);
	ArrayList sourceList = new ArrayList();
	String logdatapat = request.getParameter(LOG_DATA_PATTERN);
	String timeZoneId = request.getParameter(LOG_TIME_ZONE);
	String charset    = request.getParameter(LOG_CHARSET);
	String aId = request.getParameter(ACCOUNT_ID);
	String refrate = request.getParameter(REFRESH_RATE);
	String downloadFilesString = request.getParameter(DOWNLOAD_FILES);
	String autoUpdateString = request.getParameter(AUTO_UPDATE);
  String isDuplicateModeStr = request.getParameter(IS_DUPLICATE_MODE);
  boolean isDuplicateMode = isDuplicateModeStr != null && isDuplicateModeStr.equals("true");
	String dynamicFiles = request.getParameter("dynamicFiles");
	String sortFilesStr = request.getParameter("sortFiles");
	boolean sortFilesByLastUpdate = sortFilesStr != null && sortFilesStr.equals("byLastUpdate");
	
	String doSaveStr = request.getParameter("doSave");
	boolean doSave = doSaveStr != null && doSaveStr.length() > 0;

	if (charset != null && charset.equals("default")){
    charset = null;
  }
	
  String LOG_LOCATION_PATH = "fullPath_";  
  String LOG_LOCATION_STATUS = "locationStatus_";    
  String LOCATIONS_CNTR = "locationCntr";
  String locationCntrStr      = request.getParameter(LOCATIONS_CNTR);
  int locationsCntr = 0 ;
  try{
  	locationsCntr = Integer.parseInt(locationCntrStr);
  }catch(NumberFormatException e){
  	locationsCntr = 0;
  }
  int fileBehavior = 0;
  String _fileBehavior = request.getParameter("fileBehavior");
  if(_fileBehavior != null && _fileBehavior.length() > 0){
		try{
			fileBehavior = Integer.parseInt(_fileBehavior);
		}catch(Exception e){
			fileBehavior = 0;
		}
  }
  String locationFullPath = "";
  String locationStatus = "";  
  NameExpression nameExpr = new NameExpression();
  ArrayList nameExprList = new ArrayList();
  for(int i = 0 ; i < locationsCntr ; i++){
  	String pathParam = LOG_LOCATION_PATH + i;
  	String statusParam = LOG_LOCATION_STATUS + i;
  	locationFullPath = request.getParameter(pathParam);
  	if(locationFullPath != null && locationFullPath.length() > 0){
			String path = locationFullPath;
			int indx2 = path.indexOf("?");
			if (indx2 > 0){
				path = path.substring(0,indx2);
			}
			int indx = path.lastIndexOf("/");
			int indx1 = path.lastIndexOf("\\");
			if(indx < 0){
				indx = indx1;
			}else if(indx < indx1){
				indx = indx1;
			}
  		String dir = locationFullPath.substring(0,indx + 1);	
  		sourceList.add(dir);
  		String pattern = locationFullPath.substring(indx+1,locationFullPath.length());
  		locationStatus = request.getParameter(statusParam);
  		int dynmicState;
  		try{
  			dynmicState = (locationStatus != null && locationStatus.length() > 0) ? Integer.parseInt(locationStatus) : 0;
  		}catch(NumberFormatException e){
  			dynmicState = 0;
  	  }
  		int dynmicStateToDisplay = dynmicState;
  		dynmicState = dynmicState < 0 ? fileBehavior : dynmicState;
  		nameExpr = new NameExpression();
  		nameExpr.setDirectory(dir);
  		nameExpr.setXpologNamePatternsStr(pattern);
  		nameExpr.setLogDynamicType(LogAdminHelper.convertToFileBehavior(dynmicState));
  		nameExpr.setLogDynamicTypeToDisplay(dynmicStateToDisplay);
  		nameExprList.add(nameExpr);
  	}
  }	
	
	
		
		String oldSourceListStr = request.getParameter("oldSourceList");	
		if(oldSourceListStr == null){
			oldSourceListStr = "";
		}
	//verify data
	ErrorModel errmodel = new ErrorModel();

	if (logname == null || logname.trim().equals("")) {
		errmodel.addError("No name was supplied.");
	}

	if (WebUtil.isContainSpecialCharecter(logname)) {
		errmodel.addError("The following characters are prohibited in the name field: " + WebUtil.getSpecialCharectersList());
	}
	if(nameExprList == null || nameExprList.size() == 0){
		errmodel.addError("please check log's path and pattern.");
	}
 	
	if (modid == null || modid.trim().equals("")) {
		errmodel.addError("No parent folder was selected. If no folder is available please check your permissions");
	}

	if (aId == null || aId.trim().equals("")) {
		errmodel.addError("No Account was supplied.");
	}
	
	FileFilterConfiguration fileFilterConfiguration = null;
	try {
		fileFilterConfiguration = createFileFilterConfiguration(request, response);
	}catch(Exception e) {
		errmodel.addError(e.getMessage());
	}

	Account acc = AddressBook.getInstance().getAccountById(aId);
	/*if (acc instanceof TelnetAccount && 
	 ((TelnetAccount)acc).getTypeOfConnecion().equals(TelnetAccount.TYPE_SCP) &&
	 lognameexp != null && lognameexp.indexOf("{") != -1){
	 errmodel.addError("SCP connections do not support generic file name patterns");
	 errmodel.addError("Please enter a specific file name or use an SFTP SSH account");
	 }*/

	/*if(lognameexp != null && lognameexp.toLowerCase().endsWith(".gz")) {
	 errmodel.addError("GZip files cannot be viewed without downloading");
	 errmodel.addError("Please specify a non GZip file name or check the 'Download Files' checkbox");
	 }*/

	long refreshInterval = -1;
	try {
		refreshInterval = refrate == null ? -1 : Long.parseLong(refrate);
	}catch (Exception e) {
		errmodel.addError("Please supply a valid refresh rate.");
	}

	boolean downloadFiles = true;
	if (downloadFilesString == null || !downloadFilesString.equals("true")) {
		downloadFiles = false;
	}

	boolean autoUpdate = true;
	if (autoUpdateString == null || !autoUpdateString.equals("true")) {
		autoUpdate = false;
	}

	if (errmodel.getErrorCount() != 0) {
		request.getSession().setAttribute(ERROR_OBJ, errmodel);
		response.sendRedirect("../errorpage.jsp");
		return;
	}

	String op = request.getParameter("OP");
	if(op == null || op.length()==0){
		op = "ADD";
	}

	String logAdminScreenWidth = request.getParameter("LogAdminScreenWidth");
	if(logAdminScreenWidth == null || logAdminScreenWidth.length()==0){
		logAdminScreenWidth = "600px";
	}
	LogBrowsingManager lbm = null;
	lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  if(lbm != null && !lbm.getType().equals(SshSimpleBuilder.SSH_LOG_TYPE)){
  	lbm = null;
  	request.getSession().removeAttribute(CURRENT_LOG);
  }


	final SshSimpleBuilder builder = (SshSimpleBuilder)LogBrowserBuilderFactory.getLogBroserBuilderByType(LogBrowserBuilderFactory.SSH_LOG_TYPE);

	if (lbm != null) {
		builder.setID(lbm.getId());
		builder.setIgnoreUnparsedRecords(LogAdminHelper.isIgnoreUnparsedRecords(lbm));
		builder.setUpdateLinesNumber(LogAdminHelper.isUpdateLinesNumber(lbm));
		logdatapat = LogAdminHelper.getXpologPattern(lbm);
		builder.setDataSourceFactory(LogAdminHelper.dataSourceFactory(lbm));
    builder.setUseIndexing(lbm.isUseIndexing());
    builder.setUseIndexingForDateSearch(lbm.isUseIndexingForDateSearch());
    builder.setIndexNullValues(lbm.isIndexNullValues());
    builder.setUseWholeWords(lbm.isUseWholeWords());
    builder.setDataSourceHeaderBuilder(LogAdminHelper.getHeaderBuilder(lbm),true);
    builder.setOnline(lbm.isOnline());
		builder.setDynamicFiles(LogAdminHelper.isDynamicFiles(lbm));
		builder.setSortByLastUpdate(LogAdminHelper.isSortByLastUpdate(lbm));
	  builder.setFileFilterConfiguration(fileFilterConfiguration);
		builder.setUseQuickFilter(lbm.isUseQuickFilter());
		builder.setComputeStatistics(lbm.isComputeStatistics());
		builder.setUseInDashboard(lbm.isUseInDashboard());
		builder.setUseInDashboardTask(lbm.isUseInDashboardTask());
		builder.checkLocationsChanges(nameExprList,oldSourceListStr);
		builder.setUseSearchSuggestions(lbm.isUseSearchSuggestions());
    builder.setCollectionUnits(lbm.getCollectionUnits());
    builder.setHost(lbm.getHost());
	}

	builder.setName(logname);
  builder.setApplicationsIds(applicationsIds);  
	builder.setNameExprList(nameExprList);
	builder.setRecordPattern(logdatapat);
	builder.setLogDescription(logdesc);
	builder.setTimeZoneId(timeZoneId);
	builder.setCharset(charset);
  boolean isDynamic = fileBehavior == FileExtend.DATA_CHANGE_NAME_CHANGE_ATT || fileBehavior == FileExtend.DATA_FIXED_NAME_CHANGE_ATT;
  builder.setDynamicFiles(isDynamic);
	builder.setSortByLastUpdate(sortFilesByLastUpdate);
  builder.setFileFilterConfiguration(fileFilterConfiguration);
  builder.setFileBehavior(fileBehavior);
	
	Media med = MediaManager.newInstace().getMediaByAccount(acc);

	builder.setMedia(med);
	builder.setAccount(acc);
	if (refreshInterval != -1) {
		refreshInterval = refreshInterval * 1000 * 60;
	}
	builder.setDownloadFiles(downloadFiles);
	builder.setRefreshInterval(refreshInterval);
	builder.setAutoUpdate(autoUpdate);
  builder.setSourceLocationList(sourceList);
  
  builder.setDuplicateMode(isDuplicateMode);
  
  //audit
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  AuditManager auditMgr = AuditManager.getInstance();
  for(int i = 0 ;nameExprList != null &&  i < nameExprList.size() ; i++){    	
	  auditMgr.write(AuditConstants.BASIC_AUDIT_LEVEL,
  	userContext, AuditConstants.CHANGE, "create/edit log", AuditConstants.LOGS, "create/edit log " + logname + " path - " + ((NameExpression)nameExprList.get(i)).getDirectory()+((NameExpression)nameExprList.get(i)).getXpologNamePatternsStr()); 
  }

  boolean isNew = lbm == null || lbm.getId() == null;
  
	if (doSave) {
		builder.updateBuilder();

		//save new log without setting pattern(gets first pattern from suggestion).
  	if(lbm == null && builder.getLogBrowserManager() != null){
  		String []events = LogAdminHelper.readLines(builder.getLogBrowserManager(),100);
			String xpoPattern = PatternAdminHelper.getFirstPattrernSuggestion(events);
			builder.setRecordPattern(xpoPattern);  		
			builder.updateBuilder();
  	}
  		
		lbm = builder.getLogBrowserManager();
		LogBrowsingManager oldlbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
		if(oldlbm != null){
			lbm.setFilterManager(oldlbm.getFilterManager());
			lbm.setRecordMask(oldlbm.getRecordMask());
			LogAdminHelper.getLogRecordBuilder(lbm).setMergeColumns(LogAdminHelper.getMergeIndexing(oldlbm));
			lbm.setCustomizationManager(oldlbm.getCustomizationManager());
	    lbm.setSearchAndFilterDef(oldlbm.getSearchAndFilterDef());
			lbm.setConsolidation(oldlbm.isConsolidation());
		}
		Module parentmod = mgmt.getModuleFromId(modid);
		if (parentmod == null) {
			parentmod = mgmt.getModuleFromId(modid);
		}
		IntervalDataSource ds = IntervalAdminHelper.getIntervalDataSource(lbm);
		if(ds != null) {
			ds.setLogBrowserId(lbm.getId());
		}
	  LogAdminHelper.updateLogApplicationsMetas(lbm.getId(),applicationsIds);
	  
	  LogAdminHelperQuery reindexQuery = new LogAdminHelperQuery();
		reindexQuery.setLbm(lbm);
		reindexQuery.setHandleSortByLastUpdate(true);
		boolean shouldReindex = LogAdminHelper.shouldReindex(reindexQuery);
	  
	  String newId = admin.addLogBrowser(lbm, parentmod, userContext);
	  if(isNew && newId != null && newId.length() > 0) {
	  	String[] lbmIds = new String[1];
	  	lbmIds[0] = lbm.getId();
	  	admin.generateLogData(lbmIds, userContext);
	  }
		request.getSession().setAttribute(CURRENT_LOG, lbm);
		
		if(shouldReindex) {
    	LogAdminHelper.reindexLog(userContext, lbm.getId());
    }
		
		auditMgr.write(AuditConstants.BASIC_AUDIT_LEVEL, userContext, AuditConstants.CHANGE, "save/edit log", AuditConstants.LOGS, "change the log " + lbm.getName());
		env.setTempAttribute(SiteConstants.FORWARD_URL_ATTRIBUTE, "loggers/admin/logaddopok.jsp?removeLog=" + !builder.isLogCanBeUsed());
		response.sendRedirect(BASE_DIRECTORY + "common/actions/nextAction.jsp");
		return;
	}
	request.getSession().setAttribute("IS_NEW", Boolean.valueOf(isNew));
	
	String[] pages = {"loggers/admin/logAdminGate.jsp?isPrevious=true&logType=ssh&OP=" + op,
	"loggers/admin/logDataPattern.jsp?OP=" + op + "&LogAdminScreenWidth=" + logAdminScreenWidth,
	"loggers/admin/logFieldAdmin.jsp"};
	AdminUIController controller = new AdminUIController(pages);
	builder.setUiController(controller);

	final UserEnvironment _env = UserEnvironment.getUserEnvironment(request);

	ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + controller.getForwardPage()) {
		public void run(HttpServletRequest request) {
	try {
    
    Thread.sleep(200);
		//for configuration reasons
		builder.updateBuilder();
	}catch (Exception e) {
		errmodel.addError("Building log problem,please check patterns and path again.");
		errmodel.addError(e.getMessage());
		createErrorRedirect(request,BASE_DIRECTORY);
	}
	request.getSession().setAttribute(MODULE_ID, modid);
	request.getSession().setAttribute(BUILDER, builder);
		}
	};
	_env.setProgressRunner(runner);
	_env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, med);
%>
<%@page import="xpolog.eye.admin.patterns.PatternAdminHelper"%>
<%@page import="xpolog.eye.data.util.FileExtend"%>
<jsp:include page="../../../common/actionProgress.jsp" flush="true">
	<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>" />
	<jsp:param name="message" value="Processing" />
	<jsp:param name="useStatus" value="true" />
</jsp:include>