<%@page import="java.util.regex.Matcher"%>
<%@page import="java.util.regex.Pattern"%>
<%@ page language="java"%>
<%@page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.logview.*"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
	ErrorModel err = new ErrorModel();
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	LogViewContext logcontext = (LogViewContext) request.getSession().getAttribute(LogViewContext.LOG_CONTEXT);
	String searchText = request.getParameter("searchText");
	if (searchText == null){
		searchText = "";
	}
	
	
	
	searchText = searchText.replaceAll("<[/]*NOBR>","");
	searchText = searchText.replaceAll("<[/]*B>","");
	searchText = searchText.replaceAll("<[/]*U>","");
	//System.out.println("searchText = " + searchText);
//	searchText = URLEncoder.encode(searchText,"UTF-8");	
	
	String colName = "";
	String colIndexStr = "";
	
	
	ArrayList classesList = new ArrayList();
	Pattern pat = Pattern.compile("at (\\w+\\.[\\w\\.]+)\\.[\\w]+\\(",Pattern.DOTALL);
	Matcher matcher = pat.matcher(searchText);
	while (matcher.find()){
		String str = matcher.group(1);
		if (!classesList.contains(str)){
		  classesList.add(str);
		}
	}
	String url = "";
	
	if (classesList.size() == 0){
		pat = Pattern.compile("[^\\w\\.]*(\\w+\\.[\\w\\.]+)\\.[\\w]+\\(",Pattern.DOTALL);
		matcher = pat.matcher(searchText);
		String classStr = "";
		if (matcher.find()){
			classStr = matcher.group(1);		
		}
		//System.out.println(classStr);
		if (classStr != null && classStr.length() > 0){
			url = "http://www.jdocs.com/link/" + classStr.replaceAll("\\.","/") + ".html";
		}else {
			pat = Pattern.compile("[^\\w\\.]*(\\w+\\.[\\w\\.]+)[^\\w\\.]*",Pattern.DOTALL);
			matcher = pat.matcher(searchText);
			if (matcher.find()){
				classStr = matcher.group(1);		
			}
			//System.out.println(classStr);
			if (classStr != null && classStr.length() > 0){
				url = "http://www.jdocs.com/link/" + classStr.replaceAll("\\.","/") + ".html";
			}			
		}
		
	}
	
	boolean success = classesList.size() > 0 || url.length() > 0;
	String message = "No class found in search text";
	
	if (classesList.size() > 0){
		StringBuffer msg = new StringBuffer();
		msg.append("<div style=\"height:200px;overflow:auto\">");
		msg.append("<table border=\"0\" cellpadding=\"0\" cellmargin=\"0\" height=\"100%\" width=\"100%\">");
		msg.append("<tr heght=\"10\"><td><SPAN class=\"SMALLTEXT\" >Search in jdocs for:</span></td></tr>");
		msg.append("<tr height=\"10\">");
		msg.append("<td style=\"background:#EAEBDB;color:gray;font-family:verdanan;font-size:8pt;font-weight:bold;padding-left:5\">Class</td>");
		msg.append("<td style=\"background:#EAEBDB;color:gray;font-family:verdanan;font-size:8pt;font-weight:bold;padding-left:5\">Package</td>");
		msg.append("</tr>");		
		for (int i = 0; i < classesList.size();i++){			
			String str = (String)classesList.get(i);
			int index = str.lastIndexOf(".");
			String cls = str;
			String pkg = "";
			if (index > 0){
				cls = str.substring(index + 1);
				pkg = str.substring(0,index);
			}
			String u = "http://www.jdocs.com/link/" + str.replaceAll("\\.","/");
			String pkgu = "http://www.jdocs.com/link/" + pkg.replaceAll("\\.","/");
			msg.append("<tr height=\"10\"><td style=\"padding-left:5;padding-right:5;background:#EAEBDB\">");
			msg.append("<a href=\"javascript:hideLayer('logviewMessage');openWindow('" + u + ".html','_blank')\" class=\"BUTTON_SMALLLINK\" style=\"font-family:verdana;font-size:8pt\" >");
			msg.append(cls);
			msg.append("</a></td>");
			msg.append("<td style=\"padding-left:5;padding-right:5;background:#EAEBDB\">");
			if (pkg.length() > 0){
			  msg.append("<a href=\"javascript:hideLayer('logviewMessage');openWindow('" + pkgu + "/package-summary.html','_blank')\" class=\"BUTTON_SMALLLINK\" style=\"font-family:verdana;font-size:8pt\" >");
			  msg.append(pkg);
			  msg.append("</a></td>");
			}else {
				msg.append("&nbsp;");
			}
			msg.append("</td>");
			msg.append("</tr>");
		}
		msg.append("<tr heght=\"*\"><td><SPAN style=\"font-size:2pt\" >&nbsp;</span></td></tr>");
		msg.append("</table></div>");
		
		message = msg.toString();
	}
	
	StringBuffer result = new StringBuffer();
	result.append("<root>");
	result.append("<result>");
	result.append(success);
	result.append("</result>");
	if (url != null && url.length() > 0){
	  result.append("<url>");
	  result.append(url);
	  result.append("</url>");
	}
	result.append("<message><![CDATA[");
	result.append(message);
	result.append("]]></message>");
	result.append("<title><![CDATA[");
	result.append("<table width=\"100%\" background=\"#5c5cdc\" style=\"background:#e8e8f8\"><tr><td align=\"right\" style=\"\"><img src=\"../images/ui/ext/jdocs.gif\"></td><td style=\"padding-left:10;padding-right:100\"><span style=\"font-size:14pt;color:#3366AA;font-weight:bold\">JDocs</span></td></tr></table>");
	result.append("]]></title>");
	result.append("<width>");
	result.append(classesList.size() == 0 && url.length() == 0 ? 350 : 500);
	result.append("</width>");
	result.append("<height>");
	result.append(classesList.size() > 3 ? 200 : 120);
	result.append("</height>");
	
	
	result.append("</root>");

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	out.write(result.toString());
	out.flush();

%>
	
