<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.logview.LogZoomOutParams"%>

<%@ page import="java.util.*"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<% 
	String CURRENT_LOG = "CURRENT_LOG";

	String lbmId = "";
	String search = "";
	String regExp = "";
	String filterWholeWords = "";
	String leapsize = "";
	String opdirect = "";
	FilterCollection fc = null;
	String filterId;

	LogBrowsingManager lbm = null;
  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  String zoomOutLbmId = null;
  if (lbm != null){
  	LogBrowsingManager zoomOutLbm = (LogBrowsingManager)lbm.getZoomOutLbm();
  	if (zoomOutLbm != null){
  		zoomOutLbmId = zoomOutLbm.getId();
  		request.getSession().setAttribute(CURRENT_LOG,zoomOutLbm);
  	}
  	lbm.setZoomOutLbm(null);
  	lbm.dispose();
  }
  
  LogZoomOutParams params = (LogZoomOutParams)request.getSession().getAttribute("ZOOM_OUT_PARAMS");
  if (params != null){
  	lbmId = params.getLbmId();
		search = params.getSearch();
		regExp = params.getRegExp();
		filterWholeWords = params.getFilterWholeWords();
		leapsize = params.getLeapsize();
		opdirect = params.getOpdirect();

		request.getSession().removeAttribute("ZOOM_OUT_PARAMS");
  }

  Integer calls = (Integer)request.getSession().getAttribute("callsPage");
  int cal = 0;
  if(calls != null){
  	cal = calls.intValue();
  }
%>

<html>
<head>
</head>

<body onload="javascript:document.access.submit()">
	<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" action="logview.jsp">
		<%if (zoomOutLbmId != null){%>
		<input type="hidden" name="logid" value="<%=zoomOutLbmId%>">
		<%}%>
		<%if (search != null){%>
		<input type="hidden" name="search" value="<%=search%>">
		<%}%>
		<%if (regExp != null){%>
		<input type="hidden" name="regExp" value="<%=regExp%>">
		<%}%>
		<%if (filterWholeWords != null){%>
		<input type="hidden" name="filterWholeWords" value="<%=filterWholeWords%>">
		<%}%>
		<%if (leapsize != null){%>
		<input type="hidden" name="leapsize" value="<%=leapsize%>">
		<%}%>
		<input type="hidden" name="opdirect" value="LAST_FILTER_VIEW">
		<input type="hidden" name="calls" value="<%=cal%>">
	</form>
</body>
</html>


