<%@ page language="java"%>

<%@ page import="java.text.SimpleDateFormat"%>
<%@ page import="java.util.Date"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.computation.ComputationResultView"%>
<%@ page import="xpolog.eye.logview.LogViewContext"%>
<%@ page import="xpolog.eye.managment.XpologManagment"%>
<%@ page import="xpolog.eye.util.Constants"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
	String baseDirectory = request.getParameter("base_directory");
	String startTime = "";
	String endTime = "";
	String graphMap = "";
	if(baseDirectory == null){
		baseDirectory = BASE_DIRECTORY;
	}
	String link = "";
	String graphImagePath = "";
  LogViewContext logcontext = (LogViewContext)request.getSession().getAttribute(LogViewContext.LOG_CONTEXT);
  ComputationResultView computationResultView = null;
	if(logcontext == null){
		out.write("error");
		out.flush();
		return;
	}else{
		computationResultView = logcontext.computationResultView;
		graphImagePath = computationResultView.getGraphImagePath();
		
		SimpleDateFormat dateFormat = new SimpleDateFormat("MM/dd/yyyy HH:mm");
		long start = computationResultView.getStartTime();
		if (start % 300000 > 0){
			start = start - (start % 300000); 
		}
		startTime = dateFormat.format(new Date(start));
		endTime = dateFormat.format(new Date(computationResultView.getEndTime()));
		
		link = baseDirectory + "componentAction.jsp?selectedCompId=" + XpologManagment.ANALYTICS_COMPONENT + "&forward=root.jsp?mainPage=dashboard/view/loadObjectDashboardModel.jsp%253F";
		StringBuffer buffer = new StringBuffer();
		buffer.append("objectType=");
		buffer.append(computationResultView.getType());
		buffer.append("&objectId=");
		buffer.append(computationResultView.getId());
		buffer.append("&startTime=");
		buffer.append(computationResultView.getStartTime());
		buffer.append("&endTime=");
		buffer.append(computationResultView.getEndTime());
		String queryString = buffer.toString();
		queryString = XpologUtil.replaceAll(queryString, "&", "%26");
		queryString = XpologUtil.replaceAll(queryString, "%", "%25");
		link += queryString;
		
		graphMap = computationResultView.getGraphMap();

	}
	String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);
%>
<div id="dashboardMetricsGraphLegendDiv" class="DASHBOARD_METRICS_GRAPH_LEGEND_DIV">
	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
		<tr>
			<td><span class="DASHBOARD_METRICS_GRAPH_LEGEND_CPU_TEXT">CPU</span>&nbsp;<span class="DASHBOARD_METRICS_GRAPH_LEGEND_TEXT_SEPERATOR">|</span>&nbsp;<span class="DASHBOARD_METRICS_GRAPH_LEGEND_MEMORY_TEXT">Memory</span></td>
		</tr>
	</table>
</div>
<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
	<tr>
		<td class="LOG_VIEWER_DASHBOARD_TABLE_MAIN_CELL">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr height="10px">
					<td class="LOG_VIEWER_DASHBOARD_TABLE_TITLE_CELL">
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td class="LOG_VIEWER_DASHBOARD_TABLE_TITLE_TEXT"><%=analyticsH %> Summary</td>
								<td>&nbsp;</td>
								<td class="LOG_VIEWER_DASHBOARD_TABLE_TITLE_DATES_TEXT"><%=startTime%>&nbsp;-&nbsp;<%=endTime%></td>
							<tr>
							<tr><td><span style="font-size: 3px">&nbsp;</span></td></tr>
							<tr>
								<td width="120px"><span class="LOG_VIEWER_DASHBOARD_TABLE_SUB_TITLE_TYPE_TEXT">Events: </span><span class="LOG_VIEWER_DASHBOARD_TABLE_SUB_TITLE_VALUE_TEXT"><%=computationResultView.getTotal() %></span></td>
								<td width="120px"><span class="LOG_VIEWER_DASHBOARD_TABLE_SUB_TITLE_TYPE_TEXT">Problems: </span><span class="LOG_VIEWER_DASHBOARD_TABLE_SUB_TITLE_VALUE_TEXT"><%=computationResultView.getTotalProblems() %></span></td>
								<td>&nbsp;</td>
							<tr>
						</table>
					</td>
				</tr>
				<tr height="10px">
					<td id="dashboardGraphTD">
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td><img id="graphImg" src="<%=graphImagePath%>" border="0" usemap="#total"></td>
							</tr>								
						</table>
					</td>
				</tr>
				<tr height="1px"><td><span style="font-size: 1px">&nbsp;</span></td></tr>
				<tr height="10px">
					<td class="LOG_VIEWER_DASHBOARD_TABLE_FOOTER_CELL">
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td>&nbsp;</td>
								<td class="LOG_VIEWER_DASHBOARD_TABLE_FOOTER_GO_CELL"><a href="<%=link%>" class="LOG_VIEWER_DASHBOARD_TABLE_FOOTER_TEXT_LINK" target="_new">Go to <%=analyticsH %></a></td>
								<td class="LOG_VIEWER_DASHBOARD_TABLE_FOOTER_CLOSE_CELL"><a href="javascript:doCloseDashboardInfo()" class="LOG_VIEWER_DASHBOARD_TABLE_FOOTER_TEXT_LINK">Close</a></td>
							<tr>								
						</table>
					</td>
				</tr>
				<tr><td><span style="font-size: 1px">&nbsp;</span></td></tr>
			</table>				
		</td>
	</tr>
</table>
<%=graphMap%>