<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<% 

  String ERROR_OBJ = "ERROR_OBJ";
  String LOG_NAME = "LogName";
  String LOG_DESCRIPTION = "LogDescription";
  String MODULE_ID = "MODULE_ID";
  String LOG_DIRECTORY = "LogDirectoryDir";
  String LOG_NAME_PATTERN = "LogNamePattern";
  String LOG_DATA_PATTERN = "DataPattern";
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_TIME_ZONE = "TimeZone";
  String LOG_CHARSET = "charset";

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
 
  LogBrowsingManager lbm = null;
  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);

  SimpleLogBrowserBuilder builder = (SimpleLogBrowserBuilder)LogBrowserBuilderFactory.getLogBroserBuilderByType(LogBrowserBuilderFactory.DEFAULT_TYPE);

  if(lbm != null){
    builder.setID(lbm.getId());
    builder.setIgnoreUnparsedRecords(LogAdminHelper.isIgnoreUnparsedRecords(lbm));
    builder.setUpdateLinesNumber(LogAdminHelper.isUpdateLinesNumber(lbm));
    logdatapat = LogAdminHelper.getXpologPattern(lbm);
    builder.setDataSourceFactory(LogAdminHelper.dataSourceFactory(lbm));
    builder.setUseIndexing(lbm.isUseIndexing());
    builder.setUseIndexingForDateSearch(lbm.isUseIndexingForDateSearch());
  }
 
  response.sendRedirect(BASE_DIRECTORY + controller.getForwardPage());
%>


