<%@ page language="java" %> 
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="omega.ui.models.*"%>
<%@ page import="omega.ui.html.table.OHtmlTable"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.data.index.IndexStatus"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>
<%@ page import="xpolog.eye.admin.builders.SshSimpleBuilder"%>
<%@ page import="xpolog.eye.data.log.files.SshMediaMultiFilesDataSource"%>
<%@ page import="xpolog.eye.media.telsh.TelnetAccountPolicy"%>
<%@ page import="xpolog.eye.util.DateUtil"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>
<%

  
  String ERROR_OBJ = "ERROR_OBJ";
  String ACTIVE_SNAPSHOT_MODE ="ACTIVE_SNAPSHOT_MODE";
  
  int ALLOWED_LOG_NAME_LENGTH = 30;
  //getting the managment
  SiteManagment mgmt = SiteManagment.getInstance();
  LogViewContext logcontext = (LogViewContext)request.getSession().getAttribute(LogViewContext.LOG_CONTEXT);
  LogViewQueryInfo queryInfo = logcontext == null ? null : logcontext.query;
  LogBrowsingManager man = logcontext == null ? null : logcontext.lbm;
  if (queryInfo == null || man == null){
	%> 
<html><body bgcolor="#FFFFFF"></body></html> <%
	return;
  }
	String activeSnapshotMode = (String)request.getSession().getAttribute(ACTIVE_SNAPSHOT_MODE);
  if(activeSnapshotMode != null && activeSnapshotMode.equalsIgnoreCase("true")){
  	man.setAddOrigDataToResult(true);
	}
  
  
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
    
  String refreshStr = request.getParameter("refresh");
  String printableViewStr = request.getParameter("printableView");
  boolean isPrintableView = (printableViewStr != null && printableViewStr.equals("true"));
  
  String minusImg = "";
  String plusImg = "";
  String html = "";
  boolean isMessage = false;
  String displayMessage = "";
  String title = "";
  String op = "";
  int leapsize = 25;
  DataReferenceBuilder dfBuilder = null;
  boolean isDataSourceClosed = false;
  try {
 	man.getCustomizationManager().setPrintableView(isPrintableView);
  
  leapsize =  queryInfo.leapsize;
  op = queryInfo.op;
  String search = queryInfo.search;
  String mark = queryInfo.mark;
  boolean isRegExp = queryInfo.isRegExp;
  if (search != null){
  	search = search.replaceAll("&quot;","\"");
  }
  
  String updateStr = request.getParameter("update");
  boolean update = updateStr != null && updateStr.equals("true");
  
   //do sorting check
  String sortIndex = request.getParameter("sortIndex");
  if(sortIndex == null || sortIndex.trim().length() == 0){
    sortIndex = "-1";
  }else {
    op = "CURRENT";
  }
   
  SortingManager sortman = man.getSortingManager();
  int index = -1;
  try{
    index = Integer.parseInt(sortIndex.trim());
  }catch(Exception e){   
  }
  if(index == -1){
    sortman.cancelSort();
  }else{
    sortman.doSort(index);
  }
  
  SshMediaMultiFilesDataSource mfds = null;
  if(!isMessage && logcontext.lbm != null && 
	 			logcontext.lbm.isDataSourceClosed() &&
	 			logcontext.lbm.getLinearDataBuilder() != null && 
	 			logcontext.lbm.getLinearDataBuilder().getLinearDataSource() != null &&
	 			logcontext.lbm.getLinearDataBuilder().getLinearDataSource() instanceof SshMediaMultiFilesDataSource) {
		mfds = (SshMediaMultiFilesDataSource)logcontext.lbm.getLinearDataBuilder().getLinearDataSource();
		if(mfds.isClosed() &&
			 mfds.getAccount() != null && 
		 	 mfds.getAccount().getAccountPolicy() != null &&
		 	 mfds.getAccount().getAccountPolicy() instanceof TelnetAccountPolicy) {	
			TelnetAccountPolicy accountPolicy = (TelnetAccountPolicy)mfds.getAccount().getAccountPolicy();
			isMessage = true;
			displayMessage = "The log has been closed as it was idle for more than " + DateUtil.formatTime(accountPolicy.getSessionTimeoutInterval()) + ". Click <a href=\"javascript:reopenLog('" + logcontext.lbm.getId() + "')\">here</a> to reopen the log";
			isDataSourceClosed = true;
		}
	} 
    
	boolean next = false;
  boolean prev = false;
  boolean current  = false;
  boolean zoom = false;
  RecordsMaskTableModel RMModel = null;  
  boolean refresh = refreshStr != null && refreshStr.equals("true");
  LogEyeModel model = isDataSourceClosed ? man.createLogEyeModel(BASE_DIRECTORY) : refresh || queryInfo.isUsed? man.getLogEyeModel() : null;
  if (update){
    op = "CURRENT";
    model = null;
  }

  try{	
	  if (model == null){	  	
	  	
	    if(op.equalsIgnoreCase("NEXT")){
	      next = true;
	      RMModel = man.getNextEntries(leapsize,search,isRegExp);
	    }else if(op.equalsIgnoreCase("PREV")){
	      prev = true;
	      RMModel = man.getPrevEntries(leapsize,search,isRegExp);
	    }else if(op.equalsIgnoreCase("CURRENT")){
	      current = true;
	      RMModel = man.getCurrentEntries(leapsize,search,isRegExp);
	    }else if(op.equalsIgnoreCase("LAST")){
	      current = true;
	      RMModel = man.getLastEntries(leapsize,search,isRegExp);
	    }else if(op.equalsIgnoreCase("START")){
	      current = true;
	      RMModel = man.getFirstEntries(leapsize,search,isRegExp);
	    }else if(op.equalsIgnoreCase("ZOOM_IN")){
  	    zoom = true;
	      RMModel = man.getZoomInEntries(leapsize,queryInfo.zoomInKey,queryInfo.validateFilter);
	      search = null;
	    }else if(op.equalsIgnoreCase("ZOOM_IN_WITH_FILTER")){
  	    zoom = true;
	      RMModel = man.getZoomInEntries(leapsize,queryInfo.zoomInKey,queryInfo.validateFilter,false);
	      search = null;
	    }else if(op.equalsIgnoreCase("TAIL")){
	      RMModel = man.getLastEntries(leapsize);
	      search = null;
	    }else if(op.equalsIgnoreCase("LAST_FILTER_VIEW")){
	      RMModel = man.getLastFilterEntries(leapsize);
	    }else if(op.equalsIgnoreCase("MOVE")){
	      RMModel = man.getMoveEntries(leapsize,queryInfo.moveSteps);
	    }else if(op.equalsIgnoreCase("GOTO")){
	      dfBuilder = (DataReferenceBuilder)request.getSession().getAttribute("lastDataReferenceBuilder");      
	      String key = dfBuilder.getReferenceKey();
	     if (key == null){
	       current = true;
	       RMModel = man.getCurrentEntries(leapsize,search,isRegExp);
	     }else {
	       zoom = true;
	       RMModel = man.getGoToEntries(leapsize,key,queryInfo.validateFilter);	      
	     }
	    }
	    model = man.getLogEyeModel(BASE_DIRECTORY,RMModel);	    
	    queryInfo.isUsed = true;
	  }else {
	  	if(op.equalsIgnoreCase("NEXT")){
	      next = true;
	    }else if(op.equalsIgnoreCase("PREV")){
	      prev = true;
	    }else if(op.equalsIgnoreCase("CURRENT")){
	      current = true;
	    }else if(op.equalsIgnoreCase("LAST")){
	      current = true;
	    }else if(op.equalsIgnoreCase("LAST")){
	      current = true;
	    }else if(op.equalsIgnoreCase("START")){
	      current = true;
	    }else if(op.equalsIgnoreCase("ZOOM_IN")){
  	    zoom = true;
	    }
	  }
  }catch(Exception e){
  	ErrorModel.log.error("logrecords.jsp - Failed to get next records",e);
  	ErrorModel errModel = new ErrorModel();
  	errModel.addError("During data processing the following error occurred:");
  	if(e.getMessage() == null || e.getMessage().equals("")){
  		errModel.addError(e.getClass().toString());
  	}else{
  		errModel.addError(e.getMessage());
  	}
  	errModel.addError("Please verify the remote host is running and available.");
  	request.getSession().setAttribute(ERROR_OBJ,errModel);
  	out.println("<html><head><script>");
  	out.println("parent.document.location='../common/errorpage.jsp'");
  	out.println("</script></head><body></body></html>");
  	out.flush();
  	return;
  }
  
  if (dfBuilder == null){
    dfBuilder = LogEyeHelper.getDataReferenceBuilder(man);
  }
   
  if (dfBuilder != null){
    request.getSession().setAttribute("lastDataReferenceBuilder",dfBuilder);
  }else {
    request.getSession().removeAttribute("lastDataReferenceBuilder");
  }
  


  if (model != null){
    String str = model.getRecordsMaskTableModel().getTitle();
    if (str != null){
      title = str;
    }
  }

  int endIndex = 0;
  int logNameLength = man.getName() == null ? 0 : man.getName().length();
  int titleLength = title.lastIndexOf("(");
  String tempTitle = null;
  if(titleLength>ALLOWED_LOG_NAME_LENGTH && logNameLength>ALLOWED_LOG_NAME_LENGTH) {
  	//both names lengths are larger then 30 we cut title.
  	tempTitle = title.substring(title.lastIndexOf("("),title.length());
  	//check if the char at index ALLOWED_LOG_NAME_LENGTH are before the (%) or after it
  	if(ALLOWED_LOG_NAME_LENGTH < titleLength) {
  		title = title.substring(0,ALLOWED_LOG_NAME_LENGTH)+"..."+tempTitle;
  	}else {
  		endIndex = titleLength-1;
  		title = title.substring(0,endIndex)+"..."+tempTitle;
  	}
  }else if(titleLength>ALLOWED_LOG_NAME_LENGTH && !(logNameLength>ALLOWED_LOG_NAME_LENGTH)) {
  	//only title name is more then 30 chars, we allow 60 chars.
  	tempTitle = title.substring(title.lastIndexOf("("),title.length());
  	if(titleLength>(2*ALLOWED_LOG_NAME_LENGTH)) {
	  	//check if the char at index ALLOWED_LOG_NAME_LENGTH are before the (%) or after it
	  	if(2*ALLOWED_LOG_NAME_LENGTH < titleLength) {
	  		title = title.substring(0,2*ALLOWED_LOG_NAME_LENGTH)+"..."+tempTitle;
	  	}else {
	  		endIndex = titleLength-1;
	  		title = title.substring(0,endIndex)+"..."+tempTitle;
	  	}
  	}
  }
  if (title != null){
  	title = XpologUtil.replaceAll(title,"\\","/");
  }
    
   /**
   * manage messages
   */
   String SearchMessage = "";
   String searchDefinition = man.getSearchAndFilterDef();
   if(searchDefinition != null && searchDefinition.length() > 0) {
   		if(searchDefinition.equals("START")) {
    		SearchMessage = "from the beginning of the file";
   		}else {
   			SearchMessage = "on current view only";
   		}
   }
   

   if(model.getRowCount() == 0 && !isDataSourceClosed){
  	 if(model.getRecordsMaskTableModel() != null && model.getRecordsMaskTableModel().getDsStatus() != null && model.getRecordsMaskTableModel().getDsStatus().isFailed()) {
  		 isMessage = true;
       displayMessage = model.getRecordsMaskTableModel().getDsStatus().getStatusMessage();
  	 }else if(RMModel != null && RMModel.getDsStatus() != null && RMModel.getDsStatus().isFailed()) {
  	 		isMessage = true;
       	displayMessage = RMModel.getDsStatus().getStatusMessage();
  	 }else {
	    if(next){
	      isMessage = true;
	      displayMessage = "End of log";
	    }else if(prev){
	      isMessage = true;
	      displayMessage = "Beginning of log";
	    }else if(current){
	      isMessage = true;
	      displayMessage = "No records to display " + SearchMessage;      	
	    }else if(zoom){
	      isMessage = true;
	      displayMessage = "No records to display. Zoom in data does not exist";
	    }
  	 }
   }

   SearchManager searchManager = new SearchManager(mark);
   if (mark == null || mark.trim().length() == 0 && search != null){
     searchManager = new SearchManager(search,isRegExp);
   }

  //html creation
  OHtmlTable tab = null;
  if (logcontext.viewType == LogViewContext.EVENTS_VIEW_TYPE){
  	tab = new EventsViewRenderer(model,searchManager);  
    tab.setID("logviewTable");
  }else {
    tab = new OHtmlTable(model);  
    tab.setID("logviewTable");
    LogEyeCellRenderer cr = man.getCellRenderer(model,searchManager);
    LogEyeRowRenderer rr = man.getRowRenderer(model);
    tab.setRowRenderer(rr);
    tab.setCellRenderer(cr);
  }
  tab.render();
  html = tab.getHtml();
  
  
  
  Properties prop = Configuration.getInstance().getUIData(); 
  minusImg = BASE_DIRECTORY + prop.getProperty("logview.minus.image");
  plusImg = BASE_DIRECTORY + prop.getProperty("logview.plus.image");
 	man.getCustomizationManager().setPrintableView(false);
 	
  }catch (Exception e){
  	ErrorModel.log.error("logrecords.jsp - Failed to view",e);
  	isMessage = true;
    displayMessage = "Failed to get records.";
  }
  boolean isNeedsToUpdateData = op.equals("TAIL");
  
  if (isNeedsToUpdateData && logcontext.query != null){
  	logcontext.query.op = "LAST";
  }
  
  LogContextMenu contextMenu = new LogContextMenu(env,man);
  
  String charset = man == null ? null : man.getCharset();
  if(charset == null) {
		charset = Configuration.getInstance().getPropertiesManager().getProperty("logview.defaultCharecterEncoding", null);
		if(charset != null && charset.length() == 0) {
			charset = null;
		}
	}
  if (charset != null){
    response.setContentType("text/html;charset=" + charset);   
  }
  
%>

<jsp:include page="markSessionActivity.jsp" flush="true" />
 

<html > 
<head>
<%
if (charset != null) {%>
<meta http-equiv="Content-Type" content="text/html; charset=<%=charset%>">
<%}else {%>
<meta http-equiv="Content-Language" content="en-us">
<%}%>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" charset="iso-8859-1" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" charset="iso-8859-1" type="text/css" href="<%=BASE_DIRECTORY%>css/logview.css" />
<link rel="stylesheet" charset="iso-8859-1" type="text/css" href="<%=BASE_DIRECTORY%>css/jsdomenu.css" />
<jsp:include page="../scripts/comps/jsdomenu.jsp" flush="true">
	<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" charset="iso-8859-1" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" charset="iso-8859-1"  type="text/javascript"></script>

<script>
 var posX = 100;
    var posY = 100;
	function hideOrShow(divid){
		if(layerSetup(divid).style.display == 'none'){
		 posX=posX++;
		 posY=posY++;
		 showDiv(divid,posX,posY);
		}else{
		 hideDiv(divid);
		}

	}
	function layerSetup(id) {
		theObj = document.getElementById(id);
		return theObj;
	}
	function getHeight(id) {
		theHeight = layerSetup(id).offsetHeight;
		return theHeight;
	}
	function showDiv(id,posX,posY) {
		layerSetup(id).style.display = 'block';
		layerSetup(id).style.left = parseInt(posX);
		layerSetup(id).style.top = parseInt(posY);
		layerSetup("im" + id).src = "<%=minusImg%>";
	}
	function hideDiv(id) {
		layerSetup(id).style.display = 'none';
		layerSetup("im" + id).src = "<%=plusImg%>";
	}
	
	  var oldtr;
	  var oldTrCls;
	  var pressedKeyValue = "";
	  var rowsArrayIndex = 0;
	  var leapsize = '<%=leapsize%>';

	//Ctrl + A
	function selectAllRows(){
		//reset arrays
		parent.selectedRowsArray = new Array();
	  parent.oldRowsClsArray = new Array();
		rowsArrayIndex = 0;
		for(var i = 0 ; i < leapsize ; i++){
			var row = document.getElementById("row" + i);
			if(row){
				parent.selectedRowsArray[rowsArrayIndex] = i;
				parent.oldRowsClsArray[rowsArrayIndex] = i + "#" + row.className; 
				rowsArrayIndex++;
				changeRowClass(row,"SELECTED_ROW");
			}		
		}	
	}

	function setRowInFocus(tr,event,clickedRowIndx){
	parent.hideVisibleMenus();	
	if(event.shiftKey == 1){
		pressedKeyValue = "shiftKey";
		updateRowsArrByShiftKey(tr,clickedRowIndx);
	}else	if(event.ctrlKey == 1){
		pressedKeyValue = "ctrlKey";
		//updateRowsArrByCntrlKey(tr,clickedRowIndx);
		if(isRowSelected(tr,clickedRowIndx)){
			return;
		}
		parent.selectedRowsArray[rowsArrayIndex] = clickedRowIndx;		
	}else{
		pressedKeyValue = "";
		parent.selectedRowsArray = new Array();
		rowsArrayIndex = 0;
	}
		oldtr = tr;
		oldTrCls = tr.className;
	
	  if (parent && parent.doCloseDashboardInfo){
      parent.doCloseDashboardInfo();
    }
    if(!pressedKeyValue || pressedKeyValue.length == 0 ){
			reset();       
		}
				
		changeRowClass(tr,"SELECTED_ROW");
		parent.oldRowsClsArray[rowsArrayIndex] = clickedRowIndx + "#" + oldTrCls;			
		rowsArrayIndex++;
    
    if(!pressedKeyValue || pressedKeyValue.length == 0 ){
			parent.selectedRowsArray[0] =  clickedRowIndx;
		}

	}
	//Sets selected row cls.
	function changeRowClass(tr,cls){
			if(!tr){
				return;
			}
			oldtr = tr;
			oldTrCls = tr.className;
			tr.className = cls;
			var list = tr.getElementsByTagName("TR");
			for(var i = 0; i < list.length;i++){
			  list[i].className = cls;
			}	
	}

	//Reset rows class
	function reset(){
	  if (parent && parent.doCloseDashboardInfo){
      parent.doCloseDashboardInfo();
    }
    
    pressedKeyValue = "";
		parent.selectedRowsArray = new Array();
		rowsArrayIndex = 0;

		if(!oldtr && !parent.oldRowsClsArray){
			return;
		}
		if(!parent.oldRowsClsArray || parent.oldRowsClsArray.length == 0){
			changeRowClass(oldtr,oldTrCls);
		}else{
			for(var i=0;i<parent.oldRowsClsArray.length;i++){
				if(parent.oldRowsClsArray[i]){
					var value = parent.oldRowsClsArray[i].split("#");
					var trObj = document.getElementById("row"+value[0]);
					var cls = !value[1] || value[1] == "SELECTED_ROW" ? "ODD_ROW" : value[1];
					changeRowClass(trObj,cls);
				}else{
					changeRowClass(oldtr,"ODD_ROW");
				}				
			}		
		}		
		parent.oldRowsClsArray = new Array();
	}
	
	
	function isRowSelected(tr,clickedRowIndx){
		var isSelected = false;
		for(var i = 0 ;!isSelected && i < parent.selectedRowsArray.length; i++){
			isSelected = parent.selectedRowsArray[i] == clickedRowIndx;
			if(isSelected){
				var value =  parent.oldRowsClsArray && parent.oldRowsClsArray.length > i && parent.oldRowsClsArray[i] ? parent.oldRowsClsArray[i].split("#") : "";
				var oldTrCls = value && value.length > 1 ? value[1] : "ODD_ROW";
				parent.selectedRowsArray[i] = "-1";
				parent.oldRowsClsArray[i] = "-1";
				changeRowClass(tr,oldTrCls);
			}
		}
		return isSelected;
	}
	
	
	function updateRowsArrByCntrlKey(tr,clickedRowIndx){
		if(isRowSelected(tr,clickedRowIndx)){
			return;
		}
		parent.selectedRowsArray[rowsArrayIndex] = clickedRowIndx;
		rowsArrayIndex++;
	}
	
	function updateRowsArrByShiftKey(tr,clickedRowIndx){	
		//Get start and end index.
		var lastRowIndexData = parent.oldRowsClsArray && parent.oldRowsClsArray[rowsArrayIndex - 1] ? parent.oldRowsClsArray[rowsArrayIndex - 1] : "";
		var values = lastRowIndexData.split("#");
		var lastRowIndex = values && values.length > 1 ? values[0] : "0";
		var startIndx = lastRowIndex < clickedRowIndx ? lastRowIndex : clickedRowIndx;
		var endIndx = lastRowIndex > clickedRowIndx ? lastRowIndex : clickedRowIndx;
		//reset arrays
		parent.selectedRowsArray = new Array();
	  parent.oldRowsClsArray = new Array();
		rowsArrayIndex = 0;
		for(var i = startIndx ; i <= endIndx ; i++){
			var row = document.getElementById("row" + i);
			if(row){
				parent.selectedRowsArray[rowsArrayIndex] = i;
				parent.oldRowsClsArray[rowsArrayIndex] = i + "#" + row.className; 
				rowsArrayIndex++;
				changeRowClass(row,"SELECTED_ROW");
			}		
		}
	}
	

function doSort(index){
  document.access.sortIndex.value = "" + index;
  document.access.submit();
}

function doCancelSort(){
  document.access.sortIndex.value = "-1";
  document.access.submit();
}

function zoomIn(key){
	var r = document.getElementById(key);
   if (parent){
   	parent.logRef = r.value;
    parent.zoomIn();
  }
}

function zoomInToNewLog(key,lid){
	var r = document.getElementById(key);
   if (parent){
   	parent.logRef = r.value;
    parent.zoomInToNewLog(lid);
  }
}

function createNewDataRefBuilder(){
  return parent.createNewDataRefBuilder();
}

function initPrintView(){
	window.print();
}

<%if (!isPrintableView){
	//buildGoToStrcuture(dfBuilder,out,0,0);
	
  String addFilter = request.getParameter("addFilter");
  if ((addFilter != null && addFilter.equals("true")) || (addFilter == null && logcontext.addfilter)){
  	String filterId = man.getFilterManager().getActiveFilterId();
   FilterCollection col = filterId != null && filterId.length() > 0 ? man.getFilterManager().getFilterCollectionById(filterId) : null;
   if (col != null){
  	 String name = col.getName();
  	 name = name.replaceAll("'","");
  	 String fe = col.getAllFilterTerms();
  	 String fi = col.getId();
  	 fi += "*"+ (fe  != null && fe.length() > 0 ? "1" : "");
  	 if(name != null && name.length()>25) {
  		 name = name.substring(0,25) + "...";
     }
  %>
    
  	if (parent && parent.addFilter){
  	  parent.addFilter('<%=fi%>','<%=name%>');
  	}
  <%}else {%>
  	if (parent && parent.clearFilter){
      parent.clearFilter();
    }
    <%}
   
  }
  
  boolean showBack = false;
	if (!logcontext.disableZoomOut && (op.equals("ZOOM_IN") || (!op.equals("LAST_FILTER_VIEW") && man.isHavingLastFilterView()) || logcontext.zoomOutUrl != null)) {
		showBack = true;
	}
	%>
	  if (parent && parent.showBack){
  	  parent.showBack(<%=showBack%>);
  	}
  <%
  if (op != null && op.equalsIgnoreCase("ZOOM_IN")){
%>
  if (parent && parent.clearFilter){
    parent.clearFilter();
  }
<%}%>

  <%
  
  if (!isPrintableView && logcontext.indexStatus == null || logcontext.indexStatus.getSizeToIndex() == IndexStatus.INDEX_OK || logcontext.indexStatus.getSizeToIndex() == IndexStatus.NO_STATUS){%>
  if (parent && parent.ignoreIndex){
      parent.ignoreIndex = true;
  }
  <%}%>
<%
}
%>

<%!
  private static void buildGoToStrcuture(DataReferenceBuilder builder,JspWriter out,int index,int y) throws java.io.IOException{

    String tmpDataSource = "tmpDataSource_" + index + "_" + y;
    if (index == 0){
      tmpDataSource = "parent.rootDataSource";
    }else {
      out.println("var " + tmpDataSource + "= createNewDataRefBuilder();");
    }
    if (builder == null) return;
    for (int i = 0; i < builder.getReferencesCount(); i++) {
      out.println(tmpDataSource + ".keys[" + i + "]=\"" + builder.getReferenceKeyAt(i) + "\";");
      buildGoToStrcuture(builder.getDataReferenceBuilderAt(i),out,index + 1,i);
      out.println(tmpDataSource + ".builders[" + i + "]=tmpDataSource_" + (index+1)+ "_" + i + ";");
    }
    out.println(tmpDataSource + ".title=\"" + builder.getTitle() + "\";");
    out.println(tmpDataSource + ".selectedIndex=" + builder.getSelectedIndex() + ";");

  }
%>

function createTextMenu() {
 		<%if(!isPrintableView){ %>
		<%=contextMenu.getPopupsScript()%> 
		<%}%>
}

var selectedRow;
var selectedSrc;
var selectedTD;
var selectedColIndex;
var selectedRowIndex;
var x,y;

function showTextMenuData(){
  if (parent && parent.doCloseDashboardInfo){
    parent.doCloseDashboardInfo();
  }  
  if (parent && parent.updateRightClickMenu){
		var menu = parent.updateRightClickMenu(); 
		parent.hideVisibleMenus();
		//TODO : check menu.isShow().
  	menu.moveTo(x,y + 50);
	  menu.show();
//	  setTimeout("logDataCM.show()",20);
	  
	  return true;
	}
  return false;
}

function updateSelections(td,rowIndex,colIndex,e){
	  var row = document.getElementById("row" + rowIndex);
	  selectedRow = row;
	  selectedTD = td;
	  selectedColIndex = colIndex;
	  selectedRowIndex = rowIndex;
	  selectedSrc = this.event ? e.srcElement : e.target;
	  var e = this.event || e;
	  x = (this.event ? e.x : (document.body.scrollLeft) ? e.pageX - document.body.scrollLeft : e.pageX);
	  y = (this.event ? e.y : (document.body.scrollTop) ? e.pageY - document.body.scrollTop : e.pageY);
	  var menu = parent.updateRightClickMenu();
	  if (document.body.clientHeight - y < menu.menuObj.offsetHeight){
	  	y = document.body.clientHeight - menu.menuObj.offsetHeight;
	  }
	  updateCurrentLogAttributes(colIndex);
}

function updateCurrentLogAttributes(columnIndex){
	var page = "../common/getCurrentLogAttributes.jsp?columnIndex=" + columnIndex;
	sendAjaxRequest(page,function(req) {
		var xmldoc = req.responseXML.documentElement;
		if(xmldoc) {
			var responseElement = xmldoc.getElementsByTagName("Response")[0];
			if(responseElement) {
				var columnType = responseElement.getAttribute("columnType");
				if(!columnType) {
					columnType = "";
				}
				parent.selectedColType = columnType;
				
				var isFilterActiveResponse = responseElement.getAttribute("isFilterActive");
				if(!isFilterActiveResponse) {
					isFilterActiveResponse = "false";
				}
				parent.isFilterActive = isFilterActiveResponse;
				
				showTextMenuData();
			}
		}
  },'POST');
}


function searchText(url,target){
  if (!selectedSrc) return;
  
  var elem = selectedSrc;
 
  if (!elem.innerHTML){
    elem = elem.parentElement;
  }  
  document.searchForm.searchText.value = elem.innerHTML;
   if (selectionText && selectionText != ""){
    document.searchForm.searchText.value = selectionText;
  }
  document.searchForm.forwardURL.value = url;
  if (target){
    document.searchForm.target=target;
  }else {
    document.searchForm.target="";
  }
  if (selectedColIndex){
    document.searchForm.colIndex.value = "" + selectedColIndex;
  }else {
    document.searchForm.colIndex.value = "";
  }  
  document.searchForm.submit();
}

function gotoUrl(url,target){
  if (url && url.indexOf("http") != 0 && url.indexOf("/") != 0){
    url = "<%=BASE_DIRECTORY%>" + url;
  }
  document.goTo.action = url;
  if (target){    
    document.goTo.target=target;
  }else {
    document.goTo.target="";
  }
  document.goTo.submit();
}

function searchCustom(url){
 if (!selectedSrc) return;
  
  var elem = selectedSrc;
  if (elem.tagName == "NOBR"){
    elem = elem.parentNode;
  }
 
  if (!elem.innerHTML){
    elem = elem.parentElement;
  }  
  var val = elem.innerHTML;
  if (selectionText && selectionText != ""){
    val = selectionText;
  }
  var colIndex = "";
  if (selectedColIndex){
   colIndex = "" + selectedColIndex;
  } 
  
 
  
	var params = "searchText=" + encode(val) + "&columnIndex=" + colIndex;
	var page = url;
	sendAjaxRequest(page,function(req){
		 var xmldoc = req.responseXML.documentElement;    
		   var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
      if (result == "true"){
			  var u =  xmldoc.getElementsByTagName('url');
			  if (u && u[0]){
			    u = u[0].firstChild.nodeValue;
			    if (parent){
			      parent.openWindow(u,'_blank');
			    }
			  }else {			     
			    if (parent){
			      parent.showMessageFromXML(xmldoc);
			    }		  	    
			  } 
			}	else {
			 if (parent){
			    parent.showMessageFromXML(xmldoc);
			 }                
      }
	},'POST',params); 
}

function init(){
  if (<%=isNeedsToUpdateData%>){
    if (parent && parent.refreshData){
      parent.needsToUpdateData = true;
      parent.refreshData();
    }
  }
}

function getSearchTerm(){
  if (!selectedSrc) return;
  var elem = selectedSrc;
 
  if (!elem.innerHTML){
    elem = elem.parentElement;
  }
  
  var searchTerm = elem.innerHTML;  
  if (searchTerm){
    searchTerm = searchTerm.replace(/<\/nobr>/g,"");
    searchTerm = searchTerm.replace(/<nobr>/g,"");
    searchTerm = searchTerm.replace(/<b>/g,"");
    searchTerm = searchTerm.replace(/<\/b>/g,"");
    searchTerm = searchTerm.replace(/<u>/g,"");
    searchTerm = searchTerm.replace(/<\/u>/g,"");    
  }  
  if (selectionText && selectionText != ""){
    searchTerm = selectionText;
  }
  return searchTerm;
  
}

function find(){
  if (!selectedSrc) return;
  
  
  var searchTerm = getSearchTerm();
  if (parent && parent.document.access.searchText){
    parent.document.access.searchText.value = searchTerm;
    parent.doSearch(false);
  }
}
function filterIn(isDateCol){
  var searchTerm = getSearchTerm();
  if (parent && parent.document.access.searchText){
    parent.document.access.searchText.value = searchTerm;
  }
  if (parent && parent.document.access.isDateColumn){
    parent.document.access.isDateColumn.value = isDateCol;
  }
  if (isDateCol && parent && parent.document.access.selectedRowIndex){
    parent.document.access.selectedRowIndex.value = selectedRowIndex;
  }
  
	parent.showModuleTree();
}

function filter(prefix){
  if (!selectedSrc) return;

  var searchTerm = getSearchTerm();
  if (parent && parent.document.access.searchText){
	  if(prefix) {
		  searchTerm = prefix + " " + searchTerm;
	  }
    parent.document.access.searchText.value = searchTerm;
    parent.doSearch(true);
  }
}

function print0(){
  pw = window.open("<%=BASE_DIRECTORY%>loggers/logrecords.jsp?printableView=true","printWindow","width=720,height=600,location=no,scrollbars=yes,menubar=yes");
	pw.focus();
}

var selectionText = "";
function tableClickHandler(e) { // Private method  
  selectionText = getUserSelection();
  if (!e) {
    var e = window.event;
  }

  var td = this.event ? e.srcElement : e.target;
  if (td && !td.id ){
    td = td.parentNode;
    if (td && !td.id ){
    	td = td.parentNode;
    }
  }
  if (td && td.id){
    var params = td.id.split("_");
    if (params.length == 3 && (params[0] == "d" || params[0] == "bd")){
      if (params[2] >= 0){
        //alert(params[1] + " , " + params[2] + "," + (params[2] >= 0));
//        showTextMenuData(td,params[1],params[2],e);
        updateSelections(td,params[1],params[2],e);
      }
    }
  }
}

<%
if(isDataSourceClosed) {
%>
function reopenLog(logId) {
	document.getElementById("reopenLogId").value = logId;
	document.reopenLog.submit();
}
<%
}
%>


//SNAPSHOT
var CTRL = "false";   
function onRecordsKeyDown(e){
	//Find Which key is pressed
			if (e.keyCode) code = e.keyCode;
			else if (e.which) code = e.which;
			
			if(code == 17){
				CTRL = "true";
			}
			if(CTRL == "true" && code == 65){ 
				selectAllRows();
				return false;
		  } 
}

function onRecordsKeyUp(e){
	var CTRL = "false";   
}
</script>
</head>
<body onLoad="javascript:<%=isPrintableView?"initPrintView();":""%>init();" oncontextmenu="tableClickHandler(event);return false;"  onKeyDown="javascript:onRecordsKeyDown(event)"  onKeyUp="javascript:onRecordsKeyUp(event)">

<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="95%">
	<tr>
	<td width="0">
	<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" action="logrecords.jsp">
<input type="hidden" name="sortIndex" value="-1">
<input type="hidden" name="update" value="true">
</form>
<form AUTOCOMPLETE="OFF" id="searchForm" name="searchForm" method="post" action="logDataContextAction.jsp" target="_new">
<input type="hidden" name="searchText" value="">
<input type="hidden" name="forwardURL" value="">
<input type="hidden" name="colIndex" value="">
</form>
<form AUTOCOMPLETE="OFF" id="goTo" name="goTo" method="post" action="" target="">
</form>
<%
if(isDataSourceClosed) {
%>
<form AUTOCOMPLETE="OFF" id="reopenLog" name="reopenLog" method="post" action="reopenLog.jsp" target="main">
	<input type="hidden" name="reopenLogId" id="reopenLogId" value="">
</form>
<%
}
%>
</td>
	<td valign="top" <%=isMessage?"height=\"20\"" : ""%>>
	  
		<%=html%>
	
	</td></tr>

    <%if(isMessage){%>
    <tr><td colspan="2" valign="top" height="*">
    	<span class="HEADER">- <%=displayMessage%> -</span>
	</td></tr>
    <%}%>
</table>

<%if(!isPrintableView){ %>
<script>
var title = "<%=title%>"
createTextMenu();
</script>
<%} %>
</body>
</html>