<%@ page language="java"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.index.*"%>
<%@ page import="xpolog.eye.data.index.adapters.defaultadapter.DefaultIndexingHelper"%>
<%@ page import="xpolog.eye.data.index.adapters.IndexAdapter"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.data.log.external.*"%>
<%@ page import="xpolog.eye.data.log.files.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.data.xml.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.audit.*"%>
<%@ page import="xpolog.eye.site.main.*"%>

<%@ page autoFlush="false"%>
<%!static String EMPTY_STR = "";

	int ALLOWED_LOG_NAME_LENGTH = 30;

	static final String BASE_DIRECTORY = "../";%>
<%
LogViewContext logcontext = (LogViewContext)request.getSession().getAttribute(LogViewContext.LOG_CONTEXT);
//getting the managment
SiteManagment mgmt = SiteManagment.getInstance();
UserEnvironment env = UserEnvironment.getUserEnvironment(request);
WebSecurityManager securityManager = WebSecurityManager.getInstance();
UserSecurity user = securityManager.getUserSecurity(request);
UserContext userContext = UserEnvironment.getUserContext(request);

	

	String queryStr = request.getQueryString();
	String CURRENT_LOG = "CURRENT_LOG";
	String ERROR_OBJ = "ERROR_OBJ";
	
	LogBrowsingManager currman = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
	LogBrowsingManager man = logcontext != null ? logcontext.lbm : null;
	if (currman != null){
		if (man != null && man != currman){
			man = currman;
			logcontext = null;
		}else if (man == null){
			man = currman;
			logcontext = null;
		}
	}
	
  
	String calstr = request.getParameter("calls");
	if (calstr == null || calstr.length() == 0) {
		calstr = "0";
	}
	int cal = 0;
	boolean justRefreshNoMove = false;
	if (logcontext != null) {		
		logcontext.justRefresh = false;
		if (calstr != null){
		  cal = Integer.parseInt(calstr);
		  if (logcontext.calls == cal && cal != -1) {
	  cal++;
	  logcontext.justRefresh = true;
		  }else {
	  logcontext.calls = cal;
	  cal++;
		  }
	  }
	}

	//id handling

	String id = request.getParameter("logid");
	if (id == null) {
		id = man == null ? null : man.getId();
	}else {
		if (id.length() > 0 && man != null && man.isTemporary()) {
	man = null;
		}
	}
	
	//manager handling

	String firstTimeStr = request.getParameter("firstTime");
	boolean firstTime = firstTimeStr != null && firstTimeStr.equals("true");

	
	String updateIntervalDS = request.getParameter("updateIDS");
	if (updateIntervalDS == null)
		updateIntervalDS = "false";
	
	LogBrowsingManager oldLbm = null;
	if ((man == null) || !man.isTemporary() && (man.getId() == null || !(man.getId().equals(id)) || updateIntervalDS.equals("true"))) {
		logcontext = null;
		oldLbm = man;
		try {
	man = mgmt.getLogBrowserManager(id);
	if (man == null) {
		ErrorModel ermod = new ErrorModel();
		if(id != null && id.length() > 0) {
			File f = SiteManagment.getInstance().getLogBrowserConfigFile(id);
			if(f != null) {
				f = f.getAbsoluteFile();
				if(!f.exists() || f.length() == 0) {
					ermod.addError("Failed to open log due to a configuration problem.");
					ermod.addError("Please contact XpoLog support to resolve this issue.");
				}
			}else if(!SiteManagment.getInstance().getXpologManagment().isValidToBeActive()) {
				ermod.addError("Failed to open log.");
				ermod.addError("Please contact XpoLog support to resolve this issue.");
			}
		}
		if(ermod.getErrorCount() == 0) {
			ermod.addError("Failed to open the log. This might happen because the browser session was terminated.");
			ermod.addError("Please refresh your browser and try to open the log once again.");
			ermod.addError("If the problem persists, please contact XpoLog support to resolve this issue.");
		}
		request.getSession().setAttribute(ERROR_OBJ, ermod);
		response.sendRedirect("admin/errorpage.jsp");
		return;
	}
	//audit
	
		}catch (Exception e) {
	ErrorModel ermod = new ErrorModel();
	ermod.addError("Error Loading Log Browser - " + e.getMessage());
	ermod.addError("If you can not connect to remote host please check if its up and available");
	ermod.addError("It is also possible that your session expired");
	ermod.addError("or it is probable that the log was deleted by another user.");
	request.getSession().setAttribute(ERROR_OBJ, ermod);
	response.sendRedirect("admin/errorpage.jsp");
	return;
		}
		
		
	}else if (logcontext != null && logcontext.lbm != man){
		//oldLbm = logcontext.lbm;
		logcontext = null;
	}
	
	
	if (oldLbm != null){
		MainViewModel model = env.getMainViewModel();	
		LogViewTab tab = (LogViewTab)model.getOnlineTabByDataId(oldLbm.getId());
		if (tab != null && tab.getContext() != null && tab.getContext().lbm == oldLbm){
			oldLbm = null;
		}
		final LogBrowsingManager oldMan = oldLbm;
		final LogBrowsingManager oldManZoomOutLbm = (oldLbm != null && man != null) ? (LogBrowsingManager)man.getZoomOutLbm() : null;
		final boolean zoomOutLbmIdEqualsId = oldManZoomOutLbm != null && oldManZoomOutLbm.getId().equals(id);
		
		
		if (oldMan != null) {		
	new Thread() {
		    public void run() {
	    oldMan.dispose();
	    if (oldManZoomOutLbm != null && !zoomOutLbmIdEqualsId) {
		    oldManZoomOutLbm.dispose();
	    }
	    Runtime.getRuntime().gc();
		    }
	}.start();
		}
	}
	
	if (logcontext == null){
		firstTime = true;	
		logcontext = new LogViewContext();
		logcontext.isFirst = true;
		AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL, userContext, AuditConstants.VIEW, "log view", AuditConstants.LOGS, "view the log " + (man == null ? "N/A" : man.getName()));
	}else {
		if (logcontext.isFirst){
			firstTime = true;		
			logcontext.isFirst = false;
		}
	}
	
	boolean showMaskedData = securityManager.isHavePermission(userContext,ActionsPermissionConstants.LogViewingPermissions.SHOW_MASKED_DATA_PERMISSION);
	//logcontext.showMaskedData = showMaskedData;
	man.setMaskData(!showMaskedData);
	logcontext.lbm = man;
	logcontext.logId = man.getId();
	logcontext.cal = cal;
	logcontext.queryStr = queryStr;
	if(man != null && man.isSnapshot()){
		logcontext.snapshotID = (String)request.getSession().getAttribute("ACTIVE_SNAPSHOT_ID");
	}
	request.getSession().setAttribute(CURRENT_LOG, man);
	request.getSession().setAttribute(LogViewContext.LOG_CONTEXT, logcontext);
	request.getSession().removeAttribute("callsPage");
	request.getSession().removeAttribute("lastModel");
	
	
//update menu tree
	String refreshMenuStr = request.getParameter("refreshMenu");
	boolean refreshMenu = false;
	if (refreshMenuStr == null || refreshMenuStr.length() == 0) {
		String ref = request.getHeader("referer");
		if (ref == null || ref.indexOf("root.jsp") < 0) {
	if (ref != null&& (ref.indexOf("logview.jsp")) >= 0|| (ref != null && ref.indexOf("tailrecords.jsp") >= 0)) {
		refreshMenu = false;
	}else {
		refreshMenu = true;
	}
		}
	}else {
		refreshMenu = refreshMenuStr.equals("true");
	}
	logcontext.refreshMenu = refreshMenu;

	//check permission
	if (!userContext.isModuleMemberVisible(man.getId())) {
		response.sendRedirect(BASE_DIRECTORY + "security/common/accessDenied.jsp");
		return;
	}
	
//insert last module to session
	Module mod = null;
	String CURRENT_MODULE = "CURRENT_MODULE";
	Module curmod = (Module)request.getSession().getAttribute(CURRENT_MODULE);

	if (curmod != null) {
		if (curmod.isChild(man.getId())) {
	//dont do nothing
		}else {
	mod = mgmt.getParentModule(id);
	request.getSession().setAttribute(CURRENT_MODULE, mod);
	curmod = mod;
		}
	}else {
		mod = mgmt.getParentModule(id);
		request.getSession().setAttribute(CURRENT_MODULE, mod);
		curmod = mod;
	}

	//OLAP  
	String olapStr = request.getParameter("olap");
	logcontext.isOlap = man.isOlapView() || (olapStr != null && olapStr.equals("true"));

	LogViewQueryInfo queryInfo = null;
	String useQueryInSession = request.getParameter("useQueryInSession");
	if (logcontext.useQueryInSession || useQueryInSession != null && useQueryInSession.equals("true")) {
		queryInfo = logcontext.query;
	}

	String zoomOutUrl = request.getParameter("zoomOutUrl");
	if (zoomOutUrl != null && zoomOutUrl.length() == 0) {
		zoomOutUrl = null;
	}
	if (zoomOutUrl == null && logcontext.useQueryInSession){
		zoomOutUrl = logcontext.zoomOutUrl;
	}
  logcontext.zoomOutUrl = zoomOutUrl;
  
	String zoomOutFromMainViewPageStr = request.getParameter("zoomOutFromMainViewPage");
	if (zoomOutFromMainViewPageStr != null && zoomOutFromMainViewPageStr.length() == 0) {
		zoomOutFromMainViewPageStr = null;
	}
	boolean zoomOutFromMainViewPage = zoomOutFromMainViewPageStr != null && zoomOutFromMainViewPageStr.equals("true");
	if (zoomOutFromMainViewPageStr == null && logcontext.useQueryInSession){
		zoomOutFromMainViewPage = logcontext.zoomOutFromMainViewPage;
	}
  logcontext.zoomOutFromMainViewPage = zoomOutFromMainViewPage;
  
  
  
	logcontext.useQueryInSession = false;
	man.clearLastQuery();

	//header name
	String name = man.getName();
	//leap size
	int leapsize = queryInfo != null ? queryInfo.leapsize : man.getDefaultLeap();

	try {
		String str = request.getParameter("leapsize");
		if (str != null && str.length() > 0) {
			leapsize = Integer.parseInt(str);
			man.setDefaultLeap(leapsize);
		}
	}catch (Exception e) {
		//e.printStackTrace();
	}

	//operation check
	String op = queryInfo != null ? queryInfo.op : request.getParameter("opdirect");
	if (op == null) {
		if (firstTime) {
	op = man.getCustomizationManager().getStartOperation();
		}
		if (op == null) {
	op = "CURRENT";
		}
	}

	if (justRefreshNoMove) {
		op = "CURRENT";
	}

	
	String search = queryInfo != null ? queryInfo.search : request.getParameter("search");
	if (search == null || search.trim().length() == 0) {
		search = null;
	}

	String enc = request.getParameter("enc");
	if(enc == null) {
		enc = Configuration.getInstance().getPropertiesManager().getProperty("logview.defaultCharecterEncoding", null);
	}
	if (enc != null && enc.trim().length() == 0) {
		enc = null;
	}
	if (search != null && enc != null) {
		search = new String(search.getBytes("8859_1"), enc);
	}

	String searchRegExp = request.getParameter("searchRegExp");
	String quickFilterTerm = request.getParameter("quickFilterTerm");
	if (quickFilterTerm != null){
		quickFilterTerm = quickFilterTerm.trim();
		if (enc != null) {
			quickFilterTerm = new String(quickFilterTerm.getBytes("8859_1"), enc);
		}		
	}
	boolean isQuickFilter = quickFilterTerm != null && quickFilterTerm.length() > 0;
	String quickFilterIndex = request.getParameter("quickFilterIndex");
	String filterWholeWords = request.getParameter("filterWholeWords");

	boolean isRegExp = queryInfo != null ? queryInfo.isRegExp : (searchRegExp != null && search != null && searchRegExp.equals("true"));
	boolean isWholeWords = (filterWholeWords == null && man.isUseWholeWords()) || (filterWholeWords != null && filterWholeWords.equals("true"));
	if (isQuickFilter) {
		isRegExp = searchRegExp != null && searchRegExp.equals("true");
		search = null;
	}
	logcontext.regExpOk = !isRegExp || FilterFieldHelper.checkPattern((quickFilterTerm != null && quickFilterTerm.length() > 0 ? quickFilterTerm : search), true);

	String zoomInKey = queryInfo != null ? queryInfo.zoomInKey : request.getParameter("zoomInKey");
	if (zoomInKey == null || zoomInKey.trim().length() == 0) {
		zoomInKey = null;
	}

	if (!logcontext.regExpOk) {
		search = null;
	}

	
	String moveStepsStr = request.getParameter("moveSteps");
	int moveSteps = queryInfo != null ? queryInfo.moveSteps : 0;
	if (moveStepsStr != null && moveStepsStr.trim().length() > 0) {
		try {
	moveSteps = Integer.parseInt(moveStepsStr);
		}catch (Exception e) {
		}
	}
	
	String viewTypeStr = request.getParameter("viewType");
	if (viewTypeStr != null && viewTypeStr.length() > 0){
		try {
		  logcontext.viewType = Integer.parseInt(viewTypeStr);
		}catch (Exception e){}
	}

	LogViewQuickFilter quickFilter = new LogViewQuickFilter(man);

	/**
	 * filter segment
	 */

	
	FilterManager film = man.getFilterManager();
	
	String searchEngineSearchTerm = request.getParameter("searchEngineSearchTerm");
	String searchEngineAllWords = request.getParameter("searchEngineAllWords");
	boolean allWords = (searchEngineAllWords != null && searchEngineAllWords.equals("allWords"));
	String matchWholeWordsOnlyStr = request.getParameter("matchWholeWordsOnly");
	boolean matchWholeWordsOnly = (matchWholeWordsOnlyStr != null && matchWholeWordsOnlyStr.equals("true"));
	boolean useSearchEngineResultsOnly = false;
	if (searchEngineSearchTerm != null && !searchEngineSearchTerm.equals("")) {
		searchEngineSearchTerm = xpolog.eye.util.XpologUtil.replaceAll(searchEngineSearchTerm, "\\\"", "\"");
		searchEngineSearchTerm = searchEngineSearchTerm.replaceAll("&quot;", "\"");
		searchEngineSearchTerm = new String(searchEngineSearchTerm.getBytes("8859_1"), "UTF-8");
		FilterCollection fcol = SearchEngineAdminHelper.createFilter(searchEngineSearchTerm, allWords, man, matchWholeWordsOnly, true, true, userContext);
		if (fcol != null) {
			fcol.setSearchEngineResultsOnly(true);
			film.addFilterCollection(fcol);
	  	//audit
			AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "filtered log view", AuditConstants.LOGS, "filter view using " + fcol.getSummary());	 	 	
		}
	} else if (isQuickFilter) {
		FilterCollection fcol = null;
		boolean isActiveFilter = film != null && film.getActiveFilterId() != null && film.getActiveFilterId().length() > 0;
		String ignoreFilterInFilterStr = request.getParameter("ignoreFilterInFilter");
		boolean ignoreFilterInFilter = (ignoreFilterInFilterStr != null && ignoreFilterInFilterStr.equals("true"));

		if (quickFilterIndex != null && quickFilterIndex.length() > 0) {
			fcol = quickFilter.createQuickFilter(quickFilterTerm, Integer.parseInt(quickFilterIndex));
		}else {
			//if filter active,create filter in filter.
				fcol = SearchEngineAdminHelper.createFilter(quickFilterTerm, false, man, isWholeWords, isRegExp, false, userContext,isActiveFilter && !ignoreFilterInFilter);
		}
		if (fcol != null) {
			film.addFilterCollection(fcol);
	  	//audit
			AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "filtered log view", AuditConstants.LOGS, "filter view using " + fcol.getSummary());	 	 	
		}
	} else if (userContext != null && firstTime){
		FilterCollection fcol = userContext.updateFilterCollection(man,null,true);
		if (fcol != null){
			film.addFilterCollection(fcol);
	  	//audit
			AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "filtered log view", AuditConstants.LOGS, "filter view using " + fcol.getSummary());	 	 	
		}
		
	}
	
	if (!isQuickFilter && !op.equals("ZOOM_IN")) {
		if (!op.equals("LAST_FILTER_VIEW")) {	
			String activeId = request.getParameter("filters");
			if (activeId != null) {
				if (activeId.equalsIgnoreCase("none")) {
					film.setActiveFilterId(null);
				}else {
					if (activeId != null && activeId.indexOf(",") != -1){
						FilterCollection fc = FilterManager.createMultiFilter(name, man, activeId);
						if (fc != null){
							man.getFilterManager().addFilterCollection(fc);
							activeId = fc.getId();
					  	//audit
							AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
					   			userContext, AuditConstants.CHANGE, "filtered log view", AuditConstants.LOGS, "filter view using " + fc.getSummary());	 	 	
						}
					}
					film.setActiveFilterId(activeId);
				}
			}		
		}
	}


	String mark = queryInfo != null ? queryInfo.mark : request.getParameter("mark");

	if (mark == null) {
		mark = EMPTY_STR;
	}
	
	xpolog.eye.data.filters.Filter validateFilter = null;
	String validateTimeStr = request.getParameter("validateTime");
	if (validateTimeStr != null && validateTimeStr.length() > 0) {
		long validateTime = -1;
		try {
	validateTime = Long.parseLong(validateTimeStr);
		}catch (Exception e) {
		}
		if (validateTime >= 0) {

	DateFilter df = new DateFilter();
	df.setMinDate(new Date(validateTime));
	df.setMaxDate(new Date(validateTime));
	df.setIndexing(man.getRecordMask());
	df.setColIndex(man.getRecordMask().getDateColumnIndex());

	validateFilter = df;
		}
	}

	if (queryInfo == null) {
		queryInfo = new LogViewQueryInfo();
	}
	queryInfo.leapsize = leapsize;
	queryInfo.op = op;
	queryInfo.search = search;
	queryInfo.mark = mark;
	queryInfo.moveSteps = moveSteps;
	queryInfo.zoomInKey = zoomInKey;
	queryInfo.isRegExp = isRegExp;
	queryInfo.isWholeWords = isWholeWords;
	queryInfo.validateFilter = validateFilter;
	logcontext.query = queryInfo;
	
 
	String disableZoomOutStr = request.getParameter("disableZoomOut");
	logcontext.disableZoomOut = firstTime ? (disableZoomOutStr == null ? logcontext.disableZoomOut  : disableZoomOutStr.equals("true")) : (disableZoomOutStr != null && disableZoomOutStr.equals("true"));
	
	String quickFilterUsed = request.getParameter("quickFilterUsed");
	logcontext.useQuickFilter = quickFilterUsed != null ? quickFilterUsed.equals("true") : man.isUseQuickFilter();
	String forwardJsp = request.getParameter("forward");
	
	String addFilterStr = request.getParameter("addFilter");
	logcontext.addfilter = addFilterStr != null && addFilterStr.equals("true");
	
	String goToMain = request.getParameter("gotoMain");
  if (forwardJsp == null || forwardJsp.length() == 0){
  	String ref = request.getHeader("referer");
		boolean gotoM = goToMain != null && goToMain.equals("true");
		
		if (ref != null){
		  int index = ref.indexOf("?");
			if (index > 0){
				ref = ref.substring(0,index);
			}
		}
		
  	if ((ref != null && ref.indexOf("mainView") < 0) || (gotoM)){
  		if (gotoM && logcontext.isFirst){
    		logcontext.useQueryInSession = true;
  		}
  		response.sendRedirect("logviewAction.jsp");
  		return;
  	}
   	forwardJsp = logcontext.forward != null ? logcontext.forward : "logviewpage.jsp";
   	logcontext.forward = null;
  }
	
//Indexing
  IndexAdapter indexer = SearchEngineManager.getInstance().getDefaultIndexAdapter();
	boolean isIndexed = indexer.isIndexed(new IndexedObject(man.getId()));
	int indexingPolicy = Configuration.getInstance().getPropertiesManager().getPropertyAsInt("logview.showRunIndex", LogViewContext.WHEN_NOT_INDEXED);
	boolean searchEngineAvailable = SiteManagment.getInstance().getXpologManagment().isComponentLicenseValid(XpologManagment.SEARCH_ENGINE_COMPONENT);
	boolean indexingEnabled =  searchEngineAvailable && indexingPolicy != LogViewContext.NEVER && (indexingPolicy == LogViewContext.BY_STATUS || !isIndexed);
	String runIndexingStr = request.getParameter("runIndexing");
	boolean runIndexing = false;
	if (indexingEnabled && runIndexingStr != null && runIndexingStr.equals("true")) {
		runIndexing = true;
	}
	
	logcontext.runIndexing = runIndexing;
	if (logcontext.indexHelper == null){
		LogViewIndexHelper indexHelper = new LogViewIndexHelper();
		indexHelper.setMaxSearchTime(2000);
		String path = DefaultIndexingHelper.getIndexDirectory(man.getId());
		indexHelper.setPath(path);
		logcontext.indexHelper = indexHelper;
	}
	
	
	String rememberAnswerStr = request.getParameter("rememberAnswer");
	boolean rememberAnswer = false;
	if (indexingEnabled && rememberAnswerStr != null && rememberAnswerStr.equals("true")) {
		rememberAnswer = true;
	}
	logcontext.rememberAnswer = rememberAnswer;
	if (rememberAnswer) {
		env.setTempAttribute("INDEX_" + man.getId(), (runIndexing ? "true" : "false"));
	}
	String indexLog = (String)env.getTempAttribute("INDEX_" + man.getId(), false);
	if (indexLog == null) {
		indexLog = "";
	}
	logcontext.indexLog = indexLog;
	
	
	
	
	
	
//handle status issues
	LinearDataSource dc1 = man.getDefaultLinearDataBuilder().getLinearDataSource();
	LinearDataSource dc = null;
	if (dc1 instanceof XMLElementDataSource) {
		dc = ((XMLElementDataSource)dc1).getDataSource();
	}else {
		dc = dc1;
	}
	if (firstTime) {
		dc.setDataViewMode(DataConstants.DataViewModes.VIEW_MODE);
	}
	if (dc instanceof IntervalDataSource) {
		IntervalDataSource ds = (IntervalDataSource)dc;
		PumperManager pumper = ds.getPumperManager();
		logcontext.showReload = true;
		boolean onlyInit = !ds.isAutoUpdate() && !updateIntervalDS.equals("true") && ds.tempDataAvailable() && pumper instanceof TimedPumperManager && ((TimedPumperManager)pumper).getInterval() > 0;
		if ((firstTime && (ds.isAutoUpdate() || !ds.tempDataAvailable() || onlyInit)) || updateIntervalDS.equals("true")) {
			logcontext.forward = forwardJsp;
			response.sendRedirect("presentStatusAction.jsp?onlyInit=" + onlyInit + "&forward=loggers/" + forwardJsp);
	return;
		}
		
	}
	
	if (dc instanceof SshMediaMultiFilesDataSource) {
		String connectedStr = request.getParameter("connected");
		boolean connected = connectedStr != null && connectedStr.equals("true");

		SshMediaMultiFilesDataSource ds = (SshMediaMultiFilesDataSource)dc;
		if (firstTime && !connected) {
	response.sendRedirect("presentSshStatusAction.jsp?forward=loggers/" + forwardJsp);
	return;
		}
	}
		
		if (runIndexing) {
			logcontext.forward = forwardJsp;
	response.sendRedirect("presentIndexingStatusAction.jsp?forward=loggers/" + forwardJsp);
	return;
		}
		
		
	  IndexStatus indexStatus = null;
	  if (logcontext.indexStatus == null){
	    if (man.isUseIndexing()) {
		    indexStatus = man.getIndexStatus();
		    if (indexingEnabled && indexStatus == null) {
	    indexStatus = man.updateIndexStatus();
		    }
	    }

	    if (indexStatus == null) {
		    indexStatus = new IndexStatus(IndexStatus.NO_STATUS, -1);
	    }
		  logcontext.indexStatus = indexStatus;
	  }
%>

<%@page import="java.io.File"%><jsp:forward page="<%=forwardJsp%>" /> 

