<%@ page language="java" %> 
<%@page import="xpolog.eye.snapshot.Snapshot"%>
<%@page import="xpolog.eye.snapshot.SnapshotManager"%>
<%@page import="xpolog.eye.logview.LogViewContext"%>
<%@page import="xpolog.config.Configuration"%>
<%@page import="xpolog.eye.security.WebSecurityManager"%>
<%@page import="xpolog.eye.security.UserSecurity"%>
<%@page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@page import="xpolog.eye.site.SiteUtil"%>
<%@page import="xpolog.eye.issuetracking.*"%>


<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
		String ACTIVE_SNAPSHOT_ID = "ACTIVE_SNAPSHOT_ID";
		String baseDirectory = request.getParameter("baseDirectory");
		if (baseDirectory == null){
			baseDirectory = BASE_DIRECTORY;
		}
	  WebSecurityManager securityManager = WebSecurityManager.getInstance();
	  UserSecurity user = securityManager.getUserSecurity(request);
	  LogViewContext logcontext = (LogViewContext)request.getSession().getAttribute(LogViewContext.LOG_CONTEXT);
	  boolean isSnapshotLbm  = (logcontext == null || logcontext.lbm == null) ? false : logcontext.lbm.isSnapshot();
		String activeSnapshotName = null;
		String activeSnapshotId = (String)request.getSession().getAttribute(ACTIVE_SNAPSHOT_ID);
		if(activeSnapshotId != null && activeSnapshotId.length() > 0){
			Snapshot snapshot	= SnapshotManager.getInstance().getSnapshot(activeSnapshotId);
			if(snapshot != null){
				activeSnapshotName = snapshot.getName();
			}		
		}else{
			activeSnapshotId = null;
		}
		final boolean ALLOW_EMBEDED_FLASH = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("snapshot.allowEmbededFlash",true);
		//check permissions
		boolean hasEditPermissions = logcontext.lbm == null ? false : (user == null ? true : user.isModuleMemberEditable(logcontext.lbm.getId()));
		boolean isPermittedAddSnapshot = securityManager.isHavePermission(user,ActionsPermissionConstants.AdministrationPermissions.ADD_SNAPSHOT_PERMISSION);		
		boolean isPermittedOpenIssue = securityManager.isHavePermission(user,ActionsPermissionConstants.IssueTraqckingPermissions.OPEN_ISSUE_PERMISSION);
		boolean isPermittedIssueTrackingSettings = securityManager.isHavePermission(user,ActionsPermissionConstants.IssueTraqckingPermissions.ISSUE_TRACKING_SETTINGS_PERMISSION);
		boolean isPermittedCustomize = hasEditPermissions && securityManager.isHavePermission(user,ActionsPermissionConstants.LogViewingPermissions.CUSTOMIZE_LOG_PERMISSION);
		boolean isPermittedReports = securityManager.isHavePermission(user,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION);
		boolean isPermittedExport = securityManager.isHavePermission(user,ActionsPermissionConstants.DataSupportPermissions.EXPORT_LOG_PERMISSION);
    
    String searchMenuScript = (String)request.getAttribute("searchMenuScript");
	  
%>
<%@page import="xpolog.eye.SiteManagment"%>
<script type="text/javascript">
var isSnapshotLbm = '<%=isSnapshotLbm%>';
var isSnapshotsExsits = false;
activeSnapshotId = "<%=activeSnapshotId == null ? "" : activeSnapshotId%>";
var activeSnapshotName = "<%=activeSnapshotName == null ? "" : activeSnapshotName%>";
//For snapshot right click copy action (Only for firefox).
var flash_installed = (navigator.appName == 'Netscape') ? isFlashInstalledInBrowser() : true;
var isAllowEmbededFlash = '<%=ALLOW_EMBEDED_FLASH%>';
var showCopyAction = ((isAllowEmbededFlash == "true") && flash_installed) || (navigator.appName != 'Netscape');
var isPermittedAddSnapshot = "<%=isPermittedAddSnapshot%>";
var isPermittedCustomize = "<%=isPermittedCustomize%>";
var isPermittedReports = "<%=isPermittedReports%>";
var isPermittedExport = "<%=isPermittedExport%>";

function updateIsSnapshotsExsits(){
	isSnapshotsExsits = (mygridsnapshot && mygridsnapshot.getRowsNum() > 0);
}

function addToSnapshot(isCreate){
	updateTablesnapshot();	
	var activeDivId = 'selectSnapshot';
	if(isCreate){
		activeDivId = 'createSnapshot';	
	}else{
		activeDivId = isSnapshotsExsits ? 'selectSnapshot' : 'createSnapshot';
	}
	showGeneralAdminDiv(activeDivId,-1,70);
	//set text box focus
	if(activeDivId == 'createSnapshot'){	
		var txtBox=document.getElementById("firstNewSnapshot" );
		if (txtBox!=null ) txtBox.focus();	
	}	
	
}

function addToSnapshotById(id){
	if(!id || id.length == 0){
		id = activeSnapshotId;
	}
	saveSnapshot(id,true,true);
}

//Update the rightClick menu.
function updateRightClickMenu(){
	
	var isSnapshotActive = 	activeSnapshotId && activeSnapshotId.length > 0 && activeSnapshotName && activeSnapshotName.length > 0;
	logDataCM = new jsDOMenu(150,"","absolute");	
	with(logDataCM){
		addMenuItem(new menuItem("Copy", "copy_selected", "javascript:copySelected()"));
		if(!isMultiSelected()){	//
			addMenuItem(new menuItem("Find", "find", "javascript:_find()"));
			if(isFilterActive && isFilterActive == "true") {
				addMenuItem(new menuItem("Composite filter", "compositeFilter", "javascript:void(0)"));
				logDataCM_composite_filter = new jsDOMenu(150,"","absolute");
				with(logDataCM_composite_filter){
				addMenuItem(new menuItem("AND", "compositeFilterAnd", "javascript:_filter('and')"));
				addMenuItem(new menuItem("OR", "compositeFilterOr", "javascript:_filter('or')"));
				}	
				logDataCM.items.compositeFilter.setSubMenu(logDataCM_composite_filter);
			}else {
				addMenuItem(new menuItem("Filter", "filter", "javascript:_filter()"));
			}
			if(selectedColType == "date"){
				addMenuItem(new menuItem("Filter date in...", "filterInDate", "javascript:_filterIn(true)"));
			}else{
				addMenuItem(new menuItem("Filter in...", "filterIn", "javascript:_filterIn(false)"));
			}
			addMenuItem(new menuItem("Search", "search", "javascript:void(0)"));
		}
		addMenuItem(new menuItem("-", "", "javascript:searchText('','')"));
		if(isPermittedAddSnapshot == "true" && (selectedRowsArray && selectedRowsArray.length > 0)){ // check permissions and if row was selected
			if(isSnapshotLbm != 'true'){ //Snapshot section.
				if(isSnapshotActive){ //Entry of last snapshot in session
					addMenuItem(new menuItem("Add to " + activeSnapshotName , "snapshot_active", "javascript:addToSnapshotById()"));	
				}else{ //add new snapshot
					addMenuItem(new menuItem("Add to Snapshot", "snapshot", "javascript:addToSnapshot(true)"));
				}
				if(isSnapshotsExsits){ //select from snapshots list
					addMenuItem(new menuItem("Select Snapshot", "snapshot_select", "javascript:addToSnapshot()"));	
				}
				addMenuItem(new menuItem("-", "", ""));
			}else{
				if(showCopyAction){
					addMenuItem(new menuItem("Copy Snapshot Link", "copy_link", "javascript:copySnapLink()")); 
				}						
				addMenuItem(new menuItem("Remove from Snapshot", "snapshot_remove", "javascript:removeFromSnapshot()"));
				addMenuItem(new menuItem("-", "", ""));		
			}
		}else if(isPermittedAddSnapshot == "true" && showCopyAction && (isSnapshotLbm == 'true')){ //COPY SNAPSHOT LINK TO CLIPBOARD  EVEN IF NOW ROW WAS SELECTED
					addMenuItem(new menuItem("Copy Snapshot Link", "copy_link", "javascript:copySnapLink()"));			
					addMenuItem(new menuItem("-", "", ""));		
		}
		
		if (selectedRowsArray && selectedRowsArray.length > 0){
		  <%
		  if(isPermittedOpenIssue) {
		  	boolean showLine = false;
		  	IssueTrackingManager mgr = IssueTrackingManager.getInstance();
				IssueTracking [] tracking = mgr.getIssueTrackingList();
				for (int i = 0; i < tracking.length; i++) {
					showLine = true;
					IssueTracking issueTracking = tracking[i];
					String trackerName = issueTracking.getName();
					if (trackerName.length() > 15){
						trackerName = trackerName.substring(0,13) + "...";
					}
			%>
			  addMenuItem(new menuItem("Open a bug in <%=trackerName%>", "addIssue", "javascript:addIssue('<%=issueTracking.getId()%>')"));
		  <%
		  }
				if (tracking.length == 0 && SiteManagment.getInstance().isUsingBuildType(SiteManagment.BUILD_TYPE_TESTING) && isPermittedIssueTrackingSettings){
					showLine = true;
			%>
				addMenuItem(new menuItem("Open a bug...", "addIssue", "javascript:addIssue('')"));
			<%
			}
				if(showLine) {
			%>
				addMenuItem(new menuItem("-", "", ""));
			<%
				}
			}
			%>
		}
		if (isPermittedCustomize == "true"){
			addMenuItem(new menuItem("Customize", "customize", "javascript:_gotoUrl('loggers/customization/logCustomization.jsp','main')"));
		}
		if (isPermittedExport == "true"){
			addMenuItem(new menuItem("Export", "export", "javascript:_gotoUrl('tools/export/exportEditAction.jsp','main')"));
		}
		addMenuItem(new menuItem("Print", "print", "javascript:_print0()"));
		if(isSnapshotLbm != 'true' && isPermittedReports == "true"){
			addMenuItem(new menuItem("Aggregation Report", "aggregate", "javascript:_searchText('reports/agg/quickLogAggCreateAction.jsp?addFilters=false&addKnowledge=false&addTotal=false&colIndex=[LOG_COL_INDEX]','main')"));
		}		
	}	
  if (!isMultiSelected()){
	   <% if (searchMenuScript == null){%>
			logDataCM_search = new jsDOMenu(150,"","absolute");
			with(logDataCM_search){
			addMenuItem(new menuItem("XpoSearch", "xpoSearchEngine", "javascript:_searchText('search/view/search.jsp?searchTerm=[LOG_COL_DATA]','_new')"));
			addMenuItem(new menuItem("Google", "defaultSearch1", "javascript:_searchText('http://www.google.com/search?hl=en&q=[LOG_COL_DATA]','_new')"));
			addMenuItem(new menuItem("JDocs", "jdocs", "javascript:_searchCustom('context/jdocsAction.jsp')"));
			}	
			logDataCM.items.search.setSubMenu(logDataCM_search);
	  <%}else {%>
		  <%=searchMenuScript%>
	  <%}%>
  }
	return logDataCM;
}


function updateSnapshotList(e){
	if(!mygridsnapshot){
		return;		
	}
	var name = document.getElementById('selectSnapshot').value;
	name = updateSnapshotName(name,e)	;
	mygridsnapshot.filterBy(0,name);	
	mygridsnapshot.sortRows(0,"str");		
}

function updateSnapshotName(name,e){
	var keynum;
	var keychar;
	var numcheck;
	
	if(window.event){
		  keynum = e.keyCode;
	  }else if(e.which){
		  keynum = e.which;
	 }
	 if (keynum == 13 || keynum==59 || keynum == 8){
	  if(keynum == 8 && name.length > 0){
	  	name = name.substring(0,(name.length - 1));
	  }
	 }else{	 
			if(keynum == 189){	 
				keychar = '-';
			}else{
				keychar = String.fromCharCode(keynum);
			}			
			name = name + keychar;
		}

 	return name;
}


function saveSnapshot(name,isExists,isRightClick,description){
	var isNewSnapshot = true;
	if(isExists){
		isNewSnapshot = false;
	}
	var selectedRowIndexArr = getSelectedRowsIndexsParm();
	var params = "name="+ encode(name) + "&isNew=" + isNewSnapshot + "&selectedRowIndexArr=" + selectedRowIndexArr + "&description=" + encode(description);	
	var page = "../snapshot/selectSnapshotAction.jsp?";
			sendAjaxRequest(page,function(req){
			var result = req.responseText;
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result){
					alert("Problem updating snapshot!");			
					return;			
			}else{
				var resultArr = result.split("#");		
				if(resultArr && resultArr[0] && resultArr[0] == "ok"){
					activeSnapshotId = resultArr[1];
					activeSnapshotName = resultArr[2];				
					updateTablesnapshot();	
//					updateRightClickMenu();
					closeOpenDivs();
					disableButton('saveSnapeshotBtn');					
					if(isNewSnapshot){
//							mygridsnapshot.refreshFilters(); // refresh grid
							if(!isSnapshotsExsits){
								refreshMenus();
							}else{
								refreshMenus("","Snapshot",baseDirectory);				
							}
					}								
				}else{
						//error msg handle
						if(isRightClick){
							parent.parent.errorMsgWriter("snapshotMsgWriterId",result,"");							
							return;	
						}else	if(isExists){
							showHideSelectSnapErrorMsg(true,result);
						}else{
							ShowHideCreateErrorMsg(true,result);		
						}
						return;											
				}
			}
		},'POST',params);	
}

//Remove events from open snapshot
function removeFromSnapshot(){
	var selectedRowIndexArr = getSelectedRowsIndexsParm();
	var params = "&selectedRowIndexArr=" + selectedRowIndexArr;
	var page = "../snapshot/removeFromSnapshotAction.jsp?";
			sendAjaxRequest(page,function(req){
			var result = req.responseText;
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result || result == "error#"){
				var msg = "<nobr>Problem removing event(s) from snapshot</nobr>"
				parent.parent.errorMsgWriter("snapshotMsgWriterId",msg,"");							
				return;						
			}
			var resultArr = result.split("#");
			if(resultArr[0] == "error"){
					var msg = resultArr[1];
					parent.parent.errorMsgWriter("snapshotMsgWriterId",msg,"");							
					return;			
			}else if(result == "ok"){
					var path ="<%=BASE_DIRECTORY%>view/mainView.jsp";
					frm = getMainViewFrame();
  				if (frm){
					 	frm.location = path;
				  }
			}
		},'POST',params);	

}

function getSelectedRowsIndexsParm(){
	if(!selectedRowsArray || selectedRowsArray.length == 0){
		return selectedRowIndex;
	}else{
		var result = "";
		for(var i = 0 ; i < selectedRowsArray.length ; i++) {
			result += selectedRowsArray[i] + "#";
		}		
		return result.replace(/-1/gi,"");
	}
}

function isMultiSelected(){
	return selectedRowsArray && selectedRowsArray.length > 1;
}

function closeOpenDivs(){
		if(closeSnapshotSelectionDiv){
			closeSnapshotSelectionDiv();
		}
		if(closeNewSnapshotDiv){
			closeNewSnapshotDiv();
		}
		if(closeSnapshotSelectionDiv){
			closeSnapshotSelectionDiv();
		}

}


function getMainViewFrame(){
 	var mgmtFrm = getManagemtnFrame();
  if(mgmtFrm && mgmtFrm.parent && mgmtFrm.parent.frames['main']) {
    var frm =  mgmtFrm.parent.frames['main'];
    if (frm.location && frm.location.href && frm.location.href.indexOf("mainView.jsp") != -1){
      return frm;
    }
  }
}


function copySelected(){
	var selectedRowIndexArr = getSelectedRowsIndexsParm();
	var params = "selectedRowIndexArr=" + selectedRowIndexArr;
	var page = "../common/getLbmRecordsArr.jsp?";
			sendAjaxRequest(page,function(req){
			var result = req.responseText;
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result || result == "error"){
					alert("Problem copying event(s) from snapshot!");			
					return;			
			}else{
					var dataToCopy = "";
					var resultArr = result.split("#@#@");
					for(var i = 0 ; resultArr && i < resultArr.length ; i++){
						dataToCopy += resultArr[i] + "\n";
					}
					copyDataToClipboard(dataToCopy);
		      return true;  
			 }		   
		},'POST',params);	
}

function copySnapLink(){
		var timestamp = '<%=System.currentTimeMillis()%>';
		var id = activeSnapshotId;
		var page = "../snapshot/snapshotID.jsp?timestamp=" + timestamp;
			sendAjaxRequest(page,function(req){
			var result = req.responseText;
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result || result == "error"){
					alert("Problem copying snapshot link");			
					return;			
			}else{ 
				id = result;
				var applicationRoot = '<%=SiteUtil.getApplicationRoot(request)%>';		
				var link = applicationRoot + "componentAction.jsp?selectedCompId=XpoLog&forward=root.jsp?mainPage=snapshot/snapshotView.jsp%3FSNAPSHOT_ID=" + id;
				copyDataToClipboard(link);				
		  }		   
		});			
}

function copyDataToClipboard(dataToCopy){
		if(window.clipboardData){
			window.clipboardData.setData('text', dataToCopy);
		}else if(isAllowEmbededFlash == "true"){
        var clipboarddiv=document.getElementById('divclipboardswf');  
 				 if(clipboarddiv==null){  
	        clipboarddiv=document.createElement('div');  
          clipboarddiv.setAttribute("name", "divclipboardswf");  
	        clipboarddiv.setAttribute("id", "divclipboardswf");  
	        document.body.appendChild(clipboarddiv);  
	     }  
       clipboarddiv.innerHTML='<embed src="../common/clipboard.swf" FlashVars="clipboard='+  
			 encodeURIComponent(dataToCopy)+'" width="0" height="0" type="application/x-shockwave-flash"></embed>';  
     }  
}

function addIssue(trackerId){
  var selectedRowIndexArr = getSelectedRowsIndexsParm();
	var params = "selectedRowIndexArr=" + selectedRowIndexArr + "&ISSUE_TRACKING_ID=" + encode(trackerId);
	if (parent && parent.parent && parent.parent.openGeneralDiv){
	  parent.parent.openGeneralDiv('loggers/addIssueWithLogAction.jsp',params,"Add a Bug","Loading information...");
	}
}

</script>
<!-- New Snapshots  -->
<div id="newSnapshotDiv" style="display:">
			<jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
			<jsp:param name="baseDirectory" value="<%=baseDirectory%>"/> 
			<jsp:param name="suffix" value="createSnapshot"/> 
			<jsp:param name="includePath" value="snapshot/createSnapshotDiv.jsp"/> 
			<jsp:param name="width" value="500px"/> 
			<jsp:param name="height" value="180px"/> 
			<jsp:param name="zIndex" value="500"/> 
			<jsp:param name="title" value="Create Snapshot"/> 
			<jsp:param name="actionsNames" value="Save#Cancel"/> 
			<jsp:param name="actions" value="javascript:saveFirstNewSnapshot()#javascript:closeNewSnapshotDiv()"/> 
			</jsp:include>
</div>
<!-- End New Snapshots -->



<!-- Snapshots List  -->
<div id="selectSnapshotDiv" style="display:">
			<jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
			<jsp:param name="baseDirectory" value="<%=baseDirectory%>"/> 
			<jsp:param name="suffix" value="selectSnapshot"/> 
			<jsp:param name="includePath" value="snapshot/selectSnapshotDiv.jsp"/> 
			<jsp:param name="width" value="500px"/> 
			<jsp:param name="height" value="260px"/> 
			<jsp:param name="zIndex" value="300"/> 
			<jsp:param name="title" value="Select Snapshot"/> 
			<jsp:param name="actionsNames" value="Create New@id=createSnapeshotBtn#Apply@id=saveSnapeshotBtn#Cancel"/> 
			<jsp:param name="actions" value="javascript:openNewSnapshotName()#javascript:saveSelectedSnapshot()#javascript:closeSnapshotSelectionDiv()"/> 
			</jsp:include>
</div>
<!-- End Snapshots List -->

<script>
function endLoadsnapshot(){
  hideLoadingsnapshot();
  mygridsnapshot.setSizes();
  mygridsnapshot.sortRows(0,"str");
	updateIsSnapshotsExsits();
//	updateRightClickMenu();
	disableButton('saveSnapeshotBtn');
//  mygridsnapshot.filterBy(0,"");  
}


function doOnRowSelectedsnapshot(id){
	enableButton('saveSnapeshotBtn');
}

function doOnRowDblClickedsnapshot(id){
	saveSnapshot(id,true);
	disableButton('saveSnapeshotBtn');
}

</script>
