<%@ page language="java"%>
<%@ page import="xpolog.eye.common.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.index.adapters.*"%>
<%@ page import="xpolog.eye.data.index.adapters.defaultadapter.*"%>
<%@ page import="xpolog.eye.logview.LogViewContext"%>
<%@ page import="xpolog.eye.data.log.files.SshMediaMultiFilesDataSource"%>
<%@page import="xpolog.eye.media.telsh.TelnetAccountPolicy"%>
<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
String CURRENT_LOG = "CURRENT_LOG";
UserEnvironment env = UserEnvironment.getUserEnvironment(request);
final LogBrowsingManager man = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
final LogsIndexerRunner indexRunner = man.getLogsIndexerRunner();

JobStatus status = indexRunner.getStatus();
env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, status); 

String forward = request.getParameter("forward");
if (forward == null || forward.length() == 0){
	forward = "loggers/logview.jsp?useQueryInSession=true";
}

final LogViewContext logcontext = (LogViewContext)request.getSession().getAttribute(LogViewContext.LOG_CONTEXT);

ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + forward) {
  public void run(HttpServletRequest request){    
    try {
      if (indexRunner.isRunning()){
        while(indexRunner.isRunning()){
          Thread.sleep(500);
        }
      }else {    
        indexRunner.executeIndexing(new String[] {man.getId()});    
      }
   }catch (Exception e){
     e.printStackTrace();
   }
   man.clearIndexRunner();
   man.updateIndexStatus();
   if (logcontext != null){
  	 logcontext.indexStatus = man.getIndexStatus();
   }
  }
};
env.setProgressRunner(runner);

boolean markSessionActivity = false;
if(logcontext.lbm != null && 
	 logcontext.lbm.getLinearDataBuilder() != null && 
	 logcontext.lbm.getLinearDataBuilder().getLinearDataSource() != null &&
	 logcontext.lbm.getLinearDataBuilder().getLinearDataSource() instanceof SshMediaMultiFilesDataSource) {
	SshMediaMultiFilesDataSource mfds = (SshMediaMultiFilesDataSource)logcontext.lbm.getDefaultLinearDataBuilder().getLinearDataSource();
	if(mfds.getAccount() != null && mfds.getAccount().getAccountPolicy() != null && mfds.getAccount().getAccountPolicy() instanceof TelnetAccountPolicy) {
		TelnetAccountPolicy accountPolicy = (TelnetAccountPolicy)mfds.getAccount().getAccountPolicy();
		if(accountPolicy.getSessionTimeoutInterval() != -1) {
			markSessionActivity = true;
		}
	}
}

%>

<jsp:include page="../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Indexing"/>
 <jsp:param name="useStatus" value="true"/>
 <jsp:param name="markSessionActivity" value="<%=markSessionActivity %>"/>
 <jsp:param name="stopUrl" value="loggers/presentIndexingStatusStopAction.jsp"/>
</jsp:include>

  
