<%@ page language="java"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.common.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.data.index.IndexStatus"%>
<%@ page import="xpolog.eye.data.log.external.*"%>
<%@ page import="xpolog.eye.security.UserSecurity"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
String CURRENT_LOG = "CURRENT_LOG";
String DO_UPDATE = "doUpdate";
UserEnvironment env = UserEnvironment.getUserEnvironment(request);
UserContext userContext = UserEnvironment.getUserContext(request);
final LogBrowsingManager man = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
final IntervalDataSource ds = IntervalAdminHelper.getIntervalDataSource(man);
String onlyInitStr = request.getParameter("onlyInit");
final boolean onlyInit = onlyInitStr != null && onlyInitStr.equals("true");
boolean isPumperRunner = false;
if (!ds.getPumperManager().isRunning()){
	env.setTempAttribute(man.getId()+"_pumper_runner",userContext);
	isPumperRunner = true;
}
if (!onlyInit){
	ds.startDataSource(true);	
}
UserSecurity user = userContext != null ? userContext.getUser() : null;
String userName = "NA";
if (user != null){
	userName = user.getUser().getName();
}


//final JobStatus status = ds.getJobStatus();
final JobStatus finalStatus = new JobStatus();
env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, finalStatus); 

String forward = request.getParameter("forward");
if (forward == null || forward.length() == 0){
	forward = "loggers/logview.jsp?dataLoaded=true";
}
final LogViewContext logcontext = (LogViewContext)request.getSession().getAttribute(LogViewContext.LOG_CONTEXT);
ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + forward) {
  public void run(HttpServletRequest request){
    //if the data source failed or the datasource finished, ends the progress.
    boolean isFinished = false;
    boolean isFailed = false;
    try {
    	while(!isFinished && !isFailed){
 	  		Thread.sleep(1000);
        isFinished =  ds.isFinished();
        isFailed = ds.isFailed();
        String msg = IntervalAdminHelper.getStatus(man);
        finalStatus.setCurrentStatus(msg);
     }
      if (onlyInit){
				ds.initPumper();
      }else{
      	ds.update();
      }
   }catch (Exception e){
     e.printStackTrace();
     isFailed = true;
   }
   
   int indexingPolicy = Configuration.getInstance().getPropertiesManager().getPropertyAsInt("logview.showRunIndex", LogViewContext.WHEN_NOT_INDEXED);
   boolean indexingEnabled = man.isUseIndexing() && SiteManagment.getInstance().getXpologManagment().isComponentLicenseValid(XpologManagment.SEARCH_ENGINE_COMPONENT) && indexingPolicy != LogViewContext.NEVER;
   if(indexingEnabled) {
	   man.updateIndexStatus();
	   if (logcontext != null){
	  	 logcontext.indexStatus = man.getIndexStatus();
	   }
   }else {
  	 if(logcontext != null) {
	  	 logcontext.indexStatus = new IndexStatus(IndexStatus.NO_STATUS, -1);
  	 }
   }
  }
};
env.setProgressRunner(runner);
String stopUrl = isPumperRunner ? 
	"loggers/presentStatusStopAction.jsp" :
	"loggers/stopPumping.jsp?isPumperRunner="+isPumperRunner+"&userName="+userName;
String redirectStopUrl = isPumperRunner ? "false" : "true";

if (!ds.isAutoUpdate() &&  (ds.getLogBrowserId() == null || ds.getLogBrowserId().equals("NA"))){
	ds.setLogBrowserId(man.getId());
	SiteManagment mgmt = SiteManagment.getInstance();
	Module mod = mgmt.getParentModule(man.getId());
	SiteManagment.getAdminInstance().addLogBrowser(man,mod);
}
%>

<jsp:include page="../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Processing"/>
 <jsp:param name="useStatus" value="true"/>
 <jsp:param name="stopUrl" value="<%=stopUrl%>"/>
 <jsp:param name="redirectStopUrl" value="<%=redirectStopUrl%>"/>
</jsp:include>

  
