<%@ page language="java" %>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.linear.*"%>
<%@ page import="xpolog.eye.logview.*"%>

<%!
static final String BASE_DIRECTORY = "../";
%>

<%

  String ERROR_OBJ = "ERROR_OBJ";


  LogViewContext logcontext = (LogViewContext)request.getSession().getAttribute(LogViewContext.LOG_CONTEXT);
  LogViewQueryInfo queryInfo = logcontext == null ? null : logcontext.query;
  LogBrowsingManager lbm = logcontext == null ? null : logcontext.lbm;
  
  LinearQueryStatus status = lbm == null || queryInfo == null? null : lbm.getQueryStatus();
  String progressStr = "";
  String title = "";
  String timeStr = "";
  int progressValue = 0;
  if (status != null && status.getRecordsToRead() > 0){
    int percent = (status.getRecordsReaded() * 100) / status.getRecordsToRead();
    
    progressStr = "" + status.getRecordsReaded() + " / " + status.getRecordsToRead();
    progressValue =  percent / 10;
    progressStr += " records";
  }
  if (queryInfo != null){
    long time = (System.currentTimeMillis() - queryInfo.uniqueId)/1000;
    timeStr = String.valueOf(time) + " seconds";
  }
  
  response.setContentType("text/xml");
  response.setHeader("Cache-Control", "no-cache");
  out.println("<root>");
	out.println("<value><![CDATA[" + progressValue + "]]></value>");
	out.println("<message><![CDATA[<nobr>" + progressStr + "</nobr>]]></message>");
	out.println("<time><![CDATA[<nobr>" + timeStr + "</nobr>]]></time>");
	out.println("</root>");
	out.flush();
%>

<jsp:include page="markSessionActivity.jsp" flush="true" />