<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.logview.LogZoomOutParams"%>

<%@ page import="java.util.*"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<% 

  String CURRENT_LOG = "CURRENT_LOG";

	String search = request.getParameter("search");
	String regExp = request.getParameter("regExp");
	String filterWholeWords = request.getParameter("filterWholeWords");
	String leapsize = request.getParameter("leapsize");
	String opdirect = request.getParameter("opdirect");
	String newLogId = request.getParameter("newLogId");
	String zoomInKey = request.getParameter("zoomInKey");
	String zoomOutUrl = request.getParameter("zoomOutUrl");
  Integer calls = (Integer)request.getSession().getAttribute("callsPage");
  int cal = 0;
  if(calls != null){
  	cal = calls.intValue()+1;
  }

	LogBrowsingManager lbm = null;
  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  FilterCollection fc = null;
  if (lbm != null){
  	FilterManager filterMgr = lbm.getFilterManager();
  	if (filterMgr != null){
  		fc = filterMgr.getFilterCollectionById(filterMgr.getActiveFilterId());
  	}
    LogZoomOutParams params = new LogZoomOutParams();
    params.setSearch(search);
    params.setRegExp(regExp);
    params.setFilterWholeWords(filterWholeWords);
    params.setLeapsize(leapsize);
    params.setOpdirect(opdirect);
    params.setLbmId(lbm.getId());
    if (fc != null){
    	if (fc.isTransientFilter()){
    		params.setFc(fc);
    	}else{
    		params.setFilterCollectionId(fc.getId());
    	}
    }
    request.getSession().setAttribute("ZOOM_OUT_PARAMS",params);
  }
  
  SiteManagment mgmt = SiteManagment.getInstance();
  LogBrowsingManager newLbm = mgmt.getLogBrowserManager(newLogId);
  if (newLbm != null){
  	request.getSession().setAttribute(CURRENT_LOG,newLbm);
  	newLbm.setZoomOutLbm(lbm);
  }
%>

<html>
<head>
</head>

<body onload="javascript:document.access.submit()">
	<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" action="logview.jsp">
		<input type="hidden" name="logid" value="<%=newLogId%>">
		<input type="hidden" name="zoomInKey" value="<%=zoomInKey%>">
		<input type="hidden" name="opdirect" value="<%=opdirect%>">
		<input type="hidden" name="zoomOutUrl" value="useZoomOutAction">
		<input type="hidden" name="calls" value="<%=cal%>">
	</form>
</body>
</html>


