<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="omega.ui.models.*"%>
<%@ page import="omega.ui.html.table.OHtmlTable"%>
<%@ page import="java.io.*"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%


  String CURRENT_LOG = "CURRENT_LOG";
  String ERROR_OBJ = "ERROR_OBJ";

  //getting the managment
  SiteManagment mgmt = SiteManagment.getInstance();

  
  //manager handling
  LogViewContext logcontext = (LogViewContext)request.getSession().getAttribute(LogViewContext.LOG_CONTEXT);
  LogBrowsingManager man = logcontext == null ? null : logcontext.lbm;
  if((man == null)){
    return;
  }
  logcontext.calls = -1;


  //leap size
  int leapsize = man.getDefaultLeap();

  try{
      String str = request.getParameter("leapsize");
	if (str != null && str.length()>0){
      leapsize = Integer.parseInt(str);

	}
  }catch(Exception e){
  }



  //operation check
  String op = request.getParameter("opdirect");
  if(op == null){
    op = "CURRENT";
  }
  
  LogEyeModel model = null;



  if (model == null){
    RecordsMaskTableModel RMModel = null;
    if(op.equalsIgnoreCase("TAIL")){
      RMModel = man.getNewEntries(leapsize);
    }else {
      try {
        Thread.sleep(1000);
      }catch (Exception e){}
      return;
    }
    model = new LogEyeModel(BASE_DIRECTORY,man.getCustomizationManager(),RMModel,man);
  }

  String search = request.getParameter("search");
  SearchManager searchManager = new SearchManager(search);


  //html creation
  OHtmlTable tab = null;
  if (logcontext.viewType == LogViewContext.EVENTS_VIEW_TYPE){
  	tab = new EventsViewRenderer(model);  
    tab.setID("logTable");
  }else {
    tab = new OHtmlTable(model);  
    tab.setID("logTable");
    LogEyeCellRenderer cr = man.getCellRenderer(model,searchManager);
    LogEyeRowRenderer rr = man.getRowRenderer(model);
    tab.setRowRenderer(rr);
    tab.setCellRenderer(cr);
  }
  
  tab.render();
  String html = tab.getHtml();


%>

<jsp:include page="markSessionActivity.jsp" flush="true" />

<html>
<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
</head>
<body>
<%=html%>
</body>
</html>

