<%@ page language="java"%>

<%@ page import="xpolog.eye.data.log.files.SshMediaMultiFilesDataSource"%>
<%@ page import="xpolog.eye.LogBrowsingManager"%>
<%@ page import="xpolog.eye.logview.LogViewTab"%>
<%@ page import="xpolog.eye.media.telsh.TelnetAccountPolicy"%>
<%@ page import="xpolog.eye.site.main.MainViewModel"%>
<%@ page import="xpolog.eye.site.main.MainViewTabModel"%>
<%@ page import="xpolog.eye.site.TelShActivityManager"%>
<%@ page import="xpolog.eye.site.TelShActivityManager.TelShSessionActivityData"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.util.DateUtil"%>

<%@ page import="java.util.HashMap"%>
<%@ page import="java.util.Iterator"%>
<%@ page import="java.util.Map.Entry"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
  
	StringBuffer result = new StringBuffer();
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	MainViewModel model = env.getMainViewModel();
	MainViewTabModel tab = null;
	LogBrowsingManager lbm = null;
	String action = request.getParameter("action");
	//System.out.println(new java.util.Date() + ": " + action);
	
	if(action != null) {
		TelShActivityManager telShActivityManager = TelShActivityManager.getInstance();
		if(action.equals("count")) {
			int sshLogsCount = 0;
			MainViewTabModel[] onlineTabs = model.getAllOnlineTabs();
			for(int i = 0; i < onlineTabs.length; i++) {
				tab = onlineTabs[i];
				if(tab != null && tab instanceof LogViewTab) {
					LogViewTab logTab = (LogViewTab)tab;
					if(logTab.getContext() != null) {
						lbm = logTab.getContext().lbm;
						if(lbm != null && 
							 lbm.getLinearDataBuilder() != null && 
							 lbm.getLinearDataBuilder().getLinearDataSource() != null &&
							 lbm.getLinearDataBuilder().getLinearDataSource() instanceof SshMediaMultiFilesDataSource) {
							SshMediaMultiFilesDataSource mfds = (SshMediaMultiFilesDataSource)lbm.getLinearDataBuilder().getLinearDataSource();
							if(!mfds.isClosed() &&
								 mfds.getAccount() != null && 
								 mfds.getAccount().getAccountPolicy() != null &&
								 mfds.getAccount().getAccountPolicy() instanceof TelnetAccountPolicy) {
								TelnetAccountPolicy accountPolicy = (TelnetAccountPolicy)mfds.getAccount().getAccountPolicy();
								if(accountPolicy.getSessionTimeoutInterval() != -1) {
									sshLogsCount++;
								}
							}
						}
					}
				}
			}
			String header = "<TelShInactivityCheck sshLogsCount=\"" + sshLogsCount + "\">";
			String footer = "</TelShInactivityCheck>";
			result.insert(0, header);
			result.append(footer);
		}else if(action.equals("poll")) {
			HashMap sessionActivites = telShActivityManager.getSessionActivitiesData(session.getId());
			int inactiveLogsCount = 0;
			if(sessionActivites != null) {
				Iterator it = sessionActivites.entrySet().iterator();
				Entry entry = null;
				String logId;
				TelShSessionActivityData sessionActivityData;
				while(it.hasNext()) {
					entry = (Entry)it.next();
					logId = (String)entry.getKey();
					sessionActivityData = (TelShActivityManager.TelShSessionActivityData)entry.getValue();
					
					if(logId == null) {
						continue;
					}
					tab = model.getOnlineTabByDataId(logId);
					if(tab != null && tab instanceof LogViewTab) {
						LogViewTab logTab = (LogViewTab)tab;
						if(logTab.getContext() != null) {
							lbm = logTab.getContext().lbm;
							if(lbm != null && 
								 lbm.getLinearDataBuilder() != null && 
								 lbm.getLinearDataBuilder().getLinearDataSource() != null &&
								 lbm.getLinearDataBuilder().getLinearDataSource() instanceof SshMediaMultiFilesDataSource) {
								SshMediaMultiFilesDataSource mfds = (SshMediaMultiFilesDataSource)lbm.getLinearDataBuilder().getLinearDataSource();
								StringBuffer tmp = new StringBuffer();
								long sessionTimeoutInterval = ((TelnetAccountPolicy)mfds.getAccount().getAccountPolicy()).getSessionTimeoutInterval();
								long inactivityPeriod = System.currentTimeMillis() - sessionActivityData.getLastActivity();
								tmp.append("<InactiveLog logId=\"");
								tmp.append(logId);
								tmp.append("\" logName=\"");
								tmp.append(lbm.getName());
								tmp.append("\" inactivityPeriod=\"");
								String formattedInactivityPeriod = DateUtil.formatTime(inactivityPeriod);
								tmp.append(formattedInactivityPeriod);
								tmp.append("\" sessionTimeoutInterval=\"");
								String formattedSessionTimeoutInterval = DateUtil.formatTime(sessionTimeoutInterval);
								tmp.append(formattedSessionTimeoutInterval);
								tmp.append("\" tabId=\"");
								tab = model.getOnlineTabByDataId(logId);
								tmp.append(tab.getId());
								tmp.append("\" doClose=\"");
								if(sessionActivityData.isTimeoutCandidate()) {
									tmp.append("true");
								}else {
									tmp.append("false");
								}
								tmp.append("\" />");
								if(sessionActivityData.isTimeoutCandidate()) {
									if(inactivityPeriod > (sessionTimeoutInterval + TelShActivityManager.POST_TIMEOUT_INTERVAL)) {
										inactiveLogsCount++;
										result.append(tmp);
									}
								}else {
									if(!mfds.isClosed() && inactivityPeriod > (sessionTimeoutInterval - TelShActivityManager.PRE_TIMEOUT_INTERVAL)) {
										inactiveLogsCount++;
										telShActivityManager.markTimeoutCandidate(session.getId(), logId);
										result.append(tmp);
									}
								}
							}
						}
					}
				}
			}
			
			String header = "<TelShInactivityCheck inactiveLogsCount=\"" + inactiveLogsCount + "\">";
			String footer = "</TelShInactivityCheck>";
			result.insert(0, header);
			result.append(footer);
			
			//System.out.println(result);
		}else if(action.equals("mark")) {
			String logId = request.getParameter("logId");
			tab = model.getOnlineTabByDataId(logId);
			if(tab != null && tab instanceof LogViewTab) {
				LogViewTab logTab = (LogViewTab)tab;
				if(logTab.getContext() != null) {
					lbm = logTab.getContext().lbm;
					if(lbm != null && 
						 lbm.getLinearDataBuilder() != null && 
						 lbm.getLinearDataBuilder().getLinearDataSource() != null &&
						 lbm.getLinearDataBuilder().getLinearDataSource() instanceof SshMediaMultiFilesDataSource) {
						SshMediaMultiFilesDataSource mfds = (SshMediaMultiFilesDataSource)lbm.getLinearDataBuilder().getLinearDataSource();
						if(!mfds.isClosed() && mfds.getAccount() != null && mfds.getAccount().getAccountPolicy() != null && mfds.getAccount().getAccountPolicy() instanceof TelnetAccountPolicy) {
							TelnetAccountPolicy accountPolicy = (TelnetAccountPolicy)mfds.getAccount().getAccountPolicy();
							if(accountPolicy.getSessionTimeoutInterval() != -1) {
								telShActivityManager.markSessionActivity(session.getId(), logId, mfds);
							}
						}
					}
				}
			}
		}else if(action.equals("removeCandidates")) {
			telShActivityManager.removeAllTimeoutCandidates(session.getId());
		}
	}
  
	response.setContentType("text/xml");
	out.write(result.toString());
	out.flush();
%>

