<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.xml.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="omega.ui.models.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="omega.ui.html.table.OHtmlTable"%>
<%@ page import="xpolog.logic.ui.admin.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
  //constants
  String ADD = "ADD";
  String ERROR_OBJ = "ERROR_OBJ";
  String OP = "OP"; 
  String DUPLICATE = "DUPLICATE";
  String DATA_SOURCE_BUILDER = "DATA_SOURCE_BUILDER";
  
  String atomicId = request.getParameter("atomicId");
  String op = request.getParameter(OP);
  String isViewStr = request.getParameter("isView");
  
  boolean isView = isViewStr != null && isViewStr.equals("true");
  boolean isNew = true;
  
  UIXMLDataSourceBuilder builder = null;
  if (op == null || !op.equals(ADD)){
  	if (atomicId != null && atomicId.trim().length() > 0){
  		builder = new UIXMLDataSourceBuilder();
  		if (op != null && op.equals(DUPLICATE)){
  		  builder.duplicateDataSource(atomicId);
  		}else {
  		 builder.loadFromDataSource(atomicId);
    	 isView = true;
    	}
  	}else {
  		builder = (UIXMLDataSourceBuilder)request.getSession().getAttribute(DATA_SOURCE_BUILDER);  		
  	}
  }  
  if (builder == null){
  	builder = new UIXMLDataSourceBuilder();
  	builder.createNewDataSource();
  	builder.setTagName("ROOT");
  }else {
    isNew = false;
  }
  
  request.getSession().setAttribute(DATA_SOURCE_BUILDER,builder);

  String toVerify = request.getParameter("logLines");
  String isSchemaEditStr = request.getParameter("isSchemaEdit");
  boolean isSchemaEdit = isSchemaEditStr != null && isSchemaEditStr.equals("true");
  if (toVerify != null){
    toVerify = toVerify.trim();
  }

  //page data
  LogBrowsingManager lbm = null;
  String logname = "";

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  lbm = builder.getLogBrowserManager();


  boolean doUpdate = builder.getElementsPatternInfoCount() == 0 || toVerify != null || isSchemaEdit;
  String recordString = toVerify;
  String emptyResult = "XpoLog : There is no element found for tag name";
  if ((toVerify == null || toVerify.length() == 0) && !isNew){    
     recordString = builder.getDataSourceElementAsString();
  }
  
  if (recordString == null || recordString.trim().length() == 0){
     doUpdate = false;
     recordString = "";
  }else {
    if (!recordString.startsWith("<ROOT>")){
      recordString = "<ROOT>\n" + recordString  + "\n</ROOT>";      
    }
  }
  
  String [] metaDataKeys = UIDataSourceHelper.getMetaDataKeys();

  String errorPattern = "";
  boolean patternOk = true; 
  if (doUpdate){

    try{
      if (isSchemaEdit){
        for (int i = 0; i < builder.getElementsPatternInfoCount(); i++) {
           UIXMLDataSourceBuilder.LogicPatternElementInfo info = builder.getLogicElementPatternInfoAt(i);
           String pat = request.getParameter("elemPattern_" + i);
           String cond = request.getParameter("conditionCombo" + i);
           String condVal = request.getParameter("conditionValue_" + i);
           String ignore = request.getParameter("ignore_" + i);
           String unique = request.getParameter("uniqueUse_" + i);
           String uniqueVal = request.getParameter("uniqueValue_" + i);
           
           info.setSelected(ignore == null || !ignore.equals("on"));
           if (pat != null && pat.trim().length() > 0){
             info.setXpologPattern(pat);
           }
           
           if (cond != null && cond.trim().length() > 0  && !cond.equals("noSelect")){
             info.setConditionProperty(cond,condVal);
           }else {
             info.setConditionParameters(null);
           }
           
           boolean isUnique = unique != null && unique.equals("on");
           info.setUniqueSelected(isUnique);
           if (isUnique){
             info.setUniqueValue(uniqueVal);
           }else {
             info.setUniqueValue(null);
           }
        }                
      }else {
        builder.setDataSourceElement(recordString);
        builder.buildElementsPatternInfo();
        builder.initMappingInfo();
      }
      Properties metaDataProp = new Properties();
      for (int i = 0; i < metaDataKeys.length; i++){
        String chk = request.getParameter(metaDataKeys[i] + "Chk");
         if (chk != null && chk.equals("on")){
           String val = request.getParameter(metaDataKeys[i] + "Txt");
           metaDataProp.setProperty(metaDataKeys[i],val);
         }
      }
      builder.setMetaDataProperties(metaDataProp);
      
      builder.updateBuilder();

    }catch(Exception e){
      errorPattern = e.getMessage();
      patternOk = false;
    
    }
  }
  lbm = builder.getLogBrowserManager();
   //log table example

  String html = "";
  if(builder.getElementsPatternInfoCount() > 0 && patternOk){
    //html creation
    RecordsMaskTableModel model = lbm.getResultFromData(builder.getDataSourceElement());
    LogEyeModel lem = new LogEyeModel(BASE_DIRECTORY ,lbm.getCustomizationManager(),model);
    OHtmlTable tab = new OHtmlTable(lem);

    LogEyeCellRenderer cr = new LogEyeCellRenderer(lem);
    LogEyeRowRenderer rr = new LogEyeRowRenderer(lem);
    tab.setRowRenderer(rr);
    tab.setCellRenderer(cr);
    tab.render();
    html = tab.getHtml();
  }
  
  String charset = lbm.getCharset();
  if (charset != null){
    response.setContentType("text/html; charset=" + charset);
  }

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<jsp:include page="../../../scripts/dataview/dataView.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
</jsp:include>

<script language="javascript">
function doSave(){
   document.access.action = "addXMLDataSourceAction.jsp";
   document.access.submit();
}
function reanalyzeXMLCode(){
   document.access.action = "addXMLDataSource.jsp";
   document.access.submit();
}

function verifySchema(){
   document.access.action = "addXMLDataSource.jsp?isSchemaEdit=true";
   document.access.submit();
}

function ElementColumn(){
  this.attributes = new Array();
}

function ElementAttribute(key,value){
  this.key = key;
  this.value = value;
}

var elementsColumns = new Array();
<%
for (int i = 0; i < builder.getElementsPatternInfoCount(); i++) {
  XMLLogBrowserBuilder.PatternElementInfo info = builder.getElementPatternInfoAt(i);
%>
  elementsColumns[elementsColumns.length] = new ElementColumn();
  var atts = elementsColumns[elementsColumns.length - 1].attributes;
  <% XMLLogBrowserBuilder.AttributeInfo [] attributes = info.getAttributes();
     for(int j=0;j<attributes.length;++j){
   %>
       atts[atts.length] = new ElementAttribute("<%=attributes[j].key%>","<%=attributes[j].value%>");
  <%}
}
%>


function changeAttribute(combo,index){
  var txtVal = document.getElementById("conditionValue_" + index);
  if (combo.selectedIndex > 0){
    txtVal.value = elementsColumns[index].attributes[combo.selectedIndex - 1].value;
  }else {
    txtVal.value = "";
  }
}

function shownHideAdv(targetDiv){
         
    	show = document.getElementById(targetDiv).style.display == "";
    	if(show){
    		document.getElementById(targetDiv).style.display="none";   		
    	}else{
    		document.getElementById(targetDiv).style.display="";
    	}
    	
    }
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" name="access" id="access" method="post">
<input type="hidden" name="isView" value="<%=String.valueOf(isView)%>" >
<jsp:include page="../../tabs.jsp" />
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" bgcolor="#C0C0C0" bordercolor="#875546" style="border: 1 solid #875546">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
                <tr>
                <td colspan="2" nowrap><span class="PAGEHEADER">New Data Source </span></td>
                <td width="50%" >&nbsp;</td>
              </tr>
              <tr>
                <td width="8">&nbsp;</td>
                <td width="423">&nbsp;</td>
                <td width="456">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" valign="top">
                &nbsp;</td>
                <td width="100%" colspan="2" valign="top">
                <span class="HEADER">General</span>
                </td>
              </tr>
              <tr>
                <td width="3%" valign="top">
                </td>
                <td width="600" colspan="2" valign="top">
                <table border="0"  cellspacing="1" cellpadding="0">
                  <tr>
                    <td width="10%" nowrap><span class="REGULARTEXT">Name</span></td>
                    <%
                      String dsName = request.getParameter("dsName");
                      if (dsName == null || dsName.trim().length() == 0){
                        dsName = builder.getAtomicParadigm().getName();
                      }
                      if(dsName == null){
                        dsName = "";
                      }
                      
                      String dsDesc = request.getParameter("dsDesc");
                      if (dsDesc == null || dsDesc.trim().length() == 0){
                        dsDesc = builder.getAtomicParadigm().getDescription();
                      }
                      if(dsDesc == null){
                        dsDesc = "";
                      }
                    %>
                    <td width="35%"><input type="text" name="dsName" size="23" value="<%=dsName%>"></td>
                    <td width="*"></td>
                  </tr>
                  <tr>
                    <td width="10%" nowrap><span class="REGULARTEXT">Description</span></td>
                    <td width="35%"><input type="text" name="dsDesc" size="50" value="<%=dsDesc%>"></td>
                    <td width="*"></td>
                  </tr>
                 </table>
                 </td>
               </tr>
               <tr>
                <td colspan=3>&nbsp;</td>
              </tr>
               <tr>
                <td width="3%" valign="top">
                </td>
                <td width="100%" colspan="2" valign="top">
                <span class="HEADER"><a href="javascript:shownHideAdv('metaDataDiv')">+/- Application Definition</a></span>
                </td>
              </tr>
              <tr ><td width="3" valign="top" >
                </td>
                <td width="100%" colspan="1" valign="top" >    
                <div id="metaDataDiv"  style="display:none">    
                    <%
                       
                       Properties prop = builder.getMetaDataProperties();
                       
                    %>         
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      <tr>
                        <td colspan="2">
                          <span class="SMALLTEXT">Please define the application properties: </span>
                        </td>
                      </tr>
                      <% for (int i = 0; i < metaDataKeys.length; i++){ 
                        
                      %>
                      <tr style="padding-left:10">
                        <td width="250"><input type="checkBox" name="<%=metaDataKeys[i]%>Chk" value="on" <%=prop.getProperty(metaDataKeys[i]) == null?"":"checked"%>><span class="REGULARTEXT"><%=metaDataKeys[i]%></span></td>
                        <td width="*">
                        <input class="TEXTBOX" type="text" name="<%=metaDataKeys[i]%>Txt" size="20" value="<%=prop.getProperty(metaDataKeys[i]) == null?"" : prop.getProperty(metaDataKeys[i])%>"></td>
                      </tr>                                   
                      <%}%> 
                    </table>
                     </div>
                    </td>
                  </tr>
               
               <tr>
                <td colspan=3>&nbsp;</td>
              </tr> 
              <tr>
                <td width="8" >&nbsp;</td>
                <td colspan="2" width="881">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Text from the XML file</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><span class="SMALLTEXT">The first log
                      element from the XML log file you specified.</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18">
                    <textarea class="TEXTBOX" rows="20" name="logLines" id="logLines" wrap="off" cols="115" style="font-size: 8pt"><%=recordString%></textarea></td>
                  </tr>
                  <tr>
                    <td>
                      <table border="0" width="700" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="30%"></td>
                          <td width="41%"><a href="javascript:reanalyzeXMLCode()" class="SMALLLINK">reanalyze
                            XML code</a></td>
                          <td width="34%"></td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td><span class="HEADER">XML schema definition</span></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">Here you need to specify for each field
                      type and name according to the XML code above<br>
                      If there are missing elements or attributes please add
                      them to the structure above and click on </span><a href="javascript:reanalyzeXMLCode()" class="SMALLLINK">reanalyze
                            XML code</a></td>
                  </tr>
                  <tr>
                    <td>
                        <table border="1" width="700">
                          <tr>
                            <td width="10">&nbsp;</td>
                            <td width="150"><span class="REGULARTEXT">Tag Name</span></td>
                            <td width="150"><span class="REGULARTEXT">Attribute</span></td>
                            <td width="200"><span class="REGULARTEXT">Value - XpoLog
                              pattern</span></td>
                            <td width="270"><span class="REGULARTEXT">condition</span></td>
                            <td width="20"><span class="REGULARTEXT">Ignore</span></td>
                            <td width="100"><span class="REGULARTEXT">Unique</span></td>
                          </tr>
                          <% for (int i = 0; i < builder.getElementsPatternInfoCount(); i++) {
                               UIXMLDataSourceBuilder.LogicPatternElementInfo info = builder.getLogicElementPatternInfoAt(i);
                          %>

                            <tr>
                            <td width="10"><span class="REGULARTEXT"><%=String.valueOf(i + 1)%>.</span></td>
                            <td width="150"><span class="REGULARTEXT"><%=info.getTagName()%></span></td>
                            <td width="150"><span class="REGULARTEXT"><%=info.getPropertyKey() == null ?"&nbsp;" : info.getPropertyKey()%></span></td>
                            <td width="200"><span class="REGULARTEXT"><input class="TEXTBOX"  type="text" name="elemPattern_<%=i%>" size="30" value="<%=info.getXpologPattern()%>"></span></td>
                            <td width="200" ><nobr><font size="2">
                             <% XMLLogBrowserBuilder.AttributeInfo [] attributes = info.getAttributes();
                                if (attributes.length > 0){
                                  Properties condProp = info.getConditionParameters();
                                  %>

                                 <select size="1" name="conditionCombo<%=i%>" id="conditionCombo_<%=i%>" onChange="javascript:changeAttribute(this,<%=i%>)">
                          <%
                            String selected = "";
                            boolean hasCondition = condProp != null && condProp.size() > 0;
                            selected = !hasCondition? "selected=\"true\"" : "";
                            String value = "";
                            %>
                             <option class="TEXTBOX" value="noSelect" <%=selected%> >No Selected</option>
                            <%
                            for(int j=0;j<attributes.length;++j){
                              if(hasCondition && condProp.getProperty(attributes[j].key) != null){
                                selected = "selected=\"true\"";
                                value = attributes[j].value;
                              }else{
                                selected = "";
                              }
                            %>
                            <option class="TEXTBOX" value="<%=attributes[j].key%>" <%=selected%>><%=attributes[j].key%></option>
                          <%}%>

                             </select>
                            &nbsp;=&nbsp;<input class="TEXTBOX" type="text" name="conditionValue_<%=i%>" size="10" value="<%=value%>">
                            <% } else { %>
                                  &nbsp;
                             <% } %>
                            </nobr></td>
                            <td width="20"><input type="checkbox" name="ignore_<%=i%>"  <%=!info.isSelected()?"checked" : ""%>></td>
                            <td width="100"><nobr><input type="checkbox" name="uniqueUse_<%=i%>" <%=info.isUniqueSelected()?"checked" : ""%>>  &nbsp; <span class="REGULARTEXT"><input class="TEXTBOX"  type="text" name="uniqueValue_<%=i%>" size="20" value="<%=info.isUniqueSelected()? info.getUniqueValue() : info.getValue()%>"></span></nobr></td>
                          </tr>

                          <% } %>




                        </table>
                    </td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td>
                      <table border="0" width="602" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="260">&nbsp;</td>
                          <td width="138"><a href="javascript:verifySchema()" class="LINK">verify
                            schema</a></td>
                          <td width="76"></td>
                          <td width="118"></td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td><span class="HEADER">Pattern verification status</span></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">Analysis result of the log lines with the
                      data pattern</span></td>
                  </tr>
                  <tr>
                    <td>

                      <span class="REGULARTEXT">Log analysis verification -</span>
                        <%if(patternOk){%>
                            <span class="OKMESSAGE">ok</span>
                        <%}else{%>
                            <span class="ERRORMESSAGE">error:
                          <%=errorPattern%></span>
                        <%}%>

                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td><span class="HEADER">Log records analysis result&nbsp;&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">Here you can see the log view after the xml log was
                      analyzed the schema</span></td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td><%=html%></td>
                  </tr>
                  <tr>
                    <td>&nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="892" id="AutoNumber17">
                      <tr>
                        <td width="164">&nbsp;</td>
                        <td width="90">
                        <p align="center"><a href="dataSourceAdmin.jsp" class="LINK">cancel</a></td>
                        <td width="94">
                          <% if(!isView) {%>
                          <p align="left"><a href="javascript:doSave()" class="LINK">Save</a></p>
                          <%}%>
                        </td>
                        <td width="443">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
     
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>