<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.logic.brain.*"%>
<%@ page import="xpolog.logic.filters.*"%>
<%
  String ERROR_OBJ = "ERROR_OBJ"; 
  String OP = "OP";
  String ADD = "ADD";
  String DUPLICATE = "DUPLICATE";

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  
  String atomicId = request.getParameter("atomicId");
  UserSecurity user = manager.getUserSecurity(request);
  DataFilterManager dfm = BrainConfigurationRepository.getRepository().getDataFilterManager();
  FilterCollection[] filters = null;
  
  if (atomicId != null){
	filters = dfm.getDataFiltersForAtomic(atomicId);
	if (filters == null){
		filters = new FilterCollection[0];
	}
 	Arrays.sort(filters,new Comparator(){
		public int compare(Object o1 ,Object o2){
			FilterCollection filter1 = (FilterCollection)o1;
			FilterCollection filter2 = (FilterCollection)o2;
			return filter1.getName().compareTo(filter2.getName());
		}
	});
  }
  
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link rel="stylesheet" type="text/css" href="/logeye/css/mainproduct.css" />
<script>
	function editFilter(id){
		document.access.data_filter_id.value = id;
		document.access.submit();
	}

	function deleteFilter(id){
		document.deleteFilter.data_filter_id.value = id;
		document.deleteFilter.submit();
	}
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" action="/logeye/logic/online/TransactionFilter.jsp">
<jsp:include page="/logeye/logic/tabs.jsp" />
<input type="hidden" name="data_filter_id">
<input type="hidden" name="ds_id" value="<%=atomicId%>">
<input type="hidden" name="url" value="<%=request.getRequestURL()+"?atomicId="+atomicId%>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" bgcolor="#C0C0C0" bordercolor="#875546" style="border: 1 solid #875546">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td colspan="2" nowrap><span class="PAGEHEADER">Data Sources Filters Administration </span></td>
                <td width="50%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>              
              <tr>
                <td width="3%" valign="top">
                &nbsp;</td>
                <td width="147%" colspan="2" valign="top">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td><span class="HEADER">Data Filters List</span></td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td ><a href="javascript:editFilter(0)" class="LINK">add new</a></td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr class="TABLES_HEADERS">
                        <td width="15%"><span class="REGULARTEXT">Name</span></td>
                        <td width="30%"><span class="REGULARTEXT">Description</span></td>
                        <td width="35%" class="REGULARTEXT">&nbsp;</td>
                      </tr>
                      <%
											for (int i = 0; i < filters.length; i++) {
											   String id = filters[i].getId();						  
                      %>
                      <tr>
                        <td width="15%" class="REGULARTEXT" nowrap><a href="javascript:editFilter(<%=id%>)" class="LINK"><%=filters[i].getName()%></a></td>
                        <td width="30%" class="REGULARTEXT">&nbsp;</td>
                        <td width="35%" class="SMALLTEXT" nowrap><a href="javascript:editFilter(<%=id%>)" class="LINK">edit</a>&nbsp;
                                                                   <a href="javascript:deleteFilter(<%=id%>)" class="LINK">delete</a></td>
                      </tr>
                      <%
                      	}
                      %>
                      <tr>
                        <td width="15%" class="SMALLTEXT">&nbsp;</td>
                        <td width="30%" class="SMALLTEXT">&nbsp;</td>
                        <td width="35%" class="SMALLTEXT">&nbsp;</td>
                      </tr>
                    </table>
                   </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
           
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="35%">&nbsp;</td>
                    <td width="11%" align="center">&nbsp;</td>
                    <td width="7%" align="center">
                     &nbsp;</td>
                                          <td width="27%">&nbsp;</td>
                    <td width="20%">&nbsp;</td>
                  </tr>
                </table>
              
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
<form name="deleteFilter" action="/logeye/logic/online/TransFilterAction.jsp">
	<input type="hidden" name="data_filter_id">
	<input type="hidden" name="OP" value="REMOVE">
	<input type="hidden" name="ds_id" value="<%=atomicId%>">
	<input type="hidden" name="url" value="<%=request.getRequestURL()+"?atomicId="+atomicId%>">
</form>
</body>

</html>