<%@ page language="java"%>

<%@ page import="xpolog.logic.ui.conf.XpoLogicInitiator"%>
<%@ page import="xpolog.logic.atomic.data.*"%>
<%@ page import="xpolog.logic.brain.*"%>
<%@ page import="xpolog.logic.routine.data.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="java.util.*"%>
<%
  String ERROR_OBJ = "ERROR_OBJ";

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  UserSecurity security = manager.getUserSecurity(request);

  String atomicId = request.getParameter("atomicId");

  XpoLogAtomicParadigm atomicParadigm = (XpoLogAtomicParadigm)XpoLogicInitiator.getInstance().getAtomicConfigManager().getParadigmById(atomicId);
  if(atomicParadigm == null){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("No data source for id " + atomicId);
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect("/logeye/common/errorpage.jsp?cancelURL=logic/admin/adminboard.jsp");
    return;
  }
  String name = atomicParadigm.getName();
  
  RoutineParadigm [] routines = BrainConfigurationRepository.getRepository().getRoutineParadigmsByAtomicId(atomicId);
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="/logeye/css/mainproduct.css" />
<script>
  function operationOk(){
    var path ="removeDataSource.jsp?atomicId=<%=atomicId%>";
    document.location = path;
  }
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
  <!--    <tr>
        <td valign="top" style="border-left: 1px solid #FF9900; border-right-width: 1; border-top-width: 1; border-bottom-width: 1" height="1">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="TOPLEFTBORDER" width="33%"  height="2"></td>
            <td class="TOPBORDER" width="33%" height="2"></td>
            <td class="TOPRIGHTBORDER"  width="34%" height="2"></td>
          </tr>
        </table>
        </td>
      </tr>-->
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Operation verification.</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">General</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="22">
                    <span class="REGULARTEXT">
                    <%if(routines.length == 0){%>
                    Are you sure you want to remove data source - <%=name%>
                    <%} else {%>
                    Data source cann't be removed - <%=name%>. <br><br>
                    All transactions which use this data source should be deleted.
                    <% } %>
                    </span>
                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="35%">&nbsp;</td>
                <td width="11%" align="center"><a href='javascript:history.go(-1)' class="LINK">cancel</a></td>
                <%if (routines.length == 0){%>
                <td width="7%" align="center"><a href='javascript:operationOk()' class="LINK">
                ok</a></td>
                <%}%>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>