<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";

%>

<%
final UserContext userContext = UserEnvironment.getUserContext(request);

  String ERROR_OBJ = "ERROR_OBJ";
	

  String sessionId = request.getParameter("sessionId");
  if (sessionId == null){
    sessionId = "";
  }

  ErrorModel errmodel = new ErrorModel();
	
  if(sessionId == null || sessionId.trim().equals("")){
    errmodel.addError("No session was supplied.");
  }

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/admin/session/sessionsDefinitionView.jsp");
    return;
  }

  final CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
  final DataSession dataSession = ctrlMgr.getDataSessionById(sessionId);
  final String workspaceId = dataSession == null ? "" : dataSession.getParentWorkspaceId();
  final String sessId = sessionId;
 
  String name = "";
  if(dataSession != null) {
	  name = dataSession.getName();
  }
  //    audit
    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
       			userContext, AuditConstants.CHANGE, "remove project", AuditConstants.PROJECT, "remove project " + name);

  
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "logic/admin/common/opok.jsp?doRefresh=true&okUrl=logic/admin/session/sessionsDefinitionView.jsp?workspaceId=" + workspaceId) {
    public void run(HttpServletRequest request){    	
     boolean suc = false;
      try {   
      	Thread.sleep(500);
       suc = ctrlMgr.removeDataSession(sessId,userContext);
     }catch (Exception e){
       e.printStackTrace();
     }
     if (!suc){
      errmodel.addError("A problem occured while removing session.");
      createErrorRedirect(request, BASE_DIRECTORY);
      setRedirectUrl(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/admin/session/sessionsDefinitionView.jsp?workspaceId=" + workspaceId);      
     }  

    }
  };
  env.setProgressRunner(runner);
%>

<jsp:include page="../../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Deleting Project"/>
 <jsp:param name="useStatus" value="false"/>
</jsp:include>

