<%@ page language="java" %>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.common.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.logic.exe.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="java.text.*"%>

<%!
  static final double KB = 1024;
  static final double MB = 1024*KB;
  static final double GB = 1024*MB;
  
  static double [] sizes = {1,KB,MB,GB};
  static String [] sizesStr = {"","K","M","G"};  
  
   static DecimalFormat format = new DecimalFormat();
   static {
     format.setMaximumFractionDigits(2);
   }
  

  static String getSize(long size){
  if (size == 0 ) return "0";
    String result = "";
    double dSize = (double)size;
    for (int i=sizes.length; --i >= 0;){
      if (dSize > sizes[i]){
        double tmp = dSize / sizes[i];
        if (tmp > 1){
          result = format.format(tmp);
          result += sizesStr[i];
          break;
        }
      }
    }
    return result;
  }
%>

<%

  String ERROR_OBJ = "ERROR_OBJ";
	String seqNum = request.getParameter("seqNum");
        String num = seqNum ; 
	
	if (seqNum == null){
		seqNum = "";		
	}else{
		seqNum = "_"+seqNum;
	}
	String exeHandlerId = request.getParameter("exeHandlerId");
  ExecutionManager execman = ExecutionManager.getInstance();
	ExecutionHandler exeHandler = execman.getExecutionHandler(exeHandlerId);

  String progressStr = "";
  String title = "";
  String timeStr = "";
  int progressValue = 0;
  
	
	String currentStatus = exeHandler == null ? LogicEngine.COMPLETE : "";
	JobStatus engineJobStatus = exeHandler != null ? exeHandler.getEngineStatus() : null;
	if (engineJobStatus != null){
		currentStatus = engineJobStatus.getCurrentStatus();
	  if (engineJobStatus.getTotalSize() > 1){
	    currentStatus = "<nobr>" + currentStatus +  " (" + engineJobStatus.getPosition() + "/" + engineJobStatus.getTotalSize() + ")" + "</nobr>";
	  }
	}
	
  int percent = 0;
  if (currentStatus == LogicEngine.COMPLETE){
	  percent = 100;	  
	}else {
	  JobStatus progressJobStatus = exeHandler != null ? exeHandler.getEngine().getProgressBar() : null;
			if (progressJobStatus != null){
			  percent = (int)progressJobStatus.getPrecentPosition();
			  long currentSize = progressJobStatus.getPosition();
			  long totalSize = progressJobStatus.getTotalSize();
			  timeStr = "" + getSize(currentSize) + " / " + getSize(totalSize);
	
			}
	}
  
	progressValue =  percent / 10;
%>

<html>
<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
</head>
<body bgcolor="#FFFFFF">
<script>
  if (parent){
    var frm = parent.getProgressFrame();
    if (frm){
      frm.setprogress("p_240dc7<%=seqNum%>_",<%=String.valueOf(progressValue)%>,"<%=timeStr%>",0);
      frm.setProgressTitle("p_240dc7<%=seqNum%>_","<%=title%>");
      //frm.setProgressTime("p_240dc7<%=seqNum%>_","<%=timeStr%>");
      //parent.setTimeout("goProgress()", 1000);
    }
    <%if(num != null && currentStatus != null){%>
      parent.updateStatus(<%=num%>,"<%=currentStatus%>");
    <%}%>
  }
</script>
</body>
</html>