<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.brain.*"%>
<%@ page import="xpolog.logic.exe.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.atomic.data.*" %>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";

String dateFormat = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat", "MM/dd/yyyy HH:mm:ss");
String msSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator", ".");
String dateFormatMS = dateFormat + msSeperator + "SSS";
String timeFormat = "HH:mm:ss";

  
public String transformDateToString(Date d, long timeDiff) {
	if (d == null) {
		return null;
	}
	if (timeDiff != 0) {
		long time = d.getTime();
		d = ((Date) d.clone());
		d.setTime(time + timeDiff);
	}
	//01/31/2003 01:42:34
	String format = "";
	if (d.getTime() % 1000 == 0) {
		format = dateFormat;
	} else {
		format = dateFormatMS;
	}
	String str = new SimpleDateFormat(format).format(d);
	return str;
}
%>
<%
  String DATE_FILTER = "DateFilter";
  String DATE_MIN_FILTER_ACTIVE = "DateMinFilterActive";
  String DATE_MAX_FILTER_ACTIVE = "DateMaxFilterActive";
  String DATE_MIN_FILTER_ACTIVE_PARAM = "DATE_MIN_FILTER_ACTIVE_PARAM";
  String DATE_MAX_FILTER_ACTIVE_PARAM = "DATE_MAX_FILTER_ACTIVE_PARAM";
  String DATE_MINIMUM = "DateMinimum";
  String DATE_MAXIMUM = "DateMaximum";
  String DATE_FILTER_MINIMUM_PARAM = "DATE_FILTER_MINIMUM_PARAM";
  String DATE_FILTER_MAXIMUM_PARAM = "DATE_FILTER_MAXIMUM_PARAM";
  String NUMBER_FILTER = "NumberFilter";
  
  String ERROR_OBJ = "ERROR_OBJ";

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  UserSecurity user = manager.getUserSecurity(request);
  
  String sessionId = request.getParameter("sessionId");
  if (sessionId == null){
     sessionId = "";
  }
  CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();  
  
  DataSession dataSession = ctrlMgr.getDataSessionById(sessionId);  
  FilterCollection fc = null; 
  DateFilter datefl = new DateFilter();
	datefl.setColIndex(0);

  String sessionName = dataSession.getName();
  String sessionDesc = dataSession.getDescription();


  Date minDate = null;
	Date maxDate = null;
	String minDateStr = "";
	String maxDateStr = "";
	String minStat = "";
	String maxStat = "";
	String timeunit = "";
	String isTimeLim = "";
	String daystatsel1 = "";
	String minstatsel1 = "";
	String hourstatsel1 = "";
	String monthstatsel2 = "";
	String weekstatsel2 = "";
	String daystatsel2 = "";
	String daystatsel3 = "selected";
	String hourstatsel3 = "";
	String istoday = "";
	String islast = "";
	String isprevious = "";
	String isfrom = "";
	String selectedIndex = "1";
	long timeDiff = 0;
	String fromlastdaysat = "";
	String timeWindowSize = "";
	String dayswindowsizesel = "";
	String hourswindowsizesel = "";
	long hoursToKeep = 0;
	String isDatesLimit = "";
	
  BrainConfigurationRepository rep = BrainConfigurationRepository.getRepository();
  
  String [] transactions = ctrlMgr.getTransactionParadigmForSessionPradigm(sessionId);
  if (transactions == null){
     transactions = new String[0];
  }
  UITransactionParadigmBuilder builder = new UITransactionParadigmBuilder();
  ErrorModel ermo = new ErrorModel();
  HashSet set = new HashSet();
  LinkedList list = new LinkedList();
	  for (int i=0; i<transactions.length; i++){
	  	String transId = transactions[i];
	  	builder.loadTransactionGraph(transId);
	  	TransactionParadigm tp = builder.getTransactionParadigm();
	  	if (tp == null){
	  		ermo.addError("Failed to load transaction (id="+transId+")");
	  		continue;
	  	}
			XpoLogAtomicParadigm[] unusable = UITransactionParadigmHelper.checkTransationParadigmValidity(builder);
			if (unusable != null && unusable.length > 0){
				list.add("Transaction "+tp.getName()+" has definition problems");
		    list.add("The are problems with the following data sources:");
		    for (int u=0; i<unusable.length; i++){
		    	String lbmId = (unusable[i] == null || unusable[i].getDateSource() == null) ? "N/A" : unusable[u].getDateSource().getLbmId();
		    	String nodeId = (unusable[i] == null || unusable[i].getDateSource() == null) ? null : unusable[u].getDateSource().getNodeId();
		    	StringBuffer message = new StringBuffer();
		    	message.append("Log Id: "+lbmId);
		    	if (nodeId!=null&&nodeId.length()>0 ){
		    		message.append("(XpoLog Node Id: "+nodeId+". Check that remote node is up and that the remote log is accessible)");
		    	}
		    	set.add(message.toString());
		    }
			}
	    Iterator it = list.iterator();
	    while(it.hasNext()){
	    	String m = (String)it.next();
	    	ermo.addError(m);
	    }
	    it = set.iterator();
	    while(it.hasNext()){
	    	String m = (String)it.next();
	    	ermo.addError(m);
	    }
	  }	
	if (ermo.getErrorCount() > 0){
    request.getSession().setAttribute(ERROR_OBJ,ermo);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
	}

		LogicExecutionPolicy logicExePolicy = dataSession.getLogicExePolicy();
		FilterCollection sessionFilterCollection = (FilterCollection)session.getAttribute("sessionFilterCollection");
		if (logicExePolicy != null || sessionFilterCollection != null) {//check where to close it
			if(logicExePolicy != null) {
				fc = logicExePolicy.getCombineStartEndRule();
			}else {
				fc = sessionFilterCollection;
			}
			if (fc != null && fc.getByName(DATE_FILTER) != null
					&& fc.getByName(DATE_FILTER).size() > 0) {
				datefl = (DateFilter) fc.getByName(DATE_FILTER).get(0);
				if (datefl.getTimeType() == -1) {
					minDate = datefl.getMinDate();
					maxDate = datefl.getMaxDate();
				} else if (datefl.getTimeOpType() == 1) {
					isTimeLim = "checked";
					islast = "selected";
					selectedIndex = "1";
					timeunit = String.valueOf(datefl.getTimeGap());
					if (datefl.isDays()) {
						daystatsel1 = "selected";
						if (datefl.getTimeGap() == 0) {
							istoday = "selected";
							selectedIndex = "0";
						}
					} else if (datefl.isHours()) {
						hourstatsel1 = "selected";
					} else {
						minstatsel1 = "selected";
					}
				} else if (datefl.getTimeOpType() == 2) {
					selectedIndex = "2";
					isTimeLim = "checked";
					isprevious = "selected";
					timeunit = String.valueOf(datefl.getTimeGap());
					if (datefl.isDays()) {
						daystatsel2 = "selected";
					} else if (datefl.isWeeks()) {
						weekstatsel2 = "selected";
					} else if (datefl.isMonths()) {
						monthstatsel2 = "selected";
					}
				} else if (datefl.getTimeOpType() == 3) {

					selectedIndex = "3";
					isTimeLim = "checked";
					isfrom = "selected";
					timeunit = String.valueOf(datefl.getTimeGap());
					if (datefl.isDays()) {
						daystatsel3 = "selected";
						hourstatsel3 = "";
					} else if (datefl.isMonths()) {
						hourstatsel3 = "selected";
					}
				}

			}

			Date at = new Date(datefl.getFromGap());
			SimpleDateFormat simpleFormat = new SimpleDateFormat(timeFormat);
			simpleFormat.setTimeZone(TimeZone.getTimeZone("GMT"));
			fromlastdaysat = simpleFormat.format(at);
		}//check if this is where should be closed
		
		long windowSize = 0;
		if (datefl.getTimeWindowSize() == 0
				|| datefl.getTimeWindowSize() % (24 * 60 * 60 * 100) == 0) {
			windowSize = datefl.getTimeWindowSize() / (24 * 60 * 60 * 1000);
			dayswindowsizesel = "selected";
		} else {
			windowSize = datefl.getTimeWindowSize() / (60 * 60 * 1000);
			hourswindowsizesel = "selected";
		}
		timeWindowSize = String.valueOf(windowSize);

		long minTimeDiff = timeDiff;
		if (minDate == null) {
			minDate = new Date();
			long t = minDate.getTime();
			minDate.setTime(t - (t % 1000));
			minTimeDiff = 0;
		} else {
			isDatesLimit = "checked";
			minStat = "checked";
		}

		long maxTimeDiff = timeDiff;
		if (maxDate == null) {
			maxDate = new Date();
			long t = maxDate.getTime();
			maxDate.setTime(t - (t % 1000));
			maxTimeDiff = 0;
		} else {
			isDatesLimit = "checked";
			maxStat = "checked";
		}
		minDateStr = transformDateToString(minDate, minTimeDiff);
		maxDateStr = transformDateToString(maxDate, maxTimeDiff);
		//or here}
 
%>
<html>

<head>
  <meta http-equiv="Content-Language" content="en-us">
  <META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
  <META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
  <META HTTP-EQUIV="EXPIRES" CONTENT="0">
  
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script>
	function doCreate(){
  		updateTimeParams();
		document.access.action="sessionRuntimeAction.jsp";
		document.access.submit();
	}

	function shownHidediv(targetDiv){
	 var d = document.getElementById(targetDiv);
	 if (!d){
	   return;
	  }      
	  show = d.style.display == "";
	  if(show){
	    d.style.display="none";   		
	  }else{
	    d.style.display="";
	  }
	    	
	}
	
	var selectedIndex = <%=selectedIndex%>;
	
	function changeTimeType(combo){
	  shownHidediv("timeType" + selectedIndex + "Div");
	  var index = combo.selectedIndex;
	  if (index >= 0){ 
	    selectedIndex = index+1;
	    shownHidediv("timeType" + selectedIndex + "Div");
	  }
	  showFromInfo();
	}
	
	function showFromInfo(){
		if (selectedIndex == 3){
			if (document.access.TimeUnit3.selectedIndex == 1){
				document.getElementById("fromLastDaysAtDiv").style.display = "";
			}
			document.getElementById("timeWindowSizeDiv").style.display = "";
		}else{
			document.getElementById("fromLastDaysAtDiv").style.display = "none";
			document.getElementById("timeWindowSizeDiv").style.display = "none";
		}
	}
	
	function updateTimeParams(){
		if (selectedIndex == 0){
			document.access.TimeUnit.value = "days";
			document.access.TimeText.value = "0";
		}else{
			document.access.TimeUnit.value = eval("document.access.TimeUnit"+selectedIndex).value;
			document.access.TimeText.value = eval("document.access.TimeText"+selectedIndex).value;
		}
		
		if (selectedIndex == 1){
			document.access.TimeOpType.value = "1";
		}else if (selectedIndex == 2){
			document.access.TimeOpType.value = "2";
		}else {
			document.access.TimeOpType.value = "3";
		}
	}

  function checkDate(date_check_box, date_obj){
  	date_ok = "";
  	obj_name = date_check_box.name;
  	frames['dateValidationFrame'].location = "<%=BASE_DIRECTORY%>calendar/dateValidation.jsp?dateStr="+date_obj.value+"&date_check_box="+obj_name;
  }

</script>
<title></title>
</head>
<!-- American format mm/dd/yyyy -->
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/calendar/calendar2.js"></script><!-- Date only with year scrolling -->



<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<input type="hidden" name="sessionId" value="<%=sessionId%>">
<input type="hidden" name="TimeUnit">
<input type="hidden" name="TimeText">
<input type="hidden" name="TimeOpType">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%" height="100%" valign="top">
    	<table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      		<tr>
        		<td valign="top" height="84%">
        			<table border="0" cellpadding="0" cellspacing="0" class="LOGICGENERAL" width="100%" >
				 <tr>
                		   <td colspan="3" nowrap><span class="PAGEHEADER">Result Set Definition</span></td>
              			</tr>          			
				<tr><td colspan="3">&nbsp;</td></tr>
				
              			<tr>
				<td width="3%" valign="top">&nbsp;</td>
                		<td width="*" colspan="2">
                                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
				     <tr><td width="*"  valign="top" ><span class="HEADER">General</span></td></tr>
                                      <tr>
                                        <td ><font size="1">&nbsp;</font></td>
                                      </tr>
				     <tr><td  width="100%">
				      <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td width="100"><span class="REGULARTEXT">Name: </span></td>
					<td width="*"><span class="REGULARTEXT"><%=sessionName%></span></td>
                                      </tr>
                                      <tr><td colspan="2">&nbsp;</td></tr>
				      <tr>
                                        <td width="100"><span class="REGULARTEXT">Description: </span></td>
					<td width="*"><span class="REGULARTEXT"><%=sessionDesc%></span></td>
                                      </tr>
				      </table>
				      </td></tr>
                                      <tr><td >&nbsp;</td></tr>
                                     <tr>
								<td width="*" valign="top"><span class="HEADER"><a
									href="javascript:shownHidediv('filtersDiv')">+/- Filters</a></span></td>
							</tr>

							<tr>
								<td width="100%" valign="top">
								<div id="filtersDiv">


								<table border="0" width="800" cellspacing="0" cellpadding="0">
									<tr>
										<td width="100%" colspan="2">&nbsp;</td>
									</tr>
									<tr>
										<td width="20"><input type="radio" id="allData" checked
											name="Dates" value=""></td>
										<td width="100%"><span class="REGULARTEXT">Run on all data</span></td>
									</tr>
									<tr>
										<td valign="middle" width="20">&nbsp;</td>
										<td valign="top" width="100%"><font size="1">&nbsp;</font></td>
									</tr>									
									<tr>
										<td width="20"><input type="radio" id="TimeLimRadio" name="Dates" value="TimeLimRadio" <%=isDatesLimit%>></td>
										<td width="100%"><span class="REGULARTEXT">Dates limit</span></td>
									</tr>
									<tr>
										<td width="20">&nbsp;<iframe name="dateValidationFrame"
											style="visibility:hidden" width="0" height="0"></iframe></td>
										<td width="100%">
										<table border="0" width="100%">
											<tr>
												<td width="20" valign="bottom"><input class="SMALLTEXT"
													type="checkbox" name="<%=DATE_MIN_FILTER_ACTIVE%>"
													<%=minStat%>></td>
												<td width="60%"><span class="SMALLTEXT">Show records that
												arrive <b>after</b>&nbsp;</span> <input class="TEXTBOX"
													type="text" size="25"
													onChange="javascript:checkDate(document.access.<%=DATE_MIN_FILTER_ACTIVE%>,document.access.<%=DATE_MINIMUM%>)"
													name="<%=DATE_MINIMUM%>" value="<%=minDateStr%>"
													style="font-size: 8pt"
													onclick="document.access.TimeLimRadio.checked='true'">&nbsp;<a
													href="javascript:openCal7();"
													onclick="document.access.TimeLimRadio.checked='true'"
													class="SMALLLINK">calendar</a></td>
												<td nowrap valign="middle"><span class="SMALLTEXT"
													style="height:1">(<%=dateFormat%>, <%=dateFormatMS%>)</td>
											</tr>
											<tr>
												<td width="20" valign="bottom"><input class="SMALLTEXT"
													type="checkbox" name="<%=DATE_MAX_FILTER_ACTIVE%>"
													<%=maxStat%>></td>
												<td width="60%"><span class="SMALLTEXT">Show records that
												arrive <b>before</b>&nbsp;</span> <input class="TEXTBOX"
													type="text" size="25"
													onChange="javascript:checkDate(document.access.<%=DATE_MAX_FILTER_ACTIVE%>,document.access.<%=DATE_MAXIMUM%>)"
													name="<%=DATE_MAXIMUM%>" value="<%=maxDateStr%>"
													style="font-size: 8pt"
													onclick="document.access.TimeLimRadio.checked='true'">&nbsp;<a
													href="javascript:openCal8();"
													onclick="document.access.TimeLimRadio.checked='true'"
													class="SMALLLINK">calendar</a></td>
												<td nowrap valign="middle"><span class="SMALLTEXT">(<%=dateFormat%>,
												<%=dateFormatMS%>)</td>
											</tr>
										</table>
										</td>
									</tr>
									<tr>
										<td valign="middle" width="20">&nbsp;</td>
										<td valign="top" width="100%"><font size="1">&nbsp;</font></td>
									</tr>
									<tr>
										<td width="20"><input type="radio" id="TimeUnitRadio"
											name="Dates" <%=isTimeLim%> value="TimeUnitRadio"></td>
										<td width="100%">
										<table border="0" width="100%">
											<tr>
												<td width="100"><nobr> <span class="REGULARTEXT">Analysis time limits</span>
												 <select class="TEXTBOX" size="1"
													name="TimeType"
													onfocus="document.access.TimeUnitRadio.checked=true"
													onchange="javascript:changeTimeType(this)"
													style="font-size: 8pt">
													<option value="1" <%=islast%>>from the last</option>
													<option value="2" <%=isprevious%>>from the previous</option>
													<option value="3" <%=isfrom%>>from</option>
												</select></nobr></td>
												<td width="130">
												<div id="timeType1Div"
													<%=(datefl.getTimeOpType() == 1)?"":"style=\"display:none\""%>>
												<input class="TEXTBOX" type="text" name="TimeText1" size="3"
													value="<%=timeunit%>"
													onfocus="document.access.TimeUnitRadio.checked=true"
													style="font-size: 8pt"> <select class="TEXTBOX" size="1"
													name="TimeUnit1"
													onfocus="document.access.TimeUnitRadio.checked=true"
													style="font-size: 8pt">
													<option value="minutes" <%=minstatsel1%>>minutes</option>
													<option value="hours" <%=hourstatsel1%>>hours</option>
													<option value="days" <%=daystatsel1%>>days</option>
												</select></div>
												<div id="timeType2Div"
													<%=(datefl.getTimeOpType() == 2)?"":"style=\"display:none\""%>>
												<input class="TEXTBOX" type="text" name="TimeText2" size="3"
													value="<%=timeunit%>"
													onfocus="document.access.TimeUnitRadio.checked=true"
													style="font-size: 8pt"> <select class="TEXTBOX" size="1"
													name="TimeUnit2"
													onfocus="document.access.TimeUnitRadio.checked=true"
													style="font-size: 8pt">
													<option value="days" <%=daystatsel2%>>days</option>
													<option value="weeks" <%=weekstatsel2%>>weeks</option>
													<option value="months" <%=monthstatsel2%>>months</option>
												</select></div>
												<div id="timeType3Div"
													<%=(datefl.getTimeOpType() == 3)?"":"style=\"display:none\""%>>
												<input class="TEXTBOX" type="text" name="TimeText3" size="3"
													value="<%=timeunit%>"
													onfocus="document.access.TimeUnitRadio.checked=true"
													style="font-size: 8pt"> <select class="TEXTBOX" size="1"
													name="TimeUnit3"
													onfocus="document.access.TimeUnitRadio.checked=true"
													onchange="javascript:showFromInfo()" style="font-size: 8pt">
													<option value="hours" <%=hourstatsel3%>>hours</option>
													<option value="days" <%=daystatsel3%>>days</option>
												</select> <span class="SMALLTEXT"> ago </span></div>
												</td>
												<td>
												<div id="fromLastDaysAtDiv"
													<%=(datefl.getTimeOpType() == 3)?"":"style=\"display:none\""%>>
												<span class="SMALLTEXT">at</span> <input class="TEXTBOX"
													type="text" name="fromLastDaysAt" size="8"
													value="<%=fromlastdaysat%>"
													onfocus="document.access.TimeUnitRadio.checked=true"
													style="font-size: 8pt"> <span class="SMALLTEXT"><span
													class="SMALLTEXT" style="height:1">(<%=timeFormat%>)</span></div>
												</td>
												<td align="left">
												<div id="timeWindowSizeDiv"
													<%=(datefl.getTimeOpType() == 3)?"":"style=\"display:none\""%>>
												<span class="SMALLTEXT">for</span> <input class="TEXTBOX"
													type="text" name="TimeWindowText" size="3"
													value="<%=timeWindowSize%>"
													onfocus="document.access.TimeUnitRadio.checked=true"
													style="font-size: 8pt"> <select class="TEXTBOX" size="1"
													name="TimeWindowUnit"
													onfocus="document.access.TimeUnitRadio.checked=true"
													onchange="javascript:showFromInfo()" style="font-size: 8pt">
													<option value="hours" <%=hourswindowsizesel%>>hours</option>
													<option value="days" <%=dayswindowsizesel%>>days</option>
												</select></div>
												</td>
												<td>&nbsp;</td>
											</tr>
										</table>
										</td>
									</tr>

								</table>
								</div>
								</td>
							</tr>
							<tr>
								<td>&nbsp;</td>
							</tr>
					  <tr><td width="*"   valign="top"><span class="HEADER">Transactions</span></td></tr>
				      <tr><td width="100%" >&nbsp;</td></tr>
				      <tr><td >
					<table border="0" width="100%" cellspacing="0" cellpadding="0">
					  <%for (int i = 0; i < transactions.length;i++){
						TransactionParadigm paradigm = rep.getTransactionParadigmById(transactions[i]);
						if (paradigm == null) continue;
					 %>
					    <tr><td>
					      <span class="REGULARTEXT">&nbsp;<%=paradigm.getName()%></span>
					    </td></tr>
					  <%}%>
					</table>
				      </td></tr>	
	
                                      <tr>
                                        <td width="100%" >
                                          <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                            <tr>
                                              <td width="33%">&nbsp;</td>
                                              <td width="33%">
                                                <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                                  <tr>
                                                    <td width="33%"><a href="javascript:doCreate()" class="LINK">run</a></td>
                                                    <td width="33%"><a href="sessionView.jsp?sessionId=<%=sessionId%>" class="LINK">cancel</td>
                                                    <td width="34%">&nbsp;</td>
                                                  </tr>
                                                </table>
                                              </td>
                                              <td width="34%">&nbsp;</td>
                                            </tr>
                                          </table>
                                        </td>
                                      </tr>
                                    </table>
                                  </td>
              					</tr>
              					
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
    </table>
</form>
<script language="JavaScript">
		<!-- // create calendar object(s) just after form tag closed
			 // note: you can have as many calendar objects as you need for your application
			var cal7 = new calendar2("<%=BASE_DIRECTORY%>",document.access.<%=DATE_MINIMUM%>,null,<%="/^\\-?\\d+(\\"+msSeperator+"\\d+)*$/"%>,"<%=msSeperator%>");
			cal7.year_scroll = true;
			cal7.time_comp = true;
			var cal8 = new calendar2("<%=BASE_DIRECTORY%>",document.access.<%=DATE_MAXIMUM%>,null,<%="/^\\-?\\d+(\\"+msSeperator+"\\d+)*$/"%>,"<%=msSeperator%>");
			cal8.year_scroll = true;
			cal8.time_comp = true;

			function openCal7(){
				document.access.<%=DATE_MIN_FILTER_ACTIVE%>.checked='true';
				cal7.popup();
			}
			function openCal8(){
				document.access.<%=DATE_MAX_FILTER_ACTIVE%>.checked='true';
				cal8.popup();
			}


		//-->
		</script>

</table>
</body>

