<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.common.*"%>
<%@ page import="xpolog.logic.exe.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";

  String dateFormat = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
  String msSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator",".");
  String dateFormatMS = dateFormat+msSeperator+"SSS";

  public String transformDateToString(Date d,long timeDiff){
    if(d == null){
      return null;
    }
    if (timeDiff != 0){
       long time = d.getTime();
    	 d = ((Date)d.clone());
    	 d.setTime(time + timeDiff); 
    }
    //01/31/2003 01:42:34
    String format = "";
    if (d.getTime() % 1000 == 0){
	    format = dateFormat;
    } else {
	    format = dateFormatMS;
    }
    String str = new SimpleDateFormat(format).format(d);
    return str;
  }
%>


<%
  //constants
  String ERROR_OBJ = "ERROR_OBJ";

  //site management
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);  	
  SiteManagment mgmt = SiteManagment.getInstance();
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);

  String sessionId = request.getParameter("sessionId");
  if (sessionId == null){
    sessionId = "";
  }
  
  ExecutionManager execman = ExecutionManager.getInstance();
  ExecutionHandler[] exehandlers = execman.getAllExecutionHandlers(env,true);
  if (exehandlers == null || exehandlers.length == 0){
    response.sendRedirect(BASE_DIRECTORY + "logic/admin/session/sessionView.jsp?sessionId=" + sessionId + "&refreshMenu=true");
    return;
  }
  String[] statuses = new String[exehandlers.length];
  for (int i=0; i<exehandlers.length; i++){
  	statuses[i] = exehandlers[i].getStatus().getCurrentStatus();
  	if (statuses[i] == null) statuses[i] = "";
  }
	
  //appropriate messages
  String runMessage = "<span class=REGULARTEXT>To <b>run indexing</b>, please check the logs you would like to run indexing on, and click run</span>";
  String stopMessage = "<span class=REGULARTEXT>To <b>stop indexing</b>, click stop</span><br><span class=SMALLTEXT>Note: by clicking stop - all the log which have an 'In Progress' status will be stopped being indexed</span>";
	
  String refreshMenuStr = request.getParameter("refreshMenu");
  boolean refreshMenu = refreshMenuStr != null && refreshMenuStr.equals("true");
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/progressBar.css" />

<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/progressBar.js" type="text/javascript"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script>

var currentHandlerSeqNum = 0;

function run(){
  document.access.submit();
}

function refresh(){
  this.location = this.location;
}

function refreshStatus(){
  frames['statusFrame'].document.location = frames['statusFrame'].document.location;
}

function updateStaus0(){
  var message = frames['statusFrame'].msg;
  if (message){
    document.getElementById("statusMsg").innerHTML = "Status: " + message;
    setTimeout('refreshStatus()',2000); 
  }else {
    refresh();
  }
}

function updateExecutionStatus(i,id){
	var fname = 'funcsFrame'+i;
  if (frames[fname]){
    frames[fname].location = "sessionExecutionStatus.jsp?seqNum="+i+"&exeHandlerId="+id;
  }
}

function getProgressFrame(){
  return self;
}

function resumeExecution(i,id){
	var fname = 'funcsFrame'+i;
  if (frames[fname]){
    frames[fname].location = "sessionExecutionAction.jsp?seqNum="+i+"&exeHandlerId="+id+"&OP=<%=LogicEngine.RESUME%>";
  }
}

function pauseExecution(i,id){
	var fname = 'funcsFrame'+i;
  if (frames[fname]){
    frames[fname].location = "sessionExecutionAction.jsp?seqNum="+i+"&exeHandlerId="+id+"&OP=<%=LogicEngine.PAUSE%>";
  }
}

function cancelExecution(i,id){
	var fname = 'funcsFrame'+i;
  if (frames[fname]){
    frames[fname].location = "sessionExecutionAction.jsp?seqNum="+i+"&exeHandlerId="+id+"&OP=<%=LogicEngine.CANCEL%>";
  }
}

function updateStatus(i,stat){
	elem = document.getElementById("CurrentStatus"+i);
	if (elem){
		elem.innerHTML = stat;
		if (stat == "<%=LogicEngine.PAUSED%>"){
			document.getElementById("pause"+i).style.display = "none";
			document.getElementById("resume"+i).style.display = "";
		}else if (stat == "<%=LogicEngine.RUNNING%>"){
			//document.getElementById("pause"+i).style.display = "";
			//document.getElementById("resume"+i).style.display = "none";
		}else if (stat == "<%=LogicEngine.CANCELED%>" || stat == "<%=LogicEngine.COMPLETE%>"){
		  var str = "sessionRuntimeStatus.jsp?sessionId=<%=sessionId%>";
		  if (stat == "<%=LogicEngine.COMPLETE%>"){
		    str += "&refreshMenu=true";
		  }
			window.location = str;
		}
	}
}

function init(){
		<%if (refreshMenu){%>
			refreshMenus();
		<%}%>
	}
</script>
</head>
<body onload="javascript:init()">
<!--<iframe name="statusFrame" style="visibility:hidden" onload="javascript:updateStaus();" src="sessionExecutionStatus.jsp" width="0" height="0"></iframe>-->

<form AUTOCOMPLETE="OFF" id="access" name="access" METHOD="POST" ACTION="searchEngineIndexingAction.jsp">
<input type="hidden" name="op" value="">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
              <tr>
                <td width="2%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="58%" class="TOPBORDER" height="0">
                <span class="PAGEHEADER">Result Sets execution statuses</span> </td>
                <td width="40%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr><td>&nbsp;</td></tr>
              <tr><td >
              <td width="100%"><span class="REGULARTEXT">The following processes are currently running in background.<br>Go to <a href="<%=BASE_DIRECTORY%>/logic/logicPortal.jsp" class="LINK">TransactionExpo Home</a> to continue.</span></td>
              </td></tr>
              <tr><td>&nbsp;</td></tr>
              <tr>
                <td width="2%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="97%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                	<tr>
                		<td width="150"><span class="HEADER">Result Set</span></td>
                		<td width="200"><span class="HEADER">Start time</span></td>
                		<td width="70"><span class="HEADER">Status</span></td>
                		<td width="*">&nbsp;</td>
                		<td width="50">&nbsp;</td>
                		<td width="50">&nbsp;</td>
                	</tr>
                	<tr><td colspan="6">&nbsp;</td></tr>
                	<%
                	if (exehandlers.length > 0){
	                	for (int i=0; i<exehandlers.length; i++){
		                		ExecutionHandler handler = exehandlers[i];
		                		String hid = handler.getId();
		                		DataSession dataSession = handler.getSessionParadigm();
		                		long startTime = handler.getStartTime();
		                		String startTimeStr = transformDateToString(new Date(startTime),0);
		                		JobStatus execStatus = handler.getStatus();
		                		String currStatus = handler.getEngineStatus().getCurrentStatus();
		                	%>
		                	<tr>
		                		<td width="100"><span class="REGULARTEXT"><%=dataSession.getName()%></span></td>
		                		<td width="200"><span class="REGULARTEXT"><nobr><%=startTimeStr%></nobr></span></td>
		                		<td width="70"><span id="CurrentStatus<%=i%>" class="REGULARTEXT"><%=currStatus%></span></td>
		                		<td width="*">&nbsp;
												<%String progressBarUrl = xpolog.eye.util.WebUtil.getURLWithPrefix("common/multipleProgressBar.jsp");%>
												<iframe name="funcsFrame<%=i%>"  style="visibility:hidden" width="0%" height="0%"  ></iframe>
												<!--<iframe name="funcsFrame<%=i%>"  width="500" height="400"  ></iframe>-->
												<jsp:include page="<%=progressBarUrl%>" flush="true">
												  <jsp:param name="seqNum" value="<%=i%>"/>
												  <jsp:param name="baseDir" value="<%=BASE_DIRECTORY%>"/>
												  <jsp:param name="ignoreProgressTime" value="true"/>
												</jsp:include>
												</td>
		                		<td width="70">
		                		<!--
		                			<div id="pause<%=i%>" <%=(currStatus.equals(LogicEngine.PAUSED)||currStatus.equals(LogicEngine.CANCELED))?"style=\"display:none\"":""%>><a class="LINK" href="javascript:pauseExecution('<%=i%>','<%=hid%>')">pause</a></div>
			                		<div id="resume<%=i%>" <%=(currStatus.equals(LogicEngine.RUNNING)||currStatus.equals(LogicEngine.CANCELED))?"style=\"display:none\"":""%>><a class="LINK" href="javascript:resumeExecution('<%=i%>','<%=hid%>')">resume</a></div>
			                		-->
		                		</td>
		                		<td width="70"><a class="LINK" href="javascript:cancelExecution('<%=i%>','<%=hid%>')">stop</a></td>
		                	</tr>
	                	<%}
	                	} else {%>
	                		<tr><td colspan="6" class="REGULARTEXT">No results sets are currently running</td></tr>
  	              	<%}%> 
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="30%">&nbsp;</td>
            <td width="31%" align="center">
              <table border="0" width="109%">
                <tr>             
                  <td align="center"><a href=javascript:openHelp('<%=BASE_DIRECTORY%>',"About.htm") class="LINK">help</a></td>
                </tr>
              </table>
            </td>
            <td width="39%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>

</form>

<script>
	goProgress();
	window.setInterval("goProgress()",5000);

	function goProgress(){
	  <%for (int i=0; i < exehandlers.length; i++){%>		
		updateExecutionStatus(<%=i%>,"<%=exehandlers[i].getId()%>");
		<%}%>
	}
	
</script>

</body>
</html>