<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.logic.data.mapping.mq.*"%>
<%@ page import="com.ibm.mq.*;"%>

<%

	String ERROR_OBJ = "ERROR_OBJ";
	
	ErrorModel errmodel = new ErrorModel();
	
	String queueManagerName = request.getParameter("queueManagerName");
	String queueName = request.getParameter("queueName");
	String ccsidStr = request.getParameter("ccsid");
	int ccsid = 862;
	String type = request.getParameter("type");
	String channelName = request.getParameter("channelName");
	String host = request.getParameter("host");
	String portStr = request.getParameter("port");
	int port = 1414;
	
	if(queueManagerName == null || queueManagerName.trim().equals("")){
      errmodel.addError("No Queue manager name was supplied.");
    }
    
    if(queueName == null || queueName.trim().equals("")){
      errmodel.addError("No Queue name was supplied.");
    }
    
    if(ccsidStr == null || ccsidStr.trim().equals("")){
      errmodel.addError("No Coded Character Set ID was supplied.");
    }else {
	  try {
	    ccsid = Integer.parseInt(ccsidStr);
	  }catch (Exception e){
	    errmodel.addError("Coded Character Set ID must be a number.");
	  }    	  
	}
	
	if (type.equals("tcp")){
		if(channelName == null || channelName.trim().equals("")){
      		errmodel.addError("No Channel name was supplied.");
    	}
    	
    	if(host == null || host.trim().equals("")){
      		errmodel.addError("No Host was supplied.");
    	}
    	
    	if(portStr == null || portStr.trim().equals("")){
      		errmodel.addError("No Port was supplied.");
    	}else {
    	  try {
    	    port = Integer.parseInt(portStr);
    	  }catch (Exception e){
    	    errmodel.addError("Port must be a number.");
    	  }    	  
    	}
	}
	
	if(errmodel.getErrorCount() != 0){
      request.getSession().setAttribute(ERROR_OBJ,errmodel);
      response.sendRedirect("/logeye/common/errorpage.jsp?cancelURL=logic/admin/adminboard.jsp");
      return;
    }
    
    MQConfiguration mqSettings = new MQConfiguration();
    mqSettings.setQueueManagerName(queueManagerName);
    mqSettings.setQueueName(queueName);
    mqSettings.setCcsid(ccsid);
    mqSettings.setType(type);
    mqSettings.setChannelName(channelName);
    mqSettings.setHost(host);
    mqSettings.setPort(port);
    
    
    try {
      MQSample sample = new MQSample(mqSettings);
      sample.initMQMgr();
    }catch (MQException mqExc){
      String error = "Connection to MQ Failed from the following reason: ";
      error += MQUtil.getErrorMessage(mqExc);	  
	  errmodel.addError(error);
    }catch (Exception e){
      errmodel.addError(e.getMessage());
    }
    if(errmodel.getErrorCount() != 0){
      request.getSession().setAttribute(ERROR_OBJ,errmodel);
      response.sendRedirect("/logeye/common/errorpage.jsp?cancelURL=/logeye/logic/admin/adminboard.jsp");
      return;
    }
    MQDataSourceAdmin.saveMQXMLLinearDataSource(mqSettings);
   
     
%>

<html>
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="/logeye/css/mainproduct.css" />
<body>

<form AUTOCOMPLETE="OFF" id="access" name="access">
<jsp:include page="/logeye/logic/tabs.jsp" />
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" bgcolor="#C0C0C0" bordercolor="#875546">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">              
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">General</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="22">
                    <span class="REGULARTEXT">Saving operation ended successfully.</span>
                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" valign="bottom">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="150" id="AutoNumber7">
              <tr>
                <td width="15%">&nbsp;</td>
                <td width="11%" align="center">&nbsp;</td>
                <td width="150" align="center"><nobr>
                <a href="MQSettings.jsp" class="LINK">ok</a>               
                </nobr></td>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>