<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>


<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.db.admin.*"%>
<%@ page import="xpolog.logic.ui.admin.system.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.logic.ConfigMgr"%>

<%!
	static final String BASE_DIRECTORY = "../../../";

%>

<%
	UserContext userContext = UserEnvironment.getUserContext(request);

  final String ERROR_OBJ = "ERROR_OBJ";
	String op = request.getParameter("op");
	XpoDriversManager xpoDriversMgr = XpoDriversManager.getInstance();
	String accBuilderName = request.getParameter("accountBuilderName");
	if (accBuilderName == null || accBuilderName.length() == 0){
		accBuilderName = "AccountBuilder";
	}
	final String accountBuilderName = accBuilderName;
	String createStr = request.getParameter("doCreate");
	String buildStr = request.getParameter("doBuild");
	String initStr = request.getParameter("doInit");
	String resetStr = request.getParameter("doReset");
	String optimizeStr = request.getParameter("doOptimize");
	String clearDataStr = request.getParameter("clearData");
	String clearConfigurationStr = request.getParameter("clearConfiguration");
	final boolean createDb = (createStr != null && createStr.equals("true"));
	final boolean buildDb = (buildStr != null && buildStr.equals("true"));
	final boolean initDb = (initStr != null && initStr.equals("true"));
	final boolean resetDb = (resetStr != null && resetStr.equals("true"));
	final boolean optimizeDb = (optimizeStr != null && optimizeStr.equals("true"));
	final boolean clearData = (clearDataStr != null && clearDataStr.equals("true"));
	final boolean clearConfiguration = (clearConfigurationStr != null && clearConfigurationStr.equals("true"));
	String statusMsg = createDb ? "Creating database" : "Connecting to database";

  final DBAccountBuilder builder = (DBAccountBuilder)request.getSession().getAttribute(accountBuilderName);
  if (builder == null){
		String url = "logic/logicPortal.jsp";
    response.sendRedirect(BASE_DIRECTORY + url);
    return;
  }
  
  
	//    audit
	if (createDb){
    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
       			userContext, AuditConstants.CHANGE, "create database", AuditConstants.CONFIGURATION, "create database");
	}
	if (buildDb){
    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
       			userContext, AuditConstants.CHANGE, "build database", AuditConstants.CONFIGURATION, "build database");
	}
	if (initDb){
    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
       			userContext, AuditConstants.CHANGE, "init database", AuditConstants.CONFIGURATION, "init database ");
	}

	final ConfigMgr configMgr = ConfigMgr.getInstance();
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "logic/admin/settings/dbSettings.jsp?refreshMenu=true") {
		public void run(HttpServletRequest request){
			List executionMessages = null;
			try {   
				LogicCreatorManager creatorMgr = LogicCreatorManager.getInstance();
				executionMessages = creatorMgr.createTxExpoDb(builder,resetDb,createDb,buildDb,initDb,optimizeDb,clearData,clearConfiguration);
				request.getSession().removeAttribute(accountBuilderName);
			}catch (Exception e){
				e.printStackTrace();
			}
			if (executionMessages != null && !executionMessages.isEmpty()){
				errmodel.addError("A problem occured while creating Transaction Expo Database.");
				
				for (int i=0; i<executionMessages.size(); i++){
					errmodel.addError((String)executionMessages.get(i));
				}
		    request.getSession().setAttribute(ERROR_OBJ,errmodel);
				setRedirectUrl(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/logicPortal.jsp&okURL=logic/logicPortal.jsp");      
			}  
		}
  };
  env.setProgressRunner(runner);
%>

<jsp:include page="../../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="<%=statusMsg%>"/>
 <jsp:param name="useStatus" value="false"/>
</jsp:include>


