<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.media.AddressBook"%>
<%@ page import="xpolog.eye.media.Account"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.logic.ui.admin.system.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.logic.security.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!
  static final String BASE_DIRECTORY = "../../../";
  String dateFormat = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
  String millisecondsSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator",".");
  String dateFormatMS = dateFormat+millisecondsSeperator+"SSS";

  public String transformDateToString(Date d){
    if(d == null){
      return null;
    }
    String format = "";
    if (d.getTime() % 1000 == 0){
	    format = dateFormat;
    } else {
	    format = dateFormatMS;
    }
    String str = new SimpleDateFormat(format).format(d);
    return str;
  }
%>
<%
  String ERROR_OBJ = "ERROR_OBJ";
  ErrorModel errmodel = new ErrorModel();
  
  AddressBook adbook = AddressBook.getInstance();
  Account acc = adbook.getAccountById("xpologicDB");

  WebSecurityManager manager = WebSecurityManager.getInstance();
	if (acc != null && !manager.checkForPermission(request,response,LogicPermissionConstants.SettingsPermissions.DB_SETTINGS_PERMISSION,true)){
	  return;
	}else if (!manager.checkForPermission(request,response,LogicPermissionConstants.SettingsPermissions.DB_SETTINGS_PERMISSION,false)){
		errmodel.addError("No TxExpo account is defined");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?okURL=logEyePortal.jsp");
	}
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  LogicCreatorManager mgr = LogicCreatorManager.getInstance();
  long dateL = mgr.getLastExecutionDate();
  String date = transformDateToString(new Date(dateL));
  String stat = mgr.getLastExecutionStatus();
  List messages = mgr.getLastErrorMessages();
  
	String txDbType = request.getParameter("TxDbType");
	String txOnlineDbType = request.getParameter("TxOnlineDbType");
	if (txDbType == null) txDbType = "";
	if (txOnlineDbType == null) txOnlineDbType = "";
	
	String selectedTabId = request.getParameter("selectedTabId");
	if (selectedTabId == null || selectedTabId.length() == 0){
		selectedTabId = "0";
	}
  String refreshMenu = request.getParameter("refreshMenu");
	String showAdvancedLinksStr = xpolog.config.Configuration.getInstance().getPropertiesManager().getProperty("logic.ui.admin.settings.showAdvancedLinks","false");
  boolean showAdvancedLinks = showAdvancedLinksStr != null && showAdvancedLinksStr.equals("true");
	
	
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script src="<%=BASE_DIRECTORY%>scripts/comps/divsTabs.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script>
	var verifyingDb = "false";
  function refreshView(tabId){
		dbType = document.dbSelection.DbType.options[document.dbSelection.DbType.selectedIndex].value;
		onlineDbType = document.onlineDbSelection.OnlineDbType.options[document.onlineDbSelection.OnlineDbType.selectedIndex].value;
		document.access.TxDbType.value=dbType;
		document.access.TxOnlineDbType.value=onlineDbType;
		document.access.selectedTabId.value=tabId;
		document.access.submit();
  }
  
  function checkConnection(formName){
  	f = eval("document."+formName);
  	if (formName == "dbSelection" && document.dbSelection.DbType.selectedIndex == 0){
  		alert("database type not selected");
  		return;
  	}
  	if (formName == "onlineDbSelection" && document.onlineDbSelection.OnlineDbType.selectedIndex == 0){
  		alert("database type not selected");
  		return;
  	}
  	url = "verifyConnection.jsp?";
	  url = url + "Type=" + f.Type.value;
		if (f.Name) url = url + "&Name=" + f.Name.value;
		if (f.Description) url = url + "&Description=" + f.Description.value;
		if (f.DriverName) url = url + "&DriverName=" + f.DriverName.value;
		if (f.UserName) url = url + "&UserName=" + f.UserName.value;
		if (f.Password) url = url + "&Password=" + f.Password.value;
		if (f.DBName) url = url + "&DBName=" + f.DBName.value;
		if (f.MachineAddress) url = url + "&MachineAddress=" + f.MachineAddress.value;
		if (f.Port) url = url + "&Port=" + f.Port.value;
		if (f.extraInfo) url = url + "&extraInfo=" + f.extraInfo.value;
		if (f.dataSourceName) url = url + "&dataSourceName=" + f.dataSourceName.value;
		if (f.DBType) url = url + "&DBType=" + f.DBType.value;
		if (f.envPath) url = url + "&envPath=" + f.envPath.value;
		if (f.ConnectionString) url = url + "&ConnectionString=" + f.ConnectionString.value;
		url = url + "&formName=" + formName;
  	//alert(url);
  	frames['connectionResultFrame'].location = url;
  }

	function showConnectionStatus(divid,msg){
		div = "connectionStatusDiv" + divid;
		obj = document.getElementById("connectionStatus"+divid);
		if (obj){
			obj.innerHTML = "<span class=\"REGULARTEXT\">" + msg + "</span>";
		}
		showHideLayerInMiddle(div,-1,180);
		if (divid == '1' && msg.indexOf("Failed to load driver") != -1){
			document.getElementById("upload").style.display = "";
		}
		frames['connectionResultFrame'].location = "";
	}
	
	function onlySetAccount(){
		formName = "dbSelection";
		if (applicationTabs.selectedTabIndex == 1){
			formName = "onlineDbSelection";
		}
		f = eval("document."+formName);
		if (f){
			f.doCreate.value = "false";
			f.doBuild.value = "false";
			f.doInit.value = "false";
		}
		hideLayer('connectionStatusDiv2');
		createDb(formName);
	}
  
	function resetDb(){
		formName = "dbSelection";
		if (applicationTabs.selectedTabIndex == 1){
			formName = "onlineDbSelection";
		}
		f = eval("document."+formName);
		if (f){
			f.doReset.value = "true";
			f.doCreate.value = "true";
			f.doBuild.value = "true";
			f.doInit.value = "true";
		}
		hideLayer('connectionStatusDiv2');
		createDb(formName);
	}
  
  function createDb(formName){
  	if (!formName || formName == ""){
			if (applicationTabs.selectedTabIndex == 0){
				formName = "dbSelection";
			}
			else{
				formName = "onlineDbSelection";
			} 	
		}
  	f = eval("document."+formName);
  	if (f.ConnectionString){
  		f.action = "<%=BASE_DIRECTORY%>tools/addresses/db/other/accountDbAction.jsp";
  	}else{
  		f.action = "<%=BASE_DIRECTORY%>tools/addresses/db/general/accountDbAction.jsp";
  	}
  	if (f.actionUrl){
	  	f.action = "<%=BASE_DIRECTORY%>" + f.actionUrl.value;
	  }
	  create = f.doCreate.value;
	  build = f.doBuild.value;
	  init = f.doInit.value;
	  reset = f.doReset.value;
	  f.forwardUrl.value = f.forwardUrl.value + "&doReset="+reset+"&doCreate="+create+"&doBuild="+build+"&doInit="+init;
	  frames['connectionResultFrame'].location = "";
	  f.submit();
  }
  
  function clearData(){
		formName = "dbSelection";
		if (applicationTabs.selectedTabIndex == 1){
			formName = "onlineDbSelection";
		}
  	f = eval("document."+formName);
  	f.action = "<%=BASE_DIRECTORY%>tools/addresses/db/general/accountDbAction.jsp";
  	if (f.actionUrl){
	  	f.action = "<%=BASE_DIRECTORY%>" + f.actionUrl.value;
	  }
	  f.forwardUrl.value = f.forwardUrl.value + "&doReset=false&doCreate=false&doBuild=false&doInit=false&clearData=true&clearConfiguration=false";
	  frames['connectionResultFrame'].location = "";
	  f.submit();
  }
  
  function clearConfiguration(){
		formName = "dbSelection";
		if (applicationTabs.selectedTabIndex == 1){
			formName = "onlineDbSelection";
		}
  	f = eval("document."+formName);
  	f.action = "<%=BASE_DIRECTORY%>tools/addresses/db/general/accountDbAction.jsp";
  	if (f.actionUrl){
	  	f.action = "<%=BASE_DIRECTORY%>" + f.actionUrl.value;
	  }
	  f.forwardUrl.value = f.forwardUrl.value + "&doReset=false&doCreate=false&doBuild=false&doInit=false&clearData=false&clearConfiguration=true";
	  frames['connectionResultFrame'].location = "";
	  f.submit();
  }
  
  function go(formName,status,msg){
  	//status 1=ok, 2=no connection, 3=already exists
  	if (status == 1){
  		showConnectionStatus("3","Database does not exist. Create?");
  	}else if (status == 2){
  		showConnectionStatus("1",msg);
  	}else if (status == 3){
  		showConnectionStatus("2","Database already exists");
  	}
  	
  }
  
	function doRefresh(){		
		<%
		if(refreshMenu != null && refreshMenu.length()>0) {
		%>			
			refreshMenus();
		<%}%>
	}
	
	function goToDbList(){
		document.location = "<%=BASE_DIRECTORY%>tools/addresses/db/listOfDB.jsp";
	}
	
</script>
</head>

<body onload="javascript:doRefresh()">
<iframe name="connectionResultFrame" style="visibility:hidden" width="0" height="0" border="0"></iframe>
<form AUTOCOMPLETE="OFF" name="access" id="access" method="post" action="dbSettings.jsp">
<input type="hidden" name="TxDbType">
<input type="hidden" name="TxOnlineDbType">
<input type="hidden" name="selectedTabId">
</form>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="90%" class="TOPBORDER">
                <span class="PAGEHEADER">TxExpo Database settings</span></td>
                <td width="9%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">                
                <script>
                  var applicationTabs = createDefaultApplicationTabs("dbSettingsTabs");
                  applicationTabs.addTab("Logs","<nobr>TxExpo Db</nobr>","txExpoDiv");
                  applicationTabs.addTab("verifiers","<nobr>TxExpo Online Db</nobr>","txExpoOnlineDiv");
                </script>     
						      <%if (XpologLicenseManager.getInstance().isDemo()) {%>
                  <tr>
				            <td>
				              <span class="LICENSEMESSAGE"><nobr>Database settings are not available in trial version</nobr></span>
				            </td>
						      </tr>
						      <tr><td>&nbsp;</td></tr>
						      <%} %>
                  <tr>
                    <td width="100%">  
                    <script>
                    	tabsInLine = 8;
                    	applicationTabs.writeTabs();
                    </script> 
                   </td>
                  </tr>  
                  <tr>
                    <td width="100%" >   
                      <div id="txExpoDiv" style="display:none">
                     		<jsp:include page="dbSelection.jsp" flush="true">
                     		<jsp:param name="Type" value="<%=txDbType%>" />
                     		</jsp:include>
											</div>
                      <div id="txExpoOnlineDiv" style="display:none">
                     		<jsp:include page="dbSelection.jsp" flush="true">
                     		<jsp:param name="Online" value="true" />
                     		<jsp:param name="Type" value="<%=txOnlineDbType%>" />
                     		</jsp:include>
	                    </div>
                    </td>
                    </tr>
                  <tr>
                    <td height="100%">&nbsp;</td>
                  </tr>
                   <script>        
                  applicationTabs.selectTabByIndex(<%=selectedTabId%>);
                  </script>
                  <tr>
                    <td>
                    </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>

<div id="connectionStatusDiv1" style="position:absolute;visibility:hidden;height:80">
	<table border="0" width="350" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
		<tr height="10">
			<td align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
				<span class="PROGRESSTEXT">Connection status</span>
			</td>
		</tr>
		<tr>
			<td align="center" id="connectionStatus1">&nbsp;</td>
		</tr>
		<tr height="20">
			<td align="center" style="padding:5">
				<nobr>
				<a class="PROGRESSLINK" href="javascript:hideLayer('connectionStatusDiv1');">cancel</a>&nbsp;
				<a id="upload" style="display:none" class="PROGRESSLINK" href="javascript:goToDbList();">load driver</a>&nbsp;
				</nobr>
			</td>
		</tr>
	</table>
</div>

<div id="connectionStatusDiv2" style="position:absolute;visibility:hidden;height:80">
	<table border="0" width="450" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
		<tr height="10">
			<td align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
				<span class="PROGRESSTEXT">Connection status</span>
			</td>
		</tr>
		<tr>
			<td align="center"><span class="REGULARTEXT">Database already exists</span></td>
		</tr>
		<tr height="20">
			<td align="center" style="padding:5">
				<a class="PROGRESSLINK" href="javascript:hideLayer('connectionStatusDiv2');">cancel</a>&nbsp;
				<a class="PROGRESSLINK" href="javascript:onlySetAccount();">connect to existing database</a>&nbsp;
				<a class="PROGRESSLINK" href="javascript:resetDb();">recreate and connect</a>&nbsp;
				<%if (showAdvancedLinks){ %>
				<a class="PROGRESSLINK" href="javascript:clearData();">clear data</a>&nbsp;
				<a class="PROGRESSLINK" href="javascript:clearConfiguration();">clear configuration</a>&nbsp;
				<%}%>
			</td>
		</tr>
	</table>
</div>

<div id="connectionStatusDiv3" style="position:absolute;visibility:hidden;height:80">
	<table border="0" width="350" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
		<tr height="10">
			<td align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
				<span class="PROGRESSTEXT">Connection status</span>
			</td>
		</tr>
		<tr>
			<td align="center"><span class="REGULARTEXT">Database does not exist. Create it?</span></td>
		</tr>
		<tr height="20">
			<td align="center" style="padding:5">
				<a class="PROGRESSLINK" href="javascript:hideLayer('connectionStatusDiv3');">no</a>&nbsp;
				<a class="PROGRESSLINK" href="javascript:createDb();">yes</a>&nbsp;
			</td>
		</tr>
	</table>
</div>

</body>

</html>