<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="xpolog.eye.media.db.admin.*"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>
<%@ page import="xpolog.logic.ui.admin.system.*"%>

<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
	String Name, Description, DriverName, userName, password, dbName, machineAddress, port, ConnectionString, Id, extraInfo, dataSourceName, dbType, envPath;

	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	DriverName = request.getParameter("DriverName");
	userName = request.getParameter("UserName");
	password = request.getParameter("Password");
	dbName = request.getParameter("DBName");
	machineAddress = request.getParameter("MachineAddress");
	port = request.getParameter("Port");
	ConnectionString = request.getParameter("ConnectionString");
	Id = request.getParameter("Id");
	extraInfo = request.getParameter("extraInfo");
	String type = request.getParameter("Type");
	dataSourceName = request.getParameter("dataSourceName");
	dbType = request.getParameter("DBType");
	envPath = request.getParameter("envPath");
	String formName = request.getParameter("formName");
	

	String useDbNameStr = request.getParameter("useDbName");
	boolean useDbName = useDbNameStr != null && useDbNameStr.equals("true");

	XpoDriversManager driverMgr = XpoDriversManager.getInstance();
 	XpoDriverInfo driverInfo = driverMgr.getDriverById(type);
 	DBAccountBuilder builder =  DBAccountBuilderFactory.createDBAccountBuilder(driverInfo);

	if (Name != null){
  	builder.setXpoName(Name);
  }
	if (Description != null){
  	builder.setXpoDesc(Description);
  }
  
  if (DriverName != null){
  	builder.setDbDriverName(DriverName);
  }
  if (extraInfo != null){
  	builder.setExtraInfo(extraInfo);
  }
  
  if (machineAddress != null){
  	builder.setHost(machineAddress);
  }
  if (port != null){
  	builder.setPort(port);
  }
  if (dbName != null){
  	builder.setDbName(dbName);
  }
  if (userName != null){
  	builder.setUserName(userName);
  }
  if (password != null){
  	builder.setPassword(password);
  }
  if (dataSourceName != null){
		builder.setDataSourceName(dataSourceName);
  }
  if (dbType != null){
		builder.setDatabaseType(dbType);
  }
  if (envPath != null){
		builder.setDataSourceEnvPath(envPath);
  }
  if (ConnectionString != null){
  	builder.setConnectionString(ConnectionString);
  }


  LogicCreatorManager creatorMgr = LogicCreatorManager.getInstance();
  boolean hasCreateScript = creatorMgr.hasCreateDbScript(type.equals("datasource") ? dbType : type);
  if (hasCreateScript){
  	builder.setDbName("");
  }
  DBAccount acc = builder.updateDbAccount();
 	
	boolean verify = false;
	boolean alreadyExists = false;
  String msg = "Connection ok";
  int status = 0;
  Media med = null;
  try{
	  if (acc != null){
	  	med = MediaManager.newInstace().getMediaByAccount(acc);
		  if (med instanceof AbstractMedia){
		    ((AbstractMedia)med).setLogEnabled(false);
		  }
		  verify = med.verify(acc);
		  if (!verify){
			  status = 2;
		    msg = med.getLastErrorMessage();
		    if (msg != null && msg.length() > 0){
					msg = "Connection failed from the following reason:" + msg;
		    }else {
		    	msg = "Connection failed";
		    }
		  }else{
			  status = 1;
		  	builder.setDbName(dbName);
		  	acc = builder.updateDbAccount();
		  	if (hasCreateScript){
			  	alreadyExists = med.verify(acc);
		  	}else{
		  		alreadyExists = LogicCreatorManager.getInstance().getTxExpoConnectionStatus(acc);
		  	}
		  	if (alreadyExists){
		  		status = 3;
		  	}
		  }
		}
  }finally{
  	if (med != null){
		  med.close();
  	}
  }
  
  msg = XpologUtil.replaceAll(msg,"\"","&quot;");
%>

<html>

<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
</head>

<body>
<script>
	if (parent){
		parent.go("<%=formName%>",<%=status%>,"<%=msg%>");
	}
</script>
</body>

</html>