<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.logic.security.*"%>
<%@ page import="xpolog.eye.merge.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.SearchEngineAdminHelper"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.data.index.*"%>
<%@ page import="xpolog.eye.data.index.adapters.*"%>
<%@ page import="xpolog.eye.data.index.adapters.defaultadapter.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.helpers.SearchEngineAdminHelper"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.data.index.*"%>
<%@ page import="xpolog.eye.data.index.adapters.*"%>
<%@ page import="xpolog.eye.data.index.adapters.defaultadapter.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.cloud.*"%>

<%@ page import="java.util.*"%>
<%!static final String BASE_DIRECTORY = "../../../";

	//tree issues
	String getTreeDiv(Module node, UserContext userContext, HashMap modules,HashMap logs) {
		ArrayList list = new ArrayList();
		StringBuffer buffer = new StringBuffer();
		if (modules == null) {
			modules = new HashMap();
			getModulesFromLogs(node ,modules, logs);
		}

		if (node != null) {
			boolean selected = modules == null
					|| modules.containsKey(node.getId());
			String treeKey = "node" + node.getId() + "_0";
			String chkKey = node.getId().equals(Module.ROOT_MODULE_ID) ? "root"
					: "modules";
			buffer.append("\nvar " + treeKey + " = tree.addNode(tree.root,\""
					+ chkKey + "\",\"" + node.getId() + "\",\""
					+ node.getName() + "\",\"" + node.getDescription()
					+ "\",''," + selected + ",true);");
			addChildsNodeDiv(node, buffer, treeKey, userContext, modules, logs);
		}
		return buffer.toString();
	}

	void addChildsNodeDiv(ModuleMember node, StringBuffer buffer,
			String parentKey, UserContext userContext, HashMap modules, HashMap logs) {
		Module mod = null;
		if (node.getType().equals(Module.MODULE_TYPE)) {
			try {
				mod = SiteManagment.getInstance().getModuleFromId(node.getId());
			} catch (Exception e) {
				return;
			}
		} else {
			return;
		}
		List children = mod.getModuleMembers(userContext);
		SiteManagment mgmt = SiteManagment.getInstance();
		for (int i = 0; i < children.size(); i++) {
			ModuleMember child = (ModuleMember) children.get(i);
			//if it is a log - finding the type in order not to include db,http,merge.
			if (child.getType() != null && child.getType().equals("Log")) {
				try {
					//ignore logs without date or other merges
					LogBrowsingManager lbm = mgmt.getLogBrowserManager(child.getId());
					if (lbm == null || lbm.getRecordMask().getDateColumnIndex() < 0	|| (lbm instanceof MergedLogBrowserManager)) {
						continue;
					}
				} catch (Exception e) {
					continue;
				}
			}

			String key = child.getId();
			String treeKey = parentKey + "_" + i;
			String parentNode = parentKey.equals("node") ? "tree.root"
					: parentKey;

			String extraText = "";

			boolean selected = false;
			String chkKey = "logs";
			if (child.getType().equals(Module.MODULE_TYPE)) {
				selected = modules == null
						|| modules.containsKey(child.getId());
				chkKey = "modules";
			} else {
				selected = logs == null || logs.containsKey(child.getId());
			}

			buffer.append("\nvar " + treeKey + " = tree.addNode(" + parentNode
					+ ",\"" + chkKey + "\",\"" + child.getId() + "\",\""
					+ child.getName() + "\",\"" + child.getDescription()
					+ "\",'" + extraText + "'," + selected + ",false);");
			addChildsNodeDiv(child, buffer, treeKey, userContext, modules, logs);

		}
	}

	//check which module should be selected
	void getModulesFromLogs(Module mod, HashMap mods, HashMap logs) {		
		List mem = mod.getModuleMembers();
		ModuleMember[] members = null;
		
			members = (ModuleMember[]) mem.toArray(new ModuleMember[mem.size()]);
		
		Module current = null;
		for (int i = 0; i < members.length; i++) {
			if (members[i].getType().equals(Module.MODULE_TYPE)) {
					try {
						current = SiteManagment.getInstance().getModuleFromId(members[i].getId());
					} catch (Exception e) {
						return;
					}				
				getModulesFromLogs(current, mods, logs);
			} else {
				if (logs.containsKey(members[i].getId())) {
					mods.put(mod.getId(), mod.getName());
					try {
						Module parentModule = SiteManagment.getInstance().getParentModule(mod.getId());					
						while(parentModule != null && !mods.containsKey(parentModule.getId())) {
							mods.put(parentModule.getId(),parentModule.getName());
							parentModule = SiteManagment.getInstance().getParentModule(parentModule.getId());
						}
					}catch(Exception e) {						
					}
					break;
				}
			}
		}
	}

	%>

<%

WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request,response,LogicPermissionConstants.AdministrationPermissions.SETUP_WIZARD_PERMISSION,true)){
     return;
}
	//constants
			String OP = "OP";
			String ADD = "ADD";
			String LOG_ID = "LOG_ID";
			String BUILDER = "CURRENT_LOG_BUILDER";
			String CURRENT_LOG = "CURRENT_LOG";
			String LOG_NAME = "LOG_NAME";
			String LOG_DESCRIPTION = "LOG_DESCRIPTION";
			String MODULE_ID = "MODULE_ID";
			String CURRENT_MODULE = "CURRENT_MODULE";
			String LOG_TIME_ZONE = "LOG_TIME_ZONE";
			String LOG_INDEX_PARAM = "LOG_INDEX_"; //+ int for its index
			String TOTAL_LOG_TO_MERGE = "TOTAL_LOG_TO_MERGE";
			String emtpy = "";
			//page data
			String modid = emtpy;
			String logname = emtpy;
			String logdesc = emtpy;
			boolean isUsingDefaultTimeZone = true;
			TimeZone defaultZone = TimeZone.getDefault();
			String timeZoneId = defaultZone.getID();
			String selectedCharset = null;
			LogBrowsingManager[] mergedLogs = new LogBrowsingManager[0];
			HashMap merge = new HashMap();
			//site management
			SiteManagment mgmt = SiteManagment.getInstance();
			SiteAdministrator admin = SiteManagment.getAdminInstance();

			UserContext userContext = UserEnvironment.getUserContext(request);

			MergedLogBrowserManager lbm = null;

			String backwardURL = null;
			boolean isEdit = false;

			Module[] mdarr = mgmt.getAllModules(userContext, true);
			ModuleMember curmod = new ModuleMember();
			Module pmod = null;

			if (pmod == null) {
				pmod = (Module) request.getSession().getAttribute(CURRENT_MODULE);
				if (pmod == null) {
					pmod = new Module();
					pmod.setId("");
				}
			}

			

			if (mdarr.length == 0) {
				Module tmpMod = new Module();
				tmpMod.setId("");
				mdarr = new Module[] { tmpMod };
			}

			
			//tree issues

            //site management
			
            
			//  String treeCode = getTreeDiv(curmod,user,modulesMap,logsMap);
			Module rootMod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
			String treeCode = getTreeDiv(rootMod, userContext, null, merge);
			String listTitle = "Logs to Analyze";
			String listDesc = "Select the logs that will create the merged log. Only logs with date field can be merged.";
			
			
			logname = "";
			
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script  src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script>
	  baseDirectory = "<%=BASE_DIRECTORY%>";
      function doNext(){
       
        document.access.action = "setupWizardAction.jsp";
        document.access.submit();
      }


      function doAdd(){
        if(document.access.LogsList.selectedIndex == -1){
          return;
        }
        var name = document.access.LogsList.options[document.access.LogsList.selectedIndex].text;
        var value = document.access.LogsList.options[document.access.LogsList.selectedIndex].value;
        for(var i=0;i<document.access.LogsToMerge.options.length;i++){
          if(document.access.LogsToMerge.options[i].value == value){
            return;
          }
        }
        var option0 = new Option(name,value);
        document.access.LogsToMerge.options[document.access.LogsToMerge.options.length] = option0;
      }

    function doRemove(){
      if(document.access.LogsToMerge.selectedIndex == -1){
        return;
      }
      document.access.LogsToMerge.options[document.access.LogsToMerge.selectedIndex] = null;
    }

    function doUp(){
      if(document.access.LogsToMerge.selectedIndex == -1){
        return;
      }
      index = document.access.LogsToMerge.selectedIndex;
      if(index == 0){
      	return;
      }
      document.access.LogsToMerge.selectedIndex = index - 1;
      doDown();
      document.access.LogsToMerge.selectedIndex = index;
    }

	function doDown(){
      if(document.access.LogsToMerge.selectedIndex == -1){
        return;
      }
      index = document.access.LogsToMerge.selectedIndex;
      if(index == (document.access.LogsToMerge.options.length-1) || document.access.LogsToMerge.options.length == 1){
        return;
      }
	   var options = new Array();
	   for(var i=0;i<document.access.LogsToMerge.options.length;i++){
      	  if(i == index){
      	  	var option0 = new Option(document.access.LogsToMerge.options[i+1].text,document.access.LogsToMerge.options[i+1].value);
      		options[i] = option0;
      		option0 = new Option(document.access.LogsToMerge.options[i].text,document.access.LogsToMerge.options[i].value);
      		options[i+1] = option0;
      		i = i+1;
      	  }else{
      	    var option0 = new Option(document.access.LogsToMerge.options[i].text,document.access.LogsToMerge.options[i].value);
      		 options[i] = option0;
      	  }
       }
       for(var i=0;i<options.length;i++){
      	   document.access.LogsToMerge.options[i] = null;
       }
       for(var i=0;i<options.length;i++){
      	  document.access.LogsToMerge.options[i] = options[i];
       }

       document.access.LogsToMerge.selectedIndex = index + 1;
    }
    
    //tree issues
    function markTreeNodeForExport(node){
		nodeCbx = document.getElementById("CheckBox_" + node.tree.name + "_" + node.index);
		if (!nodeCbx) return;
		if (node.selected == nodeCbx.checked) return;
			var selected = nodeCbx.checked;	
		if (this.onSelectMarkChilds){
    		markNodeChilds(node,selected);  
  		}else {
    		node.selected = selected;
  		}
  
  		if (this.onSelectMarkParents  && selected){
    	markNodeParentsToRoot(node.parent,selected);  
  		}
	}
	function showSaveSettings(){
      showHideLayerInMiddle("saveSettingsDiv",-1,-1);
    }
	function doSave(){
		if(document.access.LogName.value == ""){
			alert("Please enter a name.");
			return;
		}
		document.access.doSave.value = "true";
        document.access.action = "searchMergeAdminAction.jsp";
  	    document.access.submit();
	}
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access">

<div id="saveSettingsDiv" style="position:absolute;visibility:hidden;height:80">
 <table border="0" width="350" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid gray">
  <tr height="10"><td align="center" bgcolor="#D2E4FC">
	<span class="PROGRESSTEXT" >Save Settings</span>
		</td>
	</tr>
	<tr><td>
		<table border="0"  cellspacing="1" cellpadding="0">
     <tr>
      <td width="120" nowrap style="padding-left:10;padding-top:10"><span class="PROGRESSTEXT">Parent folder</span></td>
      <td width="200" style="padding-left:10;padding-top:10;padding-right:10">
      <select size="1" class="TEXTBOX" name="ParentModule" id="ParentModule">
       <%
       String selected = "";
       for(int i=0;i<mdarr.length;++i){
         if(mdarr[i].getId().equals(pmod.getId())){
           selected = "selected=\"true\"";
         }else{
           selected = "";
       	 }
       %>
       <option class="PROGRESSTEXT" value="<%=mdarr[i].getId()%>" <%=selected%>><%=mdarr[i].getName()%></option>          
       <%} %>
       </select>
	  </td>
      <td width="*"></td>
     </tr>                  
     <tr>
       <td width="120" style="padding-left:10;padding-top:10" nowrap><span class="PROGRESSTEXT">Name</span></td>
       <td width="200" style="padding-left:10;padding-top:10;padding-right:10">
       <input type="text" class="PROGRESSTEXT" name="LogName" size="30" value="">
       <input type="hidden" class="PROGRESSTEXT" name="doSave" size="1" value="">
	   </td>
       <td width="*"></td>
    </tr>            
    </table>
	</td></tr>
	<tr height="20"><td align="center" style="padding:5">
		<a class="PROGRESSLINK" href="javascript:hideLayer('saveSettingsDiv');">cancel</a>&nbsp;
		<a class="PROGRESSLINK" href="javascript:doSave();">save</a>&nbsp;		  	
	</td>
	</tr>
 </table>
 </div>


<table border="0" width="92%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%"  >
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%"  >
              <tr>
                <td width="8" >&nbsp;</td>
                <td colspan="2" width="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%"  >
                  <tr>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="53">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER"><%=listTitle%></span><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td nowrap>
                    <span class="REGULARTEXT"><%=listDesc%></span>
                    </td>
                  </tr>
                  <tr>
                    <td width="15%">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
                      <tr>
                        <td class="REGULARTEXT">
                        <script>
                         <%=treeCode%>
                         tree.onSelectMarkParents = true;
                         Tree.prototype.markTreeNode = markTreeNodeForExport;
                         tree.writeTree();
                        </script>
                         </td>
                      </tr>
                    </table>
                    </td>
                  </tr>                  
                  <!-- end -->
                  <tr>
                    <td width="800">
                    </td>
                  </tr>
                  <tr>
                    <td width="800">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber17">
                      <tr>
                        <td width="20%">&nbsp;</td>
                        <td width="10%" nowrap><a href="javascript:doBack()" class="LINK">back</a></td>
                        <td width="10%" nowrap><a href="javascript:doNext()" class="LINK">next</a></td>
                        <td width="10%" nowrap><a href="<%=BASE_DIRECTORY%>common/actions/cancelAction.jsp?forward=logic/logicPortal.jsp" class="LINK">cancel</a></td>
                        <td width="38%" >&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>