<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.merge.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.util.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.logic.admin.*"%>
<%@ page import="xpolog.eye.site.*" %>

<%!static final String BASE_DIRECTORY = "../../../";%>
<%
  String ERROR_OBJ = "ERROR_OBJ";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String FILED_PARAM_PREF = "F_";
  String LOG_NAME = "LogName";
  String LOG_DESCRIPTION = "LogDescription";
  String MODULE_ID = "ParentModule";
  String DO_SAVE = "doSave";
  String TX_WIZARD = "TX_WIZARD";
  
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);

  String modid  = request.getParameter(MODULE_ID);
  String logname    = request.getParameter(LOG_NAME);
  String doSave = request.getParameter(DO_SAVE);
 
  String [] logsIds = request.getParameterValues("logs");
  
  //verify data
  ErrorModel errmodel = new ErrorModel();
  if(logsIds == null || logsIds.length ==0 ){
	  errmodel.addError("Please select logs for analysis");
  }
  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=search/searchMergeAdmin.jsp");
    return;
  }

  TxDetectionWizard wizard = new TxDetectionWizard();
  request.getSession().setAttribute(TX_WIZARD,wizard);
  wizard.setLogIds(logsIds);
  wizard.prepareLogData();
  
  //the next screen will build the view
  //screen after that we run detection.
  //screen after that w present result
  // screen after that we create workspace and session
  //screen after that we create data and report
  //screen after that we present data and report
	
   
   env.setTempAttribute(SiteConstants.FORWARD_URL_ATTRIBUTE,"logic/admin/setup/setupWizardDetails.jsp");
   response.sendRedirect(BASE_DIRECTORY + "common/actions/nextAction.jsp");
%>


