<%@ page language="java"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.common.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.data.log.external.*"%>
<%@ page import="xpolog.logic.admin.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%

String CURRENT_LOG = "CURRENT_LOG";
String TX_WIZARD = "TX_WIZARD";
UserEnvironment env = UserEnvironment.getUserEnvironment(request);
final TxDetectionWizard wizard = (TxDetectionWizard) request.getSession().getAttribute("TX_WIZARD");

wizard.prepareDetector();
JobStatus status = wizard.getJobStatus(); 
env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, status); 
env.setTempAttribute(SiteConstants.FORWARD_URL_ATTRIBUTE,"logic/admin/setup/wizTxResultView.jsp");
 

ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "common/actions/nextAction.jsp") {
  public void run(HttpServletRequest request){
    //if the data source failed or the datasource finished, ends the progress.
    boolean isFinished = false;
    boolean isFailed = false;
    try {
      while(!isFinished && !isFailed){
 	  Thread.sleep(1000);
        isFinished =  wizard.getJobStatus().isFinish();
        isFailed = wizard.getJobStatus().isFailed();
     }
     wizard.update(); 
   }catch (Exception e){
     e.printStackTrace();
     isFailed = true;
   }
  }
};
env.setProgressRunner(runner);
wizard.executeDetection();
%>

<jsp:include page="../../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Processing"/>
 <jsp:param name="useStatus" value="true"/>
 <jsp:param name="useInPage" value="true"/>
 <jsp:param name="stopUrl" value="logic/admin/setup/wizSetProgressStopAction.jsp"/>
</jsp:include>

  
