<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>


<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.db.admin.*"%>
<%@ page import="xpolog.logic.ui.admin.system.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%!
	static final String BASE_DIRECTORY = "../../../";

%>

<%
	UserContext userContext = UserEnvironment.getUserContext(request);

  String ERROR_OBJ = "ERROR_OBJ";
	String type = request.getParameter("type");
	String op = request.getParameter("op");
	final boolean create = (op == null || op.equals("create"));
	final String okURL = (type != null && type.length()>0) ? "logic/admin/system/DBSelectedAction.jsp?type="+type : "";
	XpoDriversManager xpoDriversMgr = XpoDriversManager.getInstance();
	XpoDriverInfo info = xpoDriversMgr.getDriverById(type);
	try {
  	if (info != null && !xpoDriversMgr.checkDriver(info.getDriverName())){
		  String message = "The system could not find the driver for the database type selected";
		  response.sendRedirect(BASE_DIRECTORY+"tools/addresses/db/downloadDriver.jsp?type="+type+"&message="+message+"&redirectURL=logic/admin/system/DBSelectedAction.jsp%3ftype="+type);
	  }
	}catch (Throwable e){			
		ErrorModel.log.error("Failed to load driver ",e);
		String message = "The system could not load the driver for the database type selected";
	  response.sendRedirect(BASE_DIRECTORY+"tools/addresses/db/downloadDriver.jsp?type="+type+"&message="+message+"&redirectURL=logic/admin/system/DBSelectedAction.jsp%3ftype="+type);
	}
  
  final DBAccountBuilder builder = (DBAccountBuilder)request.getSession().getAttribute("AccountBuilder");
  if (builder == null){
		String url = "logic/logicPortal.jsp";
    response.sendRedirect(BASE_DIRECTORY + url);
    return;
  }
  
  
	//    audit
	if (create){
    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
       			userContext, AuditConstants.CHANGE, "create database", AuditConstants.CONFIGURATION, "create database " + type);
	}else{
		AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
   			userContext, AuditConstants.CHANGE, "connect database", AuditConstants.CONFIGURATION, "connect to existing database " + type);
	}

 UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "logic/logicPortal.jsp?refreshMenu=true") {
    public void run(HttpServletRequest request){
     List messages = new LinkedList();
     boolean suc = false;
      try {   
       LogicCreatorManager creatorMgr = LogicCreatorManager.getInstance();
       if (create){
				 suc = creatorMgr.createXpoLogicDB(builder,messages);
       }else{
				 suc = creatorMgr.connectToExistingXpoLogicDB(builder);
       }
			 request.getSession().removeAttribute("AccountBuilder");
     }catch (Exception e){
       e.printStackTrace();
     }
     if (!suc){
      errmodel.addError("A problem occured while creating Transaction Expo Database.");
      if (!messages.isEmpty()){
      	for (int i=0; i<messages.size(); i++){
      		errmodel.addError((String)messages.get(i));
      	}
      }
      createErrorRedirect(request, BASE_DIRECTORY);
      setRedirectUrl(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/logicPortal.jsp&okURL="+okURL);      
     }  

    }
  };
  env.setProgressRunner(runner);
%>

<jsp:include page="../../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Creating Database"/>
 <jsp:param name="useStatus" value="false"/>
</jsp:include>


