<%@ page language="java" %>

<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.mail.*"%>
<%@ page import="xpolog.eye.site.*" %>

<%@ page import="xpolog.logic.alert.engine.actions.*"%>
<%@ page import="xpolog.logic.edge.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
 
<%!	  
	 
	void createEmailAlertAction(int edgeIndex, int alertIndex, HttpServletRequest request, RoutineEdgeParadigm edge, String key) {
		MailAlertAction action = null;
	  PostOffice post = null;
	  MailAccount accountFrom = null;
	  MailAccount accountTo = null;
	  String id = "edges"+edgeIndex+"_"+alertIndex;
	  //check if there was template specified
	  String templateId = request.getParameter("templateId["+id+"_x"+"]");
	  if(templateId != null && !templateId.trim().equals("")) {
	  	TemplateBook templateBook = TemplateBook.getInstance();
  		post = (PostOffice)templateBook.getTemplateById(templateId);	
	  }else {
	 		String from = request.getParameter("from["+id+"]");
	 		String to = request.getParameter("to["+id+"]");
	 		String subject = request.getParameter("subject["+id+"]");
	 		String message = request.getParameter("message["+id+"]");
	 		//check if from or to are null or empty.
	 		
	 		accountFrom = new MailAccount();
	 		accountFrom.setId("");
	 		accountFrom.setMailAddress(from);
	 		accountTo = new MailAccount();
	 		accountTo.setId("");
	 		accountTo.setMailAddress(to);
	 		post = new PostOffice();
	 		post.setId("");
	 		post.setInfo(accountFrom, accountTo, subject, message);
 		}
 		action = new MailAlertAction();
 		action.setPostOffice(post);
		UITransactionParadigmHelper.updateAlertAction(edge,action, key);
	}
	static String createFtpAlertAction(String id) {
		return null;
	}
	static String createSmsAlertAction(String id){
		return null;
	}
%>

<%
	UserContext userContext = UserEnvironment.getUserContext(request);

	String ERROR_OBJ = "ERROR_OBJ";
	
	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute("TRAN_PARADIGM_BUILDER");
	if (builder == null){
		response.sendRedirect("addNewTransaction.jsp");
		return;
	}
	
	String op = request.getParameter("OP");
	if (op == null || op.trim().length() == 0){
	  op = "Update";
	}
	
	String isEditStr = request.getParameter("isEdit");
	boolean isEdit = isEditStr != null && isEditStr.equals("true");
	
	String tranName = request.getParameter("tranName");
	
	if (op.equals("Save")){
		//		  audit
		AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		     			userContext, AuditConstants.CHANGE, "add/edit transaction", AuditConstants.TRANSACTION, "add/edit transaction " + tranName);

	  UITransactionParadigmHelper.save(builder, userContext);
	  response.sendRedirect("transactionAdmin.jsp");
	  return;
	}
  
	response.sendRedirect("transactionView.jsp?isView=" + !isEdit);
  
%>