<%@ page language="java" %>

<%@ page import="xpolog.logic.routine.data.AtomicRoutineParadigm"%>
<%@ page import="xpolog.logic.transaction.data.TransactionParadigm"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmBuilder"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmHelper"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
	
	String TRAN_PARADIGM_BUILDER = "TRAN_PARADIGM_BUILDER";

	String functionType = request.getParameter("functionType");
	String functionId = request.getParameter("functionId");
	String nodeId = request.getParameter("nodeId");
	String nodeType = request.getParameter("nodeType");
	String isViewStr = request.getParameter("isView");
	boolean isView = isViewStr != null && isViewStr.equals("true");
	
	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute(TRAN_PARADIGM_BUILDER);
	
	if(functionType.equals("equals")) {
		String routineSourceId = request.getParameter(nodeType + nodeId + "SourceId"); 
	 	String routineTargetId = request.getParameter(nodeType + nodeId + "TargetId"); 
	 	//String [] functionColumns = request.getParameterValues(nodeType + nodeId + "FunctionList"); 
	 	String [] functionColumns = request.getParameter(nodeType + nodeId + "FunctionList").split(","); 

		if(functionColumns == null ||  functionColumns.length == 0 || functionColumns[0].trim().length() == 0) {
			//errmodel.addError("Edge (" + edgeName + ") function must have selected columns");
		}else {				    	
			int [] sourceColumns = new int[functionColumns.length];
			int [] targetColumns = new int[functionColumns.length];
		 
			try {
				for(int c = 0; c < functionColumns.length; c++) {
			 		String value = functionColumns[c];
					int valueIndex = value.indexOf(";");
					if(valueIndex == -1) {
				  	sourceColumns[c] = -1;
						targetColumns[c] = -1;
					}else {					
	 					sourceColumns[c] = Integer.parseInt(value.substring(0,valueIndex));
						targetColumns[c] = Integer.parseInt(value.substring(valueIndex+1,value.length()));
					}
				}
		 	}catch (Exception e) {
				e.printStackTrace();
			}
			AtomicRoutineParadigm arpTrg = null;
			if(routineTargetId == null || routineTargetId.equals("")) {
				arpTrg = (AtomicRoutineParadigm)builder.getRoutineById(nodeId);
			}else {
				arpTrg = (AtomicRoutineParadigm)builder.getRoutineById(routineTargetId);
			}

			AtomicRoutineParadigm arpSrc = (AtomicRoutineParadigm)builder.getRoutineById(routineSourceId);
			TransactionParadigm targetSubTransaction = null;
			if(nodeType.equals("subTransaction")) {
				targetSubTransaction = builder.getTransactionById(nodeId);
			}
			UITransactionParadigmHelper.updateEdgeFunction(builder, functionId, arpSrc, arpTrg, targetSubTransaction, sourceColumns, targetColumns);
		}
	}
	
	response.setContentType("text/xml");
%>


<%@page import="java.util.Enumeration"%>
<Result>
<FunctionsList nodeId="<%=nodeId %>" nodeType="<%=nodeType %>" isView="<%=isView %>">
<![CDATA[
<jsp:include page="functionsList.jsp" flush="true" >
	<jsp:param name="nodeId" value="<%=nodeId %>"/>
	<jsp:param name="nodeType" value="<%=nodeType %>"/>
	<jsp:param name="isView" value="<%=isView %>"/>
</jsp:include>
]]>
</FunctionsList>
</Result>