<%@ page language="java" %>

<%@ page import="xpolog.logic.common.NodeModelParadigm"%>
<%@ page import="xpolog.logic.edge.NodesEdgeParadigm"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmBuilder"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%@ include file="getNodesData.jsp"%>

<%

	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute("TRAN_PARADIGM_BUILDER");
	if(builder == null) {
		response.sendRedirect("addNewTransaction.jsp");
		return;
	}
	
	String sourceId = request.getParameter("sourceId");
	String sourceType = request.getParameter("sourceType");
	String rowIndex = request.getParameter("rowIndex");
	String isViewStr = request.getParameter("isView");
	boolean isView = isViewStr != null && isViewStr.equals("true");
	String targetId = request.getParameter("targetId");
	int index = targetId.indexOf(";");
	String targetType = null;
	if(index > -1) {
		targetType = targetId.substring(0, index);
		targetId = targetId.substring(index + 1);
	}
	
	getTransactionData(request, builder, null);
	
	NodeModelParadigm[] transactionNodes = builder.getTransactionNodes(builder.getRoot());
  getNodesData(request, builder, transactionNodes, null);
  
  NodesEdgeParadigm newEdge = builder.addNewEdgeToRoutines(sourceId, sourceType, targetId, targetType);
  
  int newTableRowIndex = Integer.parseInt(rowIndex);
  NodeModelParadigm source = newEdge.getSourceParadigm();
  NodeModelParadigm newNode = newEdge.getTargetParadigm();
	int numOfEdges = builder.getNumberOfOutgoingEdges(source);
	newTableRowIndex += numOfEdges;
	
	boolean showNodeMenuImage = true;
	if(!source.getTransactionParadigmId().equals(builder.getRoot().getId())) {
		showNodeMenuImage = false;
	}
  
	response.setContentType("text/xml");
%>

<jsp:include page="transactionViewUpdate.jsp" flush="true" >
	<jsp:param name="isView" value="<%=isView %>"/>
	<jsp:param name="includeNodeAttributesElement" value="true"/>
	<jsp:param name="nodeId" value="<%=newNode.getId() %>"/>
	<jsp:param name="nodeType" value="<%=targetType %>"/>
	<jsp:param name="showNodeMenuImage" value="<%=showNodeMenuImage %>"/>
</jsp:include>
