<%@ page language="java" %>

<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmBuilder"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%@ include file="getNodesData.jsp"%>

<%

	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute("TRAN_PARADIGM_BUILDER");
	if (builder == null){
		response.sendRedirect("addNewTransaction.jsp");
		return;
	}
	
	String nodes = request.getParameter("nodes");
	String isViewStr = request.getParameter("isView");
	boolean isView = isViewStr != null && isViewStr.equals("true");
	
	getTransactionData(request, builder, null);
	
	NodeModelParadigm[] transactionNodes = builder.getTransactionNodes(builder.getRoot());
  getNodesData(request, builder, transactionNodes, null);
	
  String[] nodesArr = nodes.split(",");
  TransactionParadigm newGroup = null;
  if(nodesArr.length == 0) {
  	
  }else {
  	newGroup = builder.createGroup(nodesArr);
  }
  
  String id = newGroup == null ? "" : newGroup.getId();
  
  response.setContentType("text/xml");
%>

<jsp:include page="transactionViewUpdate.jsp" flush="true" >
	<jsp:param name="isView" value="<%=isView %>"/>
	<jsp:param name="includeNodeAttributesElement" value="true"/>
	<jsp:param name="nodeId" value="<%=id %>"/>
	<jsp:param name="nodeType" value="subTransaction"/>
	<jsp:param name="showNodeMenuImage" value="false"/>
</jsp:include>
