<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.logic.atomic.data.XpoLogAtomicParadigm"%>
<%@ page import="xpolog.logic.common.NodeModelParadigm"%>
<%@ page import="xpolog.logic.edge.InnerEdgeParadigm"%>
<%@ page import="xpolog.logic.edge.NodesEdgeParadigm"%>
<%@ page import="xpolog.logic.routine.data.AtomicRoutineParadigm"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmBuilder"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmHelper"%>

<%@ page import="java.util.Collection"%>
<%@ page import="java.util.HashSet"%>
<%@ page import="java.util.HashMap"%>
<%@ page import="java.util.List"%>


<%!
String BASE_DIRECTORY = "../../../"; %>
<%

String TRAN_PARADIGM_BUILDER = "TRAN_PARADIGM_BUILDER";

String nodeId = request.getParameter("nodeId");
String nodeType = request.getParameter("nodeType");
String isViewStr = request.getParameter("isView");
boolean isView = isViewStr != null && isViewStr.equals("true");

UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute(TRAN_PARADIGM_BUILDER);
NodeModelParadigm node = null;
if(nodeType.equals("subTransaction")) {
	node = builder.getTransactionById(nodeId);
}else if(nodeType.equals("routine")) {
	node = builder.getRoutineById(nodeId);
}

AtomicRoutineParadigm routine = builder.getRoutineById(nodeId);
XpoLogAtomicParadigm atomic = builder.getAtomicByRoutineId(nodeId);
FilterCollection[] dataFilters = null;
if (atomic != null) {
	FilterCollection[] managerFilters = null;//UITransactionParadigmHelper.getDataFiltersForAtomic(atomic.getId(), true, true);
	if (managerFilters == null){ 
		managerFilters = new FilterCollection[0];
	}
	HashMap fMap = builder.getRoutineFilters(routine);
	Collection col = (fMap != null) ? fMap.values() : null;
	//FilterCollection[] builderFilters = new FilterCollection[0];
	if (col != null){
		dataFilters = (FilterCollection[])col.toArray(new FilterCollection[col.size()]);
	}
	//dataFilters = new FilterCollection[managerFilters.length + builderFilters.length];
  //System.arraycopy(managerFilters, 0, dataFilters, 0, managerFilters.length);
  //System.arraycopy(builderFilters, 0, dataFilters, managerFilters.length, builderFilters.length);
}
HashMap routineFilters = builder.getRoutineFilters(routine);


%>

<table border="0" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%" height="90">
<%
if(routineFilters == null || dataFilters.length == 0) {
%>
	<tr height="10">
		<td class="NODE_TEXT" style="padding-left:3">No data filters exist</td>
	</tr>
<%
}else {
	for(int j = 0; j < dataFilters.length; j++) {
%>
	<tr height="10" id="dataFilter<%=dataFilters[j].getId()%>Tr">
		<td class="NODE_TEXT" style="padding-left:3"><a id="dataFilter<%=dataFilters[j].getId() %>Link" href="javascript:showDataFilter('<%=nodeId %>','<%=nodeType %>','<%=dataFilters[j].getId() %>', '<%=isView %>')" class="FILTER_TEXT"><%=dataFilters[j].getName() %></a></td>
		<td class="NODE_TEXT" width="5" style="padding-right:3"><a href="javascript:openFilterWindow('<%=nodeId %>','<%=dataFilters[j].getId() %>')" title="Edit Data Filter">edit</a></td>
		<td width="5"><a href="javascript:removeDataFilter('<%=nodeId %>','<%=nodeType %>','<%=dataFilters[j].getId() %>', '<%=isView %>')" title="Remove Data Filter"><div id="dataFilter<%=dataFilters[j].getId() %>RemoveImageDiv"><img border="0" id="dataFilter<%=dataFilters[j].getId() %>RemoveImage" src="<%=BASE_DIRECTORY%>logic/images/tranview/remove.gif"></div></a></td>
	</tr>
<%
	}
}
%>
	<tr>
		<td class="NODE_TEXT">&nbsp;</td>
	</tr>
</table>
