<%@page import="xpolog.logic.edge.StartEdgeParadigm"%>
<%@ page language="java"%>

<%@ page import="java.util.ArrayList"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.logic.common.DummyParadigm"%>
<%@ page import="xpolog.logic.common.NodeModelParadigm"%>
<%@ page import="xpolog.logic.edge.InnerEdgeParadigm"%>
<%@ page import="xpolog.logic.edge.NodesEdgeParadigm"%>
<%@ page import="xpolog.logic.routine.data.RoutineParadigm"%>
<%@ page import="xpolog.logic.transaction.data.TransactionParadigm"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmBuilder"%>

<%
	String NODE_ID = "nodeId";
	String NODE_TYPE = "nodeType";
	String TRAN_PARADIGM_BUILDER = "TRAN_PARADIGM_BUILDER";
	
	String nodeId = request.getParameter(NODE_ID);
	String nodeType = request.getParameter(NODE_TYPE);
	
	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute(TRAN_PARADIGM_BUILDER);
	if (builder == null){
		response.sendRedirect("addNewTransaction.jsp");
		return;
	}
	
	NodeModelParadigm node = null, source = null, target = null, inner = null, outer = null;
	TransactionParadigm parent = null;
	if(nodeType != null && nodeType.equals("subTransaction")) {
		node = builder.getTransactionById(nodeId);
	}else if(nodeType != null && nodeType.equals("routine")) {
		node = builder.getRoutineById(nodeId);
	}else if(nodeType != null && nodeType.equals("dummy")) {
		node = builder.getDummyById(nodeId);
	}
	
	StringBuffer result = new StringBuffer();
	if(node != null) {
		List incomingEdges = builder.getTransactionGraph().incomingEdgesOf(node);
		List outgoingEdges = builder.getTransactionGraph().outgoingEdgesOf(node);
		NodesEdgeParadigm edge = null;
		
		result.append("<NodeMenu nodeId=\"");
		result.append(node.getId());
		result.append("\">");
		if(node.getNodeType().equals(DummyParadigm.DUMMY_PARADIGM)) {
			result.append("<MenuItem id=\"setAs\" name=\"Set as\">");
			result.append("<MenuItem id=\"group\" name=\"Group\" nodeType=\"subTransaction\" />");
			result.append("<MenuItem id=\"routine\" name=\"Routine\" nodeType=\"routine\" />");
			result.append("</MenuItem>");
			if(incomingEdges.size() > 1 || (incomingEdges.size() > 0 && incomingEdges.get(0) instanceof InnerEdgeParadigm)) {
				result.append("<MenuItem id=\"removeNode\" name=\"Remove\" nodeType=\"" + nodeType + "\" />");
			}
		}else {
			// Add Connector menu
			result.append("<MenuItem id=\"addEdge\" name=\"Add Connector\">");
			result.append("<MenuItem id=\"newGroup\" name=\"to new group\" nodeType=\"");
			result.append(nodeType);
			result.append("\" targetId=\"subTransaction;new\" />");
			result.append("<MenuItem id=\"newRoutine\" name=\"to new routine\" nodeType=\"");
			result.append(nodeType);
			result.append("\" targetId=\"routine;new\" />");
			result.append("</MenuItem>");
			if(outgoingEdges.size() > 0) {
				// Split Connector menu
				result.append("<MenuItem id=\"splitEdge\" name=\"Split Connector\">");
				for(int i = 0; i < outgoingEdges.size(); i++) {
					edge = (NodesEdgeParadigm)outgoingEdges.get(i);
					if(edge instanceof InnerEdgeParadigm) {
						result.append("<MenuItem id=\"");
						result.append(edge.getId());
						result.append("\" name=\"");
						result.append(edge.getName());
						result.append("\" />");
					}
				}
				result.append("</MenuItem>");
			}
			if(incomingEdges.size() > 0 || outgoingEdges.size() > 0) {
				ArrayList firstNodes = null;
				ArrayList lastNodes = null;
				// Insert to Group menu
				result.append("<MenuItem id=\"insertToGroup\" name=\"Insert to\">");
				if(incomingEdges.size() > 0) {
					for(int i = 0; i < incomingEdges.size(); i++) {
						edge = (NodesEdgeParadigm)incomingEdges.get(i);
						source = edge.getSourceParadigm();
						if(edge instanceof InnerEdgeParadigm && source.getNodeType().equals(TransactionParadigm.TRANSACTION_PARADIGM)) {
							result.append("<MenuItem id=\"");
							result.append(source.getId());
							result.append("\" name=\"");
							result.append(source.getName());
							result.append("\" nodeType=\"");
							result.append(nodeType);
							result.append("\">");
							lastNodes = builder.getTransactionLastNodes((TransactionParadigm)source);
							if(lastNodes.size() > 0) {
								for(int j = 0; j < lastNodes.size(); j++) {
									inner = (NodeModelParadigm)lastNodes.get(j);
									result.append("<MenuItem id=\"");
									result.append(inner.getId());
									result.append("\" name=\"");
									result.append(inner.getName());
									result.append("\" type=\"after\" />");
								}
							}
							result.append("<MenuItem id=\"");
							result.append(source.getId());
							result.append("\" name=\"");
							result.append(source.getName());
							result.append("\" type=\"startPoint\" />");
							result.append("</MenuItem>");
						}
					}
				}
				if(outgoingEdges.size() > 0) {
					for(int i = 0; i < outgoingEdges.size(); i++) {
						edge = (NodesEdgeParadigm)outgoingEdges.get(i);
						target = edge.getTargetParadigm();
						if(edge instanceof InnerEdgeParadigm && target.getNodeType().equals(TransactionParadigm.TRANSACTION_PARADIGM)) {
							result.append("<MenuItem id=\"");
							result.append(target.getId());
							result.append("\" name=\"");
							result.append(target.getName());
							result.append("\" nodeType=\"");
							result.append(nodeType);
							result.append("\">");
							firstNodes = builder.getTransactionFirstNodes((TransactionParadigm)target);
							if(firstNodes.size() > 0) {
								for(int j = 0; j < firstNodes.size(); j++) {
									inner = (NodeModelParadigm)firstNodes.get(j);
									result.append("<MenuItem id=\"");
									result.append(inner.getId());
									result.append("\" name=\"");
									result.append(inner.getName());
									result.append("\" type=\"before\" />");
								}
							}
							result.append("<MenuItem id=\"");
							result.append(target.getId());
							result.append("\" name=\"");
							result.append(target.getName());
							result.append("\" type=\"startPoint\" />");
							result.append("</MenuItem>");
						}
					}
				}
				result.append("</MenuItem>");
			}
			parent = builder.getTransactionById(node.getTransactionParadigmId());
			if(parent != null && parent != builder.getTransactionParadigm()) {
				ArrayList firstNodes = null;
				ArrayList lastNodes = null;
				List subTransactionIncoming = null;
				List subTransactionOutgoing = null;
				// Extract menu
				if(node.getNodeType().equals(TransactionParadigm.TRANSACTION_PARADIGM)) {
					result.append("<MenuItem id=\"extractNode\" name=\"Extract Group\">");
				}else if(node.getNodeType().equals(RoutineParadigm.ROUTINE_PARADIGM)) {
					result.append("<MenuItem id=\"extractNode\" name=\"Extract Routine\">");
				}
				firstNodes = builder.getTransactionFirstNodes(parent);
				if(firstNodes.contains(node)) {
					subTransactionIncoming = builder.getTransactionGraph().incomingEdgesOf(parent);
					if(subTransactionIncoming.size() > 0) {
						if(subTransactionIncoming.size() > 1) {
							result.append("<MenuItem id=\"");
							result.append(parent.getId());
							result.append("\" name=\"");
							result.append(parent.getName());
							result.append("\" groupId=\"");
							result.append(parent.getId());
							result.append("\" type=\"before\" />");
						}
						for(int j = 0; j < subTransactionIncoming.size(); j++) {
							if(subTransactionIncoming.get(j) instanceof StartEdgeParadigm && subTransactionIncoming.size() == 1) {
								outer = (NodeModelParadigm)((NodesEdgeParadigm)subTransactionIncoming.get(j)).getSourceParadigm();
								result.append("<MenuItem id=\"");
								result.append(parent.getId());
								result.append("\" name=\"");
								result.append(parent.getName());
								result.append("\" groupId=\"");
								result.append(parent.getId());
								result.append("\" type=\"before\" />");
							}else {
								outer = (NodeModelParadigm)((NodesEdgeParadigm)subTransactionIncoming.get(j)).getSourceParadigm();
								result.append("<MenuItem id=\"");
								result.append(outer.getId());
								result.append("\" name=\"");
								result.append(outer.getName());
								result.append("\" groupId=\"");
								result.append(parent.getId());
								result.append("\" type=\"after\" />");
							}
						}
					}
					result.append("<MenuItem id=\"");
					result.append(parent.getId());
					result.append("\" name=\"");
					result.append(parent.getName());
					result.append("\" groupId=\"");
					result.append(parent.getTransactionParadigmId());
					result.append("\" type=\"startPoint\" />");
				}
				lastNodes = builder.getTransactionLastNodes(parent);
				if(lastNodes.contains(node)) {
					subTransactionOutgoing = builder.getTransactionGraph().outgoingEdgesOf(parent);
					int numOfOutgoingInnerEdges = 0;
					for(int j = 0; j < subTransactionOutgoing.size(); j++) {
						if(subTransactionOutgoing.get(j) instanceof InnerEdgeParadigm) {
							numOfOutgoingInnerEdges++;
						}
					}
					if(numOfOutgoingInnerEdges == 0 || numOfOutgoingInnerEdges > 1) {
						result.append("<MenuItem id=\"");
						result.append(parent.getId());
						result.append("\" name=\"");
						result.append(parent.getName());
						result.append("\" groupId=\"");
						result.append(parent.getId());
						result.append("\" type=\"after\" />");
					}
					for(int j = 0; j < subTransactionOutgoing.size(); j++) {
						if(subTransactionOutgoing.get(j) instanceof InnerEdgeParadigm) {
							outer = (NodeModelParadigm)((NodesEdgeParadigm)subTransactionOutgoing.get(j)).getTargetParadigm();
							result.append("<MenuItem id=\"");
							result.append(outer.getId());
							result.append("\" name=\"");
							result.append(outer.getName());
							result.append("\" groupId=\"");
							result.append(parent.getId());
							result.append("\" type=\"before\" />");
						}
					}
				}
				result.append("</MenuItem>");
			}
			if(node.getNodeType().equals(TransactionParadigm.TRANSACTION_PARADIGM)) {
				// Zoom In menu
				result.append("<MenuItem id=\"zoomIn\" name=\"Zoom In\" />");
				
				int numOfOutgoingInnerEdges = 0;
				for(int i = 0; i < outgoingEdges.size(); i++) {
					if(outgoingEdges.get(i) instanceof InnerEdgeParadigm) {
						numOfOutgoingInnerEdges++;
					}
				}
				result.append("<MenuItem id=\"removeNode\" name=\"Remove Group\" nodeType=\"" + nodeType + "\" />");
			}else if(node.getNodeType().equals(RoutineParadigm.ROUTINE_PARADIGM)) {
				result.append("<MenuItem id=\"removeNode\" name=\"Remove Routine\" nodeType=\"" + nodeType + "\" />");
			}
		}
		result.append("</NodeMenu>");
	}
	
	response.setContentType("text/xml");
	out.write(result.toString());
	out.flush();
%>


