<%@ page import="java.util.*"%>

<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.mail.*"%>
<%@ page import="xpolog.eye.util.WebUtil"%>

<%@ page import="xpolog.logic.alert.engine.*"%>
<%@ page import="xpolog.logic.alert.engine.actions.*"%>
<%@ page import="xpolog.logic.atomic.data.*"%>
<%@ page import="xpolog.logic.common.NodeModelParadigm"%>
<%@ page import="xpolog.logic.edge.*"%>
<%@ page import="xpolog.logic.filters.*"%>
<%@ page import="xpolog.logic.routine.data.*"%>
<%@ page import="xpolog.logic.sources.xplg.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>

<%!	  
	void getTransactionData(HttpServletRequest request, UITransactionParadigmBuilder builder, ErrorModel errmodel) {
		String tranName = request.getParameter("tranName");
		String tranDesc = request.getParameter("tranDesc");
		String tranLifeCycle = request.getParameter("tranLifeCycle");
		String tranOnlineLifeCycle = request.getParameter("tranOnlineLifeCycle");
		String tranMailAction = request.getParameter("TransactionMailAlert");
		String tranSmsMailAction = request.getParameter("TransactionSmsMailAlert");
		String appNameAtomicId = request.getParameter("appNameAtomicId");
		String appNameListIndex = request.getParameter("sourceListappNameList");
		String tranFlowMailAction = request.getParameter("TransactionFlowMailAlert");
		String tranFlowSmsMailAction = request.getParameter("TransactionFlowSmsMailAlert");
		
		String transactionAlgorithm = request.getParameter("transactionAlgorithm");
	  String closePartialTransaction = request.getParameter("closePartialTransaction");
		
		if(errmodel != null && (tranName == null || tranName.trim().equals(""))) {
	    errmodel.addError("Transaction name was not specified.");
	  }
		
		if(errmodel != null && WebUtil.isContainSpecialCharecter(tranName)) {
			errmodel.addError("The following charecters are prohibited in the transaction name field: "+WebUtil.getSpecialCharectersList());
	  }
		
		if(tranDesc == null || tranDesc.equals("null")) {
			tranDesc = "";
		}
	    
	  int appNameIndex = -1;
	  if (appNameListIndex != null && appNameListIndex.trim().length() > 0){
	    try {
				appNameIndex = Integer.parseInt(appNameListIndex);		
	 		} catch (Exception e) {
	 		}
	  }

	  if (appNameIndex == -1 || (appNameAtomicId != null && appNameAtomicId.equals(""))){
	    appNameAtomicId = null;
	  }
	  
	  ArrayList tranRules = new ArrayList();
	  tranRules.add(UITransactionParadigmHelper.createTransactionAdminRule());
	  long tranLF = -1;
	  if (tranLifeCycle != null && tranLifeCycle.trim().length() > 0){
	    try {
	      tranLF = Long.parseLong(tranLifeCycle);
	    }catch (Exception e){     	
	    }
	    if (errmodel != null && tranLF <= 0){
	      errmodel.addError("Transaction life cycle must be number bigger than 0");
	    }else {
	      String timeUnit = request.getParameter("lifeCycleTimeUnit");
	      tranLF = tranLF * Long.parseLong(timeUnit);
	      if (tranLF > 0){
	      	tranRules.add(UITransactionParadigmHelper.createWarningLifeCycleRule(tranLF));	
	      }else if(errmodel != null){
	      	errmodel.addError("Transaction life cycle is too big");
	      }
	    }
	  }
	    
	  long tranOnlineLF = -1;
	  if(tranOnlineLifeCycle != null && tranOnlineLifeCycle.trim().length() > 0) {
	    try {
	      tranOnlineLF = Long.parseLong(tranOnlineLifeCycle);
	    }catch (Exception e){     	
	    }
	    if(errmodel != null && tranOnlineLF <= 0) {
	      errmodel.addError("Transaction online period must be number bigger than 0");
	    }else {
	      String timeUnit = request.getParameter("onlineLifeCycleTimeUnit");
	      tranOnlineLF = tranOnlineLF * Long.parseLong(timeUnit);
	      if(tranOnlineLF > 0) {
	        tranRules.add(UITransactionParadigmHelper.createLifeCycleRule(tranOnlineLF));
	      }else if(errmodel != null){
	      	errmodel.addError("Transaction online period is too big");
	      }
	    }
	  }else if(errmodel != null){
	    errmodel.addError("Transaction online period must be defined");
	  }
	  
	  if(transactionAlgorithm != null && transactionAlgorithm.length() == 0) {
	    transactionAlgorithm = null;
	  }
	    
	  TransactionParadigm tran = builder.getTransactionParadigm();
	  tran.setName(tranName);
	  tran.setDescription(tranDesc);
	  tran.setApplicationNameAtomicId(appNameAtomicId);
	  tran.setApplicationNameAtomicDataIndex(appNameIndex); 
	  tran.getTransactionInfo().addProperty(TransactionParadigmInfo.TRANSACTION_ALGORITHM,transactionAlgorithm);
	  if(closePartialTransaction != null && closePartialTransaction.length() > 0) {
	    tran.getTransactionInfo().addProperty(TransactionParadigmInfo.CLEAN_PARTIAL_TRANSACTION,"false");
	  }else {
	  	tran.getTransactionInfo().addProperty(TransactionParadigmInfo.CLEAN_PARTIAL_TRANSACTION,"true");
	  }
	   
	  UITransactionParadigmHelper.updateRules(tran,(xpolog.logic.rules.TransactionRule[]) tranRules.toArray(new xpolog.logic.rules.TransactionRule[tranRules.size()]));
	  tran.setActionsForEventsMap(builder.getActionsForEventsMap() != null ? builder.getActionsForEventsMap() : new HashMap());
	  //update the transaction alerts
	  AlertAction transactionAcc = null;
	 	String transactionId, transactionType, transactionKey;
	 	int transactionCounter=0;
	 	while(request.getParameter("AlertType[transaction0_"+transactionCounter+"_x"+"]") != null) {
	 		transactionId = "transaction0_"+transactionCounter;
	 		transactionKey = request.getParameter("AlertTypeKey["+transactionId+"_x"+"]");
	 		transactionType = request.getParameter("AlertType["+transactionId+"_x"+"]");
	 		String transactionTemp = request.getParameter("templateId["+transactionId+"_x"+"]");
	 		if(transactionType != null && transactionType.equals("Email")) {
	 			MailAlertAction action = null;
	   		PostOffice post = null;
		    MailAccount accountFrom = null;
		    MailAccount accountTo = null;
	 			//check if there was template specified
	   		String templateId = request.getParameter("templateId["+transactionId+"_x"+"]");
		    if(templateId != null && !templateId.trim().equals("")) {
		    	TemplateBook templateBook = TemplateBook.getInstance();
	  			post = (PostOffice)templateBook.getTemplateById(templateId);	
		    }else {
		    	
		 		String from = request.getParameter("from["+transactionId+"]");
		 		String to = request.getParameter("to["+transactionId+"]");
		 		String subject = request.getParameter("subject["+transactionId+"]");
		 		String message = request.getParameter("message["+transactionId+"]");
		 		accountFrom = new MailAccount();
		 		accountFrom.setId("");
		 		accountFrom.setMailAddress(from);
		 		accountTo = new MailAccount();
		 		accountTo.setId("");
		 		accountTo.setMailAddress(to);
		 		post = new PostOffice();
		 		post.setId("");
		 		post.setInfo(accountFrom, accountTo, subject, message);
	 		}
	 		action = new MailAlertAction();
	 		action.setPostOffice(post);
			UITransactionParadigmHelper.updateAlertAction(tran, action, transactionKey);
	 		}else if(transactionType == "Ftp") {
	 			//createFtpAlertAction(transactionId);
	 		}else {
	 			//createSmsAlertAction(transactionId);
	 		}
	 		++transactionCounter;
	 	}
	}
	
	void getNodesData(HttpServletRequest request, UITransactionParadigmBuilder builder, NodeModelParadigm[] nodes, ErrorModel errmodel) {
		NodeModelParadigm node = null;
	  TransactionParadigm subTransaction = null;
	  RoutineParadigm routine = null;
	  
	  for (int i = 0; i < nodes.length; i++) {
	    node = nodes[i];
	    if(node.getNodeType().equals(TransactionParadigm.TRANSACTION_PARADIGM)) {
	    	subTransaction = (TransactionParadigm)node;
	    	getSubTransactionData(request, builder, subTransaction, i, errmodel);
	    	NodeModelParadigm[] transactionNodes = builder.getTransactionNodes(subTransaction);
	    	getNodesData(request, builder, transactionNodes, errmodel);
	    }else if(node.getNodeType().equals(RoutineParadigm.ROUTINE_PARADIGM)) {
	    	routine = (RoutineParadigm)node;
	    	getRoutineData(request, builder, routine, i, errmodel);
	    }
		}
	}
	
	void getSubTransactionData(HttpServletRequest request, UITransactionParadigmBuilder builder, TransactionParadigm subTransaction, int index, ErrorModel errmodel) {
		String subTransactionName;
		String subTransactionDescription;
		
		subTransactionName = request.getParameter("subTransaction" + subTransaction.getId() + "Name");
		if(subTransactionName == null || subTransactionName.length() == 0 || subTransactionName.equals("null")) {
			errmodel.addError("Group name was not specified");
			subTransactionName = "N/A";
		}
		subTransactionDescription = request.getParameter("subTransaction" + subTransaction.getId() + "Description");
		if(subTransactionDescription == null || subTransactionDescription.equals("null")) {
			subTransactionDescription = "";
		}
		subTransaction.setName(subTransactionName);
		subTransaction.setDescription(subTransactionDescription);
		
		List edges = builder.getTransactionGraph().outgoingEdgesOf(subTransaction);
		getEdgesData(request, builder, edges, errmodel);
	}
	 
	void getRoutineData(HttpServletRequest request, UITransactionParadigmBuilder builder, RoutineParadigm routine, int index, ErrorModel errmodel) {
		XpoLogAtomicParadigm atomicParadigm = null;
	  XplgDataSource dataSource = null;
	  String[] routineDataFilterIds = null;
	  AtomicDataFilter atomicDataFilter = null;
	  String filterId = null;
	  long routineLogicValue = 0;
	  String routineName = null;
	  String routineDesc = null;
	  String routineRuntimeImage = null;
	  String routineRuntimeErrorImage = null;
	  String dummyRoutineImage = null;
		 
	  atomicParadigm = builder.getAtomicByRoutineId(routine.getId());
		dataSource = builder.getDataSourceByRoutineId(routine.getId());
		
		routineName = request.getParameter("routine" + routine.getId() + "Name");	
		if(routineName == null || routineName.length() == 0 || routineName.equals("null")) {
			errmodel.addError("Routine name was not specified");
			routineName = "N/A";
		}
		routineDesc = request.getParameter("routine" + routine.getId() + "Description");
		if(routineDesc == null || routineDesc.equals("null")) {
			routineDesc = "";
		}
		filterId = request.getParameter("routine" + routine.getId() + "DataSourceFilter");
		routineDataFilterIds = request.getParameterValues("routine" + routine.getId() + "FilterList");
		routineLogicValue = 0;
		String [] routineLogicValues = request.getParameterValues("routine" + routine.getId() + "LogicType");
		/*
		builder.resetRoutineFilters(routine);
		if(routineDataFilterIds != null) {
			for(int f=0; f<routineDataFilterIds.length; f++) {
				if(routineDataFilterIds[f].equals("0")) continue;
				FilterCollection fc = UITransactionParadigmHelper.getDataFilterFromId(routine,routineDataFilterIds[f],builder);
				if(fc != null) {
					builder.addRoutineFilter(routine,fc);
				}
			}
		}
		*/

		if(routineLogicValues!= null) {
			for(int f=0; f<routineLogicValues.length; f++) {
				try{
					long value = Long.parseLong(routineLogicValues[f]);
					routineLogicValue = routineLogicValue | value;
				}catch (Exception e){}
			}
		}

		if(errmodel != null && dataSource.getLbmId() == null) {			  
			errmodel.addError("No data source was selected for routine " + routineName);
		}
			
		if(routineName == null || routineName.trim().equals("")) {
			if(routine.getName() != null && routine.getName().length() > 0) {
				routineName = routine.getName();
			}else {
				routineName = "routine " + (index + 2);
			}
   	}
   	
   	routine.setName(routineName);
   	routine.setDescription(routineDesc);
		dataSource.setFilterId(filterId);
   	
   	UIProperties properties = new UIProperties();
   	routineRuntimeImage = request.getParameter("routineRuntimeImages" + routine.getId());	
   	routineRuntimeErrorImage = request.getParameter("routineRuntimeErrorImages" + routine.getId());
   	dummyRoutineImage = request.getParameter("dummyRoutineImages" + routine.getId());
   	UITransactionParadigmHelper.addGlobalProperty(properties,UIConstants.IMAGES_TYPE,routineRuntimeImage,UIConstants.ROUTINE_RUNTIME_KEY,UIConstants.ROUTINE_GROUP_TYPE);
   	UITransactionParadigmHelper.addGlobalProperty(properties,UIConstants.IMAGES_TYPE,routineRuntimeErrorImage,UIConstants.ROUTINE_RUNTIME_ERROR_KEY,UIConstants.ROUTINE_GROUP_TYPE);
   	UITransactionParadigmHelper.addGlobalProperty(properties,UIConstants.IMAGES_TYPE,dummyRoutineImage,UIConstants.DUMMY_ROUTINE_KEY,UIConstants.ROUTINE_GROUP_TYPE);
   	  
   	routine.setUIObject(properties);
		routine.setLogicType(routineLogicValue);
		
		List edges = builder.getTransactionGraph().outgoingEdgesOf(routine);
		getEdgesData(request, builder, edges, errmodel);
	}
	
	void getEdgesData(HttpServletRequest request, UITransactionParadigmBuilder builder, List edges, ErrorModel errmodel) {
		NodesEdgeParadigm edge = null;
		long edgeLogicValue = 0;
		for(int i = 0; i < edges.size(); i++) {
			edge = (NodesEdgeParadigm)edges.get(i);
			if(edge instanceof InnerEdgeParadigm) {
				String edgeName = null;
	     	//String defaultEdgeName = builder.createDefaultEdgeName(edge);
	     	
	     	edgeName = 	request.getParameter("edge" + edge.getId() + "Name");	
			  String edgeDesc = 	request.getParameter("edge" + edge.getId() + "Description");
			  if(edgeDesc == null || edgeDesc.equals("null")) {
			  	edgeDesc = "";
				}
				String edgeLifeCycle = request.getParameter("edge" + edge.getId() + "LifeCycle");
				String edgeMailAction = request.getParameter("EdgeMailAlert" + i);
				String edgeSmsMailAction = request.getParameter("EdgeSmsMailAlert" + i);
				String edgeRepeatStr = 	request.getParameter("edge" + edge.getId() + "Repeat");	
				edgeLogicValue = 0;
				String [] edgeLogicValues = request.getParameterValues("edge" + edge.getId() + "LogicType");
				if(edgeLogicValues != null) {
				  for(int f = 0; f < edgeLogicValues.length; f++) {
					try {
					  long value = Long.parseLong(edgeLogicValues[f]);
					  edgeLogicValue = edgeLogicValue | value;
					}catch (Exception e){}
				  }
				}
			
				if(edgeName == null || edgeName.trim().equals("")) {
	   	 		edgeName = "edge " + (i + 1);
	   		}else {
	   	  	/*if (defaultEdgeName.equals(edgeName)){
	   	    	edgeName = builder.createDefaultEdgeName(edge);
	   	  	}*/
	   		}
	   	
		    long edgeLF = -1;
	   		if(edgeLifeCycle != null && edgeLifeCycle.trim().length() > 0) {
	    	  try {
	        	edgeLF = Long.parseLong(edgeLifeCycle);
	     	  }catch (Exception e){     	
	     	  }
	        if(errmodel != null && edgeLF <= 0) {
	        	errmodel.addError("Life cycle of edge " + edgeName + " must be number bigger than 0");
	     	  }else {
	     	    String timeUnit = request.getParameter("edge" + edge.getId() + "LifeCycleTimeUnit");
	          edgeLF = edgeLF * Long.parseLong(timeUnit);
	     	  }
	     	}
	     	
	     	int edgeRepeat = 1;
	     	if(edgeRepeatStr != null && edgeRepeatStr.trim().length() > 0) {
	    	  try {
	           edgeRepeat = Integer.parseInt(edgeRepeatStr);
	     	  }catch (Exception e){ 
	     	  	if(errmodel != null) {
		     	    errmodel.addError("Repeat value of edge " + edgeName + " must be a number"); 	
	     	  	}
	     	  }
	        if(errmodel != null && edgeRepeat <= 0) {
	          errmodel.addError("Repeat value of edge " + edgeName + "must be number bigger than 0");
	     	  }
	     	}else if(errmodel != null) {
	     	  errmodel.addError("Repeat value of edge " + edgeName + " was not specified");
	     	}
	   	
	   		edge.setName(edgeName);
		    edge.setDescription(edgeDesc);
	 	  	edge.setEdgeRepeat(edgeRepeat);
				edge.setLogicType(edgeLogicValue);
				UITransactionParadigmHelper.updateRules((InnerEdgeParadigm)edge, edgeLF);
	   		((InnerEdgeParadigm)edge).setActionsForEventsMap(new HashMap());
	      
	   		//get the data from alerts and check types.
	      AlertAction acc = null;
			  String id, type, key;
			  int counter=0;
			}
		}
	}
%>