<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.brain.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%!
	static final String BASE_DIRECTORY = "../../../../";
%>

<%

	UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);

  ErrorModel errmodel = new ErrorModel();
  String tranId = request.getParameter("id");
  if (tranId == null || tranId.length() == 0){
     errmodel.addError("Can't display permissions. No id is found.");
  }

 BrainConfigurationRepository rep = BrainConfigurationRepository.getRepository();
 TransactionParadigm tran = rep.getTransactionParadigmById(tranId);
  
  if (tran == null){
    errmodel.addError("No transaction was found for id - " + tranId);
  }

  ModuleMemberPermissions permissions = null;
  permissions = new ModuleMemberPermissions();
  String [] editNames = request.getParameterValues("selectedEditMembersList");
  if (editNames != null && editNames.length > 0){
    permissions.setEditMembers(Arrays.asList(editNames));
  }

  String [] viewNames = request.getParameterValues("selectedViewMembersList");
  if (viewNames != null && viewNames.length > 0){
     permissions.setViewMembers(Arrays.asList(viewNames));
  }
  

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;

  }

	//    audit
    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
       			userContext, AuditConstants.CHANGE, "edit transaction permissions", AuditConstants.TRANSACTION, "edit transaction permissions " + tran.getName());

  tran.setTransactionPermissions(permissions);
  try {
    UITransactionParadigmHelper.saveTransactionPermissions(tran);
  }catch (Exception e){
    //e.printStackTrace();
  }

  String forwardURL = request.getParameter("forwardURL");
  if (forwardURL == null || forwardURL.length() == 0){
    forwardURL = "security/common/moduleMemberSetOK.jsp?okURL=logic/admin/transaction/transactionAdmin.jsp";
  }
  forwardURL = BASE_DIRECTORY + forwardURL;
  response.sendRedirect(forwardURL);

%>

