<%@ page language="java" %>

<%@page import="xpolog.logic.common.NodeModelParadigm"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmBuilder"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
	
	String TRAN_PARADIGM_BUILDER = "TRAN_PARADIGM_BUILDER";

	String functionId = request.getParameter("functionId");
	String nodeId = request.getParameter("nodeId");
	String nodeType = request.getParameter("nodeType");
	String isViewStr = request.getParameter("isView");
	boolean isView = isViewStr != null && isViewStr.equals("true");
	
	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute(TRAN_PARADIGM_BUILDER);
	NodeModelParadigm node = null;
	
	if(nodeType.equals("subTransaction")) {
		node = builder.getTransactionById(nodeId);
	}else if(nodeType.equals("routine")) {
		node = builder.getRoutineById(nodeId);
	}
	if(node != null) {
		int index = node.getIncomingRoutineFunctionEdgeIndex(functionId);
		NodeFunctionEdge functionEdge = node.getIncomingRoutineFunctionByIndex(index);
		node.removeIncomingRoutineFunctionEdge(functionId);
		functionEdge.getSourceParadigm().removeOutgoingRoutineFunctionEdge(functionId);
	}
	
	response.setContentType("text/xml");
%>

<%@page import="xpolog.logic.functions.NodeFunctionEdge"%>
<Result>
<FunctionsList nodeId="<%=nodeId %>" nodeType="<%=nodeType %>" isView="<%=isView %>">
<![CDATA[
<jsp:include page="functionsList.jsp" flush="true" >
	<jsp:param name="nodeId" value="<%=nodeId %>"/>
	<jsp:param name="nodeType" value="<%=nodeType %>"/>
	<jsp:param name="isView" value="<%=isView %>"/>
</jsp:include>
]]>
</FunctionsList>
</Result>