<%@ page language="java" %>

<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmBuilder"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%@ include file="getNodesData.jsp"%>

<%

	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute("TRAN_PARADIGM_BUILDER");
	if (builder == null){
		response.sendRedirect("addNewTransaction.jsp");
		return;
	}
	
	String nodeType = request.getParameter("nodeType");
	String nodeId = request.getParameter("nodeId");
	String isViewStr = request.getParameter("isView");
	boolean isView = isViewStr != null && isViewStr.equals("true");
	
	getTransactionData(request, builder, null);
	
	NodeModelParadigm[] transactionNodes = builder.getTransactionNodes(builder.getRoot());
  getNodesData(request, builder, transactionNodes, null);
	
  if(nodeType != null && nodeType.length() > 0 && nodeId != null && nodeId.length() > 0) {
	  builder.removeNode(nodeType, nodeId);
  }
  
  response.setContentType("text/xml");
%>

<jsp:include page="transactionViewUpdate.jsp" flush="true" >
	<jsp:param name="isView" value="<%=isView %>"/>
</jsp:include>
