<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.atomic.data.*"%>

<%

	String routineId = request.getParameter("routineId");
	String selectName = request.getParameter("selectName");
	
	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute("TRAN_PARADIGM_BUILDER");
	if(builder == null) {		
	  return;
	}
	if(routineId == null || routineId.length() == 0) {
	  return;
	}
	
	XpoLogAtomicParadigm atomicParadigm = builder.getAtomicByRoutineId(routineId);
	if(atomicParadigm == null) {
	  return;
	}
	
	LinearBrowsingManager lbm = atomicParadigm.getLbm();
	if(lbm != null) {
		String [] names = UITransactionParadigmHelper.getColumnNames(lbm.getRecordMask());
%>

<select size="5" id="<%=selectName %>" name="<%=selectName %>" class="TRANSACTION_TEXTBOX">
<%
		for(int i = 0; i < names.length; i++) {
%>
	<option value="<%=String.valueOf(i) %>"><%=names[i] %></option>
<%
		}
%>
</select>
<%
	}else {
%>
<select size="5" id="<%=selectName %>" name="<%=selectName %>" class="TRANSACTION_TEXTBOX">
	<option value="">No data to use</option>
</select>
<%
	}
%>