<%@ page import="java.util.Collection"%>
<%@ page import="java.util.HashMap"%>
<%@ page import="java.util.HashSet"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.data.RecordMask"%>
<%@ page import="xpolog.eye.LinearBrowsingManager"%>

<%@ page import="xpolog.logic.atomic.data.XpoLogAtomicParadigm"%>
<%@ page import="xpolog.logic.edge.InnerEdgeParadigm"%>
<%@ page import="xpolog.logic.functions.*"%>
<%@ page import="xpolog.logic.routine.data.AtomicRoutineParadigm"%>
<%@ page import="xpolog.logic.routine.data.RoutineParadigm"%>
<%@ page import="xpolog.logic.sources.xplg.XplgDataSource"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmBuilder"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmHelper"%>
<%@ page import="xpolog.logic.ui.conf.UIConstants"%>
<%@ page import="xpolog.logic.ui.conf.UIProperties"%>
<%@ page import="xpolog.logic.ui.conf.UIPreferences"%>
<%@ page import="xpolog.logic.ui.conf.UIProperty"%>

<%@ include file="getGroupableNodes.jsp"%>

<%

String TRAN_PARADIGM_BUILDER = "TRAN_PARADIGM_BUILDER";

String BASE_DIRECTORY = request.getParameter("BASE_DIRECTORY");
String parentTransaction = request.getParameter("parentTransaction");
String routineId = request.getParameter("routineId");
String atomicDisplay = request.getParameter("atomicDisplay");
String filterDisplay = request.getParameter("filterDisplay");
String rulesDisplay = request.getParameter("rulesDisplay");
String isViewStr = request.getParameter("isView");
boolean isView = isViewStr != null && isViewStr.equals("true");

UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute(TRAN_PARADIGM_BUILDER);

AtomicRoutineParadigm routine = builder.getRoutineById(routineId);
XpoLogAtomicParadigm atomic = builder.getAtomicByRoutineId(routineId);
if(atomic != null && atomic.getLbm() == null) {
	atomic = null;
}
XplgDataSource dataSource = null;
if(atomic != null && atomic.getLbm() != null) {
	dataSource = builder.getDataSourceByRoutineId(routineId);
}
String logId = "", filterId = "", nodeId = "";
if(dataSource != null) {
	if(dataSource.getLbmId() != null) {
		logId = dataSource.getLbmId();
	}
	if(dataSource.getFilterId() != null) {
		filterId = dataSource.getFilterId();
	}
	if(dataSource.getNodeId() != null) {
		nodeId = dataSource.getNodeId();
	}
}


String groupableNodes = getGroupableNodes(builder, routine);
String parentLevelStr = request.getParameter("parentLevel");
int parentLevel = 0;
if (parentLevelStr != null && parentLevelStr.length() > 0){
	try {
		parentLevel = Integer.parseInt(parentLevelStr);
	}catch (Exception e){}
}
%>

<table border="1" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%">
											<tr height="20">
												<td width="100%">
												<div id="routine<%=routineId %>Div">
												<div id="routine<%=routineId %>HeaderDiv">
						  						<table border="0" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%">
														<tr id="routine<%=routineId %>HeaderRow" bgcolor="#E4E4E4" onmouseover="javascript:changeBgColor(this, '#D5D5D5')" onmouseout="javascript:changeBgColor(this, '#E4E4E4')">
															<td>
					  										<table border="0" cellspacing="0" cellpadding="0" width="100%">
					  											<tr>
																		<td width="205">
																			<table border="0" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%">
																				<tr>
																					<td width="<%=((20*(parentLevel + 1))) + "" %>" style="border-width:0; padding-left:1" align="right">
																						<input type="checkbox" id="routine<%=routineId %>Check" name="nodeChecks" value="<%=routineId %>" parentTransaction="<%=parentTransaction %>" groupableNodes="<%=groupableNodes %>" onClick="javascript:selectNodeForGroup('<%=routineId %>', 'routine')">
																					</td>
																					<td class="ROUTINE_HEADER" style="padding-left:7" onclick="javascript:clickNode('<%=routineId %>', 'routine', true, false)">
																						<img border="0" id="routine<%=routineId %>ArrowImage" src="<%=BASE_DIRECTORY%>logic/images/tranview/closedRoutineArrow.gif">
																						<%
													  								String routineName = routine.getName();
													  								String title = "";
													  								if(routineName.length() > 23) {
													  									title = "title=\"" + routineName + "\"";
													  									routineName = routineName.substring(0, 23);
													  									routineName += "...";
													  								}
													  								%>
																						<span style="font-weight:bold; cursor:pointer" <%=title %>><%=routineName %></span>
																					</td>
																				</tr>
																			</table>
																		</td>
																		<td id="routine<%=routineId %>HeaderTd" width="*">
																			<div id="routine<%=routineId %>HeaderMiscDiv">
																				<table border="0" cellspacing="0" cellpadding="0" width="100%">
																					<tr>
																						<td width="32%" class="ROUTINE_HEADER" style="padding-left:7" id="routine<%=routineId %>DataSourceHeaderCell"><%=atomicDisplay %></td>
																						<td width="32%" class="ROUTINE_HEADER" style="padding-left:7" id="routine<%=routineId %>DataSourceFilterHeaderCell"><%=filterDisplay %></td>
																						<td width="*" class="ROUTINE_HEADER" style="padding-left:7"><%=rulesDisplay %></td>
																						<td width="14" align="center">
																							<a href="javascript:removeNode('routine', '<%=routineId %>')" title="Remove Routine"><img border="0" id="routine<%=routineId %>RemoveImage" src="<%=BASE_DIRECTORY%>logic/images/tranview/remove.gif"></a>
																						</td>	
																					</tr>
																				</table>
																			</div>
																			<div id="routine<%=routineId %>TabsDiv" style="display:none">
																				<table border="0" cellspacing="0" cellpadding="0" width="100%">
																					<tr id="routine<%=routineId %>TabsRow">
																					  <td valign="bottom">
																						  <table border="0" cellspacing="0" cellpadding="0" width="100%">
																							  <tr>
																									<td width="3%" style="font-size:2pt">&nbsp;</td>
																									<td width="*" style="font-size:2pt">&nbsp;</td>
																									
																									<td id="routine<%=routineId %>GeneralTabImage" style="width:93px; background-image:url(<%=BASE_DIRECTORY %>logic/images/tranview/routineTabSelected.gif); background-repeat:no-repeat" valign="bottom" align="center" onClick="javascript:showRoutineTab('<%=routineId %>', 0)" onMouseOver="javascript:document.body.style.cursor='pointer'" onMouseOut="javascript:document.body.style.cursor='default'"><span id="routine<%=routineId %>GeneralTabLink" class="ROUTINE_SELECTED_TAB_TEXT">General</span></td>
																									<td id="routine<%=routineId %>FunctionsTabImage" style="width:93px; background-image:url(<%=BASE_DIRECTORY %>logic/images/tranview/routineTabUnselected.gif); background-repeat:no-repeat" valign="bottom" align="center" onClick="javascript:showRoutineTab('<%=routineId %>', 1)" onMouseOver="javascript:document.body.style.cursor='pointer'" onMouseOut="javascript:document.body.style.cursor='default'"><span id="routine<%=routineId %>FunctionsTabLink" class="ROUTINE_TAB_TEXT">Functions</span></td>
																									<td id="routine<%=routineId %>ConnectorsTabImage" style="width:93px; background-image:url(<%=BASE_DIRECTORY %>logic/images/tranview/routineTabUnselected.gif); background-repeat:no-repeat" valign="bottom" align="center" onClick="javascript:showRoutineTab('<%=routineId %>', 2)" onMouseOver="javascript:document.body.style.cursor='pointer'" onMouseOut="javascript:document.body.style.cursor='default'"><span id="routine<%=routineId %>ConnectorsTabLink" class="ROUTINE_TAB_TEXT">Connectors</span></td>
																									<td id="routine<%=routineId %>DataFilterTabImage" style="width:93px; background-image:url(<%=BASE_DIRECTORY %>logic/images/tranview/routineTabUnselected.gif); background-repeat:no-repeat" valign="bottom" align="center" onClick="javascript:showRoutineTab('<%=routineId %>', 3)" onMouseOver="javascript:document.body.style.cursor='pointer'" onMouseOut="javascript:document.body.style.cursor='default'"><span id="routine<%=routineId %>DataFilterTabLink" class="ROUTINE_TAB_TEXT">Data Filters</span></td>
																									<td id="routine<%=routineId %>UiSettingsTabImage" style="width:93px; background-image:url(<%=BASE_DIRECTORY %>logic/images/tranview/routineTabUnselected.gif); background-repeat:no-repeat" valign="bottom" align="center" onClick="javascript:showRoutineTab('<%=routineId %>', 4)" onMouseOver="javascript:document.body.style.cursor='pointer'" onMouseOut="javascript:document.body.style.cursor='default'"><span id="routine<%=routineId %>UiSettingsTabLink" class="ROUTINE_TAB_TEXT">UI Settings</span></td>
																									<td width="14" style="font-size:2pt">&nbsp;</td>
																							  </tr>
																						  </table>
																					 </td>
																					 <td width="14" align="center">
																							<a href="javascript:removeNode('routine', '<%=routineId %>')" title="Remove Routine"><img border="0" id="routine<%=routineId %>RemoveImage" src="<%=BASE_DIRECTORY%>logic/images/tranview/remove.gif"></a>
																						</td>	
																					</tr>
																				</table>
																			</div>
																		</td>
																	</tr>
																</table>
															</td>
														</tr>
													</table>
												</div>
												<div id="routine<%=routineId %>BodyDiv" style="display:none" parentTransaction="<%=parentTransaction %>">
													<div id="routine<%=routineId %>GeneralDiv">
														<table border="0" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%" bgcolor="#DBDDE9">
															<tr>
																<td width="200">
																	<table border="0" cellspacing="0" style="border-collapse: collapse" width="100%">
										  							<tr>
										  								<td width="10">&nbsp;</td>
										  								<td width="150" class="NODE_TEXT" style="padding-left:9; padding-top:5">Name</td>
										  								<td width="*" class="TRANSACTION_TEXTBOX" style="padding-left:9; padding-top:5"><input type="text" id="routine<%=routineId %>Name" name="routine<%=routineId %>Name" value="<%=routine.getName() %>" class="TRANSACTION_TEXTBOX"></td>
										  								<td width="15%"></td>
										  							</tr>
										  							<tr>
										  								<td>&nbsp;</td>
										  								<td class="NODE_TEXT" style="padding-left:9" width="150">Description</td>
										  								<td style="padding-left:9"><input type="text" id="routine<%=routineId %>Description" name="routine<%=routineId %>Description" value="<%=routine.getDescription() %>" class="TRANSACTION_TEXTBOX"></td>
										  								<td></td>
										  							</tr>
										  							<tr>
										  								<td>&nbsp;</td>
										  								<td class="NODE_TEXT" style="padding-left:9" width="150">
										  								<nobr>Data Source
										  								<%
										  								if(!isView) {
																			%>
																			(<a class="LINK" href="javascript:openDataSourceSelection('<%=routineId%>')">...</a>)
																			<%
																			}
										  								%>
										  								</nobr>
										  								</td>
										  								<input type="hidden" id="routine<%=routineId %>DataSource" name="routine<%=routineId %>DataSource" value="<%=logId%>">
										  								<input type="hidden" id="routine<%=routineId %>DataSourceNodeId" name="routine<%=routineId %>DataSourceNodeId" value="<%=nodeId%>">
										  								<td class="NODE_TEXT" style="padding-left:9" id="routine<%=routineId %>DataSourceCell">
										  									<%
									                      if(atomic == null) {
									                      %>
									                      None
									                      <%
									                      }else {
									                      %>                                                          
									                      <%=atomic.getName() %>
									                      <%
									                      }
										  									%>
										  								</td>
										  								<td></td>
										  							</tr>
										  							<tr>
										  								<td>&nbsp;</td>
										  								<td class="NODE_TEXT" style="padding-left:9" width="150">Filter</td>
										  								<input type="hidden" id="routine<%=routineId %>DataSourceFilter" name="routine<%=routineId %>DataSourceFilter" value="<%=filterId%>">
										  								<td class="NODE_TEXT" style="padding-left:9" id="routine<%=routineId %>DataSourceFilterCell">
										  									<%
																				if(atomic == null || dataSource.getFilterId() == null || dataSource.getFilterId().length() == 0 || dataSource.getFilterId().equals("none")) {
																				%>
														            None
																				<%
																				}else if(atomic != null) {
																	  			java.util.List filtersList = atomic.getLbm().getFilterManager().getFilterCollections();
																	  			if(filtersList != null) {
																	    			String selectedFilterId = dataSource == null ? null : dataSource.getFilterId();
																    	    	for (int f = 0; f < filtersList.size(); f++) {
																    	    		FilterCollection col = (FilterCollection)filtersList.get(f);
																	  		      boolean selected = selectedFilterId != null && selectedFilterId.equals(col.getId());
																				      if(selected) {
																	      %>
																	      <%=col.getName()%>
																				<%	
																	      			}			    
																	    			}
																	  			}
																				}
																				%>
										  								</td>
										  								<td></td>
										  							</tr>
										  						</table>													
																</td>
																<td>
																	<table border="0" cellspacing="0" style="border-collapse: collapse" width="100%">
										  							<tr>
										  								<td width="3%">&nbsp;</td>
										  								<td width="100" class="NODE_TEXT" style="padding-left:9; padding-bottom:5">Characteristics</td>
										  								<td width="*"><input type="checkbox" name="routine<%=routineId%>LogicType" value="<%=RoutineParadigm.START_LOGIC_TYPE%>" <%=routine.isLogicFromType(RoutineParadigm.START_LOGIC_TYPE)?"checked":""%>><span class="NODE_TEXT">Open - opens a transaction</span></td>
										  								<td width="5%"></td>
										  							</tr>
										  							<tr>
										  								<td>&nbsp;</td>
										  								<td></td>
										  								<td><input type="checkbox" name="routine<%=routineId%>LogicType" value="<%=RoutineParadigm.SINGLE_LOGIC_TYPE%>" <%=routine.isLogicFromType(RoutineParadigm.SINGLE_LOGIC_TYPE)?"checked":""%>><span class="NODE_TEXT">Single - occures only once within a transaction</span></td>
										  								<td></td>
										  							</tr>
										  							<tr>
										  								<td>&nbsp;</td>
										  								<td></td>
										  								<td><input type="checkbox" name="routine<%=routineId%>LogicType" value="<%=RoutineParadigm.OPTIONAL_LOGIC_TYPE%>" <%=routine.isLogicFromType(RoutineParadigm.OPTIONAL_LOGIC_TYPE)?"checked":""%>><span class="NODE_TEXT">Optional - might occure within a transaction</span></td>
										  								<td></td>
										  							</tr>
										  							<tr>
										  								<td>&nbsp;</td>
										  								<td></td>
										  								<td><input type="checkbox" name="routine<%=routineId%>LogicType" value="<%=RoutineParadigm.END_LOGIC_TYPE%>" <%=routine.isLogicFromType(RoutineParadigm.END_LOGIC_TYPE)?"checked":""%>><span class="NODE_TEXT">End - closes a transaction</span></td>
										  								<td></td>
										  							</tr>
										  						</table>													
																</td>
															</tr>
														</table>
							  					</div>
							  					<div id="routine<%=routineId %>FunctionsDiv" style="display:none">
							  						<jsp:include page="functions.jsp" flush="true" >
															<jsp:param name="nodeId" value="<%=routineId %>"/>
															<jsp:param name="nodeType" value="routine"/>
															<jsp:param name="isView" value="<%=isView %>"/>
														</jsp:include>
								  				</div>
							  					<div id="routine<%=routineId %>ConnectorsDiv" style="display:none">
							  						<jsp:include page="connectors.jsp" flush="true" >
															<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY %>"/>
															<jsp:param name="nodeId" value="<%=routineId %>"/>
															<jsp:param name="nodeType" value="routine"/>
															<jsp:param name="isView" value="<%=isView %>"/>
														</jsp:include>
							  					</div>
							  					<div id="routine<%=routineId %>DataFilterDiv" style="display:none">
							  						<jsp:include page="filters.jsp" flush="true" >
															<jsp:param name="nodeId" value="<%=routineId%>"/>
															<jsp:param name="nodeType" value="routine"/>
															<jsp:param name="isView" value="<%=isView %>"/>
														</jsp:include>
							  					</div>
							  					<div id="routine<%=routineId %>UiSettingsDiv" style="display:none">
							  						<jsp:include page="uiSettings.jsp" flush="true" >
															<jsp:param name="nodeId" value="<%=routineId%>"/>
															<jsp:param name="nodeType" value="routine"/>
															<jsp:param name="isView" value="<%=isView %>"/>
														</jsp:include>
							  					</div>
						  					</div>
						  					</div>
												</td>
											</tr>
										</table>
										