<%@ page language="java" %>

<%@ page import="xpolog.logic.transaction.data.TransactionParadigm"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmBuilder"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%@ include file="getNodesData.jsp"%>

<%

	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute("TRAN_PARADIGM_BUILDER");
	if (builder == null){
		response.sendRedirect("addNewTransaction.jsp");
		return;
	}
	
	String subTransactionId = request.getParameter("subTransactionId");
	String isViewStr = request.getParameter("isView");
	boolean isView = isViewStr != null && isViewStr.equals("true");
	
	getTransactionData(request, builder, null);
	
	NodeModelParadigm[] transactionNodes = builder.getTransactionNodes(builder.getRoot());
  getNodesData(request, builder, transactionNodes, null);
	
  TransactionParadigm root = null;
	if(subTransactionId != null) {
		root = builder.getTransactionById(subTransactionId);
		if(root != null) {
			builder.setRoot(root);
		}
	}
  
  response.setContentType("text/xml");
%>

<jsp:include page="transactionViewUpdate.jsp" flush="true" >
	<jsp:param name="isView" value="<%=isView %>"/>
	<jsp:param name="includeSubTransactionIdElement" value="true"/>
	<jsp:param name="subTransactionId" value="<%=subTransactionId %>"/>
</jsp:include>
