var dsName = "No Use";
var sourceList;
var targetList;
var filterList;
var pageLoded = "firstTime";
var sourceId = "";
var targetId = "";
var routineId = "";
var resultType = -1;

function clearFunctionList(routineId){
  functionList = document.getElementById("routine" + routineId + "FunctionList");
  if (functionList){
    functionList.options.length = 0;
  }
}

var treeAlreadyLoaded = false;
var previousTreeSelection = '';
var treeDiv;
var tree;
function openDataSourceSelection(rId){
	routineId = rId;
	var routineDataSource = document.getElementById("routine" + routineId + "DataSource");
	logId = routineDataSource.value;
	var routineDataSourceFilter = document.getElementById("routine" + routineId + "DataSourceFilter");
	filterId = routineDataSourceFilter.value;
	
	var dataSourceListWrapperDiv = document.getElementById("dataSourceListWrapperDiv");
	dataSourceListWrapperDiv.style.top = 150;
	dataSourceListWrapperDiv.style.left = 200;
	
	if(!treeAlreadyLoaded || (logId != ''  && logId != previousTreeSelection)) {
		treeAlreadyLoaded = true;
	  treeDiv = document.getElementById("treeboxbox_tree");
	  handleInnerHTML(treeDiv, '', 0);
	  
	  tree=new dhtmlXTreeObject("treeboxbox_tree","100%","100%","0");
		tree.setImagePath("../../../");
		tree.setIconSize(13,13);
		tree.focusOnSelectedItem=true;
		tree.treeDivName="treeboxbox_tree";
		tree.itemClick=false;
		tree.enableTreeLines(false);
		tree.setOnLoadingStart(startLoading);
		tree.setOnLoadingEnd(endLoading);
		tree.enableRadioButtons(true);
		tree.enableSingleRadioMode(true);
		tree.useNodeTypeMarking = false;
		tree.markUponCheck = true;
		tree.setOnDblClickHandler(selectDsById);
		tree.setOnClickHandler(checkSelected);
	  tree.setXMLAutoLoading("dsSelectionModuleTreeXML.jsp?routineId=" + routineId + "&logId=" + logId + "&filterId=" + filterId);
	  tree.loadXML("dsSelectionModuleTreeXML.jsp?routineId=" + routineId + "&logId=" + logId + "&filterId=" + filterId);
	}else{
		tree.focusOnSelectedItem=false;
	}
	dataSourceListWrapperDiv.style.display = "";
	
	var dataSourceListDiv = document.getElementById("treeboxbox_tree");
	dataSourceListDiv.style.display = "";
}

function checkSelected(itemId){
	tree.selectItem(itemId);
	tree.setCheck(itemId,1);
}

function markSelectedDs(itemId){
	tree.selectItem(itemId);
}

function selectDsById(id){
	this.setCheck(id,1);
	tree.selectItem(id);
	closeDataSourceSelction();
	selectDataSource("Log","Filter");
}

function selectDataSource(logType, filterType, isView){
  list = tree.getAllChecked();
	arr = list.split(",");
  var logsStr = "";
  var filtersStr = "";
  
	for (var i=0; i<arr.length; i++){
		s = arr[i];
		tree.selectItem(s);
		ind = s.indexOf("-");
		if (ind == -1){
			continue;
		}else{
			type = s.substring(0,ind);
			id = s.substring(ind+1,s.length);
			if (type == logType){
				if (logsStr != ""){
					logsStr += ",";
				}
				logsStr += id;
			}else if (type == filterType){
				if (filtersStr != ""){
					filtersStr += ",";
				}
				filtersStr += id;
				ind = filtersStr.indexOf("#");
				if (ind != -1){
					logsStr = filtersStr.substring(0,ind);
					filtersStr = filtersStr.substring(ind+1,filtersStr.length);
				}
			}
		}
	}
	if(logsStr != '') {
		previousTreeSelection = logsStr;
		var routineDataSource = document.getElementById("routine" + routineId + "DataSource");
		routineDataSource.value = logsStr
		var routineDataSourceFilter = document.getElementById("routine" + routineId + "DataSourceFilter");
		routineDataSourceFilter.value = filtersStr;
		updateDataSource(logsStr, filtersStr, isView);
	}else {
		clearDataSourceAndFilter();
	}
}

var xmlHttpRequestObjectUpdateDataSource;
function updateDataSource(id, filterId, isView) {
	xmlHttpRequestObjectUpdateDataSource = GetXmlHttpObject();
	
	showLayerInMiddle("processingDiv", -1, 150);
  
	var url = "updateDataSource.jsp";
 	var parameters = "";
	parameters += "&id=" + id;
	parameters += "&filterId=" + filterId;
	parameters += "&routineId=" + routineId;
	parameters += "&isView=" + isView;
	parameters += getFormElementsQueryString(document.access);
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectUpdateDataSource.open("POST", url, true);
  xmlHttpRequestObjectUpdateDataSource.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectUpdateDataSource.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectUpdateDataSource.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectUpdateDataSource.onreadystatechange = updateDataSourceCallback;
  xmlHttpRequestObjectUpdateDataSource.send(parameters);
}
		
function updateDataSourceCallback() {
	if (xmlHttpRequestObjectUpdateDataSource.readyState == 4) {
		if (xmlHttpRequestObjectUpdateDataSource.status == 200) {
			hideLayer("processingDiv");
			
			var xmlDoc = xmlHttpRequestObjectUpdateDataSource.responseXML.documentElement;
			var dataSourceElement = xmlDoc.getElementsByTagName("DataSource")[0];
			var isError = dataSourceElement.getAttribute("isError");
			if(isError == 'true') {
				var messagesErrorTd = document.getElementById("messagesErrorTd");
				var errorsInnerHTML = "";
				
				var error = dataSourceElement.getAttribute("error");
				errorsInnerHTML = error;
    		handleInnerHTML(messagesErrorTd, errorsInnerHTML, 1);
				
				showLayerInMiddle("messagesDiv", -1, 150);
			}else {
				var dsid = dataSourceElement.getAttribute("dsid");
				var dsname = dataSourceElement.getAttribute("dsname");
				var names = dataSourceElement.getAttribute("names").split(",");
				var filtersNames = dataSourceElement.getAttribute("filtersNames").split(",");
				var filtersIds = dataSourceElement.getAttribute("filtersIds").split(",");
				var dataFilters = dataSourceElement.getAttribute("dataFilters").split(",");
				
				var filterName = 'None';
				var routineDataSourceFilter = document.getElementById("routine" + routineId + "DataSourceFilter");
				for(var i = 0; i < filtersIds.length; i++) {
					if(routineDataSourceFilter.value == filtersIds[i]) {
						filterName = filtersNames[i];
						break;
					}
				}
				updateRoutineDataSourceAndFilter(routineId, dsname, filterName);
				
				//targetList = document.getElementById("targetList" + routineId);
				//updateList(targetList, names);
				
				updateTransactionView(xmlDoc);
				
				updateAppNameAtomicId();
			}
		}
	}
}

function updateAppNameAtomicId() {
	var appNameAtomicId = document.getElementById("appNameAtomicId");
	var found = false;
	for(var i = 0; i < appNameAtomicId.options.length; i++) {
		if(appNameAtomicId.options[i].value == routineId) {
			found = true;
			break;
		}
	}
	if(found && appNameAtomicId.value == routineId) {
		appNameAtomicId.selectedIndex = 0;
		selectAppNameDataSource('');
	}/*else {
		var routineName = document.getElementById("routine" + routineId + "Name").value;
		appNameAtomicId.options[appNameAtomicId.options.length] = new Option(routineName, routineId);
	}*/
	}	

function closeDataSourceSelction(){
	var dataSourceListDiv = document.getElementById("treeboxbox_tree");
  dataSourceListDiv.style.display = "none";
  
  var dataSourceListWrapperDiv = document.getElementById("dataSourceListWrapperDiv");
  dataSourceListWrapperDiv.style.display = "none";
}

function clearDataSourceAndFilter() {
	updateRoutineDataSourceAndFilter(routineId, 'None', 'None');
}

function updateRoutineDataSourceAndFilter(routineId, dataSourceName, filterName) {
	var routineDataSourceHeaderCell = document.getElementById("routine" + routineId + "DataSourceHeaderCell");
	handleInnerHTML(routineDataSourceHeaderCell, dataSourceName, 1);
	var routineDataSourceCell = document.getElementById("routine" + routineId + "DataSourceCell");
	handleInnerHTML(routineDataSourceCell, dataSourceName, 1);
	
	var routineDataSourceFilterHeaderCell = document.getElementById("routine" + routineId + "DataSourceFilterHeaderCell");
	handleInnerHTML(routineDataSourceFilterHeaderCell, filterName, 1);
	var routineDataSourceFilterCell = document.getElementById("routine" + routineId + "DataSourceFilterCell");
	handleInnerHTML(routineDataSourceFilterCell, filterName, 1);
}

function updateList(list,names){
	if (list != null){
    list.options.length = 0;
    for (var i = 0; i < names.length;i++){
      list[i] = new Option(names[i],"" + i);
    }
  
    if (names.length == 0){
      list[0] = new Option("No data to use",-1);
    }
  }
}

function doUpdate(){
	submitPage("Update");
}

function doSave() {
	var tranName = document.getElementById("tranName");
	if(tranName.value == '') {
		showLayerInMiddle("transactionNameDiv", -1, 150);
		var tranNameFromDiv = document.getElementById("tranNameFromDiv");
		tranNameFromDiv.focus();
	}else {
		hideLayer("transactionNameDiv");
		var checkTopology = document.getElementById("checkTopology");
		checkTopology.value = 'true';
		validateNodesData();
	}
}

function continueSave(doCheckTopology) {
	var transactionNameDiv = document.getElementById("transactionNameDiv");
	var tranNameFromDiv = document.getElementById("tranNameFromDiv");
	if(transactionNameDiv.style.visibility == '' && tranNameFromDiv.value == '') {
		alert('Please specify the name of the transaction');
	}else {
		if(transactionNameDiv.style.visibility == '') {
			var tranName = document.getElementById("tranName");
			tranName.value = tranNameFromDiv.value;
			hideLayer("transactionNameDiv");
		}else {
			hideLayer("validateNodesDiv");
		}
		if(doCheckTopology) {
			var checkTopology = document.getElementById("checkTopology");
			checkTopology.value = doCheckTopology;
		}
		validateNodesData();
	}
}

var xmlHttpRequestObjectValidateNodesData;
function validateNodesData() {
	xmlHttpRequestObjectValidateNodesData = GetXmlHttpObject();
	
	showLayerInMiddle("processingDiv", -1, 150);
  
	var url = "validateNodesData.jsp";
 	var parameters = "";
	parameters += getFormElementsQueryString(document.access);
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectValidateNodesData.open("POST", url, true);
  xmlHttpRequestObjectValidateNodesData.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectValidateNodesData.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectValidateNodesData.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectValidateNodesData.onreadystatechange = validateNodesDataCallback;
  xmlHttpRequestObjectValidateNodesData.send(parameters);
}
		
function validateNodesDataCallback() {
	if (xmlHttpRequestObjectValidateNodesData.readyState == 4) {
		if (xmlHttpRequestObjectValidateNodesData.status == 200) {
			hideLayer("processingDiv");
			
			var xmlDoc = xmlHttpRequestObjectValidateNodesData.responseXML.documentElement;
			var statusElement = xmlDoc.getElementsByTagName("Status")[0];
			var status = statusElement.getAttribute("status");
			var canContinue = statusElement.getAttribute("canContinue");
			
			if(status == "ok") {
				submitPage("Save");
			}else {
				var validateNodesErrorTd = document.getElementById("validateNodesErrorTd");
				var errorsInnerHTML = "";
				
				var errorsElement = xmlDoc.getElementsByTagName("Errors")[0];
				errorsInnerHTML = errorsElement.childNodes[0].nodeValue;
    		handleInnerHTML(validateNodesErrorTd, errorsInnerHTML, 1);
    		
    		var validationNoContinueButtonsDiv = document.getElementById("validationNoContinueButtonsDiv");
    		var validationContinueButtonsDiv = document.getElementById("validationContinueButtonsDiv");
    		if(canContinue == 'true') {
    			validationContinueButtonsDiv.style.display = "";
    			validationNoContinueButtonsDiv.style.display = "none";
    		}else {
    			validationContinueButtonsDiv.style.display = "none";
    			validationNoContinueButtonsDiv.style.display = "";
    		}
				
				showLayerInMiddle("validateNodesDiv", -1, 150);
			}
		}
	}
}

function cancelSave(div) {
	var tranNameFromDiv = document.getElementById("tranNameFromDiv");
	tranNameFromDiv.value = '';
	hideLayer(div);
}

function submitPage(opValue){
  showLayerInMiddle("processingDiv", -1, 150);
  
  selectAllFunctions();
	document.access.OP.value = opValue;
	document.access.action = "TransactionBuilderAction.jsp";
	document.access.submit();
}

var callsCounter = new Date().getTime();

var xmlHttpRequestObjectAddNewEdge;
function addNewEdge(sourceId, sourceType, tableRowId, isView, targetId) {
	xmlHttpRequestObjectAddNewEdge = GetXmlHttpObject();
  
  showLayerInMiddle("processingDiv", -1, 150);

  var tableRow = document.getElementById(tableRowId);
  var rowIndex = tableRow.rowIndex;
  var url = "addNewEdge.jsp";
	var parameters = "";
	parameters += "&sourceId=" + sourceId;
	parameters += "&sourceType=" + sourceType;
	parameters += "&rowIndex=" + rowIndex;
	parameters += "&isView=" + isView;
	parameters += "&targetId=" + targetId;
	parameters += getFormElementsQueryString(document.access);
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectAddNewEdge.open("POST", url, true);
	xmlHttpRequestObjectAddNewEdge.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectAddNewEdge.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectAddNewEdge.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectAddNewEdge.onreadystatechange = addNewEdgeCallback;
  xmlHttpRequestObjectAddNewEdge.send(parameters);
}

function addNewEdgeCallback() {
	if (xmlHttpRequestObjectAddNewEdge.readyState == 4) {
		if (xmlHttpRequestObjectAddNewEdge.status == 200) {
			hideLayer("processingDiv");
  		
		  var xmlDoc = xmlHttpRequestObjectAddNewEdge.responseXML.documentElement;
			updateTransactionView(xmlDoc);
		}
	}
}

var xmlHttpRequestObjectSplitEdge;
function splitEdge(edgeId, isView) {
	xmlHttpRequestObjectSplitEdge = GetXmlHttpObject();
  
	showLayerInMiddle("processingDiv", -1, 150);
  
  var url = "splitEdge.jsp?";
	var parameters = "";
	parameters += "&edgeId=" + edgeId;
	parameters += "&isView=" + isView;
	parameters += getFormElementsQueryString(document.access);
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectSplitEdge.open("POST", url, true);
	xmlHttpRequestObjectSplitEdge.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectSplitEdge.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectSplitEdge.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectSplitEdge.onreadystatechange = splitEdgeCallback;
  xmlHttpRequestObjectSplitEdge.send(parameters);
}

function splitEdgeCallback() {
	if (xmlHttpRequestObjectSplitEdge.readyState == 4) {
		if (xmlHttpRequestObjectSplitEdge.status == 200) {
			hideLayer("processingDiv");
  		
		  var xmlDoc = xmlHttpRequestObjectSplitEdge.responseXML.documentElement;
			updateTransactionView(xmlDoc);
		}
	}
}

var selectedNodeChecks = new Array();
function resetSelectedNodeChecks() {
	selectedNodeChecks = new Array();
}

function selectNodeForGroup(nodeId, nodeType) {
	var checkbox = document.getElementById(nodeType + nodeId + "Check");
	
	if(checkbox.checked) {
		selectedNodeChecks[selectedNodeChecks.length] = checkbox;
		enableAllNodeChecks(false);
		enableGroupableNodeChecks();
	}else {
		if(selectedNodeChecks.length == 0) {
			enableAllNodeChecks(true);
		}else {
			handleUnCheckedCheckbox(checkbox);
		}
	}
}

function handleUnCheckedCheckbox(checkbox) {
	var index = -1;
	for(var i = 0; i < selectedNodeChecks.length; i++) {
		if(selectedNodeChecks[i] == checkbox) {
			index = i;
			break;
		}
	}
	if(index != -1) {
		selectedNodeChecks.splice(index, 1);
		if(selectedNodeChecks.length == 0) {
			enableAllNodeChecks(true);
		}else {
			enableAllNodeChecks(false);
			enableGroupableNodeChecks();
		}
	}
}

function enableGroupableNodeChecks() {
	var nodeCheck;
	var groupableNodes;
	var groupableNodesArr;
	var groupableNodeId;
	var groupableNode;
	
	for(var i = 0; i < selectedNodeChecks.length; i++) {
		nodeCheck = selectedNodeChecks[i];
		nodeCheck.disabled = false;
		groupableNodes = nodeCheck.getAttribute("groupableNodes");
		if(groupableNodes.length > 0) {
			groupableNodesArr = groupableNodes.split(",");
			for(j = 0; j < groupableNodesArr.length; j++) {
				groupableNodeId = groupableNodesArr[j] + "Check";
				groupableNode = document.getElementById(groupableNodeId);
				groupableNode.disabled = false;
			}
		}
	}
}

function enableAllNodeChecks(enabled) {
	var nodeChecks = document.access.nodeChecks;
	var nodeCheck;
	for (var i = 0; i < nodeChecks.length; i++) {
		nodeCheck = nodeChecks[i];
		nodeCheck.disabled = !enabled;
	}
}

function disableNodeChecks(parentTransaction) {
	var enabledNodeChecksIds = new Array();
	var nodeChecks = document.access.nodeChecks;
	var nodeCheck;
	var nodeCheckParentTransaction;
	for (var i = 0; i < nodeChecks.length; i++) {
		nodeCheck = nodeChecks[i];
		nodeCheckParentTransaction = nodeCheck.getAttribute("parentTransaction");
		if(parentTransaction == nodeCheckParentTransaction) {
			enabledNodeChecksIds[enabledNodeChecksIds.length] = nodeCheck.id;
		}else {
			nodeCheck.disabled = true;
		}
	}
	
	return enabledNodeChecksIds;
}

var xmlHttpRequestObjectCreateGroupFromSelected;
function createGroupFromSelected(isView) {
	var nodeChecks = document.access.nodeChecks;
	var nodes = "";
  if(nodeChecks.length) {
		for (var i = 0; i < nodeChecks.length; i++) {
			if(nodeChecks[i].checked) {
				nodes += nodeChecks[i].value;
				nodes += ",";
			}
		}
		if(nodes.length > 0) {
			nodes = nodes.substr(0, nodes.length - 1);
		}
	}else {
		if(nodeChecks.checked) {
			nodes = nodeChecks.value;
		}
	}
	if(nodes.length == 0) {
		alert("No nodes were selected");
		return;
	}
	xmlHttpRequestObjectCreateGroupFromSelected = GetXmlHttpObject();
  
  showLayerInMiddle("processingDiv", -1, 150);
  
  var url = "createGroup.jsp?";
	var parameters = "";
	parameters += "&nodes=" + nodes;
	parameters += "&isView=" + isView;
	parameters += getFormElementsQueryString(document.access);
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectCreateGroupFromSelected.open("POST", url, true);
	xmlHttpRequestObjectCreateGroupFromSelected.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectCreateGroupFromSelected.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectCreateGroupFromSelected.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectCreateGroupFromSelected.onreadystatechange = createGroupFromSelectedCallback;
  xmlHttpRequestObjectCreateGroupFromSelected.send(parameters);
}

function createGroupFromSelectedCallback() {
	if (xmlHttpRequestObjectCreateGroupFromSelected.readyState == 4) {
		if (xmlHttpRequestObjectCreateGroupFromSelected.status == 200) {
			hideLayer("processingDiv");
  		
		  var xmlDoc = xmlHttpRequestObjectCreateGroupFromSelected.responseXML.documentElement;
			updateTransactionView(xmlDoc);
		}
	}
}

var xmlHttpRequestObjectInsertNewStartPoint;
function insertNewStartPoint(nodeType) {
	xmlHttpRequestObjectInsertNewStartPoint = GetXmlHttpObject();
  
  showLayerInMiddle("processingDiv", -1, 150);
  
  var url = "insertNewStartPoint.jsp?";
	var parameters = "";
	parameters += "nodeType=" + nodeType;
	parameters += getFormElementsQueryString(document.access);
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectInsertNewStartPoint.open("POST", url, true);
	xmlHttpRequestObjectInsertNewStartPoint.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectInsertNewStartPoint.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectInsertNewStartPoint.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectInsertNewStartPoint.onreadystatechange = insertNewStartPointCallback;
  xmlHttpRequestObjectInsertNewStartPoint.send(parameters);
}

function insertNewStartPointCallback() {
	if (xmlHttpRequestObjectInsertNewStartPoint.readyState == 4) {
		if (xmlHttpRequestObjectInsertNewStartPoint.status == 200) {
			hideLayer("processingDiv");
  		
		  var xmlDoc = xmlHttpRequestObjectInsertNewStartPoint.responseXML.documentElement;
			updateTransactionView(xmlDoc);
		}
	}
}

var xmlHttpRequestObjectInsertToGroup;
function insertToGroup(nodeType, nodeId, groupId, insertionType, targetId, isView) {
	xmlHttpRequestObjectInsertToGroup = GetXmlHttpObject();
  
  showLayerInMiddle("processingDiv", -1, 150);
  
  var url = "insertToGroup.jsp?";
	var parameters = "";
	parameters += "&nodeType=" + nodeType;
	parameters += "&nodeId=" + nodeId;
	parameters += "&groupId=" + groupId;
	parameters += "&insertionType=" + insertionType;
	parameters += "&targetId=" + targetId;
	parameters += "&isView=" + isView;
	parameters += getFormElementsQueryString(document.access);
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectInsertToGroup.open("POST", url, true);
	xmlHttpRequestObjectInsertToGroup.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectInsertToGroup.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectInsertToGroup.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectInsertToGroup.onreadystatechange = insertToGroupCallback;
  xmlHttpRequestObjectInsertToGroup.send(parameters);
}

function insertToGroupCallback() {
	if (xmlHttpRequestObjectInsertToGroup.readyState == 4) {
		if (xmlHttpRequestObjectInsertToGroup.status == 200) {
			hideLayer("processingDiv");
  		
		  var xmlDoc = xmlHttpRequestObjectInsertToGroup.responseXML.documentElement;
			updateTransactionView(xmlDoc);
		}
	}
}

var xmlHttpRequestObjectExtractNode;
function extractNode(nodeType, nodeId, groupId, extractionType, targetId, isView) {
	xmlHttpRequestObjectExtractNode = GetXmlHttpObject();
  
  showLayerInMiddle("processingDiv", -1, 150);
  
  var url = "extractNode.jsp?";
	var parameters = "";
	parameters += "&nodeType=" + nodeType;
	parameters += "&nodeId=" + nodeId;
	parameters += "&groupId=" + groupId;
	parameters += "&extractionType=" + extractionType;
	parameters += "&targetId=" + targetId;
	parameters += "&isView=" + isView;
	parameters += getFormElementsQueryString(document.access);
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectExtractNode.open("POST", url, true);
	xmlHttpRequestObjectExtractNode.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectExtractNode.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectExtractNode.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectExtractNode.onreadystatechange = extractNodeCallback;
  xmlHttpRequestObjectExtractNode.send(parameters);
}

function extractNodeCallback() {
	if (xmlHttpRequestObjectExtractNode.readyState == 4) {
		if (xmlHttpRequestObjectExtractNode.status == 200) {
			hideLayer("processingDiv");
  		
		  var xmlDoc = xmlHttpRequestObjectExtractNode.responseXML.documentElement;
			updateTransactionView(xmlDoc);
		}
	}
}

var xmlHttpRequestObjectSetDummyAs;
function setDummyAs(nodeId, nodeType, isView) {
	xmlHttpRequestObjectSetDummyAs = GetXmlHttpObject();
  
  showLayerInMiddle("processingDiv", -1, 150);
  var url = "setDummyAs.jsp?";
	var parameters = "";
	parameters += "&nodeId=" + nodeId;
	parameters += "&nodeType=" + nodeType;
	parameters += "&isView=" + isView;
	parameters += getFormElementsQueryString(document.access);
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectSetDummyAs.open("POST", url, true);
	xmlHttpRequestObjectSetDummyAs.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectSetDummyAs.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectSetDummyAs.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectSetDummyAs.onreadystatechange = setDummyAsCallback;
  xmlHttpRequestObjectSetDummyAs.send(parameters);
}

function setDummyAsCallback() {
	if (xmlHttpRequestObjectSetDummyAs.readyState == 4) {
		if (xmlHttpRequestObjectSetDummyAs.status == 200) {
			hideLayer("processingDiv");
  		
		  var xmlDoc = xmlHttpRequestObjectSetDummyAs.responseXML.documentElement;
			updateTransactionView(xmlDoc);
		}
	}
}

var xmlHttpRequestObjectRemoveNode;
function removeNode(nodeType, nodeId) {
	xmlHttpRequestObjectRemoveNode = GetXmlHttpObject();
  
  showLayerInMiddle("processingDiv", -1, 150);
  
  var url = "removeNode.jsp?";
	var parameters = "";
	parameters += "&nodeId=" + nodeId;
	parameters += "&nodeType=" + nodeType;
	parameters += getFormElementsQueryString(document.access);
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectRemoveNode.open("POST", url, true);
	xmlHttpRequestObjectRemoveNode.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectRemoveNode.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectRemoveNode.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectRemoveNode.onreadystatechange = removeNodeCallback;
  xmlHttpRequestObjectRemoveNode.send(parameters);
}

function removeNodeCallback() {
	if (xmlHttpRequestObjectRemoveNode.readyState == 4) {
		if (xmlHttpRequestObjectRemoveNode.status == 200) {
			hideLayer("processingDiv");
  		
		  var xmlDoc = xmlHttpRequestObjectRemoveNode.responseXML.documentElement;
			updateTransactionView(xmlDoc);
		}
	}
}

var nodeClicked;

var xmlHttpRequestObjectShowTransaction;
function showTransaction(subTransactionId, isView) {
	nodeClicked = false;
	hideNodeData();
	
	xmlHttpRequestObjectShowTransaction = GetXmlHttpObject();
  
	showLayerInMiddle("processingDiv", -1, 150);
  
  var url = "showTransaction.jsp?";
	var parameters = "";
	parameters += "&subTransactionId=" + subTransactionId;
	parameters += "&isView=" + isView;
	parameters += getFormElementsQueryString(document.access);
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectShowTransaction.open("POST", url, true);
	xmlHttpRequestObjectShowTransaction.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectShowTransaction.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectShowTransaction.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectShowTransaction.onreadystatechange = showTransactionCallback;
  xmlHttpRequestObjectShowTransaction.send(parameters);
}

function showTransactionCallback() {
	if (xmlHttpRequestObjectShowTransaction.readyState == 4) {
		if (xmlHttpRequestObjectShowTransaction.status == 200) {
			hideLayer("processingDiv");
  		
		  var xmlDoc = xmlHttpRequestObjectShowTransaction.responseXML.documentElement;
			updateTransactionView(xmlDoc);
		}
	}
}

var xmlHttpRequestObjectUpdateBuilder;
function updateBuilder(isView) {
	xmlHttpRequestObjectUpdateBuilder = GetXmlHttpObject();
  
	showLayerInMiddle("processingDiv", -1, 150);
  
  var url = "updateBuilder.jsp?";
	var parameters = "";
	parameters += "&isView=" + isView;
	parameters += getFormElementsQueryString(document.access);
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectUpdateBuilder.open("POST", url, true);
	xmlHttpRequestObjectUpdateBuilder.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectUpdateBuilder.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectUpdateBuilder.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectUpdateBuilder.onreadystatechange = updateBuilderCallback;
  xmlHttpRequestObjectUpdateBuilder.send(parameters);
}

function updateBuilderCallback() {
	if (xmlHttpRequestObjectUpdateBuilder.readyState == 4) {
		if (xmlHttpRequestObjectUpdateBuilder.status == 200) {
			hideLayer("processingDiv");
  		
		  var xmlDoc = xmlHttpRequestObjectUpdateBuilder.responseXML.documentElement;
			updateTransactionView(xmlDoc);
			
			var transactionVisualViewTabDiv = document.getElementById("transactionVisualViewDiv");
			if(transactionVisualViewTabDiv.style.display == "") {
				showTransactionTab(0);
			}else {
				showTransactionTab(1);
			}
		}
	}
}

function getElementValue(element) {
	var elementValue = "";
	if(document.all) {
		elementValue = element.childNodes[0].nodeValue;
	}else {
		elementValue = element.childNodes[1].nodeValue;
	}
	return elementValue;
}

function updateTransactionView(xmlDoc) {
	hideNodeMenuImageDiv();
	hideNodeData();
	resetSelectedNodeChecks();
	document.body.style.cursor='default';
	
	if(xmlDoc.getElementsByTagName("TransactionHeader").length > 0) {
		// update the transaction header
		var transactionHeaderElement = xmlDoc.getElementsByTagName("TransactionHeader")[0];
		var transactionHeaderStr = getElementValue(transactionHeaderElement);
		var transactionHeader = document.getElementById('transactionHeader');
		handleInnerHTML(transactionHeader, transactionHeaderStr, 1);
	}
	
	// update the graph image
	var imageElement = xmlDoc.getElementsByTagName("Image")[0];
	var src = imageElement.getAttribute("src");
	var graphImageDiv = document.getElementById("graphImageDiv");
	handleInnerHTML(graphImageDiv, "<img id=\"graphImage\" src=\"" + baseDirectory + src + "\" USEMAP=\"#graphMap\" border=\"0\">", 0);
	
	// update the graph mapping
	var mappingElement = xmlDoc.getElementsByTagName("Mapping")[0];
	var mappingStr = getElementValue(mappingElement);
	var graphMap = document.getElementById('graphMap');
	handleInnerHTML(graphMap, mappingStr, 0);
	
	// update the nodes div
	var nodesDivElement = xmlDoc.getElementsByTagName("NodesDiv")[0];
	var nodesDivHtml = getElementValue(nodesDivElement);
	var nodesDiv = document.getElementById('nodesDiv');
	handleInnerHTML(nodesDiv, nodesDivHtml, 1);
	
	if(xmlDoc.getElementsByTagName("NodeAttributes").length > 0) {
		var nodeAttributesElement = xmlDoc.getElementsByTagName("NodeAttributes")[0];
		var nodeType = nodeAttributesElement.getAttribute("nodeType");
		var nodeId = nodeAttributesElement.getAttribute("nodeId");
		var showNodeMenuImage = nodeAttributesElement.getAttribute("showNodeMenuImage");
		var x = nodeAttributesElement.getAttribute("x");
		var y = nodeAttributesElement.getAttribute("y");
		
		handleCurrentNode(nodeType, nodeId);
		
		if(showNodeMenuImage == 'true' && x != -1 && y != -1) {
			doShowNodeMenuImage(x, y);
		}
		clickNode(nodeId, nodeType, false, true);
	}
	var imgHeight = imageElement.getAttribute("height");
	updateTableHeight(imgHeight);
	var imgWidth = imageElement.getAttribute("width");
	if(imgWidth && imgWidth <= document.body.clientWidth) {
		var scrollElementX = document.getElementById("transactionVisualViewInnerDiv");
		scrollElementX.scrollLeft = 0;
	}
	updateImageWidth(imgWidth);
	
	// update the application name routines list
	var appNameElement = xmlDoc.getElementsByTagName("AppName")[0];
	var appNameRoutines = getElementValue(appNameElement);
	var appNameRoutinesTd = document.getElementById('appNameRoutines');
	handleInnerHTML(appNameRoutinesTd, appNameRoutines, 0);
}

/*function handleInnerHTML(element, html, type) {
	if(type == 0) {
		deleteChildren(element);
		element.innerHTML = html;
	}else if(type == 1) {
		replaceHTML(element, html);
	}
}

function deleteChildren(node) {
	if(node){
		for(var x = node.childNodes.length - 1; x >= 0; x--){
			var childNode = node.childNodes[x];
			if(childNode.hasChildNodes()){
				deleteChildren(childNode);
			}
			removeNodeEventListeners(childNode);
   		node.removeChild(childNode);
			if(childNode.outerHTML){
				childNode.outerHTML = '';
			}
			childNode=null;   
		}
		node=null;
	}
}

function removeNodeEventListeners(node) {
	removeNodeEventListener(node, "click");
	removeNodeEventListener(node, "mouseover");
	removeNodeEventListener(node, "mouseout");
	removeNodeEventListener(node, "change");
}

function removeNodeEventListener(node, event) {
	if(eval("node.on" + event)) {
		if(document.all) {
			node.detachEvent("on" + event, eval("node.on" + event));
		}else {
			node.removeEventListener(event, eval("node.on" + event), false);
		}
	}
}

function replaceHTML(el, html) {
	var oldEl = (typeof el === "string" ? document.getElementById(el) : el);
	var newEl = document.createElement(oldEl.nodeName);
	// Preserve the element's id, class and style (other properties are lost)
	newEl.id = oldEl.id;
	newEl.className = oldEl.className;
	newEl.style.display = oldEl.style.display;
	// Replace the old with the new
	newEl.innerHTML = html;
	oldEl.parentNode.replaceChild(newEl, oldEl);
	// Since we just removed the old element from the DOM, return a reference
	// to the new element, which can be used to restore variable references.
	return newEl;
}*/

function doShowNodeMenuImage(x, y) {
	if(x != -1 && y != -1) {
		var	graphImage = document.getElementById('graphImage');
		var graphImagePosition = findPos(graphImage);
		var nodeMenuImageX = graphImagePosition[0] + parseInt(x) + 15;
		var nodeMenuImageY = graphImagePosition[1] + parseInt(y) + 30;
		
		if(nodeMenuImageX > document.body.clientWidth) {
			var scrollElementX = document.getElementById("transactionVisualViewInnerDiv");
			scrollElementX.scrollLeft = nodeMenuImageX - document.body.clientWidth + 35;
		}
		
		showNodeMenuImageDiv(nodeMenuImageX, nodeMenuImageY);
		if(currentNodeType == 'dummy') {
			showNodeMenu();
		}
	}
}

function newFunction(nodeId, nodeType, isView) {
	updateFunctionTypeSelectedIndex(nodeId, nodeType, 0);
	selectFunctionType(nodeId, nodeType, isView);
	handleFunctionClick('');
}

var xmlHttpRequestObjectSelectFunctionType;
function selectFunctionType(nodeId, nodeType, isView) {
	var functionType = document.getElementById(nodeType + nodeId + "FunctionType");
	if(functionType.selectedIndex == 0) {
		var functionBodyTd = document.getElementById(nodeType + nodeId + "FunctionBody");
		handleInnerHTML(functionBodyTd, '', 1);
		
		handleFunctionClick('');
		
		return;
	}
	xmlHttpRequestObjectSelectFunctionType = GetXmlHttpObject();
  
  var functionType = document.getElementById(nodeType + nodeId + "FunctionType").value;
	
  var url = "selectFunctionType.jsp?";
	var parameters = "";
	parameters += "functionType=" + functionType;
	parameters += "&nodeId=" + nodeId;
	parameters += "&nodeType=" + nodeType;
	parameters += "&isView=" + isView;
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectSelectFunctionType.open("POST", url, true);
	xmlHttpRequestObjectSelectFunctionType.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectSelectFunctionType.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectSelectFunctionType.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectSelectFunctionType.onreadystatechange = selectFunctionTypeCallback;
  xmlHttpRequestObjectSelectFunctionType.send(parameters);
}

function selectFunctionTypeCallback() {
	if (xmlHttpRequestObjectSelectFunctionType.readyState == 4) {
		if (xmlHttpRequestObjectSelectFunctionType.status == 200) {
		  var xmlDoc = xmlHttpRequestObjectSelectFunctionType.responseXML.documentElement;
			updateFunctionBody(xmlDoc, false);
		}
	}
}

var xmlHttpRequestObjectSelectRoutine;
function selectRoutine(nodeId, nodeType, routineType) {
  var routinesList;
  var routineComunNamesList;
  var routineId;
  if(routineType == 'source') {
  	routinesList = document.getElementById(nodeType + nodeId + "SourceId");
  	routineComunNamesList = document.getElementById("sourceList" + nodeId + nodeType);
  }else if(routineType == 'target') {
  	routinesList = document.getElementById(nodeType + nodeId + "TargetId");
  	routineComunNamesList = document.getElementById("targetList" + nodeId + nodeType);
  }
  routineId = routinesList.value;
  if(routineId == "") {
		for(var i = routineComunNamesList.options.length; i >= 0; --i) {
	    routineComunNamesList.options[i] = null;
	  }
	  routineComunNamesList.options[0] = new Option("No data to use","");
  	return;
  }
	
  xmlHttpRequestObjectSelectRoutine = GetXmlHttpObject();
  
  var url = "selectRoutine.jsp?";
	var parameters = "";
	parameters += "&routineId=" + routineId;
	parameters += "&targetElement=" + routineType + nodeId + "ColumnNames";
	parameters += "&selectName=" + routineType + "List" + nodeId + nodeType;
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectSelectRoutine.open("POST", url, true);
	xmlHttpRequestObjectSelectRoutine.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectSelectRoutine.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectSelectRoutine.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectSelectRoutine.onreadystatechange = selectRoutineCallback;
  xmlHttpRequestObjectSelectRoutine.send(parameters);
}

function selectAppNameDataSource(routineId) {
	var sourceListappNameList = document.getElementById("sourceListappNameList");
	if(routineId == "") {
		for(var i = sourceListappNameList.options.length; i >= 0; --i) {
	    sourceListappNameList.options[i] = null;
	  }
	  sourceListappNameList.options[0] = new Option("No data to use","");
  	return;
  }
  
	xmlHttpRequestObjectSelectRoutine = GetXmlHttpObject();
  
  var url = "selectRoutine.jsp?";
	var parameters = "";
	parameters += "&routineId=" + routineId;
	parameters += "&targetElement=appNameColumnNames";
	parameters += "&selectName=sourceListappNameList";
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectSelectRoutine.open("POST", url, true);
	xmlHttpRequestObjectSelectRoutine.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectSelectRoutine.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectSelectRoutine.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectSelectRoutine.onreadystatechange = selectRoutineCallback;
  xmlHttpRequestObjectSelectRoutine.send(parameters);
}

function selectRoutineCallback() {
	if (xmlHttpRequestObjectSelectRoutine.readyState == 4) {
		if (xmlHttpRequestObjectSelectRoutine.status == 200) {
		  var xmlDoc = xmlHttpRequestObjectSelectRoutine.responseXML.documentElement;
			updateRoutineColumnNames(xmlDoc);
		}
	}
}

function updateRoutineColumnNames(xmlDoc) {
	var routineColumnNamesElement = xmlDoc.getElementsByTagName("RoutineColumnNames")[0];
	var targetElement = routineColumnNamesElement.getAttribute("targetElement");
	var routineColumnNames = getElementValue(routineColumnNamesElement);
	var routineColumnNamesTd = document.getElementById(targetElement);
	handleInnerHTML(routineColumnNamesTd, routineColumnNames, 0);
}

var xmlHttpRequestObjecAddFunction;
function addFunction(functionType, nodeId, nodeType, isView) {
	xmlHttpRequestObjecAddFunction = GetXmlHttpObject();
  
  var url = "addFunction.jsp?";
	var parameters = "";
	parameters += "&functionType=" + functionType;
	parameters += "&nodeId=" + nodeId;
	parameters += "&nodeType=" + nodeType;
	parameters += "&isView=" + isView;
	if(functionType == 'equals') {
		var paramName, paramValue;
		paramName = nodeType + nodeId + "SourceId";
		paramValue = document.getElementById(paramName).value;
		parameters += "&" + paramName + "=" + paramValue;
		paramName = nodeType + nodeId + "TargetId";
		paramValue = document.getElementById(paramName).value;
		parameters += "&" + paramName + "=" + paramValue;
		paramName = nodeType + nodeId + "FunctionList";
		var functionList = document.getElementById(paramName);
		paramValue = "";
		for(var i = 0; i < functionList.options.length; i++) {
			paramValue += functionList.options[i].value;
			if(i != functionList.options.length - 1) {
				paramValue += ",";
			}
		}
		parameters += "&" + paramName + "=" + paramValue;
	}
	//parameters += getFormElementsQueryString(document.access);
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjecAddFunction.open("POST", url, true);
	xmlHttpRequestObjecAddFunction.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjecAddFunction.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjecAddFunction.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjecAddFunction.onreadystatechange = addFunctionCallback;
  xmlHttpRequestObjecAddFunction.send(parameters);
}

function addFunctionCallback() {
	if (xmlHttpRequestObjecAddFunction.readyState == 4) {
		if (xmlHttpRequestObjecAddFunction.status == 200) {
		  var xmlDoc = xmlHttpRequestObjecAddFunction.responseXML.documentElement;
			updateFunctionsList(xmlDoc);
		}
	}
}

var xmlHttpRequestObjecEditFunction;
function editFunction(functionType, functionId, nodeId, nodeType, isView) {
	xmlHttpRequestObjecEditFunction = GetXmlHttpObject();
  
  var url = "addFunction.jsp?";
	var parameters = "";
	parameters += "&functionType=" + functionType;
	parameters += "&functionId=" + functionId;
	parameters += "&nodeId=" + nodeId;
	parameters += "&nodeType=" + nodeType;
	parameters += "&isView=" + isView;
	if(functionType == 'equals') {
		var paramName, paramValue;
		paramName = nodeType + nodeId + "SourceId";
		paramValue = document.getElementById(paramName).value;
		parameters += "&" + paramName + "=" + paramValue;
		paramName = nodeType + nodeId + "TargetId";
		paramValue = document.getElementById(paramName).value;
		parameters += "&" + paramName + "=" + paramValue;
		paramName = nodeType + nodeId + "FunctionList";
		var functionList = document.getElementById(paramName);
		paramValue = "";
		for(var i = 0; i < functionList.options.length; i++) {
			paramValue += functionList.options[i].value;
			if(i != functionList.options.length - 1) {
				paramValue += ",";
			}
		}
		parameters += "&" + paramName + "=" + paramValue;
	}
	//parameters += getFormElementsQueryString(document.access);
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjecEditFunction.open("POST", url, true);
	xmlHttpRequestObjecEditFunction.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjecEditFunction.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjecEditFunction.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjecEditFunction.onreadystatechange = editFunctionCallback;
  xmlHttpRequestObjecEditFunction.send(parameters);
}

function editFunctionCallback() {
	if (xmlHttpRequestObjecEditFunction.readyState == 4) {
		if (xmlHttpRequestObjecEditFunction.status == 200) {
		  var xmlDoc = xmlHttpRequestObjecEditFunction.responseXML.documentElement;
			updateFunctionsList(xmlDoc);
		}
	}
}

var xmlHttpRequestObjecShowFunction;
function showFunction(nodeId, nodeType, functionId, isView) {
	xmlHttpRequestObjecShowFunction = GetXmlHttpObject();
  
  var url = "showFunction.jsp?";
	var parameters = "";
	parameters += "&functionId=" + functionId;
	parameters += "&nodeId=" + nodeId;
	parameters += "&nodeType=" + nodeType;
	parameters += "&isView=" + isView;
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjecShowFunction.open("POST", url, true);
	xmlHttpRequestObjecShowFunction.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjecShowFunction.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjecShowFunction.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjecShowFunction.onreadystatechange = showFunctionCallback;
  xmlHttpRequestObjecShowFunction.send(parameters);
}

function showFunctionCallback() {
	if (xmlHttpRequestObjecShowFunction.readyState == 4) {
		if (xmlHttpRequestObjecShowFunction.status == 200) {
		  var xmlDoc = xmlHttpRequestObjecShowFunction.responseXML.documentElement;
		  updateFunctionBody(xmlDoc, true);
		}
	}
}

var xmlHttpRequestObjecRemoveFunction;
function removeFunction(nodeId, nodeType, functionId, isView) {
	xmlHttpRequestObjecRemoveFunction = GetXmlHttpObject();
  
  var url = "removeFunction.jsp?";
	var parameters = "";
	parameters += "&functionId=" + functionId;
	parameters += "&nodeId=" + nodeId;
	parameters += "&nodeType=" + nodeType;
	parameters += "&isView=" + isView;
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjecRemoveFunction.open("POST", url, true);
	xmlHttpRequestObjecRemoveFunction.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjecRemoveFunction.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjecRemoveFunction.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjecRemoveFunction.onreadystatechange = removeFunctionCallback;
  xmlHttpRequestObjecRemoveFunction.send(parameters);
}

function removeFunctionCallback() {
	if (xmlHttpRequestObjecRemoveFunction.readyState == 4) {
		if (xmlHttpRequestObjecRemoveFunction.status == 200) {
		  var xmlDoc = xmlHttpRequestObjecRemoveFunction.responseXML.documentElement;
		  updateFunctionsList(xmlDoc);
		}
	}
}

function updateFunctionsList(xmlDoc) {
	var functionsListElement = xmlDoc.getElementsByTagName("FunctionsList")[0];
	var nodeId = functionsListElement.getAttribute("nodeId");
	var nodeType = functionsListElement.getAttribute("nodeType");
	var isView = functionsListElement.getAttribute("isView");
	var functionsList = getElementValue(functionsListElement);
	var functionsListTd = document.getElementById(nodeType + nodeId + "FunctionsList");
	handleInnerHTML(functionsListTd, functionsList, 0);
	
	updateFunctionTypeSelectedIndex(nodeId, nodeType, 0);
	selectFunctionType(nodeId, nodeType, isView);
}

function updateFunctionBody(xmlDoc, doUpdateFunctionTypeSelectedIndex) {
	var functionBodyElement = xmlDoc.getElementsByTagName("FunctionBody")[0];
	var nodeId = functionBodyElement.getAttribute("nodeId");
	var nodeType = functionBodyElement.getAttribute("nodeType");
	var functionId = functionBodyElement.getAttribute("functionId");
	var functionBody = getElementValue(functionBodyElement);
	var functionBodyTd = document.getElementById(nodeType + nodeId + "FunctionBody");
	handleInnerHTML(functionBodyTd, functionBody, 0);

	handleFunctionClick(functionId);

	if(doUpdateFunctionTypeSelectedIndex) {
		updateFunctionTypeSelectedIndex(nodeId, nodeType, 1);
	}
}

var previousFunctionId;
function handleFunctionClick(functionId) {
	var previousFunctionLink = document.getElementById("function" + previousFunctionId + "Link");
	var previousRemoveImageDiv = document.getElementById("function" + previousFunctionId + "RemoveImageDiv");
	if(previousFunctionLink && previousFunctionId != functionId) {
		previousFunctionLink.className = "FUNCTION_TEXT";
		var previousConnectorTr = document.getElementById("function" + previousFunctionId + "Tr");
		previousConnectorTr.bgColor = "";
		handleInnerHTML(previousRemoveImageDiv, "<img border='0' id='function" + previousFunctionId + "RemoveImage' src='" + baseDirectory + "logic/images/tranview/remove.gif'>", 0);
	}
	
	if(functionId != '') {
		var functionLink = document.getElementById("function" + functionId + "Link");
		functionLink.className = "SELECTED_FUNCTION_TEXT";
		var functionTr = document.getElementById("function" + functionId + "Tr");
		functionTr.bgColor = "#949293";
		var removeImageDiv = document.getElementById("function" + functionId + "RemoveImageDiv");
		handleInnerHTML(removeImageDiv, "<img border='0' id='function" + functionId + "RemoveImage' src='" + baseDirectory + "logic/images/tranview/removeFunctionSelected.gif'>", 0);
	}
	previousFunctionId = functionId;
}

function updateFunctionTypeSelectedIndex(nodeId, nodeType, index) {
	var functionTypeList = document.getElementById(nodeType + nodeId + "FunctionType");
	functionTypeList.selectedIndex = index;
}

function doClickNode(nodeId, nodeType, closeIfOpen, doScrollToNode) {
	nodeClicked = true;
	setTimeout("clickNodeIfNoDoubleClick('" + nodeId + "', '" + nodeType + "', " + closeIfOpen + ", " + doScrollToNode + ")", 250);
}

function clickNodeIfNoDoubleClick(nodeId, nodeType, closeIfOpen, doScrollToNode) {
	if(nodeClicked) { 
		clickNode(nodeId, nodeType, closeIfOpen, doScrollToNode);
	}
}

function clickNode(nodeId, nodeType, closeIfOpen, doScrollToNode, selectedTab) {
	if(nodeType == 'subTransaction') {
		var subTransactionBodyDiv = document.getElementById("subTransaction" + nodeId + "BodyDiv");
		if(!subTransactionBodyDiv) {
			return;
		}
		var subTransactionArrowImage = document.getElementById("subTransaction" + nodeId + "ArrowImage");
		if(subTransactionBodyDiv.style.display == "" && closeIfOpen) {
			hideNodeTabs(nodeId, nodeType);
			subTransactionArrowImage.src = baseDirectory + "logic/images/tranview/closedRoutineArrow.gif";
		}else {
			var parentTransaction = subTransactionBodyDiv.getAttribute("parentTransaction");
			if(parentTransaction != "") {
				clickNode(parentTransaction, 'subTransaction', false, false, 0);
			}
			showNodeTabs(nodeId, nodeType);
			if(doScrollToNode) {
				scrollToNode(nodeType, nodeId);
			}
			subTransactionArrowImage.src = baseDirectory + "logic/images/tranview/openRoutineArrow.gif";
			var length = arguments.length;
			if(length > 4) {
				showSubTransactionTab(nodeId, selectedTab);
			}
		}
	}else  if(nodeType == 'routine') {
		var routineBodyDiv = document.getElementById("routine" + nodeId + "BodyDiv");
		var routineArrowImage = document.getElementById("routine" + nodeId + "ArrowImage");
		if(routineBodyDiv.style.display == "" && closeIfOpen) {
			hideNodeTabs(nodeId, nodeType);
			routineArrowImage.src = baseDirectory + "logic/images/tranview/closedRoutineArrow.gif";
		}else {
			var parentTransaction = routineBodyDiv.getAttribute("parentTransaction");
			if(parentTransaction != "") {
				clickNode(parentTransaction, 'subTransaction', false, false, 0);
			}
			showNodeTabs(nodeId, nodeType);
			if(doScrollToNode) {
				scrollToNode(nodeType, nodeId);
			}
			routineArrowImage.src = baseDirectory + "logic/images/tranview/openRoutineArrow.gif";
			var length = arguments.length;
			if(length > 4) {
				showSubTransactionTab(nodeId, selectedTab);
			}
		}
	}
}

function clickConnector(edgeId, nodeType, nodeId) {
	clickNode(nodeId, nodeType, false, true);
	if(nodeType == 'subTransaction') {
		showSubTransactionTab(nodeId, 3);
	}else if(nodeType == 'routine') {
		showRoutineTab(nodeId, 2);
	}
	showConnector(edgeId);
}

var previousConnectorId;
function showConnector(connectorId) {
	var previousConnectorDiv = document.getElementById("edge" + previousConnectorId + "Div");
	if(previousConnectorDiv && previousConnectorDiv.style.display == "" && previousConnectorId != connectorId) {
		changeDivDisplayMode(previousConnectorDiv, "none");
		var previousConnectorLink = document.getElementById("edge" + previousConnectorId + "Link");
		previousConnectorLink.className = "EDGE_TEXT";
		var previousConnectorTr = document.getElementById("edge" + previousConnectorId + "Tr");
		previousConnectorTr.bgColor = "";
	}
	
	var connectorDiv = document.getElementById("edge" + connectorId + "Div");
	changeDivDisplayMode(connectorDiv, "");
	var connectorLink = document.getElementById("edge" + connectorId + "Link");
	connectorLink.className = "SELECTED_EDGE_TEXT";
	var connectorTr = document.getElementById("edge" + connectorId + "Tr");
	connectorTr.bgColor = "#949293";
	previousConnectorId = connectorId;
}
		
var currentNodeId = "";
var currentNodeType = "";
var previousNodeId = "";
var isMouseOverNode;
var xmlHttpRequestObjectMouseOver;
function onMouseOverNode(nodeId, nodeType) {
	isMouseOverNodeData = false;
	window.clearTimeout(hideNodeDataIfNeededTimeoutId);
	if(nodeType == 'dummy') {
		hideNodeData();
	}
  isMouseOverNode = true;

  handleCurrentNode(nodeType, nodeId);
	
	 	xmlHttpRequestObjectMouseOver = GetXmlHttpObject();
	  
	  var url = "getNodeData.jsp";
	  var parameters = "";
		parameters += "nodeType=" + nodeType;
		parameters += "&nodeId=" + nodeId;
	  parameters += "&counter=" + callsCounter++;
		xmlHttpRequestObjectMouseOver.open("POST", url, true);
	  xmlHttpRequestObjectMouseOver.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	  xmlHttpRequestObjectMouseOver.setRequestHeader("Content-length", parameters.length);
	  xmlHttpRequestObjectMouseOver.setRequestHeader("Connection", "close");
	  xmlHttpRequestObjectMouseOver.onreadystatechange = onMouseOverNodeCallback;
	  xmlHttpRequestObjectMouseOver.send(parameters);
}

function handleCurrentNode(nodeType, nodeId) {
	previousNodeId = currentNodeId;
  currentNodeId = nodeId;
  currentNodeType = nodeType;
}
		
function onMouseOverNodeCallback() {
	if (xmlHttpRequestObjectMouseOver.readyState == 4) {
		if (xmlHttpRequestObjectMouseOver.status == 200) {
			if(isMouseOverNode) {
				var xmlDoc = xmlHttpRequestObjectMouseOver.responseXML.documentElement;
				showNodeElements(xmlDoc);
			}
		}
	}
}

function showNodeElements(xmlDoc) {
	var nodeElement = xmlDoc.getElementsByTagName("Node")[0];
	var type = nodeElement.getAttribute("type");
	var id = nodeElement.getAttribute("id");
	var name = nodeElement.getAttribute("name");
	var x = nodeElement.getAttribute("x");
	var y = nodeElement.getAttribute("y");
	
	var nodeDataDiv = document.getElementById("nodeDataDiv");
	var nodeDataDivInnerHtml = getElementValue(nodeElement);
	var	graphImage = document.getElementById('graphImage');
	var graphImagePosition = findPos(graphImage);
	
	if(type == 'subTransaction') {
		var nodeDataDivX = graphImagePosition[0] + parseInt(x) + 40;
		var nodeDataDivY = graphImagePosition[1] + parseInt(y) - 60;
		showNodeData(nodeDataDivX, nodeDataDivY, nodeDataDivInnerHtml);
		
		// update the graph mapping
		var mappingElement = xmlDoc.getElementsByTagName("Mapping")[0];
		var mappingStr = getElementValue(mappingElement);
		var subTransactionMap = document.getElementById('subTransactionMap');
		handleInnerHTML(subTransactionMap, mappingStr, 0);
	}else if(type == 'routine') {
		var nodeDataDivX = graphImagePosition[0] + parseInt(x) - 90;
		var nodeDataDivY = graphImagePosition[1] + parseInt(y) - 80;
		showNodeData(nodeDataDivX, nodeDataDivY, nodeDataDivInnerHtml);
	}
	
	var nodeMenuImageX = graphImagePosition[0] + parseInt(x) + 15;
	
	var nodeMenuImageY = graphImagePosition[1] + parseInt(y) + 30;
	showNodeMenuImageDiv(nodeMenuImageX, nodeMenuImageY);
	
	if(previousNodeId != currentNodeId) {
		hideNodeMenu();
	}
}
		
function showNodeData(x, y, nodeDataDivInnerHtml) {
	if(x != 0 && y != 0) {
		var nodeDataDiv = document.getElementById('nodeDataDiv');
		handleInnerHTML(nodeDataDiv, nodeDataDivInnerHtml, 0);
		var nodeDataTable = document.getElementById('nodeDataTable');
		
		var scrollElementX = document.getElementById("transactionVisualViewInnerDiv");
	  x -= scrollElementX.scrollLeft;
		if(x < 0) {
			x = scrollElementX.scrollLeft;
		}else if(nodeDataTable && nodeDataTable.width && x > document.body.clientWidth - nodeDataTable.width) {
			x = document.body.clientWidth - nodeDataTable.width - 20;
		}
		
		nodeDataDiv.style.left = x;
		nodeDataDiv.style.top = y;
		nodeDataDiv.style.display = "";
	}
}

function onMouseOutNode(e) {
	hideNodeDataIfNeededTimeoutId = setTimeout("hideNodeDataIfNeeded()", 1000);
	isMouseOverNode = false;
}

var isMouseOverNodeData = false;
var hideNodeDataIfNeededTimeoutId;
function onMouseOverNodeData() {
	isMouseOverNodeData = true;
}

function onMouseOutNodeData() {
	isMouseOverNodeData = false;
}

function hideNodeDataIfNeeded() {
	if(isMouseOverNodeData) {
		hideNodeDataIfNeededTimeoutId = window.setTimeout("hideNodeDataIfNeeded()", 1000);
	}else {
		hideNodeData();
	}
}

function hideNodeData() {
	var nodeDataDiv = document.getElementById('nodeDataDiv');
	handleInnerHTML(nodeDataDiv, "", 0);
	nodeDataDiv.style.display = "none";
}

function hideImageDiv() {
	var imageSettingsDiv = document.getElementById('imageSettingsDiv');
	imageSettingsDiv.style.display = "none";
}

var nodeMenuX;
var nodeMenuY;
function showNodeMenuImageDiv(x, y) {
	if(x != 0 && y != 0) {
		var nodeMenuImageDiv = document.getElementById('nodeMenuImageDiv');
		
		var scrollElementX = document.getElementById("transactionVisualViewInnerDiv");
	  x -= scrollElementX.scrollLeft;
	  
		nodeMenuImageDiv.style.left = x;
		nodeMenuImageDiv.style.top = y;
		nodeMenuImageDiv.style.display = "";
		
		nodeMenuX = x;
		nodeMenuY = y;
	}
}
		
function hideNodeMenuImageDiv() {
	var nodeMenuImageDiv = document.getElementById('nodeMenuImageDiv');
	nodeMenuImageDiv.style.display = "none";
}

var xmlHttpRequestObjectShowNodeMenu;
function showNodeMenu() {
	hideNodeData();
	xmlHttpRequestObjectShowNodeMenu = GetXmlHttpObject();
	
	var url = "getNodeMenu.jsp";
  var parameters = "";
	parameters += "nodeId="+currentNodeId;
	parameters += "&nodeType="+currentNodeType;
  parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectShowNodeMenu.open("POST", url, true);
  xmlHttpRequestObjectShowNodeMenu.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectShowNodeMenu.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectShowNodeMenu.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectShowNodeMenu.onreadystatechange = showNodeMenuCallback;
  xmlHttpRequestObjectShowNodeMenu.send(parameters);
}
		
function showNodeMenuCallback() {
	if (xmlHttpRequestObjectShowNodeMenu.readyState == 4) {
		if (xmlHttpRequestObjectShowNodeMenu.status == 200) {
			var xmlDoc = xmlHttpRequestObjectShowNodeMenu.responseXML.documentElement;
			if (!xmlDoc){
			  return;
			}
			var numOfMenuItems = xmlDoc.childNodes.length;			
			var nodeId = xmlDoc.getAttribute("nodeId");
			nodeMenu = new jsDOMenu(110, "", "absolute",false,"popupDiv");
			for(i = 0; i < numOfMenuItems; i++) {
				var menuItemElement = xmlDoc.childNodes[i];
				var id = menuItemElement.getAttribute("id");
				var name = menuItemElement.getAttribute("name");
				var numOfSubMenuItems = menuItemElement.childNodes.length;
				if(numOfSubMenuItems > 0) {
					nodeMenu.addMenuItem(new menuItem(name, id, "", true, "TRANSACTION_NODE_MENU_ITEM", "TRANSACTION_NODE_MENU_ITEM_OVER"));
					if(id == "addEdge") {
						addEdgeMenu = new jsDOMenu(100, "", "absolute",false,"popupDiv");
						for(j = 0; j < numOfSubMenuItems; j++) {
							var addEdgeMenuItemElement = menuItemElement.childNodes[j];
							var subId = addEdgeMenuItemElement.getAttribute("id");
							var subName = addEdgeMenuItemElement.getAttribute("name");
							var nodeType = addEdgeMenuItemElement.getAttribute("nodeType");
							var targetId = addEdgeMenuItemElement.getAttribute("targetId");
							addEdgeMenu.addMenuItem(new menuItem(subName, subId, "javascript:hideNodeMenuImageDiv();addNewEdge('" + nodeId + "', '" + nodeType + "', 'tableRow" + nodeType + nodeId + "', '<%=isView %>', '" + targetId + "')", true, "TRANSACTION_NODE_MENU_ITEM", "TRANSACTION_NODE_MENU_ITEM_OVER"));
						}
						nodeMenu.items[id].setSubMenu(addEdgeMenu);
					}else if(id == "splitEdge") {
						splitEdgeMenu = new jsDOMenu(150, "", "absolute",false,"popupDiv");
						for(j = 0; j < numOfSubMenuItems; j++) {
							var splitEdgeMenuItemElement = menuItemElement.childNodes[j];
							var subId = splitEdgeMenuItemElement.getAttribute("id");
							var subName = splitEdgeMenuItemElement.getAttribute("name");
							splitEdgeMenu.addMenuItem(new menuItem(subName, subId, "javascript:hideNodeMenuImageDiv();splitEdge('" + subId + "', '<%=isView %>')", true, "TRANSACTION_NODE_MENU_ITEM", "TRANSACTION_NODE_MENU_ITEM_OVER"));
						}
						nodeMenu.items[id].setSubMenu(splitEdgeMenu);
					}else if(id == "insertToGroup") {
						insertToGroupMenu = new jsDOMenu(110, "", "absolute",false,"popupDiv");
						for(j = 0; j < numOfSubMenuItems; j++) {
							var insertToGroupMenuItemElement = menuItemElement.childNodes[j];
							var subId = insertToGroupMenuItemElement.getAttribute("id");
							var subName = insertToGroupMenuItemElement.getAttribute("name");
							var nodeType = insertToGroupMenuItemElement.getAttribute("nodeType");
							insertToGroupMenu.addMenuItem(new menuItem(subName, subId, "", true, "TRANSACTION_NODE_MENU_ITEM", "TRANSACTION_NODE_MENU_ITEM_OVER"));
							
							var numOfItems = insertToGroupMenuItemElement.childNodes.length;
							if(numOfItems > 0) {
								var groupMenu = new jsDOMenu(150, "", "absolute",false,"popupDiv");
								for(k = 0; k < numOfItems; k++) {
									var groupMenuItemElement = insertToGroupMenuItemElement.childNodes[k];
									var innerId = groupMenuItemElement.getAttribute("id");
									var innerName = groupMenuItemElement.getAttribute("name");
									var innerType = groupMenuItemElement.getAttribute("type");
									
									if(innerType == 'startPoint') {
										innerName = "as new start point";
									}else {
										innerName = innerType + " " + innerName;
									}
									groupMenu.addMenuItem(new menuItem(innerName, innerId, "javascript:hideNodeMenuImageDiv();insertToGroup('" + nodeType + "', '" + nodeId + "', '" + subId + "', '" + innerType + "', '" + innerId + "', '<%=isView %>')", true, "TRANSACTION_NODE_MENU_ITEM", "TRANSACTION_NODE_MENU_ITEM_OVER"));
								}
								insertToGroupMenu.items[subId].setSubMenu(groupMenu);
							}
						}
						nodeMenu.items[id].setSubMenu(insertToGroupMenu);
					}else if(id == "extractNode") {
						extractNodeMenu = new jsDOMenu(150, "", "absolute",false,"popupDiv");
						for(j = 0; j < numOfSubMenuItems; j++) {
							var extractNodeMenuItemElement = menuItemElement.childNodes[j];
							
							var outerId = extractNodeMenuItemElement.getAttribute("id");
							var outerName = extractNodeMenuItemElement.getAttribute("name");
							var groupId = extractNodeMenuItemElement.getAttribute("groupId");
							var outerType = extractNodeMenuItemElement.getAttribute("type");
							
							if(outerType == 'startPoint') {
								outerName = "as new start point";
							}else {
								outerName = outerType + " " + outerName;
							}
							extractNodeMenu.addMenuItem(new menuItem(outerName, outerId, "javascript:hideNodeMenuImageDiv();extractNode('" + nodeType + "', '" + nodeId + "', '" + groupId + "', '" + outerType+ "', '" + outerId + "', '<%=isView %>')", true, "TRANSACTION_NODE_MENU_ITEM", "TRANSACTION_NODE_MENU_ITEM_OVER"));
						}
						nodeMenu.items[id].setSubMenu(extractNodeMenu);
					}else if(id == "setAs") {
						setAsMenu = new jsDOMenu(100, "", "absolute",false,"popupDiv");
						for(j = 0; j < numOfSubMenuItems; j++) {
							var setAsMenuItemElement = menuItemElement.childNodes[j];
							var subId = setAsMenuItemElement.getAttribute("id");
							var subName = setAsMenuItemElement.getAttribute("name");
							var nodeType = setAsMenuItemElement.getAttribute("nodeType");
							setAsMenu.addMenuItem(new menuItem(subName, subId, "javascript:hideNodeMenuImageDiv();setDummyAs('" + nodeId + "', '" + nodeType + "', '<%=isView %>')", true, "TRANSACTION_NODE_MENU_ITEM", "TRANSACTION_NODE_MENU_ITEM_OVER"));
						}
						nodeMenu.items[id].setSubMenu(setAsMenu);
					}
				}else if(id == "zoomIn") {
					//nodeMenu.addMenuItem(new menuItem("-"));
					nodeMenu.addMenuItem(new menuItem(name, id, "javascript:hideNodeMenuImageDiv();showTransaction('" + nodeId + "', '<%=isView %>')", true, "TRANSACTION_NODE_MENU_ITEM", "TRANSACTION_NODE_MENU_ITEM_OVER"));
				}else if(id == "removeNode") {
					//nodeMenu.addMenuItem(new menuItem("-"));
					var nodeType = menuItemElement.getAttribute("nodeType");
					nodeMenu.addMenuItem(new menuItem(name, id, "javascript:hideNodeMenuImageDiv();removeNode('" + nodeType + "', '" + nodeId + "')", true, "TRANSACTION_NODE_MENU_ITEM", "TRANSACTION_NODE_MENU_ITEM_OVER"));
				}
			}
			showMenuPopup(document.getElementById('nodeMenuImageDiv'), 'nodeMenu');
		}
	}
}
		
function hideNodeMenu() {
	hideVisibleMenus();
}

function findPos(obj) {
	var curleft = 0;
	var curtop = 0;
	if (obj.offsetParent) {
		curleft = obj.offsetLeft;
		curtop = obj.offsetTop;
		while (obj = obj.offsetParent) {
			curleft += obj.offsetLeft;
			curtop += obj.offsetTop;
		}
	}
	return [curleft, curtop];
}
		
function changeBgColor(node, color) {
	node.bgColor = color;
}

function selectAllFunctions() {

}
		
function showTransactionTab(selectedTabId) {
	var transactionVisualViewTabDiv = document.getElementById("transactionVisualViewDiv");
	var transactionPreferencesTabDiv = document.getElementById("transactionPreferencesDiv");
	var transactionNodesDiv = document.getElementById("nodesDiv");
	
	var transactionHeaderPathDiv = document.getElementById("transactionHeaderPathDiv");
	var transactionHeaderTitleDiv = document.getElementById("transactionHeaderTitleDiv");
	
	var transactionVisualViewTabImage = document.getElementById("transactionVisualViewTabImage");
	var transactionPreferencesTabImage = document.getElementById("transactionPreferencesTabImage");
	
	if(selectedTabId == -1) {
		changeDivDisplayMode(transactionVisualViewTabDiv, "none");
		changeDivDisplayMode(transactionPreferencesTabDiv, "none");
		changeDivDisplayMode(transactionNodesDiv, "none");
		
		hideNodeMenuImageDiv();
	}else if(selectedTabId == 0) {
		changeDivDisplayMode(transactionVisualViewTabDiv, "");
		changeDivDisplayMode(transactionPreferencesTabDiv, "none");
		changeDivDisplayMode(transactionNodesDiv, "");
		
		changeDivDisplayMode(transactionHeaderPathDiv, "");
		changeDivDisplayMode(transactionHeaderTitleDiv, "none");
		
		transactionVisualViewTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/transactionTabSelected.gif)";
		transactionPreferencesTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/transactionTabUnselected.gif)";
		
		hideNodeMenuImageDiv();
	}else if(selectedTabId == 1) {
		changeDivDisplayMode(transactionVisualViewTabDiv, "none");
		changeDivDisplayMode(transactionPreferencesTabDiv, "");
		changeDivDisplayMode(transactionNodesDiv, "none");
		
		changeDivDisplayMode(transactionHeaderPathDiv, "none");
		changeDivDisplayMode(transactionHeaderTitleDiv, "");
		
		transactionVisualViewTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/transactionTabUnselected.gif)";
		transactionPreferencesTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/transactionTabSelected.gif)";
		
		hideNodeMenuImageDiv();
	}
	transactionVisualViewTabImage.style.backgroundRepeat = "no-repeat";
	transactionPreferencesTabImage.style.backgroundRepeat = "no-repeat";
}

function showPreferencesTab(selectedTabId) {
	var transactionPreferencesGeneralDiv = document.getElementById("transactionPreferencesGeneralDiv");
	var transactionPreferencesApplicationNameDiv = document.getElementById("transactionPreferencesApplicationNameDiv");
	var transactionPreferencesAdvancedNameDiv = document.getElementById("transactionPreferencesAdvancedNameDiv");
	
	var preferencesGeneralLink = document.getElementById("preferencesGeneralLink");
	var preferencesApplicationNameLink = document.getElementById("preferencesApplicationNameLink");
	var preferencesAdvancedLink = document.getElementById("preferencesAdvancedLink");
	
	if(selectedTabId == -1) {
		changeDivDisplayMode(transactionPreferencesGeneralDiv, "none");
		changeDivDisplayMode(transactionPreferencesApplicationNameDiv, "none");
		changeDivDisplayMode(transactionNodesDiv, "none");
	}else if(selectedTabId == 0) {
		changeDivDisplayMode(transactionPreferencesGeneralDiv, "");
		changeDivDisplayMode(transactionPreferencesApplicationNameDiv, "none");
		changeDivDisplayMode(transactionPreferencesAdvancedNameDiv, "none");
		
		preferencesGeneralLink.className = "PREFERENCES_LINK_SELECTED";
		preferencesApplicationNameLink.className = "PREFERENCES_LINK";
		preferencesAdvancedLink.className = "PREFERENCES_LINK";
	}else if(selectedTabId == 1) {
		changeDivDisplayMode(transactionPreferencesGeneralDiv, "none");
		changeDivDisplayMode(transactionPreferencesApplicationNameDiv, "");
		changeDivDisplayMode(transactionPreferencesAdvancedNameDiv, "none");
		
		preferencesGeneralLink.className = "PREFERENCES_LINK";
		preferencesApplicationNameLink.className = "PREFERENCES_LINK_SELECTED";
		preferencesAdvancedLink.className = "PREFERENCES_LINK";
	}else if(selectedTabId == 2) {
		changeDivDisplayMode(transactionPreferencesGeneralDiv, "none");
		changeDivDisplayMode(transactionPreferencesApplicationNameDiv, "none");
		changeDivDisplayMode(transactionPreferencesAdvancedNameDiv, "");
		
		preferencesGeneralLink.className = "PREFERENCES_LINK";
		preferencesApplicationNameLink.className = "PREFERENCES_LINK";
		preferencesAdvancedLink.className = "PREFERENCES_LINK_SELECTED";
	}
}

function showNodeTabs(nodeId, nodeType) {
	if(nodeType == 'subTransaction') {
		var bodyTabDiv = document.getElementById("subTransaction" + nodeId + "BodyDiv");
		changeDivDisplayMode(bodyTabDiv, "");
		var tabsDiv = document.getElementById("subTransaction" + nodeId + "TabsDiv");
		changeDivDisplayMode(tabsDiv, "");
	}else if(nodeType == 'routine') {
		var bodyTabDiv = document.getElementById("routine" + nodeId + "BodyDiv");
		changeDivDisplayMode(bodyTabDiv, "");
		
		var tabsDiv = document.getElementById("routine" + nodeId + "TabsDiv");
		changeDivDisplayMode(tabsDiv, "");
		var headerMiscDiv = document.getElementById("routine" + nodeId + "HeaderMiscDiv");
		changeDivDisplayMode(headerMiscDiv, "none");
		
		var routineHeaderTd = document.getElementById("routine" + nodeId + "HeaderTd");
		routineHeaderTd.vAlign = "bottom";
	}
}

function hideNodeTabs(nodeId, nodeType) {
	if(nodeType == 'subTransaction') {
		var bodyTabDiv = document.getElementById("subTransaction" + nodeId + "BodyDiv");
		changeDivDisplayMode(bodyTabDiv, "none");
		var tabsDiv = document.getElementById("subTransaction" + nodeId + "TabsDiv");
		changeDivDisplayMode(tabsDiv, "none");
	}else if(nodeType == 'routine') {
		var bodyTabDiv = document.getElementById("routine" + nodeId + "BodyDiv");
		changeDivDisplayMode(bodyTabDiv, "none");
		
		var tabsDiv = document.getElementById("routine" + nodeId + "TabsDiv");
		changeDivDisplayMode(tabsDiv, "none");
		var headerMiscDiv = document.getElementById("routine" + nodeId + "HeaderMiscDiv");
		changeDivDisplayMode(headerMiscDiv, "");
		
		var routineHeaderTd = document.getElementById("routine" + nodeId + "HeaderTd");
		routineHeaderTd.vAlign = "middle";
	}
}

function getAbsoluteTop(htmlObject){
	var yPos = htmlObject.offsetTop;
	var temp = htmlObject.offsetParent;
	while(temp != null){
		yPos+= temp.offsetTop;
		temp = temp.offsetParent;
	}
	return yPos;
}

function scrollToNode(nodeType, nodeId) {
	var nodesDiv = document.getElementById("nodesTableFlowDiv");
	var nodeDiv = document.getElementById("tableRow" + nodeType + nodeId);
	
	var nodesDivTop = getAbsoluteTop(nodesDiv);
	var nodeDivTop = getAbsoluteTop(nodeDiv);
	
	var scrollTop = nodeDivTop - nodesDivTop;
	nodesDiv.scrollTop = scrollTop;
}

function showSubTransactionTab(subTransactionId, selectedTabId) {
	var contentTabDiv = document.getElementById("subTransaction" + subTransactionId + "ContentDiv");
	var generalTabDiv = document.getElementById("subTransaction" + subTransactionId + "GeneralDiv");
	var functionsTabDiv = document.getElementById("subTransaction" + subTransactionId + "FunctionsDiv");
	var connectorsDiv = document.getElementById("subTransaction" + subTransactionId + "ConnectorsDiv");
	
	var contentTabImage = document.getElementById("subTransaction" + subTransactionId + "ContentTabImage");
	var generalTabImage = document.getElementById("subTransaction" + subTransactionId + "GeneralTabImage");
	var functionsTabImage = document.getElementById("subTransaction" + subTransactionId + "FunctionsTabImage");
	var connectorsTabImage = document.getElementById("subTransaction" + subTransactionId + "ConnectorsTabImage");
	
	var contentTabLink = document.getElementById("subTransaction" + subTransactionId + "ContentTabLink");
	var generalTabLink = document.getElementById("subTransaction" + subTransactionId + "GeneralTabLink");
	var functionsTabLink = document.getElementById("subTransaction" + subTransactionId + "FunctionsTabLink");
	var connectorsTabLink = document.getElementById("subTransaction" + subTransactionId + "ConnectorsTabLink");
	
	if(selectedTabId == 0) {
		changeDivDisplayMode(contentTabDiv, "");
		changeDivDisplayMode(generalTabDiv, "none");
		changeDivDisplayMode(functionsTabDiv, "none");
		changeDivDisplayMode(connectorsDiv, "none");
		
		contentTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/subTransactionTabSelected.gif)";
		generalTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/subTransactionTabUnselected.gif)";
		functionsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/subTransactionTabUnselected.gif)";
		connectorsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/subTransactionTabUnselected.gif)";
		
		contentTabLink.className = "SUB_TRANSACTION_SELECTED_TAB_TEXT";
		generalTabLink.className = "SUB_TRANSACTION_TAB_TEXT";
		functionsTabLink.className = "SUB_TRANSACTION_TAB_TEXT";
		connectorsTabLink.className = "SUB_TRANSACTION_TAB_TEXT";
	}else if(selectedTabId == 1) {
		changeDivDisplayMode(contentTabDiv, "none");
		changeDivDisplayMode(generalTabDiv, "");
		changeDivDisplayMode(functionsTabDiv, "none");
		changeDivDisplayMode(connectorsDiv, "none");
		
		contentTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/subTransactionTabUnselected.gif)";
		generalTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/subTransactionTabSelected.gif)";
		functionsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/subTransactionTabUnselected.gif)";
		connectorsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/subTransactionTabUnselected.gif)";
		
		contentTabLink.className = "SUB_TRANSACTION_TAB_TEXT";
		generalTabLink.className = "SUB_TRANSACTION_SELECTED_TAB_TEXT";
		functionsTabLink.className = "SUB_TRANSACTION_TAB_TEXT";
		connectorsTabLink.className = "SUB_TRANSACTION_TAB_TEXT";
	}else if(selectedTabId == 2) {
		changeDivDisplayMode(generalTabDiv, "none");
		changeDivDisplayMode(contentTabDiv, "none");
		changeDivDisplayMode(functionsTabDiv, "");
		changeDivDisplayMode(connectorsDiv, "none");
		
		contentTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/subTransactionTabUnselected.gif)";
		generalTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/subTransactionTabUnselected.gif)";
		functionsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/subTransactionTabSelected.gif)";
		connectorsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/subTransactionTabUnselected.gif)";
		
		contentTabLink.className = "SUB_TRANSACTION_TAB_TEXT";
		generalTabLink.className = "SUB_TRANSACTION_TAB_TEXT";
		functionsTabLink.className = "SUB_TRANSACTION_SELECTED_TAB_TEXT";
		connectorsTabLink.className = "SUB_TRANSACTION_TAB_TEXT";
	}else if(selectedTabId == 3) {
		changeDivDisplayMode(generalTabDiv, "none");
		changeDivDisplayMode(contentTabDiv, "none");
		changeDivDisplayMode(functionsTabDiv, "none");
		changeDivDisplayMode(connectorsDiv, "");
		
		contentTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/subTransactionTabUnselected.gif)";
		generalTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/subTransactionTabUnselected.gif)";
		functionsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/subTransactionTabUnselected.gif)";
		connectorsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/subTransactionTabSelected.gif)";
		
		contentTabLink.className = "SUB_TRANSACTION_TAB_TEXT";
		generalTabLink.className = "SUB_TRANSACTION_TAB_TEXT";
		functionsTabLink.className = "SUB_TRANSACTION_TAB_TEXT";
		connectorsTabLink.className = "SUB_TRANSACTION_SELECTED_TAB_TEXT";
	}
	contentTabImage.style.backgroundRepeat = "no-repeat";
	generalTabImage.style.backgroundRepeat = "no-repeat";
	functionsTabImage.style.backgroundRepeat = "no-repeat";
	connectorsTabImage.style.backgroundRepeat = "no-repeat";
}
		
function showRoutineTab(routineId, selectedTabId) {
	var generalTabDiv = document.getElementById("routine" + routineId + "GeneralDiv");
	var functionsTabDiv = document.getElementById("routine" + routineId + "FunctionsDiv");
	var connectorsDiv = document.getElementById("routine" + routineId + "ConnectorsDiv");
	var dataFilterTabDiv = document.getElementById("routine" + routineId + "DataFilterDiv");
	var uiSettingsTabDiv = document.getElementById("routine" + routineId + "UiSettingsDiv");
	
	var generalTabImage = document.getElementById("routine" + routineId + "GeneralTabImage");
	var functionsTabImage = document.getElementById("routine" + routineId + "FunctionsTabImage");
	var connectorsTabImage = document.getElementById("routine" + routineId + "ConnectorsTabImage");
	var dataFilterTabImage = document.getElementById("routine" + routineId + "DataFilterTabImage");
	var uiSettingsTabImage = document.getElementById("routine" + routineId + "UiSettingsTabImage");
	
	var generalTabLink = document.getElementById("routine" + routineId + "GeneralTabLink");
	var functionsTabLink = document.getElementById("routine" + routineId + "FunctionsTabLink");
	var connectorsTabLink = document.getElementById("routine" + routineId + "ConnectorsTabLink");
	var dataFilterTabLink = document.getElementById("routine" + routineId + "DataFilterTabLink");
	var uiSettingsTabLink = document.getElementById("routine" + routineId + "UiSettingsTabLink");
	
	if(selectedTabId == 0) {
		changeDivDisplayMode(generalTabDiv, "");
		changeDivDisplayMode(functionsTabDiv, "none");
		changeDivDisplayMode(connectorsDiv, "none");
		changeDivDisplayMode(dataFilterTabDiv, "none");
		changeDivDisplayMode(uiSettingsTabDiv, "none");
		
		generalTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabSelected.gif)";
		functionsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabUnselected.gif)";
		connectorsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabUnselected.gif)";
		dataFilterTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabUnselected.gif)";
		uiSettingsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabUnselected.gif)";
		
		generalTabLink.className = "ROUTINE_SELECTED_TAB_TEXT";
		functionsTabLink.className = "ROUTINE_TAB_TEXT";
		connectorsTabLink.className = "ROUTINE_TAB_TEXT";
		dataFilterTabLink.className = "ROUTINE_TAB_TEXT";
		uiSettingsTabLink.className = "ROUTINE_TAB_TEXT";
	}else if(selectedTabId == 1) {
		changeDivDisplayMode(generalTabDiv, "none");
		changeDivDisplayMode(functionsTabDiv, "");
		changeDivDisplayMode(connectorsDiv, "none");
		changeDivDisplayMode(dataFilterTabDiv, "none");
		changeDivDisplayMode(uiSettingsTabDiv, "none");
		
		generalTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabUnselected.gif)";
		functionsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabSelected.gif)";
		connectorsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabUnselected.gif)";
		dataFilterTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabUnselected.gif)";
		uiSettingsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabUnselected.gif)";
		
		generalTabLink.className = "ROUTINE_TAB_TEXT";
		functionsTabLink.className = "ROUTINE_SELECTED_TAB_TEXT";
		connectorsTabLink.className = "ROUTINE_TAB_TEXT";
		dataFilterTabLink.className = "ROUTINE_TAB_TEXT";
		uiSettingsTabLink.className = "ROUTINE_TAB_TEXT";
	}else if(selectedTabId == 2) {
		changeDivDisplayMode(generalTabDiv, "none");
		changeDivDisplayMode(functionsTabDiv, "none");
		changeDivDisplayMode(connectorsDiv, "");
		changeDivDisplayMode(dataFilterTabDiv, "none");
		changeDivDisplayMode(uiSettingsTabDiv, "none");
		
		generalTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabUnselected.gif)";
		functionsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabUnselected.gif)";
		connectorsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabSelected.gif)";
		dataFilterTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabUnselected.gif)";
		uiSettingsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabUnselected.gif)";
		
		generalTabLink.className = "ROUTINE_TAB_TEXT";
		functionsTabLink.className = "ROUTINE_TAB_TEXT";
		connectorsTabLink.className = "ROUTINE_SELECTED_TAB_TEXT";
		dataFilterTabLink.className = "ROUTINE_TAB_TEXT";
		uiSettingsTabLink.className = "ROUTINE_TAB_TEXT";
	}else if(selectedTabId == 3) {
		changeDivDisplayMode(generalTabDiv, "none");
		changeDivDisplayMode(functionsTabDiv, "none");
		changeDivDisplayMode(connectorsDiv, "none");
		changeDivDisplayMode(dataFilterTabDiv, "");
		changeDivDisplayMode(uiSettingsTabDiv, "none");
		
		generalTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabUnselected.gif)";
		functionsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabUnselected.gif)";
		connectorsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabUnselected.gif)";
		dataFilterTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabSelected.gif)";
		uiSettingsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabUnselected.gif)";
		
		generalTabLink.className = "ROUTINE_TAB_TEXT";
		functionsTabLink.className = "ROUTINE_TAB_TEXT";
		connectorsTabLink.className = "ROUTINE_TAB_TEXT";
		dataFilterTabLink.className = "ROUTINE_SELECTED_TAB_TEXT";
		uiSettingsTabLink.className = "ROUTINE_TAB_TEXT";
	}else if(selectedTabId == 4) {
		changeDivDisplayMode(generalTabDiv, "none");
		changeDivDisplayMode(functionsTabDiv, "none");
		changeDivDisplayMode(connectorsDiv, "none");
		changeDivDisplayMode(dataFilterTabDiv, "none");
		changeDivDisplayMode(uiSettingsTabDiv, "");
		
		generalTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabUnselected.gif)";
		functionsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabUnselected.gif)";
		connectorsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabUnselected.gif)";
		dataFilterTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabUnselected.gif)";
		uiSettingsTabImage.style.background = "url(" + baseDirectory + "logic/images/tranview/routineTabSelected.gif)";
		
		generalTabLink.className = "ROUTINE_TAB_TEXT";
		functionsTabLink.className = "ROUTINE_TAB_TEXT";
		connectorsTabLink.className = "ROUTINE_TAB_TEXT";
		dataFilterTabLink.className = "ROUTINE_TAB_TEXT";
		uiSettingsTabLink.className = "ROUTINE_SELECTED_TAB_TEXT";
	}
	generalTabImage.style.backgroundRepeat = "no-repeat";
	functionsTabImage.style.backgroundRepeat = "no-repeat";
	connectorsTabImage.style.backgroundRepeat = "no-repeat";
	dataFilterTabImage.style.backgroundRepeat = "no-repeat";
	uiSettingsTabImage.style.backgroundRepeat = "no-repeat";
}
		
function changeDivDisplayMode(div, displayMode) {
	div.style.display = displayMode;
}

var filterRoutineId;
var filterDataFilterId;
var filterWindow;
function openFilterWindow(routineId, dataFilterId){
	var routineDs = document.getElementById("routine" + routineId + "DataSource");
 	if (!routineDs || !routineDs.value){
		alert("Please select a data source first");
		return;
	}
  document.addFilter.ds_id.value = routineDs.value;
	filterWindow = window.open(baseDirectory+'empty.html','filtersWindow','height=600,width=700,resizable=yes,scrollbars=yes,status=yes,left=200,top=70');
	filterWindow.focus();
	//document.addFilter.elem_id.value = filtersComboId;
	document.addFilter.routine_id.value = routineId;
	if (dataFilterId){
		document.addFilter.filter_collection_id.value = dataFilterId;
	}else{
		document.addFilter.filter_collection_id.value = "";
	}
	document.addFilter.submit();
}

function addToFunctionList(nodeId, nodeType){
  sList = document.getElementById("sourceList" + nodeId + nodeType);
  tList = document.getElementById("targetList" + nodeId + nodeType);
  sIndex = sList.options.selectedIndex;
  tIndex = tList.options.selectedIndex;
  
	var name = "";
  if (sIndex >= 0){
    name = sList.options[sIndex].text;
	}else if (tIndex >= 0){
    name = tList.options[tIndex].text;
	} else {
  	return;
	}

	var value = "" + sIndex + ";" + tIndex;
  fList = document.getElementById(nodeType + nodeId + "FunctionList");
  fIndex = fList.options.length == 1 && fList.options[0].value == "" ? 0 : fList.options.length;
  fList.options[fIndex] = new Option(name,value);
  fList.selectedIndex = fIndex;
  
	updateSourceTargetFunction(nodeId, nodeType);
}

function removeFromFunctionList(nodeId, nodeType){
  fList = document.getElementById(nodeType + nodeId + "FunctionList");
	fIndex = fList.options.selectedIndex;
	if (fIndex >= 0){
    if (fIndex == 0 && 	fList.options[0].value == ""){
		  return;
		}
	  fList.options[fIndex] = null;
	}
	if (fList.options.length == 0){
	  fList.options[0] = new Option("No data to use","");
	}
	
	updateSourceTargetFunction(nodeId, nodeType);
}

function updateSourceTargetFunction(nodeId, nodeType){
  fList = document.getElementById(nodeType + nodeId + "FunctionList");
	sList = document.getElementById("sourceList" + nodeId + nodeType);
  tList = document.getElementById("targetList" + nodeId + nodeType);
	fIndex = fList.options.selectedIndex;
	if (fIndex == -1 || fList.options[0].value == ""){
	  sList.options.selectedIndex = -1;
		tList.options.selectedIndex = -1;
		return;
	}
	
	fValue = fList.options[fIndex].value;
	index = fValue.indexOf(";");
	if (index == -1){
		return;
	}
	
	sList.options.selectedIndex = fValue.substring(0,index);
	tList.options.selectedIndex = fValue.substring(index + 1,fValue.length);
}

function shownHideAdv(txtDiv, targetDiv){
 	show = document.getElementById(targetDiv).style.display == "";
 	if(show){
 		document.getElementById(targetDiv).style.display="none";   		
 	}else{
 		document.getElementById(targetDiv).style.display="";
 	}
}

function LogicImage(id,name,src){
  this.id = id;
  this.name = name;
  this.src = src;
}

function updateImagesListsById(id){
 updateRoutineImages(document.getElementById("routineRuntimeImages" + id));
 updateRoutineImages(document.getElementById("routineRuntimeErrorImages" + id));
 updateRoutineImages(document.getElementById("dummyRoutineImages" + id));
}


function updateRoutineImages(combo,defImage){
  index = combo.selectedIndex;
  if (index == -1){
    index = 0;
  }
  combo.options.length = 0;
  combo.options[0] = new Option("Default" , "default");
  for (var i = 0; i <  globalImages.length ; i++){
    combo.options[combo.options.length] = new Option(globalImages[i].name , globalImages[i].id);
  }
  combo.selectedIndex = index;
}

function changeImage(combo,type,imageId,routineId){
  index = combo.selectedIndex;
  if (index == -1) return;
  if (index == 0){
    if (type == "routineRuntime"){
      src = defRoutineRuntimeImg.src;
    }else if (type == "routineRuntimeError"){
      src = defRoutineRuntimeErrorImg.src;
    }else if (type == "dummyRoutine"){
      src = defDummyRoutineImg.src;
    }
	  document.getElementById(imageId).src = src;
  }else {
    updateRoutineImage(routineId,type,imageId,combo.options[combo.selectedIndex].value);
  }
}

var xmlHttpRequestObjectChangeImageIcon;
function updateRoutineImage(routineId,type,imageId,propertyId) {
	xmlHttpRequestObjectChangeImageIcon = GetXmlHttpObject();
  var url = "changeImage.jsp?";
	var parameters = "";
	parameters += "&routineId=" + routineId;
	parameters += "&imageType=" + type;
	parameters += "&imageId=" + imageId;
	parameters += "&propertyId=" + propertyId;
	parameters += "&isView=true";
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectChangeImageIcon.open("POST", url, true);
	xmlHttpRequestObjectChangeImageIcon.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectChangeImageIcon.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectChangeImageIcon.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectChangeImageIcon.onreadystatechange = updateRoutineImageCallback;
  xmlHttpRequestObjectChangeImageIcon.send(parameters);
}

function updateRoutineImageCallback() {
	if (xmlHttpRequestObjectChangeImageIcon.readyState == 4) {
		if (xmlHttpRequestObjectChangeImageIcon.status == 200) {
		  var xmlDoc = xmlHttpRequestObjectChangeImageIcon.responseXML.documentElement;
			var routineImageElement = xmlDoc.getElementsByTagName("RoutineImage")[0];
			var routineId = routineImageElement.getAttribute("routineId");
			var imgsrc = routineImageElement.getAttribute("imgsrc");
			var imageId = routineImageElement.getAttribute("imageId");
			var imgElem = document.getElementById(imageId);
			if (imgElem){
				imgElem.src = baseDirectory+imgsrc;
			}
		}
	}
}


function findGlobalImageIndex(id){  
  for (var i = 0; i < globalImages.length; i++){
    if (globalImages[i].id == id){
      return i;
    }
  }
  return -1;
}

function selectImageById(comboId,type,imageId,globalId){
  var combo = document.getElementById(comboId);
  var index = -1;
  if (globalId >= 0){
    index = findGlobalImageIndex(globalId);
  }
  
  combo.selectedIndex = index + 1;
  changeImage(combo,type,imageId);
}

function addComboEntry(comboId,entryText,entryValue){
	newEntry = new Option(entryText,entryValue,true);
	combo = document.getElementById(comboId);
	index = combo.length;
	combo.options[index] = newEntry;
	combo.selectedIndex = index;
}

//on choosing type - view templates of this kind
function presentTempaltesByType() {
	var type = document.getElementById("AlertType").value;
}

//fills the email alert div according to the given id.
function createEmailAlertDiv(id) {
	var arr;
	var index1;
	var index2;
	if(id.substring(0,11) == "transaction") {
		arr = transactionAlertsArr;
		index1 = id.substring(11,id.lastIndexOf("_"));
    	index2 = id.substring(id.lastIndexOf("_")+1, id.length);
	}else {
		arr = edgesAlertsArr;
		index1 = id.substring(5,id.lastIndexOf("_"));
    	index2 = id.substring(id.lastIndexOf("_")+1, id.length);
	}

    if(document.getElementById(id).style.display == "") {
    	var from = document.getElementById("from["+id+"]").value;
    	var to = document.getElementById("to["+id+"]").value;
    	var subject = document.getElementById("subject["+id+"]").value;
    	if(from == "" || to == "" || subject == "") {
    		alert("Please make sure From, To, and Subject have values");
    		return;
    	}
    	arr[index1][index2].template.id = document.getElementById("templateId["+id+"_x]").value;
		arr[index1][index2].template.from = from;
     	arr[index1][index2].template.to = to;
     	arr[index1][index2].template.subject = subject;
     	arr[index1][index2].template.message = document.getElementById("message["+id+"]").value;
		arr[index1][index2].key = document.getElementById("AlertTypeKey["+id+"_x]").value;
		
     	shownHideAdv('',id);
     	shownHideAdv('',id+"_x");
    }else {
    	shownHideAdv('',id);
     	shownHideAdv('',id+"_x");
    }
    
    if(id.substring(0,11) == "transaction") {
		transactionAlertsArr = arr;
	}else {
		edgesAlertsArr = arr;
	}
}

function Alert(id, key, template) {
	this.id = id;
	this.key = key;
	this.template = template;
}

function emailTemplate(id, from, to, subject, message) {
	this.type = "Email";
	this.id = id;
	this.from = from;
	this.to = to;
	this.subject = subject;
	this.message = message;
}
emailTemplate.prototype.createAlertDiv = createEmailAlertDiv;


//on choosing template fill in the information
function loadTemplateData(id){
	fieldName = "templateId["+id+"]";
  	var index = -1;
  	var tempId = document.getElementById(fieldName).value;
  	for(var i=0;i<templatesArr.length;++i) { 
  		if(tempId == templatesArr[i].id) {
  			index = i;
  		}
  	}
  	
  	//fields id is built without the "_x"
	fieldId = id.substring(0,id.length-2);
  	from = "from["+fieldId+"]";
  	to = "to["+fieldId+"]";
  	subject = "subject["+fieldId+"]";
  	message = "message["+fieldId+"]";
  	if(index != -1) {  	
	  	document.getElementById("templateId["+id+"]").value = templatesArr[index].id;
	  	document.getElementById(from).value = templatesArr[index].from;
	  	document.getElementById(to).value = templatesArr[index].to;
	  	document.getElementById(subject).value = templatesArr[index].subject;
	  	document.getElementById(message).value = templatesArr[index].message;
    }else {
	  	document.getElementById(from).value = "";
	  	document.getElementById(to).value = "";
	  	document.getElementById(subject).value = "";
	  	document.getElementById(message).value = "";
  }
}

function goEdit(id){
	createEmailAlertDiv(id);
}

//insert the right id to each created div. replaces the [ID].
function insertId(id,oldHtml) {
	var newHtml = "";
	for(var i=0;i<oldHtml.length;++i) {
		if(i != oldHtml.length-1 && oldHtml.charAt(i) == "I" && oldHtml.charAt(i+1)== "D") {
			newHtml += id;
			i++;
		}else {
			newHtml += oldHtml.charAt(i);
		}
	}
	handleInnerHTML(document.getElementById(id), newHtml, 1);
}

//builds 2 lines in the main table - 1-name,2-details.
function buildAlertsTableLine(mode, i) {
		var arr;
		if(mode == "edges") {
			arr = edgesAlertsArr;
		}else {
			arr = transactionAlertsArr;
		}
		for(var j=0;j<arr[i].length;++j) {
			var a1 = document.createElement('a');
			var a2 = document.createElement('a');
			var a3 = document.createElement('a');
			a1.setAttribute('href', "javascript:goEdit('" + arr[i][j].id + "')");
			a1.appendChild(document.createTextNode("Alert_"+j));
			a1.className = 'LINK';
			a2.setAttribute('href', "javascript:goEdit('" + arr[i][j].id + "')");
			a2.className = 'LINK';
			a2.appendChild(document.createTextNode('edit'));
			
			a3.setAttribute('href', "javascript:doDelete('" + arr[i][j].id + "')");
			a3.className = 'LINK';
			a3.appendChild(document.createTextNode('delete'));
			
			td1 = document.createElement('TD');
			td1.setAttribute('width', '16%');
			td1.appendChild(a1);
			
			td2 = document.createElement('TD');
			td2.setAttribute('width', '15%');
			td2.appendChild(document.createTextNode(arr[i][j].template.type));
			td2.className = 'REGULARTEXT';
			
			td3 = document.createElement('TD');
			td3.setAttribute('width', '20%');
			td3.appendChild(a2);
			td3.appendChild(document.createTextNode('\u00a0'));
			td3.appendChild(a3);
			td4 = document.createElement('TD');
			td4.setAttribute('width', '10%');
			
			line1 = document.createElement('TR');
			line1.appendChild(td1);
			line1.appendChild(td2);
			line1.appendChild(td3);
			line1.appendChild(td4);
			
			line2 = document.createElement('TR');
			div1 = document.createElement('div');
			div1.setAttribute('style', 'top: 100px;');
			div2 = document.createElement('div');
			div2.setAttribute('style', 'top: 100px;');
			
			div2.setAttribute('id',arr[i][j].id);
			div1.setAttribute('id',arr[i][j].id+"_x");
			td5 = document.createElement('TD');
			td5.appendChild(div1);
			td5.appendChild(div2);
			line2.appendChild(td5);
			document.getElementById(mode+"AlertBody"+i).appendChild(line1);
			document.getElementById(mode+"AlertBody"+i).appendChild(line2);	
			document.getElementById(arr[i][j].id).style.display = 'none';
			document.getElementById(arr[i][j].id+"_x").style.display = 'none';
			handleInnerHTML(document.getElementById(arr[i][j].id+"_x"), document.getElementById("templateBoxDiv").innerHTML, 1);
			
			insertId(arr[i][j].id, document.getElementById("emailAlertDiv").innerHTML);
			insertId(arr[i][j].id+"_x", document.getElementById("TemplateBoxDiv").innerHTML);
			
		}
		if(mode == "edges") {
			edgesAlertsArr = arr;
		}else {
			transactionAlertsArr = arr;
		}
	updateAllFields(mode, i);
}

function updateAllFields(mode, i) {
		var arr;
		var id;
		if(mode == "edges") {
			arr = edgesAlertsArr;
		}else {
			arr = transactionAlertsArr;
		}
		for(var j=0;j<arr[i].length;++j) {
			id = mode + i + "_" + j;
			document.getElementById("from["+id+"]").value = arr[i][j].template.from;
     		document.getElementById("to["+id+"]").value = arr[i][j].template.to;
     		document.getElementById("subject["+id+"]").value = arr[i][j].template.subject;
     		document.getElementById("message["+id+"]").value = arr[i][j].template.message;
     		document.getElementById("AlertType["+arr[i][j].id+"_x"+"]").value = arr[i][j].template.type;
     		document.getElementById("templateId["+id+"_x]").value = arr[i][j].template.id;
     		document.getElementById("AlertTypeKey["+arr[i][j].id+"_x"+"]").value = arr[i][j].key;
     	}
}

function doDelete(id){
	var arr;
	var mode;
	var index1;
	var index2;
	if(id.substring(0,11) == "transaction") {
		mode = id.substring(0,11);
		arr = transactionAlertsArr;
		index1 = id.substring(11,id.lastIndexOf("_"));
    	index2 = id.substring(id.lastIndexOf("_")+1, id.length);
	}else {
		mode = id.substring(0,5);
		arr = edgesAlertsArr;
		index1 = id.substring(5,id.lastIndexOf("_"));
    	index2 = id.substring(id.lastIndexOf("_")+1, id.length);
	}
	
	//var arr = edgesAlertsArr[index1];
	var temp = new Array;
	for(var i=0;i<arr[index1].length-1;++i) {
		if(i<index2) {
			temp[i] = arr[index1][i];
		}else {
			temp[i] = arr[index1][i+1];
		}
	}
	
	//delete the lines of the switched array
	for(var i=0;i<arr[index1].length;++i) {
		document.getElementById(mode+"alertBody"+index1).deleteRow();
	}

	arr[index1] = temp;
	
	if(mode == "transaction") {
		transactionAlertsArr = arr;
	}else {
		edgesAlertsArr = arr;
	}
	
	reloadTable(mode, index1);
}

function goNew(mode, index){
	var arr;
	var temp;
	if(mode == "transaction") {
		arr = transactionAlertsArr[index];
	}else {
		arr = edgesAlertsArr[index];
	}
	
	temp = arr.length;
	var id = mode+index+"_"+temp;
	if(document.getElementById(id)) {
		alert("New Alert is now being created. Please either add the new alert or cancel its creation before adding another one.");
		return;
	}

	var a1 = document.createElement('a');
	a1.setAttribute('href', "javascript:saveAlert('" + id + "')");
	a1.appendChild(document.createTextNode("add"));
	a1.className = 'LINK';
	var a2 = document.createElement('a');
	a2.setAttribute('href', "javascript:reloadTable('"+ mode + "','" + index + "')");
	a2.appendChild(document.createTextNode("cancel"));
	a2.className = 'LINK';
	td1 = document.createElement('TD');
	
	line = document.createElement('TR');
	div1 = document.createElement('div');
	div1.setAttribute('style', 'top: 100px;');
	div2 = document.createElement('div');
	div2.setAttribute('style', 'top: 100px;');
	
	div2.setAttribute('id',id);
	div1.setAttribute('id',id+"_x");
	td = document.createElement('TD');
	td.appendChild(div1);
	td.appendChild(div2);
	td.appendChild(a1);
	td.appendChild(document.createTextNode('\u00a0'));
	td.appendChild(document.createTextNode('\u00a0'));
	td.appendChild(a2);
	line.appendChild(td);
	
	document.getElementById(mode+"alertBody"+index).appendChild(line);
	handleInnerHTML(document.getElementById(id+"_x"), document.getElementById("templateBoxDiv").innerHTML, 1);
	
	insertId(id, document.getElementById("emailAlertDiv").innerHTML);
	insertId(id+"_x", document.getElementById("TemplateBoxDiv").innerHTML);
	
	//set the proper type in the option box
 	document.getElementById("AlertType["+id+"_x"+"]").value = "Email";
 	//set the default key
}

function saveAlert(id){
	var arr;
	var mode;
	var index1;
	var index2;
	if(id.substring(0,11) == "transaction") {
		mode = id.substring(0,11);
		arr = transactionAlertsArr;
		index1 = id.substring(11,id.lastIndexOf("_"));
    	index2 = id.substring(id.lastIndexOf("_")+1, id.length);
	}else {
		mode = id.substring(0,5);
		arr = edgesAlertsArr;
		index1 = id.substring(5,id.lastIndexOf("_"));
    	index2 = id.substring(id.lastIndexOf("_")+1, id.length);
	}
	
	from = "from["+id+"]";
  	to = "to["+id+"]";
  	subject = "subject["+id+"]";
  	message = "message["+id+"]";
  	
  	fromVal = document.getElementById(from).value;
  	toVal = document.getElementById(to).value;
  	subjectVal = document.getElementById(subject).value;
  	messageVal = document.getElementById(message).value;
  	idVal = document.getElementById("templateId["+id+"_x]").value;
  	
  	if(fromVal == "" || toVal == "" || subjectVal == "" || messageVal == "") {
  		alert("Please make sure From, To, and Subject have values");
  		return;
  	}
	template = new emailTemplate(idVal,fromVal,toVal,subjectVal,messageVal);
	//set the proper type in the option box
 	var key = document.getElementById("AlertTypeKey["+id+"_x"+"]").value;
	
	arr[index1][index2] =  new Alert(id, key, template);
	
	if(mode == "transaction") {
		transactionAlertsArr = arr;
	}else {
		edgesAlertsArr = arr;
	}

	reloadTable(mode, index1);
}

function reloadTable(mode, index) {
	var alertsTableLines  = document.getElementById(mode+"alertBody"+index);
	var length = alertsTableLines.rows.length;
	for(var i=0;i<length;++i) {
		alertsTableLines.deleteRow();
	}
	buildAlertsTableLine(mode, index);
}

//the 'manager' function - invoked on load.
function buildAlertsTable() {
	buildTransactionAlertsList();
	buildEdgesAlertsList();
	buildTemplatesList();
	//build the transaction alerts table
	for(var i=0;i<transactionAlertsArr.length;++i) {
		buildAlertsTableLine("transaction", i);
	}
	//build the edges alerts table
	for(var i=0;i<edgesAlertsArr.length;++i) {
		buildAlertsTableLine("edges", i);
	}
}

function createNewTemplate(id) {
    id = id.substring(0,id.length-2);
    
    var from = "from["+id+"]";
  	var to = "to["+id+"]";
  	var subject = "subject["+id+"]";
  	var message = "message["+id+"]";
  	
  	fromVal = document.getElementById(from).value;
  	toVal = document.getElementById(to).value;
  	subjectVal = document.getElementById(subject).value;
  	messageVal = document.getElementById(message).value;
  	
  	if(fromVal == "" || toVal == "" || subjectVal == "") {
  		alert("Please make sure From, To, and Subject have values");
  		return;
  	}
  
  var x = -1;
  var y = -1;
  if (id && id != ""){
    var comp = document.getElementById(id);
    x = findPosX(comp) + 550;
    y = findPosY(comp) + 75;
  }
  document.getElementById('newTemplateId').value = id;
  showHideLayerInMiddle("newTemplateDiv",x,y);
}


function doTemplateSave() {
	if(document.getElementById('newTemplateName').value == "") {
		alert('Please insert name');
		return;
	}
	hideLayer('newTemplateDiv');
	document.access.target = 'newTemplateFrame';
	document.access.action = "addNewTemplate.jsp";
	document.access.submit();
}

function templateCreated() {
	buildTemplatesList();
	var createdTemplateName = frames['newTemplateFrame'].createdTemplateName;
	var createdTemplateId = frames['newTemplateFrame'].createdTemplateId;
	var createdTemplateFrom = frames['newTemplateFrame'].createdTemplateFrom;
	var createdTemplateTo = frames['newTemplateFrame'].createdTemplateTo;
	var createdTemplateSubject = frames['newTemplateFrame'].createdTemplateSubject;
	var createdTemplateMessage = frames['newTemplateFrame'].createdTemplateMessage;
	
	if(createdTemplateName && createdTemplateId) {
		templatesArr[templatesArr.length] = new emailTemplate(createdTemplateId,createdTemplateFrom,createdTemplateTo,createdTemplateSubject,createdTemplateMessage);
		var length = document.getElementById('templateId[edges0_0_x]').length;
		//adding the new option to the transaction
		for(var i=0;i<transactionAlertsArr.length;++i) {
				id = "transaction0_"+i+"_x";
				(document.getElementById('templateId['+id+']'))[length] = new Option(createdTemplateName,createdTemplateId);
		}
		//adding the new option to the transaction
		for(var i=0;i<edgesAlertsArr.length;++i) {
			for(var j=0;j<edgesAlertsArr[i].length;++j) {
				id = "edges"+i+"_"+j+"_x";
				(document.getElementById('templateId['+id+']'))[length] = new Option(createdTemplateName,createdTemplateId); 		
			}
		}
		(document.getElementById('templateId[ID]'))[length] = new Option(createdTemplateName,createdTemplateId);
	}
	//clean the div
	document.getElementById('newTemplateName').value = "";
}

function updateTableHeight(imgHeight) {
  var m= imgHeight;
  if (!imgHeight || imgHeight == "" || imgHeight == -1){
    imgHeight = document.getElementById("graphImage").height;
  }
  var h = document.body.clientHeight - imgHeight - 145;
 // alert(h + " , "  + document.getElementById("graphImage").height +  " , "  + document.body.clientHeight +  " , " + m);
  if (h < 150){
    h = 150;
  }
  document.getElementById("nodesDiv").style.height = h;
  document.getElementById("nodesTableFlowDiv").style.height = h;
}

function updateImageWidth(imgWidth) {
	var divWidth = document.body.clientWidth ;
	imgWidth = document.body.clientWidth;
 /*if (!imgWidth || imgWidth == -1){
    imgWidth = document.body.clientWidth;
    //divWidth = divWidth + 13;
  }else {
    if (imgWidth > (document.body.clientWidth - 20)){
      //divWidth = divWidth + 13;
    }else {
      imgWidth = document.body.clientWidth - 7;
      //divWidth = divWidth + 13;
    }
  }*/
  document.getElementById("transactionVisualViewInnerDiv").style.width = divWidth; 
  document.getElementById("transactionVisualViewInnerTable").style.width = imgWidth;
}

function doAddDataFilter() {
	if(filterRoutineId != "" && filterDataFilterId != "") {
		addFilter(filterRoutineId, filterDataFilterId);
		filterRoutineId = "";
		filterDataFilterId = "";
	}
}

var xmlHttpRequestObjectAddFilter;
function addFilter(routineId,dataFilterId) {
	xmlHttpRequestObjectAddFilter = GetXmlHttpObject();
  var url = "addDataFilter.jsp?";
	var parameters = "";
	parameters += "&nodeId=" + routineId;
	parameters += "&nodeType=routine";
	parameters += "&dataFilterId=" + dataFilterId;
	parameters += "&isView=true";
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectAddFilter.open("POST", url, true);
	xmlHttpRequestObjectAddFilter.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectAddFilter.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectAddFilter.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectAddFilter.onreadystatechange = addFilterCallback;
  xmlHttpRequestObjectAddFilter.send(parameters);
}

function addFilterCallback() {
	if (xmlHttpRequestObjectAddFilter.readyState == 4) {
		if (xmlHttpRequestObjectAddFilter.status == 200) {
		  var xmlDoc = xmlHttpRequestObjectAddFilter.responseXML.documentElement;
			updateDataFiltersList(xmlDoc);
		}
	}
}

var xmlHttpRequestObjecShowFunction;
function showFunction(nodeId, nodeType, functionId, isView) {
	xmlHttpRequestObjecShowFunction = GetXmlHttpObject();
  
  var url = "showFunction.jsp?";
	var parameters = "";
	parameters += "&functionId=" + functionId;
	parameters += "&nodeId=" + nodeId;
	parameters += "&nodeType=" + nodeType;
	parameters += "&isView=" + isView;
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjecShowFunction.open("POST", url, true);
	xmlHttpRequestObjecShowFunction.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjecShowFunction.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjecShowFunction.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjecShowFunction.onreadystatechange = showFunctionCallback;
  xmlHttpRequestObjecShowFunction.send(parameters);
}

function showFunctionCallback() {
	if (xmlHttpRequestObjecShowFunction.readyState == 4) {
		if (xmlHttpRequestObjecShowFunction.status == 200) {
		  var xmlDoc = xmlHttpRequestObjecShowFunction.responseXML.documentElement;
		  updateFunctionBody(xmlDoc, true);
		}
	}
}

var xmlHttpRequestObjecRemoveDataFilter;
function removeDataFilter(nodeId, nodeType, dataFilterId, isView) {
	var dataFilterBodyTd = document.getElementById(nodeType + nodeId + "DataFilterBody");
	handleInnerHTML(dataFilterBodyTd, "", 0);
	xmlHttpRequestObjecRemoveDataFilter = GetXmlHttpObject();
  var url = "removeDataFilter.jsp?";
	var parameters = "";
	parameters += "&dataFilterId=" + dataFilterId;
	parameters += "&nodeId=" + nodeId;
	parameters += "&nodeType=" + nodeType;
	parameters += "&isView=" + isView;
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjecRemoveDataFilter.open("POST", url, true);
	xmlHttpRequestObjecRemoveDataFilter.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjecRemoveDataFilter.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjecRemoveDataFilter.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjecRemoveDataFilter.onreadystatechange = removeDataFilterCallback;
  xmlHttpRequestObjecRemoveDataFilter.send(parameters);
}

function removeDataFilterCallback() {
	if (xmlHttpRequestObjecRemoveDataFilter.readyState == 4) {
		if (xmlHttpRequestObjecRemoveDataFilter.status == 200) {
		  var xmlDoc = xmlHttpRequestObjecRemoveDataFilter.responseXML.documentElement;
		  updateDataFiltersList(xmlDoc);
		}
	}
}

function updateDataFiltersList(xmlDoc) {
	var filtersListElement = xmlDoc.getElementsByTagName("DataFiltersList")[0];
	var nodeId = filtersListElement.getAttribute("nodeId");
	var nodeType = filtersListElement.getAttribute("nodeType");
	var dataFilterId = filtersListElement.getAttribute("dataFilterId");
	var filtersList = getElementValue(filtersListElement);
	var filtersListTd = document.getElementById(nodeType + nodeId + "DataFiltersList");
	handleInnerHTML(filtersListTd, filtersList, 0);
	if (dataFilterId && dataFilterId != ""){
		showDataFilter(nodeId, nodeType, dataFilterId, false);
	}
}

var xmlHttpRequestObjecShowDataFilter;
function showDataFilter(nodeId, nodeType, dataFilterId, isView) {
	xmlHttpRequestObjecShowDataFilter = GetXmlHttpObject();
  var url = "showDataFilter.jsp?";
	var parameters = "";
	parameters += "&dataFilterId=" + dataFilterId;
	parameters += "&nodeId=" + nodeId;
	parameters += "&nodeType=" + nodeType;
	parameters += "&isView=" + isView;
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjecShowDataFilter.open("POST", url, true);
	xmlHttpRequestObjecShowDataFilter.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjecShowDataFilter.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjecShowDataFilter.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjecShowDataFilter.onreadystatechange = showDataFilterCallback;
  xmlHttpRequestObjecShowDataFilter.send(parameters);
}

function showDataFilterCallback() {
	if (xmlHttpRequestObjecShowDataFilter.readyState == 4) {
		if (xmlHttpRequestObjecShowDataFilter.status == 200) {
		  var xmlDoc = xmlHttpRequestObjecShowDataFilter.responseXML.documentElement;
		  updateDataFilterBody(xmlDoc);
		}
	}
}

function updateDataFilterBody(xmlDoc) {
	var dataFilterBodyElement = xmlDoc.getElementsByTagName("DataFilterBody")[0];
	var nodeId = dataFilterBodyElement.getAttribute("nodeId");
	var nodeType = dataFilterBodyElement.getAttribute("nodeType");
	var dataFilterId = dataFilterBodyElement.getAttribute("dataFilterId");
	var dataFilterBody = getElementValue(dataFilterBodyElement);
	var dataFilterBodyTd = document.getElementById(nodeType + nodeId + "DataFilterBody");
	handleInnerHTML(dataFilterBodyTd, dataFilterBody, 0);
	
	handleDataFilterClick(dataFilterId);
}

var previousDataFilterId;
function handleDataFilterClick(dataFilterId) {
	var previousDataFilterLink = document.getElementById("dataFilter" + previousDataFilterId + "Link");
	var previousRemoveImageDiv = document.getElementById("dataFilter" + previousDataFilterId + "RemoveImageDiv");
	if(previousDataFilterLink && previousDataFilterId != dataFilterId) {
		previousDataFilterLink.className = "FILTER_TEXT";
		var previousDataFilterTr = document.getElementById("dataFilter" + previousDataFilterId + "Tr");
		previousDataFilterTr.bgColor = "";
		handleInnerHTML(previousRemoveImageDiv, "<img border='0' id='dataFilter" + previousDataFilterId + "RemoveImage' src='" + baseDirectory + "logic/images/tranview/remove.gif'>", 0);
	}
	
	if(dataFilterId != '') {
		var dataFilterLink = document.getElementById("dataFilter" + dataFilterId + "Link");
		dataFilterLink.className = "SELECTED_FILTER_TEXT";
		var dataFilterTr = document.getElementById("dataFilter" + dataFilterId + "Tr");
		dataFilterTr.bgColor = "#949293";
		var removeImageDiv = document.getElementById("dataFilter" + dataFilterId + "RemoveImageDiv");
		handleInnerHTML(removeImageDiv, "<img border='0' id='dataFilter" + dataFilterId + "RemoveImage' src='" + baseDirectory + "logic/images/tranview/removeFunctionSelected.gif'>", 0);
	}
	previousDataFilterId = dataFilterId;
}

var selectedImageComboId;
var selectedImageType;
var selectedImageId;
var selectedImageRoutineId;
function showImageSettingsDiv(id,imageComboId,imageType,imageId,rId){ 
  buildUploadImageDiv(); 
  selectedImageComboId = imageComboId;
  selectedImageType = imageType;
  selectedImageId = imageId;
  selectedImageRoutineId = rId;
  document.getElementById("propertyName").value = "";
  var x = -1;
  var y = -1;
  var d = document.getElementById("imageSettingsDiv");
  if (id && id != ""){
    var comp = document.getElementById(id);
    x = findPosX(comp) - 20;
    y = findPosY(comp) - (d.clientHeight/3);
  }
  
	d.style.top = 200;
	d.style.left = 300;
	d.style.display = "";
    document.getElementById("archivePath").focus();
}

var doUpdateImages = false;
function doImageSave(){
	doUpdateImages = true;
   document.getElementById("imageSettingsDiv").style.cursor = "wait";
   var propertyName = document.getElementById("propertyName").value;
   var propertyValue = document.getElementById("propertyValue").value;
   var propertyId = document.getElementById("propertyId").value;
   var archivePath = document.getElementById("archivePath").value;
   var targetPath = routineUploadPath;
   var httpPath = routineHttpPath;
   document.access.doUpdate.value = "true";
   document.imageForm.action = "uploadImage.jsp?propertyName=" + propertyName + "&propertyValue=" + propertyValue + "&propertyId=" + propertyId + "&archivePath=" + archivePath +"&targetPath="+targetPath+"&httpPath="+httpPath+"&routineId="+selectedImageRoutineId+"&imageType="+selectedImageType;
   document.imageForm.submit();
}

function updateImageInfo(){
   var path = document.getElementById("archivePath").value;
   if(!path || path == ""){
      return;
   }
   
   index = path.lastIndexOf("/");
   if(index < 0){
     index = path.lastIndexOf("\\");
   }
 
   imagePath = path.substring(index+1,path.length);
   var propertyValue = document.getElementById("propertyValue").value;
   var propertyName = document.getElementById("propertyName").value;
   if (imagePath && imagePath != ""){
     document.getElementById("propertyValue").value = imagePath;
   }
   name = imagePath;
   index = name.indexOf(".");
   if (index >= 0){
     name = name.substring(0,index);
   }
   if (!propertyName || propertyName == ""){
     document.getElementById("propertyName").value = name;
   }
}



var xmlHttpRequestObjectUploadImage;
function updateImages() {
	xmlHttpRequestObjectUploadImage = GetXmlHttpObject();
  var url = "updateImages.jsp?";
	var parameters = "";
	parameters += "&routineId=" + selectedImageRoutineId;
	parameters += "&isView=true";
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectUploadImage.open("POST", url, true);
	xmlHttpRequestObjectUploadImage.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectUploadImage.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectUploadImage.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectUploadImage.onreadystatechange = updateImagesCallback;
  xmlHttpRequestObjectUploadImage.send(parameters);
}

function updateImagesCallback() {
	if (xmlHttpRequestObjectUploadImage.readyState == 4) {
		if (xmlHttpRequestObjectUploadImage.status == 200) {
		  var xmlDoc = xmlHttpRequestObjectUploadImage.responseXML.documentElement;
		  document.getElementById("imageSettingsDiv").style.cursor = "default";
		  document.getElementById("imageSettingsDiv").style.display = "none";
			updateTransactionView(xmlDoc);
		}
	}
}

function imageLoaded(){
	if (doUpdateImages == true){
		doUpdateImages = false;
		updateImages();
	}
}

function buildUploadImageDiv(){
	handleInnerHTML(document.getElementById("archiveFileDiv"), "<input class=\"TRANSACTION_TEXTBOX\" type=\"file\" id=\"archivePath\" name=\"archivePath\" size=\"30\" onChange=\"javascript:updateImageInfo()\">", 1);
}