<%@ page import="xpolog.eye.data.filters.FilterCollection"%>

<%@ page import="xpolog.logic.atomic.data.XpoLogAtomicParadigm"%>
<%@ page import="xpolog.logic.common.NodeModelParadigm"%>
<%@ page import="xpolog.logic.routine.data.RoutineParadigm"%>
<%@ page import="xpolog.logic.sources.xplg.XplgDataSource"%>
<%@ page import="xpolog.logic.transaction.data.TransactionParadigm"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmBuilder"%>

<%

String TRAN_PARADIGM_BUILDER = "TRAN_PARADIGM_BUILDER";

String BASE_DIRECTORY = request.getParameter("BASE_DIRECTORY");
String subTransactionId = request.getParameter("subTransactionId");
String isViewStr = request.getParameter("isView");
boolean isView = isViewStr != null && isViewStr.equals("true");

UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute(TRAN_PARADIGM_BUILDER);

TransactionParadigm root = null;
if(subTransactionId != null && subTransactionId.length() > 0) {
	root = builder.getTransactionById(subTransactionId);
}else {
	root = builder.getRoot();
}

NodeModelParadigm[] nodes = builder.getTransactionNodes(root);
%>

							<table border="0" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%">
			  				<tr valign="top">
			  					<td width="100%">
			  						<table id="nodesTable" border="0" cellpadding="0" cellspacing="0" style="border-width:0" width="100%">
											<tr>
												<td width="100%" >
						  						<table border="0" cellspacing="0" style="border: solid 1px #000000 ;border-top-width:0;border-collapse: collapse" width="100%">
						  							<tr bgcolor="#C3C3C3">
					  									<td>
					  										<table border="0" cellspacing="0" cellpadding="0" width="100%">
					  											<tr>
					  												<td width="205">
																			<table border="0" cellspacing="0" cellpadding="0" width="100%">
																				<tr>
													  							<td width="20" style="border-width:0"></td>
													  							<td class="NODES_TABLE_HEADER" style="padding-left:5;border-left:1px solid #9f9f9f">Name</td>
													  						</tr>
													  					</table>
													  				</td>
										  							<td width="*" valign="middle">
																			<table border="0" cellspacing="0" cellpadding="0" width="100%">
																				<tr>
													  							<td width="32%" class="NODES_TABLE_HEADER" style="padding-left:5;border-left:1px solid #9f9f9f">Data Source</td>
													  							<td width="32%" class="NODES_TABLE_HEADER" style="padding-left:5;border-left:1px solid #9f9f9f">Filter</td>
													  							<td width="*" class="NODES_TABLE_HEADER" style="padding-left:5;border-left:1px solid #9f9f9f;">Characteristics</td>							  						
													  						</tr>
													  					</table>
													  				</td>
													  			</tr>
														  	</table>
														  </td>
									 						<td width="14" style="font-size:2pt"></td>
						  							</tr>
							  					</table>
							  				</td>
							  			</tr>
							  			<tr>
					              <td>					                
							  			<div id="nodesTableFlowDiv" style="overflow-y:scroll;height:300">
							  				<table border="0" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%">
				  						<%
				              for(int i = 0; i < nodes.length;i++) {
				              	NodeModelParadigm node = nodes[i];
				              	TransactionParadigm transaction = null;
				              	RoutineParadigm routine = null;
				              	XpoLogAtomicParadigm atomic = null;
				              	XplgDataSource dataSource = null;
				              	
				              	if(node.getNodeType().equals(TransactionParadigm.TRANSACTION_PARADIGM)) {
				              		transaction = (TransactionParadigm)node;
				              		
				              		String transactionId = transaction.getId();
				              %>
				              		<tr id="tableRowsubTransaction<%=transactionId %>">
					                	<td>
					                	
															<jsp:include page="subTransactionGlobalView.jsp" flush="true" >
																<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY %>"/>
																<jsp:param name="parentTransaction" value="<%=root.getId() %>"/>
																<jsp:param name="subTransactionId" value="<%=transactionId %>"/>
																<jsp:param name="isView" value="<%=isView %>"/>
															</jsp:include>
														</td>
													</tr>
				              <%
				              	}else if(node.getNodeType().equals(RoutineParadigm.ROUTINE_PARADIGM)) {
				              		routine = (RoutineParadigm)node;
				              		
					              	atomic = builder.getAtomicByRoutineId(routine.getId());
					              	if (atomic != null && atomic.getLbm() == null){
					              		atomic = null;
					              		dataSource = null;
												  }else {		
												  	dataSource = builder.getDataSourceByRoutineId(routine.getId());
												  }
									  		  
									  		  String atomicDisplay = atomic == null ? "None" : atomic.getName();
									  		  String filterDisplay = "";
									  		  if(/*!isView || */atomic == null || dataSource.getFilterId() == null || dataSource.getFilterId().length() == 0 || dataSource.getFilterId().equals("none")) {
									  		  	filterDisplay = "None";
									  		  }else {
									  		  	if(atomic != null) {
											  			java.util.List filtersList = atomic.getLbm().getFilterManager().getFilterCollections();
											  			if(filtersList != null) { 					
											    			String selectedFilterId = dataSource == null ? null : dataSource.getFilterId();
										    	    	for (int f = 0; f < filtersList.size(); f++) {
											  		      FilterCollection col = (FilterCollection)filtersList.get(f);
														      boolean selected = selectedFilterId != null && selectedFilterId.equals(col.getId());
														      if(/*!isView || */selected) {
														      	filterDisplay = col.getName();
														      	break;
											      			}			    
											    			}
											  			}
														}
									  		  }
									  		  String rulesDisplay = "";
									  		  rulesDisplay += routine.isLogicFromType(RoutineParadigm.START_LOGIC_TYPE) ? "Open, " : "";
									  		  rulesDisplay += routine.isLogicFromType(RoutineParadigm.SINGLE_LOGIC_TYPE) ? "Single, " : "";
									  		  rulesDisplay += routine.isLogicFromType(RoutineParadigm.OPTIONAL_LOGIC_TYPE) ? "Optional, " : "";
									  		  rulesDisplay += routine.isLogicFromType(RoutineParadigm.END_LOGIC_TYPE) ? "End, " : "";
									  		  if(rulesDisplay.length() > 0) {
									  		  	rulesDisplay = rulesDisplay.substring(0, rulesDisplay.length() - 2);
									  		  }
									  		  
									  		  String routineId = routine.getId();
			                %>
					                <tr id="tableRowroutine<%=routineId %>">
					                	<td>
															<jsp:include page="routineGlobalView.jsp" flush="true" >
																<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY %>"/>
																<jsp:param name="parentTransaction" value="<%=root.getId() %>"/>
																<jsp:param name="routineId" value="<%=routineId %>"/>
																<jsp:param name="atomicDisplay" value="<%=atomicDisplay %>"/>
																<jsp:param name="filterDisplay" value="<%=filterDisplay %>"/>
																<jsp:param name="rulesDisplay" value="<%=rulesDisplay %>"/>
																<jsp:param name="isView" value="<%=isView %>"/>
															</jsp:include>
														</td>
													</tr>
											<%
				              	}
											}
											%>
											</table>
											</div>
											</td>
											</tr>
										</table>
			  					</td>
			  				</tr>
  						</table>