<%@ page import="xpolog.logic.common.NodeModelParadigm"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmBuilder"%>
<%@ page import="xpolog.logic.ui.conf.UIConstants"%>
<%@ page import="xpolog.logic.ui.conf.UIPreferences"%>
<%@ page import="xpolog.logic.ui.conf.UIProperty"%>
<%@ page import="xpolog.logic.ui.conf.UIProperties"%>

<%!static final String BASE_DIRECTORY = "../../../";%>

<%

String TRAN_PARADIGM_BUILDER = "TRAN_PARADIGM_BUILDER";

String nodeId = request.getParameter("nodeId");
String nodeType = request.getParameter("nodeType");
String isViewStr = request.getParameter("isView");
boolean isView = isViewStr != null && isViewStr.equals("true");

UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute(TRAN_PARADIGM_BUILDER);
NodeModelParadigm node = null;
if(nodeType.equals("subTransaction")) {
	node = builder.getTransactionById(nodeId);
}else if(nodeType.equals("routine")) {
	node = builder.getRoutineById(nodeId);
}
UIProperty[] imageProperties = builder.getImagesProperties();
UIProperties properties = (UIProperties)node.getUIObject();
if (properties == null){
  properties = UIPreferences.getInstance().getAllPropertiesForNode(node,true);
}
UIProperty routineRuntimePropertyRef = properties.getProperty(UIConstants.IMAGES_TYPE,UIConstants.ROUTINE_RUNTIME_KEY).getReferenceProperty();
UIProperty routineRuntimeErrorPropertyRef = properties.getProperty(UIConstants.IMAGES_TYPE,UIConstants.ROUTINE_RUNTIME_ERROR_KEY).getReferenceProperty();
UIProperty dummyRoutinePropertyRef = properties.getProperty(UIConstants.IMAGES_TYPE,UIConstants.DUMMY_ROUTINE_KEY).getReferenceProperty();					  

UIProperties defProperties = UIPreferences.getInstance().getDefaultProperies();
UIProperty defRoutineRuntimeImg = defProperties != null ? defProperties.getProperty(UIConstants.IMAGES_TYPE,UIConstants.ROUTINE_RUNTIME_KEY) : null;
UIProperty defRoutineRuntimeErrorImg = defProperties != null ? defProperties.getProperty(UIConstants.IMAGES_TYPE,UIConstants.ROUTINE_RUNTIME_ERROR_KEY) : null;
UIProperty defDummyRoutineImg = defProperties != null ? defProperties.getProperty(UIConstants.IMAGES_TYPE,UIConstants.DUMMY_ROUTINE_KEY) : null;

%>
					                      	
<table border="0" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%" bgcolor="#DBDDE9">
					                          <tr style="padding-top:5">
						                          <td width="50" style="padding-left:10;padding-top:5"><span class="NODE_TEXT"><nobr>Existing Event </nobr></span></td>
						                          <td width="100">
							                          <select size="1" id="routineRuntimeImages<%=nodeId%>" name="routineRuntimeImages<%=nodeId%>" onChange="javascript:changeImage(this,'routineRuntime','routineRuntimeImage<%=nodeId%>','<%=nodeId%>')" class="TRANSACTION_TEXTBOX">
							                          <option value="default">Default</option>
							                          <%
							                          String src = null;
							                          String selected = "";
							                          for (int i=0; i<imageProperties.length; i++){
							                          	selected = "";
							                          	UIProperty uiProp = imageProperties[i];
							                          	if (routineRuntimePropertyRef != null && uiProp.getId().equals(routineRuntimePropertyRef.getId())){
							                          		selected = " selected";
							                          		src = uiProp.getValue();
							                          	}
							                          %>
							                          <option value="<%=uiProp.getId()%>"<%=selected%>><%=uiProp.getName()%></option>
							                          <%}
							                          if (src == null && defRoutineRuntimeImg != null){
							                          	src = defRoutineRuntimeImg.getValue();
							                          }
							                          //System.out.println("src="+src);
							                          %>
							                          </select>
						                          </td>
						                          <td width="50" style="padding-left:10;padding-top:5"><IMG id="routineRuntimeImage<%=nodeId%>" width="20" height="20" <%if(src != null){%>src="<%=BASE_DIRECTORY+src%>"<%}%>></td>
						                          <td width="100" id="newRoutineImage2<%=nodeId%>">&nbsp;<a class="BODY_ACTION_LINK" href="javascript:showImageSettingsDiv('newRoutineImage2<%=nodeId%>','routineRuntimeImages<%=nodeId%>','routineRuntime','routineRuntimeImage<%=nodeId%>','<%=nodeId%>')">upload</a></td>
					                          </tr>
					                        	<tr style="padding-top:5">                          
					                          	<td width="50" style="padding-left:10;padding-top:5;padding-right:10"><span class="NODE_TEXT"><nobr>Faulty Event </nobr></span></td>
						                          <td width="100">
							                          <select size="1" id="routineRuntimeErrorImages<%=nodeId%>" name="routineRuntimeErrorImages<%=nodeId%>" onChange="javascript:changeImage(this,'routineRuntimeError','routineRuntimeErrorImage<%=nodeId%>','<%=nodeId%>')" class="TRANSACTION_TEXTBOX">
							                          <option value="default">Default</option>
							                          <%
							                          src = null;
							                          for (int i=0; i<imageProperties.length; i++){
								                          selected = "";
							                          	UIProperty uiProp = imageProperties[i];
							                          	if (routineRuntimeErrorPropertyRef != null && uiProp.getId().equals(routineRuntimeErrorPropertyRef.getId())){
							                          		selected = " selected";
							                          		src = uiProp.getValue();
							                          	}
							                          %>
							                          <option value="<%=uiProp.getId()%>"<%=selected%>><%=uiProp.getName()%></option>
							                          <%}
							                          if (src == null && defRoutineRuntimeErrorImg != null){
							                          	src = defRoutineRuntimeErrorImg.getValue();
							                          }
							                          //System.out.println("src2="+src);
							                          %>
							                          </select>
						                          </td>
						                          <td width="50" style="padding-left:10;padding-top:5"><IMG id="routineRuntimeErrorImage<%=nodeId%>"  width="20" height="20" <%if(src != null){%>src="<%=BASE_DIRECTORY+src%>"<%}%>></td>
						                          <td width="100" id="newRoutineImage1<%=nodeId%>">&nbsp;<a class="BODY_ACTION_LINK" href="javascript:showImageSettingsDiv('newRoutineImage1<%=nodeId%>','routineRuntimeErrorImages<%=nodeId%>','routineRuntimeError','routineRuntimeErrorImage<%=nodeId%>','<%=nodeId%>')">upload</a></td>
						                          <td width="*" rowspan="3">&nbsp;</td>
					                          </tr>
					                          <tr style="padding-top:5;padding-bottom:5">
						                          <td width="50" style="padding-left:10;padding-top:5;padding-right:10"><span class="NODE_TEXT"><nobr>Missing Event </nobr></span></td>
						                          <td width="100">
							                          <select size="1" id="dummyRoutineImages<%=nodeId%>" name="dummyRoutineImages<%=nodeId%>" onChange="javascript:changeImage(this,'dummyRoutine','dummyRoutineImage<%=nodeId%>','<%=nodeId%>')" class="TRANSACTION_TEXTBOX">
							                          <option value="default">Default</option>
							                          <%
							                          src = null;
							                          for (int i=0; i<imageProperties.length; i++){
								                          selected = "";
							                          	UIProperty uiProp = imageProperties[i];
							                          	if (dummyRoutinePropertyRef != null && uiProp.getId().equals(dummyRoutinePropertyRef.getId())){
							                          		selected = " selected";
							                          		src = uiProp.getValue();
							                          	}
							                          %>
							                          <option value="<%=uiProp.getId()%>"<%=selected%>><%=uiProp.getName()%></option>
							                          <%}
							                          if (src == null && defDummyRoutineImg != null){
							                          	src = defDummyRoutineImg.getValue();
							                          }
							                          //System.out.println("src3="+src);
							                          %>
							                          </select>
						                          </td>
						                          <td width="50" style="padding-left:10;padding-top:5"><IMG id="dummyRoutineImage<%=nodeId%>"  width="20" height="20" <%if(src != null){%>src="<%=BASE_DIRECTORY+src%>"<%}%>></td>
						                          <td width="100" id="newRoutineImage3<%=nodeId%>">&nbsp;<a class="BODY_ACTION_LINK" href="javascript:showImageSettingsDiv('newRoutineImage3<%=nodeId%>','dummyRoutineImages<%=nodeId%>','dummyRoutine','dummyRoutineImage<%=nodeId%>','<%=nodeId%>')">upload</a></td>
					                          </tr>
					                      	</table>
