<%@ page language="java"%>

<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.logic.security.*"%>
<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<% 
WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request,response,LogicPermissionConstants.AdministrationPermissions.UI_SETTINGS_PERMISSION,true)){
     return;
}

UserSecurity user = manager.getUserSecurity(request);

  String ERROR_OBJ = "ERROR_OBJ";
  String propertyType = request.getParameter("propertyType");
  if (propertyType == null || propertyType.trim().length() ==0){
    propertyType = UIConstants.IMAGES_TYPE;
  }
  
  UIProperties globalProperties = UIPreferences.getInstance().getGlobalProperties();
  UIProperty [] properties = globalProperties.getSortedProperties(globalProperties.getAllProperties(propertyType));
  
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />
<script>
  function filterType(){
  	document.access.action = "UILogicView.jsp";
  	document.access.submit();
  }
  
  function goEdit(id,type){
  	path = "propertyAction.jsp?propertyType=" + type + "&propertyId="+id;
  	document.location = path;
  }
  
  function goNew(){
  	type = document.access.propertyType.options[document.access.propertyType.selectedIndex].value;
	
		path = "propertyAction.jsp?propertyType=" + type;	
    document.location = path;
  }
  
  function doDelete(id,propertyType){
    type = document.access.propertyType.options[document.access.propertyType.selectedIndex].value;
  	path = "propertyRemoveAction.jsp?propertyId=" + id + "&propertyType=" + propertyType + "&type=" + type;
  	document.location = path;
  }
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0"  width="100%" class="LOGIC_MAIN_TABLE">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td colspan="2" nowrap><span class="PAGEHEADER">UI Customization </span></td>
                <td width="50%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>              
             
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2" >
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                 <tr>
                    <td><span class="HEADER">Properties List</span></td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td style="padding-left:250"><span class="REGULARTEXT">View  <span class="REGULARTEXT">
                    <select class="TEXTBOX" size="1" name="propertyType" onchange="javascript:filterType()">
                       <!-- <option value="all">All</option> -->
                        <option value="<%=UIConstants.IMAGES_TYPE%>" <%=propertyType.equals(UIConstants.IMAGES_TYPE) ? "selected" : ""%>>Images</option>
                      </select></td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td><span class="REGULARTEXT"><a href="javascript:goNew()" class="LINK">Add new</a></span></td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr class="TABLES_HEADERS">
                        <td width="50%"><span class="REGULARTEXT">Name</span></td>                        
                        <td width="100"><span class="REGULARTEXT">Type</span></td>
                        <td width="*">&nbsp;</td>
                        <td width="20"></td>
                      </tr>
                     <%
                      for(int i=0;i<properties.length;i++){
                     %>
                      <tr>
			  <td width="50%"><a href="javascript:goEdit('<%=properties[i].getId()%>','<%=properties[i].getType()%>')" class="LINK"><%=properties[i].getName()%></a></td>
                          <td width="100"><span class="REGULARTEXT"><%=properties[i].getType()%></span></td>
                          <td width="*" nowrap>&nbsp;<a href="javascript:goEdit('<%=properties[i].getId()%>','<%=properties[i].getType()%>')" class="LINK">edit</a>
                            <a href="javascript:doDelete('<%=properties[i].getId()%>','<%=properties[i].getType()%>')" class="LINK">delete</a></td>
                        <td width="20"></td>
                       </tr>
                      <%
                        }
                      %>
                        <tr>
			 									 <td colspan="4">&nbsp;</td>                         
                       </tr>
                    </table>
                   </td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>          
        </table>
        </td>
      </tr>      
    </table>
    </td>
  </tr>
</table>
</form>


</body>

</html>