<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%!
	static final String BASE_DIRECTORY = "../../../../";
%>

<%
	UserContext userContext = UserEnvironment.getUserContext(request);

	String ERROR_OBJ = "ERROR_OBJ";
	
	ErrorModel errmodel = new ErrorModel();
	
	String propertyType = UIConstants.IMAGES_TYPE;
	String propertyId = request.getParameter("propertyId");
	String propertyName = request.getParameter("propertyName");
	String propertyValue = request.getParameter("propertyValue");
	String propertyKey = request.getParameter("propertyKey");
	String archFile = request.getParameter("archivePath");
	String targetPath = request.getParameter("targetPath");
	if (targetPath == null || targetPath.length() == 0){
		targetPath = UILogicAdminHelper.IMAGES_CUSTOM_PATH;
	}
	String httpPath = request.getParameter("httpPath");
	if (httpPath == null || httpPath.length() == 0){
		httpPath = UILogicAdminHelper.IMAGES_CUSTOM_HTTP_PATH;
	}
	
	if(propertyName == null || propertyName.trim().equals("")){
      errmodel.addError("No Qproperty name was supplied.");
    }
    
    if(propertyValue == null || propertyValue.trim().equals("")){
      errmodel.addError("No image was supplied.");
    }
    
	
	if(errmodel.getErrorCount() != 0){
      request.getSession().setAttribute(ERROR_OBJ,errmodel);
      response.sendRedirect(BASE_DIRECTORY  + "common/errorpage.jsp?cancelURL=logic/admin/adminboard.jsp");
      return;
    }
    
    boolean isNew = false;
    UIProperty property = UIPreferences.getInstance().getGlobalProperties().getProperty(propertyType,propertyId);
    if (property == null){     
      isNew = true;
    }
    property = new UIProperty();
    property.setKey(propertyKey);
    property.setType(UIConstants.IMAGES_TYPE);
    property.setGroupType(UIConstants.GLOBAL_GROUP_TYPE);
    property.setName(propertyName);
    property.setValue(httpPath + propertyValue);
    if (!isNew){
      property.setId(propertyId);
    }
    
    File arch = null;
    if (archFile != null && archFile.trim().length() > 0){
      arch = new File(archFile);
    }
    try {
      if (arch != null){
        File targetDir = new File(targetPath + propertyValue);        
 	      arch = UploadHelper.putUploadFileOnServer(request,arch,targetDir.getParentFile().getAbsolutePath(),targetDir.getName());
      }
      if (isNew){
        UIPreferences.getInstance().insertGlobalProperties(property);
      }else {
        UIPreferences.getInstance().updateGlobalProperties(property);
      }
      propertyId = property.getId();
      propertyName = property.getName();
      propertyValue = property.getValue();
     
    }catch (Exception e){
      String error = "Saving image property failed from the following reason: ";
      error += e.getMessage();	  
	    errmodel.addError(error);
    }
    if(errmodel.getErrorCount() != 0){
      request.getSession().setAttribute(ERROR_OBJ,errmodel);
      response.sendRedirect("/logeye/common/errorpage.jsp?cancelURL=logic/admin/adminboard.jsp");
      return;
    }
    
	//      audit
    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
         			userContext, AuditConstants.CHANGE, "add/edit image property", AuditConstants.CONFIGURATION, "add/edit image property");

%>

<html>
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<head>
<script>
var propertyId = "<%=propertyId == null ? "" : propertyId%>";
var propertyName = "<%=propertyName == null ? "" : propertyName%>";
var propertyValue = "<%=propertyValue == null ? "" : propertyValue%>";
var propertyURL = "<%=propertyValue == null ? "" : propertyValue%>";
</script>
</head>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access">
<!--<jsp:include page="../../../tabs.jsp" />-->
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" bgcolor="#C0C0C0" bordercolor="#875546">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">              
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">General</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="22">
                    <span class="REGULARTEXT">Saving operation ended successfully.</span>
                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" valign="bottom">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="150" id="AutoNumber7">
              <tr>
                <td width="15%">&nbsp;</td>
                <td width="11%" align="center">&nbsp;</td>
                <td width="150" align="center"><nobr>
                <a href="<%=BASE_DIRECTORY%>logic/admin/ui/UILogicView.jsp" class="LINK">ok</a>               
                </nobr></td>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>