<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";

%>

<%

	final UserContext userContext = UserEnvironment.getUserContext(request);
	
  String ERROR_OBJ = "ERROR_OBJ";
	

  String workspaceId = request.getParameter("workspaceId");
  if (workspaceId == null){
    workspaceId = "";
  }

  ErrorModel errmodel = new ErrorModel();
	
  if(workspaceId == null || workspaceId.trim().equals("")){
    errmodel.addError("No workspace was supplied.");
  }

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/admin/workspace/workspacesDefinitionView.jsp");
    return;
  }

  final CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
 
  final String workId = workspaceId;
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
 
  Workspace workspace = ctrlMgr.getWorkspaceById(workId);
  String name = "";
  if(workspace != null) {
	  name = workspace.getName();
  }
	//    audit
    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
       			userContext, AuditConstants.CHANGE, "remove worksapce", AuditConstants.WORKSPACE, "remove wrokspace " + name);

  ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "logic/admin/common/opok.jsp?doRefresh=true&okUrl=logic/admin/workspace/workspacesDefinitionView.jsp") {
    public void run(HttpServletRequest request){    	
     boolean suc = false;
      try {   
      	Thread.sleep(500);
       suc = ctrlMgr.removeWorkspace(workId,userContext);
     }catch (Exception e){
       e.printStackTrace();
     }
     if (!suc){
      errmodel.addError("A problem occured while removing workspace.");
      createErrorRedirect(request, BASE_DIRECTORY);
      setRedirectUrl(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/admin/workspace/workspacesDefinitionView.jsp");      
     }  

    }
  };
  env.setProgressRunner(runner);
%>

<jsp:include page="../../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Deleting Workspace"/>
 <jsp:param name="useStatus" value="false"/>
</jsp:include>

