<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";

%>

<%

  UserContext userContext = UserEnvironment.getUserContext(request);

  String ERROR_OBJ = "ERROR_OBJ";
	

  String workspaceId = request.getParameter("workspaceId");
  if (workspaceId == null){
    workspaceId = "";
  }

  String workspaceName = request.getParameter("workspaceName");
  String workspaceDesc = request.getParameter("workspaceDesc");

  ErrorModel errmodel = new ErrorModel();
	
  if(workspaceName == null || workspaceName.trim().equals("")){
    errmodel.addError("No workspace name was supplied.");
  }

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/admin/workspace/workspacesDefinitionView.jsp");
    return;
  }

  CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
  Workspace workspace = ctrlMgr.getWorkspaceById(workspaceId);

  if (workspace == null){
    workspace = new Workspace();
  }
   
  workspace.setName(workspaceName);
  workspace.setDescription(workspaceDesc);
  
  boolean suc = ctrlMgr.saveWorkspace(workspace,userContext);
  
  //  audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
     			userContext, AuditConstants.CHANGE, "add/edit worksapce", AuditConstants.WORKSPACE, "add/edit wrokspace " + workspace.getName());

  if (!suc){
      errmodel.addError("A problem occured while saving workspace.");
      request.getSession().setAttribute(ERROR_OBJ,errmodel);
      response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/admin/workspace/workspacesDefinitionView.jsp");
      return;
  }
  response.sendRedirect(BASE_DIRECTORY + "logic/admin/common/opok.jsp?doRefresh=true&okUrl=logic/admin/workspace/workspacesDefinitionView.jsp");
 
%>