<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>

<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<% 
  String ERROR_OBJ = "ERROR_OBJ";

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  UserSecurity user = manager.getUserSecurity(request);
  
  CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
  Workspace[] workspaces = ctrlMgr == null ? null : ctrlMgr.getWorkspaces();
  if (workspaces == null){
    workspaces = new Workspace[0];
  }
  Arrays.sort(workspaces, new Comparator() {
		public int compare(Object o1, Object o2) {
			String w1Name = ((Workspace)o1).getName();
			String w2Name = ((Workspace)o2).getName();
			return w1Name.toLowerCase().compareTo(w2Name.toLowerCase());
		}
	});
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />

</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0"  class="LOGICGENERAL" width="100%" id="AutoNumber2">              
	      <tr>
                <td colspan="2" nowrap><span class="PAGEHEADER">Workspaces</span></td>
              </tr>
              
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
		  <tr><td >&nbsp;</td></tr>                  
                  
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr class="TABLES_HEADERS">
                        <td width="300"><span class="REGULARTEXT">Name</span></td>
                        <td width="*"><span class="REGULARTEXT">Description</span></td>
                        <td width="100"></td>
                      </tr>
                     <%
                      for(int i=0;i<workspaces.length;i++){
												if (user != null && !user.isVisible(workspaces[i].getPermissions())) {
													continue;
												}
                     %>
                      <tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
			  <td width="300"><a href="../session/sessionsListView.jsp?workspaceId=<%=workspaces[i].getId()%>" class="LINK"><%=workspaces[i].getName()%></a></td>
                          <td width="*"><span class="REGULARTEXT"><%=workspaces[i].getDescription()==null?"":workspaces[i].getDescription()%></span></td>
                        <td width="100"></td>
                       </tr>
                      <%
                        }
                      %>
                        <tr>
			  <td width="16%">&nbsp;</td>
                          <td width="50%"></td>
                          <td width="24%"></td>
                         <td width="10%"></td>
                       </tr>
                    </table>
                   </td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>      
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>