<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.alert.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.config.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
  String ERROR_OBJ = "ERROR_OBJ";
  String OP = "OP";
  String ADD = "ADD";
  String TYPE_LOG = "Log";

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }

  String millisecondsSeperator = ".";
  UserSecurity user = manager.getUserSecurity(request);
  String startDate = request.getParameter("startDate");
  String endDate = request.getParameter("endDate");
  long start = -1;
  long end = -1;
  
  if(endDate != null && !(endDate.equals("")) ){
  	end = transformStringToDate(endDate).getTime();
  }else{
  	endDate = "";
  }
  
  LogicAlert[] alerts = new LogicAlert[0];
  if(startDate != null && !(startDate.equals(""))){
  	start = transformStringToDate(startDate).getTime();
  	AlertViewModel model = new AlertViewModel(null);
    alerts =  model.getLogicAlertsByFilter(start,end);
  }else{
  	startDate = "";
  }
%>
<%!
  public String transformDateToString(Date d){
    if(d == null){
      return null;
    }
    //01/31/2003 01:42:34
    String format = "MM/dd/yyyy HH:mm:ss";
    String str = new SimpleDateFormat(format).format(d);
    return str;
  }
%>
<%!
  public Date transformStringToDate(String str) throws Exception{
    if(str == null){
      return null;
    }
    //01/31/2003 01:42:34
    String format = "MM/dd/yyyy HH:mm:ss";
    Date d = null;
    try{
      d = new SimpleDateFormat(format).parse(str);
    }catch(Exception e){
      throw e;
    }
    return d;
  }
%>
<html>
<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/calendar/calendar2.js"></script><!-- Date only with year scrolling -->
<script>
	function editDateText(t){
		document.all.startDateHtml.innerHTML = t;
	}

	function markByDay(){
		document.access.scheduling.checked = true;
		document.access.bydays.checked = true;
	}
	
	function markByDayInMonoth(){
		document.access.scheduling.checked = true;
		document.access.bydaysinmonth.checked = true;
	}
	
	function markInterval(){
		document.access.interval.checked = true;
	}
	function clearEnd(){
		document.access.endDate.value = "";
		document.all.endDateHtml.innerHTML = "";
	}
	
	function showAlerts(){
		end = document.access.endDate.value;
		start = document.access.startDate.value;
		document.location = "alertsView.jsp?startDate=" + start +"&endDate="+end;
	}
</script>
</head>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%"  bgcolor="#C0C0C0" bordercolor="#875546" style="border: 1 solid #875546">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="55%"> <span class="PAGEHEADER">Alerts View</span></td>
                <td width="44%">&nbsp;</td>
              </tr>
                <tr>
                <td width="1%"  class="REGULARTEXT">&nbsp;</td>
                <td width="55%" class="REGULARTEXT">&nbsp;</td>
                <td width="44%" class="REGULARTEXT">&nbsp;</td>
              </tr>

              <tr>
                <td width="3%" valign="top">
                &nbsp;</td>
                <td width="100%" colspan="2" valign="top">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
                  <tr>
                    <td>
                      <table border="0" width="100%" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="6%" valign="top"><span class="HEADER">Filter</span></td>
                          <td width="44%">
                            <table border="0" width="100%" cellspacing="0" cellpadding="0">
                              <tr>
                                <td width="19%"><span class="REGULARTEXT"> between&nbsp;&nbsp;</span></td>
                                <td width="31%" nowrap><span CLASS="REGULARTEXT" ID='startDateHtml' ><%=startDate%></span><span CLASS="REGULARTEXT">&nbsp;</span><input type="hidden" name="startDate" value="<%=startDate%>" /><a href="javascript:openStart();" class="SMALLLINK">calendar</a></td>
                                <td width="25%"><span class="REGULARTEXT">&nbsp;
                                  &nbsp;</span></td>
                                <td width="25%"></td>
                              </tr>
                              <tr>
                                <td width="19%"><span class="REGULARTEXT">to&nbsp;</span></td>
                                <td width="31%" nowrap><span CLASS="REGULARTEXT" ID='endDateHtml'><%=endDate%></span><span CLASS="REGULARTEXT">&nbsp;</span><input type="hidden" name="endDate" value="<%=endDate%>"/><a href="javascript:openEnd();" class="SMALLLINK">calendar</a> <a href="javascript:clearEnd();" class="SMALLLINK">clear</a></td>
                                <td width="25%"></td>
                                <td width="25%"></td>
                              </tr>
                              <tr>
                                <td width="19%"><span class="REGULARTEXT">
                                  <a href="javascript:showAlerts()" class="LINK">show</a></span></td>
                                <td width="31%" nowrap></td>
                                <td width="25%"></td>
                                <td width="25%"></td>
                              </tr>
                            </table>
                          </td>
                          <td width="25%"></td>
                          <td width="50%"></td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
                      <tr class="TABLES_HEADERS">
                        <td width="15%" ><span class="REGULARTEXT">Type</span></td>                        
                        <td width="15%" class="REGULARTEXT" nowrap>Time</td>
                        <td width="*"><span class="REGULARTEXT">Description</span></td>
                      </tr>
                     <%
                     	for (int i = 0; i < alerts.length; i++) {
                     %>
                      <tr>
                        <td width="15%" class="SMALLTEXT" nowrap><%=alerts[i].getShowType()%></td>                        
                        <td width="15%" class="SMALLTEXT" nowrap><%=transformDateToString(new Date(alerts[i].getTimestamp()))%></td>
                        <td width="*" class="SMALLTEXT"><%=alerts[i].toString()%></td>
                      </tr>
                   	<%
                   		}
                   	%>
                      <tr>
                        <td width="*" class="SMALLTEXT" colspan="3">&nbsp;</td>
                      </tr>
                    </table>
                   </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
           
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
                  <tr>
                    <td width="35%">&nbsp;</td>
                    <td width="11%" align="center">&nbsp;</td>
                    <td width="7%" align="center">
                     &nbsp;</td>
                                          <td width="27%">&nbsp;</td>
                    <td width="20%">&nbsp;</td>
                  </tr>
                </table>
              
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
<script language="JavaScript">

		    // create calendar object(s) just after form tag closed
			// note: you can have as many calendar objects as you need for your application
			
			var datestart = new calendar2("<%=BASE_DIRECTORY%>",document.access.startDate,document.all.startDateHtml,<%="/^\\-?\\d+(\\"+millisecondsSeperator+"\\d+)*$/"%>,"<%=millisecondsSeperator%>");
			datestart.year_scroll = true;
			datestart.time_comp = true;
			var dateend = new calendar2("<%=BASE_DIRECTORY%>",document.access.endDate,document.all.endDateHtml,<%="/^\\-?\\d+(\\"+millisecondsSeperator+"\\d+)*$/"%>,"<%=millisecondsSeperator%>");
			
			dateend.year_scroll = true;
			dateend.time_comp = true;

			function openStart(){
                                if (document.access.startDate.value == ""){
				  datestart.popup("<%=transformDateToString(new Date())%>");
				  return;
				}
				datestart.popup();			
			}
			function openEnd(){
				 if (document.access.endDate.value == ""){
				  dateend.popup("<%=transformDateToString(new Date())%>");
				  return;
				}
				dateend.popup();				
			}

</script> 

</form>
</body>

</html>