<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>

<%@ page import="java.util.Enumeration"%>
<%
	SiteManagment mgmt = SiteManagment.getInstance();
 
  String baseDirectory = request.getParameter("baseDirectory");
  if (baseDirectory == null){
  	baseDirectory = "../../";
  }
  String baseDirectory2 = request.getParameter("baseDirectory2");
  if (baseDirectory2 == null){
  	baseDirectory2 = baseDirectory;
  }
  
  String treeName = request.getParameter("treeName");
  if (treeName == null || treeName.length() == 0){
  	treeName = "tree";
  }
  
  String mode = request.getParameter("mode");
  if (mode == null || mode.length() == 0){
  	mode = "trans";
  }
  
  String tranId = "";
  String tranProjectId = request.getParameter("TRAN_ID");
  if (tranProjectId == null || tranProjectId.length() == 0){
  	tranProjectId = "";
  }else {
  	int index = tranProjectId.indexOf("@");
  	if (index > 0){
  		tranId = tranProjectId.substring(index + 1);
  	}
  }
  
  
  String useTextBoxStr = request.getParameter("useTextBox");
  boolean useTextBox = useTextBoxStr == null || !useTextBoxStr.equals("false");

  String checkBoxesStr = request.getParameter("checkBoxes");
  boolean checkBoxes = checkBoxesStr != null && checkBoxesStr.equals("true");

  String closeTreeUponSelectStr = request.getParameter("closeTreeUponSelect");
  boolean closeTreeUponSelect = closeTreeUponSelectStr == null || !closeTreeUponSelectStr.equals("false");

  
  String checkEditPermissionsStr = request.getParameter("checkEditPermissions");
  boolean checkEditPermissions = checkEditPermissionsStr != null && checkEditPermissionsStr.equals("true");

  
  Enumeration paramNames = request.getParameterNames();
  StringBuffer sb = new StringBuffer();
  String pName, pValue;
  while (paramNames.hasMoreElements()){
  	pName = (String)paramNames.nextElement();
  	pValue = request.getParameter(pName);
  	if (sb.length() > 0){
  		sb.append("&");
  	}
  	sb.append(pName + "=" + pValue);
  }
  String params = sb.toString();
  
%>


<jsp:include page="../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
</jsp:include>


<script>
  var tranProjectId = "<%=tranProjectId%>";
	var tranId = "<%=tranId%>";
	var lastSelectedTranId = "TransactionParadigm-<%=tranId%>";	
    
	var transactionSelectionTreeLoaded = false;	
	function showTransactionTree(){
		hideAllGeneralAdminDiv();
		if (document.access.tranName && resetBgColor){
			resetBgColor(document.access.tranName,"DISABLED_TEXTBOX");
		}
		var url = "<%=baseDirectory%>logic/common/selectTransaction.jsp?<%=params%>";
		sendAjaxRequest(url,function(req){
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result){
				alert("Could not get transactions list!.");
				return;			
			}
			showGeneralAdminDiv("SelectTransaction");
			if (!transactionSelectionTreeLoaded){
				updateGeneralAdminDiv("SelectTransaction",result);
				createTree("treeboxbox_treeSelectTransaction");
				transactionSelectionTreeLoaded = true;
			}
		});
	}


	function _showTransactionTree(){
		document.getElementById("showLink").style.display = "none";
		document.getElementById("hideLink").style.display = "";
		document.getElementById("treeDiv").style.display = "";
	}

	function hideTransactionTree(){
		document.getElementById("showLink").style.display = "";
		document.getElementById("hideLink").style.display = "none";
		document.getElementById("treeDiv").style.display = "none";
	}
	
	function closeTransactionSelectionDiv(){
		showHideGeneralAdminDiv("SelectTransaction");
	}
	
	
	function updateTransaction(tree,tranTagName){
		var list = <%=treeName%>.getAllChecked();
		var arr = list.split(",");
	  var transStr = "";
		for (var i=0; i<arr.length; i++){
			var s = arr[i];
			var ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				var type = s.substring(0,ind);
				var id = s.substring(ind+1,s.length);
				if (transStr != ""){
					transStr += ",";
				}
				transStr += id;				
			}
		}
		eval("document.access."+tranTagName).value = transStr;
	}
	
	
	function updateTransactionName(id,tranName){
		var pm = document.getElementById("tranName");
		if (pm){		
			if (id.indexOf("TransactionParadigm-") != 0){			
				return;
			}
			tranId = id.substring(20);			
			var n = "";
			if (<%=treeName%>.isItemChecked(id)){
				n = <%=treeName%>.getItemText(id);
			}
			<% if (useTextBox){%>
				pm.value = n;
			<%}else{%>
				pm.innerHTML = '&nbsp;<b>' + n + '</b>';
			<%}%>
		lastSelectedTransactionId = "TransactionParadigm-"+tranId;
		}
		<%if (closeTreeUponSelect){%>		
		closeTransactionSelectionDiv();
		document.getElementById("tranErrorMsg").style.display ="none";
		document.getElementById("tranErrorMsg").innerHTML = "";	
		updateSourceForTransactionChange(id,n);
		<%}%>	
	}
	
	
	function updateSourceForTransactionChange(id,name){
	
	}
	
	var <%=treeName%>;
	var treeUrl;
	var cbmode;
	function createTree(treeDivId){
	  var tranParam = "?mode=<%=mode%>";	 
	  <%if (checkEditPermissions){%>
	  tranParam = tranParam + "&checkEditPermissions=true";
	  <%}%>
	  if (tranId && tranId != ""){
	  	lastSelectedTranId = "TransactionParadigm-" + tranId;
	    tranParam = tranParam + "&TRAN_ID=" + tranProjectId;	    
	  }
		  
		<%=treeName%>=new dhtmlXTreeObject(treeDivId,"100%","100%","0");
		<%=treeName%>.enableTreeLines(false);
		<%=treeName%>.setOnLoadingStart(startLoading);
		<%=treeName%>.setOnLoadingEnd(endLoading);
		<%=treeName%>.setImagePath("<%=baseDirectory%>");
		<%=treeName%>.setIconSize(13,13);		
		<%=treeName%>.handleMark = true;
		<%=treeName%>.checkUponSelect = true;
		<%=treeName%>.setOnClickHandler(updateTransactionName);
		<%if (checkBoxes){%>
		cbmode = true;
		<%=treeName%>.enableCheckBoxes(1);
		<%}else{%>
		cbmode = false;
		<%=treeName%>.enableRadioButtons(true);
		<%=treeName%>.enableSingleRadioMode(true);
		<%}%>
		<%
		String autoLoadUrl = baseDirectory + "logic/common/transactionTreeXML.jsp?mode="+mode;
		if (checkEditPermissions){
			autoLoadUrl += "&checkEditPermissions=true";
		}
		%>
		<%=treeName%>.setXMLAutoLoading("<%=autoLoadUrl%>");
		treeUrl = "<%=baseDirectory%>logic/common/transactionTreeXML.jsp" + (tranParam ? tranParam : "");		
		<%=treeName%>.loadXML(treeUrl);
	}
	
	function updateTree(tranId,tranName,noReload){
		if (<%=treeName%> && !noReload){
			for (i=<%=treeName%>.htmlNode.childNodes.length-1; i>=0; i--){
				<%=treeName%>.deleteItem(<%=treeName%>.htmlNode.childNodes[i].id);
			}
			var url = treeUrl;
			if (tranId && tranId.length > 0){
				url += "&TRAN_ID=" + tranId;
			}			
			<%=treeName%>.loadXML(url,updateTreeCallBack(tranName));
		}else{
			var pm = document.getElementById("tranName");
			if (pm){
			<% if (useTextBox){%>
				pm.value = tranName;
			<%}else{%>
				pm.innerHTML = '&nbsp;<b>' + tranName + '</b>';
			<%}%>
			}			
			lastSelectedTranId = "TransactionParadigm-" + tranId;
			updateSourceForTransactionChange(lastSelectedTranId,tranName);
			//tranSelectionTreeLoaded = false;
			if (<%=treeName%>){
				for (i=0; i<<%=treeName%>.htmlNode.childNodes.length; i++){
					<%=treeName%>.deleteItem(<%=treeName%>.htmlNode.childNodes[i].id);
				}
			}
			createTree("treeboxbox_treeSelectTransaction");
			tranSelectionTreeLoaded = true;
		}
	}
	
	function updateTreeCallBack(tranName){
		var id = "";
		if (tranId && tranId.length > 0){
			id = "<%=XpoLogObjectTypes.TRANSACTION_TYPE%>-" + tranId;
			
		}
		//alert(id);
		updateTransactionName(id,tranName);
		refreshMenus();
	}
	
	
	
	//override tree functions
	var lastSelectedTranNodeId = "TransactionParadigm-<%=tranId%>";
	dhtmlXTreeObject.prototype.onCheckBoxClick=function(e,htmlObject,mode){
		var obj=this.parentObject;
		if(htmlObject){
			obj=htmlObject;
		}
		var that=obj.treeNod;
		
		if(that.markUponCheck){
			that._selectItem(obj);
		}
		if(obj.dscheck){
			return true;
		}
		
		if(that.tscheck){
			if(obj.checkstate==1){
				that._setSubChecked(false,obj);
			}else{
				that._setSubChecked(true,obj);
			}
		}else{
			if (!cbmode && lastSelectedTranNodeId == obj.id){		
				return;
			}
			if(obj.checkstate==1){
				that._setCheck(obj,false);
			}else{
				that._setCheck(obj,true);
			}
		}
		
		that._correctCheckStates(obj.parentObject);
		if(that.handleMark && !mode){
			that.onRowSelect(e,this,false,true);
		}		
		
		if (obj.id && obj.id.indexOf("TransactionParadigm-") != -1){
			lastSelectedTranNodeId = obj.id;
		}
		if(that.checkFuncHandler){
			return(that.checkFuncHandler(obj.id,obj.checkstate));
		}
		else return true;
	};
	
</script>