<%@page import="xpolog.eye.admin.helpers.DashboardAdminHelper"%>
<%@page import="xpolog.logic.transaction.data.TransactionParadigm"%>
<%@page import="xpolog.logic.brain.BrainConfigurationRepository"%>
<%@page import="xpolog.logic.filters.TransactionFilter"%>
<%@page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.computation.impl.*" %>
<%@ page import="xpolog.logic.filters.SessionFilterManager"%>

<%@ page import="java.util.*" %>

<%!

	public DashboardAdminHelper getTransactionDashboardAdminHelper(){
		return new DashboardAdminHelper(){
			public void updateFilters(String [] transFilters, FilterComputationDefUnit defUnit, HashMap defUnitsMap){

				SessionFilterManager sdfmgr = null;
				FilterCollection fc = null;
				String v,tranId,filterId;
				int index;	   			
				boolean newSystemFilter = false;
				if (transFilters != null){
					for (int i = 0; i < transFilters.length; i++){
						v = transFilters[i];	    	 	
						index = v.lastIndexOf(",");
						if (index == -1 || index == v.length()-1){
							continue;
						}
						tranId = v.substring(0,index);
						filterId = v.substring(index+1);
						if (filterId == null || filterId.length() == 0 || 
								filterId.equals(TransactionFilter.SYSTEM_TIME_ERROR_FILTER_NAME) || 
								filterId.equals(TransactionFilter.SYSTEM_FLOW_ERROR_FILTER_NAME) || 
								filterId.equals(TransactionFilter.SYSTEM_DATA_ERROR_FILTER_NAME)){
							newSystemFilter = true;
						}

						if (tranId != null && tranId.length() > 0){
							sdfmgr = new SessionFilterManager(tranId);
							if (!newSystemFilter){
								fc = sdfmgr.getFilterCollectionById(filterId);
							}else{
								int type = 0;
								if (filterId.equals(TransactionFilter.SYSTEM_TIME_ERROR_FILTER_NAME)){
									type = SessionFilterManager.TIME;
								}else if (filterId.equals(TransactionFilter.SYSTEM_FLOW_ERROR_FILTER_NAME)){
									type = SessionFilterManager.FLOW;
								}else if (filterId.equals(TransactionFilter.SYSTEM_DATA_ERROR_FILTER_NAME)){
									type = SessionFilterManager.DATA;
								}
								fc = sdfmgr.createStatusErrorFilterCollection(type);
								fc.setId("");
							}
			    		if(fc != null) {
			    			fc.setDefUnits(defUnitsMap);
			    		}
						}
						String fcId = fc.getId();
						if (fcId == null || fcId.length() == 0){
							sdfmgr.saveDataFilter(fc);	
						}else{
							sdfmgr.updateDataFilter(fc);	
						}
						if (newSystemFilter){
						  BrainConfigurationRepository rep = BrainConfigurationRepository.getRepository();
						  TransactionParadigm t = rep.getTransactionParadigmById(tranId);
						  if (t != null){
								HashMap map = (HashMap)t.getFiltersForRoutinesMap();
								HashSet set = (HashSet)map.get("-1");
								if (set == null){
									set = new HashSet();
									map.put("-1",set);
								}
								set.add(fc.getId());
								rep.getTranConfigBuilder().updateTransactionFilters(t);
							}
						}
						
					}
				}
			}
		};
	}
  
%>