<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="java.util.*"%>
<%@ page import="javax.servlet.http.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%

  SiteManagment mgmt = SiteManagment.getInstance();
  Module root = mgmt.getModuleFromId("rootModule");
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);

  List list = root.getModuleMembers(user);
  ModuleMember[] memarr = new ModuleMember[list.size()];
  list.toArray(memarr);

  boolean valid = SiteManagment.getInstance().getXpologManagment().isValidToBeActive();
  boolean isDemo = XpologLicenseManager.getInstance().isDemo();
  int daynum = XpologLicenseManager.getInstance().getDaysLeft();
  boolean allowed = false;
  boolean perm = XpologLicenseManager.getInstance().isPermanentLicense();

  boolean secureActive = false;
  String userMessage = "";
  String activeState = "inactive";
  if(user != null){
    secureActive = true;
    userMessage = "Hello "+user.getUser().getDisplayName();
    activeState = "active";
  }

  Properties prop = Configuration.getInstance().getUIData();
  String userImg = prop.getProperty("gate.users.icon.image");
  String logoImg = prop.getProperty("gate.logo.image");
  String lockImg = prop.getProperty("gate.security.secure.image");
  String unlockImg = prop.getProperty("gate.security.unsecure.image");
  DashBoardViewModel model = new DashBoardViewModel(null);
  //String barImage =  model.createTransactionOnlineBarImage();
  String online = model.getOnlineTransaction();
  String errorDivImage = model.createTransactionErrorPieImage();
  String tranDivImage = model.createTransactionDiveristPieImage();
  String slaMeterImage = model.createTransactionSLAPieImage();
  String trantren = model.createTransactionTrenChartImage();
  String slatren = model.createTransactionSLAChartImage();
  String tranSlatren = model.createPerTransactionSLATrendImage(); 
%>

<HTML>
<HEAD>

<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link rel="stylesheet" type="text/css" href="/logeye/css/mainproduct.css" />

<script language="javaScript">
	function updateFullPath(fullPath) {
		document.quickLog.LOG_FULL_PATH.value = fullPath.value;
	}
	 
	function go() {
		document.quickLog.submit();
	}
</script> 

</HEAD>

<script LANGUAGE="JavaScript1.2" src="/logeye/scripts/help/help.js"></script>
<BODY BGCOLOR="#FFFFFF">
<jsp:include page="/logic/tabs.jsp" />
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%" valign="top" height="100%">
      <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
        <tr>
          <td valign="top" height="100%">
          <table border="0" cellpadding="0" cellspacing="0"  width="100%">
            <tr>
              <td>
              <table border="0" cellpadding="0" cellspacing="0"  width="100%" style="border-collapse: collapse" bordercolor="#111111">
                <tr>
                  <td height="100%" valign="top" bgcolor="#C0C0C0" bordercolor="#875546" style="border: 1 solid #875546">
                  <table border="0" cellspacing="0" width="100%"  style="border-collapse: collapse" bordercolor="#111111">
                    <tr>
                      <td><span class="HEADER">System Dash Board - currently (<%=online%>) Transactoin Online</span></td>
                    </tr>

                    <tr>
                      <td><span class='REGULARTEXT'></span></td>
                    </tr>
                    <tr>
                      <td>
                        <table border="0" width="100%" cellspacing="1">
                          <tr>
                            <td width="33%" align="center">
                              <p align="center"><img border="0" src="/logeye/<%=trantren%>" width="338" height="306"></td>
                            <td width="33%" align="center"><img border="0" src="/logeye/<%=slaMeterImage%>" width="338" height="306"></td>
                            <td width="34%" align="center"><img border="0" src="/logeye/<%=slatren%>" width="338" height="306"></td>
                          </tr>
                          <tr>
                            <td colspan="3" width="100%" align="center"><span class='REGULARTEXT'><hr></span></td>
                          </tr>
                          <tr>
                            <td width="33%" align="center"><img border="0" src="/logeye/<%=tranSlatren%>" width="338" height="306"></td>
                            <td width="33%" align="center"><img border="0" src="/logeye/<%=errorDivImage%>" width="338" height="306"></td>
                            <td width="34%" align="center"><img border="0" src="/logeye/<%=tranDivImage%>" width="338" height="306"></td>
                          </tr>
                        </table>
                      </td>
                    </tr>
                  </table>
                  </td>
                </tr>

                <tr>
                  <td class="REGULARTEXT" width="49%" height="100%" valign="top">
                  &nbsp;
                  </td>
                </tr>

                <tr>
                  <td width="49%" height="100%" valign="top">
                  <jsp:include page="/logic/pagerefresh.jsp" />
                  </td>
                </tr>

                </table>
              </td>
            </tr>
          </table>
          </td>
        </tr>
        </table>
    </td>
  </tr>
  <tr>
          <td valign="top">
          <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
            <tr>
              <td width="100%" class="TOPLEFTRIGHTBORDER">
                <p align="center">&nbsp;<span class="REGULARTEXT">Copyright  2004 XpoLog Ltd. All rights reserved</span></p>
              </td>
            </tr>
            </table>
          </td>
  </tr>
</table>
</BODY>
</HTML>