<%@page import="xpolog.eye.util.XpologUtil"%>
<%@page import="java.util.Date"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.logic.filters.StatusTransactionFilter"%>
<%@ page import="xpolog.logic.filters.DataFilterManager"%>
<%@ page import="xpolog.logic.filters.SessionFilterManager"%>
<%@ page import="xpolog.config.Configuration"%>

<%@ page import="java.text.SimpleDateFormat"%>
<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";

	String dateFormat = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
	String millisecondsSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator",".");
	String dateFormatMS = dateFormat+millisecondsSeperator+"SSS";
	
	public String transformDateToString(Date d,long timeDiff){
	  if(d == null){
	    return null;
	  }
	  if (timeDiff != 0){
	   long time = d.getTime();
		 d = ((Date)d.clone());
		 d.setTime(time + timeDiff); 
	  }
	  String format = "";
	  if (d.getTime() % 1000 == 0){
	    format = dateFormat;
	  } else {
	    format = dateFormatMS;
	  }
	  String str = new SimpleDateFormat(format).format(d);
	  return str;
	}

	public String updateTransactionFilter(HttpServletRequest request, DateFilter dateFilter){
		String filterId = request.getParameter("filterId");
		String tranId = request.getParameter("tranId");
		if (tranId != null && tranId.length() > 0 && filterId != null && filterId.length() > 0){
			SessionFilterManager sdfmgr = (SessionFilterManager)request.getSession().getAttribute("sessionDataFilterManager");
			if (sdfmgr == null){
				sdfmgr = new SessionFilterManager(tranId);
				request.getSession().setAttribute("sessionDataFilterManager",sdfmgr);
			}
			FilterCollection fc = sdfmgr.getFilterCollectionById(filterId);
			StringBuffer sb = new StringBuffer();
			if (fc != null){
				if (DataFilterManager.getInstance().isSystemFilter(fc)){
					xpolog.eye.data.filters.Filter filter = (xpolog.eye.data.filters.Filter)fc.getFilters().get(0);
					if (filter instanceof StatusTransactionFilter){
						StatusTransactionFilter statusFilter = (StatusTransactionFilter)filter;
						StatusTransactionFilter.StatusInfo[] statuses = statusFilter.getStatuses();
						String key = null;
						String type = null;
						for (int i=0; i<statuses.length; i++){
							if (i > 0){
								sb.append("&");
							}
							key = statuses[i].getInfo();
							int index = key.indexOf("_");
							if (index > 0){
								type = key.substring(0,index);
								type = "status_"+type;
							}
							sb.append(type+"=");
							sb.append(key.substring(index+1));
						}
					}
				}else{
					sb.append("filter_collection_id="+filterId);
				}
			}
			if (dateFilter != null){
				Date minDate = dateFilter.getMinDate();
				String minDateStr = transformDateToString(minDate,0);
				minDateStr = XpologUtil.replaceAll(minDateStr,"/","%2f");
				minDateStr = XpologUtil.replaceAll(minDateStr,"\\","%5c");
				Date maxDate = dateFilter.getMaxDate();
				String maxDateStr = transformDateToString(maxDate,0);
				maxDateStr = XpologUtil.replaceAll(maxDateStr,"/","%2f");
				maxDateStr = XpologUtil.replaceAll(maxDateStr,"\\","%5c");
				sb.append("&Dates=true&DateMinFilterActive=true&DateMaxFilterActive=true&DateMinimum="+minDateStr+"&DateMaximum="+maxDateStr);
			}
			return sb.toString();
		}else{
			return null;
		}
	}
%>

<%@ include file="../../../tools/sandf/dateFilterAction.jsp"%>

<%
	DateFilter dateFilter = null;
	//Date issue	
	dateFilter = new DateFilter();  
	RecordMask mask = new RecordMask();
	DateMask dateMask = new DateMask("MM/dd/yyyy HH:mm:ss");
	MaskColumn[] cols = {dateMask};
	mask.setColumns(cols);	
	try {
		dateFilter = createDateFilter(request,response,mask);	
	}catch (Exception e){
	}	
	if(dateFilter != null){
		dateFilter.updateMinTime();				
	}

	String filterLink = updateTransactionFilter(request,dateFilter);
	if (filterLink != null){
		filterLink = "&"+filterLink;
	}else{
		filterLink = "";
	}

	String tranId = request.getParameter("tranId");
	response.sendRedirect(BASE_DIRECTORY+"logic/online/TransView.jsp?isFirst=true&tran_id="+tranId+"&resetQuery=true&zoomOutUrl=dashboard/sysHealth/dashboard.jsp"+filterLink);
%>
