<%@ page language="java"%>

<%@ page import="java.text.*"%>
<%@ page import="java.util.*"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="xpolog.logic.detect.*"%>
<%@ page import="xpolog.logic.security.LogicPermissionConstants"%>

<%!

	static final String BASE_DIRECTORY = "../../";

	String dateFormat = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat", "MM/dd/yyyy HH:mm:ss");
	String msSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator", ".");
	String dateFormatMS = dateFormat + msSeperator + "SSS";
	String timeFormat = "HH:mm:ss";

	public String transformDateToString(Date d, long timeDiff) {
		if (d == null) {
			return null;
		}
		if (timeDiff != 0) {
			long time = d.getTime();
			d = ((Date) d.clone());
			d.setTime(time + timeDiff);
		}
		//01/31/2003 01:42:34
		/*String format = "";
		if (d.getTime() % 1000 == 0) {
			format = dateFormat;
		} else {
			format = dateFormatMS;
		}*/
		String format = dateFormat;
		String str = new SimpleDateFormat(format).format(d);
		return str;
	}

%>
<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,LogicPermissionConstants.AdministrationPermissions.TRANSACTION_DETECTION_PERMISSION,true)){
		return;
	}
	SiteManagment mgmt = SiteManagment.getInstance();
	SiteAdministrator admin = SiteManagment.getAdminInstance();
	UserContext userContext = UserEnvironment.getUserContext(request);;
	UserSecurity user = manager.getUserSecurity(request);
	
	TransactionDetectionManager detectionManager = TransactionDetectionManager.getInstance();
	ArrayList runningDetectionProcesses = detectionManager.getRunningTransactionDetectionProcesses();
	ArrayList completedDetectionProcesses = detectionManager.getCompletedTransactionDetectionProcesses();
	TransactionDetectionProcess process = null;
	
	String previousProcessId = (String)session.getAttribute(TransactionDetectionManager.CURRENT_PROCESS);
	if(previousProcessId != null && previousProcessId.length() > 0) {
		TransactionDetectionProcess previousProcess = detectionManager.getTransactionDetectionProcessById(previousProcessId);
		if(previousProcess != null) {
			previousProcess.dispose();
		}
		session.setAttribute(TransactionDetectionManager.CURRENT_PROCESS, null);
	}
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us" charset="windows-1255">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/transactionDetection.css" />

<script src="<%=BASE_DIRECTORY%>scripts/tree/rightClickMenu.js"></script>
<jsp:include page="../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<script src="<%=BASE_DIRECTORY%>scripts/comps/divsTabs.js" type="text/javascript"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>logic/detection/detection.js"></script>

<script>
  baseDirectory = "<%=BASE_DIRECTORY%>";
</script>

</head>
<!-- American format mm/dd/yyyy -->
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/calendar/calendar2.js"></script>
<!-- Date only with year scrolling -->



<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" action="diagnosticsAction.jsp">
<input type="hidden" name="TimeUnit"> <input type="hidden" name="TimeText">
<input type="hidden" name="TimeOpType"> <input type="hidden" name="SchedulerName" value="schedName">
<input type="hidden" name="SchedulerDescription" value="schedDesc">
<input type="hidden" name="SchedulerId" value="schedId">
<input type="hidden" name="suffix" value="session">
<input type="hidden" name="doSave" value="false">
<input type="hidden" name="mods">
<input type="hidden" name="logs">
<input type="hidden" name="Application">

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>
		<td width="100%" height="100%" valign="top">
			<table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
				<tr valign="top" height="20">
					<td width="100%">
					<table border="0" cellspacing="0" style="border-collapse: collapse" width="100%">
						<tr bgcolor="#6E6D6C">
							<td width="3%"></td>
							<td><span class="HEADER">Transaction Detection</span></td>
						</tr>
					</table>
					</td>
				</tr>
				<tr valign="top" height="15">
					<td width="100%">
						<table border="0" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%">
							<tr bgcolor="#000000">
								<td>&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr valign="top" height="15">
					<td width="100%">
						<table border="0" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%">
							<tr bgcolor="#B1B6CC">
								<td width="3" style="font-size:2">&nbsp;</td>
								<td width="*" style="font-size:2">&nbsp;</td>
								<td width="150" align="center"><a href="newDetectionProcess.jsp" class="HEADER_ACTION_LINK">New Process</a></td>
							</tr>
						</table>
					</td>
				</tr>
				<tr height="10"><td style="font-size:2">&nbsp;</td></tr>
				<tr bgcolor="#797B87" height="25">
					<td>
						<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr>
								<td width="250" align="left" style="padding-left: 15" class="RESULT_HEADER_TEXT">Running Processes</td>
								<td width="2" bgcolor="#C3C4C9"></td>
								<td width="220" align="left" style="padding-left: 15" class="RESULT_HEADER_TEXT">Start Time</td>
								<td width="2" bgcolor="#C3C4C9"></td>
								<td width="220" align="left" style="padding-left: 15" class="RESULT_HEADER_TEXT">Status</td>
								<td width="2" bgcolor="#C3C4C9"></td>
								<td style="font-size:2">&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
				<%
				if(runningDetectionProcesses.size() == 0) {
				%>
				<tr height="10">
					<td>
						<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr height="5"><td style="font-size:2">&nbsp;</td></tr>
							<tr>
								<td style="padding-left:15" colspan=6 class="REGULARTEXT">No detection processes are currently running</td>
							</tr>
						</table>
					</td>
				</tr>
				<%
				}else {
					for(int i = 0; i < runningDetectionProcesses.size(); i++) {
						process = (TransactionDetectionProcess)runningDetectionProcesses.get(i);
						String processName = process.getProcessName();
						if(processName == null || processName.length() == 0) {
							processName = "N/A";
						}
				%>
				<tr height="10" style="padding-top:3">
					<td>
						<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
								<td width="250" style="padding-left:15" class="REGULARTEXT"><%=processName %></td>
								<td width="220" style="padding-left:15" class="REGULARTEXT"><%=transformDateToString(new java.util.Date(process.getProcessStartTime()), 0) %></td>
								<td width="220" style="padding-left:15" class="REGULARTEXT" id="runningProcess<%=process.getProcessId() %>Td"><%=process.getCurrentStatus() %></td>
								<td style="font-size:2">&nbsp;</td>
								<td width="50"><a href="<%=BASE_DIRECTORY %>logic/detection/stopDetectionProcess.jsp?processId=<%=process.getProcessId() %>" class="REPORT_HEADER_LINK">stop</a></td>
								<td width="50"><a href="<%=BASE_DIRECTORY %>logic/detection/deleteDetectionProcess.jsp?processId=<%=process.getProcessId() %>" class="REPORT_HEADER_LINK">delete</a></td>
							</tr>
						</table>
					</td>
				</tr>
				<script>
					runningProcesses[runningProcesses.length] = '<%=process.getProcessId() %>';
				</script>
				<%
					}
				%>
				<script>
					updateProcessesProgress();
				</script>
				<%
				}
				%>
				<tr height="10"><td style="font-size:2">&nbsp;</td></tr>
				<tr bgcolor="#797B87" height="25">
					<td>
						<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr>
								<td width="250" align="left" style="padding-left: 15" class="RESULT_HEADER_TEXT">Completed Processes</td>
								<td width="2" bgcolor="#C3C4C9"></td>
								<td width="220" align="left" style="padding-left: 15" class="RESULT_HEADER_TEXT">Start Time</td>
								<td width="2" bgcolor="#C3C4C9"></td>
								<td width="220" align="left" style="padding-left: 15" class="RESULT_HEADER_TEXT">End Time</td>
								<td width="2" bgcolor="#C3C4C9"></td>
								<td style="font-size:2">&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
				<%
				if(completedDetectionProcesses.size() == 0) {
				%>
				<tr height="10">
					<td>
						<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr height="5"><td style="font-size:2">&nbsp;</td></tr>
							<tr>
								<td style="padding-left:15" colspan=6 class="REGULARTEXT">No completed detection processes exist</td>
							</tr>
						</table>
					</td>
				</tr>
				<%
				}else {
					for(int i = 0; i < completedDetectionProcesses.size(); i++) {
						process = (TransactionDetectionProcess)completedDetectionProcesses.get(i);
						String processName = process.getProcessName();
						if(processName == null || processName.length() == 0) {
							processName = "N/A";
						}
				%>
				<tr height="10" style="padding-top:3">
					<td>
						<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
								<td width="250" style="padding-left:15"><a href="<%=BASE_DIRECTORY %>logic/detection/showDetectionProcess.jsp?processId=<%=process.getProcessId() %>&loadProcess=true" class="REPORT_HEADER_LINK"><%=processName %></a></td>
								<td width="220" style="padding-left:15" class="REGULARTEXT"><%=transformDateToString(new java.util.Date(process.getProcessStartTime()), 0) %></td>
								<td width="220" style="padding-left:15" class="REGULARTEXT"><%=process.getProcessEndTime() == 0 ? "N/A" : transformDateToString(new java.util.Date(process.getProcessEndTime()), 0) %></td>
								<td style="font-size:2">&nbsp;</td>
								<td width="50"><a href="<%=BASE_DIRECTORY %>logic/detection/showDetectionProcess.jsp?processId=<%=process.getProcessId() %>&loadProcess=true" class="REPORT_HEADER_LINK">view</a></td>
								<td width="50"><a href="<%=BASE_DIRECTORY %>logic/detection/deleteDetectionProcess.jsp?processId=<%=process.getProcessId() %>" class="REPORT_HEADER_LINK">delete</a></td>
							</tr>
						</table>
					</td>
				</tr>
				<%
					}
				}
				%>
				<tr>
					<td style="font-size:2">&nbsp;</td>
				</tr>
			</table>
		</td>
	</tr>
</table>
</form>
</body>