<%@ page language="java"%>

<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>

<%@ page import="xpolog.logic.ConfigMgr"%>
<%@ page import="xpolog.logic.detect.TransactionDetectionHelper"%>
<%@ page import="xpolog.logic.detect.TransactionDetectionManager"%>
<%@ page import="xpolog.logic.detect.TransactionDetectionProcess"%>
<%@ page import="xpolog.logic.detect.TransactionDetectionResult"%>
<%@ page import="xpolog.logic.detect.TransactionDetectionResultQuery"%>
<%@ page import="xpolog.logic.detect.TransactionDetectionResultQueryResult"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmBuilder"%>
<%@ page import="xpolog.logic.ui.ctrl.CtrlMgr"%>
<%@ page import="xpolog.logic.ui.ctrl.DataSession"%>
<%@ page import="xpolog.logic.ui.ctrl.Workspace"%>

<%!static final String BASE_DIRECTORY = "../../";%>

<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	
  final String RESULT_ID = "resultId";
  String resultId = request.getParameter(RESULT_ID);
  if(resultId != null && resultId.length() == 0) {
  	resultId = null;
  }
  
  final String ACTION_TYPE = "actionType";
  String actionType = request.getParameter(ACTION_TYPE);
  
  if(actionType.equals("show")) {
  	final String RESULT_INDEX = "resultIndex";
    String resultIndexStr = request.getParameter(RESULT_INDEX);
    int resultIndex = -1;
    try {
    	resultIndex = Integer.parseInt(resultIndexStr);
    }catch(Exception e) {
    	resultIndex = -1;
    }
    
    final String PERMUTATION_ID = "permutationId";
    String permutationId = request.getParameter(PERMUTATION_ID);
    if(permutationId != null && permutationId.length() == 0) {
    	permutationId = null;
    }
    final String PERMUTATION_INDEX = "permutationIndex";
    String permutationIndexStr = request.getParameter(PERMUTATION_INDEX);
    int permutationIndex = -1;
    try {
    	permutationIndex = Integer.parseInt(permutationIndexStr);
    }catch(Exception e) {
    	permutationIndex = -1;
    }
    
    final String MIN_TIME_DISTANCE_THRESHOLD = "minTimeDistanceThreshold";
    String minTimeDistanceThresholdStr = request.getParameter(MIN_TIME_DISTANCE_THRESHOLD);
    int minTimeDistanceThreshold = -1;
    try {
    	minTimeDistanceThreshold = Integer.parseInt(minTimeDistanceThresholdStr);
    }catch(Exception e) {
    	minTimeDistanceThreshold = -1;
    }
    final String MAX_TIME_DISTANCE_THRESHOLD = "maxTimeDistanceThreshold";
    String maxTimeDistanceThresholdStr = request.getParameter(MAX_TIME_DISTANCE_THRESHOLD);
    int maxTimeDistanceThreshold = -1;
    try {
    	maxTimeDistanceThreshold = Integer.parseInt(maxTimeDistanceThresholdStr);
    }catch(Exception e) {
    	maxTimeDistanceThreshold = -1;
    }
    
    final String MIN_TIME_THRESHOLD = "minTimeThreshold";
    String minTimeThresholdStr = request.getParameter(MIN_TIME_THRESHOLD);
    int minTimeThreshold = -1;
    try {
    	minTimeThreshold = Integer.parseInt(minTimeThresholdStr);
    }catch(Exception e) {
    	minTimeThreshold = -1;
    }
    final String MAX_TIME_THRESHOLD = "maxTimeThreshold";
    String maxTimeThresholdStr = request.getParameter(MAX_TIME_THRESHOLD);
    int maxTimeThreshold = -1;
    try {
    	maxTimeThreshold = Integer.parseInt(maxTimeThresholdStr);
    }catch(Exception e) {
    	maxTimeThreshold = -1;
    }
    
    final String ID_FILTER = "idFilter";
    String idFilter = request.getParameter(ID_FILTER);
    if(idFilter != null && idFilter.length() == 0) {
    	idFilter = null;
    }
    
    final String MIN_PERCENTAGE_THRESHOLD = "minPercentageThreshold";
    String minPercentageThresholdStr = request.getParameter(MIN_PERCENTAGE_THRESHOLD);
    int minPercentageThreshold = -1;
    try {
    	minPercentageThreshold = Integer.parseInt(minPercentageThresholdStr);
    }catch(Exception e) {
    	minPercentageThreshold = -1;
    }
    final String MAX_PERCENTAGE_THRESHOLD = "maxPercentageThreshold";
    String maxPercentageThresholdStr = request.getParameter(MAX_PERCENTAGE_THRESHOLD);
    int maxPercentageThreshold = -1;
    try {
    	maxPercentageThreshold = Integer.parseInt(maxPercentageThresholdStr);
    }catch(Exception e) {
    	maxPercentageThreshold = -1;
    }
    
    
    
    final String PAGING_ACTION_TYPE = "pagingActionType";
    String pagingActionType = request.getParameter(PAGING_ACTION_TYPE);
    final String PAGE_NUMBER = "pageNumber";
    String pageNumberStr = request.getParameter(PAGE_NUMBER);
    int pageNumber = -1;
    try {
    	pageNumber = Integer.parseInt(pageNumberStr);
    }catch(Exception e) {
    	pageNumber = -1;
    }
    
    TransactionDetectionResultQuery resultQuery = null;
    TransactionDetectionResultQueryResult queryResult = null;
    if(pagingActionType == null || pagingActionType.equals("")) {
    	resultQuery = new TransactionDetectionResultQuery();
      resultQuery.setResultId(resultId);
      resultQuery.setResultIndex(resultIndex);
      resultQuery.setPermutationId(permutationId);
      resultQuery.setPermutationIndex(permutationIndex);
      resultQuery.setMinTimeDistanceThreshold(minTimeDistanceThreshold);
      resultQuery.setMaxTimeDistanceThreshold(maxTimeDistanceThreshold);
      resultQuery.setMinTimeThreshold(minTimeThreshold);
      resultQuery.setMaxTimeThreshold(maxTimeThreshold);
      resultQuery.setIdfilter(idFilter);
      resultQuery.setMinPercentageThreshold(minPercentageThreshold);
      resultQuery.setMaxPercentageThreshold(maxPercentageThreshold);
      
      session.setAttribute(TransactionDetectionResultQuery.RESULT_QUERY, resultQuery);
      
      String processId = (String)session.getAttribute(TransactionDetectionProcess.TRANSACTION_DETECTION_PROCESS_ID);
      TransactionDetectionManager detectionManager = TransactionDetectionManager.getInstance();
    	TransactionDetectionProcess process = detectionManager.getTransactionDetectionProcessById(processId);
    	if (process == null || process.getQuery() == null) {
    		response.sendRedirect("detectionGate.jsp");
    		return;
    	}
      queryResult = process.getQueryResult(resultQuery);
      
      if(resultQuery.getResultId() == null) {
    		queryResult.setCurrentView(TransactionDetectionResultQueryResult.RESULTS_VIEW);
    	}else if(resultQuery.getPermutationId() == null) {
    		queryResult.setCurrentView(TransactionDetectionResultQueryResult.PERMUTATIONS_VIEW);
    	}else {
    		queryResult.setCurrentView(TransactionDetectionResultQueryResult.INSTANCES_VIEW);
    	}
  		
    	session.setAttribute(TransactionDetectionResultQueryResult.QUERY_RESULT, queryResult);
    }else {
    	resultQuery = (TransactionDetectionResultQuery)session.getAttribute(TransactionDetectionResultQuery.RESULT_QUERY);
    	queryResult =  (TransactionDetectionResultQueryResult)session.getAttribute(TransactionDetectionResultQueryResult.QUERY_RESULT);
    	if(pageNumber == -1) {
    		if(pagingActionType.equals("prev")) {
    			pageNumber = queryResult.getCurrentPageNumber() - 1;
    		}else if(pagingActionType.equals("next")) {
    			pageNumber = queryResult.getCurrentPageNumber() + 1;
    		}
    	}
    	if(resultQuery.getResultId() == null) {
    		queryResult.setCurrentView(TransactionDetectionResultQueryResult.RESULTS_VIEW);
    		session.setAttribute("resultsPageNumber", Integer.toString(pageNumber));
    	}else if(resultQuery.getPermutationId() == null) {
    		queryResult.setCurrentView(TransactionDetectionResultQueryResult.PERMUTATIONS_VIEW);
    		session.setAttribute("permutationsPageNumber", Integer.toString(pageNumber));
    	}else {
    		queryResult.setCurrentView(TransactionDetectionResultQueryResult.INSTANCES_VIEW);
    		session.setAttribute("instancesPageNumber", Integer.toString(pageNumber));
    	}
    	queryResult.setCurrentPageNumber(pageNumber);
    }
    
    if(resultQuery.getResultId() == null) {
    	response.sendRedirect("detectionProcessResults.jsp?actionType=show");
    	return;
    }else if(resultQuery.getPermutationId() == null) {
    	response.sendRedirect("detectionProcessResult.jsp?actionType=show");
    	return;
    }else {
    	response.sendRedirect("detectionProcessResultInstances.jsp?actionType=show");
    	return;
    }
  }else if(actionType.equals("save")) {
  	final String EXECUTE = "execute";
    String execute = request.getParameter(EXECUTE);
    final String WORKSPACE_ID = "workspaceId";
    String workspaceId = request.getParameter(WORKSPACE_ID);
    final String WORKSPACE_NAME = "workspaceName";
    String workspaceName = request.getParameter(WORKSPACE_NAME);
    final String PROJECT_ID = "projectId";
    String projectId = request.getParameter(PROJECT_ID);
    final String PROJECT_NAME = "projectName";
    String projectName = request.getParameter(PROJECT_NAME);
    final String TRANSACTION_NAME = "transactionName";
    String transactionName = request.getParameter(TRANSACTION_NAME);
    
    TransactionDetectionManager detectionManager = TransactionDetectionManager.getInstance();
  	String processId = (String)session.getAttribute(TransactionDetectionProcess.TRANSACTION_DETECTION_PROCESS_ID);
    TransactionDetectionProcess process = detectionManager.getTransactionDetectionProcessById(processId);
		TransactionDetectionResult result = process.getResultByKey(resultId);
		UITransactionParadigmBuilder builder = null;
		
		if(result != null) {
			builder = TransactionDetectionHelper.saveResultAsTransaction(result, transactionName);
			if(builder != null) {
				String transactionId = builder.getTransactionParadigm().getId();
				
				if(execute.equals("true")) {
					CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
					if(workspaceName != null && workspaceName.length() > 0) {
						Workspace workspace = new Workspace();
						workspace.setName(workspaceName);
						workspace.setDescription("");
						
						ctrlMgr.saveWorkspace(workspace);
						workspaceId = workspace.getId();
						
						// audit
					  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
					     			userContext, AuditConstants.CHANGE, "add/edit worksapce", AuditConstants.TRANSACTION_DETECTION, "add/edit wrokspace " + workspace.getName());

					}
					
					if(projectName != null && projectName.length() > 0) {
						DataSession dataSession = new DataSession();
						dataSession.setName(projectName);
						dataSession.setDescription("");
						dataSession.setParentWorkspaceId(workspaceId);
						
						ctrlMgr.addDataSession(dataSession,workspaceId,userContext);
						projectId = dataSession.getId();
						
						// audit
						AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
				       			userContext, AuditConstants.CHANGE, "add/edit project", AuditConstants.TRANSACTION_DETECTION, "add/edit project " + dataSession.getName());
					}
					
					ctrlMgr.addTransactionToSessionParadigm(projectId,transactionId);
					
					FilterCollection fc = new FilterCollection();
					fc.addFilter(process.getQuery().getTimeFilter());
					session.setAttribute("sessionFilterCollection", fc);
					
					response.sendRedirect(BASE_DIRECTORY + "/logic/admin/session/sessionRuntimeAdmin.jsp?sessionId=" + projectId);
					return;
				}else {
					response.sendRedirect(BASE_DIRECTORY + "/logic/admin/transaction/addNewTransaction.jsp?ds_id=" + transactionId);
					return;
				}
			}
		}
		response.sendRedirect("detectionGate.jsp");			
		return;
  }
%>
