<%@ page language="java"%>

<%@ page import="java.text.SimpleDateFormat"%>

<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>

<%@ page import="xpolog.logic.detect.TransactionDetectionManager"%>
<%@ page import="xpolog.logic.detect.TransactionDetectionProcess"%>
<%@ page import="xpolog.logic.detect.TransactionDetectionResult"%>
<%@ page import="xpolog.logic.detect.TransactionDetectionResultQuery"%>
<%@ page import="xpolog.logic.detect.TransactionDetectionResultQueryResult"%>

<%!

	static final String BASE_DIRECTORY = "../../";
	
	String dateFormatStr = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat", "MM/dd/yyyy HH:mm:ss");
	SimpleDateFormat dateFormat = new SimpleDateFormat(dateFormatStr);
	
%>

<%
  final String PROCESS_ID = "processId";
  String processId = request.getParameter(PROCESS_ID);
  
  final String LOAD_PROCESS = "loadProcess";
  String loadProcessStr = request.getParameter(LOAD_PROCESS);
  boolean loadProcess = loadProcessStr != null && loadProcessStr.equals("true");
  
  TransactionDetectionManager detectionManager = TransactionDetectionManager.getInstance();
  TransactionDetectionProcess process = null;
  if(loadProcess) {
		process = detectionManager.loadProcessById(processId);
  }else {
  	process = detectionManager.getTransactionDetectionProcessById(processId);
  }
	if (process == null || process.getQuery() == null) {
		response.sendRedirect("detectionGate.jsp");
		return;
	}
	
	if(loadProcess) {
		String previousProcessId = (String)session.getAttribute(TransactionDetectionManager.CURRENT_PROCESS);
		if(previousProcessId != null && previousProcessId.length() > 0) {
			TransactionDetectionProcess previousProcess = detectionManager.getTransactionDetectionProcessById(previousProcessId);
			if(previousProcess != null && process != previousProcess) {
				previousProcess.dispose();
			}
		}
		session.setAttribute(TransactionDetectionManager.CURRENT_PROCESS, process.getProcessId());
	}
	
	if(process.isRunning()) {

	}else if(process.isFinished()) {
		UserContext userContext = UserEnvironment.getUserContext(request);
		//	audit
		AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
									userContext, AuditConstants.VIEW, "view detection results",
									AuditConstants.TRANSACTION_DETECTION, "view detection results of process " + process.getProcessId());
				
		// clean session parameters
		session.setAttribute(TransactionDetectionResult.CURRENT_RESULT, null);
		session.setAttribute("resultsPageNumber", null);
		session.setAttribute("permutationsPageNumber", null);
		session.setAttribute("instancesPageNumber", null);
		session.setAttribute(TransactionDetectionProcess.TRANSACTION_DETECTION_PROCESS_ID, process.getProcessId());
		
		TransactionDetectionResultQuery resultQuery = new TransactionDetectionResultQuery();
		session.setAttribute(TransactionDetectionResultQuery.RESULT_QUERY, resultQuery);
		
		TransactionDetectionResultQueryResult queryResult = process.getQueryResult(resultQuery);
		session.setAttribute(TransactionDetectionResultQueryResult.QUERY_RESULT, queryResult);
		
		process.getQuery().setDateFormat(dateFormat);
		
		response.sendRedirect(BASE_DIRECTORY + "logic/detection/detectionProcessResults.jsp?refreshSlide=true");
	}
%>
