<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.cloud.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="xpolog.logic.brain.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.config.image.*"%>

<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY = "../../";
%>
<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ENTERPRISE_PERMISSION,true)){
		return;
	}

	String ERROR_OBJ = "ERROR_OBJ";

	SiteManagment mgmt = SiteManagment.getInstance();
	UserContext userContext = UserEnvironment.getUserContext(request);
	MetaDataManager metaDataMgr = mgmt.getMetaDataMgr();

	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	Collection transactionsCol = BrainConfigurationRepository.getRepository().getTransactionsParadigms(userContext);
	TransactionParadigm[] transactions = (TransactionParadigm[]) transactionsCol.toArray(new TransactionParadigm[transactionsCol.size()]);

  HashSet metaDataTransactions = new HashSet();
  String[] transactionsIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,XpoLogObjectTypes.TRANSACTION_TYPE);
  
  if (transactionsIds != null){
	 	for (int i=0; i<transactionsIds.length; i++){
	 		metaDataTransactions.add(transactionsIds[i]);
	 	}
  }
%>

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";
</script>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="15%" height="28" colspan="3"><span class="HEADER">TxExpo Transactions</span></td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <%for(int i=0;i<transactions.length;++i) {
              	  String checked = "";
              	  TransactionParadigm tran = transactions[i];
	              	String desc = tran.getDescription() != null ? tran.getDescription() : "";
              	  if(metaDataTransactions.contains(tran.getId())) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }	
              %>
							<tr>
								<td colspan="3"><input type="checkbox" id="<%=XpoLogObjectTypes.TRANSACTION_TYPE%>,<%=tran.getId()%>" name="transactions" value="<%=XpoLogObjectTypes.TRANSACTION_TYPE%>,<%=tran.getId()%>" <%=checked%>><span class="REGULARTEXT"><%=tran.getName()%>&nbsp;<span class="SMALLTEXT"><%=desc%></span></span></td>
							</tr> 
              <%}%>
          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		