<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>

<%@ page import="xpolog.logic.common.*"%>
<%@ page import="xpolog.logic.atomic.data.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.transaction.status.*"%>
<%@ page import="xpolog.logic.routine.data.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.ui.util.*"%>
<%@ page import="xpolog.logic.brain.model.*"%> 
<%@ page import="xpolog.logic.brain.*"%> 
<%@ page import="xpolog.logic.filters.*"%> 
<%@ page import="xpolog.logic.ui.graph.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.ui.log.data.transactions.TransactionQuery" %>
<%@ page import="xpolog.logic.ui.site.*"%>
<%@ page import="xpolog.logic.sources.xplg.*"%>

<%@ page import="java.text.*"%>
<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%!
  public String transformDateToString(Date d){
    return xpolog.eye.site.SiteUtil.formatDefaultDate(d,true);
  }
%>

<%!
  public Transaction getTransactionFromId(Transaction[] trans, String transactionId){
  	if (trans == null){
  		return null;
  	}
  	for (int i=0; i<trans.length; i++){
  		if (trans[i].getId().equals(transactionId)){
  			return trans[i];
  		}
  	}
  	return null;
  }
%>


<%
	String ERROR_OBJ = "ERROR_OBJ";

  LogicEnvironment logicEnv = LogicEnvironment.getLogicEnvironment(request);

  TransResultBuilder tranResultBuilder = (TransResultBuilder)request.getSession().getAttribute("currentTransResultBuilder");  
  TransactionDetailsResult detailsResult = tranResultBuilder == null ? null : tranResultBuilder.getDetailsResult();
  
  if (detailsResult != null && detailsResult.isDoReset()){
  	detailsResult = null;
  }
  
  TransResultBuilder transResultBuilder = (TransResultBuilder)request.getSession().getAttribute("currentTransResultBuilder");
  TransactionQuery tranQuery = transResultBuilder == null ? null : transResultBuilder.getTranQuery();
	if (tranQuery == null){
	  ErrorModel ermod = new ErrorModel();
	  ermod.addError("An error occured. Please continue using the menu");
	  request.getSession().setAttribute(ERROR_OBJ,ermod);
	  response.sendRedirect("../../common/errorpage.jsp?cancelURL=logic/logicPortal.jsp&okURL=logic/logicPortal.jsp");
	  return;
	}
	
	 String tranId = request.getParameter("runtime_tran_id");
	  if(tranId == null){
	  	 tranId = "";
	  }
	  
	String paradigmId = tranQuery.getParadigmId();
  
  List messages = detailsResult == null ? null : detailsResult.getMessages();
  String heightStr = request.getParameter("height");
  int height = Integer.parseInt(heightStr);
  
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />

<script>
	function openDetails(loca,height){
		parent.openDetails(loca,height);
	}

	function goToTransDetails(tid){
		url = "transdetails.jsp?transId="+tid;
		var detWindow = window.open(url,'detailsWindow','top=300,left=30,height=200,width=700,toolbar=no,resizable=yes,menubar=no,scrollbars=yes,location=no')
		if (detWindow){
  		  detWindow.focus();
		}
	}
	
	function zoomIn(href){
		if (parent){
		  parent.location = href;
		}
	}

</script>

</head>

<body style="margin: 0; padding: 0; border-width: 0" class="BG_COLOR">
<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" >
  <tr valign="top">
    <td width="100%"  style="padding-right:5">
    <table border="0" width="100%" cellspacing="0" cellpadding="0" >
			
										                  
										                  <tr>
										                    <td>
											                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%"> 
											                    	<tr style="padding-bottom:5">
											                      	<td colspan="4">
												                      	<table width="100%" border="0" cellpadding="0" cellspacing="0" >
													                      	<tr>
														                      	<td width="*"><span class="SMALLTEXT" style="font-weight:bold">Transaction Details</span></td>
														                      	<td width="100" class="SMALLTEXT">
														                      	<%if (tranId!=null && tranId.length()>0 && messages != null && messages.size() > 0){%>
														                      	<a href="javascript:goToTransDetails('<%=tranId%>')"  class="SMALLLINK">view log events</a>
														                      	<%} else {%>
														                      	&nbsp;
														                      	<%}%>
														                      	</td>
														                      	<td width="80" class="SMALLTEXT">
														                      	<%if (tranId!=null && tranId.length()>0 && messages != null && messages.size() > 0){%>
														                      	<a href="javascript:openDetails('showDetailsForTransaction.jsp?tran_id=<%=paradigmId%>&runtime_tran_id=<%=tranId%>',600)"  class="SMALLLINK">view Details</a>
														                      	<%} else {%>
														                      	&nbsp;
														                      	<%}%>
														                      	</td>
													                      	</tr>
												                      	</table>
											                      	</td>
											                     	</tr>
											                    	
											                     	<tr bgcolor="#EAEDFD" >
											                        <td width="100" ><span class="REGULARTEXT">Name</span></td>
											                        <td width="*" ><span class="REGULARTEXT"><nobr>Data Summary</nobr></span></td>
											                        <td width="130" colspan="2" class="REGULARTEXT">Time</td>
											                      </tr>
		                      									<tr ><td colspan="4"><IFRAME style="border-width:0" height="<%=String.valueOf(height-60)%>" width="100%" SRC="TransDetailsViewList.jsp?runtime_tran_id=<%=tranId + "&tstmp="+System.currentTimeMillis()%>" id="transDetailsList"></IFRAME></td></tr>
											                		</table>
										                  	</td>
										                	</tr>

    </table>
    </td>
  </tr>
</table>
</form>
</body>
</html>
