<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>

<%@ page import="xpolog.logic.common.*"%>
<%@ page import="xpolog.logic.atomic.data.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.transaction.status.*"%>
<%@ page import="xpolog.logic.routine.data.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.ui.util.*"%>
<%@ page import="xpolog.logic.brain.model.*"%> 
<%@ page import="xpolog.logic.brain.*"%> 
<%@ page import="xpolog.logic.filters.*"%> 
<%@ page import="xpolog.logic.ui.graph.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.ui.log.data.transactions.TransactionQuery" %>
<%@ page import="xpolog.logic.ui.site.*"%>
<%@ page import="xpolog.logic.sources.xplg.*"%>

<%@ page import="java.text.*"%>
<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%!
  public String transformDateToString(Date d){
    return xpolog.eye.site.SiteUtil.formatDefaultDate(d,true);
  }
%>

<%!
  public Transaction getTransactionFromId(Transaction[] trans, String transactionId){
  	if (trans == null){
  		return null;
  	}
  	for (int i=0; i<trans.length; i++){
  		if (trans[i].getId().equals(transactionId)){
  			return trans[i];
  		}
  	}
  	return null;
  }
%>


<%
	String ERROR_OBJ = "ERROR_OBJ";

  LogicEnvironment logicEnv = LogicEnvironment.getLogicEnvironment(request);

  TransResultBuilder transResultBuilder = (TransResultBuilder)request.getSession().getAttribute("currentTransResultBuilder");
  TransactionQuery tranQuery = transResultBuilder == null ? null : transResultBuilder.getTranQuery();
	if (tranQuery == null){
	  ErrorModel ermod = new ErrorModel();
	  ermod.addError("An error occured. Please continue using the menu");
	  request.getSession().setAttribute(ERROR_OBJ,ermod);
	  response.sendRedirect("../../common/errorpage.jsp?cancelURL=logic/logicPortal.jsp&okURL=logic/logicPortal.jsp");
	  return;
	}
	
	String tranId = request.getParameter("runtime_tran_id");
	if(tranId == null){
		tranId = "";
	}
	  
	String paradigmId = tranQuery.getParadigmId();
	
	TransResultBuilder tranResultBuilder = (TransResultBuilder)request.getSession().getAttribute("currentTransResultBuilder");  
  TransactionTypeViewModel model = transResultBuilder.getTranTypeViewModel();
	TransactionDetailsResult detailsResult = tranResultBuilder == null ? null : tranResultBuilder.getDetailsResult();
	if (detailsResult != null && detailsResult.isDoReset()){
  	detailsResult = null;
  }  
	
	DataSessionRuntime dsr = tranQuery.getDataSessionRuntime();
  String zoomWithFilterStr = xpolog.config.Configuration.getInstance().getPropertiesManager().getProperty("logic.ui.analysis.zoomInWithFilter","false");
  boolean zoomInWithFilter = zoomWithFilterStr.equalsIgnoreCase("true");

  //List messages = detailsResult == null ? null : detailsResult.getMessages();
  List messages = model != null ? model.getAllMessagesFromGraph(model.getTransactionById(tranId)) : null;
  if (messages == null){
  	messages  =  new ArrayList();
  }
  
  String mWidth = detailsResult == null ? null : detailsResult.getMessagesWidth();
  int messagesWidth = mWidth == null || mWidth.length() == 0 ? 550 : Integer.parseInt(mWidth);
  int dataWidth = messagesWidth - 280;
  int dataChars = (dataWidth / 5);
  
  List errorMessages = detailsResult == null ? null : detailsResult.getErrorMessages();
  if (errorMessages == null){
  	errorMessages  =  new ArrayList();
  }
  
  String dataFilterId = detailsResult == null ? "" : detailsResult.getDataFilterId();
  
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />


</head>

<body style="margin: 0; padding: 0; border-width: 0" class="MAIN_SCROLL">
<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" cellpadding="0" >
  <tr valign="top">
    <td width="100%" style="padding-right:5">
    <table border="0" width="100%" cellspacing="0" cellpadding="0" >
			
	                  
	                  <tr>
	                    <td>
		                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%"> 
											                    	
											                    	
		                      <%
		                      for (int i = 0; i < messages.size(); i++) {
		                      	Routine rout = (Routine)messages.get(i);
		                      	Transaction parentTran = rout.getParentTransaction();
		                      	String parentTranParadigmId = parentTran.getParadigm().getTransactionParadigmId();
		                      	String data = rout.getAtomic().getDataModel().getData();
		                      	if (data == null){
		                      	  data = "";
		                      	}else if (data.length() > dataChars){
		                      	  data = data.substring(0,dataChars - 3) + "...";
		                      	}else if (data.length() == 0){
		                      	  data = "&nbsp;";
		                      	}
		                      	data = xpolog.eye.util.WebUtil.doHTMLEncoding(data);
														XplgDataSource source = (XplgDataSource)model.getDataSourceForRoutine(rout);
														String targetUrl = BASE_DIRECTORY;
														String myUrl = "";
														if(source.getNodeId() != null && source.getNodeId().length() > 0){
															targetUrl = xpolog.eye.cloud.CloudUtil.createUrl(source.getNodeId()).toString(); 
															myUrl = xpolog.eye.cloud.CloudUtil.createUrl("http",xpolog.eye.cloud.CloudUtil.getCurrentNodeAddress(),request.getServerPort(),request.getContextPath()).toExternalForm();
														}
														
														String filterId = source.getFilterId();
													  if (filterId != null && filterId.length() == 0){
													  	filterId = null;
													  }
														
														String zoomInKey = rout.getAtomic().getDataRef();
														String dataFilterInZoomOut = (dataFilterId != null ? "%26data_filter_id="+dataFilterId : "");
														String href = null;
														if (!(source == null || zoomInKey == null || zoomInKey.length() == 0)){
															if (filterId == null || !zoomInWithFilter){
															href = targetUrl + "loggers/logview.jsp?logid=" + source.getLbmId() + "&gotoMain=true&calls=-1&opdirect=ZOOM_IN&zoomInKey=" + zoomInKey + "&validateTime=" + rout.getCreatedTimeStamp();
															}else {
																href = targetUrl + "loggers/logview.jsp?logid=" + source.getLbmId() + "&gotoMain=true&calls=-1&opdirect=ZOOM_IN_WITH_FILTER&zoomInKey=" + zoomInKey + "&validateTime=" + rout.getCreatedTimeStamp() + "&filters" + filterId;
														}
														}
														String targetWindow = "_parent";
														if (source.getNodeId() != null){
															href += "&disableZoomOut=true";
															targetWindow = "_remoteLogWindow";
														}else{
															href += "&zoomOutFromMainViewPage=true&zoomOutUrl=" + myUrl +"logic/online/TransView.jsp?tran_id="+paradigmId+"%2526runtime_tran_id="+tranId+"%26sessionRuntimeId="+dsr.getId()+dataFilterInZoomOut;
																																												
														}
														%>
											                      <tr>
											                        <td width="100" class="SMALLTEXT">
														<%if (href != null){%>
														<%if (source.getNodeId() != null){ %>
														  <a href="<%=href%>" target="<%=targetWindow%>" class="SMALLTEXT" style="color:black">
														  <%}else { %>
														  <a href="javascript:parent.zoomIn('<%=href%>')" class="SMALLTEXT" style="color:black">
														  <%} %>
														<%}%>
														<%=rout.getRoutineParadigm().getName()%>
														<%if (href != null){%>
														  </a>
														<%}%>
														</td>
											                        <!--<td width="100" class="SMALLTEXT"><%=rout.getRoutineParadigm().getName()+"_"+rout.getId()%></td>-->
											                        <td width="*" class="SMALLTEXT"><%=data%></td>
											                        <td width="150" class="SMALLTEXT"><%=transformDateToString(new Date(rout.getCreatedTimeStamp()))%></td>
											                        <td width="10" class="SMALLTEXT"><a href="javascript:parent.openDetails('showDetailsForTransaction.jsp?tran_id=<%=parentTranParadigmId%>&runtime_tran_id=<%=parentTran.getId()%>&routine_id=<%=rout.getId()%>',400)"  class="LINK"><img src="<%=BASE_DIRECTORY%>logic/images/tranview/logicAnalysisDetails.gif" border="0"></a></td>
											                      </tr>
		                      <%
		                      }
		                      Iterator it = errorMessages.iterator();
		                      while (it.hasNext()){
		                      	String errorMessage = (String)it.next();
		                      %>
														<tr>
															<td colspan="4" class="REGULARTEXT"><%=errorMessage%></td>
														</tr>
		                      <%
		                      }
		                      %>
											                		</table>
										                  	</td>
										                	</tr>

    </table>
    </td>
  </tr>
</table>
</form>
</body>
</html>
