<%@ page language="java"%>

<%@ page import="java.util.*"%>
<%@ page import="java.util.regex.*"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%> 
<%@ page import="xpolog.eye.data.*"%> 
<%@ page import="xpolog.eye.data.filters.*"%> 

<%@ page import="xpolog.logic.brain.BrainDataRepository"%>
<%@ page import="xpolog.logic.brain.BrainConfigurationRepository"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.transaction.status.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.routine.data.*"%>
<%@ page import="xpolog.logic.brain.model.*"%>
<%@ page import="xpolog.logic.common.*"%>
<%@ page import="xpolog.logic.filters.*"%>
<%@ page import="xpolog.logic.ui.site.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.ui.log.data.transactions.TransactionQuery" %>

<%!static final String BASE_DIRECTORY = "../../";%>

<%
			

			WebSecurityManager manager = WebSecurityManager.getInstance();
			if (!manager.checkForPermission(request, response, null, true)) {
				return;
			}
			UserSecurity user = manager.getUserSecurity(request);

			LogicEnvironment logicEnv = LogicEnvironment.getLogicEnvironment(request);
			String sessionRuntimeId = logicEnv.getSessionRuntimeId();
			DataSessionRuntime dsr = null;
			if (sessionRuntimeId != null && !sessionRuntimeId.equals("")) {
				dsr = CtrlMgr.getInstance().getDataSessionRuntimeById(sessionRuntimeId);
			}
			if (dsr == null) {
				dsr = new DataSessionRuntime();
				dsr.setId(DataSession.ONLINE_DATA_SESSION_ID);
			}
			TransactionTypeViewModel model = TransactionTypeViewModelFactory.createTransactionTypeViewModel(dsr);
			BrainConfigurationRepository rep = BrainConfigurationRepository.getRepository();
			TransResultBuilder transResultBuilder = (TransResultBuilder)request.getSession().getAttribute("currentTransResultBuilder");
		  TransactionQuery tranQuery = transResultBuilder.getTranQuery();

			String tranId = request.getParameter("runtime_tran_id");
			String viewType = request.getParameter("viewType");

			Transaction tran = (Transaction) request.getSession().getAttribute("SelectedTransaction");

						
			SessionFilterManager sdfmgr = (SessionFilterManager) request.getSession().getAttribute("sessionDataFilterManager");
			FilterCollection fc = sdfmgr.getFilterCollectionById(sdfmgr.getActiveFilterId());
			TransactionsResult result = transResultBuilder.getLastResult();
			

			Transaction[] trarr = (Transaction[])request.getSession().getAttribute("transactionsList");
			boolean usingFilter = fc != null;

			boolean na = false;
			if (trarr == null || trarr.length == 0) {
				na = true;
			}

			%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />
<script>
	var lastSelectedId = "<%=tran != null ? "tr_"+tran.getId() : (tranId != null ? "tr_"+tranId : "")%>";

	function openInParent(id,elemId){
		if (document.getElementById(lastSelectedId)) document.getElementById(lastSelectedId).className = '';
		if (document.getElementById(elemId)) document.getElementById(elemId).className = 'SELECTED_BG_COLOR';
		lastSelectedId = elemId;
		if (parent && parent.parent){		  
  		parent.parent.showTransGraph(id);
  	}
	}
	
</script> 

</head>

<body  style="margin: 0; padding: 0; border-width: 0;overflow-x:auto;overflow-y:auto" class="MAIN_SCROLL" style="background-color:#F0F0F0;">
<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" cellpadding="0" class="#F0F0F0" style="background-color:#F0F0F0;">
  <tr valign="top">
    <td width="100%" >
    <table border="0" width="100%" cellspacing="0" cellpadding="0" >
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
              
              <tr>
                <td valign="top">
                <table border="0" cellpadding="0" cellspacing="3" style="border-collapse: collapse" width="100%">
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0"   style="border-collapse: collapse" width="100%">
                      
		          <%int n = 0;
			for (int i = 0; trarr != null && i < trarr.length; i++) {
				String timeStatImg = BASE_DIRECTORY + "logic/images/tranview/bullet_ball_green_small.gif";
				String flowStatImg = BASE_DIRECTORY + "logic/images/tranview/bullet_ball_green_small.gif";
				String dataStatImg = BASE_DIRECTORY + "logic/images/tranview/bullet_ball_green_small.gif";
				n++;

				//determine time status	
				TransactionStatus tranTimeStatus = trarr[i].getStatusByType(TransactionTimeStatusLogic.TYPE_TRANSACTION_TIME);
				Integer timeState = TransactionTypeViewModel.GREEN_STATE;
				if (tranTimeStatus != null) {
					if (tranTimeStatus.getStatus() == TransactionTimeStatusLogic.FAILED_STATUS.getStatus()) {
						timeState = TransactionTypeViewModel.RED_STATE;
						timeStatImg = BASE_DIRECTORY+ "logic/images/tranview/bullet_ball_red_small.gif";
					} else if (tranTimeStatus.getStatus() == TransactionTimeStatusLogic.WARN_STATUS.getStatus()) {
						timeState = TransactionTypeViewModel.YELLOW_STATE;
						timeStatImg = BASE_DIRECTORY+ "logic/images/tranview/bullet_ball_yellow_small.png";
					}
				}
				//determin flow status
				TransactionStatus tranFlowStatus = trarr[i].getStatusByType(TopologyStatusLogic.TYPE_FLOW);
				TransactionStatus tranTopStatus = trarr[i].getStatusByType(TopologyStatusLogic.TYPE_TOPOLOGY);
				Integer flowState = TransactionTypeViewModel.GREEN_STATE;

				if (tranFlowStatus != null && tranFlowStatus.getStatus() == TopologyStatusLogic.ERROR_FLOW_STATUS.getStatus()) {
					flowState = TransactionTypeViewModel.RED_STATE;
					flowStatImg = BASE_DIRECTORY + "logic/images/tranview/bullet_ball_red_small.gif";
				}
				if (tranTopStatus != null && flowState != TransactionTypeViewModel.RED_STATE) {
					if ((tranTopStatus.getStatus() == TopologyStatusLogic.PARTIAL_STATUS.getStatus())
							|| (tranTopStatus.getStatus() == TopologyStatusLogic.PARTIAL_CLOSE_STATUS.getStatus())) {
						flowState = TransactionTypeViewModel.RED_STATE;
						flowStatImg = BASE_DIRECTORY + "logic/images/tranview/bullet_ball_red_small.gif";
					}
				}
				//determine data status
				TransactionStatus tranDataStatus = trarr[i].getStatusByType(DataStatusLogic.TYPE_DATA);
				Integer dataState = TransactionTypeViewModel.GREEN_STATE;
				if (tranDataStatus != null) {
					if (tranDataStatus.getStatus() == TransactionTimeStatusLogic.FAILED_STATUS.getStatus()) {
						dataState = TransactionTypeViewModel.RED_STATE;
						dataStatImg = BASE_DIRECTORY + "logic/images/tranview/bullet_ball_red_small.gif";
					}
				}

				String onlineStatImg = "";
				if (trarr[i].getSystemState() == SystemState.USED_STATE) {
					if (flowState == TransactionTypeViewModel.GREEN_STATE 
							&& timeState == TransactionTypeViewModel.GREEN_STATE
							&& dataState == TransactionTypeViewModel.GREEN_STATE) {
						onlineStatImg = BASE_DIRECTORY + "logic/images/tranview/bullet_ball_blue.png";
					} else {
						onlineStatImg = BASE_DIRECTORY + "logic/images/tranview/onlineErr.gif";
					}
				} else {
					if (flowState == TransactionTypeViewModel.GREEN_STATE
							&& timeState == TransactionTypeViewModel.GREEN_STATE
							&& dataState == TransactionTypeViewModel.GREEN_STATE) {
						onlineStatImg = BASE_DIRECTORY + "logic/images/tranview/offlineOk.gif";
					} else {
						onlineStatImg = BASE_DIRECTORY + "logic/images/tranview/offlineErr.gif";
					}
				}

				String defineName = trarr[i].getApplicationName();
				String date = "";
				if (defineName != null) {
					if(viewType != null && viewType.equals("4")){
						date = xpolog.eye.site.SiteUtil.formatDefaultDate(trarr[i].getCreatedTimeStamp(), false);
					}else{
						defineName = defineName + "(" + xpolog.eye.site.SiteUtil.formatDefaultDate(trarr[i].getCreatedTimeStamp(), false) + ")";
					}
				} else {
					defineName = "(" + xpolog.eye.site.SiteUtil.formatDefaultDate(trarr[i].getCreatedTimeStamp(), false) + ")";
					if(viewType != null && viewType.equals("4")){
						date = xpolog.eye.site.SiteUtil.formatDefaultDate(trarr[i].getCreatedTimeStamp(), false);
						defineName = "";
					}
				}
				String zoomInImg = BASE_DIRECTORY + "images/logview/zoomin.gif";
				String zoomInRef = "TransView.jsp?direction=gotoById&runtime_tran_id=" + trarr[i].getId() + "&filter_collection_id=none";
				boolean selected = (tran != null && tran.getId().equals(trarr[i].getId())) || (tranId != null && tranId.equals(trarr[i].getId())); 

				%>
                      <tr id="tr_<%=trarr[i].getId()%>" <%=selected ? "class='SELECTED_BG_COLOR'" : ""%> >
                      	<%if (usingFilter) {
					%>
                        <td width="10"><a href="<%=zoomInRef%>" target="main"><img src="<%=zoomInImg%>" border="0"></a></td>
                      	<%}
				%>
                        <%if(viewType != null && viewType.equals("4")){%>
												<td width="200" class="SMALLTEXT" nowrap align="left" style="padding-right:3"><a class="SMALLTEXT" style="color:black" href="javascript:openInParent('<%=trarr[i].getId()%>','tr_<%=trarr[i].getId()%>')" class="LINK"><%=date%></a></td>
                        <td width="*" class="SMALLTEXT" nowrap align="left" style="padding-right:3"><a class="SMALLTEXT" style="color:black" href="javascript:openInParent('<%=trarr[i].getId()%>','tr_<%=trarr[i].getId()%>')" class="LINK"><%=defineName%></a></td>
                        <%}else{ %>
                        <td width="*" class="SMALLTEXT" nowrap align="left" style="padding-right:3"><a class="SMALLTEXT" style="color:black" href="javascript:openInParent('<%=trarr[i].getId()%>','tr_<%=trarr[i].getId()%>')" class="LINK"><%=defineName%></a></td>                        
                        <%} %>
                        <td width="27" class="SMALLTEXT" align="right"><img src="<%=flowStatImg%>"></td>
                        <td width="27" class="SMALLTEXT" nowrap align="right"><img src="<%=timeStatImg%>"></td>
                        <td width="30" class="SMALLTEXT" nowrap align="right" style="padding-right:3"><img src="<%=dataStatImg%>"></td>
                       <%if(viewType != null && viewType.equals("4")){%>
                       <td width="30" class="SMALLTEXT" nowrap align="right" style="padding-right:3">&nbsp;</td>
                       <%} %>
                       <!-- <td width="15%" class="REGULARTEXT" nowrap align="center"><img width="20" height="20 " src="<%=onlineStatImg%>"></td>-->
                      </tr>
              <%}

			%>
                      <tr>
                        <td width="*" colspan="4" class="SMALLTEXT">&nbsp;</td>
                      </tr>
                    </table>
                   </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
<script>
	if (parent.updateNumTrans){
		<%
			int p = result.getTotalNumberOfTransactions()>0 ? (result.getStartIndex() + result.getOffset() + 1) : 0;
			String posString = TransResultHelper.getCurrentPositionString(transResultBuilder);
		%>
		parent.updateNumTrans("<%=posString%>");
	}
</script>
</body>
<%
	//request.getSession().setAttribute("transactionsResult", result);

%>
</html>
