<%@ page language="java"%>

<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.logic.common.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.transaction.status.*"%>
<%@ page import="xpolog.logic.routine.data.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.ui.util.*"%>
<%@ page import="xpolog.logic.brain.model.*"%> 
<%@ page import="xpolog.logic.brain.*"%> 
<%@ page import="xpolog.logic.filters.*"%> 
<%@ page import="xpolog.logic.ui.graph.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.ui.log.data.transactions.TransactionQuery" %>
<%@ page import="xpolog.logic.ui.site.*"%>
<%@ page import="xpolog.logic.sources.xplg.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.text.*"%>
<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%!
  String dateFormat = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
  String millisecondsSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator",".");
  String dateFormatMS = dateFormat+millisecondsSeperator+"SSS";

  public String transformDateToString(Date d,long timeDiff){
    if(d == null){
      return null;
    }
    if (timeDiff != 0){
     long time = d.getTime();
  	 d = ((Date)d.clone());
  	 d.setTime(time + timeDiff); 
    }
    String format = "";
    if (d.getTime() % 1000 == 0){
      format = dateFormat;
    } else {
      format = dateFormatMS;
    }
    String str = new SimpleDateFormat(format).format(d);
    return str;
   }
%>

<%@ include file="../../tools/sandf/dateFilterAction.jsp"%>

<%

  String ERROR_OBJ = "ERROR_OBJ";
  String OP = "OP";
  String ADD = "ADD";
  String TYPE_LOG = "Log";
  String FILTER_COLLECTION_ID = "filter_collection_id";
  String LEAP_TOP = "leap_top";
  String DIRECTION = "direction";
  
  //check if a DB was configured
  CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
	if (!ctrlMgr.persistencyMediumOk()){
		ErrorModel errmod = new ErrorModel();
		errmod.addError("Could not connect to database");
		errmod.addError("Please ensure that the TxExpo database is well configured and running");
		request.getSession().setAttribute(ERROR_OBJ,errmod);
		response.sendRedirect("../../common/errorpage.jsp?cancelURL=logic/logicPortal.jsp&okURL=logic/logicPortal.jsp");
		return;
	}

  
  //run garbage collection
  System.gc();

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
	UserContext userContext = UserEnvironment.getUserContext(request);
  UserSecurity user = manager.getUserSecurity(request);
  
  String firstStr = request.getParameter("isFirst");
  boolean isFirst = firstStr != null && firstStr.equals("true");

  String queryStr = request.getQueryString();
  LogicEnvironment logicEnv = LogicEnvironment.getLogicEnvironment(request);



  String sessionRuntimeId = request.getParameter("sessionRuntimeId");
  DataSessionRuntime dsr = null;
	if (sessionRuntimeId != null && !sessionRuntimeId.equals("")){
		logicEnv.setSessionRuntimeId(sessionRuntimeId);
		dsr = CtrlMgr.getInstance().getDataSessionRuntimeById(sessionRuntimeId);
	}else{
		sessionRuntimeId = logicEnv.getSessionRuntimeId();
		if((sessionRuntimeId != null) && !sessionRuntimeId.equals("")){
		  logicEnv.setSessionRuntimeId(sessionRuntimeId);
		  dsr = CtrlMgr.getInstance().getDataSessionRuntimeById(sessionRuntimeId);
		}
	}
		
	if (dsr == null){
		dsr = new DataSessionRuntime();
		dsr.setId(DataSession.ONLINE_DATA_SESSION_ID);
	}
	
  String paradigmId = request.getParameter("tran_id");
 
	TransactionTypeViewModel model = TransactionTypeViewModelFactory.createTransactionTypeViewModel(dsr);
  LogicDirectedGraph graphModel = null;
  BrainConfigurationRepository rep = BrainConfigurationRepository.getRepository();
  
	TransResultBuilder transResultBuilder = (TransResultBuilder)request.getSession().getAttribute("currentTransResultBuilder");
	if (transResultBuilder == null){
		transResultBuilder = new TransResultBuilder(model);
		request.getSession().setAttribute("currentTransResultBuilder",transResultBuilder);
	}

  TransactionQuery tranQuery = transResultBuilder.getTranQuery();
  
  String tranId = request.getParameter("runtime_tran_id");
  if(tranId == null){
  	tranId = "";
  }
  
  TransactionParadigm[] tprgarr =  model.getTransactionParadigmList(userContext);
  if(paradigmId == null){
  	if(tprgarr != null && tprgarr.length>0){
  		paradigmId = tprgarr[0].getId(); 
  	}else{
  		paradigmId =  "";
  	}
  }
  
  String direction = request.getParameter(DIRECTION);
  if (direction == null){
  	direction = "";
  }
  
  String genFilterStr = request.getParameter("filterGenerate");
  boolean isFilterGen = genFilterStr != null && genFilterStr.equals("true");
  
  TransactionParadigm selectedParadigm = null;
  
  if (!paradigmId.equals("")){
  	TransactionParadigm t = rep.getTransactionParadigmById(paradigmId);
  	selectedParadigm = t;
	}

	SessionFilterManager sdfmgr = (SessionFilterManager)request.getSession().getAttribute("sessionDataFilterManager");
	if (sdfmgr == null){
		sdfmgr = new SessionFilterManager(paradigmId);
		request.getSession().setAttribute("sessionDataFilterManager",sdfmgr);
	}

	String selectedFilterCollectionId = request.getParameter(FILTER_COLLECTION_ID);
	if (selectedFilterCollectionId != null){
		if (!selectedFilterCollectionId.equals("none")){
			FilterCollection col = sdfmgr.getFilterCollectionByName(selectedFilterCollectionId);
			if (col != null){
				selectedFilterCollectionId = col.getId();
			}
			sdfmgr.setActiveFilterId(selectedFilterCollectionId);
		}else{
			sdfmgr.setActiveFilterId(null);
		}
	}
	selectedFilterCollectionId = sdfmgr.getActiveFilterId();
	FilterCollection fc = sdfmgr.getFilterCollectionById(sdfmgr.getActiveFilterId());
	
  //filter section
  EventFilter eventFilter = new EventFilter();
  eventFilter.setId("TimeRuleFilter");
  eventFilter.setTempFilter(true);
	RecordMask mask = new RecordMask();
	DateMask dateMask = new DateMask("MM/dd/yyyy HH:mm:ss");
	MaskColumn[] cols = {dateMask};
	mask.setColumns(cols);
	DateFilter dfilter = null;
	try {
	  dfilter = createDateFilter(request,response,mask);	
	}catch (Exception e){}
	FilterCollection timeFilterFC = null;
	
	if(dfilter != null){
		dfilter.updateMinTime();
		eventFilter.setDateFilter(dfilter);
		
		timeFilterFC = new FilterCollection();
		timeFilterFC.setId("timeFilter");
		timeFilterFC.setName("timeFilter");
		timeFilterFC.addFilter(eventFilter);
	}else {
		if (!isFilterGen && tranQuery != null){
			timeFilterFC = tranQuery.getDbTimeFilter();
		}
		
	}
	
	
  
  StatusTransactionFilter statusFilter = null;
  
  //time
  ArrayList statusesList = new ArrayList();
  boolean allStatus = false;
  String [] statuses = request.getParameterValues("status_2");
  String status_2 = null;
  
  if (statuses != null && statuses.length > 0){
  	allStatus = statuses.length == 2;
  	StringBuffer buffer = new StringBuffer("2");
  	for(int i = 0; i < statuses.length; i++ ){
  		buffer.append("_");
  		buffer.append(statuses[i]);
  	}
  	statusesList.add(buffer.toString());
    status_2 = buffer.toString();
  }
  
  //flow
  statuses = request.getParameterValues("status_4");
  String status_4 = null;
  if (statuses != null && statuses.length > 0){
  	allStatus = allStatus && statuses.length == 2;
  	StringBuffer buffer = new StringBuffer("4");
  	StringBuffer buffer1 = new StringBuffer("1");
  	for(int i = 0; i < statuses.length; i++ ){
  		buffer.append("_");
  		buffer1.append("_");
  		String [] statusesKeys = statuses[i].split(";");
  		if (statusesKeys.length > 0 && statusesKeys[0].trim().length() > 0){
    		buffer.append(statusesKeys[0]);
  		}
  		if (statusesKeys.length > 1 && statusesKeys[1].trim().length() > 0){
    		buffer1.append(statusesKeys[1]);
  		}
  	}
  	buffer.append(";");
  	buffer.append(buffer1.toString());
  	statusesList.add(buffer.toString());  	  	
    status_4 = buffer.toString();
  }
  
  //data
  statuses = request.getParameterValues("status_5");
  String status_5 = null;
  if (statuses != null && statuses.length > 0){
  	allStatus = allStatus && statuses.length == 2;
  	StringBuffer buffer = new StringBuffer("5");
  	for(int i = 0; i < statuses.length; i++ ){
  		buffer.append("_");
  		buffer.append(statuses[i]);
  	}
  	statusesList.add(buffer.toString());
  	status_5 = buffer.toString();
  }

  FilterCollection statusFilterFC = null;
  if (!allStatus && statusesList.size() > 0){
  	statusFilter = new StatusTransactionFilter();
  	statusFilter.setStatuses((String [])statusesList.toArray(new String[statusesList.size()]));
  	
  	statusFilterFC = new FilterCollection();
  	statusFilterFC.setId("statusFilter");
  	statusFilterFC.setName("statusFilter");
  	statusFilterFC.addFilter(statusFilter);
  }
  String resetTranQueryStr = request.getParameter("resetQuery");
  boolean resetTranQuery = resetTranQueryStr != null && resetTranQueryStr.equals("true");

  if (tranQuery == null){
  	tranQuery = new TransactionQuery(sessionRuntimeId, paradigmId);
  	tranQuery.setSelectedFilterCollection(fc);
    tranQuery.setStatusFilter(statusFilterFC);
    tranQuery.setDbTimeFilter(timeFilterFC);
  }else{  	
	  boolean needToResetBuilder = resetTranQuery || TransResultHelper.needToCreateNewBuilder(paradigmId, dsr, fc, statusFilterFC,timeFilterFC,tranQuery);	  
	  if (needToResetBuilder){
	  	tranQuery = new TransactionQuery(sessionRuntimeId, paradigmId);
	    tranQuery.setSelectedFilterCollection(fc);
	    tranQuery.setStatusFilter(statusFilterFC);
	    tranQuery.setDbTimeFilter(timeFilterFC);
			transResultBuilder = new TransResultBuilder(model);
			request.getSession().setAttribute("currentTransResultBuilder",transResultBuilder);
	  }
  }
   
	transResultBuilder.setTranQuery(tranQuery);
	 
  
  String del1 = StatusMapHelper.entriesDel;
  String del2 = StatusMapHelper.dimValDel;
  
	
	Transaction tran = null;
	if (tran != null && (tranId == null || tranId.length() == 0)){
		tranId = tran.getId();
	}
 	String filterActive = request.getParameter("filter");

 
 	//started before this time
 	
  boolean isNeedsToUpdateData = false;
  	
  //some imaging configuratio
  Properties prop = Configuration.getInstance().getUIData();  
  String expandImg = BASE_DIRECTORY + "logic/images/tranview/vlarrow.gif";//prop.getProperty("logview.expandframe.image");
  String unExpandImg = BASE_DIRECTORY + "logic/images/tranview/vrarrow.gif";//prop.getProperty("logview.unexpandframe.image");
  
	 
	//Navigation
	String leaptop = (String)request.getSession().getAttribute(LEAP_TOP);
	if (leaptop == null) leaptop = "25";
	
	request.getSession().setAttribute("SelectedTransaction",tran);

	request.getSession().removeAttribute("callsPage");
	
  String charset = TransactionTypeViewModel.getCharSetForTransactionParadigm(paradigmId);
  if (charset != null){
    response.setContentType("text/html; charset=" + charset);
  }

  String title = "";
  String extraTitle = "";
  if (selectedParadigm != null){	  
    title += " " + selectedParadigm.getName();
    if (dsr.getId().equals(DataSession.ONLINE_DATA_SESSION_ID)){
      extraTitle += " (Online)";      
    }else {
    	long time = dsr.getStartTime() != 0 ? dsr.getStartTime() : dsr.getCreatedTime();
      if (time > 0){
        extraTitle += " (" + xpolog.eye.site.SiteUtil.formatDefaultDate(new Date(time),true);
        if (dsr.getStartTime() == 0){
        	extraTitle += "*";
        }
      }  
      if (dsr.getEndTime() > 0){
        extraTitle += " - " + xpolog.eye.site.SiteUtil.formatDefaultDate(new Date(dsr.getEndTime()),true);
      }
      if (extraTitle.length() > 0){
	      extraTitle += ")";
      }
    }
  }
  request.getSession().removeAttribute("TransGraphViewDescriptor");
  String advancedOpenStr = request.getParameter("advancedOpen");
  boolean advancedOpen = advancedOpenStr != null && advancedOpenStr.length() > 0;
  
  String timeRuleOpenStr = request.getParameter("timeRuleOpen");
  boolean timeRuleOpen = timeRuleOpenStr != null && timeRuleOpenStr.length() > 0;
  
  if (isFirst){
  	timeRuleOpenStr = Configuration.getInstance().getPropertiesManager().getProperty("logic.analysis.view.time.open","false");
  	timeRuleOpen = timeRuleOpenStr != null && timeRuleOpenStr.equals("true");
  }
  
//Start date filter section
	DateFilter datefl = null;
	
	String DATE_MIN_FILTER_ACTIVE = "DateMinFilterActive";
	String DATE_MAX_FILTER_ACTIVE = "DateMaxFilterActive";
	String DATE_MIN_FILTER_ACTIVE_PARAM = "DATE_MIN_FILTER_ACTIVE_PARAM";
	String DATE_MAX_FILTER_ACTIVE_PARAM = "DATE_MAX_FILTER_ACTIVE_PARAM";
	String DATE_MINIMUM = "DateMinimum";
	String DATE_MAXIMUM = "DateMaximum";
	String DATE_FILTER_MINIMUM_PARAM = "DATE_FILTER_MINIMUM_PARAM";
	String DATE_FILTER_MAXIMUM_PARAM = "DATE_FILTER_MAXIMUM_PARAM";

	long timeDiff = 0;
	Date minDate = null;
	Date maxDate = null;
	String minDateStr = "";
	String maxDateStr = "";
	String minStat = "";
	String maxStat = "";
	String timeunit = "";
	String isTimeLim = "";
	String daystatsel = "";
	String minstatsel = "";
	String hourstatsel = "selected";
	String weekstatsel = "";
	String monthstatsel = "";
	boolean isLast = true;  
	
	
	if (timeFilterFC!=null){
		List list = timeFilterFC.getFilters();
		datefl = list == null || list.size() == 0 ? null : ((EventFilter)list.get(0)).getDateFilter();
		if (datefl != null){
			if(datefl.getTimeType() == -1){
				minDate = datefl.getMinDate();
				maxDate = datefl.getMaxDate();
			}else{
				hourstatsel = "";
				isLast = datefl.isLastOpType();
				isTimeLim = "checked";
				timeunit = String.valueOf(datefl.getTimeGap());
				if(datefl.isMonths()){
					monthstatsel = "selected";
				}else if(datefl.isWeeks()){
					weekstatsel = "selected";
				}else if(datefl.isDays()){
					daystatsel = "selected";      
				}else if(datefl.isHours()){
					hourstatsel = "selected";
				}else if(datefl.isMinutes()){
					minstatsel = "selected";
				}else {
					hourstatsel = "selected";
	      }
	    }
			 long minTimeDiff = timeDiff;
			  if(minDate != null){    
			    minStat = "checked";
			  }

			  long maxTimeDiff = timeDiff;
			  if(maxDate != null){  
			    maxStat = "checked";
			  }
			  minDateStr = transformDateToString(minDate,minTimeDiff);			  
			  maxDateStr = transformDateToString(maxDate,maxTimeDiff);
    }
  }
	
	String viewType = request.getParameter("viewType");
	if (viewType == null || viewType.length() == 0){
		viewType = "1";
	}
	
	int height = 540;
	int width = 800;
	
	int graphHeight = height - 300;
	int graphWidth = width - 300;
	int messagesWidth = width - 300;
	int paddingSize = 10;
	
	
	String formatPage = "TransViewFormat1.jsp";
	if (viewType.equalsIgnoreCase("2")){
		formatPage = "TransViewFormat2.jsp";
		graphHeight = graphHeight - 100;
		messagesWidth = width;
	}else if (viewType.equalsIgnoreCase("3")){
		formatPage = "TransViewFormat3.jsp";
		graphWidth = width;
		graphHeight = graphHeight - 100;
	}else if (viewType.equalsIgnoreCase("4")){
		formatPage = "TransViewFormat4.jsp";
		graphWidth = width;
		graphHeight = graphHeight - 100;
		messagesWidth = width;
		paddingSize = 1;
	}
	 
	 
	 List fcl = sdfmgr.getFilterCollections(false,true);
	  FilterCollection[] rdfArr = (FilterCollection[])fcl.toArray(new FilterCollection[fcl.size()]);

	  if (transResultBuilder.getDetailsResult() != null){
	  	transResultBuilder.getDetailsResult().setDoReset(true);
	  }
	
	//return url
	String zoomOutUrl = request.getParameter("zoomOutUrl");
  String zoomoutImg = BASE_DIRECTORY + prop.getProperty("logview.zoomout.image");  

%>
 
<html>

<head>
<%if (charset != null){ %>
  <meta http-equiv="Content-Type" content="text/html; charset=<%=charset%>">
<%}else{ %>
  <meta http-equiv="Content-Language" content="en-us">
<%}%>
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script type="text/javascript" src="<%=BASE_DIRECTORY%>logic/scripts/formCheck.js"></script>
<script>

	selectionChanged = false;
	paradigmId= "";
	var transRuntimeId = "<%=tranId%>";
	
	<%
		if(paradigmId != null && !(paradigmId.equals(""))){
	%>
	paradigmId="<%=paradigmId%>";
	<%}%>

	function loadTransaction(transactionId){
		path = "TransView.jsp?tran_id="+paradigmId+"&runtime_tran_id="+transactionId;
		path = path + "&OfOnfilter=active";		
		if(document.access.t_on.checked){
			path = path + "&t_on=1";
		}
		if(document.access.t_off.checked){
			path = path + "&t_off=1";
		}
		document.location= path;
	}
	
	function changeView(viewType){
		document.access.viewType.value = viewType;
		document.access.submit();
	}
	
	function openDetails(loca,height){
		if (loca == ''){
			if (transRuntimeId && transRuntimeId != ''){
				loca = 'showDetailsForTransaction.jsp?tran_id=<%=paradigmId%>&runtime_tran_id='+transRuntimeId;
			} else {
				alert('Please select a transaction');
				return;
			}
		}
		window.open(loca , "","top=100,left=100, width=1000, height=" + height + ", location=no, menubar=no, status=no, toolbar=no, scrollbars=yes, resizable=yes");
	}
	
	function showTransGraph(transactionId){
		root = top.frames['root'];	
		if (!root){
		  root = parent;
		}
		var time = new Date();
	  var ms = time.getTime();
	
		transRuntimeId = transactionId;
		filterInUrl = "<%=selectedFilterCollectionId!=null ? "&"+FILTER_COLLECTION_ID+"="+selectedFilterCollectionId : ""%>";
		url = "TransDetailsViewAction.jsp?tran_id=<%=paradigmId%>&runtime_tran_id="+transactionId+filterInUrl+"&ms="+ms;
	  //alert("show " + url);

		if (root.location.href == document.location.href){
		  url = url + "&root=true";
		}
		url = url + "&graphHeight=<%=String.valueOf(graphHeight)%>&graphWidth=<%=String.valueOf(graphWidth)%>&messagesWidth=<%=String.valueOf(messagesWidth)%>";
	  if (document.getElementById("transGraphFrm")){
	    document.getElementById("transGraphFrm").src = "actionProgress.jsp?message=Fetching Data&divWidth=250";
	  }
	  
	  if (document.getElementById("transDetailsFrm")){
	    document.getElementById("transDetailsFrm").src = "empty.jsp";
	  }
		document.getElementById('transDetailsViewAction').src = url;
		document.access.runtime_tran_id.value = transactionId;
	}
	
	function detailsActionLoaded(tranId){
	 transRuntimeId = tranId;
	  if (!tranId) {
	    tranId = "";
	  }
		var time = new Date();
	  var ms = time.getTime();
		
	  if (document.getElementById("transGraphFrm")){
	    document.getElementById("transGraphFrm").src = "TransGraphView.jsp?runtime_tran_id=" + tranId + "&height=" + (document.getElementById("transGraphFrm").scrollHeight-60) + "&width=" + document.getElementById("transGraphFrm").scrollWidth + "&ms="+ms;
	  }
	  
	  //if (document.getElementById("transDetailsFrm")){
	    //document.getElementById("transDetailsFrm").src = "TransDetailsView.jsp?runtime_tran_id=" + tranId + "&height=" + document.getElementById("transDetailsFrm").height + "&width=" + document.getElementById("transDetailsFrm").width + "&ms="+ms;
	  //}
	}
	
	function loadDetailsFrame(tranId){
		var time = new Date();
	  var ms = time.getTime();
	  if (document.getElementById("transDetailsFrm")){
	    document.getElementById("transDetailsFrm").src = "TransDetailsView.jsp?runtime_tran_id=" + tranId + "&height=" + document.getElementById("transDetailsFrm").scrollHeight + "&width=" + document.getElementById("transDetailsFrm").scrollWidth + "&ms="+ms;
	  }
	}

	function generate(){
		generate("");
	}

	function generate(transactionId){
		//setAllowShowHideAdv(false);
		var frm = frames["transList"];
		var statString = "";
		var successStatString = "";
		var filterQueryString = "";
		document.access.filterGenerate.value="true";
		document.access.filter.value="active";	
		document.access.<%=FILTER_COLLECTION_ID%>.value = frm.access.dataFilters.options[frm.access.dataFilters.selectedIndex].value;
		//show = document.getElementById("advanced").style.display == "";
		//if (show){
		//	document.access.advancedOpen.value="y";
		//}
		//show = document.getElementById("timeRule").style.display == "";
		//if (show){
		//	document.access.timeRuleOpen.value="y";
		//}
		document.access.submit();
	}
	
	function checkForNumber(number){
		if(number != ""){
			return true;
		}
	}
	
	function clearTime(){
		document.access.timeFilter.value="";
	}
	
	function showTransaction(){
		tran_Id = document.access.runtime_tran_id.value;
		if(tran_Id == ""){
			return;
		}
		if(isInteger(tran_Id)){
			generate();
			return;
		}
		alert("Please provide a valid transaction id!");
	}
	
	function showTransactionByName(){
		generate();
	}
	
	function getLeap(){
	  var frm = frames["transList"];
	  if (!frm){
	    return 0;
	  }
	  return frm.getLeapTop();
	}
	
	function refreshView(){
		id = "";//document.access.dataFilters.options[document.access.dataFilters.selectedIndex].value;
		datafilter = "&<%=FILTER_COLLECTION_ID%>="+id;
		leaptop = "&leap_top=" + getLeap();
		tstmp = "&tstmp="+new Date().getTime();
		tid = "&runtime_tran_id="+transRuntimeId;
		vtype = "&viewType=<%=viewType%>";
		document.getElementById("transList").src = "TransListViewAction.jsp?height=<%=height%>"+leaptop+datafilter+tstmp+tid+vtype;
	}
	
	function goStart(){
		id = "";//document.access.dataFilters.options[document.access.dataFilters.selectedIndex].value;
		datafilter = "&<%=FILTER_COLLECTION_ID%>="+id;
		leaptop = "&leap_top=" + getLeap();
		tstmp = "&tstmp="+new Date().getTime();
		tid = "&runtime_tran_id="+transRuntimeId;
		vtype = "&viewType=<%=viewType%>";
		document.getElementById("transList").src = "TransListViewAction.jsp?timestamp=<%=String.valueOf(System.currentTimeMillis())%>&height=<%=height%>&direction=first"+leaptop+datafilter+tstmp+tid+vtype;
	}
	
	function goPrev(){
		id = "";//document.access.dataFilters.options[document.access.dataFilters.selectedIndex].value;
		datafilter = "&<%=FILTER_COLLECTION_ID%>="+id;
		leaptop = "&leap_top=" + getLeap();
		tstmp = "&tstmp="+new Date().getTime();
		tid = "&runtime_tran_id="+transRuntimeId;
		vtype = "&viewType=<%=viewType%>";
		document.getElementById("transList").src = "TransListViewAction.jsp?timestamp=<%=String.valueOf(System.currentTimeMillis())%>&height=<%=height%>&direction=prev"+leaptop+datafilter+tstmp+tid+vtype;
	}
		
	function goNext(){
		id = "";//document.access.dataFilters.options[document.access.dataFilters.selectedIndex].value;
		datafilter = "&<%=FILTER_COLLECTION_ID%>="+id;
		leaptop = "&leap_top=" + getLeap();
		tstmp = "&tstmp="+new Date().getTime();
		tid = "&runtime_tran_id="+transRuntimeId;
		vtype = "&viewType=<%=viewType%>";
		document.getElementById("transList").src = "TransListViewAction.jsp?timestamp=<%=String.valueOf(System.currentTimeMillis())%>&height=<%=height%>&direction=next"+leaptop+datafilter+tstmp+tid+vtype;
	}
	
	function goLast(){
		id = "";//document.access.dataFilters.options[document.access.dataFilters.selectedIndex].value;
		datafilter = "&<%=FILTER_COLLECTION_ID%>="+id;
		leaptop = "&leap_top=" + getLeap();
		tstmp = "&tstmp="+new Date().getTime();
		tid = "&runtime_tran_id="+transRuntimeId;
		vtype = "&viewType=<%=viewType%>";
		document.getElementById("transList").src = "TransListViewAction.jsp?timestamp=<%=String.valueOf(System.currentTimeMillis())%>&height=<%=height%>&direction=last"+leaptop+datafilter+tstmp+tid+vtype;
	}
	


function hideShowMenu(){    
	root = top.frames['root'];	
	if (!root){
	  root = parent;
	}
	
	if (!root){
	  return;
	}
	queryString = "<%=queryStr%>";
	if (queryString.indexOf("runtime_tran_id")==-1){
		queryString += "&runtime_tran_id="+transRuntimeId;
	}else{
		var regExp = /(.*)runtime_tran_id=(\d+)(.*)/;
		regExp.exec(queryString);
		queryString = RegExp.$1+"&runtime_tran_id="+transRuntimeId+RegExp.$3;
	}
	if (queryString.indexOf("root")==-1){
	  if (root.location.href == document.location.href){
		  queryString += "&root=false";
		}else {
		  queryString += "&root=true";
		}
	}else{
		var regExp = /(.*)root=(true|false)(.*)/;
		regExp.exec(queryString);
		if (root.location.href == document.location.href){
		  queryString = RegExp.$1+"&root=false"+RegExp.$3;
		}else {
		  queryString = RegExp.$1+"&root=true"+RegExp.$3;
		}
	}
	if (root.location.href == document.location.href){
	  root.location = "<%=BASE_DIRECTORY%>root.jsp?mainPage=logic/online/TransView.jsp&"+queryString;
	}else {
	  root.location =  "<%=BASE_DIRECTORY%>logic/online/TransView.jsp?"+queryString;
	}
}
function getExpandImageName(){
	root = top.frames['root'];
	if (!root){
	  root = parent;
	}
	
	if (!root || root.location == document.location){
	  return "<%=unExpandImg%>";
	}else {
	  return "<%=expandImg%>";
	}
  }
  
	function init(){
		var param = "<%=request.getQueryString() != null ? request.getQueryString() : "tran_id="+paradigmId+"&runtime_tran_id="+tranId%>";
	  var url = "TransDetailsViewAction.jsp?graphHeight=<%=String.valueOf(graphHeight)%>&graphWidth=<%=String.valueOf(graphWidth)%>&messagesWidth=<%=String.valueOf(messagesWidth)%>&"+param;
	  //alert("init " + url);
	  root = top.frames['root'];	
	  if (!root){
	    root = parent;
	  }
			
		if (root.location.href == document.location.href){
		  url = url + "&root=true";
		}
		<% if (tranId != null && tranId.length() > 0){%>
	  if (document.getElementById("transGraphFrm")){
	    document.getElementById("transGraphFrm").src = "actionProgress.jsp?message=Fetching Data&divWidth=250";
	  }
	  <%}%>
    document.getElementById('transDetailsViewAction').src=url;
	}
	
	function openPathLink(url){
	  root = top.frames['root'];	
	  if (!root){
	    root = this;
	  }
			
		if (root.location.href == document.location.href){
		  url = "<%=BASE_DIRECTORY%>root.jsp?mainPage=" + url;
		}else {
		  url = "<%=BASE_DIRECTORY%>" + url;
		}
		this.location = url;
	}
	
  function zoomOut(){
		<%
		if (zoomOutUrl != null){
    	if(zoomOutUrl.indexOf("http") >=0){%>
		 		this.location = "<%=zoomOutUrl%>";
		<%}else{%>
    		this.location = "<%=BASE_DIRECTORY + zoomOutUrl%>";
    <%}%>
    <%
    }%>
  }

	function showHideTransDetails(isShow, topHeight, tr){
		if(isShow){
			document.getElementById("transDetailsId").style.display = "none";			
			document.getElementById("transGraphId").style.display = "";			
			document.getElementById("viewTabsTD").background  = "<%=BASE_DIRECTORY%>logic/images/tranview/filterSelectedTime.gif";			
		}else{
	    document.getElementById("transDetailsId").style.display="";	
			var TransDetailsElem = document.getElementById("transDetailsFrm");
			if(TransDetailsElem){
				TransDetailsElem.src = "TransDetailsView.jsp?height="+topHeight+"&runtime_tran_id="+transRuntimeId+"&tr="+tr;
			}			
			document.getElementById("transGraphId").style.display = "none";			
			document.getElementById("viewTabsTD").background  = "<%=BASE_DIRECTORY%>logic/images/tranview/filterTimeSelected.gif";			
		}
	}
	

</script>

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/jsdomenu.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />
<script>  
  var menu_base_directory = "<%=BASE_DIRECTORY%>";
</script>
<script  src="<%=BASE_DIRECTORY%>scripts/comps/jsdomenu.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/comps/slider.js" type="text/javascript" ></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/calendar/calendar2.js"></script><!-- Date only with year scrolling -->

<title></title>
</head>
<body style="margin: 0; padding: 0; border-width: 0" onLoad="init();">
<form AUTOCOMPLETE="OFF" id="access" name="access" method="POST" action="TransView.jsp">
<input type="hidden" name="tranId" id="tranId" value="<%=tranId != null ? tranId : ""%>">
<input type="hidden" name="tranParadigmId" value="<%=paradigmId%>">
<input type="hidden" name="runtime_tran_id" value="<%=tranId != null ? tranId : ""%>">
<input type="hidden" name="tran_id" value="<%=paradigmId != null ? paradigmId : ""%>">
<input type="hidden" name="filter" value="">
<input type="hidden" name="<%=FILTER_COLLECTION_ID%>" value="">
<input type="hidden" name="advancedOpen" value="">
<input type="hidden" name="timeRuleOpen" value="">
<input type="hidden" name="filterGenerate" value="">
<input type="hidden" name="viewType" value="<%=viewType%>">
<%if (status_2 != null){ %>
<input type="hidden" name="status_2" value="<%=status_2%>">
<%}%>
<%if (status_4 != null){ %>
<input type="hidden" name="status_4" value="<%=status_4%>">
<%}%>
<%if (status_5 != null){ %>
<input type="hidden" name="status_5" value="<%=status_5%>">
<%}%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" class="LOGIC_MAIN_TABLE">
  <tr valign="top">
    <td>
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
				<tr height="30"><td></td></tr>
				<tr><td>
    <nobr><%if(!Configuration.getInstance().isEmbeded()){%><a href="javascript:hideShowMenu()" class="LINK"><script>document.write("<img border=\"0\" src=" + getExpandImageName() + ">");</script></a><%}%></nobr>
    </td></tr>
    <tr><td></td></tr>
    </table>
    </td>
    <td width="100%">
    	<table border="0" width="100%" cellspacing="0" cellpadding="0">
				<tr>
					<td valign="top" height="100%" style="padding-left:10">
						<table border="0"  width="100%" cellpadding="0" cellspacing="0" >									    													
									
									
									<%
									 
									 
									%>
              					  <tr >
	               						<td height="<%=String.valueOf(height + 30)%>" >          
	               						<table border="0" cellpadding="0" cellspacing="0" width="100%">
	               						   <tr height="9">
	               						   <td align="left" width="10" valign="top"><img src="<%=BASE_DIRECTORY%>images/ui/leftTopCircle.gif" border="0"></td>
	               						   <td style="border-top:1px solid #727272" width="100%"><span style="font-size: 2pt;">&nbsp;</span></td>
	               						   <td align="right" width="10"><img src="<%=BASE_DIRECTORY%>images/ui/rightTopCircle.gif" border="0"></td>
	               						   </tr>
	               						   <tr><td colspan="3" style="border-left:1px solid #727272;border-right:1px solid #727272">
								            	<table border="0" cellpadding="0" cellspacing="0" width="100%" >								            	  			            	  								            	  
								            	  <tr height="30">

								            	  <td>
									            	  <table border="0" cellpadding="0" cellspacing="0" width="100%" style="padding:<%=String.valueOf(paddingSize)%>">
									            	  	<tr>
									            	  	<td>
												            	  <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
												            	  <tr>
												            	  <td style="padding-left:10" width="10"><a href="javascript:changeView('1')"> <img src="<%=BASE_DIRECTORY%>logic/images/tranview/<%=viewType.equalsIgnoreCase("1") ? "TxExpoAnalysisSel1.gif" : "TxExpoAnalysis1.gif"%>" border="0"></a></td>
												            	  <td style="padding-left:3" width="10"><a href="javascript:changeView('2')"><img src="<%=BASE_DIRECTORY%>logic/images/tranview/<%=viewType.equalsIgnoreCase("2") ? "TxExpoAnalysisSel2.gif" : "TxExpoAnalysis2.gif"%>" border="0"></a></td>
												            	  <td style="padding-left:3" width="10"><a href="javascript:changeView('3')"><img src="<%=BASE_DIRECTORY%>logic/images/tranview/<%=viewType.equalsIgnoreCase("3") ? "TxExpoAnalysisSel3.gif" : "TxExpoAnalysis3.gif"%>" border="0"></a></td>
												            	  <td style="padding-left:3" width="10"><a href="javascript:changeView('4')"><img src="<%=BASE_DIRECTORY%>logic/images/tranview/<%=viewType.equalsIgnoreCase("4") ? "TxExpoAnalysisSel4.gif" : "TxExpoAnalysis4.gif"%>" border="0"></a></td>
												            	  <%if (zoomOutUrl != null && zoomOutUrl.length() > 0){%>
												            	  <td style="padding-left:8" valign="bottom"><a href="javascript:zoomOut()"><img border="0" src="<%=zoomoutImg%>"></a></td>
												            	  <%}%>
												            	  <td width="*">&nbsp;</td>
												            	  </tr>
												            	  </table>
										            	  </td>
										            	  <td width="100%" nowrap align="left" style=";padding-left:30;">
										<%
										String link_2 = "javascript:openPathLink('logic/online/TransTypeView.jsp')";										
										%>
										<jsp:include page="../../common/path.jsp" flush="true">
												<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
		      									<jsp:param name="name_1" value="Transaction Analysis" />
		      									<jsp:param name="name_2" value="Transaction" />
		      									<jsp:param name="name_3" value="<%=extraTitle%>" />
		      									<jsp:param name="link_1" value="javascript:openPathLink('logic/logicPortal.jsp')" />
		      									<jsp:param name="link_2" value="<%=link_2%>" />		      									
										</jsp:include>											
										</td>									            	 	
									            	  	</tr>
									            	  </table>
								            	  </td>								            	  								            	  

								            	  </tr>      	  								            	  								            	  								            	  								            	  
		              							<tr height="<%=height%>">
		               								<td valign="top" style="padding-top:<%=String.valueOf(paddingSize)%>" >
		                								<jsp:include page="<%=formatPage%>" flush="true">
		                								<jsp:param name="direction" value="<%=direction%>"/>		                								
		                								<jsp:param name="height" value="<%=String.valueOf(height)%>"/>		                								
		                								<jsp:param name="width" value="<%=String.valueOf(width)%>"/>
		                								<jsp:param name="viewType" value="<%=viewType%>"/>
		                								</jsp:include>
			                							
		                							</td>		                							
									            	</tr>
									          	</table>
									          	</td>
									          	</tr>
									          	<tr height="9">
	               						   <td align="left" width="10" valign="bottom"><img src="<%=BASE_DIRECTORY%>images/ui/leftBottomCircle.gif" border="0"></td>
	               						   <td style="border-bottom:1px solid #727272" width="100%"><span style="font-size: 2pt;">&nbsp;</span></td>
	               						   <td align="right" width="10"><img src="<%=BASE_DIRECTORY%>images/ui/rightBottomCircle.gif" border="0"></td>
	               						   </tr>
									          	</table>
									        	</td>
									      	</tr>
	   										</table>
	   							 		</td> 
	  								</tr>
									
						</table>
					
		</td>
	</tr>
	<tr>
		<td class="REGULARTEXT">
		<IFRAME height="0" width="0" style="border-width:0" id="transDetailsViewAction" ></IFRAME>
		&nbsp;</td>
	</tr>
	
</table>
<script language="JavaScript">
 
	// create calendar object(s) just after form tag closed
			// note: you can have as many calendar objects as you need for your application
			
	//var cal7 = new calendar2("<%=BASE_DIRECTORY%>",document.access.<%=DATE_MINIMUM%>,null,<%="/^\\-?\\d+(\\"+millisecondsSeperator+"\\d+)*$/"%>,"<%=millisecondsSeperator%>");
	//cal7.year_scroll = true;
	//cal7.time_comp = true;
	//var cal8 = new calendar2("<%=BASE_DIRECTORY%>",document.access.<%=DATE_MAXIMUM%>,null,<%="/^\\-?\\d+(\\"+millisecondsSeperator+"\\d+)*$/"%>,"<%=millisecondsSeperator%>");
	//cal8.year_scroll = true;
	//cal8.time_comp = true;

	//function openCal7(){		
		//cal7.popup();
	//}
	//function openCal8(){		
	//	cal8.popup();
	//}
</script>
</body>
</html>
	