<%@ page language="java"%>

<%@ page import="xpolog.eye.common.*"%>
<%@ page import="xpolog.eye.site.*"%>


<% 
	 String BASE_DIRECTORY = SiteUtil.getBaseDirectory(request);
   String USE_STATUS = "useStatus";
   UserEnvironment env = UserEnvironment.getUserEnvironment(request);
   String use = request.getParameter(USE_STATUS);
   boolean useStatus = false;
   if(use != null && use.equals("true")) {
   	  useStatus = true;
   }

	 //div parameters
   int divWidth = 500;
   String divW = request.getParameter("divWidth");
   if (divW != null && divW.length()>0){
   	divWidth = Integer.parseInt(divW);
   }
   int divHeight = 100;
   String divH = request.getParameter("divHeight");
   if (divH != null && divH.length()>0){
   	divHeight = Integer.parseInt(divH);
   }
   String divStyle = "background:white;border:1px solid #DBD6F9";
   String divS = request.getParameter("divStyle");
   if (divS != null){
   	divStyle = divS;
   }
   String hideDivHeader = request.getParameter("hideDivHeader");
   String messageLeftPadding = request.getParameter("messageLeftPadding");
   int padding = 30;
   if (messageLeftPadding != null){
   	try{
   		padding = Integer.parseInt(messageLeftPadding);
   	}catch(Exception e){
   	}
   }
   
   String bodyStyle = request.getParameter("bodyStyle");
   if (bodyStyle == null){
  	 bodyStyle = "style=\"margin: 0; padding: 0; border-width: 0\"";
   }else{
  	 bodyStyle = "style=\"" + bodyStyle + "\"";
   }
   
		   
   String message = request.getParameter("message");
   Status status = null;
   
   if(useStatus) {
   	status = (Status)env.getTempAttribute(SiteConstants.STATUS_ATTRIBUTE,false);
   	if(status!=null) {
   	  String statusMessage = status.getCurrentStatus();
   	  if (statusMessage != null && statusMessage.trim().length() == 0){
   	    message = statusMessage;
   	  }
   	}
   }else {
     env.removeTempAttribute(SiteConstants.STATUS_ATTRIBUTE);
   }
   
   if (message == null){
     message = "Processing";
   }

   String width = request.getParameter("width");
   String height = request.getParameter("height");
   if (width == null || width.trim().length() == 0){
     width = "-1";
   }

   if (height == null || height.trim().length() == 0){
     height = "100";
   }

   String stopUrl = request.getParameter("stopUrl");
   if (stopUrl != null && stopUrl.trim().length() == 0){
     stopUrl = null;
   }
   
   String useInPageStr = request.getParameter("useInPage");
   boolean useInPage = useInPageStr != null && useInPageStr.equals("true");

   String hideDotsStr = request.getParameter("hideDots");
   boolean hideDots = hideDotsStr != null && hideDotsStr.equals("true");
%>

<html>
<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>

<script>
var count = 0;
var update = true;
var firstTime = true;
var message = "<%=message%>";

function updateDiv(){
  if (update){
    if (count == 0){
      showProgress();
    }
    count++;
    dots = (count % 5);
    dotsStr = "";
    <%if (!hideDots){%>
    for (var i = 0; i <= dots;i++){
      dotsStr += ".";
    }
    <%}%>
    document.getElementById("progressMsg").innerHTML = message + dotsStr; 
  }
}

function updateStatus(){
  if (update){
    if(firstTime) {
    	firstTime = false;
    }
    if (<%=status != null%>){
      frames['statusFrame'].document.location = "<%=BASE_DIRECTORY%>common/statusAction.jsp";  
    }else {
      dataLoad();
    }
  }
}

function showProgress(){
  showHideLayerInMiddle("progressDiv",<%=width%>,<%=height%>);
}

function dataLoad(){
	if(firstTime) {
		return;
	}
	 if (<%=status != null%>){
	   message = frames['statusFrame'].msg;
	 }
	
	if (update){
	  setTimeout('updateStatus()',1000);
	  updateDiv();
	}
}

</script>

</head>
<body bgcolor="#FFFFFF" <%=bodyStyle%>>
<iframe name="statusFrame" style="visibility:hidden" onload="javascript:dataLoad();" src="<%=BASE_DIRECTORY%>common/statusAction.jsp" width="0" height="0"></iframe>
<iframe name="stopFrame" style="visibility:hidden" width="0" height="0"></iframe>
<div id="progressDiv" style="position:absolute;visibility:hidden;width:<%=divWidth%>;height:<%=divHeight%>">
  <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="<%=divStyle%>">
  <%if (hideDivHeader==null || !hideDivHeader.equals("true")){%>
	<tr height="25"><td align="center" style="border-bottom:solid 1px #DBD6F9" bgcolor="#EEF2F5">
		<span class="PROGRESSTEXT">Progress</span>
	  </td>
	</tr>
	<%}%>
	<tr height="*" valign="center" >
	<td id="progressMsg" class="PROGRESSTEXT" align="left" style="padding-left:<%=padding%>">	
    </td>
	</tr>
	<%if (stopUrl != null) { %>
	<tr height="10" padding="2"><td align="center" style="padding-bottom:5">
		<A class="PROGRESSLINK" href="<%=BASE_DIRECTORY+stopUrl%>" target="stopFrame">Stop
	  </td>
	</tr>
	<%}%>
  </table>
</div>  

<script>
	setTimeout('updateDiv()',20); 
	setTimeout('updateStatus()',1000);
</script>
</body>
</html>