<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.security.*"%>	
<%@ page import="xpolog.config.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";

  String dateFormat = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
  String millisecondsSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator",".");
  String dateFormatMS = dateFormat+millisecondsSeperator+"SSS";

  public String transformDateToString(Date d,long timeDiff){
    if(d == null){
      return null;
    }
    if (timeDiff != 0){
       long time = d.getTime();
    	 d = ((Date)d.clone());
    	 d.setTime(time + timeDiff); 
    }
    //01/31/2003 01:42:34
    String format = "";
    if (d.getTime() % 1000 == 0){
	    format = dateFormat;
    } else {
	    format = dateFormatMS;
    }
    String str = new SimpleDateFormat(format).format(d);
    return str;
  }
%>
<%
  //constants
  String EDIT_FILTER_ID = "EDIT_FILTER_ID";

  String LOG_ID = "LOG_ID";
  String LOG_NAME = "LOG_NAME";
  String STRING_FILTER = "StringFilter";
  String PRIORITY_FILTER = "PriorityFilter";
  String DATE_FILTER = "DateFilter";
  String CHOICE_FILTER = "ChoiceFilter";
  String NUMBER_FILTER = "NumberFilter";
  String MULTI_FILTER = "MultiFilter";
  String SHOW_ONLY_VISIBLE_FIELDS = "ShowOnlyVisibleFields";

  String FILTER_VALUE_PARAM  = "StringFilterValue_";
  String FILTER_CHECK_PARAM  = "StringFilterCheck_";
  String FILTER_OP_PARAM     = "StringFilterOp_";
  String FILTER_CASE_SENSITIVE_PARAM = "StringFilterCaseSensitive_";
  String FILTER_REG_EXP_PARAM = "StringFilterRegExp_";
	String FILTER_MATCH_WHOLE_WORDS_PARAM = "StringFilterMatchWholeWords_";
  int STR_FILTER_NUMBER = 4;

  String PRIOR_CHECK_NAME = "PriorityCheck_";
  String PRIOR_SPEC_VAL = "PRIOR_SPEC_VAL_";

  String DATE_MIN_FILTER_ACTIVE = "DateMinFilterActive";
  String DATE_MAX_FILTER_ACTIVE = "DateMaxFilterActive";
  String DATE_MIN_FILTER_ACTIVE_PARAM = "DATE_MIN_FILTER_ACTIVE_PARAM";
  String DATE_MAX_FILTER_ACTIVE_PARAM = "DATE_MAX_FILTER_ACTIVE_PARAM";
  String DATE_MINIMUM = "DateMinimum";
  String DATE_MAXIMUM = "DateMaximum";
  String DATE_FILTER_MINIMUM_PARAM = "DATE_FILTER_MINIMUM_PARAM";
  String DATE_FILTER_MAXIMUM_PARAM = "DATE_FILTER_MAXIMUM_PARAM";

  //page data
  String logname    = "";

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  PriorityFilter prtfl = null;
  DateFilter datefl = null;
  FilterCollection fc = new FilterCollection();

  String filterName = "";
  String ADDparamToPass = "";
  String EDITparamToPass = "";
  //String filterId = request.getParameter(EDIT_FILTER_ID);
  int numFilterc = 0;
  if(fman != null){
    numFilterc = fman.getFilterCollections().size();
    List list = fman.getFilterCollections();
    if (!list.isEmpty()){
    	fc = (FilterCollection)list.get(0);
    	filterName = filterCollection.getName();
    }
  }
  else{
  	filterName = "GenName_" + String.valueOf(numFilterc);
  }
  
  //extracting the filters for data
  List strfl  = fc.getByName(STRING_FILTER);
  if(strfl == null){
    strfl = new LinkedList();
  }

  //RecordMask mask = lbm.getRecordMask();
  CustomizationManager cust = null;
  String[] priorities = null;
  int cnum = mask.getCulomnsNumber();
  ArrayList choiceList = new ArrayList();
  ArrayList choiceFilters = new ArrayList();
  HashMap choiceMap = new HashMap();
  LinkedList numberMaskFields = new LinkedList();
  HashMap numberMap = new HashMap();
  HashMap reverseNumberMap = new HashMap();
  boolean choiceMaskExsit = false;
  boolean dateMaskExsit = false;
  boolean numberMaskExists = false;
  int choiceNum = 0;
  int numberMaskNum = 0;
  long timeDiff = 0;

  for(int i=0;i<cnum;++i){
    if((mask.getMaskColumn(i) instanceof PriorityMask)){
      priorities = ((PriorityMask)mask.getMaskColumn(i)).getPriorities();
    }else if((mask.getMaskColumn(i) instanceof DateMask)){
      dateMaskExsit = true;
      if (i == mask.getDateColumnIndex()){
        timeDiff = ((DateMask)mask.getMaskColumn(i)).getTimeDiff();
      }
    }else if(mask.getMaskColumn(i) instanceof ChoiceMask){
      choiceList.add(mask.getMaskColumn(i));
      choiceMap.put(new Integer(i),new Integer(choiceNum++));
    }else if(mask.getMaskColumn(i) instanceof NumberMask){
    	numberMaskFields.add(mask.getMaskColumn(i));
    	numberMap.put(new Integer(i),new Integer(numberMaskNum));
    	reverseNumberMap.put(new Integer(numberMaskNum),new Integer(i));
    	numberMaskNum++;
    }
  }
  ChoiceFilter[] choice_filters = new ChoiceFilter[choiceList.size()];
  if(choiceList.size()>0){
    choiceMaskExsit = true;
  }

  choiceNum = choiceList.size();
  if(fc.getByName(CHOICE_FILTER) != null && fc.getByName(CHOICE_FILTER).size() > 0){
    List chlf = fc.getByName(CHOICE_FILTER);
    ChoiceFilter cf = null;
    for(int i=0;i<chlf.size();++i){
      cf = (ChoiceFilter)chlf.get(i);
      Integer index = (Integer)choiceMap.get(new Integer(cf.getColIndex()));
      choice_filters[index.intValue()] = cf;
      cf = null;
    }
  }

  NumberFilter[] number_filters = new NumberFilter[numberMaskFields.size()];
  if(numberMaskFields.size()>0){
    numberMaskExists = true;
  }

  numberMaskNum = numberMaskFields.size();
  if(fc.getByName(NUMBER_FILTER) != null && fc.getByName(NUMBER_FILTER).size() > 0){
    List numlf = fc.getByName(NUMBER_FILTER);
    NumberFilter nf = null;
    for(int i=0;i<numlf.size();++i){
      nf = (NumberFilter)numlf.get(i);
      Integer index = (Integer)numberMap.get(new Integer(nf.getColIndex()));
      number_filters[index.intValue()] = nf;
      nf = null;
    }
  }



  if(fc.getByName(PRIORITY_FILTER) != null && fc.getByName(PRIORITY_FILTER).size() > 0){
    List l = fc.getByName(PRIORITY_FILTER);
    if((l != null) && (l.size() > 0)){
      prtfl = (PriorityFilter)l.get(0);
    }
  }

  Date minDate = null;
  Date maxDate = null;
  String minDateStr = "";
  String maxDateStr = "";
  String minStat = "";
  String maxStat = "";
  String timeunit = "";
  String isTimeLim = "";
  String daystatsel = "";
  String minstatsel = "";
  String hourstatsel = "selected";
  String weekstatsel = "";
  String monthstatsel = "";
  boolean isLast = true;  

  if(fc.getByName(DATE_FILTER) != null && fc.getByName(DATE_FILTER).size() > 0){
   datefl = (DateFilter)fc.getByName(DATE_FILTER).get(0);
    if(datefl.getTimeType() == -1){
      minDate = datefl.getMinDate();
      maxDate = datefl.getMaxDate();
    }else{
      hourstatsel = "";
		  isLast = datefl.isLastOpType();
      isTimeLim = "checked";
      timeunit = String.valueOf(datefl.getTimeGap());
      if(datefl.isMonths()){
        monthstatsel = "selected";
      } else if(datefl.isWeeks()){
        weekstatsel = "selected";
      } else if(datefl.isDays()){
        daystatsel = "selected";      
      }else if(datefl.isHours()){
        hourstatsel = "selected";
      }else if(datefl.isMinutes()){
        minstatsel = "selected";
      }else {
        hourstatsel = "selected";
      }
    }
  }

  long minTimeDiff = timeDiff;
  if(minDate == null){
    minDate = new Date();
    long t = minDate.getTime();
    minDate.setTime(t-(t%1000));
    minTimeDiff = 0;
  }else{
    minStat = "checked";
  }

  long maxTimeDiff = timeDiff;
  if(maxDate == null){
   maxDate = new Date();
    long t = maxDate.getTime();
    maxDate.setTime(t-(t%1000));
    maxTimeDiff = 0;
  }else{
    maxStat = "checked";
  }
  minDateStr = transformDateToString(minDate,minTimeDiff);
  maxDateStr = transformDateToString(maxDate,maxTimeDiff);

  UserSecurity security = WebSecurityManager.getInstance().getUserSecurity(request);
  boolean isEditable = security == null || security.isModuleMemberEditable(lbm.getId());
  
  String forward = request.getParameter("forward");
  boolean isIndexing = false;
  String showOnlyVisibleFieldsStr = request.getParameter(SHOW_ONLY_VISIBLE_FIELDS);
  boolean showOnlyVisibleFields = (showOnlyVisibleFieldsStr != null && showOnlyVisibleFieldsStr.equals("true"));
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = BASE_DIRECTORY;
	}
%>

<script language="javascript">
	<% if (transParadigmId != null && transParadigmId.length()>0){%>
	function refreshView(){
		routineId = document.access.routineParadigmId.options[document.access.routineParadigmId.selectedIndex].value;
		statFilter = (document.access.statusFilter.checked ? "1" : "0");
		dispFilter = (document.access.displayFilter.value ? "1" : "0");
		path = "TransactionFilter.jsp?trans_paradigm_id="+<%=transParadigmId%>+"&routine_paradigm_id="+routineId+"&status_filter="+statFilter+"&display_filter="+dispFilter;
		document.location = path;
	}
	<%}%>
	
	function applyTransactionFilter(){
		routineId = document.access.routineParadigmId.options[document.access.routineParadigmId.selectedIndex].value;
		path = "TransFilterAction.jsp";
		document.location = path;
	}

  function doApply(isTemp){

    if(document.access.SpecificColumns.checked){
      addAllFiledToSelection(document.access.ToCol,document.access.ToCol_Select);
      for(var i=0;i<document.access.ToCol_Select.options.length;++i){
        document.access.ToCol_Select.options[i].selected='true';
      }
    }
		if (isTemp == "true"){
			document.access.tempFilter.value = "true";
		}else{
			document.access.tempFilter.value = "false";
		}
     <%
      if(priorities != null){
    %>
      addAllFiledToSelection(document.access.To,document.access.ToSelect);
      for(var i=0;i<document.access.ToSelect.options.length;++i){
        document.access.ToSelect.options[i].selected='true';
      }
    <%
      }
    %>

		<%
      if(choiceMaskExsit){
    %>
      var choicenumber = <%=String.valueOf(choiceNum)%>;
      for(var i=0;i<choicenumber;++i){
        selToH = eval("document.access.To_Select_"+i);
        selTo = eval("document.access.To_"+i);
        addAllFiledToSelection(selTo,selToH);
        for(var t=0;t<selToH.options.length;++t){
          selToH.options[t].selected='true';
        }
      }
    <%
      }
    %>
	
    document.access.action="TransFilterAction.jsp";
    document.access.submit();
  }
  
  function checkDate(date_check_box, date_obj){
  	date_ok = "";
  	obj_name = date_check_box.name;
  	frames['dateValidationFrame'].location = "<%=baseDirectory%>calendar/dateValidation.jsp?dateStr="+date_obj.value+"&date_check_box="+obj_name;
  }
  
</script>
<script language="JavaScript" src="<%=baseDirectory%>scripts/calendar/calendar2.js"></script><!-- Date only with year scrolling -->
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">

  <tr>
    <td width="100%" height="100%" valign="top">
    	<table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      		<tr>
        		<td valign="top" height="84%">
        			<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          			<tr>
            				<td width="100%">
            					<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              					<tr>
                				  <td width="100%" colspan="3">
                                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td width="100%"><font size="1">&nbsp;</font></td>
                                      </tr>
                                      <tr>
                                        <td width="100%"><span class="HEADER">Name: </span><input class="REGULARTEXT" type="text" name="filterName" size="30" value="<%=filterName%>"></td>
                                      </tr>
                                      <tr>
                                        <td width="100%"></td>
                                      </tr>
                                      <tr>
                                        <td width="100%">
                                          <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                          <%
                                            if(priorities != null){
                                          %>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER">Priorities</span></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="../../../tools/sandf/priorityFilter.jsp"%></td>
                                            </tr>
                                           <%
                                           	 }
                                           %>

                                           <%
                                           	 if(dateMaskExsit){
                                           %>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER">Date and Time</span></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="../../../tools/sandf/dateFilter.jsp"%></td>
                                            </tr>
                                           <%
                                           	 }
                                           %>
                                            <%
                                           	 if(choiceMaskExsit){
                                                  String colName = "";
                                                  String[] allChoice = null;
                                                  ChoiceMask chmask = null;
                                                  ChoiceFilter chFilter = null;
                                                  List fsele = null;

                                                  for(int t=0;t<choiceList.size();++t){
                                                    chmask = (ChoiceMask)choiceList.get(t);
                                                    colName = chmask.getName();
                                                    allChoice = chmask.getChoices();
                                                    chFilter = choice_filters[t];
                                                    fsele = null;
                                                    if(chFilter != null){
                                                      fsele = chFilter.getFilteredValues();
                                                    }
                                            %>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER"><%=colName%></span></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="../../../tools/sandf/choiceFilter.jsp"%></td>
                                            </tr>
                                            <%
                                              }//for
                                             }
                                            %>
                                            <%
                                           	 if(numberMaskExists){
                                            %>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER">Number</span></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="../../../tools/sandf/numberFilter.jsp"%></td>
                                            </tr>
                                            <%
                                             }
                                            %>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER">Text</span></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="../../../tools/sandf/stringFilter.jsp"%></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="../../../tools/sandf/columnSelect.jsp"%></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                          </table>
                                        </td>
                                      </tr>
                                      <tr>
                                        <td width="100%">
                                          <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                            <tr>
                                              <td width="30%">&nbsp;</td>
                                              <td width="40%">
	                                              <table border="0" width="100%" cellspacing="0" cellpadding="0">
		                                              <tr>
				                                            <td width="20%">
				                                            	<%if (newWindow != null){%>
				                                            	&nbsp;
				                                            	<%} else {
				                                            		String cancelQuery = request.getQueryString();
				                                            		if (filterCollectionId != null){
				                                            			cancelQuery = cancelQuery.replaceAll(filterCollectionId,"none");
				                                            		}
				                                            	%>
				                                            	<a href="../TransView.jsp?<%=cancelQuery%>" class="LINK">cancel
				                                            	<%}%>
																										</td>
				                                            <td width="20%"><a href="javascript:doApply('false')" class="LINK">save</a></td>
				                                            <td width="20%"><a href="javascript:doApply('true')" class="LINK">apply</a></td>
			                                              <td width="20%"><a href="javascript:openHelp('<%=BASE_DIRECTORY%>','Filter.htm')" class="LINK">help</a></td>
		                                              </tr>
	                                              </table>
                                              </td>
                                              <td width="30%">&nbsp;</td>
                                            </tr>
                                          </table>
                                        </td>
                                      </tr>
                                    </table>
                                  </td>
              					</tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
    </table>
</form>
<%
  if(dateMaskExsit){
%>
<script language="JavaScript">
		<!-- // create calendar object(s) just after form tag closed
			 // note: you can have as many calendar objects as you need for your application
			var cal7 = new calendar2("<%=baseDirectory%>",document.access.<%=DATE_MINIMUM%>,null,<%="/^\\-?\\d+(\\"+millisecondsSeperator+"\\d+)*$/"%>,"<%=millisecondsSeperator%>");
			cal7.year_scroll = true;
			cal7.time_comp = true;
			var cal8 = new calendar2("<%=baseDirectory%>",document.access.<%=DATE_MAXIMUM%>,null,<%="/^\\-?\\d+(\\"+millisecondsSeperator+"\\d+)*$/"%>,"<%=millisecondsSeperator%>");
			cal8.year_scroll = true;
			cal8.time_comp = true;

			function openCal7(){
				document.access.<%=DATE_MIN_FILTER_ACTIVE%>.checked='true';
				cal7.popup();
			}
			function openCal8(){
				document.access.<%=DATE_MAX_FILTER_ACTIVE%>.checked='true';
				cal8.popup();
			}


		//-->
		</script>
<%
  }
%>
