<%@ page language="java"%>

<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
  static SimpleDateFormat dateFormat =  new SimpleDateFormat(Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss"));
%>
<%
	String FILTER_COLLECTION_ID = "filter_collection_id";
  String ERROR_OBJ = "ERROR_OBJ";

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  UserSecurity security = manager.getUserSecurity(request);

	String filterCollectionId = request.getParameter(FILTER_COLLECTION_ID);
	SessionFilterManager sdfmgr = (SessionFilterManager)request.getSession().getAttribute("sessionDataFilterManager");
	FilterCollection filterCollection = sdfmgr.getFilterCollectionById(filterCollectionId);
	if (filterCollection == null){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("No filter for id " + filterCollectionId);
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect("/logeye/common/errorpage.jsp?cancelURL=logic/online/transView.jsp");
    return;
	}
	String filterName = filterCollection.getName();

%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />
<script>
  function operationOk(){
    var path ="removeFilterAction.jsp?<%=FILTER_COLLECTION_ID+"="+filterCollectionId%>";
    document.location = path;
  }
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0" class="LOGICGENERAL">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Operation verification.</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">General</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="22">
                    <span class="REGULARTEXT">                   
                    Click OK to remove the filter - <%=filterName%>
                    </span>
                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="35%">&nbsp;</td>
                <td width="11%" align="center"><a href='javascript:history.go(-1)' class="LINK">cancel</a></td>
                <td width="7%" align="center"><a href='javascript:operationOk()' class="LINK">
                ok</a></td>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>