var currentNodeId = "";
var currentNodeType = "";
var previousNodeId = "";
var isMouseOverNode;
var callsCounter = new Date().getTime();
var xmlHttpRequestObjectMouseOver;
function onMouseOverNode(nodeId, nodeType) {
	isMouseOverNodeData = false;
	window.clearTimeout(hideNodeDataIfNeededTimeoutId);
  isMouseOverNode = true;

  handleCurrentNode(nodeType, nodeId);
	
 	xmlHttpRequestObjectMouseOver = GetXmlHttpObject();
  
  var url = "getNodeData.jsp";
  var parameters = "";
	parameters += "nodeType=" + nodeType;
	parameters += "&nodeId=" + nodeId;
  parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectMouseOver.open("POST", url, true);
  xmlHttpRequestObjectMouseOver.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectMouseOver.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectMouseOver.setRequestHeader("Connection", "close");
  xmlHttpRequestObjectMouseOver.onreadystatechange = onMouseOverNodeCallback;
  xmlHttpRequestObjectMouseOver.send(parameters);
}

function handleCurrentNode(nodeType, nodeId) {
	previousNodeId = currentNodeId;
  currentNodeId = nodeId;
  currentNodeType = nodeType;
  
}
		
function onMouseOverNodeCallback() {
	if (xmlHttpRequestObjectMouseOver.readyState == 4) {
		if (xmlHttpRequestObjectMouseOver.status == 200) {
			if(isMouseOverNode) {
				var xmlDoc = xmlHttpRequestObjectMouseOver.responseXML.documentElement;
				showNodeElements(xmlDoc);
			}
		}
	}
}

function showNodeElements(xmlDoc) {
	var nodeElement = xmlDoc.getElementsByTagName("Node")[0];
	var type = nodeElement.getAttribute("type");
	var x = nodeElement.getAttribute("x");
	var y = nodeElement.getAttribute("y");
	
	var nodeDataDiv = document.getElementById("nodeDataDiv");
	var nodeDataDivInnerHtml = getElementValue(nodeElement);
	var	graphImage = document.getElementById('graphImage');
	var graphImagePosition = findPos(graphImage);
	if(type == 'subTransaction') {
		var nodeDataDivX = graphImagePosition[0] + parseInt(x) + 40;
		var nodeDataDivY = graphImagePosition[1] + parseInt(y) - 60;
		showNodeData(nodeDataDivX, nodeDataDivY, nodeDataDivInnerHtml);
		
		// update the graph mapping
		var mappingElement = xmlDoc.getElementsByTagName("Mapping")[0];
		var mappingStr = getElementValue(mappingElement);
		var subTransactionMap = document.getElementById('subTransactionMap');
		subTransactionMap.innerHTML = mappingStr;
	}else if(type == 'routine') {
		var nodeDataDivX = graphImagePosition[0] + parseInt(x) - 90;
		var nodeDataDivY = graphImagePosition[1] + parseInt(y) - 80;
		showNodeData(nodeDataDivX, nodeDataDivY, nodeDataDivInnerHtml);
	}
}
		
function showNodeData(x, y, nodeDataDivInnerHtml) {
	if(x != 0 && y != 0) {
		var nodeDataDiv = document.getElementById('nodeDataDiv');
		nodeDataDiv.innerHTML = nodeDataDivInnerHtml;
		var nodeDataTable = document.getElementById('nodeDataTable');
		
		var scrollElementX = document.getElementById("scrollElement");
	  x -= scrollElementX.scrollLeft;
		if(x < 0) {
			x = scrollElementX.scrollLeft;
		}else if(nodeDataTable && nodeDataTable.width && x > document.body.clientWidth - nodeDataTable.width) {
			x = document.body.clientWidth - nodeDataTable.width - 20;
		}
		
		nodeDataDiv.style.left = x;
		nodeDataDiv.style.top = y;
		nodeDataDiv.style.display = "";
	}
}

function onMouseOutNode(e) {
	hideNodeDataIfNeededTimeoutId = setTimeout("hideNodeDataIfNeeded()", 1000);
	isMouseOverNode = false;
}

var isMouseOverNodeData = false;
var hideNodeDataIfNeededTimeoutId;
function onMouseOverNodeData() {
	isMouseOverNodeData = true;
}

function onMouseOutNodeData() {
	isMouseOverNodeData = false;
}

function hideNodeDataIfNeeded() {
	if(isMouseOverNodeData) {
		hideNodeDataIfNeededTimeoutId = window.setTimeout("hideNodeDataIfNeeded()", 1000);
	}else {
		hideNodeData();
	}
}

function hideNodeData() {
	var nodeDataDiv = document.getElementById('nodeDataDiv');
	nodeDataDiv.innerHTML = "";
	nodeDataDiv.style.display = "none";
}

function getElementValue(element) {
	var elementValue = "";
	if(document.all) {
		elementValue = element.childNodes[0].nodeValue;
	}else {
		elementValue = element.childNodes[1].nodeValue;
	}
	return elementValue;
}

function findPos(obj) {
	var curleft = 0;
	var curtop = 0;
	if (obj.offsetParent) {
		curleft = obj.offsetLeft;
		curtop = obj.offsetTop;
		while (obj = obj.offsetParent) {
			curleft += obj.offsetLeft;
			curtop += obj.offsetTop;
		}
	}
	return [curleft, curtop];
}