<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.routine.data.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.ui.site.*"%>

<%!

  static final String BASE_DIRECTORY = "../../";
  public String transformDateToString(Date d){
    if(d == null){
      return null;
    }
    //01/31/2003 01:42:34
    String format = "MM/dd/yyyy HH:mm:ss";
    String str = new SimpleDateFormat(format).format(d);
    return str;
  }
%>
<%
  String ERROR_OBJ = "ERROR_OBJ";
  String OP = "OP";
  String ADD = "ADD";
  String TYPE_LOG = "Log";

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  UserSecurity user = manager.getUserSecurity(request);

  String routineId = request.getParameter("routine_id");
  String tranId = request.getParameter("runtime_tran_id");
 
	LogicEnvironment logicEnv = LogicEnvironment.getLogicEnvironment(request);
  String sessionRuntimeId = logicEnv.getSessionRuntimeId();
	DataSessionRuntime dsr = null;
	if (sessionRuntimeId != null && !sessionRuntimeId.equals("")){
		dsr = CtrlMgr.getInstance().getDataSessionRuntimeById(sessionRuntimeId);
	}
	if (dsr == null){
		dsr = new DataSessionRuntime();
		dsr.setId(DataSession.ONLINE_DATA_SESSION_ID);
	}
  TransactionTypeViewModel model = TransactionTypeViewModelFactory.createTransactionTypeViewModel(dsr);
  Transaction tran = model.getTransactionById(tranId);
 
  Routine []  routines = null;;
  List data = new ArrayList();
  String graphImg = null;
  String tranName = "";
  if(tran != null){
  	routines = model.getAllRealRoutines(tran,routineId);
  	data = model.getDataMessageForRoutines(routines);
  	tranName = tran.getTransactionParadigm().getName();
  }else {
    routines = new Routine[0];
  }

  String paradigmId = tran.getTransactionParadigmID();
  String charset = TransactionTypeViewModel.getCharSetForTransactionParadigm(paradigmId);
  if (charset != null){
    response.setContentType("text/html; charset=" + charset);
  }
%>
 
<html>

<head>
<%if (charset != null){ %>
  <meta http-equiv="Content-Type" content="text/html; charset=<%=charset%>">
<%}else{ %>
  <meta http-equiv="Content-Language" content="en-us">
<%}%>
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<Title>Transaction Messages Details</title>
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />
</head>
<body><form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" class="LOGIC_MAIN_TABLE">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
              <tr>
                <td colspan="2" nowrap><span class="PAGEHEADER">Transaction Details</span></td>
                <td width="50%">&nbsp;</td>
              </tr>
               <tr>
                <td>&nbsp;</td>
                <td>&nbsp;</td>
                <td>&nbsp;</td>
              </tr>
              <tr>
                <td width="100%" valign="top" nowrap colspan="3">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
                  <tr>
                    <td width="100%" ><span class="HEADER">Transaction Flow for type: <%=tranName%> with id (<%=tranId%>)</span></td>
                  </tr>
                  <tr>
                    <td width="100%">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
                      <tr class="TABLES_HEADERS">
                        <td width="200"><span class="REGULARTEXT">Name</span></td>
                        <td width="150"><span class="REGULARTEXT">Time</span></td>
                        <td width="*" class="REGULARTEXT" align="center">Data</td>
                        <td width="20" class="REGULARTEXT">&nbsp;</td>
                      </tr>
                      <%
                      	for (int i = 0; i < routines.length; i++) {
                      	Routine rout = routines[i];
					  %>
                      <tr>
                        <td width="200" class="SMALLTEXT" valign="top"><%=rout.getRoutineParadigm().getName()%></td>
                        <td width="150" class="SMALLTEXT" valign="top"><%=transformDateToString(new Date(tran.getCreatedTimeStamp()))%></td>
                        <td width="*" class="SMALLTEXT" align="right"><TEXTAREA rows="10" cols="63" ><%=data.get(i).toString()%></TEXTAREA></td>
                        <td width="20" class="SMALLTEXT">&nbsp;</td>
                      </tr>
                      <%
                      }
                      %>
                    </table>
                   </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="35%">&nbsp;</td>
                    <td width="11%" align="center">&nbsp;</td>
                    <td width="7%" align="center">
                     &nbsp;</td>
                    <td width="27%">&nbsp;</td>
                    <td width="20%">&nbsp;</td>
                  </tr>
                </table>
            </td>
          </tr>
        </table>
        </td> 
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
     
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>