<%@ page language="java" %> 
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="omega.ui.models.*"%>
<%@ page import="xpolog.eye.logic.TransactionLogOHtmlTable"%>
<%@ page import="xpolog.logic.ui.site.*"%>
<%@ page import="java.util.*"%>



<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%

  String CURRENT_LOG = "CURRENT_LOG";
  String ERROR_OBJ = "ERROR_OBJ";
  String CURRENT_LOG_QUERY_INFO = "CURRENT_LOG_QUERY_INFO";
  int ALLOWED_LOG_NAME_LENGTH = 30;
  //getting the managment
  SiteManagment mgmt = SiteManagment.getInstance();

  LogViewQueryInfo queryInfo = (LogViewQueryInfo)request.getSession().getAttribute(CURRENT_LOG_QUERY_INFO);
  LogBrowsingManager man = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  if (queryInfo == null || man == null){
	%> <html><body bgcolor="#FFFFFF"></body></html> <%
	return;
  }
	  
  String applic = request.getParameter("applic");
  String detailsJsp = (applic == null ? "transdetails.jsp" : BASE_DIRECTORY+"applications/retalix/transdetails.jsp");
  String refreshStr = request.getParameter("refresh");
  
  int leapsize =  queryInfo.leapsize;
  String op = queryInfo.op;
  String search = queryInfo.search;
  String mark = queryInfo.mark;
  boolean isRegExp = queryInfo.isRegExp;
  if (search != null){
  	search = search.replaceAll("&quot;","\"");
  }
  
  String updateStr = request.getParameter("update");
  boolean update = updateStr != null && updateStr.equals("true");
  
   //do sorting check
  String sortIndex = request.getParameter("sortIndex");
  if(sortIndex == null || sortIndex.trim().length() == 0){
    sortIndex = "-1";
  }else {
    op = "CURRENT";
  }
   
  SortingManager sortman = man.getSortingManager();
  int index = -1;
  try{
    index = Integer.parseInt(sortIndex.trim());
  }catch(Exception e){   
  }
  if(index == -1){
    sortman.cancelSort();
  }else{
    sortman.doSort(index);
  }
    
  boolean next = false;
  boolean prev = false;
  boolean current  = false;
  DataReferenceBuilder dfBuilder = null;
  RecordsMaskTableModel RMModel = null;  
  boolean refresh = refreshStr != null && refreshStr.equals("true");
  LogEyeModel model =  refresh || queryInfo.isUsed? man.getLogEyeModel() : null;
  if (update){
    op = "CURRENT";
    model = null;
  }

  try{	
	  if (model == null){	  	
	  	
	    if(op.equalsIgnoreCase("NEXT")){
	      next = true;
	      RMModel = man.getNextEntries(leapsize,search,isRegExp);
	    }else if(op.equalsIgnoreCase("PREV")){
	      prev = true;
	      RMModel = man.getPrevEntries(leapsize,search,isRegExp);
	    }else if(op.equalsIgnoreCase("CURRENT")){
	      current = true;
	      RMModel = man.getCurrentEntries(leapsize,search,isRegExp);
	    }else if(op.equalsIgnoreCase("LAST")){
	      current = true;
	      RMModel = man.getLastEntries(leapsize,search,isRegExp);
	    }else if(op.equalsIgnoreCase("START")){
	      current = true;
	      RMModel = man.getFirstEntries(leapsize,search,isRegExp);
	    }else if(op.equalsIgnoreCase("ZOOM_IN")){
	      RMModel = man.getZoomInEntries(leapsize,queryInfo.zoomInKey);
	      search = null;
	    }else if(op.equalsIgnoreCase("TAIL")){
	      RMModel = man.getLastEntries(leapsize);
	      search = null;
	    }else if(op.equalsIgnoreCase("LAST_FILTER_VIEW")){
	      RMModel = man.getLastFilterEntries(leapsize);
	    }else if(op.equalsIgnoreCase("MOVE")){
	      RMModel = man.getMoveEntries(leapsize,queryInfo.moveSteps);
	    }else if(op.equalsIgnoreCase("GOTO")){
	      dfBuilder = (DataReferenceBuilder)request.getSession().getAttribute("lastDataReferenceBuilder");      
	      String key = dfBuilder.getReferenceKey();
	     if (key == null){
	       current = true;
	       RMModel = man.getCurrentEntries(leapsize,search,isRegExp);
	     }else {
	       RMModel = man.getGoToEntries(leapsize,key);
	     }
	    }
	    model = man.getLogEyeModel(BASE_DIRECTORY,RMModel);
	    queryInfo.isUsed = true;
	  }
  }catch(Exception e){
  	e.printStackTrace();
  	ErrorModel errModel = new ErrorModel();
  	errModel.addError("During data processing the following error occurred:");
  	if(e.getMessage() == null || e.getMessage().equals("")){
  		errModel.addError(e.getClass().toString());
  	}else{
  		errModel.addError(e.getMessage());
  	}
  	errModel.addError("Please verify the remote host is running and available.");
  	request.getSession().setAttribute(ERROR_OBJ,errModel);
  	out.println("<html><head><script>");
  	out.println("parent.document.location='../common/errorpage.jsp'");
  	out.println("</script></head><body></body></html>");
  	out.flush();
  	return;
  }
  
  if (dfBuilder == null){
    dfBuilder = LogEyeHelper.getDataReferenceBuilder(man);
  }
   
  if (dfBuilder != null){
    request.getSession().setAttribute("lastDataReferenceBuilder",dfBuilder);
  }else {
    request.getSession().removeAttribute("lastDataReferenceBuilder");
  }
  
   String title = "";

  if (model != null){
    String str = model.getRecordsMaskTableModel().getTitle();
    if (str != null){
      title = str;
    }
  }
  int endIndex = 0;
  int logNameLength = man.getName().length();
  int titleLength = title.lastIndexOf("(");
  String tempTitle = null;
  if(titleLength>ALLOWED_LOG_NAME_LENGTH && logNameLength>ALLOWED_LOG_NAME_LENGTH) {
  	//both names lengths are larger then 30 we cut title.
  	tempTitle = title.substring(title.lastIndexOf("("),title.length());
  	//check if the char at index ALLOWED_LOG_NAME_LENGTH are before the (%) or after it
  	if(ALLOWED_LOG_NAME_LENGTH < titleLength) {
  		title = title.substring(0,ALLOWED_LOG_NAME_LENGTH)+"..."+tempTitle;
  	}else {
  		endIndex = titleLength-1;
  		title = title.substring(0,endIndex)+"..."+tempTitle;
  	}
  }else if(titleLength>ALLOWED_LOG_NAME_LENGTH && !(logNameLength>ALLOWED_LOG_NAME_LENGTH)) {
  	//only title name is more then 30 chars, we allow 60 chars.
  	tempTitle = title.substring(title.lastIndexOf("("),title.length());
  	if(titleLength>(2*ALLOWED_LOG_NAME_LENGTH)) {
	  	//check if the char at index ALLOWED_LOG_NAME_LENGTH are before the (%) or after it
	  	if(2*ALLOWED_LOG_NAME_LENGTH < titleLength) {
	  		title = title.substring(0,2*ALLOWED_LOG_NAME_LENGTH)+"..."+tempTitle;
	  	}else {
	  		endIndex = titleLength-1;
	  		title = title.substring(0,endIndex)+"..."+tempTitle;
	  	}
  	}
  }
    
   /**
   * manage messages
   */
   String SearchMessage = "";
   String searchDefinition = man.getSearchAndFilterDef();
   if(searchDefinition != null && searchDefinition.length() > 0) {
   		if(searchDefinition.equals("START")) {
    		SearchMessage = "from the beginning of the file";
   		}else {
   			SearchMessage = "on current view only";
   		}
   }
   boolean isMessage = false;
   String displayMessage = "";
   if(model.getRowCount() == 0){
    if(next){
      isMessage = true;
      displayMessage = "End Of Log";
    }else if(prev){
      isMessage = true;
      displayMessage = "Beginning Of Log";
    }else if(current){
      isMessage = true;
      displayMessage = "No Records To Display " + SearchMessage;
    }
   }
   
   SearchManager searchManager = new SearchManager(mark);
   if (mark == null || mark.trim().length() == 0 && search != null){
     searchManager = new SearchManager(search,isRegExp);
   }

  //html creation
  TransactionLogOHtmlTable tab = new TransactionLogOHtmlTable(model,BASE_DIRECTORY);
  
  tab.setID("logviewTable");
  LogEyeCellRenderer cr = man.getCellRenderer(model,searchManager);
  LogEyeRowRenderer rr = man.getRowRenderer(model);
  tab.setRowRenderer(rr);
  tab.setCellRenderer(cr);
  tab.render();
  String html = tab.getHtml();
  
  String charset = man.getCharset();
  if (charset != null){
    response.setContentType("text/html; charset=" + charset);   
  }
  
  Properties prop = Configuration.getInstance().getUIData(); 
  String minusImg = BASE_DIRECTORY + prop.getProperty("logview.minus.image");
  String plusImg = BASE_DIRECTORY + prop.getProperty("logview.plus.image");
  

%>
<html> 
<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/logview.css" />
<script>
 var posX = 100;
    var posY = 100;
	function hideOrShow(divid){
		if(layerSetup(divid).style.display == 'none'){
		 posX=posX++;
		 posY=posY++;
		 showDiv(divid,posX,posY);
		}else{
		 hideDiv(divid);
		}

	}
	function layerSetup(id) {
		theObj = document.getElementById(id);
		return theObj;
	}
	function getHeight(id) {
		theHeight = layerSetup(id).offsetHeight;
		return theHeight;
	}
	function showDiv(id,posX,posY) {
		layerSetup(id).style.display = 'block';
		layerSetup(id).style.left = parseInt(posX);
		layerSetup(id).style.top = parseInt(posY);
		layerSetup("im" + id).src = "<%=minusImg%>";
	}
	function hideDiv(id) {
		layerSetup(id).style.display = 'none';
		layerSetup("im" + id).src = "<%=plusImg%>";
	}
	
	  var oldtr;
	function setRowInFocus(tr){
		reset();
                color = 'black';
                style = 'solid';
                lwidth = '1';
		oldtr = tr;
		tdlist = tr.getElementsByTagName("td");
		for(i =0; i<tdlist.length;++i){
                        if(tdlist[i].parentNode != tr){
                          continue;
                        }
			if(i==0){
				tdlist[i].style.borderLeftStyle = style;
				tdlist[i].style.borderLeftWidth = lwidth;
				tdlist[i].style.borderLeftColor = color;
			}else if(i==tdlist.length-1){
				tdlist[i].style.borderRightStyle = style;
				tdlist[i].style.borderRightWidth = lwidth;
				tdlist[i].style.borderRightColor = color;

			}
			tdlist[i].style.borderBottomStyle = style;
			tdlist[i].style.borderTopStyle = style;
			tdlist[i].style.borderBottomWidth = lwidth;
			tdlist[i].style.borderTopWidth = lwidth;
			tdlist[i].style.borderBottomColor= color;
			tdlist[i].style.borderTopColor= color;
		}
	}

	function reset(){
		if(!oldtr){
			return;
		}
		tdlist = oldtr.getElementsByTagName("td");
		for(i =0; i<tdlist.length;++i){
			if(i==0){
				tdlist[i].style.borderLeftStyle='';
			}else if(i==tdlist.length-1){
				tdlist[i].style.borderRightStyle='';
			}
			tdlist[i].style.borderBottomStyle = '';
			tdlist[i].style.borderTopStyle = ''
		}

	}


function doSort(index){
  document.access.sortIndex.value = "" + index;
  document.access.submit();
}

function doCancelSort(){
  document.access.sortIndex.value = "-1";
  document.access.submit();
}

function zoomIn(key){
   if (parent){
    parent.zoomIn(key);
  }
}

function createNewDataRefBuilder(){
  return parent.createNewDataRefBuilder();
}

function goToTransDetails(tid){
	url = "<%=detailsJsp%>?transId="+tid;
	detWindow = window.open(url,'detailsWindow','top=300,left=30,height=200,width=700,toolbar=no,resizable=yes,menubar=no,scrollbars=yes,location=no')
	detWindow.focus();
}

function goToTransDetails__(tid){
	if (currentTrandId == tid){
		document.getElementById("transDetails").style.display = "none";
	}else{
		currentTrandId = tid;
		document.getElementById("transDetails").style.display = "";
		frames['transDetailsView'].location = "<%=detailsJsp%>?transId="+tid;
	}
}

function hideDetailsFrame(){
	document.getElementById("transDetails").style.display = "none";
}

<%
buildGoToStrcuture(dfBuilder,out,0,0);
%>

<%!
  private static void buildGoToStrcuture(DataReferenceBuilder builder,JspWriter out,int index,int y) throws java.io.IOException{

    String tmpDataSource = "tmpDataSource_" + index + "_" + y;
    if (index == 0){
      tmpDataSource = "parent.rootDataSource";
    }else {
      out.println("var " + tmpDataSource + "= createNewDataRefBuilder();");
    }
    if (builder == null) return;
    for (int i = 0; i < builder.getReferencesCount(); i++) {
      out.println(tmpDataSource + ".keys[" + i + "]=\"" + builder.getReferenceKeyAt(i) + "\";");
      buildGoToStrcuture(builder.getDataReferenceBuilderAt(i),out,index + 1,i);
      out.println(tmpDataSource + ".builders[" + i + "]=tmpDataSource_" + (index+1)+ "_" + i + ";");
    }
    out.println(tmpDataSource + ".title=\"" + builder.getTitle() + "\";");
    out.println(tmpDataSource + ".selectedIndex=" + builder.getSelectedIndex() + ";");

  }
%>
</script>
</head>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" action="translogrecords.jsp">
<input type="hidden" name="sortIndex" value="-1">
<input type="hidden" name="update" value="true">
</form>

<form name="showTransDetails" id="showTransDetails" method="post" action="transdetails.jsp" target="detailsWindow">
	<input type="hidden" name="transId">
</form>

<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="95%">
	<!--
	<tr>
		<td>
			<table id="transDetails" style="display:none" width="100%" height="150">
				<tr>
					<td><iframe name="transDetailsView" src="" width="100%" height="100%" FrameBorder="0" hspace="0" vspace="0" MarginHeight="0"></iframe></td>
				</tr> 
			</table>
		</td>
	</tr>
	-->

	<tr><td valign="top" <%=isMessage?"height=\"20\"" : ""%>>
		<%=html%>
	</td></tr>

    <%if(isMessage){%>
    <tr><td valign="top" height="*">
    	<span class="HEADER">- <%=displayMessage%> -</span>
	</td></tr>
    <%}%>
<table>

<script>
var title = "<%=title%>"
</script>
</body>
</html>