<%@page import="xpolog.logic.reports.agg.admin.TranAggFunctionBuilder"%>
<%@page import="xpolog.logic.ui.aggregators.admin.TransactionAggregationConf"%>
<%@page import="xpolog.logic.reports.agg.admin.TranAggCaseBuilder"%>
<%@page import="xpolog.logic.reports.agg.admin.TranReportBuilder"%>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page import="xpolog.eye.meta.MetaData"%>
<%@ page import="xpolog.eye.data.aggregate.admin.ExpressionAggConf"%>
<%@ page import="xpolog.eye.data.aggregate.admin.DataExpressionAggConf"%>
<%@ page import="xpolog.eye.data.aggregate.admin.SimilarityAggConf"%>
<%@ page import="xpolog.eye.data.aggregate.admin.KnowledgeAggConf"%>
<%@ page import="xpolog.eye.data.aggregate.admin.LogAggregationConf"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%@ include file="../../../tools/sandf/dateFilterAction.jsp"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
  String ERROR_OBJ = "ERROR_OBJ";
  String REPORT_BUILDER = "REPORT_BUILDER";
  
  String doSaveStr = request.getParameter("doSave");  
  boolean doSave = doSaveStr != null && doSaveStr.equalsIgnoreCase("true");
  
  ErrorModel errmodel = new ErrorModel();
  
  AbstractReportBuilder abstractBuilder = (AbstractReportBuilder)  request.getSession().getAttribute("REPORT_BUILDER");
  if(!(abstractBuilder instanceof AggReportBuilder)) {
  	errmodel.addError("Report is no longer valid, please click the 'Back to Reports' button and try again");
  }
  
  TranReportBuilder builder = null;
  boolean doGenerate = false;
  if(errmodel.getErrorCount() == 0) {
	  builder = (TranReportBuilder)abstractBuilder;
	  if (builder == null){
	  	errmodel.addError("No Report in session.Please try to create report again.");
	  }
	  	 
	  String op = builder == null ? "" : builder.getOp();
	  doGenerate = op.equalsIgnoreCase("generate");
	  
	  String parentApplication =  request.getParameter("parentApplication");
	  if (parentApplication == null){
	  	parentApplication = "";
	  }
	  
	  AggBuilderHelper.updateBasicBuilderFromRequest(builder,request,errmodel,doGenerate);
	  
	  RecordMask mask = new RecordMask();
	  DateMask dateMask = new DateMask("MM/dd/yyyy HH:mm:ss");
	  MaskColumn[] cols = {dateMask};
	  mask.setColumns(cols);
	  FilterCollection fc = null;
	  //create the date and number filter
	  builder.setTimeRule(null);
	  try {
	  	DateFilter dfilter = createDateFilter(request,response,mask);
	  
	  	if(dfilter != null) {
	  		fc = new FilterCollection();
	  		fc.setName(builder.getName()+"_fc");
		  	fc.setId(System.currentTimeMillis()+"_fc");
		  	fc.addFilter(dfilter);
		  	builder.setTimeRule(fc);
	  	}
	  }catch(Exception e) {	  
		  errmodel.addError("Invalid time rule. Please make sure the time rule is valid and try again");	  
	  }
	  
		AggBuilderHelper.updateSchedBuilderFromRequest(builder,request,errmodel,doGenerate);
	  
	  if (builder.getDefaultTransactionParaigmId() == null || builder.getDefaultTransactionParaigmId().length() == 0){
	    errmodel.addError("No transaction was selected");
	   }
		
	  
	  
	  //Report types
	  try {
	  	
	  	String group = builder.getDefaultTransactionParaigmId();
	  	String[] datafilterIds = request.getParameterValues("To_Select_filtersReportTypeAdvanced");
			builder.setDataFilters(datafilterIds);  			
	  	String resultsToDisplayStr = request.getParameter("advancedMaxResults");
	  	AggCaseDisplayRule displayRule = null;
	  	if (resultsToDisplayStr != null && resultsToDisplayStr.length() > 0) {
	  		int resultsToDisplay = -1;
	  		try {
	  			resultsToDisplay = Integer.parseInt(resultsToDisplayStr);
	  			displayRule = new AggCaseDisplayRule();
	  			displayRule.setResultsToDisplay(resultsToDisplay);
	  		} catch (Exception e) {
	  			errmodel.addError("Invalid max results value");  			
	  		}
	  	}
			builder.setDisplayRule(displayRule);
	  	builder.clearReportTypes();
	 		// Filter report type  
			String suffix = AggReportBuilder.TRAN_CASE_TYPE;
			String checkboxStr = request.getParameter("reportTypeChk" + suffix);
			boolean isCheck = checkboxStr != null && checkboxStr.equals("true");
	
			if (isCheck) {				
				boolean success = true;
				String[] filetrsIds = request.getParameterValues("To_Select_filters" + AggReportBuilder.TRAN_CASE_TYPE);
				boolean isSubTimeFilter = false;
				if (filetrsIds != null && filetrsIds.length > 0) {					
					for (int i = 0; i < filetrsIds.length; i++) {
						if (filetrsIds[i].startsWith("*TimeFilter*")) {
							filetrsIds[i] = filetrsIds[i].substring(12);
							isSubTimeFilter = true;
						}
					}
				}
	
				if (filetrsIds == null || filetrsIds.length == 0) {
					errmodel.addError("No filter was selected.");
					success = false;
				}
	
				if (success) {
					TranAggCaseBuilder[] filterBuilders = null;
					ArrayList list = new ArrayList();
					TranAggCaseBuilder caseBuilder = null;
					if (filetrsIds.length == 1) {
						filterBuilders = new TranAggCaseBuilder[] { caseBuilder };
						list.add(filetrsIds);
					} else if (filetrsIds.length > 1) {
						filterBuilders = new TranAggCaseBuilder[filetrsIds.length];
						for (int i = 0; i < filterBuilders.length; i++) {
							list.add(new String[] { filetrsIds[i] });
						}
					}
	
					for (int i = 0; i < filterBuilders.length; i++) {
						caseBuilder = filterBuilders[i];
						if (caseBuilder == null) {
							caseBuilder = new TranAggCaseBuilder();
	
							AggCaseDefinition def = new AggCaseDefinition();
							def.setName("FILTERS_NAME");
							def.setDesc("");
							def.setType(AggReportBuilder.TRAN_CASE_TYPE);
							def.setGroup(group);
							def.setId(AggBuilderHelper.createCaseBuilderId(def));
							caseBuilder.setCaseDef(def);
						}
						filterBuilders[i] = caseBuilder;
	
						caseBuilder.getCaseDef().setGroup(group);
						caseBuilder.setProjectId(builder.getDefaultProjectId());
						caseBuilder.setTransactionParaigmId(builder.getDefaultTransactionParaigmId());
	
						TransactionAggregationConf conf = new TransactionAggregationConf();
						conf.setProjectId(builder.getDefaultProjectId());
						conf.setTransactionParaigmId(builder.getDefaultTransactionParaigmId());
						conf.setTotal(true);
						conf.setDayDis(false);
						conf.setHourDis(false);
						conf.setMinDis(false);
	
						filetrsIds = (String[]) list.get(i);					
						if (filetrsIds != null && filetrsIds.length > 0 && !(filetrsIds.length == 1 && filetrsIds[0].equals("allRecords"))) {
							conf.setDataFilters(filetrsIds);						
						}
						conf.setFilters(new String[] { "" });
						conf.setFilters(true);
						caseBuilder.setAggConf(conf);
						caseBuilder.setDataFilters(filetrsIds);
						//caseBuilder.setUseInMerge(!isSubTimeFilter);
	
						AggBuilderHelper.updateAggCaseBuilderNames(caseBuilder, filetrsIds);
						builder.addReportTypeBuilder(caseBuilder);					
					}
				}
			}
			
			//function report type
			suffix = AggReportBuilder.TRAN_FUNCTION_TYPE;
			checkboxStr = request.getParameter("reportTypeChk" + suffix);
			isCheck = checkboxStr != null && checkboxStr.equals("true");
	
			if (isCheck) {			
				boolean success = true;
				TranAggFunctionBuilder caseBuilder = new TranAggFunctionBuilder();
	
				AggCaseDefinition def = new AggCaseDefinition();
				def.setName("Custom");
				def.setDesc("");
				def.setType(AggReportBuilder.TRAN_FUNCTION_TYPE);
				def.setGroup(group);
				def.setId(AggBuilderHelper.createCaseBuilderId(def));
				caseBuilder.setCaseDef(def);
	
				caseBuilder.getCaseDef().setGroup(group);
				caseBuilder.setProjectId(builder.getDefaultProjectId());
				caseBuilder.setTransactionParaigmId(builder.getDefaultTransactionParaigmId());

	
				if (success) {
					TransactionAggregationConf conf = new TransactionAggregationConf();
					conf.setProjectId(builder.getDefaultProjectId());
					conf.setTransactionParaigmId(builder.getDefaultTransactionParaigmId());
					conf.setTotal(true);
					conf.setDayDis(false);
					conf.setHourDis(false);
					conf.setMinDis(false);

	
					if (datafilterIds != null && datafilterIds.length > 0) {
						conf.setDataFilters(datafilterIds);
					}
					conf.setFilters(new String[] { "" });
					conf.setFilters(true);
					caseBuilder.setAggConf(conf);
					caseBuilder.setDataFilters(datafilterIds);
					caseBuilder.setDisplayRule(displayRule);
	
					TranAggFunctionBuilder tmpBuilder = builder.getTempTranFunctionCaseBuilder();
					if (tmpBuilder != null) {
					  if (tmpBuilder.getExpressionsAggConf() != null){
					    ArrayList list = new ArrayList(Arrays.asList(tmpBuilder.getExpressionsAggConf()));
						  caseBuilder.setExpressions(list);
					  }
						caseBuilder.setFunctionsInfo(tmpBuilder.getFunctionsInfo());
						caseBuilder.setTemplatesIds(tmpBuilder.getTemplatesIds());
					}
	
					if (caseBuilder.getExpressionsAggConf().length == 0) {
						errmodel.addError("No function was added.");					
						success = false;
					}
	
					if (success) {
						DataExpressionAggConf [] confs = caseBuilder == null ? null : caseBuilder.getExpressionsAggConf();
						ExpressionAggConf eaConf = new ExpressionAggConf();
						ArrayList list = new ArrayList(Arrays.asList(confs));
						eaConf.setExpressionsConf(list);
						conf.setExpressionConf(eaConf);
						conf.setExpression(true);
						  
						builder.addReportTypeBuilder(caseBuilder);
					}
				}
	
			}
	  	
	  }catch (Exception e){
	  	e.printStackTrace();
	  }
	  
	  AggBuilderHelper.updateSecurityBuilderFromRequest(builder,request,errmodel,doGenerate);
  }
  
  //save reports issues
  if(errmodel.getErrorCount() != 0){
  //errors
		String[] errors = errmodel.getErrors();
		StringBuffer sb = new StringBuffer();
		for (int i=0; i<errors.length; i++){
			if (sb.length() > 0){
				sb.append("*;*");
			}
			sb.append(errors[i]);
		}
		String message = sb.toString();
		//params
		String[] params = errmodel.getErrorParams();
		sb = new StringBuffer();
		for (int i=0; i<params.length; i++){
			if (sb.length() > 0){
				sb.append("*;*");
			}
			sb.append(params[i]);
		}
		String paramsList = sb.toString();
		String xml = GridModelActionsHelper.getResultXML(false, message, paramsList);
		
		response.setContentType("text/xml");
		response.setHeader("Pragma-Control", "no-cache");
		response.setHeader("Cache-Control", "no-cache");
		response.setHeader("Expires", "0");
		out.write(xml);
		out.flush();
  }else {
	  if (!doGenerate){
	     request.getSession().setAttribute(REPORT_BUILDER,builder);
	     if (doSave){
	    	 
	    	 String [] appIds = null;//parentApplication.split("\\#");
	    	 String logId = builder.getDefaultLogId();
	    	  if (logId != null && logId.length() > 0){
	    			HashSet apps = SiteManagment.getInstance().getMetaDataMgr().getMetaDatasByXplgObject(XpoLogObjectTypes.LOG_TYPE, logId, true);
	    			if (apps != null){
	    				List list = new LinkedList();
	    				Iterator it = apps.iterator();
	    				MetaData md = null; 
	    				while (it.hasNext()){
	    					md = (MetaData)it.next();
	    					if (md != null && md.getId() != null){
	    						list.add(md.getId());
	    					}
	    				}
	    				appIds = (String[])list.toArray(new String[list.size()]);
	    			}
	    			 
	    		}
	    	  builder.setApplicationsIds(appIds);
	    	 
	    	 String saveAndGenerateStr = request.getParameter("saveAndGenerate");
	     	 boolean saveAndGenerate = saveAndGenerateStr != null && saveAndGenerateStr.equals("true");
	     	 if (saveAndGenerate){
	     		response.sendRedirect(BASE_DIRECTORY + "reports/agg/aggReportSaveAction.jsp?doGenerate=true");
	     	 }else {
	  	     response.sendRedirect(BASE_DIRECTORY + "reports/agg/aggReportSaveAction.jsp");
	     	 }
	     }else {
	       response.sendRedirect(BASE_DIRECTORY + "reports/agg/aggCasesView.jsp");
	     }
	  }else {
	  	Report rep = builder.buildReport();
	  	request.getSession().setAttribute("report", rep);
	  	response.sendRedirect(BASE_DIRECTORY + "reports/reportRuntimeGenerate.jsp");
	  }
  }
%>
