<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@page import="xpolog.eye.data.util.functions.*"%>
<%@ page import="xpolog.logic.reports.agg.admin.*"%>
<%@page import="xpolog.logic.ui.aggregators.admin.*"%>
<%@page import="xpolog.logic.routine.data.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!static final String BASE_DIRECTORY = "../../../";

	%>
<%String ERROR_OBJ = "ERROR_OBJ";

			ErrorModel ermod = new ErrorModel();
			AggReportBuilder builder = (AggReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");

			if (builder == null) {
				ermod.addError("Session is not valid any more. Please try again");
			}

			if (ermod.getErrorCount() != 0) {
				request.getSession().setAttribute(ERROR_OBJ, ermod);
				response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
				return;
			}

			TranAggFunctionBuilder caseBuilder = (TranAggFunctionBuilder) builder.getCurrentCaseBuilder();
			
			//site management  

			SiteManagment mgmt = SiteManagment.getInstance();
			SiteAdministrator admin = SiteManagment.getAdminInstance();

			TransactionAggregationConf conf = (TransactionAggregationConf) caseBuilder.getAggConf();

			

			if (ermod.getErrorCount() != 0) {
				request.getSession().setAttribute(ERROR_OBJ, ermod);
				response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
				return;
			}

			
			String [] templates = caseBuilder.getTemplatesIds();
			if (templates == null){
				templates = new String[0];
			}
			
			HashSet tempatesSet = new HashSet();
			for(int i = 0; i < templates.length;i++){
				tempatesSet.add(templates[i]);
			}
			
			DataExpressionAggConf [] expressions = caseBuilder.getExpressionsAggConf();
			
			
			RoutineParadigm  [] selRoutines = null;
			
			//String [] templatesIds = {"tranTimeAvg","tranTimeMax","tranTimeMin","tranCount"};
			DataExpressionManager deMgr = DataExpressionManager.getInstance();
			DataExpressionTemplate [] deTemplates = deMgr.getTemplatesForGroup(DataExpressionConstants.ROUTINE_GROUP);
			ArrayList templatesList = new ArrayList();
			DataExpressionTemplate [] deLogTemplates = deMgr.getTemplatesForGroup(DataExpressionConstants.ROUTINE_DATA_GROUP);
			templatesList.addAll(Arrays.asList(deLogTemplates));
			deLogTemplates = deMgr.getTemplatesForGroup(DataExpressionConstants.LOG_DATA_GROUP);
			templatesList.addAll(Arrays.asList(deLogTemplates));
			deLogTemplates = (DataExpressionTemplate [])templatesList.toArray(new DataExpressionTemplate[templatesList.size()]);
			
			
			RoutineParadigm  [] paradigms = caseBuilder.getParadigms();
			RoutineParadigm selParadigm = paradigms != null && paradigms.length > 0 ? paradigms[0] : null;
			int routineIndex = selParadigm == null ? -1 : 0;
			RecordMask selMask =  selParadigm != null ? caseBuilder.getParadigmDataMask(selParadigm.getId()) : null;
			
			%>

<script>

var functionRoutineTableReq;
var selFuncRoutineIndex = -1;

function getFunctionsRoutineTable(){
  functionRoutineTableReq = GetXmlHttpObject();
  if (!functionRoutineTableReq) return;
  
  document.getElementById('functionRoutineTableTD').style.display = "none";
  document.getElementById('functionRoutineTableTDLoading').style.display = "";
  
            
  var url = "tranFunctionFieldsExpressionsTable.jsp?type=<%=DataExpressionConstants.ROUTINE_GROUP%>";  
  functionRoutineTableReq.onreadystatechange = showFunctionsRoutineTableResult;
  functionRoutineTableReq.open('GET', url, true);
  functionRoutineTableReq.send(null);  
  
}

function showFunctionsRoutineTableResult() {
      if (functionRoutineTableReq.readyState == 4) {
         if (functionRoutineTableReq.status == 200) {
            result = functionRoutineTableReq.responseText;
            document.getElementById('functionRoutineTableTD').innerHTML = result;            
            document.getElementById('functionRoutineTableTDLoading').style.display = "none";
            document.getElementById('functionRoutineTableTD').style.display = "";
         } else {
            alert('There was a problem with the request. - ' + functionRoutineTableReq.status);
         }
      }
   }
   
var functionRoutineEditReq;

function getFunctionsRoutineEdit(functionIndex){
  functionRoutineEditReq = GetXmlHttpObject();
  if (!functionRoutineEditReq) return;
  
  selFuncRoutineIndex = functionIndex;
  document.getElementById('innerFunctionRoutineDiv').innerHTML = "Loading...";
  
  var url = "tranFunctionFieldsExpressionEdit.jsp?type=<%=DataExpressionConstants.ROUTINE_GROUP%>&functionIndex=" + functionIndex;  
  functionRoutineEditReq.onreadystatechange = showFunctionsRoutineEditResult;
  functionRoutineEditReq.open('GET', url, true); 
  functionRoutineEditReq.send(null);  
  
}

function showFunctionsRoutineEditResult() {
      if (functionRoutineEditReq.readyState == 4) {
         if (functionRoutineEditReq.status == 200) {
            result = functionRoutineEditReq.responseText;
            document.getElementById('innerFunctionRoutineDiv').innerHTML = result;            
         } else {
            alert('There was a problem with the request. - ' + functionRoutineEditReq.status);
         }
      }
   }
   
 var functionRoutineApplyReq;

function applyFunctionsRoutineOp(){
  functionRoutineEditReq = GetXmlHttpObject();
  if (!functionRoutineEditReq) return;
  
  var showOverTime = document.getElementById("showOverTimeRoutine").checked ? "true" : "false";
  var parameters = "type=<%=DataExpressionConstants.ROUTINE_GROUP%>&op=apply&functionIndex=" + selFuncRoutineIndex + "&funcName=" + encode( document.getElementById("funcNameRoutine").value) + "&funcExpression=" + encode( document.getElementById("funcExpressionRoutine").value) + "&formatType=" + encode( document.getElementById("formatTypeRoutine").value)  + "&formatName=" + encode( document.getElementById("formatNameRoutine").value)  + "&showOverTime=" + showOverTime ;
  var url = "tranFunctionFieldsExpressionsOperation.jsp";  
  functionRoutineEditReq.onreadystatechange = showFunctionsRoutineApplyResult;
  functionRoutineEditReq.open('POST', url, true);
  functionRoutineEditReq.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  functionRoutineEditReq.setRequestHeader("Content-length", parameters.length);
  functionRoutineEditReq.setRequestHeader("Connection", "close");
  functionRoutineEditReq.send(parameters);  
  
}

function showFunctionsRoutineApplyResult() {
      if (functionRoutineEditReq.readyState == 4) {
         if (functionRoutineEditReq.status == 200) {
            result = functionRoutineEditReq.responseText;
            result = result.replace(/^\s+|\s+$/g, '') ;
            if (result == ""){
              closeFunctionRoutine();
              getFunctionsRoutineTable();
            }else {
              alert(result);
            }
         } else {
            alert('There was a problem with the request. - ' + functionRoutineEditReq.status);
         }
      }
   }
   
var functionRoutineRemoveReq;

function removeFunctionsRoutineOp(index){
  functionRoutineRemoveReq = GetXmlHttpObject();
  if (!functionRoutineRemoveReq) return;
  
  var parameters = "type=<%=DataExpressionConstants.ROUTINE_GROUP%>&op=remove&functionIndex=" + index;
  var url = "tranFunctionFieldsExpressionsOperation.jsp";  
  functionRoutineRemoveReq.onreadystatechange = showFunctionsRoutineRemoveResult;
  functionRoutineRemoveReq.open('POST', url, true);
  functionRoutineRemoveReq.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  functionRoutineRemoveReq.setRequestHeader("Content-length", parameters.length);
  functionRoutineRemoveReq.setRequestHeader("Connection", "close");
  functionRoutineRemoveReq.send(parameters);  
  
}

function showFunctionsRoutineRemoveResult() {
      if (functionRoutineRemoveReq.readyState == 4) {
         if (functionRoutineRemoveReq.status == 200) {
            result = functionRoutineRemoveReq.responseText;
            result = result.replace(/^\s+|\s+$/g, '') ;
            if (result == ""){
              getFunctionsRoutineTable();
            }else {
              alert(result);
            }
         } else {
            alert('There was a problem with the request. - ' + functionRoutineRemoveReq.status);
         }
      }
   }
   
   
function showFunctionRoutineDiv(divElem){    
  showHideLayerInMiddle(divElem,-1,250);
}
   
function addFunctionRoutine(){
  getFunctionsRoutineEdit(-1);  
  showFunctionRoutineDiv("functionRoutineDiv");
    
}

function closeFunctionRoutine(){
  var div = document.getElementById("functionRoutineDiv");  
  if (!div) return;  
  if(div.style.visibility == ""){
    showFunctionRoutineDiv("functionRoutineDiv");
  }   
}

function editFunctionRoutine(functionIndex){
  getFunctionsRoutineEdit(functionIndex);  
  showFunctionRoutineDiv("functionRoutineDiv");
    
}

function removeFunctionRoutine(functionIndex){
  removeFunctionsRoutineOp(functionIndex);  
    
}



var selectRoutineIndex = <%=routineIndex%>;
var routineColumnsReq;

function getRoutineColumns(routineIndex){
  routineColumnsReq = GetXmlHttpObject();
  if (!routineColumnsReq) return;
  
  selectRoutineIndex = routineIndex;
  //document.getElementById('innerFunctionRoutineDiv').innerHTML = "Loading...";
  
  var url = "routineFunctionColumns.jsp?groupType=<%=DataExpressionConstants.ROUTINE_GROUP%>&routineIndex=" + routineIndex;  
  routineColumnsReq.onreadystatechange = showRoutineColumnsResult;
  routineColumnsReq.open('GET', url, true); 
  routineColumnsReq.send(null);  
  
}

function showRoutineColumnsResult() {
      if (routineColumnsReq.readyState == 4) {
         if (routineColumnsReq.status == 200) {
            result = routineColumnsReq.responseText;
            showRoutinesFunctions();
            document.getElementById('routineColumnsDiv').innerHTML = result;            
         } else {
            alert('There was a problem with the request. - ' + routineColumnsReq.status);
         }
      }
   }
   
   function routineChanged(){
     var combo = document.getElementById("Routines");
     
     if (!combo){
       return;
     }
   
     var routineIndex = combo.selectedIndex;
     if (selectRoutineIndex == routineIndex){
       return;
     }
     document.getElementById("routineFunctions").selectedIndex = -1;
     document.getElementById("dataFunctions").selectedIndex = -1;
     getRoutineColumns(routineIndex);
     
   }
   
   
   function showRoutinesFunctions(){
     document.getElementById("dataFunctionsDiv").style.display = "none";
     document.getElementById("rfDiv").style.display = "";
   }
   
   function routineColsChanged(){
     var combo = document.getElementById("routineCols");
     
     if (!combo){
       return;
     }
     
     var colIndex = combo.selectedIndex;
     if (colIndex == -1){
       showRoutinesFunctions();
     }else {
        document.getElementById("rfDiv").style.display = "none";
        document.getElementById("dataFunctionsDiv").style.display = "";
     }
     
     
   }
   
   function getRoutineTemplateFunctionsCombo(){
     var combo = document.getElementById("routineFunctions");
     if (document.getElementById("rfDiv").style.display == "none"){      
       combo = document.getElementById("dataFunctions");
     }
     return combo;
   }
     
   function addRoutinePredefined(){
     var combo = getRoutineTemplateFunctionsCombo();
     if (combo.selectedIndex == -1){
       alert("Please select function.");
       return;
     }
     
     addFunctionsPredefinedRoutineOp(combo);
   }
   
   
   
var functionPredifinedRoutineApplyReq;

function addFunctionsPredefinedRoutineOp(combo){
  functionPredifinedRoutineApplyReq = GetXmlHttpObject();
  if (!functionPredifinedRoutineApplyReq) return;
  
  var routineIds = "";
  var routineIndex = document.getElementById("Routines").selectedIndex;
  if (routineIndex == -1){
    alert("No routine was selected.");
    return;
  }
  
  var dataKeys = "";
  var dataNames = "";
  var routineName = document.getElementById("Routines").options[routineIndex].name;
 
  var colsCombo = document.getElementById("routineCols");
  if (colsCombo.selectedIndex >= 0){
    for (var i = 0; i < colsCombo.options.length;i++){
      if (colsCombo[i].selected){
        dataKeys = dataKeys + colsCombo.options[i].value + ";";
        var name = colsCombo.options[i].name;
        if (!name || name == ""){
          name = " ";
        }
        if (routineName != ""){
          dataNames = dataNames + routineName + " ";
        }
        dataNames = dataNames + name + ";";
      }
    }
  }else {
    dataKeys = "r" + (routineIndex + 1);
    dataNames = "; ;";
  }
  
  var templatesIds = "";
  if (combo.selectedIndex >= 0){
    for (var i = 0; i < combo.options.length;i++){
      if (combo[i].selected){
        templatesIds = templatesIds + combo.options[i].value + ";";
      }
    }
  }
  
  
  
  var parameters = "type=<%=DataExpressionConstants.ROUTINE_GROUP%>&op=addTemplate&functionIndex=-1&dataKeys=" + encode(dataKeys)  + "&dataNames=" + encode(dataNames)  + "&routineName=" + encode(routineName) + "&templatesIds=" + encode(templatesIds);
   
  var url = "tranFunctionFieldsExpressionsOperation.jsp";  
  functionPredifinedRoutineApplyReq.onreadystatechange = showFunctionsPredefiniedRoutineApplyResult;
  functionPredifinedRoutineApplyReq.open('POST', url, true);
  functionPredifinedRoutineApplyReq.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  functionPredifinedRoutineApplyReq.setRequestHeader("Content-length", parameters.length);
  functionPredifinedRoutineApplyReq.setRequestHeader("Connection", "close");
  functionPredifinedRoutineApplyReq.send(parameters);  
  
}

function showFunctionsPredefiniedRoutineApplyResult() {
      if (functionPredifinedRoutineApplyReq.readyState == 4) {
         if (functionPredifinedRoutineApplyReq.status == 200) {
            result = functionPredifinedRoutineApplyReq.responseText;
            result = result.replace(/^\s+|\s+$/g, '') ;
            if (result == ""){
              getFunctionsRoutineTable();
            }else {
              alert(result);
            }
         } else {
            alert('There was a problem with the request. - ' + functionPredifinedRoutineApplyReq.status);
         }
      }
   }
   
   
</script>

<div id="functionRoutineDiv" style="position:absolute;visibility:hidden;height:200;width:450">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid DBDFE2">
	<tr height="10">
		<td align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5"><span class="PROGRESSTEXT">Function</span></td>
	</tr>
	<tr>
		<td style="padding:5">
		<div id="innerFunctionRoutineDiv" style="overflow:auto;width:450;height:180">
		
		</div>
		</td>
	</tr>
	<tr height="10">
		<td align="center" style="padding:2">
		<a class="LINK" href="javascript:closeFunctionRoutine()">close</a>&nbsp;&nbsp;
		<a class="LINK" href="javascript:applyFunctionsRoutineOp()">apply</a></td>
</table>
</div>

<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="53" style="visibility:visible">
<tr>
		<td width="15%" height="18"><span class="HEADER">Predefined Functions</span></td>
	</tr>
	<tr>
		<td><span class="REGULARTEXT">Select the predefined funtions to be added to the report.</span></td>
	</tr>
	<tr height="20">
		<td>
		<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%">
		<tr>
		<td width="100">
		<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%">
		<tr><td style="padding-left:5;padding-bottom:2;padding-top:2"> <span class="REGULARTEXT">Routines</span></td></tr>
		<tr><td>
	<select class="TEXTBOX" size="6" name="Routines" onchange="routineChanged()" style="font-size: 8pt; font-family: Verdana">
							<%for (int i = 0; i < paradigms.length; ++i) {
								String selected = paradigms[i] == selParadigm ? "selected" : "";																							
				%>
							<option value='<%=paradigms[i].getId()%>' <%=selected %>  name='<%=paradigms[i].getName()%>'>(<%="r" + (i+1)%>) <%=paradigms[i].getName()%></option>
							<%}

			%>
						</select>
			</td></tr>
			</table>			
		<td width="100" style="padding-left:10" id="routineColumnsDiv">
		<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%">
		<tr><td style="padding-left:5;padding-bottom:2;padding-top:2"> <span class="REGULARTEXT">Routines Data</span></td></tr>
		<tr><td>
	<select class="TEXTBOX" MULTIPLE size="6" name="routineCols" onChange="routineColsChanged()" style="font-size: 8pt; font-family: Verdana">
							<%
							MaskColumn[] cols = selMask == null ? new MaskColumn[0] : selMask.getMaskColumns();
							
							for (int i = 0; i < cols.length; ++i) {
																																MaskColumn col = cols[i];
																																String colKey = DataExpressionHelper.getTypeForColumn(col) + (i + 1);

				%>
							<option value='<%="r" + (routineIndex + 1) + "->" + colKey%>' name='<%=col.getName()%>'>(<%="r" + (routineIndex + 1) + "->" + colKey%>) <%=col.getName()%></option>
							<%}

			%>
						</select>
</td></tr>
			</table>
		</td>
		<td width="100" style="padding-left:10">
		<div id="rfDiv" >
		<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%">
		<tr><td style="padding-left:5;padding-bottom:2;padding-top:2"> <span class="REGULARTEXT">Routines Functions</span></td></tr>
		<tr><td>
	<select class="TEXTBOX" MULTIPLE size="6" name="routineFunctions" id="routineFunctions" style="font-size: 8pt; font-family: Verdana">
							<%
							
							for (int i = 0; i < deTemplates.length; ++i) {
																																
				%>
							<option value='<%=deTemplates[i].getId()%>'><%=deTemplates[i].getShortName()%></option>
							<%}

			%>
						</select>
						</td></tr>
			</table>
		</div>		
		<div id="dataFunctionsDiv" style="display:none">
		<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%">
		<tr><td style="padding-left:5;padding-bottom:2;padding-top:2"> <span class="REGULARTEXT"><nobr>Data Functions</nobr></span></td></tr>
		<tr><td>
	<select class="TEXTBOX" size="6" MULTIPLE name="dataFunctions" id="dataFunctions" style="font-size: 8pt; font-family: Verdana">
							<%
							
							for (int i = 0; i < deLogTemplates.length; ++i) {
																																
				%>
							<option value='<%=deLogTemplates[i].getId()%>'><%=deLogTemplates[i].getShortName()%></option>
							<%}

			%>
						</select>
						</td></tr>
			</table>
		</div>								

		</td>
		<td width="50">
		<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%">
		<tr><td style="padding-left:20;padding-bottom:2;padding-top:2"> <a class="LINK" href="javascript:addRoutinePredefined()">Add</a></td></tr>
		</table>
		</td>
			<td width="*">&nbsp;</td></tr>			
		</table>
		</td>
	</tr>
	<tr>
		<td>&nbsp;</td>
	</tr>
	
	<tr style="padding-top:5">
		<td><span class="REGULARTEXT"><a href="javascript:addFunctionRoutine()" class="LINK">Add new function</a></span></td>
	</tr>

	<tr>
		<td id="functionRoutineTableTDLoading">
		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
			<tr class="TABLES_HEADERS">
				<td width="50"><span class="REGULARTEXT">Key</span></td>
				<td width="250"><span class="REGULARTEXT">Name</span></td>
				<td width="*"><span class="REGULARTEXT">Function</span></td>
				<td width="150" class="REGULARTEXT">&nbsp;</td>
			</tr>		
			<tr>
			<td colspan="4"><span class="REGULARTEXT">Loading...</span></td>
			</tr>
					</table>
		</td>
		<td id="functionRoutineTableTD" style="display:none">		
		</td>
	</tr>

	<tr>
		<td>&nbsp;</td>
	</tr>
</table>

