
<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.logic.reports.agg.admin.*"%>
<%@page import="xpolog.logic.ui.aggregators.admin.*"%>
<%@page import="xpolog.logic.transaction.data.TransactionParadigm"%>
<%@page import="xpolog.eye.data.util.functions.*"%>
<%@page import="xpolog.eye.reports.agg.result.LogFunctionExpressionInfo"%>



<%!
	static final String BASE_DIRECTORY = "../../../";
%>


<%
  String ERROR_OBJ = "ERROR_OBJ";

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
   ErrorModel ermod = new ErrorModel();
   
   AggReportBuilder builder = (AggReportBuilder)  request.getSession().getAttribute("REPORT_BUILDER");
  
  
  if(builder == null){
    ermod.addError("Session is not valid any more. Please try again");
  }
  
  String statusRuleStr = request.getParameter("statusRule");
  AggCaseStatusRule statusRule = null;
  if (false && statusRuleStr != null && statusRuleStr.equalsIgnoreCase("ON")){
  	statusRule = new AggCaseStatusRule();
  	int ruleType = 0;
  	String ruleTypeStr = request.getParameter("ruleType");
  	if (ruleTypeStr != null && ruleTypeStr.length()>0){
  		try {
  			ruleType = Integer.parseInt(ruleTypeStr);
  		}catch (Exception e){
  			ermod.addError("Invalid rule type. Please try again");
  		}
  	}
  	statusRule.setRuleType(ruleType);
  	long amount = 0;
  	String amountStr = request.getParameter("amount");
  	if (amountStr != null && amountStr.length()>0){
  		try {
  			amount = Long.parseLong(amountStr);
  		}catch (Exception e){
  			ermod.addError("Amount is not valid number. Please try again");
  		}
  	}
  	statusRule.setAmount(amount);
  }
  
  
  TranAggFunctionBuilder caseBuilder = (TranAggFunctionBuilder) builder.getCurrentCaseBuilder();
  DataExpressionAggConf [] confs = caseBuilder == null ? null : caseBuilder.getExpressionsAggConf();
  DataExpressionAggConf [] routineConfs = caseBuilder == null ? null : caseBuilder.getRoutineExpressionsAggConf();
  
  String [] templateIds = request.getParameterValues("predefinedFunctions");
  if (templateIds == null){
  	templateIds = new String[0];
  }
	if((confs ==  null || confs.length == 0) && templateIds.length == 0 && (routineConfs == null || routineConfs.length == 0)){
		ermod.addError("No functions were defined.");
	}
	
	ArrayList statusesList = new ArrayList();
  boolean allStatus = false;
  String [] statuses = request.getParameterValues("status_2");
  
  if (statuses != null && statuses.length > 0){
  	allStatus = statuses.length == 2;
  	StringBuffer buffer = new StringBuffer("2");
  	for(int i = 0; i < statuses.length; i++ ){
  		buffer.append("_");
  		buffer.append(statuses[i]);
  	}
  	statusesList.add(buffer.toString());
  }
  
  statuses = request.getParameterValues("status_4");
  if (statuses != null && statuses.length > 0){
  	allStatus = allStatus && statuses.length == 2;
  	StringBuffer buffer = new StringBuffer("4");
  	StringBuffer buffer1 = new StringBuffer("1");
  	for(int i = 0; i < statuses.length; i++ ){
  		buffer.append("_");
  		buffer1.append("_");
  		String [] statusesKeys = statuses[i].split(";");
  		if (statusesKeys.length > 0 && statusesKeys[0].trim().length() > 0){
    		buffer.append(statusesKeys[0]);
  		}
  		if (statusesKeys.length > 1 && statusesKeys[1].trim().length() > 0){
    		buffer1.append(statusesKeys[1]);
  		}
  	}
  	buffer.append(";");
  	buffer.append(buffer1.toString());
  	statusesList.add(buffer.toString());  	  	
  }
  
  statuses = request.getParameterValues("status_5");
  if (statuses != null && statuses.length > 0){
  	allStatus = allStatus && statuses.length == 2;
  	StringBuffer buffer = new StringBuffer("5");
  	for(int i = 0; i < statuses.length; i++ ){
  		buffer.append("_");
  		buffer.append(statuses[i]);
  	}
  	statusesList.add(buffer.toString());
  }
  
  
  
  if(ermod.getErrorCount() != 0){    
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
    return;
  }
  
  
  caseBuilder.setTemplatesIds(templateIds);
  	
  TransactionAggregationConf conf = new TransactionAggregationConf();
  conf.setProjectId(caseBuilder.getProjectId());
  conf.setTransactionParaigmId(caseBuilder.getTransactionParaigmId());
  conf.setTotal(true);
  conf.setDayDis(false);
  conf.setHourDis(false);
  conf.setMinDis(false);
  
  String[] datafilterIds = request.getParameterValues("To_Select_datafilter");  
  
  ExpressionAggConf eaConf = new ExpressionAggConf();
  ArrayList list = new ArrayList(); 
  
  String [] ids = caseBuilder.getTemplatesIds();
	
  DataExpressionManager deMgr = DataExpressionManager.getInstance();
	for (int i = 0; i < ids.length; i++) {
		DataExpressionTemplate template = DataExpressionManager.getInstance().getTemplatebyId(ids[i]);
		if (template != null){
			DataExpressionAggConf c = new DataExpressionAggConf();
			c.setTemplateId(ids[i]);
			c.setResultKey(template.getId());			
			list.add(c);
			
			
			LogFunctionExpressionInfo info = new LogFunctionExpressionInfo();
			info.setDisplayName(template.getName());
			info.setFunctionKey(c.getResultKey());
			info.setFormat(template.getFormat());
			info.setUseFormatType(template.isUseFormatType());
			caseBuilder.addFunctionInfo(info);
		}
	}
  
  list.addAll(Arrays.asList(confs));
  
  ArrayList fullList = new ArrayList(list);
  fullList.addAll(Arrays.asList(routineConfs));
  eaConf.setExpressionsConf(fullList);
  
  if(datafilterIds !=  null && datafilterIds.length > 0){
  	conf.setDataFilters(datafilterIds);
  }
  
  conf.setExpressionConf(eaConf);
  conf.setExpression(true);
//  caseBuilder.setExpressions(list);
  caseBuilder.setAggConf(conf);
  caseBuilder.setDataFilters(datafilterIds);
  
  
  caseBuilder.setStatusRule(statusRule);
  xpolog.logic.filters.StatusTransactionFilter filter = null;
  if (!allStatus){
  	filter = new xpolog.logic.filters.StatusTransactionFilter();
  	filter.setStatuses((String [])statusesList.toArray(new String[statusesList.size()]));
  }
  caseBuilder.setStatusFilter(filter);
  conf.setStatusFilter(filter);
  
  
  String desc = caseBuilder.getCaseDef().getDesc();
  String name = caseBuilder.getCaseDef().getName();
  if (desc != null && desc.indexOf("TRANSACTION_NAME") >= 0 || name != null && name.indexOf("TRANSACTION_NAME") >= 0){
  	try {
  		TransactionParadigm tran =  xpolog.logic.brain.BrainConfigurationRepository.getRepository().getTransactionParadigmById(caseBuilder.getTransactionParaigmId());
  		
  		if (tran != null){
  			
  			if (desc != null){
  			   desc = XpologUtil.replaceAll(desc,"TRANSACTION_NAME",tran.getName());  	
  			}
  			
  			if (name != null){
 			   name = XpologUtil.replaceAll(name,"TRANSACTION_NAME",tran.getName());  	
 			}
  			caseBuilder.getCaseDef().setDesc(desc);
  			caseBuilder.getCaseDef().setName(name);
  		}
  	}catch (Exception e){}
  }
  
  builder.addFunctionBuilder(caseBuilder);
 
  response.sendRedirect(BASE_DIRECTORY + "reports/agg/aggCasesView.jsp");
%>


