<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@page import="xpolog.eye.data.util.functions.*"%>
<%@ page import="xpolog.logic.reports.agg.admin.*"%>
<%@page import="xpolog.logic.ui.aggregators.admin.*"%>
<%@page import="xpolog.logic.routine.data.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!static final String BASE_DIRECTORY = "../../../";

	%>
<%String ERROR_OBJ = "ERROR_OBJ";

			ErrorModel ermod = new ErrorModel();
			TranReportBuilder builder = (TranReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");

			if (builder == null) {
				ermod.addError("Session is not valid any more. Please try again");
			}

			if (ermod.getErrorCount() != 0) {
				request.getSession().setAttribute(ERROR_OBJ, ermod);
				response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
				return;
			}

			TranAggFunctionBuilder caseBuilder = builder.getTempTranFunctionCaseBuilder();
			
			//site management  

			SiteManagment mgmt = SiteManagment.getInstance();
			SiteAdministrator admin = SiteManagment.getAdminInstance();

			TransactionAggregationConf conf = (TransactionAggregationConf) caseBuilder.getAggConf();

			

			if (ermod.getErrorCount() != 0) {
				request.getSession().setAttribute(ERROR_OBJ, ermod);
				response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
				return;
			}

			
			String [] templates = caseBuilder.getTemplatesIds();
			if (templates == null){
				templates = new String[0];
			}
			
			HashSet tempatesSet = new HashSet();
			for(int i = 0; i < templates.length;i++){
				tempatesSet.add(templates[i]);
			}
			
			DataExpressionAggConf [] expressions = caseBuilder.getExpressionsAggConf();
			
			
			RoutineParadigm  [] selRoutines = null;
			
			//String [] templatesIds = {"tranTimeAvg","tranTimeMax","tranTimeMin","tranCount"};
			DataExpressionManager deMgr = DataExpressionManager.getInstance();
			DataExpressionTemplate [] deTemplates = deMgr.getTemplatesForGroup(DataExpressionConstants.TRAN_GROUP);
			%>

<script>

var functionTableReq;
var selFuncIndex = -1;
function encode(uri){
  var result = encodeURI(uri);
  if (result){
    result = result.replace(/\+/g, "%2B") ;
  }
  return result;
}

var counter = <%=System.currentTimeMillis()%>;
function getFunctionsTable(){
  functionTableReq = GetXmlHttpObject();
  if (!functionTableReq) return;
  
  document.getElementById('functionTableTD').style.display = "none";
  document.getElementById('functionTableTDLoading').style.display = "";
  
  counter++;          
  var url = "tranFunctionFieldsExpressionsTable.jsp?counter="+counter;  
  functionTableReq.onreadystatechange = showFunctionsTableResult;
  functionTableReq.open('GET', url, true);
  functionTableReq.send(null);  
  
}

function showFunctionsTableResult() {
      if (functionTableReq.readyState == 4) {
         if (functionTableReq.status == 200) {
            result = functionTableReq.responseText;
            document.getElementById('functionTableTD').innerHTML = result;            
            document.getElementById('functionTableTDLoading').style.display = "none";
            document.getElementById('functionTableTD').style.display = "";
         } else {
            alert('There was a problem with the request. - ' + functionTableReq.status);
         }
      }
   }
   
var functionEditReq;

function getFunctionsEdit(functionIndex){
  functionEditReq = GetXmlHttpObject();
  if (!functionEditReq) return;
  
  selFuncIndex = functionIndex;
  document.getElementById('innerFunctionDiv').innerHTML = "<span class='REGULARTEXT'>Loading...</span>";
  
  counter++;
  var url = "tranFunctionFieldsExpressionEdit.jsp?counter=" + counter + "&functionIndex=" + functionIndex;  
  functionEditReq.onreadystatechange = showFunctionsEditResult;
  functionEditReq.open('GET', url, true); 
  functionEditReq.send(null);  
  
}

function showFunctionsEditResult() {
      if (functionEditReq.readyState == 4) {
         if (functionEditReq.status == 200) {
            result = functionEditReq.responseText;
            document.getElementById('innerFunctionDiv').innerHTML = result;            
         } else {
            alert('There was a problem with the request. - ' + functionEditReq.status);
         }
      }
   }
   
 var functionApplyReq;

function applyFunctionsOp(){
  functionApplyReq = GetXmlHttpObject();
  if (!functionApplyReq) return;
  
  var showOverTime = document.getElementById("showOverTime").checked ? "true" : "false";
  var parameters = "op=apply&functionIndex=" + selFuncIndex + "&funcName=" + encode( document.getElementById("funcName").value) + "&funcExpression=" + encode( document.getElementById("funcExpression").value) + "&formatType=" + encode( document.getElementById("formatType").value)  + "&formatName=" + encode( document.getElementById("formatName").value) + "&showOverTime=" + showOverTime ;
  var url = "tranFunctionFieldsExpressionsOperation.jsp";  
  functionApplyReq.onreadystatechange = showFunctionsApplyResult;
  functionApplyReq.open('POST', url, true);
  functionApplyReq.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  functionApplyReq.setRequestHeader("Content-length", parameters.length);
  functionApplyReq.setRequestHeader("Connection", "close");
  functionApplyReq.send(parameters);  
  
}

function showFunctionsApplyResult() {
      if (functionApplyReq.readyState == 4) {
         if (functionApplyReq.status == 200) {
            result = functionApplyReq.responseText;
            result = result.replace(/^\s+|\s+$/g, '') ;
            if (result == ""){
              closeFunction();
              getFunctionsTable();
            }else {
              alert(result);
            }
         } else {
            alert('There was a problem with the request. - ' + functionApplyReq.status);
         }
      }
   }
   
var functionRemoveReq;

function removeFunctionsOp(index){
  functionRemoveReq = GetXmlHttpObject();
  if (!functionRemoveReq) return;
  
  var parameters = "op=remove&functionIndex=" + index;
  var url = "tranFunctionFieldsExpressionsOperation.jsp";  
  functionRemoveReq.onreadystatechange = showFunctionsRemoveResult;
  functionRemoveReq.open('POST', url, true);
  functionRemoveReq.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  functionRemoveReq.setRequestHeader("Content-length", parameters.length);
  functionRemoveReq.setRequestHeader("Connection", "close");
  functionRemoveReq.send(parameters);  
  
}

function showFunctionsRemoveResult() {
      if (functionRemoveReq.readyState == 4) {
         if (functionRemoveReq.status == 200) {
            result = functionRemoveReq.responseText;
            result = result.replace(/^\s+|\s+$/g, '') ;
            if (result == ""){
              getFunctionsTable();
            }else {
              alert(result);
            }
         } else {
            alert('There was a problem with the request. - ' + functionRemoveReq.status);
         }
      }
   }
   
   
function showFunctionDiv(divElem){    
  showHideLayerInMiddle(divElem,-1,200);
}
   
function addFunction(){
  getFunctionsEdit(-1);  
  showFunctionDiv("functionDiv");
    
}

function closeFunction(){
  var div = document.getElementById("functionDiv");  
  if (!div) return;  
  if(div.style.visibility == ""){
    showFunctionDiv("functionDiv");
  }   
}

function editFunction(functionIndex){
  getFunctionsEdit(functionIndex);  
  showFunctionDiv("functionDiv");
    
}

function removeFunction(functionIndex){
  removeFunctionsOp(functionIndex);  
    
}

function formatTypeChanged(combo,suffix){
  if (combo.selectedIndex == -1){
    return;
  }
  
  document.getElementById("formatName" + suffix).value = combo.options[combo.selectedIndex].formatName;
  document.getElementById("formatProp" + suffix).value = combo.options[combo.selectedIndex].formatProp;
}
   
</script>

<div id="functionDiv" style="position:absolute;visibility:hidden;height:220;width:600">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid DBDFE2">
	<tr height="10">
		<td align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5"><span class="PROGRESSTEXT">Function</span></td>
	</tr>
	<tr>
		<td style="padding:5">
		<div id="innerFunctionDiv" style="overflow:auto;width:600;height:200">
		
		</div>
		</td>
	</tr>
	<tr height="10">
		<td align="center" style="padding:2">
		<a class="LINK" href="javascript:closeFunction()">close</a>&nbsp;&nbsp;
		<a class="LINK" href="javascript:applyFunctionsOp()">apply</a></td>
</table>
</div>

<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="53" style="visibility:visible">
<tr>
		<td width="15%" height="18"><span class="HEADER">Predefined Functions</span></td>
	</tr>
	<tr>
		<td><span class="REGULARTEXT">Select the predefined funtions to be added to the report.</span></td>
	</tr>
	<tr height="20">
		<td>
		<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%">
		<% for (int i = 0; i < deTemplates.length ;i++){ 
			DataExpressionTemplate template = deTemplates[i];
			
			String checked = tempatesSet.contains(template.getId()) ? "checked" : "";
			if (template == null) continue;			
			if (i % 3 == 0){
			if (i > 0){%>
			<td width="*">&nbsp;</td></tr>
			<%}%>			
				<tr>
			 <%}
		%>
		<td width="100" style="padding-right:5"><input type="checkbox" name="predefinedFunctions" value="<%=template.getId() %>" title="<%=template.getDesc()%>" <%=checked %>><nobr><span class="REGULARTEXT"><%=template.getShortName()%> (<%=template.getId()%>) </span></nobr></td>
		<%		
		} 
		if (deTemplates.length > 0){%>
		</tr>
		<%}
		%>
		</table>
		</td>
	</tr>
	<tr>
		<td>&nbsp;</td>
	</tr>
	
	<tr style="padding-top:5">
		<td><span class="REGULARTEXT"><a href="javascript:addFunction()" class="LINK">Add new function</a></span></td>
	</tr>

	<tr>
		<td id="functionTableTDLoading">
		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
			<tr class="TABLES_HEADERS">
				<td width="50"><span class="REGULARTEXT">Key</span></td>
				<td width="250"><span class="REGULARTEXT">Name</span></td>
				<td width="*"><span class="REGULARTEXT">Function</span></td>
				<td width="150" class="REGULARTEXT">&nbsp;</td>
			</tr>		
			<tr>
			<td colspan="4"><span class="REGULARTEXT">Loading...</span></td>
			</tr>
					</table>
		</td>
		<td id="functionTableTD" style="display:none">		
		</td>
	</tr>

	<tr>
		<td>&nbsp;</td>
	</tr>
</table>

