<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@page import="xpolog.eye.data.util.functions.*"%>
<%@page import="xpolog.eye.reports.agg.result.*"%>
<%@ page import="xpolog.logic.reports.agg.admin.*"%>
<%@page import="xpolog.logic.ui.aggregators.admin.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!static final String BASE_DIRECTORY = "../../../";

	%>
<%String ERROR_OBJ = "ERROR_OBJ";

			ErrorModel ermod = new ErrorModel();
			TranReportBuilder builder = (TranReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");

			if (builder == null) {
				ermod.addError("Session is not valid any more. Please try again");
			}

			if (ermod.getErrorCount() != 0) {
				request.getSession().setAttribute(ERROR_OBJ, ermod);
				response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
				return;
			}

			TranAggFunctionBuilder caseBuilder = builder.getTempTranFunctionCaseBuilder();
			
			String type = request.getParameter("type");
			
			boolean isRoutine = type != null && type.equals(DataExpressionConstants.ROUTINE_GROUP);
			DataExpressionAggConf [] expressions = caseBuilder == null ? new DataExpressionAggConf[0] :  isRoutine ? caseBuilder.getRoutineExpressionsAggConf() : caseBuilder.getExpressionsAggConf();						
			String suffix = isRoutine ? "Routine" : "";
			%>


<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
	<tr class="TABLES_HEADERS">
		<td width="50"><span class="REGULARTEXT">Key</span></td>
		<td width="250"><span class="REGULARTEXT">Name</span></td>
		<td width="*"><span class="REGULARTEXT">Function</span></td>
		<td width="150" class="REGULARTEXT">&nbsp;</td>
	</tr>
	<%for (int i = 0 ;expressions != null &&  i < expressions.length; i++){
                      	DataExpressionAggConf deConf = expressions[i];
                      	String name = null;
                      	String key = deConf.getResultKey();
                      	                      	
                				LogFunctionExpressionInfo info = caseBuilder.getFunctionInfo(key);
                				if (info != null){
                					name = info.getDisplayName();
                				}
                      	
                      	
                      	if (name == null || name.length() == 0){
                      		name = "Result " + (i + 1);
                      	}
                      	if (key == null || key.length() == 0){
                      		key = "f" + (i + 1);
                      	}
                      	
                      	String exp = deConf.getExpression();
                      %>
	<tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
		<td width="50" class="REGULARTEXT"><%=key%></td>
		<td width="250" class="REGULARTEXT"><%=name%></td>
		<td width="*" class="REGULARTEXT"><%=exp%></td>
		<td width="150" class="REGULARTEXT" nowrap align="right" style="padding-right:20"><nobr> <a
			href="javascript:editFunction<%=suffix%>('<%=String.valueOf(i)%>')" class="LINK">edit</a>&nbsp;&nbsp; <a href="javascript:removeFunction<%=suffix%>('<%=String.valueOf(i)%>')"
			class="LINK">delete</a> </nobr></td>
	</tr>
	<%}%>
</table>


