<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="xpolog.logic.reports.agg.admin.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.remote.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.ConfigMgr"%>
<%@page import="xpolog.eye.media.AddressBook"%>
<%@page import="xpolog.eye.media.db.DBAccount"%>
<%@page import="xpolog.logic.ui.admin.system.LogicCreatorManager"%>


<%@ page import="java.util.*"%>

<%! 
	static final String BASE_DIRECTORY = "../../../";
%>

<%
  String ERROR_OBJ = "ERROR_OBJ";
  String LOG4J_BUILDER = "LOG4J_BUILDER";
	String	TYPE_WORKSPACE = "Workspace";
	String TYPE_PROJECT = "DataSession";


  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  
  AggReportBuilder builder = (AggReportBuilder)  request.getSession().getAttribute("REPORT_BUILDER");
  
  
 if(builder == null){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("Session is not valid any more. Please try again");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
    return;
  }
 
  TranAggFunctionBuilder caseBuilder = (TranAggFunctionBuilder)builder.getCurrentCaseBuilder();
  if (caseBuilder == null){
    String functionIndex = request.getParameter("functionIndex");
    int index = -1;
    try {
      index = Integer.parseInt(functionIndex);
    }catch (Exception e){}
  	caseBuilder = index == -1 ? null : (TranAggFunctionBuilder)builder.getCaseBuilderAt(index);
    if (caseBuilder == null){
      caseBuilder = new TranAggFunctionBuilder();
      AggCaseDefinition caseDef = new AggCaseDefinition();
      caseDef.setName("TRANSACTION_NAME computation");
      caseDef.setDesc("TRANSACTION_NAME computation");
      caseDef.setType(AggReportBuilder.TRAN_FUNCTION_TYPE);
      caseBuilder.setCaseDef(caseDef);
      
    }else {
      caseBuilder = (TranAggFunctionBuilder)caseBuilder.clone();                  
    }
    builder.setCurrentCaseBuilder(caseBuilder);
  }

  AggCaseDefinition def = caseBuilder.getCaseDef();
  
  
  
  
  String name="";
  String desc="";

  HashMap workSpacesMap = new HashMap();
  HashMap projectsMap = new HashMap();
  HashMap transactionsMap = new HashMap();
  RootWorkspace rootWorkspace = new RootWorkspace();
  rootWorkspace.setName("Workspaces");
  rootWorkspace.setId("Workspaces");
  Workspace[] workspaces = ConfigMgr.getInstance().getCtrlMgr().getWorkspaces();
  for (int i=0; i<workspaces.length; i++){
  	rootWorkspace.addDataSessionId(workspaces[i].getId());
  }
  
 String tranId = caseBuilder.getTransactionParaigmId();
 if (tranId != null && tranId.length() > 0){
	 transactionsMap.put(tranId,tranId);
 }
  
  if (def != null){
    name = def.getName();
    desc = def.getDesc();
  }
	DBAccount	dbAccount = (DBAccount)AddressBook.getInstance().getAccountById("xpologicDB");
	boolean dbConnected = false;
	if (dbAccount != null){
		dbConnected = LogicCreatorManager.getInstance().getTxExpoConnectionStatus(dbAccount);
	}

%>


<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<jsp:include page="../../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/>
</jsp:include>
<script  src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script>
    baseDirectory = "<%=BASE_DIRECTORY%>"; 
    
    function doNext(){
      updateWorkspaces();
      document.access.action = "tranFunctionSelectionAction.jsp";
      document.access.submit();
    }
    
   
    
       function updateWorkspaces(){
     var transId = ""; 
		var trans = wsTree.getAllChecked();
		indx = trans.indexOf("-");
		if(indx > -1){
			type = trans.substring(0,indx);
			transId = trans.substring(indx+1,trans.length);		
		}
		var projectId;
		var project = wsTree.getParentPath(trans);
		indx = project.indexOf("-");
		if(indx > -1){
			type = project.substring(0,indx);
			projectId = project.substring(indx+1,project.length);		
		}
		document.access.projects.value = projectId;		
		document.access.transactions.value = transId;		
	}

</script>
</head>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="POST">
<input type="hidden" name="projects">
<input type="hidden" name="transactions">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
              <tr>
                <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="53%" class="TOPBORDER" height="0">
                <span class="PAGEHEADER">Transaction Computation Selection</span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                   <tr><td width="*"  valign="top" ><span class="HEADER">General</span></td></tr>
                                      <tr>
                                        <td ><font size="1">&nbsp;</font></td>
                                      </tr>
				     <tr><td  width="100%">
				      <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td width="100"><span class="REGULARTEXT">Name: </span></td>
					<td width="*"><input class="REGULARTEXT" type="text" name="name" size="30" value="<%=name%>"></td>
                                      </tr>
                                      <tr><td colspan="2">&nbsp;</td></tr>
				      <tr>
                                        <td width="100"><span class="REGULARTEXT">Description: </span></td>
					<td width="*"><input class="REGULARTEXT" type="text" name="desc" size="30" value="<%=desc%>"></td>
                                      </tr>
				      </table>
				      </td></tr>
                                      <tr><td >&nbsp;</td></tr>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Transactions List</span><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td>
                    <span class="REGULARTEXT">Select a transaction to be used in this case</span>
                    </td>
                  </tr>
                  <tr>
                    <td width="15%">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
												<tr>
												<td>&nbsp;</td>
												</tr>
											  <tr>
											     	<td>
											        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
											                  <tr>
											                    <td width="15%" height="18"><span class="HEADER">TxExpo workspaces and projects</span></td>
											                  </tr>
											                  <tr>
													                <td width="100%" height="18"><span class="SMALLTEXT">Please check the workspaces and projects you want to save in this configuration image.</span></td>
											   		          </tr>   		             		       
														    <tr>
											                    <td width="15%">
											                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
											                    <tr>
																						<td>&nbsp;</td>
																					</tr>  
																					<tr>
																					<td valign="top">
																						<div id="wsLoadingDiv" style="display:none">
																							<span class="REGULARTEXT">Loading...</span>
																						</div>
																					</td>
																				</tr>
																				<%if(!dbConnected){ %>
																				<tr>
																						<td ><img src="../../../images/tree/close2.gif"></td>
																						<td><span class="REGULARTEXT" style="color:red">Failed to get data from database. Please verify the database's connection.</span></td>
																					</tr>
																					<%} %> 
											                      <tr>
											                        <td class="REGULARTEXT">
											                        <div id="treeboxboxWS_tree"></div>
											                         </td>
											                      </tr>
											                    </table>
											                    </td>
											                  </tr>
											         </table>
											      </td>
											   </tr>
											 	<tr>
												<td>&nbsp;</td>
												</tr>                     </table>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="30%">&nbsp;</td>
            <td width="31%" align="center">
              <table border="0" width="109%">
                <tr>
                  <td width="24%"><a href="<%=BASE_DIRECTORY%>reports/reportsDefinitionView.jsp" class="LINK">cancel</a></td>
                  <td width="40%">
                    <p align="center"><a href="<%=BASE_DIRECTORY%>reports/agg/aggCasesView.jsp" class="LINK">previous</a></td>
                  <td width="46%"><a href="javascript:doNext()" class="LINK">next</a></td>
                </tr>
              </table>
            </td>
            <td width="39%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
<script>
	var wsTree=new dhtmlXTreeObject("treeboxboxWS_tree","100%","100%","0");
	wsTree.setOnLoadingStart(startLoading);
	wsTree.setOnLoadingEnd(endLoading);		
	wsTree.setImagePath("<%=BASE_DIRECTORY%>");
	wsTree.enableRadioButtons(true);
	wsTree.enableSingleRadioMode(true);
//	wsTree.enableCheckBoxes(1);
//	wsTree.enableThreeStateCheckboxes(true);
	wsTree.setIconSize(12,12);
	wsTree.enableTreeLines(false);
	wsTree.loadingDivName="wsLoadingDiv";
	<%if(dbConnected){ %>
		wsTree.setXMLAutoLoading("tranFunctionSelectionTreeXml.jsp");
		wsTree.loadXML("tranFunctionSelectionTreeXml.jsp");
	<%}%>
</script>
	
</form>

</body>
</html>