<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="xpolog.logic.reports.agg.admin.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.security.*"%>

<%! 
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.EXPORT_MODULE_PERMISSION,true)){
    return;
  }

  String ERROR_OBJ = "ERROR_OBJ";
  ErrorModel ermod = new ErrorModel();
  //site management
  AggReportBuilder builder = (AggReportBuilder)  request.getSession().getAttribute("REPORT_BUILDER");
  
  
 if(builder == null){
   ermod.addError("Session is not valid any more. Please try again");
 }
	
	String transId = request.getParameter("transactions");
	if(transId == null || transId.length() == 0){
		 ermod.addError("No transaction was defined");
	}else{
		int ind = transId.indexOf("@");
		if (ind != -1){
			transId = transId.substring(ind+1);
		}
	}
	String projectId = request.getParameter("projects");
	if(projectId == null || projectId.length() == 0){
		projectId = "";
	}

  
  String name = request.getParameter("name");
  if (name == null || name.length() == 0){
    ermod.addError("No name was defined");
  }
  
  String desc = request.getParameter("desc");
  
 
  if(ermod.getErrorCount() != 0){    
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
    return;
  }
  
 TranAggFunctionBuilder caseBuilder = (TranAggFunctionBuilder)builder.getCurrentCaseBuilder();
 AggCaseDefinition def = new AggCaseDefinition();
 def.setName(name);
 def.setDesc(desc);
 def.setType(AggReportBuilder.TRAN_FUNCTION_TYPE);
 caseBuilder.setProjectId(projectId);
 caseBuilder.setTransactionParaigmId(transId);
 caseBuilder.setDataSessionRuntimeId(xpolog.logic.ui.aggregators.admin.TransactionAggregationConf.LAST_DATA_SESSION);
  
 caseBuilder.setCaseDef(def);
 response.sendRedirect("tranFunctionFields.jsp");
%>

