<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.audit.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.Constants"%>
<%@ page import="xpolog.logic.ui.reports.summary.result.*"%>

<%@ page import="java.awt.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.util.*"%>

<%!static final String BASE_DIRECTORY = "../../../";

	DecimalFormat decFormat = new DecimalFormat("##.##");
	String dateFormatStr = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
	SimpleDateFormat dateFormat = new SimpleDateFormat(dateFormatStr);
	%>
<%String ERROR_OBJ = "ERROR_OBJ";
			ErrorModel errmodel = new ErrorModel();
			UserContext userContext = UserEnvironment.getUserContext(request);
			String reportId = request.getParameter("reportId");
			String reportRuntimeId = request.getParameter("reportRuntimeId");
			String print = request.getParameter("print");
			boolean isPrint = print != null && print.equalsIgnoreCase("true");
			ReportsManager reportMgr = ReportsManager.getInstance();
			Report report = reportMgr.getReportById(reportId, true);

			if (reportId == null || reportId.trim().equals("")) {
				errmodel.addError("No Report id was supplied.");
			}
			if (reportRuntimeId == null || reportRuntimeId.trim().equals("")) {
				errmodel.addError("No Report runtime id was supplied.");
			}

			if (errmodel.getErrorCount() != 0) {				
				return;
			}
			
			String reportName = report.getReportName();
			  //audit
			  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
			  			userContext, AuditConstants.VIEW, "view report", AuditConstants.REPORTS, "view report " + reportName);

			TransactionSummaryReportRuntime runtime = (TransactionSummaryReportRuntime)report.getReportRuntimeById(reportRuntimeId);			
			AlertsSummarySubReportRuntime subRuntime = runtime.getAlertsSummarySubReportRuntime();
			
			Color [] colors = {Color.decode("#EC7A70"),Color.decode("#A7FF9B"),Color.decode("#AABBFF"),
					Color.decode("#FEFE9E"),Color.decode("#FC9EB9"),Color.decode("#E5F3FE"),Color.decode("#FAD996"),
					Color.decode("#808080"),Color.decode("#FE0000"),Color.decode("#FEFE00")};
		
			Color [] pieColors = {Color.decode("#EC7A70"),Color.decode("#A7FF9B"),Color.decode("#AABBFF"),Color.decode("#FEFE9E"),Color.decode("#FC9EB9"),Color.decode("#E5F3FE")};
			String pieAlertsPath = BASE_DIRECTORY + AlertSummaryReportHelper.genTotalAlertsPie(subRuntime,Color.decode("#FFFFFF"),pieColors,300,300);
			
			String lineAlertsChartPath = BASE_DIRECTORY + AlertSummaryReportHelper.genAlertsLineGraph(subRuntime,Color.decode("#FFFFFF"),pieColors,400,250);
						
			String timeStr = dateFormat.format(new Date(runtime.getStartTime() > 0 ? runtime.getStartTime() : runtime.getRunningTime()));
			if (runtime.getStartTime() > 0  && runtime.getEndTime() > 0){
				timeStr += " - " + dateFormat.format(new Date(runtime.getEndTime()));
			}
			
			String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);			
%>

<%if (isPrint){%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%"
	cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
	<tr>
		<td width="100%" height="100%" valign="top">
		<table border="0" width="100%" cellspacing="0" height="90%"
			cellpadding="0">
			<tr>
				<td valign="top" height="90%">
				<table border="0" cellpadding="0" cellspacing="0"
					style="border-collapse: collapse" width="100%">
					<tr>
                    <td width="100%" >   

<%}%>
<table border="0" cellpadding="0" cellspacing="0"
							style="border-collapse: collapse" width="100%" height="100%">
							
							<tr>
								<td width="3%">&nbsp;</td>
								<td width="80%" height="100%" align="left" valign="bottom"
									colspan="2">
								<table border="0" width="100%" cellspacing="1" cellpadding="0">
									<tr>
										<td width="80%" nowrap align="left" style="padding-top:25">
										
										<jsp:include page="../../../common/path.jsp" flush="true">
												<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
		      							<jsp:param name="name_1" value="TxExpo" />
		      							<jsp:param name="name_2" value="<%=analyticsH %>" />
		      							<jsp:param name="name_3" value="Alerts" />
		      							<jsp:param name="link_1" value="logic/logicPortal.jsp" />
										</jsp:include>											
										</td>
										<td width="20%" nowrap align="right" style="padding-top:25">
										<table border="0" width="80" cellspacing="1" height="10">
											<tr>
												<%if(!isPrint){ %>
												<td width="50%"><a
													href="alertsReport.jsp?print=true&reportId=<%=reportId%>&reportRuntimeId=<%=reportRuntimeId%>"
													target="_blank" class="LINK"><img border="0"
													src="<%=BASE_DIRECTORY%>images/ui/print.gif"></a></td>												
												<%}else {%>
												<td>&nbsp;</td>
												<%}%>
											</tr>
										</table>
										</td>
									</tr>
									<tr>
										<td width="*" nowrap valign="bottom" align="left"
											style="padding-left:30"><span class="SMALLTEXT"><nobr><%=timeStr%></nobr></span>
										</td>
									</tr>
									<tr>
										<td>&nbsp;</td>
										<td width="*" nowrap align="right">
										<table border="0" width="100%" height="10">
											<tr>
												<td width="*">&nbsp;</td>
												<td align="right">
												
												</td>
											</tr>
										</table>
										</td>
									</tr>
								</table>
								</td>
							</tr>
							
							
							<tr>
								<td width="3%" height="100%">&nbsp;&nbsp;&nbsp;</td>
								<td width="93%" colspan="2" height="100%">
								<table border="0" cellpadding="0" cellspacing="0"
									style="border-collapse: collapse" width="100%" height="53">
									<tr>
										<td>
										<table border="0" width="100%" cellpadding="0" cellspacing="0" height="100%">
																
											<tr height="300">
												<td width="100%">
												<table border="0" width="100%" cellspacing="0"
													cellpadding="0" height="100%">
													<tr>														
														<td width="*" style="padding-left:50" align="left" class="REPORT_TABLE_SUB_HEADER">Distribution Over time</td>
														<td width="*" style="padding-left:50" align="left" class="REPORT_TABLE_SUB_HEADER">Summary</td>
													</tr>
													<tr>														
														<td width="*" align="center"><img src="<%=lineAlertsChartPath%>"></td>
														<td width="*" align="center"><img src="<%=pieAlertsPath%>"></td>
													</tr>

												</table>
												</td>
											</tr>
											<tr>
												<td width="15%" height="18"></td>
											</tr>
											<tr height="*">
												<td width="100%">
												<table border="0" width="100%" cellspacing="0"
													cellpadding="0" height="100%">
													<tr bgcolor="#EAEDFD" height="10">											  		
											   		<td width="200" class="REGULARTEXT"><nobr>Alert Time</nobr></td>
											      <td width="150" class="REGULARTEXT">Type</td>
											      <td width="150" class="REGULARTEXT"><nobr>Transaction Name</nobr></td>
											      <td width="200" class="REGULARTEXT"><nobr>Transaction Time</nobr></td>
											      <td width="150" class="REGULARTEXT"><nobr>Application Name</nobr></td>
											      <td width="*" class="REGULARTEXT">&nbsp;</td>
													</tr>
		                  		<tr height="*"><td colspan="6"><IFRAME width="100%" SRC="alertsListReport.jsp?reportRuntimeId=<%=reportRuntimeId%>&reportId=<%=reportId%>&tstmp="<%=String.valueOf(System.currentTimeMillis())%>" id="alertsList"></IFRAME></td></tr>
		                  		</table>
												</td>
											</tr>
										</table>
										</td>
									</tr>
								</table>
								</td>
							</tr>
							<tr>
								<td width="100%" height="18" colspan="2">&nbsp;</td>
							</tr>

						</table>

<%if (isPrint){%>
</td></tr>
				</table>
				</td>
			</tr>
			<tr>
				<td height="*">&nbsp;</td>
			</tr>
			
		</table>
		</td>
	</tr>
</table>
</form>
</body>

</html>
<%}%>