<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.audit.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.Constants"%>
<%@ page import="xpolog.logic.ui.reports.summary.result.*"%>

<%@ page import="java.awt.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.util.*"%>

<%!static final String BASE_DIRECTORY = "../../../";

	DecimalFormat decFormat = new DecimalFormat("##.##");
	String dateFormatStr = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
	SimpleDateFormat dateFormat = new SimpleDateFormat(dateFormatStr);
	%>
<%
			WebSecurityManager manager = WebSecurityManager.getInstance();
			if (!manager.checkForPermission(request,response,null,true)){ 
   			return;
			}
			String ERROR_OBJ = "ERROR_OBJ";
			ErrorModel errmodel = new ErrorModel();
			UserContext userContext = UserEnvironment.getUserContext(request);
			String reportId = request.getParameter("reportId");
			String reportRuntimeId = request.getParameter("reportRuntimeId");
			String print = request.getParameter("print");
			boolean isPrint = print != null && print.equalsIgnoreCase("true");
			ReportsManager reportMgr = ReportsManager.getInstance();
			Report report = reportMgr.getReportById(reportId, true);

			if (reportId == null || reportId.trim().equals("")) {
				errmodel.addError("No Report id was supplied.");
			}
			if (reportRuntimeId == null || reportRuntimeId.trim().equals("")) {
				errmodel.addError("No Report runtime id was supplied.");
			}

			if (errmodel.getErrorCount() != 0) {
				request.getSession().setAttribute(ERROR_OBJ, errmodel);
				response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=applications/delek/reports/reportsDefinitionView.jsp");
				return;
			}
			
			String reportName = report.getReportName();
			String analytics = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_DISPLAY_NAME);
			 //audit
		  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		  			userContext, AuditConstants.VIEW, "view " + analytics, AuditConstants.REPORTS, "view " + analytics);

			TransactionSummaryReportRuntime runtime = (TransactionSummaryReportRuntime)report.getReportRuntimeById(reportRuntimeId);			
			
			
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script src="<%=BASE_DIRECTORY%>scripts/comps/divsTabs.js" type="text/javascript"></script>

<style>


</style>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%"
	cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
	<tr>
		<td width="100%" height="100%" valign="top">
		<table border="0" width="100%" cellspacing="0" height="90%"
			cellpadding="0">
			<tr>
				<td valign="top" height="90%">
				<table border="0" cellpadding="0" cellspacing="0"
					style="border-collapse: collapse" width="100%">
					<tr>
						<td width="100%">
						<table border="0" cellpadding="0" cellspacing="0"
							style="border-collapse: collapse" width="100%" height="100%">
							<script>
                  var applicationTabs = createDefaultApplicationTabs("metaDataMembersTabs");
                  applicationTabs.addTab("summary","<nobr>Summary</nobr>","summaryDiv");
                  applicationTabs.addTab("transactions","<nobr>Transactions</nobr>","transactionsDiv");
                  applicationTabs.addTab("alerts","<nobr>Alerts</nobr>","alertsDiv");
                </script>     
								<tr>
                    <td width="100%" colspan="1">  
                    <script>
                    	tabsInLine = 3;
                    	applicationTabs.writeTabs();
                    </script> 
                   </td>
                </tr>  			
								<tr>
                    <td width="100%" >   
                      <div id="summaryDiv" style="display:none">
                     		<jsp:include page="summaryReport.jsp" flush="true">
                     		<jsp:param name="reportId" value="<%=reportId%>" />
                     		<jsp:param name="reportRuntimeId" value="<%=reportRuntimeId%>" />
                     		</jsp:include>
                      </div>
                      <div id="transactionsDiv" style="display:none">
                     		<jsp:include page="transactionsSummaryReport.jsp" flush="true">
                     		<jsp:param name="reportId" value="<%=reportId%>" />
                     		<jsp:param name="reportRuntimeId" value="<%=reportRuntimeId%>" />
                     		</jsp:include>
                      </div>
                      <div id="alertsDiv" style="display:none">
                     		<jsp:include page="alertsReport.jsp" flush="true">
                     		<jsp:param name="reportId" value="<%=reportId%>" />
                     		<jsp:param name="reportRuntimeId" value="<%=reportRuntimeId%>" />
                     		</jsp:include>
                      </div>
                    </td>
                </tr>		
								 <script>                 
                  applicationTabs.selectTabByIndex(0);
                  </script>
							
							
														
						</table>
						</td>
					</tr>

				</table>
				</td>
			</tr>
			<tr>
				<td height="*">&nbsp;</td>
			</tr>
			
		</table>
		</td>
	</tr>
</table>
</form>
</body>

</html>
