var applicationTabsArr = new Array();


function ApplicationTabs(id,selectedTabClass,tabClass){
  this.id = id;
  this.selectedTabClass = selectedTabClass;
  this.tabClass = tabClass;
  this.tabs = new Array();
  this.selectedTabIndex = -1;
}

function Tab(id,name,divLink){
  this.id = id;
  this.name = name;
  this.divLink = divLink;
}

function addTab(id,name,divLink){
  this.tabs[this.tabs.length] = new Tab(id,name,divLink);
  return this.tabs[this.tabs.length - 1];
}

function writeTabs(){
   document.writeln("<table border=\"0\" width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><tr>");
                    
  for (var i = 0; i < this.tabs.length; i++){
    document.writeln("<td id=\"" + this.id + "_" + this.tabs[i].id + "\" width=\"50\" class=\"" + this.tabClass + "\"><span class=\"LINK\"><a href=\"javascript:selectAppTabByIndex('"+ this.id + "'," + i + ")\">" + this.tabs[i].name + "</a></span></td>");
  }
  document.writeln("<td width=\"*\" >&nbsp;</td>");
  document.writeln("</tr> </table>");
}

function selectTabByIndex(tabIndex){
  if (this.selectedTabIndex >= 0){
    oldTab = this.tabs[this.selectedTabIndex];
    document.getElementById(this.id + "_" + oldTab.id).className = this.tabClass;
    document.getElementById(oldTab.divLink).style.display = "none";
  }
  if (tabIndex >= 0){
    newTab = this.tabs[tabIndex];
    document.getElementById(this.id + "_" + newTab.id).className = this.selectedTabClass;
    document.getElementById(newTab.divLink).style.display = "";
    this.selectedTabIndex = tabIndex;
  }
}

ApplicationTabs.prototype.addTab = addTab;
ApplicationTabs.prototype.writeTabs = writeTabs;
ApplicationTabs.prototype.selectTabByIndex = selectTabByIndex;

function createApplicationTabs(id,selectedTabClass,tabClass){
  app = new ApplicationTabs(id,selectedTabClass,tabClass);
  applicationTabsArr[applicationTabsArr.length] = app;
  return app;
}

function createDefaultApplicationTabs(id){
  return createApplicationTabs(id,"APPLICATION_SELECTED_TABS","APPLICATION_TABS");
}

function selectAppTabByIndex(appTabsId,tabIndex){
  for (var i = 0; i < applicationTabsArr.length; i++){
    if (applicationTabsArr[i].id == appTabsId){
      applicationTabsArr[i].selectTabByIndex(tabIndex);
      return;
    }
  }
}
