<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.config.image.*"%>

<%@ page import="xpolog.logic.ConfigMgr"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.config.image.*"%>

<%@ page import="java.util.*"%>


<%! 
	static final String BASE_DIRECTORY = "../../../";
	
  String getTreeDiv(Workspace node,UserSecurity user,HashMap workspaces,HashMap projects,HashMap transactions){
    ArrayList list = new ArrayList();
    StringBuffer buffer = new StringBuffer();
    
    if (node != null){
      boolean selected = workspaces == null || workspaces.containsKey(node.getId());
      String treeKey = "node" + node.getId() + "_0";
      String chkKey = node.getId().equals("Workspaces") ? "root" : "workspaces";
      String name = node.getName();
      if (name == null){
      	name = "";
      }
      String desc = node.getDescription();
      if (desc == null){
      	desc = "";
      }
      String readOnly = "";
      if (node.getType().equals(TransactionParadigm.TRANSACTION_PARADIGM)){
      	readOnly = "readonly";
      }
      buffer.append("\nvar " + treeKey + " = tree.addNode(tree.root,\"" + chkKey + "\",\"" + node.getId() + "\",\"" + name + "\",\"" + desc + "\",''," + selected + ",true);");
      addChildsNodeDiv(node,buffer,treeKey,user,workspaces,projects,transactions);
    }
    return buffer.toString();
  }
  void addChildsNodeDiv(LogicNode node,StringBuffer buffer, String parentKey,UserSecurity user,HashMap workspaces,HashMap projects,HashMap transactions){
		Workspace ws = null;
  	if(!(node.getType().equals(Workspace.WORKSPACE) || node.getType().equals(DataSession.DATA_SESSION))){
  		return;
  	}
		List children = node.getMembers();
		String type = null;
		for (int i = 0; i < children.size(); i++) {
			LogicNode child = (LogicNode)children.get(i);
			if (child == null){
				continue;
			}
			String key = child.getId();
      String treeKey = parentKey + "_" + i;
      String parentNode = parentKey.equals("node") ? "tree.root" : parentKey;
      
      String name = child.getName();
      if (name == null){
      	name = "";
      }
      String desc = child.getDescription();
      if (desc == null){
      	desc = "";
      }
      String extraText = "";
      
      boolean selected = false;
      String chkKey = "logs";
      if(child.getType().equals(Workspace.WORKSPACE)){
        selected = workspaces == null || workspaces.containsKey(child.getId());
        chkKey = "workspaces";
      }else if (child.getType().equals(DataSession.DATA_SESSION)){
        selected = projects == null || projects.containsKey(child.getId());
	      chkKey = "projects";
      }else{
        selected = transactions == null || transactions.containsKey(child.getId());
	      chkKey = "transactions";
      }
      buffer.append("\nvar " + treeKey + " = tree.addNode(" + parentNode + ",\"" + chkKey +"\",\"" + child.getId() + "\",\"" + name + "\",\"" + desc + "\",'" + extraText + "'," + selected + ",false);");
      addChildsNodeDiv(child,buffer,treeKey,user,workspaces,projects,transactions);
    }
  }
%>
     
<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.ConfigurationPermissions.CONF_IMAGE_PERMISSION,true)){
    return;
  }
	String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";
  
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
	
	String name = "";
	String description = "";
	String overrideChecked = "";
	HashMap logsMap = null;
  HashMap modulesMap = null;
  HashMap workSpacesMap = null;
  HashMap projectsMap = null;
  HashMap transactionsMap = null;
  RootWorkspace rootWorkspace = new RootWorkspace();
  rootWorkspace.setName("Workspaces");
  rootWorkspace.setId("Workspaces");
  Workspace[] workspaces = ConfigMgr.getInstance().getCtrlMgr().getWorkspaces();
  for (int i=0; i<workspaces.length; i++){
  	rootWorkspace.addDataSessionId(workspaces[i].getId());
  }
  
	LogicConfigurationImageBuilder builder = (LogicConfigurationImageBuilder)request.getSession().getAttribute("CONF_IMG_BUILDER");
	if(builder != null) {
		name = builder.getName() != null ? builder.getName() : "";
		description = builder.getDescription() != null ? builder.getDescription() : "";
		logsMap = builder.getLogsToExp();
		modulesMap = builder.getModsToExp();
		workSpacesMap = (HashMap)builder.getWorkspacesToExp().clone();
		if (workSpacesMap != null && workSpacesMap.isEmpty()){
			workSpacesMap = null;
		}else{
			workSpacesMap.put(rootWorkspace.getId(),rootWorkspace.getId());
		}
		projectsMap = builder.getProjectsToExp();
		if (projectsMap != null && projectsMap.isEmpty()){
			projectsMap = null;
		}
		transactionsMap = builder.getTransactionsToExp();
		if (transactionsMap != null && transactionsMap.isEmpty()){
			transactionsMap = null;
		}
		if (builder.isoverrideConfImage()){
			overrideChecked = "checked";
		}
	}
   
	String treeCode = getTreeDiv(rootWorkspace,user,workSpacesMap,projectsMap,transactionsMap);
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script  src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>

<script>
	  baseDirectory = "<%=BASE_DIRECTORY%>";
     
	  function doNext(){
        document.access.action ="logicConfImageAction.jsp";
        document.access.submit();
      }

      function markTreeNodeForExport(node){
		nodeCbx = document.getElementById("CheckBox_" + node.tree.name + "_" + node.index);
		if (!nodeCbx) return;
		if (node.selected == nodeCbx.checked) return;
	
		var selected = nodeCbx.checked;	
  	    if (this.onSelectMarkChilds){
    		markNodeChilds(node,selected);  
  		}else {
    		node.selected = selected;
  		}
  
  		if (this.onSelectMarkParents  && selected){
    		markNodeParentsToRoot(node.parent,selected);  
  		}
	  }
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td class="TOPBORDER"><span class="PAGEHEADER">Logic Configuration Image</span> </td>
                <td width="1%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
          	<td>
          	<table> 
              <tr>
              	<td colspan="3"width="10%"><span class="HEADER">Configuration Image details</span></td>
              </tr>
	              <tr>
	                <td width="10%"><span class="REGULARTEXT">Name</span></td>
	                <td colspan="2">
	                <input class="TEXTBOX" type="text" name="Name" size="50" value="<%=name%>"></td>
	              </tr>
	              <tr>
	                <td width="10%"><span class="REGULARTEXT">Description</span></td>
	                <td colspan="2">
	                <input class="TEXTBOX" type="text" name="Description" size="50" value="<%=description%>"></td>
	              </tr>
	              <tr>
	                <td width="11%">&nbsp;</td>
	                <td width="69%">&nbsp;</td>
	              </tr>
              <tr>
                <td colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Available Workspaces, Projects and Transactions</span></td>
                  </tr>
                  <tr>
		                <td width="100%" height="18"><span class="SMALLTEXT">Please check the entities you want to save in this configuration image.</span></td>
    		          </tr>
    		          <tr>
    		          	<td><span class="REGULARTEXT"><input type="checkbox" name="override" value="true" <%=overrideChecked%>> Overwrite existing projects</input></span></td>
    		          </tr>
                  <tr>
                    <td width="15%">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr>
                        <td class="REGULARTEXT">
                        <script>
                         <%=treeCode%>
                         tree.onSelectMarkParents = true;
                         Tree.prototype.markTreeNode = markTreeNodeForExport;
                         tree.writeTree();
                        </script>
                         </td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td width="15%" height="21">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td><font size="2">&nbsp;&nbsp;</font></td>
                  </tr>
                  <tr>
                    <td>
                    <font size="2">&nbsp; </font>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    &nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="101%" id="AutoNumber17">
                      <tr>
                        <td width="25%">&nbsp;</td>
                        <td width="13%">
                        <p align="center">&nbsp;</td>
                        <td width="11%"><a href="javascript:history.go(-1)" class="LINK">cancel</a></td>
                        <td width="11%"><a href="javascript:doNext()" class="LINK">next</a></td>
                        <td width="35%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>