<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "";
%>
<%

	String charset = "UTF-8";
	response.setContentType("text/html; charset=" + charset);
	String nodeId = request.getParameter("nodeId");
	if (nodeId == null){
		nodeId = "";
	}
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  String userName = "";
  if(user != null){
    userName = "Hello " + user.getUser().getDisplayName();
  }
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  XpologApplicationComponent selectedComp = (XpologApplicationComponent)env.getSelectedComponent(user);
  
  
  String imgKey = null;
  if (selectedComp != null){
    ComponentManagement compManage = selectedComp.getComponentManagement();
    imgKey = compManage.getLogoImageKey();
  }
  
  
  if (imgKey == null){
    imgKey = "tree.top.logo.image";
  }
  Properties prop = Configuration.getInstance().getUIData();
  String img = prop.getProperty(imgKey);

	String str = Configuration.getInstance().getPropertiesManager().getProperty("lazyTree");
	boolean lazyTree = str != null && str.equals("true");
	
	AppViewContext appContext = env.getAppViewContext();
	String selectedTab = appContext == null ? null : appContext.selectedTab;
	if (selectedTab == null){
		selectedTab = "";
	}

%>

<html>

<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/menus.css"/>
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/slides.css"/>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script>
function refreshMenu(nodeId,treeId,baseDir){
	if (treeId && treeId != ""){
	  if (this.frames['mangeMainFrm']){
	    var t = eval("this.frames['mangeMainFrm'].tree" + treeId);
	    if (t){
	      if (nodeId && nodeId != ""){
  		    t.refreshItem(nodeId);
  		  }else {
  		  	if(addBaseDirectoryToUrl()) {
	  		    t.refreshItem("null",'');
  		  	}else {
	  		    t.refreshItem("null",baseDir);
  		  	}
  		  }
		  }
		  return;
		}
	}
	vur = parent.frames['treeframe'].location.href;
	index = vur.indexOf("=");
	if(index < 0){
		parent.frames['treeframe'].location = parent.frames['treeframe'].location;
		return;
	}
	loc = vur.substring(0,index+1);
	loc = loc + '<%=String.valueOf(System.currentTimeMillis())%>';
	loc = loc + '&nodeId='+nodeId+'#'+nodeId;
	parent.frames['treeframe'].location = loc;
}

function markItem(nodeId,treeId){
	if (treeId && treeId != ""){
	  if (this.frames['mangeMainFrm']){
	    var t = eval("this.frames['mangeMainFrm'].tree" + treeId);
	    if (t){
	      if (nodeId && nodeId != ""){
  		    t.selectItem(nodeId);
  		  }
		  }
		  return;
		}
	}
}



function gotoResults() {
	if(parent && parent.frames['main']) {
		parent.frames['main'].location = "diagnostics/diagnosticsResult.jsp";
	}
}


function mainLoaded(){
  if(parent && parent.frames['main']) {
    var frm =  parent.frames['main'];
    if (!frm.location || !frm.location.href || (frm.location.href.indexOf("mainView.jsp") == -1 && frm.location.href.indexOf("logCustomization") == -1 && frm.location.href.indexOf("searchAndFilter") == -1 && frm.location.href.indexOf("errorpage.jsp") == -1 && frm.location.href.indexOf("exportLog.jsp") == -1)){
      showSlide('logSlides',false);
    }
    if (!frm.location || !frm.location.href || (frm.location.href.indexOf("detectionProcessResults.jsp") == -1 && frm.location.href.indexOf("detectionProcessResult.jsp") == -1 && frm.location.href.indexOf("detectionProcessResultInstances.jsp") == -1)){
      showSlide('transactionDetectionThresholds',false);
    }
  }
}

var selectedTab = "<%=selectedTab%>";
var customId = "";
function setCustom(id,name,url){
  var isCustomShow = document.getElementById("customTabSel").style.display == "";
  if (id != customId){
    document.getElementById("customLink").innerHTML = name;
    document.getElementById("customLinkSel").innerHTML = name;
    if (!isCustomShow){
      document.getElementById("customTab").style.display = "";
    }
    customId = id;
  }
  
  if (!isCustomShow && selectedTab != "top"){
    showCustom(true);
  }
  loadCustomSlides(url);
}

function hideCustom(){
  showCustom(false);
  document.getElementById("customTab").style.display = "none";
  document.getElementById("customTabSel").style.display = "none";  
  customId = "";
}

function showSlide(id,show){
  var frm = frames['mangeMainFrm'];
  if (!frm) return;
  var d = frm.document.getElementById(id);
  if (!d) return;
  if (show){
    d.style.display = "";
    if (frm.update){
      frm.update();
    }
  }else {
    d.style.display = "none";
  }  
}

function loadCustomSlides(url){
  document.getElementById("customPageFrmTD").style.display = "none";
  document.getElementById("customPageTD").style.display = "";
  document.getElementById("mangeCustomFrm").src = url;
}

function customLoaded(){
  if (document.getElementById("customTab") && (document.getElementById("customTab").style.display == "" || document.getElementById("customTabSel").style.display == "")){
    document.getElementById("customPageTD").style.display = "none";
    document.getElementById("customPageFrmTD").style.display = "";
  }
}

function loadCustomSlidesAjax(url){
  if (typeof XMLHttpRequest != "undefined") {
       statusreq = new XMLHttpRequest();
   } else if (window.ActiveXObject) {
       statusreq = new ActiveXObject("Microsoft.XMLHTTP");
   }
   statusreq.open("GET", url, true);
   statusreq.onreadystatechange = customcallback;
   //alert(url);
   statusreq.send(null);
   document.getElementById("customPage").innerHTML = "<span class='LOADING_TEXT'>Loading...</span>";
}

function customcallback() {
  if (statusreq.readyState == 4) {
      //alert(statusreq.status);
    if (statusreq.status == 200) {
      //var val = statusreq.responseText;
      //if (!val){
      //  val = "";
      //}     
      var xmlDoc=statusreq.responseXML.documentElement;
      var val = xmlDoc.getElementsByTagName("data")[0].childNodes[0].nodeValue;
      document.getElementById("customPage").innerHTML = val;
      return;
    }
  }
  //document.getElementById("customPage").innerHTML = "No data";
}

function showCustom(show){
  if (show){
    document.getElementById("customTab").style.display = "none";
    document.getElementById("customTabSel").style.display = "";
    document.getElementById("topTab").style.display = "";
    document.getElementById("topTabSel").style.display = "none";
    document.getElementById("customSlides").style.display = "";
    document.getElementById("mainSlides").style.display = "none";
  }else {
    document.getElementById("customTab").style.display = "";
    document.getElementById("customTabSel").style.display = "none";
    document.getElementById("topTab").style.display = "none";
    document.getElementById("topTabSel").style.display = "";
    document.getElementById("mainSlides").style.display = "";
    document.getElementById("customSlides").style.display = "none";
  }
}

function setSelectedTab(id){
  selectedTab = id;
  doBackgroundAction("contextAction.jsp?op=setSelectedTab&tabId=" + id);
}


</script>

</head>
<body topmargin="0"  leftmargin="0" rightmargin="0" bottommargin="0" scroll="no" style="overflow-y: hidden;overflow-x: hidden;margin:0px;padding:0px">
<table background="images/slides/manageBg.gif" height="100%" width="100%" border="0" cellpadding="0" cellspacing="0" style="border:1px solid #8b8b8b;">
<!-- 
<tr height="10"><td align="left"  style="background-color:#FFFFFF;padding-top:2">
 <table width="100%" border="0" cellpadding="0" cellspacing="0">
	<tr height="21" style="border-top:1px solid #909090">
	<td align="left" width="10" style="border-bottom:1px solid #909090">&nbsp;</td>
	<td align="center" id="topTabSel" background="images/slides/topSelectedTab.gif" width="82">
	<a class="LINK" style="font-weight:bold" href="javascript:showCustom(false);setSelectedTab('top')">Full Pane</a>
	</td>
	<td align="center" id="topTab" width="82" style="display:none;border-bottom:1px solid #909090">
	<a class="MNG_TOP_TAB" href="javascript:showCustom(false);setSelectedTab('top')">Full Pane</a>
	</td>
	<td align="left" width="*" style="border-bottom:1px solid #909090">&nbsp;</td>
	<td align="center" id="customTab" width="82" style="display:none;border-bottom:1px solid #909090">
		<a class="MNG_TOP_TAB" href="javascript:showCustom(true);setSelectedTab('')" id="customLink"></a>
	</td>
	<td align="center" id="customTabSel" background="images/slides/topSelectedTab.gif" width="82" style="display:none">
		<a class="LINK" style="font-weight:bold" href="javascript:showCustom(true);setSelectedTab('')" id="customLinkSel"></a>
	</td>
	<td style="border-bottom:1px solid #909090" width="10">&nbsp;
		</td>
	</tr>
</table>
</td ></tr>
 -->
 <%if (false && userName != null && userName.length() > 0){ %>
<tr height="20"><td align="left" style="padding-left:13;padding-bottom:0">
<table>
	<tr><td><span class="SMALLTEXT"><%=userName%></span></tr>
</table>
</td></tr>
<%} %>
<!-- 
<tr height="10"><td align="left">
<table>
	<tr><td style="padding-bottom:10" align="center"><a href="javascript:gotoResults()" class="SMALLLINK"><nobr>Problem Isolation Result</nobr></a></tr>
</table>
</td></tr>
 -->
 
<tr height="*">
<td id="mainSlides">
<table height="100%" width="100%" border="0" cellpadding="0" cellspacing="0">
	<tr>
		<td valign="top" align="left">
		<iframe width="100%" height="100%" id="mangeMainFrm" name="mangeMainFrm" src="slides.jsp" frameborder="0"></iframe>
		</td>
	</tr>
</table>
</td>
<td id="customSlides" style="display:none">
<table height="100%" width="100%" border="0" cellpadding="0" cellspacing="0">
	<tr>
		<td valign="top" align="left" id="customPageTD" style="padding-left:20">
		  <span class="LOADING_TEXT">Loading...</span>
		</td>
		<td id="customPageFrmTD" style="display:none">
		<!-- <iframe width="100%" height="100%" id="mangeCustomFrm" name="mangeCustomFrm" frameborder="0" onLoad="javascript:customLoaded()"></iframe> -->
		</td>
	</tr>
</table>
</td>
</tr>
</table>
<iframe name="funcsFrame"  style="visibility:hidden" width="0%" height="0%" ></iframe>
</body>
</html>