<%@ page language="java"%>
<%@ page import="java.io.FileOutputStream"%>
<%@ page import="java.io.PrintWriter"%>

<%@ page import="xpolog.config.Configuration"%>

<%!
	static final String BASE_DIRECTORY = "";
	static final double KB = 1024;
%>
<%
	java.text.DecimalFormat format = new java.text.DecimalFormat("#.##");
	format.setMaximumFractionDigits(2);
	Runtime time = Runtime.getRuntime();
	double free = time.freeMemory() / 1024.0;
	double total = time.totalMemory() / 1024.0;
	String memStat = "<br>Free : &nbsp;" + format.format(free / KB)
			+ "<br>Total : &nbsp;" + format.format(total / KB)
			+ "<br>Usage : &nbsp;" + format.format((total - free) / KB);

	String timeStr = request.getParameter("time");
	int timeDelay = -1;
	if (timeStr != null) {
		try {
			timeDelay = Integer.parseInt(timeStr);
		} catch (Exception e) {
		}
	}
	
	String writeOutputStr = request.getParameter("writeOutput");
	boolean writeOutput = writeOutputStr != null && writeOutputStr.equals("true");
	if (writeOutput) {
		PrintWriter pw = null;
		try {
			String outputFilePath = Configuration.XPOLOG_ROOT_PATH + "log/memoryProbe.log";
			pw = new PrintWriter(new FileOutputStream(outputFilePath, true), true);
			pw.println(new java.util.Date() + " - total: " + format.format(total / KB) + ", free: " + format.format(free / KB) + ", usage: " + format.format((total - free) / KB));
			pw.close();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			if (pw != null) {
				pw.close();
			}
		}
	}
%>

<HTML>
<HEAD>

<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<%
	if (timeDelay > 0) {
%>
<META HTTP-EQUIV="Refresh" content="<%=String.valueOf(timeDelay)%>" url="memoryProbe.jsp">
<%
	}
%>

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>
var started = <%=String.valueOf(timeDelay > 0)%>
function execute(){
	if (started){
    this.location = "memoryProbe.jsp?writeOutput=" + document.getElementById("writeOutput").checked;
  }else {
    this.location = "memoryProbe.jsp?time=" + document.getElementById("time").value + "&writeOutput=" + document.getElementById("writeOutput").checked;
  }
}
</script>
</HEAD>

<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<BODY BGCOLOR="#FFFFFF">
Status ...... <%=memStat%>

<br>
<br>
<a href="javascript:execute();"> <%=(timeDelay > 0 ? "stop" : "start")%></a>&nbsp;&nbsp;Run every
<input id="time" type="text" value="<%=String.valueOf(timeDelay > 0 ? timeDelay : 5)%>" size="3">&nbsp; seconds

<br>

<input id="writeOutput" type="checkbox" value="true" <%if(writeOutput) {%>checked<%} %>> Write memory status to file
</BODY>
</HTML>