<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.reports.Report"%>
<%@ page import="xpolog.eye.reports.ReportsManager"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>

<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>

<%

  String ERROR_OBJ = "ERROR_OBJ";
  ErrorModel errmodel = new ErrorModel();
  
	WebSecurityManager manager = WebSecurityManager.getInstance();
	SiteManagment mgmt = SiteManagment.getInstance();
	UserSecurity user = manager.getUserSecurity(request);
  
	String appId = request.getParameter("appId");
	if (appId == null) {
		appId = "";
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}

	MetaDataManager mdMgr = mgmt.getMetaDataMgr();
 
	MetaDataCategoriesManager catMgr = MetaDataCategoriesManager.getInstance();
  String name = "", desc = "", internalId = "";
  MetaData metaData = null;
  if (appId != null){
    metaData = mdMgr.getMetaData(appId,true);
  }
 	if (metaData != null){
 		name = metaData.getName();
 		desc = metaData.getDescription();
 		internalId = metaData.getInternalId();
 	}
 	HashMap modules = null, logs = null;
  boolean txExpoViewer = mgmt.getXpologManagment().isTransactionExpoValidAndComponentExists();
  
  UserContext userContext = UserEnvironment.getUserContext(request);
	ReportsManager reportMgr = ReportsManager.getInstance();
	String reportType = Report.ENVIRONMENT_ANALYSIS_LOG_GROUP_TYPE;
	List environmentAnalysesList = reportMgr.getAllBasicReports(userContext,false,reportType);
	boolean environmentAnalysesListExist = environmentAnalysesList != null && environmentAnalysesList.size() > 0;
	boolean isTestingBuid = SiteManagment.getInstance().isTestingBuild();
	String environmentAnalysisText = "Environment Analyses";
	if(isTestingBuid) {
		environmentAnalysisText = "Testing Analyses";
	}
%>

<input type="hidden" name="IsAdmin" value="true">
<input type="hidden" name="InternalId" value="<%=internalId%>">
<input type="hidden" name="mods">
<input type="hidden" name="logs">
<input type="hidden" name="multiVerifiers">
<input type="hidden" name="verifiers">
<input type="hidden" name="workspaces">
<input type="hidden" name="projects">
<input type="hidden" name="projectTransactions">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">                
                <script>
                  var applicationTabs = createApplicationTabs("metaDataMembersTabs","APPLICATION_SELECTED_MEMBERS_TAB","APPLICATION_MEMBERS_TAB","BLACK_LINK","WHITE_LINK");
                  applicationTabs.addTab("Logs","<nobr>Logs and folders</nobr>","logsSelectionDiv");
                  applicationTabs.addTab("verifiers","<nobr>Monitors</nobr>","verifierSelectionDiv");
                  applicationTabs.addTab("accounts","<nobr>Accounts</nobr>","accountsSelectionDiv");
                  applicationTabs.addTab("reports","<nobr>Reports</nobr>","reportsSelectionDiv");
                  <%if(environmentAnalysesListExist) {%>
                  applicationTabs.addTab("environmentAnalyses","<nobr><%=environmentAnalysisText %></nobr>","environmentAnalysesSelectionDiv");
                  <%} %>
                  applicationTabs.addTab("templates","<nobr>Templates</nobr>","templatesSelectionDiv");
                  applicationTabs.addTab("wizards","<nobr>Wizards</nobr>","wizardsSelectionDiv");
                  applicationTabs.addTab("tasks","<nobr>Tasks</nobr>","tasksSelectionDiv");
                  applicationTabs.addTab("confimages","<nobr>Conf-images</nobr>","confImagesSelectionDiv");
                  <%if (txExpoViewer){%>
                  applicationTabs.addTab("workspaces","<nobr>TxExpo WS</nobr>","wsSelectionDiv");
                  applicationTabs.addTab("transactions","<nobr>TxExpo transactions</nobr>","transactionsSelectionDiv");
                  <%}%>
                  applicationTabs.addTab("envvariables","<nobr>Environment variables</nobr>","envVarsSelectionDiv");
                  applicationTabs.addTab("metadatas","<nobr>Applications</nobr>","metaDatasSelectionDiv");
                  applicationTabs.addTab("dashboards","<nobr>Dashboards</nobr>","dashboardsSelectionDiv");
                  applicationTabs.addTab("savedSearches","<nobr>Saved Searches</nobr>","savedSearchesSelectionDiv");
                </script>     
                  <tr>
                    <td width="100%">  
                    <script>
                    	tabsInLine = 8;
                    	applicationTabs.writeTabs();
                    </script> 
                   </td>
                  </tr>  
                  <tr>
                    <td width="100%" >   
                      <div id="logsSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataModulesAndLogs.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=appId%>" />
                     		</jsp:include>
                      </div>
                      <div id="verifierSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataVerifiers.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=appId%>" />
                     		</jsp:include>
                      </div>
                      <div id="accountsSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataAccounts.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=appId%>" />
                     		</jsp:include>
                      </div>
                      <div id="reportsSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataReports.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=appId%>" />
                     		</jsp:include>
                      </div>
                      <%if(environmentAnalysesListExist) {%>
                  	  <div id="environmentAnalysesSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataEnvironmentAnalyses.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=appId%>" />
                     		</jsp:include>
                      </div>
                      <%}%>
                      <div id="templatesSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataTemplates.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=appId%>" />
                     		</jsp:include>
                      </div>
                      <div id="wizardsSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataWizards.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=appId%>" />
                     		</jsp:include>
                      </div>
                      <div id="tasksSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataTasks.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=appId%>" />
                     		</jsp:include>
                      </div>
                      <div id="confImagesSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataConfImages.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=appId%>" />
                     		</jsp:include>
	                    </div>
		                  <%if (txExpoViewer){%>
                      <div id="wsSelectionDiv" style="display:none">
                     		<jsp:include page="../logic/metadata/metaDataWorkspaces.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=appId%>" />
                     		</jsp:include>
	                    </div>
                      <div id="transactionsSelectionDiv" style="display:none">
                     		<jsp:include page="../logic/metadata/metaDataTransactions.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=appId%>" />
                     		</jsp:include>
	                    </div>
		                  <%}%>
                      <div id="envVarsSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataEnvVariables.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=appId%>" />
                     		</jsp:include>
	                    </div>
                      <div id="metaDatasSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataMetaDatas.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=appId%>" />
                     		</jsp:include>
	                    </div>
                      <div id="dashboardsSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataDashboards.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=appId%>" />
                     		</jsp:include>
	                    </div>
                      <div id="savedSearchesSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataSavedSearches.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=appId%>" />
                     		</jsp:include>
	                    </div>
                    </td>
                    </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                   <script>                 
                  applicationTabs.selectTabByIndex(0);
                  </script>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>