<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.METADATA_PERMISSION,true)){
  return;
}
UserContext userContext = UserEnvironment.getUserContext(request);

boolean isAdd = true;

String appId = request.getParameter("APPLICATION_ID");
if (appId == null){
	appId = "";
}

%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>

<jsp:include page="../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<%
boolean showMenu = isAdd;
if(showMenu) {
	String menuIds = "editApplication,removeApplication";
	String menuTexts = "Edit,Remove";
	String menuHrefs = "javascript:editApplication0();,javascript:removeApplication0();";
%>
<jsp:include page="../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		</jsp:include>
	<jsp:include page="../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	</jsp:include>
<%
}
%>

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";  
	
  function goEdit(id){
  	alert('edit');
  }
  
  function goNew(){
  	path = "applicationDefinition.jsp";
  	document.location = path;
  }
  
  function doDelete(){   
    var id = getFirstSelectedRow(mygrid);
    if (id == "") {
      return;
    }
		doDelete1(id);
  }
  
  function doDelete1(id){   
    var name = mygrid.cells(id,0).getValue();
    var row = id;   
    var msgWriter = new messageWriter("mygridMessage","Application Delete Action","<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid"),50);
    msgWriter.addAction("Application only","javascript:hideLayer('mygridMessage');javascript:doDelete0('" + row + "','" +  id + "',false)");
    msgWriter.addAction("Application and members","javascript:hideLayer('mygridMessage');javascript:doDelete0('" + row + "','" +  id + "',true,refreshMenus);");
    msgWriter.addAction("No","javascript:hideLayer('mygridMessage')");  
    msgWriter.showMessage("<nobr>Are you sure you want to delete application " + name + " and <b>all its members</b></nobr>?");
  }
  
  function doDelete0(row,id,removeMembers,func){  	
  	deleteGridRow(mygrid,row,baseDirectory + "metadata/removeApplicationAction.jsp?appId=" + id + "&removeMembers=" + removeMembers + "&timestamp=" + new Date().getTime(),func);
  }
  
  function doEdit(){
    var id = getFirstSelectedRow(mygrid);
    if (id == "") {
     return;
    }
  	doEdit1(id);
  }
  
  function doEdit1(id){
    path = "applicationDefinition.jsp?appId=" + id;
  	document.location = path;
  }
	
	function handleMenuItems(){
		<% if (isAdd){%>
 		    aMenu.menu.showButtons("editApplication,removeApplication");		   
 		<%}else {%>
 			  aMenu.menu.hideBar();
 		<%}%>
  }
  
  function editApplication0(){
    if (contextRowId && contextRowId != ""){
      doEdit1(contextRowId);
    }
  }
  
  function removeApplication0(){
    if (contextRowId && contextRowId != ""){
      doDelete1(contextRowId);
    }
  }
  
</script>
</head>

<%
String onLoadFunctions = "initTables();";
if(showMenu) {
	onLoadFunctions = "initMenus();" + onLoadFunctions;
}
%>
<body onLoad="<%=onLoadFunctions %>" onUnload="destroyTables()" style="margin:0;padding:0;overflow:auto;" >
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>
		<td valign="top">
			<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              
				<tr height="10">
					<td>
						<jsp:include page="../common/pageMainHeader.jsp" flush="true">
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="headerTitle" value="Applications" />
						</jsp:include>		
					</td>
				</tr>
				<tr height="*">                
					<td valign="top"> 
					<% 
					String addName = isAdd ? "New Application" : "";
					String addLink = isAdd ? "javascript:goNew()" : "";
             
					String tableNames = isAdd ? "Edit#Delete" : "";
          String tableActions = isAdd ? "javascript:doEdit()#javascript:doDelete()" : "";
          String ids = isAdd ? "Edit#Delete" : "";
          String selectTypes = isAdd ? "2#2" : "";

          String menu = showMenu ? "aMenu" : "";
          
          String applicationsXMLUrl = "metadata/applicationsViewXML.jsp?appId=" + appId; 
					%>
					<jsp:include page="../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
						<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
						<jsp:param name="initXML" value="<%=applicationsXMLUrl%>" />
						<jsp:param name="menu" value="<%=menu%>"/>
						<jsp:param name="newActionNames" value="<%=addName%>" />
						<jsp:param name="newActions" value="<%=addLink%>" />
						<jsp:param name="tableActionNames" value="<%=tableNames%>" />
						<jsp:param name="tableActions" value="<%=tableActions%>" />
						<jsp:param name="tableActionIds" value="<%=ids%>" />
						<jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
						<jsp:param name="style" value="main" />
						<jsp:param name="recordsText" value="Applications" />
						<jsp:param name="doubleClickAction" value="doEdit" />
					</jsp:include>
					</td>
				</tr>
			</table>
		</td>
	</tr>
</table>
</body>

</html>