<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
	String ERROR_OBJ = "ERROR_OBJ";
	String type = request.getParameter("Type");
	String id = request.getParameter("Id");
	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	MetaDataManager metaDataMgr = SiteManagment.getInstance().getMetaDataMgr();
	MetaData systemMetaData;
	if ((systemMetaDataId == null || systemMetaDataId.length() == 0) && 
			type != null && type.length() > 0 && id != null && id.length() > 0){
		systemMetaData = metaDataMgr.getMergedMetaDataByXplgObjectAndType(type,id,true,false);
		if (systemMetaData != null){
			systemMetaDataId = systemMetaData.getId();
		}
	}
	if (systemMetaDataId == null){
		systemMetaDataId = "";
	}
	MetaData[] mds = metaDataMgr.getAllSystemMetaDatas();
	
	if(mds==null || mds.length == 0) {
		ErrorModel errmodel = new ErrorModel();
		errmodel.addError("There are no application definitions in system");
		errmodel.addError("Please add application definition first");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
	}
	
	String isEmbededStr = request.getParameter("isEmbeded");
	boolean isEmbeded = (isEmbededStr != null && isEmbededStr.equals("true"));
	String refreshAction = request.getParameter("refreshAction");
%>
<%if (!isEmbeded) {%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<%}%>
<script>

	function saveXplgMetaData(){
		mdId = document.access.MetaData.options[document.access.MetaData.selectedIndex].value;
		document.access.redirectURL.value = "metadata/mdAction.jsp?Type=<%=type%>&Id=<%=id%>&SystemMetaDataId="+mdId;
		document.access.SystemMetaDataId.value = mdId;
		document.access.submit();
	}
	
	function refreshView(){
		<%if (!isEmbeded) {%>
		mdId = document.access.MetaData.options[document.access.MetaData.selectedIndex].value;
		var path="md.jsp?Type=<%=type%>&Id=<%=id%>&SystemMetaDataId="+mdId;
		document.location = path;
		<%}else if (refreshAction != null){%>
		<%=refreshAction%>;
		<%}%>
	}
</script>

<%if (!isEmbeded) {%>
</head>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" action="metaDataAdminAction.jsp">
<%}%>
<input type="hidden" name="Type" value="<%=type%>">
<input type="hidden" name="Id" value="<%=id%>">
<input type="hidden" name="redirectURL">
<input type="hidden" name="SystemMetaDataId">
<input type="hidden" name="UserMetaDataId" value="<%=type+"_"+id%>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
							<%if (!isEmbeded) {%>
							<tr>
								<td>
									<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
			              <tr>
			                <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
			                <td width="53%" class="TOPBORDER" height="0">
			                <span class="PAGEHEADER">Application </span> </td>
			                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
			              </tr>
			              <tr>
			                <td width="3%" height="100%">&nbsp;</td>
			                <td width="43%" height="100%">&nbsp;</td>
			                <td width="50%" height="100%">&nbsp;</td>
			              </tr>
									</table>
								</td>
							</tr>
              <tr>
              <%}%>
              <tr>
                <td height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53" style="visibility:visible">
                  <tr>
                    <td width="15%" height="28"><span class="HEADER">Application selection</span></td>
                  </tr>
                  <tr>
                  	<td>
                  		<table width="100%" border="0" cellpadding="0" cellspacing="0">
                  			<tr>
                  				<td width="20%"><span class="REGULARTEXT">Application: </span></td>
                  				<td width="80%">
                  					<select name="MetaData" onchange="javascript:refreshView()">
                  						<option value="none"></option>
                  						<%for (int i=0; i<mds.length; i++){
                  								String selected = systemMetaDataId.equals(mds[i].getId()) ? " selected" : "";
                  						%>
                  							<option value="<%=mds[i].getId()%>" <%=selected%>><%=mds[i].getName()%></option>
                  						<%}%>
                  					</select>
                  				</td>
                  			</tr>
                  			<tr><td colspan="2">&nbsp;</td></tr>
                  			<tr>
                  				<td colspan="2">
                  				<%String typeAndId =  type+"_"+id;%>
														<jsp:include page="metaDataAdmin.jsp" flush="true">
															<jsp:param name="SystemMetaDataId" value="<%=systemMetaDataId%>" />
															<jsp:param name="UserMetaDataId" value="<%=typeAndId%>" />
														</jsp:include>
													</td>
                  			</tr>
                  		</table>
                  	</td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
			<%if (!isEmbeded) {%>
			<tr>
			  <td width="100%">
			  <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
			    <tr>
			      <td width="35%">&nbsp;</td>
			      <td width="11%" align="center"><a href="<%=BASE_DIRECTORY%>common/actions/cancelAction.jsp?forward=metadata/metaDataView.jsp" class="LINK">cancel</a></td>
			      <td width="7%" align="center"><a href="javascript:saveXplgMetaData()" class="LINK">save</a></td>
			      <td width="27%">&nbsp;</td>
			      <td width="20%">&nbsp;</td>
			    </tr>
			  </table>
			  </td>
			</tr>
			<%}%>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
<%if (!isEmbeded) {%>
</form>
</body>

</html>
<%}%>