<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY = "../";
%>
     
<%
  String ERROR_OBJ = "ERROR_OBJ";
  
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION,true)){
    return;
  }
  
  //site management
	SiteManagment mgmt = SiteManagment.getInstance();
	UserContext userContext = UserEnvironment.getUserContext(request);
	MetaDataManager metaDataMgr = mgmt.getMetaDataMgr();

	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	ErrorModel errmodel = new ErrorModel(); 

	List allAccountsList = AddressBook.getInstance().getAccountsByFilter(null,userContext);
	if(allAccountsList == null) {
		allAccountsList = new ArrayList();
	}
	HashSet relevantAccounts = new HashSet();
  String[] accountsIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,XpoLogObjectTypes.ACCOUNT_TYPE);
	if (accountsIds != null){
		for (int i=0; i<accountsIds.length; i++){
			relevantAccounts.add(accountsIds[i]);
		}
	}
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";
  function checkAccounts(){
	  if(document.access.checkedAllAcc.checked == true){
	  	for (var i=0; i<<%=allAccountsList.size()%>; i++){
  			document.access.accounts<%=allAccountsList.size() > 1 ? "[i]" : ""%>.checked = true;
	  	}  	
	  }else{
	  	for (var i=0; i<<%=allAccountsList.size()%>; i++){
  			document.access.accounts<%=allAccountsList.size() > 1 ? "[i]" : ""%>.checked = false;
  		}
	  }
  }
</script>
</head>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="15%" height="28" colspan="3"><span class="HEADER">XpoLog Accounts</span></td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <%for(int i=0;i<allAccountsList.size();++i) {
              	  String checked = "";
              	  Account acc = (Account)allAccountsList.get(i);
              	  String desc = "(Type: "+acc.getType()+", Description: "+acc.getDescription()+")";
              	  if(relevantAccounts.contains(acc.getId())) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }	
              %>
							<tr>
								<td colspan="3"><input type="checkbox" id="<%=XpoLogObjectTypes.ACCOUNT_TYPE%>,<%=acc.getId()%>" name="accounts" value="<%=XpoLogObjectTypes.ACCOUNT_TYPE%>,<%=acc.getId()%>" <%=checked%>><span class="REGULARTEXT"><%=acc.getAccountName()%><span class="SMALLTEXT"><%=desc%></span></span></td>
							</tr> 
              <%}%>
              <%if(allAccountsList  != null && allAccountsList.size() > 1){ %>
							<tr><td>&nbsp;</td></tr>  
							<tr class="TABLES_HEADERS">
								<td colspan="3"><input name="checkedAllAcc" type="checkbox" onClick="checkAccounts()"><span class="REGULARTEXT"><b>Check All</b></span></td>
							</tr>
							<%} %>
          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		