<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.cloud.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY = "../";
%>
     
<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ENTERPRISE_PERMISSION,true)){
		return;
	}

	String ERROR_OBJ = "ERROR_OBJ";

	SiteManagment mgmt = SiteManagment.getInstance();
	CloudMgr cmgr = mgmt.getCloudMgr();
	UserContext userContext = UserEnvironment.getUserContext(request);
	MetaDataManager metaDataMgr = mgmt.getMetaDataMgr();

	String systemMetaDataId = request.getParameter("SystemMetaDataId");

	XplgNode[] list = cmgr.getAllXplgNodes(userContext);
	list = CloudUtil.sortArrayByName(list);
	HashSet relevantXplgNodes = new HashSet();
  String[] xplgNodesIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,XpoLogObjectTypes.XPLG_NODE_TYPE);
	if (xplgNodesIds != null){
		for (int i=0; i<xplgNodesIds.length; i++){
			relevantXplgNodes.add(xplgNodesIds[i]);
		}
	}
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";
  function CheckNodes(){
	  if(document.access.checkedAllNodes.checked == true){
	  	for (var i=0; i<<%=list.length%>; i++){
  			document.access.xplgnodes<%=list.length > 1 ? "[i]" : ""%>.checked = true;
	  	}  	
	  }else{
	  	for (var i=0; i<<%=list.length%>; i++){
  			document.access.xplgnodes<%=list.length > 1 ? "[i]" : ""%>.checked = false;
  		}
	  }
  }
</script>
</head>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="15%" height="28" colspan="3"><span class="HEADER">XpoLog Enterprise Nodes</span></td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <%for(int i=0;i<list.length;++i) {
              	  String checked = "";
              	  XplgNode xplgNode = list[i];
              	  String desc = (xplgNode.getDescription() != null && xplgNode.getDescription().trim().length() > 0) ? " - " +xplgNode.getDescription() : "";
              	  if(relevantXplgNodes.contains(xplgNode.getId())) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }	
              %>
							<tr>
								<td colspan="3"><input type="checkbox" id="<%=XpoLogObjectTypes.XPLG_NODE_TYPE%>,<%=xplgNode.getId()%>" name="xplgnodes" value="<%=XpoLogObjectTypes.XPLG_NODE_TYPE%>,<%=xplgNode.getId()%>" <%=checked%>><span class="REGULARTEXT"><%=xplgNode.getName()%><span class="SMALLTEXT"><%=desc%></span></span></td>
							</tr> 
              <%}%>
			        <tr><td>&nbsp;</td></tr>  
				    	<tr class="TABLES_HEADERS" style="<%=list.length > 0 ? "" : "visibility: hidden;"%>">
								<td width="33%"><input name="checkedAllNodes" type="checkbox" onClick="CheckNodes()"><span class="REGULARTEXT"><b>Check All</b></span></td>                
				        <td width="33%">&nbsp;</td>                
				        <td width="34%">&nbsp;</td>           
			        </tr>
          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		