<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.config.env.XpologEnvironmentManager"%>

<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY = "../";
%>
     
<%
  String ERROR_OBJ = "ERROR_OBJ";
  
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.ENV_VARS_PERMISSION,true)){
	  return;
	}

	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	UserContext userContext = UserEnvironment.getUserContext(request);
	MetaDataManager metaDataMgr = mgmt.getMetaDataMgr();

	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	ErrorModel errmodel = new ErrorModel(); 

	HashSet metaDataEnvVariables = new HashSet();
  String[] envVariables = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,XpoLogObjectTypes.ENVIRONMENT_VARIABLE_TYPE);
	if (envVariables != null){
		for (int i=0; i<envVariables.length; i++){
			metaDataEnvVariables.add(envVariables[i]);
		}
	}
  XpologEnvironmentManager envMgr = XpologEnvironmentManager.getInstance();
  Properties allEnvVariables = envMgr.getAllEnvParams(userContext);
  List list = allEnvVariables != null ? new LinkedList(allEnvVariables.keySet()) : new LinkedList();
  Collections.sort(list);

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";
  function checkEnvVariables(){
	  if(document.access.checkedAllEnvVariables.checked == true){
	  	for (var i=0; i<<%=list.size()%>; i++){
  			document.access.envvariables<%=list.size() > 1 ? "[i]" : ""%>.checked = true;
	  	}  	
	  }else{
	  	for (var i=0; i<<%=list.size()%>; i++){
  			document.access.envvariables<%=list.size() > 1 ? "[i]" : ""%>.checked = false;
  		}
	  }
  }
</script>
</head>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="15%" height="28" colspan="3"><span class="HEADER">XpoLog Environment Variables</span></td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <%for(int i=0;i<list.size();++i) {
              	  String checked = "";
              	  String key = (String)list.get(i);
              	  String value = allEnvVariables.getProperty(key);
              	  if(metaDataEnvVariables.contains(key)) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }	
              %>
							<tr>
								<td colspan="3"><input type="checkbox" id="<%=XpoLogObjectTypes.ENVIRONMENT_VARIABLE_TYPE%>,<%=key%>" name="envvariables" value="<%=XpoLogObjectTypes.ENVIRONMENT_VARIABLE_TYPE%>,<%=key%>" <%=checked%>><span class="REGULARTEXT"><%=key%>&nbsp;<span class="SMALLTEXT">(<%=value%>)</span></span></td>
							</tr> 
              <%}%>
							<tr><td>&nbsp;</td></tr>  
							<tr class="TABLES_HEADERS" style="<%=list.size() > 0 ? "" : "visibility: hidden;"%>">
								<td width="33%"><input name="checkedAllEnvVariables" type="checkbox" onClick="checkEnvVariables()"><span class="REGULARTEXT"><b>Check All</b></span></td>                
								<td width="33%">&nbsp;</td>
								<td width="34%">&nbsp;</td>
							</tr>
          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		