<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY = "../";
%>
     
<%
  String ERROR_OBJ = "ERROR_OBJ";
  
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION,true)){
	  return;
	}
  
  //site management
	SiteManagment mgmt = SiteManagment.getInstance();
	UserContext userContext = UserEnvironment.getUserContext(request);
	MetaDataManager metaDataMgr = mgmt.getMetaDataMgr();

	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	ErrorModel errmodel = new ErrorModel(); 

	ReportsManager reportMgr = ReportsManager.getInstance();
	String reportType = Report.ENVIRONMENT_ANALYSIS_LOG_GROUP_TYPE;
	List reportsList = reportMgr.getAllBasicReports(userContext,false,reportType);
	
	HashSet metaDataReports = new HashSet();
  String[] reportsIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,XpoLogObjectTypes.REPORT_TYPE);
	if (reportsIds != null){
		for (int i=0; i<reportsIds.length; i++){
			metaDataReports.add(reportsIds[i]);
		}
	}
	
	boolean isTestingBuid = SiteManagment.getInstance().isTestingBuild();
	String title = "XpoLog Environment Analyses";
	if(isTestingBuid) {
		title = "XpoLog Testing Analyses";
	}
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";
  function checkEnvironmentAnalyses(){
	  if(document.access.checkedAllEnvironmentAnalyses.checked == true){
	  	for (var i=0; i<<%=reportsList.size()%>; i++){
  			document.access.environmentAnalyses<%=reportsList.size() > 1 ? "[i]" : ""%>.checked = true;
	  	}  	
	  }else{
	  	for (var i=0; i<<%=reportsList.size()%>; i++){
  			document.access.environmentAnalyses<%=reportsList.size() > 1 ? "[i]" : ""%>.checked = false;
  		}
	  }
  }
</script>
</head>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="15%" height="28" colspan="3"><span class="HEADER"><%=title %></span></td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <%for(int i=0;i<reportsList.size();++i) {
              	  String checked = "";
            			Report rep = (Report)reportsList.get(i);
              	  if(metaDataReports.contains(rep.getId())) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }	
              %>
							<tr>
								<td colspan="3"><input type="checkbox" id="<%=XpoLogObjectTypes.REPORT_TYPE%>,<%=rep.getId()%>" name="environmentAnalyses" value="<%=XpoLogObjectTypes.REPORT_TYPE%>,<%=rep.getId()%>" <%=checked%>><span class="REGULARTEXT"><%=rep.getReportName()%></span></td>
							</tr> 
              <%}%>
              <%if(reportsList  != null && reportsList.size() > 1){ %>
							<tr><td>&nbsp;</td></tr>  
							<tr class="TABLES_HEADERS">
								<td colspan="3"><input name="checkedAllEnvironmentAnalyses" type="checkbox" onClick="checkEnvironmentAnalyses()"><span class="REGULARTEXT"><b>Check All</b></span></td>
							</tr>
							<%} %>
          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		