<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>

<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY = "../";
%>
     
<%
  String ERROR_OBJ = "ERROR_OBJ";
  
	WebSecurityManager manager = WebSecurityManager.getInstance();

	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	UserContext userContext = UserEnvironment.getUserContext(request);
	MetaDataManager metaDataMgr = mgmt.getMetaDataMgr();

	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	ErrorModel errmodel = new ErrorModel(); 

  MetaData[] mds = metaDataMgr.getAllNonParentsSystemMetaDatas(systemMetaDataId,userContext);

	HashSet metaDataMetaDatas = new HashSet();
  String[] mdIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,XpoLogObjectTypes.META_DATA_TYPE);
	if (mdIds != null){
		for (int i=0; i<mdIds.length; i++){
			metaDataMetaDatas.add(mdIds[i]);
		}
	}
  boolean isReportViewer = manager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION);
  boolean txExpoViewer = mgmt.getXpologManagment().isTransactionExpoValid();
	int len = mds != null ? mds.length : 0;
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";
  function checkMetaDatas(){
	  if(document.access.checkedAllMetaDatas.checked == true){
	  	for (var i=0; i<<%=len%>; i++){
  			document.access.metadatas<%=len > 1 ? "[i]" : ""%>.checked = true;
	  	}  	
	  }else{
	  	for (var i=0; i<<%=len%>; i++){
  			document.access.metadatas<%=len > 1 ? "[i]" : ""%>.checked = false;
  		}
	  }
  }
</script>
</head>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="15%" height="28" colspan="3"><span class="HEADER">Applications</span></td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <%for(int i=0;i<mds.length;++i) {
              	  String checked = "";
              	  MetaData md = mds[i];
              	  String desc = md.getDescription() != null && md.getDescription().length() > 0 ? " - (" + md.getDescription() + ")" : "";
              	  if(metaDataMetaDatas.contains(md.getId())) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }	
              %>
							<tr>
								<td colspan="3"><input type="checkbox" id="<%=XpoLogObjectTypes.META_DATA_TYPE%>,<%=md.getId()%>" name="metadatas" value="<%=XpoLogObjectTypes.META_DATA_TYPE%>,<%=md.getId()%>" <%=checked%>><span class="REGULARTEXT"><%=md.getName()%><span class="SMALLTEXT"><%=desc%></span></span></td>
							</tr> 
              <%}%>
              <%if(mds != null && mds.length > 1) { %>
							<tr><td>&nbsp;</td></tr>  
							<tr class="TABLES_HEADERS">
								<td colspan="3"><input name="checkedAllMetaDatas" type="checkbox" onClick="checkMetaDatas()"><span class="REGULARTEXT"><b>Check All</b></span></td>
							</tr>
							<%} %>
          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		