<%@ page language="java"%>

<%@ page import="xpolog.eye.meta.MetaDataManager"%>
<%@ page import="xpolog.eye.site.ui.tree.ModuleMemberRenderer"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.util.*"%>

<%
	//site management
  SiteManagment mgmt = SiteManagment.getInstance();
  MetaDataManager metaDataMgr = mgmt.getMetaDataMgr();
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	
	HashMap logsMap = null;
	HashMap modulesMap = null;
	HashMap selectedModules = null;
  String[] logsIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,"Log");
  String[] modulesIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,"Module");
  if (logsIds != null){
  	logsMap = new HashMap();
  	for (int i=0; i<logsIds.length; i++){
  		logsMap.put(logsIds[i],logsIds[i]);
  	}
  }
  if (modulesIds != null){
  	selectedModules = new HashMap();
  	modulesMap = new HashMap();
  	for (int i=0; i<modulesIds.length; i++){
  		modulesMap.put(modulesIds[i],modulesIds[i]);
  		selectedModules.put(modulesIds[i],modulesIds[i]);
  	}
  }
  ModuleMemberRenderer.addModuleMemberParents(modulesMap,logsMap);
	
	boolean treeNodeExists = false;
	String treeXml = ""; 
  String id = request.getParameter("id");
  if (id != null){
  	String modid = id;
  	int ind = id.indexOf("-");
  	if (ind != -1 && ind != id.length()-1){
  		modid = id.substring(ind+1);
  	}
		curmod = SiteManagment.getInstance().getModuleFromId(modid);
		treeNodeExists = true;
  }
  
	
	if (curmod != null){
		ModuleMemberRenderer renderer = new ModuleMemberRenderer(curmod, userContext, modulesMap, logsMap, true, false, treeNodeExists);
		//renderer.setAddParentIdToNodeId(true);
		renderer.setSelectedModules(selectedModules);
		treeXml = renderer.getTreeXML(true,true);
	}
	
	//System.out.println(treeXml);
	response.setContentType("text/xml");
	out.write(treeXml);
	out.flush();
%>