<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@page import="xpolog.eye.verifiers.MultiVerifier"%>

<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
	String	TYPE_WORKSPACE = "Workspace";
	String TYPE_PROJECT = "DataSession";

  String ERROR_OBJ = "ERROR_OBJ";
  ErrorModel errmodel = new ErrorModel();
  
  SiteManagment mgmt = SiteManagment.getInstance();
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
  
	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	MetaDataManager mdMgr = mgmt.getMetaDataMgr();
  MetaDataCategoriesManager catMgr = MetaDataCategoriesManager.getInstance();
  String name = "", desc = "", internalId = "";
  MetaData metaData = null;
  if (systemMetaDataId != null){
    metaData = mdMgr.getMetaData(systemMetaDataId,true);
  }
 	if (metaData != null){
 		name = metaData.getName();
 		desc = metaData.getDescription();
 		internalId = metaData.getInternalId();
 	}
 	HashMap modules = null, logs = null;
  boolean txExpoViewer = mgmt.getXpologManagment().isTransactionExpoValidAndComponentExists();
  
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script src="<%=BASE_DIRECTORY%>scripts/tree/rightClickMenu.js"></script>
<jsp:include page="../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<script src="<%=BASE_DIRECTORY%>scripts/comps/divsTabs.js" type="text/javascript"></script>
<script>
  function doSave(){
  	updateSelected();
  	updateVerifiersSelected();
  	 <%if(txExpoViewer){%>
		  updateWorkspaces();
		<%}%>
  	document.access.submit();
  }
  
	function updateSelected(){
		list = tree1.getAllChecked(true);
		arr = list.split(",");
	  var logsStr = "";
	  var modsStr = "";
		for (var i=0; i<arr.length; i++){
			s = arr[i];
			ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				type = s.substring(0,ind);
				id = s.substring(ind+1,s.length);
				if (type == "<%=XpoLogObjectTypes.MODULE_TYPE%>"){
					if (modsStr != ""){
						modsStr += ",";
					}
					modsStr += id;
				}else{
					if (logsStr != ""){
						logsStr += ",";
					}
					logsStr += id;
				}
			}
		}
		document.access.mods.value = modsStr;
		document.access.logs.value = logsStr;
	}
	
	function updateVerifiersSelected(){
		list = metaVerTree.getAllChecked();
		arr = list.split(",");
	  var verStr = "";
	  var multiVerStr = "";
		for (var i=0; i<arr.length; i++){
			s = arr[i];
			ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				type = s.substring(0,ind);
				id = s.substring(ind+1,s.length);
				if (type == "<%=MultiVerifier.MULTI_TYPE%>"){
					if (multiVerStr != ""){
						multiVerStr += ",";
					}
					multiVerStr += id;
					if (metaVerTree.hasChildren(s) && metaVerTree.hasChildren(s)==true){
	 				multiVerStr += "*";
					}
				}else{
					if (verStr != ""){
						verStr += ",";
					}
					verStr += id;
				}
			}
		}
		document.access.multiVerifiers.value = multiVerStr;
		document.access.verifiers.value = verStr;
	}
	  function updateWorkspaces(){
		list = wsTree.getAllChecked(true);
		arr = list.split(",");
	  var wsStr = "";
	  var projStr = "";
	  var transStr = "";	  
		for (var i=0; i<arr.length; i++){
			s = arr[i];
			ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				type = s.substring(0,ind);
				id = s.substring(ind+1,s.length);
				if (type == "<%=TYPE_WORKSPACE%>"){
					if (wsStr != ""){
						wsStr += ",";
					}
					wsStr += id;
					
				}else{
					if (type == "<%=TYPE_PROJECT%>"){
						if (projStr != ""){
							projStr += ",";
						}
						projStr += id;
					
					}else{
							if (transStr != ""){
								transStr += ",";
							}
							transStr += id;
						}
					}
			}
		}
		document.access.workspaces.value = wsStr;
		document.access.projects.value = projStr;
		document.access.projectTransactions.value = transStr;		
	}
	
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" name="access" id="access" method="post" action="metaDataObjectsAdminAction.jsp">
<input type="hidden" name="IsAdmin" value="true">
<input type="hidden" name="InternalId" value="<%=internalId%>">
<input type="hidden" name="SystemMetaDataId" value="<%=systemMetaDataId%>">
<input type="hidden" name="mods">
<input type="hidden" name="logs">
<input type="hidden" name="multiVerifiers">
<input type="hidden" name="verifiers">
<input type="hidden" name="workspaces">
<input type="hidden" name="projects">
<input type="hidden" name="projectTransactions">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="90%" class="TOPBORDER">
                <span class="PAGEHEADER">System members of application <%=name%></span></td>
                <td width="9%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">                
                <script>
                  var applicationTabs = createDefaultApplicationTabs("metaDataMembersTabs");
                  applicationTabs.addTab("Logs","<nobr>Logs and folders</nobr>","logsSelectionDiv");
                  applicationTabs.addTab("verifiers","<nobr>Monitors</nobr>","verifierSelectionDiv");
                  applicationTabs.addTab("accounts","<nobr>Accounts</nobr>","accountsSelectionDiv");
                  applicationTabs.addTab("reports","<nobr>Reports</nobr>","reportsSelectionDiv");
                  applicationTabs.addTab("templates","<nobr>Templates</nobr>","templatesSelectionDiv");
                  applicationTabs.addTab("wizards","<nobr>Wizards</nobr>","wizardsSelectionDiv");
                  applicationTabs.addTab("tasks","<nobr>Tasks</nobr>","tasksSelectionDiv");
                  applicationTabs.addTab("confimages","<nobr>Conf-images</nobr>","confImagesSelectionDiv");
                  <%if (txExpoViewer){%>
                  applicationTabs.addTab("workspaces","<nobr>TxExpo WS</nobr>","wsSelectionDiv");
                  applicationTabs.addTab("transactions","<nobr>TxExpo transactions</nobr>","transactionsSelectionDiv");
                  <%}%>
                  applicationTabs.addTab("enterprise","<nobr>Enterprise</nobr>","xplgNodesSelectionDiv");
                  applicationTabs.addTab("envvariables","<nobr>Environment variables</nobr>","envVarsSelectionDiv");
                  applicationTabs.addTab("metadatas","<nobr>Applications</nobr>","metaDatasSelectionDiv");
                  applicationTabs.addTab("dashboards","<nobr>Dashboards</nobr>","dashboardsSelectionDiv");
                </script>     
                  <tr>
                    <td width="100%">  
                    <script>
                    	tabsInLine = 8;
                    	applicationTabs.writeTabs();
                    </script> 
                   </td>
                  </tr>  
                  <tr>
                    <td width="100%" >   
                      <div id="logsSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataModulesAndLogs.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=systemMetaDataId%>" />
                     		</jsp:include>
                      </div>
                      <div id="verifierSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataVerifiers.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=systemMetaDataId%>" />
                     		</jsp:include>
                      </div>
                      <div id="accountsSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataAccounts.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=systemMetaDataId%>" />
                     		</jsp:include>
                      </div>
                      <div id="reportsSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataReports.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=systemMetaDataId%>" />
                     		</jsp:include>
                      </div>
                      <div id="templatesSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataTemplates.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=systemMetaDataId%>" />
                     		</jsp:include>
                      </div>
                      <div id="wizardsSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataWizards.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=systemMetaDataId%>" />
                     		</jsp:include>
                      </div>
                      <div id="tasksSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataTasks.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=systemMetaDataId%>" />
                     		</jsp:include>
                      </div>
                      <div id="confImagesSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataConfImages.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=systemMetaDataId%>" />
                     		</jsp:include>
	                    </div>
		                  <%if (txExpoViewer){%>
                      <div id="wsSelectionDiv" style="display:none">
                     		<jsp:include page="../logic/metadata/metaDataWorkspaces.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=systemMetaDataId%>" />
                     		</jsp:include>
	                    </div>
                      <div id="transactionsSelectionDiv" style="display:none">
                     		<jsp:include page="../logic/metadata/metaDataTransactions.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=systemMetaDataId%>" />
                     		</jsp:include>
	                    </div>
		                  <%}%>
                      <div id="xplgNodesSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataCloud.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=systemMetaDataId%>" />
                     		</jsp:include>
	                    </div>
                      <div id="envVarsSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataEnvVariables.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=systemMetaDataId%>" />
                     		</jsp:include>
	                    </div>
                      <div id="metaDatasSelectionDiv" style="display:none">
                     		<jsp:include page="metaDataMetaDatas.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=systemMetaDataId%>" />
                     		</jsp:include>
	                    </div>
                      <div id="dashboardsSelectionDiv" style="display:none">
                     		<jsp:include page="dashboardsMetaDatas.jsp" flush="true">
                     		<jsp:param name="SystemMetaDataId" value="<%=systemMetaDataId%>" />
                     		</jsp:include>
	                    </div>
                    </td>
                    </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                   <script>                 
                  applicationTabs.selectTabByIndex(0);
                  </script>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="35%">&nbsp;</td>
                <td width="11%" align="center"><a href="<%=BASE_DIRECTORY%>common/actions/cancelAction.jsp?forward=metadata/metaDataView.jsp" class="LINK">
                cancel</a></td>
                <td width="7%" align="center"><a href="javascript:doSave()" class="LINK">save</a></td>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>