<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.search.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY = "../";
%>
     
<%
  String ERROR_OBJ = "ERROR_OBJ";
  
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION,true)){
	  return;
	}
  
  //site management
	SiteManagment mgmt = SiteManagment.getInstance();
	UserContext userContext = UserEnvironment.getUserContext(request);
	MetaDataManager metaDataMgr = mgmt.getMetaDataMgr();

	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	ErrorModel errmodel = new ErrorModel(); 

  WizardManager wmg = mgmt.getWizardManager(xpolog.eye.site.SiteUtil.getBaseDirectory(request));
  WizardInfo[] wsysarr = wmg.getAllSystemWizards(userContext);
  WizardInfo[] wusrarr =  wmg.getAllUserWizards(userContext);
  
	SearchHistoryManager searchHistoryManager = SearchHistoryManager.getInstance();
	List list = searchHistoryManager.getSavedSearchesList(userContext);
	SavedSearch[] savedSearches = list != null ? (SavedSearch[])list.toArray(new SavedSearch[list.size()]) : new SavedSearch[0];


	HashSet metaDataSavedSearches = new HashSet();
  String[] savedSearchesIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,XpoLogObjectTypes.SAVED_SEARCHES_TYPE);
	if (savedSearchesIds != null){
		for (int i=0; i<savedSearchesIds.length; i++){
			metaDataSavedSearches.add(savedSearchesIds[i]);
		}
	}
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";
  function checkSavedSearches(){
	  if(document.access.checkedAllSavedSearches.checked == true){
	  	for (var i=0; i<<%=savedSearches.length%>; i++){
  			document.access.savedSearches<%=savedSearches.length > 1 ? "[i]" : ""%>.checked = true;
	  	}  	
	  }else{
	  	for (var i=0; i<<%=savedSearches.length%>; i++){
  			document.access.savedSearches<%=savedSearches.length > 1 ? "[i]" : ""%>.checked = false;
  		}
	  }
  }
</script>
</head>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="15%" height="28" colspan="3"><span class="HEADER">Saved Searches</span></td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <%for(int i=0;i<savedSearches.length;++i) {
              	  String checked = "";
            			SavedSearch savedSearch = savedSearches[i];
              	  if(metaDataSavedSearches.contains(savedSearch.getId())) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }	
              	  String desc = savedSearch.getDescription() != null && savedSearch.getDescription().length() > 0 ? "(" + savedSearch.getDescription() + ")" : "";
              %>
							<tr>
								<td colspan="3"><input type="checkbox" id="<%=savedSearch.getId()%>" name="savedSearches" value="<%=savedSearch.getId()%>" <%=checked%>><span class="REGULARTEXT"><%=savedSearch.getName()%></span></span></td>
							</tr> 
              <%}%>
               <%if(savedSearches != null && savedSearches.length > 1) { %>
							<tr><td>&nbsp;</td></tr>  
							<tr class="TABLES_HEADERS">
								<td colspan="3"><input name="checkedAllSavedSearches" type="checkbox" onClick="checkSavedSearches()"><span class="REGULARTEXT"><b>Check All</b></span></td>
							</tr>
							<%} %>
						 </table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		