<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY = "../";
%>
     
<%
  String ERROR_OBJ = "ERROR_OBJ";
  
	WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.AutomationPermissions.SCHEDULER_PERMISSION,true)){
    return;
  }

	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	//UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
	UserContext userContext = UserEnvironment.getUserContext(request);
	MetaDataManager metaDataMgr = mgmt.getMetaDataMgr();

	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	ErrorModel errmodel = new ErrorModel(); 

  SchedulingMgr schmgr = XpoLogScheduleFactory.getSchdulingManager();
  List list = schmgr.getXpoOpslByFilter(null,userContext);

	HashSet metaDataJobs = new HashSet();
  String[] jobsIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,XpoLogObjectTypes.SCHEDULER_TYPE);
	if (jobsIds != null){
		for (int i=0; i<jobsIds.length; i++){
			metaDataJobs.add(jobsIds[i]);
		}
	}
  boolean isReportViewer = manager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION);
  boolean txExpoViewer = mgmt.getXpologManagment().isTransactionExpoValid();

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";
  function CheckSchedulers(){
	  if(document.access.checkedAllSchedulers.checked == true){
	  	for (var i=0; i<<%=list.size()%>; i++){
  			document.access.schedulers<%=list.size() > 1 ? "[i]" : ""%>.checked = true;
	  	}  	
	  }else{
	  	for (var i=0; i<<%=list.size()%>; i++){
  			document.access.schedulers<%=list.size() > 1 ? "[i]" : ""%>.checked = false;
  		}
	  }
  }
  
</script>
</head>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="15%" height="28" colspan="3"><span class="HEADER">XpoLog Schedulers</span></td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <%for(int i=0;i<list.size();++i) {
              	  String checked = "";
              	  XpoScheduledOperation sop = ((XpoScheduledOperation)list.get(i));
                  XpoJobDetails det = sop.getDetails();
              	  String desc = det.getDescription() != null && det.getDescription().length() > 0 ? " - (" + det.getDescription() + ")" : "";
              	  if(metaDataJobs.contains(det.getId())) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }	
              %>
							<tr>
								<td colspan="3"><input type="checkbox" id="<%=XpoLogObjectTypes.SCHEDULER_TYPE%>,<%=det.getId()%>" name="schedulers" value="<%=XpoLogObjectTypes.SCHEDULER_TYPE%>,<%=det.getId()%>" <%=checked%>><span class="REGULARTEXT"><%=det.getPresName()%><span class="SMALLTEXT"><%=desc%></span></span></td>
							</tr> 
              <%}%>
						<tr>
							<td>&nbsp;</td>
						</tr>  
						<tr class="TABLES_HEADERS" style="<%=list.size() > 1 ? "" : "visibility: hidden;"%>">
							<td width="18%"><input name="checkedAllSchedulers" type="checkbox" onClick="CheckSchedulers()"><span class="REGULARTEXT"><b>Check All</b></span></td>                
						  <td width="18%">&nbsp;</td>                
						  <td width="18%">&nbsp;</td>                
						  <td width="18%">&nbsp;</td>           
						</tr>
          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		