<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.template.*"%>
<%@ page import="xpolog.eye.template.log.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
  String ERROR_OBJ = "ERROR_OBJ";

	SiteManagment mgmt = SiteManagment.getInstance();
	UserContext userContext = UserEnvironment.getUserContext(request);
	MetaDataManager metaDataMgr = mgmt.getMetaDataMgr();

	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	ErrorModel errmodel = new ErrorModel(); 

	TemplateManager tmg = mgmt.getTemplateManager();

  Template[] tsysarr = tmg.getAllSystemTemplates(userContext);
  Template[] tusrarr = tmg.getAllUserTemplates(userContext);

	HashSet metaDataTemplates = new HashSet();
  String[] templatesIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,XpoLogObjectTypes.TEMPLATE_TYPE);
	if (templatesIds != null){
		for (int i=0; i<templatesIds.length; i++){
			metaDataTemplates.add(templatesIds[i]);
		}
	}
	int tusrarrlen = tusrarr != null ? tusrarr.length : 0;
	int tsysarrlen = tsysarr != null ? tsysarr.length : 0;
%>
<script>
  function checkUserTemplates(){
	  if(document.access.checkedAllUserTemplates.checked == true){
	  	for (var i=0; i<<%=tusrarrlen%>; i++){
  			document.access.usertemplates<%=tusrarrlen > 1 ? "[i]" : ""%>.checked = true;
	  	}  	
	  }else{
	  	for (var i=0; i<<%=tusrarrlen%>; i++){
  			document.access.usertemplates<%=tusrarrlen > 1 ? "[i]" : ""%>.checked = false;
  		}
	  }
  }

  function checkSysTemplates(){
	  if(document.access.checkedAllSysTemplates.checked == true){
	  	for (var i=0; i<<%=tsysarrlen%>; i++){
  			document.access.systemplates<%=tsysarrlen > 1 ? "[i]" : ""%>.checked = true;
	  	}  	
	  }else{
	  	for (var i=0; i<<%=tsysarrlen%>; i++){
  			document.access.systemplates<%=tsysarrlen > 1 ? "[i]" : ""%>.checked = false;
  		}
	  }
  }
</script>


<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td height="28"><span class="HEADER">User defined templates</span></td>
              </tr>
              <tr>
                <td>&nbsp;</td>
              </tr>
              <%for(int i=0;i<tusrarr.length;++i) {
              	  String checked = "";
            			Template template = tusrarr[i];
              	  if(metaDataTemplates.contains(template.getId())) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }	
              	  String desc = template.getDescription() != null && template.getDescription().length() > 0 ? " - (" + template.getDescription() + ")" : "";
              %>
							<tr>
								<td><input type="checkbox" id="<%=XpoLogObjectTypes.TEMPLATE_TYPE %>,<%=template.getId()%>" name="usertemplates" value="<%=XpoLogObjectTypes.TEMPLATE_TYPE%>,<%=template.getId()%>" <%=checked%>><span class="REGULARTEXT"><%=template.getName()%><span class="SMALLTEXT"><%=desc%></span></span></td>
							</tr> 
              <%}%>
              <%if(tusrarrlen > 1){ %>
							<tr><td>&nbsp;</td></tr>  
							<tr class="TABLES_HEADERS">
								<td colspan="3"><input name="checkedAllUserTemplates" type="checkbox" onClick="checkUserTemplates()"><span class="REGULARTEXT"><b>Check All</b></span></td>
							</tr>
							<%} %>
              <tr>
                <td>&nbsp;</td>
              </tr>
              <tr>
                <td><span class="HEADER">System templates</span></td>
              </tr>
              <tr>
                <td>&nbsp;</td>
              </tr>
              <%for(int i=0;i<tsysarr.length;++i) {
              	  String checked = "";
            			Template template = tsysarr[i];
              	  if(metaDataTemplates.contains(template.getId())) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }	
              	  String desc = template.getDescription() != null && template.getDescription().length() > 0 ? " - (" + template.getDescription() + ")" : "";
              %>
							<tr>
								<td><input type="checkbox" id="<%=XpoLogObjectTypes.TEMPLATE_TYPE %>,<%=template.getId()%>" name="systemplates" value="<%=XpoLogObjectTypes.TEMPLATE_TYPE%>,<%=template.getId()%>" <%=checked%>><span class="REGULARTEXT"><%=template.getName()%><span class="SMALLTEXT"><%=desc%></span></span></td>
							</tr> 
              <%}%>
              <%if(tsysarrlen > 1){ %>
							<tr><td>&nbsp;</td></tr>  
							<tr class="TABLES_HEADERS">
								<td colspan="3"><input name="checkedAllSysTemplates" type="checkbox" onClick="checkSysTemplates()"><span class="REGULARTEXT"><b>Check All</b></span></td>
							</tr>
							<%} %>
          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		