<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.image.*"%>

<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY = "../../";
%>
     
<%
  String ERROR_OBJ = "ERROR_OBJ";
  
	if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.ConfigurationPermissions.CONF_IMAGE_PERMISSION,true)){
	  return;
	}

	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	UserContext userContext = UserEnvironment.getUserContext(request);
	MetaDataManager metaDataMgr = mgmt.getMetaDataMgr();

	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	ErrorModel errmodel = new ErrorModel(); 

  ConfigurationImageManager confMgr = ConfigurationImageManager.getInstance();
  List list = confMgr.getAllConfigurationImagesFromType(ConfigurationImage.CONFIGURATION_IMAGE,userContext);
  
  if(list == null) {
  	list = new ArrayList();
  }

	HashSet metaDataConfImages = new HashSet();
  String[] confImageIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,XpoLogObjectTypes.CONF_IMAGE_TYPE);
	if (confImageIds != null){
		for (int i=0; i<confImageIds.length; i++){
			metaDataConfImages.add(confImageIds[i]);
		}
	}

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>
  
  function goNext(id){
  	path = "<%=BASE_DIRECTORY%>tools/confImage/confImageBuilderAction.jsp?ID="+id;
  	alert(path);
  	document.location = path;
  }
  
  function publish(id){
  	path = "<%=BASE_DIRECTORY%>tools/confImage/confImageBuilderAction.jsp?ID="+id+"&DO_PUBLISH=true";
  	document.location = path;
  }
  
  function exportConfImage(id){
  	path = "<%=BASE_DIRECTORY%>tools/confImage/publisherSelection.jsp?CONF_IMAGE_ID="+id;
  	document.location = path;
  }
  
</script>

</head>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="15%" height="28" colspan="6"><span class="HEADER">XpoLog configuration images</span></td>
              </tr>
              <tr class="TABLES_HEADERS">
                <td width="18%"><span class="REGULARTEXT">Name</span></td>
                <td width="50%"><span class="REGULARTEXT">Description</span></td>
                <td width="20%" colspan="4">&nbsp;</td>
              </tr>
              <%for(int i=0;i<list.size();++i) {
              	  ConfigurationImage confImage = (ConfigurationImage)list.get(i);
              	  String desc = confImage.getDescription() != null && confImage.getDescription().length() > 0 ? " - (" + confImage.getDescription() + ")" : "";
              %>
							<tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
								<td width="20%"><a href="javascript:goNext('<%=confImage.getId()%>')" class="LINK"><%=confImage.getName()%></a></td>
								<td width="46%"><span class="REGULARTEXT"><%=confImage.getDescription()%></span></td>
								<td width="7%" align="center" nowrap><a href="javascript:exportConfImage('<%=confImage.getId()%>')" class="LINK">export</a></td>
								<td width="7%" align="center" nowrap><a href="javascript:publish('<%=confImage.getId()%>')" class="LINK">publish</a></td>
								<td width="5%" align="center" nowrap><a href="javascript:goNext('<%=confImage.getId()%>')" class="LINK">edit</a></td>
								<td width="16%"></td>
							</tr>
              <%}%>
          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		