<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY = "../../";
%>
     
<%
  
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION,true)){
	  return;
	}
  
	UserContext searchUserContext = (UserContext)request.getSession().getAttribute(MetaDataSearchQuery.META_DATA_USER_CONTEXT);

	ReportsManager reportMgr = ReportsManager.getInstance();
	List reportsList = reportMgr.getAllBasicReports(searchUserContext,false);
	UserContext userContext = UserEnvironment.getUserContext(request);
	boolean isEdit = manager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.EDIT_REPORTS_PERMISSION);
	boolean isExecute = manager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.EXECUTE_REPORTS_PERMISSION);

%>

<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>
  function doDelete(id){
  	path = "<%=BASE_DIRECTORY%>reports/reportRemoveCheck.jsp?reportId=" + id;
  	document.location = path;
  }
  
  function doGenerate(id){
  	path = "<%=BASE_DIRECTORY%>reports/reportRuntimeAction.jsp?reportId=" + id;
  	document.location = path;
  }
  
  function doEdit(url){
  	path = "<%=BASE_DIRECTORY%>" + url;
  	document.location = path;
  }
  
  function viewReport(url){
  	path = "<%=BASE_DIRECTORY%>" + url;
  	document.location = path;
  }
  
  function goVerifier(id){
  	path = "<%=BASE_DIRECTORY%>verifiers/ReportVerifierSettings.jsp?reportId="+id;
  	document.location = path;
  }
</script>
</head>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="15%" height="28" colspan="3"><span class="HEADER">XpoLog Reports</span></td>
              </tr>
              <tr class="TABLES_HEADERS">
                <td width="30%"><span class="REGULARTEXT">Name</span></td>
                <td width="30%"><span class="REGULARTEXT">Description</span></td>
                <td width="20%"></td>                       
              </tr>
              <%for(int i=0;i<reportsList.size();++i) {
									Report rep = (Report)reportsList.get(i);
									boolean isRepEdit = userContext == null || (isEdit && rep.isEditable(userContext));
									boolean isExecutable = userContext == null || (isExecute);
									String id = rep.getId();
									String viewUrl = rep.getViewUrl();
									if (viewUrl != null){
									viewUrl = viewUrl.replaceAll("\\[REPORT_ID\\]",id);
								}
              %>

							<tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
							<td width="30%">
							<%if (viewUrl != null && viewUrl.length() > 0){%>
							<a href="javascript:viewReport('<%=viewUrl%>')" class="LINK"><nobr><%=rep.getReportName()%></nobr></a>
							<%} else {%>
							<span class="REGULARTEXT"><nobr><%=rep.getReportName()%></nobr></span>
							<%}%>
							</td>
							                     <td width="30%"><span class="REGULARTEXT"><%=((Report)reportsList.get(i)).getDescription()%></span></td>
							<td width="20%" align="right" style="padding-right:10"><nobr>
							<% if(isRepEdit && rep.getEditUrl() != null && rep.getEditUrl().length() > 0){
							String url = rep.getEditUrl();
							url = url.replaceAll("\\[REPORT_ID\\]",rep.getId());
							%>
							<a href="javascript:doEdit('<%=url%>')" class="LINK">edit</a>&nbsp;
							<%}%>                                                    
							<%if (isRepEdit) {%> 
							<a href="javascript:goVerifier('<%=id%>')" class="LINK">monitor</a>&nbsp;
							<a href="javascript:doDelete('<%=id%>')" class="LINK">delete</a>
							<%}%>
							<%if (userContext != null && isRepEdit) {%> 
							&nbsp;<a href="perm/reportPermissions.jsp?reportId=<%=rep.getId()%>" class="LINK">permissions</a>
							<%}%>
							<%if(isExecutable){ %>
							&nbsp;<a href="javascript:doGenerate('<%=id%>')" class="LINK">generate</a>
							<%}%>
							</nobr>
							</td>
							</tr>

              <%}%>
          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		