<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY = "../";
%>
     
<%
  String ERROR_OBJ = "ERROR_OBJ";
  
	WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.AutomationPermissions.SCHEDULER_PERMISSION,true)){
    return;
  }

	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	//UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
	UserContext userContext = UserEnvironment.getUserContext(request);
	MetaDataManager metaDataMgr = mgmt.getMetaDataMgr();

	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	ErrorModel errmodel = new ErrorModel(); 

  SchedulingMgr schmgr = XpoLogScheduleFactory.getSchdulingManager();
  List list = schmgr.getXpoOpslByFilter(null,userContext);

	HashSet metaDataJobs = new HashSet();
  String[] jobsIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,XpoLogObjectTypes.SCHEDULER_TYPE);
	if (jobsIds != null){
		for (int i=0; i<jobsIds.length; i++){
			metaDataJobs.add(jobsIds[i]);
		}
	}
  boolean isReportViewer = manager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION);
  boolean txExpoViewer = mgmt.getXpologManagment().isTransactionExpoValid();

%>

<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
  function goEdit(id){
  	path = "<%=BASE_DIRECTORY%>scheduler/jobAction.jsp?ID="+id;
  	document.location = path;
  }

  function goRun(id){
  	path = "<%=BASE_DIRECTORY%>scheduler/jobRunAction.jsp?ID=" + id;	
  	document.location = path;
  }
  function setState(id,op){
  	path = "<%=BASE_DIRECTORY%>scheduler/jobStateAction.jsp?ID=" + id;	
  	document.location = path;
  }
</script>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td height="28" colspan="6"><span class="HEADER">XpoLog Schedulers</span></td>
              </tr>
              <tr class="TABLES_HEADERS">
                <td width="18%"><span class="REGULARTEXT">Name</span></td>
                <td width="35%"><span class="REGULARTEXT">Description</span></td>
                <td width="15%"><span class="REGULARTEXT">Type</span></td>
                <td width="15%"><span class="REGULARTEXT">Status</span></td>
                <td width="20%" nowrap>&nbsp;</td>
                <td width="3%"></td>
              </tr>
              <%
	              String funcAct = "1";
	              String funcSus = "2"; 
	              String funcAtt = ""; 
	              String funcStrAct = "activate"; 
	              String funcStrSus = "suspend"; 
	              String funcStr = ""; 
	              String stateStrActive = "Active"; 
	              String stateStrSuspend = "Suspended"; 
	              String stateStr = ""; 
              	for(int i=0;i<list.size();++i) {
              	  XpoScheduledOperation sop = ((XpoScheduledOperation)list.get(i));
                  XpoJobDetails det = sop.getDetails();
                  boolean active = sop.isActive();
                  if(active){
                  	stateStr = stateStrActive;
                  	funcStr = funcStrSus;
                  	funcAtt = funcSus;
                  }else{
                  	stateStr = stateStrSuspend;
                    funcStr = funcStrAct;
                  	funcAtt = funcAct;
                  }
              %>
							<tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
								<td width="18%"><a href="javascript:goEdit('<%=det.getId()%>')" class="LINK"><%=det.getPresName()%></a></td>
								<td width="35%"><span class="REGULARTEXT"><%=det.getDescription()%></span></td>
								<td width="15%"><span class="REGULARTEXT"><%=det.getType()%></span></td>
								<td width="15%"><span class="REGULARTEXT"><%=stateStr%></span></td>
								<td width="20%" nowrap><a href="javascript:setState('<%=det.getId()%>',<%=funcAtt%>)" class="LINK"><%=funcStr%></a>&nbsp;<a href="javascript:goEdit('<%=det.getId()%>')" class="LINK">edit</a>&nbsp;
								<a href="javascript:goRun('<%=det.getId()%>')" class="LINK">run</a>
								&nbsp;<a href="javascript:doDelete('<%=det.getId()%>')" class="LINK">delete</a></td>
								<td width="3%"></td>
							</tr>
              <%}%>
          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		