<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>

<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY = "../../";
%>
     
<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.AutomationPermissions.VIEW_TASK_PERMISSION,true)){
	  return;
	}

	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	UserContext searchUserContext = (UserContext)request.getSession().getAttribute(MetaDataSearchQuery.META_DATA_USER_CONTEXT);

  XpoTaskManager taskmgr = XpoTaskManager.getInstance();
  List list = taskmgr.getXpoTasksByFilter(null,searchUserContext);

  boolean isReportViewer = manager.isHavePermission(searchUserContext,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION);
  boolean txExpoViewer = mgmt.getXpologManagment().isTransactionExpoValid();

%>

<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>
  function goEdit(id){
  	path = "<%=BASE_DIRECTORY%>tasks/taskAction.jsp?ID="+id;
  	document.location = path;
  }
  
  function doDelete(id){
		type = document.access.taskType.options[document.access.taskType.selectedIndex].value;
		path = "<%=BASE_DIRECTORY%>tasks/taskRemoveAction.jsp?ID=" + id + "&TYPE=" + type;	
  	document.location = path;
  }
</script>


<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td height="28" colspan="5"><span class="HEADER">XpoLog Tasks</span></td>
              </tr>
              <tr>
              <tr class="TABLES_HEADERS">
                <td width="18%"><span class="REGULARTEXT">Name</span></td>
                <td width="50%"><span class="REGULARTEXT">Description</span></td>
                <td width="15%"><span class="REGULARTEXT">Type</span></td>
                <td width="20%">&nbsp;</td>
                <td width="3%"></td>
              </tr>
              <%for(int t=0;t<list.size();++t) {
	              	String type = ((XpoTask)list.get(t)).getType();
	              	if (type != null && ((!isReportViewer && type.equals("reports"))) ||
	              			(!txExpoViewer && type.equals("sessionResult"))){
	              		continue;
	              	}
              %>
							<tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
								<td width="16%"><a href="javascript:goEdit('<%=((XpoTask)list.get(t)).getId()%>')" class="LINK"><%=((XpoTask)list.get(t)).getName()%></a></td>
								<td width="50%"><span class="REGULARTEXT"><%=((XpoTask)list.get(t)).getDescription()%></span></td>
								<td width="15%"><span class="REGULARTEXT"><%=((XpoTask)list.get(t)).getType()%></span></td>
								<td width="20%" nowrap>&nbsp;<a href="javascript:goEdit('<%=((XpoTask)list.get(t)).getId()%>')" class="LINK">edit</a>
								<a href="javascript:doDelete('<%=((XpoTask)list.get(t)).getId()%>')" class="LINK">delete</a></td>
								<td width="10%"></td>
							</tr>
              <%}%>
          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		