<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>

<%! 
	static final String BASE_DIRECTORY = "../../";
%>

<%@ include file="../../common/verifierTree.jsp"%>
<%
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  MetaDataManager metaDataMgr = mgmt.getMetaDataMgr();

  UserContext userContext = UserEnvironment.getUserContext(request);
  Verifier ver = mgmt.getVerifierManager().getVerfierFromId(Verifier.ROOT_VERIFIER_ID);
  
	String systemMetaDataId = request.getParameter("SystemMetaDataId");
  
	HashMap verifiersMap = null;
  String[] verifiersIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,"Verifier");
  if (verifiersIds != null){
  	verifiersMap = new HashMap();
  	for (int i=0; i<verifiersIds.length; i++){
  		verifiersMap.put(verifiersIds[i],verifiersIds[i]);
  	}
  }
  
	String treeCode = getTreeDiv(ver,userContext,verifiersMap,true,"verTree",true);

  String listTitle = "Monitorss hierarchy";
  String listDesc = "Select and save the monitors to be associated with the application.<br>";
  String listNote = "";
%>

<script src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";
</script>
<script>
	Tree.prototype.writeNodeData = writeNodeData1;
	Tree.prototype.selectTreeNode = selectTreeNode1;
	
	function writeNodeData1(node){ 
	  if (!node.isLeaf()){
	    var img = baseDirectory + (node.expand ? collapseImage : expandImage);  
	    document.writeln("<img src=\"" + img + "\" onClick=\"javascript:selectNode(" + node.index + "," + node.tree.name + ")\" id=\"ExpandImage_" + this.name + "_" + node.index + "\"  class=\"" + node.tree.nodeImageStyle + "\">");
	  }
	  var arr = node.id.split(",");
	  var nodeType = arr[0];
	  var nodeId = arr[1];
		document.writeln("&nbsp;<a href=../../verifiers/VerifierView.jsp?VERIFIER_ID="+nodeId+"><span class=\"LINK\">" + node.name + "</span></a>");
	  if (node.desc && node.desc != ""){
	     document.writeln("&nbsp;(" + node.desc + ")");
	  }
	  if (node.text && node.text != ""){
	     document.writeln("&nbsp;" + node.text);
	  }  
	}
	
	function selectTreeNode1(node){	
		var expand = !node.expand;	
		node.expand = expand;
		var expImage = document.getElementById("ExpandImage_" + node.tree.name + "_" + node.index);
		if (expImage){
		  expImage.src = "../../" + (expand ? collapseImage : expandImage);
		}
		for (var i = 0; i < node.childs.length; i++){
		  var childDiv = document.getElementById("DivNode_" + node.childs[i].tree.name + "_" + node.childs[i].index);
		  if (childDiv){
		    if (expand){
		      childDiv.style.display = "";
		    }else {
		      childDiv.style.display = "none";
		    }
		  }
		}
	}

</script>


<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse;padding-left:5;padding-top:5;" width="100%" id="AutoNumber3" height="53">                  
  <tr>
    <td width="15%" height="18"><span class="HEADER"><%=listTitle%></span><b>&nbsp;</b></td>
  </tr>
  <tr>
    <td>
       <span class="REGULARTEXT"><%=listDesc%></span>
       <span class="SMALLTEXT"><%=listNote%></span>
   </td>
	</tr>
	<tr>
		<td width="15%">
		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
			<tr>
				<td class="REGULARTEXT">
					<script>
						 var verTree = createTree("verTree");
						 <%=treeCode%>
						 verTree.onSelectMarkChilds = false;
						 verTree.writeTree();
					</script>
				</td>
			</tr>
		</table>
		</td>
	</tr> 
  <tr>
    <td height="100%">&nbsp;</td>
  </tr>                 
</table>
                