<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.automation.tasks.XpoTask"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.verifiers.*"%>

<%@ page import="java.util.HashSet"%>
<%
	VerifierManager verMgr = SiteManagment.getInstance().getVerifierManager();
	
	String alertType = request.getParameter("alertType");
	
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = "../";
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	HashSet includeSet = null;
	if (alertType != null && alertType.length() > 0){
		includeSet = new HashSet();
		includeSet.add(alertType);
	}
	UserContext userContext = UserEnvironment.getUserContext(request);
	XpoTask[] monitorsTasks = verMgr.getVerifiersTasks(includeSet, userContext);
	StringBuffer sb = new StringBuffer();
	if (monitorsTasks != null){
		XpoTask t;
		String taskId;
		String monId;
		Verifier monitor = null;
		String monitorName = null;
		int ind;
		for (int i=0; i<monitorsTasks.length; i++){
			t = monitorsTasks[i];
			if (sb.length() > 0){
				sb.append("#");
			}
			taskId = t.getId();
			if (taskId == null){
				continue;
			}
			ind = taskId.lastIndexOf("@");
			if (ind != -1){
				monId = taskId.substring(0,ind);
				taskId = taskId.substring(ind+1);
				monitor = verMgr.getVerfierFromId(monId);
				if (monitor != null){
					monitorName = monitor.getName();
					sb.append(t.getId() + "^" + (monitorName + " - " + t.getShortSummary()));
				}
			}
		}
	}
	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	out.write(sb.toString());
	out.flush();

%>