
<%@ page language="java"%>

<%@ page import="xpolog.eye.automation.tasks.XpoTask"%>
<%@ page import="xpolog.eye.automation.tasks.XpoTaskHelper"%>
<%@ page import="xpolog.eye.automation.tasks.XpoTaskManager"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.verifiers.admin.VerifierBuilder"%>

<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	String VERIFIER_BUILDER = "VERIFIER_BUILDER";
	
	VerifierBuilder builder = (VerifierBuilder)request.getSession().getAttribute(VERIFIER_BUILDER);
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String prefix = request.getParameter("prefix");
	if (prefix == null){
		prefix = "";
	}
	
	String alertGroup = request.getParameter("alertGroup");
	boolean isPositiveAlert = alertGroup != null && alertGroup.equals("positive");
	
	String alertType = request.getParameter("alertType");
	
	ErrorModel errModel = new ErrorModel();
	XpoTask task = null;
	if (alertType != null && alertType.equals("MailAlert")){
		task = XpoTaskHelper.createMailTask(request,errModel,true);
	}else if (alertType != null && alertType.equals("SNMPAlert")){
		task = XpoTaskHelper.createSNMPTask(request,errModel,true);
	}else if (alertType != null && alertType.equals("JMSAlert")){
		task = XpoTaskHelper.createJMSTask(request,errModel,true);
	}else if (alertType != null && alertType.equals("ExeAlert")){
		task = XpoTaskHelper.createExeTask(request,errModel,true);
	}
	
	String resultStr = "";
	if (task == null){
		if (errModel.getErrorCount() > 0){
			StringBuffer errBuffer = new StringBuffer();
			String[] errors = errModel.getErrors();
			for (int i=0; i<errors.length; i++){
				if (errBuffer.length() > 0){
					errBuffer.append("#");
				}
				errBuffer.append(errors[i]);
			}
			resultStr = "SAVE_ALERT_ERROR#" + errBuffer.toString();
		}else{
			resultStr = "SAVE_ALERT_ERROR#Failed to save new alert";
		}
	}else{
		String taskId = task.getId();
		String taskIdToReplace = null;
		if(XpoTaskManager.getInstance().getXpoTaskById(taskId) != null) {
			taskIdToReplace = taskId;
			taskId = String.valueOf(System.currentTimeMillis());
			task.setId(taskId);
		}
		resultStr = task.getName() + "*" + taskId;
		if (isPositiveAlert){
			builder.addClearingTask(task, taskIdToReplace);
		}else{
			builder.addFailTask(task, taskIdToReplace);
		}
	}
	
	response.setContentType("text/xml");
	out.write(resultStr.trim());
	out.flush();
%>