<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.config.MailConfig"%>
<%@ page import="xpolog.eye.automation.tasks.mail.*"%>
<%@ page import="xpolog.eye.media.mail.MailAccountFilter"%>
<%@ page import="xpolog.eye.media.AddressBook"%>
<%@ page import="xpolog.eye.media.mail.MailAccount"%>
<%@ page import="xpolog.eye.verifiers.admin.VerifierBuilder"%>

<%@ page import="java.util.List"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	String VERIFIER_BUILDER = "VERIFIER_BUILDER";
	
	VerifierBuilder builder = (VerifierBuilder)request.getSession().getAttribute(VERIFIER_BUILDER);
	
	String Name,  subject, body, fromId, toId, dataFormat="" ,suffix="";
	
	String alertType = request.getParameter("alertType");
	boolean isPositiveAlert = alertType != null && alertType.equals("positive");
	
	subject = request.getParameter("subjectId");
	if (subject == null){
		subject = "";
	}
	body = request.getParameter("bodyId");
	if (body != null){
		body = "";
	}
	fromId = request.getParameter("fromId");
	toId = request.getParameter("toId");
	Name = request.getParameter("taskNameId");
	suffix = request.getParameter("suffix");
	
	String error = "";
	if(Name == null || Name.equals("")){
		error += ("eMail task name was not supplied.\n");
	}		
 	
	MailConfig mail = xpolog.config.Configuration.getInstance().getMailConfigurationManager();
 	
 	if(fromId == null || fromId.equals("")){
 		fromId = MailTask.SYSTEM_ADDRESS_ID;
 	}
 	
 	String orgHost = mail.getSmtpHost();
	String host = request.getParameter("SMTPHost");
	String port = request.getParameter("SMTPProt");
	String systemAddress = request.getParameter("systemMailAddress");
	
	boolean mailEnabled = true;
	if(orgHost.equals(MailConfig.DEF_SMTP_ADDRESS)){ 
		mailEnabled = false;
	}
	if (!mailEnabled && host != null && host.length() > 0){
		mail.setSmtpHost(host);
		mail.setSystemMailAddress(systemAddress);
		try {
			mail.setSmtpPort(Integer.parseInt(port));
		} catch (Exception e) {
		}
		mail.saveMailSettings();
	}
	
 	if(toId == null || toId.equals("")) {
 		error += ("eMail address 'to' was not supplied.\n");
 	}
 	
 	//making sure
 	if(dataFormat == null || dataFormat.length() == 0) {
 		dataFormat = "NONE";
 	}
 	if(suffix == null){
 		suffix = "";
 	}
  	  	
  //check if mail acc exist,create ne one if not
  MailAccount fromMailAcc = null;
  MailAccount toMailAcc = null;
	AddressBook adbok = AddressBook.getInstance();
	List accList = adbok.getAccountsByFilter(new MailAccountFilter());
	for(int i = 0 ; accList != null && i < accList.size() ; i++){
		MailAccount mtac = (MailAccount)accList.get(i);
		if(mtac != null && mtac.getMailAddress() != null && mtac.getMailAddress().equals(fromId)){
			fromMailAcc = mtac;
		}		
		if(mtac != null && mtac.getMailAddress() != null && mtac.getMailAddress().equals(toId)){
			toMailAcc = mtac;
		}		
	}
	if(fromMailAcc == null){
		fromMailAcc = new MailAccount();
		fromMailAcc.setMailAddress(fromId);
		fromMailAcc.setAccountName(fromId);
		fromMailAcc.setFirstName(Name);	
		fromMailAcc.setDescription("");
		if (fromId.equals(MailTask.SYSTEM_ADDRESS_ID)){
			fromMailAcc.setId(fromId);	
		}else{
			fromMailAcc.setId(String.valueOf(System.currentTimeMillis()));
		}
		
	}
	
	if(toMailAcc == null){
		if(toId.equals(fromId)){
			toMailAcc = fromMailAcc;
		}else{
			toMailAcc = new MailAccount();
			toMailAcc.setMailAddress(toId);
			toMailAcc.setAccountName(toId);
			toMailAcc.setFirstName(Name);	
			toMailAcc.setDescription("");
			toMailAcc.setId(String.valueOf(System.currentTimeMillis()));
		}
	}

	//create new task
	MailTask task = new MailTask();
	
	task.setName(Name);
	task.setDescription("");
	task.setSubject(subject);
	task.setBody(body);
	task.setFromId(fromMailAcc.getId());
	task.setToId(toMailAcc.getId());
	task.setDataFormat(dataFormat);
	task.setId(String.valueOf(System.currentTimeMillis()));
	if (isPositiveAlert){
		builder.addClearingTask(task);
	}else{
		builder.addFailTask(task);
	}
	
	String resultStr = error.length() > 0 ? "errorWhileSave"  : task.getName() + "*" + task.getId() + "*" + suffix;
	response.setContentType("text/xml");
	out.write(resultStr.trim());
	out.flush();
%>