<%@ page language="java"%>

<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.mail.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.media.AddressBook"%>
<%@ page import="xpolog.eye.media.mail.MailAccount"%>
<%@ page import="xpolog.eye.media.mail.MailAccountFilter"%>
<%@ page import="xpolog.eye.site.*" %>

<%@ page import="java.util.List"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	String Name,  Subject, Body, fromId, toId, dataFormat="" ,suffix="";
	
	Subject = request.getParameter("subjectId");
	Body = request.getParameter("bodyId");
	fromId = request.getParameter("fromId");
	toId = request.getParameter("toId");
	Name = request.getParameter("taskNameId");
	suffix = request.getParameter("suffix");
	
	String error = "";
	if(Name == null || Name.equals("")){
		error += ("eMail task name was not supplied.\n");
	}		
 	
 	if(fromId == null || fromId.equals("")){
 		error += ("eMail address 'from' was not supplied.\n");
 	}
 	
 	if(toId == null || toId.equals("")) {
 		error += ("eMail address 'to' was not supplied.\n");
 	}
 	
 	
 	//making sure
 	if(dataFormat == null || dataFormat.length() == 0) {
 		dataFormat = "NONE";
 	}
 	if(suffix == null){
 		suffix = "";
 	}
  	  	
  //check if mail acc exist,create ne one if not
  MailAccount fromMailAcc = null;
  MailAccount toMailAcc = null;
	AddressBook adbok = AddressBook.getInstance();
	List accList = adbok.getAccountsByFilter(new MailAccountFilter());
	for(int i = 0 ; accList != null && i < accList.size() ; i++){
		MailAccount mtac = (MailAccount)accList.get(i);
		if(mtac != null && mtac.getMailAddress() != null && mtac.getMailAddress().equals(fromId)){
			fromMailAcc = mtac;
		}		
		if(mtac != null && mtac.getMailAddress() != null && mtac.getMailAddress().equals(toId)){
			toMailAcc = mtac;
		}		
	}
	if(fromMailAcc == null){
		fromMailAcc = new MailAccount();
		fromMailAcc.setMailAddress(fromId);
		fromMailAcc.setAccountName(fromId);
		fromMailAcc.setFirstName(Name);	
		fromMailAcc.setDescription("");
		
		adbok.addAccount(fromMailAcc,userContext);
		adbok.saveAddressBook();
		//	audit
		AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
			  			userContext, AuditConstants.CHANGE, "add account", AuditConstants.CONFIGURATION, "add mail account " + fromId);
	}
	if(toMailAcc == null){
		if(toId.equals(fromId)){
			toMailAcc = fromMailAcc;
		}else{
			toMailAcc = new MailAccount();
			toMailAcc.setMailAddress(toId);
			toMailAcc.setAccountName(toId);
			toMailAcc.setFirstName(Name);	
			toMailAcc.setDescription("");
			
			adbok.addAccount(toMailAcc,userContext);
			adbok.saveAddressBook();
			//	audit
			AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
				  			userContext, AuditConstants.CHANGE, "add account", AuditConstants.CONFIGURATION, "add mail account " + toId);
		}
	}

	//create new task
	MailTask task = new MailTask();
	XpoTaskManager taskmgr = XpoTaskManager.getInstance();
	
	task.setName(Name);
	task.setDescription("");
	task.setSubject(Subject);
	task.setBody(Body);
	task.setFromId(fromMailAcc.getId());
	task.setToId(toMailAcc.getId());
	task.setDataFormat(dataFormat);
	
	//taskmgr.addXpoTask(task,userContext);
	//taskmgr.saveXpoTasks();
	
    //audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "task added/edited", AuditConstants.TASKS, "mail task added/edited " + Name);

	String resultStr = error.length() > 0 ? "errorWhileSave"  : task.getName() + "*" + task.getId() + "*" + suffix;
	response.setContentType("text/xml");
	out.write(resultStr.trim());
	out.flush();
%>