<%@ page language="java"%>

<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.scheduler.ui.*"%>
<%@ page import="xpolog.eye.automation.tasks.mail.MailTask"%>
<%@ page import="xpolog.eye.automation.tasks.XpoTask"%>
<%@ page import="xpolog.eye.verifiers.admin.VerifierBuilder"%>

<%@ page import="java.util.*"%>

<%!static final String BASE_DIRECTORY = "../";
%>
<%

	String VERIFIER_BUILDER = "VERIFIER_BUILDER";

	VerifierBuilder builder = (VerifierBuilder)request.getSession().getAttribute(VERIFIER_BUILDER);
	if (builder == null){
		return;
	}
	
	
	String suffix = "MonitorSched";
	String name = "monitorScheduler";
	String id = "monitorId_" + System.currentTimeMillis();
	
	XpoScheduledOperation schedOp = builder.getSchedOp();
	JobBuilder jobBuilder = new JobBuilder();
	if (schedOp != null){
		if (schedOp instanceof MultiScheduledOperation){
			List schedOps = ((MultiScheduledOperation)schedOp).getSchedOps();
			jobBuilder = new MultiJobBuilder(schedOps);
		}else{
	  	jobBuilder = new VerifierJobBuilder(schedOp);
		}
	  jobBuilder.updateFromOp();
	  name = jobBuilder.getName();
	  id = jobBuilder.getId();
	}			
	request.setAttribute("CURRENT_JOB",jobBuilder);
	request.setAttribute("ONLY_SCHEDULING","true");
	request.setAttribute("suffix",suffix);
	
	MailTask mailTask = null;
	List tasks = null;//builder.getTasks();
	if (tasks != null && tasks.size() > 0){
		XpoTask task = (XpoTask)tasks.get(0);
		if (task instanceof MailTask){
			mailTask = (MailTask)task;
		}
	}
	String mailTo = "";
	String mailSubject = "";
	if (mailTask != null){
		mailTo = mailTask.getToId();
		mailSubject = mailTask.getSubject();
	}
%>



<input type="hidden" name="Name<%=suffix%>" value="<%=name%>">
<input type="hidden" name="Id<%=suffix%>" value="<%=id%>">
<input type="hidden" name="actionId<%=suffix%>" value="0">
<input type="hidden" name="State<%=suffix%>" value="<%=XpoScheduledOperation.STATE_ACTIVE%>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>
		<td style="padding-top:20px;padding-right:10px">
			<jsp:include page="../scheduler/newScheduler.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="allowMulti" value="true" />
			</jsp:include>
		</td>
	</tr>
</table>
