<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.verifiers.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
	SimpleDateFormat format = new SimpleDateFormat("MM/dd/yyyy HH:mm:ss");
%>

<%
   //update menu tree
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	final UserContext userContext = UserEnvironment.getUserContext(request);
	
	Verifier mon = null;
	String verId = request.getParameter("MONITOR_ID");
	
	String useProgressRunnerStr = request.getParameter("useProgressRunner");
	boolean useProgressRunner = useProgressRunnerStr != null && useProgressRunnerStr.equals("true");
	
	VerifierManager verManager = SiteManagment.getInstance().getVerifierManager();
	 
	if (verId != null && verId.length() > 0){
		mon = verManager.getVerfierFromId(verId);
	}else {
		mon = (Verifier) request.getSession().getAttribute("CURRENT_VERIFIER");
	}
	
	if (useProgressRunner){
		final Verifier monitor = mon;
		ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "/monitor/monitorsView.jsp") {
		  public void run(HttpServletRequest request){
		  	if (monitor != null){
		  		//audit
					AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
							userContext, AuditConstants.CHANGE, "execute monitor", AuditConstants.VERIFIERS, "execute monitor " + monitor.getName() + " manually");
		  		try{
		  			monitor.execute(userContext,true,true);
		  		}catch(Exception e){
		  			errmodel.addError("Failed to execute monitor " + monitor.getName() + ":");
		  			errmodel.addError(e.getMessage());
		  			createErrorRedirect(request,BASE_DIRECTORY);
		  		}
		  	}
		  }
		};
		env.setProgressRunner(runner);
	}else{
		//audit
		AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
				userContext, AuditConstants.CHANGE, "execute monitor", AuditConstants.VERIFIERS, "execute monitor " + mon.getName() + " manually");
		mon.execute(userContext,true,true);
	}
	
	
%>

<% if (useProgressRunner){ %>
<jsp:include page="../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Running monitor"/>
</jsp:include>
<%}%>