<%@ page language="java"%>

<%@ page import="java.text.NumberFormat"%>
<%@ page import="java.util.Date"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfigurationHelper"%>
<%@ page import="xpolog.eye.computation.TopComputationResult"%>
<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.managment.XpologManagment"%>
<%@ page import="xpolog.eye.reports.health.ui.DashboardAlert"%>
<%@ page import="xpolog.eye.reports.health.ui.DashboardAlertsManager"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewGraphQuery"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewGraphResult"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewHelper"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModelHelper"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewResult"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>
<%@page import="xpolog.eye.computation.impl.MultiHostComputationResults"%>
<%@page import="xpolog.eye.util.hosts.measurements.impl.HostDiskSpace"%>
<%@page import="xpolog.eye.util.hosts.measurements.impl.HostMemory"%>
<%@page import="xpolog.eye.util.hosts.measurements.impl.HostCpu"%>
<%@page import="xpolog.eye.util.hosts.measurements.computation.HostMeasurementTotals"%>
<%@page import="xpolog.eye.util.XpologUtil"%>

<%!
static final String BASE_DIRECTORY = "../";

%>

<%
String baseDirectory = request.getParameter("baseDirectory");
if(baseDirectory == null) {
	baseDirectory = BASE_DIRECTORY;
}
UserContext userContext = UserEnvironment.getUserContext(request);
HealthViewModel model = (HealthViewModel)request.getAttribute("homeCurrModel");
List recentAlerts = DashboardAlertsManager.getInstance().getRecentAlerts(userContext,10);
%>

<td class="HOME_PAGE_DASHBOARD_ALERTS_TOP_CELL">
<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
	<tr height="10px">
		<td>
		<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
			<tr height="10px">
				<td class="HOME_PAGE_DASHBOARD_SUB_TITLE_TEXT HOME_PAGE_DASHBOARD_ALERTS_TITLE_CELL">Recent Alerts</td>
			</tr>
			<%
													if(recentAlerts.size() > 0) {
													%>
			<tr>
				<td class="HOME_PAGE_DASHBOARD_ALERTS_TABLE_CELL">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
					<tr height="10px">
						<td class="HOME_PAGE_DASHBOARD_ALERTS_GENERAL_CELL HOME_PAGE_DASHBOARD_ALERTS_HEADER_CELL">Target</td>
						<td class="HOME_PAGE_DASHBOARD_ALERTS_GENERAL_CELL HOME_PAGE_DASHBOARD_ALERTS_HEADER_CELL" style="width: 80px;">Severity</td>
						<td class="HOME_PAGE_DASHBOARD_ALERTS_GENERAL_CELL HOME_PAGE_DASHBOARD_ALERTS_HEADER_CELL">Time</td>
						<td
							class="HOME_PAGE_DASHBOARD_ALERTS_GENERAL_CELL HOME_PAGE_DASHBOARD_ALERTS_HEADER_CELL HOME_PAGE_DASHBOARD_ALERTS_GENERAL_RIGHT_CELL"
							style="width: 30px;">&nbsp;</td>
					</tr>
					<%
																if(recentAlerts != null && recentAlerts.size() > 0) {
																	DashboardAlert alert = null;
																	String typeDisplay, name, riskText, executionTimeStr;
																	String zoomInLink = null, zoomInMmouseActionsString = null;
																	double risk;
																	String riskTextClassName = null;
																	String rowClassName = "";
																	String rowId = "";
																	for(int i = 0; i < recentAlerts.size(); i++) {
																		alert = (DashboardAlert)recentAlerts.get(i);
																		
																		typeDisplay = alert.getXpologObjectTypeDisplay();
																		name = alert.getXpologObjectName();
																		name = XpologUtil.updateAsHtmlString(name);
																		risk = alert.getRisk();																		
																		riskText = alert.getRiskText();
																		if (name == null || name.length() == 0){
																			if (typeDisplay == null || typeDisplay.length() == 0 || typeDisplay.equals("Global")){
																				name = "Global";
																			}else {
																				name = "&nbsp;";
																			}
																		}
																		executionTimeStr = alert.getExecutionTimeStr();
																		
																		if(risk > 0) {
																			riskTextClassName = "HOME_PAGE_DASHBOARD_ALERTS_STATUS_CELL_" + HealthViewModelHelper.getRiskClassNameSuffix(risk);
																		}else {
																			riskTextClassName = "HOME_PAGE_DASHBOARD_ALERTS_STATUS_CELL_0";
																		}
																		
																		zoomInLink = baseDirectory + "componentAction.jsp?selectedCompId=" + XpologManagment.ANALYTICS_COMPONENT + "&forward=root.jsp?mainPage=dashboard/view/loadObjectDashboardModel.jsp%253FobjectType=" + alert.getXpologObjectType() + "%2526objectId=" + alert.getXpologObjectId() + "%2526startTime=" + alert.getStartTime() + "%2526endTime=" + alert.getEndTime();
																		zoomInMmouseActionsString = "onMouseOver=\"javascript:showTooltip(homePageTooltips['showAlert'])\" onMouseOut=\"javascript:hideTooltip()\"";
																		
																		boolean showZoomInLink = zoomInLink != null;
									
																		if(i % 2 == 0) {
																			rowClassName = "HOME_PAGE_DASHBOARD_ALERTS_COLORED_ROW";
																		}else {
																			rowClassName = "HOME_PAGE_DASHBOARD_ALERTS_REGULAR_ROW";
																		}
																		
																		rowId = "topMessagesRow_" + i;
																	%>
					<tr id="<%=rowId %>" class="<%=rowClassName %>" height="10px">
						<td class="HOME_PAGE_DASHBOARD_ALERTS_GENERAL_CELL HOME_PAGE_DASHBOARD_ALERTS_CELL"><%=typeDisplay + " " + name %></td>
						<td class="HOME_PAGE_DASHBOARD_ALERTS_GENERAL_CELL HOME_PAGE_DASHBOARD_ALERTS_STATUS_CELL <%=riskTextClassName %>"><%=HealthViewModelHelper.getFormattedRisk(risk) %></td>
						<td class="HOME_PAGE_DASHBOARD_ALERTS_GENERAL_CELL HOME_PAGE_DASHBOARD_ALERTS_CELL"><%=executionTimeStr %></td>
						<td class="HOME_PAGE_DASHBOARD_ALERTS_GENERAL_CELL HOME_PAGE_DASHBOARD_ALERTS_IMAGES_CELL">
						<%
																		if(showZoomInLink) {
																		%> <a href="<%=zoomInLink %>" <%=zoomInMmouseActionsString %>> <img
							src="<%=baseDirectory %>images/dashboard/topMessages/tableRowZoom.gif" border="0"> </a> <%
																		}else {
																		%> &nbsp; <%
																		}
																		%>
						</td>
					</tr>
					<%
																	}
																}
																%>
					<tr>
						<td class="HOME_PAGE_DASHBOARD_ALERTS_GENERAL_BOTTOM_CELL" colspan="4">&nbsp;</td>
					</tr>
					<tr>
						<td style="font-size: 0px; height: 0px;"></td>
					</tr>
				</table>
				</td>
			</tr>
			<%
													}else {
													%>
			<tr height="10px">
				<td class="HOME_PAGE_DASHBOARD_ALERTS_CELL">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
					<tr>
						<td
							class="HOME_PAGE_DASHBOARD_ALERTS_GENERAL_CELL HOME_PAGE_DASHBOARD_ALERTS_HEADER_CELL HOME_PAGE_DASHBOARD_ALERTS_GENERAL_RIGHT_CELL">No
						alerts exist</td>
					</tr>
					<tr>
						<td class="HOME_PAGE_DASHBOARD_ALERTS_GENERAL_BOTTOM_CELL">&nbsp;</td>
					</tr>
				</table>
				</td>
			</tr>
			<tr>
				<td style="font-size: 0px; height: 0px;"></td>
			</tr>
			<%
													}
													%>
		</table>
		</td>
	</tr>
	<tr>
		<td>&nbsp;</td>
	</tr>
</table>
</td>