<%@ page language="java"%>

<%@ page import="java.text.NumberFormat"%>
<%@ page import="java.util.Date"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfigurationHelper"%>
<%@ page import="xpolog.eye.computation.TopComputationResult"%>
<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.reports.health.ui.DashboardAlert"%>
<%@ page import="xpolog.eye.reports.health.ui.DashboardAlertsManager"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewGraphQuery"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewGraphResult"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewHelper"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModelHelper"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewResult"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>
<%@page import="xpolog.eye.computation.impl.MultiHostComputationResults"%>
<%@page import="xpolog.eye.util.hosts.measurements.impl.HostDiskSpace"%>
<%@page import="xpolog.eye.util.hosts.measurements.impl.HostMemory"%>
<%@page import="xpolog.eye.util.hosts.measurements.impl.HostCpu"%>
<%@page import="xpolog.eye.util.hosts.measurements.computation.HostMeasurementTotals"%>
<%@page import="xpolog.eye.util.XpologUtil"%>

<%!
static final String BASE_DIRECTORY = "../";

%>

<%
String baseDirectory = request.getParameter("baseDirectory");
if(baseDirectory == null) {
	baseDirectory = BASE_DIRECTORY;
}

HealthViewModel model = (HealthViewModel)request.getAttribute("homeCurrModel");
HealthViewResult currentResult = model.getCurrentResult();
TopComputationResult[] topResultsElements = currentResult.getRootNodeResultElement().getComputationResults().getTopResults();

DateFilter dateFilter = model.getTimeFilter();
Date minDate = dateFilter.getMinDate();
Date maxDate = dateFilter.getMaxDate();

boolean showSourceColumn = true;
String sourceText = "";
if(showSourceColumn) {
  if(model.getViewBy().equals(HealthViewContext.VIEW_BY_FOLDERS)) {
    sourceText = "Folder/Log";
  }else if(model.getViewBy().equals(HealthViewContext.VIEW_BY_APPLICATIONS)) {
    sourceText = "Application";
  }else if(model.getViewBy().equals(HealthViewContext.VIEW_BY_SERVERS)) {
    sourceText = "Server";
  }
}


NumberFormat numberFormat = NumberFormat.getNumberInstance();
numberFormat.setMaximumFractionDigits(2);


%>


<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_TOP_CELL">
											<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
												<tr height="10px">
													<td>
														<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
															<tr height="10px">
																<td class="HOME_PAGE_DASHBOARD_SUB_TITLE_TEXT HOME_PAGE_DASHBOARD_TOP_MESSAGES_TITLE_CELL">Recent Problems</td>
															</tr>
															<%
															if(topResultsElements != null && topResultsElements.length > 0) {
															%>
															<tr height="10px">
																<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_TABLE_CELL">
																	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
																		<tr height="10px">
																			<%
																			if(showSourceColumn) {
																			%>
																			<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_HEADER_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_SOURCE_CELL"><%=sourceText %></td>
																			<%
																			}
																			%>
																			<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_HEADER_CELL">Problem</td>
																			<!--<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_HEADER_CELL" style="width: 100px;">Type</td>
																			<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_HEADER_CELL" style="width: 120px;"># of Occurrences</td>-->
																			<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_HEADER_CELL" style="width: 80px;">Severity</td>
																			<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_HEADER_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_RIGHT_CELL" style="width: 30px;">&nbsp;</td>
																		</tr>
																		<%
																		if(topResultsElements != null && topResultsElements.length > 0) {
																			TopComputationResult topResults = null;
																			String sourceId = null, parentName = null, id = null, idForJavaScript = null, name = null, longName = null, type = null;
																			String nameMouseActionsString = null;
																			String zoomInLink = null, zoomInMmouseActionsString = null;
																			long total;
																			double risk;
																			String riskTextClassName = null;
																			String rowClassName = "";
																			String rowId = "";
																			int limit = topResultsElements.length;
																			for(int i = 0; i < limit; i++) {
																				topResults = topResultsElements[i];
																				sourceId = topResults.getSourcesStr(",");
																				parentName = topResults.getParent() == null ? "N/A" : topResults.getParent().getName();
																				id = topResults.getId();
																				idForJavaScript = id;
																				idForJavaScript = XpologUtil.updateAsHtmlString(idForJavaScript);
																				idForJavaScript = XpologUtil.replaceAll(idForJavaScript, "'", "\\'");
																				name = topResults.getName();
																				name = XpologUtil.updateAsHtmlString(name);
																				type = topResults.getType();
																				total = topResults.getTotal();
																				risk = topResults.getWeight();
																				
																				rowId = "topMessagesRow_" + i;
																				
																				if (name != null && name.length() > 37){
																					longName = name;
																					name = name.substring(0,35) + "...";
																				}else{
																					longName = null;
																				}
		
																				
																				if(risk > 0) {
																					riskTextClassName = "HOME_PAGE_DASHBOARD_TOP_MESSAGES_STATUS_CELL_" + HealthViewModelHelper.getRiskClassNameSuffix(risk);
																				}else {
																					riskTextClassName = "HOME_PAGE_DASHBOARD_TOP_MESSAGES_STATUS_CELL_0";
																				}
																				if(longName != null){
																					nameMouseActionsString = "onMouseOver=\"javascript:showTooltip('" + longName + "')\" onMouseOut=\"javascript:hideTooltip()\"";
																				}else{
																					nameMouseActionsString = "";
																				}
																				
																				if(type.equals(XpoLogObjectTypes.FILTER_TYPE) ||
																					 type.equals(XpoLogObjectTypes.KNOWLEDGE_TYPE)) {
																						boolean isKnowledge = type.equals(XpoLogObjectTypes.KNOWLEDGE_TYPE);
																						zoomInLink = "javascript:openLogFromDashboard('" + baseDirectory + "','" + sourceId + "', '" + idForJavaScript + "', '" + isKnowledge + "', 'false',document.getElementById('" + rowId + "'),false,'HomePageHealthViewModel')";
																						zoomInMmouseActionsString = "onMouseOver=\"javascript:showTooltip(homePageTooltips['zoomIntoTopMessagesNode'])\" onMouseOut=\"javascript:hideTooltip()\"";
																				}else {
																					zoomInLink = null;
																					zoomInMmouseActionsString = "";
																				}
																				boolean showZoomInLink = zoomInLink != null;
											
																				if(i % 2 == 0) {
																					rowClassName = "HOME_PAGE_DASHBOARD_TOP_MESSAGES_COLORED_ROW";
																				}else {
																					rowClassName = "HOME_PAGE_DASHBOARD_TOP_MESSAGES_REGULAR_ROW";
																				}
																				
																				
																		%>
																			<tr id="<%=rowId %>" class="<%=rowClassName %>" height="10px">
																				<%
																				if(showSourceColumn) {
																				%>
																				<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_CELL"><%=parentName %></td>
																				<%
																				}
																				%>
																				<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_CELL" <%=nameMouseActionsString %>>
																				<%
																				if(false && showZoomInLink) {
																				%>
																					<a href="<%=zoomInLink %>" class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_CELL_LINK" <%=zoomInMmouseActionsString %>>
																				<%
																				}
																				%>
																					<%=name %>
																				<%
																				if(showZoomInLink) {
																				%>
																					</a>
																				<%
																				}
																				%>
																				</td>
																				<!--<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_CELL"><%=HealthViewModelHelper.getFormattedProblemType(type) %></td>
																				<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_NUMERIC_CELL"><%=numberFormat.format(total) %></td>-->
																				<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_STATUS_CELL <%=riskTextClassName %>"><%=HealthViewModelHelper.getFormattedRisk(risk) %></td>
																				<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_IMAGES_CELL">
																				<%
																				if(showZoomInLink) {
																				%>
																					<a href="<%=zoomInLink %>" <%=zoomInMmouseActionsString %>>
																						<img src="<%=baseDirectory %>images/dashboard/topMessages/tableRowZoom.gif" border="0">
																					</a>
																				<%
																				}else {
																				%>
																				&nbsp;
																				<%
																				}
																				%>
																				</td>
																			</tr>
																		<%
																			}
																		}
																		%>
																		<tr height="0px">
																			<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_BOTTOM_CELL" colspan="<%=showSourceColumn ? 4 : 3 %>">&nbsp;</td>
																		</tr>
																		<tr><td style="font-size: 0px; height: 0px;"></td></tr>
																	</table>
																</td>
															</tr>
															<%
															}else {
															%>
															<tr height="10px">
																<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_TABLE_CELL">
																	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
																		<tr>
																			<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_HEADER_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_RIGHT_CELL">No problems were found</td>
																		</tr>
																	</table>
																</td>
															</tr>
															<tr height="0px">
																<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_BOTTOM_CELL">&nbsp;</td>
															</tr>
															<%
															}
															%>
															<tr><td style="font-size: 0px; height: 0px;"></td></tr>
														</table>
													</td>
												</tr>
												<tr><td>&nbsp;</td></tr>
											</table>
										</td>