<%@ page language="java"%>

<%@ page import="java.text.NumberFormat"%>
<%@ page import="java.util.Date"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfigurationHelper"%>
<%@ page import="xpolog.eye.computation.TopComputationResult"%>
<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.managment.XpologManagment"%>
<%@ page import="xpolog.eye.reports.health.ui.DashboardAlert"%>
<%@ page import="xpolog.eye.reports.health.ui.DashboardAlertsManager"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewGraphQuery"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewGraphResult"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewHelper"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModelHelper"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewResult"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>
<%@page import="xpolog.eye.computation.impl.MultiHostComputationResults"%>
<%@page import="xpolog.eye.util.hosts.measurements.impl.HostDiskSpace"%>
<%@page import="xpolog.eye.util.hosts.measurements.impl.HostMemory"%>
<%@page import="xpolog.eye.util.hosts.measurements.impl.HostCpu"%>
<%@page import="xpolog.eye.util.hosts.measurements.computation.HostMeasurementTotals"%>
<%@page import="xpolog.eye.util.XpologUtil"%>

<%!
static final String BASE_DIRECTORY = "../";

%>

<%
String baseDirectory = request.getParameter("baseDirectory");
if(baseDirectory == null) {
	baseDirectory = BASE_DIRECTORY;
}

HealthViewModel model = (HealthViewModel)request.getAttribute("homeCurrModel");
MultiHostComputationResults [] topServers = model.getSortedHostsComputationResults();

DateFilter dateFilter = model.getTimeFilter();
Date minDate = dateFilter.getMinDate();
Date maxDate = dateFilter.getMaxDate();

%>


<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_TOP_CELL">
<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
	<tr height="10px">
		<td>
		<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
			<tr height="10px">
				<td class="HOME_PAGE_DASHBOARD_SUB_TITLE_TEXT HOME_PAGE_DASHBOARD_ALERTS_TITLE_CELL">Recent Servers Metrics</td>
			</tr>
			<%
													if(topServers.length > 0) {
													%>
			<tr height="10px">
				<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_TABLE_CELL">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
					<tr height="10px">

						<td
							class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_HEADER_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_SOURCE_CELL">Servers</td>
						<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_HEADER_CELL"
							style="width: 40px; padding-left: 10">Metrics</td>
						<td
							class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_HEADER_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_RIGHT_CELL"
							style="width: 20px;">&nbsp;</td>
					</tr>
					<%
																if(topServers.length > 0) {
																	MultiHostComputationResults topResults = null;
																	String sourceId = null, parentName = null, id = null, name = null, longName = null, type = null;
																	String nameMouseActionsString = null;
																	String zoomInLink = null, zoomInMmouseActionsString = null;
																	long total;
																	double risk;
																	String riskTextClassName = null;
																	String rowClassName = "";
																	String rowId = "";
																	int limit = topServers.length;
																	for(int i = 0; i < limit; i++) {
																		topResults = topServers[i];
																		sourceId = topResults.getName();
																		id = topResults.getId();
																		name = topResults.getName();
																		name = XpologUtil.updateAsHtmlString(name);
																		type = topResults.getType();
																		total = topResults.getTotal();
																		risk = topResults.getWeight();
																		
																		String cpuRiskBgSuffix = "0", memoryRiskBgSuffix = "0", diskSpaceRiskBgSuffix = "0";
																		boolean cpuIsDisabled = true;
																		boolean memoryIsDisabled = true;
																		boolean diskSpaceIsDisabled = true;
																		HostMeasurementTotals hostMeasurementTotals = topResults.getHostMeasurementTotals(HostCpu.HOST_CPU_TYPE);																		
																		if(hostMeasurementTotals != null) {
																			cpuIsDisabled = false;
																		}
																		double cpuRisk = topResults.getWeightByGroupType(HostCpu.HOST_CPU_TYPE);																		 
																		if(cpuRisk >= 0) {
																			cpuRiskBgSuffix = String.valueOf(HealthViewModelHelper.getRiskClassNameSuffix(cpuRisk));
																		}else {
																			cpuRiskBgSuffix = "0";
																		}
																		String cpuTitle = "CPU OK";
																		if (cpuIsDisabled){
																			cpuTitle = "No CPU data is available";
																		}else if (cpuRisk >= 3){
																			cpuTitle = "CPU Problem";
																		}
																		
																		hostMeasurementTotals = topResults.getHostMeasurementTotals(HostMemory.HOST_MEMORY_TYPE);
																		if(hostMeasurementTotals != null) {
																			memoryIsDisabled = false;
																		}
																		double memoryRisk = topResults.getWeightByGroupType(HostMemory.HOST_MEMORY_TYPE);
																		if(memoryRisk >= 0) {
																			memoryRiskBgSuffix = String.valueOf(HealthViewModelHelper.getRiskClassNameSuffix(memoryRisk));
																		}else {
																			memoryRiskBgSuffix = "0";
																		}
																		
																		String memoryTitle = "Memory OK";
																		if (memoryIsDisabled){
																			memoryTitle = "No Memory data is available";
																		}else if (memoryRisk >= 3){
																			memoryTitle = "Memory Problem";
																		}
																		hostMeasurementTotals = topResults.getHostMeasurementTotals(HostDiskSpace.HOST_DISK_SPACE_TYPE);
																		if(hostMeasurementTotals != null) {
																			diskSpaceIsDisabled = false;
																		}
																		double diskSpaceRisk = topResults.getWeightByGroupType(HostDiskSpace.HOST_DISK_SPACE_TYPE);
																		if(diskSpaceRisk >= 0) {
																			diskSpaceRiskBgSuffix = String.valueOf(HealthViewModelHelper.getRiskClassNameSuffix(diskSpaceRisk));
																		}else {
																			diskSpaceRiskBgSuffix = "0";
																		}
																		
																		String diskSpaceTitle = "Disk Space OK";
																		if (diskSpaceIsDisabled){
																			diskSpaceTitle = "No Disk Space data is available";
																		}else if (diskSpaceRisk >= 3){
																			diskSpaceTitle = "Disk Space Problem";
																		}
																		
																		rowId = "topServersRow_" + i;
																		
																		String link = baseDirectory + "componentAction.jsp?selectedCompId=" + XpologManagment.ANALYTICS_COMPONENT + "&forward=root.jsp?mainPage=dashboard/view/loadObjectDashboardModel.jsp%253F";
																		StringBuffer buffer = new StringBuffer();
																		buffer.append("objectType=");
																		buffer.append(XpoLogObjectTypes.HOST_TYPE);
																		buffer.append("&objectId=");
																		buffer.append(id);
																		buffer.append("&startTime=");
																		buffer.append(minDate == null ? -1 : minDate.getTime());
																		buffer.append("&endTime=");
																		buffer.append(maxDate == null ? -1 : maxDate.getTime());
																		String queryString = buffer.toString();
																		queryString = XpologUtil.replaceAll(queryString, "&", "%26");
																		queryString = XpologUtil.replaceAll(queryString, "%", "%25");
																		link += queryString;
																		zoomInLink = link;																		
																		zoomInMmouseActionsString = "onMouseOver=\"javascript:showTooltip(homePageTooltips['zoomIntoTopServerNode'])\" onMouseOut=\"javascript:hideTooltip()\"";
																	
																		if(i % 2 == 0) {
																			rowClassName = "HOME_PAGE_DASHBOARD_TOP_MESSAGES_COLORED_ROW";
																		}else {
																			rowClassName = "HOME_PAGE_DASHBOARD_TOP_MESSAGES_REGULAR_ROW";
																		}
																		
																		
																%>
					<tr id="<%=rowId %>" class="<%=rowClassName %>" height="10px">

						<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_CELL"><%=name%></td>
						<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_CELL HOME_PAGE_DASHBOARD_CMDS_CELL" style="width: 40px;">
						<table border="0" cellpadding="0" cellspacing="0">
							<tr>
								<td align="center"><img
									src="<%=baseDirectory%>images/dashboard/mainTable/cpu<%=cpuIsDisabled ? "Disabled" : cpuRiskBgSuffix %>.gif" border="0"
									onMouseOver="javascript:showTooltip('<%=cpuTitle%>')" onMouseOut="javascript:hideTooltip()"></td>
								<td style="font-size: 2px">&nbsp;&nbsp;</td>
								<td align="center"><img
									src="<%=baseDirectory%>images/dashboard/mainTable/memory<%=memoryIsDisabled ? "Disabled" : memoryRiskBgSuffix %>.gif" border="0"
									onMouseOver="javascript:showTooltip('<%=memoryTitle%>')" onMouseOut="javascript:hideTooltip()"></td>
								<td style="font-size: 2px">&nbsp;&nbsp;</td>
								<td align="center"><img
									src="<%=baseDirectory%>images/dashboard/mainTable/disk<%=diskSpaceIsDisabled ? "Disabled" : diskSpaceRiskBgSuffix %>.gif"
									border="0" onMouseOver="javascript:showTooltip('<%=diskSpaceTitle%>')" onMouseOut="javascript:hideTooltip()"></td>
							</tr>
						</table>

						</td>
						<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_CELL HOME_PAGE_DASHBOARD_TOP_MESSAGES_IMAGES_CELL"><a href="<%=zoomInLink %>"
							<%=zoomInMmouseActionsString%>> <img src="<%=baseDirectory %>images/dashboard/topMessages/tableRowZoom.gif" border="0"> </a></td>
					</tr>
					<%
																	}
																}
																%>
					<tr height="0px">
						<td class="HOME_PAGE_DASHBOARD_TOP_MESSAGES_GENERAL_BOTTOM_CELL" colspan="3">&nbsp;</td>
					</tr>
					<tr>
						<td style="font-size: 0px; height: 0px;"></td>
					</tr>
				</table>
				</td>
			</tr>
			<%
													}else {
													%>
			<tr height="10px">
				<td class="HOME_PAGE_DASHBOARD_ALERTS_CELL">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
					<tr>
						<td
							class="HOME_PAGE_DASHBOARD_ALERTS_GENERAL_CELL HOME_PAGE_DASHBOARD_ALERTS_HEADER_CELL HOME_PAGE_DASHBOARD_ALERTS_GENERAL_RIGHT_CELL">No
						servers metrics exist</td>
					</tr>
					<tr>
						<td class="HOME_PAGE_DASHBOARD_ALERTS_GENERAL_BOTTOM_CELL">&nbsp;</td>
					</tr>
				</table>
				</td>
			</tr>
			<tr>
				<td style="font-size: 0px; height: 0px;"></td>
			</tr>
			<%
													}
													%>
		</table>
		</td>
	</tr>
	<tr>
		<td>&nbsp;</td>
	</tr>
</table>
</td>
