<%@page import="xpolog.eye.computation.conf.monitoring.MultiComputationVerifier"%>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.audit.*"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.computation.conf.monitoring.ComputationVerifierHelper"%>
<%@ page import="xpolog.eye.computation.conf.monitoring.MultiComputationVerifierBuilder"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.reports.health.ui.DashboardAlertsManager"%>
<%@ page import="xpolog.eye.site.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%

	UserContext userContext = UserEnvironment.getUserContext(request);
	String SMTP_HOST = "SMTPHost";
	String SMTP_PORT = "SMTPProt";
	String TO = "to";
	String ERROR_OBJ = "ERROR_OBJ";

	ErrorModel err = new ErrorModel();
	
	MailConfig mail = xpolog.config.Configuration.getInstance().getMailConfigurationManager();

	String host = request.getParameter(SMTP_HOST);
	String port = request.getParameter(SMTP_PORT);
	String to = request.getParameter(TO);
	if (host == null || host.trim().equals("")) {
		err.addError("No host was supplied");
	}
	if (port == null || port.trim().equals("")) {
		err.addError("No port was supplied");
	}
	if (to == null || to.trim().equals("")) {
		err.addError("No email address supplied");
	}

	if(err.getErrorCount() == 0) {
		host = host.trim();
		port = port.trim();
		mail.setSmtpHost(host);
		
		try {
			mail.setSmtpPort(Integer.parseInt(port));
			
			//saving  
			xpolog.config.Configuration.getInstance().getMailConfigurationManager().saveMailSettings();
		}catch (Exception e) {
			err.addError("Port must be a valid number");
		}
		
		// add a dashboard global alert
		ComputationConfiguration computationConfiguration = ComputationConfiguration.getInstance();
		MultiComputationVerifierBuilder builder = new MultiComputationVerifierBuilder();
		MultiComputationVerifier globalVerifier = computationConfiguration.getGlobalVerifier();
		if(!globalVerifier.hasInternalVerifiers()) {
			builder.setVerifier(globalVerifier);
			builder.updateFromVerifier();
			
			ComputationVerifierHelper.createMailComputationVerifierTask(request, err, true, builder);
			if(err.getErrorCount() == 0) {
				builder.updateBuilder();
				DashboardAlertsManager.getInstance().setGlobalVerifier(builder.getMultiComputationVerifier());
				DashboardAlertsManager.getInstance().saveGlobalVerifier();
			}
		}
	}
	
	//audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL, userContext, AuditConstants.CHANGE, "edit mail settings from first time div",
			AuditConstants.CONFIGURATION, "edit mail settings from first time div");

	String xml = "";
	if (err != null && err.getErrorCount() > 0){
		//errors
		String[] errors = err.getErrors();
		StringBuffer sb = new StringBuffer();
		for (int i=0; i<errors.length; i++){
			if (sb.length() > 0){
				sb.append("*;*");
			}
			sb.append(errors[i]);
		}
		String message = sb.toString();
		//params
		String[] params = err.getErrorParams();
		sb = new StringBuffer();
		for (int i=0; i<params.length; i++){
			if (sb.length() > 0){
				sb.append("*;*");
			}
			sb.append(params[i]);
		}
		String paramsList = sb.toString();
		xml = GridModelActionsHelper.getResultXML(false, message, paramsList);
	}else{
		xml = GridModelActionsHelper.getResultXML(true, "Mail Settings Saved");
	}
	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	out.write(xml);
	out.flush();
%>
