<%@ page import="xpolog.eye.managment.XpologManagment"%>
<%@page import="xpolog.eye.security.WebSecurityManager"%>
<%@page import="xpolog.eye.security.UserSecurity"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.security.XpologLicenseManager"%>
<%@page import="java.util.List"%>
<%@page import="xpolog.eye.SiteManagment"%>
<%@page import="xpolog.eye.managment.ApplicationComponent"%>
<%@page import="xpolog.eye.site.UserProperties"%>
<%@page import="xpolog.config.Configuration"%>
<%@page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@page import="xpolog.logic.security.LogicPermissionConstants"%>

<%

String baseDirectory = request.getParameter("baseDirectory");
if (baseDirectory == null){
	baseDirectory = "";
}

WebSecurityManager securityManager = WebSecurityManager.getInstance();

UserSecurity user = securityManager.getUserSecurity(request);
UserContext userContext = UserEnvironment.getUserContext(request);
boolean isDemo = XpologLicenseManager.getInstance().isDemo();

List comps = SiteManagment.getInstance().getApplicationComponentsManager().getVisibleApplicationComponents(user);
boolean showComps = comps.size() > 1;

boolean xpologEnabled = false;
boolean searchEnabled = false;
boolean dashboardEnabled = false;
boolean txexpoEnabled = false;
String xpologLink = "";
String xpologSearchLink = "";
String dashboardLink = "";
String txexpoLink = "";
for(int i=0;i<comps.size();i++) {
	ApplicationComponent comp = (ApplicationComponent)comps.get(i);		
	if(comp != null && comp.getName().equals("XpoLog") && comp.isVisible()) {
		xpologEnabled = true;
		xpologLink = "componentAction.jsp?selectedCompId=" + comp.getId();
	}
	if(comp != null && comp.getName().equals("Search Engine") && comp.isVisible()) {
		searchEnabled = true;
		xpologSearchLink = "componentAction.jsp?selectedCompId=" + comp.getId();
	}
	if(comp != null && comp.getName().equals(XpologManagment.ANALYTICS_COMPONENT) && comp.isVisible()) {
		dashboardEnabled = true;
		dashboardLink = "componentAction.jsp?selectedCompId=" + comp.getId();
	}
	if(comp != null && comp.getName().equals("TxExpo") && comp.isVisible()) {
		txexpoEnabled = true;
		txexpoLink = "componentAction.jsp?selectedCompId=" + comp.getId();
	}
}

boolean isPermittedAddLog = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_LOG_PERMISSION);
boolean isPermittedAddModule = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_MODULE_PERMISSION);
boolean isPermittedSettings = securityManager.isHavePermission(userContext,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION);
boolean haveQuickStart = isPermittedAddLog || isPermittedAddModule;

boolean isPermittedAddVerify = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_VERIFY_PERMISSION);
boolean isPermittedEditVerify = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.EDIT_VERIFY_PERMISSION);

boolean isPermittedAddReport = securityManager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.EDIT_REPORTS_PERMISSION);
boolean isPermittedVerify = isPermittedAddVerify || isPermittedEditVerify;

boolean isPermittedAddTransaction = securityManager.isHavePermission(userContext,LogicPermissionConstants.AdministrationPermissions.TRANSACTIONS_PERMISSION);

boolean isTestingBuid = SiteManagment.getInstance().isTestingBuild();
String quickStartDivHeight = "485";
/*if(isTestingBuid) {
	quickStartDivHeight = "550";
}*/

UserProperties userProp = UserEnvironment.getUserProp(request);
boolean showOnStart = userProp.getPropertyAsBoolean("ui.portal.showQuickStart",true);
%>


<script>

function initStartWizard(){
  <% if (showOnStart){%>
 showStartWizard();
  <%}%>
}

function showStartWizard(){
  if (document.getElementById("quickStartDiv").style.display == "none"){
    showHideLayerInMiddle("quickStartDiv",-1,-1,true);
  }
}

function hideStartWizard(){
  document.getElementById("quickStartDiv").style.display = "none";
  setSessionParam("<%=baseDirectory%>","openQuickWizard","false");
}


function changeShow(){
  var img = document.getElementById("showImage");
  var val = "true";
  if (img.src.indexOf("dont-show.gif") == -1){
    img.src = "<%=baseDirectory%>images/portal/btns/wizard/dont-show.gif";
    val = "false";
  }else {
    img.src = "<%=baseDirectory%>images/portal/btns/wizard/show.gif";
  }
  setUserProperty("<%=baseDirectory%>","ui.portal.showQuickStart",val);
}
</script>
<div id="quickStartDiv" style="position:absolute;overflow:hidden;display:none;width:550;height:<%=quickStartDivHeight %>;left:200;top:50;border:1px solid gray;z-index:10">
<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
<tr><td bgcolor="#FFFFFF" style="padding:5">
<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
<tr height="77"><td background="images/portal/btns/wizard/title_background.gif" style="background-repeat:repeat">
<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
<tr><td style="padding-left:40"><span class="START_WIZARD_TITLE_TEXT">Quick Start Wizard</span></td>
<td width="10" valign="top" style="padding-top:5;padding-right:5" ><a href="javascript:hideStartWizard()"><img  src="images/portal/btns/wizard/close.gif" border="0"></a></td>
</tr>
</table>
</td></tr>

<tr height="10" ><td style="padding-top:20">
<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
<%if (isTestingBuid){ %>
<tr><td width="100" align="right" style="padding-bottom:10"><a href="<%=xpologLink%>&forward=root.jsp?mainPage=reports/agg/aggReportDefinition.jsp?reportTemplateId=Testing"><img src="images/portal/btns/wizard/diagnostics.gif" border="0" onmouseover="javascript:this.src='images/portal/btns/wizard/diagnostics-on.gif'" onmouseout="javascript:this.src='images/portal/btns/wizard/diagnostics.gif'"></a></td>
<td style="padding-left:10;padding-bottom:10">
<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
<tr><td><a href="<%=xpologLink%>&forward=root.jsp?mainPage=reports/agg/aggReportDefinition.jsp?reportTemplateId=Testing"><span class="START_WIZARD_ITEM_TEXT">Analyze Testing Environment</span></a></td></tr>
<tr><td><span class="START_WIZARD_ITEM_SMALL_TEXT">Automatically analyze testing environment logs</span></td></tr>
</table>
</td>
</tr>
<%}%>

<%if (isPermittedAddLog){ %>

<tr><td width="100" align="right"><a href="<%=xpologLink%>&forward=root.jsp?mainPage=loggers/admin/logAdminGate.jsp"><img src="images/portal/btns/wizard/add-logs.gif" border="0" onmouseover="javascript:this.src='images/portal/btns/wizard/add-logs-on.gif'" onmouseout="javascript:this.src='images/portal/btns/wizard/add-logs.gif'"></a></td>
<td style="padding-left:10">
<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
<tr><td><a href="<%=xpologLink%>&forward=root.jsp?mainPage=loggers/admin/logAdminGate.jsp"><span class="START_WIZARD_ITEM_TEXT">Add and View Log</span></a></td></tr>
<tr><td><span class="START_WIZARD_ITEM_SMALL_TEXT">Add Log | View | Filter | Tail</span></td></tr>
</table>
</td>
</tr>

<tr><td width="100" align="right" style="padding-top:10"><a href="<%=xpologLink%>&forward=root.jsp?mainPage=wizards/common/wizardStarter.jsp?wizardPath=scanner"><img src="images/portal/btns/wizard/add-log-dir.gif" border="0" onmouseover="javascript:this.src='images/portal/btns/wizard/add-log-dir-on.gif'" onmouseout="javascript:this.src='images/portal/btns/wizard/add-log-dir.gif'"></a></td>
<td style="padding-left:10;padding-top:10">
<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
<tr><td><a href="<%=xpologLink%>&forward=root.jsp?mainPage=wizards/common/wizardStarter.jsp?wizardPath=scanner"><span class="START_WIZARD_ITEM_TEXT">Add Logs Directory</span></a></td></tr>
<tr><td><span class="START_WIZARD_ITEM_SMALL_TEXT">Add Multiple logs | View | Filter</span></td></tr>
</table>
</td>
</tr>
<%} %>

<%if (isPermittedAddVerify){ %>
<tr><td width="100" align="right" style="padding-top:10"><a href="<%=xpologLink%>&forward=root.jsp?mainPage=monitor/monitorDefinition.jsp"><img src="images/portal/btns/wizard/create-monitor.gif" border="0" onmouseover="javascript:this.src='images/portal/btns/wizard/create-monitor-on.gif'" onmouseout="javascript:this.src='images/portal/btns/wizard/create-monitor.gif'"></a></td>
<td style="padding-left:10;padding-top:10">
<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
<tr><td><a href="<%=xpologLink%>&forward=root.jsp?mainPage=monitor/monitorDefinition.jsp"><span class="START_WIZARD_ITEM_TEXT">Create Log Monitor</span></a></td></tr>
<tr><td><span class="START_WIZARD_ITEM_SMALL_TEXT">Monitor Logs and Send Alerts</span></td></tr>
</table>
</td>
</tr>
<%}

if (isPermittedAddReport){
%>
<tr><td width="100" align="right" style="padding-top:10"><a href="<%=xpologLink%>&forward=root.jsp?mainPage=reports/agg/aggReportDefinition.jsp?reportTemplateId=Aggregation"><img src="images/portal/btns/wizard/generate-report.gif" border="0" onmouseover="javascript:this.src='images/portal/btns/wizard/generate-report-on.gif'" onmouseout="javascript:this.src='images/portal/btns/wizard/generate-report.gif'"></a></td>
<td style="padding-left:10;padding-top:10">
<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
<tr><td><a href="<%=xpologLink%>&forward=root.jsp?mainPage=reports/agg/aggReportDefinition.jsp?reportTemplateId=Aggregation"><span class="START_WIZARD_ITEM_TEXT">Generate Report</span></a></td></tr>
<tr><td><span class="START_WIZARD_ITEM_SMALL_TEXT">Events Aggregation | Statistics | Compliance</span></td></tr>
</table>
</td>
</tr>
<%}
if (searchEnabled){
%>
<tr><td width="100" align="right" style="padding-top:10"><a href="<%=xpologSearchLink%>"><img src="images/portal/btns/wizard/indexandsearch.gif" border="0" onmouseover="javascript:this.src='images/portal/btns/wizard/indexandsearch-on.gif'" onmouseout="javascript:this.src='images/portal/btns/wizard/indexandsearch.gif'"></a></td>
<td style="padding-left:10;padding-top:10">
<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
<tr><td><a href="<%=xpologSearchLink%>"><span class="START_WIZARD_ITEM_TEXT">Index and Search Logs</span></a></td></tr>
<tr><td><span class="START_WIZARD_ITEM_SMALL_TEXT">Logs Search Engine</span></td></tr>
</table>
</td>
</tr>
<%} 

if (false && txexpoEnabled && isPermittedAddTransaction && !isTestingBuid){

%>
<tr><td width="100" align="right" style="padding-top:10"><a href="<%=txexpoLink%>&forward=root.jsp?mainPage=logic/admin/transaction/addNewTransaction.jsp?OP=ADD&ds_id="><img src="images/portal/btns/wizard/transactions.gif" border="0" onmouseover="javascript:this.src='images/portal/btns/wizard/transactions-on.gif'" onmouseout="javascript:this.src='images/portal/btns/wizard/transactions.gif'"></a></td>
<td style="padding-left:10;padding-top:10">
<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
<tr><td><a href="<%=txexpoLink%>&forward=root.jsp?mainPage=logic/admin/transaction/addNewTransaction.jsp?OP=ADD&ds_id="><span class="START_WIZARD_ITEM_TEXT">Analyze Transaction - Log Correlation Rule</span></a></td></tr>
<tr><td><span class="START_WIZARD_ITEM_SMALL_TEXT">Track and Monitor Transactions</span></td></tr>
</table>
</td>
</tr>
<%} %>

</table>
</td></tr>

<tr><td>&nbsp;</td></tr>
<tr height="51"><td style="padding-left:40;padding-right:40">
<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
<tr><td style="border-top:1 solid black">
<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
<tr><td width="10" align="right"><a href="javascript:changeShow()"><img src="images/portal/btns/wizard/<%=showOnStart ?"" : "dont-" %>show.gif" border="0" id="showImage"></a></td>
<td style="padding-left:10"> <span class="START_WIZARD_BOTTOM_TEXT">Show at startup</span></td>
</tr>
</table>
</td></tr>
</table>
</td></tr>
</table>
</td></tr>
</table>
</div>