<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.site.portal.UserPortalLbmRequest"%>
<%@ page import="xpolog.eye.site.portal.UserPortalManager"%>
<%@ page import="xpolog.eye.util.ui.html.HtmlDisplayItemRepresentationRequest"%>

<%!static final String BASE_DIRECTORY = "../";
%>
<%
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = BASE_DIRECTORY;
	}
	UserContext userContext = UserEnvironment.getUserContext(request);
	WebSecurityManager securityManager = WebSecurityManager.getInstance();
	UserPortalManager portalMgr = UserPortalManager.getInstance();
  boolean isPermittedAddSnapshot = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_SNAPSHOT_PERMISSION);
  boolean isPermittedExportLog = securityManager.isHavePermission(userContext,ActionsPermissionConstants.DataSupportPermissions.EXPORT_LOG_PERMISSION);
  
	String mainSelection = request.getParameter("mainSelection");
	String displayInDivStr = request.getParameter("displayInDiv");	
	boolean displayInDiv = displayInDivStr != null && displayInDivStr.equals("true");
	String scriptsOnlyStr = request.getParameter("scriptsOnly");	
	boolean scriptsOnly = scriptsOnlyStr != null && scriptsOnlyStr.equals("true");
	String noScriptsStr = request.getParameter("noScripts");	
	boolean noScripts = noScriptsStr != null && noScriptsStr.equals("true");
	
	String autoViewStr = request.getParameter("autoView");
	boolean autoView = autoViewStr != null && autoViewStr.equals("true");
	if (autoView){
		String CURRENT_USER_PORTAL_REQUEST = "CURRENT_USER_PORTAL_REQUEST";
		UserPortalLbmRequest userPortalRequest = (UserPortalLbmRequest)request.getSession().getAttribute(CURRENT_USER_PORTAL_REQUEST);
		UserPortalLbmRequest.MissingMandatoryItemsAndGroups missingItemsAndGroups = userPortalRequest.getMissingSearchCriteria();
		if (!(!userPortalRequest.isEmpty() && (missingItemsAndGroups == null || !missingItemsAndGroups.hasMissingData()))){
			autoView = false;
		}
	}
	String autoLoadFunction = autoView ? "goUserPortal('view')" : "";
	
	HtmlDisplayItemRepresentationRequest repRequest = new HtmlDisplayItemRepresentationRequest();
	repRequest.setUserContext(userContext);
	repRequest.setMainSelection(mainSelection);
	String html = portalMgr.getDisplayItemHtml(repRequest);
	String inlineScript = portalMgr.getDisplayItemInlineScripts(baseDirectory);
	
	String msSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator", ".");
	
	final boolean ALLOW_EMBEDED_FLASH = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("snapshot.allowEmbededFlash",true);
	
	String charset = "UTF-8";
	response.setContentType("text/html; charset=" + charset);

%>
<%if (displayInDiv){%>
<html>
<meta http-equiv="Content-Language" content="text/html; charset=<%=charset%>">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<%}%>
<%if (!noScripts){%>
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=baseDirectory%>dhtmlxSuite/dhtmlxCalendar/codebase/dhtmlxcalendar.css" />
	<link rel="stylesheet" type="text/css" href="<%=baseDirectory%>css/dhtmlxCalendar.css" />
<script src="<%=baseDirectory%>scripts/UIUtil.js" type="text/javascript"></script>
<script language="JavaScript" src="<%=baseDirectory%>scripts/calendar/calendar2.js"></script>
<script language="JavaScript" src="<%=baseDirectory%>dhtmlxSuite/dhtmlxCalendar/codebase/dhtmlxcommon.js"></script>
<script language="JavaScript" src="<%=baseDirectory%>dhtmlxSuite/dhtmlxCalendar/codebase/dhtmlxcalendar.js"></script>
	

<script>

setAllowEmbededFlash('<%=ALLOW_EMBEDED_FLASH%>');

function closeUserPortalDiv(){
	if (parent.closeUserPortalDiv){
		parent.closeUserPortalDiv();
	}
}
		
</script>
<%}%>
<%if (displayInDiv){ %>
<head>
</head>

<body>
<%}%>
<form name="access" action="<%=baseDirectory%>portal/userPortalAction.jsp" method="post">
<%if (autoView){%>
<input type="hidden" id="autoLoadFunction" name="autoLoadFunction" value="<%=autoLoadFunction%>">
<%}%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>
		<td <%=!displayInDiv ? "style=\"padding-top:20\"" : ""%>>
			<table border="0" width="90%" cellspacing="0" cellpadding="0" align="center">
				<tr>
					<td id="userPortalMainTD" width="*" style="padding-left:10;padding-top:10" valign="top">
					<%
						String innerPage = "userPortalInner.jsp";
					%>
						<jsp:include page="<%=innerPage %>" flush="true">
							<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
							<jsp:param name="mainSelection" value="<%=mainSelection%>" />
						</jsp:include>
					</td>
				</tr>
				<tr style="display:;" id="userPortalErrorMsgTR" height="10">
						<td id="userPortalErrorMsgTD" style="padding-left:0px;padding-top:5px;padding-bottom:5px" class="ERROR_MSG">&nbsp;</td>
				</tr>
				<%if (displayInDiv){%>
				<jsp:include page="../common/adminGeneralFooterActions.jsp" flush="true" >
					<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
					<jsp:param name="suffix" value="userSearchCriterias" />
					<jsp:param name="actionsNames" value="Show#Export#Cancel" />
					<jsp:param name="actions" value="javascript:goUserPortal('view')#javascript:goUserPortal('export')#javascript:closeUserPortalDiv()"/>
				</jsp:include>
				<%}else{
					String actionNames = "Show";
					String actions = "javascript:goUserPortal('view')";
					if (isPermittedAddSnapshot){
						actionNames += "#Create Snapshot";
						actions += "#javascript:goUserPortal('createSnapshot')";
					}
					if (isPermittedExportLog){
						actionNames += "#Export#";
						actions += "#javascript:goUserPortal('export')";
					}
				%>
				<jsp:include page="../common/adminGeneralFooterActions.jsp" flush="true" >
					<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
					<jsp:param name="suffix" value="userSearchCriterias" />
					<jsp:param name="actionsNames" value="<%=actionNames%>" />
					<jsp:param name="actions" value="<%=actions%>"/>
				</jsp:include>
				<%}%>
			</table>
			<div id="userPortalSearchSnapshotDiv">
			</div>
			<div id="userPortalSearchSnapshotResultDiv">
			</div>
			<div id="userPortalCalendarDiv" class="XPOLOG_DHTMLX_CALENDAR_DIV" style="display:none">
				<table border="0" cellpadding="0" cellspacing="0">
					<tr>
						<td id="userPortalCalendarTd"></td>
					</tr>
					<tr>
						<td>
							<table border="0" cellpadding="0" cellspacing="0">
								<tr height="10px">
									<td class="XPOLOG_DHTMLX_CALENDAR_DATE_CELL_TEXT XPOLOG_DHTMLX_CALENDAR_START_DATE_CELL">Start Date:</td>
									<td class="XPOLOG_DHTMLX_CALENDAR_DATE_LABEL" id="userPortalCalendarStartDateTd"></td>
									<td class="XPOLOG_DHTMLX_CALENDAR_DATE_CELL_TEXT XPOLOG_DHTMLX_CALENDAR_END_DATE_CELL">End Date:</td>
									<td class="XPOLOG_DHTMLX_CALENDAR_DATE_LABEL" id="userPortalCalendarEndDateTd"></td>
								</tr>
								<tr height="10px">
									<td class="XPOLOG_DHTMLX_CALENDAR_TIME_CELL_TEXT XPOLOG_DHTMLX_CALENDAR_START_TIME_CELL">Start Time:</td>
									<td class="XPOLOG_DHTMLX_CALENDAR_TIME_INPUT_CELL"><input type="text" id="calendarStartTime" name="calendarStartTime" maxlength="8" class="XPOLOG_DHTMLX_CALENDAR_TIME_INPUT" onChange="javascript:validateTimeFormat('calendarStartTime', 'Start Time')"></td>
									<td class="XPOLOG_DHTMLX_CALENDAR_TIME_CELL_TEXT XPOLOG_DHTMLX_CALENDAR_END_TIME_CELL">End Time:</td>
									<td class="XPOLOG_DHTMLX_CALENDAR_TIME_INPUT_CELL"><input type="text" id="calendarEndTime" name="calendarEndTime" maxlength="8" class="XPOLOG_DHTMLX_CALENDAR_TIME_INPUT" onChange="javascript:validateTimeFormat('calendarEndTime', 'End Time')"></td>
								</tr>
								<tr height="10px">
									<td id="userPortalCalendarErrorTd" class="XPOLOG_DHTMLX_CALENDAR_ERROR_CELL" colspan="4">&nbsp;</td>
								</tr>
							</table>
						</td>
					</tr>
					<tr>
						<td class="XPOLOG_DHTMLX_CALENDAR_BUTTONS_CELL">
							<a href="javascript:goUserPortalCalendar()"><img src="images/dashboard/header/calendarGo.gif" border="0" onMouseOver="javascript:setImageSource(this, 'images/dashboard/header/calendarGoOver.gif')" onMouseOut="javascript:setImageSource(this, 'images/dashboard/header/calendarGo.gif')"></a>
							<a href="javascript:closeUserPortalCalendar()"><img src="images/dashboard/header/calendarClose.gif" border="0" onMouseOver="javascript:setImageSource(this, 'images/dashboard/header/calendarCloseOver.gif')" onMouseOut="javascript:setImageSource(this, 'images/dashboard/header/calendarClose.gif')"></a>
						</td>
					</tr>
				</table>
			</div>
		</td>
	</tr>
</table>
</form>
<form name="downloadFile">
</form>
<%if (!noScripts && inlineScript != null){%>
<%=inlineScript %>
<%}%>

<%if (displayInDiv){%>
</body>
</html>
<%}%>