<%@ page language="java"%>

<%@ page import="xpolog.eye.ModuleMemberPermissions"%>
<%@ page import="xpolog.eye.security.UserSecurity"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.security.XpologSecurityHelper"%>
<%@ page import="xpolog.eye.security.XpologSecurityManager"%>
<%@ page import="xpolog.eye.site.widgets.view.WidgetsView"%>
<%@ page import="xpolog.eye.site.widgets.XpoLogWidgetsManager"%>

<%@ page import="java.util.Collection"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	String VIEW_ID = "viewId";
	String viewId = request.getParameter(VIEW_ID);
	
	boolean displayOwner = WebSecurityManager.getInstance().isSecurityEnabled();
	
	String name = "";
	String templateId = "";
	String ownerDisplay = "";
	
	if(viewId != null){
		WidgetsView widgetsView = XpoLogWidgetsManager.getIntsance().getWidgetsView(request, WidgetsView.PORTAL_VIEW_TYPE, viewId);
		if(widgetsView != null) {
			name = widgetsView.getName();
			templateId = widgetsView.getTemplateKey();
			if(displayOwner) {
				ownerDisplay = widgetsView.getOwnerDisplay();
				if(ownerDisplay == null || ownerDisplay.length() == 0) {
					ownerDisplay = "N/A";
				}
			}
			request.getSession().setAttribute("lastSelectedPortalView", viewId);
			if (XpologSecurityManager.getInstance().isEnabled()){
				ModuleMemberPermissions currPermission = widgetsView.getPermissions();	
				if (currPermission != null){  	
					request.setAttribute("currPermission",currPermission);
				}
			}
		}
	}else{
		viewId = "";
		request.getSession().removeAttribute("lastSelectedPortalView");
	}
	
	String addDashboardSelectedTemplateId = "template1";
	
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/comps/divsTabs.js" type="text/javascript"></script>

<script>
var CURRENT_VIEW_ID = '<%=viewId %>';
var CURRENT_TEMPLATE_ID = '<%=templateId %>';

function init(){
<%if (XpologSecurityManager.getInstance().isEnabled()){%>
	initTabs();
<%}%>
	//initTables();
		
	var portalViewName = document.getElementById("portalViewName");
	if(portalViewName) {
		portalViewName.focus();
	}
}

var addDashboardSelectedTemplateId = "<%=addDashboardSelectedTemplateId %>";
function doSelectLayout(templateId) {
	if(templateId != addDashboardSelectedTemplateId) {
		addDashboardSelectedTemplateId = templateId;
		for(var i = 1; i < 5; i++) {
			var widgetsPortalAddDashboardSelectLayout = document.getElementById("widgetsPortalAddDashboardSelectLayout_template" + i);
			var widgetsPortalAddDashboardSelectLayoutSelected = document.getElementById("widgetsPortalAddDashboardSelectLayoutSelected_template" + i);
			if(widgetsPortalAddDashboardSelectLayout && widgetsPortalAddDashboardSelectLayoutSelected) {
				if(templateId == ("template" + i)) {
					widgetsPortalAddDashboardSelectLayoutSelected.style.display = "";
					widgetsPortalAddDashboardSelectLayout.style.display = "none";
				}else {
					widgetsPortalAddDashboardSelectLayoutSelected.style.display = "none";
					widgetsPortalAddDashboardSelectLayout.style.display = "";
				}
			}
		}
	}
}

function doSave(){
	var viewId = '';
	var viewName = document.getElementById("portalViewName").value;
	var templateId = '';
	if(CURRENT_TEMPLATE_ID == '') {
		templateId = addDashboardSelectedTemplateId;
	}else {
		viewId = CURRENT_VIEW_ID;
		templateId = CURRENT_TEMPLATE_ID;
	}
	<%if (XpologSecurityManager.getInstance().isEnabled()){%>
		updatePermissions();
	<%}%>	  
	
	var params = getFormElementsQueryString(document.access);
	params += "&viewId=" + viewId;
	params += "&viewName=" + encodeURIComponent(viewName);
	params += "&templateId=" + templateId;
	sendAjaxRequest("savePortalViewAction.jsp", function(req){
		var xmldoc = req.responseXML.documentElement;
	    if(xmldoc) {
	    	var messageElement = xmldoc.getElementsByTagName("Message")[0];
				if (messageElement){
					var msg = getXMLElementValue(messageElement);
					if(msg && msg != '') {
						var widgetsPortalAddDashboardErrorTd = document.getElementById("widgetsPortalAddDashboardErrorTd");
						if(widgetsPortalAddDashboardErrorTd) {
							widgetsPortalAddDashboardErrorTd.innerHTML = msg;
							widgetsPortalAddDashboardErrorTd.style.display = "";
						}
					}else {
						var widgetsPortalAddDashboardErrorTd = document.getElementById("widgetsPortalAddDashboardErrorTd");
						if(widgetsPortalAddDashboardErrorTd) {
							widgetsPortalAddDashboardErrorTd.innerHTML = msg;
							widgetsPortalAddDashboardErrorTd.style.display = "none";
						}
						var viewElement = xmldoc.getElementsByTagName("ViewID")[0];
						if(viewElement) {	
							var viewId = getXMLElementValue(viewElement);
							if (viewId && viewId != ""){
								parent.updateDashboardsMenu();
								this.location.href = "../view/widgetsPortalView.jsp?selectedView=" + viewId;
							}			
						}
					}
				}
	    }
  }, "POST", params);
}

function updatePermissions(){
	for(var j=0;j<document.access.selectedEditMembersList.options.length;j++){
		document.access.selectedEditMembersList.options[j].selected = true;
	}
	for(var j=0;j<document.access.selectedViewMembersList.options.length;j++){
		document.access.selectedViewMembersList.options[j].selected = true;
	}
}



</script>
<jsp:include page="../../../widgets/tabs/jsp/tabsHeaderIncluder.jsp" flush="true">
  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
</head>

<body onload="init()" style="margin:0;padding:0">

<form id="access" name="access" method="post" style="margin:0;padding:0">
<input class="TEXTBOX" type="hidden" name="viewId" size="10" value="<%=viewId%>">

<table border="0" cellpadding="0" cellspacing="0"	style="border-collapse:collapse" width="100%" height="100%">
	<tr height="1">
		<td>
			<%
			String headerUrl = BASE_DIRECTORY + "common/pageHeader.jsp";
			%>
			<jsp:include page="<%=headerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="Dashboard" />
			</jsp:include>
		</td>
	</tr>
	<tr valign="top">
		<td width="100%" height="100%" valign="top">
			<table class="ADMIN_TABLE_DIV" border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
				<tr>
					<td class="ADMIN_MAIN_TD" valign="top" height="100%">
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">																
							<tr height="1">
								<td>&nbsp;</td>
							</tr>
							<tr height="1">
								<td>
									<table class="ADMIN_SECTION_DIV" border="0" cellpadding="0" cellspacing="0" width="100%">
										<tr>
											<td class="ADMIN_SECTION_MAIN_TD">
												<table border="0" cellpadding="0" cellspacing="0" width="100%">
		                      <tr>
		                        <td width="11%"><span class="REGULARTEXT">Name *</span></td>
		                        <td width="69%">
		                        <input class="TEXTBOX" type="text" id="portalViewName" name="protalViewName" size="50" value="<%=name%>"></td>
		                      </tr>
		                      <%if(viewId.length() == 0) { %>
		                      <tr style="height: 100px" id="widgetsPortalAddDashboardSelectLayoutRow">
									    			<td style="padding-top:10"><span class="REGULARTEXT">Layout *</span></td>
									    			<td>
															<a href="javascript:doSelectLayout('template1')"><img id="widgetsPortalAddDashboardSelectLayoutSelected_template1" src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/addDashboardLayout1ColumnSelected.gif" border="0" style="display:<%=addDashboardSelectedTemplateId.equals("template1") ? "" : "none" %>"><img id="widgetsPortalAddDashboardSelectLayout_template1" src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/addDashboardLayout1Column.gif" border="0"  style="display:<%=addDashboardSelectedTemplateId.equals("template1") ? "none" : "" %>"></a>
															<a href="javascript:doSelectLayout('template2')"><img id="widgetsPortalAddDashboardSelectLayoutSelected_template2"src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/addDashboardLayout2ColumnsSelected.gif" border="0" style="display:<%=addDashboardSelectedTemplateId.equals("template2") ? "" : "none" %>"><img id="widgetsPortalAddDashboardSelectLayout_template2" src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/addDashboardLayout2Columns.gif" border="0"  style="display:<%=addDashboardSelectedTemplateId.equals("template2") ? "none" : "" %>"></a>
															<a href="javascript:doSelectLayout('template3')"><img id="widgetsPortalAddDashboardSelectLayoutSelected_template3"src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/addDashboardLayout1Row2ColumnsSelected.gif" border="0" style="display:<%=addDashboardSelectedTemplateId.equals("template3") ? "" : "none" %>"><img id="widgetsPortalAddDashboardSelectLayout_template3" src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/addDashboardLayout1Row2Columns.gif" border="0"  style="display:<%=addDashboardSelectedTemplateId.equals("template3") ? "none" : "" %>"></a>
															<a href="javascript:doSelectLayout('template4')"><img id="widgetsPortalAddDashboardSelectLayoutSelected_template4"src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/addDashboardLayout2Columns1RowSelected.gif" border="0" style="display:<%=addDashboardSelectedTemplateId.equals("template4") ? "" : "none" %>"><img id="widgetsPortalAddDashboardSelectLayout_template4" src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/addDashboardLayout2Columns1Row.gif" border="0"  style="display:<%=addDashboardSelectedTemplateId.equals("template4") ? "none" : "" %>"></a>
									    			</td>
									    		</tr>
		                      <%}else if(displayOwner) { %>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Owner</span></td>
		                        <td><span class="REGULARTEXT"><%=ownerDisplay %></span></td>
		                      </tr>
		                      <%} %>
		                      <tr>
		                        <td style="padding-top:20" colspan="2">
		                        	<span class="SMALLTEXT">* marks a manadatory field</span>
		                        </td>
		                      </tr>
					    						<tr style="height: 20px;">
									    			<td colspan="2" style="display:none;font-size: 12px; color: red;" id="widgetsPortalAddDashboardErrorTd"></td>
									    		</tr>
		                    </table>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							
							<%
							UserSecurity security = WebSecurityManager.getInstance().getUserSecurity(request);
							Collection availableMembersCol = XpologSecurityHelper.getPrincipalsCollectionFromUser(security);
							if ((availableMembersCol == null || availableMembersCol.size() > 0) && XpologSecurityManager.getInstance().isEnabled()){
							%>
							<tr style="padding-top:15;background-color:#A4A4A4">
								<td style="padding:8">
									<div id="tabbarDiv" style="width:100%;height:100%;" ></div>
									<div id="permissionsDiv" style="padding-left:10;display:none;height:100" >
										<jsp:include page="../../../security/common/moduleMemberPermissionsIncluder.jsp" flush="true">
											<jsp:param name="embedded" value="true" />
											<jsp:param name="ignoreName" value="true"/>
											<jsp:param name="showDefault" value="false"/>
											<jsp:param name="ignoreParent" value="true"/>
										</jsp:include>
									</div>
									<jsp:include page="../../../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
										<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
										<jsp:param name="id.1" value="permissionsDiv" />
										<jsp:param name="name.1" value="Security" />
									</jsp:include>
								</td>
							</tr>
							<%}else{%>
							<tr height="100%">
								<td>&nbsp;</td>
							</tr>															
							<%}%>								
							
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr height="10">
		<td>
			<%
			String footerUrl = BASE_DIRECTORY + "common/buttonsFooter.jsp";
			String cancelAction = "common/actions/cancelAction.jsp?forward=portal/widgets/admin/portalViews.jsp?fullPage=true";
			
			String actions = "javascript:doSave()#" + cancelAction;
			%>
			<jsp:include page="<%=footerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="Save#Back to Dashboards" />
				<jsp:param name="actions" value="<%=actions %>" />
			</jsp:include>
		</td>
	</tr>
</table>
</form>
</body>
</html>