<%@ page language="java"%>

<%@ page import="org.w3c.dom.Element"%>

<%@ page import="java.util.ArrayList"%>
<%@ page import="java.util.Enumeration"%>
<%@ page import="java.util.HashSet"%>
<%@ page import="java.util.List"%>
<%@ page import="java.util.Set"%>

<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.site.widgets.data.handler.WidgetDataHandler"%>
<%@ page import="xpolog.eye.site.widgets.data.handler.WidgetDataHandlerRequest"%>
<%@ page import="xpolog.eye.site.widgets.data.WidgetsDataCache"%>
<%@ page import="xpolog.eye.site.widgets.data.WidgetsDataHelper"%>
<%@ page import="xpolog.eye.site.widgets.data.WidgetDataRequest"%>
<%@ page import="xpolog.eye.site.widgets.view.WidgetsView"%>
<%@ page import="xpolog.eye.site.widgets.view.portal.PortalWidgetsViewContainer"%>
<%@ page import="xpolog.eye.site.widgets.view.portal.PortalGadget"%>
<%@ page import="xpolog.eye.site.widgets.XpoLogWidgetsManager"%>
<%@ page import="xpolog.eye.util.XMLUtil"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>

<%!
static final String BASE_DIRECTORY = "../../../";
%>
<%

UserContext userContext = UserEnvironment.getUserContext(request);
WebSecurityManager manager = WebSecurityManager.getInstance();

String gadgetId = request.getParameter("gadgetId");
String xplgGadgetId = request.getParameter("xplgGadgetId");
String specUrl = request.getParameter("url");
WidgetsView  view = null;
String viewId = request.getParameter("viewId");
if (viewId != null && viewId.length() > 0){
  view = XpoLogWidgetsManager.getIntsance().getWidgetsView(request,WidgetsView.PORTAL_VIEW_TYPE,viewId);  
}

String status = "ok";
List fieldIds = new ArrayList();
List messages = new ArrayList();
Element elem = XpoLogWidgetsManager.getIntsance().getGadgetSpec(request,specUrl);
if(elem != null) {
	List list = XMLUtil.getChildsElementsByTagName(elem,"UserPref");
	for (int i = 0;i < list.size();i++){
	 	Element e = (Element)list.get(i);
	 	String name = XMLUtil.getAttribute(e,"name","");
	 	String displayName = XMLUtil.getAttribute(e,"display_name",name);
	 	String dataType = XMLUtil.getAttribute(e,"datatype","");
	 	boolean required = XMLUtil.getAttribute(e,"required",false);
	 
	 	String value = request.getParameter(name);
	 	if(required && (value == null || value.length() == 0)) {
		 	status = "error";
		 	fieldIds.add(name);
		 	messages.add(displayName + " is missing");
	 	}
	}
}

StringBuffer buffer = new StringBuffer();
for (Enumeration e = request.getParameterNames();e.hasMoreElements();){
	String key = (String)e.nextElement();
 	if (!key.startsWith("xplg_")){
  	continue; 
 	}
 	String value = request.getParameter(key);
 	if(value != null) {
 		value = value.trim();
 	}
 	if (buffer.length() > 0){
   	buffer.append(",");
 	}
 	buffer.append(key).append(":{value:\"").append(value).append("\"}");
}

PortalGadget gadget = null;
XpoLogWidgetsManager xpologWidgetsMgr = XpoLogWidgetsManager.getIntsance();
WidgetsDataCache widgetsDataCache = xpologWidgetsMgr.getWidgetsDataCache();
PortalWidgetsViewContainer container = (PortalWidgetsViewContainer)view.getContainer();
if (container != null && xplgGadgetId != null && xplgGadgetId.length() > 0){
	PortalGadget [] gadgets = container.getAllGadgets();
	if (gadgets != null && gadgets.length > 0){
	 	for(int i = 0; i < gadgets.length; i++) {
	 	 	if(gadgets[i].getId().equals(xplgGadgetId)) {
	 	 		gadget = gadgets[i];
	 	 		
	 	 		// validate gadget prefs
	 	 		WidgetDataHandler widgetDataHandler = WidgetDataHandler.getWidgetDataHandler(gadget.getGadgetType());
	 	 		if(widgetDataHandler != null) {
	 	 			UserContext widgetUserContext = gadget.getUserContext();
	 	 			if (widgetUserContext == null){
	 	 				widgetUserContext = userContext;
	 	 			}
	 	 			WidgetDataRequest widgetDataRequest = WidgetsDataHelper.createWidgetDataRequest(request, widgetUserContext);
	 	 			WidgetDataHandlerRequest widgetDataHandlerRequest =  widgetDataHandler.createWidgetDataHandlerRequest(widgetDataRequest);
	 	 			if(widgetDataHandlerRequest != null) {
		 	 			List validationMessages = widgetDataHandler.validateWidgetPrefs(widgetDataHandlerRequest);
		 	 			if(validationMessages != null && validationMessages.size() > 0) {
		 	 				status = "error";
		 	 				for(int j = 0; j < validationMessages.size(); j++) {
		 	 					fieldIds.add("N/A");
		 	 					messages.add(validationMessages.get(j));
		 	 				}
		 	 			}
	 	 			}
	 	 		}
	 	 		break;
	 	 	}
	 	}
	}
}

if (gadget != null && buffer.length() > 0 && status.equals("ok")){
 	//append gadget id to userPrefs
 	if (buffer.length() > 0){
 	 	buffer.append(",");
 	}
 	buffer.append("xplg_gadgetId").append(":{value:\"").append(xplgGadgetId).append("\"}");
 	String userPrefs = "{" + buffer.toString() + "}";
 	 	
 	gadget.setUserPrefs(userPrefs);
 	gadget.setCanBeDisplayed(true);
 	gadget.init();
	widgetsDataCache.updateGadget(gadget);
	
 	//audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
 	  	userContext, AuditConstants.CHANGE, "edit dashboard gadget", AuditConstants.WIDGETS, "edit dashboard gadget " + gadget.getId() + " (" + userPrefs +")");
   
  xpologWidgetsMgr.updateWidgetsView(request,view);
}
response.setContentType("text/xml; charset=UTF-8");
%>

<EditPortalWidgetResult>
	<Status status="<%=status %>"/>
<%
if(status.equals("error")) {
%>
	<Messages>
<%
	for(int i = 0; i < messages.size(); i++) {
%>
		<Message fieldId="<%=fieldIds.get(i) %>"><![CDATA[<%=messages.get(i) %>]]></Message>
<%
	}
%>
	</Messages>
<%
}
%>
	
</EditPortalWidgetResult>