<%@ page language="java"%>

<%@ page import="org.w3c.dom.Element"%>

<%@ page import="java.util.List"%>

<%@ page import="xpolog.eye.search.SearchHistoryManager"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.site.widgets.view.WidgetsView"%>
<%@ page import="xpolog.eye.site.widgets.XpoLogWidgetsManager"%>
<%@ page import="xpolog.eye.util.WebUtil"%>
<%@ page import="xpolog.eye.util.XMLUtil"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>

<%!
static final String BASE_DIRECTORY = "../../../";
%>
<%

  UserContext userContext = UserEnvironment.getUserContext(request);
  WebSecurityManager manager = WebSecurityManager.getInstance();

  WidgetsView  view = null;
  String gadgetId = request.getParameter("gadgetId");
  String xplgGadgetId = request.getParameter("xplgGadgetId");
  String specUrl = request.getParameter("url");
  
  String suffix = gadgetId;
	
  Element elem = XpoLogWidgetsManager.getIntsance().getGadgetSpec(request,specUrl);
	response.setContentType("text/xml; charset=UTF-8");
%>

<Result>
<Data><![CDATA[
<% if (elem != null){%>
<table border="0" cellpadding="0" cellspacing="0" width="100%">
	<tr>
		<td class="WIDGETS_PORTAL_EDIT_GADGET_BODY">
			<table border="0" cellpadding="0" cellspacing="0" width="100%">
<%  
  int count = 0;
	List list = XMLUtil.getChildsElementsByTagName(elem,"UserPref");
	for (int i = 0;i < list.size();i++){
    Element e = (Element)list.get(i);
    String name = XMLUtil.getAttribute(e,"name","");
    String displayName = XMLUtil.getAttribute(e,"display_name",name);
    String dataType = XMLUtil.getAttribute(e,"datatype","");
    String defaultValue = XMLUtil.getAttribute(e,"default_value","");
    String helpMessageKey = XMLUtil.getAttribute(e,"helpMessageKey","");
    if (name.length() == 0 || dataType.length() == 0){
    	continue;
    }
    if (!dataType.equalsIgnoreCase("string") && !dataType.equalsIgnoreCase("enum") && !dataType.equalsIgnoreCase("hidden")){
       continue; 
    }
    if (name.equals("xplg_timeUnit")) {
    	// skip the time unit param, it will be added together with the time amount param
    	continue;
    }
    if(name.equals("xplg_timeAmount")) {
    	displayName = "Time Range";
    }
    String prefVal = request.getParameter("up_" + name);
    if (prefVal == null){
    	prefVal = defaultValue; 
    }
    prefVal = WebUtil.doHTMLEncoding(prefVal);
    
    String id = "m_" + gadgetId + "_" + count;
    String userPrefNamePrefix = "m_" + gadgetId + "_up_";
    if (dataType.equalsIgnoreCase("hidden")){
%>
				<input id="<%=id%>" name="<%=userPrefNamePrefix + name%>" type="hidden" value="<%=prefVal%>">
<%
    }else {
%>
  	  	<tr class="WIDGETS_PORTAL_EDIT_GADGET_BODY_ROW">
     			<td class="WIDGETS_PORTAL_EDIT_GADGET_BODY_ROW_PREF_NAME_CELL">
     				<%=displayName%>:
<%
			if(helpMessageKey != null && helpMessageKey.length() > 0) {
%>
					&nbsp;
					<jsp:include page="../../../help/showHelp.jsp" flush="true">
          	<jsp:param name="baseDirectory" value="../../../" />
            <jsp:param name="helpMessageDetails" value="<%=helpMessageKey %>" />
            <jsp:param name="imagePath" value="images/widgets/dashboard/gadget/questionMark.gif" />
            <jsp:param name="imagePathOver" value="images/widgets/dashboard/gadget/questionMarkOver.gif" />
            <jsp:param name="helpDivId" value="addGadgetHelpDiv" />
          </jsp:include>
<%
    	}
%>
     			</td>
      		<td class="WIDGETS_PORTAL_EDIT_GADGET_BODY_ROW_PREF_FIELD_CELL">
<%
			if (dataType.equalsIgnoreCase("string")){
				if(name.equals("xplg_timeAmount")) {
					String timeAmountId = "m_" + gadgetId + "_" + ++count;
					String timeUnitId = "m_" + gadgetId + "_" + ++count;
%>
								<select id="<%=id%>" name="<%=userPrefNamePrefix%>xplg_timeType" onChange="javascript:changeTimeType(this, '<%=timeAmountId %>', '<%=timeUnitId %>')">
									<option value="last" <%=prefVal != null && prefVal.length() > 0 ? "selected" : ""%>>Last</option>
									<option value="allTime" <%=prefVal != null && prefVal.length() > 0 ? "" : "selected"%>>All Time</option>
								</select>
								<input id="<%=timeAmountId %>" name="<%=userPrefNamePrefix + name%>" type="textbox" value="<%=prefVal%>" size="5" style="visibility:<%=prefVal != null && prefVal.length() > 0 ? "visible" : "hidden"%>;">
								<select id="<%=timeUnitId %>" name="<%=userPrefNamePrefix%>xplg_timeUnit" style="visibility:<%=prefVal != null && prefVal.length() > 0 ? "visible" : "hidden"%>">
<% 
					Element xplg_timeUnitElement = null;
					String xplg_timeUnitName = "xplg_timeUnit";
					for (int j = 0; j < list.size(); j++){
						Element tmp = (Element)list.get(j);
						String tmpName = XMLUtil.getAttribute(tmp,"name","");
						if(tmpName.equals(xplg_timeUnitName)) {
							xplg_timeUnitElement = tmp;
							break;
						}
					}
					if(xplg_timeUnitElement != null) {
						String tmpDefaultValue = XMLUtil.getAttribute(xplg_timeUnitElement,"default_value","");
						String tmpPrefVal = request.getParameter("up_" + xplg_timeUnitName);
						if(tmpPrefVal == null) {
							tmpPrefVal = tmpDefaultValue;
						}
						List enumList = XMLUtil.getChildsElementsByTagName(xplg_timeUnitElement,"EnumValue");
			      for (int j = 0; j < enumList.size();j++){
			        Element valElem = (Element)enumList.get(j); 
			        String optionName = XMLUtil.getAttribute(valElem,"display_value",null);
			        String optionValue = XMLUtil.getAttribute(valElem,"value",null);
			        if (optionName == null || optionValue == null){
			           continue; 
			        }
%>
            			<option value="<%=optionValue%>" <%=tmpPrefVal.equalsIgnoreCase(optionValue) ? "selected" : ""%>><%=optionName%></option>
<%
			      }
					}
%>
            		</select>
<%
				}else if(name.equals("xplg_logId")) {
					String selectedLogId = "";
					if(prefVal != null && prefVal.length() > 0) {
						selectedLogId = prefVal;
					}
					String actionsNames = "Close";
					String actions = "javascript:closeLogSelectionDiv" + suffix + "()";
					
					String adminSuffix = "SelectLog" + gadgetId;
%>
						<input id="<%=id%>" name="<%=userPrefNamePrefix + name%>" type="hidden" value="<%=prefVal%>">
						<jsp:include page="../../../common/selectLogHeader.jsp" flush="true">
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="LBM_ID" value="<%=selectedLogId%>" />
							<jsp:param name="mode" value="logs" />
							<jsp:param name="treeOnly" value="true" />
							<jsp:param name="ignoreHeader" value="true" />
							<jsp:param name="allowNewLog" value="true" />
							<jsp:param name="logPopupMenu" value="true" />
							<jsp:param name="openLinkName" value="select log" />
							<jsp:param name="paramNameWidth" value="150" />
							<jsp:param name="dummy" value="dummy" />
							<jsp:param name="suffix" value="<%=suffix %>" />
							<jsp:param name="doInclude" value="false" />
						</jsp:include>
						<jsp:include page="../../../common/adminGeneralDiv.jsp" flush="true">
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
							<jsp:param name="title" value="Select Log"/> 
							<jsp:param name="suffix" value="<%=adminSuffix %>"/> 
							<jsp:param name="width" value="650px"/> 
							<jsp:param name="height" value="300px"/> 
							<jsp:param name="actionsNames" value="<%=actionsNames %>"/> 
							<jsp:param name="actions" value="<%=actions %>"/> 
						</jsp:include>
						<jsp:include page="../../../common/selectLog.jsp" flush="true">
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="LBM_ID" value="<%=selectedLogId%>" />
							<jsp:param name="ignoreHeader" value="true"/>
							<jsp:param name="noTree" value="true"/>
							<jsp:param name="mode" value="logs" />
							<jsp:param name="logPopupMenu" value="true" />
							<jsp:param name="hideParameterName" value="true" />
							<jsp:param name="openLinkName" value="select log" />
							<jsp:param name="openLinkClassName" value="WIDGETS_PORTAL_EDIT_GADGET_LINK" />
							<jsp:param name="labelWidth" value="150" />
							<jsp:param name="textBoxSize" value="30" />
							<jsp:param name="suffix" value="<%=suffix %>" />
						</jsp:include>
						
						<script>
						var updateSourceForLogChangeFunctions<%=suffix %> = new Array();
						function updateSourceForLogChange<%=suffix %>(id,name){
							if (id){
								var lbmId = id;
								if (id.indexOf("Log-") == 0){
									lbmId = id.substring(4);
								}
								document.getElementById('<%=id %>').value = lbmId;
								
								for(var i = 0; i < updateSourceForLogChangeFunctions<%=suffix %>.length; i++) {
									updateSourceForLogChangeFunctions<%=suffix %>[i](lbmId);
								}
							}
						}
						</script>
<%
				}else {
%>
         				<input id="<%=id%>" name="<%=userPrefNamePrefix + name%>" type="textbox" value="<%=prefVal%>" size="40">
<%
					if(name.equals("xplg_searchQuery")) {
						SearchHistoryManager searchHistoryManager = SearchHistoryManager.getInstance();
						List savedSearches = searchHistoryManager.getSavedSearchesList(userContext);
						if(savedSearches != null && savedSearches.size() > 0) {
%>
						<img onClick="javascript:openSavedSearchesList('<%=id%>')" title="Open saved searches list" src="<%=BASE_DIRECTORY %>images/widgets/dashboard/gadget/gadgetMenuArrowOverTitle.gif" border="0">
<%
						}
					}
				}
			}else if (dataType.equalsIgnoreCase("enum")){
				int size = XMLUtil.getAttribute(e,"size",1);
				boolean multiple = XMLUtil.getAttribute(e,"multiple",false);
				String onChange = XMLUtil.getAttribute(e,"onChange",null);
				if(onChange != null) {
					onChange = XpologUtil.replaceAll(onChange, "[SUFFIX]", suffix);
				}
%>
						<select id="<%=id%>" name="<%=userPrefNamePrefix + name%>" size="<%=size%>" class="WIDGETS_PORTAL_EDIT_GADGET_SELECT_FIELD" <%=multiple ? "multiple=\"multiple\"" : ""%> <%=onChange == null ? "" : "onChange=\"javascript:" + onChange + "\""%>>
<%
				if(name.equals("xplg_filterIds")) {
					String selectedLogId = request.getParameter("up_xplg_logId");
					if(selectedLogId == null) {
						selectedLogId = "";
					}
					String selectedFilterIds = prefVal;
%>
			<jsp:include page="filtersList.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="lbmId" value="<%=selectedLogId%>" />
				<jsp:param name="filterIds" value="<%=selectedFilterIds%>" />
				<jsp:param name="resultType" value="options"/>
			</jsp:include>
			
			<script>
				function updateFiltersList<%=suffix %>(lbmId) {
					// clear the filters list
					var selectElement = document.getElementById('<%=id %>');
					for (var i = selectElement.options.length; i >= 0; i--) {
					  selectElement.options[i] = null;
					}
				
					var url = "../admin/filtersList.jsp?lbmId=" + lbmId;
					sendAjaxRequest(url, function(req){
			    	var xmldoc = req.responseXML.documentElement;
				    if(xmldoc) {
				   	 	var filtersElement = xmldoc.getElementsByTagName("Filters")[0];
				    	if(filtersElement) {
					    	var filterElements = filtersElement.getElementsByTagName("Filter");
  							if(filterElements) {
  								for(var i = 0; i < filterElements.length; i++) {
  									var id = filterElements[i].getAttribute('id');
  									var name = filterElements[i].getAttribute('name');
  									
  									var newOption = document.createElement('option');
									  newOption.text = name;
									  newOption.value = id;
									  
									  try {
									    selectElement.add(newOption, null); // standards compliant; doesn't work in IE
									  }
									  catch(ex) {
									    selectElement.add(newOption); // IE only
									  }
  								}
  							}
  						}
						}
					});
				}
				updateSourceForLogChangeFunctions<%=suffix %>[updateSourceForLogChangeFunctions<%=suffix %>.length] = updateFiltersList<%=suffix %>;
			</script>
<%
				}else if(name.equals("xplg_reportId")) {
					String selectedReportId = prefVal;
%>
			<jsp:include page="reportsList.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="reportId" value="<%=selectedReportId%>" />
				<jsp:param name="resultType" value="options"/>
			</jsp:include>
<%
				}else if(name.equals("xplg_caseId")) {
					String selectedReportId = request.getParameter("up_xplg_reportId");
					if(selectedReportId == null) {
						selectedReportId = "";
					}
					String selectedCaseId = prefVal;
%>
			<jsp:include page="reportCasesList.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="reportId" value="<%=selectedReportId%>" />
				<jsp:param name="caseId" value="<%=selectedCaseId%>" />
				<jsp:param name="resultType" value="options"/>
			</jsp:include>
			
			<script>
				function updateCasesList<%=suffix %>(reportsList) {
					var reportId = reportsList.options[reportsList.selectedIndex].value;
					// clear the filters list
					var selectElement = document.getElementById('<%=id %>');
					for (var i = selectElement.options.length; i >= 0; i--) {
					  selectElement.options[i] = null;
					}
				
					var url = "../admin/reportCasesList.jsp?reportId=" + reportId;
					sendAjaxRequest(url, function(req){
					var xmldoc = req.responseXML.documentElement;
				    if(xmldoc) {
				   	 	var casesElement = xmldoc.getElementsByTagName("Cases")[0];
				    	if(casesElement) {
					    	var casesElements = casesElement.getElementsByTagName("Case");
					    	if(casesElements) {
  								for(var i = 0; i < casesElements.length; i++) {
  									var id = casesElements[i].getAttribute('id');
  									var name = casesElements[i].getAttribute('name');
  									
  									var newOption = document.createElement('option');
									  newOption.text = name;
									  newOption.value = id;
									  try {
									    selectElement.add(newOption, null); // standards compliant; doesn't work in IE
									  }
									  catch(ex) {
									    selectElement.add(newOption); // IE only
									  }
  								}
  							}
  						}
						}
					});
				}
			</script>
<%
				}else {
		      List enumList = XMLUtil.getChildsElementsByTagName(e,"EnumValue");
		      for (int j = 0; j < enumList.size();j++){
		        Element valElem = (Element)enumList.get(j); 
		        String optionName = XMLUtil.getAttribute(valElem,"display_value",null);
		        String optionValue = XMLUtil.getAttribute(valElem,"value",null);
		        if (optionName == null || optionValue == null){
		           continue; 
		        }
%>
            	<option value="<%=optionValue%>" <%=prefVal.equalsIgnoreCase(optionValue) ? "selected" : ""%>><%=optionName%></option>
<%
					}
				}
%>
          	</select>
<%
			}
%>
      		</td>
    		</tr>
<%
    }
  		count++;
  	}
%>
				<tr style="height: 20px">
					<td colspan="2" style="width:0px">
						<div id="<%=xplgGadgetId %>AdminErrorDiv" class="WIDGETS_PORTAL_EDIT_GADGET_ERROR_DIV"></div>
					</td>
				</tr>
				<input type="hidden" id="<%="m_" + gadgetId + "_numfields"%>" value="<%=String.valueOf(count)%>">
			</table>
		</td>
	</tr>
</table>
<%
	}else {
%>
No user input was found please check gadget specifcation
<%
	}
%>
]]></Data>
</Result>