<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.util.WebUtil"%>

<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
String resultType = request.getParameter("resultType");
if(resultType == null || resultType.length() == 0) {
	resultType = "xml";
}

String lbmId = request.getParameter("lbmId");
LogBrowsingManager lbm = null;
if (lbmId != null && lbmId.length() > 0){
	try{
		lbm = SiteManagment.getInstance().getLogBrowserManager(lbmId);
	}catch(Exception e){
	}
}
 String filterIdsStr = request.getParameter("filterIds");
 HashSet filterIds = new HashSet();
 if (filterIdsStr != null && filterIdsStr.length() > 0){
 	String[] filterIdsArr = filterIdsStr.split(",");
 	for (int i=0; i<filterIdsArr.length; i++){
 		filterIds.add(filterIdsArr[i]);
 	}
 }
FilterManager filterMgr = lbm != null ? lbm.getFilterManager(): null;
List list = filterMgr != null ? filterMgr.getFilterCollections() : null;
FilterCollection [] filters = list != null ? (FilterCollection [])list.toArray(new FilterCollection[list.size()]) : new FilterCollection[0];
Arrays.sort(filters,FilterCollection.nameComparator);
if(lbm != null) {
	lbm.dispose();
}
%>

<%
if (resultType.equals("options")) {
	String selected = filterIds.contains("allRecords") ? "selected" : "";
	if(filterMgr != null) { 
%>
<option value="<%=DefaultAllFilter.ALL_FILTER_ID %>" <%=selected %>>All Events</option>
<%
		for (int i=0; i<filters.length; i++){
			selected = filterIds.contains(filters[i].getId()) ? "selected" : "";
%>
<option value="<%=filters[i].getId()%>" <%=selected %>><%=filters[i].getName()%></option>
<%
		}
	}
}else{
	response.setContentType("text/xml; charset=UTF-8");
%>
<Response>
	<Filters>
<%
	if(filterMgr != null) { 
%>
		<Filter id="<%=DefaultAllFilter.ALL_FILTER_ID %>" name="All Events" selected="<%=filterIds.contains(DefaultAllFilter.ALL_FILTER_ID)%>" />
<%
		for (int i=0; i<filters.length; i++){
%>
		<Filter id="<%=filters[i].getId()%>" name="<%=WebUtil.doHTMLEncoding(filters[i].getName())%>" selected="<%=filterIds.contains(filters[i].getId())%>" />
<%
		}
	}
%>
	</Filters>
</Response>
<%
}
%>