<%@ page language="java"%>

<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.util.WebUtil"%>
<%@page import="xpolog.eye.site.widgets.view.WidgetsView"%>
<%@page import="xpolog.eye.site.widgets.XpoLogWidgetsManager"%>
<%@page import="xpolog.eye.site.widgets.view.portal.PortalWidgetsViewContainer"%>
<%@page import="xpolog.eye.site.widgets.view.portal.PortalWidgetsLayout"%>
<%@page import="xpolog.eye.site.widgets.view.portal.PortalGadget"%>

<%@page import="org.w3c.dom.Element"%>
<%@page import="java.io.File"%>
<%@page import="xpolog.eye.util.XMLUtil"%>
<%@page import="org.w3c.dom.Document"%>
<%@page import="xpolog.eye.error.ErrorModel"%>
<%@page import="java.io.InputStream"%>
<%@page import="java.net.URL"%>
<%@page import="java.util.List"%>
<%@page import="java.util.Enumeration"%>

<%!
static final String BASE_DIRECTORY = "../../../";
%>
<%

  UserContext userContext = UserEnvironment.getUserContext(request);
  WebSecurityManager manager = WebSecurityManager.getInstance();

  String gadgetId = request.getParameter("gadgetId");
  String xplgGadgetId = request.getParameter("xplgGadgetId");
  WidgetsView  view = null;
  String viewId = request.getParameter("viewId");
  if (viewId != null && viewId.length() > 0){
    view = XpoLogWidgetsManager.getIntsance().getWidgetsView(request,WidgetsView.PORTAL_VIEW_TYPE,viewId);  
  }
  
	String status = "ok";
	String message = "";
	int numberOfGadgets = -1;
 	if (xplgGadgetId != null && xplgGadgetId.length() > 0){
   	PortalWidgetsViewContainer container = (PortalWidgetsViewContainer)view.getContainer();
   	if (container != null){
   		//audit
      AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
     	  	userContext, AuditConstants.CHANGE, "remove dashboard gadget", AuditConstants.WIDGETS, "remove dashboard gadget " + xplgGadgetId);
   		
   		container.removePortalGadget(xplgGadgetId);
   		XpoLogWidgetsManager.getIntsance().updateWidgetsView(request,view);
   		numberOfGadgets = container.getAllGadgets().length;
   	}
 	}else {
 		status = "error";
 		message = "No gadget was selected";
 	}
response.setContentType("text/xml; charset=UTF-8");
%>
<RemoveGadgetResponse>
<Result status="<%=status %>" message="<%=message %>" numberOfGadgets="<%=numberOfGadgets %>"/>
</RemoveGadgetResponse>