<%@ page language="java"%>

<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.entities.XpologPrincipal"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.ModuleMemberPermissions"%>
<%@ page import="xpolog.eye.security.UserSecurity"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.security.XpologSecurityHelper"%>
<%@ page import="xpolog.eye.security.XpologSecurityManager"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.site.widgets.view.WidgetsView"%>
<%@ page import="xpolog.eye.site.widgets.XpoLogWidgetsManager"%>
<%@ page import="xpolog.eye.util.WebUtil"%>

<%@ page import="java.util.Collection"%>
<%@ page import="java.util.HashSet"%>
<%@ page import="java.util.Iterator"%>

<%!
static final String BASE_DIRECTORY = "../../../";

%>

<%

UserContext userContext = UserEnvironment.getUserContext(request);
WebSecurityManager manager = WebSecurityManager.getInstance();
UserSecurity security = manager.getUserSecurity(request);


XpoLogWidgetsManager widgetsManager = XpoLogWidgetsManager.getIntsance();

WidgetsView view = null;
WidgetsView templateView = null;
String viewId = request.getParameter("viewId");
UserContext ownerUserContext = null;
boolean isNew = true;
if (viewId != null && viewId.length() > 0){
  view = widgetsManager.getWidgetsView(request,WidgetsView.PORTAL_VIEW_TYPE,viewId);  
  if(view != null) {
  	isNew = false;
  	ownerUserContext = view.getUserContext();
  }
}

String templateId = request.getParameter("templateId");
if (templateId != null && templateId.length() > 0){
  templateView = widgetsManager.getWidgetsTemplateView(request,WidgetsView.PORTAL_VIEW_TYPE,templateId);
}
String viewName = request.getParameter("viewName");
String message = "";
 
try {
   if (viewName == null || viewName.length() == 0){
      message = "Dashboard name is missing";  
   }else if (templateView == null){
	    message = "Dashboard layout was not selected";
   }else {
  	 WidgetsView[] widgetsViews = widgetsManager.getWidgetsViewList(request,WidgetsView.PORTAL_VIEW_TYPE);
  	 if(widgetsViews != null && widgetsViews.length > 0) {
  		 for(int i = 0; i < widgetsViews.length; i++) {
  			 if(widgetsViews[i].getName().equals(viewName) && (viewId == null || viewId.length() == 0 || !widgetsViews[i].getId().equals(viewId))) {
  				 message = "A dashboard with the same name already exists";  
  				 break;
  			 }
  		 }
  	 }
  	 if(WebUtil.isContainSpecialCharecter(viewName)){
  	 		message = "The following characters are prohibited in the name field: "+ WebUtil.getSpecialCharectersList();
  	 }
  	 
  	 
	  ModuleMemberPermissions permissions = null;
  	 
  	if(message.length() == 0) {
	  	if (view == null){
	       view = templateView;
	       view.setId("");
	       view.setName("");
	       //permissions
	       permissions = new ModuleMemberPermissions();
	       HashSet editNamesCol = new HashSet();
	       if (userContext != null){
	      	 UserSecurity userSecurity = userContext.getUser();
	      	 if (userSecurity != null){
	      		 String userName = userSecurity.getUser().getName();
	      		 editNamesCol.add(userName);
	      	 }
	       }
    		 editNamesCol.add("administrators");
				 permissions.setEditMembers(editNamesCol);

	       HashSet viewNamesCol = new HashSet();
	       viewNamesCol.add("All");
				 permissions.setViewMembers(viewNamesCol);

	    }else {
		 		//permissions
		 		if (XpologSecurityManager.getInstance().isEnabled()){
		 		  String permissionsPolicy = request.getParameter("memberPolicy");
		 		  if (permissionsPolicy != null && permissionsPolicy.equals("current")){
		 		    ModuleMemberPermissions orgPermissions = view.getPermissions();
		 		    Collection orgEditMembers = orgPermissions != null ? orgPermissions.getEditMembers() : null;
		 		    Collection orgViewMembers = orgPermissions != null ? orgPermissions.getViewMembers() : null;
		 		    Collection nonAdministeredEditMembers = null;
		 		    Collection nonAdministeredViewMembers = null;
		 		    if (orgEditMembers != null){
		 		    	nonAdministeredEditMembers = XpologSecurityHelper.getNonAdministeredPrincipals(security,manager.getGroupsMembersByNames(orgEditMembers,false));
		 		    }
		 		    permissions = new ModuleMemberPermissions();
		 		    String [] editNames = request.getParameterValues("selectedEditMembersList");
		 		    HashSet editNamesCol = new HashSet();
		 				if (editNames != null && editNames.length > 0){
		 					for (int i=0; i<editNames.length; i++){
		 						editNamesCol.add(editNames[i]);
		 					}
		 				}
		 				if (nonAdministeredEditMembers != null){
		 			  	Iterator it = nonAdministeredEditMembers.iterator();
		 			  	while (it.hasNext()){
		 			  		XpologPrincipal p = (XpologPrincipal)it.next();
		 			  		editNamesCol.add(p.getName());
		 			  	}
		 				}
		 				if (!editNamesCol.isEmpty()){
		 					permissions.setEditMembers(editNamesCol);
		 				}
		 			
		 		    if (orgViewMembers != null){
		 		    	nonAdministeredViewMembers = XpologSecurityHelper.getNonAdministeredPrincipals(security,manager.getGroupsMembersByNames(orgViewMembers,false));
		 		    }
		 				String [] viewNames = request.getParameterValues("selectedViewMembersList");
		 		    HashSet viewNamesCol = new HashSet();
		 				if (viewNames != null && viewNames.length > 0){
		 					for (int i=0; i<viewNames.length; i++){
		 						viewNamesCol.add(viewNames[i]);
		 					}
		 				}
		 				if (nonAdministeredViewMembers != null){
		 			  	Iterator it = nonAdministeredViewMembers.iterator();
		 			  	while (it.hasNext()){
		 			  		XpologPrincipal p = (XpologPrincipal)it.next();
		 			  		viewNamesCol.add(p.getName());
		 			  	}
		 				}
		 				if (!viewNamesCol.isEmpty()){
		 					permissions.setViewMembers(viewNamesCol);
		 				}
		 		  }
		 		}
	    }
	    view.setTemplateKey(templateId);
	    view.setName(viewName);
	    if(isNew) {
	    	view.setUserContext(userContext);
	    }else {
	    	view.setUserContext(ownerUserContext);
	    }
	     
			view.setPermissions(permissions);
	   	
	     //audit
	     AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   	  	userContext, AuditConstants.CHANGE, "save dashboard", AuditConstants.WIDGETS, "save dashboard " + view.getName());
	     
	     widgetsManager.updateWidgetsView(request,view);
	     viewId = view.getId();
  	 }
   }
}catch (Exception e){
  ErrorModel.log.error("Failed to save new/edit portal view " + viewId + " with template " + templateId,e); 
  message = "Failed to save dashboard " + viewName;
}
response.setContentType("text/xml; charset=UTF-8");
%>

<Result>
<Message><![CDATA[<%=message%>]]></Message>
<ViewID><%=viewId%></ViewID>
</Result>
