<%@ page language="java"%>

<%@ page import="java.util.Date"%>
<%@ page import="java.util.HashSet"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.CustomizationManager"%>
<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.data.filters.FilterManager"%>
<%@ page import="xpolog.eye.data.source.DataReference"%>
<%@ page import="xpolog.eye.data.Record"%>
<%@ page import="xpolog.eye.data.RecordMask"%>
<%@ page import="xpolog.eye.knowledge.common.KnowledgeDataProcessing"%>
<%@ page import="xpolog.eye.knowledge.common.KnowledgeDataRequest"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewRiskModel"%>
<%@ page import="xpolog.eye.search.data.impl.records.SearchDataModelRecordEvent"%>
<%@ page import="xpolog.eye.search.ui.SearchResultRecord"%>
<%@ page import="xpolog.eye.search.ui.SearchViewHelper"%>
<%@ page import="xpolog.eye.search.SearchResultLogInfo"%>
<%@ page import="xpolog.eye.search.SearchUtil"%>
<%@ page import="xpolog.eye.site.ui.grid.types.GridValueWrapper"%>
<%@ page import="xpolog.eye.site.widgets.data.ui.WidgetRecordsDataResult"%>
<%@ page import="xpolog.eye.util.DateUtil"%>
<%@ page import="xpolog.eye.util.WebUtil"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>
<%@ page import="xpolog.eye.SearchManager"%>
<%@ page import="xpolog.eye.SiteManagment"%>

<%!static final String BASE_DIRECTORY = "../../../";%>

<%
int MAX_CHARS_PER_EVENT = Configuration.getInstance().getPropertiesManager().getPropertyAsInt("xpolog.eye.search.ui.maxCharsPerEvent", 500);
int MAX_CHARS_PER_COLUMN = Configuration.getInstance().getPropertiesManager().getPropertyAsInt("xpolog.eye.search.ui.maxCharsPerColumn", 100);

String baseDirectory = request.getParameter("baseDirectory");
if (baseDirectory == null) {
	baseDirectory = BASE_DIRECTORY;
}

String suffix = "";

WidgetRecordsDataResult recordsDataResult = (WidgetRecordsDataResult)request.getAttribute("recordsDataResult" + suffix);
/*if (table == null) {
	table = (WidgetGridTable) session.getAttribute("widgetTable" + suffix);
}*/
List searchResultEvents = recordsDataResult == null ? null : recordsDataResult.getSearchResultEvents();

boolean isDashboardValid = SiteManagment.getInstance().getXpologManagment().isDashboardValidAndComponentExists();
boolean dashboardAnalysisActive = false;//model.isDashboardAnalysisActive();

try {
	if(searchResultEvents != null && searchResultEvents.size() > 0) {		
		response.setCharacterEncoding("UTF-8");
%>

<table id="widgetTable" class="tablesorter" border="0" cellpadding="0" cellspacing="0" width="100%">
	<thead>
	<tr style="display: none">
		<th class="{sorter: false}" style="width:150px">Event Time</th>
		<th class="{sorter: false}">Event Content</th>
	</tr>
	</thead>
	<tbody>
<%
		SearchDataModelRecordEvent event = null;
		SearchResultRecord searchResultRecord = null;
		
		String rowClassName = null;
		String rowId = null;
		String zoomIntoLogLink = null;
		//String zoomIntoLogLink = null, zoomIntoLogMouseActionsString = null, zoomIntoLogMouseActionsStringMessage = null;
		//String zoomIntoDashboardLink = null, zoomIntoDashboardMouseActionsString = null, zoomIntoDashboardMouseActionsStringMessage = null;
		
		SearchManager searchManager = null;
		FilterManager filterManager = null;
		KnowledgeDataProcessing knowledgeProcess = null;
		KnowledgeDataRequest knowledgeRequest = null;
		FilterCollection[] riskFilters = null;
		
		/*long startTime = currentResult.getStartTime();
		long endTime = currentResult.getEndTime();*/
		
		HealthViewRiskModel riskModel = null;
		
		HashSet columnsSet = recordsDataResult.getColumnsSet();
		
		boolean recordIsLong = false, recordIsCollapsed = false;
		for(int i = 0; i < searchResultEvents.size(); i++) {
			searchManager = null;
			
			event = (SearchDataModelRecordEvent)searchResultEvents.get(i);
			searchResultRecord = event.getRecResult();
			if(searchResultRecord == null) {
				continue;
			}
			
			rowId = "mainTableRow_" + i;
			
			if(i % 2 == 0) {
				rowClassName = "WIDGETS_PORTAL_RECORDS_LIST_COLORED_ROW";
			}else {
				rowClassName = "WIDGETS_PORTAL_RECORDS_LIST_REGULAR_ROW";
			}
			
			String logId = searchResultRecord.getLogId();
			Record record = searchResultRecord.getRecord();
			if(record == null) {
				continue;
			}
			DataReference dataReference = searchResultRecord.getDataReference();
			
			String recordDisplayHtml = null, recordDisplayHtmlShort = null, recordDateStr = null;;
			StringBuffer recordDisplayHtmlBuffer = null, recordDisplayHtmlShortBuffer = null;
			if(searchResultRecord.getRecordDisplayHtml() == null) {
				recordDisplayHtmlBuffer = new StringBuffer();
				recordDisplayHtmlShortBuffer = new StringBuffer();
				recordDateStr = "";
			}else {
				recordDisplayHtml = searchResultRecord.getRecordDisplayHtml();
				recordDisplayHtmlShort = searchResultRecord.getRecordDisplayHtmlShort();
				recordDateStr = searchResultRecord.getRecordsDateStr();
			}
			
			SearchResultLogInfo logInfo = recordsDataResult.getLogInfo(logId);
			String logName = "", hostName = "", applications = "", riskText = "";
			RecordMask recordMask = null;
			CustomizationManager customizationManager = null;
			String searchString = "";
			int numberOfColumns = -1;
			if(logInfo != null) {
				logName = logInfo.getLogName();
				if(logName == null) {
					logName = "";
				}
				hostName = logInfo.getHostName();
				if(hostName == null) {
					hostName = "";
				}
				applications = logInfo.getApplicationNamesStr();
				if(applications == null || applications.length() == 0) {
					applications = "None";
				}
				
				searchManager = logInfo.getSearchManager();
				filterManager = logInfo.getFilterManager();
				knowledgeProcess = logInfo.getKnowledgeProcess();
				knowledgeRequest = logInfo.getKnowledgeRequest();
				riskFilters = logInfo.getRiskFilters();
				
				recordMask = logInfo.getRecordMask();
				customizationManager = logInfo.getCustomizationManager();
				
				searchString = logInfo.getSearchString();
				numberOfColumns = recordMask.getCulomnsNumber();
			}
			riskText = "";
			
			recordIsLong = searchResultRecord.isLongRecord();
			recordIsCollapsed = searchResultRecord.isCollapsed();
			
			GridValueWrapper linkWrapper = event.getLinkWrapper();
			if(linkWrapper != null && recordsDataResult.getBaseDirectory() != null) {
				linkWrapper.setBaseDirectory(recordsDataResult.getBaseDirectory());
			}
			zoomIntoLogLink = GridValueWrapper.getGridCellText(linkWrapper);
			/*String searchStringForJavaScript = XpologUtil.updateAsHtmlString(searchString);
			searchStringForJavaScript = XpologUtil.replaceAll(searchStringForJavaScript, "'", "\\'");
			
			zoomIntoLogLink = "javascript:openLogFromSearch('" + baseDirectory + "','" + logId + "', '" + searchStringForJavaScript + "', 'true', document.getElementById('" + rowId + "'), false, '" + (dataReference != null ? dataReference.getKey() : "") + "', '" + minDateString + "', '" + maxDateString + "')";
			zoomIntoLogMouseActionsStringMessage = "searchTooltips['showLog']";
			zoomIntoLogMouseActionsString = "onMouseOver=\"javascript:showTooltip(" + zoomIntoLogMouseActionsStringMessage + ")\" onMouseOut=\"javascript:hideTooltip()\"";
			zoomIntoLogMouseActionsString = "";
			
			zoomIntoDashboardLink = "javascript:openDashboardFromSearch('" + BASE_DIRECTORY + "','" + XpoLogObjectTypes.LOG_TYPE + "', '" + logId + "', '" + startTime + "', '" + endTime + "')";
			zoomIntoDashboardMouseActionsStringMessage = "searchTooltips['showDashboard']";
			zoomIntoDashboardMouseActionsString = "onMouseOver=\"javascript:showTooltip(" + zoomIntoDashboardMouseActionsStringMessage + ")\" onMouseOut=\"javascript:hideTooltip()\"";
			zoomIntoDashboardMouseActionsString = "";*/
			
			if(recordDisplayHtml == null) {
				/*KnowledgeResponse knowledgeResponse = null;            
				if (currentResult.isProcessKnowledge() && dashboardAnalysisActive && knowledgeRequest != null){
		     	try {
		    		JobStatus status = new JobStatus();
		       	knowledgeRequest.clearData();
			    	KnowledgeLogHelper.upadteRequestData(knowledgeRequest,null,record);
			    	knowledgeResponse =  knowledgeProcess.processRequest(knowledgeRequest, status);
		      }catch (Exception e){
		        ErrorModel.log.error("Failed to get event knowledge ",e); 
		      }
		    }
	      
				ArrayList eventRiskFiltersList = new ArrayList();
				if (currentResult.isProcessKnowledge() && dashboardAnalysisActive && riskFilters != null){
	        for(int r = 0; r < riskFilters.length;r++){
	           if (riskFilters[r].accept(record)){
	        	   eventRiskFiltersList.add(riskFilters[r]);
	           }
	        }
	      }*/
				
				String dateStr = "";
				if(numberOfColumns > -1) {
					boolean shouldTruncateEvent = false;
					int[] charsInColumn = new int[numberOfColumns];
					if(MAX_CHARS_PER_EVENT > -1) {
						int numberOfCharsInEvent = 0;
						for(int j = 0; j < numberOfColumns; j++) {
							if(customizationManager != null) {
								int columnIndex = customizationManager.getCustomizedColFromIndex(j);
								if(columnIndex == -1) {
									continue;
								}
							}
							
							int numberOfCharsInColumn = 0;
							
							Object obj = record.getFieldAt(j);
							String value = obj == null ? "" : SearchUtil.getColumnValue(recordMask, j, obj);
							
							if(value.equals("")) {
								continue;
							}
							
							if(obj instanceof Date) {
								continue;
							}
							
							int indexOfSpace = -1;
							while((indexOfSpace = value.indexOf(" ")) != -1) {
								numberOfCharsInColumn += (indexOfSpace + 1);
								numberOfCharsInEvent += (indexOfSpace + 1);
								
								value = value.substring(indexOfSpace + 1);
							}
							if(value.length() > 0) {
								numberOfCharsInColumn += value.length();
								numberOfCharsInEvent += value.length();
							}
							
							charsInColumn[j] = numberOfCharsInColumn;
						}
						
						if(numberOfCharsInEvent > MAX_CHARS_PER_EVENT) {
							shouldTruncateEvent = true;
						}
					}
					recordIsLong = shouldTruncateEvent;
					
					for(int j = 0; j < numberOfColumns; j++) {
						if(customizationManager != null) {
							int columnIndex = customizationManager.getCustomizedColFromIndex(j);
							if(columnIndex == -1) {
								continue;
							}
						}
						
						Object obj = record.getFieldAt(j);
						String value = obj == null ? "" : SearchUtil.getColumnValue(recordMask, j, obj);
						String shortValue = null;
						
						if(obj instanceof Date) {
							dateStr = value;
							continue;
						}
						
						String name = "";
						if(recordMask != null) {
							name = SearchUtil.getColumnName(recordMask, j);
						}
						if (columnsSet != null && columnsSet.size() > 0 && !columnsSet.contains(name.toLowerCase())){
		        	continue;
		        }
						
						if (recordDisplayHtmlBuffer.length() > 0){
							recordDisplayHtmlBuffer.append(" ").append("|").append(" ");
						}
						if (recordDisplayHtmlShortBuffer.length() > 0){
							recordDisplayHtmlShortBuffer.append(" ").append("|").append(" ");
						}
						
						if (name != null && name.length() > 0){
							recordDisplayHtmlBuffer.append("<span class=\"WIDGETS_PORTAL_RECORDS_LIST_GADGET_RECORD_TEXT_COLUMN_NAME\"><nobr>[" + name + "]</nobr></span>");
							recordDisplayHtmlShortBuffer.append("<span class=\"WIDGETS_PORTAL_RECORDS_LIST_GADGET_RECORD_TEXT_COLUMN_NAME\"><nobr>[" + name + "]</nobr></span>");
						}
						
						value = WebUtil.doHTMLEncoding(value);
						value = XpologUtil.replaceAll(value, "\n", "<br>");
						
						if(searchManager != null && filterManager != null) {
							/*if (knowledgeResponse != null){
						     value = searchManager.updateKnowledgeTermStr(knowledgeResponse,searchManager,value,j, searchResultRecord);				     
						  }
		          if (eventRiskFiltersList != null){
		        	  value = searchManager.updateFilterRiskTermStr(searchManager,value,j, searchResultRecord,filterManager,eventRiskFiltersList);
		          }*/
							value = searchManager.updateFilterTermStr(filterManager, searchManager, value, j);
						}
						
						shortValue = value;
						
						if(shouldTruncateEvent) {
							int numberOfCharsInColumn = charsInColumn[j];
							if(numberOfCharsInColumn > MAX_CHARS_PER_COLUMN) {
								shortValue = SearchViewHelper.getShortColumn(shortValue);
							}
						}
						
						recordDisplayHtmlBuffer.append(" <span id=\"d_" + rowId + "_" + j + "\">").append(value).append("</span>");
						recordDisplayHtmlShortBuffer.append(" <span id=\"d_" + rowId + "_" + j + "\">").append(shortValue).append("</span>");
				  }
				}
				recordDisplayHtml = recordDisplayHtmlBuffer.toString();
				recordDisplayHtmlShort = recordDisplayHtmlShortBuffer.toString();
				recordDateStr = dateStr;
				
				searchResultRecord.setRecordDisplayHtml(recordDisplayHtml);
				searchResultRecord.setRecordDisplayHtmlShort(recordDisplayHtmlShort);
				searchResultRecord.setRecordsDateStr(recordDateStr);
				
				searchResultRecord.setLongRecord(recordIsLong);
			}
			
			String riskTextClass = "WIDGETS_PORTAL_RECORDS_LIST_GADGET_RISK_";
			/*String riskBorderClass = "WIDGETS_PORTAL_RECORDS_LIST_GADGET_SOURCE_CELL_RISK_";
			if(isDashboardValid && currentResult.isProcessKnowledge() && dashboardAnalysisActive) {
				if(riskModel == null) {
					riskModel = HealthViewRiskModel.getInstance();
				}
				double riskLevel = searchResultRecord.getRiskLevel();
				if(riskLevel == 0) {
					riskLevel = -1;
				}
				riskText = riskModel.getRiskName(riskLevel);
				int bgSuffix = riskModel.getRiskClassNameSuffix(riskLevel);
				if(bgSuffix == 0) {
					bgSuffix = -1;
				}
				if(bgSuffix > 0) {
					riskTextClass += String.valueOf(bgSuffix);
					riskBorderClass += String.valueOf(bgSuffix);
				}
			}*/
%>
				<tr id="<%=rowId %>" class="<%=rowClassName %>">
					<td class="WIDGETS_PORTAL_RECORDS_LIST_GADGET_RECORD_CELL" colspan="2"  style="border-left: 0px none;">
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td class="WIDGETS_PORTAL_RECORDS_LIST_GENERAL_CELL WIDGETS_PORTAL_RECORDS_LIST_CELL WIDGETS_PORTAL_RECORDS_LIST_GADGET_SOURCE_CELL" style="border-bottom: 0px none; border-left: 0px none;">
									<nobr><%=recordDateStr %></nobr>
									<%if(false && /*isDashboardValid && dashboardAnalysisActive && */riskText.length() > 0) { %>
									<br>
									<span class="WIDGETS_PORTAL_RECORDS_LIST_GADGET_RECORD_TEXT_COLUMN_NAME">Severity:</span> <span class="<%=riskTextClass %>"><%=riskText %></span>
									<%} %>
								</td>
								<%
								String recordCellDisplay = "none", shortRecordCellDisplay = "none";
								if(false/*allEventsCollapsed*/) {
									if(recordIsLong && recordIsCollapsed) {
										shortRecordCellDisplay = "";
									}else {
										recordCellDisplay = "";
									}
								}else {
									if(recordIsLong && recordIsCollapsed) {
										shortRecordCellDisplay = "";
									}else {
										recordCellDisplay = "";
									}
								}
								//System.out.println("recordCellDisplay=" + recordCellDisplay + ", shortRecordCellDisplay=" + shortRecordCellDisplay);
								%>
								<td id="<%=rowId %>RecordCell" style="display:<%=recordCellDisplay %>; border: 0px none;" class="WIDGETS_PORTAL_RECORDS_LIST_GENERAL_CELL WIDGETS_PORTAL_RECORDS_LIST_CELL WIDGETS_PORTAL_RECORDS_LIST_RECORD_CELL WIDGETS_PORTAL_RECORDS_LIST_RECORD_TEXT">
									<%=recordDisplayHtml %>
									<%
									if(false && recordIsLong) {
									%>
										&nbsp;<a style="vertical-align: bottom" href="javascript:toggleEventCollapsed('<%=rowId %>', 'true');"><img src="<%=baseDirectory %>images/search/mainTable/buttonCollapseRecord.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/buttonCollapseRecordOver.gif');javascript:showTooltip(searchTooltips['collapseCurrentEvent'])" onMouseOut="javascript:setImageSource(this, 'mainTable/buttonCollapseRecord.gif');javascript:hideTooltip()"></a>
									<%
									}
									%>
									<br><br>
									<span class="WIDGETS_PORTAL_RECORDS_LIST_RECORD_TEXT_SOURCE_TEXT">[Log] <%=logName %>&nbsp;&nbsp;&nbsp;</span>
									<span class="WIDGETS_PORTAL_RECORDS_LIST_RECORD_TEXT_SOURCE_TEXT">[Host] <%=hostName %>&nbsp;&nbsp;&nbsp;</span>
									<span class="WIDGETS_PORTAL_RECORDS_LIST_RECORD_TEXT_SOURCE_TEXT">[Applications] <%=applications %></span>
									&nbsp;<%=zoomIntoLogLink %>
									<br>
								</td>
								<td id="<%=rowId %>ShortRecordCell" style="display:<%=shortRecordCellDisplay %>; border: 0px none;" class="WIDGETS_PORTAL_RECORDS_LIST_GENERAL_CELL WIDGETS_PORTAL_RECORDS_LIST_CELL WIDGETS_PORTAL_RECORDS_LIST_RECORD_CELL WIDGETS_PORTAL_RECORDS_LIST_RECORD_TEXT" style="">
									<%=recordDisplayHtmlShort %>
									<%
									if(false && recordIsLong) {
									%>
										&nbsp;<a style="vertical-align: bottom" href="javascript:toggleEventCollapsed('<%=rowId %>', 'true');"><img src="<%=baseDirectory %>images/search/mainTable/buttonExpandRecord.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/buttonExpandRecordOver.gif');javascript:showTooltip(searchTooltips['expandCurrentEvent'])" onMouseOut="javascript:setImageSource(this, 'mainTable/buttonExpandRecord.gif');javascript:hideTooltip()"></a>
									<%
									}
									%>
									<br><br>
									<span class="WIDGETS_PORTAL_RECORDS_LIST_RECORD_TEXT_SOURCE_TEXT">[Log] <%=logName %>&nbsp;&nbsp;&nbsp;</span>
									<span class="WIDGETS_PORTAL_RECORDS_LIST_RECORD_TEXT_SOURCE_TEXT">[Host] <%=hostName %>&nbsp;&nbsp;&nbsp;</span>
									<span class="WIDGETS_PORTAL_RECORDS_LIST_RECORD_TEXT_SOURCE_TEXT">[Applications] <%=applications %></span>
									&nbsp;<%=zoomIntoLogLink %>
									<br>
								</td>
							</tr>
						</table>
					</td>
				</tr>
<%
		}
%>
	</tbody>
</table>
<%
  }else {
    String message = "No matching log events were found";
%>
<table border="0" width="100%" cellspacing="0" cellpadding="0">
	<tr>
    <td class="WIDGETS_PORTAL_RECORDS_LIST_GADGET_NO_DATA_CELL"><%=message %></td>
  </tr>
</table>
        
<%    
	}
} catch (Throwable e) {
	e.printStackTrace();
}
%>