<%@ page language="java"%>

<%@ page import="xpolog.eye.site.ui.grid.*"%>
<%@ page import="xpolog.eye.site.ui.grid.types.GridValueWrapper"%>
<%@ page import="xpolog.eye.site.ui.grid.types.LinkGridValue"%>
<%@ page import="xpolog.eye.site.widgets.view.portal.WidgetGridTable"%>

<%!static final String BASE_DIRECTORY = "../../../";%>

<%
String baseDirectory = request.getParameter("baseDirectory");
if (baseDirectory == null) {
	baseDirectory = BASE_DIRECTORY;
}

String suffix = "";

WidgetGridTable table = (WidgetGridTable)request.getAttribute("widgetTable" + suffix);
/*if (table == null) {
	table = (WidgetGridTable) session.getAttribute("widgetTable" + suffix);
}*/
GridTableModel model = table == null ? null : table.getModel();

try {
	if(model != null && model.getRowsCount() > 0) {
		response.setCharacterEncoding("UTF-8");
%>
<table id="widgetTable" class="tablesorter" border="0" cellpadding="0" cellspacing="0" width="100%">
	<thead>
	<tr>
<%
		for(int i = 0; i < model.getColumnsCount(); i++) {
			GridColumn col = model.getColumnAt(i);
			
			String style = "";
			String borderStyle = "";
			if(i == 0) {
				borderStyle = "border-left: none;";
			}
			String widthStyle = "";
			String w = col.getWidth();
			if(w != null && !w.equals("-1")) {
				widthStyle = "width: " + w + "px;";
			}
			
			if(borderStyle.length() > 0 || widthStyle.length() > 0) {
				style = "style=\"" + borderStyle + widthStyle + "\"";
			}
			
%>
		<th class="{sorter: false}" <%=style %> ><%=col.getName()%> </th>
<%
		}
%>
	</tr>
	</thead>
	<tbody>
<%
		for (int j = 0; j < model.getRowsCount(); j++) {
			String rowClassName = "";
			if(j % 2 == 0) {
				rowClassName = "WIDGETS_PORTAL_TABLE_GADGET_COLORED_ROW";
			}else {
				rowClassName = "WIDGETS_PORTAL_TABLE_GADGET_REGULAR_ROW";
			}
			 String rowId = model.getRowAt(j).getId();
%>
		<tr id="<%=rowId %>">
<%
			for (int i = 0; i < model.getColumnsCount(); i++) {
				GridColumn col = model.getColumnAt(i);
				String w = col.getWidth();
				GridValue value = model.getValueAt(j, i);
				String text = value == null ? "" : value.getGridText();
				String tooltip = value == null ? "" : value.getTooltip();
		    
				boolean isHtml = col.isHTML();
				if (value instanceof GridValueWrapper) {
					if(model.getBaseDirectory() != null) {
						((GridValueWrapper)value).setBaseDirectory(model.getBaseDirectory());
					}
					text = GridValueWrapper.getGridCellText((GridValueWrapper)value);
					isHtml = true;
				}else if (value instanceof LinkGridValue) {
					text = "<a href=\"" + ((LinkGridValue) value).getLink() + "\" style=\"text-decoration: none\" " + (tooltip != null && tooltip.length() > 0 ? "title=\"" + tooltip + "\"" : "") + ">" + ((LinkGridValue) value).getName() + "</a>";
				}else if (col.getType() == GridColumn.IMG_TYPE){
					String [] args = text.split("\\^");
					text = "<img src=\"" + args[0] + "\">";
					isHtml = true;
				}
				if (text.length() == 0) {
					text = "&nbsp;";
				}else if (!isHtml && !(value instanceof LinkGridValue)){
					text = text.replaceAll("<", "&lt;");
					text = text.replaceAll(">", "&gt;");
				}
				if(text.length() > 100) {
					//text = text.substring(0, 100);
				}
%>
			<td <%=i == 0 ? "style=\"border-left: none\"" : "" %>> <%=text%> </td>
<%
			}
%>
		</tr>
<%
		}
%>
	</tbody>
</table>
<%
  }else {
    String message = "No data available";
%>
<table border="0" width="100%" cellspacing="0" cellpadding="0">
	<tr>
    <td class="WIDGETS_PORTAL_TABLE_GADGET_NO_DATA_CELL"><%=message %></td>
  </tr>
</table>
        
<%    
	}
} catch (Throwable e) {
	e.printStackTrace();
}
%>