gadgets.XpoLogUserPrefStore = function() {
  gadgets.UserPrefStore.call(this);
};
gadgets.XpoLogUserPrefStore.inherits(gadgets.UserPrefStore);

gadgets.XpoLogUserPrefStore.prototype.getPrefs = function(gadget) { };

gadgets.container.userPrefStore = new gadgets.XpoLogUserPrefStore();

gadgets.IfrGadget.prototype.getTitleBarContent = function(continuation){
	var menuItemMinimize = '';
	if(CURRENT_GADGET_ID == '') {
		menuItemMinimize += '<tr id="portalGadgetMenuItemMinimize' + this.getIframeId() + '" class="WIDGETS_PORTAL_GADGET_MENU_ITEM" onClick="gadgets.container.getGadget(' + this.id + ').handleToggle();closeGadgetMenu(\'portalGadgetMenuDiv' + this.getIframeId() + '\');changeGadgetMenuMinimizeText(\'portalGadgetMenuItemMinimizeCell' + this.getIframeId() + '\', \'' + this.getIframeId() + '\');return false;" onMouseOver="javascript:setGadgetMenuItemClass(\'portalGadgetMenuItemMinimize' + this.getIframeId() + '\', \'WIDGETS_PORTAL_GADGET_MENU_ITEM_OVER\')" onMouseOut="javascript:setGadgetMenuItemClass(\'portalGadgetMenuItemMinimize' + this.getIframeId() + '\', \'WIDGETS_PORTAL_GADGET_MENU_ITEM\')">' +
								'<td id="portalGadgetMenuItemMinimizeCell' + this.getIframeId() + '" class="WIDGETS_PORTAL_GADGET_MENU_ITEM_CELL">Minimize</td>' +
							'</tr>';
	}
	var menuItemMaximize = '';
	if(CURRENT_GADGET_ID == '') {
		menuItemMaximize += '<tr id="portalGadgetMenuItemMaximize' + this.getIframeId() + '" class="WIDGETS_PORTAL_GADGET_MENU_ITEM" onClick="maximizeGadget(\'' + this.xplgGadgetId + '\');closeGadgetMenu(\'portalGadgetMenuDiv' + this.getIframeId() + '\');return false;" onMouseOver="javascript:setGadgetMenuItemClass(\'portalGadgetMenuItemMaximize' + this.getIframeId() + '\', \'WIDGETS_PORTAL_GADGET_MENU_ITEM_OVER\')" onMouseOut="javascript:setGadgetMenuItemClass(\'portalGadgetMenuItemMaximize' + this.getIframeId() + '\', \'WIDGETS_PORTAL_GADGET_MENU_ITEM\')">' +
						  	  '<td class="WIDGETS_PORTAL_GADGET_MENU_ITEM_CELL">Maximize</td>' +
						  	'</tr>';
	}else {
		menuItemMaximize += '<tr id="portalGadgetMenuItemMaximize' + this.getIframeId() + '" class="WIDGETS_PORTAL_GADGET_MENU_ITEM" onClick="restoreGadget();closeGadgetMenu(\'portalGadgetMenuDiv' + this.getIframeId() + '\');return false;" onMouseOver="javascript:setGadgetMenuItemClass(\'portalGadgetMenuItemMaximize' + this.getIframeId() + '\', \'WIDGETS_PORTAL_GADGET_MENU_ITEM_OVER\')" onMouseOut="javascript:setGadgetMenuItemClass(\'portalGadgetMenuItemMaximize' + this.getIframeId() + '\', \'WIDGETS_PORTAL_GADGET_MENU_ITEM\')">' +
						  	  '<td class="WIDGETS_PORTAL_GADGET_MENU_ITEM_CELL">Restore</td>' +
						  	'</tr>';
	}
	
	var menuItemRefresh = '<tr id="portalGadgetMenuItemRefresh' + this.getIframeId() + '" class="WIDGETS_PORTAL_GADGET_MENU_ITEM" onClick="refreshGadget(' + this.id + ', true);closeGadgetMenu(\'portalGadgetMenuDiv' + this.getIframeId() + '\');return false;" onMouseOver="javascript:setGadgetMenuItemClass(\'portalGadgetMenuItemRefresh' + this.getIframeId() + '\', \'WIDGETS_PORTAL_GADGET_MENU_ITEM_OVER\')" onMouseOut="javascript:setGadgetMenuItemClass(\'portalGadgetMenuItemRefresh' + this.getIframeId() + '\', \'WIDGETS_PORTAL_GADGET_MENU_ITEM\')">' +
							'<td class="WIDGETS_PORTAL_GADGET_MENU_ITEM_CELL">Refresh</td>' +
						  '</tr>';
	
	var menuItemEdit = '';
	if(this.hasViewablePrefs_() && CURRENT_GADGET_ID == '' && IS_EDITABLE) {
		menuItemEdit += '<tr id="portalGadgetMenuItemEdit' + this.getIframeId() + '" class="WIDGETS_PORTAL_GADGET_MENU_ITEM" onClick="gadgets.container.getGadget(' + this.id + ').handleOpenUserPrefsDialog();closeGadgetMenu(\'portalGadgetMenuDiv' + this.getIframeId() + '\');handleGadgetTitleButtons(false, \'' + this.getIframeId() + '\');return false;" onMouseOver="javascript:setGadgetMenuItemClass(\'portalGadgetMenuItemEdit' + this.getIframeId() + '\', \'WIDGETS_PORTAL_GADGET_MENU_ITEM_OVER\')" onMouseOut="javascript:setGadgetMenuItemClass(\'portalGadgetMenuItemEdit' + this.getIframeId() + '\', \'WIDGETS_PORTAL_GADGET_MENU_ITEM\')">' +
						  '<td class="WIDGETS_PORTAL_GADGET_MENU_ITEM_CELL">Edit</td>' +
						'</tr>';
	}
	
	var menuItemRemove = '';
	var separatorLine = '';
	if(this.hasViewablePrefs_() && CURRENT_GADGET_ID == '' && IS_EDITABLE) {
		menuItemRemove += '<tr id="portalGadgetMenuItemRemove' + this.getIframeId() + '" class="WIDGETS_PORTAL_GADGET_MENU_ITEM" onClick="removeGadget(' + this.id + ');closeGadgetMenu(\'portalGadgetMenuDiv' + this.getIframeId() + '\');return false;" onMouseOver="javascript:setGadgetMenuItemClass(\'portalGadgetMenuItemRemove' + this.getIframeId() + '\', \'WIDGETS_PORTAL_GADGET_MENU_ITEM_OVER\')" onMouseOut="javascript:setGadgetMenuItemClass(\'portalGadgetMenuItemRemove' + this.getIframeId() + '\', \'WIDGETS_PORTAL_GADGET_MENU_ITEM\')">' +
						  	'<td class="WIDGETS_PORTAL_GADGET_MENU_ITEM_CELL">Remove</td>' +
						  '</tr>';
		separatorLine += '<tr id="portalGadgetMenuItemSeparator' + this.getIframeId() + '"><td><hr /></td></tr>';
	}
	
	var menuDiv = '<div id="portalGadgetMenuDiv' + this.getIframeId() + '" class="WIDGETS_PORTAL_GADGET_MENU_CONTAINER">' +
					 '<div id="portalGadgetMenuShadowDiv" class="WIDGETS_PORTAL_GADGET_MENU_SHADOW">' +
						'<div id="portalGadgetMenuMenuDiv" class="WIDGETS_PORTAL_GADGET_MENU_CONTENT">' +
							'<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">' +
								menuItemMinimize +
								menuItemMaximize + 
								menuItemRefresh +
								separatorLine +
								menuItemEdit +
								menuItemRemove +
							'</table>' +
						'</div>' +
					  '</div>' +
					'</div>';
	
	var maximizeButton = '';
	if(CURRENT_GADGET_ID == '') {
		maximizeButton = '<a id="gadgetMaximizeLink' + this.getIframeId() + '" href="javascript:maximizeGadget(\'' + this.xplgGadgetId + '\');" onMouseOver="javascript:showTooltip(widgetsPortalTooltips[\'maximizeGadget\'])" onMouseOut="javascript:hideTooltip()"><img id="gadgetMaximize' + this.getIframeId() + '" src="' + BASE_DIRECTORY + 'images/widgets/dashboard/gadget/gadgetMaximize.gif" border="0"></a>';
		maximizeButton += '<img id="gadgetMaximizeDisabled' + this.getIframeId() + '" src="' + BASE_DIRECTORY + 'images/widgets/dashboard/gadget/gadgetMaximize.gif" border="0" style="display: none">';
	}else {
		maximizeButton = '<a id="gadgetMaximizeLink' + this.getIframeId() + '" href="javascript:restoreGadget();" onMouseOver="javascript:showTooltip(widgetsPortalTooltips[\'restoreGadget\'])" onMouseOut="javascript:hideTooltip()"><img id="gadgetMaximize' + this.getIframeId() + '" src="' + BASE_DIRECTORY + 'images/widgets/dashboard/gadget/gadgetRestore.gif" border="0"></a>';
		maximizeButton += '<img id="gadgetMaximizeDisabled' + this.getIframeId() + '" src="' + BASE_DIRECTORY + 'images/widgets/dashboard/gadget/gadgetRestore.gif" border="0" style="display: none">';
	}
	maximizeButton += '&nbsp;';
	
	var title = this.title;
	if(title) {
		var maxTitleLength = 40;
		if(title.length > maxTitleLength) {
			title = title.substr(0, maxTitleLength);
			title += "...";
		}
	}else {
		title = '';
	}
	
	var xplgGadgetIdParam = "";
	if(this.xplgGadgetId) {
		xplgGadgetIdParam = this.xplgGadgetId;
	}
	continuation('<div id="' + this.cssClassTitleBar + '-' + this.id +
    		'" class="' + this.cssClassTitleBar + '">'+
    		
    		'<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">'+
    		'<tr onMouseOver="javascript:handleMouseOverGadgetTitleRow(\'' + this.getIframeId() + '\', true, \'' + xplgGadgetIdParam + '\')" onMouseOut="javascript:if(!document.all){handleMouseOverGadgetTitleRow(\'' + this.getIframeId() + '\', false, \'' + xplgGadgetIdParam + '\')}" onMouseLeave="javascript:handleMouseOverGadgetTitleRow(\'' + this.getIframeId() + '\', false, \'' + xplgGadgetIdParam + '\')">'+
    		'<td id="gadgetLeftCell-' + this.getIframeId() +'" class="WIDGETS_PORTAL_GADGET_TITLE_LEFT_CELL">&nbsp;</td>'+
    		'<td id="gadgetMainCell-' + this.getIframeId() +'" class="WIDGETS_PORTAL_GADGET_TITLE_MAIN_CELL">'+
    		
    		'<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">'+
    		'<tr>'+
    		'<td class="WIDGETS_PORTAL_GADGET_TITLE_TEXT_CELL DRAG_HANDLE">'+
    		'<span id="' +
    		this.getIframeId() + '_title" class="' +
    		this.cssClassTitle + '">' + title + '</span>'+
    		'</td>'+
    		'<td id="gadgetButtonsCell-' + this.getIframeId() +'" class="WIDGETS_PORTAL_GADGET_TITLE_BUTTONS_CELL">'+
    		'<span class="' +
    		this.cssClassTitleButtonBar + '">' +
    		'<img id="gadgetMove' + this.getIframeId() + '" src="' + BASE_DIRECTORY + 'images/widgets/dashboard/gadget/gadgetMove.gif" border="0"style="cursor:move;" class="DRAG_HANDLE">&nbsp;' +
    		maximizeButton + 
    		'<a id="gadgetButtonOpenMenu' + this.getIframeId() +'" href="javascript:openGadgetMenu(\'' +this.cssClassTitleBar + '-' + this.id + '\', \'portalGadgetMenuDiv' + this.getIframeId() + '\', \'' + this.getIframeId() + '\');"><img id="gadgetMenuArrow' + this.getIframeId() + '" src="' + BASE_DIRECTORY + 'images/widgets/dashboard/gadget/gadgetMenuArrow.gif" border="0"></a>' +
    		'<img id="gadgetMenuArrowDisabled' + this.getIframeId() + '" src="' + BASE_DIRECTORY + 'images/widgets/dashboard/gadget/gadgetMenuArrow.gif" border="0" style="display: none">' +
    		'</span></div>'+
    		'</td>'+
    		'</tr>'+
    		'</table>'+
    		
    		'</td>'+
    		'<td id="gadgetRightCell-' + this.getIframeId() +'" class="WIDGETS_PORTAL_GADGET_TITLE_RIGHT_CELL">&nbsp;</td>'+
    		'</tr>'+
    		'</table>'+
    		
    		'</div>'+
    		
    		menuDiv);
}

gadgets.IfrGadget.prototype.getMainContent = function(continuation) {
  var iframeId = this.getIframeId();
  gadgets.rpc.setRelayUrl(iframeId, this.serverBase_ + this.rpcRelay);
  gadgets.rpc.setAuthToken(iframeId, this.rpcToken);
  continuation('<div class="' + this.cssClassGadgetContent + '"><iframe id="' +
      iframeId + '" name="' + iframeId + '" class="' + this.cssClassGadget +
      '" src="' + this.getIframeUrl() +
      '" frameborder="no" scrolling="no"' +
      (this.height ? ' height="' + this.height + '"' : '') +
      (this.width ? ' width="' + this.width + '"' : '') +
      '></iframe></div>');
};

gadgets.IfrGadget.prototype.handleOpenUserPrefsDialog = function() {
	  if (this.userPrefsDialogContentLoaded) {
		  if(this.canBeDisplayed && this.canBeDisplayed == "true") {
			  var cancelButton = document.getElementById("cancelButton" + this.id);
			  if(cancelButton) {
				  cancelButton.style.display = "";  
			  }
		  }
		  
		  this.showUserPrefsDialog();
		  this.hideMainFrame();
	  } else {
		  var gadget = this;
		  var params = "baseDirectory=" + BASE_DIRECTORY;
		  params += "&gadgetId=" + this.id;
		  params += "&xplgGadgetId=" + this.xplgGadgetId;
		  params += "&" + this.getUserPrefsParams() +  '&url=' + this.specUrl;
		  sendAjaxRequest(BASE_DIRECTORY + 'portal/widgets/admin/editPortalWidgetDivContent.jsp', function(req){
			var xmldoc = req.responseXML.documentElement;
		    if(xmldoc) {
		    	var dataElement = xmldoc.getElementsByTagName("Data")[0];
				if(dataElement) {
					var content = getXMLElementValue(dataElement);
					var userPrefsDialog = document.getElementById(gadget.getUserPrefsDialogId());
					gadget.userPrefsDialogContentLoaded = true;
					
					var cancelButtonDisplay = "";
					if(gadget.canBeDisplayed && gadget.canBeDisplayed == "false") {
						cancelButtonDisplay = "style=\"display: none\"";
					}
					userPrefsDialog.innerHTML = content +
					      '<div class="' + gadget.cssClassGadgetUserPrefsDialogActionBar +
					      '"><input type="button" value="Save" onclick="gadgets.container.getGadget(' +
					      gadget.id +').handleSaveUserPrefs()"> <input type="button" id="cancelButton' + gadget.id + '" value="Cancel" onclick="gadgets.container.getGadget(' +
					      gadget.id +').handleCancelUserPrefs()"' + cancelButtonDisplay + '></div>';
					gadget.showUserPrefsDialog();
					gadget.hideMainFrame();
					
					updateAjaxResponseScript(content);
					
					var inputs = document.getElementsByTagName('input');
					var input;
					for(i in inputs) {
						if(inputs[i].getAttribute && inputs[i].getAttribute("name") == "m_" + gadget.id + "_up_xplg_searchQuery") {
							var searchQueryId = inputs[i].getAttribute("id");
							var searchQueryElement = document.getElementById(searchQueryId);
							if(searchQueryElement) {
								autoCompleteObject = $("#" + searchQueryId).autocomplete({
									serviceUrl: BASE_DIRECTORY + "common/autocompleteHandler.jsp?type=complexSearch&source=dashboards",
									noCache: true,
									onSelect: handleAutoCompleteSelect,
									aposMask: APOS_MASK
								});
							}
							
							break;
						}
					}
					//alert(xplg_searchQuery);
					
				}
		    }
		}, "POST", params);		  							  						     
	   }
	}

gadgets.IfrGadget.prototype.handleCancelUserPrefs= function(){
		this.hideUserPrefsDialog();
		handleGadgetTitleButtons(true, this.getIframeId());
	}
	
gadgets.IfrGadget.prototype.hideMainFrame= function() {
		  var gadgetIframe = document.getElementById(this.getIframeId());
		  if (gadgetIframe) {
		    var gadgetContent = gadgetIframe.parentNode;
		    gadgetContent.style.display = 'none';
		  }
		}
	
gadgets.IfrGadget.prototype.hideUserPrefsDialog= function() {
		  this.showUserPrefsDialog(false);
		  this.handleToggle();
		}

gadgets.IfrGadget.prototype.hasViewablePrefs_= function(){
		return true;
		}


gadgets.IfrGadget.prototype.handleSaveUserPrefs = function() {
	var params = "baseDirectory=" + BASE_DIRECTORY;
    params += "&gadgetId=" + this.id;
    params += "&xplgGadgetId=" + this.xplgGadgetId;
    params += "&viewId=" + CURRENT_VIEW_ID;
    
    var timeType, timeTypeId, timeAmountId, timeUnitId;
    var userPrefParams = "";
    var numFields = document.getElementById('m_' + this.id + '_numfields').value;
	for (var i = 0; i < numFields; i++) {
		var inputId = 'm_' + this.id + '_' + i;
		var input = document.getElementById(inputId);
		var userPrefNamePrefix = 'm_' + this.id + '_up_';
		var userPrefName = input.name.substring(userPrefNamePrefix.length);
		var userPrefValue = trim(input.value);
		if(input.multiple) {
			userPrefValue = "";
			var selectElement = document.getElementById(inputId);
			for(var j = 0; j < selectElement.options.length; j++) {
				if(selectElement.options[j].selected) {
					if(userPrefValue != "") {
						userPrefValue += ",";
					}
					userPrefValue += selectElement.options[j].value;
				}
			}
		}
		userPrefValue = encodeURIComponent(userPrefValue);
		userPrefParams += ("&" + userPrefName + "=" + userPrefValue);
		
		if(userPrefName == "xplg_timeType") {
			timeType = userPrefValue;
			timeTypeId = input.id;
		}else if(userPrefName == "xplg_timeAmount") {
			timeAmountId = input.id;
		}else if(userPrefName == "xplg_timeUnit") {
			timeUnitId = input.id;
		}
	}
    params += "&" + userPrefParams +  '&url=' + this.specUrl;
    
    //change the visibility of the time amount and unit fields if last is selected but no amount was specified
    if(timeType && timeType == "last") {
    	var timeTypeElement = document.getElementById(timeTypeId);
    	var timeAmountElement = document.getElementById(timeAmountId);
    	var timeUnitElement = document.getElementById(timeUnitId);
    	if(timeTypeElement && timeAmountElement && timeUnitElement) {
    		if(trim(timeAmountElement.value) == "") {
    			timeTypeElement.selectedIndex = 1;
	    		timeAmountElement.value = "";
	    		timeAmountElement.style.visibility = "hidden";
	    		timeUnitElement.style.visibility = "hidden";
    		}
    	}
    }
    
    var currentGadget = this;
    
    var gadgetAdminErrorDiv = document.getElementById(currentGadget.xplgGadgetId + "AdminErrorDiv");
	if(gadgetAdminErrorDiv) {
		gadgetAdminErrorDiv.style.display = "none";
	}
    sendAjaxRequest(BASE_DIRECTORY + 'portal/widgets/admin/editPortalWidgetAction.jsp', function(req){
    	var xmldoc = req.responseXML.documentElement;
	    if(xmldoc) {
	    	var statusElement = xmldoc.getElementsByTagName("Status")[0];
	    	if(statusElement) {
	    		var status = statusElement.getAttribute("status");
	    		if(status && status == "error") {
	    			var messagesElement = xmldoc.getElementsByTagName("Messages")[0];
	    			if(messagesElement) {
	    				var messageElements = messagesElement.getElementsByTagName("Message");
	    				if(messageElements && messageElements.length > 0) {
	    					var errorMessageText = "<ul style='margin-left:0px; padding-left:20px; list-style-type:disc;'>";
	    					for(var i = 0; i < messageElements.length; i++) {
	    						var fieldId = messageElements[i].getAttribute("fieldId");
	    						var message = getXMLElementValue(messageElements[i]);
	    						errorMessageText += ("<li>" + message + "</li>");
	    					}
	    					errorMessageText += "</ul>";
	    					if(errorMessageText != "") {
	    						var gadgetAdminErrorDiv = document.getElementById(currentGadget.xplgGadgetId + "AdminErrorDiv");
	    						if(gadgetAdminErrorDiv) {
	    							replaceDivContent(currentGadget.xplgGadgetId + "AdminErrorDiv", errorMessageText);
	    							gadgetAdminErrorDiv.style.display = "block";
	    						}
	    					}
	    				}
	    			}
	    		}else {
	    			currentGadget.hideUserPrefsDialog();

	    			var numFields = document.getElementById('m_' + currentGadget.id + '_numfields').value;
	    			for (var i = 0; i < numFields; i++) {
	    				var inputId = 'm_' + currentGadget.id + '_' + i;
	    				var input = document.getElementById(inputId);
	    				var userPrefNamePrefix = 'm_' + currentGadget.id + '_up_';
	    				var userPrefName = input.name.substring(userPrefNamePrefix.length);
	    				var userPrefValue = trim(input.value);
	    				if(input.multiple) {
	    					userPrefValue = "";
	    					var selectElement = document.getElementById(inputId);
	    					for(var j = 0; j < selectElement.options.length; j++) {
	    						if(selectElement.options[j].selected) {
	    							if(userPrefValue != "") {
	    								userPrefValue += ",";
	    							}
	    							userPrefValue += selectElement.options[j].value;
	    						}
	    					}
	    				}
	    				if (currentGadget.userPrefs[userPrefName]){
	    					currentGadget.userPrefs[userPrefName].value = userPrefValue;
	    				}else {
	    					currentGadget.userPrefs[userPrefName] = {value:userPrefValue}
	    				}
	    			}
	    			
	    			if (currentGadget.userPrefs["xplg_gadgetId"]){
    					currentGadget.userPrefs["xplg_gadgetId"].value = currentGadget.xplgGadgetId;
    				}else {
    					currentGadget.userPrefs["xplg_gadgetId"] = {value:currentGadget.xplgGadgetId}
    				}
	    			
	    			currentGadget.canBeDisplayed = "true";
	    			//refreshGadget(currentGadget.id, false);
	    			currentGadget.refresh();
	    			  
	    			if(currentGadget.userPrefs.xplg_refreshInterval) {
	    			  handleGadgetRefreshInterval(currentGadget);
	    			}
	    			
	    			handleSavedGadgetButtonsAndMenu(currentGadget.getIframeId());
	    		}
	    	}
	    }
	}, "POST", params);
	};

var iframeCounter = 0;
gadgets.IfrGadget.prototype.getIframeId = function() {
			  return this.GADGET_IFRAME_PREFIX_ + this.id + "_" + iframeCounter;
			};
	
gadgets.Container.prototype.removeGadget = function(gadget) {
		var gadgetsArr = this.gadgets_;
		var newGadgetsArr = {};
		for (a in gadgetsArr) { 
			if(a != ('gadget_' + gadget.id)) {
				newGadgetsArr[a] = gadgetsArr[a];
			}
		}
		this.gadgets_ = newGadgetsArr;
	}

gadgets.Container.prototype.getGadgetByXplgGadgetId = function(xplgGadgetId) {
	var gadgetsArr = this.gadgets_;
	for (a in gadgetsArr) { 
		if(gadgetsArr[a].xplgGadgetId == xplgGadgetId) {
			return gadgetsArr[a];
		}
	}
	return null;
}

gadgets.StaticLayoutManager.prototype.addGadgetChromeId = function(gadgetId) {
			this.gadgetChromeIds_[this.gadgetChromeIds_.length] = gadgetId;
		};

gadgets.IfrContainer.prototype.renderGadget = function(gadget) {
	  var chrome = this.layoutManager.getGadgetChrome(gadget);
	  gadget.render(chrome);
	  if(gadget.canBeDisplayed && gadget.canBeDisplayed == "false" && IS_EDITABLE) {
		  gadget.handleOpenUserPrefsDialog();
		  handleNewGadgetButtonsAndMenu(gadget.getIframeId());
	  }
	};
	
gadgets.IfrGadgetService.prototype.setTitle = function(title) {
	var element = document.getElementById(this.f + '_title');
	if (element) {
		var index = title.indexOf("xplg_html:");
		if(index > -1) {
			title = title.substr(index + "xplg_html:".length);
			element.innerHTML = title;
		}else {
			element.innerHTML = title.replace(/&/g, '&amp;').replace(/</g, '&lt;');
		}
	}
};

gadgets.IfrContainer.prototype.gadgetService = new gadgets.IfrGadgetService();
gadgets.container.setParentUrl(document.location.protocol + '//' + document.location.host);