<%@ page language="java"%>

<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.site.widgets.view.portal.PortalWidgetsViewContainer"%>
<%@ page import="xpolog.eye.site.widgets.view.portal.PortalWidgetsLayout"%>
<%@ page import="xpolog.eye.site.widgets.view.portal.PortalWidgetsLayoutContainer"%>
<%@ page import="xpolog.eye.site.widgets.view.portal.PortalGadget"%>
<%@ page import="xpolog.eye.site.widgets.view.WidgetsView"%>
<%@ page import="xpolog.eye.site.widgets.XpoLogWidgetsManager"%>

<%!
static final String BASE_DIRECTORY = "../../../";
%>
<%

UserContext userContext = UserEnvironment.getUserContext(request);
WebSecurityManager manager = WebSecurityManager.getInstance();

WidgetsView  view = null;
String viewId = request.getParameter("viewId");
if (viewId != null && viewId.length() > 0){
	view = XpoLogWidgetsManager.getIntsance().getWidgetsView(request,WidgetsView.PORTAL_VIEW_TYPE,viewId);
}

String gadgetId = request.getParameter("gadgetId");
if(gadgetId == null) {
	gadgetId = "";
}

String maximizedGadgetLayoutWidth = null;
if(gadgetId.length() > 0) {
	maximizedGadgetLayoutWidth = request.getParameter("maximizedGadgetLayoutWidth");
	if(maximizedGadgetLayoutWidth == null || maximizedGadgetLayoutWidth.length() == 0) {
		maximizedGadgetLayoutWidth = "98%";
	}
}

response.setContentType("text/xml; charset=UTF-8");
%>

<PortalContainerResponse>
<%
if (view != null){
	PortalWidgetsViewContainer container =  (PortalWidgetsViewContainer)view.getContainer();
	PortalWidgetsLayoutContainer [] layoutContainers = container.getLayoutContainers();
  PortalWidgetsLayout [] layouts = container.getLayouts();
  StringBuffer layoutIdsForJquery = new StringBuffer(), gadgetNames = new StringBuffer();
  for (int i = 0; i < layouts.length;i++){
  	PortalGadget [] gadgets = layouts[i].getGadgets();
    if (gadgets == null || gadgets.length == 0 || (gadgetId.length() > 0 && !layouts[i].containsGadget(gadgetId))) {
    	continue;
    }
    
    if(i > 0) {
  		layoutIdsForJquery.append(",");
  	}
  	layoutIdsForJquery.append("#" + layouts[i].getId());
  	
    for(int j = 0; j < gadgets.length; j++) {
    	PortalGadget gadget = gadgets[j];
	    if (gadgetNames.length() > 0){
	    	gadgetNames.append(",");      
	    }
    	gadgetNames.append("'gadget_" + gadget.getId() + "'");
    }
  }
%>
	<Gadgets>
<%
	for (int i = 0; i < layouts.length;i++){
  	PortalGadget [] gadgets = layouts[i].getGadgets();
    if (gadgets == null || gadgets.length == 0 || (gadgetId.length() > 0 && !layouts[i].containsGadget(gadgetId))) {
    	continue;
    }
    for(int j = 0; j < gadgets.length; j++) {
    	PortalGadget gadget = gadgets[j];
%>
			<Gadget xplgGadgetId="<%=gadget.getId() %>" layout="<%=layouts[i].getId()%>" canBeDisplayed="<%=gadget.isCanBeDisplayed() %>">
				<![CDATA[<%=gadget.getGadgetParameters(request, true)%>]]>
			</Gadget>
<%
    }
	}
%>
  </Gadgets>
  
  <Layout gadgetNames="<%=gadgetNames%>" layoutIdsForJquery="<%=layoutIdsForJquery %>" viewId="<%=view.getId() %>" viewName="<%=view.getName() %>">
  	<![CDATA[
<%
	if(gadgetId.length() > 0) {
%>
		<div id="layoutContainer0" class="WIDGETS_PORTAL_LAYOUT_CONTAINER_DIV" style="margin-top: 10px">
			<div id="layout0" class="gadgets-gadget-chrome WIDGETS_PORTAL_LAYOUT_DIV connectedSortable" style="width:<%=maximizedGadgetLayoutWidth %>; padding:0 10px;">
				<div id="gadget_<%=gadgetId %>" class="WIDGETS_PORTAL_GADGET_DIV"></div>
			</div>
		</div>
<%
	}else {
		if(gadgetNames.length() == 0) {
			if(layoutContainers.length > 0) {
				if(layouts.length > 0) {
					for (int i = 0; i < layoutContainers.length;i++){
%>
					<div id="<%=layoutContainers[i].getId() %>" class="WIDGETS_PORTAL_LAYOUT_CONTAINER_DIV" style="<%=layoutContainers[i].getStyle()%>">
<%
						String layoutIdsStr = layoutContainers[i].getLayoutIds();
						String[] layoutIds = layoutIdsStr.split(",");
						for(int j = 0; j < layoutIds.length; j++) {
							PortalWidgetsLayout layout = container.getLayout(layoutIds[j]);
							if(layout != null) {
%>
								<div id="<%=layouts[j].getId() %>" class="gadgets-gadget-chrome WIDGETS_PORTAL_LAYOUT_DIV connectedSortable" style="<%=layouts[j].getStyle()%>"></div>
<%
							}
						}
%>
					</div>
<%
					}
				}else {
%>
					<div id="layoutContainer0" class="WIDGETS_PORTAL_LAYOUT_CONTAINER_DIV">
						<div id="layout0" class="gadgets-gadget-chrome WIDGETS_PORTAL_LAYOUT_DIV connectedSortable" style="width:<%=maximizedGadgetLayoutWidth %>"></div>
					</div>
<%   	
				}
			}else {
				if(layouts.length > 0) {
	    		for (int i = 0; i < layouts.length;i++){
%>
						<div id="layoutContainer<%=i %>" class="WIDGETS_PORTAL_LAYOUT_CONTAINER_DIV">
							<div id="<%=layouts[i].getId() %>" class="gadgets-gadget-chrome WIDGETS_PORTAL_LAYOUT_DIV connectedSortable" style="<%=layouts[i].getStyle()%>"></div>
						</div>
<%
	    		}
	    	}else {
%>
						<div id="layoutContainer0" class="WIDGETS_PORTAL_LAYOUT_CONTAINER_DIV">
	 						<div id="layout0" class="gadgets-gadget-chrome WIDGETS_PORTAL_LAYOUT_DIV connectedSortable" style="width:<%=maximizedGadgetLayoutWidth %>"></div>
	 					</div>
<%   	
	    	}
	    }
		}else {
			String maximizedGadgetLayoutStyle = "";
			if(gadgetId.length() > 0) {
				maximizedGadgetLayoutStyle = "width: " + maximizedGadgetLayoutWidth + ";";
			}
			
			if(layoutContainers.length > 0) {
				for (int i = 0; i < layoutContainers.length;i++){
					if(gadgetId.length() > 0 && !layoutContainers[i].containsGadget(container, gadgetId)) {
						continue;
					}
%>
					<div id="<%=layoutContainers[i].getId() %>" class="WIDGETS_PORTAL_LAYOUT_CONTAINER_DIV" style="<%=layoutContainers[i].getStyle()%>">
<%
						String layoutIdsStr = layoutContainers[i].getLayoutIds();
						String[] layoutIds = layoutIdsStr.split(",");
						for(int j = 0; j < layoutIds.length; j++) {
							PortalWidgetsLayout layout = container.getLayout(layoutIds[j]);
							if(layout != null) {
								if(gadgetId.length() > 0 && !layout.containsGadget(gadgetId)) {
									continue;
								}
%>
					    	<div id="<%=layout.getId()%>" class="gadgets-gadget-chrome WIDGETS_PORTAL_LAYOUT_DIV connectedSortable" style="<%=layout.getStyle()%> <%=maximizedGadgetLayoutStyle %>">
<%
								PortalGadget [] gadgets = layout.getGadgets();
		    				for(int k = 0; k < gadgets.length; k++) {
			    				if(gadgetId.length() > 0 && !gadgets[k].getId().equals(gadgetId)) {
		    						continue;
		    					}
%>
									<div id="gadget_<%=gadgets[k].getId() %>" class="WIDGETS_PORTAL_GADGET_DIV"></div>
<%		
		    				}
%>
    						</div>
<%
							}
						}
%>
					</div>
<%
				}
			}else {
				for (int i = 0; i < layouts.length;i++){
					if(gadgetId.length() > 0 && !layouts[i].containsGadget(gadgetId)) {
						continue;
					}
%>
			<div id="layoutContainer<%=i %>" class="WIDGETS_PORTAL_LAYOUT_CONTAINER_DIV">
	    	<div id="<%=layouts[i].getId()%>" class="gadgets-gadget-chrome WIDGETS_PORTAL_LAYOUT_DIV connectedSortable" style="<%=layouts[i].getStyle()%> <%=maximizedGadgetLayoutStyle %>">
<%
					PortalGadget [] gadgets = layouts[i].getGadgets();
		    	for(int j = 0; j < gadgets.length; j++) {
			    	if(gadgetId.length() > 0 && !gadgets[j].getId().equals(gadgetId)) {
		    			continue;
		    		}
%>
					<div id="gadget_<%=gadgets[j].getId() %>" class="WIDGETS_PORTAL_GADGET_DIV"></div>
<%		
		    	}
%>
    		</div>
    	</div>
<%
				}
			}
		}
	}
%>
  	]]>
  </Layout>
<%
}
%>
</PortalContainerResponse>
