<%@ page language="java"%>

<%@ page import="java.util.HashSet"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.search.ui.SearchViewHelper"%>
<%@ page import="xpolog.eye.search.SearchHistoryManager"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.widgets.view.WidgetsView"%>
<%@ page import="xpolog.eye.site.widgets.XpoLogWidgetsManager"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.SiteManagment"%>

<%!
static final String BASE_DIRECTORY = "../../../";

static final String HEADER_DIV_ID = "widgetsPortalHeaderDiv";
static final String BODY_DIV_ID = "widgetsPortalBodyDiv";
%>

<%

UserContext userContext = UserEnvironment.getUserContext(request);
WebSecurityManager manager = WebSecurityManager.getInstance();
String key = request.getParameter("key");
if (!SiteManagment.getInstance().checkKey(key)){
	if (!manager.checkForPermission(request, response, null, true)) {
	  return;
  }
}
if (!manager.checkForPermission(request,response,ActionsPermissionConstants.DashboardsPermissions.VIEW_DASHBOARDS_PERMISSION,true)){
  return;
}
boolean hasDashboardsPermission = manager.checkForPermission(request,response,ActionsPermissionConstants.DashboardsPermissions.DASHBOARDS_PERMISSION,false);
boolean hasViewDashboardsPermission = manager.checkForPermission(request,response,ActionsPermissionConstants.DashboardsPermissions.VIEW_DASHBOARDS_PERMISSION,false);
boolean hasEditDashboardPermission = manager.checkForPermission(request,response,ActionsPermissionConstants.DashboardsPermissions.EDIT_DASHBOARD_PERMISSION,false);



WidgetsView[] views = XpoLogWidgetsManager.getIntsance().getWidgetsViewList(request,WidgetsView.PORTAL_VIEW_TYPE);
WidgetsView currentView = null;

String selectedView = request.getParameter("selectedView");
String selectedViewName = "";
if (selectedView == null || selectedView.length() == 0){
	selectedView = "";
	if(views.length > 0) {
		currentView = views[0];
		selectedView = currentView.getId();
		selectedViewName = currentView.getName();
	}
}else {
	for (int i = 0; i < views.length; i++) {
		currentView = views[i];
		if(selectedView.equals(currentView.getId())) {
			selectedViewName = currentView.getName();
			break;
		}
		currentView = null;
	}
}

String selectedGadget = request.getParameter("selectedGadget");
if(selectedGadget == null) {
	selectedGadget = "";
}

String addNewDashboardStr = request.getParameter("addNewDashboard");
boolean addNewDashboard = addNewDashboardStr != null && addNewDashboardStr.equals("true");
if(addNewDashboard) {
	selectedView = "";
	selectedViewName = "";
}

int maxDashboardNameLength = 50;
String selectedViewNameShort = selectedViewName;
if(selectedViewNameShort.length() > maxDashboardNameLength) {
	selectedViewNameShort = selectedViewNameShort.substring(0, maxDashboardNameLength);
	selectedViewNameShort += "...";
}

String addDashboardSelectedTemplateId = "template1";
boolean isEditable = hasEditDashboardPermission && (userContext == null || (currentView != null && currentView.isEditable(userContext)));

UserContext ownerUserContext = null;
if(currentView != null) {
	ownerUserContext = currentView.getUserContext();
	if(ownerUserContext != null) {
		session.setAttribute("dashboards_ownerUserContext", ownerUserContext);
	}
}
boolean enableAutoComplete = SearchHistoryManager.ENABLE_AUTO_COMPLETE;
boolean useAutoCompelteCache = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("xpolog.eye.search.ui.useAutoCompelteCache", true);
if(useAutoCompelteCache && isEditable) {
	SearchViewHelper.createAutoCompleteCache(session, userContext, ownerUserContext);
}
%>

<html>

<head>

	<META HTTP-EQUIV="Content-Language" CONTENT="en-us">
	<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
	<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
	<META HTTP-EQUIV="EXPIRES" CONTENT="0">
	
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
	
	<%if(enableAutoComplete) { %>
	<!-- JQuery autocmplete css  -->
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/jquery/autocomplete/styles.css" />
	<%} %>
	
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/UIUtil.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/common/messages.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/comps/jsdomenu.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/jquery/jquery.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/jquery/jquery-ui-1.8.4.custom.min.js"></script>
	<%if(enableAutoComplete) { %>
	<!-- JQuery autocmplete code  -->
	<script type="text/javascript" src='<%=BASE_DIRECTORY%>scripts/jquery/autocomplete/jquery.autocomplete.js'></script>
	<%} %>
	
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxCalendar/codebase/dhtmlxcommon.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxCalendar/codebase/dhtmlxcalendar.js"></script>
	
  <!--<link rel="stylesheet" href="<%=BASE_DIRECTORY%>gadgets/files/container/gadgets.css"> -->
  <link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/widgetsPortal.css" />
	
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>gadgets/js/rpc.js?c=1&debug=1"></script>
  <script type="text/javascript" src="<%=BASE_DIRECTORY%>gadgets/files/container/cookies.js"></script>
  <script type="text/javascript" src="<%=BASE_DIRECTORY%>gadgets/files/container/util.js"></script>
  <script type="text/javascript" src="<%=BASE_DIRECTORY%>gadgets/files/container/gadgets.js"></script>
  <script type="text/javascript" src="<%=BASE_DIRECTORY%>gadgets/files/container/cookiebaseduserprefstore.js"></script>
  <script type="text/javascript" src="portalContainer.js"></script>
  <script type="text/javascript" src="widgetsPortal.js"></script>
  <script type="text/javascript" src="widgetsPortalTooltips.js"></script>
  
  <script type="text/javascript" src="<%=BASE_DIRECTORY%>widgets/popup/js/popup.js"></script>
  
  <jsp:include page="../../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
		<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	</jsp:include>
</head>

<script>

var BASE_DIRECTORY = "<%=BASE_DIRECTORY%>";
var GADGETS_BASE_DIRECTORY = "<%=BASE_DIRECTORY%>gadgets/";

var HEADER_DIV_ID = "<%=HEADER_DIV_ID %>";
var BODY_DIV_ID = "<%=BODY_DIV_ID %>";

var CURRENT_TEMPLATE_ID;
var CURRENT_VIEW_ID = "<%=selectedView %>";
var CURRENT_VIEW_NAME = "<%=selectedViewName %>";
var CURRENT_VIEW_NAME_SHORT = "<%=selectedViewNameShort %>";
var CURRENT_GADGET_ID = "<%=selectedGadget %>";

var IS_EDITABLE = <%=isEditable %>;

var APOS_MASK = "<%=SearchViewHelper.AUTO_COMPLETE_APOS_MASK %>";

addDashboardSelectedTemplateId = "<%=addDashboardSelectedTemplateId %>";
	
document.onclick = hideWidgetsPortalDivsIfClickedOutside;

function hideWidgetsPortalDivsIfClickedOutside(e) {
	var portalSettingsMenuDiv = document.getElementById("portalSettingsMenuDiv");
	if(portalSettingsMenuDiv && portalSettingsMenuDiv.style.display == "block") {
		var ignoreIds = new Array();
		ignoreIds[0] = "openPortalSettingsMenuLink";
		var hideIds = new Array();
		hideIds[0] = "widgetsPortalBodyCoverDiv";
		hideElementIfClickedOutside(e, "portalSettingsMenuDiv", ignoreIds, hideIds);
	}
	var widgetsPortalAddGadgetDiv = document.getElementById("widgetsPortalAddGadgetDiv");
	if(widgetsPortalAddGadgetDiv && widgetsPortalAddGadgetDiv.style.display == "block") {
		var ignoreIds = new Array();
		ignoreIds[0] = "openAddGadgetDivLink";
		ignoreIds[1] = "blankAddGadgetCellLink";
		ignoreIds[2] = "blankAddGadgetLink";
		var hideIds = new Array();
		hideIds[0] = "widgetsPortalBodyCoverDiv";
		hideElementIfClickedOutside(e, "widgetsPortalAddGadgetDiv", ignoreIds, hideIds);
	}
	var widgetsPortalChangeLayoutDiv = document.getElementById("widgetsPortalChangeLayoutDiv");
	if(widgetsPortalChangeLayoutDiv && widgetsPortalChangeLayoutDiv.style.display == "block") {
		var ignoreIds = new Array();
		ignoreIds[0] = "openChangeLayoutDivLink";
		var hideIds = new Array();
		hideIds[0] = "widgetsPortalBodyCoverDiv";
		hideElementIfClickedOutside(e, "widgetsPortalChangeLayoutDiv", ignoreIds, hideIds);
	}
	if(currentOpenGadgetMenuId) {
		var currentOpenGadgetMenu = document.getElementById(currentOpenGadgetMenuId);
		if(currentOpenGadgetMenu) {
			var ignoreIds = new Array();
			ignoreIds[0] = "gadgetMenuArrow" + currentIFrameId;
			var hideIds = new Array();
			hideElementIfClickedOutside(e, currentOpenGadgetMenuId, ignoreIds, hideIds);
		}
	}
}

</script>

<body onLoad="javascript:onWidgetsViewLoad('<%=selectedView %>', '<%=selectedGadget %>', '<%=addNewDashboard %>')">
<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/tooltip/wz_tooltip.js"></script>
<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/tooltip/tip_balloon.js"></script>
	<div id="<%=HEADER_DIV_ID %>" style="height:75px;">
		<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
			<tr class="WIDGETS_PORTAL_HEADER_ROW">
				<td class="WIDGETS_PORTAL_HEADER_CELL">
					<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
						<tr>
							<td class="WIDGETS_PORTAL_HEADER_TITLE_CELL WIDGETS_PORTAL_HEADER_TITLE">
								<span class="WIDGETS_PORTAL_HEADER_TITLE_BOLD">XpoLog Center Dashboard </span><span id="widgetsPortalHeaderDashboardName" class="WIDGETS_PORTAL_HEADER_TITLE_DASHBOARD_NAME"><%=selectedViewNameShort %></span>
							</td>                 
							<td>&nbsp;</td>
							<td class="WIDGETS_PORTAL_HEADER_BUTTONS_CELL">
							<%
							if(isEditable && views.length > 0 && selectedGadget.length() == 0 && !addNewDashboard) {
							%>
								<a id="openAddGadgetDivLink" href="javascript:openAddGadgetDiv()" onMouseOver="javascript:showTooltip(widgetsPortalTooltips['addGadget'])" onMouseOut="javascript:hideTooltip()"><img src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/buttonAddGadget.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/buttonAddGadgetOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/buttonAddGadget.gif')"></a>
								<a id="openChangeLayoutDivLink" href="javascript:openChangeLayoutDiv()" onMouseOver="javascript:showTooltip(widgetsPortalTooltips['changeLayout'])" onMouseOut="javascript:hideTooltip()"><img src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/buttonChangeLayout.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/buttonChangeLayoutOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/buttonChangeLayout.gif')"></a>
							<%
							}else {
							%>
								<img src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/buttonAddGadgetDisabled.gif" border="0">
								<img src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/buttonChangeLayoutDisabled.gif" border="0">
							<%
							}
							if(selectedGadget.length() == 0 && hasEditDashboardPermission) {
							%>
								<a id="openPortalSettingsMenuLink" href="javascript:openPortalSettingsMenu()" onMouseOver="javascript:showTooltip(widgetsPortalTooltips['portalSettings'])" onMouseOut="javascript:hideTooltip()"><img src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/buttonSettings.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/buttonSettingsOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/buttonSettings.gif')"></a>
							<%
							}else {
							%>
								<img src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/buttonSettingsDisabled.gif" border="0">
							<%
							}
							%>
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</table>
	</div>
	<div id="widgetsPortalHeaderCoverDiv" class="WIDGETS_PORTAL_HEADER_COVER_DIV"></div>
	<div id="widgetsPortalAddDashboardDiv" class="WIDGETS_PORTAL_ADD_DASHBOARD_DIV" style="display:none">
 		<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
 			<tr>
 				<td class="WIDGETS_PORTAL_ADD_DASHBOARD_DIV_CELL">
 					<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
 						<tr class="WIDGETS_PORTAL_ADD_DASHBOARD_DIV_TITLE_ROW">
			 				<td id="widgetsPortalAddDashboardTitleCell" class="WIDGETS_PORTAL_ADD_DASHBOARD_DIV_TITLE_CELL">
					    	Add New Dashboard
			 				</td>
			 			</tr>
			 			<tr class="WIDGETS_PORTAL_ADD_DASHBOARD_DIV_BODY_ROW">
			 				<td class="WIDGETS_PORTAL_ADD_DASHBOARD_DIV_BODY_CELL">
					    	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
					    		<tr style="height: 40px"><td>&nbsp;</td></tr>
					    		<tr style="height: 20px">
					    			<td style="width: 160px; font-size: 14px">Dashboard Name:</td>
					    			<td><input type="text" id="savePortalName" name="savePortalName" size="25" value="<%=selectedViewName %>"></input></td>
					    		</tr>
					    		<tr style="height: 100px" id="widgetsPortalAddDashboardSelectLayoutRow">
					    			<td style="width: 160px; font-size: 14px">Dashboard Layout:</td>
					    			<td>
											<a href="javascript:doSelectLayout('template1')"><img id="widgetsPortalAddDashboardSelectLayoutSelected_template1" src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/addDashboardLayout1ColumnSelected.gif" border="0" style="display:<%=addDashboardSelectedTemplateId.equals("template1") ? "" : "none" %>"><img id="widgetsPortalAddDashboardSelectLayout_template1" src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/addDashboardLayout1Column.gif" border="0"  style="display:<%=addDashboardSelectedTemplateId.equals("template1") ? "none" : "" %>" onMouseOver="javascript:setImageSource(this, 'header/addDashboardLayout1ColumnOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/addDashboardLayout1Column.gif')"></a>
											<a href="javascript:doSelectLayout('template2')"><img id="widgetsPortalAddDashboardSelectLayoutSelected_template2"src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/addDashboardLayout2ColumnsSelected.gif" border="0" style="display:<%=addDashboardSelectedTemplateId.equals("template2") ? "" : "none" %>"><img id="widgetsPortalAddDashboardSelectLayout_template2" src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/addDashboardLayout2Columns.gif" border="0"  style="display:<%=addDashboardSelectedTemplateId.equals("template2") ? "none" : "" %>" onMouseOver="javascript:setImageSource(this, 'header/addDashboardLayout2ColumnsOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/addDashboardLayout2Columns.gif')"></a>
											<a href="javascript:doSelectLayout('template3')"><img id="widgetsPortalAddDashboardSelectLayoutSelected_template3"src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/addDashboardLayout1Row2ColumnsSelected.gif" border="0" style="display:<%=addDashboardSelectedTemplateId.equals("template3") ? "" : "none" %>"><img id="widgetsPortalAddDashboardSelectLayout_template3" src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/addDashboardLayout1Row2Columns.gif" border="0"  style="display:<%=addDashboardSelectedTemplateId.equals("template3") ? "none" : "" %>" onMouseOver="javascript:setImageSource(this, 'header/addDashboardLayout1Row2ColumnsOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/addDashboardLayout1Row2Columns.gif')"></a>
											<a href="javascript:doSelectLayout('template4')"><img id="widgetsPortalAddDashboardSelectLayoutSelected_template4"src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/addDashboardLayout2Columns1RowSelected.gif" border="0" style="display:<%=addDashboardSelectedTemplateId.equals("template4") ? "" : "none" %>"><img id="widgetsPortalAddDashboardSelectLayout_template4" src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/addDashboardLayout2Columns1Row.gif" border="0"  style="display:<%=addDashboardSelectedTemplateId.equals("template4") ? "none" : "" %>" onMouseOver="javascript:setImageSource(this, 'header/addDashboardLayout2Columns1RowOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/addDashboardLayout2Columns1Row.gif')"></a>
					    			</td>
					    		</tr>
					    		<tr><td>&nbsp;</td></tr>
					    		<tr style="height: 20px">
					    			<td colspan="2" id="widgetsPortalAddDashboardErrorTd" class="WIDGETS_PORTAL_ADD_DASHBOARD_DIV_ERROR_CELL"></td>
					    		</tr>
					    	</table>
			 				</td>
			 			</tr>
			 			<tr class="WIDGETS_PORTAL_ADD_DASHBOARD_DIV_BUTTONS_ROW">
			 				<td class="WIDGETS_PORTAL_ADD_DASHBOARD_DIV_BUTTONS_CELL">
					    	<img src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/buttonSave.gif" onMouseOver="javascript:setImageSource(this, 'header/buttonSaveOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/buttonSave.gif')" onClick="javascript:doSavePortalView()"></img>
					    	<img src="<%=BASE_DIRECTORY %>images/widgets/dashboard/header/buttonCancel.gif" onMouseOver="javascript:setImageSource(this, 'header/buttonCancelOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/buttonCancel.gif')" onClick="javascript:hideEditPortalDiv()"></img>
			 				</td>
			 			</tr>
 					</table>
 				</td>
 			</tr>
 		</table>
  </div>
	<div id="layoutDummy" class="WIDGETS_PORTAL_BLANK_ADD_GADGET_DIV" style="display:none">
 		<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
 			<tr class="WIDGETS_PORTAL_BLANK_ADD_GADGET_DIV_LINK_ROW">
 				<td id="blankAddGadgetCellLink" class="WIDGETS_PORTAL_BLANK_ADD_GADGET_DIV_LINK_CELL" onClick="javascript:openAddGadgetDiv();">
		    	Add Gadget
 				</td>
 			</tr>
 		</table>
  </div>
	<div id="widgetsPortalAddGadgetDiv" class="WIDGETS_PORTAL_ADD_GADGET_DIV">
		<jsp:include page="addGadgetDivContent.jsp" flush="true" />
	</div>
	<div id="widgetsPortalChangeLayoutDiv" class="WIDGETS_PORTAL_CHANGE_LAYOUT_DIV">
	</div>
	<div id="portalSettingsMenuDiv" class="WIDGETS_PORTAL_SETTINGS_MENU_CONTAINER">
	 	<div id="portalSettingsMenuShadowDiv" class="WIDGETS_PORTAL_SETTINGS_MENU_SHADOW">
			<div id="portalSettingsMenuMenuDiv" class="WIDGETS_PORTAL_SETTINGS_MENU_CONTENT">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
					<%if(isEditable && views.length > 0 && !addNewDashboard) {%>
					<tr id="portalSettingsMenuItemEdit" class="WIDGETS_PORTAL_SETTINGS_MENU_ITEM" onClick="javascript:closePortalSettingsMenu();editPortalView();" onMouseOver="javascript:setSettingsMenuItemClass('portalSettingsMenuItemEdit', 'WIDGETS_PORTAL_SETTINGS_MENU_ITEM_OVER')" onMouseOut="javascript:setSettingsMenuItemClass('portalSettingsMenuItemEdit', 'WIDGETS_PORTAL_SETTINGS_MENU_ITEM')">
						<td class="WIDGETS_PORTAL_SETTINGS_MENU_ITEM_CELL">Edit Dashboard</td>
					</tr>
					<tr id="portalSettingsMenuItemRemove" class="WIDGETS_PORTAL_SETTINGS_MENU_ITEM" onClick="javascript:closePortalSettingsMenu();removePortalView();" onMouseOver="javascript:setSettingsMenuItemClass('portalSettingsMenuItemRemove', 'WIDGETS_PORTAL_SETTINGS_MENU_ITEM_OVER')" onMouseOut="javascript:setSettingsMenuItemClass('portalSettingsMenuItemRemove', 'WIDGETS_PORTAL_SETTINGS_MENU_ITEM')">
						<td class="WIDGETS_PORTAL_SETTINGS_MENU_ITEM_CELL">Remove Dashboard</td>
					</tr>
					<tr><td colspan="2"><hr></td></tr>
					<%}%>
					
					<%if(hasEditDashboardPermission) {%>
					<tr id="portalSettingsMenuItemAdd" class="WIDGETS_PORTAL_SETTINGS_MENU_ITEM" onClick="javascript:closePortalSettingsMenu();addPortalView();" onMouseOver="javascript:setSettingsMenuItemClass('portalSettingsMenuItemAdd', 'WIDGETS_PORTAL_SETTINGS_MENU_ITEM_OVER')" onMouseOut="javascript:setSettingsMenuItemClass('portalSettingsMenuItemAdd', 'WIDGETS_PORTAL_SETTINGS_MENU_ITEM')">
						<td class="WIDGETS_PORTAL_SETTINGS_MENU_ITEM_CELL">Add New Dashboard</td>
					</tr>
					<%}%>
				</table>
			</div>
	  </div>
	</div>
	
	<div id="<%=BODY_DIV_ID%>" class="WIDGETS_PORTAL_BODY_DIV">
	</div>
	<div id="widgetsPortalBodyCoverDiv" class="WIDGETS_PORTAL_BODY_COVER_DIV"></div>
	<div id="addGadgetHelpDiv" class="WIDGETS_PORTAL_EDIT_GADGET_HELP_DIV" style="visibility:hidden">
		<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white">
			<tr>
				<td class="WIDGETS_PORTAL_EDIT_GADGET_HELP_CELL">
					<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
						<tr height="10px">
							<td id="addGadgetHelpTitleTd" class="WIDGETS_PORTAL_EDIT_GADGET_HELP_TITLE_CELL"></td>
						</tr>
		 				<tr height="*">
		 					<td id="addGadgetHelpMessageTd" class="WIDGETS_PORTAL_EDIT_GADGET_HELP_MESSAGE_CELL"></td>
		 				</tr>
		 			</table>	
		 		</td>
		 	</tr>
		</table>	
	</div>
</body>
</html>