
<%@ page language="java"%>
<%@page import="xpolog.eye.site.ui.grid.GridTable"%>
<%@page import="xpolog.eye.site.ui.grid.models.AggCasesGridTableModel"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@page import="xpolog.eye.reports.agg.admin.AggReportBuilder"%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION, true)) {
		return;
	}

	UserContext userContext = UserEnvironment.getUserContext(request);
	
	 boolean isExecute = manager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.EXECUTE_REPORTS_PERMISSION);
	
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = "../../";
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	AggReportBuilder builder = (AggReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");
	
	AggCasesGridTableModel model = new AggCasesGridTableModel();
	model.setBaseDirectory(baseDirectory);
	model.setUserContext(userContext);
	model.setGridName("mygrid" + suffix);
	model.setBuilder(builder);	
	model.init();
	GridTable table = new GridTable(model);
	request.setAttribute("gridTable" + suffix,table);
	
	request.getRequestDispatcher(baseDirectory + "widgets/grid/jsp/initTableXML.jsp").forward(request, response);	
%>