<%@ page language="java"%>

<%@page import="xpolog.logic.reports.agg.admin.TranAggCaseBuilder"%>
<%@page import="xpolog.eye.reports.agg.admin.LogAggCaseBuilder"%>
<%@page import="xpolog.eye.site.ui.grid.models.FiltersListModel"%>
<%@page import="xpolog.eye.site.ui.grid.GridTable"%>
<%@page import="xpolog.eye.site.ui.grid.models.AggCasesGridTableModel"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@page import="xpolog.eye.reports.agg.admin.AggReportBuilder"%>

<%
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	AggReportBuilder builder = (AggReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");
	

	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = "../../";
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	String selectedType = request.getParameter("selectedType");
	if (selectedType == null){
		selectedType = "";
	}
	
	
	String allFilterName = request.getParameter("allFilterName");
	String allFilterId = request.getParameter("allFilterId");

	String [] selectedIds = (String [])request.getAttribute("selectedIds");
	if (selectedIds == null && builder != null && selectedType != null && selectedType.length() > 0){
		if (selectedType.equals(AggReportBuilder.LOG_CASE_TYPE) || selectedType.equals(AggReportBuilder.TRAN_CASE_TYPE)){
			ArrayList list = new ArrayList();			
			for (int i = 0;i <  builder.getCasesCount();i++){
				String [] filters = null;
				if (selectedType.equals(AggReportBuilder.LOG_CASE_TYPE)){
				  LogAggCaseBuilder caseBuilder = (LogAggCaseBuilder)builder.getCaseBuilderAt(i);
				  filters = caseBuilder.getDataFilters();
				}else if (selectedType.equals(AggReportBuilder.TRAN_CASE_TYPE)){
				  TranAggCaseBuilder caseBuilder = (TranAggCaseBuilder)builder.getCaseBuilderAt(i);
				  filters = caseBuilder.getDataFilters();
				}
				if (filters != null){
					for(int j = 0; j < filters.length;j++){
						if (filters[j].length() == 0 && allFilterId != null){
							filters[j] = allFilterId;
						}
						
						list.add(filters[j]);
					}					
				}else if (allFilterName != null && allFilterName.length() > 0){
					list.add(allFilterId);
				}
				
			}			
			selectedIds = (String [])list.toArray(new String[list.size()]);
		}else if (selectedType.equals("ReportTypeAdvanced")){			
			ArrayList list = new ArrayList();
			String [] filters = builder.getDataFilters();							
			if (filters != null){
				for(int j = 0; j < filters.length;j++){					
					list.add(filters[j]);
				}					
			}
			selectedIds = (String [])list.toArray(new String[list.size()]);
		}
		if (selectedIds == null){
			selectedIds = new String[0];
		}
	}
	
	

	FiltersListModel model = new FiltersListModel();
	if (builder != null){
	  model.setFilterManager(builder.getFilterManager());
	  model.setSelectedIds(selectedIds);
	  model.setAllFilterId(allFilterId);
	  model.setAllFilterName(allFilterName);	  
	}
	model.setTimeFilter(true);
	model.setBaseDirectory(baseDirectory);
	model.setUserContext(userContext);
	model.setGridName("mygrid" + suffix);	
	model.init();
	GridTable table = new GridTable(model);
	request.setAttribute("gridTable" + suffix,table);
	
	request.getRequestDispatcher(baseDirectory + "widgets/grid/jsp/initTableXML.jsp").forward(request, response);	
%>