<%@page import="xpolog.eye.data.aggregate.admin.LogAggregationConf"%>
<%@page import="xpolog.eye.data.aggregate.admin.SimilarityAggConf"%>
<%@page import="xpolog.eye.reports.agg.admin.LogSimilarityAggCaseBuilder"%>
<%@page import="xpolog.eye.reports.agg.admin.LogDimsAggCaseBuilder"%>
<%@page import="xpolog.eye.site.ui.grid.models.ColumnsListModel"%>
<%@page import="xpolog.eye.site.ui.grid.models.FiltersListModel"%>

<%@ page language="java"%>
<%@page import="xpolog.eye.site.ui.grid.GridTable"%>
<%@page import="xpolog.eye.site.ui.grid.models.AggCasesGridTableModel"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@page import="xpolog.eye.reports.agg.admin.AggReportBuilder"%>

<%
	UserContext userContext = UserEnvironment.getUserContext(request);

	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null) {
		baseDirectory = "../../";
	}

	String suffix = request.getParameter("suffix");
	if (suffix == null) {
		suffix = "";
	}

	String allColumnsName = request.getParameter("allColumnsName");
	String allColumnsId = request.getParameter("allColumnsId");

	AggReportBuilder builder = (AggReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");

	String[] selectedIndexes = (String[]) request.getAttribute("selectedIndexes");
	String selectedType = request.getParameter("selectedType");

	if (selectedIndexes == null && builder != null && selectedType != null && selectedType.length() > 0) {
		if (selectedType.equals(AggReportBuilder.LOG_DIMS_CASE_TYPE)) {
			
			ArrayList list = new ArrayList();
			for (int i = 0; i < builder.getDimsCount(); i++) {
				LogDimsAggCaseBuilder caseBuilder = (LogDimsAggCaseBuilder) builder.getDimsBuilderAt(i);
				int[] indexes = caseBuilder.getContentCols();
				
				if (indexes != null) {
					StringBuffer buffer = new StringBuffer();
					for (int j = 0; j < indexes.length; j++) {
						if (buffer.length() > 0) {
							buffer.append(",");
						}
						buffer.append(indexes[j]);
					}					
					list.add(buffer.toString());
				}
			}
			selectedIndexes = (String[]) list.toArray(new String[list.size()]);
		} else if (selectedType.equals(AggReportBuilder.LOG_SIMILARITY_CASE_TYPE)) {
			ArrayList list = new ArrayList();
			for (int i = 0; i < builder.getSimilarityCount(); i++) {
				LogSimilarityAggCaseBuilder caseBuilder = (LogSimilarityAggCaseBuilder) builder.getSimilarityBuilderAt(i);
				LogAggregationConf conf = (LogAggregationConf) caseBuilder.getAggConf();
				SimilarityAggConf similarityConf = conf == null ? null : conf.getSimilarityConf();
				if (similarityConf == null) {
					similarityConf = new SimilarityAggConf();
				}

				Integer[] columnsIndexes = similarityConf.getIncludeColumnsArr();
				if (columnsIndexes != null && columnsIndexes.length > 0) {					
					for (int j = 0; j < columnsIndexes.length; j++) {						
						list.add(String.valueOf(columnsIndexes[j].intValue()));
					}									
				}else if (allColumnsName != null && allColumnsName.length() > 0){					
					list.add(allColumnsId);									
				}else {					
					if (builder.getMask() != null){
						int count = builder.getMask().getCulomnsNumber();
						for(int j = 0; j < count;j++){
							list.add(String.valueOf(j));
						}
					}
				}								
			}
			if (builder.getSimilarityCount() == 0){
				if (builder.getMask() != null){
					int count = builder.getMask().getCulomnsNumber();
					for(int j = 0; j < count;j++){
						list.add(String.valueOf(j));
					}
				}
			}
			selectedIndexes = (String[]) list.toArray(new String[list.size()]);
		}

		if (selectedIndexes == null) {
			selectedIndexes = new String[0];
		}
	}

	ColumnsListModel model = new ColumnsListModel();
	if (builder != null) {
		model.setMask(builder.getMask());
		model.setSelectedIndexes(selectedIndexes);
		model.setAllColumnsId(allColumnsId);
		model.setAllColumnsName(allColumnsName);	 		
	}
	model.setBaseDirectory(baseDirectory);
	model.setUserContext(userContext);
	model.setGridName("mygrid" + suffix);
	model.init();
	GridTable table = new GridTable(model);
	request.setAttribute("gridTable" + suffix, table);

	request.getRequestDispatcher(baseDirectory + "widgets/grid/jsp/initTableXML.jsp").forward(request, response);
%>