<%@ page language="java"%>

<%@ page import="xpolog.eye.reports.agg.admin.*"%>

<%
	AggReportBuilder builder = (AggReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");
	if (builder == null) {
		return;
	}

	DefaultLogAggCaseBuilder caseBuilder = (DefaultLogAggCaseBuilder) builder.getCurrentCaseBuilder();

	String logId = "";
	String[] filtersIds = null;
	boolean isEdit = false;
	String maxResults = "";
	
	AggCaseDisplayRule displayRule = builder.getDisplayRule();
	if (displayRule != null){
		maxResults = displayRule.getResultsToDisplay() == -1 ? "" :  String.valueOf(displayRule.getResultsToDisplay());
	}
	

	String suffix = "ReportTypeAdvanced";
  
  String description = "Specify the filters to be applied on the log in order to narrow the report's data input.<br>Leave blank to use the whole log";
	
%>

			<table border="0" id="adminHeaderContent<%=suffix%>" cellpadding="0" cellspacing="0"
				width="100%" class="ADV_SETTINGS_TABLE" height="100%">				
				<tr height="18">
					<td style="padding-top:5">										
					
					<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
						
						<tr>
							<td  style="padding-left:20">
							<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
						
						<tr>
							<td>
							
									<jsp:include page="aggEditFiltersSelect.jsp" flush="true">
							<jsp:param name="baseDirectory" value="../../" />
							<jsp:param name="suffix" value="<%=suffix%>" />
							<jsp:param name="description" value="" />
							<jsp:param name="sourceHeader" value="<%=description%>" />
							<jsp:param name="targetHeader" value="<nobr>Selected filters</nobr>" />							
						</jsp:include>
						</td>
						</tr>
						</table>	
				</td>
				</tr>
				<tr height="35">
					<td style="padding-left:20;padding-top:0">										
					
					<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
						
						<tr>
							<td>
							  <table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
									<tr style="padding:5;padding-top:0">
							  		<td width=100>
							  			<nobr><span class="REGULARTEXT">Maximum number of results to be displayed in each report type:</span></nobr>
							  		</td>
										<td  style="padding-left:5">
											<input type="text" name="advancedMaxResults" class="TEXTBOX" size="6" value="<%=maxResults%>">
										</td>
									</tr>
								</table>
							</td>
						</tr>
			</table>
			</td>
		</tr>
	</table>
	</td>
</tr>
</table>
