<%@ page language="java"%>

<%@ page import="xpolog.eye.reports.agg.admin.*"%>

<%
	AggReportBuilder builder = (AggReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");
	if (builder == null) {
		return;
	}
	String type = request.getParameter("type");
	String id = request.getParameter("id");
	AggCaseBuilder caseBuilder = null;
	if (type != null && type.length() > 0 && id != null) {
		caseBuilder = builder.getReportTypeById(id);
	}

	String logId = "";
	if (caseBuilder != null && caseBuilder instanceof DefaultLogAggCaseBuilder) {
		DefaultLogAggCaseBuilder logCaseBuilder = (DefaultLogAggCaseBuilder) caseBuilder;
		caseBuilder.init();
		builder.setCurrentCaseBuilder(caseBuilder);
		logId = logCaseBuilder.getLogId();
	} else {
		builder.setCurrentCaseBuilder(null);
		type = "";
		logId = request.getParameter("logId");
		if (logId == null){
			logId = "";
		}
	}

	if (logId == null) {
		logId = "";
	}
	
	builder.setTempFunctionCaseBuilder(null);
	
%>


<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr height="40">
  <td>
  <jsp:include page="aggEditGeneralCase.jsp" flush="true"/>
      </td>
  </tr>
  <tr height="10"><td valign="top">
  <jsp:include page="../../common/selectLog.jsp" flush="true">
											<jsp:param name="baseDirectory" value="../" />
											<jsp:param name="baseDirectory2" value="../../" />
											<jsp:param name="LBM_ID" value="<%=logId%>" />
											<jsp:param name="ignoreHeader" value="true"/>
											<jsp:param name="noTree" value="true"/>
											<jsp:param name="mode" value="logs" />
											<jsp:param name="allowNewLog" value="true" />
											<jsp:param name="parameterName" value="Report on log:" />
											<jsp:param name="openLinkName" value="select log" />
											<jsp:param name="showReportsModule" value="true" />
											</jsp:include>
	</td></tr>
	<tr height="18">
		<td id="addCasesTypesDiv">
		  <%
		  	if (logId != null && logId.length() > 0) {
		  %>
		  <jsp:include page="aggEditCaseTypes.jsp" flush="true">
			<jsp:param name="baseDirectory" value="../../" />
			<jsp:param name="logId" value="<%=logId%>" />
			<jsp:param name="type" value="<%=type%>" />
		</jsp:include>
		  <%
		  	}
		  %>
		  
		</td>
	</tr>
  <tr height="*">
  <td >&nbsp;
  </td>
  </tr>
 
</table>
