<%@ page language="java"%>

<%@ page import="xpolog.eye.reports.agg.admin.*"%>

<%
  AggReportBuilder builder = (AggReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");
  if (builder == null) {
	  return;
  }
  
  AggCaseBuilder caseBuilder = (AggCaseBuilder)builder.getCurrentCaseBuilder();
  
  String logId = builder == null ? "" : builder.getDefaultLogId();
  String [] filtersIds = null;
  boolean isEdit = false;
  if (caseBuilder != null && caseBuilder instanceof LogAggCaseBuilder){
  	isEdit = true;
  	LogAggCaseBuilder logCaseBuilder = (LogAggCaseBuilder)caseBuilder;
  	logId = logCaseBuilder.getLogId();
  	if (logId == null){
  		logId = "";
  	}
  	filtersIds = logCaseBuilder.getDataFilters();
  	if (filtersIds == null || filtersIds.length == 0){
  		filtersIds = new String[]{""};
  	}  	
  	if (filtersIds != null){
    	request.setAttribute("filtersSel" + AggReportBuilder.LOG_CASE_TYPE,filtersIds);
    }
  }
  
  
  String suffix = AggReportBuilder.LOG_CASE_TYPE;
  String headerName = "Filters Summary";
  
  String description = "For each filter, summarize the number of filtered records over time.";
%>

			<table border="0" id="adminHeaderContent<%=suffix%>" cellpadding="0" cellspacing="0"  width="100%" height="100%" class="ADV_SETTINGS_TABLE">
					<tr>
						<td style="padding-left:20"><jsp:include page="aggEditFiltersSelect.jsp" flush="true">
							<jsp:param name="baseDirectory" value="../../" />
							<jsp:param name="suffix" value="<%=suffix%>" />
							<jsp:param name="description" value="<%=description %>" />
							<jsp:param name="sourceHeader" value="<nobr>Select the filters to summarize</nobr><br>&nbsp;" />
							<jsp:param name="targetHeader" value="<nobr>Selected filters</nobr>" />
							<jsp:param name="allFilterName" value="All log records" />
							<jsp:param name="allFilterValue" value="allRecords" />
						</jsp:include></td>
					</tr>
					<tr  id="FiltersErrorMsgTR" height="20">																													
							<td style="padding-left:20">
								 <div id="<%=AggReportBuilder.LOG_CASE_TYPE%>ErrorMsg" class="ERROR_MSG">
								 </div>
							</td>
					</tr>	
				</table>