<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.scheduler.ui.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="xpolog.eye.util.Constants"%>

<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!static final String BASE_DIRECTORY = "../../";	%>
<%
	String BUILDER = "CURRENT_LOG_BUILDER";
	String ERROR_OBJ = "ERROR_OBJ";

	AbstractReportBuilder builder = (AbstractReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");
	if (builder == null) {
		return;
	}
			
	int dataDis = AggReport.AUTOMATIC_DIS;
 	Report report = (Report)request.getAttribute("report");
	if (report != null) {
		dataDis = report.getDataDis();
	}
	
	int ruleType = builder == null ? 0 : builder.getStatusRuleType();
	
	String showMaintenanceSectionStr = request.getParameter("showMaintenanceSection");
	boolean showMaintenanceSection = showMaintenanceSectionStr != null && showMaintenanceSectionStr.equals("true");
	
	String resultsDeletionInterval = "";
	int resultsDeletionIntervalUnit = -1;
	if(showMaintenanceSection) {
		if(report != null) {
			resultsDeletionInterval = report.getResultsDeletionInterval();
			resultsDeletionIntervalUnit = report.getResultsDeletionIntervalUnit();
		}
	}
	
	String defaultReportsDeletionInterval = ReportsManager.getInstance().getReportsDeletionInterval();
	int defaultReportsDeletionIntervalUnit = ReportsManager.getInstance().getReportsDeletionIntervalUnit();
	String defaultReportsDeletionIntervalUnitStr = "";
	if(defaultReportsDeletionIntervalUnit == Constants.TimeUnits.INTERVAL_UNIT_DAY) {
		defaultReportsDeletionIntervalUnitStr = "days";
	}else if(defaultReportsDeletionIntervalUnit == Constants.TimeUnits.INTERVAL_UNIT_WEEK) {
		defaultReportsDeletionIntervalUnitStr = "weeks";
	}else if(defaultReportsDeletionIntervalUnit == Constants.TimeUnits.INTERVAL_UNIT_MONTH) {
		defaultReportsDeletionIntervalUnitStr = "months";
	}else if(defaultReportsDeletionIntervalUnit == Constants.TimeUnits.INTERVAL_UNIT_YEAR) {
		defaultReportsDeletionIntervalUnitStr = "years";
	}
	String defaultReportsDeletionStr = defaultReportsDeletionInterval + " " + defaultReportsDeletionIntervalUnitStr;

%>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>
		<td width="*" style="padding-left:10" valign="top">
			<table border="0" width="100%" cellspacing="0" cellpadding="0">
				<tr>
					<td><font size="1">&nbsp;</font></td>
				</tr>														
				<tr>
					<td height="18"><span class="SECTION_HEADER">Data Distribution</span></td>
				</tr>
				<tr>
					<td><input type="radio" value="0" id="none" name="dataDis" <%=dataDis == AggReport.NONE_DIS ? "checked" : ""%>> <span class="REGULARTEXT">None</span><br>
						<input type="radio" value="1" id="autoDis" name="dataDis" <%=dataDis == AggReport.AUTOMATIC_DIS ? "checked" : ""%>> <span class="REGULARTEXT">Automatic</span><br>
						<input type="radio" value="2" id="dailyDis" name="dataDis" <%=dataDis == AggReport.DAYS_DIS ? "checked" : ""%>> <span class="REGULARTEXT">Over days</span><br>
						<input type="radio" value="3" id="hourlyDis" name="dataDis" <%=dataDis == AggReport.HOURS_DIS ? "checked" : ""%>> <span class="REGULARTEXT">Over hours</span><br>
						<input type="radio" value="4" id="minutesDis" name="dataDis" <%=dataDis == AggReport.MINUTES_DIS ? "checked" : ""%>> <span class="REGULARTEXT">Over minutes</span><br>
					</td>
				</tr>
				<tr>
					<td>&nbsp;</td>
				</tr>
				<%if(showMaintenanceSection) { %>
				<tr>
          <td style="padding-top: 20px;">
          	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr>
              	<td>
                	<span class="HEADER">Maintenance</span>
               	</td>
							</tr>
						</table>
					</td>
        </tr>
        <tr>
         	<td style="padding-top: 5px;">
           	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr>
								<td class="REGULARTEXT" style="width:180px;padding-top: 5px;">Delete results older than:</td>
								<td>
									<input type="text" name="resultsDeletionInterval" size="5" value="<%=resultsDeletionInterval%>">
									<select id="resultsDeletionIntervalUnit" name="resultsDeletionIntervalUnit" size="1">
										<option value="<%=Constants.TimeUnits.INTERVAL_UNIT_DAY %>" <%=resultsDeletionIntervalUnit == Constants.TimeUnits.INTERVAL_UNIT_DAY ? "selected" : "" %>>Days</option>
										<option value="<%=Constants.TimeUnits.INTERVAL_UNIT_WEEK %>" <%=resultsDeletionIntervalUnit == Constants.TimeUnits.INTERVAL_UNIT_WEEK ? "selected" : "" %>>Weeks</option>
										<option value="<%=Constants.TimeUnits.INTERVAL_UNIT_MONTH %>" <%=resultsDeletionIntervalUnit == Constants.TimeUnits.INTERVAL_UNIT_MONTH ? "selected" : "" %>>Months</option>
										<option value="<%=Constants.TimeUnits.INTERVAL_UNIT_YEAR %>" <%=resultsDeletionIntervalUnit == Constants.TimeUnits.INTERVAL_UNIT_YEAR ? "selected" : "" %>>Years</option>
									</select>
								</td>
							</tr>
							<tr>
								<td colspan="2" class="SMALLTEXT" style="padding-top: 5px;">Leave blank to use default (<%=defaultReportsDeletionStr %>)</td>
							</tr>
						</table>
          </td>
				</tr>
				<%} %>
				<%if(builder.getReportType().equals(Report.ENVIRONMENT_ANALYSIS_LOG_GROUP_TYPE)) { %>
				<tr>
					<td height="18"><span class="SECTION_HEADER">User Input</span></td>
				</tr>
				<tr>
					<td>
						<input type="checkbox" id="needsUserInput" name="needsUserInput" value="true" <%if(report.isNeedsUserInput()) { %>checked<%} %>><span class="REGULARTEXT">Check to request user input when generating</span>
					</td>
				</tr>
				<%} %>
				<!-- 
				<tr>
					<td height="18"><span class="HEADER">Status</span></td>
				</tr>
				<tr>
					<td><span class="REGULARTEXT">&nbsp;Failure means that &nbsp; <select size="1" name="ruleType" id="ruleType">
								<option class="REGULARTEXT" value="0" <%=ruleType == 0? "selected" : ""%>>at least one case failed</option>
								<option class="REGULARTEXT" value="1" <%=ruleType == 1? "selected" : ""%>>all cases failed</option>
						</select> </span>
					</td>
				</tr>													
				 -->
			</table>												
		</td>
	</tr>
</table>

