<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@page import="xpolog.eye.meta.MetaData"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%@ include file="../../tools/sandf/dateFilterAction.jsp"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
  String ERROR_OBJ = "ERROR_OBJ";
  String REPORT_BUILDER = "REPORT_BUILDER";
  
  String doSaveStr = request.getParameter("doSave");  
  boolean doSave = doSaveStr != null && doSaveStr.equalsIgnoreCase("true");
  
  ErrorModel errmodel = new ErrorModel();
  
  AbstractReportBuilder abstractBuilder = (AbstractReportBuilder)  request.getSession().getAttribute("REPORT_BUILDER");
  if(!(abstractBuilder instanceof AggReportGroupBuilder)) {
  	errmodel.addError("Report is no longer valid, please click the 'Back to Reports' button and try again");
  }
  
  AggReportGroupBuilder builder = null;
  boolean doGenerate = false;
  String[] reportsIds = null;
  if(errmodel.getErrorCount() == 0) {
	  builder = (AggReportGroupBuilder)abstractBuilder;
	  if (builder == null){
	  	errmodel.addError("No Report in session.Please try to create report again.");
	  }
	  
	  String op = builder == null ? "" : builder.getOp();
	  doGenerate = op.equalsIgnoreCase("generate");
	  
	  String parentApplication =  request.getParameter("parentApplication");
	  if (parentApplication == null){
	  	parentApplication = "";
	  }
	  
	  AggBuilderHelper.updateBasicBuilderFromRequest(builder,request,errmodel,doGenerate);
	  
	  RecordMask mask = new RecordMask();
	  DateMask dateMask = new DateMask("MM/dd/yyyy HH:mm:ss");
	  MaskColumn[] cols = {dateMask};
	  mask.setColumns(cols);
	  FilterCollection fc = null;
	  //create the date and number filter
	  builder.setTimeRule(null);
	  try {
	  	DateFilter dfilter = createDateFilter(request,response,mask);
	  
	  	if(dfilter != null) {
	  		fc = new FilterCollection();
	  		fc.setName(builder.getName()+"_fc");
		  	fc.setId(System.currentTimeMillis()+"_fc");
		  	fc.addFilter(dfilter);
		  	builder.setTimeRule(fc);
	  	}
	  }catch(Exception e) {	  
		  errmodel.addError("Invalid time rule. Please make sure the time rule is valid and try again");	  
	  }
	  
		AggBuilderHelper.updateSchedBuilderFromRequest(builder,request,errmodel,doGenerate);
	  
	  //Report types
	  reportsIds = request.getParameterValues("To_Select_GroupReports");
	  try {
			builder.setReportIds(reportsIds == null ? null : Arrays.asList(reportsIds));  			  	
	  }catch (Exception e){
	  	ErrorModel.log.error("Failed to set group reports ids",e);
	  }
	  
	  if(reportsIds == null || reportsIds.length == 0) {
	  	errmodel.addError("At least one report must be selected");
	  }
	    
	  AggBuilderHelper.updateSecurityBuilderFromRequest(builder,request,errmodel,doGenerate);
  }
  
  //save reports issues
  if(errmodel.getErrorCount() != 0){
  	//errors
		String[] errors = errmodel.getErrors();
		StringBuffer sb = new StringBuffer();
		for (int i=0; i<errors.length; i++){
			if (sb.length() > 0){
				sb.append("*;*");
			}
			sb.append(errors[i]);
		}
		String message = sb.toString();
		//params
		String[] params = errmodel.getErrorParams();
		sb = new StringBuffer();
		for (int i=0; i<params.length; i++){
			if (sb.length() > 0){
				sb.append("*;*");
			}
			sb.append(params[i]);
		}
		String paramsList = sb.toString();
		String xml = GridModelActionsHelper.getResultXML(false, message, paramsList);
		
		response.setContentType("text/xml");
		response.setHeader("Pragma-Control", "no-cache");
		response.setHeader("Cache-Control", "no-cache");
		response.setHeader("Expires", "0");
		out.write(xml);
		out.flush();
  }else {
	  if (!doGenerate){
	     request.getSession().setAttribute(REPORT_BUILDER,builder);
	     if (doSave){
	    	 
	    	 String [] appIds = null;//parentApplication.split("\\#");    	 
	    	  if (reportsIds != null && reportsIds.length > 0){
	    	  	HashSet set = new HashSet();
	    	  	List list = new LinkedList();
	    	  	for (int i = 0 ;i < reportsIds.length;i++){
	    			  HashSet apps = SiteManagment.getInstance().getMetaDataMgr().getMetaDatasByXplgObject(XpoLogObjectTypes.REPORT_TYPE, reportsIds[i], true);
	      			if (apps != null){    				
	      				Iterator it = apps.iterator();
	      				MetaData md = null; 
	    	  			while (it.hasNext()){
	    		  			md = (MetaData)it.next();
	    			  		if (md != null && md.getId() != null && !set.contains(md.getId())){
	    				  		list.add(md.getId());
	    				  		set.add(md.getId());
	    					  }
	    				  }
	      			}
	    	  	}
	    			appIds = (String[])list.toArray(new String[list.size()]);    			    			 
	    		}
	    	  builder.setApplicationsIds(appIds);
	    	 
	    	 String saveAndGenerateStr = request.getParameter("saveAndGenerate");
	     	 boolean saveAndGenerate = saveAndGenerateStr != null && saveAndGenerateStr.equals("true");
	     	 if (saveAndGenerate){
	     		response.sendRedirect("aggReportSaveAction.jsp?doGenerate=true");
	     	 }else {
	  	     response.sendRedirect("aggReportSaveAction.jsp");
	     	 }
	     }else {
	       response.sendRedirect("aggCasesView.jsp");
	     }
	  }else {
	  	Report rep = builder.buildReport();
	  	request.getSession().setAttribute("report", rep);
	  	response.sendRedirect(BASE_DIRECTORY + "reports/reportRuntimeGenerate.jsp");
	  }
  }
%>
