<%@ page language="java"%>

<%@ page import="java.util.List"%>

<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisReportBuilder"%>

<%!
	static final String BASE_DIRECTORY = "../../";

%>

<%
	String baseDirectory = request.getParameter("baseDirectory");
	if(baseDirectory == null || baseDirectory.length() == 0) {
		baseDirectory = BASE_DIRECTORY;
	}
	
	String noLocationDivDisplay = "";
	String hasLocationDivDisplay = "";
	EnvironmentAnalysisReportBuilder builder = (EnvironmentAnalysisReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");
	List environmentAnalysisLocationInfos = builder == null ? null : builder.getEnvironmentAnalysisLocationInfos();
	if(environmentAnalysisLocationInfos == null || environmentAnalysisLocationInfos.size() == 0) {
		hasLocationDivDisplay = "display:none";
	}else {
		noLocationDivDisplay = "display:none";
	}

%>

<link rel="stylesheet" type="text/css" href="<%=baseDirectory%>css/logAdministration.css" />
<style type="text/css">
a.LOCATION_BUTTON:link {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
a.LOCATION_BUTTON:visited {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
a.LOCATION_BUTTON:active {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
a.LOCATION_BUTTON:hover {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
</style>

<script language="JavaScript" src="<%=baseDirectory%>scripts/filters/fromto.js"></script>
<script language="JavaScript" src="<%=baseDirectory%>scripts/common/admin.js"></script>
<script language="JavaScript" src="<%=baseDirectory%>scripts/reports/locations.js"></script>

<script>

	function addEnvironmentAnalysisLocation() {
		doEditEnvironmentAnalysisLocation();
	}
	
	function editEnvironmentAnalysisLocation() {
		var id = getFirstSelectedRow(mygridLocations);
		if (id == "") {
			var msgWriter = new messageWriter("mygridMessage","No Directory Selected","<%=baseDirectory%>");
	    msgWriter.setYParent(document.getElementById("mygridLocations"),50);
	    msgWriter.addAction("OK","javascript:hideLayer('mygridMessage')");
	    msgWriter.showMessage("<nobr>Please select a directory to edit</nobr>");
			return;
		}
		doEditEnvironmentAnalysisLocation(id);
	}
	
	function doEditEnvironmentAnalysisLocation(environmentAnalysisLocationId) {
		if(!environmentAnalysisLocationId) {
			environmentAnalysisLocationId = "";
		}
		var url = "aggReportEnvironmentAnalysisLocationDefinition.jsp?environmentAnalysisLocationId=" + environmentAnalysisLocationId;
		sendAjaxRequest(url,function(req){
			hideAllGeneralAdminDiv();
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result){
				alert("Could not get directory");
				return;			
			}
			showGeneralAdminDiv("Location");
			updateGeneralAdminDiv("Location",result);
		});
	}
	
	function deleteEnvironmentAnalysisLocation() {
		var id = getFirstSelectedRow(mygridLocations);
		if (id == "") {
			var msgWriter = new messageWriter("mygridMessage","No Directory Selected","<%=baseDirectory%>");
	    msgWriter.setYParent(document.getElementById("mygridLocations"),50);
	    msgWriter.addAction("OK","javascript:hideLayer('mygridMessage')");
	    msgWriter.showMessage("<nobr>Please select a directory to remove</nobr>");
			return;
		}
		doDeleteEnvironmentAnalysisLocation(id);
	}
	
	function doDeleteEnvironmentAnalysisLocation(environmentAnalysisLocationId) {
		deleteGridRow(mygridLocations, environmentAnalysisLocationId, "<%=BASE_DIRECTORY%>reports/agg/aggReportEnvironmentAnalysisLocationRemoveAction.jsp?environmentAnalysisLocationId=" + environmentAnalysisLocationId + "&timestamp=" + new Date().getTime());
		if(mygridLocations.getRowsNum() <= 1) {
			var noLocationDiv = document.getElementById("noLocationDiv");
	  	if(noLocationDiv) {
	  		noLocationDiv.style.display = "";
	  	}
	  	var hasLocationDiv = document.getElementById("hasLocationDiv");
	  	if(hasLocationDiv) {
	  		hasLocationDiv.style.display = "none";
	  	}
		}
	}
	
	var ENVIRONMENT_ANALYSIS_LOCATION_PREFIX = "environmentAnalysisLocation";
	function saveEnvironmentAnalysisLocation() {
		var isOk = true;
		var locationType = document.getElementById(ENVIRONMENT_ANALYSIS_LOCATION_PREFIX + "locationType");
		if(locationType.value == "" || locationType.value == "none"){
			var errorMessage = "Logs directory was not selected";
			showFormError(ENVIRONMENT_ANALYSIS_LOCATION_PREFIX + "locationType", ENVIRONMENT_ANALYSIS_LOCATION_PREFIX + "locationTypeErrorMsg", errorMessage);
			isOk = false;
		}else if(locationType.value == "auth" || locationType.value == "ssh") {
			var accountsList = document.getElementById(ENVIRONMENT_ANALYSIS_LOCATION_PREFIX + "AccountsList");
			if(accountsList.value == "" || accountsList.value == "none"){
				showFormError(ENVIRONMENT_ANALYSIS_LOCATION_PREFIX + "AccountsList", ENVIRONMENT_ANALYSIS_LOCATION_PREFIX + "AccountIdErrorMsg", "Account was not selected");
				isOk = false;
			}
			var locationPath = document.getElementById(ENVIRONMENT_ANALYSIS_LOCATION_PREFIX + "fullPath_0");
			if(locationPath.value == "") {
				var errorMessage = "Logs directory was not specified";
				showFormError(ENVIRONMENT_ANALYSIS_LOCATION_PREFIX + "fullPath_0", ENVIRONMENT_ANALYSIS_LOCATION_PREFIX + "Location0ErrorMsg", errorMessage);
				isOk = false;
			}
		}else {
			var locationPath = document.getElementById(ENVIRONMENT_ANALYSIS_LOCATION_PREFIX + "fullPath_0");
			if(locationPath.value == "") {
				var errorMessage = "Logs directory was not specified";
				showFormError(ENVIRONMENT_ANALYSIS_LOCATION_PREFIX + "fullPath_0", ENVIRONMENT_ANALYSIS_LOCATION_PREFIX + "Location0ErrorMsg", errorMessage);
				isOk = false;
			}
		}
		if(isOk) {
			var params = getFormElementsQueryString(document.access);
			var url = "aggReportEnvironmentAnalysisLocationDefinitionAction.jsp";
			sendAjaxRequest(url,function(req){
				var result = req.responseText;
				if (result){	
					result = result.replace(/^\s+|\s+$/g, '');
				}
				var resultStrs = result.split("#");
				if (resultStrs.length > 1 && resultStrs[0] == "error"){
			    var msgWriter = new messageWriter("mygridMessage","Save Directory Error","<%=baseDirectory%>");
			    msgWriter.setYParent(document.getElementById("mygridLocations"),50);
			    msgWriter.addAction("OK","javascript:hideLayer('mygridMessage')");
			    msgWriter.showMessage("An error occured while saving environment analysis directory, please try again");
					return;
				}else{
					var url = "<%=BASE_DIRECTORY%>reports/agg/aggReportEnvironmentAnalysisLocationsXML.jsp?dataOnly=true";
			  	mygridLocations.clearAll();
			  	mygridLocations.loadXML(url);
			  	hideGeneralAdminDiv("Location");
			  	
			  	var noLocationDiv = document.getElementById("noLocationDiv");
			  	if(noLocationDiv) {
			  		noLocationDiv.style.display = "none";
			  	}
			  	var hasLocationDiv = document.getElementById("hasLocationDiv");
			  	if(hasLocationDiv) {
			  		hasLocationDiv.style.display = "";
			  	}
				}				
			},'POST',params);
		}
	}

</script>

<jsp:include page="../../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
	<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
</jsp:include>
<jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
	<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
	<jsp:param name="initXML" value="reports/agg/aggReportEnvironmentAnalysisLocationsXML.jsp" />
	<jsp:param name="suffix" value="Locations" />
	<jsp:param name="scriptsOnly" value="true"/>
	<jsp:param name="recordsText" value="Directories" />
	<jsp:param name="doubleClickAction" value="editEnvironmentAnalysisLocation" />
</jsp:include>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr height="10">
		<td>
			<div id="noLocationDiv" style="<%=noLocationDivDisplay %>">
    	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
				<tr height="20">
					<td>&nbsp;</td>
				</tr>
				<tr valign="top">
					<td>
						<span class="REGULARTEXT" style="color:#9E5B04">* No logs directories are specified. </span><a class="LINK" href="javascript:addEnvironmentAnalysisLocation()">Add a new logs directory</a>
					</td>
				</tr>
			</table>
	    </div>
			<div id="hasLocationDiv" style="<%=hasLocationDivDisplay %>">
			<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
				<tr height="10">
					<td>
			    	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr>
								<td>
									<jsp:include page="../../common/ctrlButton.jsp" flush="true">
									<jsp:param name="base_directory" value="<%=baseDirectory%>"/>
									<jsp:param name="name" value="New Directory"/>
									<jsp:param name="action" value="javascript:addEnvironmentAnalysisLocation()"/> 
									<jsp:param name="buttonClass" value="LOCATION_BUTTON"/>
									</jsp:include>			
								</td>
								<td width="100%">
								<table border="0" width="100%" cellspacing="0" cellpadding="0">
									<tr>
										<td align="right">
											<a href="javascript:editEnvironmentAnalysisLocation()" class="BUTTON_MEDIUMLINK">edit</a>
											<a href="javascript:deleteEnvironmentAnalysisLocation()" class="BUTTON_MEDIUMLINK">remove</a>
										</td>
									</tr>
								</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr height="10">
					<td id="locationsTD" width="80%" valign="top">
					<jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
						<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
						<jsp:param name="initXML" value="reports/agg/aggReportEnvironmentAnalysisLocationsXML.jsp" />
						<jsp:param name="suffix" value="Locations" />
						<jsp:param name="noScripts" value="true" />
						<jsp:param name="recordsText" value="Directories" />
					</jsp:include>
					</td>
				</tr>
			</table>
			</div>
		</td>
	<tr>
		<td>&nbsp;</td>
	</tr>
</table>