<%@ page language="java"%>

<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisReportBuilder"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.ui.grid.GridTable"%>
<%@ page import="xpolog.eye.site.ui.grid.models.EnvironmentAnalysisLocationInfosGridTableModel"%>
<%@ page import="xpolog.eye.site.*"%>

<%
	EnvironmentAnalysisReportBuilder builder = (EnvironmentAnalysisReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");
	
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, null, true)) {
		return;
	}

	UserContext userContext = UserEnvironment.getUserContext(request);
	
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = "../../";
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	EnvironmentAnalysisLocationInfosGridTableModel model = new EnvironmentAnalysisLocationInfosGridTableModel();
	model.setEnvironmentAnalysisReportBuilder(builder);
	model.setBaseDirectory(baseDirectory);
	model.setUserContext(userContext);
	model.setGridName("mygrid" + suffix);
	model.init();
	GridTable table = new GridTable(model);
	request.setAttribute("gridTable" + suffix,table);
	
	request.getRequestDispatcher(baseDirectory + "widgets/grid/jsp/initTableXML.jsp").forward(request, response);	
%>