<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.awt.*"%>
<%@page import="java.util.List"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.AggReportCompare"%>
<%@ page import="xpolog.eye.reports.agg.result.*"%>
<%@ page import="xpolog.eye.reports.agg.result.view.*"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisAggReportRuntime"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisProperty"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisPropertyOption"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisReport"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.audit.*"%>
<%@ page import="xpolog.eye.util.WebUtil"%>
<%@ page import="xpolog.eye.data.util.functions.formats.*"%>
<%@ page import="xpolog.eye.data.util.similarity.strings.StringsSimilarityComputation"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>
<%@ page import="xpolog.eye.issuetracking.IssueTrackingManager"%>
<%@ page import="xpolog.eye.issuetracking.IssueTracking"%>

<%!static final String BASE_DIRECTORY = "../../";
	static final int MAX_NAME_CHAR = 100;
	DecimalFormat decFormat = new DecimalFormat("##.##");
	String dateFormatStr = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
	SimpleDateFormat dateFormat = new SimpleDateFormat(dateFormatStr);
	%>
<%

			String isProgressStr = request.getParameter("isProgress");
			boolean isProgress = isProgressStr != null && isProgressStr.equals("true");
			UserEnvironment env = UserEnvironment.getUserEnvironment(request);
			ReportRuntime repRuntime = (ReportRuntime)env.getTempAttribute("TEMP_REPORT_RUNTIME");
			AggReportViewer viewer = (AggReportViewer)env.getTempAttribute("TEMP_AGG_REPORT_VIEWER");
			AggReportGroupRuntime groupRuntime = (AggReportGroupRuntime)env.getTempAttribute("TEMP_REPORT_GROUP_RUNTIME");
			
			String ERROR_OBJ = "ERROR_OBJ";
			ErrorModel errmodel = new ErrorModel();
			UserContext userContext = UserEnvironment.getUserContext(request);
			String reportId = request.getParameter("reportId");
			String reportRuntimeId = request.getParameter("reportRuntimeId");
			String viewerId = request.getParameter("viewerId");
			String print = request.getParameter("print");
			boolean isPrint = print != null && print.equalsIgnoreCase("true");
			String mail = request.getParameter("mail");
			boolean isMail = mail != null && mail.equalsIgnoreCase("true");
			String refreshMenusStr = request.getParameter("refreshMenus");
			boolean refreshMenus = refreshMenusStr != null && refreshMenusStr.equals("true");
			String executableStr = request.getParameter("executable");
			boolean executable = executableStr != null && executableStr.equals("true");
			
			ReportsManager reportMgr = ReportsManager.getInstance();
			Report report = reportMgr.getReportById(reportId, true);
			if (reportId != null && !reportId.equals("AggregationCompare")){
			  request.getSession().setAttribute("lastSelectedReport",reportId);
			}

			if (reportId == null || reportId.trim().equals("")) {
				errmodel.addError("No Report id was supplied.");
			}
			if (reportRuntimeId == null || reportRuntimeId.trim().equals("")) {
				errmodel.addError("No Report runtime id was supplied.");
			}

			if (errmodel.getErrorCount() != 0) {
				request.getSession().setAttribute(ERROR_OBJ, errmodel);
				response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=applications/delek/reports/reportsDefinitionView.jsp");
				return;
			}
			
			boolean isSiteDemo = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("isSiteDemo",false);
			
			String reportName = report.getReportName();
			
			AggReportRuntime runtime = null;
			if(!isProgress || repRuntime == null) {
				repRuntime  = report.getReportRuntimeById(reportRuntimeId);			
				if (repRuntime instanceof AggReportGroupRuntime){
					groupRuntime = (AggReportGroupRuntime)repRuntime;
					runtime = groupRuntime.getAggRuntime();				
				}else {
					runtime = (AggReportRuntime)repRuntime;
				}
			}else {
				runtime = (AggReportRuntime)repRuntime;
			}
			AggSubReportRuntime casesRuntime =  runtime.getAggSubReportRuntime ();
			String piePath = null;
			String lineChartPath = null;
			Color [] pieColors = null;
			Color [] colors = null;
			boolean showGraphs = true;
			try {
			Color [] colors0 = {Color.decode("#A7FF9B"),Color.decode("#AABBFF"),
					Color.decode("#FEFE9E"),Color.decode("#FC9EB9"),Color.decode("#E5F3FE"),Color.decode("#FAD996"),
					Color.decode("#808080"),Color.decode("#FE0000"),Color.decode("#FEFE00"),Color.decode("#EC7A70")};
		
			Color [] pieColors0 = {Color.decode("#A7FF9B"),Color.decode("#AABBFF"),Color.decode("#FEFE9E"),Color.decode("#FC9EB9"),Color.decode("#E5F3FE"),Color.decode("#EC7A70")};
			 
			 pieColors = pieColors0;
			 colors = colors0;
			 piePath = BASE_DIRECTORY + AggReportHelper.genCasesPie(runtime,casesRuntime,Color.decode("#FFFFFF"),pieColors,250,200);			
			lineChartPath = BASE_DIRECTORY + AggReportHelper.genCasesLineGraph(runtime,casesRuntime,Color.decode("#FFFFFF"),pieColors,450,200);
			}catch (Throwable e){
				showGraphs = false;
			}
      boolean moreThenTenCases = casesRuntime != null && casesRuntime.getCasesList() != null && casesRuntime.getCasesList().size() > 10 ;
			String title = moreThenTenCases ? "Distribution Over time (Top 10)" : "Distribution Over time";
			String title2 = moreThenTenCases ? "Summary (Top 10)" : "Summary";
			String timeStr = "";
			if(runtime.getStartTime() <= 0 && runtime.getEndTime() <= 0) {
				timeStr = "Generated on " + dateFormat.format(new Date(runtime.getRunningTime()));
			}else if(runtime.getEndTime() <= 0) {
				timeStr = "From " + dateFormat.format(new Date(runtime.getStartTime()));
			}else if(runtime.getStartTime() <= 0) {
				timeStr = "To " + dateFormat.format(new Date(runtime.getEndTime()));
			}else {
				timeStr = dateFormat.format(new Date(runtime.getStartTime())) + " - " + dateFormat.format(new Date(runtime.getEndTime()));
			}
			
			String url = SiteUtil.getApplicationRoot(request, true, true);
			url += "componentAction.jsp?selectedCompId=XpoLog&forward=root.jsp?mainPage=reports/agg/aggReport.jsp%253F";
			Enumeration e = request.getParameterNames();
			String key, value;
			StringBuffer buffer = new StringBuffer();
			while(e.hasMoreElements()) {
				key = (String)e.nextElement();
				value = request.getParameter(key);
				if(value == null) {
					value = "";
				}
				
				buffer.append("&");
				buffer.append(key);
				buffer.append("=");
				buffer.append(value);
			}
			String queryString = buffer.toString();
			int index = queryString.indexOf("print=true");
			if(index != -1) {
				queryString = XpologUtil.replaceAll(queryString, "print=true", "print=false");
			}
			queryString = XpologUtil.replaceAll(queryString, "&", "%26");
			queryString = XpologUtil.replaceAll(queryString, "%", "%25");
			url += queryString;
			String compareStr = "";
			if(repRuntime instanceof AggReportCompareRuntime ||
				 (repRuntime.getSourceReport() != null && repRuntime.getSourceReport() instanceof AggReportCompare)) {
				AggReportCompareRuntime compareRuntime = null;
				if(repRuntime instanceof AggReportCompareRuntime) {
					compareRuntime = (AggReportCompareRuntime)repRuntime;
				}else {
					compareRuntime = (AggReportCompareRuntime)repRuntime.getSourceReport().getReportRuntimeById(reportRuntimeId);
				}
				if(compareRuntime != null) {
					ReportRuntime[] runtimes = compareRuntime.getRuntimesObjects();
					ReportRuntime tmp = null;
					if(runtimes != null && runtimes.length > 0) {
						String runtimeId = null;
						boolean flag = false;
						for(int i = 0; i < runtimes.length; i++) {
							tmp = runtimes[i];
							
							String tmpStr = "";
							if(tmp.getStartTime() <= 0 && tmp.getEndTime() <= 0) {
								tmpStr = "Generated on " + dateFormat.format(new Date(tmp.getRunningTime()));
							}else if(tmp.getEndTime() <= 0) {
								tmpStr = "From " + dateFormat.format(new Date(tmp.getStartTime()));
							}else if(tmp.getStartTime() <= 0) {
								tmpStr = "To " + dateFormat.format(new Date(tmp.getEndTime()));
							}else {
								tmpStr = dateFormat.format(new Date(tmp.getStartTime())) + " - " + dateFormat.format(new Date(tmp.getEndTime()));
							}
							
							if(compareStr.length() > 0) {
								if(!flag) {
									flag = true;
									compareStr += " with ";
								}else {
									compareStr += ", ";
								}
							}
							compareStr += tmpStr;
						}
					}
				}
			}
			if(!isProgress || viewer == null) {
			  viewer = new AggReportViewer();
			  viewer.setReport(report);
			  viewer.setReportRuntime(runtime);
			  viewer.setBaseDirectory(BASE_DIRECTORY);
			  viewer.setUserContext(userContext);
			  viewer.init();
			}
		  String isEnvironmentAnalysisStr = request.getParameter("isEnvironmentAnalysis");
		  boolean isEnvironmentAnalysis = isEnvironmentAnalysisStr != null && isEnvironmentAnalysisStr.equals("true");
		  isEnvironmentAnalysis = isEnvironmentAnalysis || (report != null && report instanceof EnvironmentAnalysisReport);
		  boolean isTestingBuid = SiteManagment.getInstance().isTestingBuild();
		  
		  StringBuffer environmentAnalysisPropertiesBuffer = new StringBuffer();
		  if(isEnvironmentAnalysis && (groupRuntime instanceof EnvironmentAnalysisAggReportRuntime)) {
		  	List environmentAnalysisProperties = ((EnvironmentAnalysisAggReportRuntime)groupRuntime).getEnvironmentAnalysisProperties();
				if(environmentAnalysisProperties != null && environmentAnalysisProperties.size() > 0) {
					EnvironmentAnalysisProperty environmentAnalysisProperty = null;
					int count = 0;
					String text = null;
					for(int i = 0; i < environmentAnalysisProperties.size(); i++) {
						environmentAnalysisProperty = (EnvironmentAnalysisProperty)environmentAnalysisProperties.get(i);
						if(environmentAnalysisProperty.getType() != null) {
							if(environmentAnalysisProperty.getType().equals(EnvironmentAnalysisProperty.TYPE_TEXT)) {
								text = environmentAnalysisProperty.getValue();
							}else if(environmentAnalysisProperty.getType().equals(EnvironmentAnalysisProperty.TYPE_SELECT)) {
								text = environmentAnalysisProperty.getValue();
								java.util.List environmentAnalysisPropertyOptions = environmentAnalysisProperty.getEnvironmentAnalysisPropertyOptions();
								if(environmentAnalysisPropertyOptions != null && environmentAnalysisPropertyOptions.size() > 0) {
									EnvironmentAnalysisPropertyOption environmentAnalysisPropertyOption  = null;
									for(int j = 0; j < environmentAnalysisPropertyOptions.size(); j++) {
										environmentAnalysisPropertyOption = (EnvironmentAnalysisPropertyOption)environmentAnalysisPropertyOptions.get(j);
										if(text.equals(environmentAnalysisPropertyOption.getId())) {
											if(text.equals("noValue")) {
												text = null;
											}else {
												text = environmentAnalysisPropertyOption.getText();
											}
											break;
										}
									}
								}
							}else {
								text = null;
							}
						}
						if(text != null && text.length() > 0) {
							if(count++ > 0) {
								environmentAnalysisPropertiesBuffer.append(",&nbsp;");
							}
							environmentAnalysisPropertiesBuffer.append(environmentAnalysisProperty.getName());
							environmentAnalysisPropertiesBuffer.append(":&nbsp;");
							environmentAnalysisPropertiesBuffer.append(text);
						}
					}
				}
		  }
		  String typeText = "report";
			if(isEnvironmentAnalysis) {
				if(isTestingBuid) {
					typeText = "environment analysis";
				}else {
					typeText = "testing analysis";
				}
			}
			
			boolean isPermittedOpenIssue = WebSecurityManager.getInstance().isHavePermission(userContext,ActionsPermissionConstants.IssueTraqckingPermissions.OPEN_ISSUE_PERMISSION);
		  IssueTrackingManager mgr = IssueTrackingManager.getInstance();
			IssueTracking [] tracking = mgr.getIssueTrackingList();
			boolean showOepnABug = true;
			if((tracking == null || tracking.length == 0) && !WebSecurityManager.getInstance().isHavePermission(userContext,ActionsPermissionConstants.IssueTraqckingPermissions.ISSUE_TRACKING_SETTINGS_PERMISSION)) {
				showOepnABug = false;
			}
			if (ReportsManager.getInstance().USE_UTF8){
				response.setContentType("text/html; charset=UTF-8");
			}
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainview.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/logview.css" />

<% if (isPrint){ %>
<%if(!isMail) { %>
<title>Print result of <%=typeText %> <%=report.getReportName()%></title>
<%} %>
<style>
/*Describes the properties of regular size text, such as sub headers*/
.REGULARTEXT
{
	font-family: verdana;
	font-size: 12;
	color: black
}

/*Describes the properties of comment texts and examples*/
.SMALLTEXT 
{
	font-family: verdana;
	font-size: 10;
	color: black
}

.REPORT_TABLE_TEXT
{
	font-family: Tahoma;
	font-size: 10pt;
	color: black;
}

.PATH_SEP{
	color: #FF9126;
	font-family: verdana;
	font-size: 10;
	font-weight: bold;
}

.REPORT_TABLE_HEADER
{
	font-family: verdana;
	font-size: 10;
	color: #6A78DB;
	font-weight: bold;
}
.REPORT_TABLE_SUB_HEADER
{
	font-family: verdana;
	font-size: 10;
	color: #0018C7;
	font-weight: bold;
}

.TOP_VIEW_TD
{	
	font-size: 7pt;
	font-weight: normal;
	font-family: verdana, helvetica;
	color:#FFFFFF;
	background:#000000;
}

.TOP_SECTION_TEXT{
  font-family: tahoma;
	font-size:11px;
	color:#b9c7f7;	
}

/*Describes the font family,size and the weight of small links*/
.SMALLLINK
{
	font-family: verdana;
	font-size: 10;
	font-weight: bold;
	text-decoration: none;
}
</style>
<%}%>

<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>

<% if (!isPrint){ %>
<jsp:include page="../../widgets/tabs/jsp/tabsHeaderIncluder.jsp" flush="true">
  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
  <jsp:param name="style" value="winXPLG" />
</jsp:include>
<jsp:include page="../../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<%} %>
<!-- Date only with year scrolling -->
<script>
	function exportExcel(caseType, caseId){		
		var url = "logCaseExportAction.jsp?reportId=<%=reportId%>&reportRuntimeId=<%=reportRuntimeId%>&caseType="+caseType+"&caseIndex="+caseId;
		sendAjaxRequest(url,function(req){
      var xmlDoc = req.responseXML.documentElement;
				var aggCaseExportElement = xmlDoc.getElementsByTagName("aggCaseExport")[0];
				if (aggCaseExportElement){
					var fileName = aggCaseExportElement.getAttribute("exportFile");
					var f = "<%=BASE_DIRECTORY%>temp/reports/export/" + fileName;
					document.downloadFile.action = f;
					document.downloadFile.submit();
				}      
    });
	}
	
	function openPrintPage(){
	 var docprint=window.open("aggReport.jsp?reportId=<%=reportId%>&reportRuntimeId=<%=reportRuntimeId%>&print=true","","toolbar=yes,location=no,resizable=yes,directories=yes,menubar=yes,scrollbars=yes,width=850, height=600,left=100, top=25");
	 docprint.focus(); 
	}
	
	function openBug(){
	  var params = "REPORT_ID=<%=reportId%>&REPORT_RUNTIME_ID=<%=reportRuntimeId%>&ISSUE_TRACKING_ID=NEW";
	  if (parent && parent.openGeneralDiv){
	    parent.openGeneralDiv('reports/addIssueWithReportAction.jsp',params,"Add a Bug", "Loading information...");
	  }
	}
	
</script>
</head>

<%if(!isPrint && refreshMenus && SiteManagment.getInstance().isSaveModuleMembers()) { %>
<script>
refreshMenus();
</script>
<%} %>
<body onLoad="<%=!isPrint? "initTabs();initTables()" : ""%>" onUnload="<%=!isPrint? "destroyTables()" : ""%>" style="padding:0;margin:0;<%=isPrint ? "" : "overflow:hidden" %>">
<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%"
	cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
	<tr>
		<td width="100%" height="100%" valign="top">
		<table border="0" width="100%" cellspacing="0" height="100%"
			cellpadding="0">
			<tr height="10">
			<td>
			<table width="100%" height="100%" cellspacing="0" cellpadding="0" border="0">
<tr>
<td height="25" width="10" class="TOP_VIEW_TD" style="padding-left:12;font-size:10pt;font-weight:bold">
<nobr><%=report.getReportName()%></nobr>
</td>
<td height="25" class="TOP_VIEW_TD" style="padding-left:20">
<%if(reportId.equals("AggregationCompare")) { %>
<span id="topDiv"><%=compareStr %></span>
<%}else { %>
<span id="topDiv"><nobr><%=timeStr%></nobr></span>
<%} %>
</td>
<%if (!isPrint){ %>
<% if (SiteManagment.getInstance().isTestingBuild() && isPermittedOpenIssue && showOepnABug){ %>
<td width="80" class="TOP_VIEW_TD" style="padding-right:10"><a href="javascript:openBug()" class="BUTTON_MEDIUMLINK" style="color:white" >Open a bug</a></td>
<%} %>
<td width="30" class="TOP_VIEW_TD" style="padding-right:10"><a href="javascript:openPrintPage()" class="BUTTON_MEDIUMLINK" style="color:white" >Print</a></td>
<% if (isSiteDemo || reportId.equals("AggregationCompare") || isEnvironmentAnalysis){ %>
<td width="30" class="TOP_VIEW_TD" style="padding-right:10"><a href="../reportsDefinitionView.jsp?isEnvironmentAnalysis=<%=isEnvironmentAnalysis %>" class="BUTTON_MEDIUMLINK" style="color:white">Close</a></td>
<%} else { %>
<td width="30" class="TOP_VIEW_TD" style="padding-right:10"><a href="../reportView.jsp?reportId=<%=reportId%>&executable=<%=executable %>" class="BUTTON_MEDIUMLINK" style="color:white">Close</a></td>
<%} %>
<%} %>
</tr>
<%if(isEnvironmentAnalysis && (groupRuntime instanceof EnvironmentAnalysisAggReportRuntime) && environmentAnalysisPropertiesBuffer.length() > 0) { %>
<tr>
<td colspan="4" class="TOP_VIEW_TD" style="padding-left:12;padding-top:5;padding-bottom:10">
	<div id="environmentAnalysisPropertiesDiv">
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
		<tr>
			<td class="TOP_VIEW_TD" style="padding-left:10">
			<%=environmentAnalysisPropertiesBuffer.toString() %>
			</td>
		</tr>
	</table>
	</div>
</td>
</tr>
<%} %>
</table>
			</td>
			</tr>
			<tr>
				<td valign="top" >
				<table border="0" cellpadding="0" cellspacing="0"
					style="border-collapse: collapse" width="100%" height="100%">
					
							
							<tr>								
								<td  colspan="2" height="100%">
								<%if (isPrint){
										if(viewer.getReportResultsCount() == 0) {
								%>
										<table border="0" width="100%" cellpadding="0" cellspacing="0" height="100%">
											<tr height="10">
												<td style="padding-top:10;padding-left:10"><span class="REGULARTEXT" style="color:#9E5B04">* No results were generated </span></td>
											</tr>
											<tr><td>&nbsp;</td></tr>
										</table>
								<%
										}else {
								%>
										<table border="0" width="100%" cellpadding="0" cellspacing="0" height="100%">
								<%
											if(isMail) {
								%>
											<tr height="10">
												<td style="padding-top:10;padding-left:5">
												<span class="REGULARTEXT">Please find below a summary of the <%=typeText %>, to view to the complete <%=typeText %> in XpoLog </span><a href="<%=url %>" class="SMALLLINK">click here</a>
												</td>
											</tr>
								<%
											}
								  		for (int i = 0; i < viewer.getReportResultsCount();i++){
								  		request.setAttribute("currentResult",viewer.getReportResultAt(i));
								%>
																  
								   	<tr height="10"><td style="padding-top:10">
								   
								   	<jsp:include page="aggReportTypeView.jsp" flush="true" >
												<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
												<jsp:param name="isPrint" value="<%=String.valueOf(isPrint)%>" />
												<jsp:param name="isMail" value="<%=String.valueOf(isMail)%>" />
									 	</jsp:include>
								   
								   
								   	</td></tr>
								<%		}
										}
								%>
								<tr><td>&nbsp;</td></tr>
								</table>
								
								<%}else {
									if(viewer.getReportResultsCount() == 0) {
								%>
								<table border="0" width="100%" cellpadding="0" cellspacing="0" height="100%">
									<tr height="10">
										<td style="padding-top:10;padding-left:10"><span class="REGULARTEXT" style="color:#9E5B04">* No results were generated </span></td>
									</tr>
									<tr><td>&nbsp;</td></tr>
								</table>
								<%
									}else {
										for (int i = 0; i < viewer.getReportResultsCount();i++){
											AggCaseResultViewer resultViewer = viewer.getReportResultAt(i);										
											request.setAttribute("currentResult",resultViewer);
											String id = resultViewer.getId();
								%>
										<div id="tabDiv<%=id%>"  style="display:none;height:100%;width:100%;overflow:auto" >
											<table border="0" width="100%" cellpadding="0" cellspacing="0" height="100%">
											 <tr><td >
								   
								   			<jsp:include page="aggReportTypeView.jsp" flush="true" >
														<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
														<jsp:param name="isPrint" value="<%=String.valueOf(isPrint)%>" />
														<jsp:param name="isMail" value="<%=String.valueOf(isMail)%>" />
									 			</jsp:include>
								   
								   
								   			</td></tr>
											</table>
										</div>
								<%	}
									}
								String [] ids = new String[viewer.getReportResultsCount()];
								String [] names = new String[viewer.getReportResultsCount()];
								String activeIndexStr = "";
								int activeIndex = -1;
								for (int i = 0; i < viewer.getReportResultsCount();i++){
									AggCaseResultViewer resultViewer = viewer.getReportResultAt(i);
									ids[i] = "tabDiv" + resultViewer.getId();
									names[i] = resultViewer.getName();
									
									if(viewerId != null && viewerId.length() > 0 && viewerId.equals(resultViewer.getId())) {
										activeIndex = i;
									}
								}
								if(activeIndex != -1) {
									activeIndexStr = String.valueOf(activeIndex + 1);
								}
								request.setAttribute("tabIds",ids);
								request.setAttribute("tabNames",names);
								%>
								<jsp:include page="../../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
  														<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
  														<jsp:param name="style" value="winXPLG" />
  														<jsp:param name="offset" value="6" />
  														<jsp:param name="activeIndex" value="<%=activeIndexStr %>" />
													</jsp:include>
								<%} %>
								<div id="tabbarDiv" style="width:0;height:0;background:#000000;" ></div>
								</td>
							</tr>
							
							
							
							
														
				</table>
				</td>
			</tr>
			
		
</table>
</td>
			</tr>
		
</table>
</form>
<form name="downloadFile" target="exportFrame">
  <input type="hidden" name="redirectUrl">
  <input type="hidden" name="closeWindow" value="true">
  <input type="hidden" name="closeWindowOnLoad" value="true">
</form>
<iframe id="exportFrame" name="exportFrame" src="<%=BASE_DIRECTORY%>empty.html" style="position:absolute;left:100;top:100;height:200px;width:520px;display:none;z-index:100"></iframe>
</body>

</html>