<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.reports.agg.result.view.*"%>
<%@page import="xpolog.eye.site.ui.grid.GridTable"%>
<%@page import="xpolog.eye.reports.agg.admin.AggReportConstants"%>
<%@page import="xpolog.eye.site.SiteUtil"%>
<%!static final String BASE_DIRECTORY = "../../";
	static final int MAX_NAME_CHAR = 100;
	DecimalFormat decFormat = new DecimalFormat("##.##");
	String dateFormatStr = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
	SimpleDateFormat dateFormat = new SimpleDateFormat(dateFormatStr);
	%>
<%
	String isPrintStr = request.getParameter("isPrint");	
  boolean isPrint = isPrintStr != null && isPrintStr.equals("true");
  String isMailStr = request.getParameter("isMail");	
  boolean isMail = isMailStr != null && isMailStr.equals("true");
			
	boolean showGraphs = true;
			
					   
	   AggCaseResultViewer result = (AggCaseResultViewer)request.getAttribute("currentResult");		   
		 if (result == null) return;
		 result.setPrint(isPrint);
		 result.setMail(isMail);
		 if(isMail) {
			 result.setApplicationRoot(SiteUtil.getApplicationRoot(request));
		 }
		 result.init();
			
		 
		 int topResults = result.getTopResults();
			boolean showTable = topResults != 0;												
			if (topResults > result.getTotalOfResults()){
				topResults = result.getTotalOfResults();
			}
			String totalString = "";
			if (topResults > 0 && topResults < result.getTotalOfResults()){
				totalString = "  (Top " + topResults + " results)";
			}
			
%>

<table border="0" width="100%" cellpadding="0" cellspacing="0" height="100%">
<% if (!isPrint){ %>
<tr height="3">
	                  <td>
	                  <table border="0" cellpadding="0" cellspacing="0"  width="100%"  height="100%" background="<%=BASE_DIRECTORY%>images/grid/mainBtnsBg.gif">
	                  <tr>
	                                        <td style="font-size:2pt">&nbsp; </td>
	                 	</tr>
	                  </table>
	                  </td>
	                  </tr>
<%} %>

<tr><td>
<table border="0" width="100%" cellpadding="0" cellspacing="0" height="100%">



	<%
	AggResultViewerGraph [] graphs = result.getGraphsResults();
	String excelLink = "";
	if (!isPrint && (result.getType().equals(AggReportConstants.LOG_SIMILARITY_CASE_TYPE) || result.getType().equals(AggReportConstants.LOG_KNOWLEDGE_CASE_TYPE))){
		excelLink = "javascript:exportExcel('" + result.getType()  + "'," + result.getIndex() + ")";
	}
				
	if(isPrint || (showGraphs && graphs != null && graphs.length > 0)){
	%>
	<tr bgcolor="#4a539a" height="20">
		<td width="80%" style="padding-left: 15">
			<span class="TOP_SECTION_TEXT"><%=result.getName() + (result.getDesc() == null || result.getDesc().length() == 0 ? "" : " -" + result.getDesc())%>
				<%if(result.getTotalOfResults() > 0) { %>
				<span style="padding-left: 70">Total number of results: <%=result.getTotalOfResults()%> <%=totalString%></span>
				<%} %>
			</span>
		</td>
		<td width="0" align="right" style="padding-right: 15;padding-top:2">		
		</td>
	</tr>
	<%
											
	}
												if(showGraphs && graphs != null && graphs.length > 0){
													
													
													%>
	<tr height="10">
		<td width="100%" style="padding-top: 5;padding-bottom:5" colspan="2">
		
		<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
			<tr>
				<%
													for(int i = 0; i < graphs.length;i++){
													%>
				<td width="*" style="padding-left: 5" align="left" class="REPORT_TABLE_SUB_HEADER"><%=graphs[i].getName() %></td>
				<%} %>
			</tr>
			<tr>
				<%
													for(int i = 0; i < graphs.length;i++){
													%>
				<td width="*" align="center"><img src="<%=graphs[i].getLink()%>"></td>
				<%} %>
			</tr>

		</table>		
		</td>
	</tr>
<%} %>

	<%if (showTable){
		try {
	String id = result.getId();
	int index = result.getIndex();
	AggResultViewerTable [] tableViewers = result == null ? null : result.getTableViewer();
	if (tableViewers != null){
		if(tableViewers.length == 0) {
	%>
		<tr height="20">
			<td colspan="2" style="padding-left:15;padding-top:10px"><span class="REGULARTEXT">No results were found</span></td>
		</tr>
		<tr>
			<td colspan="2">&nbsp;</td>
		</tr>
	<%
		}
	  for (int i = 0; i < tableViewers.length; i++){
	  	AggCaseTableModel model = tableViewers[i].getTableModel();
	
	 String suffix = id + "_" + index + "_" + i;
	if (model != null){
	  GridTable table = new GridTable(model);	  
	  request.setAttribute("gridTable" + suffix,table);
	}
	if(tableViewers[i].getMessage() != null && tableViewers[i].getMessage().length() > 0) {
		request.setAttribute("message" + suffix,tableViewers[i].getMessage());
	}
	String xmlParse = "str_xml" + suffix;
	if(isPrint && tableViewers[i].getName() != null && tableViewers[i].getName().length() > 0){
		%>
		<tr height="20">
			<td colspan="2" style="padding-left:15;padding-top:10px"><span class="REGULARTEXT"><%=tableViewers[i].getName() %></span></td>
		</tr>
		<%
	}
	%>
	<tr height="*">
		<td colspan="2"  valign="top" style="padding:0">
		
		<% if (isPrint){ %>
		<jsp:include page="../../widgets/grid/jsp/initTableXML.jsp" flush="true">
			<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
			<jsp:param name="suffix" value="<%=suffix%>" />
			<jsp:param name="isPrint" value="true" />
		</jsp:include>
		<%} else { 
		
		
		%>
		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%"  height="100%">
		<tr height="20">
		<td>
		<table border="0" cellpadding="0" cellspacing="0"  width="100%"  height="100%">
		<tr>
		<%if(tableViewers[i].getName() != null && tableViewers[i].getName().length() > 0) { %>
			<td width="80" style="padding-left:10;background-color:#4a539a;color:#ffffff;font-size:11px;font-family:tahoma;font-weight:bold;"><nobr><%=tableViewers[i].getName() %></nobr></td>
		<%} %>
			<td id="recinfoArea<%=suffix%>"  style="background-color:#4a539a;">&nbsp;</td>
			<td width="40" align="right" style=";padding-right:15;padding-top:2;background-color:#4a539a">
		<% if (excelLink != null && excelLink.length() > 0){ %>
		<a class="LINK" style="font-size:9" href="<%=excelLink%>"><img border="0" width="16" height="16" src="<%=BASE_DIRECTORY%>images/misc/01EXCEL1.gif"></a>
		<%} %>
		</td>
		</tr>
		</table>
		</td>		
		</tr>	 
		<tr><td valign="top" >
		<jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true">
			<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
			<jsp:param name="suffix" value="<%=suffix%>" />
			<jsp:param name="xmlParse" value="<%=xmlParse%>" />
			<jsp:param name="rowsNumPerPage" value="12" />
			<jsp:param name="isPrint" value="<%=String.valueOf(isPrint)%>" />
			<jsp:param name="multiline" value="true" />	
			<jsp:param name="recordsText" value="Results" />
			<jsp:param name="style" value="main" />
			<jsp:param name="cssStyle" value="xplgreportskin" />		
			<jsp:param name="useExternalTopPaging" value="true" />
			<jsp:param name="enableTextSelection" value="true" />
		</jsp:include>
		</td></tr>
		<tr style="display:none;"><td>
		<textarea id="<%=xmlParse%>" style="display:none;" cols="20">
		<jsp:include page="../../widgets/grid/jsp/initTableXML.jsp" flush="true">
			<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
			<jsp:param name="suffix" value="<%=suffix%>" />
			<jsp:param name="xml" value="false" />			
		</jsp:include>
		</textarea>
		</td></tr>
		<%if(i < tableViewers.length - 1) { %>
		<tr><td height="10" style="font-size:3pt">&nbsp;</td></tr>
		<%} %>
		</table>
		
		
		<%} %>
		</td>
	</tr>
	<%}}
		}catch (Exception e){
			e.printStackTrace();
		}
		}
											 //end show table											
											%>


</table>
</td></tr>
</table>