<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!static final String BASE_DIRECTORY = "../../";
	static final int MAX_FILTER_SIZE = 40;

	%>
<%String ERROR_OBJ = "ERROR_OBJ";
			ErrorModel ermod = new ErrorModel();
			AggReportBuilder builder = (AggReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");

			if (builder == null) {
				ermod.addError("Session is not valid any more. Please try again");
			}

			if (ermod.getErrorCount() != 0) {
				request.getSession().setAttribute(ERROR_OBJ, ermod);
				response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
				return;
			}

			LogAggCaseBuilder caseBuilder = (LogAggCaseBuilder) builder.getCurrentCaseBuilder();

			//site management  

			SiteManagment mgmt = SiteManagment.getInstance();
			SiteAdministrator admin = SiteManagment.getAdminInstance();

			LogAggregationConf conf = (LogAggregationConf) caseBuilder.getAggConf();

			LogBrowsingManager lbm = null;

			String lid = caseBuilder.getLogId();
			if ((lid != null) && !(lid.trim().equals(""))) {
				try {
					lbm = mgmt.getLogBrowserManager(lid);
				} catch (Exception e) {
				}
			} else {
				lid = conf.getLogId();
				try {
					lbm = mgmt.getLogBrowserManager(lid);
				} catch (Exception e) {
				}
			}

			if (lbm == null) {
				ermod.addError("Log couldn't created for logId " + lid);
			}

			if (ermod.getErrorCount() != 0) {
				request.getSession().setAttribute(ERROR_OBJ, ermod);
				response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
				return;
			}

			RecordMask mask = lbm.getRecordMask();
			MaskColumn[] cols = mask.getMaskColumns();
			//only proper indexs hold numeric mask
			MaskColumn[] numericCols = new MaskColumn[cols.length];
			for (int i = 0; i < cols.length; i++) {
				if (cols[i].getType().equalsIgnoreCase(NumberMask.NUM_MASK_TYPE)) {
					numericCols[i] = cols[i];
				}
			}

			FilterManager flm = lbm.getFilterManager();
			List filterList = flm.getFilterCollections();
			List dfsele = new ArrayList();
			String [] dataFilters = caseBuilder.getDataFilters();
			if (dataFilters != null){
				for (int i = 0 ; i < dataFilters.length;i++){
		  		FilterCollection col = flm.getFilterCollectionById(dataFilters[i]);
			  	if (col != null){
		  	  	dfsele.add(col);
				  }
				}
			}
			
			AggCaseStatusRule statusRule = caseBuilder.getStatusRule();
			int ruleType = statusRule == null ? 0 : statusRule.getRuleType();
			%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>

	function goAgg(){
				addAllFiledToSelection(document.access.To_datafilter,document.access.To_Select_datafilter);
        for(var t=0;t<document.access.To_Select_datafilter.options.length;++t){
          document.access.To_Select_datafilter.options[t].selected='true';
        }
        
		document.access.action = "logCaseFieldsAction.jsp";
		document.access.submit();
	}
	
	function displayFullName(){

	var browserName = navigator.appName; 
	var browserVer = (navigator.userAgent); 
	if(browserName && browserVer) {
	if((browserVer.indexOf("Firefox") != -1) || (browserVer.indexOf("MSIE 7.0") != -1)){
		return;
	} 
	}
		var indx = document.access.From_datafilter.selectedIndex;
		var name = document.access.From_datafilter.options[indx].title;
		showFullFilterName(name);
	
	}
	
	function showFullFilterName(name){
		var nameElement = document.getElementById("fullName");
		if (!nameElement) return;
	    if (name && name != "" && name.length > '<%=MAX_FILTER_SIZE%>'){		
		    fullName.innerHTML = "<b>" + "Full Filter's Name" + "</b>: " +  name;
		 }else {
		    fullName.innerHTML = "&nbsp;";
		 }	
	}
	
	
</script>

</head>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
		<tr>
				<td width="100%" height="100%" valign="top">
				<table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
						<tr>
								<td valign="top" height="90%">
								<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
										<tr>
												<td width="100%">
												<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
														<tr>
																<td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
																<td width="53%" class="TOPBORDER" height="0"><span class="PAGEHEADER">Log Case - Fields</span></td>
																<td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
														</tr>
														<tr>
																<td width="3%" height="100%">&nbsp;</td>
																<td width="43%" height="100%">&nbsp;</td>
																<td width="50%" height="100%">&nbsp;</td>
														</tr>
														<tr>
																<td width="3%" height="100%">&nbsp;&nbsp;&nbsp;</td>
																<td width="93%" colspan="2" height="100%">
																<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="53" style="visibility:visible">
																		<tr>
																				<td width="15%" height="18"><span class="HEADER">Status</span></td>
																		</tr>

																		<tr>
																				<td>
																				<input type="checkbox" name="statusRule" value="ON" <%=(ruleType > 0 ? "checked" : "")%>  >
																				<span class="REGULARTEXT">&nbsp;Failure means that there are &nbsp; <select size="1" name="ruleType" id="ruleType" onfocus="javascript:document.access.statusRule.checked=true">																						
																						<option class="REGULARTEXT" value="1" <%=ruleType == 1 || ruleType == 0? "selected" : ""%>>more than</option>
																						<option class="REGULARTEXT" value="2" <%=ruleType == 2? "selected" : ""%>>less than</option>																						
																				</select> </span> <input type="text" class="TEXTBOX" name="amount" size="5" value="<%=statusRule == null ? "0" : String.valueOf(statusRule.getAmount())%>" onfocus="javascript:document.access.statusRule.checked=true"> <span class="REGULARTEXT">&nbsp;records in the result.</span></td>
																		</tr>

																		<tr>
																				<td>&nbsp;</td>
																		</tr>
																		<tr>
																				<td width="15%" height="18"><span class="HEADER">Data Filters</span></td>
																		</tr>
																		<tr>
																				<td>&nbsp;</td>
																		</tr>
																		<tr>
																				<td>
																				<table border="0" width="600" cellspacing="0" cellpadding="0">
																						<tr>
																								<td>
																								<table border="0" width="86" cellspacing="0" cellpadding="0">
																										<tr>
																												<td width="40%"><span class="SMALLTEXT">Data Filters</span></td>
																										</tr>
																										<tr>
																												<td width="40%"><%

			%> <select class="TEXTBOX" size="6" id="From_datafilter" name="From_datafilter" style="font-size: 8pt; font-family: Verdana" onchange="javascript:displayFullName()">
				<%for (int i = 0; i < filterList.size(); ++i) {
						FilterCollection fc = (FilterCollection) filterList.get(i);
						String filterName = (fc.getName() != null && fc.getName().length() < MAX_FILTER_SIZE) ? fc.getName() : (fc.getName().substring(0,MAX_FILTER_SIZE) + "...");
						String id = fc.getId();
						boolean isTimeFilter = false;
						List list = fc.getByName(TimeEventsFilter.TIME_FILTER_TYPE);
						if (list != null && list.size() > 0){
							isTimeFilter = true;
						}
						if (isTimeFilter){
							id = "*TimeFilter*" + id;
						}
				%>
																														<option value='<%=id%>' name='<%=fc.getName()%>' title='<%=fc.getName()%>'><%=filterName%></option>
																														<%}

			%>
																												</select></td>
																										</tr>
																										<tr>
																												<td width="40%"></td>
																										</tr>
																										<tr>                  
																								</table>
																								</td>
																								<td width="100" nowrap>
																								<table border="0" width="100%" cellspacing="0" cellpadding="0">
																										<tr>
																												<td width="100%" align="center" nowrap><a href="javascript:addFiledToSelection(document.access.From_datafilter,document.access.To_datafilter)" class="SMALLLINK">add</a></td>
																										</tr>
																										<tr>
																												<td width="100%" align="center" nowrap><a href="javascript:addAllFiledToSelection(document.access.From_datafilter,document.access.To_datafilter)" class="SMALLLINK">add all</a></td>
																										</tr>
																										<tr>
																												<td width="100%" align="center" nowrap><a href="javascript:removeFiledFromSelection(document.access.To_datafilter)" class="SMALLLINK">remove</a></td>
																										</tr>
																										<tr>
																												<td width="100%" align="center" nowrap><a href="javascript:removeAllFiledFromSelection(document.access.To_datafilter)" class="SMALLLINK">remove all</a></td>
																										</tr>
																								</table>
																								</td>
																								<td width="286">
																								<table border="0" width="100%" cellspacing="0" cellpadding="0">
																										<tr>
																												<td width="100%"><span class="SMALLTEXT">Show only</span></td>
																										</tr>
																										<tr>
																												<td width="100%"><select class="TEXTBOX" multiple type="hidden" style="visibility:hidden; display:none" name="To_Select_datafilter" id="To_Select_datafilter">
																												</select> <select class="TEXTBOX" size="6" name="To_datafilter" style="font-size: 8pt; font-family: Verdana">
																														<%if (dfsele != null) {
				for (int y = 0; y < dfsele.size(); ++y) {
					FilterCollection fc = (FilterCollection)dfsele.get(y);
					String filterName = (fc.getName() != null && fc.getName().length() < MAX_FILTER_SIZE) ? fc.getName() : (fc.getName().substring(0,MAX_FILTER_SIZE) + "...");
					boolean isTimeFilter = false;
					List list = fc.getByName(TimeEventsFilter.TIME_FILTER_TYPE);
					if (list != null && list.size() > 0){
						isTimeFilter = true;
					}
					String id = fc.getId();
					if (isTimeFilter){
						id = "*TimeFilter*" + id;
					}
					%>
																														<option value='<%=id%>' title='<%=fc.getName()%>' ><%=filterName%></option>
																														<%}
			}

		%>
																												</select></td>
																										</tr>
																										<tr>
																												<td width="40%"></td>
																										</tr>
																								</table>
																								</td>
																								<td width="100" nowrap>
																								<table border="0" width="100%" cellspacing="0" cellpadding="0">
																										<tr>
																												<td width="100%" align="center"></td>
																										</tr>
																										<tr>
																												<td width="100%" align="center"><font size="1"><!--<a href="javascript:alert('holla')">move up</a>--></font></td>
																										</tr>
																										<tr>
																												<td width="100%" align="center"><font size="1"><!--<a href="javascript:alert('holla')">move down</a>--></font></td>
																										</tr>
																										<tr>
																												<td width="100%" align="center"></td>
																										</tr>
																								</table>
																								</td>
																						</tr>
																				</table>
																				</td>
																		</tr>
  <tr>
  <td colspan="4">
                    <span class="SMALLTEXT" id="fullName"></span></td>
                  </tr>
																		<tr>
																				<td>&nbsp;</td>
																		</tr>

																</table>
																</td>
														</tr>
												</table>
												</td>
										</tr>
								</table>
								</td>
						</tr>
						<tr>
								<td valign="bottom" height="10%">
								<table border="0" width="100%">
										<tr>
												<td width="33%"></td>
												<td width="33%" align="center"><a href="javascript:history.go(-1)" class="LINK">previous</a>&nbsp;&nbsp;&nbsp; <a href="javascript:goAgg()" class="LINK">next</a></td>
												<td width="34%"></td>
										</tr>
								</table>
								</td>
						</tr>
						<tr>
								<td valign="bottom" height="10%">
								<table border="0" cellpadding="0" cellspacing="0" width="100%">
										<tr>
												<td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
												<td class="BOTTOMBORDER" width="33%">&nbsp;</td>
												<td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
										</tr>
								</table>
								</td>
						</tr>
				</table>
				</td>
		</tr>
</table>

</form>
</body>

</html>
