<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.remote.*"%>


<%@ page import="java.util.*"%>

<%! 
	static final String BASE_DIRECTORY = "../../";
%>

<%
  String ERROR_OBJ = "ERROR_OBJ";

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();

  UserContext userContext = UserEnvironment.getUserContext(request);
  
    AggReportBuilder builder = (AggReportBuilder)  request.getSession().getAttribute("REPORT_BUILDER");
  
  
 if(builder == null){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("Session is not valid any more. Please try again");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
    return;
  }
 
  LogAggCaseBuilder caseBuilder = (LogAggCaseBuilder)builder.getCurrentCaseBuilder();
  if (caseBuilder == null){
    String caseIndex = request.getParameter("caseIndex");
    int index = -1;
    try {
      index = Integer.parseInt(caseIndex);
    }catch (Exception e){}
  	caseBuilder = index == -1 ? null : (LogAggCaseBuilder)builder.getCaseBuilderAt(index);
    if (caseBuilder == null){
      caseBuilder = new LogAggCaseBuilder();
      AggCaseDefinition caseDef = new AggCaseDefinition();
      caseDef.setName("Case " + (builder.getCasesCount() + 1));
      caseDef.setDesc("LOG_NAME [FILTERS_NAME]");
      caseDef.setType(AggReportBuilder.LOG_CASE_TYPE);
      caseBuilder.setCaseDef(caseDef);
      
    }else {
      caseBuilder = (LogAggCaseBuilder)caseBuilder.clone();   
    }
    builder.setCurrentCaseBuilder(caseBuilder);
  }  
  

  AggCaseDefinition def = caseBuilder.getCaseDef();
  
  
  Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
  
  
  String name="";
  String desc="";

  HashMap logsMap = new HashMap();
  HashMap modulesMap = new HashMap(); 
  
  String logId = caseBuilder.getLogId();
  if (logId != null && logId.length() > 0){
  	logsMap.put(logId,logId);
  	builder.addModuleMemberLogId(logId);
  }
 
  
  if (def != null){
    name = def.getName();
    desc = def.getDesc();
  }
  
  ModuleMember [] currentMembers = builder.getModulesMembers();
 
%>


<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script src="<%=BASE_DIRECTORY%>scripts/tree/rightClickMenu.js"></script>
<!--<script  src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>-->
<script>
    baseDirectory = "<%=BASE_DIRECTORY%>";
    
    
    function doNext(){
    	//updateSelected();
	  	if (updateLog){
		  	updateLog(tree,"logs");
		  }
      document.access.action = "logCaseSelectionAction.jsp";
      document.access.submit();
    }
    
  function markSelectionTreeNode(node){
    document.getElementById("usedLogs").selectedIndex = 0;
		nodeCbx = document.getElementById("CheckBox_" + node.tree.name + "_" + node.index);
		if (!nodeCbx) return;
		if (node.selected == nodeCbx.checked) return;
		
		var selected = nodeCbx.checked;	
	  if (this.onSelectMarkChilds){
	    markNodeChilds(node,selected);  
	  }else {
	    node.selected = selected;
	  }
	  
	  if (this.onSelectMarkParents  && selected){
	    markNodeParentsToRoot(node.parent,selected);  
	  }
	  
	}

  function updateSelectedLog(id,checkState){
  	var ind = id.indexOf("-");
  	if (ind != -1 && ind < id.length){
  		var type = id.substring(0,ind);
  		var logId = id.substring(ind+1,id.length);
  		if (!logId){
  			return;
  		}
  		var found = false;
  		for (var i=0; i<document.access.usedLogs.options.length; i++){
  			if (document.access.usedLogs.options[i].value == logId){
  				document.access.usedLogs.options[i].selected = true;
  				found = true;
  				break;
  			}
  		}
  		if (!found){
  			document.access.usedLogs.options[0].selected = true;
  		}
  	}
  }


function writeMyNodeData(node){ 
  if (!node.isLeaf() || node.chkKey=='modules'){  
    var img = baseDirectory + (node.expand ? collapseImage : expandImage);  
    document.writeln("<img src=\"" + img + "\" onClick=\"javascript:selectNode(" + node.index + ")\" id=\"ExpandImage_" + this.name + "_" + node.index + "\"  class=\"" + node.tree.nodeImageStyle + "\">");
  }else {
    document.writeln("<input type=\"radio\" name=\"" + node.chkKey + "\" value=\""+node.id +"\" id=\"CheckBox_" + this.name + "_" + node.index + "\"" + (node.selected ? " checked" : "") +  " onClick=\"javascript:markNode(" + node.index + ")\"" + (node.disable ? " disabled" : "") + ">");
  }
  document.writeln("&nbsp;" + node.name);
  if (node.desc && node.desc != ""){
     document.writeln("&nbsp;(" + node.desc + ")");
  }
  if (node.text && node.text != ""){
     document.writeln("&nbsp;" + node.text);
  }  
}

	function updateSelected(){
		list = tree.getAllCheckedAndPartiallyChecked();
		arr = list.split(",");
	  var selectedLogsCombo = document.getElementById("logs");
	  var logsStr = "";
	  var modsStr = "";
		for (var i=0; i<arr.length; i++){
			s = arr[i];
			ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				type = s.substring(0,ind);
				id = s.substring(ind+1,s.length);
				if (logsStr != ""){
					logsStr += ",";
				}
				logsStr += id;
			}
		}
		document.access.logs.value = logsStr;
	}

</script>
</head>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="POST">
<input type="hidden" name="logs">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
              <tr>
                <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="53%" class="TOPBORDER" height="0">
                <span class="PAGEHEADER">Log Case Selection</span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                   <tr><td width="*"  valign="top" ><span class="HEADER">General</span></td></tr>
                                      <tr>
                                        <td ><font size="1">&nbsp;</font></td>
                                      </tr>
				     <tr><td  width="100%">
				      <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td width="100"><span class="REGULARTEXT">Name: </span></td>
					<td width="*"><input class="REGULARTEXT" type="text" name="name" size="30" value="<%=name%>"></td>
                                      </tr>
                                      <tr><td colspan="2">&nbsp;</td></tr>
				      <tr>
                                        <td width="100"><span class="REGULARTEXT">Description: </span></td>
					<td width="*"><input class="REGULARTEXT" type="text" name="desc" size="30" value="<%=desc%>"></td>
                                      </tr>
				      </table>
				      </td></tr>
                                      <tr><td >&nbsp;</td></tr>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Logs List</span><b>&nbsp;</b></td>
                  </tr>                  
                  <tr>
                    <td>
                    <span class="REGULARTEXT">Select a log to be used in this case</span>
                    </td>
                  </tr>
                  <tr><td >&nbsp;</td></tr>
                  <tr>
                    <td style="padding-left:20">
                    <span class="REGULARTEXT">Select from used logs: </span> 
                    <select id="usedLogs" name="usedLogs" size="1" class="TEXTBOX">
                    <option value="" selected>---- Select log ----</option>
                    <% for(int i = currentMembers.length; --i >= 0;){
                    	String selectedStr = "";
                    	if (logId != null && logId.length() > 0){
                    		if (currentMembers[i].getId().equals(logId)){                    	
                        	selectedStr = "selected";
                    		}
                      }else if (i == (currentMembers.length - 1)){
                      	selectedStr = "selected";
                      }
                    	%>
                    <option value="<%=currentMembers[i].getId()%>" <%=selectedStr%>><%=currentMembers[i].getName()%></option>
                    <%}%>
                    </select>
                    </td>
                  </tr>
									<tr>
										<td valign="top">
											<div id="loadingDiv" style="display:none">
												<span class="REGULARTEXT">Loading...</span>
											</div>
										</td>
									</tr>
                  <tr>
                    <td width="15%">
											<jsp:include page="../../common/selectLog.jsp" flush="true">
											<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
											<jsp:param name="LBM_ID" value="<%=logId%>" />
											</jsp:include>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="30%">&nbsp;</td>
            <td width="31%" align="center">
              <table border="0" width="109%">
                <tr>
                  <td width="24%"><a href="<%=BASE_DIRECTORY%>reports/reportsDefinitionView.jsp" class="LINK">cancel</a></td>
                  <td width="40%">
                    <p align="center"><a href="<%=BASE_DIRECTORY%>reports/agg/aggCasesView.jsp" class="LINK">previous</a></td>
                  <td width="46%"><a href="javascript:doNext()" class="LINK">next</a></td>
                </tr>
              </table>
            </td>
            <td width="39%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>

</body>
</html>