<%@ page language="java"%>

<%@page import="xpolog.eye.util.XpologUtil"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@page import="xpolog.eye.data.util.functions.*"%>
<%@page import="xpolog.eye.reports.agg.result.*"%>
<%@page import="xpolog.eye.data.util.functions.formats.XpoLogFunctionFormat"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!static final String BASE_DIRECTORY = "../../";

	%>
<%String ERROR_OBJ = "ERROR_OBJ";

			ErrorModel ermod = new ErrorModel();
			AggReportBuilder builder = (AggReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");

			if (builder == null) {
				ermod.addError("Session is not valid any more. Please try again");
			}

			if (ermod.getErrorCount() != 0) {
				request.getSession().setAttribute(ERROR_OBJ, ermod);
				response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
				return;
			}

			LogFunctionAggCaseBuilder caseBuilder = builder.getTempFunctionCaseBuilder();

			
			DataExpressionManager deMgr = DataExpressionManager.getInstance();
			String type = request.getParameter("type");
			
			
			DataExpressionAggConf [] expressions = caseBuilder.getExpressionsAggConf();
			String op = request.getParameter("op");
			String functionIndexStr = request.getParameter("functionIndex");
			
			int functionIndex = -1;
			try {
				functionIndex = Integer.parseInt(functionIndexStr);
			}catch (Exception e){}
			
			if (op == null){
				op = "";
			}
			int startIndex = 1;
			String message = "";
			if (op.equals("apply")){
				String functionName = request.getParameter("funcName");
				String functionExpression = request.getParameter("funcExpression");
				String formatType = request.getParameter("formatType");
				String formatName = request.getParameter("formatName");
				String formatProp = request.getParameter("formatProp");
				String showOverTime = request.getParameter("showOverTime");
				if (functionExpression != null && functionExpression.length() > 0){
					functionExpression = functionExpression.replaceAll("\\\r\\\n","\n");
					DataExpressionAggConf conf = new DataExpressionAggConf();
					conf.setExpression(functionExpression);
					boolean testOK = true;
					try {
						AggReportHelper.testExpression(conf,expressions);
					}catch (Exception e){
						message = e.getMessage();
						testOK = false;
					}
					
					if (testOK){
				  	if (functionName == null || functionName.length() == 0){
					  	functionName = "Result " + (startIndex +(functionIndex == -1 ? expressions.length : functionIndex));
					  }
															
					  conf.setResultKey("f" + (startIndex +(functionIndex == -1 ? expressions.length : functionIndex)));
					  if (functionIndex == -1){
						  caseBuilder.addExpression(conf);
					  }else {
						  caseBuilder.setExpression(functionIndex,conf);
					  }
					
									
				  	LogFunctionExpressionInfo info = new LogFunctionExpressionInfo();
					  info.setDisplayName(functionName);
					  info.setFunctionKey(conf.getResultKey());
					  info.setGroupType(type);
					  if (showOverTime != null && showOverTime.length() > 0){
						  info.setShowOverTime(showOverTime.equalsIgnoreCase("true"));
					  }
					  if (formatType != null && formatType.length() > 0){
						  XpoLogFunctionFormat format = XpoLogFunctionManager.getInstance().getFormat(formatType);
						  format = format == null ? null : (XpoLogFunctionFormat)format.clone();
						  if (format != null && formatType.length() > 0){
						  	if (formatName != null && formatName.length() > 0){
							  	format.setName(formatName);
							  }
						  	if (formatProp != null && formatProp.length() > 0){
							  	format.setPropertiesStr(formatProp);
							  }
						  	
						  }
						  if (format != null){
							  info.setFormat(format);
							  info.setUseFormatType(false);
						  }
					  }
					  caseBuilder.addFunctionInfo(info);
					}
				}else {
					message = "No function expression was given";
				}
				
			}else if (op.equals("remove")){
				if (functionIndex >= 0 && functionIndex < expressions.length){
					DataExpressionAggConf conf = caseBuilder.getExpressionAggConf(functionIndex);
					if (conf != null){
						String key = conf.getResultKey();						
  					caseBuilder.removeExpression(functionIndex);
  					caseBuilder.removeFunctionInfo(key);
					}
				}
			}	else if (op.equals("addTemplate")){					
				String dataKeysStr = request.getParameter("dataKeys");
				String dataNamesStr = request.getParameter("dataNames");
		  	String templateIds = request.getParameter("templatesIds");
		  	
		  				  	
		  	String [] keys = dataKeysStr != null && dataKeysStr.length() > 0 ? dataKeysStr.split(";") : new String[0];
		  	String [] names = dataNamesStr != null && dataNamesStr.length() > 0 ? dataNamesStr.split(";") : new String[0];
		  	DataExpressionTemplate [] templates = new DataExpressionTemplate[0];
		  	if (templateIds != null && templateIds.length() > 0){
		  		ArrayList list = new ArrayList();
		  		String [] templatesArr = templateIds.split(";");
		  		for (int i = 0; i < templatesArr.length;i++){
		  			DataExpressionTemplate template = deMgr.getTemplatebyId(templatesArr[i].trim());
		  			if (template != null){
		  				list.add(template);
		  			}
		  		}
		  		templates = (DataExpressionTemplate [])list.toArray(new DataExpressionTemplate[list.size()]);
		  	}			  	
			if (keys.length > 0 && templates.length > 0){
				
				int count = 0;
				for (int i = 0; i < keys.length;i++){
					for (int j = 0; j < templates.length;j++){
						String expression = templates[j].getExpression();
						expression = XpologUtil.replaceAll(expression,"DATA_KEY",keys[i].trim());
						DataExpressionAggConf conf = new DataExpressionAggConf();
						conf.setExpression(expression);
						conf.setResultKey("f"  + (1 + count + (functionIndex == -1 ? expressions.length : functionIndex)));
						caseBuilder.addExpression(conf);
						
												
						String functionName = templates[j].getName();
						if (functionName != null){
							functionName = XpologUtil.replaceAll(functionName,"DATA_NAME",names[i].trim());
						}
						
						LogFunctionExpressionInfo info = new LogFunctionExpressionInfo();
						info.setDisplayName(functionName);
						info.setFunctionKey(conf.getResultKey());
						info.setGroupType(type);
						info.setFormat(templates[j].getFormat());
						info.setUseFormatType(templates[j].isUseFormatType());
						caseBuilder.addFunctionInfo(info);
						
						count++;
					}
											
				}
									
			}else {
				message = "No function templates was given";
			}						
			}else {
				message = "No operation was given";
			}
			
			
			%>
<%=message%>
