<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.meta.MetaDataHelper"%>
<%@ page import="xpolog.eye.meta.MetaData"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
  LinearBrowsingManager lbm = (LinearBrowsingManager)  request.getSession().getAttribute("CURRENT_LOG");
  UserContext userContext = UserEnvironment.getUserContext(request);
  
  ErrorModel ermod = new ErrorModel();
  
  String logid = request.getParameter("logid");
  if (logid != null && logid.length() > 0){
    try {
    	lbm = SiteManagment.getInstance().getLogBrowserManager(logid);
    }catch (Exception e){
    	ermod.addError("Failed to load log with id " + logid);
    }
  }

  if(lbm == null){  
   ermod.addError("Log is not valid any more. Please try again");
   request.getSession().setAttribute("ERROR_OBJ",ermod);
   response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
   return;
   }
  
  String colIndexStr = request.getParameter("colIndex");
  int colIndex = -1;
  if (colIndexStr != null && colIndexStr.length() > 0){
  	try {
  		colIndex = Integer.parseInt(colIndexStr);
  	}catch (Exception e){}
  }

  String addFiltersStr = request.getParameter("addFilters");
  boolean addFilters = addFiltersStr == null || addFiltersStr.equals("true");
  
  String addTotalStr = request.getParameter("addTotal");
  boolean addTotal = addTotalStr == null || addTotalStr.equals("true");
  
  String addKnowledgeStr = request.getParameter("addKnowledge");
  boolean addKnowledge = addKnowledgeStr == null || addKnowledgeStr.equals("true");
  
  String addSimilarityStr = request.getParameter("addSimilarity");
  boolean addSimilarity = addSimilarityStr != null && addSimilarityStr.equals("true");
  
  
  ReportsManager reportMgr = ReportsManager.getInstance();
  AggReportBuilder builder = AggBuilderHelper.createAggReportForLog("Aggregation",lbm,addTotal,addFilters,colIndex,addKnowledge,addSimilarity);
  if(builder == null){
    ermod.addError("Failed to create aggregation report for log " + lbm.getName());
    request.getSession().setAttribute("ERROR_OBJ",ermod);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
    return;
    }
  Report rep = builder.buildReport();
  if (rep != null){
  	if (builder.isNew()){
    	reportMgr.addNewReport(rep.getTemplateId(),rep,userContext)	;
  	}else {
  		reportMgr.saveReport(rep);
  	}
  }
  
  String [] appIds = null;
  String logId = lbm.getId();
	if (logId != null && logId.length() > 0){
		HashSet apps = SiteManagment.getInstance().getMetaDataMgr().getMetaDatasByXplgObject(XpoLogObjectTypes.LOG_TYPE, logId, true);
		if (apps != null){
			List list = new LinkedList();
			Iterator it = apps.iterator();
			MetaData md = null; 
			while (it.hasNext()){
				md = (MetaData)it.next();
				if (md != null && md.getId() != null){
					list.add(md.getId());
				}
			}
			appIds = (String[])list.toArray(new String[list.size()]);
		}
		
	}
	if (appIds != null){
		MetaDataHelper.addMetaData(appIds,XpoLogObjectTypes.REPORT_TYPE,rep.getId(),userContext);
	}
  
  String name = "";
  if(rep != null) {
	name = rep.getReportName();
  }
//audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			userContext, AuditConstants.CHANGE, "edit/save report", AuditConstants.REPORTS, "change report " + name);

  response.sendRedirect(BASE_DIRECTORY + "reports/agg/aggReportDefinition.jsp?op=generate&reportId=" + rep.getId());
  	
%>