<%@ page language="java"%>

<%@page import="java.io.File"%>
<%@page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisReport"%>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@page import="xpolog.eye.reports.api.ReportsSessionManager"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.meta.MetaDataHelper"%>
<%@ page import="xpolog.eye.meta.MetaData"%>
<%@page import="xpolog.eye.security.XpologSecurityHelper"%>
<%@page import="xpolog.eye.security.UserSecurity"%>
<%@page import="xpolog.eye.reports.api.ReportAPIHelper"%>


<%!static final String BASE_DIRECTORY = "../../";%>

<%

	UserContext userContext = UserEnvironment.getUserContext(request);
	if (userContext.getUser() == null){
		try {
			UserSecurity userSecurity = XpologSecurityHelper.getUserSecurity(request);
			if (userSecurity != null){				
				userContext.setUser(userSecurity);			
			}	
		}catch (Exception e){}
	}
	
	Properties prop = new Properties();
	for (Enumeration e = request.getParameterNames();e.hasMoreElements();){
		String key = (String)e.nextElement();
		String value = request.getParameter(key);
		prop.setProperty(key,value);
	}

	boolean success = true;
	String message = "";

	try {
		ReportAPIHelper.prepareReportAPI(prop,userContext);		
	}catch (Exception e){
		success = false;
		message = e.getMessage();
	}
	
	String xml = GridModelActionsHelper.getResultXML(success, message);

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	
	out.write(xml);
	out.flush();
%>