<%@ page language="java"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	//do whatever needed to remove the report
	String reportId = request.getParameter("reportId");
	if (reportId == null || reportId.length() == 0){
		reportId = request.getParameter("reportIds");
  }
  boolean success = true;
	String message = "";
	if (reportId != null) {
		String [] reports = reportId.split(",");
		ReportsManager reportMgr = ReportsManager.getInstance();
		StringBuffer ids = new StringBuffer();
		for (int j = 0; j < reports.length;j++){ 		  
			Report report = reportMgr.getReportById(reports[j], true);
			String name = "";
			if (report != null) {
				name = report.getReportName();
			}
			//audit
			AuditManager.getInstance().write(
					AuditConstants.BASIC_AUDIT_LEVEL, userContext,
					AuditConstants.CHANGE, "remove report",
					AuditConstants.REPORTS, "remove report " + name);
	
			try {
				reportMgr.removeReport(reports[j], userContext);
			} catch (Exception e) {
				ErrorModel.log.error("Failed to remove report " + name + " with id " + reports[j], e);
				success = false;
				message = e.getMessage();
			}
		}
	}else {
		message = "No report was given, please refresh and try again";
	}
	String xml = GridModelActionsHelper.getResultXML(success, message);

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	
	out.write(xml);
	out.flush();
%>
