<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>

<%!static final String BASE_DIRECTORY = "../";%>

<%

  String ERROR_OBJ = "ERROR_OBJ";
  
  String reportId = request.getParameter("reportId");
  String reportRuntimeId = request.getParameter("reportRuntimeId");
  
  boolean success = true;
  String message = "";
  	
  if(reportId == null || reportId.trim().equals("")){
	success = false;
    message = "No report was supplied.";
  }
  if(reportRuntimeId == null || reportRuntimeId.trim().equals("")){
	  if (!success){
		success = false;
		message += "<br>";
	  }
	  message += "No report runtime was supplied.";
  }

  if (success){
	  try {
		  ReportsManager reportMgr = ReportsManager.getInstance();
		  reportMgr.removeReportRuntime(reportId, reportRuntimeId);	
		  success = true;
	  } catch (Exception e){
		  ErrorModel.log.error("Failed to remove report runtime " + reportRuntimeId
					+ " with report id " + reportId, e);
			success = false;
			message = e.getMessage();
	  }
			  
  }
  
  String xml = GridModelActionsHelper.getResultXML(success, message);

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	
	out.write(xml);
	out.flush();
	  
%>
