<%@ page language="java"%>

<%@ page import="java.text.SimpleDateFormat"%>
<%@ page import="java.util.*"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.reports.Report"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisProperty"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisPropertyOption"%>

<%!
	static final String BASE_DIRECTORY = "../";

	String dateFormat = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat", "MM/dd/yyyy HH:mm:ss");
	String msSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator", ".");
	String dateFormatMS = dateFormat + msSeperator + "SSS";
	String timeFormat = "HH:mm:ss";

	public String transformDateToString(Date d, long timeDiff) {
		if (d == null) {
			return null;
		}
		if (timeDiff != 0) {
			long time = d.getTime();
			d = ((Date) d.clone());
			d.setTime(time + timeDiff);
		}
		//01/31/2003 01:42:34
		String format = "";
		if (d.getTime() % 1000 == 0) {
			format = dateFormat;
		} else {
			format = dateFormatMS;
		}
		String str = new SimpleDateFormat(format).format(d);
		return str;
	}
%>
<%
	String BASE_DIR = "base_directory";
	
  String baseDir = request.getParameter(BASE_DIR);
	if (baseDir == null || baseDir.equals("")) {
		baseDir = BASE_DIRECTORY;
	}
	
	Report report = (Report)request.getAttribute("report");
	
	String PREFIX = request.getParameter("prefix");
	if(PREFIX == null) {
		PREFIX = "";
	}
	
	String DATE_FILTER = "DateFilter";
	String DATE_MIN_FILTER_ACTIVE = "DateMinFilterActive";
	String DATE_MAX_FILTER_ACTIVE = "DateMaxFilterActive";
	String DATE_MIN_FILTER_ACTIVE_PARAM = "DATE_MIN_FILTER_ACTIVE_PARAM";
	String DATE_MAX_FILTER_ACTIVE_PARAM = "DATE_MAX_FILTER_ACTIVE_PARAM";
	String DATE_MINIMUM = "DateMinimum";
	String DATE_MAXIMUM = "DateMaximum";
	
	Date minDate = null;
	Date maxDate = null;
	String minDateStr = "";
	String maxDateStr = "";
	String minStat = "";
	String maxStat = "";
	String timeunit = "";
	String isTimeLim = "";
	String daystatsel1 = "";
	String minstatsel1 = "";
	String hourstatsel1 = "";
	String monthstatsel2 = "";
	String weekstatsel2 = "";
	String daystatsel2 = "";
	String daystatsel3 = "selected";
	String hourstatsel3 = "";
	String istoday = "";
	String islast = "";
	String isprevious = "";
	String isfrom = "";
	String selectedIndex = "1";
	long timeDiff = 0;
	String fromlastdaysat = "";
	String timeWindowSize = "0";
	String dayswindowsizesel = "";
	String hourswindowsizesel = "";
	boolean isAllData = true;
	
	FilterCollection fc = null;
	DateFilter datefl = new DateFilter();
	datefl.setColIndex(0);
	NumberFilter numberfl = new NumberFilter();
	numberfl.setColIndex(1);

	if(report != null) {
		fc = report.getTimeRule();
		isAllData = true;
		if (fc != null && fc.getByName(DATE_FILTER) != null && fc.getByName(DATE_FILTER).size() > 0) {
			datefl = (DateFilter) fc.getByName(DATE_FILTER).get(0);
			isAllData = false;
			if (datefl.getTimeType() == -1) {
				minDate = datefl.getMinDate();
				maxDate = datefl.getMaxDate();					
			} else if (datefl.getTimeOpType() == 1) {
				isTimeLim = "checked";
				islast = "selected";
				selectedIndex = "1";
				timeunit = String.valueOf(datefl.getTimeGap());
				if (datefl.isDays()) {
					daystatsel1 = "selected";
					if (datefl.getTimeGap() == 0) {
						istoday = "selected";
						selectedIndex = "0";
					}
				} else if (datefl.isHours()) {
					hourstatsel1 = "selected";
				} else {
					minstatsel1 = "selected";
				}
			} else if (datefl.getTimeOpType() == 2) {
				selectedIndex = "2";
				isTimeLim = "checked";
				isprevious = "selected";
				timeunit = String.valueOf(datefl.getTimeGap());					
				if (datefl.isDays()) {
					daystatsel2 = "selected";
				} else if (datefl.isWeeks()) {
					weekstatsel2 = "selected";
				} else if (datefl.isMonths()) {
					monthstatsel2 = "selected";
				}
			} else if (datefl.getTimeOpType() == 3) {
				selectedIndex = "3";
				isTimeLim = "checked";
				isfrom = "selected";
				timeunit = String.valueOf(datefl.getTimeGap());
				if (datefl.isDays()) {
					daystatsel3 = "selected";
					hourstatsel3 = "";
				} else if (datefl.isMonths()) {
					hourstatsel3 = "selected";
				}
			}
		}
	}

	Date at = new Date(datefl.getFromGap());
	SimpleDateFormat simpleFormat = new SimpleDateFormat(timeFormat);
	simpleFormat.setTimeZone(TimeZone.getTimeZone("GMT"));
	fromlastdaysat = simpleFormat.format(at);

	long windowSize = 0;
	if (datefl.getTimeWindowSize() == 0 || datefl.getTimeWindowSize() % (24 * 60 * 60 * 100) == 0) {
		windowSize = datefl.getTimeWindowSize() / (24 * 60 * 60 * 1000);
		dayswindowsizesel = "selected";
	} else {
		windowSize = datefl.getTimeWindowSize() / (60 * 60 * 1000);
		hourswindowsizesel = "selected";
	}
	timeWindowSize = String.valueOf(windowSize);

	long minTimeDiff = timeDiff;
	if (minDate == null) {
		minDate = new Date();
		long t = minDate.getTime();
		minDate.setTime(t - (t % 1000));
		minTimeDiff = 0;
	} else {
		minStat = "checked";
	}

	long maxTimeDiff = timeDiff;
	if (maxDate == null) {
		maxDate = new Date();
		long t = maxDate.getTime();
		maxDate.setTime(t - (t % 1000));
		maxTimeDiff = 0;
	} else {
		maxStat = "checked";
	}
	minDateStr = transformDateToString(minDate, minTimeDiff);
	maxDateStr = transformDateToString(maxDate, maxTimeDiff);
	
	String needsUserInputStr = request.getParameter("needsUserInput");
  boolean needsUserInput = needsUserInputStr != null && needsUserInputStr.equals("true");
	
%>

<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
	<%
	List environmentAnalysisProperties = (List)request.getAttribute("environmentAnalysisProperties");
	if(environmentAnalysisProperties != null) {
		EnvironmentAnalysisProperty environmentAnalysisProperty = null;
		List environmentAnalysisPropertyOptions = null;
		for(int i = 0; i < environmentAnalysisProperties.size(); i++) {
			environmentAnalysisProperty = (EnvironmentAnalysisProperty)environmentAnalysisProperties.get(i);
			if(environmentAnalysisProperty.isRequired()) {
	%>
				<tr height="10" valign="top">
					<td style="width:120;padding-top:10">
						<span class="REGULARTEXT"><%=environmentAnalysisProperty.getName() %></span>
					</td>
	<%
				if(environmentAnalysisProperty.getType().equals(EnvironmentAnalysisProperty.TYPE_TEXT)) {
	%>
					<td style="padding-top:10" align="left">
						<input id="<%=PREFIX %><%=environmentAnalysisProperty.getKey() %>" name="<%=PREFIX %><%=environmentAnalysisProperty.getKey() %>" value="<%=environmentAnalysisProperty.getValue() %>" />
					</td>
	<%
				}else if(environmentAnalysisProperty.getType().equals(EnvironmentAnalysisProperty.TYPE_SELECT)) {
					environmentAnalysisPropertyOptions = environmentAnalysisProperty.getEnvironmentAnalysisPropertyOptions();
					if(environmentAnalysisPropertyOptions != null && environmentAnalysisPropertyOptions.size() > 0) {
	%>
					<td style="padding-top:10" align="left">
						<table border="0" width="100%" cellspacing="0" cellpadding="0">
							<tr>
								<td style="width:120">
									<select id="<%=PREFIX %><%=environmentAnalysisProperty.getKey() %>" name="<%=PREFIX %><%=environmentAnalysisProperty.getKey() %>" size="1" onChange="javascript:propertySelectChange('<%=PREFIX %><%=environmentAnalysisProperty.getKey() %>')">
	<%
						EnvironmentAnalysisPropertyOption environmentAnalysisPropertyOption = null;
						String environmentAnalysisPropertyOptionSelected = "";
						boolean foundOption = false;
						for(int j = 0; j < environmentAnalysisPropertyOptions.size(); j++) {
							environmentAnalysisPropertyOption = (EnvironmentAnalysisPropertyOption)environmentAnalysisPropertyOptions.get(j);
							if(environmentAnalysisPropertyOption.getId().equals(environmentAnalysisProperty.getValue())) {
								environmentAnalysisPropertyOptionSelected = "selected";
								foundOption = true;
							}else {
								environmentAnalysisPropertyOptionSelected = "";
							}
	%>
										<option value="<%=environmentAnalysisPropertyOption.getId() %>" <%=environmentAnalysisPropertyOptionSelected %>><%=environmentAnalysisPropertyOption.getText() %></option>
	<%
						}
						String displayOtherTextField = "none";
						String environmentAnalysisPropertyOtherValue = "";
						if(!foundOption) {
							environmentAnalysisPropertyOptionSelected = "selected";
							displayOtherTextField = "";
							environmentAnalysisPropertyOtherValue = environmentAnalysisProperty.getValue();
						}else {
							environmentAnalysisPropertyOptionSelected = "";
						}
	%>
										<option value="other" <%=environmentAnalysisPropertyOptionSelected %>>Other</option>
									</select>
								</td>
								<td style="padding-left:5">
									<input id="<%=PREFIX %><%=environmentAnalysisProperty.getKey() %>Other" name="<%=PREFIX %><%=environmentAnalysisProperty.getKey() %>Other" value="<%=environmentAnalysisPropertyOtherValue %>" style="display:<%=displayOtherTextField %>" />
								</td>
							</tr>
						</table>
					</td>
	<%
					}
				}else if(environmentAnalysisProperty.getType().equals(EnvironmentAnalysisProperty.TYPE_TIME)) {
	%>
					<td style="padding-top:10" align="left">
						<input type="hidden" name="<%=PREFIX %>TimeUnit">
						<input type="hidden" name="<%=PREFIX %>TimeText">
						<input type="hidden" name="<%=PREFIX %>TimeOpType">
						<input type="hidden" name="<%=PREFIX %>SchedulerName" value="schedName">
						<input type="hidden" name="<%=PREFIX %>SchedulerDescription" value="schedDesc">
						<input type="hidden" name="<%=PREFIX %>SchedulerId" value="schedId">
						
						<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr>
								<td width="*">
									<table border="0" width="100%" cellspacing="0" cellpadding="0">												
										<tr>
											<td width="100%" valign="top">
												<div id="<%=PREFIX %>filtersDiv" style="">
												<table border="0" width="100%" cellspacing="0" cellpadding="0">
											    <tr>
														<td width="20"><input type="radio" id="<%=PREFIX %>AllData" <%=isAllData? "checked" : ""%> name="<%=PREFIX %>Dates" value=""></td>
														<td width="100%"><span class="REGULARTEXT">Run on all data</span></td>
													</tr>																		
													<tr style="padding-top:5">
														<td width="20"><input type="radio" id="<%=PREFIX %>TimeLimRadio" <%=!isAllData && isTimeLim.length() == 0? "checked" : ""%> name="<%=PREFIX %>Dates" value="TimeLimRadio"></td>
														<td width="100%"><span class="REGULARTEXT">Run</span></td>
													</tr>
													<tr>
														<td width="20">&nbsp;<iframe name="<%=PREFIX %>dateValidationFrame" style="visibility:hidden" width="0" height="0"></iframe></td>
														<td width="100%">
															<table border="0" width="100%">
																<tr>
																	<td width="20" valign="bottom"><input class="SMALLTEXT" type="checkbox" name="<%=PREFIX %><%=DATE_MIN_FILTER_ACTIVE%>" id="<%=PREFIX %><%=DATE_MIN_FILTER_ACTIVE%>" <%=minStat%> onclick="document.reportGenerationForm.<%=PREFIX %>TimeLimRadio.checked='true'"></td>
																	<td width="*"><span class="SMALLTEXT"><b>From</b>&nbsp;</span> <input class="TEXTBOX" type="text" size="25" onChange="javascript:checkDate(document.reportGenerationForm.<%=PREFIX %><%=DATE_MIN_FILTER_ACTIVE%>,document.reportGenerationForm.<%=PREFIX %><%=DATE_MINIMUM%>)" name="<%=PREFIX %><%=DATE_MINIMUM%>" value="<%=minDateStr%>" style="font-size: 8pt"
																			onclick="document.reportGenerationForm.<%=PREFIX %>TimeLimRadio.checked='true'">&nbsp;<a href="javascript:openCal17();" onclick="document.reportGenerationForm.<%=PREFIX %>TimeLimRadio.checked='true'" class="SMALLLINK">calendar</a></td>																								
																</tr>
																<tr>
																	<td width="20" valign="bottom"><input class="SMALLTEXT" type="checkbox" name="<%=PREFIX %><%=DATE_MAX_FILTER_ACTIVE%>" id="<%=PREFIX %><%=DATE_MAX_FILTER_ACTIVE%>" <%=maxStat%> onclick="document.reportGenerationForm.<%=PREFIX %>TimeLimRadio.checked='true'"></td>
																	<td width="*"><span class="SMALLTEXT"><b>To</b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span> <input class="TEXTBOX" type="text" size="25" onChange="javascript:checkDate(document.reportGenerationForm.<%=PREFIX %><%=DATE_MAX_FILTER_ACTIVE%>,document.reportGenerationForm.<%=PREFIX %><%=DATE_MAXIMUM%>)" name="<%=PREFIX %><%=DATE_MAXIMUM%>" value="<%=maxDateStr%>" style="font-size: 8pt"
																			onclick="document.reportGenerationForm.<%=PREFIX %>TimeLimRadio.checked='true'">&nbsp;<a href="javascript:openCal18();" onclick="document.reportGenerationForm.<%=PREFIX %>TimeLimRadio.checked='true'" class="SMALLLINK">calendar</a></td>																								
																</tr>
																<tr>
																	<td width="20">&nbsp;</td>
																	<td nowrap valign="middle"><span class="SMALLTEXT" style="height:1">Date format: <%=dateFormat%>, <%=dateFormatMS%></span></td>
																</tr>
															</table>
														</td> 
													</tr>
													<tr style="padding-top:5">
														<td width="20"><input type="radio" id="<%=PREFIX %>TimeUnitRadio" name="<%=PREFIX %>Dates" <%=isTimeLim%> value="TimeUnitRadio"></td>
														<td width="100%">
															<table border="0" width="100%">
																<tr>
																	<td width="100"><nobr> <span class="REGULARTEXT">Run </span>
																		<select class="TEXTBOX" size="1" name="<%=PREFIX %>TimeType" onfocus="document.reportGenerationForm.<%=PREFIX %>TimeUnitRadio.checked=true" onchange="javascript:changeTimeType(this)" style="font-size: 8pt">
																			<option value="1" <%=islast%>>from the last</option>
																			<option value="2" <%=isprevious%>>from the previous</option>
																			<option value="3" <%=isfrom%>>from</option>
																		</select></nobr>
																	</td>
																	<td width="130">
																		<div id="<%=PREFIX %>timeType1Div" <%=(datefl.getTimeOpType() == 1)?"":"style=\"display:none\""%>><input class="TEXTBOX" type="text" name="<%=PREFIX %>TimeText1" size="3" value="<%=timeunit%>" onfocus="document.reportGenerationForm.<%=PREFIX %>TimeUnitRadio.checked=true" style="font-size: 8pt">
																		<select class="TEXTBOX" size="1" name="<%=PREFIX %>TimeUnit1"
																	 					onfocus="document.reportGenerationForm.<%=PREFIX %>TimeUnitRadio.checked=true" style="font-size: 8pt">
																			<option value="<%=PREFIX %>minutes" <%=minstatsel1%>>minutes</option>
																			<option value="<%=PREFIX %>hours" <%=hourstatsel1%>>hours</option>
																			<option value="<%=PREFIX %>days" <%=daystatsel1%>>days</option>
																		</select>
																		</div>
																		<div id="<%=PREFIX %>timeType2Div" <%=(datefl.getTimeOpType() == 2)?"":"style=\"display:none\""%>><input class="TEXTBOX" type="text" name="<%=PREFIX %>TimeText2" size="3" value="<%=timeunit%>" onfocus="document.reportGenerationForm.<%=PREFIX %>TimeUnitRadio.checked=true" style="font-size: 8pt">
																		<select class="TEXTBOX" size="1" name="<%=PREFIX %>TimeUnit2"
																						onfocus="document.reportGenerationForm.<%=PREFIX %>TimeUnitRadio.checked=true" style="font-size: 8pt">
																			<option value="<%=PREFIX %>days" <%=daystatsel2%>>days</option>
																			<option value="<%=PREFIX %>weeks" <%=weekstatsel2%>>weeks</option>
																			<option value="<%=PREFIX %>months" <%=monthstatsel2%>>months</option>
																		</select>
																		</div>
																		<div id="<%=PREFIX %>timeType3Div" <%=(datefl.getTimeOpType() == 3)?"":"style=\"display:none\""%>><input class="TEXTBOX" type="text" name="<%=PREFIX %>TimeText3" size="3" value="<%=timeunit%>" onfocus="document.reportGenerationForm.<%=PREFIX %>TimeUnitRadio.checked=true" style="font-size: 8pt">
																		<select class="TEXTBOX" size="1" name="<%=PREFIX %>TimeUnit3"
																						onfocus="document.reportGenerationForm.<%=PREFIX %>TimeUnitRadio.checked=true" onchange="javascript:showFromInfo()" style="font-size: 8pt">
																			<option value="<%=PREFIX %>hours" <%=hourstatsel3%>>hours</option>
																			<option value="<%=PREFIX %>days" <%=daystatsel3%>>days</option>
																		</select> <span class="SMALLTEXT"> ago </span>
																		</div>
																	</td>
																	<td width="160">
																		<div id="<%=PREFIX %>fromLastDaysAtDiv" <%=(datefl.getTimeOpType() == 3)?"":"style=\"display:none\""%>><span class="SMALLTEXT">at</span>
																		<input class="TEXTBOX" type="text" name="<%=PREFIX %>fromLastDaysAt" size="8" value="<%=fromlastdaysat%>" onfocus="document.reportGenerationForm.<%=PREFIX %>TimeUnitRadio.checked=true" style="font-size: 8pt"> <span class="SMALLTEXT"><span
																					class="SMALLTEXT" style="height:1">(<%=timeFormat%>)</span>
																		</div>
																	</td>
																	<td width="*" align="left">
																		<div id="<%=PREFIX %>timeWindowSizeDiv" <%=(datefl.getTimeOpType() == 3)?"":"style=\"display:none\""%>><span class="SMALLTEXT">for</span>
																		<input class="TEXTBOX" type="text" name="<%=PREFIX %>TimeWindowText" size="3" value="<%=timeWindowSize%>" onfocus="document.reportGenerationForm.<%=PREFIX %>TimeUnitRadio.checked=true" style="font-size: 8pt">
																		<select class="TEXTBOX" size="1" name="<%=PREFIX %>TimeWindowUnit" onfocus="document.reportGenerationForm.<%=PREFIX %>TimeUnitRadio.checked=true"  style="font-size: 8pt">
																			<option value="hours" <%=hourswindowsizesel%>>hours</option>
																			<option value="days" <%=dayswindowsizesel%>>days</option>
																		</select>
																		</div>
																	</td>
																</tr>
															</table>
														</td>
													</tr>
												</table>
												</div>
											</td>
										</tr>														
									</table>
								</td>
							</tr>
						</table>
					</td>
	<%
				}
			}
	%>
				</tr>
	<%
		}
	}
	%>
	<tr valign="bottom">
		<td colspan="2">
			<input type="hidden" id="<%=PREFIX %>needsUserInput" name="<%=PREFIX %>needsUserInput" value="<%=report.isNeedsUserInput() || needsUserInput %>">
			<a href="javascript:changeShow()"><img src="<%=baseDir %>images/portal/btns/wizard/<%=report.isNeedsUserInput() || needsUserInput ? "" : "dont-" %>show.gif" border="0" id="showImage"></a>
			<span class="REGULARTEXT">Always show this page when generating</span>
		</td>
	</tr>
</table>