<%@ page language="java"%>

<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
  String ERROR_OBJ = "ERROR_OBJ";
  ErrorModel errmodel = new ErrorModel();

  String reportId = request.getParameter("reportId");
  String executableStr = request.getParameter("executable");
	boolean executable = executableStr != null && executableStr.equals("true");
	ReportsManager reportMgr = ReportsManager.getInstance();
  
  Report report = reportId == null || reportId.length() == 0 ? null : reportMgr.getReportById(reportId);
 
  if(report == null){
    errmodel.addError("No report was supplied.");
  }

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("../common/errorpage.jsp");
    return;
  }
  String genURL = report.getGenerateUrl();
  if (genURL == null || genURL.length() == 0){
  	genURL = "reports/reportRuntimeGenerate.jsp?reportId=[REPORT_ID]";
  }
  genURL = genURL.replaceAll("\\[REPORT_ID\\]",reportId);
  genURL = BASE_DIRECTORY + genURL;
  genURL += "&executable=" + executable;
  response.sendRedirect(genURL);

%>


