<%@ page language="java"%>

<%@page import="xpolog.eye.reports.ReportsManager"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.reports.ReportRuntimeWrapper"%>
<%@page import="xpolog.eye.reports.ReportRuntime"%>
<%@page import="xpolog.eye.reports.Report"%>
<%@page import="xpolog.eye.meta.MetaDataManager"%>
<%@page import="xpolog.eye.SiteManagment"%>
<%@page import="xpolog.eye.XpoLogObjectTypes"%>
<%@page import="java.util.HashSet"%>
<%@page import="java.util.Iterator"%>
<%@page import="xpolog.eye.meta.MetaData"%>
<%@page import="java.util.Date"%>
<%@page import="xpolog.config.Configuration"%>
<%@page import="java.text.SimpleDateFormat"%>

<%
  
  String BASE_DIR = "base_directory";
	String baseDir = request.getParameter(BASE_DIR);
	if (baseDir == null || baseDir.equals("")) {
		baseDir = "";
	}
	UserContext userContext = UserEnvironment.getUserContext(request);
  ReportsManager reportMgr = ReportsManager.getInstance(); 
  MetaDataManager metaDataMgr = SiteManagment.getInstance().getMetaDataMgr();

  ReportRuntimeWrapper []runtimeWrapperArr = reportMgr.getLastReportsRuntimes(userContext,10,true);
  
%>
<script>

	 function closeReportsView(){
	 	document.getElementById("showViewedReportsDiv").style.display = "none";
	 	document.getElementById("showViewedReportsFrame").style.display = "none";
	 }
	 
	 function viewResult(url){
  	path = "<%=baseDir%>" + url;
  	document.location = path;
  }
	
</script>
<div id="showViewedReportsDiv" class="PORTAL_TABLE_BORDER" style="position:absolute;width:550px;display:none;z-index:110">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" bgcolor="white">
  <tr>
		<td>
			<table border="0" cellpadding="0" cellspacing="0" width="100%">
				<tr>
					<td align="center" height="30" bgcolor="#CCCCCC">
							<span style="font-family: verdana;font-size:14;font-weight: bold;">Reports view</span>
					</td>
				</tr>
			</table>
	</td>
  </tr>
  <tr>
  	  <td>	
 	 	  <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" >
 	 	  <%if(runtimeWrapperArr == null || runtimeWrapperArr.length == 0){ %>
 	 	  <tr> 	 	  		
 	 	  		<td>
 	 	  			<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" >
			 	 	  <tr height="6px" style="font-size:1">
			 	 	  		<td>&nbsp;</td>
			 	 	  </tr>			 	 	  
			 	 	  <tr>
			 	 	  		<td>
			 	 	  		<span class="HEADER">&nbsp;&nbsp;&nbsp;No reports were created.</span>
			 	 	  		<td>
			 	 	  </tr>
				 	</table>
			  	</td>
			 </tr> 	
			  <%}else{
			  	String format = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
	        SimpleDateFormat dateFormat = new SimpleDateFormat(format);
	        int indx = 1;
				for(int i = 0 ; i < runtimeWrapperArr.length && i < 10 ;i++){
					ReportRuntimeWrapper runtimeWrapper = runtimeWrapperArr[i];
					Report report = runtimeWrapper.getReport();
					ReportRuntime runTime =  runtimeWrapper.getRuntime();
					if(report == null || runTime == null){
						continue;
					}
					String generationTime = runTime.getRunningTime() == -1? "" : dateFormat.format(new Date(runTime.getRunningTime()));
				  String viewUrl = report.getResultUrl();
					if (viewUrl != null){
					  viewUrl = viewUrl.replaceAll("\\[REPORT_ID\\]",report.getId());
					  viewUrl = viewUrl.replaceAll("\\[REPORT_RUNTIME_ID\\]",runTime.getId());
					}
					String applicationName = "";					
				  HashSet mds = metaDataMgr.getMetaDatasByXplgObject(XpoLogObjectTypes.REPORT_TYPE,report.getId());
				  if(mds != null) {
						Iterator it = mds.iterator();
						MetaData md = null;
						while(it.hasNext()) {
							md = (MetaData)it.next();							
						}
						applicationName = md.getApplication();
					}
					String displayName = "";
					if(applicationName == null || applicationName.length() == 0 ){
						displayName = report.getReportName();
					}else{
						displayName = applicationName + ": " + report.getReportName();
					}
					String fullDispalyName = displayName;
					displayName = displayName != null && displayName.length() > 45 ? displayName.substring(0,20) + ">...>" + displayName.substring(displayName.length() - 20 , displayName.length()) : displayName;
				
			  %>
			  <tr>
			  <td>
 	 	  			<table border="0" width="100%" cellspacing="0" height="20px" cellpadding="0" align="left">
			 	 	  <tr>			 	 	  		
			 	 	  		<td width="25px">
			 	 	  			<span style="color:#6A78DB;font-size:14;font-family:verdana;"><b>&nbsp;<%=indx++%>.</b></span>
			 	 	  		</td>
			 	 	  		<td width="380px">
				 	 	  		<b><a href="javascript:viewResult('<%=viewUrl%>')" class="LINK" title="<%=fullDispalyName %>"><%=displayName%></a></b>
			 	 	  		</td>
			 	 	  		<td width="16px">&nbsp;</td>			 	 	  		
			 	 	  		<td width="150px">
			 	 	  			<b><a href="javascript:viewResult('<%=viewUrl%>')" style="font-size:11;font-family:verdana;"><%=generationTime%></a></b>
			 	 	  		</td>
			 	 	  </tr>
				 	</table>
				</td>
			  </tr>
			  <%}} %> 	 	
		 </table>
      </td>
  </tr>
  <tr>
		<td>
			<table border="0" cellpadding="0" cellspacing="0" width="100%">
				<tr>			 	 	  		
			 	 	<td width="100%" align="middle">
			 	 		<a class="PROGRESSLINK" href="javascript:closeReportsView();">close</a>&nbsp;<nobr>
			 	 	</td>
			 	  </tr>
			 	  <tr height="3px" style="font-size:1">
 	  				 	 	<td width="100%">&nbsp;</td>			 	 			 	 	  		
			 	  </tr>
			</table>
	</td>
  </tr>
</table>
</div>
<iframe id="showViewedReportsFrame" src="<%=baseDir%>empty.html"  style="position:absolute;width:550px;height:5px;display:none;z-index:100" ></iframe> 