<%@ page language="java"%>

<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.scheduler.MultiScheduledOperation"%>
<%@ page import="xpolog.eye.scheduler.XpoScheduledOperation"%>
<%@ page import="xpolog.eye.scheduler.ui.JobBuilder"%>
<%@ page import="xpolog.eye.scheduler.ui.MultiJobBuilder"%>
<%@ page import="xpolog.eye.scheduler.ui.SchedulerHelper"%>

<%@ page import="java.util.LinkedList"%>
<%@ page import="java.util.List"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
	String suffix = request.getParameter("suffix");
	String indexToRemoveStr = request.getParameter("indexToRemove");
	int indexToRemove = -1;
	if (indexToRemoveStr != null && indexToRemoveStr.length() > 0){
		try{
			indexToRemove = Integer.parseInt(indexToRemoveStr);
		}catch(Exception e){
		}
	}
	ErrorModel errmodel = new ErrorModel();
	XpoScheduledOperation schedOp = SchedulerHelper.createMultiScheduledOperation(request,suffix,errmodel,false);
	JobBuilder jobBuilder = null;
	int numSchedulers = 0;
	if (errmodel.getErrorCount() == 0){
		if (schedOp instanceof MultiScheduledOperation){
			MultiScheduledOperation multi = (MultiScheduledOperation)schedOp;
			List schedOps = multi.getSchedOps();
			if (schedOps == null){
				schedOps = new LinkedList();
			}
			numSchedulers = schedOps.size();
			if (indexToRemove != -1){
				numSchedulers = schedOps.size()-1;
			}
			jobBuilder = new MultiJobBuilder(schedOps);
			jobBuilder.updateFromOp();
			request.getSession().setAttribute("CURRENT_JOB",jobBuilder);
		}else{
			numSchedulers = 1;
		}
	}

	StringBuffer result = new StringBuffer();
	result.append("<root>");
	result.append("<result>");
	if (errmodel.getErrorCount() == 0){
		result.append("OK");
		result.append("<numSchedulers>");
		result.append(numSchedulers);
		result.append("</numSchedulers>");
		result.append("</result>");
	}else{
		result.append("ERROR");
		result.append("</result>");
	}
	result.append("</root>");
	
	request.setAttribute("CURRENT_JOB",jobBuilder);
	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	out.write(result.toString());
	out.flush();
%>