<%@ page language="java"%>

<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>
<%	
    UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	SchedulingMgr sched = XpoLogScheduleFactory.getSchdulingManager();
	 
	String id = null;
	String type = null;
	
	id = request.getParameter("ID");
	type = request.getParameter("TYPE");
	
	ErrorModel errmodel = new ErrorModel();

	if(id == null){
		errmodel.addError("Please supply Id for the Operation to delete.");
	}
	if(errmodel.getErrorCount() > 0){
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		return;
	}
	 //audit
    String auditName = "";
	XpoScheduledOperation op = sched.getScheduedOp(id);
	if(op != null) {
		XpoJobDetails job = op.getDetails();
		if(job != null) {
			auditName = job.getName(); 
		}
	}   
    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
    			userContext, AuditConstants.CHANGE, "remove job", AuditConstants.JOBS, "remove job " + auditName);


	
	sched.removeScheduleOp(id,userContext);
	response.sendRedirect("viewjobaction.jsp?TYPE=" + type);
%>