<%@ page language="java"%>

<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="org.w3c.dom.*"%>
<%@page import="xpolog.eye.common.JobStatus"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>

<%	
    UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	final SchedulingMgr sched = XpoLogScheduleFactory.getSchdulingManager();
  final UserEnvironment env = UserEnvironment.getUserEnvironment(request);	 
	final String id = request.getParameter("ID");
	final String type = request.getParameter("TYPE");
	
	ErrorModel errmodel = new ErrorModel();

	if(id == null){
		errmodel.addError("Please supply Id for Operation to run.");
	}
	if(errmodel.getErrorCount() > 0){
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		return;
	}
	
	
		  //audit
		  String auditName = "";
		  XpoScheduledOperation opr = null;
		  XpoJob xpoJob = null;
		  try{
		  	opr = sched.getScheduedOp(id);
		  }catch(Exception e){};
		if(opr != null) {
			XpoJobDetails job = opr.getDetails();
			if(job != null) {
				auditName = job.getPresName();
				xpoJob = job.createXpoJob();
			}
		}
		  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		  			userContext, AuditConstants.CHANGE, "execute job manually", AuditConstants.JOBS, "execute job manually " + auditName);

			if(xpoJob != null){
				JobStatus status = xpoJob.getStatus();
			  env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, status);
			}
		final XpoJob job = xpoJob;
		  
	ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "scheduler/viewjobaction.jsp?TYPE=" + type) {
		public void run(HttpServletRequest request) {
			XpoScheduledOperation op = null;
			try{
				long start = System.currentTimeMillis();
				op = sched.getScheduedOp(id);
				XpoJobDataMap map = op.getDetails().getXpoJobDataMap();
				job.setConfiguration((Element)map.get(XpoJob.JOB_TAG));
				job.setIgnoreMasterOnly(true);
				job.execute();
	    	long end = System.currentTimeMillis();
	    	if (end-start < 1000){
	    		try{
	    			Thread.sleep(500);
	    		}catch(Exception e){
	    		}
	    	}

			}catch(Exception e){
        errmodel.addError("Failed run job manually.");
  			errmodel.addError(e.getMessage());
        createErrorRedirect(request,BASE_DIRECTORY);
			}
		}
	};
	
	
  env.setProgressRunner(runner);
%>
<jsp:include page="../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Running task"/>
  <jsp:param name="useStatus" value="true"/>
</jsp:include>	