<%@ page language="java"%>

<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%@ page import="xpolog.eye.error.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>
<%
    UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	SchedulingMgr sched = XpoLogScheduleFactory.getSchdulingManager();
	 
	String id = null;
	String type = null;
	String op = null;
	
	id = request.getParameter("ID");
	type = request.getParameter("TYPE");
	op = request.getParameter("OP");
	ErrorModel errmodel = new ErrorModel();

	if(id == null){
		if(op.equals("1")){
			errmodel.addError("Please supply Id for Operation to activate.");
		}else{
			errmodel.addError("Please supply Id for Operation to suspend.");
		}
	}
	if(errmodel.getErrorCount() > 0){
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		return;
	}
    XpoScheduledOperation operation = sched.getScheduedOp(id);
    if(op.equals("1")){
		sched.scheduleXpoOp(operation);
		operation.setLastChanged(System.currentTimeMillis());
		sched.saveSchduleder();
	}else if(op.equals("2")){
		sched.unScheduleXpoOp(operation);
		operation.setLastChanged(System.currentTimeMillis());
		sched.saveSchduleder();
	}
    
    //audit
    String auditName = "";
	if(operation != null) {
		XpoJobDetails job = operation.getDetails();
		if(job != null) {
			auditName = job.getName();
		}
	}
    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
    			userContext, AuditConstants.CHANGE, "change job state", AuditConstants.JOBS, "change job state " + auditName);

    
	response.sendRedirect("viewjobaction.jsp?TYPE=" + type);
%>