<%@ page language="java"%>

<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.scheduler.ui.*"%>
<%@ page import="xpolog.eye.verifiers.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%
  final String BASE_DIRECTORY = "../";
%>
<% 
	String ID = "ID";
	String ERROR_OBJ = "ERROR_OBJ";
	String id = request.getParameter(ID);
	String empty = "";
	String name = empty;
	String description = empty;
	String state = empty;
	
	String verifId = empty;
	
  UserContext userContext = UserEnvironment.getUserContext(request);

	VerifierManager verMgr = SiteManagment.getInstance().getVerifierManager();
	Verifier[] varr = verMgr.getAllVerifiers(userContext,false);	
	if(varr == null || varr.length==0 || (varr.length == 1 && varr[0].getId().equals("rootVerifier"))) {		
		//No verifiers defined in system
	  	ErrorModel errmodel = new ErrorModel();
	  	errmodel.addError("The only existing monitor is the root monitor, Please <a href=\"" + BASE_DIRECTORY + "verifiers/VerifierGate.jsp\">create a monitor</a> first.");
	  	request.getSession().setAttribute(ERROR_OBJ,errmodel);
	    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
	    return;
	}
	
	VerifierJobBuilder job = null;
	
  	if(id != null){
  		SchedulingMgr smgr = XpoLogScheduleFactory.getSchdulingManager();
  		XpoScheduledOperation op = smgr.getScheduedOp(id);
  		job = new VerifierJobBuilder(op);
  		job.updateFromOp();
  		name = job.getName();
  		description = job.getDescription();
  		id = job.getId();
  		verifId = job.getVerfierId();
  	}else{
  		job = new VerifierJobBuilder();
  	}
  	 state = job.getState();
  	 request.setAttribute("CURRENT_JOB",job);
  	 request.setAttribute("CURRENT_ID",id);
%>

<html>

<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
      function doSave(){
        document.access.action ="jobVerifierAction.jsp";
        document.access.submit();
      }
      

</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="33%" class="TOPBORDER">
                <span class="PAGEHEADER">Monitoring Job</span> </td>
                <td width="44%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%" >&nbsp;</td>
                <td colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
                  <tr>
                    <td width="15%"><span class="HEADER">Job </span><span class="HEADER">details</span></td>
                  </tr>
                  <tr>
                    <td width="15%"><span class="SMALLRTEXT">&nbsp;</span></td>
                  </tr>
                  <tr>
                    <td width="15%" >
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">Name</span></td>
                        <td width="69%">
                        <input class="TEXTBOX" type="text" name="Name" size="50" value="<%=name%>"></td>
                      </tr>
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">Description</span></td>
                        <td width="69%">
                        <input class="TEXTBOX" type="text" name="Description" size="50" value="<%=description%>"></td>
                      </tr>
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">Monitor</span>&nbsp;</td>
                        <td width="69%">
                        <input class="TEXTBOX" type="hidden" name="Id" size="10" value="<%=id%>">
                        <input class="TEXTBOX" type="hidden" name="State" size="10" value="<%=state%>">
                        <select class="TEXTBOX" size="1" name="verifierId"> 
                        	<%
                        	String sel = "";
                        	boolean checkId = true;
                        	if(verifId == null || verifId.equals("")){
                        		checkId = false;
                        	}
                        	for(int i=0;i<varr.length;++i){
                        		sel = "";
                        		if(checkId){
                        			if(varr[i].getId().equals(verifId)){
                        				sel = "selected";
                        			}
                        		}
                        	%>
                        		<option <%=sel%> value="<%=varr[i].getId()%>" ><%=varr[i].getName()%></option>
                        	<%
                        	}
                        	%>
                        </select></td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td><span class="SMALLRTEXT">
                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                       <tr>
                         <td><span class="REGULARTEXT"><input type="checkbox" name="rootTasks" value="ON" <%=(job.isGenerateTasks() ? "checked" : "")%> ></span> 
                          </td>
                          <td width="100%"><span class="REGULARTEXT">&nbsp;Activate root tasks</span></td>
                        </tr>
                        <tr>
                          <td><span class="REGULARTEXT"><input type="checkbox" name="childTasks" value="ON" <%=(job.isGenerateChildTasks() ? "checked" : "")%> ></span> 
                          </td>
                          <td width="100%"><span class="REGULARTEXT">&nbsp;Activate children tasks</span></td>
                        </tr>
                      </table>

                    </span></td>
                  </tr>
                  <tr>
                    <td width="15%"> <span class="SMALLRTEXT">&nbsp;</span></td>
                  </tr>
                  <tr>
                    <td><span class="HEADER"> Schedule Information</span></td>
                  </tr>
                  <tr>
                    <td width="15%"> <span class="SMALLRTEXT">&nbsp;</span></td>
                  </tr>
                  <tr>
                    <td><span class="REGULARTEXT"><%@ include file="schedule.jsp"%></span></td>
                  </tr>
                  <tr>
                    <td >
                    <font size="2">&nbsp; </font>
                    </td>
                  </tr>
                  <tr>
                    <td height="24">
                    &nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td height="26">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="101%" id="AutoNumber17">
                      <tr>
                        <td width="25%">&nbsp;</td>
                        <td width="13%">
                        <p align="center">&nbsp;</td>
                        <td width="11%"><a href="javascript:history.go(-1)" class="LINK">cancel</a></td>
                        <td width="11%"><a href="javascript:doSave()" class="LINK">save</a></td>
                        <td width="35%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>