<%@ page language="java"%>

<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.scheduler.ui.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>
<%
	
	String ERROR_OBJ = "ERROR_OBJ";
    UserContext userContext = UserEnvironment.getUserContext(request);
	String name,description,id,verId,iterNumber,intervalTimeUnit,startDate;
	String endDate,interTime;
	String hours,minutTens,minutUnit,secTen,secUnit,trigType,timeType;
	String typeDay;
	String[] montharr,daywarr,dayInMonarr;
	String state;
	String hoursInterval,minutesInterval;
	
	name = request.getParameter("Name");
	description = request.getParameter("Description");
	id = request.getParameter("Id");
	verId = request.getParameter("verifierId");
    String rootTasks = request.getParameter("rootTasks");
	String childTasks = request.getParameter("childTasks");
	state = request.getParameter("State");
	
	boolean generateEvents = (rootTasks != null);
	boolean generateChildEvents = (childTasks != null);
	
	startDate = request.getParameter("startDate");
	endDate = request.getParameter("endDate");
	intervalTimeUnit = request.getParameter("intervalTimeUnit");
	iterNumber = request.getParameter("iterationNumber");
	interTime = request.getParameter("intervalTime");
	daywarr = request.getParameterValues("dayw");
    
   	montharr = request.getParameterValues("Month");
   	dayInMonarr =request.getParameterValues("DayInMonth");
   	hours = request.getParameter("Hours");
	minutTens = request.getParameter("minutesTens");
	minutUnit = request.getParameter("minutesUnit");
	secTen = request.getParameter("secondTen");
	secUnit = request.getParameter("secondUnit");
	trigType = request.getParameter("trigType");
	typeDay = request.getParameter("typeDay");
	hoursInterval = request.getParameter("hoursInterval");
	minutesInterval = request.getParameter("minutesInterval");
	
	ErrorModel errmodel = new ErrorModel(); 
	if(name == null || name.equals("")){
    	errmodel.addError("No Name was supplied.");
  	}
  	if(trigType == null || trigType.equals("")){
  		errmodel.addError("Please specify scheduling method");
  	}
  	
  	if(trigType != null && trigType.equals("simple")){
	  	if(interTime == null || interTime.equals("")){
	    	errmodel.addError("Please specify interval period");
	  	}
	  	try{
			int i = Integer.parseInt(interTime);
			if(i <=0){
				errmodel.addError("Please specify a positive interval period");
			}
	  	}catch(Exception ie){
	  		errmodel.addError("Interval period must be a valid positive number");
	  	}
	}
  	if(trigType != null && trigType.equals("cron")){
	  	if(typeDay == null || typeDay.equals("")){
	    	errmodel.addError("Please specify schedule details");
	  	}else{
	  		
	  		if(typeDay.equals("dayOWeek") && (daywarr == null || daywarr.length == 0)){
	  			errmodel.addError("Please specify days in week");
	  		}else if(typeDay.equals("dayOMon")){
	  			if(dayInMonarr == null || 
	  				dayInMonarr.length == 0 || 
	  				montharr == null || 
	  				montharr.length == 0){
	  				errmodel.addError("Please specify months and days");
	  			}
	  		
	  		}
	  	}
	}
	
  	if(errmodel.getErrorCount() != 0){
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
  	}
  	
  	
  	VerifierJobBuilder builder = new VerifierJobBuilder();
  	builder.setId(id);
  	builder.setName(name);
  	builder.setDescription(description);
    builder.setVerfierId(verId);
    builder.setGenerateTasks(generateEvents);
    builder.setGenerateChildTasks(generateChildEvents);
    builder.setState(state); 
    builder.setStartDate(startDate);
    builder.setEndDate(endDate);
    
    //simple or cron
    if(trigType.equals("simple")){
    	builder.setSimple(true);
    	builder.setIntervalTime(interTime);
    	builder.setIntervalTimeUnit(intervalTimeUnit);
    	builder.setIterationNumber(iterNumber);
    }else if(trigType.equals("cron")){
    	builder.setCron(true);
    	
    	if(typeDay.equals("dayOWeek")){
    		builder.setDayType(JobBuilder.DAY_OF_WEEK);	
    	    Integer[] darr = new Integer[daywarr.length];
    	    for(int i=0;i<darr.length;++i){
    	    	darr[i] = new Integer(daywarr[i]);
    	    }
    		builder.setDays(darr);
    	}else if(typeDay.equals("dayOMon")){
    		builder.setDayType(JobBuilder.DAY_OF_MONTH);
    		Integer[] darr = new Integer[dayInMonarr.length];
    		
    	    for(int i=0;i<darr.length;++i){
    	    	if(dayInMonarr[i].equals("all")){
    	    		builder.setAllDayInMonth(true);
    	    		darr = new Integer[0];
    	    		break;
    	    	}
    	    	darr[i] = new Integer(dayInMonarr[i]);
    	    }
    		builder.setDayInMonth(darr);
    		Integer[] marr = new Integer[montharr.length];
    	    for(int i=0;i<marr.length;++i){
    	    	if(montharr[i].equals("all")){
    	    		builder.setAllMonth(true);
    	    		marr = new Integer[0];
    	    		break;
    	    	}
    	    	marr[i] = new Integer(montharr[i]);
    	    }
    		builder.setMonth(marr);
    	}
    	
    	builder.setHours(hours);
    	builder.setMinutesTen(minutTens);
    	builder.setMinuteUnit(minutUnit);
    	builder.setSecondTen(secTen);
    	builder.setSecondUnit(secUnit);
    	
    	builder.setMinutesInterval(minutesInterval);
 		  builder.setHoursInterval(hoursInterval);
 		  if(minutTens.equals("0") && minutUnit.equals("0") && minutesInterval.equals("1")){
 			  builder.setEveryMinute(true);
 		  }
 		  if(hours.equals("0") && hoursInterval.equals("1")){
 			  builder.setEveryHour(true);
 		  }
    }
  	
    String did = builder.getId();
    boolean isNew = (did == null || did.equals("") || did.equals("null"));
    XpoScheduledOperation ops = null;
    try {
      ops = builder.buildXpoSchedOp();
    }catch (IllegalArgumentException e){
    	errmodel.addError(e.getMessage());    	
    }catch (Exception e1){
    	errmodel.addError("Invalid time rule. Please make sure the time rule is valid and try again"); 
    }
    if(errmodel.getErrorCount() != 0){
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
  	}
    
    ops.setExternal(false);
	SchedulingMgr mgr = XpoLogScheduleFactory.getSchdulingManager();
	if (isNew){	
		mgr.putXpoScheduledOp(ops,userContext);
	}else{
		mgr.putXpoScheduledOp(ops);
	}
  	
    //audit
    String auditName = "";
	if(ops != null) {
		XpoJobDetails job = ops.getDetails();
		if(job != null) {
			name = job.getName();
		}
	}
    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
    			userContext, AuditConstants.CHANGE, "add verifier job", AuditConstants.JOBS, "add verifier job " + auditName);
	
	
	response.sendRedirect("jobsview.jsp?jobType=verifier");
%>