<%@ page language="java"%>

<%@ page import="xpolog.eye.scheduler.*"%>

<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.AutomationPermissions.SCHEDULER_PERMISSION,true)){
    return;
  }

  JobFilter filter = new JobFilter("op"); 

  SchedulingMgr schmgr = XpoLogScheduleFactory.getSchdulingManager();
  UserContext userContext = UserEnvironment.getUserContext(request);
  List list = schmgr.getXpoOpslByFilter(filter,userContext);
%>

<html>

<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
  function goEdit(id){
  	path = "jobAction.jsp?ID="+id;
  	document.location = path;
  }
  
  function goNew(){ 
  	path = "jobAction.jsp?JOB_TYPE=op";		
  	document.location = path;
  }
  
  function doDelete(id){
    path = "jobRemoveAction.jsp?ID=" + id + "&TYPE=op";	
  	document.location = path;
  }
  
  function goRun(id){
  	path = "jobRunAction.jsp?ID=" + id + "&TYPE=op";	
  	document.location = path;
  }
  function setState(id,op){
  	path = "jobStateAction.jsp?ID=" + id+ "&OP=" + op + "&TYPE=op";	
  	document.location = path;
  }
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
  <!--    <tr>
        <td valign="top" style="border-left: 1px solid #FF9900; border-right-width: 1; border-top-width: 1; border-bottom-width: 1" height="1">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="TOPLEFTBORDER " width="33%"  height="2"></td>
            <td class="TOPBORDER" width="33%" height="2"></td>
            <td class="TOPRIGHTBORDER"  width="34%" height="2"></td>
          </tr>
        </table>
        </td>
      </tr>-->
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Scheduler</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td>
                      <p align="left"><span class="REGULARTEXT"><a href="javascript:goNew()" class="LINK">Add new
                      Job</a></span></p>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr class="TABLES_HEADERS">
                        <td width="18%"><span class="REGULARTEXT">Name</span></td>
                        <td width="35%"><span class="REGULARTEXT">Description</span></td>
                        <td width="15%"><span class="REGULARTEXT">Status</span></td>
                        <td width="20%" nowrap>&nbsp;</td>
                        <td width="3%"></td>
                      </tr>
                     <%
                      XpoScheduledOperation sop = null;
                      String funcAct = "1";
                      String funcSus = "2"; 
                      String funcAtt = ""; 
                      String funcStrAct = "activate"; 
                      String funcStrSus = "suspend"; 
                      String funcStr = ""; 
                      String stateStrActive = "Active"; 
                      String stateStrSuspend = "Suspended"; 
                      String stateStr = ""; 
                      for(int t=0;t<list.size();t++){
	                      sop = ((XpoScheduledOperation)list.get(t));
	                      XpoJobDetails det = sop.getDetails();
	                      boolean active = sop.isActive();
	                      if(active){
	                      	stateStr = stateStrActive;
	                      	funcStr = funcStrSus;
	                      	funcAtt = funcSus;
	                      }else{
	                      	stateStr = stateStrSuspend;
	                        funcStr = funcStrAct;
	                      	funcAtt = funcAct;
	                      }
                     %>
                      <tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
			  <td width="18%"><a href="javascript:goEdit('<%=det.getId()%>')" class="LINK"><%=det.getPresName()%></a></td>
                          <td width="35%"><span class="REGULARTEXT"><%=det.getDescription()%></span></td>
                          <td width="15%"><span class="REGULARTEXT"><%=stateStr%></span></td>
                          <td width="20%" nowrap><a href="javascript:setState('<%=det.getId()%>',<%=funcAtt%>)" class="LINK"><%=funcStr%></a>&nbsp;<a href="javascript:goEdit('<%=det.getId()%>')" class="LINK">edit</a>&nbsp;
                            <a href="javascript:goRun('<%=det.getId()%>')" class="LINK">run</a>
                            &nbsp;<a href="javascript:doDelete('<%=det.getId()%>')" class="LINK">delete</a></td>
                        <td width="3%"></td>
                       </tr>
                      <%
                        }
                      %>
                        <tr>
			              <td width="18%">&nbsp;</td>
                          <td width="35%"></td>
                          <td width="15%"></td>
                          <td width="15%"></td>
                          <td width="20%" nowrap></td>
                         <td width="3%"></td>
                       </tr>
                    </table>
                   </td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="41%">&nbsp;</td>
                    <td width="11%" align="center"><a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK">
                    cancel</a></td>
                    <td width="7%" align="center"></td>
                    <td width="21%">&nbsp;</td>
                    <td width="20%">&nbsp;</td>
                  </tr>
                </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>