var previousLocationType = "";

function changeLocationType(accountsPrefix,accountTypeSelectName,baseDirectory){
	clearFormError(PREFIX + "locationType", PREFIX+"locationTypeErrorMsg");
	var locationType = eval("document.access." + PREFIX + "locationType").value;
	var accountsElem = document.getElementById(PREFIX+"accountDiv");
	var locationsDiv = document.getElementById(PREFIX+"locationPathsDiv");
	var advancedSettingsDiv = document.getElementById(PREFIX+"advancedSettingsDiv");
	if(locationType == "none"){
		accountsElem.style.display = "none";
		clearAccountsList(accountsPrefix);
		locationsDiv.style.display = "none";
		if(advancedSettingsDiv) {
			advancedSettingsDiv.style.display = "none";
		}
	}else if(locationType == "local"){		
		accountsElem.style.display = "none";		
		clearAccountsList(accountsPrefix);		
		locationsDiv.style.display = "";
		if(advancedSettingsDiv) {
			advancedSettingsDiv.style.display = "";
		}				
	}else{
		accountsElem.style.display = "";
		if(advancedSettingsDiv) {
			advancedSettingsDiv.style.display = "";
		}
		updateAccountsList(accountsPrefix,accountTypeSelectName,baseDirectory);
	}
	if(previousLocationType == "local") {
		if(locationType == "ssh") {
			clearLocations();
		}
	}else if(previousLocationType == "auth") {
		if(locationType == "ssh") {
			clearLocations();
		}
	}else if(previousLocationType == "ssh") {
		if(locationType == "local" || locationType == "auth") {
			clearLocations();
		}
	}
	if(locationType != "none") {
		previousLocationType = locationType;
	}
}

function validateAccount() {
	var isOk = true;
	var locationType = document.getElementById(PREFIX + "locationType");
	if(locationType.value == "ssh") {
		var accountsList = document.getElementById(PREFIX + "AccountsList");
		if(accountsList.value == "" || accountsList.value == "none"){
			showFormError(PREFIX + "AccountsList", PREFIX+"AccountIdErrorMsg", "Account was not selected");
			isOk = false;
		}
	}
	
	return isOk;
}

function showHideLocationsPath(){
	if (typeof PREFIX != "undefined"){
		var locationTypeElem = eval("document.access." + PREFIX + "locationType");
		if (locationTypeElem){
			var locationType = locationTypeElem.value;
			var locationsDiv = document.getElementById(PREFIX+"locationPathsDiv");
			if(locationsDiv){
				locationsDiv.style.display = "";
			}
		}
	}
}



//BROWSER FUNCTION
function openBrowser(txtboxId,i,fileFilter){
//	document.getElementById(PREFIX+"advancedDiv").style.display  = "none";		
 	showHideSysFileInMiddle(150,200);
	var rootDir = document.getElementById(PREFIX+"fullPath_"+i).value;
	var accId = "";

	accId = "";
	//only if acc was selected
	var accountsElem = document.getElementById(PREFIX+"AccountsList");
	if(accountsElem){
		accId = accountsElem.value;
		if(accId == "none"){
			accId = "";
		}
	}
	loadSysFilesTree(rootDir,txtboxId,accId,fileFilter);
}

function doOpenBrowser(txtboxId,i,e,fileFilter){
	var result = checkKey(e);
   if (result){
       openBrowser(txtboxId,i,fileFilter);
    }
}

function clearLocations() {
	for(var loop = 0 ; loop < LOCATIONS_CNTR ; loop++){
		var pathElem = document.getElementById(PREFIX+"fullPath_" + loop);
		if(pathElem){
			pathElem.value = "";
		}
	}
}

function checkKey(e){
 	if (!e) var e = window.event;
	var code = e.keyCode;
	if (code == 13){
			return true;
	}
}