var progWriter;

function progressWriter(msgWriter,actionUrl,params,callback){
  this.msgWriter = msgWriter;
  this.actionUrl = actionUrl;
  this.params = params;
  this.startRunnerUrl = this.msgWriter.base_directory + "common/startProgressRunner.jsp";
  this.stopRunnerUrl = this.msgWriter.base_directory + "common/stopProgressRunner.jsp";
  this.getRunnerStatusUrl = this.msgWriter.base_directory + "common/getProgressRunnerStatus.jsp";
  this.callback = callback;
  this.executionResult = "";
  this.executionMessage = ""; 
  return this;
}

var count = 0;
progressWriter.prototype.checkProgressStatus=function(){
	sendAjaxRequest(this.getRunnerStatusUrl, function(req){
		var xmldoc = req.responseXML.documentElement;            	
		var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
		var message = xmldoc.getElementsByTagName('message')[0].text;
		if (!message && xmldoc.getElementsByTagName('message')[0].firstChild){
			message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
		}
		if (!message){
			message = "Processing";
		}
    count++;
    dots = (count % 5);
    dotsStr = "";
    for (var i = 0; i <= dots;i++){
      dotsStr += ".";
    }
    message = message + dotsStr;
		progWriter.msgWriter.showMessage(message);
	},'POST',"");
}

var refreshStatusInterval;
progressWriter.prototype.run=function(){
	sendAjaxRequest(this.actionUrl, function(req){
		progWriter.runProgressRunner();
	},'POST',this.params);
	refreshStatusInterval = setInterval("progWriter.checkProgressStatus()",1000);
}

progressWriter.prototype.runProgressRunner=function(){
	sendAjaxRequest(this.startRunnerUrl, function(req){
		progWriter.stopProgressStatusCheck();
	    var xmldoc = req.responseXML.documentElement;            	
      var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
      var message = xmldoc.getElementsByTagName('message')[0].text;
      if (!message && xmldoc.getElementsByTagName('message')[0].firstChild){
      	message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
      }
      this.executionResult = result;
      this.executionMessage = message;
      if (typeof progWriter.callback == 'function'){
      	progWriter.callback(result,message);
      }
	},'POST',"");
}

progressWriter.prototype.stopProgressStatusCheck=function(){
	if (refreshStatusInterval){
		clearInterval(refreshStatusInterval);
	}
}

progressWriter.prototype.cancel=function(){
	sendAjaxRequest(this.stopRunnerUrl, function(req){
	},'POST',"");
}

