var applicationTabsArr = new Array();
var tabsInLine = 20;

function ApplicationTabs(id,selectedTabClass,tabClass,selectedLinkClass,linkClass){
  this.id = id;
  this.selectedTabClass = selectedTabClass;
  this.tabClass = tabClass;
  this.tabs = new Array();
  this.selectedTabIndex = -1;
  this.width = 50;
  if (linkClass){
  	this.linkClass = linkClass;
  }else{
  	this.linkClass = "LINK";
  }
  if (selectedLinkClass){
  	this.selectedLinkClass = selectedLinkClass;
  }else{
  	this.selectedLinkClass = "LINK";
  }
}

function Tab(id,name,divLink){
  this.id = id;
  this.name = name;
  this.divLink = divLink;
}

function addTab(id,name,divLink){
  this.tabs[this.tabs.length] = new Tab(id,name,divLink);
  return this.tabs[this.tabs.length - 1];
}

function writeTabs(){
  document.writeln("<table  width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><tr>");
  line = 0;
  var i = 0;
  for (i = 0; i < this.tabs.length; i++){
  	if (i > 0 && i % tabsInLine == 0){
		  document.writeln("</tr><tr>");
		  line++;
  	}
    document.writeln("<td id=\"" + this.id + "_" + this.tabs[i].id + "\" width=\"" + this.width + "\" class=\"" + this.tabClass + "\"><a id=\"" + this.id + "_a_" + this.tabs[i].id + "\" class=\"" + this.linkClass + "\" href=\"javascript:selectAppTabByIndex('"+ this.id + "'," + i + ")\">" + this.tabs[i].name + "</a></td>");
  }
  colspan = (line > 0 && i % tabsInLine != 0) ? "colspan=\""+(tabsInLine - (i%tabsInLine))+"\"" : "";
  document.writeln("<td "+colspan+" width=\"*\" >&nbsp;</td>");
  document.writeln("</tr> </table>");
}

function selectTabByIndex(tabIndex){
  if (this.selectedTabIndex >= 0){
    oldTab = this.tabs[this.selectedTabIndex];
    document.getElementById(this.id + "_" + oldTab.id).className = this.tabClass;
    document.getElementById(this.id + "_a_" + oldTab.id).className = this.linkClass;
    document.getElementById(oldTab.divLink).style.display = "none";
  }
  if (tabIndex >= 0){
    newTab = this.tabs[tabIndex];
    document.getElementById(this.id + "_" + newTab.id).className = this.selectedTabClass;
    document.getElementById(this.id + "_a_" + newTab.id).className = this.selectedLinkClass;
    document.getElementById(newTab.divLink).style.display = "";
    this.selectedTabIndex = tabIndex;
  }
}

ApplicationTabs.prototype.addTab = addTab;
ApplicationTabs.prototype.writeTabs = writeTabs;
ApplicationTabs.prototype.selectTabByIndex = selectTabByIndex;

function createApplicationTabs(id,selectedTabClass,tabClass,selectedLinkClass,linkClass){
  app = new ApplicationTabs(id,selectedTabClass,tabClass,selectedLinkClass,linkClass);
  applicationTabsArr[applicationTabsArr.length] = app;
  return app;
}

function createDefaultApplicationTabs(id){
  return createApplicationTabs(id,"APPLICATION_SELECTED_TABS","APPLICATION_TABS");
}

function selectAppTabByIndex(appTabsId,tabIndex){
  for (var i = 0; i < applicationTabsArr.length; i++){
    if (applicationTabsArr[i].id == appTabsId){
      applicationTabsArr[i].selectTabByIndex(tabIndex);
      return;
    }
  }
}
