
function isRemoteLeaf(){
  return this.childs.length == 0  && !this.actionUrl
}

function writeRemoteNodeData(node){ 
  if (!node.isLeaf()){
    var img = baseDirectory + (node.expand ? collapseImage : expandImage);  
    document.writeln("<img src=\"" + img + "\" onClick=\"javascript:selectNode(" + node.index + ")\" id=\"ExpandImage_" + this.name + "_" + node.index + "\"  class=\"" + node.tree.nodeImageStyle + "\">");
  }
  if (node.isLeaf()){
    document.writeln("<input type=\"radio\" name=\"" + node.chkKey + "\" value=\""+node.id +"\" id=\"CheckBox_" + this.name + "_" + node.index + "\"" + (node.selected ? " checked" : "") +  " onClick=\"javascript:markNode(" + node.index + ")\">");
  }
  document.writeln("&nbsp;" + node.name);
  if (node.desc && node.desc != ""){
     document.writeln("&nbsp;(" + node.desc + ")");
  }
  if (node.text && node.text != ""){
     document.writeln("&nbsp;" + node.text);
  }  
}


function addRemoteNode(parent,chkKey,id,name,desc,text,selected,expand,actionUrl,actionTarget){
  var node = this.addNode(parent,chkKey,id,name,desc,text,selected,expand,false);
  node.actionUrl = actionUrl;
  node.actionTarget = actionTarget;
  return node;
}

function selectRemoteTreeNode(node){
     if (node.childs.length > 0|| !node.actionUrl){
        var expand = !node.expand;	
	node.expand = expand;
	var expImage = document.getElementById("ExpandImage_" + node.tree.name + "_" + node.index);
	if (expImage){
	  expImage.src = baseDirectory + (expand ? collapseImage : expandImage);
	}
	for (var i = 0; i < node.childs.length; i++){
	  var childDiv = document.getElementById("DivNode_" + node.childs[i].tree.name + "_" + node.childs[i].index);
	  if (childDiv){
	    if (expand){
	      childDiv.style.display = "";
	    }else {
	      childDiv.style.display = "none";
	    }
	  }
	}
     }else {
     	eval("loadFrame('" + node.actionTarget + "','" +  node.actionUrl + "')");
     }	
	
	
}

function writeExternalNode(node){
  var d = document.getElementById("DivNode_" + node.tree.name + "_" + node.index);
  var result = writeExternalRemoteNodeData(node);
  for(var i = 0; i < node.childs.length;i++){
    result += writeExternalNode0(node.childs[i]);
  }
  d.innerHTML = result;
}


function writeExternalNode0(node){
  var result = "";
  var divStyle = node.parent.expand ? "" : " style=\"display:none\"";
  result +="<DIV class=" + (node.isLeaf() ? node.tree.nodeLeafStyle : node.tree.nodeStyle) +  " id=\"DivNode_" + node.tree.name + "_" + node.index + "\"" + divStyle +  ">";
  result += writeExternalRemoteNodeData(node);
  for(var i = 0; i < node.childs.length;i++){
    result += writeExternalNode0(node.childs[i]);
  }
  result += "</DIV>";
  return result;
}

function writeExternalRemoteNodeData(node){ 
  var result = ""
  if (!node.isLeaf()){
    var img = baseDirectory + (node.expand ? collapseImage : expandImage);  
    result += "<img src=\"" + img + "\" onClick=\"javascript:selectNode(" + node.index + ")\" id=\"ExpandImage_" + node.tree.name + "_" + node.index + "\"  class=\"" + node.tree.nodeImageStyle + "\">";
  }
  if (node.isLeaf() && !node.chkKey == ""){
    result += "<input type=\"radio\" name=\"" + node.chkKey + "\" value=\""+node.id +"\" id=\"CheckBox_" + node.tree.name + "_" + node.index + "\"" + (node.selected ? " checked" : "") +  " onClick=\"javascript:markNode(" + node.index + ")\">";
  }
  result += "&nbsp;" + node.name;
  if (node.desc && node.desc != ""){
     result += "&nbsp;(" + node.desc + ")";
  }
  if (node.text && node.text != ""){
     result += "&nbsp;" + node.text;
  } 
  return result; 
}

function loadFrame(frameId,frameUrl){
  document.getElementById(frameId).src = frameUrl;
}

Node.prototype.isLeaf = isRemoteLeaf;
Tree.prototype.writeNodeData = writeRemoteNodeData;
Tree.prototype.addRemoteNode = addRemoteNode;
Tree.prototype.selectTreeNode = selectRemoteTreeNode;