var showHelpFlag = true;
var date = new Date();
function openHelp(basedir,loc){
  page = basedir + "help/helpIndex.htm";
  if(loc){
    page = page + "?Location="+loc.replace(/#/,"%23")
  }
  help = window.open(page,"help",'width=750,height=550,status=no,scrollbars=yes,resizable=yes,top=100,left=100,dependent=yes,alwaysRaised=yes');
  help.focus();
}

function presentHelpDiv(img,baseDirectory,type,id,newSrc,helpDivId){
	var newSrcStr = baseDirectory + "help/images/question_mark_over.gif";
	if(newSrc && newSrc != '') {
    	newSrcStr=baseDirectory + newSrc;
    }
    img.src=newSrcStr;
    showHelp(baseDirectory,img,type,id,helpDivId);
}
function hideHelpDiv(img,baseDirectory,type,id,newSrc,helpDivId){
	showHelpFlag = false;
	var newSrcStr = baseDirectory + "help/images/question_mark.gif";
	if(newSrc && newSrc != '') {
    	newSrcStr=baseDirectory + newSrc;
    }
    img.src=newSrcStr;
    var divId = "helpMessageDiv";
    if(helpDivId && helpDivId != '') {
    	divId = helpDivId;
    }
	var div = document.getElementById(divId);
	if(!div) {
		divId = "helpMessageDiv";
		div = document.getElementById(divId);
	}
	if (div && div.style.visibility == ""){
      hideLayer(divId);
    }
}

var helpReq;
var helpParent;
var helpId;

function showHelp(baseDirectory,helpComp,type,id,helpDivId){
  showHelpFlag = true;
  var page = baseDirectory + "help/helpMessages/" + type + ".jsp?tstmp=" + date.getTime();
  helpReq = GetXmlHttpObject();
  if (!helpReq) return;
  helpParent = helpComp;
  helpId = id;
  helpReq.onreadystatechange = function(){
      if (helpReq.readyState == 4) {
         if (helpReq.status == 200) {    
           var xmldoc = helpReq.responseXML.documentElement;
           var helpArr = xmldoc.getElementsByTagName('Help');
           for (var i = 0; i < helpArr.length; i++){
             var id = helpArr[i].getAttribute("id");
             if (id && id == helpId){
               var title = helpArr[i].getAttribute("title");
               var msg = helpArr[i].firstChild.data;
               if(!title || title.length == 0 || !msg || msg.length == 0) {               	
               	  break;
               }
               var divWidth = helpArr[i].getAttribute("width");
               var divHeight = helpArr[i].getAttribute("height");
               showHelpMessage(msg,title,divWidth,divHeight,baseDirectory,helpDivId);
               break; 
             }
           }                            
         } else {
            //alert('There was a problem with the request - ' + helpReq.status);
            return;
         }
      }
  };
  helpReq.open('GET', page, true);
  helpReq.send(null);  
}

function showHelpMessage(message,title,divWidth,divHeight,baseDirectory,helpDivId){
	if(!showHelpFlag){
		return;
	}
	var x = findPosX(helpParent) + 20;
	var y = findPosY(helpParent);
	var w = getDocumentWidth() - 20;
	var divW = parseInt(divWidth);
	var maxX = x + divW;
	if (w > 0 && maxX > w){
		if ((x - divW - 25) > 0){
			x = x - divW - 25;
		}else {
			x = 0;
		}
	}
	if(!divWidth || divWidth == ""){
		divWidth = 200;
	}
	if(!divHeight || divHeight == ""){
		divHeight = 60;
	}
	
	if(helpDivId && helpDivId != '') {
		var helpDiv = document.getElementById(helpDivId);
		if(helpDiv) {
			var titleTd = document.getElementById("addGadgetHelpTitleTd");
			titleTd.innerHTML = title;
			var messageTd = document.getElementById("addGadgetHelpMessageTd");
			messageTd.innerHTML = message;
			
			helpDiv.x = x;
			helpDiv.y = y;
			helpDiv.style.width = divWidth + "px";
			helpDiv.style.height = divHeight + "px";
			
			showLayerInMiddle(helpDivId,x,y);
		}else {
			showHelpMessage(message,title,divWidth,divHeight,baseDirectory,'');
		}
	}else {
		var msgWriter = new messageWriter("helpMessageDiv",title,baseDirectory);
		
		msgWriter.setPosition(x,y);
		msgWriter.setSize(divWidth,divHeight);
		msgWriter.setStyle('left');
		msgWriter.setMsgClass('HELP_TEXT');
		msgWriter.showMessage(message);
	}
}   
   