function openNewAccDiv(divId,accType,accId,op){
		if(!accId){
		 accId = "";
		}
		
		var params = "ACC_TYPE=" + accType + "&ACC_DIV=" + divId + "&ACC_ID=" + accId + "&OP=" + op;
		var page = BASE_DIRECTORY + "tools/addresses/addAccountDiv.jsp?";
		sendAjaxRequest(page,function(req){
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if (!result){
				alert("Could not open add account window!");
				return;
			}   
			var accDivElem = document.getElementById("addAccDiv");
			if(accDivElem){
			  accDivElem.style.display = "";
				//accDivElem.innerHTML = result;
				handleInnerHTML(accDivElem, result, 1);
			}
			showGeneralAdminDiv("addAccount");
		},'POST',params);
}

function clearAccountsList() {
	var accountsElem = document.getElementById("LogAdminAccList");
	if(accountsElem){
		accountsElem.options.length = 0;
	}
}

function changeAccTypeFilter(){
	var accType = document.account.accountsFilter.value;
	var params = "ACC_TYPE=" + accType;
	var page = BASE_DIRECTORY + "tools/addresses/addAccountDiv.jsp?";
	sendAjaxRequest(page,function(req){
		var result = req.responseText;	
		result = result.replace(/^\s+|\s+$/g, '') ;
		if (!result){
			alert("Could not open add account window!");
			return;
		}   
		var accDivElem = document.getElementById("addAccDiv");
		if(accDivElem){
			//accDivElem.innerHTML = result;
			handleInnerHTML(accDivElem, result, 1);
		}
	},'POST',params);
}

function cancelAddAccDiv(){
  hideAddAccDiv();
}

function hideAddAccDiv(){
  var accDivElem = document.getElementById("addAccDiv");
  if(accDivElem){
	  accDivElem.style.display = "none";;
  }
  hideGeneralAdminDiv("addAccount");	
	hideGeneralAdminDiv("uploadDriver");	
}


function addNewAcc(action,accId,verifyBeforeSave){
	var addAccDiv = document.getElementById("adminGeneralIncludeTDaddAccount");
	if (addAccDiv){
		addAccDiv.scrollTop = addAccDiv.scrollHeight;
	}
	updateVerifyAccMsgDiv("Please wait...");
	var params = buildAccParamsStr(action,accId,verifyBeforeSave);
	var page = BASE_DIRECTORY + "tools/addresses/addAccountAction.jsp?";
	sendAjaxRequest(page,function(req){
		var result = req.responseText;	
		result = result.replace(/^\s+|\s+$/g, '') ;
		if(!result){
			alert("Could not save new account!");
			return;			
		}
		var resultArr = result.split("@#");
		if(resultArr && resultArr[0] && resultArr[0] == "ok"){
				var accountType = resultArr[1];							
				var actionType = resultArr[2];			
				if(actionType && actionType == "save"){
						var accName  = resultArr[3];
						var _accId  = resultArr[4];
						if(_accId == "null") {
							_accId = "";
						}
						var op = resultArr[5];
						var verified;
						if(verifyBeforeSave && verifyBeforeSave == "true") {
							verified = resultArr[6];
						}
						if((verified && verified == "true") || (verifyBeforeSave && verifyBeforeSave == "false")) {
							if(op == "edit"){
								for(var i = 0 ; i < document.access.LogAdminAccList.options.length ; i++){
									if(document.access.LogAdminAccList.options[i].value == _accId){
										document.access.LogAdminAccList.options[i].text = accName;
										break;
									}
								}								
							}else{ //add new account.
								document.access.LogAdminAccList.options[document.access.LogAdminAccList.options.length] = new Option(accName,_accId);
								document.access.LogAdminAccList.selectedIndex = (document.access.LogAdminAccList.options.length - 1);
							}
							changeAccId('LogAdminAccList');
							hideAddAccDiv();
							if(accountType == "remote" && refreshMenus) {
								refreshMenus();
							}
							return;											
						}else {
							updateVerifyAccMsgDiv('');
							var msgWriter = new messageWriter("verificationFailedMessage","Account Verification Failed",BASE_DIRECTORY);
							msgWriter.addAction("Save anyway","javascript:hideLayer('verificationFailedMessage');addNewAcc('"+action+"','"+_accId+"','false')");
				    	msgWriter.addAction("Edit account details","javascript:hideLayer('verificationFailedMessage');");  
		    			msgWriter.showMessage("Account verification has failed.<br>What do you wish to do?");
						}
				}else if(actionType && actionType == "verify"){
						var verifyMsg  = resultArr[3];
						updateVerifyAccMsgDiv(verifyMsg);
				}
		}else if(resultArr && resultArr[0] && resultArr[0] == "error"){
				var errorMsg = resultArr[1];
				updateVerifyAccMsgDiv(errorMsg);
				return;
		}
	},'POST',params);
}

function buildAccParamsStr(actionType,accId,verifyBeforeSave){
	var accType = document.access.LogType.value;
	var param = "";
	param += "isEmbeded=true&ACC_TYPE=" + accType + "&ACTION_TYPE=" + actionType + "&Id=" + accId;
	if(actionType == 'save' && verifyBeforeSave) {
		param += "&verifyBeforeSave=" + verifyBeforeSave;
	}
  param += getFormElementsQueryString(document.account);
	return param;
}


function updateVerifyAccMsgDiv(msg){
	var msgElem = document.getElementById("verifyMsgDiv");
	if(msgElem){
		msgElem.innerHTML = "";
		msgElem.style.display = "";
		msgElem.innerHTML = msg;
	}
}

function updateVerifyUploadMsgDiv(msg){
	var msgElem = document.getElementById("verifyUploadMsgDiv");
	if(msgElem){
		//msgElem.innerHTML = "";
		msgElem.style.display = "";
		//msgElem.innerHTML = msg;
		handleInnerHTML(msgElem, msg, 1);
	}
}

function clearParamDiv(){
	updateVerifyAccMsgDiv("");
	updateVerifyUploadMsgDiv("");
}

//DATABASE ACCOUNT FUNCTION
var prevDriverType;
function changeDriversType(){
	clearParamDiv();
	var driverType = document.account.driversType.value;
	if(driverType == "none"){
		var driverParamElem = document.getElementById("driverParamDiv");
						if(driverParamElem){
							driverParamElem.innerHTML = "";
							driverParamElem.style.display = "none";
							document.account.Name.value = "";
							return;
		}	
	}

	if(document.account.Name.value.length == 0 && driverType.length > 0 && driverType != "other" ||
			(prevDriverType && prevDriverType == document.account.Name.value)) {
		document.account.Name.value = driverType; 
	}
	prevDriverType = driverType;
	
	var params = "DRIVER_TYPE="+driverType;
	var page = BASE_DIRECTORY + "tools/addresses/db/general/accountDbDivAction.jsp?";
	sendAjaxRequest(page,function(req){
		var result = req.responseText;	
		result = result.replace(/^\s+|\s+$/g, '') ;
		if(!result){
			alert("Could not get driver!");
			return;			
		}
		var resultArr = result.split("@#");
		if(resultArr && resultArr[0] && resultArr[0] == "ok"){
			var driverParamElem = document.getElementById("driverParamDiv");
			if(driverParamElem){
				//driverParamElem.innerHTML = "";
				driverParamElem.style.display = "";
				var htmlDiv = resultArr[1];
				//driverParamElem.innerHTML = htmlDiv;
				handleInnerHTML(driverParamElem, htmlDiv, 1);
			}
		}else	if(resultArr && resultArr[0] && resultArr[0] == "error"){
			updateVerifyAccMsgDiv(resultArr[1]);
		}else{
			var driverParamElem = document.getElementById("driverParamDiv");
			if(driverParamElem){
				//driverParamElem.innerHTML = "";
				driverParamElem.style.display = "";
				//driverParamElem.innerHTML = result;
				handleInnerHTML(driverParamElem, result, 1);
			}				
		}
	},'POST',params);
}

//UPLOAD DRIVER
function showHideUploadDriverLink(){
		showGeneralAdminDiv("uploadDriver");
		
}

function hideUploadDriver(){
  hideGeneralAdminDiv("uploadDriver");
}

var selectedDriverType= "";


function goUploadDriver(){
		updateVerifyUploadMsgDiv("Uploading...");
		selectedDriverType = document.account.driversType.value;		
		var uploadFormElem = document.getElementById("fileUploadForm");
		var file = uploadFormElem.archivePath.value;
		var path = BASE_DIRECTORY + "tools/addresses/db/uploadDriverAction.jsp?ARCHIVE_PATH=" + file;
  	path = path + "&isEmbedded=true";
	 	uploadFormElem.action = path;
		uploadFormElem.submit();
}


function initUploadForm(){
	var uploadDriverElem = document.getElementById("adminGeneralDivuploadDriver");
	if(uploadDriverElem && uploadDriverElem.style.display == ""){
		if(selectedDriverType == document.account.driversType.value){
			var uploadFormElem = document.getElementById("fileUploadForm");
			var iframe = document.getElementById("uploadTargetIFrame") ;
			var iframeDoc = null;
			if (iframe.contentDocument) {
				iframeDoc = iframe.contentDocument;
			}
			else if (iframe.contentWindow) {
				iframeDoc = iframe.contentWindow.document;
			}
			else if (window.frames[iframe.name]) {
				iframeDoc = window.frames[iframe.name].document;
			}
			if (iframeDoc) {
				var resultElem = iframeDoc.getElementById("uploadResultDivId");
				if(resultElem){
					var result = resultElem.innerHTML;
					result = result.replace(/^\s+|\s+$/g, '') ;
					if(result == "OK"){		
							hideUploadDriver();
							updateVerifyUploadMsgDiv("Finished Uploading");		
							changeDriversType();		
					}else{
						updateVerifyUploadMsgDiv(result);		
					}
				}
			}
		}
	}
}

var hasAddressBookPermissions = true;
function openAccountDivIfNeeded(typeId, accountsElementId) {
	if(hasAddressBookPermissions == true) {
		var accountsElement = document.getElementById(accountsElementId);
		if(accountsElement) {
			var numberOfAccounts = accountsElement.length - 1;
			if(numberOfAccounts == 0) {
				var typeElement = document.getElementById(typeId);
				if(typeElement) {
					var type = typeElement.value;
					if(type == 'auth' || type == 'ssh' || type == 'db' || type == 'ftp' || type == 'http' || type == 'remote') {
						goNew();
					}
				}
			}
		}
	}
}