function addNewLocation(){
		if(isLocationsEmpty()){
			alert("Please fill the empty log path first!");
			return;
		}
		
		var params = buildLocationsParamStr();
		params += "&ACTION_TYPE=add";
		var page = BASE_DIRECTORY + "loggers/admin/common/locationPath.jsp?";
		sendAjaxRequest(page,function(req){
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if (!result){
				alert("Problem adding new location!");
				return;
			}   
			var locationPathsDivElem = document.getElementById("locationPathsDiv");
			if(locationPathsDivElem){
				//locationPathsDivElem.innerHTML = result;
				handleInnerHTML(locationPathsDivElem, result, 1);
			}
			LOCATIONS_CNTR++;
			showGeneralAdminDiv("addAccount");
		},'POST',params);
}

function buildLocationsPathStr(){
		var pathArr = "";
		for(var loop = 0 ; loop < LOCATIONS_CNTR ; loop++){
			var pathElem = document.getElementById("fullPath_" + loop);
			if(pathElem){
				var value = "";
				if(pathElem.value == ""){
				 value = "new";
				}else{
					value = pathElem.value;
				}
				pathArr += value + "@#@#";
			}
 		} 		
 		return pathArr;
}

function buildLocationsStatusStr(indx){
		var statusArr = "";
		for(var loop = 0 ; loop < LOCATIONS_CNTR ; loop++){
			var statusElem = document.getElementById("locationStatus_" + loop);
//			alert(statusElem.value);
			if(statusElem){
				statusArr += statusElem.value + "@#@#";
			}
 		} 		
 		return statusArr;
}

function buildLocationsParamStr(indx){
		var param = "LOCATIONS_PATH_ARR=" + encode(buildLocationsPathStr());
		param += "&LOCATIONS_STATUS_ARR=" + encode(buildLocationsStatusStr(indx));
		param += "&LOCATIONS_CNTR=" + LOCATIONS_CNTR;
		param += "&baseDirectory=" + BASE_DIRECTORY;
		param += "&LOG_TYPE=" + document.access.LogType.value;
		

		return param;
}

function isLocationsEmpty(){
		for(var loop = 0 ; loop < LOCATIONS_CNTR ; loop++){
			var pathElem = document.getElementById("fullPath_" + loop);
			if(pathElem){
				if(pathElem.value == ""){
					return true;
				}
			}
 		}
 		return false;
}

function removeLocation(indx){		
		var params = buildLocationsParamStr(indx);
		params += "&ACTION_TYPE=remove";
		params += "&REMOVE_INDX=" + indx;
		var page = BASE_DIRECTORY + "loggers/admin/common/locationPath.jsp?";
		sendAjaxRequest(page,function(req){
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if (!result){
				alert("Problem removing location!");
				return;
			}   
			var locationPathsDivElem = document.getElementById("locationPathsDiv");
			if(locationPathsDivElem){
				//locationPathsDivElem.innerHTML = result;
				handleInnerHTML(locationPathsDivElem, result, 1);
			}
			LOCATIONS_CNTR--;
		},'POST',params);	
}

//BROWSER FUNCTION
function openBrowser(txtboxId,i,logType){
	var rootDir = document.getElementById("fullPath_"+i).value;
	var accId = "";

	accId = "";
	//only if acc was selected
	var accountsElem = document.getElementById("LogAdminAccList");
	if(accountsElem){
		accId = accountsElem.value;
		if(accId == "none"){
			accId = "";
		}
	}
	var logTypeElem = document.getElementById('LogType');
	if(logTypeElem){
		var logType = logTypeElem.value;
		if(logType == "ssh"  && accId == ""){
			var AccountIdElem = document.getElementById("AccountIdErrorMsg");
			if(AccountIdElem && document.access.LogAdminAccList){
				document.access.LogAdminAccList.className = 'ERROR_MSG_BACKGROUNDCOLOR';										
				AccountIdElem.style.display ="";
				AccountIdElem.innerHTML = "Please set your log's account";
			}else{
			  alert("Please select account first");			
			}
			return;
		}	
	}
 	showHideSysFileInMiddle(150,200);
	loadSysFilesTree(rootDir,txtboxId,accId);
}




function doOpenBrowser(txtboxId,i,e){
	var logTypeElem = document.getElementById('LogType');
	if(logTypeElem){
		if(logTypeElem.value == "ftp" || logTypeElem.value == "http"){
			return;
		}
	}
	var result = checkKey(e);
   if (result){
       openBrowser(txtboxId,i);
    }
}



function checkKey(e){
 	if (!e) var e = window.event;
		var code = e.keyCode;
		if (code == 13 ){
			return true;
	}
}
	
//LOG DYNAMIC STATUS
	//     LOG    DATA   FILE NAME
	//0 : online,change,  change
	//1 : online,change,  fixed
	//2 : online,fixed,  change
	//3 : online,fixed,  fixed
	//4 : offline
	var dynamicType = 0 ;//online - fixed -fixed
	var dynamicTypeArr = "";
	var dynamicTmpTypeArr = new Array();
	var _id;

	function showLogSettings(e,id,dynamicType){
			var page = BASE_DIRECTORY + "loggers/admin/logDynamicSettings.jsp";
			sendAjaxRequest(page,function(req){
				var result = req.responseText;	
				result = result.replace(/^\s+|\s+$/g, '') ;
				if(!result){
					alert("Could not open 'Files Behavior' window!");
					return;			
				}
				showHideGeneralAdminDiv("dynamicSettings");
				updateGeneralAdminDiv("dynamicSettings",result);
				_id = id;
				var value = getDynamicType(id);
				if(value && value != -1){
				 	dynamicType = value;
				}else{
					dynamicType = "-1";
				}	
				var elemId = 'fileBehaviordynamicSettings';
				var radioElem = document.getElementsByName(elemId);	
				if(radioElem){
					for(var i = 0 ; i < radioElem.length ; i++){
						if(radioElem[i].value == dynamicType){
							radioElem[i].checked = 'true';
							break;
						}
					}
				}
			});		
	}
	
	function changeStatus(status,id){
	_id = id;
	 var imgId = document.getElementById("imgid_"+id);
		if(imgId){
			if(status && status == "offline"){
				imgId.style.display  = "none";		
				setDynamicType(_id,"4");
			}else{
				imgId.style.display  = "";		
				setDynamicType(_id,"0");
		}
	} 	
	}

	function applyStatus(){	 
		var status = "0";
		var elemId = 'fileBehaviordynamicSettings';
		var radioElem = document.getElementsByName(elemId);	
		if(radioElem){
			for(var i = 0 ; i < radioElem.length ; i++){
				if(radioElem[i].checked){					
					status = radioElem[i].value;
					break;
				}
			}
		}		
			setDynamicType(_id,status);			
			cancelStatus(); //close
	}
	
function setDynamicType(id,status){	
	document.getElementById("locationStatus_" + id).value = status;
}	

function cancelStatus(){
		showHideGeneralAdminDiv("dynamicSettings");
}


function getDynamicType(id){	
	return document.getElementById("locationStatus_" + id).value;
}

	
function showHideBrowserBtn(logType){
	var browserBtnElem = document.getElementById('browserBtnId');
	if(browserBtnElem){
		if(logType == "ftp" || logType == "http"){
			browserBtnElem.style.display = "none";
		}else{
			browserBtnElem.style.display = "";		
		}
	}
}
///////////////////////////////////////////////////////////////////		
