var isInitPattern = true;
var suggestionsLoaded = false;
var suggestedPatternSelected = "";
var bMenu = null;
var refreshTabs = false;

function initPattern(displaySuggestions,patternSize){
	suggestedPatternSelected = "";
		initTabs();
		addTabsCustomDiv(tabbar,"customTabsDiv");	

	if(displaySuggestions == "true"){
		var tabsElem = document.getElementById('pattrenWizardsDiv');		
		if(tabsElem){
			tabsElem.style.display = "none";
		}
		getSuggestionsList();
	}else {
	  updateRecordAnalysedResult("-1");
	}	
	isInitPattern = false;
}


function fieldRemove(){
		showHideFieldErrorMsg(false);
		var tabId = tabbar.getActiveTab();
		var builderId = tabId.replace("patternTabDiv_","")
		var fieldIndx = "0";
		if(bMenu.contextMenu){
			fieldIndx = bMenu.contextMenu.zoneId;
		}

		var params = "BUILDER_ID=" + builderId + "&FIELD_INDX=" + fieldIndx;
		var page = "pattern/fieldRemoveAction.jsp";
		sendAjaxRequest(page,function(req){
			var result = req.responseText;
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result || result == "error"){
				alert("Problem adding new field to pattern!");			
				return;
			}
				var resultArr = result.split("#");
				if(resultArr && resultArr[0] && resultArr[0] == "error"){
					alert("Could not remove field pattern!");
				 	return;
				}
				if(resultArr && resultArr[0] && resultArr[0] == "ok"){	
				var builderId = resultArr[1];
				var patternStr = resultArr[2];
				updateResult(builderId,patternStr);
			}
		},'POST',params);

}

function fieldInsert(){
		var tabId = tabbar.getActiveTab();
		var builderId = tabId.replace("patternTabDiv_","")
		var fieldIndx = "0";
		if(bMenu.contextMenu){
			fieldIndx = bMenu.contextMenu.zoneId;
		}
		addNewField(builderId,fieldIndx,"INSERT");
}


function fieldEdit(){
		var tabId = tabbar.getActiveTab();
		var builderId = tabId.replace("patternTabDiv_","")
		var fieldIndx = "0";
		if(bMenu.contextMenu){
			fieldIndx = bMenu.contextMenu.zoneId;
		}
		editFieldPattern(builderId,fieldIndx);
}

function editFieldPattern(patternIndx,fieldIndx){
	addNewField(patternIndx,fieldIndx,"EDIT");
}

function addNewField(builderId,fieldIndx,op){
		showHideFieldErrorMsg(false);

		var params = "BUILDER_ID=" + builderId + "&FIELD_INDX=" + fieldIndx + "&OP=" + op;
		var page = "pattern/addField.jsp";
		sendAjaxRequest(page,function(req){
			var result = req.responseText;
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result || result == "error"){
				alert("Problem adding new field to pattern!");			
				return;
			}
			showHideGeneralAdminDiv("addField");
			var divTitleElem = document.getElementById('generalDivTitleaddField')
			if(divTitleElem){
				if(op == "EDIT"){
					divTitleElem.innerHTML = "Edit Field";
				}else{
					divTitleElem.innerHTML = "Add Field";
				}			
			}
			updateGeneralAdminDiv("addField",result);
    },'POST',params); 
 }
 
 
 function cancelPattrernDiv(){	
		hideGeneralAdminDiv("addField");
		var errorElem = document.getElementById("fieldErroMsgId");
		if(errorElem){
				 	errorElem.innerHTML = "";
					errorElem.style.display = "none";
		 }		
	}


function saveNewPattern(){
	var params = buildFieldParams();
	var page = "pattern/savePattern.jsp";
	sendAjaxRequest(page,function(req){
			var result = req.responseText;
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result || result == "error"){
				alert("Problem saving field pattern!");			
				return;
			}		
				var errorElem = document.getElementById("fieldErroMsgId");
				var resultArr = result.split("#");
				if(resultArr && resultArr[0] && resultArr[0] == "error"){
				 var msg = resultArr[1];
				 if(errorElem){
				 		//errorElem.innerHTML = "";
						errorElem.style.display = "";
						//errorElem.innerHTML = msg;
						handleInnerHTML(errorElem, msg, 1);
						var scrollElem = document.getElementById("adminGeneralIncludeTDAddField");						
						if(scrollElem){
						 var yPos = findPosY(scrollElem);
						 scrollElem.scrollTop = (yPos - 11);
						}
				 	return;
				 }
				}
				if(resultArr && resultArr[0] && resultArr[0] == "ok"){	
				var builderId = resultArr[1];
				var patternStr = resultArr[2];
				var patternStrForIndx = resultArr[3];
				 if(errorElem){
				 	errorElem.style.display = "none";				 	
				 }
				updateResult(builderId,patternStr,patternStrForIndx);
			}
			cancelPattrernDiv();
	},'POST',params); 
}
 
function buildFieldParams(){
	var params = "BUILDER_ID=" + document.patternForm.addFieldBuilderId.value;
	params +=  "&FIELD_INDX=" + document.patternForm.addFieldIndxPos.value;;
	params +=  "&OP=" + document.patternForm.addFieldOP.value;;
	params += "&PATTERN_TYPE=" + document.getElementById("patternType").value;	
  for (var loop=0; loop < document.patternForm.elements.length; loop++)
  {
  	params += "&" + document.patternForm.elements[loop].name + "=";
  	if(document.patternForm.elements[loop].type == "checkbox"){
			params += document.patternForm.elements[loop].checked;
  	}else{
	  	params += encode(document.patternForm.elements[loop].value);
	  }
  }
	return params;
	
} 

function updateResult(builderId,updateResult,patternStrForIndx){
	//updateLogLines(false);
	//update advance tab
	var advanceElem = document.getElementById("patternsAdvance_" + builderId);
	if(advanceElem){
		if(patternStrForIndx){
//			patternStrForIndx = patternStrForIndx.replace("DUMMY","text");
			advanceElem.value = patternStrForIndx.replace(/"\t"/gi, "{tab}");		
		}else if(updateResult){
//			updateResult = updateResult.replace("DUMMY","text");
			advanceElem.value = updateResult.replace(/"\t"/gi, "{tab}");;

		}
	}
	updateWizardResult(builderId);
	updateRecordAnalysedResult(builderId);
}


function updateWizardResult(builderId,changeViewType){
	//update wizard tab
	
	var params = "BUILDER_ID=" + builderId;
	var page = "pattern/wizardPattern.jsp";
	sendAjaxRequest(page,function(req){
		var result = req.responseText;
		result = result.replace(/^\s+|\s+$/g, '') ;
		if(!result || result == "error"){
			alert("Problem updating results!");			
			return;
		}

		var fieldIndx = 0 ;
		var elemId = "fieldId_" + builderId + "_" + fieldIndx;
		var elem = document.getElementById(elemId);
		while(elem){
		var contextId = "arrowImg_" + fieldIndx + "_" + builderId;
		var obj = document.getElementById(contextId);
			obj.selfobj = null;
			obj.contextMenu=null;
			obj.contextMenuId=null;
		    obj = null;
		    fieldIndx++;		
			elemId = "fieldId_" + builderId + "_" + fieldIndx;
			elem = document.getElementById(elemId);
		}
		
		var wizardElem = document.getElementById("pattrenWizardsDiv_" + builderId);
		if(wizardElem){
			//wizardElem.innerHTML = result;
			handleInnerHTML(wizardElem, result, 1);
		}	
		fieldIndx = 0 ;
		elemId = "fieldId_" + builderId + "_" + fieldIndx;
		elem = document.getElementById(elemId);
		
		while(elem && bMenu){			
			var contextId = "arrowImg_" + fieldIndx + "_" + builderId;
			if (!document.getElementById(contextId))continue;
			bMenu.setContextZone(contextId,"" + fieldIndx);					
			fieldIndx++;		
			elemId = "fieldId_" + builderId + "_" + fieldIndx;
			elem = document.getElementById(elemId);
		}
		if(changeViewType){
			changePatternView(changeViewType);				
		}
	},'POST',params); 
}

function updateRecordAnalysedResult(builderId,pattern){
	//update analysed tab
	//update multipattern always.
	builderId = "-1";
	if(!pattern){
		pattern = "";
	}
	var params = "PATTERN=" + pattern + "&BUILDER_ID=" + builderId + "&BASE_DIRECTORY=" + BASE_DIRECTORY;
	var page = "pattern/logRecordsAnalysed.jsp";
	sendAjaxRequest(page,function(req){
		var result = req.responseText;
		result = result.replace(/^\s+|\s+$/g, '') ;
		if(!result || result == "error"){
			alert("Problem updating results!");			
			return;
		}
		var resultArr = result.split("@");
		var showWorngField = false;
		if(resultArr && resultArr[0] == "UNPARSED"){
		 	showWorngField = true;
		 	result = resultArr[1];
		}
		
		var charset = req.getResponseHeader("Content-Type");
		if (charset && charset.indexOf("UTF-16") > 0){
		  if (result.length > 8 && result.substring(result.length - 8) != "</table>"){
		    var tmpIndex = result.indexOf("<tr id=\"row");
		    var index = tmpIndex;
		    while (tmpIndex >= 0){
		      tmpIndex = result.indexOf("<tr id=\"row",tmpIndex + 1);
		      if (tmpIndex >= 0){
		        index = tmpIndex;
		      } 		    
		    }
		    if (index > 0){
		      result = result.substring(0,index);
		      result += "</tbody></table>";		    
		    }
		  }		
		}		
		var analysedElem = document.getElementById("recordAnalysedId");
		if(analysedElem){
			//analysedElem.innerHTML = result;			
			handleInnerHTML(analysedElem, result, 1);
		}
		if(showWorngField){
			doShowWorngField();
		}
	},'POST',params); 
}

function doShowWorngField(){
	var tabId = tabbar.getActiveTab();
	var patternIndex = getTabsIndex(tabbar,tabId)
	if(patternIndex == -1){
		patternIndex == 0;
	}
	
	var params = "PATTERN_INDEX=" + patternIndex;
	var page = "pattern/patternError.jsp";
	sendAjaxRequest(page,function(req){
		var result = req.responseText;
		result = result.replace(/^\s+|\s+$/g, '') ;
		if(!result || result == "-1"){
			return;
		}
		var tabId = tabbar.getActiveTab();
		var builderId = tabId.replace("patternTabDiv_","")

		var fieldIndex = result;
			var j = 0;
		 	id = "fieldId_" + builderId + "_" + j;
			fieldElem = document.getElementById(id);
			while(fieldElem){
				fieldElem.className = (j == fieldIndex) ? "ERROR_FIELD_BACKGROUND" : "ERROR_FIELD_GRAY_BACKGROUND";
				j++;
			 	id = "fieldId_" + builderId + "_" + j;
				fieldElem = document.getElementById(id);
			}
			var msg = null;
			if(j <= fieldIndex){
				msg = "The pattern is not complete";
			}
			showHideFieldErrorMsg(true,msg);
	},'POST',params); 	
	
}

function showHideFieldErrorMsg(show,msg){
	var tabId = tabbar.getActiveTab();
	var builderId = tabId.replace("patternTabDiv_","")
	var id = "fieldErrorMsgDiv_" + builderId;
	var errorMsgElem = document.getElementById(id);
	if(errorMsgElem){
		if(show){
				errorMsgElem.style.display = "";
				if(msg){
					errorMsgElem.innerHTML = msg;
				}else{
					errorMsgElem.innerHTML = "The marked field causes the log to be unparsed"
				}
		}else{
				errorMsgElem.style.display = "none";		
		}
	}
}

function changepatternType(){
	showHideFieldErrorMsg(false);
	var type = document.getElementById("patternType").value;
	
	var params = "FIELD_TYPE=" + type;
	var page = "pattern/fieldProperties.jsp";
	sendAjaxRequest(page,function(req){
		var result = req.responseText;
		result = result.replace(/^\s+|\s+$/g, '') ;
		if(!result || result == "error"){
			alert("Problem changing field type results!");			
			return;
		}
		var propElem = document.getElementById("fieldPropertiesDiv");
		if(propElem){
			document.getElementById("PattName").value = "";
			if(type == "literal" || type == "eoe" || type == "eol" || type == "block"){
				document.getElementById("newFieldNameTr").style.display = "none"		
			}else{
				document.getElementById("newFieldNameTr").style.display = "";				
			}
			//propElem.innerHTML = result;
			handleInnerHTML(propElem, result, 1);
			propElem.style.display = "";
		}			
	},'POST',params); 

}

function showSuggestionsList(){
//	closeFieldActionDiv();
	var suggElem = document.getElementById("PatternSuggestionDiv");
	var wizardElem = document.getElementById("pattrenWizardsDiv");
	var showElem = document.getElementById("showSuggestionDiv");
	var hideElem = document.getElementById("hideSuggestionDiv");	
	var titleElem = document.getElementById("headerTitle");		
	if(!suggElem || !wizardElem){
		return;
	}
	wizardElem.style.display = "none";
	suggElem.style.display = "";		
	showElem.style.display = "none";
	hideElem.style.display = "";
}


function hideSuggestionsList(){
	var suggElem = document.getElementById("PatternSuggestionDiv");
	var wizardElem = document.getElementById("pattrenWizardsDiv");
	var showElem = document.getElementById("showSuggestionDiv");
	var hideElem = document.getElementById("hideSuggestionDiv");		

//	changePatternView('wizard');
	if(!suggElem || !wizardElem){
		return;
	}
	wizardElem.style.display = "";
	suggElem.style.display = "none";		
	showElem.style.display = "";
	hideElem.style.display = "none";
}



function showPatternWizard(indx){
//	closeFieldActionDiv();
	var tabsElem = document.getElementById("tabbarDiv" + indx);
	var wizTabElem = document.getElementById("wizardTabDiv_" + indx);
	var advTabElem = document.getElementById("wizardTabDiv_" + indx);
	if(tabsElem){
			tabsElem.style.display = ""
	}
	if(wizTabElem){
			wizTabElem.style.display = ""
	}
	if(advTabElem){
			advTabElem.style.display = ""
	}
	updateRecordAnalysedResult(indx);	
}


function changePattern(builderId,pattern,isMultiLine){
	var encodePattern = "";
	if(pattern){
		encodePattern = encode(pattern);
	}
	var params = "PATTERN=" + encodePattern;
	suggestedPatternSelected = pattern;
	var page = "pattern/updatePatterns.jsp";
	sendAjaxRequest(page,function(req){
		var result = req.responseText;
		result = result.replace(/^\s+|\s+$/g, '') ;
		if(!result || result == "error"){
			alert("Problem updating results!");			
			return;
		}
		updateResult(builderId,pattern);
		refreshTabs = true;
	},'POST',params); 

}

function doVerify(builderId){
	showHideFieldErrorMsg(false);
	var advanceElem = document.getElementById("patternsAdvance_" + builderId);
	if(advanceElem){
		var pattern = advanceElem.value;
		if(pattern){
			pattern = pattern.replace(/"{tab}"/gi, "\t");
		}
		updatePattern(builderId,pattern);
	}else{
		alert("Problem verifying pattern!");			
		return;
	}
}

function doClear(builderId){
	var advanceElem = document.getElementById("patternsAdvance_" + builderId);
	if(advanceElem){
		var pattern = "{string:DUMMY}";
		advanceElem.value = pattern;
		updatePattern(builderId,pattern);
	}else{
		alert("Problem clearing pattern!");			
		return;
	}
}

function updatePattern(builderId,pattern){
	var multiPattern = getMultiPattern();
	var params = "&PATTERN=" + multiPattern;
	var page = "pattern/updatePatterns.jsp?";
	sendAjaxRequest(page,function(req){
		var result = req.responseText;
		result = result.replace(/^\s+|\s+$/g, '') ;
		var resultArr = result.split("#");
		if(!result || result == "error"){
			alert("Problem updating results!");			
			return;
		}		
		if(resultArr && resultArr[0] && resultArr[0] == "error"){
			 var msg = resultArr[1];
			 var analysedElem = document.getElementById("recordAnalysedId");
			if(analysedElem){
				//analysedElem.innerHTML = msg;
				handleInnerHTML(analysedElem, msg, 1);
			}
			return;	
		}		
		updateResult(builderId,pattern);
	},'POST',params); 
}


function getMultiPattern(){
	var i = 0;
	var multiPattern ="";
	var tabsCtr = getTabsCount(tabbar);
	for(var indx = 0 ; indx < tabsCtr - 1 ; indx++){
		var tabId = getTabsId(tabbar,indx);
		var id = getIdFromTabName(tabId);
		var advanceElem = document.getElementById("patternsAdvance_" + id);
		if(advanceElem){
			if(indx > 0 ){
//					multiPattern += "@**@";
					multiPattern += "\n";			
			}
			var advPattern = "";
			if(advanceElem.value == ""){
				advPattern = "{string:DUMMY}";
  			 advanceElem.value = advPattern;
			}else{
				advPattern = advanceElem.value.replace(/"{tab}"/gi, "\t");
			}
			 multiPattern += advPattern;
		}
				
	}	
	
//	multiPattern = multiPattern.replace("+","@*@*");
	multiPattern = encode(multiPattern);
	
	return multiPattern;
}

function doSaveLog(){
	document.access.action = BASE_DIRECTORY + "loggers/admin/logDataPatternAction.jsp";
  document.access.submit();
}


function hidePatternWizard(indx){
//	closeFieldActionDiv();
	var tabsElem = document.getElementById("tabbarDiv" + indx);
	var wizTabElem = document.getElementById("wizardTabDiv_" + indx);
	var advTabElem = document.getElementById("advanceTabDiv_" + indx);	
	var linkElem = document.getElementById("patternAsLinkDiv_" + indx);
	if(tabsElem){
			tabsElem.style.display = "none"
	}
	if(wizTabElem){
			wizTabElem.style.display = "none"
	}
	if(advTabElem){
			advTabElem.style.display = "none"
	}	
	if(linkElem){
		 linkElem.style.display = "";
	}	
	if(!isInitPattern){
		updateRecordAnalysedResult("-1");
	}
}



function hideShowAdvance(){
	
		var advanceElem = document.getElementById("propertiesId");
		var generalAdvanceElem = document.getElementById("generalPropertiesId");	
		if(advanceElem){
			if(advanceElem.style.display == ""){
				advanceElem.style.display = "none"
			}else{
				advanceElem.style.display = ""
			}		
		}
		if(generalAdvanceElem){
			if(generalAdvanceElem.style.display == ""){
				generalAdvanceElem.style.display = "none"
			}else{
				generalAdvanceElem.style.display = ""
			}		
		}
}

function hideShowMaskExpression(mask){
		var index = mask.selectedIndex;
		var maskExpressionElem = document.getElementById("maskExpressionId");
		if(index != 2){
			maskExpressionElem.style.display = "none"
		}else{
			maskExpressionElem.style.display = ""
		}		
}



function changeSeparator(){
	var sepType = document.getElementById("separator").value
	document.getElementById("separatorValue").value = "";
	switch(sepType){
		case 'CUSTOM': 
				document.getElementById("separatorValueTR").style.display = "";
				return;				
		case 'TAB': 
				document.getElementById("separatorValueTR").style.display = "none";				
				document.getElementById("separatorValue").value = "{tab}";
				return;				
		case 'SPACE': 
				document.getElementById("separatorValueTR").style.display = "none";
				document.getElementById("separatorValue").value = " ";						
				return;				
	}
	
}


function highlightParsedTxt(isOver,isLiteral,colIndx){
			if(isLiteral == "true"){
			return;
		}
		var trId = null;
		var trElem = null;
		var tdOffsetLeft = 0;
		for(var i = 0 ; i < 25 ; i++){
			trId = "d_" + i + "_" + colIndx;	
			trElem = document.getElementById(trId)
			if(trElem){
				if(i == 1 ){
				tdOffsetLeft = trElem.offsetLeft;
				}
					if(isOver){
						trElem.className = 'GC_HL';
					}else{
						trElem.className = 'GC';					
					}
			}
		}
		if(tdOffsetLeft > 0 ){
			document.getElementById("recordAnalysedId").scrollLeft = (tdOffsetLeft < 700 ? 0 : (tdOffsetLeft - 50));
		}
}

function highlightNextTxtToParsed(builderId,isOver){
	var params = "PATTERN_INDX=" + builderId;
	var page = "pattern/highlightTxt.jsp?";
	sendAjaxRequest(page,function(req){
		var result = req.responseText;
		result = result.replace(/^\s+|\s+$/g, '') ;
		if(!result || result == "error"){
			alert("Problem adding new pattern!");			
			return;
		}
		var colIndx = result;
		if(colIndx == "-1" ){
			return;
		}
		var trId = null;
		var trElem = null;
		for(var i = 0 ; i < 10 ; i++){		
			trId = "d_" + i + "_" + colIndx;	
			trElem = document.getElementById(trId)
			if(trElem){
					if(isOver){
						trElem.className = 'GC_RED_HL';
					}else{
						trElem.className = 'GC';					
					}
			}
		}		
	},'POST',params); 
}

function removePattern(){
	var tabId = tabbar.getActiveTab();
	var builderId = tabId.replace("patternTabDiv_","")
	
	var params = "OP=REMOVE_PATTERN"+ "&BUILDER_ID=" + builderId;
	var page = "pattern/updatePatterns.jsp";
	sendAjaxRequest(page,function(req){
		var result = req.responseText;
		result = result.replace(/^\s+|\s+$/g, '') ;
		if(!result || result == "error"){
			alert("Problem adding new pattern!");			
			return;
		}
		tabbar.removeTab(tabId,true);
		setTabsNames();
		updateRecordAnalysedResult("-1");
	},'POST',params); 
}

function updateLogLines(isLinesFromeLogs,isUpdateAnalysed){
	var lines = "";
	if(!isLinesFromeLogs){
		var linesElem = document.getElementById("logLines");
		if(linesElem){
			lines = linesElem.value;
			lines = encode(lines);
		}
	}	
	var params = "&LINES=" + lines + "&isUplaodFromFile=" + isLinesFromeLogs;
	var page = "pattern/updateLogLines.jsp?";
	sendAjaxRequest(page,function(req){
		var result = req.responseText;
		result = result.replace(/^\s+|\s+$/g, '') ;
		if(!result || result == "error"){
			alert("Problem loading log's lines!");			
			return;
		}else{
			 if(isLinesFromeLogs){ // if isLinesFromeLogs update textarea
				var linesElem = document.getElementById("logLines");
				if(linesElem){
					linesElem.value = result;
				}
			}
			if(isUpdateAnalysed){
				updateRecordAnalysedResult('-1');
			}						
		}				
	},'POST',params); 
}

function verifyAll(){
	updateLogLines(false,true);	
}


function getSuggestionsList(){
	var page = "pattern/patternSuggestions.jsp?";
	sendAjaxRequest(page,function(req){
		var result = req.responseText;
		result = result.replace(/^\s+|\s+$/g, '') ;
		if(!result || result == "error"){
			alert("Problem loading suggestions!");			
		}else{
			var suggestionsLoadingElem = document.getElementById('PatternSuggestionLoadingDiv');
			if(suggestionsLoadingElem){
				suggestionsLoadingElem.style.display = "none";
			}
			var builderId = "";
			var patternStr = "";
			var suggestionsElem = document.getElementById('PatternSuggestionList');
			if(suggestionsElem){
				//suggestionsElem.innerHTML = result;
				handleInnerHTML(suggestionsElem, result, 1);
				suggestionsLoaded = true;				
				if(document.access.patterns[0]){
					patternStr = document.access.patterns[0].value;
					updateRecordAnalysedResult("-1",patternStr);
				}else {
				  updateRecordAnalysedResult("-1");
				}
				if(document.access.firstPatternSuggBuilderId){
					builderId = document.access.firstPatternSuggBuilderId.value;
					updateWizardResult(builderId);
					var advanceElem = document.getElementById("patternsAdvance_" + builderId);
					if(advanceElem){
							advanceElem.value = patternStr.replace(/"{tab}"/gi, "\t");;
					}
				}
				if(document.access.patterns.length && document.access.patterns.length == 2){
					changePatternView('wizard');
				}else if(!document.access.patterns.length || document.access.patterns.length == 1){
					var advanceElem = document.getElementById("patternsAdvance_" + builderId);
					if(advanceElem){
							advanceElem.value = "{string:DUMMY}";
					}
					changePatternView('wizard');
				}else{
					suggestionsElem.style.display = "";							
					refreshTabs = true;
				}
			}
			var resultsTableElem = document.getElementById("resultsTableId");
			if(resultsTableElem){
				resultsTableElem.style.display = "";			
			}			
		}				
	},'POST'); 
}

function applySuggestion(type){
	var pattern = "";
	if(suggestedPatternSelected == ""){
	  if(document.access.patterns[0]){
			pattern = document.access.patterns[0].value;
		}
	}else{
		pattern = suggestedPatternSelected;
	}
	
	refreshPatternTabs(pattern,type);
}

function clearAllTabs(){
	var tabsCtr = getTabsCount(tabbar);
	var ids = new Array();
	for(var indx = 0 ; indx < tabsCtr ; indx++){
		var tabId = getTabsId(tabbar,indx);
		if(tabId != "patternTabDiv_NEW"){
			ids[ids.length] = tabId;
		}
	}	
	
	for(var indx = 0 ; indx < ids.length ; indx++){
		tabbar.removeTab(ids[indx]);
	}
}


function refreshPatternTabs(pattern,type){
 refreshTabs = false;
 var patternStr = encode(pattern);
 var params = "OP=REFRESH_PATTERN"+ "&PATTERN=" + patternStr;
 var page = "pattern/updatePatterns.jsp";
 sendAjaxRequest(page,function(req){
		var result = req.responseText;
		result = result.replace(/^\s+|\s+$/g, '') ;
		if(!result || result == "error"){
			alert("Problem adding new pattern!");			
			return;
		}
		var resultArr = result.split("#");
		if(resultArr && resultArr[0] == "ok"){
			clearAllTabs();
			var patternIdsArr = resultArr[1].split(",");
			for(var i = 0 ; i < patternIdsArr.length ; i++){
				appandTabToTabbar(patternIdsArr[i],"DUPLICATE",false,i,type);
			}		
		}
	},'POST',params); 
}

function changePatternView(type){
	if(refreshTabs && type != "auto"){
		applySuggestion(type);
		return;	
	}
	if(!tabbar){
		alert("Problem displaying manual view!");
		return;
	}
	var autoElem = document.getElementById('PatternSuggestionDiv');
	var tabsElem = document.getElementById('pattrenWizardsDiv');
	var tabsCtr = getTabsCount(tabbar);	
	for(var indx = 0 ; indx < tabsCtr - 1 ; indx++){
		var tabId = getTabsId(tabbar,indx);
		var id = getIdFromTabName(tabId);
		if(id){
			var advElemId = 'advanceViewTypeDiv_' + id;
			var wizardElemId = 'wizardViewTypeDiv_' + id;		
			var advanceElem = document.getElementById(advElemId);
			var wizardElem = document.getElementById(wizardElemId);
//		 alert("wizardElem: " + wizardElem + " + "'wizardViewTypeDiv_' + id " + 'wizardViewTypeDiv_'" + id)	;
			if(wizardElem && advanceElem && autoElem){
					if(type == "wizard"){
						wizardElem.style.display = "";
						advanceElem.style.display = "none";		
						autoElem.style.display = "none";		
						tabsElem.style.display = "";	
					}else if(type == "manual"){
						wizardElem.style.display = "none";
						advanceElem.style.display = "";		
						autoElem.style.display = "none";		
						tabsElem.style.display = "";		
					}else if(type == "auto"){
						wizardElem.style.display = "none";
						advanceElem.style.display = "none";		
						autoElem.style.display = "";		
						tabsElem.style.display = "none";	
						if(!suggestionsLoaded){
							getSuggestionsList();
						}	
					}
			}
			changePatternViewLink(type);
		}
	}	
	
}

function changePatternViewLink(type){
		var advanceElem = document.getElementById('customTabsDivAdvance');
		var wizardElem = document.getElementById('customTabsDivWizard');
		var autoElem = document.getElementById('patternSuggestionMsgTD');
		if(wizardElem && advanceElem && autoElem){
				if(type == "wizard"){
					wizardElem.innerHTML = "Wizard";
					advanceElem.innerHTML = "<a class=\"BUTTON_SMALLLINK\" href=\"javascript:changePatternView('manual');\">Manual</a>";		
					autoElem.innerHTML = "";		
				}else if(type == "manual"){
					wizardElem.innerHTML = "<a class=\"BUTTON_SMALLLINK\" href=\"javascript:changePatternView('wizard');\">Wizard</a>";
					advanceElem.innerHTML = "Manual";		
					autoElem.innerHTML = "";		
				}else if(type == "auto"){
					wizardElem.innerHTML = "<a class=\"BUTTON_SMALLLINK\" href=\"javascript:changePatternView('wizard');\">Wizard</a>";
					advanceElem.innerHTML = "<a class=\"BUTTON_SMALLLINK\" href=\"javascript:changePatternView('manual');\">Manual</a>";		
					autoElem.innerHTML = "Automatic Pattern Suggestions";							
				}			
		}
}

function getIdFromTabName(tabName){
	var id = tabName.replace("patternTabDiv_","");
	return id;
}


function selectTabHandler(idn,ido){	  
	  if (!idn){
	  	return false;
	  }
	  if (idn == "patternTabDiv_NEW"){
			addNewPatternTab();
	  }else if(!isInitPattern){
			updateRecordAnalysedResult("-1");
	  }
    return true;
}

function addNewPatternTab(){
	changePatternView('wizard');
	var params = "OP=ADD_NEW_PATTERN";
	var page = "pattern/updatePatterns.jsp?";
	sendAjaxRequest(page,function(req){
		var result = req.responseText;
		result = result.replace(/^\s+|\s+$/g, '') ;
		if(!result || result == "error"){
			alert("Problem adding new pattern!");			
			return;
		}
		var resultArr = result.split("#");
		if(!result || result == "error"){
			alert("Problem adding new patern!");			
			return;
		}		
		if(resultArr && resultArr[0] && resultArr[0] == "ok"){
			 var newPatternId = resultArr[1];
			 appandTabToTabbar(newPatternId,"ADD",true);			 		 
		}		
	},'POST',params); 
}


function appandTabToTabbar(id,op,updateResult,pos,type){
	var tabId = "patternTabDiv_"+id;
	if(!pos){
		pos = 0;
	}
  tabbar.addTab(tabId,"Pattern1","100",pos);	
	addMenuContext(tabbar,aMenu,true);
	updatePatternAdminIndex(tabbar);
	tabbar.setTabActive(tabId,true);				
	setTabsNames();
	
	var params = "BUILDER_ID=" + id + "&OP=" + op;
	var page = "pattern/newTabContent.jsp";
	sendAjaxRequest(page,function(req){
		var result = req.responseText;
		result = result.replace(/^\s+|\s+$/g, '') ;
		if(!result || result == "error"){
			alert("Problem adding new pattern!");			
			return;
		}
		tabbar.setContentHTML(tabId,result);
		if(updateResult){
			updateRecordAnalysedResult("-1");					
			}
		if(type){
			updateWizardResult(id,type);
			changePatternView(type);
		}			
	},'POST',params); 
}

function setTabsNames(){
		var tabsCtr = getTabsCount(tabbar);
		for(var indx = 0 ; indx < tabsCtr - 1 ; indx++){
			var tabId = getTabsId(tabbar,indx);
			tabbar.setLabel(tabId,"Pattern" + (indx+1));
		}	
}

function moveTab(direction){
	var tabId = tabbar.getActiveTab();
	var builderId = tabId.replace("patternTabDiv_","")
	var op = direction == "left" ? "MOVE_LEFT" : "MOVE_RIGHT";
	var tabIndex = getTabsIndex(tabbar,tabId);
	if(op == "MOVE_LEFT" && tabIndex == 0){
		return;
	}
	if(op == "MOVE_RIGHT"){
		var tabsCtr = getTabsCount(tabbar);		
		if(tabIndex == (tabsCtr - 2)){
			return;
		}
	}
	
	var tabNewIndex = op == "MOVE_LEFT" ? tabIndex - 1 : tabIndex + 1;
	
	var params = "OP=" + op +  "&BUILDER_ID=" + builderId;
	var page = "pattern/updatePatterns.jsp";
	sendAjaxRequest(page,function(req){
		var result = req.responseText;
		result = result.replace(/^\s+|\s+$/g, '') ;
		if(!result || result == "error"){
			alert("Problem changing pattern's position!");			
			return;
		}
		tabbar.removeTab(tabId,true);
		appandTabToTabbar(builderId,"MOVE",true,tabNewIndex)	;
		setTabsNames();
	},'POST',params); 
}

function duplicatePattern(){
	var tabId = tabbar.getActiveTab();
	var builderId = tabId.replace("patternTabDiv_","")
	
	var params = "OP=DUPLICATE" +  "&BUILDER_ID=" + builderId;
	var page = "pattern/updatePatterns.jsp";
	sendAjaxRequest(page,function(req){
		var result = req.responseText;
		result = result.replace(/^\s+|\s+$/g, '') ;
		if(!result || result == "error"){
			alert("Problem duplicating pattern!");			
			return;
		}
		var resultArr = result.split("#");
		if(!result || result == "error"){
			alert("Problem duplicating pattern!");			
			return;
		}		
		if(resultArr && resultArr[0] && resultArr[0] == "ok"){
			var newPatternId = resultArr[1];
			appandTabToTabbar(newPatternId,"DUPLICATE",true)	;
		}		
	},'POST',params); 
}
