function updateFileNamePattern(locationInfoId){
	var fnp = document.getElementById("fileNamePattern_"+locationInfoId);
	var fn = "";
	if (fnp){
		var useNamePatternElement = document.getElementById("useFileNamePattern_"+locationInfoId);
		if (useNamePatternElement && useNamePatternElement.checked){
			fn = "[FILE_NAME]";
		}
		var useDatePatternElement = document.getElementById("useDatePattern_"+locationInfoId);
		if (useDatePatternElement && useDatePatternElement.checked){
			if (fn == ""){
				fn = "[date,MMddyyyyHH]";
			}else{
				fn = fn + "_[date,MMddyyyyHH]";
			}
		}
		var useSeqPatternElement = document.getElementById("useSeqPattern_"+locationInfoId);
		if (useSeqPatternElement && useSeqPatternElement.checked){
			if (fn == ""){
				fn = "[SEQ]";
			}else{
				fn = fn + "_[SEQ]";
			}
		}
		var fileNamePatternSuffix = document.getElementById("fileNamePatternSuffix_"+locationInfoId);
		if (fileNamePatternSuffix){
			fn = fn + fileNamePatternSuffix.value; 
		}
		var compress = document.getElementById("compress_"+locationInfoId);
		if (compress && compress.checked){
			fn = fn + ".gz"; 
		}
		fnp.value = fn;
	}
	
}

function disablePatternDiv(locationInfoId,disabled){
	var useNamePatternElement = document.getElementById("useFileNamePattern_"+locationInfoId);
	var useDatePatternElement = document.getElementById("useDatePattern_"+locationInfoId);
	var useSeqPatternElement = document.getElementById("useSeqPattern_"+locationInfoId);
	var fileNamePatternSuffix = document.getElementById("fileNamePatternSuffix_"+locationInfoId);
	var compress = document.getElementById("compress_"+locationInfoId);
	var fnp = document.getElementById("fileNamePattern_"+locationInfoId);
	if (useNamePatternElement){
		useNamePatternElement.disabled = disabled;
	}
	if (useDatePatternElement){
		useDatePatternElement.disabled = disabled;
	}
	if (useSeqPatternElement){
		useSeqPatternElement.disabled = disabled;
	}
	if (fileNamePatternSuffix){
		fileNamePatternSuffix.disabled = disabled;
	}
	if (compress){
		compress.disabled = disabled;
	}
	if (fnp){
		fnp.disabled = disabled;
	}
}

function getSelectedInfoType(locationInfoId){
	var infoTypeRadio = eval("document.access.infoType_"+locationInfoId);
	if (!infoTypeRadio){
		return "manual";
	}
	for (var i=0; i<infoTypeRadio.length; i++) {
		if (infoTypeRadio[i].checked) {
			return infoTypeRadio[i].value;
		}
	}
	return "manual";
}

function selectManual(locationInfoId){
	var infoTypeRadio = eval("document.access.infoType_"+locationInfoId);
	if (infoTypeRadio && infoTypeRadio.length && infoTypeRadio.length > 1){
		infoTypeRadio[1].checked = true;
	}
}

function clearErr(locationInfoId){
	var locationInfoElem = document.getElementById("fullPath_"+locationInfoId);
	var errElement = document.getElementById("fullPath_"+locationInfoId + "ErrorMsg");
	if (errElement && locationInfoElem && locationInfoElem.value && locationInfoElem.value != ""){
		errElement.innerHTML = ""
	}
}
