<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.ui.grid.models.SavedSearchesGridTableModel"%>
<%@ page import="xpolog.eye.site.ui.grid.GridTable"%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION, true)) {
		return;
	}

	UserContext userContext = UserEnvironment.getUserContext(request);
	
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = "../../";
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
		
	SavedSearchesGridTableModel model = new SavedSearchesGridTableModel();
	model.setBaseDirectory(baseDirectory);
	model.setUserContext(userContext);
	model.setGridName("mygrid" + suffix);
	
	model.init();
	GridTable table = new GridTable(model);
	request.setAttribute("gridTable" + suffix,table);
	
	request.getRequestDispatcher(baseDirectory + "widgets/grid/jsp/initTableXML.jsp").forward(request, response);	
%>