<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.computation.conf.HealthConfig"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewRiskModel"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.util.Constants"%>
<%@ page import="xpolog.eye.util.DateUtil"%>

<%!
  static final String BASE_DIRECTORY = "../../";
%>
<% 

String[] fixedIntervals = DateUtil.FIXED_INTERVALS;
String[] fixedIntervalsNames = DateUtil.FIXED_INTERVALS_NAMES;

response.setContentType("text/html; charset=UTF-8");

String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);

%>

<form AUTOCOMPLETE="OFF" name="saveSearchForm" class="SEARCH_FORM">

<input type="hidden" id="savedSearchMinDate" name="savedSearchMinDate">
<input type="hidden" id="savedSearchMinDateStr" name="savedSearchMinDateStr">
<input type="hidden" id="savedSearchMinDateFullStr" name="savedSearchMinDateFullStr">
<input type="hidden" id="savedSearchMinTimeStr" name="savedSearchMinTimeStr">
<input type="hidden" id="savedSearchMaxDate" name="savedSearchMaxDate">
<input type="hidden" id="savedSearchMaxDateStr" name="savedSearchMaxDateStr">
<input type="hidden" id="savedSearchMaxDateFullStr" name="savedSearchMaxDateFullStr">
<input type="hidden" id="savedSearchMaxTimeStr" name="savedSearchMaxTimeStr">

<table border="0" cellpadding="0" cellspacing="0" width="100%" height="90%">
	<tr height="10px">
		<td width="170px" class="REGULARTEXT" align="left">* Name:</td>
		<td width="80px" class="REGULARTEXT" align="left">
			<input id="savedSearchId" name="savedSearchId" type="hidden">
			<input id="savedSearchName" name="savedSearchName" type="text" size="60">
		</td>
		<td>&nbsp;</td>
	</tr>
  <tr height="10px">
		<td class="REGULARTEXT" align="left" style="padding-top: 5px">* Search Term:</td>
		<td style="padding-top: 5px"><input id="savedSearchTerm" name="savedSearchTerm" type="text" size="60"></td>
		<td>&nbsp;</td>
	</tr>
  <tr height="10px">
		<td class="REGULARTEXT" align="left" style="padding-top: 5px">Description:</td>
		<td style="padding-top: 5px"><input id="savedSearchDescription" name="savedSearchDescription" type="text" size="60"></td>
		<td>&nbsp;</td>
	</tr>
  <tr height="10px">
		<td class="REGULARTEXT" align="left" style="padding-top: 5px">Time Range:</td>
		<td style="width:645px;padding-top:5px">
			<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
				<tr>
					<td class="SAVED_SEARCH_CALENDAR_FIXED_INTERVALS_CELL">
					  <select id="savedSearchFixedInterval" name="savedSearchFixedInterval" size="1" style="width:140px" onChange="javascript:changeDefaultTimeInterval(this.value)">
					  	<option value=""></option>
						<%
						for(int i = 0; i < fixedIntervals.length; i++) {
						%>
							<option value="<%=fixedIntervals[i] %>"><%=fixedIntervalsNames[i] %></option>
						<% 
						}
						%>
						</select>
					</td>
					<td id="defaultTimeIntervalCustomTd" class="SAVED_SEARCH_CALENDAR_LABEL_TEXT_CELL" style="width:280px; display:none">
						<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
							<tr>
								<td width="30px"><a href="javascript:openSearchCalendar(-100, 20, 'defaultTimeIntervalCustomTd', '1');" id="calendarLink"><img src="<%=BASE_DIRECTORY %>images/search/header/calendarOpen.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/calendarOpenOver.gif');showTooltip(searchTooltips['openCalendar'])" onMouseOut="javascript:setImageSource(this, 'header/calendarOpen.gif');hideTooltip()"></a></td>
								<td class="REGULARTEXT">
									<a href="javascript:openSearchCalendar(-100, 20, 'defaultTimeIntervalCustomTd', '1');" class="SAVED_SEARCH_CALENDAR_LABEL_TEXT_LINK" id="defaultTimeIntervalCustomTextLink"></a>
								</td>
							</tr>
						</table>
					</td>
					<td>&nbsp;</td>
				</tr>
			</table>
		</td>
		<td>&nbsp;</td>
	</tr>
	<tr>
		<td colspan="3">&nbsp;</td>
	</tr>
 
	<%
	boolean showHealth = Configuration.getInstance().getPropertiesManager().getProperty("log.filter.showHealthSettings","false").equals("true");
	boolean displaySystemHealth = showHealth && SiteManagment.getInstance().getXpologManagment().isDashboardValidAndComponentExists();
	ComputationConfiguration computeConf = ComputationConfiguration.getInstance();
  HealthConfig [] healthConfigs = computeConf.getHealthConfigs();
  if (healthConfigs != null && healthConfigs.length > 0 && displaySystemHealth){
  %>
  <tr height="10px">
		<td class="REGULARTEXT" align="left" style="padding-top: 5px">Severity:</td>
		<td style="padding-top: 5px">
	<%
		String type = healthConfigs[0].getType();
	%>
			<select id="savedSearchSeverity<%=type%>" name="savedSearchSeverity<%=type%>">
				<option value="-1">None</option>
	<%
		HealthViewRiskModel riskModel = HealthViewRiskModel.getInstance();
		int[] values = riskModel.getRiskValues();
		for (int i = 1; values != null && i < values.length;i++){
			if (values[i] <= 0) continue;
			
			String name = riskModel.getRiskName(values[i]);
	%>
				<option value="<%=String.valueOf(values[i])%>"><%=name%></option>
	<%
		}
	%>
			</select>
			<input type="hidden" id="savedSearchSeverityAmountType<%=type%>" name="savedSearchSeverityAmountType<%=type%>" value="1"> 
			<input type="hidden" id="savedSearchSeverityAmount<%=type%>" name="savedSearchSeverityAmount<%=type%>" value="0">
			<input type="hidden" id="savedSearchSeverityType" name="savedSearchSeverityType" value="<%=type %>">
			<span class="MEDIUMTEXT">Used by <%=analyticsH %></span>
		</td>
		<td>&nbsp;</td>
	</tr>
  <%
  }
  boolean displayVisibility = WebSecurityManager.getInstance().isSecurityEnabled();
	if(displayVisibility) {
	%>
	<tr>
		<td colspan="3">&nbsp;</td>
	</tr>
	<tr height="10px">
		<td class="REGULARTEXT" align="left" style="padding-top: 5px">Visible To:</td>
		<td style="padding-top: 5px" class="REGULARTEXT">
			<input id="savedSearchVisibilityEveryone" name="savedSearchVisibility" type="radio" value="false" checked>Everyone
			<input id="savedSearchVisibilityCurrentUser" name="savedSearchVisibility" type="radio" value="true"><span id="savedSearchVisibilityText"></span> only
		</td>
		<td>&nbsp;</td>
	</tr>
	<%
	}
	%>
  <tr height="10px">
		<td class="REGULARTEXT" align="left" style="padding-top: 30px" colspan="2">* marks a manadatory field</td>
		<td colspan="2">&nbsp;</td>
	</tr>
  <tr>
		<td colspan="3">&nbsp;</td>
	</tr>
	<tr height="10px">
		<td align="left" colspan="3">
			<div id="saveSearchErrorMsg" style="display:none;" class="ERROR_MSG">
			</div>
		</td>
	</tr>		
</table>
</form>