<%@ page language="java"%>

<%@ page import="java.util.*"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.helpers.SearchEngineAdminHelper"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.data.index.*"%>
<%@ page import="xpolog.eye.data.index.adapters.*"%>
<%@ page import="xpolog.eye.data.index.adapters.defaultadapter.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.cloud.*"%>
<%@ page import="xpolog.eye.logic.*"%>
<%@ page import="xpolog.eye.data.*"%>


<%!
	static final String BASE_DIRECTORY = "../";
	static final int NUMBER_OF_PAGE_LINKS = 20;
%>

<%!
	String getPagesList(String[] pagesList, int currentPage, int resultFrom, int resultTo, int totalResults){
		StringBuffer sb = new StringBuffer();
		if (pagesList == null){
			return "";
		}
		sb.append("<tr>");
		sb.append("<td align=\"left\"><table border=\"0\"><tr>");
	
		if (resultFrom > 0){
			sb.append("<td><a class=\"LINK\" href=\"javascript:doPrev()\">prev</a></td>");
			sb.append("<td><a class=\"LINK\" href=\"javascript:doPrev()\">");
			sb.append("<img alt=\"backfords records\" title=\"backfords records\" border=\"0\" src=\""+BASE_DIRECTORY+"images/logview/prev.png\"></a></td>");
		}else{
			sb.append("<td>&nbsp;</td>");
		}
		if (resultTo < totalResults){
			sb.append("<td>&nbsp;<a class=\"LINK\" href=\"javascript:doNext()\">");
			sb.append("<img alt=\"backfords records\" title=\"backfords records\" border=\"0\" src=\""+BASE_DIRECTORY+"images/logview/next.png\"></span></a></td>");
			sb.append("<td><a class=\"LINK\" href=\"javascript:doNext()\">next</a></td>");
		}else{
			sb.append("<td>&nbsp;</td>");
		}
		sb.append("</tr></table></td>");
		sb.append("</tr>");
		sb.append("<tr><td>&nbsp;</td></tr>");
		return sb.toString();
	}
%>

<%@ include file="moduleTree.jsp"%>

<%
  //constants
  String ERROR_OBJ = "ERROR_OBJ";
  String RECORD_BROWSER = "RECORD_BROWSER";
  
  //site management
	final UserEnvironment env = UserEnvironment.getUserEnvironment(request);  	
  SiteManagment mgmt = SiteManagment.getInstance();
  SearchEngineConfiguration searchEngineConfig = SearchEngineManager.getInstance().getConfiguration();

  //UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
  HashMap modulesMap = new HashMap();
  HashMap logsMap = new HashMap();
  Properties prop = Configuration.getInstance().getUIData();

  String img = BASE_DIRECTORY+"/"+prop.getProperty("search.xplgsearchlarge.image");

	UserSearches userSearches = env.getUserSearches();
	UserSearch userSearch = null;
	String userSearchId = request.getParameter("SEARCH_ID");
	String searchTerm = "";
	String searchIn = "";
	String[] logsArr = null;
	String[] modulesArr = null;
	String[]  hosts = null;
	boolean onlyIndexed = false;
	String findResults = "";
	String reformattedSearchTerm = "";
	String matchWholeWordsOnlyStr = request.getParameter("matchWholeWordsOnlyStr");
	boolean matchWholeWordsOnly = true; 

  searchTerm = request.getParameter("searchTerm");
  
	if (userSearchId != null && !userSearchId.equals("")){
		userSearch = userSearches.getUserSearch(userSearchId);
		if (userSearch != null){
			searchTerm = userSearch.getSearchString();
			onlyIndexed = userSearch.isOnlyIndexed();
			logsArr = userSearch.getLogs();
			modulesArr = userSearch.getModules();
			findResults = userSearch.isFindAllWords() ? "allWords" : "";
			hosts = userSearch.getHosts();
			matchWholeWordsOnly = userSearch.isMatchWholeWordsOnly();
		} else {
			userSearchId = "";
			userSearch = null;
		}
	}
	if (userSearchId == null || userSearchId.equals("")) {
		userSearchId = "";
	  if (searchTerm == null){
	  	searchTerm = "";
	  }
	  searchIn = request.getParameter("searchIn");
	  if (searchIn == null){
	  	searchIn = "";
	  }
		onlyIndexed = searchIn.equals("only selected logs");
		matchWholeWordsOnly = matchWholeWordsOnlyStr==null || matchWholeWordsOnlyStr.equals("true");
	}
	reformattedSearchTerm = searchTerm.replaceAll("&quot;","\"");	
	
	if (findResults == null || findResults.equals("")){
		findResults = request.getParameter("findResults");
	}
	if (findResults == null){
		findResults = "";
	}

	String treeCode = null;
	if (onlyIndexed || treeCode == null){
	  logsArr = request.getParameterValues("logs");
	  if (logsArr != null){
	  	for (int i=0; i<logsArr.length; i++){
	  		logsMap.put(logsArr[i],logsArr[i]);
	  	}
	  }
	  modulesArr = request.getParameterValues("modules");
	  if (modulesArr != null){
	  	for (int i=0; i<modulesArr.length; i++){
	  		modulesMap.put(modulesArr[i],modulesArr[i]);
	  	}
	  }
	  treeCode = getTreeDiv(curmod,userContext,modulesMap,logsMap,true,true,false,false);
  }
  
  if (hosts == null){
    hosts = request.getParameterValues("hosts");
  }
  if (hosts == null){
    hosts = new String[] {"localhost"};
  }
  
  String[] listOfPages = null;
  String pagesCode = "";
	int currentPage = 1;
	
  HashSet selLogs = new HashSet();
  
	SearchQuery searchQuery = null;
	SearchResults results = null;
	
	String goToPageStr = request.getParameter("goToPage");
	int goToPage = -1;
	if (goToPageStr != null){
		try {
			goToPage = Integer.parseInt(goToPageStr);
		}catch (NumberFormatException e){}
	}
	
	
	String lastSearchTerm = userSearches.getLastSearchedTerm();
	int totalResults = 0;
  int resultsPerPage = 0;
  int resultFrom = 0;
  int resultTo = 0;
  
  String refreshMenuStr = request.getParameter("refreshMenu");
  boolean refreshMenu = refreshMenuStr != null && refreshMenuStr.equals("true");
	String resultsPerPageStr = request.getParameter("resultsPerPage");
	if (resultsPerPageStr != null && !resultsPerPageStr.equals("")){
		resultsPerPage = Integer.parseInt(resultsPerPageStr);
	}else {
	  resultsPerPage = searchEngineConfig.getResultsPerPage();
  }
  float searchTime = 0;
  
	String op = request.getParameter("op");
	if (op == null || op.equals("")){
		op = "CURRENT";
	}
	MultiRecordsMaskTableModel model = null;
	if (!searchTerm.equals("")){
		if (userSearch != null){
			results = userSearch.getResults();
		}
		else {
			userSearch = userSearches.getLastSearch();
			if ((!op.equals("CURRENT") || !op.equals("BYTIME") || goToPage!=-1) && userSearch != null && userSearch.getSearchString().equals(searchTerm) &&
					(!userSearch.isOnlyIndexed() && !onlyIndexed ||
					(userSearch.isOnlyIndexed() && onlyIndexed && Arrays.equals(userSearch.getLogs(),logsArr))) &&
					userSearch.isFindAllWords() == findResults.equals("allWords") && userSearch.isMatchWholeWordsOnly() == matchWholeWordsOnly
				){
				userSearch = userSearches.getLastSearch();				
			} else {
				
				UserSearch uSearch = userSearches.getUserSearchBySearchTerm(searchTerm);
				if (uSearch != null){
					userSearches.removeSearch(uSearch.getId());
				}		
				userSearch = new UserSearch();
				userSearch.setSearchString(reformattedSearchTerm);
				userSearch.setUserContext(userContext);
				userSearch.setLogs(logsArr);
				userSearch.setOnlyIndexed(onlyIndexed);
				userSearch.setFindAllWords(findResults.equals("allWords"));
				userSearch.setHosts(hosts);
				userSearch.setMatchWholeWordsOnly(matchWholeWordsOnly);
				userSearch.updateSearchTerm();
				searchTerm = userSearch.getSearchString();
				userSearch.doSearch();
				userSearches.addUserSearch(userSearch.getId(), userSearch);
				userSearches.setLastSearchedTerm(searchTerm);
				refreshMenu = true;
			}
			
			results = userSearch.getResults();
		  searchTime = userSearch.getSearchTime();
		}
		
		SearchResultsRecordsBrowser browser = (SearchResultsRecordsBrowser)request.getSession().getAttribute(RECORD_BROWSER);
		if(browser == null){
			browser = new SearchResultsRecordsBrowser((LogSearchResults)userSearch.getResults(),userSearch);
			request.getSession().setAttribute(RECORD_BROWSER,browser);
		}
	    String[] pages = results.getPagesList(resultsPerPage);

		userSearches.setLastSearch(userSearch);
	    totalResults = results.length();
		model = browser.getNextRecords();
	    if (op.equals("CURRENT")){
			model = browser.getCurrentRecords();
		} else if (op.equals("NEXT")){
			model = browser.getNextRecords();
		} else if (op.equals("PREV")){
			model = browser.getPrevRecords();
		} 
		
		
		
	  resultFrom = userSearch.getResults().getFirstResultPosition();
	  resultTo = userSearch.getResults().getLastResultPosition();
	  currentPage = userSearch.getResults().getCurrentPage(resultsPerPage);
	  pagesCode = getPagesList(pages,currentPage,resultFrom,resultTo,totalResults);
	}

  String searchTermForLogview = SearchEngineAdminHelper.parseSearchTerm(searchTerm);
  String searchRegExp = "";
  if (searchTerm.indexOf(" ")!=-1 || searchTerm.indexOf("*")!=-1 || searchTerm.indexOf("?")!=-1){
  	searchRegExp = "&searchRegExp=true";
  }
  CloudMgr cmg =	SiteManagment.getInstance().getCloudMgr();
  XplgNode[] enterpriseNodes = CloudUtil.sortArrayByName(cmg.getAllXplgNodes());
  HashSet selectedHosts = new HashSet();
  for(int i = 0;i < hosts.length;i++){
    selectedHosts.add(hosts[i]);
  }
  String minusImg = BASE_DIRECTORY + prop.getProperty("logview.minus.image");
  String plusImg = BASE_DIRECTORY + prop.getProperty("logview.plus.image");
  
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script>
	function showHideLogs(){
		show = document.getElementById("defShowLink").style.display == "";
		if(show){
			document.getElementById("modTree").style.display  = "";
			document.getElementById("defShowLink").style.display="none";
			document.getElementById("defHideLink").style.display="";    		
		}else{
			document.getElementById("modTree").style.display  = "none";
			document.getElementById("defShowLink").style.display="";
			document.getElementById("defHideLink").style.display="none";
		}	
	}
	
	function showHideLine(){
		show = document.getElementById("onlyIndexed").checked == true;
		if(show){
			document.getElementById("modTree").style.display  = "none";
			document.getElementById("defShowLink").style.display="";
			document.getElementById("defHideLink").style.display="none";
		}else{
			document.getElementById("modTree").style.display  = "none";
			document.getElementById("defShowLink").style.display="none";
			document.getElementById("defHideLink").style.display="none";
		}
	}
	
	function showHideAdvanced(){
		show = document.getElementById("advanced").style.display == "";
		if(show){
			document.getElementById("advanced").style.display  = "none";
		}else{
			document.getElementById("advanced").style.display = "";
			document.getElementById("advanced").style.display = "";
		}
		showHideLine();
	}
	
	function showHideTips(){
		show = document.getElementById("tips").style.display == "";
		if(show){
			document.getElementById("tips").style.display  = "none";
		}else{
			document.getElementById("tips").style.display = "";
			document.getElementById("tips").style.display = "";
		}
		showHideLine();
	}
	
	function go(){
		formatQuery();
		if (document.access.matchWholeWordsOnly.checked == true){
			document.access.matchWholeWordsOnlyStr.value = "true";
		}else{
			document.access.matchWholeWordsOnlyStr.value = "false";
		}
		document.access.submit();
	}
	
	
	
	function init(){
		<%if (onlyIndexed){%>
			document.getElementById("searchIn").selectedIndex = 1;
			showHideLine();
		<%}%>
		<%if (refreshMenu){%>
			refreshMenus();
		<%}%>
	}
	
	function doNext(){
		formatQuery();
		document.access.action="searchByTime.jsp";
		document.access.op.value = "NEXT";
		document.access.submit();
	}
	
	function doPrev(){
		formatQuery();
		document.access.action="searchByTime.jsp";
		document.access.op.value = "PREV";
		document.access.submit();
	}
	
	function doFirst(){
		formatQuery();
		document.access.op.value = "FIRST";
		document.access.submit();
	}
	
	function doLast(){
		formatQuery();
		document.access.op.value = "LAST";
		document.access.submit();
	}
	
	function goToPage(page){
		formatQuery();
		document.access.goToPage.value = page;
		document.access.submit();
	}
	
	function doCheckSearch(e){
		var result = doCheck(e);
		if (!result){
			formatQuery();
			go();
		}
		return result;
  }

	function doCheck(e){
		if (!e) var e = window.event;
		if (e.keyCode) code = e.keyCode;
		else if (e.which) code = e.which;
		if (code == 13){
		  return false;
		}
		return true;
  }
  
  function formatQuery(){
  	//while(document.access.searchTerm.value.indexOf('"')!=-1){
	  	//document.access.searchTerm.value = document.access.searchTerm.value.replace(/"/,"&quot;");
	  //}
  }
  
  function selectAllNodes(){
  	for (var i=0; i<=<%=(enterpriseNodes!=null?enterpriseNodes.length:0)%>; i++){
  		document.access.hosts[i].checked = true;
  	}
  }
  
  function clearAllNodes(){
  	for (var i=0; i<=<%=(enterpriseNodes!=null?enterpriseNodes.length:0)%>; i++){
  		document.access.hosts[i].checked = false;
  	}
  }
  
  function showLogs(){
  	    formatQuery();
		document.access.op.value = "CURRENT";
		document.access.submit();
  }
  
  </script>
  <script>
 var posX = 100;
    var posY = 100;
	function hideOrShow(divid){
		if(layerSetup(divid).style.display == 'none'){
		 posX=posX++;
		 posY=posY++;
		 showDiv(divid,posX,posY);
		}else{
		 hideDiv(divid);
		}

	}
	function layerSetup(id) {
		theObj = document.getElementById(id);
		return theObj;
	}
	function getHeight(id) {
		theHeight = layerSetup(id).offsetHeight;
		return theHeight;
	}
	function showDiv(id,posX,posY) {
		layerSetup(id).style.display = 'block';
		layerSetup(id).style.left = parseInt(posX);
		layerSetup(id).style.top = parseInt(posY);
		layerSetup("im" + id).src = "<%=minusImg%>";
	}
	function hideDiv(id) {
		layerSetup(id).style.display = 'none';
		layerSetup("im" + id).src = "<%=plusImg%>";
	}
	
	  var oldtr;
	function setRowInFocus(tr){
		reset();
                color = 'black';
                style = 'solid';
                lwidth = '1';
		oldtr = tr;
		tdlist = tr.getElementsByTagName("td");
		for(i =0; i<tdlist.length;++i){
                        if(tdlist[i].parentNode != tr){
                          continue;
                        }
			if(i==0){
				tdlist[i].style.borderLeftStyle = style;
				tdlist[i].style.borderLeftWidth = lwidth;
				tdlist[i].style.borderLeftColor = color;
			}else if(i==tdlist.length-1){
				tdlist[i].style.borderRightStyle = style;
				tdlist[i].style.borderRightWidth = lwidth;
				tdlist[i].style.borderRightColor = color;

			}
			tdlist[i].style.borderBottomStyle = style;
			tdlist[i].style.borderTopStyle = style;
			tdlist[i].style.borderBottomWidth = lwidth;
			tdlist[i].style.borderTopWidth = lwidth;
			tdlist[i].style.borderBottomColor= color;
			tdlist[i].style.borderTopColor= color;
		}
	}

	function reset(){
		if(!oldtr){
			return;
		}
		tdlist = oldtr.getElementsByTagName("td");
		for(i =0; i<tdlist.length;++i){
			if(i==0){
				tdlist[i].style.borderLeftStyle='';
			}else if(i==tdlist.length-1){
				tdlist[i].style.borderRightStyle='';
			}
			tdlist[i].style.borderBottomStyle = '';
			tdlist[i].style.borderTopStyle = ''
		}

	}


function doSort(index){
  document.access.sortIndex.value = "" + index;
  document.access.submit();
}

function doCancelSort(){
  document.access.sortIndex.value = "-1";
  document.access.submit();
}

function zoomIn(key){
   if (parent){
    parent.zoomIn(key);
  }
}

function createNewDataRefBuilder(){
  return parent.createNewDataRefBuilder();
}



function hideDetailsFrame(){
	document.getElementById("transDetails").style.display = "none";
}

function showHideMergeWindow(){

		show = document.getElementById("merge").style.display == "";
		if(show){
			document.getElementById("merge").style.display  = "none";
		}else{
		    document.getElementById("merge").style.display = "";
			document.getElementById("merge").style.display = "";
			document.getElementById("merge").innerHTML = "<iframe width='100%' height='500' src='searchMergeAdmin.jsp?SEARCH_ID=' + '<%=userSearchId%>'></iframe>";
		}
		//showHideLine();
  	
  }

  
</script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>

</head>
<body onLoad="javascript:init()">
<form AUTOCOMPLETE="OFF" id="access" name="access" METHOD="POST" ACTION="search.jsp">
<input type="hidden" name="op">
<input type="hidden" name="goToPage">
<input type="hidden" name="matchWholeWordsOnlyStr">
<!--<input type="hidden" name="SEARCH_ID" value="<%=userSearchId%>">-->
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%"  height="100%">
            	
              <tr>
                <td width="3%" height="100%">&nbsp;</td>
                <td width="43%" height="100%">&nbsp;</td>
                <td width="50%" height="100%">&nbsp;</td>
              </tr>
              <%if (searchTerm.equals("")){%>
              <tr>
                <td colspan="3" align="center">
                	<table width="100%">
                		<tr>
                			<td align="center"><img width="225" height="115" src="<%=img%>"></td>
                			<td width="50">&nbsp;</td>
                		</tr>
                	</table>
                </td>
              </tr>
              <tr>
                <td colspan="3">&nbsp;</td>
              </tr>
              <%}%>
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%" <%=searchTerm.equals("")?"align=\"center\"":""%>>
                <table border="0" width="100%" cellpadding="0" cellspacing="0" style="border-collapse: collapse" <%=searchTerm.equals("")?"align=\"center\"":""%>  height="53">
                  <tr>
                    <td>
                      <table border="0" width="100%">
                        <tr>
                          <td <%=searchTerm.equals("")?"align=\"center\"":""%>>
												    <table border="0" width="660" bgcolor="white">
															<tr>
																<td width="130" valign="bottom">
			                          	<span class="REGULARTEXT" style="font-weight: bold;"><nobr>Search for: &nbsp;</nobr></span>
																</td>
																<td width="410" valign="bottom">
			                          	<input class="TEXTBOX" type="text" id="searchTerm" name="searchTerm" size="60" value="<%=xpolog.eye.util.XpologUtil.replaceAll(searchTerm,"\"","&quot;")%>" onKeyPress="return doCheckSearch(event)">
																</td>
																<td width="20" valign="bottom">
		  	                        	<a href="javascript:go()" class="LINK">go</a>&nbsp;&nbsp;
																</td>
																<td width="100" rowspan="2" valign="top">
																  <table border="0" width="100%" cellspacing="0" cellpadding="0">
																  <tr><td align="left" colspan="2">
		  	                        	<a href="javascript:showHideAdvanced()" class="SMALLLINK">advanced</a>
		  	                        	</td></tr>
																  <tr>
																  <td align="left">
		    	                      	<a href="javascript:showHideTips()" class="SMALLLINK">tips</a>
		    	                      	</td>
																  <td align="left">
		    	                      	<a href=javascript:openHelp('<%=BASE_DIRECTORY%>',"SearchEngine.htm") class="SMALLLINK">help</a>
		    	                      	</td>
		    	                      	</tr>
		    	                      	</table>
																</td>
															</tr>			
															<tr>
																<td>&nbsp;</td>
																<td><input type="checkbox" name="matchWholeWordsOnly" id="matchWholeWordsOnly" <%=matchWholeWordsOnly?"checked":""%>> <span class="SMALLLINK">search whole words only</span></td>
																<td colspan="2">&nbsp;</td>
															</tr>
											      </table>
                          </td>
                        </tr>
                        <tr>
                        	<td colspan="3"></td>
                        </tr>
                        <tr>
                        	<td colspan="3"></td>
                        </tr>
						
						 <tr>
			                    <td>
			                    	<div id="tips" style="display:none">
				                    	<table width="100%" border="0" style="border-style:solid; border-width:2px;">
			                        		<tr><td class="REGULARTEXT"><b>Search Tips</b></td></tr>
			                        		<tr><td >&nbsp;</td></tr>
			                        		<tr><td class="SMALLTEXT"><li><b>regular expressions:</b> you may use '*' or '?' in a regular expression search.</li></td></tr>
			                        		<!--<tr><td class="SMALLTEXT"><li><b>" ":</b> use quote to search the expression as inserted, quoted expressions are searched case sensitive.</li></td></tr>-->
			                        		<tr><td class="SMALLTEXT"><li><b>advanced:</b> use the advanced section on this page to configure the search properties.</li></td></tr>	            			                        
			                         	</table>
				                    </div>
				                 </td>
			                  </tr>
						
			                  <tr>
			                    <td>
			                    	<div id="advanced" style="display:none">
				                    	<table width="100%" border="0" style="border-style:solid; border-width:2px;">
			                        <tr><td class="REGULARTEXT"><b>Advanced search information</b></td></tr>
			                        <tr><td >&nbsp;</td></tr>
			                        <tr>
			                        	<td><span class="REGULARTEXT">
			                        	<b>Results per page: </b><input type="text" name="resultsPerPage" value="<%=resultsPerPage%>" size="3">
			                        	</span></td>
			                        </tr>
			                        <tr><td class="SMALLTEXT">&nbsp;</td></tr>
			                        <tr>
			                        	<td>
				                        	<table border="0">
					                        	<tr>
						                        	<td width="100" style="vertical-align:top"><span class="REGULARTEXT"><b>Find results: </b></span></td>
						                        	<td>
						                        		<table border="0" cellpadding="0" cellspacing="0">
							                        		<tr>
								                        		<td class="REGULARTEXT" valign="bottom">
								                        			<input type="radio" name="findResults" id="allWords" value="allWords" <%=findResults.equals("allWords")?"checked":""%>>with all of the words</input><nobr>
								                        		</td>
							                        		</tr>
							                        		<tr>
								                        		<td class="REGULARTEXT" valign="bottom">
								                        			<input type="radio" name="findResults" id="atLeastOneWord" value="atLeastOneWord" <%=!findResults.equals("allWords")?"checked":""%>>with at least one of the words</input>
								                        		</td>
							                        		</tr>
						                        		</table>
						                        	</td>
					                        	</tr>
				                        	</table>
			                        	</td>
			                        </tr>
			                        <tr><td class="SMALLTEXT">&nbsp;</td></tr>
			                        <tr>
			                        	<td><span class="REGULARTEXT"><b>Search in: </b></span></td>
			                        </tr>
			                        <tr>
			                        	<td>
			                        		<table border="0" cellpadding="0" cellspacing="0">
				                        		<tr>
					                        		<td class="REGULARTEXT" valign="bottom">
					                        			<input type="radio" name="searchIn" id="all" value="all indexed logs" <%=onlyIndexed?"":"checked"%> onclick="javascript:showHideLine()">all indexed logs </input><nobr>
					                        			<input type="radio" name="searchIn" id="onlyIndexed" value="only selected logs" <%=onlyIndexed?"checked":""%> onclick="javascript:showHideLine()">only selected logs</input>
					                        		</td>
					                        		<td>&nbsp;&nbsp;</td>
					                        		<td valign="bottom">
						                        		<a href="javascript:showHideLogs()" class="LINK"><div id="defShowLink" style="display:none">Select indexed logs</div><div id="defHideLink" style="display:none">Hide selected logs</div></a>
					                        		</td>
				                        		</tr>
							                    	<tr>
							                    		<td colspan="3">
										                    <div id="modTree" style="display:none">
								                        <%=treeCode%>
										                    </div>
							                    		</td>
								                    </tr>																		
			                        		</table>
																</td>
			                        </tr>
			                        <%if (enterpriseNodes != null && enterpriseNodes.length > 0){		%>																  
			                        <tr>
			                        	<td>
																	<table border="0" cellpadding="0" cellspacing="0">
																	<tr>
																	<td><span class="REGULARTEXT"><b>Search on: </b></span></td>
																	<td width="10">&nbsp;</td>
																	<td><a href="javascript:selectAllNodes()" class="SMALLLINK">select all</a></td>
																	<td width="10">&nbsp;</td>
																	<td><a href="javascript:clearAllNodes()" class="SMALLLINK">clear all</a></td>
																	</tr>
																	</table>
			                        	<td>
			                        </tr>
			                        <tr>
			                        	<td>
			                        		<table border="0" cellpadding="0" cellspacing="0">
				                        		<tr>
					                        		<td class="REGULARTEXT" >
			                         
																		
				                        		<tr colspan="3">
					                        		<td class="REGULARTEXT" valign="bottom">
					                        			<input type="checkbox" name="hosts" id="localhost" value="localhost"  <%=selectedHosts.contains("localhost")?"checked" : ""%>>Local Host					                        			
					                        		</td>
				                        		</tr>
				                        		<% for (int i = 0; i < enterpriseNodes.length;i++){%>
				                        		<tr>
							                    		<td colspan="3">
										                    <input type="checkbox" name="hosts" id="<%=enterpriseNodes[i].getId()%>" value="<%=enterpriseNodes[i].getId()%>"  <%=selectedHosts.contains(enterpriseNodes[i].getId())?"checked" : ""%>><nobr><%=enterpriseNodes[i].getName()%></nobr>
							                    		</td>
								                    </tr>
																		<%}%>
																		</table>
																</td>
			                        </tr>
			                        <%}%>
					                    </table>
				                    </div>
				                    
			                    </td>
			                  </tr>
			                
                      </table>
                    </td>
                  </tr>
                  <tr><td>&nbsp;</td></tr>
                  <%
                  if (results != null){
                  	HashMap resultsMap = new HashMap();
                  %>
                  <tr>
                  	<td>
                  		<table border="0" width="100%">
                  			<tr width="100%">
                  				<td class="SEARCHRESULT" nowrap><b><a href="javascript:showLogs()" class="LINK">Logs</a> / <a href="javascript:showHideMergeWindow()" class="LINK">Merge results</a> / Events by time </b><nobr>
                  				<!--
                  				<span style="text-align:right; width:73%">
                  					results <b><%=resultTo>0?resultFrom+1:0%></b> - <b><%=resultTo%></b> of <b><%=totalResults%></b>
                  					&nbsp;&nbsp;<span style="font-size: 12; vertical-align:middle">(<b><%=searchTime%></b> seconds)</span>
                  				</span>
                  				-->
                  				</td>
                  			</tr>
									      <tr>
									        <td valign="bottom" height="10%">
									        <table border="0" width="100%">
									          <tr>
									            <td width="100">&nbsp;</td>
									            <td width="50" colspan="2" align="center">
									              <table border="0" width="100%">
									              	<!--
									                <tr>
									                	<td width="20%">&nbsp;</td>
									                  <td width="20%" align="center">
									                  	<%if (resultFrom > 0){%>
									                  	<a href="javascript:doPrev()" class="LINK">previous</a>
									                  	<%} else {%>
									                  	&nbsp;
									                  	<%}%>
									                  </td>
									                  <td width="20%" align="center">
									                  	<%if (resultTo < totalResults){%>
									                  	<a href="javascript:doNext()" class="LINK">next</a>
									                  	<%} else {%>
									                  	&nbsp;
									                  	<%}%>
									                  </td>
									                  
									                	<td width="10%">&nbsp;</td>
									                </tr>
									                -->
									                <%=pagesCode%>
									              </table>
									            </td>
									            <td width="70%">&nbsp;</td>
									          </tr>
									        </table>
									        </td>
									      </tr>
									      <tr><td width="100%" height="100%"><div id="merge" style="display:none"></div></td></tr>
                  			<%
                  			
                  			for (int i=0; i< model.getRowCount(); i++){
                  				LogSearchRecord record = (LogSearchRecord)model.getRecordAt(i);
                  				ArrayList lista = new ArrayList();
								lista.add(record);
								RecordsResult s = new RecordsResult();
								s.setRecords(lista);
								MultiRecordsMaskTableModel model1 = new MultiRecordsMaskTableModel(s,model.getMaskers(),model.getCustomMgrs(),model.getFilterMgrs(),model.getBackgroundColors());
								MultiHeaderLogEyeModel m = new MultiHeaderLogEyeModel(BASE_DIRECTORY,model1);
								MultiHeaderOHtmlTable t = new MultiHeaderOHtmlTable(m);
								t.setRowRenderer(new MultiHeaderLogEyeRowRenderer(m));
								t.setCellRenderer(new MultiHeaderLogEyeCellRenderer(m));
								try{
								t.render();
								}catch(Exception e){
									e.printStackTrace();
								}
								String recordTable = t.getHtml();
								
                  				LogSearchResult result = record.getLogSearchResult();
                  				
                  				
            
                  				String logId = result.getLogId();
                  				String logName = result.getLogName();
                  				long lastIndexed0 = result.getIndexingDate();
                  				//Date lastIndexed = new Date(lastIndexed0);
                  				String lastIndexed = DateUtil.formatDate(lastIndexed0,"dd/MM/yyyy HH:mm:ss");
                  				String hostId = result.getHostId();
                  				XplgNode node = null;
                  				if (hostId != null && hostId.length() > 0){
                   					node = cmg.getNodeById(hostId);
                   				}
                  				String parentModule = result.getParentModuleName();
                  				String logSearchTerm = xpolog.eye.util.XpologUtil.replaceAll(searchTerm,"%","%25"); 
                  				logSearchTerm = xpolog.eye.util.XpologUtil.replaceAll(logSearchTerm,"&","%26"); 
													 logSearchTerm = xpolog.eye.util.XpologUtil.replaceAll(logSearchTerm,"#","%23"); 
													 logSearchTerm = xpolog.eye.util.XpologUtil.replaceAll(logSearchTerm,"+","%2B"); 
                  				 logSearchTerm = xpolog.eye.util.XpologUtil.replaceAll(logSearchTerm,"&quot;","\\&quot;"); 
						 							logSearchTerm = xpolog.eye.util.XpologUtil.replaceAll(logSearchTerm,"\"","\\&quot;"); 
                  				String logPath = "loggers/logview.jsp?gotoMain=true&opdirect=START&logid=" + logId + "&searchEngineSearchTerm=" + logSearchTerm + "&searchEngineAllWords=" + findResults + "&matchWholeWordsOnly="+matchWholeWordsOnly + "&dataRef=dataRef";
                  				String target = null;
                  				if (node != null){
                  				
                  				  logPath = "root.html?mainPage=loggers/logview.jsp?gotoMain=true%25%26logid=" + logId + "%2526searchEngineSearchTerm=" + logSearchTerm + "%2526searchEngineAllWords=" + findResults;
                  				  logPath = "cloud/cloudAction.jsp?NODE_ID=" + node.getId() + "&sucUrl=" + logPath + "&FailUrl=javascript:history.go(-1)&externalRef=true";
                  				  target = node.getId();
                  				}
                  				logPath = BASE_DIRECTORY + logPath;
                  			%>
                  			<tr>
                  				<td>
                  					<!--<span class="REGULARTEXT"><a href="<%=BASE_DIRECTORY%>loggers/logview.jsp?logid=<%=logId%>&search=<%=searchTermForLogview%><%=searchRegExp%>" class="LINK"><%=logName%></a></span>-->
                  					<span class="REGULARTEXT"><a href="<%=logPath%>" class="LINK"  <%=target != null ? "target=\"" + target + "\"" : ""%> ><%=logName%></a></span>
                  					<span class="SMALLTEXT">&nbsp;&nbsp(<b>lastIndexed: <%=lastIndexed%></b>)</span>
                  				</td>
                  			</tr>
             						<tr><td class="SMALLTEXT">Folder: <%=parentModule%></td></tr>
             						<tr><td class="SMALLTEXT"><%=result.getDataSourcesAsString()%></td></tr>
             						<% if (node != null){ %>
             						<tr><td class="SMALLTEXT">
             						  Host: <a href="<%=BASE_DIRECTORY%>cloud/cloudAction.jsp?NODE_ID=<%=node.getId()%>&externalRef=true" class="SMALLLINK" <%=target != null ? "target=\"" + target + "\"" : ""%>><%=node.getName()%></a>
             						 </td></tr>
             						<%}%>
             						<tr><td class="SMALLTEXT" width="650" >Event: <%=recordTable%></td></tr>
             						<tr><td>&nbsp;</td></tr>
                  			<%} //end for%> 
                  			<%if (results.length()==0){%>
             						<tr><td class="REGULARTEXT">No logs were found containing <b>"<%=searchTerm%>"</b></td></tr>
                  			<%}%>
                  		</table>
                  	</td>
                  </tr>
                  <%} //end if%>
                  
                  <tr>
                    <td height="100%"></td>
                  </tr>
                   <%if (XpologLicenseManager.getInstance().isDemo()){                  
                  %>
                  <tr>
       						 <td align="center">
        						<span class="LICENSEMESSAGE">Search Engine is not available in trial version</span>
       						 </td>
     						 </tr>
      						<%}%>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>

      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="100">&nbsp;</td>
            <td width="50" align="center">
              <table border="0" width="100%">
                <%=pagesCode%>
              </table>
            </td>
            <td width="70%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>