<%@ page language="java"%>

<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.data.index.*"%>
<%@ page import="xpolog.eye.data.index.adapters.defaultadapter.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.admin.helpers.SearchEngineAdminHelper"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	ErrorModel errmodel = new ErrorModel(); 
	 
	String op = request.getParameter("op");
	String message = "";
	 
	LogsIndexerRunner runner = SearchEngineManager.getInstance().getCustomIndexerRunner();
	String [] logsArr = null;
	if (op != null && op.equals("stop")){
		runner.cancel();
		message = "Indexing was stopped. Optimizing the indexed data might take a couple of minutes, depending on the size of the log.";
	}else {	 
		logsArr = null;

	 	String logsList = request.getParameter("logs");
	 	if (logsList != null && logsList.length() > 0){
	 		logsArr = logsList.split(",");
	 	}

		HashMap logs = new HashMap();
	  if (logsArr != null){
	    for (int i = 0;i< logsArr.length;i++){
	      logs.put(logsArr[i],logsArr[i]);
	    }
	  }
		HashMap mods = new HashMap();
		String [] modsArr = null;
		String modsList = request.getParameter("mods");
		if (modsList != null && modsList.length() > 0){
			modsArr = modsList.split(",");
		}
		if (modsArr != null){
			for (int i = 0;i< modsArr.length;i++){
				mods.put(modsArr[i],modsArr[i]);
			}
		}
		if (modsArr != null){
			for (int i = 0;i< modsArr.length;i++){
				String id = modsArr[i];
	     	if (modsArr[i].endsWith("*")){
					id = id.substring(0,id.length()-1);
					SearchEngineAdminHelper.addAllModuleChildren(id,mods,logs,userContext,true);
				}
				mods.put(id,id);
			}
		}
		logsArr = (String[])logs.keySet().toArray(new String[logs.size()]);
	   
	   if(logsArr == null || logsArr.length == 0){
	  	 errmodel.addError("No logs were selected.");
	   }
	   
	   if(errmodel.getErrorCount() != 0){
     	request.getSession().setAttribute(ERROR_OBJ,errmodel);
      response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
      return;
 	   }
   
	    
     boolean sucToRun = runner.executeIndexing(logsArr,userContext,"Manual indexing");
     message = sucToRun ? "Indexing started running." : "Indexing already running";
     request.getSession().removeAttribute("CURRENT_LOG");
   }
	 
	 //audit
	 String auditName = "";
	 for(int i=0;logsArr != null && i<logsArr.length;i++) {
		 auditName += logsArr[i];
		 if(logsArr.length-1 > i) {
			auditName += ", "; 
		 }
	 }     
     AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
     			userContext, AuditConstants.CHANGE, "run indexing manually", AuditConstants.SEARCH_ENGINE, "run indexing manually: " + auditName);	 	 	
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>

  function init() {
		operationOk();
	}

  function operationOk(){    
    document.location = "searchEngineIndexing.jsp";
  }

</script>
</head>

<body onload="javascript:init()">

<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
  <!--    <tr>
        <td valign="top" style="border-left: 1px solid #FF9900; border-right-width: 1; border-top-width: 1; border-bottom-width: 1" height="1">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="TOPLEFTBORDER" width="33%"  height="2"></td>
            <td class="TOPBORDER" width="33%" height="2"></td>
            <td class="TOPRIGHTBORDER"  width="34%" height="2"></td>
          </tr>
        </table>
        </td>
      </tr>-->
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Operation done.&nbsp;</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Custom Indexing</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="22">
                    <span class="REGULARTEXT"><%=message%></span>
                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>                  
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="35%">&nbsp;</td>
                <td width="11%" align="center">&nbsp;</td>
                <td width="7%" align="center"><a href='javascript:operationOk()'class="LINK">
                ok</a></td>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>