<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.scheduler.ui.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.index.*"%>
<%@ page import="xpolog.eye.admin.helpers.SearchEngineAdminHelper"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.indexing.*"%>
<%@ page import="xpolog.eye.data.index.adapters.defaultadapter.LogsIndexerRunner"%>
<%@ page import="xpolog.eye.site.ui.tree.ModuleMemberRenderer"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%!
  static final String BASE_DIRECTORY = "../";
%>
<%
	String ERROR_OBJ = "ERROR_OBJ";
	String SEARCH_ENG_MGR = "SEARCH_ENG_MGR";

	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	SiteAdministrator admin = SiteManagment.getAdminInstance();
	UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
	final UserContext userContext = UserEnvironment.getUserContext(request);

	final SearchEngineManager searchEngineMgr = SearchEngineManager.getInstance();
	final SearchEngineConfiguration searchEngineConfig = (SearchEngineConfiguration) SearchEngineManager.getInstance().getConfiguration().clone();

	ErrorModel errmodel = new ErrorModel();

	Map map = request.getParameterMap();
	final HashMap logs = new HashMap();
	final HashMap mods = new HashMap();
  String [] logsArr = null;
 	String logsList = request.getParameter("logs");
 	if (logsList != null && logsList.length() > 0){
 		logsArr = logsList.split(",");
 	}
  if (logsArr != null){
    for (int i = 0;i< logsArr.length;i++){
      logs.put(logsArr[i],logsArr[i]);
    }
  }

  String [] modsArr = null;
  String modsList = request.getParameter("mods");
  if (modsList != null && modsList.length() > 0){
  	modsArr = modsList.split(",");
  }
  if (modsArr != null){
    for (int i = 0;i< modsArr.length;i++){
    	if (!modsArr[i].endsWith("*")){
      	mods.put(modsArr[i],modsArr[i]);
    	}
    }
  }
  if (modsArr != null){
    for (int i = 0;i< modsArr.length;i++){
    	String id = modsArr[i];
    	if (modsArr[i].endsWith("*")){
     		id = id.substring(0,id.length()-1);
     		ModuleMemberRenderer.addAllModuleChildren(id,mods,logs);
     	}
      mods.put(id,id);
    }
  }

	String resultsPerPageStr = request.getParameter("resultsPerPage");
	int resultsPerPage = 10;
	if (resultsPerPageStr != null) {
		try{
			resultsPerPage = Integer.parseInt(resultsPerPageStr);
		}catch(Exception e){
			errmodel.addError("Failed to parse results per page");
		}
	}
	if (resultsPerPage == 0){
		errmodel.addError("Illegnal value of results per page");
		errmodel.addError("Please set results per page to a positive number");
	}

	String minDeltaStr = request.getParameter("minDelta");
	int minDelta = 1000000;
	if (minDeltaStr != null) {
		try{
	minDelta = Integer.parseInt(minDeltaStr.trim());
		}catch(Exception e){}
	}

	String cpuLimitStr = request.getParameter("cpuLimit");
	double cpuLimit = -1;
	if (cpuLimitStr != null && cpuLimitStr.length() > 0) {
		cpuLimit = Double.parseDouble(cpuLimitStr);
	}

	String indexNumbersStr = request.getParameter("indexNumbers");
	boolean indexNumbers = false;
	if (indexNumbersStr != null && indexNumbersStr.equals("true")) {
		indexNumbers = true;
	}

	String specialCharacters = request.getParameter("specialCharacters");
	if (specialCharacters != null) {
		specialCharacters = specialCharacters.trim();
		if (specialCharacters.length() == 0) {
	specialCharacters = null;
		}
	}

	String dirStr = request.getParameter("dir");
	String dirPath = null;
	if (dirStr != null && dirStr.equals("other")) {
		dirPath = request.getParameter("dirPath");
	}
	if (dirPath != null && dirPath.length() == 0) {
		dirPath = null;
	}
	String thresholdStr = request.getParameter("threshold");
	long threshold = -1;
	String thresholdUnitStr = request.getParameter("thresholdUnit");
	int thresholdUnit = -1;
	if (thresholdStr != null && thresholdStr.length() > 0){
		try{
			threshold = Long.parseLong(thresholdStr);
			if (thresholdUnitStr != null && thresholdUnitStr.length() > 0){
				thresholdUnit = Constants.InformationUnits.getUnit(thresholdUnitStr);
			}
		}catch(Throwable e){
			errmodel.addError("Wrong capacity value");
		}
	}
	List alternatePaths = new LinkedList();
	String numPathsStr = request.getParameter("numPaths");
	int numPaths = 3;
	if (numPathsStr != null && numPathsStr.length() > 0){
		try{
			numPaths = Integer.parseInt(numPathsStr);
		}catch(Throwable t){}
	}
	String alternatePath;
	String alternatePathThresholdStr;
	long alternatePathThreshold;
	String alternatePathThresholdUnitStr;
	int alternatePathThresholdUnit = -1;
	for (int i=0; i<numPaths; i++){
		alternatePath = request.getParameter("alternateDir" + i);
		if (alternatePath != null && alternatePath.length() > 0){
			alternatePathThresholdStr = request.getParameter("alternateThreshold" + i);
			if (alternatePathThresholdStr != null && alternatePathThresholdStr.length() > 0){
				try{
					alternatePathThreshold = Long.parseLong(alternatePathThresholdStr); 
				}catch(Throwable e){
					errmodel.addError("Wrong capacity value");
					break;
				}
				alternatePathThresholdUnitStr = request.getParameter("alternateThresholdUnit"+i);
				if (alternatePathThresholdUnitStr != null && alternatePathThresholdUnitStr.length() > 0){
					alternatePathThresholdUnit = Constants.InformationUnits.getUnit(alternatePathThresholdUnitStr);
				}
			}else{
				errmodel.addError("Missing capacity value");
				break;
				//alternatePathThreshold = -1;
				//alternatePathThresholdUnit = -1;
			}
			IndexingPath indexingPath = new IndexingPath(alternatePath,alternatePathThreshold,alternatePathThresholdUnit);
			alternatePaths.add(indexingPath);
		}
	}
	
	String id = null;
	SchedulingMgr smgr = XpoLogScheduleFactory.getSchdulingManager();
	//Scheduler Indexing
	id = searchEngineConfig.getIndexingJobId();
	ActionJobBuilder builder = null;
	String IndexSchedEnableStr = request.getParameter("IndexSchedEnable");
	boolean indexSchedEnable = IndexSchedEnableStr != null&& IndexSchedEnableStr.equalsIgnoreCase("on");

	XpoScheduledOperation op = smgr.getScheduedOp(id);
	builder = new ActionJobBuilder(op);
	builder.setKeepMisfireBehavior(true);
	builder.updateFromOp();
	builder.resetTriggers();
	String iterNumber, intervalTimeUnit, startDate;
	String endDate, interTime;
	String hours, minutTens, minutUnit, secTen, secUnit, trigType, timeType;
	String typeDay;
	String[] montharr, daywarr, dayInMonarr;
	String hoursInterval, minutesInterval;

	startDate = request.getParameter("startDateIndex");
	if(startDate == null) {
		startDate = "";
	}
	endDate = request.getParameter("endDateIndex");
	if(endDate == null) {
		endDate = "";
	}
	intervalTimeUnit = request.getParameter("intervalTimeUnitIndex");
	iterNumber = request.getParameter("iterationNumberIndex");
	interTime = request.getParameter("intervalTimeIndex");
	daywarr = request.getParameterValues("daywIndex");

	montharr = request.getParameterValues("MonthIndex");
	dayInMonarr = request.getParameterValues("DayInMonthIndex");
	hours = request.getParameter("HoursIndex");
	minutTens = request.getParameter("minutesTensIndex");
	minutUnit = request.getParameter("minutesUnitIndex");
	secTen = request.getParameter("secondTenIndex");
	secUnit = request.getParameter("secondUnitIndex");
	trigType = request.getParameter("trigTypeIndex");
	typeDay = request.getParameter("typeDayIndex");
	hoursInterval = request.getParameter("hoursIntervalIndex");
	minutesInterval = request.getParameter("minutesIntervalIndex");

	if (trigType == null || trigType.equals("")) {
		errmodel.addError("Global Scheduler - Please specify scheduling method");
	}

	if (trigType != null && trigType.equals("simple")) {
		if (interTime == null || interTime.equals("")) {
	errmodel.addError("Global Scheduler - Please specify Index interval period");
		}
		try {
	int i = Integer.parseInt(interTime);
	if (i <= 0) {
		errmodel.addError("Global Scheduler - Please specify a positive interval period");
	}
		} catch (Exception ie) {
	errmodel.addError("Global Scheduler - Interval period must be a valid positive number");
		}
	}

	if (trigType != null && trigType.equals("cron")) {
		if (typeDay == null || typeDay.equals("")) {
	errmodel.addError("Global Scheduler - Please specify schedule details");
		} else {
	if (typeDay.equals("dayOWeek")&& (daywarr == null || daywarr.length == 0)) {
		errmodel.addError("Global Scheduler - Please specify days in week");
	} else if (typeDay.equals("dayOMon")) {
		if (dayInMonarr == null || dayInMonarr.length == 0 
	|| montharr == null || montharr.length == 0) {
	errmodel.addError("Global Scheduler - Please specify months and days");
		}
	}
		}
	}
	
	if (errmodel.getErrorCount() == 0) {
		builder.setStartDate(startDate);
		builder.setEndDate(endDate);
	
		//simple or cron
		if (trigType.equals("simple")) {
			builder.setSimple(true);
			builder.setCron(false);
			builder.setIntervalTime(interTime);
			builder.setIntervalTimeUnit(intervalTimeUnit);
			builder.setIterationNumber(iterNumber);
		} else if (trigType.equals("cron")) {
			builder.setSimple(false);
			builder.setCron(true);
			if (typeDay.equals("dayOWeek")) {
		
		if (daywarr != null && daywarr.length > 0) {
			builder.setDayType(JobBuilder.DAY_OF_WEEK);
			Integer[] darr = new Integer[daywarr.length];
			for (int i = 0; i < darr.length; ++i) {
		darr[i] = new Integer(daywarr[i]);
			}
			builder.setDays(darr);
		}
			} else if (typeDay.equals("dayOMon")) {
		if (dayInMonarr != null && dayInMonarr.length > 0 && montharr != null
		&& montharr.length > 0) {
			builder.setDayType(JobBuilder.DAY_OF_MONTH);
			Integer[] darr = new Integer[dayInMonarr.length];
			
			for (int i = 0; i < darr.length; ++i) {
		if (dayInMonarr[i].equals("all")) {
			builder.setAllDayInMonth(true);
			darr = new Integer[0];
			break;
		}
		darr[i] = new Integer(dayInMonarr[i]);
			}
			builder.setDayInMonth(darr);
			Integer[] marr = new Integer[montharr.length];
			for (int i = 0; i < marr.length; ++i) {
		if (montharr[i].equals("all")) {
			builder.setAllMonth(true);
			marr = new Integer[0];
			break;
		}
		marr[i] = new Integer(montharr[i]);
			}
			builder.setMonth(marr);
		}
			}
	
			builder.setHours(hours);
			builder.setMinutesTen(minutTens);
			builder.setMinuteUnit(minutUnit);
			builder.setSecondTen(secTen);
			builder.setSecondUnit(secUnit);
			builder.setMinutesInterval(minutesInterval);
			builder.setHoursInterval(hoursInterval);
			if (minutTens.equals("0") && minutUnit.equals("0")&& minutesInterval.equals("1")) {
		builder.setEveryMinute(true);
			} else {
		builder.setEveryMinute(false);
			}
			if (hours.equals("0") && hoursInterval.equals("1")) {
		builder.setEveryHour(true);
			} else {
		builder.setEveryHour(false);
			}
		}
	}
	XpoScheduledOperation opsIndex = null;
	try {
		opsIndex = builder.buildXpoSchedOp();
		if (indexSchedEnable) {
	opsIndex.setActive();
		} else {
	opsIndex.setSuspend();
		}
	} catch (IllegalArgumentException e) {
		errmodel.addError("Global Scheduler - " + e.getMessage());
	} catch (Exception e1) {
		errmodel.addError("Global Scheduler - Invalid time rule. Please make sure the time rule is valid and try again");
	}

	//Scheduler Delta
	id = searchEngineConfig.getIncrementalIndexingJobId();

	String deltaSchedEnableStr = request.getParameter("DeltaSchedEnable");
	boolean deltaSchedEnable = deltaSchedEnableStr != null&& deltaSchedEnableStr.equalsIgnoreCase("on");

	String useIfIndexStr = request.getParameter("useIfIndex");
	boolean useIfIndex = useIfIndexStr != null&& useIfIndexStr.equalsIgnoreCase("on");

	op = smgr.getScheduedOp(id);
	builder = new ActionJobBuilder(op);
	builder.setKeepMisfireBehavior(true);
	builder.updateFromOp();
	builder.resetTriggers();
	iterNumber = null;
	intervalTimeUnit = null;
	startDate = null;
	endDate = null;
	interTime = null;
	hours = null;
	minutTens = null;
	minutUnit = null;
	secTen = null;
	secUnit = null;
	trigType = null;
	timeType = null;
	typeDay = null;
	montharr = null;
	daywarr = null;
	dayInMonarr = null;
	hoursInterval = null;
	minutesInterval = null;

	startDate = request.getParameter("startDateDelta");
	if(startDate == null) {
		startDate = "";
	}
	endDate = request.getParameter("endDateDelta");
	if(endDate == null) {
		endDate = "";
	}
	intervalTimeUnit = request.getParameter("intervalTimeUnitDelta");
	iterNumber = request.getParameter("iterationNumberDelta");
	interTime = request.getParameter("intervalTimeDelta");
	daywarr = request.getParameterValues("daywDelta");

	montharr = request.getParameterValues("MonthDelta");
	dayInMonarr = request.getParameterValues("DayInMonthDelta");
	hours = request.getParameter("HoursDelta");
	minutTens = request.getParameter("minutesTensDelta");
	minutUnit = request.getParameter("minutesUnitDelta");
	secTen = request.getParameter("secondTenDelta");
	secUnit = request.getParameter("secondUnitDelta");
	trigType = request.getParameter("trigTypeDelta");
	typeDay = request.getParameter("typeDayDelta");
	hoursInterval = request.getParameter("hoursIntervalDelta");
	minutesInterval = request.getParameter("minutesIntervalDelta");

	if (trigType == null || trigType.equals("")) {
		errmodel.addError("Delta Scheduler - Please specify scheduling method");
	}

	if (trigType != null && trigType.equals("simple")) {
		if (interTime == null || interTime.equals("")) {
	errmodel.addError("Delta Scheduler - Please specify interval period");
		}
		try {
	int i = Integer.parseInt(interTime);
	if (i <= 0) {
		errmodel.addError("Delta Scheduler - Please specify a positive interval period");
	}
		} catch (Exception ie) {
	errmodel.addError("Delta Scheduler - Interval period must be a valid positive number");
		}
	}
	if (trigType != null && trigType.equals("cron")) {
		if (typeDay == null || typeDay.equals("")) {
	errmodel.addError("Delta Scheduler - Please specify schedule details");
		} else {
	if (typeDay.equals("dayOWeek") && (daywarr == null || daywarr.length == 0)) {
		errmodel.addError("Delta Scheduler - Please specify days in week");
	} else if (typeDay.equals("dayOMon")) {
		if (dayInMonarr == null || dayInMonarr.length == 0 || montharr == null || montharr.length == 0) {
	errmodel.addError("Delta Scheduler - Please specify months and days");
		}
	}
		}
	}
	
	if (errmodel.getErrorCount() == 0) {
		builder.setStartDate(startDate);
		builder.setEndDate(endDate);
	
		//simple or cron
		if (trigType.equals("simple")) {
			builder.setSimple(true);
			builder.setCron(false);
			builder.setIntervalTime(interTime);
			builder.setIntervalTimeUnit(intervalTimeUnit);
			builder.setIterationNumber(iterNumber);
		} else if (trigType.equals("cron")) {
			builder.setSimple(false);
			builder.setCron(true);
	
			if (typeDay.equals("dayOWeek")) {
		builder.setDayType(JobBuilder.DAY_OF_WEEK);
		Integer[] darr = new Integer[daywarr.length];
		for (int i = 0; i < darr.length; ++i) {
			darr[i] = new Integer(daywarr[i]);
		}
		builder.setDays(darr);
			} else if (typeDay.equals("dayOMon")) {
				if (dayInMonarr != null && dayInMonarr.length > 0 && montharr != null
						&& montharr.length > 0) {
		builder.setDayType(JobBuilder.DAY_OF_MONTH);
		Integer[] darr = new Integer[dayInMonarr.length];
	
		for (int i = 0; i < darr.length; ++i) {
			if (dayInMonarr[i].equals("all")) {
		builder.setAllDayInMonth(true);
		darr = new Integer[0];
		break;
			}
			darr[i] = new Integer(dayInMonarr[i]);
		}
		builder.setDayInMonth(darr);
		Integer[] marr = new Integer[montharr.length];
		for (int i = 0; i < marr.length; ++i) {
			if (montharr[i].equals("all")) {
		builder.setAllMonth(true);
		marr = new Integer[0];
		break;
			}
			marr[i] = new Integer(montharr[i]);
		}
		builder.setMonth(marr);
				}
			}
	
			builder.setHours(hours);
			builder.setMinutesTen(minutTens);
			builder.setMinuteUnit(minutUnit);
			builder.setSecondTen(secTen);
			builder.setSecondUnit(secUnit);
			builder.setMinutesInterval(minutesInterval);
			builder.setHoursInterval(hoursInterval);
			if (minutTens.equals("0") && minutUnit.equals("0")&& minutesInterval.equals("1")) {
		builder.setEveryMinute(true);
			} else {
		builder.setEveryMinute(false);
			}
			if (hours.equals("0") && hoursInterval.equals("1")) {
		builder.setEveryHour(true);
			} else {
		builder.setEveryHour(false);
			}
		}
	}
	XpoScheduledOperation opsDelta = null;
	try {
		opsDelta = builder.buildXpoSchedOp();
		if (deltaSchedEnable) {
	opsDelta.setActive();
		} else {
	opsDelta.setSuspend();
		}
	} catch (IllegalArgumentException e) {
		errmodel.addError("Delta Scheduler - " + e.getMessage());
	} catch (Exception e1) {
		errmodel.addError("Delta Scheduler - Invalid time rule. Please make sure the time rule is valid and try again");
	}
	
	if (errmodel.getErrorCount() != 0) {
		request.getSession().setAttribute(ERROR_OBJ, errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=search/view/search.jsp");
		return;
	}
	ActionJobBuilder job = new ActionJobBuilder(opsDelta);
	job.updateFromOp();
	

	XpoTaskManager taskManager = XpoTaskManager.getInstance();
	SearchEngineIndexingTask task = (SearchEngineIndexingTask) taskManager.getXpoTaskById(job.getActionId());
	if (task != null) {
		task.setUseIfIndex(useIfIndex);
		taskManager.saveXpoSystemTasks();
	}

	searchEngineConfig.setResultsPerPage(resultsPerPage);
	searchEngineConfig.setMinDeltaToIndex(minDelta);
	searchEngineConfig.setCpuLimit(cpuLimit);
	String orgIndexPath = searchEngineConfig.getIndexPath();
	boolean dirPathOk = true;
	if (orgIndexPath == null && dirPath != null || orgIndexPath != null
	&& dirPath == null || orgIndexPath != null && dirPath != null
	&& !orgIndexPath.equalsIgnoreCase(dirPath)) {
		dirPathOk = xpolog.eye.data.index.adapters.defaultadapter.DefaultIndexingHelper.moveIndexes(orgIndexPath, dirPath);
	}
	if (dirPathOk) {
		searchEngineConfig.setIndexPath(dirPath);
		searchEngineConfig.setDiskSpaceThreshold(threshold);
		searchEngineConfig.setDiskSpaceThresholdUnit(thresholdUnit);
		searchEngineConfig.setAlternateIndexPaths(alternatePaths);
	}

	if ((searchEngineConfig.isIndexNumbers() != indexNumbers)
	|| (specialCharacters == null && searchEngineConfig.getIndexSpecialChars() != null)
	|| (specialCharacters != null && (searchEngineConfig.getIndexSpecialChars() == null || !specialCharacters.equals(searchEngineConfig.getIndexSpecialChars())))) {
		LogsIndexerRunner runner = SearchEngineManager.getInstance().getCustomIndexerRunner();
		runner.deleteIndexes();
	}

	searchEngineConfig.setIndexNumbers(indexNumbers);
	searchEngineConfig.setIndexSpecialChars(specialCharacters);
	XpoQuartzSchedMgr mgr = (XpoQuartzSchedMgr) XpoLogScheduleFactory.getSchdulingManager();
	mgr.putXpoSysScheduledOp(opsIndex);
	mgr.putXpoSysScheduledOp(opsDelta);
	request.getSession().removeAttribute("CURRENT_LOG");

	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "search/saveopok.jsp") {
		public void run(HttpServletRequest request) {
	try {
		searchEngineMgr.setConfiguration(searchEngineConfig);
		searchEngineMgr.save();
		SearchEngineAdminHelper.updateLogsUseIndexing(logs, userContext);
		SearchEngineAdminHelper.updateModulesUseIndexing(mods, userContext);
		Thread.sleep(1000);
	} catch (Exception e) {
		e.printStackTrace();
	}
		}
	};
	env.setProgressRunner(runner);

	//audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	userContext, AuditConstants.CHANGE,
	"edit search engine configuration", AuditConstants.SEARCH_ENGINE,
	"edit search engine configuration");
%>
<%@page import="xpolog.eye.util.Constants"%>
<jsp:include page="../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Saving"/>
</jsp:include>	