<%@ page language="java"%>

<%@ page import="xpolog.eye.admin.builders.MergedLogBrowserBuilder"%>
<%@ page import="xpolog.eye.admin.builders.RemoteLogBuilder"%>
<%@ page import="xpolog.eye.data.index.adapters.IndexAdapter"%>
<%@ page import="xpolog.eye.site.ui.tree.*"%>
<%@ page import="xpolog.eye.data.index.SearchEngineManager"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.util.*"%>

<%
	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
	
  SearchEngineManager searchEngineMgr = SearchEngineManager.getInstance();
	HashMap logsMap = null;
	HashMap modulesMap = null;
	HashMap selectedModules = null;
	
  String usingIndexStr = request.getParameter("usingIndex");
  boolean usingIndex = usingIndexStr != null && usingIndexStr.equals("true");
  String textIndexedStr = request.getParameter("textIndexed");
  boolean textIndexed = textIndexedStr != null && textIndexedStr.equals("true");
	String allStr = request.getParameter("all");
	boolean all = allStr != null && allStr.equals("true");
	String searchEngineManagementStr = request.getParameter("searchEngineManagement");
	boolean searchEngineManagement = searchEngineManagementStr != null && searchEngineManagementStr.equals("true");
	String showIndexingInfoStr = request.getParameter("showIndexingInfo");
	boolean showIndexingInfo = showIndexingInfoStr != null && showIndexingInfoStr.equals("true");
	boolean treeNodeExists = false;
	
	if (searchEngineManagement){
		HashSet excludeLogTypes = new HashSet();
		excludeLogTypes.add(MergedLogBrowserBuilder.MERGE_LOG_TYPE);
		excludeLogTypes.add(RemoteLogBuilder.PROXY_LOG_TYPE);
		logsMap = searchEngineMgr.getLogs(excludeLogTypes);
		selectedModules = new HashMap();//searchEngineMgr.getModules();
		modulesMap = new HashMap();
		SearchEngineModuleMemberRenderer.updateModulesMap(selectedModules,modulesMap,userContext);
	}
	
	boolean showDefaultTree = true;
	boolean showStorageTree = true;
	
	String treeXml = ""; 
  String id = request.getParameter("id");
  if (id != null){
  	String modid = id;
  	int ind = id.indexOf("-");
  	if (ind != -1){
  		modid = id.substring(ind+1);
  	}
		curmod = SiteManagment.getInstance().getModuleFromId(modid);
		treeNodeExists = true;
  }
  
	
	if (curmod != null){
		SearchEngineModuleMemberRenderer renderer = new SearchEngineModuleMemberRenderer(curmod, userContext, modulesMap, logsMap, true, false, treeNodeExists);
		//treeXml = SearchEngineAdminHelper.getTreeXML(
		//		curmod, userContext, modulesMap, logsMap, true, false, treeNodeExists, null, null, usingIndex, textIndexed, all, searchEngineManagement, showIndexingInfo);
		renderer.setShowRootModule(true);
		renderer.setOpenRootStorageModule(true);
		if (searchEngineManagement){
			renderer.setSelectedModules(selectedModules);
		}
		IndexAdapter indexer = SearchEngineManager.getInstance().getDefaultIndexAdapter();
		renderer.setIndexer(indexer);
		renderer.setUsingIndex(usingIndex);
		renderer.setTextIndexed(textIndexed);
		renderer.setAll(all);
		renderer.setSearchEngineManagement(searchEngineManagement);
		renderer.setShowIndexingInfo(showIndexingInfo);
		treeXml = renderer.getTreeXML(showDefaultTree,showStorageTree);
	}
	//System.out.println(treeXml);
	response.setContentType("text/xml");
	out.write(treeXml);
	out.flush();
%>