<%@ page language="java"%>

<%@ page import="java.util.Date"%>

<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.search.SearchContext"%>
<%@ page import="xpolog.eye.search.SearchModel"%>
<%@ page import="xpolog.eye.util.DateUtil"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
String SEARCH_MODEL = "SearchModel";

SearchModel model = (SearchModel) session.getAttribute(SEARCH_MODEL);

String fixedInterval = model.getFixedInterval();

String timeDisplayStr = "";
String minDateLongStr = "";
String minDateString = "";
String minDateShortString = "";
String minTimeString = "";
String maxDateLongStr = "";
String maxDateString = "";
String maxDateShortString = "";
String maxTimeString = "";
DateFilter dateFilter = model.getTimeFilter();
Date minDate = null;
Date maxDate = null;
if(dateFilter != null) {
	minDate = dateFilter.getMinDate();
	maxDate = dateFilter.getMaxDate();
}else {
	long now = System.currentTimeMillis();
	now = now - (now % 1000);
	minDate = new Date(now - 86400000);
	
	maxDate = new Date(now);
	
	timeDisplayStr = "All time";
}
minDateLongStr = String.valueOf(minDate.getTime());

minDateString = DateUtil.transformDateToString(minDate);
int minIndex = minDateString.indexOf(" ");
minDateShortString = minDateString.substring(0, minIndex);
minTimeString = minDateString.substring(minIndex + 1);
if(minTimeString.indexOf(":") != minTimeString.lastIndexOf(":")) {
	minTimeString = minTimeString.substring(0, minTimeString.lastIndexOf(":"));
}

maxDateLongStr = String.valueOf(maxDate.getTime());

maxDateString = DateUtil.transformDateToString(maxDate);
int maxIndex = maxDateString.indexOf(" ");
maxDateShortString = maxDateString.substring(0, maxIndex);
maxTimeString = maxDateString.substring(maxIndex + 1);
if(maxTimeString.indexOf(":") != maxTimeString.lastIndexOf(":")) {
	maxTimeString = maxTimeString.substring(0, maxTimeString.lastIndexOf(":"));
}

if(dateFilter != null) {
	timeDisplayStr = minDateShortString + " " + minTimeString + " - " + maxDateShortString + " " + maxTimeString;
}

String[] fixedIntervals = model.getFixedIntervals();
String[] fixedIntervalsNames = model.getFixedIntervalsNames();

%>

<input type="hidden" id="searchMinDate" name="searchMinDate" value="<%=minDateLongStr %>">
<input type="hidden" id="searchMinDateStr" name="searchMinDateStr" value="<%=minDateShortString %>">
<input type="hidden" id="searchMinDateFullStr" name="searchMinDateFullStr" value="<%=minDateString %>">
<input type="hidden" id="searchMinTimeStr" name="searchMinTimeStr" value="<%=minTimeString %>">
<input type="hidden" id="searchMaxDate" name="searchMaxDate" value="<%=maxDateLongStr %>">
<input type="hidden" id="searchMaxDateStr" name="searchMaxDateStr" value="<%=maxDateShortString %>">
<input type="hidden" id="searchMaxDateFullStr" name="searchMaxDateFullStr" value="<%=maxDateString %>">
<input type="hidden" id="searchMaxTimeStr" name="searchMaxTimeStr" value="<%=maxTimeString %>">

<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
	<tr>
		<td class="SEARCH_HEADER_FIXED_INTERVAL_CELL">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr><td>&nbsp;</td></tr>
				<tr height="26px">
					<td class="SEARCH_HEADER_FIXED_INTERVAL_LEFT_CELL">&nbsp;</td>
					<td class="SEARCH_HEADER_FIXED_INTERVAL_MAIN_CELL">
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td class="SEARCH_HEADER_FIXED_INTERVAL_LABEL_TEXT_CELL">
									<a id="fixedIntervalMenuTextLink" href="javascript:openFixedIntervalMenu()" class="SEARCH_HEADER_FIXED_INTERVAL_LABEL_TEXT_LINK"><%=model.getFixedIntervalName() %></a>
								</td>
								<td class="SEARCH_HEADER_FIXED_INTERVAL_ARROW_CELL">
									<a id="fixedIntervalMenuLink" href="javascript:openFixedIntervalMenu()"><img src="<%=BASE_DIRECTORY %>images/search/header/fixedIntervalsOpen.gif" border="0" onMouseOver="javascript:showTooltip(searchTooltips['openFixedIntervalsList'])" onMouseOut="javascript:hideTooltip()"></a>
								</td>
							</tr>
						</table>
					</td>
					<td class="SEARCH_HEADER_FIXED_INTERVAL_RIGHT_CELL">&nbsp;</td>
				</tr>
				<tr><td>&nbsp;</td></tr>
			</table>
			<div id="searchFixedIntervalDiv" class="SEARCH_HEADER_FIXED_INTERVAL_MENU_CONTAINER" style="display:none">
				<div id="searchFixedIntervalShadowDiv" class="SEARCH_HEADER_FIXED_INTERVAL_MENU_SHADOW">
					<div id="searchFixedIntervalMenuDiv" class="SEARCH_HEADER_FIXED_INTERVAL_MENU_CONTENT">
						<input type="hidden" id="fixedInterval" name="fixedInterval" value="<%=fixedInterval %>">
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<%
							String currentInterval = null;
							for(int i = 0; i < fixedIntervals.length; i++) {
								if(i == 1 || i == 4 || i == 6 || i == 9 || i == 12) {
							%>
								<tr>
									<td colspan="2"><hr></td>
								</tr>
							<%
								}
								currentInterval = fixedIntervals[i];
							%>
								<tr id="<%=currentInterval %>" class="SEARCH_HEADER_FIXED_INTERVAL_MENU_ITEM" onClick="javascript:setFixedInterval('<%=currentInterval %>', 'false', 'false')" onMouseOver="javascript:setFixedIntervalMenuItemClass('<%=currentInterval %>', 'SEARCH_HEADER_FIXED_INTERVAL_MENU_ITEM_OVER')" onMouseOut="javascript:setFixedIntervalMenuItemClass('<%=currentInterval %>', 'SEARCH_HEADER_FIXED_INTERVAL_MENU_ITEM')">
									
							<%
								if(fixedInterval.equals(currentInterval)) {
							%>
									<td class="SEARCH_HEADER_FIXED_INTERVAL_MENU_ITEM_CELL SEARCH_HEADER_SELECTED_FIXED_INTERVAL_MENU_ITEM"><img src="<%=BASE_DIRECTORY %>images/search/header/fixedIntervalsSelected.gif" border="0"></td>
							<%
								}else {
							%>
									<td class="SEARCH_HEADER_FIXED_INTERVAL_MENU_ITEM_CELL">&nbsp;</td>
							<%
								}
							%>
									<td class="SEARCH_HEADER_FIXED_INTERVAL_MENU_ITEM_CELL"><%=fixedIntervalsNames[i] %></td>
								</tr>
							<%
							}
							%>
						</table>
					</div>
				</div>
			</div>
		</td>
	</tr>
</table>