<%@ page language="java"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%@ page import="java.util.ArrayList"%>
<%@ page import="java.util.Date"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.common.JobStatus"%>
<%@ page import="xpolog.eye.CustomizationManager"%>
<%@ page import="xpolog.eye.data.filters.FilterManager"%>
<%@ page import="xpolog.eye.data.source.DataReference"%>
<%@ page import="xpolog.eye.data.Record"%>
<%@ page import="xpolog.eye.data.RecordMask"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.knowledge.common.KnowledgeDataProcessing"%>
<%@ page import="xpolog.eye.knowledge.common.KnowledgeDataRequest"%>
<%@ page import="xpolog.eye.knowledge.helpers.KnowledgeLogHelper"%>
<%@ page import="xpolog.eye.knowledge.KnowledgeResponse"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewRiskModel"%>
<%@ page import="xpolog.eye.search.*"%>
<%@ page import="xpolog.eye.search.data.impl.records.SearchDataModelRecordEvent"%>
<%@ page import="xpolog.eye.search.ui.*"%>
<%@ page import="xpolog.eye.SearchManager"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.util.Constants"%>
<%@ page import="xpolog.eye.util.WebUtil"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>

<%
String SEARCH_MODEL = "SearchModel";
try {
int MAX_CHARS_PER_EVENT = Configuration.getInstance().getPropertiesManager().getPropertyAsInt("xpolog.eye.search.ui.maxCharsPerEvent", 500);
int MAX_CHARS_PER_COLUMN = Configuration.getInstance().getPropertiesManager().getPropertyAsInt("xpolog.eye.search.ui.maxCharsPerColumn", 100);
SearchModel model = (SearchModel)request.getAttribute(SEARCH_MODEL);
SearchResult currentResult = model.getCurrentResult();

String minDateString = (String)request.getAttribute("minDateString");
String maxDateString = (String)request.getAttribute("maxDateString");

int runningMode = model.getRunningMode();
boolean logsResultsRunning = runningMode == SearchRunner.ALL_RUNNING || runningMode == SearchRunner.LOGS_RESULTS_RUNNING;
boolean allEventsCollapsed = model.isEventsCollapsed();

boolean isDashboardValid = SiteManagment.getInstance().getXpologManagment().isDashboardValidAndComponentExists();
boolean includeDashboardAnalysisInSearch = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("xpolog.eye.search.ui.includeDashboardAnalysisInSearch", true);
boolean dashboardAnalysisActiveInModel = model.isDashboardAnalysisActive(); 
boolean dashboardAnalysisActive = dashboardAnalysisActiveInModel && includeDashboardAnalysisInSearch;

String analytics = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_DISPLAY_NAME);
String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);

response.setContentType("text/html; charset=UTF-8");

List currentPageEvents = currentResult == null || currentResult.getTableDataModel() == null ? null : currentResult.getTableDataModel().getCurrentPageEvents();
if(currentPageEvents != null && currentPageEvents.size() > 0) {
%>

<tr class="SEARCH_MAIN_TABLE_ACTIONS_ROW">
	<td>
		<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
			<tr>
				<td class="empty">&nbsp;</td>
				<td class="SEARCH_MAIN_TABLE_ACTIONS_CELL">
					<div id="searchMainTableActionsUpperDiv" class="SEARCH_MAIN_TABLE_ACTIONS_UPPER">
					<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
						<tr>
							<%
							if(isDashboardValid) {
								if(dashboardAnalysisActive) {
							%>
									<td align="right"><a href="javascript:toggleDashboardAnalysis('false');"><img src="<%=BASE_DIRECTORY %>images/search/mainTable/buttonDashboardAnalysisActive.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/buttonDashboardAnalysisActiveOver.gif');javascript:showSearchMainTableActionsSlidingDiv('<nobr>Disable <%=analyticsH %></nobr>')" onMouseOut="javascript:setImageSource(this, 'mainTable/buttonDashboardAnalysisActive.gif');javascript:hideSearchMainTableActionsSlidingDiv()"></a></td>
									<td class="empty">&nbsp;&nbsp;&nbsp;</td>
							<%
								}else {
									if(includeDashboardAnalysisInSearch) {
							%>
							
									<td align="right"><a href="javascript:toggleDashboardAnalysis('true');"><img src="<%=BASE_DIRECTORY %>images/search/mainTable/buttonDashboardAnalysisDisabled.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/buttonDashboardAnalysisDisabledOver.gif');javascript:showSearchMainTableActionsSlidingDiv('<nobr>Enable <%=analyticsH %></nobr>')" onMouseOut="javascript:setImageSource(this, 'mainTable/buttonDashboardAnalysisDisabled.gif');javascript:hideSearchMainTableActionsSlidingDiv()"></a></td>
							<%
									}else {
							%>
									<td align="right"><img src="<%=BASE_DIRECTORY %>images/search/mainTable/buttonDashboardAnalysisDisabled.gif" border="0"></td>
							<%
									}
							%>
									<td class="empty">&nbsp;&nbsp;&nbsp;</td>
							<%
								}
							}
							%>
							<%
							if(allEventsCollapsed) {
							%>
								<td align="right"><a href="javascript:toggleEventsCollapsed('false');"><img src="<%=BASE_DIRECTORY %>images/search/mainTable/buttonExpandRecords.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/buttonExpandRecordsOver.gif');javascript:showSearchMainTableActionsSlidingDiv('<nobr>Expand All Events</nobr>')" onMouseOut="javascript:setImageSource(this, 'mainTable/buttonExpandRecords.gif');javascript:hideSearchMainTableActionsSlidingDiv()"></a></td>
							<%
							}else {
							%>
								<td align="right"><a href="javascript:toggleEventsCollapsed('true');"><img src="<%=BASE_DIRECTORY %>images/search/mainTable/buttonCollapseRecords.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/buttonCollapseRecordsOver.gif');javascript:showSearchMainTableActionsSlidingDiv('<nobr>Collapse All Events</nobr>')" onMouseOut="javascript:setImageSource(this, 'mainTable/buttonCollapseRecords.gif');javascript:hideSearchMainTableActionsSlidingDiv()"></a></td>
							<%
							}
							%>
						</tr>
					</table>
					</div>
					<div id="searchMainTableActionsSlidingDiv" class="SEARCH_MAIN_TABLE_ACTIONS_POPUP" style="width:0px;"></div>
				</td>
			</tr>
		</table>
	</td>
</tr>
<tr class="RECRODS_TOP_SEPERATOR">
	<td>&nbsp;</td>
</tr>
<%
	SearchResultRecord searchResultRecord = null;
	
	String rowClassName = null;
	String rowId = null;
	String zoomIntoLogLink = null, zoomIntoLogMouseActionsString = null, zoomIntoLogMouseActionsStringMessage = null;
	String zoomIntoDashboardLink = null, zoomIntoDashboardMouseActionsString = null, zoomIntoDashboardMouseActionsStringMessage = null;
	
	SearchManager searchManager = null;
	FilterManager filterManager = null;
	KnowledgeDataProcessing knowledgeProcess = null;
	KnowledgeDataRequest knowledgeRequest = null;
	FilterCollection [] riskFilters = null;
	
	long startTime = currentResult.getStartTime();
	long endTime = currentResult.getEndTime();
	
	HealthViewRiskModel riskModel = null;
	
	boolean recordIsLong = false, recordIsCollapsed = false, shouldRunDashboardAnalysis = false;
	for(int i = 0; i < currentPageEvents.size(); i++) {
		searchManager = null;
		Object event = currentPageEvents.get(i);
    if (event instanceof SearchResultRecord){
		  searchResultRecord = (SearchResultRecord)event;
    }else if (event instanceof SearchDataModelRecordEvent){
       searchResultRecord = ((SearchDataModelRecordEvent)event).getRecResult();
    }else {
     //System.out.println("continue");
     continue;
    }
		
		rowId = "mainTableRow_" + i;
		
		if(i % 2 == 0) {
			rowClassName = "SEARCH_MAIN_TABLE_COLORED_ROW";
		}else {
			rowClassName = "SEARCH_MAIN_TABLE_REGULAR_ROW";
		}
		
		String logId = searchResultRecord.getLogId();
		Record record = searchResultRecord.getRecord(); 
		if(record == null) {
			continue;
		}
		DataReference dataReference = searchResultRecord.getDataReference();
		
		shouldRunDashboardAnalysis = dashboardAnalysisActive && !searchResultRecord.isContainsDashboardAnalysis();
		//System.out.println("shouldRunDashboardAnalysis=" + shouldRunDashboardAnalysis);
		String recordDisplayHtml = null, recordDisplayHtmlWithoutAnalytics = null, recordDisplayHtmlShort = null, recordDisplayHtmlShortWithoutAnalytics = null, recordDateStr = null;;
		StringBuffer recordDisplayHtmlBuffer = null, recordDisplayHtmlWithoutAnalyticsBuffer = null, recordDisplayHtmlShortBuffer = null, recordDisplayHtmlShortWithoutAnalyticsBuffer = null;
		if(searchResultRecord.getRecordDisplayHtml() == null || shouldRunDashboardAnalysis) {
			recordDisplayHtmlBuffer = new StringBuffer();
			recordDisplayHtmlWithoutAnalyticsBuffer = new StringBuffer();
			recordDisplayHtmlShortBuffer = new StringBuffer();
			recordDisplayHtmlShortWithoutAnalyticsBuffer = new StringBuffer();
			recordDateStr = "";
		}else {
			recordDisplayHtml = searchResultRecord.getRecordDisplayHtml();
			recordDisplayHtmlWithoutAnalytics = searchResultRecord.getRecordDisplayHtmlWithoutAnalytics();
			recordDisplayHtmlShort = searchResultRecord.getRecordDisplayHtmlShort();
			recordDisplayHtmlShortWithoutAnalytics = searchResultRecord.getRecordDisplayHtmlShortWithoutAnalytics();
			recordDateStr = searchResultRecord.getRecordsDateStr();
		}
		SearchResultLogInfo logInfo = currentResult.getLogInfo(logId);
		String logName = "", hostName = "", applications = "", riskText = "";
		RecordMask recordMask = null;
		CustomizationManager customizationManager = null;
		String searchString = "";
		int numberOfColumns = -1;
		if(logInfo != null) {
			logName = logInfo.getLogName();
			if(logName == null) {
				logName = "";
			}
			hostName = logInfo.getHostName();
			if(hostName == null) {
				hostName = "";
			}
			applications = logInfo.getApplicationNamesStr();
			if(applications == null || applications.length() == 0) {
				applications = "None";
			}
			
			searchManager = logInfo.getSearchManager();			
			filterManager = logInfo.getFilterManager();
			knowledgeProcess = logInfo.getKnowledgeProcess();
			knowledgeRequest = logInfo.getKnowledgeRequest();
			riskFilters = logInfo.getRiskFilters();
			
			recordMask = logInfo.getRecordMask();
			customizationManager = logInfo.getCustomizationManager();
			
			searchString = logInfo.getSearchString();
			numberOfColumns = recordMask.getCulomnsNumber();
		}
		riskText = "";
		
		recordIsLong = searchResultRecord.isLongRecord();
		recordIsCollapsed = searchResultRecord.isCollapsed();
		
		String searchStringForJavaScript = XpologUtil.updateAsHtmlString(searchString);
		searchStringForJavaScript = XpologUtil.replaceAll(searchStringForJavaScript, "\\", "\\\\");
		searchStringForJavaScript = XpologUtil.replaceAll(searchStringForJavaScript, "'", "\\'");
		
		zoomIntoLogLink = "javascript:openLogFromSearch('" + BASE_DIRECTORY + "','" + logId + "', '" + searchStringForJavaScript + "', 'true', document.getElementById('" + rowId + "'), false, '" + (dataReference != null ? dataReference.getKey() : "") + "', '" + minDateString + "', '" + maxDateString + "')";
		zoomIntoLogMouseActionsStringMessage = "searchTooltips['showLog']";
		zoomIntoLogMouseActionsString = "onMouseOver=\"javascript:showTooltip(" + zoomIntoLogMouseActionsStringMessage + ")\" onMouseOut=\"javascript:hideTooltip()\"";
		zoomIntoLogMouseActionsString = "";
		
		zoomIntoDashboardLink = "javascript:openDashboardFromSearch('" + BASE_DIRECTORY + "','" + XpoLogObjectTypes.LOG_TYPE + "', '" + logId + "', '" + startTime + "', '" + endTime + "')";
		zoomIntoDashboardMouseActionsStringMessage = "searchTooltips['showDashboard']";
		zoomIntoDashboardMouseActionsString = "onMouseOver=\"javascript:showTooltip(" + zoomIntoDashboardMouseActionsStringMessage + ")\" onMouseOut=\"javascript:hideTooltip()\"";
		zoomIntoDashboardMouseActionsString = "";
		
		if(recordDisplayHtml == null) {
			if(dashboardAnalysisActive) {
				searchResultRecord.setContainsDashboardAnalysis(true);
			}
			KnowledgeResponse knowledgeResponse = null;            
			if (dashboardAnalysisActive && currentResult.isProcessKnowledge() && knowledgeRequest != null){
	     	try {
	    		JobStatus status = new JobStatus();
	       	knowledgeRequest.clearData();
		    	KnowledgeLogHelper.upadteRequestData(knowledgeRequest,null,record);
		    	knowledgeResponse =  knowledgeProcess.processRequest(knowledgeRequest, status);
	      }catch (Exception e){
	        ErrorModel.log.error("Failed to get event knowledge ",e); 
	      }
	    }
      
			ArrayList eventRiskFiltersList = new ArrayList();
			if (dashboardAnalysisActive && currentResult.isProcessKnowledge() && riskFilters != null){
        for(int r = 0; r < riskFilters.length;r++){
           if (riskFilters[r].accept(record)){
        	   eventRiskFiltersList.add(riskFilters[r]);
           }
        }
      }
			if (searchManager != null){
				searchManager.setAddTagsSpaces(true);    
      }
			String dateStr = "";
			if(numberOfColumns > -1) {
				boolean shouldTruncateEvent = false;
				int[] charsInColumn = new int[numberOfColumns];
				if(MAX_CHARS_PER_EVENT > -1) {
					int numberOfCharsInEvent = 0;
					for(int j = 0; j < numberOfColumns; j++) {
						if(customizationManager != null) {
							int columnIndex = customizationManager.getCustomizedColFromIndex(j);
							if(columnIndex == -1) {
								continue;
							}
						}
						
						int numberOfCharsInColumn = 0;
						
						Object obj = record.getFieldAt(j);
						String value = obj == null ? "" : SearchUtil.getColumnValue(recordMask, j, obj);
						
						if(value.equals("")) {
							continue;
						}
						
						if(obj instanceof Date) {
							continue;
						}
						
						int indexOfSpace = -1;
						while((indexOfSpace = value.indexOf(" ")) != -1) {
							numberOfCharsInColumn += (indexOfSpace + 1);
							numberOfCharsInEvent += (indexOfSpace + 1);
							
							value = value.substring(indexOfSpace + 1);
						}
						if(value.length() > 0) {
							numberOfCharsInColumn += value.length();
							numberOfCharsInEvent += value.length();
						}
						
						charsInColumn[j] = numberOfCharsInColumn;
					}
					
					if(numberOfCharsInEvent > MAX_CHARS_PER_EVENT) {
						shouldTruncateEvent = true;
					}
				}
				recordIsLong = shouldTruncateEvent;
				for(int j = 0; j < numberOfColumns; j++) {
					if(customizationManager != null) {
						int columnIndex = customizationManager.getCustomizedColFromIndex(j);
						if(columnIndex == -1) {
							continue;
						}
					}
					Object obj = record.getFieldAt(j);					
					String value = obj == null ? "" : SearchUtil.getColumnValue(recordMask, j, obj);
          value = value.replaceAll("[\\x00-\\x09\\x0B-\\x1F\\x7F]","");
					String valueWithoutAnalytics = null, shortValue = null, shortValueWithoutAnalytics = null;
					
					if(obj instanceof Date) {
						dateStr = value;
						if(searchManager != null && filterManager != null) {
							dateStr = searchManager.updateFilterTermStr(filterManager, searchManager, dateStr, j);
							if(dateStr != null) {
								dateStr = searchManager.removeExtraSpaces(dateStr);
	            }
						}
						continue;
					}
					
					String name = "";
					if(recordMask != null) {
						name = SearchUtil.getColumnName(recordMask, j);
					}
					if (recordDisplayHtmlBuffer.length() > 0){
						recordDisplayHtmlBuffer.append(" | ");
					}
					if (recordDisplayHtmlWithoutAnalyticsBuffer.length() > 0){
						recordDisplayHtmlWithoutAnalyticsBuffer.append(" | ");
					}
					if (recordDisplayHtmlShortBuffer.length() > 0){
						recordDisplayHtmlShortBuffer.append(" | ");
					}
					if (recordDisplayHtmlShortWithoutAnalyticsBuffer.length() > 0){
						recordDisplayHtmlShortWithoutAnalyticsBuffer.append(" | ");
					}
					
					if (name != null && name.length() > 0){
						recordDisplayHtmlBuffer.append("<span class=\"SEARCH_MAIN_TABLE_RECORD_TEXT_COLUMN_NAME\"><nobr>[" + name + "]</nobr></span>");
						recordDisplayHtmlWithoutAnalyticsBuffer.append("<span class=\"SEARCH_MAIN_TABLE_RECORD_TEXT_COLUMN_NAME\"><nobr>[" + name + "]</nobr></span>");
						recordDisplayHtmlShortBuffer.append("<span class=\"SEARCH_MAIN_TABLE_RECORD_TEXT_COLUMN_NAME\"><nobr>[" + name + "]</nobr></span>");
						recordDisplayHtmlShortWithoutAnalyticsBuffer.append("<span class=\"SEARCH_MAIN_TABLE_RECORD_TEXT_COLUMN_NAME\"><nobr>[" + name + "]</nobr></span>");
					}
					
					value = WebUtil.doHTMLEncoding(value);
					valueWithoutAnalytics = value;
					if(searchManager != null && filterManager != null) {
            try {
						  if (knowledgeResponse != null){
					       value = searchManager.updateKnowledgeTermStr(knowledgeResponse,searchManager,value,j, searchResultRecord);				     
					    }
	            if (eventRiskFiltersList != null){
	        	    value = searchManager.updateFilterRiskTermStr(searchManager,value,j, searchResultRecord,filterManager,eventRiskFiltersList);
	            }
						  value = searchManager.updateFilterTermStr(filterManager, searchManager, value, j);
						  valueWithoutAnalytics = searchManager.updateFilterTermStr(filterManager, searchManager, valueWithoutAnalytics, j);
            }catch (Exception e){
            	ErrorModel.log.warn("An error occured in searchMainTable.jsp", e);
            }
					}
		  
					shortValue = value;
					shortValueWithoutAnalytics = valueWithoutAnalytics;
					
					if(shouldTruncateEvent) {
						int numberOfCharsInColumn = charsInColumn[j];
						if(numberOfCharsInColumn > MAX_CHARS_PER_COLUMN) {
              try {
							  shortValue = SearchViewHelper.getShortColumn(shortValue);
							  shortValueWithoutAnalytics = SearchViewHelper.getShortColumn(shortValueWithoutAnalytics);
							  //shortValue = WebUtil.doHTMLEncoding(shortValue);
								//shortValue = XpologUtil.replaceAll(shortValue, "\n", "<br>");
              }catch (Exception e){
            	  ErrorModel.log.warn("An error occured in searchMainTable.jsp", e);
              }							
						}
					}
					if (searchManager != null){
			            if (value != null){
			            	value = searchManager.removeExtraSpaces(value);
			            }
			            if (shortValue != null){
			            	shortValue = searchManager.removeExtraSpaces(shortValue);
			            }
			            if (valueWithoutAnalytics != null){
			            	valueWithoutAnalytics = searchManager.removeExtraSpaces(value);
			            }
			            if (shortValueWithoutAnalytics != null){
			            	shortValueWithoutAnalytics = searchManager.removeExtraSpaces(shortValueWithoutAnalytics);
			            }
			          }
					value = XpologUtil.replaceAll(value, "\n", "<br>");
					
					recordDisplayHtmlBuffer.append(" <span id=\"d_" + rowId + "_" + j + "\">").append(value).append("</span>");
					recordDisplayHtmlWithoutAnalyticsBuffer.append(" <span id=\"d_" + rowId + "_" + j + "\">").append(valueWithoutAnalytics).append("</span>");
					recordDisplayHtmlShortBuffer.append(" <span id=\"d_" + rowId + "_" + j + "\">").append(shortValue).append("</span>");
					recordDisplayHtmlShortWithoutAnalyticsBuffer.append(" <span id=\"d_" + rowId + "_" + j + "\">").append(shortValueWithoutAnalytics).append("</span>");
			  }
			}
			if (searchManager != null){
				searchManager.setAddTagsSpaces(false);    
      }
			recordDisplayHtml = recordDisplayHtmlBuffer.toString();
			recordDisplayHtmlWithoutAnalytics = recordDisplayHtmlWithoutAnalyticsBuffer.toString();
			recordDisplayHtmlShort = recordDisplayHtmlShortBuffer.toString();
			recordDisplayHtmlShortWithoutAnalytics = recordDisplayHtmlShortWithoutAnalyticsBuffer.toString();
			recordDateStr = dateStr;
			
			searchResultRecord.setRecordDisplayHtml(recordDisplayHtml);
			searchResultRecord.setRecordDisplayHtmlWithoutAnalytics(recordDisplayHtmlWithoutAnalytics);
			searchResultRecord.setRecordDisplayHtmlShort(recordDisplayHtmlShort);
			searchResultRecord.setRecordDisplayHtmlShortWithoutAnalytics(recordDisplayHtmlShortWithoutAnalytics);
			searchResultRecord.setRecordsDateStr(recordDateStr);
			
			searchResultRecord.setLongRecord(recordIsLong);
		}
		
		String riskTextClass = "SEARCH_MAIN_TABLE_RISK_";
		String riskBorderClass = "SEARCH_MAIN_TABLE_SOURCE_CELL_RISK_";
		if(isDashboardValid && currentResult.isProcessKnowledge()) {
			if(riskModel == null) {
				riskModel = HealthViewRiskModel.getInstance();
			}
			double riskLevel = searchResultRecord.getRiskLevel();
			if(riskLevel == 0) {
				riskLevel = -1;
			}
			riskText = riskModel.getRiskName(riskLevel);
			int bgSuffix = riskModel.getRiskClassNameSuffix(riskLevel);
			if(bgSuffix == 0) {
				bgSuffix = -1;
			}
			if(bgSuffix > 0) {
				riskTextClass += String.valueOf(bgSuffix);
				riskBorderClass += String.valueOf(bgSuffix);
			}
		}
%>
<tr id="<%=rowId %>" class="<%=rowClassName %>" onMouseOver="javascript:showMainTableRowActionsCell('<%=rowId %>', 'true')" onMouseOut="javascript:if(!document.all){showMainTableRowActionsCell('<%=rowId %>', 'false')}" onMouseLeave="javascript:showMainTableRowActionsCell('<%=rowId %>', 'false')">
	<td>
		<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
			<tr>
				<td class="SEARCH_MAIN_TABLE_GENERAL_CELL SEARCH_MAIN_TABLE_CELL SEARCH_MAIN_TABLE_SOURCE_CELL">
					<nobr><%=recordDateStr %></nobr>&nbsp;
					<%if(isDashboardValid && dashboardAnalysisActive && riskText.length() > 0) { %>
					<br>
					<span class="SEARCH_MAIN_TABLE_RECORD_TEXT_COLUMN_NAME">Severity:</span> <span class="<%=riskTextClass %>"><%=riskText %></span>
					<%} %>
				</td>
				<%
				String recordCellDisplay = "none", shortRecordCellDisplay = "none";
				if(allEventsCollapsed) {
					if(recordIsLong && recordIsCollapsed) {
						shortRecordCellDisplay = "";
					}else {
						recordCellDisplay = "";
					}
				}else {
					if(recordIsLong) {
						recordCellDisplay = "";
					}else {
						shortRecordCellDisplay = "";
					}
				}
				//System.out.println("recordCellDisplay=" + recordCellDisplay + ", shortRecordCellDisplay=" + shortRecordCellDisplay);
				%>
				<td id="<%=rowId %>RecordCell" style="display:<%=recordCellDisplay %>" class="SEARCH_MAIN_TABLE_GENERAL_CELL SEARCH_MAIN_TABLE_CELL SEARCH_MAIN_TABLE_RECORD_CELL SEARCH_MAIN_TABLE_RECORD_TEXT">
					<%=dashboardAnalysisActive ? recordDisplayHtml : recordDisplayHtmlWithoutAnalytics %>
					<%
					if(recordIsLong) {
					%>
						&nbsp;<a style="vertical-align: bottom" href="javascript:toggleEventCollapsed('<%=rowId %>', 'true');"><img src="<%=BASE_DIRECTORY %>images/search/mainTable/buttonCollapseRecord.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/buttonCollapseRecordOver.gif');javascript:showTooltip(searchTooltips['collapseCurrentEvent'])" onMouseOut="javascript:setImageSource(this, 'mainTable/buttonCollapseRecord.gif');javascript:hideTooltip()"></a>
					<%
					}
					%>
					<br><br>
					<span class="SEARCH_MAIN_TABLE_RECORD_TEXT_SOURCE_TEXT">[Log] <%=logName %>&nbsp;&nbsp;&nbsp;</span>
					<span class="SEARCH_MAIN_TABLE_RECORD_TEXT_SOURCE_TEXT">[Host] <%=hostName %>&nbsp;&nbsp;&nbsp;</span>
					<span class="SEARCH_MAIN_TABLE_RECORD_TEXT_SOURCE_TEXT">[Applications] <%=applications %></span>
					<br>
				</td>
				<td id="<%=rowId %>ShortRecordCell" style="display:<%=shortRecordCellDisplay %>" class="SEARCH_MAIN_TABLE_GENERAL_CELL SEARCH_MAIN_TABLE_CELL SEARCH_MAIN_TABLE_RECORD_CELL SEARCH_MAIN_TABLE_RECORD_TEXT">
					<%=dashboardAnalysisActive ? recordDisplayHtmlShort : recordDisplayHtmlShortWithoutAnalytics %>
					<%
					if(recordIsLong) {
					%>
						&nbsp;<a style="vertical-align: bottom" href="javascript:toggleEventCollapsed('<%=rowId %>', 'false');"><img src="<%=BASE_DIRECTORY %>images/search/mainTable/buttonExpandRecord.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/buttonExpandRecordOver.gif');javascript:showTooltip(searchTooltips['expandCurrentEvent'])" onMouseOut="javascript:setImageSource(this, 'mainTable/buttonExpandRecord.gif');javascript:hideTooltip()"></a>
					<%
					}
					%>
					<br><br>
					<span class="SEARCH_MAIN_TABLE_RECORD_TEXT_SOURCE_TEXT">[Log] <%=logName %>&nbsp;&nbsp;&nbsp;</span>
					<span class="SEARCH_MAIN_TABLE_RECORD_TEXT_SOURCE_TEXT">[Host] <%=hostName %>&nbsp;&nbsp;&nbsp;</span>
					<span class="SEARCH_MAIN_TABLE_RECORD_TEXT_SOURCE_TEXT">[Applications] <%=applications %></span>
					<br>
				</td>
				<td class="SEARCH_MAIN_TABLE_ROW_ACTIONS_CELL">
					<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
						<tr>
							<td class="SEARCH_MAIN_TABLE_ROW_ACTIONS_LIST_CELL" id="mainTableRowActionsListCell<%=rowId %>">
								<table border="0" cellpadding="0" cellspacing="0" width="100%">
									<tr class="SEARCH_MAIN_TABLE_ROW_ACTION_ROW">
										<td class="SEARCH_MAIN_TABLE_ROW_ACTION_CELL"><a href="<%=zoomIntoLogLink %>" <%=zoomIntoLogMouseActionsString %> class="SEARCH_MAIN_TABLE_ROW_ACTIONS_LINK">Log Viewer</a></td>
									</tr>
									<%if(isDashboardValid && dashboardAnalysisActive && (logInfo != null && logInfo.isDashboardEnabled())) { %>
									<tr class="SEARCH_MAIN_TABLE_ROW_ACTION_ROW">
										<td class="SEARCH_MAIN_TABLE_ROW_ACTION_CELL"><a href="<%=zoomIntoDashboardLink %>" <%=zoomIntoDashboardMouseActionsString %> class="SEARCH_MAIN_TABLE_ROW_ACTIONS_LINK"><%=analyticsH %></a></td>
									</tr>
									<%} %>
									<tr><td class="empty">&nbsp;</td></tr>
								</table>
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</table>
	</td>
</tr>
<%
	}
}else {
	String message = "No matching log events were found";
	if(logsResultsRunning) {
		message = "Fetching events...";
	}
%>
<tr>
	<td class="SEARCH_MAIN_TABLE_GENERAL_CELL SEARCH_MAIN_TABLE_HEADER_CELL"><%=message %></td>
</tr>
<%
}
}catch(Exception e) {
	ErrorModel.log.error("An error occured in searchMainTableEvents.jsp", e);
}
%>