<%@ page language="java"%>

<%@ page import="java.util.List"%>

<%@ page import="xpolog.eye.search.*"%>
<%@ page import="xpolog.eye.search.ui.*"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
String SEARCH_MODEL = "SearchModel";

String isHeaderStr = request.getParameter("isHeader");
boolean isHeader = isHeaderStr != null && isHeaderStr.equals("true");
String classSuffix = "_HEADER";
if(!isHeader) {
	classSuffix = "_FOOTER";
}

SearchModel model = (SearchModel)session.getAttribute(SEARCH_MODEL);
SearchResult currentResult = model.getCurrentResult();

SearchUITableDataModel tableResult = currentResult.getTableDataModel();
List searchResultRecords = tableResult.getSearchResultEvents();
List currentPageEvents = tableResult.getCurrentPageEvents();

int recordsPerPage = model.getRecordsPerPage();
String pagingString = "";


int maxRecordsInPageGroup = recordsPerPage * model.getMaxPagingLinks();
int minRecordIndex = tableResult.getMinRowIndex();
int maxRecordIndex = tableResult.getMaxRowIndex();
if(searchResultRecords != null && searchResultRecords.size() > 0) {
	int pageGroup = model.getCurrentRecordsPageGroup();
	int addition = maxRecordsInPageGroup * pageGroup;
	pagingString = "Viewing events " + (minRecordIndex + addition) + " - " + (maxRecordIndex + addition);
}

String recordsPerPageStr = String.valueOf(recordsPerPage);
String recordsPerPageValues = model.RECORDS_PER_PAGE_VALUES;
String[] recordsPerPageArr = recordsPerPageValues.split(",");
%>

<%@page import="xpolog.eye.search.ui.model.result.UISearchDataResult"%>
<%@page import="xpolog.eye.search.ui.model.SearchUITableDataModel"%><table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
	<%
	int colspan = 1;
	if(searchResultRecords != null && searchResultRecords.size() > 0 && recordsPerPageArr != null && recordsPerPageArr.length > 1) {
		colspan = 2;
	}
	%>
	<tr class="SEARCH_MAIN_TABLE_PADDING_ROW<%=classSuffix %>"><td colspan="<%=colspan %>">&nbsp;</td></tr>
	<tr class="SEARCH_MAIN_TABLE_PAGING_NAVIGATION_ROW">
		<td class="SEARCH_MAIN_TABLE_PAGING_NAVIGATION_CELL">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr>
					<%
					if(searchResultRecords != null) {
					%>
					<td class="SEARCH_MAIN_TABLE_PAGING_TEXT<%=classSuffix %>"><nobr><%=pagingString %></nobr></td>
					<%
						int currentRecordsPage = model.getCurrentRecordsPage();
						if(searchResultRecords.size() > recordsPerPage || currentRecordsPage > 0) {
							int maxPagingLinks = model.getMaxPagingLinks();
							int minRecordsPage = currentRecordsPage - (currentRecordsPage % maxPagingLinks);
							int maxRecordsPage = Math.min(minRecordsPage + maxPagingLinks, model.getNumberOfPages());
							if(searchResultRecords.size() < (maxRecordsPage - minRecordsPage) * recordsPerPage) {
								maxRecordsPage = (int)Math.ceil(minRecordsPage + ((double)searchResultRecords.size() / recordsPerPage));
							}
					%>
					<td class="SEARCH_MAIN_TABLE_PAGING_ARROW_CELL">
					<%
							if(minRecordsPage == 0) {
					%>
						<img style="vertical-align: middle" src="<%=BASE_DIRECTORY %>images/search/mainTable/buttonPagingLeftArrowDisabled.gif" border="0">
					<%
							}else {
					%>
						<a href="javascript:showPrevResultsGroup()" onMouseOver="javascript:showTooltip(searchTooltips['previousResults'])" onMouseOut="javascript:hideTooltip()"><img style="vertical-align: middle" src="<%=BASE_DIRECTORY %>images/search/mainTable/buttonPagingLeftArrow.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/buttonPagingLeftArrowOver.gif')" onMouseOut="javascript:setImageSource(this, 'mainTable/buttonPagingLeftArrow.gif')"></a>
					<%
							}
					%>
					</td>
					<%
							for(int i = minRecordsPage; i < maxRecordsPage; i++) {
								if(i == currentRecordsPage) {
					%>
					<td class="SEARCH_MAIN_TABLE_PAGING_CURRENT_PAGE_CELL"><%=(i + 1) %></td>
					<%
								}else {
					%>
					<td class="SEARCH_MAIN_TABLE_PAGING_PAGE_CELL">
						<a href="javascript:showPageResults(<%=i %>)" class="SEARCH_MAIN_TABLE_PAGING_PAGE_LINK"><%=(i + 1) %></a>
					</td>
					<%
								}
							}
					%>
					<td class="SEARCH_MAIN_TABLE_PAGING_ARROW_CELL">
					<%
							if(maxRecordsPage == model.getNumberOfPages()) {
					%>
						<img style="vertical-align: middle" src="<%=BASE_DIRECTORY %>images/search/mainTable/buttonPagingRightArrowDisabled.gif" border="0">
					<%
							}else {
					%>
						<a href="javascript:showNextResultsGroup()" onMouseOver="javascript:showTooltip(searchTooltips['nextResults'])" onMouseOut="javascript:hideTooltip()"><img style="vertical-align: middle" src="<%=BASE_DIRECTORY %>images/search/mainTable/buttonPagingRightArrow.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/buttonPagingRightArrowOver.gif')" onMouseOut="javascript:setImageSource(this, 'mainTable/buttonPagingRightArrow.gif')"></a>
					<%
							}
					%>
					</td>
					<%
						}
					}
					%>
				</tr>
			</table>
		</td>
		<%
		if(searchResultRecords != null && searchResultRecords.size() > 0 && recordsPerPageArr != null && recordsPerPageArr.length > 1) {
		%>
		<td class="SEARCH_MAIN_TABLE_RECORDS_PER_PAGE_CELL">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr>
					<td class="SEARCH_MAIN_TABLE_RECORDS_PER_PAGE_LEFT_CELL<%=classSuffix %>">&nbsp;</td>
					<td class="SEARCH_MAIN_TABLE_RECORDS_PER_PAGE_MAIN_CELL<%=classSuffix %>">
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td class="SEARCH_MAIN_TABLE_RECORDS_PER_PAGE_LABEL_TEXT_CELL">
									<a id="recordsPerPageMenuTextLink" href="javascript:openRecordsPerPageMenu('<%=isHeader %>')" class="SEARCH_MAIN_TABLE_RECORDS_PER_PAGE_LABEL_TEXT_LINK"><nobr><%=recordsPerPageStr %> per page</nobr></a>
								</td>
								<td class="SEARCH_MAIN_TABLE_RECORDS_PER_PAGE_ARROW_CELL">
									<a id="recordsPerPageMenuLink" href="javascript:openRecordsPerPageMenu('<%=isHeader %>')"><img src="<%=BASE_DIRECTORY %>images/search/mainTable/recordsPerPageOpen.gif" border="0" onMouseOver="javascript:showTooltip(searchTooltips['openRecordsPerPageList'])" onMouseOut="javascript:hideTooltip()"></a>
								</td>
							</tr>
						</table>
					</td>
					<td class="SEARCH_MAIN_TABLE_RECORDS_PER_PAGE_RIGHT_CELL<%=classSuffix %>">&nbsp;</td>
				</tr>
			</table>
			<%
			// include the div only in the header secion
			if(isHeader) {
			%>
			<div id="searchRecordsPerPageDiv" class="SEARCH_MAIN_TABLE_RECORDS_PER_PAGE_MENU_CONTAINER_HEADER" style="display:none">
				<div id="searchRecordsPerPageShadowDiv" class="SEARCH_MAIN_TABLE_RECORDS_PER_PAGE_MENU_SHADOW">
					<div id="searchRecordsPerPageMenuDiv" class="SEARCH_MAIN_TABLE_RECORDS_PER_PAGE_MENU_CONTENT">
						<input type="hidden" id="recordsPerPage" name="recordsPerPage" value="<%=recordsPerPageStr %>">
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<%
							String currentRecordsPerPage;
							for(int i = 0; i < recordsPerPageArr.length; i++) {
								currentRecordsPerPage = recordsPerPageArr[i];
								if(currentRecordsPerPage == null || currentRecordsPerPage.length() == 0) {
									continue;
								}
							%>
								<tr id="<%=currentRecordsPerPage %>" class="SEARCH_MAIN_TABLE_RECORDS_PER_PAGE_MENU_ITEM" onClick="javascript:setRecordsPerPage('<%=currentRecordsPerPage %>')" onMouseOver="javascript:setRecordsPerPageMenuItemClass('<%=currentRecordsPerPage %>', 'SEARCH_MAIN_TABLE_RECORDS_PER_PAGE_MENU_ITEM_OVER')" onMouseOut="javascript:setRecordsPerPageMenuItemClass('<%=currentRecordsPerPage %>', 'SEARCH_MAIN_TABLE_RECORDS_PER_PAGE_MENU_ITEM')">
									
							<%
								if(recordsPerPageStr.equals(currentRecordsPerPage)) {
							%>
									<td class="SEARCH_MAIN_TABLE_RECORDS_PER_PAGE_MENU_ITEM_CELL SEARCH_MAIN_TABLE_SELECTED_RECORDS_PER_PAGE_MENU_ITEM"><img src="<%=BASE_DIRECTORY %>images/search/mainTable/recordsPerPageSelected.gif" border="0"></td>
							<%
								}else {
							%>
									<td class="SEARCH_MAIN_TABLE_RECORDS_PER_PAGE_MENU_ITEM_CELL">&nbsp;</td>
							<%
								}
							%>
									<td class="SEARCH_MAIN_TABLE_RECORDS_PER_PAGE_MENU_ITEM_CELL"><%=recordsPerPageArr[i] %> per page</td>
								</tr>
							<%
							}
							%>
						</table>
					</div>
				</div>
			</div>
			<%
			}
			%>
		</td>
		<%
		}
		%>
	</tr>
	<tr class="SEARCH_MAIN_TABLE_PADDING_ROW<%=classSuffix %>"><td colspan="<%=colspan %>">&nbsp;</td></tr>
</table>