<%@ page language="java"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.jaas.*"%>
<%@ page import="xpolog.eye.jaas.base.*"%>
<%@ page import="xpolog.eye.jaas.siteminder.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%

  String redirect = "home.jsp";
	String  queryString = request.getQueryString();
	if (queryString != null && queryString.length() > 0){
		redirect = redirect + "?" + queryString + "&";
	}else{
		redirect = redirect + "?";
	}

  if (redirect != null && redirect.length() > 0){
    redirect = BASE_DIRECTORY + redirect;
  }

  AuthenticatorFactory factory = XpologSecurityManager.getInstance().getAuthenticatorFactory();
  XpologAuthenticatorFactory xpologFactory = factory != null && factory instanceof XpologAuthenticatorFactory ? (XpologAuthenticatorFactory) factory : null;
  SiteminderConfiguration smConf = null;
  SiteminderValidatorFactory smFactory = null;
  String cookieName = "";
  if (xpologFactory != null){
	  smFactory = (SiteminderValidatorFactory)xpologFactory.getValidatorById("siteminder");
	  if (smFactory != null ){
	  	smConf = SiteminderConfiguration.createSMConf(smFactory.getSmConfPath());
	  	cookieName = smConf.getCookieName();
	  }	  
  }
  

%>
<html>
<head>
<script>
	function setCookie(name, value)
	{
		var argv = setCookie.arguments;
		var argc = setCookie.arguments.length;
		var expires = (argc > 2) ? argv[2] : null;
		var path = (argc > 3) ? argv[3] : null;
		var domain = (argc > 4) ? argv[4] : null;
		var secure = (argc > 5) ? argv[5] : false;
		document.cookie = " "+name + "=" + escape (value) +
		((expires == null) ? "" : ("; expires=" + expires.toGMTString())) +
		((path == null) ? "" : ("; path=" + path)) +
		((domain == null) ? "" : ("; domain=" + domain)) +
		((secure == true) ? "; secure" : "");
	}

	function getCookie(name) {
		var cookie = " " + document.cookie;
		var search = " " + name + "=";
		var setStr = null;
		var offset = 0;
		var end = 0;
		if (cookie.length > 0) {
			offset = cookie.indexOf(search);
			if (offset != -1) {
				offset += search.length;
				end = cookie.indexOf(";", offset)
				if (end == -1) {
					end = cookie.length;
				}
				setStr = unescape(cookie.substring(offset, end));
			}
		}
		
		//alert(setStr);
		return setStr;
	}

	function redirect(){
		//alert('redirecting');
		setCookie("cts_empnoid","app1admin");
		userId = getCookie("<%=cookieName%>");
		document.location = "<%=redirect%>UserID="+userId;
	}
</script>
</head>
<body onload="javascript:redirect()">
</body>
</html>

