<%@ page language="java"%>

<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.jaas.callback.SimpleCallbackHandler"%>
<%@ page import="xpolog.eye.jaas.callback.WebCallbackHandler"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%

  WebSecurityManager manager = WebSecurityManager.getInstance();

  boolean suc = false;
  String errorMsg = null;
  try {
    String username = request.getParameter(WebSecurityManager.USERNAME_PARAMETER);
    String password = request.getParameter(WebSecurityManager.PASSWORD_PARAMETER);
  	WebCallbackHandler callbackHandler = new WebCallbackHandler(username,password,request);
    suc = manager.login(request, callbackHandler);
    if (!suc){
    	errorMsg = SimpleCallbackHandler.getErrorDescription(callbackHandler.getErrorType());
    }
    UserContext userContext = UserEnvironment.getUserContext(request);
	//audit
    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
    			userContext, AuditConstants.LOGIN, "login/logout",AuditConstants.SECURITY, "login"); 
  }catch (Exception e){
    errorMsg = e.getMessage();
  }

  String redirect = null;
  if (suc){
    redirect = request.getParameter("successURL");
  }else {
    redirect = request.getParameter("failURL");
  }

  if (redirect != null && redirect.length() > 0){
    redirect = BASE_DIRECTORY + redirect;
     response.sendRedirect(redirect);
  }

%>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access">
<input type="hidden" id="loginSuc" name="loginSuc" value="<%=suc%>">
<input type="hidden" id="errorMsg" name="errorMsg" value="<%=errorMsg%>">
</form>
</body>

