<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.cert.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="java.security.cert.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
			if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.ToolsPermissions.EDIT_CERTIFICATES_PERMISSION,true)){
			    return;
			}
			String PKCS12_PATH = "pkcs12Path";
			String KEY_PATH = "keyPath";
			String ID = "id";
			String NAME = "name";
			String DESC = "desc";
			String CURRENT_X509 = "currentX509";

			String ERROR_OBJ = "ERROR_OBJ";

			CertificatesManager cmgr = CertificatesManager.getInstance();

			String pkcs12Path = request.getParameter(PKCS12_PATH);
			
			XPLG509Certificate cxc = (XPLG509Certificate)request.getSession().getAttribute(CURRENT_X509);
			//verify data
			ErrorModel errmodel = new ErrorModel();
			
			if(cxc == null){
				errmodel.addError("Certifiacte object missing please retry, session may be invalid due to timeout.");
			}
			
			
			if (errmodel.getErrorCount() > 0) {
				request.getSession().setAttribute(ERROR_OBJ, errmodel);
				response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
				return;
			}

			
			//here we will use xpolog builder for import -

			File pkcs12File = new File(pkcs12Path);
			
			try {
				pkcs12File = UploadHelper.uploadFile(request, pkcs12File);
			} catch (Exception e) {
				e.printStackTrace();
				ErrorModel errmod = new ErrorModel();
				errmod.addError(e.getMessage());
				request.getSession().setAttribute(ERROR_OBJ, errmod);
				response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
				return;
			} 
		
			if (errmodel.getErrorCount() > 0) {
				request.getSession().setAttribute(ERROR_OBJ, errmodel);
				response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
				return;
			}
			//pkcs12File
			cmgr.addCertificate(cxc,pkcs12File);
			response.sendRedirect("certview.jsp");
			
			//response.sendRedirect("certPrvKeyAdmin.jsp");
		%>


