<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.SecurityPermissions.EDIT_GROUPS_PERMISSION,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);

  Collection availGroupsCol = XpologSecurityHelper.getGroupsCollectionFromUser(security);
  XpologGroup [] groups = (XpologGroup [])availGroupsCol.toArray(new XpologGroup [availGroupsCol.size()]);
  String selectedGroupName = request.getParameter("selectedGroup");
  if (selectedGroupName == null || selectedGroupName.length() == 0){
  	if (security.getUser().getAssociatedGroup("administrators") != null){
  		selectedGroupName = "All";
  	}else if (groups != null && groups.length > 0){
  		selectedGroupName = groups[0].getName();
  	}
  }

   XpologGroup selectedGroup = null;

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>
function changeGroup(){
  var groupCombo = document.getElementById("groups");
  var groupName = groupCombo.options[groupCombo.selectedIndex].value;
  this.location = "<%=BASE_DIRECTORY%>security/management/groupsView.jsp?selectedGroup=" + groupName;
}

function doDelete(name){
   this.location = "removeopcheck.jsp?managementType=group&name="+name;
}
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Groups</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
									<tr>
                    <td width="15%" height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Groups:</span></td>
                        <td width="77%">

                        <select size="1" id="groups" name="groups" onChange="javascript:changeGroup()">
                          <%
                            String selected = "";
                            for(int i=0;i<groups.length;++i){
                              if(groups[i].getName().equals(selectedGroupName)){
                                selected = "selected=\"true\"";
                                selectedGroup = groups[i];
                              }else{
                                selected = "";
                              }
                            %>
                            <option class="TEXTBOX" value="<%=groups[i].getName()%>" <%=selected%>><%=groups[i].getDisplayName()%></option>
                          <%}%>
                        </select></td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr>
                        <td width="*" ><span class="HEADER">Groups members</span></td>
                        <td width="150"  class="REGULARTEXT"><a href="groupSettings.jsp" class="LINK">Add Group</a></td>
                      </tr>
                      <tr>
                       <td colspan="2">&nbsp;</td>
                       </tr>
                      <tr class="TABLES_HEADERS">
                        <td width="*"><span class="REGULARTEXT">Name</span></td>
                        <td width="150" class="REGULARTEXT">&nbsp;</td>
                      </tr>
                      <tr>
                        <td width="*" class="SMALLTEXT">&nbsp;</td>
                        <td width="150" class="SMALLTEXT">&nbsp;</td>
                      </tr>
                      <%
                        if (selectedGroup != null){
                          XpologGroup [] viewGroups = XpologEntitiesHelper.getGroupsFromGroup(selectedGroup);
                          XpologEntitiesHelper.sort(viewGroups,true);
			  String clas = "UNMARKITEM";
                          for(int i=0;i<viewGroups.length;++i){
                            if((i%2) == 0){
                              clas = "UNMARKITEM";
                            }else{
                              clas = "MARKITEM";
                            }
                          %>
                            <tr class="<%=clas%>">



			  <td width="*"><span class="REGULARTEXT"><%=viewGroups[i].getDisplayName()%></span></td>
                          <td width="150">
                               <%if (viewGroups[i].isEditable()){%>
                              <a href="groupSettings.jsp?groupname=<%=viewGroups[i].getName()%>" class="LINK">edit</a><span class="REGULARTEXT">&nbsp;&nbsp;</span>
                              <% }else { %>
                              <a href="groupSettings.jsp?isViewOnly=true&groupname=<%=viewGroups[i].getName()%>" class="LINK">View</a><span class="REGULARTEXT">&nbsp;&nbsp;</span>
                              <%}
                               if (viewGroups[i].isDeletable()){%>
                               <a href='javascript:doDelete("<%=viewGroups[i].getName()%>")' class="LINK">delete</a>
                               <%}%>

                           </td>
                       </tr>
                      <%}}%>
                    </table>
                   </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>
</html>