<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.SecurityPermissions.EDIT_POLICIES_PERMISSION,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  String policyname = request.getParameter("name");
  ErrorModel errmodel = new ErrorModel();

  if(policyname == null || policyname.trim().equals("")){
    errmodel.addError("No policy name was supplied.");
  }


  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;

  }
  
  //audit  
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
			userContext, AuditConstants.CHANGE, "remove policy", AuditConstants.SECURITY, "remove policy " + policyname);	 	 	

   manager.removePolicy(security,policyname);
   response.sendRedirect("removeopok.jsp?managementType=policy");
%>