<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="xpolog.eye.jaas.search.*"%>
<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>

<%

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.SecurityPermissions.EDIT_USERS_PERMISSION,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);



  Collection availGroupsCol = XpologSecurityHelper.getGroupsCollectionFromUser(security);
  XpologGroup [] availGroups = (XpologGroup [])availGroupsCol.toArray(new XpologGroup [availGroupsCol.size()]);
  XpologGroup [] associatedGroups = {manager.getGroup(security,XpologAllGroup.ALL_GROUP_NAME)};
  XpologPolicy [] availPolicies = manager.getPoliciesByOrder(security,true);
  XpologPolicy policy = null;
  
  
  PrincipalSearcher searcher = manager.getPrincicpalSearcher(security);
  PrincipalSearchResults result = new PrincipalSearchResults();
  request.getSession().setAttribute("UsersSearchResult",result);

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>

function doSave(){
  for(var j=0;j<document.access.SelectedGroupsList.options.length;j++){
    document.access.SelectedGroupsList.options[j].selected = true;
  }
   for(var j=0;j<document.access.SelectedUsersList.options.length;j++){
    document.access.SelectedUsersList.options[j].selected = true;
  }
  document.access.action="usersSearchingAction.jsp";
  document.access.target = "";
  document.access.submit();
}

function doSearch(){ 
  document.access.action="usersSearchResult.jsp";
  document.access.target = "searchFrame";
  document.access.submit();
}


function doCancel(){
  this.location = "usersSearching.jsp";
}

function doGroupAdd(){
  if(document.access.availableGroupsList.selectedIndex == -1){
    return;
  }
  for(var j=0;j<document.access.availableGroupsList.options.length;j++){
    if (document.access.availableGroupsList.options[j].selected){
      var name = document.access.availableGroupsList.options[j].text;
      var value = document.access.availableGroupsList.options[j].value;
      var found = false;
      for(var i=0;i<document.access.SelectedGroupsList.options.length;i++){
        if(document.access.SelectedGroupsList.options[i].value == value){
          found = true;
        }
      }
      if (!found){
        var option0 = new Option(name,value);
        document.access.SelectedGroupsList.options[document.access.SelectedGroupsList.options.length] = option0;
      }
    }
  }
}

function doGroupRemove(){
  if(document.access.SelectedGroupsList.selectedIndex == -1){
    return;
  }

  for(var i= document.access.SelectedGroupsList.options.length ; --i >= 0;){
    if(document.access.SelectedGroupsList.options[i].selected){
       document.access.SelectedGroupsList.options[i] = null;
    }
  }
}

function doUserAdd(){
  if(document.access.availableUsersList.selectedIndex == -1){
    return;
  }
  for(var j=0;j<document.access.availableUsersList.options.length;j++){
    if (document.access.availableUsersList.options[j].selected){
      var name = document.access.availableUsersList.options[j].text;
      var value = document.access.availableUsersList.options[j].value;
      var found = false;
      for(var i=0;i<document.access.SelectedUsersList.options.length;i++){
        if(document.access.SelectedUsersList.options[i].value == value){
          found = true;
        }
      }
      if (!found){
        var option0 = new Option(name,value);
        document.access.SelectedUsersList.options[document.access.SelectedUsersList.options.length] = option0;
      }
    }
  }
}

function doUserRemove(){
  if(document.access.SelectedUsersList.selectedIndex == -1){
    return;
  }

  for(var i= document.access.SelectedUsersList.options.length ; --i >= 0;){
    if(document.access.SelectedUsersList.options[i].selected){
       document.access.SelectedUsersList.options[i] = null;
    }
  }
}

function updateSearch(){
  var ids = frames['searchFrame'].ids;
  var names = frames['searchFrame'].names;
  
  document.access.availableUsersList.options.length = 0;
  for(i = 0 ; ids && i < ids.length; i++){
    var option0 = new Option(names[i],ids[i]);
    document.access.availableUsersList.options[document.access.availableUsersList.options.length] = option0;
  }
}

function doCheckSearch(e){
		var result = doCheck(e);
		if (!result){
			doSearch();
		}
		return result;
  }

	function doCheck(e){
		if (!e) var e = window.event;
		if (e.keyCode) code = e.keyCode;
		else if (e.which) code = e.which;
		if (code == 13){
		  return false;
		}
		return true;
  }

</script>
</head>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" action="usersSearchingAction.jsp" method="post" style="padding:0;margin:0">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
              <tr>
                <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="53%" class="TOPBORDER" height="0">
                <span class="PAGEHEADER">Users Searching</span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td colspan="3" >&nbsp;</td>
              </tr>
             </table>
             <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%"  height="100%">
               <tr>
                   <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                                    <tr>
                    <td width="15%" height="5"></td>
                  </tr>
                 
                  <tr>
                    <td height="10">
                    <%if (searcher != null){ %>                    
                      <input type="text" size="25" name="searchTerm" onKeyPress="return doCheckSearch(event)">                      
                      &nbsp;&nbsp;<a class="LINK" href="javascript:doSearch()">search</a>
                      <%}%>
                    </td>
                    <td>
                    <iframe name="searchFrame" style="visibility:hidden" onload="javascript:updateSearch();" src="usersSearchResult.jsp" width="0" height="0"></iframe>
                    </td>
                  </tr> 


                  <tr>
                    <td width="15%" height="8"></td>
                  </tr>
                   <tr>
                    <td width="15%" height="18"><span class="HEADER">Search Result</span><b>&nbsp;</b></td>
                  </tr>                 
                  <tr>
                    <td>
                    <span class="REGULARTEXT">Select the users which you want to add:</span>
                    </td>
                  </tr>
                 <tr>
                    <td width="15%" height="8"></td>
                  </tr>
                   <tr>
                    <td width="100%" height="18">
                      <table border="0" width="500">
                        <tr>
                    	  <td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Available Users</span></td>
				  <td width="100" height="18">&nbsp;</td>
				  <td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Selected Users</span></td>
                  	</tr>
                        <tr>
                          <td width="200">
                             <select size="5" style="width:200" name="availableUsersList" id="availableUsersList" multiple>
                             
                              </select>
 				  </td>
                          <td width="100">
                            <table border="0" width="100">
                             <tr><td align="center">
                               <a href="javascript:doUserAdd()" class="LINK">Add</a>
                             </td> </tr>
					<tr><td align="center">
                  	    <a href="javascript:doUserRemove()" class="LINK">Remove</a>
					</td> </tr>

                          </table>
                          <td width="200">
                            <select size="5" style="width:200" name="SelectedUsersList" id="SelectedUsersList" multiple>
			
                              </select>
 				  </td>
                          </tr>

                      </table>
                    </td>
                  </tr>




			

			<tr>
                    <td>
                    <font size="2">&nbsp;</font>
                    </td>
                  </tr>
                  
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Groups list</span><b>&nbsp;</b></td>
                  </tr>
                 
                  <tr>
                    <td>
                    <span class="REGULARTEXT">Select the groups which this user Associated to:</span>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%" height="8">
                    &nbsp;</td>
                  </tr>
                   <tr>
                    <td width="100%" height="18">
                      <table border="0" width="500">
                        <tr>
                    	  <td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Available Groups</span></td>
				  <td width="100" height="18">&nbsp;</td>
				  <td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Associated Groups</span></td>
                  	</tr>
                        <tr>
                          <td width="200">
                             <select size="5" style="width:200" name="availableGroupsList" id="availableGroupsList" multiple>
                             <%
                               for (int i = 0; i < availGroups.length; i++) {
                             %>


                                <option value="<%=availGroups[i].getName()%>" class="TEXTBOX" name="<%=availGroups[i].getName()%>"><%=availGroups[i].getDisplayName()%></option>
                              <%}%>
                              </select>
 				  </td>
                          <td width="100">
                            <table border="0" width="100">
                             <tr><td align="center">
                               <a href="javascript:doGroupAdd()" class="LINK">Add</a>
                             </td> </tr>
					<tr><td align="center">
                  	    <a href="javascript:doGroupRemove()" class="LINK">Remove</a>
					</td> </tr>

                          </table>
                          <td width="200">
                            <select size="5" style="width:200" name="SelectedGroupsList" id="SelectedGroupsList" multiple>
				<%
                               for (int i = 0; i < associatedGroups.length; i++) {
                             %>


                                <option value="<%=associatedGroups[i].getName()%>" class="TEXTBOX" name="<%=associatedGroups[i].getName()%>"><%=associatedGroups[i].getDisplayName()%></option>
                              <%}%>
                              </select>
 				  </td>
                          </tr>

                      </table>
                    </td>
                  </tr>




			<tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Policy Settings</span><b>&nbsp;</b></td>
                  </tr>
                 
                  <tr>
                    <td>
                    <span class="REGULARTEXT">Select If the user will use the user's group policy or specific policy</span>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                   <tr>
                    <td width="100%" height="18">
                      <table border="0" width="100%">
                        <tr>
                    	  <td>
                            <input type="radio" value="sone" name="UserPolicy" <%=policy == null?"checked" : ""%>><span class="REGULARTEXT">&nbsp;Use the policy of the selected groups</span>
 			  </td>
			      </tr>
				<tr>
                    	  <td>
                             <input type="radio" value="specific" name="UserPolicy" <%=policy != null?"checked" : ""%>><span class="REGULARTEXT">&nbsp;Use the following policy: &nbsp; </span>
					 <select size="1" name="selectedPolicy" id="selectedPolicy">
                              <%
                               String selectedName = policy == null ? "default" : policy.getName();
                               for (int i = 0; i < availPolicies.length; i++) {
                                 String selectedStr = selectedName.equals(availPolicies[i].getName())  ? "selected" : "";
                             %>


                                <option value="<%=availPolicies[i].getName()%>" class="REGULARTEXT" name="selectedPolicy" <%=selectedStr%>><%=availPolicies[i].getDisplayName()%></option>
                              <%}%>

                       		 </select>

 				  </td>
			      </tr>


                      </table>
                    </td>
                  </tr>

			<tr>
                    <td>
                    <font size="2">&nbsp;</font>
                    </td>
                  </tr>



                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="30%">&nbsp;</td>
            <td width="31%" align="center">
              <table border="0" width="225">
                <tr>
                  <td width="33%"><a href="javascript:doSave()" class="LINK" >Save</a></td>
                  <td width="33%"><a href="javascript:doCancel()" class="LINK">Cancel</a></td>
                </tr>
              </table>
            </td>
            <td width="39%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>

</body>
</html>