<%@ page language="java"%>
<%@ page import="xpolog.eye.jaas.search.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
	
<%String ERROR_OBJ = "ERROR_OBJ";
			WebSecurityManager manager = WebSecurityManager.getInstance();
			if (!manager.checkForPermission(request, response, ActionsPermissionConstants.SecurityPermissions.EDIT_USERS_PERMISSION, true)) {
				return;
			}
			UserSecurity security = manager.getUserSecurity(request);
			UserContext userContext = UserEnvironment.getUserContext(request);
			ErrorModel errmodel = new ErrorModel();

			String[] usersAtt = request.getParameterValues("SelectedUsersList");

			if (usersAtt == null || usersAtt.length == 0) {
				errmodel.addError("No user was defined.");
			}

			String[] asscociatedAtt = request.getParameterValues("SelectedGroupsList");

			if (asscociatedAtt == null || asscociatedAtt.length == 0) {
				errmodel.addError("At least one associated group must be selected.");
			}

			String policy = request.getParameter("UserPolicy");
			if (policy != null && policy.equals("specific")) {
				policy = request.getParameter("selectedPolicy");
			} else {
				policy = null;
			}

			if (errmodel.getErrorCount() != 0) {
				request.getSession().setAttribute(ERROR_OBJ, errmodel);
				response.sendRedirect("errorpage.jsp");
				return;

			}

			PrincipalSearchResults result = (PrincipalSearchResults) request.getSession().getAttribute("UsersSearchResult");
			String usersNames = "";
			if (result != null && usersAtt != null) {
				for (int i = 0; i < usersAtt.length; i++) {
					PrincipalSearchResult principal = result.getPrincipalbyName(usersAtt[i]);
					if (principal == null) continue;
					
					XpologUser user = new XpologUser();
					manager.fillGroupMemberParameters(user, principal.getName(), principal.getDisplayName(), "", asscociatedAtt, null, policy);
					manager.setUser(security, user, principal.getPasswd());
					usersNames += principal.getDisplayName();
					if(usersAtt.length-1>i) {
						usersNames += ", ";
					}
				}
			}
		
			 //audit
			 AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		     			userContext, AuditConstants.CHANGE, "add users", AuditConstants.SECURITY, "add users: " + usersNames);	 	 	

			response.sendRedirect("addopok.jsp?managementType=user");

		%>