<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.SecurityPermissions.EDIT_USERS_PERMISSION,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);
  boolean isAdmin = security.getUser().isAdmin();

  Collection col = XpologSecurityHelper.getGroupsCollectionFromUser(security);
  XpologGroup [] groups = (XpologGroup [])col.toArray(new XpologGroup [col.size()]);
  String selectedGroupName = request.getParameter("selectedGroup");
  if (selectedGroupName == null || selectedGroupName.length() == 0){
  	if (security.getUser().getAssociatedGroup("administrators") != null){
  		selectedGroupName = "All";
  	}else if (groups != null && groups.length > 0){
  		selectedGroupName = groups[0].getName();
  	}
  }

   XpologGroup selectedGroup = null;
   
   xpolog.eye.jaas.search.PrincipalSearcher searcher = manager.getPrincicpalSearcher(security);
   request.getSession().removeAttribute("UsersSearchResult");
   
   boolean USER_LOCKOUT_IS_ACTIVE = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("xpolog.eye.security.userLockout.isActive", false);
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>
function changeGroup(){
  var groupCombo = document.getElementById("groups");
  var groupName = groupCombo.options[groupCombo.selectedIndex].value;
  this.location = "<%=BASE_DIRECTORY%>security/management/usersView.jsp?selectedGroup=" + groupName;
}

function doDelete(name){
   this.location = "removeopcheck.jsp?managementType=user&name="+name;
}

function doUnlock(name){
	   this.location = "unlockUser.jsp?name="+name;
	}
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access" style="padding:0;margin:0">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Users</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
										<tr>
                    <td width="15%" height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Groups:</span></td>
                        <td width="77%">

                        <select size="1" id="groups" name="groups" onChange="javascript:changeGroup()">
                          <%
                            String selected = "";
                            for(int i=0;i<groups.length;++i){
                              if(groups[i].getName().equals(selectedGroupName)){
                                selected = "selected=\"true\"";
                                selectedGroup = groups[i];
                              }else{
                                selected = "";
                              }
                            %>
                            <option class="TEXTBOX" value="<%=groups[i].getName()%>" <%=selected%>><%=groups[i].getDisplayName()%></option>
                          <%}%>
                        </select></td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr>
                        <td width="*" ><span class="HEADER">Group users</span></td>
                        <td width="150"  class="REGULARTEXT"><nobr><a href="userSettings.jsp" class="LINK">Add User</a> 
                        <%if (searcher != null){ %>
                        &nbsp;/&nbsp; <a href="usersSearching.jsp" class="LINK">Search Users</a> 
                        <%}%></nobr>
                        </td>
                      </tr>
                      <tr>
                       <td colspan="2">&nbsp;</td>
                       </tr>
                      <tr class="TABLES_HEADERS">
                        <td width="*"><span class="REGULARTEXT">Name</span></td>
                        <td width="150" class="REGULARTEXT">&nbsp;</td>
                      </tr>
                      <tr>
                        <td width="*" class="SMALLTEXT">&nbsp;</td>
                        <td width="150" class="SMALLTEXT">&nbsp;</td>
                      </tr>
                      <%
                        if (selectedGroup != null){
                          XpologUser [] users = XpologEntitiesHelper.getUsersFromGroup(selectedGroup);
                          XpologEntitiesHelper.sort(users,true);
			  									String clas = "UNMARKITEM";
                          for(int i=0;i<users.length;++i){
	                          boolean isDeleted = !users[i].getName().equals(security.getUser().getName()) && users[i].isDeletable();
	                          if((i%2) == 0){
	                            clas = "UNMARKITEM";
	                          }else{
	                            clas = "MARKITEM";
	                          }
                          %>
                          <tr class="<%=clas%>">
			  										<td width="*"><span class="REGULARTEXT"><%=users[i].getDisplayName()%></span></td>
                          	<td width="150">
                           	<%if (!isAdmin && users[i].getName().equals(security.getUser().getName())){%>
                           		<span class="REGULARTEXT">&nbsp;&nbsp;</span>
                           	<%}else if (users[i].isEditable()){%>
                              <a href="userSettings.jsp?username=<%=users[i].getName()%>" class="LINK">Edit</a><span class="REGULARTEXT">&nbsp;&nbsp;</span>
                           	<%}else {%>
                              <a href="userSettings.jsp?isViewOnly=true&username=<%=users[i].getName()%>" class="LINK">View</a><span class="REGULARTEXT">&nbsp;&nbsp;</span>
                           	<%}
                           		if (isDeleted){
                           	%>
                              <a href='javascript:doDelete("<%=users[i].getName()%>")' class="LINK">Delete</a><span class="REGULARTEXT">&nbsp;&nbsp;</span>
                          	<%}%>
	                          <%
  		                        if(USER_LOCKOUT_IS_ACTIVE && manager.isUserLockedOut(users[i].getName())) {
                          	%>
															<a href='javascript:doUnlock("<%=users[i].getName()%>")' class="LINK">Unlock</a>
                          	<%
                          	}
                          	%>
                          	</td>
                       		</tr>
                      	<%
                      		}
                          if(WebSecurityManager.USER_LOCKOUT_IS_ACTIVE && XpologAllGroup.ALL_GROUP_NAME.equals(selectedGroupName)) {
                          	String[] lockedTemporaryUsersNames = XpologEntitiesHelper.getLockedTemporaryUsersNames(users);
                          	if(lockedTemporaryUsersNames != null && lockedTemporaryUsersNames.length > 0) {
                          		int add = users.length % 2 == 0 ? 0 : 1;
                          		for(int i = 0; i < lockedTemporaryUsersNames.length; i++) {
                          			if((i+add%2) == 0){
    	                            clas = "UNMARKITEM";
    	                          }else{
    	                            clas = "MARKITEM";
    	                          }
                        %>
                          			<tr class="<%=clas%>">
	    			  										<td width="*"><span class="REGULARTEXT"><%=lockedTemporaryUsersNames[i]%></span></td>
	                              	<td width="150">
	                               		<a href='javascript:doUnlock("<%=lockedTemporaryUsersNames[i]%>")' class="LINK">Unlock</a>
	                              	</td>
	                           		</tr>
	                      <%
                          		}
                          	}
                          }
                        }
                        %>
                    </table>
                   </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>
</html>