<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.config.env.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  XpologEnvironmentManager envMgr = XpologEnvironmentManager.getInstance();
  

  String ERROR_OBJ = "ERROR_OBJ";
  ErrorModel err = new ErrorModel();
	String redirectUrl = request.getParameter("redirectURL");
	String op = request.getParameter("OP");

	String numPropsStr = request.getParameter("numberOfEnvVars");
	int numProps = (numPropsStr == null || numPropsStr.length() == 0) ? 0 : Integer.parseInt(numPropsStr);
	//envMgr.clearEnvParams();
	Properties oldEnvParams = new Properties();
	if (envMgr.getAllEnvParams(userContext) != null){
		oldEnvParams = (Properties)envMgr.getAllEnvParams(userContext).clone();
	}
	String key,value;
	for (int i=1; i<=numProps; i++){
		key = request.getParameter("key_"+i);
		value = request.getParameter("value_"+i);
		if (key != null && value != null && key.length() > 0){
			envMgr.addEnvParam(key,value,userContext);
			oldEnvParams.remove(key);
		}
	}
	Iterator it = oldEnvParams.keySet().iterator();
	while (it.hasNext()){
		key = (String)it.next();
		envMgr.removeEnvParam(key,userContext);
	}
	envMgr.saveEnvParams();

	if(err.getErrorCount() > 0){
    request.getSession().setAttribute(ERROR_OBJ,err);
    response.sendRedirect("errorpage.jsp");
    return;
  }
	
	  //audit
	  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	  			userContext, AuditConstants.CHANGE, "edit/save XpoLog environment variables", AuditConstants.CONFIGURATION, "change XpoLog environment variables");
	if (redirectUrl == null || redirectUrl.length() == 0){
		response.sendRedirect(BASE_DIRECTORY+"settings/envAdmin.jsp");
	}else{
		response.sendRedirect(BASE_DIRECTORY+redirectUrl);
	}
%>