<%@page import="xpolog.eye.media.telsh.TelnetAccountPolicy"%>
<%@page import="xpolog.eye.site.TelShActivityManager"%>
<%
  // default account policies
  TelnetAccountPolicy defaultTelnetAccountPolicy = TelShActivityManager.getInstance().getDefaultTelnetAccountPolicy();
  long sshPoolTimeoutInterval = -1, sshSessionTimeoutInterval = -1;
  String sshPoolTimeoutIntervalValueType = "", sshSessionTimeoutIntervalValueType = "";
  int sshMaxConnections = -1, sshMaxSessionsPerConnection = -1;
  if(defaultTelnetAccountPolicy != null) {
  	sshPoolTimeoutInterval = defaultTelnetAccountPolicy.getPoolTimeoutInterval();
  	sshPoolTimeoutIntervalValueType = defaultTelnetAccountPolicy.getPoolTimeoutIntervalValueType();
  	if(sshPoolTimeoutIntervalValueType.equals("min")) {
  		sshPoolTimeoutInterval = sshPoolTimeoutInterval / 1000 / 60;
  	}else if(sshPoolTimeoutIntervalValueType.equals("hour")) {
  		sshPoolTimeoutInterval = sshPoolTimeoutInterval / 1000 / 60 / 60;
  	}
  	sshSessionTimeoutInterval = defaultTelnetAccountPolicy.getSessionTimeoutInterval();
  	sshSessionTimeoutIntervalValueType = defaultTelnetAccountPolicy.getSessionTimeoutIntervalValueType();
  	if(sshSessionTimeoutInterval != -1) {
	  	if(sshSessionTimeoutIntervalValueType.equals("min")) {
	  		sshSessionTimeoutInterval = sshSessionTimeoutInterval / 1000 / 60;
	  	}else if(sshSessionTimeoutIntervalValueType.equals("hour")) {
	  		sshSessionTimeoutInterval = sshSessionTimeoutInterval / 1000 / 60 / 60;
	  	}
  	}
  	sshMaxConnections = defaultTelnetAccountPolicy.getMaxConnections();
  	sshMaxSessionsPerConnection = defaultTelnetAccountPolicy.getMaxSessionsPerConnection();
  }
%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>
		<td style="padding-left:10px">
			<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
<!-- start default account policies -->
								<tr>
									<td>&nbsp;</td>                        
								</tr>
								<tr>
									<td>
										<div id="defaultAccountPoliciesDiv" style="display:">
											<table border="0" width="100%" cellpadding="0" cellspacing="0">
												<tr>
													<td>
														<span class="HEADER">Default SSH Account Policy</span>
													</td>
												</tr>
												<tr>
													<td style="padding-top:10">
														<span class="REGULARTEXT">Connection pool timeout interval  
															<input type="text" id="sshPoolTimeoutInterval" name="sshPoolTimeoutInterval" value="<%=String.valueOf(sshPoolTimeoutInterval)%>" size="5">
														</span>
														<select id="sshPoolTimeoutIntervalValueType" name="sshPoolTimeoutIntervalValueType" size="1">
															<option value="min" <%=sshPoolTimeoutIntervalValueType.equals("min") ? "selected" : "" %>>minutes</option>
															<option value="hour" <%=sshPoolTimeoutIntervalValueType.equals("hour") ? "selected" : "" %>>hours</option>
														</select>
													</td>
												</tr>
												<tr>
													<td>
														<span class="SMALLTEXT"> the allowed period of connections inactivity before a pool is closed; type -1 to close the pool as soon as possible</span>
													</td>
												</tr>
												<tr>
													<td style="padding-top:10">
														<span class="REGULARTEXT">User session timeout interval  
															<input type="text" id="sshSessionTimeoutInterval" name="sshSessionTimeoutInterval" value="<%=sshSessionTimeoutInterval == -1 ? "" : String.valueOf(sshSessionTimeoutInterval)%>" size="5">
														</span>
														<select id="sshSessionTimeoutIntervalValueType" name="sshSessionTimeoutIntervalValueType" size="1">
															<option value="min" <%=sshSessionTimeoutIntervalValueType.equals("min") ? "selected" : "" %>>minutes</option>
															<option value="hour" <%=sshSessionTimeoutIntervalValueType.equals("hour") ? "selected" : "" %>>hours</option>
														</select>
													</td>
												</tr>
												<tr>
													<td>
														<span class="SMALLTEXT"> the allowed period of user inactivity before a log is closed. leave blank for unlimited inactivity period</span>
													</td>
												</tr>
												<tr>
													<td style="padding-top:10">
														<span class="REGULARTEXT">Number of connections allowed to remote machine  
															<input type="text" id="sshMaxConnections" name="sshMaxConnections" value="<%=sshMaxConnections == -1 ? "" : String.valueOf(sshMaxConnections)%>" size="5">
														</span>
													</td>
												</tr>
												<tr>
													<td>
														<span class="SMALLTEXT"> the allowed number of connections to a remote machine. leave blank for unlimited number of connections</span>
													</td>
												</tr>
												<tr>
													<td style="padding-top:10">
														<span class="REGULARTEXT">Number of sessions allowed per connection
															<select id="sshMaxSessionsPerConnection" name="sshMaxSessionsPerConnection" size="1">
																<option value="2" <%=sshMaxSessionsPerConnection == 2 ? "selected" : "" %>>2</option>
																<option value="3" <%=sshMaxSessionsPerConnection == 3 ? "selected" : "" %>>3</option>
																<option value="4" <%=sshMaxSessionsPerConnection == 4 ? "selected" : "" %>>4</option>
																<option value="5" <%=sshMaxSessionsPerConnection == 5 ? "selected" : "" %>>5</option>
																<option value="6" <%=sshMaxSessionsPerConnection == 6 ? "selected" : "" %>>6</option>
																<option value="7" <%=sshMaxSessionsPerConnection == 7 ? "selected" : "" %>>7</option>
															</select>  
														</span>
													</td>
												</tr>
												<tr>
													<td>
														<span class="SMALLTEXT"> the number of sessions that can be opened using the same connection</span>
													</td>
												</tr>
											</table>
										</div>
									</td>
								</tr>
<!-- end default account policies -->
                 
                 
                 
                  <tr height="100%">
		                    <td>
		                    &nbsp;                    
		                    </td>
		                </tr>                 
			</table>
		</td>
	</tr>
</table>			