<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.reports.ReportsManager"%>
<%@ page import="xpolog.eye.security.XpologSecurityHelper"%>
<%@ page import="xpolog.eye.util.Constants"%>

<%
String apiPolicy = Configuration.getInstance().getPropertiesManager().getProperty("api.policy", XpologSecurityHelper.API_POLICY_NONE);
if (apiPolicy.length() == 0){
	apiPolicy = XpologSecurityHelper.API_POLICY_NONE;
}

String reportsDeletionInterval = ReportsManager.getInstance().getReportsDeletionInterval();
int reportsDeletionIntervalUnit = ReportsManager.getInstance().getReportsDeletionIntervalUnit();
%>


<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>
		<td style="padding-left:10px">
			<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
								 <tr>
                    <td>&nbsp;</td>                        
                 </tr>
                  <tr>
                    <td>
	                    <span class="HEADER">API Policy</span>
                    </td>
                  </tr>
                  <tr>
                    <td>
	                    <span class="REGULARTEXT">Select the activation policy of XpoLog's API:</span>
                    </td>
                  </tr>
                  <tr>
                  		<td>
                  				<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
																  <tr>
																			<td class="REGULARTEXT"><input type="radio" name="apiPolicy" <%=apiPolicy.equals(XpologSecurityHelper.API_POLICY_NONE) ? "checked" : ""%> value="<%=XpologSecurityHelper.API_POLICY_NONE%>"/>Api not allowed</td>
																	</tr>                  				
																	<%if(apiPolicy.equals(XpologSecurityHelper.API_POLICY_PREDEFINED)){ %>
																	<tr>
																			<td class="REGULARTEXT"><input type="radio" name="apiPolicy"  checked value="<%=XpologSecurityHelper.API_POLICY_PREDEFINED%>"/>Api allowed only for predefined definition</td>
																	</tr>  
																	<%}%>                																					
																	<tr>
																			<td class="REGULARTEXT"><input type="radio" name="apiPolicy"  <%=apiPolicy.equals(XpologSecurityHelper.API_POLICY_USER_PASSWORD) ? "checked" : ""%> value="<%=XpologSecurityHelper.API_POLICY_USER_PASSWORD%>"/>Api allowed only with user and password</td>
																	</tr>                  				
																	<%if(apiPolicy.equals(XpologSecurityHelper.API_POLICY_USER_PASSWORD_PREDEFINED)){ %>
																	<tr>
																			<td class="REGULARTEXT"><input type="radio" name="apiPolicy"  checked value="<%=XpologSecurityHelper.API_POLICY_USER_PASSWORD_PREDEFINED%>"/>Api allowed only with user, password and predefined definition</td>
																	</tr>                  																																						
																	<%}%>
																	<tr>
																			<td class="REGULARTEXT"><input type="radio" name="apiPolicy" <%=apiPolicy.equals(XpologSecurityHelper.API_POLICY_ALL) ? "checked" : ""%> value="<%=XpologSecurityHelper.API_POLICY_ALL%>"/>Api allowed for all</td>
																	</tr>                  				
                  				</table>
                  		</td>
                  </tr>
                  <tr>
                  	<td style="padding-top: 20px;">
                  		<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
												<tr>
			                    <td>
				                    <span class="HEADER">Reports Maintenance</span>
			                    </td>
												</tr>
											</table>
										</td>
                  </tr>
                  <tr>
                  	<td style="padding-top: 5px;">
                  		<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
												<tr>
													<td class="REGULARTEXT" style="width:220px;padding-top: 5px;">Delete report results older than:</td>
													<td>
														<input type="text" name="reportsDeletionInterval" size="5" value="<%=reportsDeletionInterval%>">
														<select id="reportsDeletionIntervalUnit" name="reportsDeletionIntervalUnit" size="1">
															<option value="<%=Constants.TimeUnits.INTERVAL_UNIT_DAY %>" <%=reportsDeletionIntervalUnit == Constants.TimeUnits.INTERVAL_UNIT_DAY ? "selected" : "" %>>Days</option>
															<option value="<%=Constants.TimeUnits.INTERVAL_UNIT_WEEK %>" <%=reportsDeletionIntervalUnit == Constants.TimeUnits.INTERVAL_UNIT_WEEK ? "selected" : "" %>>Weeks</option>
															<option value="<%=Constants.TimeUnits.INTERVAL_UNIT_MONTH %>" <%=reportsDeletionIntervalUnit == Constants.TimeUnits.INTERVAL_UNIT_MONTH ? "selected" : "" %>>Months</option>
															<option value="<%=Constants.TimeUnits.INTERVAL_UNIT_YEAR %>" <%=reportsDeletionIntervalUnit == Constants.TimeUnits.INTERVAL_UNIT_YEAR ? "selected" : "" %>>Years</option>
														</select>
													</td>
												</tr>
											</table>
                  	</td>
									</tr>
									<tr>
                  	<td style="padding-top: 20px;">
                  		<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
												<tr>
			                    <td>
				                    <span class="HEADER">Custom Report Functions</span>
			                    </td>
												</tr>
											</table>
										</td>
                  </tr>
									<tr>
								  	<td width="100%">
									  	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">							
												<tr style="font-size:1px" height="6">
													<td>&nbsp;</td>
												</tr>  
												<tr>										
													<td><span class="REGULARTEXT">Click </span><a href="javascript:showHideUploadFunctionLink()" class="LINK">here</a><span class="REGULARTEXT"> to upload report functions JAR to XpoLog Center</span></td>
													<td width="*">&nbsp;</td>
												</tr>			 
											</table>   	        					    	
								    </td>
									</tr>		
                  <tr height="100%">
                  		<td>&nbsp;</td>
                  </tr>
			</table>
		</td>
	</tr>
</table>				