<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.site.run.LogActionsConfiguration"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.util.Constants"%>
<%

	//new log actions
	LogActionsConfiguration logActionsConf = LogActionsConfiguration.getInstance();
	double cpuLimit = logActionsConf.getCpuLimit();
	String runIndexing = logActionsConf.isRunIndexing() ? " checked" : "";
	String runReports = logActionsConf.isRunReports() ? " checked" : "";
	String runDashboard = logActionsConf.isRunDashboard() ? " checked" : "";

	boolean isDashboardValid = SiteManagment.getInstance().getXpologManagment().isDashboardValidAndComponentExists();
	
	String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);
	
%>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>
		<td style="padding-left:10px">
			<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
<!-- start new log actions -->
								<tr>
									<td>&nbsp;</td>                        
								</tr>
								<tr>
									<td>
										<div id="newLogActionsDiv" style="display:">
											<table border="0" width="100%" cellpadding="0" cellspacing="0">
												<tr>
													<td>
														<span class="HEADER">New Log Actions</span>
													</td>
												</tr>
												<tr>
													<td>
														<span class="REGULARTEXT">Execute the following actions after a new log is added:</span>
													</td>
												</tr>
												<tr>
													<td>
														<input type="checkbox" name="runIndexing" <%=runIndexing%> value="true">
														<span class="REGULARTEXT">Index Log</span>
													</td>
												</tr>
												<tr>
													<td>
														<input type="checkbox" name="runReports" <%=runReports%> value="true">
														<span class="REGULARTEXT">Run Quick Report</span>
													</td>
												</tr>
												<%if(isDashboardValid) { %>
												<tr>
													<td>
														<input type="checkbox" name="runDashboard" <%=runDashboard%> value="true">
														<span class="REGULARTEXT">Run <%=analyticsH %></span>
													</td>
												</tr>
												<%} %>
												<tr>
													<td>
														<span class="REGULARTEXT">Limit CPU utilization during new log actions to 
															<input type="text" name="cpuLimit" size="2" value="<%=cpuLimit == -1 ? "" : String.valueOf((int)cpuLimit)%>"> %
														</span>
														<span class="SMALLTEXT"> (leave empty for no CPU limitations)</span>
													</td>
												</tr>
											</table>
										</div>
									</td>
								</tr>
<!-- end new log actions -->
                 
                  <tr height="100%">
                  		<td>&nbsp;</td>
                  </tr>
			</table>
		</td>
	</tr>
</table>				