<%@ page language="java"%>

<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@page import="xpolog.eye.data.util.functions.XpoLogFunctionManager"%>
<%@ page import="xpolog.eye.security.*"%>

<%@ page import="java.io.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%

  String ARCHIVE_PATH = "ARCHIVE_PATH";
  String ERROR_OBJ = "ERROR_OBJ";    


  String arch_file  = request.getParameter(ARCHIVE_PATH);
	String result = "OK";

  //verify data
  ErrorModel errmodel = new ErrorModel();
  if(arch_file == null || arch_file.trim().equals("")){
    errmodel.addError("No archive file was supplied.");
    	result = "<div id=\"uploadResultDivId\">";
    	result += "<b>No archive file was supplied.</b>";
    	result += "</div>";
    	out.write(result);
    	out.flush();
    return;
  }
  
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)){
  	errmodel.addError("Upload permission denied.");
  	result = "<div id=\"uploadResultDivId\">";
  	result += "<b>Upload permission denied.</b>";
  	result += "</div>";
  	out.write(result);
  	out.flush();
    return;
  }

  //here we will use xpolog builder for import -
  File arch = new File(arch_file);
	try{
		String name = arch.getName();
		int index = name.lastIndexOf("/");
		int index2 = name.lastIndexOf("\\");
		if (index >= 0 && index > index2){
			name = name.substring(index + 1);
		}else if (index2 > 0){
			name = name.substring(index2 + 1);
		}
		arch = UploadHelper.putUploadFileOnServer(request,arch,XpoLogFunctionManager.FUNCTIONS_LIB_USER_PATH,name);
		XpoLogFunctionManager.getInstance().initialzeFunctionsClassLoader();
  }catch(Exception e){
    e.printStackTrace();
    	result = "<div id=\"uploadResultDivId\">";
    	result += "<b>Could not upload function jar.</b>";
    	result += "</div>";
    	out.write(result);
    	out.flush();
    
    return;
  }

%>


<div id="uploadResultDivId">
<%=result.trim()%>
</div>

