<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.LOG_VIEW_SETTINGD_PERMISSION,true)){
    return;
  }
  
  String searchAndFilterDefStr = Configuration.getInstance().getPropertiesManager().getProperty("searchAndFilterDef","START");
  boolean isSearchFromStart = false;
  if(searchAndFilterDefStr != null && searchAndFilterDefStr.equals("START")) {
	  isSearchFromStart = true;
  }
  
  //tail refresh rate
  String tailRefreshRateStr = Configuration.getInstance().getPropertiesManager().getProperty("tailRefreshRateDef","2000");
  int tailRefreshRate = Integer.parseInt(tailRefreshRateStr)/1000;
  if(tailRefreshRate <= 0) {
	  tailRefreshRate = 2;
  }
  
  //tail number of records
  String tailNumberOfRecordsStr = Configuration.getInstance().getPropertiesManager().getProperty("tailNumberOfRecrodsDef","500");
  int tailNumberOfRecords = Integer.parseInt(tailNumberOfRecordsStr);
  if(tailNumberOfRecords <= 0) {
	  tailNumberOfRecords = 500;
  }
  
/*// dealing with the installation service
String linkMessage = "";
String link = "";
boolean toShowXpoLogAsService = false;
String xpologAsService = Configuration.getInstance().getXpologAsService();
if(xpologAsService != null && xpologAsService != "" && xpologAsService.equals("uninstalledAsService") && !Configuration.isWar()) {
	toShowXpoLogAsService = true;
	linkMessage = "Install XpoLog as Service";
	link = "xpologAsServiceAction.jsp?OP=INSTALL";
}else if(xpologAsService != null && xpologAsService != "" && xpologAsService.equals("installedAsService") && !Configuration.isWar()) {
	toShowXpoLogAsService = true;
	linkMessage = "Un-Install XpoLog as Service";
	link = "xpologAsServiceAction.jsp?OP=UNINSTALL";
}*/
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>
  function doSave(){
    document.access.action="logViewSetAction.jsp";
    document.access.submit();
  }
  
  var contextreq;
function addMenu(op,id){
  if (typeof XMLHttpRequest != "undefined") {
       contextreq = new XMLHttpRequest();
   } else if (window.ActiveXObject) {
       contextreq = new ActiveXObject("Microsoft.XMLHTTP");
   }
  var url = "logContextAdminMenues.jsp?op=" + op + "&id=" + id;
   var contextSearchCol = eval("document.access.contextSearchCol0");
   for (var i = 0; contextSearchCol;){
     url = url + "&contextSearchCol" + i + "=" + contextSearchCol.value;
     url = url + "&contextSearchName" + i + "=" + escape(eval("document.access.contextSearchName" + i).value);
     url = url + "&contextSearchPath" + i + "=" + escape(eval("document.access.contextSearchPath" + i).value);
     i++;
     contextSearchCol = eval("document.access.contextSearchCol" + i);   
   }
   
   contextreq.open("POST",url, true);
   contextreq.onreadystatechange = addMenucallback;
   contextreq.send(null);
}

function addMenucallback() {
  if (contextreq.readyState == 4) {
    if (contextreq.status == 200) {
     
      var val = contextreq.responseText;
      if (!val){
        val = "";
      }     
      var td = document.getElementById("searchMenuesTD");
     
      if(td){
        td.innerHTML = val;
      }
      return;
    }
  }
}
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" name="access" id="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
  <!--    <tr>
        <td valign="top" style="border-left: 1px solid #FF9900; border-right-width: 1; border-top-width: 1; border-bottom-width: 1" height="1">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="TOPLEFTBORDER" width="33%"  height="2"></td>
            <td class="TOPBORDER" width="33%" height="2"></td>
            <td class="TOPRIGHTBORDER"  width="34%" height="2"></td>
          </tr>
        </table>
        </td>
      </tr>-->
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Log Viewer settings</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0"  width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="100%" height="18" colspan="2"><span class="HEADER">Default Log Search Settings</span></td>
                  </tr>
                   <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>                
              
                  <tr>
                        <td width="150"><span class="REGULARTEXT">Default Search</span></td>
                        <td width="*"><input type="checkbox" name="searchAndFilterDefStr" id="searchAndFilterDefStr" <%=isSearchFromStart?"checked" : ""%>><span class="SMALLTEXT">
                          When checked - a search and filter result will be presented from the beginning of the logs<br>&nbsp;&nbsp;&nbsp;&nbsp;(Note: when unchecked the result that will be presented is on current view)</span></td>
                      </tr>                 
                  <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
                  
                  </table>
                    </td>
                  </tr>
                  <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0"  width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="100%" height="18" colspan="2"><span class="HEADER">Default Tail Settings</span></td>
                  </tr>
                   <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>                
                  <tr>
                        <td width="20%"><span class="REGULARTEXT">Tail refresh rate</span></td>
                        <td width="85%"><select size="1" name="tailRefreshRateDefStr">
                            <%
                              String addch = "";
                              String vals = "";
                              for(int i=1;i<11;i++){
                                vals = String.valueOf(i);
                                addch = "";
                                if(vals.equals(String.valueOf(tailRefreshRate))){
                                  addch = "selected=true";
                                }
                            %>
                              <option <%=addch%> > <%=vals%> </option>
                            <%
                              }
                            %>
                          </select>
                          <span class="SMALLTEXT">you can set the refresh rate of tailing (in seconds)<br>&nbsp;&nbsp;&nbsp;&nbsp;(Note: when activating the tail on log viewer XpoLog is loading the new records according to the specified refresh rate)</span></td>
                      </tr>
                      <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                        <td width="20%"><span class="REGULARTEXT">Tail number of record view</span></td>
                        <td width="85%"><select size="1" name="tailNumberOfRecrodsDefStr">
                           <option <%=(String.valueOf(tailNumberOfRecords).equals("50")?"selected=true":"")%> > 50 </option>
                           <option <%=(String.valueOf(tailNumberOfRecords).equals("100")?"selected=true":"")%> > 100 </option>
                           <option <%=(String.valueOf(tailNumberOfRecords).equals("200")?"selected=true":"")%> > 200 </option>
                           <option <%=(String.valueOf(tailNumberOfRecords).equals("300")?"selected=true":"")%> > 300 </option>
                           <option <%=(String.valueOf(tailNumberOfRecords).equals("500")?"selected=true":"")%> > 500 </option>
                        </select>
                          <span class="SMALLTEXT">while tailing XpoLog will accumulate the selected number of records in log viewer<br>&nbsp;&nbsp;&nbsp;&nbsp;(Note: after the view will reach the selected number of records, XpoLog will restart the accumulation)</span></td>
                      </tr>
                                  
                  <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
                  
                  </table>
                    </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
           <tr>
                    <td><span class="HEADER">Search Context Menu</span></td>
                  </tr>  
                  
                  <tr>
                    <td id="searchMenuesTD">
                    <jsp:include page="logContextAdminMenues.jsp" flush="true"/>
                   
                  </td></tr>
                   <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="35%">&nbsp;</td>
                <td width="11%" align="center"><a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK">
                cancel</a></td>
                <td width="7%" align="center"><a href="javascript:doSave()" class="LINK">save</a></td>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>