<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.jaas.*"%>
<%@ page import="xpolog.eye.jaas.base.*"%>
<%@ page import="xpolog.eye.jaas.search.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.media.AccountPolicy"%>
<%@ page import="xpolog.eye.media.telsh.TelnetAccountPolicy"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.run.LogActionsConfiguration"%>
<%@ page import="xpolog.eye.site.TelShActivityManager"%>

<%@ page import="java.text.*"%>
<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)){
    return;
  }
  
  String ERROR_OBJ = "ERROR_OBJ";
  ErrorModel errmodel = new ErrorModel();
  
  String SMTP_HOST = "SMTPHost";
  String SMTP_PORT = "SMTPProt";
  String HTTP_PORT = "HttpPort";
  String SSL_PORT  = "SslProt";
  ServerAdmin sad = SiteManagment.getAdminInstance().getServerAdministrator();
  String httpport = String.valueOf(sad.getHttpPort());
  String sslport = String.valueOf(sad.getSslPort());

  MailConfig mail = xpolog.config.Configuration.getInstance().getMailConfigurationManager();

  String host = mail.getSmtpHost();
  String port = String.valueOf(mail.getSmtpPort());
  String sysAddress = mail.getSystemMailAddress();

  XpologSecurityManager secure = (XpologSecurityManager)xpolog.config.Configuration.getInstance().getSecurityConfigurator();
  String sestimeout = "";
  if(!Configuration.isWar()){
   sestimeout = secure.getSessionTimeout();
  }
  String issecurecheck = secure.isEnabled() ? "checked" : "";
  String issslcheck = secure.isStartSSL() ? "checked" : "";

  //external directory configuration
XpologManagment mgmt = new XpologManagment();
String configurationLocation = Configuration.XPOLOG_ROOT_PATH;
/*//Windows Service
String linkMessage = "";
String link = "";
boolean xpologAsService = false;
String xpologAsServiceStr = Configuration.getInstance().getPropertiesManager().getProperty("xpologAsService","false");
if(xpologAsServiceStr != null && xpologAsServiceStr.equals("true")) {
  xpologAsService = true;
}
if(!Configuration.isWar() && !xpologAsService) {
	linkMessage = "Install XpoLog as Service";
	link = "xpologAsServiceAction.jsp?OP=INSTALL";
}else if(!Configuration.isWar() && xpologAsService) {
	linkMessage = "Un-Install XpoLog as Service";
	link = "xpologAsServiceAction.jsp?OP=UNINSTALL";
}*/


  AuthenticatorFactory factory = XpologSecurityManager.getInstance().getAuthenticatorFactory();
  XpologAuthenticatorFactory xpologFactory = factory != null && factory instanceof XpologAuthenticatorFactory ? (XpologAuthenticatorFactory) factory : null;
  ValidatorFactory [] factories = null;
  if (xpologFactory != null){
	  factories = xpologFactory.getValidatorsFactory();
  }
  
  MultiPrincipalSearcherFactory multiSearcherFactory = null;
  PrincipalSearcherFactory searcherFactory = XpologSecurityManager.getInstance().getSearcherFactory();
  PrincipalSearcherFactory [] searcherFactories = null;
  if (searcherFactory != null && searcherFactory instanceof MultiPrincipalSearcherFactory){
  	multiSearcherFactory = (MultiPrincipalSearcherFactory)searcherFactory;
  	searcherFactories = multiSearcherFactory.getFactories();
  }
  
  //new log actions
  LogActionsConfiguration logActionsConf = LogActionsConfiguration.getInstance();
  double cpuLimit = logActionsConf.getCpuLimit();
  String runIndexing = logActionsConf.isRunIndexing() ? " checked" : "";
  String runReports = logActionsConf.isRunReports() ? " checked" : "";
  String runDashboard = logActionsConf.isRunDashboard() ? " checked" : "";
  
  // default account policies
  TelnetAccountPolicy defaultTelnetAccountPolicy = TelShActivityManager.getInstance().getDefaultTelnetAccountPolicy();
  long sshPoolTimeoutInterval = -1, sshSessionTimeoutInterval = -1;
  String sshPoolTimeoutIntervalValueType = "", sshSessionTimeoutIntervalValueType = "";
  int sshMaxConnections = -1, sshMaxSessionsPerConnection = -1;
  if(defaultTelnetAccountPolicy != null) {
  	sshPoolTimeoutInterval = defaultTelnetAccountPolicy.getPoolTimeoutInterval();
  	sshPoolTimeoutIntervalValueType = defaultTelnetAccountPolicy.getPoolTimeoutIntervalValueType();
  	if(sshPoolTimeoutIntervalValueType.equals("min")) {
  		sshPoolTimeoutInterval = sshPoolTimeoutInterval / 1000 / 60;
  	}else if(sshPoolTimeoutIntervalValueType.equals("hour")) {
  		sshPoolTimeoutInterval = sshPoolTimeoutInterval / 1000 / 60 / 60;
  	}
  	sshSessionTimeoutInterval = defaultTelnetAccountPolicy.getSessionTimeoutInterval();
  	sshSessionTimeoutIntervalValueType = defaultTelnetAccountPolicy.getSessionTimeoutIntervalValueType();
  	if(sshSessionTimeoutInterval != -1) {
	  	if(sshSessionTimeoutIntervalValueType.equals("min")) {
	  		sshSessionTimeoutInterval = sshSessionTimeoutInterval / 1000 / 60;
	  	}else if(sshSessionTimeoutIntervalValueType.equals("hour")) {
	  		sshSessionTimeoutInterval = sshSessionTimeoutInterval / 1000 / 60 / 60;
	  	}
  	}
  	sshMaxConnections = defaultTelnetAccountPolicy.getMaxConnections();
  	sshMaxSessionsPerConnection = defaultTelnetAccountPolicy.getMaxSessionsPerConnection();
  }
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>
<script>
  var onSave = false;
  function saveSettings(){
    onSave = true;
    if (document.access.selectedValidatorMembersList){
      for(var j=0;j<document.access.selectedValidatorMembersList.options.length;j++){
        document.access.selectedValidatorMembersList.options[j].selected = true;
      }
    }
    updateAdvanceSettingsSelection();
    document.access.action="mailsetaction.jsp";
    document.access.submit();
  }
  



function doValidatorMembersAdd(){
  if(document.access.availableValidatorMembersList.selectedIndex == -1){
    return;
  }
  for(var j=0;j<document.access.availableValidatorMembersList.options.length;j++){
    if (document.access.availableValidatorMembersList.options[j].selected){
      var name = document.access.availableValidatorMembersList.options[j].text;

      var value = document.access.availableValidatorMembersList.options[j].value;
      var found = false;
      for(var i=0;i<document.access.selectedValidatorMembersList.options.length;i++){
        if(document.access.selectedValidatorMembersList.options[i].value == value){
          found = true;
          break;
        }
      }
      if (!found){
        var option0 = new Option(name,value);
        document.access.selectedValidatorMembersList.options[document.access.selectedValidatorMembersList.options.length] = option0;
        document.access.selectedValidatorMembersList.selectedIndex = document.access.selectedValidatorMembersList.options.length - 1;
        showDetails(document.access.selectedValidatorMembersList);
      }
    }
  }
}

function doValidatorMembersRemove(){
  if(document.access.selectedValidatorMembersList.selectedIndex == -1){
    return;
  }

  for(var i= document.access.selectedValidatorMembersList.options.length;--i >= 0;){
    if(document.access.selectedValidatorMembersList.options[i].selected && !(document.access.selectedValidatorMembersList.options[i].name == "administrators")){
       document.access.selectedValidatorMembersList.options[i] = null;       
    }    
  }
  if (document.access.selectedValidatorMembersList.options.length > 0){
    document.access.selectedValidatorMembersList.selectedIndex = 0;    
  }
  showDetails(document.access.selectedValidatorMembersList);
  showDesc(document.access.selectedValidatorMembersList);
}

function AuthType(id,name,desc,url){
  this.id = id;
  this.name = name;
  this.desc = desc;
  this.url = url;
}

var authTypesList = new Array();
<%
  if (factories != null){  
  for (int i = 0; i < factories.length; i++) {
	  String id = factories[i].getId();
	  String desc = factories[i].getDesc();
	  String name = factories[i].getName();
	  if (desc == null) desc = "";
	  
	  String settingsUrl = "";
	  if (factories[i] instanceof XpologValidatorFactory){
	  	XpologValidatorFactory xpologValidator  = (XpologValidatorFactory)factories[i];
	  	settingsUrl = xpologValidator.getSettingsUrl();
	  	if (settingsUrl == null){
	  		settingsUrl = "";
	  	}
	  }
%>
authTypesList[authTypesList.length] = new AuthType('<%=id%>','<%=name%>','<%=desc%>','<%=settingsUrl%>');
<%}}%>

function showDetails(combo){
      
  if (onSave) return;
  if (combo.selectedIndex == -1){
    showDetailsByType();
    return;
  }
  
  var item = combo.options[combo.selectedIndex];
  if (!item) return;
  
  for (var i = 0; i < authTypesList.length;i++){
    if (authTypesList[i].id == item.value){
      showDetailsByType(authTypesList[i]);
      break;
    }
  }
  
}

function showDetailsByType(authType){
 
  var detailsLink = document.getElementById("detailsLink");
  if (!detailsLink) return;
  
  if (authType && authType.url != ""){
		detailsLink.disabled = false;
		detailsLink.target = "_new";
		detailsLink.href = "<%=BASE_DIRECTORY%>" + authType.url;
		detailsLink.className = "SMALLLINK";
		detailsLink.style.cursor="pointer";
  }else {
    detailsLink.disabled = true;
    detailsLink.target = "";
    detailsLink.href = "javascript:void(0);"
    detailsLink.className = "HOMEPATHLINK";
    detailsLink.style.cursor="none";
  }
  
  if (authType){
    detailsLink.innerHTML = "<nobr>" + authType.name + "</nobr><br>Configuration";
  }else {
    detailsLink.innerHTML = "Configuration";    
  }
}

function showDesc(combo){
  if (onSave) return;
  if (combo.selectedIndex == -1){
    showDescByType();
    return;
  }
  
  var item = combo.options[combo.selectedIndex];
  if (!item) return;
  
  for (var i = 0; i < authTypesList.length;i++){
    if (authTypesList[i].id == item.value){
      showDescByType(authTypesList[i]);
      break;
    }
  }
}

function showDescByType(authType){
  
  var authDesc = document.getElementById("authDesc");
  if (!authDesc) return;
  if (authType && authType.desc != ""){		
    authDesc.innerHTML = "<b>" + authType.name + "</b>: " +  authType.desc;
  }else {
    authDesc.innerHTML = "&nbsp;";
  }
}





function doSearcherMembersAdd(){
  if(document.access.availableSearcherMembersList.selectedIndex == -1){
    return;
  }
  for(var j=0;j<document.access.availableSearcherMembersList.options.length;j++){
    if (document.access.availableSearcherMembersList.options[j].selected){
      var name = document.access.availableSearcherMembersList.options[j].text;

      var value = document.access.availableSearcherMembersList.options[j].value;
      var found = false;
      for(var i=0;i<document.access.selectedSearcherMembersList.options.length;i++){
        if(document.access.selectedSearcherMembersList.options[i].value == value){
          found = true;
          break;
        }
      }
      if (!found){
        var option0 = new Option(name,value);
        document.access.selectedSearcherMembersList.options[document.access.selectedSearcherMembersList.options.length] = option0;
        document.access.selectedSearcherMembersList.selectedIndex = document.access.selectedSearcherMembersList.options.length - 1;
        showSearcherDetails(document.access.selectedSearcherMembersList);
      }
    }
  }
}

function doSearcherMembersRemove(){
  if(document.access.selectedSearcherMembersList.selectedIndex == -1){
    return;
  }

  for(var i= document.access.selectedSearcherMembersList.options.length;--i >= 0;){
    if(document.access.selectedSearcherMembersList.options[i].selected){
       document.access.selectedSearcherMembersList.options[i] = null;       
    }    
  }
  if (document.access.selectedSearcherMembersList.options.length > 0){
    document.access.selectedSearcherMembersList.selectedIndex = 0;    
  }
  showSearcherDetails(document.access.selectedSearcherMembersList);
  showSearcherDesc(document.access.selectedSearcherMembersList);
}

function SearcherType(id,name,desc,url){
  this.id = id;
  this.name = name;
  this.desc = desc;
  this.url = url;
}

var searcherTypesList = new Array();
<%
  if (searcherFactories != null){  
  for (int i = 0; i < searcherFactories.length; i++) {
	  String id = searcherFactories[i].getId();
	  String desc = searcherFactories[i].getDesc();
	  String name = searcherFactories[i].getName();
	  if (desc == null) desc = "";
	  
	  String settingsUrl = "";
	  if (searcherFactories[i] instanceof XpologPrincipalSearcherFactory){
	  	XpologPrincipalSearcherFactory xpologSearcherr  = (XpologPrincipalSearcherFactory)searcherFactories[i];
	  	settingsUrl = xpologSearcherr.getSettingsUrl();
	  	if (settingsUrl == null){
	  		settingsUrl = "";
	  	}
	  }
%>
searcherTypesList[searcherTypesList.length] = new AuthType('<%=id%>','<%=name%>','<%=desc%>','<%=settingsUrl%>');
<%}}%>

function showSearcherDetails(combo){
      
  if (onSave) return;
  if (combo.selectedIndex == -1){
    showSearcherDetailsByType();
    return;
  }
  
  var item = combo.options[combo.selectedIndex];
  if (!item) return;
  
  for (var i = 0; i < searcherTypesList.length;i++){
    if (searcherTypesList[i].id == item.value){
      showSearcherDetailsByType(searcherTypesList[i]);
      break;
    }
  }
  
}

function showSearcherDetailsByType(searcherType){
 
  var detailsLink = document.getElementById("detailsSearcherLink");
  if (!detailsLink) return;
  
  if (searcherType && searcherType.url != ""){
		detailsLink.disabled = false;
		detailsLink.target = "_new";
		detailsLink.href = "<%=BASE_DIRECTORY%>" + searcherType.url;
		detailsLink.className = "SMALLLINK";
		detailsLink.style.cursor="pointer";
  }else {
    detailsLink.disabled = true;
    detailsLink.target = "";
    detailsLink.href = "javascript:void(0);"
    detailsLink.className = "HOMEPATHLINK";
    detailsLink.style.cursor="none";
  }
  
  if (searcherType){
    detailsLink.innerHTML = "<nobr>" + searcherType.name + "</nobr><br>Configuration";
  }else {
    detailsLink.innerHTML = "Configuration";    
  }
}

function showSearcherDesc(combo){
  if (onSave) return;
  if (combo.selectedIndex == -1){
    showSearcherDescByType();
    return;
  }
  
  var item = combo.options[combo.selectedIndex];
  if (!item) return;
  
  for (var i = 0; i < searcherTypesList.length;i++){
    if (searcherTypesList[i].id == item.value){
      showSearcherDescByType(searcherTypesList[i]);
      break;
    }
  }
}

function showSearcherDescByType(searcherType){
  
  var searcherDesc = document.getElementById("searcherDesc");
  if (!searcherDesc) return;
  if (searcherType && searcherType.desc != ""){		
    searcherDesc.innerHTML = "<b>" + searcherType.name + "</b>: " +  searcherType.desc;
  }else {
    searcherDesc.innerHTML = "&nbsp;";
  }
}

function init(){
		initTabs();
  <%
  if (factories != null){  
  	%>
  	showDetails(document.access.selectedValidatorMembersList);
  	showDesc(document.access.selectedValidatorMembersList);
  <%}%>
  
  <%
  //if (searcherFactories != null){  
  	%>
  	//showSearcherDetails(document.access.selectedSearcherMembersList);
  	//showSearcherDesc(document.access.selectedSearcherMembersList);
  <%//}%>
  externalConfigurationChecked(true);
}

function externalConfigurationChecked(onLoad){
		if(<%=(configurationLocation!=null && configurationLocation.length()>0) && Configuration.isExternalConf()%> && onLoad) {        	
        	document.access.externalConfiguration.checked = "checked";
        	document.access.externalConfigurationPath.disabled=false;        	        	        	
        	return;
        }
        if(document.access.externalConfiguration.checked) {       	        
        	document.access.externalConfigurationPath.disabled=false;
        	document.access.externalConfigurationPath.value='';
        	//document.access.isRunnerNode.disabled = false;
        }else {
	        document.access.externalConfigurationPath.value='---check the use external configuration to set the path---';
        	document.access.externalConfigurationPath.disabled=true;
        	//document.access.isRunnerNode.disabled = true;
        }
}

function updateAdvanceSettingsSelection(){
//Api policy selection
	if(document.access.apiPolicy){
	  for (var i = 0; i < document.access.apiPolicy.length;i++){
	    if (document.access.apiPolicy[i].checked == true){
	      document.access.apiPolicySelection.value = document.access.apiPolicy[i].value;
	      break;
	    }
	  }
	}
}

function showHideUploadFunctionLink(){
    updateVerifyUploadMsgDiv("");
		showGeneralAdminDiv("uploadFunction");
}

function hideUploadFunction(){  	
  hideGeneralAdminDiv("uploadFunction");  
}

function goUploadFunction(){
		updateVerifyUploadMsgDiv("Uploading...");		
		var uploadFormElem = document.getElementById("fileUploadForm");
		var file = uploadFormElem.archivePath.value;
		var path = "<%=BASE_DIRECTORY%>settings/general/uploadFunctionAction.jsp?ARCHIVE_PATH=" + file;
	 	uploadFormElem.action = path;
		uploadFormElem.submit();
}

function initUploadFunctionForm(){
	var uploadDriverElem = document.getElementById("adminGeneralDivuploadFunction");
	if(uploadDriverElem && uploadDriverElem.style.display == ""){
			var uploadFormElem = document.getElementById("fileUploadForm");
			var iframe = document.getElementById("uploadFunctionTargetIFrame") ;
			var iframeDoc = null;
			if (iframe.contentDocument) {
				iframeDoc = iframe.contentDocument;
			}
			else if (iframe.contentWindow) {
				iframeDoc = iframe.contentWindow.document;
			}
			else if (window.frames[iframe.name]) {
				iframeDoc = window.frames[iframe.name].document;
			}
			if (iframeDoc) {
				var resultElem = iframeDoc.getElementById("uploadResultDivId");
				if(resultElem){
					var result = resultElem.innerHTML;
					result = result.replace(/^\s+|\s+$/g, '') ;
					if(result == "OK"){		
							hideUploadFunction();
							showMessage("XpoLog Center Suite","Finished uploading successfully",300,100);				
					}else{
						updateVerifyUploadMsgDiv(result);		
					}
				}
			}
		}
}

function updateVerifyUploadMsgDiv(msg){
	var msgElem = document.getElementById("verifyUploadMsgDiv");
	if(msgElem){
		msgElem.style.display = "";
		handleInnerHTML(msgElem, msg, 1);
	}
}

function showMessage(title,msg,width,height){
	var msgWriter = new messageWriter("popupMessageDiv",title,"<%=BASE_DIRECTORY%>");  
  msgWriter.width = width;
  msgWriter.height = height;
  msgWriter.addAction("OK","javascript:hideLayer('popupMessageDiv')");
  msgWriter.showMessage(msg);
}
</script>
</head>



<jsp:include page="../widgets/tabs/jsp/tabsHeaderIncluder.jsp" flush="true">
  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<body onLoad="init()" style="margin:0;padding:0;">
 <jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
			<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
			<jsp:param name="title" value="Upload Report Function JAR"/> 
			<jsp:param name="suffix" value="uploadFunction"/>
			<jsp:param name="includePath" value="settings/general/uploadFunctionInnerDiv.jsp"/> 
			<jsp:param name="width" value="500px"/> 
			<jsp:param name="height" value="150px"/> 
			<jsp:param name="zIndex" value="500"/>
			<jsp:param name="actionsNames" value="Upload#Cancel"/> 
			<jsp:param name="actions" value="javascript:goUploadFunction()#javascript:hideUploadFunction()"/> 
			</jsp:include>
<form AUTOCOMPLETE="OFF" id="access" name="access" style="margin:0;padding:0;" method="POST">
<input type="hidden" id="apiPolicySelection" name="apiPolicySelection" value="">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr height="1">
		<td>
			<jsp:include page="../common/pageHeader.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="General Settings" />
			</jsp:include>											
		</td>
	</tr>
	<tr>
		<td width="100%" height="100%" valign="top">
		<table class="ADMIN_TABLE_DIV" border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="margin:0;padding:0;">
			<tr>
				<td class="ADMIN_MAIN_TD" valign="top" height="100%">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">																
					<tr height="1">
						<td>&nbsp;</td>
					</tr>											
					<tr style="background-color:#A4A4A4">
						<td style="padding:8">
							<div id="tabbarDiv" style="width:100%;height:100%;"></div>
							<div id="generalDiv" style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr><td style="padding:10">
								<jsp:include page="general/settingsGeneral.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<div id="securityDiv" style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr><td style="padding:10">
								<jsp:include page="general/settingsSecurity.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>							
							<div id="mailDiv" style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr><td style="padding:10">
								<jsp:include page="general/settingsMail.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>		
							<div id="newLogDiv" style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr><td style="padding:10">
								<jsp:include page="general/settingsNewLog.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>		
							<div id="accountsPolicyDiv" style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr><td style="padding:10">
								<jsp:include page="general/settingsAccountsPolicy.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>		
							<div id="advanceDiv" style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr><td style="padding:10">
								<jsp:include page="general/settingsAdvance.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>		
							<jsp:include page="../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								<jsp:param name="id.1" value="generalDiv" />
								<jsp:param name="name.1" value="General" />
								<jsp:param name="id.2" value="securityDiv" />
								<jsp:param name="name.2" value="Security" />
								<jsp:param name="id.3" value="mailDiv" />
								<jsp:param name="name.3" value="Mail" />
								<jsp:param name="id.4" value="newLogDiv" />
								<jsp:param name="name.4" value="Log Settings" />
								<jsp:param name="id.5" value="accountsPolicyDiv" />
								<jsp:param name="name.5" value="Connection Policies" />
								<jsp:param name="id.6" value="advanceDiv" />
								<jsp:param name="name.6" value="Advanced" />
							</jsp:include>																		
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
	<tr>
		<td style="padding-top:20">
			<jsp:include page="../common/buttonsFooter.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="Save#Cancel" />
				<jsp:param name="actions" value="javascript:saveSettings()#common/actions/cancelAction.jsp" />
			</jsp:include>											
		</td>
	</tr>
</table>

<div id="messageDiv" style="position:absolute;width:300;height:120;display:none;z-index=110">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
	<tr height="20">
		<td align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
				<span class="PROGRESSTEXT" id="messageTitle"></span>
		</td>
	</tr>
	<tr height="*" style="padding:5">
		<td class="PROGRESSTEXT" id="messageText" align="center" style="padding-left:10;padding-right:10">	 
		</td>
	</tr>											
	<tr height="10">
		<td align="center" style="padding:5"><nobr>
			<a class="PROGRESSLINK" href="javascript:hideMessageDiv()"> close </a>
			</nobr>		  							
		</td>
	</tr>
</table>
</div>
</form>
</body>