<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.controllers.setup.*"%>
<%@ page import="xpolog.eye.site.controllers.*"%>
<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../";

%>
<%
  

  String CURRENT_MODULE = "CURRENT_MODULE";
  String ERROR_OBJ = "ERROR_OBJ";  

  SiteManagment mgmt = SiteManagment.getInstance();

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  UserSecurity user = manager.getUserSecurity(request);
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  
  SiteWizardController control = env.getSiteWizardController();
  String imagePath = null;
  if (control != null){
  	ControllerItem item = control.getCurrentItem();
  	if (item != null){
  		UIControllerItem uiItem = item.getUiItem();
  		imagePath = uiItem == null ? null : uiItem.getProp().getProperty("imagePath");  	
  		if (imagePath != null && imagePath.length() == 0){
  			imagePath = null;
  		}
  	}
  }
  

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>

</head>

<body>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">  
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
              <%if(imagePath != null){%>
              <img src="<%=BASE_DIRECTORY + imagePath%>">
              <%} else { %>
                No Image was found.
              <%} %>
            </td>
          </tr>
          
          <tr>
            <td width="100%" height="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">           
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="50%" align="right">
                    <%if(control != null && !control.isStart()){ %>
                    <a href="<%=BASE_DIRECTORY%>common/actions/prevAction.jsp" class="LINK"><img title="go prev" border="0" src="<%=BASE_DIRECTORY%>images/controllers/prev.gif"></a>&nbsp;&nbsp;&nbsp;&nbsp;
                    <%}%>
                    </td><td width="50%" align="left">
                    <a href="<%=BASE_DIRECTORY%>common/actions/nextAction.jsp" class="LINK"><img title="go next" border="0" src="<%=BASE_DIRECTORY%>images/controllers/next.gif"></a>
                    </td>                                        
                  </tr>
                </table>             
            </td>
          </tr>
        </table>
        </td>
      </tr>      
    </table>
    </td>
  </tr>
</table>
</body>

</html>