<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.menu.*"%>
<%@ page import="xpolog.eye.site.controllers.setup.*"%>
<%@ page import="xpolog.eye.site.controllers.*"%>
<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../";

String getTreeDiv(MenuGroup node,UserSecurity user){
  ArrayList list = new ArrayList();
  StringBuffer buffer = new StringBuffer();
  
  if (node != null){
    boolean selected = true;
    String treeKey = "node" + node.id + "_0";
    String chkKey = "root";
    buffer.append("\nvar " + treeKey + " = tree.addNode(tree.root,\"" + chkKey + "\",\"" + node.id + "\",\"" + node.name + "\",\"\",''," + selected + ",true);");
    int numberOfItems = node.getNumberOfMenuItems();
    boolean autoSelect = (numberOfItems == 1);
    addChildsNodeDiv(node,buffer,treeKey,user,autoSelect);
  }
  return buffer.toString();
}

void addChildsNodeDiv(MenuGroup node,StringBuffer buffer, String parentKey,UserSecurity user, boolean autoSelect){	
	List children = node.items;
	String type = null;
  for (int i = 0; i < children.size(); i++) {
    MenuItem child = (MenuItem)children.get(i);
   
   String key = child.id;
    String treeKey = parentKey + "_" + i;
    String parentNode = parentKey.equals("node") ? "tree.root" : parentKey;
    
    String extraText = "";
    
    boolean selected = autoSelect;
    String chkKey = "item";
    if(child.getType().equals("MenuGroup")){
      chkKey = "groups";
    } 
    
    buffer.append("\nvar " + treeKey + " = tree.addNode(" + parentNode + ",\"" + chkKey +"\",\"" + child.id + "\",\"" + child.name + "\",\"\",'" + extraText + "'," + selected + ","+autoSelect+");");
    if (child.getType().equals("MenuGroup")){
      addChildsNodeDiv((MenuGroup)child,buffer,treeKey,user,autoSelect);
    }

  }
}

%>
<%
  

  String CURRENT_MODULE = "CURRENT_MODULE";
  String ERROR_OBJ = "ERROR_OBJ";  

  SiteManagment mgmt = SiteManagment.getInstance();

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  UserSecurity user = manager.getUserSecurity(request);
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  
  SiteWizardController control = env.getSiteWizardController();
  MenuGroup rootMenu = null;
  if (control != null){
  	ControllerItem item = control.getCurrentItem();
  	if (item != null){
  		UIControllerItem uiItem = item.getUiItem();
  		String filePath = uiItem == null ? null : uiItem.getProp().getProperty("logsDefinitionPath");  	
  		if (filePath != null && filePath.length() > 0){
  			rootMenu = SetupPagesHelper.loadLogsDefinitionMemebers(filePath,user);
  		}
  	}
  }
  
  Module pmod = (Module)request.getSession().getAttribute(CURRENT_MODULE);
  
  String treeCode = rootMenu == null ? "" : getTreeDiv(rootMenu,user);


%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script  src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script>
baseDirectory = "<%=BASE_DIRECTORY%>";

 function markSelectionTreeNode(node){
	nodeCbx = document.getElementById("CheckBox_" + node.tree.name + "_" + node.index);
	if (!nodeCbx) return;
	if (node.selected == nodeCbx.checked) return;
	
	var selected = nodeCbx.checked;	
  if (this.onSelectMarkChilds){
    markNodeChilds(node,selected);  
  }else {
    node.selected = selected;
  }
  
  if (this.onSelectMarkParents  && selected){
    markNodeParentsToRoot(node.parent,selected);  
  }
}

function writeMyNodeData(node){ 
  if (node.id == "root") return;
  if (!node.isLeaf()){
    var img = baseDirectory + (node.expand ? collapseImage : expandImage);  
    document.writeln("<img src=\"" + img + "\" onClick=\"javascript:selectNode(" + node.index + ")\" id=\"ExpandImage_" + this.name + "_" + node.index + "\"  class=\"" + node.tree.nodeImageStyle + "\">");
  }
  if (node.isLeaf()){
    document.writeln("<input type=\"radio\" name=\"" + node.chkKey + "\" value=\""+node.id +"\" id=\"CheckBox_" + this.name + "_" + node.index + "\"" + (node.selected ? " checked" : "") +  " onClick=\"javascript:markNode(" + node.index + ")\"" + (node.disable ? " disabled" : "") + ">");
  }
  document.writeln("&nbsp;" + node.name);
  if (node.desc && node.desc != ""){
     document.writeln("&nbsp;(" + node.desc + ")");
  }
  if (node.text && node.text != ""){
     document.writeln("&nbsp;" + node.text);
  }  
}

Tree.prototype.markTreeNode = markSelectionTreeNode;
Tree.prototype.writeNodeData = writeMyNodeData;
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" action="setupLogsDefAction.jsp" method="POST">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">  
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Logs Definition</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">                  
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td><span class="HEADER">Logs Selection</span></td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                 <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr>
                        <td>
                        <script>
                         <%=treeCode%>
                         tree.writeTree();
                        </script>
                         </td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <span class="ERRORMESSAGE">
            	Note: The wizard enables you to easily define logs is your system. If your license limits the number
            	of logs that can be defined, the wizard will not add new log definitions once this number has been reached.<br>
            <span>
            </td>
          </tr>
          <tr>
            <td width="100%" height="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">           
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="35%">&nbsp;</td>
                    <td width="11%" align="center"><a href="javascript:document.access.submit()" class="LINK">
                    next</a></td>                    
                    <td width="*">&nbsp;</td>
                  </tr>
                </table>             
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>