<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.menu.*"%>
<%@ page import="xpolog.eye.site.controllers.setup.*"%>
<%@ page import="xpolog.eye.site.controllers.*"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)){
    return;
  }

  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);

  String ERROR_OBJ = "ERROR_OBJ";
  String START_SSL = "startSSL";

  ErrorModel err = new ErrorModel();

  String [] logsArr = request.getParameterValues("item");
  String nodeId = null;
  if (logsArr != null && logsArr.length > 0){
  	nodeId = logsArr[0];
  }else {
    err.addError("No log was defined.");
  }
  
  MenuItem menuItem = null;
  if (nodeId != null && nodeId.length() > 0){ 
    SiteWizardController control = env.getSiteWizardController();
    MenuGroup rootMenu = null;
    if (control != null){
  	  ControllerItem item = control.getCurrentItem();
  	  if (item != null){
  		  UIControllerItem uiItem = item.getUiItem();
  		  String filePath = uiItem == null ? null : uiItem.getProp().getProperty("logsDefinitionPath");  	
  		  if (filePath != null && filePath.length() > 0){
  			  rootMenu = SetupPagesHelper.loadLogsDefinitionMemebers(filePath,user);
  		  }
  	  }
    }
    if (rootMenu != null){
    	menuItem = rootMenu.getMenuItemById(nodeId);
    }
    
    if (menuItem == null){
    	err.addError("No log was found.");
    }
  }
 
  if(err.getErrorCount() > 0){
    request.getSession().setAttribute(ERROR_OBJ,err);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }
  String link = menuItem.link;
  
  response.sendRedirect(BASE_DIRECTORY + link);
%>
