<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.site.controllers.*"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)){
    return;
  }

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  SiteWizardController control = env.getSiteWizardController();

  String ERROR_OBJ = "ERROR_OBJ";
  String START_SSL = "startSSL";

  ErrorModel err = new ErrorModel();

  String modname = request.getParameter("moduleName");
  String modparent = request.getParameter("parentModule");
  
  if(modparent == null || modparent.trim().equals("")){
    err.addError("No parent folder was selected. If no folder is available please check your permissions");    
    return;
  }

  Module parent = modparent == null || modparent.trim().equals("")? null : mgmt.getModuleFromId(modparent);
  
  if(parent == null){
    err.addError("No parent folder was selected. If no folder is available please check your permissions");    
    return;
  }

  if (modname != null && xpolog.eye.util.WebUtil.isContainSpecialCharecter(modname)){
  	err.addError("The following charecters are prohibited in the name field: " +xpolog.eye.util.WebUtil.getSpecialCharectersList());
  }
  if(err.getErrorCount() > 0){
    request.getSession().setAttribute(ERROR_OBJ,err);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }
  
  Module currMod = null;
  if (modname == null || modname.length() == 0){
  	currMod = parent;
  }else {
  	currMod = new Module();
  	currMod.setName(modname);
  	admin.addModule(currMod,parent);
  }
  request.getSession().setAttribute("CURRENT_MODULE",currMod);
  if (control != null){
    control.getAttributes().put("rootModuleFirstVisit","false");
  }
  
  response.sendRedirect(BASE_DIRECTORY + "common/actions/nextAction.jsp");
%>
