<%@ page language="java" %> 

<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.snapshot.Snapshot"%>
<%@page import="xpolog.eye.snapshot.SnapshotManager"%>
<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
		UserContext userContext = UserEnvironment.getUserContext(request);
		SnapshotManager smgr = SnapshotManager.getInstance();
		String id = request.getParameter("snapshotId");
		if(id == null || smgr.getSnapshot(id) == null){
			out.write("error");
			out.flush();
			return;							
		}else{
			//Snapshots lock check
			String errorMsg = "";
			if(smgr.isSnapshotLocked(id,userContext)){
				errorMsg = "This snapshot is currently used by another user and cannot be edit";
				out.write(errorMsg);
				out.flush();
				return;						
			}else{
				smgr.updateActiveSnapshotInfo(id,userContext);
				Snapshot snap = smgr.getSnapshot(id);
				String name = request.getParameter("snapshotName");
				
				if(name == null || name.length() == 0){
					errorMsg = "Please enter snapshot name";
				}else{
					String oldName = snap.getName();
					if(!oldName.equals(name) && smgr.isSnapshotNameExist(name)){
						errorMsg = "Snapshot name alredy exists";
					}
				}
				if(errorMsg != null && errorMsg.length() > 0){
					out.write(errorMsg);
					out.flush();
					return;											
				}else{
					String description = request.getParameter("snapshotDescription");
					if(description == null || description.length() == 0){
						description = snap.getDescription();
					}
					smgr.updateSnapshot(snap,name,description,userContext);
					out.write("ok");
					out.flush();
					return;	
				}
			}
		}	
%>