<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.logview.LogViewQueryInfo"%>
<%@ page language="java" %> 

<%@page import="xpolog.eye.data.source.DataReference"%>
<%@page import="xpolog.eye.data.log.LogRecord"%>
<%@page import="java.util.Iterator"%>
<%@page import="java.util.Collections"%>
<%@page import="java.util.LinkedList"%>
<%@page import="java.util.List"%>
<%@page import="xpolog.eye.data.Record"%>
<%@page import="xpolog.eye.data.RecordsMaskTableModel"%>
<%@page import="xpolog.eye.logview.LogViewContext"%>
<%@page import="xpolog.eye.LogBrowsingManager"%>
<%@page import="xpolog.eye.snapshot.Snapshot"%>
<%@page import="xpolog.eye.snapshot.SnapshotManager"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
		LogViewContext logcontext = (LogViewContext)request.getSession().getAttribute(LogViewContext.LOG_CONTEXT);
		UserContext userContext = UserEnvironment.getUserContext(request);
		LogBrowsingManager lbm = logcontext == null ? null : logcontext.lbm;
		Snapshot snapshot = null;
		String errorMsg = "";
		boolean doLocked = false;
	    LogViewQueryInfo queryInfo = logcontext == null ? null : logcontext.query;
		SnapshotManager smgr = SnapshotManager.getInstance();
		String id = logcontext.snapshotID;
		if(id != null && id.length() > 0){
			if(smgr.isSnapshotLocked(id,userContext)){
				errorMsg = "You can't remove event(s) from the snapshot<br>The snapshot is currently used by another user";
			}else{
				doLocked = !smgr.isLockedByMe(id,userContext);
				smgr.updateActiveSnapshotInfo(id,userContext);
			}
		}

		//Getting the selected indexes list
		String selectedRowIndexStr = request.getParameter("selectedRowIndexArr");
		String[] selectedRowIndexArr = selectedRowIndexStr == null ? null : selectedRowIndexStr.split("#");
		List selectedRowIndexes = new LinkedList();
		for(int i = 0 ; selectedRowIndexArr != null && i < selectedRowIndexArr.length ; i++){
			int rowIndx = -1;
			try{
					rowIndx = Integer.parseInt(selectedRowIndexArr[i]);
					selectedRowIndexes.add(new Integer(rowIndx));
			}catch(Exception e){
				rowIndx = -1;
			}			
		}
		Collections.sort(selectedRowIndexes);
		if(selectedRowIndexes.isEmpty()){
			errorMsg = "Please select event(s) to remove";
		}
		
		//Getting the dataRefs array from selected indexes.
	  List recRefList = new LinkedList();
	  Record rec = null;
		if(lbm == null ){
			errorMsg = "Action denied";
		}else if(errorMsg.length() == 0){
			Iterator it = selectedRowIndexes.iterator();
		  RecordsMaskTableModel RMModel = lbm.getLogEyeModel() == null ? null : lbm.getLogEyeModel().getRecordsMaskTableModel() ; 
		  if(RMModel != null){
				while(it.hasNext()){
					Integer selectedRowIndx = (Integer)it.next();
			  	rec = RMModel.getRecordAt(selectedRowIndx.intValue());
			  	if(rec != null && rec instanceof LogRecord){
			  		LogRecord logRecord = (LogRecord)rec;
			  		recRefList.add(logRecord.getDataReference());
			  	}else{
			  		errorMsg = "Problem to get data for log " + lbm.getName();
			  	}
				}
		  }
		  if(errorMsg.length() == 0 && recRefList.size() > 0){
				if(id != null && id.length() > 0){
					try{
						snapshot = smgr.getSnapshot(id);
						DataReference [] refs = (DataReference[])recRefList.toArray(new DataReference[recRefList.size()]);
						snapshot.removeFromSnapshot(refs);
						
						 //For update model while loading logrecords.jsp.
						queryInfo.isUsed = false;
					}catch(Exception e){
						errorMsg = "Problem removing event(s) from snapshot";
					}
				}
		  }
		}
		if(doLocked){
			smgr.removeSnapshotFromMap(id,userContext);
		}
	
		out.write(errorMsg.length() > 0 ? "error#" + errorMsg : "ok");
		out.flush();
		return;

%>