<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.error.ErrorModel"%>
<%@page import="xpolog.eye.LogBrowsingManager"%>
<%@page import="xpolog.eye.snapshot.SnapshotManager"%>
<%@page import="xpolog.eye.snapshot.Snapshot"%>
<%@ page language="java" %> 

<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
	String ERROR_OBJ = "ERROR_OBJ";
	String CURRENT_LOG = "CURRENT_LOG";
	String SNAPSHOT_ID = "SNAPSHOT_ID";
	String ACTIVE_SNAPSHOT_ID = "ACTIVE_SNAPSHOT_ID";

	UserContext userContext = UserEnvironment.getUserContext(request);
	ErrorModel errmodel = new ErrorModel();
	Snapshot snapshot = null;
	SnapshotManager smgr = SnapshotManager.getInstance();
	String allowViewStr = request.getParameter("allowView");
	boolean allowView = allowViewStr != null && allowViewStr.equals("true");
	
	LogBrowsingManager lbm = null;
	String snapshotId = request.getParameter(SNAPSHOT_ID);
	String activeSnapshotId = (String)request.getSession().getAttribute(ACTIVE_SNAPSHOT_ID);
	if(activeSnapshotId != null && activeSnapshotId.length() > 0 && !activeSnapshotId.equalsIgnoreCase(snapshotId)){
		Snapshot oldSnapshot = smgr.getSnapshot(activeSnapshotId);				
		if(oldSnapshot != null){
			smgr.removeSnapshotFromMap(oldSnapshot.getId(),userContext);
			oldSnapshot.dispose();
		}		
	}

	
	if (snapshotId != null && snapshotId.length() > 0) {
	  request.getSession().setAttribute(ACTIVE_SNAPSHOT_ID,snapshotId);
		snapshot = SnapshotManager.getInstance().getSnapshot(snapshotId);
		if(snapshot != null){
			snapshot.setUserContext(userContext);
			snapshot.setOverridePermissions(allowView);
			lbm = snapshot.getLogView();
		}
	}

	
/*	//Snapshots lock check
	SnapshotManager snapMgr = SnapshotManager.getInstance();
	if(!snapMgr.isSnapshotLocked(snapshotId,userContext)){
		snapMgr.updateActiveSnapshotInfo(snapshotId,userContext);
	}
*/
	if(errmodel != null && errmodel.getErrorCount() > 0){
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY+"common/errorpage.jsp");
	    return;
	}

	if(lbm != null ){
		lbm.setSnapshot(true);
		request.getSession().setAttribute(CURRENT_LOG,lbm);
		request.getSession().setAttribute("logid",lbm.getId()); 
		response.sendRedirect(BASE_DIRECTORY + "/loggers/logview.jsp?opdirect=START&gotoMain=true&counter=-1&allowView="+allowView);		
	}else{
		String msg = (snapshot != null && snapshot.getViewErrorMsg().length() > 0 ) ? 
									snapshot.getViewErrorMsg() : "Problem loading snapshot's view.";			
	  errmodel.addError(msg);
	  request.getSession().setAttribute(ERROR_OBJ,errmodel);
	  response.sendRedirect(BASE_DIRECTORY+"common/errorpage.jsp");
    return;

	}
%>
