<%@ page language="java"%>

<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.config.*"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
String lastSelectedRow = (String)request.getSession().getAttribute("lastSelectedAccount");
if (lastSelectedRow == null){
	lastSelectedRow = "";
}

String refreshMenusStr = request.getParameter("refreshMenus");
boolean refreshMenus = refreshMenusStr != null && refreshMenusStr.equals("true");

final boolean ALLOW_EMBEDED_FLASH = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("snapshot.allowEmbededFlash",true);

%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>

<script>
<%
if(refreshMenus) {
%>
refreshMenus();
<%
}
%>
</script>

<jsp:include page="../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<%
	String menuIds = "viewSnapshot,editSnapshot,removeSnapshot,exportSnapshot,copySnapshot,copySnapshotLink";
	String menuTexts = "View,Edit,Remove,Export,Copy to Clipboard,Copy snapshot link";
	String menuHrefs = "javascript:doViewSnapshot(),javascript:doEdit();,javascript:removeSnapshpt0();,javascript:doExport(),javascript:doCopyToClipboard();,javascript:doCopyLinkToClipboard();";
%>
<jsp:include page="../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		</jsp:include>
	<jsp:include page="../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	  <jsp:param name="showMenu" value="true" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	</jsp:include>
<%
%>

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";
	var flash_installed = (navigator.appName == 'Netscape') ? isFlashInstalledInBrowser() : true;
	var isAllowEmbededFlash = '<%=ALLOW_EMBEDED_FLASH%>';
	var showCopyAction = ((isAllowEmbededFlash == "true") && flash_installed) || (navigator.appName != 'Netscape');
	var	msgWriter = null;
	  
	
	function init() {
	}
	
 
  function closeEditSnapshotDiv() {
		showHideGeneralAdminDiv("snapshot");
	}
  
  function doEdit(){
    var snapshotId = getFirstSelectedRow(mygrid);
    if (snapshotId == "") {
     return;
    }
    doEdit1(snapshotId);
  }
  
  function doEdit1(snapshotId){
		  var params = "snapshotId=" + snapshotId;
 			var page = "../snapshot/createSnapshotDiv.jsp?";
			sendAjaxRequest(page,function(req){
				var result = req.responseText;
				result = result.replace(/^\s+|\s+$/g, '') ;
				if(!result || result == "error"){
						alert("Could not open div!");			
						return;			
				}else{
					var editDiv = document.getElementById("adminGeneralIncludeTDsnapshot");
					if(editDiv){
						editDiv.innerHTML = result;
					  showHideGeneralAdminDiv("snapshot");
					}
				 }
			},'POST',params);	  
	  return;
  }
  
  function doDelete(){
    var snapshotId = mygrid.getSelectedRowId();
    if (snapshotId == "") {
      return;
    }
    doDelete1(snapshotId);
  }
  
  function doDelete1(snapshotId){
    var name = snapshotId.indexOf(",") >= 0 ? "" : mygrid.cells(snapshotId,0).getValue();
    var type = snapshotId.indexOf(",") >= 0 ? "3" :mygrid.cells(snapshotId,1).getValue();
    var row = snapshotId;
    msgWriter = new messageWriter("mygridMessage","Snapshot Delete Action","<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid"),50);
    msgWriter.addAction("Yes","javascript:hideLayer('mygridMessage');javascript:doDelete0('" + row + "','" +  snapshotId + "','" +  type + "')");
    msgWriter.addAction("No","javascript:hideLayer('mygridMessage')");  
    if(snapshotId.indexOf(",") >= 0){
	    msgWriter.showMessage("<nobr>Are you sure you want to delete the selected snapshots? </nobr>");	
		}else{
	    msgWriter.showMessage("<nobr>Are you sure you want to delete snapshot </nobr>" + name + "?");
	  }
  }
  
  function doDelete0(row,id,type){
  	if(!id){
  		return;
  	}
  	 msgWriter = new messageWriter("deleteSnapshotId","Snapshot Delete Action",baseDirectory);		
	   msgWriter.setPosition(-1,-1);
		 msgWriter.showMessage("Deleting snapshots...");
 		var param = id.indexOf(",") >= 0 ? "SNAPSHOT_IDS=" : "SNAPSHOT_ID=";
 		param +=id;
  	deleteGridRow(mygrid,row,baseDirectory + "snapshot/snapshotRemoveAction.jsp?getAsXML=true&" + param + "&timestamp=" + new Date().getTime(),refreshSnapshotsTree);
  }
  
  function refreshSnapshotsTree(){
  	var size = mygrid.getRowsNum();
  	if(!size || size == 0){
  		refreshMenus();
  	}else{
	  	refreshMenus('','Snapshot',baseDirectory); 
	  }
  	closeMsgWriter("deleteSnapshotId");
  }
  
  
  
  
  function closeMsgWriter(id){
		msgWriter = null;
		hideLayer(id);
	}
  
	function handleMenuItems(){
	    aMenu.menu.showButtons("viewSnapshot,editSnapshot,removeSnapshot,exportSnapshot,copySnapshot,copySnapshotLink");
  }
  
 
  function removeSnapshpt0(){
    if (contextRowId && contextRowId != ""){
      doDelete1(contextRowId);
    }
  }
  
  function doViewSnapshot(){
     var id = getFirstSelectedRow(mygrid);
    if (id == "") {
      return;
    }
     var url = "snapshot/snapshotView.jsp?SNAPSHOT_ID=" + id;
     
    path = "<%=BASE_DIRECTORY%>" + url;
  	document.location = path;
   }
    
  function doExport(){
     var id = getFirstSelectedRow(mygrid);
    if (id == "") {
      return;
    }
     var url = "snapshot/exportSnapshotAction.jsp?SNAPSHOT_ID=" + id;
     
    path = "<%=BASE_DIRECTORY%>" + url;
  	document.location = path;
   }
   
   function doCopyLinkToClipboard(){
		var id = getFirstSelectedRow(mygrid);
    if (id == "") {
      return;
    }
		var timestamp = '<%=System.currentTimeMillis()%>';
		var applicationRoot = '<%=SiteUtil.getApplicationRoot(request)%>';		
		var link = applicationRoot + "componentAction.jsp?selectedCompId=XpoLog&forward=root.jsp?mainPage=snapshot/snapshotView.jsp%3FSNAPSHOT_ID=" + id;
		copyToClipboard(link);
   }
   
   function doCopyToClipboard(){
		var id = getFirstSelectedRow(mygrid);
    if (id == "") {
      return;
    }
   		doCopyToClipboard1(id);
   
   }
   
   
   function doCopyToClipboard1(snapId){
		var id = snapId;
		var page = "<%=BASE_DIRECTORY%>common/getLbmRecordsArr.jsp?SNAPSHOT_ID=" +id;
				sendAjaxRequest(page,function(req){
				var result = req.responseText;
				result = result.replace(/^\s+|\s+$/g, '') ;
				if(!result || result == "error"){
					var msg = "<nobr>Problem copying selected snapshot to clipboard!</nobr>"
					parent.errorMsgWriter(snapshotMsgWriterId,msg,"");							
					return;			
				}else if(result == "ActionDenied"){
					var msg = "<nobr>Another user is using this snapshot</nobr>"
					parent.errorMsgWriter(snapshotMsgWriterId,msg,"");							
					return;							
				}else{
					var dataToCopy = "";
					var resultArr = result.split("#@#@");
					for(var i = 0 ; resultArr && i < resultArr.length ; i++){
						dataToCopy += resultArr[i] + "\n";
					}
					copyToClipboard(dataToCopy);
				}
			});	
	}
   
 	function copyToClipboard(dataToCopy){
			if(window.clipboardData){
				window.clipboardData.setData('text', dataToCopy);
			}else if(showCopyAction){
		     var clipboarddiv=document.getElementById('divclipboardswf');  
				 if(clipboarddiv==null){  
		        clipboarddiv=document.createElement('div');  
		        clipboarddiv.setAttribute("name", "divclipboardswf");  
		        clipboarddiv.setAttribute("id", "divclipboardswf");  
		        document.body.appendChild(clipboarddiv);  
		     }  
		     clipboarddiv.innerHTML='<embed src="../common/clipboard.swf" FlashVars="clipboard='+  
				 encodeURIComponent(dataToCopy)+'" width="0" height="0" type="application/x-shockwave-flash"></embed>';  			    	
			}else{
				var msg = "<nobr>Problem copying selected snapshot to clipboard!</nobr>"
				parent.errorMsgWriter("snapshotMsgWriterId",msg,"");							
				return;			
			}	
	 }
   
   
  function doApply(){
		var id = getFirstSelectedRow(mygrid);
    if (id == "") {
      return;
    }
		var name;
		if(document.getElementById('firstNewSnapshot')){
			name = document.getElementById('firstNewSnapshot').value;
		}
		var description;
		if(document.getElementById('snapshotDescription')){
			description  = document.getElementById('snapshotDescription').value;
		}
		var params = "snapshotId=" + id + "&snapshotName=" + name + "&snapshotDescription=" + description;
		var page = "../snapshot/editSnapshotAction.jsp?";
			sendAjaxRequest(page,function(req){
				var result = req.responseText;
				result = result.replace(/^\s+|\s+$/g, '') ;
				if(!result || result != "ok"){
						var title = "Edit Snapshot Action";
						var actions = "Close@javascript:closeMsgWriter('snapshotMsgWriterId')";
						var msg = "<nobr>" + result + "</nobr>";
						parent.openMsgWriter('snapshotMsgWriterId',title,actions,msg,"","");
						return;			
				}else{
					parent.refreshMenus("","Snapshot");
	  		 refreshTable();
			   closeEditSnapshotDiv();
			  }		   
			},'POST',params);				
	}
   
  
</script>
</head>

<%
String onLoadFunctions = "initTables()";
onLoadFunctions = "initMenus();" + onLoadFunctions;
%>
<body onLoad="<%=onLoadFunctions %>" onUnload="destroyTables()" style="margin:0;padding:0;overflow:auto;" >

<jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="title" value="Select snapshot to edit"/> 
	<jsp:param name="suffix" value="snapshot"/> 
	<jsp:param name="width" value="500px"/> 
	<jsp:param name="height" value="160px"/> 
	<jsp:param name="zIndex" value="500"/> 
	<jsp:param name="includePath" value="snapshot/createSnapshotDiv.jsp"/> 
	<jsp:param name="actionsNames" value="Apply#Cancel"/> 
	<jsp:param name="actions" value="javascript:doApply()#javascript:closeEditSnapshotDiv()"/> 
</jsp:include>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td valign="top">
      <table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              
        <tr height="10">
          <td>
          <jsp:include page="../common/pageMainHeader.jsp" flush="true">
						<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
						<jsp:param name="headerTitle" value="Snapshots" />
					</jsp:include>		
        </td>
	      </tr>
	      <tr>                
	        <td valign="top">
	          <% 
	          String tableNames = "Edit#Delete";
	          String tableActions = "javascript:doEdit()#javascript:doDelete()";
	          String ids = "Edit#Delete";
	          String selectTypes = "2#3";
	          
	          if (tableNames.length() > 0){
	        		tableNames += "*;*";
	        		tableActions += "*;*";
	        		ids += "*;*";
	        		selectTypes += "*;*";
	        	}             	
	          
	          tableNames += "View#Export";
	      		tableActions += "javascript:doViewSnapshot()#javascript:doExport()";
	      		ids += "viewSnapshot#exportSnapshot";
	      		selectTypes += "2#2";
	
	       		String menu ="aMenu";
	          
	          %>
						<jsp:include page="../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="initXML" value="snapshot/snapshotGridXML.jsp" />
							<jsp:param name="menu" value="<%=menu%>"/>
							<jsp:param name="tableActionNames" value="<%=tableNames%>" />
							<jsp:param name="tableActions" value="<%=tableActions%>" />
							<jsp:param name="tableActionIds" value="<%=ids%>" />
							<jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
							<jsp:param name="recordsText" value="Snapshots" />
							<jsp:param name="style" value="main" />
							<jsp:param name="doubleClickAction" value="doViewSnapshot" />
							<jsp:param name="lastSelectedRow" value="<%=lastSelectedRow%>" />
							<jsp:param name="showSelectedRowOnLoad" value="true" />
						</jsp:include>
        	</td>
      	</tr>      
    	</table>
    </td>
  </tr>
</table>

<script>
	function updateButtonActivate(rowid,id,columnType,gridType){
	   if (!rowid || !mygrid.doesRowExist(rowid) || (gridType == 3 && columnType != 3)){
    
     disableActionButton(id);
     return;
   }   
	 	   enableActionButton(id);
	}
	
	function onErrorMsg(message){
    closeMsgWriter("deleteSnapshotId");
     msgWriter = new messageWriter("mygridMessage","Snapshot Delete Error","<%=BASE_DIRECTORY%>");
      msgWriter.setYParent(document.getElementById("mygrid"),50);
    msgWriter.addAction("Close","javascript:hideLayer('mygridMessage')");
    msgWriter.showMessage(message);
    var size = mygrid.getRowsNum();
  	if(!size || size == 0){
  		refreshMenus();
  	}else{
	  	refreshMenus('','Snapshot',baseDirectory); 
	  }
  }
</script>

</body>

</html>