<%@ page language="java"%>

<%@page import="xpolog.eye.site.startup.ui.*"%>

<%!
	static final String BASE_DIRECTORY = "../";
	static final String IMAGES_BASE_DIRECTORY = BASE_DIRECTORY + "images/startup/";
%>

<%
	String clearControllerStr = request.getParameter("clearController");
	boolean clearController = clearControllerStr != null && clearControllerStr.equals("true");
	StartupUIController startupUIController = (StartupUIController)session.getAttribute(StartupUIController.STARTUP_UI_CONTROLLER_TYPE);
	if(startupUIController == null) {
		startupUIController = new StartupUIController();
		session.setAttribute(StartupUIController.STARTUP_UI_CONTROLLER_TYPE, startupUIController);
	}else {
		if(clearController) {
			startupUIController = new StartupUIController();
			session.setAttribute(StartupUIController.STARTUP_UI_CONTROLLER_TYPE, startupUIController);
		}
	}
	if (clearController){
		StartupViewHelper helper = (StartupViewHelper)request.getSession().getAttribute(StartupViewHelper.STARTUP_HELPER_TYPE);
		if (helper != null){
			helper.dispose();
			request.getSession().removeAttribute(StartupViewHelper.STARTUP_HELPER_TYPE);
		}
	}
	StartupUIPage startupUIPage = startupUIController.getCurrentPage();
	String topImage = null;
	String headerButton1Image = null;
	String headerButton1Text = null;
	String headerButton2Image = null;
	String headerButton2Text = null;
	String headerButton3Image = null;
	String headerButton3Text = null;
	boolean showAdvancedLink = false;
	String advancedHref = null;
	String mainPageName = null;
	String footerButton1Image = null;
	String footerButton2Image = null;
	String footerButton3Image = null;
	String actionPage = null;
	if(startupUIPage != null) {
		topImage = startupUIPage.getTopImage();
		headerButton1Image = startupUIPage.getHeaderButton1Image();
		headerButton1Text = startupUIPage.getHeaderButton1Text();
		headerButton2Image = startupUIPage.getHeaderButton2Image();
		headerButton2Text = startupUIPage.getHeaderButton2Text();
		headerButton3Image = startupUIPage.getHeaderButton3Image();
		headerButton3Text = startupUIPage.getHeaderButton3Text();
		showAdvancedLink = startupUIPage.isShowAdvancedLink();
		advancedHref = startupUIPage.getAdvancedHref();
		mainPageName = startupUIPage.getMainPageName();
		footerButton1Image = startupUIPage.getFooterButton1Image();
		footerButton2Image = startupUIPage.getFooterButton2Image();
		footerButton3Image = startupUIPage.getFooterButton3Image();
		actionPage = startupUIPage.getActionPage();
	}
	
	String heightStr = request.getParameter("height");
	if(heightStr != null) {
		session.setAttribute("height", heightStr);
	}else {
		heightStr = (String)session.getAttribute("height");
	}
	String bodyHeightStr = "367";
	if(heightStr != null) {
		try {
			int height = Integer.parseInt(heightStr);			
			bodyHeightStr = Integer.toString(height - 333);
		}catch(Exception e) {
		}

	}
%>

<%@page import="xpolog.eye.site.startup.StartupViewHelper"%>
<html>

<head>
	<meta http-equiv="Content-Language" content="en-us">
	<meta http-equiv="CACHE-CONTROL" content="NO-CACHE">
	<meta http-equiv="PRAGMA" content="NO-CACHE">
	<meta http-equiv="EXPIRES" content="0">
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/startup.css" />
	<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
	<title>Xpolog Center Automatic Configuration Wizard</title>
	
	<script type="text/javascript">
	var referer = opener;
	var position = <%=startupUIController.getPosition() %>;
	
	function getXmlHttpObject() {
	 	var xmlHttp = null;
	  try {
	    // Firefox, Opera 8.0+, Safari
	    xmlHttp = new XMLHttpRequest();
	  }catch (e) {
	    // Internet Explorer
	    try {
	      xmlHttp = new ActiveXObject("Msxml2.XMLHTTP");
	    }catch (e) {
	      xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
	    }
	  }
	  return xmlHttp;
	}
	
	function updateProgress(percentage, message) {
		var tdWidth = document.getElementById("progressWrapper").clientWidth;
		var progressWidth = (tdWidth * percentage) / 100;
		var backgroundWidth = tdWidth - progressWidth;
		if(parseInt(percentage) == 0) {
			document.getElementById("progressBackground").width = backgroundWidth;
		}else if(parseInt(percentage) == 100) {
			document.getElementById("progressBar").width = tdWidth;
			document.getElementById("progressBar").style.display = "";
			document.getElementById("progressBackground").style.display = "none";
		}else {
			document.getElementById("progressBar").width = progressWidth;
			document.getElementById("progressBar").style.display = "";
			document.getElementById("progressBackground").width = backgroundWidth;
		}
		if(message.indexOf("errorMessage:") > -1) {
			message = message.substr("errorMessage:".length);
			document.getElementById("progressText").className = "STARTUP_BODY_ERROR_TEXT";
		}else {
			document.getElementById("progressText").className = "STARTUP_BODY_PROGRESS_TEXT";
		}
		document.getElementById("progressText").innerHTML = message;
	}
	
	function hideShowLocalApplications() {
		var localApplicationsDiv = document.getElementById("localApplicationsDiv");
		var localApplicationsDivLink = document.getElementById("showLocalApplications");
		var display = localApplicationsDiv.style.display;
		if(display == "") {
			localApplicationsDiv.style.display = "none";
			if(document.all) {
				localApplicationsDivLink.innerText = "Show";
			}else {
				localApplicationsDivLink.textContent = "Show";
			}	
		}else {
			localApplicationsDiv.style.display = "";
			if(document.all) {
				localApplicationsDivLink.innerText = "Hide";
			}else {
				localApplicationsDivLink.textContent = "Hide";
			}	
		}
	}
	
	function hideShowNetworkApplications(hideIfShown) {
		var networkApplicationsDiv = document.getElementById("networkApplicationsDiv");
		var networkApplicationsDivLink = document.getElementById("showNetworkApplications");
		var display = networkApplicationsDiv.style.display;
		if(display == "" && hideIfShown == true) {
			networkApplicationsDiv.style.display = "none";
			if(document.all) {
				networkApplicationsDivLink.innerText = "Show";
			}else {
				networkApplicationsDivLink.textContent = "Show";
			}
		}else {
			networkApplicationsDiv.style.display = "";
			if(document.all) {
				networkApplicationsDivLink.innerText = "Hide";
			}else {
				networkApplicationsDivLink.textContent = "Hide";
			}
		}
	}
	
	function hideShowHostApplications(hostNum) {
		var hostApplicationsDiv = document.getElementById("network" + hostNum + "ApplicationsDiv");
		var hostApplicationsDivLink = document.getElementById("showNetwork" + hostNum + "Applications");
		var display = hostApplicationsDiv.style.display;
		if(display == "") {
			hostApplicationsDiv.style.display = "none";
			if(document.all) {
				hostApplicationsDivLink.innerText = "Show";
			}else {
				hostApplicationsDivLink.textContent = "Show";
			}
		}else {
			hostApplicationsDiv.style.display = "";
			if(document.all) {
				hostApplicationsDivLink.innerText = "Hide";
			}else {
				hostApplicationsDivLink.textContent = "Hide";
			}
		}
	}
	
	function changeButtonLayout(image, action, name) {
		var imageLink = document.getElementById(name + "Link");
		if(imageLink.disabled == true) {
			return;
		}
		if(action == "over") {
			image.src = "<%=IMAGES_BASE_DIRECTORY %>" + name + "ButtonClicked.gif";
		}else {
			image.src = "<%=IMAGES_BASE_DIRECTORY %>" + name + "ButtonEnabled.gif";
		}
	}
	
	function doSubmit(index, command) {
		var imageLink = document.getElementById(command + "Link");
		if(imageLink.disabled == true) {
			return;
		}
		var image = document.getElementById("button" + index);
		image.src = "<%=IMAGES_BASE_DIRECTORY %>" + command + "ButtonClicked.gif";
		document.access.command.value = command;
		if(command == 'done') {
			try {
				if(referer.name == 'main') {
					if(position == 4) {
						referer.parent.location = "<%=BASE_DIRECTORY %>componentAction.jsp?selectedCompId=XpoLog&forward=root.jsp?mainPage=view/mainView.jsp";
					}
					referer.parent.focus();
				}else {
					if(position == 4) {
						referer.location = "<%=BASE_DIRECTORY %>componentAction.jsp?selectedCompId=XpoLog&forward=root.jsp?mainPage=view/mainView.jsp";
					}
					referer.focus();
				}
			}catch(err) {
			}
			window.close();
		}
		document.access.submit();
	}
	
	function cleanStartup(){
		if (window.screenLeft >screen.width){
			doBackgroundAction("cleanStartup.jsp");
		}
	}
	
	function abortAjaxCalls() {
		try {
			if(updateStatusXmlHttp) {
				updateStatusXmlHttp.abort();
			}
		}catch(err) {
		}
		try {
			if(detectLocalAppsXmlHttp) {
				detectLocalAppsXmlHttp.abort();
			}
		}catch(err) {
		}
		try {
			if(addHostXmlHttp) {
				addHostXmlHttp.abort();
			}
		}catch(err) {
		}
		try {
			if(updateAddHostStatusXmlHttp) {
				updateAddHostStatusXmlHttp.abort();
			}
		}catch(err) {
		}
		try {
			if(addAppXmlHttp) {
				addAppXmlHttp.abort();
			}
		}catch(err) {
		}
		try {
			if(updateAddAppStatusXmlHttp) {
				updateAddAppStatusXmlHttp.abort();
			}
		}catch(err) {
		}
		try {
			if(createApplicationsXmlHttp) {
				createApplicationsXmlHttp.abort();
			}
		}catch(err) {
		}
		try {
			if(createDashboardXmlHttp) {
				createDashboardXmlHttp.abort();
			}
		}catch(err) {
		}
	}
	
	</script>

</head>

<body style="margin:0;padding:0" onabort="javascript:abortAjaxCalls()" onunload="javascript:abortAjaxCalls();cleanStartup()">

<form AUTOCOMPLETE="OFF" id="access" name="access" action="<%=actionPage %>" method="POST" style="padding:0;margin:0">
<input type="hidden" name="command">
<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
  <tr valign="top">
    <td valign="top">
    	<table border="0" width="100%" cellspacing="0" cellpadding="0">
      	<tr>
      		<td>
        		<table border="0" width="100%" cellspacing="0" cellpadding="0">
	        		<tr>
	        			<td background="<%=IMAGES_BASE_DIRECTORY + topImage %>" width="100%" height="265">
	        			</td>
	        		</tr>
	        		<tr>
	        			<td background="<%=IMAGES_BASE_DIRECTORY %>titleBackground.gif" height="27">
	        				<table border="0" width="100%" cellspacing="0" cellpadding="0">
	        					<tr>
	        						<td width="3%" style="font-size:3pt">&nbsp;</td>
	        						<td width="16" style="padding-left:5">
	        							<img src="<%=IMAGES_BASE_DIRECTORY + headerButton1Image %>" align="middle">
	        						</td>
	        						<td width="80" align="left" valign="center" style="padding-left:3">
	        							<span class="STARTUP_STEP_TITLE_TEXT"><%=headerButton1Text %></span>
	        						</td>
	        						<td width="16" style="padding-left:15">
	        							<img src="<%=IMAGES_BASE_DIRECTORY + headerButton2Image %>" align="middle">
	        						</td>
	        						<td width="90" align="left" valign="center" style="padding-left:3">
	        							<span class="STARTUP_STEP_TITLE_TEXT"><%=headerButton2Text %></span>
	        						</td>
	        						<td width="16" style="padding-left:15">
	        							<img src="<%=IMAGES_BASE_DIRECTORY + headerButton3Image %>" align="middle">
	        						</td>
	        						<td width="80" align="left" valign="center" style="padding-left:3;">
	        							<span class="STARTUP_STEP_TITLE_TEXT"><%=headerButton3Text %></span>
	        						</td>
	        						<td width="*" style="font-size:3pt">&nbsp;</td>
	        						<td width="20" align="right" style="padding-right:20">
	        							<%
	        							if(showAdvancedLink) {
	        							%>
	        								<a href="<%=advancedHref %>" class="STARTUP_TABLE_HEADER_LINK">Advanced</a>
	        							<%
	        							}
	        							%>
	        						</td>
	        					</tr>
	        				</table>
	        			</td>
	        		</tr>
	        		<tr height="<%=bodyHeightStr %>">
	        			<jsp:include flush="true" page="<%=mainPageName %>">
									<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY %>"/>
									<jsp:param name="actionPage" value="<%=actionPage %>"/>
									<jsp:param name="height" value="<%=bodyHeightStr %>"/>
								</jsp:include>
						  </tr>
						  <tr height="20" valign="bottom">
	        			<td align="center">
	        				<table border="0" width="100%" cellspacing="0" cellpadding="0">
	        					<hr size="1" width="94%">
	        					<tr>
	        						<td width="3%" style="font-size:3pt">&nbsp;</td>
	        						<td align="left" valign="center" width="50"><img src="<%=IMAGES_BASE_DIRECTORY %>xplgLogo.gif"></td>
	        						<td><span class="STARTUP_FOOTER_TEXT" valign="center" style="padding-left:2">Go to <a href="http://www.xplg.com" class="STARTUP_FOOTER_LINK" target="_blank">XPLG web site</a> for more add ons</span></td>
	        						<td align="right" valign="center" width="50">
	        							<%
	        							if(footerButton1Image != null && !footerButton1Image.equals("")) {
	        							%>
	        								<a id="doneLink" href="javascript:doSubmit(1, 'back')"><img id="button1" valign="center" src="<%=IMAGES_BASE_DIRECTORY + footerButton1Image %>" border="0" onmouseover="changeButtonLayout(this, 'over', 'back')" onmouseout="changeButtonLayout(this, 'out', 'back')"></a>
	        							<%
	        							}
	        							%>
	        						</td>
	        						<td align="right" valign="center" width="50">
	        							<%
	        							if(footerButton2Image != null && !footerButton2Image.equals("")) {
	        							%>
	        								<a id="nextLink" href="javascript:doSubmit(2, 'next')"><img id="button2" valign="center" src="<%=IMAGES_BASE_DIRECTORY + footerButton2Image %>" border="0" onmouseover="changeButtonLayout(this, 'over', 'next')" onmouseout="changeButtonLayout(this, 'out', 'next')"></a>
	        							<%
	        							}
	        							%>
	        						</td>
	        						<td align="right" valign="center" width="50" style="padding-right:5">
	        							<%
	        							if(footerButton3Image != null && !footerButton3Image.equals("")) {
	        							%>
	        								<a id="doneLink" href="javascript:doSubmit(3, 'done')"><img id="button3" valign="center" src="<%=IMAGES_BASE_DIRECTORY + footerButton3Image %>" border="0" onmouseover="changeButtonLayout(this, 'over', 'done')" onmouseout="changeButtonLayout(this, 'out', 'done')"></a>
	        							<%
	        							}
	        							%>
	        						</td>
	        						<td width="*" style="font-size:3pt">&nbsp;</td>
	        						<td width="3%" style="font-size:3pt">&nbsp;</td>
	        					</tr>
	        				</table>
	        			</td>
	        		</tr>
	        	</table>
        	</td>
        </tr>
      </table>
    </td>
  </tr>
</table>
</form>
</body>
</html>