<%@page import="xpolog.eye.site.SiteUtil"%>
<%@page import="xpolog.eye.SiteManagment"%>
<%@page import="xpolog.eye.admin.wizards.common.WizardManager"%>
<%@page import="xpolog.eye.admin.wizards.common.WizardInfo"%>
<%@ page language="java"%>

<%@page import="java.io.IOException"%>
<%@page import="java.util.*"%>

<%@page import="xpolog.eye.site.startup.*"%>
<%@page import="xpolog.eye.site.startup.ui.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";

	private void prepareApplicationCreation(StartupViewHelper helper, HttpServletRequest request, HttpServletResponse response) throws IOException {
		StartupApplication app = null;
		String isSelectedStr = null;
		boolean isSelected;
		
		ArrayList apps = (ArrayList)helper.getLocalApps();
		int numberOfSelectedLocalApps = 0, numberOfSelectedNetworkApps = 0;
		
		for (int i = 0; i < apps.size(); i++) {
			app = (StartupApplication)apps.get(i);
			isSelectedStr = request.getParameter("local_" + app.getId() + "_check");
			isSelected = (isSelectedStr != null && isSelectedStr.equals("on"));
			app.setSelected(isSelected);
			if(isSelected) {
				numberOfSelectedLocalApps++;
			}
		}
		helper.setNumberOfSelectedLocalApps(numberOfSelectedLocalApps);
		
		ArrayList networkHosts = helper.getNetworkHosts();
		NetworkHost networkHost = null;
		int numberOfSelectedHosts = 0, numberOfSelectedApps = 0;
		
		for(int i = 0; i < networkHosts.size(); i++) {
			numberOfSelectedApps = 0;
			networkHost = (NetworkHost)networkHosts.get(i);
			if(networkHost != null) {
				isSelectedStr = request.getParameter("network" + i + "_check");
				isSelected = (isSelectedStr != null && isSelectedStr.equals("on"));
				networkHost.setSelected(isSelected);
				if(isSelected) {
					numberOfSelectedHosts++;
				}
				apps = networkHost.getNetworkApps();
				for (int j = 0; j < apps.size(); j++) {
					app = (StartupApplication)apps.get(j);
					isSelectedStr = request.getParameter("network" + i + "_" + app.getId() + "_check");
					isSelected = (isSelectedStr != null && isSelectedStr.equals("on"));
					app.setSelected(isSelected);
					if(isSelected) {
						numberOfSelectedApps++;
						numberOfSelectedNetworkApps++;
					}
				}
				networkHost.setNumberOfSelectedApps(numberOfSelectedApps);
			}
		}
		helper.setNumberOfSelectedHosts(numberOfSelectedHosts);
		helper.setNumberOfSelectedNetworkApps(numberOfSelectedNetworkApps);
	}
%>

<%
	StartupUIController startupUIController = (StartupUIController)session.getAttribute(StartupUIController.STARTUP_UI_CONTROLLER_TYPE);
	String command = request.getParameter("command");
	
	if(startupUIController != null && command != null && !command.equals("")) {
		if(command.equals("back")	) {
			startupUIController.setPosition(1);
		}else if(command.equals("next")	) {
			StartupViewHelper helper = (StartupViewHelper)request.getSession().getAttribute(StartupViewHelper.STARTUP_HELPER_TYPE);
			if(helper != null) {
				prepareApplicationCreation(helper, request, response);
				startupUIController.setPosition(3);
			}
		}else if(command.equals("addApplication")) {
			StartupViewHelper helper = (StartupViewHelper)request.getSession().getAttribute(StartupViewHelper.STARTUP_HELPER_TYPE);
			if(helper != null) {
				String hostId = request.getParameter("hostId");
				String applicationId = request.getParameter("applicationId");
				String path = request.getParameter("path");
				
				SiteManagment mgmt = SiteManagment.getInstance();
				WizardManager wmg = mgmt.getWizardManager(SiteUtil.getBaseDirectory(request));
				WizardInfo wizardInfo = null;
				StartupApplication app = null;
				if(hostId != null) {
					wizardInfo = wmg.getWizardById(applicationId);
					app = new StartupApplication();
					app.setWizardId(wizardInfo.getID());
					app.setId(wizardInfo.getID());
					app.setName(wizardInfo.getName());
					app.setPath(path);
					app.setType(wizardInfo.getMetaData().getApplication());
					if(hostId.equals("-1")) {
						helper.addLocalApp(app);
					}else {
						int index = Integer.parseInt(hostId);
						helper.addNetworkAppToHost(index, app);
					}
				}
			}		
			startupUIController.setPosition(2);
		}
	}

	response.sendRedirect("../startupTemplate.jsp");
%>
