<%@ page language="java"%>
<%@page import="java.util.ArrayList"%>

<%@page import="xpolog.eye.admin.wizards.common.WizardInfo"%>
<%@page import="xpolog.eye.admin.wizards.common.WizardManager"%>
<%@page import="xpolog.eye.media.Account"%>
<%@page import="xpolog.eye.media.auth.win.WinAuthenticationAccount"%>
<%@page import="xpolog.eye.media.telsh.TelnetAccount"%>
<%@page import="xpolog.eye.site.startup.*"%>
<%@page import="xpolog.eye.SiteManagment"%>
<%@page import="xpolog.eye.site.SiteUtil"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.tools.XpologSystemInfo"%>

<%!
private String getAccountDetail(Account account, String detailId) {
	if(account == null) {
		return "";
	}
	if(account instanceof WinAuthenticationAccount) {
		WinAuthenticationAccount winAccount = (WinAuthenticationAccount)account;
		if(detailId != null) {
			if(detailId.equals("port")) {
				return "";
			}else if(detailId.equals("username")) {
				return winAccount.getUser() + "";
			}else if(detailId.equals("password")) {
				if(winAccount.getPassword() != null && !winAccount.getPassword().equals("")) {
					return "********";
				}
			}
		}
	}else {
		TelnetAccount sshAccount = (TelnetAccount)account;
		if(detailId != null) {
			if(detailId.equals("port")) {
				return Integer.toString(sshAccount.getPort());
			}else if(detailId.equals("username")) {
				return sshAccount.getUserName();
			}else if(detailId.equals("password")) {
				return "********";
			}
		}
	}
	return "";
}
%>
<%

String BASE_DIRECTORY = request.getParameter("BASE_DIRECTORY");
String IMAGES_BASE_DIRECTORY = BASE_DIRECTORY + "images/startup/";
String actionPage = request.getParameter("actionPage");
String heightStr = request.getParameter("height");
String bottomHeightStr = "40";
int topHeight = Integer.parseInt(heightStr) - Integer.parseInt(bottomHeightStr);

StartupViewHelper helper = (StartupViewHelper)request.getSession().getAttribute(StartupViewHelper.STARTUP_HELPER_TYPE);
String isInitStr = request.getParameter("init");
boolean isInit = (isInitStr != null && isInitStr.equals("true"));
if(isInit) {
	helper.clearNetworkHosts();
}

String checkLocalCheck = "";
if(isInit || helper.getNumberOfSelectedLocalApps() > 0) {
	checkLocalCheck = "checked";
}
String checkNetworkCheck = "";
if(helper.getNumberOfSelectedHosts() > 0) {
	checkNetworkCheck = "checked";
}

ArrayList localApps = helper.getLocalApps();
ArrayList networkHosts = helper.getNetworkHosts();
int numberOfHosts = helper.getNumberOfHosts();
int maxHostNum = helper.getMaxHostNum();

SiteManagment mgmt = SiteManagment.getInstance();
WizardManager wmg = mgmt.getWizardManager(SiteUtil.getBaseDirectory(request));
UserEnvironment env = UserEnvironment.getUserEnvironment(request);
UserContext userContext = env.getUserContext();
WizardInfo[] wizards = wmg.getStartupWizards(userContext);
boolean isWindows = XpologSystemInfo.isWindows();

%>

<script>
function checkLocal(checkbox) {
	var inputs = document.getElementsByTagName("input"), i;
	for(i = 0; i < inputs.length; i++) {
		if(inputs[i].type == "checkbox") {
			var prefix = "local_";
			var prefixLength = prefix.length;
			var substring = inputs[i].name.substring(prefixLength, 0);
			if(substring == prefix && inputs[i].disabled == false) {
				inputs[i].checked = checkbox.checked;
			}
		}
	}
}

function checkLocalApp(checkbox) {
	var localCheck = document.getElementById("local_check");
	if(checkbox.checked == true) {
		localCheck.checked = true;
	}else {
		var inputs = document.getElementsByTagName("input"), i, count = 0;
		for(i = 0; i < inputs.length; i++) {
			if(inputs[i].type == "checkbox") {
				var prefix = "local_";
				var prefixLength = prefix.length;
				var substring = inputs[i].name.substring(prefixLength, 0);
				if(substring == prefix && inputs[i].name != "local_check" && inputs[i].checked == true) {
					count += 1;
				}
			}
		}
		if(count == 0) {
			localCheck.checked = false;
		}
	}
}

function doCheck(e){
   	if (!e) var e = window.event;
	if (e.keyCode) code = e.keyCode;
	else if (e.which) code = e.which;
	if (code == 13){
	  return false;
	}
	return true;
  }

  function doCheckAddHost(e){
	var result = doCheck(e);
        if (!result){
         addHost();
        }
	return result;
  }

function addHost() {
	var addHostLink = document.getElementById("addHostLink");
	if(addHostLink.disabled == true) {
		return;
	}else {
		handleAddHostMessageDiv('');
		addHostAction();
		setTimeout("updateAddHostStatus()", 2000);
	}
}

var addHostXmlHttp;
function addHostAction() {
	addHostXmlHttp = getXmlHttpObject();
 	if (addHostXmlHttp == null) {
	  return;
	}
	disableAddHostElements(true);
	
	var numberOfHosts = document.getElementById("numberOfHosts");
	num = parseInt(numberOfHosts.value);
	
	var hostNum = num;
  var newdiv = document.createElement('div');
  newdiv.setAttribute("id", "network" + hostNum + "ApplicationsParentDiv");
  var networkApplicationsDiv = document.getElementById("networkApplicationsDiv");
	networkApplicationsDiv.appendChild(newdiv);
  
	var url = "steps/addHost.jsp";
	url += "?hostNum=" + hostNum;
	url += "&osType=" + document.getElementById("osType").value;
	url += "&host=" + document.getElementById("host").value;
	url += "&port=" + document.getElementById("port").value;
	url += "&username=" + document.getElementById("username").value;
	url += "&password=" + document.getElementById("password").value;
	url += "&counter=" + counter++
	
	addHostXmlHttp.onreadystatechange = function() {
		var hostDiv = document.getElementById("network" + hostNum + "ApplicationsParentDiv");
		var addHostMessageDiv = document.getElementById("addHostMessageDiv");
		if(addHostXmlHttp.readyState == 4) {
			if(addHostXmlHttp.status == 200) {
				var txt = addHostXmlHttp.responseText;
				if(txt.indexOf('errorMessage') == -1) {
					var networkCheck = document.getElementById("network_check");
					networkCheck.checked = true;
					hostDiv.innerHTML = txt;
					handleAddHostMessageDiv('');
					var maxHostNum = document.getElementById("maxHostNum");
				  num = parseInt(maxHostNum.value);
				  maxHostNum.value = num + 1;
				  numberOfHosts = document.getElementById("numberOfHosts");
					num = parseInt(numberOfHosts.value);
					numberOfHosts.value = num + 1;
					hideShowNetworkApplications(false);
					clearHost();
				}else {
					handleAddHostMessageDiv(txt);
				}
			}else {
				var message = buildErrorMessage('An error occurred, please try again');
				handleAddHostMessageDiv(message);
			}
			disableAddHostElements(false);
		}
	}
	addHostXmlHttp.open("GET", url, true);
	addHostXmlHttp.send(null);
}

function buildErrorMessage(message) {
	var error = '';
	error += '<table border=0 width=100% cellspacing=0 cellpadding=0>';
	error += '<tr>';
	error += '<td><span class=STARTUP_BODY_ERROR_TEXT>';
	error += 'errorMessage:';
	error += message;
	error += '</span></td>';
	error += '</tr>';
	error += '</table>';
	
	return error;
}

function disableAddHostElements(disabled) {
	var host = document.getElementById("host");
	host.disabled = disabled;
	var osType = document.getElementById("osType");
	osType.disabled = disabled;
	var port = document.getElementById("port");
	port.disabled = disabled;
	var username = document.getElementById("username");
	username.disabled = disabled;
	var password = document.getElementById("password");
	password.disabled = disabled;
	
	var addHostLink = document.getElementById("addHostLink");
	addHostLink.disabled = disabled;
	
	var nextLink = document.getElementById("nextLink");
	nextLink.disabled = disabled;
	var image = document.getElementById("button2");
	if(disabled == true) {
		image.src = "<%=IMAGES_BASE_DIRECTORY %>" + "nextButtonDisabled.gif";
	}else {
		image.src = "<%=IMAGES_BASE_DIRECTORY %>" + "nextButtonEnabled.gif";
	}
}

var updateAddHostStatusXmlHttp;
function updateAddHostStatus() {
	var finished = "false";
	updateAddHostStatusXmlHttp = getXmlHttpObject();
 	if (updateAddHostStatusXmlHttp == null) {
	  return;
	}
	var url = "steps/updateStep2AddHostStatus.jsp?counter=" + counter++;
	updateAddHostStatusXmlHttp.onreadystatechange = function() {
		if(updateAddHostStatusXmlHttp.readyState == 4) {
			if(updateAddHostStatusXmlHttp.status == 200) {
				var xmlDoc = updateAddHostStatusXmlHttp.responseXML.documentElement;
				var statusElement = xmlDoc.getElementsByTagName("status")[0];
				finished = statusElement.getAttribute("finished");
				var progressStatusElement = xmlDoc.getElementsByTagName("progressStatus")[0];
				var numberOfNetworkAppsToDetect = progressStatusElement.getAttribute("numberOfNetworkAppsToDetect");
				var numberOfNetworkAppsCompleted = progressStatusElement.getAttribute("numberOfNetworkAppsCompleted");
				var numberOfNetworkAppsFound = progressStatusElement.getAttribute("numberOfNetworkAppsFound");
				if(numberOfNetworkAppsToDetect > 0) {
					var addHostLink = document.getElementById("addHostLink");
					if(addHostLink.disabled == true) {
						updateNetworkDetectionProgress(numberOfNetworkAppsCompleted, numberOfNetworkAppsToDetect, numberOfNetworkAppsFound);
						if(finished == "false") {
							setTimeout("updateAddHostStatus()", 1000);
						}
					}			
				}else {
					if(finished == "false") {
						setTimeout("updateAddHostStatus()", 1000);
					}
				}
			}else {
				if(finished == "false") {
						setTimeout("updateAddHostStatus()", 1000);
					}
			}
		}
	}
	updateAddHostStatusXmlHttp.open("GET", url, true);
	updateAddHostStatusXmlHttp.send(null);
}

function updateNetworkDetectionProgress(numberOfNetworkAppsCompleted, numberOfNetworkAppsToDetect, numberOfNetworkAppsFound) {
	var message = '';
	var num = parseInt(numberOfNetworkAppsCompleted);
	if(numberOfNetworkAppsCompleted != '' && num >= 0) {
		message = 'Completed search for ' + numberOfNetworkAppsCompleted + ' out of ' + numberOfNetworkAppsToDetect + ' known applications on ' + document.getElementById("host").value + ', found ' + numberOfNetworkAppsFound + ' applications';
	}else {
		message = 'Connecting to ' + document.getElementById("host").value;
	}
	var str = '<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">';
	str += '<tr>'
	str += '<td width=\"4%\"></td>';
	str += '<td width=\"90%\"><span class=\"STARTUP_BODY_TABLE_TEXT\">' + message + '</span></td>';
	str += '<td width=\"6%\"></td>';
	str += '</tr>'
	str += '</table>'
	handleAddHostMessageDiv(str);
}

function clearHost() {
	document.getElementById("host").value = '';
	document.getElementById("osType").selectedIndex = 0;
	document.getElementById("port").value = '';
	document.getElementById("username").value = '';
	document.getElementById("password").value = '';
	changeOsType();
}

function handleAddHostMessageDiv(message) {
	var addHostMessageDiv = document.getElementById("addHostMessageDiv");
	if(message == "") {
		addHostMessageDiv.style.display = "none";
	}else {
		addHostMessageDiv.style.display = "";
		message = remove(message, "errorMessage:");
	}
	addHostMessageDiv.innerHTML = message;
}

function remove(s, t) {
  i = s.indexOf(t);
  r = "";
  if(i == -1) {
  	return s;
  }
  r += s.substring(0, i) + remove(s.substring(i + t.length), t);
  return r;
}

function checkNetwork(checkbox) {
	var inputs = document.getElementsByTagName("input"), i;
	for(i = 0; i < inputs.length; i++) {
		if(inputs[i].type == "checkbox") {
			var prefix = "network";
			var prefixLength = prefix.length;
			var substring = inputs[i].name.substring(prefixLength, 0);
			if(substring == "network" && inputs[i].disabled == false) {
				inputs[i].checked = checkbox.checked;
			}
		}
	}
}

function checkHost(hostNum, checkbox) {
	var networkCheck = document.getElementById("network_check");
	if(checkbox.checked == true) {
		networkCheck.checked = true;
	}
	var inputs = document.getElementsByTagName("input"), i;
	for(i = 0; i < inputs.length; i++) {
		if(inputs[i].type == "checkbox") {
			var prefix = "network"+hostNum;
			var prefixLength = prefix.length;
			var substring = inputs[i].name.substring(prefixLength, 0);
			if(substring == "network"+hostNum && inputs[i].disabled == false) {
				inputs[i].checked = checkbox.checked;
			}
		}
	}
	if(checkbox.checked == false) {
		handleUncheckAction("network", "network_check", networkCheck);
	}
}

function checkNetworkApp(hostNum, checkbox) {
	var networkCheck = document.getElementById("network_check");
	var hostCheck = document.getElementById("network"+hostNum+"_check");
	if(checkbox.checked == true) {
		networkCheck.checked = true;
		hostCheck.checked = true;
	}else {
		if(handleUncheckAction("network"+hostNum, "network"+hostNum+"_check", hostCheck)) {
			checkHost(hostNum, hostCheck);
		}
	}
}

function handleUncheckAction(prefix, excludeName, checkbox) {
	var inputs = document.getElementsByTagName("input"), i, count = 0;
	for(i = 0; i < inputs.length; i++) {
		if(inputs[i].type == "checkbox") {
			var prefixLength = prefix.length;
			var substring = inputs[i].name.substring(prefixLength, 0);
			if(substring == prefix && inputs[i].name != excludeName && inputs[i].checked == true) {
				count += 1;
			}
		}
	}
	if(count == 0) {
		checkbox.checked = false;
		return true;
	}
	return false;
}

function changeOsType() {
	var osType = document.getElementById("osType");
	var text = document.getElementById("port");
	if(osType.value == "windows") {
		text.readOnly = true;
		text.value = "";
	}else {
		text.readOnly = false;
		text.value = "22";
	}
}

function addApp(index) {
	var addAppLink;
	var addAppLinkId = "";
	if(index == -1) {
		addAppLinkId = "addAppLink";
	}else {
		addAppLinkId = "add" + index + "AppLink";
	}
	addAppLink = document.getElementById(addAppLinkId);
	if(addAppLink.disabled == true) {
		return;
	}else {
		addAppAction(index);
	}
}

var counter = 0;
var addAppXmlHttp;
function addAppAction(index) {
	addAppXmlHttp = getXmlHttpObject();
 	if (addAppXmlHttp == null) {
	  return;
	}
	
	disableAddAppElements(true, index);
	handleAddAppMessageDiv(index, '');
	
	var addAppLinkId = "";
	var appTypeId = "appType";
	var pathId = "path";
	if(index == -1) {
		addAppLinkId = "addAppLink";
	}else {
		addAppLinkId = "add" + index + "AppLink";
		appTypeId += index;
		pathId += index;
	}
	var addAppLink = document.getElementById(addAppLinkId);
	addAppLink.disabled = true;
	var url = "steps/addApp.jsp";
	url += "?index=" + index;
	url += "&appType=" + document.getElementById(appTypeId).value;
	url += "&path=" + document.getElementById(pathId).value;
	url += "&counter=" + counter++;

	addAppXmlHttp.onreadystatechange = function() {
		if(addAppXmlHttp.readyState == 4) {
			if(addAppXmlHttp.status == 200) {
				var txt = addAppXmlHttp.responseText;
				if(txt.indexOf('errorMessage') == -1) {
					var newDiv = document.createElement('div');
					if(index == -1) {
						newDiv.setAttribute("id", "localManualApplicationsParentDiv");
					}else {
						newDiv.setAttribute("id", "network" + counter + "ManualApplicationsParentDiv");
					}
					newDiv.innerHTML = txt;
					var networkManualApplicationsDivId = "";
					if(index == -1) {
						networkManualApplicationsDivId = "localManualApplicationsDiv";
					}else {
						networkManualApplicationsDivId = "network" + index + "ManualApplicationsDiv";
					}
					var networkManualApplicationsDiv = document.getElementById(networkManualApplicationsDivId);
					networkManualApplicationsDiv.appendChild(newDiv);
					var check;
					if(index == -1) {
						check = document.getElementById("local_check");
					}else {
						check = document.getElementById("network_check");
						var hostCheck = document.getElementById("network" + index + "_check");
						hostCheck.checked = true;
					}
					check.checked = true;
					handleAddAppMessageDiv(index, '');
					clearApp(index);
				}else {
					handleAddAppMessageDiv(index, txt);
				}
			}else {
				var message = buildErrorMessage('An error occurred, please try again');
				handleAddAppMessageDiv(index, message);
			}
			disableAddAppElements(false, index);
		}
	}
	addAppXmlHttp.open("GET", url, true);
	addAppXmlHttp.send(null);
}

function disableAddAppElements(disabled, index) {
	var appTypeId = "appType";
	var pathId = "path";
	var addAppLinkId = "";
	if(index != -1) {
		appTypeId += index;
		pathId += index;
		addAppLinkId = "add" + index + "AppLink";
	}else {
		addAppLinkId = "addAppLink";
	}
	var appType = document.getElementById(appTypeId);
	appType.disabled = disabled;
	var path = document.getElementById(pathId);
	path.disabled = disabled;
	var addAppLink = document.getElementById(addAppLinkId);
	addAppLink.disabled = disabled;
}

function clearApp(index) {
	var appTypeId = "appType";
	var pathId = "path";
	if(index != -1) {
		appTypeId += index;
		pathId += index;
	}
	document.getElementById(appTypeId).selectedIndex = 0;
	document.getElementById(pathId).value = '';
}

function handleAddAppMessageDiv(index, message) {
	var addAppMessageDivId = "addAppMessageDiv";
	if(index != -1) {
		addAppMessageDivId += index;
	}
	var addAppMessageDiv = document.getElementById(addAppMessageDivId);
	if(message == "") {
		addAppMessageDiv.style.display = "none";
	}else {
		addAppMessageDiv.style.display = "";
		message = remove(message, "errorMessage:");
	}
	addAppMessageDiv.innerHTML = message;
}

function showHideAddApp(index) {
	var addAppDivId = "";
	if(index == -1) {
		addAppDivId = "addAppDiv";
	}else {
		addAppDivId = "add" + index + "AppDiv";
	}
	var addAppDiv = document.getElementById(addAppDivId);
	var display = addAppDiv.style.display;
	if(display == "none"){
		addAppDiv.style.display  = "";
	}else {
		addAppDiv.style.display  = "none";
	}
}
</script>

<input type="hidden" name="numberOfHosts" id="numberOfHosts" value="<%=numberOfHosts%>"/>
<input type="hidden" name="maxHostNum" id="maxHostNum" value="<%=maxHostNum%>"/>

<td align="center" valign="top">
	<div id="scroller" style="overflow:auto; width:100%; height:<%=topHeight %>"> 
	<table border="0" width="100%" cellspacing="0" cellpadding="0" width="100%" height="<%=topHeight %>">
		<tr height="5">
			<td width="3%"></td>
			<td width="550"></td>
			<td width="14"></td>
	  	<td width="3%"></td>
	  </tr>
		<tr height="20">
			<td width="3%" style="font-size:3pt">&nbsp;</td>
			<td colspan="2">
      	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
        	<tr>
	       		<td width="4%" background="<%=IMAGES_BASE_DIRECTORY %>step2Background.gif"><input type="checkbox" id="local_check" name="local_check" onclick="javascript:checkLocal(this)" <%=checkLocalCheck %>></td>
						<td width="550" align="left" background="<%=IMAGES_BASE_DIRECTORY %>step2Background.gif"><span class="STARTUP_BODY_TITLE_TEXT">Local Applications Detected</span></td>
						<td width="14" align="left" style="padding-right:5" background="<%=IMAGES_BASE_DIRECTORY %>step2Background.gif"><a id="showLocalApplications" href="javascript:hideShowLocalApplications()" class="STARTUP_TABLE_TEXT_LINK">Hide</a></td>
	       	</tr>
	      </table>
	    </td>
			<td width="3%" style="font-size:3pt">&nbsp;</td>
		</tr>
		<tr style="padding-top:2">
			<td width="3%" style="font-size:3pt">&nbsp;</td>
      <td colspan="2">
      	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
        	<tr>
	       		<td>
	       		<div id="localApplicationsDiv">
	       			<table border="0" width="100%" cellspacing="0" cellpadding="0">
		    			<tr>
		    			<td>
       		<%
       			StartupApplication app = null;
       			if(localApps.size() == 0) {
       		%>
       				<table border="0" width="100%" cellspacing="0" cellpadding="0">
			        	<tr>
			         		<td width="34%"><span class="STARTUP_BODY_TABLE_TEXT">No applications were found</span></td>
									<td width="60%"></td>
			 		      	<td width="6%"></td>
			          </tr>
			         </table>
          <%
         		}else {
         	%>
         			<table border="0" width="100%" cellspacing="0" cellpadding="0">
         	<%
          		for(int i = 0; i < localApps.size(); i++) {
								app = (StartupApplication)localApps.get(i);
								String checked = "";
	    					if(app.isCanBeExecuted()) {
	    						if(app.isSelected()) {
	    							checked ="checked";
	    						}
	    					}else {
	    						checked ="disabled";
	    					}
									String path = app.getPath(), tooltip = "";
									if(!app.isCanBeExecuted() || (app.getMessage() != null && !app.getMessage().equals(""))) {
										if(path == null || path.equals("")) {
											path = app.getMessage();
										}else {
											path = (app.getMessage() + ": " + path);
										}
									}
									if(path.length() > 50) {
										tooltip = path;
										path = path.substring(0, 50) + "...";
									}
         	%>
			       	 	<tr <%=i % 2 == 1 ? "class=\"STARTUP_TABLE_COLORED_ROW\"" : "" %>>
			        		<td width="4%"><input type="checkbox" name="local_<%=app.getId()%>_check" id="local_<%=app.getId()%>_check" <%=checked%> onClick="javascript:checkLocalApp(this)" <%if(!app.isCanBeExecuted()) { %>disabled<%} %>></td>
									<td width="30%"><span class="STARTUP_BODY_TABLE_TEXT"><%=app.getName()%></span></td>
									<td width="60%" title="<%=tooltip %>"><span class="STARTUP_BODY_TABLE_TEXT"><%=path %></span></td>
			          	<td width="6%"></td>
			        	</tr>
        	<%
         			}
         	%>
         			</table>
         	<%
        		}
       		%>
       		
       				<table border="0" width="100%" cellspacing="0" cellpadding="0">
		    				<tr>
									<td <%=(localApps.size() > 0) ? "colspan=\"4\"": "colspan=\"3\"" %>>
										<div id="localManualApplicationsDiv"></div>
									</td>
								</tr>
		    			</table>
		    
		    			<table border="0" width="100%" cellspacing="0" cellpadding="0">
		    				<tr>
									<td <%=(localApps.size() == 0) ? "colspan=\"2\"": "colspan=\"3\"" %> width="94%" align="left" style="padding-left:5"><a id="addManualApp" href="javascript:showHideAddApp(-1)" class="STARTUP_TABLE_TEXT_LINK">Add Application Manually</a></td>
									<td width="6%"></td>
								</tr>
								
								<tr>
									<td <%=(localApps.size() == 0) ? "colspan=\"3\"": "colspan=\"4\"" %> width="94%">
										<div id="addAppDiv" style="display:none">
										  <table border="0" width="100%" cellspacing="0" cellpadding="0" width="100%" height="20">
										    <tr>
													<td width="94%">
										       	<table border="0" width="100%" cellspacing="0" cellpadding="0">
										       		<tr style="padding-top:5">
											          <td width="37%" style="padding-left:5">
											          	<span class="STARTUP_BODY_TABLE_TEXT">
											          	Application:
											          	<select name="appType" id="appType" class="TEXT_BOX" size="1">
											          	<%
											          	for(int k = 0; k < wizards.length; k++) {
											          		if(!wizards[k].getID().equals("win_event") && helper.isWizardSupportedByHost(null, wizards[k])) {
											          	%>
											          		<option value="<%=wizards[k].getID()%>"><%=wizards[k].getName()%></option>
											          	<%
											          		}
											          	}
											          	%>
											          	</span>
											          </td>
											          <td width="50%" style="padding-left:5"><span class="STARTUP_BODY_TABLE_TEXT">Path:<input type="text" name="path" id="path" class="TEXT_BOX" size="40"></span></td>
											          <td width="13%"><span class="STARTUP_TABLE_LINK"><a id="addAppLink" href="javascript:addApp(-1)" class="STARTUP_TABLE_TEXT_LINK">Add</a></td>
										          </tr>
										        </table>
										     	</td>
										     	<td width="6%" style="font-size:3pt">&nbsp;</td>
										    </tr>
										    
										    <tr height="12">
						          		<td colspan="2" style="padding-left:5">
							          		<div id="addAppMessageDiv" style="display:none"></div>
							          	</td>
							          </tr>
											</table>
										</div>
									</td>
									<td width="6%"></td>
								</tr>
								
								</table>
       					</td>
       					</tr>
	       			</table>
	       		</div>
       			</td>
       		</tr>
        </table>
      </td>
      <td width="3%" style="font-size:3pt">&nbsp;</td>
    </tr>
		<tr height="5">
			<td width="3%"></td>
			<td width="550"></td>
			<td width="14"></td>
	  	<td width="3%"></td>
	  </tr>
		<tr height="20">
			<td width="3%" style="font-size:3pt">&nbsp;</td>
			<td colspan="2">
      	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
        	<tr>
	       		<td width="4%" background="<%=IMAGES_BASE_DIRECTORY %>step2Background.gif"><input type="checkbox" id="network_check" name="network_check" onclick="javascript:checkNetwork(this)" <%=checkNetworkCheck %>></td>
						<td width="550" align="left" background="<%=IMAGES_BASE_DIRECTORY %>step2Background.gif"><span class="STARTUP_BODY_TITLE_TEXT">Network Applications Detected</span></td>
						<td width="14" align="left" style="padding-right:5" background="<%=IMAGES_BASE_DIRECTORY %>step2Background.gif"><a id="showNetworkApplications" href="javascript:hideShowNetworkApplications(true)" class="STARTUP_TABLE_TEXT_LINK">Hide</a></td>
	       	</tr>
	      </table>
	    </td>
			<td width="3%" style="font-size:3pt">&nbsp;</td>
		</tr>
		<tr style="padding-top:2">
			<td width="3%" style="font-size:3pt">&nbsp;</td>
      <td colspan="2">
       	<div id="networkApplicationsDiv">
     		<%
		    	if(networkHosts.size() > 0) {
		    		NetworkHost networkHost = null;
		    		ArrayList networkHostApps = null;
		    		app = null;
		    		for(int i = 0; i < networkHosts.size(); i++) {
		    			networkHost = (NetworkHost)networkHosts.get(i);
		    			networkHostApps = networkHost.getNetworkApps();
		    %>
		    <table border="0" width="100%" cellspacing="0" cellpadding="0">
		    	<tr <%=i % 2 == 1 ? "class=\"STARTUP_TABLE_COLORED_ROW\"" : "" %>>
		    		<td width="5" class="STARTUP_BODY_TABLE_TEXT"><input type="checkbox" name="network<%=networkHost.getIndex() %>_check" id="network<%=networkHost.getIndex() %>_check" onClick="javascript:checkHost(<%=networkHost.getIndex() %>, this)" <%=networkHost.isSelected() ? "checked" : "" %>></td>
		    		<td width="500" class="STARTUP_BODY_TABLE_TEXT">Host: <%=networkHost.getHost() %>, OS Type: <%=networkHost.getOsType() %><%=!getAccountDetail(networkHost.getAccount(), "username").equals("") ? ", Username: " + getAccountDetail(networkHost.getAccount(), "username") : "" %></td>
		    		<td width="14" align="left" style="padding-right:5"><a id="showNetwork<%=networkHost.getIndex() %>Applications" href="javascript:hideShowHostApplications(<%=networkHost.getIndex() %>)" class="STARTUP_TABLE_TEXT_LINK">Hide</a></td>
		    	</tr>
		    	<tr>
		    		<td colspan="3">
		    		<div id="network<%=networkHost.getIndex() %>ApplicationsDiv">
		    			<table border="0" width="100%" cellspacing="0" cellpadding="0">
		    			<tr>
		    			<td>
		    <%
		    			if(networkHostApps.size() == 0) {
		    %>
		    			<table border="0" width="100%" cellspacing="0" cellpadding="0">
		    				<tr>
									<td width="4%"></td>
									<td width="90%"><span class="STARTUP_BODY_TABLE_TEXT">No applications were found</span></td>
									<td width="10"></td>
								</tr>
							</table>
		    <%
		    			}else {
		    %>
		    			<table border="0" width="100%" cellspacing="0" cellpadding="0">
		    <%
		    				for(int j = 0; j < networkHostApps.size(); j++) {
		    					app = (StartupApplication)networkHostApps.get(j);
		    					String checked = "";
		    					if(app.isCanBeExecuted()) {
		    						if(app.isSelected()) {
		    							checked ="checked";
		    						}
		    					}else {
		    						checked ="disabled";
		    					}
		    					String path = app.getPath(), tooltip = "";
		    					if(!app.isCanBeExecuted() || (app.getMessage() != null && !app.getMessage().equals(""))) {
		    						if(path == null || path.equals("")) {
		    							path = app.getMessage();
		    						}else {
		    							path = (app.getMessage() + ": " + path);
		    						}
		    					}
									if(path.length() > 50) {
										tooltip = path;
										path = path.substring(0, 50) + "...";
									}
		    %>
		    				<tr <%=j % 2 == 1 ? "class=\"STARTUP_TABLE_COLORED_ROW\"" : "" %>>
		    					<td width="4%"></td>
		    					<td width="30%"><input type="checkbox" name="network<%=networkHost.getIndex() %>_<%=app.getId() %>_check" id="network<%=networkHost.getIndex() %>_<%=app.getId() %>_check" onClick="javascript:checkNetworkApp(<%=networkHost.getIndex() %>, this)" <%=checked %> <%if(!app.isCanBeExecuted()) {%>disabled<%} %>><span class="STARTUP_BODY_TABLE_TEXT"><%=app.getName() %></span></td>
		    					<td width="60%" title="<%=tooltip %>"><span class="STARTUP_BODY_TABLE_TEXT"><%=path %></span></td>
		    					<td width="10"></td>
		    				</tr>
		    <%
		    				}
		    %>
		    			</table>
		    <%
		    			}
		    %>
		    
		    			<table border="0" width="100%" cellspacing="0" cellpadding="0">
		    				<tr>
									<td <%=(networkHostApps.size() > 0) ? "colspan=\"4\"": "colspan=\"3\"" %>>
										<div id="network<%=networkHost.getIndex() %>ManualApplicationsDiv"></div>
									</td>
								</tr>
		    			</table>
		    
		    			<table border="0" width="100%" cellspacing="0" cellpadding="0">
		    				<tr>
									<td width="4%"></td>
									<td <%=(networkHostApps.size() == 0) ? "": "colspan=\"2\"" %> width="90%" align="left" style="padding-left:5"><a id="addManualApp<%=networkHost.getIndex() %>" href="javascript:showHideAddApp(<%=networkHost.getIndex() %>)" class="STARTUP_TABLE_TEXT_LINK">Add Application Manually</a></td>
									<td width="6%"></td>
								</tr>
								
								<tr>
									<td width="4%"></td>
									<td <%=(networkHostApps.size() == 0) ? "colspan=\"3\"": "colspan=\"4\"" %> width="90%">
										<div id="add<%=networkHost.getIndex() %>AppDiv" style="display:none">
										  <table border="0" width="100%" cellspacing="0" cellpadding="0" width="100%" height="20">
										    <tr>
													<td>
										       	<table border="0" width="100%" cellspacing="0" cellpadding="0">
										       		<tr style="padding-top:5">
											          <td width="37%" style="padding-left:5">
											          	<span class="STARTUP_BODY_TABLE_TEXT">
											          	Application:
											          	<select name="appType<%=networkHost.getIndex() %>" id="appType<%=networkHost.getIndex() %>" class="TEXT_BOX" size="1">
											          	<%
											          	for(int k = 0; k < wizards.length; k++) {
											          		if(!wizards[k].getID().equals("win_event") && helper.isWizardSupportedByHost(networkHost, wizards[k])) {
											          	%>
											          		<option value="<%=wizards[k].getID()%>"><%=wizards[k].getName()%></option>
											          	<%
											          		}
											          	}
											          	%>
											          	</span>
											          </td>
											          <td width="50%" style="padding-left:5"><span class="STARTUP_BODY_TABLE_TEXT">Path:<input type="text" name="path<%=networkHost.getIndex() %>" id="path<%=networkHost.getIndex() %>" class="TEXT_BOX" size="40"></span></td>
											          <td width="13%"><span class="STARTUP_TABLE_LINK"><a id="add<%=networkHost.getIndex() %>AppLink" href="javascript:addApp(<%=networkHost.getIndex() %>)" class="STARTUP_TABLE_TEXT_LINK">Add</a></td>
										          </tr>
										        </table>
										     	</td>
										    </tr>
										    
										    <tr height="12">
						          		<td <%=(networkHostApps.size() == 0) ? "colspan=\"3\"": "colspan=\"4\"" %> style="padding-left:5">
							          		<div id="addAppMessageDiv<%=networkHost.getIndex() %>" style="display:none"></div>
							          	</td>
							          </tr>
											</table>
										</div>
									</td>
									<td width="6%"></td>
								</tr>
								
								</table>
								</td>
								</tr>
		    			</table>
		    		</div>
		    		</td>
		    	</tr>
		    </table>
		    <%
		    		}
		    	}
		    %>
		    </div>
     	</td>
     	<td width="3%" style="font-size:3pt">&nbsp;</td>
    </tr>
    <tr height="100%">
			<td width="3%"></td>
			<td width="550"></td>
			<td width="14"></td>
	  	<td width="3%"></td>
	  </tr>
  </table>
  </div>
  <div id="addHostDiv">
  <table border="0" width="100%" cellspacing="0" cellpadding="0" width="100%" height="<%=bottomHeightStr %>">
    <tr>
			<td width="3%" style="font-size:3pt">&nbsp;</td>
      <td>
       	<table border="0" width="100%" cellspacing="0" cellpadding="0">
       		<tr>
       			<td width="4%"></td>
         		<td width="15%" style="padding-left:24"><span class="STARTUP_BODY_TITLE_TEXT">Host</span></td>
       	 		<td width="18%" style="padding-left:18"><span class="STARTUP_BODY_TITLE_TEXT">OS Type</span></td>
       		 	<td width="15%" style="padding-left:24"><span class="STARTUP_BODY_TITLE_TEXT">Port</span></td>
         		<td width="15%" style="padding-left:8"><span class="STARTUP_BODY_TITLE_TEXT">Username</span></td>
         		<td width="15%" style="padding-left:8"><span class="STARTUP_BODY_TITLE_TEXT">Password</span></td>
         		<td width="13%" style="font-size:3pt">&nbsp;</td>
         		<td width="5%" style="font-size:3pt">&nbsp;</td>
     			</tr>
          <tr class="STARTUP_TABLE_HEADER">
	          <td width="4%" style="font-size:3pt">&nbsp;</td>
	          <td width="15%"><span class="STARTUP_BODY_TABLE_HEADER"><input type="text" name="host" id="host" class="TEXT_BOX" size="12" value="" onKeyPress="return doCheckAddHost(event)"></span></td>
	          <td width="18%">
	          	<span class="STARTUP_BODY_TABLE_HEADER">
	          	<select name="osType" id="osType" class="TEXT_BOX" onChange="javascript:changeOsType()" size="1">
	          		<%if (isWindows){%>
	          		<option value="windows">Windows</option>
	          		<%}%>
	          		<option value="unix">Unix based</option></select>
	          	</span>
	          </td>
	          <td width="15%"><span class="STARTUP_BODY_TABLE_HEADER"><input type="text" name="port" id="port" class="TEXT_BOX" <%if(isWindows) {%>readonly<%}else { %>value="22" <%} %> size="12"></span></td>
	          <td width="15%"><span class="STARTUP_BODY_TABLE_HEADER"><input type="text" name="username" id="username" class="TEXT_BOX" size="12" onKeyPress="return doCheckAddHost(event)"></span></td>
	          <td width="15%"><span class="STARTUP_BODY_TABLE_HEADER"><input type="password" name="password" id="password" class="TEXT_BOX" size="12" onKeyPress="return doCheckAddHost(event)"></span></td>
	          <td width="13%"><span class="STARTUP_TABLE_LINK"><a id="addHostLink" href="javascript:addHost()" class="STARTUP_TABLE_HEADER_LINK">Add Host</a></td>
	          <td width="5%" style="font-size:3pt">&nbsp;</td>
          </tr>
          <tr height="12">
          	<td colspan="8">
          	<div id="addHostMessageDiv" style="display:none"></div>
          	</td>
          </tr>
        </table>
     	</td>
     	<td width="3%" style="font-size:3pt">&nbsp;</td>
    </tr>
	</table>
	</div>
</td>