<%@ page language="java"%>

<%@ page import="java.text.*"%>
<%@page import="java.util.*"%>

<%@ page import="xpolog.config.*"%>
<%@page import="xpolog.eye.data.*"%>
<%@page import="xpolog.eye.data.filters.*"%>
<%@page import="xpolog.eye.data.masks.*"%>
<%@page import="xpolog.eye.error.*"%>
<%@page import="xpolog.eye.reports.health.ui.*"%>
<%@page import="xpolog.eye.site.startup.*"%>
<%@page import="xpolog.eye.site.startup.ui.*"%>

<%@ include file="../../tools/sandf/dateFilterAction.jsp"%>

<%!
	static final String BASE_DIRECTORY = "../../";
	String ERROR_OBJ = "ERROR_OBJ";
	String HEALTH_MODEL = "HealthViewModel";
%>

<%
	StartupUIController startupUIController = (StartupUIController)session.getAttribute(StartupUIController.STARTUP_UI_CONTROLLER_TYPE);
	String command = request.getParameter("command");
	
	if(startupUIController != null && command != null) {
		if(command.equals("back")	) {
			startupUIController.setPosition(2);
		}else if(command.equals("next")	) {
			StartupViewHelper helper = (StartupViewHelper)request.getSession().getAttribute(StartupViewHelper.STARTUP_HELPER_TYPE);
			if(helper != null) {
				ErrorModel errmodel = new ErrorModel();
				RecordMask mask = new RecordMask();
			  DateMask dateMask = new DateMask("MM/dd/yyyy HH:mm:ss");
			  MaskColumn[] cols = {dateMask};
			  mask.setColumns(cols);
			  FilterCollection fc = null;
			  //create the date and number filter
			  helper.setFilterCollection(null);
			  try {
			  	DateFilter dfilter = createDateFilter(request,response,mask);
			  	if(dfilter != null) {
				  	HealthViewModel model = new HealthViewModel();
			  		dfilter.setRoundMilliseconds(model.getMsToRound());
			  		dfilter.updateMinTime();
			  		fc = new FilterCollection();
			  		fc.setName("startup_fc");
				  	fc.setId(System.currentTimeMillis()+"_fc");
				  	fc.addFilter(dfilter);
				  	helper.setFilterCollection(fc);
				  	
				  	model.setTimeFilter(dfilter);
				  	request.getSession().setAttribute(HEALTH_MODEL,model);
			  	}
			  }catch(Exception e) {	  
				  errmodel.addError("Invalid time rule. Please make sure the time rule is valid and try again");
			  }
			  if(errmodel.getErrorCount() != 0){
			    request.getSession().setAttribute(ERROR_OBJ, errmodel);
			    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
			    return;
			  }else {
					startupUIController.setPosition(5);
			  }
			}
		}
	}

	response.sendRedirect("../startupTemplate.jsp");
%>
