<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.util.Constants"%>

<%
String BASE_DIRECTORY = request.getParameter("BASE_DIRECTORY");
String IMAGES_BASE_DIRECTORY = BASE_DIRECTORY + "images/startup/";

String heightStr = request.getParameter("height");
%>

<script>
var createDashboardXmlHttp;
function createDashboard() {
	createDashboardXmlHttp = getXmlHttpObject();
 	if (createDashboardXmlHttp == null) {
	  return;
	}
	var url = "steps/createDashboard.jsp";
	createDashboardXmlHttp.onreadystatechange = function() {
	}
	createDashboardXmlHttp.open("GET", url, true);
	createDashboardXmlHttp.send(null);
	setTimeout('updateStatus()', 500);
}

var updateStatusXmlHttp;
function updateStatus() {
	var finished = "false";
	updateStatusXmlHttp = getXmlHttpObject();
 	if (updateStatusXmlHttp == null) {
	  return;
	}
	var url = "steps/updateStep5Status.jsp";
	updateStatusXmlHttp.onreadystatechange = function() {
		if(updateStatusXmlHttp.readyState == 4) {
			if(updateStatusXmlHttp.status == 200) {
				if(updateStatusXmlHttp.responseXML) {
					var xmlDoc = updateStatusXmlHttp.responseXML.documentElement;
					var statusElement = xmlDoc.getElementsByTagName("status")[0];
					finished = statusElement.getAttribute("finished");
					var progressStatusElement = xmlDoc.getElementsByTagName("progressStatus")[0];
					var currentApplication = progressStatusElement.getAttribute("currentApplication");
					var currentHost = progressStatusElement.getAttribute("currentHost");
					var numberOfAppsReportsCreated = progressStatusElement.getAttribute("numberOfAppsReportsCreated");
					var numberOfCurrentAppReportsGenerated = progressStatusElement.getAttribute("numberOfCurrentAppReportsGenerated");
					var numberOfCurrentAppReportsCreated = progressStatusElement.getAttribute("numberOfCurrentAppReportsCreated");
					var numberOfSelectedApps = progressStatusElement.getAttribute("numberOfSelectedApps");
					var reportsGenerationFinished = progressStatusElement.getAttribute("reportsGenerationFinished");
					var systemHelthStatus = progressStatusElement.getAttribute("systemHelthStatus");
					var systemHealthExecutionPercent = progressStatusElement.getAttribute("systemHealthPercent");
					if(numberOfSelectedApps > 0) {
						var percentage = (numberOfAppsReportsCreated / numberOfSelectedApps) * 100;
						percentage /= 2;
						var innerPercentage = 0;
						if(numberOfCurrentAppReportsCreated > 0) {
							innerPercentage = (numberOfCurrentAppReportsGenerated / numberOfCurrentAppReportsCreated) * 100;
							innerPercentage /= (2 * numberOfSelectedApps);
						}
						percentage += innerPercentage;
						var message = "";
						if(reportsGenerationFinished == "false") {
							if(numberOfCurrentAppReportsGenerated < numberOfCurrentAppReportsCreated) {
								numberOfCurrentAppReportsGenerated = (parseInt(numberOfCurrentAppReportsGenerated) + 1);
							}
							if(numberOfAppsReportsCreated < numberOfSelectedApps) {
								numberOfAppsReportsCreated = (parseInt(numberOfAppsReportsCreated) + 1);
							}
							var hostStr = "";
							if(currentHost != "") {	
								hostStr = " of host " + currentHost + " ";
							}
							message = "Generating data of report " + numberOfCurrentAppReportsGenerated + " out of " + numberOfCurrentAppReportsCreated + " of " + currentApplication + hostStr + " (" + numberOfAppsReportsCreated + " out of " + numberOfSelectedApps + ")";
						}else {
							if(percentage > 0) {
								percentage = 50 + (systemHealthExecutionPercent/2);
								message = systemHelthStatus;
							}
						}
						updateProgress(percentage, message);
						if(finished == "false") {
							setTimeout("updateStatus()", 1000);
						}else {
							document.access.command.value = "next";
							document.access.submit();
						}
					}else {
						if(finished == "false") {
							setTimeout("updateStatus()", 1000);
						}else {
							document.getElementById("progressBar").width = "100%";
							document.access.command.value = "next";
							document.access.submit();
						}
					}
				}
			}else {
				document.getElementById("progressBar").width = "100%";
				document.access.command.value = "next";
				document.access.submit();
			}
		}
	}
	updateStatusXmlHttp.open("GET", url, true);
	updateStatusXmlHttp.send(null);
}
</script>

<script>createDashboard()</script>

<td align="center" valign="top">
	<div id="scroller" style="overflow:auto; width:100%; height:<%=heightStr %>;"> 
	<table border="0" width="100%" cellspacing="0" cellpadding="0">
		<tr style="padding-top:5">
			<td width="3%">&nbsp;</td>
			<%
			String text = "Xpolog Center is now generating data for " + Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME) + " . This may take a couple of minutes...";
			boolean isDashboardValid = SiteManagment.getInstance().getXpologManagment().isDashboardValidAndComponentExists();
			if(!isDashboardValid) {
				text = "Xpolog Center is now generating reports data. This may take a couple of minutes...";
			}
			%>
			
			<td align="left" class="STARTUP_BODY_TITLE_TEXT"><%=text %></td>
		</tr>
	</table>
	<table border="0" width="100%" height="8" cellspacing="0" cellpadding="0">
		<tr>
			<td></td>
		</tr>
	</table>
	<table border="0" width="100%" cellspacing="0" cellpadding="0" style="padding-top:1;padding-left:1;padding-right:1">
		<tr>
			<td width="3%">&nbsp;</td>
			<td id="progressWrapper" width="209" background="<%=IMAGES_BASE_DIRECTORY %>progressBackground.gif" style="width:209;background-repeat:no-repeat">
				<table border="0" width="209" height="100%" cellspacing="0" cellpadding="0" style="padding-top:1;padding-left:1;padding-right:1">
					<tr>
						<td id="progressBar" background="<%=IMAGES_BASE_DIRECTORY %>progressBar.gif" style="background-repeat:repeat-x;display:none">&nbsp;</td>
						<td id="progressBackground" width="209"></td>
					</tr>
				</table>
			</td>
			<td width="*">&nbsp;</td>
		</tr>
		<tr>
			<td width="3%">&nbsp;</td>
			<td id="progressText" colspan="2" class="STARTUP_BODY_PROGRESS_TEXT"></td>
		</tr>
	</table>
	</div>
</td>
