<%@ page language="java"%>

<%@ page import="xpolog.eye.site.startup.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
	
	private String buildStatusXml(StartupViewHelper helper) {
		StringBuffer xml = new StringBuffer();
		int numberOfNetworkAppsToDetect = helper.getNumberOfNetworkAppsToDetect();
		int numberOfNetworkAppsCompleted = helper.getNumberOfNetworkAppsCompleted();
		int numberOfNetworkAppsFound = helper.getNumberOfNetworkAppsFound();
		
		xml.append("<process>");
		xml.append("<status finished=\"");
		if(helper.isStopped()) {
			xml.append("true");
		}else {
			xml.append(helper.isNetworkDetectionCompleted());
		}
		xml.append("\"/>");
		xml.append("<progressStatus numberOfNetworkAppsToDetect=\"");
		xml.append(numberOfNetworkAppsToDetect);
		xml.append("\" numberOfNetworkAppsCompleted=\"");
		xml.append(numberOfNetworkAppsCompleted);		
		xml.append("\" numberOfNetworkAppsFound=\"");
		xml.append(numberOfNetworkAppsFound);		
		xml.append("\"/>");
		xml.append("</process>");
		
		return xml.toString();
	}
	
	private String buildErrorXml(String error) {
		StringBuffer xml = new StringBuffer();
		
		xml.append("<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">");
		xml.append("<tr>");
		xml.append("<td width=\"3%\"></td>");
		xml.append("<td width=\"60%\"><span class=\"STARTUP_BODY_TABLE_TEXT\">");
		xml.append(error);
		xml.append("</span></td>");
		xml.append("<td width=\"37%\"></td>");
		xml.append("</tr>");
		xml.append("</table>");
		
		return xml.toString();
	}
%>

<%
	Object obj = request.getSession().getAttribute(StartupViewHelper.STARTUP_HELPER_TYPE);
	StartupViewHelper helper = null;
	if(obj != null) {
		helper = (StartupViewHelper)obj;
	}
	String xml = null;
	
	if(helper != null) {
		xml = buildStatusXml(helper);
	}else {
		xml = buildErrorXml("An error occured while detecting network applications");
	}
	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	out.write(xml);
	out.flush();
%>
