<%@page import="xpolog.eye.error.ErrorModel"%>
<%@page import="xpolog.config.Configuration"%>
<%@page import="xpolog.eye.media.AddressBook"%>
<%@page import="xpolog.eye.util.crypto.DataEncryptionFactory"%>
<%@page import="xpolog.eye.util.crypto.DataEncryptionImpl"%>
<%@page import="xpolog.eye.util.crypto.DataEncryption"%>
<%@ page language="java"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
	String ERROR_OBJ = "ERROR_OBJ";

	ErrorModel errmodel = new ErrorModel(); 
	String algKey = request.getParameter("algKey");
	if(algKey == null || algKey.length() == 0){
		algKey = "";
	}
	String algCipher = request.getParameter("algCipher");
	if(algCipher == null || algCipher.length() == 0){
		algCipher = "";
	}
	String algLength = request.getParameter("algLength");
	if(algLength == null || algLength.length() == 0 ){
		algLength = "-1";
	}
	int algLen = -1 ;
	try{
		algLen = Integer.parseInt(algLength);
	}catch(NumberFormatException e){
		errmodel.addError("Please check your algorithm length.");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY+"common/errorpage.jsp");
    return;
	}
	String algPath = request.getParameter("algPath");
	if(algPath == null || algPath.length() == 0){
		algPath = "";
	}
  DataEncryption dataEnc = DataEncryptionFactory.getInstance().getDataEncription();
	DataEncryptionImpl dataEncImpl =  null;
	if(dataEnc != null && dataEnc instanceof DataEncryptionImpl){
	 dataEncImpl = (DataEncryptionImpl)dataEnc;
	}
	if(dataEncImpl == null || (algKey.equals(dataEncImpl.getKeyAlg()) && algLen == dataEncImpl.getAlgLength() && algPath.equals(dataEncImpl.getKeyPath()) && algCipher.equals(dataEncImpl.getCipherAlg()))){
		
	}else{
		AddressBook adb = AddressBook.getInstance();
		String oldKey = dataEncImpl.getKeyAlg();
		String oldCipher = dataEncImpl.getCipherAlg();
		String oldPath = dataEncImpl.getKeyPath();
		int oldLen = dataEncImpl.getAlgLength();
		dataEncImpl.setAlgLength(algLen);
		if(algKey.length() > 0){
			dataEncImpl.setKeyAlg(algKey);
		}
		if(algCipher.length() > 0){
			dataEncImpl.setCipherAlg(algCipher);
		}
		if(algPath.length() > 0 ){
			dataEncImpl.setKeyPath(algPath);
		}	
		String msg = dataEncImpl.reset();
		if(msg.length() > 0){
			dataEncImpl.setAlgLength(oldLen);
			dataEncImpl.setCipherAlg(oldCipher);
			dataEncImpl.setKeyAlg(oldKey);
			dataEncImpl.setKeyPath(oldPath);
			DataEncryptionFactory.getInstance().setDataEncryption(dataEncImpl);
			errmodel.addError("Failed to save new key : " + msg);
	    request.getSession().setAttribute(ERROR_OBJ,errmodel);
	    response.sendRedirect(BASE_DIRECTORY+"common/errorpage.jsp");
	    return;
		}
		DataEncryptionFactory.getInstance().setDataEncryption(dataEncImpl);
		Configuration.getInstance().saveConfiguration();
		
		adb.saveAddressBook();				
	}
	response.sendRedirect(BASE_DIRECTORY + "common/opok.jsp?okUrl=support/advanced/index.jsp");
	
%>
