<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.PropertyManager"%>
<%@ page import="java.util.List"%>
<%@ page import="xpolog.config.Configuration"%>

<%!static final String BASE_DIRECTORY = "../../";%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, null, true)) {
		return;
	}
	
  PropertyManager propMgr = Configuration.getInstance().getPropertiesManager();
  if(propMgr == null){
  	return;
  }
  String newValue = "";
  List l = propMgr.getAllPropertiesKys();
  boolean foundNewValue = false;
  for(int i = 0 ; l != null && i < l.size() ; i++){
  	newValue = request.getParameter("newValue_" + i);
  	if(newValue != null && newValue.length() > 0){
  		String key = (String)l.get(i);
  		if(key != null && key.length() > 0){
  			String previousValue = propMgr.getProperty(key);
  			if(!previousValue.equals(newValue)) {
		  		propMgr.setUserProperty(key,newValue);
		  		foundNewValue = true;
  			}
  		}
  	}
  }
  if(foundNewValue) {
    propMgr.saveProperties();  	
  }
  String msg = "Operation ended successfully.<br>" + 
							 "<b>Note: you must restart XpoLog in order for the changes to take effect.</b>";
  response.sendRedirect(BASE_DIRECTORY + "common/opok.jsp?okUrl=support/advanced/index.jsp&message=" + msg);
  
%>

