<%@ page language="java"%>

<%@page import="xpolog.eye.util.resource.ThreadsResourceLimitation"%>
<%@page import="xpolog.eye.util.resource.ResourceLimitation"%>
<%@page import="java.util.HashMap"%>
<%@page import="xpolog.eye.util.resource.ResourceManager"%>

<%!
	 String BASE_DIR = ".././";
%>

<%
	String result = "";
	String TYPE = "type";
	String type = request.getParameter(TYPE);
	if (type == null) {
		type = "";
	}
	String CONSUMER = "consumer";
	String consumer = request.getParameter(CONSUMER);
	if (consumer == null) {
		consumer = "";
	}
	String RUNNER_NODE = "runnerNode";
	String runnerNode = request.getParameter(RUNNER_NODE);
	if (runnerNode == null) {
		runnerNode = "";
	}
	String HOSTS = "hosts";
	String hosts = request.getParameter(HOSTS);
	if (hosts == null) {
		hosts = "";
	}
	String NEW_HOSTS = "newHosts";
	String newHosts = request.getParameter(NEW_HOSTS);
	if (newHosts == null) {
		newHosts = "";
	}
	if(newHosts.equals("*")){	
		result = "Cancel*Illegal host name.\n";
	}
	int maxThreads = 1;
	int maxThreadsPerHost = 1;
	String MAX_THREADS = "maxThreads";
	String maxThreadsStr = request.getParameter(MAX_THREADS);
	if (maxThreadsStr == null || maxThreadsStr.equals("")) {
		maxThreadsStr = "1";
	}
	String MAX_THREADS_PER_HOST = "maxThreadsPerHost";
	String maxThreadsPerHostStr = request.getParameter(MAX_THREADS_PER_HOST);
	if (maxThreadsPerHostStr == null || maxThreadsPerHostStr.equals("")) {
		maxThreadsPerHostStr = "1";
	}
	try{
		maxThreads = Integer.parseInt(maxThreadsStr.trim());		
	}catch(Exception e){
		result += "Cancel*Max threads value is ilegal.\n";
	}
	try{
		maxThreadsPerHost = Integer.parseInt(maxThreadsPerHostStr.trim());		
	}catch(Exception e){
		result += "Cancel*Max threads per host value is ilegal.\n";
	}
	if(maxThreadsPerHost > maxThreads) {
		result += "Cancel*Max threads per host value cannot be greater than max threads.\n";
	}
	
	
	ResourceManager resourceMgr = ResourceManager.getInstance();
	if(resourceMgr == null ){
		result += "Cancel*Could not load resource manager!.\n";
	}else {
		String key = type + "*;*" + consumer;
		ResourceLimitation resLimitation = null;
		boolean ok = true;
		if(hosts != null && hosts.length() > 0) {
			resLimitation = resourceMgr.getResourceLimitation(key);
			if(resLimitation != null && resLimitation instanceof ThreadsResourceLimitation){
				ThreadsResourceLimitation threadResLimitation = (ThreadsResourceLimitation)resLimitation;
				if(maxThreads > threadResLimitation.getMaxNumberOfThreads()) {
					result += "Cancel*Max threads value cannot be greater than default max threads.\n";
					ok = false;
				}
			}
		}
		if(ok) {
			HashMap resourcesMap = new HashMap();
		
			//resources with host.
			if(result.length() == 0){
				if(hosts.length() > 0 && resourceMgr.getHostsResourceLimitations() != null){
					resourcesMap = (HashMap)resourceMgr.getHostsResourceLimitations().get(hosts);		
					if(resourcesMap != null){
						resLimitation = (ResourceLimitation)resourcesMap.get(key);
						if(resLimitation != null && resLimitation instanceof ThreadsResourceLimitation){
							ThreadsResourceLimitation threadResLimitation = (ThreadsResourceLimitation)resLimitation;
							if(threadResLimitation != null){			
									threadResLimitation.setMaxNumberOfThreads(maxThreads);
									threadResLimitation.setMaxNumberOfThreadsPerHost(maxThreadsPerHost);
									threadResLimitation.setRunnerNode(runnerNode);
								//change host and data
								if(newHosts.length() > 0 && !newHosts.equals(hosts)){
									threadResLimitation.setHost(newHosts);
									resourceMgr.getHostsResourceLimitations().put(newHosts,resourcesMap);
									resourceMgr.getHostsResourceLimitations().remove(hosts);
									//change data for host
								}else{
									resourcesMap.put(key,threadResLimitation);
									resourceMgr.getHostsResourceLimitations().put(hosts,resourcesMap);
								}
							}
						}
					}
				//resource without host	
				}else if(resourceMgr.getResourceLimitations() != null){
					resourcesMap = resourceMgr.getResourceLimitations();
					if(resourcesMap != null){
						resLimitation = (ResourceLimitation)resourcesMap.get(key);
						if(resLimitation != null && resLimitation instanceof ThreadsResourceLimitation){
							ThreadsResourceLimitation threadResLimitation = (ThreadsResourceLimitation)resLimitation;
							if(threadResLimitation != null){										
								threadResLimitation.setMaxNumberOfThreads(maxThreads);
								threadResLimitation.setMaxNumberOfThreadsPerHost(maxThreadsPerHost);
								threadResLimitation.setRunnerNode(runnerNode);
								//add host
								if(newHosts.length() > 0){
									threadResLimitation.setHost(newHosts);
								}
								resourcesMap.put(key,threadResLimitation);
							}
						}
					}					
				}
			
				boolean suc =  resourceMgr.save();
				if(!suc){
					result += "Cancel*Failed to save changes!\n";
				}
			}
		}
	}
	
	response.setContentType("text/xml");
	out.write(result.length() == 0 ? "OK" : result);
	out.flush();

%>
