<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.PropertyManager"%>
<%@ page import="xpolog.eye.util.WebUtil"%>
<%@ page import="java.util.List"%>
<%@ page import="xpolog.config.Configuration"%>
<%@page import="java.io.File"%>
<%@page import="java.util.HashSet"%>
<%@page import="xpolog.eye.util.XMLUtil"%>
<%@page import="org.w3c.dom.Element"%>
<%@page import="org.w3c.dom.Document"%>
<%@page import="xpolog.eye.media.AddressBook"%>
<%@page import="xpolog.eye.media.Account"%>
<%@page import="java.util.ArrayList"%>

<%!static final String BASE_DIRECTORY = "../../";%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, null, true)) {
		return;
	}
  File logsDir = new File(Configuration.XPOLOG_ROOT_PATH + "conf/logsconf");
  File [] logs = logsDir.listFiles();
  HashSet accountsSet = new HashSet();
  if (logs != null){
    for(int i = 0; i < logs.length;i++){
    	if (logs[i].isFile()){
          try {
            Document doc = XMLUtil.parseXML(logs[i].getAbsolutePath());
            if (doc != null){
              Element elem =  doc.getDocumentElement();
              if (elem != null){
                 List accounts = XMLUtil.getElementsByTagName(elem,"Account");
                 for (int j = 0; j < accounts.size();j++){
                   Element e = (Element)accounts.get(j);
                   String id = XMLUtil.getAttribute(e,"id",null);
                   if (id != null){
                    accountsSet.add(id); 
                   }
                 }
              }
            }
          }catch (Exception e){
            e.printStackTrace(); 
          }
      }
    }
  }
  AddressBook address = AddressBook.getInstance();
  List list = address.getAllAccountList();
  int numOfHosts = 0;
  List unusedAccounts = new ArrayList();
  for (int i = 0; i < list.size();i++){
    Account acc = (Account)list.get(i);
    if (acc.getHost() == null){
      continue; 
    }
    numOfHosts++;
    if (!accountsSet.contains(acc.getId())){
    	unusedAccounts.add(acc);
    }
  }
%>

<script>
function doRemove(){
 document.access.submit(); 
}
</script>
<form name="access" method="post" action="unusedAccountsAction.jsp">
<table border="0" width="100%" cellspacing="0" height="100%"	cellpadding="0">
	<tr>
		<td>&nbsp;</td>
	</tr>
	<tr>
		<td width="100%">
		<table border="0" width="100%" cellspacing="0" cellpadding="0" height="450px"	>
			<tr>
				<td>
				<table border="0" cellpadding="0" cellspacing="0"
					style="border-collapse: collapse" width="100%" id="AutoNumber1">
					<tr>
						<td width="100%">
						<table border="0" cellpadding="0" cellspacing="0"	width="100%" id="AutoNumber2">
							<tr>
								<td width="15%" height="28" colspan="3"><span	class="HEADER">Unused accounts</span></td>
							</tr>		
              <tr>
                <td> <span class="REGULARTEXT"><b>Number of accounts hosts = <%=numOfHosts %></b></span>       		</td>
              </tr>                  
							<tr>
								<td>&nbsp;</td>
							</tr>
							<tr>
								<td width="100%">
								<table border="0" cellpadding="0" cellspacing="0"	width="100%" id="AutoNumber2">
									<tr class="TABLES_HEADERS">
										<td width="20">&nbsp;</td>
                    <td width="20">&nbsp;</td>
										<td width="300"><span class="REGULARTEXT"><b>id</b></span></td>
										<td width="300"><span class="REGULARTEXT"><b>name</b></span></td>
										<td width="*">&nbsp;</td>										
									</tr>
								</table>
								</td>
							</tr>
							<tr>
								<td>&nbsp;</td>
							</tr>		
							<%for(int i = 0 ; unusedAccounts != null && i < unusedAccounts.size() ; i ++){
                Account acc = (Account)unusedAccounts.get(i);
								String id = acc.getId();
								String name = acc.getAccountName();
								//value = value.replaceAll("<","&lt;").replaceAll(">","&gt;");
								//value = value.replace(/\\&/g, '&amp;').replace(/\\</g, '&lt;').replace(/\\>/g, '&gt;').replace(/\\t/g, '&nbsp;&nbsp;&nbsp;').replace(/\\n/g, '<br />');
								name = WebUtil.doHTMLEncoding(name);
								
							%>						
							<tr>
								<td width="100%">
								<table border="0" cellpadding="0" cellspacing="0"	width="100%" id="AutoNumber2">
									<tr>
										<td width="20">&nbsp;</td>
                    <td width="20"><input type="checkbox" name="accounts" value="<%=id%>" checked></input></td>
										<td width="300"><span class="REGULARTEXT"><%=id%></span></td>
										<td width="300"><span class="REGULARTEXT"><%=name%></span></td>
										<td width="*">&nbsp;</td>	
									</tr>
								</table>
								</td>
							</tr>
							<tr>
								<td>&nbsp;</td>
							</tr>		
							<%}%>
						</table>
						</td>
					</tr>
				</table>
				</td>
			</tr>
			<tr>
				<td width="100%" height="100%">&nbsp;</td>
			</tr>	
		</table>
		</td>
	</tr>
	<tr>
		<td width="100%" height="100%">&nbsp;</td>
	</tr>	
	<tr>
		<td width="100%">
		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
			<tr>
				<td width="40%%">&nbsp;</td>
				<td width="10%" align="center"><a href="javascript:doRemove()"	class="LINK">remove selected</a></td>
				<td width="40%">&nbsp;</td>
			</tr>
		</table>
		</td>
	</tr>
	
</table>
</form>















