<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%!static final String BASE_DIRECTORY = "../../";%>
<%

String baseDirectory = request.getParameter("baseDirectory");
if (baseDirectory == null){
   baseDirectory = BASE_DIRECTORY;
}
	
String suffix = "_properties";

boolean showMenu = true;
if(showMenu) {
	String menuIds = "propertyEdit,propertyReset";
	String menuTexts = "Edit,Reset";
	String menuHrefs = "javascript:propertyEdit(),javascript:propertyReset()";
%>
<jsp:include page="../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
		</jsp:include>

	<jsp:include page="../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	 <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	</jsp:include>
<%
}
%>
<script>
function propertyEdit(){
   var id = mygrid_properties.getSelectedRowId();
      if (id == "") {
         return;
      }
   var key = mygrid_properties.cells(id,0).getValue();
   var customVal = mygrid_properties.getUserData(key, "customValue");
   var defaultVal = mygrid_properties.getUserData(key, "defaultValue");
   if (key && document.getElementById("propertyEditKeySpan")){
	   document.getElementById("propertyEditKey").value = key;
	   document.getElementById("propertyEditKeySpan").innerHTML = key;
   }
   if (document.getElementById("propertyNewValue")){
	   document.getElementById("propertyNewValue").value = customVal;
   }
   if (defaultVal && document.getElementById("propertyDefaultValue")){     
	   document.getElementById("propertyDefaultValue").value = defaultVal;
   }   
   showGeneralAdminDiv("editProperty",150,100);
   document.getElementById("propertyNewValue").focus();

}

function hideEdit(){
	showGeneralAdminDiv('editProperty'); 
}

function saveProperty(){
	  var key = document.getElementById("propertyEditKey").value;
	  var newValue = document.getElementById("propertyNewValue").value; 
	  hideEdit();
    if (key){
      showMessage("Properties","mygrid_properties","Saving",200,60);
      workingSupportData("_properties",baseDirectory + "support/advancedSettings/propertiesActions.jsp","action=save&propertyIds=" + key + "&value=" + newValue + "&timestamp=" + new Date().getTime());
    }
  }


function propertyReset(){
     var id = mygrid_properties.getSelectedRowId();
        if (id == "") {
           return;
        }
        if (id.indexOf(",") >= 0){
          doPropertyMembersReset(id,id);
          return;
        }
        resetMemberProperty(id);
  }

  function doPropertyMembersReset(id){
     showActionMessage("Properties Reset Action","mygrid_properties","doResetProperty('" + id + "','" +  id + "')","<nobr>Are you sure you want to reset all selected properties</nobr>" + "?");   
    }

    function resetMemberProperty(id){
      var name = mygrid_properties.cells(id,0).getValue();
      showActionMessage("Properties Reset Action","mygrid_properties","doResetProperty('" + id + "','" +  id + "')","<nobr>Are you sure you want to reset property </nobr>" + name + "?");   
    }

    function doResetProperty(row,id){
      showMessage("Properties","mygrid_properties","Reset",200,60);
      workingSupportData("_properties",baseDirectory + "support/advancedSettings/propertiesActions.jsp","action=reset&propertyIds=" + id + "&timestamp=" + new Date().getTime());
    }


function handleMenuItems_properties(){
  aMenu_properties.menu.showButtons("propertyEdit");
  aMenu_properties.menu.showButtons("propertyReset");	
}

function refreshSupportTable_properties(){
	disableActionButton("propertEdit");
	disableActionButton("propertReset");
	updateTable_properties();  
}

		
	function refreshPropertiesInfo(){
		var t = applicationTabs.tabs[applicationTabs.selectedTabIndex];
		if (t && t.id == "Properties"){
			updateTable_properties();
		}
	}

	initMenus<%=suffix %>();
</script>
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
		<tr valign="top">
			<td width="100%">
      <jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
      <jsp:param name="baseDirectory" value="<%=baseDirectory%>"/> 
      <jsp:param name="title" value="Property Edit"/> 
      <jsp:param name="suffix" value="editProperty"/> 
      <jsp:param name="includePath" value="support/advancedSettings/propertyEdit.jsp"/>      
      <jsp:param name="width" value="600px"/> 
      <jsp:param name="height" value="200px"/>
      <jsp:param name="zIndex" value="300"/>  
      <jsp:param name="actionsNames" value="Save#Cancel"/> 
      <jsp:param name="actions" value="javascript:saveProperty()#javascript:hideEdit()"/> 
      </jsp:include>
			<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
				<tr>
					<td valign="top" height="100%" style="padding-top:10px">
					<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              								
						<tr height="*">
							<td valign="top"> 
							<% 
							String tableNames = "Edit#Reset";
							String tableActions = "javascript:propertyEdit()#javascript:propertyReset()";
							String ids = "propertyTableEdit#propertyTableReset";
							String selectTypes = "2#3";
              
							String initXML = "support/advancedSettings/propertiesViewXML.jsp?suffix=properties&baseDirectory=" + baseDirectory;
							String updateXML = "support/advancedSettings/propertiesViewXML.jsp?suffix=properties&dataOnly=true&baseDirectory=" + baseDirectory;
              String menu = showMenu ? "aMenu_properties" : "";
							%>                               
							<jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />								
							<jsp:param name="initXML" value="<%=initXML%>" />	
							<jsp:param name="updateXML" value="<%=updateXML%>" />																		
							<jsp:param name="menu" value="<%=menu%>" />
							<jsp:param name="suffix" value="<%=suffix %>" />
							<jsp:param name="recordsText" value="Properties" />
							<jsp:param name="style" value="main" />
							<jsp:param name="height" value="100%" />
							<jsp:param name="autoHeight" value="-1" />
							<jsp:param name="rowsNumPerPage" value="-1" />
							<jsp:param name="multiline" value="true" />
              <jsp:param name="tableActionNames" value="<%=tableNames%>" />
              <jsp:param name="tableActions" value="<%=tableActions%>" />
              <jsp:param name="tableActionIds" value="<%=ids%>" />
              <jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
							</jsp:include>													
							</td>
						</tr>								
					</table>
					</td>
				</tr>
			</table>
			</td>
		</tr>
	</table>		
