
<%@page import="xpolog.eye.util.resource.ThreadsResourceLimitation"%>
<%@page import="xpolog.eye.util.resource.ResourceLimitation"%>
<%@page import="xpolog.eye.util.resource.ResourceManager"%>
<%@page import="xpolog.eye.XpoLogObjectTypes"%><%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@page import="xpolog.eye.system.XpoLogSystemProcess"%>
<%@page import="xpolog.eye.audit.event.ProcessSystemAuditEvent"%>
<%@page import="xpolog.eye.system.XpoLogSystemProcessInfo"%>
<%@page import="xpolog.eye.system.XpoLogSystemMnager"%>
<%@page import="xpolog.eye.audit.AuditConstants"%>
<%@page import="xpolog.eye.audit.AuditManager"%>
<%@page import="xpolog.eye.SiteManagment"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@page import="xpolog.eye.error.ErrorModel"%>

<%!static final String BASE_DIRECTORY = "../../";
	static final String DELIMITER = ",";%>
<%
	if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)) {
		return;
	}
	UserContext userContext = UserEnvironment.getUserContext(request);
	boolean success = true;
	String message = "";
	String childrenIdsList = null;
	String action = request.getParameter("action");
	String isDefaultStr = request.getParameter("isDefault");
  boolean isDefault = isDefaultStr != null && isDefaultStr.equals("true");
   
	String hosts = request.getParameter("hosts");
	if (hosts == null || hosts.equals("")) {
		hosts = "";
	}
  
	String newHosts = request.getParameter("newHosts");
	if (newHosts == null || newHosts.equals("")) {
		newHosts = "";
	}
  if (!isDefault && newHosts.equals("*")){
    success = false;
    message += "Illegal host name.\n";
  }

	String type = "THREADS";
	String consumer = request.getParameter("consumer");
	if (consumer == null || consumer.equals("")) {
		consumer = "";
	}
  
	String runnerNode = request.getParameter("runnerNode");
	if(runnerNode == null) {
		runnerNode = "";
	}
  
	int maxThreads = 1;
	int maxThreadsPerHost = 1;
	String maxThreadsStr = request.getParameter("maxThreads");
	if (maxThreadsStr == null || maxThreadsStr.equals("")) {
		maxThreadsStr = "1";
	}
	String maxThreadsPerHostStr = request.getParameter("maxThreadsPerHost");
	if (maxThreadsPerHostStr == null || maxThreadsPerHostStr.equals("")) {
		maxThreadsPerHostStr = "1";
	}
  
	try{
		maxThreads = Integer.parseInt(maxThreadsStr.trim());		
	}catch(Exception e){
    success = false;
		message += "Max threads value is ilegal.\n";
	}
	try{
		maxThreadsPerHost = Integer.parseInt(maxThreadsPerHostStr.trim());		
	}catch(Exception e){
		success = false;
		message += "Max threads per host value is ilegal.\n";
	}
	if(maxThreadsPerHost > maxThreads) {
		success = false;
		message += "Max threads per host value cannot be greater than max threads.\n";
	}
	ResourceManager resourceMgr = ResourceManager.getInstance();
	if (success) {
		if (action.equalsIgnoreCase("save")) {
			String key = type + "*;*" + consumer;
			ResourceLimitation resLimitation = null;
      try {
			if(hosts != null && hosts.length() > 0) {
				resLimitation = resourceMgr.getResourceLimitation(key);
				if(resLimitation != null && resLimitation instanceof ThreadsResourceLimitation){
					ThreadsResourceLimitation threadResLimitation = (ThreadsResourceLimitation)resLimitation;
					if(maxThreads > threadResLimitation.getMaxNumberOfThreads()) {
						message += "Max threads value cannot be greater than default max threads.\n";
						success = false;
					}
				}
			}
			if(success) {
				HashMap resourcesMap = new HashMap();
			
				//resources with host.
				if(success){
					if(hosts.length() > 0 && resourceMgr.getHostsResourceLimitations() != null){
						resourcesMap = (HashMap)resourceMgr.getHostsResourceLimitations().get(hosts);		
						if(resourcesMap != null){
							resLimitation = (ResourceLimitation)resourcesMap.get(key);
							if(resLimitation != null && resLimitation instanceof ThreadsResourceLimitation){
								ThreadsResourceLimitation threadResLimitation = (ThreadsResourceLimitation)resLimitation;
								if(threadResLimitation != null){			
										threadResLimitation.setMaxNumberOfThreads(maxThreads);
										threadResLimitation.setMaxNumberOfThreadsPerHost(maxThreadsPerHost);
										threadResLimitation.setRunnerNode(runnerNode);
									//change host and data
									if(newHosts.length() > 0 && !newHosts.equals(hosts)){
										threadResLimitation.setHost(newHosts);
										resourceMgr.getHostsResourceLimitations().put(newHosts,resourcesMap);
										resourceMgr.getHostsResourceLimitations().remove(hosts);
										//change data for host
									}else{
										resourcesMap.put(key,threadResLimitation);
										resourceMgr.getHostsResourceLimitations().put(hosts,resourcesMap);
									}
								}
							}
						}
					//resource without host	
					}else if(resourceMgr.getResourceLimitations() != null){
						resourcesMap = resourceMgr.getResourceLimitations();
						if(resourcesMap != null){
							resLimitation = (ResourceLimitation)resourcesMap.get(key);
							if(resLimitation != null && resLimitation instanceof ThreadsResourceLimitation){
								ThreadsResourceLimitation threadResLimitation = (ThreadsResourceLimitation)resLimitation;
								if(threadResLimitation != null){										
									threadResLimitation.setMaxNumberOfThreads(maxThreads);
									threadResLimitation.setMaxNumberOfThreadsPerHost(maxThreadsPerHost);
									threadResLimitation.setRunnerNode(runnerNode);
									//add host
									if(newHosts.length() > 0){
										threadResLimitation.setHost(newHosts);
									}
									resourcesMap.put(key,threadResLimitation);
								}
							}
						}					
					}
				
					boolean suc =  resourceMgr.save();
					if(!suc){
            success = false;
						message += "Failed to save changes!<br>";
					}
				}
			}
      }catch (Exception e){
    	  ErrorModel.log.error("Failed to save resource  " + key, e);
			  success = false;
			  message = e.getMessage();
      }
		} else if (action.equalsIgnoreCase("delete")) {
      if (!isDefault){
			  String id = type + "*;*" + consumer;
			  try {				
				  if(hosts.length() > 0){
					  resourceMgr.removeExtraResourceLimitation(type + "*;*" + consumer, hosts);
				  }else if(resourceMgr.getResourceLimitations() != null && resourceMgr.getResourceLimitations().containsKey(id)){
					  resourceMgr.getResourceLimitations().remove(id);
			  	}
			  } catch (Exception e) {
				  ErrorModel.log.error("Failed to remove resource  " + id, e);
				  success = false;
				  message = e.getMessage();
			  }
      }else {
    	  success = false;
		    message = "Default resource is not allow to delete"; 
      }
		}
	} 
	String xml = GridModelActionsHelper.getResultXML(success, message,"", childrenIdsList);

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");

	out.write(xml);
	out.flush();
%>