<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>


<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%

  String baseDirectory = request.getParameter("baseDirectory");
  if (baseDirectory == null){
  	baseDirectory = BASE_DIRECTORY;
  }
  
  String clusterNode = request.getParameter("clusterNode");
  if (clusterNode == null){
  	clusterNode = "";
  }

	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,null,true)){
		return;
	}
	
	
	
	UserContext user = UserEnvironment.getUserContext(request);
	if (user != null && user.getUser() != null && !user.getUser().isAdmin()){
		response.sendRedirect(BASE_DIRECTORY + "security/common/accessDenied.jsp");
		return;
	}
  SiteManagment mgmt = SiteManagment.getInstance();
  
  UserContext userContext = UserEnvironment.getUserContext(request);
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL, userContext, AuditConstants.VIEW, "view support", AuditConstants.SUPPORT_CONSOLE, "view basic support");
%>


               
<div id="logsDiv" style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr><td style="padding:10">
								<jsp:include page="logsInformation.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
                <jsp:param name="clusterNode" value="<%=clusterNode%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>	
							<div id="informationDiv" style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr><td style="padding:10">
								<jsp:include page="systemInformation.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
                <jsp:param name="clusterNode" value="<%=clusterNode%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>							
							<jsp:include page="../../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
								<jsp:param name="id.1" value="logsDiv" />
								<jsp:param name="name.1" value="System Logs" />
								<jsp:param name="id.2" value="informationDiv" />
								<jsp:param name="name.2" value="System Information" />
							</jsp:include>																		
