<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%!static final String BASE_DIRECTORY = "../../";%>
<%

String baseDirectory = request.getParameter("baseDirectory");
if (baseDirectory == null){
   baseDirectory = BASE_DIRECTORY;
}

String clusterNode = request.getParameter("clusterNode");
if (clusterNode == null){
	clusterNode = "";
}

String suffix = "_logs";

boolean showMenu = true;
if(showMenu) {
	String menuIds = "menuview";
	String menuTexts = "View";
	String menuHrefs = "javascript:viewLog();";
%>
<jsp:include page="../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
		</jsp:include>
		
<jsp:include page="../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	  <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	</jsp:include>
<%
}
%>
<script>
function viewLog(){
    var id = getFirstSelectedRow(mygrid_logs);
    if (id == "") {
     return;
    }
    var zoomInUrl = mygrid_logs.getUserData(id,"zoomInUrl"); 
		if (!zoomInUrl || zoomInUrl == ""){
		  return;
		}    
  	path = "<%=baseDirectory%>" + zoomInUrl;
  	window.open(path,'LogViewer');
  }

function saveLogLevel(){
	 var level = document.getElementById("logLevelSelect").value;
   var appender = document.getElementById("appenderLevel").value;
   hideLogLevel();
   showMessage("Change Logging Level","mygrid_logs","Saving",200,60);
   workingSupportData("_logs",baseDirectory + "support/basic/changeLogLevelActions.jsp","appender=" + appender + "&level=" + level + "&timestamp=" + new Date().getTime());
}

function openLogLevel(){
	var id = mygrid_logs.getSelectedRowId();
    if (id == "") {
       return;
    }
    var level = mygrid_logs.cells(id,4).getValue();
    var appender = mygrid_logs.getUserData(id,"appender");
    showGeneralAdminDiv('logLevel',150,100);
    if (level && level != "" && appender != null && appender != "" &&document.getElementById("logLevelSelect")){        
        document.getElementById("logLevelSelect").value = level;
        document.getElementById("appenderLevel").value = appender;
    }
}

function hideLogLevel(){
  showGeneralAdminDiv('logLevel');
}
 

function handleMenuItems_logs(){
  aMenu_logs.menu.showButtons("menuview");	
}

function exportLogs(){
	var id = mygrid_logs.getSelectedRowId();
  if (id == "") {
    return;
  }
  runExportAction("selectedLogs=" + id);
}

function exportLogsLight(){
  var id = mygrid_logs.getSelectedRowId();
  if (id == "") {
    return;
  }
  showGeneralAdminDiv('exportLight');
	document.getElementById("exportSelectedLogs").value = id;
}

function refreshSupportTable_logs(){
  disableActionButton("tableLogView");
  disableActionButton("tableLogLevel");
  updateTable_logs();  
}

function addXpoLogSystemLogs() {
	showMessage("Add XpoLog System Logs","mygrid_logs","Adding logs",200,60);
	workingSupportData("_logs",baseDirectory + "support/basic/addXpoLogSystemLogs.jsp","timestamp=" + new Date().getTime());
}
</script>
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
		<tr valign="top">
			<td width="100%">
      <jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
      <jsp:param name="baseDirectory" value="<%=baseDirectory%>"/> 
      <jsp:param name="title" value="Change Logging Level"/> 
      <jsp:param name="suffix" value="logLevel"/> 
      <jsp:param name="includePath" value="support/basic/changeLogLevel.jsp"/>      
      <jsp:param name="width" value="350px"/> 
      <jsp:param name="height" value="100px"/>
      <jsp:param name="zIndex" value="300"/>  
      <jsp:param name="actionsNames" value="Save#Cancel"/> 
      <jsp:param name="actions" value="javascript:saveLogLevel()#javascript:hideLogLevel()"/> 
      </jsp:include>
      
			<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
				<tr>
					<td valign="top" height="100%" style="padding-top:10px">
					<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              								
						<tr height="*">
							<td valign="top"> 
							<% 
							String tableNames = "View#Export#Export Light#Change Logging Level";
              String tableActions = "javascript:viewLog()#javascript:exportLogs()#javascript:exportLogsLight()#javascript:openLogLevel()";
              String ids = "tableLogView#exportLogsTable#exportLogsLightTable#tableLogLevel";
              String selectTypes = "2#3#3#2";
              
              boolean showAddXpoLogSystemLogs = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("support.showAddXpoLogSystemLogs", false);
              if(showAddXpoLogSystemLogs) {
              	tableNames += "*;*Add XpoLog System Logs#";
            		tableActions += "*;*javascript:addXpoLogSystemLogs()#";
            		ids += "*;*addXpoLogSystemLogs";
            		selectTypes += "*;*1";
              }
              
							String initXML = "support/basic/logsViewXML.jsp?suffix=logs&baseDirectory=" + baseDirectory + "&clusterNode=" + clusterNode;
							String updateXML = "support/basic/logsViewXML.jsp?suffix=logs&dataOnly=true&baseDirectory=" + baseDirectory+ "&clusterNode=" + clusterNode;
							%>                               
							<jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />								
							<jsp:param name="initXML" value="<%=initXML%>" />									
							<jsp:param name="updateXML" value="<%=updateXML%>" />									
							<jsp:param name="suffix" value="<%=suffix %>" />
							<jsp:param name="menu" value="aMenu_logs" />
							<jsp:param name="recordsText" value="Logs" />
							<jsp:param name="style" value="main" />
							<jsp:param name="height" value="100%" />
							<jsp:param name="autoHeight" value="-1" />
							<jsp:param name="rowsNumPerPage" value="-1" />
							<jsp:param name="tableActionNames" value="<%=tableNames%>" />
							<jsp:param name="tableActions" value="<%=tableActions%>" />
							<jsp:param name="tableActionIds" value="<%=ids%>" />
							<jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
							<jsp:param name="doubleClickAction" value="viewLog" />
							</jsp:include>														
							</td>
						</tr>								
					</table>
					</td>
				</tr>
			</table>
			</td>
		</tr>
	</table>	
	
	<script>
function updateButtonActivate_logs(rowid,id,columnType,gridType){
  if (!id || id == "") return; 		
 	if (gridType == columnType || (gridType == 2)){
    if (id == "tableLogView"){
    	var zoomInUrl = mygrid_logs.getUserData(rowid,"zoomInUrl");
 		  if ((!zoomInUrl || zoomInUrl == "")){
 			  disableActionButton(id);
 		  }else{
  		  enableActionButton(id);
  	  }
    }else if (id == "tableLogLevel"){
    	var appender = mygrid_logs.getUserData(rowid,"appender");
    	if ((!appender || appender == "")){
			  disableActionButton(id);
		  }else{
		   enableActionButton(id);
	    }
    }else if (id == "exportLogsTable" || id == "exportLogsLightTable"){
    	enableActionButton(id);
    }else if(id == "addXpoLogSystemLogs") {
    	enableActionButton(id);
    }
	}else if ((gridType == columnType || (gridType == 2 || gridType == 3)) && (id == "exportLogsTable" || id == "exportLogsLightTable" || id == "addXpoLogSystemLogs")){
    enableActionButton(id);
	}else {
  	disableActionButton(id);
	}
	
}

initMenus<%=suffix %>();
</script>