
<%@page import="com.xpolog.logcollection.util.constants.Constants"%>
<%@page import="xpolog.eye.logcollection.XpologCollectionUnitAdminRequest"%>
<%@page import="com.xpolog.logcollection.CollectionUnit"%>
<%@page import="com.xpolog.logcollection.CollectionUnitsManager"%>
<%@page import="com.xpolog.logcollection.LogCollectionManager"%>
<%@page import="xpolog.eye.reports.Report"%>
<%@page import="xpolog.eye.reports.ReportsManager"%>
<%@page import="xpolog.eye.audit.AuditConstants"%>
<%@page import="xpolog.eye.audit.AuditManager"%>
<%@page import="xpolog.eye.verifiers.Verifier"%>
<%@page import="xpolog.eye.SiteManagment"%>
<%@page import="xpolog.eye.verifiers.VerifierManager"%><%@page import="xpolog.eye.reports.health.ui.DashboardDataManager"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.data.index.SearchEngineManager"%>
<%@page import="xpolog.eye.data.index.adapters.defaultadapter.LogIndexerRunner"%><%@ page language="java"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.data.index.adapters.defaultadapter.DefaultIndexingHelper"%>
<%@page import="xpolog.eye.error.ErrorModel"%>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>

<%!
  static final String BASE_DIRECTORY = "../../";
	static final String DELIMITER = ",";
 %>
<%
	if (!WebSecurityManager.getInstance().checkForPermission(request,response, ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)) {
		return;
	}
  UserContext userContext = UserEnvironment.getUserContext(request);
  boolean success = true;
  String message = "";  
  String childrenIdsList = null;
	String path = DefaultIndexingHelper.getIndexDirectory();
  String action = request.getParameter("action");
  String collectionIds = request.getParameter("collectionIds");
  String deleteStorageLogStr = request.getParameter("deleteStorageLog");
	boolean deleteStorageLog = deleteStorageLogStr != null && deleteStorageLogStr.equals("true");
	String deleteCollectedDataStr = request.getParameter("deleteCollectedData");
	boolean deleteCollectedData = deleteCollectedDataStr != null && deleteCollectedDataStr.equals("true");
	XpologCollectionUnitAdminRequest delRequest = new XpologCollectionUnitAdminRequest(Constants.Actions.DELETE);
	delRequest.setRemoveCollectedData(deleteCollectedData);
	delRequest.setRemoveStorageLbm(deleteStorageLog);
	
  if (collectionIds != null && collectionIds.length() > 0){
  	StringTokenizer indexedLogsIdsList = new StringTokenizer(collectionIds,DELIMITER);
  	if (action.equalsIgnoreCase("delete")){
  		CollectionUnitsManager cuMgr = LogCollectionManager.getInstance().getCollectionUnitsManager();
	    while (indexedLogsIdsList.hasMoreTokens()) {
		    String id = indexedLogsIdsList.nextToken();
		    String name = "";
        try {      		        	
        	CollectionUnit cu = cuMgr.getCollectionUnit(id);;    		  
    		  if (cu != null) {
    			 name = cu.getName();
    		  }
  		    //audit
  		    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL, userContext,AuditConstants.CHANGE, "remove log collection",AuditConstants.LOG_COLLECTION, "remove log collection " + name + " (" + id + ")");
  		    cuMgr.removeCollectionUnit(id,delRequest);
        }catch (Exception e){
        	ErrorModel.log.error("Failed to remove log collection " + name+ " with id " + id, e);
		      success = false;
		      message = e.getMessage(); 
        }
      }	
  	}	else if (action.equalsIgnoreCase("deleteData")){
  		CollectionUnitsManager cuMgr = LogCollectionManager.getInstance().getCollectionUnitsManager();
      while (indexedLogsIdsList.hasMoreTokens()) {
        String id = indexedLogsIdsList.nextToken();
        String name = "";
        try {                   
        	CollectionUnit cu = cuMgr.getCollectionUnit(id);;    		  
  		  if (cu != null) {
  			 name = cu.getName();
  		  }
          //audit
           AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL, userContext,AuditConstants.CHANGE, "remove log collection data",AuditConstants.REPORTS, "remove data for log collection" + name + " (" + id + ")");
           cu.update(delRequest);
        }catch (Exception e){
          ErrorModel.log.error("Failed to remove data for log collection " + name+ " with id " + id, e);
          success = false;
          message = e.getMessage(); 
        }
      } 
    } 
  }else {
    message = "No report selected, please refresh and try again";
  }
  String xml = GridModelActionsHelper.getResultXML(success, message, "", childrenIdsList);

  response.setContentType("text/xml");
  response.setHeader("Pragma-Control", "no-cache");
  response.setHeader("Cache-Control", "no-cache");
  response.setHeader("Expires", "0");
  
  out.write(xml);
  out.flush();
%>