<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.data.index.adapters.defaultadapter.DefaultIndexingHelper"%>
<%@ page import="xpolog.eye.data.index.adapters.defaultadapter.LogIndexerRunner"%>
<%@ page import="xpolog.eye.data.index.SearchEngineManager"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.reports.health.ui.DashboardDataManager"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.util.*"%>

<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>

<%!
  static final String BASE_DIRECTORY = "../../";
	static final String DELIMITER = ",";
	static final String CONF_DIRECTORY = Configuration.XPOLOG_ROOT_PATH + "conf/systemlogs/";
	static final String SEARCH_ENGINE_TAB_INDX = "2";
 %>
<%
	if (!WebSecurityManager.getInstance().checkForPermission(request,response, ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)) {
		return;
	}
  UserContext userContext = UserEnvironment.getUserContext(request);
  boolean success = true;
  String message = "";  
  String childrenIdsList = null;
	String path = DefaultIndexingHelper.getIndexDirectory();
  String action = request.getParameter("action");
  String comptationIds = request.getParameter("computationIds");
	String type = request.getParameter("computationType"); 
  if (type == null || type.length() == 0){
   type = "logs"; 
  }
  if (action == null || action.length() == 0){
    success = false;
    message = "No action was selected";
  } else if (comptationIds != null && comptationIds.length() > 0){
  	StringTokenizer indexedLogsIdsList = new StringTokenizer(comptationIds,DELIMITER);
  	if (action.equalsIgnoreCase("delete")){
	    while (indexedLogsIdsList.hasMoreTokens()) {
		    String indexedogId = indexedLogsIdsList.nextToken();      
		    File rootComputationsDir = new File(Configuration.XPOLOG_COMPUTATION_PATH  +  type + "/" + indexedogId);
        try {      		        	
    		  if (rootComputationsDir.isDirectory()) {
    			  FileUtil.deleteFile(rootComputationsDir);
    		  }
        }catch (Exception e){
        	String analytics = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_DISPLAY_NAME);
    	    ErrorModel.log.error("Failed to delete " + analytics + " data " + rootComputationsDir, e);
		      success = false;
		      message = e.getMessage(); 
        }
      }
	    Thread t = new Thread(){
			public void run(){
				DashboardDataManager.getInstance().updateCache();	
			}};	
		  t.start();
  	}	
  }else {
    message = "No log selected, please refresh and try again";
  }
  String xml = GridModelActionsHelper.getResultXML(success, message, "", childrenIdsList);

  response.setContentType("text/xml");
  response.setHeader("Pragma-Control", "no-cache");
  response.setHeader("Cache-Control", "no-cache");
  response.setHeader("Expires", "0");
  
  out.write(xml);
  out.flush();
%>