<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%!static final String BASE_DIRECTORY = "../../";%>
<%

String baseDirectory = request.getParameter("baseDirectory");
if (baseDirectory == null){
   baseDirectory = BASE_DIRECTORY;
}
	
String suffix = "_indexing";

boolean showMenu = true;
if(showMenu) {
	String menuIds = "deleteIndexing,index,reindex";
	String menuTexts = "Delete,Index,ReIndex";
	String menuHrefs = "javascript:deleteIndexing(),javascript:indexIndexing(),javascript:reindexIndexing()";
%>
<jsp:include page="../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
		</jsp:include>

	<jsp:include page="../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	 <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	</jsp:include>
<%
}
%>
<script>
function deleteIndexing(){
	 var id = mygrid_indexing.getSelectedRowId();
	 if (id == "") {
	    return;
	 }
	 if (id.indexOf(",") >= 0){
	   doIndexingMembersDelete(id,id);
	   return;
	 }
	 deleteMemberIndexing(id);
}

function doIndexingMembersDelete(id){
  showActionMessage("Indexing Delete Action","mygrid_indexing","doDeleteIndexing('" + id + "','" +  id + "')","<nobr>Are you sure you want to delete all selected logs</nobr>" + "?");   
}

function deleteMemberIndexing(id){
	var name = mygrid_indexing.cells(id,0).getValue();
	showActionMessage("Indexing Delete Action","mygrid_indexing","doDeleteIndexing('" + id + "','" +  id + "')","<nobr>Are you sure you want to delete log </nobr>" + name + "?");   
}

function doDeleteIndexing(row,id){
	showMessage("Indexing","mygrid_indexing","Deleting",200,60);
	workingSupportData("_indexing",baseDirectory + "support/data/indexingActions.jsp","action=delete&indexedIds=" + id + "&timestamp=" + new Date().getTime());
}

function indexIndexing(){
   var id = mygrid_indexing.getSelectedRowId();
   if (id == "") {
      return;
   }
   if (id.indexOf(",") >= 0){
     indexingMembers(id,id);
     return;
   }
   indexMember(id);
}

function indexingMembers(id){
 showActionMessage("Indexing Action","mygrid_indexing","doIndexing('" + id + "','" +  id + "')","<nobr>Are you sure you want to index all selected logs</nobr>" + "?");   
}

function indexMember(id){
  var name = mygrid_indexing.cells(id,0).getValue();
  showActionMessage("Indexing Action","mygrid_indexing","doIndexing('" + id + "','" +  id + "')","<nobr>Are you sure you want to index </nobr>" + name + "?");   
}

function doIndexing(row,id){
  showMessage("Indexing","mygrid_indexing","Start indexing",200,60);
  workingSupportData("_indexing",baseDirectory + "support/data/indexingActions.jsp","action=index&indexedIds=" + id + "&timestamp=" + new Date().getTime());
}

function reindexIndexing(){
     var id = mygrid_indexing.getSelectedRowId();
     if (id == "") {
        return;
     }
     if (id.indexOf(",") >= 0){
       reindexingMembers(id,id);
       return;
     }
     indexMember(id);
  }

  function reindexingMembers(id){
   showActionMessage("Reindexing Action","mygrid_indexing","doReIndexing('" + id + "','" +  id + "')","<nobr>Are you sure you want to reindex all selected logs</nobr>" + "?");   
  }

  function reindexMember(id){
    var name = mygrid_indexing.cells(id,0).getValue();
    showActionMessage("Reindexing Action","mygrid_indexing","doReIndexing('" + id + "','" +  id + "')","<nobr>Are you sure you want to reindex </nobr>" + name + "?");   
  }

  function doReIndexing(row,id){
    showMessage("Reindexing","mygrid_indexing","Start reindexing",200,60);
    workingSupportData("_indexing",baseDirectory + "support/data/indexingActions.jsp","action=reindex&indexedIds=" + id + "&timestamp=" + new Date().getTime());
  }


function handleMenuItems_indexing(){
  aMenu_indexing.menu.showButtons("deleteIndexing");
  aMenu_indexing.menu.showButtons("index");
  aMenu_indexing.menu.showButtons("reindex");	
}

		
	function refreshIndexingInfo(){
		var t = applicationTabs.tabs[applicationTabs.selectedTabIndex];
		if (t && t.id == "Indexing"){
			updateTable_indexing();
		}
	}

	initMenus<%=suffix %>();
</script>
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
		<tr valign="top">
			<td width="100%">
			<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
				<tr>
					<td valign="top" height="100%" style="padding-top:10px">
					<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              								
						<tr height="*">
							<td valign="top"> 
							<% 
              
							String tableNames = "Delete#Index#Reindex";
				      String tableActions = "javascript:deleteIndexing()#javascript:indexIndexing()#javascript:reindexIndexing()";
				      String ids = "deleteIndex#index#reindex";
				      String selectTypes = "3#3#3";
              
              
							String initXML = "support/data/indexingViewXML.jsp?suffix=indexing&baseDirectory=" + baseDirectory;
							String updateXML = "support/data/indexingViewXML.jsp?suffix=indexing&dataOnly=true&baseDirectory=" + baseDirectory;
              				String menu = showMenu ? "aMenu_indexing" : "";              				
							%>                               
							<jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />								
							<jsp:param name="initXML" value="<%=initXML%>" />	
							<jsp:param name="updateXML" value="<%=updateXML%>" />																		
							<jsp:param name="menu" value="<%=menu%>" />
							<jsp:param name="suffix" value="<%=suffix %>" />
							<jsp:param name="recordsText" value="Logs" />
							<jsp:param name="style" value="main" />
							<jsp:param name="height" value="100%" />
							<jsp:param name="autoHeight" value="-1" />
							<jsp:param name="rowsNumPerPage" value="-1" />
							<jsp:param name="multiline" value="true" />
              <jsp:param name="tableActionNames" value="<%=tableNames%>" />
              <jsp:param name="tableActions" value="<%=tableActions%>" />
              <jsp:param name="tableActionIds" value="<%=ids%>" />
              <jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
							</jsp:include>
<script>
function updateButtonActivate_indexing(rowid,id,columnType,gridType){
	 if (!rowid || !mygrid_indexing.doesRowExist(rowid)){
     disableActionButton(id);
     return;
   }   
   var enableActions = mygrid_indexing.getUserData(rowid,"enableActions");
   if(enableActions && enableActions == "true") {
	   enableActionButton(id);
   }else {
	   disableActionButton(id);
   }
}
</script>
							</td>
						</tr>								
					</table>
					</td>
				</tr>
			</table>
			</td>
		</tr>
	</table>		
