<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%!static final String BASE_DIRECTORY = "../../";%>
<%

String baseDirectory = request.getParameter("baseDirectory");
if (baseDirectory == null){
   baseDirectory = BASE_DIRECTORY;
}
	
String suffix = "_reports";

boolean showMenu = true;
if(showMenu) {
	String menuIds = "deleteReport,deleteReportData";
	String menuTexts = "Delete Report,Delete Data";
	String menuHrefs = "javascript:deleteReport(),javascript:deleteReportData()";
%>
<jsp:include page="../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
		</jsp:include>

	<jsp:include page="../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	 <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	</jsp:include>
<%
}
%>
<script>
function deleteReportData(){
    var id = mygrid_reports.getSelectedRowId();
    if (id == "") {
       return;
    }
    if (id.indexOf(",") >= 0){
      doReportDataMembersDelete(id,id);
      return;
    }
    deleteMemberReportData(id);
 }

 function doReportDataMembersDelete(id){
  showActionMessage("Delete Report Results","mygrid_reports","doDeleteReportData('" + id + "','" +  id + "')","<nobr>Are you sure you want to delete data for all selected reports</nobr>" + "?");   
 }

 function deleteMemberReportData(id){
   var name = mygrid_reports.cells(id,0).getValue();
   showActionMessage("Delete Report Results","mygrid_reports","doDeleteReportData('" + id + "','" +  id + "')","<nobr>Are you sure you want to delete data for report </nobr>" + name + "?");   
 }

 function doDeleteReportData(row,id){
   showMessage("Report","mygrid_reports","Deleting data",200,60);
   workingSupportData("_reports",baseDirectory + "support/data/reportActions.jsp","action=deleteData&reportIds=" + id + "&timestamp=" + new Date().getTime());
 }

 function deleteReport(){
     var id = mygrid_reports.getSelectedRowId();
     if (id == "") {
        return;
     }
     if (id.indexOf(",") >= 0){
       doReportMembersDelete(id,id);
       return;
     }
     deleteMemberReport(id);
  }

  function doReportMembersDelete(id){
   showActionMessage("Report Delete Action","mygrid_reports","doDeleteReport('" + id + "','" +  id + "')","<nobr>Are you sure you want to delete all selected reports</nobr>" + "?");   
  }

  function deleteMemberReport(id){
    var name = mygrid_reports.cells(id,0).getValue();
    showActionMessage("Report Delete Action","mygrid_reports","doDeleteReport('" + id + "','" +  id + "')","<nobr>Are you sure you want to delete report </nobr>" + name + "?");   
  }

  function doDeleteReport(row,id){
    showMessage("Report","mygrid_reports","Deleting report",200,60);
    workingSupportData("_reports",baseDirectory + "support/data/reportActions.jsp","action=delete&reportIds=" + id + "&timestamp=" + new Date().getTime());
  }

function handleMenuItems_reports(){
	aMenu_reports.menu.showButtons("deleteReport");
  aMenu_reports.menu.showButtons("deleteReportData");	
}

function keepLastReports(){
   var reportsIds = document.getElementById("reportIds").value;
  var amount = document.getElementById("keepLastReports").value;
  hideLastReports();
  showMessage("Delete Report Results","mygrid_logs","Deleting",200,60);
  workingSupportData("_reports",baseDirectory + "support/data/reportActions.jsp","action=keepLast&reportIds=" + reportsIds + "&amount=" + amount + "&timestamp=" + new Date().getTime());
}

function openLastReports(){
  var id = mygrid_reports.getSelectedRowId();
   if (id == "") {
      return;
   }
   showGeneralAdminDiv('lastReports',150,100);
   if (document.getElementById("reportIds")){        
       document.getElementById("reportIds").value = id;
   }
}

function hideLastReports(){
 showGeneralAdminDiv('lastReports');
}

		
	function refreshReportsInfo(){
		var t = applicationTabs.tabs[applicationTabs.selectedTabIndex];
		if (t && t.id == "Reports"){
			updateTable_reports();
		}
	}

	function refreshSupportTable_reports(){
		  disableActionButton("deleteTableReport");
		  disableActionButton("deleteTableReportData");
		  disableActionButton("openLastReportsTable");
		}

	initMenus<%=suffix %>();
</script>
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
		<tr valign="top">
			<td width="100%">
			<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
				<tr>
					<td valign="top" height="100%" style="padding-top:10px">
					<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              								
						<tr height="*">
							<td valign="top"> 
               <jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
      <jsp:param name="baseDirectory" value="<%=baseDirectory%>"/> 
      <jsp:param name="title" value="Delete Report Results"/> 
      <jsp:param name="suffix" value="lastReports"/> 
      <jsp:param name="includePath" value="support/data/keepLastReports.jsp"/>      
      <jsp:param name="width" value="350px"/> 
      <jsp:param name="height" value="100px"/>
      <jsp:param name="zIndex" value="300"/>  
      <jsp:param name="actionsNames" value="Delete#Cancel"/> 
      <jsp:param name="actions" value="javascript:keepLastReports()#javascript:hideLastReports()"/> 
      </jsp:include>
							<%
							String tableNames = "Delete Report#Delete All Report Results#Delete Part of a Report Results";
						  String tableActions = "javascript:deleteReport()#javascript:deleteReportData()#javascript:openLastReports()";
						  String ids = "deleteTableReport#deleteTableReportData#openLastReportsTable";
						  String selectTypes = "3#3#3";
		
							String initXML = "support/data/reportsViewXML.jsp?suffix=reports&baseDirectory=" + baseDirectory;
							String updateXML = "support/data/reportsViewXML.jsp?suffix=reports&dataOnly=true&baseDirectory=" + baseDirectory;
              				String menu = showMenu ? "aMenu_reports" : "";              				
							%>                               
							<jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />								
							<jsp:param name="initXML" value="<%=initXML%>" />	
							<jsp:param name="updateXML" value="<%=updateXML%>" />																		
							<jsp:param name="menu" value="<%=menu%>" />
							<jsp:param name="suffix" value="<%=suffix %>" />
							<jsp:param name="recordsText" value="Reports" />
							<jsp:param name="style" value="main" />
							<jsp:param name="height" value="100%" />
							<jsp:param name="autoHeight" value="-1" />
							<jsp:param name="rowsNumPerPage" value="-1" />
							<jsp:param name="multiline" value="true" />
              <jsp:param name="tableActionNames" value="<%=tableNames%>" />
              <jsp:param name="tableActions" value="<%=tableActions%>" />
              <jsp:param name="tableActionIds" value="<%=ids%>" />
              <jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />                  
							</jsp:include>													
							</td>
						</tr>								
					</table>
					</td>
				</tr>
			</table>
			</td>
		</tr>
	</table>		
