<%@ page language="java"%>

<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.media.telsh.TelShMediaPoolManager"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>

<%!static final String BASE_DIRECTORY = "../";%>

<%
	if (!WebSecurityManager.getInstance().checkForPermission(request,
			response,
			ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,
			true)) {
		return;
	}
	
	String selectedTabId = request.getParameter("selectedTabId");
	String poolAccountId = request.getParameter("poolAccountId");
	if(poolAccountId == null || poolAccountId.length() == 0) {
		return;
	}
	UserContext userContext = UserEnvironment.getUserContext(request);
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	  	userContext, AuditConstants.CHANGE, "destroy ssh pool", AuditConstants.ACCOUNTS, "destroy ssh pool of account " + poolAccountId); 
	
	TelShMediaPoolManager.getInstance().destroyPool(poolAccountId);
	
	response.sendRedirect(BASE_DIRECTORY + "support/index.jsp?selectedTabId=" + selectedTabId);
%>
