<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.util.Constants"%>

<%!
  static final String BASE_DIRECTORY = "../";
	static final String DELIMITER = ",";
%>
<%
	String ERROR_OBJ = "ERROR_OBJ";

  String type = request.getParameter("computationType");
  boolean isLogs = type == null || !type.equals("hosts");
	String[] idsArr = isLogs ? request.getParameterValues("computationLogsList") : request.getParameterValues("computationHostsList");;
	ErrorModel errmodel = new ErrorModel();
	String analytics = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_DISPLAY_NAME);

	if(idsArr == null) {
		errmodel.addError("No " + analytics + " " + (isLogs ? "logs" : "hosts") + " were Selected");
	}
	if(errmodel.getErrorCount() != 0){
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?closeWindow=true");
		request.getSession().setAttribute(ERROR_OBJ, errmodel);
		return;
 	}


	String computationIds = "";
	if (idsArr != null && idsArr.length > 0){
		 for(int i=0; i < idsArr.length; i++){
			 computationIds += idsArr[i] + DELIMITER;
		 }
		}
%>

<html>

<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css"
	href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>
  function operationOk(){
    document.access.submit();
  }
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" action="systemHealthAction.jsp">
<input type="hidden" name="computationIds" value="<%=computationIds%>">
<input type="hidden" name="computationType" value="<%=type%>">
<table border="0" width="100%" cellspacing="0" height="100%"
	cellpadding="0">
	<tr valign="top">
		<td width="100%">
		<table border="0" width="100%" cellspacing="0" cellpadding="0">
			<tr>
				<td valign="top" height="100%">
				<table border="0" cellpadding="0" cellspacing="0"
					style="border-collapse: collapse" width="100%" id="AutoNumber1">
					<tr>
						<td width="100%">
						<table border="0" cellpadding="0" cellspacing="0"
							style="border-collapse: collapse" width="100%" id="AutoNumber2">
							<tr>
								<td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
								<td width="55%" class="TOPBORDER"><span class="PAGEHEADER">Operation
								verfication</span></td>
								<td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
							</tr>
							<tr>
								<td width="3%">&nbsp;</td>
								<td width="24%">&nbsp;</td>
								<td width="100%">&nbsp;</td>
							</tr>
							<tr>
								<td width="3%">&nbsp;</td>
								<td width="147%" colspan="2">
								<table border="0" cellpadding="0" cellspacing="0"
									style="border-collapse: collapse" width="100%" id="AutoNumber3"
									height="53">
									<tr>
										<td width="15%" height="18"><span class="HEADER">General</span></td>
									</tr>
									<tr>
										<td width="15%" height="18"></td>
									</tr>
									<tr>
										<td width="15%" height="22"><span class="REGULARTEXT"><b>Are
										you sure you want to remove those selected <%=analytics %> <%=isLogs ? "logs" : "hosts" %> ?</b></span></td>
									</tr>
									<tr>
										<td>&nbsp;</td>
									</tr>
									<%if (idsArr != null && idsArr.length > 0){ %>
									<tr>
										<td>
										<table border="0" cellpadding="0" cellspacing="0" width="100%">
											<%
											for(int i=0; i < idsArr.length; i++){
												int serNum = i+1;
											%>
											<tr class="TABLES_HEADERS">
												<td width="3%"><span class="REGULARTEXT"><b><%=serNum%>.</b></span></td>
												<td width="36%"><span class="REGULARTEXT"><%=idsArr[i]%></span></td>
											</tr>
											<%}//end of for loop %>
										</table>
										</td>
									</tr>
									<%} %>
									<tr>
										<td>&nbsp;</td>
									</tr>
									<tr>
										<td>&nbsp;</td>
									</tr>
								</table>
								</td>
							</tr>
						</table>
						</td>
					</tr>
					<tr>
						<td width="100%">&nbsp;</td>
					</tr>
					<tr>
						<td width="100%">&nbsp;</td>
					</tr>
					<tr>
						<td width="100%" height="100%">&nbsp;</td>
					</tr>
					<tr>
						<td width="100%">
						<table border="0" cellpadding="0" cellspacing="0"
							style="border-collapse: collapse" width="100%" id="AutoNumber7">
							<tr>
								<td width="35%">&nbsp;</td>
								<td width="11%" align="center"><a
									href='javascript:window.close()' class="LINK">cancel</a></td>
								<td width="7%" align="center"><a
									href='javascript:operationOk()'
									class="LINK"> ok</a></td>
								<td width="27%">&nbsp;</td>
								<td width="20%">&nbsp;</td>
							</tr>
						</table>
						</td>
					</tr>
				</table>
				</td>
			</tr>
			<tr valign="bottom">
				<td valign="bottom" height="10%">
				<table border="0" cellpadding="0" cellspacing="0" width="100%">
					<tr>
						<td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
						<td class="BOTTOMBORDER" width="33%">&nbsp;</td>
						<td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
</table>
</form>
</body>

</html>
