<%@page import="xpolog.eye.admin.builders.OnlineDBSimpleLogBuilder"%>
<%@page import="xpolog.eye.automation.tasks.download.DownloadModuleMemberChecker"%>
<%@page import="xpolog.eye.admin.builders.MergedLogBrowserBuilder"%>
<%@page import="xpolog.eye.admin.builders.SimpleLogBrowserBuilder"%>
<%@page import="xpolog.eye.admin.LogBrowserBuilderFactory"%>
<%@page import="xpolog.eye.admin.builders.WinEventLogBuilder"%>
<%@page import="xpolog.eye.admin.builders.RemoteLogBuilder"%>
<%@page import="xpolog.eye.automation.tasks.download.DownloadFileTask"%>
<%@page import="xpolog.eye.automation.tasks.XpoTaskManager"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.pack.ExportFlow"%>
<%@ page import="xpolog.eye.site.ui.tree.ModuleMemberRenderer"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.util.*"%>

<%
	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
	
	String operation = request.getParameter("op");
	String taskId = request.getParameter("taskId");
	
	boolean execute = false;
	
	if (operation == null || operation.trim().length() == 0){
	  operation = String.valueOf(ExportFlow.EXECUTE_TYPE);
	  execute = true;
	} 
	
//	String EXPORT_FLOW = "EXPORT_FLOW";
//	ExportFlow flow = (ExportFlow)request.getSession().getAttribute(EXPORT_FLOW);
	
	HashMap logsMap = new HashMap();
	HashMap modulesMap = new HashMap();
	if(taskId != null && !taskId.equals("")){
  	XpoTaskManager taskmgr = XpoTaskManager.getInstance();
  	DownloadFileTask dt = (DownloadFileTask)taskmgr.getXpoTaskById(taskId); 
  	logsMap = dt.getLogsToDownload();
  	ModuleMemberRenderer.addModuleMemberParents(modulesMap,logsMap);		
  }
	
		
	boolean treeNodeExists = false;
	String treeXml = ""; 
  String id = request.getParameter("id");
  if (id != null){
  	String modid = id;
  	int ind = id.indexOf("-");
  	if (ind != -1){
  		modid = id.substring(ind+1);
  	}
		curmod = SiteManagment.getInstance().getModuleFromId(modid);
		treeNodeExists = true;
  }
  
	
	if (curmod != null){
		ModuleMemberRenderer renderer = new ModuleMemberRenderer(curmod, userContext, modulesMap, logsMap, true, false, treeNodeExists);
		HashSet logTypesToIgnore = new HashSet();
		logTypesToIgnore.add(SimpleLogBrowserBuilder.SIMPLE_LOG_TYPE);
		logTypesToIgnore.add(RemoteLogBuilder.PROXY_LOG_TYPE);
		logTypesToIgnore.add(LogBrowserBuilderFactory.XML_LOG_TYPE);
		logTypesToIgnore.add(LogBrowserBuilderFactory.TRANSACTION_LOG_TYPE);
		logTypesToIgnore.add(LogBrowserBuilderFactory.DEFAULT_TYPE);
		logTypesToIgnore.add(LogBrowserBuilderFactory.LOG4J_TYPE);
		logTypesToIgnore.add(LogBrowserBuilderFactory.WIN_EVENT_TYPE);
		logTypesToIgnore.add(WinEventLogBuilder.EVENT_VIEWER_TYPE);
		logTypesToIgnore.add(OnlineDBSimpleLogBuilder.ONLINE_DB_LOG_TYPE);
		logTypesToIgnore.add(OnlineDBSimpleLogBuilder.ONLINE_DB_CACHE_LOG_TYPE);
		logTypesToIgnore.add(MergedLogBrowserBuilder.MERGE_LOG_TYPE);
		renderer.setLogTypesToIgnore(logTypesToIgnore);
		renderer.setModuleMemberChecker(new DownloadModuleMemberChecker());
		treeXml = renderer.getTreeXML();
	}
	
	//System.out.println(treeXml);
	response.setContentType("text/xml");
	out.write(treeXml);
	out.flush();
%>