<%@ page language="java"%>

<%@ page import="java.util.*"%>

<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.exe.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.WebUtil"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>


<%
	String ACCOUNT_TYPE = "accountType";
	String IS_SSH = "IsSsh";
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	String exePath = "";
	String exeArgs = "";
	
	String exeEnvVar = "";
	String exeWorkDir = "";
	
	String accountId = "";
	String exeOutputTargetFile = "";
	boolean addOptionalParams = true;
	
	ExeTask task = (ExeTask)request.getAttribute("CURRENT_TASK");
	String accountType = request.getParameter(ACCOUNT_TYPE);
	String isSshStr = request.getParameter(IS_SSH);
	boolean isSsh = isSshStr != null && isSshStr.equals("true");
	if(task != null){
		exePath = task.getExePath();
		exePath = WebUtil.doHTMLEncoding(exePath);
		exeArgs = task.getExeArgs();
		exeArgs = WebUtil.doHTMLEncoding(exeArgs);
		exeEnvVar = task.getExeEnvp();		
		exeEnvVar = WebUtil.doHTMLEncoding(exeEnvVar);
		exeOutputTargetFile = task.getExeOutputTargetFile();
		exeOutputTargetFile = WebUtil.doHTMLEncoding(exeOutputTargetFile);
		addOptionalParams = task.isAddOptionalParams();
		
		isSsh = task.getType().equals(ExeTask.TYPE_SSH_EXE);
		if (isSsh){
			accountId = task.getAccountId();
		}else {
			exeWorkDir = task.getExeDir();
			exeWorkDir = WebUtil.doHTMLEncoding(exeWorkDir);
		}
	}
	
	String accountListId = request.getParameter("accountListId");
	if(accountListId == null) {
		accountListId = "";
	}
	
%>

<input type="hidden" name="<%=IS_SSH%>" value="<%=isSsh%>">

<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
	<tr>
		<td style="padding-left:15;padding-top:10">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
			<%if (isSsh){%>
				<tr height="10">
			  	<td width="12%"><span class="REGULARTEXT">Connection Details *</span></td>
			    <td width="69%">
						<%
						String accountsListUrl = BASE_DIRECTORY + "common/accountsListCombo.jsp";
						%>
						<jsp:include flush="true" page="<%=accountsListUrl %>">
							<jsp:param name="ACC_TYPE" value="<%=accountType%>"/>
							<jsp:param name="ACC_ID" value="<%=accountId%>"/>
							<jsp:param name="ACC_LIST_ID" value="<%=accountListId %>"/>
							<jsp:param name="CHANGE_ACC_SELECTION" value="false"/>
							<jsp:param name="PREFIX" value=""/>
						</jsp:include>
			    <%
			    if (userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){
			    %>
			    <span class="SMALLTEXT"><a href="javascript:generalOpenNewAccountDiv()" class="BUTTON_MEDIUMLINK">new</a></span>
			    <%}%>
			    </td>
			  </tr>
			  <%} %>
			  <tr height="10">
			    <td width="12%" style="padding-top:10" nowrap><span class="REGULARTEXT">Program/Script Path *</span></td>
			    <td width="69%">
			    <input class="TEXTBOX" type="text" name="exePath" size="50" value="<%=exePath%>"></td>
			  </tr>
			  <tr height="10">
			    <td style="padding-top:10" nowrap><span class="REGULARTEXT">Arguments</span></td>
			    <td><input class="TEXTBOX" type="text" name="exeArgs" size="50" value="<%=exeArgs%>"></td>
			  </tr>
			  <tr height="10">
			    <td style="padding-top:10" nowrap><span class="REGULARTEXT">Environment Variables</span></td>
			    <td><input class="TEXTBOX" type="text" name="exeEnvVar" size="50" value="<%=exeEnvVar%>"></td>
			  </tr>
			  <%if (!isSsh){%>
			  <tr height="10">
			    <td style="padding-top:10" nowrap><span class="REGULARTEXT">Working Directory</span></td>
			    <td><input class="TEXTBOX" type="text" name="exeWorkDir" size="50" value="<%=exeWorkDir%>"></td>
			  </tr>
			  <%}%>
			  <tr height="10">
			    <td style="padding-top:10" nowrap><span class="REGULARTEXT">Output Target File</span></td>
			    <td><input class="TEXTBOX" type="text" name="exeOutputTargetFile" size="50" value="<%=exeOutputTargetFile%>"></td>
			  </tr>
			  <tr height="10">
			    <td style="padding-top:10" nowrap><span class="REGULARTEXT">Add Optional Params</span></td>
			    <td><input type="checkbox" name="addOptionalParams" <%=addOptionalParams ? "checked" : "" %>><span class="SMALLTEXT">when checked the output file will contain the date, account name, host name and username</span></td>
			  </tr>
			  <tr height="10">
          <td style="padding-top:20" colspan="2">
          	<span class="SMALLTEXT">* marks a manadatory field</span>
          </td>
        </tr>
			  <tr>
			  	<td>&nbsp;</td>
			  </tr>
			</table>
		</td>
	</tr>
</table>