<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.net.*"%>
<%@ page import="xpolog.eye.error.*"%>\
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.export.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
  static final String BASE_DIRECTORY = "../../";
%>

<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String XPOTASK_ID = "ID";
	String DUPLICATE = "DUPLICATE";
	String ERROR_OBJ = "ERROR_OBJ";
	
	String Name, Description, Subject, Body, fromId, toId, Id;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");	
	
	Id = request.getParameter(XPOTASK_ID);
	String duplicateStr = request.getParameter(DUPLICATE);
	boolean duplicate = duplicateStr != null && duplicateStr.equals("true");
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
    	errmodel.addError("No Name was supplied.");
  	}
  	
  	String EXPORT_FLOW = "EXPORT_FLOW";
    ExportFlow flow = (ExportFlow)request.getSession().getAttribute(EXPORT_FLOW);
    if (flow == null){
      errmodel.addError("Export folder parameters are missing.Please try again.");
    }
    
    ExportModuleTask moduleTask = (ExportModuleTask)request.getSession().getAttribute("TASK");
  
  	
  	if(errmodel.getErrorCount() != 0){
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
  	}
	
	XpoTaskManager taskmgr = XpoTaskManager.getInstance();
	if(moduleTask == null && Id != null){
		moduleTask = (ExportModuleTask)taskmgr.getXpoTaskById(Id);
	}
	if(moduleTask == null || duplicate){
		moduleTask = new ExportModuleTask();
	}
	
	moduleTask.setName(Name);
	moduleTask.setDescription(Description);
	moduleTask.setExportFlow(flow);
	
	taskmgr.addXpoTask(moduleTask,userContext);
	taskmgr.saveXpoTasks();
	
    //audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "task added/edited", AuditConstants.TASKS, "export module task added/edited " + Name);

	
	request.getSession().removeAttribute("EXPORT_FLOW");
	request.getSession().removeAttribute("TASK");
	response.sendRedirect(BASE_DIRECTORY + "tasks/xpotasksview.jsp?taskType=exportModule");
%>