<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.ftp.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	
	String Name,Description,Url,Port,User,Pwd,Id;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	Url = request.getParameter("Url");
	Port = request.getParameter("Port");
	User = request.getParameter("User");
	Pwd = request.getParameter("Pwd");
	Id = request.getParameter("Id");
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
    	errmodel.addError("No Name was supplied.");
  	}

  	/*if(Description == null || Description.trim().equals("")){
    	errmodel.addError("No parent folder was selected. If no folder is available please check your permissions");
  	}*/
  	
  	if(Url == null || Url.equals("")){
    	errmodel.addError("Server Url was not supplied.");
  	}

  	if(Port == null || Port.trim().equals("")){
    	errmodel.addError("Port number was not supplied.");
  	}
	if(User == null || User.equals("")){
    	errmodel.addError("User name was not supplied.");
  	}

  	if(Pwd == null || Pwd.trim().equals("")){
    	errmodel.addError("Password was not supplied.");
  	}
 
  	
  	if(errmodel.getErrorCount() != 0){
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
  	}
	
	int port = Integer.parseInt(Port);
	
	FTPAccount ftac = null;
	AddressBook adbok = AddressBook.getInstance();
	if(Id != null){
		ftac = (FTPAccount)adbok.getAccountById(Id);
		
	}
	if(ftac == null){
		ftac = new FTPAccount();
	}
	
	ftac.setAccountName(Name);
	ftac.setNetAddress(Url);
	ftac.setPassword(Pwd);
	ftac.setPort(port);
	ftac.setUserName(User);
	ftac.setDescription(Description);
	
	adbok.addAccount(ftac,userContext);
	adbok.saveAddressBook();
	
	//audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "task added/edited", AuditConstants.TASKS, "ftp task added/edited " + Name);

	response.sendRedirect(BASE_DIRECTORY + "tasks/addressview.jsp?taskType=ftp");
%>