<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.http.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.net.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
    UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	
	String Name,Description,strUrl,Port,User,Pwd,Id;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	strUrl = request.getParameter("Url");
	Id = request.getParameter("Id");
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
    	errmodel.addError("No Name was supplied.");
  	}

  	/*if(Description == null || Description.trim().equals("")){
    	errmodel.addError("No parent folder was selected. If no folder is available please check your permissions");
  	}*/
  	URL url = null;
  	if(strUrl == null || strUrl.equals("")){
    	errmodel.addError("Server Url was not supplied.");
  	}
  	try{
  		url = new URL(strUrl);
  	}catch(Exception e){
  		errmodel.addError("Invalid Url!" + e.getMessage());
  	}
 
  	
  	if(errmodel.getErrorCount() != 0){
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
  	}
	
	
	
	HttpAccount htac = null;
	AddressBook adbok = AddressBook.getInstance();
	if(Id != null){
		htac = (HttpAccount)adbok.getAccountById(Id);
		
	}
	if(htac == null){
		htac = new HttpAccount();
	}
	
	htac.setAccountName(Name);
	htac.setUrl(url);
	htac.setDescription(Description);
	
	adbok.addAccount(htac,userContext);
	adbok.saveAddressBook();
	
    //audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "task added/edited", AuditConstants.TASKS, "http task added/edited " + Name);

	response.sendRedirect(BASE_DIRECTORY + "tasks/addressview.jsp?taskType=http");
%>