<%@ page language="java"%>

<%@ page import="java.util.*"%>

<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.jms.*"%>
<%@ page import="xpolog.eye.media.jms.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%!
  static final String BASE_DIRECTORY = "../../";
%>


<%

	String PREFIX = "jms_";

	String scriptsOnlyStr = request.getParameter("scriptsOnly");
	boolean scriptsOnly = scriptsOnlyStr != null && scriptsOnlyStr.equals("true");
	
	String noScriptsStr = request.getParameter("noScripts");
	boolean noScripts = noScriptsStr != null && noScriptsStr.equals("true");
	
	String embeddedStr = request.getParameter("embedded");
	boolean embedded = embeddedStr != null && embeddedStr.equals("true");
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String jmsTaskLabel = request.getParameter("jmsTaskLabel");
	if (jmsTaskLabel == null || jmsTaskLabel.length() == 0){
		jmsTaskLabel = "JMS Message Task";
	}
	String existingTasksLabel = request.getParameter("existingTasksLabel");
	if (existingTasksLabel == null || existingTasksLabel.length() == 0){
		existingTasksLabel = "Existing JMS Tasks";
	}
	
	String existingTasksNote = request.getParameter("existingTasksNote");
	if (existingTasksLabel == null || existingTasksLabel.length() == 0){
		existingTasksNote = "copy details from existing JMS task";
	}

	String jmsTasksListStr = (String)request.getParameter("tasks");
	String[] jmsTasks = null;
	if (jmsTasksListStr != null){
		jmsTasks = jmsTasksListStr.split("#");
	}
	
	String onlyUpdateStr = request.getParameter("onlyUpdate");
	boolean onlyUpdate = onlyUpdateStr != null && onlyUpdateStr.equals("true");
	
	String TASK_ID = "ID";
	String DUPLICATE = "DUPLICATE";
	String ERROR_OBJ = "ERROR_OBJ";
	String id = request.getParameter(TASK_ID);
	String duplicateStr = request.getParameter(DUPLICATE);
	boolean duplicate = duplicateStr != null && duplicateStr.equals("true");
	
	String name = "";
	String description = "";
	String jmsMsg = "";
	
	String jmsAccId = "";
	
	String queueName = "";
	String topicName = "";
	String user = "";
	String password = "";
	
	XpoTask sessionTask = (XpoTask)request.getSession().getAttribute("XpoTask");
	request.getSession().removeAttribute("XpoTask");
	JMSTask task = null;
	if (sessionTask instanceof JMSTask){
		task = (JMSTask)sessionTask;
	}
	if(id != null){
		XpoTaskManager taskmgr = XpoTaskManager.getInstance();
		task = (JMSTask)taskmgr.getXpoTaskById(id); 
	}else{
		id = "";
	}
	if (task != null){
		if(!duplicate) {
			name = task.getName();
		}
		description = task.getDescription();
		jmsMsg = task.getJmsMsgStr();
		jmsAccId = task.getJmsAccountId();
		queueName = task.getQueueName();
		if (queueName == null){
			queueName = "";
		}
		topicName = task.getTopicName();
		if (topicName == null){
			topicName = "";
		}
		id = task.getId();
	}
	
	JMSAccountFilter filter = new JMSAccountFilter();
    AddressBook adbook = AddressBook.getInstance();
    List list = adbook.getAccountsByFilter(filter);
	/*if(list.size() == 0) {
	  	//No accounts defined in system
	  	ErrorModel errmodel = new ErrorModel();
	  	errmodel.addError("There is no JMS account defined, Please <a href=\"../tools/addresses/jms/accountJms.jsp\">create JMS account</a> first.");
	  	request.getSession().setAttribute(ERROR_OBJ,errmodel);
	    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
	    return;
  	}*/

  UserContext userContext = UserEnvironment.getUserContext(request);
%>

<%if (!embedded){%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<%} %>

<%if (!noScripts){%>
<script>
	
</script>
<%}%>
<%if (!embedded){%>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<%}%>
<%if (!scriptsOnly){%>
<%if (!onlyUpdate){%>
<input type="hidden" name="taskId<%=suffix%>" value="<%=duplicate ? "" : id%>">
<%}%>
<%if (!onlyUpdate){%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
		<td style="padding-right:30" id="taskDescriptionTD<%=suffix%>">
<%}%>  
		<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
			<%if (!embedded){%>
			<tr>
				<td style="padding-bottom:10;"><span class="REGULARTEXT"><%=jmsTaskLabel%></span></td>
			</tr>
			<%}%>
			<%if (jmsTasks != null){%>
			<tr>
				<td>
					<span class="REGULARTEXT">
						<%=existingTasksLabel%>:  
						<select id="jmsTasks" name="jmsTasks" onChange="updateFromJMSTask()">
							<option value="">-- Select Alert --</option>
							<%
							String t,tId,tName;
							int ind;
							for (int i=0; i<jmsTasks.length; i++){
								t = jmsTasks[i];
								ind = t.indexOf("^");
								if (ind != -1){
									tId = t.substring(0,ind);
									tName = t.substring(ind+1);
								}else{
									continue;
								}
							%>
							<option value="<%=tId%>"><%=tName%></option>
							<%}%>
						</select>
					</span>
				</td>
			</tr>
			<tr>
				<td style="padding-bottom:10;"><span class="SMALLTEXT"><%=existingTasksNote%></span></td>
			</tr>
			<%} %>
 			<tr>
				<td style="padding-top:10;padding-bottom:10;padding-left:30px;background-color:#E4E4E4">
					<table border="0" cellpadding="0" cellspacing="0" width="100%" >
						<tr>
							<td>
								<span class="REGULARTEXT">JMS Message Details</span>
							</td>
						</tr>
						<tr>
							<td style="padding-top:15px">
								<table border="0" cellpadding="0" cellspacing="0" width="100%" >
									<tr>
										<td width="100" nowrap><span class="REGULARTEXT"><b>Name</b></span></td>
										<td width="*">
											<input class="TEXTBOX" type="text" name="name<%=suffix%>" size="50" value="<%=name%>">
										</td>
									</tr>
									<tr>
										<td nowrap><span class="REGULARTEXT">Description</span></td>
										<td>
											<input class="TEXTBOX" type="text" name="description<%=suffix%>" size="50" value="<%=description%>">
										</td>
									</tr>
									<tr>
										<td colspan="2" style="padding-top:15;font-size:1">&nbsp;</td>
									</tr>
									<tr>
										<td>
											<span class="REGULARTEXT"><b>Connection Details</b></span>
										</td>
										<td width="150">
											<table border="0" cellpadding="0" cellspacing="0" width="100%">
							  				<tr>
							  					<td width="150">
							  						<div id="accountsListDiv">
															<jsp:include flush="true" page="../../common/accountsListCombo.jsp">
																<jsp:param name="ACC_TYPE" value="jms"/>
																<jsp:param name="ACC_ID" value="<%=jmsAccId%>"/>
																<jsp:param name="CHANGE_ACC_SELECTION" value="false"/>
																<jsp:param name="PREFIX" value="<%=PREFIX%>"/>
																<jsp:param name="noScripts" value="true"/>
															</jsp:include> 																								
														</div>
														<input type="hidden" id="jmsAccountId<%=suffix%>" name="jmsAccountId<%=suffix%>" value="<%=jmsAccId %>">
							  					</td>
							  					<%if (userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){%>
			    								<td align="left" style="padding-left:10"><a href="javascript:jmsNewAccount();" class="BUTTON_MEDIUMLINK">new</a></td>
			    								<%} %>
							  				</tr>
							  			</table>
		                 </td>
									</tr>
									<tr>
										<td nowrap><span class="REGULARTEXT">JMS Message</span></td>
										<td>
											<textarea class="TEXTBOX" rows="7" name="jmsMsg<%=suffix%>" cols="50"><%=jmsMsg%></textarea>
										</td>
									</tr>
								</table>
							</td>
						</tr>
					</table>
				</td>
			</tr>
		  <tr>
		  	<td style="font-size:3">&nbsp;</td>
		  </tr>
		  <tr>
				<td style="padding-top:10px;padding-left:30px;background-color:#F8F8F8">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" >
					<tr>
						<td><span class="REGULARTEXT"><b>General details</b></span></td>
					</tr>
					<tr>
						<td style="padding-top:15px">
						<table border="0" cellpadding="0" cellspacing="0" width="100%" >
							<tr>
								<td width="130"><span class="REGULARTEXT"><nobr>JMS Topic Name</nobr></span></td>
								<td width="*">
								<input class="TEXTBOX" type="text" name="topicName<%=suffix%>" size="45" value="<%=topicName%>"></td>
							</tr>
							<tr>
								<td width="130"><span class="REGULARTEXT">JMS Queue Name</span></td>
								<td width="*">
									<input class="TEXTBOX" type="text" name="queueName<%=suffix%>" size="45" value="<%=queueName%>">
								</td>
							</tr>                      
						</table>
						</td>
					</tr>
					<%if (!embedded){ %>
					<tr>
						<td>
						<table border="0" cellpadding="0" cellspacing="0" width="101%" >
							<tr>
								<td width="25%">&nbsp;</td>
								<td width="13%">
								<p align="center">&nbsp;</td>
								<td width="11%"><a href="javascript:history.go(-1)" class="LINK">cancel</a></td>
								<td width="11%"><a href="javascript:doSave()" class="LINK">save</a></td>
								<td width="35%">&nbsp;</td>
							</tr>
						</table>
						</td>
					</tr>
					<%} %>
				</table>
				</td>
			</tr>
		</table>
<%if (!onlyUpdate){%>
		</td>
	</tr>
	<tr height="100%">
		<td>&nbsp;</td>
	</tr>
</table>
<%}%>
<%}%>
<%if (!embedded){%>
</form>
</body>
</html>
<%}%>