<%@ page language="java"%>

<%@ page import="xpolog.eye.automation.tasks.jms.*"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>

<%!
  static final String BASE_DIRECTORY = "../../";
%>


<%
	String ACCOUNT_TYPE = "accountType";
	
	UserContext userContext = UserEnvironment.getUserContext(request);

	String jmsMsg = "";
	
	String accountId = "";
	
	String queueName = "";
	String topicName = "";
	
	JMSTask task = (JMSTask)request.getAttribute("CURRENT_TASK");
	String accountType = request.getParameter(ACCOUNT_TYPE);
	if(task != null){
		jmsMsg = task.getJmsMsgStr();
		accountId = task.getJmsAccountId();
		queueName = task.getQueueName();
		topicName = task.getTopicName();		
	}
	
	String accountListId = request.getParameter("accountListId");
	if(accountListId == null) {
		accountListId = "";
	}

%>

<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
	<tr>
		<td style="padding-left:15;padding-top:10">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr height="10">
			  	<td width="12%"><span class="REGULARTEXT">Connection Details *</span></td>
			    <td width="69%">
						<%
						String accountsListUrl = BASE_DIRECTORY + "common/accountsListCombo.jsp";
						%>
						<jsp:include flush="true" page="<%=accountsListUrl %>">
							<jsp:param name="ACC_TYPE" value="<%=accountType%>"/>
							<jsp:param name="ACC_ID" value="<%=accountId%>"/>
							<jsp:param name="ACC_LIST_ID" value="<%=accountListId %>"/>
							<jsp:param name="CHANGE_ACC_SELECTION" value="false"/>
							<jsp:param name="PREFIX" value=""/>
						</jsp:include>
			    <%
			    if (userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){
			    %>
			    <span class="SMALLTEXT"><a href="javascript:generalOpenNewAccountDiv()" class="BUTTON_MEDIUMLINK">new</a></span>
			    <%}%>
			    </td>
			  </tr>
			  <tr height="10">
          <td style="padding-top:10" nowrap><span class="REGULARTEXT">JMS message *</span></td>
          <td>
          <textarea class="TEXTBOX" rows="7" name="jmsMsg" cols="50"><%=jmsMsg%></textarea></td>
        </tr>
			  <tr height="10">
          <td style="padding-top:10" nowrap><span class="REGULARTEXT">JMS Topic name</span></td>
          <td>
          <input class="TEXTBOX" type="text" name="topicName" size="50" value="<%=topicName%>"></td>
        </tr>
        <tr height="10">
          <td style="padding-top:10" nowrap><span class="REGULARTEXT">JMS Queue Name</span></td>
          <td>
          <input class="TEXTBOX" type="text" name="queueName" size="50" value="<%=queueName%>"></td>
        </tr>
			  <tr height="10">
          <td style="padding-top:20" colspan="2">
          	<span class="SMALLTEXT">* marks a manadatory field</span>
          </td>
        </tr>
			  <tr>
			  	<td>&nbsp;</td>
			  </tr>
			</table>
		</td>
	</tr>
</table>