<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.automation.tasks.exe.ExeTask"%>
<%@ page import="xpolog.eye.automation.tasks.export.ExportModuleTask"%>
<%@ page import="xpolog.eye.automation.tasks.jms.JMSTask"%>
<%@ page import="xpolog.eye.automation.tasks.logic.session.SessionResultTask"%>
<%@ page import="xpolog.eye.automation.tasks.mail.MailTask"%>
<%@ page import="xpolog.eye.automation.tasks.pop.PopUpTask"%>
<%@ page import="xpolog.eye.automation.tasks.scan.ScanTask"%>
<%@ page import="xpolog.eye.automation.tasks.sms.SmsTask"%>
<%@ page import="xpolog.eye.automation.tasks.snmp.SNMPTask"%>
<%@ page import="xpolog.eye.automation.tasks.url.URLTask"%>
<%@ page import="xpolog.eye.security.*"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>
<% 
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.AutomationPermissions.VIEW_TASK_PERMISSION,true)){
    return;
  }

  SiteManagment mgmt = SiteManagment.getInstance();
  boolean txExpoViewer = mgmt.getXpologManagment().isTransactionExpoValidAndComponentExists();
%>

<form AUTOCOMPLETE="OFF" name="taskTypeForm" style="padding:0;margin:0">
<table border="0" cellpadding="0" cellspacing="0" width="100%" height="90%">
	<tr height="10">
		<td style="padding-top:5"><input name="taskType" type="radio" value="<%=ScanTask.TYPE_SCAN%>"></td>
		<td style="padding-top:5" class="REGULARTEXT">Add Logs Directory Task</td>
	</tr>
	<tr height="10">
		<td width="30" style="padding-top:5"><input name="taskType" type="radio" value="<%=ExeTask.TYPE_EXE %>"></td>
		<td class="REGULARTEXT" align="left" style="padding-top:5">Batch Execution Task</td>
	</tr>
	<tr height="10">
		<td style="padding-top:5"><input name="taskType" type="radio" value="<%=MailTask.TYPE_MAIL %>"></td>
		<td style="padding-top:5" class="REGULARTEXT">Email Task</td>
	</tr>
  <!--
  <tr height="10">
		<td style="padding-top:5"><input name="taskType" type="radio" value="<%=ExportModuleTask.TYPE_EXPORT_MODULE %>"></td>
		<td style="padding-top:5" class="REGULARTEXT">Export Folder Task</td>
	</tr>
	-->
  <tr height="10">
		<td style="padding-top:5"><input name="taskType" type="radio" value="<%=JMSTask.TYPE_JMS_TASK %>"></td>
		<td style="padding-top:5" class="REGULARTEXT">JMS Message Task</td>
	</tr>
  <!--
  <tr height="10">
		<td style="padding-top:5"><input name="taskType" type="radio" value="<%=PopUpTask.TYPE_POP %>"></td>
		<td style="padding-top:5" class="REGULARTEXT">POP3 Task</td>
	</tr>
  -->
  <tr height="10">
		<td style="padding-top:5"><input name="taskType" type="radio" value="<%=SNMPTask.SNMP_TASK_TYPE %>"></td>
		<td style="padding-top:5" class="REGULARTEXT">SNMP Trap Task</td>
	</tr>
  <!--
  <tr height="10">
		<td style="padding-top:5"><input name="taskType" type="radio" value="<%=SmsTask.TYPE_SMS %>"></td>
		<td style="padding-top:5" class="REGULARTEXT">SMS Task</td>
	</tr>
  -->
  <tr height="10">
		<td style="padding-top:5"><input name="taskType" type="radio" value="<%=ExeTask.TYPE_SSH_EXE %>"></td>
		<td style="padding-top:5" class="REGULARTEXT">SSH Execution Task</td>
	</tr>
	<%            
  if (txExpoViewer){
  %>
  <tr height="10">
		<td style="padding-top:5"><input name="taskType" type="radio" value="<%=SessionResultTask.TYPE_SESSION_TASK %>"></td>
		<td style="padding-top:5" class="REGULARTEXT">Transaction Execution Task</td>
	</tr>
  <%
  }
	%>
	<tr height="10">
		<td style="padding-top:5"><input name="taskType" type="radio" value="<%=URLTask.TYPE_URL %>"></td>
		<td style="padding-top:5" class="REGULARTEXT">URL Task</td>
	</tr>
  <tr>
		<td>&nbsp;</td>
	</tr>
</table>
</form>
<table border="0" cellpadding="0" cellspacing="0" width="100%" height="10%">
	<tr>
		<td align="left">
			<div id="taskTypeErrorMsg" style="display:none;" class="ERROR_MSG">
			</div>
		</td>
	</tr>		
</table>