<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.config.MailConfig"%>

<%
  
  String BASE_DIR = "base_directory";
	String baseDir = request.getParameter(BASE_DIR);
	if (baseDir == null || baseDir.equals("")) {
		baseDir = "";
	}
	String taskDivBaseDirectory = request.getParameter("taskDivBaseDirectory");
	if(taskDivBaseDirectory == null) {
		taskDivBaseDirectory = "";
	}
	String scriptsOnlyStr = request.getParameter("scriptsOnly");
	boolean scriptsOnly = scriptsOnlyStr != null && scriptsOnlyStr.equals("true");
	
	String noScriptsStr = request.getParameter("noScripts");
	boolean noScripts = noScriptsStr != null && noScriptsStr.equals("true");
	
	String embeddedStr = request.getParameter("embedded");
	boolean embedded = embeddedStr != null && embeddedStr.equals("true");
	
	String divStyle = request.getParameter("divStyle");
	if (divStyle == null || divStyle.length() == 0){
		divStyle = "position:absolute;width:400px;height:300px;display:none;z-index:110;border:solid 2px #DBDFE2"; 
	}
	
	String showSaveLinkStr = request.getParameter("showSaveLink");
	boolean showSaveLink = showSaveLinkStr == null || showSaveLinkStr.equals("true");
	String saveLinkName = request.getParameter("saveLinkName");
	if (saveLinkName == null || saveLinkName.length() == 0){
		saveLinkName = "save";
	}
	
	String showCloseLinkStr = request.getParameter("showCloseLink");
	boolean showCloseLink = showCloseLinkStr == null || showCloseLinkStr.equals("true");
	String closeLinkName = request.getParameter("closeLinkName");
	if (closeLinkName == null || closeLinkName.length() == 0){
		closeLinkName = "close";
	}
	
	Configuration conf = Configuration.getInstance();
	MailConfig mail = conf.getMailConfigurationManager();
	String host = mail.getSmtpHost();
  String port = String.valueOf(mail.getSmtpPort());
  String sysAddress = mail.getSystemMailAddress();
  String adminMail = mail.getAdminMail();
  
  String postconditionUrl = request.getParameter("postconditionUrl");
  if(postconditionUrl == null) {
  	postconditionUrl = "";
  }
  
  String isShortStr = request.getParameter("isShort");
  boolean isShort = isShortStr != null && isShortStr.equals("true");
  
  String message = request.getParameter("message");
  if(message == null || message.length() == 0) {
  	message = "Please specify the following mail settings before adding an email alert:";
  }
	
%>
<%if (!noScripts){%>
<script>
</script>
<%}%>
<%if (!scriptsOnly){%>

<input type="hidden" id="postconditionUrl" name="postconditionUrl" value="<%=postconditionUrl %>">

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" bgcolor="white">
  <tr>
		<td >
		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="100%">
			<tr>
				<td colspan="3">
					<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" >
						<tr>
							<td style="padding-top:10;padding-bottom:10;padding-right:15px;padding-left:15px;background-color:#E4E4E4">
							<table border="0" width="100%" cellspacing="0" cellpadding="0">
								<tr>
									<td colspan="2" style="padding-bottom:10"><span class="REGULARTEXT"><%=message %></span></td>
								</tr>
								<tr>
									<td width="40%"><span class="REGULARTEXT">SMTP Host</span></td>
									<td width="60%">
										<input type="text" id="SMTPHost" name="SMTPHost" class="TEXTBOX" size="24" value="<%=host%>">
									</td>
								</tr>
								<%if (!isShort){ %>
								<tr>
									<td>&nbsp;</td>
									<td>
										<span class="SMALLTEXT">example: mail.mydomain.com</span>
									</td>
								</tr>
								<%} %>
								<tr>
									<td><span class="REGULARTEXT">SMTP Port</span></td>
									<td>
										<input type="text" id="SMTPProt" name="SMTPProt" class="TEXTBOX" size="24" value="<%=port%>">
									</td>
								</tr>
								<%if (!isShort){ %>
								<tr>
									<td>&nbsp;</td>
									<td>
										<span class="SMALLTEXT">default: 25</span>
									</td>
								</tr>
								<%} %>
								<tr>
									<td><span class="REGULARTEXT">System Email Address</span></td>
									<td>
										<input type="text" id="systemMailAddress" name="systemMailAddress" class="TEXTBOX" size="24" value="<%=sysAddress%>">
									</td>
								</tr>
								<%if (!isShort){ %>
								<tr>
									<td>&nbsp;</td>
									<td>
										<span class="SMALLTEXT">example: system@mydomain.com</span>
									</td>
								</tr>
								<%} %>
								<tr>
									<td><span class="REGULARTEXT">Administrator Email Address</span></td>
									<td>
										<input type="text" id="adminMail" name="adminMail" class="TEXTBOX" size="24" value="<%=adminMail%>">
									</td>
								</tr>
								<%if (!isShort){ %>
								<tr>
									<td>&nbsp;</td>
									<td>
										<span class="SMALLTEXT">The email address of XpoLog administrator</span>
									</td>
								</tr>
								<%} %>
								<tr>
									<td colspan="2" style="padding-top:5">
										<span class="SMALLTEXT">* For advanced mail settings go to Settings -> General -> Mail</span>
									</td>
								</tr>
							</table>
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
	<tr height="100%">
		<td>&nbsp;</td>
	</tr>
</table>
<%}%>