<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.audit.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%

	UserContext userContext = UserEnvironment.getUserContext(request);
	String SMTP_HOST = "SMTPHost";
	String SMTP_PORT = "SMTPProt";
	String ERROR_OBJ = "ERROR_OBJ";

	ErrorModel err = new ErrorModel();
	
	MailConfig mail = xpolog.config.Configuration.getInstance().getMailConfigurationManager();

	String host = request.getParameter(SMTP_HOST);
	String port = request.getParameter(SMTP_PORT);
	if (host == null || host.trim().equals("")) {
		err.addError("No host was supplied.");
	}
	if (port == null || port.trim().equals("")) {
		err.addError("No port was supplied.");
	}

	String systemAddress = request.getParameter("systemMailAddress");
	String adminMail = request.getParameter("adminMail");

	if (err.getErrorCount() > 0) {
		request.getSession().setAttribute(ERROR_OBJ, err);
		response.sendRedirect("errorpage.jsp");
		return;
	}

	host = host.trim();
	port = port.trim();
	mail.setSmtpHost(host);
	mail.setSystemMailAddress(systemAddress);
	mail.setAdminMail(adminMail);
	try {
		mail.setSmtpPort(Integer.parseInt(port));
	} catch (Exception e) {
		err.addError("Port must be a valid number.");
		request.getSession().setAttribute(ERROR_OBJ, err);
		response.sendRedirect("errorpage.jsp");
		return;
	}

	//saving  
	xpolog.config.Configuration.getInstance().getMailConfigurationManager().saveMailSettings();
	
	//audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL, userContext, AuditConstants.CHANGE, "edit mail settings",
			AuditConstants.CONFIGURATION, "edit mail settings");

	response.setContentType("text/xml");
	out.write("ok");
	out.flush();
%>
