<%@ page language="java"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	//do whatever needed to remove the task
	String taskId = request.getParameter("taskId");
	boolean success = true;
	String message = "";
	if (taskId != null) {
		XpoTaskManager taskmgr = XpoTaskManager.getInstance();
		XpoTask task = taskmgr.getXpoTaskById(taskId);
		String name = "";
		if (task != null) {
			name = task.getName();
		}
		//audit
		AuditManager.getInstance().write(
				AuditConstants.BASIC_AUDIT_LEVEL, userContext,
				AuditConstants.CHANGE, "remove task",
				AuditConstants.ACCOUNTS, "remove task " + name);

		try {
			taskmgr.removeTask(taskId,userContext);
			success = true;
		} catch (Exception e) {
			ErrorModel.log.error("Failed to remove task " + name
					+ " with id " + taskId, e);
			success = false;
			message = e.getMessage();
		}
	}else {
		message = "No task was given, please refresh and try again";
	}
	String xml = GridModelActionsHelper.getResultXML(success, message);

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	
	out.write(xml);
	out.flush();
%>
