<%@ page language="java"%>

<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.sms.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	
	String Name,Description,SmsAccountId ,Id,smsMess;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	SmsAccountId = request.getParameter("SmsAccountId");
	smsMess = request.getParameter("SmsMessage");
	Id = request.getParameter("Id");
	
	ErrorModel errmodel = new ErrorModel(); 
		if(Name == null || Name.equals("")){
    	errmodel.addError("No Name was supplied.");
  	}

  	if(SmsAccountId== null || SmsAccountId.equals("")){
    	errmodel.addError("SMS Account was not supplied.");
  	}

  	if(errmodel.getErrorCount() != 0){
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
  	}
	
	SmsTask task = null;
	XpoTaskManager taskmgr = XpoTaskManager.getInstance();
	if(Id != null && Id.length() > 0){
		task = (SmsTask)taskmgr.getXpoTaskById(Id);
		
	}
	if(task == null){
		task = new SmsTask();
	}
	 
	task.setName(Name);
	task.setDescription(Description);
	task.setSmsAccountId(SmsAccountId);
	task.setSmsMessage(smsMess);
	
	taskmgr.addXpoTask(task,userContext);
	taskmgr.saveXpoTasks();
	
    //audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "task added/edited", AuditConstants.TASKS, "sms task added/edited " + Name);

    
	response.sendRedirect(BASE_DIRECTORY + "tasks/xpotasksview.jsp?taskType=sms");
%>