<%@ page language="java"%>

<%@ page import="java.util.*"%>

<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.snmp.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.snmp.*"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>

<%!
  static final String BASE_DIRECTORY = "../../";
%>


<%
	String ACCOUNT_TYPE = "accountType";

	UserContext userContext = UserEnvironment.getUserContext(request);

	String accountId = "";
	String snmpOid = "";
	String snmpCommunity = "";
	
	SNMPTaskVariable[] snmpTaskVariables = null, predefinedSnmpTaskVariables = null;
	
	SNMPTask task = (SNMPTask)request.getAttribute("CURRENT_TASK");
	String accountType = request.getParameter(ACCOUNT_TYPE);
	if(task != null){
		accountId = task.getSnmpAccountId();
		snmpOid = task.getSnmpOid();
		snmpCommunity = task.getSnmpCommunity();
		snmpTaskVariables = task.getSnmpTaskVariables();
	}
	
	SNMPConfiguration snmpConfig = new SNMPConfiguration();
	snmpConfig.loadPredefinedSnmpTaskVariables();
	predefinedSnmpTaskVariables = snmpConfig.getPredefinedSnmpTaskVariables();
	String predefinedSnmpTaskVariablesOids = "", predefinedSnmpTaskVariablesNames = "", predefinedSnmpTaskVariablesDescriptions = "", predefinedSnmpTaskVariablesTypes = "", predefinedSnmpTaskVariablesMessages = "";
	if(predefinedSnmpTaskVariables != null && predefinedSnmpTaskVariables.length > 0) {
		for(int i = 0; i < predefinedSnmpTaskVariables.length; i++) {
			predefinedSnmpTaskVariablesOids += ("\"" + predefinedSnmpTaskVariables[i].getOid() + "\"");
			predefinedSnmpTaskVariablesNames += ("\"" + predefinedSnmpTaskVariables[i].getName() + "\"");
			predefinedSnmpTaskVariablesDescriptions += ("\"" + predefinedSnmpTaskVariables[i].getDescription() + "\"");
			predefinedSnmpTaskVariablesTypes += ("\"" + predefinedSnmpTaskVariables[i].getType() + "\"");
			predefinedSnmpTaskVariablesMessages += ("\"" + predefinedSnmpTaskVariables[i].getMessage() + "\"");
			if(i < predefinedSnmpTaskVariables.length - 1) {
				predefinedSnmpTaskVariablesOids += ", ";
				predefinedSnmpTaskVariablesNames += ", ";
				predefinedSnmpTaskVariablesDescriptions += ", ";
				predefinedSnmpTaskVariablesTypes += ", ";
				predefinedSnmpTaskVariablesMessages += ", ";
			}
		}
		predefinedSnmpTaskVariablesOids = "[" + predefinedSnmpTaskVariablesOids + "]";
		predefinedSnmpTaskVariablesNames = "[" + predefinedSnmpTaskVariablesNames + "]";
		predefinedSnmpTaskVariablesDescriptions = "[" + predefinedSnmpTaskVariablesDescriptions + "]";
		predefinedSnmpTaskVariablesTypes = "[" + predefinedSnmpTaskVariablesTypes + "]";
		predefinedSnmpTaskVariablesMessages = "[" + predefinedSnmpTaskVariablesMessages + "]";
	}
	
	String accountListId = request.getParameter("accountListId");
	if(accountListId == null) {
		accountListId = "";
	}
	
%>

<script>
		var snmpTaskVariablesTypesValues = new Array();
		snmpTaskVariablesTypesValues = ['-1', '<%=SNMPTask.VARIABLE_TRAP_TIME_TYPE %>', '<%=SNMPTask.VARIABLE_LOG_TIME_TYPE %>', '<%=SNMPTask.VARIABLE_TIME_TYPE %>', '<%=SNMPTask.VARIABLE_TEXT_TYPE %>', '<%=SNMPTask.VARIABLE_INTEGER_TYPE %>', '<%=SNMPTask.VARIABLE_UNSIGNED_INTEGER_TYPE %>', '<%=SNMPTask.VARIABLE_IP_ADDRESS_TYPE %>', '<%=SNMPTask.VARIABLE_STATUS_TYPE %>', '<%=SNMPTask.VARIABLE_COUNTER_32_TYPE %>', '<%=SNMPTask.VARIABLE_COUNTER_64_TYPE %>', '<%=SNMPTask.VARIABLE_GAUGE_32_TYPE %>', '<%=SNMPTask.VARIABLE_SMI_ADDRESS_TYPE %>', '<%=SNMPTask.VARIABLE_TCP_ADDRESS_TYPE %>', '<%=SNMPTask.VARIABLE_TIME_TICKS_TYPE %>', '<%=SNMPTask.VARIABLE_UDP_ADDRESS_TYPE %>'];
		var snmpTaskVariablesTypesTexts = new Array();
		snmpTaskVariablesTypesTexts = ['--- Select type ---', 'Trap Time', 'Log Time', 'Time', 'Text', 'Integer 32', 'Unsigned Integer 32', 'IP Address', 'Status', 'Counter 32', 'Counter 64', 'Gauge 32', 'SMI Address', 'TCP Address', 'Time ticks', 'UDP Address'];

		var predefinedSnmpTaskVariablesOids = new Array();
		var predefinedSnmpTaskVariablesNames = new Array();
		var predefinedSnmpTaskVariablesDescriptions = new Array();
		var predefinedSnmpTaskVariablesTypes = new Array();
		var predefinedSnmpTaskVariablesMessages = new Array();
		<%
		if(predefinedSnmpTaskVariables != null && predefinedSnmpTaskVariables.length > 0) {
			//for(int i = 0; i < predefinedSnmpTaskVariables.length; i++) {
		%>
			predefinedSnmpTaskVariablesOids = <%=predefinedSnmpTaskVariablesOids %>;
			predefinedSnmpTaskVariablesNames = <%=predefinedSnmpTaskVariablesNames %>;
			predefinedSnmpTaskVariablesDescriptions = <%=predefinedSnmpTaskVariablesDescriptions %>;
			predefinedSnmpTaskVariablesTypes = <%=predefinedSnmpTaskVariablesTypes %>;
			predefinedSnmpTaskVariablesMessages = <%=predefinedSnmpTaskVariablesMessages %>;
		<%
			//}
		}
		%>
    
    function showHideAddNewVariables(index) {
			var addNewVariablesDiv = document.getElementById("addNewVariablesDiv");
			var display = addNewVariablesDiv.style.display;
			if(display == "none"){
				addNewVariablesDiv.style.display  = "";
			}else {
				addNewVariablesDiv.style.display  = "none";
			}
		}
		
		function changeVariable(index) {
			document.getElementById("newVariableSelectionTypePredefined").checked = true;
			document.getElementById("newVariableSelectionTypeCustom").checked = false;
			if(index == 0) {
				document.getElementById("newVariableOid").value = "";
				document.getElementById("newVariableName").value = "";
				document.getElementById("newVariableDescription").value = "";
				document.getElementById("newVariableType").selectedIndex = 0;
				document.getElementById("newVariableMessage").value = "";
			}else {
				document.getElementById("newVariableOid").value = predefinedSnmpTaskVariablesOids[index - 1];
				document.getElementById("newVariableName").value = predefinedSnmpTaskVariablesNames[index - 1];
				document.getElementById("newVariableDescription").value = predefinedSnmpTaskVariablesDescriptions[index - 1];
				for(i = 1; i < document.getElementById("newVariableType").options.length; i++) {
					if(document.getElementById("newVariableType").options[i].value == predefinedSnmpTaskVariablesTypes[index - 1]) {
						document.getElementById("newVariableType").selectedIndex = i;
						break;
					}
				}
				document.getElementById("newVariableMessage").value = predefinedSnmpTaskVariablesMessages[index - 1];
			}
			handleTimeType(document.getElementById("newVariableType"), document.getElementById("newVariableMessage"));
		}
		
		function handleTimeType(select, text) {
			/*if(select.value == 0) {
				text.value = "[TRAP_TIME]";
				text.readOnly = true;
			}else if(select.value == 1) {
				text.value = "[LOG_TIME]";
				text.readOnly = true;
			}else {
				text.value = "";
				text.readOnly = false;
			}*/
		}
		
		function addNewVariable() {
			if(document.getElementById("newVariableOid").value == "") {
				alert("OID was not specified");
				return;
			}else if(document.getElementById("newVariableName").value == "") {
				alert("Name was not specified");
				return;
			}else if(document.getElementById("newVariableType").selectedIndex == 0) {
				alert("Type was not specified");
				return;
			}
		
			var numOfVariables = document.getElementById("numOfVariables");
			num = parseInt(numOfVariables.value) + 1;
			var maxVariableIndex = document.getElementById("maxVariableIndex");
			max = parseInt(maxVariableIndex.value) + 1;
			
			var newDiv = document.createElement('div');
			newDiv.setAttribute("id", "variable" + max + "Div");
			
			var html = '  <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >' + 
				         '    <tr>' + 
				         '    <input type="hidden" name="variable' + max + 'Visible" value="true">' +
								 '      <td width="18%"><input class="TEXTBOX" type="text" name="variableOid' + max + '" size="25" value="' + document.getElementById("newVariableOid").value + '">' + 
								 '      <td width="18%"><input class="TEXTBOX" type="text" name="variableName' + max + '" size="25" value="' + document.getElementById("newVariableName").value + '">' + 
								 '      <td width="18%"><input class="TEXTBOX" type="text" name="variableDescription' + max + '" size="25" value="' + document.getElementById("newVariableDescription").value + '">' + 
								 '			<td width="18%">' +
				         '	     	<select class="TEXTBOX" name="variableType' + max + '" size="1">';
			var selectedType = document.getElementById("newVariableType").value;
			for(i = 0; i < snmpTaskVariablesTypesValues.length; i++) {
				var selected = "";
				if(selectedType == snmpTaskVariablesTypesValues[i]) {
					selected = "selected";
				}else {
					selected = "";
				}
				html +=  '               		<option value="' + snmpTaskVariablesTypesValues[i] + '" ' + selected + '>' + snmpTaskVariablesTypesTexts[i] + '</option>';
			}
			html +=    '               	</select>' +
				         '               </td>' +
								 '      <td width="18%"><input class="TEXTBOX" type="text" name="variableMessage' + max + '" size="25" value="' + document.getElementById("newVariableMessage").value + '">' + 
								 '      <td width="10%"><a href="javascript:removeVariable(' + max + ')" class="LINK">Remove</a></td>' + 
								 '    </tr>' + 
				         '  </table>'; 
			newDiv.innerHTML = html;
			var variablesDiv = document.getElementById("variablesDiv");
			variablesDiv.appendChild(newDiv);
			
			numOfVariables.value = num;
			maxVariableIndex.value = max;
		}
		
		function removeVariable(index) {
			var variableDiv = document.getElementById("variable" + index + "Div");
			variableDiv.style.display = "none";
			
			var numOfVariables = document.getElementById("numOfVariables");
			num = parseInt(numOfVariables.value) - 1;
			numOfVariables.value = num;
			
			var variableVisible = document.getElementById("variable" + index + "Visible");
			variableVisible.value = "false";
		}

</script>

<input type="hidden" id="numOfVariables" name="numOfVariables" value="<%=(snmpTaskVariables != null) ? snmpTaskVariables.length : 0 %>">
<input type="hidden" id="maxVariableIndex" name="maxVariableIndex" value="<%=(snmpTaskVariables != null) ? snmpTaskVariables.length : 0 %>">

<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
	<tr>
		<td style="padding-left:15;padding-top:10">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr height="10">
			  	<td width="12%"><span class="REGULARTEXT">Connection Details *</span></td>
			    <td width="69%">
						<%
						String accountsListUrl = BASE_DIRECTORY + "common/accountsListCombo.jsp";
						%>
						<jsp:include flush="true" page="<%=accountsListUrl %>">
							<jsp:param name="ACC_TYPE" value="<%=accountType%>"/>
							<jsp:param name="ACC_ID" value="<%=accountId%>"/>
							<jsp:param name="ACC_LIST_ID" value="<%=accountListId %>"/>
							<jsp:param name="CHANGE_ACC_SELECTION" value="false"/>
							<jsp:param name="PREFIX" value=""/>
						</jsp:include>
			    <%
			    if (userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){
			    %>
			    <span class="SMALLTEXT"><a href="javascript:generalOpenNewAccountDiv()" class="BUTTON_MEDIUMLINK">new</a></span>
			    <%}%>
			    </td>
			  </tr>
			  <tr height="10">
          <td style="padding-top:10" nowrap><span class="REGULARTEXT">SNMP Trap OID *</span></td>
          <td>
          	<input class="TEXTBOX" type="text" name="snmpOid" size="50" value="<%=snmpOid%>">&nbsp;<span class="SMALLTEXT">mandatory when account is SNMP version 2</span>
          </td>
        </tr>
        <tr height="10">
          <td style="padding-top:10" nowrap><span class="REGULARTEXT">SNMP Community</span></td>
          <td>
           <input class="TEXTBOX" type="text" name="snmpCommunity" size="50" value="<%=snmpCommunity%>">&nbsp;<span class="SMALLTEXT">default is public</span>
          </td>
        </tr>
			  <tr height="10">
          <td style="padding-top:20" colspan="2">
          	<span class="SMALLTEXT">* marks a manadatory field</span>
          </td>
        </tr>
        <tr height="10">
        	<td colspan="2" style="padding-top:10">
        		<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
        			<tr>
			          <td width="15%" height="18"><span class="HEADER">SNMP Trap Variables</span></td>
			        </tr>
			        <tr>
			          <td width="15%" height="18"></td>
			        </tr>
			        <tr>
			        	<td><a href="javascript:showHideAddNewVariables()" class="LINK">Add new variables</a></td>
			        </tr>
			        <tr>
			          <td width="15%" height="5"></td>
			        </tr>
			        <tr>
			        	<td>
			         		<div id="addNewVariablesDiv" style="display:none">
			      			<table border="0" width="100%" cellspacing="0" cellpadding="0">
			            	<tr>
			           			<td width="21%"><input type="radio" id="newVariableSelectionTypePredefined" name="newVariableSelectionType" value="predefined" checked><span class="REGULARTEXT">Select a predefined variable:&nbsp;</span></td>
			           			<td>
			           				<select id="predefinedVariables" class="TEXTBOX" onchange="javascript:changeVariable(this.selectedIndex)">
			           					<option value="0">--- Select variable ---</option>
			           					<%
													if(predefinedSnmpTaskVariables != null && predefinedSnmpTaskVariables.length > 0) {
														for(int i = 0; i < predefinedSnmpTaskVariables.length; i++) {
													%>
													<option value="<%=predefinedSnmpTaskVariables[i].getOid() %>"><%=predefinedSnmpTaskVariables[i].getName() %></option>
													<%
														}
													} 
													%>
			            			</select>
			            		</td>
			           		</tr>
			           		<tr>
			           			<td colspan="2"><input type="radio" id="newVariableSelectionTypeCustom" name="newVariableSelectionType" value="custom"><span class="REGULARTEXT">Create a custom variable:&nbsp;</span></td>
			           		</tr>
			           		<tr>
			             		<td colspan="2" width="15%" height="10"></td>
			           		</tr>
			           		<tr>
			           			<td colspan="2" width="100%">
			           				<table border="0" width="100%" cellspacing="0" cellpadding="0">
				             			<tr>
					                  <td width="18%"><span class="REGULARTEXT">OID</span></td>
					                  <td width="18%"><span class="REGULARTEXT">Name</span></td>
			    		              <td width="18%"><span class="REGULARTEXT">Description</span></td>
			        		          <td width="18%"><span class="REGULARTEXT">Type</span></td>
			            		      <td width="18%"><span class="REGULARTEXT">Message</span></td>
			                		  <td width="10%"></td>
			                		</tr>
			                		<tr>
			                  		<td><input class="TEXTBOX" type="text" id="newVariableOid" name="newVariableOid" size="25" value="">
			                  		<td><input class="TEXTBOX" type="text" id="newVariableName" name="newVariableName" size="25" value="">
			                  		<td><input class="TEXTBOX" type="text" id="newVariableDescription" name="newVariableDescription" size="25" value="">
			                  		<td>
			                  			<select class="TEXTBOX" id="newVariableType" name="newVariableType" size="1" onchange="javascript:handleTimeType(this, document.access.newVariableMessage)">
			                  				<script>
																for(i = 0; i < snmpTaskVariablesTypesValues.length; i++) {
																	document.write('<option value="' + snmpTaskVariablesTypesValues[i] + '">' + snmpTaskVariablesTypesTexts[i] + '</option>');
																}
																</script>
			                  			</select>
			                  		</td>
			                  		<td><input class="TEXTBOX" type="text" id="newVariableMessage" name="newVariableMessage" size="25" value="">
			                  		<td width="10%"><a href="javascript:addNewVariable()" class="LINK">Add</a></td>
			                		</tr>
			              		</table>
			            		</td>
			             </tr>
									</table>
									</div>
			        	</td>
			        </tr>
			        <tr>
			          <td width="15%" height="18"></td>
			        </tr>
			        <tr>
			        	<td width="100%">
			        		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
			        			<tr>
			            	  <td width="15%" height="5"></td>
			            	</tr>
			            	<tr>
			            		<td>
			            			<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
			                 	<tr>
				                 	<td><span class="SMALLTEXT">The following variable types are available:</span></td>
			                 	</tr>
			                 	<tr>
				                 	<td><span class="SMALLTEXT"><b>Trap Time:</b> the time of the SNMP trap. Specify the date format in the Message column, or leave empty for default date format (MM/dd/yyyy HH:mm:ss)</span></td>
			                 	</tr>
			                 	<tr>
				                 	<td><span class="SMALLTEXT"><b>Log Time:</b> the time of the event. Specify the date format in the Message column, or leave empty for default date format (MM/dd/yyyy HH:mm:ss)</span></td>
			                 	</tr>
			                 	<tr>
				                 	<td><span class="SMALLTEXT"><b>Time:</b> the value of a date column from the event. Specify the column name in square brackets. Add the date format after the column name (i.e: [Date;MM/dd/yyyy]) or leave empty for default date format (as configured in the log)</span></td>
			                 	</tr>
			                 	<tr>
				                 	<td><span class="SMALLTEXT"><b>Text:</b> free text or the value of any column from the event. Specify the column name in square brackets</span></td>
			                 	</tr>
			                 	<tr>
				                 	<td><span class="SMALLTEXT"><b>Status:</b> the status of the event</span></td>
			                 	</tr>
			                 	<tr>
				                 	<td><span class="SMALLTEXT"><b>Other Types:</b> the value of a column from the event (choose the type matching the data in the event, i.e. Integer 32 for a numeric value and IP Address for an IP address). Specify the column name in square brackets</span></td>
			                 	</tr>
				               </table>
			            		</td>
			            	</tr>
			        			<tr>
			              	<td width="15%" height="5"></td>
			            	</tr>
			            	<tr>
				              <td width="15%" height="18"><span class="REGULARTEXT" style="font-weight:bold">Existing Variables</span></td>
			            	</tr>
			            	<tr>
				              <td width="15%" height="5"></td>
			            	</tr>
			            	<tr>
			             	<td width="15%" >
			               	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
			                 	<tr>
			                   	<td width="18%"><span class="REGULARTEXT">OID</span></td>
			                   	<td width="18%"><span class="REGULARTEXT">Name</span></td>
			                  	<td width="18%"><span class="REGULARTEXT">Description</span></td>
			                   	<td width="18%"><span class="REGULARTEXT">Type</span></td>
			                   	<td width="18%"><span class="REGULARTEXT">Message</span></td>
			                   	<td width="10%"></td>
			                 	</tr>
				              </table>
			             	</td>
			           	</tr>
			            <tr>
			           		<td width="15%">
			            		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
			            		  <tr>
			              		  <td width="15%">
			            					<div id="variablesDiv">
			            		    	<%
			            					if(snmpTaskVariables != null && snmpTaskVariables.length > 0) {
			            						SNMPTaskVariable snmpTaskVariable = null;
			            						for(int i = 1; i <= snmpTaskVariables.length; i++) {
			            							snmpTaskVariable = snmpTaskVariables[i - 1];
			           		 				%>
			             					<div id="variable<%=i %>Div">
			                     	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
			             						<tr>
			             							<input type="hidden" id="variable<%=i %>Visible" name="variable<%=i %>Visible" value="true">
			                        	<td width="18%"><input class="TEXTBOX" type="text" id="variableOid<%=i %>" name="variableOid<%=i %>" size="25" value="<%=snmpTaskVariable.getOid()%>">
			                        	<td width="18%"><input class="TEXTBOX" type="text" id="variableName<%=i %>" name="variableName<%=i %>" size="25" value="<%=snmpTaskVariable.getName()%>">
			                        	<td width="18%"><input class="TEXTBOX" type="text" id="variableDescription<%=i %>" name="variableDescription<%=i %>" size="25" value="<%=snmpTaskVariable.getDescription()%>">
			                        	
			                        	<td width="18%">
																	<select class="TEXTBOX" id="variableType<%=i %>" name="variableType<%=i %>" size="1" onchange="javascript:handleTimeType(this, document.access.variableMessage<%=i %>)">
			   													<script>
			   													var selected = "";
			   													for(i = 0; i < snmpTaskVariablesTypesValues.length; i++) {
																		if(snmpTaskVariablesTypesValues[i] == '<%=snmpTaskVariable.getType() %>') {
																			selected = "selected";
																		}else {
																			selected = "";
																		}
																		document.write('<option value="' + snmpTaskVariablesTypesValues[i] + '" ' + selected + '>' + snmpTaskVariablesTypesTexts[i] + '</option>');
																	}
																	</script>
																	</select>
																</td>
			              	          <td width="18%"><input class="TEXTBOX" type="text" id="variableMessage<%=i %>" name="variableMessage<%=i %>" size="25" value="<%=snmpTaskVariable.getMessage()%>">
			                	      	<td width="10%"><a href="javascript:removeVariable(<%=i %>)" class="LINK">Remove</a></td>
			                  	   	</tr>
			             					</table>
			             					</div>
			            					<%
			            						}
			            					}
			            					%>
			            					</div>
			              			</td>
			            			</tr>
			            		</table>
			            	</td>
			            </tr>
			        	</table>
			        </td>
			       </tr>
			      </table>
			    </td>
			  </tr>
			  <tr>
			  	<td>&nbsp;</td>
			  </tr>
			</table>
		</td>
	</tr>
</table>