<%@ page language="java"%>

<%@ page import="xpolog.eye.site.ui.grid.GridTable"%>
<%@ page import="xpolog.eye.site.ui.grid.models.TasksGridTableModel"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, null, true)) {
		return;
	}

	String isFilterStr = request.getParameter("isFilter");
  boolean isFilter = isFilterStr != null && isFilterStr.equals("true"); 

	String selectOnlyStr = request.getParameter("selectOnly");
  boolean selectOnly = selectOnlyStr != null && selectOnlyStr.equals("true"); 

	UserContext userContext = UserEnvironment.getUserContext(request);
	
	
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = "../";
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	TasksGridTableModel model = new TasksGridTableModel();
	model.setBaseDirectory(baseDirectory);
	model.setUserContext(userContext);
	model.setSelectOnly(selectOnly);
	model.setGridName("mygrid" + suffix);
	model.init();
	GridTable table = new GridTable(model);
	request.setAttribute("gridTable" + suffix,table);
	
	request.getRequestDispatcher(baseDirectory + "widgets/grid/jsp/initTableXML.jsp").forward(request, response);	
%>