<%@ page language="java"%>

<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.url.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	
	String Name,Description,HttpAccountId,Id;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	HttpAccountId = request.getParameter("HttpAccountId");
	Id = request.getParameter("Id");
	
	ErrorModel errmodel = new ErrorModel(); 
		if(Name == null || Name.equals("")){
    	errmodel.addError("Name was not supplied");
  	}

  	if(HttpAccountId == null || HttpAccountId.equals("")){
    	errmodel.addError("Http account was not supplied.");
  	}

  	if(errmodel.getErrorCount() != 0){
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
  	}
	
	URLTask task = null;
	XpoTaskManager taskmgr = XpoTaskManager.getInstance();
	if(Id != null){
		task = (URLTask)taskmgr.getXpoTaskById(Id);
		
	}
	if(task == null){
		task = new URLTask();
	}
	
	task.setName(Name);
	task.setDescription(Description);
	task.setHttpAccountId(HttpAccountId);
	
	taskmgr.addXpoTask(task,userContext);
	taskmgr.saveXpoTasks();
	
    //audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "task added/edited", AuditConstants.TASKS, "url task added/edited " + Name);

	response.sendRedirect(BASE_DIRECTORY + "tasks/xpotasksview.jsp?taskType=url");
%>

