<%@ page language="java"%>

<%@ page import="xpolog.eye.automation.tasks.exe.ExeTask"%>
<%@ page import="xpolog.eye.automation.tasks.export.ExportModuleTask"%>
<%@ page import="xpolog.eye.automation.tasks.jms.JMSTask"%>
<%@ page import="xpolog.eye.automation.tasks.logic.session.SessionResultTask"%>
<%@ page import="xpolog.eye.automation.tasks.mail.MailTask"%>
<%@ page import="xpolog.eye.automation.tasks.pop.PopUpTask"%>
<%@ page import="xpolog.eye.automation.tasks.scan.ScanTask"%>
<%@ page import="xpolog.eye.automation.tasks.sms.SmsTask"%>
<%@ page import="xpolog.eye.automation.tasks.snmp.SNMPTask"%>
<%@ page import="xpolog.eye.automation.tasks.url.URLTask"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request,response,ActionsPermissionConstants.AutomationPermissions.VIEW_TASK_PERMISSION,true)){
  return;
}
UserContext userContext = UserEnvironment.getUserContext(request);

boolean isEdit = manager.isHavePermission(userContext,ActionsPermissionConstants.AutomationPermissions.EDIT_TASK_PERMISSION);
boolean isExecute = manager.isHavePermission(userContext,ActionsPermissionConstants.AutomationPermissions.EXECUTE_TASK_PERMISSION);

String lastSelectedRow = (String)request.getSession().getAttribute("lastSelectedTask");
if (lastSelectedRow == null){
	lastSelectedRow = "";
}

String openTaskTypeStr = request.getParameter("openTaskType");
boolean openTaskType = openTaskTypeStr != null && openTaskTypeStr.equals("true");

%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>

<jsp:include page="../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<%
boolean showMenu = isEdit || isExecute;
if(showMenu) {
	String menuIds = "executeTask,editTask,duplicateTask,removeTask";
	String menuTexts = "Execute,Edit,Duplicate,Delete";
	String menuHrefs = "javascript:executeTask0();,javascript:editTask0();,javascript:duplicateTask0();,javascript:removeTask0();";
%>
<jsp:include page="../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		</jsp:include>
	<jsp:include page="../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	</jsp:include>
<%
}
%>

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";  
	
  function init() {
		<%
		if(openTaskType) {
		%>
			goNew();
		<%
		}
		%>
	}
	
  function goNew(){
  	showGeneralAdminDiv("taskType", -1, 100);
  }
  
  function goNewTask() {
  	var taskTypeErrorMsgElement = document.getElementById("taskTypeErrorMsg");
 		if(taskTypeErrorMsgElement) {
 			taskTypeErrorMsgElement.style.display ="none";
 		}
 		
	  var taskType = document.taskTypeForm.taskType;
	  var selectedType = "";
	  if(taskType) {
		  for(var i = 0; i < taskType.length; i++) {
	  		if(taskType[i].checked) {
		      selectedType = taskType[i].value;
	      }
	   	}
	  }

  	if(selectedType == "") {
  		if(taskTypeErrorMsgElement) {
  			taskTypeErrorMsgElement.style.display ="";
				taskTypeErrorMsgElement.innerHTML = "Task type was not selected";
				return;
  		}
  	}
  
  	var path = "";
  	var checkPrecondition = false;
  	if(selectedType == "<%=ExeTask.TYPE_EXE %>") {
  		path = "execute/taskExe.jsp";
  	}else if(selectedType == "<%=ExeTask.TYPE_SSH_EXE %>") {
  		path = "execute/taskExe.jsp?IsSsh=true";
  		checkPrecondition = true;
  	}else if(selectedType == "<%=PopUpTask.TYPE_POP %>") {
  		path = "pop/taskPop.jsp";
  	}else if(selectedType == "<%=URLTask.TYPE_URL %>") {
  		path = "url/taskURL.jsp";
  		checkPrecondition = true;
  	}else if(selectedType == "<%=MailTask.TYPE_MAIL %>") {
  		path = "mail/taskMail.jsp";
  		checkPrecondition = true;
  	}else if(selectedType == "<%=SmsTask.TYPE_SMS %>") {
  		path = "sms/taskSms.jsp";
  		checkPrecondition = true;
  	}else if(selectedType == "<%=ExportModuleTask.TYPE_EXPORT_MODULE %>") {
  		path = "export/taskExportModuleRedirect.jsp";
  	}else if(selectedType == "<%=JMSTask.TYPE_JMS_TASK %>") {
  		path = "jms/taskJms.jsp";
  		checkPrecondition = true;
  	}else if(selectedType == "<%=SNMPTask.SNMP_TASK_TYPE %>") {
  		path = "snmp/taskSnmp.jsp";
  		checkPrecondition = true;
  	}else if(selectedType == "<%=SessionResultTask.TYPE_SESSION_TASK %>") {
  		path = "session/taskSession.jsp";
  	}else if(selectedType == "<%=ScanTask.TYPE_SCAN %>") {
  		path = "scan/taskScan.jsp";
  	}
  	if(path != "") {
  		/*if(checkPrecondition == true) {
  			sendAjaxRequest("checkTaskPrecondition.jsp?taskType=" + selectedType,function(req){
					var preconditionResult = req.responseText;
					if(trim(preconditionResult) == "ok") {
						document.location = path;
					}else {
						//var preconditionUrl = "../tasks/mail/mailSettings.jsp";
						//showPrecondition("MailAlert",url,preconditionUrl);
						alert("no account was found for type " + selectedType);
					}
				});
  		}else {
  			document.location = path;
  		}*/
  		path = "xpotaskDefinition.jsp?TASK_TYPE=" + selectedType;
  		document.location = path;
  	}
  }
  
  function closeTaskTypeDiv() {
		showHideGeneralAdminDiv("taskType");
	}
  
  function doEdit(){
    var taskId = getFirstSelectedRow(mygrid);
    if (taskId == "") {
     return;
    }
    doEdit1(taskId);
  }
  
  function doEdit1(taskId){
    path = "taskAction.jsp?ID=" + taskId;
  	document.location = path;
  }
  
  function doDuplicate() {
  	var taskId = getFirstSelectedRow(mygrid);
    if (taskId == "") {
     return;
    }
  	doDuplicate1(taskId);
  }
  
  function doDuplicate1(taskId) {
  	path = "taskAction.jsp?ID="+taskId+"&DUPLICATE=true";
  	document.location = path;
  }
  
  function doDelete(){
    var taskId = getFirstSelectedRow(mygrid);
    if (taskId == "") {
      return;
    }
    doDelete1(taskId);
  }
  
  function doDelete1(taskId){
    var name = mygrid.cells(taskId,0).getValue();
    var row = taskId;
    var msgWriter = new messageWriter("mygridMessage","Task Delete Action","<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid"),50);
    msgWriter.addAction("Yes","javascript:hideLayer('mygridMessage');javascript:doDelete0('" + row + "','" +  taskId + "')");
    msgWriter.addAction("No","javascript:hideLayer('mygridMessage')");  
    msgWriter.showMessage("<nobr>Are you sure you want to delete task </nobr>" + name + "?");
  }
  
  function doDelete0(row,id){
  	deleteGridRow(mygrid,row,baseDirectory + "tasks/removeTaskAction.jsp?taskId=" + id + "&timestamp=" + new Date().getTime());
  }
  
  function doExecute(){
   	var id = getFirstSelectedRow(mygrid);
    if (id == "") {
      return;
    }
		doExecute1(id);
  }
  
  function doExecute1(id){
   	var url = "runTask.jsp?TASK_ID=" + id;
		sendAjaxRequest(url,function(req){
			updateTable();
		});
		setTimeout("updateTable()",200);
  }
	
	function handleMenuItems(){
 		<% if (isEdit || isExecute){%>
 			<%if(isExecute) {%>
 				aMenu.menu.showButtons("executeTask");
 			<%} %>
    	<%if(isEdit) {%>
 			 aMenu.menu.showButtons("editTask,duplicateTask,removeTask");
 			<%} %>
 		<%}else {%>
		  aMenu.menu.hideBar();
 		<%}%>
  }
  
  function executeTask0(){
    if (contextRowId && contextRowId != ""){
      doExecute1(contextRowId);
    }
  }
  
  function editTask0(){
    if (contextRowId && contextRowId != ""){
      doEdit1(contextRowId);
    }
  }
  
  function duplicateTask0(){
    if (contextRowId && contextRowId != ""){
      doDuplicate1(contextRowId);
    }
  }
  
  function removeTask0(){
    if (contextRowId && contextRowId != ""){
      doDelete1(contextRowId);
    }
  }

</script>
</head>

<%
String onLoadFunctions = "initTables();init()";
if(showMenu) {
	onLoadFunctions = "initMenus();" + onLoadFunctions;
}
%>
<body onLoad="<%=onLoadFunctions %>" onUnload="destroyTables()" style="margin:0;padding:0;overflow:auto;" >

<jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="title" value="Select the type of task to add"/> 
	<jsp:param name="suffix" value="taskType"/> 
	<jsp:param name="width" value="650px"/> 
	<jsp:param name="height" value="290px"/> 
	<jsp:param name="includePath" value="tasks/listOfTasks.jsp"/> 
	<jsp:param name="actionsNames" value="Continue#Cancel"/> 
	<jsp:param name="actions" value="javascript:goNewTask()#javascript:closeTaskTypeDiv()"/> 
</jsp:include>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td valign="top">
      <table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              
	      <tr height="10">
          <td>
	          <jsp:include page="../common/pageMainHeader.jsp" flush="true">
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="headerTitle" value="Tasks" />
						</jsp:include>		
         	</td>
        </tr>
        <tr>                
          <td valign="top"> 
          <% 
          String addName = isEdit ? "New Task" : "";
          String addLink = isEdit ? "javascript:goNew()" : "";
          
          String tableNames = isEdit ? "Edit#Duplicate#Delete" : "";
          String tableActions = isEdit ? "javascript:doEdit()#javascript:doDuplicate()#javascript:doDelete()" : "";
          String ids = isEdit ? "Edit#Duplicate#Delete" : "";
          String selectTypes = isEdit ? "2#2#2" : "";
          
          if (tableNames.length() > 0){
        		tableNames += "*;*";
        		tableActions += "*;*";
        		ids += "*;*";
        		selectTypes += "*;*";
        	}
          if(isExecute) {
         		tableNames += "Execute#";
       			tableActions += "javascript:doExecute()#";
       			ids += "Execute#";
       			selectTypes += "2#";
          }
          
          String menu = showMenu ? "aMenu" : "";
          
          %>
						<jsp:include page="../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="initXML" value="tasks/xpotasksViewXML.jsp" />
							<jsp:param name="updateXML" value="tasks/xpotasksViewXML.jsp?dataOnly=true" />
							<jsp:param name="menu" value="<%=menu%>"/>
							<jsp:param name="newActionNames" value="<%=addName%>" />
							<jsp:param name="newActions" value="<%=addLink%>" />
							<jsp:param name="tableActionNames" value="<%=tableNames%>" />
							<jsp:param name="tableActions" value="<%=tableActions%>" />
							<jsp:param name="tableActionIds" value="<%=ids%>" />
							<jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
							<jsp:param name="recordsText" value="Tasks" />
							<jsp:param name="style" value="main" />
							<jsp:param name="doubleClickAction" value="doEdit" />
							<jsp:param name="lastSelectedRow" value="<%=lastSelectedRow%>" />
							<jsp:param name="showSelectedRowOnLoad" value="true" />
						</jsp:include>
        	</td>
      	</tr>      
    	</table>
    </td>
  </tr>
</table>

<script>
	function updateButtonActivate(rowid,id,columnType,gridType){
	  if (!id || id == "") return;
	   /*var isMulti = mygrid.getUserData(rowid,"isMulti"); 
		 if (isMulti && isMulti == "true" && id == "ShowResult"){
		   gridType = 0;
		 }*/
		 var isVerifiable = mygrid.getUserData(rowid,"isVerifiable");
	   if ((id != "Verify" || isVerifiable == "true") && (gridType == columnType || (gridType == 2))){
	 	   enableActionButton(id);
	 	 }else {
	 	   disableActionButton(id);
	 	 }
	}
</script>

</body>

</html>