<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.template.*"%>
<%@ page import="xpolog.eye.template.log.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.merge.*"%>

<%@ page import="java.util.*"%>
<%
  //constants
  String CURRENT_LOG = "CURRENT_LOG";
  String ERROR_OBJ = "ERROR_OBJ";
  String CURRENT_TEMPLATE = "CURRENT_TEMPLATE";
  String logid = "logid";
  String id = request.getParameter(logid);
  LogBrowsingManager lbm = null;
  if(id != null && !(id.trim().equals(""))){
    lbm = SiteManagment.getInstance().getLogBrowserManager(id);
  }else{
    lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  }
  
  ErrorModel ermod = new ErrorModel();
  if(lbm == null || lbm.getId() == null){     
      ermod.addError("You must select a log before saving as Template.");      
  }else {
  	 if(lbm instanceof MergedLogBrowserManager || lbm instanceof xpolog.eye.remote.ProxyLogBrowser){
  		 ermod.addError("This type of log cannot be saved as a template.");      
  	 }
  	
  }
  
  if(ermod.getErrorCount() > 0){
  	request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect("errorpage.jsp");
    return;
  }

    SimpleLogTemplateBuilder builder = (SimpleLogTemplateBuilder)TemplateBuilderFactory.getTemplateBuilderByType(TemplateBuilderFactory.SIMPLE_LOG_TYPE);
    builder.setManager(lbm);
    Template template = builder.buildTemplate();
    request.getSession().setAttribute(CURRENT_TEMPLATE,template);
    response.sendRedirect("saveastemplate.jsp");
%>