<%@page import="xpolog.eye.knowledge.util.ReplacePattern"%>
<%@ page language="java"%>

<%@page import="java.util.regex.Pattern"%>
<%@page import="xpolog.eye.knowledge.log.prepattern.LogAdminSignature"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.template.*"%>
<%@ page import="xpolog.eye.template.log.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%
  String CURRENT_TEMPLATE = "CURRENT_TEMPLATE";
  String ERROR_OBJ = "ERROR_OBJ";

  SiteManagment mgmt = SiteManagment.getInstance();
  TemplateManager tmgr  = mgmt.getTemplateManager();
  UserContext userContext = UserEnvironment.getUserContext(request);
  ErrorModel errormodel = new ErrorModel();
  
  Template template = (Template)request.getSession().getAttribute(CURRENT_TEMPLATE);
  if(template == null){
      ErrorModel ermod = new ErrorModel();
      ermod.addError("Can not find any template to show please select a Template!");
      request.getSession().setAttribute(ERROR_OBJ,ermod);
      response.sendRedirect("errorpage.jsp");
      return;
  }
  String name = request.getParameter("TEMPLATE_NAME");
  String desc = request.getParameter("TEMPLATE_DESCRIPTION");
  boolean useInScan = true;
  String useInScanStr = request.getParameter("USE_IN_SCAN");
  if(useInScanStr != null && useInScanStr.equals("false")){
  	useInScan = false;
  }
  boolean useValidation = true;
  String useValidationStr = request.getParameter("USE_VALIDATION");
  if(useValidationStr != null && useValidationStr.equals("false")){
  	useValidation = false;
  }
  String ignoreNameExprStr = request.getParameter("IGNORE_NEXPR");
  boolean ignoreNameExpr = false;
  if(ignoreNameExprStr != null && ignoreNameExprStr.equals("true")){
  	ignoreNameExpr = true;
  }
  String signature = request.getParameter("SIGNATURE");
  if(signature == null || signature.length() == 0){
  	signature = "";
  }
  String linesNumStr = request.getParameter("LINES_NUM");
  if(linesNumStr == null || linesNumStr.length() == 0){
  	linesNumStr = "";
  }
  int lineNum = 0;
  if(linesNumStr.length() > 0){
  	try{
	  	lineNum = Integer.parseInt(linesNumStr);
  	}catch(Throwable e){
  		errormodel.addError("Please check again the number of firs events info.");
  	}
  }
  String regexStr = request.getParameter("REGEX_STR");
  if(regexStr == null || regexStr.length() == 0){
  	regexStr = "";
  }
  
  String replaceStr = request.getParameter("REPLACE_STR");
  if(replaceStr == null || replaceStr.length() == 0){
  	replaceStr = "";
  }
  if(name == null || name.trim().equals("")){
    errormodel.addError("Template must have a name,please supply a name for the Template.");
  }
  
  if((regexStr.length() > 0 && replaceStr.length() == 0)  || (regexStr.length() == 0 && replaceStr.length() > 0)){
  	errormodel.addError("File replace statment must have both (or none) fields set.");
  }
  if(errormodel.getErrorCount() > 0){
    request.getSession().setAttribute(ERROR_OBJ,errormodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  
  if (template instanceof LogTemplate){
  	LogTemplate logTemplate = (LogTemplate)template;
  	LogAdminTemplate adminTemplate = new LogAdminTemplate();
    adminTemplate.setUseInScan(useInScan);
    adminTemplate.setUsePatternOnly(ignoreNameExpr);
    adminTemplate.setUseValidation(useValidation);
    if(signature.length() > 0){
    	LogAdminSignature sig = new LogAdminSignature();    
    	Pattern p = Pattern.compile(signature);
    	sig.setPatterns(new Pattern[]{p});
    	if(lineNum > 0){
    		sig.setNumOfEvents(lineNum);
    	}
    	adminTemplate.setSignatures(new LogAdminSignature[]{sig});    	
    }   
    if(regexStr.length() > 0 && replaceStr.length() > 0){
  		ReplacePattern repPattern = new ReplacePattern();
  		repPattern.setRegexp(regexStr);
  		repPattern.setReplcaeString(replaceStr);
  		adminTemplate.setFileReplaceStatments(new ReplacePattern[]{repPattern});		   	
  	}
  	logTemplate.setLogAdminTemplate(adminTemplate);
  	
  }
  
  template.setName(name);
  template.setDescription(desc);
  tmgr.addUserTemplate(template,userContext);
  
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "save log as template", AuditConstants.CONFIGURATION, "save log as template " + name);
  
  response.sendRedirect("addopok.jsp");

%>