<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.template.*"%>
<%@ page import="xpolog.eye.template.log.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@page import="xpolog.eye.util.XpologUtil"%>
<%@page import="xpolog.eye.knowledge.log.prepattern.LogAdminSignature"%>
<%@page import="java.util.regex.Pattern"%>
<%@page import="xpolog.eye.knowledge.util.ReplacePattern"%>
<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
  String CURRENT_TEMPLATE = "CURRENT_TEMPLATE";
  String ERROR_OBJ = "ERROR_OBJ";
  String templateId = "templateId";
  SiteManagment mgmt = SiteManagment.getInstance();
  TemplateManager tmgr  = mgmt.getTemplateManager();
  String id = request.getParameter(templateId);
  Template template = null;
  if(id != null && !(id.trim().equals(""))){
    template = tmgr.getTemplateById(id);
  }else{
    template = (Template)request.getSession().getAttribute(CURRENT_TEMPLATE);
  }
  if(template == null){
        ErrorModel ermod = new ErrorModel();
        ermod.addError("Can not find any template to show please select a Template!");
        request.getSession().setAttribute(ERROR_OBJ,ermod);
        response.sendRedirect("errorpage.jsp");
        return;
  }
  final boolean useValidationDefualt = Configuration.getInstance().getPropertiesManager().getProperty("xpolog.eye.admin.wizards.common.scanner.useValidation","true").equalsIgnoreCase("true");;
  boolean useInScan = true;
  boolean usePatternOnly = false;
  boolean useValidation = useValidationDefualt;
  String signatureStr = "";
  String numOfEventsStr = "";
  String regexpStr = "";
  String replacStr = "";
  if(template instanceof LogTemplate ) {
  	LogTemplate _template = (LogTemplate)template;  	
  	if(_template.getLogAdminTemplate() != null){
		  	useInScan =  _template.getLogAdminTemplate().isUseInScan();
		  	usePatternOnly =   _template.getLogAdminTemplate().isUsePatternOnly();
		  	LogAdminSignature []sigArr = _template.getLogAdminTemplate().getSignatures();
		  	Pattern []pattarnArr = sigArr != null && sigArr.length > 0 && sigArr[0] != null ? sigArr[0].getPatterns() : null;
		  	for(int i = 0 ;pattarnArr != null && i < pattarnArr.length; i ++){
		  		if(i > 0){
		  			signatureStr += ",";
		  		}
		  		signatureStr += pattarnArr[i].pattern();
		  	}  	
		  	numOfEventsStr = sigArr != null && sigArr.length > 0 && sigArr[0] != null ? String.valueOf(sigArr[0].getNumOfEvents()) : "";
		  	ReplacePattern  []repPatternArr = _template.getLogAdminTemplate().getFileReplaceStatments();
		  	if(repPatternArr != null && repPatternArr.length >0){
		  		regexpStr = repPatternArr[0].getRegexp();
		  		replacStr = repPatternArr[0].getReplcaeString();
		  	}
		  	useValidation = _template.getLogAdminTemplate().isUseValidation();
		 }
  }
  request.getSession().setAttribute(CURRENT_TEMPLATE,template);
%>
<%@page import="xpolog.config.Configuration"%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>


<script>
  function operationOk(){
	  if(!document.access.IgnoreNameExpr.checked){	
			document.access.Signature.value = "";		
			document.access.LineNumber.value = "";	  
	  }else{
	    var num = document.access.LineNumber.value;
	    if(num && num.length > 0){
	    	var ok = validateInt(num);
	    	if(!ok){
	    		alert(num + " is not a number.");
	    		return;
	    	}
	    }
	  }
    var path ="saveastemplaction.jsp?";
    path = path + "TEMPLATE_NAME=" + document.access.TemplateName.value;
    path = path + "&" + "TEMPLATE_DESCRIPTION=" + document.access.TemplateDescription.value;
    path = path + "&" + "USE_IN_SCAN=" + document.access.TemplateToUseInScan.checked;
    path = path + "&" + "IGNORE_NEXPR=" + document.access.IgnoreNameExpr.checked;
    path = path + "&" + "SIGNATURE=" + document.access.Signature.value;
    path = path + "&" + "LINES_NUM=" + document.access.LineNumber.value;
    path = path + "&" + "REGEX_STR=" + document.access.regexStr.value;
    path = path + "&" + "REPLACE_STR=" + document.access.replaceStr.value;
    path = path + "&" + "USE_VALIDATION=" + document.access.useTempalteValidation.checked;
    document.location = path;
  }
  
  
  function validateInt(n){
  		if(n == null || n.length == 0 ){
  			return true;
  		}
  		for (var i = 0; i < n.length; i++)
      {
         var c = n.charAt(i);

         if (!((c >= "0") && (c <= "9"))) return false;
      }
      return true;  
  }
  
  function shownHideAdv(){
		var vis = document.getElementById("advancedDiv").style.display == "";
		if(vis){
			document.getElementById("advancedDiv").style.display  = "none";		
		}else{
			document.getElementById("advancedDiv").style.display  = "";
		}	
	}
	
	function showHideSignature(){
		if(document.access.IgnoreNameExpr.checked){		
			document.getElementById("signatureDiv").style.display  = "";		
		}else{
			document.getElementById("signatureDiv").style.display  = "none";
		}
	}
	
	
	function showHideIgnoreAndValidate(){
			if(document.access.TemplateToUseInScan.checked){		
			document.getElementById("ignoreNameExprDiv").style.display  = "";		
			document.getElementById("useValidationDiv").style.display  = "";					
		}else{
			document.getElementById("useValidationDiv").style.display  = "none";
			document.getElementById("ignoreNameExprDiv").style.display  = "none";
			document.getElementById("signatureDiv").style.display  = "none";
			document.access.IgnoreNameExpr.checked = false;			
		}
	}
  
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
  <!--    <tr>
        <td valign="top" style="border-left: 1px solid #FF9900; border-right-width: 1; border-top-width: 1; border-bottom-width: 1" height="1">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="TOPLEFTBORDER " width="33%"  height="2"></td>
            <td class="TOPBORDER" width="33%" height="2"></td>
            <td class="TOPRIGHTBORDER"  width="34%" height="2"></td>
          </tr>
        </table>
        </td>
      </tr>-->
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Save Template</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">General</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      <tr>
                        <td width="23%"><span class="HEADER">Name</span></td>
                        <td width="77%">
                        <%String templateName = template.getName();
	                        templateName = XpologUtil.replaceAll(templateName,"\"","&quot;");
                        %>
                        <input class="REGULARTEXT" type="text" name="TemplateName" size="30" value="<%=templateName%>"></td>
                      </tr>
                      <tr>
                        <td width="23%"><span class="HEADER">Description</span></td>
                        <td width="77%">
                        <input class="REGULARTEXT" type="text" name="TemplateDescription" size="53" value="<%=template.getDescription()%>"></td>
                      </tr>
                    </table>
                    </td>
                  </tr>            
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  
                  <tr>
                  	<td>
   		                  <table border="0" width="100%" cellspacing="0" cellpadding="0">
                  			       <tr>
			                  					 <td colspan="2"><a id="AdvancedLink" href="javascript:shownHideAdv()" class="SMALLLINK">Advanced</a></td>
			                  				</tr>
			                  				<tr>
			                  						<td>&nbsp;</td>
			                  				</tr>
                  							<tr>   
                  							   <td colspan="2">
								                      <div id="advancedDiv" style="display:none">
			    					                  <table border="0" width="100%" cellspacing="0" cellpadding="0">
									                  				<tr>
									                  						<td><span class="HEADER">Scanner Wizard Settings</span></td>
									                  				</tr>
						                  							<tr>
								                  						<td>&nbsp;</td>
			    						              				</tr>
			                		  								<tr>   
						                  							   <td colspan="2">
									    					                  <table border="0" width="100%" cellspacing="0" cellpadding="0">			    					                    					                  			    					                  			    					                  			    					                  
								                  												<tr>
																              				      <td width="2%">&nbsp;</td>                      
																              				      <td width="98%">                      
								                  									  			   <input class="REGULARTEXT" type="checkbox" <%=useInScan ? "checked" : "" %> name="TemplateToUseInScan" id="TemplateToUseInScan" onClick="showHideIgnoreAndValidate()"><span class="REGULARTEXT">&nbsp;Include template while running wizard</span>
											          	      	     							</td>
								      					      	   	     				  </tr>			                 			
								      					      	   	     				  <tr height="3">
											    				              						<td>&nbsp;</td>
																                  				</tr>
																                  				<tr>
																              				      <td width="2%">&nbsp;</td>                      
																              				      <td width="98%">                      
								            		                  								<table border="0" width="100%" cellspacing="0" cellpadding="0">			    					                    					                  			    					                  			    					                  			    					                  					                					        																				                  				
																					                  				<tr>
																					              				      <td width="95%">                      
																		                  								<div id="useValidationDiv" style="display:">
													                  									  			   <input class="REGULARTEXT" type="checkbox" <%=useValidation ? "checked" : "" %> name="useTempalteValidation" id="useTempalteValidation"><span class="REGULARTEXT">&nbsp;Use template's validation while running wizard</span>
																          	      	     							</div>  																          	      	     							
																          	      	     							</td>
													      					      	   	     				  </tr>			            
																                  								</table>
																                  						</td>
																                  				</tr>				
																                  				   			
								      					      	   	     				  <tr height="3">
											    				              						<td>&nbsp;</td>
																                  				</tr>																                  				
																                  				<tr>   
														                  							  <td width="2%">&nbsp;</td>                      
																              				      	<td width="98%"> 
																              				      			<div id="ignoreNameExprDiv" style="display:">     
																	    					                  <table border="0" width="100%" cellspacing="0" cellpadding="0">			    					                    					                  			    					                  			    					                  			    					                  					                					        																				                  				
														      					      	   	     				  <tr>
																						              				      <td width="95%">                      
														                  									  			   <input class="REGULARTEXT" type="checkbox" <%=usePatternOnly ? "checked" : "" %> name="IgnoreNameExpr" id="IgnoreNameExpr" onClick="showHideSignature()"><span class="REGULARTEXT">&nbsp;Ignore file's name expression</span>
																	          	      	     							</td>
														      					      	   	     				  </tr>			                 			
														      					      	   	     				  <tr height="3">
																	    				              						<td>&nbsp;</td>
																						                  				</tr>
														      					      	   	     				  <tr>
																						              				      <td width="95%">     
																										              				      <div id="signatureDiv" style="display:<%=usePatternOnly ? "" : "none"%>">     
																										              				        <table border="0" width="100%" cellspacing="0" cellpadding="0">																					              				        																					              				         																				              				       	
																											              				        <tr>
																																												<td>
																																														<table border="0" width="100%" cellspacing="0" cellpadding="0">
																																															<tr>								              				      					
																																																	<td width="180px">
																																																			<span class="REGULARTEXT">Search Signature</span>
																																																	</td>
																																																	<td width="60px">
																												                  									  			   <input class="REGULARTEXT" type="textbox" name="Signature" size ="50" id="Signature" value="<%=signatureStr%>">
																																																	</td>
																																																	<td width="20px">&nbsp;</td>
																																											     				<td width="60px">
																																																				<span class="REGULARTEXT">in first</span>
																																																	</td>
																																																	<td width="200px">
																																								          					   <input class="REGULARTEXT" type="textbox" name="LineNumber " id="LineNumber" size="6" value="<%=numOfEventsStr%>"><span class="REGULARTEXT">&nbsp;&nbsp; events.</span>
																																																	</td>
    																																															<td width="*">&nbsp;</td>
																																														  </tr>																																								  																											                  				  																																																																																																																																										
																												              				      					</table>
																																											</td>																				              				        
																											              				        </tr>	
																											              				        <tr>
																											              				        		<td>
																															              				        <table border="0" width="100%" cellspacing="0" cellpadding="0">																					              				        							<tr>
																																		              				        		<td width="520px"><span class="SMALLTEXT">Regular expression to confirm template match.</span></td>
																																		              				        		<td width="*"><span class="SMALLTEXT">If empty, search in all events.</span></td>																	              				        																							              				        							
																											              				        							</tr>
																											              				        				</table>
																											              				        		</td>
																											              				        </tr>	
																																										<tr>
																														              				      <td width="95%">&nbsp;</td>      																				              				        
																														              				  </tr>	
																														              				  <tr>  																														              				           																				              				        
																																												<td>
																																              				      <span class="HEADER">File replace statment:</span>
																														              				      </td>
																														              				  </tr>																														            																														              				 
																											              				         <tr>
						 																				              				        		<td>
																														              				        <table border="0" width="100%" cellspacing="0" cellpadding="0">																					              				        																					              				         																				              				        										 																				              				         																														               				  	
																																				              				  <tr>
																																				              				      <td width="180px">
																																																					<span class="REGULARTEXT">Replace file name (regex)</span>
																																																		</td>
																																																		<td width="45px">
																																		                  								   <input class="REGULARTEXT" type="textbox" name="regexStr" size ="30" id="regexStr" value="<%=regexpStr%>">
																																																		</td>																																																																																								
																																																		<td width="20px">&nbsp;</td>																																																																																								
																																																		<td width="20px">
																																																					<span class="REGULARTEXT">With&nbsp;&nbsp;</span>
																																																		</td>
																																																		<td width="45px">
																																		                  								   <input class="REGULARTEXT" type="textbox" name="replaceStr" size ="30" id="replaceStr" value="<%=replacStr%>" >
																																																		</td>																																																																																								
																																																		<td width="*">&nbsp;</td>																																												
																																																		
																																				              				  </tr>    
																											              				      					</table>
																											              				      			</td>
																											              				      	</tr>		
																											              				      	 <tr>
						 																				              				        		<td>
																														              				        <table border="0" width="100%" cellspacing="0" cellpadding="0">																					              				        																					              				         																				              				        										 																				              				         
																																				            					<tr>
																																				            					<td width="100%"><span class="SMALLTEXT">Replace file name using regex. <b>Example:</b> logname.log1 , regexp to replace - (.*)\d+  with $1{number},<br>
																																				            																									 result - logname.log{number}.   <a href=javascript:openHelp('<%=BASE_DIRECTORY%>',"Pattern.htm") title="open patterns help page" class="SMALLLINK">pattern help</a></span></td>
																																				            					</tr>
																																				            			</table>
																																				            	</td>
																																				           </tr> 																								              				        							              				        																				              				        
																										              				        </table>																				              				        																				              				        																				              				                  															  			    					                  																              				      																					              				      																					              				      					
																						              				      			</div>
																	          	      	     							</td>
														      					      	   	     				  </tr>	    					      	   	     				  								      					      	   	     				  
								      					      	   	     				  </table>
								      					      	   	     				  </div>
								      					      	   	     				</td>
								      					      	   	     		</tr>		  								      					      	   	     				  								      					      	   	     				  
								      					      	   				  </table>
								      					      				  </td>
								      					      	    </tr>	   	     				        					      	   	     				        					      	   	     				  		                 			      					      	   	     				        					      	   	     				  
                  										</table>
                  										</div>
							                  	</td>
              							    </tr>                                                                             
              							 </table>
	         							 </td>
	         					</tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="35%">&nbsp;</td>
                    <td width="11%" align="center"><a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK">
                    cancel</a></td>
                    <td width="7%" align="center"><a href='javascript:operationOk()' class="LINK">
                    save</a></td>
                    <td width="27%">&nbsp;</td>
                    <td width="20%">&nbsp;</td>
                  </tr>
                </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>