<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.template.*"%>
<%@ page import="xpolog.eye.template.log.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
  String ERROR_OBJ = "ERROR_OBJ";
  String TEMP_CURRENT_LOG = "TEMP_CURRENT_LOG";
  request.getSession().removeAttribute(TEMP_CURRENT_LOG);

  SiteManagment mgmt = SiteManagment.getInstance();
  TemplateManager tmg = mgmt.getTemplateManager();
  MetaDataCategoriesManager mdcmgr = mgmt.getMetaDataCategoriesManager();
  UserContext userContext = UserEnvironment.getUserContext(request);

  String categoryId = request.getParameter("CategoryId");
  if (categoryId == null || categoryId.equals("")){
  	categoryId = MetaDataCategory.ROOT_CATEGORY_ID;
  }
  MetaDataCategory cat = mdcmgr.getMetaDataCategory(categoryId);
  String letterSysTemplate = request.getParameter("LetterSysTemplate");
  if (letterSysTemplate == null || letterSysTemplate.equals("")){
  	letterSysTemplate = "all";
  }
  String letterUserTemplate = request.getParameter("LetterUserTemplate");
  if (letterUserTemplate == null || letterUserTemplate.equals("")){
  	letterUserTemplate = "all";
  }

  Template[] tsysarr = tmg.getAllSystemTemplates(userContext);
  Template[] tusrarr = tmg.getAllUserTemplates(userContext);
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
  function operationOk(){
  }
  
  function refreshByCategory(category){
  	document.access.CategoryId.value = category;
  	document.access.LetterSysTemplate.value = "all";
  	document.access.submit();
  }
  
  function refreshByLetterSysTemplate(letter){
  	document.access.LetterSysTemplate.value = letter;
  	document.access.submit();
  }
  
  function refreshByLetterUserTemplate(letter){
  	document.access.LetterUserTemplate.value = letter;
  	document.access.submit();
  }
  
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" action="templateview.jsp">
<input type="hidden" name="CategoryId" value="<%=categoryId%>">
<input type="hidden" name="LetterSysTemplate" value="<%=letterSysTemplate%>">
<input type="hidden" name="LetterUserTemplate" value="<%=letterUserTemplate%>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
  <!--    <tr>
        <td valign="top" style="border-left: 1px solid #FF9900; border-right-width: 1; border-top-width: 1; border-bottom-width: 1" height="1">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="TOPLEFTBORDER " width="33%"  height="2"></td>
            <td class="TOPBORDER" width="33%" height="2"></td>
            <td class="TOPRIGHTBORDER"  width="34%" height="2"></td>
          </tr>
        </table>
        </td>
      </tr>-->
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Templates </span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td><span class="HEADER">User defined templates</span></td>
                  </tr>
                  <tr><td></td></tr>
                  <tr>
	                  <td>
		                  <table border="0" cellpadding="0" cellspacing="0">
		                  <tr>
		                  	<td><a class="MEDIUMLINK" <%=letterUserTemplate.equals("all")?"style=\"background-color:#CCCCCC; padding:4px;\"":""%> href="javascript:refreshByLetterUserTemplate('all')">all</a>&nbsp;</td>
		                  <%
		                  for (char i='a'; i<='z'; i++){
		                  	String l = Character.toString(i);
		                  	String style = l.equals(letterUserTemplate) ? "style=\"background-color:#CCCCCC; padding:4px;\"" : "";
		                  	boolean showLink = TemplateHelper.contains(tusrarr,l);
		                  %>
		                  	<td>&nbsp;
		                  	<%if (showLink){%>
		                  	<a class="MEDIUMLINK" <%=style%> href="javascript:refreshByLetterUserTemplate('<%=i%>')"><%=i%></a>
		                  	<%} else {%>
		                  	<span class="DISABLEDLINK"><%=i%></span>
		                  	<%}%>
		                  	</td>
		                  <%}%>
		                  </tr>
		                  </table>
		                </td>
                 	</tr>
                  <tr><td></td></tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr class="TABLES_HEADERS">
                        <td width="16%"><span class="REGULARTEXT">Name</span></td>
                        <td width="50%"><span class="REGULARTEXT">Description</span></td>
                        <td width="24%">&nbsp;</td>
                        <td width="10%"></td>
                      </tr>
                     <%
										  if (!(letterUserTemplate.equals("all"))){
										  	tusrarr = TemplateHelper.getAllTemplatesByFilter(tusrarr,null,letterUserTemplate);
										  }
                      for(int t=0;t<tusrarr.length;t++){
                     %>
                      <tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
			  <td width="16%"><a href="saveastemplate.jsp?templateId=<%=tusrarr[t].getId()%>" class="LINK"><%=tusrarr[t].getName()%></a></td>
                          <td width="50%"><span class="REGULARTEXT"><%=tusrarr[t].getDescription()%></span></td>
                          <td width="24%">&nbsp;<a href="createlogaction.jsp?templateId=<%=tusrarr[t].getId()%>" class="LINK">create log</a>  <a href="removeopcheck.jsp?templateId=<%=tusrarr[t].getId()%>" class="LINK">delete</a></td>
                        <td width="10%"></td>
                       </tr>
                      <%
                        }
                      %>
                        <tr>
			  <td width="16%">&nbsp;</td>
                          <td width="50%"></td>
                          <td width="24%"></td>
                         <td width="10%"></td>
                       </tr>
                    </table>
                   </td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td>
                    <span class="HEADER">System defined templates</span>
                    </td>
                  </tr>
                 	<!-- 
                  <tr>
                  	<td>
                  	<table border="0" cellpadding="0" cellspacing="0">
                  	<tr>
	                  	<td>
	    	              <%
	                  	MetaDataCategory mdCat = cat;
	                  	List list = new LinkedList();
	                  	MetaDataCategory[] mdcarr = mdcmgr.getPathFromRoot(mdCat);
	                  	for (int i=0; i<mdcarr.length; i++){
	                  		mdCat = mdcarr[i];
	      	            %>
			                  <a class="MEDIUMLINK" href="javascript:refreshByCategory('<%=mdCat.getId()%>')"><%=mdCat.getName()%></a>&nbsp;&gt;&nbsp;
	        	          <%}%>
			                <a class="MEDIUMLINK" style="background-color:#CCCCCC; padding:4px;" href="javascript:refreshByCategory('<%=cat.getId()%>')"><%=cat.getName()%></a>&nbsp;</td>
			              <%if(cat.getParent() != null && (cat.getMembers() != null && cat.getMembers().size() != 0)){%>
			              </tr>
		                <tr>
		                <%}%>
	              	    <td style="padding-left:10">
	              	    <%
										  List categoryMembers = cat.getMembers();
										  Iterator it = categoryMembers.iterator();
	                  	while (it.hasNext()){
	                  		mdCat = (MetaDataCategory)it.next();
	                	  %>
			              	  <nobr><a class="MEDIUMLINK" href="javascript:refreshByCategory('<%=mdCat.getId()%>')"><%=mdCat.getName()%></a>&nbsp;&nbsp;</nobr>
		                  <%}%>
		                  </td>
	                  </tr>
	                  </table>
	                  </td>
                  </tr>
                  -->
                  <tr><td></td></tr>
                  <tr>
	                  <td>
		                  <table border="0" cellpadding="0" cellspacing="0">
		                  <tr>
		                  	<td><a class="MEDIUMLINK" <%=letterSysTemplate.equals("all")?"style=\"background-color:#CCCCCC; padding:4px;\"":""%> href="javascript:refreshByLetterSysTemplate('all')">all</a>&nbsp;</td>
		                  <%
		                  for (char i='a'; i<='z'; i++){
		                  	String l = Character.toString(i);
		                  	String style = l.equals(letterSysTemplate) ? "style=\"background-color:#CCCCCC; padding:4px;\"" : "";
		                  	boolean showLink = TemplateHelper.contains(tsysarr,l);
		                  %>
		                  	<td>&nbsp;
		                  	<%if (showLink){%>
		                  	<a class="MEDIUMLINK" <%=style%> href="javascript:refreshByLetterSysTemplate('<%=i%>')"><%=i%></a>
		                  	<%} else {%>
		                  	<span class="DISABLEDLINK"><%=i%></span>
		                  	<%}%>
		                  	</td>
		                  <%}%>
		                  </tr>
		                  </table>
		                </td>
                 	</tr>
                  <tr><td></td></tr>
                  <tr>
                    <td>

                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr class="TABLES_HEADERS">
                        <td width="16%"><span class="REGULARTEXT">Name</span></td>
                        <td width="50%"><span class="REGULARTEXT">&nbsp; Description</span></td>
                        <td width="24%">&nbsp;</td>
                        <td width="10%"></td>
                      </tr>
                     <%
										  if (!categoryId.equals(MetaDataCategory.ROOT_CATEGORY_ID) || !(letterSysTemplate.equals("all"))){
										  	tsysarr = TemplateHelper.getAllTemplatesByFilter(tsysarr,categoryId,letterSysTemplate);
										  }
                      for(int i=0;i<tsysarr.length;i++){
                     %>
                      <tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
											  <td width="16%"><span class="REGULARTEXT"><%=tsysarr[i].getName()%></span></td>
                        <td width="50%"><span class="REGULARTEXT">&nbsp;<%=tsysarr[i].getDescription()%></span></td>
                        <td width="24%">&nbsp;<a href="createlogaction.jsp?templateId=<%=tsysarr[i].getId()%>" class="LINK">create log</a></td>
                        <td width="10%"></td>
                       </tr>
                      <%}%>
                      <tr>
			  								<td width="16%">&nbsp;</td>
                        <td width="50%"></td>
                        <td width="24%"></td>
                        <td width="10%"></td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="35%">&nbsp;</td><td width="13%" align="center"><a href="javascript:history.go(-1)" class="LINK">
                    previous</a></td>
                    <td width="13%" align="center"><a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK">
                    cancel</a></td>
                    <td width="5%" align="center"></td>
                    <td width="27%">&nbsp;</td>
                    <td width="20%">&nbsp;</td>
                  </tr>
                </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>