<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	AddressBook adbok = AddressBook.getInstance();
	
	String id = null;
	String type = null;
	
	id = request.getParameter("ID");
	type = request.getParameter("TYPE");
	
	ErrorModel errmodel = new ErrorModel();
	
	if(id == null){
		errmodel.addError("Please supply Id for Account to delete.");
	}
	
	Account acc = adbok.getAccountById(id);
	if (acc == null){
		errmodel.addError("Failed to delete account");
		errmodel.addError("Account might have been deleted by another user");
	}

	if(errmodel.getErrorCount() > 0){
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		return;
	}
	
	String name = acc.getAccountName();
    //audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "remove account", AuditConstants.CONFIGURATION, "remove account " + name);

	
	adbok.removeAccount(id,userContext);
	
	boolean refreshMenus = false;
	if(type != null && type.equals("remote")) {
		refreshMenus = true;
	}
	
	response.sendRedirect("viewaddressesaction.jsp?TYPE="+type+"&refreshMenus="+refreshMenus);
%>