<%@ page language="java"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
	String BASE_DIR = "base_directory";
	String CSS_BGCOLOR = "cssBgcolor";
  String FILTER_TYPE = "ACC_TYPE";
  String ACC_ID = "ACC_ID";
  
  String baseDir = request.getParameter(BASE_DIR);
	if (baseDir == null || baseDir.equals("")) {
		baseDir = BASE_DIRECTORY;
	}
	String cssBgcolor = request.getParameter(CSS_BGCOLOR);
	if (cssBgcolor == null || cssBgcolor.equals("")) {
		cssBgcolor = "#EEF2F5";
	}
  String filterstr = request.getParameter(FILTER_TYPE);
  if(filterstr == null){
  	filterstr = "";
  }	
	
  String op = request.getParameter("OP");
  if(op == null || op.length() == 0){
  	op = "NEW";
  }  

  String accId = request.getParameter(ACC_ID);
  if(accId == null){
  	accId = "";
  }
  
  String divHeight = request.getParameter("divHeight");
  if(divHeight == null || divHeight.length() == 0) {
  	divHeight = "420px";
  }
  
  Account acc = null;
  if(accId.length() > 0){
  	AddressBook adbook = AddressBook.getInstance();
  	acc = adbook.getAccountById(accId);  	
  	if (acc != null && filterstr.length() == 0){
  		filterstr = acc.getType();
  	}
  }
  
  if (filterstr.equals("winEvent")){
  	filterstr = "auth";
  }
  String divPath = BASE_DIRECTORY;
  String displayType = "";
  if(filterstr.equals("http")){
  	divPath += "tools/addresses/http/accountHttpDiv.jsp?ACC_ID=" + accId;
  	displayType = "HTTP";
  }else if(filterstr.equals("ftp")){
  	divPath += "tools/addresses/ftp/accountFtpDiv.jsp?ACC_ID=" + accId;
  	displayType = "FTP";
  }else if(filterstr.equals("ssh")){
  	divPath += "tools/addresses/ssh/accountSshDiv.jsp?ACC_ID=" + accId;
  	displayType = "SSH";
  }else if(filterstr.equals("fs")){
  }else if(filterstr.equals("email")){
  	divPath += "tools/addresses/mail/accountMailDiv.jsp?ACC_ID=" + accId;
  	displayType = "Email";
  }else if(filterstr.equals("db")){
  	divPath += "tools/addresses/db/general/accountDbDiv.jsp?ACC_ID=" + accId;
  	displayType = "Database";
  }else if(filterstr.equals("sms")){
  }else if(filterstr.equals("jms")){
		divPath += "tools/addresses/jms/accountJmsDiv.jsp?ACC_ID=" + accId;
		displayType = "JMS";
	}else if(filterstr.equals("snmp")){
		divPath += "tools/addresses/snmp/accountSnmpDiv.jsp?ACC_ID=" + accId;
		displayType = "SNMP";
	}else if(filterstr.equals("auth")){
		divPath += "tools/addresses/auth/authAccWinDiv.jsp?ACC_ID=" + accId;
		displayType = "Windows Authentication";
  }else if(filterstr.equals("remote")){
  	divPath += "tools/addresses/remote/accountRemoteDiv.jsp?ACC_ID=" + accId;
  	displayType = "Remote XpoLog";
  }
  String title = accId == null || accId.length() == 0 ? "Add " + displayType + " Account" : "Edit " + displayType + " Account";
  
  if (acc != null){
    request.setAttribute("account",acc);
  }
  request.setAttribute("type",filterstr);
  request.setAttribute("divPath",divPath);
  
  String actionsNames = "";
  String actions = "";
  boolean showVerifyButton = !filterstr.equals("remote") && !filterstr.equals("auth") && !filterstr.equals("http") && !filterstr.equals("snmp");
  if(showVerifyButton){
  	actionsNames += "Verify";
  	actions += "javascript:addNewAcc('verify')";
  }
  
  if (actionsNames.length() > 0){
  	actionsNames += "#";
  	actions += "#";
  }
  actionsNames += "Save";
	actions += "javascript:addNewAcc('save','" + accId + "','" + showVerifyButton + "')";
	
	actionsNames += "#Cancel";
	actions += "#javascript:cancelAddAccDiv()";
	
%>
<%@page import="xpolog.eye.media.AddressBook"%>
<%@page import="xpolog.eye.media.Account"%>

<form AUTOCOMPLETE="OFF" id="account" name="account" action="" style="margin:0px;padding:0px">
<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
			<jsp:param name="baseDirectory" value="<%=baseDir%>"/> 
			<jsp:param name="title" value="<%=title%>"/> 
			<jsp:param name="suffix" value="addAccount"/>
			<jsp:param name="includePath" value="tools/addresses/addAccount.jsp"/> 
			<jsp:param name="width" value="650px"/> 
			<jsp:param name="height" value="<%=divHeight %>"/>
			<jsp:param name="zIndex" value="400"/> 
			<jsp:param name="actionsNames" value="<%=actionsNames%>"/> 
			<jsp:param name="actions" value="<%=actions%>"/> 
			</jsp:include>
</form>
 <jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
			<jsp:param name="baseDirectory" value="<%=baseDir%>"/> 
			<jsp:param name="title" value="Upload Driver"/> 
			<jsp:param name="suffix" value="uploadDriver"/>
			<jsp:param name="includePath" value="tools/addresses/uploadDriverInnerDiv.jsp"/> 
			<jsp:param name="width" value="500px"/> 
			<jsp:param name="height" value="200px"/> 
			<jsp:param name="zIndex" value="500"/>
			<jsp:param name="actionsNames" value="Upload#Cancel"/> 
			<jsp:param name="actions" value="javascript:goUploadDriver()#javascript:hideUploadDriver()"/> 
			</jsp:include>