<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.media.telsh.TelnetAccount"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION,true)){
  return;
}
UserContext userContext = UserEnvironment.getUserContext(request);

boolean isEdit = manager.isHavePermission(userContext,ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION);

String lastSelectedRow = (String)request.getSession().getAttribute("lastSelectedAccount");
if (lastSelectedRow == null){
	lastSelectedRow = "";
}

request.getSession().removeAttribute("AccountBuilder");

String refreshMenusStr = request.getParameter("refreshMenus");
boolean refreshMenus = refreshMenusStr != null && refreshMenusStr.equals("true");

String openAccountTypeStr = request.getParameter("openAccountType");
boolean openAccountType = openAccountTypeStr != null && openAccountTypeStr.equals("true");

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>

<script>
<%
if(refreshMenus) {
%>
refreshMenus();
<%
}
%>
</script>

<jsp:include page="../../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<%
boolean showMenu = isEdit;
if(showMenu) {
	boolean showVerifyDebugModeProperty = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("showVerifyDebugMode", false);
	boolean showVerifyDebugMode = showVerifyDebugModeProperty && (userContext == null || (userContext != null && (userContext.getUser() == null || userContext.getUser().isAdmin())));
	String verifyDebugModeMenuId = "";
	String verifyDebugModeMenuText = "";
	String verifyDebugModeMenuHref = "";
	if(showVerifyDebugMode) {
		verifyDebugModeMenuId = "verifyDebugAccount,";
		verifyDebugModeMenuText = "Verify (debug mode),";
		verifyDebugModeMenuHref = "javascript:verifyAccount0(true);,";
	}
	
	String menuIds = "verifyAccount," + verifyDebugModeMenuId + "enableAccount,disableAccount,editAccount,removeAccount";
	String menuTexts = "Verify," + verifyDebugModeMenuText + "Enable,Disable,Edit,Delete";
	String menuHrefs = "javascript:verifyAccount0(false);," + verifyDebugModeMenuHref + "javascript:enableAccount0(true);,javascript:enableAccount0(false);,javascript:editAccount0();,javascript:removeAccount0();";
%>
<jsp:include page="../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		</jsp:include>
	<jsp:include page="../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	</jsp:include>
<%
}
%>

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";  
	
	function init() {
		<%
		if(openAccountType) {
		%>
			goNew();
		<%
		}
		%>
	}
	
  function goNew(){
  	showGeneralAdminDiv("accountType", -1, 100);
  }
  
  function goNewAccount() {
  	var accountTypeErrorMsgElement = document.getElementById("accountTypeErrorMsg");
 		if(accountTypeErrorMsgElement) {
 			accountTypeErrorMsgElement.style.display ="none";
 		}
 		
	  var accountType = document.accountTypeForm.accountType;
	  var selectedType = "";
	  if(accountType) {
		  for(var i = 0; i < accountType.length; i++) {
	  		if(accountType[i].checked) {
		      selectedType = accountType[i].value;
	      }
	   	}
	  }

  	if(selectedType == "") {
  		if(accountTypeErrorMsgElement) {
  			accountTypeErrorMsgElement.style.display ="";
				accountTypeErrorMsgElement.innerHTML = "Account type was not selected";
				return;
  		}
  	}
  
  	var path = "";
  	if(selectedType == "db") {
  		path = "db/listOfDB.jsp";
  	}else if(selectedType == "fs") {
  		path = "fs/accountFs.jsp";
  	}else if(selectedType == "ftp") {
  		path = "ftp/accountFtp.jsp";
  	}else if(selectedType == "http") {
  		path = "http/accountHttp.jsp";
  	}else if(selectedType == "email") {
  		path = "mail/accountMail.jsp";
  	}else if(selectedType == "sms") {
  		path = "sms/accountSms.jsp";
  	}else if(selectedType == "ssh") {
  		path = "ssh/accountSsh.jsp";
  	}else if(selectedType == "snmp") {
  		path = "snmp/accountSnmp.jsp";
  	}else if(selectedType == "jms") {
  		path = "jms/accountJms.jsp";
  	}else if(selectedType == "remote") {
  		path = "remote/accountRemote.jsp";
  	}else if(selectedType == "winAuthentication") {
  		path = "auth/authAccWin.jsp";
  	}
  	if(path != "") {
  		document.location = path;
  	}
  }
  
  function closeAccountTypeDiv() {
		showHideGeneralAdminDiv("accountType");
	}
  
  function doEdit(){
    var accountId = getFirstSelectedRow(mygrid);
    if (accountId == "") {
     return;
    }
    doEdit1(accountId);
  }
  
  function doEdit1(accountId){
    path = "accoutAction.jsp?ID=" + accountId;
  	document.location = path;
  }
  
  function doDelete(){
    var accountId = getFirstSelectedRow(mygrid);
    if (accountId == "") {
      return;
    }
    doDelete1(accountId);
  }
  
  function doDelete1(accountId){
    var name = mygrid.cells(accountId,0).getValue();
    var type = mygrid.cells(accountId,1).getValue();
    var row = accountId;
    var msgWriter = new messageWriter("mygridMessage","Account Delete Action","<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid"),50);
    msgWriter.addAction("Yes","javascript:hideLayer('mygridMessage');javascript:doDelete0('" + row + "','" +  accountId + "','" +  type + "')");
    msgWriter.addAction("No","javascript:hideLayer('mygridMessage')");  
    msgWriter.showMessage("<nobr>Are you sure you want to delete account </nobr>" + name + "?");
  }
  
  function doDelete0(row,id,type){
  	deleteGridRow(mygrid,row,baseDirectory + "tools/addresses/removeAccountAction.jsp?accountId=" + id + "&timestamp=" + new Date().getTime());
  	if(type && type == "Remote XpoLog") {
  		refreshMenus();
  	}
  }
  
  function doVerify() {
	  var accountId = getFirstSelectedRow(mygrid);
    if (accountId == "") {
      return;
    }
		doVerify1(accountId);
  }
  
  function doVerify1(accountId,debugMode) {
	  var title = "Account Verification";
	  if(debugMode) {
			title += " (debug mode)";
	  }
	  var msgWriter = new messageWriter("verificationWaitMessage",title,baseDirectory);
		msgWriter.showMessage("Please wait...");
  	var page = baseDirectory + "tools/addresses/verifyAccount.jsp?";
		var params = "id=" + accountId + "&isEmbeded=true&debugMode=" + debugMode;
		sendAjaxRequest(page,function(req){
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result){
				alert("Cannot verify account");
				return;			
			}
			var resultArr = result.split("@#");
			if(resultArr) {
				var resultType = resultArr[0];
				var resultMessage = resultArr[1];
				hideLayer('verificationWaitMessage');
				msgWriter = new messageWriter("verificationMessage",title,baseDirectory);
				msgWriter.addAction("OK","javascript:hideLayer('verificationMessage');");
				if(resultType == "error") {
					msgWriter.setMsgClass("ERRORMESSAGE_LIGHT");
				}
	    	msgWriter.showMessage(resultMessage);
			}else {
				
			}
		},'POST',params);
  }

  function doEnable(enable) {
	  var accountId = getFirstSelectedRow(mygrid);
    if (accountId == "") {
      return;
    }
    doEnable1(accountId,enable);
  }

  function doEnable1(accountId,enable) {
	  var page = baseDirectory + "tools/addresses/enableAccountAction.jsp?";
		var params = "accountId=" + accountId + "&enabled=" + enable;
		sendAjaxRequest(page,function(req){
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result){
				alert("Cannot enable account");
				return;			
			}
			updateTable();
		},'POST',params);
  }
	
	function handleMenuItems(){
 		var isVerifiable = mygrid.getUserData(contextRowId,"isVerifiable");
 		var type = mygrid.getUserData(contextRowId,"type");
		var enabled = mygrid.getUserData(contextRowId,"enabled");
		<% if (isEdit){%>
    	if(isVerifiable && isVerifiable == "true") {
    		aMenu.menu.showButtons("verifyAccount,verifyDebugAccount");
    	}
    	if(type == "<%=TelnetAccount.TYPE_SSH %>") {
				if(enabled == "true") {
					aMenu.menu.showButtons("disableAccount");
				}else {
					aMenu.menu.showButtons("enableAccount");
				}
    	}
	    aMenu.menu.showButtons("editAccount,removeAccount");
 		<%}else {%>
		  aMenu.menu.hideBar();
 		<%}%>
  }
  
  function verifyAccount0(debugMode){
    if (contextRowId && contextRowId != ""){
      doVerify1(contextRowId,debugMode);
    }
  }

  function enableAccount0(enable) {
	  if (contextRowId && contextRowId != ""){
	    doEnable1(contextRowId,enable);
	  }
  }
  
  function editAccount0(){
    if (contextRowId && contextRowId != ""){
      doEdit1(contextRowId);
    }
  }
  
  function removeAccount0(){
    if (contextRowId && contextRowId != ""){
      doDelete1(contextRowId);
    }
  }

</script>
</head>

<%
String onLoadFunctions = "initTables();init()";
if(showMenu) {
	onLoadFunctions = "initMenus();" + onLoadFunctions;
}
%>
<body onLoad="<%=onLoadFunctions %>" onUnload="destroyTables()" style="margin:0;padding:0;overflow:auto;" >

<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="title" value="Select the type of account to add"/> 
	<jsp:param name="suffix" value="accountType"/> 
	<jsp:param name="width" value="650px"/> 
	<jsp:param name="height" value="350px"/> 
	<jsp:param name="includePath" value="tools/addresses/listOfAccounts.jsp"/> 
	<jsp:param name="actionsNames" value="Continue#Cancel"/> 
	<jsp:param name="actions" value="javascript:goNewAccount()#javascript:closeAccountTypeDiv()"/> 
</jsp:include>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td valign="top">
      <table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              
         <tr height="10">
          <td>
            <jsp:include page="../../common/pageMainHeader.jsp" flush="true">
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="headerTitle" value="Address Book" />
						</jsp:include>		
          </td>
        </tr>
        <tr>                
          <td valign="top"> 
            <% 
            String addName = isEdit ? "New Account" : "";
            String addLink = isEdit ? "javascript:goNew()" : "";
            
            String tableNames = isEdit ? "Enable#Disable#Edit#Delete" : "";
            String tableActions = isEdit ? "javascript:doEnable(true)#javascript:doEnable(false)#javascript:doEdit()#javascript:doDelete()" : "";
            String ids = isEdit ? "Enable#Disable#Edit#Delete" : "";
            String selectTypes = isEdit ? "2#2#2#2" : "";
            
            if (tableNames.length() > 0){
          		tableNames += "*;*";
          		tableActions += "*;*";
          		ids += "*;*";
          		selectTypes += "*;*";
          	}             	
           	tableNames += "Verify#";
         		tableActions += "javascript:doVerify()#";
         		ids += "Verify#";
         		selectTypes += "2#";
            
         		String menu = showMenu ? "aMenu" : "";
            
            %>
						<jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="initXML" value="tools/addresses/addressBookViewXML.jsp" />
							<jsp:param name="updateXML" value="tools/addresses/addressBookViewXML.jsp?dataOnly=true" />				
							<jsp:param name="menu" value="<%=menu%>"/>
							<jsp:param name="newActionNames" value="<%=addName%>" />
							<jsp:param name="newActions" value="<%=addLink%>" />
							<jsp:param name="tableActionNames" value="<%=tableNames%>" />
							<jsp:param name="tableActions" value="<%=tableActions%>" />
							<jsp:param name="tableActionIds" value="<%=ids%>" />
							<jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
							<jsp:param name="recordsText" value="Accounts" />
							<jsp:param name="style" value="main" />
							<jsp:param name="doubleClickAction" value="doEdit" />
							<jsp:param name="lastSelectedRow" value="<%=lastSelectedRow%>" />
							<jsp:param name="showSelectedRowOnLoad" value="true" />
						</jsp:include>
        	</td>
      	</tr>      
    	</table>
    </td>
  </tr>
</table>

<script>
	function updateButtonActivate(rowid,id,columnType,gridType){
	  if (!id || id == "") return;
		 var isVerifiable = mygrid.getUserData(rowid,"isVerifiable");
		 var type = mygrid.getUserData(rowid,"type");
		 var enabled = mygrid.getUserData(rowid,"enabled");
		 if ((id != "Verify" || isVerifiable == "true") && (gridType == columnType || (gridType == 2))){
			 if(id == "Enable") {
				if(type == "<%=TelnetAccount.TYPE_SSH %>") {
					if(enabled == "true") {
						disableActionButton(id);
					}else {
						enableActionButton(id);
					}
				}else {
					disableActionButton(id);
				}
			 }else if(id == "Disable") {
				 if(type == "<%=TelnetAccount.TYPE_SSH %>") {
					if(enabled == "true") {
						enableActionButton(id);
					}else {
						disableActionButton(id);
					}
				 }else {
					 disableActionButton(id);
				 }
			 }else {
	 	   	enableActionButton(id);
			 }
	 	 }else {
	 	   disableActionButton(id);
	 	 }
	}
</script>

</body>

</html>