<%@ page language="java"%>

<%@ page import="xpolog.eye.media.AddressBook"%>
<%@ page import="xpolog.eye.media.db.DBAccount"%>
<%@ page import="xpolog.eye.media.db.XpoDriverInfo"%>
<%@ page import="xpolog.eye.media.db.XpoDriversManager"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION,true)){
  return;
}
UserContext userContext = UserEnvironment.getUserContext(request);

String id = request.getParameter("ID");
String forwardURL = request.getParameter("forwardURL");
request.getSession().removeAttribute("AccountBuilder");

if (id != null && id.length() >0){
   AddressBook adbook = AddressBook.getInstance();
	 DBAccount dbac = (DBAccount)adbook.getAccountById(id);
	 if (dbac != null){
		 XpoDriversManager driverMgr = XpoDriversManager.getInstance();
		 XpoDriverInfo driverInfo = driverMgr.getDriverById(dbac.getDriverType());
     if (driverInfo != null){
       String url = driverInfo.getDriverJspUrl();
       if (url.indexOf("?") == -1){
         url += "?";
       }else {
         url += "&";
       }
       if (forwardURL == null){
      	 forwardURL = "";
       }
       response.sendRedirect(url+"ID=" + id + "&forwardUrl=" + forwardURL);
       return;
     }else {
      String url = dbac.getDriverType()+"/accountDb.jsp";  	
      response.sendRedirect(url +"?ID=" + id + "&forwardUrl=" + forwardURL);
      return;
    }
  }
}

boolean isEdit = manager.isHavePermission(userContext,ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION);

String openAccountTypeStr = request.getParameter("openAccountType");
boolean openAccountType = openAccountTypeStr != null && openAccountTypeStr.equals("true");

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>

<jsp:include page="../../../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<%
boolean showMenu = isEdit;
if(showMenu) {
	String menuIds = "createAccount,downloadDriver";
	String menuTexts = "Create Account,Download Driver";
	String menuHrefs = "javascript:createAccount0();,javascript:downloadDriver0();";
%>
<jsp:include page="../../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		</jsp:include>
	<jsp:include page="../../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
		<jsp:param name="width" value="120" />
	</jsp:include>
<%
}
%>

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";  
	
	function uploadDriver(){
		document.location = "uploadDriver.jsp";
	}
	
	function createAccount() {
		var id = getFirstSelectedRow(mygrid);
		if (id == "") {
     	return;
   	}
  	createAccount1(id)
  }
	
	function createAccount1(id) {
		var link = mygrid.getUserData(id,"link");
  	if(link && link != "") {
			document.location = link;
  	}
  }
	
	function downloadDriver() {
		var id = getFirstSelectedRow(mygrid);
		if (id == "") {
     	return;
   	}
  	downloadDriver1(id)
  }
	
	function downloadDriver1(id) {
		var url = mygrid.getUserData(id,"url");
  	if(url && url != "") {
  		window.open(url);
  	}
  }
	
	function handleMenuItems(){
 		var isDownloadable = mygrid.getUserData(contextRowId,"isDownloadable");
    <% if (isEdit){%>
    	aMenu.menu.showButtons("createAccount");
    	if(isDownloadable && isDownloadable == "true") {
    		aMenu.menu.showButtons("downloadDriver");
    	}
 		<%}else {%>
		  aMenu.menu.hideBar();
 		<%}%>
  }
  
  function createAccount0(){
    if (contextRowId && contextRowId != ""){
      createAccount1(contextRowId);
    }
  }
  
  function downloadDriver0(){
    if (contextRowId && contextRowId != ""){
      downloadDriver1(contextRowId);
    }
  }
  
</script>
</head>

<%
String onLoadFunctions = "initTables();";
if(showMenu) {
	onLoadFunctions = "initMenus();" + onLoadFunctions;
}
%>
<body onLoad="<%=onLoadFunctions %>" onUnload="destroyTables()" style="margin:0;padding:0;overflow:auto;" >

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td valign="top">
      <table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              
        <tr height="10">
          <td>
          	<jsp:include page="../../../common/pageMainHeader.jsp" flush="true">
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="headerTitle" value="Database Types" />
						</jsp:include>		
         	</td>
        </tr>
        <tr>                
          <td valign="top"> 
            <% 
            String addName = isEdit ? "Upload Driver" : "";
            String addLink = isEdit ? "javascript:uploadDriver()" : "";
            
            String tableNames = isEdit ? "Create Account#Download Driver" : "";
            String tableActions = isEdit ? "javascript:createAccount()#javascript:downloadDriver()" : "";
            String ids = isEdit ? "Create#Download" : "";
            String selectTypes = isEdit ? "2#2" : "";

            String menu = showMenu ? "aMenu" : "";
            %>
						<jsp:include page="../../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="initXML" value="tools/addresses/db/databaseTypesViewXML.jsp" />
							<jsp:param name="menu" value="<%=menu%>"/>
							<jsp:param name="newActionNames" value="<%=addName%>" />
							<jsp:param name="newActions" value="<%=addLink%>" />
							<jsp:param name="tableActionNames" value="<%=tableNames%>" />
							<jsp:param name="tableActions" value="<%=tableActions%>" />
							<jsp:param name="tableActionIds" value="<%=ids%>" />
							<jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
							<jsp:param name="recordsText" value="Database Type" />
							<jsp:param name="style" value="main" />
							<jsp:param name="doubleClickAction" value="createAccount" />
							<jsp:param name="showSelectedRowOnLoad" value="true" />
						</jsp:include>
        	</td>
      	</tr>      
    	</table>
    </td>
  </tr>
</table>

<script>
	function updateButtonActivate(rowid,id,columnType,gridType){
	  if (!id || id == "") return;
		 var isDownloadable = mygrid.getUserData(rowid,"isDownloadable");
	   if ((id != "Download" || isDownloadable == "true") && (gridType == columnType || (gridType == 2))){
	 	   enableActionButton(id);
	 	 }else {
	 	   disableActionButton(id);
	 	 }
	}
</script>

</body>

</html>