<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.net.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
	static final String BASE_DIRECTORY = "../../../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	
	String Name, Description, DriverName, ConnectionString, Id;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	DriverName = request.getParameter("DriverName");
	ConnectionString = request.getParameter("ConnectionString");
	Id = request.getParameter("Id");
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
    	errmodel.addError("No Name was supplied.");
  	}

  	if(DriverName == null || DriverName.equals("")){
    	errmodel.addError("Driver name was not supplied.");
  	}
  
  	if(ConnectionString == null || ConnectionString.equals("")){
    	errmodel.addError("Connection string was not supplied.");
  	}

 	if(errmodel.getErrorCount() != 0){
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
  	}
	
	
	
	DBAccount dbac = null;
	AddressBook adbok = AddressBook.getInstance();
	if(Id != null){
		dbac = (DBAccount)adbok.getAccountById(Id);
		
	}
	if(dbac == null){
		dbac = new DBAccount();
	}
	
	dbac.setAccountName(Name);
	dbac.setDescription(Description);
	dbac.setDriverName(DriverName);
	dbac.setConnectionString(ConnectionString);
	
	adbok.addAccount(dbac);
	adbok.saveAddressBook();
	
	//	audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	  			userContext, AuditConstants.CHANGE, "add/edit account", AuditConstants.CONFIGURATION, "add/edit db account " + Name);


	response.sendRedirect("addressview.jsp");
%>

