<%@ page language="java"%>

<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.db.*"%>

<%@ page import="java.io.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%

  String ARCHIVE_PATH = "ARCHIVE_PATH";
  String ERROR_OBJ = "ERROR_OBJ";
  String IS_EMBEDDED = "isEmbedded";

  String arch_file  = request.getParameter(ARCHIVE_PATH);
	String isEmbeddedStr = request.getParameter(IS_EMBEDDED);
	boolean isEmbedded = (isEmbeddedStr != null && isEmbeddedStr.equals("true"));
	String result = "OK";

  //verify data
  ErrorModel errmodel = new ErrorModel();
  if(arch_file == null || arch_file.trim().equals("")){
    errmodel.addError("No archive file was supplied.");
    if(isEmbedded){
    	result = "<div id=\"uploadResultDivId\">";
    	result += "<b>No archive file was supplied.</b>";
    	result += "</div>";
    	out.write(result);
    	out.flush();
    }else{
	    request.getSession().setAttribute(ERROR_OBJ,errmodel);
	    response.sendRedirect("errorpage.jsp");
    }
    return;
  }

  //here we will use xpolog builder for import -
  File arch = new File(arch_file);
	try{
		String name = arch.getName();
		int index = name.lastIndexOf("/");
		int index2 = name.lastIndexOf("\\");
		if (index >= 0 && index > index2){
			name = name.substring(index + 1);
		}else if (index2 > 0){
			name = name.substring(index2 + 1);
		}
		arch = UploadHelper.putUploadFileOnServer(request,arch,DBMedia.DRIVERS_DIRECTORY,name);
		DBMedia.initialzeDriverClassLoader();
  }catch(Exception e){
    e.printStackTrace();
    if(isEmbedded){
    	result = "<div id=\"uploadResultDivId\">";
    	result += "<b>Could not upload driver.</b>";
    	result += "</div>";
    	out.write(result);
    	out.flush();
    }else{
	    ErrorModel errmod = new ErrorModel();
	    errmod.addError(e.getMessage());
	    request.getSession().setAttribute(ERROR_OBJ,errmod);
	    response.sendRedirect("errorpage.jsp");
	    }
    return;
  }

	String redirectUrl = request.getParameter("redirectURL");
	if(!isEmbedded){
		if (redirectUrl != null && redirectUrl.length() > 0){
			response.sendRedirect(BASE_DIRECTORY + redirectUrl);
		}else{
		  response.sendRedirect("listOfDB.jsp");
		}
		return;
	}
%>

<div id="uploadResultDivId">
<%=result.trim()%>
</div>

