
<%@page import="xpolog.eye.media.telsh.TelShMediaPoolManager"%>
<%@page import="xpolog.eye.media.telsh.TelnetAccount"%><%@ page language="java"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	//do whatever needed to remove the account
	String accountId = request.getParameter("accountId");
	String enabledStr = request.getParameter("enabled");
	boolean enabled = enabledStr != null && enabledStr.equals("true");
	boolean success = true;
	String message = "";
	if (accountId != null) {
		AddressBook adbok = AddressBook.getInstance();
		Account acc = adbok.getAccountById(accountId);
		String name = "";
		if (acc != null) {
			name = acc.getAccountName();
			//audit
			AuditManager.getInstance().write(
					AuditConstants.BASIC_AUDIT_LEVEL, userContext,
					AuditConstants.CHANGE, "enable account",
					AuditConstants.ACCOUNTS, (enabled ? "enable" : "disable") + " account " + name);
			try {
				acc.setEnabled(enabled);
				adbok.addAccount(acc, userContext);
				success = true;
			} catch (Exception e) {
				ErrorModel.log.error("Failed to enable account " + name + " with id " + accountId, e);
				success = false;
				message = e.getMessage();
			}
			
			request.getSession().setAttribute("lastSelectedAccount",acc.getId());
			
			if(acc instanceof TelnetAccount) {
				TelShMediaPoolManager.getInstance().updatePool((TelnetAccount)acc);
			}
		}
	}else {
		message = "No account was given, please refresh and try again";
	}
	String xml = GridModelActionsHelper.getResultXML(success, message);

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	
	out.write(xml);
	out.flush();
%>
