<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.ftp.*"%>
<%@ page import="xpolog.eye.security.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION,true)){
    return;
  }
	String ACCOUT_ID = "ID";
	String id = request.getParameter(ACCOUT_ID);
	
	String ftpUrl = "";
	String name = "";
	String description = "";
	String port = "21";
	String user = "";
	String password = "";
	
	if(id != null){
		AddressBook adbok = AddressBook.getInstance();
		FTPAccount acc = (FTPAccount)adbok.getAccountById(id);
		name = acc.getAccountName();
		description = acc.getDescription();
		ftpUrl = acc.getNetAddress();
		port = String.valueOf(acc.getPort());
		password = acc.getPassword();
		user = acc.getUserName();
		
		request.getSession().setAttribute("lastSelectedAccount",acc.getId());
	}else{
		id = "";
		request.getSession().removeAttribute("lastSelectedAccount");
	}
	String path = "accountFtpAction.jsp";
	String forwardURL = request.getParameter("forwardURL");
	if (forwardURL != null && forwardURL.length() > 0){
	 path += "?forwardURL=" + forwardURL;
	}
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
      function doSave(){
        document.access.action ="<%=path%>";
        document.access.submit();
      }

</script>
</head>

<body style="margin:0;padding:0">

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" style="margin:0;padding:0">
<input class="TEXTBOX" type="hidden" name="Id" size="10" value="<%=id%>">

<table border="0" cellpadding="0" cellspacing="0"	style="border-collapse:collapse" width="100%" height="100%">
	<tr height="10">
		<td>
			<%
			String headerUrl = BASE_DIRECTORY + "common/pageHeader.jsp";
			%>
			<jsp:include page="<%=headerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="FTP Account" />
			</jsp:include>
		</td>
	</tr>
	<tr valign="top">
		<td>
			<table class="ADMIN_TABLE_DIV" width="100%">
				<tr>
					<td class="ADMIN_MAIN_TD">
						<table width="100%">
							<tr>
								<td style="padding-top:15">
									<table class="ADMIN_SECTION_DIV" cellpadding="0" cellspacing="0" width="100%">
										<tr>
											<td class="ADMIN_SECTION_MAIN_TD">
												<table border="0" cellpadding="0" cellspacing="0" width="100%">
		                      <tr>
		                        <td width="11%"><span class="REGULARTEXT">Name *</span></td>
		                        <td width="69%">
		                        <input class="TEXTBOX" type="text" name="Name" size="50" value="<%=name%>"></td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Description</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="Description" size="50" value="<%=description%>"></td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Host Address *</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="Url" size="50" value="<%=ftpUrl%>">
		                        </td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Port *</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="Port" size="50" value="<%=port%>"></td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Username *</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="User" size="50" value="<%=user%>">
		                        </td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Password</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="password" name="Pwd" size="50" value="<%=password%>">
		                        </td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:20" colspan="2">
		                        	<span class="SMALLTEXT">* marks a manadatory field</span>
		                        </td>
		                      </tr>
		                    </table>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr height="10">
		<td>
			<%
			String footerUrl = BASE_DIRECTORY + "common/buttonsFooter.jsp";
			String cancelAction = "common/actions/cancelAction.jsp?forward=tools/addresses/addressview.jsp";
			
			String actions = "javascript:doSave()#" + cancelAction;
			%>
			<jsp:include page="<%=footerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="Save#Back to Address Book" />
				<jsp:param name="actions" value="<%=actions %>" />
			</jsp:include>
		</td>
	</tr>
</table>
</form>
<iframe id="resultFrame" name="resultFrame" style="display:none">
</body>
</html>