<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.jms.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	

  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  
	String ERROR_OBJ = "ERROR_OBJ";
	
	String actionType = request.getParameter("ACTION_TYPE");
	if(actionType == null || actionType.length() == 0 ){
		actionType = "save";
	}
	String verifyBeforeSaveStr = request.getParameter("verifyBeforeSave");
	boolean verifyBeforeSave = verifyBeforeSaveStr != null && verifyBeforeSaveStr.equals("true");
	String verifyMsg = "";
	String errorMsg = "";
	String result = "";
	String isEmbededStr = request.getParameter("isEmbeded");
	boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");
	
	String Name,Description,User,Pwd,Id;
	String jndiProviderUrl = null;
	String jndiContextFactory = null;
	//JMS connection factory settings
	String conectionFactoryKey = null;
	//JMS Topic connection factory settings
	String topicConectionFactoryKey = null;
	//JMS Queue connection factory settings
	String queueConectionFactoryKey = null;
	//JMS Security if needed
	String userName = "";
	String password = "";
	String credentials = "";
	String jmsUserName = "";
	String jmsPassword = "";
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	Id = request.getParameter("Id");
	jmsUserName = request.getParameter("userName");
	jmsPassword = request.getParameter("password");
	userName = request.getParameter("userName");
	password = request.getParameter("password");	
	jndiProviderUrl = request.getParameter("jndiProviderUrl");
	jndiContextFactory =request.getParameter("jndiContextFactory");
	topicConectionFactoryKey = request.getParameter("topicConectionFactoryKey");
	queueConectionFactoryKey = request.getParameter("queueConectionFactoryKey");
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
   	errmodel.addError("Name was not supplied");
   	if(isEmbeded){
  		errorMsg += "Name was not supplied<br>";
  	}
 	}
 	if(jndiContextFactory == null || jndiContextFactory.trim().equals("")){
   	errmodel.addError("JNDI context was not supplied");
   	if(isEmbeded){
  		errorMsg += "JNDI context was not supplied<br>";
  	}
 	}
 	if(jndiProviderUrl == null || jndiProviderUrl.equals("")){
   	errmodel.addError("JNDI provider URL was not supplied");
   	if(isEmbeded){
  		errorMsg += "JNDI provider URL was not supplied<br>";
  	}
 	}
 	if(topicConectionFactoryKey == null || topicConectionFactoryKey.equals("")){
   	errmodel.addError("JMS topic factory was not supplied");
   	if(isEmbeded){
  		errorMsg += "JMS topic factory was not supplied<br>";
  	}
 	}
 	if(queueConectionFactoryKey == null || queueConectionFactoryKey.trim().equals("")){
   	errmodel.addError("JMS queue factory was not supplied");
   	if(isEmbeded){
  		errorMsg += "JMS queue factory was not supplied<br>";
  	}
 	}
 	
 	if(errmodel.getErrorCount() != 0){
		if(!isEmbeded){
	 		request.getSession().setAttribute(ERROR_OBJ,errmodel);
 			response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=tools/addresses/addressview.jsp");
	 	}else{
			result += "error@#" + errorMsg;
			out.write(result);
			out.flush();
		}
  	return;
	}
	
	JMSAccount mtac = null;
	AddressBook adbok = AddressBook.getInstance();
	if(Id != null){
		mtac = (JMSAccount)adbok.getAccountById(Id);
		
	}
	if(mtac == null){
		mtac = new JMSAccount();
	}
	mtac.setAccountName(Name);
	mtac.setDescription(Description);
  mtac.setJmsUserName(jmsUserName);
	mtac.setJmsPassword(jmsPassword);
	mtac.setUserName(userName);	
	mtac.setPassword(password);
	mtac.setJndiProviderUrl(jndiProviderUrl);
	mtac.setJndiContextFactory(jndiContextFactory);
	mtac.setTopicConectionFactoryKey(topicConectionFactoryKey);
	mtac.setQueueConectionFactoryKey(queueConectionFactoryKey);
	
	boolean verified = false;
	if(actionType.equals("verify") || verifyBeforeSave){
		if(errorMsg.length() == 0){
			Media med = MediaManager.newInstace().getMediaByAccount(mtac);
		  if (med instanceof AbstractMedia){
		    ((AbstractMedia)med).setLogEnabled(false);
		  }
		  try {
				verified = med.verify(mtac);
			  if (!verified){
			  	verifyMsg = "<span style=\"font-size:11;color: red;\">Verification failed. Please verify your account's info</span>";
			  }else{
			  	verifyMsg = "<span style=\"font-size:11;color: green;\">Verification OK</span>";
			  }
		  }catch(Throwable t) {
		  	verifyMsg = "An error occured during verification: " + t.getMessage();
		  }
		}
	}
	
	if((!verifyBeforeSave || verified) && !actionType.equals("verify")){
		adbok.addAccount(mtac,userContext);
		adbok.saveAddressBook();
		
		if(!isEmbeded) {
			request.getSession().setAttribute("lastSelectedAccount",mtac.getId());
		}
		
		//	audit
		AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
			  			userContext, AuditConstants.CHANGE, "add/edit account", AuditConstants.CONFIGURATION, "add/edit jms account " + Name);
	}
	
	if(isEmbeded){
		response.setContentType("text/xml");
		//result: action type + acc type + action result status + 
		//        error msg OR new acc name + new acc Id
		result += "ok@#";
		result += "jms@#";		
		result += actionType + "@#";
		if(actionType.equals("verify")){
			result += verifyMsg;
		}else{
			result += mtac.getAccountName() + "@#";
			result += mtac.getId() + "@#";
			result += Id != null && Id.length() > 0 ? "edit" : "new";
			if(verifyBeforeSave) {
				result += "@#" + verified;
			}
		}
		out.write(result);
		out.flush();
	}else{
		String forwardURL = request.getParameter("forwardURL");
		if (forwardURL != null && !forwardURL.startsWith("http")){
			forwardURL = BASE_DIRECTORY + forwardURL;
		}
		if (forwardURL != null){
			forwardURL += (forwardURL.indexOf("?") == -1 ? "?" : "&") + "accountId=" + mtac.getId();
			response.sendRedirect(forwardURL);
		}else{
			response.sendRedirect(BASE_DIRECTORY + "tools/addresses/addressview.jsp?addressType=jms");
		}
	}
	
%>

