<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.mail.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	

  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  
	String ERROR_OBJ = "ERROR_OBJ";
	
	String actionType = request.getParameter("ACTION_TYPE");
	if(actionType == null || actionType.length() == 0 ){
		actionType = "save";
	}
	String verifyBeforeSaveStr = request.getParameter("verifyBeforeSave");
	boolean verifyBeforeSave = verifyBeforeSaveStr != null && verifyBeforeSaveStr.equals("true");
	String verifyMsg = "";
	String errorMsg = "";
	String result = "";
	String isEmbededStr = request.getParameter("isEmbeded");
	boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");
	
	String Name,Description,mail,Port,User,Pwd,Id;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	mail = request.getParameter("email");
	Id = request.getParameter("Id");
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
   	errmodel.addError("Name was not supplied");
   	if(isEmbeded){
  		errorMsg += "Name was not supplied<br>";
  	}
 	}
 	if(mail == null || mail.equals("")){
   	errmodel.addError("Email address was not supplied");
   	if(isEmbeded){
  		errorMsg += "Email address was not supplied<br>";
  	}
 	}

 	if(errmodel.getErrorCount() != 0){
 		if(!isEmbeded){
	 		request.getSession().setAttribute(ERROR_OBJ,errmodel);
 			response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=tools/addresses/addressview.jsp");
	 	}else{
			result += "error@#" + errorMsg;
			out.write(result);
			out.flush();
		}
  	return;
 	}
	
	MailAccount mtac = null;
	AddressBook adbok = AddressBook.getInstance();
	if(Id != null){
		mtac = (MailAccount)adbok.getAccountById(Id);
		
	}
	if(mtac == null){
		mtac = new MailAccount();
	}
	
	mtac.setMailAddress(mail);
	mtac.setAccountName(Name);
	mtac.setFirstName(Name);	
	mtac.setDescription(Description);
	
	boolean verified = false;
	if(actionType.equals("verify") || verifyBeforeSave){
		if(errorMsg.length() == 0){
			Media med = MediaManager.newInstace().getMediaByAccount(mtac);
		  if (med instanceof AbstractMedia){
		    ((AbstractMedia)med).setLogEnabled(false);
		  }
		  try {
				verified = med.verify(mtac);
			  if (!verified){
			  	verifyMsg = "<span style=\"font-size:11;color: red;\">Verification failed. Please verify your account's info</span>";
			  }else{
			  	verifyMsg = "<span style=\"font-size:11;color: green;\">Verification OK</span>";
			  }
		  }catch(Throwable t) {
		  	verifyMsg = "An error occured during verification: " + t.getMessage();
		  }
		}
	}
	
	if((!verifyBeforeSave || verified) && !actionType.equals("verify")){
		adbok.addAccount(mtac,userContext);
		adbok.saveAddressBook();
		
		if(!isEmbeded) {
			request.getSession().setAttribute("lastSelectedAccount",mtac.getId());
		}
		
		//	audit
		AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
			  			userContext, AuditConstants.CHANGE, "add/edit account", AuditConstants.CONFIGURATION, "add/edit email account " + Name);
	}
	
	if(isEmbeded){
		response.setContentType("text/xml");
		//result: action type + acc type + action result status + 
		//        error msg OR new acc name + new acc Id
		result += "ok@#";
		result += "email@#";
		result += actionType + "@#";
		if(actionType.equals("verify")){
			result += verifyMsg;
		}else{
			result += mtac.getAccountName() + "@#";
			result += mtac.getId() + "@#";
			result += Id != null && Id.length() > 0 ? "edit" : "new";
			if(verifyBeforeSave) {
				result += "@#" + verified;
			}
		}
		out.write(result);
		out.flush();
	}else{
		String forwardURL = request.getParameter("forwardURL");
		if (forwardURL != null && !forwardURL.startsWith("http")){
			forwardURL = BASE_DIRECTORY + forwardURL;
		}
		if (forwardURL != null){
			forwardURL += (forwardURL.indexOf("?") == -1 ? "?" : "&") + "accountId=" + mtac.getId();
			response.sendRedirect(forwardURL);
		}else{
			response.sendRedirect(BASE_DIRECTORY + "tools/addresses/addressview.jsp?addressType=email");
		}
	}

%>

