<%@page import="xpolog.eye.media.remote.RemoteXplgAccount"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%!static final String BASE_DIRECTORY = "../../../";%> 
<%
 	String ERROR_OBJ = "ERROR_OBJ";
 	UserContext userContext = UserEnvironment.getUserContext(request);

 	String Name, Description, context, Port, User, Pwd, Id, conType, host;
 	String forwardURL = request.getParameter("forwardURL");

 	String actionType = request.getParameter("ACTION_TYPE");
 	if (actionType == null || actionType.length() == 0) {
 		actionType = "save";
 	}
 	String verifyMsg = "";
 	String errorMsg = "";
 	String result = "";
 	String isEmbededStr = request.getParameter("isEmbeded");
 	boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");

 	Name = request.getParameter("Name");
 	Description = request.getParameter("Description");
 	context = request.getParameter("context");
 	host = request.getParameter("hostAddress");
 	Port = request.getParameter("Port");
 	User = request.getParameter("User");
 	Pwd = request.getParameter("Pwd");
 	Id = request.getParameter("Id");
 	conType = request.getParameter("conType");

 	ErrorModel errmodel = new ErrorModel();
 	if (Name == null || Name.equals("")) {
 		errmodel.addError("Name was not supplied");
 		if (isEmbeded) {
 			errorMsg += "Name was not supplied<br>";
 		}
 	}
 	if (host == null || host.equals("")) {
 		errmodel.addError("Host address was not supplied");
 		errorMsg += "Host address was not supplied<br>";
 	}
 	int port = -1;
 	if (Port == null || Port.trim().equals("")) {
 		errmodel.addError("Port was not supplied");
 		errorMsg += "Port was not supplied<br>";
 	}else {
		try {
	 		port = Integer.parseInt(Port);
	 	} catch (NumberFormatException e) {
	 		errmodel.addError("Port must be a valid number");
	 		errorMsg += "Port must be a valid number<br>";
	 	}
 	}

 	if (errmodel.getErrorCount() != 0) {
 		if (!isEmbeded) {
 			request.getSession().setAttribute(ERROR_OBJ, errmodel);
 			response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=tools/addresses/addressview.jsp");
 		} else {
 			result += "error@#" + errorMsg;
 			out.write(result);
 			out.flush();
 		}
 		return;
 	}

 	RemoteXplgAccount racc = null;
 	AddressBook adbok = AddressBook.getInstance();
 	if (Id != null) {
 		racc = (RemoteXplgAccount) adbok.getAccountById(Id);

 	}
 	if (racc == null) {
 		racc = new RemoteXplgAccount();
 	}

 	racc.setAccountName(Name);
 	racc.setDescription(Description);
 	racc.setHostName(host);
 	if (Pwd != null && Pwd.length() > 0) {
 		racc.setPwd(Pwd);
 	} else {
 		racc.setPwd("");
 	}

 	racc.setHttpPort(Port);
 	racc.setUserName(User);
 	racc.setDescription(Description);

 	if (conType != null) {
 		racc.setConType(conType);
 	} else {
 		racc.setConType("HTTP");
 	}

 	if (!actionType.equals("verify")) {
 		adbok.addAccount(racc, userContext);
 		if(!isEmbeded) {
 			request.getSession().setAttribute("lastSelectedAccount",racc.getId());
 		}
 	}
 	//	if(actionType.equals("verify")){
 	//		if(errorMsg.length() == 0){
 	//			Media med = MediaManager.newInstace().getMediaByAccount(ftac);
 	//		  if (med instanceof AbstractMedia){
 	//		    ((AbstractMedia)med).setLogEnabled(false);
 	//		  }
 	//		  boolean verify = med.verify(ftac);
 	//		  if (!verify){
 	//		  	verifyMsg = "<span style=\"font-size:11;color: red;\">Verification failed. Please verify your account's info</span>";
 	//		  }else{
 	//		  	verifyMsg = "<span style=\"font-size:11;color: green;\">Verification OK</span>";
 	//		  }
 	//		}
 	//	}else{
 	adbok.saveAddressBook();
	
 	//	}
 	//	audit
 	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
 			userContext, AuditConstants.CHANGE, "add/edit account",
 			AuditConstants.CONFIGURATION, "add/edit remote xplg account " + Name);

 	if (isEmbeded) {
 		response.setContentType("text/xml");
 		//result: action type + acc type + action result status + 
 		//        error msg OR new acc name + new acc Id
 		result += "ok@#";
 		result += "remote@#";
 		result += actionType + "@#";
 		if (actionType.equals("verify")) {
 			result += verifyMsg;
 		} else {
 			result += racc.getAccountName() + "@#";
 			result += racc.getId() + "@#";
 			result += Id != null && Id.length() > 0 ? "edit" : "new";
 		}
 		out.write(result);
 		out.flush();
 	} else {
 		forwardURL = request.getParameter("forwardURL");
 		if (forwardURL != null && !forwardURL.startsWith("http")) {
 			forwardURL = BASE_DIRECTORY + forwardURL;
 		}
 		if (forwardURL != null) {
 			forwardURL += (forwardURL.indexOf("?") == -1 ? "?" : "&")
 					+ "accountId=" + racc.getId();
 			response.sendRedirect(forwardURL);
 		} else {
 			response.sendRedirect(BASE_DIRECTORY + "tools/addresses/addressview.jsp?addressType=remote&refreshMenus=true");
 		}
 	}
 %>

