<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.snmp.*"%>
<%@ page import="xpolog.eye.security.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION,true)){
    return;
  }
	String ACCOUT_ID = "ID";
	String id = request.getParameter(ACCOUT_ID);
	
	String host = "";
	String port = "";
	int ver = SNMPAccount.SNMP_VERSION_2;
	String name = "";
	String description = "";
	String protocol = "udp";
	boolean useProxy = false;
	boolean sendAgentAddress = false;
	String sendAgentAddressDivVisibility = "hidden";
	
	if(id != null){
		AddressBook adbok = AddressBook.getInstance();
		SNMPAccount acc = (SNMPAccount)adbok.getAccountById(id);
		name = acc.getAccountName();
		description = acc.getDescription();
		host = acc.getHost();
		port = acc.getPort();
		ver = acc.getVersion();
		protocol = acc.getProtocol();
		useProxy = acc.isUseProxy();
		sendAgentAddress = acc.isSendAgentAddress();
		if(ver == SNMPAccount.SNMP_VERSION_1) {
			sendAgentAddressDivVisibility = "visible";
		}else {
			sendAgentAddressDivVisibility = "hidden";
		}
		
		request.getSession().setAttribute("lastSelectedAccount",acc.getId());
	}else{
		id = "";
		request.getSession().removeAttribute("lastSelectedAccount");
	}
	
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
      function doSave(){
        document.access.action ="accountSnmpAction.jsp";
        document.access.submit();
      }
      
      function toggleSendAgentAddressDiv() {
      	var sendAgentAddressDiv = document.getElementById("sendAgentAddressDiv");
      	var version = document.access.version.value;
      	if(sendAgentAddressDiv && version) {
	      	if(version == <%=SNMPAccount.SNMP_VERSION_1 %>) {
	      		sendAgentAddressDiv.style.visibility = "visible";
	      	}else {
	      		sendAgentAddressDiv.style.visibility = "hidden";
	      	}
	      }
      }

</script>
</head>

<body style="margin:0;padding:0">

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" style="margin:0;padding:0">
<input class="TEXTBOX" type="hidden" name="Id" size="10" value="<%=id%>">

<table border="0" cellpadding="0" cellspacing="0"	style="border-collapse:collapse" width="100%" height="100%">
	<tr height="10">
		<td>
			<%
			String headerUrl = BASE_DIRECTORY + "common/pageHeader.jsp";
			%>
			<jsp:include page="<%=headerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="SNMP Account" />
			</jsp:include>
		</td>
	</tr>
	<tr valign="top">
		<td>
			<table class="ADMIN_TABLE_DIV" width="100%">
				<tr>
					<td class="ADMIN_MAIN_TD">
						<table width="100%">
							<tr>
								<td style="padding-top:15">
									<table class="ADMIN_SECTION_DIV" cellpadding="0" cellspacing="0" width="100%">
										<tr>
											<td class="ADMIN_SECTION_MAIN_TD">
												<table border="0" cellpadding="0" cellspacing="0" width="100%">
		                      <tr>
		                        <td width="15%"><span class="REGULARTEXT">Name *</span></td>
		                        <td width="85%">
		                        <input class="TEXTBOX" type="text" name="Name" size="50" value="<%=name%>"></td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Description</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="Description" size="50" value="<%=description%>"></td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Host *</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="host" size="50" value="<%=host%>"></td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Port *</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="port" size="50" value="<%=port%>">
		                        </td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Version *</span></td>
		                        <td>
			                        <select class="TEXTBOX" size="1" name="version" onChange="javascript:toggleSendAgentAddressDiv()">
			                        <% 
			                        	String ver1select = "";
			                        	String ver2select = "selected='true'";
			                        	String ver3select = "";
			                        	if(ver == SNMPAccount.SNMP_VERSION_1){
			                        		ver1select = "selected='true'";
			                        		ver2select = "";
			                        	}else if(ver == SNMPAccount.SNMP_VERSION_3){
			                        		ver3select = "selected='true'";
			                        		ver2select = "";
			                        	}
			                       	%>
			                        <option value="<%=SNMPAccount.SNMP_VERSION_1%>" <%=ver1select%>>Version 1</option>
			                        <option value="<%=SNMPAccount.SNMP_VERSION_2%>" <%=ver2select%>>Version 2</option>
			                        
			                      	</select>
		                        
		                        </td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Protocol *</span></td>
		                        <td>
			                        <select class="TEXTBOX" size="1" name="protocol">
			                        <% 
			                        	String udpselect = "selected='true'";
			                        	String tcpselect = "";
			                        	if(protocol != null && protocol.equals("tcp")){
			                        		tcpselect = "selected='true'";
			                            	udpselect = "";
			                        	}
			                       	%>
			                        <option value="udp" <%=udpselect%> >UDP</option>
			                       	<!--   <option value="tcp" <%=tcpselect%>  >TCP</option>-->
									
			                      	</select>
														</td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Use Proxy</span></td>
		                        <td style="padding-top:10">
		                        <input class="TEXTBOX" type="checkbox" name="useProxy" size="50" <%if(useProxy) {%>checked<%} %>>
		                        </td>
		                      </tr>
		                      <tr>
		                      	<td colspan="2" style="padding-top:10">
		                      		<div id="sendAgentAddressDiv" style="visibility:<%=sendAgentAddressDivVisibility %>">
		                      		<table border="0" cellpadding="0" cellspacing="0" width="100%">
		                      			<tr>
			                      			<td width="15%"><span class="REGULARTEXT">Send agent address</span></td>
					                        <td width="85%">
					                        <input class="TEXTBOX" type="checkbox" name="sendAgentAddress" size="50" <%if(sendAgentAddress) {%>checked<%} %>>
					                        </td>
		                      			</tr>
		                      		</table>
		                        </div>
		                      	</td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:20" colspan="2">
		                        	<span class="SMALLTEXT">* marks a manadatory field</span>
		                        </td>
		                      </tr>
		                    </table>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr height="10">
		<td>
			<%
			String footerUrl = BASE_DIRECTORY + "common/buttonsFooter.jsp";
			String cancelAction = "common/actions/cancelAction.jsp?forward=tools/addresses/addressview.jsp";
			
			String actions = "javascript:doSave()#" + cancelAction;
			%>
			<jsp:include page="<%=footerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="Save#Back to Address Book" />
				<jsp:param name="actions" value="<%=actions %>" />
			</jsp:include>
		</td>
	</tr>
</table>
</form>
<iframe id="resultFrame" name="resultFrame" style="display:none">
</body>
</html>