<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.snmp.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	

  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
	
	String ERROR_OBJ = "ERROR_OBJ";
	
	String errorMsg = "";
	String result = "";
	String isEmbededStr = request.getParameter("isEmbeded");
	boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");
	
	String Name,Description,version,port,host,protocol,useProxyStr,sendAgentAddressStr,Id;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	protocol = request.getParameter("protocol");
	if(protocol == null || protocol.length() == 0) {
		protocol = "udp";
	}
	Id = request.getParameter("Id");
	version = request.getParameter("version");
	host = request.getParameter("host");
	port = request.getParameter("port");
	useProxyStr = request.getParameter("useProxy");
	boolean useProxy = (useProxyStr != null && useProxyStr.length() > 0 && useProxyStr.equals("on"));
	sendAgentAddressStr = request.getParameter("sendAgentAddress");
	boolean sendAgentAddress = sendAgentAddressStr != null && sendAgentAddressStr.equals("on");
	int ver = 2;

	
	ErrorModel errmodel = new ErrorModel(); 
	
	try{
		ver = Integer.parseInt(version);
	}catch(Exception e){
		
	}
	
	if(Name == null || Name.equals("")){
   	errmodel.addError("Name was not supplied");
   	if(isEmbeded){
   		errorMsg += "Name was not supplied<br>";
   	}
 	}
 	if(host == null || host.equals("")){
   	errmodel.addError("Host was not supplied");
   	if(isEmbeded){
   		errorMsg += "Host was not supplied<br>";
   	}
 	}
 	if(port == null || port.equals("")){
   	errmodel.addError("Port was not supplied");
   	if(isEmbeded){
   		errorMsg += "Port was not supplied<br>";
   	}
 	}else{
 		try{
 			Integer.parseInt(port);
 		}catch(Exception e){
 			errmodel.addError("Port must be a valid number");
 			if(isEmbeded){
     		errorMsg += "Port must be a valid number<br>";
     	}
 		}
 	}
  
 	if(errmodel.getErrorCount() != 0){
 		if(!isEmbeded){
 	 		request.getSession().setAttribute(ERROR_OBJ,errmodel);
  			response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=tools/addresses/addressview.jsp");
 	 	}else{
 			result += "error@#" + errorMsg;
 			out.write(result);
 			out.flush();
 		}
   	return;
 	}
	
 	SNMPAccount mtac = null;
	AddressBook adbok = AddressBook.getInstance();
	if(Id != null){
		mtac = (SNMPAccount)adbok.getAccountById(Id);
		
	}
	if(mtac == null){
		mtac = new SNMPAccount();
	}
	

	mtac.setAccountName(Name);
	mtac.setHost(host);
	mtac.setPort(port);
	mtac.setVersion(ver);
	mtac.setProtocol(protocol);
	mtac.setUseProxy(useProxy);
	if(ver == SNMPAccount.SNMP_VERSION_1) {
		mtac.setSendAgentAddress(sendAgentAddress);
	}else {
		mtac.setSendAgentAddress(false);
	}
	mtac.setDescription(Description);
	
	adbok.addAccount(mtac,userContext);
	adbok.saveAddressBook();
	
	if(!isEmbeded) {
		request.getSession().setAttribute("lastSelectedAccount",mtac.getId());
	}

	//	audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		  			userContext, AuditConstants.CHANGE, "add/edit account", AuditConstants.CONFIGURATION, "add/edit snmp account " + Name);

	if(isEmbeded){
		response.setContentType("text/xml");
		//result: action type + acc type + action result status + 
		//        error msg OR new acc name + new acc Id
		result += "ok@#";
		result += "snmp@#";		
		result += "save@#";
		result += mtac.getAccountName() + "@#";
		result += mtac.getId() + "@#";;
		result += Id != null && Id.length() > 0 ? "edit" : "new";
		out.write(result);
		out.flush();
	}else{
		env.setTempAttribute(SiteConstants.FORWARD_URL_ATTRIBUTE,"tools/addresses/addressview.jsp?addressType=snmp");
  	response.sendRedirect(BASE_DIRECTORY + "common/actions/nextAction.jsp");
	}
	
%>

