<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.snmp.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	String ACC_ID = "ACC_ID";
	String accId = request.getParameter(ACC_ID);
	if(accId == null){
		accId = "";
	}  
	
	String host = "";
	String port = "";
	int ver = SNMPAccount.SNMP_VERSION_2;
	boolean useProxy = false;
	boolean sendAgentAddress = false;
	String sendAgentAddressDivVisibility = "hidden";
	
	if(accId.length() > 0){
		AddressBook adbok = AddressBook.getInstance();
		Account acc = adbok.getAccountById(accId);
		if(acc != null && acc instanceof SNMPAccount) {
			SNMPAccount snmpAcc = (SNMPAccount)acc;
			host = snmpAcc.getHost();
			port = snmpAcc.getPort();
			ver = snmpAcc.getVersion();
			useProxy = snmpAcc.isUseProxy();
			sendAgentAddress = snmpAcc.isSendAgentAddress();
			if(ver == SNMPAccount.SNMP_VERSION_1) {
				sendAgentAddressDivVisibility = "visible";
			}else {
				sendAgentAddressDivVisibility = "hidden";
			}
		}
	}
	if(port == null || port.length() == 0) {
		port = "162";
	}
	
%>

<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
	<tr>
    <td width="30%"><span class="REGULARTEXT">Host</span></td>
    <td>
      <input class="TEXTBOX" type="text" id="host" name="host" size="50" value="<%=host%>">
    </td>
  </tr>
  <tr>
    <td><span class="REGULARTEXT">Port</span></td>
    <td>
    	<input class="TEXTBOX" type="text" id="port" name="port" size="50" value="<%=port%>">
    </td>
  </tr>
  <tr>
    <td><span class="REGULARTEXT">Version</span></td>
    <td>
    	<select class="TEXTBOX" size="1" id="version" name="version" onChange="javascript:toggleSendAgentAddressDiv()">
    <% 
    	String ver1select = "";
    	String ver2select = "selected='true'";
    	String ver3select = "";
    	if(ver == SNMPAccount.SNMP_VERSION_1){
    		ver1select = "selected='true'";
    		ver2select = "";
    	}else if(ver == SNMPAccount.SNMP_VERSION_3){
    		ver3select = "selected='true'";
    		ver2select = "";
    	}
   	%>
    		<option value="<%=SNMPAccount.SNMP_VERSION_1%>" <%=ver1select%>>Version 1</option>
    		<option value="<%=SNMPAccount.SNMP_VERSION_2%>" <%=ver2select%>>Version 2</option>
  		</select>
   	</td>
  </tr>
  <tr>
  	<td><span class="REGULARTEXT">Use Proxy</span></td>
    <td>
   		<input class="TEXTBOX" type="checkbox" id="useProxy" name="useProxy" size="50" <%if(useProxy) {%>checked<%} %>>
    </td>
  </tr> 
  <tr>
   	<td colspan="2">
   		<div id="sendAgentAddressDiv" style="visibility:<%=sendAgentAddressDivVisibility %>">
   		<table border="0" cellpadding="0" cellspacing="0" width="100%">
   			<tr>
    			<td width="30%"><span class="REGULARTEXT">Send agent address</span></td>
        <td>
        <input class="TEXTBOX" type="checkbox" name="sendAgentAddress" size="50" <%if(sendAgentAddress) {%>checked<%} %>>
        </td>
   			</tr>
   		</table>
     </div>
   	</td>
   </tr>
</table>