<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
  String id = request.getParameter("id");
	String debugModeStr = request.getParameter("debugMode");
	boolean debugMode = debugModeStr != null && debugModeStr.equals("true");
	String isEmbededStr = request.getParameter("isEmbeded");
	boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");
  Account acc = AddressBook.getInstance().getAccountById(id == null ? "" : id);
  boolean verify = false;
  String msg = "Verification OK";
  if(isEmbeded) {
  	msg = "ok@#" + msg;
  }
  if (acc != null){
  	Media med = MediaManager.newInstace().getMediaByAccount(acc);
	  if (med instanceof AbstractMedia){
	    ((AbstractMedia)med).setLogEnabled(false);
	  }
	  try {
	  	verify = med.verify(acc, debugMode);
	  	if (verify){
	  		String tmpMsg = med.getLastWarningMessage();
	  		if (tmpMsg != null && tmpMsg.length() > 0){
	  			msg = "Verification OK.<br>A warning was detected during verification:<br>" + tmpMsg;
	  			if(isEmbeded) {
		  	  	msg = "ok@#" + msg;
		  	  }
	  		}
	  	}else {
		    msg = med.getLastErrorMessage();
		    if (msg != null && msg.length() > 0){
					msg = "Verification failed for the following reason:<br>" + msg;
		    }else {
		    	msg = "Verification failed";
		    }
		    if(isEmbeded) {
			  	msg = "error@#" + msg;
			  }
		  }
	  }catch(Throwable t) {
	  	msg = "An error occured during verification: " + t.getMessage();
			if(isEmbeded) {
		  	msg = "error@#" + msg;
		  }
	  }
	}else {
		msg = "Verification failed, account does not exist";
		if(isEmbeded) {
	  	msg = "error@#" + msg;
	  }
	}
  
  if(isEmbeded) {
  	response.setContentType("text/xml");
		out.write(msg);
		out.flush();
		return;
  }
%>

<html>

<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>
  function operationOk(){
    var path ="listOfAccounts.jsp";
    document.location = path;
  }
</script>
</head>

<body>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Verification&nbsp;</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Result</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="22">
                    <span class="REGULARTEXT"><%=msg%></span>
                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="35%">&nbsp;</td>
                <td width="11%" align="center">&nbsp;</td>
                <td width="7%" align="center"><a href='javascript:history.go(-1)' class="LINK">
                ok</a></td>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</body>

</html>