<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.data.aggregate.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";

  String format = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
  SimpleDateFormat dateFormat = new SimpleDateFormat(format);
%>
<%
  String AGG_CONF = "AGG_CONF";
  String AGG_MGR = "AGG_MGR";
  
  String CURRENT_LOG = "CURRENT_LOG";
  
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  

//site management
  LogAggregationConf conf = (LogAggregationConf)request.getSession().getAttribute(AGG_CONF);
  AggregationManager mgr = (AggregationManager)request.getSession().getAttribute(AGG_MGR);
  
  TimeFramesAggregatorResults timeFramesResults = mgr.getTaresult();
  
  String resultKey = request.getParameter("resultKey");
  TimeFrameAggregatorResult frameResult = null;
  if (resultKey == null || resultKey.length() == 0){
  	frameResult = timeFramesResults == null ? null : timeFramesResults.getAllTimeFrameResult();
  }else {
  	frameResult = timeFramesResults == null ? null : timeFramesResults.getResultFromKey(resultKey);
  }
  
  TimeFrameAggregatorResult [] drillDownResults = new TimeFrameAggregatorResult[0];
  if (frameResult != null){
  	drillDownResults = timeFramesResults.getDrillDownFramesResults(frameResult);
  }

  LogBrowsingManager lbm = null;

  String lid = conf.getLogId();
	if((lid != null) && !(lid.trim().equals(""))){
	 try{
	  lbm = mgmt.getLogBrowserManager(lid);
	 }catch(Exception e){}
	}else{
	  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
	}
	
	DecimalFormat decFormat = new DecimalFormat("##.##");
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>	
	
	
</script>

</head>
<body>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
              <tr>
                <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="53%" class="TOPBORDER" height="0">
                <span class="PAGEHEADER">Aggregation Results </span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;</td>
                <td width="43%" height="100%">&nbsp;</td>
                <td width="50%" height="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%"    height="53" style="visibility:visible">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Aggregation result summary
                     <% if (frameResult != null && frameResult.getStartTime() > 0){%>
                <nobr>(<%=dateFormat.format(new Date(frameResult.getStartTime()))%> - <%=dateFormat.format(new Date(frameResult.getEndTime()))%>)</nobr>
                <%}%>
                </span></td>
                  </tr>
                  <tr>
                    <td>
                    &nbsp;
                    </td>
                  </tr>
                  <tr>
                    <td>
                    Filter:
                    </td>
                  </tr>
                  <tr>
                    <td>
                     	<%
                     	if(conf.isFilters() && frameResult != null){
                     	FilterAggregationResult fresult = mgr.getFaresult(frameResult);
                        
                        String[] fIds = conf.getFilters();
                        for (int i = 0; i < fIds.length; i++) {
							AggregationResultData fd = fresult.getResultData(fIds[i]);
						%>
						Result For: <%=lbm == null ? fIds[i] : lbm.getFilterManager().getFilterCollectionById(fIds[i]).getName()%> Count <%=fd.getResultParameter(FiltersAggregator.TOTAL_MATCH_LONG)%><br>
						<%}}%>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    &nbsp;
                    </td>
                  </tr>
                  <tr>
                    <td>
                    Content:
                    </td>
                  </tr>
                  <tr>
                    <td>
                   <%
                   if(conf.isContent() && frameResult != null){
  		ColumnAggregationResult cresult = mgr.getCaresult(frameResult);
  		int[] nindexs = conf.getContentIndexToAgg();
  		for (int i = 0; i < nindexs.length; i++) {
  		    AggregationResultData dc = cresult.getResultData(""+nindexs[i]);
			List list = dc.getParameterKeys();
			for (int t = 0; t < list.size(); t++) {
				Object key = list.get(t);
				Object l = dc.getResultParameter(key);
	%>
			  Result For  <%=key%>   Count:<%=l%><br>
	<%
		    }
		}}
  	%>
                    </td>
                  </tr>
                   <tr>
                    <td>
                    &nbsp;
                    </td>
                  </tr>
                  <tr>
                    <td>
                    Numeric:
                    </td>
                  </tr>
                  <tr>
                    <td>
                     	<%
                     	if(conf.isNumeric() && frameResult != null){
  		ColumnAggregationResult result = mgr.getNaresult(frameResult);
  		int[] indexs = conf.getNumericIndexToAgg();
		for (int i = 0; i < indexs.length; i++) {
			AggregationResultData d = result.getResultData(String.valueOf(indexs[i]));
	%>
			
			Result For index: <%=lbm == null ? "" + indexs[i] : lbm.getRecordMask().getMaskColumn(indexs[i]).getName()%> <br>&nbsp;&nbsp;  Count:<%=d.getResultParameter(NumbersAggregator.TOTAL_COUNT_LONG)%>, 
			Sum : <%=decFormat.format(d.getResultParameter(NumbersAggregator.TOTAL_SUM_DOUBLE))%>, Avg: <%=decFormat.format(d.getResultParameter(NumbersAggregator.TOTAL_AVG_DOUBLE))%><br>
	<%
		}}
  	%>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    &nbsp;
                    </td>
                  </tr>
                  <tr>
                    <td>
                    <% for(int i = 0; i < drillDownResults.length;i++){ 
                       String key = timeFramesResults.createKeyForResult(drillDownResults[i]);
                       String title = dateFormat.format(new Date(drillDownResults[i].getStartTime()));
                    %>
                    <a class="LINK" href="aggResult.jsp?resultKey=<%=key%>"><%=title %></a><br>
                    <%} %>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="33%"></td>
            <td width="33%" align="center">
            <a href="javascript:history.go(-1)" class="LINK">back</a>&nbsp;&nbsp;
            <a href="<%=BASE_DIRECTORY%>/logEyePortal.jsp" class="LINK">ok</a></td>
            <td width="34%"></td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</body>

</html>