<%@ page language="java"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.common.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.data.aggregate.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);

  final AggregationManager mgr = (AggregationManager)request.getSession().getAttribute("AGG_MGR");  	
	mgr.aggregate(true);
	
	final JobStatus finalStatus = mgr.getTag().getStatus();
	env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, finalStatus); 

  ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "tools/aggregation/aggResult.jsp") {
  public void run(HttpServletRequest request){  	 
    //if the data source failed or the datasource finished, ends the progress.
    boolean isFinished = false;
    boolean isFailed = false;
    try {
      while(!isFinished && !isFailed){
 	  		Thread.sleep(1000);
        isFinished =  finalStatus.isFinish();
        isFailed = finalStatus.isFailed();
     }
   }catch (Exception e){
     e.printStackTrace();
     isFailed = true;
   }
   

   

  }
};
env.setProgressRunner(runner);

%>

<jsp:include page="../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Processing"/>
 <jsp:param name="useStatus" value="true"/>
</jsp:include>

  
