<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.aggregate.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%@ include file="../sandf/dateFilterAction.jsp"%>

<%
  String ERROR_OBJ = "ERROR_OBJ";
  String CURRENT_LOG = "CURRENT_LOG";
  String AGG_CONF = "AGG_CONF";
  String LOG_ID = "logbrowser";

  //aggregation types:
  String filters = "filters";
  String numeric = "numbers";
  String content = "content";
  String exeRule = "executionRules";
  
  //distribution data
  String totalCountDis = "totalCount";
  String dailyDis ="dailyDis"; 
  String hourlyDis ="hourlyDis";
  String minutesDis ="minutesDis";

  //time rules
  String XP_DOWN = "download";
  

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  String filtersParam       = request.getParameter(filters);
  String numbericParam    = request.getParameter(numeric);
  String contentParam    = request.getParameter(content);
  String exeRuleParam    = request.getParameter(exeRule);
  String logId    = request.getParameter(LOG_ID);
  String disTotal    = request.getParameter(totalCountDis);
  String disDay    = request.getParameter(dailyDis);
  String disHour    = request.getParameter(hourlyDis);
  String disMin    = request.getParameter(minutesDis);

  //verify data
  ErrorModel errmodel = new ErrorModel();
  LogBrowsingManager lbm = null;
  
   String id = request.getParameter(LOG_ID);
  try{
	  if((id != null) && !(id.trim().equals(""))){
	    lbm = SiteManagment.getInstance().getLogBrowserManager(id);
	    
	  }else{
	    lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
	  } 
  }catch(Exception e){
	  	ErrorModel ermod = new ErrorModel();
	    ermod.addError("XpoLog Failed to load log due to the following error:");
	    ermod.addError(e.getMessage());
      request.getSession().setAttribute(ERROR_OBJ,ermod);
      response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
      return;
  }
  
  RecordMask mask = lbm.getRecordMask();
  FilterCollection fc = null;
  if(exeRuleParam.equals("timeRule")){ 
  	fc = new FilterCollection();
  	DateFilter dfilter = createDateFilter(request,response,mask);
  	if(dfilter != null){
     fc.addFilter(dfilter);
  	}
  }
  
  LogAggregationConf conf = new LogAggregationConf();
  request.getSession().setAttribute(AGG_CONF,conf);
  
  conf.setLogId(lbm.getId());
  conf.setFilters((filtersParam != null));
  conf.setNumeric((numbericParam != null));
  conf.setContent((contentParam != null));
  conf.setDayDis((disDay != null));
  conf.setHourDis((disHour != null));
  conf.setMinDis((disMin != null));
  conf.setTotal((disTotal != null));
  if(fc != null){
  	conf.setTimeRule(fc);
  }else{
	  conf.setOnAllLog(exeRuleParam.equals("allLog"));
  }
 
  response.sendRedirect("aggregateFields.jsp");
 // return;
  
 
%>

<html>
	<body>
  	filtersParam: <%=filtersParam%><br>
  	numbericParam: <%=numbericParam%><br>
    contentParam: <%=contentParam%><br>
  	exeRuleParam: <%=exeRuleParam%><br>
    logId: <%=logId%><br>
    disTotal: <%=disTotal%><br>
  	disDay: <%=disDay%><br>
    disHour: <%=disHour%><br>
  	disMin: <%=disMin%><br>
	</body>
</html>
