<%@ page language="java"%>

<%@ page import="xpolog.config.image.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);

	String ERROR_OBJ = "ERROR_OBJ";
	ConfigurationImageManager confMgr = ConfigurationImageManager.getInstance();
	ConfigurationImage confImg = null;
	
	String id = request.getParameter("ID");
	ErrorModel errmodel = new ErrorModel();
	
	if(id == null){
		errmodel.addError("Please supply Id for Configuration Image to duplicate.");
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		return;
	}
	
	confMgr.duplicateConfigurationImage(id);
	
	//	audit
	String Name = confMgr.getConfigurationImageById(id).getName();
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		  			userContext, AuditConstants.CHANGE, "duplicate configuration image", AuditConstants.CONFIGURATION, "duplicate configuration image " + Name);

	String redirectUrl = request.getParameter("redirectURL");
	if (redirectUrl != null && redirectUrl.length() > 0){
		response.sendRedirect(BASE_DIRECTORY + redirectUrl);
	}else{
		response.sendRedirect("confImageView.jsp");
	}
	

%>