<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.image.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%

	String ERROR_OBJ = "ERROR_OBJ";
	String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";

	SiteManagment mgmt = SiteManagment.getInstance();

	boolean isTxExpoViewere = mgmt.getXpologManagment().isTransactionExpoValidAndComponentExists();
	
	ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute(CONF_IMG_BUILDER);
	ErrorModel errmodel = new ErrorModel(); 

	//create builder object by license type
	ConfImageBuilderInitilizer xplgBuilder = (ConfImageBuilderInitilizer)ConfImageBuilderFactory.getConfImageBuilderFactory(ConfImageBuilderFactory.XPOLOG_TYPE);
	if(xplgBuilder != null){
		xplgBuilder.updateConfImageBuilder(request,builder,errmodel);
	}
	if(isTxExpoViewere){ //license for TxExpo
		ConfImageBuilderInitilizer txExpoBuilder = (ConfImageBuilderInitilizer)ConfImageBuilderFactory.getConfImageBuilderFactory(ConfImageBuilderFactory.TXEXPO_TYPE);
		if(txExpoBuilder != null){
			txExpoBuilder.updateConfImageBuilder(request,builder,errmodel);
		}
	}
	
	if(builder.getName() == null || builder.getName().equals("")){
	  	errmodel.addError("No Name was supplied.");
	  	request.getSession().setAttribute(ERROR_OBJ,errmodel);
	  	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
	  	return;
	}
	if(builder == null){
  	request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
	}else	if(builder.getVerifiersMap() == null && builder.getVerifiersMap().size() == 0 &&
		builder.getAccountsToExp() == null && builder.getAccountsToExp().size() == 0 && builder.getReportsToExp() == null && builder.getReportsToExp().size() == 0 &&
		builder.getSchedulersToExp() == null && builder.getSchedulersToExp().size() == 0 && builder.getTasksToExp() == null && builder.getTasksToExp().size() == 0 &&
		builder.getMetaDataToExp() == null && builder.getMetaDataToExp().size() == 0 && 
		builder.getTemplatesToExp() == null && builder.getTemplatesToExp().size() == 0 && builder.getWizardsToExp() == null && builder.getWizardsToExp().size() == 0 ){
		errmodel.addError("You cannot save an empty configuration image. ");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
	}
	

	response.sendRedirect("confImageSaveAction.jsp");

%>

