<%@ page language="java"%>

<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.config.image.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
	String ERROR_OBJ = "ERROR_OBJ";
	String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";
	String IMAGE_PROP = "IMAGE_PROP";

	ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute("CONF_IMG_BUILDER");

  ConfigurationPublisher publisher = builder == null ? null : builder.getCurrentPublisher();
	
	ErrorModel errmodel = new ErrorModel(); 
	if(publisher == null){
		errmodel.addError("No Publisher was saved on session.");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
  }
  
	Properties prop = publisher.getProperties();
	if (prop == null){
		prop = new Properties();
	}
	
	for (int i = 1; i < 1000;i++){
	  String key = request.getParameter("globalpathSource_" + i);
	  if (key != null && key.length() > 0){
	    String value = request.getParameter("globalpathTarget_" + i);
	    prop.put(ConfigurationImage.GLOBAL_LOG_ENTRY_KEY_PROPERTIES+"_"+i,key);
	    prop.put(ConfigurationImage.GLOBAL_LOG_ENTRY_VALUE_PROPERTIES+"_"+i,value);
	  }else {
	    break;
	  }
	}
  String targetPaths = request.getParameter("targetPaths");
  if (targetPaths != null){  	
  	String[] logspaths = targetPaths.split("\\|");
  	int indx = 0;
  	for (int i=0; i<logspaths.length; i++){
  		String[] lp = logspaths[i].split("=");
  		if (lp != null && lp.length==2){
    		if(prop != null){
    			String key =  prop.getProperty(lp[0]+"_"+indx) ;
    			if(key != null && key.length() > 0){
    				indx++;
    			}else{
    				indx = 0;
    			}
    		}
  			prop.put(lp[0]+"_"+indx,lp[1]);
  		}
  	}
  }
    
	WizardUIController uiCtrl = builder.getPublisherUiController();
	uiCtrl.updatePageId("tools/confImage/confImageLogsPathsAction.jsp");
	String forwardUrl = uiCtrl.getForwardPage();

	response.sendRedirect(BASE_DIRECTORY + forwardUrl);
%>

