<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.data.log.external.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.image.*"%>
<%@page import="xpolog.eye.meta.MetaDataManager"%>
<%! 
	static final String BASE_DIRECTORY = "../../";
%>
     
<%
  String ERROR_OBJ = "ERROR_OBJ";
	String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";
	if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.ConfigurationPermissions.CONF_IMAGE_PERMISSION,true)){
      return;
    }
  SiteManagment mgmt = SiteManagment.getInstance();
	ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute("CONF_IMG_BUILDER");
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	ErrorModel errmodel = new ErrorModel(); 
	
	HashMap mods = builder.getModsToExp();
	
	HashMap metaDatas = builder.getMetaDataToExp();
	HashSet modsToAdd = new HashSet();
	if(metaDatas != null && metaDatas.size() > 0){
		MetaDataManager metaDataMgr = SiteManagment.getInstance().getMetaDataMgr();
		Iterator it = builder.getMetaDataToExp().keySet().iterator();
		while(it.hasNext()){
			String metaId = (String)it.next();
			if(metaId == null){
				continue;
			}
			String[] members = metaDataMgr.getXplgObjectsByMetaData(metaId);
			if(members == null){
				continue;
			}
			for(int i=0 ; i<members.length;i++){
				int indx = members[i].indexOf('-');
				if(indx == -1){
					continue;
				}else{
					String type = members[i].substring(0,indx);
					String id = members[i].substring(indx+1, members[i].length());
					if(type.equals(XpoLogObjectTypes.MODULE_TYPE)){
						Module mod  =mgmt.getModuleFromId(id);
						if(mod != null && !mods.containsKey(id)){
							modsToAdd.add(id);
							List list = mod.getModuleMembers(userContext);
							for (int l = 0; l < list.size();l++){
								ModuleMember member = (ModuleMember)list.get(l);
								if (member.getType().equalsIgnoreCase("Module")){
									modsToAdd.add(member.getId());
								}
							}
					  }
					}
				}
			}
			
		}
	
	}
	
	ArrayList modsList = null;
	if(mods != null) {
		modsList = new ArrayList(mods.values());
		if(modsToAdd != null && modsToAdd.size() > 0){
			modsList.addAll(modsToAdd);
		}
		Collections.sort(modsList);
	}else {
		modsList = new ArrayList();
	}
	
	ConfigurationPublisher publisher = null;
	String publisherId = request.getParameter("publisherId");
	if (publisherId != null){
	  if (publisherId.equals("current")){
	    publisher = builder.getCurrentPublisher();
	  }else {
	    publisher = builder.getConfigurationPublisher(publisherId);
	    if (publisher != null){    
	      try {
	        publisher = (ConfigurationPublisher)publisher.clone();	        
	      }catch (Exception e){
	        e.printStackTrace();
	        publisher = null;
	      }
	    }
	  }
	}
	
	if (publisher == null){
	  publisherId = "";
	  publisher = builder.createNewConfPublisher();
	}
	builder.setCurrentPublisher(publisher);
	WizardUIController uiCtrl = builder.getPublisherUiController();
	uiCtrl.updatePageId("tools/confImage/confImageModuleNames.jsp");
	String forwardUrl = uiCtrl.getForwardPage();
	String backwardUrl = uiCtrl.getBackwardPage();
	String cancelUrl = uiCtrl.getCancelUrl();

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
  baseDirectory = "<%=BASE_DIRECTORY%>";
 
  function doNext(){
    document.access.action ="<%=BASE_DIRECTORY+forwardUrl%>";
    updateNewModNames();
    document.access.submit();
  }
  
  function updateNewModNames(){
 		var modnames = "";
  	for (var i=0; i<<%=modsList.size()%>; i++){
  		modid = eval("document.access.modid_"+i);
  		newmodname = eval("document.access.newModName_"+i);
 			if (modid && newmodname && newmodname.value!=""){
	 			modnames += (modnames==""?"":"|")+("<%=ConfigurationImage.MODULE_ENTRY_IN_PROPERTIES%>_"+modid.value+"="+newmodname.value);
	 		}
  	}
  	document.access.modnames.value = modnames;
  }
  
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<input type="hidden" name="modnames">
<input type="hidden" name="publisherId" value="<%=publisherId%>">
<table border="0" width="100%" cellspacing="0" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="5" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="56%" class="TOPLEFTBORDER">
                <span class="PAGEHEADER">&nbsp;Configuration Image folder names</span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td colspan="2">&nbsp;</td>
              </tr>
              <tr>
                <td colspan="2" height="18"><span class="HEADER">General</span></td>
              </tr>
              <tr>
                <td colspan="2" >
                  <table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%">
                  <tr>
  	               <td width="120"><span class="REGULARTEXT">Publisher name:</span></td>
	                 <td width="*"><span class="REGULARTEXT"><input type="text" name="publisherName" size="20" value="<%=publisher.getName()%>"></span></td>
	               </tr></table>
	               </td>
	            </tr>
              <tr>
                <td colspan="2">&nbsp;</td>
              </tr>
              <tr>
                <td colspan="2" height="18"><span class="HEADER">Folder names</span></td>
              </tr>
              <tr>
                <td colspan="2" height="18"><span class="SMALLTEXT">Please specify for each folder the name it will have in the target machine.</span></td>
              </tr>
              <tr><td colspan="2">&nbsp;</td></tr>
            </table>
            </td>
          </tr>
          <tr>
          	<td>
            <table border="0" cellpadding="2" cellspacing="2"  width="100%">
            	<tr>
                <td width="25%" align="center"><span class="HEADER">Local folder name</span></td>
                <td width="25%" align="center"><span class="HEADER">New folder name</td>
                <td width="50%" align="center">&nbsp;</td>
              </tr>
              <%
              for(int i=0;i<modsList.size();++i) {
      	  			String modId = (String)modsList.get(i);
      	  			Module module = mgmt.getModuleFromId(modId);
      	  			if(module == null) {
      	  				continue;
      	  			}
      	  			String localModName = module.getName();
      	  			String newModName = "";
      	  			if (publisher != null && publisher.getProperties() != null){
	      	  			newModName = publisher.getProperties().getProperty(ConfigurationImage.MODULE_ENTRY_IN_PROPERTIES+"_"+modId);
      	  			}
      	  			if (localModName == null || localModName.equals("")){
      	  				continue;
      	  			}
      	  			if (newModName == null || newModName.equals("")){
      	  				newModName = localModName;
      	  			}
      		  	%>
	            <tr>
	              <td width="25%"><span class="REGULARTEXT"><%=localModName%></span></td>
	              <td width="25%"><span class="REGULARTEXT"><input type="text" name="newModName_<%=i%>" size="50" value="<%=newModName%>"></span><input type="hidden" name="modid_<%=i%>" value="<%=modId%>"></td>
	              <td width="50%">&nbsp;</td>
	            </tr>
              <%}%>
          	</table>
		        </td>
    		  </tr>
    		</table>
    		</td>
    	</tr>
      <tr>
				<td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
					<tr><td colspan="3">&nbsp;</td></tr>
					<tr><td colspan="3">&nbsp;</td></tr>
          <tr>
             <td width="*" colspan="3" align="center"><a href="<%=backwardUrl!=null ? (BASE_DIRECTORY+backwardUrl) :"javascript:history.go(-1)"%>" class="LINK">previous</a>&nbsp;&nbsp;
             <a href="javascript:doNext()" class="LINK">next</a>&nbsp;&nbsp;
             <a href="<%=BASE_DIRECTORY+cancelUrl%>" class="LINK">cancel</a></td>
          </tr>
          <tr><td colspan="3">&nbsp;</td></tr>
       		<tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>