<%@ page language="java"%>

<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.config.image.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
	String ERROR_OBJ = "ERROR_OBJ";
	String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";
	String IMAGE_PROP = "IMAGE_PROP";

  ErrorModel errmodel = new ErrorModel(); 
	ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute("CONF_IMG_BUILDER");
	
	String publisherId = request.getParameter("publisherId");
	String publisherName = request.getParameter("publisherName");
	
	if(publisherName == null || publisherName.length() == 0){
		errmodel.addError("No name was supplied.");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
  }

	ConfigurationPublisher publisher = builder == null ? null : builder.getCurrentPublisher();
	
	
	
	if(publisher == null){
		errmodel.addError("No Publisher was saved on session.");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
  }
  
  publisher.setName(publisherName);
	Properties prop = new Properties();
  String modnames = request.getParameter("modnames");
  if (modnames != null){
  	String[] newmodnames = modnames.split("\\|");
  	for (int i=0; i<newmodnames.length; i++){
  		String[] mn = newmodnames[i].split("=");
  		if (mn != null && mn.length==2){
  			prop.put(mn[0],mn[1]);
  		}
  	}
  }
	
	publisher.setProperties(prop);
	
	WizardUIController uiCtrl = builder.getPublisherUiController();
	uiCtrl.updatePageId("tools/confImage/confImageModuleNamesAction.jsp");
	String forwardUrl = uiCtrl.getForwardPage();
	response.sendRedirect(BASE_DIRECTORY + forwardUrl);
%>

