<%@ page language="java"%>
 
<%@ page import="xpolog.config.image.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.cloud.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%  

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ENTERPRISE_PERMISSION,true)){
     return;
  }
  
  String ERROR_OBJ = "ERROR_OBJ";
	String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";

  String NodeName = "nodeName"; 
  String nodeName = request.getParameter(NodeName);
    
	ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute("CONF_IMG_BUILDER");
	
	ConfigurationPublisher publisher = builder == null ? null : builder.getCurrentPublisher();
	
	ErrorModel errmodel = new ErrorModel(); 
	if(publisher == null){
		errmodel.addError("No Publisher was saved on session.");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
  }
	
	HashMap imageXplgNodesMap = publisher.getXplgNodes();
	Set set = imageXplgNodesMap != null ? imageXplgNodesMap.keySet() : null;
	
  SiteManagment mgmt = SiteManagment.getInstance();
  CloudMgr cmgr = mgmt.getCloudMgr();
  XplgNode[] list = cmgr.getAllXplgNodes();
  list = CloudUtil.sortArrayByName(list);
  String localHostChecked = "";
  if (publisher.isLocalMachine()){
  	localHostChecked = "checked";
  }

	WizardUIController uiCtrl = builder.getPublisherUiController();
	uiCtrl.updatePageId("tools/confImage/confImageXplgNodes.jsp");
	String forwardUrl = uiCtrl.getForwardPage();
	String backwardUrl = uiCtrl.getBackwardPage();
	String cancelUrl = uiCtrl.getCancelUrl();
%>

<html>

<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
	function doNext(){
    document.access.action ="<%=BASE_DIRECTORY + forwardUrl%>";
    document.access.submit();
	}
	<%if (list != null){%>
  function selectAllNodes(){
  	<%if(list.length == 1) {%>
  		document.access.xplgNode.checked = true;
  	<%}else { %>
	  	for (var i=0; i<<%=list.length%>; i++){
	  		document.access.xplgNode[i].checked = true;
	  	}
  	<%} %>
  }
  
  function clearAllNodes(){
  	<%if(list.length == 1) {%>
  		document.access.xplgNode.checked = false;
  	<%}else { %>
	  	for (var i=0; i<<%=list.length%>; i++){
	  		document.access.xplgNode[i].checked = false;
	  	}
  	<%} %>
  }
	<%}%>
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="98%" class="TOPBORDER">
                <span class="PAGEHEADER"> Publish to nodes</span></td>
                <td width="1%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td colspan="3">&nbsp;</td>
              </tr>
              <tr>
                <td colspan="3"><span class="HEADER">XpoLog Enterprise Nodes</span></td>
              </tr>
              <tr>
                <td colspan="3" height="18">&nbsp;</td>
              </tr>
              <tr>
                <td colspan="3"><span class="SMALLTEXT">Select the XpoLog Enterprise Nodes you want to publish the configuration image to</span></td>
              </tr>
              <tr>
                <td colspan="3">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="53">
              <tr>
                <td>
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
										<tr>
											<td><input type="checkbox" id="publishToLocalHost" name="publishToLocalHost" value="true" <%=localHostChecked%>><span class="REGULARTEXT">local Xpolog Node</span></td>
										</tr> 
									<%if(list.length > 0) {%>
	                <tr>
										<td><hr></td>
									</tr>
									<tr>
	                	<td>
											<table border="0" cellpadding="0" cellspacing="0">
												<tr>
													<td><a href="javascript:selectAllNodes()" class="SMALLLINK">select all</a></td>
													<td width="10">&nbsp;</td>
													<td><a href="javascript:clearAllNodes()" class="SMALLLINK">clear all</a></td>
												</tr>
											</table>
	                	<td>
	                </tr>
		              <%for(int t=0;t<list.length;t++) {
		              	  String checked = "";
		              	  if (set != null){
			              	  if (set.contains(list[t].getId())){
			              	  	checked = "checked";
			              	  }
		              	  }
		              %>
										<tr>
											<td><input type="checkbox" id="<%=list[t].getId()%>" name="xplgNode" value="<%=list[t].getId()%>" <%=checked%>><span class="REGULARTEXT"><%=list[t].getName()%></span></td>
										</tr> 
		              <%}%>
		              <%}%>
                </table>
               </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
				          <tr>
				          	<td width="28%"></td>
				            <td width="12%" align="center"><a href="<%=backwardUrl!=null ? (BASE_DIRECTORY+backwardUrl) :"javascript:history.go(-1)"%>" class="LINK">previous</a></td>
				            <td width="14%" align="center"><a href="javascript:doNext()" class="LINK">next</a></td>
				          	<td width="*">&nbsp;</td>
				            </td>
				          </tr>
                </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>