<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%> 
<%@ page import="xpolog.eye.util.*"%> 
<%@ page import="xpolog.config.image.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	final UserContext userContext = UserEnvironment.getUserContext(request);	
	String ID = "ID";
	String id = request.getParameter(ID);
	final String publisherId = request.getParameter("PUBLISHER_ID");

	ConfigurationImageManager confMgr = ConfigurationImageManager.getInstance();
	ConfigurationImage confImg = null;
	if (id != null && id.length() > 0){
		confImg = confMgr.getConfigurationImageById(id);
	}else {
  	confImg = (ConfigurationImage)request.getSession().getAttribute("CONF_IMG");
	}

	confImg.setImagePackingMode(ConfigurationImagePackingUnit.EXPORT_MODE); // set publish mode
	//	audit
 		String Name = "";
 		if(confImg != null) {
 			Name = confImg.getName();
 		}
 		AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			  			userContext, AuditConstants.CHANGE, "export configuration image", AuditConstants.CONFIGURATION, "export configuration image " + Name);

  
	final ConfigurationImage confImgTmp = confImg;

	ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "tools/confImage/confImageView.jsp") {
		public void run(HttpServletRequest request) {
			File zipFile;
			String zipFilePath = "";			
			
			try{
				Thread.sleep(500);
		      zipFile = confImgTmp.execute(publisherId);
		      zipFilePath = zipFile.getName();
		      setRedirectUrl(BASE_DIRECTORY + "common/opok.jsp?redirectUrl=temp/" + zipFilePath + "&okUrl=tools/confImage/confImageView.jsp");
		      
		} catch (Exception e) {
			String err = XpologUtil.getErrorMessage(e);
      errmodel.addError("The following error occured while archiving:");      
      errmodel.addError(err);      
      createErrorRedirect(request, BASE_DIRECTORY);
      return;
		}			
		}		
	};
	
	env.setProgressRunner(runner);

%>
<jsp:include page="../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Exporting configuration"/>
</jsp:include>	
