<%@ page language="java"%>

<%@ page import="java.util.*"%>

<%@ page import="xpolog.eye.automation.tasks.XpoTask"%>
<%@ page import="xpolog.eye.cloud.XplgNode"%>
<%@ page import="xpolog.eye.cloud.CloudUtil"%>
<%@ page import="xpolog.eye.cloud.CloudMgr"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.security.UserSecurity"%>
<%@ page import="xpolog.config.image.ConfigurationImageBuilder"%>

<%!
	static final String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";
%>
<%
	WebSecurityManager securityManager = WebSecurityManager.getInstance();
  if (!securityManager.checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION,true)){
    return;
  }

	UserContext userContext = UserEnvironment.getUserContext(request);
	SiteManagment mgmt = SiteManagment.getInstance();
	UserSecurity user = securityManager.getUserSecurity(request);
  ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute(CONF_IMG_BUILDER);
	CloudMgr cmgr = mgmt.getCloudMgr();
	XplgNode[] nodesArr = cmgr.getAllXplgNodes(userContext);
	nodesArr = CloudUtil.sortArrayByName(nodesArr);
	

	  HashSet selectedXplgNodes = new HashSet();
	  HashMap nodes = builder.getXplgNodesToExp();
		HashMap nodesToOverride = builder.getXplgNodesToOverride();
	  if (nodes != null){
			Iterator it = nodes.keySet().iterator();
			while (it.hasNext()){
				String templ = (String)it.next();
				selectedXplgNodes.add(templ);
			}
	 }
	  String style3 = nodesArr.length > 1 ? "" : "visibility: hidden;";
	
%>
<script>
  function CheckNodes(){
	  if(document.access.checkedAllNodes.checked == true){
	  	for (var i=0; i<<%=nodesArr.length%>; i++){
  			document.access.checkNodesList<%=nodesArr.length > 1 ? "[i]" : ""%>.checked = true;
	  	}  	
	  }else{
	  	for (var i=0; i<<%=nodesArr.length%>; i++){
  			document.access.checkNodesList<%=nodesArr.length > 1 ? "[i]" : ""%>.checked = false;
  		}
	  }
  }
  
  function CheckOverrideNodes(){
   if(document.access.checkOverrideNodes.checked == true){
	  	for (var i=0; i<<%=nodesArr.length%>; i++){
  			document.access.checkOverrideNodesList<%=nodesArr.length > 1 ? "[i]" : ""%>.checked = true;
	  	}  	
	  }else{
	  	for (var i=0; i<<%=nodesArr.length%>; i++){
  			document.access.checkOverrideNodesList<%=nodesArr.length > 1 ? "[i]" : ""%>.checked = false;
  		}
	  }
  }
</script>
<table width="100%" border="0"> 
	<tr>
	<td>&nbsp;</td>
	</tr>
  <tr>
     	<td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="15%" height="28" colspan="3"><span class="HEADER">XpoLog Nodes</span></td>
              </tr>                
               <tr>
                <td width="100%" height="18"><span class="SMALLTEXT">Please check the nodes you want to save in this configuration image.</span></td>
                </tr>
                
                
                
                           <tr>
                <td width="33%">&nbsp;</td>                
              </tr>
               <tr>
     	<td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
        <tr class="TABLES_HEADERS">
        <td width="33%"><span class="REGULARTEXT"><b>Name</b></span></td>                
        <td width="33%"><span class="REGULARTEXT"><b>Description</b></span></td>                
        <td width="33%"><span class="REGULARTEXT"><b>Overwrite</b></span></td>                
        </tr>        
       <%for(int i=0;i<nodesArr.length;++i) {
              	  String checked = "";
              	 	String override = "";
              	  XplgNode node = (XplgNode)nodesArr[i];     	  
              	  String desc = node.getDescription() != null && node.getDescription().length() > 0 ? " - (" + node.getDescription() + ")" : "";

              	  if(selectedXplgNodes.contains(node.getId())) {
              	  	  checked = "checked";
              	   	  if(nodesToOverride.containsKey(node.getId())){
              	  		  override = "checked";
              	  	  }
              	  }else {
              	      checked = "";
              	  }

              %>
         <tr>     
		<td width="18%"><input id="<%=node.getId()%>" name="checkNodesList" value="<%=node.getId()%>" type="checkbox"   <%=checked%>><span class="REGULARTEXT"><%=node.getName()%></span></td>                
        <td width="18%"><span class="REGULARTEXT"><%=node.getDescription()%></span></td>                
        <td width="18%"><input id="override_<%=node.getId()%>" name="checkOverrideNodesList" value="<%=node.getId()%>" type="checkbox"   <%=override%>></td>            
        </tr>
        <%} %>
                 <tr>
	<td>&nbsp;</td>
	</tr>  
	    <tr class="TABLES_HEADERS"   style="<%=style3%>">
		<td width="33%"><input name="checkedAllNodes" type="checkbox" onClick="CheckNodes()"><span class="REGULARTEXT"><b>Check All</b></span></td>                
        <td width="33%">&nbsp;</td>                
        <td width="33%"><input name="checkOverrideNodes" type="checkbox" onClick="CheckOverrideNodes()"><span class="REGULARTEXT"><b>Check All</b></span></td>           
        </tr>
        </table>
        </td>
        </tr>           
       </table>
      </td>
   </tr>
 	<tr>
	<td>&nbsp;</td>
	</tr>  
</table>      
				

