<%@ page language="java"%>

<%@ page import="xpolog.eye.admin.builders.RemoteLogBuilder"%>
<%@ page import="xpolog.config.image.ConfigurationImageBuilder"%>
<%@ page import="xpolog.eye.site.ui.tree.ModuleMemberRenderer"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.util.*"%>

<%
	String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";

	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
	
	HashMap logsMap = null;
	HashMap modulesMap = null;
	HashMap undeletableLogsMap = null;
	HashMap undeletableModulesMap = null;
	
	ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute(CONF_IMG_BUILDER);
  if (builder != null){
		logsMap = builder.getLogsToExp();
		modulesMap = builder.getModsToExp();
		undeletableLogsMap = builder.getUndeletableLogsToExp();
		undeletableModulesMap = builder.getUndeletableModsToExp();
  }
	
	boolean treeNodeExists = false;
	String treeXml = ""; 
  String id = request.getParameter("id");
  if (id != null){
  	String modid = id;
  	int ind = id.indexOf("-");
  	if (ind != -1){
  		modid = id.substring(ind+1);
  	}
		curmod = SiteManagment.getInstance().getModuleFromId(modid);
		treeNodeExists = true;
  }
  
	
	if (curmod != null){
		ModuleMemberRenderer renderer = new ModuleMemberRenderer(curmod, userContext, modulesMap, logsMap, true, false, treeNodeExists);
		if (!userContext.isModuleMemberEditable(Module.ROOT_MODULE_ID)){
			renderer.setShowRootModule(false);
		}
		HashSet logTypesToIgnore = new HashSet();
		logTypesToIgnore.add(RemoteLogBuilder.PROXY_LOG_TYPE);
		renderer.setLogTypesToIgnore(logTypesToIgnore);
		renderer.setDisabledLogs(undeletableLogsMap);
		renderer.setDisabledModules(undeletableModulesMap);
		treeXml = renderer.getTreeXML(true,true);
	}
	
	//System.out.println(treeXml);
	response.setContentType("text/xml");
	out.write(treeXml);
	out.flush();
%>