<%@ page language="java"%>

<%@ page import="java.util.*"%>
<%@page import="xpolog.eye.automation.tasks.XpoTaskManager"%>
<%@page import="xpolog.eye.automation.tasks.XpoTask"%>

<%@page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@page import="xpolog.eye.security.WebSecurityManager"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.SiteManagment"%>
<%@page import="xpolog.config.image.ConfigurationImageBuilder"%>
<%@page import="xpolog.eye.security.UserSecurity"%>

<%!
	static final String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";
%>

<%
	WebSecurityManager securityManager = WebSecurityManager.getInstance();
	if (!securityManager.checkForPermission(request,response,ActionsPermissionConstants.AutomationPermissions.VIEW_TASK_PERMISSION,true)){
		return;
	}
	UserContext userContext = UserEnvironment.getUserContext(request);
	SiteManagment mgmt = SiteManagment.getInstance();
	UserSecurity user = securityManager.getUserSecurity(request);
	ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute(CONF_IMG_BUILDER);

	XpoTaskManager taskmgr = XpoTaskManager.getInstance();
	List list = taskmgr.getXpoTasksByFilter(null,userContext);
	
	  boolean isReportViewer = securityManager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION);
		boolean txExpoViewer = mgmt.getXpologManagment().isTransactionExpoValidAndComponentExists();

	  HashSet selectedTasks = new HashSet();
	  HashMap tasks = builder.getTasksToExp();
		HashMap tasksToOverride = builder.getTasksToOverride();
	  if (tasks != null){
			Iterator it = tasks.keySet().iterator();
			while (it.hasNext()){
				String templ = (String)it.next();
				selectedTasks.add(templ);
			}
	 }
	  String style1 = list.size() > 1 ? "" : "visibility: hidden;";
	
%>

<script>
  function CheckTasks(){
	  if(document.access.checkedAllTasks.checked == true){
	  	for (var i=0; i<<%=list.size()%>; i++){
  			document.access.checkTasksList<%=list.size() > 1 ? "[i]" : ""%>.checked = true;
	  	}  	
	  }else{
	  	for (var i=0; i<<%=list.size()%>; i++){
  			document.access.checkTasksList<%=list.size() > 1 ? "[i]" : ""%>.checked = false;
  		}
	  }
  }
  
  function CheckOverrideTasks(){
   if(document.access.checkOverrideTasks.checked == true){
	  	for (var i=0; i<<%=list.size()%>; i++){
  			document.access.checkOverrideTasksList<%=list.size() > 1 ? "[i]" : ""%>.checked = true;
	  	}  	
	  }else{
	  	for (var i=0; i<<%=list.size()%>; i++){
  			document.access.checkOverrideTasksList<%=list.size() > 1 ? "[i]" : ""%>.checked = false;
  		}
	  }
  }
</script>
<table width="100%" border="0"> 
	<tr>
	<td>&nbsp;</td>
	</tr>
  <tr>
     	<td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="15%" height="28" colspan="3"><span class="HEADER">XpoLog Tasks</span></td>
              </tr>                
               <tr>
                <td width="100%" height="18"><span class="SMALLTEXT">Please check the tasks you want to save in this configuration image.</span></td>
                </tr>
                
                
                
                           <tr>
                <td width="33%">&nbsp;</td>                
              </tr>
               <tr>
     	<td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
        <tr class="TABLES_HEADERS">
        <td width="18%"><span class="REGULARTEXT"><b>Name</b></span></td>                
        <td width="18%"><span class="REGULARTEXT"><b>Type</b></span></td>                
        <td width="18%"><span class="REGULARTEXT"><b>Description</b></span></td>                
        <td width="18%"><span class="REGULARTEXT"><b>Overwrite</b></span></td>                
        </tr>        
       <%for(int i=0;i<list.size();++i) {
              	  String checked = "";
              	 	String override = "";
              	  XpoTask task = (XpoTask)list.get(i);
              	  String type = task.getType();
              	  String desc = task.getDescription() != null && task.getDescription().length() > 0 ? " - (" + task.getDescription() + ")" : "";
                	if (type != null && ((!isReportViewer && type.equals("reports"))) ||
                			(!txExpoViewer && type.equals("sessionResult"))){
                		continue;
                	}
              	  if(selectedTasks.contains(task.getId())) {
              	  	  checked = "checked";
              	   	  if(tasksToOverride.containsKey(task.getId())){
              	  		  override = "checked";
              	  	  }
              	  }else {
              	      checked = "";
              	  }

              %>
         <tr>     
		<td width="18%"><input id="<%=task.getId()%>" name="checkTasksList" value="<%=task.getId()%>" type="checkbox"   <%=checked%>><span class="REGULARTEXT"><%=task.getName()%></span></td>                
        <td width="18%"><span class="REGULARTEXT"><%=task.getType()%></span></td>                
        <td width="18%"><span class="REGULARTEXT"><%=task.getDescription()%></span></td>                
        <td width="18%"><input id="override_<%=task.getId()%>" name="checkOverrideTasksList" value="<%=task.getId()%>" type="checkbox"   <%=override%>></td>            
        </tr>
        <%} %>
                 <tr>
	<td>&nbsp;</td>
	</tr>  
	    <tr class="TABLES_HEADERS"   style="<%=style1%>">
		<td width="18%"><input name="checkedAllTasks" type="checkbox" onClick="CheckTasks()"><span class="REGULARTEXT"><b>Check All</b></span></td>                
        <td width="18%">&nbsp;</td>                
        <td width="18%">&nbsp;</td>                
        <td width="18%"><input name="checkOverrideTasks" type="checkbox" onClick="CheckOverrideTasks()"><span class="REGULARTEXT"><b>Check All</b></span></td>           
        </tr>
        </table>
        </td>
        </tr>           
       </table>
      </td>
   </tr>
 	<tr>
	<td>&nbsp;</td>
	</tr>  
</table>      
				

