<%@ page language="java"%>

<%@ page import="java.util.*"%>
<%@page import="xpolog.eye.template.TemplateManager"%>
<%@page import="xpolog.eye.template.Template"%>

<%@page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@page import="xpolog.eye.security.WebSecurityManager"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.SiteManagment"%>
<%@page import="xpolog.config.image.ConfigurationImageBuilder"%>
<%@page import="xpolog.eye.security.UserSecurity"%>
<%!
	static final String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";
%>
     
<%
	WebSecurityManager securityManager = WebSecurityManager.getInstance();
	if (!securityManager.checkForPermission(request,response,null,true)){
		return;
	}
	UserContext userContext = UserEnvironment.getUserContext(request);
	SiteManagment mgmt = SiteManagment.getInstance();
	UserSecurity user = securityManager.getUserSecurity(request);
	ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute(CONF_IMG_BUILDER);
	TemplateManager tmg = mgmt.getTemplateManager();
	
	Template[] tsysarr = tmg.getAllSystemTemplates(userContext);
	Template[] tusrarr = tmg.getAllUserTemplates(userContext);

	HashSet selectedTemplates = new HashSet();
	HashMap templates = builder.getTemplatesToExp();
	if (templates != null){
		Iterator it = templates.keySet().iterator();
		while (it.hasNext()){
			String templ = (String)it.next();
			selectedTemplates.add(templ);
		}
	}
	
%>
<script>
  function selectAllUserTemp(){
  	for (var i=0; i<<%=tusrarr.length%>; i++){
  		document.access.checkUserTemplateList<%=tusrarr.length > 1 ? "[i]" : ""%>.checked = true;
  	}
  }
  
  function clearAllUserTemp(){
  	for (var i=0; i<<%=tusrarr.length%>; i++){
  		document.access.checkUserTemplateList<%=tusrarr.length > 1 ? "[i]" : ""%>.checked = false;
  	}
  }
   function selectAllSysTemp(){
  	for (var i=0; i<<%=tsysarr.length%>; i++){
  		document.access.checkSysTemplateList<%=tsysarr.length > 1 ? "[i]" : ""%>.checked = true;
  	}
  }
  
  function clearAllSysTemp(){
  	for (var i=0; i<<%=tsysarr.length%>; i++){
  		document.access.checkSysTemplateList<%=tsysarr.length > 1 ? "[i]" : ""%>.checked = false;
  	}
  }
</script>

<table width="100%" border="0"> 
	<tr>
	<td>&nbsp;</td>
	</tr>
  <tr>
     	<td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td height="28"><span class="HEADER">User defined templates</span></td>
              </tr>
              <tr>
                <td>&nbsp;</td>
              </tr>
              <%for(int i=0;i<tusrarr.length;++i) {
              	  String checked = "";
            	  Template template = tusrarr[i];
              	  String desc = template.getDescription() != null && template.getDescription().length() > 0 ? " - (" + template.getDescription() + ")" : "";
            	  if(selectedTemplates.contains(template.getId())) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }

              %>
							<tr>
								<td><input type="checkbox" id="<%=template.getId()%>" name="checkUserTemplateList" value="<%=template.getId()%>" <%=checked%>><span class="REGULARTEXT"><%=template.getName()%><span class="SMALLTEXT"><%=desc%></span></span></td>
							</tr> 
              <%}%>
              <tr>
                <td>&nbsp;</td>
              </tr>
              <%if(tusrarr.length > 0){ %>
              <tr>
              <td>
								<table border="0" cellpadding="0" cellspacing="0">
									<tr>
										<td><a href="javascript:selectAllUserTemp()"
											class="SMALLLINK">select all</a></td>
										<td width="10">&nbsp;</td>
										<td><a href="javascript:clearAllUserTemp()" class="SMALLLINK">clear
										all</a></td>
									</tr>
								</table>
								</td>
							</tr>
							              <tr>
                <td>&nbsp;</td>
              </tr>
					<%}%>		
              <tr>
                <td><span class="HEADER">System templates</span></td>
              </tr>
              <tr>
                <td>&nbsp;</td>
              </tr>
              <%for(int i=0;i<tsysarr.length;++i) {
              	  String checked = "";
       			  Template template = tsysarr[i];
               	  String desc = template.getDescription() != null && template.getDescription().length() > 0 ? " - (" + template.getDescription() + ")" : "";
              	  if(selectedTemplates.contains(template.getId())) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }
              %>
							<tr>
								<td><input id="<%=template.getId()%>" name="checkSysTemplateList" value="<%=template.getId()%>" type="checkbox" <%=checked%>><span class="REGULARTEXT"><%=template.getName()%><span class="SMALLTEXT"><%=desc%></span></span></td>
							</tr> 
              <%}%>
              <tr>
                <td>&nbsp;</td>
              </tr>
          	</table>
        		</td>
   </tr>
 	<%if(tsysarr.length > 0){ %>
		<tr>
								<td>
								<table border="0" cellpadding="0" cellspacing="0">
									<tr>
										<td><a href="javascript:selectAllSysTemp()"
											class="SMALLLINK">select all</a></td>
										<td width="10">&nbsp;</td>
										<td><a href="javascript:clearAllSysTemp()" class="SMALLLINK">clear
										all</a></td>
									</tr>
								</table>
								</td>
							</tr>
							<%} %>
		
</table>      
				
