<%@ page language="java"%>

<%@ page import="java.util.*"%>
<%@page import="xpolog.eye.admin.wizards.common.WizardManager"%>
<%@page import="xpolog.eye.admin.wizards.common.WizardInfo"%>
<%@page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@page import="xpolog.eye.security.WebSecurityManager"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.SiteManagment"%>
<%@page import="xpolog.config.image.ConfigurationImageBuilder"%>
<%@page import="xpolog.eye.security.UserSecurity"%>
<%!
	static final String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";
%>
     
<%
	WebSecurityManager securityManager = WebSecurityManager.getInstance();
	if (!securityManager.checkForPermission(request,response,null,true)){
		return;
	}
	UserContext userContext = UserEnvironment.getUserContext(request);
	SiteManagment mgmt = SiteManagment.getInstance();
	UserSecurity user = securityManager.getUserSecurity(request);
	ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute(CONF_IMG_BUILDER);

	WizardManager wmg = mgmt.getWizardManager(xpolog.eye.site.SiteUtil.getBaseDirectory(request));
	WizardInfo[] wsysarr = wmg.getAllSystemWizards(userContext);
	WizardInfo[] wusrarr =  wmg.getAllUserWizards(userContext);
	HashSet selectedWizards = new HashSet();

	
	HashMap wizards = builder.getWizardsToExp();
	if (wizards != null){
		Iterator it = wizards.keySet().iterator();
		while (it.hasNext()){
			String wiz = (String)it.next();
			selectedWizards.add(wiz);
		}
	}

%>

<script>

  function selectAllUserWiz(){
  	for (var i=0; i<<%=wusrarr.length%>; i++){
  		document.access.checkUserWizards<%=wusrarr.length > 1 ? "[i]" : ""%>.checked = true;
  	}
  }
  
  function clearAllUserWiz(){
  	for (var i=0; i<<%=wusrarr.length%>; i++){
  		document.access.checkUserWizards<%=wusrarr.length > 1 ? "[i]" : ""%>.checked = false;
  	}
  }
  function selectAllSysWiz(){
  	for (var i=0; i<<%=wsysarr.length%>; i++){
  		document.access.checkSysWizards<%=wsysarr.length > 1 ? "[i]" : ""%>.checked = true;
  	}
  }
  
  function clearAllSysWiz(){
  	for (var i=0; i<<%=wsysarr.length%>; i++){
  		document.access.checkSysWizards<%=wsysarr.length > 1 ? "[i]" : ""%>.checked = false;
  	}
  }
</script>

<table width="100%" border="0"> 
	<tr>
	<td>&nbsp;</td>
	</tr>
  <tr>
     	<td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="15%" height="28" colspan="3"><span class="HEADER">XpoLog Wizards</span></td>
              </tr>
                     <tr>
                <td width="100%" height="18"><span class="SMALLTEXT">Please check the wizards you want to save in this configuration image.</span></td>
              </tr>
       
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <%for(int i=0;i<wusrarr.length;++i) {
              	  String checked = "";
            	  WizardInfo wi = wusrarr[i];
              	  String desc = wi.getDescription() != null && wi.getDescription().length() > 0 ? "(" + wi.getDescription() + ")" : "";
              	  if(selectedWizards.contains(wi.getID())) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }	
              %>
							<tr>
								<td colspan="3"><input type="checkbox" id="<%=wi.getID()%>" name="checkUserWizards" value="<%=wi.getID()%>"  <%=checked%>><span class="REGULARTEXT"><%=wi.getName()%> - <span class="SMALLTEXT"><%=desc%></span></span></td>
							</tr> 
              <%}%>
              <tr>
	<td>&nbsp;</td>
	</tr>  
	<%if (wusrarr.length > 0){ %>
		<tr>
								<td>
								<table border="0" cellpadding="0" cellspacing="0">
									<tr>
										<td><a href="javascript:selectAllUserWiz()"
											class="SMALLLINK">select all</a></td>
										<td width="10">&nbsp;</td>
										<td><a href="javascript:clearAllUserWiz()" class="SMALLLINK">clear
										all</a></td>
									</tr>
								</table>
								</td>
							</tr>
							          <tr>
	<td>&nbsp;</td>
	</tr>  
	<%}%>
              <%for(int i=0;i<wsysarr.length;++i) {
              	  String checked = "";
       			  WizardInfo wi = wsysarr[i];
              	  String desc = wi.getDescription() != null && wi.getDescription().length() > 0 ? "(" + wi.getDescription() + ")" : "";
              	  if(selectedWizards.contains(wi.getID())) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }
              %>
							<tr>
								<td colspan="3"><input type="checkbox" id="<%=wi.getID()%>" name="checkSysWizards" value="<%=wi.getID()%>"  <%=checked%>><span class="REGULARTEXT"><%=wi.getName()%> - <span class="SMALLTEXT"><%=desc%></span></span></td>
							</tr> 
              <%}%>
          	</table>
        		</td>
   </tr>
 	<tr>
	<td>&nbsp;</td>
	</tr>  
	<%if(wsysarr.length > 0){ %>
		<tr>
								<td>
								<table border="0" cellpadding="0" cellspacing="0">
									<tr>
										<td><a href="javascript:selectAllSysWiz()"
											class="SMALLLINK">select all</a></td>
										<td width="10">&nbsp;</td>
										<td><a href="javascript:clearAllSysWiz()" class="SMALLLINK">clear
										all</a></td>
									</tr>
								</table>
								</td>
							</tr>
		<%} %>
</table>      
				
