<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.image.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<% 
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.ConfigurationPermissions.CONF_IMAGE_PERMISSION,true)){
    return;
  }
  String ERROR_OBJ = "ERROR_OBJ";
  String CONF_IMAGE_ID = "CONF_IMAGE_ID";
  String PUBLISHER_ID = "PUBLISHER_ID";
  
  
  SiteManagment mgmt = SiteManagment.getInstance();
  //ask the list of conf from conf mgr
  String id = request.getParameter(CONF_IMAGE_ID);
  
  ConfigurationImageManager confMgr = ConfigurationImageManager.getInstance();
  ConfigurationImage confImg = null;
  boolean inEdit = false;
  
  if (id != null && id.length() > 0){
  	confImg = confMgr.getConfigurationImageById(id);
  	if (confImg != null){
  	  confImg = confImg.copy();
  	}
  }else {
	  confImg = (ConfigurationImage)request.getSession().getAttribute("CONF_IMG");
	  inEdit = true;	  	  
	}
	
	ErrorModel errmodel = new ErrorModel(); 
	if(confImg == null){
    	errmodel.addError("No Configuration Image was saved on session.");
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
  	}
  boolean isNew = confImg.getId() == null || confImg.getId().length() == 0;
  ConfigurationPublisher [] publishers = confImg.getAllConfigurationPublishers();
  request.getSession().setAttribute("CONF_IMG", confImg);
  
	String redirectUrl = request.getParameter("redirectURL");
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script>
  function exportConfImage(){
  	pubId = document.access.publisher.value;
  	path = "exportConfImage.jsp?ID=<%=id%>&PUBLISHER_ID="+pubId;
  	<%if (redirectUrl != null && redirectUrl.length() > 0){%>
  	path = path + "&redirectURL=<%=redirectUrl%>";
  	<%}%>
  	document.location = path;
  }
</script>
</head>

<body >

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<input type="hidden" name="publish">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="98%" class="TOPBORDER">
                <span class="PAGEHEADER">Export configuration image</span></td>
                <td width="1%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" id="AutoNumber3" height="53">
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" id="AutoNumber6">
		                  <tr>
		                    <td><span class="REGULARTEXT"><a href="javascript:goNext()" class="LINK">Export configuration image for publisher &nbsp;</a></span></td>
	                    	<td>
	                    	<select name="publisher">
	                     <%
	                     for(int i=0;i<publishers.length;i++){
	                       ConfigurationPublisher publisher = publishers[i];
	                     %>
	                     	 <option value="<%=publisher.getId()%>"><%=publisher.getName()%></option>
	                     <%
	                     }
	                     %>
	                     	</select>
	                     	</td>
	                   	</tr>
                    </table>
                   </td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="100">&nbsp;</td>
                    <td width="400" align="center"><nobr>
				            &nbsp;&nbsp;<a href="javascript:exportConfImage()" class="LINK">export</a>
								  	<%if (redirectUrl != null && redirectUrl.length() > 0){%>
                    &nbsp;&nbsp;<a href="<%=BASE_DIRECTORY%>logic/tools/confImage/logicConfImageView.jsp" class="LINK">cancel</a>
                    <%}else{%>
                    &nbsp;&nbsp;<a href="confImageView.jsp" class="LINK">cancel</a>
                    <%}%>
                    </nobr></td>
                    <td width="*">&nbsp;</td>
                  </tr>
                </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>