<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.mail.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.*"%>

<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  //constants
  String TEXT = "TEXT";
  String CURRENT_LOG = "CURRENT_LOG";
  String SUBJECT = "SUBJECT";
  String ERROR_OBJ = "ERROR_OBJ";

	 UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
   boolean mailEnabled = true;
   Configuration conf = Configuration.getInstance();
   MailConfig mail = conf.getMailConfigurationManager();
   String smtp = mail.getSmtpHost();
   if(smtp.equals("my.domain.com")){ 
    mailEnabled = false;
   }
   if(!mailEnabled){
    ErrorModel errmod = new ErrorModel();
    errmod.addError("You must set the mail configuration in the <a href=\"" + BASE_DIRECTORY + "settings/mailset.jsp\">settings</a> screen");
    request.getSession().setAttribute(ERROR_OBJ,errmod);
    response.sendRedirect("errorpage.jsp");
    return;
   }
   
    MailAccountFilter filter = new MailAccountFilter();
    AddressBook adbook = AddressBook.getInstance();
    List list = adbook.getAccountsByFilter(filter);
	if(list.size() == 0) {
	  //No accounts defined in system
	  ErrorModel errmodel = new ErrorModel();
	  errmodel.addError("There is no eMail account defined, Please <a href=\"" + "../../tools/addresses/mail/accountMail.jsp\">create eMail account</a> first.");
	  request.getSession().setAttribute(ERROR_OBJ,errmodel);
	  response.sendRedirect("../errorpage.jsp");
	  return;
	}
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
      function doNext(){
        document.access.action = "exportLogMailAction.jsp";
    	document.access.submit();
      }
      
      function goNew(){
		path = "<%=BASE_DIRECTORY%>tools/addresses/accoutAction.jsp?ACCOUNT_TYPE=email";
  		document.location = path;
  	  }
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" style="margin:0;padding:0">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="33%" class="TOPBORDER">
                <span class="PAGEHEADER">email log</span> </td>
                <td width="44%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%" >&nbsp;</td>
                <td colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Mail message</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">From</span></td>
                        <td width="69%">
                        
                        <select class="TEXTBOX" size="1" name="fromId">
                        <option value="">--- Select email account ---</option>
                        <%
                        	for(int i=0;i<list.size();++i){
                        		Account acc = (Account)list.get(i);
                        %>
                               <option value="<%=acc.getId()%>"><%=acc.getAccountName()%></option>
                        <%
                        	}
                        %></select>
                        <%
                        if (user == null || user.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){
                        %>
                        <span class="SMALLTEXT"><a href="javascript:goNew()" class="LINK">new</a></span>
                        <%}%>
                        </td>
                      </tr>
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">To</span></td>
                        <td width="69%">
                        
                        <select class="TEXTBOX" size="1" name="toId">
                        <option value="">--- Select email account ---</option>
                        <%
                        	for(int i=0;i<list.size();++i){
                        		Account acc = (Account)list.get(i);
                        %>
                        <option value="<%=acc.getId()%>"><%=acc.getAccountName()%></option>
                        <%
                        	}
                        %>
                        </select>
                        <%
                        if (user == null || user.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){
                        %>
                        <span class="SMALLTEXT"><a href="javascript:goNew()" class="LINK">new</a></span>
                        <%}%>
                        </td>
                      </tr>
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">Subject&nbsp;</span></td>
                        <td width="69%">
                        <input class="TEXTBOX" type="text" name="Subject" size="50" value=""></td>
                      </tr>
                      <tr>
                        <td width="11%">&nbsp;</td>
                        <td width="69%">
                        &nbsp;</td>
                      </tr>
                      <tr>
                        <td width="11%" valign="top"><span class="REGULARTEXT">Text</span></td>
                        <td width="69%">
                        <textarea class="TEXTBOX" rows="7" name="Text" cols="60"></textarea></td>
                      </tr>
                      <tr>
                        <td width="11%">&nbsp;</td>
                        <td width="69%">
                        &nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">XpoLog will send the message with the zipped
                    log attached to it.</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="21">
                    &nbsp;</td>
                  </tr>
                  <!--
                  <tr>
                    <td><b><i>Log context pattern</i></b></td>
                  </tr>-->
                  <tr>
                    <td><font size="2">&nbsp;&nbsp;</font></td>
                  </tr>
                  <tr>
                    <td>
                    <font size="2">&nbsp; </font>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    &nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="101%" id="AutoNumber17">
                      <tr>
                        <td width="25%">&nbsp;</td>
                        <td width="13%">
                        <p align="center">&nbsp;</td>
                        <td width="11%"><a href="javascript:history.go(-1)" class="LINK">previous</a></td>
                        <td width="11%"><a href="javascript:doNext()" class="LINK">next</a></td>
                        <td width="35%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>