<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.merge.MergedLogBrowserManager"%>
<%@ page import="xpolog.eye.remote.ProxyLogBrowser"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  String CURRENT_LOG = "CURRENT_LOG";
  String params = "";

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  //verify data
  ErrorModel errmodel = new ErrorModel();
  
  

  LogBrowsingManager lbm = null;
   String id = request.getParameter("LOG_ID");
  try{
	  if((id != null) && !(id.trim().equals(""))){
	    lbm = SiteManagment.getInstance().getLogBrowserManager(id,true);
	    params = "?LOG_ID=" + id;
	  }else{
	    lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
	  } 
  }catch(Exception e){	  	
	    errmodel.addError("XpoLog Failed to load log due to the following error:");
	    errmodel.addError(e.getMessage());
      request.getSession().setAttribute(ERROR_OBJ,errmodel);
      response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
      return;
  }

  String type = lbm == null ? "" : lbm.getType();
  if(lbm == null || lbm.getId()==null){
    errmodel.addError("You must select a log first.");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }else if(type.equals(OnlineDBSimpleLogBuilder.ONLINE_DB_LOG_TYPE) || type.equals(OnlineDBSimpleLogBuilder.ONLINE_DB_CACHE_LOG_TYPE) || lbm instanceof MergedLogBrowserManager || lbm instanceof ProxyLogBrowser  || lbm.isTemporary()){    
     if (params.length() == 0){
       params += "?";
     }else {
       params += "&";
     }
	   params += "type=ignoreFile";
  }

  response.sendRedirect("exportLog.jsp" + params);
%>


