<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%

  String logid = request.getParameter("LOG_ID");
  if (logid == null){
    logid = "";
  }
  
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  boolean hasAddressPerm = WebSecurityManager.getInstance().isHavePermission(user,ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION);
  
  AddressBook addBook = AddressBook.getInstance();
  
  boolean ignoreFile = false;
  String type = request.getParameter("type");
  if((type != null) && (type.equals("ignoreFile"))){
    ignoreFile = true;
  }
  String snapshotId = request.getParameter("SNAPSHOT_ID");
  if(snapshotId == null){
  	snapshotId = "";
  }
  
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>

	function goNext(type){
		isPlain = false;
		if(document.access.R2){
			isPlain = document.access.R2.checked;
		}
		transformer = document.access.DataType.options[document.access.DataType.selectedIndex].value;
		if(isPlain){
			transformer = "plain";
		}
		path = "exportLogAction.jsp?TYPE_EXP=" + type;
		path = path + "&TRANSFORMER_TYPE=" + transformer;
		path = path + "&LOG_ID=<%=logid%>";
		path = path + "&SNAPSHOT_ID=<%=snapshotId%>";
		document.location = path;

	}
	
	function isSQL() {
	<%if (hasAddressPerm || addBook.getAccountsByFilter(new xpolog.eye.media.db.DBAccountFilter()).size() > 0){%>
		if (document.access.DataType.options[document.access.DataType.selectedIndex].value == "SQL") {
			document.getElementById("execute").style.visibility = "visible";
		}
		else 
			document.getElementById("execute").style.visibility = "hidden";
			
	  <%}%>
	}

</script>

</head>
<body onload="javascript:isSQL()">
<form AUTOCOMPLETE="OFF" id="access" name="access" style="margin:0;padding:0">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
              <tr>
                <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="53%" class="TOPBORDER" height="0">
                <span class="PAGEHEADER">Export Log</span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;</td>
                <td width="43%" height="100%">&nbsp;</td>
                <td width="50%" height="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53" style="visibility:visible">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Transformation</span></td>
                  </tr>
                  <tr>
                    <td>
                    &nbsp;
                    </td>
                  </tr>
                  <tr>
                    <td>
                      <p>
                      <%
                        String check = "";
                        if(!ignoreFile){
                          check = "checked";
                      %>
                      <input type="radio" value="plain" id="R2" name="R1" checked> <span class="REGULARTEXT">Export the log together with its configuration, to enable future import</span><br>
                      <%
                        }
                      %>
                      <input type="radio" value="proc" id="R3" <%=check%> name="R1">
                      <span class="REGULARTEXT">Only transform the current data to the following type</span>
                      <select size="1" name="DataType" onclick="document.access.R3.checked=true" onchange="javascript:isSQL()">
                        <option class="TEXTBOX" value="XML">XML</option>
                        <option class="TEXTBOX" value="CSV">CSV</option>
                        <option class="TEXTBOX" value="TAB">TAB Delimited</option>
                        <option class="TEXTBOX" value="SIMPLE">Raw data</option>
                        <option class="TEXTBOX" value="SQL">SQL Database Table</option>
                      </select></font></p>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    &nbsp;
                    </td>
                  </tr>
                  <tr>
                    <td>
                    <span class="HEADER">Select exporting method</span>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    &nbsp;
                    </td>
                  </tr>
                  <tr>
                    <td width="15%">
                    <a href="javascript:goNext('download')" class="LINK">Get current log as Zip</a></td>
                  </tr>
                  <%if (hasAddressPerm || addBook.getAccountsByFilter(new xpolog.eye.media.mail.MailAccountFilter()).size() > 0){%>
                  <tr>
                    <td>
                    <a href="javascript:goNext('email')" class="LINK">Zip and send current log by email</a></td>
                  </tr>
                  <%}%>
                  <%if (hasAddressPerm || addBook.getAccountsByFilter(new xpolog.eye.media.ftp.FTPAccountFilter()).size() > 0){%>
                  <tr>
                    <td height="100%">
                    <a href="javascript:goNext('ftp')" class="LINK">
                    Zip and send current log to ftp site</a></td>
                  </tr>
                  <%}%>
<!--
                  <tr>
                    <td height="100%">
                    <a href="javascript:goNext('upload')" class="LINK">
                    Zip and upload current log to a web site</a></td>
                  </tr>
-->
									<%if (hasAddressPerm || addBook.getAccountsByFilter(new xpolog.eye.media.fs.FSAccountFilter()).size() > 0){%>
                  <tr>
                    <td height="100%">
                    <a href="javascript:goNext('filesys')" class="LINK">
                    Zip and copy current log to a local file system address</a></td>
                  </tr>
                  <%}%>
                  <%if (hasAddressPerm || addBook.getAccountsByFilter(new xpolog.eye.media.telsh.TelnetAccountFilter()).size() > 0){%>
                  <tr>
                    <td height="100%">
                    <a href="javascript:goNext('telnetssh')" class="LINK">
                    Zip and copy current log over SSH to a remote machine</a></td>
                  </tr>
                  <%}%>
                  <%if (hasAddressPerm || addBook.getAccountsByFilter(new xpolog.eye.media.db.DBAccountFilter()).size() > 0){%>
                  <tr>
                    <td width="15%">
                    <a href="javascript:goNext('execute')" id="execute" class="LINK" style="visibility:hidden">Insert log to database table</a></td>
                  </tr>
                  <%}%>
                  <tr>
                    <td height="100%">
                    </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="33%"></td>
            <td width="33%" align="center"><a href="javascript:history.go(-1)" class="LINK">cancel</a></td>
            <td width="34%"></td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>