<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.media.mail.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  String FROM = "FROM";
  String ALL = "ALL";
  String TO = "TO";
  String TEXT = "TEXT";
  String CURRENT_LOG = "CURRENT_LOG";
  String SUBJECT = "SUBJECT";

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  String from    = request.getParameter(FROM);
  String to    = request.getParameter(TO);
  String subject     = request.getParameter(SUBJECT);
  String text = request.getParameter(TEXT);

  //verify data
  ErrorModel errmodel = new ErrorModel();

  LogBrowsingManager lbm = null;
  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);

  if(lbm == null){
    errmodel.addError("You must select a log fist.");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  //error handling
  if(from == null || from.trim().equals("")){
    errmodel.addError("From email was not supplied.");
  }
  if(to == null || to.trim().equals("")){
    errmodel.addError("To email(s) were not supplied.");
  }
  if(subject == null || subject.trim().equals("")){
    errmodel.addError("Subject was not supplied");
  }
  if(errmodel.getErrorCount() > 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  String EXPORT_FLOW = "EXPORT_FLOW";
  ExportFlow flow = (ExportFlow)request.getSession().getAttribute(EXPORT_FLOW);
  File zipFile = flow.execute();
  try{
    //setting the log
    flow.setLogBrowsingManager(lbm);
    zipFile = flow.execute();
    Vector v = new Vector();
    v.add(zipFile);
    MailAccount mafrom = new MailAccount();
    mafrom.setMailAddress(from);
    MailAccount mato = new MailAccount();
    mato.setMailAddress(to);
    MediaManager medm = MediaManager.newInstace();
    PostOffice post = medm.getPostOffice();
    PostOffice.sendWithAttachments(mafrom,mato,subject,text,v);
  }catch(Exception e){
    errmodel.addError("The following error occured while sending the log:");
    //errmodel.addError(e.getMessage());
    String err = XpologUtil.getErrorMessage(e);  
    errmodel.addError(err);
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  //succes page with log view link
  response.sendRedirect("exportMailStatus.jsp");
%>


