<%@ page language="java"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.fs.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	String ERROR_OBJ = "ERROR_OBJ";
	
	FSAccountFilter filter = new FSAccountFilter();
    AddressBook adbook = AddressBook.getInstance();
    List list = adbook.getAccountsByFilter(filter);
    if(list.size() == 0) {
	  //No accounts defined in system
	  ErrorModel errmodel = new ErrorModel();
	  errmodel.addError("There is no File System account defined, Please <a href=\"" + "../../tools/addresses/fs/accountFs.jsp\">create File System account</a> first.");
	  request.getSession().setAttribute(ERROR_OBJ,errmodel);
	  response.sendRedirect("../errorpage.jsp");
	  return;
	}
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>

      function doNext(){
        document.access.action = "exportLogFSAction.jsp";
    	document.access.submit();
      }
      
      function goNew(){
		path = "<%=BASE_DIRECTORY%>tools/addresses/accoutAction.jsp?ACCOUNT_TYPE=fs";
  		document.location = path;
  	  }

</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" style="margin:0;padding:0">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="33%" class="TOPBORDER">
                <span class="PAGEHEADER">Export to File System&nbsp;</span></td>
                <td width="44%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%" >&nbsp;</td>
                <td colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="252">
                  <tr>
                    <td width="15%" height="27"><span class="HEADER">File System Location</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="22"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="54">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      <tr>
                        <td width="11%" valign="top"><span class="REGULARTEXT">Directory</span></td>
                        <td width="69%">
                        <select class="TEXTBOX" size="1" name="FSDirectory">
                        <option value="">--- Select fs account ---</option>
                        <%
                        	for(int i=0;i<list.size();++i){
                        		Account acc = (Account)list.get(i);
                        %>
                               <option value="<%=acc.getId()%>"><%=acc.getAccountName()%></option>
                        <%
                        	}
                        %></select> <a href="javascript:goNew()" class="LINK">new</a>
                        <span class="SMALLTEXT">(File system address)</span></td>
                      </tr>
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">Overwrite</span></td>
                        <td width="69%">
                        <input type="checkbox" name="FSOverWrite" checked>
                        &nbsp;<span class="SMALLTEXT">(When unchecked XpoLog will create
                        a new unique file name)</span></td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td height="22"><span class="SMALLTEXT">XpoLog will zip the log and copy it to
                      the File system location.</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="27">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td height="22"><font size="2">&nbsp;&nbsp;</font></td>
                  </tr>
                  <tr>
                    <td height="22">
                    <font size="2">&nbsp; </font>
                    </td>
                  </tr>
                  <tr>
                    <td height="27">
                    &nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td height="29">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="101%" id="AutoNumber17">
                      <tr>
                        <td width="25%">&nbsp;</td>
                        <td width="13%">
                        <p align="center">&nbsp;</td>
                        <td width="11%"><a href="javascript:history.go(-1)" class="LINK">previous</a></td>
                        <td width="11%"><a href="javascript:doNext()" class="LINK">next</a></td>
                        <td width="35%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>