<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.util.*"%> 

<%!static final String BASE_DIRECTORY = "../../";%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	final UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	
	//constants
	String EXPORT_FLOW = "EXPORT_FLOW";
	final ExportFlow flow = (ExportFlow)request.getSession().getAttribute(EXPORT_FLOW);
  env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, flow);

	//audit
	String Name = "";
	LogBrowsingManager lbm = flow.getLogBrowsingManager();
	if (lbm != null) {
		Name = lbm.getName();
	}
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
			userContext, AuditConstants.CHANGE, "export log as zip file",
			AuditConstants.CONFIGURATION, "export log as zip file " + Name);
	
	ProgressRunner runner = new ProgressRunner() {
    public void run(HttpServletRequest request){
      try{
      	Thread.sleep(500);
      	final File zipFile = flow.execute();
      	final String zipFilePath = zipFile.getName();
      	setRedirectUrl("getLogZipStatus.jsp?zipFilePath=" + BASE_DIRECTORY + "temp/" + zipFilePath);
      }catch(Exception e){
      	String err = XpologUtil.getErrorMessage(e);
    		errmodel.addError("The following error occured while archiving:");
    		errmodel.addError(err);
        createErrorRedirect(request,BASE_DIRECTORY);
    }
	 }
 };
 env.setProgressRunner(runner);
%>

<jsp:include page="../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Processing"/>
 <jsp:param name="useStatus" value="true" />
</jsp:include>