<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="omega.ui.models.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
  public String createBodyWithText(OTableModel _model,RecordMask mask){

    String sep = "%0d";
    String gap = "%20";

    String gapStr = " ";
    String linesepw = System.getProperty("line.separator");

    StringBuffer body = new StringBuffer();
    Object[] arr = null;
    String str = "";
    for(int i=0;i<_model.getRowCount();++i){
      arr = _model.getRowColumns(i);
      for(int t=0;t<arr.length;++t){
        str = mask.getMaskColumn(t).format(arr[t]).toString();
        body.append(str);
        body.append(gapStr);
      }
      body.append(linesepw);
    }
    String message = "This mail was created by XpoLog.";
    body.append(message);
    return body.toString();
  }
%>
<%
  String ERROR_OBJ = "ERROR_OBJ";
  String CURRENT_LOG = "CURRENT_LOG";
  //constants
  String FROM = "FROM";
  String TO = "TO";
  String TEXT = "TEXT";
  String SUBJECT = "SUBJECT";
  String LAST_TEXT_MAIL = "LAST_TEXT_MAIL";
  String FREE_TEXT = "FREE_TEXT";

   boolean mailEnabled = true;
   Configuration conf = Configuration.getInstance();
   MailConfig mail = conf.getMailConfigurationManager();
   String smtp = mail.getSmtpHost();
   if(smtp.equals("my.domain.com")){
    mailEnabled = false;
   }
   if(!mailEnabled){
    ErrorModel errmod = new ErrorModel();
    errmod.addError("You must set the mail configuration in the <a href=\"" + BASE_DIRECTORY + "settings/mailset.jsp\">settings</a> screen");
    request.getSession().setAttribute(ERROR_OBJ,errmod);
    response.sendRedirect("errorpage.jsp");
    return;
   }

  LogBrowsingManager lbm = null;
  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);

  ErrorModel errmodel = new ErrorModel();
  if(lbm == null || lbm.getId()==null){
   errmodel.addError("You must select a log first.");
   request.getSession().setAttribute(ERROR_OBJ,errmodel);
   response.sendRedirect("errorpage.jsp");
   return;
  }
  String mailto = "mailto:";
  OTableModel model =  lbm.getCurrentEntries(lbm.getDefaultLeap());
  String subjectTxt = "XpoLog mail - " + lbm.getName();
  String gap = "%20";
  String gapStr = " ";
  String subject = "subject="+subjectTxt.replaceAll(gapStr,gap);
  String body = "body=Please paste the content here.Thank you, XpoLog";
  body = body.replaceAll(gapStr,gap);
  mailto = mailto + "?" + subject + "&" + body;
  String value = createBodyWithText(model,lbm.getRecordMask());
  request.getSession().setAttribute(LAST_TEXT_MAIL,value);
%>

<%@page import="xpolog.eye.data.RecordMask"%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>

        function openMailClient(){
          window.open("<%=mailto%>");
        }

	function doNext(){
          var path ="sendLogTextAction.jsp?";
          path = path + "FROM=" + document.access.From.value;
    	  path = path + "&TO=" + document.access.To.value;
    	  path = path + "&SUBJECT=" + document.access.Subject.value;
    	  path = path + "&FREE_TEXT=" + document.access.FreeText.value;
    	  document.location = path;
	}

</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="9" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="" class="TOPBORDER">
                <span class="PAGEHEADER">email current text</span> </td>
                <td width="8" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="8">&nbsp;</td>
                <td >&nbsp;</td>
                <td width="7">&nbsp;</td>
              </tr>
              <tr>
                <td width="8" >&nbsp;</td>
                <td colspan="2" >
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" id="AutoNumber3">
                  <tr>
                    <td height="18"><span class="REGULARTEXT">Note: if you
                    want to use your default mail client
                    <a href="javascript:openMailClient()" class="LINK">click here</a> and
                    copy/paste the text into it. XpoLog can not do this for you
                    due to browser constraints. Sorry.</span></td>
                  </tr>
                  <tr>
                    <td  height="18"></td>
                  </tr>
                  <tr>
                    <td  height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">From</span></td>
                        <td width="89%">
                        <input class="TEXTBOX" type="text" name="From" size="50" value=""><span class="SMALLTEXT">(sender
                        email)</span></td>
                      </tr>
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">To</font></td>
                        <td width="89%">
                        <input class="TEXTBOX"type="text" name="To" size="50" value=""><span class="SMALLTEXT">(recipient
                        (s) email)</span></td>
                      </tr>
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">Subject&nbsp;</span></td>
                        <td width="89%">
                        <input class="TEXTBOX" type="text" name="Subject" size="50" value="<%=subjectTxt%>"></td>
                      </tr>
                      <tr>
                        <td width="11%">&nbsp;</td>
                        <td width="89%">
                        &nbsp;</td>
                      </tr>
                      <tr>
                        <td width="11%" valign="top"><span class="REGULARTEXT">Text&nbsp;</span></td>
                        <td width="89%">
                        <textarea class="TEXTBOX" rows="4" name="FreeText" cols="60"></textarea></td>
                      </tr>
                      <tr>
                        <td width="11%" valign="top"><span class="REGULARTEXT">Log text&nbsp;</span></td>
                        <td width="89%">
                        <textarea class="TEXTBOX" rows="8" name="Text" cols="60"><%=value%></textarea></td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td >

                    <span class="SMALLTEXT">Only the text will be added to the
                    message. New text in the log field will be ignored.&nbsp;</span>

                    </td>
                  </tr>
                  <tr>
                    <td >
</td>
                  </tr>
                  <tr>
                    <td >
                    </td>
                  </tr>
                  <tr>
                    <td >
                    </td>
                  </tr>
                  <tr>
                    <td >
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber17">
                      <tr>
                        <td width="25%">&nbsp;</td>
                        <td width="10%"><a href="javascript:history.go(-1)" class="LINK">Cancel</a></td>
                        <td width="10%"><a href="javascript:doNext()" class="LINK">Send</a></td>
                        <td width="15%">&nbsp;</td>
                        <td width="35%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%" >
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>