<%@page import="xpolog.eye.computation.impl.FilterComputationDefUnit"%>
<%@page import="xpolog.eye.computation.conf.HealthConfig"%>
<%@page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.linear.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.data.xml.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.global.filters.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.log.files.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.util.regex.*"%>

<%@ include file="../../sandf/textFilterAction.jsp"%>
<%@ include file="../../sandf/prioFilterAction.jsp"%>
<%@ include file="../../sandf/dateFilterAction.jsp"%>
<%@ include file="../../sandf/choiceFilterAction.jsp"%>
<%@ include file="../../sandf/numberFilterAction.jsp"%>

 
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  UserContext userContext = UserEnvironment.getUserContext(request);

  String ERROR_OBJ = "ERROR_OBJ";
  String COL_INDEX = "COL_INDEX_";
  String CURRENT_LOG = "CURRENT_LOG";
  String COLOR_PARAM = "COLOR_PARAM_";

    SiteManagment mgmt = SiteManagment.getInstance();
    GlobalFilters gcm = GlobalFilters.getInstance();
  
    LogBrowsingManager lbm = null;
    RecordMask mask = null;
	String logname    = "";
    FilterManager fman = null;
    
    //check validty for name
  	String filterName = request.getParameter("filterName");

	if(filterName == null || filterName.trim().equals("")){
	  ErrorModel ermo = new ErrorModel();
	  ermo.addError("You must name the filter.");
	  request.getSession().setAttribute(ERROR_OBJ,ermo);
	  response.sendRedirect(BASE_DIRECTORY + "loggers/admin/errorpage.jsp");
	  return;
    }
    
   
	//description
	String customDesc = request.getParameter("filterDesc");
	//cusid for edit of exsiting set
	String  filterSetId = request.getParameter("filterSetId");
	//if new set then contain lbmId
	String lbmId= request.getParameter("logbrowser");

	if(filterSetId == null || filterSetId.length() == 0){
		if(lbmId != null && lbmId.length()>0){
			lbm = mgmt.getLogBrowserManager(lbmId);
			if(lbm != null){
				//do not use flm from log, since have more filters
				fman = new FilterManager();
 				mask = lbm.getRecordMask();
 			}
		}
	
	}else{
		FilterSet cs = gcm.getFilterSetById(filterSetId);
		fman = cs.filterMgr;
		mask = cs.recordMask;
	}
	
 
  
  FilterSet cusSet = new FilterSet();
  cusSet.name = filterName;
  cusSet.description = customDesc;
  cusSet.id = filterSetId;
  cusSet.filterMgr = fman;
  cusSet.recordMask = mask;
  cusSet.type = GlobalFilters.FILTER_TYPE; 
  if(fman == null){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("Failed to load FilterManager Set, please verify configuration data.");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }
  
  
  //constants

  String LOG_ID = "logid";
  String LOG_NAME = "LOG_NAME";
  String STRING_FILTER = "StringFilter";
  String PRIORITY_FILTER = "PriorityFilter";
  String DATE_FILTER = "DateFilter";
  String CHOICE_FILTER = "ChoiceFilter";
  String NUMBER_FILTER = "NumberFilter";

  String REMOVE_FILTER_ID = "REMOVE_FILTER_ID";
  String ACTIVATE_FILTER_ID = "ACTIVATE_FILTER_ID";
  String EDIT_FILTER_ID = "EDIT_FILTER_ID";
  String OP = "OP";
  String ADD = "ADD";
  
  String RUN_INDEXING = "RUN_INDEXING";
  String REMEMBER_ANSWER = "REMEMBER_ANSWER";

 

  //site management
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  

  FilterCollection fcman = null;
  String filterId = request.getParameter(EDIT_FILTER_ID);
    
  if(filterId == null || filterId.equals("")){
    fcman = new FilterCollection();
  }else{
    fcman = fman.getFilterCollectionById(filterId);
    if(fcman == null){
      fcman = new FilterCollection();
    }else{
      //clonneing because of the cache mechanism
      fcman = (FilterCollection)fcman.clone();
    }
  }


  fcman.setTransientFilter(false);
  fcman.setName(filterName);
  fcman.setDescription(customDesc);
  fcman.clearAllFromName(STRING_FILTER);
  fcman.clearAllFromName(PRIORITY_FILTER);
  fcman.clearAllFromName(DATE_FILTER);
  fcman.clearAllFromName(CHOICE_FILTER);
  fcman.clearAllFromName(NUMBER_FILTER);
  try{
    StringFilter[] strfilters = createStringFilters(request,response,mask);
    if((strfilters != null) && (strfilters.length > 0)){
      for(int i=0;i<strfilters.length;++i){
        fcman.addFilter(strfilters[i]);
      }
    }

    ChoiceFilter[] chfilters = createChoiceFilters(request,response,mask);
    if((chfilters != null) && (chfilters.length > 0)){
      for(int i=0;i<chfilters.length;++i){
        fcman.addFilter(chfilters[i]);
      }
    }

    PriorityFilter pfilter = createPriorityFilter(request,response,mask);
    if(pfilter != null){
        fcman.addFilter(pfilter);

    }
    DateFilter dfilter = createDateFilter(request,response,mask);
    if(dfilter != null){
        fcman.addFilter(dfilter);
    }
    NumberFilter[] numfilters = createNumberFilters(request,response,mask);
    if(numfilters != null && numfilters.length > 0){
      for(int i=0;i<numfilters.length;++i){
        fcman.addFilter(numfilters[i]);
      }
    }
    
    ComputationConfiguration computeConf = ComputationConfiguration.getInstance();
    HealthConfig[] healthConfigs = computeConf.getHealthConfigs();
    HashMap defUnitsMap = new HashMap();
    if (healthConfigs != null && healthConfigs.length > 0){
    	for(int i = 0 ; i < healthConfigs.length;i++){
    		String type = healthConfigs[i].getType();
    		String healthWeight = request.getParameter("healthWeight" + type);
      	double weight = -1;
      	if (healthWeight != null && healthWeight.length() > 0){
      		try {
      			weight = Double.parseDouble(healthWeight);
      		}catch (Exception e){}  	
      	}
      
    		FilterComputationDefUnit defUnit = null;
	    	if (weight >= 0){
  	  		defUnit = new FilterComputationDefUnit();
  	  	    defUnitsMap.put(type,defUnit);
    			defUnit.setType(type);
    			defUnit.setWeight(weight);
    			String healthAmountType = request.getParameter("healthAmountType" + type);
	    		int amountType = -1;
  	  		if (healthAmountType != null && healthAmountType.length() > 0){
    	  		try {
      				amountType = Integer.parseInt(healthAmountType);
      				defUnit.setAmountType(amountType);
	      		}catch (Exception e){}  	
	  	    }
  	  		String healthAmount = request.getParameter("healthAmount" + type);
    			int amount = -1;
    			if (healthAmount != null && healthAmount.length() > 0){
      			try {
      				amount = Integer.parseInt(healthAmount);
      				defUnit.setAmount(amount);
	      		}catch (Exception e){}  	
  	    	}    			    			
    	
    		}
    	}
    }
		fcman.setDefUnits(defUnitsMap);
    

  }catch(Exception e){
    ErrorModel ermo = new ErrorModel();
    ermo.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,ermo);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }

  
  
  fman.addFilterCollection(fcman);
  gcm.putFilterSet(cusSet);
  
	//	audit
  	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  		  			userContext, AuditConstants.CHANGE, "add/edit global filter", AuditConstants.CONFIGURATION, "add/edit global filter " + filterName);

  
  
  response.sendRedirect("globalFilters.jsp");
%>


