<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%

  String ARCHIVE_PATH = "ARCHIVE_PATH";
  String ERROR_OBJ = "ERROR_OBJ";
  String CURRENT_LOG = "CURRENT_LOG";
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  String arch_file  = request.getParameter(ARCHIVE_PATH);

  //verify data
  ErrorModel errmodel = new ErrorModel();
  if(arch_file == null || arch_file.trim().equals("")){
    errmodel.addError("No archive file was supplied.");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }

  //here we will use xpolog builder for import -
  LogBrowsingManager lbm = null;
  arch_file = arch_file.replaceAll("\\\\\\\\","/");
  arch_file = arch_file.replaceAll("\\\\","/");
  File arch = new File(arch_file);
  try{
   ImportFlow iml = new ImportFlow();
   arch = UploadHelper.uploadFile(request,arch);
   iml.setFile(arch);
   iml.executeImport();
   lbm = iml.getLog();
   request.getSession().setAttribute(CURRENT_LOG,lbm);
  }catch(Exception e){
    e.printStackTrace();
    ErrorModel errmod = new ErrorModel();
    errmod.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,errmod);
    response.sendRedirect("errorpage.jsp");
    return;
  }

  response.sendRedirect("importLogList.jsp");
%>


