<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.site.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
  String ERROR_OBJ = "ERROR_OBJ";
  String CURRENT_MODULE = "CURRENT_MODULE";
  String CURRENT_LOG = "CURRENT_LOG";

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  UserContext userContext = UserEnvironment.getUserContext(request);
  
  Module pmod = (Module)request.getSession().getAttribute(CURRENT_MODULE);;
  if (pmod == null || pmod.getId() == null || pmod.getId().length() == 0){
  	pmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
  }
  
  LogBrowsingManager lbm =(LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  String logName = "";
  if(lbm != null){
    logName = lbm.getName();
  }


  /*
  Log4jBuilder builder = (Log4jBuilder)request.getSession().getAttribute(LOG4J_BUILDER);
  if(builder == null){
    ErrorModel errmodel = new ErrorModel();
    errmodel.addError("No Log4J builders specified,please restart procedure.");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }

  if(builder.getLoggersCount() == 0){
    ErrorModel errmodel = new ErrorModel();
    errmodel.addError("No Log4J loggers found,please recheck the properties file.");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  List blist = builder.getBuildersList();
  */

  boolean allowNewFolder = true;
  if (userContext != null && !userContext.isHavePermission(ActionsPermissionConstants.AdministrationPermissions.ADD_MODULE_PERMISSION)){
  	allowNewFolder = false;
  }

%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<jsp:include page="../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<script>
    function doNext(){
    	if (updateParentModule){
    		updateParentModule(tree,"MODULE_ID");
    	}
      document.access.submit();
    }
    
</script>
<script src="../../scripts/UIUtil.js" type="text/javascript"></script>
</head>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" action="importLogListAction.jsp" method="post" style="margin:0;padding:0">
<input type="hidden" name="MODULE_ID">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
              <tr>
                <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="53%" class="TOPBORDER" height="0">
                <span class="PAGEHEADER">Import log</span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;</td>
                <td width="43%" height="100%">&nbsp;</td>
                <td width="50%" height="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Parent Folder Selection&nbsp;</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td>
                    <span class="REGULARTEXT">Import wizard found log <b><%=logName%>
                    </b> in the archive</span></td>
                  </tr>
                  <tr>
                    <td style="padding-top:5">
                    <span class="REGULARTEXT">Please select a parent folder for the log
                    and press next</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18" style="padding-top:5">
											<jsp:include page="../../common/selectParentModule.jsp" flush="true">
											<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
											<jsp:param name="PARENT_MODULE_ID" value="<%=pmod.getId()%>" />
											<jsp:param name="allowNewFolder" value="<%=allowNewFolder %>" />
											</jsp:include>
                    </td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td>
                    <font size="2">&nbsp;</font>
                    </td>
                  </tr>

                  <tr>
                    <td width="15%">

                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;&nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="30%">&nbsp;</td>
            <td width="31%" align="center">
              <table border="0" width="100%">
                <tr>
				  <td>&nbsp;</td>
                  <td width="150"><a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK">cancel</a></td>
                  <td width="150" ><a href="javascript:history.go(-1)" class="LINK">&nbsp;previous</a></td>
                  <td width="150"><a href="javascript:doNext()" class="LINK">&nbsp;next</a></td>
				  <td width="30%">&nbsp;</td>
                </tr>
              </table>
            </td>
            <td width="39%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>

</body>
</html>