<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
  UserContext userContext = UserEnvironment.getUserContext(request);

  String ERROR_OBJ = "ERROR_OBJ";
  String LOG4J_BUILDER = "LOG4J_BUILDER";
  String MODULE_ID = "MODULE_ID";
  String CURRENT_LOG = "CURRENT_LOG";

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  String modid = request.getParameter(MODULE_ID);
  if(modid == null || modid.trim().equals("")){
    ErrorModel errmodel = new ErrorModel();
    errmodel.addError("No parent folder was selected. If no folder is available please check your permissions");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }
  Module parent = mgmt.getModuleFromId(modid);
  LogBrowsingManager lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);

  if(lbm == null){
    ErrorModel err = new ErrorModel();
    err.addError("Cant find the Log, please check if it was deleted.");
    request.getSession().setAttribute(ERROR_OBJ,err);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  try{
	    String name = "";
	    if(lbm != null) {
	  	  name = lbm.getName();
	    }
	    //audit
	    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	     			userContext, AuditConstants.CHANGE, "import log to system", AuditConstants.LOGS, "import log to system " + name);	 	 	

    admin.addLogBrowser(lbm,parent);
    lbm = mgmt.getLogBrowserManager(lbm.getId());
    String lbmId = lbm.getId();
		if(lbmId != null && lbmId.length() > 0) {
	  	String[] lbmIds = new String[1];
	  	lbmIds[0] = lbmId;
	  	admin.generateLogData(lbmIds, userContext);
	  }

    request.getSession().setAttribute(CURRENT_LOG,lbm);
    response.sendRedirect("logaddopok.jsp");
  }catch(Exception e){
    ErrorModel err = new ErrorModel();
    err.addError("Error during importing log." );
    err.addError("Error Message - " + e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,err);
    response.sendRedirect("errorpage.jsp");
    return;
  }

%>


