<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%

  UserContext userContext = UserEnvironment.getUserContext(request);

  String ERROR_OBJ = "ERROR_OBJ";
  String IMPORT_FLOW = "IMPORT_FLOW";
  String PARENT_MODULE = "ParentModule";

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  String modid  = request.getParameter(PARENT_MODULE);

  Module parentModule =  null;
  
  ErrorModel errmodel = new ErrorModel();
  if(modid == null ||  modid.equals("")){
  	errmodel.addError("Please specify a parent folder.");
  }
  try{
  	parentModule = mgmt.getModuleFromId(modid);
  }catch(Exception e){
  	errmodel.addError("Failed to load parent folder. Please try again.");
  }
  
  if(errmodel.getErrorCount() > 0){
  	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("../errorpage.jsp");
    return;
  }
  
  try{
  String name = "";
  if(parentModule != null) {
	  name = parentModule.getName();
  }
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
   			userContext, AuditConstants.CHANGE, "import folder to system", AuditConstants.MODULES, "import folder to system " + name);	 	 	

   ImportFlow iml = (ImportFlow)request.getSession().getAttribute(IMPORT_FLOW);
   iml.executeImportModule(parentModule);
  }catch(Exception e){
  	e.printStackTrace();
    ErrorModel errmod = new ErrorModel();
    errmod.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,errmod);
    response.sendRedirect("../errorpage.jsp");
    return;
  }

  response.sendRedirect("modaddopok.jsp");
%>