<%@ page language="java" %> 
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="java.util.*"%>
<%@page import="xpolog.eye.issuetracking.ui.IssueTrackingUIElement"%>
<%@page import="xpolog.eye.issuetracking.ui.IssueTrackingUIElementOption"%>
<%@page import="xpolog.eye.issuetracking.*"%>
<%@page import="xpolog.eye.issuetracking.util.IssueTrackingClientActionRequest"%>
<%@page import="xpolog.eye.issuetracking.util.IssueTrackingClientActionResult"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);

	IssueTracking tracker = env.getIssueTracking();
	List list = (List) env.getTempAttribute("IssueTrackingElements");
	if (list == null){
		if (tracker != null){
			IssueTrackingClientActionRequest req = new IssueTrackingClientActionRequest();
			req.setActionType(IssueTrackingClient.ACTION_TYPE_REFRESH_VIEW);
			
			IssueTrackingClientActionResult result =  tracker.getClient().getActionElements(req);
			
			list = result.getActionElements();			
			if(list == null){
				list = new ArrayList();
			}
		}else {
			list = new ArrayList();
		}
	}
	
	DefaultIssueUpdateHandler handler = (DefaultIssueUpdateHandler)env.getGlobalAttribute("issueTrackingHandler");
	
%>



<%@page import="xpolog.eye.issuetracking.ui.DefaultIssueUpdateHandler"%>
<html> 
<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/logview.css" />
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>

<script>

function close(){
  if (parent && parent.closeGenralDiv){
    parent.closeGenralDiv();
  }
  return "";
}

function createIssue(){
  updateIssue("save");
}

var msgWriter;
function updateIssue(action){
  if (action == "save"){
    msgWriter = new messageWriter("addIssueMsg","Add a Bug","<%=BASE_DIRECTORY%>");		    	  	
    msgWriter.setPosition(-1,-1);
    msgWriter.showMessage("Creating bug...");
  }else {
    msgWriter = new messageWriter("addIssueMsg","Add a Bug","<%=BASE_DIRECTORY%>");		    	  	
    msgWriter.setPosition(-1,-1);
    msgWriter.showMessage("Loading information...");
  }
  
  document.getElementById("addIssueErrorMsgTD").innerHTML = "&nbsp;";
  var params = getFormElementsQueryString(document.access,"");
  params += "&action=" + action;  
   sendAjaxRequest("addIssueAction.jsp",function(req){
      if (msgWriter && msgWriter != null){
        closeMsgWriter();
      }
	    var xmldoc = req.responseXML.documentElement;            	
      var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
      var message = xmldoc.getElementsByTagName('message')[0].text;
      if (result == "true"){
          if (action == "save"){
            if (xmldoc.getElementsByTagName('message')[0].firstChild){
			        var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;			        			         
		  			  msgWriter = new messageWriter("addIssueMsg","Add a Bug","<%=BASE_DIRECTORY%>");
		  			  if (xmldoc.getElementsByTagName('params') && xmldoc.getElementsByTagName('params')[0].firstChild){
			          var gotoUrl = xmldoc.getElementsByTagName('params')[0].firstChild.nodeValue;
			          msgWriter.addAction("View Bug","javascript:viewBug('" + gotoUrl + "');javascript:close()");
			        }		
							msgWriter.addAction("Close","javascript:closeMsgWriter();javascript:close()");    	  										
  						msgWriter.setPosition(-1,-1);
  						msgWriter.showMessage(message);
  				  }else {		
              close();
            }
          }else {      		
      		  this.location = "addIssueInnerFrm.jsp";
      		}
			}	else if (xmldoc.getElementsByTagName('message')[0].firstChild){
			  var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
			  //document.getElementById("addIssueErrorMsgTD").innerHTML = message;
			  msgWriter = new messageWriter("addIssueMsg","Add a Bug","<%=BASE_DIRECTORY%>");		
				msgWriter.addAction("OK","javascript:closeMsgWriter()");    	  	
  			msgWriter.setPosition(-1,-1);
  			msgWriter.setMsgClass("ERRORMESSAGE_LIGHT");
  			msgWriter.showMessage(message);			                  
      }
	  },'POST',params);
}

function closeMsgWriter(){
	msgWriter = null;
	hideLayer("addIssueMsg");
}

function viewBug(page){
	window.open(page);
}
</script>
</head>
<body style="margin:0;padding:0">
<form AUTOCOMPLETE="OFF" name="access" style="margin:0;padding:0">
<table border="0" cellpadding="0" cellspacing="0" style="padding-top:0px;padding-left:00px;" width="100%" height="100%">
	<tr>		
		<td>
			<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="100%">
			   <%
			   for (int i = 0; i < list.size(); i++) {
						IssueTrackingUIElement uiElement = (IssueTrackingUIElement) list.get(i);						
					  String type = uiElement.getType();
					  if (type == null || type.length() == 0 || !uiElement.isVisible()){
					  	continue;
					  }
			   
			   %>
				<tr style="padding-top:0px;" align="left" height="30">
					<td width="10" valign="middle">
						<span class="SMALLTEXT"><%=uiElement.isRequired() ? "*" : "&nbsp;" %></span>
					</td>
					<td width="120px" valign="middle">
						<span class="SMALLTEXT"><%=uiElement.getName()%>:</span>
					</td>	
					<td style="padding-left:3px">
					<% 
					  
					  	if (type.equals(IssueTrackingUIElement.TYPE_TEXT)){
					%>
					      <input type="TEXTBOX" class="TEXTBOX" name="issue<%=uiElement.getKey()%>" id="issue<%=uiElement.getKey()%>"  size="60" value="<%=uiElement.getValue() == null ? "" : uiElement.getValue()%>">
					    <%} else if (type.equals(IssueTrackingUIElement.TYPE_TEXT_AREA)){%>
					     <textarea rows="4" cols="44" style="width:378px" name="issue<%=uiElement.getKey()%>" id="issue<%=uiElement.getKey()%>"><%=uiElement.getValue() == null ? "" : uiElement.getValue()%></textarea>
					    <%} else if (type.equals(IssueTrackingUIElement.TYPE_SELECT)){%>
					  		<select class="TEXTBOX" name="issue<%=uiElement.getKey()%>" id="issue<%=uiElement.getKey()%>" style="width:378px" <%=uiElement.isDoRefreshOnUpdate() ? "onChange=\"javascript:updateIssue('update')\"" : "" %>>
					  		<%
					  	  List options = uiElement.getIssueTrackingUIElementOptions();
							  if (options != null && options.size() > 0){
							  	String value = uiElement.getValue() == null ? "" : uiElement.getValue();
							  	for (int j = 0; j < options.size();j++){
							  		IssueTrackingUIElementOption option = (IssueTrackingUIElementOption)options.get(j);							  		
					  		%>
										<option value="<%=option.getId()%>" <%=value.equals(option.getId()) ? "selected" : ""%>><%=option.getText() %></option>					  		
					  		<%}} %>
					  		</select> 			  
					  	<%} %>
					</td>
					<td width="*">&nbsp;</td>
				</tr>
				<% 
				if (uiElement.getKey().equalsIgnoreCase("description") && handler != null && handler.isAtachmentsEnabled() && tracker != null && tracker.isSupportsAttachments()){%>
					<tr style="padding-top:0px;" align="left" height="15">	
					<td width="10" valign="middle">
						&nbsp;
					</td>
					<td width="120px" valign="middle">
						<span class="SMALLTEXT">&nbsp;</span>
					</td>
					<td style="padding-left:3px" >
					<table border="0" cellpadding="0" cellspacing="0" style="padding-top:0px;padding-left:0px;" width="100%" height="100%" >
					<tr>	
					<td width="10" >
					<input type="checkbox" name="doAttach" value="true" <%=handler.isAddDataAsAttachments() ? "checked" : ""%>>
					</td>
					<td style="padding-left:5px" >
					  <span class="MEDIUMTEXT"><%=handler.getAddDataAsAttachmentsMessage() %></span>
					 </td>
					 </tr>
					 </table>
					</td>
					</tr>	
					
					<%}
				if (uiElement.getKey().equalsIgnoreCase("description") && handler != null && handler.isDescriptionDataEnabled()){%>				
					<tr style="padding-top:0px;" align="left" height="15">	
					<td width="10" valign="middle">
						&nbsp;
					</td>
					<td width="120px" valign="middle">
						<span class="SMALLTEXT">&nbsp;</span>
					</td>
					<td style="padding-left:3px" >
					<table border="0" cellpadding="0" cellspacing="0" style="padding-top:0px;padding-left:0px;" width="100%" height="100%" >
					<tr>	
					<td width="10" >
					<input type="checkbox" name="includeDataInDesc" value="true" <%=handler.isAddDataToDescription() ? "checked" : ""%>>
					</td>
					<td style="padding-left:5px" >
					  <span class="MEDIUMTEXT"><%=handler.getAddDataToDescriptionMessage() %></span>
					 </td>
					 </tr>
					 </table>
					</td>
					</tr>	
										
				<%}
				
				%>
				<%}%>
				<tr><td>&nbsp;</td></tr>
			</table>			
		</td>
	</tr>
	<tr  style="display:;" id="addIssueErrorMsgTR" height="10">
			<td id="addIssueErrorMsgTD" style="padding-left:50px;padding-top:5px" class="ERROR_MSG">&nbsp;</td>
	</tr>		
	
	
	
	 <jsp:include page="../../common/adminGeneralFooterActions.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="../../" />
							<jsp:param name="suffix" value="addIssue" />
							<jsp:param name="actionsNames" value="Create#Cancel" />
							<jsp:param name="actions" value="javascript:createIssue()#javascript:close()"/>
						</jsp:include>
	
	
</table>	
</form>
</body>
</html>