<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.issuetracking.bugzilla.*"%>
<%@ page import="xpolog.eye.issuetracking.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION,true)){
    return;
  }

  String embededStr = request.getParameter("isEmbeded");
  boolean isEmbeded = embededStr != null && embededStr.equals("true");


	String id = request.getParameter("id");
	BugzillaIssueTrackingConfiguration conf = null;
	IssueTracking tracker = id == null || id.length() == 0 ? null : IssueTrackingManager.getInstance().getIssueTrackingById(id);
	if (tracker == null){
		tracker =  IssueTrackingManager.getInstance().getIssueTrackingTemplateById("bugzilla");
		request.getSession().removeAttribute("lastSelectedIssueTracking");
	}else {
		request.getSession().setAttribute("lastSelectedIssueTracking",id);
	}
	

	if (tracker != null){
		conf = (BugzillaIssueTrackingConfiguration)tracker.getConfig();
	}
	
	String bugzillaUrl = "";
	String user = "";
	String password = "";
	String name = "";
	String desc = "";
	
	if(conf != null){
		bugzillaUrl = conf.hasServerUrl() ? conf.getServerUrl() : "";
		user = conf.hasDefaultUsername() ? conf.getDefaultUsername() : "";
		password = conf.hasDefaultPassword() ? conf.getDefaultPassword() : "";
		name = tracker.getName();
		desc = tracker.getDesc();
	}
	

%>
<% if (!isEmbeded){ %>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>

<script>
	function doSave(){
  	var params = getFormElementsQueryString(document.access,"");
  	sendAjaxRequest("bugzillaSettingsAction.jsp",function(req){
	    var xmldoc = req.responseXML.documentElement;            	
      var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
      var message = xmldoc.getElementsByTagName('message')[0].text;      
      if (result == "true"){
      	document.location = "../issueTrackingView.jsp?refreshMenus=true";
			}else if (xmldoc.getElementsByTagName('message')[0].firstChild){
			  var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
			  var msg = "<ul>";
    		var errs = message.split("*;*");
    		for (var i=0; i<errs.length; i++){
    			msg = msg + "<li>" + errs[i] + "</li>";
    		}
    		msg = msg + "</ul>"
			  
			  msgWriter = new messageWriter("saveBugzillaMsg","Bug Tracking System Save Error","<%=BASE_DIRECTORY%>");		
				msgWriter.addAction("OK","javascript:closeMsgWriter()");    	  	
  			msgWriter.setPosition(-1,-1);
  			msgWriter.setMsgClass("ERRORMESSAGE_LIGHT");
  			msgWriter.setStyle("left");
  			msgWriter.showMessage(msg);			                  
      }
	  },'POST',params);
  }
  
  function closeMsgWriter(){
		msgWriter = null;
		hideLayer("saveBugzillaMsg");
	}
</script>


</head>

<body style="margin:0;padding:0">

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" style="margin:0;padding:0">
<%} %>
<input class="TEXTBOX" type="hidden" name="id" size="10" value="<%=id%>">
<input class="TEXTBOX" type="hidden" name="isEmbeded" size="10" value="<%=String.valueOf(isEmbeded)%>">

<table border="0" cellpadding="0" cellspacing="0"	style="border-collapse:collapse" width="100%" height="100%">
	<tr height="10">
		<td>
			<%
			String headerUrl = BASE_DIRECTORY + "common/pageHeader.jsp";
			%>
			<jsp:include page="<%=headerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="Bugzilla Settings" />
			</jsp:include>
		</td>
	</tr>
	<tr valign="top">
		<td>
			<table class="ADMIN_TABLE_DIV" width="100%">
				<tr>
					<td class="ADMIN_MAIN_TD">
						<table width="100%">
							<tr>
								<td style="padding-top:15">
									<table class="ADMIN_SECTION_DIV" cellpadding="0" cellspacing="0" width="100%">
										<tr>
											<td class="ADMIN_SECTION_MAIN_TD">
												<table border="0" cellpadding="0" cellspacing="0" width="100%">
		                      <tr height="25">
		                        <td width="100"><span class="REGULARTEXT">Name *</span></td>
		                        <td width="*">
		                        <input class="TEXTBOX" type="text" name="Name" size="50" value="<%=name%>"></td>
		                      </tr>
		                      <tr height="25">
		                        <td style="padding-top:0"><span class="REGULARTEXT">Description</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="Description" size="50" value="<%=desc%>"></td>
		                      </tr>
		                      <tr height="25">
		                        <td style="padding-top:0"><span class="REGULARTEXT">Bugzilla URL *</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="Url" size="50" value="<%=bugzillaUrl%>">
		                        </td>
		                      </tr>
		                      <tr height="25">
		                        <td style="padding-top:0"><span class="REGULARTEXT">&nbsp;</span></td>
		                        <td>
		                        <span class="SMALLTEXT">for example: http://BUGZILLA_HOST:8080/bugzilla</span>
		                        </td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:20" colspan="2">
		                        	<span class="SMALLTEXT">* marks a manadatory field</span>
		                        </td>
		                      </tr>		                      
		                    </table>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
<% if (!isEmbeded){ %>
	<tr height="10">
		<td>
			<%
			String footerUrl = BASE_DIRECTORY + "common/buttonsFooter.jsp";
			String cancelAction = "common/actions/cancelAction.jsp?forward=tools/issuetracking/issueTrackingView.jsp";
			
			String actions = "javascript:doSave()#" + cancelAction;
			%>
			<jsp:include page="<%=footerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="Save#Back to Bug Tracking Systems" />
				<jsp:param name="actions" value="<%=actions %>" />
			</jsp:include>
		</td>
	</tr>
</table>
</form>
<iframe id="resultFrame" name="resultFrame" style="display:none">
</body>
</html>
<%}%>