<%@page import="xpolog.eye.util.WebUtil"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%@page import="xpolog.eye.issuetracking.*"%>
<%@page import="xpolog.eye.issuetracking.bugzilla.*"%>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%> 
<%
	
	String ERROR_OBJ = "ERROR_OBJ";
	UserContext userContext = UserEnvironment.getUserContext(request);

	String Name,Description,Url,User,Pwd,id;
	String forwardURL = request.getParameter("forwardURL");
	
	String actionType = request.getParameter("ACTION_TYPE");
	if(actionType == null || actionType.length() == 0 ){
		actionType = "save";
	}
	String verifyMsg = "";
	String result = "";
	String isEmbededStr = request.getParameter("isEmbeded");
	boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");
	String verifyBeforeSaveStr = request.getParameter("verifyBeforeSave");
	boolean verifyBeforeSave = (verifyBeforeSaveStr != null && verifyBeforeSaveStr.equals("true")) || isEmbeded;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	Url = request.getParameter("Url");
	User = request.getParameter("User");
	Pwd = request.getParameter("Pwd");
	id = request.getParameter("id");
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
  	errmodel.addError("Name was not supplied");
  }else {
  	if(WebUtil.isContainSpecialCharecter(Name)){
  		errmodel.addError("The following charecters are prohibited in the name field: "+WebUtil.getSpecialCharectersList());
  	}
  }
  if(Url == null || Url.equals("")){
   	errmodel.addError("Bugilla URL was not supplied");
  }  
	
	if(errmodel.getErrorCount() != 0){
		response.setContentType("text/xml");
		response.setHeader("Pragma-Control", "no-cache");
	 	response.setHeader("Cache-Control", "no-cache");
	 	response.setHeader("Expires", "0");
	 	String[] errors = errmodel.getErrors();
		StringBuffer sb = new StringBuffer();
		for (int i=0; i<errors.length; i++){
			if (sb.length() > 0){
				sb.append("*;*");
			}
			sb.append(errors[i]);
		}
		String message = sb.toString();
 		String xml = GridModelActionsHelper.getResultXML(false,message);
		out.write(xml);
		out.flush();
  	return;
	}
	
	IssueTracking tracker = null;
	BugzillaIssueTrackingConfiguration conf = null;
	IssueTrackingManager mgr = IssueTrackingManager.getInstance(); 
	if(id != null){
		tracker = mgr.getIssueTrackingById(id);
		if (tracker == null){
			tracker = mgr.getIssueTrackingTemplateById(id);
		}		
	}
	if (tracker == null){
		tracker =  IssueTrackingManager.getInstance().getIssueTrackingTemplateById("bugzilla");
	}
	
	conf = (BugzillaIssueTrackingConfiguration)tracker.getConfig();
	tracker.setName(Name);
	tracker.setDesc(Description);
	conf.setServerUrl(Url);
	if (User != null && User.length() > 0){
		conf.setDefaultUsername(User);
		if (Pwd != null){
			conf.setDefaultPassword(Pwd);
		}
	}
	
	boolean verified = false;
	if(actionType.equals("verify") || verifyBeforeSave){
		if(errmodel.getErrorCount() == 0){					  
		  try {
			  verified = tracker.validateSettings();
			  if (!verified){
			  	verifyMsg = "Failed to communicate with Bugzilla*;*Please verify the Bugzilla settings*;*Please verify that Bugzilla enables XML-RPC communitaion";
			  }else{
			  	verifyMsg = "Verification OK";
			  }
		  }catch(Throwable t) {
		  	verifyMsg = "An error occured during verification: " + t.getMessage();
		  }
		}
	}
	
	if((!verifyBeforeSave || verified) && !actionType.equals("verify")){
		if(mgr.saveIssueTracking(tracker)) {
			UserEnvironment env = UserEnvironment.getUserEnvironment(request);
			IssueTracking currTracker = env.getIssueTracking();
			if (currTracker != null && currTracker.getId() != null && currTracker.getId().equals(tracker.getId())){
				currTracker.dispose();
				env.setIssueTracking(null);
			}
			
			if(!isEmbeded) {
				request.getSession().setAttribute("lastSelectedIssueTracking",tracker.getId());
			}
			
			//	audit
			AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
				  			userContext, AuditConstants.CHANGE, "add/edit issue tracking", AuditConstants.ISSUE_TRACKING, "add/edit Bugzilla issue tracking " + tracker.getName());
		}else {
			errmodel.addError("An error occured while saving bug tracking system");
	  	
	  	response.setContentType("text/xml");
		 	response.setHeader("Pragma-Control", "no-cache");
		 	response.setHeader("Cache-Control", "no-cache");
		 	response.setHeader("Expires", "0");

		 	String[] errors = errmodel.getErrors();
			StringBuffer sb = new StringBuffer();
			for (int i=0; i<errors.length; i++){
				if (sb.length() > 0){
					sb.append("*;*");
				}
				sb.append(errors[i]);
			}
			String message = sb.toString();
		 	String xml = GridModelActionsHelper.getResultXML(false,message);
			out.write(xml);
			out.flush();
	  	return;
		}
	}
	
	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");

	String xml = "";
	if(verifyBeforeSave && !verified) {
		xml = GridModelActionsHelper.getResultXML(false,verifyMsg,tracker.getId());
	}else {
		xml = GridModelActionsHelper.getResultXML(true,"",tracker.getId());
	}
	out.write(xml);
	out.flush();
%>

