<%@page import="xpolog.eye.issuetracking.util.IssueTrackingClientActionResult"%>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@page import="xpolog.eye.issuetracking.*"%>
<%@page import="xpolog.eye.site.*"%>
<%

	UserEnvironment env = UserEnvironment.getUserEnvironment(request);


  
	boolean success = false;
	String message = "";

	IssueTracking tracker = env.getIssueTracking();
	if (tracker != null){
		IssueTrackingManager issueTrackingManager = IssueTrackingManager.getInstance();
		if(tracker != null && issueTrackingManager.getIssueTrackingById(tracker.getId()) == null) {
			tracker.dispose();
			env.setIssueTracking(null);
			message = "No bug tracking system was supplied";
		}else {
			String username = request.getParameter("username");
			String password = request.getParameter("password");
			if (username == null || username.length() == 0){
				message = "No username was supplied";
			}else {
				if (password == null){
					password = "";
				}
				IssueTrackingClient client =  tracker.getClient();
				if (client != null){
					client.init();
					IssueTrackingClientActionResult result =  client.login(username,password);
					success = result.isSuccessful();
					if (!success){
						String [] errors = result.getErrorModel().getErrors();
						for (int i = 0; i < errors.length;i++){
							if (i > 0){
								message+= "<br>";
							}
							message += errors[i];
						}
					}
				}else {
					message = "No client was created to the bug tracking system";
				}
			}
		}
	}else {
		message = "No bug tracking system was supplied";
	}

  
	String xml = GridModelActionsHelper.getResultXML(success,message);	
  response.setContentType("text/xml");
  response.setHeader("Pragma-Control", "no-cache");
  response.setHeader("Cache-Control", "no-cache");
  response.setHeader("Expires", "0");

	
  out.write(xml);
	out.flush();

%>