<%@ page language="java"%>

<%@ page import="xpolog.eye.issuetracking.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
  UserContext userContext = UserEnvironment.getUserContext(request);

  String id = request.getParameter("id");
  
  IssueTrackingManager mgr = IssueTrackingManager.getInstance();
  String isEmbededStr = request.getParameter("isEmbeded");
	boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");
  boolean success = true;
  String msg = "Verification OK";
  if(isEmbeded) {
  	msg = "ok@#" + msg;
  }
	if (id != null){
  	IssueTracking tracker = mgr.getIssueTrackingById(id);

  	if (tracker != null){  	
  		try {
  			success = tracker.validateSettings();
  			if (!success){
  				msg = "Failed to communicate with bug tracking system<br>Please verify the settings<br>Please verify that XML-RPC communitaion is enabled in the bug tracking system";
  				if(isEmbeded) {
  			  	msg = "error@#Failed to communicate with bug tracking system*;*Please verify the settings*;*Please verify that XML-RPC communitaion is enabled in the bug tracking system";
    			}
  			}
  		}catch (Exception e){  			
				success = false;
				msg = e.getMessage();
				if(isEmbeded) {
			  	msg = "error@#" + msg;
			  }
  		}
  	
  	}
  } else {
  	msg = "No issue tracking was given, please refresh and try again";
  	if(isEmbeded) {
	  	msg = "error@#" + msg;
	  }
  }
	if(isEmbeded) {
  	response.setContentType("text/xml");
		out.write(msg);
		out.flush();
		return;
  }

%>

<html>

<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
</head>

<body>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Verification&nbsp;</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Result</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="22">
                    <span class="REGULARTEXT"><%=msg%></span>
                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="35%">&nbsp;</td>
                <td width="11%" align="center">&nbsp;</td>
                <td width="7%" align="center"><a href='javascript:history.go(-1)' class="LINK">
                ok</a></td>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</body>

</html>