<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.patch.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.config.image.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
  UserContext userContext = UserEnvironment.getUserContext(request);

  String PATCH_PATH = "PATCH_PATH";
  String ERROR_OBJ = "ERROR_OBJ";
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);  	
	PatchPublisherRunner runner = PatchPublisherRunner.getInstance();
	ErrorModel errmodel = new ErrorModel(); 

  String patch_file  = request.getParameter(PATCH_PATH);
  String op = request.getParameter("op");
	
	if (op != null && op.equals("stop")){
		runner.cancel();
		response.sendRedirect("importPatch.jsp?publishPatch=true");
	}else {	 
	  //verify data
	  if(patch_file == null || patch_file.trim().equals("")){
	    errmodel.addError("No patch file was supplied.");
	    request.getSession().setAttribute(ERROR_OBJ,errmodel);
	    response.sendRedirect(BASE_DIRECTORY+"common/errorpage.jsp");
	    return;
	  }
	  
	  String publishPatchStr = request.getParameter("publishPatch");
	  boolean publishPatch = publishPatchStr != null && publishPatchStr.equals("true");

	  ConfigurationPublisher publisher = new ConfigurationPublisher();
		HashMap xplgNodes = new HashMap();
		/*
	  String nodesList = request.getParameter("xplgNodes");
	  if (nodesList == null) nodesList = "";
	  String[] nodes = nodesList.split(",");
	  if (nodes != null){
		  for (int i=0; i<nodes.length; i++){
		  	xplgNodes.put(nodes[i],nodes[i]);
		  }
	  }
	  */
	  xplgNodes = (HashMap)request.getSession().getAttribute("xplgNodes");
	  request.getSession().removeAttribute("xplgNodes");
	  int numNodes = xplgNodes != null ? xplgNodes.size() : 0;

		publisher.setXplgNodes(xplgNodes);

	  File arch = new File(patch_file);
	  try{
	    //audit
	    if (!publishPatch){
	    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	     			userContext, AuditConstants.CHANGE, "import patch to system", AuditConstants.CONFIGURATION, "import patch to system " + patch_file);	 	 	
	    }else{
		    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	     			userContext, AuditConstants.CHANGE, "publish patch", AuditConstants.CONFIGURATION, "publish patch to " + numNodes + " nodes using file " + patch_file);	 	 	
	    }
	    File f = new File("temp/");
	    if (Configuration.isWar() || !f.getAbsoluteFile().exists()){
  			arch = UploadHelper.uploadFile(request,arch);
	    }else {	    		    	
	    	arch = UploadHelper.uploadFile(request,arch,f.getAbsolutePath());
	    }
			PatchBuilder patchBuilder = new PatchBuilder(arch);
			patchBuilder.setPublisher(publisher);
			patchBuilder.setPublish(publishPatch);
			patchBuilder.validate();
			if (!Configuration.isWar() && f.getAbsoluteFile().exists()){
				patchBuilder.setPatchTargetDir(f.getAbsolutePath());
			}
			if (publishPatch){
				//response.sendRedirect("patchPublishStatusAction.jsp");
				runner.init(patchBuilder,publisher);
				runner.execute();
				response.sendRedirect("importPatch.jsp?publishPatch=true");
			}else{
				env.setTempAttribute("patchBuilder",patchBuilder);
				response.sendRedirect("runPatchStatus.jsp");
			}
	  }catch(Exception e){
	    e.printStackTrace();
	    ErrorModel errmod = new ErrorModel();
	    errmod.addError("The patch is not valid. Please contact our support team at - support@xpolog.com");
	    errmod.addError(e.getMessage());
	    request.getSession().setAttribute(ERROR_OBJ,errmod);
	    response.sendRedirect(BASE_DIRECTORY+"common/errorpage.jsp");
	    return;
	  }
	}

%>