<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.exe.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.patch.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.common.JobStatus"%>
<%@ page import="xpolog.config.*"%>

<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.ABOUT_PERMISSION,true)){
    return;
  }
	String ERROR_OBJ = "ERROR_OBJ";
	String ID = "ID";
	
	final UserEnvironment env = UserEnvironment.getUserEnvironment(request); 
	final PatchBuilder patchBuilder = (PatchBuilder)env.getTempAttribute("patchBuilder");
  
  final String context = request.getContextPath();
  final int localPort = request.getServerPort();

	ErrorModel errmodel = new ErrorModel();
	
	JobStatus status = patchBuilder.getJobStatus();

	env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, status);

	ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "tools/patches/systemAndPatchInfo.jsp") {
	  public void run(HttpServletRequest request){
	    //if the data source failed or the datasource finished, ends the progress.
	    boolean isFinished = false;
	    try {
			  patchBuilder.setSourceContext(context);
			  patchBuilder.setPort(localPort);
				patchBuilder.createPatch();
	    }catch (Exception e){
	      e.printStackTrace();
	    }
			env.removeTempAttribute("patchBuilder");
	  }
	};
	env.setProgressRunner(runner);
%>

<jsp:include page="../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Processing"/>
 <jsp:param name="useStatus" value="true"/>
 <jsp:param name="stopUrl" value="tools/patches/patchPublishStatusStopAction.jsp"/>
</jsp:include>

