<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.exe.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.patch.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.security.*"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%

  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.ABOUT_PERMISSION,true)){
    return;
  }
  String ERROR_OBJ = "ERROR_OBJ";
	File rootPath_ = new File(Configuration.XPOLOG_ROOT_PATH);
	String rootPath = rootPath_.getAbsolutePath();
	String patchZip = request.getParameter("patchZip");
	
	UserEnvironment env = UserEnvironment.getUserEnvironment(request); 
	PatchBuilder patchBuilder = (PatchBuilder)env.getTempAttribute("patchBuilder",false);
	
	if (patchBuilder == null && patchZip != null && patchZip.length() > 0){
	  patchBuilder = new PatchBuilder(new File(patchZip));
	}

  //verify data
  ErrorModel errmodel = new ErrorModel();
  if(patchBuilder == null){
    errmodel.addError("No patch was supplied.");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY+"common/errorpage.jsp");
    return;
  }
  
  String context = request.getContextPath();
  int localPort = request.getServerPort();
  patchBuilder.setSourceContext(context);
  patchBuilder.setPort(localPort);

	String patchFile = request.getParameter("patchFile");
	if (patchFile == null || patchFile.equals("")){
		patchFile = "patch.xml";
	}
	
	String target = request.getParameter("target");
	if (target != null && target.length() == 0){
		target = null;
	}
	if (target != null){
	  patchBuilder.setTarget(target);
	}
	try {
		patchBuilder.createPatch();
	}catch (Exception e){
	  e.printStackTrace();
	}
	       
%>