<%!
  public PriorityFilter createPriorityFilter(HttpServletRequest request,HttpServletResponse response,RecordMask mask) throws Exception{
    String PRIOR_SPEC_VAL = "ToSelect";
    boolean priorIsActive = false;
    int cnum = mask.getCulomnsNumber();
    String[] priorities = null;
    PriorityFilter pfl = null;

    for(int i=0;i<cnum;++i){
      if((mask.getMaskColumn(i) instanceof PriorityMask)){
        priorities = ((PriorityMask)mask.getMaskColumn(i)).getPriorities();
        pfl = new PriorityFilter(mask,i);
        break;
      }
    }
    if(priorities != null && priorities.length > 0){
        String[] filterVal = null;
        filterVal = request.getParameterValues(PRIOR_SPEC_VAL);
        if(filterVal != null){
          priorIsActive = true;
          pfl.setPriorities(filterVal);
        }
    }
    if(priorIsActive){
      return pfl;
    }else{
      return null;
    }
  }
%>
