<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.mail.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
//need to be changed to template book permission.
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION,true)){
    return;
  }
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  
  	String ERROR_OBJ = "ERROR_OBJ";
	String TEMPLATE_ID = "ID";
	String id = request.getParameter(TEMPLATE_ID);
	
	Account from = null;
	Account to = null;
	String subject = "";
	String message = "";
	String name = "";
	String description = "";
	
	if(id != null){
		TemplateBook templateBook = TemplateBook.getInstance();
		PostOffice med = (PostOffice)templateBook.getTemplateById(id);
		name = med.getMediaName();
		description = med.getDescription();
		from = med.getFrom();
		to = med.getTo();
		subject = med.getSubject();
		message = med.getMessage();
	}else{
		id = "";
	}
	
	MailAccountFilter filter = new MailAccountFilter();
    AddressBook adbook = AddressBook.getInstance();
    List list = adbook.getAccountsByFilter(filter);
	if(list.size() == 0) {
	  //No accounts defined in system
	  ErrorModel errmodel = new ErrorModel();
	  errmodel.addError("There is no eMail account defined, Please <a href=\"" + BASE_DIRECTORY + "tools/addresses/mail/accountMail.jsp\">create eMail account</a> first.");
	  request.getSession().setAttribute(ERROR_OBJ,errmodel);
	  response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
	  return;
	}
	
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
      function doSave(){
        document.access.action ="templateMailAction.jsp";
        document.access.submit();
      }
      
       function goNew(){
		path = "<%=BASE_DIRECTORY%>tools/addresses/accoutAction.jsp?ACCOUNT_TYPE=email";
  		document.location = path;
  	  }
 
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="33%" class="TOPBORDER">
                <span class="PAGEHEADER">eMail Alert Template</span> </td>
                <td width="44%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%" >&nbsp;</td>
                <td colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">eMail details</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">Name</span></td>
                        <td width="69%">
                        <input class="TEXTBOX" type="text" name="name" size="50" value="<%=name%>"></td>
                      </tr>
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">Description</span></td>
                        <td width="69%">
                        <input class="TEXTBOX" type="text" name="Description" size="50" value="<%=description%>"></td>
                      </tr>
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">From</span></td>
                        <td width="69%">
                        <select class="TEXTBOX" size="1" name="fromId">
                        <option value="">--- Select email account ---</option>
                        <%
                        	String accselected = "selected";
                            String accunselected = "";
                            String toGo = accunselected;
                            Account acc = null;
                            
                            for(int i=0;i<list.size();++i){
                            	acc = (Account)list.get(i);
                            	if(from != null && acc.getId().equals(from.getId())){
                            			toGo = accselected;
                            		}else{
                            			toGo = accunselected;
                            		}
                        %>
                               <option <%=toGo%> value="<%=acc.getId()%>"><%=acc.getAccountName()%></option>
                        <%
                        	}
                        %></select>
                        <%
                        if (user == null || user.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){
                        %>
                        <span class="SMALLTEXT"><a href="javascript:goNew()" class="LINK">new</a></span>
                        <%}%>
                        </td>
                      </tr>
                       <tr>
                        <td width="11%"><span class="REGULARTEXT">To</span></td>
                        <td width="69%">
                        
                        <select class="TEXTBOX" size="1" name="toId">
                        <option value="">--- Select email account ---</option>
                        <%
                        	String acselected = "selected";
                            String acunselected = "";
                            String acToGo = acunselected;
                            Account ac = null;
                            
                            for(int i=0;i<list.size();++i){
                            	ac = (Account)list.get(i);
                            	if(to != null && ac.getId().equals(to.getId())){
                            			acToGo = acselected;
                            		}else{
                            			acToGo = acunselected;
                            		}
                        %>
                               <option <%=acToGo%> value="<%=ac.getId()%>"><%=ac.getAccountName()%></option>
                        <%
                        	}
                        %></select>
                        <%
                        if (user == null || user.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){
                        %>
                        <span class="SMALLTEXT"><a href="javascript:goNew()" class="LINK">new</a></span>
                        <%}%>
                        </td>
                      </tr>
                       <tr>
                        <td width="11%"><span class="REGULARTEXT">eMail Subject</span></td>
                        <td width="69%">
                        <input class="TEXTBOX" type="text" name="subject" size="50" value="<%=subject%>"></td>
                      </tr>
                       <tr>
                        <td width="11%"><span class="REGULARTEXT">eMail Message</span></td>
                        <td width="69%">
                       <textarea class="TEXTBOX" rows="6" cols="60" type="text" name="message" value="<%=message%>"><%=message%></textarea></td>
                      </tr>
                      <tr>
                        <td width="11%">&nbsp;</td>
                        <td width="69%"><input class="TEXTBOX" type="hidden" name="Id" size="10" value="<%=id%>">
                        &nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td width="15%" height="21">
                    &nbsp;</td>
                  </tr>
                  <!--
                  <tr>
                    <td><b><i>Log context pattern</i></b></td>
                  </tr>-->
                  <tr>
                    <td><font size="2">&nbsp;&nbsp;</font></td>
                  </tr>
                  <tr>
                    <td>
                    <font size="2">&nbsp; </font>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    &nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="101%" id="AutoNumber17">
                      <tr>
                        <td width="25%">&nbsp;</td>
                        <td width="13%">
                        <p align="center">&nbsp;</td>
                        <td width="11%"><a href="javascript:history.go(-1)" class="LINK">cancel</a></td>
                        <td width="11%"><a href="javascript:doSave()" class="LINK">save</a></td>
                        <td width="35%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>