<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
  UserContext userContext = UserEnvironment.getUserContext(request);

	String ERROR_OBJ = "ERROR_OBJ";
	String SSH_ACC = "sshAccount";
	
	String Name, Description, targetDir, Id, sshAccount;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	targetDir = request.getParameter("targetDirectory");
	Id = request.getParameter("Id");
	sshAccount = request.getParameter(SSH_ACC);
	

	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
    	errmodel.addError("No Name was supplied.");
  	}

  	if(targetDir == null || targetDir.equals("")){
    	errmodel.addError("Server target Directory was not supplied.");
  	}

  	if(sshAccount == null || sshAccount.trim().equals("")){
    	errmodel.addError("No SSH Account was not supplied.");
  	}
 
  	
  	if(errmodel.getErrorCount() != 0){
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
  	}
	
	AddressBook adbook = AddressBook.getInstance();
    TelnetAccount sshacc = (TelnetAccount)adbook.getAccountById(sshAccount);
	
	
	
	TelShManager med = null;
	TemplateBook templateBook = TemplateBook.getInstance();
	if(Id != null){
		med = (TelShManager)templateBook.getTemplateById(Id);
	}
	if(med == null){
		med = new TelShManager();
	}
	
	med.setMediaName(Name);
	med.setDescription(Description);
	med.setTargetDirectory(targetDir);
	med.setAccount(sshacc);
	
	templateBook.addTemplate(med);
	templateBook.saveTemplateBook();

	//audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		   			userContext, AuditConstants.CHANGE, "add/edit template", AuditConstants.CONFIGURATION, "add/edit ssh template " + Name);	 	 	

	response.sendRedirect(BASE_DIRECTORY + "tools/templates/templateview.jsp?templateType=SshMedia");
%>

