<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
  UserContext userContext = UserEnvironment.getUserContext(request);

	String ERROR_OBJ = "ERROR_OBJ";
	TemplateBook templateBook = TemplateBook.getInstance();
	
	String id = null;
	String type = null;
	
	id = request.getParameter("ID");
	type = request.getParameter("TYPE");
	
	ErrorModel errmodel = new ErrorModel();
	
	if(id == null){
		errmodel.addError("Please supply Id for Template to delete.");
	}
	
	if(errmodel.getErrorCount() > 0){
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		return;
	}
	
	  String name = "";
	  Media template = templateBook.getTemplateById(id);
	  if(template != null) {
		  name = template.getMediaName();
	  }
	  //audit
	  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "remove template from system", AuditConstants.CONFIGURATION, "remove template from system " + name);	 	 	

	
	templateBook.removeTemplate(id);
	response.sendRedirect("viewtemplatesaction.jsp?TYPE="+type);
	

%>