<%@ page language="java"%>

<%@ page import="omega.ui.html.tree.ODefaultTreeCellRenderer"%>
<%@ page import="omega.ui.models.tree.ODefaultMutableTreeNode"%>

<%@ page import="xpolog.eye.Module"%>
<%@ page import="xpolog.eye.ModuleMember"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.menu.ModulesMenuLoader"%>
<%@ page import="xpolog.eye.site.*" %>

<%@ page import="java.util.HashSet"%>

<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);

	String storageStr = request.getParameter("storage");
	boolean isStorage = storageStr != null && storageStr.equals("true");
	
	String treeModulesName = isStorage ? ModulesMenuLoader.TREE_MODULES + ModuleMember.STORAGE_SUFFIX : ModulesMenuLoader.TREE_MODULES;
	HashSet treeModules = (HashSet)env.getGlobalAttribute(treeModulesName);
	String script = "";
	if (treeModules == null){
		treeModules = new HashSet();
		env.setGlobalAttribute(treeModulesName,treeModules);
	}
	String moduleId = request.getParameter("moduleId");
	treeModules.add(moduleId);
	
	String globalAttributeName = "folderIdsToOpen" + (isStorage ? ModuleMember.STORAGE_SUFFIX : "");
	String folderIdsToOpen = (String)env.getGlobalAttribute(globalAttributeName);
	if(folderIdsToOpen != null) {
		String[] folderIdsToOpenArr = folderIdsToOpen.split(",");
		for(int i = 0; i < folderIdsToOpenArr.length; i++) {
			treeModules.add(folderIdsToOpenArr[i]);
		}
		env.removeGlobalAttribute(globalAttributeName);
		
		if(folderIdsToOpen.length() > 0) {
			ViewContext viewContext = env.getViewContext();
			if(viewContext != null) {
				String slideId = isStorage ? "rootModule" + ModuleMember.STORAGE_SUFFIX : "rootModule";
				viewContext.setSlideOpen(slideId);
			}
		}
	}
	
	String modId = moduleId;
	
	SiteManagment mgmt = SiteManagment.getInstance();
	Module mod = null;
	try{
		mod = mgmt.getModuleFromId(modId);
		ODefaultTreeCellRenderer cr = new ODefaultTreeCellRenderer();
		ModulesMenuLoader modMenuLoader = new ModulesMenuLoader();
		modMenuLoader.setStorage(isStorage);
		ODefaultMutableTreeNode node = (ODefaultMutableTreeNode)modMenuLoader.creatMutableNodeFromModule(mod,userContext,env);
		if (isStorage){
			script = cr.renderNode(node,!mod.getId().equalsIgnoreCase(Module.ROOT_STORAGE_MODULE_ID),!mod.getId().equalsIgnoreCase(Module.ROOT_STORAGE_MODULE_ID));
		}else{
			script = cr.renderNode(node,!mod.getId().equalsIgnoreCase(Module.ROOT_MODULE_ID),!mod.getId().equalsIgnoreCase(Module.ROOT_MODULE_ID));
		}
	}catch(Exception e){
		ErrorModel.log.error("Failed to load folders tree",e);
		
	}
	
	 response.setContentType("text/xml");
	 out.write(script);
		out.flush();
%>
