<%@ page import="omega.ui.models.tree.*" %>
<%@ page import="omega.ui.html.tree.*" %>
<%@ page import="xpolog.eye.*" %>
<%@ page import="xpolog.eye.verifiers.*" %>
<%@ page import="xpolog.eye.security.*" %>
<%@ page import="xpolog.eye.managment.*" %>
<%@ page import="xpolog.eye.menu.*" %>
<%@ page import="xpolog.eye.site.UserEnvironment" %>
<%@ page import="java.util.*" %>

<%
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  XpologApplicationComponent selectedComp = (XpologApplicationComponent)env.getSelectedComponent(user);
  MenuManager manager = null;
  if (selectedComp != null){
    ComponentManagement compManage = selectedComp.getComponentManagement();
    manager = compManage.getMenuManager();
  }else {
    manager = new MenuManager(null);
  }
 
  PopupMenues popupMenues = manager.getPopupMenues();
  PopupMenu [] popups = popupMenues == null ? new PopupMenu[0] : popupMenues.getPopups();
  
  int defMenuWidth = popupMenues == null ? -1 : popupMenues.getDefaultMenuWidth();
  if (defMenuWidth <= 0){
    defMenuWidth = 150;
  }
%>

<% for(int i = 0; i < popups.length; i++){
   List items = popups[i].getItems();
   if (items.size() == 0){
     continue;
   }
   int menuWidth = popups[i].getMenuWidth();
   if (menuWidth <= 0){
     menuWidth = defMenuWidth;
   }
%>
<%=popups[i].getPopupId()%> = new jsDOMenu(<%=String.valueOf(menuWidth)%>,"","absolute");
  with(<%=popups[i].getPopupId()%>){
<% 
  
  for (int j = 0;j < items.size();j++){
    MenuItem item = (MenuItem)items.get(j);
    
    %>
    addMenuItem(new menuItem("<%=item.name%>", "<%=item.id%>", "<%=item.link%>"));
  <%}%>
  }  
<%}%>


