<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%
  UserContext userContext = UserEnvironment.getUserContext(request);

  String ERROR_OBJ = "ERROR_OBJ";
  //the temp header and footer  
  String headerText = request.getParameter("htext");
  String footerText = request.getParameter("ftext");
  String mode = request.getParameter("operationMode");
  
  UserSecurity user = null;
  HeadersAndFootersManager headersAndFootersManager = Configuration.uiResourcesManager.getHeadersAndFootersManager();

  //the tmp,saved and default headers and footers.
  //get the tmp path of the header and footer.
  String tmpHeaderPath = headersAndFootersManager.getTmpHeaderPath(user);
  String tmpFooterPath = headersAndFootersManager.getTmpFooterPath(user);
  //the tmp header and footer 
  File tmpHeaderFile = headersAndFootersManager.getTmpHeaderFile(user);
  File tmpFooterFile = headersAndFootersManager.getTmpFooterFile(user);
  //get the saved path of the header and footer.
  String savedHeaderPath = headersAndFootersManager.getSavedHeaderPath(user);
  String savedFooterPath = headersAndFootersManager.getSavedFooterPath(user);
  //the saved header and footer
  File savedHeaderFile = headersAndFootersManager.getSavedHeaderFile(user);
  File savedFooterFile = headersAndFootersManager.getSavedFooterFile(user);
  //get the default path of the header and footer.
  String defaultHeaderPath = headersAndFootersManager.getDefaultHeaderPath(user);
  String defaultFooterPath = headersAndFootersManager.getDefaultFooterPath(user);
  //the default header and footer path
  File defaultHeaderFile = headersAndFootersManager.getDefaultHeaderFile(user);
  File defaultFooterFile = headersAndFootersManager.getDefaultFooterFile(user);
  
  // on click verify.
  if(mode.equals("verify")) {
	//write header and footer to the tmp files
	headersAndFootersManager.doVerify(headerText, footerText, user);
	/*BufferedWriter tmpHeaderWriter = new BufferedWriter(new FileWriter(tmpHeaderFile));
	BufferedWriter tmpFooterWriter = new BufferedWriter(new FileWriter(tmpFooterFile));
	tmpHeaderWriter.write(headerText);
	tmpHeaderWriter.flush();
	tmpFooterWriter.write(footerText);
	tmpFooterWriter.flush();*/
  }
	
  //on click save
  if (mode.equals("save")) {
	//write header and footer to the saved files
	headersAndFootersManager.doSave(headerText, footerText, user);
	/*BufferedWriter savedHeaderWriter = new BufferedWriter(new FileWriter(savedHeaderFile));
	BufferedWriter savedFooterWriter = new BufferedWriter(new FileWriter(savedFooterFile));
	savedHeaderWriter.write(headerText);
	savedHeaderWriter.flush();
	savedFooterWriter.write(footerText);
	savedFooterWriter.flush();
	//copy the saved to the tmp header and footer after writing the current header and footer to the saved.
	//xpolog.eye.util.FileUtil.copy(savedHeaderFile,tmpHeaderFile,true);
	//xpolog.eye.util.FileUtil.copy(savedFooterFile,tmpFooterFile,true);
	headersAndFootersManager.copySavedToTmp(user);*/
	}
	
	//on click reset
	if (mode.equals("reset")) {
	  //copy the saved header and footer to the tmp.
	  headersAndFootersManager.copySavedToTmp(user);
	  //xpolog.eye.util.FileUtil.copy(savedHeaderFile,tmpHeaderFile,true);
	  //xpolog.eye.util.FileUtil.copy(savedFooterFile,tmpFooterFile,true);
	}
	
	if (mode.equals("default")) {
	  //copy the default header and footer to the tmp and saved.
	  headersAndFootersManager.doDefault(user);
	  /*xpolog.eye.util.FileUtil.copy(defaultHeaderFile,savedHeaderFile,true);
	  xpolog.eye.util.FileUtil.copy(defaultHeaderFile,tmpHeaderFile,true);
	  xpolog.eye.util.FileUtil.copy(defaultFooterFile,savedFooterFile,true);
	  xpolog.eye.util.FileUtil.copy(defaultFooterFile,tmpFooterFile,true);*/
	}
	
	//audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		   			userContext, AuditConstants.CHANGE, "edit headers/footers UI center", AuditConstants.CONFIGURATION, "edit headers/footers UI center");	 	 	

	
  response.sendRedirect("headersandfootersset.jsp");
%>


