<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="omega.ui.models.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="omega.ui.html.table.OHtmlTable"%>


<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
	if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)){
    return;
    }
    
    //constants
    String ERROR_OBJ = "ERROR_OBJ";
    String HEADER_TEXT = "htext";
    String FOOTER_TEXT = "ftext";
    String MODE = "saved";
  	
    //site management
    HeadersAndFootersManager headersAndFootersManager = Configuration.uiResourcesManager.getHeadersAndFootersManager();
    StringsManager stringsManager = Configuration.uiResourcesManager.getStringManager();
    
    //the header and footer titles
	String headerTitle = stringsManager.getString("headersPageHeaderTitle");
	String footerTitle = stringsManager.getString("headersPageFooterTitle");
    
    UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);

	//String sep = System.getProperty("line.separator");
	//get the saved path of the header and footer.
	String tmpHeaderPath = headersAndFootersManager.getTmpHeaderPath(user);
	String tmpFooterPath = headersAndFootersManager.getTmpFooterPath(user);
	//the tmp header and footer path
	//File tmpHeaderFile = headersAndFootersManager.getTmpHeaderFile(user);
	//File tmpFooterFile = headersAndFootersManager.getTmpFooterFile(user);
	//get the saved path of the header and footer.
    //String savedHeaderPath = BASE_DIRECTORY+headersAndFootersManager.getSavedHeaderPath(user);
    // savedFooterPath = BASE_DIRECTORY+headersAndFootersManager.getSavedFooterPath(user);
    //the saved header and footer
    //File savedHeaderFile = new File("defaultroot/"+savedHeaderPath);
    //File savedFooterFile = new File("defaultroot/"+savedFooterPath);
	//check if this is the first time in this page.
    String toCopy = request.getParameter("COPY_TO_TMP");
    if(toCopy != null && toCopy.equals("copy")) {
      //xpolog.eye.util.FileUtil.copy(savedHeaderFile,tmpHeaderFile,true);
	  //xpolog.eye.util.FileUtil.copy(savedFooterFile,tmpFooterFile,true);
	  headersAndFootersManager.copySavedToTmp(user);
    }
	
	//read and present the temp header and footer.
	String currentHeader = headersAndFootersManager.getCurrentHeader(user);
	String currentFooter = headersAndFootersManager.getCurrentFooter(user);
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>

<script language="javascript">
	function doVerify(mode){
	  document.access.operationMode.value=mode;
   	  document.access.submit();
	}
	
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" name="access" id="access" action="headersandfootersAction.jsp">
<input type="hidden" name="operationMode" value="on">
<table border="0" width="100%" cellspacing="0" height="673" cellpadding="0">
  <tr>
    <td width="100%" height="673">
    <table border="0" width="100%" cellspacing="0" height="65%" cellpadding="0">
      <tr>
        <td valign="top" height="65%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
              <jsp:include page="<%=tmpHeaderPath%>" flush="true">
				<jsp:param name="headerTitle" value="<%=headerTitle%>"/>
			  </jsp:include>
          </tr>
              <tr>
                <td width="8">&nbsp;</td>
                <td width="423">&nbsp;</td>
                <td width="456">&nbsp;</td>
              </tr>
              <tr>
                <td width="8" >&nbsp;</td>
                <td colspan="2" width="881">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="881" id="AutoNumber3">
                  <tr>
                    <td width="881" height="18" colspan="6"></td>
                  </tr>
                  <tr>
                    <td width="881" height="18" colspan="6"><span class="HEADER"><%=stringsManager.getString("headerTitle")%></span></td>
                  </tr>
                  
                  <tr>
                    <td width="881" height="18" colspan="6"><span class="SMALLTEXT"><%=stringsManager.getString("headerNote")%></span></td>
                  </tr>
                  <tr><td width="881" height="18" colspan="6"><textarea class="TEXTBOX" wrap="off" rows="8" name="htext" cols="120" style="font-size: 8pt"><%=currentHeader%></textarea></td>
                  </tr>
                  <tr>
                    <td colspan="6" width="881">&nbsp;</td>
                  </tr>
                  <tr>
                    <td colspan="6" width="881">&nbsp;</td>
                  </tr>
                  <tr>
                    <td colspan="6" width="881"><span class="HEADER"><%=stringsManager.getString("footerTitle")%></span></td>
                  </tr>
                  <tr>
                    <td width="881" height="18" colspan="6"><span class="SMALLTEXT"><%=stringsManager.getString("footerNote")%></span></td>
                  </tr>
                  <tr>
                    <td width="881" height="18" colspan="6"><textarea class="TEXTBOX" wrap="off" rows="8" name="ftext" cols="120" style="font-size: 8pt"><%=currentFooter%></textarea></td>
                  </tr>
                  <tr>
                    <td colspan="6" width="881">&nbsp;</td>
                  </tr>
                  <tr>
                    <td colspan="6" width="881">
                    <a href="javascript:doVerify('verify')" class="LINK"><%=stringsManager.getString("verifyLinkText")%></a> 
                    <span class="SMALLTEXT"><%=stringsManager.getString("verifyNote")%><br>
&nbsp;</span><p>&nbsp;</p>
                    <p>&nbsp;</p>
                    <p>&nbsp;</p>
                    <p>&nbsp;</p>
                    <p>&nbsp;</td>
                  </tr>
                  <tr>
                    <td colspan="6" width="881">
                      <table border="0" width="602" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="593">&nbsp;</td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td colspan="6" width="881">&nbsp;</td>
                  </tr>
                  <tr>
                    <td colspan="6" width="881">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td width="104">
                    &nbsp;</td>
                    <td width="195">
                    <a href="javascript:doVerify('default')" class="LINK"><%=stringsManager.getString("restoreDefaultLinkText")%></a></td>
                    <td width="120">
                    <a href="javascript:doVerify('reset')" class="LINK"><%=stringsManager.getString("resetLinkText")%></a></td>
                    <td width="118">
                    <a href="javascript:doVerify('save')" class="LINK"><%=stringsManager.getString("saveLinkText")%></a></td>
                    <td width="131">
                    <a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK"><%=stringsManager.getString("cancelLinkText")%></a></td>
                    <td width="213">
                    <a href="<%=BASE_DIRECTORY%>uicenter/uisetcenter.jsp" class="LINK"><%=stringsManager.getString("backToUICenterLinkText")%></a></td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
           <jsp:include page="<%=tmpFooterPath%>" flush="true">
				<jsp:param name="footerTitle" value="<%=footerTitle%>" />
		   </jsp:include>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>