<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.verifiers.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%
  final String BASE_DIRECTORY = "../";
%>

<%!
	static final String [] rulesNames = {"more than", " less than"};
%>

<%
	String ERROR_OBJ = "ERROR_OBJ";
	String VERIFIER_ID = "VERIFIER_ID";
	String LOG_ID = "LOG_ID";
	
	SiteManagment mgmt = SiteManagment.getInstance();
	WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  UserContext userContext = UserEnvironment.getUserContext(request);
	
	LogVerifier verifier = new LogVerifier();
	String verId = request.getParameter(VERIFIER_ID);
	String logId = request.getParameter(LOG_ID);
	
	VerifierManager verManager = SiteManagment.getInstance().getVerifierManager();
	LogBrowsingManager lbm = new LogBrowsingManager();
	String selectedLogId = "";
	String selectedFilterId = "";
  
  List filters = new ArrayList();
  
	if (logId != null && logId.length() > 0){
		selectedLogId = logId;
	}
	if (verId != null && verId.length() > 0){
	  verifier = (LogVerifier)verManager.getVerfierFromId(verId);
	  if (logId == null || logId.equals("")){
			selectedLogId = verifier.getLogId();
	  }
	}
	if (verId != null && verId.length() > 0){
		selectedFilterId = verifier.getLogFilterId();
	}
	else if (filters != null && filters.size() > 0){
		FilterCollection filter = (FilterCollection)filters.get(0);
		selectedFilterId = filter.getId();
	}
	
	request.setAttribute("CUREENT_VERIFIER",verifier);
	String verifierName = verifier.getName();
	if (request.getParameter("VERIFIER_NAME") != null){
		verifierName = request.getParameter("VERIFIER_NAME");
	}
	String verifierId = verId != null && verId.length() > 0 ? verId : "";
	String lbmId = logId != null && logId.length() > 0 ? logId : "";
%>

<script>

function Filter(id, name){
  this.id = id;
	this.name = name;
}

function Log(id,name){
  this.id = id;
	this.name = name;
	this.filters = new Array();
	this.filters[0] = new Filter("", "None");
}

var logs = new Array();

function updateFilters(){
   document.access.filtersCombo.options.length = 0;
	 if(document.access.logsCombo.selectedIndex == -1){
      return;
  }
	
	var id = document.access.logsCombo.options[document.access.logsCombo.selectedIndex].value;
	for(var i=0;i<logs.length;i++){
	  if (logs[i].id == id){
			for (var j = 0; j < logs[i].filters.length;j++){
			  var option0 = new Option(logs[i].filters[j].name,logs[i].filters[j].id);
				document.access.filtersCombo.options[document.access.filtersCombo.options.length] = option0;				
			}
			break;
		}
  }
}

function refreshFilters(){
	document.refresh.LOG_ID.value = document.access.logsCombo.options[document.access.logsCombo.selectedIndex].value;
	document.refresh.VERIFIER_NAME.value = document.access.name.value;
	document.refresh.submit();
}
	
function doSave(){
	updateSelected();
  doTasks();
	document.access.submit();
}

function doReset(){
   this.location = "LogVerifierSettings.jsp?VERIFIER_ID=<%=verifier.getId()%>";
}

function updateSelected(){
	list = tree.getAllCheckedAndPartiallyChecked();
	arr = list.split(",");
  var logsStr = "";
  var filtersStr = "";
	for (var i=0; i<arr.length; i++){
		s = arr[i];
		ind = s.indexOf("-");
		if (ind == -1){
			continue;
		}else{
			type = s.substring(0,ind);
			id = s.substring(ind+1,s.length);
			if (type == "<%=XpoLogObjectTypes.LOG_TYPE%>"){
				if (logsStr != ""){
					logsStr += ",";
				}
				logsStr += id;
			}else if (type == "<%=XpoLogObjectTypes.FILTER_TYPE%>"){
				if (filtersStr != ""){
					filtersStr += ",";
				}
				filtersStr += id;
			}
		}
	}
	document.access.logs.value = logsStr;
	document.access.filters.value = filtersStr;
}

   
</script>

<html >
	<head>
		<meta http-equiv="Content-Language" content="en-us">
		<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
		<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
		<META HTTP-EQUIV="EXPIRES" CONTENT="0">
		<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css">
		<jsp:include page="../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
		<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		</jsp:include>
		<title></title>
	</head>

	<body>
		<form AUTOCOMPLETE="OFF" id="access" name="access" action="LogVerifierSettingsAction.jsp">
			<input type="hidden"  name="id" value="<%=verifier.getId()%>">
			<input type="hidden"  name="LOG_ID">
			<input type="hidden" name="mods">
			<input type="hidden" name="logs">
			<input type="hidden" name="filters">
			<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse"
			bordercolor="#111111">
				<tr>
					<td width="100%" height="100%" valign="top">
						<table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
							<tr>
								<td valign="top" height="90%">
									<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id=
									"AutoNumber1">
										<tr>
											<td width="100%">
												<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width=
												"100%" id="AutoNumber2" height="100%">
													<tr>
														<td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
														<td width="53%" class="TOPBORDER" height="0">
															<span class="PAGEHEADER">Log Monitor Settings</span> 
														</td>
														<td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
													</tr>
													<tr><td colspan="3">&nbsp;</td></tr>
												</table>

												<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width=
												"100%" height="100%">
													<tr>
														<td width="3%" height="100%">&nbsp;&nbsp;&nbsp;</td>
														<td width="93%" colspan="2" height="100%">
															<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse"
															width="100%" id="AutoNumber3" height="53">
																<tr>
																	<td width="15%">
																		<span class="HEADER">Global</span><b>&nbsp;</b> 
																	</td>
																</tr>
																<tr>
																	<td>
																		
																	</td>
																</tr>

																<tr>
																	<td width="100%">
																		<table border="0" width="300">
																			<tr>
																				<td width="150">
																					<span class="REGULARTEXT">Name:</span> 
																				</td>
																				<td width="150">
																					<input type="text" class="TEXTBOX" name="name" size="30" value="<%=verifierName%>"> 
																				</td>
																			</tr>
																		</table>
																	</td>
																</tr>

																<tr><td width="15%" ></td></tr>
																<tr>
																	<td width="15%" >
																		<span class="HEADER">Settings</span><b>&nbsp;</b> 
																	</td>
																</tr>
																<tr>
																	<td>	
																	</td>
																</tr>
																<tr>
																	<td>
																		<span class="REGULARTEXT">Select the log and the filter to be used as
																		monitor:</span> 
																	</td>
																</tr>
																<tr><td height="100%"></td></tr>
																<tr>
																	<td valign="top">
																		<div id="loadingDiv" style="display:none">
																			<span class="REGULARTEXT">Loading...</span>
																		</div>
																	</td>
																</tr>
							                  <tr>
							                    <td width="15%">
							                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
							                      <tr>
							                        <td class="REGULARTEXT">
									                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
									                      <tr>
																					<td valign="top">
																						<div id="treeboxbox_tree"></div>
																					</td>
									                      </tr>
									                    </table>
							                        </td>
							                      </tr>
							                    </table>
							                    </td>
							                  </tr>
							                  <tr>
							                    <td>
							                    </td>
							                  </tr>
																<tr>
																	<td>
																		
                                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                      <tr>                                                                      
                                        <td><input type="checkbox" name="runFromLastLocation" value="ON" <%=(verifier.isRunFromLastLocation() ? "checked" : "")%> ></td>
                                        <td nowrap><span class="REGULARTEXT">Scan log from last scan stop</span></td>
                                        <td width="90%"></td>
                                      </tr>
                                    </table>
																		
																	</td>
																</tr>
															
																<tr>
																	<td>
																		
																	</td>
																</tr>

																<tr>
																	<td width="15%" >
																		<span class="HEADER">Rules</span><b>&nbsp;</b> 
																	</td>
																</tr>
																<tr>
																	<td>
																		
																	</td>
																</tr>
																<tr>
																	<td>
																		<span class="REGULARTEXT">Select the rules for this monitor:</span> 
																	</td>
																</tr>
																<tr><td height="100%"></td></tr>

																<tr>
																	<td>
																		<span class="REGULARTEXT">&nbsp;Failure means that there are  &nbsp;
																		   <select size="1" name="rulesType" id="rulesType">
																			  <% for (int i = 0; i < rulesNames.length; i++){%>
																						<option class="REGULARTEXT" value="<%=String.valueOf(i)%>"  <%=verifier.getRuleType() == i? "selected" : ""%>><%=rulesNames[i]%></option>
																						<%}%>
																					</select> </span>
																		<input type="text" class="TEXTBOX" name="recordsAmount" size="5" value="<%=verifier.getRecordsAmount()%>"> <span class=
																		"REGULARTEXT">&nbsp;records in the result.</span> 
																	</td>
																</tr>
																<tr><td width="100%" ></td></tr>
																<tr><td width="100%" ><span class="HEADER">Actions</span></td></tr>
																<tr><td width="100%" >
																<jsp:include flush="true" page="tasksVerifier.jsp">
																	  	<jsp:param name="taskDivBaseDirectory" value="../"/>															
																</jsp:include> 
																</td></tr>
																<tr><td width="100%" >&nbsp;</td></tr>
															</table>
														</td>
													</tr>

													<tr>
														<td>
															<font size="2">&nbsp;</font> 
														</td>
													</tr>
												</table>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td valign="bottom" height="10%">
						<table border="0" width="100%">
							<tr>
								<td width="30%">&nbsp;</td>
								<td width="31%" align="center">
									<table border="0" width="225">
										<tr>
											<td width="33%">
												<a href="javascript:doSave()" class="LINK">save</a> 
											</td>
											<td width="33%">
												<a href="javascript:doReset()" class="LINK">reset</a> 
											</td>
											<td width="33%">
												<a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK">cancel</a> 
											</td>
										</tr>
									</table>
								</td>
								<td width="39%">&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td valign="bottom" height="10%">
						<table border="0" cellpadding="0" cellspacing="0" width="100%">
							<tr>
								<td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td><td class="BOTTOMBORDER" width="100%">
								&nbsp;</td><td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</form>
		
		<form AUTOCOMPLETE="OFF" name="refresh" action="LogVerifierSettings.jsp" method="post">
			<input type="hidden" name="VERIFIER_ID"<%if (verId != null && verId.length() > 0){%> value="<%=verId%>"<%}%>>
			<input type="hidden" name="VERIFIER_NAME">
			<input type="hidden" name="LOG_ID" value="">
		</form>

<script>
	tree=new dhtmlXTreeObject("treeboxbox_tree","100%","100%","0");
	tree.setImagePath("<%=BASE_DIRECTORY%>");
	tree.setIconSize(13,13);
	tree.enableTreeLines(false);
	tree.setOnLoadingStart(startLoading);
	tree.setOnLoadingEnd(endLoading);
	tree.enableCheckBoxes(1);
	tree.enableThreeStateCheckboxes(true);
	tree.setXMLAutoLoading("LogVerifierModuleTreeXML.jsp");
	tree.loadXML("LogVerifierModuleTreeXML.jsp?VERIFIER_ID=<%=verifierId%>&LOG_ID=<%=lbmId%>");
</script>
	</body>
</html>
