<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.verifiers.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%@ include file="tasksVerifierAction.jsp"%>

<%
  UserContext userContext = UserEnvironment.getUserContext(request);

  String ERROR_OBJ = "ERROR_OBJ";
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
    return;
  }
  UserSecurity user = manager.getUserSecurity(request);
  VerifierManager verManager = SiteManagment.getInstance().getVerifierManager();
	ErrorModel errmodel = new ErrorModel();
		
  String id = request.getParameter("id");
	
	String name = request.getParameter("name");
	 if (name == null || name.trim().equals("")){
     errmodel.addError("No Name was supplied.");
   }
	 if(WebUtil.isContainSpecialCharecter(name)){
     errmodel.addError("The following charecters are prohibited in the name field: "+WebUtil.getSpecialCharectersList());
  }

	 
	 String [] verifiersIds = request.getParameterValues("SelectedVerifiersList");

	 boolean isRoot = id != null && id.equals(Verifier.ROOT_VERIFIER_ID);
	 if (!isRoot){
  		if (verifiersIds == null || verifiersIds.length == 0){
    		errmodel.addError("At least one monitor must be selected.");
  		}
	 }else {
	    verifiersIds = new String[0];
	 }
	 
	 int ruleType = Integer.parseInt(request.getParameter("rulesType"));
	
	
	 if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }
	
	MultiVerifier verifier = null;
	if (id == null || id.trim().length() == 0){
	  id = XpologUtil.generateID(name);	  
	}else {
	  verifier = (MultiVerifier)verManager.getVerfierFromId(id);
	}
	
	if (verifier == null) {
	   verifier = new MultiVerifier();
	}else {
	  verifier = (MultiVerifier)verifier.clone();
	}
	
	verifier.setId(id);
	verifier.setName(name);
	verifier.setRuleType(ruleType);
	verifier.setVerifiersIds(verifiersIds);
	
	createTasksForVerifier(request,response,verifier);
	
	SiteManagment.getInstance().getVerifierManager().addVerifier(verifier,null,userContext);
    //audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		 			userContext, AuditConstants.CHANGE, "add/edit multi verifier", AuditConstants.VERIFIERS, "add/edit multi verifier " + name);	 	 	

	request.getSession().removeAttribute("CURRENT_VERIFIER_RESULT");
	request.getSession().setAttribute("CURRENT_VERIFIER",verifier);
	response.sendRedirect("addopok.jsp?refreshMenu=true");
	
%>