<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%
  final String BASE_DIRECTORY = "../";
%>

<%
	//String VERIFIER_ID = "VERIFIER_ID";
	String REPORT_ID = "reportId";
	String ERROR_OBJ = "ERROR_OBJ";
	
	WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  UserContext userContext = UserEnvironment.getUserContext(request);
	ErrorModel errmodel = new ErrorModel();
	
	ReportVerifier verifier;
	
	ReportsManager reportsMgr = ReportsManager.getInstance();
	String reportId = request.getParameter(REPORT_ID);
	if (reportId == null || reportId.trim().equals("")){
		errmodel.addError("No report id was supplied.");
	}
	
	Report report = null;
	if (reportId != null && reportId.length() > 0){
		report = reportsMgr.getReportById(reportId,true);
	}
	if (report == null){
		errmodel.addError("Error loading report");
	}
	 
	if(errmodel.getErrorCount() != 0){
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
	}
	
  verifier = report.getDefaultReportVerifier();
  if (verifier == null){
  	verifier = report.createReportVerifier();
  }
	
	request.setAttribute("CUREENT_VERIFIER",verifier);
	String verifierName = verifier.getName();
	if (request.getParameter("VERIFIER_NAME") != null){
		verifierName = request.getParameter("VERIFIER_NAME");
	}
	
%>

<script>

var logs = new Array();

function doSave(){
    doTasks();
	  document.access.submit();
}

function doReset(){
   this.location = "ReportVerifierSettings.jsp?VERIFIER_ID=<%=verifier.getId()%>&reportId=<%=reportId%>";
}

   
</script>

<html >
	<head>
		<meta http-equiv="Content-Language" content="en-us">
		<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
		<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
		<META HTTP-EQUIV="EXPIRES" CONTENT="0">
		<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css">
		<title></title>
	</head>

	<body>
		<form AUTOCOMPLETE="OFF" id="access" name="access" action="ReportVerifierSettingsAction.jsp">
			<input type="hidden"  name="id" value="<%=verifier.getId()%>">
			<input type="hidden"  name="reportId" value="<%=reportId%>">
			<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse"
			bordercolor="#111111">
				<tr>
					<td width="100%" height="100%" valign="top">
						<table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
							<tr>
								<td valign="top" height="90%">
									<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id=
									"AutoNumber1">
										<tr>
											<td width="100%">
												<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width=
												"100%" id="AutoNumber2" height="100%">
													<tr>
														<td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
														<td width="53%" class="TOPBORDER" height="0">
															<span class="PAGEHEADER">Report Monitor Settings</span> 
														</td>
														<td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
													</tr>
													<tr><td colspan="3">&nbsp;</td></tr>
												</table>

												<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width=
												"100%" height="100%">
													<tr>
														<td width="3%" height="100%">&nbsp;&nbsp;&nbsp;</td>
														<td width="93%" colspan="2" height="100%">
															<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse"
															width="100%" id="AutoNumber3" height="53">
																<tr>
																	<td width="15%">
																		<span class="HEADER">Global</span><b>&nbsp;</b> 
																	</td>
																</tr>
																<tr>
																	<td>
																		
																	</td>
																</tr>

																<tr>
																	<td width="100%">
																		<table border="0" width="300">
																			<tr>
																				<td width="150">
																					<span class="REGULARTEXT">Name:</span> 
																				</td>
																				<td width="150">
																					<input type="text" class="TEXTBOX" name="name" size="30" value="<%=verifierName%>"> 
																				</td>
																			</tr>
																		</table>
																	</td>
																</tr>

																<tr><td width="100%" ></td></tr>
																<tr><td width="100%" ><span class="HEADER">Actions</span></td></tr>
																<tr><td width="100%" >
																	<jsp:include flush="true" page="tasksVerifier.jsp"/>
																</td></tr>
																<tr><td width="100%" >&nbsp;</td></tr>
															</table>
														</td>
													</tr>

													<tr>
														<td>
															<font size="2">&nbsp;</font> 
														</td>
													</tr>
												</table>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td valign="bottom" height="10%">
						<table border="0" width="100%">
							<tr>
								<td width="30%">&nbsp;</td>
								<td width="31%" align="center">
									<table border="0" width="225">
										<tr>
											<td width="33%">
												<a href="javascript:doSave()" class="LINK">save</a> 
											</td>
											<td width="33%">
												<a href="javascript:doReset()" class="LINK">reset</a> 
											</td>
											<td width="33%">
												<a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK">cancel</a> 
											</td>
										</tr>
									</table>
								</td>
								<td width="39%">&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td valign="bottom" height="10%">
						<table border="0" cellpadding="0" cellspacing="0" width="100%">
							<tr>
								<td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td><td class="BOTTOMBORDER" width="100%">
								&nbsp;</td><td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</form>				
	</body>
</html>
