<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.verifiers.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>

<%!

   SimpleDateFormat format = new SimpleDateFormat("MM/dd/yyyy HH:mm:ss");

	 String getTreeDiv(VerifierResult result){
    StringBuffer buffer = new StringBuffer();
    if (result != null){
      addDiv(result,buffer,1);
    }
    return buffer.toString();
  }

  void addDiv(VerifierResult result,StringBuffer buffer, int level){
	 int num = level * 5;
	 buffer.append("\n<DIV style=\"margin-top:2px;margin-bottom:2px;margin-left:" + num + "pt\" id=\"");
	 buffer.append(result.getSource().getId());
	 buffer.append("\">");
	 String imgStr = "emptyBullet.gif";
	 String message = "";
	 String zoomInLink = null;
	 if (level > 1){
	   zoomInLink = "VerifierView.jsp?VERIFIER_ID=" + result.getSource().getId();
	 }else {
	   if (result.getSource().getType().equals(LogVerifier.LOG_TYPE)){
	      LogVerifier logVerifier = (LogVerifier)result.getSource(); 
	      zoomInLink = BASE_DIRECTORY + "tools/sandf/searchAndFilterAction.jsp?logid=" + logVerifier.getLogId() + "&ACTIVATE_FILTER_ID="+logVerifier.getLogFilterId();
	   } 
	 }
	 
	 int status = result.getStatus();
		switch (status){
		case VerifierResult.SUCCESS:
 			message = "&nbsp; - OK";
			imgStr = "greenBullet.gif";
			break;
		case VerifierResult.FAILURE:
 			message = "&nbsp; - FAILED";
			imgStr = "redBullet.gif";
			break;
		case VerifierResult.NA:
 			message = "&nbsp; - N/A (" + result.getStatusMessage() + ")";
			break;
		case VerifierResult.ERROR:
 			message = "&nbsp; - ERROR (" + result.getStatusMessage() + ")";
			break;
		}
		
	 buffer.append("<img src=\"" + BASE_DIRECTORY + "images/verifierview/" + imgStr + "\"> ");
	 if (zoomInLink != null){
	 		buffer.append(" <a class=\"LINK\" href=\"" + zoomInLink + "\"> ");
		}else {
		   buffer.append("<span class=\"REGULARTEXT\">");
		}
	 buffer.append(result.getSource().getName());
	 if (zoomInLink != null){
	 		buffer.append("</a>");
		}else {
		   buffer.append("</span>");
		}
		
		buffer.append("<span class=\"SMALLTEXT\">");
   	buffer.append(message);
		buffer.append("</span>");
	 
  
    for (int i = 0; i < result.getChildsCount(); i++) {
      addDiv(result.getChildAt(i), buffer,level + 1);      
    }
		buffer.append("\n</DIV>");
  }
%>

<%
   //update menu tree
 SiteManagment mgmt = SiteManagment.getInstance();
 WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  UserContext userContext = UserEnvironment.getUserContext(request);
	
	Verifier verifier = null;
	String verId = request.getParameter("VERIFIER_ID");
	String rootTasks = request.getParameter("rootTasks");
	String childTasks = request.getParameter("childTasks");
	
	boolean generateEvents = (rootTasks != null);
	boolean generateChildEvents = (childTasks != null);
	
	VerifierManager verManager = SiteManagment.getInstance().getVerifierManager();
  
	if (verId != null && verId.length() > 0){
	   verifier = verManager.getVerfierFromId(verId);
	}else {
		 verifier = (Verifier) request.getSession().getAttribute("CURRENT_VERIFIER");
	}
	
	if (verifier == null){
	  ErrorModel errmodel = new ErrorModel();
		errmodel.addError("Monitor doesn't exists for id " + verId);
		request.getSession().setAttribute("ERROR_OBJ",errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
	}
	
	request.getSession().setAttribute("CURRENT_VERIFIER",verifier);

	
	String doExecuteStr = request.getParameter("doExecute");
	boolean doExecute = doExecuteStr != null && doExecuteStr.equals("true");
	
	VerifierResult result = (VerifierResult)request.getSession().getAttribute("CURRENT_VERIFIER_RESULT");
	if (doExecute){
		    //audit
		    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		  	 			userContext, AuditConstants.VIEW, "run verifier", AuditConstants.VERIFIERS, "run verifier " + verifier.getName());	 	 	

		result = verifier.execute(userContext,generateEvents,generateChildEvents);
	}else {
	  if (result != null){
		   result = result.getChildById(verifier.getId(),true);
		}
	 
	}
	
	if (result == null){
	   result = verifier.createEmptyResult(userContext);
	}else {
		request.getSession().setAttribute("CURRENT_VERIFIER_RESULT",result);
	}
	
%>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script>
  
function doUpdate(){
	document.access.action="VerifierView.jsp";
	document.access.submit();
}

   
</script>

<html >
	<head>
		<meta http-equiv="Content-Language" content="en-us">
		<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
		<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
		<META HTTP-EQUIV="EXPIRES" CONTENT="0">
		<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css">
		<title></title>
	</head>

	<body>
		<form AUTOCOMPLETE="OFF" id="access" name="access" action="LogVerifierSettingsAction.jsp">
			<input type="hidden"  name="id" value="<%=verifier.getId()%>">
			<input type="hidden"  name="isUpdate" value="true">
			<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse"
			bordercolor="#111111">
				<tr>
					<td width="100%" height="100%" valign="top">
						<table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
							<tr>
								<td valign="top" height="90%">
									<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id=
									>
										<tr>
											<td width="100%">
												<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width=
												"100%" height="100%">
													<tr>
														<td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
														<td width="53%" class="TOPBORDER" height="0">
															<span class="PAGEHEADER">Monitor View</span> 
														</td>
														<td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
													</tr>
													<tr><td colspan="3"></td></tr>
												</table>

												<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width=
												"100%" height="100%">
													<tr>
														<td width="3%" height="100%">&nbsp;&nbsp;&nbsp;</td>
														<td width="93%" colspan="2" height="100%">
															<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse"
															width="100%">

																<tr>
																	<td width="100%" >
																		<table border="0" width="*">
																			<tr>
																				<td width="150">
																					<span class="REGULARTEXT">Name:</span> 
																				</td>
																				<td width="150">
																					<span class="REGULARTEXT"><%=verifier.getName()%></span> 
																				</td>
																				 <td width="*">
																					  &nbsp;
																				</td>
																			</tr>
																		</table>
																	</td>
																</tr>
																																

																
																<tr>
																	<td width="100%" >
																		<table border="0" width="*">
																			<tr>
																				<td width="150" valign="top">
																					<span class="REGULARTEXT">Last Update:</span> 
																				</td>
																				<td width="500" valign="top">
																				<% long time = result.getUpdateTime();
																				   String updateStr = "No Update";
																					 if (time > 0){
																					   updateStr = format.format(new Date(time));
																					 }
																					 %>
																					<span class="REGULARTEXT"><nobr><%=updateStr%></nobr></span> 
																				</td>
																				<td width="250" valign="top">
                                                                                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                                                                      <tr>
                                                                                        <td width="100%">
                                                                                        <input type="hidden" name="VERIFIER_ID" id="VERIFIER_ID" value="<%=verifier.getId()%>">
                                                                                        <input type="hidden" name="doExecute" id="doExecute" value="true">
																					<a class="LINK" href="javascript:doUpdate()">Update View</a>
                                                                                        </td>
                                                                                      </tr>
                                                                                      <tr>
                                                                                        <td width="100%">
                                                                                          <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                                                                            <tr>
                                                                                              <td><span class="REGULARTEXT"><input type="checkbox" name="rootTasks" value="ON"></span> 
                                                                                              </td>
                                                                                              <td width="100%"><span class="REGULARTEXT">&nbsp;Activate
                                                                                                root
                                                                                                tasks</span></td>
                                                                                            </tr>
                                                                                            <tr>
                                                                                              <td><span class="REGULARTEXT"><input type="checkbox" name="childTasks" value="ON"></span> 
                                                                                              </td>
                                                                                              <td width="100%"><span class="REGULARTEXT">&nbsp;Activate
                                                                                                children
                                                                                                tasks</span></td>
                                                                                            </tr>
                                                                                          </table>
                                                                                        </td>
                                                                                      </tr>
                                                                                    </table>
																				</td>
																				<td width="*">
																					  &nbsp;
																				</td>
																			</tr>
																		</table>
																</tr>
																<tr>
																	<td width="15%">
																		<span class="HEADER">Result</span><b>&nbsp;</b> 
																	</td>
																</tr>
																

																<tr>
                            <td class="PORTALS">

														<%=getTreeDiv(result)%>
                          </td>
                      </tr>
														
															</table>
														</td>
													</tr>

													<tr>
														<td>
															<font size="2">&nbsp;</font> 
														</td>
													</tr>
												</table>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				
				<tr>
					<td valign="bottom" height="10%">
						<table border="0" cellpadding="0" cellspacing="0" width="100%">
							<tr>
								<td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td><td class="BOTTOMBORDER" width="100%">
								&nbsp;</td><td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</form>
	</body>
</html>
