<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.verifiers.*"%>
<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>
<%

  String ERROR_OBJ = "ERROR_OBJ";

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  UserSecurity security = manager.getUserSecurity(request);

  SiteManagment mgmt = SiteManagment.getInstance();
  String id = request.getParameter("VERIFIER_ID");

  Verifier ver = null;
  if(id == null || id.trim().equals("")){
    ver = (Verifier)request.getSession().getAttribute("CURRENT_VERIFIER");
  }else{
    ver = mgmt.getVerifierManager().getVerfierFromId(id);
    if(ver != null){
      request.getSession().setAttribute("CURRENT_VERIFIER",ver);
    }
  }
  if(ver == null ){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("You must select a monitor first.");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }
  String name = ver.getName();
  if (security != null && !security.isEditable(ver)){
    response.sendRedirect(BASE_DIRECTORY + "security/common/operationDenied.jsp");
    return;
  }
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>
  function operationOk(removeChildren){
    var path ="removeverifier.jsp?VERIFIER_ID=<%=ver.getId()%>";
    if (removeChildren){
    	path += "&removeChildren=true";
    }
    document.location = path;
  }
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
  <!--    <tr>
        <td valign="top" style="border-left: 1px solid #FF9900; border-right-width: 1; border-top-width: 1; border-bottom-width: 1" height="1">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="TOPLEFTBORDER" width="33%"  height="2"></td>
            <td class="TOPBORDER" width="33%" height="2"></td>
            <td class="TOPRIGHTBORDER"  width="34%" height="2"></td>
          </tr>
        </table>
        </td>
      </tr>-->
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Operation verification.</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">General</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="22">
                    <%if (ver instanceof MultiVerifier ){%>
                    <span class="REGULARTEXT">Do you want to remove <b><u>all the children</u></b> of monitor - <%=name%>?</span>
                    <%}else{%>
                    <span class="REGULARTEXT">Are you sure you want to remove monitor - <%=name%></span>
                    <%}%>
                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="35%">&nbsp;</td>
                <td width="11%" align="center"><a href='javascript:history.go(-1)' class="LINK">cancel</a></td>
                <%if (ver instanceof MultiVerifier ){%>
                <td width="7%" align="center"><a href='javascript:operationOk(false)' class="LINK">no</a></td>
                <td width="7%" align="center"><a href='javascript:operationOk(true)' class="LINK">yes</a></td>
                <%}else{%>
                <td width="7%" align="center"><a href='javascript:operationOk(false)' class="LINK">yes</a></td>
                <%}%>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>