<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.verifiers.*"%>
<%!static final String BASE_DIRECTORY = "../";%>

<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	XpoTaskManager mgr = XpoTaskManager.getInstance();
	List list = mgr.getXpoTasksByFilter(null, userContext);

	Verifier ver = (Verifier) request.getAttribute("CUREENT_VERIFIER");
	LogVerifier logVer = ver instanceof LogVerifier ? (LogVerifier)ver : null;
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	String baseDirectory = request.getParameter("baseDirectory");
	if(baseDirectory == null || baseDirectory.length() == 0) {
		baseDirectory = BASE_DIRECTORY;
	}
	String taskDivBaseDirectory = request.getParameter("taskDivBaseDirectory");
	if(taskDivBaseDirectory == null) {
		taskDivBaseDirectory = "";
	}

	List sucTasks = null;
	List failTasks = null;
	List aggTasks = null;
	List clearingTasks = null;
	VerifierTasksListener listener = null;
	long failCountForAggTasks = -1;
	int posAlertInterval = -1;
	int intervalTimeUnit = 0;
	if (ver != null) {
		Vector v = ver.getListeners();
		for (int i = 0; i < v.size(); ++i) {
			if (v.get(i) instanceof VerifierTasksListener) {
				listener = (VerifierTasksListener) v.get(i);
			}
		}
	}

	if (listener != null) {
		failTasks = listener.getFailTasksId();
		sucTasks = listener.getSuccessTasksId();
		aggTasks = listener.getAggregationTasksId();
		clearingTasks = listener.getClearingTasksId();
		failCountForAggTasks = listener.getFailCountForAggregationTasks();
		posAlertInterval = listener.getPositiveAlertInterval();
		intervalTimeUnit = listener.getIntervalTimeUnit();
	} else {
		sucTasks = new ArrayList();
		failTasks = new ArrayList();
		aggTasks = new ArrayList();
		clearingTasks = new ArrayList();
	}
	
	boolean showAdvancedDiv = posAlertInterval != -1;
	boolean showFailTaskExecPolicy = logVer != null;
%>
<script language="JavaScript" src="<%=baseDirectory%>scripts/filters/fromto.js"></script>
<script language="JavaScript" src="<%=baseDirectory%>scripts/UIUtil.js"></script>
<script>
	var taskType;
	function doTasks(){
  //success tasks
     addAllFiledToSelection(document.access.To_Suc<%=suffix%>,document.access.To_Select_Suc<%=suffix%>);
     for(var i=0;i<document.access.To_Select_Suc<%=suffix%>.options.length;++i){
       document.access.To_Select_Suc<%=suffix%>.options[i].selected='true';
     }
     //failure tasks
     addAllFiledToSelection(document.access.To_Fail<%=suffix%>,document.access.To_Select_Fail<%=suffix%>);
     for(var i=0;i<document.access.To_Select_Fail<%=suffix%>.options.length;++i){
       document.access.To_Select_Fail<%=suffix%>.options[i].selected='true';
     }
     //clearing tasks
     addAllFiledToSelection(document.access.To_Clear<%=suffix%>,document.access.To_Select_Clear<%=suffix%>);
     for(var i=0;i<document.access.To_Select_Clear<%=suffix%>.options.length;++i){
       document.access.To_Select_Clear<%=suffix%>.options[i].selected='true';
     }
	}
	
	function showHideAdvancedDiv(suffix){
		d = document.getElementById('advancedDiv'+suffix);
		td = document.getElementById('advancedLink'+suffix);
		if (d){
			if (d.style.display == "none"){
				d.style.display = "";
				if (td){
					td.innerHTML = "<a href=\"javascript:showHideAdvancedDiv('"+suffix+"')\" class=\"SMALLLINK\">hide advanced options</a>";
				}
			}else{
				d.style.display = "none";
				if (td){
					td.innerHTML = "<a href=\"javascript:showHideAdvancedDiv('"+suffix+"')\" class=\"SMALLLINK\">show advanced options</a>";
				}
			}
		}
	}
	
	function showNewTasksType(id,type,suffix){
		taskType	= type;
		var xPos = findPosX(document.getElementById(id));
		var yPos = findPosY(document.getElementById(id));
		var newTasksElem = document.getElementById("newTasksVerifierDiv_"+suffix);
		var newTaskFramElem = document.getElementById("newTasksVerifierFrame_"+ suffix);
		if(newTasksElem){
			if(newTasksElem.style.display == ""){
				newTasksElem.style.display = "none";
				newTaskFramElem.style.display = "none";
				return;
			}
			newTasksElem.style.display = "";
			newTasksElem.style.left =  xPos + 11;
			newTasksElem.style.top = yPos;
		}
		if(newTaskFramElem){
			newTaskFramElem.style.display = "";
			newTaskFramElem.style.left =  xPos + 11;
			newTaskFramElem.style.top = yPos;
			newTaskFramElem.style.height = newTasksElem.offsetHeight - 2;
		}
	}
	
	<%
		String path = taskDivBaseDirectory + "tasks/tasksDiv.jsp";
	%>
	
</script>
<!-- show new Task list  -->	

	<jsp:include page="<%=path%>" flush="true">
			<jsp:param name="base_directory" value="<%=baseDirectory%>"/> 
			<jsp:param name="taskDivBaseDirectory" value="<%=taskDivBaseDirectory%>"/> 
			<jsp:param name="_suffix" value="<%=suffix%>"/> 			
	</jsp:include>
<table border="0" width="100%">
  <tr>
    <td width="100%">
        <span class="SMALLTEXT">execute following actions upon monitor <b>success</b>:</span>
    
    </td>
  </tr>
  <tr>
    <td width="100%">
    	<table border="0" width="600" cellspacing="0" cellpadding="0">
  <tr>
	<td>
		<table border="0" width="86" cellspacing="0" cellpadding="0">
			<tr>
			  <td width="40%"><span class="SMALLTEXT">Actions</span></td>
			</tr>
			<tr>
			  <td width="40%">
				  <select class="TEXTBOX" size="6" id="From_Task_Suc<%=suffix%>" name="From_Task_Suc<%=suffix%>" style="font-size: 8pt; font-family: Verdana" >
                                  <%
                                  for (int i = 0; i < list.size(); ++i) {
                                  %>
					<option value='<%=((XpoTask)list.get(i)).getId()%>'><%=((XpoTask) list.get(i)).getName()%></option>
                                  <%
                                  }
                                  %>
				  </select>
				</td>
			  </tr>
			  <tr>
				  <td width="40%"></td>
			  </tr>
		</table>
	
	  <td width="100" nowrap>
		  <table border="0" width="100%" cellspacing="0" cellpadding="0">
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:addFiledToSelection(document.access.From_Task_Suc<%=suffix%>,document.access.To_Suc<%=suffix%>)" class="SMALLLINK">add</a></td>
			</tr>
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:addAllFiledToSelection(document.access.From_Task_Suc<%=suffix%>,document.access.To_Suc<%=suffix%>)" class="SMALLLINK">add all</a></td>
			</tr>
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:removeFiledFromSelection(document.access.To_Suc<%=suffix%>)" class="SMALLLINK">remove</a></td>
			</tr>
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:removeAllFiledFromSelection(document.access.To_Suc<%=suffix%>)" class="SMALLLINK">remove all</a></td>
			</tr>
			
		  </table>
	  </td>
	  <td width="100">
		  <table border="0" width="96" cellspacing="0" cellpadding="0">
			<tr>
			  <td width="100%"><span class="SMALLTEXT">Execute actions</span></td>
			</tr>
			<tr>
			  <td width="100%">
                                <select class="TEXTBOX" multiple type="hidden"  style="visibility:hidden; display:none" name="To_Select_Suc<%=suffix%>" id="To_Select_Suc<%=suffix%>">
                                </select>
				<select class="TEXTBOX" size="6" id="To_Suc<%=suffix%>" name="To_Suc<%=suffix%>" style="font-size: 8pt; font-family: Verdana">
                                <%
                                	XpoTask st = null;
                                	for (int y = 0; y < sucTasks.size(); ++y) {
                                		st = mgr.getXpoTaskById((String) sucTasks.get(y));
                                		if (st == null) {
                                			continue;
                                		}
                                %>
				    <option value='<%=st.getId()%>'><%=st.getName()%></option>
                                <%
                                }
                                %>
				</select></td>
			</tr>
			<tr>
			  <td width="40%"></td>
			</tr>
		  </table>
	  </td>
	  
	  <td width="50" nowrap>
		<table border="0" width="100%" cellspacing="0" cellpadding="0">
		  <tr>
		  	<td width="100%" nowrap>
						<table border="0" width="100%" cellspacing="0" cellpadding="0">
									<tr>
  										 <td width="6px">&nbsp;</td>									
			 								 <td align="center" nowrap><a href="javascript:showNewTasksType('newSucTasksArrowId_<%=suffix%>','suc','<%=suffix%>')" class="SMALLLINK">add new task</a></td>
			 								 <td width="11px" nowrap>&nbsp;</td>
			 								 <td id="newSucTasksArrowId_<%=suffix%>" width="4px" align="left" nowrap><a style="cursor:pointer;" href="javascript:showNewTasksType('newSucTasksArrowId_<%=suffix%>','suc','<%=suffix%>');"><img border="0" src="<%=baseDirectory%>images/slides/closeTabArrow.gif"></a></td>
									</tr>				
						</table>
				</td>			
		  </tr>
		  <tr>
			<td width="100%" align="center"><font size="1"><!--<a href="javascript:alert('holla')">move up</a>--></font></td>
		  </tr>
		  <tr>
			<td width="100%" align="center"><font size="1"><!--<a href="javascript:alert('holla')">move down</a>--></font></td>
		  </tr>
		  <tr>
			<td width="100%" align="center"></td>
		  </tr>
		</table>
	  </td>	
	  <td width="211">&nbsp;</td>		  
  </tr>
</table>
    
    </td>
  </tr>
  <tr>
    <td width="100%">
        <span class="SMALLTEXT">execute following actions upon monitor <b>failure</b>:</span>
    </td>
  </tr>
  <tr>
    <td width="100%">
    	<table border="0" width="600" cellspacing="0" cellpadding="0">
  <tr>
	<td>
		<table border="0" width="86" cellspacing="0" cellpadding="0">
			<tr>
			  <td width="40%"><span class="SMALLTEXT">Actions</span></td>
			</tr>
			<tr>
			  <td width="40%">
				  <select class="TEXTBOX" size="6" name="From_Fail<%=suffix%>" id="From_Fail<%=suffix%>" style="font-size: 8pt; font-family: Verdana" >
                                    <%
                                    for (int i = 0; i < list.size(); ++i) {
                                    %>
					<option value='<%=((XpoTask)list.get(i)).getId()%>'><%=((XpoTask) list.get(i)).getName()%></option>
                                  <%
                                  }
                                  %>
				  </select>
				</td>
			  </tr>
			  <tr>
				  <td width="40%"></td>
			  </tr>
		</table>
	  </td>
	  <td width="100" nowrap>
		  <table border="0" width="100%" cellspacing="0" cellpadding="0">
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:addFiledToSelection(document.access.From_Fail<%=suffix%>,document.access.To_Fail<%=suffix%>)" class="SMALLLINK">add</a></td>
			</tr>
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:addAllFiledToSelection(document.access.From_Fail<%=suffix%>,document.access.To_Fail<%=suffix%>)" class="SMALLLINK">add all</a></td>
			</tr>
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:removeFiledFromSelection(document.access.To_Fail<%=suffix%>)" class="SMALLLINK">remove</a></td>
			</tr>
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:removeAllFiledFromSelection(document.access.To_Fail<%=suffix%>)" class="SMALLLINK">remove all</a></td>
			</tr>
		  </table>
	  </td>
	  <td width="100">
		  <table border="0" width="96" cellspacing="0" cellpadding="0">
			<tr>
			  <td width="100%"><span class="SMALLTEXT">Execute actions</span></td>
			</tr>
			<tr>
			  <td width="100%">
                                <select class="TEXTBOX" multiple type="hidden"  style="visibility:hidden; display:none" name="To_Select_Fail<%=suffix%>" id="To_Select_Fail<%=suffix%>">
                                </select>
				<select class="TEXTBOX" size="6" id="To_Fail<%=suffix%>" name="To_Fail<%=suffix%>" style="font-size: 8pt; font-family: Verdana">
                                <%
                                	XpoTask ft = null;
                                	for (int y = 0; y < failTasks.size(); ++y) {
                                		ft = mgr.getXpoTaskById((String) failTasks.get(y));
                                		if (ft == null) {
                                			continue;
                                		}
                                %>
				    <option value='<%=ft.getId()%>'><%=ft.getName()%></option>
                                <%
                                }
                                %>
				</select></td>
			</tr>
		  </table>
	  </td>
	  <td width="50" nowrap>
		<table border="0" width="100%" cellspacing="0" cellpadding="0">
		  <tr>
		  	<td width="100%" nowrap>
						<table border="0" width="100%" cellspacing="0" cellpadding="0">
									<tr>	
											 <td width="6px">&nbsp;</td>
			 								 <td align="center" nowrap><a href="javascript:showNewTasksType('newFailTasksArrowId_<%=suffix%>','fail','<%=suffix%>')" class="SMALLLINK">add new task</a></td>
			 								 <td width="11px" nowrap>&nbsp;</td>
			 								 <td id="newFailTasksArrowId_<%=suffix%>" width="4px" align="left" nowrap><a style="cursor:pointer;" href="javascript:showNewTasksType('newFailTasksArrowId_<%=suffix%>','fail','<%=suffix%>');"><img border="0" src="<%=baseDirectory%>images/slides/closeTabArrow.gif"></a></td>
									</tr>				
						</table>
				</td>			
		  </tr>
		  <tr>
			<td width="100%" align="center"><font size="1"><!--<a href="javascript:alert('holla')">move up</a>--></font></td>
		  </tr>
		  <tr>
			<td width="100%" align="center"><font size="1"><!--<a href="javascript:alert('holla')">move down</a>--></font></td>
		  </tr>
		  <tr>
			<td width="100%" align="center"></td>
		  </tr>
		</table>
	  </td>
	   <td width="211">&nbsp;</td>	
  </tr>
</table>
    </td>
  </tr>
  <tr>
  	<td id="advancedLink<%=suffix%>">
  	<a href="javascript:showHideAdvancedDiv('<%=suffix%>')" class="SMALLLINK">show advanced options</a>
  	</td>
  </tr>
	<tr>
		<td>
		<div id="advancedDiv<%=suffix%>" <%=showAdvancedDiv ? "" : "style=display:none"%>>
		<table border="0" width="100%" cellspacing="2" cellpadding="2" style="border-style:solid; border-width:2px;">
			<tr>
				<td><span class="HEADER">Failure</span><b>&nbsp;</b></td>
			</tr>
			<tr>
				<td><span class="REGULARTEXT">&nbsp;Once failed, execute failure actions only after &nbsp; <input type="text" class="TEXTBOX"
					name="failCountForAggTasks<%=suffix%>" size="5"
					value="<%=(failCountForAggTasks != -1 ? String.valueOf(failCountForAggTasks) : "")%>">
				&nbsp;monitor failures </span></td>
			</tr>
			<%
			if (showFailTaskExecPolicy){
				int policy = logVer.getFailTaskExecPolicy();
			%>
			<tr>
				<td>
					<table border="0" width="100%" cellpadding="0" cellspacing="0">
						<tr>
							<td width="30%"><span class="REGULARTEXT">&nbsp;Once failed, execute failure actions for: &nbsp;</span></td>
							<td width="70%"><input type="radio" name="eventExecution<%=suffix%>" value="<%=LogVerifier.NO_EVENT%>" <%=policy==LogVerifier.NO_EVENT ? "checked":""%>><span class="REGULARTEXT">&nbsp; none of the events</span></td>						
						</tr>
						<tr>
							<td width="30%"></td>
							<td width="70%"><input type="radio" name="eventExecution<%=suffix%>" value="<%=LogVerifier.FIRST_EVENT_ONLY%>" <%=policy==LogVerifier.FIRST_EVENT_ONLY ? "checked":""%>><span class="REGULARTEXT">&nbsp; the first event only</span></td>						
						</tr>
						<tr>
							<td width="30%"></td>
							<td width="70%"><input type="radio" name="eventExecution<%=suffix%>" value="<%=LogVerifier.EACH_EVENT%>" <%=policy==LogVerifier.EACH_EVENT ? "checked":""%>><span class="REGULARTEXT">&nbsp; each event</span></td>						
						</tr>
						<tr>
							<td width="30%"></td>
							<td width="70%"><input type="radio" name="eventExecution<%=suffix%>" value="<%=LogVerifier.LAST_EVENT_ONLY%>" <%=policy==LogVerifier.LAST_EVENT_ONLY ? "checked":""%>><span class="REGULARTEXT">&nbsp; the last event only</span></td>						
						</tr>						
					</table>
				</td>
			</tr>
			<%}%>
			<tr>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td><span class="HEADER">Positive</span><b>&nbsp;</b></td>
			</tr>
			<tr>
				<td><span class="REGULARTEXT">&nbsp;Execute positive alert(s) after 
				<input type="text" class="TEXTBOX" name="posAlertInterval<%=suffix%>" size="5" value="<%=(posAlertInterval != -1 ? String.valueOf(posAlertInterval) : "")%>">
				<select name="timeUnit<%=suffix%>" id="timeUnit<%=suffix%>">
					<%
						String[] timeUnits = VerifierTasksListener.getTimeUnits();
						for (int i = 0; i < timeUnits.length; i++) {
							String tu = timeUnits[i];
							int tv = -1;
							try{
								tv = Integer.parseInt(VerifierTasksListener.getTimeUnitValue(tu));
							}catch(Exception e){}
							if (tu.length() == 0){
								tu = "- select -";
							}
					%>
					<option class="REGULARTEXT" value="<%=tv%>"
						<%=intervalTimeUnit == tv ? " selected" : ""%>><%=tu%></option>
					<%
					}
					%>
				</select> &nbsp;from last failure </span></td>
			</tr>
			<tr>
		    <td width="100%">
    	    <span class="SMALLTEXT">&nbsp;Note: if no positive alert settings are defined positive alert<br>
    	    &nbsp;will be sent upon first monitor success following a monitor failure
    	    </span>
	    	</td>
  		</tr>
			<%
			if (showFailTaskExecPolicy){
				int posAlertPolicy = logVer.getPositiveAlertPolicy();
			%>
			<tr>
				<td>
					<table border="0" width="100%" cellpadding="0" cellspacing="0">
						<tr>
							<td width="30%"><span class="REGULARTEXT">&nbsp;Send positive alert </span></td>
							<td width="70%"><input type="radio" name="posAlertPolicy<%=suffix%>" value="<%=LogVerifier.ONCE%>" <%=posAlertPolicy==LogVerifier.ONCE || posAlertPolicy==LogVerifier.UNDEFINED? "checked":""%>><span class="REGULARTEXT">&nbsp; once only</span></td>						
						</tr>
						<tr>
							<td width="30%"></td>
							<td width="70%"><input type="radio" name="posAlertPolicy<%=suffix%>" value="<%=LogVerifier.FOR_EACH_EVENT%>" <%=posAlertPolicy==LogVerifier.FOR_EACH_EVENT ? "checked":""%>><span class="REGULARTEXT">&nbsp; for each executed failure action</span></td>						
						</tr>
					</table>
				</td>
			</tr>
			<%}%>			<tr><td class="SMALLTEXT">&nbsp;</td></tr>
			<tr>
		    <td width="100%">
    	    <span class="SMALLTEXT">execute following actions upon <b>positive alert</b> signal:</span>
	    	</td>
  		</tr>
			<tr>
				<td>
				<table border="0" width="86" cellspacing="0" cellpadding="0">
					<tr>
						<td>
						<table border="0" width="86" cellspacing="0" cellpadding="0">
							<tr>
								<td width="40%"><span class="SMALLTEXT">Actions</span></td>
							</tr>
							<tr>
								<td width="40%"><select class="TEXTBOX" size="6"
									name="From_Task_Clear<%=suffix%>"
									style="font-size: 8pt; font-family: Verdana">
									<%
									for (int i = 0; i < list.size(); ++i) {
									%>
									<option value='<%=((XpoTask)list.get(i)).getId()%>'><%=((XpoTask) list.get(i)).getName()%></option>
									<%
									}
									%>
								</select></td>
							</tr>
							<tr>
								<td width="40%"></td>
							</tr>
						</table>
						</td>
						<td width="100" nowrap>
						<table border="0" width="100%" cellspacing="0" cellpadding="0">
							<tr>
								<td width="100%" align="center" nowrap><a
									href="javascript:addFiledToSelection(document.access.From_Task_Clear<%=suffix%>,document.access.To_Clear<%=suffix%>)"
									class="SMALLLINK">add</a></td>
							</tr>
							<tr>
								<td width="100%" align="center" nowrap><a
									href="javascript:addAllFiledToSelection(document.access.From_Task_Clear<%=suffix%>,document.access.To_Clear<%=suffix%>)"
									class="SMALLLINK">add all</a></td>
							</tr>
							<tr>
								<td width="100%" align="center" nowrap><a
									href="javascript:removeFiledFromSelection(document.access.To_Clear<%=suffix%>)"
									class="SMALLLINK">remove</a></td>
							</tr>
							<tr>
								<td width="100%" align="center" nowrap><a
									href="javascript:removeAllFiledFromSelection(document.access.To_Clear<%=suffix%>)"
									class="SMALLLINK">remove all</a></td>
							</tr>
						</table>
						</td>
						<td width="286">
						<table border="0" width="100%" cellspacing="0" cellpadding="0">
							<tr>
								<td width="100%"><span class="SMALLTEXT">Execute actions</span></td>
							</tr>
							<tr>
								<td width="100%"><select class="TEXTBOX" multiple type="hidden" style="visibility:hidden; display:none"
									name="To_Select_Clear<%=suffix%>" id="To_Select_Clear<%=suffix%>">
								</select> <select class="TEXTBOX" size="6" name="To_Clear<%=suffix%>"
									style="font-size: 8pt; font-family: Verdana">
									<%
										XpoTask ct = null;
										for (int y = 0; y < clearingTasks.size(); ++y) {
											ct = mgr.getXpoTaskById((String) clearingTasks.get(y));
											if (ct == null) {
												continue;
											}
									%>
									<option value='<%=ct.getId()%>'><%=ct.getName()%></option>
									<%
									}
									%>
								</select></td>
							</tr>
							<tr>
								<td width="40%"></td>
							</tr>
						</table>
						</td>
						<td width="100" nowrap>
						<table border="0" width="100%" cellspacing="0" cellpadding="0">
							<tr>
								<td width="100%" align="center"></td>
							</tr>
						</table>
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
  	</div>
  	</td>
  </tr>
</table>
