<%@ page language="java"%>
<%@ page import="xpolog.eye.site.main.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.security.*"%>

<%!static final String BASE_DIRECTORY = "../";%>

<%
	WebSecurityManager securityManager = WebSecurityManager.getInstance();
	if (!securityManager.checkForPermission(request, response, null, true)) {
		return;
	}

	ErrorModel err = new ErrorModel();
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
	MainViewModel model = env.getMainViewModel();
	
	ApplicationComponent app = env.getSelectedComponent(user);
	if (app != null && app.getId().equals("XpoLog")){
    env.setUsePage("view/mainView.jsp");
	}

	MainViewTabModel selectedTab = model.getSelectedTab();
	if (selectedTab == null) {
		selectedTab = model.updateFirstSelectedTab();
	}

	String topView = "view/mainTopView.jsp";

	if (!topView.startsWith("/") || topView.startsWith("http")) {
		topView = BASE_DIRECTORY + topView;
	}
	String tabMainView = "view/tabMainView.jsp";

	if (!tabMainView.startsWith("/") || tabMainView.startsWith("http")) {
		tabMainView = BASE_DIRECTORY + tabMainView;
	}
	MainViewTabModel[] onlineTabs = model.getAllOnlineTabs();
	
	XpologApplicationComponent selectedComp = (XpologApplicationComponent)env.getSelectedComponent(user);   
  
  String mainPage = null; 
  
 if (selectedComp != null){
    mainPage = selectedComp.getMainPage();    
 }
 
 if (mainPage == null){
   mainPage = "logEyePortal.jsp";
 }
 mainPage = BASE_DIRECTORY + mainPage;
 
 String hideImg = BASE_DIRECTORY + "images/logview/vlarrow.gif";
 String showImg = BASE_DIRECTORY + "images/logview/vrarrow.gif";
 
 long pollInterval = TelShActivityManager.POLL_INTERVAL;
%>

<html>
<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">

<title>XpoLog Center</title>
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainview.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/menus.css"/>
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/jsdomenu.css" />
<jsp:include page="../widgets/xtabs/tabMainView.jsp" flush="true" >
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script  src="<%=BASE_DIRECTORY%>scripts/comps/jsdomenu.js"></script>
<script  src="<%=BASE_DIRECTORY%>scripts/common/messages.js"></script>
<script>
  menu_base_directory = "<%=BASE_DIRECTORY%>";
</script>

<script src="<%=BASE_DIRECTORY%>scripts/tree/rightClickMenu.js"></script>

<script>
var width = 0;
var height = 0;
function init(){  
  if (<%=onlineTabs == null || onlineTabs.length == 0%>){
    showSlide('logSlides',false);
    return;
  }
  
  var topTD = document.getElementById("topTD"); 
  document.getElementById("a_tabbar").style.width=topTD.clientWidth-10;
  document.getElementById("a_tabbar").style.height=document.body.clientHeight-22;
  tabbar=new dhtmlXTabBar("tabbar","a_tabbar","top");
  tabbar.setImagePath("<%=BASE_DIRECTORY%>images/tabs/");  
  tabbar.setOffset(6);
  tabbar.setStyle("winXPLG");  
  width = document.body.clientWidth;          
  height = document.body.clientHeight;          
  tabbar.loadXML("tabs.jsp");
  
  startPollingService();
}

var allowResize = true;
function doresize(){
  <%if (onlineTabs != null && onlineTabs.length > 0){%>
    if (allowResize && (width != document.body.clientWidth || height != document.body.clientHeight)){
    this.location = "mainView.jsp";
  }
  <%}%>
}

var req;
var removeId;
var win;
function callback() {
if (req.readyState == 4) {
  tabbar.removeTab(removeId,true); 
  if (tabbar.getActiveTab() == null && win){
     win.location = "mainView.jsp?timestamp=<%=System.currentTimeMillis()%>";
  }      
 }
}

function removeTab(id){
removeId = id;
var url = "removeTab.jsp?id=" + removeId;
   if (typeof XMLHttpRequest != "undefined") {
       req = new XMLHttpRequest();
   } else if (window.ActiveXObject) {
       req = new ActiveXObject("Microsoft.XMLHTTP");
   }
   req.open("GET", url, true);
   req.onreadystatechange = callback;
   req.send(null);
   win = this;
  
}

function onClickHandler(e){
  hideVisibleMenus();
  tabbar._onClickHandler(e);
}

function RightClickMade(id,obj,e){
  hideVisibleMenus(); 
  showMenuPopup(obj,"logMenu",e);
  return false;
}

//use this method to show or hide menu by the target component and the menu name (string).
//The document which use it must include the jsdomenu.js
function showMenuPopup(comp,menuName,e){  
   var exists;
   eval('exists = typeof ' + menuName);
   if ( exists == 'undefined' ){
     return;
   }

  
  m = eval(menuName);
  if (!m){
    return;
  }
  if (m.isShow()){
    hideVisibleMenus();
  }else {
    x = e.x + 20;
    y = e.y + comp.offsetHeight;
    m.moveTo(x,y);
    setTimeout(menuName + ".show()",20);
  }
}


function showHideManage(){
  var show = showHideManagement();
  
}

function hideShowMenu(){    
	root = top.frames['root'];	
	if (!root){
	  root = parent;
	}
	
	if (!root){
	  return;
	}
	
	if (root.location.href == document.location.href || root.location.href.indexOf("root.jsp") == -1){
	  root.location = "<%=BASE_DIRECTORY%>root.jsp?mainPage=view/mainView.jsp";
	}else {
	  root.location =  "<%=BASE_DIRECTORY%>view/mainView.jsp";
	}
  }

function getExpandImageName(){
  var show = isManagementVisible();
  if (show){
    return "<%=hideImg%>";
  }else {
    return "<%=showImg%>";
  }
}

function getExpandImageName0(){
  root = top.frames['root'];
	if (!root){
	  root = parent;
	}
	
	if (!root || root.location.href == document.location.href || root.location.href.indexOf("root.jsp") == -1){
	  return "<%=showImg%>";
	}else {
	  return "<%=hideImg%>";
	}
}

var showPathVar = false;
function showPath(current,e,path){
	var e = this.event || e;
	var tt = document.getElementById('logPathDiv');
	if (showPathVar){
		return ;
	}
	var tableWidth = path.length * 7;
	var logPathTab = document.getElementById("logPathTable");
	if (logPathTab){
		logPathTab.setAttribute("width",tableWidth);
	}
  var sizeArr = getWindowSize();
  var winWidth = 1280;
  var winHeight = 1024;
  if (sizeArr && sizeArr.length == 2){
  	winWidth = sizeArr[0];
  }
	
	x = (this.event ? document.body.scrollLeft + e.x : e.pageX);
  y = (this.event ? document.body.scrollTop +  e.y : e.pageY);
	tt.style.left = x < (winWidth-tableWidth-50) ? x + 50 : x - tableWidth;
	tt.style.top = y + 20;
	var path_td = document.getElementById('pathTD');
	if (document.all){
		path_td.innerText = path;
	}else{
		path_td.textContent = path;
	}
	tt.style.display = "";
	showPathVar = true;
}

function hidePath(){
	var tt = document.getElementById('logPathDiv');
	tt.style.display = "none";
	showPathVar = false;
}

var timer;
function startPollingService() {
	checkSshLogsCount();
}

function stopPollingService() {
	if(timer != null) {
		clearTimeout(timer);
	}
	var page = "<%=BASE_DIRECTORY%>loggers/telShActivity.jsp?action=removeCandidates";
	doBackgroundAction(page);
}

function checkSshLogsCount() {
	var page = "<%=BASE_DIRECTORY%>loggers/telShActivity.jsp?action=count";
	sendAjaxRequest(page,function(req){
		var xmlDoc = req.responseXML.documentElement;
		var sshLogsCount = xmlDoc.getAttribute("sshLogsCount");
		if(sshLogsCount != "" && sshLogsCount != "0") {
			doPoll();
		}else {
			stopPollingService();
		}
	});
}

function doPoll() {
	var page = "<%=BASE_DIRECTORY%>loggers/telShActivity.jsp?action=poll";
	sendAjaxRequest(page,function(req){
		var xmlDoc = req.responseXML.documentElement;
		var inactiveLogsCount = xmlDoc.getAttribute("inactiveLogsCount");
		if(inactiveLogsCount != "" && inactiveLogsCount != "0") {
			for(var i = 0; i < parseInt(inactiveLogsCount); i++) {
				var inactiveLogElement = xmlDoc.getElementsByTagName("InactiveLog")[i];
				var logId = inactiveLogElement.getAttribute("logId");
				var logName = inactiveLogElement.getAttribute("logName");
				var inactivityPeriod = inactiveLogElement.getAttribute("inactivityPeriod");
				var sessionTimeoutInterval = inactiveLogElement.getAttribute("sessionTimeoutInterval");
				var tabId = inactiveLogElement.getAttribute("tabId");
				var doClose = inactiveLogElement.getAttribute("doClose");
				if(doClose == "true") {
					hideLayer("pollingServiceMessage");
					removeTab(tabId);
				}else {
					var msgWriter = new messageWriter("pollingServiceMessage" + logId,"Inactive SSH Log","<%=BASE_DIRECTORY%>");
					msgWriter.addAction("Continue working","javascript:hideLayer('pollingServiceMessage" + logId + "');markLog('" + logId + "')");
		    	msgWriter.addAction("Close log","javascript:hideLayer('pollingServiceMessage" + logId + "');javascript:removeTab('" + tabId + "')");  
		    	msgWriter.showMessage("Log " + logName + " has been idle for almost " + sessionTimeoutInterval + ".<br>What do you wish to do?");
		    }
			}
			timer = setTimeout("checkSshLogsCount()", <%=pollInterval %>);
		}else {
			timer = setTimeout("checkSshLogsCount()", <%=pollInterval %>);
		}
	});
}

function markLog(logId) {
	var page = "<%=BASE_DIRECTORY%>loggers/telShActivity.jsp?action=mark&logId=" + logId;
	doBackgroundAction(page);
}

</script>
</head>
<body SCROLL="NO" topmargin=0 leftmargin=0 rightmargin=0 onLoad="javascript:init()" onUnload="javascript:stopPollingService()" onresize="doresize()" onClick="javascript:hideVisibleMenus()" style="overflow-y: hidden;overflow-x: hidden;">

<div id="logPathDiv" class="TREE_NODE_CLASS" style="position:absolute;display:none;z-index:200">
<table id="logPathTable" border="0" width="300" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
	<tr>
		<td class="PROGRESSTEXT" id="" align="center" style="padding-top:1;padding-bottom:0;border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5"></td>
	</tr>
	<tr>
		<td id="pathTD" class="PROGRESSTEXT" style="padding-left:5;padding-top:2;padding-bottom:2"></td>
	</tr>
</table>
</div>

<table width="100%" height="100%" cellspacing="0" cellpadding="0" border="0">
	<tr>
		<td height="25" id="topTD"><jsp:include page="mainTopView.jsp" flush="true" /></td>
	</tr>
	<tr height="*">
		<td>
		<table width="100%" height="100%" cellspacing="0" cellpadding="0" border="0">
			<tr>
				
				<%if(onlineTabs == null || onlineTabs.length == 0){ %>
				<td  style="padding-left:30;padding-top:10" valign="top">
					<span class="HEADER">Select a log from the Folders and Logs panel on the left</span>
					<%
					UserContext userContext = UserEnvironment.getUserContext(request);
					boolean isPermittedAddLog = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_LOG_PERMISSION);
				  if(isPermittedAddLog) {
				  %>
					<span class="HEADER"> or </span>
					<a href="<%=BASE_DIRECTORY %>loggers/admin/logAdminGate.jsp" class="LINK">Create a new Log</a>
					<%} %>
				</td>
				<%}else { %>
				<td height="25" style="padding-left:10" valign="top">
					<div id="a_tabbar" style="width:0;height:0;background:#000000;">
					</div>
				</td>
				<%} %>
			</tr>
			
		</table>
		</td>
	</tr>
</table>
<script>
/*
logMenu = new jsDOMenu(130,"","absolute");
  with(logMenu){
    addMenuItem(new menuItem("Close", "close", "javascript:openPopupLink('tabAction.jsp?action=close&id=[ID]')"));
    addMenuItem(new menuItem("Close Others", "closeOthers", "javascript:openPopupLink('tabAction.jsp?action=closeOthers&id=[ID]')"));  
    addMenuItem(new menuItem("Create Snapshot", "createSnapshot", "javascript:openPopupLink('tabAction.jsp?action=createSnapshot&id=[ID]')"));  
  }
  */  
</script>

</body>
</HTML>

