<%@ page language="java" %>
<%@ page import="xpolog.eye.site.main.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.ModuleMembersUtil"%>

<%!static final String BASE_DIRECTORY = "../";%>
<%

ErrorModel err = new ErrorModel();
UserEnvironment env = UserEnvironment.getUserEnvironment(request);
MainViewModel model = env.getMainViewModel();

MainViewTabModel selectedTab = model.getSelectedTab();
if (selectedTab == null) {
	selectedTab = model.updateFirstSelectedTab();
}

MainViewTabModel[] onlineTabs = model.getAllOnlineTabs();
String selectedId = model.getSelectedTabId();

response.setContentType("text/xml");
response.setHeader("Cache-Control", "no-cache");
%>
<tabbar hrefmode="iframe">
    <row>
    <%for (int i = 0; i < onlineTabs.length;i++){ 
      MainViewTabModel tab = onlineTabs[i];
      String selectedStr = "";
      if (selectedId == null || selectedId.length() == 0){
      	if (i == 0){
      		selectedStr = "selected=\"1\"";
      	}
      }else if (tab.getId().equals(selectedId)){
      	selectedStr = "selected=\"1\"";
      }
      int width = 100;
      String displayName = tab.getDisplayName();
      if(displayName != null) {
	      if (displayName.length() > 20){
	      	width = 200;
	      	displayName = displayName.substring(0,20) + "...";
	      }else if (displayName.length() > 15){
	      	width = 200;
	      }else if (displayName.length() > 10){
	      	width = 150;
	      }
      }
      String path = "";	
      if (tab != null){
      	String mmId = tab.getDataId();
      	path = ModuleMembersUtil.getPathToRoot(mmId);
      	if((path == null || path.length() == 0) && tab.getDisplayName() != null){
      		path = tab.getDisplayName();
      	}
      }
    %>
        
        <tab id="<%=tab.getId()%>" width='<%=String.valueOf(width)%>' height='100%' <%=selectedStr%> href="mainTabAction.jsp?id=<%=tab.getId()%>" ><![CDATA[
        <table width="100%" height="100%" cellspacing="0" cellpadding="0" border="0">
        <tr  style="padding-left:0;padding-top:0;margin-top:0">        
				<td style="padding-left:5;padding-top:1;margin-top:0" valign="top" class="SMALLTEXT" <%if(path != null && path.length() > 0){%>onmouseover="javascript:showPath(this,event,'<%=path%>')" onmouseout="javascript:hidePath()"<%}%>><nobr><%=displayName%></nobr>
				<td width="11" style="padding-left:0;padding-top:2;margin-top:0" valign="top" class="SMALLTEXT">
        <img  src="<%=BASE_DIRECTORY%>images/tabs/tabremove.gif"  border="0" id="canImg<%=tab.getId()%>" onClick="javascript:removeTab('<%=tab.getId()%>')">
				</td>
				</td></tr>
				
				</table>
				]]>
        </tab>
        <% }%>  
         
    </row>
</tabbar>