
<%@page import="xpolog.eye.site.SiteConstants"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.site.ProgressRunner"%>
<%@page import="xpolog.eye.site.widgets.actions.WidgetActionResponse"%>
<%@page import="xpolog.eye.site.widgets.actions.WidgetActionRequest"%>
<%@page import="xpolog.eye.site.widgets.actions.WidgetActionExecuter"%>
<%@page import="xpolog.eye.site.widgets.XpoLogWidgetsManager"%><%@ page language="java"%>

<%!
  static final String BASE_DIRECTORY = "../../";
%>

<%

  String widgetId = request.getParameter("widgetId");
  if (widgetId == null || widgetId.length() == 0){
    return;
  }
  
	final WidgetActionExecuter executer = XpoLogWidgetsManager.getIntsance().createActionExecuter(widgetId);
	final WidgetActionRequest req = new WidgetActionRequest();
  req.getParams().putAll(SiteLogHelper.createParametersMapFromRequest(request.getParameterMap()));
  req.setResultType(WidgetActionRequest.URL_TYPE);
  req.setContext(UserEnvironment.getUserContext(request));
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  request.getSession().setAttribute("WidgetActionExecuter",executer);
	ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "home.jsp") {
		public void run(HttpServletRequest request) {
	try {
		Thread.sleep(300);
		WidgetActionResponse res = executer.executeAction(req);
		  if (res != null){        
		   String url = res.getRedirectPage();
       if (res.getActionStatus() == WidgetActionResponse.CANCEL_STATUS){
          url = "home.jsp"; 
       }
       if (url == null || url.length() == 0){
    	   if (res.getMessage() != null && res.getMessage().length() > 0){
    	      url = "common/opok.jsp?okUrl=home.jsp&message=" + res.getMessage();
    	   }   
       }
		   if (url != null && url.length() > 0){
		    setRedirectUrl(BASE_DIRECTORY + url);
		   }
       if (res.getActionStatus() == WidgetActionResponse.FAIL_STATUS && res.getErrorMessage() != null && res.getErrorMessage().length() > 0){
   		   errmodel.addError(res.getErrorMessage());
   		   createErrorRedirect(request,BASE_DIRECTORY);         
       }
		  }
	}catch (Exception e) {
		errmodel.addError(".");
		errmodel.addError(e.getMessage());
		createErrorRedirect(request,BASE_DIRECTORY);
	}
		}
	};
	env.setProgressRunner(runner);
	env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, executer.getStatus());

	
%>

<%@page import="xpolog.eye.site.helpers.SiteLogHelper"%>
<%@page import="java.util.Map"%><jsp:include page="../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="processing"/>
 <jsp:param name="useStatus" value="true"/>
 <jsp:param name="stopUrl" value="view/widgets/widgetStopAction.jsp"/>
</jsp:include>
