<%@ page language="java"%>
<%!
	static final String BASE_DIRECTORY = "../";
	static final int DEFAULT_MENU_WIDTH = 80;
%>

<%
String baseDirectory = request.getParameter("baseDirectory");
if (baseDirectory == null){
	baseDirectory = BASE_DIRECTORY;
}

	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
		
	String widthStr = request.getParameter("width");
	int width = 0;
	if(widthStr != null && widthStr.length() > 0) {
		try {
			width = Integer.parseInt(widthStr);
		}catch(Exception e) {
			width = 0;
		}
	}
	if(width == 0) {
		width = DEFAULT_MENU_WIDTH;
	}

	String showMenuStr = request.getParameter("showMenu");
	boolean showMenu = showMenuStr != null && showMenuStr.equals("true");
	String menuIds = request.getParameter("menuIds");
	String[] menuIdsArr = null;
	if(menuIds != null && menuIds.length() > 0) {
		menuIdsArr = menuIds.split(",");
	}
	String menuTexts = request.getParameter("menuTexts");
	String[] menuTextsArr = null;
	if(menuTexts != null && menuTexts.length() > 0) {
		menuTextsArr = menuTexts.split(",");
	}
	String menuHrefs = request.getParameter("menuHrefs");
	String[] menuHrefsArr = null;
	if(menuHrefs != null && menuHrefs.length() > 0) {
		menuHrefsArr = menuHrefs.split(",");
	}
%>


<script charset="iso-8859-1">
function initMenu<%=suffix%>(baseDirectory){
  var m = new dhtmlXContextMenuObject('40',0,baseDirectory + "dhtmlxSuite/dhtmlxMenu/codebase/imgs/");
  m.menu.setZIndex(200);
 //set css
  m.menu.tableCSS="menuTable";
  return m;
}

function initMenu<%=suffix%>() {
	<%	
	if (showMenu){
	%>
		aMenu<%=suffix%>=new dhtmlXContextMenuObject('<%=width %>','',"<%=baseDirectory%>dhtmlxSuite/dhtmlxMenu/codebase/imgs/");
		aMenu<%=suffix%>.menu.setZIndex(200);
			//set css
		aMenu<%=suffix%>.menu.tableCSS="menuTable";
						
		//create menu items
		var item;
		<%
		for(int i = 0; i < menuIdsArr.length; i++) {
		%>
			item = new dhtmlXMenuItemObject("<%=menuIdsArr[i] %>","<%=menuTextsArr[i] %>","","","contextMenu","","<%=menuHrefsArr[i] %>");
			aMenu<%=suffix%>.menu.addItem(aMenu<%=suffix%>.menu,item);
		<%
		}
		%>
		
		aMenu<%=suffix%>.setOnShowMenuHandler(onShowMenu<%=suffix%>);
	<%
	}
	%>
}

var contextRowId<%=suffix%> = "";
function onShowMenu<%=suffix%>(cell_id){  
	var arr = new Array();
  var index = cell_id.lastIndexOf("_");
  if (index <= 0) {
  	aMenu<%=suffix%>.menu.hideBar();
    return;
  }else {
    arr[0] = cell_id.substring(0,index);
    arr[1] = cell_id.substring(index+1);
  }                
   contextRowId<%=suffix%> = arr[0];
      
   if (!mygrid<%=suffix%>.doesRowExist(contextRowId<%=suffix%>)) {
   	aMenu<%=suffix%>.menu.hideBar();
     return;
   }
   mygrid<%=suffix%>.selectRowById(contextRowId<%=suffix%>);
   doButtonsOnRowSelected<%=suffix%>(contextRowId<%=suffix%>);
   
   aMenu<%=suffix%>.menu.hideButtons("<%=menuIds %>");
   
   handleMenuItems<%=suffix%>();
}

function handleMenuItems<%=suffix%>() {
}
addInitMenuFunction<%=suffix%>("initMenu<%=suffix%>()");
</script>