var POPUPS_ARE_BLOCKED;
var popupWaitCount = 0;
var DURING_TEST = false;
var DURING_CHROME_TEST = false;

var PopupWarning = {

	init : function(baseDirectory) {
		DURING_TEST = true;
		if(this.popups_are_disabled(baseDirectory) == true) {       
			return true;
		}else {
			DURING_TEST = false;
			return false;
		}
	},

	popups_are_disabled : function(baseDirectory) {
		var popup = window.open(baseDirectory + "widgets/popup/popupTest.html", "popup_tester", "width=1,height=1,left=0,top=0");
		if(!popup || popup.closed || typeof popup == 'undefined' || typeof popup.closed=='undefined') {
			POPUPS_ARE_BLOCKED = "true";
			DURING_TEST = false;
			return true;
		}

		window.focus();
		popup.blur();    

		//
		// Chrome popup detection requires that the popup validates itself 
		// - so we need to give
		// the popup time to load, then call js on the popup itself
		//
		if(navigator && (navigator.userAgent.toLowerCase()).indexOf("chrome") > -1) {
			DURING_CHROME_TEST = true;
			var on_load_test = function(){PopupWarning.test_chrome_popups(popup);};    
			var timer = setTimeout(on_load_test, 500);
			return;
		}
		    
		    
		popup.close();
		POPUPS_ARE_BLOCKED = "false";
		DURING_TEST = false;
		return false;
	},

	test_chrome_popups : function(popup) {
		if(popup && popup.chrome_popups_permitted && popup.chrome_popups_permitted() == true) {
			popup.close();
			POPUPS_ARE_BLOCKED = "false";
			DURING_CHROME_TEST = false;
			DURING_TEST = false;
			return true;
		}
		
		//
		// If the popup js fails - popups are blocked
		//
		POPUPS_ARE_BLOCKED = "true";
		DURING_CHROME_TEST = false;
		DURING_TEST = false;
	},
	
	is_running : function() {
		return DURING_TEST || DURING_CHROME_TEST;
	},
	
	is_blocked : function() {
		if(POPUPS_ARE_BLOCKED == null || typeof POPUPS_ARE_BLOCKED == "undefined" || POPUPS_ARE_BLOCKED == "true") {
			return true;
		}else {
			return false;
		}
	}
};