<%@ page language="java"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%

	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = BASE_DIRECTORY;
	}
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String style = request.getParameter("style");
	if (style == null || style.length() == 0){
		style = "xplgadmin";
	}
	boolean isAdminStyle = style.equals("xplgadmin");
	String defaultWidth = request.getParameter("width");
	if (defaultWidth == null || defaultWidth.length() == 0){
		defaultWidth = isAdminStyle ? "120" : "100";
	}
	
	String activeIndex = request.getParameter("activeIndex");
	String activeId = null;
	if (activeIndex != null && activeIndex.length() > 0){
		activeId = "tab" + suffix + "_" + activeIndex;
	}
	
	String width = request.getParameter("width");
	if (width == null || width.length() == 0){
		width = "100%";
	}
	
	String height = request.getParameter("height");
	if (height == null || height.length() == 0){
		height = "100%";
	}
	
	String menuObj = request.getParameter("menuObj");
	if (menuObj != null && menuObj.length() == 0){
		menuObj = null;
	}
	String useArrowStr = request.getParameter("useArrow");
	boolean useArrow = menuObj != null && useArrowStr != null && useArrowStr.equals("true");
	
	
	
	String offset = request.getParameter("offset");
	if (offset == null || offset.length() == 0){
		offset = "";
	}
%>
              
<% if (isAdminStyle){ %>
<style>
.dhx_tab_element_active{
    background-color: #F0F8FF;
    font-weight:bold;
    z-Index:70;    
    margin-top:3px;
    color:black;
}


.dhx_tab_element_inactive{
    font-weight:normal;
    z-Index:40;
 		color:white;
}

</style>
<%} %>     

<style>

   </style>        
<script>

function addXPLGTab<%=suffix%>(tabId,id,name,width){
 
  tabbar<%=suffix%>.addTab(tabId,name,width);
  tabbar<%=suffix%>.setContent(tabId,id);
}


function initTabsSection<%=suffix%>(){
  //document.getElementById("tabbarDiv" + suffix).style.backgroundColor = "#a4a4a4";
  tabbar<%=suffix%>=initTabSection("<%=baseDirectory%>","<%=suffix%>"); 
  tabbar<%=suffix%>.setStyle("<%=style%>");
  	<% if (menuObj != null){
  	if (useArrow){
  	%>   
   tabbar<%=suffix%>._TabCloseButtonSrc = "buttonDown.gif";
   <%}%>  
   tabbar<%=suffix%>.enableTabCloseButton(true);
   <%}%>
   
  if (typeof selectTabHandler<%=suffix%>=="function"){
    tabbar<%=suffix%>.setOnSelectHandler(selectTabHandler<%=suffix%>);
  }  
  
  
  <% if (offset.length() > 0){%>
   tabbar<%=suffix%>.setOffset(<%=offset%>);   
  <%}%>
  
  tabbar<%=suffix%>.setMargin(0);
  <%
  int i = 1;
  String tab = null;
  String [] ids = (String [])request.getAttribute("tabIds");
  String [] names = (String [])request.getAttribute("tabNames");
  String [] tabbarIds = (String [])request.getAttribute("tabbarIds");
  String [] widths = (String [])request.getAttribute("tabWidths");
  String id = ids != null &&  (i - 1) < ids.length ? ids[i - 1] : request.getParameter("id." + i);  
  while (id != null && id.length() > 0){
  	String name = names != null ? names[i -1] : request.getParameter("name." + i);
  	String w = widths != null ? widths[i - 1] : request.getParameter("width." + i);  	
  	if (w == null || w.length() == 0){
  		w = defaultWidth;
  		int wid = -1;
  		if (name.length() > 45){
  			wid= 300;
  		}else if (name.length() > 33){
  			wid = 250;
  		}else if (name.length() > 23){
  			wid = 200;
  		}else if (name.length() > 15){
  			wid = 160;
  		}
  		if (wid > 0){
  			w = String.valueOf(isAdminStyle ? wid + 20 : wid);
  		}
  	}
  	String tabId = tabbarIds != null ? tabbarIds[i - 1] : "tab" + suffix + "_" + i;
  	if ((activeId == null || activeId.length() == 0) && i == 1){
  		activeId = tabId;
  	}
  	
 %> 
  
  addXPLGTab<%=suffix%>("<%=tabId%>","<%=id%>","<%=name%>","<%=w%>");
  
<%
		i++;
		id = ids != null && (i - 1) < ids.length ? ids[i - 1] : request.getParameter("id." + i);
  }
  
  if (activeId != null){
  	%>
  	<% if (isAdminStyle){%>
  	updateTabsZIndex(tabbar<%=suffix%>);  
  	<%}%>
  	
  	 <% if (style.equals("patternadmin")){%>
  updatePatternAdminIndex(tabbar);
  <%}%>
  	
  	<% if (menuObj != null){%>
 
   
  	addMenuContext(tabbar<%=suffix%>,<%=menuObj%>,<%=String.valueOf(useArrow)%>);
  	<%}%>
  	tabbar<%=suffix%>.setTabActive("<%=activeId%>",true);     
  <%
  }
  %>
  
 
}



addInitTabsFunction("initTabsSection<%=suffix%>()");
</script>