<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%
  UserContext userContext = UserEnvironment.getUserContext(request);

  String ARCHIVE_PATH = "ARCHIVE_PATH";
  String ERROR_OBJ = "ERROR_OBJ";
  String CURRENT_LOG = "CURRENT_LOG";
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();


  String arch_file  = request.getParameter(ARCHIVE_PATH);

  //verify data
  ErrorModel errmodel = new ErrorModel();
  if(arch_file == null || arch_file.trim().equals("")){
    errmodel.addError("No archive file was supplied.");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }

  //here we will use xpolog builder for import -
  LogBrowsingManager lbm = null;
  File arch = new File(arch_file);
  try{
   ArchiveOperation archm = new ArchiveOperation();
   lbm = archm.extractFromUploadFile(request,arch);
   request.getSession().setAttribute(CURRENT_LOG,lbm);
  }catch(Exception e){
    ErrorModel errmod = new ErrorModel();
    errmod.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,errmod);
    response.sendRedirect("errorpage.jsp");
    return;
  }
      //audit
      AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
    	 			userContext, AuditConstants.CHANGE, "export wizard", AuditConstants.CONFIGURATION, "export wizard");	 	 	

  
  response.sendRedirect("importLogList.jsp");
%>


