<%@ page language="java"%>

<%@ page import="xpolog.eye.media.AddressBook"%>
<%@ page import="xpolog.eye.media.Account"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.controlers.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.scanner.WizardScannerViewControl"%>
<%@ page import="xpolog.eye.site.*" %>

<%!static final String BASE_DIRECTORY = "../../";%>
<%
	String PREFIX = "prefix";
	String LOCATION_TYPE = "locationType";
	String APP_DIR = "applicationDir";
	String ACCOUNT_ID = "accountId";
	String HOST = "host";
	String INCLUDE_FILES = "includeFiles";
	String EXCLUDE_FILES = "excludeFiles";
	String SUBDIRS_SCAN_LEVEL = "subdirScanLevel";
	String SCAN_METHOD = "scanMethod";

  int position = Integer.parseInt(request.getParameter(WizardConstants.VIEW_CONTROL_POSITION_PARAM));
  DefaultWizardBuilder builder =  (DefaultWizardBuilder)request.getSession().getAttribute(WizardConstants.WIZARD_BUILDER_SESSION_ATT);
  WizardApplicationViewControl view = (WizardApplicationViewControl)builder.getControler().getWizardViewControlByPosition(position,true);
  
  String prefix = request.getParameter(PREFIX);
  if(prefix == null) {
  	prefix = "";
  }
  String locationType = request.getParameter(prefix + LOCATION_TYPE);
  String appDir  = request.getParameter(APP_DIR);
  String host = request.getParameter(HOST);
  String accountId = request.getParameter(ACCOUNT_ID);
 	Account acc = AddressBook.getInstance().getAccountById(accountId);
  
	view.setLocationType(locationType);
	view.setRootDirectory(appDir);
  view.setHost(host);
	view.setAccount(acc);

  if(view instanceof WizardScannerViewControl){
  	WizardScannerViewControl _view = (WizardScannerViewControl)view;
    String includeFiles  = request.getParameter(INCLUDE_FILES);
    String excludeFiles = request.getParameter(EXCLUDE_FILES);
    String subdirScanLevelStr = request.getParameter(SUBDIRS_SCAN_LEVEL);
    int subdirScanLevel = 1000;
    if(subdirScanLevelStr != null && subdirScanLevelStr.length() > 0){
    	subdirScanLevel = Integer.parseInt(subdirScanLevelStr);
    }
    String scanMethodStr = request.getParameter(SCAN_METHOD);
    int scanMethod = scanMethodStr != null ? Integer.parseInt(scanMethodStr) : WizardScannerViewControl.SCAN_METHOD_ALL;
    
    String namePatternLogicStr = request.getParameter("namePatternLogic");
    int namePatternLogic = namePatternLogicStr != null && namePatternLogicStr.length() > 0? Integer.parseInt(namePatternLogicStr) : WizardScannerViewControl.NAME_PATTERN_LOGIC_AUTO;
        
    _view.setFilesToInclude(includeFiles);
    _view.setFilesToExclude(excludeFiles);
    _view.setSubdirsScanLevel(subdirScanLevel);
    _view.setScanMethod(scanMethod);
    _view.setNamePatternLogic(namePatternLogic);
  }
  final UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  final WizardApplicationViewControl viewFinal = view;

  final JobStatus finalStatus = new JobStatus();
  env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, finalStatus); 
  
  final String actionsURL = "okURL=wizards/common/wizardApplication.jsp?viewControlPosition=1";
  
  ProgressRunner runner = new ProgressRunner(view.getNext(true).getViewURL()) {
    public void run(HttpServletRequest request){

    	boolean suc = false;
    	try{
    			Thread.sleep(1000);
					viewFinal.setStatus(finalStatus);
				  suc = viewFinal.doNext();      	
				  if (!suc){
				  	errmodel = new ErrorModel();
				  	errmodel = viewFinal.getErrorModel();
				  	createErrorRedirect(request,BASE_DIRECTORY, actionsURL);
				  }
     }catch(Throwable e){
        e.printStackTrace();
        errmodel.addError("Scanning problem,please check directory path again.");
  			errmodel.addError(e.getMessage());
        createErrorRedirect(request,BASE_DIRECTORY, actionsURL);
      }
    }
 };
 env.setProgressRunner(runner);

%>
<%@page import="xpolog.eye.error.ErrorModel"%>
<%@page import="xpolog.eye.common.JobStatus"%>
<jsp:include page="../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
  <jsp:param name="message" value="Processing"/>
  <jsp:param name="useStatus" value="true"/>
  <jsp:param name="stopUrl" value="wizards/common/scannerStatusStopAction.jsp?stopScan=true"/>
</jsp:include>
