<%@ page language="java"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.common.JobStatus"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.nodes.* "%>
<%@ page import="xpolog.eye.admin.wizards.common.controlers.* "%>
<%@ page import="xpolog.eye.admin.wizards.common.scanner.WizardScannerResult "%>
<%@ page import="xpolog.eye.site.*"%>

<%!
static final String BASE_DIRECTORY = "../../"; 
%>

<%

		final String ERROR_OBJ = "ERROR_OBJ"; 
		String MODULE_ID = "MODULE_ID"; 
		
		SiteManagment mgmt = SiteManagment.getInstance();
		UserEnvironment env = UserEnvironment.getUserEnvironment(request);
		
		int position = Integer.parseInt(request.getParameter(WizardConstants.VIEW_CONTROL_POSITION_PARAM)); 
		DefaultWizardBuilder builder = (DefaultWizardBuilder)request.getSession().getAttribute(WizardConstants.WIZARD_BUILDER_SESSION_ATT);
		WizardListViewControl view = (WizardListViewControl)builder.getControler().getWizardViewControlByPosition(position,true); 
		WizardNode rootNode = view.getRootNode();
		List nodesList = new ArrayList(); 
		if (rootNode != null){ 
			nodesList = WizardUtil.getNodesAsList(rootNode);
		}
		
		//add the selected logs and modules 
		HashMap selectedIds = new HashMap(); 
		String [] selectedIdsArr = null; 
		String selectedIdsList = request.getParameter("selectedIds");
		
		if (selectedIdsList != null && selectedIdsList.length() > 0){ 
			selectedIdsArr = selectedIdsList.split("<<>>"); 
		}
		
		if (selectedIdsArr != null){ 
			for (int i = 0;i< selectedIdsArr.length;i++){ 
				String id = selectedIdsArr[i];
				if(id.endsWith("*")){
					selectedIds.putAll(WizardRenderer.getChildrensIds(rootNode,id.substring(0,id.length() - 1),null));
				}
				selectedIds.put(id,id);
			}
		}
		
		String modid = request.getParameter(MODULE_ID);
			
		if(modid == null || modid.trim().equals( "")){ 
			ErrorModel errmodel = new ErrorModel(); 
			errmodel.addError("No parent folder was selected. If no folder is available please check your permissions"); 
			request.getSession().setAttribute(ERROR_OBJ,errmodel);
			response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp"); 
			return; 
		}
		
		Module parent = mgmt.getModuleFromId(modid);
		rootNode.setValue(parent);
		HashSet nodesCheckedSet = new HashSet(); 
		Iterator it = selectedIds.keySet().iterator();
		while(it.hasNext()){ 			
			String selectNodeId = (String)it.next();	
			if(selectNodeId.endsWith("*")){
				selectNodeId = selectNodeId.substring(0,selectNodeId.length() -1);
			}
			String selectTemplateId = ""; 		
			int templateIndx = selectNodeId.indexOf("#"); 		
			if(templateIndx > 0 ){ 
				String _selecteNodeId = selectNodeId.substring(0,templateIndx);		
				selectTemplateId = selectNodeId.substring(templateIndx+1,selectNodeId.length());		
				selectNodeId = _selecteNodeId;		
				//remove from set to re-init the template in node 
				nodesCheckedSet.remove(selectNodeId);		
			}		
			boolean foundNode = false; 		
			for(int k = 0 ; !foundNode && k < nodesList.size(); k++){ 
				WizardUtil.NodeInfo info = (WizardUtil.NodeInfo)nodesList.get(k);
				WizardNode node = info.node;			
				String id = node.getID().replaceAll("\\\\","/"); 			
				if(nodesCheckedSet.contains(id)){ 
					continue; 
				}			
				if(id.equals(selectNodeId)){ 
					node.setSelected(true); 
					foundNode = true; 
					nodesCheckedSet.add(id);		
					if(selectTemplateId != null && selectTemplateId.length() > 0){ 					
						if(node instanceof WizardScannerResult){ 
							WizardScannerResult _node = (WizardScannerResult)node;						
							_node.setTemplateId(selectTemplateId);
						}
					}
				}	else if(id.equals("ROOT" )){ 
							node.setSelected(true); 
							nodesCheckedSet.add(id);
						}else{ 
							node.setSelected(false); 
						}
			}
		}
						
		final WizardListViewControl viewFinal = view; 
		final JobStatus finalStatus = new JobStatus(); 
		env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, finalStatus); 
		
		String parentApplication =  request.getParameter("parentApplication");
	  if (parentApplication == null){
	  	parentApplication = "";
	  }
	  final String [] appIds = parentApplication.length() == 0 ? new String[0] : parentApplication.split("\\#");
		
		ProgressRunner runner = new ProgressRunner(view.getNext(true).getViewURL()) { 
		public void run(HttpServletRequest request){ 
			try{ 
				viewFinal.setStatus(finalStatus);
				viewFinal.setApplicationsIds(appIds);
				boolean suc = viewFinal.doNext(); 
				if (!suc){ 
					errmodel = new ErrorModel(); 
					errmodel = viewFinal.getErrorModel();
					createErrorRedirect(request,BASE_DIRECTORY);
				}
			}catch(Exception e){ 
				e.printStackTrace();
				errmodel.addError("Problems while creating the selected logs."); 
				errmodel.addError(e.getMessage());
				createErrorRedirect(request,BASE_DIRECTORY);
			}
		}
		};
		env.setProgressRunner(runner);

%>
	<%@page import="xpolog.eye.site.ui.tree.WizardRenderer"%>
<jsp:include page="../../common/actionProgress.jsp" flush="true">
	<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>" />
	<jsp:param name="message" value="Creating selected logs" />
	<jsp:param name="useStatus" value="true" />
</jsp:include>




