<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.wizards.generator.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.nodes.WizardModuleNode"%>
<%@ page import="xpolog.eye.repository.*"%>


<%@ page import="java.util.*"%>

<%! 
	static final String BASE_DIRECTORY = "../../";
%>

<%
  String ERROR_OBJ = "ERROR_OBJ";

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  UserContext userContext = UserEnvironment.getUserContext(request);
	WizardGeneratorBuilder builder = (WizardGeneratorBuilder)request.getSession().getAttribute(WizardGeneratorBuilder.WIZARD_GENERATOR_BUILDER_TAG);
	String repInfoId = request.getParameter("repInfoId");
	String objectId = request.getParameter("objectId");
	String xplgObjectType = request.getParameter("xplgObjectType");
	String repInfoName = "", repInfoVersion = "", repInfoDesc = "", repInfoBuildStr = "";
	int repInfoBuild = 0;
	RepositoryInfo repInfo = null;
	if (repInfoId != null && repInfoId.length() > 0){
		repInfo = builder.getRepositoryInfoById(repInfoId);
		if (repInfo != null){
			xplgObjectType = repInfo.getXplgObjectType();
			repInfoName = repInfo.getName();
			repInfoDesc = repInfo.getDesc();
			repInfoVersion = repInfo.getVersion();
			repInfoBuild = repInfo.getBuild();
			if (repInfoBuild > 0){
				repInfoBuildStr = String.valueOf(repInfoBuild);
			}
			if (objectId == null || objectId.length() == 0){
				objectId = builder.getRepositoryInfoObjectId(repInfoId);
			}
		}
	}
	
%>


<html>

<head>
<title> Edit repository info repository </title>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />

<script>
   function doOK(){
    	document.access.submit();
    	//window.close();
   }
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" action="dataRepositoryInfoAction.jsp">
<input type="hidden" name="objectId" value="<%=objectId%>">
<input type="hidden" name="xplgObjectType" value="<%=xplgObjectType%>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">              
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="28"><span class="HEADER">Edit repository info </span><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td>
                    	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse">
                    		<tr>
                    			<td><span class="REGULARTEXT">Repository log id:&nbsp;&nbsp;</span></td>
                    			<td><span class="REGULARTEXT"><input type="text" name="repInfoId" size="20" value="<%=repInfoId%>"></span></td>
                    		</tr>
                    		<tr>
                    			<td><span class="REGULARTEXT">name: </span></td>
                    			<td><span class="REGULARTEXT"><input type="text" name="repInfoName" size="20" value="<%=repInfoName%>"></span></td>
                    		</tr>
                    		<tr>
                    			<td><span class="REGULARTEXT">description: </span></td>
                    			<td><span class="REGULARTEXT"><input type="text" name="repInfoDesc" size="20" value="<%=repInfoDesc%>"></span></td>
                    		</tr>
                    		<tr>
                    			<td><span class="REGULARTEXT">version: </span></td>
                    			<td><span class="REGULARTEXT"><input type="text" name="repInfoVersion" size="20" value="<%=repInfoVersion%>"></span></td>
                    		</tr>
                    		<tr>
                    			<td><span class="REGULARTEXT">build: </span></td>
                    			<td><span class="REGULARTEXT"><input type="text" name="repInfoBuild" size="20" value="<%=repInfoBuildStr%>"></span></td>
                    		</tr>
                    	</table>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%">&nbsp;</td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="30%">&nbsp;</td>
            <td width="150" align="center">
              <table border="0" width="100%">
                <tr>
                  <td width="40%"><a href="javascript:window.close()" class="LINK">cancel</a></td>
                  <td width="40%">
                    <p align="center"><a href="javascript:doOK()" class="LINK">ok</a></td>
                  <td width="*">&nbsp;</td>
                </tr>
              </table>
            </td>
            <td width="20%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>

</body>
</html>