<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.admin.wizards.generator.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="java.util.*"%>
<%@page import="xpolog.eye.admin.wizards.common.WizardSignature"%>
<%@page import="xpolog.eye.admin.wizards.common.signatures.*"%>
<%! 
	static final String BASE_DIRECTORY = "../";
%>
     
<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.ConfigurationPermissions.WIZARD_GENERATION_PERMISSION,true)){
		return;
	}
	
	String ERROR_OBJ = "ERROR_OBJ";
	
	WizardGeneratorBuilder builder = (WizardGeneratorBuilder)request.getSession().getAttribute(WizardGeneratorBuilder.WIZARD_GENERATOR_BUILDER_TAG);
	String appName = builder != null ? builder.getApplicationName() : "";
	if (appName == null){
		appName = "";
	}
	String desc = builder != null ? builder.getDesc() : "";
	if (desc == null){
		desc = "";
	}
	Properties properties = builder.getProperties();
	Properties predefinedProps = builder.getPredefinedProps();
	int propSize = properties != null ? properties.size() : 0;
	HashMap signatures = builder.getWizardSignatures();
%>
<input type="hidden" id="numberOfWizProps" name="numberOfWizProps" value="<%=propSize%>"/>
<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";

	function addNewWizProp(){
		document.getElementById("NewWizPropTableHeader").style.display = "";
		var ni = document.getElementById("newWizProps");
		var numi = document.getElementById("numberOfWizProps");
		var num = (document.getElementById("numberOfWizProps").value -1)+ 2;
		numi.value = num;
		var divIdName = "newWizProp"+num+"Div";
		var newdiv = document.createElement('div');
		newdiv.setAttribute("id",divIdName);
		newdiv.innerHTML = "<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">"+
                       "<tr><td width=\"20%\" valign=\"top\" nowrap><span class=\"REGULARTEXT\">"+
                       "<input type=\"text\" name=\"wiz_key_"+num+"\" id=\"wiz_key_"+num+"\" size=\"20\">"+
                       "</span></td>"+
                       "<td width=\"80%\">"+
	                     "<input type=\"text\" name=\"wiz_value_"+num+"\" id=\"wiz_value_"+num+"\" size=\"20\">"+
	                     "&nbsp;<span class=\"LINK\"><a href=\"javascript:;\" onclick=\"javascript:removeWizEvent(\'"+divIdName+"\')\">&nbsp;remove</a></link>"+
                       "</td></tr></table>";
		ni.appendChild(newdiv);
	}

	function removeWizEvent(divNum){
		var d = document.getElementById('newWizProps');
		var olddiv = document.getElementById(divNum);
		d.removeChild(olddiv);
		num = document.access.numberOfWizProps.value;
		if (!document.getElementById("newWizProp"+num+"Div")){
			document.getElementById("NewWizPropTableHeader").style.display = "none";
		}
	}

</script>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
	            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
	              <tr>
	                <td width="15%" height="28" colspan="3"><span class="HEADER">Wizard General Information</span></td>
	              </tr>
	              <tr>
	              	<td>&nbsp;</td>
	              </tr>
	              <tr>
	              	<td>
	              		<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	              			<tr>
	              				<td width="150"><span class="REGULARTEXT">Application name: </span></td>
	              				<td><span class="REGULARTEXT"><input type="text" name="appName" id="appName" class="REGULARTEXT" size="30" value="<%=appName%>"></span></td>
	              			</tr>
	              			<tr>
	              				<td colspan="2" style="font-size: 2px">&nbsp;</td>
	              			<tr>
	              				<td width="150"><span class="REGULARTEXT">Application description: </span></td>
	              				<td><span class="REGULARTEXT"><input type="text" name="appDesc" id="appDesc" class="REGULARTEXT" size="50" value="<%=desc%>"></span></td>
	              			</tr>
	              		</table>
	              	</td>
	              </tr>


								<tr>
									<td>&nbsp;</td>
								</tr>
                <tr>
                  <td width="15%" height="28"><span class="HEADER">Properties</span></td>
                </tr>
								<tr>
									<td>
										<div id="newWizProps">
										<%if (properties != null){
											Iterator it = properties.keySet().iterator();
											int i = 1;
											while (it.hasNext()){
												String key = (String)it.next();
												String value = properties.getProperty(key);
												boolean isPredefined = predefinedProps != null && predefinedProps.containsKey(key);
											%>
											<div id="newWizProp<%=i%>Div">
											<table border="0" width="100%" cellspacing="0" cellpadding="0">
						            <tr>
					  	          	<td colspan="2"><span style="font-size:2px">&nbsp;<span></td>
					    	        </tr>
												<tr>
													<td width="130" valign="top" nowrap>
														<span class="REGULARTEXT"><%=key%>&nbsp;</span>
														<input type="hidden" name="wiz_key_<%=i%>" id="key_<%=i%>" value="<%=key%>">
													</td>
													<td>
														<input type="text" name="wiz_value_<%=i%>" id="value_<%=i%>" value="<%=value%>" size="20">
														<%if (!isPredefined){ %>
														&nbsp;<span class="LINK"><a href="javascript:;" onclick="removeWizEvent('newWizProp<%=i%>Div')">&nbsp;remove</a>
														<%}%>
													</td>
												</tr>
											</table>
											</div>
											<%
												i++;
												}
											}%>
											<table border="0" width="100%" cellspacing="0" cellpadding="0">
						            <tr><td>&nbsp;</td></tr>
												<tr><td><a href="javascript:addNewWizProp()" class="LINK">add new property</a></td></tr>
												<tr>
													<td>
														<table id="NewWizPropTableHeader" border="0" width="100%" cellspacing="0" cellpadding="0" style="display:none">
															<tr><td colspan="2"><span style="font-size:2px">&nbsp;<span></td></tr>
															<tr>
																<td width="130" valign="top" bgcolor="#FFB13E">
																	<span class="REGULARTEXT">&nbsp;type</span>
																</td>
																<td valign="top" bgcolor="#FFB13E">
																	<span class="REGULARTEXT">&nbsp;value</span>
																</td>
															</tr>
															<tr><td colspan="2"><span style="font-size:2px">&nbsp;<span></td></tr>
														</table>
													</td>
												</tr>
											</table>
										</div>
									</td>
								</tr>
	          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		