<%@ page language="java"%>

<%@ page import="xpolog.eye.admin.wizards.generator.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.nodes.WizardModuleNode"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.template.TemplateManager"%>
<%@ page import="xpolog.eye.meta.MetaDataCategoriesManager"%>
<%@ page import="xpolog.eye.meta.MetaDataCategory"%>
<%@ page import="xpolog.eye.template.Template"%>

<%!
  static final String BASE_DIRECTORY = "../../../";
%>
<%
  
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
	WizardGeneratorBuilder builder = (WizardGeneratorBuilder)request.getSession().getAttribute(WizardGeneratorBuilder.WIZARD_GENERATOR_BUILDER_TAG);
  WizardNode[] wizNodeArr = builder.getWizardModuleNodes();
	String parentWizardNodeId = request.getParameter("parentId");

  SiteManagment mgmt = SiteManagment.getInstance();
  TemplateManager tmg = mgmt.getTemplateManager();
  MetaDataCategoriesManager mdcmgr = mgmt.getMetaDataCategoriesManager();
  UserContext userContext = UserEnvironment.getUserContext(request);

  String categoryId = request.getParameter("CategoryId");
  if (categoryId == null || categoryId.equals("")){
  	categoryId = MetaDataCategory.ROOT_CATEGORY_ID;
  }
  MetaDataCategory cat = mdcmgr.getMetaDataCategory(categoryId);
  String letterSysTemplate = request.getParameter("LetterSysTemplate");
  if (letterSysTemplate == null || letterSysTemplate.equals("")){
  	letterSysTemplate = "all";
  }
  String letterUserTemplate = request.getParameter("LetterUserTemplate");
  if (letterUserTemplate == null || letterUserTemplate.equals("")){
  	letterUserTemplate = "all";
  }

  Template[] tsysarr = tmg.getAllSystemTemplates(userContext);
  Template[] tusrarr = tmg.getAllUserTemplates(userContext);
	
  
%>

<%@page import="xpolog.eye.template.TemplateHelper"%>
<html>
<head>
	<title> Log template selection </title>
	<meta http-equiv="Content-Language" content="en-us">
	<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
	<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
	<META HTTP-EQUIV="EXPIRES" CONTENT="0">
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />

<script>
    baseDirectory = "<%=BASE_DIRECTORY%>";
    var firstTime = true;

   function doSelect(id){
   		document.access.templateId.value = id;
			document.access.action="logTemplateSelectionAction.jsp";
    	document.access.submit();
   }
</script>
</head>

<body>
	<form AUTOCOMPLETE="OFF" id="access" name="access" method="POST">
	<input type="hidden" name="templateId">
		<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
		  <tr valign="top">
		    <td width="100%">
		    <table border="0" width="100%" cellspacing="0" cellpadding="0">
		      <tr>
		        <td valign="top" height="100%">
		        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
		          <tr>
		            <td width="100%">
		            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
		              <tr>
		                <td width="3%" class="TOPLEFTBORDER ">&nbsp;</td>
		                <td width="96%" class="TOPBORDER">
		                	<span class="PAGEHEADER">Log Templates</span>
		                </td>
		                <td width="1%" class="TOPRIGHTBORDER">&nbsp;</td>
		              </tr>
	               	<%if (wizNodeArr != null && (wizNodeArr.length > 1 || (wizNodeArr.length == 1 && !wizNodeArr[0].getID().equals("ROOT")))){ %>
		              <tr>
		                <td width="3%">&nbsp;</td>
		                <td width="96%">&nbsp;</td>
		                <td width="1%">&nbsp;</td>
		              </tr>
		              <tr>
		                <td width="3%">&nbsp;</td>
		                <td width="97%" colspan="2">
		                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
		                  <tr>
		                    <td width="15%" height="18"><span class="HEADER">General</span></td>
		                  </tr>
		                  <tr>
		                    <td width="15%" height="18"></td>
		                  </tr>
		                  <tr>
		                    <td width="15%" height="22">
		                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
		                      <tr>
		                        <td width="30%"><span class="REGULARTEXT">Parent wizard node&nbsp;&nbsp;</span></td>
		                        <td width="70%">
		                        <select size="1" class="TEXTBOX" name="parentModuleId">
		                          <%
		                            String selected = "";
		                            for(int i=0;i<wizNodeArr.length;++i){
		                              if(parentWizardNodeId != null && wizNodeArr[i].getID().equals(parentWizardNodeId)){
		                                selected = "selected=\"true\"";
		                              }else{
		                                selected = "";
		                              }
		                            %>
		                            <option class="TEXTBOX" value="<%=wizNodeArr[i].getID()%>" <%=selected%>><%=wizNodeArr[i].getName()%></option>
		                          <%}%>
		                        </select>
		                        </td>
		                      </tr>
						              <tr>
						                <td colspan="2">&nbsp;</td>
						            	</tr>
						            </table>
							          </td>
							        </tr>
							      </table>
							    	</td>
							  	</tr>
							  	<%} %>

		              <tr>
		                <td colspan="3">&nbsp;</td>
		              </tr>
		              <tr>
		                <td width="3%">&nbsp;</td>
		                <td width="97%" colspan="2">
		                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
		                  <tr>
		                    <td><span class="HEADER">User defined templates</span></td>
		                  </tr>
		                  <tr><td></td></tr>
		                  <tr>
		                    <td>
		                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
		                      <tr class="TABLES_HEADERS">
		                        <td width="40%"><span class="REGULARTEXT">Name</span></td>
		                        <td width="40%"><span class="REGULARTEXT">Description</span></td>
		                        <td width="20%">&nbsp;</td>
		                      </tr>
		                     <%
												  if (!(letterUserTemplate.equals("all"))){
												  	tusrarr = TemplateHelper.getAllTemplatesByFilter(tusrarr,null,letterUserTemplate);
												  }
		                      for(int t=0;t<tusrarr.length;t++){
		                     %>
		                      <tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
					  								<td width="40%"><a href="javascript:doSelect('<%=tusrarr[t].getId()%>')" class="LINK"><%=tusrarr[t].getName()%></a></td>
		                        <td width="40%"><span class="REGULARTEXT"><%=tusrarr[t].getDescription()%></span></td>
		                        <td width="20%">&nbsp;<a href="javascript:doSelect('<%=tusrarr[t].getId()%>')" class="LINK">select</a></td>
		                       </tr>
		                      <%
		                        }
		                      %>
													<tr>
					  								<td colspan="3">&nbsp;</td>
		                      </tr>
		                    </table>
		                   </td>
		                  </tr>
		                  <tr>
		                    <td></td>
		                  </tr>
		                  <tr>
		                    <td>
			                    <span class="HEADER">System defined templates</span>
		                    </td>
		                  </tr>
		                  <tr><td></td></tr>
		                  <tr>
		                    <td>
		                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
		                      <tr class="TABLES_HEADERS">
		                        <td width="40%"><span class="REGULARTEXT">Name</span></td>
		                        <td width="40%"><span class="REGULARTEXT">&nbsp; Description</span></td>
		                        <td width="20%">&nbsp;</td>
		                      </tr>
		                     <%
												  if (!categoryId.equals(MetaDataCategory.ROOT_CATEGORY_ID) || !(letterSysTemplate.equals("all"))){
												  	tsysarr = TemplateHelper.getAllTemplatesByFilter(tsysarr,categoryId,letterSysTemplate);
												  }
		                      for(int i=0;i<tsysarr.length;i++){
		                     %>
		                      <tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
													  <td width="40%"><a href="javascript:doSelect('<%=tsysarr[i].getId()%>')" class="LINK"><%=tsysarr[i].getName()%></a></td>
		                        <td width="40%"><span class="REGULARTEXT">&nbsp;<%=tsysarr[i].getDescription()%></span></td>
		                        <td width="20%">&nbsp;<a href="javascript:doSelect('<%=tsysarr[i].getId()%>')" class="LINK">select</a></td>
		                       </tr>
		                      <%}%>
		                      <tr>
					  								<td colspan="3">&nbsp;</td>
		                      </tr>
		                    </table>
		                    </td>
		                  </tr>


		                  <tr>
		                    <td>&nbsp;</td>
		                  </tr>
								      <tr>
								        <td valign="bottom" height="10%">
								        <table border="0" width="100%">
								          <tr>
								            <td width="30%">&nbsp;</td>
								            <td width="150" align="center">
								              <table border="0" width="100%">
								                <tr>
								                  <td width="40%"><a href="javascript:window.close()" class="LINK">cancel</a></td>
								                  <td width="40%">
								                    <p align="center"><a href="javascript:doOK()" class="LINK">ok</a></td>
								                  <td width="*">&nbsp;</td>
								                </tr>
								              </table>
								            </td>
								            <td width="20%">&nbsp;</td>
								          </tr>
								        </table>
								        </td>
								      </tr>
		                </table>
		                </td>
		              </tr>
		            </table>
		            </td>
		          </tr>
		        </table>
		        </td>
		      </tr>
		    </table>
		    </td>
		  </tr>
		</table>
	</form>
	</body>
</html>