
function writeWizardNodeData(node){ 
  if (!node.isLeaf()){
    var img = baseDirectory + (node.expand ? collapseImage : expandImage);  
    document.writeln("<img src=\"" + img + "\" onClick=\"javascript:selectNode(" + node.index + "," + node.tree.name + ")\" id=\"ExpandImage_" + this.name + "_" + node.index + "\"  class=\"" + node.tree.nodeImageStyle + "\">");
  }
  document.writeln("<input type=\"radio\" name=\"" + node.chkKey + "\" value=\""+node.id +"\" id=\"CheckBox_" + this.name + "_" + node.index + "\"" + (node.selected ? " checked" : "") +  " onClick=\"javascript:markNode(" + node.index + "," + node.tree.name + ")\"" + (node.disable ? " disabled" : "") + ">");
  document.writeln("&nbsp;" + node.name);
  if (node.desc && node.desc != ""){
     document.writeln("&nbsp;(" + node.desc + ")");
  }
  if (node.text && node.text != ""){
     document.writeln("&nbsp;" + node.text);
  }  
}


function selectWizardTreeNode(node){
	if (node.childs && node.childs.length > 0|| !node.actionUrl){
		var expand = !node.expand;	
		node.expand = expand;
		var expImage = document.getElementById("ExpandImage_" + node.tree.name + "_" + node.index);
		if (expImage){
		  expImage.src = baseDirectory + (expand ? collapseImage : expandImage);
		}
		for (var i = 0; i < node.childs.length; i++){
	 		var childDiv = document.getElementById("DivNode_" + node.childs[i].tree.name + "_" + node.childs[i].index);
		  if (childDiv){
		    if (expand){
	 		    childDiv.style.display = "";
		    }else {
	 		    childDiv.style.display = "none";
		    }
		  }
		}
	}else {
		eval("document.frames['" + node.actionTarget + "']").location = node.actionUrl;
	}	
}

Tree.prototype.writeNodeData = writeWizardNodeData;
Tree.prototype.selectTreeNode = selectWizardTreeNode;