<%@ page language="java"%>

<%@ page import="xpolog.eye.admin.wizards.generator.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%!
  static final String BASE_DIRECTORY = "../../../";
%>
<%
  
  String WIZARD_NODE_ID = "WIZARD_NODE_ID";
  String ERROR_OBJ = "ERROR_OBJ";
  String TYPE_LOG = "Log";

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  UserContext userContext = UserEnvironment.getUserContext(request);
	WizardGeneratorBuilder builder = (WizardGeneratorBuilder)request.getSession().getAttribute(WizardGeneratorBuilder.WIZARD_GENERATOR_BUILDER_TAG);
  WizardNode[] wizNodeArr = builder.getWizardModuleNodes();
	String parentWizardNodeId = request.getParameter("parentId");

  String wizardNodeId = request.getParameter(WIZARD_NODE_ID);
  if (wizardNodeId != null){
  	wizardNodeId = "";
  }
 
%>

<html>
<head>
	<title> Select Appliction Class </title>
	<meta http-equiv="Content-Language" content="en-us">
	<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
	<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
	<META HTTP-EQUIV="EXPIRES" CONTENT="0">
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />

<script>
    baseDirectory = "<%=BASE_DIRECTORY%>";
    var firstTime = true;

   function doOK(){
   		document.access.action="scannerNodeSelectionAction.jsp";
    	document.access.submit();
   }
</script>
</head>

<body>
	<form AUTOCOMPLETE="OFF" id="access" name="access" method="POST" >
		<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
		  <tr valign="top">
		    <td width="100%">
		    <table border="0" width="100%" cellspacing="0" cellpadding="0">
		      <tr>
		        <td valign="top" height="100%">
		        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
		          <tr>
		            <td width="100%">
		            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
		              <tr>
		                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
		                <td width="55%" class="TOPBORDER">
		                <span class="PAGEHEADER">Select Appliction Class</span></td>
		                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
		              </tr>
		              <tr>
		                <td width="3%">&nbsp;</td>
		                <td width="24%">&nbsp;</td>
		                <td width="100%">&nbsp;</td>
		              </tr>
		              <tr>
		                <td width="3%">&nbsp;</td>
		                <td width="147%" colspan="2">
		                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
		                  <tr>
		                    <td width="15%" height="18"><span class="HEADER">General</span></td>
		                  </tr>
		                  <tr>
		                    <td width="15%" height="18"></td>
		                  </tr>
		                  <tr>
		                    <td width="15%" height="22">
		                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
					               	<%if (wizNodeArr != null && (wizNodeArr.length > 1 || (wizNodeArr.length == 1 && !wizNodeArr[0].getID().equals("ROOT")))){ %>
		                      <tr>
		                        <td width="30%"><span class="REGULARTEXT">Parent wizard node&nbsp;&nbsp;</span></td>
		                        <td width="70%">
		
		                        <select size="1" class="TEXTBOX" name="parentModuleId">
		                          <%
		                            String selected = "";
		                            for(int i=0;i<wizNodeArr.length;++i){
		                              if(parentWizardNodeId != null && wizNodeArr[i].getID().equals(parentWizardNodeId)){
		                                selected = "selected=\"true\"";
		                              }else{
		                                selected = "";
		                              }
		                            %>
		                            <option class="TEXTBOX" value="<%=wizNodeArr[i].getID()%>" <%=selected%>><%=wizNodeArr[i].getName()%></option>
		                          <%}%>
		                        </select></td>
		                      </tr>
			              			<tr>
			              				<td colspan="2" style="font-size: 2px">&nbsp;</td>
			              			<tr>
			              			<%} %>
		                      <tr>
		                        <td width="30%"><span class="REGULARTEXT">Class Name </span></td>
		                        <td width="70%">
		                        <input type="text" name="className" size="30" class="TEXTBOX"></td>
		                      </tr>
			              			<tr>
			              				<td colspan="2" style="font-size: 2px">&nbsp;</td>
			              			<tr>
		                      <tr>
		                        <td width="30%"><span class="REGULARTEXT">Full Class Path </span></td>
		                        <td width="70%">
		                        <input type="text" name="fullClassPath" size="53" class="TEXTBOX"></td>
		                      </tr>		                       
			              			<tr>
			              				<td colspan="2" style="font-size: 2px">&nbsp;</td>
			              			<tr>
		                      <tr>
		                        <td width="30%"><span class="REGULARTEXT">Root Class Path </span></td>
		                        <td width="70%">
		                        <input type="text" name="rootClassPath" size="53" class="TEXTBOX"></td>
		                      </tr>
		                    </table>
		                    </td>
		                  </tr>
		                  <tr>
		                    <td>&nbsp;</td>
		                  </tr>
								      <tr>
								        <td valign="bottom" height="10%">
								        <table border="0" width="100%">
								          <tr>
								            <td width="30%">&nbsp;</td>
								            <td width="150" align="center">
								              <table border="0" width="100%">
								                <tr>
								                  <td width="40%"><a href="javascript:window.close()" class="LINK">cancel</a></td>
								                  <td width="40%">
								                    <p align="center"><a href="javascript:doOK()" class="LINK">ok</a></td>
								                  <td width="*">&nbsp;</td>
								                </tr>
								              </table>
								            </td>
								            <td width="20%">&nbsp;</td>
								          </tr>
								        </table>
								        </td>
								      </tr>
		                </table>
		                </td>
		              </tr>
		            </table>
		            </td>
		          </tr>
		        </table>
		        </td>
		      </tr>
		    </table>
		    </td>
		  </tr>
		</table>
	</form>
	</body>
</html>