<%@ page language="java"%>

<%@ page import="xpolog.eye.reports.ReportsManager"%>
<%@ page import="xpolog.eye.reports.Report"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.admin.wizards.generator.WizardGeneratorBuilder"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>


<%
	String ERROR_OBJ = "ERROR_OBJ";

	String parentId = request.getParameter("parentModuleId");
	if (parentId == null){
		parentId = "";
	}
	String reportId = request.getParameter("reportId");
	String useLogReportsStr = request.getParameter("useLogReports");
	boolean useLogReports = useLogReportsStr != null && useLogReportsStr.equals("true");
  
	ReportsManager repMgr = ReportsManager.getInstance();
	Report report = repMgr.getReportById(reportId);
	String[] logIds = null;
	if (report == null){
		ErrorModel errmodel = new ErrorModel();
		errmodel.addError("Failed to get report for id " + reportId);
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?closeWindow=true");
	}else{
		logIds = WizardGeneratorBuilder.getReportLogs(reportId);
	}

	StringBuffer sb = new StringBuffer();
	String repLogId = null;
	if (logIds != null){
		for (int i=0; i<logIds.length; i++){
			repLogId = request.getParameter(logIds[i]);
			if (repLogId != null){
				if (sb.length() > 0){
					sb.append(",");
				}
				sb.append(logIds[i]+"="+repLogId);
			}
		}
	}
  
%>
<html>
<head>
<script language="javascript">
function display(){
  if (opener){
  	opener.selectReport("<%=reportId%>","<%=parentId%>","<%=useLogReports%>","<%=sb.toString()%>");
  }
  window.close();
}		
</script>
</head>
<body onLoad="display()">
</body>
</html>

