<%@ page language="java"%>

<%@ page import="xpolog.eye.admin.wizards.generator.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.repository.*"%>
<%@ page import="xpolog.eye.reports.ReportsManager"%>
<%@ page import="xpolog.eye.reports.Report"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>

<%! 
	static final String BASE_DIRECTORY = "../../../";
%>
     
<%

	String ERROR_OBJ = "ERROR_OBJ";

	WizardGeneratorBuilder builder = (WizardGeneratorBuilder)request.getSession().getAttribute(WizardGeneratorBuilder.WIZARD_GENERATOR_BUILDER_TAG);
	String parentId = request.getParameter("parentModuleId");
	if (parentId == null){
		parentId = "";
	}
	String reportId = request.getParameter("reportId");
	ReportsManager repMgr = ReportsManager.getInstance();
	Report report = repMgr.getReportById(reportId);
	String[] logIds = null;
	if (report == null){
		ErrorModel errmodel = new ErrorModel();
		errmodel.addError("Failed to get report for id " + reportId);
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?closeWindow=true");
	}else{
		logIds = WizardGeneratorBuilder.getReportLogs(reportId);
	}

	
	String useLogReportsStr = request.getParameter("useLogReports");
	boolean useLogReports = useLogReportsStr != null && useLogReportsStr.equals("true");
	

	RepositoryInfo[] repInfos = builder.getAllRepositoryInfos();
	if (repInfos == null || repInfos.length == 0){
		ErrorModel errmodel = new ErrorModel();
		errmodel.addError("Report logs must be matched to existing repository logs");
		errmodel.addError("Please add repository logs first");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?closeWindow=true");
	}
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
   function doOK(){
			document.access.action="reportSelectionAction.jsp";
    	document.access.submit();
   }
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<input type="hidden" name="reportId" value="<%=reportId%>">
<input type="hidden" name="useLogReports" value="<%=useLogReports%>">
<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="100%" id="AutoNumber1">
	<tr>
		<td width="100%">
    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="90%" id="AutoNumber2">
			<tr>
        <td width="15%" height="28" colspan="3"><span class="HEADER">Data Repository</span></td>
      </tr>
      <tr>
      	<td><span class="REGULARTEXT">Please select for each report log a repository log</span></td>
      </tr>
      <tr>
      	<td>
     		<table border="0">
   			<%
   			SiteManagment mgmt = SiteManagment.getInstance();
   			LogBrowsingManager lbm = null;
   			for (int i=0; i<logIds.length; i++){
   				lbm = mgmt.getLogBrowserManager(logIds[i]);
   				if (lbm == null){
   					ErrorModel errmodel = new ErrorModel();
   					errmodel.addError("Failed to report log " + logIds[i]);
   					request.getSession().setAttribute(ERROR_OBJ,errmodel);
   					response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?closeWindow=true");
   				}
   				String logName = lbm.getName();
   			%>
    			<tr>
     				<td><span class="REGULARTEXT"><%=logName%> - matching repository log: </span></td>
     				<td>
     					<select id="<%=lbm.getId()%>" name="<%=lbm.getId()%>">
     					<%for (int j=0; j<repInfos.length; j++){%>
     						<option value="<%=repInfos[j].getId()%>"><%=repInfos[j].getName()%></option>
    					<%}%>
     					</select>
     				</td>
     			</tr>
     			<%}%>
     		</table>
        </td>
      </tr>
      <tr>
        <td height="100%">&nbsp;</td>
      </tr>
      <tr>
        <td valign="bottom">
        <table border="0" width="100%">
          <tr>
            <td width="30%">&nbsp;</td>
            <td width="150" align="center">
              <table border="0" width="100%">
                <tr>
                  <td width="40%"><a href="javascript:window.close()" class="LINK">cancel</a></td>
                  <td width="40%">
                    <p align="center"><a href="javascript:doOK()" class="LINK">ok</a></td>
                  <td width="*">&nbsp;</td>
                </tr>
              </table>
            </td>
            <td width="20%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
  	</td>
 	</tr>
</table>
</form>
</body>

</html>