<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.wizards.generator.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.nodes.WizardModuleNode"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,null,true)){
		return;
	}

  String ERROR_OBJ = "ERROR_OBJ";
  ErrorModel errmodel = new ErrorModel();
  
  SiteManagment mgmt = SiteManagment.getInstance();
  UserContext userContext = UserEnvironment.getUserContext(request);
  
  boolean txExpoViewer = mgmt.getXpologManagment().isTransactionExpoValid();
  
	String selectedTabId = request.getParameter("selectedTabId");
	if (selectedTabId == null || selectedTabId.length() == 0){
		selectedTabId = "0";
	}
	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	if (systemMetaDataId == null){
		systemMetaDataId = "";
	}

	String wizardNodeParentId = request.getParameter("parentNodeId");
	if (wizardNodeParentId == null){
		wizardNodeParentId = "";
	}
	String metaDataAttr = WizardGeneratorBuilder.WIZARD_GENERATOR_BUILDER_META_DATA_TAG;
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script src="<%=BASE_DIRECTORY%>scripts/comps/divsTabs.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script>
  function updateGenerator(doSave){
  	document.access.action = "wizardGeneratorAdminAction.jsp";
  	document.access.selectedTabId.value = applicationTabs.selectedTabIndex;
  	document.access.doSave.value = doSave;
  	//alert(document.access.selectedTabId.value);
  	document.access.submit();
  }
  
	function refreshMetaDataView(){
		id = document.access.MetaData.options[document.access.MetaData.selectedIndex].value;
		document.access.SystemMetaDataId.value = id;
		document.access.selectedTabId.value = "1";
		document.access.submit();
	}
  
	function refreshWizardModulesView(){
		id = document.access.ParentWizardNode.options[document.access.ParentWizardNode.selectedIndex].value;
		document.access.parentNodeId.value = id;
		document.access.selectedTabId.value = "2";
		document.access.submit();
	}
	
	function selectModule(id,parentId){
		document.access.modId.value = id;
		document.access.parentModId.value = parentId;
		updateGenerator();
	}
	
	function selectLog(id,parentId){
		document.access.logId.value = id;
		document.access.parentModId.value = parentId;
		document.access.useTemplate.value = "false";
		updateGenerator();
	}
	
	function selectTemplate(id,parentId){
		document.access.logId.value = id;
		document.access.parentModId.value = parentId;
		document.access.useTemplate.value = "true";
		updateGenerator();
	}
	
	function selectRepInfo(objectId,xplgObjectType,repInfoId,repInfoName,repInfoDesc,repInfoVersion,repInfoBuild){
		//alert(id+","+repLogId+","+repLogName+","+repLogVersion+","+repLogBuild);
		document.access.objectId.value = objectId;
		document.access.xplgObjectType.value = xplgObjectType;
		document.access.repInfoId.value = repInfoId;
		document.access.repInfoName.value = repInfoName;
		document.access.repInfoDesc.value = repInfoDesc;
		document.access.repInfoVersion.value = repInfoVersion;
		document.access.repInfoBuild.value = repInfoBuild;
		updateGenerator();
	}
	function selectRepLogs(ids,parentId){
		document.access.repLogs.value = ids;
		document.access.parentModId.value = parentId;
		updateGenerator();
	}
	function createModule(name,desc,parentId){
		document.access.modName.value = name;
		document.access.modDesc.value = desc;
		document.access.parentModId.value = parentId;
		updateGenerator();
	}
	
	function addConfigurationWizard(configFile,parentId){
		document.access.parentModId.value = parentId;
		document.access.wizConfigFile.value = configFile;
		updateGenerator();
	}
	function addApplicationClass(className,fullClassPath,rootClassPath,parentId){
		document.access.className.value = className;
		document.access.fullClassPath.value = fullClassPath;
		document.access.rootClassPath.value = rootClassPath;
		document.access.parentModId.value = parentId;
		updateGenerator();
	}
	
	function getSelectedNodeId(onlyModules){
		var id = "";
		if (!document.access.nodes){
			return id;
		}
		for (var i=0; i<document.access.nodes.length; i++){
			if (eval("document.access.nodes["+i+"]").checked == true){
				v = (eval("document.access.nodes["+i+"]").value);
				if (v.indexOf(",") != -1){
					varr = v.split(",");
					if (!onlyModules || varr[0] == "<%=WizardModuleNode.WIZARD_MODULE_NODE_TYPE%>"){
						id = varr[1];
					}
				}
				break;
			}
		}
		return id;
	}
	
	function selectReport(id,parentId,useReportLogs,logIdsToRepositoryIds){
		document.access.reportId.value = id;
		document.access.parentModId.value = parentId;
		document.access.useReportLogs.value = useReportLogs;
		document.access.lbmToRepIds.value = logIdsToRepositoryIds;
		updateGenerator();
	}
	
	
	
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" name="access" id="access" method="post" action="wizardGeneratorAdmin.jsp">
<input type="hidden" name="selectedTabId">
<input type="hidden" name="doSave">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="90%" class="TOPBORDER">
                <span class="PAGEHEADER">Wizard Generator</span></td>
                <td width="9%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">                
                <script>
                  var applicationTabs = createDefaultApplicationTabs("metaDataMembersTabs");
                  applicationTabs.addTab("General","<nobr>General</nobr>","generalDiv");
                  applicationTabs.addTab("MetaData","<nobr>Applications</nobr>","metaDataDiv");
                  applicationTabs.addTab("Modules","<nobr>Folders</nobr>","modulesDiv");
                  applicationTabs.addTab("DataRepository","<nobr>Data repository</nobr>","dataRepDiv");
                  applicationTabs.addTab("Reports","<nobr>Reports</nobr>","reportsDiv");
                  <%if (txExpoViewer){%>
                  <%}%>
                </script>     
                  <tr>
                    <td width="100%">  
                    <script>
                    	tabsInLine = 8;
                    	applicationTabs.writeTabs();
                    </script> 
                   </td>
                  </tr>  
                  <tr>
                    <td width="100%" >   
                      <div id="generalDiv" style="display:none">
                     		<jsp:include page="general.jsp" flush="true"/>
                      </div>
                      <div id="metaDataDiv" style="display:none">
                     		<jsp:include page="../../metadata/metaDataAdmin.jsp" flush="true">
                     		<jsp:param name="isAdmin" value="false"/>
                     		<jsp:param name="baseDir" value="../../metadata/"/>
                     		<jsp:param name="metaDataAttr" value="<%=metaDataAttr%>"/>
                     		</jsp:include>
                      </div>
                      <div id="modulesDiv" style="display:none">
                     		<jsp:include page="wizardModulesAndLogs.jsp" flush="true"/>
                      </div>
                      <div id="dataRepDiv" style="display:none">
                     		<jsp:include page="wizardGeneratorDataRepository.jsp" flush="true"/>
                      </div>
                      <div id="reportsDiv" style="display:none">
                     		<jsp:include page="wizardGeneratorReports.jsp" flush="true"/>
                      </div>
                    </td>
                    </tr>
                  <tr>
                    <td height="100%">&nbsp;</td>
                  </tr>
                   <script>                 
                  applicationTabs.selectTabByIndex(<%=selectedTabId%>);
                  </script>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="35%">&nbsp;</td>
                <td width="11%" align="center"><a href="<%=BASE_DIRECTORY%>common/actions/cancelAction.jsp?forward=wizards/wizardsview.jsp" class="LINK">
                cancel</a></td>
                <td width="7%" align="center"><a href="javascript:updateGenerator('true')" class="LINK">save</a></td>
                <td width="9%" align="center"><a href="javascript:updateGenerator('false')" class="LINK">apply</a></td>
                <td width="20%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>