<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.admin.wizards.generator.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.nodes.WizardModuleNode"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.repository.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY = "../../";
%>
     
<%
	
	WizardGeneratorBuilder builder = (WizardGeneratorBuilder)request.getSession().getAttribute(WizardGeneratorBuilder.WIZARD_GENERATOR_BUILDER_TAG);
	String parentWizardNodeId = request.getParameter("parentWizardNodeId");
	if (parentWizardNodeId == null){
		parentWizardNodeId = "";
	}
	WizardNode parentWizardNode = builder.getWizardNodeById(parentWizardNodeId);
	
	RepositoryInfo[] repInfos = builder.getAllRepositoryInfos();
%>

<script src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script src="nodes/moduleOrLogSelection.js"></script>
<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";

	function openRepDSSelction(){
		var param = "?logSelection=true&repLog=true"; 
		var id = getSelectedNodeId(true);
		if (id != ""){
			param = param + (param == "" ? "?" : "&") + "parentId=" + id;
		}
	  newWindow = window.open("nodes/dsSelection.jsp"+param,"DataSourceSelection","height=400,width=600,resizable=yes,scrollbars=yes,status=yes,left=300,top=200");
	  newWindow.focus();	
	}
	
	function showRepLogAddMenu(){
		showHideLayerInMiddle('addRepLogDiv',-1,120);
	}
	
	function selectRepLogFromTemplate(){
		var param = "";
		var id = getSelectedNodeId(true);
		if (id != ""){
			param = "?parentId=" + id;
		}
	  newWindow = window.open("nodes/logTemplateSelection.jsp"+param,"LogTemplateSelection","height=400,width=600,resizable=yes,scrollbars=yes,status=yes,left=300,top=200");
	  newWindow.focus();	
	}
	
	function editRepInfo(objectId,repInfoId,xplgObjectType){
	  newWindow = window.open("dataRepositoryInfoEdit.jsp?objectId="+objectId+"&repInfoId="+repInfoId+"&xplgObjectType="+xplgObjectType,"DataRepInfoEdit","height=400,width=600,resizable=yes,scrollbars=yes,status=yes,left=300,top=200");
	  newWindow.focus();	
	}
	
	function removeRepInfo(id){
		document.access.repIdToDelete.value = id;
		updateGenerator();
	}
	
	function reloadRepInfo(id){
		document.access.repIdToReload.value = id;
		updateGenerator();
	}
	
	function showLogFilters(divId){
		var vis = document.getElementById("Div_" + divId).style.display == "";
		var expImage = document.getElementById("LogExpandImage_" + divId);
		if(vis){
			document.getElementById("Div_"+divId).style.display  = "none";		
			if (expImage){
			  expImage.src = "<%=BASE_DIRECTORY%>images/tree/plusnode.gif";
			}
		}else{
			document.getElementById("Div_"+divId).style.display  = "";
			if (expImage){
			  expImage.src = "<%=BASE_DIRECTORY%>images/tree/minusnode.gif";
			}
		}	
		
	}
	
</script>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<input type="hidden" name="objectId">
	<input type="hidden" name="repInfoId">
	<input type="hidden" name="xplgObjectType">
	<input type="hidden" name="repInfoName">
	<input type="hidden" name="repInfoDesc">
	<input type="hidden" name="repInfoVersion">
	<input type="hidden" name="repInfoBuild">
	<input type="hidden" name="repIdToDelete">
	<input type="hidden" name="repIdToReload">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
	            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
	              <tr>
	                <td width="15%" height="28" colspan="3"><span class="HEADER">Data Repository</span></td>
	              </tr>
	              <tr>
	              	<td>&nbsp;</td>
	              </tr>
	              <tr>
	              	<td>
				            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
				            	<tr>
				            		<td><a href="javascript:openRepDSSelction()" class="LINK"> add log</a></td>
				            	</tr>
				            	<tr><td>&nbsp;</td></tr>
	              		</table>
	              	</td>
	              </tr>
	              <tr>
	              	<td>
	              		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
                      <tr class="TABLES_HEADERS">
                        <td width="25%"><span class="REGULARTEXT">Name</span></td>
                        <td width="15%"><span class="REGULARTEXT">Id</span></td>
                        <td width="15%"><span class="REGULARTEXT">Description</span></td>
                        <td width="10%"><span class="REGULARTEXT">Type</span></td>
                        <td width="8%"><span class="REGULARTEXT">Version</span></td>
                        <td width="7%"><span class="REGULARTEXT">Build</span></td>
                        <td width="20%">&nbsp;</td>
                      </tr>
	              			<%
	              			RepositoryInfo info = null;
	              			for (int i=0; i<repInfos.length; i++){
	              				info = repInfos[i];
	              				if (info == null){
	              					continue;
	              				}
		              			String repId = info.getId();
		              			String logRepId = info.getId();
	              				String type = info.getXplgObjectType();
	              				String name = info.getName();
	              				String desc = info.getDesc();
	              				String version = info.getVersion();
	              				String build = "";
	              				if (info.getBuild() > 0){
	              					build = String.valueOf(info.getBuild());
	              				}
	              				Object data = info.getData();
	              				LogBrowsingManager lbm = null;
	              				if (data == null || !(data instanceof LogBrowsingManager)){
	              					continue;
	              				}
	              				lbm = (LogBrowsingManager)data;
              					name = lbm.getName();
	              				String objectId = builder.getRepositoryInfoObjectId(repId);
	              			%>
	              				<tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
	              					<td>
	              					<%String srcPath = (lbm.getFilterManager().getFilterCollections().size() > 0) ? BASE_DIRECTORY + "images/tree/plusnode.gif" : BASE_DIRECTORY + "images/tree/minusnode.gif";%>
	              						<img id="LogExpandImage_<%=repId%>" src="<%=srcPath%>" onClick="javascript:showLogFilters('<%=repId%>')">
	              						<span class="REGULARTEXT"><%=name%></span>
	              					</td>
	              					<td><span class="REGULARTEXT"><%=repId%></span></td>
	              					<td><span class="REGULARTEXT"><%=desc%></span></td>
	              					<td><span class="REGULARTEXT"><%=type%></span></td>
	              					<td><span class="REGULARTEXT"><%=version%></span></td>
	              					<td><span class="REGULARTEXT"><%=build%></span></td>
	              					<td>
	              						<a class="LINK" href="javascript:editRepInfo('<%=objectId%>','<%=repId%>','<%=type%>')">edit</a>&nbsp;
	              						<a class="LINK" href="javascript:removeRepInfo('<%=repId%>')">remove</a>&nbsp;
	              						<a class="LINK" href="javascript:reloadRepInfo('<%=repId%>')">reload</a>
	              					</td>
	              				</tr>
	              				<tr>
	              					<td colspan="7">
	              					<div id="Div_<%=repId%>" style="display:none">
	              					<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
	              				<%
	              				if (lbm != null){ 
	              					FilterManager filterMgr = lbm.getFilterManager();
	              					if (filterMgr != null){
	              						List fcs = filterMgr.getFilterCollections();
	              						for (int j=0; j<fcs.size(); j++){
	              							FilterCollection fc = (FilterCollection)fcs.get(j);
      	              				name = fc.getName();
	              							objectId = logRepId + ";" + fc.getId();
	              							info = builder.getRepositoryInfoByObjectId(objectId);
	              							if (info != null){
	      		              			repId = info.getId();
	      	              				type = info.getXplgObjectType();
	      	              				desc = info.getDesc();
	      	              				version = info.getVersion();
	      	              				build = "";
	      	              				if (info.getBuild() > 0){
	      	              					build = String.valueOf(info.getBuild());
	      	              				}
	              							}else{
	      		              			repId = "";
	      	              				type = XpoLogObjectTypes.FILTER_TYPE;
	      	              				desc = "";
	      	              				version = "";
	      	              				build = "";
	              							}
	              							%>
				              				<tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
				              					<td width="25%"><span class="REGULARTEXT">&nbsp;&nbsp;&nbsp;&nbsp;<%=name%></span></td>
				              					<td width="15%"><span class="REGULARTEXT"><%=repId%></span></td>
				              					<td width="15%"><span class="REGULARTEXT"><%=desc%></span></td>
				              					<td width="10%"><span class="REGULARTEXT"><%=type%></span></td>
				              					<td width="8%"><span class="REGULARTEXT"><%=version%></span></td>
				              					<td width="7%"><span class="REGULARTEXT"><%=build%></span></td>
				              					<td width="20%">&nbsp;</td>
				              				</tr>
	              							<%
	              						}
	              					}
	              				}%>
	              					</table>
	              					</div>
	              					</td>
	              				</tr>
	              			<%
	              			}%>
	              		</table>
	              	</td>
	              </tr>
	          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		

<div id="addRepModuleDiv" style="position:absolute;visibility:hidden;height:80">
	<table border="0" width="350" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
		<tr height="10">
			<td colspan="3" align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
				<span class="PROGRESSTEXT">Add folder</span>
			</td>
		</tr>
		<tr height="20">
			<td align="center" style="padding:5">
				<a class="PROGRESSLINK" href="javascript:hideLayer('addRepModuleDiv');">cancel</a>&nbsp;
			</td>
			<td align="center" style="padding:5">
				<a class="PROGRESSLINK" href="javascript:addNewModule();hideLayer('addRepModuleDiv');">new folder</a>&nbsp;
			</td>
			<td align="center" style="padding:5">
				<a class="PROGRESSLINK" href="javascript:openDSSelction('false');hideLayer('addRepModuleDiv');">select existing folder</a>&nbsp;
			</td>
		</tr>
	</table>
</div>

<div id="addRepLogDiv" style="position:absolute;visibility:hidden;height:80">
	<table border="0" width="350" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
		<tr height="10">
			<td colspan="3" align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
				<span class="PROGRESSTEXT">Add log</span>
			</td>
		</tr>
		<tr height="20">
			<td align="center" style="padding:5">
				<a class="PROGRESSLINK" href="javascript:hideLayer('addRepLogDiv');">cancel</a>&nbsp;
			</td>
			<td align="center" style="padding:5">
				<a class="PROGRESSLINK" href="javascript:selectRepLogFromTemplate();hideLayer('addRepLogDiv');">select log template</a>&nbsp;
			</td>
			<td align="center" style="padding:5">
				<a class="PROGRESSLINK" href="javascript:openRepDSSelction('true');hideLayer('addRepLogDiv');">select existing log</a>&nbsp;
			</td>
		</tr>
	</table>
</div>
