<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>


<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>

<%! 
	String getTreeDiv(Module node,UserContext userContext,HashMap modules,HashMap logs, boolean addTypeToId, String treeName){
		UserSecurity user = null;
		if (userContext != null){
			user = userContext.getUser();
		}
	  StringBuffer buffer = new StringBuffer();
	  String type = addTypeToId ? "Module," : "";
	  if (treeName == null || treeName.length() == 0) treeName = "tree";
	  if (node != null){
	    boolean selected = modules != null && modules.containsKey(node.getId());
	    String treeKey = "node" + node.getId() + "_0";
	    String chkKey = "modules";
	    buffer.append("\nvar " + treeKey + " = "+treeName+".addNode("+treeName+".root,\"" + chkKey + "\",\"" + type+node.getId() + "\",\"" + node.getName() + "\",\"" + node.getDescription() + "\",''," + selected + ",true,false);");
	    addChildsNodeDiv(node,buffer,treeKey,userContext,modules,logs,addTypeToId,treeName);
	  }
	  return buffer.toString();
	}
	void addChildsNodeDiv(ModuleMember node,StringBuffer buffer, String parentKey, UserContext userContext, HashMap modules, HashMap logs, boolean addTypeToId, String treeName){
		UserSecurity user = null;
		if (userContext != null){
			user = userContext.getUser();
		}
		Module mod = null;
		if(node.getType().equals(Module.MODULE_TYPE)){
			try{
				mod = SiteManagment.getInstance().getModuleFromId(node.getId());
			}catch(Exception e){
				return;
			}
		}else{
			return;
		}
		List children = mod.getModuleMembers(userContext);
	  for (int i = 0; i < children.size(); i++) {
	    ModuleMember child = (ModuleMember)children.get(i);
	   	String key = child.getId();
	    String treeKey = parentKey + "_" + i;
	    String parentNode = parentKey.equals("node") ? "tree.root" : parentKey;
	    String type = addTypeToId ? child.getType()+"," : "";
	    String extraText = "";
	    
	    boolean selected = false;
	    String chkKey = "logs";
	    if(child.getType().equals(Module.MODULE_TYPE)){
	      selected = modules != null && modules.containsKey(child.getId());
	      chkKey = "modules";
	    }else {
	      selected = logs != null && logs.containsKey(child.getId());
	    } 
	    buffer.append("\nvar " + treeKey + " = "+treeName+".addNode(" + parentNode + ",\"" + chkKey +"\",\"" + type+child.getId() + "\",\"" + child.getName() + "\",\"" + child.getDescription() + "\",'" + extraText + "'," + selected + ",false,false);");
	    addChildsNodeDiv(child,buffer,treeKey,userContext,modules,logs,addTypeToId,treeName);
	  }
	}
%>

<html>
	<head>
	</head>
	<body>
		<script>
      function markTreeNodeForExport(node){
				nodeCbx = document.getElementById("CheckBox_" + node.tree.name + "_" + node.index);
				if (!nodeCbx) return;
				if (node.selected == nodeCbx.checked) return;
	
				var selected = nodeCbx.checked;	
  	    if (this.onSelectMarkChilds){
    			markNodeChilds(node,selected);  
  			}else {
    			node.selected = selected;
	  		}
  
  			if (this.onSelectMarkParents  && selected){
    			markNodeParentsToRoot(node.parent,selected);  
  			}
		  }
		</script>
	</body>
</html>
