<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.controlers.*"%>
<%@ page import="xpolog.wizardsExt.siebel.SiebelConfigurator"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.ftp.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>

<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../../../";
%>


<%
	String ERROR_OBJ = "ERROR_OBJ";

   int position = Integer.parseInt(request.getParameter(WizardConstants.VIEW_CONTROL_POSITION_PARAM));
   DefaultWizardBuilder builder =  (DefaultWizardBuilder)request.getSession().getAttribute(WizardConstants.WIZARD_BUILDER_SESSION_ATT);
   WizardConfigurationViewControl view = (WizardConfigurationViewControl)builder.getControler().getWizardViewControlByPosition(position,true);
   WizardInfo wizardInfo = view.getWizardInfo();
   Object obj = wizardInfo.getWizardData(SiebelConfigurator.SERVERS_KEY);
   if (obj == null || !(obj instanceof HashMap)){
  	 ErrorModel errmodel = new ErrorModel();
  	 errmodel.addError("Failed to extract the servers list from the configuration file");
  	 request.getSession().setAttribute(ERROR_OBJ,errmodel);
  	 response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
  	 return;
   }
   HashMap servers = (HashMap)obj;
   int numberServers = servers != null ? servers.size() : 0;
   String title = "Siebel servers configuration";
   String serversDesc = "Please enter for each siebel server its complete home directory path";
   String accountDesc = view.getProperty("account","Select the account if connecting through SSH");
   
   UserContext userContext = UserEnvironment.getUserContext(request);
   AddressBook adbook = AddressBook.getInstance();
   AddressFilter filter = new TelnetAccountFilter();
   List list = adbook.getAccountsByFilter(filter,userContext);
   
   String isEmbededStr = request.getParameter("isEmbeded");
   boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");
   String parentModuleId = request.getParameter("parentModuleId");

%>

<html>
<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
	function doNext(){
		var path ="<%=view.getActionURL()%>&numServers=<%=numberServers%>";
		for (var i=0; i<<%=numberServers%>; i++){
			sn = eval("document.access.server_"+i).value;
			rp = eval("document.access.rootPath_"+i).value;
			path = path + "&server_"+i+"="+sn+"&rootPath_"+i+"="+rp; 
		}
		<%if (view.isUseAccount()){%>
		path = path + "&accountId=" + document.access.accountId.options[document.access.accountId.selectedIndex].value;
		<%}%>
		<%if (isEmbeded){%>
		path = path + "&isEmbeded=true";
		<%}%>
		<%if (parentModuleId != null && parentModuleId.length() > 0){%>
		path = path + "&parentModuleId=<%=parentModuleId%>";
		<%}%>
		document.location = path;
	}

</script>

</head>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" action="<%=view.getActionURL()%>">
<input type="hidden" name="numServers" value="<%=servers != null ? servers.size() : 0%>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
              <tr>
                <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="53%" class="TOPBORDER" height="0">
                <span class="PAGEHEADER"><%=title%></span></td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;</td>
                <td width="43%" height="100%">&nbsp;</td>
                <td width="50%" height="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Siebel servers&nbsp;</span></td>
                  </tr>
                  <tr>
                    <td>
                    &nbsp;
                    </td>
                  </tr>
                  
                  <tr>
                    <td width="15%"><span class="REGULARTEXT"><%=serversDesc%></span></td>
                  </tr>
                  <tr><td>&nbsp;</td></tr>
                  <tr>
                    <td>
                      <table border="0" cellpadding="2" cellspacing="0">
	                      <tr class="TABLES_HEADERS">
	                        <td width="150"><span class="REGULARTEXT">Siebel server name</span></td>
	                        <td width="300"><span class="REGULARTEXT">server root directory full path</span></td>
	                      </tr>
                      	<%Iterator it = servers.keySet().iterator();
                      		int i=0;
                      		while (it.hasNext()){
                      			String serverName = (String)it.next();
                      			String host = (String)servers.get(serverName);
                      	%>
                        <tr>
                        	<td width="150"><span class="REGULARTEXT"><%=serverName%>&nbsp;</span><input type="hidden" name="server_<%=i%>" value="<%=serverName%>"></td>
                        	<td width="300"><span class="REGULARTEXT"><input type="text" name="rootPath_<%=i%>" value="<%=host%>" size="50"></span></td>
                        </tr>
                        <%i++;
                        } %>
                      </table>
                    </td>
                  </tr>
                  <tr>
                  	<td>&nbsp;</td>
                  </tr>
                  <tr>
                  	<td><span class="SMALLTEXT">Note: if no path is entered for a server, it will be ignored in the <br>
                  	process of creating the folders and their logs</span></td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>

									<%if (view.isUseAccount()){%>
                  <tr>
                    <td width="15%">
                    <span class="REGULARTEXT"><%=accountDesc%></span></td>
                  </tr>
                  <tr>
                    <td>
                      <table border="0" width="106%">
                        <tr>
                          <td width="10%"><span class="REGULARTEXT">Account</span></td>
                          <td width="58%">
			                     <select name="accountId" id="accountId">
			                     	<option value=""><span class="REGULARTEXT">-- select ---</span></option>
			                     <%
			                      for(int t=0;t<list.size();t++){
			                        Account acc = (Account)list.get(t);
			                     %>
			                     	<option value="<%=acc.getId()%>"><span class="REGULARTEXT"><%=acc.getAccountName()%></span></option>
			                     <%} %>
			                     </select>
                          </td>
                          <td width="38%"></td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
									<%}%>

                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;&nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="30%">&nbsp;</td>
            <td width="31%" align="center">
              <table border="0" width="109%">
                <tr>
                  <td width="24%">
                  	<%if (!isEmbeded){%>
                  	<a href="<%=BASE_DIRECTORY%>common/actions/cancelAction.jsp" class="LINK">cancel</a>
                  	<%}else{ %>
                  	<a href="javascript:window.close()" class="LINK">cancel</a>
                  	<%} %>
                  </td>
                  <td width="40%">
                    <p align="center"><a href="javascript:history.go(-1)" class="LINK">previous</a></td>
                  <td width="46%"><a href="javascript:doNext()" class="LINK">next</a></td>
                </tr>
              </table>
            </td>
            <td width="39%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>