<%@ page language="java"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.controlers.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.admin.wizards.generator.WizardGeneratorBuilder"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.*" %>

<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>

<%!static final String BASE_DIRECTORY = "../../";%>

<%

  int position = Integer.parseInt(request.getParameter(WizardConstants.VIEW_CONTROL_POSITION_PARAM));
  DefaultWizardBuilder builder =  (DefaultWizardBuilder)request.getSession().getAttribute(WizardConstants.WIZARD_BUILDER_SESSION_ATT);
  WizardViewControl pView = (WizardViewControl)builder.getControler().getWizardViewControlByPosition(position-1,false);
  WizardConfigurationViewControl view = (WizardConfigurationViewControl)builder.getControler().getWizardViewControlByPosition(position,true);
  if (pView != null && pView instanceof WizardConfigurationViewControl && view != null && !view.doValidation()){
  	WizardConfigurationViewControl prevView = (WizardConfigurationViewControl)pView;
  	view.setConfigurationFile(prevView.getConfigurationFile());
  	view.setRootDirectory(prevView.getRootDirectory());
  }
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  WizardInfo info = builder.getWizardInfo();
  HashMap map = (HashMap)info.getWizardData("serversToCompGroups");

  String ERROR_OBJ = "ERROR_OBJ";
  String numServersStr = request.getParameter("numServers");
  int numServers = numServersStr != null ? Integer.parseInt(numServersStr) : 0;
  String serverName, serverRootPath;
  HashMap servers = new HashMap();
  for (int i=0; i<numServers; i++){
  	serverName = request.getParameter("server_"+i);
  	serverRootPath = request.getParameter("rootPath_"+i);
  	if (serverName != null && serverRootPath != null){
  		if (serverRootPath.length() > 0){
	  		servers.put(serverName,serverRootPath);
  		}else if (map != null){
  			map.remove(serverName);
  		}
  	}
  }
  info.setWizardData("servers",servers);
  
  String isEmbededStr = request.getParameter("isEmbeded");
  boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");
	String parentModuleId = request.getParameter("parentModuleId");
	if (parentModuleId == null){
		parentModuleId = "";
	}
  

	if (!isEmbeded){
	  boolean suc = view.doNext();
	  if (!suc){
	    request.getSession().setAttribute(ERROR_OBJ,view.getErrorModel());
	    response.sendRedirect(view.getErrorURL(true));
	  }else {
	 		response.sendRedirect(view.getNext().getViewURL());
	  }
	}else{
		env.setTempAttribute("WIZARD_INFO",info);
	}

%>

<%if (isEmbeded) {%>
<html>
<head>
<script language="javascript">
function display(){
  if (opener){
  	opener.addConfigurationWizard("","<%=parentModuleId%>");
  }
  window.close();
}		
</script>
</head>
<body onLoad="display()">
</body>
</html>

<%} %>
