<%@ page language="java"%>

<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.controlers.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.winevent.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>

<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../../";
%>

<%
	String ERROR_OBJ = "ERROR_OBJ";

	WebSecurityManager securityManager = WebSecurityManager.getInstance();
	if (!securityManager.checkForPermission(request,response,ActionsPermissionConstants.AdministrationPermissions.EDIT_LOG_PERMISSION,true)){
	  return;
	}
	int position = Integer.parseInt(request.getParameter(WizardConstants.VIEW_CONTROL_POSITION_PARAM));
	DefaultWizardBuilder builder =  (DefaultWizardBuilder)request.getSession().getAttribute(WizardConstants.WIZARD_BUILDER_SESSION_ATT);
	WizardWinEventViewControl view = (WizardWinEventViewControl)builder.getControler().getWizardViewControlByPosition(position,true);
	String title = view.getProperty("title","Wizard Admin");
	String hostsDesc = view.getProperty("hostsDesc","Please select the hosts for which you to create a windows event log");
	String eventTypesDesc = view.getProperty("eventTypesDesc","Please select the windows event types you want to create logs for");
	if (!WinEventAdminHelper.isWindowsEventCanBeUsed()){
	  ErrorModel ermo = new ErrorModel();
	  ermo.addError("Cannot setup windows event viewer");
	  ermo.addError("Not a Windows environment");
	  request.getSession().setAttribute(ERROR_OBJ,ermo);
	  response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
	  return;
	}
	List list = WinEventHelper.getComputerNamesOnNetwork();
  
%>

<html>
<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>

<script>
	function doNext(){
		for(var i=0;i<document.access.CustomizedColSelect.options.length;i++){
		  document.access.CustomizedColSelect.options[i].selected = true;
		}
		document.access.action = "<%=view.getActionURL()%>";
		document.access.submit();
	}

  function addToCust(){
    if(document.access.RealColSelect.selectedIndex == -1){
      return;
    }
    var name = document.access.RealColSelect.options[document.access.RealColSelect.selectedIndex].text;
    var value = document.access.RealColSelect.options[document.access.RealColSelect.selectedIndex].value;
    for(var i=0;i<document.access.CustomizedColSelect.options.length;i++){
      if(document.access.CustomizedColSelect.options[i].value == value){
				alert("You can not add a column twice!");
        return;
      }
    }
    var option0 = new Option(name,value);
    document.access.CustomizedColSelect.options[document.access.CustomizedColSelect.options.length] = option0;
  }

  function removeFromCust(){
    if(document.access.CustomizedColSelect.selectedIndex == -1){
      return;
    }
    document.access.CustomizedColSelect.options[document.access.CustomizedColSelect.selectedIndex] = null;
  }
  
  function removeAllFromCust(){
  	for (var i=document.access.CustomizedColSelect.length-1; i>=0; i--){
  		document.access.CustomizedColSelect.options[i] = null;
  	}
  }
  
  function addAllToCust(){
  	removeAllFromCust();
  	for (var i=0; i<document.access.RealColSelect.length; i++){
	    var name = document.access.RealColSelect.options[i].text;
	    var value = document.access.RealColSelect.options[i].value;
	    var option0 = new Option(name,value);
  	  document.access.CustomizedColSelect.options[document.access.CustomizedColSelect.options.length] = option0;
  	}
  }
	
</script>

</head>

<body style="margin:0;padding:0">

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" style="margin:0;padding:0">

<table border="0" cellpadding="0" cellspacing="0"	style="border-collapse:collapse" width="100%" height="100%">
	<tr height="10">
		<td>
			<%
			String headerUrl = BASE_DIRECTORY + "common/pageHeader.jsp";
			%>
			<jsp:include page="<%=headerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="<%=title%>" />
			</jsp:include>
		</td>
	</tr>
	<tr valign="top">
		<td>
			<table class="ADMIN_TABLE_DIV" width="100%">
				<tr>
					<td class="ADMIN_MAIN_TD">
						<table width="100%">
							<tr>
								<td class="ADMIN_SECTION_HEADER" style="padding-left:5">Wizard Settings</td>
							</tr>
							<tr>
								<td>
									<table class="ADMIN_SECTION_DIV" cellpadding="0" cellspacing="0" width="100%">
										<tr>
											<td class="ADMIN_SECTION_MAIN_TD">
												<table border="0" cellpadding="0" cellspacing="0" width="100%">
													<tr>
														<td><span class="REGULARTEXT"><%=hostsDesc%></span></td>
													</tr>
													
													<tr>
				                    <td style="padding-top:10">
				                    	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber19">
				                      	<tr>
				                        	<td width="250">
				                        	<select size="7" name="RealColSelect" id="RealColSelect" style="width: 250; height: 156">
				                          	<option class="TEXTBOX" value="" alt="localhost" title="localhost" name="localhost">localhost</option>
				                          	<%
				                            String name = null;
				                            String value = null;
				                            for(int i=0;i<list.size();++i){
					                            name = (String)list.get(i);
				                             	value = String.valueOf(i);
				                          	%>
				                          	<option class="TEXTBOX" value="<%=name%>" alt="<%=name%>" title="<%=name%>" name="<%=name%>"><%=name%></option>
				                          	<%
					                          }
				                          	%>
				                        	</select>
				                        	</td>
				                        	<td width="75" style="padding-left:5;padding-right:5">
				                        		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber20">
				                          		<tr>
				                            		<td width="100%" align="center"><a href="javascript:addToCust()" class="SMALLLINK">add</a> </td>
				                          		</tr>
				                          		<tr>
				                            		<td width="100%" align="center"><a href="javascript:addAllToCust()" class="SMALLLINK"> add all </a> </td>
				                          		</tr>
				                          		<tr>
				                            		<td width="100%" align="center"><a href="javascript:removeFromCust()" class="SMALLLINK">remove</a></td>
				                          		</tr>
				                          		<tr>
				                            		<td width="100%" align="center"><a href="javascript:removeAllFromCust()" class="SMALLLINK"> remove all </a></td>
				                          		</tr>
				                         		</table>
					                        </td>
				  	                      <td width="250">
																		<select size="7" name="CustomizedColSelect" id="CustomizedColSelect" style="width: 250; height: 156" multiple>
																			<option class="TEXTBOX" value="" alt="localhost" title="localhost" name="localhost">localhost</option>
				          	                </select>
				          	              </td>
				                        	<td width="*%">&nbsp;</td>
				                      	</tr>
				                    	</table>
				                    </td>
				                  </tr>
													
													<tr>
				                    <td style="padding-top:10">
				                    <span class="ERRORMESSAGE">
				                    	Note: you must have user permissions in order to access the windows event logs of remote machines.<br>
				                    	If this is not the case, the system will add the logs but you will not be able to view the events
				                    <span>
				                    </td>
				                  </tr>
				                  
				                  <tr>
				                    <td style="padding-top:10"><span class="REGULARTEXT"><%=eventTypesDesc%></span></td>
				                  </tr>
				                  <tr>
				                    <td>
				                    	<nobr>
				                    		<input type="checkbox"  name="Application" id="Application" value="true" checked><span class="REGULARTEXT">&nbsp;Application</span>&nbsp;&nbsp;
				                    		<input type="checkbox"  name="System" id="System" value="true" checked><span class="REGULARTEXT">&nbsp;System</span>&nbsp;&nbsp;
				                    		<input type="checkbox"  name="Security" id="Security" value="true" checked><span class="REGULARTEXT">&nbsp;Security</span>
				                    	</nobr>
				                    </td>
				                  </tr>             
												</table>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr height="10">
		<td>
			<%
			String footerUrl = BASE_DIRECTORY + "common/buttonsFooter.jsp";
			String cancelAction = "common/actions/cancelAction.jsp?forward=wizards/wizardsview.jsp";
			
			String actions = "javascript:doNext()#" + cancelAction;
			%>
			<jsp:include page="<%=footerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="Next#Cancel" />
				<jsp:param name="actions" value="<%=actions %>" />
			</jsp:include>
		</td>
	</tr>
</table>
</form>
<iframe id="resultFrame" name="resultFrame" style="display:none">
</body>
</html>