
CREATE TABLE principals (
  principalId VARCHAR2(50) NOT NULL,
  principalName VARCHAR2(50) default '' NOT NULL ,
  description VARCHAR2(100) default '',
  principalType VARCHAR2(50) default '',  
  principalMode NUMBER default 0,
  extraInfo VARCHAR2(50) default '',
  timeModified NUMBER default '0',
  principalState NUMBER default 0,
  counter NUMBER default 0,
  CONSTRAINT PK_PRINCIPALS
  PRIMARY KEY ( principalId ) USING INDEX
);
CREATE TABLE userPasswords (
  principalId VARCHAR2(50) NOT NULL,
  password VARCHAR2(1000) default '' NOT NULL ,
  CONSTRAINT PK_USERPSSWD
  PRIMARY KEY ( principalId ) USING INDEX
);
CREATE TABLE associatedGroups (
  principalId VARCHAR2(50) NOT NULL,
  groupId VARCHAR2(1000) default '' NOT NULL,
  grouptype VARCHAR2(50) default '',
  CONSTRAINT PK_ASSGROUPS
  PRIMARY KEY ( principalId,groupId,grouptype ) USING INDEX
);

CREATE TABLE principalPolicy (
  principalId VARCHAR2(50) NOT NULL,
  policyId VARCHAR2(50) default '' NOT NULL,
  CONSTRAINT PK_PRINPOLICY
  PRIMARY KEY ( principalId ) USING INDEX
);

CREATE TABLE policyActions (
  policyId VARCHAR2(50) NOT NULL,
  actionId VARCHAR2(50) default '' NOT NULL,
  CONSTRAINT PK_POLICYACTION
  PRIMARY KEY ( policyId,actionId ) USING INDEX
);
