INSERT INTO statusdimension (statusId,name) VALUES (1,'Topology');
INSERT INTO statusdimension (statusId,name) VALUES (2,'TransactionTime');
INSERT INTO statusdimension (statusId,name) VALUES (3,'EdgeTime');
INSERT INTO statusdimension (statusId,name) VALUES (4,'Flow');
INSERT INTO statusdimension (statusId,name) VALUES (5,'Data');
INSERT INTO statusvalues (statusDimId,statusValueId,statusValue) VALUES (1,1,'Open');
INSERT INTO statusvalues (statusDimId,statusValueId,statusValue) VALUES (1,2,'Close');
INSERT INTO statusvalues (statusDimId,statusValueId,statusValue) VALUES (1,3,'Partial');
INSERT INTO statusvalues (statusDimId,statusValueId,statusValue) VALUES (1,4,'Partial Close');
INSERT INTO statusvalues (statusDimId,statusValueId,statusValue) VALUES (2,0,'None');
INSERT INTO statusvalues (statusDimId,statusValueId,statusValue) VALUES (2,1,'Success');
INSERT INTO statusvalues (statusDimId,statusValueId,statusValue) VALUES (2,2,'Failed');
INSERT INTO statusvalues (statusDimId,statusValueId,statusValue) VALUES (2,3,'Warning');
INSERT INTO statusvalues (statusDimId,statusValueId,statusValue) VALUES (3,0,'None');
INSERT INTO statusvalues (statusDimId,statusValueId,statusValue) VALUES (3,1,'Success');
INSERT INTO statusvalues (statusDimId,statusValueId,statusValue) VALUES (3,2,'Failed');
INSERT INTO statusvalues (statusDimId,statusValueId,statusValue) VALUES (4,0,'None');
INSERT INTO statusvalues (statusDimId,statusValueId,statusValue) VALUES (4,1,'OK');
INSERT INTO statusvalues (statusDimId,statusValueId,statusValue) VALUES (4,2,'Error');
INSERT INTO statusvalues (statusDimId,statusValueId,statusValue) VALUES (5,1,'OK');
INSERT INTO statusvalues (statusDimId,statusValueId,statusValue) VALUES (5,2,'Error');

/** Insert default UI preferences **/
INSERT INTO uidefaultglobalproperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default transaction paradigm','transactionParadigm','logic/images/graph/transactionParadigm.gif');
INSERT INTO uidefaultglobalproperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default routine paradigm','routineParadigm','logic/images/graph/routineParadigm.gif');
INSERT INTO uidefaultglobalproperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default transaction runtime','transactionRuntime','logic/images/graph/runtime/transactions/transactionRuntime.gif');
INSERT INTO uidefaultglobalproperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default routine runtime','routineRuntime','logic/images/graph/runtime/routines/routineRuntime.gif');
INSERT INTO uidefaultglobalproperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default routine runtime error','routineRuntimeError','logic/images/graph/runtime/routines/routineRuntimeError.gif');
INSERT INTO uidefaultglobalproperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default dummy routine','dummyRoutine','logic/images/graph/runtime/routines/routineDummy.gif');
INSERT INTO uidefaultglobalproperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default dummy routine error','dummyRoutineError','logic/images/graph/runtime/routines/routineDummyError.gif');
INSERT INTO uidefaultglobalproperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default transaction runtime','subTransactionRuntime','logic/images/graph/runtime/transactions/subTransactionRuntime.gif');
INSERT INTO uidefaultglobalproperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default transaction runtime error','subTransactionRuntimeError','logic/images/graph/runtime/transactions/subTransactionRuntimeError.gif');
INSERT INTO uidefaultglobalproperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default dummy transaction','dummySubTransaction','logic/images/graph/runtime/transactions/subTransactionDummy.gif');
INSERT INTO uidefaultglobalproperties (propertyType,propertyName,propertyKey,propertyValue) VALUES ('Images','Default dummy transaction error','dummySubTransactionError','logic/images/graph/runtime/transactions/subTransactionDummyError.gif');

INSERT INTO paradigminfodetails (infoName,infoDesc,infoKey,infoValue,isDefault) VALUES ('Global Algorithm','','transactionAlgorithm','GlobalAlgorithm',1);
INSERT INTO paradigminfodetails (infoName,infoDesc,infoKey,infoValue,isDefault) VALUES ('Linear Algorithm','','transactionAlgorithm','LinearAlgorithm',0);

/** Insert default online settings **/
INSERT INTO workspaces (id,woName,woDescription,timestamp,state) VALUES ('0','Monitoring','transaction monitoring, Do Not Delete','0','0');
UPDATE workspaces SET id='0' WHERE id='1';
INSERT INTO sessionsparadigm (id,name,description,filter,cronexp,timestamp,state,hoursToKeep) VALUES ('0','Monitor','monitor project, Do Not Delete',' ',' ','0','0','120');
UPDATE sessionsparadigm SET id='0' WHERE id='1';
INSERT INTO sessionruntime (id,sessionParadigmId,startTime,endTime,createdTime,state) VALUES ('0','0','0','0','0','0');
UPDATE sessionruntime SET id='0' WHERE id='1';
INSERT INTO sessionparadigmtoworkspace (workspaceId,sessionParadigmId) VALUES ('0','0');
UPDATE sessionparadigmtoworkspace SET workspaceId='0' WHERE workspaceId='1';



