/****** Create foreign keys ******/
ALTER TABLE ACTIONTOEDGE ADD  CONSTRAINT FK_ACTIONTOEDGE_ACTIONS
 FOREIGN KEY (ACTIONID) 
  REFERENCES ACTIONS (ACTIONID) ;

ALTER TABLE ACTIONTOEDGE ADD  CONSTRAINT FK_ACTIONTOEDGE_EDGEPARADIGM
 FOREIGN KEY (EDGEPARADIGMID)
  REFERENCES EDGEPARADIGM (PARADIGMID) ;

ALTER TABLE ACTIONTOEDGE ADD  CONSTRAINT FK_ACTIONTOEDGE_STATUSVALUES
 FOREIGN KEY (STATUSDIMID, STATUSVALUEFROM) 
  REFERENCES STATUSVALUES (STATUSDIMID, STATUSVALUEID) ;

ALTER TABLE ACTIONTOEDGE ADD  CONSTRAINT FK_ACTIONTOEDGE_STATUSVALUES1
 FOREIGN KEY (STATUSDIMID, STATUSVALUETO) 
  REFERENCES STATUSVALUES (STATUSDIMID, STATUSVALUEID) ;

ALTER TABLE ACTIONTOROUTINE ADD  CONSTRAINT FK_ACTIONTOROUTINE_ACTIONS
 FOREIGN KEY (ACTIONID) 
  REFERENCES ACTIONS (ACTIONID) ;

ALTER TABLE ACTIONTOROUTINE ADD  CONSTRAINT FK_ACTIONTOROUTINE_ROUTINEPAR
 FOREIGN KEY (ROUTINEPARADIGMID) 
  REFERENCES ROUTINEPARADIGM (PARADIGMID) ;

ALTER TABLE ACTIONTOROUTINE ADD  CONSTRAINT FK_ACTIONTOROUTINE_STATVALUES
 FOREIGN KEY (STATUSDIMID, STATUSVALUEFROM) 
  REFERENCES STATUSVALUES (STATUSDIMID, STATUSVALUEID) ;

ALTER TABLE ACTIONTOROUTINE ADD  CONSTRAINT FK_ACTIONTOROUTINE_STATVALUES1
 FOREIGN KEY (STATUSDIMID, STATUSVALUETO) 
  REFERENCES STATUSVALUES (STATUSDIMID, STATUSVALUEID) ;

ALTER TABLE ACTIONTOTRANSACTION ADD  CONSTRAINT FK_ACTIONTOTRANS_STATUSVALUES
 FOREIGN KEY (STATUSDIMID, STATUSVALUEFROM) 
  REFERENCES STATUSVALUES (STATUSDIMID, STATUSVALUEID) ;

ALTER TABLE ACTIONTOTRANSACTION ADD  CONSTRAINT FK_ACTIONTOTRANS_STATUSVALUES1
 FOREIGN KEY (STATUSDIMID, STATUSVALUETO) 
  REFERENCES STATUSVALUES (STATUSDIMID, STATUSVALUEID) ;

ALTER TABLE ATOMICRUNTIME ADD  CONSTRAINT FK_ATOMICRUNTIME_PARADIGM
 FOREIGN KEY (ATOMICPARADIGMID) 
  REFERENCES ATOMICPARADIGM (PARADIGMID) ;

ALTER TABLE DUMMYROUTINERUNTIME ADD  CONSTRAINT FK_DUMMYROUTINERT_ROUTINEPAR
 FOREIGN KEY (ROUTINEPARADIGMID) 
  REFERENCES ROUTINEPARADIGM (PARADIGMID) ;

ALTER TABLE DUMMYROUTINERUNTIME ADD  CONSTRAINT FK_DUMMYROUTINERT_TRANSRT
 FOREIGN KEY (TRANSACTIONRUNTIME) 
  REFERENCES TRANSACTIONRUNTIME (TRANSACTIONID) ;

ALTER TABLE EDGEPARADIGM ADD  CONSTRAINT FK_EDGEPARADIGM_TRANSPARADIGM
 FOREIGN KEY (TRANSACTIONPARADIGMID)
  REFERENCES TRANSACTIONPARADIGM (PARADIGMID) ;

ALTER TABLE EDGERUNTIME ADD  CONSTRAINT FK_EDGERUNTIME_EDGEPARADIGM
 FOREIGN KEY (EDGEPARADIGMID) 
  REFERENCES EDGEPARADIGM (PARADIGMID) ;

ALTER TABLE EDGERUNTIME ADD  CONSTRAINT FK_EDGERUNTIME_TRANSRUNTIME
 FOREIGN KEY (TRANSACTIONRUNTIMEID) 
  REFERENCES TRANSACTIONRUNTIME (TRANSACTIONID) ;

ALTER TABLE TRANSACTIONFILTERS ADD  CONSTRAINT FK_TRANFILTER_TRANSPARADIGM
 FOREIGN KEY (TRANSACTIONPARADIGMID) 
  REFERENCES TRANSACTIONPARADIGM (PARADIGMID) ;

ALTER TABLE FUNCTIONTOEDGE ADD  CONSTRAINT FK_FUNCTIONTOEDGE_FUNCTIONTOEDGE
 FOREIGN KEY (EDGEPARADIGMID) 
  REFERENCES FUNCTIONEDGE (PARADIGMID) ;

ALTER TABLE FUNCTIONTOEDGE ADD  CONSTRAINT FK_FUNCTIONTOEDGE_FUNCTIONS
 FOREIGN KEY (FUNCTIONID)
  REFERENCES FUNCTIONS (FUNCTIONID) ;

ALTER TABLE FUNCTIONEDGE ADD  CONSTRAINT FK_FUNCTIONEDGE_TRANSPARADIGM
 FOREIGN KEY (TRANSACTIONPARADIGMID)
  REFERENCES TRANSACTIONPARADIGM (PARADIGMID) ;

ALTER TABLE ROUTINEPARADIGM ADD  CONSTRAINT FK_ROUTINEPAR_ATOMICPAR
 FOREIGN KEY (ATOMICPARADIGMID)
  REFERENCES ATOMICPARADIGM (PARADIGMID) ;

ALTER TABLE ROUTINEPARADIGM ADD  CONSTRAINT FK_ROUTINEPAR_TRANSPAR
 FOREIGN KEY (TRANSACTIONPARADIGMID) 
  REFERENCES TRANSACTIONPARADIGM (PARADIGMID) ;

ALTER TABLE ROUTINERUNTIME ADD  CONSTRAINT FK_ROUTINERT_ATOMICRT
 FOREIGN KEY (ATOMICRUNTIMEID) 
  REFERENCES ATOMICRUNTIME (ATOMICID) ;

ALTER TABLE ROUTINERUNTIME ADD  CONSTRAINT FK_ROUTINERT_ROUTINEPARADIGM
 FOREIGN KEY (ROUTINEPARADIGMID) 
  REFERENCES ROUTINEPARADIGM (PARADIGMID) ;

ALTER TABLE ROUTINERUNTIME ADD  CONSTRAINT FK_ROUTINERT_TRANSACTIONRT
 FOREIGN KEY (TRANSACTIONRUNTIMEID) 
  REFERENCES TRANSACTIONRUNTIME (TRANSACTIONID) ;

ALTER TABLE RULETOEDGE ADD  CONSTRAINT FK_RULETOEDGE_EDGEPARADIGM
 FOREIGN KEY (EDGEPARADIGMID) 
  REFERENCES EDGEPARADIGM (PARADIGMID) ;

ALTER TABLE RULETOEDGE ADD  CONSTRAINT FK_RULETOEDGE_RULES
 FOREIGN KEY (RULEID) 
  REFERENCES RULES (RULEID) ;

ALTER TABLE RULETOTRANSACTION ADD  CONSTRAINT FK_RULETOTRANSACTION_RULES
 FOREIGN KEY (RULEID) 
  REFERENCES RULES (RULEID) ;

ALTER TABLE RULETOTRANSACTION ADD  CONSTRAINT FK_RULETOTRANS_TRANSPARADIGM
 FOREIGN KEY (TRANSACTIONPARADIGMID) 
  REFERENCES TRANSACTIONPARADIGM (PARADIGMID) ;

ALTER TABLE STATUSTOEDGE ADD  CONSTRAINT FK_STATUSTOEDGE_EDGEPARADIGM
 FOREIGN KEY (EDGEPARADIGMID) 
  REFERENCES EDGEPARADIGM (PARADIGMID) ;

ALTER TABLE STATUSTOEDGE ADD  CONSTRAINT FK_STATUSTOEDGE_STATUSDIM
 FOREIGN KEY (STATUSDIMID) 
  REFERENCES STATUSDIMENSION (STATUSID) ;

ALTER TABLE STATUSTOEDGERUNTIME ADD  CONSTRAINT FK_STATUSTOEDGERT_EDGERT
 FOREIGN KEY (EDGERUNTIMEID) 
  REFERENCES EDGERUNTIME (EDGEID) ;

ALTER TABLE STATUSTOEDGERUNTIME ADD  CONSTRAINT FK_STATUSTOEDGERT_STATUSDIM
 FOREIGN KEY (STATUSDIMENSIONID) 
  REFERENCES STATUSDIMENSION (STATUSID) ;

ALTER TABLE STATUSTOROUTINE ADD  CONSTRAINT FK_STATUSTOROUTINE_ROUTINEPAR
 FOREIGN KEY (ROUTINEPARADIGMID) 
  REFERENCES ROUTINEPARADIGM (PARADIGMID) ;

ALTER TABLE STATUSTOROUTINE ADD  CONSTRAINT FK_STATUSTOROUTINE_STATUSDIM
 FOREIGN KEY (STATUSDIMID) 
  REFERENCES STATUSDIMENSION (STATUSID) ;

ALTER TABLE STATUSTOROUTINERUNTIME ADD  CONSTRAINT FK_STATUSTOROUTINERT_STATUSDIM
 FOREIGN KEY (STATUSDIMENSION) 
  REFERENCES STATUSDIMENSION (STATUSID) ;

ALTER TABLE STATUSTOTRANSACTION ADD  CONSTRAINT FK_STATUSTOTRANS_STATUSDIM
 FOREIGN KEY (STATUSID) 
  REFERENCES STATUSDIMENSION (STATUSID) ;

ALTER TABLE STATUSTOTRANSACTION ADD  CONSTRAINT FK_STATUSTOTRANS_TRANSPARADIGM
 FOREIGN KEY (TRANSACTIONPARADIGMID) 
  REFERENCES TRANSACTIONPARADIGM (PARADIGMID) ;

ALTER TABLE STATUSTOTRANSACTIONRUNTIME ADD  CONSTRAINT FK_STATUSTOTRANSRT_STATUSDIM
 FOREIGN KEY (STATUSDIMENSIONID) 
  REFERENCES STATUSDIMENSION (STATUSID) ;

ALTER TABLE STATUSTOTRANSACTIONRUNTIME ADD  CONSTRAINT FK_STATUSTOTRANSRT_TRANSRT
 FOREIGN KEY (TRANSACTIONRUNTIMEID) 
  REFERENCES TRANSACTIONRUNTIME (TRANSACTIONID) ;

ALTER TABLE STATUSVALUES ADD  CONSTRAINT FK_STATUSVALUES_STATUSDIM1
 FOREIGN KEY (STATUSDIMID) 
  REFERENCES STATUSDIMENSION (STATUSID) ;

ALTER TABLE TRANSACTIONRUNTIME ADD  CONSTRAINT FK_TRANSRUNTIME_TRANSPARADIGM
 FOREIGN KEY (TRANSACTIONPARADIGMID) 
  REFERENCES TRANSACTIONPARADIGM (PARADIGMID) ;
  
ALTER TABLE TRANSACTIONPARADIGMPERMISSIONS ADD  CONSTRAINT FK_TPPERM_TRANPARADIGM
 FOREIGN KEY (TRANSACTIONPARADIGMID) 
  REFERENCES TRANSACTIONPARADIGM (PARADIGMID) ;
  
ALTER TABLE UIATOMICPARADIGMPROPERTIES ADD  CONSTRAINT FK_ATOMICPROP_GLOBALPROP
 FOREIGN KEY (GLOBALPROPERTYID) 
  REFERENCES UIGLOBALPROPERTIES (PROPERTYID) ;

ALTER TABLE UIATOMICPARADIGMPROPERTIES ADD  CONSTRAINT FK_ATOMICPROP_ATOMICPARADIGM
 FOREIGN KEY (ATOMICPARADIGMID) 
  REFERENCES ATOMICPARADIGM (PARADIGMID) ;
  

ALTER TABLE UIROUTINEPARADIGMPROPERTIES ADD  CONSTRAINT FK_ROUTINEPROP_GLOBALPROP
 FOREIGN KEY (GLOBALPROPERTYID) 
  REFERENCES UIGLOBALPROPERTIES (PROPERTYID) ;

ALTER TABLE UIROUTINEPARADIGMPROPERTIES ADD  CONSTRAINT FK_ROUTINEPROP_ROUTINEPARADIGM
 FOREIGN KEY (ROUTINEPARADIGMID) 
  REFERENCES ROUTINEPARADIGM (PARADIGMID) ;
  
ALTER TABLE UIEDGEPARADIGMPROPERTIES ADD  CONSTRAINT FK_EDGEPROP_GLOBALPROP
 FOREIGN KEY (GLOBALPROPERTYID) 
  REFERENCES UIGLOBALPROPERTIES (PROPERTYID) ;

ALTER TABLE UIEDGEPARADIGMPROPERTIES ADD  CONSTRAINT FK_EDGEPROP_ATOMICPARADIGM
 FOREIGN KEY (EDGEPARADIGMID) 
  REFERENCES EDGEPARADIGM (PARADIGMID) ;
  
ALTER TABLE UITRANPARADIGMPROPERTIES ADD  CONSTRAINT FK_TRANPROP_GLOBALPROP
 FOREIGN KEY (GLOBALPROPERTYID) 
  REFERENCES UIGLOBALPROPERTIES (PROPERTYID) ;

ALTER TABLE UITRANPARADIGMPROPERTIES ADD  CONSTRAINT FK_TRANPROP_ATOMICPARADIGM
 FOREIGN KEY (TRANSACTIONPARADIGMID) 
  REFERENCES TRANSACTIONPARADIGM (PARADIGMID) ;
  
ALTER TABLE TRANSACTIONTOSESSIONPARADIGM ADD CONSTRAINT FK_TRANSACTIONTOSESSION_1
 FOREIGN KEY (SESSIONID) 
  REFERENCES SESSIONSPARADIGM (ID) ;  
  
ALTER TABLE SESSIONPARADIGMPERMISSIONS ADD  CONSTRAINT FK_SESPERM_TRANPARADIGM
 FOREIGN KEY (SESSIONPARADIGMID) 
  REFERENCES SESSIONSPARADIGM (ID) ;

ALTER TABLE WORKSPACEPERMISSIONS ADD  CONSTRAINT FK_WSPERM_TRANPARADIGM
 FOREIGN KEY (WORKSPACEID) 
  REFERENCES WORKSPACES (ID) ;