<%@ page language="java"%>

<%@ page import="xpolog.eye.analytics.analyzer.AnalyzerHelper"%>
<%@ page import="xpolog.eye.analytics.analyzer.AnalyzerViewHelper"%>
<%@ page import="xpolog.eye.analytics.analyzer.error.AnalyzerErrorDataFilter"%>
<%@ page import="xpolog.eye.analytics.analyzer.error.AnalyzerErrorData"%>
<%@ page import="xpolog.eye.analytics.analyzer.error.AnalyzerErrorDatas"%>
<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.data.filters.FilterField"%>
<%@ page import="xpolog.eye.data.filters.StringFilter"%>
<%@ page import="xpolog.eye.data.masks.DateMask"%>
<%@ page import="xpolog.eye.data.masks.MaskColumn"%>
<%@ page import="xpolog.eye.data.RecordMask"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>

<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../";

  static final long MS_TO_ROUND = 1000*60*5;
%>

<%

String lbmId = request.getParameter("lbmId");
String filterValue = request.getParameter("filterValue");

RecordMask mask = new RecordMask();
DateMask dateMask = new DateMask("MM/dd/yyyy HH:mm:ss");
MaskColumn[] cols = {dateMask};
mask.setColumns(cols);

HealthViewModel model = (HealthViewModel)session.getAttribute("HealthViewModel");
if(model == null) {
	response.sendRedirect("");
}
DateFilter df1 = model.getTimeFilter();
DateFilter df2 = null;
if(df1 != null){
	df1.setRoundMilliseconds(MS_TO_ROUND);
	df1.updateMinTime();	
	df1.setTimeType(-1);
	df1.setTimeGap(-1);
	if (df1.getMinDate() == null){
		df1.setMinDate(new Date(0));
	}
	if (df1.getMaxDate() == null){
		df1.setMaxDate(new Date());
	}
	df2 = (DateFilter)df1.clone();
}

AnalyzerErrorDataFilter errorDataFilter = new AnalyzerErrorDataFilter();

StringFilter sf = null;
int ind = filterValue.indexOf("@");
if (ind != -1){
	filterValue = filterValue.substring(ind+1,filterValue.length());
	sf = new StringFilter();
	FilterField ff = new FilterField(filterValue, false, false);
	sf.addField(ff);
	sf.setOperation(StringFilter.getSupportedOperations()[2]);
	errorDataFilter.setStringFilter(sf);
}
if (df2 != null){
	errorDataFilter.setDateFilter(df2);
}

AnalyzerErrorDatas analyzerErrorDatas = AnalyzerHelper.loadAalyzerErrorDataResults(lbmId, errorDataFilter);

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<meta http-equiv="CACHE-CONTROL" content="NO-CACHE">
<meta http-equiv="PRAGMA" content="NO-CACHE">
<meta http-equiv="EXPIRES" content="0">

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/dashboard.css" />

<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/calendar/calendar2.js"></script>
<!-- Date only with year scrolling -->
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/comps/jsdomenu.js"></script>

</head>

<body>
<table border="0" width="100%" cellspacing="0"  cellpadding="0" height="100%" cellpadding="0">
	<tr valign="top">
		<td width="100%">
			<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
				<tr valign="middle" height="58">
					<td width="4" style="background-image:url(<%=BASE_DIRECTORY%>images/dashboard/rootResultHeaderLeft.gif);background-repeat:no-repeat">&nbsp;</td>
					<td height="58" style="background-image:url(<%=BASE_DIRECTORY%>images/dashboard/rootResultHeaderNoBorders.gif)">
						<table border="0" cellspacing="0" style="border-collapse: collapse" width="100%">
							<tr>
								<td width="3%"></td>
								<td><span style="font-size:16;font-weight:bold">Analytics Results - <%=filterValue %></span></td>
							</tr>
						</table>
					</td>
				</tr>
				
				<tr height="28" bgcolor="#778877">
					<td width="4" style="background-image:url(<%=BASE_DIRECTORY%>images/dashboard/navBarLeft.gif);background-repeat:no-repeat"></td>
					<td valign="bottom" width="*" style="background-image:url(<%=BASE_DIRECTORY%>images/dashboard/navBar.gif);padding-right:10">
				</tr>
				
				<%
				List errorDatas = analyzerErrorDatas.getErrorDatas();
				AnalyzerErrorData analyzerErrorData = null;
				String includeUrl = null, bgColor = null;
				int count = 0;
				for(int i = 0; i < errorDatas.size(); i++) {
					analyzerErrorData = (AnalyzerErrorData)errorDatas.get(i);
					includeUrl = AnalyzerViewHelper.getAnalyzerErrorDataUrl(analyzerErrorData);
					if(includeUrl == null) {
						continue;
					}
					includeUrl = "../analytics/" + includeUrl;
					bgColor = (i % 2 == 0) ? "#EAEBED" : "#AABBBB";
					++count;
					
					request.setAttribute("analyzerErrorDatas", analyzerErrorDatas);
				%>
				<tr height="10" bgcolor="<%=bgColor %>">
					<td colspan="2">
						<jsp:include page="<%=includeUrl %>" flush="true">
							<jsp:param name="index" value="<%=Integer.toString(i)%>" />
							<jsp:param name="count" value="<%=Integer.toString(count)%>" />
						</jsp:include>
					</td>
				</tr>
				<%
				}
				%>
				
				<tr>
					<td colspan="2">&nbsp;</td>
				</tr>
			</table>
		</td>
	</tr>
</table>


</html>