<%@ page language="java"%><%@ page import="xpolog.eye.error.*"%><%@ page import="xpolog.eye.*"%><%@ page import="xpolog.eye.remote.*"%><%@ page import="xpolog.eye.remote.*"%><%@ page import="java.io.*"%><%@ page import="java.util.*"%><%@ page import="xpolog.eye.data.source.*"%><%@ page import="xpolog.eye.security.*"%><%@ page import="java.util.zip.*"%><%
	String logId = request.getParameter("logId");
	String sesid = request.getParameter("sessionId");
	String command = request.getParameter("command");
	String user = request.getParameter("user");
	String applicationId = request.getParameter("applicationId");
	if(user == null){
		user = "";
	}
	String password = request.getParameter("password");
	LogBrowsingManager lbm = null;
	SiteManagment mgmt = SiteManagment.getInstance();
	ObjectOutputStream os = null;
	try {
	UserSecurity userSec = null;
	try{
		if(WebSecurityManager.getInstance().isSecurityEnabled()){
			userSec = WebSecurityManager.getInstance().autenticate(user,password);
		}
	}catch(Exception e){}
	xpolog.eye.site.UserContext userContext = new xpolog.eye.site.UserContext();
	userContext.setUser(userSec);
	if (applicationId != null && applicationId.length() > 0){
		HashSet set = new HashSet();
		set.add(applicationId);
		userContext.setIncludeSet(set);
	}
	
	
	String resp = "";
	if(command != null){
		if(command.equals("getConfiguration")){
			//response.setHeader("Content-Type", "text/xml");
			response.setHeader("Content-Type", "application/octet-stream");
			File conf =  mgmt.getLogBrowserConfigFile(logId);
			boolean deleteFile = false;
      LogBrowsingManager lbm1 = mgmt.getLogBrowserManager(logId);
      if (lbm1 != null && lbm1 instanceof ProxyLogBrowser){
        lbm = ((ProxyLogBrowser)lbm1).getLogBrowsingManager();
        /*
        xpolog.eye.data.linear.LinearDataBuilder builder = lbm.getLinearDataBuilder();
        if (builder instanceof ProxyDataBuilder){
        	ProxyDataBuilder proxyBuilder = (ProxyDataBuilder)builder;
        	lbm.setLinearDataBuilder(proxyBuilder.getRemoteBuilder());
        }
        */
				
        conf = File.createTempFile("remote",".xml",new File(xpolog.config.Configuration.XPOLOG_TEMP_PATH));
        SiteManagment.getAdminInstance().saveLogBrowser(lbm,conf.getAbsolutePath());
        deleteFile = true;
      }else if (lbm1 != null && lbm1 instanceof xpolog.eye.merge.MergedLogBrowserManager){
      	xpolog.eye.merge.MergeBrowsingInfo mergeInfo = (xpolog.eye.merge.MergeBrowsingInfo)lbm1.getDataBrowserInfo();        
        mergeInfo.setAppendLogsConf(true);
        
        conf = File.createTempFile("remote",".xml",new File(xpolog.config.Configuration.XPOLOG_TEMP_PATH));
        SiteManagment.getAdminInstance().saveLogBrowser(lbm1,conf.getAbsolutePath());
        deleteFile = true;
      }

			//prepare the output stream.
			
			try {
				GZIPOutputStream gzos = new GZIPOutputStream(response.getOutputStream());
				os = new ObjectOutputStream(gzos);
				//os = new ObjectOutputStream(response.getOutputStream());
			}catch (Exception e) {
				ErrorModel.log.error("could not get input stream",e);
				if (deleteFile){
					ErrorModel.log.debug("delete file = " + conf.getAbsolutePath());
				  conf.delete();
				}
				return;
			}
			if (conf.exists()){
				RandomAccessFile f = new RandomAccessFile(conf,"r");
				int i = (int)f.length();
				byte[] ba = new byte[i];
				f.readFully(ba);
				os.writeInt(i);
				os.write(ba);
				os.flush();
				os.close();
				f.close();
			}else {
				os.writeInt(0);
				os.close();
			}
			os = null;
			if (deleteFile){
				ErrorModel.log.debug("delete file = " + conf.getAbsolutePath());
			  
			  conf.delete();
			}
		}else if(command.equals("getLogList")){
			response.setHeader("Content-Type", "application/octet-stream");
			ModuleMember[] mema = new ModuleMember[0];
			if(WebSecurityManager.getInstance().isSecurityEnabled()){
				try{
				  if (userSec != null){
  				 	mema = mgmt.getAllLogBrowsersIds(userContext,false);
  				}
				}catch(Exception e){}
			}else{
				mema = mgmt.getAllLogBrowsersIds();
			}
			os = new ObjectOutputStream(response.getOutputStream());
			os.writeInt(mema.length);
			for (int i = 0; i < mema.length; i++) {
				os.writeObject(mema[i]);				
			}
			os.flush();
			os.close();
			os = null;
		}else if(command.equals("getFilterManager")){
			response.setHeader("Content-Type", "application/octet-stream");
			xpolog.eye.data.filters.FilterManager fm = mgmt.getLogBrowserManager(logId).getFilterManager();
			GZIPOutputStream gzos = new GZIPOutputStream(response.getOutputStream());
			os = new ObjectOutputStream(gzos);
			os.writeObject(fm);
			os.flush();
			os.close();
			os = null;
		}else if(command.equals("logVerification")){ 
			boolean result = false;
			response.setHeader("Content-Type", "application/octet-stream");			
			if(WebSecurityManager.getInstance().isSecurityEnabled()){
				try{
				  if (userSec != null){
					result = userSec.isModuleMemberVisible(logId);					
  				}
				}catch(Exception e){
					result = false;
				}
			}else{
				if(logId != null){
					try{
						ModuleMember localMem = mgmt.getModuleMember(logId);
						result = localMem == null ? false : true;							
					}catch(Exception e){
						result = false;
					}
				}else{
					result = false;
				}
			}
			os = new ObjectOutputStream(response.getOutputStream());
			os.writeBoolean(result);
			os.flush();
			os.close();
			os = null;
		}
	}
	}catch (Throwable e1){
		ErrorModel.log.error("Failue occured in logConfApi",e1);
	}finally {
		if (os != null){
			try {
	  		os.flush();
  			os.close();
			}catch (Exception e){}
		}
	}
%>