<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%!
	static final String BASE_DIRECTORY = "../";

  String millisecondsSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator",".");

  String calendarDateFormat = "MM/dd/yyyy HH:mm:ss";
  String calendarDateFormatMS = calendarDateFormat+millisecondsSeperator+"SSS";

  String xpologDateFormat = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
  String xpologDateFormatMS = xpologDateFormat+millisecondsSeperator+"SSS";
  
  public long getDateFromXpologString(String date){
  	if (date==null || date.length()==0){
  		return -1;
  	}
  	Date d;
  	SimpleDateFormat sdf = new SimpleDateFormat(xpologDateFormatMS);
  	try{
  		d = sdf.parse(date);
  		String sd = sdf.format(d);
  		if (sd.equals(date)){
	  		return d.getTime();
	  	}else{
	  		return -1;
	  	}
  	}catch(Exception e){
  		sdf.applyPattern(xpologDateFormat);
  		try{
	  		d = sdf.parse(date);
	  		String sd = sdf.format(d);
	  		if (sd.equals(date)){
		  		return d.getTime();
		  	}else{
		  		return -1;
		  	}
  		}catch(Exception e2){
  			return -1;
  		}
  	}
  }

  public long getDateFromCalendarString(String date){
  	//System.out.println("date="+date);
  	if (date==null || date.length()==0){
  		return -1;
  	}
  	Date d;
  	SimpleDateFormat sdf = new SimpleDateFormat(calendarDateFormatMS);
  	try{
  		d = sdf.parse(date);
  		String sd = sdf.format(d);
  		if (sd.equals(date)){
	  		return d.getTime();
	  	}else{
	  		return -1;
	  	}
  	}catch(Exception e){
  		sdf.applyPattern(calendarDateFormat);
  		try{
	  		d = sdf.parse(date);
	  		String sd = sdf.format(d);
	  		if (sd.equals(date)){
		  		return d.getTime();
		  	}else{
		  		return -1;
		  	}
  		}catch(Exception e2){
  			return -1;
  		}
  	}
  }

%>



<%
	String ERROR_OBJ = "ERROR_OBJ";

	String datetimeStr = request.getParameter("datetimeStr");
	boolean datetimeStrEmpty = (datetimeStr==null || datetimeStr.length()==0);
	String datetimeLong = request.getParameter("datetime");
	long datetime = -1;
	if (datetimeLong != null && datetimeLong.length() > 0){
		try{
			datetime = Long.parseLong(datetimeLong);
		}catch(Exception e){
		}
	}
	if (datetime == -1){
		datetime = getDateFromXpologString(datetimeStr);
	}
  if(!datetimeStrEmpty && datetime==-1){
    ErrorModel errmodel = new ErrorModel();
    errmodel.addError("Date entered does not correspond with your XpoLog date format.");
    errmodel.addError("<br>");
    errmodel.addError("Please check your entry again");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect("dateErrorPage.jsp?closeWindow=true");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		return;
  }
	String id = request.getParameter("id");
	
%>

<html>
<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<title>Select Date, Please.</title>
<style>
	td {font-family: Tahoma, Verdana, sans-serif; font-size: 12px;}
</style>
<script language="JavaScript">

// months as they appear in the calendar's title
var ARR_MONTHS = ["January", "February", "March", "April", "May", "June",
		"July", "August", "September", "October", "November", "December"];
// week day titles as they appear on the calendar
var ARR_WEEKDAYS = ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"];
// day week starts from (normally 0-Mo or 1-Su)
var NUM_WEEKSTART = 1;
// path to the directory where calendar images are stored. trailing slash req.
var STR_ICONPATH = '../images/calendar/img/';
var re_url = new RegExp('datetime=(\\-?\\d+)');
//var dt_current = (re_url.exec(String(window.location)) ? new Date(new Number(RegExp.$1)) : new Date());
//var dt_current = <%=datetimeStr != null ? "Date(new Number("+datetimeStr+"))" : "new Date()"%>;
<% if (datetime != -1) {%>
var dt_current = new Date(new Number(<%=datetime%>));
<%} else {%>
var dt_current = new Date();
<%}%>
var re_id = new RegExp('id=(\\d+)');
//var num_id = (re_id.exec(String(window.location)) ? new Number(RegExp.$1) : 0);
//var num_id = <%=id != null ? "new Number("+id+")" : "0"%>;
<% if (id != null) {%>
var num_id = new Number(<%=id%>);
<%} else {%>
var dt_current = 0;
<%}%>
var obj_caller = (window.opener ? window.opener.calendars[num_id] : null);
var calendar_base_directory = "../";

if (obj_caller && obj_caller.year_scroll) {
	// get same date in the previous year
	var dt_prev_year = new Date(dt_current);
	dt_prev_year.setFullYear(dt_prev_year.getFullYear() - 1);
	if (dt_prev_year.getDate() != dt_current.getDate())
		dt_prev_year.setDate(0);
	
	// get same date in the next year
	var dt_next_year = new Date(dt_current);
	dt_next_year.setFullYear(dt_next_year.getFullYear() + 1);
	if (dt_next_year.getDate() != dt_current.getDate())
		dt_next_year.setDate(0);
}

// get same date in the previous month
var dt_prev_month = new Date(dt_current);
dt_prev_month.setMonth(dt_prev_month.getMonth() - 1);
if (dt_prev_month.getDate() != dt_current.getDate())
	dt_prev_month.setDate(0);

// get same date in the next month
var dt_next_month = new Date(dt_current);
dt_next_month.setMonth(dt_next_month.getMonth() + 1);
if (dt_next_month.getDate() != dt_current.getDate())
	dt_next_month.setDate(0);

// get first day to display in the grid for current month
var dt_firstday = new Date(dt_current);
dt_firstday.setDate(1);
dt_firstday.setDate(1 - (7 + dt_firstday.getDay() - NUM_WEEKSTART) % 7);

// function passing selected date to calling window
function set_datetime(n_datetime, b_close) {
	if (!obj_caller) return;
	var dt_datetime = obj_caller.prs_time(
		(document.cal ? document.cal.time.value : ''),
		new Date(n_datetime)
	);
	if (!dt_datetime) return;
	if (b_close) {
		var str_datetime = (document.cal
			? obj_caller.gen_tsmp(dt_datetime)
			: obj_caller.gen_date(dt_datetime)
		);
		document.returnDateValue.dateTimeStr.value = str_datetime;
		document.returnDateValue.cal_id.value = num_id;
		document.returnDateValue.submit();
	}
	else {
		obj_caller.popup_bd(calendar_base_directory,dt_datetime.valueOf());	
	}
}

</script>
</head>
<body bgcolor="#FFFFFF" marginheight="5" marginwidth="5" topmargin="5" leftmargin="5" rightmargin="5">
<form AUTOCOMPLETE="OFF"  name="returnDateValue" method="post" action="dateConverter.jsp">
	<input type="hidden" name="cal_id">
	<input type="hidden" name="dateTimeStr">
</form>
<table class="clsOTable" cellspacing="0" border="0" width="100%">
<tr><td bgcolor="#4682B4">
<table cellspacing="1" cellpadding="3" border="0" width="100%">
<tr><td colspan="7"><table cellspacing="0" cellpadding="0" border="0" width="100%">
<tr>
<script language="JavaScript">
document.write(
'<td>'+(obj_caller&&obj_caller.year_scroll?'<a href="javascript:set_datetime('+dt_prev_year.valueOf()+')"><img src="'+STR_ICONPATH+'prev_year.gif" width="16" height="16" border="0" alt="previous year"></a>&nbsp;':'')+'<a href="javascript:set_datetime('+dt_prev_month.valueOf()+')"><img src="'+STR_ICONPATH+'prev.gif" width="16" height="16" border="0" alt="previous month"></a></td>'+
'<td align="center" width="100%"><font color="#ffffff">'+ARR_MONTHS[dt_current.getMonth()]+' '+dt_current.getFullYear() + '</font></td>'+
'<td><a href="javascript:set_datetime('+dt_next_month.valueOf()+')"><img src="'+STR_ICONPATH+'next.gif" width="16" height="16" border="0" alt="next month"></a>'+(obj_caller && obj_caller.year_scroll?'&nbsp;<a href="javascript:set_datetime('+dt_next_year.valueOf()+')"><img src="'+STR_ICONPATH+'next_year.gif" width="16" height="16" border="0" alt="next year"></a>':'')+'</td>'
);
</script>
</tr>
</table></td></tr>
<tr>
<script language="JavaScript">

// print weekdays titles
for (var n=0; n<7; n++)
	document.write('<td bgcolor="#87cefa" align="center"><font color="#ffffff">'+ARR_WEEKDAYS[(NUM_WEEKSTART+n)%7]+'</font></td>');
document.write('</tr>');

// print calendar table
var dt_current_day = new Date(dt_firstday);
while (dt_current_day.getMonth() == dt_current.getMonth() ||
	dt_current_day.getMonth() == dt_firstday.getMonth()) {
	// print row heder
	document.write('<tr>');
	for (var n_current_wday=0; n_current_wday<7; n_current_wday++) {
		if (dt_current_day.getDate() == dt_current.getDate() &&
			dt_current_day.getMonth() == dt_current.getMonth())
			// print current date
			document.write('<td bgcolor="#ffb6c1" align="center" width="14%">');
		else if (dt_current_day.getDay() == 0 || dt_current_day.getDay() == 6)
			// weekend days
			document.write('<td bgcolor="#dbeaf5" align="center" width="14%">');
		else
			// print working days of current month
			document.write('<td bgcolor="#ffffff" align="center" width="14%">');

		document.write('<a href="javascript:set_datetime('+dt_current_day.valueOf() +', true);">');

		if (dt_current_day.getMonth() == this.dt_current.getMonth())
			// print days of current month
			document.write('<font color="#000000">');
		else 
			// print days of other months
			document.write('<font color="#606060">');
			
		document.write(dt_current_day.getDate()+'</font></a></td>');
		dt_current_day.setDate(dt_current_day.getDate()+1);
	}
	// print row footer
	document.write('</tr>');
}
if (obj_caller && obj_caller.time_comp)
	document.write('<form AUTOCOMPLETE="OFF"  onsubmit="javascript:set_datetime('+dt_current.valueOf()+', true);return false" name="cal"><tr><td colspan="7" bgcolor="#87CEFA"><font color="White" face="tahoma, verdana" size="2">Time: <input type="text" name="time" value="'+obj_caller.gen_time(this.dt_current)+'" size="12" maxlength="12"></font></tr></form>');
</script>
</table></tr></td>
</table>
<form AUTOCOMPLETE="OFF" name="dateError" method="post" action="dateError.jsp">
</form>
</body>
</html>
