<%@ page language="java"%>
 
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.cloud.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%!
	static final String BASE_DIRECTORY = "../";
%>
<%  

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ENTERPRISE_PERMISSION,true)){
     return;
  }
  
  String ERROR_OBJ = "ERROR_OBJ";
  String NodeName = "nodeName"; 
  String nodeName = request.getParameter(NodeName);
  
    
  SiteManagment mgmt = SiteManagment.getInstance();
  CloudMgr cmgr = mgmt.getCloudMgr();
  UserContext userContext = UserEnvironment.getUserContext(request);
  XplgNode[] listn = cmgr.getAllXplgNodes(userContext);
  XplgNode[] list = null;
  
  if(nodeName != null){
    nodeName = nodeName.toLowerCase();
  	String n = null;
  	ArrayList l = new ArrayList();
  	for (int i = 0; i < listn.length; i++) {
  		n = listn[i].getName();
  		if((n != null)){
  		 n = n.toLowerCase();
  		 if  (n.indexOf(nodeName) > -1){
  			l.add(listn[i]);
  		 }
    	}
	}
	list = (XplgNode[]) l.toArray(new XplgNode[l.size()]);
  }else{
  	list = listn;
  }
  
  list = CloudUtil.sortArrayByName(list);
%>

<html>

<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
  function filterType(){
  	document.access.action = "cloud.jsp";
  	document.access.submit();
  }
  
  function goEdit(id){
  	path = "nodeHttp.jsp?id="+id;
  	document.location = path;
  }
  
  function goNew(){
		path = "nodeHttp.jsp";
  		document.location = path;
  }
  
  function doDelete(id){
  	path = "nodeRemoveAction.jsp?id=" + id;
  	document.location = path;
  }
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">XpoLog Enterprise Cloud</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="53">
                  <tr>
                    <td><span class="REGULARTEXT">Search&nbsp; <span class="REGULARTEXT"><input type=text class="TEXTBOX" size="25" name="nodeName"/>
                     </span></span><a href="javascript:filterType()" class="LINK">go</a>&nbsp;
                      <a href="cloud.jsp" class="LINK">reset</a></td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td><span class="REGULARTEXT"><a href="javascript:goNew()" class="LINK">Add
                      Remote XpoLog</a></span></td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr class="TABLES_HEADERS">
                        <td width="18%"><span class="REGULARTEXT">Name</span></td>
                        <td width="30%"><span class="REGULARTEXT">Description</span></td>
                        <td width="15%"><span class="REGULARTEXT">Location</span></td>
                        <td width="15%"><span class="REGULARTEXT">Type</span></td>
                        <td width="20%">&nbsp;</td>
                        <td width="3%">&nbsp;</td>
                      </tr>
                     <%
                      for(int t=0;t<list.length;t++){
                     %>
                      <tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
			  				   <td width="18%" nowrap><a href="cloudAction.jsp?NODE_ID=<%=list[t].getId()%>" class="LINK"><%=list[t].getName()%></a></td>
                          <td width="30%" nowrap><span class="REGULARTEXT"><%=list[t].getDescription()%></span></td>
                          <td width="15%" nowrap><span class="REGULARTEXT"><%=list[t].getHost()%></span></td>
                          <td width="15%" nowrap><span class="REGULARTEXT"><%=list[t].getContype()%></span></td>
                          <td width="20%" nowrap>&nbsp;<a href="javascript:goEdit('<%=list[t].getId()%>')" class="LINK">edit</a>
                            <a href="javascript:doDelete('<%=list[t].getId()%>')" class="LINK">delete</a></td>
                        <td width="3%" nowrap></td>
                       </tr>
                      <%
                        }
                      %>
                        <tr>
			  				   <td width="18%"></td>
                          <td width="30%"></td>
                          <td width="15%"></td>
                          <td width="15%"></td>
                          <td width="20%"></td>
                          <td width="3%"></td>

                       </tr>
                    </table>
                   </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="35%">&nbsp;</td>
                    <td width="13%" align="center"><a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK">
                    cancel</a></td>
                    <td width="5%" align="center"></td>
                    <td width="27%">&nbsp;</td>
                    <td width="20%">&nbsp;</td>
                  </tr>
                </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>