<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.cloud.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.net.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%> 
<%@page import="xpolog.config.Configuration"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  String NODE_ID = "NODE_ID";

  SiteManagment mgmt = SiteManagment.getInstance();
  CloudMgr cmgr = mgmt.getCloudMgr();
  String nid = request.getParameter(NODE_ID);
  String externalRefStr = request.getParameter("externalRef");
  boolean externalRef = externalRefStr != null && externalRefStr.equals("true");
  if(nid == null){
    if (!externalRef){
    	response.sendRedirect("cloud.jsp");
    }
  	return;
  }
  XplgNode node = cmgr.getNodeById(nid);
  
  
  URL url = CloudUtil.createUrl(node);
  boolean conSOK = CloudUtil.checkConnection(url);
  
  if(!conSOK){
  	response.sendRedirect("clientCloudConnector.jsp?id="+nid + "&externalRef=" + externalRef);
  	return;
  }
  
  //redirect by propfile
  String nodeRedirctUrl = Configuration.getInstance().getPropertiesManager().getProperty("defaultEnterpriseRedirectUrl", "");
  //server connection ok
  //client side urls and test
   String sucUrl = request.getParameter("sucUrl");
  String failUrl = request.getParameter("failUrl");
  if (sucUrl == null || sucUrl.length() == 0){
    sucUrl = nodeRedirctUrl.equals("") ? "index.html" : nodeRedirctUrl;
  }
  if (failUrl == null || failUrl.length() == 0){
    failUrl = "index.html";
  }
  
  String hostHome = url.toString();
  String link = hostHome;
  if(node.isAutoLogin()){
	  link = link +  "security/auth/loginAction.jsp?successURL=" + sucUrl;
  }else {
    link = link + sucUrl;
  }
  
 
  
%>
<html>
<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<script>
function doRedirect(){
  document.access.submit();
}
</script>
</head>
<body onLoad="doRedirect()">
<form AUTOCOMPLETE="OFF" id="access" name="access" action="<%=link%>"  method="post" target="_top">
<% if (node.isAutoLogin()){%>
<input type="hidden" name="username" value="<%=node.getUserName()%>">
<input type="hidden" name="password" value="<%=node.getPassword()%>">
<input type="hidden" name="successURL" value="<%=sucUrl%>">
<input type="hidden" name="failURL" value="<%=failUrl%>">
<%}%>
</form>
</body>
</html>

