<%@ page language="java"%>
<%@ page import="xpolog.tools.XpologSystemInfo"%>

<%
	String BASE_DIR = "base_directory";
	String ACC_DIV = "accDiv";
	String POS_LEFT = "posLeft";
	String POS_TOP = "posTop";
	String CSS_BGCOLOR = "cssBgcolor";
	
	String baseDir = request.getParameter(BASE_DIR);
	if (baseDir == null || baseDir.equals("")) {
		baseDir = "";
	}
	String accDiv = request.getParameter(ACC_DIV);
	if (accDiv == null || accDiv.equals("")) {
		accDiv = "";
	}
	
	String posLeft = request.getParameter(POS_LEFT);
	if (posLeft == null || posLeft.equals("")) {
		posLeft = "30px";
	}
	String posTop = request.getParameter(POS_TOP);
	if (posTop == null || posTop.equals("")) {
		posTop = "110px";
	}
	String cssBgcolor = request.getParameter(CSS_BGCOLOR);
	if (cssBgcolor == null || cssBgcolor.equals("")) {
		cssBgcolor = "#EEF2F5";
	}
	String zIndex = request.getParameter("zIndex");
	if(zIndex == null || zIndex.equals("")) {
		zIndex = "110";
	}
	boolean isWindows = XpologSystemInfo.isWindows();
%>
<script>
		
		var contextreq;		
		var accDiv = "<%=accDiv%>";
		
		function GetXmlHttpObject()
		{
			var contextreq=null;
			try {
				  // Firefox, Opera 8.0+, Safari
				  contextreq=new XMLHttpRequest();
			}catch (e)		  {
			  // Internet Explorer
		  	try{
			    contextreq=new ActiveXObject("Msxml2.XMLHTTP");
			    }catch (e)			    {
				    contextreq=new ActiveXObject("Microsoft.XMLHTTP");
			    }
			  }
			return contextreq;
		}
		
		function addAccount(){
			disableAddHostElements(true);
			var url = "<%=baseDir%>common/addAccountAction.jsp?";
			var params = buildParametersStr();
			contextreq = GetXmlHttpObject();
			contextreq.open('POST', url, true);
			contextreq.onreadystatechange = addAccountCallback;
			contextreq.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		  contextreq.setRequestHeader("Content-length", params.length);
		  contextreq.setRequestHeader("Connection", "close");
		  contextreq.send(params);  					
		}
		
		function addAccountCallback() {
			if (contextreq.readyState == 4) {
					if (contextreq.status == 200) {
						var val = contextreq.responseText;					
						if (!val){
							val = "";							
						}
						val = val.replace(/^\s+|\s+$/g, '') ;
						if(val.indexOf("AccountSaved:") > -1){ //NEW ACC ID WAS RETURNED
							val = val.replace("AccountSaved:","");
							var arr = val.split("#");
							var accId = "";
							var accName = "";
							var accType = "";
							if(arr != null && arr[0] != null){
								accId = arr[0]
							}
							if(arr != null && arr[1] != null){
								accName = arr[1]
							}
							if(arr != null && arr[2] != null){
								accType = arr[2]
							}
							updateNewAccDiv(accId,accName,accType);
						}else{
							updateMsgResult(val)													
						}
					}
			}
		}
		
		function buildParametersStr(){
			var parameters = "host=" + document.getElementById("hostID").value;
			parameters += "&osType=" + document.getElementById("osType").value;
			parameters += "&port=" + document.getElementById("port").value;
			parameters += "&username=" + document.getElementById("username").value;
			parameters += "&password=" + document.getElementById("password").value;
			return parameters;		
		}
		
		function updateNewAccDiv(accId,accName,accType){
			if(accDiv == null || accDiv.length == 0 || accId == null || accId.length == 0 ||
					accName == null || accName.length == 0){
					updateMsgResult("can't create new account");
			}else{
						var optionsElem = document.getElementById(accDiv);
						var accTxtName = accType != null && accType.length > 0 ? accName + "(" + accType + ")" : accName;
	  				optionsElem.options[optionsElem.options.length] = new Option(accTxtName,accId);
	  				optionsElem.selectedIndex = (optionsElem.options.length - 1);
	  				//override this function when
	  				//including this div (addAccount.jsp)
	  				handleNewAcc(accId);
		  			CancelDiv();				
				}				
		}
		
		
		function updateMsgResult(msg){
				disableAddHostElements(false);
				handleAddHostMessageDiv("errorMessage:" + msg);	
		}
		
		function disableAddHostElements(disabled) {
			var hostID = document.getElementById("hostID");
			hostID.disabled = disabled;
			var osType = document.getElementById("osType");
			osType.disabled = disabled;
			var port = document.getElementById("port");
			port.disabled = disabled;
			var username = document.getElementById("username");
			username.disabled = disabled;
			var password = document.getElementById("password");
			password.disabled = disabled;			
		}
		
		function clearAddAccElements() {
			document.getElementById("hostID").value = "";
			document.getElementById("port").value = "";
			document.getElementById("username").value = "";
			document.getElementById("password").value = "";
			document.getElementById("verfiyMsgDiv").style.display = "none";;
			document.getElementById("verfiyMsgDiv").innerHTML = "";
			var osType = document.getElementById("osType");
			if(osType.value == "windows") {
				document.getElementById("hostID").disabled = true;
				document.getElementById("port").disabled = true;			
			}
		}
		

		function CancelDiv(){		
			document.getElementById("addAccDiv").style.display = "none";
  		document.getElementById("addAccIframe").style.display = "none";
  		disableAddHostElements(false);
  		clearAddAccElements();
		}
		
		function changeOsType() {
			var osType = document.getElementById("osType");
			var port = document.getElementById("port");
			var hostID = document.getElementById("hostID");
			var verifyLink = document.getElementById("verifyLinkId");
			document.getElementById("verfiyMsgDiv").innerHTML = "";
			if(osType.value == "windows") {
				port.disabled = true;
				port.value = "";
				hostID.disabled = true;
				hostID.value = "";				
				verifyLink.style.display = "none";
			}else {
				port.disabled = false;
				port.value = "22";			
				hostID.disabled = false;
				hostID.value = "";
				verifyLink.style.display = "";
			}
		}
		
		function handleAddHostMessageDiv(message) {
			var addHostMessageDiv = document.getElementById("verfiyMsgDiv");
			if(message == "") {
				addHostMessageDiv.style.display = "none";
			}else {
				addHostMessageDiv.style.display = "";
				message = remove(message, "errorMessage:");
			}
			addHostMessageDiv.innerHTML = message;
		}
		
		
		function remove(s, t) {
		  i = s.indexOf(t);
		  r = "";
		  if(i == -1) {
		  	return s;
		  }
		  r += s.substring(0, i) + remove(s.substring(i + t.length), t);
		  return r;
		}
		

		function verifyAccount(){
			var newLogDiv = document.getElementById("adminGeneralIncludeTDNewLog");
			if (newLogDiv){
				newLogDiv.scrollTop = newLogDiv.scrollHeight;
			}
			disableAddHostElements(true);
			var url = "<%=baseDir%>common/verifyAccountAction.jsp?";
			var params = buildParametersStr();
			contextreq = GetXmlHttpObject();
			contextreq.open('POST', url, true);
			contextreq.onreadystatechange = verifyAccountCallback;
			contextreq.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		  contextreq.setRequestHeader("Content-length", params.length);
		  contextreq.setRequestHeader("Connection", "close");
		  contextreq.send(params);  					
		}
		
		
		function verifyAccountCallback(){
			if (contextreq.readyState == 4) {
					if (contextreq.status == 200) {
						var val = contextreq.responseText;					
						if (!val){
							val = "";							
						}
						val = val.replace(/^\s+|\s+$/g, '') ;
						updateMsgResult(val);													
					}
			}
		}
		
</script>
<div id="addAccDiv" style="position:absolute;left:<%=posLeft%>;top:<%=posTop%>;height:90px;width:500px;display:none;z-index:<%=zIndex %>">
<table border="0" width="100%" cellspacing="0" height="100%" style="background:white;border:2px solid #DBDFE2">
	<tr>
			<td align="center" height="25" style="border-bottom:solid 2px #DBDFE2" bgcolor="<%=cssBgcolor%>">
					<span class="PROGRESSTEXT">Add Account</span>
			</td>		
	</tr>					
	<tr>
		<td>				
				 <table border="0" width="100%" width="100%" >
						<tr>
								<td>&nbsp;</td>
						</tr>
				    <tr>
							<td width="3%"style="font-size:3pt">&nbsp;</td>
				      <td>
				       	<table border="0" width="100%" >
				       		<tr>
				     					<td>
				     							<table border="0" width="100%" cellspacing="0" cellpadding="0">
											       		<tr>
												       		<td width="18%" style="padding-left:18"><span class="PROGRESSTEXT">OS Type</span></td>
											         		<td width="15%" style="padding-left:24"><span class="PROGRESSTEXT">Host</span></td>				       	 		
											       		 	<td width="15%" style="padding-left:24"><span class="PROGRESSTEXT">Port</span></td>
											         		<td width="15%" style="padding-left:8"><span class="PROGRESSTEXT">Username</span></td>
											         		<td width="15%" style="padding-left:8"><span class="PROGRESSTEXT">Password</span></td>
											     			</tr>	     			
								     			</table>
						     			</td>
				     			</tr>
				     			<tr>
				     					<td>
				     							<table border="0" width="100%" cellspacing="1" cellpadding="4" bgcolor="<%=cssBgcolor%>" >
											          <tr height="3px">
													          <td width="18%">
													          	<select name="osType" id="osType" class="TEXT_BOX" onChange="javascript:changeOsType()" size="1">
													          		<%if (isWindows){%>
													          		<option value="windows">Windows</option>
													          		<%}%>
													          		<option value="unix">Unix based</option></select>
													          </td>	
													          <td width="15%"><input type="text" name="hostName" id="hostID" class="TEXT_BOX" <%if(isWindows) {%>disabled<%}%> size="12" value=""></td>
													          <td width="15%"><input type="text" name="port" id="port" class="TEXT_BOX" <%if(isWindows) {%>disabled<%}else { %>value="22" <%} %> size="12"></td>
													          <td width="15%"><input type="text" name="username" id="username" class="TEXT_BOX" size="12" ></td>
													          <td width="15%"><input type="password" name="password" id="password" class="TEXT_BOX" size="12" ></td>
												    	   </tr>
												    </table>
												  </td>
												</tr>    	   
				  	        <tr height="12">
					          	<td colspan="8" style="font-size:11;color: red;">
          								<div id="verfiyMsgDiv" style="display:none"></div>
					          	</td>
					          </tr>
				          </table>
				     	</td>
				     	<td width="3%" style="font-size:3pt">&nbsp;</td>
				    </tr>
					</table>				
		</td>
	</tr>	
	<tr>
		<td>
			<table border="0" cellpadding="2" cellspacing="0" style="border-collapse: collapse" width="100%" >
				<tr >
					<td width="30%" style="padding-top:8;padding-bottom:4">&nbsp;</td>
					<td valign="top" width="11%" >
						<div id="verifyLinkId" style="<%if (isWindows){%>display:none<%}%>">
							<a class="PROGRESSLINK" href="javascript:verifyAccount();">Verify</a>&nbsp;<nobr>
						</div>	
					</td>
					<td valign="top" width="10%">
							<a class="PROGRESSLINK" href="javascript:addAccount();">Add</a>&nbsp;<nobr>
					</td>
					<td valign="top" width="30%">
							<a class="PROGRESSLINK" href="javascript:CancelDiv();">Cancel</a>&nbsp;<nobr>
					</td>									
					
					<td width="45%">&nbsp;</td>					
				</tr>
			</table>
		</td>
	</tr> 	
</table>
</div>
<iframe id="addAccIframe" src="<%=baseDir%>empty.html"  style="position:absolute;left:<%=posLeft%>;top:<%=posTop%>;height:90px;width:500px;display:none;z-index:100"></iframe> 
