<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.media.telsh.TelnetAccount"%>
<%@page import="xpolog.eye.media.auth.win.WinAuthenticationAccount"%>
<%@page import="xpolog.eye.media.AddressBook"%>
<%@ page language="java"%>


<%!
	private String verifyHost(String osType, String host, int port,
					String username, String password) {
		String verified = null;

		if (osType == null || osType.equals("")) {
			verified = "OS Type was not specified";
		}else if (!osType.equals("windows") && (host == null || host.equals(""))) {
			verified = "Host was not specified";
		}else if (!osType.equals("windows")) {
			try {
				if (username == null || username.equals("")) {
					verified = "Username was not specified";
				}else if (password == null || password.equals("")) {
					verified = "Password was not specified";
				}else {
					if (port < 1 || port > 65535) {
						verified = "Port is not valid (should be a number between 1 and 65535)";
					}
				}
			}catch (Exception e) {
				verified = "Unknown host " + host;
			}
		}else {
			try {
				if (username == null || username.equals("")) {
					if (password == null || password.equals("")) {
						verified = "Username and password were not specified";
					}else {
						verified = "Username was not specified";
					}
				}else if (password == null || password.equals("")) {
					verified = "Password was not specified";
				}
			}catch (Exception e) {
				verified = "Unknown host " + host;
			}
		}

		return verified;
	}
	
		
%>


<%

			String result = "";
			String newAccId="";
			String osType = request.getParameter("osType");
			String host = request.getParameter("host");
			String portStr = request.getParameter("port");
			int port = -1;
			try {
				port = Integer.parseInt(portStr);
			}catch (NumberFormatException nfe) {
				port = -1;
			}
			String username = request.getParameter("username");
			String password = request.getParameter("password");
			String error = verifyHost(osType, host, port, username, password);
			if (error != null) {
				result = error;
			}else {
				try{
					AddressBook adbok = AddressBook.getInstance();
					UserContext userContext = UserEnvironment.getUserContext(request);
					//CREATE AUTH ACC
					if(osType.equals("windows")){
						WinAuthenticationAccount ac =  new WinAuthenticationAccount();
						String name = "win " + username ;
						ac.setAccountName(name);
						ac.setPassword(password);
						ac.setUser(username);
						ac.setDescription("");
						ac.setDefault(true);
						adbok.addAccount(ac,userContext);
						adbok.saveAddressBook();
						newAccId = ac.getId();
						result = "AccountSaved:"+newAccId+"#"+name+"#"+"auth";
					//CREATE SSH ACC
					}else{
						TelnetAccount ftac = new TelnetAccount();
						String name = "ssh " + username + "@" + host;
						ftac.setAccountName(name);
						ftac.setNetAddress(host);
						ftac.setPassword(password);
						ftac.setPort(port);
						ftac.setUserName(username);
						ftac.setDescription("");
						ftac.setCertificate(false);
						ftac.setCertificateId("");
						ftac.setMediaClass(null);
						adbok.addAccount(ftac,userContext);
						adbok.saveAddressBook();
						newAccId = ftac.getId();
						result = "AccountSaved:"+newAccId+"#"+name+"#"+"ssh";
					}
				}catch(Exception e){
					result = "problems while saving " +host+ " ." ;
				}
			}

			response.setContentType("text/xml");
			out.write(result);
			out.flush();
%>