<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	boolean allowNewFilter = true;
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.AdministrationPermissions.EDIT_LOG_PERMISSION,false)){
		allowNewFilter = false;
  }
  
  String baseDirectory = request.getParameter("baseDirectory");
  if (baseDirectory == null){
  	baseDirectory = BASE_DIRECTORY;
  }
  
  String PREFIX = request.getParameter("PREFIX");
  if (PREFIX == null || PREFIX.length() == 0){
  	PREFIX = "";
  }
  
  String showDivStr = request.getParameter("showDiv");
  boolean showDiv = showDivStr == null || showDivStr.equals("true");
  
  String divStyle = request.getParameter("divStyle");
  if (divStyle == null || divStyle.length() == 0){
  	divStyle = "position:absolute;width:400;height:200;display:none";
  }

  String showTableHeaderStr = request.getParameter("showTableHeader");
  boolean showTableHeader = showTableHeaderStr == null || showTableHeaderStr.equals("true");

  String tableStyle = request.getParameter("tableStyle");
  if (tableStyle == null || divStyle.length() == 0){
  	tableStyle = "background:white;border:2px solid #DBDFE2";
  }else if (tableStyle.equals("none")){
  	tableStyle = "";
  }

  String showActionsStr = request.getParameter("showActions");
  boolean showActions = showActionsStr == null || showActionsStr.equals("true");

  String embeddedStr = request.getParameter("embedded");
  boolean embedded = embeddedStr == null || embeddedStr.equals("true");
  
  String newFilterLabel = request.getParameter("newFilterLabel");
  if(newFilterLabel == null || newFilterLabel.length() == 0) {
  	newFilterLabel = "Contains text";
  }
%>
<%if(allowNewFilter) { %>
<%if (showDiv && !embedded){ %>
<div id="<%=PREFIX%>addFilterDiv" style="<%=divStyle%>">
<%}%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="<%=tableStyle%>">
	<%if (showTableHeader && !embedded){ %>
	<tr height="20">
		<td align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
				<span class="PROGRESSTEXT" id="<%=PREFIX%>addFilterTitle">Add Filter</span>
		</td>
	</tr>
	<%}else if (!embedded){%>
	<tr class="REGULARTEXT">
		<td height="18">&nbsp;<b>Rule</b></td>
	</tr>
	<%} %>
	<tr height="*" style="padding:5">
		<td>
		<table border="0">
			<tr>
				<td><span class="REGULARTEXT"><%=newFilterLabel %>: </span></td>
				<td><span style="padding-left:4"><input type="text" class="REGULARTEXT" id="<%=PREFIX%>filterText" name="<%=PREFIX%>filterText" size="40"></span></td>
			</tr>
			<tr>
				<td><span class="REGULARTEXT"><nobr>Regular Expression: </nobr></span></td>
				<td><input type="checkbox" id="<%=PREFIX%>filterRegExp" name="<%=PREFIX%>filterRegExp" value="true"></td>
			</tr>
		</table>
		</td>
	</tr>				
	<%if (showActions && !embedded){ %>							
	<tr height="10">
		<td align="center" style="padding:5"><nobr>
			<a class="SMALLLINK" href="javascript:saveNewFilter()"> save </a>
			<a class="SMALLLINK" style="padding-left:5" href="javascript:hideLayer('addFilterDiv')"> close </a>
			</nobr>		  							
		</td>
	</tr>
	<%} %>
</table>
<%if (!showDiv){ %>
</div>
<%}%>
<%}%>