<%@ page language="java" %> 

<%@ page import="xpolog.eye.data.filters.FilterManager"%>
<%@ page import="xpolog.eye.data.RecordsMaskTableModel"%>
<%@ page import="xpolog.eye.logview.LogViewContext"%>
<%@ page import="xpolog.eye.LogBrowsingManager"%>


<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
	LogViewContext logcontext = (LogViewContext)request.getSession().getAttribute(LogViewContext.LOG_CONTEXT);
	LogBrowsingManager lbm = logcontext == null ? null : logcontext.lbm;

	String columnType = "";
	String columnIndexStr = request.getParameter("columnIndex");
	int columnIndex;
	try{
		columnIndex = Integer.parseInt(columnIndexStr);
	}catch(Exception e){
		columnIndex = -1;
	}
	if(columnIndex != -1) {
		if(lbm != null){
			RecordsMaskTableModel RMModel = lbm.getCurrentEntries(10);
			if(RMModel != null){
				columnType = RMModel.getColumnType(columnIndex);
			}
		}
	}
	
	
	boolean isFilterActive = false;
	if(lbm != null) {
		FilterManager filterManager = lbm.getFilterManager();
		if(filterManager != null) {
			isFilterActive = filterManager.getActiveFilterId() != null && filterManager.getActiveFilterId().length() > 0;
		}
	}
	
	response.setContentType("text/xml; charset=UTF-8");
%>

<CurrentLogAttributesResponse>
	<Response columnType="<%=columnType %>" isFilterActive="<%=isFilterActive %>">
	</Response>
</CurrentLogAttributesResponse>