<%@ page language="java"%>

<%@ page import="omega.ui.html.tree.ODefaultTreeCellRenderer"%>
<%@ page import="omega.ui.models.tree.ODefaultMutableTreeNode"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.menu.ModulesMenuLoader"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.ui.tree.ModuleMemberRenderer"%>

<%@ page import="java.util.*"%>

<%
	String CURRENT_MODULE = "CURRENT_MODULE";

	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	Module rootmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
  Module curmod = (Module)request.getSession().getAttribute(CURRENT_MODULE);
  ModuleMember moduleMember = null;
	
	String modid = request.getParameter("MODULE_ID");
	String logid = request.getParameter("LOG_ID");
	String filterid = request.getParameter("FILTER_ID");

	boolean showDefaultTree = true;
	boolean showStorageTree = true;
	HashMap modulesMap = new HashMap();
	HashMap logsMap = null;
	HashMap filtersMap = null;

	if (modid != null && modid.length() > 0){
	  try {
	  	curmod = SiteManagment.getInstance().getModuleFromId(modid);
	  }catch (Exception e){
		}
	}
	if (logid != null && logid.length() > 0){
	  try {
			moduleMember = SiteManagment.getInstance().getModuleMember(logid);
	  }catch (Exception e){
		}
	}
	String modeStr = request.getParameter("mode");
	boolean all = modeStr == null || modeStr.length() == 0;
	boolean logsMode = modeStr != null && modeStr.equals("logs");
	boolean modulesMode = modeStr != null && modeStr.equals("modules");
	boolean filtersMode = modeStr != null && modeStr.equals("filters");
  String logPopupMenuStr = request.getParameter("logPopupMenu");
  boolean logPopupMenu = logPopupMenuStr != null && logPopupMenuStr.equals("true");
  //show empty monitors module
  String showMonitorsModuleStr = request.getParameter("showMonitorsModule");
  boolean showMonitorsModule = showMonitorsModuleStr != null && showMonitorsModuleStr.equals("true");
  Module monitorsModule = mgmt.getModuleFromId(Module.ROOT_MONITORS_MODULE_ID);
  showMonitorsModule = showMonitorsModule && monitorsModule == null;
	//show empty reports module
  String showReportsModuleStr = request.getParameter("showReportsModule");
  boolean showReportsModule = showReportsModuleStr != null && showReportsModuleStr.equals("true");
  Module reportsModule = mgmt.getModuleFromId(Module.ROOT_REPORTS_MODULE_ID);
  showReportsModule = showReportsModule && reportsModule == null;
	//show empty collections module
  String showCollectionsModuleStr = request.getParameter("showCollectionsModule");
  boolean showCollectionsModule = showCollectionsModuleStr != null && showCollectionsModuleStr.equals("true");
  Module collectionsModule = mgmt.getModuleFromId(Module.ROOT_COLLECTIONS_MODULE_ID);
  showCollectionsModule = showCollectionsModule && collectionsModule == null;

  String checkEditPermissionsStr = request.getParameter("checkEditPermissions");
  boolean checkEditPermissions = checkEditPermissionsStr != null && checkEditPermissionsStr.equals("true");

  List emtpyModulesToAdd = null;
  if (showMonitorsModule){
  	Module mod = new Module();
  	mod.setId(Module.ROOT_MONITORS_MODULE_ID);
  	mod.setName(Module.ROOT_MONITORS_MODULE_NAME);
  	emtpyModulesToAdd = new LinkedList();
  	emtpyModulesToAdd.add(mod);
  }
  if (showReportsModule){
  	Module mod = new Module();
  	mod.setId(Module.ROOT_REPORTS_MODULE_ID);
  	mod.setName(Module.ROOT_REPORTS_MODULE_NAME);
  	if (emtpyModulesToAdd == null){
  		emtpyModulesToAdd = new LinkedList();
  	}
  	emtpyModulesToAdd.add(mod);
  }
  if (showCollectionsModule){
  	Module mod = new Module();
  	mod.setId(Module.ROOT_COLLECTIONS_MODULE_ID);
  	mod.setName(Module.ROOT_COLLECTIONS_MODULE_NAME);
  	if (emtpyModulesToAdd == null){
  		emtpyModulesToAdd = new LinkedList();
  	}
  	emtpyModulesToAdd.add(mod);
  }
	
	String modulesToIgnoreStr = request.getParameter("MODULE_IDS_TO_IGNORE");
	HashSet modulesToIgnore = null;
	if (modulesToIgnoreStr != null && modulesToIgnoreStr.length() > 0){
		modulesToIgnore = new HashSet();
		String[] ids = modulesToIgnoreStr.split(",");
		for (int i=0; i<ids.length; i++){
			modulesToIgnore.add(ids[i]);
		}
	}
	
	String logTypeToIgnoreIgnoreStr = request.getParameter("LOG_TYPES_TO_IGNORE");
	List logTypeToIgnoreIgnoreList = null;
	String[] logTypesToIgnore = null;
	if (logTypeToIgnoreIgnoreStr != null && logTypeToIgnoreIgnoreStr.length() > 0){
		logTypeToIgnoreIgnoreList = new LinkedList();
		String[] ids = logTypeToIgnoreIgnoreStr.split(",");
		for (int i=0; i<ids.length; i++){
			logTypeToIgnoreIgnoreList.add(ids[i]);
		}
		logTypesToIgnore = (String[])logTypeToIgnoreIgnoreList.toArray(new String[logTypeToIgnoreIgnoreList.size()]);
	}
	
	boolean treeNodeExists = false;
	String treeXml = ""; 
  String id = request.getParameter("id");
  String type = null;
  if (id != null){
  	int ind = id.indexOf("-");
  	if (ind != -1){
  		type = id.substring(0,ind);
  		id = id.substring(ind+1);
  		int index = id.indexOf(ModuleMember.STORAGE_SUFFIX);
  		if (index != -1){
  			showDefaultTree = false;
  		}else{
  			showStorageTree = false;
  		}
  	}
  	if (type != null){
  		if (type.equals(XpoLogObjectTypes.MODULE_TYPE)){
  			try{
  			curmod = SiteManagment.getInstance().getModuleFromId(id);
  			rootmod = curmod;
  			treeNodeExists = true;
  			}catch(Exception e){
  				ErrorModel.log.error("Failed to load folders tree for folder " + id,e);
  			}
  		}else if (type.equals(XpoLogObjectTypes.LOG_TYPE)){
  			try{
  				moduleMember = SiteManagment.getInstance().getModuleMember(id);
  			}catch(Exception e){
  				ErrorModel.log.error("Failed to load folders tree for log " + id,e);
  			}
  		}
  	}
  }
 
	if (curmod != null){
    modulesMap.put(curmod.getId(),curmod.getId());
	}
	if (moduleMember != null){
		logsMap = new HashMap();
		String mmId = moduleMember.getId();
		logsMap.put(mmId,mmId);
	}
	if (filterid != null){
		filtersMap = new HashMap();
		if (filterid.indexOf(",") == -1){
			filtersMap.put(filterid,filterid);
		}else{
			String[] filterIds = filterid.split(",");
			for (int i=0; i<filterIds.length; i++){
				filtersMap.put(filterIds[i],filterIds[i]);
			}
		}
	}
	
	if (logsMap != null){
		ModuleMemberRenderer.addModuleMemberParents(modulesMap, logsMap);
	}
	
	if (type != null && type.equals(XpoLogObjectTypes.LOG_TYPE)){
		LogBrowsingManager lbm = SiteManagment.getInstance().getLogBrowserManager(moduleMember.getId());
		ODefaultTreeCellRenderer cr = new ODefaultTreeCellRenderer();
		ModulesMenuLoader modMenuLoader = new ModulesMenuLoader();
		modMenuLoader.setShowFilters(true);
		modMenuLoader.setShowRootFilter(false);	
		ODefaultMutableTreeNode node = (ODefaultMutableTreeNode)modMenuLoader.createMutableNodeFromLog(lbm,userContext,null);
		treeXml = cr.renderNode(node,true,false);
	}else if (rootmod != null){
    ModuleMemberRenderer.addModuleMemberParents(modulesMap,null);
		ModuleMemberRenderer renderer = new ModuleMemberRenderer(rootmod, userContext, modulesMap, logsMap, true, false, treeNodeExists);
		renderer.setEmptyModulesToAdd(emtpyModulesToAdd);
		if (logPopupMenu){
			renderer.addUserData(XpoLogObjectTypes.LOG_TYPE,"popupKey","'logMenu','[ID]'");
		}
		if (modulesMode){
			renderer.setShowModulesOnly(true);
		}else if (logsMode){
			renderer.setLogsRadio(true);
		}else if (filtersMode){
			renderer.setLogsMapOnlyOpen(true);
			renderer.setShowFilters(true);
			renderer.setShowRootFilter(false);
			renderer.setFiltersRadio(true);
		}
		renderer.setCheckEditPermissions(checkEditPermissions);
		
		if (!userContext.isModuleMemberEditable(Module.ROOT_MODULE_ID)){
			renderer.setShowRootModule(false);
		}
    HashMap selectedModules = new HashMap();
    if (curmod != null){
    	selectedModules.put(curmod.getId(),curmod.getId());
    	renderer.setSelectedModules(selectedModules);
    }
    if (modulesToIgnore != null){
    	renderer.setModulesToIgnore(modulesToIgnore);
    }
    if (logTypesToIgnore != null){
    	renderer.setLogTypesToIgnore(logTypesToIgnore);
    }
		renderer.setFilters(filtersMap);
    //renderer.setOpenRootModule(openRootModule);
		treeXml = renderer.getTreeXML(showDefaultTree,showStorageTree);
	}
	
	//System.out.println(treeXml);
	response.setContentType("text/xml");
	out.write(treeXml);
	out.flush();
%>