<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.site.ui.tree.ModuleMemberRenderer"%>
<%@ page import="xpolog.eye.util.WebUtil"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
	String PREFIX = request.getParameter("PREFIX");
	if (PREFIX == null || PREFIX.length() == 0){
		PREFIX = "";
	}

	String ERROR_OBJ = PREFIX+"ERROR_OBJ";
	
  String baseDirectory = request.getParameter("baseDirectory");
  if (baseDirectory == null){
  	baseDirectory = BASE_DIRECTORY;
  }
  
  SiteManagment siteMgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  
  String parentModuleId = request.getParameter("parentModId");
  String newModuleName = request.getParameter("newModName");
  String moduleId = request.getParameter("modId");


  //verify data
  ErrorModel errmodel = new ErrorModel();
  
  if(newModuleName == null || newModuleName.length() == 0){
    errmodel.addError("No name was supplied.");
  }
  
  if(WebUtil.isContainSpecialCharecter(newModuleName)){
    errmodel.addError("The following characters are prohibited in the name field: "+WebUtil.getSpecialCharectersList());
  }
	StringBuffer xml = new StringBuffer();
	Module parentMod = siteMgmt.getModuleFromId(parentModuleId);
	if (parentMod != null && newModuleName != null && newModuleName.length() > 0){
		ModuleMember mm = parentMod.getMemberByName(newModuleName);
		if (mm != null && (mm.getType() == null || mm.getType().equals(XpoLogObjectTypes.MODULE_TYPE))){
			xml.append("<root>");
			xml.append("<result error=\"The specified folder name already exists. Please specify a different name\"/>");
			xml.append("</root>");
		}else{
			UserContext userContext = UserEnvironment.getUserContext(request);
			Module newModule = new Module();
			if (moduleId != null && moduleId.length() > 0){
				newModule = siteMgmt.getModuleFromId(moduleId);
				if (newModule != null){
					newModule = (Module)newModule.clone();
					if (newModule != null){
						newModule.setName(newModuleName);
						admin.addModule(newModule,parentMod,userContext);
					}
				}
			}else {
				
				newModule.setName(newModuleName);
				admin.addModule(newModule,parentMod,userContext);
				
			}
			//UserEnvironment env = UserEnvironment.getUserEnvironment(request);
			
			AuditManager auditMgr = AuditManager.getInstance();
			auditMgr.write(AuditConstants.BASIC_AUDIT_LEVEL,
			userContext, AuditConstants.CHANGE, "save/edit module", AuditConstants.MODULES, "add the module " + newModuleName + "(" + (newModule == null ? "" : newModule.getId()) + ")");
			//result
			xml.append("<root>");
			xml.append("<result ");
			xml.append("modId=\"" + newModule.getId()+ "\" modName=\"" + newModule.getName() + "\"");
			xml.append("/>");
			xml.append("<insertItem parentId=\"Module-" + parentMod.getId() + 
					"\" itemId=\"Module-" + newModule.getId() +
					"\" itemText=\"Module-" + newModule.getName() +
					"\" image1=\"" + ModuleMemberRenderer.getImageForType(XpoLogObjectTypes.MODULE_TYPE,"im0",baseDirectory) + 
					"\" image2=\"" + ModuleMemberRenderer.getImageForType(XpoLogObjectTypes.MODULE_TYPE,"im1",baseDirectory) +
					"\" image3=\"" + ModuleMemberRenderer.getImageForType(XpoLogObjectTypes.MODULE_TYPE,"im2",baseDirectory) +
					"\" type=\"Module\"/>");
			xml.append("</root>");
		}
	}else if (newModuleName == null || newModuleName.length() == 0){
		xml.append("<root>");
		xml.append("<result error=\"Please specify folder name\"/>");
		xml.append("</root>");
	}
	String result = xml.toString();

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	out.write(result);
	out.flush();

%>