<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>

<%@ page import="java.util.List"%>
<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
  WebSecurityManager manager = WebSecurityManager.getInstance();
  SiteManagment mgmt = SiteManagment.getInstance();
  
  String baseDirectory = request.getParameter("baseDirectory");
  if (baseDirectory == null){
  	baseDirectory = BASE_DIRECTORY;
  }
  String baseDirectory2 = request.getParameter("baseDirectory2");
  if (baseDirectory2 == null){
  	baseDirectory2 = baseDirectory;
  }

  String mode = request.getParameter("mode");
  if (mode == null || mode.length() == 0){
  	mode = "logs";
  }
  
  ModuleMember mm = null;
  String lbmId = request.getParameter("LBM_ID");
  if (lbmId != null && lbmId.length() > 0){
    try {
      mm = mgmt.getModuleMember(lbmId);
      if (mm == null){
      	lbmId = "";
      }
    }catch (Exception e){}
  }else {
  	lbmId = "";
  }
  
  String filterId = request.getParameter("FILTER_ID");
  String filterName = null;
  if (mm != null && filterId != null && filterId.length() > 0){
  	List filters = mm.getFilters();
  	String[] filterIds = filterId.split(",");
  	for (int i=0; i<filters.size(); i++){
  		for (int j=0; j<filterIds.length; j++){
	  		ModuleFilterMember filterMember = (ModuleFilterMember)filters.get(i);
	  		if (filterIds[j].equals(filterMember.getFilterId())){
	  			if (filterName == null){
		  			filterName = filterMember.getFilterName();
	  			}else{
	  				filterName = filterName + "," + filterMember.getFilterName();
	  			}
	  		}
  		}
  	}
  }else{
  	filterId = "";
  }
  String moduleMemberName = "";
  if (mm != null && mode != null){
  	if (mode.equals("logs")){
  		moduleMemberName = mm.getName();
  	}else if (mode.equals("filters") && filterName != null){
    	moduleMemberName = mm.getName() + " (" + filterName + ")";
  	}
  }
  boolean showDisplayLogDiv = moduleMemberName.length() == 0; 
  
  String treeName = request.getParameter("treeName");
  if (treeName == null || treeName.length() == 0){
  	treeName = "tree";
  }
  
  String ignoreHeaderStr = request.getParameter("ignoreHeader");
  boolean ignoreHeader = ignoreHeaderStr != null && ignoreHeaderStr.equals("true");
  
  String parameterName = request.getParameter("parameterName");
  if (parameterName == null || parameterName.length() == 0){
  	parameterName = "Log:";
  }
  String hideParameterNameStr = request.getParameter("hideParameterName");
  boolean hideParameterName = hideParameterNameStr != null && hideParameterNameStr.equals("true");
  String labelWidth = request.getParameter("labelWidth");
  String logNameWidth = request.getParameter("logNameWidth");
  
  String useTextBoxStr = request.getParameter("useTextBox");
  boolean useTextBox = useTextBoxStr == null || !useTextBoxStr.equals("false");
  
  String textBoxSize = request.getParameter("textBoxSize");
  if (textBoxSize == null || textBoxSize.length() == 0){
  	textBoxSize = "40";
  }
  
  String textBoxDisabledStr = request.getParameter("textBoxDisabled");
  boolean textBoxDisabled = textBoxDisabledStr == null || !textBoxDisabledStr.equals("false");  

  String openLinkName = request.getParameter("openLinkName");
  if (openLinkName == null || openLinkName.length() == 0){
  	openLinkName = "open";
  }
  String openLinkClassName = request.getParameter("openLinkClassName");
  if (openLinkClassName == null || openLinkName.length() == 0){
  	openLinkClassName = "BUTTON_MEDIUMLINK";
  }
  
  String closeLinkName = request.getParameter("closeLinkName");
  if (closeLinkName == null || closeLinkName.length() == 0){
  	closeLinkName = "close";
  }

  String logPopupMenuStr = request.getParameter("logPopupMenu");
  boolean logPopupMenu = logPopupMenuStr != null && logPopupMenuStr.equals("true");
  
  String checkBoxes = mode.equals("filters") ? "true" : "false";
  String closeTreeUponSelect = mode.equals("filters") ? "false" : "true";
  
  String allowNewLogStr = request.getParameter("allowNewLog");
  boolean allowNewLog = allowNewLogStr == null || allowNewLogStr.equals("true");
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.AdministrationPermissions.ADD_LOG_PERMISSION,false)){
  	allowNewLog = false;
  }

  String showMonitorsModuleStr = request.getParameter("showMonitorsModule");
  boolean showMonitorsModule = showMonitorsModuleStr != null && showMonitorsModuleStr.equals("true");
  
  String showReportsModuleStr = request.getParameter("showReportsModule");
  boolean showReportsModule = showReportsModuleStr != null && showReportsModuleStr.equals("true");
  
  String showCollectionsModuleStr = request.getParameter("showCollectionsModule");
  boolean showCollectionsModule = showCollectionsModuleStr != null && showCollectionsModuleStr.equals("true");
  
  String checkEditPermissionsStr = request.getParameter("checkEditPermissions");
  boolean checkEditPermissions = checkEditPermissionsStr != null && checkEditPermissionsStr.equals("true");

  String treeOnlyStr = request.getParameter("treeOnly");
  boolean treeOnly = treeOnlyStr != null && treeOnlyStr.equals("true");

  String noTreeStr = request.getParameter("noTree");
  boolean noTree = noTreeStr != null && noTreeStr.equals("true");
  
  String newFilterTitle = request.getParameter("newFilterTitle");
  if(newFilterTitle == null || newFilterTitle.length() == 0) {
  	newFilterTitle = "Create New Log Filter";
  }
  
  String newFilterLabel = request.getParameter("newFilterLabel");
  if(newFilterLabel == null || newFilterLabel.length() == 0) {
  	newFilterLabel = "Contains text";
  }

  String logTypesToIgnore = request.getParameter("LOG_TYPES_TO_IGNORE");
  if (logTypesToIgnore == null){
  	logTypesToIgnore = "";
  }
  
  String className = request.getParameter("className");
  if(className == null || className.length() == 0) {
  	className = "REGULARTEXT";
  }
  
  String suffix = request.getParameter("suffix");
  if(suffix == null) {
  	suffix = "";
  }
  
  String newLogUrl = "../loggers/quicklog/quickLogAdmin.jsp";
%>

<% if (!ignoreHeader){ %>

<jsp:include page="selectLogHeader.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
	<jsp:param name="baseDirectory2" value="<%=baseDirectory2%>" />
	<jsp:param name="treeName" value="<%=treeName%>" />
	<jsp:param name="LBM_ID" value="<%=lbmId%>" />
	<jsp:param name="FILTER_ID" value="<%=filterId%>" />
	<jsp:param name="mode" value="<%=mode%>" />
	<jsp:param name="logPopupMenu" value="<%=logPopupMenu%>" />
	<jsp:param name="checkBoxes" value="<%=checkBoxes%>" />
	<jsp:param name="closeTreeUponSelect" value="<%=closeTreeUponSelect%>" />
	<jsp:param name="showMonitorsModule" value="<%=showMonitorsModule%>" />
	<jsp:param name="showReportsModule" value="<%=showReportsModule%>" />
	<jsp:param name="showCollectionsModule" value="<%=showCollectionsModule%>" />
	<jsp:param name="checkEditPermissions" value="<%=checkEditPermissions%>" />
	<jsp:param name="useTextBox" value="<%=useTextBox%>"/>
	<jsp:param name="newFilterLabel" value="<%=newFilterLabel%>"/>
	<jsp:param name="LOG_TYPES_TO_IGNORE" value="<%=logTypesToIgnore%>"/>
	<jsp:param name="suffix" value="<%=suffix%>"/>
</jsp:include>

<%} %>



<table border="0" cellpadding="0" cellspacing="0" width="100%" >
	<%if (!treeOnly){%>
	<tr>
		<td >
		<table border="0" cellpadding="0" cellspacing="0"  width="100%" >
			<tr>
				<% if(!hideParameterName) { %>
				<td <%=labelWidth != null ? "width=\"" + labelWidth + "\"" : ""%>>
					<span class="<%=className %>"><%=parameterName%></span>
				</td>
				<% } %>
				<td <%=!useTextBox && logNameWidth != null ? "width=\"" + logNameWidth + "\"" : "width=\"100\""%>>
				<% if (useTextBox){ %>
				<input name="logName<%=suffix %>" id="logName<%=suffix %>" type="text" size="<%=textBoxSize%>" value="<%=moduleMemberName == null || moduleMemberName.length() == 0 ? "" : moduleMemberName%>" <%=textBoxDisabled ? "readonly" : "" %> class="<%=textBoxDisabled ? "DISABLED_TEXTBOX" : ""%>" onClick="resetBgColor(this,'<%=textBoxDisabled ? "DISABLED_TEXTBOX" : ""%>')">
				<%} else {%>
					<span class="<%=className %>" id="logName<%=suffix %>">&nbsp;<b><%=moduleMemberName == null || moduleMemberName.length() == 0 ? "&nbsp;" : moduleMemberName%></b></span>
				<%} %>
				</td>
				<td width="*" align="left" style="padding-left:10"><div id="showLink<%=suffix %>"><a class="<%=openLinkClassName %>" href="javascript:showModuleTree<%=suffix %>()"><%=openLinkName%></a></div></td>
			</tr>
		</table>
		</td>
	</tr>
	<tr height="5">
	<td >
		<table border="0" cellpadding="0" cellspacing="0"  width="100%" >
			<tr>
	    <td <%=labelWidth != null ? "width=\"" + labelWidth + "\"" : ""%> style="font-size:5pt">
					<span style="font-size:5pt">&nbsp;</span>
				</td>
			<td>
				 <div id="logErrorMsg<%=suffix %>" style="display:none;" class="ERROR_MSG">
				 </div>
			</td>
			</tr>
			</table>
		</td>
	</tr>
	<%}%>
	<%if (!noTree){%>
	<tr >
  	<td width="15%" height="18">
  	<div id="treeDiv<%=suffix %>" style="disply:none">
    <table border="0" width="100%">
			<tr>
				<td valign="top">
					<div id="loadingDiv<%=suffix %>" style="display:none">
						<span class="<%=className %>">Loading...</span>
					</div>
				</td>
			</tr>
			<tr>
				<td width="15%">
				<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
					<tr>
						<td valign="top">
							<div id="treeboxbox_treeSelectLog<%=suffix %>"></div>
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</div>
		</td>
	</tr>
	<%}%>
</table>

<% if (!ignoreHeader && !noTree){ %>
<script>
	createTree<%=suffix%>("treeboxbox_treeSelectLog<%=suffix%>","<%=lbmId%>","<%=filterId%>");	
	<%if (mm != null && (mode.equals("logs")) || (mode.equals("filters") && filterId != null && filterId.length() > 0)){%>	  
		hideModuleTree<%=suffix%>();
	<%}%>
</script>
<%}%>

<%
if (!treeOnly){
	String newLogSuffix = "NewLog" + suffix;
	String newFilterSuffix = "NewFilter" + suffix;
%>
<jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=baseDirectory%>"/> 
	<jsp:param name="title" value="Create New Log"/> 
	<jsp:param name="suffix" value="<%=newLogSuffix %>"/> 
	<jsp:param name="width" value="600px"/> 
	<jsp:param name="height" value="300px"/> 
	<jsp:param name="zIndex" value="210"/>
	<jsp:param name="actionsNames" value="Save@id=saveLogBtn#Cancel"/> 
	<jsp:param name="actions" value="javascript:saveQuickLog()#javascript:closeNewLogDiv('close')"/> 
</jsp:include>

<jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=baseDirectory%>"/> 
	<jsp:param name="title" value="<%=newFilterTitle %>"/> 
	<jsp:param name="suffix" value="<%=newFilterSuffix %>"/> 
	<jsp:param name="width" value="490px"/> 
	<jsp:param name="height" value="150px"/> 
	<jsp:param name="zIndex" value="211"/>
	<jsp:param name="actionsNames" value="Save#Cancel"/> 
	<jsp:param name="actions" value="javascript:saveNewFilter()#javascript:showHideGeneralAdminDiv('NewFilter')"/> 
</jsp:include>
<%} %>
