<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>

<%@ page import="java.util.Enumeration"%>
<%
	SiteManagment mgmt = SiteManagment.getInstance();
 
  String baseDirectory = request.getParameter("baseDirectory");
  if (baseDirectory == null){
  	baseDirectory = "../";
  }
  String baseDirectory2 = request.getParameter("baseDirectory2");
  if (baseDirectory2 == null){
  	baseDirectory2 = baseDirectory;
  }
  
  String treeName = request.getParameter("treeName");
  if (treeName == null || treeName.length() == 0){
  	treeName = "tree";
  }
  
  String mode = request.getParameter("mode");
  if (mode == null || mode.length() == 0){
  	mode = "logs";
  }
  
  String lbmId = request.getParameter("LBM_ID");
  if (lbmId == null || lbmId.length() == 0){
  	lbmId = "";
  }
  
  String filterId = request.getParameter("FILTER_ID");
  if (filterId == null || filterId.length() == 0){
  	filterId = "";
  }
  
  String useTextBoxStr = request.getParameter("useTextBox");
  boolean useTextBox = useTextBoxStr == null || !useTextBoxStr.equals("false");

  String checkBoxesStr = request.getParameter("checkBoxes");
  boolean checkBoxes = checkBoxesStr != null && checkBoxesStr.equals("true");

  String closeTreeUponSelectStr = request.getParameter("closeTreeUponSelect");
  boolean closeTreeUponSelect = closeTreeUponSelectStr == null || !closeTreeUponSelectStr.equals("false");

  String logPopupMenuStr = request.getParameter("logPopupMenu");
  boolean logPopupMenu = logPopupMenuStr != null && logPopupMenuStr.equals("true");

  String showMonitorsModuleStr = request.getParameter("showMonitorsModule");
  boolean showMonitorsModule = showMonitorsModuleStr != null && showMonitorsModuleStr.equals("true");
  
  String showReportsModuleStr = request.getParameter("showReportsModule");
  boolean showReportsModule = showReportsModuleStr != null && showReportsModuleStr.equals("true");
  
  String showCollectionsModuleStr = request.getParameter("showCollectionsModule");
  boolean showCollectionsModule = showCollectionsModuleStr != null && showCollectionsModuleStr.equals("true");
  
  String checkEditPermissionsStr = request.getParameter("checkEditPermissions");
  boolean checkEditPermissions = checkEditPermissionsStr != null && checkEditPermissionsStr.equals("true");

  String newFilterLabel = request.getParameter("newFilterLabel");
  if(newFilterLabel == null || newFilterLabel.length() == 0) {
  	newFilterLabel = "Contains text";
  }
  
	String useTempLbmStr = request.getParameter("useTempLbm");
	boolean useTempLbm = useTempLbmStr != null && useTempLbmStr.equals("true");
  
  String logTypesToIgnore = request.getParameter("LOG_TYPES_TO_IGNORE");
  
  String suffix = request.getParameter("suffix");
  if(suffix == null) {
  	suffix = "";
  }
  treeName += suffix;
  
  Enumeration paramNames = request.getParameterNames();
  StringBuffer sb = new StringBuffer();
  String pName, pValue;
  while (paramNames.hasMoreElements()){
  	pName = (String)paramNames.nextElement();
  	pValue = request.getParameter(pName);
  	if (sb.length() > 0){
  		sb.append("&");
  	}
  	sb.append(pName + "=" + pValue);
  }
  String params = sb.toString();
  
  boolean doHideAllGeneralAdminDivWhenOpenningDiv = suffix == null || suffix.length() == 0;
  
  String doIncludeStr = request.getParameter("doInclude");
  boolean doInclude = doIncludeStr == null || !doIncludeStr.equals("false");
  if(doInclude) {
%>

<jsp:include page="../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=baseDirectory2%>" />
</jsp:include>

<jsp:include page="../loggers/quicklog/quickLogAdminHeader.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
	<jsp:param name="baseDirectory2" value="<%=baseDirectory2%>" />
	<jsp:param name="treeName" value="<%=treeName%>" />
	<jsp:param name="divName" value="newLogDiv" />
	<jsp:param name="frmName" value="newLogFrm" />
	<jsp:param name="PREFIX" value="quickLog_"/>
	<jsp:param name="showMonitorsModule" value="<%=showMonitorsModule%>"/>
	<jsp:param name="showReportsModule" value="<%=showReportsModule%>"/>
	<jsp:param name="showCollectionsModule" value="<%=showCollectionsModule%>"/>
	<jsp:param name="showNewFilter" value="false"/>
</jsp:include>
<%
  }
%>
<script>
	var lbmId<%=suffix %> = "<%=lbmId%>";
	var filterId<%=suffix %> = "<%=filterId%>";
	var lastSelectedLogId<%=suffix %> = "Log-<%=lbmId%>";
    
	var logSelectionTreeLoaded<%=suffix %> = false;	
	function showModuleTree<%=suffix %>(){
		<%
		if(doHideAllGeneralAdminDivWhenOpenningDiv) {
		%>
		hideAllGeneralAdminDiv();
		<%
		}
		%>
		if (document.access && document.access.logName<%=suffix %> && resetBgColor){
			resetBgColor(document.access.logName<%=suffix %>,"DISABLED_TEXTBOX");
		}
		var url = "<%=baseDirectory%>common/selectLog.jsp?<%=params%>";
		sendAjaxRequest(url,function(req){
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result){
				alert("Could not get logs list!.");
				return;			
			}
			showGeneralAdminDiv("SelectLog<%=suffix %>");
			if (!logSelectionTreeLoaded<%=suffix %>){
				updateGeneralAdminDiv("SelectLog<%=suffix %>",result);
				var treeboxId = "treeboxbox_treeSelectLog<%=suffix %>";
				createTree<%=suffix %>(treeboxId);
				logSelectionTreeLoaded<%=suffix %> = true;
			}
		});
	}


	function _showModuleTree<%=suffix %>(){
		document.getElementById("showLink<%=suffix %>").style.display = "none";
		document.getElementById("hideLink<%=suffix %>").style.display = "";
		document.getElementById("treeDiv<%=suffix %>").style.display = "";
	}

	function hideModuleTree<%=suffix %>(){
		document.getElementById("showLink<%=suffix %>").style.display = "";
		document.getElementById("hideLink<%=suffix %>").style.display = "none";
		document.getElementById("treeDiv<%=suffix %>").style.display = "none";
	}
	
	function closeLogSelectionDiv<%=suffix %>(){
		showHideGeneralAdminDiv("SelectLog<%=suffix %>");
	}
	
	function closeNewLogDiv<%=suffix %>(action){
		showHideGeneralAdminDiv("NewLog<%=suffix %>");
		if(!action || action != 'close') {
			showHideGeneralAdminDiv("SelectLog<%=suffix %>");
			refreshMenus();
		}
	}
	
	function updateLog<%=suffix %>(tree,logTagName){
		var list = <%=treeName%>.getAllChecked();
		var arr = list.split(",");
	  var logsStr = "";
	  var modsStr = "";
		for (var i=0; i<arr.length; i++){
			var s = arr[i];
			var ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				var type = s.substring(0,ind);
				var id = s.substring(ind+1,s.length);
				if (type == "<%=XpoLogObjectTypes.MODULE_TYPE%>"){
					if (modsStr != ""){
						modsStr += ",";
					}
					modsStr += id;
				}else{
					if (logsStr != ""){
						logsStr += ",";
					}
					logsStr += id;
				}
			}
		}
		if(document.access) {
			eval("document.access."+logTagName<%=suffix %>).value = logsStr;
		}
	}
	
	function getSelectedFilters<%=suffix %>(tree,lName,fName){
		//alert(lName+","+fName);
		var list = <%=treeName%>.getAllChecked();
		var arr = list.split(",");
	  var logName = "";
	  var filters = "";
		var needToAddNewFilter = lName && fName && lName.length > 0 && fName.length > 0;
		var newFilterAdded = false;
		for (var i=0; i<arr.length; i++){
			var s = arr[i];
			var ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				var filterName = <%=treeName%>.getItemText(s);
				var type = s.substring(0,ind);
				if (type == "Filter"){
					parentId = <%=treeName%>.getParentId(s);
					if(parentId){
						ind = parentId.indexOf("-");
						type = parentId.substring(0,ind);
						if (type == "Log"){
							var parentName = <%=treeName%>.getItemText(parentId);
							var newLog = false;
							if (logName == "" || logName != parentName){
								logName = parentName;
								newLog = true;
							}
						}
					}
				}
				if (filters == ""){
					filters = logName + "(" + filterName;
				}else if (newLog){
					filters = filters + ")" + ", " + logName + "(" + filterName;
				}else{
					filters = filters + "," + filterName;
				}
			}
		}
		if (filters != ""){
			filters = filters + ")";
		}
		if (needToAddNewFilter && !newFilterAdded){
			if (filters != ""){
				filters = filters + "," + lName + "(" + fName + ")";
			}else{
				filters = lName + "(" + fName + ")";
			}
		}
		if (filters.length > 60){
			filters = filters.substring(0,60) + "...";
		}
		return filters;
	}
	
	function updateLogName<%=suffix %>(id,logName,filterName){
		var pm = document.getElementById("logName<%=suffix %>");
		if (pm){
			<%if (mode.equals("filters")){%>
			if (id && id.indexOf("Log-") == 0){
				if(<%=treeName%>.hasChildren(id)){
					<%=treeName%>.openItem(id);
				}else{
					hideVisibleMenus();
					var temp=<%=treeName%>._globalIdStorageFind(id);
					lbmId<%=suffix %> = id.substring(4);
					var menuId = temp.parentObject.treeNod.getUserData(id,"popupKey");
					var htmlNode = document.getElementById(id);
					openPopupMenu(htmlNode,menuId);
					return false;
				}
				//if (lastSelectedLogId<%=suffix %> && lastSelectedLogId<%=suffix %> != lbmId<%=suffix %>){
				//	clearLastLbmFilters<%=suffix %>();
				//}
			}else{
				lbmId<%=suffix %> = <%=treeName%>.getParentId(id).substring(4);
				//if (lastSelectedLogId<%=suffix %> && lastSelectedLogId<%=suffix %> != bmId){
				//	clearLastLbmFilters<%=suffix %>();
				//}
			<% if (useTextBox){%>
				pm.value = getSelectedFilters<%=suffix %>(<%=treeName%>,logName,filterName);
			<%}else{%>
				pm.innerHTML = '&nbsp;<b>' + getSelectedFilters<%=suffix %>(<%=treeName%>,logName,filterName) + '</b>';
			<%}%>
			}
			
			<%}else{%>
			if (id.indexOf("Log") != 0){
				return;
			}
			lbmId<%=suffix %> = id.substring(4);
			var n = "";
			if (<%=treeName%>.isItemChecked(id)){
				n = <%=treeName%>.getItemText(id);
			}
			<% if (useTextBox){%>
				pm.value = n;
			<%}else{%>
				pm.innerHTML = '&nbsp;<b>' + n + '</b>';
			<%}%>
			<%}%>
			lastSelectedLogId<%=suffix %> = "Log-"+lbmId<%=suffix %>;
		}
		<%if (closeTreeUponSelect){%>
		closeLogSelectionDiv<%=suffix %>();
		document.getElementById("logErrorMsg<%=suffix %>").style.display ="none";
		document.getElementById("logErrorMsg<%=suffix %>").innerHTML = "";
		updateSourceForLogChange<%=suffix %>(id,n);
		<%}%>	
	}
	
	function clearLastLbmFilters<%=suffix %>(){
		var list = <%=treeName%>.getAllSubItems(lastSelectedLogId<%=suffix %>);
		if (list){
			var arr = list.split(",");
			for (var i=0; i<arr.length; i++){
				<%=treeName%>.setCheck(arr[i],0);
			}
		}
	}
	
	function updateSourceForLogChange<%=suffix %>(id,name){
	}
	
	var <%=treeName%>;
	var treeUrl<%=suffix %>;
	var cbmode<%=suffix %>;
	function createTree<%=suffix %>(treeDivId){
	  var lbmParam = "?mode=<%=mode%>&logPopupMenu=<%=logPopupMenu%>";
	  lbmParam = lbmParam + "&showMonitorsModule=<%=showMonitorsModule%>&showReportsModule=<%=showReportsModule%>&showCollectionsModule=<%=showCollectionsModule%>";
	  <%if (logTypesToIgnore != null && logTypesToIgnore.length() > 0){%>
	  lbmParam = lbmParam + "&LOG_TYPES_TO_IGNORE=<%=logTypesToIgnore%>";
	  <%}%>
	  <%if (checkEditPermissions){%>
	  lbmParam = lbmParam + "&checkEditPermissions=true";
	  <%}%>
	  if (lbmId<%=suffix %> && lbmId<%=suffix %> != ""){
		  lastSelectedLogId<%=suffix %> = "Log-" + lbmId<%=suffix %>;
	    lbmParam = lbmParam + "&LOG_ID=" + lbmId<%=suffix %>;
	    if (filterId<%=suffix %> && filterId<%=suffix %> != ""){
	    	lbmParam = lbmParam + "&FILTER_ID=" + filterId<%=suffix %>;
	    }
	  }
	  //alert(lbmParam);
		<%=treeName%>=new dhtmlXTreeObject(treeDivId,"100%","100%","0");
		<%=treeName%>.enableTreeLines(false);
		<%=treeName%>.setOnLoadingStart(startLoading);
		<%=treeName%>.setOnLoadingEnd(endLoading);
		<%=treeName%>.setImagePath("<%=baseDirectory%>");
		<%=treeName%>.setIconSize(13,13);
		<%=treeName%>.loadingDivName = "loadingDiv<%=suffix %>";
		<%if (logPopupMenu){%>
		<%=treeName%>.setOnRightClickHandler(rightClickNode<%=suffix %>);
		<%}%>
	
	  <%=treeName%>.suffix = "<%=suffix %>";
		<%=treeName%>.handleMark = true;
		<%=treeName%>.checkUponSelect = true;
		<%=treeName%>.setOnClickHandler(updateLogName<%=suffix %>);
		<%if (checkBoxes){%>
		cbmode<%=suffix %> = true;
		<%=treeName%>.enableCheckBoxes(1);
		<%}else{%>
		cbmode<%=suffix %> = false;
		<%=treeName%>.enableRadioButtons(true);
		<%=treeName%>.enableSingleRadioMode(true);		
		<%}%>
		<%
		String autoLoadUrl = baseDirectory + "common/moduleTreeXML.jsp?mode="+mode+"&logPopupMenu="+logPopupMenu;
		if (logTypesToIgnore != null && logTypesToIgnore.length() > 0){
			autoLoadUrl += "&LOG_TYPES_TO_IGNORE="+logTypesToIgnore;
		}
		if (checkEditPermissions){
			autoLoadUrl += "&checkEditPermissions=true";
		}
		%>
		<%=treeName%>.setXMLAutoLoading("<%=autoLoadUrl%>");
		treeUrl<%=suffix %> = "<%=baseDirectory%>common/moduleTreeXML.jsp" + (lbmParam ? lbmParam : "");
		<%=treeName%>.loadXML(treeUrl<%=suffix %>);
	}
	
	function updateTree<%=suffix %>(logId,logName,filterId,filterName,noReload){
		if (<%=treeName%> && !noReload){
			for (i=<%=treeName%>.htmlNode.childNodes.length-1; i>=0; i--){
				<%=treeName%>.deleteItem(<%=treeName%>.htmlNode.childNodes[i].id);
			}
			var url = treeUrl<%=suffix %>;
			if (logId && logId.length > 0){
				url += "&LOG_ID=" + logId;
			}
			if (filterId && filterId.length > 0){
				url += "&FILTER_ID=" + filterId;
			}
			<%=treeName%>.loadXML(url,updateTreeCallBack<%=suffix %>(logName,filterName));
		}else{
			var pm = document.getElementById("logName<%=suffix %>");
			if (pm){
			<% if (useTextBox){%>
				pm.value = logName;
			<%}else{%>
				pm.innerHTML = '&nbsp;<b>' + logName + '</b>';
			<%}%>
			}
			lbmId<%=suffix %> = logId;
			lastSelectedLogId<%=suffix %> = "Log-" + logId;
			updateSourceForLogChange<%=suffix %>(lastSelectedLogId<%=suffix %>,logName);
			//logSelectionTreeLoaded<%=suffix %> = false;
			if (<%=treeName%>){
				for (i=0; i<<%=treeName%>.htmlNode.childNodes.length; i++){
					<%=treeName%>.deleteItem(<%=treeName%>.htmlNode.childNodes[i].id);
				}
			}
			var treeboxId = "treeboxbox_treeSelectLog<%=suffix %>";
			createTree<%=suffix %>(treeboxId);
			logSelectionTreeLoaded<%=suffix %> = true;
		}
	}
	
	function updateTreeCallBack<%=suffix %>(logName,filterName){
		//alert(logId + "," + filterId);
		var id = "";
		if (lbmId<%=suffix %> && lbmId<%=suffix %>.length > 0){
			if (filterId && filterId.length > 0){
				id = "<%=XpoLogObjectTypes.FILTER_TYPE%>-" + lbmId<%=suffix %> + "#" + filterId;
			}else{
				id = "<%=XpoLogObjectTypes.LOG_TYPE%>-" + lbmId<%=suffix %>;
			}
		}
		//alert(id);
		updateLogName<%=suffix %>(id,logName,filterName);
		refreshMenus();
	}
	
	function openNewLogDiv<%=suffix %>(){
		var params = "baseDirectory=<%=baseDirectory%>&baseDirectory2=<%=baseDirectory2%>";
		params += "&ignoreHeader=true&embedded=true";
		params += "&showMonitorsModule=<%=showMonitorsModule%>&showReportsModule=<%=showReportsModule%>&showCollectionsModule=<%=showCollectionsModule%>";
		var url = "<%=baseDirectory%>loggers/quicklog/quickLogAdmin.jsp?" + params;
		sendAjaxRequest(url,function(req){
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result){
				alert("Cannot create new log");
				return;			
			}
			showGeneralAdminDiv("NewLog");
			updateGeneralAdminDiv("NewLog",result);
		});
	}

	function _openNewLogDiv<%=suffix %>(){
		showHideLayerInMiddle2("newLogDiv<%=suffix %>",100,50);
		document.getElementById("newLogFrm<%=suffix %>").style.display = "";
	}
	
	function rightClickNode<%=suffix %>(e){
		hideVisibleMenus();
		var id = this.childNodes[0].parentObject.id;
		lbmId<%=suffix %> = id.substring(4);
		var menuId = this.childNodes[0].parentObject.treeNod.getUserData(id,"popupKey");
		var htmlNode = document.getElementById(id);
		openPopupMenu(htmlNode,menuId);
		return false;
	}
	
	function createNewFilter<%=suffix %>(){
		openNewFilterDiv<%=suffix %>();
	}
	
	function openNewFilterDiv<%=suffix %>(x,y){
		<%
		if(doHideAllGeneralAdminDivWhenOpenningDiv) {
		%>
		hideAllGeneralAdminDiv();
		<%
		}
		%>
		var params = "baseDirectory=<%=baseDirectory%>&embedded=true&tableStyle=none&newFilterLabel=<%=newFilterLabel %>";
		var url = "<%=baseDirectory%>common/addLogFilter.jsp?" + params;
		sendAjaxRequest(url,function(req){
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result){
				alert("Cannot create new log");
				return;			
			}
			if (!x) x = -1;
			if (!y) y = -1;
			showGeneralAdminDiv("NewFilter",x,y);
			updateGeneralAdminDiv("NewFilter",result);
			if(document.getElementById("filterText<%=suffix %>")) {
				setTimeout("document.getElementById('filterText<%=suffix %>').focus()",5);
			}
		});
	}

	function _openNewFilterDiv<%=suffix %>(){
	  document.getElementById("addFilterTitle<%=suffix %>").innerHTML = "Add filter";
	  showLayerInMiddle("addFilterDiv",200,100);
	}
	
	function saveNewFilter<%=suffix %>(){
		var lId = "";
		if(lastSelectedLogId<%=suffix %> && lastSelectedLogId<%=suffix %>.length > 0 && lastSelectedLogId<%=suffix %>.indexOf("Log") == 0){
			lId = lastSelectedLogId<%=suffix %>.substring(4);
		}else if (lbmId<%=suffix %>){
			lId = lbmId<%=suffix %>;
		}
		var params = "lbmId="+lId;
		params = params + "&filterText=" + encodeURIComponent(document.getElementById("filterText<%=suffix %>").value);
		params = params + "&filterRegExp=" + (document.getElementById("filterRegExp<%=suffix %>").checked == true ? "true" : "false");
		var url = "<%=baseDirectory%>common/saveNewFilter.jsp?useTempLbm=<%=useTempLbm%>&" + params;
		//alert(url);
		sendAjaxRequest(url,function(req){
			var result = req.responseText;	
			var fId = "";
			if(!result){
				alert("Could not get save filter!");
				return;			
			}
			result = result.replace(/^\s+|\s+$/g, '');
			var resultStrs = result.split("#");
			if (resultStrs.length > 1 && resultStrs[0] == "FILTER_SAVE_ERROR"){
		    showHideLayerInMiddle2("messageDiv",300,220);
		    var d = document.getElementById("messageDiv<%=suffix %>");
		    if (d){
		    	d.style.zIndex = 600;
		    	var msgTitle = document.getElementById("messageText<%=suffix %>");
		    	if (msgTitle){
		    		var msg = "";
		    		for (var i=1; i<resultStrs.length; i++){
		    			if (msg != ""){
		    				msg = msg + "<br>";
		    			}
		    			msg = msg + resultStrs[i];
		    		}
		    		msgTitle.innerHTML = msg;
		    	}
		    }
			}else{
				fId = result;
				showHideGeneralAdminDiv("NewFilter");
				updateSourceForFilterChange<%=suffix %>(lId,fId);
			}
		});
	}
	
	function updateSourceForFilterChange<%=suffix %>(lId,fId){
	}
	
	function createLogMenu<%=suffix %>(){
		var logMenu = new jsDOMenu(150,"","absolute");
	  with(logMenu){
	    addMenuItem(new menuItem("add new filter", "addFilter", "javascript:openNewFilterDiv<%=suffix %>()"));
		}
	}
	
	//override tree functions
	var lastSelectedLogNodeId<%=suffix %> = "Log-<%=lbmId%>";
	dhtmlXTreeObject.prototype.onCheckBoxClick=function(e,htmlObject,mode){	
		var obj=this.parentObject;		
		if(htmlObject){
			obj=htmlObject;
		}
		var that=obj.treeNod;
		
	  var suffix = that.suffix;
	  if (!suffix){
	   suffix = "";
	  }
		if(that.markUponCheck){
			that._selectItem(obj);
		}
		if(obj.dscheck){
			return true;
		}

		if(that.tscheck){
			if(obj.checkstate==1){
				that._setSubChecked(false,obj);
			}else{
				that._setSubChecked(true,obj);
			}
		}else{
			if (!eval("cbmode" + suffix) && eval("lastSelectedLogNodeId" + suffix) == obj.id){
				return;
			}
			if(obj.checkstate==1){
				that._setCheck(obj,false);
			}else{
				that._setCheck(obj,true);
			}
		}
		that._correctCheckStates(obj.parentObject);
		if(that.handleMark && !mode){
			that.onRowSelect(e,this,false,true);
		}
		if (obj.id && obj.id.indexOf("Log-") != -1){
			eval("lastSelectedLogNodeId" + suffix + "= '" + obj.id + "'");
		}
		if(that.checkFuncHandler){
			return(that.checkFuncHandler(obj.id,obj.checkstate));
		}
		else return true;
	};
	
</script>