<%@ page language="java"%>


<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  String CURRENT_MODULE = "CURRENT_MODULE";
  String ERROR_OBJ = "ERROR_OBJ";
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  
  String baseDirectory = request.getParameter("baseDirectory");
  if (baseDirectory == null){
  	baseDirectory = BASE_DIRECTORY;
  }

  String paddingLeft = "0px";
  String paddingLeftStr = request.getParameter("paddingLeft");
  if (paddingLeftStr != null && paddingLeftStr.length() > 0){
  	paddingLeft = paddingLeftStr;
  }

 	String objectType = request.getParameter("OBJECT_TYPE");
  if(objectType == null || objectType.length() == 0){  	
  	objectType = "";
  }
  String objectId = request.getParameter("OBJECT_ID");
  if(objectId == null || objectId.length() == 0){  	
  	objectId = "";
  }
	MetaDataManager metaDataMgr = SiteManagment.getInstance().getMetaDataMgr();
	MetaData[] systemMetaDatas = metaDataMgr.getAllSystemMetaDatas(userContext);
	String displayTreeLink = "";
	if(systemMetaDatas == null || systemMetaDatas.length == 0){
		displayTreeLink = "none";
	}
	String applicationsNameStr = "";
	String applicationsIdsStr = "";
  String applicationsIds = request.getParameter("APPLICATIONS_IDS");
  if (applicationsIds == null){
  	applicationsIdsStr = "";
  }else{
  	applicationsIdsStr = applicationsIds;
  }
  String[] ids = null;
	if(applicationsIdsStr.length() > 0){		
	  ids = applicationsIdsStr.split("#");
	  applicationsIdsStr = "";
	  for(int i = 0 ;ids != null &&  i < ids.length ; i++){
			MetaData meta =	metaDataMgr.getMetaData(ids[i]);
	  	if(meta != null){
	  		applicationsNameStr += meta.getName() + ", ";
	  		applicationsIdsStr += meta.getId() + ", ";	
	  	}
	  }
	}else{
		HashSet set = metaDataMgr.getMetaDatasByXplgObject(objectType,objectId,true);
		String appName = "", appId = "";
		if (set != null){
			for(Iterator iter = set.iterator();iter.hasNext();){
	  		MetaData meta = (MetaData)iter.next();
		  	appName = meta.getName();
		  	applicationsNameStr += appName + ", ";
			  appId = meta.getId();
		  	applicationsIdsStr += appId + ", ";		  
		  }
		}
	}
	if(applicationsNameStr.endsWith(", ")){
		applicationsNameStr = applicationsNameStr.substring(0,applicationsNameStr.length() - 2);
	}
	String applicationParam = "?SELECTED_APP_IDS=" + applicationsIdsStr;

  String treeName = request.getParameter("treeName");
  if (treeName == null || treeName.length() == 0){
  	treeName = "appTree";
  }
  
  request.setAttribute("baseDirectory",baseDirectory);
  request.setAttribute("applicationParam",applicationParam);
  request.setAttribute("treeName",treeName);
  
  String titleColWidth = request.getParameter("titleColWidth");
  if (titleColWidth == null || titleColWidth.length() == 0){
  	titleColWidth = "100";
  }
  
  String folderNameWidth = request.getParameter("folderNameWidth");
  if (folderNameWidth == null || folderNameWidth.length() == 0){
  	folderNameWidth = "20";
  }
  
  String useTextBoxStr = request.getParameter("useTextBox");
  boolean useTextBox = useTextBoxStr == null || !useTextBoxStr.equals("false");
  
  String textBoxSize = request.getParameter("textBoxSize");
  if (textBoxSize == null || textBoxSize.length() == 0){
  	textBoxSize = "40";
  }
  
  String textBoxDisabledStr = request.getParameter("textBoxDisabled");
  boolean textBoxDisabled = textBoxDisabledStr == null || !textBoxDisabledStr.equals("false");
  
  String allowNewApplicationStr = request.getParameter("allowNewApplication");
  boolean allowNewApplication = allowNewApplicationStr == null || allowNewApplicationStr.equals("true");
  if (userContext!= null && !userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.METADATA_PERMISSION)){
  	allowNewApplication = false;
  }
  String actionsNames = allowNewApplication ? "Apply#Create New#Cancel" : "Apply#Cancel";
  String actions = allowNewApplication ? "javascript:applyParentApplicationName()#javascript:goNewApplicationName('newApplicationLink')#javascript:hideApplicationTree()" : "javascript:applyParentApplicationName()#javascript:hideApplicationTree()";
%>

<%@page import="java.util.HashSet"%>
<%@page import="xpolog.eye.meta.MetaDataManager"%>
<%@page import="xpolog.eye.meta.MetaData"%>
<%@page import="java.util.Iterator"%>
<jsp:include page="../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
</jsp:include>

<script>
	function showApplicationTree(){
		showGeneralAdminDiv("parentApp");	
	}

	function hideApplicationTree(){
		hideGeneralAdminDiv("parentApp");
	}
	
	function getParentApplications(tree){
		var list = tree.getAllChecked();
		var arr = list.split(",");
	  var appsStr = "";
		for (var i=0; i<arr.length; i++){
			id = arr[i];
			appsStr += id + "#";
		}
		return appsStr;;
	}
	
	function updateParentApplication(tree,appTagName){		
		eval("document.access."+appTagName).value = getParentApplications(tree);
	}
	
	function setApplicationName(appsStr){
	  var pm = document.getElementById("parentAppName");
	  if (pm){ 
	    <% if (useTextBox){%>
		  	pm.value = appsStr;
			  <% } else {  %>
			  pm.innerHTML = '<span class="REGULARTEXT"><nobr><b>' + appsStr + '</b></nobr></span>';
			  <%}%>
	  }
	}
    
	function applyParentApplicationName(){
		if (<%=treeName%>){
		  var appsStr = "";
			var list = <%=treeName%>.getAllChecked();
			var arr = list.split(",");
			if(!arr || arr == ""){
					appsStr = ""			
			}else{
					for (var i=0; i<arr.length; i++){
						var id = arr[i];
						var name = <%=treeName%>.getItemText(id);
						appsStr += name;
						if(i < arr.length - 1){
							 appsStr += ", ";
						}
					}
				}	
				setApplicationName(appsStr);
		}		
			
		hideApplicationTree();   
	}
	
	
function goNewApplicationName(divId){
			showGeneralAdminDiv("newApp");	
			document.getElementById("newApplicationName").focus();
}

function cancelNewApplicationName(){
	hideGeneralAdminDiv("newApp");
}


function saveNewApplicationName(){    
	var newApplicationId = "";
	if(document.access.newApplicationId) {
		newApplicationId = document.access.newApplicationId.value;
	}
	var newApplicationName = document.access.newApplicationName.value;
	var url = "<%=baseDirectory%>metadata/newApplicationNameAction.jsp?timeStm=" + new Date().getTime() + "&newAppId=" + newApplicationId + "&newAppName=" + newApplicationName +
						"&OBJECT_ID=newApplicationLink&OBJECT_TYPE=<%=objectType%>";						
	contextreq = GetXmlHttpObject();
	contextreq.open('POST', url, true);
	contextreq.onreadystatechange = saveNewApplicationNameCallback;
  contextreq.send(null);  		
}


function saveNewApplicationNameCallback(){
	if (contextreq.readyState == 4) {
			if (contextreq.status == 200) {
				var result = contextreq.responseText;					
				result = result.replace(/^\s+|\s+$/g, '') ;
				if(!result){
					alert("Could not add new application name!.");
					return;			
				}
				var resultArr = result.split("@");
				if(resultArr && resultArr[0] && resultArr[0] == "ok"){
						var appName = resultArr[1];							
						var appId = resultArr[2];
						 var appIds =  <%=treeName%>.getAllChecked();
				    if (appTree.htmlNode && appTree.htmlNode.childNodes && appTree.htmlNode.childNodes.length > 0){
					    	appTree.deleteItem(appTree.htmlNode.childNodes[0].id);
				    }

				    if (appIds && appIds != ""){
				      appIds = appIds + "," + appId;
				    }else {
				       appIds =  appId;
				    } 

						appTree.loadXML("<%=baseDirectory%>common/applicationTreeXML.jsp?SELECTED_APP_IDS=" + appIds);							
						appTree.setXMLAutoLoading("<%=baseDirectory%>common/applicationTreeXML.jsp");
						var pa = document.getElementById("parentApplicationName");
						if (pa){
							setApplicationName(appName);		
						}
						hideGeneralAdminDiv("newApp");
												
				}else{				
					updateMsgDiv(result,"newAppMsgDiv");
				}
			}
	}
}	

function updateMsgDiv(msg,id){
	var msgElem = document.getElementById(id);
	if(msgElem){
		//msgElem.innerHTML = "";
		msgElem.style.display = "";
		//msgElem.innerHTML = msg;
		handleInnerHTML(msgElem, msg, 1);
	}
}

function prepareApplicationToSubmit(){      
   document.getElementById("parentApplication").value = getParentApplications(appTree);    
  }
    
</script>
<jsp:include page="adminGeneralDiv.jsp" flush="true">
			<jsp:param name="baseDirectory" value="<%=baseDirectory%>"/> 
			<jsp:param name="title" value="Tag to Application(s)"/> 
			<jsp:param name="suffix" value="parentApp"/> 
			<jsp:param name="includePath" value="common/selectParentApplicationInner.jsp"/> 			
			<jsp:param name="width" value="500px"/> 
			<jsp:param name="height" value="300px"/>
			<jsp:param name="zIndex" value="300"/> 
			<jsp:param name="actionsNames" value="<%=actionsNames %>"/> 
			<jsp:param name="actions" value="<%=actions %>"/> 
			</jsp:include> 

<%
actions = "javascript:saveNewApplicationName()#javascript:cancelNewApplicationName()";
%>
<jsp:include page="adminGeneralDiv.jsp" flush="true">
			<jsp:param name="baseDirectory" value="<%=baseDirectory%>"/> 
			<jsp:param name="title" value="New Application"/> 
			<jsp:param name="suffix" value="newApp"/> 
			<jsp:param name="includePath" value="common/selectNewApplicationInner.jsp"/> 			
			<jsp:param name="width" value="350px"/> 
			<jsp:param name="height" value="140px"/>
			<jsp:param name="zIndex" value="500"/> 
			<jsp:param name="actionsNames" value="Add#Cancel"/> 
			<jsp:param name="actions" value="<%=actions %>"/> 
			</jsp:include> 

<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse">
	<tr>
		<td>
		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse">
			<tr>
			<td style="padding-left:<%=paddingLeft%>" width="<%=titleColWidth%>"><span class="REGULARTEXT"><nobr>Tag to Application(s):</nobr></span></td>				
				<td style="padding-left:0" width="<%=folderNameWidth%>">
				<% if (useTextBox){ %>
				<input id="parentAppName" type="text" size="<%=textBoxSize%>" value="<%=applicationsNameStr == null || applicationsNameStr.length() == 0 ? "" : applicationsNameStr%>" <%=textBoxDisabled ? "readonly" : "" %> 
					onClick="javascript:showApplicationTree()" class="<%=textBoxDisabled ? "DISABLED_TEXTBOX" : ""%>" style="cursor:pointer;cursor:hand;">
				<%} else {%>
					<span class="REGULARTEXT"><b><%=applicationsNameStr == null || applicationsNameStr.length() == 0 ? "&nbsp;" : applicationsNameStr%></span>				
				<%} %>
				</td>				
				<td width="*" align="left" style="padding-left:10"><div id="showParentAppLink" ><a class="BUTTON_MEDIUMLINK" href="javascript:showApplicationTree()">select</a></div></td>							
			</tr>
		</table>
		</td>
	</tr>
</table>
