<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.admin.helpers.WinEventAdminHelper"%>
<%@ page import="xpolog.eye.error.*"%>
<%!
	static final String BASE_DIRECTORY = "../";
	static final String NO_FOLDERS_AVAILABLE = "No folders available, check permissions";
%>
<%
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  String CURRENT_MODULE = "CURRENT_MODULE";
  String ERROR_OBJ = "ERROR_OBJ";
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  
  String baseDirectory = request.getParameter("baseDirectory");
  if (baseDirectory == null){
  	baseDirectory = BASE_DIRECTORY;
  }

  String paddingLeft = "0px";
  String paddingLeftStr = request.getParameter("paddingLeft");
  if (paddingLeftStr != null && paddingLeftStr.length() > 0){
  	paddingLeft = paddingLeftStr;
  }

  //String selectLink = "select parent folder";
  String selectLink = "select";
  String shortLink = request.getParameter("shortLink");
  if (shortLink != null && shortLink.equals("true")){
  	selectLink = "select";
  }

  String useSessionModuleStr = request.getParameter("useSessionModule");
  boolean useSessionModule = useSessionModuleStr != null && useSessionModuleStr.equals("true");
  String parentModuleParam = "?mode=modules";
  Module parentModule = null;
  String parentModuleId = request.getParameter("PARENT_MODULE_ID");
  boolean invalidParentModule = false;
  if (parentModuleId != null && parentModuleId.length() > 0){
    try {
    	if(userContext != null && userContext.isModuleMemberEditable(parentModuleId)) {
      	parentModule = mgmt.getModuleFromId(parentModuleId);
    	}
    }catch (Exception e){}
  }else{
  	if (useSessionModule){
  		parentModule = (Module)request.getSession().getAttribute(CURRENT_MODULE);
    	if(parentModule != null) {
    		Module tmp = SiteManagment.getInstance().getModuleFromId(parentModule.getId());
    		if(tmp == null) {
  	  		invalidParentModule = true;
    		}
    	}
  	}
  }
  if (parentModule == null || parentModule.getId() == null || parentModule.getId().length() == 0 || invalidParentModule){
  	if(userContext != null && userContext.isModuleMemberEditable(Module.ROOT_MODULE_ID)) {
  		parentModule = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
  	}
  }

  if (parentModule != null){
  	if (!userContext.isModuleMemberEditable(parentModule.getId())){
  		Module[] userModules = mgmt.getAllModules(userContext, true);
  		if (userModules != null && userModules.length > 0){
  			parentModule = userModules[0];
  		}
  	}
  }else {
  	Module[] userModules = mgmt.getAllModules(userContext, true);
		if (userModules != null && userModules.length > 0){
			parentModule = userModules[0];
		}
  }
  
  if (parentModule != null){
  	parentModuleParam += "&MODULE_ID="+parentModule.getId();
  }

  String modulesToIgnore = request.getParameter("MODULE_IDS_TO_IGNORE");
	if (modulesToIgnore != null && modulesToIgnore.length() > 0){
		parentModuleParam += "&MODULE_IDS_TO_IGNORE="+modulesToIgnore;
	}

  String parentModuleName = parentModule != null ? parentModule.getName() : NO_FOLDERS_AVAILABLE;
  String treeName = request.getParameter("treeName");
  if (treeName == null || treeName.length() == 0){
  	treeName = "tree";
  }
  request.setAttribute("baseDirectory",baseDirectory);
  request.setAttribute("parentModuleParam",parentModuleParam);
  request.setAttribute("treeName",treeName);
  
  String titleColWidth = request.getParameter("titleColWidth");
  if (titleColWidth == null || titleColWidth.length() == 0){
  	titleColWidth = "100";
  }
  
  String folderNameWidth = request.getParameter("folderNameWidth");
  if (folderNameWidth == null || folderNameWidth.length() == 0){
  	folderNameWidth = "20";
  }
  
  String useTextBoxStr = request.getParameter("useTextBox");
  boolean useTextBox = useTextBoxStr == null || !useTextBoxStr.equals("false");
  
  String textBoxSize = request.getParameter("textBoxSize");
  if (textBoxSize == null || textBoxSize.length() == 0){
  	textBoxSize = "40";
  }
  
  String height = request.getParameter("height");
  if (height == null){
  	height = "300px";
  }
  
  String textBoxDisabledStr = request.getParameter("textBoxDisabled");
  boolean textBoxDisabled = textBoxDisabledStr == null || !textBoxDisabledStr.equals("false") || parentModuleName.equals(NO_FOLDERS_AVAILABLE);  
  
  String allowNewFolderStr = request.getParameter("allowNewFolder");
  boolean allowNewFolder = allowNewFolderStr == null || allowNewFolderStr.equals("true");
  if (userContext!= null && !userContext.isHavePermission(ActionsPermissionConstants.AdministrationPermissions.ADD_MODULE_PERMISSION)){
  	allowNewFolder = false;
  }
  String actionsNames = allowNewFolder ? "Create New@id=createNewFolderBtn#Cancel" : "Cancel";
  String actions = allowNewFolder ? "javascript:showNewParentFolder()#javascript:hideParentModuleTree()" : "javascript:hideParentModuleTree()";
%>

<jsp:include page="../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
</jsp:include>


<script>
	function showParentModuleTree(){			   
		showGeneralAdminDiv("parentModule");					
	}

	function hideParentModuleTree(){
		hideNewParentFolder();
		hideGeneralAdminDiv("parentModule");
	}
	
	function updateParentModule(tree,modTagName){
		eval("document.access."+modTagName).value = getSelectedParentModule(tree);
	}
    
	var parentModuleId = "<%=parentModule != null ? parentModule.getId() : ""%>";
	var lastSelectedParentModuleId = "<%=parentModule != null ? XpoLogObjectTypes.MODULE_TYPE+"-"+parentModule.getId() : ""%>";
	var treeUrl;
	var closeParentModuleDivUponSelection = true;
	function updateParentModuleName(id,name){
		var pm = document.getElementById("parentModuleName");
		if (pm){
			var n = name;
			if (<%=treeName%>.isItemChecked(id)){
				n = <%=treeName%>.getItemText(id);
			}
			parentModuleId = id.substring(4);
			<% if (useTextBox){%>
			pm.value = n;
			<% } else {  %>
			pm.innerHTML = '<span class="REGULARTEXT"><nobr><b>' + n + '</b></nobr></span>';
			<%}%>			
		}
		lastSelectedParentModuleId = "<%=XpoLogObjectTypes.MODULE_TYPE%>"+parentModuleId;
		if (closeParentModuleDivUponSelection){
			hideGeneralAdminDiv("parentModule");
			document.getElementById("parentModuleErrorMsg").style.display ="none";
			document.getElementById("parentModuleErrorMsg").innerHTML = "";
		}		
	}
		
	//override tree functions
	var lastSelectedModuleNodeId = "<%=parentModule != null ? "Module-"+ parentModule.getId() : ""%>";
	dhtmlXTreeObject.prototype.onCheckBoxClick=function(e,htmlObject,mode){
		var obj=this.parentObject;
		if(htmlObject){
			obj=htmlObject;
		}
		var that=obj.treeNod;
		
		if(that.markUponCheck){
			that._selectItem(obj);
		}
		if(obj.dscheck){
			return true;
		}
		if(that.tscheck){
			if(obj.checkstate==1){
				that._setSubChecked(false,obj);
			}else{
				that._setSubChecked(true,obj);
			}
		}else{
			if (lastSelectedModuleNodeId == obj.id){
				return;
			}
			if(obj.checkstate==1){
				that._setCheck(obj,false);
			}else{
				that._setCheck(obj,true);
			}
		}
		that._correctCheckStates(obj.parentObject);
		if(that.handleMark && !mode){
			that.onRowSelect(e,this,false,true);
		}
		
		if (obj.id && obj.id.indexOf("Module-") != -1){
			lastSelectedModuleNodeId = obj.id;
		}
		if(that.checkFuncHandler){
			return(that.checkFuncHandler(obj.id,obj.checkstate));
		}
		else return true;
	};
	
	function showNewParentFolder(){
		var parentModDiv = document.getElementById("adminGeneralIncludeTDparentModule");
		if (parentModDiv){
			parentModDiv.scrollTop = 0;
		}
		var el = document.getElementById("newFolderDiv");
		if (el){
			el.style.display = "";
			var createBtn = document.getElementById("createNewFolderBtn");
			if (createBtn){
				createBtn.innerHTML = "Save";
				createBtn.href = "javascript:saveNewFolder()";
			}
			closeParentModuleDivUponSelection = false;
		}
	}
	
	function hideNewParentFolder(){
		var el = document.getElementById("newFolderDiv");
		if (el){
			el.style.display = "none";
			var createBtn = document.getElementById("createNewFolderBtn");
			if (createBtn){
				createBtn.innerHTML = "<nobr>Create New</nobr>";
				createBtn.href = "javascript:showNewParentFolder()";
				createBtn.className = "BUTTON";
			}
			closeParentModuleDivUponSelection = false;
		}
		clearNewModuleNameError();
		document.access.newModuleName.value = "";
		allowSave = true;
		closeParentModuleDivUponSelection = true;
	}
	
	function getSelectedParentModule(tree){
		var list = tree.getAllChecked();
		var arr = list.split(",");
	  var logsStr = "";
	  var modsStr = "";
		for (var i=0; i<arr.length; i++){
			var s = arr[i];
			var ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				type = s.substring(0,ind);
				id = s.substring(ind+1,s.length);
				if (type == "<%=XpoLogObjectTypes.MODULE_TYPE%>"){
					if (modsStr != ""){
						modsStr += ",";
					}
					modsStr += id;
				}else{
					if (logsStr != ""){
						logsStr += ",";
					}
					logsStr += id;
				}
			}
		}
		return modsStr;
	}
    
	var allowSave = true;
	function saveNewFolder(){
		var parentModId = getSelectedParentModule(<%=treeName%>);
		var newModName = document.access.newModuleName.value;
		if (!newModName || newModName == ""){
			var errorElem = document.getElementById("newModuleNameErrorMsg");
			if (errorElem){
			  document.access.newModuleName.className = 'ERROR_MSG_BACKGROUNDCOLOR';
			  errorElem.style.display ="";			
			  errorElem.innerHTML = "Please enter a folder name";
			  document.getElementById("newModuleNameErrorMsgTR").style.display ="";
			}
			return;
		}
		var parentModDiv = document.getElementById("adminGeneralIncludeTDparentModule");
		if (parentModDiv){
			parentModDiv.scrollTop = parentModDiv.scrollHeight;
		}
		showModuleSaveMessage("Saving folder...");
		var saveBtn = document.getElementById("createNewFolderBtn");
		if (saveBtn){
			saveBtn.className = "BUTTON_DISABLED";
		}
		var url = "<%=baseDirectory%>common/saveParentModuleAction.jsp?newModName="+newModName+"&parentModId="+parentModId;
		sendAjaxRequest(url,function(req){
			showModuleSaveMessage("");
			var xmlDoc = req.responseXML.documentElement;
			var resultElement = xmlDoc.getElementsByTagName("result")[0];
			var error = resultElement.getAttribute("error");
			if (error && error.length > 0){
				if (saveBtn){
					saveBtn.className = "BUTTON";
				}
				showModuleSaveMessage(error);
				return;
			}
			var modId = resultElement.getAttribute("modId");
			var modName = resultElement.getAttribute("modName");
			var insertItems = xmlDoc.getElementsByTagName("insertItem");
			for (var i=0; i<insertItems.length; i++){
				var parentId = insertItems[i].getAttribute("parentId");
				var itemId = insertItems[i].getAttribute("itemId");
				var itemText = insertItems[i].getAttribute("itemText");
				var image1 = insertItems[i].getAttribute("image1");
				var image2 = insertItems[i].getAttribute("image2");
				var image3 = insertItems[i].getAttribute("image3");
				var type = insertItems[i].getAttribute("type");
				if (parentId == "Module-rootModule"){
					updateRoot = true;
				}
			}
			hideNewParentFolder();
			closeParentModuleDivUponSelection = true;
			updateModuleSelectionTree(modId,modName,true);
			hideModuleSaveMessage();
		});
	}
	
	
	function updateModuleSelectionTree(modId,modName){
		if (<%=treeName%>){
			var parentModuleParam = "?mode=modules";
			for (i=<%=treeName%>.htmlNode.childNodes.length-1; i>=0; i--){
				<%=treeName%>.deleteItem(<%=treeName%>.htmlNode.childNodes[i].id);
			}
			var url = treeUrl;
			if (modId && modId.length > 0){
				url += "&MODULE_ID="+modId;
			}
			<%=treeName%>.loadXML(url,updateModuleSelectionTreeCallBack(modName));
		}
	}
	
	function updateModuleSelectionTreeCallBack(modName){
		var id = "";
		if (parentModuleId && parentModuleId.length > 0){
			id = "<%=XpoLogObjectTypes.MODULE_TYPE%>-" + parentModuleId;
		}
		updateParentModuleName(id,modName);
		refreshMenus();
	}
	
	function showModuleSaveMessage(message) {
		var saveLogMsgDiv = document.getElementById("saveModuleMsgDiv");
		if(saveLogMsgDiv) {
			saveLogMsgDiv.innerHTML = message;
			saveLogMsgDiv.style.display = "";
		}
	}
	
	function hideModuleSaveMessage() {
		var saveLogMsgDiv = document.getElementById("saveModuleMsgDiv");
		if(saveLogMsgDiv) {
			saveLogMsgDiv.innerHTML = "";
			saveLogMsgDiv.style.display = "none";
		}
	}
	
	function clearNewModuleName(){
		document.getElementById("newModuleName").className = 'TEXTBOX';
		clearNewModuleNameError();
	}
	
	function clearNewModuleNameError(){
		var errorElem = document.getElementById("newModuleNameErrorMsg");
		if (errorElem){
		  document.access.newModuleName.className = 'TEXTBOX';
		  errorElem.style.display = "none";			
		  document.getElementById("newModuleNameErrorMsgTR").style.display ="none";
		}
	}
    
</script>
 <jsp:include page="adminGeneralDiv.jsp" flush="true">
			<jsp:param name="baseDirectory" value="<%=baseDirectory%>"/> 
			<jsp:param name="title" value="Parent Folder"/> 
			<jsp:param name="suffix" value="parentModule"/> 
			<jsp:param name="includePath" value="common/selectParentModuleInner.jsp"/> 			
			<jsp:param name="width" value="500px"/> 
			<jsp:param name="height" value="<%=height%>"/>
			<jsp:param name="zIndex" value="300"/> 
			<jsp:param name="actionsNames" value="<%=actionsNames %>"/> 
			<jsp:param name="actions" value="<%=actions %>"/> 
			</jsp:include> 
<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
	<tr>
		<td>
		<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
			<tr>
				<td style="padding-left:<%=paddingLeft%>" width="<%=titleColWidth%>"><span class="REGULARTEXT"><nobr>Parent Folder:</nobr></span></td>				
				<td style="padding-left:0" width="<%=folderNameWidth%>">
				<% if (useTextBox){ %>
				<input id="parentModuleName" type="text" size="<%=textBoxSize%>" value="<%=parentModuleName == null || parentModuleName.length() == 0 ? "" : parentModuleName%>" <%=textBoxDisabled ? "readonly" : "" %>
					<%if(!textBoxDisabled) { %> onClick="javascript:showParentModuleTree()" <%} %> class="<%=textBoxDisabled ? "DISABLED_TEXTBOX" : ""%>" <%if(!textBoxDisabled) { %> style="cursor:pointer;cursor:hand;" <%} %>>
				<%} else {%>
					<span class="REGULARTEXT"><b><%=parentModuleName == null || parentModuleName.length() == 0 ? "&nbsp;" : parentModuleName%></span>				
				<%} %>
				</td>				
				<td width="*" align="left" style="padding-left:10"><div id="showParentModuleLink" <%=parentModuleName != null && parentModuleName.length() > 0 && !parentModuleName.equals(NO_FOLDERS_AVAILABLE) ? "" : "style=\"display:none\""%>><a class="BUTTON_MEDIUMLINK" href="javascript:showParentModuleTree()"><%=selectLink%></a></div></td>				
			</tr>
			<tr>
				<td>&nbsp;</td>
				<td colspan="2">
					<div id="parentModuleErrorMsg" style="display:none;" class="ERROR_MSG">
					</div>
				</td>
			</tr>
		</table>
		</td>
	</tr>
</table>


