<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.verifiers.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>


<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>

<%! 
	String getTreeDiv(Verifier node,UserContext userContext,HashMap verifiers, boolean addTypeToId, String treeName){
		return getTreeDiv(node,userContext,verifiers,addTypeToId,treeName,false);
	}

	String getTreeDiv(Verifier node,UserContext userContext,HashMap verifiers, boolean addTypeToId, String treeName, boolean disable){
		StringBuffer buffer = new StringBuffer();
	  String type = addTypeToId ? "Verifier," : "";
	  if (treeName == null || treeName.length() == 0) treeName = "verTree";
	  if (node != null){
	    boolean selected = verifiers != null && verifiers.containsKey(node.getId());
	    String treeKey = "node" + node.getId() + "_0";
	    String chkKey = "verifiers";
	    buffer.append("\nvar " + treeKey + " = "+treeName+".addNode("+treeName+".root,\"" + chkKey + "\",\"" + type+node.getId() + "\",\"" + node.getName() + "\",\"" + node.getDescription() + "\",''," + selected + ",true,"+disable+");");
	    addChildsNodeDiv(node,buffer,treeKey,userContext,verifiers,addTypeToId,treeName);
	  }
	  return buffer.toString();
	}
	void addChildsNodeDiv(Verifier node,StringBuffer buffer, String parentKey, UserContext userContext, HashMap verifiers, boolean addTypeToId, String treeName){
		MultiVerifier ver = null;
		VerifierManager verMgr = SiteManagment.getInstance().getVerifierManager();
		if(node.getType().equals(MultiVerifier.MULTI_TYPE)){
			try{
				ver = (MultiVerifier)SiteManagment.getInstance().getVerifierManager().getVerfierFromId(node.getId());
			}catch(Exception e){
				return;
			}
		}else{
			return;
		}
		List children = verMgr.getChildsForVerifier(userContext,node.getId(),false);
	  for (int i = 0; i < children.size(); i++) {
	    Verifier child = (Verifier)children.get(i);
	   	String key = child.getId();
	    String treeKey = parentKey + "_" + i;
	    String parentNode = parentKey.equals("node") ? "verTree.root" : parentKey;
	    String type = addTypeToId ? "Verifier," : "";
	    String extraText = "";
	    
	    boolean selected = false;
	    String chkKey = "verifiers";
      selected = verifiers != null && verifiers.containsKey(child.getId());
	    buffer.append("\nvar " + treeKey + " = "+treeName+".addNode(" + parentNode + ",\"" + chkKey +"\",\"" + type+child.getId() + "\",\"" + child.getName() + "\",\"" + child.getDescription() + "\",'" + extraText + "'," + selected + ",false,false);");
	    addChildsNodeDiv(child,buffer,treeKey,userContext,verifiers,addTypeToId,treeName);
	  }
	}
%>

<html>
	<head>
	</head>
	<body>
		<script>
      function markTreeNodeForExport(node){
				nodeCbx = document.getElementById("CheckBox_" + node.tree.name + "_" + node.index);
				if (!nodeCbx) return;
				if (node.selected == nodeCbx.checked) return;
	
				var selected = nodeCbx.checked;	
  	    if (this.onSelectMarkChilds){
    			markNodeChilds(node,selected);  
  			}else {
    			node.selected = selected;
	  		}
  
  			if (this.onSelectMarkParents  && selected){
    			markNodeParentsToRoot(node.parent,selected);  
  			}
		  }
		</script>
	</body>
</html>
