<%@ page language="java"%>

<%@ page import="xpolog.eye.managment.*" %>
<%@ page import="xpolog.eye.security.*" %>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.site.controllers.*" %>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
  
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  SiteWizardController control = env.getSiteWizardController();
  ControllerItem selectedItem = control.getCurrentItem();
 
%>


<html> 
<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
function goTo(url){
  if (this.parent &&  this.parent.parent && this.parent.parent.location.href.indexOf("controllerRoot") >= 0){    
    this.parent.parent.location = url;
  }else {
    alert("not find - " + this.parent.parent.location.href);
  }
}
</script>

</head>
<body topmargin=0 marginheight=0 leftmargin=0  marginwidth=0>
<table width="100%" height="100%" cellspacing="0" cellpadding="0" border="0">
<%if (control.getTopImg() != null && control.getTopImg().length() > 0){ %>
<tr height="20"><td>
<img src="<%=BASE_DIRECTORY + control.getTopImg()%>">
</td></tr>
<%}%>
<%if (control.getTitle() != null && control.getTitle().length() > 0){ %>
<tr height="20"><td align="left" style="padding-top:5;padding-left:10">
<span class="REGULARTEXT"><%=control.getTitle()%></span>
</td></tr>
<%}%>
<tr height="20"><td style="padding-top:10">
<table width="100%" height="100%" cellspacing="0" cellpadding="0" border="0" >
<%
 UIControllerItem defItem = control.getDefaultUIItem();
 for (int i = 0; i < control.getItemsCount();i++){
	 ControllerItem item = control.getItemAt(i);
	 if (!item.isVisible()){
		 continue;
	 }
	 UIControllerItem uiItem = item.getUiItem();
	 if (uiItem == null){
		 uiItem = defItem;
	 }
	 boolean isSelected = item == selectedItem;
%>
<tr height="10" style="padding-top:2;padding-bottom:2"  <%=(isSelected ? "class=\"MARKITEM\"" : "")%>>
<td>
<%
if (uiItem != null){
	String img = isSelected ? uiItem.getSelectedImg() : uiItem.getUnselectedImg();
  if (img != null && img.length() > 0){
   img = BASE_DIRECTORY + img;	
  
%>
<img src="<%=img%>">
<%}}%>
</td>
<td>
<%if (isSelected || item.isViewOnly()){%>
<span class="SMALLTEXT"><b><%=item.getName()%><b></span>
<%}else {%>
 <a class="REPORT_HEADER_LINK" href="<%="controllerSelectionAction.jsp?itemId=" + item.getId()%>" target="root"><%=item.getName()%></a>
<%}%>
</td>
</tr>
<%}%>
</table>
</td></tr>
<tr height="*"><td>&nbsp;
</td></tr>
<tr height="10"><td style="padding-top:5;padding-bottom:5">
<table width="100%" height="100%" cellspacing="0" cellpadding="0" border="0" >
<tr>
<td width="30">&nbsp;</td>
<td width="40" align="center">
<a <%= !control.isStart() ? "href=\"controllerPrevAction.jsp?fromController=true&proxyId=" + String.valueOf(System.currentTimeMillis()) + "\"" : ""%>><img border="0" src="<%=BASE_DIRECTORY%>images/controllers/prev.gif"></a>
</td>
<td width="30" align="center" style="padding-bottom:5"><a class="REPORT_HEADER_LINK" href="controllerCancel.jsp?fromController=true">exit</a></td>
<td width="40" align="center">
<%if (selectedItem != null && selectedItem.isShowNext()){ %>
<a href="controllerNextAction.jsp?fromController=true&proxyId=<%=String.valueOf(System.currentTimeMillis())%>"><img border="0" src="<%=BASE_DIRECTORY%>images/controllers/next.gif"></a>
<%}%>
</td>
<td width="*">&nbsp;</td>
</tr>
</table>
</td></tr>
</table>

</body>


</HTML>
