<%@ page language="java"%>

<%@ page import="xpolog.eye.managment.*" %>
<%@ page import="xpolog.eye.security.*" %>
<%@ page import="java.io.*" %>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.site.controllers.*" %>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%

  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  SiteWizardController control = env.getSiteWizardController();
  
  String forward = null;
  if (control != null){
  	String fromController = request.getParameter("fromController");
  	boolean isController = fromController != null && fromController.equals("true");
  	ControllerItem item = null;
  	if (isController){
    	item = control.nextItem();
  	}else {
  		item = control.getCurrentItem();
  		if (item == null || !item.isLoop()){
  			item = control.nextItem();
  		}
  	}
  	if (item != null){
    	forward = "controllers/controllerRoot.jsp?poxyId=" + System.currentTimeMillis();
  	}else {
  		forward = control.getExitPage();
  	}
  }

  if (forward == null || forward.length() == 0){
  	forward = "home.jsp";
  }
   forward = BASE_DIRECTORY + forward;
%>
<html>
<head>
<title>XpoLog Center</title>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">

<SCRIPT LANGUAGE="JavaScript">
var tmp = parent;
while (tmp && tmp.location.href && tmp.location.href.indexOf('controllerRoot.jsp') < 0){
  tmp = tmp.parent;
}
if (!tmp){
  tmp = top;
}
tmp.location = "<%=forward%>";
</script>
</head>
</HTML>