function enableDisableTask(){
	var id = getFirstSelectedRow(mygridAlerts);
	var alertType = mygridAlerts.getUserData(id,"alertType");
  var gridName = "mygridAlerts";
  if (id == "") {
		var msgWriter = new messageWriter("mygridMessage","No Alert Selected",BASE_DIRECTORY);
	  msgWriter.setYParent(document.getElementById(gridName),50);
	  msgWriter.addAction("OK","javascript:hideLayer('mygridMessage')");
	  msgWriter.showMessage("<nobr>Please select an alert</nobr>");
		return;
  }
  if(!ALLOW_EDIT_EXTERNAL_ALERTS) {
  	var external = mygridAlerts.getUserData(id,"external");
  	if(external && external == "true") {
  		var msgWriter = new messageWriter("mygridMessage","Operation Not Allowed",BASE_DIRECTORY);
		  msgWriter.setYParent(document.getElementById(gridName),50);
		  msgWriter.addAction("OK","javascript:hideLayer('mygridMessage')");
		  msgWriter.showMessage("<nobr>An external alert cannot be enabled/disabled</nobr>");
			return;
  	}
  }
  if (alertType){
		if (alertType == MAIL_TASK_TYPE){
			var page = "alerts/enableDisableAlertAction.jsp?verifierId=" + id; 
		  sendAjaxRequest(page,function(req){
		    var xmldoc = req.responseXML.documentElement;            	
	      var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
	      var message = xmldoc.getElementsByTagName('message')[0].text;
	      if (result == "true"){
	      	var url = BASE_DIRECTORY + ALERTS_XML_PAGE + getCurrentObjectsQuery();
			  	mygridAlerts.clearAll();
			  	mygridAlerts.loadXML(url);
			  	hideAllAlertDivs();
				}
		  });	
		}
  } 
}

function editTask0() {
	editTask('false');
}

function editTask(doHideAllGeneralAdminDiv){
	var id = getFirstSelectedRow(mygridAlerts);
	var alertType = mygridAlerts.getUserData(id,"alertType");
  var gridName = "mygridAlerts";
  if (id == "") {
		var msgWriter = new messageWriter("mygridMessage","No Alert Selected",BASE_DIRECTORY);
	  msgWriter.setYParent(document.getElementById(gridName),50);
	  msgWriter.addAction("OK","javascript:hideLayer('mygridMessage')");
	  msgWriter.showMessage("<nobr>Please select an alert to edit</nobr>");
		return;
  }
  if(!ALLOW_EDIT_EXTERNAL_ALERTS) {
  	var external = mygridAlerts.getUserData(id,"external");
  	if(external && external == "true") {
  		var msgWriter = new messageWriter("mygridMessage","Operation Not Allowed",BASE_DIRECTORY);
		  msgWriter.setYParent(document.getElementById(gridName),50);
		  msgWriter.addAction("OK","javascript:hideLayer('mygridMessage')");
		  msgWriter.showMessage("<nobr>An external alert cannot be edited</nobr>");
			return;
  	}
  }
  if (alertType){
		if (alertType == MAIL_TASK_TYPE){
			editMailAlert(id, doHideAllGeneralAdminDiv);
		}
  } 
}

var alertTypes = new Array();
alertTypes[0] = "MailAlert";

function addMailAlert(doHideAllGeneralAdminDiv){
	editMailAlert("", doHideAllGeneralAdminDiv);
}

var mailTaskLabels = "&emailTaskLabel=Email Alert";
function editMailAlert(verifierId, doHideAllGeneralAdminDiv){
	var url = "alerts/mailTaskDefinition.jsp?";
	url = url + "base_directory=" + BASE_DIRECTORY + "&noScripts=true&embedded=true";
	url = url + "&showName=false&showFrom=false&showAdvanced=true&suffix=MailAlert"+mailTaskLabels;
	if (verifierId && verifierId != ""){
		sendAjaxRequest("alerts/setVerifierInSession.jsp?verifierId="+verifierId,function(req1){
			showAlert("MailAlert",url,"Edit Email Alert",doHideAllGeneralAdminDiv);
		});
	}else{
		sendAjaxRequest("alerts/checkAlertPrecondition.jsp?alertType=" + MAIL_TASK_TYPE,function(req1){
			var preconditionResult = req1.responseText;
			if(trim(preconditionResult) == "ok") {
				showAlert("MailAlert",url,"Add Email Alert",doHideAllGeneralAdminDiv);
			}else {
				var preconditionUrl = BASE_DIRECTORY + "tasks/mail/mailSettings.jsp";
				showPrecondition("MailAlert",url,preconditionUrl);
			}
		});
	}
}

function showAlert(alertType,url,title,doHideAllGeneralAdminDiv){
	var index = url.indexOf("?");
	var params = "";
	if(index > -1) {
		params = url.substring(index + 1);
		url = url.substring(0, index);
	}
	sendAjaxRequest(url,function(req){
		if(!doHideAllGeneralAdminDiv || doHideAllGeneralAdminDiv == "true") {
			hideAllGeneralAdminDiv();
		}
		var result = req.responseText;	
		result = result.replace(/^\s+|\s+$/g, '') ;
		if(!result){
			alert("Could not get logs list!.");
			return;			
		}
		hideAllAlertDivs(alertType);
		showGeneralAdminDiv(alertType);
		if (title){
			var t = document.getElementById("generalDivTitle"+alertType);
			if (t){
				t.innerHTML = title;
			}
		}
		updateGeneralAdminDiv(alertType,result);
	}, 'POST', params);
}

function showPrecondition(alertType,url,preconditionUrl){
	if(preconditionUrl.indexOf("?") == -1) {
		preconditionUrl += "?";
	}
	preconditionUrl += "&postconditionUrl=" + escape(url);
	sendAjaxRequest(preconditionUrl,function(req){
		var result = req.responseText;	
		result = result.replace(/^\s+|\s+$/g, '') ;
		if(!result){
			alert("Could not get logs list!.");
			return;			
		}
		hideAllAlertDivs(alertType + "Precondition");
		showGeneralAdminDiv(alertType + "Precondition");
		updateGeneralAdminDiv(alertType + "Precondition",result);
	});
}

function saveMailSettings() {
	var postconditionUrl = document.getElementById("postconditionUrl");
	saveMailSettings0("MailAlert", postconditionUrl.value);
}

function saveMailSettings0(alertType,url) {
	var smtpHost = document.getElementById("SMTPHost").value;
	if(smtpHost == '') {
		alert("SMTP host cannot be empty");
		return;
	}else if(smtpHost == 'my.domain.com') {
		alert("SMTP host cannot be my.domain.com");
		return;
	}

	var params = "";
	params += "SMTPHost=" + document.getElementById("SMTPHost").value;
	params += "&SMTPProt=" + document.getElementById("SMTPProt").value;
	params += "&systemMailAddress=" + document.getElementById("systemMailAddress").value;
	sendAjaxRequest(BASE_DIRECTORY + "tasks/mail/mailSettingsAction.jsp?"+params,function(req){
		var result = req.responseText;	
		result = result.replace(/^\s+|\s+$/g, '') ;
		if(!result){
			alert("Could not get logs list!.");
			return;			
		}
		if(result.indexOf("ok") != -1) {
			hideGeneralAdminDiv(alertType + "Precondition");
			showAlert(alertType,url);
		}
	});
}

function hideAllAlertDivs(type){
	for (var i=0; i<alertTypes.length; i++){
		if (alertTypes[i] != type){
			hideGeneralAdminDiv(alertTypes[i]);
		}
	}
}

function closeAlertDiv(type){
	showHideGeneralAdminDiv(type);
}

function saveAlert(alertType){
	if(alertType == 'SNMPAlert' && eval("document.access." + SNMP_PREFIX + "AccountsList")) {
		eval("document.access.snmpAccountId" + alertType).value = eval("document.access." + SNMP_PREFIX + "AccountsList").value;
	}else if(alertType == 'JMSAlert' && eval("document.access." + JMS_PREFIX + "AccountsList")) {
		eval("document.access.jmsAccountId" + alertType).value = eval("document.access." + JMS_PREFIX + "AccountsList").value;
	} 
	var params = getFormElementsQueryString(document.access,alertType);
	if(params == "falseInput"){
		return;
	}else{
		if (alertType){
			params += "&suffix=" + alertType + "&alertType=" + alertType;
		}
	}
	
	var timeUnitElem = document.getElementById("timeUnit");
	if (timeUnitElem){
		timeUnitElem.style.display = "";
	}

	var url = "alerts/saveAlert.jsp?" + params;
	sendAjaxRequest(url,function(req){
		var result = req.responseText;
		if (result){	
			result = result.replace(/^\s+|\s+$/g, '');
		}
		var resultStrs = result.split("#");
		if (resultStrs.length > 1 && resultStrs[0] == "SAVE_ALERT_ERROR"){
			var msg = "<ul>";
   		for (var i=1; i<resultStrs.length; i++){
   			msg = msg + "<li>" + resultStrs[i] + "</li>";
   		}
   		msg = msg + "</ul>"

    	var msgWriter = new messageWriter("saveAlertMessage","Save Alert Error",BASE_DIRECTORY);
	    msgWriter.addAction("OK","javascript:hideLayer('saveAlertMessage')");  
	    msgWriter.showMessage(msg);
		}else{
			var url = BASE_DIRECTORY + ALERTS_XML_PAGE + getCurrentObjectsQuery();
	  	mygridAlerts.clearAll();
	  	mygridAlerts.loadXML(url);
	  	hideAllAlertDivs();
		}				
	});
}

function deleteTask(){
 	var id = getFirstSelectedRow(mygridAlerts);
  var gridName = "mygridAlerts";
 	if (id == "") {
		var msgWriter = new messageWriter("mygridMessage","No Alert Selected",BASE_DIRECTORY);
    msgWriter.setYParent(document.getElementById(gridName),50);
    msgWriter.addAction("OK","javascript:hideLayer('mygridMessage')");
    msgWriter.showMessage("<nobr>Please select an alert to remove</nobr>");
		return;
  }
  if(!ALLOW_EDIT_EXTERNAL_ALERTS) {
  	var external = mygridAlerts.getUserData(id,"external");
  	if(external && external == "true") {
  		var msgWriter = new messageWriter("mygridMessage","Operation Not Allowed",BASE_DIRECTORY);
		  msgWriter.setYParent(document.getElementById(gridName),50);
		  msgWriter.addAction("OK","javascript:hideLayer('mygridMessage')");
		  msgWriter.showMessage("<nobr>An external alert cannot be removed</nobr>");
			return;
  	}
  }
 	deleteGridRow(mygridAlerts,id,baseDirectory + "dashboard/admin/alerts/removeAlertAction.jsp?verifierId=" + id + "&timestamp=" + new Date().getTime());
 }

function toggleFrom(isSystem, suffix) {
	if(!suffix) {
		suffix = "";
	}
	var mailFrom = document.getElementById("mailFrom" + suffix);
	var fromCustom = document.getElementById("fromCustom" + suffix);
	if(mailFrom && fromCustom) {
		if(isSystem) {
			fromCustom.disabled = true;
			fromCustom.value = "";
		}else {
			fromCustom.disabled = false;
		}
	}
}