<%@ page language="java"%>

<%@ page import="xpolog.eye.automation.tasks.mail.MailTask"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModelHelper"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.hosts.HostsManager"%>
<%@ page import="xpolog.eye.util.hosts.measurements.HostMeasurement"%>
<%@ page import="xpolog.eye.util.hosts.measurements.HostMeasurementConfiguration"%>
<%@ page import="xpolog.eye.util.hosts.measurements.HostMeasurementLogLocationInfo"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request,response,null,true)){
  return;
}
UserContext userContext = UserEnvironment.getUserContext(request);

boolean isSecurity = userContext != null && userContext.getUser() != null;

String suffix = "CustomProblems";

boolean showMenu = true;
if(showMenu) {
	String menuIds = "changeSeverityLow,changeSeverityMedium,changeSeverityHigh,exclude,reset";
	String menuTexts = "Change severity to low,Change severity to medium,Change severity to high,Exclude from analysis,Reset severity";
	String menuHrefs = "javascript:doChangeSeverity('low');,javascript:doChangeSeverity('medium');,javascript:doChangeSeverity('high');,javascript:doExcludeFromAnalysis();,javascript:doResetSeverity();";
%>
  <jsp:include page="../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
	  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	  <jsp:param name="suffix" value="<%=suffix %>" />
	</jsp:include>
	<jsp:include page="../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	  <jsp:param name="suffix" value="<%=suffix %>" />
	</jsp:include>
<%
}
%>

<script>
function handleMenuItemsCustomProblems(){
	aMenuCustomProblems.menu.showButtons("changeSeverityLow,changeSeverityMedium,changeSeverityHigh,exclude,reset");
	var objectId = getFirstSelectedRow(mygridCustomProblems);
	if (objectId == "") {
		return;
	}
} 
</script>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>                
    <td valign="top"> 
    <%                 
    			                
    String tableNames = "Change Severity#Exclude From Analysis#Reset Severity";
    String tableActions = "javascript:openSeverityDiv()#javascript:doExcludeFromAnalysis()#javascript:doResetSeverity()";
    String ids = "ChangeSeverity#Exclude#Reset";
    String selectTypes = "2#2#2";
 		
		String menu = showMenu ? "aMenu" + suffix : "";
		
		String initXML = "dashboard/admin/dashboardAdministrationCustomProblemsManagementXML.jsp?";
		String updateXML = "dashboard/admin/dashboardAdministrationCustomProblemsManagementXML.jsp?dataOnly=true";
    %>                               
    <jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
			<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
			<jsp:param name="initXML" value="<%=initXML %>" />
			<jsp:param name="updateXML" value="<%=updateXML %>" />
			<jsp:param name="menu" value="<%=menu%>"/>
			<jsp:param name="newActionNames" value="" />
			<jsp:param name="newActions" value="" />
			<jsp:param name="tableActionNames" value="<%=tableNames%>" />
			<jsp:param name="tableActions" value="<%=tableActions%>" />
			<jsp:param name="tableActionIds" value="<%=ids%>" />
			<jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
			<jsp:param name="recordsText" value="Custom Problems" />
			<jsp:param name="style" value="main" />
			<jsp:param name="suffix" value="<%=suffix %>" />
		</jsp:include>
<script>
	function updateButtonActivateCustomProblems(rowid,id,columnType,gridType){
		if (!rowid || !mygridCustomProblems.doesRowExist(rowid) || (gridType == 3 && columnType != 3)){
	  	disableActionButton(id);
	    return;
	  }
		enableActionButton(id);
	}
</script>
		</td>
	</tr>
</table>

<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
  <jsp:param name="title" value="Change Problem Severity"/> 
  <jsp:param name="suffix" value="ChangeSeverity"/> 
  <jsp:param name="includePath" value="dashboard/admin/changeProblemSeverity.jsp"/>      
  <jsp:param name="width" value="400px"/> 
  <jsp:param name="height" value="100px"/>
  <jsp:param name="zIndex" value="300"/>  
  <jsp:param name="actionsNames" value="Save#Cancel"/> 
  <jsp:param name="actions" value="javascript:doChangeSeverity1()#javascript:closeSeverityDiv()"/> 
</jsp:include>