<%@ page language="java"%>

<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.computation.conf.monitoring.MultiComputationVerifierBuilder"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
	String DASHBOARD_GLOBAL_VERIFIER_BUILDER = "DASHBOARD_GLOBAL_VERIFIER_BUILDER";
	
	String baseDirectory = request.getParameter("baseDirectory");
	if(baseDirectory == null || baseDirectory.length() == 0) {
		baseDirectory = "";
	}
	
	ComputationConfiguration computationConfiguration = ComputationConfiguration.getInstance();
	MultiComputationVerifierBuilder builder = new MultiComputationVerifierBuilder();
	builder.setVerifier(computationConfiguration.getGlobalVerifier());
	builder.updateFromVerifier();
	session.setAttribute(DASHBOARD_GLOBAL_VERIFIER_BUILDER, builder);

String suffix = "Alerts";

boolean showMenu = true;
if(showMenu) {
	String menuIds = "enableTask,disableTask,editTask,deleteTask";
	String menuTexts = "Enable,Disable,Edit,Delete";
	String menuHrefs = "javascript:enableDisableTask();,javascript:enableDisableTask();,javascript:editTask();,javascript:deleteTask();";
%>
	<jsp:include page="../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	  <jsp:param name="suffix" value="<%=suffix %>" />
	</jsp:include>
	<jsp:include page="../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	  <jsp:param name="suffix" value="<%=suffix %>" />
	</jsp:include>
<%
}
%>

<link rel="stylesheet" type="text/css" href="<%=baseDirectory%>css/logAdministration.css" />
<style type="text/css">
a.MONITOR_BUTTON:link {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
a.MONITOR_BUTTON:visited {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
a.MONITOR_BUTTON:active {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
a.MONITOR_BUTTON:hover {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
</style>

<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/admin.js"></script>

<jsp:include page="../../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	<jsp:param name="suffix" value="<%=suffix%>" />
</jsp:include>

<script>
function handleMenuItemsAlerts(){
	var enabled = mygridAlerts.getUserData(contextRowIdAlerts,"enabled");
	if(enabled && enabled == "true") {
		aMenuAlerts.menu.showButtons("disableTask");
	}else {
		aMenuAlerts.menu.showButtons("enableTask,editTask,deleteTask");
	}
	aMenuAlerts.menu.showButtons("editTask,deleteTask");
} 
</script>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>
		<td id="alertsTD" valign="top">
		<%
		String menu = showMenu ? "aMenu" + suffix : "";
		
		String addName = "New Email";
    String addLink = "javascript:addMailAlert()";
    
		String tableNames = "Enable#Disable#Edit#Delete";
    String tableActions = "javascript:enableDisableTask()#javascript:enableDisableTask()#javascript:editTask()#javascript:deleteTask()";
    String ids = "Enable#Disable#Edit#Delete";
    String selectTypes = "2#2#2#2";
		%>
		<jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
			<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
			<jsp:param name="initXML" value="dashboard/admin/dashboardAdministrationGlobalAlertsXML.jsp" />
			<jsp:param name="updateXML" value="dashboard/admin/dashboardAdministrationGlobalAlertsXML.jsp?dataOnly=true" />
			<jsp:param name="menu" value="<%=menu%>"/>
			<jsp:param name="newActionNames" value="<%=addName%>" />
			<jsp:param name="newActions" value="<%=addLink%>" />
			<jsp:param name="tableActionNames" value="<%=tableNames%>" />
			<jsp:param name="tableActions" value="<%=tableActions%>" />
			<jsp:param name="tableActionIds" value="<%=ids%>" />
			<jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
			<jsp:param name="suffix" value="<%=suffix %>" />
			<jsp:param name="recordsText" value="Alerts" />
			<jsp:param name="style" value="main" />
			<jsp:param name="doubleClickAction" value="editTask" />
		</jsp:include>
		</td>
	</tr>
</table>
<script>
	function updateButtonActivateAlerts(rowid,id,columnType,gridType){
		if (!id || id == "") return;
		
		if(id == "Enable" || id == "Disable") { 
			var enabled = mygridAlerts.getUserData(rowid,"enabled");
			if(enabled && enabled == "true") {
				if(id == "Enable") {
					disableActionButton(id);
				}else {
					enableActionButton(id);
				}
			}else {
				if(id == "Enable") {
					enableActionButton(id);
				}else {
					disableActionButton(id);
				}
			}
		}else {
			enableActionButton(id);
		}
	}
</script>