<%@ page language="java"%>

<%@ page import="xpolog.eye.computation.conf.monitoring.MultiComputationVerifierBuilder"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.ui.grid.GridTable"%>
<%@ page import="xpolog.eye.site.ui.grid.models.dashboard.ComputationAlertsGridTableModel"%>
<%@ page import="xpolog.eye.site.*"%>

<%
	String DASHBOARD_GLOBAL_VERIFIER_BUILDER = "DASHBOARD_GLOBAL_VERIFIER_BUILDER";
	
	MultiComputationVerifierBuilder builder = (MultiComputationVerifierBuilder)session.getAttribute(DASHBOARD_GLOBAL_VERIFIER_BUILDER);
	
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, null, true)) {
		return;
	}

	UserContext userContext = UserEnvironment.getUserContext(request);
	
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = "../../";
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	ComputationAlertsGridTableModel model = new ComputationAlertsGridTableModel();
	model.setBuilder(builder);
	model.setBaseDirectory(baseDirectory);
	model.setUserContext(userContext);
	model.setGridName("mygrid" + suffix);
	model.init();
	GridTable table = new GridTable(model);
	request.setAttribute("gridTable" + suffix,table);
	
	request.getRequestDispatcher(baseDirectory + "widgets/grid/jsp/initTableXML.jsp").forward(request, response);	
%>
