<%@ page language="java"%>

<%@ page import="java.util.*"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.data.masks.MaskColumn"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%

String measurementType = request.getParameter("measurementType");

String lbmId = request.getParameter("lbmId");
if(lbmId != null && lbmId.length() == 0) {
	lbmId = null;
}
String filterId = request.getParameter("filterId");
if(filterId == null) {
	filterId = "";
}
String measurementValueColName = request.getParameter("measurementValueColName");
if(measurementValueColName == null) {
	measurementValueColName = "";
}
String measurementIdColumnName = request.getParameter("measurementIdColumnName");
if(measurementIdColumnName == null) {
	measurementIdColumnName = "";
}
String hostColumnName = request.getParameter("hostColumnName");
if(hostColumnName == null) {
	hostColumnName = "";
}


if(lbmId == null) {
	response.setContentType("text/xml");
	out.write("NO_LOG");
	out.flush();
}else {
	LogBrowsingManager lbm = null;
	if (lbmId.length() > 0){
		try{
			lbm = SiteManagment.getInstance().getLogBrowserManager(lbmId);
		}catch(Exception e){
		}
	}
	
	MaskColumn[] maskColumns = lbm.getRecordMask().getMaskColumns();
	
	FilterManager filterMgr = lbm != null ? lbm.getFilterManager(): null;
	List list = filterMgr != null ? filterMgr.getFilterCollections() : null;
	FilterCollection [] filters = list != null ? (FilterCollection [])list.toArray(new FilterCollection[list.size()]) : new FilterCollection[0];
	Arrays.sort(filters,FilterCollection.nameComparator);
	
%>

<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
	<tr>
		<td style="width:150px;padding-top:5px"><span class="MEDIUMTEXT">* Metrics value column:</span></td>
		<td style="padding-top:5px">
			<select id="measurementValueColName<%=measurementType %>" name="measurementValueColName<%=measurementType %>" class="MEDIUMTEXTBOX">
				<option value=""></option>
				<%
				for (int i = 0; i < maskColumns.length; i++){
				%>
				<option value="<%=maskColumns[i].getName() %>" <%=measurementValueColName.equals(maskColumns[i].getName()) ? "selected" : "" %>><%=maskColumns[i].getName() %></option>
				<%
				}
				%>
			</select>
		</td>
	</tr>
	<tr>
		<td style="padding-top:5px"><span class="MEDIUMTEXT">Filter:</span></td>
		<td style="padding-top:5px">
			<select id="externalFilterId<%=measurementType %>" name="externalFilterId<%=measurementType %>" class="MEDIUMTEXTBOX">
				<option value=""></option>
				<%
				for (int i = 0; i < filters.length; i++){
				%>
				<option value="<%=filters[i].getId() %>" <%=filterId.equals(filters[i].getId()) ? "selected" : "" %>><%=filters[i].getName() %></option>
				<%
				}
				%>
			</select>
		</td>
	</tr>
	<tr>
		<td style="padding-top:5px"><span class="MEDIUMTEXT">Identifier column:</span></td>
		<td style="padding-top:5px">
			<select id="measurementIdColumnName<%=measurementType %>" name="measurementIdColumnName<%=measurementType %>" class="MEDIUMTEXTBOX">
				<option value=""></option>
				<%
				for (int i = 0; i < maskColumns.length; i++){
				%>
				<option value="<%=maskColumns[i].getName() %>" <%=measurementIdColumnName.equals(maskColumns[i].getName()) ? "selected" : "" %>><%=maskColumns[i].getName() %></option>
				<%
				}
				%>
			</select>
		</td>
	</tr>
	<tr>
		<td style="padding-top:5px"><span class="MEDIUMTEXT">Host column:</span></td>
		<td style="padding-top:5px">
			<select id="hostColumnName<%=measurementType %>" name="hostColumnName<%=measurementType %>" class="MEDIUMTEXTBOX">
				<option value=""></option>
				<%
				for (int i = 0; i < maskColumns.length; i++){
				%>
				<option value="<%=maskColumns[i].getName() %>" <%=hostColumnName.equals(maskColumns[i].getName()) ? "selected" : "" %>><%=maskColumns[i].getName() %></option>
				<%
				}
				%>
			</select>
		</td>
	</tr>
	<tr>
		<td colspan="2" style="padding-top:15px;padding-bottom:5px"><span class="MEDIUMTEXT">* marks a mandatory field</span></td>
	</tr>
</table>
<%
}
%>