<%@ page language="java"%>

<%@ page import="java.util.HashSet"%>
<%@ page import="java.util.List"%>
<%@ page import="java.util.Set"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.admin.helpers.DashboardAdminHelper"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.managment.XpologManagment"%>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.util.Constants"%>
<%@ page import="xpolog.eye.util.hosts.HostInfo"%>
<%@ page import="xpolog.eye.util.hosts.HostsManager"%>
<%@ page import="xpolog.eye.util.hosts.UpdateHostInfoRequest"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
	String HEALTH_VIEW_MODEL = "HealthViewModel";

	UserContext userContext = UserEnvironment.getUserContext(request);

	String objectType = request.getParameter("objectType");
	String objectId = request.getParameter("objectId");
	String doEnableStr = request.getParameter("doEnable");
	boolean doEnable = doEnableStr != null && doEnableStr.equals("true");
	String enableLogsStr = request.getParameter("enableLogs");
	boolean enableLogs = enableLogsStr != null && enableLogsStr.equals("true");
	String enableMetricsStr = request.getParameter("enableMetrics");
	boolean enableMetrics = enableMetricsStr != null && enableMetricsStr.equals("true");
	
	boolean success = true;
	String message = "";
	if (objectType != null && objectId != null) {
		String parentType = null;
		String parentId = null;
		int index = objectId.indexOf("^");
		if(index != -1) {
			String parentTypeId = objectId.substring(0, index);
			objectId = objectId.substring(index + 1);
			index = parentTypeId.indexOf("-");
			if(index != -1) {
				parentType = parentTypeId.substring(0, index);
				parentId = parentTypeId.substring(index + 1);
			}
		}
		String analytics = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_DISPLAY_NAME);
		AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
				userContext, AuditConstants.CHANGE, "enable/disable " + analytics + " object", AuditConstants.DASHBOARD, (doEnable ? "enable" : "disable") + analytics + " of " + objectType + " " + objectId);
		
		if(enableLogs || !objectType.equals(XpoLogObjectTypes.HOST_TYPE)) {
			DashboardAdminHelper.updateUseInDashboard(parentType, parentId, objectType, objectId, doEnable, userContext);
		}
		if(enableMetrics) {
			HostInfo hostInfo = HostsManager.getInstance().getHostInfo(objectId);
			if(hostInfo != null) {
				AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
						userContext, AuditConstants.CHANGE, "enable/disable " + analytics + " metrics", AuditConstants.DASHBOARD, (doEnable ? "enable" : "disable") + " metrics of host " + hostInfo.getHost());
				
				UpdateHostInfoRequest updateHostInfoRequest = new UpdateHostInfoRequest();
				updateHostInfoRequest.setHost(hostInfo.getHost());
				updateHostInfoRequest.setName(hostInfo.getName());
				List serverLogs = hostInfo.getLogIds();
				if(serverLogs != null) {
					Set logsSet = new HashSet();
					for(int i = 0; i < serverLogs.size(); i++) {
						logsSet.add(serverLogs.get(i));
					}
					updateHostInfoRequest.setLogIds(logsSet);
				}
				//updateHostInfoRequest.setCollectMeasurementData(hostInfo.isCollectMeasurementData());
				updateHostInfoRequest.setUseInDashboard(doEnable);
				updateHostInfoRequest.setUseInDashboardSet(true);
				updateHostInfoRequest.setUserContext(userContext);
				
				HostsManager.getInstance().updateHostInfo(updateHostInfoRequest);
			}
		}
		success = true;
		
		session.removeAttribute(HEALTH_VIEW_MODEL);
	}else {
		message = "No object was given, please refresh and try again";
	}
	String xml = GridModelActionsHelper.getResultXML(success, message);

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	
	out.write(xml);
	out.flush();
%>
