<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.security.DashboardPermissionConstants"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.util.Constants"%>

<%!
static final String BASE_DIRECTORY = "../../";

static final String HEADER_DIV_ID = "dashboardHeaderDiv";
static final String GRAPH_DIV_ID = "dashboardGraphDiv";
static final String MAIN_TABLE_DIV_ID = "dashboardMainTableDiv";
static final String TOP_MESSAGES_DIV_ID = "dashboardTopMessagesDiv";
static final String STATUS_OK = "0";
static final String STATUS_NO_ACTION = "1";
%>

<%
UserContext userContext = UserEnvironment.getUserContext(request);
WebSecurityManager manager = WebSecurityManager.getInstance();
String key = request.getParameter("key");
if (!SiteManagment.getInstance().checkKey(key)){
	if (!manager.checkForPermission(request,response,DashboardPermissionConstants.DashboardPermissions.SYSTEM_HEALTH_VIEW_DATA_PERMISSION,true)){
	  return;
	}
}

//boolean allowGenerate = manager.isHavePermission(userContext,DashboardPermissionConstants.DashboardPermissions.SYSTEM_HEALTH_GENERATE_DATA_PERMISSION);

String resetModelStr = request.getParameter("resetModel");
boolean resetModel = resetModelStr != null && resetModelStr.equals("true");
String preserveRunnersStr = request.getParameter("preserveRunners");
boolean preserveRunners = preserveRunnersStr != null && preserveRunnersStr.equals("true");

//audit
AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	userContext, AuditConstants.VIEW, "view system health", AuditConstants.REPORTS, "view system health");

boolean printExtraDataOnError = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("ui.js.printExtraDataOnError", false);

%>

<html>

<head>

	<META HTTP-EQUIV="Content-Language" CONTENT="en-us">
	<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
	<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
	<META HTTP-EQUIV="EXPIRES" CONTENT="0">
	
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
	
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxCalendar/codebase/dhtmlxcalendar.css" />
	
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/dashboard.css" />
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/dhtmlxCalendar.css" />
	
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/UIUtil.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/common/messages.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/comps/jsdomenu.js"></script>
	
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/jquery/jquery.js"></script>
	
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxCalendar/codebase/dhtmlxcommon.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxCalendar/codebase/dhtmlxcalendar.js"></script>
	
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/common/dashboardCalendarFunctions.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/view/dashboard.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/view/dashboardExt.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/view/dashboardHeader.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/view/dashboardCalendar.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/view/dashboardGraph.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/view/dashboardMainTable.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/view/dashboardTopMessages.js"></script>
	<script type="text/javascript" src="<%=BASE_DIRECTORY%>dashboard/view/dashboardTooltips.js"></script>

	<script type="text/javascript" src="<%=BASE_DIRECTORY%>widgets/popup/js/popup.js"></script>
</head>

<script>

var BASE_DIRECTORY = "../../";

var HEADER_DIV_ID = "<%=HEADER_DIV_ID %>";
var GRAPH_DIV_ID = "<%=GRAPH_DIV_ID %>";
var MAIN_TABLE_DIV_ID = "<%=MAIN_TABLE_DIV_ID %>";
var TOP_MESSAGES_DIV_ID = "<%=TOP_MESSAGES_DIV_ID %>";

var STATUS_OK = "<%=STATUS_OK %>";
var STATUS_NO_ACTION = "<%=STATUS_NO_ACTION %>";

var RESULTS_PER_PAGE = 10;

var VIEW_BY;

var printExtraDataOnError = <%=printExtraDataOnError %>;

document.onclick = hideDashboardDivsIfClickedOutside;

function hideDashboardDivsIfClickedOutside(e) {
	var ignoreIds = new Array();
	ignoreIds[0] = "fixedIntervalMenuTextLink";
	ignoreIds[1] = "fixedIntervalMenuLink";
	hideElementIfClickedOutside(e, "dashboardFixedIntervalDiv", ignoreIds);
	ignoreIds = new Array();
	ignoreIds[0] = "sc&Cal";
	ignoreIds[1] = "month_btn_left";
	ignoreIds[2] = "month_btn_right";
	ignoreIds[3] = "planeMonth";
	ignoreIds[4] = "planeYear";
	ignoreIds[5] = "dhtmlxRichSelector";
	ignoreIds[6] = "calendarTextLink";
	ignoreIds[7] = "calendarLink";
	hideElementIfClickedOutside(e, "dashboardCalendarDiv", ignoreIds);
	hideElementIfClickedOutside(e, "dashboardFilterByTypeDiv");
	hideElementIfClickedOutside(e, "dashboardZoomInDiv");
	hideElementIfClickedOutside(e, "dashboardZoomInSmallImageDiv");
	ignoreIds = new Array();
	ignoreIds[0] = "problemActionsMenuLinkMainTable";
	ignoreIds[1] = "problemActionsMenuLinkTopMessages";
	hideElementIfClickedOutside(e, "dashboardProblemActionsDiv", ignoreIds);
}

</script>

<jsp:include page="../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<body onLoad="javascript:doOnLoad(<%=resetModel %>, <%=preserveRunners %>)" onUnload="javascript:doOnUnload();">
<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/tooltip/wz_tooltip.js"></script>
<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/tooltip/tip_balloon.js"></script>
<div id="dashboardCalendarDiv" class="XPOLOG_DHTMLX_CALENDAR_DIV">
	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
		<tr>
			<td id="dashboardCalendarTd"></td>
		</tr>
		<tr>
			<td>
				<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
					<tr height="10px">
						<td class="XPOLOG_DHTMLX_CALENDAR_DATE_CELL_TEXT XPOLOG_DHTMLX_CALENDAR_START_DATE_CELL">Start Date:</td>
						<td class="XPOLOG_DHTMLX_CALENDAR_DATE_LABEL" id="dashboardCalendarStartDateTd"></td>
						<td class="XPOLOG_DHTMLX_CALENDAR_DATE_CELL_TEXT XPOLOG_DHTMLX_CALENDAR_END_DATE_CELL">End Date:</td>
						<td class="XPOLOG_DHTMLX_CALENDAR_DATE_LABEL" id="dashboardCalendarEndDateTd"></td>
					</tr>
					<tr height="10px">
						<td class="XPOLOG_DHTMLX_CALENDAR_TIME_CELL_TEXT XPOLOG_DHTMLX_CALENDAR_START_TIME_CELL">Start Time:</td>
						<td class="XPOLOG_DHTMLX_CALENDAR_TIME_INPUT_CELL"><input type="text" id="calendarStartTime" name="calendarStartTime" maxlength="8" class="XPOLOG_DHTMLX_CALENDAR_TIME_INPUT" onChange="javascript:validateTimeFormat('calendarStartTime', 'Start Time')"></td>
						<td class="XPOLOG_DHTMLX_CALENDAR_TIME_CELL_TEXT XPOLOG_DHTMLX_CALENDAR_END_TIME_CELL">End Time:</td>
						<td class="XPOLOG_DHTMLX_CALENDAR_TIME_INPUT_CELL"><input type="text" id="calendarEndTime" name="calendarEndTime" maxlength="8" class="XPOLOG_DHTMLX_CALENDAR_TIME_INPUT" onChange="javascript:validateTimeFormat('calendarEndTime', 'End Time')"></td>
					</tr>
					<tr height="10px">
						<td id="dashboardCalendarErrorTd" class="XPOLOG_DHTMLX_CALENDAR_ERROR_CELL" colspan="4">&nbsp;</td>
					</tr>
				</table>
			</td>
		</tr>
		<tr>
			<td class="XPOLOG_DHTMLX_CALENDAR_BUTTONS_CELL">
				<a href="javascript:goDashboardCalendar()"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/calendarGo.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/calendarGoOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/calendarGo.gif')"></a>
				<a href="javascript:closeDashboardCalendar()"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/calendarClose.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/calendarCloseOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/calendarClose.gif')"></a>
			</td>
		</tr>
	</table>
</div>
<jsp:include page="dashboardFilterBy.jsp" flush="true" />
<div id="dashboardGraphTooltipDiv" class="DASHBOARD_GRAPH_TOOLTIP_DIV" onMouseOver="javascript:onMouseOverDashboardGraphTooltip();" onMouseOut="javascript:onMouseOutDashboardGraphTooltip();">
</div>
<div id="dashboardGraphTooltipStumDiv" class="DASHBOARD_GRAPH_TOOLTIP_STUM_DIV" onMouseOver="javascript:onMouseOverDashboardGraphTooltip();" onMouseOut="javascript:onMouseOutDashboardGraphTooltip();">
	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
		<tr>
			<td align="center"><img id="dashboardGraphTooltipStumImage" src="" border="0"></td>
		</tr>
	</table>
</div>
<div id="dashboardZoomInTopDiv" class="DASHBOARD_GRAPH_ZOOM_IN_TOP_DIV">
	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
		<tr>
			<td class="empty"></td>
		</tr>
	</table>
</div>
<div id="dashboardZoomInDiv" class="DASHBOARD_GRAPH_ZOOM_IN_DIV">
	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
		<tr>
			<td align="center"><img id="dashboardGraphZoomInDivImage" src="<%=BASE_DIRECTORY %>images/dashboard/graph/zoomInDiv.gif" border="0"></td>
		</tr>
	</table>
</div>
<div id="dashboardServerMetricsColumnTooltipDiv" class="DASHBOARD_SERVER_METRICS_COLUMN_TOOLTIP_DIV" onMouseOver="javascript:onMouseOverDashboardServerMetricsColumnTooltip();" onMouseOut="javascript:onMouseOutDashboardServerMetricsColumnTooltip();">
</div>
<div id="dashboardServerMetricsColumnTooltipStumDiv" class="DASHBOARD_SERVER_METRICS_COLUMN_TOOLTIP_STUM_DIV" onMouseOver="javascript:onMouseOverDashboardServerMetricsColumnTooltip();" onMouseOut="javascript:onMouseOutDashboardServerMetricsColumnTooltip();">
	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
		<tr>
			<td align="center"><img id="dashboardServerMetricsColumnTooltipStumImage" src="" border="0"></td>
		</tr>
	</table>
</div>
<div id="dashboardSearchDiv" class="DASHBOARD_SEARCH_DIV">
	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
		<tr>
			<td class="DASHBOARD_SEARCH_DIV_CELL">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
					<tr>
					<td>
						<input type="text" id="searchTerm" name="searchTerm" class="DASHBOARD_SEARCH_TEXT_BOX" onKeyPress="return doCheckSearch(event)">
					</td>
					<td class="DASHBOARD_SEARCH_DIV_BUTTONS_CELL">
						<a href="javascript:goDashboardSearch()"><img src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/searchGo.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/searchGoOver.gif')" onMouseOut="javascript:setImageSource(this, 'mainTable/searchGo.gif')"></a>
						<a href="javascript:closeDashboardSearchDiv()"><img src="<%=BASE_DIRECTORY %>images/dashboard/mainTable/searchClose.gif" border="0" onMouseOver="javascript:setImageSource(this, 'mainTable/searchCloseOver.gif')" onMouseOut="javascript:setImageSource(this, 'mainTable/searchClose.gif')"></a>
					</td>
					</tr>
				</table>
			</td>
		</tr>
	</table>
</div>
<div id="dashboardMetricsGraphLegendDiv" class="DASHBOARD_METRICS_GRAPH_LEGEND_DIV">
	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
		<tr>
			<td><span class="DASHBOARD_METRICS_GRAPH_LEGEND_CPU_TEXT">CPU</span>&nbsp;<span class="DASHBOARD_METRICS_GRAPH_LEGEND_TEXT_SEPERATOR">|</span>&nbsp;<span class="DASHBOARD_METRICS_GRAPH_LEGEND_MEMORY_TEXT">Memory</span></td>
		</tr>
	</table>
</div>
<div id="dashboardProblemActionsDiv" class="DASHBOARD_PROBLEM_ACTIONS_MENU_CONTAINER">
	<div id="dashboardProblemActionsShadowDiv" class="DASHBOARD_PROBLEM_ACTIONS_MENU_SHADOW">
		<div id="dashboardProblemActionsMenuDiv" class="DASHBOARD_PROBLEM_ACTIONS_MENU_CONTENT">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr id="problemActionChangeSeverityLow" class="DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM" onClick="javascript:doProblemActions('low')" onMouseOver="javascript:setProblemActionsMenuItemClass('problemActionChangeSeverityLow', 'DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM_OVER')" onMouseOut="javascript:setProblemActionsMenuItemClass('problemActionChangeSeverityLow', 'DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM')">
					<td class="DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM_CELL">&nbsp;</td>
					<td class="DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM_CELL">Change severity to low</td>
				</tr>
				<tr id="problemActionChangeSeverityMedium" class="DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM" onClick="javascript:doProblemActions('medium')" onMouseOver="javascript:setProblemActionsMenuItemClass('problemActionChangeSeverityMedium', 'DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM_OVER')" onMouseOut="javascript:setProblemActionsMenuItemClass('problemActionChangeSeverityMedium', 'DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM')">
					<td class="DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM_CELL">&nbsp;</td>
					<td class="DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM_CELL">Change severity to medium</td>
				</tr>
				<tr id="problemActionChangeSeverityHigh" class="DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM" onClick="javascript:doProblemActions('high')" onMouseOver="javascript:setProblemActionsMenuItemClass('problemActionChangeSeverityHigh', 'DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM_OVER')" onMouseOut="javascript:setProblemActionsMenuItemClass('problemActionChangeSeverityHigh', 'DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM')">
					<td class="DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM_CELL">&nbsp;</td>
					<td class="DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM_CELL">Change severity to high</td>
				</tr>
				<tr>
					<td colspan="2"><hr></td>
				</tr>
				<tr id="problemActionExclude" class="DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM" onClick="javascript:doProblemActions('exclude')" onMouseOver="javascript:setProblemActionsMenuItemClass('problemActionExclude', 'DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM_OVER')" onMouseOut="javascript:setProblemActionsMenuItemClass('problemActionExclude', 'DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM')">
					<td class="DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM_CELL">&nbsp;</td>
					<td class="DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM_CELL">Exclude from analysis</td>
				<!--</tr>
					<td colspan="2"><hr></td>
				</tr>
				<tr id="problemActionAdvanced" class="DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM" onClick="javascript:doProblemActions('advanced')" onMouseOver="javascript:setProblemActionsMenuItemClass('problemActionAdvanced', 'DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM_OVER')" onMouseOut="javascript:setProblemActionsMenuItemClass('problemActionAdvanced', 'DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM')">
					<td class="DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM_CELL">&nbsp;</td>
					<td class="DASHBOARD_PROBLEM_ACTIONS_MENU_ITEM_CELL">Advanced options</td>
				</tr>-->
			</table>
		</div>
	</div>
</div>
<form AUTOCOMPLETE="OFF" id="showLogForm" name="showLogForm" method="POST" action="<%=BASE_DIRECTORY %>common/showLog.jsp" class="DASHBOARD_FORM">
	<input type="hidden" name="lbmId">
	<input type="hidden" name="filterId">
	<input type="hidden" name="isKnowledge">
	<input type="hidden" name="DateMinimum">
	<input type="hidden" name="DateMaximum">
	<input type="hidden" name="Dates" value="TimeLimRadio">
	<input type="hidden" name="quickDateFilter" value="true">
	<input type="hidden" name="expandLogViewer" value="true">
	<input type="hidden" name="hideDashboardButton" value="true">
	<input type="hidden" name="modelSessionAttributeName" value="HealthViewModel">
</form>

<div id="<%=HEADER_DIV_ID %>" style="height:160px;">
</div>

<div id="<%=GRAPH_DIV_ID %>" style="height:300px;">
</div>

<div id="<%=MAIN_TABLE_DIV_ID %>">
</div>

<div id="<%=TOP_MESSAGES_DIV_ID %>">
</div>

<%
String missingDataTitle = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME) + " Data Missing"; 
%>
<form AUTOCOMPLETE="OFF" id="missingExecutionsForm" name="missingExecutionsForm" method="POST" class="DASHBOARD_FORM">
	<input type="hidden" id="missingExecutionsLogIds" name="missingExecutionsLogIds" value="">
	<input type="hidden" id="missingExecutionsHostIds" name="missingExecutionsHostIds" value="">
	<input type="hidden" id="errorLogIds" name="errorLogIds" value="">
	<input type="hidden" id="errorHostIds" name="errorHostIds" value="">
	<input type="hidden" id="rootNodeId" name="rootNodeId" value="">
	<input type="hidden" id="rootNodeType" name="rootNodeType" value="">
	<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
		<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
		<jsp:param name="suffix" value="MissingExecutions"/> 
		<jsp:param name="includePath" value="dashboard/view/dashboardMissingExecutions.jsp"/>
		<jsp:param name="width" value="550px"/> 
		<jsp:param name="height" value="200px"/>
		<jsp:param name="title" value="<%=missingDataTitle %>"/> 
		<jsp:param name="actionsNames" value="Continue#Cancel"/> 
		<jsp:param name="actions" value="javascript:continueMissingExecutions()#javascript:showHideGeneralAdminDiv('MissingExecutions')"/> 
	</jsp:include>
</form>

</body>
</html>