<%@ page language="java"%>

<%@ page import="java.util.Date"%>

<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.util.DateUtil"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
String HEALTH_VIEW_MODEL = "HealthViewModel";

HealthViewModel model = (HealthViewModel)session.getAttribute(HEALTH_VIEW_MODEL);

String fixedInterval = model.getFixedInterval();

DateFilter dateFilter = model.getTimeFilter();
Date minDate = dateFilter.getMinDate();
Date maxDate = dateFilter.getMaxDate();

String minDateString = DateUtil.transformDateToString(minDate);
int minIndex = minDateString.indexOf(" ");
String minDateShortString = minDateString.substring(0, minIndex);
String minTimeString = minDateString.substring(minIndex + 1);
if(minTimeString.indexOf(":") != minTimeString.lastIndexOf(":")) {
	minTimeString = minTimeString.substring(0, minTimeString.lastIndexOf(":"));
}

String maxDateString = DateUtil.transformDateToString(maxDate);
int maxIndex = maxDateString.indexOf(" ");
String maxDateShortString = maxDateString.substring(0, maxIndex);
String maxTimeString = maxDateString.substring(maxIndex + 1);
if(maxTimeString.indexOf(":") != maxTimeString.lastIndexOf(":")) {
	maxTimeString = maxTimeString.substring(0, maxTimeString.lastIndexOf(":"));
}

String[] fixedIntervals = model.getFixedIntervals();
String[] fixedIntervalsNames = model.getFixedIntervalsNames();

%>

<input type="hidden" id="dashboardMinDate" name="dashboardMinDate" value="<%=minDate.getTime() %>">
<input type="hidden" id="dashboardMinDateStr" name="dashboardMinDateStr" value="<%=minDateShortString %>">
<input type="hidden" id="dashboardMinDateFullStr" name="dashboardMinDateFullStr" value="<%=minDateString %>">
<input type="hidden" id="dashboardMinTimeStr" name="dashboardMinTimeStr" value="<%=minTimeString %>">
<input type="hidden" id="dashboardMaxDate" name="dashboardMaxDate" value="<%=maxDate.getTime() %>">
<input type="hidden" id="dashboardMaxDateStr" name="dashboardMaxDateStr" value="<%=maxDateShortString %>">
<input type="hidden" id="dashboardMaxDateFullStr" name="dashboardMaxDateFullStr" value="<%=maxDateString %>">
<input type="hidden" id="dashboardMaxTimeStr" name="dashboardMaxTimeStr" value="<%=maxTimeString %>">

<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
	<tr class="DASHBOARD_HEADER_CALENDAR_ROW">
		<td class="empty">&nbsp;</td>
		<td class="DASHBOARD_HEADER_PLUS_MINUS_CELL">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr>
					<%
					if(model.allowZoomOutCalendar()) {
					%>
					<td><a href="javascript:zoomOutCalendar();"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/calendarMinus.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/calendarMinusOver.gif');showTooltip(dashboardTooltips['zoomOutCalendar'])" onMouseOut="javascript:setImageSource(this, 'header/calendarMinus.gif');hideTooltip()"></a></td>
					<%
					}else {
					%>
					<td><img src="<%=BASE_DIRECTORY %>images/dashboard/header/calendarMinusDisabled.gif" border="0"></td>
					<%
					}
					if(model.allowZoomInCalendar()) {
					%>
					<td><a href="javascript:zoomInCalendar();"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/calendarPlus.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/calendarPlusOver.gif');showTooltip(dashboardTooltips['zoomInCalendar'])" onMouseOut="javascript:setImageSource(this, 'header/calendarPlus.gif');hideTooltip()"></a></td>
					<%
					}else {
					%>
					<td><img src="<%=BASE_DIRECTORY %>images/dashboard/header/calendarPlusDisabled.gif" border="0"></td>
					<%
					}
					%>
				</tr>
			</table>
		</td>
		<td class="DASHBOARD_HEADER_FIXED_INTERVAL_CELL">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr><td></td></tr>
				<tr>
					<td class="DASHBOARD_HEADER_FIXED_INTERVAL_LABEL_TEXT">
						<a id="fixedIntervalMenuTextLink" href="javascript:openFixedIntervalMenu()" class="DASHBOARD_HEADER_FIXED_INTERVAL_LABEL_TEXT_LINK"><%=model.getFixedIntervalName() %></a>
						<span class="DASHBOARD_HEADER_FIXED_INTERVAL_ARROW"><a id="fixedIntervalMenuLink" href="javascript:openFixedIntervalMenu()"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/fixedIntervalsOpen.gif" border="0" onMouseOver="javascript:showTooltip(dashboardTooltips['openFixedIntervalsList'])" onMouseOut="javascript:hideTooltip()"></a></span>
					</td>
				</tr>
				<tr><td></td></tr>
			</table>
			<div id="dashboardFixedIntervalDiv" class="DASHBOARD_HEADER_FIXED_INTERVAL_MENU_CONTAINER">
				<div id="dashboardFixedIntervalShadowDiv" class="DASHBOARD_HEADER_FIXED_INTERVAL_MENU_SHADOW">
					<div id="dashboardFixedIntervalMenuDiv" class="DASHBOARD_HEADER_FIXED_INTERVAL_MENU_CONTENT">
						<input type="hidden" id="fixedInterval" name="fixedInterval" value="<%=fixedInterval %>">
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<%
							String currentInterval = null;
							for(int i = 1; i < fixedIntervals.length - 1; i++) {
								if(i == 4 || i == 6 || i == 9) {
							%>
								<tr>
									<td colspan="2"><hr></td>
								</tr>
							<%
								}
								currentInterval = fixedIntervals[i];
							%>
								<tr id="<%=currentInterval %>" class="DASHBOARD_HEADER_FIXED_INTERVAL_MENU_ITEM" onClick="javascript:setFixedInterval('<%=currentInterval %>', 'false', 'false')" onMouseOver="javascript:setFixedIntervalMenuItemClass('<%=currentInterval %>', 'DASHBOARD_HEADER_FIXED_INTERVAL_MENU_ITEM_OVER')" onMouseOut="javascript:setFixedIntervalMenuItemClass('<%=currentInterval %>', 'DASHBOARD_HEADER_FIXED_INTERVAL_MENU_ITEM')">
									
							<%
								if(fixedInterval.equals(currentInterval)) {
							%>
									<td class="DASHBOARD_HEADER_FIXED_INTERVAL_MENU_ITEM_CELL DASHBOARD_HEADER_SELECTED_FIXED_INTERVAL_MENU_ITEM"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/fixedIntervalsSelected.gif" border="0"></td>
							<%
								}else {
							%>
									<td class="DASHBOARD_HEADER_FIXED_INTERVAL_MENU_ITEM_CELL">&nbsp;</td>
							<%
								}
							%>
									<td class="DASHBOARD_HEADER_FIXED_INTERVAL_MENU_ITEM_CELL"><%=fixedIntervalsNames[i] %></td>
								</tr>
							<%
							}
							%>
						</table>
					</div>
				</div>
			</div>
		</td>
		<td class="DASHBOARD_HEADER_CALENDAR_LABEL_CELL">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr><td></td></tr>
				<tr>
					<td class="DASHBOARD_HEADER_CALENDAR_LABEL_TEXT">
						<a id="calendarTextLink" href="javascript:openDashboardCalendar(-380, 20);" class="DASHBOARD_HEADER_CALENDAR_LABEL_TEXT_LINK"><%=(minDateShortString + " " + minTimeString) %> - <%=(maxDateShortString + " " + maxTimeString) %></a>
					</td>
				</tr>
				<tr><td></td></tr>
			</table>
		</td>
		<td class="DASHBOARD_HEADER_OPEN_CALENDAR_CELL">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr>
					<td><a href="javascript:openDashboardCalendar(-380, 20);" id="calendarLink"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/calendarOpen.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/calendarOpenOver.gif');showTooltip(dashboardTooltips['openCalendar'])" onMouseOut="javascript:setImageSource(this, 'header/calendarOpen.gif');hideTooltip()"></a></td>
				</tr>
			</table>
		</td>
	</tr>
</table>