<%@ page language="java"%>

<%@ page import="xpolog.eye.reports.health.ui.DashboardExecutionManager"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
String HEALTH_VIEW_MODEL = "HealthViewModel";

HealthViewModel model = (HealthViewModel)session.getAttribute(HEALTH_VIEW_MODEL);
String runnerIds = model.getRunnerIdsString();
String[] runnerIdsArr = XpologUtil.split(runnerIds, "|");
DashboardExecutionManager executionManager = DashboardExecutionManager.getInstance();
boolean isRunning = false;
for(int i = 0; i < runnerIdsArr.length; i++) {
	if(runnerIdsArr[i].length() > 0) {
		if(executionManager.isRunning(runnerIdsArr[i])) {
			isRunning = true;
		}else {
			model.removeRunnerId(runnerIdsArr[i]);
		}
		//System.out.println("runner " + runnerIdsArr[i] + " isRunning=" + isRunning);
	}
}
model.setMissingDataReady(!isRunning);

boolean needToRefresh = false;
if(!isRunning) {
	long lastUserActionTimestamp = model.getLastUserActionTimestamp();
	long lastDataGenerationActionTimestamp = model.getLastDataGenerationActionTimestamp();
	needToRefresh = lastUserActionTimestamp != -1 && lastDataGenerationActionTimestamp > lastUserActionTimestamp;
}

response.setContentType("text/xml");
%>
<DashboardExecutionStatusResponse>
	<Response isRunning="<%=isRunning %>" needToRefresh="<%=needToRefresh %>">
	</Response>
</DashboardExecutionStatusResponse>