<%@ page language="java"%>

<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContextFilter"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModelHelper"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
String HEALTH_VIEW_MODEL = "HealthViewModel";

HealthViewModel model = (HealthViewModel)session.getAttribute(HEALTH_VIEW_MODEL);
HealthViewContextFilter contextFilter = null;
String filterByType = null;
String filterByFoldersAndLogsType = HealthViewContext.VIEW_BY_FOLDERS;
String filterByFoldersAndLogs = HealthViewModelHelper.getCurrentRootNodeName(filterByFoldersAndLogsType);
String filterByApplicationsType = HealthViewContext.VIEW_BY_APPLICATIONS;
String filterByApplications = HealthViewModelHelper.getCurrentRootNodeName(filterByApplicationsType);
String filterByServersType = HealthViewContext.VIEW_BY_SERVERS;
String filterByServers = HealthViewModelHelper.getCurrentRootNodeName(filterByServersType);

boolean isFoldersAndLogsFilterActive = false;
boolean isApplicationsFilterActive = false;
boolean isServersFilterActive = false;
if(model != null) {
	contextFilter = model.getContextFilter();
	if(contextFilter.isFilterActive()) {
		if(contextFilter.isApplicationsFilterActive()) {
			isApplicationsFilterActive = true;
			filterByType = filterByApplicationsType;
		}else if(contextFilter.isServersFilterActive()) {
			isServersFilterActive = true;
			filterByType = filterByServersType;
		}else if(contextFilter.isFoldersAndLogsFilterActive()) {
			isFoldersAndLogsFilterActive = true;
			filterByType = filterByFoldersAndLogsType;
		}
	}else {
		isFoldersAndLogsFilterActive = true;
		filterByType = filterByFoldersAndLogsType;
	}
}else {
	isFoldersAndLogsFilterActive = true;
	filterByType = filterByFoldersAndLogsType;
}

%>

<script>
var filterByFoldersAndLogsType = "<%=filterByFoldersAndLogsType %>";
var filterByFoldersAndLogs = "<%=filterByFoldersAndLogs %>";
var filterByApplicationsType = "<%=filterByApplicationsType %>";
var filterByApplications = "<%=filterByApplications %>";
var filterByServersType = "<%=filterByServersType %>";
var filterByServers = "<%=filterByServers %>";
</script>

<div id="dashboardFilterByDiv" class="DASHBOARD_FILTER_BY_CONTAINER">
	<div id="dashboardFilterByShadowDiv" class="DASHBOARD_FILTER_BY_SHADOW">
		<div id="dashboardFilterByContentDiv" class="DASHBOARD_FILTER_BY_CONTENT">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr height="10px">
					<td class="DASHBOARD_FILTER_BY_HEADER_CELL">
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td class="DASHBOARD_FILTER_BY_HEADER">Filter by</td>
								<td class="DASHBOARD_FILTER_BY_TYPE_CELL">
									<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
										<tr>
											<td class="DASHBOARD_FILTER_BY_TYPE_LABEL_TEXT">
												<a id="filterByTypeText" href="javascript:openFilterByTypeMenu()" class="DASHBOARD_FILTER_BY_TYPE_LABEL_TEXT_LINK"><%=HealthViewModelHelper.getCurrentRootNodeName(filterByType) %></a>
												<span class="DASHBOARD_FILTER_BY_TYPE_ARROW"><a id="filterByTypeMenuLink" href="javascript:openFilterByTypeMenu()"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/filterByTypesOpen.gif" border="0" onMouseOver="javascript:showTooltip(dashboardTooltips['openFilterByTypesList'])" onMouseOut="javascript:hideTooltip()"></a></span>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr height="1px">
					<td class="DASHBOARD_FILTER_BY_SEPARATOR_CELL"><hr class="DASHBOARD_FILTER_BY_SEPARATOR"></td>
				</tr>
				<tr>
					<td class="DASHBOARD_FILTER_BY_CONTENT_CELL">
						<div id="filterByContentDivLoading">
							<span class="REGULARTEXT">Loading...</span>
						</div>
						<div id="filterByContentDiv" class="DASHBOARD_FILTER_BY_CONTENT_DIV">
							<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%" id="dashboardGraphTooltipTable">
								<tr>
									<td valign="top">
										<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
											<tr>
												<td class="REGULARTEXT">
												<div id="filterByContentTreeExternalDiv" class="DASHBOARD_FILTER_BY_TREE_EXTERNAL_DIV">
													<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
														<tr>
															<td valign="top">
															<form AUTOCOMPLETE="OFF" id="dashboardFilterByForm" name="dashboardFilterByForm" class="DASHBOARD_FORM">
																<input type="hidden" id="filterModules" name="filterModules">
																<input type="hidden" id="filterLogs" name="filterLogs">
																<input type="hidden" id="filterApplications" name="filterApplications">
																<input type="hidden" id="filterServers" name="filterServers">
																
																<div id="filterByContentbox_tree" class="DASHBOARD_FILTER_BY_TREE_DIV"></div>
															</form>
															</td>
														</tr>
													</table>
												</div>
												</td>
											</tr>
										</table>
									</td>
								</tr>
							</table>
						</div>
					</td>
				</tr>
				<tr height="1px">
					<td class="DASHBOARD_FILTER_BY_SEPARATOR_CELL"><hr class="DASHBOARD_FILTER_BY_SEPARATOR"></td>
				</tr>
				<tr height="10px">
					<td class="DASHBOARD_FILTER_BY_BUTTONS_CELL">
						<a href="javascript:goDashboardFilterBy()"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/filterByGo.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/filterByGoOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/filterByGo.gif')"></a>
						<a href="javascript:closeDashboardFilterByDiv()"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/filterByClose.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/filterByCloseOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/filterByClose.gif')"></a>
					</td>
				</tr>
			</table>
		</div>
	</div>
</div>
<div id="dashboardFilterByTypeDiv" class="DASHBOARD_FILTER_BY_TYPE_MENU_CONTAINER">
	<div id="dashboardFilterByTypeShadowDiv" class="DASHBOARD_FILTER_BY_TYPE_MENU_SHADOW">
		<div id="dashboardFilterByTypeMenuDiv" class="DASHBOARD_FILTER_BY_TYPE_MENU_CONTENT">
			<input type="hidden" id="filterByType" name="filterByType" value="<%=filterByType %>">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr id="<%=filterByFoldersAndLogsType %>ListRow" class="DASHBOARD_FILTER_BY_TYPE_MENU_ITEM" onClick="javascript:setFilterByType('<%=filterByFoldersAndLogsType %>', false)" onMouseOver="javascript:setFilterByTypeMenuItemClass('<%=filterByFoldersAndLogsType %>ListRow', 'DASHBOARD_FILTER_BY_TYPE_MENU_ITEM_OVER')" onMouseOut="javascript:setFilterByTypeMenuItemClass('<%=filterByFoldersAndLogsType %>ListRow', 'DASHBOARD_FILTER_BY_TYPE_MENU_ITEM')">
				<%
					if(isFoldersAndLogsFilterActive) {
				%>
						<td id="<%=filterByFoldersAndLogsType %>ImageTd" class="DASHBOARD_FILTER_BY_TYPE_MENU_ITEM_CELL DASHBOARD_SELECTED_FILTER_BY_TYPE_MENU_ITEM"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/filterByTypeSelected.gif" border="0"></td>
				<%
					}else {
				%>
						<td id="<%=filterByFoldersAndLogsType %>ImageTd" class="DASHBOARD_FILTER_BY_TYPE_MENU_ITEM_CELL">&nbsp;</td>
				<%
					}
				%>
					<td class="DASHBOARD_FILTER_BY_TYPE_MENU_ITEM_CELL"><%=filterByFoldersAndLogs %></td>
				</tr>
				<tr id="<%=filterByApplicationsType %>ListRow" class="DASHBOARD_FILTER_BY_TYPE_MENU_ITEM" onClick="javascript:setFilterByType('<%=filterByApplicationsType %>', false)" onMouseOver="javascript:setFilterByTypeMenuItemClass('<%=filterByApplicationsType %>ListRow', 'DASHBOARD_FILTER_BY_TYPE_MENU_ITEM_OVER')" onMouseOut="javascript:setFilterByTypeMenuItemClass('<%=filterByApplicationsType %>ListRow', 'DASHBOARD_FILTER_BY_TYPE_MENU_ITEM')">
				<%
					if(isApplicationsFilterActive) {
				%>
						<td id="<%=filterByApplicationsType %>ImageTd" class="DASHBOARD_FILTER_BY_TYPE_MENU_ITEM_CELL DASHBOARD_SELECTED_FILTER_BY_TYPE_MENU_ITEM"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/filterByTypeSelected.gif" border="0"></td>
				<%
					}else {
				%>
						<td id="<%=filterByApplicationsType %>ImageTd" class="DASHBOARD_FILTER_BY_TYPE_MENU_ITEM_CELL">&nbsp;</td>
				<%
					}
				%>
					<td class="DASHBOARD_FILTER_BY_TYPE_MENU_ITEM_CELL"><%=filterByApplications %></td>
				</tr>
				<tr id="<%=filterByServersType %>ListRow" class="DASHBOARD_FILTER_BY_TYPE_MENU_ITEM" onClick="javascript:setFilterByType('<%=filterByServersType %>', false)" onMouseOver="javascript:setFilterByTypeMenuItemClass('<%=filterByServersType %>ListRow', 'DASHBOARD_FILTER_BY_TYPE_MENU_ITEM_OVER')" onMouseOut="javascript:setFilterByTypeMenuItemClass('<%=filterByServersType %>ListRow', 'DASHBOARD_FILTER_BY_TYPE_MENU_ITEM')">
				<%
					if(isServersFilterActive) {
				%>
						<td id="<%=filterByServersType %>ImageTd" class="DASHBOARD_FILTER_BY_TYPE_MENU_ITEM_CELL DASHBOARD_SELECTED_FILTER_BY_TYPE_MENU_ITEM"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/filterByTypeSelected.gif" border="0"></td>
				<%
					}else {
				%>
						<td id="<%=filterByServersType %>ImageTd" class="DASHBOARD_FILTER_BY_TYPE_MENU_ITEM_CELL">&nbsp;</td>
				<%
					}
				%>
					<td class="DASHBOARD_FILTER_BY_TYPE_MENU_ITEM_CELL"><%=filterByServers %></td>
				</tr>
			</table>
		</div>
	</div>
</div>