<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewContext"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.util.Constants"%>

<%!
static final String BASE_DIRECTORY = "../../";

%>

<%
int maxCurrentNodeNameLength = 20;

String HEALTH_VIEW_MODEL = "HealthViewModel";

HealthViewModel model = (HealthViewModel)session.getAttribute(HEALTH_VIEW_MODEL);

String viewBy = model.getViewBy();
String viewType = model.getViewType();
String viewGroupType = model.getViewGroupType();
boolean showMetrics = model.isShowMetrics();

String windowWidthStr = request.getParameter("windowWidth");
int windowWidth = windowWidthStr != null && windowWidthStr.length() > 0 ? Integer.parseInt(windowWidthStr) : -1;

String currentNodeName = model.getCurrentNodeName();
String currentNodeTooltip = null;
String currentNodeToolipCluase = "";
if(currentNodeName.length() > maxCurrentNodeNameLength && windowWidth != -1 && windowWidth < 1100) {
	currentNodeTooltip = currentNodeName;
	currentNodeToolipCluase = "onMouseOver=\"javascript:showTooltip('" + currentNodeTooltip + "')\" onMouseOut=\"hideTooltip()\"";
	currentNodeName = currentNodeName.substring(0, maxCurrentNodeNameLength);
	currentNodeName += "...";
}
String currentViewString = model.getCurentViewString();

boolean isRoot = model.getCurrentNode().getId().equals(HealthViewContext.ROOT_NODE_ID);
boolean enableFoldersAndLogs = isRoot || viewBy.equals(HealthViewContext.VIEW_BY_FOLDERS);
boolean enableApplications = isRoot || viewBy.equals(HealthViewContext.VIEW_BY_APPLICATIONS);
boolean enableServers = isRoot || viewBy.equals(HealthViewContext.VIEW_BY_SERVERS);

boolean showZoomOut = model.getZoomInDateFilters().size() > 0;
String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);
%>

<form AUTOCOMPLETE="OFF" id="dashboardHeaderForm" name="dashboardHeaderForm" method="POST" class="DASHBOARD_FORM">
<div id="dashboardHeaderParentDiv" style="height:100%; width:100%;">
<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
	<tr>
		<td>
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr height="10px">
					<td>
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td class="DASHBOARD_HEADER_TITLE">
									<span class="DASHBOARD_HEADER_TITLE_BOLD">XpoLog Center</span> <%=analyticsH %>
								</td>
								<td class="empty">&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr height="10px">
					<td>
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td class="DASHBOARD_HEADER_VIEW_BY_LEFT_CELL">&nbsp;</td>
								<td class="DASHBOARD_HEADER_VIEW_BY_CELL">
									<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
										<tr>
											<td class="DASHBOARD_HEADER_VIEW_BY_BUTTONS_CELL">
												<div id="dashboardViewByUpperDiv" class="DASHBOARD_HEADER_VIEW_BY_UPPER">
													<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
														<tr>
															<td class="DASHBOARD_HEADER_VIEW_BY_TEXT">View By:</td>
															<td class="DASHBOARD_HEADER_VIEW_BY_IMAGES_CELL">
																<%if(viewBy.equals(HealthViewContext.VIEW_BY_FOLDERS)) { %>
																<img src="<%=BASE_DIRECTORY %>images/dashboard/header/viewByFoldersOver.gif" border="0" onMouseOver="javascript:showDashboardViewBySlidingDiv('Folders and Logs')" onMouseOut="javascript:hideDashboardViewBySlidingDiv()">
																<%}else if(!enableFoldersAndLogs){ %>
																<img src="<%=BASE_DIRECTORY %>images/dashboard/header/viewByFoldersDisabled.gif" border="0">
																<%}else { %>
																<a href="javascript:changeViewBy('<%=HealthViewContext.VIEW_BY_FOLDERS %>');"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/viewByFolders.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/viewByFoldersOver.gif'); showDashboardViewBySlidingDiv('Folders and Logs')" onMouseOut="javascript:setImageSource(this, 'header/viewByFolders.gif'); hideDashboardViewBySlidingDiv()"></a>
																<%} %>
																<%if(viewBy.equals(HealthViewContext.VIEW_BY_APPLICATIONS)) { %>
																<img src="<%=BASE_DIRECTORY %>images/dashboard/header/viewByApplicationsOver.gif" border="0" onMouseOver="javascript:showDashboardViewBySlidingDiv('Applications')" onMouseOut="javascript:hideDashboardViewBySlidingDiv()">
																<%}else if(!enableApplications){ %>
																<img src="<%=BASE_DIRECTORY %>images/dashboard/header/viewByApplicationsDisabled.gif" border="0">
																<%}else { %>
																<a href="javascript:changeViewBy('<%=HealthViewContext.VIEW_BY_APPLICATIONS %>');"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/viewByApplications.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/viewByApplicationsOver.gif'); showDashboardViewBySlidingDiv('Applications')" onMouseOut="javascript:setImageSource(this, 'header/viewByApplications.gif'); hideDashboardViewBySlidingDiv()"></a>
																<%} %>
																<%if(viewBy.equals(HealthViewContext.VIEW_BY_SERVERS)) { %>
																<img src="<%=BASE_DIRECTORY %>images/dashboard/header/viewByServersOver.gif" border="0" onMouseOver="javascript:showDashboardViewBySlidingDiv('Servers')" onMouseOut="javascript:hideDashboardViewBySlidingDiv()">
																<%}else if(!enableServers){ %>
																<img src="<%=BASE_DIRECTORY %>images/dashboard/header/viewByServersDisabled.gif" border="0">
																<%}else { %>
																<a href="javascript:changeViewBy('<%=HealthViewContext.VIEW_BY_SERVERS %>');"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/viewByServers.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/viewByServersOver.gif'); showDashboardViewBySlidingDiv('Servers')" onMouseOut="javascript:setImageSource(this, 'header/viewByServers.gif'); hideDashboardViewBySlidingDiv()"></a>
																<%} %>
															</td>
															<td class="empty">&nbsp;</td>
														</tr>
													</table>
												</div>
												<div id="dashboardViewByCoverDiv" class="DASHBOARD_HEADER_VIEW_BY_COVER"></div>
												<div id="dashboardViewBySlidingDiv" class="DASHBOARD_HEADER_VIEW_BY_POPUP"></div>
											</td>
											<td class="empty">&nbsp;</td>
											<td class="DASHBOARD_HEADER_CONTROL_CELL">
												<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
													<tr>
														<td align="right" id="dataGenerationInProgressTd" style="display:none"><img id="dataGenerationInProgressImage" src="<%=BASE_DIRECTORY %>images/dashboard/header/dataGenerationInProgress.gif" border="0" onMouseOver="javascript:showTooltip(dashboardTooltips['dataGenerationInProgress'])" onMouseOut="javascript:hideTooltip()"></td>
														<td align="right" id="dataGenerationICompletedTd" style="display:none"><a href="javascript:refreshData('true');"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/dataGenerationCompleted.gif" border="0" onMouseOver="javascript:showTooltip(dashboardTooltips['dataGenerationCompleted'])" onMouseOut="javascript:hideTooltip()"></a></td>
														<!-- <td align="right" id="refreshDataTd" style="display:none"><a href="javascript:refreshData();" onMouseOver="javascript:showTooltip(dashboardTooltips['refreshData'])" onMouseOut="javascript:hideTooltip()"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/refreshData.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/refreshDataOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/refreshData.gif')"></a></td> -->
													</tr>
												</table>
											
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr height="10px">
					<td class="DASHBOARD_HEADER_PATH_CELL">
						<jsp:include page="dashboardPath.jsp" flush="true">
							<jsp:param name="showResetButton" value="true"/>
							<jsp:param name="pathClassName" value="DASHBOARD_HEADER_PATH"/>
							<jsp:param name="pathSeparatorClassName" value="DASHBOARD_HEADER_PATH_SEPARATOR"/>
						</jsp:include>
					</td>
				</tr>
				<tr height="10px">
					<td class="DASHBOARD_HEADER_CURRENT_VIEW_CELL">
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td class="DASHBOARD_HEADER_CURRENT_VIEW"><span class="DASHBOARD_HEADER_CURRENT_VIEW_ORANGE" <%=currentNodeToolipCluase %>><%=currentNodeName %></span>&nbsp;<%=currentViewString %></td>
								<td class="empty">&nbsp;</td>
								<td align="right">
									<jsp:include page="dashboardCalendar.jsp" flush="true" />
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr height="10px">
					<td>
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td class="DASHBOARD_HEADER_FILTER_BY_CELL">
									<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
										<tr>
											<td class="DASHBOARD_HEADER_FILTER_BY_TEXT">
												<a id="filterByDivLink" href="javascript:openDashboardFilterByDiv()" class="DASHBOARD_HEADER_FILTER_BY_TEXT_LINK" onMouseOver="javascript:showTooltip(dashboardTooltips['openFilterByDiv'])" onMouseOut="javascript:hideTooltip()">Filter Entities</a>
												<!--<span class="DASHBOARD_HEADER_FILTER_BY_ARROW"><a id="filterByDivLink" href="javascript:openDashboardFilterByDiv()"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/filterByOpen.gif" border="0" onMouseOver="javascript:showTooltip(dashboardTooltips['openFilterByDiv'])" onMouseOut="javascript:hideTooltip()"></a></span>-->
											<%
											if(model.getContextFilter().isFilterActive()) {
											%>
												&nbsp;|&nbsp;<a href="javascript:clearDashboardFilterBy()" class="DASHBOARD_HEADER_FILTER_BY_TEXT_LINK_CLEAR">Clear filter</a>
											<%
											}
											%>
											</td>
											<td class="empty">&nbsp;</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr height="10px">
					<td>
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td class="DASHBOARD_HEADER_VIEW_TYPE_CELL">
									<div id="dashboardViewTypeUpperDiv" class="DASHBOARD_HEADER_VIEW_TYPE_UPPER">
									<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
										<tr>
											<%
											if(viewType.equals(HealthViewContext.VIEW_TYPE_TOTAL)) {
											%>
											<td align="left"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/viewTypeTotalOver.gif" border="0" onMouseOver="javascript:showDashboardViewTypeSlidingDiv('<nobr>Total View</nobr>')" onMouseOut="javascript:hideDashboardViewTypeSlidingDiv()"></td>
											<td class="empty">&nbsp;&nbsp;&nbsp;</td>
											<td align="left"><a href="javascript:changeViewType('<%=HealthViewContext.VIEW_TYPE_RISK %>');"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/viewTypeRisk.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/viewTypeRiskOver.gif');javascript:showDashboardViewTypeSlidingDiv('<nobr>Risk View</nobr>')" onMouseOut="javascript:setImageSource(this, 'header/viewTypeRisk.gif');javascript:hideDashboardViewTypeSlidingDiv()"></a></td>
											<%
											}else if(viewType.equals(HealthViewContext.VIEW_TYPE_RISK)) {
											%>
											<td align="left"><a href="javascript:changeViewType('<%=HealthViewContext.VIEW_TYPE_TOTAL %>');"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/viewTypeTotal.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/viewTypeTotalOver.gif');javascript:showDashboardViewTypeSlidingDiv('<nobr>Total View</nobr>')" onMouseOut="javascript:setImageSource(this, 'header/viewTypeTotal.gif');javascript:hideDashboardViewTypeSlidingDiv()"></a></td>
											<td class="empty">&nbsp;&nbsp;&nbsp;</td>
											<td align="left"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/viewTypeRiskOver.gif" border="0" onMouseOver="javascript:showDashboardViewTypeSlidingDiv('<nobr>Risk View</nobr>')" onMouseOut="javascript:hideDashboardViewTypeSlidingDiv()"></td>
											<%
											}
											%>
										</tr>
									</table>
									</div>
									<div id="dashboardViewTypeSlidingDiv" class="DASHBOARD_HEADER_VIEW_TYPE_POPUP"></div>
								</td>
								<td align="center">
									<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
										<tr>
										<%
										if(showZoomOut) {
										%>
											<td class="DASHBOARD_GRAPH_ZOOM_OUT_OUTER_CELL">
												<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
													<tr>
														<td class="empty">&nbsp;</td>
														<td class="DASHBOARD_GRAPH_ZOOM_OUT_CELL"><a href="javascript:zoomOutGraph()" class="DASHBOARD_GRAPH_ZOOM_OUT_TEXT" onMouseOver="javascript:showTooltip(dashboardTooltips['zoomOutGraph'])" onMouseOut="javascript:hideTooltip()">Zoom out</a></td>
														<td class="empty">&nbsp;</td>
													</tr>
												</table>
											</td>
										<%
										}else {
										%>
											<td class="empty">&nbsp;</td>
										<%
										}
										%>
										</tr>
									</table>
								</td>
								<td class="DASHBOARD_HEADER_GROUP_TYPE_CELL">
									<div id="dashboardViewGroupTypeUpperDiv" class="DASHBOARD_HEADER_GROUP_TYPE_UPPER">
									<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
										<tr>
											<%
											if(showMetrics) {
											%>
											<td align="right"><a href="javascript:changeShowMetrics('false');"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/viewMetricsOver.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/viewMetrics.gif');javascript:showDashboardGroupTypeSlidingDiv('<nobr>Hide Metrics</nobr>')" onMouseOut="javascript:setImageSource(this, 'header/viewMetricsOver.gif');javascript:hideDashboardGroupTypeSlidingDiv()"></a></td>
											<td class="empty">&nbsp;&nbsp;&nbsp;</td>
											<%
											}else {
											%>
											<td align="right"><a href="javascript:changeShowMetrics('true');"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/viewMetrics.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/viewMetricsOver.gif');javascript:showDashboardGroupTypeSlidingDiv('<nobr>Show Metrics</nobr>')" onMouseOut="javascript:setImageSource(this, 'header/viewMetrics.gif');javascript:hideDashboardGroupTypeSlidingDiv()"></a></td>
											<td class="empty">&nbsp;&nbsp;&nbsp;</td>
											<%
											}
											if(viewGroupType.equals(HealthViewContext.VIEW_GROUP_TYPE_SPLIT)) {
											%>
											<td align="right"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/viewGroupTypeSplitOver.gif" border="0" onMouseOver="javascript:showDashboardGroupTypeSlidingDiv('<nobr>Split View</nobr>')" onMouseOut="javascript:hideDashboardGroupTypeSlidingDiv()"></td>
											<td class="empty">&nbsp;&nbsp;&nbsp;</td>
											<td align="right"><a href="javascript:changeViewGroupType('<%=HealthViewContext.VIEW_GROUP_TYPE_SUMMARY %>');"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/viewGroupTypeSummary.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/viewGroupTypeSummaryOver.gif');javascript:showDashboardGroupTypeSlidingDiv('<nobr>Summary View</nobr>')" onMouseOut="javascript:setImageSource(this, 'header/viewGroupTypeSummary.gif');javascript:hideDashboardGroupTypeSlidingDiv()"></a></td>
											<%
											}else if(viewGroupType.equals(HealthViewContext.VIEW_GROUP_TYPE_SUMMARY)) {
											%>
											<td align="right"><a href="javascript:changeViewGroupType('<%=HealthViewContext.VIEW_GROUP_TYPE_SPLIT %>');"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/viewGroupTypeSplit.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/viewGroupTypeSplitOver.gif');javascript:showDashboardGroupTypeSlidingDiv('<nobr>Split View</nobr>')" onMouseOut="javascript:setImageSource(this, 'header/viewGroupTypeSplit.gif');javascript:hideDashboardGroupTypeSlidingDiv()"></a></td>
											<td class="empty">&nbsp;&nbsp;&nbsp;</td>
											<td align="right"><img src="<%=BASE_DIRECTORY %>images/dashboard/header/viewGroupTypeSummaryOver.gif" border="0" onMouseOver="javascript:showDashboardGroupTypeSlidingDiv('<nobr>Summary View</nobr>')" onMouseOut="javascript:hideDashboardGroupTypeSlidingDiv()"></td>
											<%
											}
											%>
										</tr>
									</table>
									</div>
									<div id="dashboardGroupTypeSlidingDiv" class="DASHBOARD_HEADER_GROUP_TYPE_POPUP" style="width:0px;"></div>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td class="empty">&nbsp;</td>
				</tr>
			</table>
		</td>
	</tr>
</table>
</div>

</form>