<%@ page language="java"%>

<%@ page import="java.util.HashSet"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.reports.health.ui.DashboardExecutionManager"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.util.Constants"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
String HEALTH_VIEW_MODEL = "HealthViewModel";

UserContext userContext = UserEnvironment.getUserContext(request);

HealthViewModel model = (HealthViewModel)session.getAttribute(HEALTH_VIEW_MODEL);

String missingExecutionsActionType = request.getParameter("missingExecutionsActionType");
if(!missingExecutionsActionType.equals(ComputationConfiguration.MISSING_DATA_USER_POLICY_IGNORE)) {
	DashboardExecutionManager executionManager = DashboardExecutionManager.getInstance();
	if(missingExecutionsActionType.equals(ComputationConfiguration.MISSING_DATA_USER_POLICY_COMPLETE)) {
		HashSet missingExecutionsLogIdsSet = null;
		String missingExecutionsLogIdsStr = request.getParameter("missingExecutionsLogIds");
		if(missingExecutionsLogIdsStr != null) {
			String[] missingExecutionsLogIds = missingExecutionsLogIdsStr.split(",");
			//System.out.println("missingExecutionsLogIds length=" + missingExecutionsLogIds.length);
			missingExecutionsLogIdsSet = new HashSet();
			for(int i = 0; i < missingExecutionsLogIds.length; i++) {
				if(missingExecutionsLogIds[i].length() > 0) {
					missingExecutionsLogIdsSet.add(missingExecutionsLogIds[i]);
				}
			}
			String errorLogIdsStr = request.getParameter("errorLogIds");
			if (errorLogIdsStr != null && errorLogIdsStr.length() > 0){
				String[] errorLogIds = errorLogIdsStr.split(",");
				for(int i = 0; i < errorLogIds.length; i++) {
					if(errorLogIds[i].length() > 0) {
						missingExecutionsLogIdsSet.add(errorLogIds[i]);
					}
				}
			}
						
		}
		
		HashSet missingExecutionsHostIdsSet = null;
		String missingExecutionsHostIdsStr = request.getParameter("missingExecutionsHostIds");
		if(missingExecutionsHostIdsStr != null) {
			String[] missingExecutionsHostIds = missingExecutionsHostIdsStr.split(",");
			//System.out.println("missingExecutionsHostIds length=" + missingExecutionsHostIds.length);
			missingExecutionsHostIdsSet = new HashSet();
			for(int i = 0; i < missingExecutionsHostIds.length; i++) {
				if(missingExecutionsHostIds[i].length() > 0) {
					missingExecutionsHostIdsSet.add(missingExecutionsHostIds[i]);
				}
			}
			String errorHostIdsStr = request.getParameter("errorHostIds");
			if (errorHostIdsStr != null && errorHostIdsStr.length() > 0){
				String[] errorHostIds = errorHostIdsStr.split(",");
				for(int i = 0; i < errorHostIds.length; i++) {
					if(errorHostIds[i].length() > 0) {
						missingExecutionsHostIdsSet.add(errorHostIds[i]);
					}
				}
			}
						
		}
		String analytics = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_DISPLAY_NAME);
		if (missingExecutionsLogIdsSet != null || missingExecutionsHostIdsSet != null){
			String datesString = model.getTimeFilter().getMinDate() + "-" + model.getTimeFilter().getMaxDate();
			AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
					userContext, AuditConstants.COMPUTATION, "manual " + analytics + " execution", AuditConstants.DASHBOARD, "start manual " + analytics + " execution on dates " + datesString);
			
		  String runnerId = executionManager.startExecution(missingExecutionsLogIdsSet,missingExecutionsHostIdsSet, model.getTimeFilter(), userContext, true);
		//System.out.println("start runnerId " + runnerId);
		  model.addRunnerId(runnerId);
		}
	}else if(missingExecutionsActionType.equals("selected")) {
		
	}
	model.setLastDataGenerationActionTimestamp(System.currentTimeMillis());
}
String missingExecutionsSaveAnswerStr = request.getParameter("missingExecutionsSaveAnswer");
boolean missingExecutionsSaveAnswer = missingExecutionsSaveAnswerStr != null && missingExecutionsSaveAnswerStr.equals("true");
if(missingExecutionsSaveAnswer) {
	ComputationConfiguration computationConfiguration = ComputationConfiguration.getInstance();
	computationConfiguration.setMissingDataUserPolicy(missingExecutionsActionType);
	computationConfiguration.save();
}

response.setContentType("text/xml");
%>

<DashboardExecutionResponse>
	<Response missingExecutionsActionType="<%=missingExecutionsActionType %>">
	</Response>
</DashboardExecutionResponse>