<%@ page language="java"%>

<%@ page import="xpolog.eye.data.aggregate.DashboardProblemsRepositoryElement"%>
<%@ page import="xpolog.eye.data.aggregate.DashboardProblemsRepositoryManager"%>
<%@ page import="xpolog.eye.data.aggregate.DashboardProblemsRepositoryUpdateRequest"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%

UserContext userContext = UserEnvironment.getUserContext(request);

String action = request.getParameter("action");
String objectType = request.getParameter("objectType");
String objectId = request.getParameter("objectId");
String id = request.getParameter("id");
String type = request.getParameter("type");
String term = request.getParameter("term");
String matchTypeStr = request.getParameter("matchType");
String weightStr = request.getParameter("weight");
String defaultWeightStr = request.getParameter("defaultWeight");

DashboardProblemsRepositoryUpdateRequest updateRequest = new DashboardProblemsRepositoryUpdateRequest();
updateRequest.setAction(action);
updateRequest.setObjectType(objectType);
updateRequest.setObjectId(objectId);

DashboardProblemsRepositoryElement repositoryElement = new DashboardProblemsRepositoryElement();
repositoryElement.setUniqueId(String.valueOf(System.currentTimeMillis()));
repositoryElement.setId(id);
repositoryElement.setType(type);
repositoryElement.setTerm(term);
int matchType = 0;
try {
	matchType = Integer.parseInt(matchTypeStr);
}catch(Exception e) {
	matchType = 0;
}
repositoryElement.setMatchType(matchType);
double weight = -1;
try {
	weight = Double.parseDouble(weightStr);
}catch(Exception e) {
	weight = -1;
}
repositoryElement.setWeight(weight);
double defaultWeight = -1;
try {
	defaultWeight = Double.parseDouble(defaultWeightStr);
}catch(Exception e) {
	defaultWeight = -1;
}
repositoryElement.setDefaultWeight(defaultWeight);

updateRequest.setRepositoryElement(repositoryElement);

String status = "ok";
String message = "";
String showMessageStr = (String)session.getAttribute("dashboard.showProblemsRepositoryActionMessage");
boolean showMessage = true;
if(showMessageStr == null) {
	session.setAttribute("dashboard.showProblemsRepositoryActionMessage", "false");
}else {
	showMessage = Boolean.getBoolean(showMessageStr);
}


DashboardProblemsRepositoryManager.getInstance().updateProblemsRepository(updateRequest);

response.setContentType("text/xml");
%>

<DashboardProblemsRepositoryResponse>
	<Response status="<%=status %>" message="<%=message %>" showMessage="<%=showMessage %>">
	</Response>
</DashboardProblemsRepositoryResponse>