<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.reports.health.ui.DashboardDataManager"%>

<%
String DASHBOARD_SESSION_ACTIVITY = "DashboardSessionActivity";
String PREVIOUS_LAST_MONITOR_EXECUTION_TIMESTAMP = "previousLastMonitorExecutionTimestamp";

DashboardDataManager.NeedToRefreshWrapper needToRefreshWrapper = null;
boolean needToRefresh = false;
String dashboardSessionLastActivityStr = (String)session.getAttribute(DASHBOARD_SESSION_ACTIVITY);
long dashboardSessionLastActivity = -1;
if(dashboardSessionLastActivityStr != null && dashboardSessionLastActivityStr.length() > 0) {
	try {
		dashboardSessionLastActivity = Long.parseLong(dashboardSessionLastActivityStr);
		long minimumSessionActivityInterval = Configuration.getInstance().getPropertiesManager().getPropertyAsLong("dashboard.UI.minimumSessionActivityInterval", 300000);
		// refresh only if last activity was more than minimumSessionActivityInterval (default is 5 minutes)
		needToRefresh = minimumSessionActivityInterval != -1 && System.currentTimeMillis() - dashboardSessionLastActivity > minimumSessionActivityInterval;
		if(needToRefresh) {
			// refresh only if monitor was executed
			Long previousLastMonitorExecutionTimestampLong = (Long)session.getAttribute(PREVIOUS_LAST_MONITOR_EXECUTION_TIMESTAMP);
			long previousLastMonitorExecutionTimestamp = -1;
			if(previousLastMonitorExecutionTimestampLong != null) {
				previousLastMonitorExecutionTimestamp = previousLastMonitorExecutionTimestampLong.longValue();
				
			}
			needToRefreshWrapper = DashboardDataManager.getInstance().needToResfresh(previousLastMonitorExecutionTimestamp);
			needToRefresh = needToRefreshWrapper.isNeedToRefresh();
			session.setAttribute(PREVIOUS_LAST_MONITOR_EXECUTION_TIMESTAMP, new Long(needToRefreshWrapper.getLastMonitorExecutionTimestamp()));
		}
	}catch(Exception e) {
		
	}
}

response.setContentType("text/xml");
%>
<DashboardViewResponse>
	<Response dashboardSessionLastActivity="<%=dashboardSessionLastActivity %>" needToRefresh="<%=needToRefresh %>">
	</Response>
</DashboardViewResponse>