	/**
*	@desc: XPLG skin for paging
*/
dhtmlXGridObject.prototype._pgn_xplg = function(page, start, end){
		//set class names depending on grid skin
		var tmpAr = this.entBox.className.split("_");
		var sfx = "_xplg";
		
		this.pagerElAr = new Array();
		this.pagerElAr["pagerCont"] = document.createElement("DIV");
		this.pagerElAr["pagerBord"] = document.createElement("DIV");
		this.pagerElAr["pagerLine"] = document.createElement("DIV");
		this.pagerElAr["pagerBox"] = document.createElement("DIV");
		this.pagerElAr["pagerInfo"] = document.createElement("DIV");
		this.pagerElAr["pagerInfoBox"] = document.createElement("DIV");
		this.pagerElAr["pagerCont"].style.width = this.objBox.offsetWidth;
		this.pagerElAr["pagerCont"].style.clear = "both";
		this.pagerElAr["pagerBord"].className = "dhx_pbox"+sfx;
		this.pagerElAr["pagerLine"].className = "dhx_pline"+sfx;
		this.pagerElAr["pagerBox"].style.clear = "both";
		this.pagerElAr["pagerInfo"].className = "dhx_pager_info"+sfx;
		
		//create structure
		//this.pagerElAr["pagerCont"].appendChild(this.pagerElAr["pagerBord"]);
		this.pagerElAr["pagerCont"].appendChild(this.pagerElAr["pagerLine"]);
		//this.pagerElAr["pagerCont"].appendChild(this.pagerElAr["pagerInfo"]);
		this.pagerElAr["pagerLine"].appendChild(this.pagerElAr["pagerBox"]);
		this.pagerElAr["pagerInfo"].appendChild(this.pagerElAr["pagerInfoBox"]);
		this.pagerElAr["pagerCont"].className = "pager_cont";
		this._pgn_parentObj.innerHTML = "";
		this._pgn_parentObj.appendChild(this.pagerElAr["pagerCont"]);
		this._pgn_recInfoParentObj.innerHTML = "";
	  this._pgn_recInfoParentObj.appendChild(this.pagerElAr["pagerInfo"]);
				
		this.pagerElAr["pagerLine"].style.height="20px";				
		if(this.rowsBuffer.length>0  && this.rowsBuffer.length > this.rowsBufferOutSize){
			var lineWidth = 120;
			var lineWidthInc = 22;
			
		
			
			if (this.pagesInGroup > 0){
			  var pageCont = document.createElement("DIV");
			  var pageBox = document.createElement("DIV");
			  pageCont.appendChild(pageBox);
			  pageCont.className = "dhx_page"+sfx;			  
			  pageCont.style.cursor="default";
			  pageBox.style.width = "30px";
			  pageBox.innerHTML = "Page";
			  this.pagerElAr["pagerBox"].appendChild(pageCont);
			}
			
			//create left arrow if needed
			if(page>this.pagesInGroup){
				var pageCont = document.createElement("DIV");
				var pageBox = document.createElement("DIV");
				pageCont.className = "dhx_page"+sfx;
				pageBox.innerHTML = "&larr;";
				pageCont.appendChild(pageBox);
				this.pagerElAr["pagerBox"].appendChild(pageCont);
				var self = this;
				pageCont.pgnum = (Math.ceil(page/this.pagesInGroup)-1)*this.pagesInGroup;
				pageCont.onclick = function(){
					self.changePage(this.pgnum);
				}
				lineWidth +=lineWidthInc;
			}
				//create pages
			for(var i=1;i<=this.pagesInGroup;i++){
				var pageCont = document.createElement("DIV");
				var pageBox = document.createElement("DIV");
				pageCont.className = "dhx_page"+sfx;
				pageNumber = ((Math.ceil(page/this.pagesInGroup)-1)*this.pagesInGroup)+i;
				if(pageNumber>Math.ceil(this.rowsBuffer.length/this.rowsBufferOutSize))
					break;
				pageBox.innerHTML = "["  + pageNumber + "]";
				pageCont.appendChild(pageBox);
				if(page==pageNumber){
					pageCont.className += " dhx_page_active"+sfx;
					pageBox.className = "dhx_page_active"+sfx;
				}else{
					var self = this;
					pageCont.pgnum = pageNumber;
					pageCont.onclick = function(){
						self.changePage(this.pgnum);
					}
				}
				lineWidth +=(parseInt(lineWidthInc/3)*pageNumber.toString().length)+15;
				pageBox.style.width = (parseInt(lineWidthInc/3)*pageNumber.toString().length)+8+"px";
				this.pagerElAr["pagerBox"].appendChild(pageCont);
			}
			
			//create right arrow if needed
			if(Math.ceil(page/this.pagesInGroup)*this.pagesInGroup<Math.ceil(this.rowsBuffer.length/this.rowsBufferOutSize)){
				var pageCont = document.createElement("DIV");
				var pageBox = document.createElement("DIV");
				pageCont.className = "dhx_page"+sfx;
				pageBox.innerHTML = "&rarr;";
				pageCont.appendChild(pageBox);
				this.pagerElAr["pagerBox"].appendChild(pageCont);
				var self = this;
				pageCont.pgnum = (Math.ceil(page/this.pagesInGroup)*this.pagesInGroup)+1;
				pageCont.onclick = function(){
					self.changePage(this.pgnum);
				}
				lineWidth +=lineWidthInc;				
			}
			
			this.pagerElAr["pagerLine"].style.width = lineWidth+"px";
		}
		
		//create page info
		if(this.rowsBuffer.length>0 && this.showRecInfo)
			this.pagerElAr["pagerInfoBox"].innerHTML = this.xplg_records+(start+1)+this.xplg_to+end+this.i18n.paging.of+this.rowsBuffer.length;
		else if(this.rowsBuffer.length==0){
			//this.pagerElAr["pagerLine"].parentNode.removeChild(this.pagerElAr["pagerLine"]);
			//this.pagerElAr["pagerInfoBox"].innerHTML = this.i18n.paging.notfound;
			//this.pagerElAr["pagerLine"].innerHTML = this.i18n.paging.notfound;
			var pageCont = document.createElement("DIV");
			  var pageBox = document.createElement("DIV");
			  pageCont.appendChild(pageBox);
			  pageCont.className = "dhx_page"+sfx;			  
			  pageCont.style.cursor="default";
			  pageBox.style.width = "30px";
			  pageBox.innerHTML = "<nobr>" + this.xplg_notfound + "</nobr>";
			  this.pagerElAr["pagerBox"].appendChild(pageCont);
		}
		//add whitespaces where necessary
		this.pagerElAr["pagerBox"].appendChild(document.createElement("SPAN")).innerHTML = "&nbsp;";
		this.pagerElAr["pagerBord"].appendChild(document.createElement("SPAN")).innerHTML = "&nbsp;";
		this.pagerElAr["pagerCont"].appendChild(document.createElement("SPAN")).innerHTML = "&nbsp;";
		
	}

