<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.util.List"%>
<%@ page import="java.io.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.agg.result.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.audit.*"%>
<%@ page import="xpolog.eye.data.filters.*"%> 
<%@ page import="xpolog.eye.site.problem.*"%>
<%@ page import="xpolog.eye.site.problem.results.*"%>
<%@ page import="xpolog.eye.meta.MetaDataManager"%>
<%@ page import="xpolog.eye.meta.MetaData"%>


<%!static final String BASE_DIRECTORY = "../";

	DecimalFormat decFormat = new DecimalFormat("##.##");
	String dateFormatStr = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
	SimpleDateFormat dateFormat = new SimpleDateFormat(dateFormatStr);			
	String millisecondsSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator",".");
    String dateFormatMS = dateFormatStr+millisecondsSeperator+"SSS";

	  public String transformDateToString(Date d,long timeDiff){
	    if(d == null){
	      return null;
	    }
	    if (timeDiff != 0){
	     long time = d.getTime();
	  	 d = ((Date)d.clone());
	  	 d.setTime(time + timeDiff); 
	    }
	    String format = "";
	    if (d.getTime() % 1000 == 0){
	      format = dateFormatStr;
	    } else {
	      format = dateFormatMS;
	    }
	    String str = new SimpleDateFormat(format).format(d);
	    return str;
	   }
%>
<%
	
	String ERROR_OBJ = "ERROR_OBJ";
	ErrorModel errmodel = new ErrorModel();
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	ProblemViewModel model = (ProblemViewModel)request.getSession().getAttribute(ProblemViewModel.PROBLEM_MODEL_TYPE);
	
	if (errmodel.getErrorCount() != 0) {
		request.getSession().setAttribute(ERROR_OBJ, errmodel);
		return;
	}
	ProblemLogsResult	logsResult = model == null ? null : (ProblemLogsResult)model.getResult(ProblemViewModel.LOGS_TYPE);
	ModuleMember [] members = logsResult == null ? null : logsResult.getMembers();
	String treeCode = ProblemViewHelper.getTreeDivForDiagnosticsResultLogs(userContext,members,true,"modTree",true,BASE_DIRECTORY);			
	
	%>

<table border="0" width="100%" cellspacing="0" height="100%"
	cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
	<tr>
		<td width="100%" height="100%" valign="top">
		<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
			<tr>
				<td valign="top" height="100%">
				<div id="logsDiv">
				<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
					<tr>
						<td width="100%">
						<%if (members != null && members.length > 0 ){%>
							<table border="0" cellpadding="0" cellspacing="0" width="100%">
								<tr>
								<td class="REGULARTEXT">
								  <form AUTOCOMPLETE="OFF" id="logsResultForm" name="logsResultForm" action="viewMergeAction.jsp" method="POST" style="padding:0;margin:0">
									<script>									    
										 var modTree = createTree("modTree");
										 <%=treeCode%>
										 modTree.onSelectMarkChilds = true;
										 modTree.writeTree();
									</script>
									</form>
								</td>
								</tr>
							</table>
						<% } else { %>
						<span class="SMALLTEXT" style="padding-left:15"> <nobr>No logs available </nobr> </span>
						<%} %>
				
				</td>
			</tr>
		</table>
		</div>
		</td>
	</tr>
</table>
