<%@ page language="java"%>
<%@ page import="xpolog.eye.site.problem.ProblemViewModel"%>
<%@ page import="xpolog.eye.site.problem.ProblemViewQuery"%>
<%@ page import="xpolog.eye.meta.MetaDataManager"%>
<%@ page import="xpolog.eye.site.problem.ProblemViewHelper"%>
<%@ page import="xpolog.eye.site.ui.tree.ModuleMemberRenderer"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.util.regex.Matcher"%>
<%@ page import="java.util.regex.Pattern"%>
<%
	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
	
	boolean treeNodeExists = false;
	String treeXml = ""; 
  String id = request.getParameter("id");

  String appId = null;
	int rootIdCounter = -1;
  if (id != null){
  	String modid = id;
  	int ind = id.indexOf("-");
  	if (ind != -1 && ind < id.length()-1){
  		modid = id.substring(ind+1);
  	}
  	ind = modid.indexOf("@");
  	if (ind != -1 && ind < modid.length()-1){
  		appId = modid.substring(0,ind);
  		modid = modid.substring(ind+1);
  	}
  	Pattern p = Pattern.compile(".*\\[(\\d+)].*");
  	Matcher m = p.matcher(modid);
  	String rootExt = null;
  	try{
	 		if (m.matches()){
	 			rootExt = m.group(1);
	 			if (rootExt != null){
	 				rootIdCounter = Integer.parseInt(rootExt);
	 			}
	 		}
  	}catch(Exception e){
  	}
  	modid = ModuleMemberRenderer.getIdFromUniqueId(modid);
		curmod = SiteManagment.getInstance().getModuleFromId(modid);
		treeNodeExists = true;
  }

	ProblemViewModel model = (ProblemViewModel)request.getSession().getAttribute(ProblemViewModel.PROBLEM_MODEL_TYPE);		
	ProblemViewQuery query = null;
	if (model != null) {
		query = model.getQuery();				
	}
	HashSet members = new HashSet();
	boolean edit = false;
	if(query!=null) {
		members.addAll(query.getApplications());
		members.addAll(query.getModuleMembers()); 
		edit = true;
	}

	ModuleMemberRenderer renderer = null;
	if (model != null){
		renderer = model.getRenderer();
	}else{
		renderer = (ModuleMemberRenderer)request.getAttribute("DiagnosticsModuleMemberRenderer");
	}
	if (renderer == null){
		renderer = new ModuleMemberRenderer();
		renderer.setUseUniqueIds(true);
		renderer.setUserContext(userContext);
		renderer.setRemoveEmptyFolders(true);
		renderer.setAddTypeToId(true);
		request.setAttribute("DiagnosticsModuleMemberRenderer",renderer);
	}
	if (model != null){
		model.setRenderer(renderer);
		request.removeAttribute("DiagnosticsModuleMemberRenderer");
	}
	renderer.setRootIdCounter(rootIdCounter);
	renderer.setTreeNodeExists(treeNodeExists);
	renderer.setAddStorageIndication(true);
	if (!treeNodeExists){
		//treeXml = ProblemViewHelper.getTreeXML(userContext, members, true);
		renderer.resetCounter();
		ProblemViewHelper.updateRendrerMembers(renderer,members);
		treeXml = renderer.getApplicationTreeXML(false,true);
	}else if (curmod != null){
		if (appId != null && appId.length() > 0){
	    renderer.setExtIdToAppend(appId);
    }
		renderer.setMod(curmod);
		if (edit){
	    ProblemViewHelper.updateRendrerMembers(renderer,members);
		}
		treeXml = renderer.getTreeXML();
	}
	
	response.setContentType("text/xml");
	out.write(treeXml);
	out.flush();
%>
