<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.util.List"%>
<%@ page import="java.io.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.agg.result.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.audit.*"%>
<%@ page import="xpolog.eye.data.filters.*"%> 
<%@page import="xpolog.eye.site.problem.*"%>
<%@page import="xpolog.eye.site.problem.results.*"%>


<%!static final String BASE_DIRECTORY = "../";

	DecimalFormat decFormat = new DecimalFormat("##.##");
	String dateFormatStr = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
	SimpleDateFormat dateFormat = new SimpleDateFormat(dateFormatStr);			
	String millisecondsSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator",".");
    String dateFormatMS = dateFormatStr+millisecondsSeperator+"SSS";

	  public String transformDateToString(Date d,long timeDiff){
	    if(d == null){
	      return null;
	    }
	    if (timeDiff != 0){
	     long time = d.getTime();
	  	 d = ((Date)d.clone());
	  	 d.setTime(time + timeDiff); 
	    }
	    String format = "";
	    if (d.getTime() % 1000 == 0){
	      format = dateFormatStr;
	    } else {
	      format = dateFormatMS;
	    }
	    String str = new SimpleDateFormat(format).format(d);
	    return str;
	   }
%>
<%
	
	String ERROR_OBJ = "ERROR_OBJ";
	ErrorModel errmodel = new ErrorModel();
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	ProblemViewModel model = (ProblemViewModel)request.getSession().getAttribute(ProblemViewModel.PROBLEM_MODEL_TYPE);
	
	if (errmodel.getErrorCount() != 0) {
		request.getSession().setAttribute(ERROR_OBJ, errmodel);
		return;
	}
	ProblemReportResult	reportsResult = model == null ? null : (ProblemReportResult)model.getResult(ProblemViewModel.REPORTS_TYPE);
	Map reports = reportsResult == null ? null : reportsResult.getReportsMap();
 	        
	%>

<table border="0" width="100%" cellspacing="0" height="100%"
	cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
	<tr>
		<td width="100%" height="100%" valign="top">
		<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
			<tr>
				<td valign="top" height="100%">
				<table border="0" cellpadding="0" cellspacing="0" width="100%">
					<tr>
						<td width="100%" style="padding-left:15">
						<%if (reports != null && reports.size() > 0 ){%>
							<table border="0" cellpadding="0" cellspacing="0" width="100%">
							
						<% Collection col = reports.keySet();
						  for (Iterator iter = col.iterator();iter.hasNext();){
						  	Report rep = (Report)iter.next();
						  	String repName = rep.getReportName();
						  	
						  	ReportRuntime[] runtimes = (ReportRuntime[])reports.get(rep);
						  	ReportRuntime lastRuntime = runtimes != null && runtimes.length>0 ? runtimes[runtimes.length-1]:null;
						  	
						  	if(lastRuntime == null) {						  		
						  		continue;
						  	}						  
						  	String TimeLim = dateFormat.format(new Date(lastRuntime.getStartTime())) + "-" + dateFormat.format(new Date(lastRuntime.getEndTime()));						  	
						%>
						 <tr><td>
						  <nobr><a class="DIAGNOSTICS_LINK" href="<%=BASE_DIRECTORY%>reports/agg/aggReport.jsp?reportId=<%=rep.getId()%>&reportRuntimeId=<%=lastRuntime.getId()%>"><b><%=repName%></b> - (<%=TimeLim%>)</a> </nobr>
						  </td></tr>
						<%}%>
						</table>
						<% } else { %>												
						<span class="SMALLTEXT"><nobr>No reports available</nobr></span>											
						<%} %>				
				</td>
			</tr>
		</table>
		</td>
	</tr>
</table>
</td></tr></table>