
<%@page import="xpolog.eye.data.filters.MultiFilter"%>
<%@page import="xpolog.eye.data.filters.DefaultAllFilter"%>
<%@page import="xpolog.eye.data.filters.QueryFilter"%>
<%@page import="xpolog.eye.util.DateUtil"%><%@ page language="java"%>

<%@ page import="java.text.SimpleDateFormat"%>
<%@ page import="java.util.*"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.admin.helpers.LogAdminHelper"%>
<%@ page import="xpolog.eye.admin.helpers.MergeAdminHelper"%>
<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.data.masks.DateMask"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.data.filters.FilterManager"%>
<%@ page import="xpolog.eye.data.masks.MaskColumn"%>
<%@ page import="xpolog.eye.data.RecordMask"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.logview.LogViewTab"%>
<%@ page import="xpolog.eye.site.main.MainViewModel"%>
<%@ page import="xpolog.eye.site.main.MainViewTabModel"%>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>
<%@ page import="xpolog.eye.LogBrowsingManager"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>

<%!
static final String BASE_DIRECTORY = "../";
%>

<%
String ERROR_OBJ = "ERROR_OBJ";	


SiteManagment mgmt = SiteManagment.getInstance();
String lbmId = request.getParameter("lbmId");
String filterIds = request.getParameter("filterIds");
String filterName = request.getParameter("filterName");
String startTimeFullStr = request.getParameter("startTimeFullStr");
String startTime = request.getParameter("startTime");
String endTimeFullStr = request.getParameter("endTimeFullStr");
String endTime = request.getParameter("endTime");
String hideDashboardButtonStr = request.getParameter("hideDashboardButton");
boolean hideDashboardButton = hideDashboardButtonStr != null && hideDashboardButtonStr.equals("true");
String opdirect = request.getParameter("opdirect");
if(opdirect == null || opdirect.length() == 0) {
	opdirect = "START";
}
String zoomInKey = request.getParameter("zoomInKey");
if(zoomInKey == null) {
	zoomInKey = "";
}

String message = "";
boolean success = false;
if (lbmId != null && lbmId.length() > 0) {
	LogBrowsingManager lbm = null;
	try{
		UserEnvironment env = UserEnvironment.getUserEnvironment(request);
		MainViewModel mainViewModel = env.getMainViewModel();
		
		String [] LogsToMerge = lbmId.split(",");
  	if (LogsToMerge.length > 1){
  		lbm = MergeAdminHelper.getMergeLogsFromLogs(LogsToMerge,"Merge filter log","Merge filter log","mergeDashboardFilter" + System.currentTimeMillis());
  		if (lbm != null){
  			lbmId = LogsToMerge[0];
  		}
  	}else {
		  MainViewTabModel tab = mainViewModel.getOnlineTabByDataId(lbmId);
		  if (tab != null && tab instanceof LogViewTab){
			  lbm = ((LogViewTab)tab).getLbm();
		  }
		  if (lbm == null){
		  	lbm = mgmt.getLogBrowserManager(lbmId);
		  }
  	}
		if (lbm != null){
			RecordMask mask = new RecordMask();
			DateMask dateMask = new DateMask("MM/dd/yyyy HH:mm:ss");
			MaskColumn[] cols = {dateMask};
			mask.setColumns(cols);	
			
			Date startDate = null, endDate = null;
			long startTimeLong = -1, endTimeLong = -1;
			if(startTimeFullStr != null && startTimeFullStr.length() > 0 &&
				 endTimeFullStr != null && endTimeFullStr.length() > 0) {
				startDate = DateUtil.transformStringToDate(startTimeFullStr);
				endDate = DateUtil.transformStringToDate(endTimeFullStr);
			}else if(startTime != null && startTime.length() > 0 &&
							 endTime != null && endTime.length() > 0) {
				try {
					startTimeLong = Long.parseLong(startTime);
					startDate = new Date(startTimeLong);
					endTimeLong = Long.parseLong(endTime);
					endDate = new Date(endTimeLong);
				}catch(Exception e) {
				}
			}
			DateFilter dateFilter = null;
			if(startDate != null || endDate != null) {
				dateFilter = new DateFilter();
				if(startDate != null) {
					dateFilter.setMinDate(startDate);
				}
				if(endDate != null) {
					dateFilter.setMaxDate(endDate);
				}
			}
			if(dateFilter != null){
				//dateFilter.setRoundMilliseconds(model.getMsToRound());
				dateFilter.updateMinTime();	
				dateFilter.setTimeType(-1);
				dateFilter.setTimeGap(-1);
				if (dateFilter.getMinDate() == null){
					dateFilter.setMinDate(new Date(0));
				}
				if (dateFilter.getMaxDate() == null){
					dateFilter.setMaxDate(new Date());
				}
			}
			DateFilter df = null;
			if (dateFilter != null){
				mask = lbm.getRecordMask();
				df = (DateFilter)dateFilter.clone();
				if (df != null){
					df.setColInd(mask.getDateColumnIndex());
					df.setIndexing(mask);
					df.updateMinTime();
					df.setTimeOpType(0);
					df.setTimeGap(-1);
					df.setTimeType(-1);
				}
			}
			
			FilterManager filterManager = lbm.getFilterManager();
			FilterCollection fc = new FilterCollection();
			fc.setName(filterName == null || filterName.length() == 0 ? "query filter" : filterName);
			fc.setTransientFilter(true);
			
			if (!success) {
				String[] filterIdsArr = filterIds.split(",");
				if(filterIdsArr != null) {
					if(filterManager != null) {
						List filterCollections = new ArrayList();
						String currentFilterId = null;
						FilterCollection currentFilterCollection = null;
						for (int i = 0; i < filterIdsArr.length; i++) {
							currentFilterId = filterIdsArr[i];
							if(currentFilterId == null || currentFilterId.length() == 0) {
								continue;
							}
							if(currentFilterId.equals(DefaultAllFilter.ALL_FILTER_ID)) {
								DefaultAllFilter allFilter = new DefaultAllFilter();
								fc = new FilterCollection();
								fc.setTransientFilter(true);
								fc.setName(filterName == null || filterName.length() == 0 ? "gadget filter" : filterName);
								fc.addFilter(allFilter);
								filterManager.addFilterCollection(fc);
								filterCollections.add(fc);
							}else {
								currentFilterCollection = filterManager.getFilterCollectionById(currentFilterId);
								if(currentFilterCollection != null) {
									FilterCollection fc1 = (FilterCollection)currentFilterCollection.clone();
									List dateFilters = fc1.getByName(DateFilter.DATE_FILTER_NAME);
									if(dateFilters != null && dateFilters.size() > 0) {
										// remove the date filters, as the time is determined in the gadget
										DateFilter df1 = null;
										for(int j = 0; j < dateFilters.size(); j++) {
											df1 = (DateFilter)dateFilters.get(j);
											fc1.removeFilter(df1);
										}
										if(fc1.getFilters() != null && fc1.getFilters().size() == 0) {
											// if no filter remain in this filter collection, continue
											continue;
										}
									}
									filterCollections.add(fc1);
								}
							}
						}
						
						if(filterCollections.size() > 0) {
							fc = new FilterCollection();
							if(filterCollections.size() == 1) {
								currentFilterCollection = (FilterCollection)filterCollections.get(0);
								if(df != null) {
									currentFilterCollection.addFilter(df);
								}
								fc = currentFilterCollection;
							}else {
								fc.setName(filterName == null || filterName.length() == 0 ? "gadget filter" : filterName);
								MultiFilter multiFilter = new MultiFilter();
								multiFilter.setKey("LogAndFilterGadgetMultiFilterKey");
								multiFilter.setFman(filterManager);
								for(int i = 0; i < filterCollections.size(); i++) {
									currentFilterCollection = (FilterCollection)filterCollections.get(i);
									if(df != null) {
										currentFilterCollection.addFilter(df);
										// put the filter collection with the new date filter inside the filter manager
										filterManager.addFilterCollection(currentFilterCollection);
									}
									multiFilter.addFilteCollection(currentFilterCollection.getId());
								}
								fc.addFilter(multiFilter);
							}
							fc.setTransientFilter(true);
						}
					}
				}
				
				boolean failed = false;
				try {
					
				long logStartTime = LogAdminHelper.checkForUpdateLogStartTime(lbm,false);
				if (logStartTime > 0 && dateFilter != null && dateFilter.getMaxDate() != null && dateFilter.getMaxDate().getTime() < logStartTime){
					if (ErrorModel.log.isInfoEnabled()){
					  ErrorModel.log.info("No data is exists for log " + lbmId + " in filter " + dateFilter + " and start time in log "  + new Date(logStartTime));
					}
					success = false;
					message = "The log doesn't contain matching events from the given time";
					failed = true;
				}
				}catch (Exception e){
					ErrorModel.log.error("Failed to get first time for " + lbmId  + " in filter " + dateFilter,e);
				}
				if (!failed){
				  filterManager.addFilterCollection(fc);
				  lbm.setShowDashboardInLogView(!hideDashboardButton);
				  request.getSession().setAttribute("logid",lbm.getId()); 
				  request.getSession().setAttribute("CURRENT_LOG",lbm);
				
				  String expandLogViewerStr = request.getParameter("expandLogViewer");
				  boolean expandLogViewer = expandLogViewerStr != null && expandLogViewerStr.equals("true");
				  String url = "";
				  if(expandLogViewer) {
					
					  url = "componentAction.jsp?selectedCompId=Xpolog&forward=loggers/logview.jsp?";
				  	if (!lbm.isTemporary()){
					  	url = url + "logid="+lbmId+"%26";
					  }
					  url = url + "opdirect=START%26filters="+fc.getId()+"%26addFilter=true%26calls=-1%26gotoMain=true%26timetamp=" + System.currentTimeMillis();
				  }else {
					  url = "componentAction.jsp?selectedCompId=Xpolog&forward=root.jsp?mainPage=loggers/logview.jsp%253F";
					  StringBuffer buffer = new StringBuffer();
					  buffer.append("logid=");
					  buffer.append(lbmId);
					  buffer.append("&opdirect=");
					  buffer.append(opdirect);
					  buffer.append("&zoomInKey=");
					  buffer.append(zoomInKey);
					  buffer.append("&filters=");
					  buffer.append(fc.getId());
					  buffer.append("&addFilter=true");
					  buffer.append("&calls=-1");
					  buffer.append("&gotoMain=true");
					  buffer.append("&timetamp=");
					  buffer.append(System.currentTimeMillis());
					  String queryString = buffer.toString();
					  queryString = XpologUtil.replaceAll(queryString, "&", "%26");
					  queryString = XpologUtil.replaceAll(queryString, "%", "%25");
					  url += queryString;						
				  }
				  success = true;
				  message = url;
				}
			}
		}else {
			message = "The log doesn't exist";
		}
	}catch(Exception e){		
		ErrorModel.log.error("Failed to load log browsing manager for log " + lbmId,e);
		success = false;
		message = "Unable to load log";
	}
	
	 String xml = GridModelActionsHelper.getResultXML(success, message);

		response.setContentType("text/xml");
		response.setHeader("Pragma-Control", "no-cache");
		response.setHeader("Cache-Control", "no-cache");
		response.setHeader("Expires", "0");
		
		
		out.write(xml);
		out.flush();
}
%>