<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.site.main.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@page import="xpolog.eye.error.ErrorModel"%>

<%
 
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  UserContext userContext = UserEnvironment.getUserContext(request);
  
  String sourceId = request.getParameter("sourceId");
  String targetId = request.getParameter("targetId");
  String childStr = request.getParameter("isChild");
  boolean isChild = childStr != null && childStr.equals("true");
  
  String openStr = request.getParameter("isOpen");
  boolean isOpen = openStr != null && openStr.equals("true");

  String message = "";
  boolean success = false;
  if (sourceId != null && sourceId.length() > 0 && targetId != null && targetId.length() > 0){  
	  
	  try {
	    ModuleMember targetMember = mgmt.getModuleMember(targetId);
	    ArrayList sources = new ArrayList();
	    String [] sourceIds = sourceId.split(",");
	    for(int i = 0 ; i < sourceIds.length;i++){
	    	ModuleMember source = mgmt.getModuleMember(sourceIds[i]);
	    	if (source != null){
	    		sources.add(source);
	    	}
	    }	    
	    if (targetMember != null && sources.size() > 0){	    
	    	 Module parent = isChild || isOpen? mgmt.getModuleFromId(targetId) : mgmt.getParentModule(targetId);
	   		 if (parent != null){
	   			int index = isChild ? parent.getModuleMembers().size() : isOpen ? 0 : parent.indexOf(targetMember) + 1;
	   		//audit
	   		  for (Iterator iterator = sources.iterator(); iterator.hasNext();) {
			      ModuleMember sourceMember = (ModuleMember) iterator.next();
	   		    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   		  			userContext, AuditConstants.CHANGE, "move folder/log", AuditConstants.MODULES, "move the folder/log  " + sourceMember.getId() + " to parent " + parent.getId() + " in position " + index);
	   		  }
	   		 success = admin.updateMemberLocation(sources,parent,index,userContext);	   			
	   		 }	      
	     }
	   } catch (Exception e) {
				ErrorModel.log.error("Failed to move folder/log " + sourceId
						+ " to " + targetId + " , is child = " + isChild + " , is open = " + isOpen, e);
				success = false;
				message = e.getMessage();
		 }
	  
  }else {
		message = "No source or taget were given, please refresh and try again";
	}
  
  String xml = GridModelActionsHelper.getResultXML(success, message);

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	
	out.write(xml);
	out.flush();
 
%>
