<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
  UserContext userContext = UserEnvironment.getUserContext(request);
  //constants
  String ERROR_OBJ = "ERROR_OBJ";
  String CURRENT_MODULE = "CURRENT_MODULE";
  String  MODULE_ID = "MODULE_ID";
  String id = request.getParameter(MODULE_ID);
  Module mod = null;
  if (id == null || id.length() == 0){
     mod = (Module)request.getSession().getAttribute(CURRENT_MODULE);
     if (mod != null){
        id = mod.getId();
     }else {
       id = null;
     }
  }
  if (id == null){
        ErrorModel ermod = new ErrorModel();
        ermod.addError("No folder was selected!");
        request.getSession().setAttribute(ERROR_OBJ,ermod);
        response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
        return;
  }
  String name = "";
  if(mod == null) {
	  try {
		  ModuleMember member = SiteManagment.getInstance().getModuleMember(id);
		  if(member != null) {
			  name = member.getName();
		  }
	  }catch(Exception e) {}
  }else {
	  name = mod.getName();
  }
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			userContext, AuditConstants.CHANGE, "save/edit folder", AuditConstants.MODULES, "change permission to folder " + name);
  
  response.sendRedirect(BASE_DIRECTORY + "security/common/moduleMemberPermissions.jsp?id="+ id);
%>