<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!

  public void go(String str){
    System.out.println(str);
  }

%>
<%

  String MODULE_NAME = "MODULE_NAME";
  String MODULE_OWNER = "MODULE_OWNER";
  String MODULE_DESCRIPTION = "MODULE_DESCRIPTION";
  String MODULE_PARENT = "MODULE_PARENT";
  String MODULE_ID = "MODULE_ID";
  String CURRENT_MODULE = "CURRENT_MODULE";
  String ERROR_OBJ = "ERROR_OBJ";

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  UserContext userContext = UserEnvironment.getUserContext(request);

  String modid = request.getParameter(MODULE_ID);
  String modname = request.getParameter(MODULE_NAME);
  String modowner = request.getParameter(MODULE_OWNER);
  String modparent = request.getParameter(MODULE_PARENT);
  String moddesc = request.getParameter(MODULE_DESCRIPTION);


  if(modname == null || modname.trim().equals("")){
    ErrorModel errmod = new ErrorModel();
    errmod.addError("No name was supplied.");
    request.getSession().setAttribute(ERROR_OBJ,errmod);
    response.sendRedirect("errorpage.jsp");
    return;
  }

  HashSet set = new HashSet();
  set.add("?");
  set.add("\"");
  set.add("'");
  set.add(">");
  set.add("<");
  set.add("}");
  set.add("{");
  set.add("\\");
  set.add("/");
  set.add("!");
  set.add(":");
  set.add(";");
  set.add("=");
  set.add("(");
  set.add(")");
  set.add("|");
  set.add("[");
  set.add("]");
  String chars = "?,\",\\,',/,{,},[,],(,),=,:,;,<,>,!,|";
  Iterator it = set.iterator();
  while(it.hasNext()){
    if(modname.indexOf((String)it.next()) >= 0){
      ErrorModel errmod = new ErrorModel();
      errmod.addError("The following charecters are prohibited in the name field: " +chars);
      request.getSession().setAttribute(ERROR_OBJ,errmod);
      response.sendRedirect("errorpage.jsp");
      return;
    }
  }
  Module curmod = null;
  if(modid == null || modid.trim().equals("")){
    curmod = (Module)request.getSession().getAttribute(CURRENT_MODULE);
  }else{
    curmod = mgmt.getModuleFromId(modid);
  }

  if(curmod == null){
    curmod = new Module();
    request.getSession().setAttribute(CURRENT_MODULE,curmod);
  }else {
  	curmod = (Module)curmod.clone();
  }

  if(curmod.getId() != null && curmod.getId().equals("rootModule")){
    ErrorModel errmod = new ErrorModel();
    errmod.addError("Please do not change the folder Folders.");
    request.getSession().setAttribute(ERROR_OBJ,errmod);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  curmod.setName(modname);
  curmod.setOwner(modowner);
  curmod.setDescription(moddesc);
  Module parent = mgmt.getModuleFromId(modparent);

  if(parent != null && parent.getId().equals(curmod.getId())){
    ErrorModel errmod = new ErrorModel();
    errmod.addError("You can not set the folder to be its parent.");
    request.getSession().setAttribute(ERROR_OBJ,errmod);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			userContext, AuditConstants.CHANGE, "save/edit folder", AuditConstants.MODULES, "change the folder: " + curmod.getName());
  
  //parent.addMember(curmod);
  try {
    String str =  admin.addModule(curmod,parent,userContext);
    request.getSession().setAttribute(CURRENT_MODULE,curmod);
    response.sendRedirect("addopok.jsp");
  }catch (Exception e){
  	ErrorModel.log.error("Failed to add folder " + curmod + " to parent " + parent,e);
  	ErrorModel errmod = new ErrorModel();
  	errmod.addError("Failed to save folder.");
    request.getSession().setAttribute(ERROR_OBJ,errmod);
    response.sendRedirect("errorpage.jsp");
    return;
  }
%>
