<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.site.main.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@page import="xpolog.eye.error.ErrorModel"%>

<%
 
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  UserContext userContext = UserEnvironment.getUserContext(request);
  
  String ids = request.getParameter("ids");

	boolean success = true;
	String message = "";
  
  if (ids != null && ids.length() > 0){
  	String [] arr = ids.split(",");
  	for (int i = 0; i < arr.length;i++){
  	  ModuleMember curmod = mgmt.getModuleMember(arr[i]);
  	
  	 
  	  String name = "";
  	  if(curmod != null) {
  		  
  		  name = curmod.getName();
  		  
  		  //audit
  		  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  		  			userContext, AuditConstants.CHANGE, "remove folder", AuditConstants.MODULES, "remove the folder: " + name);
  		  try {
  		  Module parent = mgmt.getParentModule(curmod.getId());
  		  if (curmod.getType().equals(Module.MODULE_TYPE)){
  		  	 Module m = mgmt.getModuleFromId(curmod.getId());
  		  	 if (m != null){
  		    	admin.removeModule(m,parent,userContext);
  		  	 }
  		  }else {
  		  	admin.removeLogBrowser(curmod.getId(),parent,userContext);
  		  }
  		 
  		  } catch (Exception e) {
  				ErrorModel.log.error("Failed to remove folder " + name
  						+ " with id " + curmod.getId(), e);
  				success = false;
  				message = e.getMessage();
  			}
  	  }
  	  try {
			  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
				MainViewModel model = env.getMainViewModel();
				model.verify();
  	  } catch (Exception e) {
				ErrorModel.log.error("Failed to verify tabs model ", e);				
			}
  	}
  }else {
		message = "No log id was given, please refresh and try again";
	}
  
  String xml = GridModelActionsHelper.getResultXML(success, message);

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	
	out.write(xml);
	out.flush();
 
%>
