<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.site.main.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@page import="xpolog.eye.error.ErrorModel"%>

<%
  String MODULE_ID = "MODULE_ID";
 
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  UserContext userContext = UserEnvironment.getUserContext(request);
  
  String modid = request.getParameter(MODULE_ID);

  Module curmod = modid == null || modid.length() == 0 ? null : mgmt.getModuleFromId(modid);
	boolean success = true;
	String message = "";
 
  String name = "";
  if(curmod != null) {
	  
	  name = curmod.getName();
	  
	  //audit
	  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	  			userContext, AuditConstants.CHANGE, "remove folder", AuditConstants.MODULES, "remove the folder: " + name);
	  try {
	  Module parent = mgmt.getParentModule(curmod.getId());
	  String str =  admin.removeModule(curmod,parent,userContext);
	  
	  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
		MainViewModel model = env.getMainViewModel();
		model.verify();
	  } catch (Exception e) {
			ErrorModel.log.error("Failed to remove folder " + name
					+ " with id " + modid, e);
			success = false;
			message = e.getMessage();
		}
  }else {
		message = "No log id was given, please refresh and try again";
	}
  
  String xml = GridModelActionsHelper.getResultXML(success, message);

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	
	out.write(xml);
	out.flush();
 
%>
