<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.site.main.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%
  String MODULE_ID = "MODULE_ID";
  String CURRENT_MODULE = "CURRENT_MODULE";
  String CURRENT_LOG = "CURRENT_LOG";

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  UserContext userContext = UserEnvironment.getUserContext(request);
  
  String modid = request.getParameter(MODULE_ID);

  Module curmod = null;
  if(modid == null || modid.trim().equals("")){
    curmod = (Module)request.getSession().getAttribute(CURRENT_MODULE);
  }else{
    curmod = mgmt.getModuleFromId(modid);
  }
  
  String name = "";
  if(curmod == null) {
	  try {
		  ModuleMember member = SiteManagment.getInstance().getModuleMember(modid);
		  if(member != null) {
			  name = member.getName();
		  }
	  }catch(Exception e) {}
  }else {
	  name = curmod.getName();
  }
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			userContext, AuditConstants.CHANGE, "remove folder", AuditConstants.MODULES, "remove the folder: " + name);
  
  Module parent = mgmt.getParentModule(curmod.getId());
  String str =  admin.removeModule(curmod,parent,userContext);
  
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	MainViewModel model = env.getMainViewModel();
	model.verify();
  //request.getSession().setAttribute(CURRENT_MODULE,parent);
  request.getSession().removeAttribute(CURRENT_LOG);
  request.getSession().removeAttribute(CURRENT_MODULE);
  response.sendRedirect("removeopok.jsp");
%>
