<%@ page language="java"%>
<%
response.setContentType("text/xml");
response.setHeader("Pragma-Control", "no-cache");
response.setHeader("Cache-Control", "no-cache");
response.setHeader("Expires", "0");
%>
<Root>
<!-- General -->
<Help id="charsLength" title="Chars Length" width="300" height="60"><![CDATA[This attribute allows you to force the existence of a fixed number of characters in a string, even if there are less characters in the record.]]></Help>
<Help id="trimChars" title="Trim Chars" width="250" height="60"><![CDATA[This attribute allows you to set a char or string to delete from the display of the column value ]]></Help>
<Help id="delimiterChars" title="Delimiter Chars" width="250" height="60"><![CDATA[This attribute allows you to set a char or string to delimit the column]]></Help>
<Help id="uiMessageLength" title="UI Message Length" width="300" height="60"><![CDATA[This attribute allows you to limit the length of data displayed in a specific column. If the data is longer than specified, it will be divided to several lines.]]></Help>
<Help id="optional" title="Optional" width="300" height="60"><![CDATA[An optional string that does not appears in all records. Case This field does not appears in all records,check this check box. ]]></Help>
<Help id="columnType" title="Column Type"><![CDATA[The source column type. For example: <b>Date</b>,<b>Ip</b>,<b>Number</b>...]]></Help>
<Help id="masker" title="Masker" width="250" height="60"><![CDATA[This attribute allows you define the masking of column text]]></Help>
<Help id="maskerRegExp" title="Masker" width="250" height="60"><![CDATA[This attribute allows you to set a regular expression whose matches will be masked]]></Help>

<!-- Date -->
<Help id="dateFormat" title="Date Format" width="330" height="300"><![CDATA[The format that will be used to format the date.<br>For example:<br><b>Text in log </b>2003-05-23 00:24:41,368<br><b>Format </b>yyyy-MM-dd HH:mm:ss,SSS<br><br>Examples of optional identifiers:<br>
<b>MM</b> - numeric month<br>
<b>MMMMM</b> - full textual month<br>
<b>dd</b> - numeric day<br>
<b>EEEEE</b> - full textual day<br>
<b>EEE</b> - textual day<br>
<b>yy</b> - 2 digit year<br>
<b>yyyy</b> - 4 digit year<br>
<b>HH</b> - 24 hour<br>
<b>hh</b> - 12 hour<br>
<b>a</b> - AM/PM marker<br>
<b>mm</b> - minute<br>
<b>ss</b>- second<br>
<b>SSS</b> - millisecond<br>
<b>z</b> - general time zone<br>
<b>Z</b> - RFC 822 time zone<br>
<b>'TEXT'</b> - a constant text that appears in the date string<br>]]></Help>
<Help id="dateDisplayFormat" title="Display Format" width="330" height="300"><![CDATA[The format to display the date. For example:<br><b>Text in log </b>2003-05-23 00:24:41,368<br><b>Display Format </b>yyyy-MM-dd<br><b>Result in the log view </b>2003-05-23<br><br>Examples of optional identifiers:<br>
<b>MM</b> - numeric month<br>
<b>MMMMM</b> - full textual month<br>
<b>dd</b> - numeric day<br>
<b>EEEEE</b> - full textual day<br>
<b>EEE</b> - textual day<br>
<b>yy</b> - 2 digit year<br>
<b>yyyy</b> - 4 digit year<br>
<b>HH</b> - 24 hour<br>
<b>hh</b> - 12 hour<br>
<b>a</b> - AM/PM marker<br>
<b>mm</b> - minute<br>
<b>ss</b>- second<br>
<b>SSS</b> - millisecond<br>
<b>z</b> - general time zone<br>
<b>Z</b> - RFC 822 time zone<br>
<b>'TEXT'</b> - a constant text that appears in the date string<br>]]></Help>
<Help id="dateTimeDiff" title="Time Difference"  width="330" height="80"><![CDATA[Specify time offset in milliseconds. For example, to subtract 5 second from the result in the log view:<br>
<b>Text in log </b>2003-05-23 00:24:<b>41</b>,368<br><b>Time Diff Value </b>-5000<br><b>Result in the log view </b>2003-05-23 00:24:<b>36</b>,368<br>]]></Help>
<Help id="dateLocale" title="Locale"><![CDATA[Specify the locale in which the log was written]]></Help>
<Help id="dateLocaleView" title="Locale View"><![CDATA[Specify the locale in which the log should be displayed]]></Help>
<Help id="5" title=""><![CDATA[]]></Help>
<Help id="6" title=""><![CDATA[]]></Help>

<!-- Priority -->
<Help id="prioritySet" title="Priority" width="330" height="80"><![CDATA[A set of priorities that can appear in a record. All optional priorities should appear as a semi-colon separated list.<br>
For example: <b>DEBUG;INFO;WARN;ERROR;FATAL</b>]]></Help>

<!-- Choice -->
<Help id="choicesSet" title="Choices" width="300" height="80"><![CDATA[A set of strings that can appear in a record. All optional choices should appear as a semi-colon separated list.<br>
For example: <b>RED;GREEN;BLUE</b>]]></Help>

<!-- Timestamp -->
<Help id="timeZoneDisplayFormat" title="Time Zone Display Format" width="330" height="300"><![CDATA[The format to display the time zone. For example:<br><b>Text in log </b>56895633232<br><b>Time Zone Value </b>yyyy/MM/dd<br><b>Result in the log view </b>2007/11/13<br><br>Examples of optional identifiers:<br>
<b>MM</b> - numeric month<br>
<b>MMMMM</b> - full textual month<br>
<b>dd</b> - numeric day<br>
<b>EEEEE</b> - full textual day<br>
<b>EEE</b> - textual day<br>
<b>yy</b> - 2 digit year<br>
<b>yyyy</b> - 4 digit year<br>
<b>HH</b> - 24 hour<br>
<b>hh</b> - 12 hour<br>
<b>a</b> - AM/PM marker<br>
<b>mm</b> - minute<br>
<b>ss</b>- second<br>
<b>SSS</b> - millisecond<br>
<b>z</b> - general time zone<br>
<b>Z</b> - RFC 822 time zone<br>
<b>'TEXT'</b> - a constant text that appears in the date string<br>]]></Help>
<Help id="timeZone" title="Time Zone" width="300" height="60"><![CDATA[This attribute represents a time zone offset.]]></Help>
<Help id="product" title="Product" width="360" height="80"><![CDATA[Convert the timestamp to miliseconds. For example:<br>To conver timestamp represented in seconds, set this value to 1000]]></Help>

<!-- Term -->
<Help id="term" title="Term" width="380" height="100"><![CDATA[A constant string that appears in a record and needs to be displayed in the log view. For example, 
Assuming you have the next two records in your log:<br>
03/07/2005 03:44:56 app1 IP=192.168.11.44 success (where IP is a source IP)<br>
03/07/2005 03:44:57 app2 IP=192.168.12.33 failure (where IP is a destination IP)<br>
The multi-pattern you should use is:<br>
{date,dd/MM/yyyy HH:mm:ss} {<b>term</b>,app1} IP={text:<b>Source IP</b>} {string}<br><br>
{date,dd/MM/yyyy HH:mm:ss} {<b>term</b>,app2} IP={text:<b>Destination IP</b>} {string}<br><br>
This will result in the following view in the log view:<br>
<table border="0" width="100%" cellspacing="0" height="" class="HELP_TEXT" align="left">    
			<tr valign="top">
				<td>
					<table border="0" width="100%" cellspacing="0" height="" class="HELP_TEXT" align="left">    
								<tr valign="top">
											<td>03/07/2005 03:44:56</td><td>app1</td><td>192.168.11.44</td><td style="padding-left:40px">success</td>
								</tr>
					</table>					
				</td>
			</tr>
			<tr valign="top">
					<td>
					<table border="0" width="100%" cellspacing="0" height="" class="HELP_TEXT" align="left">    
									<tr valign="top">
											<td>03/07/2005 03:44:57</td><td>app2</td><td style="padding-left:40px">192.168.12.33</td><td>failure</td>
									</tr>
						</table>										
					</td>
			</tr>
</table>					
]]></Help>
<!-- Free Text -->
<Help id="freeText" title="Free Text" width="390" height="100"><![CDATA[Any text you wish to display in the log view, usually used in multi-pattern logs to distinguish records. For example:<br>
Assuming you have the next records in your log:<br>
03/07/2005 03:44:56 $ success<br>
03/07/2005 03:44:57 % failure<br>
The multi-pattern you should use is:<br>
{date,dd/MM/yyyy HH:mm:ss} {<b>freetext</b>,Dollar}$ {string}<br>
{date,dd/MM/yyyy HH:mm:ss} {<b>freetext</b>,Percentage}% {string}<br>
<b>Note</b> that the freetext tag does not replace any text in the pattern, therefore it could be placed anywhere in the pattern and should not be separated with a space.<br>
This will result in the following view in the log view:<br>
03/07/2005 03:44:56 Dollar success<br>
03/07/2005 03:44:57 Percentage failure ]]></Help>

<!-- Regexp -->
<Help id="refIndx" title="Ref Index" width="300" height="60"><![CDATA[The zero-based index of the source column. The regular expression will be extracted out according to this reference. ]]></Help>
<Help id="refName" title="Ref Name" width="300" height="60"><![CDATA[The name of the source column. The regular expression will be extracted out according to this reference.]]></Help>
<Help id="isMultiLine" title="Multi Line"><![CDATA[Indicates whether the record spreads over more than one line]]></Help>
<Help id="regexpExpression" title="Expression" width="300" height="60"><![CDATA[The regular expression that will be extracted out of the value in the source column.]]></Help>

<!-- Expression (functions) -->
<Help id="functionExpression" title="Expression" width="300" height="60"><![CDATA[The expression that will be used according to the source columns given.For example, assuming you have two columns in your log (from type 'Number'), and you want to create a new column in your log view, represents a combining of these two records:<br>
Column name 1: <b>Cycles</b>.<br>
Column name 2: <b>Runs</b>.<br>
The Expression will be: <b>Cycles + Runs</b>.<br>
]]></Help>

<!-- Converter (map) -->
<Help id="map" title="Converter"><![CDATA[A set of pairs values in witch the second value replace the first one in the log view.<br>For Example:<br>DEBUG=1;INFO=2;WARN=3;ERROR=4;FATAL=5]]></Help>
</Root>