<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.knowledge.*"%>
<%@ page import="xpolog.eye.knowledge.admin.*"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
  if (!xpolog.eye.security.WebSecurityManager.getInstance().checkForPermission(request,response,null,true)){
    return;
  }
  KnowledgeEngine engine = KnowledgeEngine.getInstance();
  KnowledgeConfiguration knowledgeConfig = engine.getKnowledgeConfig();
  KnowledgePackage [] packages = null;
  if (knowledgeConfig != null){
  	packages = knowledgeConfig.getPackages();
  }
  if (packages == null){
  	packages = new KnowledgePackage[0];
  }
  
  String selectedAppId = request.getParameter("appId");
  if (selectedAppId == null || selectedAppId.length() == 0){
  	if (packages.length > 0){
  		selectedAppId = packages[0].getId();
  	}else {
  		selectedAppId = "";
  	}
  }
  
  
  KnowledgePackage selPackage = null;
  if (knowledgeConfig != null && selectedAppId != null && selectedAppId.length() > 0){
  	selPackage = knowledgeConfig.getPackageById(selectedAppId);
  }
  
  KnowledgePackageBuilder builder = (KnowledgePackageBuilder)request.getSession().getAttribute(KnowledgePackageBuilder.KNOWLEDGE_BUILDER_ATT);
  if (builder == null){
  	builder = new KnowledgePackageBuilder(selPackage);
  	builder.init();
  }else if (selPackage == null || builder.getKnowledgePackage() != selPackage){
  	builder.setKnowledgePackage(selPackage);
  	builder.init();
  }
  
  request.getSession().setAttribute(KnowledgePackageBuilder.KNOWLEDGE_BUILDER_ATT,builder);
  
  
  int tabIndex = 0;
  String tabIndexStr = request.getParameter("tabIndex");
  if (tabIndexStr != null && tabIndexStr.length() > 0){
  	try {
  		tabIndex = Integer.parseInt(tabIndexStr);
  	}catch (Exception e){}
  }

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/comps/divsTabs.js" type="text/javascript"></script>
<script>

function changeApplication(combo){
  var selectedIndex = combo.selectedIndex;
  if (selectedIndex >= 0){
    var appId = combo.options[selectedIndex].value;
    this.location = "packageAdmin.jsp?appId=" + appId;
  }
}

var initFunction = new Array();

function init(){
  for (var i = 0; i < initFunction.length;i++){
    eval(initFunction[i]);
  }
}
</script>
</head>

<body onLoad="init()">

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr><td style="padding-left:20">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
     <tr height="10"><td>
  	   <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
		    <tr>
    		  <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Knowledge package settings</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
        </table>
        </td></tr>
	    
		<tr height="10"><td style="padding-top:10"><span class="REGULARTEXT">Package</span>
			<select size="1" name="packageList" id="packageList" onChange="javascript:changeApplication(this)">
			<% for (int i = 0; i < packages.length;i++){ 
					String selected = packages[i] == selPackage ? "selected" : "";			
			%>
			<option value="<%=packages[i].getId()%>" <%=selected%>><%=packages[i].getName()%></option>
			<%} %>
			</select>
		</td></tr>
	
		<tr height="10"><td valign="top" style="padding-top:10">
		  	   <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr>                
                <td width="*" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">                
                <script>
                  var packageTabs = createDefaultApplicationTabs("packageTabs");
                  packageTabs.addTab("SyntaxHandler","<nobr>Syntax handler</nobr>","packageSyntaxAdminDiv");
                  packageTabs.addTab("Repository","<nobr>Repository</nobr>","packageRepAdminDiv");
                  packageTabs.addTab("Test","<nobr>Knowledge Test</nobr>","testAdminDiv");
                  packageTabs.addTab("patternTest","<nobr>Pattern Test</nobr>","patternTestAdminDiv");
                </script>
                <tr>
                    <td width="100%">  
                    <script>
                    	tabsInLine = 8;
                    	packageTabs.writeTabs();
                    </script> 
                   </td>
                  </tr>  
                  <tr>
                    <td width="100%" style="padding-top:5;padding-left:10" valign="top">   
                      <div id="packageSyntaxAdminDiv" style="display:none">
                     		<jsp:include page="packageSyntaxAdmin.jsp" flush="true">
                     		<jsp:param name="appId" value="<%=selectedAppId%>" />
                     		</jsp:include>
                      </div>
                      <div id="packageRepAdminDiv" style="display:none">
                     		<jsp:include page="packageRepositoryAdmin.jsp" flush="true">
                     		<jsp:param name="appId" value="<%=selectedAppId%>" />
                     		</jsp:include>
                      </div>
                      <div id="testAdminDiv" style="display:none">
                     		<jsp:include page="packageTestAdmin.jsp" flush="true">
                     		<jsp:param name="appId" value="<%=selectedAppId%>" />
                     		</jsp:include>
                      </div>
                      <div id="patternTestAdminDiv" style="display:none">
                     		<jsp:include page="patternTestAdmin.jsp" flush="true"/>
                      </div>
                    </td>
                    </tr>
                  <tr>
                    <td height="*">
                    &nbsp;</td>
                  </tr>
                   <script>                 
                  packageTabs.selectTabByIndex(<%=tabIndex%>);
                  </script>
                  </table>
              </td></tr>
              </table>
		</td></tr>
	
		<tr height="*"><td><span class="SMALLTEXT">
		&nbsp;</span>
		</td></tr>
	</table>
</td></tr>
</table>
</body>
</html>