<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="java.util.*"%>
<%@page import="xpolog.eye.template.TemplateManager"%>
<%@page import="xpolog.eye.template.Template"%>
<%@page import="xpolog.eye.media.Account"%>
<%@page import="xpolog.eye.media.AddressBook"%>
<%@page import="xpolog.eye.media.AddressFilter"%>
<%@page import="xpolog.eye.media.telsh.TelnetAccountFilter"%>
<%@page import="xpolog.eye.media.auth.win.WinAuthenticationAccountFilter"%>
<%@page import="xpolog.tools.XpologSystemInfo"%>
<%@page import="xpolog.eye.site.portal.PortalItem"%>

<%!
	static final String BASE_DIRECTORY = "";
%>
<%

	final String START_PAGE_STATUS = "start";
	final String ADMIN_PAGE_STATUS = "admin";
	final String CURRENT_PAGE_STATUS = "currentPageStatus	";
	
	WebSecurityManager securityManager = WebSecurityManager.getInstance();
	if (!securityManager.checkForPermission(request,response,null,true)){
	  return;
	}

	String currentSliderStatus = (String)request.getSession().getAttribute(CURRENT_PAGE_STATUS);
	if(currentSliderStatus == null || currentSliderStatus.length() == 0){
		currentSliderStatus = START_PAGE_STATUS;
	}
  boolean isSiteDemo = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("isSiteDemo",false);
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  Module root = mgmt.getModuleFromId("rootModule");
  UserSecurity user = securityManager.getUserSecurity(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  boolean isPermittedAddLog = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_LOG_PERMISSION);
  boolean isPermittedAddModule = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_MODULE_PERMISSION);
  boolean isPermittedSettings = securityManager.isHavePermission(userContext,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION);
  boolean haveQuickStart = isPermittedAddLog || isPermittedAddModule;
  
  boolean isPermittedAddVerify = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_VERIFY_PERMISSION);
  boolean isPermittedEditVerify = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.EDIT_VERIFY_PERMISSION);
  boolean isPermittedVerify = isPermittedAddVerify || isPermittedEditVerify;
  boolean isPermittedViewReports = securityManager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION);
  boolean isPermittedAddReports = securityManager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.EDIT_REPORTS_PERMISSION);
  boolean isPermittedReports = isPermittedViewReports || isPermittedAddReports;
  boolean isPermittedEnvironmentAnalysis = securityManager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION);
  boolean isPermittedViewLogCollection = securityManager.isHavePermission(userContext,ActionsPermissionConstants.LogCollectionPermissions.VIEW_LOG_COLLECTION_PERMISSION);
  boolean isPermittedAddLogCollection = securityManager.isHavePermission(userContext,ActionsPermissionConstants.LogCollectionPermissions.EDIT_LOG_COLLECTOR_PERMISSION);
  boolean isPermittedLogCollection = isPermittedViewLogCollection || isPermittedAddLogCollection;

 
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  env.setUsePage("logEyePortal.jsp");

   boolean valid = SiteManagment.getInstance().getXpologManagment().isValidToBeActive();
  boolean isDemo = XpologLicenseManager.getInstance().isDemo();
  int daynum = XpologLicenseManager.getInstance().getDaysLeft();
  boolean allowed = false;
  boolean perm = XpologLicenseManager.getInstance().isPermanentLicense();

  boolean secureActive = false;
  String userMessage = "";
  String activeState = "inactive";
  if(user != null){
    secureActive = true;
    userMessage = "Hello "+user.getUser().getDisplayName();
    activeState = "active";
  }

  Properties prop = Configuration.getInstance().getUIData();
  String userImg = prop.getProperty("gate.users.icon.image");
  String logoImg = prop.getProperty("gate.logo.image");
  String lockImg = prop.getProperty("gate.security.secure.image");
  String unlockImg = prop.getProperty("gate.security.unsecure.image");
  int ALLOWED_LOG_NAME_LENGTH = 30;

  /*boolean toShowXpoLogAsService = false;
  String xpologAsService = Configuration.getInstance().getXpologAsService();
  //check if xpolog is not war, and it is the first time of system.
  if(xpologAsService != null && xpologAsService.equals("firstTime") && !Configuration.isWar()) {
  	toShowXpoLogAsService = true;
  	Configuration.getInstance().setXpologAsService("uninstalledAsService");
  	Configuration.getInstance().saveConfiguration();
  }*/
  String refreshMenuStr = request.getParameter("refreshMenu");
  boolean refreshMenu = (refreshMenuStr!=null && refreshMenuStr.equals("true"));
  
  boolean isWindows = XpologSystemInfo.isWindows();
  
  boolean isTestingBuid = SiteManagment.getInstance().isTestingBuild();
  	
  ArrayList list = new ArrayList();
  if(isTestingBuid && isPermittedEnvironmentAnalysis) {
  	list.add(new PortalItem("Testing<br>Environments","testingPortal.jsp","Testing Environments","images/portal/btns/diagnostics.gif","images/portal/btns/diagnostics-on.gif"));
  	list.add(PortalItem.SEP_ITEM);
  }
  list.add(new PortalItem("Log <br>Viewer","view/mainView.jsp","Log Viewer","images/portal/btns/log-viewer.gif","images/portal/btns/log-viewer-on.gif"));
  list.add(PortalItem.SEP_ITEM);
	list.add(new PortalItem("Log <br>Monitor","monitor/monitorsView.jsp","Log Monitor","images/portal/btns/log-monitor.gif","images/portal/btns/log-monitor-on.gif"));
  if (isPermittedReports){
    list.add(PortalItem.SEP_ITEM);
    list.add(new PortalItem("Reports","reports/reportsDefinitionView.jsp","Reports","images/portal/btns/reports.gif","images/portal/btns/reports-on.gif"));
  }
  if(!isTestingBuid && isPermittedEnvironmentAnalysis) {
  	list.add(PortalItem.SEP_ITEM);
  	list.add(new PortalItem("Environment<br>Analysis","reports/reportsDefinitionView.jsp?isEnvironmentAnalysis=true","Environment Analysis","images/portal/btns/diagnostics.gif","images/portal/btns/diagnostics-on.gif"));
  }
  if (isPermittedLogCollection){
  	list.add(PortalItem.SEP_ITEM);
  	list.add(new PortalItem("Log <br>Collection","logcollection/logCollectionsView.jsp","Log Collection","images/portal/btns/collection.gif","images/portal/btns/collection-on.gif"));
  }
   
  request.setAttribute("mainItems",list);
  
  list = new ArrayList();
  if (valid){
    if (isPermittedAddLog){
      list.add(new PortalItem("Add Log","loggers/admin/logAdminGate.jsp","Add Log","images/portal/btns/small/add-log.gif","images/portal/btns/small/add-log-on.gif"));
      if (isPermittedAddModule){
        list.add(new PortalItem("Add Logs Directory","wizards/common/wizardStarter.jsp?wizardPath=scanner","Add Log Directory","images/portal/btns/small/add-log-dir.gif","images/portal/btns/small/add-log-dir-on.gif"));
        list.add(new PortalItem("Application Detection Wizard","javascript:openWizard('" + BASE_DIRECTORY + "')","Run Detection Wizard","images/portal/btns/small/wizard.gif","images/portal/btns/small/wizard-on.gif"));
      }
    }
    if (isPermittedAddVerify){
      list.add(new PortalItem("Create Monitor","monitor/monitorDefinition.jsp","Create Monitor","images/portal/btns/small/create-monitor.gif","images/portal/btns/small/create-monitor-on.gif"));
    }
    if (isPermittedAddReports){
      list.add(new PortalItem("Generate Report","reports/agg/aggReportDefinition.jsp?reportTemplateId=Aggregation","Generate Report","images/portal/btns/small/generate-report.gif","images/portal/btns/small/generate-report-on.gif"));
    }
    if (isPermittedAddLogCollection){
    	list.add(new PortalItem("Create Log Collector","logcollection/admin/log/logCollectionDefinition.jsp","Create Log Collector","images/portal/btns/small/collect-logs.gif","images/portal/btns/small/collect-logs-on.gif"));
    }
    if (isPermittedSettings){
      list.add(new PortalItem("Settings","settings/mailset.jsp","Settings","images/portal/btns/small/settings.gif","images/portal/btns/small/settings-on.gif"));
    }
  
    request.setAttribute("adminItems",list);
  
    list = new ArrayList();
    if (securityManager.isHavePermission(userContext,ActionsPermissionConstants.DataSupportPermissions.METADATA_PERMISSION)){
      list.add(new PortalItem("Create Application","metadata/applicationDefinition.jsp?appId=","Add Application Information"));
    }
    if (securityManager.isHavePermission(userContext,ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){
      list.add(new PortalItem("Add Account","tools/addresses/addressview.jsp?openAccountType=true","Add Account"));
    }
    if (securityManager.isHavePermission(userContext,ActionsPermissionConstants.AutomationPermissions.VIEW_TASK_PERMISSION) &&
    		securityManager.isHavePermission(userContext,ActionsPermissionConstants.AutomationPermissions.EDIT_TASK_PERMISSION)){
      list.add(new PortalItem("Add Task","tasks/xpotasksview.jsp?openTaskType=true","Add Task"));
    }
    if (isPermittedAddLog && isPermittedAddModule){
    	list.add(new PortalItem("View Wizards","wizards/wizardsview.jsp","View Wizards"));
    }
    request.setAttribute("linksItems",list);
  }
  String titleMsg = "XpoLog Manager";
  if(isSiteDemo) {
	  titleMsg="XpoLog Manager &nbsp;&nbsp;<a href=\"http://www.xplg.com/home/downloads/index.jsp\" class=\"HELP_HEADER_LINK\" target=\"_target\">Download free trial from www.xplg.com</a>";
  }
%>

<HTML>
<HEAD>

<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/portal.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/portal.js"></script>
</HEAD>
<BODY style="margin: 0; padding: 0; border-width: 0;overflow:auto">
<jsp:include page="portal/portal.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
<jsp:param name="title" value="<%=titleMsg %>" />
</jsp:include>
</BODY>
</HTML>