<%@ page import="java.text.*"%>
<%@ page import="java.util.*"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.RecordMask"%>
<%@ page import="xpolog.eye.data.util.FileFilterConfiguration"%>

<%@ include file="../../tools/sandf/dateFilterAction.jsp"%>

<%!
public FileFilterConfiguration createFileFilterConfiguration(HttpServletRequest request,HttpServletResponse response) throws Exception {
	FileFilterConfiguration fileFilterConfiguration = null;
	String fileSizeOpStr = request.getParameter("fileSizeOp");
	int fileSizeOp = (fileSizeOpStr != null && !fileSizeOpStr.equals("") ? Integer.parseInt(fileSizeOpStr) : -1);
	String fileSizeStr = request.getParameter("fileSize");
	NumberFilter numberFilter = null;
	DateFilter dateFilter = null;
	String filesLimitStr = request.getParameter("filesLimit");
	int filesLimit = -1;
	
	try {
		numberFilter = new NumberFilter(fileSizeStr, fileSizeOp, 0);
	}catch (NumberFormatException e){
		if(fileSizeStr != null && !fileSizeStr.equals("")) {
			throw new NumberFormatException("A numeric file size must be specified.");
		}
	}
	
	try {
		String timeText = request.getParameter("TimeText");
		if(timeText != null && !timeText.equals("")) {
			dateFilter = new DateFilter();  
			RecordMask mask = new RecordMask();
			DateMask dateMask = new DateMask("MM/dd/yyyy HH:mm:ss");
			MaskColumn[] cols = {dateMask};
			mask.setColumns(cols);	
			dateFilter = createDateFilter(request,response,mask);	
		}
	}catch (Exception e){
		throw e;
	}
	
	try {
		filesLimit = (filesLimitStr != null && !filesLimitStr.equals("") ? Integer.parseInt(filesLimitStr) : -1)	;
	}catch(Exception e) {
		throw new NumberFormatException("A numeric number of files must be specified.");
	}
	
	fileFilterConfiguration = new FileFilterConfiguration();
  fileFilterConfiguration.setNumberFilter(numberFilter);
  fileFilterConfiguration.setDateFilter(dateFilter);
  fileFilterConfiguration.setFilesLimit(filesLimit);
  
	return fileFilterConfiguration;
}
%>