<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.LogCollectionManager"%>
<%@ page import="com.xpolog.logcollection.admin.builders.CollectionUnitBuilder"%>
<%@ page import="com.xpolog.logcollection.admin.helpers.ReaderAdapterHelper"%>
<%@ page import="com.xpolog.logcollection.collection.SourcePolicy"%>
<%@ page import="com.xpolog.logcollection.data.writers.FilePacketWriter"%>
<%@ page import="com.xpolog.logcollection.system.LogCollectionSystemManager"%>

<%@ page import="xpolog.eye.automation.tasks.XpoTask"%>
<%@ page import="xpolog.eye.automation.tasks.mail.MailTask"%>
<%@ page import="xpolog.eye.logcollection.adapters.XpologCollectionAdapter"%>

<%@ page import="java.util.List"%>

<%!static final String BASE_DIRECTORY = "../../../";%>

<%
	String BUILDER = "CURRENT_COLLECTION_UNIT_BUILDER";
		
	CollectionUnitBuilder builder = (CollectionUnitBuilder)request.getSession().getAttribute(BUILDER);
	if (builder == null){
		return;
	}
	

  String COLLECTOR_PACKET_WRITER_ID = "collectorPacketWriter";
  String DEFAULT_COLLECTOR_PACKET_WRITER_ID = "defaultCollectorPacketWriter";
  String COLLECTOR_SOURCE_POLICY_ID = "collectorSourcePolicy";
  
  String SUFFIX = "logCollectionAdmin";

	LogCollectionSystemManager sysMgr = LogCollectionManager.getInstance().getSystemMgr();

	XpologCollectionAdapter ca = null;
	FilePacketWriter packetWriter = null;
	SourcePolicy sourcePolicy = null;
  ca = (XpologCollectionAdapter)builder.getCurrentCollectionAdapter();
  if (ca != null){
  	packetWriter = ReaderAdapterHelper.getFilePacketWriter(ca);
  	sourcePolicy = ca.getSourcePolicy();
  }
  if (packetWriter == null){
  	packetWriter = (FilePacketWriter)sysMgr.getDefaultPacketWriter();
  }
  if (packetWriter != null){
  	request.setAttribute(COLLECTOR_PACKET_WRITER_ID,packetWriter);
  }
  
  if (sourcePolicy == null){
  	sourcePolicy = sysMgr.getSourcePolicy();
  }
	if (sourcePolicy != null){
		request.setAttribute(COLLECTOR_SOURCE_POLICY_ID,sourcePolicy);
	}
  
	MailTask mailTask = null;
	String mailTo = "";
	List tasks = ca != null ? ca.getTasks() : null;
	if (tasks != null && tasks.size() > 0) {
		XpoTask task = (XpoTask) tasks.get(0);
		if (task instanceof MailTask) {
			mailTask = (MailTask) task;
			if (mailTask != null) {
				mailTo = mailTask.getToId();
			}
		}
	}
	if (mailTo == null || mailTo.length() == 0){
		mailTo = sysMgr.getMailRecipients();
	}
	if (mailTo == null){
		mailTo = "";
	}
	
  
  String rotationPolicy = request.getParameter("rotationPolicy");
  if (rotationPolicy == null){
  	rotationPolicy = "";
  }
  
	FilePacketWriter pw = (FilePacketWriter)sysMgr.getDefaultPacketWriter();
	request.setAttribute(DEFAULT_COLLECTOR_PACKET_WRITER_ID,pw);
%>
<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
	<tr>
		<td style="vertical-align:top;padding-top:10px">
			<div id="advancedSettingsDiv">
			<jsp:include page="../../../logcollection/common/filePacketWriterAdvanced.jsp">
				<jsp:param name="packetWriterId" value="<%=COLLECTOR_PACKET_WRITER_ID%>"/>
				<jsp:param name="defaultPacketWriterId" value="<%=DEFAULT_COLLECTOR_PACKET_WRITER_ID%>"/>
				<jsp:param name="sourcePolicyId" value="<%=COLLECTOR_SOURCE_POLICY_ID%>"/>
				<jsp:param name="suffix" value="<%=SUFFIX%>"/>
				<jsp:param name="showDefault" value="true"/>
				<jsp:param name="rotationPolicy" value="<%=rotationPolicy%>"/>
				<jsp:param name="mailTo" value="<%=mailTo%>"/>
			</jsp:include>
			</div>
		</td>
	</tr>
	<tr height="100%">
		<td>&nbsp;</td>
	</tr>

</table>