<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.admin.builders.CollectionUnitBuilder"%>
<%@ page import="xpolog.eye.logcollection.admin.builders.CollectionUnitJobBuilder"%>

<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.automation.tasks.mail.MailTask"%>
<%@ page import="xpolog.eye.automation.tasks.XpoTask"%>

<%@ page import="java.util.*"%>

<%!static final String BASE_DIRECTORY = "../../../";
%>
<%
	String BUILDER = "CURRENT_COLLECTION_UNIT_BUILDER";

	CollectionUnitBuilder builder = (CollectionUnitBuilder)request.getSession().getAttribute(BUILDER);
	if (builder == null){
		return;
	}
	
	
	String suffix = "LogCollectionSched";
	String name = "logCollectionScheduler";
	String id = "cuId_" + System.currentTimeMillis();
	
	XpoScheduledOperation schedOp = builder.getSchedOp();
	CollectionUnitJobBuilder jobBuilder = new CollectionUnitJobBuilder();
	if (schedOp != null){
	  jobBuilder = new CollectionUnitJobBuilder(schedOp);
	  jobBuilder.updateFromOp();
	  name = jobBuilder.getName();
	  id = jobBuilder.getId();
	}			
	request.setAttribute("CURRENT_JOB",jobBuilder);
	request.setAttribute("ONLY_SCHEDULING","true");
	request.setAttribute("suffix",suffix);
	
	MailTask mailTask = null;
	List tasks = null;//builder.getTasks();
	if (tasks != null && tasks.size() > 0){
		XpoTask task = (XpoTask)tasks.get(0);
		if (task instanceof MailTask){
			mailTask = (MailTask)task;
		}
	}
	String mailTo = "";
	String mailSubject = "";
	if (mailTask != null){
		mailTo = mailTask.getToId();
		mailSubject = mailTask.getSubject();
	}
%>



<input type="hidden" name="Name<%=suffix%>" value="<%=name%>">
<input type="hidden" name="Id<%=suffix%>" value="<%=id%>">
<input type="hidden" name="actionId<%=suffix%>" value="0">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>
		<td style="padding-top:20px;padding-right:10px">
			<jsp:include page="../../../scheduler/newScheduler.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
			</jsp:include>
		</td>
	</tr>
</table>
