<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.collection.adapters.services.syslog.kiwi.*"%>

<%@ page import="xpolog.eye.site.*"%>
<%@page import="com.xpolog.logcollection.collection.adapters.services.syslog.Facility"%>
<%@page import="com.xpolog.logcollection.collection.adapters.services.syslog.Priority"%>


<%!
  static final String BASE_DIRECTORY = "../../../../";
%>


<%
	String baseDirectory = request.getParameter("baseDirectory");
	if(baseDirectory == null || baseDirectory.length() == 0) {
		baseDirectory = BASE_DIRECTORY;
	}
	
	String scriptsOnlyStr = request.getParameter("scriptsOnly");
	boolean scriptsOnly = scriptsOnlyStr != null && scriptsOnlyStr.equals("true");
	
	String noScriptsStr = request.getParameter("noScripts");
	boolean noScripts = noScriptsStr != null && noScriptsStr.equals("true");
	
	String embeddedStr = request.getParameter("embedded");
	boolean embedded = embeddedStr != null && embeddedStr.equals("true");
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String prioritiyFilterLabel = request.getParameter("prioritiyFilterLabel");
	if (prioritiyFilterLabel == null || prioritiyFilterLabel.length() == 0){
		prioritiyFilterLabel = "Priority";
	}
	
	String onlyUpdateStr = request.getParameter("onlyUpdate");
	boolean onlyUpdate = onlyUpdateStr != null && onlyUpdateStr.equals("true");
	
	String ERROR_OBJ = "ERROR_OBJ";
	String SEQ = "seq";
	String KIWI_RULE = "KIWI_RULE";
	
	KiwiRule rule = (KiwiRule)request.getSession().getAttribute(KIWI_RULE);
	String seq = request.getParameter(SEQ);
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	String name = "";
	
	KiwiPriorityFilter filter = null;
	if(seq != null){
		filter = (KiwiPriorityFilter)rule.getFilter(seq); 
	}else{
		seq = "";
	}
	if(filter != null){
		name = filter.getEntryName();
		seq = filter.getSeq();
	}
	
	KiwiKeysConfiguration keysConf = KiwiConfigurationManager.getInstance().getKiwiKeysConf();
	Facility[] facilities = keysConf.getFacilities();
	Priority[] priorities = keysConf.getPrioritiesOrdered();
	
%>

<%if (!embedded){%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<style type="text/css">
a.PRIORITY_FILTER_BUTTON:link {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
a.PRIORITY_FILTER_BUTTON:visited {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
a.PRIORITY_FILTER_BUTTON:active {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
a.PRIORITY_FILTER_BUTTON:hover {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
</style>
<%} %>

<%if (!noScripts){%>
<script>
	function selectAllPriorities(all){
		for (var i=0; i<<%=facilities.length%>; i++){
			for (var j=0; j<<%=priorities.length%>; j++){
				var cbName = i + "-" + j + "<%=suffix%>";
				var cb = document.getElementById(cbName);
				if (cb){
					if (all){
						cb.checked = true;
					}else{
						cb.checked = false;
					}
				}
			}
		}
	}
	
</script>
<%}%>
<%if (!embedded){%>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<%}%>
<%if (!scriptsOnly){%>
<%if (!onlyUpdate){%>
<input type="hidden" name="filterSeq<%=suffix%>" size="50" value="<%=seq%>">
<%}%>
<%if (!onlyUpdate){%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
		<td id="taskDescriptionTD<%=suffix%>">
<%}%>  
		<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
			<%if (!embedded){%>
			<tr>
				<td style="padding-bottom:10;"><span class="REGULARTEXT"><%=prioritiyFilterLabel%></span></td>
			</tr>
			<%}%>
 			<tr>
				<td style="padding-top:10;padding-bottom:10;padding-left:30px;background-color:#E4E4E4">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" >
					<tr>
						<td>
							<span class="REGULARTEXT">Priority Filter Details</span>
						</td>
					</tr>
					<tr>
						<td style="padding-top:15px">
							<table border="0" cellpadding="0" cellspacing="0" width="100%" >
								<tr>
									<td width="100" nowrap><span class="REGULARTEXT">Name</span></td>
									<td width="*">
										<input class="TEXTBOX" type="text" name="name<%=suffix%>" size="50" value="<%=name%>">
									</td>
								</tr>
								
								<tr>
									<td colspan="2">
										<table border="0" cellspacing="0" height="100%" cellpadding="0">
											<tr>
												<td>
													<jsp:include page="../../../../common/ctrlButton.jsp" flush="true">
													<jsp:param name="base_directory" value="<%=baseDirectory%>"/>
													<jsp:param name="name" value="Select All"/>
													<jsp:param name="action" value="javascript:selectAllPriorities(true)"/> 
													<jsp:param name="buttonClass" value="PRIORITY_FILTER_BUTTON"/>
													</jsp:include>			
												</td>
												<td style="padding-left:10">
													<jsp:include page="../../../../common/ctrlButton.jsp" flush="true">
													<jsp:param name="base_directory" value="<%=baseDirectory%>"/>
													<jsp:param name="name" value="Unselect All"/>
													<jsp:param name="action" value="javascript:selectAllPriorities(false)"/> 
													<jsp:param name="buttonClass" value="PRIORITY_FILTER_BUTTON"/>
													</jsp:include>			
												</td>
											</tr>
										</table>
									</td>
								</tr>								
								<tr>
									<td colspan="2" style="padding-top:10px">
									<table border="1" cellpadding="0" cellspacing="0" width="100%">
									<%
									for (int i=0; i<facilities.length; i++){
										if (i == 0){
									%>
										<tr>
											<td>&nbsp;</td>
										<%
											for (int j=0; j<priorities.length; j++){
										%>
											<td align="center"><span class="REGULARTEXT"><%=priorities[j].getName()%></span></td>
										<%}%> 
										</tr>
										<%}%>

										<tr align="left">
											<td><span class="REGULARTEXT" style="padding-left:3px"><%=facilities[i].getName()%></span></td>
										<%
										for (int j1=0; j1<priorities.length; j1++){
											boolean used = filter != null && filter.hasPriorityForFacility(facilities[i].getName(),priorities[j1].getName());
											String checked = used ? "checked" : "";
											String cbName = i + "-" + j1 + suffix;
										%>
											<td align="center">
												<input class="CHECKBOX" type="checkbox" name="<%=cbName%>" id="<%=cbName%>" <%=checked%> value="true">
											</td>
									<%} //end priorities loop%>
									</tr>
									<%} //end facilities loop%>
									</table>
									</td>
								</tr>
							</table>
						</td>
					</tr>
					<%if (!embedded){ %>
					<tr>
						<td>
						<table border="0" cellpadding="0" cellspacing="0" width="101%" >
							<tr>
								<td width="25%">&nbsp;</td>
								<td width="13%">
								<p align="center">&nbsp;</td>
								<td width="11%"><a href="javascript:history.go(-1)" class="LINK">cancel</a></td>
								<td width="11%"><a href="javascript:doSave()" class="LINK">save</a></td>
								<td width="35%">&nbsp;</td>
							</tr>
						</table>
						</td>
					</tr>
					<%} %>
				</table>
				</td>
			</tr>
		</table>
<%if (!onlyUpdate){%>
		</td>
	</tr>
	<tr height="100%">
		<td>&nbsp;</td>
	</tr>
</table>
<%}%>
<%}%>
<%if (!embedded){%>
</form>
</body>
</html>
<%}%>