<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.collection.adapters.services.syslog.kiwi.*"%>

<%@ page import="xpolog.eye.error.ErrorModel"%>

<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	String KIWI_RULE = "KIWI_RULE";

	KiwiRule rule = (KiwiRule)request.getSession().getAttribute(KIWI_RULE);
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String prefix = request.getParameter("prefix");
	if (prefix == null){
		prefix = "";
	}
	
	String filterType = request.getParameter("filterType");
	
	ErrorModel errModel = new ErrorModel();
	KiwiPriorityFilter filter = null;
	if (filterType != null && filterType.equals(KiwiPriorityFilter.KIWI_PRIORITY_FILTER_TYPE)){
		filter = KiwiHelper.createPriorityFilter(request,errModel);
	}
	
	String resultStr = "";
	if (filter == null){
		if (errModel.getErrorCount() > 0){
			StringBuffer errBuffer = new StringBuffer();
			String[] errors = errModel.getErrors();
			for (int i=0; i<errors.length; i++){
				if (errBuffer.length() > 0){
					errBuffer.append("#");
				}
				errBuffer.append(errors[i]);
			}
			resultStr = "SAVE_RULE_FILTER_ERROR#" + errBuffer.toString();
		}else{
			resultStr = "SAVE_RULE_FILTER_ERROR#Failed to save rule filter";
		}
	}else{
		rule.addFilter(filter);
		resultStr = filter.getEntryName() + "*" + filter.getSeq();
	}
	
	response.setContentType("text/xml");
	out.write(resultStr.trim());
	out.flush();
%>