<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.CollectionUnit"%>
<%@ page import="com.xpolog.logcollection.CollectionUnitsManager"%>
<%@ page import="com.xpolog.logcollection.LogCollectionManager"%>
<%@ page import="xpolog.eye.logcollection.XpologCollectionUnitAdminRequest"%>
<%@ page import="com.xpolog.logcollection.collection.adapters.services.syslog.Syslog"%>
<%@ page import="com.xpolog.logcollection.collection.adapters.services.syslog.SyslogsManager"%>
<%@ page import="com.xpolog.logcollection.util.constants.Constants"%>

<%@ page import="xpolog.eye.logcollection.admin.helpers.SyslogCollectionHelper"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>

<%!static final String BASE_DIRECTORY = "../../../";%>

<%
	String SUFFIX = "logCollectionAdmin";

  LogCollectionManager logCollectionMgr = LogCollectionManager.getInstance();
  CollectionUnitsManager cuMgr = logCollectionMgr.getCollectionUnitsManager();
 	
  String syslogId = request.getParameter("syslogId");
  Syslog syslog = null;
  SyslogsManager syslogsMgr = SyslogsManager.getInstance();
  syslog = syslogId != null ? syslogsMgr.getSyslog(syslogId) : null;
  if (syslog == null && syslogId != null && syslogId.equals(SyslogsManager.DEFAULT_SYSLOG_ID)){
  	syslog = syslogsMgr.createDefaultSyslog();
  }
	String xml = "";
  ErrorModel errmodel = new ErrorModel();
  
  String lastCuId = "";
  if (syslog != null){
   	CollectionUnit[] selectorsCus = SyslogCollectionHelper.createCollectionUnits(request,SUFFIX,errmodel);
   	if (selectorsCus != null && selectorsCus.length > 0){
   		XpologCollectionUnitAdminRequest saveRequest = new XpologCollectionUnitAdminRequest(Constants.Actions.SAVE);
   		UserContext userContext = UserEnvironment.getUserContext(request);
   		saveRequest.setUserContext(userContext);
  		for (int i=0; i<selectorsCus.length; i++){
  			syslog.addCollectionUnit(selectorsCus[i].getId());
  			cuMgr.saveCollectionUnit(selectorsCus[i], saveRequest);
  			lastCuId = selectorsCus[i].getId();
  		}
  	}
  	syslogsMgr.initDefaultWindowsSyslogConfiguration();
  	syslogsMgr.addSyslog(syslog);
  	syslogsMgr.save();
		xml = GridModelActionsHelper.getResultXML(true, lastCuId);
	}else{
		xml = GridModelActionsHelper.getResultXML(false, "No syslog found with id " + syslogId);
	}
  
  if (errmodel.getErrorCount() > 0){
		String[] errors = errmodel.getErrors();
		StringBuffer sb = new StringBuffer();
		for (int i=0; i<errors.length; i++){
			if (sb.length() > 0){
				sb.append("*;*");
			}
			sb.append(errors[i]);
		}
		String message = sb.toString();
		//params
		String[] params = errmodel.getErrorParams();
		sb = new StringBuffer();
		for (int i=0; i<params.length; i++){
			if (sb.length() > 0){
				sb.append("*;*");
			}
			sb.append(params[i]);
		}
		String paramsList = sb.toString();
		xml = GridModelActionsHelper.getResultXML(false, message, paramsList);
  }
  
	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	out.write(xml);
	out.flush();
%>