<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.collection.adapters.services.syslog.*"%>

<%@ page import="xpolog.eye.error.ErrorModel"%>

<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	SyslogConfEntry rule = null;
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String prefix = request.getParameter("prefix");
	if (prefix == null){
		prefix = "";
	}
	
	String action = request.getParameter("action");
	boolean add = true;
	boolean delete = false;
	if (action != null && action.equals("delete")){
		add = false;
		delete = true;
	}
	
	ErrorModel errModel = new ErrorModel();
	if (add){
		rule = SyslogHelper.createSyslogConfEntry(request,errModel);
		if (rule != null){
			SyslogsManager syslogsMgr = SyslogsManager.getInstance();
			syslogsMgr.initDefaultWindowsSyslogConfiguration();
		}
	}else if (delete){
		SyslogHelper.deleteSyslogConfEntry(request,errModel);
	}
	
	String resultStr = "";
	if (add){
		if (errModel.getErrorCount() > 0){
			StringBuffer errBuffer = new StringBuffer();
			String[] errors = errModel.getErrors();
			for (int i=0; i<errors.length; i++){
				if (errBuffer.length() > 0){
					errBuffer.append("#");
				}
				errBuffer.append(errors[i]);
			}
			resultStr = "SAVE_RULE_SELECTOR_ERROR#" + errBuffer.toString();
		}else if (rule == null){
			resultStr = "SAVE_RULE_SELECTOR_ERROR#Failed to save rule filter";
		}
	}
	
	response.setContentType("text/xml");
	out.write(resultStr.trim());
	out.flush();
%>