<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.locations.db.DbLocationInfo"%>
<%@ page import="com.xpolog.logcollection.locations.files.patterns.DatePattern"%>
<%@ page import="com.xpolog.logcollection.locations.files.patterns.FileNamePattern"%>
<%@ page import="com.xpolog.logcollection.locations.files.patterns.FileSeqIdPattern"%>
<%@ page import="com.xpolog.logcollection.locations.LocationInfoConstraints"%>
<%@ page import="com.xpolog.logcollection.util.constants.Constants"%>

<%@ page import="xpolog.eye.media.db.DBAccount"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	String prefix = request.getParameter("prefix");
	if (prefix == null){
		prefix = suffix;
	}
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = BASE_DIRECTORY;
	}
	
	String locationIndexStr = request.getParameter("locationIndex");
	int locationIndex = 0;
	if (locationIndexStr != null && locationIndexStr.length() > 0){
		locationIndex = Integer.parseInt(locationIndexStr);
	}
	String collectionSettingsDesc = request.getParameter("collectionSettingsDesc");
	if (collectionSettingsDesc == null || collectionSettingsDesc.length() == 0){
		collectionSettingsDesc = "Collection Settings";
	}
	String targetDbTableDesc = request.getParameter("targetDbTableDesc");
	if (targetDbTableDesc == null || targetDbTableDesc.length() == 0){
		targetDbTableDesc = "Target database table";
	}
	String locationInfoId = request.getParameter("locationInfoId");
	String showConstraintsStr = request.getParameter("showConstraints");
	boolean showConstraints = showConstraintsStr != null && showConstraintsStr.equals("true");
	String defaultLocationInfoId = request.getParameter("defaultLocationInfoId");
	String showDefaultStr = request.getParameter("showDefault");
	boolean showDefault = showDefaultStr != null && showDefaultStr.equals("true");
	String showCheckBoxStr = request.getParameter("showCheckBox");
	boolean showCheckBox = showCheckBoxStr != null && showCheckBoxStr.equals("true");
	String checkBoxDesc = request.getParameter("checkBoxDesc");
	if (checkBoxDesc == null || checkBoxDesc.length() == 0){
		checkBoxDesc = "Write to database table";
	}
	String dbTableDesc = request.getParameter("dbTableDesc");
	if (dbTableDesc == null || dbTableDesc.length() == 0){
		dbTableDesc = "Write to database table";
	}
	String doOnTableChange = request.getParameter("doOnTableChange");
	if (doOnTableChange == null){
		doOnTableChange = "";
	}
	String activeStr = request.getParameter("active");
	boolean active = activeStr != null && activeStr.equals("true");
	
	String targetId = request.getParameter("targetId");
	
	String scriptsOnlyStr = request.getParameter("scriptsOnly");
	boolean scriptsOnly = scriptsOnlyStr != null && scriptsOnlyStr.equals("true");
	
	String noScriptsStr = request.getParameter("noScripts");
	boolean noScripts = noScriptsStr != null && noScriptsStr.equals("true");
	
	DbLocationInfo dbli = null;
	DbLocationInfo ddbli = null;
	LocationInfoConstraints constraints = null;
	boolean useDefault = true;
	if (locationInfoId != null && locationInfoId.length() > 0){
		dbli = (DbLocationInfo)request.getAttribute(locationInfoId);
		if (dbli != null){
			dbli = (DbLocationInfo)dbli.clone();
			dbli.init();
			DBAccount dbAcc = dbli.getDbAccount();
			constraints = dbli.getConstraints();
		}
		request.getSession().removeAttribute(locationInfoId);
	}
	
	DBAccount defaultAcc = null;
	String defaultTable = null;
	if (showDefault && defaultLocationInfoId != null && defaultLocationInfoId.length() > 0){
		ddbli = (DbLocationInfo)request.getAttribute(defaultLocationInfoId);
		if (ddbli != null){
			ddbli = (DbLocationInfo)ddbli.clone();
			ddbli.init();
			defaultAcc = ddbli.getDbAccount();
			defaultTable = ddbli.getTableName();
		}
		if (dbli == null){
			dbli = ddbli;
		}
		request.getSession().removeAttribute(defaultLocationInfoId);
		//constraints = dfli.getConstraints();
	}
	
	if (locationInfoId == null){
		locationInfoId = "";
	}
	DBAccount acc = null;
	String createStmt = "";
	String insertStmt = "";
	String tblName = request.getParameter("tblName");
	if (tblName == null) tblName = "";
	String accId = "";
	int[] sizeUnits = Constants.InformationUnits.getInformationUnits();
	long maxSize = constraints != null ? constraints.getMaxSize() : -1;
	int sizeUnit = constraints != null ? constraints.getSizeType() : -1;
	double maxPercent = constraints != null ? constraints.getMaxPercent() : -1;
	if (dbli != null){
		acc = dbli.getDbAccount();
		if (acc != null){
			accId = acc.getId();
		}
		createStmt = dbli.getCreateStatement();
		if (createStmt == null) createStmt = "";
		insertStmt = dbli.getInsertStatement();
		if (insertStmt == null) insertStmt = "";
		tblName = dbli.getTableName();
		if (tblName == null) tblName = "";
	}
	String maxSizeStr = maxSize > 0 ? String.valueOf(maxSize) : "";
	String maxPercentStr = maxPercent > 0 ? String.valueOf(maxPercent) : "";
	String activeChecked = active ? "checked" : "";
	String divStyle = active ? "" : "style=\"display:none;\"";
	
  UserContext userContext = UserEnvironment.getUserContext(request);
%>

<%if (!noScripts){%>
<script>
function tableNameChanged(){
	<%=doOnTableChange%>
}

function showHideDbLocationInfoDiv(cb,divid){
	var d = document.getElementById(divid);
	if (divid && cb){
		if (cb.checked == true){
			d.style.display = "";
		}else{
			d.style.display = "none";
		}
	}
}

function openNewDBAccountDiv(){
	openNewAccDiv('addAccDiv','db','','new','<%=prefix%>AccountsList','<%=baseDirectory%>','<%=prefix%>AccountsList');
}

</script>
<%}%>

<%if (!scriptsOnly){%>
<%if (targetId != null && targetId.length() > 0){%>
<input type="hidden" name="dbLocationTarget_<%=suffix%>" value="<%=targetId%>">
<%}%>
<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
	<%if (showDefault){%>
	<tr>
		<td>
		<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
			<%if (showCheckBox){%>
			<tr>
				<td style="padding-top:10px">
					<input type="hidden" name="dbLocationInfoCheckBox_<%=suffix%>" id="dbLocationInfoCheckBox_<%=suffix%>" value="true">
					<input type="checkbox" name="useDbLocationInfo_<%=suffix%>" id="useDbLocationInfo_<%=suffix%>" <%=activeChecked%> value="true" onclick="javascript:showHideDbLocationInfoDiv(this,'dbLocationInfoDiv_<%=suffix%>')">
				</td>
				<td>
					<span class="REGULARTEXT"><b><%=checkBoxDesc%></b></span>
				</td>
			</tr>
			<%}%>
			<%if (showCheckBox){%>
			<tr>
				<td>&nbsp;</td>
				<td>
				<div id="dbLocationInfoDiv_<%=suffix%>">
				<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
			<%}%>
			<tr>
				<td colspan="2" style="padding-top:5px;padding-left:5px">
					<span class="REGULARTEXT"><%=showCheckBox?"":"<b>"%><%=targetDbTableDesc%><%=showCheckBox?"":"</b>"%></span>
				</td>
			</tr>
			<tr>
				<td style="padding-top:5px"><input type="radio" name="infoType_<%=suffix%>" id="infoType_<%=suffix%>" value="default" <%=useDefault ? "checked" : ""%>></td>
				<td style="padding-top:5px">
					<span class="REGULARTEXT">Default</span>
				</td>
			</tr>
			<%if (showCheckBox){%>
				</table>
				</div>
				</td>
			</tr>
			<%}%>
		</table>
		</td>
	</tr>
	<%}else{%>
	<%if (showCheckBox){%>
	<tr>
		<td style="padding-top:10px">
			<input type="hidden" name="dbLocationInfoCheckBox_<%=suffix%>" id="dbLocationInfoCheckBox_<%=suffix%>" value="true">
			<input type="checkbox" name="useDbLocationInfo_<%=suffix%>" id="useDbLocationInfo_<%=suffix%>" <%=activeChecked%> value="true" onclick="javascript:showHideDbLocationInfoDiv(this,'dbLocationInfoDiv_<%=suffix%>')">
		</td>
		<td style="padding-top:10px;padding-left:3px" width="100%">
			<span class="REGULARTEXT"><b><%=checkBoxDesc%></b></span>
		</td>
	</tr>
	<%}%>
	<%if (showCheckBox){%>
	<tr>
		<td>&nbsp;</td>
		<td>
		<div id="dbLocationInfoDiv_<%=suffix%>" <%=divStyle%>>
		<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
	<%}%>
	<%if (targetDbTableDesc != null && !targetDbTableDesc.equals("NONE")){%>
	<tr>
		<td style="padding-top:5px">
			<span class="REGULARTEXT"><%=targetDbTableDesc%>: </span>
		</td>
	</tr>
	<%}%>
	<!--  Account Start -->
	<tr>
		<td width="100%" style="padding-top:5px">
			<div id="<%=prefix%>logAccountDiv""> 			                   
			<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse">                                        
				<tr>
					<td width="25%"><span class="REGULARTEXT">Connection Details: </span></td>
					<td width="100px" style="padding-left:3px">
						<div id="<%=prefix%>accountsListDiv" style="display">
							<jsp:include flush="true" page="../../common/accountsListCombo.jsp">
							<jsp:param name="ACC_TYPE" value="db"/>
							<jsp:param name="ACC_ID" value="<%=accId%>"/>
							<jsp:param name="CHANGE_ACC_SELECTION" value="false"/>
							<jsp:param name="PREFIX" value="<%=prefix%>"/>
							<jsp:param name="noScripts" value="true"/>
							</jsp:include> 																								
						</div>
					</td>
					<%if (userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){%>
			    <td width="6">&nbsp;</td>
					<td style="padding-left:5">
						<div id="<%=prefix%>newAccountDiv">
							<span class="SMALLTEXT"><a href="javascript:openNewDBAccountDiv('<%=baseDirectory%>')" class="BUTTON_MEDIUMLINK">new</a></span>
						</div>	
					</td>
					<%} %>
					<td width="*">&nbsp;</td>
				</tr>
				<tr>
					<td width="23%" style="font-size:1px">&nbsp;</td>
					<td colspan="4">
						<div id="<%=prefix%>AccountIdErrorMsg" style="display:none;" class="ERROR_MSG">
					</div>
					</td>
				</tr>																																																																																																				
			</table>
			</div>  
		</td>
	</tr>
	<!-- Account end -->
	<tr>
		<td>
		<table border="0">
			<tr>
				<td><span class="REGULARTEXT"><%=dbTableDesc%>:</span></td>
				<td>
					<span class="REGULARTEXT"><input type="text" id="tableName_<%=suffix%>" name="tableName_<%=suffix%>" size="20" value="<%=tblName%>" onChange="javascript:tableNameChanged()"></span>
				</td>
			</tr>
		</table>
		</td>
	</tr>  
	<tr>
		<td>
		<table border="0">
			<tr>
				<td colspan="2" id="advancedDbLocationInfo"">
					<a href="javascript:showHideElement('advancedDbLocationInfoDiv','advancedDbLocationInfoLink','show database advanced settings','hide database advanced settings')" class="SMALLLINK"><span id="advancedDbLocationInfoLink">show database advanced settings</span></a>
				</td>
			</tr>
			<tr>
				<td>
					<div id="advancedDbLocationInfoDiv" style="display:none">
					<table border="0" width="100%" cellpadding="0" cellspacing="0">
						<tr>
							<td>&nbsp;</td>
						</tr>
						<tr>
							<td><span class="REGULARTEXT"><b>Create table statement</b></span></td>
						</tr>
						<tr>
							<td><span class="SMALLTEXT">Enter the sql statement to create the table with, in case it does not exist</span></td>
						</tr>
						<tr>
							<td><textarea class="TEXTBOX" rows="3" id="createStatement_<%=suffix%>" name="createStatement_<%=suffix%>" cols="120" style="font-size: 8pt"><%=createStmt%></textarea></td>
						</tr>
						<tr>
							<td><span class="SMALLTEXT">example: CREATE TABLE <i>TableName</i>(column_1 dataType_1,...,column_n dataType_n))</span></td>
						</tr>
						<tr>
							<td>&nbsp;</td>
						</tr>
						<tr>
							<td><span class="REGULARTEXT"><b>Insert statement</b></span></td>
						</tr>
						<tr>
							<td><span class="SMALLTEXT">Enter the sql statement to use to insert data into the table</span></td>
						</tr>
						<tr>
							<td><span class="SMALLTEXT"><b><u>Note</u></b>: if inserted data is longer than the column's size, it will be truncated as needed</span></td>
						</tr>
						<tr>
							<td><textarea class="TEXTBOX" rows="3" id="insertStatement_<%=suffix%>" name="insertStatement_<%=suffix%>" cols="120" style="font-size: 8pt"><%=insertStmt%></textarea></td>
						</tr>
						<tr>
							<td><span class="SMALLTEXT">example: INSERT INTO TABLE (column_1,...,column_n) VALUES ({field_i1},,,{field_in})</span></td>
						</tr>
					</table>
					</div>
				</td>
			</tr>
		</table>
		</td>
	</tr>  
	<%}%>
	<%if (showConstraints){%>
	<!-- 
	<tr>
		<td style="padding-top:5px">
			<span class="REGULARTEXT"><b>Constraints</b></span>
		</td>
	</tr>
	 -->
	<tr>
		<td style="padding-top:5px">
			<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
				<tr>
					<td>
						<span class="REGULARTEXT"><nobr>Max Disk Space: </nobr></span>
					</td>
					<td>
						<table border="0" height="100%" cellpadding="0" cellspacing="0">
							<tr>
								<td style="padding-left:3px">
									<input type="text" class="TEXTBOX" name="dbMaxSize_<%=suffix%>" id="dbMaxSize_<%=suffix%>" size="10" value="<%=maxSizeStr%>">
								</td>
								<td style="padding-left:4px">
									<select name="dbSizeUnitType_<%=suffix%>">
									<%
									for (int i=0; i<sizeUnits.length; i++){
										String selected = (sizeUnits[i] == sizeUnit || sizeUnit == -1 ? "selected" : "");
										String unitDesc = Constants.InformationUnits.getUnitDescription(sizeUnits[i]);
									%>
										<option value="<%=sizeUnits[i]%>" <%=selected%> class="TEXTBOX"><%=unitDesc%></option>
									<%}%>
									</select>
								</td>
							</tr>
						</table>
					</td>			
					<td width="100%">&nbsp;</td>
				</tr>
			</table>
		</td>
	</tr>
	<%}%>
	
	<tr height="100%">
		<td>&nbsp;</td>
	</tr>
	
	<%if (showCheckBox){%>
		</table>
		</div>
		</td>
	</tr>
	<%}%>
	
</table>
<%}%>