<%@ page language="java"%>

<%@ page import="com.xpolog.logcollection.LogCollectionManager"%>
<%@ page import="com.xpolog.logcollection.system.LogCollectionSystemManager"%>

<%@ page import="xpolog.eye.scheduler.XpoScheduledOperation"%>
<%@ page import="xpolog.eye.scheduler.ui.ActionJobBuilder"%>

<%
  final String BASE_DIRECTORY = "../../";
%>
<% 
  //site management
  LogCollectionSystemManager sysMgr = LogCollectionManager.getInstance().getSystemMgr();
  
	String suffix = "DefaultCollectionScheduler";
	String name = "defaultCollectionScheduler";
	String id = "defaultCollection_" + System.currentTimeMillis();
	String actionId = "0";

	XpoScheduledOperation op = sysMgr.getDefaultSchedOp();
	ActionJobBuilder jobBuilder = new ActionJobBuilder(op);
	jobBuilder.updateFromOp();
	name = jobBuilder.getName();
	id = jobBuilder.getId();
	
	request.setAttribute("CURRENT_JOB",jobBuilder);
	request.setAttribute("ONLY_SCHEDULING","true");
  request.setAttribute("suffix",suffix);
%>
<input type="hidden" name="Name<%=suffix%>" value="<%=name%>">
<input type="hidden" name="Id<%=suffix%>" value="<%=id%>">
<input type="hidden" name="actionId<%=suffix%>" value="<%=actionId%>">
<input type="hidden" name="State<%=suffix%>" value="<%=XpoScheduledOperation.STATE_ACTIVE%>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>
		<td style="padding-top:5px">
			<jsp:include page="../../scheduler/newScheduler.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
			</jsp:include>
		</td>
	</tr>
</table>
