<%@ page language="java"%>

<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>

<%!static final String BASE_DIRECTORY = "../../";%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, ActionsPermissionConstants.LogCollectionPermissions.LOG_COLLECTION_SETTINGS_PERMISSION, true)) {
		return;
	}
%>

<html>
<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/jsdomenu.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/logcollection/common.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/logcollection/locations.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/logcollection/filelocationinfo.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/tree/rightClickMenu.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/accounts.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/errors.js"></script>

<jsp:include page="../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<jsp:include page="../../widgets/tabs/jsp/tabsHeaderIncluder.jsp" flush="true">
  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<jsp:include page="../../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<script language="javascript">

	function init(){
		initTabs();
		if(typeof initChecksumLocation == 'function') {
			initChecksumLocation();
		}
		showHideMailAddressDiv();
	}

	function doSave(){
		document.access.submit();
	}
	
	function showHideMailAddressDiv(){
		var sched = document.access.frequencyCollectionSecurityScheduler;
		if (sched){
			var d = document.getElementById("integrityMailDiv");
			if (d){
				if (sched.selectedIndex == 0){
					d.style.display = "none";
				}else{
					d.style.display = "";
				}
			}			
		}
	}
</script>
</head>

<body onLoad="init()" style="margin:0;padding:0;overflow:auto;">
<div id="addChecksumLocationAccDiv" style="display:none">
</div>

<form AUTOCOMPLETE="OFF" name="access" name="id" action="logCollectionSettingsAction.jsp" method="post" style="margin:0;padding:0">

<jsp:include page="../../common/sysFilesBrowser.jsp" flush="true">
<jsp:param name="base_directory" value="<%=BASE_DIRECTORY%>"/> 
<jsp:param name="file_filter" value="dirOnly"/> 
</jsp:include>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="margin:0;padding:0">
	<tr height="1">
		<td>
			<jsp:include page="../../common/pageHeader.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="Log Collection Settings" />
			</jsp:include>											
		</td>
	</tr>
	<tr>
		<td width="100%" height="100%" valign="top">
		<table class="ADMIN_TABLE_DIV" border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
			<tr>
				<td class="ADMIN_MAIN_TD" valign="top" height="100%">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">																
					<tr height="1">
						<td>&nbsp;</td>
					</tr>
					<tr style="padding-top:15;background-color:#A4A4A4">
						<td style="padding:8">
							<div id="tabbarDiv" style="width:100%;height:100%;background-color:#a4a4a4" ></div>
							<div id="storageDiv"  style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
								<tr><td style="padding-left:10px">							
								<jsp:include page="storageSettings.jsp" flush="true">
									<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<div id="archivingDiv"  style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
								<tr><td style="padding-left:10px">							
								<jsp:include page="archiveSettings.jsp" flush="true">
									<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<div id="securityDiv"  style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
								<tr><td style="padding-left:10px">							
								<jsp:include page="securitySettings.jsp" flush="true">
									<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<jsp:include page="../../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								<jsp:param name="id.1" value="storageDiv" />
								<jsp:param name="name.1" value="Storage" />
								<jsp:param name="id.2" value="archivingDiv" />
								<jsp:param name="name.2" value="Archiving" />
								<jsp:param name="id.3" value="securityDiv" />
								<jsp:param name="name.3" value="Security" />
							</jsp:include>
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
	<tr>
		<td style="padding-top:20">
			<jsp:include page="../../common/buttonsFooter.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="Save#Cancel" />
				<jsp:param name="actions" value="javascript:doSave()#common/actions/cancelAction.jsp" />
			</jsp:include>											
		</td>
	</tr>

</table>
</form>
<iframe id="resultFrame" name="resultFrame" style="display:none">
</body>

</html>
