<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.util.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>

<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
  //constants

  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
	String STRING_BUILDER = "CURRENT_STRING_BUILDER";

  //page data

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  StringSimpleBuilder builder = (StringSimpleBuilder)request.getSession().getAttribute(STRING_BUILDER);
  
  LogBrowsingManager lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  
  RecordMask mrecMask = null;
  MergeIndexing mergeIndexing = null;
  if(lbm == null){
    lbm = builder.getLogBrowserManager();      
  }else {
    LogBrowsingManager lbm1 = builder.getLogBrowserManager();
    if(LogAdminHelper.getXpologPattern(lbm).equals(LogAdminHelper.getXpologPattern(lbm1))){
      mrecMask = lbm.getRecordMask();
      mergeIndexing = LogAdminHelper.getMergeIndexing(lbm);
    }
    lbm = lbm1;
  }
  if (mrecMask == null){
    mrecMask = lbm.getRecordMask();
    mergeIndexing = LogAdminHelper.getMergeIndexing(lbm);
  }
  BuilderSourceInfo [] sources = builder.createBuilderSourcesInfo();
  BuildersColumnsInfo automaticInfo = builder.buildAutomaticColumnsInfo(sources);
  
  String backwardURL = null;
  AdminUIController controller = builder.getUiController();
  if (controller != null){
    controller.updatePageId("colmergeadmin.jsp");
    backwardURL = BASE_DIRECTORY + controller.getBackwardPage();
  }

%>

<%!
  public List buildMergeScriptFromMask(MergeIndexing indexing,RecordMask masks,HashMap patternToArray){
    LinkedList lines = new LinkedList();
    lines.add("logm = new Array();");
    int number = indexing.getDescriptorCount();
    MergeDescriptor desc = null;
    Iterator patternit = null;
    String patternId = null;
    String array = null;
    int index;
    for(int i=0;i<number;++i){     
      if (masks.getMaskColumn(i) == null){
        continue;
      }
      desc = indexing.getDescriptorAt(i);
      Set set = desc == null ? null : desc.getLogIdsAssociatedWithRecord();
      if (set == null || set.size() == 0){ 
        continue;
      }
      lines.add("logm["+i+"]= new MergedColumn(\""+masks.getMaskColumn(i).getName() +"\",\""+i+"\",new Array());");
      patternit = set.iterator();
      while(patternit.hasNext()){
        patternId = (String)patternit.next();
        array = (String)patternToArray.get(patternId);
        index = desc.getIndexForLog(patternId);
        lines.add("logm["+i+"].cols[logm["+i+"].cols.length] = "+array+"["+index+"];");
      }
    }
    return lines;
  }

  public List buildLogScriptFromMask(MaskColumn [] masks,String logid,String array){
    int number = masks.length;
    LinkedList lines = new LinkedList();
    MaskColumn mascol = null;

    lines.add(array+ " = new Array();");
    for(int i=0;i<number;++i){
      mascol = masks[i];
      lines.add(array + "["+i+"] = new Column(\""+mascol.getName()+"\",\""+logid+"\",\""+i+"\",\"-1\");");
    }
    return lines;
  }
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
</head>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/merge/mergecols.js"></script>
<script LANGUAGE="JavaScript1.2">
dateColumnCanBeRemoved = true;

    <%
      String arrname = "log";//for log1 log2 etc
      MaskColumn [] masks = null;
      List lines = null;
      HashMap map = new HashMap();
      String namarr = null;
      String arrayName = "";
      String fieldName = "document.getElementById(\"";
      for(int i=0;i<sources.length;++i){
       masks = sources[i].getColumns();
       namarr = arrname+i;
       arrayName = arrayName + namarr + ",";
       fieldName = fieldName + sources[i].getSourceId() + "\"),document.getElementById(\"";
       map.put(sources[i].getSourceId(),namarr);
       lines = buildLogScriptFromMask(masks,sources[i].getSourceId(),namarr);
       for(int t=0;t<lines.size();++t){%>
        <%=(String)lines.get(t)%>
    <%
        }
      }
      arrayName = arrayName.substring(0,arrayName.lastIndexOf(","));
      fieldName = fieldName.substring(0,fieldName.lastIndexOf(",document.getElementById(\""));
    %>


    <%
      List linlinit = buildMergeScriptFromMask(mergeIndexing, mrecMask,map);
      for(int t=0;t<linlinit.size();++t){%>
        <%=(String)linlinit.get(t)%>
    <%}%>

    logSelect = new Array();
    logArray = new Array();

    function initData(){
    	logSelect = new Array(<%=fieldName%>);
    	logArray = new Array(<%=arrayName%>);
    }

    function createAutoDetect(){
        <%
          List linl = buildMergeScriptFromMask(automaticInfo.getMergeIndexing(),automaticInfo.getRecordMask(),map);
          for(int t=0;t<linl.size();++t){%>
            <%=(String)linl.get(t)%>
        <%}%>

    	for(var x=document.access.IDMASTER.options.length;x > 0 ;--x){
    		document.access.IDMASTER[x-1]=null;
    	}

    	for(var i=0;i<logm.length;++i){
    		option0 = new Option(logm[i].name,i);
    		document.access.IDMASTER[document.access.IDMASTER.options.length] = option0;
    	}
    	synchronizeColumns();
    }


    function doNext(){
    
      var selectedCombo = document.getElementById("IDMASTER");
      for(var i=0;i<logm.length;++i){
        var value = logm[i].name;
        for(var t=0;t<logm[i].cols.length;++t){
          value = value + ";"+logm[i].cols[t].logid+"-"+logm[i].cols[t].indexAtlog;
        }
        selectedCombo.options[i].value = value;
	selectedCombo.options[i].selected = true;
      }
      document.access.submit();;
    }
</script>


<body onload="javascript:init()">
<form AUTOCOMPLETE="OFF" id="access" name="access" action="colmergeadminaction.jsp" method="post">
<table border="0" width="92%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="848" id="AutoNumber2">
              <tr>
                <td width="9" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="395" class="TOPBORDER">
                <span class="PAGEHEADER">Merge Patterns Admin</span> </td>
                <td width="525" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="8">&nbsp;</td>
                <td width="393">&nbsp;</td>
                <td width="524">&nbsp;</td>
              </tr>
              <tr>
                <td width="8" >&nbsp;</td>
                <td colspan="2" width="919">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
                  <tr>
                    <td width="100%" height="18"><span class="HEADER">Column admin</span></td>
                  </tr>
                  <!--
                  <tr>
                    <td><b><i>Log context pattern</i></b></td>
                  </tr>-->
                  <tr>
                    <td width="100%">
                    <span class="SMALLTEXT">Please select the table structure(columns) of the
                    merged patterns.</span></td>
                  </tr>
                  <tr>
                    <td width="100%">
                    <span class="SMALLTEXT">In this screen you define for each pattern column its target column in the merged table.<a href=javascript:openHelp('<%=BASE_DIRECTORY%>',"Merge.htm") class="SMALLLINK">help</a></span></td>
                  </tr>
                  <tr>
                    <td width="100%"> &nbsp;</td>
                  </tr>
                  <tr>

                    <td width="100%">
                      <table border="0" width="100%" cellspacing="0" cellpadding="0">
                        <%
                          int lastcounter = 0;
                          for(int i=0;i<sources.length;i=i+3){
                        %>
                        <tr>
                          <td width="5%">&nbsp;</td>
                          <%
                            lastcounter = 0;
                            //running 3 times but no more the the log number
                            for(int t=i;(t<(i+3) && t<sources.length);++t){
                              //for last iteration checking how much is left to add
                              ++lastcounter;
                              int colnum = sources[t].getColumns().length;
                              String name = sources[t].getSourceName();
                              String id = sources[t].getSourceId();
                          %>
                          <td width="26%" valign="top">
                           <table border="0" width="100%" cellspacing="0" cellpadding="0">
                              <tr>
                                <td width="100%"><span class="REGULARTEXT">Log - <%=name%></span></td>
                              </tr>
                              <tr>
                                <td width="100%">
                                  <select size="7" name="<%=id%>" id="<%=id%>" onChange="unMarkAll('<%=id%>')" class="TEXTBOX">
                                  </select>
                                </td>
                              </tr>
                            </table>
                          </td>
                          <td width="5%">&nbsp;</td>
                          <%
                            }//log 3 lops
                            int toadd = 2-lastcounter;
                            for(int x=0;x<toadd;++x){
                          %>
                            <td width="26%">&nbsp;</td>
                            <td width="5%">&nbsp;</td>
                          <%
                            }
                          %>
                             </tr>
                             <tr>
                              <td width="5%"></td>
                              <td width="26%"></td>
                              <td width="5%"></td>
                              <td width="26%"><font size="2">&nbsp;</font></td>
                              <td width="5%"></td>
                              <td width="26%"></td>
                              <td width="5%"></td>
                            </tr>
                          <%
                            }//mother of loops
                          %>
                      <tr>
                        <td width="5%"></td>
                        <td width="26%" valign="top"></td>
                        <td width="5%"></td>
                        <td width="26%"><span class="REGULARTEXT">Merged patterns columns</span></td>
                        <td width="5%"></td>
                        <td width="26%" valign="top"></td>
                        <td width="5%"></td>
                      </tr>
                      <tr>
                        <td width="5%"></td>
                        <td width="26%" valign="top">
                          <table border="0" width="100%" cellspacing="0" cellpadding="0">
                            <tr>
                              <td width="100%"><a href="javascript:addToMerged()" class="SMALLLINK">add column</a></td>
                            </tr>
                            <tr>
                              <td width="100%"><font size="2"><a href="javascript:removeFromMerged()" class="SMALLLINK">remove column</a><hr></td>
                            </tr>
                            <tr>
                              <td width="100%"><font size="2"><a href="javascript:uniteCols()" class="SMALLLINK">unite columns</a></td>
                            </tr>
                            <tr>
                              <td width="100%"><font size="2"><a href="javascript:createAutoDetect()" class="SMALLLINK">autodetect merge</a></td>
                            </tr>
                            <tr>
                              <td width="100%"><font size="2">&nbsp;</font></td>
                            </tr>
                          </table>
                        </td>
                        <td width="5%"></td>
                        <td width="26%"><select size="10" multiple  name="IDMASTER" id="IDMASTER" onChange="markDependentLogs()" onClick="markDependentLogs()" class="TEXTBOX">
                        </select></td>
                        <td width="5%"></td>
                        <td width="26%" valign="top">
                        </td>
                        <td width="5%"></td>
                      </tr>
                      <tr>
                        <td width="5%"></td>
                        <td width="26%"></td>
                        <td width="5%"></td>
                        <td width="26%"><span class="SMALLTEXT">By clicking on a column the source column will be marked.</span></td>
                        <td width="5%"></td>
                        <td width="26%"></td>
                        <td width="5%"></td>
                      </tr>
                      <tr>
                        <td width="5%"></td>
                        <td width="26%"></td>
                        <td width="5%"></td>
                        <td width="26%"></td>
                        <td width="5%"></td>
                        <td width="26%"></td>
                        <td width="5%"></td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td width="100%">
                    <font size="1"></font></td>
                  </tr>
                  <tr>
                    <td width="100%">
                    </td>
                  </tr>
                  <tr>
                    <td width="100%">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber17">
                      <tr>
                        <td width="20%">&nbsp;</td>
                        <td width="11%">
                        <p align="center"><a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK">cancel</a></td>
                        <td width="10%"><a href="<%= backwardURL != null ? backwardURL : "javascript:history.go(-1)" %>" class="LINK">previous</a></td>
                        <td width="16%"><a href="javascript:doNext()" class="LINK">next</a></td>
                        <td width="38%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>