<%@ page language="java"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.common.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.data.log.external.*"%>
<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
String CURRENT_LOG = "CURRENT_LOG";

UserEnvironment env = UserEnvironment.getUserEnvironment(request);
LogBrowsingManager man = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
final IntervalDataSource ds = IntervalAdminHelper.getIntervalDataSource(man);
String onlyInitStr = request.getParameter("onlyInit");
final boolean onlyInit = onlyInitStr != null && onlyInitStr.equals("true");
if (!onlyInit){
	ds.startDataSource(true);	
}

JobStatus status = ds.getJobStatus();
env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, status); 


ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "loggers/logview.jsp?dataLoaded=true") {
  public void run(HttpServletRequest request){
    //if the data source failed or the datasource finished, ends the progress.
    boolean isFinished = false;
    boolean isFailed = false;
    try {
      while(!isFinished && !isFailed){
 	  Thread.sleep(1000);
        isFinished =  ds.isFinished();
        isFailed = ds.getJobStatus().isFailed();
     }
      if (onlyInit){
				ds.initPumper();
      }else{
      	ds.update();
      }
   }catch (Exception e){
     e.printStackTrace();
     isFailed = true;
   }
   

   

  }
};
env.setProgressRunner(runner);

if (!ds.isAutoUpdate()){
	SiteManagment mgmt = SiteManagment.getInstance();
	Module mod = mgmt.getParentModule(man.getId());
	SiteManagment.getAdminInstance().addLogBrowser(man,mod);
}
%>

<jsp:include page="../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Processing"/>
 <jsp:param name="useStatus" value="true"/>
 <jsp:param name="stopUrl" value="loggers/presentStatusStopAction.jsp"/>
</jsp:include>

  
