<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  String MODULE_ID = "MODULE_ID";
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";


  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  XMLLogBrowserBuilder builder = (XMLLogBrowserBuilder)request.getSession().getAttribute(BUILDER);

  //verify data
  ErrorModel errmodel = new ErrorModel();

  for (int i = 0; i < builder.getElementsPatternInfoCount(); i++) {
    XMLLogBrowserBuilder.PatternElementInfo info = builder.getElementPatternInfoAt(i);
    String pat = request.getParameter("elemPattern_" + i);
    String cond = request.getParameter("conditionCombo" + i);
    String condVal = request.getParameter("conditionValue_" + i);
    String ignore = request.getParameter("ignore_" + i);
    info.setSelected(ignore == null || !ignore.equals("on"));
    if (pat != null && pat.trim().length() > 0){
       info.setXpologPattern(pat);
    }

    if (cond != null && cond.trim().length() > 0  && !cond.equals("noSelect")){
       info.setConditionProperty(cond,condVal);
    }
  }

  if(builder.getSelectedPatternElementInfoCount() == 0){
    errmodel.addError("No elements pattern were supplied.");
  }
  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;

  }

  try{
    //for configuration reasons
    builder.updateBuilder();
  }catch(Exception e){
    errmodel.addError("Building log problem,please check patterns and path again.");
    errmodel.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }

  response.sendRedirect("xmlLogFieldAdmin.jsp");
%>


