<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.helpers.IntervalAdminHelper"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
	String CURRENT_LOG = "CURRENT_LOG";
	String CURRENT_MODULE = "CURRENT_MODULE";
	String  LOG_ID = "LOG_ID";
	String ERROR_OBJ = "ERROR_OBJ";
	String BUILDER = "CURRENT_LOG_BUILDER";

	UserContext userContext = UserEnvironment.getUserContext(request);
	SiteManagment mgmt = SiteManagment.getInstance();
    Module[] mdarr = mgmt.getAllModules(userContext,true);
	if(mdarr == null || mdarr.length==0) {
		  ErrorModel errmodel = new ErrorModel();
		  errmodel.addError("No available folders were found");
		  errmodel.addError("Please check your application constraints");
		  request.getSession().setAttribute(ERROR_OBJ,errmodel);
		  response.sendRedirect(BASE_DIRECTORY+"common/errorpage.jsp");
		  return;
	  }
		
	request.getSession().removeAttribute(BUILDER);
	LogBrowsingManager lbm = null;
	String id = request.getParameter(LOG_ID);
	ErrorModel ermod = new ErrorModel();
	try{
		if(id != null && !id.trim().equals("")){
			lbm = SiteManagment.getInstance().getLogBrowserManager(id);
			if (lbm == null){
				ermod.addError("Failed to load log");
			}else{
				lbm.setID(null);
				lbm.setName("");
				lbm.setDescription("");
			}
		}else{
			ermod.addError("No log id was supplied");
		}
	}catch(Exception e){
		ermod.addError("XpoLog Failed to load log due to the following error:");
		ermod.addError(e.getMessage());
	}
	if (ermod.getErrorCount() > 0){
		request.getSession().setAttribute(ERROR_OBJ,ermod);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
	}
  
  request.getSession().setAttribute(CURRENT_LOG,lbm);
  try{
	  Module parentModule = SiteManagment.getInstance().getParentModule(id);
	  if (parentModule != null){
	  	request.getSession().setAttribute(CURRENT_MODULE,parentModule);	
	  }
  }catch(Exception e){
  }
  response.sendRedirect(BASE_DIRECTORY + "loggers/admin/logeditaction.jsp?isDuplicateMode=true");
%>