<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%> 
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.util.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="omega.ui.models.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="omega.ui.html.table.OHtmlTable"%>
<%@page import="xpolog.eye.data.source.DataSource"%>
<%@page import="xpolog.eye.data.log.files.SshMediaFileDataSource"%>
<%@page import="xpolog.eye.common.JobStatus"%>
<%@page import="xpolog.eye.data.log.files.SshMediaMultiFilesDataSource"%>
<%@page import="xpolog.eye.admin.patterns.PatternAdminHelper"%>
<%@page import="xpolog.eye.data.log.LogRecordBuilder"%>
<%@page import="xpolog.eye.knowledge.log.LogAdminResult"%>
<%@page import="java.text.DecimalFormat"%> 
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@page import="xpolog.config.Configuration"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
  //constants
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String STRING_BUILDER = "CURRENT_STRING_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String ERROR_OBJ = "ERROR_OBJ";
  String LOG_DATA_PATTERN = "logDataPattern";
	String DIR_NOT_EXIST = "dirNotExists";
	String NO_PREMISSION = "noPremission";
	boolean displaySuggestions = false;
  int multiPatternCounter = 0;


  //page data
  LogBrowsingManager lbm = null;
  String logname = "";
  List patternsList = null;
  String []events = null;
 
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

	String op = request.getParameter("OP");
	if(op == null || op.length()==0){
		op = "ADD";
	}
	
	String logAdminScreenWidth = request.getParameter("LogAdminScreenWidth");
	if(logAdminScreenWidth == null || logAdminScreenWidth.length()==0){
		logAdminScreenWidth = "600px";
	}else {
		int w = -1;
		try {
			w = Integer.parseInt(logAdminScreenWidth);
			logAdminScreenWidth = "" + (w - 8);
		}catch (Exception e){			
		}
		
	}

  String headerTitle = op.equals("ADD") ? "Add Log" : "Edit Log";

  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  SimpleLogBrowserBuilder builder = (SimpleLogBrowserBuilder)request.getSession().getAttribute(BUILDER);
  if(builder == null){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("Please select log first.");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  
  AdminUIController controller = builder.getUiController();
  if (controller != null){
    controller.updatePageId("logDataPattern.jsp");
  }
  String toVerify = request.getParameter(LOG_DATA_PATTERN);
  String backwardURL = request.getParameter("backwardURL");
  if (backwardURL != null && backwardURL.length() > 0){
    if (!backwardURL.startsWith("javascript")){
      backwardURL = BASE_DIRECTORY + backwardURL;
    }
  }else {
    if (controller != null){
      backwardURL = controller.getBackwardPage();
    }
  }  
  

  if (toVerify != null){
    toVerify  = xpolog.eye.util.XpologUtil.replaceAll(toVerify,"\r\n","\n");
  }

  RecordMask oldMask = null;
  RecordMask tmpMask = null;
  MergeIndexing indexing = null;
  if(lbm == null){
     lbm = builder.getLogBrowserManager();
  }else{
    LogBrowsingManager lbm1 = builder.getLogBrowserManager();
    String patternCheck = toVerify != null ? toVerify : LogAdminHelper.getXpologPattern(lbm1);
    if(LogAdminHelper.getXpologPattern(lbm).equals(patternCheck)){
      oldMask = lbm.getRecordMask();
      indexing = LogAdminHelper.getMergeIndexing(lbm);
    }else if (LogAdminHelper.comparePattern(LogAdminHelper.getXpologPattern(lbm),patternCheck)){
			tmpMask = lbm.getRecordMask();
    }
    lbm = lbm1;
  }
   
  boolean ignoreUnparsedRecords = builder.isIgnoreUnparsedRecords(); 
  boolean updateLinesNumber =  builder.isUpdateLinesNumber();
  if (request.getParameter("checkParameters") != null){
    String ignoreUnparsedRecordsStr = request.getParameter("ignoreUnparsedRecords");
    String updateLinesNumberStr = request.getParameter("updateLinesNumberStr");    
    ignoreUnparsedRecords = ignoreUnparsedRecordsStr != null && ignoreUnparsedRecordsStr.equalsIgnoreCase("on");
    updateLinesNumber = updateLinesNumberStr != null && updateLinesNumberStr.equalsIgnoreCase("on");
  }
  

  String xpoPattern = LogAdminHelper.getXpologPattern(lbm);
  String headerPattern = builder.getHeaderPattern();
  int headerCheckNumOfRecords = builder.getHeaderCheckNumOfRecords();
  String oldPattern = xpoPattern;
  String errorPattern = "";
  boolean patternOk = true;
  String builderId = "";
  String charset = builder.getCharset();
	if(charset == null){
	  charset = Configuration.getInstance().getPropertiesManager().getProperty("logview.defaultCharecterEncoding", null);
		if(charset != null && charset.length() == 0) {
			charset = null;
		}
	}
  try{
    if(toVerify != null){
       xpoPattern = toVerify;
       String fileHeader = request.getParameter("logHeaderFile");
       boolean isFileHeader = fileHeader != null && fileHeader.equals("true");
       headerPattern = request.getParameter("logHeaderPattern");
  		
       if (!isFileHeader && headerPattern != null && headerPattern.length() > 0){
         String headerCheckNumOfRecordsStr = request.getParameter("headerNumOfRecords");
         if (headerCheckNumOfRecordsStr != null && headerCheckNumOfRecordsStr.length() > 0){
           try {
             headerCheckNumOfRecords = Integer.parseInt(headerCheckNumOfRecordsStr);
           }catch (Exception e){           
           }         
         }
         
       }else if (isFileHeader){
      	 headerPattern = SimpleLogBrowserBuilder.FILE_TIME_HEADER;
       }else{
         headerPattern = null;
       }
       builder.setDataSourceHeaderBuilder(null,true);
       builder.setHeaderPattern(headerPattern);
       builder.setHeaderCheckNumOfRecords(headerCheckNumOfRecords);      
    }
    
	try{
			events = LogAdminHelper.readLines(lbm,100);
	    }catch(Exception e){
	    	events = null;
	    }
	    
	    
	    
	    builder.setIgnoreUnparsedRecords(ignoreUnparsedRecords);
	    builder.setUpdateLinesNumber(updateLinesNumber);
			StringSimpleBuilder stringBuilder = new StringSimpleBuilder();
			stringBuilder.setEvents(events);
			stringBuilder.getUIProperties().put("LogAdminScreenWidth",logAdminScreenWidth);
			stringBuilder.setCharset(charset);
    displaySuggestions = op.equals("ADD") && events != null && events.length > 0;

    if(displaySuggestions){  
    	xpoPattern = "{string:DUMMY}";
    }
		multiPatternCounter = PatternAdminHelper.getPatternsQuantity(xpoPattern);
		stringBuilder.setRecordPattern(xpoPattern);
	 	stringBuilder.updateBuilder();
	 	builderId = stringBuilder.getPatternManager().getPatternIdByIndex("0");
	 	request.getSession().setAttribute(STRING_BUILDER,stringBuilder);
    lbm = builder.getLogBrowserManager();

    if (oldMask != null){
      lbm.setRecordMask(oldMask);
      LogAdminHelper.getLogRecordBuilder(lbm).setMergeColumns(indexing);      
      builder.initCustomizationManager(lbm,oldMask.getCulomnsNumber());
    }
    if (tmpMask != null){
    	LogAdminHelper.updateMaskNames(tmpMask,lbm.getRecordMask());
      LogAdminHelper.getLogRecordBuilder(lbm).setMergeColumns(indexing);      
      builder.initCustomizationManager(lbm,tmpMask.getCulomnsNumber());
    }
  }catch(Exception e){
    errorPattern = e.getMessage();
    patternOk = false;
  }


  String html = "";
  boolean exsitLines = false;
  boolean isFailed = false;
  String color = "";
  String[] lines = new String[20];
	DataSource ds = lbm.getLinearDataBuilder().getDataSource();
	if(ds != null && ds instanceof SshMediaMultiFilesDataSource ){
	 SshMediaMultiFilesDataSource sshDs = (SshMediaMultiFilesDataSource)ds;
	 JobStatus jobStatus = sshDs.getSshStatus();
	 if(jobStatus != null && jobStatus.isFailed()){
		 lines = new String[1];
			lines[0] = "XpoLog : " + jobStatus.getCurrentStatus();
			isFailed = true;
	 }
 	}
	if(!isFailed && ds != null && ds.getStatus() != null &&  ds.getStatus().isFailed()) {
		lines = new String[1];
		lines[0] = "XpoLog : " + ds.getStatus().getStatusMessage();
		isFailed = true;
	}else if (!isFailed &&!LogAdminHelper.isFilesExists(lbm)){
	    lines = new String[2];
	    lines[0] = "XpoLog : No files were found according to the details you supplied.";
	    lines[1] = "XpoLog : Please check the path details.";
			isFailed = true;
	  }else if (!isFailed ){
//	  	lines = LogAdminHelper.readLines(lbm,20);
	  	lines = events ;
	  	if(lines == null || lines.length == 0){
		  	lines = new String[1];
		    lines[0] = "XpoLog : It seems that the file is empty.";
				isFailed = true;
	  	}
	  }

	if(!isFailed){
	  for (int i = 0; i < lines.length; i++) {
	    if (lines[i] != null && lines[i].length() > 0){
	       exsitLines = true;
	    }
	  }
	}else{
		color = "red";
		html = "";
	}


  //log table example
  RecordsMaskTableModel model = lbm.getFirstEntries(10);
  boolean patternToLogOk = true;
  String errorPatternToLog = "";
  if(exsitLines){
    if(model==null || model.getColumnCount()==0 || !patternOk){
      patternToLogOk = false;
      errorPatternToLog = "Please check if pattern acurately describes the log records.";
    }
  }
 
  if (charset != null){
    response.setContentType("text/html; charset=" + charset);
  }
  
%>
<html>

<head>
<%if (charset != null) {%>
<meta http-equiv="Content-Type" content="text/html; charset=<%=charset%>">
<%}else {%>
<meta http-equiv="Content-Language" content="en-us">
<%}%>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" charset="iso-8859-1" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" charset="iso-8859-1" type="text/css" href="<%=BASE_DIRECTORY%>css/logAdministration.css" />
<script LANGUAGE="JavaScript1.2" charset="iso-8859-1" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script LANGUAGE="JavaScript1.2" charset="iso-8859-1" src="<%=BASE_DIRECTORY%>scripts/common/messages.js"></script>
<script LANGUAGE="JavaScript1.2" charset="iso-8859-1" src="<%=BASE_DIRECTORY%>scripts/UIUtil.js"></script>
<script LANGUAGE="JavaScript1.2" charset="iso-8859-1" src="<%=BASE_DIRECTORY%>scripts/logAdmin/patternWizard.js"></script>
<jsp:include page="../../scripts/dataview/dataView.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
</jsp:include>

<jsp:include page="../../widgets/tabs/jsp/tabsHeaderIncluder.jsp" flush="true">
  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
  <jsp:param name="style" value="patternadmin" />
</jsp:include>
<jsp:include page="../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		</jsp:include>
<jsp:include page="../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<script type="text/javascript" charset="iso-8859-1">
var BASE_DIRECTORY = "<%=BASE_DIRECTORY%>";
var LOG_ADMIN_SCREEN_WIDTH = "<%=logAdminScreenWidth%>";

function correctMenuObj(panel,obj){
  var z = findPosY(obj);
  z = z+10;
   panel.style.top = z + "px";
}

function updateWidth(){
  var w = document.getElementById("textHeaderTable").clientWidth - 2;
  document.getElementById("logLines").style.width=w + "px";
  document.getElementById("recordAnalysedId").style.width=(w + 3) + "px";
  //document.getElementById("resultsTableId").width=w;
  LOG_ADMIN_SCREEN_WIDTH = w;
}

</script>

</head>
<body onLoad="initPattern('<%=displaySuggestions%>','<%=multiPatternCounter%>');updateWidth();" style="margin:0;padding:0;overflow:auto">

	<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
		<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
		<jsp:param name="title" value="Add field"/> 
		<jsp:param name="suffix" value="addField"/> 
		<jsp:param name="width" value="550px"/> 
		<jsp:param name="height" value="380px"/> 
		<jsp:param name="actionsNames" value="Apply#Cancel"/> 
		<jsp:param name="actions" value="javascript:saveNewPattern();#javascript:cancelPattrernDiv();"/> 
	</jsp:include>
	
	
	
	<div id="fieldActionDiv" style="position:absolute;height:121px;width:100px;display:none;z-index:110">
	</div>
	<iframe id="fieldActionDivFrame" src="<%=BASE_DIRECTORY%>empty.html" style="position:absolute;height:118px;width:95px;display:none;z-index:100"></iframe> 


<form AUTOCOMPLETE="OFF" name="access" id="access" method="post" style="margin:0px;padding:0px">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1" height="100%">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
							<tr height="10">
											<td >
												<jsp:include page="../../common/pageHeader.jsp" flush="true">
												<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
												<jsp:param name="headerTitle" value="<%=headerTitle%>" />
												</jsp:include>											
										</td>
									</tr>             
              <tr  height="10">
                               <td  width="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">

				  <tr style="font-size:1" height="8px">
					  <td style="padding-top:10;padding-left:5">
							<table border="0" cellpadding="0" cellspacing="0" width="100%" style="border-collapse: collapse" >
								<tr>
									<td width="120" class="HEADER">Log Pattern</td>
									<td width="380" class="REGULARTEXT">Text sample from the log selected</td>
									<td width="*">&nbsp;</td>
								</tr>
							</table>
						</td>			
            </tr>	
	          <tr style="font-size:1" height="8px">
		           	<td >
		           		&nbsp;
		           	</td>
		          </tr>															

<!-- text from the logs -->				             
                  <tr>
                  		<td style="padding-left:5">
                  			<table border="0" cellpadding="0" cellspacing="0" style="border:1px solid #DBDFE2" width="100%" height="145">
					                  <tr >
					                  	<td>
					                  			<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse;display:" width="100%" id="textHeaderTable">
					                  					<tr bgcolor="#838383">
					                  							<td width="100%" height="18">&nbsp;</td>
																					<td height="18" align="right" style="padding-right:11px"><a class="WHITE_BUTTON_SMALLLINK" href="javascript:verifyAll()">Verify</a></td>					                  							
					                  							<td height="18" align="right" style="padding-right:41px"><a class="WHITE_BUTTON_SMALLLINK" href="javascript:updateLogLines(true,true)">Reset</a></td>
					                  					</tr>		
					                  			</table>
					                  	</td>			
					                  </tr>
					                  <tr><%String sep = System.getProperty("line.separator");%>
					                    <td width="100%" height="18">
					                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse;display:" width="100%" id="textHeaderTable">
					                    <tr><td>
					                    <textarea class="TEXTBOX" wrap="off" rows="8" name="logLines" id="logLines"  style="padding-left:16px;padding-top:4px;width:<%=logAdminScreenWidth%>;font-size: 8pt;color:<%=color%>;background-color: #F2F1F1;border:none;overflow:auto"><%
								for(int t=0;t<lines.length;++t){									
									String line = lines[t];												
									line = line.replaceAll("<","&lt;");
									line = line.replaceAll(">","&gt;");
									line = line.replaceAll("\"","&quot;");
												
								%><%=line%><%=sep%><%}%></textarea>
								</td></tr>
								</table>
								</td>
					                  </tr>															
							</table>
						</td>
				  </tr>	
				  
<!-- NEW BAR START-->
                  <tr>
                  		<td style="padding-left:5">
                  			<table border="0" cellpadding="0" cellspacing="0" style="border:1px solid #DBDFE2;background-color: #CFCFCF;width:100%;height:168px;overflow-x:auto" >
<!-- Pattern sufggestion list -->
												   <tr>
								                  		<td>
								                  			<div id="PatternSuggestionDiv" style="display:<%=displaySuggestions ? "" : "none" %>">
									                  			<table border="0" width="100%" cellspacing="0" style="height:168px;background:white;border:1px solid #DBDFE2;overflow:auto">
										                  			<tr bgcolor="#CFCFCF" height="30px">
										                  					<td>
										                  							<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse;display:" valign="top" width="100%" height="18px">
																                  					<tr class="REGULARTEXT_GRAY" valign="middle" >
																                  							<td id="patternSuggestionMsgTD" width="*" style="padding-left:20px" class="SMALL_BLACK_HEADER">Automatic Pattern Suggestions</td>
																                  							<td width="120px" height="18px" align="right" style="padding-right:3px"><nobr>Pattern Editor:</nobr> </td>
																																<td width="40px" height="18px" align="center">Auto</td>					                  							
																																<td width="5px" height="18px" align="center">|</td>					                  																												
																                  							<td width="50px" height="18px" align="center"><a class="BUTTON_SMALLLINK" href="javascript:changePatternView('wizard');">Wizard</a></td>
																																<td width="5px" height="18px" align="center">|</td>					                  							
																                  							<td width="50px" height="18px" align="center"><a class="BUTTON_SMALLLINK" href="javascript:changePatternView('manual');">Manual</a></td>					                  							
																																<td width="20px" height="18px">&nbsp;</td>					                  							
																                  					</tr>							                  					
																                  		</table>                  							
										                  					</td>
										                  			</tr>		                  							     
														             <tr width="100%" valign="top">
															           	<td>
																				<div id="PatternSuggestionLoadingDiv"  style="width:100%;height:117px;overflow-x:auto">
									      		            							<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse;display:">
																													<tr height="8px">
																		             							<td>&nbsp;</td>
																		             					</tr>
															                  					<tr>
															                  							<td style="padding-left:30" class="REGULARTEXT">Loading...</td>
															                  					</tr>
															                  			</table>				
																				</div>														   			                  			 
																				<div id="PatternSuggestionList" style="width:100%;height:100%;overflow-x:auto;">
																				</div>														   			                 			 														
															           	</td>
															          </tr>							          	
																</table>
															</div>
														</td>
												  </tr>			
<!-- wizards section -->                  
				                  <tr>
				                  	<td>
				                  		<table border="0" width="100%" cellspacing="0" height="*">
				                  					<tr>
				                  							<td width="100%">
				     									           		<div id="pattrenWizardsDiv" style="display:<%=displaySuggestions ? "" : "" %>">
																			<jsp:include flush="true" page="pattern/logPattern.jsp">
																				<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
																				<jsp:param name="OP" value="<%=op%>"/>
																			</jsp:include>																																								
																		</div>	
																		<div id="customTabsDiv">
																				<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse;display:" valign="top" width="100%">
										                  							<tr class="REGULARTEXT_GRAY" valign="middle" width="100%">
											                  							<td width="*" height="18" style="padding-left:20px" class="SMALL_BLACK_HEADER">&nbsp;</td>
											                  							<td width="120px" height="18" align="right" style="padding-right:3px"><nobr>Pattern Editor:</nobr> </td>
											                  							<%if(displaySuggestions){%>
																						<td width="40px" height="18" align="center"><a class="BUTTON_SMALLLINK" href="javascript:changePatternView('auto');">Auto</a></td>					                  							
																						<td id="customTabsDivAuto" width="5px" height="18" align="center">|</td>					                  																												
																						<%}else{%>
																									                  																																																		
																						<%}%>
																											                  																												
											                  							<td id="customTabsDivWizard" width="50px" height="18" align="center" >Wizard</td>					                  												                  							
																						<td width="5px" height="18" align="center">|</td>					                  							
											                  							<td id="customTabsDivAdvance" width="50px" height="18" align="center"><a class="BUTTON_SMALLLINK" href="javascript:changePatternView('manual');">Manual</a></td>					                  							
																						<td width="20px" height="18">&nbsp;</td>					                  							
												                  					</tr>							                  					
													                  			</table>
																			</div>													                                          							
				                  									</td>
							              					</tr>                  		
				            				 </table>
				                  	</td>
				                  </tr>						  
							      </table> 
							    </td>   
							</tr>										
     </table> 
    </td>   
</tr>			
					  				  				  				  				                                      
<!-- Log records analysis result  -->					
                  <tr valign="top">                
                    <td style="padding-left:5">
                     <table id="resultsTableId" border="0" cellpadding="0" cellspacing="0" width="100%"  align="left" valign="top" style="display:<%=displaySuggestions ? "none" : ""%>">
				                  <tr  bgcolor="#4A539A" height="18px" width="100%">
				                    <td style="padding-left:20px"><span class="REGULARTEXT_WHITE">Log records analysis result</span></td>
				                  </tr>
	                     		<tr>
                     				<td valign="top">	
					                    <div id="recordAnalysedId" style="width:<%=logAdminScreenWidth%>px;height:250;overflow-y:auto;overflow-x:auto;border:1px solid #DBDFE2;">
					                    </div>                    
					                  </td>
					              </tr>
					           </table>       
                    </td>
                  </tr>
                  
                  <tr height="10" >
									<td  style="padding-top:10">
									
									<%
									
									String actionNames = "";
									String actions = "";
									
									
                  actionNames += "Previous";
									if(backwardURL == null) {
										int o = -1;
	                  if(toVerify != null){
	                    o = -2;
	                  }
	                  actions += "javascript:history.go(" + o + ")";
                  }else {
                  	actions += backwardURL;
                  }

									actionNames += "#Save";
									actions += "#javascript:doSaveLog()";

									actionNames += "#Cancel";
									actions += "#" + "common/actions/cancelAction.jsp";
									
									%>
										<jsp:include page="../../common/buttonsFooter.jsp" flush="true">
											<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />				
											<jsp:param name="align" value="right"/> 
											<jsp:param name="actionNames" value="<%=actionNames%>"/> 
										    <jsp:param name="actions" value="<%=actions%>"/> 
										</jsp:include>											
									</td>
								</tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
</table>
</form>
</body>

</html>