
<%@page import="xpolog.eye.data.util.FilterHelper"%>
<%@page import="xpolog.eye.data.filters.FilterCollection"%>
<%@page import="xpolog.eye.data.filters.FilterManager"%>
<%@page import="xpolog.eye.data.RecordMask"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.site.SiteConstants"%>
<%@page import="xpolog.eye.audit.AuditConstants"%>
<%@page import="xpolog.eye.audit.AuditManager"%>
<%@ page language="java"%> 

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%

  String BASE_DIRECTORY = "../../";
  
  String ERROR_OBJ = "ERROR_OBJ";
  String MODULE_ID = "MODULE_ID";
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_DATA_PATTERN = "logDataPattern";
  String SELECTED_DATA_PATTERN = "SELECTED_DATA_PATTERN";
  String STRING_BUILDER = "CURRENT_STRING_BUILDER";

  SiteManagment mgmt = SiteManagment.getInstance();
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);

  
  ErrorModel errmodel = new ErrorModel();
  String logdatapat = "";

  StringSimpleBuilder strBuilder = (StringSimpleBuilder)request.getSession().getAttribute(STRING_BUILDER);
	if(strBuilder == null || strBuilder.getPatternManager() == null){
    errmodel.addError("Building log problem,please check patterns and path again.");
	}else{
//  	PatternAdminHelper.removeDummyBuilder(strBuilder.getPatternManager().getPatternBuilders());
//	  logdatapat =  strBuilder.getPatternManager().getPatternsAsString();		
	  logdatapat =  strBuilder.getPatternManager().getMgrXpologPattern();		
	  if(logdatapat != null && logdatapat.indexOf("DUMMY") > 0){
		  strBuilder.getPatternManager().updateDummyFieldInPattern(strBuilder);
		  try{
			  strBuilder.updateBuilder();
		  }catch(Exception e){
			  
		  }
	  }	  
	  logdatapat =  strBuilder.getPatternManager().getMgrXpologPattern();
	}

  request.getSession().setAttribute(SELECTED_DATA_PATTERN,logdatapat);
  //verify data
 
  if(logdatapat == null || logdatapat.trim().equals("")){
    errmodel.addError("No data pattern was supplied.");
  }
  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;

  }
  //logdatapat = logdatapat.trim();
  if (logdatapat != null){
    logdatapat = xpolog.eye.util.XpologUtil.replaceAll(logdatapat,"\r\n","\n");
    logdatapat = logdatapat.replaceAll("DUMMY","text");
  }
  
  SimpleLogBrowserBuilder builder = (SimpleLogBrowserBuilder)request.getSession().getAttribute(BUILDER);  
  boolean ignoreUnparsedRecords = builder.isIgnoreUnparsedRecords();
  boolean updateLinesNumber =  builder.isUpdateLinesNumber();
  if (request.getParameter("checkParameters") != null){
    String ignoreUnparsedRecordsStr = request.getParameter("ignoreUnparsedRecords");
    String updateLinesNumberStr = request.getParameter("updateLinesNumberStr");    
    ignoreUnparsedRecords = ignoreUnparsedRecordsStr != null && ignoreUnparsedRecordsStr.equalsIgnoreCase("on");
    updateLinesNumber = updateLinesNumberStr != null && updateLinesNumberStr.equalsIgnoreCase("on");
  }
  String headerPattern = request.getParameter("logHeaderPattern");
  String fileHeader = request.getParameter("logHeaderFile");
  boolean isFileHeader = fileHeader != null && fileHeader.equals("true");
 
  int headerCheckNumOfRecords = 1000;
  if (!isFileHeader && headerPattern != null && headerPattern.length() > 0){
    String headerCheckNumOfRecordsStr = request.getParameter("headerNumOfRecords");
    if (headerCheckNumOfRecordsStr != null && headerCheckNumOfRecordsStr.length() > 0){
      try {
       headerCheckNumOfRecords = Integer.parseInt(headerCheckNumOfRecordsStr);
      }catch (Exception e){           
      }
    }
  }else if (isFileHeader){
 	 headerPattern = SimpleLogBrowserBuilder.FILE_TIME_HEADER;
  }else {
   headerPattern = null;
  }
  
  
  builder.setRecordPattern(logdatapat);
  builder.setIgnoreUnparsedRecords(ignoreUnparsedRecords);
  builder.setUpdateLinesNumber(updateLinesNumber);
  
 
  //builder.setDataSourceHeaderBuilder(null,true);
  //builder.setHeaderPattern(headerPattern);
  builder.setHeaderCheckNumOfRecords(headerCheckNumOfRecords);

  LogBrowsingManager lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  if(lbm != null && builder.getVirtualColumnsBuilder() == null && (!builder.isMultiPattern() && LogAdminHelper.comparePattern(LogAdminHelper.getXpologPattern(lbm),LogAdminHelper.getXpologPattern(builder.getLogBrowserManager())))){
     builder.setVirtualColumnsBuilder(LogAdminHelper.getVirtualColumnsBuilder(lbm));
  }
  
  Boolean isNew = (Boolean)request.getSession().getAttribute("IS_NEW");
  if(isNew != null && isNew.booleanValue()) {
  	builder.setUseIndexing(true);
  }

  try{
  	boolean maskChanged = false;
	  
  	LogBrowsingManager oldlbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  	boolean doDispose = (oldlbm == null);
  	//for configuration reasons
    builder.updateBuilder();
  	lbm = builder.getLogBrowserManager();
  	
  	//check if we can use same same customization manager
  	if(oldlbm == null && lbm.getId() != null && lbm.getId().length() > 0) {
  		oldlbm = SiteManagment.getInstance().getLogBrowserManager(lbm.getId(), false, false, true);
  	}
  	if(oldlbm != null){
	    lbm.setConsolidation(oldlbm.isConsolidation());
     //check if the record have been changed
  	  RecordMask mask = lbm.getRecordMask();
  	  RecordMask oldMask = oldlbm.getRecordMask();
  	  if(mask.getCulomnsNumber() != oldMask.getCulomnsNumber()) {
  	  	maskChanged = true;
  	  }else {
  		  String type = null;
  		  String oldType = null;
  		  for(int i=0;i<mask.getCulomnsNumber();++i) {
  		  	type = mask.getMaskColumn(i).getType();
  		  	oldType = oldMask.getMaskColumn(i).getType();
  		  	if(!type.equals(oldType)) {
  		  		maskChanged = true;
  		  		break;
  		  	}
  		  }
  	  }
      if(!maskChanged){
        CustomizationManager cuman = oldlbm.getCustomizationManager();
        lbm.setCustomizationManager(cuman);
        lbm.setFilterManager(oldlbm.getFilterManager());
      }else{
      	FilterManager oldFilterMgr = oldlbm.getFilterManager();
      	if (oldFilterMgr != null){
      		List fcs = oldFilterMgr.getFilterCollections();
        	FilterManager filterMgr = new FilterManager();
      		FilterCollection oldFc, fc;
    			for (int j=0; j<fcs.size(); j++){
    				oldFc = (FilterCollection)fcs.get(j);
    				fc = FilterHelper.createFilterCollection(oldFc, oldMask, mask, true);
    				if (fc != null){
    					filterMgr.addFilterCollection(fc);
    				}
    			}
    			lbm.setFilterManager(filterMgr);
      	}

      }
      if(doDispose) {
      	oldlbm.dispose();
      }
    }
  	
		// parent handling
    String modid =  (String)request.getSession().getAttribute(MODULE_ID);
     if(modid == null || modid.trim().equals("")){
      modid = "rootModule";
    }
    Module parentmod = mgmt.getModuleFromId(modid);
    if(parentmod == null){
      modid = "rootModule";
      parentmod = mgmt.getModuleFromId(modid);
    }
    
    LogAdminHelperQuery reindexQuery = new LogAdminHelperQuery();
  	reindexQuery.setLbm(lbm);
  	reindexQuery.setHandleRecordMask(true);
  	reindexQuery.setHandleSortByLastUpdate(true);
  	boolean shouldReindex = LogAdminHelper.shouldReindex(reindexQuery);
    
    boolean saved = builder.saveLogBrowser(lbm,parentmod);
		if(saved) {
			LogAdminHelper.updateLogApplicationsMetas(lbm.getId(),builder.getApplicationsIds());
			
			if(isNew != null && isNew.booleanValue()) {
				SiteAdministrator admin = SiteManagment.getAdminInstance();
				String[] lbmIds = new String[1];
		  	lbmIds[0] = lbm.getId();
		  	admin.generateLogData(lbmIds, userContext);
			}
		}

    request.getSession().removeAttribute("logid");
    request.getSession().removeAttribute("callsPage");
    request.getSession().removeAttribute("lastModel");
    request.getSession().setAttribute(CURRENT_LOG,lbm);
    request.getSession().removeAttribute(BUILDER);
    request.getSession().removeAttribute(STRING_BUILDER);
    request.getSession().removeAttribute("IS_NEW");
    
    if(shouldReindex) {
    	LogAdminHelper.reindexLog(userContext, lbm.getId());
    }
    
    //audit
    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
    			userContext, AuditConstants.CHANGE, "save/edit log", AuditConstants.LOGS, "change the log " + lbm.getName()); 
      
    env.setTempAttribute(SiteConstants.FORWARD_URL_ATTRIBUTE,"loggers/admin/logaddopok.jsp?removeLog=" + !builder.isLogCanBeUsed());
    response.sendRedirect(BASE_DIRECTORY + "common/actions/nextAction.jsp");

  	
  }catch(Exception e){
    errmodel.addError("Building log problem,please check patterns and path again.");
    errmodel.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }
 
  
%>


