<%@page import="xpolog.eye.data.filters.FilterCollection"%>
<%@page import="xpolog.eye.data.filters.FilterManager"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.log.files.MultiFilesDataSource"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.data.util.*"%>
<%@ page import="xpolog.eye.data.log.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.builders.virtual.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.smart.patternmap.*"%>
<%@ page import="xpolog.eye.data.index.adapters.defaultadapter.*"%>
<%@ page import="xpolog.eye.data.index.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
  //constants
  String ERROR_OBJ = "ERROR_OBJ";
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String MODULE_ID = "MODULE_ID";
  String FILED = "FIELD_NAME_";
  String PATTERNS_LIST = "PATTERNS_LIST";
  String SELECTED_DATA_PATTERN = "SELECTED_DATA_PATTERN";
  String LOG_DATA_PATTERN = "LOG_DATA_PATTERN";
  
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);

  //page data
  LogBrowsingManager lbm = null;
  LogBrowsingManager oldlbm = null;
  oldlbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);

  String logname = "";
 
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  RecordMask mask = null;


  SimpleLogBrowserBuilder builder = (SimpleLogBrowserBuilder)request.getSession().getAttribute(BUILDER);
  if(builder == null){
		//put erro data and send to error
		ErrorModel errmodel = new ErrorModel();
		errmodel.addError("No builder was found in session");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect("errorpage.jsp");
		return;
  }
  builder.doFinished();
  lbm = builder.getLogBrowserManager();
  mask = lbm.getRecordMask();  
  
  int origColNumber= mask.getCulomnsNumber();

  //update path locations changes made by the user (only intervalDataSource);
  if(!builder.isDuplicateMode()) {
	  IntervalAdminHelper.updateLocationsChanges(oldlbm,lbm);
  }
  	
  String doSaveOnlyStr = request.getParameter("doSaveOnly");
  boolean doSaveOnly = doSaveOnlyStr != null && doSaveOnlyStr.equals("true");
  boolean doUpdate = false;

  String skipDataGenerateStr = request.getParameter("skipDataGenerate");
  boolean skipDataGenerate = skipDataGenerateStr != null && skipDataGenerateStr.equals("true");
  
  String op = request.getParameter("OP");
  VirtualColumnsBuilder virtualColumnBuilder = builder.getVirtualColumnsBuilder(); 
  ArrayList virtualList = new ArrayList();
  if (virtualColumnBuilder != null){
    VirtualColumn [] virtualColumns = virtualColumnBuilder.getVertualColumns();
    for(int i = 0; i < virtualColumns.length; i++){
      virtualList.add(virtualColumns[i]);
    }
  }

  int colMaskNumber = origColNumber - virtualList.size();

  int [] realIndexes = null;
  if (op != null && op.length() > 0){
    if (op.equals("ADD_VIRTUAL_COL")){
			VirtualColumn virCol = new VirtualColumn ();
			String virtualColOp = request.getParameter("virtualColOp");
			String [] colIndexes = request.getParameterValues("virtualColSelected");
			int [] refsCols = new int[colIndexes.length];

      for (int i = 0; i < colIndexes .length; i++) {
        try {
          refsCols[i] = Integer.parseInt(colIndexes[i]);
        }catch (Exception e){
          refsCols[i] = -1;
        }
      }

			virCol.setRefColumns(refsCols);
      virCol.setVirtualFunction(new xpolog.eye.data.util.transformers.virtual.StringVirtualFunction ());
      virCol.setMaskColumn(new StringMask());
			virtualList.add(virCol);
      doUpdate = true;
    }else if (op.equals("REMOVE_VIRTUAL_COL")){
			String indexStr = request.getParameter("virtualColIndex");
			int index = -1;
			try {
			  index = Integer.parseInt(indexStr);
			}catch (Exception e){}
		
			if (index >= 0){
			  realIndexes  = new int[origColNumber];
		          VirtualColumn virCol = (VirtualColumn)virtualList.get(index);
		 	  virtualList.remove(index);
		          int realIndex = virCol.getVirtualIndex();
		          for (int i = 0; i < realIndexes .length; i++) {
		            if (i <realIndex){
		               realIndexes[i] = i;
			    }else if (i == realIndex){
				realIndexes[i] = -1;
			    }else {
				realIndexes[i] = i - 1;
			    }
			  }
			  
			}
			doUpdate = true;
	 
    }
  }

  Boolean isNew = (Boolean)request.getSession().getAttribute("IS_NEW");
  if(isNew != null && isNew.booleanValue()) {
  	builder.setUseIndexing(true);
  }
  
  if (doUpdate){
    if (virtualList.size() == 0){
      virtualColumnBuilder  = null;
    }else {
      int colsCount = colMaskNumber;
      virtualColumnBuilder = new VirtualColumnsBuilder();
      for(int i = 0; i < virtualList.size(); i++){
        VirtualColumn virCol = (VirtualColumn)virtualList.get(i);
        virCol.setVirtualIndex(colsCount++);
        virtualColumnBuilder.addVirtualColumn(virCol);
      }
      
    }
    
    try {
      MergeIndexing indexing = LogAdminHelper.getMergeIndexing(lbm);
      builder.setVirtualColumnsBuilder(virtualColumnBuilder); 
      builder.updateBuilder();
      if (builder.isMultiPattern()){
        
      
				ArrayList list = new ArrayList();
				for (int i = 0; i < colMaskNumber ;i++){
				  list.add(mask.getMaskColumn(i));
				}
				builder.addVirtualColumns(list);
				MaskColumn [] columns = (MaskColumn[])list.toArray(new MaskColumn[list.size()]);
				lbm.getRecordMask().setColumns(columns);
				builder.initCustomizationManager(lbm,lbm.getRecordMask().getCulomnsNumber());
				
				if (lbm != null){
          
          lbm = builder.getLogBrowserManager();
          LogRecordBuilder recBuilder = LogAdminHelper.getLogRecordBuilder(lbm);
          if (recBuilder != null){
            recBuilder.setMergeColumns(indexing);
          }
        }
				
				
      }
    }catch (Exception e){
      e.printStackTrace();
      return;
    }
    lbm = builder.getLogBrowserManager();
     mask = lbm.getRecordMask();
     
  }



  boolean shouldRemoveIndex = false;
  boolean statisticsColumnChanged = false;

  int number = origColNumber;
  String name = "";
  String useIndexAction = "";
  String useStatisticsAction = "";
  for(int i=0;i<number && !doSaveOnly ;i++){
    name = request.getParameter(FILED+i);
    int index = realIndexes == null ? i : realIndexes[i];
    if(index >= 0 && (name != null ) && (!(name.trim().equals("")))){
      mask.getMaskColumn(index).setName(name);
    }
    
    useIndexAction = request.getParameter("useColIndex"+i);
    boolean useIndex = useIndexAction != null && useIndexAction.equals("ON");
    if(index >= 0){
    	shouldRemoveIndex = shouldRemoveIndex || mask.getMaskColumn(index).isUseIndex() != useIndex;
    	mask.getMaskColumn(index).setUseIndex(useIndex);
    }

    useStatisticsAction = request.getParameter("useColStatistics"+i);
    if (index >=0){
    	if (useStatisticsAction == null || useStatisticsAction.equals("no")){
    		if (mask.getMaskColumn(index).isUseInStatistics()){
    			statisticsColumnChanged = true;
    		}
    		mask.getMaskColumn(index).setUseInStatistics(false);
      	mask.getMaskColumn(index).setComputeAvgContextStatistics(false);
    	}else if (useStatisticsAction.equals("yes")){
    		if (!mask.getMaskColumn(index).isUseInStatistics() || mask.getMaskColumn(index).isComputeAvgContextStatistics()){
    			statisticsColumnChanged = true;
    		}
    		mask.getMaskColumn(index).setUseInStatistics(true);
      	mask.getMaskColumn(index).setComputeAvgContextStatistics(false);
    	}else if (useStatisticsAction.equals("useAvg")){
    		if (!mask.getMaskColumn(index).isUseInStatistics() || !mask.getMaskColumn(index).isComputeAvgContextStatistics()){
    			statisticsColumnChanged = true;
    		}
    		mask.getMaskColumn(index).setUseInStatistics(true);
      	mask.getMaskColumn(index).setComputeAvgContextStatistics(true);
    	}
    }
    
	}
  String dateIndexStr = request.getParameter("dateIndex");
  if (dateIndexStr != null && dateIndexStr.length() > 0){
  	try{
  		int dateIndex = Integer.parseInt(dateIndexStr);
    	mask.setDateColumnIndex(dateIndex);
  	}catch(Exception e){}
  }
  
  
  //check if we can use same same customization manager
  if(oldlbm != null && !doUpdate){
   //check if the record have been changed
	  boolean maskChanged = false;
	  RecordMask oldMask = oldlbm.getRecordMask();
	  if(mask.getCulomnsNumber() != oldMask.getCulomnsNumber()) {
	  	maskChanged = true;
	  }else {
		  String type = null;
		  String oldType = null;
		  for(int i=0;i<mask.getCulomnsNumber();++i) {
		  	type = mask.getMaskColumn(i).getType();
		  	oldType = oldMask.getMaskColumn(i).getType();
		  	if(!type.equals(oldType)) {
		  		maskChanged = true;
		  		break;
		  	}
		  }
	  }
    if(!maskChanged){
      CustomizationManager cuman = oldlbm.getCustomizationManager();
      lbm.setCustomizationManager(cuman);
      lbm.setFilterManager(oldlbm.getFilterManager());
    }else{
    	FilterManager oldFilterMgr = oldlbm.getFilterManager();
    	if (oldFilterMgr != null){
    		List fcs = oldFilterMgr.getFilterCollections();
      	FilterManager filterMgr = new FilterManager();
    		FilterCollection oldFc, fc;
  			for (int j=0; j<fcs.size(); j++){
  				oldFc = (FilterCollection)fcs.get(j);
  				fc = FilterHelper.createFilterCollection(oldFc, oldMask, mask, true);
  				if (fc != null){
  					filterMgr.addFilterCollection(fc);
  				}
  			}
  			lbm.setFilterManager(filterMgr);
    	}

    }
  }
  
  //statistics
  String computeStatisticsStr = request.getParameter("computeStatisticsStr");
  boolean computeStatistics = computeStatisticsStr != null && computeStatisticsStr.equalsIgnoreCase("on");
  if (!doSaveOnly){
    lbm.setComputeStatistics(computeStatistics);
  }

  //parent handling
  String modid =  (String)request.getSession().getAttribute(MODULE_ID);
   if(modid == null || modid.trim().equals("")){
    modid = "rootModule";
  }
  Module parentmod = mgmt.getModuleFromId(modid);
  if(parentmod == null){
    modid = "rootModule";
    parentmod = mgmt.getModuleFromId(modid);
  }
  
  if(lbm.getLinearDataBuilder().getDataSource() instanceof MultiFilesDataSource || lbm.getType().equals(OnlineDBSimpleLogBuilder.ONLINE_DB_LOG_TYPE)) {
	  String useIndexingStr = request.getParameter("useIndexingStr");
	  boolean useIndexing = useIndexingStr != null && useIndexingStr.equalsIgnoreCase("on");
	  String shouldRemoveIndexStr = request.getParameter("shouldRemoveIndex");
	  shouldRemoveIndex = shouldRemoveIndex || (shouldRemoveIndexStr != null && shouldRemoveIndexStr.equalsIgnoreCase("true"));  
	  String useIndexingForDateSearchStr = request.getParameter("useIndexingForDateSearchStr");
	  boolean useIndexingForDateSearch = useIndexingForDateSearchStr != null && useIndexingForDateSearchStr.equalsIgnoreCase("on");
	  
	  
	  if (!doSaveOnly){
	  	lbm.setUseIndexing(useIndexing);
	  	lbm.setUseIndexingForDateSearch(useIndexing && useIndexingForDateSearch);
	  }
	  if (shouldRemoveIndex){
	    SearchEngineManager.getInstance().getDefaultIndexAdapter().removeIndex(new IndexedObject(lbm));
	  }
  }
  if (statisticsColumnChanged){
  	mask.setLastStatisticsColumnUpdate(System.currentTimeMillis());
  }
  if (doUpdate){
    response.sendRedirect("logFieldAdmin.jsp?update=true");
    return;
  }
  
  LogAdminHelperQuery reindexQuery = new LogAdminHelperQuery();
	reindexQuery.setLbm(lbm);
	reindexQuery.setHandleRecordMask(true);
	reindexQuery.setHandleSortByLastUpdate(true);
	boolean shouldReindex = LogAdminHelper.shouldReindex(reindexQuery);
  
  boolean saved = builder.saveLogBrowser(lbm,parentmod);
  if(saved) {
		if(!skipDataGenerate && isNew != null && isNew.booleanValue()) {
			String[] lbmIds = new String[1];
	  	lbmIds[0] = lbm.getId();
	  	admin.generateLogData(lbmIds, userContext);
		}
  }
  request.getSession().removeAttribute("logid");
  request.getSession().removeAttribute("callsPage");
  request.getSession().removeAttribute("lastModel");
  request.getSession().setAttribute(CURRENT_LOG,lbm);
  request.getSession().removeAttribute("IS_NEW");
  
  if(shouldReindex) {
  	LogAdminHelper.reindexLog(userContext, lbm.getId());
  }

  //pattern mapping
  ArrayList patternList = (ArrayList)request.getSession().getAttribute(PATTERNS_LIST);
  String selectedPattern = (String)request.getSession().getAttribute(SELECTED_DATA_PATTERN);
  PatternMapManager pmManager = PatternMapManager.getInstance();
  if (patternList != null && patternList.size() > 0 && selectedPattern != null) {
	  pmManager.addPatternMapList(patternList, selectedPattern);
	  pmManager.save();
  }
  request.getSession().removeAttribute(PATTERNS_LIST);
  request.getSession().removeAttribute(SELECTED_DATA_PATTERN);
  request.getSession().removeAttribute(BUILDER);
  
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			userContext, AuditConstants.CHANGE, "save/edit log", AuditConstants.LOGS, "change the log " + lbm.getName()); 
    
  env.setTempAttribute(SiteConstants.FORWARD_URL_ATTRIBUTE,"loggers/admin/logaddopok.jsp?removeLog=" + !builder.isLogCanBeUsed());
  response.sendRedirect(BASE_DIRECTORY + "common/actions/nextAction.jsp");
%>


