  <%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.data.log.winevent.*"%>
<%@ page import="xpolog.eye.data.xml.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.data.log.files.*"%>
<%@page import="xpolog.eye.merge.MergeCustomizationManager"%>
<%@page import="xpolog.eye.data.log.db.OnlineDBDataSource"%>

<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.LogViewingPermissions.CUSTOMIZE_LOG_PERMISSION,true)){
   		return;
	}	

  //constants
  String LOG_ID = "LOG_ID";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_NAME = "LOG_NAME";
  String LOG_DESCRIPTION = "LOG_DESCRIPTION";
  String MODULE_ID = "MODULE_ID";
  String ERROR_OBJ = "ERROR_OBJ";

  String COLOR_PRIOR_NAME = "COLOR_PRIOR_NAME_";
  String COLOR_PARAM = "COLOR_PARAM_";

  //page data
  LogBrowsingManager lbm = null;
  String logname    = "";
  boolean updateLinesNumber = false;
  boolean toCheckLineNumbers = false;
  boolean toCheckUseIndexing = false;
  boolean useIndexing = false;
  boolean useIndexingForDateSearch = false;
  boolean computeStatistics = false;
  
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();


  String id = request.getParameter(LOG_ID);
  if((id != null) && !(id.trim().equals(""))){
    try{
      lbm = mgmt.getLogBrowserManager(id);
    }catch(Exception e){}
   }else{
      lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
   }
   
    CustomizationManager cuman = null;
    RecordMask mask = null;

    if(lbm != null && lbm.getId() != null){
      logname = lbm.getName();
      cuman = lbm.getCustomizationManager();
      mask = lbm.getRecordMask();
      request.getSession().setAttribute(CURRENT_LOG,lbm);
    }else{
      ErrorModel ermod = new ErrorModel();
      ermod.addError("You must select a log first.");
      request.getSession().setAttribute(ERROR_OBJ,ermod);
      response.sendRedirect("errorpage.jsp");
      return;
    }
    
    //lines number and indexing issue
    LinearDataSource linearDS = lbm.getLinearDataBuilder().getLinearDataSource();    
    MultiFilesDataSource ds = null;
		if(linearDS instanceof MultiFilesDataSource) {
        ds = (MultiFilesDataSource)linearDS;       
        useIndexing = lbm.isUseIndexing();
        useIndexingForDateSearch = lbm.isUseIndexingForDateSearch();
        toCheckUseIndexing = true;
    }else if(linearDS instanceof XMLElementDataSource) {
        ds = ((XMLElementDataSource)linearDS).getDataSource();       
        useIndexing = lbm.isUseIndexing();
        useIndexingForDateSearch = lbm.isUseIndexingForDateSearch();
        toCheckUseIndexing = true;
    }else if(linearDS instanceof WinEventDataSource) {     
      useIndexing = lbm.isUseIndexing();
      useIndexingForDateSearch = lbm.isUseIndexingForDateSearch();
      toCheckUseIndexing = true;
   }else if (lbm.getType().equals(OnlineDBSimpleLogBuilder.ONLINE_DB_LOG_TYPE)){
  	 useIndexing = lbm.isUseIndexing();
     useIndexingForDateSearch = lbm.isUseIndexingForDateSearch();
     toCheckUseIndexing = true;
   }
		computeStatistics = lbm.isComputeStatistics();    
    if (ds != null){
       updateLinesNumber = ds.isUpdateLines();
       if(!(ds instanceof SshMediaMultiFilesDataSource)) {
	       toCheckLineNumbers = true;
       }
    }
    
    //search and filter issue
     String searchAndFilterDef = lbm.getSearchAndFilterDef();
     if(searchAndFilterDef == null || searchAndFilterDef.length() == 0) {
     	searchAndFilterDef = Configuration.getInstance().getPropertiesManager().getProperty("searchAndFilterDef","START");
     }
     boolean useQuickFilter = lbm.isUseQuickFilter();
     boolean useWholeWords = lbm.isUseWholeWords();
    
    String[] priorities = null;
    int cnum = mask.getCulomnsNumber();
    for(int i=0;i<cnum;++i){
      if((mask.getMaskColumn(i) instanceof PriorityMask)){
        priorities = ((PriorityMask)mask.getMaskColumn(i)).getPriorities();
      }
    }
    HashMap p2c = cuman.getPriorityColorMap();

    String startOperation = cuman.getStartOperation();
    if (startOperation == null || startOperation.length() == 0){
      startOperation = "CURRENT";
    }
    boolean showIndexing = SiteManagment.getInstance().getXpologManagment().isComponentLicenseValid(XpologManagment.SEARCH_ENGINE_COMPONENT) && toCheckUseIndexing;
    
    String globalCustomName = "";
    if(cuman != null && cuman.isUseGlobal()){
		String name = cuman.getGlobalCustomName();
		if(name != null && name.length() > 0) {
			globalCustomName = "Currenlty using global customization: " + cuman.getGlobalCustomName()+"<br>&nbsp;";
		}else {
			globalCustomName = "<br>&nbsp;";
		}
    }
%>



<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>
  function doApply(){
		for(var i=0;i<document.access.CustomizedColSelect.options.length;i++){
		  document.access.CustomizedColSelect.options[i].selected = true;
		}
		document.access.submit();
  }
  
    function addToCust(){
  		if(document.access.RealColSelect.selectedIndex == -1){
    		return;
  		}
  		for(var j=0;j<document.access.RealColSelect.options.length;j++){
    		if (document.access.RealColSelect.options[j].selected){
      			var name = document.access.RealColSelect.options[j].text;
      			var value = document.access.RealColSelect.options[j].value;
      			var found = false;
      			for(var i=0;i<document.access.CustomizedColSelect.options.length;i++){
        			if(document.access.CustomizedColSelect.options[i].value == value){
          				alert("One or more of the selected columns is already presented. Please modify the selection!");
          				return;
        			}
      			}
        		var option0 = new Option(name,value);
        		document.access.CustomizedColSelect.options[document.access.CustomizedColSelect.options.length] = option0;
    		}
  		}
	}

function removeFromCust(){
  if(document.access.CustomizedColSelect.selectedIndex == -1){
    return;
  }

  for(var i= document.access.CustomizedColSelect.options.length ; --i >= 0;){
    if(document.access.CustomizedColSelect.options[i].selected){
       document.access.CustomizedColSelect.options[i] = null;
    }
  }
}
  

  function moveUpinCust(){
      if(document.access.CustomizedColSelect.selectedIndex == -1){
        return;
      }
      index = document.access.CustomizedColSelect.selectedIndex;
      if(index == 0){
      	return;
      }
      document.access.CustomizedColSelect.selectedIndex = index - 1;
      moveDowninCust();
      document.access.CustomizedColSelect.selectedIndex = index;
    }

	function moveDowninCust(){
      if(document.access.CustomizedColSelect.selectedIndex == -1){
        return;
      }
      index = document.access.CustomizedColSelect.selectedIndex;
      if(index == (document.access.CustomizedColSelect.options.length-1) || document.access.CustomizedColSelect.options.length == 1){
        return;
      }
	   var options = new Array();
	   for(var i=0;i<document.access.CustomizedColSelect.options.length;i++){
      	  if(i == index){
      	  	var option0 = new Option(document.access.CustomizedColSelect.options[i+1].text,document.access.CustomizedColSelect.options[i+1].value);
      		options[i] = option0;
      		option0 = new Option(document.access.CustomizedColSelect.options[i].text,document.access.CustomizedColSelect.options[i].value);
      		options[i+1] = option0;
      		i = i+1;
      	  }else{
      	    var option0 = new Option(document.access.CustomizedColSelect.options[i].text,document.access.CustomizedColSelect.options[i].value);
      		 options[i] = option0;
      	  }
       }
       for(var i=0;i<options.length;i++){
      	   document.access.CustomizedColSelect.options[i] = null;
       }
       for(var i=0;i<options.length;i++){
      	  document.access.CustomizedColSelect.options[i] = options[i];
       }

       document.access.CustomizedColSelect.selectedIndex = index + 1;
    }


   function openColorSelector(name){
    window.open('<%=BASE_DIRECTORY%>colorchooser/ColorChooser.jsp?TEXT_NAME=' + name,'color','width=300,height=300,status=no,resizable=no,top=200,left=400,dependent=yes,alwaysRaised=yes');
  }
  
  	function updateUseIndex(){
		var isChecked = document.getElementById("useIndexingStr").checked;
		var dateIndexSearchDiv = document.getElementById("dateIndexSearchDiv");
	  if(dateIndexSearchDiv){
	    if (isChecked){
	      dateIndexSearchDiv.style.visibility = "";
	    }else {
	      dateIndexSearchDiv.style.visibility = "hidden";
	    } 
	  }
	}


var contextreq;
function addMenu(op,id){
  if (typeof XMLHttpRequest != "undefined") {
       contextreq = new XMLHttpRequest();
   } else if (window.ActiveXObject) {
       contextreq = new ActiveXObject("Microsoft.XMLHTTP");
   }
  var url = "logUIAdminMenues.jsp?op=" + op + "&id=" + id;
   var contextSearchCol = eval("document.access.contextSearchCol0");
   for (var i = 0; contextSearchCol;){
     url = url + "&contextSearchCol" + i + "=" + contextSearchCol[contextSearchCol.selectedIndex].value;
     url = url + "&contextSearchName" + i + "=" + escape(eval("document.access.contextSearchName" + i).value);
     url = url + "&contextSearchPath" + i + "=" + escape(eval("document.access.contextSearchPath" + i).value);
     i++;
     contextSearchCol = eval("document.access.contextSearchCol" + i);   
   }
   
   contextreq.open("POST",url, true);
   contextreq.onreadystatechange = addMenucallback;
   contextreq.send(null);
}

function addMenucallback() {
  if (contextreq.readyState == 4) {
    if (contextreq.status == 200) {
     
      var val = contextreq.responseText;
      if (!val){
        val = "";
      }     
      var td = document.getElementById("searchMenuesTD");
     
      if(td){
        td.innerHTML = val;
      }
      return;
    }
  }
}
  
</script>
</head>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" action="logUIadminAction.jsp" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="53%" class="TOPBORDER" height="0">
                <span class="PAGEHEADER">Log UI Admin&nbsp;</span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="43%">&nbsp;</td>
                <td width="30%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr><td class="SMALLTEXT"><%=globalCustomName%></td></tr>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Table customization</span></td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber19">
                      <tr>
                        <td width="17%">


                        <select size="7" name="RealColSelect" id="RealColSelect" style="width: 250; height: 156" multiple>

                          <%
                            String name = null;
                            String value = null;
                            for(int i=0;i<mask.getCulomnsNumber();++i){
                              name = mask.getMaskColumn(i).getName();
                              value = String.valueOf(i);
                          %>
                          <option class="TEXTBOX" value="<%=value%>" alt="<%=name%>" title="<%=name%>" name="<%=name%>"><%=name%></option>
                          <%
                            }
                          %>
                        </select>


                        </td>
                        <td width="10%" style="padding-left:5;padding-right:5">
                        	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="77%" id="AutoNumber20">
                          <tr>
                            <td width="100%" align="center">
                            <a href="javascript:addToCust()" class="SMALLLINK">add</a> </td>
                          </tr>
                          <tr>
                            <td width="100%" align="center">
                            <a href="javascript:removeFromCust()" class="SMALLLINK">remove</a></td>
                          </tr>
                         </table>

                        </td>
                        <td width="14%">
                         <select size="7" name="CustomizedColSelect" id="CustomizedColSelect" style="width: 250; height: 156" multiple>

                         <%
                            name = null;
                            value = null;
                            int ci = -1;
                            for(int i=0;i<mask.getCulomnsNumber();++i){
                              ci = cuman.getIndexFromCustomizedCol(i);
                              if(ci == -1){
                                continue;
                              }
                              name = mask.getMaskColumn(ci).getName();
                              value = String.valueOf(ci);
                          %>
                          <option  class="TEXTBOX" value="<%=value%>" alt="<%=name%>" title="<%=name%>" name="<%=name%>"><%=name%></option>
                          <%
                            }
                          %>

                         </select></td>
                        <td width="14%" style="padding-left:5;padding-right:5">
                        	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber21">
                          <tr>
                            <td width="100%" align="center">
                           <a href="javascript:moveUpinCust()" class="SMALLLINK"><nobr>Move up</nobr></a></td>
                          </tr>
                          <tr>
                            <td width="100%" align="center">
                            <a href="javascript:moveDowninCust()" class="SMALLLINK"><nobr>Move down</nobr></a></td>
                          </tr>
                        </table>
                        </td>
                        <td width="20%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td width="15%">
                    &nbsp;</td>
                  </tr>
                  <%
                      if(priorities != null){
                      	boolean usePriorityColors = cuman.isUsePriorityBgColor();
                        String priorName = "";
                  %>
                  <tr>
                    <td><span class="HEADER">Priority color selection</span></td>
                  </tr>
                  <tr>
                    <td><input id="usePriorityColors" name="usePriorityColors" type="checkbox" <%=usePriorityColors?"checked" : ""%> value="true"><span class="REGULARTEXT">Use priority colors</span></td>
                  </tr>                 
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber18">
                        <%
                          String val = "";
                          String[] defcol = null;
                          if(p2c.size() == 0){
                            DefaultColorConfig colm = Configuration.getInstance().getDefColorMgr();
                            defcol = colm.getPriorColorsForNumber(priorities.length);
                          }
                          for (int i=0;i<priorities.length;++i){
                            priorName = priorities[i];
                            val = (String)p2c.get(priorities[i]);
                            if(val == null){
                              if(defcol != null){
                                val = defcol[i];
                              }else{
                                val = "";
                              }
                            }
                        %>
                      <tr>
                        <td width="20%"><span class="REGULARTEXT">&nbsp;<%=priorName%> &nbsp;paint in </span></td>
                        <td width="80%">
                          <input type="text" class="TEXTBOX" name="<%=COLOR_PRIOR_NAME + String.valueOf(i)%>" value="<%=val%>">
                          <a href="javascript:openColorSelector('<%=COLOR_PRIOR_NAME + String.valueOf(i)%>')" class="SMALLLINK">pick color</a>
                        </td>
                      </tr>
                      <%
                        }
                      %>
                      </table>

                    </td>
                  </tr>

                  <%
                     }
                  %>
                  <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
                 
                   <tr>
                    <td><span class="HEADER">Log Viewer Settings</span></td>
                  </tr>  
                   <%
                  if(toCheckLineNumbers) {
                  %>                
                  <tr>
                    <td><input id="updateLinesNumberStr" name="updateLinesNumberStr" type="checkbox"  <%=updateLinesNumber?"checked" : ""%>><span class="SMALLTEXT">Show lines number - when this option is checked you will be able to see the lines number <br>&nbsp;&nbsp;&nbsp;(Note: unchecking this option will improve performance on browsing to the end of the log) </span></td>
                  </tr>   
                   <%
                    }
                  %>              
                  <tr>
                    <td><input id="consolidationStr" name="consolidationStr" type="checkbox"  <%=lbm != null && lbm.isConsolidation() ?"checked" : ""%>><span class="SMALLTEXT">Consolidation - merge similar records. </span></td>
                  </tr>   
                  <%if (cuman instanceof MergeCustomizationManager){
                  	MergeCustomizationManager mergeCuman = (MergeCustomizationManager)cuman;
                  	boolean singleZoomIn = mergeCuman.isZoomInToSingleLog();
                  %>
                  <tr>
                    <td><input id="singleZoomInStr" name="singleZoomInStr" type="checkbox"  <%=singleZoomIn ? "checked" : ""%>><span class="SMALLTEXT">Single zoom in - zoom in to single log from merge filter view. </span></td>
                  </tr>   
                  <%}%>
                  <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
                 
                   <tr>
                    <td><span class="HEADER">Log Search Settings </span></td>
                  </tr>                  
                  <tr>
                    <td><input id="searchAndFilterDefStr" name="searchAndFilterDefStr" type="checkbox"  <%=searchAndFilterDef.equals("START")?"checked" : ""%>><span class="SMALLTEXT">When checked - a search and filter result will be presented from the beginning of the log<br>&nbsp;&nbsp;&nbsp;(Note: when unchecked the result is on current view) </span></td>
                  </tr>                 
                              
                  <tr>
                    <td><input id="useWholeWords" name="useWholeWords" type="checkbox"  <%=useWholeWords ? "checked" : ""%>>
                    <span class="REGULARTEXT">Use by default whole words in Search Engine</span><br>
                    <span class="SMALLTEXT">&nbsp;&nbsp;&nbsp;Checking this option will cause the search engine to search by default for whole words only<br>
                    &nbsp;&nbsp;&nbsp;this can boost up dramatically search and filter performances</span></td>
                  </tr>                 
                  <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
                   <tr>
                    <td><span class="HEADER">Log Start Operation</span></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">When viewing a log that compound of several files,<br>
					you may choose from which file to start your view.</span></td>
                  </tr>
				  <tr><td><span class="SMALLTEXT">&nbsp;</span></td></tr>
                  <tr>
                    <td>
                     <input type="radio" value="CURRENT" name="startOperation" <%=startOperation.equals("CURRENT")? "checked" : ""%>><span class="REGULARTEXT">View from the beginning of the most updated file</span><br>
                     <input class="REGULARTEXT" type="radio" value="START" name="startOperation" <%=startOperation.equals("START")? "checked" : ""%>><span class="REGULARTEXT">View from the beginning of the oldest file</span><br>
                     <input class="REGULARTEXT" type="radio" value="LAST" name="startOperation" <%=startOperation.equals("LAST")? "checked" : ""%>><span class="REGULARTEXT">View from the end of the most updated file</span><br>
                    </td>
                  </tr>
                  <tr>
                  <td>
                    &nbsp;</td>
                  </tr>                  
                 
                  <tr>
                    <td><span class="HEADER">Statistics settings</span></td>
                  </tr>                  
                  <tr>
                    <td><input id="computeStatisticsStr" name="computeStatisticsStr" type="checkbox"  <%=computeStatistics?"checked" : ""%>><span class="REGULARTEXT">Compute statistics</span><br><span class="SMALLTEXT">&nbsp;&nbsp;&nbsp;set this option to enable statistical evaluations on this log</span></td>
                  </tr>                 
                  <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>


                  <tr <%=showIndexing ? "" : "style=\"visibility:hidden\""%>>
                    <td><span class="HEADER">Indexing settings</span></td>
                  </tr>                  
                  <tr <%=showIndexing ? "" : "style=\"visibility:hidden\""%>>
                    <td><input id="useIndexingStr" name="useIndexingStr" type="checkbox" <%=useIndexing?"checked" : ""%> value="true" onClick="javascript:updateUseIndex()"><span class="REGULARTEXT">Use indexing</span><br><span class="SMALLTEXT">&nbsp;&nbsp;&nbsp;using log indexing enables rapid search and filtering; indexed logged can be used in Xpolog Search Engine </span></td>
                  </tr>                 
                  <tr <%=showIndexing ? "" : "style=\"visibility:hidden\""%> style="font-size:3">
                    <td>&nbsp;</td>
                  </tr>
                  <tr <%=showIndexing ? "" : "style=\"visibility:hidden\""%>>
                    <td>
                    	<div>
                    	<input id="useIndexingForDateSearchStr" name="useIndexingForDateSearchStr" type="checkbox"  <%=useIndexingForDateSearch?"checked" : ""%> value="true"><span class="REGULARTEXT">Use indexing for date search</span><br><span class="SMALLTEXT">&nbsp;&nbsp;&nbsp;set this option to allow for quick date search using the index</span>
                    	</div>
                    </td>
                  </tr>                 
                  <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
                 
									<%if (!(cuman instanceof MergeCustomizationManager)){%>
									 
                 
                   <tr>
                    <td><span class="HEADER">Search Context Menu</span></td>
                  </tr>  
                  
                  <tr>
                    <td id="searchMenuesTD">
                    <jsp:include page="logUIAdminMenues.jsp" flush="true"/>
                   
                  </td></tr>
                   <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
									<%} %>

                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber17" height="14">
                      <tr>
                        <td width="21%">&nbsp;</td>
                        <td width="13%" align="center">
                        &nbsp;</td>
                        <td width="10%" nowrap align="center">
                        <a href="../logview.jsp?refreshMenu=false" class="LINK">cancel / back to log viewer</a>&nbsp;&nbsp;
                        </td>
                        <td width="17%" align="center" nowrap>
                        <p align="left">
                        &nbsp;<a href="javascript:doApply()" class="LINK">apply</a><span class="SMALLTEXT"></span></p>
                        </td>
                        <td width="30%"></td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>