<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.merge.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.util.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>

<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  //constants

  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";

  //page data
  MergedLogBrowserManager lbm = null;
  MergedLogBrowserBuilder builder = null;

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  builder = (MergedLogBrowserBuilder)request.getSession().getAttribute(BUILDER);
  lbm = builder.getMergeLogBrowser();
  if(lbm == null){
    lbm = (MergedLogBrowserManager)request.getSession().getAttribute(CURRENT_LOG);
  }

  String backwardURL = null;
  AdminUIController controller = builder.getUiController();
  if (controller != null){
    controller.updatePageId("colmergeadmin.jsp");
    backwardURL = controller.getBackwardPage();
  }

  RecordMask mrecMask = lbm.getRecordMask();
  MergeIndexing mergeIndexing = MergeAdminHelper.getMergeIndexing(lbm);
  BuildersColumnsInfo automaticInfo = builder.initAutomaticMergeRecordMask();

  LogBrowsingManager[] logs = null;
  if(lbm != null){
    logs = lbm.getLogBrowsers();
  }
%>

<%!
  public List buildMergeScriptFromMask(MergeIndexing indexing,RecordMask masks,HashMap logToArray){
    LinkedList lines = new LinkedList();
    lines.add("logm = new Array();");
    int number = indexing.getDescriptorCount();
    MergeDescriptor desc = null;
    Iterator logit = null;
    String logid = null;
    String array = null;
    int index;
    for(int i=0;i<number;++i){
      lines.add("logm["+i+"]= new MergedColumn(\""+masks.getMaskColumn(i).getName() +"\",\""+i+"\",new Array());");
      desc = indexing.getDescriptorAt(i);
      logit = desc.getLogIdsAssociatedWithRecord().iterator();
      while(logit.hasNext()){
        logid = (String)logit.next();
        array = (String)logToArray.get(logid);
        index = desc.getIndexForLog(logid);
        lines.add("logm["+i+"].cols[logm["+i+"].cols.length] = "+array+"["+index+"];");
      }
    }
    return lines;
  }

  public List buildLogScriptFromMask(RecordMask mask,String logid,String array){
    int number = mask.getCulomnsNumber();
    LinkedList lines = new LinkedList();
    MaskColumn mascol = null;

    lines.add(array+ " = new Array();");
    for(int i=0;i<number;++i){
      mascol = mask.getMaskColumn(i);
      lines.add(array + "["+i+"] = new Column(\""+mascol.getName()+"\",\""+logid+"\",\""+i+"\",\"-1\");");
    }
    return lines;
  }
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
</head>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/merge/mergecols.js"></script>
<script LANGUAGE="JavaScript1.2">
    <%
      String arrname = "log";//for log1 log2 etc
      RecordMask mas = null;
      List lines = null;
      HashMap map = new HashMap();
      String namarr = null;
      String arrayName = "";
      String fieldName = "document.getElementById(\"";
      for(int i=0;i<logs.length;++i){
       mas = logs[i].getRecordMask();
       namarr = arrname+i;
       arrayName = arrayName + namarr + ",";
       fieldName = fieldName + logs[i].getId() + "\"),document.getElementById(\"";
       map.put(logs[i].getId(),namarr);
       lines = buildLogScriptFromMask(mas,logs[i].getId(),namarr);
       for(int t=0;t<lines.size();++t){%>
        <%=(String)lines.get(t)%>
    <%
        }
      }
      arrayName = arrayName.substring(0,arrayName.lastIndexOf(","));
      fieldName = fieldName.substring(0,fieldName.lastIndexOf(",document.getElementById(\""));
    %>


    <%
      List linlinit = buildMergeScriptFromMask(mergeIndexing, mrecMask,map);
      for(int t=0;t<linlinit.size();++t){%>
        <%=(String)linlinit.get(t)%>
    <%}%>

    logSelect = new Array();
    logArray = new Array();

    function initData(){
    	logSelect = new Array(<%=fieldName%>);
    	logArray = new Array(<%=arrayName%>);
    }

    function createAutoDetect(){
        <%
          List linl = buildMergeScriptFromMask(automaticInfo.getMergeIndexing(),automaticInfo.getRecordMask(),map);
          for(int t=0;t<linl.size();++t){%>
            <%=(String)linl.get(t)%>
        <%}%>

    	for(var x=document.access.IDMASTER.options.length;x > 0 ;--x){
    		document.access.IDMASTER[x-1]=null;
    	}

    	for(var i=0;i<logm.length;++i){
    		option0 = new Option(logm[i].name,i);
    		document.access.IDMASTER[document.access.IDMASTER.options.length] = option0;
    	}
    	synchronizeColumns();
    }


    function doNext(){
    
      var selectedCombo = document.getElementById("IDMASTER");
      for(var i=0;i<logm.length;++i){
        var value = logm[i].name;
        for(var t=0;t<logm[i].cols.length;++t){
          value = value + ";"+logm[i].cols[t].logid+"-"+logm[i].cols[t].indexAtlog;
        }
        selectedCombo.options[i].value = value;
	selectedCombo.options[i].selected = true;
      }
      document.access.submit();;
    }
</script>


<body onload="javascript:init()" style="margin:0;padding:0;overflow:auto;">
<form AUTOCOMPLETE="OFF" id="access" name="access" action="colmergeadminaction.jsp" method="post" style="padding:0;margin:0">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
          <tr>
            <td valign="top">
            <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
            	<tr height="10">
								<td colspan="3">
									<jsp:include page="../../../common/pageHeader.jsp" flush="true">
										<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
										<jsp:param name="headerTitle" value="Columns Administration" />
									</jsp:include>											
								</td>
							</tr>
              <tr>
                <td colspan="3" style="padding-top:10;padding-left:10" valign=top">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="100%">
                  <!--
                  <tr>
                    <td><b><i>Log context pattern</i></b></td>
                  </tr>-->
                  <tr height="18">
                    <td width="100%">
                    	<span class="REGULARTEXT">In this page you define for each log column its target column in the merged log table.<a href=javascript:openHelp('<%=BASE_DIRECTORY%>',"Merge.htm") class="SMALLLINK">help</a></span>
                    </td>
                  </tr>
                  <tr height="18">
                    <td width="100%" style="padding-top:10">
                    	<span class="REGULARTEXT">Please select the columns of the merged log:</span>
                    </td>
                  </tr>
                  <tr>
                    <td width="100%" style="padding-top:10">
                      <table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
                        <%
                          int lastcounter = 0;
                          for(int i=0;i<logs.length;i=i+3){
                        %>
                        <tr>
                          <td width="5%">&nbsp;</td>
                          <%
                            lastcounter = 0;
                            //running 3 times but no more the the log number
                            for(int t=i;(t<(i+3) && t<logs.length);++t){
                              //for last iteration checking how much is left to add
                              ++lastcounter;
                              LogBrowsingManager lb = logs[t];
                              RecordMask mask = lb.getRecordMask();
                              int colnum = mask.getCulomnsNumber();
                              String name = lb.getName();
                              String id = lb.getId();
                          %>
                          <td width="26%" valign="top">
                           <table border="0" width="100%" cellspacing="0" cellpadding="0">
                              <tr>
                                <td width="100%"><span class="REGULARTEXT">Log - <%=name%></span></td>
                              </tr>
                              <tr>
                                <td width="100%">
                                  <select size="7" name="<%=id%>" id="<%=id%>" onChange="unMarkAll('<%=id%>')" class="TEXTBOX">
                                  </select>
                                </td>
                              </tr>
                            </table>
                          </td>
                          <td width="5%">&nbsp;</td>
                          <%
                            }//log 3 lops
                            int toadd = 2-lastcounter;
                            for(int x=0;x<toadd;++x){
                          %>
                            <td width="26%">&nbsp;</td>
                            <td width="5%">&nbsp;</td>
                          <%
                            }
                          %>
                             </tr>
                             <tr>
                              <td width="5%"></td>
                              <td width="26%"></td>
                              <td width="5%"></td>
                              <td width="26%"><font size="2">&nbsp;</font></td>
                              <td width="5%"></td>
                              <td width="26%"></td>
                              <td width="5%"></td>
                            </tr>
                          <%
                            }//mother of loops
                          %>
                      <tr>
                        <td width="5%"></td>
                        <td width="26%" valign="top"></td>
                        <td width="5%"></td>
                        <td width="26%"><span class="REGULARTEXT">Merged Log Columns</span></td>
                        <td width="5%"></td>
                        <td width="26%" valign="top"></td>
                        <td width="5%"></td>
                      </tr>
                      <tr>
                        <td width="5%"></td>
                        <td width="26%" valign="top">
                          <table border="0" width="100%" cellspacing="0" cellpadding="0">
                            <tr>
                              <td width="100%"><a href="javascript:addToMerged()" class="SMALLLINK">add column</a></td>
                            </tr>
                            <tr>
                              <td width="100%"><font size="2"><a href="javascript:removeFromMerged()" class="SMALLLINK">remove column</a><hr></td>
                            </tr>
                            <tr>
                              <td width="100%"><font size="2"><a href="javascript:uniteCols()" class="SMALLLINK">unite columns</a></td>
                            </tr>
                            <tr>
                              <td width="100%"><font size="2"><a href="javascript:createAutoDetect()" class="SMALLLINK">autodetect merge</a></td>
                            </tr>
                            <tr>
                              <td width="100%"><font size="2">&nbsp;</font></td>
                            </tr>
                          </table>
                        </td>
                        <td width="5%"></td>
                        <td width="26%"><select size="10" multiple  name="IDMASTER" id="IDMASTER" onChange="markDependentLogs()" onClick="markDependentLogs()" class="TEXTBOX">
                        </select></td>
                        <td width="5%"></td>
                        <td width="26%" valign="top">
                        </td>
                        <td width="5%"></td>
                      </tr>
                      <tr>
                        <td width="5%"></td>
                        <td width="26%"></td>
                        <td width="5%"></td>
                        <td width="26%"><span class="SMALLTEXT">Selecting on a column will mark the source columns</span></td>
                        <td width="5%"></td>
                        <td width="26%"></td>
                        <td width="5%"></td>
                      </tr>
                    <tr height="100%"><td>&nbsp;</td></tr>
                  	</table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
              <tr height="10" style="padding-top:10">
								<td colspan="3" style="padding-top:10">
								
								<%
								
								String actionNames = "";
								String actions = "";
								
                actionNames += "Previous";
								if(backwardURL == null) {
                  actions += "javascript:history.go(-1)";
                 }else {
                 	actions += backwardURL;
                 }

								actionNames += "#Save";
								actions += "#javascript:doNext()";

								actionNames += "#Cancel";
								actions += "#" + "common/actions/cancelAction.jsp";
								
								%>
									<jsp:include page="../../../common/buttonsFooter.jsp" flush="true">
										<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />				
										<jsp:param name="actionNames" value="<%=actionNames%>"/> 
										<jsp:param name="align" value="right"/> 
									   <jsp:param name="actions" value="<%=actions%>"/> 
									</jsp:include>											
								</td>
							</tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>