<%@page import="xpolog.eye.admin.helpers.MergeAdminHelper"%>
<%@ page import="xpolog.eye.admin.builders.MergedLogBrowserBuilder"%>
<%@ page import="xpolog.eye.merge.MergedLogBrowserManager"%>
<%@ page import="xpolog.eye.site.ui.tree.ModuleMemberRenderer"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.util.*"%>

<%!

%>

<%
	String OP = "OP";
	String ADD = "ADD";
	String BUILDER = "CURRENT_LOG_BUILDER";
	String CURRENT_LOG = "CURRENT_LOG";

	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	SiteAdministrator admin = SiteManagment.getAdminInstance();
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
	Module[] roots = mgmt.getRoots();
	
	HashMap logsMap = null;
	HashMap modulesMap = null, selectedModules = null;

	LogBrowsingManager[] mergedLogs = new LogBrowsingManager[0];
	MergedLogBrowserManager lbm = null;
	String addop = request.getParameter(OP);
	if (addop != null && addop.equalsIgnoreCase(ADD)) {
	} else {
		MergedLogBrowserBuilder builder = (MergedLogBrowserBuilder) request.getSession().getAttribute(BUILDER);
		if (builder != null) {
			lbm = builder.getMergeLogBrowser();
		}
		if (lbm == null) {
			Object tmp = request.getSession().getAttribute(CURRENT_LOG);
			if (tmp != null && tmp instanceof MergedLogBrowserManager) {
				lbm = (MergedLogBrowserManager) tmp;
			}
		}
		if (lbm != null) {
			mergedLogs = lbm.getLogBrowsers();
			if (mergedLogs != null && mergedLogs.length > 0){
				logsMap = new HashMap();
			}
			for (int i = 0; i < mergedLogs.length; ++i) {
				logsMap.put(mergedLogs[i].getId(), mergedLogs[i].getId());
			}
		}
	}
	if(logsMap == null) {
		String logs = request.getParameter("logs");
		if(logs != null && logs.length() > 0) {
			logsMap = new HashMap();
			String[] logsArr = logs.split(",");
			for(int i = 0; i < logsArr.length; i++) {
				logsMap.put(logsArr[i], logsArr[i]);
			}
		}
		String mods = request.getParameter("mods");
		if(mods != null && mods.length() > 0) {
			if(modulesMap == null) {
				modulesMap = new HashMap();
			}
			if(selectedModules == null) {
				selectedModules = new HashMap();
			}
			String[] modsArr = mods.split(",");
			String mod;
			for(int i = 0; i < modsArr.length; i++) {
				mod = modsArr[i];
				if(mod.endsWith("*")) {
					mod = mod.substring(0, mod.length() - 1);
					selectedModules.put(mod, mod);
				}else {
					modulesMap.put(mod, mod);
				}
			}
		}
	}
	
	boolean treeNodeExists = false;
	String treeXml = ""; 
  String id = request.getParameter("id");
  if (id != null){
  	String modid = id;
  	int ind = id.indexOf("-");
  	if (ind != -1){
  		modid = id.substring(ind+1);
  	}
		curmod = SiteManagment.getInstance().getModuleFromId(modid);
		treeNodeExists = true;
  }else if (logsMap != null && logsMap.size() > 0){
  	if(modulesMap == null) {
  		modulesMap = new HashMap();
  	}
  	MergeAdminHelper.getModulesFromLogs(roots,modulesMap,logsMap);
  }
  
	
	if (curmod != null){
		ModuleMemberRenderer renderer= new ModuleMemberRenderer(curmod, userContext, modulesMap, logsMap, true, false, treeNodeExists);
		if(selectedModules != null) {
			renderer.setSelectedModules(selectedModules);
		}
		if(lbm != null) {
			HashSet logsToIgnore = new HashSet();
			logsToIgnore.add(lbm.getId());
			renderer.setLogsToIgnore(logsToIgnore);
		}
		treeXml = renderer.getTreeXML();
	}
	
	//System.out.println(treeXml);
	response.setContentType("text/xml");
	out.write(treeXml);
	out.flush();
%>