<%@page import="xpolog.eye.admin.helpers.LogAdminHelper"%>
<%@page import="xpolog.eye.site.startup.LogsDataGeneratorQuery"%>
<%@page import="xpolog.eye.data.util.MergeIndexing"%>
<%@page import="xpolog.eye.site.SiteConstants"%>
<%@page import="xpolog.eye.audit.AuditConstants"%>
<%@page import="xpolog.eye.audit.AuditManager"%>
<%@page import="xpolog.eye.admin.helpers.MergeAdminHelper"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.merge.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.site.ui.tree.ModuleMemberRenderer"%>
<%@ page import="xpolog.eye.site.run.LogActionsConfiguration"%>
<%
	String BASE_DIRECTORY = "../../../";
  
	String ERROR_OBJ = "ERROR_OBJ";
  String LOG_NAME = "LogName";
  String LOG_DESCRIPTION = "LogDescription";
  String MODULE_ID = "ParentModule";
  String LOG_DIRECTORY = "LOG_DIRECTORY";
  String LOG_NAME_PATTERN = "LOG_NAME_PATTERN";
  String LOG_DATA_PATTERN = "LOG_DATA_PATTERN";
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_TIME_ZONE = "TimeZone";
  String LOG_INDEX_PARAM = "LOG_INDEX_"; //+ int for its index
  String TOTAL_LOG_TO_MERGE = "TOTAL_LOG_TO_MERGE";
  String LOG_CHARSET = "charset";
  String IS_DUPLICATE_MODE = "isDuplicateMode";
  

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);

  String modid  = request.getParameter(MODULE_ID);
  String parentApps = request.getParameter("parentApplication");
	HashSet applicationsIds = new HashSet();
  String[] appArr = null;
	if(parentApps != null && parentApps.length() >0){
		appArr = parentApps.split("#");
		for(int i = 0 ;	appArr != null &&  i < appArr.length ; i++){
			applicationsIds.add(appArr[i]);
		}		
	}  
  String logname    = request.getParameter(LOG_NAME);
  String logdesc    = request.getParameter(LOG_DESCRIPTION);
  String timeZoneId = request.getParameter(LOG_TIME_ZONE);
  String charset    = request.getParameter(LOG_CHARSET);
  if (charset != null && charset.equals("default")){
    charset = null;
  }

  String [] LogsToMerge = null;
	String logsList = request.getParameter("logs");
	if (logsList != null && logsList.length() > 0){
		LogsToMerge = logsList.split(",");
	}
	
	if (LogsToMerge == null|| LogsToMerge.length == 0){
		logsList = request.getParameter("editMergeIds");
		if (logsList != null && logsList.length() > 0){
			LogsToMerge = logsList.split(",");
		}					
	}
	
	if (LogsToMerge == null){
		LogsToMerge = new String[0];
	}

	HashMap logs = new HashMap();
  HashMap mods = new HashMap();
	String [] modsArr = null;
  String modsList = request.getParameter("mods");
  if (modsList != null && modsList.length() > 0){
  	modsArr = modsList.split(",");
  }
  if (modsArr != null){
    for (int i = 0;i< modsArr.length;i++){
    	if (!modsArr[i].endsWith("*")){
      	mods.put(modsArr[i],modsArr[i]);
    	}
    }
  }
  if (modsArr != null){
    for (int i = 0;i< modsArr.length;i++){
    	String id = modsArr[i];
    	if (modsArr[i].endsWith("*")){
     		id = id.substring(0,id.length()-1);
     		ModuleMemberRenderer.addAllModuleChildren(id,mods,logs);
     	}
      mods.put(id,id);
    }
  }
  if (logs != null && logs.size() > 0){
  	for (int i = 0; i < LogsToMerge.length;i++){
  		if (logs.containsKey(LogsToMerge[i])){
  			logs.remove(LogsToMerge[i]);
  		}
  	}
  	if (logs.size() > 0){
  	  String[] implicitLogs = (String[])logs.keySet().toArray(new String[logs.size()]);
  	  String[] tmp = new String[LogsToMerge.length + implicitLogs.length];
  	  System.arraycopy(LogsToMerge,0,tmp,0,LogsToMerge.length);
  	  System.arraycopy(implicitLogs,0,tmp,LogsToMerge.length,implicitLogs.length);
  	  LogsToMerge = tmp;
  	}
  }
  
  MergedLogBrowserManager lbm = null;
  lbm = (MergedLogBrowserManager)request.getSession().getAttribute(CURRENT_LOG);
  if(lbm != null && !lbm.getType().equals(MergedLogBrowserBuilder.MERGE_LOG_TYPE)){
  	lbm = null;
  	request.getSession().removeAttribute(CURRENT_LOG);
  }
  String logid = null;
  if(lbm != null){
    logid = lbm.getId();
  }

  
  //verify data
  ErrorModel errmodel = new ErrorModel();

  if(logname == null || logname.trim().equals("")){
    errmodel.addError("No name was supplied.");
  }
  
  if(WebUtil.isContainSpecialCharecter(logname)){
     errmodel.addError("The following characters are prohibited in the name field: "+WebUtil.getSpecialCharectersList());
  }

  /*if(LogsToMerge == null || LogsToMerge.length < 2) {
  	errmodel.addError("You must select at least two logs for a merge.");
  }*/
  
  if(LogsToMerge == null || LogsToMerge.length < 2) {
	errmodel.addError("You must select at least two logs for a merge.");
  }

  if(modid == null || modid.trim().equals("")){
    errmodel.addError("No parent folder was selected. If no folder is available please check your permissions");
  }
  

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;

  }
  String doSaveStr = request.getParameter("doSave");
  boolean doSave = doSaveStr != null && doSaveStr.length() > 0;

  //grtting the log ids
  String[] logidarr = LogsToMerge;

  //for(int i=0;i<logidarr.length;++i){
  	//System.out.println(logidarr[i]);
    //logidarr[i] = request.getParameter(LOG_INDEX_PARAM + i);
  //}
  MergedLogBrowserBuilder builder = null;
	// case user add new log from different type and then press prev to chose merge log type.
	LogBrowserBuilder builderInSession = (LogBrowserBuilder)request.getSession().getAttribute(BUILDER);
	if(builderInSession == null || !(builderInSession instanceof MergedLogBrowserBuilder)){
	  builder = (MergedLogBrowserBuilder)LogBrowserBuilderFactory.getLogBroserBuilderByType(LogBrowserBuilderFactory.MERGE_LOG_TYPE);
	  request.getSession().setAttribute(BUILDER,builder);		
	}else{
		builder = (MergedLogBrowserBuilder)builderInSession;
	}
  if(lbm != null){
    builder.setID(lbm.getId());
  }

  boolean isNew = lbm == null || lbm.getId() == null;
  
  String isDuplicateModeStr = request.getParameter(IS_DUPLICATE_MODE);
  boolean isDuplicateMode = isDuplicateModeStr != null && isDuplicateModeStr.equals("true");
  
  builder.setID(logid);
  builder.setName(logname);
  builder.setApplicationsIds(applicationsIds);
  builder.setLogDescription(logdesc);
  builder.setTimeZoneId(timeZoneId);
  builder.setLogsToMergeIds(logidarr);
  builder.setCharset(charset);
  try{
    //for configuration reasons
    builder.updateBuilder();
  }catch(Exception e){
  e.printStackTrace();
    errmodel.addError("Building log problem,please check.");
    errmodel.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  HashSet logIds = new HashSet();
  MergedLogBrowserManager builderLbm = builder.getMergeLogBrowser();
  if (builderLbm != null){
  	LogBrowsingManager[] lbms = builderLbm.getLogBrowsers();
  	for (int i=0; i<lbms.length; i++){
  		logIds.add(lbms[i].getId());
  	}
  	for (int i=0; i<logidarr.length; i++){
  		if (!logIds.contains(logidarr[i])){
  	ModuleMember mm = mgmt.getModuleMember(logidarr[i]);
  	String name = mm != null ? mm.getName() : logidarr[i];
  	errmodel.addError("Failed to get log browsing manager " + name);
  		}
  	}
  	if (errmodel.getErrorCount() > 0){
      request.getSession().setAttribute(ERROR_OBJ,errmodel);
      response.sendRedirect("errorpage.jsp");
      return;
  	}
  }

  if (doSave){
		//If new merge log , make autodetect merge
  	builder.updateBuilder();
	  lbm = builder.getMergeLogBrowser();
    if(isNew && !isDuplicateMode){
      BuildersColumnsInfo automaticInfo = builder.initAutomaticMergeRecordMask();
  	  if(lbm != null && automaticInfo != null && automaticInfo.getMergeIndexing() != null){	  	
  	  	MergeIndexing indexing = automaticInfo.getMergeIndexing();
  	    MergeAdminHelper.setMergeIndexing(lbm,indexing);
  	    lbm.setRecordMask(automaticInfo.getRecordMask());
  	    //Reset customization
  	    MergeCustomizationManager mcum = (MergeCustomizationManager)lbm.getCustomizationManager();
  	    int[] phy = new int[indexing.getDescriptorCount()];
  	    int[] vi = new int[indexing.getDescriptorCount()];
  	    for(int t=0;t<vi.length;++t){
  	      phy[t] = t;
  	      vi[t] = t;
  	    }
  	    mcum.setCustomizationColumns(phy,vi);
  	  }
    }else{
			MergedLogBrowserManager oldlbm = (MergedLogBrowserManager)request.getSession().getAttribute(CURRENT_LOG);
			if(oldlbm != null){
		  	lbm.setFilterManager(oldlbm.getFilterManager());
		  	MergeAdminHelper.setMergeIndexing(lbm,MergeAdminHelper.getMergeIndexing(oldlbm));
		  	lbm.setCustomizationManager(oldlbm.getCustomizationManager());
		  	lbm.setRecordMask(oldlbm.getRecordMask());
		  	lbm.setConsolidation(oldlbm.isConsolidation());
		    lbm.setSearchAndFilterDef(oldlbm.getSearchAndFilterDef());
		    lbm.setUseWholeWords(oldlbm.isUseWholeWords());
		  	LogAdminHelper.setIgnoreUnparsedRecords(lbm,LogAdminHelper.isIgnoreUnparsedRecords(oldlbm));
			}
    }
    Module parentmod = mgmt.getModuleFromId(modid);
    if(parentmod == null){
      modid = "rootModule";
      parentmod = mgmt.getModuleFromId(modid);
    }
    String newId = admin.addLogBrowser(lbm,mgmt.getModuleFromId(modid));
    if(isNew && newId != null && newId.length() > 0) {
    	boolean runReports = LogActionsConfiguration.getInstance().isRunReports();
    	boolean runDashboard = LogActionsConfiguration.getInstance().isRunDashboard();
    	LogsDataGeneratorQuery query = new LogsDataGeneratorQuery();
    	query.setRunReports(runReports);
    	query.setRunDashboard(runDashboard);
    	query.setRunIndexing(false);
	  	String[] lbmIds = new String[1];
	  	lbmIds[0] = lbm.getId();
	  	admin.generateLogData(lbmIds, query, userContext);
	  }
    request.getSession().setAttribute(CURRENT_LOG,lbm);    
    request.getSession().setAttribute("logid",lbm.getId());
    request.getSession().removeAttribute(BUILDER);

    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			userContext, AuditConstants.CHANGE, "save/edit log", AuditConstants.LOGS, "change the log " + lbm.getName());
  
	  env.setTempAttribute(SiteConstants.FORWARD_URL_ATTRIBUTE,"loggers/admin/merge/logaddopok.jsp");
  	response.sendRedirect(BASE_DIRECTORY + "common/actions/nextAction.jsp");
  	return;
  }else if(isNew){//if new log:AutoMerge. (Like suggestions)
  	builder.updateBuilder();
	  lbm = builder.getMergeLogBrowser();  	
    BuildersColumnsInfo automaticInfo = builder.initAutomaticMergeRecordMask();
	  if(lbm != null && automaticInfo != null && automaticInfo.getMergeIndexing() != null){	  	
	  	MergeIndexing indexing = automaticInfo.getMergeIndexing();
	    MergeAdminHelper.setMergeIndexing(lbm,indexing);
	    lbm.setRecordMask(automaticInfo.getRecordMask());
	    //Reset customization
	    MergeCustomizationManager mcum = (MergeCustomizationManager)lbm.getCustomizationManager();
	    int[] phy = new int[indexing.getDescriptorCount()];
	    int[] vi = new int[indexing.getDescriptorCount()];
	    for(int t=0;t<vi.length;++t){
	      phy[t] = t;
	      vi[t] = t;
	    }
	    mcum.setCustomizationColumns(phy,vi);
	  }
  }
  request.getSession().setAttribute("IS_NEW", Boolean.valueOf(isNew));

  if(lbm != null){
    String[] li = lbm.getLogBrowsersIds();
    HashSet setId = new HashSet();
    boolean similar = true;
    if(li.length == logidarr.length){
      for(int t=0;t<li.length;++t){
        setId.add(li[t]);
      }
      for(int t=0;t<logidarr.length;++t){
        if(!setId.contains(logidarr[t])){
          similar = false;
        }
      }

      if(similar){
        MergedLogBrowserManager newlbm = (MergedLogBrowserManager)SiteManagment.getInstance().copyDataBrowsingManager(lbm);
        if (newlbm != null){
        	newlbm.setName(logname);
        	newlbm.setDescription(logdesc);
        	builder.setTimeZoneId(newlbm,timeZoneId);          
        	newlbm.setCharset(charset);
          builder.setMergeLogBrowserManager(newlbm);
          builder.updateOnlyExtraInformation();
          builder.setUseQuickFilter(lbm.isUseQuickFilter());
        }

      }
    }
  }
  
  String [] pages = {"loggers/admin/logAdminGate.jsp?isPrevious=true&logType=merge",
  		     "loggers/admin/merge/colmergeadmin.jsp",
  		     "loggers/admin/merge/mergefieldadmin.jsp"};
  AdminUIController controller = new AdminUIController(pages);
  builder.setUiController(controller);
  request.getSession().setAttribute(MODULE_ID,modid);
  //request.getSession().setAttribute(BUILDER,builder);

  response.sendRedirect(BASE_DIRECTORY + controller.getForwardPage());
%>
