<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.merge.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.audit.*" %>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
  //constants
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String ERROR_OBJ = "ERROR_OBJ";
  String FILED = "FieldNumber_";
  String MODULE_ID = "ParentModule";
  
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  
  //page data
  MergedLogBrowserManager lbm = null;
  String logname = "";

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  RecordMask mask = null;
  MergeCustomizationManager mcum = null;
  lbm = (MergedLogBrowserManager)request.getSession().getAttribute(CURRENT_LOG);
  MergedLogBrowserBuilder builder = (MergedLogBrowserBuilder)request.getSession().getAttribute(BUILDER);
  if(builder != null){
    lbm = builder.getMergeLogBrowser();
  }
  if(lbm == null){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("Please select log first.");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  mask = lbm.getRecordMask();
  mcum = (MergeCustomizationManager)lbm.getCustomizationManager();

  int number = mask.getCulomnsNumber();
  String name = "";
  String useStatisticsAction = "";
  for(int i=0;i<number;i++){
    name = request.getParameter(FILED+i);
    if((name != null ) && (!(name.trim().equals("")))){
      mask.getMaskColumn(i).setName(name);
    }
    useStatisticsAction = request.getParameter("useColStatistics"+i);
    boolean useStatistics = useStatisticsAction != null && useStatisticsAction.equals("ON");
   	mask.getMaskColumn(i).setUseInStatistics(useStatistics);
  }

  LogBrowsingManager[] logs  = lbm.getLogBrowsers();
  LogBrowsingManager llt  = null;
  String id = "";
  String color = "";
  for(int i=0;i<logs.length;++i){
    llt = logs[i];
    id = llt.getId();
    color = request.getParameter("MergeColorField_"+id);
    mcum.setLogColor(id,color);
  }
  
  //statistics
  String computeStatisticsStr = request.getParameter("computeStatisticsStr");
  boolean computeStatistics = computeStatisticsStr != null && computeStatisticsStr.equalsIgnoreCase("on");
  lbm.setComputeStatistics(computeStatistics);

  String modid = (String)request.getSession().getAttribute(MODULE_ID);
  admin.addLogBrowser(lbm,mgmt.getModuleFromId(modid));
  request.getSession().setAttribute(CURRENT_LOG,lbm);
  request.getSession().setAttribute("logid",lbm.getId());
  request.getSession().removeAttribute(BUILDER);
  
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			userContext, AuditConstants.CHANGE, "save/edit log", AuditConstants.LOGS, "change the log " + lbm.getName());
  
  env.setTempAttribute(SiteConstants.FORWARD_URL_ATTRIBUTE,"loggers/admin/merge/logaddopok.jsp");
  response.sendRedirect(BASE_DIRECTORY + "common/actions/nextAction.jsp");
  
%>


