<%@ page language="java"%>
<%@page import="xpolog.eye.admin.patterns.StringFieldBuilder"%>
<%@page import="xpolog.eye.admin.patterns.TextFieldBuilder"%>
<%@page import="xpolog.eye.admin.patterns.PriorityFieldBuilder"%>
<%@page import="xpolog.eye.admin.patterns.ChoicesFieldBuilder"%>
<%@page import="xpolog.eye.admin.patterns.NumberFieldBuilder"%>
<%@page import="xpolog.eye.admin.patterns.DateFieldBuilder"%>
<%@page import="xpolog.eye.admin.patterns.LiteralFieldBuilder"%>
<%@page import="xpolog.eye.admin.patterns.EOLFieldBuilder"%>
<%@page import="xpolog.eye.admin.patterns.TimestampFieldBuilder"%>
<%@page import="xpolog.eye.admin.patterns.EOEFieldBuilder"%>
<%@page import="xpolog.eye.admin.patterns.IPFieldBuilder"%>
<%@page import="xpolog.eye.admin.builders.SimpleLogBrowserBuilder"%>
<%@page import="xpolog.eye.admin.patterns.PatternManager"%>
<%@page import="java.util.List"%>
<%@page import="java.util.LinkedList"%>
<%@page import="xpolog.eye.LogBrowsingManager"%>
<%@page import="xpolog.eye.admin.helpers.LogAdminHelper"%>
<%@page import="xpolog.eye.admin.patterns.PatternAdminHelper"%>
<%@page import="xpolog.eye.admin.patterns.FieldBuilder"%>
<%@page import="xpolog.eye.admin.patterns.PatternBuilder"%>
<%@page import="xpolog.eye.admin.builders.StringSimpleBuilder"%>
<%@page import="xpolog.eye.admin.patterns.RegExpFieldBuilder"%>
<%@page import="xpolog.eye.admin.patterns.TermFieldBuilder"%>
<%@page import="xpolog.eye.admin.patterns.MapFieldBuilder"%>
<%@page import="xpolog.eye.admin.patterns.BlockFieldBuilder"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%

	String BASE_DIR = "base_directory";
	String CSS_BGCOLOR = "cssBgcolor";
	String PATTERN_TYPE = "PATTERN_TYPE";
	String PATTERN_INDX = "PATTERN_INDX";
	String OP = "OP";
	String TEXT_TO_PARSE = "TEXT_TO_PARSE";
	String STRING_BUILDER = "CURRENT_STRING_BUILDER";
	String FIELD_INDX = "FIELD_INDX";
	String COMPILE_ONLY	  = "COMPILE_ONLY";

	String compileOnlyStr = request.getParameter(COMPILE_ONLY);
	boolean compileOnly = compileOnlyStr != null && compileOnlyStr.equals("true") ;
	if(compileOnly){
		return;
	}
	
	String baseDir = request.getParameter(BASE_DIR);
	if (baseDir == null || baseDir.equals("")) {
		baseDir = BASE_DIRECTORY;
	}
	String cssBgcolor = request.getParameter(CSS_BGCOLOR);
	if (cssBgcolor == null || cssBgcolor.equals("")) {
		cssBgcolor = "#EEF2F5";
	}
	

 String op = request.getParameter(OP);
	if (op == null || op.equals("")) {
		op = "ADD";
	}
	
  int pattIndx = 0 ;	
  String builderId = request.getParameter("BUILDER_ID");
  if(builderId == null){
	builderId = "";
  }
  

  int fieldIndx = 0 ;	
  String fieldIndxStr = request.getParameter(FIELD_INDX);
  try{
	  fieldIndx = Integer.parseInt(fieldIndxStr);
  }catch(Exception e){
	  fieldIndx = 0;
  }
 
  LogBrowsingManager lbm  = null;
  StringSimpleBuilder builder = (StringSimpleBuilder)request.getSession().getAttribute(STRING_BUILDER);
	if(builder != null){
		lbm = builder.getLogBrowserManager();
	}

	if(builder == null || lbm == null){
		out.write("error");
		out.flush();
		return;
	}
	int lastFieldPos = PatternAdminHelper.getPatternsLength(builder,pattIndx);
	PatternManager mgr = builder.getPatternManager();
	FieldBuilder lastBuilder = null;
	pattIndx = PatternAdminHelper.getPatternIndexById(builder,builderId);
	String []events = null;
	FieldBuilder fieldBuilder = null;
	if(op.equals("ADD")){
		fieldBuilder = PatternAdminHelper.getNextFieldSuggestion(builder,pattIndx,20);
	}else if(mgr != null){
			fieldBuilder = mgr.getFieldBuilder(pattIndx,fieldIndx);
	}
	


	String patternType = "",divPath = "", pattern = "", pattName = "";
	
	if(fieldBuilder != null && !op.equals("INSERT")){
		patternType = fieldBuilder.getType();
		divPath = BASE_DIRECTORY + fieldBuilder.getUrl();	
		pattern = fieldBuilder.getId().equals("literal") ? fieldBuilder.getXpologPattern() : fieldBuilder.getPattern();
		pattName = patternType.equals(LiteralFieldBuilder.TYPE) ? "" : fieldBuilder.getName();
	}else{	
		if(mgr != null){
			lastBuilder = mgr.getFieldBuilder(pattIndx,lastFieldPos - 1);						
		}
		patternType = lastBuilder != null && !lastBuilder.getType().equals("literal") ? "literal" : "string";
		divPath = PatternAdminHelper.getUrlByType(patternType);
	}
		
	int insertIndxpPos = -1;
	if(op.equals("ADD")){
		if(PatternAdminHelper.hasDummyBuilder(builder.getPatternManager(),pattIndx)){
			insertIndxpPos = lastFieldPos - 1;
		}else{
			insertIndxpPos = lastFieldPos;
		}
	}else{
		insertIndxpPos = fieldIndx;
	}
	
	
  String stringSelect = "", textSelect = "",dateSelect = "",literalSelect = "", prioritySelect = "", choiceSelect = "",numberSelect = "", timestampSelect = "";
  String eolSelect = "",remoteSelect = "",eoeSelect = "",ipSelect = "",regexp = "",termSelect= "",mapSelect= "",blockSelect= "",expressionSelect = "",freeTextSelect = "";
  String displayVerify = "";
  boolean isDisplayName = true;
  
  if(patternType.equals("string")){
  	stringSelect = "selected";
  }else if(patternType.equals("text")){
  	textSelect = "selected";
  }else if(patternType.equals("priority")){
  	prioritySelect = "selected";
  }else if(patternType.equals("choice")){
  	choiceSelect = "selected";
  }else if(patternType.equals("number")){
  	numberSelect = "selected";
  }else if(patternType.equals("timestamp")){
  	timestampSelect = "selected";
  }else if(patternType.equals("eol")){
  	isDisplayName = false;
  	eolSelect = "selected";
  }else if(patternType.equals("literal")){
  	isDisplayName = false;
		literalSelect = "selected";
  }else if(patternType.equals("date")){
	dateSelect = "selected";
  }else if(patternType.equals("eol")){
  	isDisplayName = false;
		eolSelect = "selected";
  }else if(patternType.equals("eoe")){
  	isDisplayName = false;
  	eoeSelect = "selected";
  }else if(patternType.equals("ip")){
	 ipSelect = "selected";
  }else if(patternType.equals("regexp")){
	 regexp = "selected";
  }else if(patternType.equals("term")){
	 termSelect = "selected";
  }else if(patternType.equals("map")){
 	 mapSelect = "selected";
  }else if(patternType.equals("block")){
  	 blockSelect = "selected";
 	 	isDisplayName = false;
  }else if(patternType.equals("expression")){
  	expressionSelect = "selected";
   }else if(patternType.equals("tab")){
 	isDisplayName = false;
	literalSelect = "selected";
  }else if(patternType.equals("freetext")){
	  freeTextSelect = "selected";
  }
  
  
  boolean isNewField = !op.equals("EDIT");

%>
<%@page import="xpolog.eye.admin.patterns.ExpressionFieldBuilder"%>
<%@page import="xpolog.eye.admin.patterns.FreeTextBuilder"%>
<form AUTOCOMPLETE="OFF" id="patternForm" name="patternForm" action="">

<input type="hidden" id="addFieldBuilderId" name="addFieldBuilderId" value="<%=builderId%>">
<input type="hidden" id="addFieldOP" name="addFieldOP" value="<%=op%>">
<input type="hidden" id="addFieldIndxPos" name="addFieldIndxPos" value="<%=insertIndxpPos%>">

<table border="0" width="100%" cellspacing="0" height="100px" valign="top">
						
	<tr>
		<td valign="top">				
			<table border="0" width="100%" cellspacing="0" cellpadding="0"  valign="top">
			 		<tr valign="top">
				       	<td width="11">&nbsp;</td>
				     		<td>
					     		<table border="0" width="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td width="30%">
													<span class="REGULARTEXT">Type </span>
											</td>
											<td>		
						                  <select class="TEXTBOX" size="1" id="patternType" name="patternType" onchange="javascript:changepatternType('<%=builderId%>','<%=fieldIndx%>')" class="TEXTBOX" style="width:197px">
						                        <option value="<%=LiteralFieldBuilder.TYPE%>" <%=literalSelect%>><%="Separator"%></option>
						                        <option value="<%=StringFieldBuilder.TYPE%>" <%=stringSelect%>>String</option>
						                        <option value="<%=DateFieldBuilder.TYPE%>" <%=dateSelect%>>Date</option>
						                        <option value="<%=TextFieldBuilder.TYPE%>" <%=textSelect%>>Text</option>
						                        <option value="<%=PriorityFieldBuilder.TYPE%>" <%=prioritySelect%>>Priority</option>
																		<option value="<%=ChoicesFieldBuilder.TYPE%>" <%=choiceSelect%>>Choices</option>
						                        <option value="<%=NumberFieldBuilder.TYPE%>" <%=numberSelect%>>Number</option>
						                        <option value="<%=TimestampFieldBuilder.TYPE%>" <%=timestampSelect%>>Timestamp</option>
						                        <option value="<%=EOLFieldBuilder.TYPE%>" <%=eolSelect%>>New Line</option>
						                        <option value="<%=EOEFieldBuilder.TYPE%>" <%=eoeSelect%>>End Of Event</option>
						                        <option value="<%=IPFieldBuilder.TYPE%>" <%=ipSelect%>>IP Address</option>			                        
						                        <option value="<%=TermFieldBuilder.TYPE%>" <%=termSelect%>>Term</option>			                        
						                        <option value="<%=FreeTextBuilder.TYPE%>" <%=freeTextSelect%>>Free Text</option>						                        
														    <optgroup label="Advanced Options">
						                        <option value="<%=RegExpFieldBuilder.TYPE%>" <%=regexp%>>Regular Expression</option>			                        
<!--						                        <option value="<%=BlockFieldBuilder.TYPE%>" <%=blockSelect%>>Optional Section</option>	-->		                        
						                        <option value="<%=ExpressionFieldBuilder.TYPE%>" <%=expressionSelect%>>Function</option>			                        						                        
						                        <option value="<%=MapFieldBuilder.TYPE%>" <%=mapSelect%>>Converter</option>			                        
																</optgroup>				                        
                              </select>
			                      </td>	     											     							
										</tr>
								<tr style="font-size:1px" height="8px">
										<td>&nbsp;</td>
								</tr>
												<tr id="newFieldNameTr" style="display:<%=isDisplayName ? "" : "none"%>">
														<td width="30%">
																	<span class="REGULARTEXT">Name</span>
															</td>
															<td>		
																<input class="TEXTBOX" type="text" name="PattName"  id="PattName" size="30" value="<%=pattName %>" >
															</td>
		  									</tr>
								<tr style="font-size:1px" height="6px">
										<td>&nbsp;</td>
								</tr>
							</table>
					</td>		
			  	</tr>									   		
			</table>
			</td>
			</tr>
				<tr  valign="top">
			  			<td valign="top">
			  					<div id="fieldPropertiesDiv" style="display:">
			  						<jsp:include page="fieldProperties.jsp" flush="true">
										<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
										<jsp:param name="BUILDER_ID" value="<%=builderId%>" />
										<jsp:param name="FIELD_INDX" value="<%=fieldIndx%>" />
										<jsp:param name="FIELD_TYPE" value="<%=patternType%>" />													
										<jsp:param name="SUGGESTED_PATTERN" value="<%=pattern%>" />													
										<jsp:param name="IS_NEW_TYPE" value="<%=isNewField%>" />													
										</jsp:include>  					
			  					</div>
			  			</td>
			  	</tr>
			
				<tr>
						<td valign="top" style="font-size:11;color:red;display:;padding-left:14" height="3px">
								<div id="fieldErroMsgId" style="display:none"></div>
						</td>
				</tr>	
</table>
				     		
</form>