<%@ page language="java"%>

<%@page import="java.util.List"%>
<%@page import="xpolog.eye.admin.patterns.PatternBuilder"%>
<%@page import="xpolog.eye.admin.patterns.PatternManager"%>
<%@page import="xpolog.eye.admin.builders.StringSimpleBuilder"%>
<%!static final String BASE_DIRECTORY = "../../../";%>
<%
	String STRING_BUILDER = "CURRENT_STRING_BUILDER";
	String BASE_DIRECTORY = "BASE_DIRECTORY";
	String PATTERN = "PATTERN";
	String patternAsSrring = "{string}";
	List patternBuilders = null;
	PatternManager patternMgr = null;

	String baseDirectory = request.getParameter(BASE_DIRECTORY);
	if (baseDirectory == null || baseDirectory.length() == 0) {
		baseDirectory = BASE_DIRECTORY;
	}

	String op = request.getParameter("OP");
	if (op == null || op.length() == 0) {
		op = "ADD";
	}

	String pattern = request.getParameter(PATTERN);
	if (pattern == null) {
		pattern = "";
	}

	StringSimpleBuilder builder = (StringSimpleBuilder) request.getSession().getAttribute(STRING_BUILDER);
	if (builder != null && builder.getPatternManager() != null) {
		if (pattern.length() > 0) {
			builder.setRecordPattern(pattern);
			try {
				builder.updateBuilder();
			} catch (Exception e) {

			}
		}
		patternMgr = builder.getPatternManager();
		patternBuilders = patternMgr.getPatternBuilders();
	}
	int pattLinesCntr = patternBuilders == null ? 0 : patternBuilders.size();
	boolean isMultiLine = pattLinesCntr > 1;
	String[] tabNames = new String[pattLinesCntr + 1];
	String[] tabIds = new String[pattLinesCntr + 1];
	String[] widths = new String[pattLinesCntr + 1];
	for (int i = 0; patternBuilders != null && i < patternBuilders.size(); i++) {
		PatternBuilder pattBuilder = (PatternBuilder) patternBuilders.get(i);
		if (pattBuilder != null) {
			tabNames[i] = "Pattern" + (i + 1);
			tabIds[i] = "patternTabDiv_" + pattBuilder.getId();
			widths[i] = "100";
		}
	}
	tabNames[pattLinesCntr] = "New";
	tabIds[pattLinesCntr] = "patternTabDiv_NEW";
	widths[pattLinesCntr] = "50";
	request.setAttribute("tabIds", tabIds);
	request.setAttribute("tabNames", tabNames);
	request.setAttribute("tabbarIds", tabIds);
	request.setAttribute("tabWidths", widths);

	PatternBuilder pattBuilder = null;
	boolean ignoreMenuInitilize = false;
%>
<table id="patternsWizards" border="0" width="100%" cellspacing="0"
	height="168px" cellpadding="0">
	<tr valign="top">
		<td valign="top">
		<table id="patternsTabs" border="0" width="100%" cellspacing="0"
			height="100%" cellpadding="0">
			<tr valign="top">
				<td valign="top">

				<div id="tabbarDiv" style="width: 100%; height: 168px; display: ;"></div>

				<%
					for (int i = 0; patternBuilders != null && i < patternBuilders.size(); i++) {
						if (op.equals("ADD") && i > 0 && !isMultiLine) {
							break;
						}
						pattBuilder = (PatternBuilder) patternBuilders.get(i);
						if (pattBuilder == null) {
							continue;
						}
						String patternBuilderId = pattBuilder.getId();
						int patternIndx = patternMgr.getPatternIndexById(patternBuilderId);
// 						patternAsSrring = pattBuilder.getPatternAsString().replaceAll("DUMMY", "text");
						patternAsSrring = patternMgr.getMgrXpologPattern(i).replaceAll("DUMMY", "text");
						ignoreMenuInitilize = i > 0;
				%>

				<div id="patternTabDiv_<%=patternBuilderId%>" style="display:none;width:100%">
							<%boolean compileOnly = 	op.equals("ADD");	%>	
																		<jsp:include flush="true" page="tabPattern.jsp">
																				<jsp:param name="BASE_DIRECTORY" value="<%=baseDirectory%>" />
																				<jsp:param name="PATTERN_INDEX" value="<%=patternIndx%>" />
																				<jsp:param name="PATTERN" value="<%=patternAsSrring%>" />
																				<jsp:param name="BUILDER_ID" value="<%=patternBuilderId%>" />
																				<jsp:param name="ignoreMenuInitilize" value="<%=ignoreMenuInitilize%>" />
																				<jsp:param name="compileOnly" value="<%=compileOnly%>" />
																	</jsp:include>
				</div>


				<%
					}
				%>
				<div id="patternTabDiv_NEW" style="display: none"></div>


				<jsp:include page="../../../widgets/tabs/jsp/tabsIncluder.jsp"
					flush="true">
					<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
					<jsp:param name="style" value="patternadmin" />
					<jsp:param name="menuObj" value="aMenu" />
					<jsp:param name="useArrow" value="true" />
				</jsp:include> <script>
		function addXPLGTab(tabId,id,name,width){
		  if (id == "patternTabDiv_NEW"){
		    tabbar.enableTabCloseButton(false);
		  }
		  tabbar.addTab(tabId,name,width);
		  tabbar.setContent(tabId,id);
		  tabbar.enableTabCloseButton(true);
		}
	 	 
	 //TAB MENU
    aMenu=new dhtmlXContextMenuObject('40',0,"<%=baseDirectory%>dhtmlxSuite/dhtmlxMenu/codebase/imgs/");
    aMenu.menu.setZIndex(200);
 		//set css
		aMenu.menu.tableCSS="menuTable";
						
		//create menu item
		//remove
		var item = new dhtmlXMenuItemObject("remove_pattern","Remove","","","contextMenu","","javascript:removePattern();");
		aMenu.menu.addItem(aMenu.menu,item);		
		//move left
		var item = new dhtmlXMenuItemObject("move_left","Move Left","","","contextMenu","","javascript:moveTab('left');");
		aMenu.menu.addItem(aMenu.menu,item);
		//move right
		var item = new dhtmlXMenuItemObject("move_right","Move Right","","","contextMenu","","javascript:moveTab('right');");
		aMenu.menu.addItem(aMenu.menu,item);
		//Duplicate
		var item = new dhtmlXMenuItemObject("duplicate","Duplicate","","","contextMenu","","javascript:duplicatePattern();");
		aMenu.menu.addItem(aMenu.menu,item);
		
		 aMenu.setOnShowMenuHandler(function(){
              var count = getTabsCount(tabbar);
//							alert(aMenu.contextMenu.zoneId);
              if (count > 2){
              if(aMenu.contextMenu){
//									alert(aMenu.contextMenu.zoneId);
							}
                aMenu.menu.showItem("move_left");
                aMenu.menu.showItem("move_right");
              }else {
                aMenu.menu.hideItem("move_left");
                aMenu.menu.hideItem("move_right");
              }
            });   
 			
				
			
		</script></td>
			</tr>
		</table>
		</td>
	</tr>
</table>