<%@page import="xpolog.config.Configuration"%>
<%@ page language="java"%>
<%@page import="java.util.LinkedList"%>
<%@page import="xpolog.eye.data.log.LogRecord"%>
<%@page import="xpolog.eye.data.Record"%>
<%@page import="java.util.List"%>
<%@page import="xpolog.eye.admin.patterns.PatternManager"%>
<%@page import="xpolog.eye.admin.builders.StringSimpleBuilder"%>
<%@page import="xpolog.eye.logview.LogEyeRowRenderer"%>
<%@page import="xpolog.eye.logview.LogEyeCellRenderer"%>
<%@page import="omega.ui.html.table.OHtmlTable"%>
<%@page import="xpolog.eye.logview.LogEyeModel"%>
<%@page import="xpolog.eye.data.RecordsMaskTableModel"%>
<%@page import="xpolog.eye.LogBrowsingManager"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
	static final int MAX_HEADER_LINES  = 25;
%>
<%
	String BASE_DIR = "BASE_DIRECTORY";
	String STRING_BUILDER = "CURRENT_STRING_BUILDER";
	String PATTERN = "PATTERN";
	String errorMsg = "<table><tr><td>Please check if pattern accurately describes the log records</td></tr></table>";
	String result = "";
	String baseDir = request.getParameter(BASE_DIR);
	if (baseDir == null || baseDir.equals("")) {
		baseDir = BASE_DIRECTORY;
	}
	String builderId = request.getParameter("BUILDER_ID");
	if(builderId == null){
		builderId = "";
	}
	String patternStr = request.getParameter(PATTERN);
	if(patternStr == null){
		patternStr = "";
		
	}

	LogBrowsingManager lbm  = null;
  String originalPattern = "";
  StringSimpleBuilder builder = (StringSimpleBuilder)request.getSession().getAttribute(STRING_BUILDER);
	if(builder != null){
	  PatternManager pattMgr = builder.getPatternManager();
	  String pattToAnalysed = "";
//	  patternStr = patternStr.length() > 0 ? patternStr : pattMgr.getPatternsAsString();
	  patternStr = patternStr.length() > 0 ? patternStr : pattMgr.getMgrXpologPattern();
	  //ANALYSE ALWAYS MULTI
		if(patternStr.length() > 0){
//	  	originalPattern = pattMgr.getPatternsAsString();
	  	originalPattern = pattMgr.getMgrXpologPattern();
	  	pattToAnalysed = patternStr;
	  	builder.setRecordPattern(pattToAnalysed);
			builder.updateBuilder();			
		}
		lbm = builder.getLogBrowserManager();

	}

	if(builder == null || lbm == null){
		out.write(errorMsg);
		out.flush();
		return;
	}
	List recResults = null;	
	try{
	//log table example
	boolean foundParseRec = false;
  String html = "";
  RecordsMaskTableModel model = null;
  String header = "UNPARSED LINES \n";
  int unparsedRowCntr = 0;
  String charset = lbm.getCharset();
	if(charset == null){
	  charset = Configuration.getInstance().getPropertiesManager().getProperty("logview.defaultCharecterEncoding", null);
		if(charset != null && charset.length() == 0) {
			charset = null;
		}
	}
  if (charset != null){
    response.setContentType("text/html; charset=" + charset);
  }
  model = lbm.getFirstEntries(100);  
	recResults = model.getRecords();
	if(recResults != null && !recResults.isEmpty()){
		LogRecord record = null;
		for(int i = 0 ; i < recResults.size() && i < MAX_HEADER_LINES ; i++){
			record = (LogRecord)recResults.get(i);
			if (record.isSpecialType(Record.UNPARSER_SPECIAL_TYPE) || record.isSpecialType(Record.MESSAGE_SPECIAL_TYPE)){
				if(record.getFieldAt(0) != null && record.getFieldAt(0) instanceof String){
					header += record.getFieldAt(0)  + "\n";
				}
				unparsedRowCntr++;
			}else{
				foundParseRec = true;
				break;
			}
		}
	}
	if(unparsedRowCntr > 0 && foundParseRec){
		LogRecord headerRec = (LogRecord)recResults.get(0);
		if(headerRec != null){
			String []headerArr = new String[1];
			headerArr[0] = header;
			headerRec.setAllFields(headerArr);
		}
		List parsedRecsList =  new LinkedList();
		parsedRecsList.add(headerRec);
		for(int i = unparsedRowCntr; recResults != null && i < recResults.size() ; i++){
			parsedRecsList.add(recResults.get(i));
		}
		int index = 20;
		if(parsedRecsList.size() < index){
			index = parsedRecsList.size();
		}
		model.setRecords(parsedRecsList.subList(0,index));
	}else{
	  model = lbm.getFirstEntries(20);  
	  if(unparsedRowCntr > 0 && !foundParseRec){
		  result = "UNPARSED@";
	  }
	}
	
	if(model.getRowCount() == 0){
  	html = "<table><tr class=\"REGULARTEXT\"><td><span style=\"font-size: 8pt;color:red\" >No parsed records were found.<br>Please check if pattern accurately describes the log records!.</span></td></tr></table>";
	}else{
	    //html creation
	    LogEyeModel lem = new LogEyeModel(baseDir,lbm.getCustomizationManager(),model);
	    // don't use priority coloring in admin
	    lem.getCustomizationManager().setUsePriorityBgColor(false);
	    OHtmlTable tab = new OHtmlTable(lem);

	    LogEyeCellRenderer cr = new LogEyeCellRenderer(lem);
	    LogEyeRowRenderer rr = new LogEyeRowRenderer(lem);
	    tab.setRowRenderer(rr);
	    tab.setCellRenderer(cr);
	    tab.render();
	    html = tab.getHtml();
	    html = html.replaceAll("DUMMY","Extra Text");
	}
		if(originalPattern != null && originalPattern.length() > 0){
			builder.setRecordPattern(originalPattern);
			builder.updateBuilder();
		}
	  result += html;
	  out.write(result);
	  out.flush();
	  return;
	}catch(Exception e){
		out.write(errorMsg);
		out.flush();
		return;
	}
%>