<%@ page language="java"%>	

<%@page import="xpolog.eye.admin.patterns.PatternManager"%>
<%@page import="xpolog.eye.admin.builders.StringSimpleBuilder"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%

	String BASE_DIRECTORY = "BASE_DIRECTORY";
	String BUILDER_ID = "BUILDER_ID";
	String STRING_BUILDER = "CURRENT_STRING_BUILDER";
	String OP = "OP";
	
	String baseDirectory = request.getParameter(BASE_DIRECTORY);
	if(baseDirectory == null || baseDirectory.length() == 0){
		baseDirectory = BASE_DIRECTORY;
	}
	
	String builderId = request.getParameter(BUILDER_ID);
	if(builderId == null){
		builderId = "";
	}
	String pattern = "";
	String op = request.getParameter(OP) ;	
	boolean isAddingNewPattern = op != null && op.equals("ADD");
	boolean isDuplicatePattern = op != null && op.equals("DUPLICATE");
	boolean isMovePattern = op != null && op.equals("MOVE");
	if(builderId.length() == 0 || isAddingNewPattern){
		pattern = "{string:DUMMY}";
	}else if(builderId.length() > 0 && (isDuplicatePattern || isMovePattern)){
		StringSimpleBuilder builder = (StringSimpleBuilder)request.getSession().getAttribute(STRING_BUILDER);
		if(builder != null){
			PatternManager mgr = builder.getPatternManager();
			int indx = mgr.getPatternIndexById(builderId);
			if(indx > -1){
				pattern = mgr.getPatternsAsString(indx);
			}
		}
	}

%>
<div id="patternTabDiv_<%=builderId%>" >
					<jsp:include flush="true" page="tabPattern.jsp">
					<jsp:param name="BASE_DIRECTORY" value="<%=baseDirectory%>"/>
					<jsp:param name="PATTERN_INDEX" value="-1"/>
					<jsp:param name="PATTERN" value="<%=pattern%>"/>
					<jsp:param name="BUILDER_ID" value="<%=builderId%>"/>
					</jsp:include> 																																
	</div>
