<%@ page language="java"%>

<%@page import="java.util.List"%>
<%@page import="xpolog.eye.admin.patterns.PatternAdminHelper"%>
<%@page import="xpolog.eye.knowledge.log.LogAdminResult"%>
<%@page import="xpolog.eye.admin.builders.StringSimpleBuilder"%>
<%@page import="java.text.DecimalFormat"%>
<%@page import="xpolog.eye.admin.helpers.LogAdminHelper"%>
<%@page import="xpolog.eye.util.XMLUtil"%>
<%@page import="xpolog.eye.error.ErrorModel"%>
<%@page import="org.w3c.dom.Element"%>

<%
	String STRING_BUILDER = "CURRENT_STRING_BUILDER";
	DecimalFormat df1 = new DecimalFormat("####.0");

	String []events = null;
	List patternsList = null;
	StringSimpleBuilder builder = (StringSimpleBuilder)request.getSession().getAttribute(STRING_BUILDER);
	if(builder != null){
		events = builder.getEvents();
		patternsList = PatternAdminHelper.getPatternSuggestions(events,builder);
		if(patternsList == null || patternsList.size() == 0){
  		builder.setRecordPattern("{string:DUMMY}");
		}else{
		  LogAdminResult res = (LogAdminResult)patternsList.get(0);
			if(res != null && res.getXpologPattern() != null){
				builder.setRecordPattern(res.getXpologPattern());
			}else if(res != null && res.getXmlLogTemplate() != null &&  res.getXmlLogTemplate().length() > 0 ){
				try {
				  Element elem = XMLUtil.parseString(res.getXmlLogTemplate());
				  if (elem != null){
				    String pattern = LogAdminHelper.getLogPattern(elem);
				    builder.setRecordPattern(pattern);
				  }
				}catch (Exception e){
					ErrorModel.log.error("failed to parse tempate xml " + res.getXmlLogTemplate(),e);
				}
			}
		}
		try{
			builder.updateBuilder();
		}catch(Exception e){
			System.out.println(e);
		}		
	}	
  String patternStr = "";
  String patternDispalyName = "";
  String accuracyLevelStr = "";
  int patternSize = patternsList != null ? patternsList.size() : 0;
  
 	String builderId = builder.getPatternManager().getPatternIdByIndex("0");

%>
<input type="hidden" value="<%=builderId%>" name="firstPatternSuggBuilderId" id="firstPatternSuggBuilderId">
<table border="0" cellpadding="0" width="100%" cellspacing="0" align="left" style="padding-left:11px">
          <tr style="font-size:1" height="11px">
           	<td colspan="2">
           		&nbsp;
           	</td>
          </tr>															
          <%String firstPattern = "checked";
          	boolean isMultiLine = false;
         	for(int i = 0 ; i < patternSize && i < 4; i++){
        	  LogAdminResult res = (LogAdminResult)patternsList.get(i);
	  				if(res != null && res.getXpologPattern() != null){
	  				patternStr = res.getXpologPattern();
	  				isMultiLine = patternStr.indexOf("\n") > 0;
	  				patternStr = patternStr.replaceAll("<","&lt;");
	  				patternStr = patternStr.replaceAll(">","&gt;");
	  				patternStr = patternStr.replaceAll("\"","&quot;");

	  				
	  				patternDispalyName = patternStr.length() < 80 ? patternStr : patternStr.substring(0,35) + " ... " + patternStr.substring(patternStr.length() - 40,patternStr.length());
	  				try{
		  				accuracyLevelStr =  "(" +df1.format(res.getAccuracyLevel()) + "%)";										  				
	  				}catch(Exception e){
	  					accuracyLevelStr = "N/A";
	  				}
        	%>
          <tr  valign="middle"">
           	<td width="*">
           		<input type="radio" value="<%=patternStr%>" name="patterns" id="patterns" onClick="javascript:changePattern('<%=builderId%>',this.value,'<%=isMultiLine%>');"  <%=firstPattern%>><span class="REGULARTEXT" title="<%=patternStr%>"><%=patternDispalyName%></span>
           	</td>
           	<td width="60px" class="REGULARTEXT" align="right"  style="padding-right:11px"><%=accuracyLevelStr%></td>								           									           	
          </tr>		
          <%
		  			firstPattern = "";
          }}%>													
          <tr valign="top">
           	<td width="*">
           		<input type="radio" value="{string:DUMMY}" name="patterns" id="patterns" onClick="javascript:changePattern('<%=builderId%>',this.value,false);" <%=patternSize == 0 ? "checked" : "" %>><span class="REGULARTEXT">Define pattern manually</span>
           	</td>
           	<td width="60px" class="REGULARTEXT" align="right" style="padding-right:11px">&nbsp;</td>
          </tr>	
          <tr style="font-size:1" height="100%">
           	<td colspan="4">
           		&nbsp;
           	</td>
          </tr>
			<tr>
			<td colspan="4" align="right">
				<table border="0" cellpadding="0" width="100%" cellspacing="0" >				
						<tr align="right">
							<td width="90%">&nbsp;</td>
							<td width="5%" style="padding-right:3px;padding-bottom:3px">
									<table border="0" width="100%" cellspacing="0" >
											<tr>									
							         		<jsp:include page="../../../common/ctrlButton.jsp" flush="true">
													<jsp:param name="baseDirectory" value="../../"/>
													<jsp:param name="name" value="Edit"/>
													<jsp:param name="action" value="javascript:applySuggestion('wizard')"/> 
													</jsp:include>				         
											</tr>
									</table>
							</td>						
							<td  align="right" width="5%" style="padding-right:3px;padding-bottom:3px">
									<table border="0" width="100%" cellspacing="0" >
											<tr>									
							         		<jsp:include page="../../../common/ctrlButton.jsp" flush="true">
													<jsp:param name="baseDirectory" value="../../"/>
													<jsp:param name="name" value="Save"/>
													<jsp:param name="action" value="javascript:doSaveLog()"/> 
													</jsp:include>				         
											</tr>
									</table>
							</td>												
						</tr>
				</table>
			</td>				
    </tr>		
</table> 
