<%@page import="xpolog.eye.admin.patterns.PatternBuilder"%>
<%@page import="java.util.Map"%>
<%@page import="xpolog.eye.admin.builders.StringSimpleBuilder"%>
<%@page import="java.util.List"%>
<%@page import="xpolog.eye.admin.patterns.PatternManager"%>
<%@ page language="java"%>
<%@page import="xpolog.eye.admin.patterns.PatternAdminHelper"%>
<%@page import="xpolog.eye.admin.patterns.FieldBuilder"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	String BASE_DIR = "base_directory";
	String PATTERN_TYPE = "PATTERN_TYPE";
	String PATTERN_INDX = "PATTERN_INDX";
	String TEXT_TO_PARSE = "TEXT_TO_PARSE";
	String STRING_BUILDER = "CURRENT_STRING_BUILDER";
	String FIELD_INDX = "FIELD_INDX";
	String PATTERN_NAME = "PATTERN_NAME";
	String FIELD_PATTERN = "FIELD_PATTERN";
	String OP = "OP";
	  
	String baseDir = request.getParameter(BASE_DIR);
	if (baseDir == null || baseDir.equals("")) {
		baseDir = BASE_DIRECTORY;
	}
	
	 String op = request.getParameter(OP);
		if (op == null || op.equals("")) {
			op = "ADD";
		}

	  int patternIndx = 0 ;	
	  String builderId = request.getParameter("BUILDER_ID");
	  if(builderId == null){
	  	builderId = "";
	  }
	
	  int fieldIndx = 0 ;	
	  String fieldIndxStr = request.getParameter(FIELD_INDX);
	  try{
		  fieldIndx = Integer.parseInt(fieldIndxStr);
	  }catch(Exception e){
		  fieldIndx = 0;
	  }
	 
	  String patternType = request.getParameter(PATTERN_TYPE);
	  if(patternType == null){
	  	patternType = "string";
	  }  
	  
	  Map pattInfoMap = request.getParameterMap();
		FieldBuilder fieldBuilder = PatternAdminHelper.createFieldBuilder(patternType,pattInfoMap);
		if(fieldBuilder == null){
			out.write("error");
			out.flush();
			return;
		}
		String fieldValidteErrorMsg = PatternAdminHelper.validateFieldFormat(fieldBuilder);
		if(fieldValidteErrorMsg.length() > 0){
			out.write("error#" + fieldValidteErrorMsg);
			out.flush();
			return;
			
		}
		
		StringSimpleBuilder builder = (StringSimpleBuilder)request.getSession().getAttribute(STRING_BUILDER);
		if(builder != null){
			PatternManager mgr = builder.getPatternManager();
			patternIndx  = mgr.getPatternIndexById(builderId);
			if(mgr != null){
				List list = mgr.getFiledBuildersByPatternIndx(patternIndx);
				if(list == null){
					out.write("error");
					out.flush();
					return;
				}
				if(!op.equals("EDIT")){
					int prevBuilderIndx = -1;
					if(op.equals("INSERT")){
						prevBuilderIndx = fieldIndx;
					}
					String errorMsg = PatternAdminHelper.fieldPermission(list,fieldBuilder,prevBuilderIndx);
					if(errorMsg.length() > 0){
						out.write("error#" + errorMsg);
						out.flush();
						return;				
					}
				}
				
				int userCurrFieldPos = fieldIndx;	
				if(op.equals("ADD")){
					mgr.addFieldToPattern(list,fieldIndx,fieldBuilder,"ADD");
				}else if(op.equals("INSERT")){
					userCurrFieldPos += 1;
					mgr.addFieldToPattern(list,fieldIndx + 1,fieldBuilder,"INSER");
				}else{
					list.set(fieldIndx,fieldBuilder);
				}
				

				// update suggestion handler obj.
				PatternBuilder patternBuilder = (PatternBuilder)mgr.getPatternBuilders().get(patternIndx);
				if(patternBuilder != null && fieldBuilder.isOptional()){
					patternBuilder.getBlockBuildersIndexs().add(String.valueOf(fieldBuilder.getColIndex()));
				}
				if(patternBuilder != null && patternBuilder.getPattSuggestionHandler() != null){
					patternBuilder.getPattSuggestionHandler().updateUserCurrSuggestion(fieldBuilder,userCurrFieldPos);
					int currSuggestionPod = patternBuilder.getPattSuggestionHandler().getCurrFieldPos();
					currSuggestionPod = currSuggestionPod == -1 ? 1 : currSuggestionPod + 1;
					patternBuilder.getPattSuggestionHandler().setCurrFieldPos(currSuggestionPod);
				}

				builder.setRecordPattern(mgr.getPatternsAsString());
			try{
				builder.updateBuilder();
			}catch(Exception e){
				out.write("error#Illegal pattern. Please check pattern!.");
				out.flush();
				return;		
			}
				out.write("ok" + "#" + builderId + "#" + mgr.getPatternsAsString()  + "#" + mgr.getPatternsAsString(patternIndx));
				out.flush();
				return;
			
			}		
		}
	
		
	%>
