<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="xpolog.eye.common.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="omega.ui.models.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="omega.ui.html.table.OHtmlTable"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%> 
<%@ page import="java.sql.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  //constants
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String CURRENT_MODULE = "CURRENT_MODULE";
  String ERROR_OBJ = "ERROR_OBJ";
  String SQL_TO_VERIFY = "sqlQuery";
  String SELECTED_LBMS = "selectedLbms";
  String AdvancedPatternDefinitionLink = null;
  String logDataPattern = null;
  String verifyQuery = request.getParameter(SQL_TO_VERIFY);
  int MAX_NUMBER_OF_RECORDS_FOR_PERMISSION = 100;
  int ALLOWED_LOG_NAME_LENGTH = 30;
  //page data
 
  LogBrowsingManager lbm = null;

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  
  UserContext userContext = UserEnvironment.getUserContext(request);
  boolean isPermittedAddLog = WebSecurityManager.getInstance().isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_LOG_PERMISSION);

  SQLLogSimpleBuilder builder = (SQLLogSimpleBuilder)request.getSession().getAttribute(BUILDER);
  
  if(builder == null){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("No builder exsited in session");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect("../errorpage.jsp");
    return;
  }
  String userAgreed = request.getParameter("userAgreed");
	  String isFirstTimeStr = request.getParameter("isFirstTime");
	  boolean isFirstTime = isFirstTimeStr != null && isFirstTimeStr.equals("true");
	  
	  String executeQueryStr = request.getParameter("executeQuery");
	  boolean executeQuery = executeQueryStr != null && executeQueryStr.equals("true");
	  
	  String showResultsStr = request.getParameter("showResults");
	  boolean showResults = showResultsStr != null && showResultsStr.equals("true");
	  
	  String errorQuery = "";
	  boolean queryOk = true;
	  
	  RecordMask oldMask = null;
	  String sql = null;
	
	  lbm = builder.getLogBrowserManager();	
	  String query = builder.getQuery();
	  
	  // create the tables names list
	 
	  boolean runLogBrowser = true;
	  
	  String [] selectedLbmIds = builder.getLbmIds();
	  String [] selectedFilterIds = builder.getFilterIds();
	
	  boolean isLogsFiltersIdentical = true;
	  DBAccount account = (DBAccount)builder.getAccount();
	  DBMedia media = (DBMedia)builder.getMedia();
	  if (!isFirstTime && !showResults){
	 
	    String [] lbmFilterIds = request.getParameterValues(SELECTED_LBMS);
	    //put values on session for later fetch
	    if(userAgreed == null) {
	    	request.getSession().setAttribute(SELECTED_LBMS,lbmFilterIds);
	    }
	    if(lbmFilterIds == null && userAgreed != null) {
	    	lbmFilterIds = (String [])request.getSession().getAttribute(SELECTED_LBMS);
	    }
	    if (lbmFilterIds  != null){    
	      isLogsFiltersIdentical = lbmFilterIds.length == selectedLbmIds.length;
	      String [] lbmIds = new String[lbmFilterIds.length];
	  	  String [] filterIds = new String[lbmFilterIds.length];
	      for (int i = 0; i < lbmFilterIds.length; i++) {
	        int index = lbmFilterIds[i].indexOf(";");
	        lbmIds[i] = lbmFilterIds[i].substring(0,index);
	        filterIds[i] = lbmFilterIds[i].substring(index + 1,lbmFilterIds[i].length());
	        if (isLogsFiltersIdentical){
	          isLogsFiltersIdentical = selectedLbmIds[i].equals(lbmIds[i]) && selectedFilterIds[i].equals(filterIds[i]);
	        }
	      }
	      selectedLbmIds = lbmIds;
	      selectedFilterIds = filterIds;
	    }else {
	      	selectedLbmIds = new String[0];
	      	selectedFilterIds = new String[0];
	    }
	  	builder.setLogsInfo(selectedLbmIds,selectedFilterIds);
	  	if(lbmFilterIds == null || lbmFilterIds.length == 0 || lbmFilterIds[0].length() == 0){
	    	errorQuery = "No selected logs were supplied.";
	    	queryOk = false;
	  	}
	  	
	    boolean isQueryIdentical = false;
	    
	  	if(verifyQuery != null && !verifyQuery.equals("")) {
	  	  query = verifyQuery;
	    }else {
	      query = builder.getQuery();
	  	}
	    query = query.trim();
	  
	    builder.setColumnsPattern(null);
	
	    builder.setQuery(query);
	     if(query == null || query.trim().equals("")){
	        if (!queryOk){
	          errorQuery += "<br>";
	        }
	    	errorQuery += "No SQL Query was supplied.";
	    	queryOk = false;    	
	  	 }
	 
	  	logDataPattern =  isQueryIdentical? LogAdminHelper.getXpologPattern(lbm) : null;
	  	if(logDataPattern != null && !logDataPattern.equals("")) {
			if(!logDataPattern.equals("{string}")){
				builder.setRecordPattern(logDataPattern);
			  	builder.buildPatternFields();
			  	runLogBrowser = true;
			}
	  	}
	  
	  	String[] pattern = builder.getColumnsPattern();
	  	String check = "";
	  	String fieldName = "";
	    
	  	String maxRecordsToUseChoice = request.getParameter("maxRecordsToUseChoice");
	  	String maxRecordsToUseStr = request.getParameter("maxRecordsToUse");
	  	int maxRecordsToUse = builder.getMaxRecordsToUse();
	  	if (maxRecordsToUseChoice != null){  	
	    	if (maxRecordsToUseChoice.equalsIgnoreCase("custom") && maxRecordsToUseStr != null){
	   		  if (maxRecordsToUseStr.trim().length() > 0){
	        	try {
	        	  maxRecordsToUse = Integer.parseInt(maxRecordsToUseStr);
		          if (maxRecordsToUse < 0){
	    	       maxRecordsToUse = builder.getMaxRecordsToUse();
	        	  }
		        }catch (Exception e){}
	    	  }else {
		        maxRecordsToUse = -1;
	    	  }
	        }else {
	          maxRecordsToUse = -1;
	        }
		  }
		  builder.setMaxRecordsToUse(maxRecordsToUse);
		  //check if memory problems will rise.
  	  	  int checkQuery = LogSQLAdminHelper.checkMemoryQuery(query);
  	  	  if(((checkQuery > 0 && maxRecordsToUse > 10) || (checkQuery > 5 && maxRecordsToUse > 5) || (checkQuery > 0 && maxRecordsToUse == -1)) && userAgreed == null) {
  	  	     response.sendRedirect("askUserPermission.jsp?url=SQLAnalyzerPattern.jsp");
  	         return;
  	  	  }
	  try{
	  	//if query not valid default pattern exists
    	builder.updateBuilder();
	    builder.buildPatternFields();
    	lbm = builder.getLogBrowserManager();
    	if (oldMask != null){
     	  builder.getLogBrowserManager().setRecordMask(oldMask);
    	} 
 	}catch(Exception e){
 		if (!queryOk){
          errorQuery += "<br>";
        }
    	errorQuery += e.getMessage();
	    queryOk = false;
  	}
 }
 
  //check if the query is executable
  if(!media.verifyQuery() || !media.isUpdateVerification()){
	  if (!queryOk){
          errorQuery += "<br>";
       }
	  errorQuery += media.getLastErrorMessage();
	  queryOk = false;
	  runLogBrowser = false;
  }

  HashSet selectedLbmsFilters = new HashSet();
  HashSet selectedLbms = new HashSet();
  for (int i = 0; i < selectedLbmIds.length; i++) {
    selectedLbmsFilters.add(selectedLbmIds[i] + ";" + selectedFilterIds[i]);
    selectedLbms.add(selectedLbmIds[i]);
  }
  Module[] mdarr = mgmt.getAllModules(userContext,true);
  ModuleMember curmod = new ModuleMember();
  Module pmod = (Module)request.getSession().getAttribute(CURRENT_MODULE);
  if(pmod == null){
    pmod = new Module();
    pmod.setId("");
  }
  if (mdarr.length == 0){
    Module tmpMod = new Module();
    tmpMod.setId("");
    mdarr = new Module [] {tmpMod};
  }
  
  String html = "";
  String resultText = "";
  runLogBrowser = runLogBrowser && queryOk;
  
  final UserEnvironment env = UserEnvironment.getUserEnvironment(request);

%>

<%
  if(runLogBrowser && !showResults && ( executeQuery || !isFirstTime)){
	
	JobStatus status = lbm.getLinearDataBuilder().getLinearDataSource().getJobStatus();
	env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, status); 
	
	final LogBrowsingManager lbmRunner = lbm;
	
	ProgressRunner runner = new ProgressRunner("SQLAnalyzerPattern.jsp?showResults=true") {
 	 public void run(HttpServletRequest request){
    	 RecordsMaskTableModel model = lbmRunner.getFirstEntries(20);
    	 env.setTempAttribute("resultsModel", model); 
  	 }
	};
	env.setProgressRunner(runner);
  
%>
<jsp:include page="../../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Processing"/>
 <jsp:param name="useStatus" value="true"/>
 <jsp:param name="stopUrl" value="loggers/admin/common/adminPumperStopAction.jsp"/>
</jsp:include>
<%
    return;
  }else {
    if (showResults){
      RecordsMaskTableModel model = (RecordsMaskTableModel)env.getTempAttribute("resultsModel");
      if (model != null){
        //html creation
        LogEyeModel lem = new LogEyeModel(BASE_DIRECTORY,lbm.getCustomizationManager(),model);
        OHtmlTable tab =  new OHtmlTable(lem);
        LogEyeCellRenderer cr = new LogEyeCellRenderer(lem);
        LogEyeRowRenderer rr = new LogEyeRowRenderer(lem);
        tab.setRowRenderer(rr);
        tab.setCellRenderer(cr);
        tab.render();
        html = tab.getHtml();
     
        int totalRecords = LogSQLAdminHelper.getLastQueryResultCount(lbm);
        int rowCount = model.getRowCount();
        if (totalRecords >= 0){
          resultText = "(" + rowCount + "/" + totalRecords + ")";
        }
      }
    }
  }

%>

    

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<jsp:include page="../../../scripts/dataview/dataView.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
</jsp:include>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script language="javascript">	
	
	function goToLogView(){
		prepareToSubmit();
    	document.access.action = "SQLAnalyzerPatternAction.jsp";
        document.access.submit();
	}
	   	 
   	function doVerify(){
   		prepareToSubmit();
        document.access.action = "SQLAnalyzerPattern.jsp";
  	    document.access.submit();
    }
    
    function showSaveSettings(){
      showHideLayerInMiddle("saveSettingsDiv",-1,-1);
    }
    
    function doSave(){
    	prepareToSubmit();
        document.access.action = "SQLAnalyzerPatternAction.jsp?doSave=true";
  	    document.access.submit();
	}
	
	function prepareToSubmit(){
	  var selectedCombo = document.getElementById("selectedLbms");
 	  if (selectedCombo.options.length == 1 && selectedCombo.options[0].value == ""){
    	selectedCombo.options[0] = null;
  	  }
  	  for (var i = 0; i < selectedCombo.options.length; i++){
    	selectedCombo.options[i].selected =true;
      }
	}
	
	
	function Filter(id,name,isSelected){
	this.id = id;
	this.name = name;
	this.isSelected = isSelected;
}


function LBM(id,name){
	this.id = id;
	this.name = name;
	this.filters = new Array();
	this.filtersInit = false;
}

var lbms = new Array();
<%
  String name = null;
  ModuleMember [] membersLbm = SiteManagment.getInstance().getAllLogBrowsersIdsByContext(userContext,false);
   for (int i = 0; i < membersLbm.length; i++) {
     try {
     String id = membersLbm[i].getId();
     boolean isSelectedLbm = selectedLbms.contains(id);
     String [][] filters =  !isSelectedLbm ? new String [0][0] : SiteManagment.getInstance().getFiltersForLogBrowserManager(id);
     name = membersLbm[i].getName();
	 if(name != null && name.length()>ALLOWED_LOG_NAME_LENGTH) {
		 name = name.substring(0,ALLOWED_LOG_NAME_LENGTH)+"...";
	 }
    
%> 
   var lbm = new LBM("<%=id%>","<%=name%>");
   lbm.filters[lbm.filters.length] = new Filter("","None",<%=selectedLbmsFilters.contains(id + ";")%>);
   lbm.filtersInit = <%=String.valueOf(isSelectedLbm)%>;
<%
   	
   	for (int j = 0; j < filters.length; j++) {
   	  String filterId = filters[j][0];
   	  String fName = filters[j][1];
   	  if(fName != null && fName.length()> ALLOWED_LOG_NAME_LENGTH) {
		 fName = fName.substring(0,ALLOWED_LOG_NAME_LENGTH)+"...";
	 }
%>
  lbm.filters[lbm.filters.length] = new Filter("<%=filterId%>","<%=fName%>",<%=selectedLbmsFilters.contains(id + ";" + filterId)%>);
  
<% 	} %>
   lbms[lbms.length] = lbm;
<%}catch (Exception e){}
 } %>
	

function initLbms(){
  var selectedCombo = document.getElementById("selectedLbms");
  selectedCombo.options[selectedCombo.options.length] = new Option("           ","");
  var lbmCombo = document.getElementById("lbms");
  for (var i = 0; i < lbms.length; i++){
    lbmCombo.options[lbmCombo.options.length] = new Option(lbms[i].name,lbms[i].id);
  }
  if (lbms.length > 0){
    lbmCombo.selectedIndex = 0;
  }
  initSelectedLbms();
  initFilters();
}

function initSelectedLbms(){
  <% for (int i = 0; i < selectedLbmIds.length; i++){%>
      initSelectedLbm("<%=selectedLbmIds[i]%>","<%=selectedFilterIds[i]%>");
  <%}%>
}

function initSelectedLbm(lbmId,filterId){
   for (var i = 0; i < lbms.length; i++){
     if (lbms[i].id == lbmId){
       for (var j = 0; j < lbms[i].filters.length; j++){
         if (lbms[i].filters[j].id == filterId){
           addSelectedLbm(i,j);
         }
       }
     }
   }
}

function initFilters(){
  var lbmCombo = document.getElementById("lbms");
  var filterCombo = document.getElementById("filters");
  filterCombo.options.length = 0;
  var index = lbmCombo.selectedIndex;
  if (index == -1 || lbmCombo.options[index].value == ""){
  	return;
  }
  
  if (lbms[index].filtersInit){
    for (var i = 0; i < lbms[index].filters.length; i++){
      filterCombo.options[filterCombo.options.length] = new Option(lbms[index].filters[i].name,lbms[index].filters[i].id);
    }
    filterCombo.selectedIndex = 0;
  }else {
    frames['filtersResultFrame'].location = "SQLAnalyzerGetFilters.jsp?lbmId=" + lbms[index].id + "&index=" + index;
  }
}

function filtersLoaded(){  
  if (frames['filtersResultFrame'].filtersIds && frames['filtersResultFrame'].lbmIndex >= 0){
    var lbm = lbms[frames['filtersResultFrame'].lbmIndex];
    for (var i = 0; i < frames['filtersResultFrame'].filtersIds.length;i++){
      lbm.filters[lbm.filters.length] = new Filter(frames['filtersResultFrame'].filtersIds[i],frames['filtersResultFrame'].filtersNames[i],false);
    }
    lbm.filtersInit = true;
    initFilters();
  }
}

function doAdd(){
  var lbmIndex = document.getElementById("lbms").selectedIndex;
  var filterIndex = document.getElementById("filters").selectedIndex;
  addSelectedLbm(lbmIndex,filterIndex);
}

function addSelectedLbm(lbmIndex,filterIndex){
   if (filterIndex == -1){
     return;
   }
   var selectedId = lbms[lbmIndex].id + ";" + lbms[lbmIndex].filters[filterIndex].id;
  
  var selectedCombo = document.getElementById("selectedLbms");
  if (selectedCombo.options.length == 1 && selectedCombo.options[0].value == ""){
    selectedCombo.options.length = 0;
  }
  for (var i = 0; i < selectedCombo.options.length; i++){
    if (selectedCombo.options[i].value == selectedId){
      return;
    }
  }
  var selectedName = lbms[lbmIndex].name + " [" + lbms[lbmIndex].filters[filterIndex].name + "] (Table" + (selectedCombo.options.length + 1) + ")";
  selectedCombo.options[selectedCombo.options.length] = new Option(selectedName,selectedId);

}
 
function doRemove(){
  var selectedCombo = document.getElementById("selectedLbms");
  if (selectedCombo.selectedIndex >= 0 && selectedCombo.options[selectedCombo.selectedIndex].value != ""){
    selectedCombo.options[selectedCombo.selectedIndex] = null;  
    updateSelectedLbms();      
  }
  
} 

function updateSelectedLbms(){
  var selectedCombo = document.getElementById("selectedLbms");
  for (var i = 0; i < selectedCombo.options.length; i++){
    var name = selectedCombo.options[i].text;
    var index = name.lastIndexOf("(Table");
    if (index >= 0){
      name = name.substring(0,index) + "(Table" + (i + 1) + ")";
    }
    selectedCombo.options[i].text = name;
  }
}	
  
function selectCustomChoice(){
  document.getElementById("maxRecordsToUseChoiceCustom").checked = true;
} 
    
</script>
</head>

<body onLoad="initLbms()">
<iframe name="filtersResultFrame" style="visibility:hidden" onLoad="javascript:filtersLoaded()" width="0" height="0"></iframe>
<form AUTOCOMPLETE="OFF" name="access" id="access" method="post">
 <div id="saveSettingsDiv" style="position:absolute;visibility:hidden;height:80">
 <table border="0" width="350" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
  <tr height="10"><td align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
	<span class="PROGRESSTEXT" >Save Settings</span>
		</td>
	</tr>
	<tr><td>
		<table border="0"  cellspacing="1" cellpadding="0">
     <tr>
      <td width="120" nowrap style="padding-left:10;padding-top:10"><span class="REGULARTEXT">Parent folder</span></td>
      <td width="200" style="padding-left:10;padding-top:10;padding-right:10">
      <select size="1" class="TEXTBOX" name="ParentModule" id="ParentModule">
       <%
       String selected = "";
       for(int i=0;i<mdarr.length;++i){
         if(mdarr[i].getId().equals(pmod.getId())){
           selected = "selected=\"true\"";
         }else{
           selected = "";
       	 }
       %>
       <option class="TEXTBOX" value="<%=mdarr[i].getId()%>" <%=selected%>><%=mdarr[i].getName()%></option>          
       <%} %>
       </select>
	  </td>
      <td width="*"></td>
     </tr>                  
     <tr>
       <td width="120" style="padding-left:10;padding-top:10" nowrap><span class="REGULARTEXT">Name</span></td>
       <td width="200" style="padding-left:10;padding-top:10;padding-right:10">
       <input type="text" class="TEXTBOX" name="LogName" size="30" value="">
	   </td>
       <td width="*"></td>
    </tr>            
    </table>
	</td></tr>
	<tr height="20"><td align="center" style="padding:5">
		<a class="PROGRESSLINK" href="javascript:hideLayer('saveSettingsDiv');">cancel</a>&nbsp;
		<a class="PROGRESSLINK" href="javascript:doSave();">save</a>&nbsp;		  	
	</td>
	</tr>
 </table>
 </div>
<table border="0" width="100%" cellspacing="0" height="98%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="9" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="425" class="TOPBORDER">
                <span class="PAGEHEADER">SQL Analyzer</span></td>
                <td width="457" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
                     
              <tr>
                <td width="8" >&nbsp;</td>
                <td colspan="2" width="881">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">                                                   
                	<tr>
                   	  <td>&nbsp;</td>
		            </tr>
                    <tr>

                    	<td >
                       		<span class="HEADER">Logs</span>
                    	</td>
                  	 </tr>
                  	<tr>
                    	<td >
                     	 <table border="0" width="100%" cellspacing="0" cellpadding="0">
                     	 <tr>
                    	   <td>
                      		<table border="0" width="100%" cellspacing="0" cellpadding="0">
                      			<tr>
                      				<td width="50"><span class="REGULARTEXT">Logs: </span></td>
                      				<td width="100"><select size="1" class="TEXTBOX" name="lbms" id="lbms" onChange="initFilters()">
                      					</select></td>
                      				<td width="50" style="padding-left:10"><span class="REGULARTEXT">Filters: </span></td>
                      				<td width="100"><select size="1" class="TEXTBOX" name="filters" id="filters">
                      					</select></td>
                      				<td width="50" style="padding-left:10;padding-right:10">
                        				<table border="0" width="100%" cellspacing="0" cellpadding="0">
                        				 <tr>
                        					 <td width="100%"></td>
                        				 </tr>
                        				 <tr>
                        					<td width="100%">
                           						<table border="0" width="100%" cellspacing="0" cellpadding="0">
                                  			 		<tr>
					                                  <td width="100%" align="center"><a href="javascript:doAdd()" class="SMALLLINK">add</a></td>
                    			                	</tr>
                               						<tr>
                        	          					<td width="100%" align="center"><a href="javascript:doRemove()" class="SMALLLINK">remove</a></td>
                               						</tr>
                            					</table>
                            				</td>
                            			</tr>
                            			<tr>
                              				<td width="100%"></td>
                            			</tr>
                      				    </table>
                     				</td>
                     				<td width="200"><select size="3" class="TEXTBOX" name="selectedLbms" id="selectedLbms" multiple>                     				      
                      					</select></td>
                      				<td width="*">&nbsp;</td>
                      			</tr>
                      		</table>
                      		</td>
                      	</tr>     
                     </table>
                   </td>
                     	 
                  </tr>                 
                  <tr>
                    <td><span class="HEADER">Logs Query</span></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">Here you need to specify the query you 
                    want XpoLog to execute on one or more of the logs listed above</span></td>
                  </tr>
                  <tr>
                    <td><textarea class="TEXTBOX" rows="5" id="sqlQuery" name="sqlQuery" cols="120" style="font-size: 8pt"><%=query%></textarea></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">example: SELECT * FROM TABLE1, TABLE2 &nbsp;&nbsp;&nbsp;</span></td>
                  </tr>
                  <tr>
                    <td>
                      <table border="0" width="602" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="260">&nbsp;</td>
                          <td width="250"><a href="javascript:doVerify()" class="LINK">execute query</a></td>
                          <td width="1"></td>                         
                        </tr>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>                 
	              <tr>
                    <td><span class="HEADER">Preview settings</span></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT"></span></td>
                  </tr>
                  <tr>
                    <td>
                    	<input type="radio" value="All" id="maxRecordsToUseChoiceAll" name="maxRecordsToUseChoice" <%=builder.getMaxRecordsToUse() == -1? "checked" : ""%>>
                    	<span class="REGULARTEXT">&nbsp;Use all log records</span>                        
                    </td>
                  </tr>
				  <tr>
                    <td>
                    	<input type="radio" value="Custom" id="maxRecordsToUseChoiceCustom" name="maxRecordsToUseChoice" <%=builder.getMaxRecordsToUse() >= 0? "checked" : ""%>>
                    	<span class="REGULARTEXT">&nbsp;Use the first &nbsp;
                    	<input id="maxRecordsToUse" name="maxRecordsToUse" type="text" size="5"  onfocus="selectCustomChoice()" value="<%=builder.getMaxRecordsToUse() == -1 ? "" : String.valueOf(builder.getMaxRecordsToUse())%>">
                    	&nbsp; of log records to show result.
                        </span>
                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  
                  <tr>
                    <td><span class="HEADER">Log records analysis result&nbsp;&nbsp;<%=resultText%></span></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">Here you can see the log lines after they
                      were analyzed using the data pattern</span></td>
                  </tr>                 
                  <tr>
                    <td>
                    <%if (!isFirstTime  || executeQuery){
                        if(queryOk){%>
			 				<%=html%>
						<%}else{%>
                			<span class="ERRORMESSAGE">error:<%=errorQuery%></span>
 					<%	  }
 					  }else {%>
						<span class="OKMESSAGE">Please execute query</span>
					<%}%>
</td>
                  </tr>
                  <tr>
                    <td>&nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td>&nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td style="padding-left:300">
                   
                        <p >
                        <a href="<%=BASE_DIRECTORY%>common/actions/cancelAction.jsp" class="LINK">cancel</a>&nbsp;
                        <%if (isPermittedAddLog) {%>
                        <a href="javascript:showSaveSettings()" class="LINK">save</a>&nbsp;
                        <%}%>
                        <a href="javascript:goToLogView()" class="LINK">show in log viewer</a>
                        </p>                                          
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>


</form>
</body>

</html>