<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%> 
<%@ page import="java.sql.*"%>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  String MODULE_ID = "MODULE_ID";
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String SQL_QUERY = "sqlQuery";
  String SELECTED_DATA_PATTERN = "SELECTED_DATA_PATTERN";
  String PATTERN_FIELDS = "advanced";
  
  LogBrowsingManager lbm = null;
  DBMedia media = null;
  String errorQuery = null;
  boolean queryOk = true;
  int maxRecordsToUse = -1;
  String modid = null;
  String logname = null;
  RecordMask oldMask = null;
  //verify data
  ErrorModel errmodel = new ErrorModel();
  
  
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  
  //check if need to save or configure.
  String isNextStr = request.getParameter("isNext");
  boolean isNext = isNextStr != null && isNextStr.equals("true");
  
  SQLLogSimpleBuilder builder = (SQLLogSimpleBuilder)request.getSession().getAttribute(BUILDER);

  //chekc if back from user permission or fist time here
  String userAgreed = request.getParameter("userAgreed");
  if(userAgreed == null) {

	  String query = request.getParameter(SQL_QUERY);
	  request.getSession().setAttribute(SELECTED_DATA_PATTERN,query);
	  //verify data
	
	  if(query == null || query.trim().equals("")){
	    errmodel.addError("No SQL Query was supplied.");
	  }
	  if(errmodel.getErrorCount() != 0){
	    request.getSession().setAttribute(ERROR_OBJ,errmodel);
	    response.sendRedirect("../errorpage.jsp");
	    return;
	
	  }

	 boolean isQueryIdentical = false;
	  query = query.trim();
          
	  if(!query.equals(builder.getQuery())) { 
	     builder.setColumnsPattern(null);
	  }else {
 	   isQueryIdentical = true; 
	  }

	  builder.setQuery(query);

	  
	  //check if the query and pattern is valid
	  lbm = builder.getLogBrowserManager();
	  media = (DBMedia)builder.getMedia();
	  errorQuery = null;
	  queryOk = true;
	  //try{
		  //check the data pattern

		  String[] pattern = builder.getColumnsPattern();
		  String check = "";
		  String fieldName = "";
		  String patternFromFields = "";
		  // check if there are null values and we are in edit
		  check = request.getParameter("FieldPattren_0");
		  //get the old pattern from the log
		  //check if need to assamble new pattern
		  if(pattern != null && pattern.length > 0 && check != null && !check.equals("")) {
			  for(int i=0; i<pattern.length; ++i) {
			  	fieldName = "FieldPattren_" + String.valueOf(i);
			  	check = "";
			  	check = request.getParameter(fieldName);
			  	if(check == null || check.equals("")) {
			  		pattern[i] = "{string}";
			  	}else {
			  		pattern[i] = check;
			  	}
			  }
			  builder.setColumnsPattern(pattern);
			  patternFromFields = builder.BuildColumnsPattern();
			  builder.setRecordPattern(patternFromFields);
		  }

		  if(isQueryIdentical){
    		    if(LogAdminHelper.getXpologPattern(lbm).equals(builder.BuildColumnsPattern())){
  	    	      oldMask = lbm.getRecordMask();
  	    	    }
		  }
		  

		  String maxRecordsToUseStr = request.getParameter("maxRecordsToUse");
	  	  maxRecordsToUse = builder.getMaxRecordsToUse();
	 	  if (maxRecordsToUseStr != null){
	      if (maxRecordsToUseStr.trim().length() > 0){
	        try {
	          maxRecordsToUse = Integer.parseInt(maxRecordsToUseStr);
	          if (maxRecordsToUse < 0){
	            maxRecordsToUse = builder.getMaxRecordsToUse();
	          }
	        }catch (Exception e){}
	      }else {
	        maxRecordsToUse = -1;
	      }
	  }
  
  	  builder.setMaxRecordsToUse(maxRecordsToUse);
	    //check if memory problems will rise.
	    int checkQuery = LogSQLAdminHelper.checkMemoryQuery(query);
	  	if((checkQuery > 0 && maxRecordsToUse > 10) || (checkQuery > 5 && maxRecordsToUse > 5) || (checkQuery > 0 && maxRecordsToUse == -1)) {
	  	   response.sendRedirect("askUserPermission.jsp?url=SQLLogDataPatternAction.jsp&isNext="+isNext);
	  	   return;
	  	}
  }//user agreed
  try {

  	  //if query not valid default pattern exists
      builder.updateBuilder();
      builder.buildPatternFields();
      LogBrowsingManager newLbm = builder.getLogBrowserManager();
      //check if the query is executable
 	  media = (DBMedia)builder.getMedia();
 	  if(!media.verifyQuery() || !media.isUpdateVerification()){
	  	  errorQuery = media.getLastErrorMessage();
	  	  queryOk = false;
      } 

      if (oldMask != null){       
        newLbm.setRecordMask(oldMask);
      }

	
  }catch(Exception e){
    errorQuery = e.getMessage();
    queryOk = false;
  }
  if(!queryOk) {
  	errmodel.addError("Building log problem,please check query and pattern again.");
    errmodel.addError(errorQuery);
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("../errorpage.jsp");
    return;
  }
  
  if(isNext) {
     String BASE_DIRECTORY = "../../../";
    AdminUIController controller = builder.getUiController();
    String forwardPage = "../logFieldAdmin.jsp";
    if (controller != null){    
      if (controller.getForwardPage() != null){
        forwardPage = BASE_DIRECTORY + controller.getForwardPage();
      }
    }
  
    response.sendRedirect(forwardPage);
  }else {
  	response.sendRedirect("../logFieldAdminAction.jsp");
  }
  
%>


