<%@page import="xpolog.eye.data.util.FileExtend"%>
<%@page import="xpolog.eye.media.AddressBook"%>
<%@page import="xpolog.eye.media.auth.AuthenticationAccount"%>
<%@page import="xpolog.eye.site.SiteConstants"%>
<%@page import="xpolog.eye.audit.AuditConstants"%>
<%@page import="xpolog.eye.audit.AuditManager"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.data.util.FileFilterConfiguration"%>
<%@page import="xpolog.eye.data.util.NameExpression"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>

<%@ include file="../fileFilterConfigurationAction.jsp"%>
<%
  String ERROR_OBJ = "ERROR_OBJ";
  String LOG_NAME = "LogName";
  String LOG_DESCRIPTION = "LogDescription";
  String MODULE_ID = "MODULE_ID";
  String PARENT_MODULE = "ParentModule";
  String LOG_DIRECTORY = "LogDirectoryDir";
  String LOG_NAME_PATTERN = "LogNamePattern";
  String LOG_TAG_NAME = "tagName";
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_TIME_ZONE = "TimeZone";
  String LOG_CHARSET = "charset";
  String NUM_OF_PATHS = "numOfPaths";
  String BASE_DIRECTORY = "../../../";
  
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();


  String modid      = request.getParameter(PARENT_MODULE);
  String parentApps = request.getParameter("parentApplication");
	HashSet applicationsIds = new HashSet();
  String[] appArr = null;
	if(parentApps != null && parentApps.length() >0){
		appArr = parentApps.split("#");
		for(int i = 0 ;	appArr != null &&  i < appArr.length ; i++){
			applicationsIds.add(appArr[i]);
		}		
	}  
  String logname    = request.getParameter(LOG_NAME);
  String logdesc    = request.getParameter(LOG_DESCRIPTION);
  String tagName = request.getParameter("tagName");
  String timeZoneId = request.getParameter(LOG_TIME_ZONE);
  String charset    = request.getParameter(LOG_CHARSET);
  String authAccId = request.getParameter("accountId");
  String logType = request.getParameter("LogType");
  if(logType == null || logType.length() == 0){
  	logType = "local";
  }

   String zippwd = request.getParameter("zippwd");
  if (charset != null && charset.equals("default")){
    charset = null;
  }
  
  String sortFilesStr = request.getParameter("sortFiles");
  boolean sortFilesByLastUpdate = sortFilesStr != null && sortFilesStr.equals("byLastUpdate");

  
  String LOG_LOCATION_PATH = "fullPath_";  
  String LOG_LOCATION_STATUS = "locationStatus_";    
  String LOCATIONS_CNTR = "locationCntr";
  String locationCntrStr      = request.getParameter(LOCATIONS_CNTR);
  int locationsCntr = 0 ;
  try{
  	locationsCntr = Integer.parseInt(locationCntrStr);
  }catch(NumberFormatException e){
  	locationsCntr = 0;
  }
  int fileBehavior = 0;
  String _fileBehavior = request.getParameter("fileBehavior");
  if(_fileBehavior != null && _fileBehavior.length() > 0){
		try{
			fileBehavior = Integer.parseInt(_fileBehavior);
		}catch(Exception e){
			fileBehavior = 0;
		}
  }
  String locationFullPath = "";
  String locationStatus = "";  
  NameExpression nameExpr = new NameExpression();
  ArrayList nameExprList = new ArrayList();
  for(int i = 0 ; i < locationsCntr ; i++){
  	String pathParam = LOG_LOCATION_PATH + i;
  	String statusParam = LOG_LOCATION_STATUS + i;
  	locationFullPath = request.getParameter(pathParam);
  	if(locationFullPath != null && locationFullPath.length() > 0){
  		int indx = locationFullPath.lastIndexOf("/");
  		if(indx < 0){
  			indx = locationFullPath.lastIndexOf("\\");
  		}
  		String dir = locationFullPath.substring(0,indx + 1);	
  		String pattern = locationFullPath.substring(indx+1,locationFullPath.length());
  		locationStatus = request.getParameter(statusParam);
  		int dynmicState;
  		try{
  			dynmicState = (locationStatus != null && locationStatus.length() > 0) ? Integer.parseInt(locationStatus) : 0;
  		}catch(NumberFormatException e){
  			dynmicState = 0;
  	  }
  		int dynmicStateToDisplay = dynmicState;
  		dynmicState = dynmicState < 0 ? fileBehavior : dynmicState;
  		nameExpr = new NameExpression();
  		nameExpr.setDirectory(dir);
  		nameExpr.setXpologNamePatternsStr(pattern);
  		nameExpr.setLogDynamicType(LogAdminHelper.convertToFileBehavior(dynmicState));
  		nameExpr.setLogDynamicTypeToDisplay(dynmicStateToDisplay);
  		nameExprList.add(nameExpr);
  	}
  }	
  
		//verify data
  ErrorModel errmodel = new ErrorModel();

  if(logname == null || logname.trim().equals("")){
    errmodel.addError("No name was supplied.");
  }
  if(WebUtil.isContainSpecialCharecter(logname)){
     errmodel.addError("The following characters are prohibited in the name field: "+WebUtil.getSpecialCharectersList());
  }
	if(nameExprList == null || nameExprList.size() == 0){
		errmodel.addError("please check log's path and pattern.");
	}
  String doSaveStr = request.getParameter("doSave");
  boolean doSave = doSaveStr != null && doSaveStr.length() > 0;

 	
  if(modid == null || modid.trim().equals("")){
    errmodel.addError("No parent folder was selected. If no folder is available please check your permissions");
  }
  
  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;

  }

  FileFilterConfiguration fileFilterConfiguration = null;
	try {
		fileFilterConfiguration = createFileFilterConfiguration(request, response);
	}catch(Exception e) {
		errmodel.addError(e.getMessage());
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
	}

  LogBrowsingManager lbm = null;
  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);

  XMLLogBrowserBuilder builder = (XMLLogBrowserBuilder)LogBrowserBuilderFactory.getLogBroserBuilderByType(LogBrowserBuilderFactory.XML_LOG_TYPE);

  if(lbm != null && !lbm.getType().equals(XMLLogBrowserBuilder.XML_LOG_TYPE)){	
	lbm = null;
  	request.getSession().removeAttribute(CURRENT_LOG);
  }

  if(lbm != null){
    builder.setID(lbm.getId());
    builder.getLogBrowserManager().setRecordMask(lbm.getRecordMask());
    builder.setElementPatternsParser(XMLLogAdminHelper.getElementPatternsParser(lbm,true));
    builder.buildElementsPatternInfoFromParser();
    builder.setUseIndexing(lbm.isUseIndexing());
    builder.setFileFilterConfiguration(fileFilterConfiguration);
    builder.setUseIndexingForDateSearch(lbm.isUseIndexingForDateSearch());
    builder.setUseWholeWords(lbm.isUseWholeWords());
    builder.setUseQuickFilter(lbm.isUseQuickFilter());
    builder.setComputeStatistics(lbm.isComputeStatistics());
		builder.setUseInDashboard(lbm.isUseInDashboard());
		builder.setUseInDashboardTask(lbm.isUseInDashboardTask());
    builder.setUseSearchSuggestions(lbm.isUseSearchSuggestions());
    builder.setCollectionUnits(lbm.getCollectionUnits());
    builder.setHost(lbm.getHost());
    tagName = XMLLogAdminHelper.getTagName(lbm);
  }

  builder.setName(logname);
	builder.setNameExprList(nameExprList);
  builder.setApplicationsIds(applicationsIds);  
  builder.setTagName(tagName);
  builder.setLogDescription(logdesc);
  builder.setFileFilterConfiguration(fileFilterConfiguration);
  builder.setTimeZoneId(timeZoneId);
  builder.setCharset(charset);
  builder.setZipPassword(zippwd);
  boolean isDynamic = fileBehavior == FileExtend.DATA_CHANGE_NAME_CHANGE_ATT || fileBehavior == FileExtend.DATA_FIXED_NAME_CHANGE_ATT;
  builder.setDynamicFiles(isDynamic);
  builder.setFileBehavior(fileBehavior);
  builder.setSortByLastUpdate(sortFilesByLastUpdate);
  if (authAccId != null){
  	AuthenticationAccount acc = (AuthenticationAccount)AddressBook.getInstance().getAccountById(authAccId);
  	builder.setAuthenticationAccount(acc);
  }else{
  	builder.setAuthenticationAccount(null);
  }

  try{
    //for configuration reasons
    builder.updateBuilder();
  }catch(Exception e){
    errmodel.addError("Building log problem,please check patterns and path again.");
    errmodel.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }

  //audit
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  AuditManager auditMgr = AuditManager.getInstance();
  for(int i = 0 ;nameExprList != null &&  i < nameExprList.size() ; i++){    	
	  auditMgr.write(AuditConstants.BASIC_AUDIT_LEVEL,
  	userContext, AuditConstants.CHANGE, "create/edit log", AuditConstants.LOGS, "create/edit log " + logname + " path - " + ((NameExpression)nameExprList.get(i)).getDirectory()+((NameExpression)nameExprList.get(i)).getXpologNamePatternsStr()); 
  }
  
  boolean isNew = lbm == null || lbm.getId() == null;
  
  if (doSave){
    builder.updateBuilder();
  	lbm = builder.getLogBrowserManager();
  	LogBrowsingManager oldlbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  	if(oldlbm != null){
	  	lbm.setFilterManager(oldlbm.getFilterManager());
	    lbm.setRecordMask(oldlbm.getRecordMask());
	    lbm.setCustomizationManager(oldlbm.getCustomizationManager());
  	}
    Module parentmod = mgmt.getModuleFromId(modid);
    if(parentmod == null){
      modid = "rootModule";
      parentmod = mgmt.getModuleFromId(modid);
    }
	  LogAdminHelper.updateLogApplicationsMetas(lbm.getId(),applicationsIds);
	  
	  LogAdminHelperQuery reindexQuery = new LogAdminHelperQuery();
		reindexQuery.setLbm(lbm);
		reindexQuery.setHandleSortByLastUpdate(true);
		boolean shouldReindex = LogAdminHelper.shouldReindex(reindexQuery);
	  
    String newId = admin.addLogBrowser(lbm, parentmod, userContext);
	  if(isNew && newId != null && newId.length() > 0) {
	  	String[] lbmIds = new String[1];
	  	lbmIds[0] = lbm.getId();
	  	admin.generateLogData(lbmIds, userContext);
	  }
    request.getSession().setAttribute(CURRENT_LOG,lbm);
    
    if(shouldReindex) {
    	LogAdminHelper.reindexLog(userContext, lbm.getId());
    }
    
    auditMgr.write(AuditConstants.BASIC_AUDIT_LEVEL,
  	userContext, AuditConstants.CHANGE, "save/edit log", AuditConstants.LOGS, "change the log " + lbm.getName()); 
	  env.setTempAttribute(SiteConstants.FORWARD_URL_ATTRIBUTE,"loggers/admin/logaddopok.jsp?removeLog=" + !builder.isLogCanBeUsed());
  	response.sendRedirect(BASE_DIRECTORY + "common/actions/nextAction.jsp");
  	return;
  }
  request.getSession().setAttribute("IS_NEW", Boolean.valueOf(isNew));
  
  String logAdminScreenWidth = request.getParameter("LogAdminScreenWidth");
	if(logAdminScreenWidth == null || logAdminScreenWidth.length()==0){
		logAdminScreenWidth = "600px";
	}
	
	String [] pages = {"loggers/admin/logAdminGate.jsp?isPrevious=true&logType=" + logType + "&dataType=xml",
  			 "loggers/admin/xml/XMLLogSchema.jsp?LogAdminScreenWidth=" + logAdminScreenWidth + "&tagName=" + tagName,
  			 "loggers/admin/xml/xmlLogFieldAdmin.jsp"};
  AdminUIController controller = new AdminUIController(pages);
  builder.setUiController(controller);

  request.getSession().setAttribute(MODULE_ID,modid);
  request.getSession().setAttribute(BUILDER,builder);

  response.sendRedirect(BASE_DIRECTORY + controller.getForwardPage());
%>

