<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.builders.virtual.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="omega.ui.models.*"%>
<%@ page import="omega.ui.html.table.OHtmlTable"%>


<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  //constants
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String MODULE_ID = "MODULE_ID";
  String ERROR_OBJ = "ERROR_OBJ";

  //page data
  LogBrowsingManager lbm = null;
  String logname = "";

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  RecordMask mask = null;

  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  XMLLogBrowserBuilder builder = (XMLLogBrowserBuilder)request.getSession().getAttribute(BUILDER);
  if(builder == null){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("Please select log first.");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect("errorpage.jsp");
    return;
  }

  String backwardURL = null;
  AdminUIController controller = builder.getUiController();
  if (controller != null){
    controller.updatePageId("xmlLogFieldAdmin.jsp");
    backwardURL = BASE_DIRECTORY + controller.getBackwardPage();
  }
  boolean shouldRemoveIndex = false;
  VirtualColumnsBuilder virtualColumnBuilder = builder.getVirtualColumnsBuilder();;
  if(lbm == null){
     lbm = builder.getLogBrowserManager();
     mask = lbm.getRecordMask();
  }else{
    shouldRemoveIndex = lbm.isUseIndexing() && lbm.isTextIndexed();
    String isUpdateStr = request.getParameter("update");
    boolean isUpdate = isUpdateStr != null && isUpdateStr.equals("true");
    LogBrowsingManager lbm1 = builder.getLogBrowserManager();
    if(!isUpdate && builder.isEqualsSelectedPatterns(XMLLogAdminHelper.getElementPatternsParser(lbm,false))){
      mask = lbm.getRecordMask();
      shouldRemoveIndex = false;
    }else{
      mask = lbm1.getRecordMask();
    }
    lbm = lbm1;
  }

  int number = mask.getCulomnsNumber();
  int dateIndex = mask.getDateColumnIndex();

  //log table example
  RecordsMaskTableModel model = lbm.getFirstEntries(3);
  String html = "";
  //html creation
  LogEyeModel lem = new LogEyeModel(BASE_DIRECTORY,lbm.getCustomizationManager(),model);
  OHtmlTable tab = new OHtmlTable(lem);

  LogEyeCellRenderer cr = new LogEyeCellRenderer(lem);
  LogEyeRowRenderer rr = new LogEyeRowRenderer(lem);
  tab.setRowRenderer(rr);
  tab.setCellRenderer(cr);
  tab.render();
  html = tab.getHtml();
  
  String charset = lbm.getCharset();
  if (charset != null){
    response.setContentType("text/html; charset=" + charset);
  }

  boolean useIndexing = lbm.isUseIndexing();
  boolean isDemo = XpologLicenseManager.getInstance().isDemo();
  boolean showIndexing = SiteManagment.getInstance().getXpologManagment().isComponentLicenseValid(XpologManagment.SEARCH_ENGINE_COMPONENT);
  boolean computeStatistics = lbm.isComputeStatistics();

  
  VirtualColumn [] virtualColumns = virtualColumnBuilder == null ? new VirtualColumn[0] : virtualColumnBuilder.getVertualColumns();
  number = number - virtualColumns.length;

%>




<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<jsp:include page="../../../scripts/dataview/dataView.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
</jsp:include>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script>
	function doNext(){
	   document.access.action = "xmlLogFieldAdminAction.jsp";
           document.access.submit();
	}

	function update(params){
	   document.access.action = "xmlLogFieldAdminAction.jsp?" + params;
           document.access.submit();
	}

	function updateUseIndex(){
		var isChecked = document.getElementById("useIndexingStr").checked;
		for (var i = 0; i < <%=number%>; i++){
		  var indexDiv = document.getElementById("colIndex" + i);
		  if(indexDiv){
		    if (isChecked){
		      indexDiv.style.visibility = "";
		    }else {
		      indexDiv.style.visibility = "hidden";
		    } 
		  }
		}
	}

	function updateComputeStatistics(){
		var isChecked = document.getElementById("computeStatisticsStr").checked;
		for (var i = 0; i < <%=number%>; i++){
		  var statisticsDiv = document.getElementById("colStatistics" + i);
		  if(statisticsDiv){
		    if (isChecked){
		      statisticsDiv.style.visibility = "";
		    }else {
		      statisticsDiv.style.visibility = "hidden";
		    } 
		  }
		}
	}
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" name="access" id="access" method="POST" >
<input type="hidden" name="shouldRemoveIndex" value="<%=String.valueOf(shouldRemoveIndex)%>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="800" id="AutoNumber2">
              <tr>
                <td width="10" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="300" class="TOPBORDER">
                <span class="PAGEHEADER">Log field admin <%=logname%></span> </td>
                <td width="400" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="9">&nbsp;</td>
                <td width="300">&nbsp;</td>
                <td width="400">&nbsp;</td>
              </tr>
              <tr>
                <td width="9" >&nbsp;</td>
                <td colspan="2" width="846">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Generated table</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><%=html%></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Field specification</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="850" id="AutoNumber6">
                      <tr class="TABLES_HEADERS">
                        <td width="4%">&nbsp;</td>
                        <td width="10%"><span class="REGULARTEXT">Field Type</span></td>
                        <td width="25%"><span class="REGULARTEXT">Field Name</span></td>
                        <td width="15%">&nbsp;</td>
                        <td width="20%">&nbsp;</td>
                        <td width="*">&nbsp;</td>
                      </tr>
                      <tr>
                       <td colspan="6">&nbsp;</td>
                      </tr>

                      <%
                        String name = "";
                        String type = "";
                        String filedentry = "FIELD_NAME_";
                        for(int i=0;i<number;++i){
                          name = mask.getMaskColumn(i).getName();
                          type = mask.getMaskColumn(i).getType();
                          boolean useInStatistics = mask.getMaskColumn(i).isUseInStatistics();
                          boolean computeAvg = useInStatistics && mask.getMaskColumn(i).isComputeAvgContextStatistics();
                      %>
                      <tr>
                        <td><span class="REGULARTEXT"><%=String.valueOf(i+1)%>.</span></td>
                        <td><span class="REGULARTEXT"><%=type%></span></td>
                        <td>
                          <input class="REGULARTEXT" type="text" name="<%=filedentry + String.valueOf(i)%>" id="<%=String.valueOf(filedentry+i)%>" size="26" value="<%=name%>">
                        </td>
                        <td valign="middle">&nbsp;
                          <%if (type !=null && type.equalsIgnoreCase("DATE")){%>
                            <input type="radio" name="dateIndex" value="<%=i%>" <%=i==dateIndex?"checked":"" %>>
                            <span class="SMALLTEXT">event date&nbsp;</span>
                          <%}%>
                        </td>
                        <td valign="middle">
                          <%if (showIndexing){ %>
                          <div id="colIndex<%=String.valueOf(i)%>" <%=!useIndexing?"style=\"visibility:hidden\"" : ""%>>
  													<input type="checkbox" name="useColIndex<%=String.valueOf(i)%>" value="ON" <%=(mask.getMaskColumn(i).isUseIndex() || isDemo ? "checked" : "")%> >
                            <span class="SMALLTEXT">Index this column&nbsp;</span>
                        	</div>
                        	<nobr>
                        <%} %>
                        	<nobr>
                        </td>
                        <td valign="center" style="padding-top:1">
                        	<nobr>
                          <div id="colStatistics<%=String.valueOf(i)%>" <%=!computeStatistics?"style=\"visibility:hidden\"" : ""%>>
                          	<span class="SMALLTEXT" style="vertical-align:middle">Compute statistics: </span>
                          	<select name="useColStatistics<%=String.valueOf(i)%>" class="TEXT_BOX">
                          		<option value="no">do not compute</option>
                          		<option value="yes" <%=useInStatistics && !computeAvg ? "selected" : ""%>>compute unique values</option>
                          		<option value="useAvg" <%=computeAvg ? "selected" : "" %>>compute average</option>
                          	</select>
                        	</div>
                        	</nobr>
                        </td>
                      </tr>
                      <%
                        }//for
                      %>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr><td>
			<script>
			function showAddVirtualCol(){
			   comp = document.getElementById("addVirtualColTD");
 			   y = findPosY(comp) - 150;
      			  showHideLayerInMiddle("addVirtualColDiv",200,y);
    			}

		   	function addVirtualCol(){
			  var cmbo = document.getElementById("virtualColSelected");
			  var count = 0;
                          if (cmbo){
			    for (var i = 0; i < cmbo.options.length; i++){
			      if (cmbo.options[i].selected){
 				count++;
			      }
			    }
			  }
			  if (count == 0){
			    alert("Please select one of the columns");
			    return;
			  }
			  update("OP=ADD_VIRTUAL_COL");
			}

			function removeVirtualCol(virCol){
			  update("OP=REMOVE_VIRTUAL_COL&&virtualColIndex=" + virCol);
			}
                      </script>
		      <div id="addVirtualColDiv" style="position:absolute;visibility:hidden;height:80">
 			<table border="0" width="200" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:1px solid #000000">
  			<tr height="10"><td align="center" style="background:blue;color:white">
			  <span class=REGULARTEXT" >Add Virtual Column</span>
			</td>
			</tr>
			<tr><td>
			  <table border="0"  cellspacing="1" cellpadding="0">
     			    <tr>
      			      <td width="70" nowrap style="padding-left:10;padding-top:10"><span class="REGULARTEXT">Operation</span></td>
      			      <td width="200" style="padding-left:10;padding-top:10;padding-right:10">
      				<select size="1" class="TEXTBOX" name="virtualColOp" id="virtualColOp">
      				  <option class="TEXTBOX" value="append">Merge</option>          
      
      				</select>
	  		      </td>
      			      <td width="*"></td>
     			    </tr>                  
     			    <tr>
      			      <td width="70" nowrap style="padding-left:10;padding-top:10"><span class="REGULARTEXT">Columns</span></td>
      			      <td width="200" style="padding-left:10;padding-top:10;padding-right:10">
      				<select size="5" multiple class="TEXTBOX" name="virtualColSelected" id="virtualColSelected">      				          
      				<%
      	
       				for(int i=0;i<number;++i){
                                  name = mask.getMaskColumn(i).getName();				  
       				%>
      				  <option class="TEXTBOX" value="<%=String.valueOf(i)%>"><%=name%></option>          
      				<%} %>
      				</select>
			      </td>
       			      <td width="*"></td>
    			    </tr>            
    			   </table>
			</td></tr>
			<tr height="20"><td align="center" style="padding:5">
			  <a class="LINK" href="javascript:hideLayer('addVirtualColDiv');">cancel</a>&nbsp;
			  <a class="LINK" href="javascript:addVirtualCol();">add</a>&nbsp;		  	
			</td>
			</tr>
 		     </table>
 		     </div>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="700">                                      
                    <tr>
                      <td width="200">
                        <span class="HEADER">Virtual columns</span>
                      </td>
                      <td width="*" id="addVirtualColTD">
                        <a href="javascript:showAddVirtualCol()" class="LINK">Add virtual column
                      </td>
                    </tr>
                    </table>
                  </td></tr>                  
                  <%if (virtualColumns.length > 0){%>
                    
                  <tr>
                    <td>		      
			

                      <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="700" id="AutoNumber6">
                      <tr>
                        <td width="30" bgcolor="#FFB13E">&nbsp;</td>
                        <td width="100" bgcolor="#FFB13E"><span class="REGULARTEXT">Field Type</span></td>
                        <td width="200" bgcolor="#FFB13E" style="padding-left:10"><span class="REGULARTEXT">Field Name</span></td>
                        <td width="*" bgcolor="#FFB13E" style="padding-left:10"><span class="REGULARTEXT">Field Description</span></td>
                        <td width="50" bgcolor="#FFB13E" style="padding-left:10">&nbsp;</td>
                      </tr>
                      <%
                      
                      
                      String virtualfiledentry = "FIELD_NAME_";
                      for (int i = 0; i < virtualColumns.length  ;i++){
                        name = virtualColumns[i].getMaskColumn().getName();
			String desc = "Merge columns: ";
			int [] virCols = virtualColumns[i].getRefColumns();
			for(int j = 0;j < virCols.length; j++){
			  if (j > 0){
			    desc += ", ";
			  }
			  desc += mask.getMaskColumn(virCols[j]).getName();
			}
                      %>
                      <tr>
                        <td width="30" ><span class="REGULARTEXT"><%=String.valueOf(virtualColumns[i].getVirtualIndex() + 1)%></span></td>
                        <td width="100" ><span class="REGULARTEXT"><%=virtualColumns[i].getMaskColumn().getType()%></span></td>
                        <td width="200" style="padding-left:10"><span class="REGULARTEXT"><input class="REGULARTEXT" type="text" name="<%=virtualfiledentry + String.valueOf(virtualColumns[i].getVirtualIndex())%>" size="26" value="<%=name%>"></span></td>
                        <td width="*" style="padding-left:10"><span class="REGULARTEXT"><%=desc%></span></td>
                        <td width="50" style="padding-left:10"><a href="javascript:removeVirtualCol(<%=String.valueOf(i)%>)" class="LINK">remove</a></td>
                      </tr>
                      <%}%>
                      </table>
                    </td>
                  </tr>  
                  <%}%>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
									<tr>
										<td>
											<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
			                  <tr>
			                    <td><span class="HEADER">Statistics settings</span></td>
			                  </tr>                  
			                  <tr>
			                    <td><input id="computeStatisticsStr" name="computeStatisticsStr" type="checkbox"  <%=computeStatistics?"checked" : ""%> onClick="javascript:updateComputeStatistics()"><span class="REGULARTEXT">Compute statistics</span><br><span class="SMALLTEXT">&nbsp;&nbsp;&nbsp;set this option to enable statistical evaluations on this log</span></td>
			                  </tr>                 
			                </table>
			              </td>
			            </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
									<%
									if(showIndexing) {
									%>
                  <tr>
                    <td><span class="HEADER">Indexing settings</span></td>
                  </tr>                  
                  <tr>
                    <td><input id="useIndexingStr" name="useIndexingStr" type="checkbox"  <%=useIndexing?"checked" : ""%> onClick="javascript:updateUseIndex()"><span class="REGULARTEXT">Use indexing</span><br><span class="SMALLTEXT">&nbsp;&nbsp;&nbsp;using log indexing enables rapid search and filtering; indexed logged can be used in Xpolog Search Engine </span></td>
                  </tr>                 
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <%
                  }
                  %>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="800" id="AutoNumber17">
                      <tr>
                        <td width="200">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                        <td width="52">
                        <p align="center"><a href="<%=BASE_DIRECTORY%>common/actions/cancelAction.jsp" class="LINK">cancel</a></td>
                        <td width="10"></td>
                        <td width="69"><a href="<%= backwardURL != null ? backwardURL : "javascript:history.go(-1)" %>" class="LINK">previous</a></td>
                        <td width="8"></td>
                        <td width="42"><a href="javascript:doNext()" class="LINK">next</a></td>
                        <td width="300">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>