<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.builders.virtual.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.data.index.adapters.defaultadapter.*"%>
<%@ page import="xpolog.eye.data.index.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  //constants
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG";
  String MODULE_ID = "MODULE_ID";
  String FILED = "FIELD_NAME_";

  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  //page data
  LogBrowsingManager lbm = null;
  LogBrowsingManager oldlbm = null;
  oldlbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);

  String logname = "";

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  RecordMask mask = null;


  XMLLogBrowserBuilder builder = (XMLLogBrowserBuilder)request.getSession().getAttribute(BUILDER);
     if(builder == null){
      //put erro data and send to error
      response.sendRedirect("errorpage.jsp");
  }

  lbm = builder.getLogBrowserManager();
  mask = lbm.getRecordMask();
  int origColNumber= mask.getCulomnsNumber();

  boolean doUpdate = false;
  
  String op = request.getParameter("OP");

  VirtualColumnsBuilder virtualColumnBuilder = builder.getVirtualColumnsBuilder(); 
  ArrayList virtualList = new ArrayList();
  if (virtualColumnBuilder != null){
    VirtualColumn [] virtualColumns = virtualColumnBuilder.getVertualColumns();
    for(int i = 0; i < virtualColumns.length; i++){
      virtualList.add(virtualColumns[i]);
    }
  }

  int colMaskNumber = origColNumber - virtualList.size();

  int [] realIndexes = null;
  if (op != null && op.length() > 0){
    if (op.equals("ADD_VIRTUAL_COL")){
	VirtualColumn virCol = new VirtualColumn ();
	String virtualColOp = request.getParameter("virtualColOp");
	String [] colIndexes = request.getParameterValues("virtualColSelected");
	int [] refsCols = new int[colIndexes.length];

        for (int i = 0; i < colIndexes .length; i++) {
          try {
            refsCols[i] = Integer.parseInt(colIndexes[i]);
          }catch (Exception e){
            refsCols[i] = -1;
          }
        }

	virCol.setRefColumns(refsCols);
        virCol.setVirtualFunction(new xpolog.eye.data.util.transformers.virtual.StringVirtualFunction ());
        virCol.setMaskColumn(new StringMask());
	virtualList.add(virCol);
        doUpdate = true;
    }else if (op.equals("REMOVE_VIRTUAL_COL")){
	String indexStr = request.getParameter("virtualColIndex");
	int index = -1;
	try {
	  index = Integer.parseInt(indexStr);
	}catch (Exception e){}

	if (index >= 0){
	  realIndexes  = new int[origColNumber];
          VirtualColumn virCol = (VirtualColumn)virtualList.get(index);
 	  virtualList.remove(index);
          int realIndex = virCol.getVirtualIndex();
          for (int i = 0; i < realIndexes .length; i++) {
            if (i <realIndex){
               realIndexes[i] = i;
	    }else if (i == realIndex){
		realIndexes[i] = -1;
	    }else {
		realIndexes[i] = i - 1;
	    }
	  }
	  
	}
	doUpdate = true;
	 
    }
  }

  
  if (doUpdate){
    if (virtualList.size() == 0){
      virtualColumnBuilder  = null;
    }else {
      int colsCount = colMaskNumber;
      virtualColumnBuilder = new VirtualColumnsBuilder();
      for(int i = 0; i < virtualList.size(); i++){
        VirtualColumn virCol = (VirtualColumn)virtualList.get(i);
        virCol.setVirtualIndex(colsCount++);
        virtualColumnBuilder.addVirtualColumn(virCol);
      }
      
    }

    try {
      builder.setVirtualColumnsBuilder(virtualColumnBuilder); 
      builder.updateBuilder();
    }catch (Exception e){
      e.printStackTrace();
      return;
    }
    lbm = builder.getLogBrowserManager();
    mask = lbm.getRecordMask();
     
  }
  
  
  boolean shouldRemoveIndex = false;
  boolean statisticsColumnChanged = false;

  String name = "";
  String useIndexAction = "";
  String useStatisticsAction = "";
  for(int i=0;i<origColNumber;i++){
    name = request.getParameter(FILED+i);
    int index = realIndexes == null ? i : realIndexes[i];
    if(index >= 0 && (name != null ) && (!(name.trim().equals("")))){
      mask.getMaskColumn(i).setName(name);
    }

    useIndexAction = request.getParameter("useColIndex"+i);
    boolean useIndex = useIndexAction != null && useIndexAction.equals("ON");
    if(index >= 0){
    	shouldRemoveIndex = shouldRemoveIndex || mask.getMaskColumn(index).isUseIndex() != useIndex;
    	mask.getMaskColumn(index).setUseIndex(useIndex);
    }
    
    useStatisticsAction = request.getParameter("useColStatistics"+i);
    if (index >=0){
    	if (useStatisticsAction == null || useStatisticsAction.equals("no")){
    		if (mask.getMaskColumn(index).isUseInStatistics()){
    			statisticsColumnChanged = true;
    		}
    		mask.getMaskColumn(index).setUseInStatistics(false);
      	mask.getMaskColumn(index).setComputeAvgContextStatistics(false);
    	}else if (useStatisticsAction.equals("yes")){
    		if (!mask.getMaskColumn(index).isUseInStatistics() || mask.getMaskColumn(index).isComputeAvgContextStatistics()){
    			statisticsColumnChanged = true;
    		}
    		mask.getMaskColumn(index).setUseInStatistics(true);
      	mask.getMaskColumn(index).setComputeAvgContextStatistics(false);
    	}else if (useStatisticsAction.equals("useAvg")){
    		if (!mask.getMaskColumn(index).isUseInStatistics() || !mask.getMaskColumn(index).isComputeAvgContextStatistics()){
    			statisticsColumnChanged = true;
    		}
    		mask.getMaskColumn(index).setUseInStatistics(true);
      	mask.getMaskColumn(index).setComputeAvgContextStatistics(true);
    	}
    }
  }
  
  String dateIndexStr = request.getParameter("dateIndex");
  if (dateIndexStr != null && dateIndexStr.length() > 0){
  	try{
  		int dateIndex = Integer.parseInt(dateIndexStr);
    	mask.setDateColumnIndex(dateIndex);
  	}catch(Exception e){}
  }

  //check if we can use same same customization manager
  if(oldlbm != null){
		 if (builder.isEqualsSelectedPatterns(XMLLogAdminHelper.getElementPatternsParser(oldlbm,false))  && LogAdminHelper.isEqualsVirtualColumnsBuilder(virtualColumnBuilder,XMLLogAdminHelper.getVirtualColumnsBuilder(oldlbm))){
		   CustomizationManager cuman = oldlbm.getCustomizationManager();
       lbm.setCustomizationManager(cuman);
       lbm.setFilterManager(oldlbm.getFilterManager());
		 }
  }


  //parent handling
  String modid =  (String)request.getSession().getAttribute(MODULE_ID);
   if(modid == null || modid.trim().equals("")){
    modid = "rootModule";
  }
  Module parentmod = mgmt.getModuleFromId(modid);
  if(parentmod == null){
    modid = "rootModule";
    parentmod = mgmt.getModuleFromId(modid);
  }
  
  //statistics
  String computeStatisticsStr = request.getParameter("computeStatisticsStr");
  boolean computeStatistics = computeStatisticsStr != null && computeStatisticsStr.equalsIgnoreCase("on");
  lbm.setComputeStatistics(computeStatistics);
  
  String useIndexingStr = request.getParameter("useIndexingStr");
  boolean useIndexing = useIndexingStr != null && useIndexingStr.equalsIgnoreCase("on");
  lbm.setUseIndexing(useIndexing);
  String useIndexingForDateSearchStr = request.getParameter("useIndexingForDateSearchStr");
  boolean useIndexingForDateSearch = useIndexingForDateSearchStr != null && useIndexingForDateSearchStr.equalsIgnoreCase("on");
  lbm.setUseIndexingForDateSearch(useIndexingForDateSearch);
  String shouldRemoveIndexStr = request.getParameter("shouldRemoveIndex");
	shouldRemoveIndex = shouldRemoveIndexStr != null && shouldRemoveIndexStr.equalsIgnoreCase("true");
	if (shouldRemoveIndex){
	   SearchEngineManager.getInstance().getDefaultIndexAdapter().removeIndex(new IndexedObject(lbm));
	}

  if (doUpdate){
    response.sendRedirect("xmlLogFieldAdmin.jsp?update=true");
    return;
  }
  
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			userContext, AuditConstants.CHANGE, "save/edit log", AuditConstants.LOGS, "change the log " + lbm.getName());
  
  builder.saveLogBrowser(lbm,parentmod);
  request.getSession().removeAttribute("logid");
  request.getSession().removeAttribute("callsPage");
  request.getSession().removeAttribute("lastModel");
  request.getSession().removeAttribute(BUILDER);
  request.getSession().setAttribute(CURRENT_LOG,lbm);
  env.setTempAttribute(SiteConstants.FORWARD_URL_ATTRIBUTE,("loggers/admin/xml/xmlLogAddOpOk.jsp?removeLog=" + !builder.isLogCanBeUsed()));
  response.sendRedirect(BASE_DIRECTORY + "common/actions/nextAction.jsp");
  
%>


