
<%@page import="xpolog.eye.admin.helpers.LogAdminHelperQuery"%>
<%@page import="xpolog.eye.admin.helpers.DashboardAdminHelper"%>
<%@ page language="java"%>

<%@page import="xpolog.eye.merge.MergedLogBrowserManager"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.builders.OnlineDBSimpleLogBuilder"%>
<%@ page import="xpolog.eye.admin.builders.SimpleLogBrowserBuilder"%>
<%@ page import="xpolog.eye.admin.helpers.LogAdminHelper"%>
<%@ page import="xpolog.eye.admin.helpers.XMLLogAdminHelper"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.log.db.OnlineDBDataSource"%>
<%@ page import="xpolog.eye.data.log.files.*"%>
<%@ page import="xpolog.eye.data.log.winevent.WinEventDataSource"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.xml.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.merge.MergeCustomizationManager"%>
<%@ page import="xpolog.eye.menu.*" %>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.reports.health.ui.DashboardUpdateCacheQuery"%>
<%@ page import="xpolog.eye.reports.health.ui.DashboardDataManager"%>

<%@ page import="java.util.*"%>

<%

	String ERROR_OBJ = "ERROR_OBJ";
	String CURRENT_LOG = "CURRENT_LOG";
	String COLOR_PRIOR_NAME = "COLOR_PRIOR_NAME_";
	String COLOR_LOG_NAME = "COLOR_LOG_NAME_";
	String VIRTUAL_LOG_NAME = "VIRTUAL_LOG_NAME_";
	String FILED = "FIELD_NAME_";
	String FILED_NUMBER = "FieldNumber_";
	
	
	SiteManagment mgmt = SiteManagment.getInstance();
	SiteAdministrator admin = SiteManagment.getAdminInstance();
	UserContext userContext = UserEnvironment.getUserContext(request);
	LogBrowsingManager lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
	CustomizationManager cuman = null;
	RecordMask mask = null;

	if(lbm == null){
		ErrorModel ermod = new ErrorModel();
		ermod.addError("You must select a log first.");
		request.getSession().setAttribute(ERROR_OBJ,ermod);
		response.sendRedirect("errorpage.jsp");
		return;
	}
  
	//lines number issue
	boolean reloadLog = false;
	String logId = null;
	
	//log header pattern
	String eventDate = request.getParameter("eventDate");
	String headerPattern = request.getParameter("logHeaderPattern");
 
	int headerCheckNumOfRecords = 1000;
	if (eventDate != null && eventDate.equals("headerDate") && headerPattern != null && headerPattern.length() > 0){
		String headerCheckNumOfRecordsStr = request.getParameter("headerNumOfRecords");
		if (headerCheckNumOfRecordsStr != null && headerCheckNumOfRecordsStr.length() > 0){
			try {
				headerCheckNumOfRecords = Integer.parseInt(headerCheckNumOfRecordsStr);
			}catch (Exception e){           
			}
		}
	}else if (eventDate != null && eventDate.equals("fileDate")){
		headerPattern = SimpleLogBrowserBuilder.FILE_TIME_HEADER;
	}else {
		headerPattern = null;
	}

	//statistics
	String useInDashboardStr = request.getParameter("useInDashboardStr");
	boolean useInDashboard = useInDashboardStr != null && useInDashboardStr.equals("on");
	boolean useInDashboardChanged = useInDashboard != lbm.isUseInDashboard();
	lbm.setUseInDashboard(useInDashboard);
	
	String computeStatisticsStr = request.getParameter("computeStatisticsStr");
	boolean computeStatistics = computeStatisticsStr != null && computeStatisticsStr.equalsIgnoreCase("on");
	if(useInDashboard) {
		lbm.setComputeStatistics(computeStatistics);
	}
  
	LinearDataSource linearDS = lbm.getLinearDataBuilder().getLinearDataSource();
	LinearDataSource ds = null;
	if(linearDS instanceof MultiFilesDataSource) {
		ds = (MultiFilesDataSource)linearDS;     
	}else if(linearDS instanceof XMLElementDataSource) {
		ds = ((XMLElementDataSource)linearDS).getDataSource();       
	}else if(linearDS instanceof WinEventDataSource) {
		ds = (WinEventDataSource)linearDS;
	}else if(lbm.getType().equals(OnlineDBSimpleLogBuilder.ONLINE_DB_LOG_TYPE)) {
		ds = (OnlineDBDataSource)linearDS;
	}
  
	boolean headerChanged = false;
	if (ds != null){
		String useIndexingStr = request.getParameter("useIndexingStr");
		boolean useIndexing = useIndexingStr != null && useIndexingStr.equalsIgnoreCase("true");
		lbm.setUseIndexing(useIndexing);
		String useIndexingForDateSearchStr = request.getParameter("useIndexingForDateSearchStr");
		boolean useIndexingForDateSearch = useIndexingForDateSearchStr != null && useIndexingForDateSearchStr.equalsIgnoreCase("true");
		lbm.setUseIndexingForDateSearch(useIndexingForDateSearch);
		String indexNullValuesStr = request.getParameter("indexNullValuesStr");
		boolean indexNullValues = indexNullValuesStr != null && indexNullValuesStr.equalsIgnoreCase("true");
		lbm.setIndexNullValues(indexNullValues);
		
		String updateLinesNumberStr = request.getParameter("updateLinesNumberStr");
		boolean updateLinesNumber = updateLinesNumberStr != null && updateLinesNumberStr.equalsIgnoreCase("on");
		
		//clean the log from session and update ds only if changed
		if(ds instanceof MultiFilesDataSource && ((MultiFilesDataSource)ds).isUpdateLines() != updateLinesNumber) {
			reloadLog = true;
			logId = lbm.getId();
			((MultiFilesDataSource)ds).setUpdateLines(updateLinesNumber);
			request.getSession().removeAttribute(CURRENT_LOG);
		}
		
		FileDSHeaderBuilder dsHeaderBuilder = null;
		if (linearDS instanceof MultiFilesDataSource){
			dsHeaderBuilder = LogAdminHelper.getHeaderBuilder(lbm); 
		}else if (linearDS instanceof XMLElementDataSource){
			dsHeaderBuilder = XMLLogAdminHelper.getHeaderBuilder(lbm);
		}
		String headerPatternOrg = null;
		if (dsHeaderBuilder != null){
			if (!dsHeaderBuilder.isUseFileTime()){
				if(dsHeaderBuilder.getBuilder() != null) {
					headerPatternOrg = LogAdminHelper.getLogRecordBuilderPattern(dsHeaderBuilder.getBuilder());
				}
			}else{
				headerPatternOrg = SimpleLogBrowserBuilder.FILE_TIME_HEADER;
			}
		}
		
		if (headerPatternOrg != headerPattern && (headerPatternOrg == null || !headerPatternOrg.equals(headerPattern))){
			headerChanged = true;
		}
    try {
    	if(headerChanged) {
	    	LogAdminHelper.updateLogDataSourceHeaderBuilder(lbm,headerPattern,headerCheckNumOfRecords);
  			reloadLog = true;
  			logId = lbm.getId();
      	//ds.setHeaderBuilder(dsHeaderBuilder);
  			request.getSession().removeAttribute(CURRENT_LOG);
  		}
    }catch (Exception e) {
    }
		
		
	}
  
	String ignoreUnparsedRecordsStr = request.getParameter("ignoreUnparsedRecords");
	boolean ignoreUnparsedRecords = ignoreUnparsedRecordsStr != null && ignoreUnparsedRecordsStr.equalsIgnoreCase("on");
	boolean ignoreUnparsedRecordsChanged = LogAdminHelper.isIgnoreUnparsedRecords(lbm) != ignoreUnparsedRecords;
	if(ignoreUnparsedRecordsChanged) {
		reloadLog = true;
		logId = lbm.getId();
		LogAdminHelper.setIgnoreUnparsedRecords(lbm,ignoreUnparsedRecords);
		request.getSession().removeAttribute(CURRENT_LOG);
	}

  
  
	String consolidationStr = request.getParameter("consolidationStr");
	boolean consolidation = consolidationStr != null && consolidationStr.equalsIgnoreCase("on");
	lbm.setConsolidation(consolidation);
	
	String singleZoomInStr = request.getParameter("singleZoomInStr");
	boolean singleZoomIn = singleZoomInStr != null && singleZoomInStr.equalsIgnoreCase("on");
	
	String[] selCols = request.getParameterValues("CustomizedColSelect");
   
	//search and filter issue
	String searchAndFilterDefStr = request.getParameter("searchAndFilterDefStr");
	boolean searchAndFilterDef = searchAndFilterDefStr != null && searchAndFilterDefStr.equalsIgnoreCase("on");
	if(searchAndFilterDef) {
		searchAndFilterDefStr = "START";
	}else {
		searchAndFilterDefStr = "CURRENT";
	}
	lbm.setSearchAndFilterDef(searchAndFilterDefStr);

	String quickFilterStr = request.getParameter("useQuickFilter");
	boolean useQuickFilter = quickFilterStr != null && quickFilterStr.equalsIgnoreCase("on");
	lbm.setUseQuickFilter(useQuickFilter);
	
	String wholeWordsStr = request.getParameter("useWholeWords");
	boolean useWholeWords = wholeWordsStr != null && wholeWordsStr.equalsIgnoreCase("on");
	lbm.setUseWholeWords(useWholeWords);
	
	cuman = lbm.getCustomizationManager();
	mask = lbm.getRecordMask();
	int origColNumber= mask.getCulomnsNumber();
	
	int[] indexs = new int[mask.getCulomnsNumber()];
	int[] cols = new int[mask.getCulomnsNumber()];
	boolean atLeatOne = false;
	if (selCols != null && selCols.length > 0){
		for(int i=0;i<indexs.length;i++){
			cols[i] = i;
			indexs[i] = -1;
			for (int j=0; j<selCols.length; j++){
				if (selCols[j].equals(String.valueOf(i))){
					indexs[i] = j;
					break;
				}
			}
			atLeatOne = true;
		}
	}
  
	if(!atLeatOne){
		ErrorModel ermod = new ErrorModel();
		ermod.addError("You must specify at least one visible column.");
		request.getSession().setAttribute(ERROR_OBJ,ermod);
		response.sendRedirect("errorpage.jsp");
		return;
	}

	cuman.setCustomizationColumns(cols,indexs);
	lbm.updateMappingFromCustomization();

	/*
  LinearDataBuilder linearDataBuilder = lbm.getLinearDataBuilder();
  if (linearDataBuilder instanceof DefaultLinearDataBuilder){
  	LinearRecordsBuilder recsBuilder = ((DefaultLinearDataBuilder)linearDataBuilder).getLinearRecordsBuilder();
	  LinearRecordBuilder recBuilder = recsBuilder.getLinearRecordBuilder();
	  if (recBuilder instanceof TransactionRecordBuilder){
	  	((TransactionRecordBuilder)recBuilder).setColsMapping(cuman.getIndexToPlace());
	  }else if(lbm instanceof TransactionMergedLogBrowserManager){
	  	((TransactionMergedLogBrowserManager)lbm).setLogColsMappings();
	  }
  }
  */
   
	//Priorities color handling if exsit
	String[] priorities = null;
	int cnum = mask.getCulomnsNumber();
	int pindex = -1;
	for(int i=0;i<cnum;++i){
		if((mask.getMaskColumn(i) instanceof PriorityMask)){
			pindex = i;
			priorities = ((PriorityMask)mask.getMaskColumn(i)).getPriorities();
			//must leave this place
			//priorities = new String[]{"DEBUG" ,"INFO","WARN" ,"ERROR" ,"FALSE"};
		}
	}

	if(priorities != null){
		String usePriorityColorsStr = request.getParameter("usePriorityColors");
		boolean usePriorityColors = usePriorityColorsStr != null && usePriorityColorsStr.equals("true");
		HashMap pToColor = new HashMap();
		String color = "";
		for(int i=0;i<priorities.length;++i){
			color = request.getParameter(COLOR_PRIOR_NAME + i);
			if(color == null){
				color = "";
			}
			pToColor.put(priorities[i],color);
		}
		cuman.setUsePriorityBgColor(usePriorityColors);
		cuman.setPriorityColorMap(pToColor);
		cuman.setPriorityIndex(pindex);
	}
	

	String startOperation = request.getParameter("startOperation");
	if (startOperation != null && startOperation.trim().length() > 0){
		cuman.setStartOperation(startOperation);
	}
	//set customization to work from private conf and not from global customization
	cuman.setUseGlobal(false);
  
	cuman.clearMenues("logDataCM");
	HashMap map = new HashMap();
	int count = 0;
	int total = 0;
	boolean clearSearchItems = true;
	String col = request.getParameter("contextSearchCol0");
	while (col != null && col.length() > 0){
		String name = request.getParameter("contextSearchName" + count);
		String path = request.getParameter("contextSearchPath" + count);
		if (name == null || name.length() == 0 || path == null || path.length() == 0){
			count++;
			col = request.getParameter("contextSearchCol" + count);
			continue;
		}
    
		MenuItem item = new MenuItem();
		item.id = "customSearch" + total++;
		item.name = name;
		item.link = path;
		item.target = "_new";
		item.componentsMask = MenuItem.ALL_MASK;
		PopupMenu menu = (PopupMenu)map.get(col);
		MenuGroup group = new MenuGroup();
		if (menu == null){
			menu = new PopupMenu();
			menu.setPopupId("logDataCM");
			map.put(col,menu);     
			group.id = "search";
			group.name = "Search";
			group.componentsMask = MenuItem.ALL_MASK;
			menu.addItem(group);
		}else {
			group = (MenuGroup)menu.getItem("search");
		}
    
		if (group != null){
			if (clearSearchItems){
				group.items.clear();
				clearSearchItems = false;
			}
			group.items.add(item);
		}
    
		count++;
		col = request.getParameter("contextSearchCol" + count);
  }
	
	for (Iterator iter = map.keySet().iterator();iter.hasNext();){
		String key = (String)iter.next();
		int index = Integer.parseInt(key);
		PopupMenu menu = (PopupMenu)map.get(key);
		cuman.addPopupMenues(index,menu);
	}
  
	if (cuman instanceof MergeCustomizationManager){
		MergeCustomizationManager mergeCuman = (MergeCustomizationManager)cuman;
		mergeCuman.setZoomInToSingleLog(singleZoomIn);
		//merge logs naming 
		MergedLogBrowserManager mlbm = (MergedLogBrowserManager)lbm;
	  String[] logIds = mlbm.getLogBrowsersIds();
		String virtualName = "";
		HashMap logsIdToVirtualNames = new HashMap();
	  for (int i=0;logIds != null && i<logIds.length;++i){
	  	virtualName = request.getParameter(VIRTUAL_LOG_NAME + i);
			if(virtualName != null && virtualName.length() > 0){
				logsIdToVirtualNames.put(logIds[i],virtualName);
			}
		}
		MergeCustomizationManager mcuman = (MergeCustomizationManager)cuman;
		mcuman.setLogsIdToVirtualNames(logsIdToVirtualNames);
	}
	
	if(lbm instanceof MergedLogBrowserManager) {
		int number = mask.getCulomnsNumber();
	  String name = "";
	  for(int i=0;i<number;i++){
	    name = request.getParameter(FILED_NUMBER+i);
	    if((name != null ) && (!(name.trim().equals("")))){
	      mask.getMaskColumn(i).setName(name);
	    }
	  }
	}
  
	Integer calls = (Integer)request.getSession().getAttribute("callsPage");
	String calStr = "calls=";
	if (calls != null){
		calStr += calls.intValue() + 1;
	}

	boolean indexedColumnsChanged = false;
	boolean statisticsColumnChanged = false;
	
	int number = origColNumber;
	String name = "";
	String useIndexAction = "";
	String useStatisticsAction = "";
	for(int i=0;i<number  ;i++){
		name = request.getParameter(FILED+i);
		if(i >= 0 && (name != null ) && (!(name.trim().equals("")))){
		  mask.getMaskColumn(i).setName(name);
		}
		
		useIndexAction = request.getParameter("useColIndex"+i);
		boolean useIndex = useIndexAction != null && useIndexAction.equals("ON");
		if(i >= 0){
			if(!indexedColumnsChanged) {
				indexedColumnsChanged = mask.getMaskColumn(i).isUseIndex() != useIndex;
			}
			mask.getMaskColumn(i).setUseIndex(useIndex);
		}
		
		if(useInDashboard && computeStatistics) {
			useStatisticsAction = request.getParameter("useColStatistics"+i);
			if (i >=0){
				if (useStatisticsAction == null || useStatisticsAction.equals("no")){
					if (mask.getMaskColumn(i).isUseInStatistics()){
						statisticsColumnChanged = true;
					}
					mask.getMaskColumn(i).setUseInStatistics(false);
					mask.getMaskColumn(i).setComputeAvgContextStatistics(false);
				}else if (useStatisticsAction.equals("yes")){
					if (!mask.getMaskColumn(i).isUseInStatistics() || mask.getMaskColumn(i).isComputeAvgContextStatistics()){
						statisticsColumnChanged = true;
					}
					mask.getMaskColumn(i).setUseInStatistics(true);
					mask.getMaskColumn(i).setComputeAvgContextStatistics(false);
				}else if (useStatisticsAction.equals("useAvg")){
					if (!mask.getMaskColumn(i).isUseInStatistics() || !mask.getMaskColumn(i).isComputeAvgContextStatistics()){
						statisticsColumnChanged = true;
					}
					mask.getMaskColumn(i).setUseInStatistics(true);
					mask.getMaskColumn(i).setComputeAvgContextStatistics(true);
				}
			}
		}
	}
  if (statisticsColumnChanged){
  	mask.setLastStatisticsColumnUpdate(System.currentTimeMillis());
  }
	
  
	//date index
	String dateIndexStr = request.getParameter("dateIndex");
	if (dateIndexStr != null && dateIndexStr.length() > 0){
		try{
			int dateIndex = Integer.parseInt(dateIndexStr);
			mask.setDateColumnIndex(dateIndex);
		}catch(Exception e){}
	}
	
	LogAdminHelperQuery reindexQuery = new LogAdminHelperQuery();
	reindexQuery.setLbm(lbm);
	reindexQuery.setHandleIgnoreUnparsedRecords(true);
	reindexQuery.setHandleHeader(true);
	reindexQuery.setHandleIndexedColumnsChanged(true);
	reindexQuery.setIndexedColumnsChanged(indexedColumnsChanged);
	boolean shouldReindex = LogAdminHelper.shouldReindex(reindexQuery);
	
	UserSecurity security = WebSecurityManager.getInstance().getUserSecurity(request);
	if (security == null || security.isModuleMemberEditable(lbm.getId())){
		Module parent = mgmt.getParentModule(lbm.getId());
		admin.addLogBrowser(lbm,parent,userContext);
	}
	
	if(useInDashboardChanged) {
		HashSet logIds = new HashSet();
		logIds.add(lbm.getId());
		DashboardUpdateCacheQuery query = new DashboardUpdateCacheQuery();
		query.setLogsIds(logIds);
		DashboardDataManager.getInstance().updateCache(query);
		
		DashboardAdminHelper.updateLogUseInDashboard(null, null, lbm.getId(), useInDashboard, userContext, true);
	}

	if(shouldReindex) {
  	LogAdminHelper.reindexLog(userContext, lbm.getId());
  }
	
	//audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
			userContext, AuditConstants.CHANGE, "save/edit log", AuditConstants.LOGS, "change customization of log " + lbm.getName());
  
	if(reloadLog) {
		response.sendRedirect("../logview.jsp?logid="+logId+"&updateIDS=true");
	}else {
		response.sendRedirect("../logview.jsp");
	}
%>
