
<%@ page language="java"%>

<%@ page import="java.util.List"%>

<%@ page import="xpolog.eye.admin.helpers.LogAdminHelper"%>
<%@ page import="xpolog.eye.computation.ComputationExecutionManager"%>
<%@ page import="xpolog.eye.computation.ComputationResults"%>
<%@ page import="xpolog.eye.computation.ComputationResultView"%>
<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.data.filters.Filter"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.data.filters.FilterManager"%>
<%@ page import="xpolog.eye.LogBrowsingManager"%>
<%@ page import="xpolog.eye.logview.LogViewContext"%>
<%@ page import="xpolog.eye.ModuleMember"%>
<%@ page import="xpolog.eye.reports.ExecutionInfo"%>
<%@ page import="xpolog.eye.reports.ExecutionResult"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewHelper"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewGraphQuery"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewGraphResult"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModel"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewModelHelper"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewResult"%>
<%@ page import="xpolog.eye.reports.health.ui.HealthViewResultElement"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>
<%@page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@page import="xpolog.eye.reports.ExecutionResultFilter"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);

	LogBrowsingManager lbm = null;
  LogViewContext logcontext = (LogViewContext)request.getSession().getAttribute(LogViewContext.LOG_CONTEXT);	
  ComputationResultView computationResultView = logcontext.computationResultView;
  if(computationResultView == null){
  	computationResultView = new ComputationResultView();
  }
	String logId = logcontext.logId;
	if(logId != null){
		lbm = logcontext.lbm;
		if(lbm != null){
			ModuleMember mm = SiteManagment.getInstance().getModuleMember(logId);
			if(mm != null && !mm.isUseInDashboard()) {
				out.write("error");
				out.flush();
				return;
			}
			
			long now = System.currentTimeMillis();
			long logStartTime = -1;
			long logEndTime = now;
			long dashboardEndTime = now;
			long dashboardStartTime = -1;
			long filterMinTime = -1;					
			long filterMaxTime = now;
			
			if(lbm.getFilterManager() != null){
				FilterManager fm = lbm.getFilterManager();
				String activeFilterId = fm.getActiveFilterId();
				FilterCollection fc = lbm.getFilterManager().getFilterCollectionById(activeFilterId);
				if(fc!= null && fc.getFilters().size() > 0){
					List dfList = fc.getByName(DateFilter.DATE_FILTER_NAME);
					if(dfList != null && dfList.size() > 0) {
						Filter df = (Filter)dfList.get(0);
						if(df instanceof DateFilter){
							DateFilter filter = (DateFilter)df;
							filter.updateMinTime();
							if(filter.getMinDate() != null) {
								filterMinTime = filter.getMinDate().getTime();
							}
							if(filter.getMaxDate() != null) {
								filterMaxTime = filter.getMaxDate().getTime();
							}
							logEndTime = filterMaxTime;
						}else{
							out.write("stringFilter");
							out.flush();
							return;
						}
					}else{
						out.write("stringFilter");
						out.flush();
						return;
					}
				}else{
//				Get log data end time
					/*int dateIndex = lbm.getRecordMask().getDateColumnIndex();
					if(dateIndex > -1){
						RecordsMaskTableModel RMModel = lbm.getLastEntries(1);
						if(RMModel != null && RMModel.getRowCount() > 0){
							LogRecord rec = (LogRecord)RMModel.getRecordAt(0);			
							Date date = null;
							if(rec != null){
								Object obj = rec.getFieldAt(dateIndex);
								if (obj instanceof Date){
									date = (Date)obj;
									logEndTime = date == null ? now : date.getTime();
								}
							}
						}		
					}*/
				}
			}
			//Getting log start time.
			if(computationResultView.getLogComputedStartTime() > 0){
				logStartTime = computationResultView.getLogComputedStartTime();
			}else{
				logStartTime = LogAdminHelper.checkForUpdateLogStartTime(lbm,true);
				computationResultView.setLogComputedStartTime(logStartTime);
			}
			logStartTime = logStartTime > filterMinTime ?  logStartTime : filterMinTime;
			ComputationExecutionManager compExecMgr = ComputationExecutionManager.getInstance();
			ExecutionInfo executionInfo = compExecMgr.getExecutionInfo(ComputationExecutionManager.HEALTH_TYPE,logId);
			if (executionInfo != null){
				List executionList = executionInfo.getExecutionList();
				if(executionList != null && !executionList.isEmpty()){
					// get dashboard start time
					ExecutionResult executionResult = (ExecutionResult)executionList.get(0);
					if(executionResult != null){						 
						dashboardStartTime = executionResult.getStartTime();
						if (executionResult.isEmpty()){
							dashboardStartTime = -1;
							for(int i = 1; i < executionList.size();i++){
								executionResult = (ExecutionResult)executionList.get(i);
								if (!executionResult.isEmpty()){
									dashboardStartTime = executionResult.getStartTime();
									break;
								}
							}
							if (dashboardStartTime == -1){
								out.write("error");
								out.flush();
								return;
							}
						}
					}
					// get dashboard end time
					executionResult = (ExecutionResult)executionList.get(executionList.size() - 1);
					if(executionResult != null){
						dashboardEndTime = executionResult.getEndTime();
						if (executionResult.isEmpty()){
							for (int i = executionList.size() - 1;--i >= 0;){
								executionResult = (ExecutionResult)executionList.get(i);
								if (executionResult != null && !executionResult.isEmpty()){
									dashboardEndTime = executionResult.getEndTime();
									break;
								}
							}
						}
					}
				}
					
			}
			long startTime = logStartTime > dashboardStartTime ? logStartTime : dashboardStartTime;		
			long endTime =  logEndTime <  dashboardEndTime ? logEndTime : dashboardEndTime;
			if(endTime < startTime){
				//Get the heigher end time
				endTime =  logEndTime >  dashboardEndTime ? logEndTime : dashboardEndTime;
				//if still lower,get current time
				if(endTime < startTime){
					endTime = now;
				}
			}
			
			if(endTime % 1000 == 999) {
				endTime += 1;
			}
			boolean showMetrics = ComputationConfiguration.getInstance().isShowMetrics();
			HealthViewModel model = HealthViewModelHelper.getObjectModel(XpoLogObjectTypes.LOG_TYPE, logId, startTime, endTime, userContext,showMetrics);
			HealthViewResult currentResult = model.getCurrentResult();
			HealthViewResultElement rootNodeResultElement = currentResult.getRootNodeResultElement();
			ComputationResults rootNodeComputationResults = rootNodeResultElement.getComputationResults();
			
			String graphMapName = "total";
			HealthViewGraphQuery graphQuery = new HealthViewGraphQuery(560, 190, graphMapName);
			graphQuery.setShowZoom(false);
			graphQuery.setShowTooltip(false);
			graphQuery.setShowMeasurments(showMetrics);
			//Total graph image
			HealthViewGraphResult graphResult = HealthViewHelper.generateTotalXYChart(currentResult, graphQuery);
			String graphImagePath = graphResult == null || graphResult.getImagePath() == null ? "" : BASE_DIRECTORY + graphResult.getImagePath();		 										
			computationResultView.setGraphImagePath(graphImagePath);
			String graphMap = graphResult == null || graphResult.getMapStr() == null ? "" : graphResult.getMapStr();
			computationResultView.setGraphMap(graphMap);
			computationResultView.setTotal(rootNodeComputationResults.getTotal());
			computationResultView.setTotalProblems(rootNodeComputationResults.getTotalProblems());
			computationResultView.setTotalFiltered(rootNodeComputationResults.getTotalFiltered());
			computationResultView.setTotalKnowledge(rootNodeComputationResults.getTotalKnowledgeEvents());
			computationResultView.setTotalStatistical(rootNodeComputationResults.getTotalAnomalyEvents());
			
			computationResultView.setStartTime(startTime);
			computationResultView.setEndTime(endTime);
			computationResultView.setComputed(true);
			
			computationResultView.setType(XpoLogObjectTypes.LOG_TYPE);
			computationResultView.setId(logId);
			computationResultView.setName(lbm.getName());
			if(logcontext != null){
				logcontext.computationResultView = computationResultView;
			}
			out.write("ok");
			out.flush();
			return;		
		}	
	}else{
		out.write("error");
		out.flush();
		return;
	}
	
%>	

