<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.admin.helpers.SearchEngineAdminHelper"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%@ include file="../../tools/sandf/dateFilterAction.jsp"%>
<%
	ErrorModel err = new ErrorModel();
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	LogViewContext logcontext = (LogViewContext) request.getSession().getAttribute(LogViewContext.LOG_CONTEXT);
	String logRecordsJsp = "loggers/logview.jsp";
	String extra = "";
	if (logcontext != null && logcontext.lbm != null) {
		FilterCollection fc = null;

		String search = request.getParameter("search");
		if (search != null && search.length() > 0) {
      String regExp = request.getParameter("regExp");
      String wholeWord = request.getParameter("wholeWords");
      String enc = logcontext.lbm.getCharset();
      if(enc != null) {
      	search = new String(search.getBytes("8859_1"), enc);
      }
			fc = SearchEngineAdminHelper.createFilter(search, false,logcontext.lbm, wholeWord != null && wholeWord.equals("true"), regExp != null && regExp.equals("true"), false, userContext);

		}

		DateFilter dfilter = null;
		try {
			dfilter = createDateFilter(request, response, logcontext.lbm.getRecordMask());
		} catch (Exception e) {
			e.printStackTrace();
		}
    
		if (dfilter != null) {
			dfilter.updateMinTime();
			if (fc == null){
			  fc = new FilterCollection();
			  fc.setId("timeFilter");
			  fc.setName("timeFilter");
			  fc.setTransientFilter(true);
			}
			fc.addFilter(dfilter);
		}
		if (fc != null){
			logcontext.lbm.getFilterManager().addFilterCollection(fc);
	  	//audit
			AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "filtered log view", AuditConstants.LOGS, "filter view using " + fc.getSummary());	 	 	
		}		
		logRecordsJsp = logcontext.isOlap ? BASE_DIRECTORY + "logic/online/translogrecords.jsp" : "logrecords.jsp";
		extra = "addFilter=true&";
		String searchAndFilterDef = logcontext.lbm.getSearchAndFilterDef();
		if (searchAndFilterDef == null || searchAndFilterDef.length() == 0) {
			searchAndFilterDef = Configuration.getInstance().getPropertiesManager().getProperty("searchAndFilterDef", "START");
		}
		extra += "addFilter=true&opdirect=" + searchAndFilterDef + "&";
	}

	response.setHeader("Cache-Control", "no-cache");
	response.sendRedirect(BASE_DIRECTORY + "loggers/logview.jsp?" + extra + "forward=" + logRecordsJsp);
%>
	
