<%@ page language="java"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.global.filters.GlobalFilters"%>
<%@ page import="xpolog.eye.common.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.comparators.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.index.*"%>
<%@ page import="xpolog.eye.data.index.adapters.IndexAdapter"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="omega.ui.models.*"%>
<%@ page import="omega.ui.html.table.OHtmlTable"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.data.log.external.*"%>
<%@ page import="xpolog.eye.data.log.files.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.data.xml.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.audit.*"%>
<%@page import="xpolog.eye.meta.MetaDataManager"%>
<%@page import="xpolog.eye.computation.ComputationExecutionManager"%>
<%@page import="xpolog.eye.reports.ExecutionInfo"%>
<%@page import="xpolog.eye.merge.MergedLogBrowserManager"%>
<%@page import="xpolog.eye.meta.MetaData"%>
<%@page import="xpolog.eye.computation.conf.ComputationConfiguration"%>


<%@ page autoFlush="true"%>
<%!
static String EMPTY_STR = "";

	int ALLOWED_LOG_NAME_LENGTH = 30;

	static final String BASE_DIRECTORY = "../";

	static String[] filterExtraNames = {"Zoom Out"};

	static String[] filterExtraFunctions = {"goLastFilterView()"};

	static String[] keysNames = {"logview.keys.prevKey",
								 "logview.keys.nextKey", 
								 "logview.keys.lastKey",
								 "logview.keys.firstKey"};

	static String[] keysFunctions = {"goPrevTop()", 
									 "goNextTop()",
									 "goLastTop()", 
									 "goStartTop()"};
	
	static boolean showTimeFilter = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("logview.showTimeFilter",false);
%>
<%
	
  LogViewContext logcontext = (LogViewContext)request.getSession().getAttribute(LogViewContext.LOG_CONTEXT);
  String ERROR_OBJ = "ERROR_OBJ";
  if (logcontext == null || logcontext.lbm == null){
  	ErrorModel ermod = new ErrorModel();
		ermod.addError("You may not see the log. Please check for license constraints!");
		ermod.addError("It is probable that maximum number of active users was reached.");
		ermod.addError("Please try again later.");
		ermod.addError("For license upgrades visit us at <a href=http://www.xpolog.com>XpoLog</a>");
		request.getSession().setAttribute(ERROR_OBJ, ermod);
		response.sendRedirect("admin/errorpage.jsp");
		return;
  }
  
//getting the managment
  SiteManagment mgmt = SiteManagment.getInstance();
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  WebSecurityManager securityManager = WebSecurityManager.getInstance();
  UserSecurity user = securityManager.getUserSecurity(request);
  UserContext userContext = UserEnvironment.getUserContext(request);


	String id = logcontext.logId;
	String logRecordsJsp = logcontext.isOlap ? BASE_DIRECTORY + "logic/online/translogrecords.jsp" : "logrecords.jsp";

	LogViewQueryInfo queryInfo = logcontext.query;

	LogBrowsingManager man = logcontext.lbm;
	man.clearLastQuery();

	//header name
	String name = man.getName();

	/**
	 * Dashboard segment
	 */
	String objId = ""; 
	String dashboardLink = "";
	boolean isDashboardExist = SiteManagment.getInstance().getXpologManagment().isComponentValid(XpologManagment.ANALYTICS_COMPONENT);
  final boolean showDashboard = Configuration.getInstance().getPropertiesManager().getProperty("logview.showDashboardInfo","true").equalsIgnoreCase("true") && isDashboardExist && securityManager.isHavePermission(userContext,ActionsPermissionConstants.DashboardPermissions.DASHBOARD_VIEW_PERMISSION);
	boolean isDisplayDashboardButton = false;
	if(!showDashboard || man instanceof MergedLogBrowserManager || man.isTemporary() || !man.isShowDashboardInLogView()){
		isDisplayDashboardButton = false;
	}else{
		ComputationExecutionManager compExecMgr = ComputationExecutionManager.getInstance();
		ExecutionInfo executionInfo = compExecMgr.getExecutionInfo(ComputationExecutionManager.HEALTH_TYPE,man.getId());
		if (executionInfo != null){
			isDisplayDashboardButton  = executionInfo.getExecutionListSize() > 0 ;// && !updateDashboardInfo;
			//Get parent app id
			String appId = MetaData.OTHER_ID;
			MetaDataManager metaMgr = SiteManagment.getInstance().getMetaDataMgr();
			if(metaMgr != null){
				HashSet parentMetaDatas = metaMgr.getMetaDatasByXplgObject(XpoLogObjectTypes.LOG_TYPE, logcontext.logId, true);
				if(parentMetaDatas != null && !parentMetaDatas.isEmpty()){
					Iterator it = parentMetaDatas.iterator();
					if(it.hasNext()){
						MetaData app = (MetaData)it.next();					
						if(app != null){
							appId = app.getId();
						}
					}
				}
			}
			objId = XpoLogObjectTypes.LOG_TYPE + "-" + appId + "@" + logcontext.logId;
		}
	}

	//leap size
	LogViewQueryInfo queryinfo = logcontext.query;
	queryinfo.uniqueId = System.currentTimeMillis();
	int leapsize = queryInfo.leapsize;
	String op = queryInfo.op;

	
	String search = queryInfo.search;

	boolean isNeedsToUpdateData = op.equals("TAIL");
	String tailFuncName = isNeedsToUpdateData ? "Stop Tail" : "Tail";
	String tailFunc = isNeedsToUpdateData ? "goLast()" : "goTail()";

	String title = EMPTY_STR;

	DataReferenceBuilder dfBuilder = logcontext.dfBuilder;

	String dfBuilderType = null;
	String dfBuilderTitle = "Go To";
	DataReferenceBuilder[] viewBuilders = new DataReferenceBuilder[0];
	if (dfBuilder != null) {
		ArrayList list = new ArrayList();
		dfBuilder.getBuilders(list);
		viewBuilders = (DataReferenceBuilder[])list.toArray(new DataReferenceBuilder[list.size()]);
		if (viewBuilders.length > 0) {
			for (int i = viewBuilders.length - 1; i >= 0; i--) {
		if (viewBuilders[i].isVisible()) {
			dfBuilderType = viewBuilders[i].getTitle();
			break;
		}
			}

			if (dfBuilderType != null) {
		if (dfBuilderType.equalsIgnoreCase("Line")) {
			dfBuilderTitle = "Go To Line";
		}else if (dfBuilderType.equalsIgnoreCase("File")) {
			dfBuilderTitle = "Go To File";
		}
			}
		}
	}

	
	int moveSteps = queryInfo.moveSteps;
	LogViewQuickFilter quickFilter = new LogViewQuickFilter(man);

	/**
	 * filter segment
	 */

	String searchAndFilterDef = man.getSearchAndFilterDef();
	if (searchAndFilterDef == null || searchAndFilterDef.length() == 0) {
		searchAndFilterDef = Configuration.getInstance().getPropertiesManager().getProperty("searchAndFilterDef", "START");
	}
	FilterManager film = man.getFilterManager();
	List listfilters = film.getFilterCollections();
	String activeFilter = "";
	if (!op.equals("ZOOM_IN")) {
		if (op.equals("LAST_FILTER_VIEW")) {
			activeFilter = man.getLastActiveFilter();
		}else {			
			activeFilter = film.getActiveFilterId();
		}
	}
	boolean displayResetBtn = (activeFilter != null && activeFilter.length() > 0)|| (search != null && search.length() > 0) ? true : false;
//Search history handling
	SearchValuesMgr searchMgr = UserEnvironment.getUserEnvironment(request).getSearchValuesMgr();
	String[] searchVals = null;
	if (searchMgr != null) {
		searchVals = searchMgr.getValues(id);
		if (search != null && search.length() > 0) {
			searchMgr.addValue(id, search);
		}
	}

	String searchAndFilterDefStr = man.getSearchAndFilterDef();
	if (searchAndFilterDefStr == null || searchAndFilterDefStr.length() == 0) {
		searchAndFilterDefStr = Configuration.getInstance().getPropertiesManager().getProperty("searchAndFilterDef", "START");
	}
	//add the value to the search history.
	String zoomOutUrl = logcontext.zoomOutUrl;
	boolean disableZoomOut = logcontext.disableZoomOut;
	boolean showBack = false;
	ArrayList filterExtraIndexes = new ArrayList();
	if (!disableZoomOut && (op.equals("ZOOM_IN") || (!op.equals("LAST_FILTER_VIEW") && man.isHavingLastFilterView()) || zoomOutUrl != null)) {
		showBack = true;
	}

	boolean useQuickFilter = logcontext.useQuickFilter;

	IndexStatus indexStatus = logcontext.indexStatus;
	if(indexStatus == null) {
		indexStatus = new IndexStatus(IndexStatus.NO_STATUS, -1);
	}
  IndexAdapter indexer = SearchEngineManager.getInstance().getDefaultIndexAdapter();
	boolean isIndexed = indexer.isIndexed(new IndexedObject(man.getId()));
	boolean enableAutoSuggest = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("logview.useSearchSuggestions", true);
	boolean useAutoSuggest = enableAutoSuggest && isIndexed && man.isUseSearchSuggestions();
	boolean editable =  (man.getId() != null && man.getId().length() > 0 && (userContext == null || userContext.isModuleMemberEditable(man.getId())));

	String mark = queryInfo.mark;
	String legend = man.getLegend().getHtml();
 
	//some imaging configuratio
	Properties prop = Configuration.getInstance().getUIData();
	String firstImg = BASE_DIRECTORY + prop.getProperty("logview.firstarrow.image");
	String nextImg = BASE_DIRECTORY + prop.getProperty("logview.next.image");
	String lastImg = BASE_DIRECTORY + prop.getProperty("logview.lastarrow.image");
	String prevImg = BASE_DIRECTORY + prop.getProperty("logview.prev.image");
	String currImg = BASE_DIRECTORY + prop.getProperty("logview.currentarrow.image");
	String expandImg = BASE_DIRECTORY + prop.getProperty("logview.expandframe.image");
	String unExpandImg = BASE_DIRECTORY + prop.getProperty("logview.unexpandframe.image");
	String minusImg = BASE_DIRECTORY + prop.getProperty("logview.minus.image");
	String plusImg = BASE_DIRECTORY + prop.getProperty("logview.plus.image");
	String zoomoutImg = BASE_DIRECTORY + prop.getProperty("logview.zoomout.image");

	String charset = man.getCharset();
	if(charset == null) {
		charset = Configuration.getInstance().getPropertiesManager().getProperty("logview.defaultCharecterEncoding", null);
		if(charset != null && charset.length() == 0) {
			charset = null;
		}
	}
	if (charset != null) {
		if (charset.startsWith("UTF-16")){
			charset = "UTF-8";
		}
		response.setContentType("text/html; charset=" + charset);
	}
		
	int indexingPolicy = Configuration.getInstance().getPropertiesManager().getPropertyAsInt("logview.showRunIndex", LogViewContext.WHEN_NOT_INDEXED);
	boolean searchEngineAvailable = SiteManagment.getInstance().getXpologManagment().isComponentLicenseValid(XpologManagment.SEARCH_ENGINE_COMPONENT);
	boolean indexingEnabled =  searchEngineAvailable && indexingPolicy != LogViewContext.NEVER && (indexingPolicy == LogViewContext.BY_STATUS || !isIndexed);
	
	
	String tempName = null;
	String topDiv = "";
  tempName = name;
  if(name != null && name.length() > ALLOWED_LOG_NAME_LENGTH) {
  	tempName = name.substring(0,ALLOWED_LOG_NAME_LENGTH) + "...";
  }
  topDiv = "<table width=\"100%\" height=\"100%\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\"><tr>" + 
  "<td width=\"10\" class=\"TOP_VIEW_TD\"><nobr>" + tempName  + "</nobr></td>" + 
  "<td width=\"10\" class=\"TOP_VIEW_TD\"><nobr>&nbsp; - <span id=\"titleSpan\"></span></nobr></td>" +
  "<td width=\"*\" class=\"TOP_VIEW_TD\">" + (legend == null || legend.length() == 0 ? "&nbsp;" : legend) + "</td></tr></table>";
  
  String leapSizesList = Configuration.getInstance().getPropertiesManager().getProperty("logview.leapSizes","25,50,100,250,500");
  String[] leapSizes = leapSizesList.split(",");
  
%>

<html>

<head>
<%if (charset != null) {%>
<meta http-equiv="Content-Type" content="text/html; charset=<%=charset%>">
<%}else {%>
<meta http-equiv="Content-Language" content="en-us">
<%}%>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link charset="iso-8859-1" rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link charset="iso-8859-1" rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/logview.css" />

<script charset="iso-8859-1" src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script charset="iso-8859-1" src="<%=BASE_DIRECTORY%>dashboard/view/dashboard.js" type="text/javascript"></script>
<script charset="iso-8859-1" src="<%=BASE_DIRECTORY%>scripts/dataview/dataprogress.js" type="text/javascript"></script>
<script charset="iso-8859-1" src="searchSuggest.js" type="text/javascript"></script>
<script charset="iso-8859-1" language="javascript">
  //update menu
  <%if(logcontext.refreshMenu){%>
  	//refreshMenus('<%=XpoLogObjectTypes.LOG_TYPE + "-" + id%>','Module');
  	markItem('<%=XpoLogObjectTypes.LOG_TYPE + "-" + id%>','Module');
  	<%}%>
  	
  if (parent && parent.document.getElementById("topDiv")){
     parent.document.getElementById("topDiv").innerHTML = '<%=topDiv%>';
     
  }
   	
  var value = <%=leapsize%>;
  var calls = <%=String.valueOf(logcontext.cal)%>;
  var needsToUpdateData = false;
  var runIndexing = <%=logcontext.runIndexing%>;
  var rememberAnswer = <%=logcontext.rememberAnswer%>;
  var doQuickFilter = <%=useQuickFilter%>;
  var ignoreIndex  = false;
  var showProgress = true;
  function initPage(){
    
    document.access.leaptop.selectedIndex = 0;
    //document.access.updateIntervalDS.value = "0";
	var list = document.access.leaptop.options;
	for (var i = 0; i < list.length; i++) {
	  if (list[i].text == value){
		document.access.leaptop.selectedIndex = i;
	  }
	} 
	
  }

  function goNextTop(){
    goNext(document.access.leaptop.options[document.access.leaptop.selectedIndex].text);
  }
 
  function goNext(size){
	updatePage(size,"NEXT");
  }
  function goPrevTop(){
    goPrev(document.access.leaptop.options[document.access.leaptop.selectedIndex].text);
  }
 
  function goPrev(size){
	updatePage(size,"PREV");
  }

  function goLast(){
    size = document.access.leaptop.options[document.access.leaptop.selectedIndex].text;
    updatePage(size,"LAST");
  }

  function goLastTop(){
    goLast(document.access.leaptop.options[document.access.leaptop.selectedIndex].text);
  }

  function goStart(size){
	updatePage(size,"START");
  }

  function goStartTop(){
    goStart(document.access.leaptop.options[document.access.leaptop.selectedIndex].text);
  }
  
  function goCurrent(size){
	updatePage(size,"CURRENT");
  }

  function goCurrentTop(){
    goCurrent(document.access.leaptop.options[document.access.leaptop.selectedIndex].text);
  }
  
  function goMove(size){  		
	updatePage(size,"MOVE");
  }


  function goMoveTop(){
    goMove(document.access.leaptop.options[document.access.leaptop.selectedIndex].text);
  }

  function doMark(){
	size = document.access.leaptop.options[document.access.leaptop.selectedIndex].text;
	updatePage(size,"CURRENT");
  }


  function doSearch(quickFilter){
    doQuickFilter = quickFilter;
    if (ignoreIndex || document.getElementById('searchText').value == ""){
      doSearchDirect(quickFilter);
      return;
     }
     if (rememberAnswer){
       doSearchDirect(quickFilter);
       return;
     }
		<%if (indexStatus == null || !indexingEnabled || logcontext.indexLog == null || !logcontext.indexLog.equals("")){%>
			doSearchDirect(quickFilter);
		<%}else{%>
		<%if (indexStatus.getStatus() == IndexStatus.NEED_TO_INDEX){%>
			showGoToIndexDiv("searchLink","searchIndexStatusDiv");
		<%} else {%>
			<%if (indexStatus.getStatus() == IndexStatus.AUTO_INDEX){%>
				runIndexing = 'true';
		  <%} else {%>
				runIndexing = 'false';
		  <%}%>
			doSearchDirect(quickFilter);
	    <%}%>
    <%}%>
  }

  function doSearchDirect(quickFilter){
	  rememberAnswer = document.getElementById("rememberSearchIndexing").checked;
	  
    if (quickFilter){
      var combo = document.getElementById("filters");      
      //if (document.access.searchText.value == "" && combo.options.selectedIndex > 0){
      //  goFilter();
      //  return;
      //}
    	document.access.quickFilterUsed.value = "true";
	    goQuickFilter(document.access.searchText.value);
    //show reset button.
      showHideResetButton(true);
  
    }else{
    	document.access.quickFilterUsed.value = "false";
			size = document.access.leaptop.options[document.access.leaptop.selectedIndex].text;
			updatePage(size,"<%=searchAndFilterDefStr%>");
		  //show/hide reset button.
       showHideResetButton(true);
    }
  }
  
  function formatSearchText(searchText){
  	while(searchText.indexOf('"')!=-1){
	  	searchText = searchText.replace(/"/,"&quot;");
	  }
  	return searchText;
  }
  
  var logRef;

  function zoomIn(key){
    size = document.access.leaptop.options[document.access.leaptop.selectedIndex].text;
		if (key){
     updatePageWithKey(size,"ZOOM_IN",key);
		}else{
     updatePageWithKey(size,"ZOOM_IN",logRef);
		}
  }
  
  function zoomInToNewLog(lid){
    size = document.access.leaptop.options[document.access.leaptop.selectedIndex].text;    
    document.zoomAccess.disableZoomOut.value = "true";
    updatePageWithKeyAndNewLogId(size,"ZOOM_IN",logRef,lid);
  }

   function goTail(){
     goTailSize(25);
  }

  function goTailSize(size){       
        updatePage(size,"TAIL");
        document.getElementById("tailLink").className = "BOTTOM_BAR_SELECTED_LINK";
  }

  function goLastFilterView(){
    <%if (zoomOutUrl != null){
    	if(zoomOutUrl.indexOf("http") >=0){%>
    	<%if (logcontext.zoomOutFromMainViewPage){%>
				 frm = getMainViewFrame();
				 if (frm){
				 	frm.location = "<%=BASE_DIRECTORY + zoomOutUrl%>";
				 }
		 	<%}else{%>
		 	this.location = "<%=zoomOutUrl%>";
		 	<%}%>
		<%}else if(zoomOutUrl.indexOf("useZoomOutAction") >=0){%>
			<%if (logcontext.zoomOutFromMainViewPage){%>
				 frm = getMainViewFrame();
				 if (frm){
				 	frm.location = "getZoomOutParamsAction.jsp";
				 }
		 	<%}else{%>
		 	this.location = "getZoomOutParamsAction.jsp";
		 	<%}%>		 
		<%}else{%>
    	<%if (logcontext.zoomOutFromMainViewPage){%>
				 frm = getMainViewFrame();
				 if (frm){
				 	frm.location = "<%=BASE_DIRECTORY + zoomOutUrl%>";
				 }
			<%}else{%>
         this.location = "<%=BASE_DIRECTORY + zoomOutUrl%>";
      <%}%>
         <%}%>
    <%} else {%>
      document.access.addFilter.value = "true";
      updatePage(document.access.leaptop.options[document.access.leaptop.selectedIndex].text,"LAST_FILTER_VIEW");
      document.access.addFilter.value = "";
    <%}%>
  }
  
  function getMainViewFrame(){
  	var mgmtFrm = getManagemtnFrame();
	  if(mgmtFrm && mgmtFrm.parent && mgmtFrm.parent.frames['main']) {
	    var frm =  mgmtFrm.parent.frames['main'];
	    if (frm.location && frm.location.href && frm.location.href.indexOf("mainView.jsp") != -1){
	      return frm;
	    }
	  }
  }

  function goNew(){
    goNextWithSize(document.access.leaptop.options[document.access.leaptop.selectedIndex].text);
  }

  function goNewWithSize(size){
    if (needsToUpdateData){
      updateData(size,"TAIL");
    }
  }


  function updatePage(size,direct){
     updatePageWithKey(size,direct,"");
  }

  function updatePageWithKey(size,direct,key){
        updatePageWithKey(size,direct,key,"");
  }
  function updatePageWithKey(size,direct,key,moreParams){
  			doCloseDashboardInfo();
        needsToUpdateData = false;
        updateProg = false;
        document.access.search.value = formatSearchText(document.access.searchText.value);
        if(document.access.search.value != ""){
	        showHideResetButton(true);
        }else if(direct == "ZOOM_IN"){
	        showHideResetButton(false);
	      }
        re = (document.access.regExp.checked == true) ? "true" : "";
        ww = (document.access.wholeWords.checked == true) ? "true" : "";
        document.access.searchRegExp.value = re;
        document.access.filterWholeWords.value = ww;
        document.access.leapsize.value = size;
        document.access.opdirect.value = direct;
        document.access.zoomInKey.value = key;
        document.access.runIndexing.value = runIndexing;
        document.access.rememberAnswer.value = rememberAnswer;
        document.access.action="logview.jsp";
        document.access.target="logRecordsView";
        resetStatus();
        recordsLoaded = false;
        if (showProgress && (!runIndexing || runIndexing != 'true')){
          showProgess(true);
        }
        if (runIndexing == 'true'){
          document.access.target = "";
          document.access.forward.value = "logviewpage.jsp";
        }
        document.access.submit();
        
        setTimeout("goProgress()", 1000);
	//this.location="logview.jsp?leapsize="+ size +"&opdirect=" + direct + "&calls="+calls + "&mark=" + mark + "&search=" + search + "&zoomInKey=" + key + "&"+moreParams;

  }
  
  function updatePageWithKeyAndNewLogId(size,direct,key,lid){
    document.zoomAccess.opdirect.value = direct;
		document.zoomAccess.zoomInKey.value = key;
		document.zoomAccess.gotoMain.value = "true";
		document.zoomAccess.logid.value = lid;
		document.zoomAccess.action="logview.jsp";
		document.zoomAccess.target="_parent";
		document.zoomAccess.submit();
	}
  

  function updateIntervalData(){
  	document.access.updateIDS.value = "true";
  	showProgress = false;
  	goCurrentTop();
  	showProgress = true;
  	document.access.updateIDS.value = "false";
  }


  function updateData(size,direct){
     updateDataWithKey(size,direct,"");
  }

  function updateDataWithKey(size,direct,key){
     needsToUpdateData = true;
     search = document.access.searchText.value;
     re = (document.access.regExp.checked == true) ? "true" : "";
     mark = "";
     calls++;
     frames['dataResultFrame'].location="tailrecords.jsp?leapsize="+ size +"&opdirect=" + direct + "&calls="+calls + "&mark=" + mark + "&search=" + search + "&zoomInKey=" + key + "&searchRegExp=" + re + "&runIndexing=" + runIndexing;
  }

  function copyImageAttributes(result,n){
    for (var i = 0; i < n.attributes.length;i++){
      var att = n.attributes[i];
      if (att.specified && att.nodeName == "src"){
       result.setAttribute(att.nodeName,att.nodeValue);
      }
    }

    for (var i = 0; i < n.attributes.length;i++){
      var att = n.attributes[i];
      if (att.specified && att.nodeName != "src"){
         result.setAttribute(att.nodeName,att.nodeValue);
      }
    }
  }


  function copy(n){
   if (!n.tagName && n.childNodes.length == 0){
      var s = n.nodeValue;
      if (s == null){
        s ="";
      }

      return frames['logRecordsView'].document.createTextNode(s);
   }
   var result = frames['logRecordsView'].document.createElement(n.tagName);
   if (n.tagName == "IMG" ){
     copyImageAttributes(result,n);
   }else {
     for (var i = 0; i < n.attributes.length;i++){
       var att = n.attributes[i];
       if (att.specified){
         result.setAttribute(att.nodeName,att.nodeValue);
       }
     }
   }
   result.style.cssText = n.style.cssText;
   result.className = n.className;

   for (var i = 0; i < n.childNodes.length;i++){
     if (n.childNodes[i].outerHTML != "<BR>"){
        var oTD = copy(n.childNodes[i]);
        result.appendChild(oTD);
     }else {
       result.innerHTML += n.childNodes[i].outerHTML;
     }
   }
   return result;
  }

  function dataLoaded(){
    
    if (needsToUpdateData){
      var dataTable = frames['dataResultFrame'].document.getElementById("logTable");
      var viewTable = frames['logRecordsView'].document.getElementById("logviewTable");
      if (dataTable != null && viewTable != null){
        
        var dataTBody = dataTable.childNodes.length > 1 ? dataTable.childNodes[1] : dataTable.childNodes[0];
        //var viewTable = layerSetup("logviewTable");
        var viewTBody = viewTable.childNodes.length > 1 ? viewTable.childNodes[1] : viewTable.childNodes[0];
       
        if (viewTBody.childNodes.length + dataTBody.childNodes.length > <%=Configuration.getInstance().getPropertiesManager().getProperty("tailNumberOfRecrodsDef","500")%>){
           goTail();
           return;
        }

        for (var i = 0; i < dataTBody.childNodes.length;){
           var obj = copy(dataTBody.childNodes[i]);          
	    dataTBody.deleteRow(i);
	   
           viewTBody.appendChild(obj);
           
        }
      }
      frames['logRecordsView'].scrollTo(0,frames['logRecordsView'].document.body.scrollHeight);
      refreshData();

    }
  }

  function refreshData(){
     var id = window.setTimeout("goNewWithSize("+ <%=Configuration.getInstance().getPropertiesManager().getProperty("tailNumberOfRecrodsDef","500")%> + ")",<%=Configuration.getInstance().getPropertiesManager().getProperty("tailRefreshRateDef","2000")%>);


  }

  function clearTable(keepNumber){
    var viewTable = frames['logRecordsView'].document.getElementById("logviewTable");
    var viewTBody = viewTable.childNodes[1];
    var num = viewTBody.childNodes.length - keepNumber;
    for (var i = num - 1; i >= 0; i--){
      viewTBody.deleteRow(i);
    }
  }

  function doCheckKey(e){
   	if (!e) var e = window.event;
	if (e.keyCode) code = e.keyCode;
	else if (e.which) code = e.which;
	if (code == 13 || code==59){
	  return false;
	}
	return true;
  }

  function doCheckMark(e){
	var result = doCheckKey(e);
        if (!result){
         doMark();
        }
	return result;
  }

   function doCheckSearch(e){
	var result = doCheckKey(e);
        if (!result){
         doSearch(doQuickFilter);
        }
	return result;
  }



  function hideShowMenu(){    
	root = top.frames['root'];	
	if (!root){
	  root = parent;
	}
	
	if (!root){
	  return;
	}
	
	if (root.location.href == document.location.href || root.location.href.indexOf("root.jsp") == -1){
	  root.location = "<%=BASE_DIRECTORY%>root.jsp?mainPage=loggers/logview.jsp&<%=logcontext.queryStr%>";
	}else {
	  root.location =  "<%=BASE_DIRECTORY%>loggers/logview.jsp?<%=logcontext.queryStr%>";
	}
  }

  function getExpandImageName(){
	root = top.frames['root'];
	if (!root){
	  root = parent;
	}
	
	if (!root || root.location.href == document.location.href || root.location.href.indexOf("root.jsp") == -1){
	  return "<%=unExpandImg%>";
	}else {
	  return "<%=expandImg%>";
	}
  }


   
   			function getFilterEntries(f){
   				var i = f.indexOf("*");
   				if (i != -1){
   					return f.substring(i+1,f.length)
   				} else {
   					return f;
   				}
   			}
   			function getFilterId(f){
   				var i = f.indexOf("*");
   				if (i != -1){
   					return f.substring(0,i);
   				} else {
   					return f;
   				}
   			}
   			
        function editFilter(){
          id = getFilterId(document.access.filters.options[document.access.filters.selectedIndex].value);
          path = "../tools/sandf/searchAndFilter.jsp?EDIT_FILTER_ID="+id;
          parent.location = path;
        }
        function removeFilter(){
          id = getFilterId(document.access.filters.options[document.access.filters.selectedIndex].value);
          path = "../tools/sandf/searchAndFilterAction.jsp?REMOVE_FILTER_ID="+id;
          parent.location = path;
        }
        function newFilter(){
          path = "../tools/sandf/searchAndFilter.jsp?OP=ADD";
          parent.location = path;
        }
        function newMultiFilter(negate){
				  if(negate == false && document.access.filters.options.length < 3){
	    		 alert("There must be at least two exsiting filters in order to create a Multi Filter.");
			     return;
          }
          path = "../tools/sandf/multiFilter.jsp?OP=ADD";
          if (negate == true){
          	path = path + "&Negate=true";
          }
          parent.location = path;
        }
        
        function newEventsTimeFilter(){
				  if(document.access.filters.options.length < 3){
	    		 alert("There must be at least two exsiting filters in order to create a Multi Filter.");
			     return;
          }
          path = "../tools/sandf/eventsTimeFilter.jsp?OP=ADD";          
          parent.location = path;
        }
        
        
        
        function goFilter(){
          id = getFilterId(document.access.filters.options[document.access.filters.selectedIndex].value);
          entries = getFilterEntries(document.access.filters.options[document.access.filters.selectedIndex].value);
          
          if (rememberAnswer || ignoreIndex){
            goFilterDirect();
       			return;
     			}
          <%if (!indexingEnabled || logcontext.indexLog == null || !logcontext.indexLog.equals("")){%>
          	goFilterDirect();
          <%}else{%>
          if (entries != ""  && id != "none"){
	        	<%if (indexStatus.getStatus() == IndexStatus.NEED_TO_INDEX){%>
							showGoToIndexDiv("filterOperation","filterIndexStatusDiv");
	        	<%} else {
							if (indexStatus.getStatus() == IndexStatus.AUTO_INDEX){%>
								runIndexing = 'true';
						  <%} else {%>
								runIndexing = 'false';
						  <%}%>
	          goFilterDirect();
	          <%}%>
	        }else {
	          goFilterDirect();
	        }
	        <%}%>
        	//update dashboarf info according to time filter	        
					<%if(isDisplayDashboardButton){%>
					  updateDashboardInfo();        	
				  <%}%>
        }
        
        function duplicateFilter(){
          id = getFilterId(document.access.filters.options[document.access.filters.selectedIndex].value);
          path = "../tools/sandf/searchAndFilter.jsp?EDIT_FILTER_ID="+id+"&OP=duplicate";
          parent.location = path;
        }

        function goFilterDirect(){
          rememberAnswer = document.getElementById("rememberFilterIndexing").checked;
          <%if (logcontext.indexLog!=null && logcontext.indexLog.equals("true") && indexStatus.getStatus() == IndexStatus.NEED_TO_INDEX){%>
          	runIndexing = 'true';
          <%}%>
          id = getFilterId(document.access.filters.options[document.access.filters.selectedIndex].value);
          path = "../tools/sandf/searchAndFilterAction.jsp?ACTIVATE_FILTER_ID="+id+"&RUN_INDEXING="+runIndexing+"&REMEMBER_ANSWER="+rememberAnswer + "&forward=loggers/logview.jsp?forward=<%=logRecordsJsp%>";
          path = path + "&quickFilterUsed=" + doQuickFilter;
          
          beginLogRecordsChanged();
          if (frames['logRecordsView']){
             frames['logRecordsView'].location = path;
          }
          endLogRecordsChanged();                                  
         //show/hide reset button.
					if(id == "none"){
   		      showHideResetButton(false);
					}else{
	          showHideResetButton(true);
	        }
        }
        
        
        function showHideResetButton(isShow){
        	var showBtnElem = document.getElementById('showBtnDiv');
        	var hideBtnElem = document.getElementById('hideBtnDiv');        
        	if(isShow){
        			showBtnElem.style.display = "";
        			hideBtnElem.style.display = "none";
        	}else{
        			showBtnElem.style.display = "none";
        			hideBtnElem.style.display = "";      	        
        	}
        }
        
        
        function beginLogRecordsChanged(){
          resetStatus();
          recordsLoaded = false;
          if (showProgress && (!runIndexing || runIndexing != 'true')){
            showProgess(true);
          }
        }
        
        function endLogRecordsChanged(){
          setTimeout("goProgress()", 1000);
        }
        
        function goQuickFilter(filterTerm,ind){       
          //path = "logview.jsp?calls=" + calls + "&opdirect=<%=searchAndFilterDef%>&quickFilterTerm=" + filterTerm + "&quickFilterUsed=true&searchRegExp=" + re+"&filterWholeWords=" + ww;
          //if (ind){
          //	path += ("&quickFilterIndex=" + ind);
          //}
          document.access.quickFilterTerm.value = filterTerm;
          if (ind){
	          document.access.quickFilterIndex.value = ind;
	        }
          document.access.searchText.value = "";
          document.access.addFilter.value = "true";
	        size = document.access.leaptop.options[document.access.leaptop.selectedIndex].text;
			    updatePage(size,"<%=searchAndFilterDefStr%>");
      		document.access.addFilter.value = "";
	      	document.access.quickFilterTerm.value = "";
        }
        
        function createFilterMenu() {
 		 filterMenu = new jsDOMenu(100,"","absolute");
 		 with (filterMenu) {
 		 	<%if (editable){%>
    		addMenuItem(new menuItem("Edit", "editItem", "javascript:editFilter()"));
		    addMenuItem(new menuItem("New", "newItem", "javascript:newFilter()"));
		    addMenuItem(new menuItem("Multi", "multiItem", "javascript:newMultiFilter(false)"));
			<%}%>
		    <%if (showTimeFilter){%>
  		    addMenuItem(new menuItem("Events Time", "eventsTimeItem", "javascript:newEventsTimeFilter()"));
  		  <%}%>
 		 	<%if (editable){%>
		    addMenuItem(new menuItem("Negate", "negateItem", "javascript:newMultiFilter(true)"));
		    addMenuItem(new menuItem("Duplicate", "duplicateItem", "javascript:duplicateFilter()"));
		    addMenuItem(new menuItem("-"));
		    addMenuItem(new menuItem("Remove", "removeItem", "javascript:removeFilter()"));
			<%}%>
		 } 
		 <%
		   
	 		 if (quickFilter.getQuickFilterCount() > 0){
	 		 
	 		 %>
	 		 <%if (editable || showTimeFilter){%>
	 		   filterMenu.addMenuItem(new menuItem("-"));
	 		 <%}%>
	 		   
	 		<%   
	     for (int i = 0; i < quickFilter.getQuickFilterCount(); i++) {
	       String filterId = "filterMenu" + i;
	       int colIndex = quickFilter.getQuickFilterColumnIndexAt(i);
	       String [] quickFilters = quickFilter.getQuickFiltersAt(i);
	       %>
	       filterMenu.addMenuItem(new menuItem("<%=quickFilter.getQuickFilterColumnNameAt(i)%>", "<%=filterId%>", ""));
	       <%=filterId%> = new jsDOMenu(100,"","absolute");
	       with(<%=filterId%>){
	         <%for (int j = 0; j < quickFilters.length; j++) {%>
	           addMenuItem(new menuItem("<%=quickFilters[j]%>", "<%=filterId + "_" + j%>", "javascript:goQuickFilter('<%=quickFilters[j]%>','<%=String.valueOf(i)%>')"));
	         <%}%>
	       }
	       filterMenu.items.<%=filterId%>.setSubMenu(<%=filterId%>);
				<%}%>	       	     	   	     	   				
	     <%}%>
		 //filterChanged();
		}
		
		function selectedSearchVal(searchStr) {
    		document.getElementById('searchText').value = searchStr;
		}
		
		function clearSearchBox() {
    		document.getElementById('searchText').value = '';
		}
		
		function setQuickFilter(qf){
			doQuickFilter = qf;
			doSearchDirect(true);
		}
		
		
        
        function filterChanged(){
                	
          enable = document.access.filters.selectedIndex > 0;          
          setItemEnabled(filterMenu.items.duplicateItem,enable);
          var filterSelected = document.access.filters.options[document.access.filters.selectedIndex];
          enable = (filterSelected.innerHTML.indexOf('<%=GlobalFilters.GLOBAL_FILTER_NAME_PREFIX %>') != 0);
          setItemEnabled(filterMenu.items.editItem,enable);
          setItemEnabled(filterMenu.items.removeItem,enable);
          
        }


        function kpress(e){
          if (!e) var e = window.event;
          if(e.srcElement){
            objElement = e.srcElement;
            if(objElement == document.access.searchText){
              return;
            }
          }


	  if (e.keyCode) code = e.keyCode;
	  else if (e.which) code = e.which;
          key = String.fromCharCode(code);
          <%
          for (int i = 0; i < keysNames.length; i++) {
            String keyValue = prop.getProperty(keysNames[i]);
            if (keyValue != null && keyValue.length() > 0){%>
               if (code == "<%=keyValue%>" || key == "<%=keyValue%>"){
                  <%=keysFunctions[i]%>;
               }
            <%}
          }%>

         }

         if(document.layers){
           document.captureEvents(Event.KEYPRESS)
         }
         document.onkeypress=kpress;



      


function DataRefBuilder(){
  this.keys = new Array();
  this.builders = new Array();
  this.title = "";
  this.selectedIndex = -1;
}

function createNewDataRefBuilder(){
  return new DataRefBuilder();
}

var rootDataSource = new createNewDataRefBuilder();
var deep = <%=dfBuilder == null? 0 : dfBuilder.getDeepLength()%>;



function updateGoTo(index,builder){
  if (index < deep){
    if (builder.keys.length > 0){
      var combo = document.getElementById("goToDS_" + index);
      combo.options.length = 0;
      for (var i = 0; i < builder.keys.length;i++){
       combo.options[combo.options.length] = new Option(builder.keys[i],builder.keys[i]);
      }
      var selIndex = builder.selectedIndex == -1 ? 0 : builder.selectedIndex;
      combo.selectedIndex = selIndex;
      updateGoTo(0,builder.builders[0]);
    }else {
      document.getElementById("goToDS_" + (deep -1)).value = "";
    }
  }
}



 function goTo(){
   size = document.access.leaptop.options[document.access.leaptop.selectedIndex].text;
   updatePage(size,"GOTO");
 }

  function doGoTo(e){
	var result = doCheckKey(e);
        if (!result){
         goTo();
        }
	return result;
  }


function init(){
  showProgess0(true);
  showSlide('logSlides',true);
  <%if(isDisplayDashboardButton){%>
	  updateDashboardInfo();
  <%}%>
  //snapshot xml loading
  if(initTables){
	  initTables();	
	}
  
}


var recordsLoaded = false;
function recordsViewLoaded(){
 if (parent && parent.document.getElementById("titleSpan") && frames['logRecordsView'].title){
    parent.document.getElementById("titleSpan").innerHTML = frames['logRecordsView'].title;     
  }
 showProgess(false);
 if (!recordsLoaded){
   
   DataRefBuilder();
   updateProg = false;
   updateQueryStatus();
   recordsLoaded = true;
   
   updateGoTo(0,rootDataSource);
   
   if (<%=isNeedsToUpdateData%>){
     //refreshData();
   }
 }
}

var updateProg = true;
function getProgressFrame(){
  return self;
}

function goProgress(){
  if (updateProg){
    updateQueryStatus();
  }
}

var statusreq;

function resetStatus(){
  document.getElementById("recordsMsg").innerHTML = "&nbsp;";
  document.getElementById("recordsTime").innerHTML = "&nbsp;";
  recProgress.setprogress(0);
  updateProg = true;
}


function updateQueryStatus(){
  if (typeof XMLHttpRequest != "undefined") {
       statusreq = new XMLHttpRequest();
   } else if (window.ActiveXObject) {
       statusreq = new ActiveXObject("Microsoft.XMLHTTP");
   }
   statusreq.open("GET", "queryStatus.jsp", true);
   statusreq.onreadystatechange = statuscallback;
   statusreq.send(null);
}

function statuscallback() {
  if (statusreq.readyState == 4) {
    if (statusreq.status == 200) {
    	if(statusreq.responseXML) {
	      var val = statusreq.responseXML.getElementsByTagName("value")[0];
	      if (val && val.childNodes && val.childNodes.length > 0){
	        var num = val.childNodes[0].nodeValue;
	        recProgress.setprogress(num);
	      }
	      var msg = statusreq.responseXML.getElementsByTagName("message")[0];
	      if (msg && msg.childNodes && msg.childNodes.length > 0){       
	        document.getElementById("recordsMsg").innerHTML = msg.childNodes[0].nodeValue;
	      }
	      var t = statusreq.responseXML.getElementsByTagName("time")[0];
	      if (t && t.childNodes && t.childNodes.length > 0){       
	        document.getElementById("recordsTime").innerHTML = t.childNodes[0].nodeValue;
	      }
	    }
	    setTimeout("goProgress()", 1000);
    }
  }
}

function refreshRecordsView(){
  frames['logRecordsView'].location = "<%=logRecordsJsp%>?refresh=true&timestamp=<%=String.valueOf(System.currentTimeMillis())%>";
}

var cancelreq;
function cancelQuery(){
  document.getElementById("tailLink").className = "BOTTOM_BAR_LINK";
  if (needsToUpdateData){
    needsToUpdateData = false;
    goLast();    
    return;
  }
  updateProg = false; 
  if (typeof XMLHttpRequest != "undefined") {
       cancelreq = new XMLHttpRequest();
   } else if (window.ActiveXObject) {
       cancelreq = new ActiveXObject("Microsoft.XMLHTTP");
   }
   cancelreq.open("GET", "cancelQuery.jsp", true);
   cancelreq.onreadystatechange = cancelback;
   cancelreq.send(null);  
}

function cancelback() {
  if (cancelreq.readyState == 4) {
    if (cancelreq.status == 200) {
      refreshRecordsView();
    }
  }
}





function move(step){
  document.access.moveSteps.value = "" + step;
  if (step == 0){
    return;
  }
  goMoveTop();
}


function showGoToIndexDiv(posElem,divElem){  
  //comp = document.getElementById(posElem);
  //d = document.getElementById(divElem);
  //x = findPosX(comp) - d.clientWidth;
  //y = findPosY(comp) + 70;
  showHideLayerInMiddle(divElem,-1,100);
}

function formatQuery(){
	while(document.access.searchTerm.value.indexOf('"')!=-1){
		document.access.searchText.value = document.access.searchText.value.replace(/"/,"&quot;");
	}
}

function gotoLogViewById(lbmId){
	<%if(man.isOlapView()){%>
	this.location = "<%=BASE_DIRECTORY%>logic/online/translogviewAction.jsp?transParadigmId="+lbmId+"&zoomOutUrl=logic/online/translogviewAction.jsp";
	<%} else {%>
	this.location = "logview.jsp?logid="+lbmId+"&zoomOutUrl=loggers/logview.jsp?logid=<%=man.getId()%>";
	<%}%>
}

function openPrintableView(){
	pw = window.open("logrecords.jsp?printableView=true","printWindow","width=720,height=600,location=no,scrollbars=yes,menubar=yes");
	pw.focus();
}

function changeView(viewType){
  var oldVal = document.access.viewType.value;
  if (viewType == oldVal){
    return;
  }
  document.access.viewType.value = viewType;
  document.getElementById("viewTypeImg" + oldVal).src = "<%=BASE_DIRECTORY%>images/logview/viewType" + oldVal + ".gif";
  document.getElementById("viewTypeImg" + viewType).src = "<%=BASE_DIRECTORY%>images/logview/viewTypeSel" + viewType + ".gif";
  goCurrentTop();
}

function addFilter(id,value){ 
  var combo = document.getElementById("filters");
	//UPDATE DASHBOARD DIV INFO
	<%if(isDisplayDashboardButton){%>
		  updateDashboardInfo();        	
  <%}%>
  if (combo != null){
     if(value != ""){
	      showHideResetButton(true);
     }    
    for(var i = 0; i < combo.options.length;i++){
      if (combo.options[i].value == id){
        combo.options[i].selected = true;
        return;
      }
    }
    combo.options[combo.options.length] = new Option(value,id);
    combo.options[combo.options.length - 1].selected = true;
  }
}

function clearFilter(){
  var combo = document.getElementById("filters");
  if (combo != null && combo.options.length > 1){
    combo.options.selectedIndex = 0;
  }
}

function showBack(doShow){
  if (doShow){
    document.getElementById("backLink").style.display = "";
  }else {
    document.getElementById("backLink").style.display = "none";
  }
}

function leapChanged(){
  var size = document.access.leaptop.options[document.access.leaptop.selectedIndex].text;
  doBackgroundAction("logviewContextAction.jsp?op=changeLeapSize&leapSize=" + size);
}

var inProgress = true;
function showProgess(show){
  if (show){
    inProgress = true;
    setTimeout("showProgess0(true)", 1000);
  }else {
    showProgess0(false);
  }
}

function showProgess0(show){
  var divElem = document.getElementById("progressDiv");
  if (show && inProgress){
    inProgress = false;
    showHideLayerInMiddle("progressDiv",-1,100);
  }else {
    inProgress = false;
    divElem.style.visibility = "hidden";
  }
}

function openWindow(url,target){
   document.searchFormPage.searchText.value = "";
   document.searchFormPage.forwardURL.value = url;
   document.searchFormPage.target=target;  
   document.searchFormPage.colIndex.value = "";
   document.searchFormPage.submit();
} 

function showMessageFromXML(xmldoc){
   if (xmldoc.getElementsByTagName('message')[0].firstChild){
			       var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
			       var title = xmldoc.getElementsByTagName('title')[0].firstChild.nodeValue;			       
			       var msgWriter = new messageWriter("logviewMessage",title,"<%=BASE_DIRECTORY%>");
			       var w = 350;
			       if (xmldoc.getElementsByTagName('width')[0] && xmldoc.getElementsByTagName('width')[0].firstChild){
			         w = xmldoc.getElementsByTagName('width')[0].firstChild.nodeValue;
			       }
			       var h = 120;
			       if (xmldoc.getElementsByTagName('height')[0] && xmldoc.getElementsByTagName('height')[0].firstChild){
			         h = xmldoc.getElementsByTagName('height')[0].firstChild.nodeValue;
			       }			      
   				   msgWriter.setPosition(-1,100);
   				   msgWriter.setSize(w,h);    			   
    			   msgWriter.addAction("Close","javascript:hideLayer('logviewMessage')");  
    			   msgWriter.showMessage(message);
			     }	
}

function doReset(){
	document.access.filters.selectedIndex = 0;
	goFilter();

}

var recProgress = new Progress("records",10,4);
var logProgress = new Progress("logfiles",20,4);



//DASHBOARD BAR 
var isDashboardBlink = false;
var dashboardInfoHTML = null;

//update the computation result object
function updateDashboardInfo(){
		doCloseDashboardInfo();
		var page = "logDashboardInfo.jsp";
		sendAjaxRequest(page,function(req){
			var result = req.responseText;
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result || result == "error"){
				hideDashboardButton();
				return;
			}else if(result == "ok"){
					setDashboardInfoView();
					displayDashboardButton();	
					return;		
			}else if(result == "stringFilter"){
					return;		
			}
		});
}

function hideDashboardButton(){   
		var dashboardButtonDivElem = document.getElementById('dashboardButtonDiv');
		if(dashboardButtonDivElem){
				dashboardButtonDivElem.innerHTML = "&nbsp;";
		}						
}

//dispaly dashboard div button according to computed 
//computation result object
function displayDashboardButton(){
		if(!dashboardInfoHTML){
			setDashboardInfoView();
		}
		var page = "logDashboardButton.jsp?base_directory=<%=BASE_DIRECTORY%>";
		sendAjaxRequest(page,function(req){
			var result = req.responseText;
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result || result == "error"){
				alert("Problem getting DashboardInfo View!");			
				return;
			}
			var dashboardButtonDivElem = document.getElementById('dashboardButtonDiv');
			if(dashboardButtonDivElem){
				dashboardButtonDivElem.innerHTML = result;
				if (!isDashboardBlink) {
				  isDashboardBlink = true;
				  blinkDashboardButtonIntervalObject = setTimeout("blinkDashboardButton(0, 0)", 1000);
				}
			}
		});
}

function setDashboardInfoView(){
		var page = "logDashboardInfoView.jsp";
		sendAjaxRequest(page,function(req){
			var result = req.responseText;
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result || result == "error"){
				dashboardInfoHTML = "Problem getting DashboardInfo!";			
				return;
			}else{
				dashboardInfoHTML = result;	
			}
		});
}

var blinkDashboardButtonTimeoutObject;
function blinkDashboardButton(value, counter) {
	if(counter < 5) {
		var logViewerDashboardButtonLeftTd = document.getElementById("logViewerDashboardButtonLeftTd");
		var logViewerDashboardButtonCenterTd = document.getElementById("logViewerDashboardButtonCenterTd");
		var logViewerDashboardButtonRightTd = document.getElementById("logViewerDashboardButtonRightTd");
		if(logViewerDashboardButtonLeftTd && logViewerDashboardButtonCenterTd && logViewerDashboardButtonRightTd) {
			var nextValue;
			if(value == 1) {
				logViewerDashboardButtonLeftTd.className = "LOG_VIEWER_DASHBOARD_BUTTON_LEFT_CELL";
				logViewerDashboardButtonCenterTd.className = "LOG_VIEWER_DASHBOARD_BUTTON_CENTER_CELL";
				logViewerDashboardButtonRightTd.className = "LOG_VIEWER_DASHBOARD_BUTTON_RIGHT_CELL";
				
				nextValue = 0;
			}else {
				logViewerDashboardButtonLeftTd.className = "LOG_VIEWER_DASHBOARD_BUTTON_OVER_LEFT_CELL";
				logViewerDashboardButtonCenterTd.className = "LOG_VIEWER_DASHBOARD_BUTTON_OVER_CENTER_CELL";
				logViewerDashboardButtonRightTd.className = "LOG_VIEWER_DASHBOARD_BUTTON_OVER_RIGHT_CELL";
				
				nextValue = 1;
			}
			blinkDashboardButtonTimeoutObject = setTimeout("blinkDashboardButton(" + nextValue + ", " + (counter + 1) + ")", 1000);
		}
	}else {
		clearTimeout(blinkDashboardButtonTimeoutObject);
		isDashboardBlink = true;
	}
}

function doOpenDashboardInfo(){
	var x = document.body.clientWidth - 191;
	var y = 10;

	var id = "logviewDashboardDiv";
	var divElem = document.getElementById(id);
	if(divElem){
		if(divElem.style.display == "block"){
			doCloseDashboardInfo();
			return;
		}
		if(dashboardInfoHTML){
			divElem.innerHTML = dashboardInfoHTML;
			divElem.style.display = "block";						
			showHideLayerInMiddle(divElem.id,(x - 415),(y + 20),true);
			<%if (ComputationConfiguration.getInstance().isShowMetrics()){%>
			showMetricsLegendDiv();
			<%}%>
			
		}else{
			divElem.innerHTML = "";
		}
	}		
}

function showMetricsLegendDiv() {
	var dashboardMetricsGraphLegendDiv = document.getElementById("dashboardMetricsGraphLegendDiv");
	var dashboardGraphDiv = document.getElementById("logviewDashboardDiv");	
	if(dashboardMetricsGraphLegendDiv && dashboardGraphDiv) {				
			dashboardMetricsGraphLegendDiv.style.left = "55px";
			dashboardMetricsGraphLegendDiv.style.top = "175px";
			dashboardMetricsGraphLegendDiv.style.display = "block";
	}
}

function doCloseDashboardInfo(){
    <%if (isDisplayDashboardButton){%>
    var id = "logviewDashboardDiv";
		var divElem = document.getElementById(id);
		if(divElem){			
			divElem.style.display = "none";
		}			
		<%}%>
}

//Right click menu functions defined in logrecords.jsp
function _find(){
 frames['logRecordsView'].find();
}
function _filterIn(isDateCol){
 frames['logRecordsView'].filterIn(isDateCol);
}
function _filter(prefix){
 frames['logRecordsView'].filter(prefix);
}
function _gotoUrl(url,target){
 frames['logRecordsView'].gotoUrl(url,target);
}

function _print0(){
 frames['logRecordsView'].print0();
}

function _searchText(url,target){
 frames['logRecordsView'].searchText(url,target);	  
}

function _searchCustom(url){
 frames['logRecordsView'].searchCustom(url);	  
}
	  
var selectedColType;	 
var isFilterActive;
	  
//SNAPSHOT
var selectedRowsArray = new Array();
var oldRowsClsArray = new Array();
	  
//FILTER IN SEVERAL LOGS
var isMultiLogSelection = false;

function filterMergeView(){
		updateSelected();	
		if(!document.access.logs.value || document.access.logs.value.length == 0){
			alert("No log was selected");
			return;
		}

	closeLogSelectionDiv();
	var action = "<%=BASE_DIRECTORY%>loggers/filterLogSelectionAction.jsp";
	if(isMultiLogSelection){
		action = "<%=BASE_DIRECTORY%>loggers/filterMultiLogSelectionAction.jsp";	
	}
	document.access.searchEngineSearchTerm.value = document.access.searchText.value;
	document.access.action = action;
	document.access.target="_parent";
  document.access.submit();
	
}
function updateSelected(){
	if (tree){
		list = tree.getAllCheckedAndPartiallyChecked();
		arr = list.split(",");
		isMultiLogSelection = arr.length > 1;
	  var logsStr = "";
	  var filtersStr = "";
		for (var i=0; i<arr.length; i++){
			s = arr[i];
			ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				type = s.substring(0,ind);
				id = s.substring(ind+1,s.length);
				if (type == "<%=XpoLogObjectTypes.LOG_TYPE%>"){
					if (logsStr != ""){
						logsStr += ",";
					}
					logsStr += id;
				}else if (type == "<%=XpoLogObjectTypes.FILTER_TYPE%>"){
					if (filtersStr != ""){
						filtersStr += ",";
					}
					filtersStr += id;
				}
			}
		}
		document.access.logs.value = logsStr;
	}else{
	}
}

</script>
<link charset="iso-8859-1" rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/jsdomenu.css" />
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" charset="iso-8859-1"  type="text/javascript"></script>
<jsp:include page="../scripts/comps/jsdomenu.jsp" flush="true">
	<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<jsp:include page="../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<script charset="iso-8859-1" src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
</head>
<body onload='javascript:initPage();init();' onunload='javascript:clearSuggestionsCache()' topmargin="0" leftmargin="0" rightmargin="0" scroll="NO" style="overflow-y: hidden;overflow-x: hidden;">

<div id="logviewDashboardDiv" class="LOG_VIEWER_DASHBOARD_DIV">
</div>
<%

LogContextMenu contextMenu = new LogContextMenu(env,man);
String searchMenuScript = contextMenu.getPopupsScript();
if (searchMenuScript != null && searchMenuScript.indexOf("logDataCM_search") > 0){
  java.util.regex.Pattern pat = java.util.regex.Pattern.compile(".*(logDataCM_search =.*)",java.util.regex.Pattern.DOTALL);
  java.util.regex.Matcher matcher = pat.matcher(searchMenuScript);
  if (matcher.matches()){
	  searchMenuScript = matcher.group(1);
	  searchMenuScript = searchMenuScript.replaceAll(":searchText",":_searchText");
	  searchMenuScript = searchMenuScript.replaceAll(":searchCustom",":_searchCustom");
  }else {
	  searchMenuScript = "";
  }
}else {
	searchMenuScript = ""; 
}
request.setAttribute("searchMenuScript",searchMenuScript);

%>
<!-- SNAPSHOT DIV -->
			<jsp:include page="logviewpageAdvanced.jsp" flush="true">
			<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
			</jsp:include>
<!-- END SNAP DIV -->

<jsp:include page="../common/selectLogHeader.jsp" flush="true">
	<jsp:param name="baseDirectory" value="../" />
	<jsp:param name="mode" value="logs" />
	<jsp:param name="LBM_ID" value="<%=man.getId()%>" />	
	<jsp:param name="treeOnly" value="true" />
	<jsp:param name="ignoreHeader" value="true" />
	<jsp:param name="checkBoxes" value="true" />	
	<jsp:param name="closeTreeUponSelect" value="false" />		
	<jsp:param name="paramNameWidth" value="150" />
</jsp:include>
<jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="title" value="Select Log(s) to Filter"/> 
	<jsp:param name="suffix" value="SelectLog"/> 
	<jsp:param name="width" value="500px"/> 
	<jsp:param name="height" value="300px"/> 
	<jsp:param name="actionsNames" value="View#Cancel"/> 
	<jsp:param name="actions" value="javascript:filterMergeView()#javascript:closeLogSelectionDiv()"/> 
</jsp:include>

<div id="tooltip" class="TREE_NODE_CLASS" style="position:absolute;display:none;z-index:120">
<table border="0" width="300" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
	<tr>
		<td class="PROGRESSTEXT" colspan="2" id="tooltipTitle" align="center" style="padding-top:3;padding-bottom:3;border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5"></td>
	</tr>
	<tr>
		<td style="font-size:4">&nbsp;</td>
	</tr>
	<tr>
		<td class="PROGRESSTEXT" style="padding-left:5">From: </td>
		<td id="tooltipFromDate" class="PROGRESSTEXT" style="padding-left:5;padding-right:5"></td>
	</tr>
	<tr>
		<td class="PROGRESSTEXT" style="padding-left:5">To: </td>
		<td id="tooltipToDate" class="PROGRESSTEXT" style="padding-left:5;padding-right:5"></td>
	</tr>
	<tr>
		<td style="font-size:4">&nbsp;</td>
	</tr>
	<tr>
		<td id="tooltipValueType" class="PROGRESSTEXT" style="padding-left:5"></td>
		<td id="tooltipValue" class="PROGRESSTEXT" style="padding-left:5;padding-right:5"></td>
	</tr>
	<tr>
		<td style="font-size:4">&nbsp;</td>
	</tr>
</table>
</div>
<div id="multitooltip" class="TREE_NODE_CLASS" style="position:absolute;display:none;z-index:120">
<table border="0" width="450" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
	<tr>
		<td colspan="2" class="PROGRESSTEXT" colspan="2" id="multitooltipTitle" align="center" style="padding-top:3;padding-bottom:3;border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5"></td>
	</tr>
	<tr>
		<td colspan="2" style="font-size:4">&nbsp;</td>
	</tr>
	<tr>
		<td class="PROGRESSTEXT" style="padding-left:5">From: </td>
		<td width="*" id="multitooltipFromDate" class="PROGRESSTEXT" align="left" style="padding-left:5;padding-right:5"></td>
	</tr>
	<tr>
		<td class="PROGRESSTEXT" style="padding-left:5">To: </td>
		<td width="*" id="multitooltipToDate" class="PROGRESSTEXT" align="left" style="padding-left:5;padding-right:5"></td>
	</tr>
	<tr>
		<td colspan="2" style="font-size:4">&nbsp;</td>
	</tr>
	<tr>
		<td colspan="2" id="tooltipTD" class="PROGRESSTEXT" style="padding-left:5">
		</td>
	</tr>
	<tr>
		<td colspan="2" style="font-size:10">&nbsp;</td>
	</tr>
</table>
</div>


<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">

<tr height="35" ><td bgcolor="#bfc3dd"  style="height:35;padding-left:2;padding-top:3;padding-bottom:0" nowrap>

<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%"> 
<tr><td style="padding-top:0;padding-bottom:2;" background="<%=BASE_DIRECTORY%>images/logview/controlSimpleBg.gif">
<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">                                     
                      <tr>
                       <td width="0">
<form AUTOCOMPLETE="OFF" id="searchFormPage" name="searchFormPage" method="post" action="logDataContextAction.jsp" target="_new">
<input type="hidden" name="searchText" value="">
<input type="hidden" name="forwardURL" value="">
<input type="hidden" name="colIndex" value="">
</form>                      
                       <form AUTOCOMPLETE="OFF" id="zoomAccess" name="zoomAccess" method="post">
<input type="hidden" name="logid" value="">
<input type="hidden" name="gotoMain" value="";>
<input type="hidden" name="opdirect" value="CURRENT"> 
<input type="hidden" name="zoomInKey" value=""> 
<input type="hidden" name="disableZoomOut" value="">
</form>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<input type="hidden" name="enc" value="<%=charset == null? "" : charset%>">
<input type="hidden" name="calls" value="<%=String.valueOf(logcontext.cal)%>">
<input type="hidden" name="opdirect" value="CURRENT"> 
<input type="hidden" name="leapsize" value="<%=leapsize%>"> 
<input type="hidden" name="search" value="<%=queryInfo.search == null ? "" : queryInfo.search%>"> 
<input type="hidden" name="quickFilterTerm"> 
<input type="hidden" name="quickFilterIndex">
<input type="hidden" name="searchRegExp" value="<%=queryInfo.isRegExp%>"> 
<input type="hidden" name="filterWholeWords" value="<%=queryInfo.isWholeWords%>">
<input type="hidden" name="runIndexing" value="<%=logcontext.runIndexing%>">
<input type="hidden" name="rememberAnswer" value="<%=logcontext.rememberAnswer%>">
<input type="hidden" name="mark" value=""> 
<input type="hidden" name="zoomInKey" value=""> 
<input type="hidden" name="moveSteps" value="0"> 
<input type="hidden" name="updateIDS" value="false"> 
<input type="hidden" name="zoomOutUrl" value="<%=zoomOutUrl != null ? zoomOutUrl : ""%>">
<input type="hidden" name="quickFilterUsed" value="<%=useQuickFilter%>">
<input type="hidden" name="newLogId">
<input type="hidden" name="forward" value="<%=logRecordsJsp%>">
<input type="hidden" name="viewType" value="<%=logcontext.viewType%>">
<input type="hidden" name="addFilter" value="">
<input type="hidden" name="logs" value="">
<input type="hidden" name="searchEngineSearchTerm" value="">
<input type="hidden" name="isDateColumn" value="">
<input type="hidden" name="selectedRowIndex" value="">


                       </td>
                        <!-- This is the navigation part -->
                        <td background="<%=BASE_DIRECTORY%>images/logview/controlBg.gif"  style="width:5" width="5"> 
                        <div id="filterIndexStatusDiv" style="position:absolute;visibility:hidden;height:80;width:200">
		 						    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid DBDFE2">
											<tr height="10"><td align="center"  style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
											  <span class="PROGRESSTEXT">Log Indexing</span>
									    </td>
									    </tr>
		 						    	<tr height="10"><td class="PROGRESSTEXT" align="center">Log needs to be indexed. Start indexing?</td></tr>
											<tr height="10">
												<td align="center">
													<input type="checkbox" name="rememberFilterIndexing" id="rememberFilterIndexing"><span class="PROGSMALLTEXT">remember my answer</span></input>
												</td>
											</tr>
											<tr height="20">
												<td align="center" style="padding:5">
					 								<a class="PROGRESSLINK" href="javascript:hideLayer('filterIndexStatusDiv');">cancel</a>&nbsp;<nobr>
					  							<a class="PROGRESSLINK" href="javascript:hideLayer('filterIndexStatusDiv');runIndexing='true';goFilterDirect()">yes</a>&nbsp;<nobr>
					  							<a class="PROGRESSLINK" href="javascript:hideLayer('filterIndexStatusDiv');runIndexing='false';goFilterDirect()">no</a>&nbsp;<nobr>
												</td>
											</tr>
		 							 	</table>
									</div>  
                        	<div id="searchIndexStatusDiv" style="position:absolute;visibility:hidden;height:80;width:250">
		 						    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
											<tr height="10" ><td align="center"  style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
											  <span class="PROGRESSTEXT">Log Indexing</span>
									    </td>
									    </tr>
		 						    	<tr height="20" style="padding:5"><td class="PROGRESSTEXT" align="center">Log needs to be indexed.<br> Start indexing?</td></tr>
											<tr height="10" >
												<td align="center">
													<input type="checkbox" name="rememberSearchIndexing" id="rememberSearchIndexing"><span class="PROGSMALLTEXT">remember my answer</span>
												</td>
											</tr>
											<tr height="20">
												<td align="center" style="padding:5">
					 								<a class="PROGRESSLINK" href="javascript:hideLayer('searchIndexStatusDiv');">cancel</a>&nbsp;<nobr>
					  							<a class="PROGRESSLINK" href="javascript:hideLayer('searchIndexStatusDiv');runIndexing='true';doSearchDirect(doQuickFilter)">yes</a>&nbsp;<nobr>
					  							<a class="PROGRESSLINK" href="javascript:hideLayer('searchIndexStatusDiv');runIndexing='false';doSearchDirect(doQuickFilter)">no</a>&nbsp;<nobr>
												</td>
											</tr>
		 							 	</table>
									</div>
									
									<div id="search_suggest_div" onfocus="keepSuggestDivOpen()" onblur="hideSuggest()" style="overflow-y:auto;position:absolute;display:none;height:20;width:230;background-color: #FFFFFF;border:1px solid DBDFE2">
									</div>  

									
									<div id="progressDiv" style="position:absolute;visibility:hidden;height:80;width:200">
		 						    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid DBDFE2">
											<tr height="10"><td align="center"  style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
											  <span class="PROGRESSTEXT">Status</span>
									    </td>
									    </tr>
		 						    	<tr height="*"><td class="PROGRESSTEXT" align="center">Processing...</td></tr>											
		 							 	</table>
									</div>  
                        </td>
                                <td width="10" border="1" align="left" style="padding-left:20">                                
                                <a href='javascript:goStartTop()' class="LINK">
								<img alt="first records" title="first records" border="0" src="<%=firstImg%>"></a></td>
								<td width="10" >
								<a  href="javascript:goPrevTop()" class="LINK">
								<img alt="previous records" title="previous records" border="0" src="<%=prevImg%>"></a></td>
								<td width="15" style="padding-top:2;padding-bottom:2">
								<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
								<tr><td height="10" background="<%=BASE_DIRECTORY%>images/logview/navBg.gif">
                                <select class="TEXTBOX" size="1" name="leaptop" style="font-family: Verdana, Geneva, Arial, Helvetica; font-size: 7pt; padding-left: 3px;" <%=isNeedsToUpdateData? "DISABLED" : ""%> onChange="javascript:leapChanged()">
                                	<%for (int l=0; l<leapSizes.length; l++){%>
                                    <option><%=leapSizes[l]%></option>
                                  <%}%>
                                  </select>
                 </td>
                 </tr>
                 </table>
									</td>
									<td width="15" >
                                <a href='javascript:goNextTop()' class="LINK">
                                  <img alt="next records" title="next records" border="0" src="<%=nextImg%>"></a></td>
                  <td width="15" style="padding-top:2">                
								<a href='javascript:goLastTop()' class="LINK">
								  <img alt="last records" title="last records" border="0" src="<%=lastImg%>"></a>
								  </td>
								  
								  
								  
								  
								  
								  <!-- This is the quick search part -->
								  
								  <td width="60" style="height:20;padding-left:5;visibility:hidden" >
								  <input type="checkbox" name="regExp" value="true" <%=queryInfo.isRegExp ? "checked" : ""%>>
								  <input type="checkbox" name="wholeWords" value="true" <%=queryInfo.isWholeWords ? "checked" : ""%>>
								  </td>
								  <td width="30" style="padding-left:5">
								  <input class="SMALLTEXT" type="text" name="searchText" id="searchText" value="<%=queryInfo.search == null ? "" : queryInfo.search%>" size="20" onKeyPress="return doCheckSearch(event)" style="height: 20px; padding-left: 3px;font-size:9" <%=useAutoSuggest?"onkeyup=\"searchSuggest(event)\" onkeydown=\"handleArrows(event)\" onblur=\"hideSuggest()\"":""%> autocomplete="off" >
								  </td>
								  <td width="30" title="find" style="padding-left:5;font-size:8pt;padding-bottom:0;"><a href="javascript:doSearch(false)" class="FILTER_LINK">Find</a>
								  </td>
								  <td width="30" title="quick filter" style="padding-left:5;font-size:8pt;padding-bottom:0;"><a href="javascript:doSearch(true)" class="FILTER_LINK">Filter</a>
								  </td>
								  <td id="showBtnDiv" width="40px" title="Reset filter / find" style="padding-left:5;font-size:8pt;padding-bottom:0;display:<%=displayResetBtn ? "" : "none" %>">
								  		  <a href="javascript:doReset()" class="FILTER_LINK">Reset</a>
								  </td>
								  <td id="hideBtnDiv" width="40px" style="padding-left:5;font-size:8pt;padding-bottom:0;display:<%=displayResetBtn ? "none" : "" %>">
											&nbsp;
								  </td>							  
								   <td width="30"  class="SMALLTEXT">&nbsp;
								  </td>
								  
								  <!-- This is the filter part -->
								  
								  <td width="30" style="padding-left:5;padding-right:5">
										<table border="0"  height="20" cellspacing="0" cellpadding="0" width="100%">
                        	<tr><td>						 
                          <select class="SMALLTEXT" name="filters"  id="filters" size="1" style="height: 20px; padding-left: 3px;" onchange="javascript:filterChanged()">
                          <option class="SMALLTEXT" value="none" selected>None</option>
                          <%
                          FilterCollection fc = null;
                          String fn = null;
                          String tempFn = null;
                          String fi = null;
                          String fis = "";
                          String fe = "";
                          for(int i=0;i<listfilters.size();++i){
                            fc = (FilterCollection)listfilters.get(i);
                            fn = fc.getName();
                            fi = fc.getId();
                            fe = fc.getAllFilterTerms();
                            if(fi.equals(activeFilter)){
                              fis = "selected";
                            }else{
                               fis = "";
                            }
                            fi += "*"+ (fe  != null && fe.length() > 0 ? "1" : "");
                            tempFn = fn;
                        	if(fn != null && fn.length()>25) {
                            	tempFn = fn.substring(0,25) + "...";
                            }
                          %>
                          <option class="SMALLTEXT" title="<%=fn%>" value="<%=fi%>" <%=fis%>><%=tempFn%></option>
                          <% } %>
                        </select>
                        </td>
                        </tr>
                        </table>
								  </td>
													 
								   <td width="20" title="activate selected filter" style="font-size:8pt;padding-bottom:0;"><a href="javascript:goFilter()" class="FILTER_LINK">Go</a>
								  </td>
								  <%if (editable || showTimeFilter || quickFilter.getQuickFilterCount() > 0){%>
								  <td width="20" title="filter menu" style="cursor:pointer;padding-left:5;padding-right:5" id="FilterBut" onClick="javascript:doCloseDashboardInfo();showMenuPopup(this,'filterMenu')"><img src="<%=BASE_DIRECTORY%>images/logview/filterMenu.gif"></td>
								  <%}else{%>
								  <td width="20">&nbsp;</td>
								  <%}%>
								  
								   <td background="<%=BASE_DIRECTORY%>images/logview/controlBg.gif" style="width:5" width="5"> </td>
								   <td style="width:5" width="5"> </td>
								   
									  <td class="LOG_VIEWER_DASHBOARD_BUTTON_CELL">
									  	<table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" >
									  		<tr><td></td></tr>
									  		<tr align="center">
									  			<td>&nbsp;</td>
									  			<td id="dashboardButtonDiv" class="LOG_VIEWER_DASHBOARD_BUTTON_DIV"></td>
									  			<td>&nbsp;</td>
									  		</tr>
									  		<tr><td></td></tr>
									  	</table>
									  </td>
                    </tr>                    
                   </table>
                   </td>
                   </tr>
                   </table>
    
</td></tr>
<tr height="6"><td bgcolor="#4a539a"  width="*" nowrap>
<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">                   
                      <tr>
                        
                                <td width="*" align="left" style="padding-left:20;font-size:6pt;border-top:1 solid #8c8c8c;border-bottom:1 solid #585151">&nbsp;<a id="backLink" href="javascript:goLastFilterView()" class="BACK_LINK" style="<%=showBack ? "" : "display:none"%>"><img alt="Zoom out" title="Zoom out" style="cursor:pointer" src="<%=BASE_DIRECTORY%>images/logview/zoomout.gif" border="0">&nbsp;&nbsp;Back</a></td>
                               <td width="77" valign="bottom" style="border-top:1 solid #8c8c8c;"><img alt="list view" title="list view" style="cursor:pointer" onMouseOver="" onMouseOut="" onClick="javascript:changeView(2)" id="viewTypeImg2" src="<%=BASE_DIRECTORY%>images/logview/viewType<%=logcontext.viewType == 2 ? "Sel" : "" %>2.gif"></td>
                               <td width="77" valign="bottom" style="border-top:1 solid #8c8c8c;"><img alt="tabular view" title="tabular view" style="cursor:pointer" onClick="javascript:changeView(1)" id="viewTypeImg1" src="<%=BASE_DIRECTORY%>images/logview/viewType<%=logcontext.viewType == 1 ? "Sel" : "" %>1.gif"></td>
								 							 <td width="30" style="font-size:6pt;border-top:1 solid #8c8c8c;border-bottom:1 solid #585151">&nbsp;</td>
                    </tr>
                   </table>
    
</td></tr>




<!--  This is data view -->

<tr><td>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
 <%if(!logcontext.regExpOk){%>
 <tr height="1"><td style="padding-left:30">
    	<span class="ERRORMESSAGE">*&nbsp;Could not parse regular expression. Please check your entry again</span>
 </td></tr>
 <tr height="1"><td>&nbsp;</td></tr>
 <%}%>
 <tr><td >
 <iframe name="logRecordsView"  onfocus="javascript:hideVisibleMenus()" onload="javascript:recordsViewLoaded();" src="<%=logRecordsJsp%>" width="100%" height="100%" FrameBorder="0" hspace="0" vspace="0" MarginHeight="0"></iframe> 
 </td></tr>
</table>
<iframe name="dataResultFrame"  onload="javascript:dataLoaded();" style="visibility:hidden" width="1" height="1"></iframe>
<iframe name="funcsFrame"  style="visibility:hidden" width="0%" height="0%"  ></iframe>
</td></tr>





<!--  This is the bottom bar -->
<tr height="5"><td class="BOTTOM_BAR" nowrap style="padding-top:3;padding-bottom:3" >
<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">                   
   <tr>                     
   <td border="0" width="20" align="left" style="padding-left:20" class="BOTTOM_BAR">
   &nbsp;
  </td>
  <td width="1" align="left" class="MENUSEPARATE">
  </td>
  <td border="0" width="200" align="left" style="padding-left:5;padding-right:5" class="BOTTOM_BAR">
   <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">                   
  <tr  height="5">
  
	<td width="20" class="progressBar" nowrap  style="padding-top:0">
	<script charset="iso-8859-1">
	
	recProgress.writeProgress();
	</script>
	
	</td>
	<td class="BOTTOM_BAR"  nowrap style="padding-left:5" bgcolor="#FFFFFF" id="recordsMsg">
		&nbsp;
	</td>
	<td class="BOTTOM_BAR"  align="right" style="padding-right:5" bgcolor="#FFFFFF" id="recordsTime">
		<nobr>&nbsp;</nobr>
	</td>
</tr>
</table>
  </td>
  <td width="1" align="left" class="MENUSEPARATE">
  </td>
  <td  title="stop" width="20" align="center" style="padding-left:3;padding-right:3;" class="BOTTOM_BAR_LINK" onClick="javascript:cancelQuery();">
   Stop
  </td>
  <td width="1" align="left" class="MENUSEPARATE">
  </td>
  <td border="0" width="12" align="center" style="padding-left:3;padding-right:3;padding-bottom:0" class="BOTTOM_BAR_LINK" onClick="javascript:goCurrentTop()">
   <img alt="refresh" src="<%=currImg%>"  border="0">
  </td>
  <td width="1" align="left" class="MENUSEPARATE">
  </td>
  <td id="tailLink" title="tail" width="20" align="center" style="padding-left:3;padding-right:3" class="<%=op != null && op.equals("TAIL") ? "BOTTOM_BAR_SELECTED_LINK" : "BOTTOM_BAR_LINK"%>" onClick="javascript:goTail()">
  Tail
  </td>
  <td width="1" align="left" class="MENUSEPARATE">
  </td>
  <%if (logcontext.showReload && !man.isTemporary()){%>
  <td title="reload" width="20" align="center" style="padding-left:3;padding-right:3" class="BOTTOM_BAR_LINK" onClick="javascript:updateIntervalData()">
		Reload
  </td>
  <td width="1" align="left" class="MENUSEPARATE">
  </td>
	<%}%>
  <td border="0" width="*" align="left" style="padding-left:5" class="BOTTOM_BAR">
   &nbsp;
  </td>
  <!-- 
  <td width="1" align="left" class="MENUSEPARATE">
  </td>
  <td border="0" width="200" align="left" class="BOTTOM_BAR" style="padding-left:3;padding-right:3;">
  <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">                   
  <tr >
  <td class="BOTTOM_BAR" nowrap width="20">Title</td>
	<td class="progressBar" nowrap style="padding-left:5;padding-top:0">
		<script>
	  
	   logProgress.writeProgress();
	</script>
	
	</td>
	 -->
	<td class="BOTTOM_BAR"  nowrap  id="num_installationProgress">
		&nbsp;
	</td>
</tr>
</table>
  </td>
  </tr>
  </table>
</form>
<script charset="iso-8859-1">
createFilterMenu();
setTimeout("goProgress()", 1000);
</script>

</body>
</html>