<%@ page language="java"%>
<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.data.index.IndexStatus"%>
<%@ page import="xpolog.eye.data.log.files.*"%>
<%@ page import="xpolog.eye.managment.XpologManagment"%>
<%@ page import="xpolog.eye.security.UserSecurity"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
String CURRENT_LOG = "CURRENT_LOG";
UserEnvironment env = UserEnvironment.getUserEnvironment(request);
UserContext userContext = UserEnvironment.getUserContext(request);
final LogBrowsingManager man = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
if (man == null){
	ErrorModel ermod = new ErrorModel();
	ermod.addError("You may not see the log. Please try again later.");
	request.getSession().setAttribute("ERROR_OBJ", ermod);
	response.sendRedirect("admin/errorpage.jsp");
	return;
}
final SshMediaMultiFilesDataSource ds = SshAdminHelper.getSshDataSource(man);

UserSecurity user = userContext != null ? userContext.getUser() : null;
String userName = "NA";
if (user != null){
	userName = user.getUser().getName();
}

env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, ds); 

String forward = request.getParameter("forward");
if (forward == null || forward.length() == 0){
	forward = "loggers/logview.jsp?firstTime=true&connected=true";
}
final LogViewContext logcontext = (LogViewContext)request.getSession().getAttribute(LogViewContext.LOG_CONTEXT);
ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + forward) {
  public void run(HttpServletRequest request){
    try {
    	ds.update();
   }catch (Exception e){
	   ErrorModel.log.error("Failed to update datasource", e);
   }
   int indexingPolicy = Configuration.getInstance().getPropertiesManager().getPropertyAsInt("logview.showRunIndex", LogViewContext.WHEN_NOT_INDEXED);
   boolean indexingEnabled = man.isUseIndexing() && SiteManagment.getInstance().getXpologManagment().isComponentLicenseValid(XpologManagment.SEARCH_ENGINE_COMPONENT) && indexingPolicy != LogViewContext.NEVER;
   if(indexingEnabled && (ds.getStatus() == null || !ds.getStatus().isFailed())) {
	   man.updateIndexStatus();
	   if (logcontext != null){
	  	 logcontext.indexStatus = man.getIndexStatus();
	   }
   }else {
  	 if(logcontext != null) {
	  	 logcontext.indexStatus = new IndexStatus(IndexStatus.NO_STATUS, -1);
  	 }
   }
  }
};
env.setProgressRunner(runner);
%>

<jsp:include page="../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Processing"/>
 <jsp:param name="useStatus" value="true"/>
</jsp:include>

  
