
function addNewLocation(){
		if(isLocationsEmpty()){
			alert("Please fill the empty location first!");
			return;
		}
		var url = BASE_DIRECTORY + "loggers/admin/common/locationPath.jsp?";
		var params = buildLocationsParamStr();
		params += "&ACTION_TYPE=add";
		contextreq = GetXmlHttpObject();
		contextreq.open('POST', url, true);
		contextreq.onreadystatechange = addNewLocationCallback;
		contextreq.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	  contextreq.setRequestHeader("Content-length", params.length);
	  contextreq.setRequestHeader("Connection", "close");
	  contextreq.send(params);  	
	
}


function addNewLocationCallback(){
		if (contextreq.readyState == 4) {
			if (contextreq.status == 200) {
				var result = contextreq.responseText;	
				result = result.replace(/^\s+|\s+$/g, '') ;
				if (!result){
					alert("Problem adding new location!.");
					return;
				}   
				var locationPathsDivElem = document.getElementById(PREFIX+"locationPathsDiv");
				if(locationPathsDivElem){
					locationPathsDivElem.innerHTML = result;
				}
				LOCATIONS_CNTR++;
		}
	}
}

function buildLocationsPathStr(){
		var pathArr = "";
		for(var loop = 0 ; loop < LOCATIONS_CNTR ; loop++){
			var pathElem = document.getElementById(PREFIX+"fullPath_" + loop);
			if(pathElem){
				var value = "";
				if(pathElem.value == ""){
				 value = "new";
				}else{
					value = pathElem.value;
				}
				pathArr += value + "@";
			}
 		} 		
 		return pathArr;
}


function buildLocationsStatusStr(){
		var statusArr = "";
		for(var loop = 0 ; loop < LOCATIONS_CNTR ; loop++){
			var statusElem = document.getElementById(PREFIX+"logStatus_" + loop);
			if(statusElem){
				//TODO:: SET THE RIGHT STATUS (NOT ALLWAYS ZERO)!!!
				statusArr += "0" + "@";
			}
 		} 		
 		return statusArr;
}


function buildLocationsParamStr(){
		var param = "tstmp=" + date.getTime();
		param += "&LOCATIONS_PATH_ARR=" + buildLocationsPathStr();
		param += "&LOCATIONS_STATUS_ARR=" + buildLocationsStatusStr();;
		param += "&LOCATIONS_CNTR=" + LOCATIONS_CNTR;
		param += "&baseDirectory=" + BASE_DIRECTORY;

		return param;
}

function isLocationsEmpty(){
		for(var loop = 0 ; loop < LOCATIONS_CNTR ; loop++){
			var pathElem = document.getElementById(PREFIX+"fullPath_" + loop);
			if(pathElem){
				if(pathElem.value == ""){
					return true;
				}
			}
 		}
 		return false;
}


function removeLocation(indx){
		var url = BASE_DIRECTORY + "loggers/admin/common/locationPath.jsp?";
		var params = buildLocationsParamStr();
		params += "&ACTION_TYPE=remove";
		params += "&REMOVE_INDX=" + indx;
		contextreq = GetXmlHttpObject();
		contextreq.open('POST', url, true);
		contextreq.onreadystatechange = removeLocationCallback;
		contextreq.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	  contextreq.setRequestHeader("Content-length", params.length);
	  contextreq.setRequestHeader("Connection", "close");
	  contextreq.send(params);  		
}


function removeLocationCallback(){
		if (contextreq.readyState == 4) {
			if (contextreq.status == 200) {
				var result = contextreq.responseText;	
				result = result.replace(/^\s+|\s+$/g, '') ;
				if (!result){
					alert("Problem removing location!.");
					return;
				}   
				var locationPathsDivElem = document.getElementById(PREFIX+"locationPathsDiv");
				if(locationPathsDivElem){
					locationPathsDivElem.innerHTML = result;
				}
				LOCATIONS_CNTR--;
		}
	}
}

//BROWSER FUNCTION
function openBrowser(txtboxId,i){
	var accId = "";
	//only if acc was selected
	var accountsElem = document.getElementById(PREFIX+"AccountsList");
	if(accountsElem){
		accId = accountsElem.value;
		if(accId == "none"){
			accId = "";
		}
	}
	var logTypeElem = document.getElementById(ACCOUNT_TYPE_SELECT_NAME);
	if(logTypeElem){
		var logType = logTypeElem.value;
		if(logType == "ssh" && accId == ""){
			var accountIdElem = document.getElementById(PREFIX+"AccountIdErrorMsg");
			if(accountIdElem && document.getElementById(PREFIX+"AccountsList"))	{
				document.getElementById(PREFIX+ACCOUNTS_LIST_NAME).className = "ERROR_MSG_BACKGROUNDCOLOR";										
				accountIdElem.style.display ="";
				accountIdElem.innerHTML = "Please set your log's account.";
			}else{
			  alert("Please select account first");			
			}
			return;
		}	
	}
 	showHideSysFileInMiddle(150,200);
	var rootDir = document.getElementById(PREFIX+"fullPath_"+i).value;
	loadSysFilesTree(rootDir,txtboxId,accId);
}




function doOpenBrowser(txtboxId,i,e){
	var result = checkKey(e);
   if (result){
       openBrowser(txtboxId,i);
    }
}



function checkKey(e){
 	if (!e) var e = window.event;
		var code = e.keyCode;
		if (code == 13 ){
			return true;
	}
}
	
//LOG DYNAMIC STATUS
	//     LOG    DATA   FILE NAME
	//0 : online,change,  change
	//1 : online,change,  fixed
	//2 : online,fixed,  change
	//3 : online,fixed,  fixed
	//4 : offline
	var dynamicType = 0 ;//online - fixed -fixed
	var dynamicTypeArr = "";
	var dynamicTmpTypeArr = new Array();
	var _id;
	base_dir = "<%=baseDir%>";

	function showLogSettings(e,id,dynamicType){
			_id = id;
			var value = getDynamicTypeById(id);
			if(value && value != -1){
			 	dynamicType = value;
			}
			iframElem = document.getElementById(PREFIX+"iframeId");
			var x = (this.event && document.all ? document.body.scrollLeft + e.x : e.pageX);
		  var y = (this.event && document.all ? document.body.scrollTop +  e.y : e.pageY);
			document.getElementById(PREFIX+"logSettingsDiv").style.left = x-220;
			document.getElementById(PREFIX+"logSettingsDiv").style.top = y-130;
			var vis = document.getElementById(PREFIX+"logSettingsDiv").style.display == "";
		if(vis){
			document.getElementById(PREFIX+"logSettingsDiv").style.display  = "none";		
	    iframElem.style.display = "none";
		}else{
			document.getElementById(PREFIX+"logSettingsDiv").style.display  = "";
		  iframElem.style.position = "absolute";
		  iframElem.style.left="" + (x-220);
		  iframElem.style.top="" + (y-130);
		  iframElem.style.display = "";
		}
		if(	dynamicType ){
			switch(dynamicType){
				case "0" :
					document.getElementById(PREFIX+"LogDataType").options[1].selected = true;
			  	document.getElementById(PREFIX+"LogFileType").options[1].selected = true;
					break;
	 		  case "1" : 
			  	document.getElementById(PREFIX+"LogDataType").options[1].selected = true;
			  	document.getElementById(PREFIX+"LogFileType").options[0].selected = true;
					break;
	  	  case "2" : 
			  	document.getElementById(PREFIX+"LogDataType").options[0].selected = true;
			  	document.getElementById(PREFIX+"LogFileType").options[1].selected = true;
					break;
			  case "3" : 
			  	document.getElementById(PREFIX+"LogDataType").options[0].selected = true;
			  	document.getElementById(PREFIX+"LogFileType").options[0].selected = true;
					break;	
				default :
					break;
					
			}
		}
		
	}
	function changeStatus(status,id){
	_id = id;
	 var imgId = document.getElementById(PREFIX+"imgid_"+id);
		if(imgId){
			if(status && status == "offline"){
				imgId.style.display  = "none";		
				setDynamicType(_id,"4");
			}else{
				imgId.style.display  = "";		
				setDynamicType(_id,"0");
		}
	} 	
	}

	function applyStatus(){	 
		var dataType = document.getElementById(PREFIX+"LogDataType").value;
		var fileType = document.getElementById(PREFIX+"LogFileType").value;
			 if(dataType == "fixed"){
			 		if(fileType == "fixed"){
			 			dynamicType = "3";
			 		}else{ // data - fixed file - change
			 				dynamicType = "2";
			 		}
			 }else{ // dataType == changeable	
					if(fileType == "fixed"){
			 			dynamicType = "1";
			 		}else{ // data - change, file - change
			 				dynamicType = "0";
			 		}
			}			
			document.getElementById(PREFIX+"iframeId").style.display  = "none";
			document.getElementById(PREFIX+"logSettingsDiv").style.display  = "none";		
			setDynamicType(_id,dynamicType);
	}
	
function setDynamicType(id,status){
	document.getElementById(PREFIX+"locationStatus_" + id).value = status;
}	

function cancelStatus(){
		document.getElementById(PREFIX+"iframeId").style.display  = "none";
		document.getElementById(PREFIX+"logSettingsDiv").style.display  = "none";					
}


	
	function getDynamicTypeById(id){
		var found = false;
			for(var i=0;!found && i < dynamicTmpTypeArr.length;i++){			
			var value = dynamicTmpTypeArr[i];
			if(!value){
				return -1;
			}
			var att = value.split(":");
			if(att){
				var _id = att[0]
				if(_id == id){
					return att[1];
				}
			}
		}
		if(!found){
				return -1;
		}
	}
///////////////////////////////////////////////////////////////////		
