<%@ page language="java"%>

<%@ page import="xpolog.tools.XpologSystemInfo"%>
<%@ page import="xpolog.eye.media.auth.AuthenticationAccount"%>
<%@ page import="xpolog.eye.media.db.DBAccount"%>
<%@ page import="xpolog.eye.media.ftp.FTPAccount"%>
<%@ page import="xpolog.eye.media.http.HttpAccount"%>
<%@ page import="xpolog.eye.media.telsh.TelnetAccount"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
	
  String baseDirectory = request.getParameter("baseDirectory");
  //System.out.println("baseDirectory = " + baseDirectory);
  if (baseDirectory == null){
  	baseDirectory = BASE_DIRECTORY;
  }
  String baseDirectory2 = request.getParameter("baseDirectory2");
  if (baseDirectory2 == null){
  	baseDirectory2 = baseDirectory;
  }
  
  String PREFIX = request.getParameter("PREFIX");
  if (PREFIX == null || PREFIX.length() == 0){
  	PREFIX = "";
  }
  
  String showMonitorsModuleStr = request.getParameter("showMonitorsModule");
  boolean showMonitorsModule = showMonitorsModuleStr != null && showMonitorsModuleStr.equals("true");
  
  String showReportsModuleStr = request.getParameter("showReportsModule");
  boolean showReportsModule = showReportsModuleStr != null && showReportsModuleStr.equals("true");

  String showCollectionsModuleStr = request.getParameter("showCollectionsModule");
  boolean showCollectionsModule = showCollectionsModuleStr != null && showCollectionsModuleStr.equals("true");
  
  String treeName = request.getParameter("treeName");
  if (treeName == null || treeName.length() == 0){
  	treeName = "tree";
  }

  String divName = request.getParameter("divName");
  if (divName == null || divName.length() == 0){
  	divName = "newLogDiv";
  }
  String frmName = request.getParameter("frmName");
  if (frmName == null || frmName.length() == 0){
  	frmName = "newLogFrm";
  }
  
  String showNewFilterStr = request.getParameter("showNewFilter");
  boolean showNewFilter = showNewFilterStr != null && showNewFilterStr.equals("true");
  
  boolean loadUiUtil = false;

	
  //page data
  String accountId = "";
  String locationsStatusesStr = "";
  int locationsCntr = 1;
  boolean isXml = false;

  
  UserContext userContext = UserEnvironment.getUserContext(request);

%>

<link rel="stylesheet" type="text/css" href="<%=baseDirectory2%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=baseDirectory2%>css/logAdministration.css" />
<%if (loadUiUtil){ %>
<script LANGUAGE="JavaScript1.2" src="<%=baseDirectory2%>scripts/UIUtil.js"></script>
<%}%>
<script LANGUAGE="JavaScript1.2" src="<%=baseDirectory2%>loggers/quicklog/common.js"></script>
<script LANGUAGE="JavaScript1.2" src="<%=baseDirectory2%>loggers/quicklog/locations.js"></script>

<link rel="stylesheet" type="text/css" href="<%=baseDirectory2%>css/components.css" />

<%
String sysFileBrowserUrl = "../../common/sysFilesBrowser.jsp";
%>
<jsp:include page="<%=sysFileBrowserUrl%>" flush="true">
	<jsp:param name="base_directory" value="<%=baseDirectory%>"/> 
</jsp:include>

<jsp:include page="logDynamicSettings.jsp" flush="true">
	<jsp:param name="base_directory" value="<%=baseDirectory%>"/> 
</jsp:include>

<jsp:include page="../../common/accountsListCombo.jsp" flush="true">
	<jsp:param name="base_directory" value="<%=baseDirectory%>"/> 
	<jsp:param name="scriptsOnly" value="true"/>
</jsp:include>
	

<script>

function closeNewLogDiv(){
	closeNewLogDiv();
}

var PREFIX = "<%=PREFIX%>";
var QUICK_LOG_PREFIX = "<%=PREFIX%>";
var divName = "<%=divName%>";
var frmName = "<%=frmName%>";
var BASE_DIRECTORY = "<%=baseDirectory%>";
var IS_WINDOW = <%=XpologSystemInfo.isWindows()%>;

var ACC_TYPE_DB = "<%=DBAccount.TYPE_DB%>";
var ACC_TYPE_FTP = "<%=FTPAccount.TYPE_FTP%>";
var ACC_TYPE_REMOTE = "remote";
var ACC_TYPE_HTTP = "<%=HttpAccount.TYPE_HTTP%>";
var ACC_TYPE_SSH = "<%=TelnetAccount.TYPE_SSH%>";
var ACC_TYPE_NONE = "none";
var ACC_TYPE_AUTH = "<%=AuthenticationAccount.TYPE_AUTH%>";
var ACC_ID = "<%=accountId%>"

var LOCATIONS_CNTR = "<%=locationsCntr%>";
var LOCATION_STATUS_ARR = "<%=locationsStatusesStr%>";

var IS_XML ="<%=isXml%>";
var closeDivFunction = closeNewLogDiv;

var SHOW_MONITORS_MODULE = <%=showMonitorsModule%>;
var SHOW_REPORTS_MODULE = <%=showReportsModule%>;
var SHOW_COLLECTIONS_MODULE = <%=showCollectionsModule%>;
var SHOW_NEW_FILTER = <%=showNewFilter%>;

// instantiate hasAddressBookPermissions - it is declared in accounts.js
hasAddressBookPermissions = <%=userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)%>
	
//var tree;
//var mergeTree;
//var remoteLogTree;

</script>