<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.logic.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.ui.admin.alerts.*"%>
<%@ page import="xpolog.logic.brain.*"%>
<%@ page import="xpolog.logic.exe.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.util.LogicUserContext"%>
<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.scheduler.ui.*"%>

<%
  final String BASE_DIRECTORY = "../../../";
%>


<%
WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request,response,LogicPermissionConstants.MonitorPermissions.TRANSACTION_ALERTS_PERMISSION,true)){
     return;
}
	String TRAN_ID = "tranId";
	String ERROR_OBJ = "ERROR_OBJ";
	
	SiteManagment mgmt = SiteManagment.getInstance();	
  	if (!manager.checkForPermission(request,response,null,true)){
     	return;
  	}
  	UserContext userContext = UserEnvironment.getUserContext(request);
	String tranId = request.getParameter(TRAN_ID);
	String sessionId = DataSession.ONLINE_DATA_SESSION_ID;
	String workspaceId = DataSession.ONLINE_DATA_SESSION_ID;

	HashSet selectedTransMap = new HashSet();

	CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
	DataSession dataSession = ctrlMgr.getDataSessionById(sessionId);
	
	//get only montored transaction
	String[] txIds = ctrlMgr.getTransactionParadigmForSessionPradigm(DataSession.ONLINE_DATA_SESSION_ID);
	if(txIds == null || txIds.length == 0){
		ErrorModel errmodel = new ErrorModel();
		errmodel.addError("There are no Online Trasnactionss defined in system");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/logicPortal.jsp&okURL=logic/logicPortal.jsp");
		return;
	}
	
	List txList = new LinkedList();
	for (int i = 0; i<txIds.length; i++){
		TransactionParadigm t = BrainConfigurationRepository.getRepository().getTransactionParadigmById(txIds[i]);
		if (t != null && (userContext == null || LogicUserContext.isTransactionVisible(userContext,t))){
			txList.add(t);
		}
	}
	TransactionParadigm[] transactions = (TransactionParadigm[])txList.toArray(new TransactionParadigm[txList.size()]);
	
	String selectedTranId = null;
  
	if (tranId != null && tranId.length() > 0){
		selectedTranId = tranId;
	}
	
	if (selectedTranId == null && transactions.length > 0) {
		selectedTranId = transactions[0].getId();
	}else if(selectedTranId == null){
		selectedTranId = "";
	}
	
	
	TransactionParadigm transact = BrainConfigurationRepository.getRepository().getTransactionParadigmById(selectedTranId);
	if(transact == null && transactions.length > 0){
		transact = transactions[0];
	}
	int alertsTimeFrame = 0,alertsTimeUnit=0,alertsMaxLimit=0,alertsCntr=0;
	String alertsTimeUnitStr = "";
	if(transact != null){
		TaskAlertsActionBuilder builder = new TaskAlertsActionBuilder();
		builder.initFromTxParadigm(transact);
		alertsTimeFrame = builder.getAlertsTimeFrame();
		alertsTimeUnit = builder.getAlertstimeUnit();
		alertsTimeUnitStr = String.valueOf(alertsTimeUnit);
		alertsMaxLimit = builder.getAlertsMaxLimit();
		alertsCntr = builder.getAlertsCntr();
		request.getSession().setAttribute("CUREENT_TX_BUILDER",builder);
	}

	
%>

<script>

function updateTran(){
   document.access.filtersCombo.options.length = 0;
	 if(document.access.logsCombo.selectedIndex == -1){
      return;
  }
	
	var id = document.access.logsCombo.options[document.access.logsCombo.selectedIndex].value;
	for(var i=0;i<logs.length;i++){
	  if (logs[i].id == id){
			for (var j = 0; j < logs[i].filters.length;j++){
			  var option0 = new Option(logs[i].filters[j].name,logs[i].filters[j].id);
				document.access.filtersCombo.options[document.access.filtersCombo.options.length] = option0;				
			}
			break;
		}
  }
}

function refreshTran(){
	document.access.action = "alertToTran.jsp";
	document.access.submit();
}
	
function doSave(){
      doTasks();
      var msg = doAdvancedOptions();
			if(msg != ""){
	      alert(msg);
	      return;
	    }  
      document.access.action = "alertToTranAction.jsp";
		  document.access.submit();
}
function doFinish(){
      doTasks();
      var msg = doAdvancedOptions();
      if(msg != ""){
	      alert(msg);
	      return;
	    }
      document.access.finish.value = "true";
      document.access.action = "alertToTranAction.jsp";
	  document.access.submit();
}

function showHideAdvancedDiv(){
	var d = document.getElementById("advancedDiv");
	var td = document.getElementById("advancedLinkTd");
	if (d){
		if (d.style.display == "none"){
			d.style.display = "";
			if (td){
				td.innerHTML = "<a href=\"javascript:showHideAdvancedDiv()\" class=\"SMALLLINK\">hide advanced options</a>";
			}
		}else{
			d.style.display = "none";
			if (td){
				td.innerHTML = "<a href=\"javascript:showHideAdvancedDiv()\" class=\"SMALLLINK\">show advanced options</a>";
			}
		}
	}
}

function doAdvancedOptions(){
	var errorMsg = "";
	var cntrChckBox = document.getElementById("ExecutionCntrFilter").checked;
	if(cntrChckBox){
		var cntrText = document.getElementById("ExecutionTextCntrFilter").value;
		if(!cntrText || cntrText == ""){
			errorMsg = "No number of executaion were enterd\n";
		}else{
			document.access.cntrAlerts.value = cntrText;
		}
	}else{
		document.access.cntrAlerts.value = "";
	}
	var maxChckBox = document.getElementById("MaxExecutionFilter").checked;
	if(maxChckBox){
		var maxText = document.getElementById("MaxExecutionTextTimeFilter").value;
		if(!maxText || maxText == ""){
			errorMsg = "No number of executaion were enterd\n";
		}else{
			document.access.maxAlerts.value = maxText;
		}		
	}else{
		document.access.maxAlerts.value = "";
	}
	if(document.access.maxAlerts.value.length == 0 && document.access.cntrAlerts.value.length == 0){
		document.access.alertsTimeFrameFilter.value	 = "";
	}
	var timeUnit = document.access.TimeUnitFilter.options[document.access.TimeUnitFilter.selectedIndex].value;	
 	if(timeUnit){
		document.access.timeUnit.value	= timeUnit;
	}	
		return errorMsg;
}
 
function doCheckBox(id){
	var elem = document.getElementById(id);
	if(elem){
		elem.checked = true;	
	}
}   
</script>

<html >
	<head>
		<meta http-equiv="Content-Language" content="en-us">
		<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
		<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
		<META HTTP-EQUIV="EXPIRES" CONTENT="0">
		<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css">
		<title></title>
	</head>

	<body>
		<form AUTOCOMPLETE="OFF" id="access" name="access" >
		    <input type="hidden" name="finish" id="finish" />
		    <input type="hidden" name="timeFram" id="timeFram" />
		    <input type="hidden" name="cntrAlerts" id="cntrAlerts" />
		    <input type="hidden" name="maxAlerts" id="maxAlerts" />
		    <input type="hidden" name="timeUnit" id="timeUnit" />
			<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse"
			bordercolor="#111111">
				<tr>
					<td width="100%" height="100%" valign="top">
						<table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
							<tr>
								<td valign="top" height="90%">
									<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id=
									"AutoNumber1">
										<tr>
											<td width="100%">
												<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width=
												"100%" id="AutoNumber2" height="100%">
													<tr>
														<td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
														<td width="53%" class="TOPBORDER" height="0">
															<span class="PAGEHEADER">Transaction Alerts Settings</span> 
														</td>
														<td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
													</tr>
													<tr><td colspan="3">&nbsp;</td></tr>
												</table>

												<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width=
												"100%" height="100%">
													<tr>
														<td width="3%" height="100%">&nbsp;&nbsp;&nbsp;</td>
														<td width="93%" colspan="2" height="100%">
															<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse"
															width="100%" >
																
									              <%if (XpologLicenseManager.getInstance().isDemo()) {%>
									              <tr><td>&nbsp;</td></tr>
									              <tr>
									              	<td><span class="LICENSEMESSAGE">
									              		Monitoring is not avaiable in trial version.
									              	</span></td>
									              </tr>
									              <tr><td>&nbsp;</td></tr>
									              <%}%>

																<tr><td width="15%" ></td></tr>
																<tr>
																	<td width="15%" >
																		<span class="HEADER">Transaction</span><b>&nbsp;</b> 
																	</td>
																</tr>
																<tr>
																	<td>	
																	</td>
																</tr>
																<tr>
																	<td>
																		<span class="REGULARTEXT">Select a Transaction to edit alerts:</span> 
																	</td>
																</tr>
																<tr><td height="100%"></td></tr>
																<tr>
																	<td width="100%" >
																		<table border="0" width="100%">
																			<tr>
																				<td width="50">
																					<span class="REGULARTEXT">Transaction:</span> 
																				</td>
																				<td width="*">
																					<select size="1" name="tranId" id="tranId" onchange="javascript:refreshTran()">
																					<% for (int i = 0; i < transactions.length;i++){
																						String selected = transactions[i].getId().equals(selectedTranId) ? " selected" : "";
																					%>
																						<option value="<%=transactions[i].getId()%>"<%=selected%>><%=transactions[i].getName()%></option>
																					<%}%>
																					</select> 
																				</td>
																			</tr>
																		</table>
																	</td>
																</tr>
															<tr>
																	<td>																		                                    																		
																	</td>
																</tr>
																<tr><td height="100%">&nbsp;</td></tr>																
																<tr><td width="100%" >&nbsp;</td></tr>										
																<tr><td width="100%" ><%@ include file="tasksList.jsp"%></td></tr>
																<tr><td width="100%" >&nbsp;</td></tr>
															</table>
														</td>
													</tr>
												  <tr>
													  <td width="3%" height="100%">&nbsp;</td>
												  	<td id="advancedLinkTd">
													  	<a href="javascript:showHideAdvancedDiv()" class="SMALLLINK">show advanced options</a>
												  	</td>
												  </tr>													
												  <tr>
															<td width="3%" height="100%">&nbsp;</td>
												  		<td>
												  				<div id="advancedDiv" style="display:none">
												  					<table border="0" width="100%" cellspacing="2" cellpadding="2" style="border-style:solid; border-width:2px;">
																				<tr>
																					<td width="3%" height="100%">&nbsp;</td>
																					<td>&nbsp;</td>
																				</tr>
																				<tr>
																					<td colspan="2"><span class="HEADER">Alerts Time Frame</span></td>
																				</tr>
																				<tr>
																					<td width="3%" height="100%">&nbsp;</td>
																					<td>
																  					<table border="0" width="100%" cellspacing="0" cellpadding="0" >
																  					<tr>
																							<td>	
																								<span class="REGULARTEXT">Frame intervals : &nbsp;&nbsp;&nbsp;&nbsp;</span>
																								<input class="TEXTBOX" type="text" name="alertsTimeFrameFilter" id="alertsTimeFrameFilter" size="3" value="<%=alertsTimeFrame < 1 ? "" : String.valueOf(alertsTimeFrame) %>" style="font-size: 8pt">
																								<select class="TEXTBOX" size="1" name="TimeUnitFilter" id="TimeUnitFilter" style="font-size: 8pt">
																										<option value="minutesExecutionFilter" <%=alertsTimeUnitStr.equals("0") ? "selected" : ""%>>minutes</option>
																										<option value="hoursExecutionFilter" <%=alertsTimeUnitStr.equals("1") ? "selected" : ""%>>hours</option>
																										<option value="daysExecutionFilter" <%=alertsTimeUnitStr.equals("2") ? "selected" : ""%>>days</option>
																								</select>
																							</td>
																						</tr>
																						</table>
																					</td>
																				</tr>
																				<tr>
																					<td width="3%" height="100%">&nbsp;</td>
																					<td>
																  					<table border="0" width="100%" cellspacing="0" cellpadding="0" >
																  					<tr height="16" style="font-size:8">																  						
																							<td width="3%" height="100%">&nbsp;</td>
																							<td width="3%"><input type="CHECKBOX" name="ExecutionCntrFilter" id="ExecutionCntrFilter" <%=alertsCntr < 1 ? "" : "checked" %>></td>
																							<td width="14%">	
																								<span class="REGULARTEXT">Execute only after </span>
																							</td>
																							<td width="11%"><input class="TEXTBOX" type="text" name="ExecutionTextCntrFilter" id="ExecutionTextCntrFilter" size="3" value="<%=alertsCntr < 1 ? "" : String.valueOf(alertsCntr) %>" style="font-size: 8pt" onKeyPress="javascript:doCheckBox('ExecutionCntrFilter')">
																								<span class="REGULARTEXT">&nbsp;&nbsp;alerts.</span>																							
																							</td>	
																							<td width="*">&nbsp;</td>	
																						</tr>
																						<tr>
																							<td colspan="5" style="font-size:1" height="3">&nbsp;</td>
																						</tr>
																  					<tr>																  		
																  					  <td width="3%" height="100%">&nbsp;</td>																  									
																							<td width="3%"><input type="CHECKBOX" name="MaxExecutionFilter" id="MaxExecutionFilter" <%=alertsMaxLimit < 1 ? "" : "checked" %>></td>
																							<td width="14%">	
																								<span class="REGULARTEXT">Max Alerts to send</span>																								
																							</td>
																							<td width="11%"><input class="TEXTBOX" type="text" name="MaxExecutionTextTimeFilter" id="MaxExecutionTextTimeFilter" size="3" value="<%=alertsMaxLimit < 1 ? "" : String.valueOf(alertsMaxLimit) %>" style="font-size: 8pt" onKeyPress="javascript:doCheckBox('MaxExecutionFilter')"></td>	
																							<td width="*">&nbsp;</td>	

																						</tr>
																						</table>
																					</td>
																				</tr>
																			</table>																		
												  				</div>
												  		</td>
												  </tr>				
												  
													<tr>
														<td>
															<font size="2">&nbsp;</font> 
														</td>
													</tr>
												</table>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td valign="bottom" height="10%">
						<table border="0" width="100%">
							<tr>
								<td width="30%">&nbsp;</td>
								<td width="31%" align="center">
									<table border="0" width="225">
										<tr>
				              <%if (!XpologLicenseManager.getInstance().isDemo()) {%>
											<td width="30%">
												<a href="javascript:doSave()" class="LINK">save</a> 
											</td>
											<td width="40%">
												<a href="javascript:doFinish()" class="LINK">save & finish</a> 
											</td>
											<%}else{ %>
											<td width="70%">&nbsp;</td>
											<%}%>
											<td width="30%" align="right">
												<a href="<%=BASE_DIRECTORY%>logic/logicPortal.jsp" class="LINK">cancel</a> 
											</td>
										</tr>
									</table>
								</td>
								<td width="39%">&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td valign="bottom" height="10%">
						<table border="0" cellpadding="0" cellspacing="0" width="100%">
							<tr>
								<td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td><td class="BOTTOMBORDER" width="100%">
								&nbsp;</td><td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</form>
	</body>
</html>
