<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.merge.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.util.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.logic.admin.*"%>
<%@ page import="xpolog.logic.exe.*"%>
<%@ page import="xpolog.logic.ui.admin.alerts.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%!static final String BASE_DIRECTORY = "../../../";%>
<%
  String ERROR_OBJ = "ERROR_OBJ";
  String FIN = "finish";
  String TRAN_ID = "tranId";
  String TASKS_TIME = "To_Time_Task";
  String TASKS_FLOW = "To_Flow_Task";
  String TASKS_DATA = "To_Data_Task";

  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);

  String finish = request.getParameter(FIN); 
  String tranId    = request.getParameter(TRAN_ID);

	TaskAlertsActionBuilder bd = (TaskAlertsActionBuilder)request.getSession().getAttribute("CUREENT_TX_BUILDER");
	request.getSession().removeAttribute("CUREENT_TX_BUILDER");
	
	String[] timeTaskIdArr = new String[0];
	String[] dataTaskIdArr = new String[0];
	String[] flowTaskIdArr = new String[0];
	List timeTaskIdsToAdd = new LinkedList();
	List dataTaskIdsToAdd = new LinkedList();
	List flowTaskIdsToAdd = new LinkedList();

	if(bd != null){
		timeTaskIdArr = bd.getTimeTask()== null ? timeTaskIdArr : bd.getTimeTask();
		dataTaskIdArr = bd.getDataTask() == null ? dataTaskIdArr : bd.getDataTask();
		flowTaskIdArr = bd.getFlowTask() == null ? flowTaskIdArr : bd.getFlowTask();

		//add time task ids unvisible in context
		for (int i=0; i<timeTaskIdArr.length; i++){
			if (!userContext.isTaskVisible(timeTaskIdArr[i])){
				timeTaskIdsToAdd.add(timeTaskIdArr[i]);
			}
		}
		//add data task ids unvisible in context
		for (int i=0; i<dataTaskIdArr.length; i++){
			if (!userContext.isTaskVisible(dataTaskIdArr[i])){
				dataTaskIdsToAdd.add(dataTaskIdArr[i]);
			}
		}
		//add flow task ids unvisible in context
		for (int i=0; i<flowTaskIdArr.length; i++){
			if (!userContext.isTaskVisible(flowTaskIdArr[i])){
				flowTaskIdsToAdd.add(flowTaskIdArr[i]);
			}
		}
		
	}
	
	

  String [] taskTimeIds = request.getParameterValues(TASKS_TIME);
  String [] taskFlowIds = request.getParameterValues(TASKS_FLOW);
  String [] taskDataIds = request.getParameterValues(TASKS_DATA);

  String  timeFrameFilter = request.getParameter("alertsTimeFrameFilter");
  String timeUnit = request.getParameter("timeUnit");
  String  cntrAlerts = request.getParameter("cntrAlerts");
  String  maxAlerts = request.getParameter("maxAlerts");

  String[] tmp = null;
  //update time task id arr
  if (timeTaskIdsToAdd.size() > 0){
  	if (taskTimeIds == null || taskTimeIds.length == 0){
  		taskTimeIds = (String[])timeTaskIdsToAdd.toArray(new String[timeTaskIdsToAdd.size()]);
  	}else{
	  	int len  = taskTimeIds.length;
		  tmp = new String[taskTimeIds.length + timeTaskIdsToAdd.size()];
		  System.arraycopy(taskTimeIds,0,tmp,0,taskTimeIds.length);
		  for (int i=0; i<timeTaskIdsToAdd.size(); i++){
		  	String id = (String)timeTaskIdsToAdd.get(i);
		  	tmp[len+i] = id;
		  }
		  taskTimeIds = tmp;
  	}
  }
  
  //update data task id arr
  if (dataTaskIdsToAdd.size() > 0){
  	if (taskDataIds == null || taskDataIds.length == 0){
  		taskDataIds = (String[])dataTaskIdsToAdd.toArray(new String[dataTaskIdsToAdd.size()]);
  	}else{
	  	int len  = taskDataIds.length;
		  tmp = new String[taskDataIds.length + dataTaskIdsToAdd.size()];
		  System.arraycopy(taskDataIds,0,tmp,0,taskDataIds.length);
		  for (int i=0; i<dataTaskIdsToAdd.size(); i++){
		  	String id = (String)dataTaskIdsToAdd.get(i);
		  	tmp[len+i] = id;
		  }
		  taskDataIds = tmp;
  	}
  }
  
  //update flow task id arr
  if (flowTaskIdsToAdd.size() > 0){
  	if (taskFlowIds == null || taskFlowIds.length == 0){
  		taskFlowIds = (String[])flowTaskIdsToAdd.toArray(new String[flowTaskIdsToAdd.size()]);
  	}else{
	  	int len  = taskFlowIds.length;
		  tmp = new String[taskFlowIds.length + flowTaskIdsToAdd.size()];
		  System.arraycopy(taskFlowIds,0,tmp,0,taskFlowIds.length);
		  for (int i=0; i<flowTaskIdsToAdd.size(); i++){
		  	String id = (String)flowTaskIdsToAdd.get(i);
		  	tmp[len+i] = id;
		  }
		  taskFlowIds = tmp;
  	}
  }
  

  //verify data
  ErrorModel errmodel = new ErrorModel();
  if(tranId == null || tranId.length() == 0 ){
	  errmodel.addError("Please select transaction");
  }
  if((timeFrameFilter == null || timeFrameFilter.length() == 0) && 
  	((cntrAlerts != null && cntrAlerts.length() > 0)||(maxAlerts != null && maxAlerts.length() > 0))){
  	errmodel.addError("Please select time frame for the alert's monitoring. ");
  }
  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=search/searchMergeAdmin.jsp");
    return;
  }
  TaskAlertsActionBuilder wiz = new TaskAlertsActionBuilder();
  wiz.setDataTask(taskDataIds);
  wiz.setFlowTask(taskFlowIds);
  wiz.setTimeTask(taskTimeIds);
  wiz.setTranId(tranId);
 
  //settings advanced option
  if(timeFrameFilter != null && timeFrameFilter.length() > 0){
  	wiz.setAlertsTimeFrame(Integer.parseInt(timeFrameFilter));
		String timeUnitStr = "0";
		if(timeUnit.equals("hoursExecutionFilter")){
			timeUnitStr = "1";
		}else if(timeUnit.equals("daysExecutionFilter")){
			timeUnitStr = "2";
		}
  	wiz.setAlertstimeUnit(Integer.parseInt(timeUnitStr));
  	if(cntrAlerts != null && cntrAlerts.length() > 0){
  		wiz.setAlertsCntr(Integer.parseInt(cntrAlerts));
  	}
  	if(maxAlerts != null && maxAlerts.length() > 0){
  		wiz.setAlertsMaxLimit(Integer.parseInt(maxAlerts));
  	}
  }

  wiz.updateTransactionWithAlerts();
  //restart engine with new alerts.
  OnlineEngineControl.getInstance().getDefaultEngine().configurationChanged();
	//    audit
    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
       			userContext, AuditConstants.CHANGE, "add/edit alerts to transactions", AuditConstants.TRANSACTION, "add/edit alerts to trasnactions");

 //put data into wizard and run save
 //wizard should build relevant actions, and add it to the transaction.
 //make sure we run configuration update to online engine.
 //make sure we do that for the txmonitor admin screen as well. maybe through db counter.
   if(finish != null && finish.length()>0) {
	   response.sendRedirect(BASE_DIRECTORY + "logic/logicPortal.jsp");
   }else {
	   response.sendRedirect("alertToTran.jsp?tranId="+tranId);
   }
%>


