
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.logic.ui.admin.alerts.*"%>
<%!
  static final String BASE_DIRECTORY = "../../../";
%>

<%
	XpoTaskManager mgr = XpoTaskManager.getInstance();
  UserContext userContext1 = UserEnvironment.getUserContext(request);
	List list = mgr.getXpoTasksByFilter(null,userContext1);
	
	TaskAlertsActionBuilder bd = (TaskAlertsActionBuilder)request.getSession().getAttribute("CUREENT_TX_BUILDER");
	//request.getSession().removeAttribute("CUREENT_TX_BUILDER");
	
	String[] timeTaskIdArr = new String[0];
	String[] dataTaskIdArr = new String[0];
	String[] flowTaskIdArr = new String[0];
	if(bd != null){
		timeTaskIdArr = bd.getTimeTask()== null ? timeTaskIdArr : bd.getTimeTask();
		dataTaskIdArr = bd.getDataTask() == null ? dataTaskIdArr : bd.getDataTask();
		flowTaskIdArr = bd.getFlowTask() == null ? flowTaskIdArr : bd.getFlowTask();
	}
	
	List timeTasks = new ArrayList();
	List dataTasks = new ArrayList();
	List flowTasks = new ArrayList();
	
	for(int i=0;i<timeTaskIdArr.length;i++){
		if (userContext1 == null || userContext1.isTaskVisible(timeTaskIdArr[i])){
			timeTasks.add(timeTaskIdArr[i]);
		}
	}
	
	for(int i=0;i<dataTaskIdArr.length;i++){
		if (userContext1 == null || userContext1.isTaskVisible(dataTaskIdArr[i])){
			dataTasks.add(dataTaskIdArr[i]);
		}
	}
	for(int i=0;i<flowTaskIdArr.length;i++){
		if (userContext1 == null || userContext1.isTaskVisible(flowTaskIdArr[i])){
			flowTasks.add(flowTaskIdArr[i]);
		}
	}
	
	
	
	
%>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>
<script>
	function doTasks(){
	  //TIME tasks
      addAllFiledToSelection(document.access.To_Time,document.access.To_Time_Task);
      for(var i=0;i<document.access.To_Time_Task.options.length;++i){
        document.access.To_Time_Task.options[i].selected='true';
      }
      //DATA tasks
      addAllFiledToSelection(document.access.To_Data,document.access.To_Data_Task);
      for(var i=0;i<document.access.To_Data_Task.options.length;++i){
        document.access.To_Data_Task.options[i].selected='true';
      }
      
      //FLOW tasks
      addAllFiledToSelection(document.access.To_Flow,document.access.To_Flow_Task);
      for(var i=0;i<document.access.To_Flow_Task.options.length;++i){
        document.access.To_Flow_Task.options[i].selected='true';
      }
		
	}
</script>
<table border="0" width="100%">
	<tr><td width="100%" ><span class="HEADER">Time Alerts</span></td></tr>
  <tr>
    <td width="100%">
        <span class="SMALLTEXT">execute following actions upon time dimension <b>failure</b>:</span>
    
    </td>
  </tr>
  <tr>
    <td width="100%">
    	<table border="0" width="600" cellspacing="0" cellpadding="0">
  <tr>
	<td>
		<table border="0" width="86" cellspacing="0" cellpadding="0">
			<tr>
			  <td width="40%"><span class="SMALLTEXT">Actions</span></td>
			</tr>
			<tr>
			  <td width="40%">
				  <select class="TEXTBOX" size="6" name="From_Time" style="font-size: 8pt; font-family: Verdana" >
                                  <%
                                    for(int i=0;i<list.size();++i){
                                  %>
					<option value='<%=((XpoTask)list.get(i)).getId()%>'><%=((XpoTask)list.get(i)).getName()%></option>
                                  <%
                                   }
                                  %>
				  </select>
				</td>
			  </tr>
			  <tr>
				  <td width="40%"></td>
			  </tr>
		</table>
	  </td>
	  <td width="100" nowrap>
		  <table border="0" width="100%" cellspacing="0" cellpadding="0">
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:addFiledToSelection(document.access.From_Time,document.access.To_Time)" class="SMALLLINK">add</a></td>
			</tr>
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:addAllFiledToSelection(document.access.From_Time,document.access.To_Time)" class="SMALLLINK">add all</a></td>
			</tr>
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:removeFiledFromSelection(document.access.To_Time)" class="SMALLLINK">remove</a></td>
			</tr>
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:removeAllFiledFromSelection(document.access.To_Time)" class="SMALLLINK">remove all</a></td>
			</tr>
		  </table>
	  </td>
	  <td width="286">
		  <table border="0" width="100%" cellspacing="0" cellpadding="0">
			<tr>
			  <td width="100%"><span class="SMALLTEXT">Execute actions</span></td>
			</tr>
			<tr>
			  <td width="100%">
                                <select class="TEXTBOX" multiple type="hidden"  style="visibility:hidden; display:none" name="To_Time_Task" id="To_Time_Task">
                                </select>
				<select class="TEXTBOX" size="6" name="To_Time" style="font-size: 8pt; font-family: Verdana">
                                <%
								   XpoTask st = null;
                                   for(int y=0;y<timeTasks.size();++y){
                                   st = mgr.getXpoTaskById((String)timeTasks.get(y));
                                   if(st == null){
                                    continue;
                                   }
                                %>
				    <option value='<%=st.getId()%>'><%=st.getName()%></option>
                                <%
                                   }
                                %>
				</select></td>
			</tr>
			<tr>
			  <td width="40%"></td>
			</tr>
		  </table>
	  </td>
	  <td width="100" nowrap>
		<table border="0" width="100%" cellspacing="0" cellpadding="0">
		  <tr>
			<td width="100%" align="center"></td>
		  </tr>
		  <tr>
			<td width="100%" align="center"><font size="1"><!--<a href="javascript:alert('holla')">move up</a>--></font></td>
		  </tr>
		  <tr>
			<td width="100%" align="center"><font size="1"><!--<a href="javascript:alert('holla')">move down</a>--></font></td>
		  </tr>
		  <tr>
			<td width="100%" align="center"></td>
		  </tr>
		</table>
	  </td>
  </tr>
</table>
    
    </td>
  </tr>
  <tr><td width="100%" >&nbsp;</td></tr>
  <tr><td width="100%" ><span class="HEADER">Data Alerts</span></td></tr>
  <tr>
    <td width="100%">
        <span class="SMALLTEXT">execute following actions upon data dimension <b>failure</b>:</span>
    </td>
  </tr>
  <tr>
    <td width="100%">
    	<table border="0" width="600" cellspacing="0" cellpadding="0">
  <tr>
	<td>
		<table border="0" width="86" cellspacing="0" cellpadding="0">
			<tr>
			  <td width="40%"><span class="SMALLTEXT">Actions</span></td>
			</tr>
			<tr>
			  <td width="40%">
				  <select class="TEXTBOX" size="6" name="From_Data" style="font-size: 8pt; font-family: Verdana" >
                                    <%
                                    for(int i=0;i<list.size();++i){
                                  %>
					<option value='<%=((XpoTask)list.get(i)).getId()%>'><%=((XpoTask)list.get(i)).getName()%></option>
                                  <%
                                   }
                                  %>
				  </select>
				</td>
			  </tr>
			  <tr>
				  <td width="40%"></td>
			  </tr>
		</table>
	  </td>
	  <td width="100" nowrap>
		  <table border="0" width="100%" cellspacing="0" cellpadding="0">
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:addFiledToSelection(document.access.From_Data,document.access.To_Data)" class="SMALLLINK">add</a></td>
			</tr>
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:addAllFiledToSelection(document.access.From_Data,document.access.To_Data)" class="SMALLLINK">add all</a></td>
			</tr>
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:removeFiledFromSelection(document.access.To_Data)" class="SMALLLINK">remove</a></td>
			</tr>
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:removeAllFiledFromSelection(document.access.To_Data)" class="SMALLLINK">remove all</a></td>
			</tr>
		  </table>
	  </td>
	  <td width="286">
		  <table border="0" width="100%" cellspacing="0" cellpadding="0">
			<tr>
			  <td width="100%"><span class="SMALLTEXT">Execute actions</span></td>
			</tr>
			<tr>
			  <td width="100%">
                                <select class="TEXTBOX" multiple type="hidden"  style="visibility:hidden; display:none" name="To_Data_Task" id="To_Data_Task">
                                </select>
				<select class="TEXTBOX" size="6" name="To_Data" style="font-size: 8pt; font-family: Verdana">
                                <%
								   XpoTask ft = null;
                                   for(int y=0;y<dataTasks.size();++y){
                                   ft = mgr.getXpoTaskById((String)dataTasks.get(y));
                                   if(ft == null){
                                    continue;
                                   }
                                %>
				    <option value='<%=ft.getId()%>'><%=ft.getName()%></option>
                                <%
                                   }
                                %>
				</select></td>
			</tr>
			<tr>
			  <td width="40%"></td>
			</tr>
		  </table>
	  </td>
	  <td width="100" nowrap>
		<table border="0" width="100%" cellspacing="0" cellpadding="0">
		  <tr>
			<td width="100%" align="center"></td>
		  </tr>
		  <tr>
			<td width="100%" align="center"><font size="1"><!--<a href="javascript:alert('holla')">move up</a>--></font></td>
		  </tr>
		  <tr>
			<td width="100%" align="center"><font size="1"><!--<a href="javascript:alert('holla')">move down</a>--></font></td>
		  </tr>
		  <tr>
			<td width="100%" align="center"></td>
		  </tr>
		</table>
	  </td>
  </tr>
</table>
    </td>
  </tr>
    <tr><td width="100%" >&nbsp;</td></tr>
  <tr><td width="100%" ><span class="HEADER">Flow Alerts</span></td></tr>
  <tr>
    <td width="100%">
        <span class="SMALLTEXT">execute following actions upon flow dimension <b>failure</b>:</span>
    </td>
  </tr>
  <tr>
    <td width="100%">
    	<table border="0" width="600" cellspacing="0" cellpadding="0">
  <tr>
	<td>
		<table border="0" width="86" cellspacing="0" cellpadding="0">
			<tr>
			  <td width="40%"><span class="SMALLTEXT">Actions</span></td>
			</tr>
			<tr>
			  <td width="40%">
				  <select class="TEXTBOX" size="6" name="From_Flow" style="font-size: 8pt; font-family: Verdana" >
                                    <%
                                    for(int i=0;i<list.size();++i){
                                  %>
					<option value='<%=((XpoTask)list.get(i)).getId()%>'><%=((XpoTask)list.get(i)).getName()%></option>
                                  <%
                                   }
                                  %>
				  </select>
				</td>
			  </tr>
			  <tr>
				  <td width="40%"></td>
			  </tr>
		</table>
	  </td>
	  <td width="100" nowrap>
		  <table border="0" width="100%" cellspacing="0" cellpadding="0">
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:addFiledToSelection(document.access.From_Flow,document.access.To_Flow)" class="SMALLLINK">add</a></td>
			</tr>
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:addAllFiledToSelection(document.access.From_Flow,document.access.To_Flow)" class="SMALLLINK">add all</a></td>
			</tr>
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:removeFiledFromSelection(document.access.To_Flow)" class="SMALLLINK">remove</a></td>
			</tr>
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:removeAllFiledFromSelection(document.access.To_Flow)" class="SMALLLINK">remove all</a></td>
			</tr>
		  </table>
	  </td>
	  <td width="286">
		  <table border="0" width="100%" cellspacing="0" cellpadding="0">
			<tr>
			  <td width="100%"><span class="SMALLTEXT">Execute actions</span></td>
			</tr>
			<tr>
			  <td width="100%">
                                <select class="TEXTBOX" multiple type="hidden"  style="visibility:hidden; display:none" name="To_Flow_Task" id="To_Flow_Task">
                                </select>
				<select class="TEXTBOX" size="6" name="To_Flow" style="font-size: 8pt; font-family: Verdana">
                                <%
								   XpoTask ft1 = null;
                                   for(int y=0;y<flowTasks.size();++y){
                                   ft1 = mgr.getXpoTaskById((String)flowTasks.get(y));
                                   if(ft1 == null){
                                    continue;
                                   }
                                %>
				    <option value='<%=ft1.getId()%>'><%=ft1.getName()%></option>
                                <%
                                   }
                                %>
				</select></td>
			</tr>
			<tr>
			  <td width="40%"></td>
			</tr>
		  </table>
	  </td>
	  <td width="100" nowrap>
		<table border="0" width="100%" cellspacing="0" cellpadding="0">
		  <tr>
			<td width="100%" align="center"></td>
		  </tr>
		  <tr>
			<td width="100%" align="center"><font size="1"><!--<a href="javascript:alert('holla')">move up</a>--></font></td>
		  </tr>
		  <tr>
			<td width="100%" align="center"><font size="1"><!--<a href="javascript:alert('holla')">move down</a>--></font></td>
		  </tr>
		  <tr>
			<td width="100%" align="center"></td>
		  </tr>
		</table>
	  </td>
  </tr>
</table>
    </td>
  </tr>
  
</table>
