<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.scheduler.ui.*"%>
<%@ page import="xpolog.eye.automation.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.data.*"%>
<%@ page import="xpolog.logic.data.cleaners.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>

<%
  //constants
  String BASE_DIRECTORY = "../../../";
  String ERROR_OBJ = "ERROR_OBJ";
	String ID = "id";
	String DS_NAME = "dsName";
	String id = request.getParameter(ID);
	String dsName = request.getParameter(DS_NAME);
	String actionId = "";

	ActionJobBuilder job = new ActionJobBuilder();
	DataServiceRunner runner = null;
	DataService service = null;
	DataServiceJobInfo jobInfo = null;
	
	int hoursToKeep = 48;
	
	if(dsName != null){
		service = DataServicesConfiguration.getInstance().getDataService(dsName);
	}

	boolean showHoursToKeep = false;
	if(id != null && service != null){
		runner = service.getRunner(id);
		if (runner != null){
			jobInfo = service.getJobInfo(runner.getJobInfoId());
			XpoScheduledOperation op = runner.createXpoScheduledOperation();
	 		job = new ActionJobBuilder(op);
	 		job.updateFromOp();
	 		id = job.getId();
	 		actionId = job.getActionId();
	 		if (jobInfo instanceof SweeperSqlScript){
		 		hoursToKeep = ((SweeperSqlScript)jobInfo).getHoursToKeep();
		 		showHoursToKeep = true;
		 	}
		}
	}
 	request.setAttribute("CURRENT_JOB",job);
 	request.setAttribute("CURRENT_ID",id);
 	request.setAttribute("ONLY_SCHEDULING","true");
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />

<script language="javascript">
function doSave(){
   document.access.action = "dataServiceAction.jsp";
   document.access.submit();
}

</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" name="access" id="access" method="post">
<input type="hidden" name="id" value="<%=id%>">
<input type="hidden" name="dsName" value="<%=dsName%>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%"  class="LOGIC_MAIN_TABLE">
          <tr>
            <td valign="top">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
                <tr>
                <td colspan="2" nowrap><span class="PAGEHEADER">Edit Data Service - <%=service.getName()%></span></td>
                <td width="50%" >&nbsp;</td>
              </tr>
              <tr>
                <td colspan="3">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" valign="top">&nbsp;</td>
                <td width="100%" colspan="2" valign="top"><span class="HEADER">Scheduler</span></td>
              </tr>
               <tr>
                <td colspan="3">&nbsp;</td>
              </tr>
              <tr>
                <td valign="top">
                </td>
                <td colspan="2" valign="top">
                <table width="100%" border="0"  cellspacing="1" cellpadding="0">
                  <tr>
                    <td><span class="REGULARTEXT"><%@ include file="../../../scheduler/schedule.jsp"%></span></td>
                  </tr>
                </table>
                </td>
              </tr>
              <tr>
                <td colspan=3>&nbsp;</td>
              </tr>
              <%if (showHoursToKeep){%>
              <tr>
                <td>&nbsp;</td>
              	<td><span class="REGULARTEXT">Hours to keep: <input type="text" name="hoursToKeep" size="5" value="<%=hoursToKeep%>"></span></td>
              </tr>
              <tr>
                <td colspan=3>&nbsp;</td>
              </tr>
              <%}%>
              <tr>
                <td colspan=3>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="892" id="AutoNumber17">
                      <tr>
                        <td width="164">&nbsp;</td>
                        <td width="90">
                        <p align="center"><a href="dataServicesAdmin.jsp" class="LINK">Cancel</a></td>
                        <td width="94">
                          <p align="left"><a href="javascript:doSave()" class="LINK">Save</a></p>
                        </td>
                        <td width="443">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>                  
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
     
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>