<%@ page language="java"%>

<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.scheduler.ui.*"%>
<%@ page import="xpolog.logic.data.*"%>
<%@ page import="xpolog.logic.data.cleaners.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%@ page import="xpolog.eye.error.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	 
	UserContext userContext = UserEnvironment.getUserContext(request);


	String ERROR_OBJ = "ERROR_OBJ";
	
	String name,dsName,description,id,actionId,iterNumber,intervalTimeUnit,startDate;
	String endDate,interTime, hoursToKeep;
	String hours,minutTens,minutUnit,secTen,secUnit,trigType,timeType;
	String hoursInterval,minutesInterval;
	String typeHour,typeDay;
	String[] montharr,daywarr,dayInMonarr;
	
	name = request.getParameter("Name");
	description = request.getParameter("Description");
	id = request.getParameter("id");
	dsName = request.getParameter("dsName");
	
	startDate = request.getParameter("startDate");
	endDate = request.getParameter("endDate");
	intervalTimeUnit = request.getParameter("intervalTimeUnit");
	iterNumber = request.getParameter("iterationNumber");
	interTime = request.getParameter("intervalTime");
	daywarr = request.getParameterValues("dayw");
    
 	montharr = request.getParameterValues("Month");
 	dayInMonarr =request.getParameterValues("DayInMonth");
 	hours = request.getParameter("Hours");
	minutTens = request.getParameter("minutesTens");
	minutUnit = request.getParameter("minutesUnit");
	secTen = request.getParameter("secondTen");
	secUnit = request.getParameter("secondUnit");
	trigType = "cron";
	hoursInterval = request.getParameter("hoursInterval");
	minutesInterval = request.getParameter("minutesInterval");
	typeDay = request.getParameter("typeDay");
	typeHour = request.getParameter("typeHour");
	String state = "2";
	hoursToKeep = request.getParameter("hoursToKeep");
	
	ErrorModel errmodel = new ErrorModel(); 
 	if(typeDay == null || typeDay.equals("")){
   	errmodel.addError("Please specify schedule details");
 	}else{
 		if(typeDay.equals("dayOWeek") && (daywarr == null || daywarr.length == 0)){
 			errmodel.addError("Please specify days in week");
 		}else if(typeDay.equals("dayOMon")){
 			if(dayInMonarr == null || 
 				dayInMonarr.length == 0 || 
 				montharr == null || 
 				montharr.length == 0){
 				errmodel.addError("Please specify months and days");
 			}
 		}
 	}
 	/*
 	if ((hours.equals("0") || hours == null) && (hoursInterval.equals("0") || hoursInterval == null)){
 		errmodel.addError("Please specify hour / hour interval");
 	}
 	*/
	
  if(errmodel.getErrorCount() != 0){
   	request.getSession().setAttribute(ERROR_OBJ,errmodel);
   	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
   	return;
 	}
  	
  	
 	ActionJobBuilder builder = new ActionJobBuilder();
 	builder.setId(id);
 	builder.setName(name);
 	builder.setDescription(description);
	builder.setState(state); 
    
  builder.setStartDate(startDate);
  builder.setEndDate(endDate);
    
 	builder.setCron(true);
    	
 	if(typeDay.equals("dayOWeek")){
 		builder.setDayType(JobBuilder.DAY_OF_WEEK);	
    Integer[] darr = new Integer[daywarr.length];
    int numberOfDays = 0;
    for(int i=0;i<darr.length;++i){
    	darr[i] = new Integer(daywarr[i]);
    	numberOfDays++;
    }
 		builder.setDays(darr);
 		if (numberOfDays == 7){
 			builder.setAllDayInWeek(true);
 			darr = new Integer[0];
 		}
 	}else if(typeDay.equals("dayOMon")){
 		builder.setDayType(JobBuilder.DAY_OF_MONTH);
 		Integer[] darr = new Integer[dayInMonarr.length];
 		
 	  for(int i=0;i<darr.length;++i){
 	  	if(dayInMonarr[i].equals("all")){
 	  		builder.setAllDayInMonth(true);
 	  		darr = new Integer[0];
 	  		break;
 	   	}
 	   	darr[i] = new Integer(dayInMonarr[i]);
 	  }
  	builder.setDayInMonth(darr);
  	Integer[] marr = new Integer[montharr.length];
 	  for(int i=0;i<marr.length;++i){
 	  	if(montharr[i].equals("all")){
 	   		builder.setAllMonth(true);
 	   		marr = new Integer[0];
 	   		break;
 	   	}
 	   	marr[i] = new Integer(montharr[i]);
 	  }
   	builder.setMonth(marr);
  }
    	
	  builder.setHours(hours);
	  builder.setMinutesTen(minutTens);
	  builder.setMinuteUnit(minutUnit);
	  builder.setSecondTen(secTen);
	  builder.setSecondUnit(secUnit);

 		builder.setMinutesInterval(minutesInterval);
 		builder.setHoursInterval(hoursInterval);
 		if(minutTens != null && minutTens.equals("0") && minutUnit.equals("0") && minutesInterval.equals("1")){
 			builder.setEveryMinute(true);
 		}
 		if(hours != null && hours.equals("0") && hoursInterval.equals("1")){
 			builder.setEveryHour(true);
 		}
    	
  
  XpoScheduledOperation ops = null;
  try {  	
  	ops = builder.buildXpoSchedOp();
  } catch (IllegalArgumentException e) {
  		errmodel.addError(e.getMessage());
  } catch (Exception e1) {
  		errmodel.addError("Invalid time rule. Please make sure the time rule is valid and try again");
  }
  
  int hoursToKeepInt = -1;
  if (hoursToKeep != null && hoursToKeep.length()>0){
    try {
    	hoursToKeepInt = Integer.parseInt(hoursToKeep);
    }catch (Exception e){
  	  errmodel.addError("Hours to keep - Invalid number");
    }
  }
  if (ops == null || ops.getTriggers() == null || ops.getTriggers().size() == 0){
  	errmodel.addError("No scheduling was selected");
  }
  if(errmodel.getErrorCount() != 0){
   	request.getSession().setAttribute(ERROR_OBJ,errmodel);
   	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
   	return;
 	}
  
  String cronExp = ((XpoCronTrigger)ops.getTriggers().get(0)).getCronExpression();
  
  DataService service = DataServicesConfiguration.getInstance().getDataService(dsName);
  DataServiceRunner runner = service.getRunner(id);
	DataServiceJobInfo jobInfo = service.getJobInfo(runner.getJobInfoId());
  runner.setCron(cronExp);
  if (jobInfo instanceof SweeperSqlScript && hoursToKeepInt > 0){
  	((SweeperSqlScript)jobInfo).setHoursToKeep(hoursToKeepInt);
  }
  DataServicesConfiguration.getInstance().saveDataServicesConfiguration();
	DataServices ds = DataServices.getInstance();
	ds.restart();
  
	
	//	  audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	     			userContext, AuditConstants.CHANGE, "edit data services", AuditConstants.CONFIGURATION, "edit data services");

	response.sendRedirect("dataServicesAdmin.jsp");
%>

