<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.atomic.data.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.edge.*"%>
<%@ page import="xpolog.logic.routine.data.*"%>
<%@ page import="xpolog.logic.alert.engine.actions.*"%> 
<%
  String ERROR_OBJ = "ERROR_OBJ"; 
  String OP = "OP";
  String ADD = "ADD";
  String DUPLICATE = "DUPLICATE";

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  
  UserSecurity user = manager.getUserSecurity(request);
  AtomicConfigurationManager atomicConfig = XpoLogicInitiator.getInstance().getAtomicConfigManager();
  AtomicModelParadigm[] dataSources = new AtomicModelParadigm[0];
  if (atomicConfig != null){
 	dataSources = atomicConfig.getParadigms();
 	Arrays.sort(dataSources,new Comparator(){
		public int compare(Object o1 ,Object o2){
			AtomicModelParadigm atomic1 = (AtomicModelParadigm)o1;
			AtomicModelParadigm atomic2 = (AtomicModelParadigm)o2;
			
			return atomic1.getName().compareTo(atomic2.getName());
		}
	});
  }
  
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link rel="stylesheet" type="text/css" href="/logeye/css/mainproduct.css" />
<script>
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" bgcolor="#C0C0C0" bordercolor="#875546" style="border: 1 solid #875546">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td colspan="2" nowrap><span class="PAGEHEADER">Data Sources Administration </span></td>
                <td width="50%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>              
              <tr>
                <td width="3%" valign="top">
                &nbsp;</td>
                <td width="147%" colspan="2" valign="top">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td><span class="HEADER">Data Source List</span></td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td ><a href="addXMLDataSource.jsp?OP=<%=ADD%>&atomicId=" class="LINK">add new</a></td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr class="TABLES_HEADERS">
                        <td width="15%" ><span class="REGULARTEXT">Name</span></td>
                        <td width="30%"><span class="REGULARTEXT">Description</span></td>
                        <td width="35%" class="REGULARTEXT">&nbsp;</td>
                      </tr>
                      <%
						for (int i = 0; i < dataSources.length; i++) {
						   String id = dataSources[i].getId();						  
                      %>
                      <tr>
                        <td width="15%" class="REGULARTEXT" nowrap><a href="addXMLDataSource.jsp?atomicId=<%=id%>" class="LINK"><%=dataSources[i].getName()%></a></td>
                        <td width="30%" class="REGULARTEXT"><%=dataSources[i].getDescription()==null?"N/A" : dataSources[i].getDescription()%></td>
                        <td width="35%" class="SMALLTEXT" nowrap><a href="addXMLDataSource.jsp?atomicId=<%=id%>" class="LINK">view</a>&nbsp;
                        										   <a href="addXMLDataSource.jsp?OP=<%=DUPLICATE%>&atomicId=<%=id%>" class="LINK">duplicate</a>&nbsp;
                        										   <a href="dataSourceFiltersAdmin.jsp?atomicId=<%=id%>" class="LINK">filters</a>&nbsp;
                                                                   <a href="dataSourceRemoveCheck.jsp?atomicId=<%=id%>" class="LINK">delete</a></td>
                      </tr>
                      <%
                      	}
                      %>
                      <tr>
                        <td width="15%" class="SMALLTEXT">&nbsp;</td>
                        <td width="30%" class="SMALLTEXT">&nbsp;</td>
                        <td width="35%" class="SMALLTEXT">&nbsp;</td>
                      </tr>
                    </table>
                   </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
           
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="35%">&nbsp;</td>
                    <td width="11%" align="center">&nbsp;</td>
                    <td width="7%" align="center">
                     &nbsp;</td>
                                          <td width="27%">&nbsp;</td>
                    <td width="20%">&nbsp;</td>
                  </tr>
                </table>
              
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>