<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.logic.security.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.brain.*"%>
<%@ page import="xpolog.logic.exe.*"%>
<%@ page import="xpolog.logic.sources.ModelSamplerRunner"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.scheduler.ui.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.DateUtil"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%!static final String BASE_DIRECTORY = "../../../";%>

<%
String ERROR_OBJ = "ERROR_OBJ";
String NUMBER_FILTER = "NumberFilter";
		
UserContext userContext = UserEnvironment.getUserContext(request);
WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request,response,LogicPermissionConstants.MonitorPermissions.TRANSACTION_ADMIN_PERMISSION,true)){
     return;
}
			UserSecurity user = manager.getUserSecurity(request);
			String sessionId = DataSession.ONLINE_DATA_SESSION_ID;
			String workspaceId = DataSession.ONLINE_DATA_SESSION_ID;
						
			long hoursToKeep = 0;

			Collection transactionsCol = BrainConfigurationRepository.getRepository().getTransactionsParadigms(userContext);
			TransactionParadigm[] transactions = (TransactionParadigm[]) transactionsCol.toArray(new TransactionParadigm[transactionsCol.size()]);
			Arrays.sort(transactions, new Comparator() {
				public int compare(Object o1, Object o2) {
					String t1Name = ((TransactionParadigm)o1).getName();
					String t2Name = ((TransactionParadigm)o2).getName();
					return t1Name.toLowerCase().compareTo(t2Name.toLowerCase());
				}
			});

			if(transactions == null || transactions.length == 0) {
				ErrorModel errmodel = new ErrorModel();
				errmodel.addError("There are no Trasnactions defined in system");
				request.getSession().setAttribute(ERROR_OBJ,errmodel);
				response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/logicPortal.jsp&okURL=logic/logicPortal.jsp");
				return;

			}
			
			HashSet selectedTransMap = new HashSet();

			CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
			DataSession dataSession = ctrlMgr.getDataSessionById(sessionId);
			if (dataSession == null){
				ErrorModel errmod = new ErrorModel();
				errmod.addError("Monitoring definitions are missing");
		    request.getSession().setAttribute(ERROR_OBJ,errmod);
		    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?okURL=logic/logicPortal.jsp&cancelURL=logic/logicPortal.jsp");
		    return;
			}
			

				if (workspaceId.length() == 0) {
					workspaceId = dataSession.getParentWorkspaceId();
				}
				hoursToKeep = dataSession.getHoursToKeep();
				String[] selectedTrans = ctrlMgr.getTransactionParadigmForSessionPradigm(sessionId);
				if (selectedTrans != null) {
					for (int i = 0; i < selectedTrans.length; i++) {
						selectedTransMap.add(selectedTrans[i]);
					}
				}
				
				String defaultSamplingIntervalStr = DateUtil.formatTime(ModelSamplerRunner.DEFAULT_SAMPLING_INTERVAL);
				
			%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">

<link rel="stylesheet" type="text/css" 	href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" 	href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />
<script>
  function doSave(){
    document.access.action="tranToMonitorAction.jsp";
    document.access.submit();
  }
</script>
<title></title>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%"
	cellpadding="0">

	<tr>
		<td width="100%" height="100%" valign="top">
		<table border="0" width="100%" cellspacing="0" height="90%"
			cellpadding="0">
			<tr>
				<td valign="top" height="84%">
				<table border="0" cellpadding="0" cellspacing="0"
					class="LOGICGENERAL" width="100%">
					<tr>
						<td colspan="3" class="LOGIC_TOPLEFTRIGHTBORDER" nowrap><span class="PAGEHEADER">Transaction Monitor</span></td>
					</tr>
					<tr>
						<td width="3%" valign="top">&nbsp;</td>
						<td width="*" colspan="2">
						<table border="0" width="100%" cellspacing="0" cellpadding="0">
              <%if (XpologLicenseManager.getInstance().isDemo()) {%>
              <tr><td>&nbsp;</td></tr>
              <tr>
              	<td><span class="LICENSEMESSAGE">
              		Monitoring is not avaiable in trial version.
              	</span></td>
              </tr>
              <tr><td>&nbsp;</td></tr>
              <%}%>
							<tr>
								<td width="*" valign="top"><span class="HEADER">Monitored Transactions</span></td>
							</tr>
							<tr>
								<td width="*"><span class="REGULARTEXT">Select transactions to monitor and set the data sampling interval, or leave blank for <%=defaultSamplingIntervalStr %></span></td>
							</tr>
							<tr>
								<td width="100%">&nbsp;</td>
							</tr>
							<tr>
								<td>
								<table border="0" width="100%" cellspacing="0" cellpadding="0">
									<%
									for (int i = 0; i < transactions.length; i++) {
										String intervalTime = "";
										String secsel = "";
										String minsel = "";
										String hrsel = "";
										if(selectedTransMap.contains(transactions[i].getId())) {
											TransactionParadigmInfo info = transactions[i].getTransactionInfo();
											if(info != null) {
												String onlineSleepIntervalStr = info.getProperty(TransactionParadigmInfo.ONLINE_SLEEP_INTERVAL);
												String onlineSleepIntervalUnit = info.getProperty(TransactionParadigmInfo.ONLINE_SLEEP_INTERVAL_UNIT);
												if(onlineSleepIntervalStr != null && onlineSleepIntervalStr.length() > 0 && onlineSleepIntervalUnit != null && onlineSleepIntervalUnit.length() > 0){
													try {
														long onlineSleepInterval = Long.parseLong(onlineSleepIntervalStr);
														if(onlineSleepInterval > 0) {
															if(onlineSleepIntervalUnit.equals("hours")) {
																intervalTime = Long.toString(onlineSleepInterval / DateUtil.HOUR_UNIT);
																hrsel = "selected";
															}else if(onlineSleepIntervalUnit.equals("minutes")) {
																intervalTime = Long.toString(onlineSleepInterval / DateUtil.MIN_UNIT);
																minsel = "selected";
															}else if(onlineSleepIntervalUnit.equals("seconds")) {
																intervalTime = Long.toString(onlineSleepInterval / DateUtil.SEC_UNIT);
																secsel = "selected";
															}else {
																intervalTime = "1";
																secsel = "selected";
															}
														}
													}catch(Exception e) {
													}
												}
											}
										}
									%>
									<tr>
										<td width="200">
											<input type="checkbox" name="transactions" value="<%=transactions[i].getId()%>" <%=selectedTransMap.contains(transactions[i].getId()) ? "checked" : "" %>>
											<span class="REGULARTEXT">&nbsp;<%=transactions[i].getName()%></span>
										</td>
										<td width="300">
											<span class="REGULARTEXT">&nbsp;Sampling interval:</span>
											<input CLASS="TEXTBOX" type="text" id="intervalTime<%=transactions[i].getId()%>" name="intervalTime<%=transactions[i].getId()%>" size="5" value="<%=intervalTime%>" >
                      	<span CLASS="REGULARTEXT">
                        	<select size="1" CLASS="TEXTBOX" name="intervalTimeUnit<%=transactions[i].getId()%>">
                          	<option value="seconds" <%=secsel%> >seconds</option>
                            <option value="minutes" <%=minsel%> >minutes</option>
                            <option value="hours" <%=hrsel%> >hours</option>
                          </select>
                        </span>
                    </td>
										<td  width="*">&nbsp;</td>
									</tr>
									<%}%>
								</table>
								</td>
							</tr>
							<tr>
								<td>&nbsp;</td>
							</tr>
							<tr>
								<td width="*" valign="top"><span class="HEADER">Data Cleaner</span></td>
							</tr>
							<tr>
								<td width="*"><span class="REGULARTEXT">Set time in hours to keep
								results set data, or blank to use global settings (Data Services)</span></td>
							</tr>
							<tr>
								<td width="100%">&nbsp;</td>
							</tr>
							<tr>
								<td><span class="REGULARTEXT">Hours to keep: </span><input class="TEXTBOX" type="text" name="hoursToKeep"
									size="5"
									value="<%=hoursToKeep > 0 ? String.valueOf(hoursToKeep) : ""%>">
								</td>
							</tr>
							<tr>
								<td width="100%">&nbsp;</td>
							</tr>
							<tr>
								<td width="100%">
								<table border="0" width="100%" cellspacing="0" cellpadding="0">
									<tr>
										<td width="33%">&nbsp;</td>
										<td width="33%">
										<table border="0" width="100%" cellspacing="0" cellpadding="0">
											<tr>
												<td width="33%">
					              <%if (XpologLicenseManager.getInstance().isDemo()) {%>
					              &nbsp;
					              <%}else{ %>
												<a href="javascript:doSave()" class="LINK">save</a>
												<%} %>
												</td>
												<td width="33%"><a
													href="../../logicPortal.jsp"
													class="LINK">cancel</a></td>
												<td width="34%">&nbsp;</td>
											</tr>
										</table>
										</td>
										<td width="34%">&nbsp;</td>
									</tr>       					
								</table>
								</td>
							</tr>
							
						</table>
						</td>
					</tr>
					<tr valign="bottom">
				        <td valign="bottom" colspan="5" height="10%">
        					<table border="0" cellpadding="0" cellspacing="0" width="100%">
          					<tr>
          				  	<td class="LOGIC_BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            				<td class="LOGIC_BOTTOMBORDER" width="33%">&nbsp;</td>
            				<td class="LOGIC_BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
         					</tr>
        					</table>
       				</td>
      				</tr>       
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
</table>
</form>


</body>