<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";

%>

<%
UserContext userContext = UserEnvironment.getUserContext(request);

  String ERROR_OBJ = "ERROR_OBJ";
	

  String sessionRuntimeId = request.getParameter("sessionRuntimeId");
  if (sessionRuntimeId == null){
    sessionRuntimeId = "";
  }

  ErrorModel errmodel = new ErrorModel();
	
  if(sessionRuntimeId == null || sessionRuntimeId.trim().equals("")){
    errmodel.addError("No session was supplied.");
  }

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/admin/session/sessionView.jsp");
    return;
  }

  final CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
  final DataSessionRuntime dataSession = ctrlMgr.getDataSessionRuntimeById(sessionRuntimeId);
  final String sessionId = dataSession == null ? "" : dataSession.getDataSesParadigmId();

  String name = "";
  if(dataSession != null) {
	  name = dataSession.getName();
  }
  //    audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
       			userContext, AuditConstants.CHANGE, "remove project runtime", AuditConstants.PROJECT, "remove project runtime " + name);

  
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "logic/admin/common/opok.jsp?doRefresh=true&okUrl=logic/admin/session/sessionView.jsp?sessionId=" + sessionId) {
    public void run(HttpServletRequest request){
     boolean suc = false;
      try {   
       suc = ctrlMgr.removeRuntimeDataSession(dataSession);
     }catch (Exception e){
       e.printStackTrace();
     }
     if (!suc){
      errmodel.addError("A problem occured while removing runtime session.");
      createErrorRedirect(request, BASE_DIRECTORY);
      setRedirectUrl(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/admin/session/sessionView.jsp?sessionId=" + sessionId);      
     }  

    }
  };
  env.setProgressRunner(runner);
%>

<jsp:include page="../../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Deleting"/>
 <jsp:param name="useStatus" value="false"/>
</jsp:include>
