<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.logic.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.brain.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
  String ERROR_OBJ = "ERROR_OBJ";
  String OP = "OP";
  String ADD = "ADD";
  String TYPE_LOG = "Log"; 

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  UserSecurity user = manager.getUserSecurity(request);

  String sessionId = request.getParameter("sessionId");
  if (sessionId == null){
     sessionId = "";
  }

  CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
  DataSession dataSession = ctrlMgr.getDataSessionById(sessionId);  
  if (dataSession == null){
   ErrorModel errmodel = new ErrorModel();
   errmodel.addError("Session doesn't exist.");
   request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/admin/session/sessionsDefinitionView.jsp");
    return;
  }
  boolean isOnline = dataSession.getId().equals(DataSession.ONLINE_DATA_SESSION_ID);
  
  
  String workspaceId = dataSession == null ? "" : dataSession.getParentWorkspaceId();

  
  DataSessionRuntime [] sessions = ctrlMgr.getDataSessionRuntimeForSessionPgm(sessionId);
  if (sessions == null){
    sessions  = new DataSessionRuntime[0];
  }

  SimpleDateFormat dateFormat =  new SimpleDateFormat(Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss"));
  
  String refreshMenuStr = request.getParameter("refreshMenu");
  boolean refreshMenu = refreshMenuStr != null && refreshMenuStr.equals("true");
  
  WebSecurityManager securityManager = WebSecurityManager.getInstance();

	boolean isPermittedResultsSet = securityManager.isHavePermission(user,
					LogicPermissionConstants.AdministrationPermissions.RESULT_SET_PERMISSION);
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script>
function init(){
		<%if (refreshMenu){%>
			refreshMenus();
		<%}%>
	}
</script>
</head>

<body onload="javascript:init()">
<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">

      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%" class="LOGICGENERAL">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
              <tr>
                <td colspan="2" nowrap><span class="PAGEHEADER">Project -  <%=dataSession.getName()%></span></td>
                <td width="50%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" valign="top">
                &nbsp;</td>
                <td width="147%" colspan="2" valign="top">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
                  <tr>
                    <td height="30">
                      <table border="0" width="100%" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="25%"><span class="HEADER">Result Sets</span></td>
                          <td width="25%"></td>
                          <td width="25%"></td>
                          <td width="25%"></td>
                        </tr>                        
                      </table>
                    </td>
                  </tr>
		  <tr>
                    <td><span class="REGULARTEXT">
                    <%if(isPermittedResultsSet && !isOnline){ %>
                    <a href="sessionRuntimeAdmin.jsp?sessionId=<%=sessionId%>" class="LINK">create new result set</a>
                    <%} %>
                    </span>
                    </td>
                  </tr>		  
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
                      <tr class="TABLES_HEADERS">
                      	<%if (!isOnline){%>
                        <td width="200"><span class="REGULARTEXT">Created Time</span></td>
                        <td width="200"><span class="REGULARTEXT">Start Time</span></td>
                        <td width="200"><span class="REGULARTEXT">End Time</span></td>
                        <td width="*" class="REGULARTEXT">&nbsp;</td>
                        <%}else{%>
                        <td width="*" class="REGULARTEXT">&nbsp;</td>
                        <%}%>
                      </tr>
                      <%for (int i = 0 ; i < sessions.length; i++){
                      		
                      %>
                      <tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
                      	<%if (!isOnline){%>
                        <td width="200" class="REGULARTEXT" nowrap><a href="<%=BASE_DIRECTORY%>logic/online/sessionViewAction.jsp?refreshMenu=true&workspaceId=<%=workspaceId%>&sessionRuntimeId=<%=sessions[i].getId()%>" class="LINK"><%=dateFormat.format(new Date(sessions[i].getCreatedTime()))%></a></td>
                        <td width="200" class="REGULARTEXT" nowrap><%=sessions[i].getStartTime() == 0 ? "" : dateFormat.format(new Date(sessions[i].getStartTime()))%></td>
                        <td width="200" class="REGULARTEXT"><%=sessions[i].getEndTime() == 0 ? "" : dateFormat.format(new Date(sessions[i].getEndTime()))%></td>
                        <td width="*" class="REGULARTEXT" nowrap>
                        <%if(isPermittedResultsSet){ %>
                        <a href="<%=BASE_DIRECTORY%>logic/admin/session/sessionRuntimeRemoveCheck.jsp?sessionId=<%=sessionId%>&sessionRuntimeId=<%=sessions[i].getId()%>" class="LINK">delete</a>
                        <%}%>
                        <%}else{
                        	if (XpologLicenseManager.getInstance().isDemo()){%>
		                        <td width="200" class="REGULARTEXT" nowrap><b>online transations</b></td>
                        <%}else{%>
                        <td width="200" class="REGULARTEXT" nowrap><a href="<%=BASE_DIRECTORY%>logic/online/sessionViewAction.jsp?refreshMenu=true&workspaceId=<%=workspaceId%>&sessionRuntimeId=<%=sessions[i].getId()%>" class="LINK">online transations</a></td>
                        <%} %>
                        <%} %>
                      </tr>
                      <%}%>
                      <tr>
                        <td colspan="4" class="SMALLTEXT">&nbsp;</td>                        
                      </tr>
                    </table>
                   </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <%if (isOnline && XpologLicenseManager.getInstance().isDemo()) {%>
          <tr><td>&nbsp;</td></tr>
          <tr>
          	<td align="center"><span class="LICENSEMESSAGE">
          		Monitoring is not avaiable in trial version.<br>
          		Use TxExpo's commercial version to see online transactions analysis of your system.
          	</span></td>
          </tr>
          <tr><td>&nbsp;</td></tr>
          <%}%>
          
          <tr>
            <td width="100%">
           
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="35%">&nbsp;</td>
                    <td width="11%" align="center">&nbsp;</td>
                    <td width="7%" align="center">
                     &nbsp;</td>
                                          <td width="27%">&nbsp;</td>
                    <td width="20%">&nbsp;</td>
                  </tr>
                </table>
              
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">

        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>