<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.logic.security.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>

<%@ page import="java.util.*"%>
<%!static final String BASE_DIRECTORY = "../../../";

	%>
<%String ERROR_OBJ = "ERROR_OBJ";

			String workspaceId = request.getParameter("workspaceId");
			if (workspaceId == null) {
				workspaceId = "";
			}
			
			UserContext userContext = UserEnvironment.getUserContext(request);
		  
			CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
			Workspace[] workspaces = ctrlMgr == null ? null : ctrlMgr.getWorkspaces(userContext);
			if (workspaces == null) {
				workspaces = new Workspace[0];
			}
			DataSession[] sessions = ctrlMgr == null ? null : ctrlMgr
					.getDataSessionsByWorkspace(workspaceId);
			if (sessions == null) {
				sessions = new DataSession[0];
			}
			ArrayList list = new ArrayList();

			WebSecurityManager securityManager = WebSecurityManager.getInstance();
			UserSecurity user = securityManager.getUserSecurity(request);

			boolean isPermittedResultsSet = securityManager.isHavePermission(user,
							LogicPermissionConstants.AdministrationPermissions.PROJECTS_PERMISSION);
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />

<script>
  function workspaceChange(){
	workspaceId = document.access.workspaces.options[document.access.workspaces.selectedIndex].value;	
	path = "sessionsListView.jsp?workspaceId="+workspaceId;
  	document.location = path;
  }
  
  function goEdit(id){
  	path = "sessionDefinition.jsp?sessionId="+id + "&workspaceId=<%=workspaceId%>";
  	document.location = path;
  }
  
  function goNew(){ 
  	workspaceId = document.access.workspaces.options[document.access.workspaces.selectedIndex].value;	
	path = "sessionDefinition.jsp?workspaceId="+workspaceId;
  	document.location = path;
  	
  }
  
  function doDelete(id){
  	path = "sessionRemoveCheck.jsp?sessionId=" + id;
  	document.location = path;
  }
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
		<tr valign="top">
				<td width="100%">
				<table border="0" width="100%" cellspacing="0" cellpadding="0">
						<tr>
								<td valign="top" height="100%">
								<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
										<tr>
												<td width="100%">
												<table border="0" cellpadding="0" cellspacing="0" class="LOGICGENERAL" width="100%" id="AutoNumber2">
														<tr>
																<td colspan="2" nowrap><span class="PAGEHEADER">Workspace Projects</span></td>
														</tr>

														<tr>
																<td width="3%">&nbsp;</td>
																<td width="147%" colspan="2">
																<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
																		<tr>
																				<td>&nbsp;</td>
																		</tr>
																		<tr>
																				<td><span class="REGULARTEXT">View projects from workspace <span class="REGULARTEXT"> <select class="TEXTBOX" size="1" name="workspaces" onchange="javascript:workspaceChange()">
																						<%for (int i = 0; i < workspaces.length; i++) {%>
																						<option value="<%=workspaces[i].getId()%>" <%=workspaceId.equals(workspaces[i].getId()) ? "selected" : ""%>><%=workspaces[i].getName()%></option>
																						<%}%>
																				</select></td>
																		</tr>
																		<tr>
																				<td>&nbsp;</td>
																		</tr>

																		<tr>
																				<td>
																				<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
																						<tr class="TABLES_HEADERS">
																								<td width="300"><span class="REGULARTEXT">Name</span></td>
																								<td width="*"><span class="REGULARTEXT">Description</span></td>
																								<td width="100"></td>
																						</tr>
																						<%for (int i = 0; i < sessions.length; i++) {
																							if (user != null && !user.isVisible(sessions[i].getPermissions())) {
																								continue;
																							}
																						%>
																						<tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
																								<td width="300"><a href="sessionView.jsp?sessionId=<%=sessions[i].getId()%>" class="LINK"><%=sessions[i].getName()%></a></td>
																								<td width="*"><span class="REGULARTEXT"><%=sessions[i].getDescription()==null?"":sessions[i].getDescription()%></span></td>
																								<td width="100"></td>
																						</tr>
																						<%}%>
																						<tr>
																								<td width="16%">&nbsp;</td>
																								<td width="50%"></td>
																								<td width="24%"></td>
																								<td width="10%"></td>
																						</tr>
																				</table>
																				</td>
																		</tr>
																		<tr>
																				<td></td>
																		</tr>
																		<tr>
																				<td></td>
																		</tr>
																		<tr>
																				<td></td>
																		</tr>
																</table>
																</td>
														</tr>
												</table>
												</td>
										</tr>
										<tr>
												<td width="100%">&nbsp;</td>
										</tr>
										<tr>
												<td width="100%">&nbsp;</td>
										</tr>
										<tr>
												<td width="100%" height="100%">&nbsp;</td>
										</tr>
								</table>
								</td>
						</tr>
				</table>
				</td>
		</tr>
</table>
</form>
</body>

</html>
