<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.logic.ui.admin.system.*"%>

<%@ page import="java.util.*"%>


<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
	String ERROR_OBJ = "ERROR_OBJ";
	String onlineStr = request.getParameter("Online");
	boolean online = onlineStr != null && onlineStr.equals("true");
	String accountBuilderName = online ? "TxExpoOnlineAccountBuilder" : "TxExpoAccountBuilder";
	request.getSession().removeAttribute(accountBuilderName);
	String forwardUrl = "logic/admin/settings/dbCreationAction.jsp?accountBuilderName="+accountBuilderName;
	String dbType = request.getParameter("Type");
	  SiteManagment mgmt = SiteManagment.getInstance();
	  XpoDriversManager driverMgr = XpoDriversManager.getInstance();
	  XpoDriverInfo driverInfo = null;
	  if (dbType != null && dbType.length() > 0){
		  driverInfo = driverMgr.getDriverById(dbType);
	  }
	String link = "";
	String driverName = "";
	boolean driverAvailable = false;
	if (driverInfo != null){
		driverName = driverInfo.getDriverName();
		link = driverInfo.getDriverJspUrl();
		try {
		  driverAvailable = driverMgr.checkDriver(driverName);
		}catch (Throwable e){			
			ErrorModel.log.error("Failed to load driver "  + driverName,e);
		}
	}

	DBAccount dbAccount = null;
	if (online){
		dbAccount = (DBAccount)AddressBook.getInstance().getAccountById("xpologicOnlineDB");

	}else{
		dbAccount = (DBAccount)AddressBook.getInstance().getAccountById("xpologicDB");
	}
	String connectionStatus = "";
	boolean stat = false;
	if (dbAccount != null){
		if (dbAccount.getDataSourceName() != null && dbAccount.getDataSourceName().length() > 0){
			connectionStatus = dbAccount.getDataSourceName();
		}else{
			connectionStatus = dbAccount.getConnectionString();
		}
		stat = LogicCreatorManager.getInstance().getTxExpoConnectionStatus(dbAccount);
	}
	if (connectionStatus == null) connectionStatus = "";
	String id = null;
	if (dbAccount != null && (driverInfo == null || dbType.equals(dbAccount.getDriverType()))){
		id = dbAccount.getId();
		//System.out.println("id="+id+", dbType="+dbType+", dbAccount.getDatabaseType()=" + dbAccount.getDatabaseType());
		if (dbType == null || dbType.length() == 0){
			dbType = dbAccount.getDriverType();
			driverInfo = driverMgr.getDriverById(dbType);
			driverName = driverInfo.getDriverName();
			link = driverInfo.getDriverJspUrl();
			driverAvailable = driverMgr.checkDriver(driverName);
		}
	}
	link = BASE_DIRECTORY + "tools/addresses/db/" + link;
	//System.out.println(link);

	if (link.indexOf("?") == -1){
	  link += "?";
	}else {
	  link += "&";
	}
	link = link + "isEmbeded=true&hideDefault=true";
	link = link + "&accountBuilderName="+(online ? "TxExpoOnlineAccountBuilder" : "TxExpoAccountBuilder");
	link = link + "&actionUrl=accountDbAction.jsp%3fskipSave=true";
	if (id != null && id.length() >0){
		link = link + "&ID=" + id;
	}

	XpoDriverInfo [] drivers = LogicCreatorManager.getInstance().getLogicSupportedDrivers();  
%>
<script>
</script>

<form AUTOCOMPLETE="OFF" name="<%=online ? "onlineD" : "d"%>bSelection" id="<%=online ? "onlineD" : "d"%>bSelection" method="post">
<input type="hidden" name="accountBuilderName" value="<%=accountBuilderName%>">
<input type="hidden" name="skipSave" value="true">
<input type="hidden" name="Type" value="<%=dbType%>">
<input type="hidden" name="doCreate" value="true">
<input type="hidden" name="doBuild" value="true">
<input type="hidden" name="doInit" value="true">
<input type="hidden" name="doReset" value="false">
<input type="hidden" name="forwardUrl" value="<%=forwardUrl%>">
<%if (online){%>
<input type="hidden" name="txExpoOnlineAccount" value="true">
<%}else{%>
<input type="hidden" name="txExpoAccount" value="true">
<%}%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="97%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53" style="visibility:visible">
                	<tr><td>&nbsp;</td></tr>
                  <tr>
                  	<td>
                  		<table width="100%" border="0" cellpadding="0" cellspacing="0">
                  			<tr>
                  				<td>
                  					<span class="REGULARTEXT" style="font-weight:bold">
                  						Current settings: <%=connectionStatus%> - <%=stat?"Connection OK":"<span style=\"color:red\">No connection</span>"%>
                  					</span>
                  				</td>
                  			</tr>
                  			<tr><td colspan="2">&nbsp;</td></tr>
                  			<tr>
                  				<td><span class="REGULARTEXT">select db type: </span>
                  					<select id="DbType" name="<%=online?"Online":""%>DbType" onchange="javascript:refreshView(<%=online ? "1" : "0"%>)">
                  						<option value="none">--- select db type ---</option>
                  						<%
                              for(int t=0;t<drivers.length;t++){
                              	XpoDriverInfo dInfo = drivers[t];                      	
                              	String dType = dInfo.getType();
                              	boolean selectedB = dType != null && dbType != null && dType.equals(dbType);
                              	String selected = selectedB ? "selected" : "";
                  						%>
                  							<option value="<%=dInfo.getType()%>" <%=selected%>><%=dInfo.getType()%></option>
                  						<%}%>
                  					</select>
                  				</td>
                  			</tr>
                  			<%if (dbType != null && dbType.length() > 0 && !dbType.equals("none")){ %>
                  			<tr><td>&nbsp;</td></tr>
                  			<tr>
                  				<td>
														<jsp:include page="<%=link%>" flush="true"/>
													</td>
                  			</tr>
                  			<%}%>
                  		</table>
                  	</td>
                  </tr>
             			<%if (dbType != null && dbType.length() > 0 && !dbType.equals("none")){ %>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="101%" id="AutoNumber17">
                      <tr>
                        <td width="30%">&nbsp;</td>
                        <td width="10%"><a href="<%=BASE_DIRECTORY%>logic/logicPortal.jsp" class="LINK">cancel</a></td>
                        <td width="15%">
									      <%if (XpologLicenseManager.getInstance().isDemo()) {%>
									      &nbsp;
									      <%}else{%>
                        <a href="javascript:checkConnection('<%=online ? "onlineD" : "d"%>bSelection')" class="LINK">update</a>
                        <%}%>
                        </td>
                        <td width="40%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <%}%>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>