<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.logic.admin.*"%>
<%@ page import="xpolog.eye.site.*" %>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>


<%
  String ERROR_OBJ = "ERROR_OBJ";
  String TX_WIZARD = "TX_WIZARD";
  
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  ErrorModel ermod = new ErrorModel();
  
  
  TxDetectionWizard wizard = (TxDetectionWizard) request.getSession().getAttribute("TX_WIZARD");

  if (wizard == null) {
		ermod.addError("Session is not valid any more. Please try again");
  }
  
  
  String[] logIds = wizard.getLogIds();
  for(int i=0;i<logIds.length;++i){
  	String[] datafilterIds = request.getParameterValues("To_Select_datafilter_" + i);  
  	String[] colsIds = request.getParameterValues("To_Select_cols_" + i);  
  	if(colsIds == null || colsIds.length == 0){
  		ermod.addError("Please select keys for all events.");
  		break;
  	}
  	String col = request.getParameter("To_Select_cols_" + i);
  	wizard.setFiltersForId(logIds[i],datafilterIds);
  	wizard.setColKeysForId(logIds[i],colsIds);
  }
  
  if(ermod.getErrorCount() != 0){    
	    request.getSession().setAttribute(ERROR_OBJ,ermod);
	    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
	    return;
  }

  env.setTempAttribute(SiteConstants.FORWARD_URL_ATTRIBUTE,"logic/admin/setup/wizSetRun.jsp");
  response.sendRedirect(BASE_DIRECTORY + "common/actions/nextAction.jsp");
%>


