<%@ page language="java"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.common.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.data.log.external.*"%>
<%@ page import="xpolog.logic.admin.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.site.controllers.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
	UserContext userContext = UserEnvironment.getUserContext(request);

	String CURRENT_LOG = "CURRENT_LOG";
	String TX_WIZARD = "TX_WIZARD";
	String ERROR_OBJ = "ERROR_OBJ";
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	TxDetectionWizard wizard = (TxDetectionWizard) request.getSession().getAttribute("TX_WIZARD");
	TxDetectdgmBuilder builder = new TxDetectdgmBuilder(wizard);
  SiteWizardController control = env.getSiteWizardController();
	
	xpolog.eye.error.ErrorModel errmodel = new xpolog.eye.error.ErrorModel();
	String wsName = request.getParameter("wsName");
	if(wsName == null){
		wsName = "TxWizardResult";
	}
	String[] txIds = request.getParameterValues("doTx");
	HashMap idTxName = new HashMap();
	
	for(int i=0;i<txIds.length;++i){
		String txName = request.getParameter("name_" + txIds[i]);
		if(txName == null){
			txName = txIds[i];
		}
		idTxName.put(txIds[i],txName);
	}
	if(idTxName.size() == 0){
		errmodel.addError("Please select at least one transaction");
	}
	if(errmodel.getErrorCount() != 0){
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=search/searchMergeAdmin.jsp");
		return;
	}
	builder.setTxModelIdsAndNames(idTxName);
	builder.setWorkspaceName(wsName);
	builder.setSessionName(wsName+"Project");

	builder.createEnvironment(); 
	String sessionId = builder.getDatas().getId();
	
	//	  audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	     			userContext, AuditConstants.CHANGE, "run setup wizards", AuditConstants.CONFIGURATION, "run setup wizards");

    //insert error handling
  if (control != null){
  	control.setExitPage("componentAction.jsp?selectedCompId=TransactionExpo&forward=root.jsp?mainPage=logic/admin/session/sessionRuntimeAdmin.jsp?sessionId=" + sessionId);
  	response.sendRedirect(BASE_DIRECTORY + "controllers/controllerNextAction.jsp");
  }else {  	
    response.sendRedirect(BASE_DIRECTORY + "logic/admin/session/sessionRuntimeAdmin.jsp?sessionId=" + sessionId);
  }
%>

  