<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.db.admin.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%!
	static final String BASE_DIRECTORY = "../../../";

%>

<%

	UserContext userContext = UserEnvironment.getUserContext(request);

	String ERROR_OBJ = "ERROR_OBJ";
	

  String type = request.getParameter("type");
  XpoDriversManager driverMgr = XpoDriversManager.getInstance();
  XpoDriverInfo driver = driverMgr.getDriverById(type); 
  
  DBAccountBuilder builder = DBAccountBuilderFactory.createDBAccountBuilder(driver);
  if (builder != null){
    builder.setDbName("xpologic");
    builder.setXpoName(null);
    builder.setXpoDesc(null);
    builder.setEnableSave(false);
    builder.setForwardUrl("logic/admin/system/DBCreatedAction.jsp?type="+type);
    request.getSession().setAttribute("AccountBuilder",builder);
  }
  
	//    audit
    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
       			userContext, AuditConstants.CHANGE, "select database to create", AuditConstants.CONFIGURATION, "add wrokspace " + type);

  String url = "tools/addresses/db/" + driver.getDriverJspUrl();
  response.sendRedirect(BASE_DIRECTORY + url);
 
%>
