<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.atomic.data.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.ui.graph.*"%>
<%@ page import="xpolog.logic.edge.*"%>
<%@ page import="xpolog.logic.filters.*"%>
<%@ page import="xpolog.logic.routine.data.*"%>
<%@ page import="xpolog.logic.alert.engine.*"%>
<%@ page import="xpolog.logic.alert.engine.actions.*"%>
<%@ page import="java.awt.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.mail.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%!
	 static String createMappingString(JGraphImage graphImg){
			StringBuffer buffer = new StringBuffer();
			buffer.append("<MAP NAME=\"graphMap\">\n");
			Collection edges = graphImg.getAllEdges();
			for (Iterator iter = edges.iterator(); iter.hasNext();) {
				Object  obj = iter.next();
				if (obj instanceof RoutineEdgeParadigm){
					RoutineEdgeParadigm edge = (RoutineEdgeParadigm)obj;
					Polygon pol = graphImg.getPolygonForEdge(edge,2);
					buffer.append("<AREA SHAPE=\"POLY\" COORDS=\"");
					for (int i = 0; i < pol.npoints; i++) {
						if (i > 0){
							buffer.append(",");
						}
						buffer.append(pol.xpoints[i]);
						buffer.append(",");
						buffer.append(pol.ypoints[i]);
					}	
					buffer.append("\" ");
					buffer.append("href=\"javascript:goToEdge('" + edge.getId() + "')\" ");
					buffer.append("alt=\"" + edge.getName() + "\" ");
					buffer.append(">");
					buffer.append("\n");	
				}		
			}
			Collection vertexes = graphImg.getAllVertexes();
			for (Iterator iter = vertexes.iterator(); iter.hasNext();) {
				Object  obj = iter.next();
				if (obj instanceof RoutineParadigm){
					RoutineParadigm routine = (RoutineParadigm)obj;
					Rectangle rec = graphImg.getRectangleForVertex(routine);
					buffer.append("<AREA SHAPE=\"RECT\"  COORDS=\"");
					buffer.append((int)rec.getMinX());
					buffer.append(",");
					buffer.append((int)rec.getMinY());
					buffer.append(",");
					buffer.append((int)rec.getMaxX());
					buffer.append(",");
					buffer.append((int)rec.getMaxY());
					buffer.append("\" ");					
					buffer.append("href=\"javascript:goTo('" + routine.getId() + "')\" ");
					buffer.append("alt=\"" + routine.getName() + "\" ");
					buffer.append(">");
					buffer.append("\n");	
				}		
			}
			buffer.append("</MAP>");
			return buffer.toString();
		}
%>
<%
  String ERROR_OBJ = "ERROR_OBJ";
  String OP = "OP";
  String ADD = "ADD";
  String DUPLICATE = "DUPLICATE";
  String TYPE_LOG = "Log"; 
  String TRAN_PARADIGM_BUILDER = "TRAN_PARADIGM_BUILDER";

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  UserSecurity user = manager.getUserSecurity(request);
  String ds_id = request.getParameter("ds_id");
  String op = request.getParameter(OP);
  
  String isViewStr = request.getParameter("isView");
  boolean isView = isViewStr != null && isViewStr.equals("true");
  
  UITransactionParadigmBuilder builder = null;
  if (op == null || !op.equals(ADD)){
  	if (ds_id != null && ds_id.trim().length() > 0){
  		builder = new UITransactionParadigmBuilder();
  		if (op != null && op.equals(DUPLICATE)){
  		  builder.duplicateTransactionGraph(ds_id);
  		}else {
  		  builder.loadTransactionGraph(ds_id);
  		  builder.setEditTransaction(true);
  		  isView = true;
  		}
  	}else {
  		builder = (UITransactionParadigmBuilder)request.getSession().getAttribute(TRAN_PARADIGM_BUILDER);
  	}
  }
  if (builder == null){
  	builder = new UITransactionParadigmBuilder();
  	builder.setEditTransaction(true);
  	builder.createNewTransaction();
  }
  
  
  request.getSession().setAttribute(TRAN_PARADIGM_BUILDER,builder);
	
	String selectedRoutineId = request.getParameter("selectedRoutineId");
	if (selectedRoutineId == null){
	  selectedRoutineId = "";
	}
	
	String selectedEdgeId = request.getParameter("selectedEdgeId");
	if (selectedEdgeId == null){
	  selectedEdgeId = "";
	}
  
	if (selectedRoutineId.length() > 0){
	  AtomicRoutineParadigm routine = builder.getRoutineById(selectedRoutineId);
		if (routine != null){
		  builder.updateSelectedEdges(routine);
		}
	}else if (selectedEdgeId.length() > 0){
	  EdgeParadigm edge = builder.getEdgeById(selectedEdgeId);
		if (edge != null){
		  builder.updateSelectedEdges(edge);
		}
	}
  RoutineEdgeParadigm [] edges = builder.getSelectedEdges();
  
  AtomicModelParadigm [] dataSources = builder.getDataSources();
  /*if (dataSources.length == 0){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("No data source are defnied.");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/admin/adminboard.jsp");
    return;
  }*/ 
  AtomicConfigurationManager atomicConfig = XpoLogicInitiator.getInstance().getAtomicConfigManager();
  JGraphImageDescriptor imageDescriptor = builder.getImageForGraph(700,220);
	String mappingStr = createMappingString(imageDescriptor.getJgraphImage());
	
  UIProperties defProperties = UIPreferences.getInstance().getDefaultProperies();
  UIProperties globalProperties = UIPreferences.getInstance().getGlobalProperties();
  UIProperty [] imagesProperties = globalProperties.getSortedProperties(globalProperties.getAllProperties(UIConstants.IMAGES_TYPE));	
  
  
  RoutineEdgeParadigm [] edgesAlerts = builder.getEdges();
  TransactionParadigm [] transactionAlerts = new TransactionParadigm [1];
  transactionAlerts[0] = builder.getTransactionParadigm();
  
  
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicAdminUI.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>logic/scripts/logicAdminUI.js" type="text/javascript"></script>
<script>
var ds = "";
var sourceList;
var targetList;
var filterList;
var pageLoded = "firstTime";
var sourceRoutineId = "";

function changeDS(combo,sourceId,targetId){
  changeDSLists(combo,"sourceList" + sourceId,"targetList" + targetId,"filterList" + sourceId,"newDataFilter" + sourceId);
}

function changeDSLists(combo,sourceIdName,targetIdName,filterIdName,newFilterIdName){
  sourceList = document.getElementById(sourceIdName);
  targetList = document.getElementById(targetIdName);
  filterList = document.getElementById(filterIdName);
  index = combo.selectedIndex;
  if (index >= 0){
    ds = combo.options[index].value;
    frames['dataResultFrame'].location = "getDSColumnsNames.jsp?ds_id=" + ds;
  }
  return true;
}

function clearFunctionList(functionId){
  functionList = document.getElementById("functionList" + functionId);
	functionList.options.length = 0;
}

function dataLoaded(){
    if (frames['dataResultFrame'].ds){
	  names = frames['dataResultFrame'].names;
	  dataFilters = frames['dataResultFrame'].dataFilters;
	  updateList(sourceList,names);
	  updateList(targetList,names);
	  updateList(filterList,dataFilters);
	}
}

function updateList(list,names){
if (list != null){
    list.options.length = 0;
    for (var i = 0; i < names.length;i++){
      list[i] = new Option(names[i],"" + i);
    }
  
    if (names.length == 0){
      list[0] = new Option("No data to use",-1);
    }
  }
}

function doUpdate(){
	submitPage("Update");
}

function doSave(){
	submitPage("Save");
}


function addNewEdge(edgeIndex){
  document.access.edgeIndex.value=edgeIndex;
	submitPage("addNewEdge");
}

function changeEdge(edgeIndex){  
  document.access.edgeIndex.value=edgeIndex;
	submitPage("changeEdge");
}

function removeEdge(edgeIndex){
  document.access.edgeIndex.value=edgeIndex;
	submitPage("removeEdge");
}

function submitPage(opValue){
  selectAllFunctions();
	document.access.OP.value=opValue;
	document.access.action = "TransactionBuilderAction.jsp";
	document.access.submit();
}

function selectAllFunctions(){
  for (var i = 0; i < <%=edges.length%>;i++){
	  fList = document.getElementById("functionList" + i);
		for (var j = 0; j < fList.options.length;j++){
		  fList.options[j].selected = true;
		}
	}
}

function addToFunctionList(edgeId){
  sList = document.getElementById("sourceList" + edgeId);
  tList = document.getElementById("targetList" + edgeId);
	sIndex = sList.options.selectedIndex;
	tIndex = tList.options.selectedIndex;
	name = "";
	if (sIndex >= 0){
	  name = sList.options[sIndex].text;
	}else if (tIndex >= 0){
	  name = tList.options[tIndex].text;
	} else {
		return;
	}
	
	value = "" + sIndex + "," + tIndex;
	fList = document.getElementById("functionList" + edgeId);
	fIndex = fList.options.length == 1 && fList.options[0].value == "" ? 0 : fList.options.length;
	fList.options[fIndex] = new Option(name,value);
}

function removeFromFunctionList(edgeId){
  fList = document.getElementById("functionList" + edgeId);
	fIndex = fList.options.selectedIndex;
	if (fIndex >= 0){
    if (fIndex == 0 && 	fList.options[0].value == ""){
		  return;
		}
	  fList.options[fIndex] = null;
	}
	if (fList.options.length == 0){
	  fList.options[0] = new Option("No data to use","");
	}
}

function updateSourceTargetFunction(edgeId){
  fList = document.getElementById("functionList" + edgeId);
	sList = document.getElementById("sourceList" + edgeId);
  tList = document.getElementById("targetList" + edgeId);
	fIndex = fList.options.selectedIndex;
	if (fIndex == -1 || fList.options[0].value == ""){
	  sList.options.selectedIndex = -1;
		tList.options.selectedIndex = -1;
		return;
	}
	
	fValue = fList.options[fIndex].value;
	index = fValue.indexOf(",");
	if (index == -1){
		return;
	}
	
	sList.options.selectedIndex = fValue.substring(0,index);
	tList.options.selectedIndex = fValue.substring(index + 1,fValue.length);
}


function shownHideAdv(txtDiv,targetDiv){
         
    	show = document.getElementById(targetDiv).style.display == "";
    	if(show){
    		document.getElementById(targetDiv).style.display="none";   		
    	}else{
    		document.getElementById(targetDiv).style.display="";
    	}
    	
}

function goTo(routineId){
  obj = document.getElementById("routine" + routineId);
	if (!obj){
	  this.location = "addNewTransaction.jsp?selectedRoutineId=" + routineId;
		return;
	}
	y = findPosY(obj)
	this.scrollTo(0,y);
}

function goToEdge(edgeId){
  obj = document.getElementById("edge" + edgeId);
	if (!obj){
	  this.location = "addNewTransaction.jsp?selectedEdgeId=" + edgeId;
		return;
	}
	y = findPosY(obj)
	this.scrollTo(0,y);
}



function LogicImage(id,name,src){
  this.id = id;
  this.name = name;
  this.src = src;
}

<%!
  static String buildLogicImage(UIProperty property){
    if (property == null){
      return "null";
    }
    
    return "new LogicImage('" + property.getId() + "','" + property.getName() + "','" + BASE_DIRECTORY + property.getValue() + "');";
  }
%>

var globalImages = new Array();
var defRoutineParadigmImg = <%=buildLogicImage(defProperties.getProperty(UIConstants.IMAGES_TYPE,UIConstants.ROUTINE_PARADIGM_KEY))%>
var defRoutineRuntimeImg = <%=buildLogicImage(defProperties.getProperty(UIConstants.IMAGES_TYPE,UIConstants.ROUTINE_RUNTIME_KEY))%>
var defDummyRoutineImg = <%=buildLogicImage(defProperties.getProperty(UIConstants.IMAGES_TYPE,UIConstants.DUMMY_ROUTINE_KEY))%>

<%
  for (int i = 0; i < imagesProperties.length; i++){%>
    globalImages[globalImages.length] = <%=buildLogicImage(imagesProperties[i])%>
  <%}
%>

<% int numRoutines = edges.length == 0 ? 0 : edges.length + 1; 
%>

function updateImagesLists(){
  for (var i = 0; i < <%=numRoutines%> ; i++){   
    updateImagesListsByIndex(i);
  }
}

function updateImagesListsByIndex(i){
 updateRoutineImages(document.getElementById("routineParadigmImages" + i),defRoutineParadigmImg);
 updateRoutineImages(document.getElementById("routineRuntimeImages" + i),defRoutineRuntimeImg);
 updateRoutineImages(document.getElementById("dummyRoutineImages" + i),defDummyRoutineImg);
}


function updateRoutineImages(combo,defImage){
  index = combo.selectedIndex;
  if (index == -1){
    index = 0;
  }
  combo.options.length = 0;
  combo.options[0] = new Option("Default" , "default");
  for (var i = 0; i <  globalImages.length ; i++){
    combo.options[combo.options.length] = new Option(globalImages[i].name , globalImages[i].id);
  }
  combo.selectedIndex = index;
}

function changeImage(combo,type,imageId){
  index = combo.selectedIndex;
  if (index == -1) return;
  
  if (index == 0){
    if (type == "routineParadigm"){
      src = defRoutineParadigmImg.src;
    }else if (type == "routineRuntime"){
      src = defRoutineRuntimeImg.src;
    }else if (type == "dummyRoutine"){
      src = defDummyRoutineImg.src;
    }
  }else {
    src = globalImages[index - 1].src;
  }
  document.getElementById(imageId).src = src;
}

function findGlobalImageIndex(id){  
  for (var i = 0; i < globalImages.length; i++){
    if (globalImages[i].id == id){
      return i;
    }
  }
  return -1;
}

function selectImageById(comboId,type,imageId,globalId){
  var combo = document.getElementById(comboId);
  var index = -1;
  if (globalId >= 0){
    index = findGlobalImageIndex(globalId);
  }
  
  combo.selectedIndex = index + 1;
  changeImage(combo,type,imageId);
}

function pageLoaded(){
	if (document.getElementById("routine<%=selectedRoutineId%>")){
	  goTo("<%=selectedRoutineId%>");
	}else if (document.getElementById("edge<%=selectedEdgeId%>")){
	  goToEdge("<%=selectedEdgeId%>");
	}
}

function openFilterWindow(routine,filtersComboId){
	var combo = document.getElementById("routineDS"+routine);
  index = combo.selectedIndex;
  if (index >= 0){
    document.addFilter.ds_id.value = combo.options[index].value;
  }
	if (document.addFilter.ds_id.value == "0"){
		alert("Please select a data source first");
		return;
	}
	newWindow = window.open('<%=BASE_DIRECTORY%>empty.html','filtersWindow','height=800,width=800,resizable=yes,scrollbars=yes,status=yes,left=100,top=100');
	newWindow.focus();
	document.addFilter.elem_id.value = filtersComboId;
	document.addFilter.submit();
}

function addComboEntry(comboId,entryText,entryValue){
	newEntry = new Option(entryText,entryValue,true);
	combo = document.getElementById(comboId);
	index = combo.length;
	combo.options[index] = newEntry;
	combo.selectedIndex = index;
}

//fill into an array all the existing alerts of the edges    
var edgesAlertsArr = new Array();
function buildEdgesAlertsList() {
	  <%
	  MailAlertAction edgesAcc = null;
	  for(int l=0;l<edgesAlerts.length;++l) {
	  %>
	    var tempArr = new Array();
	    <%
	    int counter = 0;
	    AlertAction[] alertsOnEdge = UITransactionParadigmHelper.getAllAlertsByKey(edgesAlerts[l],UITransactionParadigmHelper.ROUTINE_LF_STATUS_KEY);
		if(alertsOnEdge == null) {
			alertsOnEdge = new AlertAction[0];
		}
	  	for(int m=0;m<alertsOnEdge.length;++m) {
  	    %>

		//fill in each edge with its alerts		  	
                <%
			  	edgesAcc = (MailAlertAction)alertsOnEdge[m];
			  	String mediaId = edgesAcc.getMedia().getId();
			  	if(mediaId == null) {
			  		mediaId = "";
			  	}
			  	%>
				var id = "edges"+"<%=l%>_<%=counter%>";
				var key = "<%=UITransactionParadigmHelper.ROUTINE_LF_STATUS_KEY%>";			
				template = new emailTemplate("<%=mediaId%>", "<%=((MailAccount)edgesAcc.getPostOffice().getFrom()).getMailAddress()%>",
											"<%=((MailAccount)edgesAcc.getPostOffice().getTo()).getMailAddress()%>",
											"<%=edgesAcc.getPostOffice().getSubject()%>","<%=edgesAcc.getPostOffice().getMessage()%>");
			  	
			  	tempArr[tempArr.length] = new Alert(id, key, template);	
	      <%
	      counter++;
		  }
		  %>
	      edgesAlertsArr[<%=l%>] = tempArr;
	  <%
	  }
	  %>
}

//fill into an array all the existing alerts of the edges    
var transactionAlertsArr = new Array();
function buildTransactionAlertsList() {
	  <%
	  MailAlertAction transactionAcc = null;
	  for(int l=0;l<transactionAlerts.length;++l) {
	  %>
	    var tempArr = new Array();
	    <%
	    
	    int counter = 0;
	    AlertAction[] alertsOnTransaction = UITransactionParadigmHelper.getAllAlertsByKey(transactionAlerts[l],UITransactionParadigmHelper.ROUTINE_LF_STATUS_KEY);
		if(alertsOnTransaction == null) {
			alertsOnTransaction = new AlertAction[0];
		}
	  	for(int m=0;m<alertsOnTransaction.length;++m) {
  	    %>

		//fill in each edge with its alerts		  	
                <%
			  	transactionAcc = (MailAlertAction)alertsOnTransaction[m];
			  	String mediaId = transactionAcc.getMedia().getId();
			  	if(mediaId == null) {
			  		mediaId = "";
			  	}
			  	%>
				var id = "transaction"+"<%=l%>_<%=counter%>";
				var key = "<%=UITransactionParadigmHelper.ROUTINE_LF_STATUS_KEY%>";
				
				template = new emailTemplate("<%=mediaId%>", "<%=((MailAccount)transactionAcc.getPostOffice().getFrom()).getMailAddress()%>",
											"<%=((MailAccount)transactionAcc.getPostOffice().getTo()).getMailAddress()%>",
											"<%=transactionAcc.getPostOffice().getSubject()%>","<%=transactionAcc.getPostOffice().getMessage()%>");
			  	
			  	tempArr[tempArr.length] = new Alert(id, key, template);	
	      <%
	      counter++;
		  }
		  %>
	      transactionAlertsArr[<%=l%>] = tempArr;
	  <%
	  }
	  %>
}

//fill into an array all the existing templates    
var templatesArr = new Array();
function buildTemplatesList() {
		templatesArr = new Array();
  		<%
  		  TemplateBook templateBook = TemplateBook.getInstance();
		  MailMediaFilter filter = new MailMediaFilter();
		  java.util.List list = templateBook.getAccountsByFilter(filter);
		  PostOffice postOffice = null;
		  AlertAction alert = null;
  		int counter = 0;
  		for(int i=0;i<list.size();++i) {
  			if(((Media)list.get(i)).getType() == PostOffice.MAIL_MEDIA_TYPE) {
  				postOffice = (PostOffice)list.get(i);
  		%>
  			templatesArr[<%=counter%>] = new emailTemplate("<%=postOffice.getId()%>","<%=((MailAccount)postOffice.getFrom()).getMailAddress()%>","<%=((MailAccount)postOffice.getTo()).getMailAddress()%>","<%=postOffice.getSubject()%>","<%=postOffice.getMessage()%>");
		   <%
		   counter++;
		   }
		   %>
		<%}%>
		
}

//on choosing type - view templates of this kind
function presentTempaltesByType() {
	var type = document.getElementById("AlertType").value;
}

//fills the email alert div according to the given id.
function createEmailAlertDiv(id) {
	var arr;
	var index1;
	var index2;
	if(id.substring(0,11) == "transaction") {
		arr = transactionAlertsArr;
		index1 = id.substring(11,id.lastIndexOf("_"));
    	index2 = id.substring(id.lastIndexOf("_")+1, id.length);
	}else {
		arr = edgesAlertsArr;
		index1 = id.substring(5,id.lastIndexOf("_"));
    	index2 = id.substring(id.lastIndexOf("_")+1, id.length);
	}

    if(document.getElementById(id).style.display == "") {
    	var from = document.getElementById("from["+id+"]").value;
    	var to = document.getElementById("to["+id+"]").value;
    	var subject = document.getElementById("subject["+id+"]").value;
    	if(from == "" || to == "" || subject == "") {
    		alert("Please make sure From, To, and Subject have values");
    		return;
    	}
    	arr[index1][index2].template.id = document.getElementById("templateId["+id+"_x]").value;
		arr[index1][index2].template.from = from;
     	arr[index1][index2].template.to = to;
     	arr[index1][index2].template.subject = subject;
     	arr[index1][index2].template.message = document.getElementById("message["+id+"]").value;
		arr[index1][index2].key = document.getElementById("AlertTypeKey["+id+"_x]").value;
		
     	shownHideAdv('',id);
     	shownHideAdv('',id+"_x");
    }else {
    	shownHideAdv('',id);
     	shownHideAdv('',id+"_x");
    }
    
    if(id.substring(0,11) == "transaction") {
		transactionAlertsArr = arr;
	}else {
		edgesAlertsArr = arr;
	}
}

function Alert(id, key, template) {
	this.id = id;
	this.key = key;
	this.template = template;
}

function emailTemplate(id, from, to, subject, message) {
	this.type = "Email";
	this.id = id;
	this.from = from;
	this.to = to;
	this.subject = subject;
	this.message = message;
}
emailTemplate.prototype.createAlertDiv = createEmailAlertDiv;

//on choosing template fill in the information
function loadTemplateData(id){
	fieldName = "templateId["+id+"]";
  	var index = -1;
  	var tempId = document.getElementById(fieldName).value;
  	for(var i=0;i<templatesArr.length;++i) { 
  		if(tempId == templatesArr[i].id) {
  			index = i;
  		}
  	}
  	
  	//fields id is built without the "_x"
	fieldId = id.substring(0,id.length-2);
  	from = "from["+fieldId+"]";
  	to = "to["+fieldId+"]";
  	subject = "subject["+fieldId+"]";
  	message = "message["+fieldId+"]";
  	if(index != -1) {  	
	  	document.getElementById("templateId["+id+"]").value = templatesArr[index].id;
	  	document.getElementById(from).value = templatesArr[index].from;
	  	document.getElementById(to).value = templatesArr[index].to;
	  	document.getElementById(subject).value = templatesArr[index].subject;
	  	document.getElementById(message).value = templatesArr[index].message;
    }else {
	  	document.getElementById(from).value = "";
	  	document.getElementById(to).value = "";
	  	document.getElementById(subject).value = "";
	  	document.getElementById(message).value = "";
  }
}

function goEdit(id){
	createEmailAlertDiv(id);
}

//insert the right id to each created div. replaces the [ID].
function insertId(id,oldHtml) {
	var newHtml = "";
	for(var i=0;i<oldHtml.length;++i) {
		if(i != oldHtml.length-1 && oldHtml.charAt(i) == "I" && oldHtml.charAt(i+1)== "D") {
			newHtml += id;
			i++;
		}else {
			newHtml += oldHtml.charAt(i);
		}
	}
	document.getElementById(id).innerHTML = newHtml;
}

//builds 2 lines in the main table - 1-name,2-details.
function buildAlertsTableLine(mode, i) {
		var arr;
		if(mode == "edges") {
			arr = edgesAlertsArr;
		}else {
			arr = transactionAlertsArr;
		}
		for(var j=0;j<arr[i].length;++j) {
			var a1 = document.createElement('a');
			var a2 = document.createElement('a');
			var a3 = document.createElement('a');
			a1.setAttribute('href', "javascript:goEdit('" + arr[i][j].id + "')");
			a1.appendChild(document.createTextNode("Alert_"+j));
			a1.className = 'LINK';
			a2.setAttribute('href', "javascript:goEdit('" + arr[i][j].id + "')");
			a2.className = 'LINK';
			a2.appendChild(document.createTextNode('edit'));
			
			a3.setAttribute('href', "javascript:doDelete('" + arr[i][j].id + "')");
			a3.className = 'LINK';
			a3.appendChild(document.createTextNode('delete'));
			
			td1 = document.createElement('TD');
			td1.setAttribute('width', '16%');
			td1.appendChild(a1);
			
			td2 = document.createElement('TD');
			td2.setAttribute('width', '15%');
			td2.appendChild(document.createTextNode(arr[i][j].template.type));
			td2.className = 'REGULARTEXT';
			
			td3 = document.createElement('TD');
			td3.setAttribute('width', '20%');
			td3.appendChild(a2);
			td3.appendChild(document.createTextNode('\u00a0'));
			td3.appendChild(a3);
			td4 = document.createElement('TD');
			td4.setAttribute('width', '10%');
			
			line1 = document.createElement('TR');
			line1.appendChild(td1);
			line1.appendChild(td2);
			line1.appendChild(td3);
			line1.appendChild(td4);
			
			line2 = document.createElement('TR');
			div1 = document.createElement('div');
			div1.setAttribute('style', 'top: 100px;');
			div2 = document.createElement('div');
			div2.setAttribute('style', 'top: 100px;');
			
			div2.setAttribute('id',arr[i][j].id);
			div1.setAttribute('id',arr[i][j].id+"_x");
			td5 = document.createElement('TD');
			td5.appendChild(div1);
			td5.appendChild(div2);
			line2.appendChild(td5);
			document.getElementById(mode+"AlertBody"+i).appendChild(line1);
			document.getElementById(mode+"AlertBody"+i).appendChild(line2);	
			document.getElementById(arr[i][j].id).style.display = 'none';
			document.getElementById(arr[i][j].id+"_x").style.display = 'none';
			document.getElementById(arr[i][j].id+"_x").innerHTML = document.getElementById("templateBoxDiv").innerHTML;
			
			
			insertId(arr[i][j].id, document.getElementById("emailAlertDiv").innerHTML);
			insertId(arr[i][j].id+"_x", document.getElementById("TemplateBoxDiv").innerHTML);
			
		}
		if(mode == "edges") {
			edgesAlertsArr = arr;
		}else {
			transactionAlertsArr = arr;
		}
	updateAllFields(mode, i);
}

function updateAllFields(mode, i) {
		var arr;
		var id;
		if(mode == "edges") {
			arr = edgesAlertsArr;
		}else {
			arr = transactionAlertsArr;
		}
		for(var j=0;j<arr[i].length;++j) {
			id = mode + i + "_" + j;
			document.getElementById("from["+id+"]").value = arr[i][j].template.from;
     		document.getElementById("to["+id+"]").value = arr[i][j].template.to;
     		document.getElementById("subject["+id+"]").value = arr[i][j].template.subject;
     		document.getElementById("message["+id+"]").value = arr[i][j].template.message;
     		document.getElementById("AlertType["+arr[i][j].id+"_x"+"]").value = arr[i][j].template.type;
     		document.getElementById("templateId["+id+"_x]").value = arr[i][j].template.id;
     		document.getElementById("AlertTypeKey["+arr[i][j].id+"_x"+"]").value = arr[i][j].key;
     	}
}

function doDelete(id){
	var arr;
	var mode;
	var index1;
	var index2;
	if(id.substring(0,11) == "transaction") {
		mode = id.substring(0,11);
		arr = transactionAlertsArr;
		index1 = id.substring(11,id.lastIndexOf("_"));
    	index2 = id.substring(id.lastIndexOf("_")+1, id.length);
	}else {
		mode = id.substring(0,5);
		arr = edgesAlertsArr;
		index1 = id.substring(5,id.lastIndexOf("_"));
    	index2 = id.substring(id.lastIndexOf("_")+1, id.length);
	}
	
	//var arr = edgesAlertsArr[index1];
	var temp = new Array;
	for(var i=0;i<arr[index1].length-1;++i) {
		if(i<index2) {
			temp[i] = arr[index1][i];
		}else {
			temp[i] = arr[index1][i+1];
		}
	}
	
	//delete the lines of the switched array
	for(var i=0;i<arr[index1].length;++i) {
		document.getElementById(mode+"alertBody"+index1).deleteRow();
	}

	arr[index1] = temp;
	
	if(mode == "transaction") {
		transactionAlertsArr = arr;
	}else {
		edgesAlertsArr = arr;
	}
	
	reloadTable(mode, index1);
}

function goNew(mode, index){
	var arr;
	var temp;
	if(mode == "transaction") {
		arr = transactionAlertsArr[index];
	}else {
		arr = edgesAlertsArr[index];
	}
	
	temp = arr.length;
	var id = mode+index+"_"+temp;
	if(document.getElementById(id)) {
		alert("New Alert is now being created. Please either add the new alert or cancel its creation before adding another one.");
		return;
	}

	var a1 = document.createElement('a');
	a1.setAttribute('href', "javascript:saveAlert('" + id + "')");
	a1.appendChild(document.createTextNode("add"));
	a1.className = 'LINK';
	var a2 = document.createElement('a');
	a2.setAttribute('href', "javascript:reloadTable('"+ mode + "','" + index + "')");
	a2.appendChild(document.createTextNode("cancel"));
	a2.className = 'LINK';
	td1 = document.createElement('TD');
	
	line = document.createElement('TR');
	div1 = document.createElement('div');
	div1.setAttribute('style', 'top: 100px;');
	div2 = document.createElement('div');
	div2.setAttribute('style', 'top: 100px;');
	
	div2.setAttribute('id',id);
	div1.setAttribute('id',id+"_x");
	td = document.createElement('TD');
	td.appendChild(div1);
	td.appendChild(div2);
	td.appendChild(a1);
	td.appendChild(document.createTextNode('\u00a0'));
	td.appendChild(document.createTextNode('\u00a0'));
	td.appendChild(a2);
	line.appendChild(td);
	
	document.getElementById(mode+"alertBody"+index).appendChild(line);
	document.getElementById(id+"_x").innerHTML = document.getElementById("templateBoxDiv").innerHTML;
	
	insertId(id, document.getElementById("emailAlertDiv").innerHTML);
	insertId(id+"_x", document.getElementById("TemplateBoxDiv").innerHTML);
	
	//set the proper type in the option box
 	document.getElementById("AlertType["+id+"_x"+"]").value = "Email";
 	//set the default key
}

function saveAlert(id){
	var arr;
	var mode;
	var index1;
	var index2;
	if(id.substring(0,11) == "transaction") {
		mode = id.substring(0,11);
		arr = transactionAlertsArr;
		index1 = id.substring(11,id.lastIndexOf("_"));
    	index2 = id.substring(id.lastIndexOf("_")+1, id.length);
	}else {
		mode = id.substring(0,5);
		arr = edgesAlertsArr;
		index1 = id.substring(5,id.lastIndexOf("_"));
    	index2 = id.substring(id.lastIndexOf("_")+1, id.length);
	}
	
	from = "from["+id+"]";
  	to = "to["+id+"]";
  	subject = "subject["+id+"]";
  	message = "message["+id+"]";
  	
  	fromVal = document.getElementById(from).value;
  	toVal = document.getElementById(to).value;
  	subjectVal = document.getElementById(subject).value;
  	messageVal = document.getElementById(message).value;
  	idVal = document.getElementById("templateId["+id+"_x]").value;
  	
  	if(fromVal == "" || toVal == "" || subjectVal == "" || messageVal == "") {
  		alert("Please make sure From, To, and Subject have values");
  		return;
  	}
	template = new emailTemplate(idVal,fromVal,toVal,subjectVal,messageVal);
	//set the proper type in the option box
 	var key = document.getElementById("AlertTypeKey["+id+"_x"+"]").value;
	
	arr[index1][index2] =  new Alert(id, key, template);
	
	if(mode == "transaction") {
		transactionAlertsArr = arr;
	}else {
		edgesAlertsArr = arr;
	}

	reloadTable(mode, index1);
}

function reloadTable(mode, index) {
	var alertsTableLines  = document.getElementById(mode+"alertBody"+index);
	var length = alertsTableLines.rows.length;
	for(var i=0;i<length;++i) {
		alertsTableLines.deleteRow();
	}
	buildAlertsTableLine(mode, index);
}

//the 'manager' function - invoked on load.
function buildAlertsTable() {
	buildTransactionAlertsList();
	buildEdgesAlertsList();
	buildTemplatesList();
	//build the transaction alerts table
	for(var i=0;i<transactionAlertsArr.length;++i) {
		buildAlertsTableLine("transaction", i);
	}
	//build the edges alerts table
	for(var i=0;i<edgesAlertsArr.length;++i) {
		buildAlertsTableLine("edges", i);
	}
}

function createNewTemplate(id) {
    id = id.substring(0,id.length-2);
    
    var from = "from["+id+"]";
  	var to = "to["+id+"]";
  	var subject = "subject["+id+"]";
  	var message = "message["+id+"]";
  	
  	fromVal = document.getElementById(from).value;
  	toVal = document.getElementById(to).value;
  	subjectVal = document.getElementById(subject).value;
  	messageVal = document.getElementById(message).value;
  	
  	if(fromVal == "" || toVal == "" || subjectVal == "") {
  		alert("Please make sure From, To, and Subject have values");
  		return;
  	}
  
  var x = -1;
  var y = -1;
  if (id && id != ""){
    var comp = document.getElementById(id);
    x = findPosX(comp) + 550;
    y = findPosY(comp) + 75;
  }
  document.getElementById('newTemplateId').value = id;
  showHideLayerInMiddle("newTemplateDiv",x,y);
}


function doTemplateSave() {
	if(document.getElementById('newTemplateName').value == "") {
		alert('Please insert name');
		return;
	}
	hideLayer('newTemplateDiv');
	document.access.target = 'newTemplateFrame';
	document.access.action = "addNewTemplate.jsp";
	document.access.submit();
}

function templateCreated() {
	buildTemplatesList();
	var createdTemplateName = frames['newTemplateFrame'].createdTemplateName;
	var createdTemplateId = frames['newTemplateFrame'].createdTemplateId;
	var createdTemplateFrom = frames['newTemplateFrame'].createdTemplateFrom;
	var createdTemplateTo = frames['newTemplateFrame'].createdTemplateTo;
	var createdTemplateSubject = frames['newTemplateFrame'].createdTemplateSubject;
	var createdTemplateMessage = frames['newTemplateFrame'].createdTemplateMessage;
	
	if(createdTemplateName && createdTemplateId) {
		templatesArr[templatesArr.length] = new emailTemplate(createdTemplateId,createdTemplateFrom,createdTemplateTo,createdTemplateSubject,createdTemplateMessage);
		var length = document.getElementById('templateId[edges0_0_x]').length;
		//adding the new option to the transaction
		for(var i=0;i<transactionAlertsArr.length;++i) {
				id = "transaction0_"+i+"_x";
				(document.getElementById('templateId['+id+']'))[length] = new Option(createdTemplateName,createdTemplateId);
		}
		//adding the new option to the transaction
		for(var i=0;i<edgesAlertsArr.length;++i) {
			for(var j=0;j<edgesAlertsArr[i].length;++j) {
				id = "edges"+i+"_"+j+"_x";
				(document.getElementById('templateId['+id+']'))[length] = new Option(createdTemplateName,createdTemplateId); 		
			}
		}
		(document.getElementById('templateId[ID]'))[length] = new Option(createdTemplateName,createdTemplateId);
	}
	//clean the div
	document.getElementById('newTemplateName').value = "";
}

</script>
</head>

<body onload="pageLoaded();buildAlertsTable()">
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">

<input type="hidden" name="TranId" value="<%=builder.getTransactionParadigm().getId()%>">
<input type="hidden" name="OP" value="Update">
<input type="hidden" name="edgeIndex" value="">
<input type="hidden" name="isEdit" value="<%=!isView%>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" bgcolor="#C0C0C0" bordercolor="#875546" style="border: 1 solid #875546">
          <tr>
            <td width="100%">
            <table border="0" cellspacing="1" style="border-collapse: collapse" width="100%">
              <tr>
                <td colspan="2" nowrap><span class="PAGEHEADER">New Transaction </span></td>
                <td width="50%" >&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" valign="top">
                &nbsp;</td>
                <td width="100%" colspan="2" valign="top">
                <span class="HEADER">General</span>
                </td>
              </tr>
              <tr>
                <td width="3%" valign="top">
                </td>
                <td width="100%" colspan="2" valign="top">
                <table border="0" width="100%" cellspacing="1" cellpadding="0">
                  <tr>
                    <td width="15%" nowrap><span class="REGULARTEXT">Name</span></td>
                    <td width="33%"><input type="text" name="tranName" size="23" value="<%=builder.getTransactionParadigm().getName()%>"></td>
                    <td width="34%"></td>
                  </tr>
                  <tr>
                    <td width="15%" nowrap><span class="REGULARTEXT">Description</span></td>
                    <td width="33%"><input type="text" name="tranDesc" size="50" value="<%=builder.getTransactionParadigm().getDescription()%>"></td>
                    <td width="34%"></td>
                  </tr>
                  <tr>
                    <td width="15%" nowrap><span class="REGULARTEXT">Normal life cycle period</span></td>
                      <%  long lifeCycle = UITransactionParadigmHelper.getWarnLifeCycle(builder.getTransactionParadigm());
                          long timeUnit = UITransactionParadigmHelper.calculateTimeUnit(lifeCycle);
                          String lifeCycleStr = timeUnit == -1 ? "" : String.valueOf(lifeCycle / timeUnit);
                          %>
                    <td width="33%"><input type="text" name="tranLifeCycle" size="5" value="<%=lifeCycleStr%>"><span CLASS="REGULARTEXT">
                            <select size="1" CLASS="TEXTBOX" name="lifeCycleTimeUnit">
                                <option value="<%=UITransactionParadigmHelper.SECOND%>" <%=timeUnit == UITransactionParadigmHelper.SECOND? "selected" : "" %> >seconds</option>
                                <option value="<%=UITransactionParadigmHelper.MINUTE%>" <%=timeUnit == UITransactionParadigmHelper.MINUTE? "selected" : "" %> >minutes</option>
                                <option value="<%=UITransactionParadigmHelper.HOUR%>" <%=timeUnit == UITransactionParadigmHelper.HOUR? "selected" : "" %>>hours</option>
                                <option value="<%=UITransactionParadigmHelper.DAY%>" <%=timeUnit == UITransactionParadigmHelper.DAY? "selected" : "" %>>days</option>
                            </select></span></td>
                    <td width="34%"></td>
                  </tr>
                  <tr>                
                     <td width="100%" colspan="2" valign="top">&nbsp;</td>
                  </tr>
                  <tr>
                    <td width="15%" nowrap><span class="REGULARTEXT">Online period</span></td>
                      <%  long onLineLifeCycle = UITransactionParadigmHelper.getLifeCycle(builder.getTransactionParadigm());
                          if (onLineLifeCycle == -1){
                            onLineLifeCycle = 1 * UITransactionParadigmHelper.DAY;
                          }
                          long onlineTimeUnit = UITransactionParadigmHelper.calculateTimeUnit(onLineLifeCycle);
                          String onlineLifeCycleStr = onlineTimeUnit == -1 ? "" : String.valueOf(onLineLifeCycle / onlineTimeUnit);                          
                          %>
                    <td width="33%"><input type="text" name="tranOnlineLifeCycle" size="5" value="<%=onlineLifeCycleStr%>"><span CLASS="REGULARTEXT">
                            <select size="1" CLASS="TEXTBOX" name="onlineLifeCycleTimeUnit">
                                <option value="<%=UITransactionParadigmHelper.SECOND%>" <%=onlineTimeUnit == UITransactionParadigmHelper.SECOND? "selected" : "" %> >seconds</option>
                                <option value="<%=UITransactionParadigmHelper.MINUTE%>" <%=onlineTimeUnit == UITransactionParadigmHelper.MINUTE? "selected" : "" %> >minutes</option>
                                <option value="<%=UITransactionParadigmHelper.HOUR%>" <%=onlineTimeUnit == UITransactionParadigmHelper.HOUR? "selected" : "" %>>hours</option>
                                <option value="<%=UITransactionParadigmHelper.DAY%>" <%=onlineTimeUnit == UITransactionParadigmHelper.DAY? "selected" : "" %>>days</option>
                            </select></span></td>
                    <td width="34%"></td>
                  </tr>
                </table>
                </td>
              </tr>
              <tr>
                <td width="3%" valign="top">
                </td>
                <td width="100%" colspan="2" valign="top">
                </td>
              </tr>
              <tr>
                <td width="3%" valign="top">
                </td>
                <td width="100%" colspan="2" valign="top">
                <span class="HEADER">Visual View</span>
                </td>
              </tr>
              <tr>
                <td width="3%" valign="top">
                </td>
                <td width="100%" colspan="2" valign="top">
                <p align="center"><img src="<%=BASE_DIRECTORY + imageDescriptor.getImageGraphURL()%>" USEMAP="#graphMap" border="0">
								<%=mappingStr%>
                </td>
              </tr>
              <tr>
                <td width="3%" valign="top">
                </td>
                <td width="100%" colspan="2" valign="top">
                </td>
              </tr>
              <tr>
                <td width="3%" valign="top">
                </td>
                <td width="100%" colspan="2" valign="top">
                <span class="HEADER"><a href="javascript:shownHideAdv('','tranAlertsDiv')">+/- Transaction Alerts</a></span>
                </td>
              </tr>
              
              <tr ><td width="3" valign="top" >
                </td>
                <td width="100%" colspan="1" valign="top" >    
                <div id="tranAlertsDiv"  style="display:none">
                
                	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      <tr><td colspan="2" style="padding-left:30" style="padding-top:10">
                      <table border="0" name="alertsTableTransaction" id="alertsTableTransaction" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <thead>
                      <tr>
                        <td width="18%" nowrap>&nbsp;<a href="javascript:goNew('transaction','0')" class="LINK">Add new Alert</a>
                           </td>
                        <td width="15%"></td>
                        <td width="20%" ></td>
                        <td width="3%"></td>
                      </tr>
                      <tr>
                        <td width="70%" bgcolor="#FFB13E"><span class="REGULARTEXT">Name</span></td>
                        <td width="15%" bgcolor="#FFB13E"><span class="REGULARTEXT">Type</span></td>
                        <td width="20%" bgcolor="#FFB13E">&nbsp;</td>
                        <td width="3%" bgcolor="#FFB13E"></td>
                      </tr>
                      </thead>
                      <tbody id="transactionAlertBody0" style="padding-top:5">
                      </tbody>
					</table>
					</table>
  
                </div>
                    </td>
                  </tr>
                 
              <tr>
                <td width="3%" valign="top">
                </td>
                <td width="100%" colspan="2" valign="top">
                </td>
              </tr>
               <tr>
                <td width="3%" valign="top">
                </td>
                <td width="100%" colspan="2" valign="top">
                </td>
              </tr>
              <tr>
                <td width="3%" valign="top">
                </td>
                <td width="100%" colspan="2" valign="top" style="padding-top:20">
                <span class="HEADER"><a href="javascript:shownHideAdv('','appNameDiv')">+/- Application Name</a></span>
                </td>
              </tr>
              
              <tr ><td width="3" valign="top" >
                </td>
                <td width="100%" colspan="1" valign="top" >    
                <div id="appNameDiv"  style="display:none">    
                    <% 
                      String appNameAtomicId = builder.getTransactionParadigm().getApplicationNameAtomicId();
                      int appNameDataIndex = builder.getTransactionParadigm().getApplicationNameAtomicDataIndex();
                      XpoLogAtomicParadigm appNameAtomic = appNameAtomicId == null ? null : (XpoLogAtomicParadigm)atomicConfig.getParadigmById(appNameAtomicId);
                    %>         
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      
                      <tr style="padding-left:20">
                        <td width="100"><span class="REGULARTEXT">Data Source</span></td>
                        <td width="*">
                        <span class="REGULARTEXT"><select size="1" name="appNameAtomicId" onChange="changeDSLists(this,'appNameList','');">
                        <option value="0" <%=appNameAtomic == null ? "selected" : ""%>>No Use</option>
                        <%for (int d = 0; d < dataSources.length ; d++){
                          String selected = "";                                
                          if (dataSources[d].getId().equals(appNameAtomicId)){
                            selected = "selected";
                          }
                          
                        %>
                            <option value="<%=dataSources[d].getId()%>" <%=selected%>><%=dataSources[d].getName()%></option>
                        <%}%>
                          </select></span>
						</td>
                      </tr>
                      <tr>               
                		<td colspan="2" valign="top">&nbsp;
                		</td>
             		 </tr>
                       <tr>
                          <td colspan="2" style="padding-left:20">
                          <select size="10" name="appNameList">
                             <% if (appNameAtomic != null){
                               LinearBrowsingManager lbm = appNameAtomic.getLbm();
                               xpolog.eye.data.RecordMask mask = lbm.getRecordMask();                              
                               for (int j = 0; j < mask.getCulomnsNumber(); j++){
                               String selected = "";                                
                               if (appNameDataIndex == j){
                                  selected = "selected";
                               }
                               %>
                               <option value="<%=String.valueOf(j)%>" <%=selected%>><%=mask.getMaskColumn(j).getName()%></option>
                             <% }%>
                            </select></td>                        
                             <% }else { %>
                             <option value="-1">No data to use</selected>
                             <% }%>
                            </select></td>
                        </tr>   
                        <tr>               
                		<td colspan="2" valign="top">&nbsp;
                		</td>
             		 </tr>          
                    </table>
                     </div>
                    </td>
                  </tr>               
                   <tr>
                <td width="3%" valign="top">
                </td>
                <td width="100%" colspan="2" valign="top">
                </td>
              </tr>
              <tr>
                <td width="3%" valign="top">
                </td>
                <td width="100%" colspan="2" valign="top">
                <span class="HEADER">Flow Definition</span>
                </td>
              </tr>
              
              <%
              int routineIndex = 0;
              String routineIndexStr;
              String edgeIndexStr = "";
              for(int i = 0; i < edges.length;i++){
              	edgeIndexStr = String.valueOf(i);
              	AtomicRoutineParadigm routineSource = null;
              	AtomicRoutineParadigm routineTarget = null;
              	RoutineEdgeParadigm edge = null;
              	XpoLogAtomicParadigm atomicSource = null;
              	XpoLogAtomicParadigm atomicTarget = null;
              	AtomicRoutineParadigm useRoutine = null;
              	XpoLogAtomicParadigm useAtomic = null;
           
              	if (i < edges.length){
             	  routineSource = (AtomicRoutineParadigm)edges[i].getSourceParadigm();
             	  routineTarget = (AtomicRoutineParadigm)edges[i].getTargetParadigm();
             	  edge = edges[i];
             	  atomicSource = (XpoLogAtomicParadigm)atomicConfig.getParadigmById(routineSource.getAtomicParadigmID());
             	  atomicTarget = (XpoLogAtomicParadigm)atomicConfig.getParadigmById(routineTarget.getAtomicParadigmID());
             	}
              	            	
              	
              %>
              
              <tr>
                <td width="3%" valign="top">
                </td>
                <td width="100%" colspan="2" valign="top">
                
                <table border="0" width="100%" cellpadding="0" cellspacing="0">
                <%if (i == 0) {
                  routineIndex = i;
                  routineIndexStr = String.valueOf(routineIndex);
                  useRoutine = routineSource;
                  useAtomic = atomicSource;
                %>
								                 
                   <%@ include file="routineGlobalView.jsp" %>
                      
                  
                  <%}                  
                  routineIndex = i+1;
                  routineIndexStr = String.valueOf(routineIndex);
                  useRoutine = routineTarget;
                  useAtomic = atomicTarget;
                  %>
                  <tr>
                    <td width="100%">&nbsp;</td>
                  </tr>
                  <a name="edge<%=edge.getId()%>"><!-- --></a>
                  <tr>
                    <td width="100%" bgcolor="#C0C0C0">
                      <table border=0" width="100%">
                        <tr>
                          <td width="33%" valign="top">
                            <table border="0" width="100%" cellspacing="0" cellpadding="0">
                              <tr>
                                <td width="33%"><span class="REGULARTEXT">Edge repeat</span></td>
                                <td width="67%"><input type="text" name="edgeRepeat<%=edgeIndexStr%>" size="8" value="<%=String.valueOf(edge.getEdgeRepeat())%>"></td>
                              </tr>
                              <tr>
                                <td width="33%"><span class="REGULARTEXT">Edge name</span></td>
                                <td width="67%"><input type="text" name="edgeName<%=edgeIndexStr%>" size="24" value="<%=edge.getName()%>"></td>
                              </tr>
                              <tr>
                                <td width="33%"><span class="REGULARTEXT">Life
                                  cycle</span></td>
                                  <%  long edgeLifeCycle = UITransactionParadigmHelper.getLifeCycle(edge);
                                      long edgeTimeUnit = UITransactionParadigmHelper.calculateTimeUnit(edgeLifeCycle);
                          			  String edgeLifeCycleStr = edgeTimeUnit == -1 ? "" : String.valueOf(edgeLifeCycle / edgeTimeUnit);
                         		  %>
                                <td width="67%"><input type="text" name="edgeLifeCycle<%=edgeIndexStr%>" size="5" value="<%=edgeLifeCycleStr%>">
                                  <span CLASS="REGULARTEXT"><select size="1" CLASS="TEXTBOX" name="edgeLifeCycleTimeUnit<%=edgeIndexStr%>">
                                <option value="<%=UITransactionParadigmHelper.SECOND%>" <%=edgeTimeUnit == UITransactionParadigmHelper.SECOND? "selected" : "" %> >seconds</option>
                                <option value="<%=UITransactionParadigmHelper.MINUTE%>" <%=edgeTimeUnit == UITransactionParadigmHelper.MINUTE? "selected" : "" %> >minutes</option>
                                <option value="<%=UITransactionParadigmHelper.HOUR%>" <%=edgeTimeUnit == UITransactionParadigmHelper.HOUR? "selected" : "" %>>hours</option>
                                <option value="<%=UITransactionParadigmHelper.DAY%>" <%=edgeTimeUnit == UITransactionParadigmHelper.DAY? "selected" : "" %>>days</option>
                            </select></span></td>
                              </tr>
                            </table>
                          </td>
                          <td width="33%" valign="top">
                            <table border="0" width="100%" cellspacing="0" cellpadding="0">
                              <tr>
                                <td width="37%"><span class="REGULARTEXT">Description</span></td>
                                <td width="63%" valign="top"><input type="text" name="edgeDesc<%=edgeIndexStr%>" size="23" value="<%=edge.getDescription()%>"></td>
                              </tr>                              
                              <tr>
                                <td width="37%">&nbsp;</td>
                                <td width="63%" valign="top">&nbsp;</td>
                              </tr>
                            </table>
                          </td>
                          <td width="34%" valign="top">
                            <table border="0" width="100%" cellspacing="0" cellpadding="0">
                              <tr>
                                <td width="50%">&nbsp;</td>
                                <td width="50%">
                                  <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                    <tr>
                                      <td width="33%"></td>
                                      <td width="33%"></td>
                                      <td width="34%">
                                        <p align="right"><span class="REGULARTEXT"></span></td>
                                    </tr>
                                  </table>
                                </td>
                              </tr>
                              <tr>
                                <td width="50%">&nbsp;</td>
                                <td width="50%">&nbsp;</td>
                              </tr>
                            </table>
                          </td>
                        </tr>
                      </table>
                      
                      

				<table border="0" width="100%" cellspacing="0" cellpadding="0">
                 <tr>
                   <td>

                      <table border="0" width="100%" cellspacing="0" cellpadding="5">
                        <tr>
                          <td width="20%" nowrap height="20"><span class="REGULARTEXT">Function
                            <select size="1" name="D4">
                              <option>Equals</option>
                            </select>&nbsp;</span></td>
                          <td width="*" height="20" colspan="4">&nbsp;</td>
                        </tr>
                        
                        <tr>
                          <td width="20%" nowrap height="20" align="center"><select size="10" name="sourceList<%=edgeIndexStr%>" <%=isView ? "disabled" : "" %>  multiple>
                             <%
                              xpolog.eye.data.RecordMask sourceMask = null;
                              xpolog.eye.data.RecordMask targetMask = null;
                              if (atomicSource != null){
                               LinearBrowsingManager lbm = atomicSource.getLbm();
                               sourceMask = lbm.getRecordMask();
                               int [] indexes = UITransactionParadigmHelper.getSourceColumnIndexes(edge);
															 int index = indexes != null && indexes.length > 0 ? indexes[0] : -1;
                               for (int j = 0; j < sourceMask.getCulomnsNumber(); j++){
                               String selected = "";                                
                               if (index == j){
                                  selected = "selected";
                               }
                               %>
                               <option value="<%=String.valueOf(j)%>" <%=selected%>><%=sourceMask.getMaskColumn(j).getName()%></option>
                             <% }
                              }%>
                            </select></td>
                          <td width="20%" height="20" align="center"><select size="10" name="targetList<%=edgeIndexStr%>" <%=isView ? "disabled" : "" %>  multiple>
                               <% if (atomicTarget != null){
                               LinearBrowsingManager lbm = atomicTarget.getLbm();
                               targetMask = lbm.getRecordMask();                               
															 int [] indexes = UITransactionParadigmHelper.getTargetColumnIndexes(edge);
															 int index = indexes != null && indexes.length > 0 ? indexes[0] : -1;
                               for (int j = 0; j < targetMask.getCulomnsNumber(); j++){
                               String selected = "";                                
                               if (index == j){
                                  selected = "selected";
                               }
                               %>
                               <option value="<%=String.valueOf(j)%>" <%=selected%>><%=targetMask.getMaskColumn(j).getName()%></option>
                             <% }
                             }  else { %>
                             <option value=""">No data to use</selected>
                             <% }%> 
                            
                            </select></td>
                            <td width="20" height="20" align="center">
                            	<table border="0" width="30" height="30" cellspacing="0" cellpadding="5">
                        				<tr><td width="20" align="center">
                        					<%if (!isView){%><a class="LINK" href="javascript:addToFunctionList(<%=edgeIndexStr%>)" class="LINK"><%}%>add<%if (!isView){%></a><%}%>
                        				</td></tr>  
                        				<tr><td width="20" align="center">
                        					<%if (!isView){%><a class="LINK" href="javascript:removeFromFunctionList(<%=edgeIndexStr%>)"><%}%>remove<%if (!isView){%></a><%}%>
                        				</td></tr> 
                        				</table>                      				
                            </td>
                            <td width="20%" height="20" align="left"><select size="10" name="functionList<%=edgeIndexStr%>" multiple onChange="updateSourceTargetFunction(<%=edgeIndexStr%>);">
                               <% if (atomicTarget != null){
                              
                               int [] sourceIndexes = UITransactionParadigmHelper.getSourceColumnIndexes(edge);
                               int [] targetIndexes = UITransactionParadigmHelper.getTargetColumnIndexes(edge);
                               for (int j = 0; j < sourceIndexes.length; j++){
                               String selected = "";  
															 if (j == 0){
															   selected = "selected";
															 }
                               String resultName = sourceIndexes[j] >= 0 ? sourceMask.getMaskColumn(sourceIndexes[j]).getName() : targetMask.getMaskColumn(targetIndexes[j]).getName();
                               %>
                               <option value="<%=String.valueOf(sourceIndexes[j]) + "," + String.valueOf(targetIndexes[j])%>" <%=selected%>><%=resultName%></option>
                             <%} } else { %>
                             <option value=""">No data to use</selected>
                             <% }%>                            
                            </select></td>
                            <td width="*">
                  				  <table border="0" width="100%" height="50" cellspacing="0" cellpadding="5">
                   					<%
				                     if (!isView){
        				            %>
                				    <tr><td align="left">
				        	           <span class="REGULARTEXT"><a c ass="LINK" href="javascript:removeEdge('<%=edgeIndexStr%>')">Remove Edge</a></span>
        				  	        </td></tr>
                   					<% }%>
                    				<%
				                     if (!isView && !builder.isEmptyNewEdge(edge)){
        			               RoutineParadigm [] newRoutines = builder.getRoutinesPerEdge(edge);
              				      %>
                      		  <tr><td align="left">
					                   <span class="REGULARTEXT"><a href="javascript:addNewEdge('<%=edgeIndexStr%>')">Add</a> new edge to </span>&nbsp;                   
          					         <select size="1" name="newEdge<%=edgeIndexStr%>" >
					                   <option value="new" selected>new routine</option>
          					         <% for (int r = 0; r < newRoutines.length; r++) {
															%>
				                     <option value="<%=newRoutines[r].getId()%>"><%=newRoutines[r].getName()%></option>                 
        				            <% }%>
                					   </select>
					                  </td></tr>
          					        <% }%>
					                  <% 
          				           RoutineEdgeParadigm [] neighbors = builder.getEdgeNeighbors(edge);
                  				   if (neighbors.length > 0){%>
					                  <tr><td align="left">                   
          					         <span class="REGULARTEXT"><a href="javascript:changeEdge('<%=edgeIndexStr%>')">Change</a> edge to </span>&nbsp;&nbsp;
					                   <select size="1" name="changeEdge<%=edgeIndexStr%>" >
          					         <% for (int n = 0 ; n < neighbors.length;n++){%>
						                  <option value="<%=neighbors[n].getId()%>"><%=neighbors[n].getName()%></option>                   
            				       <% } %>
					                   </select>
          					        </td></tr>
				                   <% } %>
        			      	     </table>
              			  	   </td>
                        </tr>
                      </table>
                      
                     </td>
                   </tr></table>
                     
                      
                      
                      
                      
                      
                      <table border="0" width="100%">
                        <tr>
                          <td width="100%" valign="top">&nbsp;<span class="HEADER"><a href="javascript:shownHideAdv('','edgeAlertsDiv<%=edgeIndexStr%>')">+/- Alerts</a></span></td>
                        </tr>
                        <tr >
                </td>
                <td width="100%" colspan="1" valign="top" >    
                <div id="edgeAlertsDiv<%=edgeIndexStr%>"  style="display:none">  
					
					<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      <tr><td colspan="2" style="padding-left:30" style="padding-top:10">
                      <table border="0" name="alertsTable<%=edgeIndexStr%>" id="alertsTable<%=edgeIndexStr%>" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <thead>
                      <tr>
                        <td width="18%" nowrap>&nbsp;<a href="javascript:goNew('edges', <%=edgeIndexStr%>)" class="LINK">Add new Alert</a>
                           </td>
                        <td width="15%"></td>
                        <td width="20%" ></td>
                        <td width="3%"></td>
                      </tr>
                      <tr>
                        <td width="60%" bgcolor="#FFB13E"><span class="REGULARTEXT">Name</span></td>
                        <td width="15%" bgcolor="#FFB13E"><span class="REGULARTEXT">Type</span></td>
                        <td width="20%" bgcolor="#FFB13E">&nbsp;</td>
                        <td width="3%" bgcolor="#FFB13E"></td>
                      </tr>
                      </thead>
                      <tbody id="edgesAlertBody<%=edgeIndexStr%>" style="padding-top:5">
                      </tbody>
					</table>
					</table>
					
               </div>
                    </td>
                  </tr>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td width="100%">&nbsp;</td>
                  </tr>
				<%@ include file="routineGlobalView.jsp" %>
                 

                </table>
                </td>
              </tr>
              
              
              
              <%}%>
              
              <%
                     if (!isView){
                       RoutineParadigm [] newRoutines = builder.getRoutinesPerEdge(edges.length > 0 ? edges[edges.length - 1] : null);
                    %>
               <tr>
               <td width="100%" colspan="2" valign="top">
              <table border="0" width="100%" height="20" cellspacing="0" cellpadding="5">
                    
                        <tr><td align="right">
                   <span class="REGULARTEXT"><a href="javascript:addNewEdge('')">Add</a> new edge to </span>&nbsp;                   
                   <select size="1" name="newEdge" >
                   <option value="new" selected>new routine</option>
                   <% for (int r = 0; r < newRoutines.length; r++) {
										%>
                     <option value="<%=newRoutines[r].getId()%>"><%=newRoutines[r].getName()%></option>                 
                    <% }%>
                   </select>
                   </td></tr>
                             
                   </table>
                   </td>
              </tr>
               <% }%>       
              
              
              <tr>
                <td width="3%" valign="top">
                </td>
                <td width="100%" colspan="2" valign="top">
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>                            
          
          
          
          <tr>
            <td width="100%">
           
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="35%">&nbsp;</td>
                    <td width="11%" align="center">&nbsp;</td>
                    <td width="7%" align="center">
                     &nbsp;</td>
                                          <td width="27%">&nbsp;</td>
                    <td width="20%">&nbsp;</td>
                  </tr>
                </table>
              
            </td>
          </tr>
          
            <tr>
                    <td width="100%">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber17">
                      <tr>
                        <td width="40%">&nbsp;</td>
                        <td width="11%">
                        <p align="center"><a href="transactionAdmin.jsp" class="LINK">cancel</a></td>
                        <%if (!isView){%>
                        <td width="10%"><a href="javascript:doUpdate()" class="LINK">update</a></td>
                        <%}%>        
                        <td width="16%"><a href="javascript:doSave()" class="LINK">save</a></td>
                        <td width="18%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr> 
         
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">

        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
<div id="newTemplateDiv" style="position:absolute;visibility:hidden;height:80">
<input type="hidden" id="newTemplateId" name="newTemplateId" value="" >
 <table border="0" width="350" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:1px solid #000000">
  <tr height="10"><td align="center" style="background:blue;color:white">
	<span class=REGULARTEXT" >New Template</span>
		</td>
	</tr>
	<tr><td>
		<table border="0"  cellspacing="1" cellpadding="0">
     <tr>
      <td width="100" nowrap style="padding-left:10;padding-top:10"><span class="REGULARTEXT">Template Name</span></td>
      <td width="200" style="padding-left:10;padding-top:10;padding-right:10"><input class="TEXTBOX" type="text" id="newTemplateName" name="newTemplateName" size="23" value=""></td>
      <td width="*"></td>
     </tr>                            
    </table>
	</td></tr>
	<tr height="20"><td align="center" style="padding:5">
		<a class="LINK" href="javascript:hideLayer('newTemplateDiv');">cancel</a>&nbsp;
		<a class="LINK" href="javascript:doTemplateSave();">save</a>&nbsp;		  	
	</td>
	</tr>
 </table>
 </div>

</form>
<iframe name="dataResultFrame"  onload="javascript:dataLoaded();"  style="visibility:hidden" width="1" height="1"></iframe>
<script>
var selectedImageComboId;
var selectedImageType;
var selectedImageId;
function showImageSettingsDiv(id,imageComboId,imageType,imageId){ 
  buildUploadImageDiv(); 
  selectedImageComboId = imageComboId;
  selectedImageType = imageType;
  selectedImageId = imageId;
  document.getElementById("propertyName").value = "";
  var x = -1;
  var y = -1;
  if (id && id != ""){
    var comp = document.getElementById(id);
    var d = document.getElementById("imageSettingsDiv");
    x = findPosX(comp) + 100;
    y = findPosY(comp) - d.clientHeight;
  }
  showHideLayerInMiddle("imageSettingsDiv",x,y);
  if (d.style.visibility == ""){    
    document.getElementById("archiveFile").focus();
  }
}

function doImageSave(){
   document.getElementById("imageSettingsDiv").style.cursor = "wait";
   var propertyName = document.getElementById("propertyName").value;
   var propertyValue = document.getElementById("propertyValue").value;
   var propertyId = document.getElementById("propertyId").value;
   var archivePath = document.getElementById("archiveFile").value;
   document.imageForm.action = "../ui/images/propertyImageAction.jsp?propertyName=" + propertyName + "&propertyValue=" + propertyValue + "&propertyId=" + propertyId + "&archivePath=" + archivePath;
   document.imageForm.submit();
}

function updateImageInfo(){
   var path = document.getElementById("archivePath").value;
   if(!path || path == ""){
      return;
   }
   
   index = path.lastIndexOf("/");
   if(index < 0){
     index = path.lastIndexOf("\\");
   }
 
   imagePath = path.substring(index+1,path.length);
   var propertyValue = document.getElementById("propertyValue").value;
   var propertyName = document.getElementById("propertyName").value;
   if (!propertyValue || propertyValue == ""){
     document.getElementById("propertyValue").value = imagePath;
   }
   name = imagePath;
   index = name.indexOf(".");
   if (index >= 0){
     name = name.substring(0,index);
   }
   if (!propertyName || propertyName == ""){
     document.getElementById("propertyName").value = name;
   }
}

function imageLoaded(){  
  var propertyId = frames['imageResultFrame'].propertyId;
  var propertyName = frames['imageResultFrame'].propertyName;
  var propertyURL = frames['imageResultFrame'].propertyURL;
  if (propertyId && propertyId != ""){
    globalImages[globalImages.length] = new LogicImage(propertyId , propertyName, propertyURL);
    updateImagesLists();
    if (selectedImageComboId){
      selectImageById(selectedImageComboId,selectedImageType,selectedImageId,propertyId);
    }
  }
  document.getElementById("imageSettingsDiv").style.cursor = "default";
  if (document.getElementById("imageSettingsDiv").style.visibility == ""){
    hideLayer('imageSettingsDiv');
  }
}

function buildUploadImageDiv(){
  document.getElementById("archiveFileDiv").innerHTML = "<input class=\"TEXTBOX\" type=\"file\" id=\"archiveFile\" name=\"archivePath\" size=\"30\" onChange=\"javascript:updateImageInfo()\">";
}

</script>
<div id="imageSettingsDiv" style="position:absolute;visibility:hidden;height:80">
<input type="hidden" name="propertyId" value="" >
<input type="hidden" name="propertyValue" value="" >
 <table border="0" width="350" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:1px solid #000000">
  <tr height="10"><td align="center" style="background:blue;color:white">
	<span class=REGULARTEXT" >Image Settings</span>
		</td>
	</tr>
	<tr><td>
		<table border="0"  cellspacing="1" cellpadding="0">
     <tr>
      <td width="100" nowrap style="padding-left:10;padding-top:10"><span class="REGULARTEXT">Image Name</span></td>
      <td width="200" style="padding-left:10;padding-top:10;padding-right:10"><input class="TEXTBOX" type="text" name="propertyName" size="23" value=""></td>
      <td width="*"></td>
     </tr>                  
      <form AUTOCOMPLETE="OFF" name="imageForm" id="imageForm" method="post" ENCTYPE="multipart/form-data" target="imageResultFrame">
     <tr>
       <td width="120" style="padding-left:10;padding-top:10" nowrap><span class="REGULARTEXT">Image upload</span></td>
       <td width="200" style="padding-left:10;padding-top:10;padding-right:10">
		<div id="archiveFileDiv">
	
       </div></td>
       <td width="*"></td>
    </tr>
     </form>             
    </table>
	</td></tr>
	<tr height="20"><td align="center" style="padding:5">
		<a class="LINK" href="javascript:hideLayer('imageSettingsDiv');">cancel</a>&nbsp;
		<a class="LINK" href="javascript:doImageSave();">save</a>&nbsp;		  	
	</td>
	</tr>
 </table>
 </div>
 
 <iframe id="imageResultFrame" name="imageResultFrame"   onload="javascript:imageLoaded();"  style="visibility:hidden" width="0" height="0"></iframe>
 <iframe id="newTemplateFrame" name="newTemplateFrame"   onload="javascript:templateCreated();"  style="visibility:hidden" width="0" height="0"></iframe>


	<form AUTOCOMPLETE="OFF" name="addFilter" action="<%=BASE_DIRECTORY%>logic/online/TransactionFilter.jsp" target="filtersWindow">
		<input type="hidden" name="ds_id">
		<input type="hidden" name="elem_id">
		<input type="hidden" name="new_window" value="y">
	</form>
	
	<div id="templateBoxDiv" name="templateBoxDiv" style="display:none">
					 
					 <select class="TEXTBOX" size="1" name="templateId[ID]" id="templateId[ID]" style="padding-top:20" onchange="javascript:loadTemplateData('ID')">
                        <option value="">--- Select template ---</option>
                        <%
                        	String accselected = "selected";
                            String accunselected = "";
                            String toGo = accunselected;
                            Media med = null;
                            
                            for(int i=0;i<list.size();++i){
                            	med = (Media)list.get(i);
                            	//if(from != null && acc.getId().equals(from.getId())){
                            	//		toGo = accselected;
                            	//	}else{
                            	//		toGo = accunselected;
                            	//	} 
                        %>
                               <option <%=toGo%> value="<%=med == null ? "" : med.getId()%>"><%=med.getMediaName()%></option>                      
                        <%
                        	}
                        %></select>
                        <%
                        if (user == null || user.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){
                        %>
                        <span class="SMALLTEXT"><a href="javascript:createNewTemplate('ID');" class="LINK">Save as</a></span>
                        <%}%>

						&nbsp;
						&nbsp;
						&nbsp;
						&nbsp;
						<span class="REGULARTEXT">Action type</span>
						<select class="TEXTBOX" size="1" name="AlertType[ID]" id="AlertType[ID]" style="padding-top:20" onchange="javascript:presentTempaltesByType()">
                                <option value="Email">Email</option>
                                <!--<option value="Ftp">Ftp</option>
                                <option value="Ssh">Ssh</option>-->
                        </select>
                        &nbsp;
						&nbsp;
						<span class="REGULARTEXT">Alert type</span>
						<select class="TEXTBOX" size="1" name="AlertTypeKey[ID]" id="AlertTypeKey[ID]" style="padding-top:20" onchange="javascript:presentTempaltesByType()">
                                <option value="<%=UITransactionParadigmHelper.ROUTINE_LF_STATUS_KEY%>">Life Cycle</option>
                                <!--<option value="FtpMedia">Ftp</option>
                                <option value="SshMedia">Ssh</option>-->
                        </select>
				</div>
			 <tr>
			  <td width="16%">&nbsp;</td>
                          <td width="50%"></td>
                          <td width="24%"></td>
                         <td width="10%"></td>
             </tr>
             <tr><td>
              <div id="emailAlertDiv" name="emailAlertDiv" style="display:none">
               	<table>		 
               		  <tr style="padding-left:20">
                        <td width="11%"><span class="REGULARTEXT">From</span></td>
                        <td width="89%">
                        <input class="TEXTBOX" type="text" id="from[ID]" name="from[ID]" size="50" value=""></td>
                      </tr>
                      <tr style="padding-left:20">
                        <td width="11%"><span class="REGULARTEXT">To</font></td>
                        <td width="89%">
                        <input class="TEXTBOX"type="text" id="to[ID]" name="to[ID]" size="50" value=""></td>
                      </tr>
                      <tr style="padding-left:20">
                        <td width="11%"><span class="REGULARTEXT">Subject&nbsp;</span></td>
                        <td width="89%">
                        <input class="TEXTBOX" type="text" id="subject[ID]" name="subject[ID]" size="50" value=""></td>
                      </tr>
                      <tr style="padding-left:20">
                        <td width="11%">&nbsp;</td>
                        <td width="89%">
                        &nbsp;</td>
                      </tr>
                      <tr style="padding-left:20">
                        <td width="11%" valign="top"><span class="REGULARTEXT">Message&nbsp;</span></td>
                        <td width="89%">
                        <textarea class="TEXTBOX" rows="4" id="message[ID]" name="message[ID]" cols="60" ></textarea></td>
                      </tr> 
                      <tr>
                        <td colspan="2">
                          &nbsp;
                        </td>
                      </tr>
                         <!--<tr>
                         <td width="11%" valign="top"><span class="REGULARTEXT">Use Text Fields&nbsp;</span></td>
                        <td width="89%" colspan="2">
                          <input type="checkBox" name="mailAlert[ID]" id="mailAlert[ID]" value="on"><span class="SMALLTEXT">&nbsp;&nbsp;When checked Xpologic will
                          use the values edited in fields, when unchecked XpoLogic will use Template values</span>
                        </td>
                      </tr>-->
			  </div>
</body>

</html>