<%@ page import="xpolog.eye.data.RecordMask"%>
<%@ page import="xpolog.eye.LinearBrowsingManager"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.LogBrowsingManager"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.data.filters.DateFilter"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.data.filters.FilterManager"%>
<%@ page import="xpolog.eye.data.filters.NumberFilter"%>
<%@ page import="xpolog.eye.data.filters.PriorityFilter"%>
<%@ page import="xpolog.eye.data.filters.StringFilter"%>
<%@ page import="xpolog.eye.data.masks.MaskColumn"%>
<%@ page import="xpolog.logic.atomic.data.XpoLogAtomicParadigm"%>
<%@ page import="xpolog.logic.common.NodeModelParadigm"%>
<%@ page import="xpolog.logic.filters.AtomicDataFilter"%>
<%@ page import="xpolog.logic.functions.NodeFunctionEdge"%>
<%@ page import="xpolog.logic.functions.RoutineFunctionEdge"%>
<%@ page import="xpolog.logic.functions.transform.TransactionTableModelTransformFunction"%>
<%@ page import="xpolog.logic.routine.data.AtomicRoutineParadigm"%>
<%@ page import="xpolog.logic.routine.data.RoutineParadigm"%>
<%@ page import="xpolog.logic.transaction.data.TransactionParadigm"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmBuilder"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmHelper"%>

<%@ page import="java.text.SimpleDateFormat"%>
<%@ page import="java.util.Date"%>
<%@ page import="java.util.List"%>

<%!
  String dateFormat = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
  String millisecondsSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator",".");
  String dateFormatMS = dateFormat+millisecondsSeperator+"SSS";
  boolean showHealth = Configuration.getInstance().getPropertiesManager().getProperty("log.filter.showHealthSettings","false").equals("true");

  public String transformDateToString(Date d,long timeDiff){
    if(d == null){
      return null;
    }
    if (timeDiff != 0){
       long time = d.getTime();
    	 d = ((Date)d.clone());
    	 d.setTime(time + timeDiff); 
    }
    //01/31/2003 01:42:34
    String format = "";
    if (d.getTime() % 1000 == 0){
	    format = dateFormat;
    } else {
	    format = dateFormatMS;
    }
    String str = new SimpleDateFormat(format).format(d);
    return str;
  }
%>

<%

String TRAN_PARADIGM_BUILDER = "TRAN_PARADIGM_BUILDER";

String nodeId = request.getParameter("nodeId");
String nodeType = request.getParameter("nodeType");
String dataFilterId = request.getParameter("dataFilterId");
String isViewStr = request.getParameter("isView");
boolean isView = isViewStr != null && isViewStr.equals("true");

UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute(TRAN_PARADIGM_BUILDER);
NodeModelParadigm node = null;
if(nodeType.equals("subTransaction")) {
	node = builder.getTransactionById(nodeId);
}else if(nodeType.equals("routine")) {
	node = builder.getRoutineById(nodeId);
}

String STRING_FILTER = "StringFilter";
String PRIORITY_FILTER = "PriorityFilter";
String DATE_FILTER = "DateFilter";
String CHOICE_FILTER = "ChoiceFilter";
String MULTI_FILTER = "MultiFilter";
String NUMBER_FILTER = "NumberFilter";

XpoLogAtomicParadigm atomic = builder.getAtomicByRoutineId(nodeId);
String lbmId = null;
if (atomic != null){
	if (atomic.getDateSource() != null){
		lbmId = atomic.getDateSource().getLbmId();
	}else{
		lbmId = atomic.getDataSourceId();
	}
}
LogBrowsingManager lbm = null;
if (lbmId != null){
	lbm = SiteManagment.getInstance().getLogBrowserManager(lbmId);
}
RecordMask mask = lbm != null ? lbm.getRecordMask() : null;

String filterName = "";
FilterCollection filterCollection = builder.getRoutineFilter((RoutineParadigm)node,dataFilterId);
AtomicDataFilter transFilter = null;
if (filterCollection != null && filterCollection.getFilters().size() > 0){
	transFilter = (AtomicDataFilter)filterCollection.getFilters().get(0);
}
FilterCollection fc = null;
if (transFilter.getRecordFilter() != null){
	FilterManager filterMgr = (FilterManager)transFilter.getRecordFilter();
	if (filterMgr != null){
    List list = filterMgr.getFilterCollections();
    if (!list.isEmpty()){
    	fc = (FilterCollection)list.get(0);
    	filterName = filterCollection.getName();
    }
		
	}
}

List priorityFilters = fc != null ? fc.getByName(PRIORITY_FILTER) : null;
List dateFilters = fc != null ? fc.getByName(DATE_FILTER) : null;
List choiceFilters = fc != null ? fc.getByName(CHOICE_FILTER) : null;
List numberFilters = fc != null ? fc.getByName(NUMBER_FILTER) : null;
List stringFilters = fc != null ? fc.getByName(STRING_FILTER) : null;
DateFilter datefl = null;

Date minDate = null;
Date maxDate = null;
String minDateStr = "";
String maxDateStr = "";
String minStat = "";
String maxStat = "";
String timeunit = "";
String isTimeLim = "";
String daystatsel = "";
String minstatsel = "";
String hourstatsel = "selected";
String weekstatsel = "";
String monthstatsel = "";
boolean isLast = true;

if(fc.getByName(DATE_FILTER) != null && fc.getByName(DATE_FILTER).size() > 0){
  datefl = (DateFilter)fc.getByName(DATE_FILTER).get(0);
  if(datefl.getTimeType() == -1){
    minDate = datefl.getMinDate();
    maxDate = datefl.getMaxDate();      
  }else{
    hourstatsel = "";
    isLast = datefl.isLastOpType();
    isTimeLim = "checked";
    timeunit = String.valueOf(datefl.getTimeGap());
    if(datefl.isMonths()){
      monthstatsel = "selected";
    } else if(datefl.isWeeks()){
      weekstatsel = "selected";
    } else if(datefl.isDays()){
      daystatsel = "selected";      
    }else if(datefl.isHours()){
      hourstatsel = "selected";
    }else if(datefl.isMinutes()){
      minstatsel = "selected";
    }else {
      hourstatsel = "selected";
    }
  }
}

if(minDate == null){
  minDate = new Date();
  long t = minDate.getTime();
  minDate.setTime(t-(t%1000));
}else{
  minStat = "checked";
}

if(maxDate == null){
 maxDate = new Date();
  long t = maxDate.getTime();
  maxDate.setTime(t-(t%1000));
}else{
  maxStat = "checked";
}
minDateStr = transformDateToString(minDate,0);
maxDateStr = transformDateToString(maxDate,0);


%>
<%@page import="xpolog.eye.data.filters.ChoiceFilter"%>
<table border="0" cellspacing="0" cellpadding="0" style="padding-left:20">
	<tr height="10">
	    <%
	      if(priorityFilters != null && priorityFilters.size() == 1){
      		PriorityFilter f = (PriorityFilter)priorityFilters.get(0);
	      	StringBuffer sb = new StringBuffer();
	      	String[] values = f.getValues();
	      	for (int i=0; i<values.length; i++){
	      		if (i > 0){
	      			sb.append(", ");
	      		}
	      		sb.append(values[i]);
	      	}
	    %>
	  <td valign="top">
	  	<nobr>
	  	<table border="0" cellspacing="0" cellpadding="0" style="padding-left:5">
	      <tr>
	        <td><span class="FILTERS_LIST_HEADER">Priorities</span></td>
	      </tr>
	      <tr>
	        <td><span class="NODE_TEXT"><%=sb.toString()%></span></td>
	      </tr>
	      <tr style="font-size:3"><td>&nbsp;</td></tr>
	    </table>
	    </nobr>
	  </td>  
	     <%
	     	 }
	     %>
	
	     <%if(datefl != null){%>
	  <td valign="top">
	  	<nobr>
	  	<table border="0" cellspacing="0" cellpadding="0" style="padding-left:5">
	      <tr>
	        <td><span class="FILTERS_LIST_HEADER">Date and Time</span></td>
	      </tr>
	      <%if (isTimeLim.equals("")){%>
				<tr>
					<td width="100%">
						<table cellspacing="0" cellpadding="0" border="0" width="100%">
							<tr>
								<td><span class="NODE_TEXT">show records that arrive <b>after</b>&nbsp;
								<%=minDateStr%>
								</span>
								</td>
							</tr>
							<tr>
								<td><span class="NODE_TEXT">show records that arrive <b>before</b>&nbsp;
								<%=maxDateStr%>
								</span>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<%}else{%>
				<tr>
					<td width="100%">
						<span class="NODE_TEXT">show records from the <%=isLast?"last":"previous"%> <%=timeunit%>
							<%if (minstatsel.length() > 0){%>minutes
							<%}else if (hourstatsel.length() > 0){%>hours
							<%}else if (daystatsel.length() > 0){%>days
							<%}else if (weekstatsel.length() > 0){%>weeks
							<%}else if (monthstatsel.length() > 0){%>months
							<%}else{%>&nbsp;<%}%>
						</span>
					</td>
				</tr>
	      <%}%>
	      <tr style="font-size:3"><td>&nbsp;</td></tr>
	    </table>
	    </nobr>
	  </td>
	      <%}%>
	      
	    <%
	      if(choiceFilters != null){
	    %>
	  <td valign="top">
	  	<nobr>
	  	<table border="0" cellspacing="0" cellpadding="0" style="padding-left:5">
	  	<%
    	for (int i=0; i<choiceFilters.size(); i++){
    		ChoiceFilter f = (ChoiceFilter)choiceFilters.get(i);
    		if (f == null){
    			continue;
    		}
    		int ind = f.getColInd();
    		String name = mask.getMaskColumn(ind).getName();
    		List selectedValues = f.getFilteredValues();
    		if (selectedValues == null || selectedValues.size() == 0){
    			continue;
    		}
    		StringBuffer sb = new StringBuffer();
	  		for (int j=0; j<selectedValues.size(); j++){
	  			if (j > 0){
	  				sb.append(",");
	  			}
	  			sb.append(selectedValues.get(j).toString());
	  		}
	  	%>
	  		<tr><td><span class="FILTERS_LIST_HEADER"><%=name%></span></td></tr>
	  	<%for (int j=0; j<selectedValues.size(); j++){%>
				<tr><td><span class="NODE_TEXT"><%=selectedValues.get(j).toString()%></span></td></tr>
			<%}%>
			<%}%>	  	
	    </table>
	    </nobr>
	  </td>  
	     <%
	     	 }
	     %>


	      <%
	     	 if(mask != null && numberFilters != null && numberFilters.size() > 0){
	      %>
	  <td valign="top">
	  	<nobr>
	  	<table border="0" cellspacing="0" cellpadding="0" style="padding-left:5">
	      <tr>
	        <td><span class="FILTERS_LIST_HEADER">Number</span></td>
	      </tr>
	      <%
				for (int i=0; i<numberFilters.size(); i++){
					NumberFilter f = (NumberFilter)numberFilters.get(i);
					int ind = f.getColInd();
					MaskColumn col = mask.getMaskColumn(ind);
					if (col == null){
						continue;
					}
					String name = col.getName();
					String operation = f.getOperation();
					String value = f.getStringValue();
				%>
	      <tr>
	        <td><span class="NODE_TEXT"><%=name %> <%=operation %> <%=value %></span></td>
	      </tr>
				<%}%>
	      <tr style="font-size:3"><td>&nbsp;</td></tr>
	    </table>
	    </nobr>
	  </td>
	      <%}%>
	      
	      <%if (stringFilters != null && stringFilters.size() > 0){
	      	StringFilter fl = (StringFilter)stringFilters.get(0);
      		boolean allColumns = fl.isForAllColumns();
      		int[] selectedCols = fl.getColumnsIndexes();
		      String colsDesc = "";
	     		if (allColumns){
      			colsDesc = "all columns";
      		}else{
      			StringBuffer colsDescBuffer = new StringBuffer();
      			String colName = null;
      			for (int j=0; j<selectedCols.length; j++){
      				MaskColumn col = mask.getMaskColumn(selectedCols[j]);
      				if (col == null){
      					continue;
      				}else{
      					colName = col.getName();
      					if (colsDescBuffer.length() > 0){
      						colsDescBuffer.append(",");
      					}
      					colsDescBuffer.append(colName);
      				}
      			}
      			colsDesc = colsDescBuffer.toString();
      			colsDesc = "columns : " + colsDesc;
      		}

	      %>
	  <td valign="top">
	  	<nobr>
	  	<table border="0" cellspacing="0" cellpadding="0">
	      <tr>
	        <td><span class="FILTERS_LIST_HEADER">Text (<%=colsDesc%>)</span></td>
	      </tr>
	      <%
	      	for (int i=0; i<stringFilters.size(); i++){
	      		StringFilter f = (StringFilter)stringFilters.get(i);
	      		String operation = f.getOperation();
	      		String value = f.getValue();
	      		value = value.replaceAll("\"", "&quot;");
	      		boolean caseSensitive = f.isCaseSensitive();
	      		boolean regExp = f.isRegExp();
	      		boolean isMatchWholeWords = f.isMatchWholeWords();
	      		String abb = "";
	      		String comma = "";
	      		if (regExp){
	      			abb = "regExp";
	      			comma = ", ";
	      		}
	      		if (caseSensitive){
	      			abb += comma + "case sensitive";
	      		}
	      		if (abb.length() > 0){
		      		abb = "(" + abb + ")";
	      		}
	      %>
	      <tr>
	      	<td><span class="NODE_TEXT"><%=operation%> <%=value%> <%=abb %></span></td>
	      </tr>
	      <%}%>
	    </table>
	    </nobr>
	  </td>
	      <%}%>
	  <td width="*">&nbsp;</td>
	</tr>
</table>