<%@ page import="xpolog.eye.data.RecordMask"%>
<%@ page import="xpolog.eye.LinearBrowsingManager"%>

<%@ page import="xpolog.logic.atomic.data.XpoLogAtomicParadigm"%>
<%@ page import="xpolog.logic.common.NodeModelParadigm"%>
<%@ page import="xpolog.logic.functions.NodeFunctionEdge"%>
<%@ page import="xpolog.logic.functions.RoutineFunctionEdge"%>
<%@ page import="xpolog.logic.routine.data.AtomicRoutineParadigm"%>
<%@ page import="xpolog.logic.routine.data.RoutineParadigm"%>
<%@ page import="xpolog.logic.transaction.data.TransactionParadigm"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmBuilder"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmHelper"%>

<%

String TRAN_PARADIGM_BUILDER = "TRAN_PARADIGM_BUILDER";

String nodeId = request.getParameter("nodeId");
String nodeType = request.getParameter("nodeType");
String functionId = request.getParameter("functionId");
String isViewStr = request.getParameter("isView");
boolean isView = isViewStr != null && isViewStr.equals("true");

UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute(TRAN_PARADIGM_BUILDER);
NodeModelParadigm node = null;
if(nodeType.equals("subTransaction")) {
	node = builder.getTransactionById(nodeId);
}else if(nodeType.equals("routine")) {
	node = builder.getRoutineById(nodeId);
}

RoutineParadigm[] sourceRoutineParadigms = builder.getSourceRoutineParadimgsForNode(node);
RoutineParadigm[] targetRoutineParadigms = builder.getTargetRoutineParadimgsForNode(node);

TransactionParadigm targetSubTransaction = null;
AtomicRoutineParadigm source = null, target = null;
XpoLogAtomicParadigm sourceAtomicParadigm =  null, targetAtomicParadigm = null;
NodeFunctionEdge functionEdge = null;

if(targetRoutineParadigms.length == 1) {
	target = (AtomicRoutineParadigm)targetRoutineParadigms[0];
}
if(nodeType.equals("subTransaction")) {
	targetSubTransaction = builder.getTransactionById(nodeId);
}

if(functionId != null && !(functionId.equals(""))) {
	if(targetSubTransaction == null) {
		int index = target.getIncomingRoutineFunctionEdgeIndex(functionId);
		functionEdge = target.getIncomingRoutineFunctionByIndex(index);
		if(functionEdge != null) {
			source = (AtomicRoutineParadigm)functionEdge.getSourceParadigm();
		}
	}else {
		int index = targetSubTransaction.getIncomingRoutineFunctionEdgeIndex(functionId);
		functionEdge = targetSubTransaction.getIncomingRoutineFunctionByIndex(index);
		if(functionEdge != null) {
			source = (AtomicRoutineParadigm)functionEdge.getSourceParadigm();
			String targetRoutineId = ((TransactionTableModelTransformFunction)functionEdge.getFunction()).getTargetRoutineParadigmId();
			if(targetRoutineId != null) {
				target = builder.getRoutineById(targetRoutineId);
			}
		}
	}
}
if(source != null) {
	sourceAtomicParadigm = builder.getAtomicByRoutineId(source.getId());
}
if(target != null) {
	targetAtomicParadigm = builder.getAtomicByRoutineId(target.getId());
}

%>

<%@page import="xpolog.logic.functions.transform.TransactionTableModelTransformFunction"%>
<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
	<tr height="120">
		<td width="100">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr height="10">
					<td class="NODE_TEXT">Source Schema</td>
				</tr>
				<tr height="10">
					<td>
						<select <%=isView ? "disabled" : "" %> id="<%=nodeType %><%=nodeId %>SourceId" name="<%=nodeType %><%=nodeId %>SourceId" onchange="javascript:selectRoutine('<%=nodeId%>','<%=nodeType%>','source')" style="width:120px" width="10" size="1" class="TRANSACTION_TEXTBOX"> 
              <option value="">Please Select</option>
						<%
						for(int s = 0; s < sourceRoutineParadigms.length; s++) {
            	String sel = "";
          		if(source != null && sourceRoutineParadigms[s].getId().equals(source.getId())){
          			sel = "selected";
          		}		
            %>
              <option value="<%=sourceRoutineParadigms[s].getId()%>" <%=sel%>><%=sourceRoutineParadigms[s].getName()%></option>
            <%
            }//close options on paradigm if emty notify
            if(sourceRoutineParadigms.length == 0) {
            %>
							<option value="">No Data Source</option>
						<%
            }
						%>
            </select>
					</td>
				</tr>
				<tr height="10">
					<td id="source<%=nodeId%>ColumnNames">
						<select size="5" id="sourceList<%=nodeId%><%=nodeType %>" name="sourceList<%=nodeId%><%=nodeType %>" <%=isView ? "disabled" : "" %> class="TRANSACTION_TEXTBOX">
						<%
           	RecordMask sourceMask = null;
            RecordMask targetMask = null;
            
           	if(sourceAtomicParadigm != null && sourceAtomicParadigm.getLbm() != null) {
            	LinearBrowsingManager lbm = sourceAtomicParadigm.getLbm();
             
           		sourceMask = lbm.getRecordMask();
           		int [] indexes = null;
           		if(functionEdge != null){
           			indexes = UITransactionParadigmHelper.getSourceColumnIndexes(functionEdge);
           		}
           	 	int index = indexes != null && indexes.length > 0 ? indexes[0] : -1;
             	for (int j = 0; j < sourceMask.getCulomnsNumber(); j++){
             		String selected = "";                                
             		if (index == j){
               		selected = "selected";
             		}
            %>
             	<option value="<%=String.valueOf(j)%>" <%=selected%>><%=sourceMask.getMaskColumn(j).getName()%></option>
            <% 
         	 	 	}
					  }else {
					  %>
				      <option value="">No data to use</option>
					  <%
					  }
					  %> 
            </select>
					</td>
				</tr>
				
			</table>
		</td>
		<td width="100" style="padding-left:5">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr height="10">
					<td class="NODE_TEXT">Target Schema</td>
				</tr>
				<tr height="10">
					<td>
					<%
					if(targetRoutineParadigms.length == 1 && targetSubTransaction == null) {
						String name = target.getName();
						if (name.length() > 15){
							name = name.substring(0,12) + "...";
						}
					%>
						<span class="NODE_TEXT" title="<%=target.getName() %>" ><%=name %></span>
						<input type="hidden" id="<%=nodeType %><%=nodeId %>TargetId" name="<%=nodeType %><%=nodeId %>TargetId" value="<%=target.getId() %>">
					<%
					}else {
					%>
						<select <%=isView ? "disabled" : "" %> id="<%=nodeType %><%=nodeId %>TargetId" name="<%=nodeType %><%=nodeId %>TargetId" onchange="javascript:selectRoutine('<%=nodeId%>','<%=nodeType%>','target')" style="width:120px" width="10" size="1" class="TRANSACTION_TEXTBOX"> 
              <option value="">Please Select</option>
						<%
						for(int s = 0; s < targetRoutineParadigms.length; s++) {
            	String sel = "";
          		if(target != null && targetRoutineParadigms[s].getId().equals(target.getId())){
          			sel = "selected";
          		}		
            %>
              <option value="<%=targetRoutineParadigms[s].getId()%>" <%=sel%>><%=targetRoutineParadigms[s].getName()%></option>
            <%
            }//close options on paradigm if emty notify
            if(targetRoutineParadigms.length == 0) {
            %>
							<option value="">No Data Source</option>
						<%
            }
						%>
            </select>
          <%
					}
          %>
					</td>
				</tr>
				<tr height="10">
					<td id="target<%=nodeId%>ColumnNames">
						<select size="5" id="targetList<%=nodeId%><%=nodeType %>" name="targetList<%=nodeId%><%=nodeType %>" <%=isView ? "disabled" : "" %> class="TRANSACTION_TEXTBOX">
							<%
							XpoLogAtomicParadigm targetAtom = null;
							if(target != null) {
								targetAtom = builder.getAtomicByRoutineId(target.getId());
							}
							//XpoLogAtomicParadigm targetAtom = null;
							if(targetAtom != null && targetAtom.getLbm()!= null) {
              	LinearBrowsingManager lbm = targetAtom.getLbm();
                targetMask = lbm.getRecordMask();
                int [] indexes = null;
                if(functionEdge != null) {
						  		indexes = UITransactionParadigmHelper.getTargetColumnIndexes(functionEdge);
							 	}
						 		int index = indexes != null && indexes.length > 0 ? indexes[0] : -1;
                for(int j = 0; j < targetMask.getCulomnsNumber(); j++) {
                	String selected = "";                                
                  if(index == j) {
                  	selected = "selected";
                  }
				      %>
				      <option value="<%=String.valueOf(j)%>" <%=selected%>><%=targetMask.getMaskColumn(j).getName()%></option>
				      <% 
				      	}
						  }else {
				      %>
				      	<option value="">No data to use</option>
				      <%
				      }
				      %> 
            </select>
					</td>
				</tr>
			
			</table>
		</td>
		<td width="30" valign="middle">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">				
				<tr height="10">
					<td align="center" style="padding-left:5;padding-right:5;padding-top:30">
       			<table border="0" width="30" height="30" cellspacing="0" cellpadding="0">
   						<tr>
   							<td width="30" valign="bottom" align="center">
   							<%if(!isView) {%><a class="BODY_ACTION_LINK" href="javascript:addToFunctionList('<%=nodeId%>', '<%=nodeType%>')" class="LINK"><%}%>add<%if(!isView) {%></a><%}%>
   							</td>
   						</tr>  
   						<tr>
   							<td width="30" valign="top" style="padding-top:0" align="center">
   							<%if(!isView) {%><a class="BODY_ACTION_LINK" href="javascript:removeFromFunctionList('<%=nodeId%>', '<%=nodeType%>')"><%}%>remove<%if(!isView) {%></a><%}%>
   							</td>
   						</tr> 
   					</table>                      				
       		</td>
				</tr>
				
			</table>
		</td>
		<td width="100">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr height="10" >
					<td class="NODE_TEXT">&nbsp;</td>
				</tr>
				<tr height="10" style="padding-top:2;padding-bottom:2">
					<td class="NODE_TEXT">&nbsp;</td>
				</tr>
				<tr height="10">
					<td align="left">
          	<select size="5" id="<%=nodeType %><%=nodeId %>FunctionList" name="<%=nodeType %><%=nodeId %>FunctionList" multiple onChange="updateSourceTargetFunction('<%=nodeId%>', '<%=nodeType%>');"  class="TRANSACTION_TEXTBOX">
         		<%
            if(targetAtom != null && sourceMask != null && functionEdge != null) {
	           	int [] sourceIndexes = UITransactionParadigmHelper.getSourceColumnIndexes(functionEdge);
             	int [] targetIndexes = UITransactionParadigmHelper.getTargetColumnIndexes(functionEdge);
             	for(int j = 0; j < sourceIndexes.length; j++) {
  	         		String selected = "";  
						 		if(j == 0) {
							   	selected = "selected";
						 		}
             		String resultName = sourceIndexes[j] >= 0 ? sourceMask.getMaskColumn(sourceIndexes[j]).getName() : targetMask.getMaskColumn(targetIndexes[j]).getName();
					  %>
					  	<option value="<%=String.valueOf(sourceIndexes[j]) + ";" + String.valueOf(targetIndexes[j])%>" <%=selected%>><%=resultName%></option>
					  <%
             	}
				    }else {
					  %>
					  	<option value=""">No data to use</option>
					  <%
					  }
					  %>       
          	</select>
          </td>
				</tr>
				
			</table>
		</td>
		<td width="30">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr height="10">
					<td align="left" style="padding-left:5;padding-right:5;padding-top:30">
					<%
					if(functionId != null && !functionId.equals("")) {
					%>
						<a class="BODY_ACTION_LINK" href="javascript:editFunction('equals', '<%=functionId %>', '<%=nodeId %>', '<%=nodeType %>', '<%=isView %>')">Update Function</a>
					<%
					}else {
					%>
						<a class="BODY_ACTION_LINK" href="javascript:addFunction('equals', '<%=nodeId %>', '<%=nodeType %>', '<%=isView %>')">Add Function</a>
					<%
					}
					%>
					</td>
				</tr>
				
			</table>
		</td>
		<td width="*" style="font-size:2pt">&nbsp;</td>
	</tr>
</table>