<%@ page language="java" %>

<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmBuilder"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%@ include file="getNodesData.jsp"%>

<%

	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute("TRAN_PARADIGM_BUILDER");
	if (builder == null){
		response.sendRedirect("addNewTransaction.jsp");
		return;
	}
	
	String nodeType = request.getParameter("nodeType");
	String nodeId = request.getParameter("nodeId");
	String groupId = request.getParameter("groupId");
	String extractionType = request.getParameter("extractionType");
	String targetId = request.getParameter("targetId");
	String isViewStr = request.getParameter("isView");
	boolean isView = isViewStr != null && isViewStr.equals("true");
	
	getTransactionData(request, builder, null);
	
	NodeModelParadigm[] transactionNodes = builder.getTransactionNodes(builder.getRoot());
  getNodesData(request, builder, transactionNodes, null);
	
  TransactionParadigm group = null;
  if(nodeType != null && nodeId != null && groupId != null && extractionType != null && targetId != null) {
  	group = builder.extractNode(nodeType, nodeId, groupId, extractionType, targetId);
  }
  
  response.setContentType("text/xml");
%>

<jsp:include page="transactionViewUpdate.jsp" flush="true" >
	<jsp:param name="isView" value="<%=isView %>"/>
</jsp:include>
