<%@ page language="java" %>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.atomic.data.*"%>

<%
	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute("TRAN_PARADIGM_BUILDER");
	if (builder == null){		
	  return;
	}
	String routineId = request.getParameter("routineId");
	if (routineId == null || routineId.length() == 0){
	  return;
	}
	
	XpoLogAtomicParadigm atomicParadigm = builder.getAtomicByRoutineId(routineId);
	if (atomicParadigm == null){
	  return;
	}
	
	 LinearBrowsingManager lbm = atomicParadigm.getLbm();
	  if (lbm == null){
	    return;
	  }
	
	String [] names = UITransactionParadigmHelper.getColumnNames(lbm.getRecordMask());
	
%>
<html>
<head>
  <meta http-equiv="Content-Language" content="en-us">
  <META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
  <META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
  <META HTTP-EQUIV="EXPIRES" CONTENT="0">
</head>
<body>
<script>

var names = new Array();
<% for (int i = 0; i < names.length; i++) {%>
	names[names.length] = "<%=names[i]%>"; 
<%}%>
</script>
</body>
</html>