<%@ page language="java" %>

<%@ page import="xpolog.logic.edge.InnerEdgeParadigm"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmBuilder"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%@ include file="getNodesData.jsp"%>

<%

	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute("TRAN_PARADIGM_BUILDER");
	if (builder == null){
		response.sendRedirect("addNewTransaction.jsp");
		return;
	}
	
	String nodeType = request.getParameter("nodeType");
	String isViewStr = request.getParameter("isView");
	boolean isView = isViewStr != null && isViewStr.equals("true");
	
	getTransactionData(request, builder, null);
	
	NodeModelParadigm[] transactionNodes = builder.getTransactionNodes(builder.getRoot());
  getNodesData(request, builder, transactionNodes, null);
  
  if(nodeType != null && nodeType.length() == 0) {
  	nodeType = "dummy";
  }
  NodeModelParadigm newStartPoint = builder.insertNewStartPoint(nodeType);
  
  response.setContentType("text/xml");
%>

<jsp:include page="transactionViewUpdate.jsp" flush="true" >
	<jsp:param name="isView" value="<%=isView %>"/>
	<jsp:param name="includeNodeAttributesElement" value="true"/>
	<jsp:param name="nodeId" value="<%=newStartPoint.getId() %>"/>
	<jsp:param name="nodeType" value="<%=nodeType %>"/>
	<jsp:param name="showNodeMenuImage" value="true"/>
</jsp:include>
