<%@ page language="java" %>

<%@ page import="xpolog.logic.common.NodeModelParadigm"%>
<%@ page import="xpolog.logic.functions.NodeFunctionEdge"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmBuilder"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
	
	String TRAN_PARADIGM_BUILDER = "TRAN_PARADIGM_BUILDER";

	String dataFilterId = request.getParameter("dataFilterId");
	String nodeId = request.getParameter("nodeId");
	String nodeType = request.getParameter("nodeType");
	String isViewStr = request.getParameter("isView");
	boolean isView = isViewStr != null && isViewStr.equals("true");
	
	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute(TRAN_PARADIGM_BUILDER);
	NodeModelParadigm node = null;
	
	if(nodeType.equals("subTransaction")) {
		node = builder.getTransactionById(nodeId);
	}else if(nodeType.equals("routine")) {
		node = builder.getRoutineById(nodeId);
	}
	if(node != null) {
		builder.removeRoutineFilter(nodeId,dataFilterId);
	}
	
	response.setContentType("text/xml");
%>

<Result>
<DataFiltersList nodeId="<%=nodeId %>" nodeType="<%=nodeType %>" isView="<%=isView %>">
<![CDATA[
<jsp:include page="filtersList.jsp" flush="true" >
	<jsp:param name="nodeId" value="<%=nodeId %>"/>
	<jsp:param name="nodeType" value="<%=nodeType %>"/>
	<jsp:param name="isView" value="<%=isView %>"/>
</jsp:include>
]]>
</DataFiltersList>
</Result>