
<%
					{
				
					  UIProperties properties = (UIProperties)useRoutine.getUIObject();
					  if (properties == null){
					    properties = UIPreferences.getInstance().getAllPropertiesForRoutine(useRoutine,true);
					  }
					  UIProperty routineParadigmPropertyRef = properties.getProperty(UIConstants.IMAGES_TYPE,UIConstants.ROUTINE_PARADIGM_KEY).getReferenceProperty();
					  UIProperty routineRuntimePropertyRef = properties.getProperty(UIConstants.IMAGES_TYPE,UIConstants.ROUTINE_RUNTIME_KEY).getReferenceProperty();
					  UIProperty dummyRoutinePropertyRef = properties.getProperty(UIConstants.IMAGES_TYPE,UIConstants.DUMMY_ROUTINE_KEY).getReferenceProperty();					  
						FilterCollection[] dataFilters = null;
						
						if (useAtomic != null) {
							//dataFilters = UITransactionParadigmHelper.getDataFiltersForAtomic(useAtomic.getId(),true,true);
							FilterCollection[] managerFilters = UITransactionParadigmHelper.getDataFiltersForAtomic(useAtomic.getId(),true,true);
							if (managerFilters == null){ 
								managerFilters = new FilterCollection[0];
							}
							HashMap fMap = builder.getNewRoutineFilters(useRoutine);
							Collection col = (fMap != null) ? fMap.values() : null;
							FilterCollection[] builderFilters = new FilterCollection[0];
							if (col != null){
								builderFilters = (FilterCollection[])col.toArray(new FilterCollection[col.size()]);
							}
							dataFilters = new FilterCollection[managerFilters.length+builderFilters.length];
						  System.arraycopy(managerFilters,0,dataFilters,0,managerFilters.length);
						  System.arraycopy(builderFilters,0,dataFilters,managerFilters.length,builderFilters.length);
						}
						
				xpolog.logic.functions.NodeFunctionEdge[] finedge = (xpolog.logic.functions.NodeFunctionEdge[])useRoutine.getIncomingRoutineFunctionEdge();
        			
                                  
				%>
				 <script>
                    var applicationTabs = createDefaultApplicationTabs("routineTabs<%=routineIndexStr%>");
                    applicationTabs.addTab("global","global","globalDiv<%=routineIndexStr%>");
                    //applicationTabs.addTab("images","images","imagesDiv<%=routineIndexStr%>");
		    		applicationTabs.addTab("dataFiltes","dataFilters","dataFiltersDiv<%=routineIndexStr%>");
		    
                 </script>     
                 <table width="100%">
				<a name="routine<%=useRoutine.getId()%>"><!-- --></a>
                  <tr>
                    <td width="100%"><script>applicationTabs.writeTabs();</script></td>
                   </tr> 
                  <tr>
                   <td width="100%" style="padding-right:10">   
                   <div id="globalDiv<%=routineIndexStr%>" style="display:none;border:1px solid #A58B9D">
   					<table border="0" width="100%" height="150" border="0" cellpadding="0" cellspacing="0">
                        <tr height="100">
                          <td width="33%" rowspan="1">
                            <table border="0" width="100%">
                              <tr>
                                <td width="50%" nowrap><span class="REGULARTEXT">Routine name</span></td>
                                <td width="50%"><input type="text" name="routineName<%=routineIndexStr%>" size="23" value="<%=useRoutine.getName()%>"></td>
                              </tr>
                              <tr>
                                <td width="50%"><span class="REGULARTEXT">Description</span></td>
                                <td width="50%"><input type="text" name="routineDesc<%=routineIndexStr%>" size="29" value="<%=useRoutine.getDescription()%>"></td>
                              </tr>
                            </table>
                          </td>
                          <td width="33%" style="padding-left:10">
                            
                            <table border="0" width="100%">
                              <tr>
                                <td width="100"><span class="REGULARTEXT"><nobr>Data source</nobr></span></td>
                                <td width="150"><span class="REGULARTEXT">
                                <select  size="1" name="routineDS<%=routineIndexStr%>" id="routineDS<%=routineIndexStr%>" >
                                <%if (useAtomic == null){%>
                                    <option value="" selected">No Use</option>
                                 <%}else {%>                                                          
                                    <option value="<%=useAtomic.getId()%>" selected><%=useAtomic.getName()%></option>
                                <%}%>
                                  </select></span></td>
								<td width="*">
								<%if(!isView){%>
								<a class="LINK" href="javascript:openDSSelction('<%=routineIndexStr%>','<%=String.valueOf(routineIndex - 1)%>','<%=useRoutine.getId()%>')">new</a>
								<%}%>
								</td>
                              </tr>
                              <tr>
                                <td width="100"><span class="REGULARTEXT">Filter</span></td>
                                <td width="150"><span class="REGULARTEXT">
	                                <select  size="1" name="routineDSFilter<%=routineIndexStr%>" id="routineDSFilter<%=routineIndexStr%>" >
										<%if (!isView || useAtomic == null || useDS.getFilterId() == null || useDS.getFilterId().length() == 0 || useDS.getFilterId().equals("none")){%>
							                           <option value="none">None</option>
										<%}
										if (useAtomic != null){
										  java.util.List filtersList = useAtomic.getLbm().getFilterManager().getFilterCollections();
										  if (filtersList != null){ 					
										    String selectedFilterId = useDS == null ? null : useDS.getFilterId();
									    	    for (int f = 0; f < filtersList.size(); f++) {
								  		      FilterCollection col = (FilterCollection)filtersList.get(f);
										      boolean selected = selectedFilterId != null && selectedFilterId.equals(col.getId());
										      if (!isView || selected){
										      %>
										        <option value="<%=col.getId()%>" <%=selected ? "selected" : ""%>><%=col.getName()%></option>
										      	
										<%	
										      }			    
										    }
										  }
										}%>
	                                  </select></span></td>
									<td width="*">&nbsp;</td>
                              	</tr>
                            </table>
                          </td>
                          <td width="34%" align="left">&nbsp;</td>
                        </tr>                        
						<tr height="20">
                            <td width="100%" colspan="3" align="left" valign="top" style="padding-left:20">
										<input type="checkbox" name="routineLogicType<%=routineIndexStr%>" value="<%=RoutineParadigm.OPTIONAL_LOGIC_TYPE%>" <%=useRoutine.isLogicFromType(RoutineParadigm.OPTIONAL_LOGIC_TYPE)?"checked":""%>><span class="REGULARTEXT">Optional</span>&nbsp;
										<input type="checkbox" name="routineLogicType<%=routineIndexStr%>" value="<%=RoutineParadigm.END_LOGIC_TYPE%>" <%=useRoutine.isLogicFromType(RoutineParadigm.END_LOGIC_TYPE)?"checked":""%>><span class="REGULARTEXT">End</span>&nbsp;
										<input type="checkbox" name="routineLogicType<%=routineIndexStr%>" value="<%=RoutineParadigm.START_LOGIC_TYPE%>" <%=useRoutine.isLogicFromType(RoutineParadigm.START_LOGIC_TYPE)?"checked":""%>><span class="REGULARTEXT">Open</span>&nbsp;
										<input type="checkbox" name="routineLogicType<%=routineIndexStr%>" value="<%=RoutineParadigm.SINGLE_LOGIC_TYPE%>" <%=useRoutine.isLogicFromType(RoutineParadigm.SINGLE_LOGIC_TYPE)?"checked":""%>><span class="REGULARTEXT">Single</span>&nbsp;&nbsp;
										<a href=javascript:openHelp('<%=BASE_DIRECTORY%>',"logic/Transactions.htm#RoutineDef")><span class="SMALLLINK">help</span></a>
							</td>
                        </tr>
                       <tr><td width="100%" colspan="3">&nbsp;</td></tr>
                       
                        <%
                        //if function already exsit
                        int z = finedge.length == 0 ? -1 : 0;
                        for (int t = z; t < finedge.length; t++) {
 						 AtomicRoutineParadigm target = useRoutine;
 						 AtomicRoutineParadigm source = null;
                         if(t >=0 && finedge[t]!= null && finedge[t] instanceof RoutineFunctionEdge){
                         	source = (AtomicRoutineParadigm)finedge[t].getSourceParadigm();
                         }
                       
                       XpoLogAtomicParadigm srcAtom =  null;
                       XpoLogAtomicParadigm targetAtom = null;
                       
                       if(source != null){
                        	srcAtom = builder.getAtomicByRoutineId(source.getId());
                       }
                       if(target != null){
                           targetAtom = builder.getAtomicByRoutineId(target.getId());
                       }
                       String hideStr = (i == 0) ? " style=\"display:none\"" : "";
                      %>

               <!-- beginning of function edge -->
      				 <tr>
 						<td width="100%" colspan="3">
 							<table border="0" width="100%" cellspacing="0" cellpadding="5">
														<%if (i != 0){%>
	                        	<tr>
		                          	<td width="20%" nowrap height="20"><span class="REGULARTEXT">Function
		                            	<select size="1" name="D4">
		                             	 <option>Equals</option>
		                            	</select>&nbsp;</span></td>
		                          	<td height="20" colspan="4">&nbsp;</td>
		                        </tr>
	                          <tr>
	                          	<%
	                          	
									RoutineParadigm[] pdgma = builder.getRoutineParadimgs();
	                          	%>
	                          	<td><span class="REGULARTEXT">Source Schema
	                            	<select <%=isView ? "disabled" : "" %>  onchange="javascript:dsSelected('sourceList<%=edgeIndexStr%>',this)" style="width:120px" width="10" size="1" name="routineSourceId<%=edgeIndexStr%>" id="routineSourceId<%=edgeIndexStr%>"> 
	                              		<option value="">Please Select</option>
										<%for (int s = 0;s < pdgma.length; s++) {
	                              			if(target !=null && pdgma[s].getId().equals(target.getId())){
	                              				continue;
	                              			}
	                              			String sel = "";
	                              			if(source != null && pdgma[s].getId().equals(source.getId())){
	                              				sel = "selected";
	                              			}
	                              			
	                              		%>
	                              		<option value="<%=pdgma[s].getId()%>" <%=sel%>><%=pdgma[s].getName()%></option>
	                              		<%}//close options on paradigm if emty notify
	                              		if(pdgma.length == 0){%>
										<option value=">No Data Source</option>
										<%}%>
	                            	</select>&nbsp;</span></td>
	                           	
	                          	<td><span class="REGULARTEXT">Target Schema</span></td>
	                            <td>&nbsp;</td>
	                         	<td>&nbsp;</td>
	                          	<td width="*">&nbsp;</td>
	                          </tr>
														<%}%>
	                          
	                          <tr>
	                           <td width="20" nowrap height="20" align="center" <%=hideStr%>><select size="10" id="sourceList<%=edgeIndexStr%>" name="sourceList<%=edgeIndexStr%>" <%=isView ? "disabled" : "" %>  multiple>
		                             <%
		                             try{
		                             
		                              xpolog.eye.data.RecordMask sourceMask = null;
		                              xpolog.eye.data.RecordMask targetMask = null;
		                              
		                              if (srcAtom != null && srcAtom.getLbm() != null){
		                               LinearBrowsingManager lbm = srcAtom.getLbm();
		                               
		                               sourceMask = lbm.getRecordMask();
		                               int [] indexes = null;
		                               if(t >= 0 && finedge[t] instanceof RoutineFunctionEdge){
		                               	indexes = UITransactionParadigmHelper.getSourceColumnIndexes((RoutineFunctionEdge)finedge[t]);
		                               }
		                               
									   							 int index = indexes != null && indexes.length > 0 ? indexes[0] : -1;
		                               for (int j = 0; j < sourceMask.getCulomnsNumber(); j++){
		                               String selected = "";                                
		                               if (index == j){
		                                  selected = "selected";
		                               }
		                               %>
		                               	<option value="<%=String.valueOf(j)%>" <%=selected%>><%=sourceMask.getMaskColumn(j).getName()%></option>
		                             <% }
		                              } else { %>
		                             <option value="">No data to use</option>
		                             <% }%> 
		                            </select>
	                            </td>
	                            <td width="20" height="20" align="center" <%=hideStr%>><select size="10" id="targetList<%=edgeIndexStr%>" name="targetList<%=edgeIndexStr%>" <%=isView ? "disabled" : "" %>  multiple>
		                             <%
		                             if (targetAtom != null && targetAtom.getLbm()!= null){
		                               
		                               LinearBrowsingManager lbm = targetAtom.getLbm();
		                               targetMask = lbm.getRecordMask();
		                               int [] indexes = null;
		                               if(t >=0 && finedge[t] instanceof RoutineFunctionEdge){                               //finedge[t]
																	   indexes = UITransactionParadigmHelper.getTargetColumnIndexes((RoutineFunctionEdge)finedge[t]);
																	 }
																	 int index = indexes != null && indexes.length > 0 ? indexes[0] : -1;
		                               for (int j = 0; j < targetMask.getCulomnsNumber(); j++){
		                               	String selected = "";                                
		                               	if (index == j){
		                                  selected = "selected";
		                               	}
		                               
		                               %>
		                               <option value="<%=String.valueOf(j)%>" <%=selected%>><%=targetMask.getMaskColumn(j).getName()%></option>
		                             <% }
		                             }  else { %>
		                             <option value="">No data to use</option>
		                             <% }%> 
	                            </select></td>
	                             <td width="20" height="20" align="center" <%=hideStr%>>
	                            		<table border="0" width="30" height="30" cellspacing="0" cellpadding="5">
	                        				<tr><td width="20" align="center">&nbsp;
	                        					<%if (!isView){%><a class="LINK" href="javascript:addToFunctionList(<%=edgeIndexStr%>)" class="LINK"><%}%>add<%if (!isView){%></a><%}%>
	                        				</td></tr>  
	                        				<tr><td width="20" align="center">&nbsp;
	                        					<%if (!isView){%><a class="LINK" href="javascript:removeFromFunctionList(<%=edgeIndexStr%>)"><%}%>remove<%if (!isView){%></a><%}%>
	                        				</td></tr> 
	                        			</table>                      				
	                            </td>
	                            <td width="10" height="20" align="left" <%=hideStr%>><select size="10" id="functionList<%=edgeIndexStr%>" name="functionList<%=edgeIndexStr%>" multiple onChange="updateSourceTargetFunction(<%=edgeIndexStr%>);">
		                               <% if (targetAtom != null && t >= 0 && sourceMask != null && finedge[t] instanceof RoutineFunctionEdge){
		                             
		                               int [] sourceIndexes = UITransactionParadigmHelper.getSourceColumnIndexes((RoutineFunctionEdge)finedge[t]);
		                               int [] targetIndexes = UITransactionParadigmHelper.getTargetColumnIndexes((RoutineFunctionEdge)finedge[t]);
		                               for (int j = 0; j < sourceIndexes.length; j++){
		                               String selected = "";  
																	 if (j == 0){
																	   selected = "selected";
																	 }
		                               String resultName = sourceIndexes[j] >= 0 ? sourceMask.getMaskColumn(sourceIndexes[j]).getName() : targetMask.getMaskColumn(targetIndexes[j]).getName();
		                               %>
		                               <option value="<%=String.valueOf(sourceIndexes[j]) + "," + String.valueOf(targetIndexes[j])%>" <%=selected%>><%=resultName%></option>
		                             <%} } else { %>
		                             <option value=""">No data to use</option>
		                             <% }%>                            
		                            </select>
	                            </td>
	                            
	                           
	                            <td width="*">
	                  				  <table border="0" width="100%" height="50" cellspacing="0" cellpadding="5">
	                   					<%
					                     if (!isView && (edge instanceof RoutineEdgeParadigm)){
	        				            %>
	                				    <tr><td align="left">
					        	           <span class="REGULARTEXT"><a class="LINK" href="javascript:removeEdge('<%=edgeIndexStr%>')">Remove Edge</a></span>
	        				  	        </td></tr>
	                   					<% }%>
	                    				<%
                               if (!isView && outgoingEdge != null && !builder.isEmptyNewEdge(outgoingEdge)){
					                      
	        			               RoutineParadigm [] newRoutines = builder.getRoutinesPerEdge(edge);
	              				      %>
	                      		 		 <tr><td align="left"><nobr>
						                   <span class="REGULARTEXT"><a href="javascript:addNewEdge('<%=outgoingEdgeIndexStr%>')">Add</a> new edge to </span>&nbsp;                   
	          					         <select size="1" name="newEdge<%=edgeIndexStr%>" >
						                   <option value="new" selected>new routine</option>
	          					         <% for (int r = 0; r < newRoutines.length; r++) {%>
					                     <option value="<%=newRoutines[r].getId()%>"><%=newRoutines[r].getName()%></option>                 
	        				             <%}%>
	                					   </select></nobr>
						                  </td>
						                  </tr>
						                  <%}%>
										</table>
						            </td>
	                          </tr>
	                          <tr>
	                          	<td><a class="LINK" href="">add new function</a></td>
	                          </tr>
	                          </table>
	                          
	                          
                        </td>
                        </tr>
                        <!-- end of function edge -->
                         <% }catch(Exception e){
													e.printStackTrace();
                         }%>
                         <%}//for each function we iterate%>
           
                  </table>
                  
                  
                  
                      </div>
                      <div id="imagesDiv<%=routineIndexStr%>" style="display:none;border:1px solid #A58B9D">
                      <table border="0" width="100%" height="150">
                          <tr>                          
                          <td width="50" style="padding-left:10;padding-top:5"><span class="REGULARTEXT"><nobr>Routine Paradigm </nobr></span></td>
                          <td width="50" style="padding-left:10;padding-top:5"><IMG id="routineParadigmImage<%=routineIndexStr%>"  width="32" height="32" ></td>
                          <td width="100">
                          <select size="1" id="routineParadigmImages<%=routineIndexStr%>" name="routineParadigmImages<%=routineIndexStr%>" onChange="javascript:changeImage(this,'routineParadigm','routineParadigmImage<%=routineIndexStr%>')">
                          </select>
                          </td>
                          <td width="100" id="newRoutineImage1<%=routineIndexStr%>">&nbsp;<a class="LINK" href="javascript:showImageSettingsDiv('newRoutineImage1<%=routineIndexStr%>','routineParadigmImages<%=routineIndexStr%>','routineParadigm','routineParadigmImage<%=routineIndexStr%>')">New </a></td>
                          <td width="*" rowspan="3">&nbsp;</td>
                          </tr>
                          <tr>
                          <td width="50" style="padding-left:10;padding-top:5"><span class="REGULARTEXT"><nobr>Routine Runtime </nobr></span></td>
                          <td width="50" style="padding-left:10;padding-top:5"><IMG id="routineRuntimeImage<%=routineIndexStr%>"  width="32" height="32" ></td>
                          <td width="100">
                          <select size="1" id="routineRuntimeImages<%=routineIndexStr%>" name="routineRuntimeImages<%=routineIndexStr%>" onChange="javascript:changeImage(this,'routineRuntime','routineRuntimeImage<%=routineIndexStr%>')">
                          </select>
                          </td>
                          <td width="100" id="newRoutineImage2<%=routineIndexStr%>">&nbsp;<a class="LINK" href="javascript:showImageSettingsDiv('newRoutineImage2<%=routineIndexStr%>','routineRuntimeImages<%=routineIndexStr%>','routineRuntime','routineRuntimeImage<%=routineIndexStr%>')">New </a></td>
                          </tr>
                          <tr>
                          <td width="50" style="padding-left:10;padding-top:5"><span class="REGULARTEXT"><nobr>Dummy Routine </nobr></span></td>
                          <td width="50" style="padding-left:10;padding-top:5"><IMG id="dummyRoutineImage<%=routineIndexStr%>"  width="32" height="32" ></td>
                          <td width="100">
                          <select size="1" id="dummyRoutineImages<%=routineIndexStr%>" name="dummyRoutineImages<%=routineIndexStr%>" onChange="javascript:changeImage(this,'dummyRoutine','dummyRoutineImage<%=routineIndexStr%>')">
                          </select>
                          </td>
                          <td width="100" id="newRoutineImage3<%=routineIndexStr%>">&nbsp;<a class="LINK" href="javascript:showImageSettingsDiv('newRoutineImage3<%=routineIndexStr%>','dummyRoutineImages<%=routineIndexStr%>','dummyRoutine','dummyRoutineImage<%=routineIndexStr%>')">New </a></td>
                          </tr>
                         </table>
                      </div>

                      <div id="dataFiltersDiv<%=routineIndexStr%>" style="display:none;border:1px solid #A58B9D">
                      <table border="0" width="200" height="150">
                          <tr>                          
	                          <td width="100" style="padding-left:10;padding-top:5"><span class="REGULARTEXT"><nobr>Routine Data Filter</nobr></span></td>
	                          <td width="100">
		                          <select size="5" name="filterList<%=routineIndexStr%>" multiple>
																<option value="0">No Filter</option>		                          	
																<%
																HashSet routineFilters = builder.getRoutineFilters(useRoutine);
		                          	if (dataFilters != null){
			                          	for (int d=0; d < dataFilters.length; d++){
			                          	String selected = (routineFilters!=null && routineFilters.contains(dataFilters[d])) ? "selected" : "";
		                          	%>
																	<option value="<%=dataFilters[d].getId()%>" <%=selected%>><%=dataFilters[d].getName()%></option>
		                          	<%}
		                          	}%>
	                          	</select>
	                          </td>
	                          <td width="100">&nbsp;<a class="LINK" id="newDataFilter<%=routineIndexStr%>" href="javascript:openFilterWindow('<%=routineIndexStr%>','filterList<%=routineIndexStr%>','<%=useRoutine.getId()%>')">New </a></td>
	                          <!--<td width="100">&nbsp;<a class="LINK" id="newDataFilter<%=routineIndexStr%>" href="javascript:openFilterWindow('<%=routineIndexStr%>','filterList<%=routineIndexStr%>')">New </a></td>-->
                          </tr>
                         </table>
                      </div>

                     </td>
                  </tr>
                  
                  </table>
                  <script>
                  updateImagesListsByIndex(<%=routineIndexStr%>);
                  selectImageById('routineParadigmImages<%=routineIndexStr%>','routineParadigm','routineParadigmImage<%=routineIndexStr%>',<%=routineParadigmPropertyRef != null && routineParadigmPropertyRef.isGlobal() ? routineParadigmPropertyRef.getId() : "-1"%>); 
                  selectImageById('routineRuntimeImages<%=routineIndexStr%>','routineRuntime','routineRuntimeImage<%=routineIndexStr%>',<%=routineRuntimePropertyRef != null && routineRuntimePropertyRef.isGlobal() ? routineRuntimePropertyRef.getId() : "-1"%>); 
                  selectImageById('dummyRoutineImages<%=routineIndexStr%>','dummyRoutine','dummyRoutineImage<%=routineIndexStr%>',<%=dummyRoutinePropertyRef != null && dummyRoutinePropertyRef.isGlobal() ? dummyRoutinePropertyRef.getId() : "-1"%>); 
                  applicationTabs.selectTabByIndex(0);
                 
                  </script>
                  
                  <%
                  
                    }
                  %>