<%@ page import="java.util.List"%>

<%@ page import="xpolog.eye.data.filters.FilterCollection"%>

<%@ page import="xpolog.logic.atomic.data.XpoLogAtomicParadigm"%>
<%@ page import="xpolog.logic.common.NodeModelParadigm"%>
<%@ page import="xpolog.logic.edge.InnerEdgeParadigm"%>
<%@ page import="xpolog.logic.routine.data.RoutineParadigm"%>
<%@ page import="xpolog.logic.sources.xplg.XplgDataSource"%>
<%@ page import="xpolog.logic.transaction.data.TransactionParadigm"%>
<%@ page import="xpolog.logic.ui.admin.UITransactionParadigmBuilder"%>

<%@ include file="getGroupableNodes.jsp"%>

<%

String TRAN_PARADIGM_BUILDER = "TRAN_PARADIGM_BUILDER";

String BASE_DIRECTORY = request.getParameter("BASE_DIRECTORY");
String parentTransaction = request.getParameter("parentTransaction");
String subTransactionId = request.getParameter("subTransactionId");
if(subTransactionId == null || subTransactionId.length() == 0) {
	return;
}
String isViewStr = request.getParameter("isView");
boolean isView = isViewStr != null && isViewStr.equals("true");

UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute(TRAN_PARADIGM_BUILDER);
TransactionParadigm root = builder.getTransactionById(subTransactionId);
if(root == null) {
	return;
}
NodeModelParadigm[] nodes = builder.getTransactionNodes(root);

String groupableNodes = getGroupableNodes(builder, root);

String parentLevelStr = request.getParameter("parentLevel");
int parentLevel = 0;
if (parentLevelStr != null && parentLevelStr.length() > 0){
	try {
		parentLevel = Integer.parseInt(parentLevelStr);
	}catch (Exception e){}
}
String newParentLevel = String.valueOf(parentLevel + 1);
%>

							<table border="1" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%">
			  				<tr valign="top" height="20">
			  					<td width="100%" style="padding-top:<%= (parentLevel > 0 ? "1" : "0")%>">
			  						<div id="subTransaction<%=subTransactionId %>Div">
			  						<div id="subTransaction<%=subTransactionId %>HeaderDiv">
				  						<table id="subTransaction<%=subTransactionId %>HeaderTable" border="0" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%">
												<tr>
													<td width="100%">
							  						<table border="0" cellspacing="0" cellpadding="0" style="border-width:0;border: solid 0px #000000 ;border-collapse: collapse" width="100%">
							  							<tr bgcolor="#9399BB">
								  							<td width="<%=(1 + (20*(parentLevel + 1))) + "" %>" align="right">
								  								<input type="checkbox" id="subTransaction<%=subTransactionId %>Check" name="nodeChecks" value="<%=subTransactionId %>" parentTransaction="<%=parentTransaction %>" groupableNodes="<%=groupableNodes %>" onClick="javascript:selectNodeForGroup('<%=subTransactionId %>', 'subTransaction')">
								  							</td>
								  							<td width="*" style="padding-left:7">
								  								<table border="0" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%">
								  									<tr>
								  										<td class="SUB_TRANSACTION_HEADER" onclick="javascript:clickNode('<%=subTransactionId %>', 'subTransaction', true, false)">
								  											<nobr>
								  												<img border="0" id="subTransaction<%=subTransactionId %>ArrowImage" src="<%=BASE_DIRECTORY%>logic/images/tranview/closedRoutineArrow.gif">
												  								<span style="cursor:pointer"><%=root.getName() %></span>
												  							</nobr>
								  										</td>
								  										<td align="left" valign="middle" width="100%" style="padding-left:3"><a id="zoomInLink" href="javascript:showTransaction('<%=root.getId()%>', '<%=isView %>')" class="BACK_LINK"><img alt="Zoom In" title="Zoom In" style="cursor:pointer" src="<%=BASE_DIRECTORY%>logic/images/tranview/zoomIn.gif" border="0"></a></td>
								  									</tr>
								  								</table>
								  							</td>
								  							<td width="400" valign="bottom">
								  							<div id="subTransaction<%=subTransactionId %>TabsDiv" style="display:none">
													  			<table border="0" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%">
																		<tr id="subTransaction<%=subTransactionId %>TabsRow">
																		<td valign="bottom">
															  		<table border="0" cellspacing="0" cellpadding="0" style="border-collapse: collapse" width="100%"  >
															  		<tr>
																			<td width="3%" style="font-size:2pt">&nbsp;</td>
																			<td id="subTransaction<%=subTransactionId %>ContentTabImage" style="width:93px; background-image:url(<%=BASE_DIRECTORY %>logic/images/tranview/subTransactionTabSelected.gif); background-repeat:no-repeat" valign="bottom" align="center" onClick="javascript:showSubTransactionTab('<%=subTransactionId %>', 0)" onMouseOver="javascript:document.body.style.cursor='pointer'" onMouseOut="javascript:document.body.style.cursor='default'"><span id="subTransaction<%=subTransactionId %>ContentTabLink" class="SUB_TRANSACTION_SELECTED_TAB_TEXT">Content</span></td>
																			<td id="subTransaction<%=subTransactionId %>GeneralTabImage" style="width:93px; background-image:url(<%=BASE_DIRECTORY %>logic/images/tranview/subTransactionTabUnselected.gif); background-repeat:no-repeat" valign="bottom" align="center" onClick="javascript:showSubTransactionTab('<%=subTransactionId %>', 1)" onMouseOver="javascript:document.body.style.cursor='pointer'" onMouseOut="javascript:document.body.style.cursor='default'"><span id="subTransaction<%=subTransactionId %>GeneralTabLink" class="SUB_TRANSACTION_TAB_TEXT">General</span></td>
																			<td id="subTransaction<%=subTransactionId %>FunctionsTabImage" style="width:93px; background-image:url(<%=BASE_DIRECTORY %>logic/images/tranview/subTransactionTabUnselected.gif); background-repeat:no-repeat" valign="bottom" align="center" onClick="javascript:showSubTransactionTab('<%=subTransactionId %>', 2)" onMouseOver="javascript:document.body.style.cursor='pointer'" onMouseOut="javascript:document.body.style.cursor='default'"><span id="subTransaction<%=subTransactionId %>FunctionsTabLink" class="SUB_TRANSACTION_TAB_TEXT">Functions</span></td>
																			<td id="subTransaction<%=subTransactionId %>ConnectorsTabImage" style="width:93px; background-image:url(<%=BASE_DIRECTORY %>logic/images/tranview/subTransactionTabUnselected.gif); background-repeat:no-repeat" valign="bottom" align="center" onClick="javascript:showSubTransactionTab('<%=subTransactionId %>', 3)" onMouseOver="javascript:document.body.style.cursor='pointer'" onMouseOut="javascript:document.body.style.cursor='default'"><span id="subTransaction<%=subTransactionId %>ConnectorsTabLink" class="SUB_TRANSACTION_TAB_TEXT">Connectors</span></td>
																			<td width="*" style="font-size:2pt">&nbsp;</td>
																		</tr>
																		</table>
															  		</td>
															  		</tr>
																	</table>
													  		</div>
								  							</td>
								  							<td width="16" align="center">
								  								<a href="javascript:removeNode('subTransaction', '<%=subTransactionId %>')" title="Remove Group"><img border="0" id="subTransaction<%=subTransactionId %>RemoveImage" src="<%=BASE_DIRECTORY%>logic/images/tranview/removeSubTransaction.gif"></a>
								  							</td>
								  						</tr>
								  					</table>
								  				</td>
								  			</tr>
								  		</table>
								  	</div>
								  	<div id="subTransaction<%=subTransactionId %>BodyDiv" style="display:none" parentTransaction="<%=parentTransaction %>">
								  		<div id="subTransaction<%=subTransactionId %>ContentDiv">
									  		<table id="subTransaction<%=subTransactionId %>NodesTable" border="0" cellspacing="0" cellpadding="0" style="" width="100%" bgcolor="#DBDDE9">
					  						<%
					  							int numberOfNodes = 0;
						              for(int i = 0; i < nodes.length;i++) {
						              	NodeModelParadigm node = nodes[i];
						              	TransactionParadigm transaction = null;
						              	RoutineParadigm routine = null;
						              	XpoLogAtomicParadigm atomic = null;
						              	XplgDataSource dataSource = null;
						              	
						              	if(node.getNodeType().equals(TransactionParadigm.TRANSACTION_PARADIGM)) {
						              		numberOfNodes++;
						              		transaction = (TransactionParadigm)node;
						              		
						              		String transactionId = transaction.getId();
					              %>
					              		<tr id="tableRowsubTransaction<%=transactionId %>" >
						                	<td>
																<jsp:include page="subTransactionGlobalView.jsp" flush="true" >
																	<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY %>"/>
																	<jsp:param name="parentTransaction" value="<%=subTransactionId %>"/>
																	<jsp:param name="subTransactionId" value="<%=transactionId %>"/>
																	<jsp:param name="isView" value="<%=isView %>"/>
																	<jsp:param name="parentLevel" value="<%=newParentLevel%>"/>
																</jsp:include>
															</td>
														</tr>
					              <%
						              	}else if(node.getNodeType().equals(RoutineParadigm.ROUTINE_PARADIGM)) {
						              		numberOfNodes++;
						              		routine = (RoutineParadigm)node;
						              		
							              	atomic = builder.getAtomicByRoutineId(routine.getId());
							              	if (atomic != null && atomic.getLbm() == null){
							              		atomic = null;
							              		dataSource = null;
														  }else {		
														  	dataSource = builder.getDataSourceByRoutineId(routine.getId());
														  }
											  		  
											  		  String atomicDisplay = atomic == null ? "None" : atomic.getName();
											  		  String filterDisplay = "";
											  		  if(!isView || atomic == null || dataSource.getFilterId() == null || dataSource.getFilterId().length() == 0 || dataSource.getFilterId().equals("none")) {
											  		  	filterDisplay = "None";
											  		  }else {
											  		  	if(atomic != null) {
													  			java.util.List filtersList = atomic.getLbm().getFilterManager().getFilterCollections();
													  			if(filtersList != null) { 					
													    			String selectedFilterId = dataSource == null ? null : dataSource.getFilterId();
												    	    	for (int f = 0; f < filtersList.size(); f++) {
													  		      FilterCollection col = (FilterCollection)filtersList.get(f);
																      boolean selected = selectedFilterId != null && selectedFilterId.equals(col.getId());
																      if(!isView || selected) {
																      	filterDisplay = col.getName();
																      	break;
													      			}			    
													    			}
													  			}
																}
											  		  }
											  		  String rulesDisplay = "";
											  		  rulesDisplay += routine.isLogicFromType(RoutineParadigm.START_LOGIC_TYPE) ? "Open, " : "";
											  		  rulesDisplay += routine.isLogicFromType(RoutineParadigm.SINGLE_LOGIC_TYPE) ? "Single, " : "";
											  		  rulesDisplay += routine.isLogicFromType(RoutineParadigm.OPTIONAL_LOGIC_TYPE) ? "Optional, " : "";
											  		  rulesDisplay += routine.isLogicFromType(RoutineParadigm.END_LOGIC_TYPE) ? "End, " : "";
											  		  if(rulesDisplay.length() > 0) {
											  		  	rulesDisplay = rulesDisplay.substring(0, rulesDisplay.length() - 2);
											  		  }
											  		  
											  		  String routineId = routine.getId();
				                %>
						                <tr id="tableRowroutine<%=routineId %>">

						                	<td>
																<jsp:include page="routineGlobalView.jsp" flush="true" >
																	<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY %>"/>
																	<jsp:param name="parentTransaction" value="<%=subTransactionId %>"/>
																	<jsp:param name="routineId" value="<%=routineId %>"/>
																	<jsp:param name="atomicDisplay" value="<%=atomicDisplay %>"/>
																	<jsp:param name="filterDisplay" value="<%=filterDisplay %>"/>
																	<jsp:param name="rulesDisplay" value="<%=rulesDisplay %>"/>
																	<jsp:param name="isView" value="<%=isView %>"/>
																	<jsp:param name="parentLevel" value="<%=newParentLevel%>"/>
																</jsp:include>
															</td>
														</tr>
												<%
						              	}
													}
					  						if(numberOfNodes == 0) {
					  						%>
					  							<tr height="10">
														<td width="3%">&nbsp;</td>
					  								<td class="NODE_TEXT" style="padding-left:3">No content exists</td>
													</tr>
					  						<%
					  						}
												%>
											</table>
										</div>
										<div id="subTransaction<%=subTransactionId %>GeneralDiv" style="display:none">
					  						<table border="0" cellspacing="0" cellpadding="0" style="border-collapse: collapse;" width="100%" bgcolor="#DBDDE9">
					  							<tr>
					  								<td width="3%">&nbsp;</td>
					  								<td width="15%" class="NODE_TEXT" style="padding-left:9; padding-top:5">Name</td>
					  								<td width="30%" class="TRANSACTION_TEXTBOX" style="padding-left:9; padding-top:5"><input type="text" id="subTransaction<%=subTransactionId %>Name" name="subTransaction<%=subTransactionId %>Name" value="<%=root.getName() %>" class="TRANSACTION_TEXTBOX"></td>
					  								<td width="15%"></td>
					  								<td width="*">&nbsp;</td>
					  							</tr>
					  							<tr>
					  								<td>&nbsp;</td>
					  								<td class="NODE_TEXT" style="padding-left:9; padding-bottom:5">Description</td>
					  								<td style="padding-left:9; padding-bottom:5"><input type="text" id="subTransaction<%=subTransactionId %>Description" name="subTransaction<%=subTransactionId %>Description" value="<%=root.getDescription() %>" class="TRANSACTION_TEXTBOX"></td>
					  								<td></td>
					  								<td></td>
					  								<td></td>
					  								<td></td>
					  							</tr>
					  						</table>
					  					</div>
					  				<div id="subTransaction<%=subTransactionId %>FunctionsDiv" style="display:none">
				  						<jsp:include page="functions.jsp" flush="true" >
												<jsp:param name="nodeId" value="<%=subTransactionId %>"/>
												<jsp:param name="nodeType" value="subTransaction"/>
												<jsp:param name="isView" value="<%=isView %>"/>
											</jsp:include>
				  					</div>
										<div id="subTransaction<%=subTransactionId %>ConnectorsDiv" style="display:none">
											<jsp:include page="connectors.jsp" flush="true" >
												<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY %>"/>
												<jsp:param name="nodeId" value="<%=subTransactionId %>"/>
												<jsp:param name="nodeType" value="subTransaction"/>
												<jsp:param name="isView" value="<%=isView %>"/>
											</jsp:include>
				  					</div>
									</div>
									</div>
			  					</td>
			  				</tr>
  						</table>