<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.logic.security.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.brain.*"%>

<%@ page import="java.util.*"%>

<%!static final String BASE_DIRECTORY = "../../../";

%>

<%
	String ERROR_OBJ = "ERROR_OBJ";
	String OP = "OP";
	String ADD = "ADD";
	String TYPE_LOG = "Log";

	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,LogicPermissionConstants.AdministrationPermissions.TRANSACTIONS_PERMISSION,true)){
		return;
	}

	UserSecurity user = manager.getUserSecurity(request);
	UserContext userContext = UserEnvironment.getUserContext(request);

	Collection transactionsCol = BrainConfigurationRepository.getRepository().getTransactionsParadigms(userContext);
	TransactionParadigm[] transactions = (TransactionParadigm[]) transactionsCol.toArray(new TransactionParadigm[transactionsCol.size()]);
	Arrays.sort(transactions, new Comparator() {
		public int compare(Object o1, Object o2) {
			String t1Name = ((TransactionParadigm)o1).getName();
			String t2Name = ((TransactionParadigm)o2).getName();
			return t1Name.toLowerCase().compareTo(t2Name.toLowerCase());
		}
	});
		
	boolean addTranAllowed = xpolog.logic.ConfigMgr.getInstance().isMoreTransactionsAllowed();
			
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />
<script>
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
		<tr valign="top">
				<td width="100%">
				<table border="0" width="100%" cellspacing="0" cellpadding="0">

						<tr>
								<td valign="top" height="100%">
								<table border="0" cellpadding="0" cellspacing="0" width="100%" class="LOGICGENERAL">
										<tr>
												<td width="100%">
												<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
														<tr>
																<td colspan="2" nowrap><span class="PAGEHEADER">Transaction Administration </span></td>
																<td width="50%">&nbsp;</td>
														</tr>
														<tr>
																<td width="3%">&nbsp;</td>
																<td width="24%">&nbsp;</td>
																<td width="100%">&nbsp;</td>
														</tr>
														<tr>
																<td width="3%" valign="top">&nbsp;</td>
																<td width="147%" colspan="2" valign="top">
																<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
																		<tr>
																				<td height="30">
																				<table border="0" width="100%" cellspacing="0" cellpadding="0">
																						<tr>
																								<td width="25%"><span class="HEADER">Transaction List</span></td>
																								<td width="25%"></td>
																								<td width="25%"></td>
																								<td width="25%"></td>
																						</tr>
																						<tr>
																								<td width="25%">&nbsp;</td>
																								<td width="25%"></td>
																								<td width="25%"></td>
																								<td width="25%"></td>
																						</tr>
																						<tr>
																								<td width="25%">
																								<%if(addTranAllowed){ %>
																								<a href="addNewTransaction.jsp?OP=ADD&ds_id=" class="LINK">Add new transaction</a>
																								<%}%>
																								</td>
																								<td width="25%"></td>
																								<td width="25%"></td>
																								<td width="25%"></td>
																						</tr>
																				</table>
																				</td>
																		</tr>
																		<tr>
																				<td>
																				<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
																						<tr class="TABLES_HEADERS">
																								<td width="30%"><span class="REGULARTEXT">Name</span></td>
																								<td width="*"><span class="REGULARTEXT">Description</span></td>
																								<td width="350" class="REGULARTEXT">&nbsp;</td>
																						</tr>
																						<%for (int i = 0; i < transactions.length; i++) {
																								boolean allowEdit = (user == null || user.isEditable(transactions[i].getTransactionPermissions()));
																								if (user != null && !user.isVisible(transactions[i].getTransactionPermissions())) {
																									continue;
																								}
																								if(transactions[i].getTransactionType() == TransactionParadigm.SUB_TRANSACTION_TYPE) {
																									continue;
																								}
																						%>
																						<tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
																								<td width="30%" class="SMALLTEXT" nowrap>
																								<%if (allowEdit){%>
																								<a href="addNewTransaction.jsp?ds_id=<%=transactions[i].getId()%>" class="LINK"><%=transactions[i].getName()%></a>
																								<%}else{%>
																								<a class="EMPTYLINK"><%=transactions[i].getName()%></a>
																								<%}%>
																								</td>
																								<td width="*" class="SMALLTEXT"><%=transactions[i].getDescription() == null ? "" : transactions[i].getDescription()%></td>
																								<td width="350" class="SMALLTEXT" nowrap>&nbsp;
																								<%if(allowEdit){ %>
																								<a href="addNewTransaction.jsp?ds_id=<%=transactions[i].getId()%>" class="LINK">edit</a>&nbsp; <a href="addNewTransaction.jsp?OP=DUPLICATE&ds_id=<%=transactions[i].getId()%>" class="LINK">duplicate</a>
																								&nbsp;
																								<a href="transactionRemoveCheck.jsp?ds_id=<%=transactions[i].getId()%>" class="LINK">delete</a>&nbsp; 
																									<%if (user != null) {%> 
																										<a href="perm/transactionPermissions.jsp?id=<%=transactions[i].getId()%>" class="LINK">Edit Permissions</a>&nbsp;
																									<%}%>
																								<%}%>
																								</td>
																						</tr>
																						<%}%>
																						<tr>
																								<td colspan="3" class="SMALLTEXT">&nbsp;</td>
																						</tr>
																				</table>
																				</td>
																		</tr>
																</table>
																</td>
														</tr>
												</table>
												</td>
										</tr>
										<tr>
												<td width="100%" class="REGULARTEXT">&nbsp;</td>
										</tr>
										<tr>
												<td width="100%">

												<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
														<tr>
																<td width="35%">&nbsp;</td>
																<td width="11%" align="center">&nbsp;</td>
																<td width="7%" align="center">&nbsp;</td>
																<td width="27%">&nbsp;</td>
																<td width="20%">&nbsp;</td>
														</tr>
												</table>

												</td>
										</tr>
								</table>
								</td>
						</tr>
						 <%if(!addTranAllowed){%>
             <tr>
              <td width="100%" style="border-top-width: 1" align="center">
              	<span class="LICENSEMESSAGE">Note that you have reached
                      the number of transactions permitted in your license.</span>
             </td>
            </tr> 
            <%}%>
						<tr valign="bottom">
								<td valign="bottom" height="10%"></td>
						</tr>
				</table>
				</td>
		</tr>
</table>
</form>
</body>

</html>
