<%@ page import="xpolog.logic.common.NodeModelParadigm"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.ui.graph.JGraphImageDescriptor"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%@ include file="getNodePosition.jsp"%>

<%

String includeSubTransactionIdElementStr = request.getParameter("includeSubTransactionIdElement");
boolean includeSubTransactionIdElement = includeSubTransactionIdElementStr != null && includeSubTransactionIdElementStr.equals("true");
String includeNodeAttributesElementStr = request.getParameter("includeNodeAttributesElement");
boolean includeNodeAttributesElement = includeNodeAttributesElementStr != null && includeNodeAttributesElementStr.equals("true");
String includeDataSourceElementStr = request.getParameter("includeDataSourceElement");
boolean includeDataSourceElement = includeDataSourceElementStr != null && includeDataSourceElementStr.equals("true");
String isViewStr = request.getParameter("isView");
boolean isView = isViewStr != null && isViewStr.equals("true");

UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute("TRAN_PARADIGM_BUILDER");

JGraphImageDescriptor imageDescriptor = builder.getImageForGraph(700, 220, "#FFFFFF");
String mappingStr = builder.createMappingString(imageDescriptor.getJgraphImage(), true);

String subTransactionId = "";
if(includeSubTransactionIdElement) {
	subTransactionId = request.getParameter("subTransactionId");
}

double[] nodePosition = null;
NodeModelParadigm node = null;
String nodeId = null;
String nodeType = null;
String showNodeMenuImageStr = null;
boolean showNodeMenuImage = false;
if(includeNodeAttributesElement) {
	nodeId = request.getParameter("nodeId");
	nodeType = request.getParameter("nodeType");
	showNodeMenuImageStr = request.getParameter("showNodeMenuImage");
	showNodeMenuImage = showNodeMenuImageStr != null && showNodeMenuImageStr.equals("true");
	node = builder.getTransactionById(nodeId);
	if(node == null) {
		node = builder.getRoutineById(nodeId);
	}
	if(node == null) {
		node = builder.getDummyById(nodeId);
	}
	nodePosition = getNodePosition(builder, node);  
}

String isErrorStr = "";
boolean isError = false;
String dsid = "", dsname = "", names = "", filtersNames = "", filtersIds = "", dataFilters = ""; 
if(includeDataSourceElement) {
	isErrorStr = request.getParameter("isError");
	isError = isErrorStr != null && isErrorStr.equals("true");
	if(!isError) {
		dsid = request.getParameter("dsid");
		dsname = request.getParameter("dsname");
		names = request.getParameter("names");
		filtersNames = request.getParameter("filtersNames");
		filtersIds = request.getParameter("filtersIds");
		dataFilters = request.getParameter("dataFilters");
	}
}

response.setContentType("text/xml");
%>

<TransactionView>
<TransactionHeader>
<![CDATA[
<jsp:include page="transactionHeader.jsp" flush="true" >
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY %>"/>
	<jsp:param name="isView" value="<%=isViewStr %>"/>
</jsp:include>
]]>
</TransactionHeader>
<Image src="<%=imageDescriptor.getImageGraphURL() %>" height="<%=imageDescriptor.getImageGraphHeight()%>" width="<%=imageDescriptor.getImageGraphWidth()%>"/>
<Mapping>
<![CDATA[<%=mappingStr %>]]>
</Mapping>
<NodesDiv>
<![CDATA[
<jsp:include page="transactionGlobalView.jsp" flush="true" >
<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY %>"/>
<jsp:param name="subTransactionId" value="<%=subTransactionId %>"/>
<jsp:param name="isView" value="<%=isView %>"/>
</jsp:include>
]]>
</NodesDiv>
<%
if(includeNodeAttributesElement) {
%>
	<NodeAttributes nodeType="<%=nodeType %>" nodeId="<%=nodeId %>" showNodeMenuImage="<%=showNodeMenuImage %>" x="<%=nodePosition[0] %>" y="<%=nodePosition[1] %>" />
<%
}
if(includeDataSourceElement) {
	if(isError) {
%>
	<DataSource isError="true" error="The data source is not usable" />
<%
	}else {
%>
	<DataSource dsid="<%=dsid %>" dsname="<%=dsname %>" names="<%=names %>" filtersNames="<%=filtersNames %>" filtersIds="<%=filtersIds %>" dataFilters="<%=filtersIds %>" />
<%
	}
}
%>
<AppName>
<![CDATA[
<jsp:include page="appNameRoutines.jsp" flush="true" />
]]>
</AppName>
</TransactionView>