<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../../";
%>

<%
  //constants

  String ERROR_OBJ = "ERROR_OBJ";
  
  String propertyType = UIConstants.IMAGES_TYPE;
  String propertyId = request.getParameter("propertyId");
  
  UIProperty property = null;
  if (propertyId != null){
    property = UIPreferences.getInstance().getGlobalProperties().getProperty(propertyType,propertyId);
  }
  boolean isNew = false;
  if (property == null){
    property = new UIProperty();
    property.setName("");
    property.setValue("");
    property.setId("");
    isNew = true;
  }

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />

<script language="javascript">
function doSave(){
   var propertyName = document.getElementById("propertyName").value;
   var propertyValue = document.getElementById("propertyValue").value;
   var propertyId = document.getElementById("propertyId").value;
   var archivePath = document.getElementById("archiveFile").value;
   document.access.action = "propertyImageAction.jsp?propertyName=" + propertyName + "&propertyValue=" + propertyValue + "&propertyId=" + propertyId + "&archivePath=" + archivePath;
   document.access.submit();
}

function updateImageInfo(){
   var path = document.getElementById("archivePath").value;
   if(!path || path == ""){
      return;
   }
   
   index = path.lastIndexOf("/");
   if(index < 0){
     index = path.lastIndexOf("\\");
   }
 
   imagePath = path.substring(index+1,path.length);
   var propertyValue = document.getElementById("propertyValue").value;
   var propertyName = document.getElementById("propertyName").value;
   if (!propertyValue || propertyValue == ""){
     document.getElementById("propertyValue").value = imagePath;
   }
   name = imagePath;
   index = name.indexOf(".");
   if (index >= 0){
     name = name.substring(0,index);
   }
   if (!propertyName || propertyName == ""){
     document.getElementById("propertyName").value = name;
   }
}


</script>
</head>

<body>
<input type="hidden" name="propertyId" value="<%=propertyId == null ? "" : propertyId%>" >
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%"  class="LOGIC_MAIN_TABLE">
          <tr>
            <td valign="top">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
                <tr>
                <td colspan="2" nowrap><span class="PAGEHEADER">Image Settings </span></td>
                <td width="50%" >&nbsp;</td>
              </tr>
              <tr>
                <td colspan="3">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" valign="top">
                &nbsp;</td>
                <td width="100%" colspan="2" valign="top">
                <span class="HEADER">Image</span>
                </td>
              </tr>
               <tr>
                <td colspan="3">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" valign="top">
                </td>
                <td width="600" colspan="2" valign="top">
                <table border="0"  cellspacing="1" cellpadding="0">
                  <tr>
                    <td width="120" style="padding-left:10;padding-top:10"style="padding-left:10;padding-top:10" nowrap><span class="REGULARTEXT">Image Name</span></td>
                    <td width="300" style="padding-left:10;padding-top:10"><input class="TEXTBOX" type="text" name="propertyName" size="40" value="<%=property.getName()%>"></td>
                    <td width="*" rowspan="2">
                      <% if (!isNew) {%>
                        <IMG src="<%=WebUtil.getURLWithPrefix(property.getValue())%>"  width="32" height="32" >
                      <% } %>
                    </td>
                  </tr>
                 <tr>
                    <td width="120" style="padding-left:10;padding-top:10" nowrap><span class="REGULARTEXT">Image path</span></td>
                    <td width="300" style="padding-left:10;padding-top:10"><input class="TEXTBOX" type="text" name="propertyValue" size="40" value="<%=UILogicAdminHelper.getCustomImageSuffixPath(property.getValue())%>"></td>                    
                  </tr>    
                  <form AUTOCOMPLETE="OFF" name="access" id="access" method="post" ENCTYPE="multipart/form-data">
                  <tr>
                    <td width="120" style="padding-left:10;padding-top:10" nowrap><span class="REGULARTEXT">Image upload</span></td>
                    <td width="300" style="padding-left:10;padding-top:10"><input class="TEXTBOX" type="file" id="archiveFile" name="archivePath" size="40" onChange="javascript:updateImageInfo()"></td>
                    <td width="*"></td>
                  </tr>
                  </form>             
                 </table>
                 </td>
               </tr>
               <tr>
                <td colspan=3>&nbsp;</td>
              </tr>
              <tr>
                <td colspan=3>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="892" id="AutoNumber17">
                      <tr>
                        <td width="164">&nbsp;</td>
                        <td width="90">
                        <p align="center"><a href="../UILogicView.jsp" class="LINK">Cancel</a></td>
                        <td width="94">
                          <p align="left"><a href="javascript:doSave()" class="LINK">Save</a></p>
                        </td>
                        <td width="443">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>                  
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
     
    </table>
    </td>
  </tr>
</table>
   
</body>

</html>