<%@ page language="java"%>

<%@ page import="java.util.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	String ERROR_OBJ = "ERROR_OBJ";
	
	String type = request.getParameter("type");
	String propertyId = request.getParameter("propertyId");
	String propertyType = request.getParameter("propertyType");
	
	ErrorModel errmodel = new ErrorModel();
	
	if(propertyId == null){
		errmodel.addError("Please supply Id for property to delete.");
	}
	
	if(propertyType == null){
		errmodel.addError("Please supply type for property to delete.");
	}
	
	if(errmodel.getErrorCount() > 0){
		response.sendRedirect("/logeye/common/errorpage.jsp");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		return;
	}
	
	UILogicAdminHelper.deleteProperty(propertyType,propertyId);
	
	//	  audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	     			userContext, AuditConstants.CHANGE, "remove system property", AuditConstants.CONFIGURATION, "remove system property");

	
	response.sendRedirect("UILogicView.jsp?propertyType="+type);
	

%>