<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%!
	static final String BASE_DIRECTORY = "../../../../";
%>

<%
UserContext userContext = UserEnvironment.getUserContext(request);
  String ERROR_OBJ = "ERROR_OBJ";
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);

  ErrorModel errmodel = new ErrorModel();
  String workspaceId = request.getParameter("id");
  if (workspaceId == null || workspaceId.length() == 0){
     errmodel.addError("Can't display permissions. No id is found.");
  }

  CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
  Workspace workspace = ctrlMgr.getWorkspaceById(workspaceId); 
  
  if (workspace == null){
    errmodel.addError("No workspace was found for id - " + workspaceId);
  }

  ModuleMemberPermissions permissions = null;
  permissions = new ModuleMemberPermissions();
  String [] editNames = request.getParameterValues("selectedEditMembersList");
  if (editNames != null && editNames.length > 0){
    permissions.setEditMembers(Arrays.asList(editNames));
  }

  String [] viewNames = request.getParameterValues("selectedViewMembersList");
  if (viewNames != null && viewNames.length > 0){
     permissions.setViewMembers(Arrays.asList(viewNames));
  }
  

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;

  }

//    audit
    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
       			userContext, AuditConstants.CHANGE, "edit worksapce permissions", AuditConstants.WORKSPACE, "edit wrokspace permissions " + workspace.getName());

  workspace.setPermissions(permissions);
  try {
  	ctrlMgr.saveWorkspace(workspace);
  }catch (Exception e){
    //e.printStackTrace();
  }

  String forwardURL = request.getParameter("forwardURL");
  if (forwardURL == null || forwardURL.length() == 0){
    forwardURL = "security/common/moduleMemberSetOK.jsp?okURL=logic/admin/workspace/workspacesDefinitionView.jsp";
  }
  forwardURL = BASE_DIRECTORY + forwardURL;
  response.sendRedirect(forwardURL);

%>

