<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.logic.ui.conf.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";

%>
<%

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  UserSecurity user = manager.getUserSecurity(request);
  

  String workspaceId = request.getParameter("workspaceId");
  if (workspaceId == null){
    workspaceId = "";
  }

  CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
  Workspace workspace = ctrlMgr.getWorkspaceById(workspaceId);

  String workspaceName = "";
  String workspaceDesc = "";

  if (workspace != null){
    workspaceName = workspace.getName();
    workspaceDesc = workspace.getDescription();
    if(workspaceDesc == null || workspaceDesc.equals("null")) {
    	workspaceDesc = "";
    }
  }
  
 
%>
<html>

<head>
  <meta http-equiv="Content-Language" content="en-us">
  <META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
  <META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
  <META HTTP-EQUIV="EXPIRES" CONTENT="0">
  
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script>

  function doSave(){
    document.access.action="workspaceDefinitionAction.jsp";
    document.access.submit();
  }


</script>
<title></title>
</head>


<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<input type="hidden" name="workspaceId" value="<%=workspaceId%>">

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">

  <tr>
    <td width="100%" height="100%" valign="top">
    	<table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      		<tr>
        		<td valign="top" height="84%">
        			<table border="0" cellpadding="0" cellspacing="0" class="LOGICGENERAL" width="100%" >
		 						<tr>
		 							 <td class="LOGIC_TOPLEFTBORDER">&nbsp;</td>
	             		 <td nowrap class="LOGIC_TOPBORDER"><span class="PAGEHEADER">Workspace Definition</span></td>
		 							 <td class="LOGIC_TOPRIGHTBORDER">&nbsp;</td>
	           			</tr>          			
								<tr><td colspan="3">&nbsp;</td></tr>
	           			<tr>
									<td width="1" valign="top">&nbsp;</td>
	           	  		<td width="*" colspan="2">
										<table border="0" width="100%" cellspacing="0" cellpadding="0">
											<tr><td colspan="2" width="*"  valign="top"><span class="HEADER">General</span></td></tr>
	                       <tr>
	                         <td colspan="2"><font size="1">&nbsp;</font></td>
	                       </tr>
	                       <tr>
	                         <td width="100"><span class="REGULARTEXT">Name: </span></td>
												<td width="*"><input class="REGULARTEXT" type="text" name="workspaceName" size="30" value="<%=workspaceName%>"></td>
	                       </tr>
	                       <tr><td colspan="2">&nbsp;</td></tr>
								      <tr>
	                        <td width="100"><span class="REGULARTEXT">Description: </span></td>
												<td width="*"><input class="REGULARTEXT" type="text" name="workspaceDesc" size="30" value="<%=workspaceDesc%>"></td>
	                       </tr>
								      <tr><td colspan="2">&nbsp;</td></tr>
	                    <tr>
                        <td  colspan="2">
                          <table border="0" width="100%" cellspacing="0" cellpadding="0">
                            <tr>
                              <td width="33%">&nbsp;</td>
                              <td width="33%">
                                <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                  <tr>
                                    <td width="33%"><a href="javascript:doSave()" class="LINK">save</a></td>
                                    <td width="33%"><a href="workspacesDefinitionView.jsp" class="LINK">cancel</a></font></td>
                                    <td width="34%">&nbsp;</td>
                                  </tr>
                                </table>
                              </td>
                              <td width="34%">&nbsp;</td>
                            </tr>
                          </table>
                        </td>
                      </tr>
											<tr valign="bottom">
								        <td valign="bottom" colspan="2">
								        <table border="0" cellpadding="0" cellspacing="0" width="100%">
								          <tr>
								            <td class="LOGIC_BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
								            <td class="LOGIC_BOTTOMBORDER" width="33%">&nbsp;</td>
								            <td class="LOGIC_BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
								          </tr>
								        </table>
								        </td>
								      </tr>              					
                    </table>
	                </td>
								</tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
    </table>
</form>

</table>
</body>

