<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="java.util.*"%>
<%@ page import="javax.servlet.http.*"%>
<%@ page import="xpolog.logic.ui.conf.XpoLogicInitiator"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>
<%

  SiteManagment mgmt = SiteManagment.getInstance();
  Module root = mgmt.getModuleFromId("rootModule");
  UserContext userContext = UserEnvironment.getUserContext(request);


  List list = root.getModuleMembers(userContext);
  ModuleMember[] memarr = new ModuleMember[list.size()];
  list.toArray(memarr);

  boolean valid = SiteManagment.getInstance().getXpologManagment().isValidToBeActive();
  boolean isDemo = XpologLicenseManager.getInstance().isDemo();
  int daynum = XpologLicenseManager.getInstance().getDaysLeft();
  boolean allowed = false;
  boolean perm = XpologLicenseManager.getInstance().isPermanentLicense();

  boolean secureActive = false;
  String userMessage = "";
  String activeState = "inactive";
  if(userContext != null && userContext.getUser() != null){
    secureActive = true;
    userMessage = "Hello "+userContext.getUser().getUser().getDisplayName();
    activeState = "active";
  }

  Properties prop = Configuration.getInstance().getUIData();
  String userImg = BASE_DIRECTORY + prop.getProperty("gate.users.icon.image");
  String logoImg = BASE_DIRECTORY + prop.getProperty("gate.logo.image");
  String lockImg = BASE_DIRECTORY + prop.getProperty("gate.security.secure.image");
  String unlockImg = BASE_DIRECTORY +  prop.getProperty("gate.security.unsecure.image");
  //init logic
  XpoLogicInitiator.getInstance();
%>

<HTML>
<HEAD>

<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link rel="stylesheet" type="text/css" href="/logeye/css/mainproduct.css" />

<script language="javaScript">
	function updateFullPath(fullPath) {
		document.quickLog.LOG_FULL_PATH.value = fullPath.value;
	}
	 if(top.location != document.location){
	 	top.location =  document.location;
	 }
	function go() {
		document.quickLog.submit();
	}
</script>

</HEAD>

<script LANGUAGE="JavaScript1.2" src="/logeye/scripts/help/help.js"></script>
<BODY BGCOLOR="#FFFFFF">

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%" valign="top" height="100%">
      <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
        <tr>
          <td valign="top" height="100%">
          <table border="0" cellpadding="0" cellspacing="0"  width="100%">
            <tr>
              <td height="100%">
              <p align="center"><img border="0" src="<%=logoImg%>" width="350" height="150">
              </td>
            </tr>
            <tr>
              <td height="100%"><span class="REGULARTEXT"><%=userMessage%></span>
              </td>
            </tr>
            <tr>
              <td height="100%">
              </td>
            </tr>
            <tr>
              <td height="100%">
              &nbsp;
              </td>
            </tr>
            <tr>
              <td>
              <table border="0" cellpadding="0" cellspacing="0"  width="100%" style="border-collapse: collapse" bordercolor="#111111">
                <tr>
                  <td height="100%" valign="top" bgcolor="#FEEFC2" bordercolor="#875546" style="border: 1 solid #875546">
                  <table border="0" cellspacing="0" width="100%"  style="border-collapse: collapse" bordercolor="#111111">
                    <tr>
                      <td width="525"><span class="HEADER">Applications</span></td>
                    </tr>
                    <tr>
                      <td width="525"><span class="REGULARTEXT"><a href="/logeye/logic/dashboard/dashboard.jsp" class="LINK">XpoLogic
                        Transaction Monitoring</a></span></td>
                    </tr>
                    <tr>
                      <td width="525"><span class="REGULARTEXT"><a href="/logeye/root.html" class="LINK">XpoLog
                        Portal </a></span></td>
                    </tr>
                  </table>
                  </td>
                  <td height="100%" valign="top"></td>
                  <td valign="top" bordercolor="#875546" style="border: 1 solid #875546">
                  <p align="center">
                  &nbsp;<img border="0" src="/logeye/logic/images/dnaGate.gif"></p>
                  </td>
                </tr>

                <tr>
                  <td width="49%" height="100%" valign="top">
                  &nbsp;
                  </td>
                  <td width="2%" height="100%" valign="top">
                  </td>
                  <td width="49%" valign="top" height="100%">
                  </td>
                </tr>

                <tr>
                  <td width="49%" height="100%" valign="top" bgcolor="#FEEFC2" bordercolor="#875546" style="border: 1 solid #875546">
                  <table border="0" width="100%" cellpadding="2">
                    <tr>
                      <td width="100%"><span class="HEADER">Security</span></td>
                    </tr>
                    <tr>
                      <td width="100%">&nbsp;<span class="REGULARTEXT"><img border="0" src="<%=userImg%>" width="16" height="14"><a href="/logeye/settings/mailset.jsp" class="LINK">User permission mechanism <%=activeState%></a></span></td>
                    </tr>

                    <%
                      if(!Configuration.isWar()){
                    %>
                    <tr>
                      <td width="100%">
                        <%
                          final ServerAdmin sad = SiteManagment.getAdminInstance().getServerAdministrator();
                          String url = "http://" + request.getServerName() +":";
                          String surl = "https://" + request.getServerName() +":";
                          String hport = String.valueOf(sad.getHttpPort());
                          String sport = String.valueOf(sad.getSslPort());

                          if(request.getServerPort() == sad.getSslPort()){
                        %>
                          <img border="0" src="<%=unlockImg%>" width="28" height="28"><span class="REGULARTEXT"><a href=<%=url+hport%> class="LINK">Switch to unsecured connection</a> <span class="SMALLTEXT">(faster)</span></span>
                        <%
                          } else {
                        %>
                          <img border="0" src="<%=lockImg%>" width="30" height="30"><span class="REGULARTEXT"><a href=<%=surl+sport%> class="LINK">Switch to secure connection</a>
                        <span class="SMALLTEXT">(slower)</span></span>
                        <%
                          }
                        %>
                      </td>
                    </tr>
                    <%
                      }//iswar
                    %>

                    <tr>
                      <td width="100%"></td>
                    </tr>
                  </table>
                  </td>
                  <td width="2%" height="100%" valign="top">
                  </td>
                  <td width="49%" valign="top" height="100%" bgcolor="#FEEFC2" bordercolor="#875546" style="border: 1 solid #875546">
                  &nbsp;
                  </td>
                </tr>

                <tr>
                  <td width="49%" height="100%" valign="top">
                  </td>
                  <td width="2%" height="100%" valign="top">
                  </td>
                  <td width="49%" valign="top" height="100%">
                  </td>
                </tr>

                </table>
              </td>
            </tr>
          </table>
          </td>
        </tr>
        </table>
    </td>
  </tr>
  <tr>
          <td valign="top">
          <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
            <tr>
              <td width="100%" style="border-top-width: 1" align="center">

              <%
                if(valid){
              %>
                  <%if(perm){%>
              <span class="LICENSEMESSAGE">You have a permanent license.</span>
                        <a href=javascript:openHelp('<%=BASE_DIRECTORY%>') class="MEDIUMLINK"><font color="#FF0000">help</font></a>
                  <%}else if(daynum > 0){
                      if (daynum < 60){%>

                        <span class="LICENSEMESSAGE">Your <%=isDemo?"trial version ":""%>license will expire in <%=String.valueOf(daynum)%> days.</span>
                        <a href=javascript:openHelp('<%=BASE_DIRECTORY%>') class="MEDIUMLINK"><font color="#FF0000">help</font></a>
                    <%
                       }
                      }else{
                    %>
                        <span class="LICENSEMESSAGE">Your <%=isDemo?"trial version ":""%> license has expired. Xpolog will not work
                        properly.</span>
                        <a href=javascript:openHelp('<%=BASE_DIRECTORY%>') class="MEDIUMLINK"><font color="#FF0000">help</font></a>
                      <font size="2" color="#FF0000"><b>&nbsp;</b></font>
                    <%}%>
              <%
               }else {%>
              <span class="LICENSEMESSAGE">Your license is not valid.</span>
               <%}
              %>


              </td>
            </tr>
            <tr>
              <td width="100%" class="TOPLEFTRIGHTBORDER">
                <p align="center">&nbsp;<B><span class="REGULARTEXT">Copyright  2004 XpoLog Ltd. All rights reserved</span></b></p>
              </td>
            </tr>
            </table>
          </td>
  </tr>

</table>

	<form AUTOCOMPLETE="OFF" name="quickLog" action="/logeye/quicklog/quickLogAction.jsp" method="post">
		<input type="hidden" name="LOG_FULL_PATH">
	</form>
</BODY>
</HTML>