<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@page import="xpolog.logic.transaction.data.TransactionParadigm"%>
<%@page import="xpolog.logic.brain.BrainConfigurationRepository"%>
<%@ page import="java.util.List"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
  WebSecurityManager manager = WebSecurityManager.getInstance();
  SiteManagment mgmt = SiteManagment.getInstance();
  
  String baseDirectory = request.getParameter("baseDirectory");
  if (baseDirectory == null){
  	baseDirectory = BASE_DIRECTORY;
  }
  String baseDirectory2 = request.getParameter("baseDirectory2");
  if (baseDirectory2 == null){
  	baseDirectory2 = baseDirectory;
  }

  String mode = request.getParameter("mode");
  if (mode == null || mode.length() == 0){
  	mode = "trans";
  }
  
  
  TransactionParadigm tran = null;
  String tranName = "";
  String tranId = request.getParameter("TRAN_ID");
  if (tranId != null && tranId.length() > 0){
    try {
    	int index = tranId.indexOf("@");
			if (index > 0){
				String projectId = tranId.substring(0,index);
				String id = tranId.substring(index + 1);
				TransactionParadigm paradigm = BrainConfigurationRepository.getRepository().getTransactionParadigmById(id);
				if (paradigm != null){
					tranName = paradigm.getName();
				}
			}
			
    }catch (Exception e){}
  }else {
  	tranId = "";
  }
  
  
  String treeName = request.getParameter("treeName");
  if (treeName == null || treeName.length() == 0){
  	treeName = "tree";
  }
  
  String ignoreHeaderStr = request.getParameter("ignoreHeader");
  boolean ignoreHeader = ignoreHeaderStr != null && ignoreHeaderStr.equals("true");
  
  String parameterName = request.getParameter("parameterName");
  if (parameterName == null || parameterName.length() == 0){
  	parameterName = "Transaction:";
  }
  String labelWidth = request.getParameter("labelWidth");
  String tranNameWidth = request.getParameter("tranNameWidth");
  
  String useTextBoxStr = request.getParameter("useTextBox");
  boolean useTextBox = useTextBoxStr == null || !useTextBoxStr.equals("false");
  
  String textBoxSize = request.getParameter("textBoxSize");
  if (textBoxSize == null || textBoxSize.length() == 0){
  	textBoxSize = "40";
  }
  
  String textBoxDisabledStr = request.getParameter("textBoxDisabled");
  boolean textBoxDisabled = textBoxDisabledStr == null || !textBoxDisabledStr.equals("false");  

  String openLinkName = request.getParameter("openLinkName");
  if (openLinkName == null || openLinkName.length() == 0){
  	openLinkName = "open";
  }
  
  String closeLinkName = request.getParameter("closeLinkName");
  if (closeLinkName == null || closeLinkName.length() == 0){
  	closeLinkName = "close";
  }

  String checkEditPermissionsStr = request.getParameter("checkEditPermissions");
  boolean checkEditPermissions = checkEditPermissionsStr != null && checkEditPermissionsStr.equals("true");

  String treeOnlyStr = request.getParameter("treeOnly");
  boolean treeOnly = treeOnlyStr != null && treeOnlyStr.equals("true");

  String noTreeStr = request.getParameter("noTree");
  boolean noTree = noTreeStr != null && noTreeStr.equals("true");
  
  
%>

<% if (!ignoreHeader){ %>

<jsp:include page="selectTransaction.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
	<jsp:param name="baseDirectory2" value="<%=baseDirectory2%>" />
	<jsp:param name="treeName" value="<%=treeName%>" />
	<jsp:param name="TRAN_ID" value="<%=tranId%>" />
	<jsp:param name="mode" value="<%=mode%>" />
	<jsp:param name="checkEditPermissions" value="<%=checkEditPermissions%>" />
	<jsp:param name="useTextBox" value="<%=useTextBox%>"/>	
</jsp:include>

<%} %>



<table border="0" cellpadding="0" cellspacing="0" width="100%" >
	<%if (!treeOnly){%>
	<tr>
		<td >
		<table border="0" cellpadding="0" cellspacing="0"  width="100%" >
			<tr>
				<td <%=labelWidth != null ? "width=\"" + labelWidth + "\"" : ""%>>
					<span class="REGULARTEXT"><%=parameterName%></span>
				</td>
				<td <%=!useTextBox && tranNameWidth != null ? "width=\"" + tranNameWidth + "\"" : "width=\"100\""%>>
				<% if (useTextBox){ %>
				<input name="tranName" id="tranName" type="text" size="<%=textBoxSize%>" value="<%=tranName == null || tranName.length() == 0 ? "" : tranName%>" <%=textBoxDisabled ? "readonly" : "" %> class="<%=textBoxDisabled ? "DISABLED_TEXTBOX" : ""%>" onClick="resetBgColor(this,'<%=textBoxDisabled ? "DISABLED_TEXTBOX" : ""%>')">
				<%} else {%>
					<span class="REGULARTEXT" id="tranName">&nbsp;<b><%=tranName == null || tranName.length() == 0 ? "&nbsp;" : tranName%></b></span>
				<%} %>
				</td>
				<td width="*" align="left" style="padding-left:10"><div id="showLink"><a class="BUTTON_MEDIUMLINK" href="javascript:showTransactionTree()"><%=openLinkName%></a></div></td>
			</tr>
		</table>
		</td>
	</tr>
	<tr height="5">
	<td >
		<table border="0" cellpadding="0" cellspacing="0"  width="100%" >
			<tr>
	    <td <%=labelWidth != null ? "width=\"" + labelWidth + "\"" : ""%> style="font-size:5pt">
					<span style="font-size:5pt">&nbsp;</span>
				</td>
			<td>
				 <div id="tranErrorMsg" style="display:none;" class="ERROR_MSG">
				 </div>
			</td>
			</tr>
			</table>
		</td>
	</tr>
	<%}%>
	<%if (!noTree){%>
	<tr >
  	<td width="15%" height="18">
  	<div id="treeDiv" style="disply:none">
    <table border="0" width="100%">
			<tr>
				<td valign="top">
					<div id="loadingDiv" style="display:none">
						<span class="REGULARTEXT">Loading...</span>
					</div>
				</td>
			</tr>
			<tr>
				<td width="15%">
				<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
					<tr>
						<td valign="top">
							<div id="treeboxbox_treeSelectTransaction"></div>
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</div>
		</td>
	</tr>
	<%}%>
</table>

<% if (!ignoreHeader && !noTree){ %>
<script>
	createTree("treeboxbox_tree","<%=tranId%>");	
	<%if (tran != null && (mode.equals("trans"))){%>	  
		hideTransactionTree();
	<%}%>
</script>
<%}%>

