<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.cloud.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="xpolog.logic.brain.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.config.image.*"%>
<%@ page import="xpolog.logic.filters.SessionFilterManager"%>

<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY_2 = "../../";
%>
<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ENTERPRISE_PERMISSION,true)){
		return;
	}

	String ERROR_OBJ = "ERROR_OBJ";

	SiteManagment mgmt = SiteManagment.getInstance();
	UserContext userContext = UserEnvironment.getUserContext(request);

	Collection transactionsCol = BrainConfigurationRepository.getRepository().getTransactionsParadigms();
	TransactionParadigm[] transactions = (TransactionParadigm[]) transactionsCol.toArray(new TransactionParadigm[transactionsCol.size()]);

%>

<%@page import="xpolog.eye.data.filters.FilterCollection"%>
<%@page import="xpolog.eye.computation.impl.FilterComputationDefUnit"%>
<%@page import="xpolog.eye.computation.conf.HealthConfig"%>
<%@page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<script>
	function openTranFilters(id){
		if (document.getElementById(id).style.display == ""){
			document.getElementById(id).style.display = "none";
			document.getElementById("img_"+id).src = "<%=BASE_DIRECTORY_2%>images/tree/plusnode.gif";
		}else{
			document.getElementById(id).style.display = "";
			document.getElementById("img_"+id).src = "<%=BASE_DIRECTORY_2%>images/tree/minusnode.gif";
		}
	}
</script>

<%if (transactions != null && transactions.length > 0){%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td height="18"><span class="HEADER">TxExpo Transactions</span></td>
              </tr>
              <tr>
                <td >&nbsp;</td>
              </tr>
              <%for(int i=0;i<transactions.length;++i) {
              	  String checked = "";
              	  TransactionParadigm tran = transactions[i];
              	  SessionFilterManager sdfmgr = new SessionFilterManager(tran.getId());
              	  List fcs = sdfmgr.getFilterCollections(true,true,true);
              	  if (fcs == null || fcs.size() == 0){
              	  	continue;
              	  }
              %>
							<tr>
								<td style="padding-left:3">
								<table border="0">
									<tr>
										<td style="border:1px solid white;padding-left:5" align="center" width="10" valign="top">
											<img id='img_<%=tran.getId()%>' border="0" src="<%=BASE_DIRECTORY_2%>images/tree/plusnode.gif" onclick="javascript:openTranFilters('<%=tran.getId()%>')">
										</td>
										<td style="padding-left:5" valign="top">
											<span class="REGULARTEXT"><%=tran.getName()%></span>
											<div id="<%=tran.getId()%>" style="display:none">
												<table border="0">
													<%
													for (int j=0; j<fcs.size(); j++) {
														FilterCollection fc = (FilterCollection)fcs.get(j);
														String desc = "";
										  			if(fc != null) {
										  				FilterComputationDefUnit[] compArr = fc.getDefUnits();	  			
										  				if(compArr!= null) {
										  					for(int k=0;k<compArr.length;k++) {
										  						FilterComputationDefUnit defUnit = compArr[k];
										  						if(defUnit != null) {
										  							HealthConfig healthConfig = ComputationConfiguration.getInstance().getHealthConfig(defUnit.getType());
										  							if(healthConfig != null) {
										  								desc += defUnit.getType();
											  							desc += " - ";
											  							desc += defUnit.getWeight();
											  							if(k < compArr.length-1) {
											  								desc += ", ";
											  							}	
										  							}	  							
										  						}
										  					}
										  				}
										  			}	  	
													%>
													<tr>
														<td>
															<input type="checkbox" name="transFilter" value="<%=tran.getId()+","+fc.getId()%>">
															<span class="REGULARTEXT"><%=fc.getName() + " (" + (desc.length() > 0 ? desc : "n/a") + ")"%></span>
														</td>
													</tr>
													<%} %>
												</table>
											</div>
										</td>
										
									</tr>
								</table>
								</td>
							</tr> 
              <%}%>
          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		
<%}%>