

function doPrev() {
	doPaging("prev");
}

function doNext() {
	doPaging("next");
}

function goToPage(pageNumber) {
	doPaging("goToPage", pageNumber);
}

function doPaging(pagingActionType, pageNumber) {
	document.getElementById("actionType").value = "show";
	document.getElementById("pagingActionType").value = pagingActionType;
	if(pageNumber) {
		document.getElementById("pageNumber").value = pageNumber;
	}
	document.getElementById("access").submit();
}
 
var resultId;
var action;
function saveResult(id) {
	resultId = id;
 	showLayerInMiddle("saveTransactionDiv", -1, 150);
	var saveAndExecuteHeaderDiv = document.getElementById("saveAndExecuteHeaderDiv");
 	saveAndExecuteHeaderDiv.style.display = "none";
 	var saveHeaderDiv = document.getElementById("saveHeaderDiv");
 	saveHeaderDiv.style.display = "";
	var transactionName = document.getElementById("tranName");
	transactionName.focus();
	action = "saveResult";
}

function saveAndExecuteResult(id) {
	resultId = id;
 	showLayerInMiddle("saveTransactionDiv", -1, 150);
	var saveHeaderDiv = document.getElementById("saveHeaderDiv");
 	saveHeaderDiv.style.display = "none";
	var saveAndExecuteHeaderDiv = document.getElementById("saveAndExecuteHeaderDiv");
 	saveAndExecuteHeaderDiv.style.display = "";
	var workspaceId = document.getElementById("wsId");
	workspaceId.focus();
	action = "saveAndExecuteResult";
}
 
function continueSave() {
	var workspaceId = document.getElementById("wsId").value;
	var workspaceName = document.getElementById("wsName").value;
	var projectId = document.getElementById("pjId").value;
	var projectName = document.getElementById("pjName").value;
	var transactionName = document.getElementById("tranName").value;
	
	if(action == "saveAndExecuteResult") {
		if((workspaceId == "" || workspaceId == "-1") && workspaceName == "") {
			alert('Please specify the name of the workspace');
			document.getElementById("wsName").focus();
			return;
		}else if((!projectId || projectId == "-1") && projectName == "") {
			alert('Please specify the name of the project');
			document.getElementById("pjName").focus();
			return;
		}else if(transactionName == '') {
			alert('Please specify the name of the transaction');
			document.getElementById("tranName").focus();
			return;
		}
		document.getElementById("execute").value = "true";
	}else if(action == "saveResult") {
		if(transactionName == '') {
			alert('Please specify the name of the transaction');
			document.getElementById("tranName").focus();
			return;
		}
		document.getElementById("execute").value = "false";
	}
	
	document.getElementById("workspaceId").value = workspaceId;
	document.getElementById("workspaceName").value = workspaceName;
	document.getElementById("projectId").value = projectId;
	document.getElementById("projectName").value = projectName;
	document.getElementById("transactionName").value = transactionName;
	
	hideLayer("saveTransactionDiv");

	document.getElementById("actionType").value = "save";
	document.getElementById("resultId").value = resultId;
	document.getElementById("access").submit();
}

function editProcessName() {
	showLayerInMiddle("editProcessNameDiv", -1, 150);
	var newProcessName = document.getElementById("newProcessName");
	newProcessName.value = document.getElementById("processName").value;
	newProcessName.focus();
}

var xmlHttpRequestObjectContinueEditProcessName;
function continueEditProcessName() {
	var processId = document.getElementById("processId").value;
	var newProcessName = document.getElementById("newProcessName").value;
	if(!newProcessName || newProcessName == '') {
		alert("Process name was not specified");
		return;
	}
	
	var url = "editProcessNameAction.jsp";
	var parameters = "";
	parameters += "processId=" + processId;
	parameters += "&newProcessName=" + escape(newProcessName);
	
	xmlHttpRequestObjectContinueEditProcessName = GetXmlHttpObject();
	xmlHttpRequestObjectContinueEditProcessName.open("POST", url, true);
  xmlHttpRequestObjectContinueEditProcessName.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectContinueEditProcessName.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectContinueEditProcessName.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectContinueEditProcessName.onreadystatechange = continueEditProcessNameCallback;
  xmlHttpRequestObjectContinueEditProcessName.send(parameters);
  
	
}

function continueEditProcessNameCallback() {
	if (xmlHttpRequestObjectContinueEditProcessName.readyState == 4) {
		if (xmlHttpRequestObjectContinueEditProcessName.status == 200) {
			var xmlDoc = xmlHttpRequestObjectContinueEditProcessName.responseXML.documentElement;
			var statusElement = xmlDoc.getElementsByTagName("Status")[0];
			var status = statusElement.getAttribute("status");
			var editProcessNameErrorTd = document.getElementById("editProcessNameErrorTd");
			
			if(status == "ok") {
				var newProcessName = statusElement.getAttribute("newProcessName");
				document.getElementById("processName").value = newProcessName;
				processNameTd.innerHTML = newProcessName + getEditLinkHtml();
				
				editProcessNameErrorTd.innerHTML = '';
				hideLayer("editProcessNameDiv");
			}else {
				var errorsInnerHTML = "";
				
				var errorsElement = xmlDoc.getElementsByTagName("Errors")[0];
				errorsInnerHTML = errorsElement.childNodes[0].nodeValue;
				editProcessNameErrorTd.innerHTML = errorsInnerHTML;
			}
		}
	}
}

function getEditLinkHtml() {
	return '&nbsp;&nbsp;&nbsp;<a href="javascript:editProcessName()" class="REPORT_HEADER_LINK">edit</a>';
}

function cancelSave(div) {
	hideLayer(div);
}

function shownHidediv(targetDiv) {
 	var d = document.getElementById(targetDiv);
  if (!d){
		return;
 	}
 	var hideDiv = document.getElementById(targetDiv + "Hide");
 	var showDiv = document.getElementById(targetDiv + "Show");	 
 	show = d.style.display == "";
 	if(show){
 	  d.style.display="none";   		
 		if(hideDiv && showDiv) {
 			hideDiv.style.display="none";
	 		showDiv.style.display="";
	 	}
	}else{
 		d.style.display="";
 		if(hideDiv && showDiv) {
 			hideDiv.style.display="";
 			showDiv.style.display="none";
 		}
 	}
}

var runningProcesses = new Array();
var numberOfRunningProcess = 0;
var callsCounter = new Date().getTime();

var xmlHttpRequestObjectUpdateProcessesProgress;
function updateProcessesProgress() {
	xmlHttpRequestObjectUpdateProcessesProgress = GetXmlHttpObject();
	
	var url = "updateProcessesProgress.jsp";
 	var parameters = "";
	parameters += "&counter=" + callsCounter++;
	xmlHttpRequestObjectUpdateProcessesProgress.open("POST", url, true);
  xmlHttpRequestObjectUpdateProcessesProgress.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xmlHttpRequestObjectUpdateProcessesProgress.setRequestHeader("Content-length", parameters.length);
  xmlHttpRequestObjectUpdateProcessesProgress.setRequestHeader("Connection", "close");
 	xmlHttpRequestObjectUpdateProcessesProgress.onreadystatechange = updateProcessesProgressCallback;
  xmlHttpRequestObjectUpdateProcessesProgress.send(parameters);
}
		
function updateProcessesProgressCallback() {
	if (xmlHttpRequestObjectUpdateProcessesProgress.readyState == 4) {
		if (xmlHttpRequestObjectUpdateProcessesProgress.status == 200) {
			numberOfRunningProcess = 0;
			var xmlDoc = xmlHttpRequestObjectUpdateProcessesProgress.responseXML.documentElement;
			var statusElements = xmlDoc.getElementsByTagName("Status");
			
			var needReload = false;
			for(var i = 0; i < statusElements.length; i++) {
				numberOfRunningProcess++;
				var statusElement = statusElements[i];
				var processId = statusElement.getAttribute("processId");
				var running = statusElement.getAttribute("running");
				var currentStatus = statusElement.getAttribute("currentStatus");
				
				if(running == 'true') {
					var runningProcessTd = document.getElementById("runningProcess" + processId + "Td");
					if(runningProcessTd) {
						runningProcessTd.innerHTML = currentStatus;
					}
				}else {
					needReload = true;
				}
			}
			if(needReload || numberOfRunningProcess < runningProcesses.length) {
				window.location.reload();
			}else {
				setTimeout("updateProcessesProgress()", 2000);
			}
		}
	}
}