<%@ page language="java"%>

<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.util.WebUtil"%>

<%@ page import="xpolog.logic.detect.TransactionDetectionManager"%>

<%!static final String BASE_DIRECTORY = "../../";%>

<%
  String processId = request.getParameter("processId");
  if(processId == null || processId.equals("")) {
  	return;
  }
  
	ErrorModel errmodel = new ErrorModel();
	
  String newProcessName = request.getParameter("newProcessName");
  if(newProcessName == null || newProcessName.trim().equals("")){
    errmodel.addError("Process name was not specified.");
  }
	if(newProcessName != null && WebUtil.isContainSpecialCharecter(newProcessName)){
    errmodel.addError("The following charecters are prohibited in the process name field: "+WebUtil.getSpecialCharectersList());
 	}
	
	if(errmodel.getErrorCount() == 0) {
	  final TransactionDetectionManager detectionManager = TransactionDetectionManager.getInstance();
	  detectionManager.editProcessName(processId, newProcessName);
	}
	
	StringBuffer result = new StringBuffer();
	
	result.append("<EditProcessNameResult>");
	if(errmodel.getErrorCount() == 0) {
		result.append("<Status status=\"ok\" newProcessName=\"" + newProcessName + "\" />");
	}else {
		result.append("<Status status=\"fail\" />");
		result.append("<Errors>");
		result.append("<![CDATA[");
		result.append("<table border=0 cellspacing=0 cellpadding=0>");
		String[] errors = errmodel.getErrors();
		for(int i = 0; i < errors.length; i++) {
			result.append("<tr><td class=PROCESSING_TEXT align=left>* " + errors[i] + "</td></tr>");
		}
		result.append("</table>");
		result.append("]]>");
		result.append("</Errors>");
	}
	result.append("</EditProcessNameResult>");
	
	response.setContentType("text/xml");
	out.write(result.toString());
	out.flush();
%>