/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
var slider=new Array();
slider[1]=new Object();
slider[1].min=0;
slider[1].max=100;
slider[1].minVal=0;
slider[1].maxVal=100;
slider[1].onchange=setBoxValue;
slider[2]=new Object();
slider[2].onchange=setBoxValue;
slider[3]=new Object();
slider[3].min=0;
slider[3].max=100;
slider[3].minVal=0;
slider[3].maxVal=100;
slider[3].onchange=setBoxValue;
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function setBoxValue(minVal, maxVal, field) {
  minVal = Math.round(minVal);
  maxVal = Math.round(maxVal);
  if(field == 1) {
	  document.getElementById("slider" + field + "Text").value = minVal + "% - " + maxVal + "%";
	}else if(field == 2) {
		document.getElementById("slider" + field + "Text1Display").value = getFormattedValue(minVal);
		document.getElementById("slider" + field + "Text2Display").value = getFormattedValue(maxVal);
		document.getElementById("slider" + field + "Text1").value = minVal;
		document.getElementById("slider" + field + "Text2").value = maxVal;
	}else if(field == 3) {
	  document.getElementById("slider" + field + "Text").value = minVal + "% - " + maxVal + "%";
	}
}
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

function sliderMouseUp(e) {
  var el = sliderFromEvent(e);
	if (!el) return;

	if(el.num == 1) {
		var frm = getFrameByName("main");
		if(frm.showResults) {
			frm.document.getElementById("minTimeDistanceThreshold").value = getMinSliderText("slider1Text", 1);
			frm.document.getElementById("maxTimeDistanceThreshold").value = getMaxSliderText("slider1Text", 1);
		}
	}else if(el.num == 2) {
		var frm = getFrameByName("main");
		if(frm.showResults) {
			frm.document.getElementById("minTimeThreshold").value = getSliderText("slider2Text1", 0);
			frm.document.getElementById("maxTimeThreshold").value = getSliderText("slider2Text2", 0);
		}
	}else if(el.num == 3) {
		var frm = getFrameByName("main");
		if(frm.showResults) {
			frm.document.getElementById("minPercentageThreshold").value = getMinSliderText("slider3Text", 1);
			frm.document.getElementById("maxPercentageThreshold").value = getMaxSliderText("slider3Text", 1);
		}
	}
}

function doThresholds() {
	var frm = getFrameByName("main");
	if(frm.showResults) {
		frm.document.getElementById("minTimeDistanceThreshold").value = getMinSliderText("slider1Text", 1);
		frm.document.getElementById("maxTimeDistanceThreshold").value = getMaxSliderText("slider1Text", 1);
		if(document.getElementById("slider02")) {
			frm.document.getElementById("minTimeThreshold").value = getSliderText("slider2Text1", 0);
		}
		if(document.getElementById("slider02")) {
			frm.document.getElementById("maxTimeThreshold").value = getSliderText("slider2Text2", 0);
		}
		frm.document.getElementById("idFilter").value = document.getElementById("idFilter").value;
		frm.document.getElementById("minPercentageThreshold").value = getMinSliderText("slider3Text", 1);
		frm.document.getElementById("maxPercentageThreshold").value = getMaxSliderText("slider3Text", 1);
		frm.showResults();
	}
}

function getSliderText(slider, suffixLength) {
	var sliderText = document.getElementById(slider).value;
	sliderText = sliderText.substring(0, sliderText.length - suffixLength);
	return sliderText;
}

function getMinSliderText(slider, suffixLength) {
 	var sliderText = document.getElementById(slider).value;
 	var index = sliderText.indexOf("-");
 	if(index > -1) {
 		sliderText = sliderText.substring(0, index);
 	}
 																											// -1 because of the space before the dash 
 	sliderText = sliderText.substring(0, sliderText.length - 1 - suffixLength);
 	return sliderText;
}

function getMaxSliderText(slider, suffixLength) {
 	var sliderText = document.getElementById(slider).value;
 	var index = sliderText.indexOf("-");
 	if(index > -1) {
	 																				// +1 because of the space after the dash 
 		sliderText = sliderText.substring(index + 1 + 1);
 	}
 	sliderText = sliderText.substring(0, sliderText.length - suffixLength);
 	return sliderText;
}

var timeUnits = new Array();
timeUnits[0] = 1;
timeUnits[1] = 1 * 1000;
timeUnits[2] = 1 * 1000 * 60;
timeUnits[3] = 1 * 1000 * 60 * 60;
timeUnits[4] = 1 * 1000 * 60 * 60 * 24;

var timeUnitsStr = new Array();
timeUnitsStr[0] = 'ms';
timeUnitsStr[1] = 'sec';
timeUnitsStr[2] = 'min';
timeUnitsStr[3] = 'hour';
timeUnitsStr[4] = 'day';

function getFormattedValue(value) {
	var result = "";
	var firstUnit, intValue = parseInt(value), intTimeUnit;
	for(var i = timeUnits.length - 1; i >= 0; i--) {
		intTimeUnit = parseInt(timeUnits[i]);
		firstUnit = intValue / intTimeUnit;
		if(firstUnit >= 1 || i == 0) {
			result += formatNumber(value / intTimeUnit, 2);
			result += " ";
			result += timeUnitsStr[i];
			break;
		}
	}
	return result;
}

function formatNumber(number, dec) {
	return Math.round(number*Math.pow(10,dec))/Math.pow(10,dec);
}