<%@page import="java.util.Iterator"%>
<%@page import="xpolog.eye.meta.MetaDataManager"%>
<%@page import="java.util.HashMap"%>
<%@page import="xpolog.logic.ui.ctrl.DataSession"%>
<%@page import="xpolog.logic.ui.ctrl.CtrlMgr"%>
<%@page import="xpolog.logic.ui.util.WorkspaceRenderer"%>
<%@page import="xpolog.logic.ConfigMgr"%>
<%@page import="xpolog.logic.ui.ctrl.Workspace"%>
<%@page import="xpolog.logic.ui.ctrl.RootWorkspace"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%

	String	TYPE_WORKSPACE = "Workspace";
	String TYPE_PROJECT = "DataSession";


	SiteManagment mgmt = SiteManagment.getInstance();
	UserContext userContext = UserEnvironment.getUserContext(request);
	CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
	MetaDataManager metaDataMgr = mgmt.getMetaDataMgr();
	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	
  RootWorkspace rootWorkspace = new RootWorkspace();
  rootWorkspace.setName("Workspaces");
  rootWorkspace.setId("Workspaces");
  Workspace[] workspaces = ctrlMgr.getWorkspaces(userContext);
  for (int i=0; i<workspaces.length; i++){
  	rootWorkspace.addDataSessionId(workspaces[i].getId());
  }
  

  HashMap workspacesMap = null;
  HashMap projectsMap = null;
  HashMap transactionsMap = null;
  
  String[] wsIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,XpoLogObjectTypes.WORKSAPCE_TYPE);
  String[] projectsIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,XpoLogObjectTypes.PROJECT_TYPE);
  String[] transactionsIds = null;//metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,XpoLogObjectTypes.TRANSACTION_TYPE);

  HashMap partialSelectedProjectsIds = metaDataMgr.getMetaDataObjectsChildrens();
  HashMap partialProjectsMap = null;
	if(partialSelectedProjectsIds != null){
		partialProjectsMap = (HashMap)partialSelectedProjectsIds.get(systemMetaDataId);
	}
  
  if (wsIds != null){
  	workspacesMap = new HashMap();
  	for (int i=0; i<wsIds.length; i++){
  		workspacesMap.put(wsIds[i],wsIds[i]);
  	}
  }
 
  HashMap projTrans = new HashMap();
  if (projectsIds != null){
  	projectsMap = new HashMap();
  	for (int i=0; i<projectsIds.length; i++){
  		if (partialProjectsMap != null){
  			String s = (String)partialProjectsMap.get(XpoLogObjectTypes.PROJECT_TYPE + "-" + projectsIds[i]);
  			if (s != null && s.length() > 0){
  				String[] trans = s.split(",");
  				String tranId = null;
  				for (int j=0; j<trans.length; j++){
  					int ind = trans[j].indexOf("-");
  					if (ind != -1){
  						tranId = trans[j].substring(ind+1);
  						HashMap transMap = (HashMap)projTrans.get(projectsIds[i]);
  						if (transMap == null){
  							transMap = new HashMap();
  							projTrans.put(projectsIds[i],transMap);
  						}
  						transMap.put(tranId,tranId);
  					}
  				}
  				continue; //don't put in projectsMap
  			}
  		}
  		projectsMap.put(projectsIds[i],projectsIds[i]);
  	}
  }
 
  if (transactionsIds != null){
  	transactionsMap = new HashMap();
  	for (int i=0; i<transactionsIds.length; i++){
  		transactionsMap.put(transactionsIds[i],transactionsIds[i]);
  	}
  }
  
  HashMap openProjects = projectsMap != null ? (HashMap)projectsMap.clone() : new HashMap();
  HashMap openWorkspaces = workspacesMap != null ? (HashMap)workspacesMap.clone() : new HashMap();
  WorkspaceRenderer.addParents(openWorkspaces, openProjects, transactionsMap);
  
  String rootId = request.getParameter("rootId");
  if (rootId == null){
  	rootId = "0";  	
  }
	
	WorkspaceRenderer renderer = new WorkspaceRenderer(userContext, workspacesMap,projectsMap,transactionsMap, rootId);
	renderer.setSelectedProjTransactions(projTrans);
  
	String type = "";
	String treeXml = ""; 
  String id = request.getParameter("id");
  if (id != null){
  	String objid = id;
  	int ind = id.indexOf("-");
  	if (ind != -1){
  		objid = id.substring(ind+1);
  		type = id.substring(0,ind);
			if(type.equals(TYPE_WORKSPACE)){
				Workspace currWorkspace = ctrlMgr.getWorkspaceById(objid);
				if(currWorkspace != null){
				renderer.setWorkspace(currWorkspace);
				treeXml = renderer.getWorkspaceTreeXML();
				}else{
					treeXml = "";
				}
			}
			if(type.equals(TYPE_PROJECT)){
				DataSession currProject = ctrlMgr.getDataSessionById(objid);
				renderer.setProject(currProject);
				treeXml = renderer.getProjectTreeXML();
			}			
  	}

  }else{ //rootWS
 		if (partialProjectsMap != null){
 			Iterator it = partialProjectsMap.keySet().iterator();
   		String key;
   		int ind;
   		String projType,projId;
  		while (it.hasNext()){
 				key = (String)it.next();
 				ind = key.indexOf("-");
 				if (ind != -1){
 					projType = key.substring(0,ind);
 					if (projType != null && projType.equals(XpoLogObjectTypes.PROJECT_TYPE)){
 						projId = key.substring(ind+1);
 						openProjects.put(projId,projId);
 					}
 				}
 			}
 		}
  	renderer.setRootWorkspace(rootWorkspace);
    WorkspaceRenderer.addParents(openWorkspaces, openProjects, transactionsMap);
		renderer.setOpenWorkspaces(openWorkspaces);
		renderer.setOpenProjects(openProjects);
  	treeXml = renderer.getRootTreeXML();
  }
	response.setContentType("text/xml");
	//System.out.println(treeXml);
		out.write(treeXml);
		out.flush();



%>  