<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="xpolog.logic.ConfigMgr"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>

<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY = "../../";
	
  String getTreeDiv(Workspace node,UserContext userContext,HashMap workspaces,HashMap projects,HashMap transactions,boolean addTypeToId,String treeName){
    ArrayList list = new ArrayList();
    StringBuffer buffer = new StringBuffer();
	  String type = addTypeToId ? "Workspace," : "";
	  if (treeName == null || treeName.length() == 0) treeName = "tree";
    
    if (node != null){
      boolean selected = false;
      String treeKey = "node" + node.getId() + "_0";
      String chkKey = node.getId().equals("Workspaces") ? "root" : "workspaces";
      String name = node.getName();
      if (name == null){
      	name = "";
      }
      String desc = node.getDescription();
      if (desc == null){
      	desc = "";
      }
      buffer.append("\nvar " + treeKey + " = "+treeName+".addNode("+treeName+".root,\"" + chkKey + "\",\"" + type+node.getId() + "\",\"" + name + "\",\"" + desc + "\",''," + selected + ",true);");
      addChildsNodeDiv(node,buffer,treeKey,userContext,workspaces,projects,transactions,addTypeToId,treeName);
    }
    return buffer.toString();
  }
  
  void addChildsNodeDiv(LogicNode node,StringBuffer buffer, String parentKey,UserContext userContext,HashMap workspaces,HashMap projects,HashMap transactions, boolean addTypeToId, String treeName){
		Workspace ws = null;
  	if(!(node.getType().equals(Workspace.WORKSPACE) || node.getType().equals(DataSession.DATA_SESSION))){
  		return;
  	}
		List children = node.getMembers();
		Collections.sort(children, new Comparator(){
			public int compare(Object o1, Object o2){
				if (o1 == null){
					return -1;
				}else if (o2== null){
					return 1;
				}else{
					LogicNode ln1 = (LogicNode)o1;
					LogicNode ln2 = (LogicNode)o2;
					return ln1.getName().compareTo(ln2.getName());
				}
			}
		});
		String type = null;
		for (int i = 0; i < children.size(); i++) {
			LogicNode child = (LogicNode)children.get(i);
			if (child == null){
				continue;
			}
			String key = child.getId();
      String treeKey = parentKey + "_" + i;
      String parentNode = parentKey.equals("node") ? "tree.root" : parentKey;
      
      String name = child.getName();
      if (name == null){
      	name = "";
      }
      String desc = child.getDescription();
      if (desc == null){
      	desc = "";
      }
	    type = addTypeToId ? child.getType()+"," : "";
      String extraText = "";
      
      boolean selected = false;
      String chkKey = "transactions";
      if(child.getType().equals(Workspace.WORKSPACE)){
        selected = workspaces != null && workspaces.containsKey(child.getId());
        chkKey = "workspaces";
      }else if (child.getType().equals(DataSession.DATA_SESSION)){
        selected = projects != null && projects.containsKey(child.getId());
	      chkKey = "projects";
      }else{
      	//selected = transactions == null || transactions.containsKey(child.getId());
	      //chkKey = "transactions";
	      continue;
	    }
      buffer.append("\nvar " + treeKey + " = "+treeName+".addNode(" + parentNode + ",\"" + chkKey +"\",\"" + type+child.getId() + "\",\"" + name + "\",\"" + desc + "\",'" + extraText + "'," + selected + ",false);");
      addChildsNodeDiv(child,buffer,treeKey,userContext,workspaces,projects,transactions,addTypeToId,treeName);
    }
  }
%>
     
     
<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ENTERPRISE_PERMISSION,true)){
		return;
	}

	String ERROR_OBJ = "ERROR_OBJ";

	SiteManagment mgmt = SiteManagment.getInstance();
	UserContext searchUserContext = (UserContext)request.getSession().getAttribute(MetaDataSearchQuery.META_DATA_USER_CONTEXT);

  RootWorkspace rootWorkspace = new RootWorkspace();
  rootWorkspace.setName("Workspaces");
  rootWorkspace.setId("Workspaces");
  Workspace[] workspaces = ConfigMgr.getInstance().getCtrlMgr().getWorkspaces();
  for (int i=0; i<workspaces.length; i++){
  	rootWorkspace.addDataSessionId(workspaces[i].getId());
  }

  HashMap workspacesMap = null;
  HashMap projectsMap = null;
  HashMap transactionsMap = null;
  
	String treeCode = getTreeDiv(rootWorkspace,searchUserContext,workspacesMap,projectsMap,transactionsMap,true,"txExpoTree");
%>

<script>
	Tree.prototype.writeNodeData = writeNodeData2;
	Tree.prototype.selectTreeNode = selectTreeNode2;
	
	function writeNodeData2(node){ 
	  if (!node.isLeaf()){
	    var img = "<%=BASE_DIRECTORY%>" + (node.expand ? collapseImage : expandImage);  
	    document.writeln("<img src=\"" + img + "\" onClick=\"javascript:selectNode(" + node.index + "," + node.tree.name + ")\" id=\"ExpandImage_" + this.name + "_" + node.index + "\"  class=\"" + node.tree.nodeImageStyle + "\">");
	  }
	  var arr = node.id.split(",");
	  var nodeType = arr[0];
	  var nodeId = arr[1];
	  if (nodeType = "Workspace"){
			document.writeln("&nbsp;<a href=../../logic/admin/session/sessionsListView.jsp?workspaceId="+nodeId+"><span class=\"LINK\">" + node.name + "</span></a>");
		}else{
			document.writeln("&nbsp;<a href=../../logic/admin/session/sessionView?sessionId="+nodeId+"><span class=\"LINK\">" + node.name + "</span></a>");
		}
	  if (node.desc && node.desc != ""){
	     document.writeln("&nbsp;(" + node.desc + ")");
	  }
	  if (node.text && node.text != ""){
	     document.writeln("&nbsp;" + node.text);
	  }  
	}
	
	function selectTreeNode2(node){	
		var expand = !node.expand;	
		node.expand = expand;
		var expImage = document.getElementById("ExpandImage_" + node.tree.name + "_" + node.index);
		if (expImage){
		  expImage.src = "../../" + (expand ? collapseImage : expandImage);
		}
		for (var i = 0; i < node.childs.length; i++){
		  var childDiv = document.getElementById("DivNode_" + node.childs[i].tree.name + "_" + node.childs[i].index);
		  if (childDiv){
		    if (expand){
		      childDiv.style.display = "";
		    }else {
		      childDiv.style.display = "none";
		    }
		  }
		}
	}

</script>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td height="28" colspan="3"><span class="HEADER">TxExpo workspaces and projects</span></td>
              </tr>
              <tr>
                <td>&nbsp;</td>
              </tr>
							<tr>
								<td>
								<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
									<tr>
										<td class="REGULARTEXT">
											<script>
												 var txExpoTree = createTree("txExpoTree");
												 <%=treeCode%>
												 txExpoTree.onSelectMarkChilds = false;
												 txExpoTree.onSelectMarkParents = false;
												 txExpoTree.writeTree();
											</script>
										</td>
									</tr>
								</table>
								</td>
							</tr>           	
						</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		