<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>

<%@ page import="xpolog.logic.common.*"%>
<%@ page import="xpolog.logic.atomic.data.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.transaction.status.*"%>
<%@ page import="xpolog.logic.routine.data.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.ui.util.*"%>
<%@ page import="xpolog.logic.brain.model.*"%> 
<%@ page import="xpolog.logic.brain.*"%> 
<%@ page import="xpolog.logic.filters.*"%> 
<%@ page import="xpolog.logic.ui.graph.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.ui.log.data.transactions.TransactionQuery" %>
<%@ page import="xpolog.logic.ui.site.*"%>
<%@ page import="xpolog.logic.sources.xplg.*"%>

<%@ page import="java.text.*"%>
<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%!
  public String transformDateToString(Date d){
    return xpolog.eye.site.SiteUtil.formatDefaultDate(d,true);
  }
%>

<%!
  public Transaction getTransactionFromId(Transaction[] trans, String transactionId){
  	if (trans == null){
  		return null;
  	}
  	for (int i=0; i<trans.length; i++){
  		if (trans[i].getId() != null && trans[i].getId().equals(transactionId)){
  			return trans[i];
  		}
  	}
  	return null;
  }
%>


<%
	String ERROR_OBJ = "ERROR_OBJ";

  LogicEnvironment logicEnv = LogicEnvironment.getLogicEnvironment(request);

  TransResultBuilder transResultBuilder = (TransResultBuilder)request.getSession().getAttribute("currentTransResultBuilder");
  TransactionQuery tranQuery = transResultBuilder == null ? null : transResultBuilder.getTranQuery();
	
  String tranId = request.getParameter("runtime_tran_id");
  if(tranId == null){
  	 tranId = "";
  }
  Transaction tran = null;
  String paradigmId = ""; 
  if (tranQuery != null){
  	Transaction[] trarrbuffer = (Transaction[])request.getSession().getAttribute("transactionsList");

  	
    tran = getTransactionFromId(trarrbuffer,tranId);
    request.getSession().setAttribute("SelectedTransaction",tran);
    
    paradigmId = tranQuery.getParadigmId();
  }else {
  	request.getSession().removeAttribute("SelectedTransaction");
  }
	
  String dataFilterId = (String)request.getParameter("data_filter_id");

  LogicDirectedGraph graphModel = null;
  BrainConfigurationRepository rep = BrainConfigurationRepository.getRepository();
  String zoomWithFilterStr = xpolog.config.Configuration.getInstance().getPropertiesManager().getProperty("logic.ui.analysis.zoomInWithFilter","false");
  boolean zoomInWithFilter = zoomWithFilterStr == null ? false : zoomWithFilterStr.equalsIgnoreCase("true");

  List messages = new ArrayList();
  String graphImg = null;
  JGraphImageDescriptor imageDescriptor = null;

 
  
	TransResultBuilder tranResultBuilder = (TransResultBuilder)request.getSession().getAttribute("currentTransResultBuilder");

  HashMap routinesDesc = new HashMap();
  long  transactionTime = -1;
  String  transactionTimeStr = null;
  
  String root = request.getParameter("root");
  boolean isRoot = root != null && root.equals("true");
  
  TransactionDetailsResult detailsResult = null;
	ArrayList errorMessages = new ArrayList();
	TransactionDetailsResult oldDetailsResult = tranResultBuilder == null ? null : tranResultBuilder.getDetailsResult();
	try {
  if(tran != null){  	
  	boolean isNew = oldDetailsResult == null || !oldDetailsResult.getTranId().equalsIgnoreCase(tranId);
  	
  	detailsResult = isNew ? new TransactionDetailsResult() : oldDetailsResult;
  	DataSessionRuntime dsr = tranQuery.getDataSessionRuntime();
    TransactionTypeViewModel model  = tranResultBuilder.getTranTypeViewModel();
  	if (isNew){
  		model = TransactionTypeViewModelFactory.createTransactionTypeViewModel(dsr);
      UITransactionParadigmBuilder builder = new UITransactionParadigmBuilder();
      builder.loadTransactionGraph(tran.getTransactionParadigm().getId());
		  XpoLogAtomicParadigm[] unusable = UITransactionParadigmHelper.checkTransationParadigmValidity(builder);
		  if (unusable != null && unusable.length > 0){
	      errorMessages.add("Error in transaction definition");
	      errorMessages.add("The are problems with the following data sources:");
	      HashSet set = new HashSet();
	      for (int i=0; i<unusable.length; i++){	      	
	    	  String lbmId = (unusable[i] == null || unusable[i].getDateSource() == null) ? "N/A" : unusable[i].getDateSource().getLbmId();
	    	  String nodeId = (unusable[i] == null || unusable[i].getDateSource() == null) ? null : unusable[i].getDateSource().getNodeId();
	    	  StringBuffer message = new StringBuffer();
	    	  message.append("Log Id: "+lbmId);
	    	  if (nodeId!=null&&nodeId.length()>0 ){
	    		  xpolog.eye.cloud.XplgNode node = SiteManagment.getInstance().getCloudMgr().getNodeById(nodeId);
	    		  String nodeName = node != null ? node.getName() : nodeId;
	    		  message.append(" (XpoLog Node Id: "+nodeName+". Check that remote node is up and that the remote log is accessible)");
	    	  }
	    	  set.add(message.toString());
	      }
	      Iterator it = set.iterator();
	      while (it.hasNext()){
	    	  errorMessages.add((String)it.next());
	      }
		  }
  	}
		
		String heightStr = request.getParameter("graphHeight");
		String widthStr = request.getParameter("graphWidth");
		
		int height = 330;
		int width = isRoot? 750 : 550;
		int graphTopHeight = 70;
		if (heightStr != null && heightStr.length() > 0){
			try {
				height = Integer.parseInt(heightStr);								
			}catch (Exception e){}
		}
		
		if (widthStr != null && widthStr.length() > 0){
			try {
				width = Integer.parseInt(widthStr);
				if (isRoot){
					width += 150;
				}
			}catch (Exception e){}
		}
		
		boolean isGraphChanged = height != detailsResult.getGraphHeight() || width != detailsResult.getGraphWidth();
		
		String messagesWidth = request.getParameter("messagesWidth");

	  if (messagesWidth == null || messagesWidth.length() == 0){
	  	messagesWidth = isRoot? "750" : "550";
	  } 
	  
	  int mesW = Integer.parseInt(messagesWidth);
	  if (isRoot){
	  	mesW += 150;
		}
	  messagesWidth = String.valueOf(mesW);
		
	  if (isNew){
  	  graphModel = model.loadGraphModelForTransaction(tran);
  	  messages = model.getMessagesFromGraph(tran);
  	  model.setZoomInWithFilter(zoomInWithFilter);
  	  model.setBaseDirectory(BASE_DIRECTORY);
  	  model.setDataFilterId(dataFilterId);
  	  messages = model.getAllMessagesFromGraph(tran);
  	  
  	  if (messages != null && messages.size() > 1){
        Routine rout1 = (Routine)messages.get(0);
        Routine rout2 = (Routine)messages.get(messages.size()-1);
        transactionTime = rout2.getCreatedTimeStamp() - rout1.getCreatedTimeStamp();
      
        transactionTimeStr = xpolog.eye.util.DateUtil.formatTime(transactionTime,new DecimalFormat("##.##"));
      }
      
			detailsResult.setRoutinesSec(routinesDesc);
	    detailsResult.setMessages(messages);
	    detailsResult.setErrorMessages(errorMessages);  	    
	    detailsResult.setTransactionTimeStr(transactionTimeStr);
      
	  }
	  
    detailsResult.setTranId(tranId);    
    detailsResult.setDataFilterId(dataFilterId);    
    detailsResult.setMessagesWidth(messagesWidth);
    detailsResult.setDoReset(false);
    
    tranResultBuilder.setDetailsResult(detailsResult);
    tranResultBuilder.setTranTypeViewModel(model);
  }else {
  	tranResultBuilder.setDetailsResult(null);
  }
  
  }catch (Exception e){
  	ErrorModel.log.error("Failed to create tranResultBuilder data",e);
  	if (tranResultBuilder != null){
    	tranResultBuilder.setDetailsResult(null);
  	}
  }
%>

<html>
<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
</head>
<body bgcolor="#FFFFFF">
<script>
  if (parent){
  	parent.detailsActionLoaded('<%=tranId%>');
  }
</script>
</body>
</html>
