<%@ page language="java"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.util.regex.*"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%> 
<%@ page import="xpolog.eye.data.*"%> 
<%@ page import="xpolog.config.*"%> 
<%@ page import="xpolog.eye.data.filters.*"%> 

<%@ page import="xpolog.logic.brain.BrainDataRepository"%>
<%@ page import="xpolog.logic.brain.BrainConfigurationRepository"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.transaction.status.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.routine.data.*"%>
<%@ page import="xpolog.logic.brain.model.*"%>
<%@ page import="xpolog.logic.common.*"%>
<%@ page import="xpolog.logic.filters.*"%>
<%@ page import="xpolog.logic.ui.site.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.ui.log.data.transactions.TransactionQuery" %>

<%!static final String BASE_DIRECTORY = "../../";%>

<%!
  String dateFormat = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
  String millisecondsSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator",".");
  String dateFormatMS = dateFormat+millisecondsSeperator+"SSS";

  public String transformDateToString(Date d,long timeDiff){
    if(d == null){
      return null;
    }
    if (timeDiff != 0){
     long time = d.getTime();
  	 d = ((Date)d.clone());
  	 d.setTime(time + timeDiff); 
    }
    String format = "";
    if (d.getTime() % 1000 == 0){
      format = dateFormat;
    } else {
      format = dateFormatMS;
    }
    String str = new SimpleDateFormat(format).format(d);
    return str;
   }
%>
<%
			int ALLOWED_FILTER_NAME_LENGTH = 20;
			String ERROR_OBJ = "ERROR_OBJ";
			String OP = "OP";
			String ADD = "ADD";
			String TYPE_LOG = "Log";
			String RECORD_FILTER = "RecordFilter";
			String ROUTINE_DATA_FILTER_ID = "data_filter_id";
			String ROUTINE_PARADIGM_ID = "routine_paradigm_id";
			String LEAP_TOP = "leap_top";
			String DIRECTION = "direction";
			String APP_NAME = "appName";
			String TOTAL_TRANSACTIONS = "totalTrans";
			String TRANS_POS = "trans_pos";
			String FILTER_COLLECTION_ID = "filter_collection_id";

			WebSecurityManager manager = WebSecurityManager.getInstance();
			if (!manager.checkForPermission(request, response, null, true)) {
				return;
			}
			UserSecurity user = manager.getUserSecurity(request);

			String viewType = request.getParameter("viewType");
			if (viewType == null || viewType.length() == 0){
				viewType = "1";
			}
			
			LogicEnvironment logicEnv = LogicEnvironment.getLogicEnvironment(request);
			String sessionRuntimeId = logicEnv.getSessionRuntimeId();
			DataSessionRuntime dsr = null;
			if (sessionRuntimeId != null && !sessionRuntimeId.equals("")) {
				dsr = CtrlMgr.getInstance().getDataSessionRuntimeById(sessionRuntimeId);
			}
			if (dsr == null) {
				dsr = new DataSessionRuntime();
				dsr.setId(DataSession.ONLINE_DATA_SESSION_ID);
			}
			TransactionTypeViewModel model = TransactionTypeViewModelFactory.createTransactionTypeViewModel(dsr);
			BrainConfigurationRepository rep = BrainConfigurationRepository.getRepository();
			TransResultBuilder transResultBuilder = (TransResultBuilder)request.getSession().getAttribute("currentTransResultBuilder");
		  TransactionQuery tranQuery = transResultBuilder.getTranQuery();

			String tranId = request.getParameter("runtime_tran_id");

			Transaction tran = (Transaction) request.getSession().getAttribute("SelectedTransaction");
			String routineParadigmId = "";
			String filterCollectionId = "";
			String appName = request.getParameter(APP_NAME);
			if (appName != null) {
				appName = appName.replaceAll("\\*", ".*");
				appName = appName.replaceAll("\\?", ".?");
			} else {
				appName = "";
			}
			String paradigmId = request.getParameter("tran_id");
			if (paradigmId == null) {
				paradigmId = tranQuery.getParadigmId();
			}
			String[] ids = { paradigmId };
			SessionFilterManager sdfmgr = (SessionFilterManager) request.getSession().getAttribute("sessionDataFilterManager");
			FilterCollection fc = sdfmgr.getFilterCollectionById(sdfmgr.getActiveFilterId());
			TransactionsResult result = transResultBuilder.getLastResult();

			String totalTransactions = "na";
			int numTrans = transResultBuilder.getTotalNumberOfTransactions();
			if (numTrans != -1){
				totalTransactions = String.valueOf(numTrans);
			}

			String useLastResultStr = request.getParameter("use_last_result");
			boolean useLastResult = (useLastResultStr != null && useLastResultStr.equals("true"));

			Transaction[] trarr = (Transaction[])request.getSession().getAttribute("transactionsList");
			boolean usingFilter = fc != null;

			boolean na = false;
			if (trarr == null || trarr.length == 0) {
				na = true;
			}
			String posString = TransResultHelper.getCurrentPositionString(transResultBuilder);
			int total = transResultBuilder.getTotalNumberOfTransactions();
			String totalStr = total <= 0 ? "" : String.valueOf(total);
			
			String leaptop = (String)request.getSession().getAttribute(LEAP_TOP);
			if (leaptop == null) leaptop = "25";
			
			String heightStr = request.getParameter("height");
		  int height = Integer.parseInt(heightStr);
		  
		  List fcl = sdfmgr.getFilterCollections(false,true);
		  FilterCollection[] rdfArr = (FilterCollection[])fcl.toArray(new FilterCollection[fcl.size()]);
		  String selectedFilterCollectionId = sdfmgr.getActiveFilterId();
		  
		  StatusTransactionFilter statusFilter = null;
		  FilterCollection statusFilterFC = tranQuery.getStatusFilter();
		  List statusList = statusFilterFC == null ? null : statusFilterFC.getByName("StatusFilter");
		  if (statusList != null && statusList.size() > 0){
		  	statusFilter = (StatusTransactionFilter)statusList.get(0);
		  }
		  
		  
//		Start date filter section
			DateFilter datefl = null;
			
			String DATE_MIN_FILTER_ACTIVE = "DateMinFilterActive";
			String DATE_MAX_FILTER_ACTIVE = "DateMaxFilterActive";
			String DATE_MIN_FILTER_ACTIVE_PARAM = "DATE_MIN_FILTER_ACTIVE_PARAM";
			String DATE_MAX_FILTER_ACTIVE_PARAM = "DATE_MAX_FILTER_ACTIVE_PARAM";
			String DATE_MINIMUM = "DateMinimum";
			String DATE_MAXIMUM = "DateMaximum";
			String DATE_FILTER_MINIMUM_PARAM = "DATE_FILTER_MINIMUM_PARAM";
			String DATE_FILTER_MAXIMUM_PARAM = "DATE_FILTER_MAXIMUM_PARAM";

			long timeDiff = 0;
			Date minDate = null;
			Date maxDate = null;
			String minDateStr = "";
			String maxDateStr = "";
			String minStat = "";
			String maxStat = "";
			String timeunit = "";
			String isTimeLim = "";
			String daystatsel = "";
			String minstatsel = "";
			String hourstatsel = "selected";
			String weekstatsel = "";
			String monthstatsel = "";
			boolean isLast = true;  
			
			FilterCollection timeFilterFC = tranQuery.getDbTimeFilter();
			if (timeFilterFC!=null){
				List list = timeFilterFC.getFilters();
				datefl = list == null || list.size() == 0 ? null : ((EventFilter)list.get(0)).getDateFilter();
				if (datefl != null){
					if(datefl.getTimeType() == -1){
						minDate = datefl.getMinDate();
						maxDate = datefl.getMaxDate();
					}else{
						hourstatsel = "";
						isLast = datefl.isLastOpType();
						isTimeLim = "checked";
						timeunit = String.valueOf(datefl.getTimeGap());
						if(datefl.isMonths()){
							monthstatsel = "selected";
						}else if(datefl.isWeeks()){
							weekstatsel = "selected";
						}else if(datefl.isDays()){
							daystatsel = "selected";      
						}else if(datefl.isHours()){
							hourstatsel = "selected";
						}else if(datefl.isMinutes()){
							minstatsel = "selected";
						}else {
							hourstatsel = "selected";
			      }
			    }
					 long minTimeDiff = timeDiff;
					  if(minDate != null){    
					    minStat = "checked";
					  }

					  long maxTimeDiff = timeDiff;
					  if(maxDate != null){  
					    maxStat = "checked";
					  }
					  minDateStr = transformDateToString(minDate,minTimeDiff);			  
					  maxDateStr = transformDateToString(maxDate,maxTimeDiff);
		    }
		  }
			
			%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/jsdomenu.css" />
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/calendar/calendar2.js"></script><!-- Date only with year scrolling -->
<script>  
  var menu_base_directory = "<%=BASE_DIRECTORY%>";
</script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script  src="<%=BASE_DIRECTORY%>scripts/comps/jsdomenu.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/comps/slider.js" type="text/javascript" ></script>
<script>
	var lastSelectedId = "<%=tran != null ? "tr_"+tran.getId() : ""%>";
	var allowShowHideAdv = true;
	
	function openInParent(id,elemId){
		if (document.getElementById(lastSelectedId)) document.getElementById(lastSelectedId).className = '';
		if (document.getElementById(elemId)) document.getElementById(elemId).className = 'SELECTED_BG_COLOR';
		lastSelectedId = elemId;
		parent.showTransGraph(id);
	}
	
	function setAllowShowHideAdv(allow){
		parent.setAllowShowHideAdv(allow);
	}
	
	function enterFilter(){
	 enterBtn(document.getElementById("filterOperation"));
	 enterBtn(document.getElementById("FilterBut")); 
	}
	
	function exitFilter(){
	  exitBtn(document.getElementById("filterOperation"));
	  exitBtn(document.getElementById("FilterBut")); 
	}
	
	function enterBtn(comp){
	  setClassName(comp,"LINKBTNOVER");
	}
	
	function exitBtn(comp){
	  setClassName(comp,"LINKBTN");
	}
	
	function createFilterMenu() {
		filterMenu = new jsDOMenu(80,"","absolute");
		with (filterMenu) {
			addMenuItem(new menuItem("Edit", "editItem", "javascript:editFilter()"));
			addMenuItem(new menuItem("New", "newItem", "javascript:newFilter()"));
			
			newItem = new jsDOMenu(100,"","absolute");
			with(newItem){
				addMenuItem(new menuItem("Data filter", "newDataFilter", "javascript:newFilter()"));
				addMenuItem(new menuItem("Event filter", "newEventFilter", "javascript:newEventFilter()"));
				addMenuItem(new menuItem("Multi", "newMulti", "javascript:newMultiFilter(false)"));
				addMenuItem(new menuItem("Negate", "newNegate", "javascript:newMultiFilter(true)"));
			}
      filterMenu.items.newItem.setSubMenu(newItem);
	    addMenuItem(new menuItem("Duplicate", "duplicateItem", "javascript:duplicateFilter()"));
			addMenuItem(new menuItem("-"));
			addMenuItem(new menuItem("Remove", "removeItem", "javascript:removeFilter()"));

		}
		filterChanged();
		
	}

	function filterChanged(){
		enable = document.access.dataFilters.selectedIndex > 0;
		setItemEnabled(filterMenu.items.editItem,enable);
		setItemEnabled(filterMenu.items.removeItem,enable);
		setItemEnabled(filterMenu.items.duplicateItem,enable);
	}
	
	function showHideAdvanced(){
		if (allowShowHideAdv == true){
			show = document.getElementById("advanced").style.display == "";
			if(show){			  
				document.getElementById("advanced").style.display  = "none";
				document.getElementById("filterTabsTD").background  = "<%=BASE_DIRECTORY%>logic/images/tranview/filterTimeBasic.gif";
				//document.getElementById("showAdvanced").style.display  = "";
				//document.getElementById("hideAdvanced").style.display  = "none";
			}else{
			  if (document.getElementById("timeRule").style.display == ""){
			    showHideTimeRule();
			  }
				document.getElementById("advanced").style.display = "";
				document.getElementById("filterTabsTD").background  = "<%=BASE_DIRECTORY%>logic/images/tranview/filterSelectedTime.gif";
				//document.getElementById("seperator").style.display  = "";
				//document.getElementById("showAdvanced").style.display  = "none";
				//document.getElementById("hideAdvanced").style.display  = "";
			}
		}
	}
	
	function showHideTimeRule(){
		if (allowShowHideAdv == true){
			show = document.getElementById("timeRule").style.display == "";
			if(show){			  
				document.getElementById("timeRule").style.display  = "none";
				document.getElementById("filterTabsTD").background  = "<%=BASE_DIRECTORY%>logic/images/tranview/filterTimeBasic.gif";
				//document.getElementById("seperator").style.display  = "none";
				//document.getElementById("showTimeRule").style.display  = "";
				//document.getElementById("hideTimeRule").style.display  = "none";
			}else{
			  if (document.getElementById("advanced").style.display == ""){
			    showHideAdvanced();
			  }
				document.getElementById("timeRule").style.display = "";
				document.getElementById("filterTabsTD").background  = "<%=BASE_DIRECTORY%>logic/images/tranview/filterTimeSelected.gif";
				//document.getElementById("seperator").style.display  = "";
				//document.getElementById("showTimeRule").style.display  = "none";
				//document.getElementById("hideTimeRule").style.display  = "";
			}
		}
	}
	
	function setAllowShowHideAdv(allow){
		allowShowHideAdv = allow;
	}
	
	function showMenuPopup(comp,menuName){  
	 
   var exists;
   eval('exists = typeof ' + menuName);
   if ( exists == 'undefined' ){
     return;
   }

  
  m = eval(menuName);
  
  if (!m){
    return;
  }
  if (m.isShow()){
    hideVisibleMenus();
  }else {
    x = findPosX(comp)-50;
    y = findPosY(comp) + comp.offsetHeight + 10;
    m.moveTo(x,y);   
    setTimeout(menuName + ".show()",20);
  }
}


function editFilter(){
		id = document.access.dataFilters.options[document.access.dataFilters.selectedIndex].value;
		path = "<%=BASE_DIRECTORY%>logic/online/filters/TransFilterRedirector.jsp?OP=EDIT&trans_paradigm_id=<%=paradigmId%>&<%=FILTER_COLLECTION_ID%>="+id;
		if (parent){
		  parent.document.location = path;
		}
	}

	function removeFilter(){
		id = document.access.dataFilters.options[document.access.dataFilters.selectedIndex].value;
		path = "<%=BASE_DIRECTORY%>logic/online/filters/removeFilterCheck.jsp?<%=FILTER_COLLECTION_ID%>="+id;
		if (parent){
		  parent.document.location = path;
		}
	}

	function newFilter(){
		path = "<%=BASE_DIRECTORY%>logic/online/filters/TransactionFilter.jsp?trans_paradigm_id=<%=paradigmId%>&OP=ADD";
		if (parent){
		  parent.document.location = path;
		}
	}

	function newMultiFilter(negate){
		if(negate == false && document.access.dataFilters.options.length < 3){
			alert("There must be at least two exsiting filters in order to create a Multi Filter.");
			return;
		}
		path = "<%=BASE_DIRECTORY%>logic/online/filters/multiFilter.jsp?trans_paradigm_id=<%=paradigmId%>&OP=ADD";
    if (negate == true){
    	path = path + "&Negate=true";
    }
		if (parent){
		  parent.document.location = path;
		}
	}

	function newEventFilter(){
		path = "<%=BASE_DIRECTORY%>logic/online/filters/eventFilter.jsp?trans_paradigm_id=<%=paradigmId%>&OP=ADD";
		if (parent){
		  parent.document.location = path;
		}
	}

	function goFilter(){
		id = document.access.dataFilters.options[document.access.dataFilters.selectedIndex].value;
		path = "TransView.jsp?<%=FILTER_COLLECTION_ID%>="+id;
		generate();
	}

	function duplicateFilter(){
		id = document.access.dataFilters.options[document.access.dataFilters.selectedIndex].value;
		path = "<%=BASE_DIRECTORY%>logic/online/filters/TransFilterRedirector.jsp?OP=duplicate&trans_paradigm_id=<%=paradigmId%>&<%=FILTER_COLLECTION_ID%>="+id;
		if (parent){
		  parent.document.location = path;
		}
	}
	
	function generate(){
		var statString = "";
		var successStatString = "";
		var filterQueryString = "";
		document.access.filterGenerate.value="true";
		document.access.filter.value="active";	
		document.access.<%=FILTER_COLLECTION_ID%>.value = document.access.dataFilters.options[document.access.dataFilters.selectedIndex].value;		
		document.access.submit();
	}
	
	function checkDate(date_check_box, date_obj){
  	date_ok = "";
  	obj_name = "";  	
  	frames['dateValidationFrame'].location = "<%=BASE_DIRECTORY%>calendar/dateValidation.jsp?dateStr="+date_obj.value+"&date_check_box="+obj_name;
  }
  
  function isNumeric(sText)
{   
    if (!sText || sText.length == 0){
      return;
    }
   var ValidChars = "0123456789";
   var IsNumber=true;
   var Char;

 
   for (var i = 0; i < sText.length && IsNumber == true; i++) 
      { 
      Char = sText.charAt(i); 
      if (ValidChars.indexOf(Char) == -1) 
         {
         IsNumber = false;
         break;
      }
   }   		
   if (!IsNumber){
     alert("Invalid number " + sText);
     return false;
   }
   return true;
   
}
	
	function getLeapTop(){
	  var combo = document.access.leaptop;
	  return combo.options[combo.selectedIndex].value;
	}

	
	
	
</script> 
</head>

<body onLoad="createFilterMenu();setAllowShowHideAdv(true);" style="margin: 0; padding: 0; border-width: 0" class="BG_COLOR">
<form AUTOCOMPLETE="OFF" id="access" name="access" method="POST" action="TransView.jsp" target="_parent">
<input type="hidden" name="filter" value="">
<input type="hidden" name="<%=FILTER_COLLECTION_ID%>" value="">
<input type="hidden" name="advancedOpen" value="">
<input type="hidden" name="timeRuleOpen" value="">
<input type="hidden" name="filterGenerate" value="">
<input type="hidden" name="viewType" value="<%=viewType%>">

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" class="#">
  <tr valign="top">
    <td width="100%" >
    <table border="0" width="100%" cellspacing="0" cellpadding="0" >
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0"  width="100%"  >
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" width="100%">
              
              <tr>
                <td valign="top">
                <table border="0" cellpadding="0" cellspacing="0" width="100%">
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" width="100%">
                    <tr >
                      <td colspan="4">
                      <table border="0" cellpadding="0" cellspacing="0" width="100%">
                      <tr>                      	
                        <td width="*" style="padding-right:5" align="right">&nbsp;</td>                        
                        <td id="filterTabsTD" width="155" height="25" style="padding-left:5" class="SMALLTEXT"  align="right" background="<%=BASE_DIRECTORY%>logic/images/tranview/filterTimeBasic.gif">                                                                        
                        <table border="0" cellpadding="0" cellspacing="0" width="100%" >
                      <tr >                          
                     
                        <td style="padding-left:15">
                        <a href='javascript:showHideAdvanced()' class="LINK" style="text-decoration:none">                        
                        <span class="SMALLTEXT" style="color:#000000;">Filters</span>
                        </a>
                        </td>                        
                        <td style="padding-left:15">
                        <a href='javascript:showHideTimeRule()' class="LINK" style="text-decoration:none">                        
                        <span class="SMALLTEXT" style="color:#000000"><nobr>Time Rule</nobr></span>
                        </a>
                        </td>
                        </tr>
                        </table>
                        
                        </td>                        
                      </tr>
                      </table>
                      </td>
                      </tr>
                    
                    <tr style="display:none" id="advanced" bgcolor="#D0C8AD"><td colspan="4" >
											<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100">
											  <tr><td style="padding-left:10;padding-right:10">
											  <table border="0" cellpadding="0" cellspacing="0" width="100%" >
											  <tr>
											  <td colspan="3">
											  <span class="SMALLTEXT">Data</span>
											  </td>
											  </tr>
											  <tr style="padding-bottom:5">
											  <td width="50" >						 
								                          <select class="SMALLTEXT" name="dataFilters"  size="1" style="height: 20px; padding-left: 3px;" onchange="javascript:filterChanged()">
								                          <option class="SMALLTEXT" value="none" selected>None</option>
			                              			<%if (rdfArr != null){
			                              				for (int i = 0;i<rdfArr.length;i++) {
			                              					FilterCollection filter = rdfArr[i];
			                              					String routineId = "";
			                              					String routineName = "";
			                              					xpolog.eye.data.filters.Filter f = (xpolog.eye.data.filters.Filter)filter.getFilters().get(0);
			                              					if (filter.getFilters().size() > 0 && f instanceof TransactionFilter){
			                              						routineId = ((TransactionFilter)f).getRoutineParadigmId();
			                              					}
			                              					RoutineParadigm rp = rep.getRoutineParadigmById(routineId);
			                              					if (rp != null){
			                              						routineName = rp.getName();
			                              					}
			                              					if (routineId == null || routineId.length()==0){
			                              						routineName = "TRANS";
			                              					}else if(routineName == null || routineName.length()==0){
			                              						routineName = routineId;
			                              					}
			                              					String selected = rdfArr[i].getId().equals(selectedFilterCollectionId) ? "selected" : "";
			                              					if (filter == null){
			                              						continue;
			                              					}
			                              					String filterName = filter.getName()+(filter.isTransientFilter() ? "-temp" : "");
			                              					filterName += "("+routineName+")";
			                              					 String tempName = null;
			                              	                tempName = filterName;
			                              	                if(filterName != null && filterName.length() > ALLOWED_FILTER_NAME_LENGTH) {
			                              	                	tempName = filterName.substring(0,ALLOWED_FILTER_NAME_LENGTH) + "...";
			                              	                }
			                              			%>
								                          	<option class="SMALLTEXT" value="<%=rdfArr[i].getId()%>" <%=selected%>><%=tempName%></option>
								                          <%
								                          	}
								                          }
								                          %>
									                        </select>
							                    	    </td>   
							                    	     <td width="*" align="left" style="padding-left:5">
																				  <table border="0" cellpadding="0" cellspacing="0" width="100%" >                             
																				  <tr>
													   						    <td width="40" id="filterOperation" class="LINKBTN" onmouseenter="javascript:enterFilter();" onmouseleave="javascript:exitFilter();">
												         					   <a href="javascript:generate()" class="LINK">Filter</a>
												         				    </td>
													   						    <td width="10" valign="top" id="FilterBut" class="LINKBTN" onClick="javascript:showMenuPopup(this,'filterMenu')" onmouseenter="javascript:enterFilter();" onmouseleave="javascript:exitFilter();">
												           					  <img src="<%=BASE_DIRECTORY%>images/logview/downArrow.png" >
													  						    </td>
													  						    <td width="*">&nbsp;</td>
													  						    </tr>
													  						   </table>
													  						  </td> 
											  </tr>
											  <tr height="1" bgcolor="#FFFFFF"><td colspan="3"> </td></tr>
											  </table>
											  </td>
											  </tr>
											  <tr style="padding-bottom:5;padding-top:10">
											  <td align="left" style="padding-left:10">
											  <table border="0" cellpadding="0" cellspacing="0" width="150">
											  <tr>
											  <td width="60"><span class="SMALLTEXT">Status</span></td>
											  <td width="30"><span class="SMALLTEXT">Flow</span></td>
											  <td width="30"><span class="SMALLTEXT">Time</span></td>
											  <td width="30"><span class="SMALLTEXT">Data</span></td>
											  </tr>
											  <tr>
			                                  <td width="60" nowrap><span class='SMALLTEXT'>Error</span></td>
			                                  <td nowrap><input type="checkbox" name="status_4" value="2;3_4" <%=statusFilter == null || statusFilter.isContain("4",2) ? "checked" : ""%>></td>
			                                  <td nowrap><input type="checkbox" name="status_2" value="2" <%=statusFilter == null || statusFilter.isContain("2",2) ? "checked" : ""%>></td>
			                                  <td nowrap><input type="checkbox" name="status_5" value="2" <%=statusFilter == null || statusFilter.isContain("5",2) ? "checked" : ""%>></td>			                                  
			                                  
			                                </tr>
			                                <tr>
			                                  <td width="60" nowrap><span class='SMALLTEXT'>Normal</span></td>
			                                  <td nowrap><input type="checkbox" name="status_4" value="0_1;0_1_2" <%=statusFilter == null || statusFilter.isContain("4",1) ? "checked" : ""%>></td>
			                                  <td nowrap><input type="checkbox" name="status_2" value="0_1" <%=statusFilter == null || statusFilter.isContain("2",1) ? "checked" : ""%>></td>
			                                  <td nowrap><input type="checkbox" name="status_5" value="0_1" <%=statusFilter == null || statusFilter.isContain("5",1) ? "checked" : ""%>></td>
			                                </tr>
											  </table>											  
											  </td>
											  </tr>
											  
											  		
											  <tr style="padding-top:16">
											  <td align="left" style="padding-left:10">
											  <table border="0" cellpadding="0" cellspacing="0" width="100%">
											  <tr>
											  <td width="*">&nbsp;</td>
											  <td width="68" height="26" background="<%=BASE_DIRECTORY%>logic/images/tranview/filtergobg.gif" align="center">
											  <table border="0" cellpadding="0" cellspacing="0" width="100%" >
											  <tr>
											  <td align="right" >
											  <a href="javascript:generate()" style="text-decoration:none">
											  <span class="REGULARTEXT" style="color:#FFFFFF;font-weight:bold">GO</span>
											  </a>
											  </td>
											  <td align="left" style="padding-right:10;padding-left:5">
											  <a href="javascript:generate('')" style="text-decoration:none">
											  <img src="<%=BASE_DIRECTORY%>logic/images/tranview/rightWhiteArraow.gif" border="0">
											  </a>
											  </td>
											  </tr>
											  </table>
											  </td>
											  </tr>
											  </table>
											  </tr>
											  
											  
											</table>                    
                    </td></tr>
                    
                    
                     <tr style="display:none" id="timeRule" bgcolor="#D0C8AD"><td colspan="4" >
											<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100">
											  <tr style="padding-top:20"><td>
											  <table border="0" cellpadding="0" cellspacing="0" width="100%" >											  
											  <tr>
											  <td width="100%" style="padding-left:5">
											  
											  <input type="hidden" name="quickDateFilter" value="true">
												<table border="0" width="100%" cellspacing="0" cellpadding="0">
												<tr height="0"><td> <iframe name="dateValidationFrame" style="visibility:hidden" width="0" height="0"></iframe></td></tr>
												<tr>
                          <td width="25" rowspan="3" valign="top" style="padding-top:3"><input type="radio" id="TimeLimRadio" checked name="Dates" value="TimeLimRadio"></td>
                          <td width="30" style="padding-right:5"> <span class="SMALLTEXT"><b>From</b></span>
                          <td width="*" >                         
                          <input class="TEXTBOX" type="text" size="23" onChange="javascript:checkDate(document.access.<%=DATE_MIN_FILTER_ACTIVE%>,document.access.<%=DATE_MINIMUM%>)" name="<%=DATE_MINIMUM%>" value="<%=minDateStr==null? "" : minDateStr%>" style="font-size: 8pt" onfocus="document.access.TimeLimRadio.checked=true">&nbsp;<a href="javascript:openCal7();"  class="SMALLLINK">calendar</a><br>                         
												</td>												
                        </tr>
                        <tr style="padding-bottom:2">                        
                          <td width="30" style="padding-right:5"> <span class="SMALLTEXT"><b>To</b></span>
                          <td width="*">                             
                        		<input class="TEXTBOX" type="text" size="23" onChange="javascript:checkDate(document.access.<%=DATE_MAX_FILTER_ACTIVE%>,document.access.<%=DATE_MAXIMUM%>)" name="<%=DATE_MAXIMUM%>" value="<%=maxDateStr == null ? "" : maxDateStr%>" style="font-size: 8pt" onfocus="document.access.TimeLimRadio.checked=true">&nbsp;<a href="javascript:openCal8();"  class="SMALLLINK">calendar</a>												
                        </td>
                        </tr>
                        <tr style="padding-bottom:2">
                        <td width="30">&nbsp;</td>
                        <td width="*" ><span class="SMALLTEXT"><nobr>(<%=dateFormatMS%>)</nobr></span></td>
                        </tr>
                        <tr height="1" bgcolor="#FFFFFF"><td colspan="3"> </td></tr>
                        <tr style="padding-top:10">
                            <td width="25"><input type="radio" id="TimeUnitRadio" name="Dates" <%=isTimeLim%> value="TimeUnitRadio"></td>
                            <td width="30" style="padding-right:5"> <span class="SMALLTEXT"><b>From </b></span>
                            <td width="*">                              
															<select class="TEXTBOX" size="1" name="TimeOpType" onfocus="document.access.TimeUnitRadio.checked=true" style="font-size: 8pt">
                                <option value="1" <%=isLast?"selected":""%>>last</option>
                                <option value="2" <%=!isLast?"selected":""%>>previous</option>
                              </select>
															<input class="TEXTBOX" type="text" name="TimeText" size="3" value="<%=timeunit%>" onfocus="document.access.TimeUnitRadio.checked=true" style="font-size: 8pt" onChange="javascript:isNumeric(document.access.TimeText.value)">
                              <select class="TEXTBOX" size="1" name="TimeUnit" onfocus="document.access.TimeUnitRadio.checked=true" style="font-size: 8pt">
                                <option value="minutes" <%=minstatsel%>>minutes</option>
                                <option value="hours" <%=hourstatsel%>>hours</option>
                                <option value="days" <%=daystatsel%>>days</option>
                                <option value="weeks" <%=weekstatsel%>>weeks</option>
                                <option value="months" <%=monthstatsel%>>months</option>
                              </select>
                            </td>
                        </tr>

												</table>
											  
											  
											  
											  </td>
											  </tr>
											  
											  <tr style="padding-top:10">
											  <td align="left" style="padding-left:10">
											  <table border="0" cellpadding="0" cellspacing="0" width="100%">
											  <tr>
											  <td width="*">&nbsp;</td>
											  <td width="68" height="26" background="<%=BASE_DIRECTORY%>logic/images/tranview/filtergobg.gif" align="center">
											  <table border="0" cellpadding="0" cellspacing="0" width="100%" >
											  <tr>
											  <td align="right" >
											  <a href="javascript:generate()" style="text-decoration:none">
											  <span class="REGULARTEXT" style="color:#FFFFFF;font-weight:bold">GO</span>
											  </a>
											  </td>
											  <td align="left" style="padding-right:10;padding-left:5">
											  <a href="javascript:generate()" style="text-decoration:none">
											  <img src="<%=BASE_DIRECTORY%>logic/images/tranview/rightWhiteArraow.gif" border="0">
											  </a>
											  </td>
											  </tr>
											  </table>
											  </td>
											  </tr>
											  </table>
											  </tr>
											  
											  </table>
											  </td>
											  </tr>
											</table>                    
                    </td></tr>
                    
                    <tr height="3"><td colspan="4"> </td></tr>
                    
                    
                    
                    <tr  style="padding-bottom:1">
                      <td colspan="4" >
                      <table border="0" cellpadding="0" cellspacing="0" width="100%" >
                      <tr height="34" bgcolor="F0F0F0">                      	
                        <td width="*" style="padding-left:10" ><span class="SMALLTEXT" style="color:#000000">Total: <%=totalStr%></span></td>
                        <td width="30" class="SMALLTEXT" style="padding-right:5" align="right"><span class="SMALLTEXT" style="color:#000000">view</span></td>
                        <td width="10"  class="SMALLTEXT" style="padding-right:5"  align="left" ><select class="TEXTBOX" size="1" name="leaptop" name="leaptop" onchange="javascript:parent.refreshView()" style="height: 20px; font-family: Verdana, Geneva, Arial, Helvetica; font-size: 10px; padding-left: 3px;">
				                                    <option value="25" <%=leaptop.equals("25") ? "selected" : ""%>>25</option>
				                                    <option value="50" <%=leaptop.equals("50") ? "selected" : ""%>>50</option>
				                                    <option value="100" <%=leaptop.equals("100") ? "selected" : ""%>>100</option>
				                                    <option value="250" <%=leaptop.equals("250") ? "selected" : ""%>>250</option>
				                                    <option value="500" <%=leaptop.equals("500") ? "selected" : ""%>>500</option>
				                                  </select></td>
                      </tr>
                      </table>
                      </td>
                      </tr>
                      
                      <tr >
                      <td colspan="4">
                      <table border="0" cellpadding="0" cellspacing="0" width="100%">
                      <tr bgcolor="#5761B1">                      	
                        <td width="*" style="padding-right:5" align="right"><a href='javascript:parent.goStart()' class="LINK"><img alt="first records" src="<%=BASE_DIRECTORY%>logic/images/tranview/logicAnalysisFirst.gif" border="0"></a></td>
                        <td width="30" style="padding-rightt:5" class="SMALLTEXT" align="left"><a  href="javascript:parent.goPrev()" class="LINK"><img alt="previous records" src="<%=BASE_DIRECTORY%>logic/images/tranview/logicAnalysisPrev.gif" border="0"></a></td>
                        <td width="50" class="SMALLTEXT" nowrap align="center"><span class="SMALLTEXT" style="color:#FFFFFF"><%=posString%></span></td>
                        <td width="30" style="padding-left:5" class="SMALLTEXT"  align="right" ><a href='javascript:parent.goNext()' class="LINK"><img alt="next records" src="<%=BASE_DIRECTORY%>logic/images/tranview/logicAnalysisNext.gif" border="0"></a></td>
                        <td width="*" style="padding-left:5" class="SMALLTEXT"  align="left"><a href='javascript:parent.goLast()' class="LINK"><img alt="last records" src="<%=BASE_DIRECTORY%>logic/images/tranview/logicAnalysisLast.gif" border="0"></a></td>                        
                      </tr>
                      </table>
                      </td>
                      </tr>                     
                      <tr border="0" bgcolor="#C5CCFD">                      	
                      <%String tdWidth = "210";
	                      if(viewType != null && viewType.equals("4")){
	                      	tdWidth = "*";                      	
    	                  }
                      %>
                        <td width="<%=tdWidth%>" style="padding-left:50">
                        <table border="0" cellpadding="0" cellspacing="0" width="100%"><tr>
                         <%if(viewType != null && viewType.equals("4")){%>
                         <td width="170" align="left"><span class="ANALYSIS_LIST_TABLE_HEADER">Date</span></td>
                         <td width="50"><span class="ANALYSIS_LIST_TABLE_HEADER">Name</span></td>
	                       <td width="*" align="left" style="padding-top:2"><img src="<%=BASE_DIRECTORY%>logic/images/tranview/buttonDown.gif" border="0"></td>
                         <%}else{ %>
                         <td width="25"><span class="ANALYSIS_LIST_TABLE_HEADER">Name</span></td>
                          <td width="*" align="left" style="padding-top:2"><img src="<%=BASE_DIRECTORY%>logic/images/tranview/buttonDown.gif" border="0"></td>                       
                         <%} %>
                        </tr></table>
                        </td>
                        <td width="25" class="ANALYSIS_LIST_TABLE_HEADER" style="padding-left:3" nowrap align="right">Flow</td>
                        <td width="25" class="ANALYSIS_LIST_TABLE_HEADER" style="padding-left:3" nowrap align="center" >Time</td>
                         <%String width = "25";
	                         if(viewType != null && viewType.equals("4")){
  													width = "70";
  		                     } %>
                        <td width="<%=width%>" class="ANALYSIS_LIST_TABLE_HEADER"  nowrap align="left" style="padding-left:3">Data</td>  
                        <!-- <td width="15%" bgcolor="#FFB13E" class="SMALLTEXT" nowrap align="center">Status</td> -->
                      </tr>
		          				<tr><td colspan="4" bgcolor="#F0F0F0" style="padding-left:2"><IFRAME style="border-width:0" height="<%=String.valueOf(height-120)%>" width="100%" SRC="TransListViewResult.jsp?runtime_tran_id=<%=tranId%>&<%="tstmp="+System.currentTimeMillis()%>&viewType=<%=viewType%>" id="transListResult"></IFRAME></td></tr>
                      <tr>
                        <td width="*" colspan="4" class="SMALLTEXT">&nbsp;</td>
                      </tr>
                    </table>
                   </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
<script language="JavaScript">
 
	// create calendar object(s) just after form tag closed
			// note: you can have as many calendar objects as you need for your application
			
	var cal7 = new calendar2("<%=BASE_DIRECTORY%>",document.access.<%=DATE_MINIMUM%>,null,<%="/^\\-?\\d+(\\"+millisecondsSeperator+"\\d+)*$/"%>,"<%=millisecondsSeperator%>");
	cal7.year_scroll = true;
	cal7.time_comp = true;
	var cal8 = new calendar2("<%=BASE_DIRECTORY%>",document.access.<%=DATE_MAXIMUM%>,null,<%="/^\\-?\\d+(\\"+millisecondsSeperator+"\\d+)*$/"%>,"<%=millisecondsSeperator%>");
	cal8.year_scroll = true;
	cal8.time_comp = true;

	function openCal7(){		
		cal7.popup();
	}
	function openCal8(){		
		cal8.popup();
	}
</script>
</body>
</html>
