<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>

<%@ page import="xpolog.logic.brain.BrainConfigurationRepository"%>
<%@ page import="xpolog.logic.filters.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.transaction.data.TransactionParadigm"%>
<%@ page import="xpolog.logic.routine.data.RoutineParadigm"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%@ include file="../../../tools/sandf/textFilterAction.jsp"%>
<%@ include file="../../../tools/sandf/prioFilterAction.jsp"%>
<%@ include file="../../../tools/sandf/dateFilterAction.jsp"%>
<%@ include file="../../../tools/sandf/choiceFilterAction.jsp"%>
<%@ include file="../../../tools/sandf/numberFilterAction.jsp"%>

<%
  UserContext userContext = UserEnvironment.getUserContext(request);


  //constants

  String RECORD_MASK = "RECORD_MASK";
  String FILTER_MAN = "FILTER_MAN";
  String XPOLOG_FILTER = "XPOLOG_FILTER";
  String FILTER_COLLECTION_ID = "filter_collection_id";
  String LOG_NAME = "LOG_NAME";
  String ERROR_OBJ = "ERROR_OBJ";
  String STRING_FILTER = "StringFilter";
  String PRIORITY_FILTER = "PriorityFilter";
  String DATE_FILTER = "DateFilter";
  String CHOICE_FILTER = "ChoiceFilter";
  String NUMBER_FILTER = "NumberFilter";
  String RECORD_FILTER = "RecordFilter";
  String ROUTINE_PARADIGM_ID = "routineParadigmId";
  String TRANS_PARADIGM_ID = "trans_paradigm_id";
  String ATOMIC_PARADIGM_ID = "atomicParadigmId";
  String FILTER_NAME = "filterName";
  String STATUS_FILTER = "statusFilter";
  String DISPLAY_FILTER = "displayFilter";
  String DATA_SOURCE_ID = "ds_id";
  String ROUTINE_ID = "routine_id"; //used from addNewTransaction.jsp

  String REMOVE_FILTER_ID = "REMOVE_FILTER_ID";
  String ACTIVATE_FILTER_ID = "ACTIVATE_FILTER_ID";
  String EDIT_FILTER_ID = "EDIT_FILTER_ID";
  String OP = "OP";
  String ADD = "ADD";
  String REMOVE = "REMOVE";
  String EDIT = "EDIT";
  String DUPLICATE = "DUPLICATE";

  //page data
  FilterCollection filterCollection = null; //parent of transFilter
	AtomicDataFilter dataFilter = null;
  FilterCollection fcman = null; //son of dataFilter
  FilterManager fman = null;
  String logname    = "";
  String enc = request.getParameter("enc");
  if (enc != null && enc.trim().length() == 0){
    enc = null;
  }
  String routineParadigmId = request.getParameter(ROUTINE_PARADIGM_ID);
  String transParadigmId = request.getParameter(TRANS_PARADIGM_ID);
  String atomicParadigmId = request.getParameter(ATOMIC_PARADIGM_ID);
  String filterName = request.getParameter(FILTER_NAME);
	if (filterName != null && enc != null){
		filterName = new String(filterName.getBytes("8859_1") ,enc);
	}
  String statusFilterStr = request.getParameter(STATUS_FILTER);
  boolean statusFilter = statusFilterStr != null && statusFilterStr.equals("true");
  String displayFilterStr = request.getParameter(DISPLAY_FILTER);
  boolean displayFilter = displayFilterStr != null && displayFilterStr.equals("true");
  
	String dsId = request.getParameter(DATA_SOURCE_ID);
	String routine_id = request.getParameter(ROUTINE_ID);
	/*
	if (routine_id != null && routineParadigmId == null){
		routineParadigmId = routine_id;
	}
	*/
	String comboId = request.getParameter("combo_id");
	String url = request.getParameter("url");
	String newWindow = request.getParameter("new_window");
  boolean doAdd = request.getParameter(OP).equals(ADD);
  boolean doRemove = request.getParameter(OP).equals(REMOVE);
  boolean doEdit = request.getParameter(OP).equals(EDIT);
  boolean doDuplicate = request.getParameter(OP).equals(DUPLICATE);
  String isTempFilterStr = request.getParameter("tempFilter");
  boolean isTempFilter = (isTempFilterStr != null && isTempFilterStr.equals("true"));
  boolean wasTempFilter = false;

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  BrainConfigurationRepository rep = BrainConfigurationRepository.getRepository();
	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute("TRAN_PARADIGM_BUILDER");
	SessionFilterManager sdfmgr = (SessionFilterManager)request.getSession().getAttribute("sessionDataFilterManager");
  
	String filterCollectionId = request.getParameter(FILTER_COLLECTION_ID);

  if (filterCollectionId == null){
  	filterCollection = new FilterCollection();
  	dataFilter = new AtomicDataFilter();
  }else{
  	if (newWindow == null){
	  	filterCollection = sdfmgr.getFilterCollectionById(filterCollectionId);
  	}else if (!routine_id.equals("") && builder != null){
  		filterCollection = builder.getRoutineFilter(routine_id,filterCollectionId);
  	}
	  wasTempFilter = filterCollection.isTransientFilter();
	  dataFilter = (AtomicDataFilter)filterCollection.getFilters().get(0);
	}
	String tempFilterId = filterCollectionId;
	
  if (isTempFilter != wasTempFilter){
  	doAdd = true;
  	doEdit = false;
  	filterCollection = new FilterCollection();
  	dataFilter = new AtomicDataFilter();
  	if (isTempFilter && !wasTempFilter){
	  	filterCollectionId = String.valueOf(System.currentTimeMillis());
	  	filterCollection.setId(filterCollectionId);
	  	//filterName = filterName+"-temp";
  	}
  }
  fman = new FilterManager();
  fcman = new FilterCollection();

  //removing a filter
	if (doRemove){
		RoutineParadigm[] rp = rep.getRoutineParadigmsByDataFilterId(filterCollectionId);
		boolean allowDelete = true;
		if (rp != null && rp.length > 0){
			if (routine_id != null && rp.length > 0 || !(rp.length==1 && rp[0].getId().equals(routineParadigmId))){
				//allowDelete = false;
			}
		}
		if (allowDelete){
		  sdfmgr.removeFilterCollection(filterCollectionId);
		  if (url != null){
			  response.sendRedirect(url);
		  }else {
	  	  response.sendRedirect(BASE_DIRECTORY +"logic/online/TransView.jsp");
	  	}
    	return;
    } else {
	    ErrorModel ermo = new ErrorModel();
	    ermo.addError("Data filter cannot be deleted");
	    ermo.addError("It is being used by multiple routines");
	    request.getSession().setAttribute(ERROR_OBJ,ermo);
	    response.sendRedirect(BASE_DIRECTORY +"loggers/admin/errorpage.jsp");
	    return;
    }
  }
  
  //check validity for name
  if(filterName == null || filterName.trim().equals("")){
    ErrorModel ermo = new ErrorModel();
    ermo.addError("You must name the filter.");
    request.getSession().setAttribute(ERROR_OBJ,ermo);
    response.sendRedirect(BASE_DIRECTORY +"loggers/admin/errorpage.jsp");
    return;
  }
  
	if (doAdd || doEdit){
	  fcman.setName(filterName);
	  fcman.clearAllFromName(STRING_FILTER);
	  fcman.clearAllFromName(PRIORITY_FILTER);
	  fcman.clearAllFromName(DATE_FILTER);
	  fcman.clearAllFromName(CHOICE_FILTER);
	  fcman.clearAllFromName(NUMBER_FILTER);
	  RecordMask mask = (RecordMask)request.getSession().getAttribute(RECORD_MASK);
	  
	  try{
	    StringFilter[] strfilters = createStringFilters(request,response,mask);
	    if((strfilters != null) && (strfilters.length > 0)){
	      for(int i=0;i<strfilters.length;++i){
	        fcman.addFilter(strfilters[i]);
	      }
	    }
	
	    ChoiceFilter[] chfilters = createChoiceFilters(request,response,mask);
	    if((chfilters != null) && (chfilters.length > 0)){
	      for(int i=0;i<chfilters.length;++i){
	        fcman.addFilter(chfilters[i]);
	      }
	    }
	
	    PriorityFilter pfilter = createPriorityFilter(request,response,mask);
	   
	    if(pfilter != null){
	        fcman.addFilter(pfilter);
	
	    }
	    DateFilter dfilter = createDateFilter(request,response,mask);
	    if(dfilter != null){
	        fcman.addFilter(dfilter);
	    }
	    NumberFilter[] numfilters = createNumberFilters(request,response,mask);
	    if(numfilters != null && numfilters.length > 0){
	      for(int i=0;i<numfilters.length;++i){
	        fcman.addFilter(numfilters[i]);
	      }
	    }
	
	  }catch(Exception e){
	    ErrorModel ermo = new ErrorModel();
	    ermo.addError(e.getMessage());
	    request.getSession().setAttribute(ERROR_OBJ,ermo);
	    response.sendRedirect("/logeye/loggers/admin/errorpage.jsp");
	    return;
	  }
	  
	  fman.addFilterCollection(fcman);
	  dataFilter.setRecordFilter(fman);
	  dataFilter.setAtomicParadigmId(atomicParadigmId);
	  dataFilter.setRoutineParadigmId(routineParadigmId);
	  //dataFilter.setName(fcman.getName());
	  dataFilter.setStatusFilter(statusFilter);
	  dataFilter.setDisplayFilter(displayFilter);
	  dataFilter.setTempFilter(isTempFilter);
	  
	  filterCollection.setName(fcman.getName());
	  filterCollection.setTransientFilter(isTempFilter);
	  filterCollection.addFilter(dataFilter);
	}
	
  request.getSession().setAttribute(XPOLOG_FILTER,fman);

	int tempId = 0;
  if (dataFilter != null){
	  
	//	    audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	       			userContext, AuditConstants.CHANGE, "add/edit data filter", AuditConstants.TRANSACTION, "add/edit filter name " + filterName);

	  
   	if (newWindow == null){
	    if (doAdd){
	    	if (!isTempFilter){
				  filterCollectionId = sdfmgr.saveDataFilter(filterCollection);
				}else{
					if (sdfmgr != null){
						sdfmgr.addFilterCollection(filterCollection);
					}
				}
		  }
	    if (doEdit){
			  sdfmgr.updateDataFilter(filterCollection);
		  }
		  TransactionParadigm t = rep.getTransactionParadigmById(transParadigmId);
		  if (t != null){
		  	if (!isTempFilter){
					HashMap map = (HashMap)t.getFiltersForRoutinesMap();
					HashSet set = (HashSet)map.get(routineParadigmId);
					if (set == null){
						set = new HashSet();
						map.put(routineParadigmId,set);
					}
					set.add(filterCollection.getId());
					rep.getTranConfigBuilder().updateTransactionFilters(t);
				}
			}
			//remove temp filter if saved
	  	if (!isTempFilter && wasTempFilter){
	  		sdfmgr.removeFilterCollection(tempFilterId);
		  }
		  //update view
		  if (url != null){
			  response.sendRedirect(url);
		  }else {
			  response.sendRedirect(BASE_DIRECTORY +"logic/online/TransView.jsp?filter_collection_id="+filterCollectionId+"&advancedOpen=y&resetQuery=true");
			}
		}
	  else if (!routine_id.equals("") && builder != null){
	  	dataFilter.setAtomicParadigmId(dsId);
	  	dataFilter.setFilterName(filterName);
	  	//filterCollection.setId(dsId);
	  	if (filterCollectionId == null || filterCollectionId.length() == 0){
		  	tempId = UITransactionParadigmHelper.filterCounter++;
		  	dataFilter.setId(UITransactionParadigmBuilder.NEW_PREFIX+tempId);
	  	}
	  	builder.addNewRoutineFilter(routine_id,dataFilter);
	  }
  }
%>
<html>
<head>
	<script language="javascript">
		function display(){
			opener.filterRoutineId = '<%=routine_id%>';
			opener.filterDataFilterId = '<%=dataFilter.getId()%>';
			opener.setTimeout("doAddDataFilter()",100);
			opener.filterWindow.close();
		}
	</script>
</head>
<body onLoad="display()">
</body>
</html>

