<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>

<%@ page import="xpolog.logic.brain.*"%>
<%@ page import="xpolog.logic.filters.*"%>
<%@ page import="xpolog.logic.routine.data.RoutineParadigm"%>
<%@ page import="xpolog.logic.ui.TransactionTypeViewModel"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%!
  String dateFormat = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
  String millisecondsSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator",".");
  String dateFormatMS = dateFormat+millisecondsSeperator+"SSS";

  public String transformDateToString(Date d,long timeDiff){
    if(d == null){
      return null;
    }
    if (timeDiff != 0){
       long time = d.getTime();
    	 d = ((Date)d.clone());
    	 d.setTime(time + timeDiff); 
    }
    String format = "";
    if (d.getTime() % 1000 == 0){
	    format = dateFormat;
    } else {
	    format = dateFormatMS;
    }
    String str = new SimpleDateFormat(format).format(d);
    return str;
  }
%>
<%
  //constants
  String FILTER_COLLECTION_ID = "filter_collection_id";
  String OP = "OP";
  String ADD = "ADD";
  String ERROR_OBJ = "ERROR_OBJ";
  String MULTI_FILTER = "MultiFilter";
  String FILTER_COL_IDS = "FilterCollectionIds";
  String TRANS_PARADIGM_ID = "trans_paradigm_id";

  //page data
  String transParadigmId = request.getParameter(TRANS_PARADIGM_ID);
  LogBrowsingManager lbm = null;
  String logname    = "";
  SessionFilterManager sdfmgr = (SessionFilterManager)request.getSession().getAttribute("sessionDataFilterManager");
  FilterCollection fc = null;
  EventFilter eventFilter = null;

  //site management

  String filterCollectionId = request.getParameter(FILTER_COLLECTION_ID);
  int numFilterc = 0;
  if(sdfmgr != null){
    numFilterc = sdfmgr.getFilterCollections().size();
  }
 	String operation = request.getParameter(OP);
  String filterName = "EventName_" + String.valueOf(numFilterc);
  if(filterCollectionId != null){
    if(filterCollectionId.equals("none")){
      sdfmgr.setActiveFilterId(null);
      operation = "ADD";
    }else{
      sdfmgr.setActiveFilterId(filterCollectionId);
      fc = sdfmgr.getFilterCollectionById(filterCollectionId);
      if(fc != null){
        filterName = fc.getName();
        filterName = filterName.replaceAll("\"", "&quot;");
		  	if (operation != null && operation.equals("duplicate")){
		  		filterCollectionId = null;
		  		fc = (FilterCollection)fc.clone();
		  		fc.setId(filterCollectionId);
		  		fc.setName("copy of "+fc.getName());
		  		operation = "ADD";
				}else{
			    operation = "EDIT";
				}
	    	filterName = fc.getName();
      }
    }
  }else{
    filterCollectionId = "";
    operation = "ADD";
  }

	if (fc != null){
		try{
			eventFilter = (EventFilter)fc.getFilters().get(0);
		}catch(Error err){
	    ErrorModel ermo = new ErrorModel();
	    ermo.addError("Filter found is not an event filter");
	    request.getSession().setAttribute(ERROR_OBJ,ermo);
	    response.sendRedirect(BASE_DIRECTORY +"common/errorpage.jsp");
	    return;
		}
	}
	
	RoutineParadigm[] routineParadigms = BrainConfigurationRepository.getRepository().getRoutineParadigmsByTransactionParadigmId(transParadigmId);

  List filterCollectionIds = null;

  UserSecurity security = WebSecurityManager.getInstance().getUserSecurity(request);
  //boolean isEditable = security == null || security.isModuleMemberEditable(lbm.getId());

  String enc = request.getParameter("enc");
  if (enc != null && enc.trim().length() == 0){
    enc = null;
  }
	String charset = TransactionTypeViewModel.getCharSetForTransactionParadigm(transParadigmId);	
	
	//Start date filter section
	DateFilter datefl = null;
	
	String DATE_MIN_FILTER_ACTIVE = "DateMinFilterActive";
	String DATE_MAX_FILTER_ACTIVE = "DateMaxFilterActive";
	String DATE_MIN_FILTER_ACTIVE_PARAM = "DATE_MIN_FILTER_ACTIVE_PARAM";
	String DATE_MAX_FILTER_ACTIVE_PARAM = "DATE_MAX_FILTER_ACTIVE_PARAM";
	String DATE_MINIMUM = "DateMinimum";
	String DATE_MAXIMUM = "DateMaximum";
	String DATE_FILTER_MINIMUM_PARAM = "DATE_FILTER_MINIMUM_PARAM";
	String DATE_FILTER_MAXIMUM_PARAM = "DATE_FILTER_MAXIMUM_PARAM";

	long timeDiff = 0;
	Date minDate = null;
	Date maxDate = null;
	String minDateStr = "";
	String maxDateStr = "";
	String minStat = "";
	String maxStat = "";
	String timeunit = "";
	String isTimeLim = "";
	String daystatsel = "";
	String minstatsel = "";
	String hourstatsel = "selected";
	String weekstatsel = "";
	String monthstatsel = "";
	boolean isLast = true;  
	
  if (eventFilter!=null){
		datefl = eventFilter.getDateFilter();
		if (datefl != null){
			if(datefl.getTimeType() == -1){
				minDate = datefl.getMinDate();
				maxDate = datefl.getMaxDate();
			}else{
				hourstatsel = "";
				isLast = datefl.isLastOpType();
				isTimeLim = "checked";
				timeunit = String.valueOf(datefl.getTimeGap());
				if(datefl.isMonths()){
					monthstatsel = "selected";
				}else if(datefl.isWeeks()){
					weekstatsel = "selected";
				}else if(datefl.isDays()){
					daystatsel = "selected";      
				}else if(datefl.isHours()){
					hourstatsel = "selected";
				}else if(datefl.isMinutes()){
					minstatsel = "selected";
				}else {
					hourstatsel = "selected";
	      }
	    }
    }
  }

  long minTimeDiff = timeDiff;
  if(minDate == null){
    minDate = new Date();
    long t = minDate.getTime();
    minDate.setTime(t-(t%1000));
    minTimeDiff = 0;
  }else{
    minStat = "checked";
  }

  long maxTimeDiff = timeDiff;
  if(maxDate == null){
   maxDate = new Date();
    long t = maxDate.getTime();
    maxDate.setTime(t-(t%1000));
    maxTimeDiff = 0;
  }else{
    maxStat = "checked";
  }
  minDateStr = transformDateToString(minDate,minTimeDiff);
  maxDateStr = transformDateToString(maxDate,maxTimeDiff);
	//Start date filter section
%>
<html>

<head>
<%if (charset != null){ %>
  <meta http-equiv="Content-Type" content="text/html; charset=<%=charset%>">
<%}else{ %>
  <meta http-equiv="Content-Language" content="en-us">
<%}%>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />


<script>
  function doApply(isTemp){
  	fKeys = "";
  	var found = false;
  	for (var i=0; i<<%=routineParadigms.length%>; i++){
 			if (document.getElementById("rp_"+i).checked == true){
 				rp_id = document.getElementById("rp_id_"+i).value;
 				rp_op = document.getElementById("rp_op_"+i).value;
 				rp_val = document.getElementById("rp_val_"+i).value;
 				f = rp_id+"*"+rp_op+"*"+rp_val;
 				if (found == true){
 					fKeys = fKeys + "|";
 				}else{
 					found = true;
 				}
 				fKeys = fKeys + f;
 			}
  	}
  	document.access.filtersKeys.value = fKeys;
		if (isTemp == "true"){
			document.access.tempFilter.value = "true";
		}else{
			document.access.tempFilter.value = "false";
		}
    document.access.submit();
  }


	function showHideValue(index){
		rp = document.getElementById("rp_"+index).checked = 'true';
		op = document.getElementById("rp_op_"+index).value;
		if (op == "1" || op == "2"){
			document.getElementById("fop_div_"+index).style.display = "none";
		}else{
			document.getElementById("fop_div_"+index).style.display = "";
		}
	}

  function checkDate(date_check_box, date_obj){
  	date_ok = "";
  	obj_name = date_check_box.name;
  	frames['dateValidationFrame'].location = "<%=BASE_DIRECTORY%>calendar/dateValidation.jsp?dateStr="+date_obj.value+"&date_check_box="+obj_name;
  }

</script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/calendar/calendar2.js"></script><!-- Date only with year scrolling -->
<title></title>
</head>
<body style="font-size: 8pt">
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" action="eventFilterAction.jsp">
<input type="hidden" name="filtersKeys">
<input type="hidden" name="<%=OP%>" value="<%=operation%>">
<input type="hidden" name="<%=TRANS_PARADIGM_ID%>" value="<%=transParadigmId%>">
<input type="hidden" name="tempFilter">
<%if (filterCollectionId != null){%>
<input type="hidden" name="<%=FILTER_COLLECTION_ID%>" value="<%=filterCollectionId%>">
<%}%>
<input type="hidden" name="enc" value="<%=charset == null? "" : charset%>">
<input type="hidden" name="statusFilter" value="false">
<input type="hidden" name="displayFilter" value="true">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%" height="100%" valign="top">
    	<table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      		<tr>
        		<td valign="top" height="84%">
        			<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          			<tr>
            				<td width="100%">
            					<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              					<tr>
                				  <td width="2%" class="TOPLEFTBORDER"></td>
                				  <td width="50%" class="TOPBORDER"><span class="PAGEHEADER">Event Filter definition</span></td>
                				  <td width="48%" class="TOPRIGHTBORDER"></td>
              					</tr>
          
              					<tr>
                				  <td width="100%" colspan="3">
                                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td width="100%"><font size="1">&nbsp;</font></td>
                                      </tr>
                                      <tr>
                                        <td width="100%"><span class="HEADER">Name: </span><input class="TEXTBOX" type="text" name="filterName" size="30" value="<%=filterName%>"></td>
                                      </tr>
                                      <tr>
                                        <td width="100%"></td>
                                      </tr>
							              					<tr>
							                				  <td width="100%" colspan="3">
																					<table border="0" width="100%" cellspacing="0" cellpadding="0">
										                        <tr>
										                          <td width="20">&nbsp;</td>
										                          <td width="98%"></td>
										                        </tr>
										                        <tr>
										                          <td width="20">&nbsp;</td>
										                          <td width="98%"><hr><span class="HEADER">Date and Time</span></td>
										                        </tr>
										                        <tr>
										                          <td width="20">&nbsp;</td>
										                          <td width="98%"><%@ include file="../../../tools/sandf/dateFilter.jsp"%></td>
										                        </tr>
										                      </table>
										                    </td>
									                    </tr>
                                      <tr>
                                        <td width="100%"></td>
                                      </tr>
                                      <tr>
                                        <td width="100%">
                                          <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER">Events</span></td>
                                            </tr>
                                            	<td>&nbsp;</td>
                                            	<td>
                                            		<table border="0" cellpadding="0" cellspacing="0">
			                                            <%for (int i=0; i<routineParadigms.length; i++){
			                                            	int op = EventFilter.UNDEFINED;
			                                            	String val = "";
			                                            	String visibility = "";
			                                            	String checked = "";
			                                            	if (eventFilter != null){
			                                            		op = eventFilter.getOpForRoutineParadigm(routineParadigms[i].getId());
			                                            		val = eventFilter.getValueForRoutineParadigm(routineParadigms[i].getId());
			                                            		if (val == null){
			                                            			val = "";
			                                            		}
			                                            	}
			                                            	if (op == EventFilter.UNDEFINED || op == EventFilter.EXISTS || op == EventFilter.NOT_EXISTS){
			                                            		visibility = "style=\"display:none\"";
			                                            	}
			                                            	if (op != EventFilter.UNDEFINED){
			                                            		checked = "checked";
			                                            	}
			                                            %>
			                                            <tr>
			                                            	<td class="REGULARTEXT">
			                                            		<input type="checkbox" id="rp_<%=i%>" name="rp_<%=i%>" <%=checked%>>&nbsp;<%=routineParadigms[i].getName()%>
			                                            		<input type="hidden" id="rp_id_<%=i%>" name="rp_id_<%=i%>" value="<%=routineParadigms[i].getId()%>">
			                                            	</td>
			                                            	<td>&nbsp;</td>
			                                            	<td>
			                                            		<select id="rp_op_<%=i%>" name="rp_op_<%=i%>" onchange="javascript:showHideValue('<%=i%>')">
			                                            			<option value="1" <%=(op == EventFilter.EXISTS ? "selected" : "")%>>exists</option>
			                                            			<option value="2" <%=(op == EventFilter.NOT_EXISTS ? "selected" : "")%>>does not exist</option>
			                                            			<option value="3" <%=(op == EventFilter.HAS_MIN ? "selected" : "")%>>has at least</option>
			                                            			<option value="4" <%=(op == EventFilter.HAS_MAX ? "selected" : "")%>>has no more than</option>
			                                            		</select>
			                                            	</td>
			                                            	<td>&nbsp;</td>
			                                            	<td>
			                                            		<div id="fop_div_<%=i%>" <%=visibility%>>
			                                            		<input type="text" id="rp_val_<%=i%>" name="rp_val_<%=i%>" value="<%=val%>" size="5"> occurrences in transaction
			                                            		</div>
			                                            	</td>
			                                            	
			                                            </tr>
			                                            <%}%>
                                            		</table>
                                            	</td>
                                            </tr>
																				    <tr>
                                              <td width="20" class="REGULARTEXT">&nbsp;</td>
                                              <td width="98%" class="REGULARTEXT">&nbsp;</td>
                                            </tr>
                                          </table>
                                        </td>
                                      </tr>
                                      <tr>
                                        <td width="100%">
                                          <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                            <tr>
                                              <td width="33%">&nbsp;</td>
                                              <td width="33%">
                                                <table border="0" width="100%" cellspacing="0" cellpadding="0">
																								  <tr>&nbsp;</tr>
																								  <tr>&nbsp;</tr>
																								  <tr>&nbsp;</tr>
																								  <tr>&nbsp;</tr>
                                                  <tr>
                                                    <td width="22%"><a href="javascript:doApply('false')" class="LINK">save</a></td>
                                                    <td width="22%"><a href="javascript:doApply('true')" class="LINK">apply</a></td>
                                                    <%
			                                            		String cancelQuery = request.getQueryString();
			                                            		if (filterCollectionId != null && filterCollectionId.length() > 0){
			                                            			cancelQuery = cancelQuery.replaceAll(filterCollectionId,"none");
			                                            		}
                                                    %>
                                                    <td width="22%"><a href="../TransView.jsp?<%=cancelQuery%>" class="LINK">cancel</a></td>
                                                    <td width="34%"><a href="javascript:openHelp('<%=BASE_DIRECTORY%>','Filter.htm')" class="LINK">help</a></td>
                                                  </tr>
                                                </table>
                                              </td>
                                              <td width="34%">&nbsp;</td>
                                            </tr>
                                          </table>
                                        </td>
                                      </tr>
                                    </table>
                                  </td>
              					</tr>
              					<tr>
                				  <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                				  <td width="50%" class="TOPBORDER"></td>
                				  <td width="47%" class="TOPRIGHTBORDER">&nbsp;</td>
              					</tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
    </table>
</form>
<script language="JavaScript">
	<!-- // create calendar object(s) just after form tag closed
			// note: you can have as many calendar objects as you need for your application
	var cal7 = new calendar2("<%=BASE_DIRECTORY%>",document.access.<%=DATE_MINIMUM%>,null,<%="/^\\-?\\d+(\\"+millisecondsSeperator+"\\d+)*$/"%>,"<%=millisecondsSeperator%>");
	cal7.year_scroll = true;
	cal7.time_comp = true;
	var cal8 = new calendar2("<%=BASE_DIRECTORY%>",document.access.<%=DATE_MAXIMUM%>,null,<%="/^\\-?\\d+(\\"+millisecondsSeperator+"\\d+)*$/"%>,"<%=millisecondsSeperator%>");
	cal8.year_scroll = true;
	cal8.time_comp = true;

	function openCal7(){
		document.access.<%=DATE_MIN_FILTER_ACTIVE%>.checked='true';
		cal7.popup();
	}
	function openCal8(){
		document.access.<%=DATE_MAX_FILTER_ACTIVE%>.checked='true';
		cal8.popup();
	}
	//-->
</script>
</table>
</body>

