<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.security.*"%>

<%@ page import="xpolog.logic.filters.*"%>
<%@ page import="xpolog.logic.ui.TransactionTypeViewModel"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  //constants
  String FILTER_COLLECTION_ID = "filter_collection_id";
  String OP = "OP";
  String ADD = "ADD";
  String ERROR_OBJ = "ERROR_OBJ";
  String MULTI_FILTER = "MultiFilter";
  String FILTER_COL_IDS = "FilterCollectionIds";
  String TRANS_PARADIGM_ID = "trans_paradigm_id";
  String NEGATE = "Negate";

  //page data
  String transParadigmId = request.getParameter(TRANS_PARADIGM_ID);
  LogBrowsingManager lbm = null;
  String logname    = "";
  SessionFilterManager fman = (SessionFilterManager)request.getSession().getAttribute("sessionDataFilterManager");

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  String filterId = request.getParameter(FILTER_COLLECTION_ID);
  int numFilterc = 0;
  if(fman != null){
    numFilterc = fman.getFilterCollections().size();
  }
  
 	String op = request.getParameter(OP);
  String filterName = "MultiName_" + String.valueOf(numFilterc);
  String paramToPass = "";
  FilterCollection fc = null;
  if(filterId != null){
    if(filterId.equals("none")){
      fman.setActiveFilterId(null);
      paramToPass = "&OP=ADD";
    }else{
      fman.setActiveFilterId(filterId);
      fc = fman.getFilterCollectionById(filterId);
      if(fc != null){
        filterName = fc.getName();
        filterName = filterName.replaceAll("\"", "&quot;");
	      paramToPass = "&EDIT_FILTER_ID=" + filterId;
		  	if (op != null && op.equals("duplicate")){
		  		filterId = null;
		  		fc = (FilterCollection)fc.clone();
		  		fc.setId(filterId);
		  		fc.setName("copy of "+fc.getName());
			    paramToPass += "&OP=ADD";
				}else{
			    paramToPass += "&OP=EDIT";
				}
	    	filterName = fc.getName();
      }
    }
  }else{
    filterId = "";
    paramToPass = "&OP=ADD";
  }
  paramToPass = paramToPass + "&trans_paradigm_id="+transParadigmId;
  //String op = request.getParameter(ADD);

  List filters = null;
  if(fc != null){
    filters = fc.getByName(MULTI_FILTER);
  }else{
    filters = new ArrayList();
  }

  MultiFilter multiFilter = null;
  List filterCollectionIds = null;
  List allcol = fman.getFilterCollections();

  String negateStr = request.getParameter(NEGATE);
  boolean negate = (negateStr != null && negateStr.equals("true"));
  negate = negate || (multiFilter != null && multiFilter.isNegateFilter());

  if(!negate && allcol.size() < 2){
    ErrorModel erm = new ErrorModel();
    erm.addError("There must be at least two exsiting filters in order to create a Multi Filter.");
    request.getSession().setAttribute(ERROR_OBJ,erm);
    response.sendRedirect(BASE_DIRECTORY + "loggers/admin/errorpage.jsp");
    return;
  }

  if(filters != null && filters.size()>0){
    multiFilter = (MultiFilter)filters.get(0);
    filterCollectionIds = multiFilter.getFilterCollectionList();
  }else{
    multiFilter = new MultiFilter(fman);
    filterCollectionIds = new ArrayList();
  }

  String orselected="",andselected="";
  if(multiFilter.isBooleanOpOR()){
    orselected = "selected";
  }else{
    andselected = "selected";
  }

  UserSecurity security = WebSecurityManager.getInstance().getUserSecurity(request);
  boolean isEditable = security == null || security.isModuleMemberEditable(lbm.getId());

	String charset = TransactionTypeViewModel.getCharSetForTransactionParadigm(transParadigmId);
%>
<html>

<head>
<%if (charset != null){ %>
  <meta http-equiv="Content-Type" content="text/html; charset=<%=charset%>">
<%}else{ %>
  <meta http-equiv="Content-Language" content="en-us">
<%}%>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
  function doApply(isTemp){
    path = "multiFilterAction.jsp?";
    for(var i=0;i<document.access.ToUse.options.length;i++){
      val = document.access.ToUse.options[i].value;
      path = path + "<%=FILTER_COL_IDS%>" + "=" + val;
      path = path +"&";
    }
    var filterName = document.access.filterName.value;
    var re1 = new RegExp("[&]", 'gi');
  	filterName = filterName.replace(re1,"%26");
    path = path + "filterName=" + filterName;
 		if (isTemp == "true"){
			path = path + "&tempFilter=true";
		}else{
			path = path + "&tempFilter=false";
		}
		<%if (charset != null){%>
		//path = path + "&enc=<%=charset%>";
		<%}%>
    path = path + "<%=paramToPass%>";
    path = path +"&LogicalOp=" + document.access.LogicalOp.options[document.access.LogicalOp.selectedIndex].value;
    <%if (negate){ %>
    path = path +"&Negate=" + document.access.Negate.value;
    <%} %>
    document.location = path;
  }

  function trim(a){
      while(''+a.charAt(a.length-1)==' '){
       a=a.substring(0,a.length-1);
      }
      return a;
  }


</script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>

<title></title>
</head>
<body style="font-size: 8pt">
<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%" height="100%" valign="top">
    	<table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      		<tr>
        		<td valign="top" height="84%">
        			<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          			<tr>
            				<td width="100%">
            					<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              					<tr>
                				  <td width="3%" class="TOPLEFTBORDER"></td>
                				  <td width="50%" class="TOPBORDER"><span class="PAGEHEADER">Multi Filter definition</span></td>
                				  <td width="47%" class="TOPRIGHTBORDER"></td>
              					</tr>
              					<tr>
                				  <td width="100%" colspan="3">
                                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td width="100%"><font size="1">&nbsp;</font></td>
                                      </tr>
                                      <tr>
                                        <td width="100%"><span class="HEADER">Name: </span><input class="TEXTBOX" type="text" name="filterName" size="30" value="<%=filterName%>"></td>
                                      </tr>
                                      <tr>
                                        <td width="100%"></td>
                                      </tr>
                                      <tr>
                                        <td width="100%">
                                          <table border="0" width="100%" cellspacing="0" cellpadding="0">

                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER">Filters</span></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="../../../tools/sandf/filterSelect.jsp"%></td>
                                            </tr>
																				    <tr>
                                              <td width="20" class="REGULARTEXT">&nbsp;</td>
                                              <td width="98%" class="REGULARTEXT">&nbsp;</td>
                                            </tr>
                                            <tr>
                                              <td width="20"></td>
                                              <td width="98%"><span class="REGULARTEXT">Logical operation between filters</span>
                                                <select class="TEXTBOX" size="1" name="LogicalOp">
                                                  <option <%=orselected%> value="OR">OR</option>
                                                  <option <%=andselected%> value="AND">AND</option>
                                                </select></td>
                                            </tr>
                                            <%if (negate){ %>
																				    <tr>
                                              <td width="20" class="REGULARTEXT">&nbsp;</td>
                                              <td width="98%" class="REGULARTEXT">&nbsp;</td>
                                            </tr>
                                            <tr>
                                              <td width="20"></td>
                                              <td width="98%"><input type="checkbox" name="Negate" value="true" checked><span class="REGULARTEXT"> negate filter</span>
                                              </td>
                                            </tr>
																				    <tr>
                                              <td width="20" class="REGULARTEXT">&nbsp;</td>
                                              <td width="98%" class="SMALLTEXT">Click this option in order to negate the result of the filter (e.g. (A AND B) => (NOT A OR NOT B))</td>
                                            </tr>
                                            <%}%>
                                          </table>
                                        </td>
                                      </tr>
                                      <tr>
                                        <td width="100%">
                                          <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                            <tr>
                                              <td width="33%">&nbsp;</td>
                                              <td width="33%">
                                                <table border="0" width="100%" cellspacing="0" cellpadding="0">
																								  <tr>&nbsp;</tr>
																								  <tr>&nbsp;</tr>
																								  <tr>&nbsp;</tr>
																								  <tr>&nbsp;</tr>
                                                  <tr>
                                                    <td width="22%"><a href="javascript:doApply('false')" class="LINK">save</a></td>
                                                    <td width="22%"><a href="javascript:doApply('true')" class="LINK">apply</a></td>
                                                    <%
			                                            		String cancelQuery = request.getQueryString();
			                                            		if (filterId != null){
			                                            			cancelQuery = cancelQuery.replaceAll(filterId,"none");
			                                            		}
                                                    %>
                                                    <td width="22%"><a href="../TransView.jsp?<%=cancelQuery%>" class="LINK">cancel</a></td>
                                                    <td width="34%"><a href="javascript:openHelp('<%=BASE_DIRECTORY%>','Filter.htm')" class="LINK">help</a></td>
                                                  </tr>
                                                </table>
                                              </td>
                                              <td width="34%">&nbsp;</td>
                                            </tr>
                                          </table>
                                        </td>
                                      </tr>
                                    </table>
                                  </td>
              					</tr>
              					<tr>
                				  <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                				  <td width="50%" class="TOPBORDER"></td>
                				  <td width="47%" class="TOPRIGHTBORDER">&nbsp;</td>
              					</tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
    </table>
</form>
</table>
</body>

