<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.security.*"%>

<%@ page import="xpolog.logic.brain.admin.db.filters.*"%>
<%@ page import="xpolog.logic.brain.BrainConfigurationRepository"%>
<%@ page import="xpolog.logic.filters.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.transaction.data.TransactionParadigm"%>
<%@ page import="xpolog.logic.routine.data.RoutineParadigm"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
  UserContext userContext = UserEnvironment.getUserContext(request);

  //constants
  String RECORD_MASK = "RECORD_MASK";
  String FILTER_MAN = "FILTER_MAN";
  String XPOLOG_FILTER = "XPOLOG_FILTER";
  String FILTER_COLLECTION_ID = "filter_collection_id";
  String LOG_NAME = "LOG_NAME";
  String ERROR_OBJ = "ERROR_OBJ";
  String STRING_FILTER = "StringFilter";
  String PRIORITY_FILTER = "PriorityFilter";
  String DATE_FILTER = "DateFilter";
  String CHOICE_FILTER = "ChoiceFilter";
  String NUMBER_FILTER = "NumberFilter";
  String RECORD_FILTER = "RecordFilter";
  String ROUTINE_PARADIGM_ID = "routineParadigmId";
  String TRANS_PARADIGM_ID = "trans_paradigm_id";
  String ATOMIC_PARADIGM_ID = "atomicParadigmId";
  String FILTER_NAME = "filterName";
  String IS_STATUS_FILTER = "isStatusFilter";
  String IS_DISPLAY_FILTER = "isDisplayFilter";
  String DATA_SOURCE_ID = "ds_id";
  String ROUTINE_ID = "routine_id"; //used from addNewTransaction.jsp

  String REMOVE_FILTER_ID = "REMOVE_FILTER_ID";
  String ACTIVATE_FILTER_ID = "ACTIVATE_FILTER_ID";
  String EDIT_FILTER_ID = "EDIT_FILTER_ID";
  String OP = "OP";
  String ADD = "ADD";
  String REMOVE = "REMOVE";
  String EDIT = "EDIT";

  //page data
  FilterCollection filterCollection = null; //parent of transFilter
	AtomicDataFilter dataFilter = null;
  FilterCollection fcman = null; //son of dataFilter
  FilterManager fman = null;
  String logname    = "";
  String routineParadigmId = request.getParameter(ROUTINE_PARADIGM_ID);
  String transParadigmId = request.getParameter(TRANS_PARADIGM_ID);
  String atomicParadigmId = request.getParameter(ATOMIC_PARADIGM_ID);
  String filterName = request.getParameter(FILTER_NAME);
  String isStatusFilter = request.getParameter(IS_STATUS_FILTER);
  String isDisplayFilter = request.getParameter(IS_DISPLAY_FILTER);
	String dsId = request.getParameter(DATA_SOURCE_ID);
	String routine_id = request.getParameter(ROUTINE_ID);

  //site management
  BrainConfigurationRepository rep = BrainConfigurationRepository.getRepository();
	UITransactionParadigmBuilder builder = (UITransactionParadigmBuilder)request.getSession().getAttribute("TRAN_PARADIGM_BUILDER");
	SessionFilterManager sdfmgr = (SessionFilterManager)request.getSession().getAttribute("sessionDataFilterManager");
  
	String filterCollectionId = request.getParameter(FILTER_COLLECTION_ID);

  if (filterCollectionId != null){
  	filterCollection = sdfmgr.getFilterCollectionById(filterCollectionId);
	}
	if (filterCollection == null){
    ErrorModel ermo = new ErrorModel();
    ermo.addError("Filter cannot be deleted");
    request.getSession().setAttribute(ERROR_OBJ,ermo);
    response.sendRedirect(BASE_DIRECTORY +"common/errorpage.jsp");
    return;
	}
	
  //removing a filter
  //System.out.println("remove filter collection "+filterCollectionId);
	sdfmgr.removeFilterCollection(filterCollectionId);
	
  //	  audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	     			userContext, AuditConstants.CHANGE, "remove filter", AuditConstants.TRANSACTION, "remove filter " + filterName);

	response.sendRedirect(BASE_DIRECTORY +"logic/online/TransView.jsp");
%>
