<%@ page language="java" %>

<%@ page import="xpolog.logic.transaction.data.Transaction"%>
<%@ page import="xpolog.logic.ui.graph.JGraphImageDescriptor"%>
<%@ page import="xpolog.logic.ui.TransResultBuilder"%>
<%@ page import="xpolog.logic.ui.TransactionTypeViewModel"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%

	TransResultBuilder tranResultBuilder = (TransResultBuilder)request.getSession().getAttribute("currentTransResultBuilder");  
	TransactionTypeViewModel model = tranResultBuilder.getTranTypeViewModel();
	
	String subTransactionId = request.getParameter("subTransactionId");
	String heightStr = request.getParameter("height");
	int height = heightStr != null && heightStr.length() > 0 ? Integer.parseInt(heightStr) : 330;
	String widthStr = request.getParameter("width");
	int width = widthStr != null && widthStr.length() > 0 ? Integer.parseInt(widthStr) : 750;
	
  Transaction root = null;
	if(subTransactionId != null) {
		root = model.getTransactionById(subTransactionId);
		if(root != null) {
			model.setRoot(root);
		}
	}
  
  JGraphImageDescriptor imageDescriptor = model.getGraphForRoot(width, height);
	String mappingStr = model.createMappingString(imageDescriptor.getJgraphImage(),request,true);

	response.setContentType("text/xml");
%>

<Transaction>
<TransactionHeader>
<![CDATA[
<jsp:include page="transactionHeader.jsp" flush="true" >
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY %>"/>
</jsp:include>
]]>
</TransactionHeader>
<Image src="<%=imageDescriptor.getImageGraphURL() %>" />
<Mapping>
<![CDATA[<%=mappingStr %>]]>
</Mapping>
</Transaction>
