<%@ page language="java" %> 
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="omega.ui.models.*"%>
<%@ page import="omega.ui.html.table.OHtmlTable"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.logic.*"%>
<%@ page import="xpolog.eye.data.linear.*"%>
<%@ page import="xpolog.logic.routine.data.Routine"%>
<%@ page import="xpolog.logic.routine.data.RoutinesToLbmsConverter"%>
<%@ page import="xpolog.logic.transaction.data.Transaction"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.ui.site.*"%>



<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%

  String CURRENT_LOG = "CURRENT_LOG";
  String ERROR_OBJ = "ERROR_OBJ";
  String CURRENT_LOG_QUERY_INFO = "CURRENT_LOG_QUERY_INFO";
  int ALLOWED_LOG_NAME_LENGTH = 30;

  //getting the managment
  SiteManagment mgmt = SiteManagment.getInstance();
  
  LogViewQueryInfo queryInfo = (LogViewQueryInfo)request.getSession().getAttribute(CURRENT_LOG_QUERY_INFO);
	String transId = request.getParameter("transId");
	String transName = request.getParameter("transName");
	if ((transName == null || transName.equals(""))&& transId != null){
		transName = transId;
	}

	LogicEnvironment logicEnv = LogicEnvironment.getLogicEnvironment(request);
  String sessionRuntimeId = logicEnv.getSessionRuntimeId();
  
  DataSessionRuntime dsr = null;
	if (sessionRuntimeId != null && !sessionRuntimeId.equals("")){
		dsr = CtrlMgr.getInstance().getDataSessionRuntimeById(sessionRuntimeId);
	}
	if (dsr == null){
		dsr = new DataSessionRuntime();
		dsr.setId(DataSession.ONLINE_DATA_SESSION_ID);
	}
 	TransactionTypeViewModel transTypeViewModel = TransactionTypeViewModelFactory.createTransactionTypeViewModel(dsr);
 	Transaction t = transTypeViewModel.getTransactionById(transId);
  if(t == null){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("Error fetching transaction");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect("../../common/errorpage.jsp");
    return;
  }
 	Routine[] routines = transTypeViewModel.getAllRoutines(t,null);
 	RoutinesToLbmsConverter conv = new RoutinesToLbmsConverter();
 	conv.createLbmsFromRoutines(routines);
  HashMap mansMap = conv.getLbmsMap();
 	HashMap rpToLbms = conv.getRoutineParadigmIdsToLbms();
 	Transaction[] transactions = transTypeViewModel.getAllTransactions(t,null);
 
  ExpandedEventViewHelper transViewHelper = new ExpandedEventViewHelper(transactions,mansMap,rpToLbms);
  LogBrowsingManager[] mans = conv.getLbms();
  String legend = transViewHelper.getLegend().getHtml();


  LogBrowsingManager man = null;
  try{
	  man = mans[0];
  	//man = mgmt.getLogBrowserManager(transViewHelper.getGenEventLogId());
  }catch(Exception e){}
  if (mans == null || mans.length == 0){
	%> <html><body bgcolor="#FFFFFF"></body></html> <%
	return;
  }

  String refreshStr = request.getParameter("refresh");
  
  int leapsize = 100;
  String op = "CURRENT";
  String search = "";
  String mark = "";
  boolean isRegExp = false;
  
  String updateStr = request.getParameter("update");
  boolean update = updateStr != null && updateStr.equals("true");
  
   //do sorting check
  String sortIndex = request.getParameter("sortIndex");
  if(sortIndex == null || sortIndex.trim().length() == 0){
    sortIndex = "-1";
  }else {
    op = "CURRENT";
  }
   
  SortingManager sortman = mans[0].getSortingManager();
  int index = -1;
  try{
    index = Integer.parseInt(sortIndex.trim());
  }catch(Exception e){   
  }
  if(index == -1){
    sortman.cancelSort();
  }else{
    sortman.doSort(index);
  }

  boolean next = false;
  boolean prev = false;
  boolean current  = false;
  DataReferenceBuilder dfBuilder = null;
  MultiRecordsMaskTableModel RMModel = null;  
  boolean refresh = refreshStr != null && refreshStr.equals("true");
  int numRows = -1;
  MultiHeaderLogEyeModel model = null;
  if (update){
    op = "CURRENT";
    model = null;
  }

  try{	
	  RMModel = transViewHelper.createTableModel();
	  model = new MultiHeaderLogEyeModel(BASE_DIRECTORY,RMModel);
	  numRows = model.getRowCount();
  }catch(Exception e){
  	e.printStackTrace();
  	ErrorModel errModel = new ErrorModel();
  	errModel.addError("During data processing the following error occurred:");
  	if(e.getMessage() == null || e.getMessage().equals("")){
  		errModel.addError(e.getClass().toString());
  	}else{
  		errModel.addError(e.getMessage());
  	}
  	errModel.addError("Please verify the remote host is running and available.");
  	request.getSession().setAttribute(ERROR_OBJ,errModel);
  	out.println("<html><head><script>");
  	out.println("parent.document.location='../../common/errorpage.jsp'");
  	out.println("</script></head><body></body></html>");
  	out.flush();
  	return;
  }
  
   String title = "";

  if (model != null){
    String str = model.getRecordsMaskTableModel().getTitle();
    if (str != null){
      title = str;
    }
  }
  int endIndex = 0;
  int logNameLength = man.getName().length();
  int titleLength = title.lastIndexOf("(");
  String tempTitle = null;
  if(titleLength>ALLOWED_LOG_NAME_LENGTH && logNameLength>ALLOWED_LOG_NAME_LENGTH) {
  	//both names lengths are larger then 30 we cut title.
  	tempTitle = title.substring(title.lastIndexOf("("),title.length());
  	//check if the char at index ALLOWED_LOG_NAME_LENGTH are before the (%) or after it
  	if(ALLOWED_LOG_NAME_LENGTH < titleLength) {
  		title = title.substring(0,ALLOWED_LOG_NAME_LENGTH)+"..."+tempTitle;
  	}else {
  		endIndex = titleLength-1;
  		title = title.substring(0,endIndex)+"..."+tempTitle;
  	}
  }else if(titleLength>ALLOWED_LOG_NAME_LENGTH && !(logNameLength>ALLOWED_LOG_NAME_LENGTH)) {
  	//only title name is more then 30 chars, we allow 60 chars.
  	tempTitle = title.substring(title.lastIndexOf("("),title.length());
  	if(titleLength>(2*ALLOWED_LOG_NAME_LENGTH)) {
	  	//check if the char at index ALLOWED_LOG_NAME_LENGTH are before the (%) or after it
	  	if(2*ALLOWED_LOG_NAME_LENGTH < titleLength) {
	  		title = title.substring(0,2*ALLOWED_LOG_NAME_LENGTH)+"..."+tempTitle;
	  	}else {
	  		endIndex = titleLength-1;
	  		title = title.substring(0,endIndex)+"..."+tempTitle;
	  	}
  	}
  }
    
   /**
   * manage messages
   */
   String SearchMessage = "";
   String searchDefinition = man.getSearchAndFilterDef();
   if(searchDefinition != null && searchDefinition.length() > 0) {
   		if(searchDefinition.equals("START")) {
    		SearchMessage = "from the beginning of the file";
   		}else {
   			SearchMessage = "on current view only";
   		}
   }
   boolean isMessage = false;
   String displayMessage = "";
   if(model.getRowCount() == 0){
    if(next){
      isMessage = true;
      displayMessage = "End Of Log";
    }else if(prev){
      isMessage = true;
      displayMessage = "Beginning Of Log";
    }else if(current){
      isMessage = true;
      displayMessage = "No Records To Display " + SearchMessage;
    }
   }
   
   SearchManager searchManager = new SearchManager(mark);
   if (mark == null || mark.trim().length() == 0 && search != null){
     searchManager = new SearchManager(search,isRegExp);
   }

  //html creation
  MultiHeaderOHtmlTable tab = new MultiHeaderOHtmlTable(model);
  
  tab.setID("logviewTable");
  //LogEyeCellRenderer cr = man.getCellRenderer(model,searchManager);
  MultiHeaderLogEyeCellRenderer cr = new MultiHeaderLogEyeCellRenderer(model);
  MultiHeaderLogEyeRowRenderer rr = new MultiHeaderLogEyeRowRenderer(model);
  tab.setRowRenderer(rr);
  tab.setCellRenderer(cr);
  tab.render();
  String html = tab.getHtml();
  
  String charset = man.getCharset();
  if (charset != null){
    response.setContentType("text/html; charset=" + charset);   
  }
  
  Properties prop = Configuration.getInstance().getUIData(); 
  String minusImg = BASE_DIRECTORY + prop.getProperty("logview.minus.image");
  String plusImg = BASE_DIRECTORY + prop.getProperty("logview.plus.image");
  
  

%>
<html> 
<head>
<%if (charset != null){ %>
  <meta http-equiv="Content-Type" content="text/html; charset=<%=charset%>">
<%}else{ %>
  <meta http-equiv="Content-Language" content="en-us">
<%}%>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<style type="text/css">
tr {font-size:8pt;}
</style>

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/logview.css" />
<script>
 var posX = 100;
    var posY = 100;
    
	function hideOrShow(divid){
		if(layerSetup(divid).style.display == 'none'){
		 posX=posX++;
		 posY=posY++;
		 showDiv(divid,posX,posY);
		}else{
		 hideDiv(divid);
		}
	}
	
	function layerSetup(id) {
		theObj = document.getElementById(id);
		return theObj;
	}
	function getHeight(id) {
		theHeight = layerSetup(id).offsetHeight;
		return theHeight;
	}
	function showDiv(id,posX,posY) {
		layerSetup(id).style.display = 'block';
		layerSetup(id).style.left = parseInt(posX);
		layerSetup(id).style.top = parseInt(posY);
		layerSetup("im" + id).src = "<%=minusImg%>";
	}
	function hideDiv(id) {
		layerSetup(id).style.display = 'none';
		layerSetup("im" + id).src = "<%=plusImg%>";
	}
	
	  var oldtr;
	function setRowInFocus(tr){
		reset();
                color = 'black';
                style = 'solid';
                lwidth = '1';
		oldtr = tr;
		tdlist = tr.getElementsByTagName("td");
		for(i =0; i<tdlist.length;++i){
                        if(tdlist[i].parentNode != tr){
                          continue;
                        }
			if(i==0){
				tdlist[i].style.borderLeftStyle = style;
				tdlist[i].style.borderLeftWidth = lwidth;
				tdlist[i].style.borderLeftColor = color;
			}else if(i==tdlist.length-1){
				tdlist[i].style.borderRightStyle = style;
				tdlist[i].style.borderRightWidth = lwidth;
				tdlist[i].style.borderRightColor = color;

			}
			tdlist[i].style.borderBottomStyle = style;
			tdlist[i].style.borderTopStyle = style;
			tdlist[i].style.borderBottomWidth = lwidth;
			tdlist[i].style.borderTopWidth = lwidth;
			tdlist[i].style.borderBottomColor= color;
			tdlist[i].style.borderTopColor= color;
		}
	}

	function reset(){
		if(!oldtr){
			return;
		}
		tdlist = oldtr.getElementsByTagName("td");
		for(i =0; i<tdlist.length;++i){
			if(i==0){
				tdlist[i].style.borderLeftStyle='';
			}else if(i==tdlist.length-1){
				tdlist[i].style.borderRightStyle='';
			}
			tdlist[i].style.borderBottomStyle = '';
			tdlist[i].style.borderTopStyle = ''
		}

	}


function doSort(index){
  document.access.sortIndex.value = "" + index;
  document.access.submit();
}

function doCancelSort(){
  document.access.sortIndex.value = "-1";
  document.access.submit();
}

function zoomIn(key){
   if (parent){
    parent.zoomIn(key);
  }
}

function createNewDataRefBuilder(){
  return parent.createNewDataRefBuilder();
}

	function hideOrShowGroup(group,op){
	  var obj = document.getElementById("logviewTable");
		for (var i=0; i<obj.rows.length; i++){
		  if(obj.rows[i].id && obj.rows[i].id.length > 2 && obj.rows[i].id.substring(0,2)=="ID"){		  
			  var divid = obj.rows[i].id;
			  if(op == 'e'){
			  posX=posX++;
			  posY=posY++;
			  showDiv(divid,posX,posY);
			  }else{
			  hideDiv(divid);
			  }
			}
		}
	
		if (op == 'e'){
			document.getElementById("expandAll").style.display="none";
			document.getElementById("collapseAll").style.display="";
		} else {
			document.getElementById("expandAll").style.display="";
			document.getElementById("collapseAll").style.display="none";
		}
	}
	
	function backToTrans(){
		parent.hideDetailsFrame();
		//parent.parent.location="<%=BASE_DIRECTORY%>loggers/logview.jsp";
	}
		


<%
buildGoToStrcuture(dfBuilder,out,0,0);
%>

<%!
  private static void buildGoToStrcuture(DataReferenceBuilder builder,JspWriter out,int index,int y) throws java.io.IOException{

    String tmpDataSource = "tmpDataSource_" + index + "_" + y;
    if (index == 0){
      tmpDataSource = "parent.rootDataSource";
    }else {
      out.println("var " + tmpDataSource + "= createNewDataRefBuilder();");
    }
    if (builder == null) return;
    for (int i = 0; i < builder.getReferencesCount(); i++) {
      out.println(tmpDataSource + ".keys[" + i + "]=\"" + builder.getReferenceKeyAt(i) + "\";");
      buildGoToStrcuture(builder.getDataReferenceBuilderAt(i),out,index + 1,i);
      out.println(tmpDataSource + ".builders[" + i + "]=tmpDataSource_" + (index+1)+ "_" + i + ";");
    }
    out.println(tmpDataSource + ".title=\"" + builder.getTitle() + "\";");
    out.println(tmpDataSource + ".selectedIndex=" + builder.getSelectedIndex() + ";");

  }
%>
</script>
</head>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" action="logrecords.jsp">
<input type="hidden" name="sortIndex" value="-1">
<input type="hidden" name="update" value="true">
</form>
<table border="0" cellpadding="0" cellspacing="0"  width="100%">
	<tr>
		<td>
			<table border="0" cellpadding="0" cellspacing="0">
				<tr>
					<td class="HEADER"><span style="color:#CA6500">Events of transaction <%=transName%></span></td>
					<td width="10">&nbsp;</td>
					<td><span class="HEADER"><%=legend%></span></td>
				</tr>
			</table>
		</td>
	</tr>
  <tr><td>&nbsp;</td></tr>
	<tr><td valign="top" <%=isMessage?"height=\"20\"" : ""%>>
		<%=html%>
	</td>
	</tr>

  <tr>
    <td width="800">
    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber17">
      <tr>
        <td width="2%">&nbsp;</td>
        <td width="18%" align="left"><a id="expandAll" href="javascript:hideOrShowGroup('ID','e')" class="SMALLLINK">expand all</a><a id="collapseAll" href="javascript:hideOrShowGroup('ID','c')" class="SMALLLINK" style="display:none">collapse all</a></td>
        <td width="18%" algin="left"><a href="javascript:window.close();" class="SMALLLINK">close</a></td>
        <td width="62%">&nbsp;</td>
      </tr>
    </table>
    </td>
  </tr>
  <!--
  <tr>
    <td width="800">
    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber17">
      <tr>
        <td width="2%">&nbsp;</td>
        <td width="28%" align="left"><a href="javascript:backToTrans();" class="LINK">hide</a></td>
        <td width="70%">&nbsp;</td>
      </tr>
    </table>
    </td>
  </tr>
  -->

<table>

<script>
var title = "<%=title%>"
</script>
</body>
</html>