<%@ page language="java"%>  
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.common.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.comparators.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.index.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="omega.ui.models.*"%>
<%@ page import="omega.ui.html.table.OHtmlTable"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.data.log.external.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.data.xml.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page autoFlush="true"  %>
<%!
  static String EMPTY_STR = "";
  int ALLOWED_LOG_NAME_LENGTH = 30;
  static final String BASE_DIRECTORY = "../../";

  static String [] filterExtraNames = {"Zoom Out"};
  static String [] filterExtraFunctions = {"goLastFilterView()"};

  static String [] keysNames = {"logview.keys.prevKey",
                                "logview.keys.nextKey" ,
                                "logview.keys.lastKey" ,
                                "logview.keys.firstKey"};

  static String [] keysFunctions = {"goPrevTop()",
                                "goNextTop()" ,
                                "goLastTop()" ,
                                "goStartTop()"};
%>
<%
  //update menu tree
  String refreshMenuStr= request.getParameter("refreshMenu");
  boolean refreshMenu = false;
  if (refreshMenuStr == null || refreshMenuStr.length() == 0){
    String ref = request.getHeader("referer");
    if(ref == null || ref.indexOf("root.jsp") < 0){
  	if(ref != null && (ref.indexOf("translogview.jsp")) >= 0 || (ref != null && ref.indexOf("tailrecords.jsp") >=0)){
  		refreshMenu = false;
  	}else{
  		refreshMenu = true;
  	}
    }
  }else {
     refreshMenu  = refreshMenuStr.equals("true");
  }
  
  String queryStr = request.getQueryString();
  String CURRENT_LOG = "CURRENT_LOG";
  String CURRENT_LOG_QUERY_INFO = "CURRENT_LOG_QUERY_INFO";
  String ERROR_OBJ = "ERROR_OBJ";

  String enc = request.getParameter("enc");
  if (enc != null && enc.trim().length() == 0){
    enc = null;
  }

  Integer calls = (Integer)request.getSession().getAttribute("callsPage");
  String calstr = request.getParameter("calls");
  if(calstr == null || calstr.length() == 0){
    calstr = "0";
  }
  int cal = 0;
  boolean justRefreshNoMove = false;
  if(calls == null){
    request.getSession().setAttribute("callsPage",new Integer(-1));
  }else{
    cal = Integer.parseInt(calstr);
    if(calls.intValue() == cal){
      cal++;
      justRefreshNoMove = true;
    }else{
      calls = new Integer(cal);
      request.getSession().setAttribute("callsPage",calls);
      cal++;
    }
  }

  //getting the managment
  SiteManagment mgmt = SiteManagment.getInstance();
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);

  //id handling
  LogBrowsingManager man = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  String id = request.getParameter("logid");
  if(id == null){
    id = (String)request.getSession().getAttribute("logid");
  }else{
    if (id.length() > 0 && man != null && man.isTemporary()){
      man = null;
    }
    request.getSession().setAttribute("logid",id);
  }
  //manager handling
  
  String firstTimeStr = request.getParameter("firstTime");
  boolean firstTime = firstTimeStr != null && firstTimeStr.equals("true");
  
  
	String updateIntervalDS = request.getParameter("updateIDS");
	if (updateIntervalDS == null) updateIntervalDS = "false";
  if((man == null) || !man.isTemporary() && (man.getId()==null || !(man.getId().equals(id)) || updateIntervalDS.equals("true"))){
    final LogBrowsingManager oldMan = man;
    try{      
      man = mgmt.getLogBrowserManager(id);
      if(man == null){
        ErrorModel ermod = new ErrorModel();
        ermod.addError("You may not see the log. Please check for license constraints!");
        ermod.addError("It is probable that maximum number of active users was reached.");
        ermod.addError("Please try again later.");
        ermod.addError("For license upgrades visit us at <a href=http://www.xpolog.com>XpoLog</a>");
        request.getSession().setAttribute(ERROR_OBJ,ermod);
        response.sendRedirect("../../loggers/admin/errorpage.jsp");
        return;
      }
    }catch(Exception e){
      ErrorModel ermod = new ErrorModel();
      ermod.addError("Error Loading Log Browser - " + e.getMessage());
      ermod.addError("If you can not connect to remote host please check if its up and available");
      ermod.addError("It is also possible that your session expired");
      ermod.addError("or it is probable that the log was deleted by another user.");
      request.getSession().setAttribute(ERROR_OBJ,ermod);
      response.sendRedirect("../../loggers/admin/errorpage.jsp");
      return;
    }
    request.getSession().setAttribute(CURRENT_LOG,man);
    request.getSession().removeAttribute("callsPage");
    request.getSession().removeAttribute("lastModel");
    firstTime = true;
    if (oldMan != null){
      new Thread(){
        public void run(){
          oldMan.dispose();
          Runtime.getRuntime().gc();
        }
      }.start();
    }
  }
  //handle status issues
	LinearDataSource dc1 = man.getDefaultLinearDataBuilder().getLinearDataSource();
	LinearDataSource dc = null;
	if(dc1 instanceof XMLElementDataSource){
		dc = ((XMLElementDataSource)dc1).getDataSource();
	}else{
		dc = dc1;
	}
	if (firstTime){
    dc.setDataViewMode(DataConstants.DataViewModes.VIEW_MODE);
  }
	if(dc instanceof IntervalDataSource){
		IntervalDataSource ds = (IntervalDataSource)dc;
		if ((firstTime && (ds.isAutoUpdate() || !ds.tempDataAvailable())) || updateIntervalDS.equals("true")){
	    	response.sendRedirect("presentStatusAction.jsp");
	    	return;
	  } 
	  String dataLoadedString = request.getParameter("dataLoaded");
	  boolean dataLoaded = (dataLoadedString != null && dataLoadedString.equals("true"));
	  
	  if (!ds.isAutoUpdate() && (firstTime || dataLoaded)){
			//UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	  	String orgDirStr = IntervalAdminHelper.getTempDirFromEnv(env,man.getId());
	  	if (orgDirStr.equals("") || dataLoaded){
	  		File newDir = new File(ds.getNameExpression().getDirectory());
	  		ArrayList list = new ArrayList();
	  		list.add(newDir);
	  		if (newDir.exists() && ds.tempDataAvailable(list)){
		  		IntervalAdminHelper.setTempDirInEnv(env,man.getId(),ds.getNameExpression().getDirectory());
		  	}
	  	} else if (!orgDirStr.equals(ds.getNameExpression().getDirectory())){
	  		ds.resetNameExp(orgDirStr);
	  	}
	  }
	}
  /*String logType = man.getType();
  if(firstTime && logType != null && logType.equals(DBSimpleLogBuilder.DB_LOG_TYPE) || 
  	 logType.equals(HttpSimpleLogBuilder.HTTP_LOG_TYPE) ||
  	 logType.equals(HttpXmlLogBuilder.HTTP_XML_LOG_TYPE) ||
  	 logType.equals(FTPSimpleBuilder.FTP_LOG_TYPE) ||
  	 logType.equals(FTPXMLLogBrowserBuilder.FTP_XML_LOG_TYPE)) {
	 response.sendRedirect("presentStatusAction.jsp");
  }*/
  

  //insert last module to session
  Module mod = null;
  String CURRENT_MODULE = "CURRENT_MODULE";
  Module curmod = (Module)request.getSession().getAttribute(CURRENT_MODULE);

  if(curmod != null){
    if(curmod.isChild(man.getId())){
      //dont do nothing
    }else{
      mod = mgmt.getParentModule(id);
      request.getSession().setAttribute(CURRENT_MODULE,mod);
      curmod = mod;
    }
  }else{
    mod = mgmt.getParentModule(id);
    request.getSession().setAttribute(CURRENT_MODULE,mod);
    curmod = mod;
  }
  
  LogViewQueryInfo queryInfo = null;
  String useQueryInSession = request.getParameter("useQueryInSession");
  if (useQueryInSession != null && useQueryInSession.equals("true")){
    queryInfo = (LogViewQueryInfo)request.getSession().getAttribute(CURRENT_LOG_QUERY_INFO);
  }
  
  man.clearLastQuery();

  //header name
  String name = man.getName();
  //leap size
  int leapsize = queryInfo != null ? queryInfo.leapsize : man.getDefaultLeap();

  try{
	String str = request.getParameter("leapsize");
	if (str != null && str.length()>0){
      leapsize = Integer.parseInt(str);
	  man.setDefaultLeap(leapsize);
	}
  }catch(Exception e){
	//e.printStackTrace();
  }


  //operation check
  String op = queryInfo != null ? queryInfo.op : request.getParameter("opdirect");
  if(op == null){
    if (firstTime){
      op = man.getCustomizationManager().getStartOperation();
    }
    if (op == null){
      op = "CURRENT";
    }
  }

  
  if(justRefreshNoMove){
   op = "CURRENT";
  }
  
  //Indexing
  boolean indexingEnabled = SiteManagment.getInstance().getXpologManagment().isComponentLicenseValid(XpologManagment.SEARCH_ENGINE_COMPONENT);
	String runIndexingStr = request.getParameter("runIndexing");
	boolean runIndexing = false;
	if (indexingEnabled && runIndexingStr != null && runIndexingStr.equals("true")){
		runIndexing = true;
	}
	String rememberAnswerStr = request.getParameter("rememberAnswer");
	boolean rememberAnswer = false;
	if (indexingEnabled && rememberAnswerStr != null && rememberAnswerStr.equals("true")){
		rememberAnswer = true;
	}
	//System.out.println("rememberAnswer="+rememberAnswer);
  if (rememberAnswer){
  	env.setTempAttribute("INDEX_"+man.getId(),(runIndexing?"true":"false"));
  }
	String indexLog = (String)env.getTempAttribute("INDEX_"+man.getId(),false);
	if (indexLog == null) {
		indexLog = "";
	}
	//System.out.println("indexLog="+indexLog);
 
  String search = queryInfo != null ? queryInfo.search : request.getParameter("search");
  if (search == null || search.trim().length() == 0){
    search = null;
  }

  if (search != null && enc != null){
    search = new String(search.getBytes("8859_1") ,enc);
  }
  
  String searchRegExp = request.getParameter("searchRegExp");
  boolean isRegExp = queryInfo != null ? queryInfo.isRegExp : (searchRegExp != null && search != null && searchRegExp.equals("true"));
  boolean regExpOk = !isRegExp || FilterFieldHelper.checkPattern(search,true);
  
  String zoomInKey = queryInfo != null ? queryInfo.zoomInKey : request.getParameter("zoomInKey");
  if (zoomInKey == null || zoomInKey.trim().length() == 0){
    zoomInKey = null;
  }
 
  String searchStr = search == null ? "" : search;
  if (!regExpOk){
  	search = null;
  }

  boolean isNeedsToUpdateData = op.equals("TAIL");
  String tailFuncName = isNeedsToUpdateData ? "Stop Tail" : "Tail";
  String tailFunc = isNeedsToUpdateData ? "goLast()" : "goTail()";

  String title = EMPTY_STR;



   DataReferenceBuilder dfBuilder = null;
   if(op.equalsIgnoreCase("GOTO")){
      dfBuilder = (DataReferenceBuilder)request.getSession().getAttribute("lastDataReferenceBuilder");
      int deep = dfBuilder.getDeepLength();
      DataReferenceBuilder tmpBuilder = dfBuilder;
      for (int i = 0; i < deep; i++) {
      String val = request.getParameter("goToDS_" + i);
      if (val != null){
        tmpBuilder.setValue(val);
        tmpBuilder = tmpBuilder.getSelectedtDataReferenceBuilder();
        if (tmpBuilder == null){
          break;
        }
       }
     }
   }else {
     dfBuilder = LogEyeHelper.getDataReferenceBuilder(man);
   }

   String dfBuilderType = null;
   String dfBuilderTitle = "Go To";
   DataReferenceBuilder [] viewBuilders = new DataReferenceBuilder[0];
   if (dfBuilder != null){
     ArrayList list = new ArrayList();
     dfBuilder.getBuilders(list);
     viewBuilders = (DataReferenceBuilder [])list.toArray(new DataReferenceBuilder[list.size()]);
     if (viewBuilders.length > 0){
       for (int i = viewBuilders.length - 1; i >= 0; i--){
         if (viewBuilders[i].isVisible()){
           dfBuilderType = viewBuilders[i].getTitle();
           break;
         }
       }
       
       if (dfBuilderType != null){
         if (dfBuilderType.equalsIgnoreCase("Line")){
           dfBuilderTitle = "Go To Line";
         }else if (dfBuilderType.equalsIgnoreCase("File")){
           dfBuilderTitle = "Go To File";
         }
       }
     }
   }
   
   
 
	String moveStepsStr = request.getParameter("moveSteps");
	int moveSteps = queryInfo != null ? queryInfo.moveSteps : 0;
 	if (moveStepsStr != null && moveStepsStr.trim().length() > 0){
 	  try {
        moveSteps = Integer.parseInt(moveStepsStr);
      }catch (Exception e){}
    }
    
  LogViewQuickFilter quickFilter = new LogViewQuickFilter(man);
	 		
  /**
   * filter segment
   */
   
   String searchAndFilterDef = man.getSearchAndFilterDef();
   if(searchAndFilterDef == null || searchAndFilterDef.length() == 0) {
  	  searchAndFilterDef = Configuration.getInstance().getPropertiesManager().getProperty("searchAndFilterDef","START");
   }
   FilterManager film = man.getFilterManager();
   String searchEngineSearchTerm = request.getParameter("searchEngineSearchTerm");
   String searchEngineAllWords = request.getParameter("searchEngineAllWords");
   boolean allWords = (searchEngineAllWords != null && searchEngineAllWords.equals("allWords"));
   if (searchEngineSearchTerm != null && !searchEngineSearchTerm.equals("")){
   	 searchEngineSearchTerm = searchEngineSearchTerm.replaceAll("&quot;","\"");
	   FilterCollection fcol = SearchEngineAdminHelper.createFilter(searchEngineSearchTerm,allWords,man,false);
		 if (fcol != null){
		 	 film.addFilterCollection(fcol);
		 }
   }
   
   String quickFilterTerm = request.getParameter("quickFilterTerm");
   String quickFilterIndex = request.getParameter("quickFilterIndex");   
   if (quickFilterTerm != null && quickFilterTerm.length() > 0){
   	 
	   FilterCollection fcol = quickFilter.createQuickFilter(quickFilterTerm,Integer.parseInt(quickFilterIndex));
		 if (fcol != null){
		 	 film.addFilterCollection(fcol);
		 }
   }
   
   List listfilters = film.getFilterCollections();
   listfilters = Comparators.sortList(listfilters,FilterManager.FILTER_ASCENDING_IGNORE_CASE_COMPARATOR);
   String activeFilter =  "";
   if (!op.equals("ZOOM_IN")){
     if (op.equals("LAST_FILTER_VIEW")){
       activeFilter = man.getLastActiveFilter();
     }else {
       String activeId = request.getParameter("filters");
 	   if(activeId != null){
         if(activeId.equalsIgnoreCase("none")){
           film.setActiveFilterId(null);
         }else{
           film.setActiveFilterId(activeId);
         }
        }
        activeFilter = film.getActiveFilterId();
     }
   }
   
  /**
   * Indexing
   */
  IndexStatus indexStatus = null;
  if (man.isUseIndexing()){
     indexStatus = man.getIndexStatus();
     if (indexingEnabled && indexStatus == null){
	     indexStatus = man.updateIndexStatus(); 
	   }
	}
	
  if (indexStatus == null){
	  indexStatus = new IndexStatus(IndexStatus.NO_STATUS, -1);
	}
	//System.out.println("logview. indexStatus="+indexStatus);

  String mark = queryInfo != null ? queryInfo.mark : request.getParameter("mark");
   
  if (mark == null){
	mark = EMPTY_STR;
  }
  String legend = man.getLegend().getHtml();
  ArrayList filterExtraIndexes = new ArrayList();
  if (op.equals("ZOOM_IN") || (!op.equals("LAST_FILTER_VIEW") &&man.isHavingLastFilterView())){
    filterExtraIndexes.add(new Integer(0));
  }

  //some imaging configuratio
  Properties prop = Configuration.getInstance().getUIData();
  String firstImg = BASE_DIRECTORY + prop.getProperty("logview.firstarrow.image");
  String nextImg = BASE_DIRECTORY + prop.getProperty("logview.next.image");
  String lastImg = BASE_DIRECTORY + prop.getProperty("logview.lastarrow.image");
  String prevImg = BASE_DIRECTORY + prop.getProperty("logview.prev.image");
  String currImg = BASE_DIRECTORY + prop.getProperty("logview.currentarrow.image");
  String expandImg = BASE_DIRECTORY + prop.getProperty("logview.expandframe.image");
  String unExpandImg = BASE_DIRECTORY + prop.getProperty("logview.unexpandframe.image");
  String minusImg = BASE_DIRECTORY + prop.getProperty("logview.minus.image");
  String plusImg = BASE_DIRECTORY + prop.getProperty("logview.plus.image");
  String zoomoutImg = BASE_DIRECTORY + prop.getProperty("logview.zoomout.image");


  String charset = man.getCharset();
  if (charset != null){
    response.setContentType("text/html; charset=" + charset);
    
  }
  
  if (queryInfo == null){
    queryInfo = new LogViewQueryInfo();
  }
  queryInfo.leapsize = leapsize;
  queryInfo.op = op;
  queryInfo.search = search;
  queryInfo.mark = mark;
  queryInfo.moveSteps = moveSteps;
  queryInfo.zoomInKey = zoomInKey;
  queryInfo.isRegExp = isRegExp;
  request.getSession().setAttribute(CURRENT_LOG_QUERY_INFO,queryInfo);
  
  if (runIndexing){
    response.sendRedirect("presentIndexingStatusAction.jsp");
	  return;
	}

//Search history handling
SearchValuesMgr searchMgr = UserEnvironment.getUserEnvironment(request).getSearchValuesMgr();
String[] searchVals = searchMgr.getValues(id);
String searchAndFilterDefStr = man.getSearchAndFilterDef();
if(searchAndFilterDefStr == null || searchAndFilterDefStr.length() == 0) {
	searchAndFilterDefStr = Configuration.getInstance().getPropertiesManager().getProperty("searchAndFilterDef","START");
}
//add the value to the search history.
searchMgr.addValue(id,searchStr);
%>




<html>

<head>
<%if (charset != null){ %>
  <meta http-equiv="Content-Type" content="text/html; charset=<%=charset%>">
<%}else{ %>
  <meta http-equiv="Content-Language" content="en-us">
<%}%>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script language="javascript">
  //update menu
  <%if(refreshMenu){%>
  	refreshMenus();
  	<%}%>

  var value = <%=leapsize%>;
  var calls = <%=String.valueOf(cal)%>;
  var needsToUpdateData = false;
  var runIndexing = <%=runIndexing%>;
  var rememberAnswer = <%=rememberAnswer%>;
  function initPage(){
    document.access.leaptop.selectedIndex = 0;
    //document.access.updateIntervalDS.value = "0";
	var list = document.access.leaptop.options;
	for (var i = 0; i < list.length; i++) {
	  if (list[i].text == value){
		document.access.leaptop.selectedIndex = i;
	  }
	} 
	createSearchMenu();  
  }

  function goNextTop(){
    goNext(document.access.leaptop.options[document.access.leaptop.selectedIndex].text);
  }
 
  function goNext(size){
	updatePage(size,"NEXT");
  }
  function goPrevTop(){
    goPrev(document.access.leaptop.options[document.access.leaptop.selectedIndex].text);
  }
 
  function goPrev(size){
	updatePage(size,"PREV");
  }

  function goLast(){
    size = document.access.leaptop.options[document.access.leaptop.selectedIndex].text;
    updatePage(size,"LAST");
  }

  function goLastTop(){
    goLast(document.access.leaptop.options[document.access.leaptop.selectedIndex].text);
  }

  function goStart(size){
	updatePage(size,"START");
  }

  function goStartTop(){
    goStart(document.access.leaptop.options[document.access.leaptop.selectedIndex].text);
  }
  
  function goCurrent(size){
	updatePage(size,"CURRENT");
  }

  function goCurrentTop(){
    goCurrent(document.access.leaptop.options[document.access.leaptop.selectedIndex].text);
  }
  
  function goMove(size){  		
	updatePage(size,"MOVE");
  }


  function goMoveTop(){
    goMove(document.access.leaptop.options[document.access.leaptop.selectedIndex].text);
  }

  function doMark(){
	size = document.access.leaptop.options[document.access.leaptop.selectedIndex].text;
	updatePage(size,"CURRENT");
  }


  function doSearch(){
    if (document.getElementById('searchText').value == ""){
      doSearchDirect();
      return;
     }
		<%if (!indexingEnabled || !indexLog.equals("")){%>
			doSearchDirect();
		<%}else{%>
		<%if (indexStatus.getStatus() == IndexStatus.NEED_TO_INDEX){%>
			showGoToIndexDiv("searchLink","searchIndexStatusDiv");
		<%} else {
			if (indexStatus.getStatus() == IndexStatus.AUTO_INDEX){%>
				runIndexing = 'true';
		  <%} else {%>
				runIndexing = 'false';
		  <%}%>
			doSearchDirect();
    <%}%>
    <%}%>
  }

  function doSearchDirect(){
	  rememberAnswer = document.getElementById("rememberSearchIndexing").checked;
		size = document.access.leaptop.options[document.access.leaptop.selectedIndex].text;
		updatePage(size,"<%=searchAndFilterDefStr%>");
  }
  
  function formatSearchText(searchText){
  	while(searchText.indexOf('"')!=-1){
	  	searchText = searchText.replace(/"/,"&quot;");
	  }
  	return searchText;
  }

  function zoomIn(key){
     size = document.access.leaptop.options[document.access.leaptop.selectedIndex].text;
     updatePageWithKey(size,"ZOOM_IN",key);
  }

   function goTail(){
     goTailSize(25);
  }

  function goTailSize(size){
        updatePage(size,"TAIL");
  }

  function goLastFilterView(){
    updatePage(document.access.leaptop.options[document.access.leaptop.selectedIndex].text,"LAST_FILTER_VIEW");
  }

  function goNew(){
    goNextWithSize(document.access.leaptop.options[document.access.leaptop.selectedIndex].text);
  }

  function goNewWithSize(size){
        updateData(size,"TAIL");
  }


  function updatePage(size,direct){
     updatePageWithKey(size,direct,"");
  }

  function updatePageWithKey(size,direct,key){
        updatePageWithKey(size,direct,key,"");
  }
  function updatePageWithKey(size,direct,key,moreParams){
        needsToUpdateData = false;
        updateProg = false;
        document.access.search.value = formatSearchText(document.access.searchText.value);
        re = (document.access.regExp.checked == true) ? "true" : "";
        document.access.searchRegExp.value = re;
        document.access.leapsize.value = size;
        document.access.opdirect.value = direct;
        document.access.zoomInKey.value = key;
        document.access.runIndexing.value = runIndexing;
        document.access.rememberAnswer.value = rememberAnswer;
        document.access.action="translogview.jsp";
        document.access.submit();
	//this.location="logview.jsp?leapsize="+ size +"&opdirect=" + direct + "&calls="+calls + "&mark=" + mark + "&search=" + search + "&zoomInKey=" + key + "&"+moreParams;

  }

  function updateIntervalData(){
  	document.access.updateIDS.value = "true";
  	goCurrentTop();
  }


  function updateData(size,direct){
     updateDataWithKey(size,direct,"");
  }

  function updateDataWithKey(size,direct,key){
     needsToUpdateData = true;
     search = document.access.searchText.value;
     re = (document.access.regExp.checked == true) ? "true" : "";
     mark = "";
     calls++;
     frames['dataResultFrame'].location="tailrecords.jsp?leapsize="+ size +"&opdirect=" + direct + "&calls="+calls + "&mark=" + mark + "&search=" + search + "&zoomInKey=" + key + "&searchRegExp=" + re + "&runIndexing=" + runIndexing;
  }

  function copyImageAttributes(result,n){
    for (var i = 0; i < n.attributes.length;i++){
      var att = n.attributes[i];
      if (att.specified && att.nodeName == "src"){
       result.setAttribute(att.nodeName,att.nodeValue);
      }
    }

    for (var i = 0; i < n.attributes.length;i++){
      var att = n.attributes[i];
      if (att.specified && att.nodeName != "src"){
         result.setAttribute(att.nodeName,att.nodeValue);
      }
    }
  }


  function copy(n){
   if (!n.tagName && n.childNodes.length == 0){
      var s = n.nodeValue;
      if (s == null){
        s ="";
      }

      return frames['logRecordsView'].document.createTextNode(s);
   }
   var result = frames['logRecordsView'].document.createElement(n.tagName);
   if (n.tagName == "IMG" ){
     copyImageAttributes(result,n);
   }else {
     for (var i = 0; i < n.attributes.length;i++){
       var att = n.attributes[i];
       if (att.specified){
         result.setAttribute(att.nodeName,att.nodeValue);
       }
     }
   }
   result.style.cssText = n.style.cssText;

   for (var i = 0; i < n.childNodes.length;i++){
     if (n.childNodes[i].outerHTML != "<BR>"){
        var oTD = copy(n.childNodes[i]);
        result.appendChild(oTD);
     }else {
       result.innerHTML += n.childNodes[i].outerHTML;
     }
   }
   return result;
  }

  function dataLoaded(){
    if (needsToUpdateData){
      var dataTable = frames['dataResultFrame'].document.getElementById("logTable");
      var viewTable = frames['logRecordsView'].document.getElementById("logviewTable");
      if (dataTable != null && viewTable != null){
        
        var dataTBody = dataTable.childNodes[1];
        //var viewTable = layerSetup("logviewTable");
        var viewTBody = viewTable.childNodes[1];
       
        if (viewTBody.childNodes.length + dataTBody.childNodes.length > <%=Configuration.getInstance().getPropertiesManager().getProperty("tailNumberOfRecrodsDef","500")%>){
           goTail();
           return;
        }

        for (var i = 0; i < dataTBody.childNodes.length;){
           var obj = copy(dataTBody.childNodes[i]);          
	    dataTBody.deleteRow(i);
	   
           viewTBody.appendChild(obj);
           
        }
      }
      frames['logRecordsView'].scrollTo(0,frames['logRecordsView'].document.body.scrollHeight);
      refreshData();

    }
  }

  function refreshData(){
     var id = window.setTimeout("goNewWithSize("+ <%=Configuration.getInstance().getPropertiesManager().getProperty("tailNumberOfRecrodsDef","500")%> + ")",<%=Configuration.getInstance().getPropertiesManager().getProperty("tailRefreshRateDef","2000")%>);


  }

  function clearTable(keepNumber){
    var viewTable = frames['logRecordsView'].document.getElementById("logviewTable");
    var viewTBody = viewTable.childNodes[1];
    var num = viewTBody.childNodes.length - keepNumber;
    for (var i = num - 1; i >= 0; i--){
      viewTBody.deleteRow(i);
    }
  }

  function doCheck(e){
   	if (!e) var e = window.event;
	if (e.keyCode) code = e.keyCode;
	else if (e.which) code = e.which;
	if (code == 13 || code==59){
	  return false;
	}
	return true;
  }

  function doCheckMark(e){
	var result = doCheck(e);
        if (!result){
         doMark();
        }
	return result;
  }

   function doCheckSearch(e){
	var result = doCheck(e);
        if (!result){
         doSearch();
        }
	return result;
  }



  function hideShowMenu(){    
	root = top.frames['root'];	
	if (!root){
	  root = parent;
	}
	
	if (!root){
	  return;
	}
	
	if (root.location.href == document.location.href){
	  root.location = "<%=BASE_DIRECTORY%>root.jsp?mainPage=logic/online/translogview.jsp&<%=queryStr%>";
	}else {
	  root.location =  "<%=BASE_DIRECTORY%>logic/online/translogview.jsp?<%=queryStr%>";
	}
  }

  function getExpandImageName(){
	root = top.frames['root'];
	if (!root){
	  root = parent;
	}
	
	if (!root || root.location.href == document.location.href){
	  return "<%=unExpandImg%>";
	}else {
	  return "<%=expandImg%>";
	}
  }


   
   			function getFilterEntries(f){
   				var i = f.indexOf("*");
   				if (i != -1){
   					return f.substring(i+1,f.length)
   				} else {
   					return f;
   				}
   			}
   			function getFilterId(f){
   				var i = f.indexOf("*");
   				if (i != -1){
   					return f.substring(0,i);
   				} else {
   					return f;
   				}
   			}
   			
        function editFilter(){
          id = getFilterId(document.access.filters.options[document.access.filters.selectedIndex].value);
          path = "../tools/sandf/searchAndFilter.jsp?EDIT_FILTER_ID="+id;
          document.location = path;
        }
        function removeFilter(){
          id = getFilterId(document.access.filters.options[document.access.filters.selectedIndex].value);
          path = "../tools/sandf/searchAndFilterAction.jsp?REMOVE_FILTER_ID="+id;
          document.location = path;
        }
        function newFilter(){
          path = "../tools/sandf/searchAndFilter.jsp?OP=ADD";
          document.location = path;
        }
        function newMultiFilter(){
	  if(document.access.filters.options.length < 3){
	     alert("There must be at least two exsiting filters in order to create a Multi Filter.");
	     return;
          }
          path = "../tools/sandf/multiFilter.jsp?OP=ADD";
          document.location = path;
        }
        function goFilter(){
          id = getFilterId(document.access.filters.options[document.access.filters.selectedIndex].value);
          entries = getFilterEntries(document.access.filters.options[document.access.filters.selectedIndex].value);
          <%if (!indexingEnabled || !indexLog.equals("")){%>
          	goFilterDirect();
          <%}else{%>
          if (entries != ""  && id != "none"){
	        	<%if (indexStatus.getStatus() == IndexStatus.NEED_TO_INDEX){%>
							showGoToIndexDiv("filterOperation","filterIndexStatusDiv");
	        	<%} else {
							if (indexStatus.getStatus() == IndexStatus.AUTO_INDEX){%>
								runIndexing = 'true';
						  <%} else {%>
								runIndexing = 'false';
						  <%}%>
	          goFilterDirect();
	          <%}%>
	        }else {
	          goFilterDirect();
	        }
	        <%}%>
        }
        
        function duplicateFilter(){
          id = getFilterId(document.access.filters.options[document.access.filters.selectedIndex].value);
          path = "../tools/sandf/searchAndFilter.jsp?EDIT_FILTER_ID="+id+"&OP=duplicate";
          document.location = path;
        }

        function goFilterDirect(){
          rememberAnswer = document.getElementById("rememberFilterIndexing").checked;
          <%if (indexLog!=null && indexLog.equals("true") && indexStatus.getStatus() == IndexStatus.NEED_TO_INDEX){%>
          	runIndexing = 'true';
          <%}%>
          id = getFilterId(document.access.filters.options[document.access.filters.selectedIndex].value);
          path = "../tools/sandf/searchAndFilterAction.jsp?ACTIVATE_FILTER_ID="+id+"&RUN_INDEXING="+runIndexing+"&REMEMBER_ANSWER="+rememberAnswer;
          document.location = path;
        }
        
        function goQuickFilter(filterTerm,ind){       
         
          calls++;
          path = "translogview.jsp?calls=" + calls + "&opdirect=<%=searchAndFilterDef%>&quickFilterTerm=" + filterTerm + "&quickFilterIndex=" + ind;
	  document.location = path;
        }
        
        function createFilterMenu() {
 		 filterMenu = new jsDOMenu(100,"","absolute");
 		 with (filterMenu) {
    		addMenuItem(new menuItem("Edit", "editItem", "javascript:editFilter()"));
		    addMenuItem(new menuItem("New", "newItem", "javascript:newFilter()"));
		    addMenuItem(new menuItem("Multi", "multiItem", "javascript:newMultiFilter()"));
		    addMenuItem(new menuItem("Duplicate", "duplicateItem", "javascript:duplicateFilter()"));
		    addMenuItem(new menuItem("-"));
		    addMenuItem(new menuItem("Remove", "removeItem", "javascript:removeFilter()"));
		 } 
		 <%
		   
	 		 if (quickFilter.getQuickFilterCount() > 0){
	 		 
	 		 %>
	 		   filterMenu.addMenuItem(new menuItem("-"));
	 		   
	 		<%   
	     for (int i = 0; i < quickFilter.getQuickFilterCount(); i++) {
	       String filterId = "filterMenu" + i;
	       int colIndex = quickFilter.getQuickFilterColumnIndexAt(i);
	       String [] quickFilters = quickFilter.getQuickFiltersAt(i);
	       %>
	       filterMenu.addMenuItem(new menuItem("<%=quickFilter.getQuickFilterColumnNameAt(i)%>", "<%=filterId%>", ""));
	       <%=filterId%> = new jsDOMenu(100,"","absolute");
	       with(<%=filterId%>){
	         <%for (int j = 0; j < quickFilters.length; j++) {%>
	           addMenuItem(new menuItem("<%=quickFilters[j]%>", "<%=filterId + "_" + j%>", "javascript:goQuickFilter('<%=quickFilters[j]%>','<%=String.valueOf(i)%>')"));
	         <%}%>
	       }
	       filterMenu.items.<%=filterId%>.setSubMenu(<%=filterId%>);
				<%}%>	       	     	   	     	   				
	     <%}%>
		 filterChanged();
		}
		
		function selectedSearchVal(searchStr) {
    		document.getElementById('searchText').value = searchStr;
		}
		
		function clearSearchBox() {
    		document.getElementById('searchText').value = '';
		}
		
		function createSearchMenu(searchStr) {
			searchMenu = new jsDOMenu(100,"","absolute");
			<%
			if(searchVals != null) {
				for(int i=0;i<searchVals.length;++i) {
					if(searchVals[i] != null) {%>	
						searchMenu.addMenuItem(new menuItem("<%=searchVals[i]%>", "", "javascript:selectedSearchVal('<%=searchVals[i]%>')"));
					<%
					}
				}
			}
			%>
			if(searchMenu.items.length > 0) {
				searchMenu.addMenuItem(new menuItem("-", "", ""));
				searchMenu.addMenuItem(new menuItem("Clear", "", "javascript:clearSearchBox()"));
			}	
		}
        
        function filterChanged(){
          enable = document.access.filters.selectedIndex > 0;          
          filterMenu.items.editItem.setEnabled(enable);
          filterMenu.items.removeItem.setEnabled(enable);
          filterMenu.items.duplicateItem.setEnabled(enable);
        }


        function kpress(e){
          if (!e) var e = window.event;
          if(e.srcElement){
            objElement = e.srcElement;
            if(objElement == document.access.searchText){
              return;
            }
          }


	  if (e.keyCode) code = e.keyCode;
	  else if (e.which) code = e.which;
          key = String.fromCharCode(code);
          <%
          for (int i = 0; i < keysNames.length; i++) {
            String keyValue = prop.getProperty(keysNames[i]);
            if (keyValue != null && keyValue.length() > 0){%>
               if (code == "<%=keyValue%>" || key == "<%=keyValue%>"){
                  <%=keysFunctions[i]%>;
               }
            <%}
          }%>

         }

         if(document.layers){
           document.captureEvents(Event.KEYPRESS)
         }
         document.onkeypress=kpress;



      


function DataRefBuilder(){
  this.keys = new Array();
  this.builders = new Array();
  this.title = "";
  this.selectedIndex = -1;
}

function createNewDataRefBuilder(){
  return new DataRefBuilder();
}

var rootDataSource = new createNewDataRefBuilder();
var deep = <%=dfBuilder == null? 0 : dfBuilder.getDeepLength()%>;



function updateGoTo(index,builder){
  if (index < deep){
    if (builder.keys.length > 0){
      var combo = document.getElementById("goToDS_" + index);
      combo.options.length = 0;
      for (var i = 0; i < builder.keys.length;i++){
       combo.options[combo.options.length] = new Option(builder.keys[i],builder.keys[i]);
      }
      var selIndex = builder.selectedIndex == -1 ? 0 : builder.selectedIndex;
      combo.selectedIndex = selIndex;
      updateGoTo(0,builder.builders[0]);
    }else {
      document.getElementById("goToDS_" + (deep -1)).value = "";
    }
  }
}



 function goTo(){
   size = document.access.leaptop.options[document.access.leaptop.selectedIndex].text;
   updatePage(size,"GOTO");
 }

  function doGoTo(e){
	var result = doCheck(e);
        if (!result){
         goTo();
        }
	return result;
  }


function init(){
}

var recordsLoaded = false;
function recordsViewLoaded(){
 if (!recordsLoaded){
   document.getElementById("titleDiv").innerHTML = frames['logRecordsView'].title;
   updateProg = false;
   updateQueryStatus();
   recordsLoaded = true;
   
   updateGoTo(0,rootDataSource);
   
   if (<%=isNeedsToUpdateData%>){
     refreshData();
   }
 }
}

var updateProg = true;
function getProgressFrame(){
  return self;
}

function goProgress(){
  if (updateProg){
    updateQueryStatus();
  }
}

function updateQueryStatus(){
  if (frames['funcsFrame']){
    frames['funcsFrame'].location = "queryStatus.jsp";
  }
}

function refreshRecordsView(){
  frames['logRecordsView'].location = "translogrecords.jsp?refresh=true&timestamp=<%=String.valueOf(System.currentTimeMillis())%>";
}

function cancelQuery(){
  updateProg = false; 
  if (frames['funcsFrame']){
    frames['funcsFrame'].location = "cancelQuery.jsp";
  }
}

function moveFunction(sliderPosition) {
	document.getElementById("sliderValue").innerHTML = "<nobr>" + getCalculateSliderPosition(sliderPosition) + "</nobr>";
}

function stopFunction(sliderPosition) {
    step = getCalculateSliderPosition(sliderPosition);
	move(step);
}

function getCalculateSliderPosition(sliderPosition){
  step = value / 25; 
  result = Math.round(value*2*sliderPosition);  
  result = result - (result % step);
  return result - value;  
}

function move(step){
  document.access.moveSteps.value = "" + step;
  if (step == 0){
    return;
  }
  goMoveTop();
}

var myslider;

function createSlider(){
  myslider = new slider(
	16,        //height of track
	100,       //width of track
	'#9999bb', //colour of track
	2,         //thickness of track border
	'#770000', //colour of track border
	2,         //thickness of runner (in the middle of the track)
	'#000000', //colour of runner
	12,        //height of button
	5,        //width of button
	'#dfdfdf', //colour of button
	2,         //thickness of button border (shaded to give 3D effect)
	'', //text of button (if any)
	true,      //direction of travel (true = horizontal, false = vertical)
	'moveFunction', //the name of the function to execute as the slider moves
	'stopFunction', //the name of the function to execute when the slider stops
	                //the functions must have already been defined (or use null for none)
	true);

  myslider.setPosition(0.5);
}

</script>

<script language="javascript">
function enterFilter(){
 enterBtn(document.getElementById("filterOperation"));
 enterBtn(document.getElementById("FilterBut")); 
}

function exitFilter(){
  exitBtn(document.getElementById("filterOperation"));
  exitBtn(document.getElementById("FilterBut")); 
}

function enterSearch(){
 enterBtn(document.getElementById("searchLink"));
 enterBtn(document.getElementById("SearchBut")); 
}

function exitSearch(){
  exitBtn(document.getElementById("searchLink"));
  exitBtn(document.getElementById("SearchBut")); 
}

function enterBtn(comp){
  setClassName(comp,"LINKBTNOVER");
}

function exitBtn(comp){
  setClassName(comp,"LINKBTN");
}


function showGoToDiv(){  
  comp = document.getElementById("goTOTD");
  d = document.getElementById("goToDiv");
  x = findPosX(comp) - d.clientWidth;
  y = 100;
  showHideLayerInMiddle("goToDiv",x,y);
  if (d.style.visibility == "" && deep > 0){  
    for(var i = deep - 1; i>= 0;i--){
      if (document.getElementById("goToDS_" + i).style.visibility == ""){
        document.getElementById("goToDS_" + i).focus();
        break;
      }
    }  
    
  }
}

function showGoToIndexDiv(posElem,divElem){  
  comp = document.getElementById(posElem);
  d = document.getElementById(divElem);
  x = findPosX(comp) - d.clientWidth;
  y = findPosY(comp) + 70;
  showHideLayerInMiddle(divElem,x,y);
}

function formatQuery(){
	while(document.access.searchTerm.value.indexOf('"')!=-1){
		document.access.searchText.value = document.access.searchText.value.replace(/"/,"&quot;");
	}
}

</script>
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/jsdomenu.css" />
<jsp:include page="../../scripts/comps/jsdomenu.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
</jsp:include>
<script src="<%=BASE_DIRECTORY%>scripts/comps/slider.js" type="text/javascript" ></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
</head>
<body onload='javascript:initPage();init();' topmargin="2" leftmargin="2" rightmargin="0">
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" >
<input type="hidden" name="enc" value="<%=charset == null? "" : charset%>">
<input type="hidden" name="calls" value="<%=String.valueOf(cal)%>">
<input type="hidden" name="opdirect" value="CURRENT">
<input type="hidden" name="leapsize" value="<%=leapsize%>">
<input type="hidden" name="search" value="<%=searchStr%>">
<input type="hidden" name="searchRegExp" value="<%=searchRegExp%>">
<input type="hidden" name="runIndexing" value="<%=runIndexing%>">
<input type="hidden" name="rememberAnswer" value="<%=rememberAnswer%>">
<input type="hidden" name="mark" value="">
<input type="hidden" name="zoomInKey" value="">
<input type="hidden" name="moveSteps" value="0">
<input type="hidden" name="updateIDS" value="false">

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
<tr><td height="10%">
<table border="0" width="100%" cellspacing="0"  cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" >
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1" >
          <tr>
            <td width="100%"  valign="top">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td   class="TOPLEFTBORDER" align="left">
                <font size="2">
                <table border="0" cellpadding="0" cellspacing="0">
                <%
                String tempName = null;
                tempName = name;
                if(name != null && name.length() > ALLOWED_LOG_NAME_LENGTH) {
                	tempName = name.substring(0,ALLOWED_LOG_NAME_LENGTH) + "...";
                }
                %>
                <tr>
                  <td nowrap ><nobr><%if(!Configuration.getInstance().isEmbeded()){%><a href="javascript:hideShowMenu()" class="LINK"><script>document.write("<img border=\"0\" src=" + getExpandImageName() + ">");</script></a><%}%></nobr></td>
                  <td nowrap ><span class="HEADER">Log View -</span></td>
                  <td nowrap ><span class="HEADER"><%=tempName%>- </span></td>
                  <td nowrap ><span class="HEADER"><div id="titleDiv"><%=title%></div></span></td>
                  <td nowrap ><span class="HEADER"><%=legend%></span> </td>
                </table>
                  </font> </td>

                <td width="*" class="TOPRIGHTBORDER"><font size="2">&nbsp;</font></td>
              </tr>
              <tr>

                <td  colspan="2" border="1" style="padding-top: 5;padding-bottom: 5">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="70">
                  <tr>
                    <td  height="2">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
                      <tr>
                        <td style="padding-left:20;padding-top: 2" width="165" >
							<table border="0" cellpadding="0" cellspacing="0"  width="100%">
								<tr><td width="15">
									<a  href="javascript:move(-1);" class="LINK">
									<img alt="backfords records" title="backfords records" border="0" src="<%=BASE_DIRECTORY%>images/logview/prev.png">
									</a>
								</td>
								<td width="100" style="padding-left:2">
                       				 <script>createSlider();</script>
								</td>
								<td width="15" style="padding-left:2">
									<a  href="javascript:move(1);" class="LINK">
									<img alt="forwards records" title="forwards records" border="0" src="<%=BASE_DIRECTORY%>images/logview/next.png">
									</a>
								</td>
								<td width="*" style="padding-left:2;padding-bottom:2" class="REGULARTEXT" id="sliderValue">
								0
								</td></tr>
							</table>
                        </td>
                        
                        <td class="MENUSEPARATE" width="1"></td>
                        
                        <td style="padding-top: 2;padding-left:5" width="200">
                        	<table border="0"  height="20" cellspacing="0" cellpadding="0">
                        	<tr><td width="50">						 
                          <select class="SMALLTEXT" name="filters"  size="1" style="height: 20px; padding-left: 3px;" onchange="javascript:filterChanged()">
                          <option class="SMALLTEXT" value="none" selected>None</option>
                          <%
                          FilterCollection fc = null;
                          String fn = null;
                          String tempFn = null;
                          String fi = null;
                          String fis = "";
                          String fe = "";
                          for(int i=0;i<listfilters.size();++i){
                            fc = (FilterCollection)listfilters.get(i);
                            fn = fc.getName();
                            fi = fc.getId();
                            fe = fc.getAllFilterTerms();
                            if(fi.equals(activeFilter)){
                              fis = "selected";
                            }else{
                               fis = "";
                            }
                            fi += "*"+ (fe  != null && fe.length() > 0 ? "1" : "");
                            tempFn = fn;
                        	if(fn != null && fn.length()>15) {
                            	tempFn = fn.substring(0,15) + "...";
                            }
                          %>
                          <option class="SMALLTEXT" title="<%=fn%>" value="<%=fi%>" <%=fis%>><%=tempFn%></option>
                          <% } %>
                        </select>
                        </td><td width="*" style="padding-left:3">
                        <table border="0"  cellspacing="0"  cellpadding="0">
 						 <tr>
   						 <td >        
                        <table border="0" width="50" height="20" cellspacing="0" cellpadding="0">
         				 <tr style="padding:1">
	   						<td id="filterOperation" class="LINKBTN" onmouseenter="javascript:enterFilter();" onmouseleave="javascript:exitFilter();">
									<a href="javascript:goFilter()" class="LINK">Filter</a>
     				    </td>
	   						<td valign="top" id="FilterBut" class="LINKBTN" onClick="javascript:showMenuPopup(this,'filterMenu')" onmouseenter="javascript:enterFilter();" onmouseleave="javascript:exitFilter();">
           					  <img src="<%=BASE_DIRECTORY%>images/logview/downArrow.png" >
           					  
	  						 </td>	
	  						 					
	  						 <% if (filterExtraIndexes.size() > 0){%>
                            <td style="padding-left:3;padding-right:2">
                           <% for (int i = 0; i < filterExtraIndexes.size(); i++) {
                             int index = ((Integer)filterExtraIndexes.get(i)).intValue();
                           %>
                              <img alt="<%=filterExtraNames[index]%>" src="<%=zoomoutImg%>" onClick="javascript:<%=filterExtraFunctions[index]%>" onmouseover="this.style.cursor='pointer'" onmouseout="this.style.cursor='default'">
                            </td>
                            <% } %>
                           
                        <%}%>  
	 					</tr>
						</table>
						</td>
  						</tr>

						</table>                        
                        
                        </td></tr></table>
						</td>
						<td class="MENUSEPARATE" width="1"></td>
						<td rowspan="2" style="padding-top: 2;padding-left:5" width="100">
						  <table border="0"  cellspacing="0"  cellpadding="1">
						  <tr><td>
						   <a href="admin/logUIadmin.jsp" class="LINKBTN" onmouseenter="javascript:enterBtn(this);" onmouseleave="javascript:exitBtn(this);">Customize</a>&nbsp;&nbsp;
						  </td></tr>						  
						  <tr><td id="goTOTD">
						  <%if (dfBuilder != null){%>
						<a class="LINKBTN" href="javascript:showGoToDiv()" onmouseenter="javascript:enterBtn(this);" onmouseleave="javascript:exitBtn(this);"><%=dfBuilderTitle%></a>
							<div id="goToDiv" style="position:absolute;visibility:hidden;height:80">
       						    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:1px solid #000000">
									<tr height="10"><td align="center" style="background:blue;color:white">
									  <span class=REGULARTEXT" ><%=dfBuilderTitle%></span>
								    </td>
									</tr>
									<tr height="*" align="left" valign="center" style="padding-top:15;padding-left:15"><td>
		 			 				<nobr>
		  							 <%int deep = dfBuilder.getDeepLength();
                           			 int i = 0;                           			
                           			 for (; i < viewBuilders.length - 1; i++) {%>
                             		   <select class="SMALLTEXT" size="1" name="goToDS_<%=i%>" id="goToDS_<%=i%>" <%=viewBuilders[i].isVisible() ? "" : "style=\"visibility:hidden\""%>>
                             		   </select>&nbsp;&nbsp;
                          			 <%} 
                          			  
                          			 %>
                            		 <input class="SMALLTEXT" type="text" name="goToDS_<%=i%>" id="goToDS_<%=i%>" value="" size="5" onKeyPress="return doGoTo(event)" <%=viewBuilders[viewBuilders.length - 1].isVisible() ? "" : "style=\"visibility:hidden\""%>>&nbsp;&nbsp;                            		 
                  					</nobr>
                  					</td>
									</tr>
									<tr height="20"><td align="center" style="padding:5">
		 								<a class="LINK" href="javascript:hideLayer('goToDiv');">cancel</a>&nbsp;
		  								<a class="LINK" href="javascript:hideLayer('goToDiv');goTo()">go</a>&nbsp;		  	
									</td>
									</tr>
	  							 </table>
							</div>  
                    	<%}%>  
                    	
						  </td></tr>
						  <% IntervalDataSource ds = IntervalAdminHelper.getIntervalDataSource(man);%>
						  <% if (man.isTailSupported()){%>
						  	<tr><td>
	              <a href="javascript:<%=tailFunc%>" class="LINKBTN" onmouseenter="javascript:enterBtn(this);" onmouseleave="javascript:exitBtn(this);"><%=tailFuncName%></a>&nbsp;
	              <%if (ds != null && !man.isTemporary()){%>
									<a href="javascript:updateIntervalData()" class="LINKBTN" onmouseenter="javascript:enterBtn(this);" onmouseleave="javascript:exitBtn(this);">Reload</a>
		            <%}%>
	              </td></tr>
	            <% } else if (ds != null && !man.isTemporary()){%>
						  	<tr><td><a href="javascript:updateIntervalData()" class="LINKBTN" onmouseenter="javascript:enterBtn(this);" onmouseleave="javascript:exitBtn(this);">reload</a></td></tr>
	            <% } %>
						  </table>
						</td>
						<td class="MENUSEPARATE" width="1"></td>
						<td  width="*" rowspan="2">
						<%String progressBarUrl = xpolog.eye.util.WebUtil.getURLWithPrefix("common/progressBar.jsp");%>
						<jsp:include page="<%=progressBarUrl%>" flush="true">
						  <jsp:param name="stopURL" value="javascript:cancelQuery()"/>
						</jsp:include>
						</td>
                 
                      </tr>                   
                      <tr>
                        
                                <td border="1" align="left" width="165" style="padding-left:20;padding-top:2;padding-bottom:2">
                                <nobr>
                                <a href='javascript:goStartTop()' class="LINK">
								<img alt="first records" title="first records" border="0" src="<%=firstImg%>"></a>
								<a  href="javascript:goPrevTop()" class="LINK">
								<img alt="previous records" title="previous records" border="0" src="<%=prevImg%>"></a>

                                <select class="TEXTBOX" size="1" name="leaptop" style="height: 20px; font-family: Verdana, Geneva, Arial, Helvetica; font-size: 10px; padding-left: 3px;" <%=isNeedsToUpdateData? "DISABLED" : ""%>>
                                    <option>25</option>
                                    <option>50</option>
                                    <option>100</option>
                                    <option>250</option>
                                    <option>500</option>
                                  </select>

                                <a href='javascript:goNextTop()' class="LINK">
                                  <img alt="next records" title="next records" border="0" src="<%=nextImg%>"></a>
								<a href='javascript:goLastTop()' class="LINK">
								  <img alt="last records" title="last records" border="0" src="<%=lastImg%>"></a>
								<a href='javascript:goCurrentTop()' class="LINK">
								  <img alt="update records" title="update records" border="0" src="<%=currImg%>"></a>
								</nobr>
								</td>
								<td class="MENUSEPARATE" width="1">
									<div id="filterIndexStatusDiv" style="position:absolute;visibility:hidden;height:80;width:200">
		 						    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:1px solid #000000">
											<tr height="10"><td align="center" style="background:blue;color:white">
											  <span class=REGULARTEXT">Log Indexing</span>
									    </td>
									    </tr>
		 						    	<tr height="10"><td class="REGULARTEXT" align="center">Log needs to be indexed. Start indexing?</td></tr>
											<tr height="10">
												<td class="SMALLTEXT" align="center">
													<input type="checkbox" name="rememberFilterIndexing" id="rememberFilterIndexing">remember my answer</input>
												</td>
											</tr>
											<tr height="20">
												<td align="center" style="padding:5">
					 								<a class="LINK" href="javascript:hideLayer('filterIndexStatusDiv');">cancel</a>&nbsp;<nobr>
					  							<a class="LINK" href="javascript:hideLayer('filterIndexStatusDiv');runIndexing='true';goFilterDirect()">yes</a>&nbsp;<nobr>
					  							<a class="LINK" href="javascript:hideLayer('filterIndexStatusDiv');runIndexing='false';goFilterDirect()">no</a>&nbsp;<nobr>
												</td>
											</tr>
		 							 	</table>
									</div>  
									<div id="searchIndexStatusDiv" style="position:absolute;visibility:hidden;height:80;width:250">
		 						    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:1px solid #000000">
											<tr height="10" ><td align="center" style="background:blue;color:white">
											  <span class=REGULARTEXT">Log Indexing</span>
									    </td>
									    </tr>
		 						    	<tr height="20" style="padding:5"><td class="REGULARTEXT" align="center">Log needs to be indexed.<br> Start indexing?</td></tr>
											<tr height="10" >
												<td class="SMALLTEXT" align="center">
													<input type="checkbox" name="rememberSearchIndexing" id="rememberSearchIndexing">remember my answer</input>
												</td>
											</tr>
											<tr height="20">
												<td align="center" style="padding:5">
					 								<a class="LINK" href="javascript:hideLayer('searchIndexStatusDiv');">cancel</a>&nbsp;<nobr>
					  							<a class="LINK" href="javascript:hideLayer('searchIndexStatusDiv');runIndexing='true';doSearchDirect()">yes</a>&nbsp;<nobr>
					  							<a class="LINK" href="javascript:hideLayer('searchIndexStatusDiv');runIndexing='false';doSearchDirect()">no</a>&nbsp;<nobr>
												</td>
											</tr>
		 							 	</table>
									</div>  
             		</td>
                        		
								<td style="padding-left:5" width="165">
								 <!--<span class="REGULARTEXT">Search:&nbsp;</span>-->
								 <table border="0"  cellspacing="0"  cellpadding="0">
						  		<tr><td align="left" nowrap>
						  			 <%String regExpChecked = isRegExp ? " checked" : "";%>
                        <span class="SMALLTEXT" style="margin-left:-3px"><input style="height:15px;" type="checkbox" name="regExp" value="true" <%=regExpChecked%>>regular expression</span>
                  </td></tr>
                  <tr><td align="left">     
                        <input class="SMALLTEXT" type="text" name="searchText" id="searchText" value="<%=searchStr%>" size="20" onKeyPress="return doCheckSearch(event)" style="height: 20px; padding-left: 3px;font-size:9">
                        </td>
												<td width="*" style="padding-left:3">
                        <table border="0"  cellspacing="0"  cellpadding="0">
 												 <tr>
   												 <td >        
                         		<table border="0" width="50" height="20" cellspacing="0" cellpadding="0">
         				 							<tr style="padding:1">
	   														<td id="searchLink" class="LINKBTN" onmouseenter="javascript:enterSearch();" onmouseleave="javascript:exitSearch();">
         					 							  <a href="javascript:doSearch()" class="LINK">search</a>
         				  						  </td>
	   														<td valign="top" id="SearchBut" class="LINKBTN" onClick="javascript:showMenuPopup(this,'searchMenu')" onmouseenter="javascript:enterSearch();" onmouseleave="javascript:exitSearch();">
           											  <img alt="search history" src="<%=BASE_DIRECTORY%>images/logview/downArrow.png" >
           					  
	  														 </td>	
	  						 					
	  						   
	 														</tr>
														</table>
													</td>
  											</tr>
											</table>                        
                    
                   </tr>
								</table>
								                  
						</td>
						<td class="MENUSEPARATE" width="1"></td>
						<!--<td  nowrap style="padding-top: 2;padding-left:5" wid	th="150" id="goTOTD"><nobr>
						
                        </nobr>                                          
                      </td>-->
                      <td class="MENUSEPARATE" width="1"></td>
                    </tr>
                   </table>

                   </td>
                  </tr>
                                  

                    </table>

                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
     
 </form>     
    </table>
</td></tr>

<tr><td height="90%">

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
 <%if(!regExpOk){%>
 <tr height="1"><td style="padding-left:30">
    	<span class="ERRORMESSAGE">*&nbsp;Could not parse regular expression. Please check your entry again</span>
 </td></tr>
 <tr height="1"><td>&nbsp;</td></tr>
 <%}%>
 <tr><td style="padding-left:10">
 <iframe name="logRecordsView"  onfocus="javascript:hideVisibleMenus()" onload="javascript:recordsViewLoaded();" src="translogrecords.jsp?timestamp=<%=String.valueOf(System.currentTimeMillis())%>" width="100%" height="100%" FrameBorder="0" hspace="0" vspace="0" MarginHeight="0"></iframe> 
 </td></tr> 
</table>
<iframe name="dataResultFrame"  onload="javascript:dataLoaded();" style="visibility:hidden" width="1" height="1"></iframe>
<iframe name="funcsFrame"  style="visibility:hidden" width="0%" height="0%"  ></iframe>

</td></tr> 
</table>

<script>
createFilterMenu();
setTimeout("goProgress()", 1000);
</script>

</body>
</html>

