<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.logic.atomic.data.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.ui.admin.*"%>
<%@ page import="xpolog.logic.ui.log.admin.*"%>
<%@ page import="xpolog.logic.ui.site.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="xpolog.logic.ui.site.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
UserContext userContext = UserEnvironment.getUserContext(request);

	String TRANS_PARADIGM_ID = "transParadigmId";
	String TRANS_PARADIGM_IDS_LIST = "transParadigmIdsList";
  String CURRENT_LOG = "CURRENT_LOG";
  String ERROR_OBJ = "ERROR_OBJ";
	
	String transParadigmId = request.getParameter(TRANS_PARADIGM_ID);
	String transParadigmIdsList = request.getParameter(TRANS_PARADIGM_IDS_LIST);
	String transactionLogId = TransactionLogBuilder.TRANSACTION_LOG_BASE_ID;
	String zoomOutUrl = request.getParameter("zoomOutUrl");
	if (zoomOutUrl != null){
		zoomOutUrl = "&zoomOutUrl="+zoomOutUrl;
	}else{
		zoomOutUrl = "";
	}
	if (transParadigmId != null && !transParadigmId.equals("")){
	//	transactionLogId += "_"+transParadigmId;
	}

  LogicEnvironment logicEnv = LogicEnvironment.getLogicEnvironment(request);
  String sessionRuntimeId = logicEnv.getSessionRuntimeId();
  
  DataSessionRuntime dsr = null;
	if (sessionRuntimeId != null && !sessionRuntimeId.equals("")){
		dsr = CtrlMgr.getInstance().getDataSessionRuntimeById(sessionRuntimeId);
	}
	if (dsr == null || dsr.getId().equals(DataSession.ONLINE_DATA_SESSION_ID)){
		dsr = new DataSessionRuntime();
		dsr.setId(DataSession.ONLINE_DATA_SESSION_ID);
    ErrorModel ermod = new ErrorModel();
    ermod.addError("You are trying to display the log view of a Transaction, but there is no selected project");
    ermod.addError("Select a result from the tree pane and try again");
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect("../../common/errorpage.jsp?cancelURL=logic/logicPortal.jsp&okURL=logic/logicPortal.jsp");
    return;
	}

  CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();  
  String [] transactions = ctrlMgr.getTransactionParadigmForSessionPradigm(dsr.getDataSesParadigmId());
  if (transactions == null){
     transactions = new String[0];
  }
  UITransactionParadigmBuilder uipBuilder = new UITransactionParadigmBuilder();
  ErrorModel ermo = new ErrorModel();
  HashSet set = new HashSet();
  LinkedList list = new LinkedList();
	  for (int i=0; i<transactions.length; i++){
	  	String transId = transactions[i];
	  	uipBuilder.loadTransactionGraph(transId);
	  	TransactionParadigm tp = uipBuilder.getTransactionParadigm();
	  	if (tp == null){
	  		ermo.addError("Failed to load transaction (id="+transId+")");
	  		continue;
	  	}
			XpoLogAtomicParadigm[] unusable = UITransactionParadigmHelper.checkTransationParadigmValidity(uipBuilder);
			if (unusable != null && unusable.length > 0){
				list.add("Transaction "+tp.getName()+" has definition problems");
		    list.add("The are problems with the following data sources:");
		    for (int u=0; i<unusable.length; i++){
		    	String lbmId = unusable[u].getDateSource().getLbmId();
		    	String nodeId = unusable[u].getDateSource().getNodeId();
		    	StringBuffer message = new StringBuffer();
		    	message.append("Log Id: "+lbmId);
		    	if (nodeId!=null&&nodeId.length()>0 ){
		    		message.append("(XpoLog Node Id: "+nodeId+". Check that remote node is up and that the remote log is accessible)");
		    	}
		    	set.add(message.toString());
		    }
			}
	    Iterator it = list.iterator();
	    while(it.hasNext()){
	    	String m = (String)it.next();
	    	ermo.addError(m);
	    }
	    it = set.iterator();
	    while(it.hasNext()){
	    	String m = (String)it.next();
	    	ermo.addError(m);
	    }
	  }	
	if (ermo.getErrorCount() > 0){
    request.getSession().setAttribute(ERROR_OBJ,ermo);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
	}

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){ 
     return;
  }
  UserSecurity user = manager.getUserSecurity(request);
  TransactionTypeViewModel model = TransactionTypeViewModelFactory.createTransactionTypeViewModel(dsr);
  TransactionParadigm[] trarr =  model.getTransactionParadigmList(userContext);
  String[] pid = new String[trarr.length];
  for (int i=0; i<trarr.length; i++){
  	pid[i] = trarr[i].getId();
  }

	SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = mgmt.getAdminInstance();
	LogBrowsingManager lbm = null;
	try {
		//lbm = mgmt.getLogBrowserManager(transactionLogId);
	} catch (Exception e){
	}
	if (lbm == null){
		if (transParadigmId != null){
	    TransactionLogBuilder builder = new TransactionLogBuilder();//(TransactionLogBuilder)LogBrowserBuilderFactory.getLogBroserBuilderByType(LogBrowserBuilderFactory.TRANSACTION_LOG_TYPE);
	    builder.setDataSessionRuntime(dsr);
	    if (transParadigmId != null && !transParadigmId.equals("")){
	      builder.setTransactionParadigmId(transParadigmId);
	    }
	    builder.updateBuilder();
	    lbm = builder.getLogBrowserManager();
	    lbm.setTemporary(true);
	    //Module module = mgmt.getModuleFromId("xpologicRootModule");
	    //admin.addLogBrowser(lbm,module);
		} else {
			TransactionMergedLogBrowserBuilder builder = TransactionMergedLogBrowserBuilderHelper.createTransactionMergedLogBrowserBuilder(pid,dsr);
			if (builder == null){
			  ErrorModel errmodel = new ErrorModel();
			  errmodel.addError("No Transactions to display.");
			  request.getSession().setAttribute("ERROR_OBJ",errmodel);
    		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=logic/logicPortal.jsp&okURL=logic/logicPortal.jsp");
    		return;
			}
	    lbm = builder.getMergeLogBrowser();
	    lbm.setTemporary(true);
		}
	}
	//	  audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	     			userContext, AuditConstants.VIEW, "transactions log view", AuditConstants.TRANSACTION, "transactions log view");

	
	lbm.setOlapView(true);
	request.getSession().setAttribute(CURRENT_LOG,lbm);	
	response.sendRedirect("../../loggers/logview.jsp?olap=true"+zoomOutUrl);
%>