<%@ page language="java"%>

<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@page import="xpolog.eye.data.RecordMask"%>
<%@page import="xpolog.eye.LogBrowsingManager"%>
<%@page import="xpolog.eye.data.masks.MaskColumn"%>
<%@page import="java.util.HashSet"%>
<%@page import="xpolog.eye.data.util.functions.DataExpressionManager"%>
<%@page import="xpolog.eye.data.util.functions.DataExpressionTemplate"%>
<%@page import="xpolog.eye.data.aggregate.admin.DataExpressionAggConf"%>
<%@page import="xpolog.eye.data.util.functions.DataExpressionConstants"%>
<%@page import="xpolog.eye.data.util.functions.DataExpressionHelper"%>
<%@page import="xpolog.logic.reports.agg.admin.TranReportBuilder"%>
<%@page import="xpolog.logic.reports.agg.admin.TranAggFunctionBuilder"%>

<%!static final String BASE_DIRECTORY = "../../";

	%>

<%

  TranReportBuilder builder = (TranReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");
  if (builder == null) {
	  return;
  }
  
  
  
  AggCaseBuilder caseBuilder = (AggCaseBuilder)builder.getCurrentCaseBuilder();
  
  String tranId = builder == null ? "" : builder.getDefaultTransactionParaigmId();
  if (tranId == null || tranId.length() == 0){
    out.write("<span class=\"REGULARTEST\" >No transaction was selected</span>");
    return;
  }
  String projectId = builder.getDefaultProjectId();
  String [] filtersIds = null;
  boolean isEdit = false;
  TranAggFunctionBuilder functionBuilder = null;
  if (caseBuilder == null && builder.getFunctionCount() > 0){  	
  	caseBuilder = builder.getFunctionBuilderAt(0);
  }
  if (caseBuilder != null && caseBuilder instanceof TranAggFunctionBuilder){
  	isEdit = true;
  	functionBuilder = (TranAggFunctionBuilder)caseBuilder;
  	tranId = functionBuilder.getTransactionParaigmId();
  	if (tranId == null){
  		tranId = "";
  	}  	  	
  	projectId = functionBuilder.getProjectId();
  	if (projectId == null){
  		projectId = "";
  	}
  }else {
  	functionBuilder = new TranAggFunctionBuilder();  	
  }
  
  builder.setTempTranFunctionCaseBuilder(functionBuilder);
    
  functionBuilder.setTransactionParaigmId(tranId);
  functionBuilder.setProjectId(projectId);
  
	String [] templates = functionBuilder.getTemplatesIds();
	if (templates == null){
		templates = new String[0];
	}
	
	HashSet tempatesSet = new HashSet();
	for(int i = 0; i < templates.length;i++){
		tempatesSet.add(templates[i]);
	}
	
	DataExpressionManager deMgr = DataExpressionManager.getInstance();
	DataExpressionTemplate [] deTemplates = deMgr.getTemplatesForGroup(DataExpressionConstants.TRAN_GROUP);
	
	DataExpressionAggConf [] expressions = functionBuilder.getExpressionsAggConf();
  
  String suffix = AggReportBuilder.TRAN_FUNCTION_TYPE;
  String headerName = "Custom report type";
%>


		
<table border="0" id="adminHeaderContent<%=suffix%>" cellpadding="0" cellspacing="0"  width="100%" height="100%" class="ADV_SETTINGS_TABLE">
					<tr>
						<td style="padding-left:20">
						
						
						
						
						
						

<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="100%" >
  <tr id="predfinedTR" height="10"><td valign="top">
  <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="50">
	<tr height="10">
		<td><span class="SMALLTEXT">Select the columns to be used in computation.</span></td>
	</tr>
	<tr height="10">
		<td style="padding-top:5">
		<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
			<tr>
				
				<td width="100" style="padding-left:10">
		<div id="lfDiv" >
		<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%">
		<tr><td style="padding-left:5;padding-bottom:2;padding-top:2"> <span class="SMALLTEXT">Functions</span></td></tr>
		<tr><td>
	<select class="TEXTBOX" MULTIPLE size="6" name="Functions" id="tranFunctions" style="font-size: 8pt; font-family: Verdana">
							<%
							
							for (int i = 0; i < deTemplates.length; ++i) {
																																
				%>
							<option value='<%=deTemplates[i].getId()%>'><%=deTemplates[i].getShortName()%></option>
							<%}

			%>
						</select>
						</td></tr>
			</table>
			</div>
			</td>
			<td width="50">
		<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%">
		<tr><td style="padding-left:20;padding-bottom:2;padding-top:2"> <a class="BUTTON_MEDIUMLINK" href="javascript:addPredefined();makeChecked('tranFunctionAgg')">Add</a></td></tr>
		</table>
		</td>
			<td width="*">&nbsp;</td></tr>			
		</table>
		</td>
			</tr>
			<tr><td style="font-size:2pt">&nbsp;</td></tr>
	</table>
	</td>
	</tr>	
	<tr style="padding-top:5" height="10">
		<td><span class="REGULARTEXT"><a href="javascript:addFunction()" class="BUTTON_MEDIUMLINK">Add new function</a></span></td>
	</tr>

	<tr height="10">
		<td id="functionTableTDLoading">
		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
			<tr class="TABLES_HEADERS">
				<td width="50"><span class="REGULARTEXT">Key</span></td>
				<td width="200"><span class="REGULARTEXT">Name</span></td>
				<td width="*"><span class="REGULARTEXT">Function</span></td>
				<td width="150" class="REGULARTEXT">&nbsp;</td>
			</tr>		
			<tr>
			<td colspan="4"><span class="REGULARTEXT">Loading...</span></td>
			</tr>
					</table>
		</td>
		<td id="functionTableTD" style="display:none">		
		</td>
	</tr>

	<tr>
		<td>&nbsp;</td>
	</tr>
</table>
</td>
</tr>
</table>								
						
						
						
						
						
						
						
						
						
						
						
						
			