<%@ page language="java"%>

<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@page import="xpolog.eye.reports.Report"%>
<%@page import="xpolog.logic.reports.agg.admin.TranReportBuilder"%>

<%!
static final String BASE_DIRECTORY = "../../../";
static final int MAX_FILTER_SIZE = 40;
%>

<%

  String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null || baseDirectory.length() == 0){
		baseDirectory = BASE_DIRECTORY;
	}
  TranReportBuilder builder = (TranReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");
	if (builder == null) {
		return;
	}
	
	
	
	for (int i = 0; i < builder.getReportTypesCount();i++){
	  builder.getReportTypeBuilderAt(i).init();
	}
	
	String type = request.getParameter("type");
	if (type == null){
		type = "";
	}
	
	String tranId = builder == null ? "" : builder.getDefaultTransactionParaigmId();
	String noTranDivDisplay = "";
	String hasTranDivDisplay = "";
	if(tranId == null || tranId.length() == 0) {
		hasTranDivDisplay = "display:none";
	}else {
		noTranDivDisplay = "display:none";
	}
	
	String advancedSuffix = "ReportTypeAdvanced";
	
%>

<link rel="stylesheet" type="text/css" href="<%=baseDirectory%>css/logAdministration.css" />
<script language="JavaScript" src="<%=baseDirectory%>scripts/filters/fromto.js"></script>
<script language="JavaScript" src="<%=baseDirectory%>scripts/common/admin.js"></script>
<script>
 
  function addAllGridFiledToSelection(gridFrom,to){
     removeAllFiledFromSelection(to);     
     var selectedids = getAllRowsIds(gridFrom);     
  	 for (var i = 0; i < selectedids.length; i++){
        var frRow = gridFrom.getRowById(selectedids[i]);
  			if (!frRow) continue;
  			
  			var id = selectedids[i];
  			if (frRow.cells.length> 0){
  				var value = gridFrom.cells(id, 0).getValue();
  				var option0 = new Option(value,id);
      		to.options[to.options.length] = option0;      		
  			}
     }
  }
    
  function prepareFieldsForAdd(from,to){
    if (!from || !to) return;        
    addAllGridFiledToSelection(from,to);
    for(var t=0;t<to.options.length;++t){
       to.options[t].selected='true';
    }        
  }
  
  function prepareFiltersForAdd(suffix){ 		
    prepareFieldsForAdd(eval("mygridListTo" + suffix),document.getElementById("To_Select_filters" + suffix));
  }
  
  function prepareColumnsForAdd(suffix){
 // alert(eval("mygridListTo" + suffix) + " , " + document.getElementById("To_Select_column" + suffix));
    prepareFieldsForAdd(eval("mygridListTo" + suffix),document.getElementById("To_Select_column" + suffix));
  }
  
  function doReportTypesAdd(){    
    prepareFiltersForAdd("<%=AggReportBuilder.TRAN_CASE_TYPE%>");
    prepareFiltersForAdd("<%=advancedSuffix%>");
       
  }

</script>

<script>
function updateSourceForTransactionChange(id,name){     
    if (id.indexOf("TransactionParadigm-") == 0){
      id = id.substring(20,id.length);
    }
    var selectedTran = id;
    
    sendAjaxRequest("<%=baseDirectory%>logic/reports/agg/updateTransaction.jsp?tranId=" + selectedTran,function(req){
         
    		 
    		 
    		 
    		updateTableListFromtranAgg();
    		updateTableListTotranAgg();
    		
    		
    		updateTableListFromReportTypeAdvanced();
    		updateTableListToReportTypeAdvanced();
    		

    		
    		sendAjaxRequest("<%=baseDirectory%>logic/reports/agg/aggTranEditFunctionCase.jsp",function(req){
    		   	var result = req.responseText;	
				    result = result.replace(/^\s+|\s+$/g, '') ;
				    document.getElementById("reportTypeDiv<%=AggReportBuilder.TRAN_FUNCTION_TYPE%>").innerHTML = result;
				    initFunctionTable();  
    		 });
    		
				var result = req.responseText;					
				       
         var noTranDiv = document.getElementById("noTranDiv");
		     var hasTranDiv = document.getElementById("hasTranDiv");
		     if(selectedTran == '') {
			     noTranDiv.style.display = "";
		      	hasTranDiv.style.display = "none";
				}else {
					noTranDiv.style.display = "none";
					hasTranDiv.style.display = "";
				}
  });	
}


	
	function addColumnsToSelection(source,target,specificId){
	  addFiledToSelection(source,target);
	  if (specificId && specificId != ""){
	    document.getElementById(specificId).checked = true;
	  }
	}
	
	function addAllColumnsToSelection(source,target,specificId){
	  addAllFiledToSelection(source,target);
	  if (specificId && specificId != ""){
	    document.getElementById(specificId).checked = true;
	  }
	  
	}
	
	
	
	
	function initReportTypes(){
	  initFunctionTable();
	}
	
	function makeChecked(suffix){
	  var chk = document.getElementById("reportTypeChk" + suffix);
	  if (chk){ 
	    chk.checked = true;
	  }
	}
	
	var reportTypesArr = new Array();
	
	function changeType(type){	
	  for (var i = 0; i < reportTypesArr.length;i++){
	    if (reportTypesArr[i] == type){
	    	document.getElementById("reportTypeTitle" + reportTypesArr[i]).style.fontWeight="bold";
	    	document.getElementById("reportTypesTitle").innerHTML = document.getElementById("reportTypeTitle" + reportTypesArr[i]).innerHTML;
	    	document.getElementById("reportTypeDiv" + reportTypesArr[i]).style.display = "";	   
	    }else {
	      document.getElementById("reportTypeTitle" + reportTypesArr[i]).style.fontWeight="";
	      document.getElementById("reportTypeDiv" + reportTypesArr[i]).style.display = "none";
	    }
	  }
	}
	
	function changeChk(chk,type){
		if (chk.checked){
		  changeType(type);
		}
	}
</script>



<script language="JavaScript" src="<%=baseDirectory%>logic/reports/agg/aggTranEditFunctions.js"></script>

<div id="noTranDiv" style="<%=noTranDivDisplay %>">
	    	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="padding:5px;">
					
					<tr>
						<td style="padding:10;padding-top:20"  valign="top">
							<span class="REGULARTEXT" style="color:#9E5B04">* No Transaction is selected. </span><a class="LINK" href="javascript:showTransactionTree()">Select a transaction</a>
						</td>
					</tr>
				</table>
	    </div>
	     <div id="hasTranDiv" style="<%=hasTranDivDisplay %>">

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="padding:5px;">
<tr height="20">
<td width="180px" align="center">	 <div id="ReportTypesErrorMsg"  class="ERROR_MSG">
								 </div></td>
<td style="padding-left:20px;padding-bottom:5px" valign="bottom"><span class="SECTION_HEADER" id="reportTypesTitle">Filters Summary</span></td>
</tr>
<tr>
<td width="180px">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
<tr height="10"><td width="20"  style="padding-left:10;padding-top:5" valign="top"><input type="checkbox" id="reportTypeChk<%=AggReportBuilder.TRAN_CASE_TYPE%>" name="reportTypeChk<%=AggReportBuilder.TRAN_CASE_TYPE%>" value="true" onClick="javascript:changeChk(this,'<%=AggReportBuilder.TRAN_CASE_TYPE%>')" <%=builder.getCasesCount() > 0 ? "checked" : "" %>></td><td style="padding-left:5;padding-top:5;cursor:pointer" onClick="javascript:changeType('<%=AggReportBuilder.TRAN_CASE_TYPE%>')"><span class="MEDIUMTEXT" style="font-weight:bold" id="reportTypeTitle<%=AggReportBuilder.TRAN_CASE_TYPE%>">Filters Summary</span></td></tr>
<tr height="10"><td width="20"  style="padding-left:10;padding-top:10" valign="top"><input type="checkbox" id="reportTypeChk<%=AggReportBuilder.TRAN_FUNCTION_TYPE%>" name="reportTypeChk<%=AggReportBuilder.TRAN_FUNCTION_TYPE%>" value="true" onClick="javascript:changeChk(this,'<%=AggReportBuilder.TRAN_FUNCTION_TYPE%>')" <%=builder.getFunctionCount() > 0 ? "checked" : "" %>></td><td style="padding-left:5;padding-top:10;cursor:pointer" onClick="javascript:changeType('<%=AggReportBuilder.TRAN_FUNCTION_TYPE%>')"><span class="MEDIUMTEXT"id="reportTypeTitle<%=AggReportBuilder.TRAN_FUNCTION_TYPE%>">Custom</span></td></tr>
<tr height="10"><td width="20"  style="padding-left:10;padding-top:20" valign="top">&nbsp;</td><td style="padding-left:5;padding-top:20;cursor:pointer" onClick="javascript:changeType('<%=advancedSuffix%>')"><span class="MEDIUMTEXT"id="reportTypeTitle<%=advancedSuffix%>">Advanced</span></td></tr>
<tr height="*"><td>&nbsp;</td></tr>
</table>
</td>
<td valign="top">
<table border="0" width="100%" cellspacing="0" height="200" cellpadding="0" >
<tr>
<td valign="top" >
<%
if (type.length() == 0 || type.equals(Report.TRANSACTION_TYPE)){

	%>
<div id="reportTypeDiv<%=AggReportBuilder.TRAN_CASE_TYPE%>" style="height:100%">	
	<jsp:include page="aggTranEditFilterCase.jsp" flush="true"/>
</div>
	<script>reportTypesArr[reportTypesArr.length] = "<%=AggReportBuilder.TRAN_CASE_TYPE%>";</script>
	<!--  Group by count section -->

	<% 
   }
	if (type.length() == 0 || type.equals(Report.TRANSACTION_TYPE)){
	
	%>
	<div id="reportTypeDiv<%=AggReportBuilder.TRAN_FUNCTION_TYPE%>" style="display:none;height:100%">
	<jsp:include page="aggTranEditFunctionCase.jsp" flush="true"/>	
	</div>
	<script>reportTypesArr[reportTypesArr.length] = "<%=AggReportBuilder.TRAN_FUNCTION_TYPE%>";</script>
	<% }
	if (type.length() == 0 || type.equals(Report.TRANSACTION_TYPE)){
	%>	
	
	<div id="reportTypeDiv<%=advancedSuffix%>" style="display:none">
	<jsp:include page="../../../reports/agg/aggEditAdvancedCase.jsp" flush="true"/>
	</div>
	<script>reportTypesArr[reportTypesArr.length] = "<%=advancedSuffix%>";</script>
	<%}%>
	
</td>
</tr>
</table>
</td>
<tr>
</tr>
</table>
</div>
