<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="xpolog.logic.reports.agg.admin.*"%>
<%@ page import="xpolog.logic.transaction.data.*"%>
<%@ page import="xpolog.logic.ui.*"%>
<%@ page import="xpolog.logic.ui.aggregators.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>


<%
  String ERROR_OBJ = "ERROR_OBJ";

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
   ErrorModel ermod = new ErrorModel();
   
   AggReportBuilder builder = (AggReportBuilder)  request.getSession().getAttribute("REPORT_BUILDER");
  
  
  if(builder == null){
    ermod.addError("Session is not valid any more. Please try again");
  }
  
  String statusRuleStr = request.getParameter("statusRule");
  AggCaseStatusRule statusRule = null;
  if (statusRuleStr != null && statusRuleStr.equalsIgnoreCase("ON")){
  	statusRule = new AggCaseStatusRule();
  	int ruleType = 0;
  	String ruleTypeStr = request.getParameter("ruleType");
  	if (ruleTypeStr != null && ruleTypeStr.length()>0){
  		try {
  			ruleType = Integer.parseInt(ruleTypeStr);
  		}catch (Exception e){
  			ermod.addError("Invalid rule type. Please try again");
  		}
  	}
  	statusRule.setRuleType(ruleType);
  	long amount = 0;
  	String amountStr = request.getParameter("amount");
  	if (amountStr != null && amountStr.length()>0){
  		try {
  			amount = Long.parseLong(amountStr);
  		}catch (Exception e){
  			ermod.addError("Amount is not valid number. Please try again");
  		}
  	}
  	statusRule.setAmount(amount);
  }
  
  ArrayList statusesList = new ArrayList();
  boolean allStatus = false;
  String [] statuses = request.getParameterValues("status_2");
  
  if (statuses != null && statuses.length > 0){
  	allStatus = statuses.length == 2;
  	StringBuffer buffer = new StringBuffer("2");
  	for(int i = 0; i < statuses.length; i++ ){
  		buffer.append("_");
  		buffer.append(statuses[i]);
  	}
  	statusesList.add(buffer.toString());
  }
  
  statuses = request.getParameterValues("status_4");
  if (statuses != null && statuses.length > 0){
  	allStatus = allStatus && statuses.length == 2;
  	StringBuffer buffer = new StringBuffer("4");
  	StringBuffer buffer1 = new StringBuffer("1");
  	for(int i = 0; i < statuses.length; i++ ){
  		buffer.append("_");
  		buffer1.append("_");
  		String [] statusesKeys = statuses[i].split(";");
  		if (statusesKeys.length > 0 && statusesKeys[0].trim().length() > 0){
    		buffer.append(statusesKeys[0]);
  		}
  		if (statusesKeys.length > 1 && statusesKeys[1].trim().length() > 0){
    		buffer1.append(statusesKeys[1]);
  		}
  	}
  	buffer.append(";");
  	buffer.append(buffer1.toString());
  	statusesList.add(buffer.toString());  	  	
  }
  
  statuses = request.getParameterValues("status_5");
  if (statuses != null && statuses.length > 0){
  	allStatus = allStatus && statuses.length == 2;
  	StringBuffer buffer = new StringBuffer("5");
  	for(int i = 0; i < statuses.length; i++ ){
  		buffer.append("_");
  		buffer.append(statuses[i]);
  	}
  	statusesList.add(buffer.toString());
  }
  
  
  
  if(ermod.getErrorCount() != 0){    
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
    return;
  }
  	
  TranAggCaseBuilder caseBuilder = (TranAggCaseBuilder)builder.getCurrentCaseBuilder();
  TransactionAggregationConf conf = new TransactionAggregationConf();
  conf.setProjectId(caseBuilder.getProjectId());
  conf.setTransactionParaigmId(caseBuilder.getTransactionParaigmId());
  conf.setTotal(true);
  conf.setDayDis(false);
  conf.setHourDis(false);
  conf.setMinDis(false);
  
  String[] datafilterIds = request.getParameterValues("To_Select_datafilter");
  
  //verify data


  
  if(datafilterIds !=  null && datafilterIds.length > 0){
  	conf.setDataFilters(datafilterIds);
  }
  conf.setFilters(new String[]{""});
  conf.setFilters(true);
  caseBuilder.setAggConf(conf);
  
  caseBuilder.setStatusRule(statusRule);
  caseBuilder.setDataFilters(datafilterIds);
  
  xpolog.logic.filters.StatusTransactionFilter filter = null;
  if (!allStatus){
  	filter = new xpolog.logic.filters.StatusTransactionFilter();
  	filter.setStatuses((String [])statusesList.toArray(new String[statusesList.size()]));
  }
  caseBuilder.setStatusFilter(filter);
  conf.setStatusFilter(filter);
  
  String desc = caseBuilder.getCaseDef().getDesc();
  if (desc != null && (desc.indexOf("TRANSACTION_NAME") >= 0 || desc.indexOf("FILTERS_NAME") >= 0)){
  	try {
  		TransactionParadigm tran =  xpolog.logic.brain.BrainConfigurationRepository.getRepository().getTransactionParadigmById(caseBuilder.getTransactionParaigmId());
  		
  		if (tran != null){
  			desc = XpologUtil.replaceAll(desc,"TRANSACTION_NAME",tran.getName());
  			xpolog.logic.filters.SessionFilterManager sdfmgr = new xpolog.logic.filters.SessionFilterManager(tran.getId());
  			if (sdfmgr != null && desc.indexOf("FILTERS_NAME") >= 0){
  				if(datafilterIds !=  null && datafilterIds.length > 0){  				
    				StringBuffer buffer = new StringBuffer();
    				for(int i = 0; i < datafilterIds.length;i++){
  	  				if (i > 0){
  		  				buffer.append(",");
  			  		}
  					
  				  	FilterCollection fc = sdfmgr.getFilterCollectionById(datafilterIds[i]);
  					  if (fc != null){
  						  buffer.append(fc.getName());
  					  }else {
  						  buffer.append(datafilterIds[i]);
  					  }
  				  }
  				  desc = XpologUtil.replaceAll(desc,"FILTERS_NAME",buffer.toString());
  				}else {
  					desc = XpologUtil.replaceAll(desc,"FILTERS_NAME","NONE");
  				}
  			}
  			caseBuilder.getCaseDef().setDesc(desc);
  		}
  	}catch (Exception e){}
  }
  
  builder.addCaseBuilder(caseBuilder);
  response.sendRedirect(BASE_DIRECTORY + "reports/agg/aggCasesView.jsp");
%>


