<%@page import="xpolog.logic.reports.agg.admin.TranAggCaseBuilder"%>
<%@page import="xpolog.eye.reports.agg.admin.AggReportBuilder"%>
<%@page import="xpolog.logic.ui.ctrl.DataSession"%>
<%@page import="xpolog.logic.ui.ctrl.CtrlMgr"%>
<%@page import="xpolog.logic.ui.util.WorkspaceRenderer"%>
<%@page import="xpolog.logic.ConfigMgr"%>
<%@page import="xpolog.logic.ui.ctrl.Workspace"%>
<%@page import="xpolog.logic.ui.ctrl.RootWorkspace"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.util.*"%>


<%

	String	TYPE_WORKSPACE = "Workspace";
	String TYPE_PROJECT = "DataSession";


	SiteManagment mgmt = SiteManagment.getInstance();
	UserContext userContext = UserEnvironment.getUserContext(request);
	CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
	
  RootWorkspace rootWorkspace = new RootWorkspace();
  rootWorkspace.setName("Workspaces");
  rootWorkspace.setId("Workspaces");
  Workspace[] workspaces = ctrlMgr.getWorkspaces(userContext);
  for (int i=0; i<workspaces.length; i++){
  	rootWorkspace.addDataSessionId(workspaces[i].getId());
  }

  HashMap selectedWsMap = new HashMap();
  HashMap selectedProjMap = new HashMap();
  HashMap selectedTransMap = new HashMap();
 
  String projectId = null;
  String wsId = null;
  String tranId = null;
  AggReportBuilder builder = (AggReportBuilder)  request.getSession().getAttribute("REPORT_BUILDER");
  if(builder != null){
  	TranAggCaseBuilder caseBuilder = (TranAggCaseBuilder)builder.getCurrentCaseBuilder();
  	tranId = caseBuilder.getTransactionParaigmId();
		if(tranId != null && tranId.length() > 0){
			selectedTransMap.put(tranId,tranId);
		}
		projectId = caseBuilder.getProjectId();
		if(projectId != null && projectId.length() > 0){
			selectedProjMap.put(projectId,projectId);
			DataSession ds = ctrlMgr.getDataSessionById(projectId);		
			if(ds != null){
				wsId =  ds.getParentWorkspaceId();
				if(wsId != null && wsId.length() > 0){
					selectedWsMap.put(wsId,wsId);
				}
			}  				
		} 		
  }
  String rootId = request.getParameter("rootId");
  if (rootId == null){
  	rootId = "0";  	
  }
	
	WorkspaceRenderer renderer = new WorkspaceRenderer(userContext, selectedWsMap,selectedProjMap,selectedTransMap, rootId);
  
	renderer.setTranSelectOnly(true);
	String type = "";
	String treeXml = ""; 
  String id = request.getParameter("id");
  if (id != null){
  	String objid = id;
  	int ind = id.indexOf("-");
  	if (ind != -1){
  		objid = id.substring(ind+1);
  		type = id.substring(0,ind);
			if(type.equals(TYPE_WORKSPACE)){
				Workspace currWorkspace = ctrlMgr.getWorkspaceById(objid);
				if(currWorkspace != null){
				renderer.setWorkspace(currWorkspace);
				treeXml = renderer.getWorkspaceTreeXML();
				}else{
					treeXml = "";
				}
			}
			if(type.equals(TYPE_PROJECT)){
				DataSession currProject = ctrlMgr.getDataSessionById(objid);
				renderer.setProject(currProject);
				treeXml = renderer.getProjectTreeXML();
			}			
  	}

  }else{ //roootWS
  	renderer.setRootWorkspace(rootWorkspace);
  	treeXml = renderer.getRootTreeXML();
  }
	response.setContentType("text/xml");
		out.write(treeXml);
		out.flush();

%>
