<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.awt.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.ext.tehila.reports.*"%>

<%!static final String BASE_DIRECTORY = "../../";

	DecimalFormat decFormat = new DecimalFormat("##.##");

	%>
<%String ERROR_OBJ = "ERROR_OBJ";
			ErrorModel errmodel = new ErrorModel();

			String reportId = request.getParameter("reportId");
			String reportRuntimeId = request.getParameter("reportRuntimeId");
			String print = request.getParameter("print");
			boolean isPrint = print != null && print.equalsIgnoreCase("true");
			ReportsManager reportMgr = ReportsManager.getInstance();
			Report report = reportMgr.getReportById(reportId, true);

			if (reportId == null || reportId.trim().equals("")) {
				errmodel.addError("No Report id was supplied.");
			}
			if (reportRuntimeId == null || reportRuntimeId.trim().equals("")) {
				errmodel.addError("No Report runtime id was supplied.");
			}

			if (errmodel.getErrorCount() != 0) {
				request.getSession().setAttribute(ERROR_OBJ, errmodel);
				response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=applications/delek/reports/reportsDefinitionView.jsp");
				return;
			}


			TehilaSecurityReportRuntime runtime = (TehilaSecurityReportRuntime)report.getReportRuntimeById(reportRuntimeId);
			SubReportRuntime[] subReports = runtime.getSubReports();
			TehilaSecurityCasesSubReportRuntime casesRuntime = (TehilaSecurityCasesSubReportRuntime) runtime.getCaseSubReportRuntime();
			TehilaSecuirtyIPSubReportRuntime ipsRuntime = (TehilaSecuirtyIPSubReportRuntime)runtime.getIpSubReportRuntime();
			Color [] colors = {Color.decode("#00CC99"),Color.decode("#3333CC"),Color.decode("#CCCCFE"),
					Color.decode("#B2B2B2"),Color.decode("#808080"),Color.decode("#000000"),Color.decode("#0066CD"),
					Color.decode("#CCCCFE"),Color.decode("#FE0000"),Color.decode("#FEFE00")};
			String ipsSrcPath = BASE_DIRECTORY + TehilaReportHelper.genSrcIPsBar(ipsRuntime,Color.decode("#C0C0C0"),colors,250,250);
			String ipsDstPath = BASE_DIRECTORY + TehilaReportHelper.genDstIPsBar(ipsRuntime,Color.decode("#C0C0C0"),colors,250,250);
			
			Color [] pieColors = {Color.decode("#00CC99"),Color.decode("#3333CC"),Color.decode("#FE0000"),Color.decode("#FEFE00")};
			String piePath = BASE_DIRECTORY + TehilaReportHelper.genPie(casesRuntime,Color.decode("#C0C0C0"),pieColors,250,250);
			
			String lineChartPath = BASE_DIRECTORY + TehilaReportHelper.genLineGraph(casesRuntime,Color.decode("#C0C0C0"),pieColors,500,300);
			
			TehilaCase [] cases = casesRuntime.getTehilaSortedCases();
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

</head>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>
<!-- American format mm/dd/yyyy -->
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/calendar/calendar2.js"></script>
<!-- Date only with year scrolling -->


<body>
<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
		<tr>
				<td width="100%" height="100%" valign="top">
				<table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
						<tr>
								<td valign="top" height="90%">
								<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
										<tr>
												<td width="100%">
												<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="100%">
														<tr>
																<td width="3%">&nbsp;</td>
																<td width="80%" height="100%" align="left" valign="bottom" colspan="2">
																<table border="0" width="100%" cellspacing="1" cellpadding="0">
																		<tr >
																				<td valign="bottom" width="200" rowspan="2"><img border="0" src="<%=BASE_DIRECTORY%>images/ui/xpologCenter-small.jpg" width="135" height="57"></td>
																				<td width="*" nowrap align="left" valign="bottom" style="border-color:black;border-style: solid;border-bottom-width: 1px;border-top-width:0px;border-left-width:0px;border-right-width:0px;"><span class="PAGEHEADER">Transactions Summary</span></td>
																		</tr>
																		<tr>
																				
																				<td width="*" nowrap valign="bottom"  align="left" style="padding-left:10">
																				<span class="REGULARTEXT"><nobr>Status at <%=new SimpleDateFormat("dd/MM/yyyy HH:mm").format(new Date(runtime.getRunningTime()))%></nobr></span>
																				</td>
																		</tr>
																		<tr>
																				<td valign="bottom">
																				<table border="0" width="80" cellspacing="1" height="10">
																						<tr>
																						<%if(!isPrint){ %>
																								<td width="50%"> <a href="casesReport.jsp?print=true&reportId=<%=reportId%>&reportRuntimeId=<%=reportRuntimeId%>" target="_blank" class="LINK"><img border="0" src="<%=BASE_DIRECTORY%>images/ui/print.png" width="16" height="19" ></a></td>
																								<td width="50%"  valign="top"><span class="REGULARTEXT">&nbsp;&nbsp;Print&nbsp;&nbsp;&nbsp;</span></td>
																							<%}else {%>
																							<td>&nbsp;</td>
																							<%}%>
																						</tr>
																				</table>
																				</td>
																				<td width="*" nowrap  align="right">
																				<table border="0" width="100%" height="10">
																						<tr>
																								<td width="*">&nbsp;</td>
																								<td align="right">
																								<table border="0" width="100" cellspacing="1">
																										<tr>
																												<td width="30%" nowrap><span class="REGULARTEXT"><span class="REGULARTEXT">System Status</span></td>
																												<td width="70%" nowrap><img border="0" src="<%=BASE_DIRECTORY + (runtime.getStatus() == ReportsConstants.FAILURE_STATUS ? "images/verifierview/redBullet.gif" : "images/verifierview/greenBullet.gif")%>" width="16" height="16"></td>
																										</tr>
																								</table>
																								</td>
																						</tr>
																				</table>
																				</td>
																		</tr>
																</table>
																</td>
														</tr>
														<tr>
																<td width="3%">&nbsp;</td>
																<td width="53%" height="100%"></td>
																<td width="30%" height="100%" align="right"></td>
														</tr>
														<tr>
																<td width="3%" height="100%">&nbsp;&nbsp;&nbsp;</td>
																<td width="93%" colspan="2" height="100%">
																<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="53" style="visibility:visible">
																		<tr>
																				<td bgcolor="#C0C0C0" style="border: 1 solid #000000">
																				<table border="0" width="100%" style="border-style: solid; border-width: 1">
																						<tr>
																								<td width="100%" align="left"><span class="HEADER">Top 10 Cases</span></td>
																						</tr>
																						<tr>
																																				<td width="*" valign="top">
																																				<table border="1" width="100%" style="border-style: solid; border-width: 0" cellspacing="0" cellpadding="0" bordercolordark="#000000" bordercolorlight="#000000" height="100%">
																																						<tr height="10">
																																								<td align="center" width="50"><span class="REGULARTEXT">Case</span></td>
																																								<td align="center" width="*"><span class="REGULARTEXT"><nobr>Transaction Name</nobr></span></td>
																																								<td align="center" width="*"><span class="REGULARTEXT"><nobr>Analysis Type</nobr></span></td>
																																								<td align="center" width="200"><span class="REGULARTEXT">Total</span></td>
																																								
																																						</tr>
																																						<%
			for (int i = 0; i < cases.length; i++) {
							String logName = cases[i].getLogName() == null ? "&nbsp;" : cases[i].getLogName();
							String filterName = cases[i].getFilterName() == null ? "&nbsp;" : cases[i].getFilterName();
							CaseResult result = casesRuntime.getCaseResult(cases[i]);
							String total = result == null ? "0" : String.valueOf(result.getTotal());
							String sev = cases[i].getSev() == null ? "&nbsp;" : cases[i].getSev();
							if (sev != null){
							  if (sev.equals("1")){
							    sev = "LOW";
							  } else if (sev.equals("2")){
							    sev = "NORMAL";
							  } else if (sev.equals("3")){
							    sev = "HIGH";
							  } else if (sev.equals("4")){
							    sev = "CRITICAL";
							  }
							}

				%>
																																						<tr height="10">
																																								<td><span class="REGULARTEXT" width="50"><%=String.valueOf(i+1)%></span></td>
																																								<td><span class="REGULARTEXT" width="*"><nobr><%=logName%></nobr></span></td>
																																								<td><span class="REGULARTEXT" width="*"><nobr><%=filterName%></nobr></span></td>
																																								<td><span class="REGULARTEXT" width="200"><%=total%></span></td>																																								
																																						</tr>
																																						<%}%>
																																					
																																				</table>
																																				</td>
																																		</tr>
																						<tr>
																								<td width="100%">
																								<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
																										<tr>																										
																												<td width="*" align="center"><img src="<%=piePath%>" ></td> 
																												<td width="*" align="center"><img src="<%=lineChartPath%>" ></td> 											
																										</tr>
																										
																								</table>
																								</td>
																						</tr>
																						<tr>
																								<td width="15%" height="18"></td>
																						</tr>

																				</table>
																				</td>
																		</tr>																		
																</table>
																</td>
														</tr>
													<tr>
																				<td width="100%" height="18" colspan="2">&nbsp;</td>
																		</tr>
															
												</table>
												</td>
										</tr>										
										
								</table>
								</td>
						</tr>
						<tr><td height="*">&nbsp;</td></tr>
										<tr>
												<td valign="bottom" height="10%">
												<table border="0" width="100%">
														<tr>
																<td width="33%"></td>
																<td width="33%" align="center">
																<%if(!isPrint){%>
																<a href="javascript:history.go(-1)" class="LINK">back</a>
																<%}%>
																</td>
																<td width="34%"></td>
														</tr>
												</table>
												</td>
										</tr>
				</table>
				</td>
		</tr>
</table>
</form>
</body>

</html>
