<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.awt.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.logic.ui.reports.summary.result.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.audit.*"%>

<%!static final String BASE_DIRECTORY = "../../../";

	DecimalFormat decFormat = new DecimalFormat("##.##");
	String dateFormatStr = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
	SimpleDateFormat dateFormat = new SimpleDateFormat(dateFormatStr);
	
	public String transformDateToString(Date d){
    return xpolog.eye.site.SiteUtil.formatDefaultDate(d,true);
  }
	%>
<%
String ERROR_OBJ = "ERROR_OBJ";
			ErrorModel errmodel = new ErrorModel();
			UserContext userContext = UserEnvironment.getUserContext(request);
			String reportId = request.getParameter("reportId");
			String reportRuntimeId = request.getParameter("reportRuntimeId");
			String print = request.getParameter("print");
			boolean isPrint = print != null && print.equalsIgnoreCase("true");
			ReportsManager reportMgr = ReportsManager.getInstance();
			Report report = reportMgr.getReportById(reportId, true);

			if (reportId == null || reportId.trim().equals("")) {
				errmodel.addError("No Report id was supplied.");
			}
			if (reportRuntimeId == null || reportRuntimeId.trim().equals("")) {
				errmodel.addError("No Report runtime id was supplied.");
			}
			
			if (errmodel.getErrorCount() != 0) {				
				return;
			}
			
			String reportName = report.getReportName();
			  //audit
			  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
			  			userContext, AuditConstants.VIEW, "view report", AuditConstants.REPORTS, "view report " + reportName);

			TransactionSummaryReportRuntime runtime = (TransactionSummaryReportRuntime)report.getReportRuntimeById(reportRuntimeId);			
			AlertsSummarySubReportRuntime subRuntime = runtime.getAlertsSummarySubReportRuntime();
			
			LogicAlertResults results = subRuntime.getAlertResults();
			LogicAlertResult [] alerts = results == null ? new LogicAlertResult[0] : results.getAlerts();			
			Properties types = new Properties();
			types.setProperty("xpolog.logic.alert.types.TransactionTimeAlert","Transaction Time");
			types.setProperty("xpolog.logic.alert.types.TransactionFlowAlert","Transaction Flow");
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>logic/css/logicUI.css" />


</head>

<body style="margin: 0; padding: 0; border-width: 0" class="MAIN_SCROLL">
<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" >
  <tr valign="top">
    <td width="100%"  style="padding-right:5">
    <table border="0" width="100%" cellspacing="0" cellpadding="0" >
			
										                  
										                  <tr>
										                    <td>
											                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%"> 
											                    	
											                    	
		                      <%
		                      for (int i = alerts.length; --i >= 0;) {
		                      	LogicAlertResult alertResult = alerts[i];
		                      	if (alertResult.getAlert() == null){
		                      		continue;
		                      	}
		                      	xpolog.logic.alert.LogicAlert alert = alertResult.getAlert();
		                      	
														%>
											                      <tr>
											                        <td width="200" class="SMALLTEXT"><nobr><%=transformDateToString(new Date(alert.getTimestamp()))%></nobr></td>
											                        <td width="150" class="SMALLTEXT"><nobr><%=types.getProperty(alert.getType(),alert.getType())%></nobr></td>
											                        <td width="150" class="SMALLTEXT"><%=alertResult.getTransactionName()%></td>
											                        <td width="200" class="SMALLTEXT"><nobr><%=alertResult.getTransactionCreated() == 0 ? "" : transformDateToString(new Date(alertResult.getTransactionCreated()))%></nobr></td>
											                        <td width="150" class="SMALLTEXT"><%=alertResult.getApplicationName()%></td>
											                        <td width="*" class="SMALLTEXT">&nbsp;</td>
											                      </tr>
		                      <%
		                      }		                      
		                      %>
											                		</table>
										                  	</td>
										                	</tr>

    </table>
    </td>
  </tr>
</table>
</form>
</body>
</html>