<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.audit.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.managment.XpologManagment"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.Constants"%>
<%@ page import="xpolog.logic.ui.reports.summary.result.*"%>

<%@ page import="java.awt.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.util.*"%>

<%!static final String BASE_DIRECTORY = "../../../";

	%>
<%String ERROR_OBJ = "ERROR_OBJ";
			ErrorModel errmodel = new ErrorModel();
			UserContext userContext = UserEnvironment.getUserContext(request);
			String reportId = "TransactionSummary";
			String reportRuntimeId = request.getParameter("reportRuntimeId");
			String generatedStr = request.getParameter("generated");
			boolean isGenerated = generatedStr != null && generatedStr.equalsIgnoreCase("true");

			ReportsManager reportMgr = ReportsManager.getInstance();
			Report report = reportMgr.getReportById(reportId, true);
			TransactionSummaryReportRuntime runtime = null;
			String analytics = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_DISPLAY_NAME);

			if (report == null) {
				errmodel.addError("No " + analytics + " report definition was supplied.");
			}else {
				if (reportRuntimeId != null && reportRuntimeId.length() > 0){
					runtime = (TransactionSummaryReportRuntime)report.getReportRuntimeById(reportRuntimeId);
				}else {
  				runtime = (TransactionSummaryReportRuntime)report.getLastReportRuntime();
				}
			}
			if (isGenerated && runtime == null){
				errmodel.addError("No dashboard result was created.");
			}
			if (errmodel.getErrorCount() != 0) {
				request.getSession().setAttribute(ERROR_OBJ, errmodel);
				response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=applications/delek/reports/reportsDefinitionView.jsp");
				return;
			}						
			
			if (runtime != null){
				response.sendRedirect("dashboardReport.jsp?reportId=" + reportId + "&reportRuntimeId=" + runtime.getId());
				return;				
			}else {
				final Report rep = reportMgr.getReportById(reportId, false);
				
				reportId = rep.getId();
			  //put the report on session
			  request.getSession().setAttribute("report",rep);
			  
			  final UserEnvironment env = UserEnvironment.getUserEnvironment(request);
			  
			  final ReportGenerator reportGenerator = rep.getGenerator();
			  final xpolog.eye.common.JobStatus jobStatus = reportGenerator.createJobStatus();
			  env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, jobStatus); 
			  
			  
				 //audit
			  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
			  			userContext, AuditConstants.CHANGE, "execute dashboard report", AuditConstants.REPORTS, "execute dashboard report ");
			  
			  ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "logic/reports/summary/dashboardReportViewAction.jsp?generated=true") {
			      public void run(HttpServletRequest request){
			        try{
			        	Thread.sleep(500);
			         
			         ReportRuntime reportRuntime = reportGenerator.generateReport(null,jobStatus);
			         if (reportRuntime != null){
			           reportRuntime.saveData();								 
			         }else {
			         	ReportsManager reportMgr = ReportsManager.getInstance();
			         	reportMgr.removeReportRuntime(rep.getId(),reportGenerator.getId());
			         }
			        }catch(Throwable e){
			          e.printStackTrace();
			          errmodel.addError("Building log problem,please check patterns and path again.");
			    			errmodel.addError(e.getMessage());
			          createErrorRedirect(request, BASE_DIRECTORY);
			        }
			      }
			   };
			   env.setProgressRunner(runner);
			}
			
			String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);
%>
<jsp:include page="../../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Generating <%=analyticsH %> Data"/>
 <jsp:param name="useStatus" value="true"/>
 <jsp:param name="stopUrl" value="logic/reports/summary/dashboardReportViewActionStop.jsp"/>
</jsp:include>
