<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.logic.*"%>
<%@ page import="xpolog.logic.support.*"%>
<%@ page import="xpolog.logic.ui.ctrl.*"%>
<%@ page import="java.text.*"%>

<%@ page import="java.util.*"%>

<%!static final String BASE_DIRECTORY = "../../";

	static final String MONITORING_WORKSPACE = "Monitoring";%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, null, true)) {
		return;
	}
	boolean isMonitorActive = false;
	OnlineEngineControl xpc = OnlineEngineControl.getInstance();
	isMonitorActive = xpc.isRunning();

	SimpleDateFormat dateFormat = new SimpleDateFormat(Configuration
			.getInstance().getPropertiesManager().getProperty(
			"htmlInputDateFormat", "MM/dd/yyyy HH:mm:ss"));
	CtrlMgr ctrlMgr = null;
	ArrayList projectsSessionsList = new ArrayList();
	try {
	ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
	Workspace[] workspaces = ctrlMgr == null ? null : ctrlMgr.getWorkspaces();
	
	if (ctrlMgr != null && workspaces != null) {
		DataSession[] projectsSessions = null;
		for (int i = 0; i < workspaces.length; i++) {
			if (workspaces[i].getName().equals(MONITORING_WORKSPACE)) {
		continue;
			} else {
		projectsSessions = ctrlMgr.getDataSessionsByWorkspace(workspaces[i]
				.getId());
		for (int j = 0; j < projectsSessions.length; j++) {
			projectsSessionsList.add(projectsSessions[j]);
		}
			}
		}

	}
	}catch (Exception e){
		
	}
%>

<%@page import="xpolog.logic.exe.OnlineEngineControl"%>
<script>
</script>


<table border="0" width="100%" cellspacing="0" height="100%"
	cellpadding="0">
	<tr>
		<td width="100%">
		<table border="0" width="100%" cellspacing="0" height="100%"
			cellpadding="0">
			<tr>
				<td>
				<table border="0" cellpadding="0" cellspacing="0"	width="100%" id="AutoNumber1">
					<tr>
						<td width="100%">
						<table border="0" cellpadding="0" cellspacing="0"
							style="border-collapse: collapse" width="100%" id="AutoNumber2">
							<tr>
								<td width="15%" height="28" colspan="3"><span
									class="HEADER">TxExpo</span></td>
							</tr>
							<tr>
								<td>&nbsp;</td>
							</tr>
														<tr>
<td>
								<table border="0" cellpadding="0" cellspacing="0" width="100%">
									<tr class="TABLES_HEADERS">
										<td width="8%"><span class="REGULARTEXT"><b>Monitoring :</b></span></td>
										<td width="16%"><span class="REGULARTEXT"><%=isMonitorActive ? "Active" : "Not Active"%></span></td>
										<td width="16%">&nbsp;</td>
										<td width="60%">&nbsp;</td>
									</tr>																									
							</table>
							</td>
							</tr>
								<tr>
								<td>&nbsp;</td>
							</tr>
							<tr>
<td>
								<table border="0" cellpadding="0" cellspacing="0" width="100%">
									<tr class="TABLES_HEADERS">
										<td width="16%"><span class="REGULARTEXT"><b>Project Name</b></span></td>
										<td width="16%"><span class="REGULARTEXT"><b>Workspace</b></span></td>
										<td width="16%"><span class="REGULARTEXT"><b>Results Sets</b></span></td>
										<td width="60%"><span class="REGULARTEXT"><b>Run Times</b></span></td>
									</tr>																									
									<%
									Iterator it = projectsSessionsList.iterator();
									while (it.hasNext()) {
										DataSession dataSession = (DataSession) it.next();
										Workspace workspace = ctrlMgr.getWorkspaceById(dataSession.getParentWorkspaceId());
										String workspaceName = (workspace == null) ? "NA" : workspace.getName();
										DataSessionRuntime[] sessions = ctrlMgr.getDataSessionRuntimeForSessionPgm(dataSession.getId());
										DataSessionRuntime lastRuntime = SupportHelper.getLastRuntime(sessions);
										String lastCreated = (lastRuntime.getCreatedTime() == 0) ? ""	: dateFormat.format(new Date(lastRuntime.getCreatedTime()));
										String lastStarted = (lastRuntime.getStartTime() == 0) ? ""	: dateFormat.format(new Date(lastRuntime.getStartTime()));
										String lastEnded = (lastRuntime.getEndTime() == 0) ? "" : dateFormat.format(new Date(lastRuntime.getEndTime()));
										DataSessionRuntime firstRuntime = SupportHelper.getFirstRuntime(sessions);
										String firstCreated = (firstRuntime.getCreatedTime() == 0) ? ""	: dateFormat.format(new Date(firstRuntime.getCreatedTime()));
										String firstStarted = (firstRuntime.getStartTime() == 0) ? ""	: dateFormat.format(new Date(firstRuntime.getStartTime()));
										String firstEnded = (firstRuntime.getEndTime() == 0) ? "" : dateFormat.format(new Date(firstRuntime.getEndTime()));
								%>
									<tr>
											<td>&nbsp;</td>
									</tr>																						
									<tr class="TABLES_HEADERS">
										<td width="16%"><span class="REGULARTEXT"><%=dataSession.getName()%></span></td>
										<td width="16%"><span class="REGULARTEXT"><%=workspaceName%></span></td>
										<td width="16%"><span class="REGULARTEXT"><%=sessions.length%></span></td>
										<td width="60%">
											<table border="0" cellpadding="0" cellspacing="0" width="100%">
												<tr>
												<%
												if (!firstCreated.equals("")) {
												%>
													<td><span class="REGULARTEXT"><b>First Runtime:</b>&nbsp;<%=firstCreated%>&nbsp;<b>Start:&nbsp;</b><%=firstStarted%> &nbsp;&nbsp;<b>End:&nbsp;</b><%=firstEnded%> </span></td>
												</tr>
													<tr>
													<td><span class="REGULARTEXT"><b>Last Runtime:</b>&nbsp;<%=lastCreated%> &nbsp;<b>Start:&nbsp;</b><%=lastStarted%> &nbsp;&nbsp;<b>End:&nbsp;</b><%=lastEnded%> </span></td>
													<%
													}
													%>
												</tr>																	
											</table>
										 </td>	
									</tr>	 
									<%
	 									}//end of iterator loop
	 									%>
								</table>
</td>	
							
														</tr>
							<tr>
								<td>&nbsp;</td>
							</tr>
						</table>
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
</table>


















