<%@ page language="java"%>

<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.image.*"%>
<%@ page import="xpolog.logic.config.image.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);

	String ERROR_OBJ = "ERROR_OBJ";
	String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";
	String Name,Description,override;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	override = request.getParameter("override");
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
   	errmodel.addError("No Name was supplied.");
   	request.getSession().setAttribute(ERROR_OBJ,errmodel);
   	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
   	return;
 	}
  	
	LogicConfigurationImageBuilder builder = (LogicConfigurationImageBuilder)request.getSession().getAttribute(CONF_IMG_BUILDER);

	builder.setName(Name);
	builder.setDescription(Description);
	if (override != null && override.equals("true")){
		builder.setOverrideConfImage(true);
	}else{
		builder.setOverrideConfImage(false);
	}
	
  HashMap transactions = new HashMap();
  HashMap projects = new HashMap();
  HashMap workspaces = new HashMap();
  
	String [] transArr = request.getParameterValues("transactions");
	if (transArr != null){
	  for (int i = 0;i< transArr.length;i++){
	    transactions.put(transArr[i],transArr[i]);
	  }
	}
	String [] projectsArr = request.getParameterValues("projects");
	if (projectsArr != null){
	  for (int i = 0;i< projectsArr.length;i++){
	    projects.put(projectsArr[i],projectsArr[i]);
	  }
	}
	String [] workspacesArr = request.getParameterValues("workspaces");
	if (workspacesArr != null){
	  for (int i = 0;i< workspacesArr.length;i++){
	    workspaces.put(workspacesArr[i],workspacesArr[i]);
	  }
	}
	
	//add the chosen logs and modules to congImg according to api
	boolean logsOk = builder.setTransProjsWorkspacesMap(transactions, projects, workspaces);
	
	//	  audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	     			userContext, AuditConstants.CHANGE, "add/edit configuration image", AuditConstants.CONFIGURATION, "add/edit configuration image " + Name);

	
	response.sendRedirect(BASE_DIRECTORY + "tools/confImage/confImage.jsp?useSessionImage=true&disableSelectedModule=true");
%>

