<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.config.image.*"%>
<%@ page import="xpolog.logic.config.image.*"%>
<%@ page import="xpolog.logic.security.*"%>
<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<% 
WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request,response,LogicPermissionConstants.AdministrationPermissions.CONF_IMAGE_PERMISSION,true)){
     return;
}
  String ERROR_OBJ = "ERROR_OBJ";
  
  String refreshMenuStr = request.getParameter("refreshMenu");
  boolean refreshMenu = (refreshMenuStr!=null && refreshMenuStr.equals("true"));
  
  
  SiteManagment mgmt = SiteManagment.getInstance();
  UserContext userContext = UserEnvironment.getUserContext(request);
  //ask the list of conf from conf mgr
  ConfigurationImageManager confMgr = ConfigurationImageManager.getInstance();
  List list = confMgr.getAllConfigurationImagesFromType(LogicConfigurationImage.LOGIC_CONFIGURATION_IMAGE,userContext);
  
  if(list == null) {
  	list = new ArrayList();
  }
	request.getSession().setAttribute("redirectURL", "logic/tools/confImage/logicConfImageView.jsp");
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script>
  
  function goNext(id){
  	path = "logicConfImageBuilderAction.jsp?ID="+id;
  	document.location = path;
  }
  
  function doDelete(id){
  	path = "<%=BASE_DIRECTORY%>tools/confImage/confRemoveAction.jsp?ID="+id+"&redirectURL=logic/tools/confImage/logicConfImageView.jsp";
  	document.location = path;
  }
  
  function doDuplicate(id){
  	path = "<%=BASE_DIRECTORY%>tools/confImage/confDuplicateAction.jsp?ID="+id+"&redirectURL=logic/tools/confImage/logicConfImageView.jsp";
  	document.location = path;
  }
  
  function publish(id){
  	path = "logicConfImageBuilderAction.jsp?ID="+id+"&DO_PUBLISH=true";
  	document.location = path;
  }
  
  function exportConfImage(id){
  	path = "<%=BASE_DIRECTORY%>tools/confImage/publisherSelection.jsp?CONF_IMAGE_ID="+id+"&redirectURL=logic/tools/confImage/logicConfImageView.jsp";
  	document.location = path;
  }
  
  function checkIfTorefreshMenus(){
    if(<%=refreshMenu%>) {
    	refreshMenus();
    }
  }

</script>
</head>

<body onload="javascript:checkIfTorefreshMenus()">

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="98%" class="TOPBORDER">
                <span class="PAGEHEADER">Logic Configuration Image Set</span></td>
                <td width="1%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td><span class="REGULARTEXT"><a href="javascript:goNext()" class="LINK">Add new Logic Configuration Image</a></span></td>
                    
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr class="TABLES_HEADERS">
                        <td width="18%"><span class="REGULARTEXT">Name</span></td>
                        <td width="50%"><span class="REGULARTEXT">Description</span></td>
                        <td width="20%" colspan="5">&nbsp;</td>
                      </tr>
                     <%
                      for(int i=0;i<list.size();i++){
                        ConfigurationImage confImg = (ConfigurationImage)list.get(i);
                     %>
                      <tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
			  									<td width="20%"><a href="javascript:goNext('<%=confImg.getId()%>')" class="LINK"><%=confImg.getName()%></a></td>
                          <td width="46%"><span class="REGULARTEXT"><%=confImg.getDescription()%></span></td>
                          <td width="7%" style="padding-left:10" align="center" nowrap><a href="javascript:exportConfImage('<%=confImg.getId()%>')" class="LINK">export</a></td>
                          <td width="7%" style="padding-left:10" align="center" nowrap><a href="javascript:publish('<%=confImg.getId()%>')" class="LINK">publish</a></td>
                          <td width="5%" style="padding-left:10" align="center" nowrap><a href="javascript:goNext('<%=confImg.getId()%>')" class="LINK">edit</a></td>
                          <td width="7%" style="padding-left:10" align="center" nowrap><a href="javascript:doDelete('<%=confImg.getId()%>')" class="LINK">delete</a></td>
                          <td width="7%" style="padding-left:10" align="center" nowrap><a href="javascript:doDuplicate('<%=confImg.getId()%>')" class="LINK">duplicate</a></td>
                          <td width="2%"></td>
                       </tr>
                      <%
                        }
                      %>
                        <tr>
                         <td colspan="6"></td>
                       </tr>
                    </table>
                   </td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="35%">&nbsp;</td>
                    <td width="13%" align="center"><a href="<%=BASE_DIRECTORY%>logic/logicPortal.jsp" class="LINK">
                    cancel</a></td>
                    <td width="5%" align="center"></td>
                    <td width="27%">&nbsp;</td>
                    <td width="20%">&nbsp;</td>
                  </tr>
                </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>