<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.smart.magicdir.*"%>
<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>
<%
  String MAGICDIR_ID = "MAGICDIR_ID";
  String MODULE_ID = "MODULE_ID";
  String CURRENT_MODULE = "CURRENT_MODULE";
  String ERROR_OBJ = "ERROR_OBJ";
  String OP = "OP";
  String ADD = "ADD";
  String TYPE_LOG = "Log";

  SiteManagment mgmt = SiteManagment.getInstance();
  MagicDirManager mdmanager = SiteManagment.getMagicDirManagerInstance();

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  UserContext userContext = UserEnvironment.getUserContext(request);

  Module[] mdarr = mgmt.getAllModules(userContext,true);

  String modid = request.getParameter(MODULE_ID);
  String magicdirid = request.getParameter(MAGICDIR_ID);
  String op = request.getParameter(OP);

  Module curmod = null;

  if(curmod == null){
    curmod = new Module();
    modid = "";
    request.getSession().setAttribute(CURRENT_MODULE,curmod);
  }else{
    request.getSession().setAttribute(CURRENT_MODULE,curmod);
  }
  String imd = curmod.getId();
  boolean notmodules = true;
  if(imd != null && imd.equalsIgnoreCase("rootModule")){
    notmodules = false;
  }

  boolean isEditable = mdarr.length > 0;
  if(isEditable && userContext != null && imd != null && imd.length() > 0){
    isEditable = userContext.isModuleMemberEditable(imd);
  }
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script>
  function operationOk(){
    document.access.submit();
  }
</script>
</head>
<%boolean refresh = session.getAttribute("REFRESH") != null;%>
<body<%if (refresh) {session.removeAttribute("REFRESH");%> onload="javascript:refreshMenus()"<%}%>>

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" action="magicDirAction.jsp">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Magic Directories</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Magic Directories View</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td width="11%"><a href="magicDirEdit.jsp" class="LINK">add magic directory</a></td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr class="TABLES_HEADERS">
                        <td width="23%"><span class="REGULARTEXT">Name</span></td>
                        <td width="20%"><span class="REGULARTEXT">Description</span></td>
                        <td width="40%" class="REGULARTEXT">Directory</td>
                        <td width="15%" class="REGULARTEXT">&nbsp;</td>
                      </tr>
                      <tr>
                        <td width="23%" class="SMALLTEXT">&nbsp;</td>
                        <td width="20%" class="SMALLTEXT">&nbsp;</td>
                        <td width="40%" class="SMALLTEXT">&nbsp;</td>
                        <td width="15%" class="SMALLTEXT">&nbsp;</td>
                      </tr>
                      <%
                        MagicDir md = null;
                        List mdList = mdmanager.getMagicDirList();
                        String id = null;
												String clas = "#ffe1aa";
                        for(int i=0 ; i<mdList.size() ; ++i){
                          md = (MagicDir)mdList.get(i);
                          id = md.getId();
						  						if((i%2) == 0){
														clas = "#ffe1aa";
						  						}else{
														clas = "#ffffff";
						  						}
                      %>
                      <tr bgcolor="<%=clas%>">
			           				<td width="23%"><%=md.getName()%></td>
                        <td width="20%"><span class="REGULARTEXT"><%=md.getDescription()%>&nbsp;</span></td>
                        <td width="40%"><span class="REGULARTEXT"><%=md.getDirectory()%>&nbsp;&nbsp;</span></td>
                        <td width="15%" class="REGULARTEXT">
                        	<a href="magicDirEdit.jsp?MAGICDIR_ID=<%=id%>" class="LINK">edit</a><span class="REGULARTEXT">&nbsp;&nbsp;</span>
                        	<a href="magicDirDelCheck.jsp?MAGICDIR_ID=<%=id%>" class="LINK">delete</a><span class="REGULARTEXT">&nbsp;&nbsp;</span>
                        	<%if (!md.getParentModuleId().equals("")) {%>
                        		<a href="magicDirRunAction.jsp?MAGICDIR_ID=<%=id%>&OP=RUN" class="LINK">run</a>
                        	<%}%>
                        </td>
                       </tr>
                      <%}%>
                    </table>
	                </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
						<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
							<tr>
								<td width="35%">&nbsp;</td>
								<td width="18%" align="center"><a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK">ok</a></td>
								<td width="27%">&nbsp;</td>
								<td width="20%">&nbsp;</td>
							</tr>
						</table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>