<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.smart.magicdir.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>
<%
  String MAGICDIR_ID = "MAGICDIR_ID";
  String MODULE_ID = "MODULE_ID";
  String CURRENT_MODULE = "CURRENT_MODULE";
  String ERROR_OBJ = "ERROR_OBJ";
  String OP = "OP";
  String ADD = "ADD";
  String PRINT = "PRINT";
  String EXCLUDE = "EXCLUDE";
  String INCLUDE = "INCLUDE";

  SiteManagment mgmt = SiteManagment.getInstance();
  MagicDirManager mdManager = SiteManagment.getMagicDirManagerInstance();
  ErrorModel errmod = new ErrorModel();

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  UserContext userContext = UserEnvironment.getUserContext(request);

  Module[] mdarr = mgmt.getAllModules(userContext,true);

  String magicdirid = request.getParameter(MAGICDIR_ID);
  String op = request.getParameter(OP);
  
  MagicDir md = new MagicDir();
  String recurse = "";
  boolean isAddOp = true;
  if ((op == null) || !(op.equals(ADD))) {
    
    if(magicdirid != null && !magicdirid.trim().equals("")) {
      isAddOp = false;
    	md = mdManager.getMagicDir(magicdirid);
  		if (md != null){
  		  Module parentModule = null;
  	    try {
  	      parentModule = mgmt.getModuleFromId(md.getParentModuleId());
  	    }catch (Exception e){  	              
  	    }
  	    
  	     if (parentModule == null){
  	      errmod.addError("Parent folder doesn't exists any more, Please delete it and recreate.");
  	      request.getSession().setAttribute(ERROR_OBJ,errmod);
  	      response.sendRedirect("errorpage.jsp");
				  return;
  	    }
  	    
  	    mdarr = new Module[] {parentModule};
  		
    	  if (md.isRecurseDirs())
    		  recurse = "checked";
    		  
    		
      }
    }
    else
    	magicdirid = "";
  }

  boolean isEditable = mdarr.length > 0;
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>
  function operationOk(){
    document.access.submit();
  }
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" action="magicDirAction.jsp">
<input type="hidden" name="MAGICDIR_ID" value="<%=magicdirid%>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Magic Directory</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">General</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Parent folder</span></td>
                        <td width="77%">

                        <select size="1" class="TEXTBOX" name="PARENT_MODULE">
                          <%if (isAddOp){%>
                          <option class="TEXTBOX" value="">---Select a folder---</option>
                          <%}%>
                          <%
                            String selected = "";
                            for(int i=0;i<mdarr.length;++i){
                              if(md != null && mdarr[i].getId().equals(md.getParentModuleId())){
                                selected = "selected=\"true\"";
                              }else{
                                selected = "";
                              }
                            %>
                            <option class="TEXTBOX" value="<%=mdarr[i].getId()%>" <%=selected%>><%=mdarr[i].getName()%></option>
                          <%}%>
                        </select></td>
                      </tr>
                      <tr>
                      	<td width="23%"><span class="REGULARTEXT">Directory</span></td>
                        <td width="77%">
                        <input type="text" name="MAGICDIR_DIRECTORY" size="53" value="<%=md.getDirectory()%>" class="TEXTBOX"></td>
                      </tr>
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Name</span></td>
                        <td width="77%">
                        <input type="text" name="MAGICDIR_NAME" size="30" value="<%=md.getName()%>" class="TEXTBOX"></td>
                      </tr>
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Owner</span></td>
                        <td width="77%">
                        <input type="text" name="MAGICDIR_OWNER" size="30" value="<%=md.getOwner()%>" class="TEXTBOX"></td>
                      </tr>
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Description</span></td>
                        <td width="77%">
                        <input type="text" name="MAGICDIR_DESCRIPTION" size="53" value="<%=md.getDescription()%>" class="TEXTBOX">
                        </td>
                      </tr>
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Recurse directories</span></td>
                        <td width="77%">
                        <input type="checkbox" name="MAGICDIR_RECURSEDIR" <%=recurse%> value="true"></td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td width="800">&nbsp;</td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Filter</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">File extensions &nbsp;</span></td>
                        <td width="77%">
                        <input type="text" name="MAGICDIR_FE_FILTER" size="53" value="<%=md.getFilter().getFileExtensions()%>" class="TEXTBOX">
                        <input type="radio" name="MAGICDIR_FE_FILTER_TYPE"" value="<%=EXCLUDE%>"
                        	<%if (md.getFilter().getFileExtType().equals(EXCLUDE)) {%> checked<%}%>
                        >
                        <span class="REGULARTEXT">exclude</span>
                        <input type="radio" name="MAGICDIR_FE_FILTER_TYPE"" value="<%=INCLUDE%>"
                        	<%if (md.getFilter().getFileExtType().equals(INCLUDE)) {%> checked<%}%>
                        >
                        <span class="REGULARTEXT">include only</span>
                       </td>
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">&nbsp;</span></td>
                        <td width="77%" colspan="2"><span class="SMALLTEXT">
                        use file extension seperated by a blank, e.g. &quot;exe doc jpg&quot;</span></td>
                      </tr>
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">Name expressions &nbsp;</span></td>
                        <td width="77%">
                        <input type="text" name="MAGICDIR_NE_FILTER" size="53" value="<%=md.getFilter().getNameExpressions()%>" class="TEXTBOX">
                        <input type="radio" name="MAGICDIR_NE_FILTER_TYPE"" value="<%=EXCLUDE%>" 
                        	<%if (md.getFilter().getNameExpType().equals(EXCLUDE)) {%>checked<%}%>
                        >
                        	<span class="REGULARTEXT">exclude</span>
                        <input type="radio" name="MAGICDIR_NE_FILTER_TYPE"" value="<%=INCLUDE%>"
                        	<%if (md.getFilter().getNameExpType().equals(INCLUDE)) {%>checked<%}%>
                        >
                        	<span class="REGULARTEXT">include only</span>
                       </td>
                      <tr>
                        <td width="23%"><span class="REGULARTEXT">&nbsp;</span></td>
                        <td width="77%" colspan="2"><span class="SMALLTEXT">
                        use name expression seperated by a blank, e.g. &quot;my-app-{date,dd-MM-yyyy}.{string}.log&quot;</span></td>
                      </tr>
                    </table>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="35%">&nbsp;</td>
                    <td width="11%" align="center"><a href="magicDirAdmin.jsp" class="LINK">
                    cancel</a></td>
                    <td width="7%" align="center">
                     <%if (isEditable){ %>
                       <a href='javascript:operationOk()' class="LINK">ok</a></td>
                      <%}else {%>
                        &nbsp;
                      <%}%>
                    <td width="27%">&nbsp;</td>
                    <td width="20%">&nbsp;</td>
                  </tr>
                </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>