<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.smart.magicdir.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%!
	static final String BASE_DIRECTORY = "../";
%>

<%!

  public void go(String str){
    System.out.println(str);
  }

%>
<%

  final UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  String MAGICDIR_ID = "MAGICDIR_ID";
  String OP = "OP";
  String ERROR_OBJ = "ERROR_OBJ";

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  final MagicDirManager mdManager = SiteManagment.getMagicDirManagerInstance();
  ErrorModel errmod = new ErrorModel();
  
  String magicDirId = request.getParameter(MAGICDIR_ID);

  
  
  MagicDir magicDir;

  if (magicDirId != null && !magicDirId.equals("") &&
  		request.getParameter(OP) != null && request.getParameter(OP).equals("RUN")) {
  	  magicDir = mdManager.getMagicDir(magicDirId);
  	  
  	  Module parentModule = null;
  	  try {
  	    parentModule = mgmt.getModuleFromId(magicDir.getParentModuleId());
  	  }catch (Exception e){  	              
  	  }
  	  
  	  if (parentModule == null){
  	    errmod.addError("Could not create folder - Parent folder is no longer valid");
  	    request.getSession().setAttribute(ERROR_OBJ,errmod);
  	    response.sendRedirect("errorpage.jsp");
				return;
  	  }
      //audit
  	  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  		  			userContext, AuditConstants.CHANGE, "run magic directory", AuditConstants.LOGS, "run magic directory " + magicDir.getName());

  	  
  	final MagicDir md = magicDir;
    ProgressRunner runner = new ProgressRunner("magicDirAdmin.jsp") {
     public void run(HttpServletRequest request){
        try{
          mdManager.createMagicDirModule(md);
	  	  md.run();
  	      if (md.isRecurseDirs()) {
  		    mdManager.setSubMagicDirsParentModule(md);
  	      }
  	      mdManager.save();
  	      request.getSession().setAttribute("REFRESH","yes");
        }catch(Exception e){
          errmodel.addError("A problem occured while running magic directory.");
          errmodel.addError(e.getMessage());
          createErrorRedirect(request);
        }
  	 }
    };
    env.setProgressRunner(runner);
  }else {
    response.sendRedirect("magicDirAdmin.jsp");
    return;
  }
%>

<jsp:include page="../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
  <jsp:param name="message" value="Running"/>
</jsp:include>