<%@ page language="java"%><%@ page import="java.util.zip.*"%><%@ page import="java.io.*"%><%@ page import="xpolog.common.messaging.http.*"%><%@ page import="xpolog.common.messaging.*"%><%@ page import="xpolog.eye.messaging.server.*"%><%
 
try {
	final int OK_CODE = 0;
	final int ERROR_CODE = 1;
	response.setHeader("Content-Type", "application/octet-stream");
	String messageId = request.getParameter("messageId");
	String action = request.getParameter("action");
	XpoLogMessage requestMessage = null;
	XpoLogMessage responseMessage = null;	
	HttpCommunicationManager mgr = HttpCommunicationManager.getInstance();
	//prepare the output stream.
	ObjectOutputStream os = null;
	
	try {
		GZIPOutputStream gzos = new GZIPOutputStream(response.getOutputStream());
		os = new ObjectOutputStream(gzos);
	}catch (Exception e) {
		e.printStackTrace();
	}
	
	if(action != null && action.equals("send")) {
		try {
			ObjectInputStream ois = new ObjectInputStream(request.getInputStream());
			int checkCode = ois.readInt();
			if(checkCode == 1) {
				requestMessage = (XpoLogMessage)ois.readObject();
				xpolog.common.messaging.util.MessageFileUtil.readFiles(ois,requestMessage);
			}
			ois.close();
		}catch(Exception e) {
			e.printStackTrace();
		}
		if(requestMessage != null) {
			MessageConsumerHandler handler = XpoLogMessageManager.getInstance().createMessageHandler(requestMessage);
			if(handler != null) {
				//dealing with failure in handlers
				try {
					handler.messageArrived(requestMessage);
					mgr.addHandler(messageId, handler);
				}catch(Exception e) {
					XpoLogMessage message = new XpoLogMessage();
					message.setProperty("error", "Handler failed to prepare the response");
					handler.setResponse(message);
					mgr.addHandler(messageId, handler);
				}
			}
		}
	}
	
	if(action != null && action.equals("receive")) {
		MessageConsumerHandler handler = mgr.getHandler(messageId);
		if(handler != null) {
			responseMessage = handler.getResponse();
		}else {
			responseMessage = new XpoLogMessage();
			responseMessage.setProperty("error", "Handler is null for message id: " + messageId);
		}
		
		try {
			os.writeInt(OK_CODE);
			os.writeObject(responseMessage);
			xpolog.common.messaging.util.MessageFileUtil.writeFiles(os,responseMessage);
		}catch (Exception e) {
			e.printStackTrace();
		}
   }
  os.flush();
  os.close();
}catch (Throwable e2){
  e2.printStackTrace();
}
%>