
<%@page import="xpolog.eye.site.widgets.view.WidgetsView"%>
<%@page import="xpolog.eye.site.widgets.XpoLogWidgetsManager"%><%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.entities.XpologPrincipal"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.menu.*" %>
<%@ page import="xpolog.eye.search.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.site.main.MainViewModel"%>
<%@ page import="xpolog.eye.util.*"%>

<%@ page import="java.util.*"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  MetaDataManager metaDataMgr = SiteManagment.getInstance().getMetaDataMgr();
  MetaDataCategoriesManager metaDataCatMgr = MetaDataCategoriesManager.getInstance();
  UserContext userContext = UserEnvironment.getUserContext(request);
  WebSecurityManager manager = WebSecurityManager.getInstance();
  UserSecurity security = manager.getUserSecurity(request);

  String ERROR_OBJ = "ERROR_OBJ";
  ErrorModel err = new ErrorModel();
  String isAdminStr = request.getParameter("IsAdmin");
  boolean isAdmin = isAdminStr !=  null && isAdminStr.equals("true");
	String redirectUrl = request.getParameter("redirectURL");
	String op = request.getParameter("OP");
	String removeAllMembersStr = request.getParameter("removeAllMembers");
	boolean removeAllMembers = removeAllMembersStr != null && removeAllMembersStr.equals("true");
	
	String appId = request.getParameter("appId");
	if (appId != null){
		appId = appId.trim();
		if(WebUtil.isContainSpecialCharecter(appId)) {
			err.addError("The following charecters are prohibited in the id field: "+WebUtil.getSpecialCharectersList());
		}
	}
	if (isAdmin && appId!= null && op != null && op.equals("delete")){
		metaDataMgr.removeMetaData(appId,true,removeAllMembers);
		MainViewModel model = env.getMainViewModel();
		model.verify();
		response.sendRedirect("metaDataView.jsp?isAdmin="+isAdmin+"&refreshMenus="+removeAllMembers);
		return;
	}
	
	String userMetaDataId = request.getParameter("UserMetaDataId");
  String name = request.getParameter("name");
  // generate an automatic id in case the id field is hidden
  if(!MetaDataManager.SHOW_ID_FIELD) {
  	if(appId == null || appId.length() == 0) {
	  	appId = String.valueOf(System.currentTimeMillis());
	  }
  }
	if (isAdmin){
		if (appId == null || appId.length() == 0){
			err.addError("No id was entered");
		}
		if (name == null || name.length() == 0){
			err.addError("No name was entered");
		}
		if (err.getErrorCount() > 0){
			request.getSession().setAttribute(ERROR_OBJ,err);
			response.sendRedirect(BASE_DIRECTORY+"common/errorpage.jsp");
			return;
		}
	}
  
  String desc = request.getParameter("desc");
  if (desc == null){
  	desc = "";
  }
  String internalId = request.getParameter("InternalId");
  String app = request.getParameter("Application");
  boolean newApplication = false;
  String parentApplicationId = request.getParameter("NewApplicationParent");
  if (app == null || app.length() == 0 || app.equalsIgnoreCase("other")){
  	app = request.getParameter("NewApplication");
  	if (app != null && app.length() > 0){
	  	newApplication = true;
	  	if (parentApplicationId == null || parentApplicationId.length() == 0){
	  		parentApplicationId = "applications";
	  	}
  	}
  }
	String version = request.getParameter("Version");
	String build = request.getParameter("Build");
	String[] platformarr = request.getParameterValues("Platform");
	String platformstr = null;
	String newPlatformValue = null;
  boolean newPlatform = false;
  if (platformarr != null){
  	StringBuffer sb = new StringBuffer();
  	for (int i=0; i<platformarr.length; i++){
  		String platform = platformarr[i];
			if (platform == null || platform.length() == 0 || platform.equalsIgnoreCase("other")){
				platform = request.getParameter("NewPlatform");
		  	if (platform != null && platform.length() > 0){
		  		newPlatformValue = platform;
			  	newPlatform = true;
		  	}
			}
			if (i > 0){
				sb.append(",");
			}
			sb.append(platform);
  	}
  	if (sb.length() > 0){
  		platformstr = sb.toString();
  	}
  }
	String[] osarr = request.getParameterValues("Os");
	String osstr = null;
	String newOsValue = null;
  boolean newOs = false;
  if (osarr != null){
  	StringBuffer sb = new StringBuffer();
  	for (int i=0; i<osarr.length; i++){
  		String os = osarr[i];
			if (os == null || os.length() == 0 || os.equalsIgnoreCase("other")){
				os = request.getParameter("NewOs");
		  	if (os != null && os.length() > 0){
		  		newOsValue = os;
			  	newOs = true;
		  	}
			}
			if (i > 0){
				sb.append(",");
			}
			sb.append(os);
  	}
  	if (sb.length() > 0){
  		osstr = sb.toString();
  	}
  }
	String vendor = request.getParameter("Vendor");
  boolean newVendor = false;
	if (vendor == null || vendor.length() == 0 || vendor.equalsIgnoreCase("other")){
		vendor = request.getParameter("NewVendor");
  	if (vendor != null && vendor.length() > 0){
	  	newVendor = true;
  	}
	}
	String numPropsStr = request.getParameter("numberOfProps");
	int numProps = (numPropsStr == null || numPropsStr.length() == 0) ? 0 : Integer.parseInt(numPropsStr);
	Properties newProps = new Properties();
	String key,value;
	for (int i=1; i<=numProps; i++){
		key = request.getParameter("key_"+i);
		value = request.getParameter("value_"+i);
		if (key != null && value != null && key.length() > 0 && value.length() > 0){
			newProps.setProperty(key,value);
		}
	}

	if(err.getErrorCount() > 0){
    request.getSession().setAttribute(ERROR_OBJ,err);
    response.sendRedirect("errorpage.jsp");
    return;
  }
	
	if (newApplication && parentApplicationId != null && parentApplicationId.length() > 0){
		MetaDataCategory cat = new MetaDataCategory();
		cat.setName(app);
		app = WebUtil.doHTMLEncoding(app).toLowerCase();
		cat.setId(app);
		metaDataCatMgr.addMetaDataCategory(cat,parentApplicationId);
	}
	
	if (newPlatform){
		MetaDataCategory cat = new MetaDataCategory();
		cat.setName(newPlatformValue);
		newPlatformValue = WebUtil.doHTMLEncoding(newPlatformValue).toLowerCase();
		cat.setId(newPlatformValue);
		metaDataCatMgr.addMetaDataCategory(cat,"platforms");
	}
	
	if (newOs){
		MetaDataCategory cat = new MetaDataCategory();
		cat.setName(newOsValue);
		newOsValue = WebUtil.doHTMLEncoding(newOsValue).toLowerCase();
		cat.setId(newOsValue);
		metaDataCatMgr.addMetaDataCategory(cat,"os");
	}
	
	if (newVendor){
		MetaDataCategory cat = new MetaDataCategory();
		cat.setName(vendor);
		vendor = WebUtil.doHTMLEncoding(vendor).toLowerCase();
		cat.setId(vendor);
		metaDataCatMgr.addMetaDataCategory(cat,"vendors");
	}
	
	
	Properties prop = new Properties();
	if (app != null && app.length() > 0)
		prop.setProperty("application",app);
	if (version != null && version.length() > 0)
		prop.setProperty("version",version);
	if (build != null && build.length() > 0)
		prop.setProperty("build",build);
	if (platformstr != null && platformstr.length() > 0)
		prop.setProperty("platform",platformstr);
	if (osstr != null && osstr.length() > 0)
		prop.setProperty("os",osstr);
	if (vendor != null && vendor.length() > 0)
		prop.setProperty("vendor",vendor);
	Iterator it = newProps.keySet().iterator();
	while (it.hasNext()){
		key = (String)it.next();
		value = newProps.getProperty(key);
		prop.setProperty(key,value);
	}
	
	MetaData systemMetaData = null;
	MetaData userMetaData = null;
	boolean isNew = true;
	if (appId != null && appId.length() > 0){
		systemMetaData = metaDataMgr.getMetaData(appId);
		String intId = null;
		if (systemMetaData != null){
			isNew = false;
			intId = systemMetaData.getInternalId();
			if (internalId != null && !internalId.equals(intId)){
				err.addError("There is already a application with the given id");
				err.addError("Please enter another id");
				request.getSession().setAttribute(ERROR_OBJ,err);
				response.sendRedirect(BASE_DIRECTORY+"common/errorpage.jsp");
				return;
			}
		}
	}
	
	int count = 0;
  int total = 0;
  PopupMenues menues = new PopupMenues();

  if (menues != null){
    PopupMenu menu = menues.getPopupById("logDataCM");
    String col = request.getParameter("contextSearchCol0");
    boolean clearSearchItem = true;
    while (col != null && col.length() > 0){
  	  String menuname = request.getParameter("contextSearchName" + count);
      String path = request.getParameter("contextSearchPath" + count);
      if (menuname == null || menuname.length() == 0 || path == null || path.length() == 0){
    	  count++;
    	  col = request.getParameter("contextSearchCol" + count);
    	  continue;
      }
    
      MenuItem item = new MenuItem();
      item.id = "metaSearch" + appId  + total++;
      item.name = menuname;
      item.link = path;
    	item.target = "_new";
    	item.componentsMask = MenuItem.ALL_MASK;
    	
    	MenuGroup group = new MenuGroup();
    	if (menu == null){
      	menu = new PopupMenu();
      	menu.setPopupId("logDataCM");
      	group.id = "search";
      	group.name = "Search";
      	group.componentsMask = MenuItem.ALL_MASK;
      	menu.addItem(group);
    	}else {
    		group = (MenuGroup)menu.getItem("search");
    	}
      if (clearSearchItem){
      	group.items.clear();
      	clearSearchItem = false;
      }
    	if (group != null){
    		group.items.add(item);
    	}
    
  		count++;
  		col = request.getParameter("contextSearchCol" + count);
  	}
  	menues.removePopupMenu("logDataCM");
   	if (menu != null){
  		 menues.addPopup(menu);
   	}
  }
  
	if (isAdmin){
		if (systemMetaData == null){
			systemMetaData = new MetaData();
			systemMetaData.setId(appId);
			long intId = System.currentTimeMillis();
			systemMetaData.setInternalId(String.valueOf(intId));
		}
		if (systemMetaData.getPermissions() == null){
			systemMetaData.setPermissions((ModuleMemberPermissions)metaDataMgr.getDefaultPermissions().clone());
		}
		systemMetaData.setName(name);
		systemMetaData.setDescription(desc);
		systemMetaData.setSystemMetaData(true);
		systemMetaData.setProperties(prop);
		systemMetaData.setPopupMenues(menues);
	}
	
	boolean systemMetaDataOverwritten = false;
	if (!isAdmin && systemMetaData != null){
		Properties systemMdProps = systemMetaData.getProperties();
		systemMetaDataOverwritten = !MetaData.sameProperties(systemMdProps,prop);
	}
	if (userMetaDataId != null && userMetaDataId.length() > 0){
		if (systemMetaDataOverwritten && prop != null && !prop.isEmpty()){
			userMetaData = new MetaData();
			userMetaData.setId(userMetaDataId);
			userMetaData.setName(userMetaDataId);
			userMetaData.setProperties(prop);
			userMetaData.setSystemMetaData(false);
			long intId = System.currentTimeMillis();
			userMetaData.setInternalId(String.valueOf(intId));
			metaDataMgr.saveMetaData(userMetaData);
		}else{
			metaDataMgr.removeMetaData(userMetaDataId,false,false);
		}
	}
	
	//permissions
	if (XpologSecurityManager.getInstance().isEnabled()){
	  ModuleMemberPermissions permissions = null;
	  String permissionsPolicy = request.getParameter("memberPolicy");
	  if (permissionsPolicy != null && permissionsPolicy.equals("current")){
	    ModuleMemberPermissions orgPermissions = systemMetaData.getPermissions();
	    Collection orgEditMembers = orgPermissions != null ? orgPermissions.getEditMembers() : null;
	    Collection orgViewMembers = orgPermissions != null ? orgPermissions.getViewMembers() : null;
	    Collection nonAdministeredEditMembers = null;
	    Collection nonAdministeredViewMembers = null;
	    if (orgEditMembers != null){
	    	nonAdministeredEditMembers = XpologSecurityHelper.getNonAdministeredPrincipals(security,manager.getGroupsMembersByNames(orgEditMembers,false));
	    }
	    permissions = new ModuleMemberPermissions();
	    String [] editNames = request.getParameterValues("selectedEditMembersList");
	    HashSet editNamesCol = new HashSet();
			if (editNames != null && editNames.length > 0){
				for (int i=0; i<editNames.length; i++){
					editNamesCol.add(editNames[i]);
				}
			}
			if (nonAdministeredEditMembers != null){
		  	it = nonAdministeredEditMembers.iterator();
		  	while (it.hasNext()){
		  		XpologPrincipal p = (XpologPrincipal)it.next();
		  		editNamesCol.add(p.getName());
		  	}
			}
			if (!editNamesCol.isEmpty()){
				permissions.setEditMembers(editNamesCol);
			}
		
	    if (orgViewMembers != null){
	    	nonAdministeredViewMembers = XpologSecurityHelper.getNonAdministeredPrincipals(security,manager.getGroupsMembersByNames(orgViewMembers,false));
	    }
			String [] viewNames = request.getParameterValues("selectedViewMembersList");
	    HashSet viewNamesCol = new HashSet();
			if (viewNames != null && viewNames.length > 0){
				for (int i=0; i<viewNames.length; i++){
					viewNamesCol.add(viewNames[i]);
				}
			}
			if (nonAdministeredViewMembers != null){
		  	it = nonAdministeredViewMembers.iterator();
		  	while (it.hasNext()){
		  		XpologPrincipal p = (XpologPrincipal)it.next();
		  		viewNamesCol.add(p.getName());
		  	}
			}
			if (!viewNamesCol.isEmpty()){
				permissions.setViewMembers(viewNamesCol);
			}
	  }
	  systemMetaData.setPermissions(permissions);
	}
	
	//save only once, here
  try {
    metaDataMgr.saveMetaData(systemMetaData, userContext);
  }catch (Exception e){
  }

	//members start
  String [] types = {"accounts","reports","environmentAnalyses","usertemplates","systemplates","wizards","tasks",
  		"schedulers","xplgnodes","configimages","envvariables","metadatas","transactions"};
  String [] values = null;
  
  HashSet metaDataDashboards = new HashSet();
	String[] dashboardsIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(appId,XpoLogObjectTypes.WIDGET_TYPE);
	if (dashboardsIds != null){
		for (int i=0; i<dashboardsIds.length; i++){
			metaDataDashboards.add(dashboardsIds[i]);
		}
	}
  
	HashSet metaDataSavedSearches = new HashSet();
	String[] savedSearchesIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(appId,XpoLogObjectTypes.SAVED_SEARCHES_TYPE);
	if (savedSearchesIds != null){
		for (int i=0; i<savedSearchesIds.length; i++){
			metaDataSavedSearches.add(savedSearchesIds[i]);
		}
	}


  metaDataMgr.clearMetaDataMapping(appId,true);

  for (int t=0; t<types.length; t++){
		values = request.getParameterValues(types[t]);
		String v,type,id;
		int index;
	  if (values != null){
	    for (int i = 0; i < values.length; i++){
	    	v = values[i];
	    	index = v.indexOf(",");
	    	if (index == -1 || index == v.length()-1){
	    		continue;
	    	}
	    	type = v.substring(0,index);
	    	if (type != null && type.indexOf("tempaltes") != -1){
	    		type = "templates";
	    	}
	    	id = v.substring(index+1);
	    	metaDataMgr.addXplgObjMetaData(type,id,appId,true,false);
	    }
	  }
	}
  
  //Modules and logs
	HashMap logs = new HashMap();
  HashMap mods = new HashMap();
  String [] logsArr = null;
 	String logsList = request.getParameter("logs");
 	if (logsList != null && logsList.length() > 0){
 		logsArr = logsList.split(",");
 	}
  if (logsArr != null){
    for (int i = 0;i< logsArr.length;i++){
  	 logs.put(logsArr[i],logsArr[i]);
    }
  }

  String [] modsArr = null;
  String modsList = request.getParameter("mods");
  if (modsList != null && modsList.length() > 0){
  	modsArr = modsList.split(",");
  }
  if (modsArr != null){
    for (int i = 0;i< modsArr.length;i++){
     mods.put(modsArr[i],modsArr[i]);
    }
  }
//add the chosen ver and multiVer to congImg according to api
	HashMap verifiers = new HashMap();
	HashMap multiVerifiers = new HashMap();
	
	String [] verifiersArr = null;
		String verifiersList = request.getParameter("verifiers");
		if (verifiersList != null && verifiersList.length() > 0){
			verifiersArr = verifiersList.split(",");
		}
	if (verifiersArr != null){
	  for (int i = 0;i< verifiersArr.length;i++){
	    verifiers.put(verifiersArr[i],verifiersArr[i]);
	  }
	}
	
	//Verifiers
	String [] multiVerifiersArr = null;
	String multiVerifiersList = request.getParameter("multiVerifiers");
	if (multiVerifiersList != null && multiVerifiersList.length() > 0){
		multiVerifiersArr = multiVerifiersList.split(",");
	}
	if (multiVerifiersArr != null){
	  for (int i = 0;i< multiVerifiersArr.length;i++){
	  	if (!multiVerifiersArr[i].endsWith("*")){
	    	multiVerifiers.put(multiVerifiersArr[i],multiVerifiersArr[i]);
	  	}
	  }
	}
	if (multiVerifiersArr != null){
	  for (int i = 0;i< multiVerifiersArr.length;i++){
	  	String id = multiVerifiersArr[i];
	  	if (multiVerifiersArr[i].endsWith("*")){
	   		id = id.substring(0,id.length()-1);
	   		VerifierRenderer.addAllMultiVerifierChildren(id,multiVerifiers,verifiers); 
	   	}
	    multiVerifiers.put(id,id);
	  }
	}
	verifiers.putAll(multiVerifiers);
	
	//Dashboards
	HashMap dashboards = new HashMap();
	String [] dashboardsArr = request.getParameterValues("dashboards");
	if (dashboardsArr != null){
		for (int i = 0;i< dashboardsArr.length;i++){
			dashboards.put(dashboardsArr[i],dashboardsArr[i]);
		}
	}
	//Add non-visible application's dashboards
	XpoLogWidgetsManager xpoLogWidgetsManager = XpoLogWidgetsManager.getIntsance();
	List nonVisibleDashboards = xpoLogWidgetsManager.getComplementaryDashboardsList(userContext, WidgetsView.PORTAL_VIEW_TYPE);
	if (nonVisibleDashboards != null && nonVisibleDashboards.size() > 0){
		for (int i=0; i<nonVisibleDashboards.size(); i++){
			WidgetsView view = (WidgetsView)nonVisibleDashboards.get(i);
			if (view != null && metaDataDashboards.contains(view.getId())){
				dashboards.put(view.getId(),view.getId());
			}
		}
	}
	
	//Saved Searches
	HashMap savedSearches = new HashMap();
	String [] savedSearchesArr = request.getParameterValues("savedSearches");
	if (savedSearchesArr != null){
		for (int i = 0;i< savedSearchesArr.length;i++){
			savedSearches.put(savedSearchesArr[i],savedSearchesArr[i]);
		}
	}
	//Add non-visible application's saved searches
	SearchHistoryManager searchHistoryManager = SearchHistoryManager.getInstance();
	List nonVisibleSavedSearches = searchHistoryManager.getComplementarySavedSearchesList(userContext);
	if (nonVisibleSavedSearches != null && nonVisibleSavedSearches.size() > 0){
		for (int i=0; i<nonVisibleSavedSearches.size(); i++){
			SavedSearch savedSearch = (SavedSearch)nonVisibleSavedSearches.get(i);
			if (metaDataSavedSearches != null && metaDataSavedSearches.contains(savedSearch.getId())){
				savedSearches.put(savedSearch.getId(),savedSearch.getId());
			}
		}
	}

  
  //workspace tree
	HashMap workspaces = new HashMap();
	HashMap projects = new HashMap();
	HashMap transactions = new HashMap();
	
	String [] transArr = null;
	String transList = request.getParameter("projectTransactions");
	if (transList != null && transList.length() > 0){
		transArr = transList.split(",");
	}
	if (transArr != null){
		for (int i = 0;i< transArr.length;i++){
			transactions.put(transArr[i],transArr[i]);
		}	
	}
	
	String [] projectsArr = null;
	String projectsList = request.getParameter("projects");
	if (projectsList != null && projectsList.length() > 0){
		projectsArr = projectsList.split(",");
	}
	if (projectsArr != null){
		for (int i = 0;i< projectsArr.length;i++){
				projects.put(projectsArr[i],projectsArr[i]);				
		}
	}
	String [] workspacesArr = null;
	String workspacesList = request.getParameter("workspaces");
	if (workspacesList != null && workspacesList.length() > 0){
		workspacesArr = workspacesList.split(",");
	}
	if (workspacesArr != null){
		for (int i = 0;i< workspacesArr.length;i++){
			workspaces.put(workspacesArr[i],workspacesArr[i]);
		}
	}
  

  it = logs.keySet().iterator();
  String type = XpoLogObjectTypes.LOG_TYPE;
  String id = null;
  while (it.hasNext()){
  	id = (String)it.next();
  	metaDataMgr.addXplgObjMetaData(type,id,appId,true,false);
  }
  it = mods.keySet().iterator();
  type = XpoLogObjectTypes.MODULE_TYPE;
  while (it.hasNext()){
  	id = (String)it.next();
  	metaDataMgr.addXplgObjMetaData(type,id,appId,true,false);
  }
  
  it = verifiers.keySet().iterator();
  type = XpoLogObjectTypes.VERIFIER_TYPE;
  while (it.hasNext()){
  	id = (String)it.next();
  	metaDataMgr.addXplgObjMetaData(type,id,appId,true,false);
  }
  
  it = dashboards.keySet().iterator();
  type = XpoLogObjectTypes.WIDGET_TYPE;
  while (it.hasNext()){
  	id = (String)it.next();
  	metaDataMgr.addXplgObjMetaData(type,id,appId,true,false);
  }
  
  it = savedSearches.keySet().iterator();
  type = XpoLogObjectTypes.SAVED_SEARCHES_TYPE;
  while (it.hasNext()){
  	id = (String)it.next();
  	metaDataMgr.addXplgObjMetaData(type,id,appId,true,false);
  }
  
  it = transactions.keySet().iterator();
  type = XpoLogObjectTypes.TRANSACTION_TYPE;
  id = null;
  HashMap projectsTransMap = new HashMap();
  HashMap tmp = new HashMap();
  while (it.hasNext()){
  	id = (String)it.next();
  	int ind = id.indexOf("@");
  	if (ind != -1){
  		String projId = id.substring(0,ind);
  		id = id.substring(ind+1);
  		String transChilds = (String)projectsTransMap.get(projId);
  		if(transChilds == null || transChilds.length() == 0){
  			transChilds = type + "-" + id;
  		}else{
  			transChilds += "," + type + "-" + id;
  		}
  		projectsTransMap.put(projId,transChilds);
  	}
  	tmp.put(id,id);
  }
  transactions = tmp;
 
  
  it = workspaces.keySet().iterator();
  type = XpoLogObjectTypes.WORKSAPCE_TYPE;
  id = null;
  while (it.hasNext()){
  	id = (String)it.next();
  	metaDataMgr.addXplgObjMetaData(type,id,appId,true,false);
  }
  
  it = projects.keySet().iterator();
  type = XpoLogObjectTypes.PROJECT_TYPE;
  id = null;
  while (it.hasNext()){
  	id = (String)it.next();
  	metaDataMgr.addXplgObjMetaData(type,id,appId,true,false);
  }

  it = projectsTransMap.keySet().iterator();
  type = XpoLogObjectTypes.PROJECT_TYPE;
  id = null;
  while (it.hasNext()){
  	id = (String)it.next();
		String projChilds = (String)projectsTransMap.get(id);
		if(projChilds != null && projChilds.length() > 0){
			metaDataMgr.setMetaDataObjectsChildrens(appId,type+"-"+id,projChilds);
		}
		metaDataMgr.addXplgObjMetaData(type,id,appId,true,false);
  }

  
  it = transactions.keySet().iterator();
  type = XpoLogObjectTypes.TRANSACTION_TYPE;
  id = null;
  while (it.hasNext()){
  	id = (String)it.next();
  	int indx = id.indexOf("#");
  	if(indx > 0){
  		id = id.substring(0,indx);
  	}
  	metaDataMgr.addXplgObjMetaData(type,id,appId,true,false);
  }

 
  metaDataMgr.saveMetaDataRepository();

  ErrorModel errmodel = new ErrorModel(); 
  if(errmodel.getErrorCount() != 0){
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
	}
	
	//members end
	
	//audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		userContext, AuditConstants.CHANGE, "edit/save application", AuditConstants.CONFIGURATION, "change application " + name);
	if (redirectUrl == null || redirectUrl.length() == 0){
		response.sendRedirect(BASE_DIRECTORY+"metadata/applicationsView.jsp");
	}else{
		response.sendRedirect(BASE_DIRECTORY+redirectUrl);
	}

	
%>