<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.security.*"%>

<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	SiteManagment mgmt = SiteManagment.getInstance();
	UserSecurity user = manager.getUserSecurity(request);
			
	String appId = request.getParameter("appId");
	if (appId == null) {
		appId = "";
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	String isAdminStr = request.getParameter("IsAdmin");
	boolean isAdmin = isAdminStr !=  null && isAdminStr.equals("true");
	//String systemMetaDataId = request.getParameter("SystemMetaDataId");
	String userMetaDataId = request.getParameter("UserMetaDataId");
	MetaDataManager mdMgr = SiteManagment.getInstance().getMetaDataMgr();
	MetaDataCategoriesManager catMgr = MetaDataCategoriesManager.getInstance();
	MetaDataCategory applications = catMgr.getMetaDataCategory("applications");
	MetaDataCategory platforms = catMgr.getMetaDataCategory("platforms");
	MetaDataCategory operatingSystems = catMgr.getMetaDataCategory("os");
	MetaDataCategory vendors = catMgr.getMetaDataCategory("vendors");
	String baseDir = request.getParameter("baseDir");
	if (baseDir == null){
		baseDir = "";
	}
	String name = "", desc = "", app = "", version = "", build = "";
	String platform = "", os = "", vendor = "", internalId = "";
	HashSet selPlatforms = null;
	HashSet selOs = null;
	MetaData systemMetaData = null, userMetaData = null;
	if (appId != null){
		systemMetaData = mdMgr.getMetaData(appId,true);
	}else{
		String metaDataAttr = request.getParameter("metaDataAttr");
		if (metaDataAttr != null && metaDataAttr.length() > 0){
			systemMetaData = (MetaData)request.getSession().getAttribute(metaDataAttr);
		}
		appId = "";
	}
	if (userMetaDataId != null){
		userMetaData = mdMgr.getMetaData(userMetaDataId,false);
	}
	MetaData metaData = MetaDataManager.mergeMetaData(systemMetaData, userMetaData);
	HashSet nonPredefinedAttributes = null;
	int numberOfNonPredefinedAttributes = 0;
	if (metaData != null){
		name = metaData.getName();
		desc = metaData.getDescription();
		app = metaData.getApplication();
		version = metaData.getVersion();
		build = metaData.getBuild();
		platform = metaData.getPlatform();
		if (platform != null && platform.length() > 0){
			selPlatforms = new HashSet();
			String[] arr = platform.split(",");
			for (int i=0; i<arr.length; i++){
				selPlatforms.add(arr[i]);
			}
		}
		os = metaData.getOs();
		if (os != null && os.length() > 0){
			selOs = new HashSet();
			String[] arr = os.split(",");
			for (int i=0; i<arr.length; i++){
				selOs.add(arr[i]);
			}
		}
		vendor = metaData.getVendor();
		internalId = metaData.getInternalId();
		nonPredefinedAttributes = metaData.getAllNonPredefinedAttributes();
		if (nonPredefinedAttributes != null){
			numberOfNonPredefinedAttributes = nonPredefinedAttributes.size();
		}
	}
	if (metaData !=  null){
 	request.setAttribute("metaData",metaData);
	}
%>

<input type="hidden" value="<%=numberOfNonPredefinedAttributes%>" id="numberOfProps" name="numberOfProps"/>
<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
	<tr>
		<td width="100%">
		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
			<tr>
				<td colspan="3">
				<table border="0" cellpadding="0" cellspacing="0"  width="100%" id="AutoNumber3" height="53">
					<tr>
						<td>&nbsp;</td>
					</tr>
					<tr>
						<td width="15%" height="28"><span class="HEADER">Properties</span></td>
					</tr>
					<tr>
						<td>
						<table border="0" width="100%" cellspacing="0" cellpadding="0">
							<tr>
								<td width="20%" valign="top" nowrap><span class="REGULARTEXT">Application</span></td>
								<td width="80%">
									<%if (applications != null) {%>
									<select name="Application" onchange="javascript:showTextField(this)">
									<option value="">--- select ---</option>
									<%
									List list = applications.getMembers(true);
									for (int i=0; i<list.size();i++){
										MetaDataCategory child = (MetaDataCategory)list.get(i);
										String indentation = "";
										for (int j=1; j<child.getLevel(); j++){
											indentation += "&nbsp;&nbsp;";
										}
										String selected = app != null && app.equals(child.getId()) ? " selected" : "";
									%>
									<option value="<%=child.getId()%>" <%=selected%>><%=indentation+child.getName()%></option>
									<%}%>
									<option value="other">other</option>
									</select>
									<%}%>
									<span id="NewApplicationDiv" style="display:none">
									<input type="text" name="NewApplication" value="" size="20">
									<span class="REGULARTEXT">as child of: </span>
									<%if (applications != null) {%>
									<select name="NewApplicationParent">
									<option value="">--- select ---</option>
									<%
									List list = applications.getMembers(true);
									for (int i=0; i<list.size();i++){
										MetaDataCategory child = (MetaDataCategory)list.get(i);
										String indentation = "";
										for (int j=1; j<child.getLevel(); j++){
											indentation += "&nbsp;";
										}
										String selected = app != null && app.equals(child.getId()) ? " selected" : "";
									%>
									<option value="<%=child.getId()%>" <%=selected%>><%=indentation+child.getName()%></option>
									<%}%>
									</select>
									<%}%>
									</span>
								</td>
							</tr>
							<tr>
								<td><span style="font-size:2px">&nbsp;<span></td>
							</tr>
							<tr>
								<td width="20%" valign="top" nowrap><span class="REGULARTEXT">Version</span></td>
								<td width="80%">
									<input type="text" name="Version" value="<%=version%>" size="20">
								</td>
							</tr>
							<tr>
								<td><span style="font-size:2px">&nbsp;<span></td>
							</tr>
							<tr>
								<td width="20%" valign="top" nowrap><span class="REGULARTEXT">Build</span></td>
								<td width="80%">
									<input type="text" name="Build" value="<%=build%>" size="20">
								</td>
							</tr>
							<tr>
								<td><span style="font-size:2px">&nbsp;<span></td>
							</tr>
							<tr>
								<td width="20%" valign="top" nowrap>
									<span class="REGULARTEXT">Platform</span>
								</td>
								<td width="80%">
									<%if (platforms != null) {%>
									<select name="Platform" onchange="javascript:showTextField(this)" multiple size="5">
									<%
									List list = platforms.getMembers(true);
									for (int i=0; i<list.size();i++){
										MetaDataCategory child = (MetaDataCategory)list.get(i);
										String selected = selPlatforms != null && selPlatforms.contains(child.getId()) ? " selected" : "";
									%>
									<option value="<%=child.getId()%>" <%=selected%>><%=child.getName()%></option>
									<%}%>
									<option value="other">other</option>
									</select>
									<%}%>
									<span id="NewPlatformDiv" style="display:none">
										<input type="text" name="NewPlatform" value="" size="20">
									</span>
								</td>
							</tr>
							<tr>
								<td><span style="font-size:2px">&nbsp;<span></td>
							</tr>
							<tr>
								<td width="20%" valign="top" nowrap><span class="REGULARTEXT">Operating system</span></td>
								<td width="80%">
									<%if (operatingSystems != null) {%>
									<select name="Os" onchange="javascript:showTextField(this)" multiple size="5">
									<%
									List list = operatingSystems.getMembers(true);
									for (int i=0; i<list.size();i++){
										MetaDataCategory child = (MetaDataCategory)list.get(i);
										String selected = selOs != null && selOs.contains(child.getId()) ? " selected" : "";
									%>
									<option value="<%=child.getId()%>" <%=selected%>><%=child.getName()%></option>
									<%}%>
									<option value="other">other</option>
									</select>
									<%}%>
									<span id="NewOsDiv" style="display:none">
										<input type="text" name="NewOs" value="" size="20">
									</span>
								</td>
							</tr>
							<tr>
								<td><span style="font-size:2px">&nbsp;<span></td>
							</tr>
							<tr>
								<td width="20%" valign="top" nowrap><span class="REGULARTEXT">Vendor</span></td>
								<td width="80%">
									<%if (vendors != null) {%>
									<select name="Vendor" onchange="javascript:showTextField(this)">
									<option value="">--- select ---</option>
									<%
									List list = vendors.getMembers(true);
									for (int i=0; i<list.size();i++){
									MetaDataCategory child = (MetaDataCategory)list.get(i);
									String selected = vendor != null && vendor.equals(child.getId()) ? " selected" : "";
									%>
									<option value="<%=child.getId()%>" <%=selected%>><%=child.getName()%></option>
									<%}%>
									<option value="other">other</option>
									</select>
									<%}%>
									<span id="NewVendorDiv" style="display:none">
										<input type="text" name="NewVendor" value="" size="20">
									</span>
								</td>
							</tr>
							<tr>
								<td colspan="2">
								<div id="newProps">
								<%
								if (nonPredefinedAttributes != null){
									Iterator it = nonPredefinedAttributes.iterator();
									int i = 1;
									while (it.hasNext()){
										String key = (String)it.next();
										String value = metaData.getValue(key);
								%>
									<div id="newProp<%=i%>Div">
										<table border="0" width="100%" cellspacing="0" cellpadding="0">
											<tr>
												<td><span style="font-size:2px">&nbsp;<span></td>
											</tr>
											<tr>
												<td width="20%" valign="top" nowrap>
													<span class="REGULARTEXT"><%=key%></span>
													<input type="hidden" name="key_<%=i%>" id="key_<%=i%>" value="<%=key%>">
												</td>
												<td width="80%">
													<input type="text" name="value_<%=i%>" id="value_<%=i%>" value="<%=value%>" size="20">
													&nbsp;<span class="LINK"><a href="javascript:;" onclick="removeEvent('newProp<%=i%>Div')">&nbsp;remove</a>
												</td>
											</tr>
										</table>
									</div>
								<%
									i++;
									}
								}%>
									<table border="0" width="100%" cellspacing="0" cellpadding="0">
										<tr><td>&nbsp;</td></tr>
										<tr><td><a href="javascript:addNewProp()" class="LINK">add new property</a></td></tr>
										<tr>
											<td>
											<table id="NewPropTableHeader" border="0" width="100%" cellspacing="0" cellpadding="0" style="display:none">
												<tr>
													<td colspan="2"><span style="font-size:2px">&nbsp;<span></td>
												</tr>
												<tr>
													<td width="20%" valign="top" bgcolor="#EEEEEE">
														<span class="REGULARTEXT">&nbsp;type</span>
													</td>
													<td width="80%" valign="top" bgcolor="#EEEEEE">
														<span class="REGULARTEXT">&nbsp;value</span>
													</td>
												</tr>
												<tr>
													<td colspan="2"><span style="font-size:2px">&nbsp;<span></td>
												</tr>
											</table>
											</td>
										</tr>
									</table>
								</div>
								</td>
							</tr>
						</table>
						</td>
					</tr>
					<tr>
						<td><b>&nbsp;</b></td>
					</tr>
					<tr>
						<td><span class="HEADER">Search Context Menu</span></td>
					</tr>  
					<tr>
						<td id="searchMenuesTD">
							<jsp:include page="metaDataContextMenues.jsp" flush="true"/>
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
	<tr>
		<td width="100%">&nbsp;</td>
	</tr>
	<tr>
		<td width="100%">&nbsp;</td>
	</tr>
	<tr>
		<td width="100%" height="100%">&nbsp;</td>
	</tr>
</table>