<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  MetaDataManager metaDataMgr = SiteManagment.getInstance().getMetaDataMgr();
  UserContext userContext = UserEnvironment.getUserContext(request);

  String ERROR_OBJ = "ERROR_OBJ";
  ErrorModel err = new ErrorModel();
	String redirectUrl = request.getParameter("redirectURL");
	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	String prevSystemMetaDataId = null;
	String type = request.getParameter("Type");//of xplg object
	String id = request.getParameter("Id");//of xplg object
	MetaData systemMetaData = metaDataMgr.getMergedMetaDataByXplgObjectAndType(type,id,true,false);
	if (systemMetaData != null){
		prevSystemMetaDataId = systemMetaData.getId();
	}
	
	if (systemMetaDataId != null && systemMetaDataId.length() > 0 && !systemMetaDataId.equalsIgnoreCase("none")){
		metaDataMgr.addXplgObjMetaData(type,id,systemMetaDataId,true);
	}else{
		metaDataMgr.removeXplgObjectMetaData(type,id,prevSystemMetaDataId,true);
	}
	String userMetaDataId = type + "_" + id;
	metaDataMgr.addXplgObjMetaData(type,id,userMetaDataId,false);
	
	  
	String name = XpoLogObjectTypes.getName(id,type);	  
	//audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	  			userContext, AuditConstants.CHANGE, "application change", AuditConstants.CONFIGURATION, "change application for " + name + " of type " + type);
	
	response.sendRedirect(BASE_DIRECTORY+"logEyePortal.jsp");
%>
