<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>
<%@ include file="../common/moduleTree.jsp"%>

<%
  String ERROR_OBJ = "ERROR_OBJ";
  ErrorModel errmodel = new ErrorModel();
  
  SiteManagment mgmt = SiteManagment.getInstance();
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  
  String isAdminStr = request.getParameter("IsAdmin");
  boolean isAdmin = isAdminStr !=  null && isAdminStr.equals("true");
	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	String userMetaDataId = request.getParameter("UserMetaDataId");
	MetaDataManager mdMgr = SiteManagment.getInstance().getMetaDataMgr();
  MetaDataCategoriesManager catMgr = MetaDataCategoriesManager.getInstance();
  MetaDataCategory applications = catMgr.getMetaDataCategory("applications");
  MetaDataCategory platforms = catMgr.getMetaDataCategory("platforms");
  MetaDataCategory operatingSystems = catMgr.getMetaDataCategory("os");
  MetaDataCategory vendors = catMgr.getMetaDataCategory("vendors");
  String baseDir = request.getParameter("baseDir");
  if (baseDir == null){
  	baseDir = "";
  }
  String name = "", desc = "", app = "", version = "", build = "";
  String platform = "", os = "", vendor = "", internalId = "";
  HashSet selPlatforms = null;
  HashSet selOs = null;
  MetaData systemMetaData = null, userMetaData = null;
  if (systemMetaDataId != null){
  	systemMetaData = mdMgr.getMetaData(systemMetaDataId,true);
  }else{
  	String metaDataAttr = request.getParameter("metaDataAttr");
  	if (metaDataAttr != null && metaDataAttr.length() > 0){
  		systemMetaData = (MetaData)request.getSession().getAttribute(metaDataAttr);
  	}
  	systemMetaDataId = "";
  }
  if (userMetaDataId != null){
  	userMetaData = mdMgr.getMetaData(userMetaDataId,false);
  }
  MetaData metaData = MetaDataManager.mergeMetaData(systemMetaData, userMetaData);
  HashSet nonPredefinedAttributes = null;
  int numberOfNonPredefinedAttributes = 0;
 	if (metaData != null){
 		name = metaData.getName();
 		desc = metaData.getDescription();
 		app = metaData.getApplication();
 		version = metaData.getVersion();
 		build = metaData.getBuild();
 		platform = metaData.getPlatform();
 		if (platform != null && platform.length() > 0){
 			selPlatforms = new HashSet();
 			String[] arr = platform.split(",");
 			for (int i=0; i<arr.length; i++){
 				selPlatforms.add(arr[i]);
 			}
 		}
 		os = metaData.getOs();
 		if (os != null && os.length() > 0){
 			selOs = new HashSet();
 			String[] arr = os.split(",");
 			for (int i=0; i<arr.length; i++){
 				selOs.add(arr[i]);
 			}
 		}
 		vendor = metaData.getVendor();
 		internalId = metaData.getInternalId();
 		nonPredefinedAttributes = metaData.getAllNonPredefinedAttributes();
 		if (nonPredefinedAttributes != null){
 			numberOfNonPredefinedAttributes = nonPredefinedAttributes.size();
 		}
 	}
 	if (metaData !=  null){
   	request.setAttribute("metaData",metaData);
 	}
  
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script  src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";
  
  function doSave(){
  	document.access.submit();
  }
  
  function showTextField(combo){
  	if (combo.options.multiple == false){
	  	if (combo.options[combo.options.selectedIndex].value == "other"){
	  		document.getElementById("New"+combo.name+"Div").style.display = "";
	  	}else{
	  		document.getElementById("New"+combo.name+"Div").style.display = "none";
	  	}
  	}else{
  		otherSelected = false;
  		for (var i=0; i<combo.length; i++){
  			if (combo.options[i].value == "other"){
  				if (combo.options[i].selected == true){
			  		document.getElementById("New"+combo.name+"Div").style.display = "";
  				}else{
			  		document.getElementById("New"+combo.name+"Div").style.display = "none";
  				}
  			}
  		}
  	}
  }
  
	function addNewProp(){
		document.getElementById("NewPropTableHeader").style.display = "";
		var ni = document.getElementById("newProps");
		var numi = document.getElementById("numberOfProps");
		var num = (document.getElementById("numberOfProps").value -1)+ 2;
		numi.value = num;
		var divIdName = "newProp"+num+"Div";
		var newdiv = document.createElement('div');
		newdiv.setAttribute("id",divIdName);
		//newdiv.innerHTML = "Element Number "+num+" has been added! <a href=\"javascript:;\" onclick=\"removeEvent(\'"+divIdName+"\')\">Remove the div &quot;"+divIdName+"&quot;</a>";
		newdiv.innerHTML = "<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">"+
                       "<tr><td width=\"20%\" valign=\"top\" nowrap><span class=\"REGULARTEXT\">"+
                       "<input type=\"text\" name=\"key_"+num+"\" id=\"key_"+num+"\" size=\"20\">"+
                       "</span></td>"+
                       "<td width=\"80%\">"+
	                     "<input type=\"text\" name=\"value_"+num+"\" id=\"value_"+num+"\" size=\"20\">"+
	                     "&nbsp;<span class=\"LINK\"><a href=\"javascript:;\" onclick=\"removeEvent(\'"+divIdName+"\')\">&nbsp;remove</a></link>"+
                       "</td></tr></table>";
		ni.appendChild(newdiv);
	}

	function removeEvent(divNum){
		var d = document.getElementById('newProps');
		var olddiv = document.getElementById(divNum);
		d.removeChild(olddiv);
		num = document.access.numberOfProps.value;
		if (!document.getElementById("newProp"+num+"Div")){
			document.getElementById("NewPropTableHeader").style.display = "none";
		}
	}


 var contextreq;
function addMenu(op,id){
  if (typeof XMLHttpRequest != "undefined") {
       contextreq = new XMLHttpRequest();
   } else if (window.ActiveXObject) {
       contextreq = new ActiveXObject("Microsoft.XMLHTTP");
   }
  var url = "<%=baseDir%>metaDataContextMenues.jsp?op=" + op + "&id=" + id;
   var contextSearchCol = eval("document.access.contextSearchCol0");
   for (var i = 0; contextSearchCol;){
     url = url + "&contextSearchCol" + i + "=" + contextSearchCol.value;
     url = url + "&contextSearchName" + i + "=" + escape(eval("document.access.contextSearchName" + i).value);
     url = url + "&contextSearchPath" + i + "=" + escape(eval("document.access.contextSearchPath" + i).value);
     i++;
     contextSearchCol = eval("document.access.contextSearchCol" + i);   
   }
   
   contextreq.open("POST",url, true);
   contextreq.onreadystatechange = addMenucallback;
   contextreq.send(null);
}

function addMenucallback() {
  if (contextreq.readyState == 4) {
    if (contextreq.status == 200) {
     
      var val = contextreq.responseText;
      if (!val){
        val = "";
      }     
      var td = document.getElementById("searchMenuesTD");
     
      if(td){
        td.innerHTML = val;
      }
      return;
    }
  }
}
</script>
</head>

<body>
<%if (isAdmin){%>
<form AUTOCOMPLETE="OFF" name="access" id="access" method="post" action="metaDataAdminAction.jsp">
<input type="hidden" name="UserMetaDataId" value="<%=userMetaDataId != null ? userMetaDataId : "" %>">
<input type="hidden" name="IsAdmin" value="true">
<input type="hidden" name="InternalId" value="<%=internalId%>">
<%}%>
<input type="hidden" value="<%=numberOfNonPredefinedAttributes%>" id="numberOfProps" name="numberOfProps"/>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
	          <%if (isAdmin){%>
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Application settings</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <%}%>
              <tr>
                <td colspan="3">
                <table border="0" cellpadding="0" cellspacing="0"  width="100%" id="AutoNumber3" height="53">
			          <%if (isAdmin){%>
                  <tr>
                    <td height="18"><span class="HEADER">General settings</span></td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Id</span></td>
                        <td width="80%">
                        <%
                        if (systemMetaDataId == null || systemMetaDataId.length() == 0){%>
                        <input type="text" name="SystemMetaDataId" class="TEXTBOX" size="30" value="<%=systemMetaDataId%>">
                        <%}else{%>
                        <span class="REGULARTEXT" style="height:20px"><b><%=systemMetaDataId%></b></span>
                        <input type="hidden" name="SystemMetaDataId" value="<%=systemMetaDataId%>">
                        <%}%>
                        </td>
                      </tr>
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Name</span></td>
                        <td width="80%"><input type="text" name="Name" class="TEXTBOX" size="30" value="<%=name%>">
                        </td>
                      </tr>
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Description</span></td>
                        <td width="80%"><input type="text" name="Description" class="TEXTBOX" size="30" value="<%=desc%>">
                        </td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                  	<td>&nbsp;</td>
                  </tr>
                  <%}%>
                  <tr>
                    <td width="15%" height="28"><span class="HEADER">Properties</span></td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Application</span></td>
                        <td width="80%">
                        	<%if (applications != null) {%>
	                        	<select name="Application" onchange="javascript:showTextField(this)">
	                        		<option value="">--- select ---</option>
	                        	<%
                        			List list = applications.getMembers(true);
                        			for (int i=0; i<list.size();i++){
                        				MetaDataCategory child = (MetaDataCategory)list.get(i);
                        				String indentation = "";
                        				for (int j=1; j<child.getLevel(); j++){
                        					indentation += "&nbsp;&nbsp;";
                        				}
                        				String selected = app != null && app.equals(child.getId()) ? " selected" : "";
                        		%>
                        			<option value="<%=child.getId()%>" <%=selected%>><%=indentation+child.getName()%></option>
	                        	<%}%>
	                        		<option value="other">other</option>
 		                        </select>
                        	<%}%>
                        		<span id="NewApplicationDiv" style="display:none">
 		                        <input type="text" name="NewApplication" value="" size="20">
 		                        <span class="REGULARTEXT">as child of: </span>
                        	<%if (applications != null) {%>
	                        	<select name="NewApplicationParent">
	                        		<option value="">--- select ---</option>
	                        	<%
                        			List list = applications.getMembers(true);
                        			for (int i=0; i<list.size();i++){
                        				MetaDataCategory child = (MetaDataCategory)list.get(i);
                        				String indentation = "";
                        				for (int j=1; j<child.getLevel(); j++){
                        					indentation += "&nbsp;";
                        				}
                        				String selected = app != null && app.equals(child.getId()) ? " selected" : "";
                        		%>
                        			<option value="<%=child.getId()%>" <%=selected%>><%=indentation+child.getName()%></option>
	                        	<%}%>
 		                        </select>
                        	<%}%>
 		                        </span>
                        </td>
                      </tr>
                      <tr><td><span style="font-size:2px">&nbsp;<span></td></tr>
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Version</span></td>
                        <td width="80%">
	                        <input type="text" name="Version" value="<%=version%>" size="20">
                        </td>
                      </tr>
                      <tr><td><span style="font-size:2px">&nbsp;<span></td></tr>
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Build</span></td>
                        <td width="80%">
	                        <input type="text" name="Build" value="<%=build%>" size="20">
                        </td>
                      </tr>
                      <tr><td><span style="font-size:2px">&nbsp;<span></td></tr>
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Platform</span></td>
                        <td width="80%">
                        	<%if (platforms != null) {%>
	                        	<select name="Platform" onchange="javascript:showTextField(this)" multiple size="5">
	                        	<%
                        			List list = platforms.getMembers(true);
                        			for (int i=0; i<list.size();i++){
                        				MetaDataCategory child = (MetaDataCategory)list.get(i);
                        				String selected = selPlatforms != null && selPlatforms.contains(child.getId()) ? " selected" : "";
                        		%>
                        			<option value="<%=child.getId()%>" <%=selected%>><%=child.getName()%></option>
	                        	<%}%>
	                        		<option value="other">other</option>
 		                        </select>
                        	<%}%>
                       			<span id="NewPlatformDiv" style="display:none">
		                        <input type="text" name="NewPlatform" value="" size="20">
		                        </span>
                        </td>
                      </tr>
                      <tr><td><span style="font-size:2px">&nbsp;<span></td></tr>
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Operating system</span></td>
                        <td width="80%">
                        	<%if (operatingSystems != null) {%>
	                        	<select name="Os" onchange="javascript:showTextField(this)" multiple size="5">
	                        	<%
                        			List list = operatingSystems.getMembers(true);
                        			for (int i=0; i<list.size();i++){
                        				MetaDataCategory child = (MetaDataCategory)list.get(i);
                        				String selected = selOs != null && selOs.contains(child.getId()) ? " selected" : "";
                        		%>
                        			<option value="<%=child.getId()%>" <%=selected%>><%=child.getName()%></option>
	                        	<%}%>
	                        		<option value="other">other</option>
 		                        </select>
                        	<%}%>
                       			<span id="NewOsDiv" style="display:none">
		                        <input type="text" name="NewOs" value="" size="20">
		                        </span>
                        </td>
                      </tr>
                      <tr><td><span style="font-size:2px">&nbsp;<span></td></tr>
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Vendor</span></td>
                        <td width="80%">
                        	<%if (vendors != null) {%>
	                        	<select name="Vendor" onchange="javascript:showTextField(this)">
	                        		<option value="">--- select ---</option>
	                        	<%
                        			List list = vendors.getMembers(true);
                        			for (int i=0; i<list.size();i++){
                        				MetaDataCategory child = (MetaDataCategory)list.get(i);
                        				String selected = vendor != null && vendor.equals(child.getId()) ? " selected" : "";
                        		%>
                        			<option value="<%=child.getId()%>" <%=selected%>><%=child.getName()%></option>
	                        	<%}%>
	                        		<option value="other">other</option>
 		                        </select>
                        	<%}%>
                       			<span id="NewVendorDiv" style="display:none">
 		                        <input type="text" name="NewVendor" value="" size="20">
		                        </span>
                        </td>
                      </tr>
                      <tr><td colspan="2">
                      <div id="newProps">
                      <%if (nonPredefinedAttributes != null){
	                      	Iterator it = nonPredefinedAttributes.iterator();
	                      	int i = 1;
	                      	while (it.hasNext()){
		                      	String key = (String)it.next();
		                      	String value = metaData.getValue(key);
                      %>
                      	<div id="newProp<%=i%>Div">
												<table border="0" width="100%" cellspacing="0" cellpadding="0">
		                      <tr><td><span style="font-size:2px">&nbsp;<span></td></tr>
													<tr>
														<td width="20%" valign="top" nowrap>
															<span class="REGULARTEXT"><%=key%></span>
															<input type="hidden" name="key_<%=i%>" id="key_<%=i%>" value="<%=key%>">
														</td>
														<td width="80%">
															<input type="text" name="value_<%=i%>" id="value_<%=i%>" value="<%=value%>" size="20">
															&nbsp;<span class="LINK"><a href="javascript:;" onclick="removeEvent('newProp<%=i%>Div')">&nbsp;remove</a>
														</td>
													</tr>
												</table>
												</div>
												<%
												i++;
												}
											}%>
												<table border="0" width="100%" cellspacing="0" cellpadding="0">
		                      <tr><td>&nbsp;</td></tr>
		                      <tr><td><a href="javascript:addNewProp()" class="LINK">add new property</a></td></tr>
													<tr>
														<td>
															<table id="NewPropTableHeader" border="0" width="100%" cellspacing="0" cellpadding="0" style="display:none">
					                      <tr><td colspan="2"><span style="font-size:2px">&nbsp;<span></td></tr>
																<tr>
																	<td width="20%" valign="top" bgcolor="#EEEEEE">
																		<span class="REGULARTEXT">&nbsp;type</span>
																	</td>
																	<td width="80%" valign="top" bgcolor="#EEEEEE">
																		<span class="REGULARTEXT">&nbsp;value</span>
																	</td>
																</tr>
					                      <tr><td colspan="2"><span style="font-size:2px">&nbsp;<span></td></tr>
															</table>
														</td>
													</tr>
												</table>
                      </div></td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                   <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
                   <tr>
                    <td><span class="HEADER">Search Context Menu</span></td>
                  </tr>  
                  
                  <tr>
                    <td id="searchMenuesTD">
                    <jsp:include page="metaDataContextMenues.jsp" flush="true"/>
                   
                  </td></tr>
                  
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <%if (isAdmin){%>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="35%">&nbsp;</td>
                <td width="11%" align="center"><a href="<%=BASE_DIRECTORY%>common/actions/cancelAction.jsp?forward=metadata/metaDataView.jsp" class="LINK">
                cancel</a></td>
                <td width="7%" align="center"><a href="javascript:doSave()" class="LINK">save</a></td>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
          <%}%>
        </table>
        </td>
      </tr>
      <!--
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      -->
    </table>
    </td>
  </tr>
</table>
<%if (isAdmin){%>
</form>
<%}%>
</body>

</html>