<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.main.MainViewModel"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.menu.*" %>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  MetaDataManager metaDataMgr = SiteManagment.getInstance().getMetaDataMgr();
  MetaDataCategoriesManager metaDataCatMgr = MetaDataCategoriesManager.getInstance();
  UserContext userContext = UserEnvironment.getUserContext(request);

  String ERROR_OBJ = "ERROR_OBJ";
  ErrorModel err = new ErrorModel();
  String isAdminStr = request.getParameter("IsAdmin");
  boolean isAdmin = isAdminStr !=  null && isAdminStr.equals("true");
	String redirectUrl = request.getParameter("redirectURL");
	String op = request.getParameter("OP");
	String removeAllMembersStr = request.getParameter("removeAllMembers");
	boolean removeAllMembers = removeAllMembersStr != null && removeAllMembersStr.equals("true");
	
	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	if (isAdmin && systemMetaDataId!= null && op != null && op.equals("delete")){
		metaDataMgr.removeMetaData(systemMetaDataId,true,removeAllMembers);
		MainViewModel model = env.getMainViewModel();
		model.verify();
		response.sendRedirect("metaDataView.jsp?isAdmin="+isAdmin+"&refreshMenus="+removeAllMembers);
		return;
	}
	
	String userMetaDataId = request.getParameter("UserMetaDataId");
  String name = request.getParameter("Name");
	if (isAdmin){
		if (systemMetaDataId == null || systemMetaDataId.length() == 0){
			err.addError("No id was entered");
		}
		if (name == null || name.length() == 0){
			err.addError("No name was entered");
		}
		if (err.getErrorCount() > 0){
			request.getSession().setAttribute(ERROR_OBJ,err);
			response.sendRedirect(BASE_DIRECTORY+"common/errorpage.jsp");
			return;
		}
	}
  
  String desc = request.getParameter("Description");
  String internalId = request.getParameter("InternalId");
  String app = request.getParameter("Application");
  boolean newApplication = false;
  String parentApplicationId = request.getParameter("NewApplicationParent");
  if (app == null || app.length() == 0 || app.equalsIgnoreCase("other")){
  	app = request.getParameter("NewApplication");
  	if (app != null && app.length() > 0){
	  	newApplication = true;
	  	if (parentApplicationId == null || parentApplicationId.length() == 0){
	  		parentApplicationId = "applications";
	  	}
  	}
  }
	String version = request.getParameter("Version");
	String build = request.getParameter("Build");
	String[] platformarr = request.getParameterValues("Platform");
	String platformstr = null;
	String newPlatformValue = null;
  boolean newPlatform = false;
  if (platformarr != null){
  	StringBuffer sb = new StringBuffer();
  	for (int i=0; i<platformarr.length; i++){
  		String platform = platformarr[i];
			if (platform == null || platform.length() == 0 || platform.equalsIgnoreCase("other")){
				platform = request.getParameter("NewPlatform");
		  	if (platform != null && platform.length() > 0){
		  		newPlatformValue = platform;
			  	newPlatform = true;
		  	}
			}
			if (i > 0){
				sb.append(",");
			}
			sb.append(platform);
  	}
  	if (sb.length() > 0){
  		platformstr = sb.toString();
  	}
  }
	String[] osarr = request.getParameterValues("Os");
	String osstr = null;
	String newOsValue = null;
  boolean newOs = false;
  if (osarr != null){
  	StringBuffer sb = new StringBuffer();
  	for (int i=0; i<osarr.length; i++){
  		String os = osarr[i];
			if (os == null || os.length() == 0 || os.equalsIgnoreCase("other")){
				os = request.getParameter("NewOs");
		  	if (os != null && os.length() > 0){
		  		newOsValue = os;
			  	newOs = true;
		  	}
			}
			if (i > 0){
				sb.append(",");
			}
			sb.append(os);
  	}
  	if (sb.length() > 0){
  		osstr = sb.toString();
  	}
  }
	String vendor = request.getParameter("Vendor");
  boolean newVendor = false;
	if (vendor == null || vendor.length() == 0 || vendor.equalsIgnoreCase("other")){
		vendor = request.getParameter("NewVendor");
  	if (vendor != null && vendor.length() > 0){
	  	newVendor = true;
  	}
	}
	String numPropsStr = request.getParameter("numberOfProps");
	int numProps = (numPropsStr == null || numPropsStr.length() == 0) ? 0 : Integer.parseInt(numPropsStr);
	Properties newProps = new Properties();
	String key,value;
	for (int i=1; i<=numProps; i++){
		key = request.getParameter("key_"+i);
		value = request.getParameter("value_"+i);
		if (key != null && value != null && key.length() > 0 && value.length() > 0){
			newProps.setProperty(key,value);
		}
	}

	if(err.getErrorCount() > 0){
    request.getSession().setAttribute(ERROR_OBJ,err);
    response.sendRedirect("errorpage.jsp");
    return;
  }
	
	if (newApplication && parentApplicationId != null && parentApplicationId.length() > 0){
		MetaDataCategory cat = new MetaDataCategory();
		cat.setName(app);
		app = WebUtil.doHTMLEncoding(app).toLowerCase();
		cat.setId(app);
		metaDataCatMgr.addMetaDataCategory(cat,parentApplicationId);
	}
	
	if (newPlatform){
		MetaDataCategory cat = new MetaDataCategory();
		cat.setName(newPlatformValue);
		newPlatformValue = WebUtil.doHTMLEncoding(newPlatformValue).toLowerCase();
		cat.setId(newPlatformValue);
		metaDataCatMgr.addMetaDataCategory(cat,"platforms");
	}
	
	if (newOs){
		MetaDataCategory cat = new MetaDataCategory();
		cat.setName(newOsValue);
		newOsValue = WebUtil.doHTMLEncoding(newOsValue).toLowerCase();
		cat.setId(newOsValue);
		metaDataCatMgr.addMetaDataCategory(cat,"os");
	}
	
	if (newVendor){
		MetaDataCategory cat = new MetaDataCategory();
		cat.setName(vendor);
		vendor = WebUtil.doHTMLEncoding(vendor).toLowerCase();
		cat.setId(vendor);
		metaDataCatMgr.addMetaDataCategory(cat,"vendors");
	}
	
	
	Properties prop = new Properties();
	if (app != null && app.length() > 0)
		prop.setProperty("application",app);
	if (version != null && version.length() > 0)
		prop.setProperty("version",version);
	if (build != null && build.length() > 0)
		prop.setProperty("build",build);
	if (platformstr != null && platformstr.length() > 0)
		prop.setProperty("platform",platformstr);
	if (osstr != null && osstr.length() > 0)
		prop.setProperty("os",osstr);
	if (vendor != null && vendor.length() > 0)
		prop.setProperty("vendor",vendor);
	Iterator it = newProps.keySet().iterator();
	while (it.hasNext()){
		key = (String)it.next();
		value = newProps.getProperty(key);
		prop.setProperty(key,value);
	}
	
	MetaData systemMetaData = null;
	MetaData userMetaData = null;
	if (systemMetaDataId != null && systemMetaDataId.length() > 0){
		systemMetaData = metaDataMgr.getMetaData(systemMetaDataId);
		String intId = null;
		if (systemMetaData != null){
			intId = systemMetaData.getInternalId();
			if (internalId != null && !internalId.equals(intId)){
				err.addError("There is already a application with the given id");
				err.addError("Please enter another id");
				request.getSession().setAttribute(ERROR_OBJ,err);
				response.sendRedirect(BASE_DIRECTORY+"common/errorpage.jsp");
				return;
			}
		}
	}
	
	int count = 0;
  int total = 0;
  PopupMenues menues = new PopupMenues();

  if (menues != null){
    PopupMenu menu = menues.getPopupById("logDataCM");
    String col = request.getParameter("contextSearchCol0");
    boolean clearSearchItem = true;
    while (col != null && col.length() > 0){
  	  String menuname = request.getParameter("contextSearchName" + count);
      String path = request.getParameter("contextSearchPath" + count);
      if (menuname == null || menuname.length() == 0 || path == null || path.length() == 0){
    	  count++;
    	  col = request.getParameter("contextSearchCol" + count);
    	  continue;
      }
    
      MenuItem item = new MenuItem();
      item.id = "metaSearch" + systemMetaDataId  + total++;
      item.name = menuname;
      item.link = path;
    	item.target = "_new";
    	item.componentsMask = MenuItem.ALL_MASK;
    	
    	MenuGroup group = new MenuGroup();
    	if (menu == null){
      	menu = new PopupMenu();
      	menu.setPopupId("logDataCM");
      	group.id = "search";
      	group.name = "Search";
      	group.componentsMask = MenuItem.ALL_MASK;
      	menu.addItem(group);
    	}else {
    		group = (MenuGroup)menu.getItem("search");
    	}
      if (clearSearchItem){
      	group.items.clear();
      	clearSearchItem = false;
      }
    	if (group != null){
    		group.items.add(item);
    	}
    
  		count++;
  		col = request.getParameter("contextSearchCol" + count);
  	}
  	menues.removePopupMenu("logDataCM");
   	if (menu != null){
  		 menues.addPopup(menu);
   	}
  }
  
	if (isAdmin){
		if (systemMetaData == null){
			systemMetaData = new MetaData();
			systemMetaData.setId(systemMetaDataId);
			long intId = System.currentTimeMillis();
			systemMetaData.setInternalId(String.valueOf(intId));
		}
		if (systemMetaData.getPermissions() == null){
			systemMetaData.setPermissions((ModuleMemberPermissions)metaDataMgr.getDefaultPermissions().clone());
		}
		systemMetaData.setName(name);
		systemMetaData.setDescription(desc);
		systemMetaData.setSystemMetaData(true);
		systemMetaData.setProperties(prop);
		systemMetaData.setPopupMenues(menues);
		metaDataMgr.saveMetaData(systemMetaData);
	}
	
	boolean systemMetaDataOverwritten = false;
	if (!isAdmin && systemMetaData != null){
		Properties systemMdProps = systemMetaData.getProperties();
		systemMetaDataOverwritten = !MetaData.sameProperties(systemMdProps,prop);
	}
	if (userMetaDataId != null && userMetaDataId.length() > 0){
		if (systemMetaDataOverwritten && prop != null && !prop.isEmpty()){
			userMetaData = new MetaData();
			userMetaData.setId(userMetaDataId);
			userMetaData.setName(userMetaDataId);
			userMetaData.setProperties(prop);
			userMetaData.setSystemMetaData(false);
			long intId = System.currentTimeMillis();
			userMetaData.setInternalId(String.valueOf(intId));
			metaDataMgr.saveMetaData(userMetaData);
		}else{
			metaDataMgr.removeMetaData(userMetaDataId,false,false);
		}
	}

	
	  //audit
	  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	  			userContext, AuditConstants.CHANGE, "edit/save application", AuditConstants.CONFIGURATION, "change application " + name);
	if (redirectUrl == null || redirectUrl.length() == 0){
		response.sendRedirect(BASE_DIRECTORY+"metadata/metaDataView.jsp");
	}else{
		response.sendRedirect(BASE_DIRECTORY+redirectUrl);
	}
%>