<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%!
public MetaData createMetaDatas(HttpServletRequest request,HttpServletResponse response, boolean doSave) throws Exception {
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  MetaDataManager metaDataMgr = SiteManagment.getInstance().getMetaDataMgr();
  MetaDataCategoriesManager metaDataCatMgr = MetaDataCategoriesManager.getInstance();
  UserContext userContext = UserEnvironment.getUserContext(request);

  String ERROR_OBJ = "ERROR_OBJ";
  ErrorModel err = new ErrorModel();
  String isAdminStr = request.getParameter("IsAdmin");
  boolean isAdmin = isAdminStr !=  null && isAdminStr.equals("true");
	String redirectUrl = request.getParameter("redirectURL");
	String op = request.getParameter("OP");

	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	
	String userMetaDataId = request.getParameter("UserMetaDataId");
  String name = request.getParameter("Name");
	if (isAdmin){
		if (systemMetaDataId == null || systemMetaDataId.length() == 0){
			err.addError("No id was entered");
			throw new Exception("Missing application id");
		}
		if (name == null || name.length() == 0){
			err.addError("No name was entered");
			throw new Exception("Missing application name");
		}
	}
  
  String desc = request.getParameter("Description");
  String internalId = request.getParameter("InternalId");
  String app = request.getParameter("Application");
  boolean newApplication = false;
  String parentApplicationId = request.getParameter("NewApplicationParent");
  if (app == null || app.length() == 0 || app.equalsIgnoreCase("other")){
  	app = request.getParameter("NewApplication");
  	if (app != null && app.length() > 0){
	  	newApplication = true;
	  	if (parentApplicationId == null || parentApplicationId.length() == 0){
	  		parentApplicationId = "applications";
	  	}
  	}
  }
	String version = request.getParameter("Version");
	String build = request.getParameter("Build");
	String[] platformarr = request.getParameterValues("Platform");
	String platformstr = null;
	String newPlatformValue = null;
  boolean newPlatform = false;
  if (platformarr != null){
  	StringBuffer sb = new StringBuffer();
  	for (int i=0; i<platformarr.length; i++){
  		String platform = platformarr[i];
			if (platform == null || platform.length() == 0 || platform.equalsIgnoreCase("other")){
				platform = request.getParameter("NewPlatform");
		  	if (platform != null && platform.length() > 0){
		  		newPlatformValue = platform;
			  	newPlatform = true;
		  	}
			}
			if (i > 0){
				sb.append(",");
			}
			sb.append(platform);
  	}
  	if (sb.length() > 0){
  		platformstr = sb.toString();
  	}
  }
	String[] osarr = request.getParameterValues("Os");
	String osstr = null;
	String newOsValue = null;
  boolean newOs = false;
  if (osarr != null){
  	StringBuffer sb = new StringBuffer();
  	for (int i=0; i<osarr.length; i++){
  		String os = osarr[i];
			if (os == null || os.length() == 0 || os.equalsIgnoreCase("other")){
				os = request.getParameter("NewOs");
		  	if (os != null && os.length() > 0){
		  		newOsValue = os;
			  	newOs = true;
		  	}
			}
			if (i > 0){
				sb.append(",");
			}
			sb.append(os);
  	}
  	if (sb.length() > 0){
  		osstr = sb.toString();
  	}
  }
	String vendor = request.getParameter("Vendor");
  boolean newVendor = false;
	if (vendor == null || vendor.length() == 0 || vendor.equalsIgnoreCase("other")){
		vendor = request.getParameter("NewVendor");
  	if (vendor != null && vendor.length() > 0){
	  	newVendor = true;
  	}
	}
	String numPropsStr = request.getParameter("numberOfProps");
	int numProps = (numPropsStr == null || numPropsStr.length() == 0) ? 0 : Integer.parseInt(numPropsStr);
	Properties newProps = new Properties();
	String key,value;
	for (int i=1; i<=numProps; i++){
		key = request.getParameter("key_"+i);
		value = request.getParameter("value_"+i);
		if (key != null && value != null && key.length() > 0 && value.length() > 0){
			newProps.setProperty(key,value);
		}
	}

	if (newApplication && parentApplicationId != null && parentApplicationId.length() > 0){
		MetaDataCategory cat = new MetaDataCategory();
		cat.setName(app);
		app = WebUtil.doHTMLEncoding(app).toLowerCase();
		cat.setId(app);
		metaDataCatMgr.addMetaDataCategory(cat,parentApplicationId);
	}
	
	if (newPlatform){
		MetaDataCategory cat = new MetaDataCategory();
		cat.setName(newPlatformValue);
		newPlatformValue = WebUtil.doHTMLEncoding(newPlatformValue).toLowerCase();
		cat.setId(newPlatformValue);
		metaDataCatMgr.addMetaDataCategory(cat,"platforms");
	}
	
	if (newOs){
		MetaDataCategory cat = new MetaDataCategory();
		cat.setName(newOsValue);
		newOsValue = WebUtil.doHTMLEncoding(newOsValue).toLowerCase();
		cat.setId(newOsValue);
		metaDataCatMgr.addMetaDataCategory(cat,"os");
	}
	
	if (newVendor){
		MetaDataCategory cat = new MetaDataCategory();
		cat.setName(vendor);
		vendor = WebUtil.doHTMLEncoding(vendor).toLowerCase();
		cat.setId(vendor);
		metaDataCatMgr.addMetaDataCategory(cat,"vendors");
	}
	
	
	Properties prop = new Properties();
	if (app != null && app.length() > 0)
		prop.setProperty("application",app);
	if (version != null && version.length() > 0)
		prop.setProperty("version",version);
	if (build != null && build.length() > 0)
		prop.setProperty("build",build);
	if (platformstr != null && platformstr.length() > 0)
		prop.setProperty("platform",platformstr);
	if (osstr != null && osstr.length() > 0)
		prop.setProperty("os",osstr);
	if (vendor != null && vendor.length() > 0)
		prop.setProperty("vendor",vendor);
	Iterator it = newProps.keySet().iterator();
	while (it.hasNext()){
		key = (String)it.next();
		value = newProps.getProperty(key);
		prop.setProperty(key,value);
	}
	
	MetaData systemMetaData = null;
	MetaData userMetaData = null;
	if (systemMetaDataId != null && systemMetaDataId.length() > 0){
		systemMetaData = metaDataMgr.getMetaData(systemMetaDataId);
		String intId = null;
		if (systemMetaData != null){
			intId = systemMetaData.getInternalId();
			if (internalId != null && !internalId.equals(intId)){
				err.addError("There is already a application with the given id");
				err.addError("Please enter another id");
				request.getSession().setAttribute(ERROR_OBJ,err);
				throw new Exception("There is already a application with the given id. Please enter a different one");
			}
		}
	}
	if (isAdmin){
		if (systemMetaData == null){
			systemMetaData = new MetaData();
			systemMetaData.setId(systemMetaDataId);
			long intId = System.currentTimeMillis();
			systemMetaData.setInternalId(String.valueOf(intId));
		}
		systemMetaData.setName(name);
		systemMetaData.setDescription(desc);
		systemMetaData.setSystemMetaData(true);
		systemMetaData.setProperties(prop);
		metaDataMgr.saveMetaData(systemMetaData);
	}
	
	boolean systemMetaDataOverwritten = false;
	if (!isAdmin && systemMetaData != null){
		Properties systemMdProps = systemMetaData.getProperties();
		systemMetaDataOverwritten = !MetaData.sameProperties(systemMdProps,prop);
	}
	if (userMetaDataId != null && userMetaDataId.length() > 0){
		if (systemMetaDataOverwritten && prop != null && !prop.isEmpty()){
			userMetaData = new MetaData();
			userMetaData.setId(userMetaDataId);
			userMetaData.setName(userMetaDataId);
			userMetaData.setProperties(prop);
			userMetaData.setSystemMetaData(false);
			long intId = System.currentTimeMillis();
			userMetaData.setInternalId(String.valueOf(intId));
			metaDataMgr.saveMetaData(userMetaData);
		}else{
			metaDataMgr.removeMetaData(userMetaDataId,false,false);
		}
	}
	
	MetaData result = metaDataMgr.mergeMetaData(systemMetaData,userMetaData);
	return result;
	
}
%>