<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.widgets.XpoLogWidgetsManager"%>
<%@ page import="xpolog.eye.site.widgets.view.WidgetsView"%>

<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY = "../";
%>
     
<%
  String ERROR_OBJ = "ERROR_OBJ";
  
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.AutomationPermissions.VIEW_TASK_PERMISSION,true)){
	  return;
	}

	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	UserContext userContext = UserEnvironment.getUserContext(request);
	MetaDataManager metaDataMgr = mgmt.getMetaDataMgr();

	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	ErrorModel errmodel = new ErrorModel(); 

	XpoLogWidgetsManager xpologWidgetsMgr = XpoLogWidgetsManager.getIntsance();
	WidgetsView[] dashboards = xpologWidgetsMgr.getWidgetsViewList(userContext,WidgetsView.PORTAL_VIEW_TYPE);

	HashSet metaDataDashboards = new HashSet();
  String[] dashboardsIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,XpoLogObjectTypes.WIDGET_TYPE);
  if (dashboardsIds == null){
  	dashboardsIds = new String[0];
  }
	for (int i=0; i<dashboardsIds.length; i++){
		metaDataDashboards.add(dashboardsIds [i]);
	}
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";
  function checkDashboards(){
	  if(document.access.checkedAllDashboards.checked == true){
	  	for (var i=0; i<<%=dashboards.length%>; i++){
  			document.access.dashboards<%=dashboards.length > 1 ? "[i]" : ""%>.checked = true;
	  	}  	
	  }else{
	  	for (var i=0; i<<%=dashboards.length%>; i++){
  			document.access.dashboards<%=dashboards.length > 1 ? "[i]" : ""%>.checked = false;
  		}
	  }
  }
  
</script>
</head>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="15%" height="28" colspan="3"><span class="HEADER">XpoLog Dashboards</span></td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <%for(int i=0;i<dashboards.length;++i) {
              	  String checked = "";
              	  WidgetsView dashboard = dashboards[i];
              	  String type = dashboard.getType();
              	  String desc = "";
              	  if(metaDataDashboards.contains(dashboard.getId())) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }	
              %>
							<tr>
								<td colspan="3"><input type="checkbox" id="<%=dashboard.getId()%>" name="dashboards" value="<%=dashboard.getId()%>" <%=checked%>><span class="REGULARTEXT"><%=dashboard.getName()%><span class="SMALLTEXT"><%=desc%></span></span></td>
							</tr> 
              <%}%>
              <%if(dashboards != null && dashboards.length > 1) { %>
							<tr><td>&nbsp;</td></tr>  
							<tr class="TABLES_HEADERS">
								<td colspan="3"><input name="checkedAllDashboards" type="checkbox" onClick="checkDashboards()"><span class="REGULARTEXT"><b>Check All</b></span></td>
							</tr>
							<%} %>
          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		