<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>

<%! 
	static final String BASE_DIRECTORY = "../";
%>

<%
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  MetaDataManager metaDataMgr = mgmt.getMetaDataMgr();

  //UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
  
	String systemMetaDataId = request.getParameter("SystemMetaDataId");
  
  boolean execute = false;
  boolean showResultsPerPage = false;

	HashMap logsMap = null;
	HashMap modulesMap = null;
  String[] logsIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,"Log");
  String[] modulesIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,"Module");
  if (logsIds != null){
  	logsMap = new HashMap();
  	for (int i=0; i<logsIds.length; i++){
  		logsMap.put(logsIds[i],logsIds[i]);
  	}
  }
  if (modulesIds != null){
  	modulesMap = new HashMap();
  	for (int i=0; i<modulesIds.length; i++){
  		modulesMap.put(modulesIds[i],modulesIds[i]);
  	}
  }
  
  String listTitle = "Logs hierarchy";
  String listDesc = "Select and save the folders and logs to be associated with the application.<br>";
  String listNote = "";
%>

<script  src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";
</script>

<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse;padding-left:5;padding-top:5;" width="100%" id="AutoNumber3" height="53">                  
  <tr>
    <td width="15%" height="18"><span class="HEADER"><%=listTitle%></span><b>&nbsp;</b></td>
  </tr>
  <tr>
    <td>
       <span class="REGULARTEXT"><%=listDesc%></span>
       <span class="SMALLTEXT"><%=listNote%></span>
   </td>
	</tr>
	<tr>
		<td valign="top">
			<div id="loadingDiv" style="display:none">
				<span class="REGULARTEXT">Loading...</span>
			</div>
		</td>
	</tr>
	<tr>
		<td width="15%">
		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
			<tr>
				<td valign="top">
					<div id="treeboxbox_tree"></div>
				</td>
			</tr>
		</table>
		</td>
	</tr> 
  <tr>
    <td height="100%">&nbsp;</td>
  </tr>                 
</table>
                
<script>
	tree1=new dhtmlXTreeObject("treeboxbox_tree","100%","100%","0");
	tree1.enableTreeLines(false);
	tree1.setOnLoadingStart(startLoading);
	tree1.setOnLoadingEnd(endLoading);
	tree1.setImagePath("<%=BASE_DIRECTORY%>");
	tree1.setIconSize(13,13);
	tree1.enableCheckBoxes(1);
	tree1.enableThreeStateCheckboxes(true);
	tree1.setXMLAutoLoading("metaDataModuleTreeXML.jsp");
	tree1.loadXML("metaDataModuleTreeXML.jsp?SystemMetaDataId=<%=systemMetaDataId%>");
</script>
                