<%@page import="xpolog.eye.util.VerifierRenderer"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.meta.*"%>

<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>
<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.EXPORT_MODULE_PERMISSION,true)){
    return;
  }

  String ERROR_OBJ = "ERROR_OBJ";

	String systemMetaDataId = request.getParameter("SystemMetaDataId");

	//site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
	MetaDataManager mdMgr = mgmt.getMetaDataMgr();
  MetaData metaData = null;
  if (systemMetaDataId != null){
    metaData = mdMgr.getMetaData(systemMetaDataId,true);
  }
  if (metaData == null){
  	ErrorModel errmodel = new ErrorModel();
  	errmodel.addError("Failed to get application "+systemMetaDataId);
  	response.sendRedirect(BASE_DIRECTORY+"common/errorpage.jsp?okURL=metadata/metaDataView.jsp");
  	return;
  }

  ErrorModel errmodel = new ErrorModel(); 

  String [] types = {"accounts","reports","usertemplates","systemplates","wizards","tasks",
  		"schedulers","xplgnodes","configimages","envvariables","metadatas","transactions","dashboards"};
  String [] values = null;

  mdMgr.clearMetaDataMapping(systemMetaDataId,true);

  for (int t=0; t<types.length; t++){
		values = request.getParameterValues(types[t]);
		String v,type,id;
		int index;
	  if (values != null){
	    for (int i = 0; i < values.length; i++){
	    	v = values[i];
	    	index = v.indexOf(",");
	    	if (index == -1 || index == v.length()-1){
	    		continue;
	    	}
	    	type = v.substring(0,index);
	    	if (type != null && type.indexOf("tempaltes") != -1){
	    		type = "templates";
	    	}
	    	id = v.substring(index+1);
	    	mdMgr.addXplgObjMetaData(type,id,systemMetaDataId,true,false);
	    }
	  }
	}
  
  //Modules and logs
	HashMap logs = new HashMap();
  HashMap mods = new HashMap();
  HashMap allMods = new HashMap();
  String [] logsArr = null;
 	String logsList = request.getParameter("logs");
 	if (logsList != null && logsList.length() > 0){
 		logsArr = logsList.split(",");
 	}
  if (logsArr != null){
    for (int i = 0;i< logsArr.length;i++){
  	 logs.put(logsArr[i],logsArr[i]);
    }
  }

  String [] modsArr = null;
  String modsList = request.getParameter("mods");
  if (modsList != null && modsList.length() > 0){
  	modsArr = modsList.split(",");
  }
  if (modsArr != null){
    for (int i = 0;i< modsArr.length;i++){
     mods.put(modsArr[i],modsArr[i]);
    }
  }
//add the chosen ver and multiVer to congImg according to api
	HashMap verifiers = new HashMap();
	HashMap multiVerifiers = new HashMap();
	
	String [] verifiersArr = null;
		String verifiersList = request.getParameter("verifiers");
		if (verifiersList != null && verifiersList.length() > 0){
			verifiersArr = verifiersList.split(",");
		}
	if (verifiersArr != null){
	  for (int i = 0;i< verifiersArr.length;i++){
	    verifiers.put(verifiersArr[i],verifiersArr[i]);
	  }
	}
	
	String [] multiVerifiersArr = null;
	String multiVerifiersList = request.getParameter("multiVerifiers");
	if (multiVerifiersList != null && multiVerifiersList.length() > 0){
		multiVerifiersArr = multiVerifiersList.split(",");
	}
	if (multiVerifiersArr != null){
	  for (int i = 0;i< multiVerifiersArr.length;i++){
	  	if (!multiVerifiersArr[i].endsWith("*")){
	    	multiVerifiers.put(multiVerifiersArr[i],multiVerifiersArr[i]);
	  	}
	  }
	}
	if (multiVerifiersArr != null){
	  for (int i = 0;i< multiVerifiersArr.length;i++){
	  	String id = multiVerifiersArr[i];
	  	if (multiVerifiersArr[i].endsWith("*")){
	   		id = id.substring(0,id.length()-1);
	   		VerifierRenderer.addAllMultiVerifierChildren(id,multiVerifiers,verifiers); 
	   	}
	    multiVerifiers.put(id,id);
	  }
	}
	verifiers.putAll(multiVerifiers);
	HashMap visitedVerifiers =	VerifierRenderer.addAllVerParents(verifiers);

	
//	builder.setVisitedVerMap(visitedVerifiers);
//	builder.setVerifiersMap(verifiers);

  
  //workspace tree
  	HashMap workspaces = new HashMap();
		HashMap projects = new HashMap();
		HashMap transactions = new HashMap();

		String [] transArr = null;
		String transList = request.getParameter("projectTransactions");
		if (transList != null && transList.length() > 0){
			transArr = transList.split(",");
		}
		if (transArr != null){
			for (int i = 0;i< transArr.length;i++){
				transactions.put(transArr[i],transArr[i]);
			}	
		}

		String [] projectsArr = null;
		String projectsList = request.getParameter("projects");
		if (projectsList != null && projectsList.length() > 0){
			projectsArr = projectsList.split(",");
		}
		if (projectsArr != null){
			for (int i = 0;i< projectsArr.length;i++){
					projects.put(projectsArr[i],projectsArr[i]);				
			}
		}
		String [] workspacesArr = null;
		String workspacesList = request.getParameter("workspaces");
		if (workspacesList != null && workspacesList.length() > 0){
			workspacesArr = workspacesList.split(",");
		}
		if (workspacesArr != null){
			for (int i = 0;i< workspacesArr.length;i++){
				workspaces.put(workspacesArr[i],workspacesArr[i]);
			}
		}
  

  Iterator it = logs.keySet().iterator();
  String type = XpoLogObjectTypes.LOG_TYPE;
  String id = null;
  while (it.hasNext()){
  	id = (String)it.next();
  	mdMgr.addXplgObjMetaData(type,id,systemMetaDataId,true,false);
  }
  it = mods.keySet().iterator();
  type = XpoLogObjectTypes.MODULE_TYPE;
  while (it.hasNext()){
  	id = (String)it.next();
  	mdMgr.addXplgObjMetaData(type,id,systemMetaDataId,true,false);
  }
  
  it = verifiers.keySet().iterator();
  type = XpoLogObjectTypes.VERIFIER_TYPE;
  while (it.hasNext()){
  	id = (String)it.next();
  	mdMgr.addXplgObjMetaData(type,id,systemMetaDataId,true,false);
  }
  
  it = transactions.keySet().iterator();
  type = XpoLogObjectTypes.TRANSACTION_TYPE;
  id = null;
  HashMap projectsTransMap = new HashMap();
  HashMap tmp = new HashMap();
  while (it.hasNext()){
  	id = (String)it.next();
  	int ind = id.indexOf("@");
  	if (ind != -1){
  		String projId = id.substring(0,ind);
  		id = id.substring(ind+1);
  		String transChilds = (String)projectsTransMap.get(projId);
  		if(transChilds == null || transChilds.length() == 0){
  			transChilds = type + "-" + id;
  		}else{
  			transChilds += "," + type + "-" + id;
  		}
  		projectsTransMap.put(projId,transChilds);
  	}
  	tmp.put(id,id);
  }
  transactions = tmp;
 
  
  it = workspaces.keySet().iterator();
  type = XpoLogObjectTypes.WORKSAPCE_TYPE;
  id = null;
  while (it.hasNext()){
  	id = (String)it.next();
  	mdMgr.addXplgObjMetaData(type,id,systemMetaDataId,true,false);
  }
  
  it = projects.keySet().iterator();
  type = XpoLogObjectTypes.PROJECT_TYPE;
  id = null;
  while (it.hasNext()){
  	id = (String)it.next();
  	mdMgr.addXplgObjMetaData(type,id,systemMetaDataId,true,false);
  }

  it = projectsTransMap.keySet().iterator();
  type = XpoLogObjectTypes.PROJECT_TYPE;
  id = null;
  while (it.hasNext()){
  	id = (String)it.next();
		String projChilds = (String)projectsTransMap.get(id);
		if(projChilds != null && projChilds.length() > 0){
			mdMgr.setMetaDataObjectsChildrens(systemMetaDataId,type+"-"+id,projChilds);
		}
  	mdMgr.addXplgObjMetaData(type,id,systemMetaDataId,true,false);
  }

  
  it = transactions.keySet().iterator();
  type = XpoLogObjectTypes.TRANSACTION_TYPE;
  id = null;
  while (it.hasNext()){
  	id = (String)it.next();
  	int indx = id.indexOf("#");
  	if(indx > 0){
  		id = id.substring(0,indx);
  	}
  	mdMgr.addXplgObjMetaData(type,id,systemMetaDataId,true,false);
  }

 
	mdMgr.saveMetaDataRepository();

	if(errmodel.getErrorCount() != 0){
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
	}
	
	response.sendRedirect("metaDataView.jsp");
	
%>
