<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>

<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY = "../";
%>
     
<%
  String ERROR_OBJ = "ERROR_OBJ";
  
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.AutomationPermissions.VIEW_TASK_PERMISSION,true)){
	  return;
	}

	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	UserContext userContext = UserEnvironment.getUserContext(request);
	MetaDataManager metaDataMgr = mgmt.getMetaDataMgr();

	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	ErrorModel errmodel = new ErrorModel(); 

  XpoTaskManager taskmgr = XpoTaskManager.getInstance();
  List list = taskmgr.getXpoTasksByFilter(null,userContext);

	HashSet metaDataTasks = new HashSet();
  String[] tasksIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,XpoLogObjectTypes.TASK_TYPE);
	if (tasksIds != null){
		for (int i=0; i<tasksIds.length; i++){
			metaDataTasks.add(tasksIds[i]);
		}
	}
  boolean isReportViewer = manager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION);
  boolean txExpoViewer = mgmt.getXpologManagment().isTransactionExpoValid();
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";
  function checkTasks(){
	  if(document.access.checkedAllTasks.checked == true){
	  	for (var i=0; i<<%=list.size()%>; i++){
  			document.access.tasks<%=list.size() > 1 ? "[i]" : ""%>.checked = true;
	  	}  	
	  }else{
	  	for (var i=0; i<<%=list.size()%>; i++){
  			document.access.tasks<%=list.size() > 1 ? "[i]" : ""%>.checked = false;
  		}
	  }
  }
  
</script>
</head>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="15%" height="28" colspan="3"><span class="HEADER">XpoLog Tasks</span></td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <%for(int i=0;i<list.size();++i) {
              	  String checked = "";
              	  XpoTask task = (XpoTask)list.get(i);
              	  String type = task.getType();
              	  String desc = task.getDescription() != null && task.getDescription().length() > 0 ? " - (" + task.getDescription() + ")" : "";
                	if (type != null && ((!isReportViewer && type.equals("reports"))) ||
                			(!txExpoViewer && type.equals("sessionResult"))){
                		continue;
                	}
              	  if(metaDataTasks.contains(task.getId())) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }	
              %>
							<tr>
								<td colspan="3"><input type="checkbox" id="<%=XpoLogObjectTypes.TASK_TYPE%>,<%=task.getId()%>" name="tasks" value="<%=XpoLogObjectTypes.TASK_TYPE%>,<%=task.getId()%>" <%=checked%>><span class="REGULARTEXT"><%=task.getName()%><span class="SMALLTEXT"><%=desc%></span></span></td>
							</tr> 
              <%}%>
              <%if(list.size() > 1) { %>
							<tr><td>&nbsp;</td></tr>  
							<tr class="TABLES_HEADERS">
								<td colspan="3"><input name="checkedAllTasks" type="checkbox" onClick="checkTasks()"><span class="REGULARTEXT"><b>Check All</b></span></td>
							</tr>
							<%} %>
          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		