<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	UserSecurity user = manager.getUserSecurity(request);
	UserContext userContext = UserEnvironment.getUserContext(request);
	MetaDataManager metaDataMgr = SiteManagment.getInstance().getMetaDataMgr();
	MetaData[] systemMetaDatas = metaDataMgr.getAllSystemMetaDatas(userContext);
	
	String refreshMenusStr = request.getParameter("refreshMenus");
	boolean refreshMenus = refreshMenusStr != null && refreshMenusStr.equals("true");
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>

</head>
<body <%=refreshMenus ? "onload=\"javascript:refreshMenus()\"" : "" %>">
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Applications List</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="73%">&nbsp;</td>
              </tr>
							<tr>
                <td width="3%">&nbsp;</td>
								<td width="24%"><a href="metaDataAdmin.jsp?IsAdmin=true" class="LINK">add new</a></td>
								<td width="73%"></td>
							</tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="97%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr class="TABLES_HEADERS">
                        <td width="30%"><span class="REGULARTEXT">Name</span></td>
                        <td width="*"><span class="REGULARTEXT">Description</span></td>
                        <td width="350">&nbsp;</td>
                      </tr>
                      <%for (int i = 0; i < systemMetaDatas.length; i++){
                      	MetaData md = systemMetaDatas[i];
												boolean allowEdit = (user == null || user.isEditable(md.getPermissions()));
												if (user != null && !user.isVisible(md.getPermissions())) {
													continue;
												}
                      %>
                      <tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">                      
								  			<td width="300">
												<%if (allowEdit){%>
												<a href="metaDataAdmin.jsp?SystemMetaDataId=<%=md.getId()%>&IsAdmin=true" class="LINK"><%=md.getName()%></a>
												<%}else{%>
												<a class="EMPTYLINK"><%=md.getName()%></a>
												<%}%>
								  			</td>
                        <td width="*"><span class="REGULARTEXT"><%=md.getDescription()%></span></td>
												<td width="350" class="SMALLTEXT" nowrap>&nbsp;
												<%if(allowEdit){ %>
													<a href="metaDataAdmin.jsp?SystemMetaDataId=<%=md.getId()%>&IsAdmin=true" class="LINK">edit</a>&nbsp;&nbsp;
													<a href="metaDataRemoveCheck.jsp?metaDataId=<%=md.getId()%>" class="LINK">delete</a>&nbsp;&nbsp;
													<a href="metaDataObjectsAdmin.jsp?SystemMetaDataId=<%=md.getId()%>" class="LINK">members</a>&nbsp;&nbsp;
													<%if (user != null) {%> 
														<a href="perm/metaDataPermissions.jsp?id=<%=md.getId()%>" class="LINK">permissions</a>&nbsp;
													<%}%>
												<%}%>
												</td>
                      </tr>
                      <%}%>
                    </table>
                   </td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="35%">&nbsp;</td>
                    <td width="91"><a href="javascript:history.go(-1)" class="LINK">&nbsp;</a></td>
                    <td width="13%" align="center"><a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK">ok</a></td>
                    <td width="5%" align="center"></td>
                    <td width="27%">&nbsp;</td>
                    <td width="20%">&nbsp;</td>
                  </tr>
                </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>