<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY = "../";
%>
     
<%
  String ERROR_OBJ = "ERROR_OBJ";
  
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION,true)){
	  return;
	}
  
  //site management
	SiteManagment mgmt = SiteManagment.getInstance();
	UserContext userContext = UserEnvironment.getUserContext(request);
	MetaDataManager metaDataMgr = mgmt.getMetaDataMgr();

	String systemMetaDataId = request.getParameter("SystemMetaDataId");
	ErrorModel errmodel = new ErrorModel(); 

  WizardManager wmg = mgmt.getWizardManager(xpolog.eye.site.SiteUtil.getBaseDirectory(request));
  WizardInfo[] wsysarr = wmg.getAllSystemWizards(userContext);
  WizardInfo[] wusrarr =  wmg.getAllUserWizards(userContext);

	HashSet metaDataWizards = new HashSet();
  String[] wizardsIds = metaDataMgr.getXplgObjectIdsByMetaDataAndType(systemMetaDataId,XpoLogObjectTypes.WIZARD_TYPE);
	if (wizardsIds != null){
		for (int i=0; i<wizardsIds.length; i++){
			metaDataWizards.add(wizardsIds[i]);
		}
	}
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";
  function checkWizards(){
	  if(document.access.checkedAllWizards.checked == true){
	  	for (var i=0; i<<%=wsysarr.length%>; i++){
  			document.access.wizards<%=wsysarr.length > 1 ? "[i]" : ""%>.checked = true;
	  	}  	
	  }else{
	  	for (var i=0; i<<%=wsysarr.length%>; i++){
  			document.access.wizards<%=wsysarr.length > 1 ? "[i]" : ""%>.checked = false;
  		}
	  }
  }
</script>
</head>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="15%" height="28" colspan="3"><span class="HEADER">XpoLog Wizards</span></td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <%for(int i=0;i<wusrarr.length;++i) {
              	  String checked = "";
            			WizardInfo wi = wusrarr[i];
              	  if(metaDataWizards.contains(wi.getID())) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }	
              	  String desc = wi.getDescription() != null && wi.getDescription().length() > 0 ? "(" + wi.getDescription() + ")" : "";
              %>
							<tr>
								<td colspan="3"><input type="checkbox" id="Report,<%=wi.getID()%>" name="reports" value="<%=XpoLogObjectTypes.WIZARD_TYPE%>,<%=wi.getID()%>" <%=checked%>><span class="REGULARTEXT"><%=wi.getName()%> - <span class="SMALLTEXT"><%=desc%></span></span></td>
							</tr> 
              <%}%>
              <%for(int i=0;i<wsysarr.length;++i) {
              	  String checked = "";
            			WizardInfo wi = wsysarr[i];
              	  if(metaDataWizards.contains(wi.getID())) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }	
              	  String desc = wi.getDescription() != null && wi.getDescription().length() > 0 ? "(" + wi.getDescription() + ")" : "";
              %>
							<tr>
								<td colspan="3"><input type="checkbox" id="<%=XpoLogObjectTypes.WIZARD_TYPE%>,<%=wi.getID()%>" name="wizards" value="<%=XpoLogObjectTypes.WIZARD_TYPE%>,<%=wi.getID()%>" <%=checked%>><span class="REGULARTEXT"><%=wi.getName()%> - <span class="SMALLTEXT"><%=desc%></span></span></td>
							</tr> 
              <%}%>
              <%if(wsysarr.length > 1){ %>
							<tr><td>&nbsp;</td></tr>  
							<tr class="TABLES_HEADERS">
								<td colspan="3"><input name="checkedAllWizards" type="checkbox" onClick="checkWizards()"><span class="REGULARTEXT"><b>Check All</b></span></td>
							</tr>
							<%} %>
          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		