<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>

<%
  String ERROR_OBJ = "ERROR_OBJ";
  ErrorModel errmodel = new ErrorModel();
  
  UserContext userContext = UserEnvironment.getUserContext(request);
	MetaDataSearchQuery metaDataSearchQuery = (MetaDataSearchQuery)request.getSession().getAttribute(MetaDataSearchQuery.META_DATA_SEARCH_QUERY);
  
  MetaDataCategoriesManager catMgr = MetaDataCategoriesManager.getInstance();
  MetaDataCategory applications = catMgr.getMetaDataCategory("applications");
  MetaDataCategory platforms = catMgr.getMetaDataCategory("platforms");
  MetaDataCategory operatingSystems = catMgr.getMetaDataCategory("os");
  MetaDataCategory vendors = catMgr.getMetaDataCategory("vendors");
  String app = "", version = "", build = "", platform = "", os = "", vendor = "";
  HashSet selPlatforms = null;
  HashSet selOs = null;
  HashSet nonPredefinedAttributes = null;
  int numberOfNonPredefinedAttributes = 0;
  HashSet result = null;
 	if (metaDataSearchQuery != null){
 		app = metaDataSearchQuery.getApplication();
 		version = metaDataSearchQuery.getVersion();
 		build = metaDataSearchQuery.getBuild();
 		platform = metaDataSearchQuery.getPlatform();
 		if (platform != null && platform.length() > 0){
 			selPlatforms = new HashSet();
 			String[] arr = platform.split(",");
 			for (int i=0; i<arr.length; i++){
 				selPlatforms.add(arr[i]);
 			}
 		}
 		os = metaDataSearchQuery.getOs();
 		if (os != null && os.length() > 0){
 			selOs = new HashSet();
 			String[] arr = os.split(",");
 			for (int i=0; i<arr.length; i++){
 				selOs.add(arr[i]);
 			}
 		}
 		vendor = metaDataSearchQuery.getVendor();
 		nonPredefinedAttributes = metaDataSearchQuery.getAllNonPredefinedAttributes();
 		if (nonPredefinedAttributes != null){
 			numberOfNonPredefinedAttributes = nonPredefinedAttributes.size();
 		}
 		result = SiteManagment.getInstance().getMetaDataMgr().getMetaDatasByQuery(metaDataSearchQuery,true);
 		UserContext searchUserContext = (UserContext)request.getSession().getAttribute(MetaDataSearchQuery.META_DATA_USER_CONTEXT);
 		if (searchUserContext == null){
 			searchUserContext = new UserContext();
 			searchUserContext.setUser(userContext.getUser());
 			searchUserContext.setTreatEmptyIncSetAsAll(false);
 			request.getSession().setAttribute(MetaDataSearchQuery.META_DATA_USER_CONTEXT, searchUserContext);
 		}
 		searchUserContext.setIncludeSet(result);
 		//System.out.println(result);
 	}
  
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script  src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/comps/divsTabs.js" type="text/javascript"></script>
<script>
  
  function doSearch(){
  	document.access.submit();
  }
  
  function showTextField(combo){
  	if (combo.options.multiple == false){
	  	if (combo.options[combo.options.selectedIndex].value == "other"){
	  		document.getElementById("New"+combo.name+"Div").style.display = "";
	  	}else{
	  		document.getElementById("New"+combo.name+"Div").style.display = "none";
	  	}
  	}else{
  		otherSelected = false;
  		for (var i=0; i<combo.length; i++){
  			if (combo.options[i].value == "other"){
  				if (combo.options[i].selected == true){
			  		document.getElementById("New"+combo.name+"Div").style.display = "";
  				}else{
			  		document.getElementById("New"+combo.name+"Div").style.display = "none";
  				}
  			}
  		}
  	}
  }
  
	function addNewProp(){
		document.getElementById("NewPropTableHeader").style.display = "";
		var ni = document.getElementById("newProps");
		var numi = document.getElementById("numberOfProps");
		var num = (document.getElementById("numberOfProps").value -1)+ 2;
		numi.value = num;
		var divIdName = "newProp"+num+"Div";
		var newdiv = document.createElement('div');
		newdiv.setAttribute("id",divIdName);
		//newdiv.innerHTML = "Element Number "+num+" has been added! <a href=\"javascript:;\" onclick=\"removeEvent(\'"+divIdName+"\')\">Remove the div &quot;"+divIdName+"&quot;</a>";
		newdiv.innerHTML = "<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">"+
                       "<tr><td width=\"20%\" valign=\"top\" nowrap><span class=\"REGULARTEXT\">"+
                       "<input type=\"text\" name=\"key_"+num+"\" id=\"key_"+num+"\" size=\"20\">"+
                       "</span></td>"+
                       "<td width=\"80%\">"+
	                     "<input type=\"text\" name=\"value_"+num+"\" id=\"value_"+num+"\" size=\"20\">"+
	                     "&nbsp;<span class=\"LINK\"><a href=\"javascript:;\" onclick=\"removeEvent(\'"+divIdName+"\')\">&nbsp;remove</a></link>"+
                       "</td></tr></table>";
		ni.appendChild(newdiv);
	}

	function removeEvent(divNum){
		var d = document.getElementById('newProps');
		var olddiv = document.getElementById(divNum);
		d.removeChild(olddiv);
		num = document.access.numberOfProps.value;
		if (!document.getElementById("newProp"+num+"Div")){
			document.getElementById("NewPropTableHeader").style.display = "none";
		}
	}

</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" name="access" id="access" method="post" action="metaDataSearchAction.jsp">
<input type="hidden" value="<%=numberOfNonPredefinedAttributes%>" id="numberOfProps" name="numberOfProps"/>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
          	<td>
          		<table border="0">
          			<script>
                  var applicationTabs = createDefaultApplicationTabs("metaDataSearchTabs");
                  applicationTabs.addTab("Query","<nobr>Query</nobr>","queryDiv");
                  applicationTabs.addTab("Result","<nobr>Result</nobr>","resultDiv");
          			</script>
          			<tr>
          				<td>
                    <script>
                    	applicationTabs.writeTabs();
                    </script> 
          				</td>
          			</tr>
          		</table>
          	</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="100%">
                <div id="queryDiv" style="display:none">
                <table border="0" cellpadding="0" cellspacing="0"  width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="28"><span class="HEADER">Properties</span></td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Application</span></td>
                        <td width="80%">
                        	<%if (applications != null) {%>
	                        	<select name="Application" onchange="javascript:showTextField(this)">
	                        		<option value="">--- select ---</option>
	                        	<%
                        			List list = applications.getMembers(true);
                        			for (int i=0; i<list.size();i++){
                        				MetaDataCategory child = (MetaDataCategory)list.get(i);
                        				String indentation = "";
                        				for (int j=1; j<child.getLevel(); j++){
                        					indentation += "&nbsp;&nbsp;";
                        				}
                        				String selected = app != null && app.equals(child.getId()) ? " selected" : "";
                        		%>
                        			<option value="<%=child.getId()%>" <%=selected%>><%=indentation+child.getName()%></option>
	                        	<%}%>
	                        		<option value="other">other</option>
 		                        </select>
                        	<%}%>
                        		<span id="NewApplicationDiv" style="display:none">
 		                        <input type="text" name="NewApplication" value="" size="20">
 		                        <span class="REGULARTEXT">as child of: </span>
                        	<%if (applications != null) {%>
	                        	<select name="NewApplicationParent">
	                        		<option value="">--- select ---</option>
	                        	<%
                        			List list = applications.getMembers(true);
                        			for (int i=0; i<list.size();i++){
                        				MetaDataCategory child = (MetaDataCategory)list.get(i);
                        				String indentation = "";
                        				for (int j=1; j<child.getLevel(); j++){
                        					indentation += "&nbsp;";
                        				}
                        				String selected = app != null && app.equals(child.getId()) ? " selected" : "";
                        		%>
                        			<option value="<%=child.getId()%>" <%=selected%>><%=indentation+child.getName()%></option>
	                        	<%}%>
 		                        </select>
                        	<%}%>
 		                        </span>
                        </td>
                      </tr>
                      <tr><td><span style="font-size:2px">&nbsp;<span></td></tr>
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Version</span></td>
                        <td width="80%">
	                        <input type="text" name="Version" value="<%=version%>" size="20">
                        </td>
                      </tr>
                      <tr><td><span style="font-size:2px">&nbsp;<span></td></tr>
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Build</span></td>
                        <td width="80%">
	                        <input type="text" name="Build" value="<%=build%>" size="20">
                        </td>
                      </tr>
                      <tr><td><span style="font-size:2px">&nbsp;<span></td></tr>
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Platform</span></td>
                        <td width="80%">
                        	<%if (platforms != null) {%>
	                        	<select name="Platform" onchange="javascript:showTextField(this)" multiple size="5">
	                        	<%
                        			List list = platforms.getMembers(true);
                        			for (int i=0; i<list.size();i++){
                        				MetaDataCategory child = (MetaDataCategory)list.get(i);
                        				String selected = selPlatforms != null && selPlatforms.contains(child.getId()) ? " selected" : "";
                        		%>
                        			<option value="<%=child.getId()%>" <%=selected%>><%=child.getName()%></option>
	                        	<%}%>
	                        		<option value="other">other</option>
 		                        </select>
                        	<%}%>
                       			<span id="NewPlatformDiv" style="display:none">
		                        <input type="text" name="NewPlatform" value="" size="20">
		                        </span>
                        </td>
                      </tr>
                      <tr><td><span style="font-size:2px">&nbsp;<span></td></tr>
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Operating system</span></td>
                        <td width="80%">
                        	<%if (operatingSystems != null) {%>
	                        	<select name="Os" onchange="javascript:showTextField(this)" multiple size="5">
	                        	<%
                        			List list = operatingSystems.getMembers(true);
                        			for (int i=0; i<list.size();i++){
                        				MetaDataCategory child = (MetaDataCategory)list.get(i);
                        				String selected = selOs != null && selOs.contains(child.getId()) ? " selected" : "";
                        		%>
                        			<option value="<%=child.getId()%>" <%=selected%>><%=child.getName()%></option>
	                        	<%}%>
	                        		<option value="other">other</option>
 		                        </select>
                        	<%}%>
                       			<span id="NewOsDiv" style="display:none">
		                        <input type="text" name="NewOs" value="" size="20">
		                        </span>
                        </td>
                      </tr>
                      <tr><td><span style="font-size:2px">&nbsp;<span></td></tr>
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Vendor</span></td>
                        <td width="80%">
                        	<%if (vendors != null) {%>
	                        	<select name="Vendor" onchange="javascript:showTextField(this)">
	                        		<option value="">--- select ---</option>
	                        	<%
                        			List list = vendors.getMembers(true);
                        			for (int i=0; i<list.size();i++){
                        				MetaDataCategory child = (MetaDataCategory)list.get(i);
                        				String selected = vendor != null && vendor.equals(child.getId()) ? " selected" : "";
                        		%>
                        			<option value="<%=child.getId()%>" <%=selected%>><%=child.getName()%></option>
	                        	<%}%>
	                        		<option value="other">other</option>
 		                        </select>
                        	<%}%>
                       			<span id="NewVendorDiv" style="display:none">
 		                        <input type="text" name="NewVendor" value="" size="20">
		                        </span>
                        </td>
                      </tr>
                      <tr><td colspan="2">
                      <div id="newProps">
                      <%if (nonPredefinedAttributes != null){
	                      	Iterator it = nonPredefinedAttributes.iterator();
	                      	int i = 1;
	                      	while (it.hasNext()){
		                      	String key = (String)it.next();
		                      	String value = metaDataSearchQuery.getValue(key);
                      %>
                      	<div id="newProp<%=i%>Div">
												<table border="0" width="100%" cellspacing="0" cellpadding="0">
		                      <tr><td><span style="font-size:2px">&nbsp;<span></td></tr>
													<tr>
														<td width="20%" valign="top" nowrap>
															<span class="REGULARTEXT"><%=key%></span>
															<input type="hidden" name="key_<%=i%>" id="key_<%=i%>" value="<%=key%>">
														</td>
														<td width="80%">
															<input type="text" name="value_<%=i%>" id="value_<%=i%>" value="<%=value%>" size="20">
															&nbsp;<span class="LINK"><a href="javascript:;" onclick="removeEvent('newProp<%=i%>Div')">&nbsp;remove</a>
														</td>
													</tr>
												</table>
												</div>
												<%
												i++;
												}
											}%>
												<table border="0" width="100%" cellspacing="0" cellpadding="0">
		                      <tr><td>&nbsp;</td></tr>
		                      <tr><td><a href="javascript:addNewProp()" class="LINK">add new search property</a></td></tr>
													<tr>
														<td>
															<table id="NewPropTableHeader" border="0" width="100%" cellspacing="0" cellpadding="0" style="display:none">
					                      <tr><td colspan="2"><span style="font-size:2px">&nbsp;<span></td></tr>
																<tr>
																	<td width="20%" valign="top" bgcolor="#FFB13E">
																		<span class="REGULARTEXT">&nbsp;type</span>
																	</td>
																	<td width="80%" valign="top" bgcolor="#FFB13E">
																		<span class="REGULARTEXT">&nbsp;value</span>
																	</td>
																</tr>
					                      <tr><td colspan="2"><span style="font-size:2px">&nbsp;<span></td></tr>
															</table>
														</td>
													</tr>
												</table>
                      </div></td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                </table>
                </div>
                <div id="resultDiv" style="display:none">
	             		<jsp:include page="metaDataQueryResult.jsp" flush="true"/>
                </div>
                </td>
              </tr>
							<script>                 
               	tabsInLine = 8;
								applicationTabs.selectTabByIndex(<%=metaDataSearchQuery == null ? 0 : 1%>);
							</script>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="35%">&nbsp;</td>
                <td width="18%" align="center"><a href="javascript:doSearch()" class="LINK">search</a></td>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>