<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY = "../../";
%>
     
<%
  String ERROR_OBJ = "ERROR_OBJ";
  
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION,true)){
	  return;
	}
  
  //site management
	SiteManagment mgmt = SiteManagment.getInstance();
	UserContext searchUserContext = (UserContext)request.getSession().getAttribute(MetaDataSearchQuery.META_DATA_USER_CONTEXT);

  WizardManager wmg = mgmt.getWizardManager(xpolog.eye.site.SiteUtil.getBaseDirectory(request));
  WizardInfo[] wsysarr = wmg.getAllSystemWizards(searchUserContext);
  WizardInfo[] wusrarr =  wmg.getAllUserWizards(searchUserContext);

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>
  function openLink(path){
  	document.location = path;
  }
</script>
</head>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="15%" height="28" colspan="4"><span class="HEADER">XpoLog Wizards</span></td>
              </tr>
							<tr class="TABLES_HEADERS">
								<td width="30%"><span class="REGULARTEXT">Name</span></td>
								<td width="45%"><span class="REGULARTEXT">Description</span></td>
								<td width="15%">&nbsp;</td>
								<td width="10%"></td>
							</tr>
              <%for(int i=0;i<wusrarr.length;++i) {
                  String startPath = wusrarr[i].getStartsPath();
                  String editPath = wusrarr[i].getStartsPath();
              %>
							<tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
								<td width="30%"><span class="REGULARTEXT"><%=wusrarr[i].getName()%></span></td>
								<td width="45%"><span class="REGULARTEXT"><%=wusrarr[i].getDescription()%></span></td>
								<td width="15%">&nbsp;<a href="javascript:openLink('<%=startPath%>')" class="LINK">create log</a>
								<%if (wusrarr[i].isEditable()){%>
								&nbsp;<a href="javascript:openLink('<%=editPath%>')" class="LINK">edit</a>
								<%} %>
								</td>
								<td width="10%"></td>
							</tr>
              <%}%>
              <%for(int i=0;i<wsysarr.length;++i) {
                String startPath = wsysarr[i].getStartsPath();
                String editPath = wsysarr[i].getStartsPath();
              %>
							<tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
								<td width="30%"><span class="REGULARTEXT"><%=wsysarr[i].getName()%></span></td>
								<td width="45%"><span class="REGULARTEXT"><%=wsysarr[i].getDescription()%></span></td>
								<td width="15%">&nbsp;<a href="javascript:openLink('<%=startPath%>')" class="LINK">create log</a>
								<%if (wsysarr[i].isEditable()){%>
								&nbsp;<a href="javascript:openLink('<%=editPath%>')" class="LINK">edit</a>
								<%} %>
								</td>
								<td width="10%"></td>
							</tr>
              <%}%>
          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		