<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.config.MailConfig"%>
<%@ page import="xpolog.eye.automation.tasks.jms.JMSTask"%>
<%@ page import="xpolog.eye.automation.tasks.mail.MailTask"%>
<%@ page import="xpolog.eye.automation.tasks.snmp.SNMPTask"%>
<%@ page import="xpolog.eye.media.AddressBook"%>
<%@ page import="xpolog.eye.media.jms.JMSAccountFilter"%>
<%@ page import="xpolog.eye.media.snmp.SNMPAccountFilter"%>

<%@ page import="java.util.List"%>

<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	
	String resultStr = "";

	String alertType = request.getParameter("alertType");
	if(alertType == null || alertType.length() == 0) {
		resultStr = "ok";
	}else {
		if(alertType.equals(MailTask.TYPE_MAIL)) {
			Configuration conf = Configuration.getInstance();
			MailConfig mail = conf.getMailConfigurationManager();
			String host = mail.getSmtpHost();
			if(host.length() == 0 || host.equals(MailConfig.DEF_SMTP_ADDRESS)){ 
				resultStr = "fail";
			}else {
				resultStr = "ok";
			}
		}else if(alertType.equals(SNMPTask.SNMP_TASK_TYPE)) {
			SNMPAccountFilter filter = new SNMPAccountFilter();
		  AddressBook adbook = AddressBook.getInstance();
		  List list = adbook.getAccountsByFilter(filter);
			if(list.size() == 0) {
				resultStr = "fail";
			}else {
				resultStr = "ok";
			}
		}else if(alertType.equals(JMSTask.TYPE_JMS_TASK)) {
			JMSAccountFilter filter = new JMSAccountFilter();
		  AddressBook adbook = AddressBook.getInstance();
		  List list = adbook.getAccountsByFilter(filter);
			if(list.size() == 0) {
				resultStr = "fail";
			}else {
				resultStr = "ok";
			}
		}
	}

	response.setContentType("text/xml");
	out.write(resultStr.trim());
	out.flush();
%>