<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.automation.tasks.XpoTask"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.ui.grid.GridTable"%>
<%@ page import="xpolog.eye.site.ui.grid.models.TasksGridTableModel"%>
<%@ page import="xpolog.eye.verifiers.VerifierManager"%>

<%@ page import="java.util.HashSet"%>
<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, null, true)) {
		return;
	}
	VerifierManager verMgr = SiteManagment.getInstance().getVerifierManager();

	String isFilterStr = request.getParameter("isFilter");
  boolean isFilter = isFilterStr != null && isFilterStr.equals("true"); 

	String selectOnlyStr = request.getParameter("selectOnly");
  boolean selectOnly = selectOnlyStr != null && selectOnlyStr.equals("true"); 

	UserContext userContext = UserEnvironment.getUserContext(request);
	
	String alertType = request.getParameter("alertType");
	
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = "../";
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	TasksGridTableModel model = new TasksGridTableModel();
	model.setBaseDirectory(baseDirectory);
	model.setUserContext(userContext);
	model.setSelectOnly(selectOnly);
	model.setGridName("mygrid" + suffix);
	HashSet includeSet = null;
	if (alertType != null && alertType.length() > 0){
		includeSet = new HashSet();
		includeSet.add(alertType);
	}
	XpoTask[] monitorsTasks = verMgr.getVerifiersTasks(includeSet);
	model.setTasks(monitorsTasks);
	model.init();
	GridTable table = new GridTable(model);
	request.setAttribute("gridTable" + suffix,table);
	
	request.getRequestDispatcher(baseDirectory + "widgets/grid/jsp/initTableXML.jsp").forward(request, response);	
%>