<%@ page language="java"%>

<%@ page import="omega.ui.html.tree.ODefaultTreeCellRenderer"%>
<%@ page import="omega.ui.models.tree.ODefaultMutableTreeNode"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.builders.OnlineDBSimpleLogBuilder"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.menu.ModulesMenuLoader"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.ui.tree.ModuleMemberRenderer"%>
<%@ page import="xpolog.eye.verifiers.admin.LogVerifierBuilder"%>

<%@ page import="java.util.*"%>

<%
	String VERIFIER_BUILDER = "VERIFIER_BUILDER";

	LogVerifierBuilder builder = (LogVerifierBuilder)request.getSession().getAttribute(VERIFIER_BUILDER);
	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);

	LogBrowsingManager lbm = new LogBrowsingManager();
	String selectedLogId = "";
	String selectedFilterId = "";
	
	if (builder != null){
		selectedLogId = builder.getLogId();
		selectedFilterId = builder.getLogFilterId();
	}
	
	Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
	HashMap logsMap = null;
	HashMap modulesMap = null;
	HashMap filtersMap = null;
	if (selectedLogId != null){
		logsMap = new HashMap();
		logsMap.put(selectedLogId,selectedLogId);
		modulesMap = new HashMap();
		ModuleMemberRenderer.addModuleMemberParents(modulesMap, logsMap);		
		if (selectedFilterId != null){
			filtersMap = new HashMap();
			filtersMap.put(selectedFilterId,selectedFilterId);
		}
	}
	
	boolean treeNodeExists = false;
	String treeXml = ""; 
  String id = request.getParameter("id");
  String type = null;
  if (id != null){
  	int ind = id.indexOf("-");
  	if (ind != -1){
  		type = id.substring(0,ind);
  		id = id.substring(ind+1);
  	}
  	if (type != null){
  		if (type.equals(XpoLogObjectTypes.MODULE_TYPE)){
  			try{
  			curmod = SiteManagment.getInstance().getModuleFromId(id);
  			treeNodeExists = true;
  			}catch(Exception e){
  				ErrorModel.log.error("Failed to load folders tree for folder " + id,e);
  			}
  		}else if (type.equals(XpoLogObjectTypes.LOG_TYPE)){
  			try{
	  			lbm = mgmt.getLogBrowserManager(id,true,false,true);
  			}catch(Exception e){
  				ErrorModel.log.error("Failed to load folders tree for log " + id,e);
  			}
  		}
  	}
  }
  
	String [] ignoreTypes = {OnlineDBSimpleLogBuilder.ONLINE_DB_CACHE_LOG_TYPE};
	if (type != null && type.equals(XpoLogObjectTypes.LOG_TYPE) && lbm != null){
		ODefaultTreeCellRenderer cr = new ODefaultTreeCellRenderer();
		ModulesMenuLoader modMenuLoader = new ModulesMenuLoader();
		modMenuLoader.setShowFilters(true);		
		ODefaultMutableTreeNode node = (ODefaultMutableTreeNode)modMenuLoader.createMutableNodeFromLog(lbm,userContext,env);
		treeXml = cr.renderNode(node,true,false);
	}else if (curmod != null){
		ModuleMemberRenderer renderer = new ModuleMemberRenderer(curmod, userContext, modulesMap, logsMap, true, false, treeNodeExists);
		renderer.addUserData(XpoLogObjectTypes.LOG_TYPE,"popupKey","'monitorLogMenu','[ID]'");
		renderer.setLogsMapOnlyOpen(true);
		renderer.setShowFilters(true);
		renderer.setFiltersRadio(true);
		renderer.setLogTypesToIgnore(ignoreTypes);
		renderer.setFilters(filtersMap);
		treeXml = renderer.getTreeXML();
	}
	response.setContentType("text/xml");
	//System.out.println(treeXml);
	out.write(treeXml);
	out.flush();
%>