<%@ page language="java"%>

<%@ page import="xpolog.eye.verifiers.admin.VerifierBuilder"%>

<%!
	static final String BASE_DIRECTORY = "../";

%>

<%
	String VERIFIER_BUILDER = "VERIFIER_BUILDER";
	
	VerifierBuilder builder = (VerifierBuilder)request.getSession().getAttribute(VERIFIER_BUILDER);

	String baseDirectory = request.getParameter("baseDirectory");
	if(baseDirectory == null || baseDirectory.length() == 0) {
		baseDirectory = BASE_DIRECTORY;
	}

	String taskDivBaseDirectory = request.getParameter("taskDivBaseDirectory");
	if(taskDivBaseDirectory == null) {
		taskDivBaseDirectory = "../";
	}
	
	String path = taskDivBaseDirectory + "tasks/tasksDiv.jsp";
%>

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/logAdministration.css" />
<style type="text/css">
a.MONITOR_BUTTON:link {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
a.MONITOR_BUTTON:visited {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
a.MONITOR_BUTTON:active {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
a.MONITOR_BUTTON:hover {color: #5B6678; font-family: Tahoma;font-size: 10pt;text-decoration: none;font-weight:bold}
</style>

<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/admin.js"></script>

<%
String suffix = "Alerts";

boolean showMenu = true;
if(showMenu) {
	String menuIds = "editTask,deleteTask";
	String menuTexts = "Edit,Delete";
	String menuHrefs = "javascript:editTask();,javascript:deleteTask();";
%>
	<jsp:include page="../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	  <jsp:param name="suffix" value="<%=suffix %>" />
	</jsp:include>
	<jsp:include page="../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	  <jsp:param name="suffix" value="<%=suffix %>" />
	</jsp:include>
<%
}
%>

<jsp:include page="../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	<jsp:param name="suffix" value="<%=suffix%>" />
</jsp:include>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>
		<td id="alertsTD" valign="top">
		<%
		String menu = showMenu ? "aMenu" + suffix : "";
		
		String addName = "New Email#New SNMP#New JMS#New Batch Execution";
    String addLink = "javascript:addMailAlert()#javascript:addSNMPAlert()#javascript:addJMSAlert()#javascript:addExeAlert()";
    
		String tableNames = "Edit#Delete";
    String tableActions = "javascript:editTask()#javascript:deleteTask()";
    String ids = "Edit#Delete";
    String selectTypes = "2#2";
		%>
		<jsp:include page="../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
			<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
			<jsp:param name="initXML" value="monitor/monitorAlertsXML.jsp" />
			<jsp:param name="updateXML" value="monitor/monitorAlertsXML.jsp?dataOnly=true" />
			<jsp:param name="menu" value="<%=menu%>"/>
			<jsp:param name="newActionNames" value="<%=addName%>" />
			<jsp:param name="newActions" value="<%=addLink%>" />
			<jsp:param name="tableActionNames" value="<%=tableNames%>" />
			<jsp:param name="tableActions" value="<%=tableActions%>" />
			<jsp:param name="tableActionIds" value="<%=ids%>" />
			<jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
			<jsp:param name="suffix" value="<%=suffix %>" />
			<jsp:param name="recordsText" value="Alerts" />
			<jsp:param name="style" value="main" />
			<jsp:param name="doubleClickAction" value="editTask" />
		</jsp:include>
		</td>
	</tr>
</table>
<script>
	function updateButtonActivateAlerts(rowid,id,columnType,gridType){
		if (!id || id == "") return;
		enableActionButton(id);
	}
</script>