<%@ page language="java"%>

<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page import="xpolog.eye.verifiers.*"%>
<%@ page import="xpolog.eye.verifiers.admin.VerifierBuilder"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
	String VERIFIER_BUILDER = "VERIFIER_BUILDER";
	String ERROR_OBJ = "ERROR_OBJ";
	
	VerifierBuilder builder = (VerifierBuilder)request.getSession().getAttribute(VERIFIER_BUILDER);
	
	ErrorModel errmod = VerifiersHelper.saveVerifier(request,builder);
	String xml = "";
	if (errmod != null && errmod.getErrorCount() > 0){
		//errors
		String[] errors = errmod.getErrors();
		StringBuffer sb = new StringBuffer();
		for (int i=0; i<errors.length; i++){
			if (sb.length() > 0){
				sb.append("*;*");
			}
			sb.append(errors[i]);
		}
		String message = sb.toString();
		//params
		String[] params = errmod.getErrorParams();
		sb = new StringBuffer();
		for (int i=0; i<params.length; i++){
			if (sb.length() > 0){
				sb.append("*;*");
			}
			sb.append(params[i]);
		}
		String paramsList = sb.toString();
		xml = GridModelActionsHelper.getResultXML(false, message, paramsList);
  	//request.getSession().setAttribute(ERROR_OBJ,errmod);
  	//response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?okURL=monitor/monitorDefinition.jsp%3FuseSessionBuilder=true");
	}else{
		request.getSession().removeAttribute(VERIFIER_BUILDER);
		request.getSession().removeAttribute("CURRENT_VERIFIER_RESULT");
		request.getSession().setAttribute("CURRENT_VERIFIER",builder.getVerifier());
		request.getSession().setAttribute("lastSelectedMonitor",builder.getVerifier().getId());
		//response.sendRedirect("addopok.jsp?refreshMenu=true");
		xml = GridModelActionsHelper.getResultXML(true, "Monitor Saved");
	}
	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	out.write(xml);
	out.flush();
%>