<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.verifiers.*"%>
<%@ page import="xpolog.eye.verifiers.admin.LogVerifierBuilder"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
	String VERIFIER_BUILDER = "VERIFIER_BUILDER";

	LogVerifierBuilder builder = (LogVerifierBuilder)request.getSession().getAttribute(VERIFIER_BUILDER);
	LogVerifier monitor = builder.getLogVerifier();
	
	String logMonitorType = LogVerifier.LOG_MONITOR_TYPE_FILTER_RULES;
	if (monitor == null){
		monitor = new LogVerifier();
	}else {
		logMonitorType = monitor.getLogMonitorType();
	}
	String lbmId = monitor.getLogId();
	if (lbmId == null){
		lbmId = "";
	}
	
	String filterId = monitor.getLogFilterId();
	if (filterId == null){
		filterId = "";
	}
	LogBrowsingManager lbm = null;
	if (lbmId != null && lbmId.length() > 0){
		try{
			lbm = SiteManagment.getInstance().getLogBrowserManager(lbmId);
		}catch(Exception e){
		}
	}
	FilterManager filterMgr = lbm != null ? lbm.getFilterManager(): null;
	List list = filterMgr != null ? filterMgr.getFilterCollections() : null;
	boolean hasFilters = list != null && !list.isEmpty();

	String noLogDivDisplay = "";
	String hasLogDivDisplay = "";
	if(lbmId == null || lbmId.length() == 0) {
		hasLogDivDisplay = "display:none";
	}else {
		noLogDivDisplay = "display:none";
	}
	
	String selectFilterString = "Select or ";
	boolean allowNewFilter = true;
	UserContext userContext = UserEnvironment.getUserContext(request);
	if (userContext!= null && !userContext.isHavePermission(ActionsPermissionConstants.AdministrationPermissions.EDIT_LOG_PERMISSION)){
		allowNewFilter = false;
		selectFilterString = "Select rule ";
  }
%>

<script>
function handleDivs() {
	alert("logs = " + document.getElementById("logs").value);
}
</script>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
	<tr valign="top">
	  <td>
	    <div id="noLogDiv" style="<%=noLogDivDisplay %>">
	    	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
					<tr height="20">
						<td>&nbsp;</td>
					</tr>
					<tr valign="top">
						<td>
							<span class="REGULARTEXT" style="color:#9E5B04">* No log is selected. </span><a class="LINK" href="javascript:showModuleTree()">Select a log</a>
						</td>
					</tr>
				</table>
	    </div>
	    
	    <div id="hasLogDiv" style="<%=hasLogDivDisplay %>">
	    	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	    		<!-- hide radio buttons area until the auto monitor is implemented -->
	    		<input type="hidden" name="logMonitorType" value="<%=LogVerifier.LOG_MONITOR_TYPE_FILTER_RULES %>">
	    		<!--
	    		<tr height="20">
						<td>&nbsp;</td>
					</tr>
					<tr>
						<td style="padding-left:10">
						<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" height="100%">
							<tr>
								<td>
									<span class="REGULARTEXT">
										<input type="radio" name="logMonitorType" value="<%=LogVerifier.LOG_MONITOR_TYPE_FILTER_RULES %>" <%=logMonitorType.equals(LogVerifier.LOG_MONITOR_TYPE_FILTER_RULES) ? "checked" : "" %>>Rules
									</span>
								</td>
								<td width="20">&nbsp;</td>
								<td>
									<span class="REGULARTEXT">
										<input type="radio" name="logMonitorType" value="<%=LogVerifier.LOG_MONITOR_TYPE_AUTO %>" <%=logMonitorType.equals(LogVerifier.LOG_MONITOR_TYPE_AUTO) ? "checked" : "" %>>Auto Monitor
									</span>
								</td>
							</tr>
							<tr height="7">
								<td>&nbsp;</td>
							</tr>
						</table>
						</td>												
					</tr>
					<tr style="background-color:#CBCBCB">
						<td style="font-size:3;">&nbsp;</td>
					</tr>
					 -->
					<tr>
						<td style="padding-left:15;padding-top:10">
						<div>
						<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="100%">
							<tr>
								<td style="vertical-align:top">
									<table border="0">
										<tr>
											<td id="filtersSelectionLabelTD">
												<%if (hasFilters){%>
												<span class="REGULARTEXT"><%=selectFilterString%></span>
												<%}else{ %>
												<span class="REGULARTEXT" style="color:#9E5B04">* No rules are assigned to this log. </span>
												<%}%>
											</td>
											<%if(allowNewFilter) { %>
											<td><a class="LINK" href="javascript:createNewFilter()">Create new</a><span class="REGULARTEXT"> Rule</span></td>
											<%} %>
										</tr>
									</table>
								</td>
							</tr>
							<tr>
								<td style="padding-left:30;padding-top:10;vertical-align:top">
								<div id="filtersListDiv">
								<jsp:include page="filtersList.jsp">
									<jsp:param name="lbmId" value="<%=lbmId%>"/>
									<jsp:param name="filterId" value="<%=filterId%>"/>
								</jsp:include>
								</div>
								</td>
							</tr>
							<tr height="100%">
								<td>&nbsp;</td>
							</tr>
						</table>
						</div>
						</td>
					</tr>
				</table>
	    </div>
	  </td>
	</tr>
</table>
