<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.verifiers.VerifierManager"%>
<%@ page import="xpolog.eye.verifiers.Verifier"%>
<%@ page import="xpolog.eye.site.*"%>

<%@page import="java.util.LinkedList"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request, response, null, true)) {
	return;
}
UserContext userContext = UserEnvironment.getUserContext(request);

boolean isAdd = manager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_VERIFY_PERMISSION);
boolean isExecute = manager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.EXECUTE_VERIFIER_PERMISSION);

String monitorId = request.getParameter("MONITOR_ID");
if (monitorId == null){
	monitorId = "";
}
String[] parentIds = null;
if (monitorId.length() > 0){
	LinkedList parentIdsList = new LinkedList();
	VerifierManager verMgr = VerifierManager.getInstance();
	Verifier parent = verMgr.getParentVerifier(monitorId);
	while (parent != null){
		if (!parent.getId().equals(Verifier.ROOT_VERIFIER_ID)){
			parentIdsList.add(0,parent.getId());
		}
		parent = verMgr.getParentVerifier(parent.getId());
	}
	parentIds = (String[])parentIdsList.toArray(new String[parentIdsList.size()]);
}

String lastSelectedRow = (String)request.getSession().getAttribute("lastSelectedMonitor");
if (lastSelectedRow == null){
	lastSelectedRow = "";
}

%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>

<jsp:include page="../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
<jsp:param name="useTree" value="true" />
</jsp:include>
<%
boolean showMenu = isAdd || isExecute;
if(showMenu) {
	String menuIds = "executeGroup,executeMonitor,showMonitorResults,editGroup,editMonitor,removeGroup,removeMonitor";
	String menuTexts = "Execute,Execute,Show Results,Edit,Edit,Delete,Delete";
	String menuHrefs = "javascript:executeGroup0();,javascript:executeMonitor0();,javascript:showMonitorResults0();,javascript:editGroup0();,javascript:editMonitor0();,javascript:removeGroup0();,javascript:removeMonitor0();";
%>
<jsp:include page="../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		</jsp:include>
	<jsp:include page="../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	</jsp:include>
<%
}
%>

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";  
	
  function goEdit(id){
  	alert('edit');
  }
  
  function goNew(){
  	goMonitor('');
  }
  
  function goNewGroup(){
    doEditMulti('');
  }
  
  function doEdit(){
  	var id = getFirstSelectedRow(mygrid);
    if (id == "") {
     return;
    }
    var isMulti = mygrid.getUserData(id,"isMulti"); 
		if (isMulti && isMulti == "true"){
		  doEditMulti(id);
		} else {
		  doLogEdit(id);
		}  	
  }
  
  function showResults(){
    var id = getFirstSelectedRow(mygrid);
    if (id == "") {
     return;
    }
    var zoomInUrl = mygrid.getUserData(id,"zoomInUrl"); 
		if (!zoomInUrl || zoomInUrl == ""){
		  return;
		}    
  	path = "<%=BASE_DIRECTORY%>" + zoomInUrl;
  	window.open(path,'LogViewer');
  	//document.location = path;
  }
  
  function doDeleteOld(id){
  	path = "monitorRemoveCheck.jsp?verifierId=" + id;
  	document.location = path;
  }
  
  var deleteMulti = false;
  function doDelete(){
    var id = mygrid.getSelectedRowId();
    if (id == "") {
      return;
    }
    if (id.indexOf(",") >= 0){
      doMembersDelete(id,id);
      return;
    }
    doDelete1(id);
  }
  
  function doMembersDelete(row,id){   
    var msgWriter = new messageWriter("mygridMessage","Monitor Delete Action","<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid"),50);
    msgWriter.addAction("Yes","javascript:hideLayer('mygridMessage');javascript:doMembersDelete0('" + row + "','" +  id + "')");
    msgWriter.addAction("No","javascript:hideLayer('mygridMessage')");  
    msgWriter.showMessage("<nobr>Are you sure you want to delete all selected monitors</nobr>" + "?");
  }
  
  function doDelete1(id) {
  	var name = mygrid.cells(id,0).getValue();
    var row = id;   
    var isMulti = mygrid.getUserData(id,"isMulti"); 
    var msgWriter = new messageWriter("mygridMessage","Monitor Delete Action","<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid"),50);
    if (isMulti && isMulti == "true"){
    	msgWriter.addAction("Group only","javascript:hideLayer('mygridMessage');javascript:doDelete0('" + row + "','" +  id + "',false)");
    	msgWriter.addAction("Group and members","javascript:hideLayer('mygridMessage');javascript:doDelete0('" + row + "','" +  id + "',true)");
	    msgWriter.addAction("No","javascript:hideLayer('mygridMessage')");  
	    msgWriter.showMessage("<nobr>Are you sure you want to delete group " + name + " and <b>all its members</b></nobr>?");
	    deleteMulti = true;
    }else{
    	msgWriter.addAction("Yes","javascript:hideLayer('mygridMessage');javascript:doDelete0('" + row + "','" +  id + "')");
	    msgWriter.addAction("No","javascript:hideLayer('mygridMessage')");  
	    msgWriter.showMessage("<nobr>Are you sure you want to delete monitor </nobr>" + name + "?");
	    deleteMulti = false;
    }
  }
  
  function doDelete0(row,id,removeChildren){
  	deleteGridRow(mygrid,row,baseDirectory + "monitor/removeMonitorAction.jsp?monitorId=" + id + "&timestamp=" + new Date().getTime() + (removeChildren ? "&removeChildren=true" : ""));
  }
  
  function doMembersDelete0(row,id){  	
  	deleteGridRow(mygrid,row,baseDirectory + "monitor/removeMonitorAction.jsp?monitorIds=" + id + "&timestamp=" + new Date().getTime());
  }
  
  function doExecute(){
   var id = getFirstSelectedRow(mygrid);
    if (id == "") {
      return;
    }
		doExecute1(id);
  }
  
  function doExecute1(id) {
  	var url = "runMonitor.jsp?MONITOR_ID=" + id;
		sendAjaxRequest(url,function(req){
			updateTable();
		});
		setTimeout("updateTable()",200);
  }
  
  function doLogEdit(id){
  	path = "monitorDefinition.jsp?monitorId=" + id;
  	document.location = path;
  }
  
  function doEditMulti(id){
  	path = "monitorDefinition.jsp?type=MultiVerifier&monitorId=" + id;
  	document.location = path;
  }
  
  function doDuplicate(url){
  	if (url.indexOf('?') != -1){
  		url += "&DUPLICATE=true";
  	}else{
  		url += "?DUPLICATE=true";
  	}
  	path = "<%=BASE_DIRECTORY%>" + url;
  	document.location = path;
  }
  
  function viewMonitor(url){
  	path = "<%=BASE_DIRECTORY%>" + url;
  	document.location = path;
  }
  
  function goMonitor(id){
  	path = "<%=BASE_DIRECTORY%>monitor/monitorDefinition.jsp?useSessionLog=false";
  	if (id && id != ""){
  		path = path + "&monitorId="+id;
  	}
  	document.location = path;
  }
  
  function showHideReports(id){
  	var repDiv = document.getElementById('md_'+id+'_div');
  	var im = document.getElementById('img_'+id);
  	if (repDiv){
  		if (repDiv.style.display == ""){
  			repDiv.style.display = "none";
  			if (im){
  				im.src = "<%=BASE_DIRECTORY%>images/tree/plus.gif";
  			}
  		}else{
  			repDiv.style.display = "";
  			if (im){
  				im.src = "<%=BASE_DIRECTORY%>images/tree/minus.gif";
  			}
  		}
  	}
  }
  
	function showDesc(current,e,desc){
		var e = this.event || e;
		var tt = document.getElementById('monitorDescDiv');
		var tableWidth = desc.length * 6;
		var reportDescTab = document.getElementById("monitorDescTable");
		if (reportDescTab){
			reportDescTab.setAttribute("width",tableWidth);
		}
	  var sizeArr = getWindowSize();
	  var winWidth = 1280;
	  var winHeight = 1024;
	  if (sizeArr && sizeArr.length == 2){
	  	winWidth = sizeArr[0];
	  }
		
		x = (this.event ? document.body.scrollLeft + e.x : e.pageX);
	  y = (this.event ? document.body.scrollTop +  e.y : e.pageY);
		tt.style.left = x < (winWidth-tableWidth-50) ? x + 50 : (x - tableWidth > 0 ? x - tableWidth : 0);
		tt.style.top = y;
		var desc_td = document.getElementById('descTD');
		if (document.all){
			desc_td.innerText = desc;
		}else{
			desc_td.textContent = desc;
		}
		tt.style.display = "";
	}
	
	function hideDesc(){
		var tt = document.getElementById('monitorDescDiv');
		tt.style.display = "none";
	}

//filter grid contnet based on values of two filter fields
   
  
    
	var actionMonitorReq;
	var rowId = "";
	function setScheduler(id){
	  actionMonitorReq = GetXmlHttpObject();
	  if (!actionMonitorReq) return;
	  var url = "setMonitorScheduler.jsp?monitorId=" + id;
	  actionMonitorReq.onreadystatechange = setSchedulerCallBack;
	  actionMonitorReq.open('GET', url, true);
	  actionMonitorReq.send(null);  
	  
	}
	
	function setSchedulerCallBack() {
		if (actionMonitorReq.readyState == 4) {
			if (actionMonitorReq.status == 200) {
				updateTable();
			}
		}
	}	
	
	function handleMenuItems(){
		var editable = mygrid.getUserData(contextRowId,"editable");
		var executable = mygrid.getUserData(contextRowId,"executable");
    var type = mygrid.cells(contextRowId,1).getValue();  			
 		if (type == "Group"){	  
 		<% if (isAdd || isExecute){%>
 			<%if(isExecute) {%>
 				if(executable && executable == "true") {
 		    	aMenu.menu.showButtons("executeGroup");
 		    }		   
 			<%}
 			if(isAdd) {%>
 				if(editable && editable == "true") {
 		    	aMenu.menu.showButtons("editGroup,removeGroup");
 		    }		   
 			<%}
 		}else {%>
 			  aMenu.menu.hideBar();
 			<%}%> 			    			  
 		}else {  		
 		  <% if (isAdd || isExecute){%>
 			<%if(isExecute) {%>
 		    if(executable && executable == "true") {
 		    	aMenu.menu.showButtons("executeMonitor");
 		    }		   
 			<%}
 			%>
 			aMenu.menu.showButtons("showMonitorResults");
 			<%
 			if(isAdd) {%>
 				if(editable && editable == "true") {
 		    	aMenu.menu.showButtons("editMonitor,removeMonitor");
 		    }		   
 			<%}
 		  }else {%>
 			  aMenu.menu.hideBar();
 			<%}%>
 		}
  }
  
  function executeGroup0(){
    if (contextRowId && contextRowId != ""){
      doExecute1(contextRowId);
    }
  }
  
  function executeMonitor0(){
    if (contextRowId && contextRowId != ""){
      doExecute1(contextRowId);
    }
  }
  
  function showMonitorResults0(){
    if (contextRowId && contextRowId != ""){
      showResults();
    }
  }
  
  function editGroup0(){
    if (contextRowId && contextRowId != ""){
      doEditMulti(contextRowId);
    }
  }
  
  function editMonitor0(){
    if (contextRowId && contextRowId != ""){
      doLogEdit(contextRowId);
    }
  }
  
  function removeGroup0(){
    if (contextRowId && contextRowId != ""){
      doDelete1(contextRowId);
    }
  }
  
  function removeMonitor0(){
    if (contextRowId && contextRowId != ""){
      doDelete1(contextRowId);
    }
  }
	
</script>
</head>

<%
String onLoadFunctions = "initTables();";
if(showMenu) {
	onLoadFunctions = "initMenus();" + onLoadFunctions;
}
%>
<body onLoad="<%=onLoadFunctions %>" onUnload="destroyTables()" style="margin:0;padding:0;overflow:auto;" >
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td valign="top">
    	<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              
        <tr height="10">
          <td>
	          <jsp:include page="../common/pageMainHeader.jsp" flush="true">
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="headerTitle" value="Monitors" />
						</jsp:include>		
	         </td>
        </tr>
        <tr>                
          <td valign="top"> 
           <% 
           String addName = isAdd ? "New Monitor#New Group" : "";
           String addLink = isAdd ? "javascript:goNew()#javascript:goNewGroup()" : "";
           
           String tableNames = isAdd ? "Edit#Delete" : "";
           String tableActions = isAdd ? "javascript:doEdit()#javascript:doDelete()" : "";
           String ids = isAdd ? "Edit#Delete" : "";
           String selectTypes = isAdd ? "2#3" : "";
           
           if (tableNames.length() > 0){
         		tableNames += "*;*";
         		tableActions += "*;*";
         		ids += "*;*";
         		selectTypes += "*;*";
         	}
          if (isExecute){                	
          	tableNames += "Execute#";
        		tableActions += "javascript:doExecute()#";
        		ids += "Execute#";
        		selectTypes += "2#";
          }
           /*if (tableNames.length() > 0){
         		tableNames += "*;*";
         		tableActions += "*;*";
         		ids += "*;*";
         		selectTypes += "*;*";
         	}*/
         	tableNames += "Show Results#";
       		tableActions += "javascript:showResults()#";
       		ids += "ShowResult#";
       		selectTypes += "2#";
           
          String menu = showMenu ? "aMenu" : "";
           
          String monitorXMLUrl = "monitor/monitorsViewXML.jsp?monitorId=";
          String monitorXMLTreeUrl = "monitor/monitorsViewXML.jsp?dataOnly=true";
          %>                               
          <jsp:include page="../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
						<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
						<jsp:param name="initXML" value="<%=monitorXMLUrl%>" />
						<jsp:param name="updateXML" value="<%=monitorXMLTreeUrl%>" />
						<jsp:param name="menu" value="<%=menu%>"/>
						<jsp:param name="newActionNames" value="<%=addName%>" />
						<jsp:param name="newActions" value="<%=addLink%>" />
						<jsp:param name="tableActionNames" value="<%=tableNames%>" />
						<jsp:param name="tableActions" value="<%=tableActions%>" />
						<jsp:param name="tableActionIds" value="<%=ids%>" />
						<jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
						<jsp:param name="recordsText" value="Monitors" />
						<jsp:param name="style" value="main" />
						<jsp:param name="doubleClickAction" value="showResults" />
						<jsp:param name="lastSelectedRow" value="<%=lastSelectedRow%>" />																				
					</jsp:include>
<script>
function updateButtonActivate(rowid,id,columnType,gridType){
  if (!id || id == "") return;
  var editable = mygrid.getUserData(rowid,"editable"); 
 	var isMulti = mygrid.getUserData(rowid,"isMulti"); 
	if (isMulti && isMulti == "true" && id == "ShowResult"){
  	gridType = 0;
	}
	var zoomInUrl = mygrid.getUserData(rowid,"zoomInUrl");
	var executable = mygrid.getUserData(rowid,"executable");
 	if (gridType == columnType || (gridType == 2)){
 		if ((id == "Execute" && executable != "true") || (id == "ShowResult" && (!zoomInUrl || zoomInUrl == ""))){
 			disableActionButton(id);
 		}else{
			if ((id == "Edit" || id == "Delete") && editable == "false"){
				disableActionButton(id);
			}else{
				enableActionButton(id);
			}
		}
	}else {
  	disableActionButton(id);
	}
}

function onAfterDelete(){
	if(refreshMenus && parent.frames[0]!=null){
		if (deleteMulti){
			updateTable();
		}
		refreshMenus();
	}
}
 
var monitorId = "<%=monitorId%>";
var parentId = "";
 function endLoad(){
    hideLoading();
    mygrid.setSizes();        
    if (monitorId && monitorId != "" ){
    	<%
    	if (parentIds != null){
    		for (int i=0; i<parentIds.length; i++){	
    	%>
    	parentId = "<%=parentIds[i]%>"; 
    	if (parentId && parentId != "" && mygrid.doesRowExist(parentId)){
    		mygrid.openItem(parentId);
    	}
    	<%
    		}
    	}%>
      if (mygrid.doesRowExist(monitorId)){     
        mygrid.selectRowById(monitorId,"",true,true);
        mygrid.showRow(monitorId);
      }
      monitorId = "";
    }else {
      if (lastSelectedRow && lastSelectedRow != ""){
 		    var arr = lastSelectedRow.split(",");     
		    for (var i = 0; i < (arr.length - 1);i++){
		      if (mygrid.doesRowExist(arr[i])){
		        mygrid.selectRowById(arr[i],true,true,true);
		      }
		    }
		    if (mygrid.doesRowExist(arr[arr.length - 1])){
		      mygrid.selectRowById(arr[arr.length - 1],arr.length == 1 ? "" : true,true,true);
		      mygrid.openItem(arr[arr.length - 1]);
		      mygrid.showRow(arr[arr.length - 1]);
		    }                    
		  }
		}
  }
</script>
					</td>
				</tr>
			</table>
    </td>
  </tr>
</table>

</body>

</html>