<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.ui.grid.GridTable"%>
<%@ page import="xpolog.eye.site.ui.grid.models.MonitorsGridTableModel"%>
<%@ page import="xpolog.eye.site.*"%>
<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, null, true)) {
		return;
	}

	String isFilterStr = request.getParameter("isFilter");
  boolean isFilter = isFilterStr != null && isFilterStr.equals("true"); 

	UserContext userContext = UserEnvironment.getUserContext(request);
	
	
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = "../";
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String monitorId = request.getParameter("monitorId");
	
	MonitorsGridTableModel model = new MonitorsGridTableModel();
	model.setBaseDirectory(baseDirectory);
	model.setUserContext(userContext);
	if (monitorId != null && monitorId.length() > 0){
		model.addMonitorId(monitorId);
	}
	model.setGridName("mygrid" + suffix);
	model.init();
	GridTable table = new GridTable(model);
	request.setAttribute("gridTable" + suffix,table);
	
	request.getRequestDispatcher(baseDirectory + "widgets/grid/jsp/initTableXML.jsp").forward(request, response);	
%>