<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.verifiers.*"%>
<%@ page import="xpolog.eye.verifiers.admin.MultiVerifierBuilder"%>

<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
	String VERIFIER_BUILDER = "VERIFIER_BUILDER";

	UserContext userContext = UserEnvironment.getUserContext(request);
	
	MultiVerifierBuilder builder = (MultiVerifierBuilder)request.getSession().getAttribute(VERIFIER_BUILDER);
	MultiVerifier monitor = builder.getMultiVerifier();
	if (monitor == null){
		monitor = new MultiVerifier();
	}
	String verId = builder.getId();
	
	VerifierManager verManager = SiteManagment.getInstance().getVerifierManager();
	HashSet set = new HashSet();
	set.add(Verifier.ROOT_VERIFIER_ID);
  
	Verifier[] varr = verManager.getAllPossibleChildsVerifiers(userContext,verId,set,false);
	if (varr == null){
		varr = new Verifier[0];
	}
	Arrays.sort(varr,VerifierManager.verNameComp);

%>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
	<tr>
		<td>
		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="100%">
			<%if (varr.length > 0){%>
			<tr>
				<td width="100%" height="100%">
					<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
						<tr>
							<td>
								<span class="REGULARTEXT">Select the group's monitors:</span> 
							</td>
						</tr>
						<tr><td height="100%"></td></tr>
<!-- start verifiers settings -->
						<tr >
							<td width="100%" style="padding-top:10">
							<table border="0" width="500">
								<tr>
									<td width="200" height="18" align="center">
										<span class="REGULARTEXT" style="font-weight:bold">Available Monitors</span>
									</td>
									<td width="100" >&nbsp;</td>
									<td width="200"  align="center">
										<span class="REGULARTEXT" style="font-weight:bold">Selected Monitors</span>
									</td>
								</tr>
							<tr>
							<td width="200">
								<select size="10" style="width:200" name="availableVerifiersList" id="availableVerifiersList" multiple>
								<%for (int i = 0; i < varr.length; i++){ %>
									<option value="<%=varr[i].getId()%>"><%=varr[i].getName()%></option>
								<%}%>
								</select>
							</td>
							<td width="100">
							<table border="0" width="100">
								<tr>
									<td align="center">
										<a href="javascript:doVerifierAdd()" class="SMALLLINK">Add</a>
									</td>
								</tr>
								<tr>
									<td align="center">
										<a href="javascript:doVerifierRemove()" class="SMALLLINK">Remove</a>
									</td>
								</tr>
							</table>
							</td>
							<td width="200">
							<select size="10" style="width:200" name="SelectedVerifiersList" id="SelectedVerifiersList" multiple>
								<%
								String [] ids = monitor.getVerifiersIds();
								for (int i = 0; i < ids.length; i++){ 
									String name = null;
									for (int j = 0; j < varr.length; j++){
										if (ids[i].equals(varr[j].getId())){
											name = varr[j].getName();
											break;
										}
									}
									if (name != null){%>
								<option value="<%=ids[i]%>" class="TEXTBOX"><%=name%></option>
								<%} 
								}%>
							</select>
							</td>
							</tr>
							</table>
							</td>
						</tr>
<!-- end verifiers settings -->						
						
					</table>
				</td>
			</tr>
			<%}else{ %>
			<tr valign="top">
				<td>
					<span class="REGULARTEXT" style="color:#9E5B04">* At least one monitor should exist to add a group. </span>
					<a class="LINK" href="monitorDefinition.jsp">Create new Monitor</a>
				</td>
			</tr>
			<%} %>

		</table>
		</td>												
	</tr>
	<tr height="100%">
		<td>&nbsp;</td>
	</tr>
</table>
