<%@page import="java.util.LinkedList"%>
<%@page import="java.util.List"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page import="xpolog.eye.verifiers.Verifier"%>
<%@ page import="xpolog.eye.verifiers.VerifierManager"%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	//do whatever needed to remove the report
	String monitorId = request.getParameter("monitorId");
  String removeChildrenStr = request.getParameter("removeChildren");
  if (monitorId == null || monitorId.length() == 0){
  	monitorId = request.getParameter("monitorIds");
  }
  boolean removeChildren = removeChildrenStr != null && removeChildrenStr.equals("true");

	boolean success = true;
	String message = "";
	String childrenIdsList = null;
	if (monitorId != null) {
		String [] monitors = monitorId.split(",");
		VerifierManager verMgr = SiteManagment.getInstance().getVerifierManager();
		StringBuffer ids = new StringBuffer();
		for (int j = 0; j < monitors.length;j++){ 		  
		  Verifier monitor = verMgr.getVerfierFromId(monitors[j]);
		  String name = "";
		  if (monitor != null) {
			  name = monitor.getName();
		  }
		  //audit
		  AuditManager.getInstance().write(
		  AuditConstants.BASIC_AUDIT_LEVEL, userContext,
		  AuditConstants.CHANGE, "remove monitor",
		  AuditConstants.VERIFIERS, "remove monitor " + name);

		  try {
			  List children = removeChildren ? verMgr.getAllChildsForVerifier(monitors[j]) : null;
			  verMgr.removeVerifier(monitors[j], userContext, removeChildren);
			  if (removeChildren){
				  if (children != null){
					  Verifier ver = null;					  
					  for (int i=0; i<children.size(); i++){
						  ver = (Verifier)children.get(i);
						  if (ver != null){
							  if (ids.length() > 0){
								  ids.append(",");
							  }
							  ids.append(ver.getId());
						  }
					  }
					  childrenIdsList = ids.toString();
			  	}
			  }		 
		  } catch (Exception e) {
			  ErrorModel.log.error("Failed to remove monitor " + name
				  	+ " with id " + monitorId, e);
			  success = false;
			  message = e.getMessage();
		  }
		}
	}else {
		message = "No monitor selected, please refresh and try again";
	}
	String xml = GridModelActionsHelper.getResultXML(success, message, "", childrenIdsList);

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	
	out.write(xml);
	out.flush();
%>
