<%@ page language="java"%>

<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page import="xpolog.eye.verifiers.Verifier"%>
<%@ page import="xpolog.eye.verifiers.VerifierManager"%>
<%
	String monitorId = request.getParameter("monitorId");
	boolean success = true;
	String message = "";
	if (monitorId != null) {
		VerifierManager verMgr = SiteManagment.getInstance().getVerifierManager();
		Verifier monitor = verMgr.getVerfierFromId(monitorId);
		XpoScheduledOperation schedOp;
		if (monitor != null) {
			schedOp = monitor.getSchedOp();
			if (schedOp != null){
				int state = schedOp.getState();
		    if(state == XpoScheduledOperation.STATE_ACTIVE){
					schedOp.setSuspend();
		  		verMgr.addVerifier(monitor);
		  	}else if(state == XpoScheduledOperation.STATE_SUSPENDED){
					schedOp.setActive();
		  		verMgr.addVerifier(monitor);
		  	}
			}
		}
	}else {
		message = "No monitor selected, please refresh and try again";
	}
	String xml = GridModelActionsHelper.getResultXML(success, message);

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	
	out.write(xml);
	out.flush();
%>
