
<%
String baseDirectory = request.getParameter("baseDirectory");
if (baseDirectory == null){
	baseDirectory = "";
}
String urlStr = xpolog.config.Configuration.getInstance().getPropertiesManager().getProperty("licenseDemo.register", "http://www.xplg.com/home/common/productRegisterAction.jsp");

%>


<script>
var key = "";
function showRegistrationDiv(){
  if (document.getElementById("registrationDiv").style.display == "none"){
    showHideLayerInMiddle("registrationDiv",-1,-1,true);
  }
}

function hideRegistrationDiv(){
  document.getElementById("registrationDiv").style.display = "none";
}

function registerFinished(){
 	this.location = location;
}

function showRegistrationSuccessMessage(){
  showRegistrationSuccessMessage0("Thank you for registering.<br>Your evaluation period has been extended.");
}

function showRegistrationSuccessMessage0(msg){
	var msgWriter = new messageWriter("firstTimeDivMessage","XpoLog Center Suite",BASE_DIRECTORY);
  msgWriter.setYParent(document.getElementById("firstTimeDiv"),50);
  msgWriter.width = "400";
  msgWriter.height = "150";
  msgWriter.addAction("OK","javascript:registerFinished()");
  msgWriter.showMessage(msg);
}

function showRegistrationFailureMessage(){
  var msgWriter = new messageWriter("firstTimeDivMessage","XpoLog Center Suite",BASE_DIRECTORY);
  msgWriter.setYParent(document.getElementById("firstTimeDiv"),50);
  msgWriter.width = "300";
  msgWriter.height = "150";
  msgWriter.addAction("OK","javascript:registerFailureClosed()");
  msgWriter.showMessage("Online registration has failed.<br>Click&nbsp;<a href='mailto:register@xpolog.com?subject=XpoLog License Registration'><span class='START_WIZARD_ITEM_TEXT'>here</span></a><span> to register by email</span>");
}

function registerFailureClosed(){
  hideLayer('firstTimeDivMessage');
  hideRegistrationDiv();
}

function doRegistration(){

  showSimpleMessage("Registration in progress","Registering online, please stand by",300,60);
  var url = "<%=baseDirectory%>portal/registerDivInfo.jsp";
  var params = "fullname=" + encode(document.getElementById("registrationName").value);
  params = params + "&email=" + encode(document.getElementById("registrationEmail").value);
  var location = this.location;
	sendAjaxRequest(url,function(req){	   	   
		 var xmlDoc = req.responseXML.documentElement;
		 var resultElement = xmlDoc.getElementsByTagName("client")[0];
		 var resultElementText;
		 if(resultElement) {
		 	 resultElementText = getXMLElementValue(resultElement);
		 }
		 if (resultElementText && resultElementText == "true"){
		   resultElement = xmlDoc.getElementsByTagName("key")[0];		 
 		   var resultElementText;
		 	 if(resultElement) {
		 	 	 resultElementText = getXMLElementValue(resultElement);
		 	 }
		 	 var key = "";
		 	 if (resultElementText){
	 		   key = resultElementText;
	 		 }
 		   sendRegistration(key);
		 }else {
		   hideSimpleMessage();
		   resultElement = xmlDoc.getElementsByTagName("message")[0];		 
 		   var resultElementText;
 		 	 if(resultElement) {
 		 	 	 resultElementText = getXMLElementValue(resultElement);
 		 	 }
 		 	 var message = "";
  		 if (resultElementText){
 		     message = resultElementText;
 		   }
 		   if (message != ""){ 		   
 		     showMessage("Registration Problem",message,300,150);
 		   }else { 		     
 		     showRegistrationSuccessMessage();
 		   }
		 }		  
  }, "POST", params);			
}

function sendRegistration(key){
  var params = "fullname=" + encode(document.getElementById("registrationName").value);
  params = params + "&email=" + encode(document.getElementById("registrationEmail").value);
  params = params + "&key=" + key;
  var url = "<%=urlStr%>";
  //var url = "http://aaa:20303/logeye/test/registeration.jsp";
  try {
	sendAjaxRegisterRequest(url,function(req){
	   hideSimpleMessage();
		 var xmlDoc = req.responseXML.documentElement;
		 var resultElement = xmlDoc.getElementsByTagName("message")[0];
		 var resultElementText;
		 if(resultElement) {
		 	 resultElementText = getXMLElementValue(resultElement);
		 }
		 var message = "";
		 if (resultElementText){
		   message = resultElementText;
		 }
 		 if (message != ""){ 		   
 		   showMessage("Registration Result",message,300,150);
 		 }else {
 		   updateRegistration(); 		  
 		 }
 		 
  }, "POST", params,true);	
   }catch (e){
     hideSimpleMessage();
    showRegistrationFailureMessage();
  }
}

function updateRegistration(){
  var url = "<%=baseDirectory%>portal/registerDivAction.jsp";
	sendAjaxRequest(url,function(req){
		 var xmlDoc = req.responseXML.documentElement;
		 var resultElement = xmlDoc.getElementsByTagName("message")[0];
		 var resultElementText;
		 if(resultElement) {
		 	 resultElementText = getXMLElementValue(resultElement);
		 }
		 var msg = "";
		 if (resultElementText){
			 msg = resultElementText;
		 }
 		 if (msg != ""){
 		   showMessage("Registration Problem",msg,300,150);
 		 }else {
 		   showRegistrationSuccessMessage();
 		 }
  });			
}

function sendAjaxRegisterRequest(page,resultFunc,method,parameters,async){
 var req = GetXmlHttpObject();
  if (!req) return;
  var m = method;
  if (!m){
    m = "GET";
  }
 
    req.onreadystatechange = function(){
      if (req.readyState && req.readyState == 4) {
        if (req.status == 200) { 
           if (resultFunc){          
             resultFunc(req);
             req = null;
           }  			              
   		  } else {
   		    hideSimpleMessage();   			 
          showRegistrationFailureMessage();
          
        }
      }      
    };
   
  
  if (m == "GET" || m == "get"){
    var index = page.indexOf("?"); 
    var timestampParam = "";
    if (index == -1){
      timestampParam += "?";
    }else if (index < (page.length - 2)){
      timestampParam += "&";
    }
    timestampParam += "ajaxTimestamp=" + new Date().getTime();
    page += timestampParam;
  }
  
  req.open(m, page, async);
 
  if (m == "POST"){
    if (!parameters){
      parameters = "ajaxTimestamp=" + new Date().getTime();
    }else {
      if (parameters != ""){
        parameters += "&";
      }
      parameters += "ajaxTimestamp=" + new Date().getTime()
    }
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    req.setRequestHeader("Content-length", parameters.length);
    req.setRequestHeader("Connection", "close");
    req.send(parameters);
  }else {
    req.send(null);
  }
}
</script>
<div id="registrationDiv" style="position:absolute;overflow:hidden;display:none;width:550;height:360;left:200;top:50;border:1px solid gray;z-index:15">
	<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
	<tr>
		<td bgcolor="#FFFFFF" style="padding:5">
			<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
				<tr height="50">
					<td background="images/portal/btns/wizard/title_background.gif" style="background-repeat:repeat">
						<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
							<tr>
								<td style="padding-left:30"><span class="START_WIZARD_TITLE_TEXT">XpoLog Center Registration</span></td>
								<td width="10" valign="top" style="padding-top:5;padding-right:5" ><a href="javascript:hideRegistrationDiv()"><img  src="images/portal/btns/wizard/close.gif" border="0"></a></td>
							</tr>
						</table>
					</td>
				</tr>

				<tr>
					<td>
						<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
							<tr height="10">
								<td class="START_WIZARD_ITEM_SMALL_TEXT" style="padding-left:30px;padding-top:5px;" colspan="2">Please enter the following details to register <br>Get <b>additional 15 days</b> for your evaluation free of charge</td>
							</tr>
							
							<tr height="20"><td>&nbsp;</td></tr>
							
							<tr height="10">
								<td>
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr height="10">
											<td class="START_WIZARD_ITEM_SMALL_TEXT" style="padding-left:30px;padding-top:5px;width:100px">Full Name:</td>
											<td><input type="text" class="" id="registrationName" name="registrationName" style="width:200px"></td>
										</tr>
										<tr height="5" style="font-size:1pt"><td colspan="2">&nbsp;</td></tr>
										<tr height="10">
											<td class="START_WIZARD_ITEM_SMALL_TEXT" style="padding-left:30px;padding-top:5px;width:100px">Email:</td>
											<td><input type="text" class="" id="registrationEmail" name="registrationEmail" style="width:200px"></td>
										</tr>
										<tr height="5"><td colspan="2">&nbsp;</td></tr>
									</table>
								</td>
							</tr>
							
							<tr height="*"><td>&nbsp;</td></tr>
							
							<tr style="font-size:1" height="3">
								<td align="right" style="padding-right:50;padding-bottom:5">
									<div  id="adminGeneralCtrlButtonTDRegitration" >
										<table border="0" width="50" cellspacing="0" height="100%">
												<tr >									
													<jsp:include page="../common/ctrlButton.jsp" flush="true">
														<jsp:param name="base_directory" value="<%=baseDirectory%>"/>
														<jsp:param name="name" value="Register"/>
														<jsp:param name="action" value="javascript:doRegistration()"/> 
													</jsp:include>
												</tr>
										</table>		
									</div>											
								</td>				
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
</table>
</div>