<%@page import="xpolog.eye.site.portal.UserPortalHelper"%>
<%@page import="xpolog.eye.site.portal.UserPortalLbmRequest"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.LogBrowsingManager"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.common.JobStatus"%>
<%@ page import="xpolog.eye.data.transform.TransformationFactory"%>
<%@ page import="xpolog.eye.data.transform.Transformer"%>
<%@ page import="xpolog.eye.pack.ExportFlow"%>
<%@ page import="xpolog.eye.snapshot.Snapshot"%>
<%@ page import="xpolog.eye.site.ProgressRunner"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.site.portal.UserPortalManager"%>
<%@ page import="xpolog.eye.site.portal.UserPortalSearchRunner"%>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page import="xpolog.eye.util.Constants"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>

<%@ page import="java.io.File"%>
<%@ page import="java.util.Map"%>

<%!static final String BASE_DIRECTORY = "../";%>

<%
	String ERROR_OBJ = "ERROR_OBJ";
	String CURRENT_USER_PORTAL_REQUEST = "CURRENT_USER_PORTAL_REQUEST";
	final String USER_PORTAL_CURRENT_LOG = UserPortalSearchRunner.USER_PORTAL_CURRENT_LOG;
	
	final UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	String charset = "UTF-8";
	response.setContentType("text/html; charset=" + charset);
	request.setCharacterEncoding(charset);

	final JobStatus jobStatus = new JobStatus();
	
	final String action = request.getParameter("action");

	boolean success = false;
	String message = "";
	
	final UserPortalManager portalMgr = UserPortalManager.getInstance();
	final UserPortalSearchRunner portalSearchRunner = portalMgr.createRunner(request,action,jobStatus);
	portalSearchRunner.setJobStatus(jobStatus);
	final UserPortalLbmRequest userPortalRequest = portalSearchRunner.createDisplayItemRequest(request.getParameterMap(),userContext);
	final UserPortalLbmRequest.MissingMandatoryItemsAndGroups missingItemsAndGroups = userPortalRequest.getMissingSearchCriteria();
	request.getSession().setAttribute(CURRENT_USER_PORTAL_REQUEST,userPortalRequest);
	
	ProgressRunner runner = new ProgressRunner() {
    public void run(HttpServletRequest request){
    	int executionStatus = Constants.ExecutionStatus.RUNNING;
    	setExecutionStatus(executionStatus);
    	String executionMsg = "";
      try{
      	Thread.sleep(500);
      	setStatus(jobStatus);
      	if (userPortalRequest.isEmpty()){
      		executionStatus = Constants.ExecutionStatus.FAILURE;
      		executionMsg = "Please enter search criteria";
      	}else if (missingItemsAndGroups != null && missingItemsAndGroups.hasMissingData()){
      		executionStatus = Constants.ExecutionStatus.FAILURE;
      		executionMsg = UserPortalHelper.getErrorMessageFromMissingCriteria(missingItemsAndGroups);
      	}else{
        	LogBrowsingManager lbm = portalSearchRunner.createSearchPortalLogBrowserManager();
        	if (lbm != null && (getExecutionStatus() != Constants.ExecutionStatus.FAILURE || getExecutionStatus() != Constants.ExecutionStatus.CANCELED)){
        		request.getSession().setAttribute(USER_PORTAL_CURRENT_LOG,lbm);
        		executionMsg = USER_PORTAL_CURRENT_LOG;
        		if (action != null && action.equals("export")){
        			Integer exportTo = portalMgr.getExportTo();
        			if (exportTo != null){
        				Transformer trans = TransformationFactory.getTransformaerByType(exportTo);
        				if (trans == null){
        					executionStatus = Constants.ExecutionStatus.FAILURE;
        					executionMsg = "Could not export log";
        				}else{
        					try{
        				    ExportFlow flow = new ExportFlow();
        				    flow.setLogBrowsingManager(lbm);
        				    flow.setTransformer(trans);
        				    File zipFile = flow.execute();
        				    executionStatus = Constants.ExecutionStatus.SUCCESS;
        				    executionMsg = zipFile.getName(); 
        					}catch(Exception e){
        						executionStatus = Constants.ExecutionStatus.FAILURE;
        						executionMsg = "Could not export log";
        					}
        				}
        			}
        		}else if (action != null && action.equals("createSnapshot")){
        			Snapshot snapshot = portalSearchRunner.createSnapshot();
        			if (snapshot != null){
        				executionStatus = Constants.ExecutionStatus.SUCCESS;
        				executionMsg = snapshot.getId();
        			}else{
        				executionStatus = Constants.ExecutionStatus.FAILURE;
        				executionMsg = "Could not create snapshot";
        			}
        		}else{
        			executionStatus = Constants.ExecutionStatus.SUCCESS;
        		}
        	}else{
        		executionStatus = Constants.ExecutionStatus.FAILURE;
          	//System.out.println("3: " + executionStatus);
        		executionMsg = "No data was found according to search criteria";
        	}
      	}
      	
      }catch(Exception e){
      	String err = XpologUtil.getErrorMessage(e);
    		StringBuffer sb = new StringBuffer("The following error occured while searching:");
    		sb.append(err);
    		executionStatus = Constants.ExecutionStatus.FAILURE;
    		executionMsg = sb.toString();
    	}
      if (getExecutionStatus() != Constants.ExecutionStatus.CANCELED){
      	setExecutionStatus(executionStatus);
      	setExecutionMessage(action + ";" + executionMsg);
      }
		}
    
    public void stop(){
    	super.stop();
    	portalSearchRunner.cancel();
    }
	};
	env.setProgressRunner(runner);
	String userSearchSummary = userPortalRequest != null ? userPortalRequest.getSummary(request.getParameterMap()) : "";
	//AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	//		userContext, AuditConstants.CHANGE, "execute user search", AuditConstants.USER_PORTAL_SEARCH, "Execute search: " + userSearchSummary);

 	
	String xml = GridModelActionsHelper.getResultXML(success,message);	
  response.setContentType("text/xml");
  response.setHeader("Pragma-Control", "no-cache");
  response.setHeader("Cache-Control", "no-cache");
  response.setHeader("Expires", "0");

  out.write(xml);
	out.flush();

%>
