<%@ page language="java"%>

<%@ page import="java.util.List"%>
<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.managment.ApplicationComponent"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.security.UserSecurity"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.security.XpologLicenseManager"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>

<%!
static final String BASE_DIRECTORY = "../";
%>

<%
String baseDirectory = request.getParameter("baseDirectory");
if(baseDirectory == null) {
	baseDirectory = BASE_DIRECTORY;
}

WebSecurityManager securityManager = WebSecurityManager.getInstance();
if (!securityManager.checkForPermission(request,response,null,true)){
  return;
}

UserSecurity user = securityManager.getUserSecurity(request);
UserContext userContext = UserEnvironment.getUserContext(request);

boolean isPermittedAddLog = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_LOG_PERMISSION);
boolean isPermittedAddModule = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_MODULE_PERMISSION);
boolean isPermittedSettings = securityManager.isHavePermission(userContext,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION);
boolean haveQuickStart = isPermittedAddLog || isPermittedAddModule;

boolean isPermittedAddVerify = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_VERIFY_PERMISSION);
boolean isPermittedEditVerify = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.EDIT_VERIFY_PERMISSION);

boolean isPermittedAddReport = securityManager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.EDIT_REPORTS_PERMISSION);
boolean isPermittedViewReport = securityManager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION);
boolean isPermittedVerify = isPermittedAddVerify || isPermittedEditVerify;

boolean isPermittedAddLogCollection = securityManager.isHavePermission(userContext,ActionsPermissionConstants.LogCollectionPermissions.EDIT_LOG_COLLECTOR_PERMISSION);
boolean isPermittedViewLogCollection = securityManager.isHavePermission(userContext,ActionsPermissionConstants.LogCollectionPermissions.VIEW_LOG_COLLECTION_PERMISSION);
boolean isPermittedLogCollection = isPermittedViewLogCollection || isPermittedAddLogCollection;

boolean presentQuickStart = isPermittedAddLog || isPermittedAddReport || isPermittedAddVerify;

boolean valid = SiteManagment.getInstance().getXpologManagment().isValidToBeActive();

boolean isTestingBuid = SiteManagment.getInstance().isTestingBuild();

boolean isDemo = XpologLicenseManager.getInstance().isDemo();
%>

<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
	<tr valign="top" height="10px">
		<td>
			<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
				<tr height="10px">
					<td class="HOME_PAGE_LEFT_PANEL_DARK_BACKGROUND HOME_PAGE_LEFT_PANEL_SECTION_TITLE_CELL HOME_PAGE_LEFT_PANEL_SECTION_TITLE_TEXT">
					</td>
				</tr>
			</table>
		</td>
	</tr>
</table>