<%@ page language="java"%>

<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.site.widgets.view.WidgetsView"%>
<%@ page import="xpolog.eye.site.widgets.XpoLogWidgetsManager"%>
<%@ page import="xpolog.eye.site.widgets.view.portal.PortalWidgetsViewContainer"%>

<%!
static final String BASE_DIRECTORY = "../../../";

%>

<%

UserContext userContext = UserEnvironment.getUserContext(request);
WebSecurityManager manager = WebSecurityManager.getInstance();

WidgetsView view = null;
String viewId = request.getParameter("viewId");
if (viewId != null && viewId.length() > 0){
  view = XpoLogWidgetsManager.getIntsance().getWidgetsView(request,WidgetsView.PORTAL_VIEW_TYPE,viewId);  
}

String message = "";

String gadgetId = request.getParameter("gadgetId");
String targetLayoutId = request.getParameter("targetLayoutId");
String nextGadgetId = request.getParameter("nextGadgetId");

boolean shouldRefreshGadget = false; 
try {
	if(view != null) {
		PortalWidgetsViewContainer portalContainer = (PortalWidgetsViewContainer)view.getContainer();
		shouldRefreshGadget = portalContainer.movePortalGadget(gadgetId, targetLayoutId, nextGadgetId);
		XpoLogWidgetsManager.getIntsance().updateWidgetsView(request,view);
	}
}catch (Exception e){
  ErrorModel.log.error("Failed to move gadget " + gadgetId + " to layout " + targetLayoutId + " (" + nextGadgetId + ") in view " + viewId,e); 
  message = "Failed to move gadget";
}
response.setContentType("text/xml; charset=UTF-8");
%>

<Result>
	<ShouldRefreshGadget value="<%=shouldRefreshGadget %>" />
	<Message><%=message%></Message>
</Result>
