<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request,response,ActionsPermissionConstants.DashboardsPermissions.VIEW_DASHBOARDS_PERMISSION,true)){
  return;
}
boolean hasViewDashboardsPermission = manager.checkForPermission(request,response,ActionsPermissionConstants.DashboardsPermissions.VIEW_DASHBOARDS_PERMISSION,false);
boolean hasEditDashboardPermission = manager.checkForPermission(request,response,ActionsPermissionConstants.DashboardsPermissions.EDIT_DASHBOARD_PERMISSION,false);

UserContext userContext = UserEnvironment.getUserContext(request);

String lastSelectedRow = (String)request.getSession().getAttribute("lastSelectedPortalView");
if (lastSelectedRow == null){
	lastSelectedRow = "";
}

%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>


<jsp:include page="../../../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<%
boolean showMenu = true;
String menuIds = "viewPortalView,editPortalView,removePortalView";
String menuTexts = "View,Edit,Delete";
String menuHrefs = "javascript:doView0();,javascript:editPortalView0();,javascript:removePortalView0();";
if(hasViewDashboardsPermission && hasEditDashboardPermission) {
	menuIds = "viewPortalView,editPortalView,removePortalView";
	menuTexts = "View,Edit,Delete";
	menuHrefs = "javascript:doView0();,javascript:editPortalView0();,javascript:removePortalView0();";
}else if(hasViewDashboardsPermission) {
	menuIds = "viewPortalView";
	menuTexts = "View";
	menuHrefs = "javascript:doView0();";
}else	if(hasEditDashboardPermission) {
		menuIds = "editPortalView,removePortalView";
		menuTexts = "Edit,Delete";
		menuHrefs = "javascript:editPortalView0();,javascript:removePortalView0();";
}else{
	showMenu = false;
}
if (showMenu){
%>
<jsp:include page="../../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<jsp:include page="../../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
  <jsp:param name="showMenu" value="<%=showMenu%>" />
  <jsp:param name="menuIds" value="<%=menuIds%>" />
  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
</jsp:include>
<%
}
%>

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";  
	
	function init() {
	}
	
  function goNew(){
	  document.location.href = baseDirectory + "portal/widgets/admin/editPortalView.jsp";
  }
  
  function doEdit(){
    var viewId = getFirstSelectedRow(mygrid);
    if (viewId == "") {
     return;
    }
    doEdit1(viewId);
  }
  
  function doEdit1(viewId){
   document.location.href = baseDirectory + "portal/widgets/admin/editPortalView.jsp?viewId=" + viewId;
  }
  
  function doDelete(){
    var viewId = getFirstSelectedRow(mygrid);
    if (viewId == "") {
      return;
    }
    doDelete1(viewId);
  }
  
  function doDelete1(viewId){
    var name = mygrid.cells(viewId,0).getValue();
    var row = viewId;
    var msgWriter = new messageWriter("mygridMessage","Dashboard Delete Action","<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid"),50);
    msgWriter.addAction("Yes","javascript:hideLayer('mygridMessage');javascript:doDelete0('" + row + "','" +  viewId + "')");
    msgWriter.addAction("No","javascript:hideLayer('mygridMessage')");  
    msgWriter.showMessage("<nobr>Are you sure you want to delete the dashboard </nobr>" + name + "?");
  }
  
  function doDelete0(row,id){
  	deleteGridRow(mygrid,row,baseDirectory + "portal/widgets/admin/removePortalViewAction.jsp?viewId=" + id + "&gridAction=true&timestamp=" + new Date().getTime());
  }
  
  function doView() {
	  var viewId = getFirstSelectedRow(mygrid);
    if (viewId == "") {
      return;
    }
    doView1(viewId);
  }
  
  function doView1(viewId) {
	  document.location.href = baseDirectory + "portal/widgets/view/widgetsPortalView.jsp?fullPage=true&selectedView=" + viewId;
  }
	
  function doView0(){
    if (contextRowId && contextRowId != ""){
    	doView1(contextRowId);
    }
  }

	function editPortalView0(){
	  if (contextRowId && contextRowId != ""){
	    doEdit1(contextRowId);
	  }
	}
  
  function removePortalView0(){
    if (contextRowId && contextRowId != ""){
      doDelete1(contextRowId);
    }
  }
  
  function handleMenuItems(){
		var editable = mygrid.getUserData(contextRowId,"editable");
    var type = mygrid.cells(contextRowId,1).getValue();  			
 		<% if (hasViewDashboardsPermission && hasEditDashboardPermission){%>
			aMenu.menu.showButtons("viewPortalView");
			if(editable && editable == "true") {
				aMenu.menu.showButtons("editPortalView,removePortalView");
			}		   
 		<%}else if (hasViewDashboardsPermission){%>
	    aMenu.menu.showButtons("viewPortalView");
 		<%}else if (hasEditDashboardPermission){%>
	    aMenu.menu.showButtons("editPortalView,removePortalView");
 		<%}else {%>
		  aMenu.menu.hideBar();
 		<%}%>
  }
  
  
  
  

</script>
</head>

<%
String onLoadFunctions = "initTables();init()";
if(showMenu) {
	onLoadFunctions = "initMenus();" + onLoadFunctions;
}
%>
<body onLoad="<%=onLoadFunctions %>" onUnload="destroyTables()" style="margin:0;padding:0;overflow:auto;" >

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td valign="top">
   		<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              
        <tr height="10">
          <td>
            <jsp:include page="../../../common/pageMainHeader.jsp" flush="true">
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="headerTitle" value="Dashboards" />
						</jsp:include>
       		</td>
      	</tr>
      	<tr>                
        	<td valign="top"> 
            <% 
            String addName = hasEditDashboardPermission ? "New Dashboard" : "";
            String addLink = hasEditDashboardPermission ? "javascript:goNew()" : "";
            
            String tableNames = hasEditDashboardPermission ? "Edit#Delete" : "";
            String tableActions = hasEditDashboardPermission ? "javascript:doEdit()#javascript:doDelete()" : "";
            String ids = hasEditDashboardPermission ? "Edit#Delete" : "";
            String selectTypes = hasEditDashboardPermission ? "2#2" : "";
            
            if (tableNames.length() > 0){
          		tableNames += "*;*";
          		tableActions += "*;*";
          		ids += "*;*";
          		selectTypes += "*;*";
          	}             	
           	tableNames += "View Dashboard#";
         		tableActions += "javascript:doView()#";
         		ids += "View#";
         		selectTypes += "2#";
            
         		String menu = showMenu ? "aMenu" : "";
            
            %>
						<jsp:include page="../../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="initXML" value="portal/widgets/admin/portalViewsXML.jsp" />
							<jsp:param name="menu" value="<%=menu%>"/>
							<jsp:param name="newActionNames" value="<%=addName%>" />
							<jsp:param name="newActions" value="<%=addLink%>" />
							<jsp:param name="tableActionNames" value="<%=tableNames%>" />
							<jsp:param name="tableActions" value="<%=tableActions%>" />
							<jsp:param name="tableActionIds" value="<%=ids%>" />
							<jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
							<jsp:param name="recordsText" value="Dashboards" />
							<jsp:param name="style" value="main" />
							<jsp:param name="doubleClickAction" value="doEdit" />
							<jsp:param name="lastSelectedRow" value="<%=lastSelectedRow%>" />
							<jsp:param name="showSelectedRowOnLoad" value="true" />
						</jsp:include>
    			</td>
  			</tr>
			</table>
		</td>
	</tr>
</table>
<script>
function updateButtonActivate(rowid,id,columnType,gridType){
	if (!id || id == "") return;
	var editable = mygrid.getUserData(rowid,"editable");
	if (gridType == columnType || gridType == 2){
		if ((id == "Edit" || id == "Delete") && editable == "false"){
			disableActionButton(id);
		}else{
			enableActionButton(id);
		}
	}else {
		disableActionButton(id);
	}
}

function onAfterDelete(){
	if (typeof parent.updateDashboardsMenu == "function"){
		parent.updateDashboardsMenu();
	}
}
 

</script>

</body>

</html>