<%@ page language="java"%>

<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page import="xpolog.eye.site.widgets.view.WidgetsView"%>
<%@ page import="xpolog.eye.site.widgets.XpoLogWidgetsManager"%>

<%!
static final String BASE_DIRECTORY = "../../../";

%>

<%

UserContext userContext = UserEnvironment.getUserContext(request);
WebSecurityManager manager = WebSecurityManager.getInstance();

WidgetsView view = null;
WidgetsView templateView = null;
String viewId = request.getParameter("viewId");

boolean success = false;
String message = "";
try {
	if (viewId == null || viewId.length() == 0){
		viewId = "No view was given";  
  }else {
  	view = XpoLogWidgetsManager.getIntsance().getWidgetsView(request,WidgetsView.PORTAL_VIEW_TYPE,viewId);
  	if(view != null) {
			//audit
	  	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	  	userContext, AuditConstants.CHANGE, "remove dashboard", AuditConstants.WIDGETS, "remove dashboard " + view.getName());
	
	    XpoLogWidgetsManager.getIntsance().removeWidgetsView(request,WidgetsView.PORTAL_VIEW_TYPE,viewId);
  	}
  	success = true;
	}
}catch (Exception e){
  ErrorModel.log.error("Failed to remove portal view " + viewId,e); 
  message = "Failed to remove portal view " + viewId;
}

String gridActionStr = request.getParameter("gridAction");
boolean gridAction = gridActionStr != null && gridActionStr.equals("true");
if(gridAction) {
	String xml = GridModelActionsHelper.getResultXML(success, message);

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	
	out.write(xml);
	out.flush();
}else {
	response.setContentType("text/xml; charset=UTF-8");
%>
<Result>
		<Message><%=message%></Message>
		<Status><%=String.valueOf(success)%></Status>
	</Result>
<%
}
%>