<%@ page language="java"%>

<%@ page import="xpolog.eye.data.aggregate.admin.DataExpressionAggConf"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.data.filters.FilterManager"%>
<%@ page import="xpolog.eye.site.widgets.data.handler.report.ReportWidgetDataHandler"%>
<%@ page import="xpolog.eye.reports.Report"%>
<%@ page import="xpolog.eye.reports.ReportsManager"%>
<%@ page import="xpolog.eye.reports.agg.admin.AggCaseBuilder"%>
<%@ page import="xpolog.eye.reports.agg.admin.AggReport"%>
<%@ page import="xpolog.eye.reports.agg.admin.AggReportBuilder"%>
<%@ page import="xpolog.eye.reports.agg.admin.AggReportConstants"%>
<%@ page import="xpolog.eye.reports.agg.admin.LogAggCaseBuilder"%>
<%@ page import="xpolog.eye.reports.agg.admin.LogDimsAggCaseBuilder"%>
<%@ page import="xpolog.eye.reports.agg.admin.LogFunctionAggCaseBuilder"%>
<%@ page import="xpolog.eye.reports.agg.admin.LogKnowledgeAggCaseBuilder"%>
<%@ page import="xpolog.eye.reports.agg.admin.LogSimilarityAggCaseBuilder"%>
<%@ page import="xpolog.eye.reports.agg.result.LogFunctionExpressionInfo"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.util.WebUtil"%>
<%@ page import="xpolog.logic.reports.agg.admin.TranReportBuilder"%>

<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
String resultType = request.getParameter("resultType");
if(resultType == null || resultType.length() == 0) {
	resultType = "xml";
}

String reportId = request.getParameter("reportId");
if(reportId == null) {
	reportId = "";
}
String selectedCaseId = request.getParameter("caseId");
if(selectedCaseId == null) {
	selectedCaseId = "";
}

UserContext userContext = UserEnvironment.getUserContext(request);
ReportsManager reportMgr = ReportsManager.getInstance();
Report report = null;
String reportType = null;
AggReportBuilder builder = null;
List reportCaseIdsList = null, reportCaseNamesList = null;;
if(reportId.length() > 0) {
	report = reportMgr.getReportById(reportId);
	if(report != null) {
		reportType = report.getReportType();
		builder = reportType.equals(Report.TRANSACTION_TYPE) ? new TranReportBuilder((AggReport)report) :  new AggReportBuilder((AggReport)report);
		builder.setNew(false);
		builder.updateInfo();
		
		// filters
		List caseBuilders = builder.getBuildersListByType(AggReportConstants.LOG_CASE_TYPE);
		if(caseBuilders != null && caseBuilders.size() > 0) {
			if(reportCaseIdsList == null) {
				reportCaseIdsList = new ArrayList();
				reportCaseNamesList = new ArrayList();
			}
			
			String caseId = "Filters" + builder.getDefaultLogId();
			String caseName = "Filters Summary";
			
			String caseKey = AggReportBuilder.LOG_CASE_TYPE + ReportWidgetDataHandler.CASE_TYPE_SEPARATOR + ReportWidgetDataHandler.REPORT_GADGET_PIE_CHART + ReportWidgetDataHandler.RESPONSE_TYPE_SEPARATOR + caseId;
			reportCaseIdsList.add(caseKey);
			reportCaseNamesList.add(caseName + " Pie Chart");
			caseKey = AggReportBuilder.LOG_CASE_TYPE + ReportWidgetDataHandler.CASE_TYPE_SEPARATOR + ReportWidgetDataHandler.REPORT_GADGET_OVER_TIME_GRAPH + ReportWidgetDataHandler.RESPONSE_TYPE_SEPARATOR + caseId;
			reportCaseIdsList.add(caseKey);
			reportCaseNamesList.add(caseName + " Over Time");
			caseKey = AggReportBuilder.LOG_CASE_TYPE + ReportWidgetDataHandler.CASE_TYPE_SEPARATOR + ReportWidgetDataHandler.REPORT_GADGET_TABLE + ReportWidgetDataHandler.RESPONSE_TYPE_SEPARATOR + caseId;
			reportCaseIdsList.add(caseKey);
			reportCaseNamesList.add(caseName + " Table");
		}
		
		// group by
		caseBuilders = builder.getBuildersListByType(AggReportConstants.LOG_DIMS_CASE_TYPE);
		if(caseBuilders != null && caseBuilders.size() > 0) {
			AggCaseBuilder caseBuilder = null;
			for(int i = 0; i < caseBuilders.size(); i++) {
				caseBuilder = (AggCaseBuilder)caseBuilders.get(i);
				String caseId = null, caseKey = null, caseName = null;
				if (caseBuilder != null && caseBuilder instanceof LogDimsAggCaseBuilder){
					caseBuilder.init();
					
					if(reportCaseIdsList == null) {
						reportCaseIdsList = new ArrayList();
						reportCaseNamesList = new ArrayList();
					}
					
					caseId = caseBuilder.getCaseDef().getId();
					caseName = caseBuilder.getCaseDef().getName();
					
					caseKey = AggReportBuilder.LOG_DIMS_CASE_TYPE + ReportWidgetDataHandler.CASE_TYPE_SEPARATOR + ReportWidgetDataHandler.REPORT_GADGET_PIE_CHART + ReportWidgetDataHandler.RESPONSE_TYPE_SEPARATOR + caseId;
					reportCaseIdsList.add(caseKey);
					reportCaseNamesList.add(caseName + " Pie Chart");
					caseKey = AggReportBuilder.LOG_DIMS_CASE_TYPE + ReportWidgetDataHandler.CASE_TYPE_SEPARATOR + ReportWidgetDataHandler.REPORT_GADGET_OVER_TIME_GRAPH + ReportWidgetDataHandler.RESPONSE_TYPE_SEPARATOR + caseId;
					reportCaseIdsList.add(caseKey);
					reportCaseNamesList.add(caseName + " Over Time");
					caseKey = AggReportBuilder.LOG_DIMS_CASE_TYPE + ReportWidgetDataHandler.CASE_TYPE_SEPARATOR + ReportWidgetDataHandler.REPORT_GADGET_TABLE + ReportWidgetDataHandler.RESPONSE_TYPE_SEPARATOR + caseId;
					reportCaseIdsList.add(caseKey);
					reportCaseNamesList.add(caseName + " Table");
				}
			}
		}
		
		// content
		caseBuilders = builder.getBuildersListByType(AggReportConstants.LOG_KNOWLEDGE_CASE_TYPE);
		if(caseBuilders != null && caseBuilders.size() > 0) {
			AggCaseBuilder caseBuilder = null;
			for(int i = 0; i < caseBuilders.size(); i++) {
				caseBuilder = (AggCaseBuilder)caseBuilders.get(i);
				String caseId = null, caseKey = null, caseName = null;
				if (caseBuilder != null && caseBuilder instanceof LogKnowledgeAggCaseBuilder){
					caseBuilder.init();
					
					if(reportCaseIdsList == null) {
						reportCaseIdsList = new ArrayList();
						reportCaseNamesList = new ArrayList();
					}
					
					caseId = caseBuilder.getCaseDef().getId();
					caseName = caseBuilder.getCaseDef().getName();
					
					caseKey = AggReportBuilder.LOG_KNOWLEDGE_CASE_TYPE + ReportWidgetDataHandler.CASE_TYPE_SEPARATOR + ReportWidgetDataHandler.REPORT_GADGET_TABLE + ReportWidgetDataHandler.RESPONSE_TYPE_SEPARATOR + caseId;
					reportCaseIdsList.add(caseKey);
					reportCaseNamesList.add(caseName);
				}
			}
		}
		
		// similarity
		caseBuilders = builder.getBuildersListByType(AggReportConstants.LOG_SIMILARITY_CASE_TYPE);
		if(caseBuilders != null && caseBuilders.size() > 0) {
			AggCaseBuilder caseBuilder = null;
			for(int i = 0; i < caseBuilders.size(); i++) {
				caseBuilder = (AggCaseBuilder)caseBuilders.get(i);
				String caseId = null, caseKey = null, caseName = null;
				if (caseBuilder != null && caseBuilder instanceof LogSimilarityAggCaseBuilder){
					caseBuilder.init();
					
					if(reportCaseIdsList == null) {
						reportCaseIdsList = new ArrayList();
						reportCaseNamesList = new ArrayList();
					}
					
					caseId = caseBuilder.getCaseDef().getId();
					caseName = caseBuilder.getCaseDef().getName();
					
					caseKey = AggReportBuilder.LOG_SIMILARITY_CASE_TYPE + ReportWidgetDataHandler.CASE_TYPE_SEPARATOR + ReportWidgetDataHandler.REPORT_GADGET_TABLE + ReportWidgetDataHandler.RESPONSE_TYPE_SEPARATOR + caseId;
					reportCaseIdsList.add(caseKey);
					reportCaseNamesList.add(caseName);
				}
			}
		}
		
		// custom
		caseBuilders = builder.getBuildersListByType(AggReportConstants.LOG_FUNCTION_CASE_TYPE);
		if(caseBuilders != null && caseBuilders.size() > 0) {
			AggCaseBuilder caseBuilder = null;
			for(int i = 0; i < caseBuilders.size(); i++) {
				caseBuilder = (AggCaseBuilder)caseBuilders.get(i);
				String caseId = null, caseKey = null, caseName = null;
				if (caseBuilder != null && caseBuilder instanceof LogFunctionAggCaseBuilder){
					caseBuilder.init();
					
					LogFunctionAggCaseBuilder functionBuilder = (LogFunctionAggCaseBuilder)caseBuilder;
					List expressions = functionBuilder.getExpressions();
					HashMap expressionsInfo = functionBuilder.getFunctionsInfo();
					if(expressions != null && expressions.size() > 0 && expressionsInfo != null) {
						DataExpressionAggConf expression = null;
						LogFunctionExpressionInfo expressionInfo = null;
						for(int j = 0; j < expressions.size(); j++) {
							expression = (DataExpressionAggConf)expressions.get(j);
							
							expressionInfo = (LogFunctionExpressionInfo)expressionsInfo.get(expression.getResultKey());
							if(expressionInfo != null) {
								if(reportCaseIdsList == null) {
									reportCaseIdsList = new ArrayList();
									reportCaseNamesList = new ArrayList();
								}
								
								caseId = caseBuilder.getCaseDef().getId() + ReportWidgetDataHandler.FUNCTION_KEY_SEPARATOR + expressionInfo.getFunctionKey();
								caseName = expressionInfo.getDisplayName();
								
								if(expressionInfo.isShowOverTime()) {
									caseKey = AggReportBuilder.LOG_FUNCTION_CASE_TYPE + ReportWidgetDataHandler.CASE_TYPE_SEPARATOR + ReportWidgetDataHandler.REPORT_GADGET_OVER_TIME_GRAPH + ReportWidgetDataHandler.RESPONSE_TYPE_SEPARATOR + caseId;
									reportCaseIdsList.add(caseKey);
									reportCaseNamesList.add(caseName + " Over Time");
								}
								caseKey = AggReportBuilder.LOG_FUNCTION_CASE_TYPE + ReportWidgetDataHandler.CASE_TYPE_SEPARATOR + ReportWidgetDataHandler.REPORT_GADGET_TABLE + ReportWidgetDataHandler.RESPONSE_TYPE_SEPARATOR + caseId;
								reportCaseIdsList.add(caseKey);
								reportCaseNamesList.add(caseName + " Table");
								
								
							}
						}
					}
				}
			}
		}
	}
}

if (resultType.equals("options")) {
%>

<option value="">Select a case</option>
<%
	if(reportCaseIdsList != null) {
		String caseId = null, caseName = null;
		String selected = null;
		for (int i = 0; i < reportCaseIdsList.size(); i++) {
			caseId = (String)reportCaseIdsList.get(i);
			caseName = (String)reportCaseNamesList.get(i);
			selected = caseId.equals(selectedCaseId) ? "selected" : "";
%>

<option value="<%=caseId%>" <%=selected %>><%=caseName%></option>
<%
		}
	}
}else{
	response.setContentType("text/xml; charset=UTF-8");
%>
<Response>
	<Cases>
		<Case id="" name="Select a case" selected="false" />
<%
if(reportCaseIdsList != null) {
	String caseId = null, caseName = null;
	for (int i = 0; i < reportCaseIdsList.size(); i++) {
		caseId = (String)reportCaseIdsList.get(i);
		caseName = (String)reportCaseNamesList.get(i);
%>
		<Case id="<%=caseId%>" name="<%=WebUtil.doHTMLEncoding(caseName)%>" selected="<%=selectedCaseId.equals(caseId)%>" />
<%
		}
	}
%>
	</Cases>
</Response>
<%
}
%>