<%@ page language="java"%>
<%@page import="xpolog.eye.site.ui.grid.models.ReportsListModel"%>
<%@page import="xpolog.eye.site.ui.grid.GridTable"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.group.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	ReportGroupBuilder builder = (ReportGroupBuilder) request.getSession().getAttribute("REPORT_BUILDER");
	

	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = "../../";
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	String reportType = request.getParameter("reportType");
	if (reportType == null){
		reportType = "";
	}
	
	String isSelectedStr = request.getParameter("isSelected");
	boolean isSelected = isSelectedStr != null && isSelectedStr.equals("true");
	
	
	String [] selectedIds = (String [])request.getAttribute("selectedIds");
	if (builder != null && isSelected){
		List list = builder.getReportIds();
		selectedIds = list == null ? null : (String [])list.toArray(new String[list.size()]);
		if (selectedIds == null){
			selectedIds = new String[0];
		}
	}
	
	

	ReportsListModel model = new ReportsListModel();
	if (builder != null){
	  model.setReportType(reportType);
	  model.setSelectedIds(selectedIds);	  
	}
	
	model.setBaseDirectory(baseDirectory);
	model.setUserContext(userContext);
	model.setGridName("mygrid" + suffix);	
	model.init();
	GridTable table = new GridTable(model);
	request.setAttribute("gridTable" + suffix,table);
	
	request.getRequestDispatcher(baseDirectory + "widgets/grid/jsp/initTableXML.jsp").forward(request, response);	
%>