<%@ page language="java"%>

<%@page import="xpolog.eye.reports.agg.admin.*"%>
<%@page import="xpolog.eye.data.masks.MaskColumn"%>
<%@page import="xpolog.eye.data.RecordMask"%>
<%@page import="xpolog.eye.data.masks.NumberMask"%>

<%!static final int MAX_FILTER_SIZE = 40;%>
<%
	AggReportBuilder builder = (AggReportBuilder) request.getSession()
			.getAttribute("REPORT_BUILDER");
	if (builder == null) {
		return;
	}

	RecordMask mask = builder.getMask();
	

	MaskColumn[] cols = new MaskColumn[0];

	cols = mask == null ? cols : mask.getMaskColumns();
	//only proper indexs hold numeric mask
	MaskColumn[] numericCols = new MaskColumn[cols.length];
	for (int i = 0; i < cols.length; i++) {
		if (cols[i].getType()
				.equalsIgnoreCase(NumberMask.NUM_MASK_TYPE)) {
			numericCols[i] = cols[i];
		}
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null) {
		suffix = "";
	}

	int[] columnsSel = (int [])request.getAttribute("columnsSel" + suffix);
	if (columnsSel == null) {
		columnsSel = new int[0];
	}
	
	String description = request.getParameter("description");
	if(description == null) {
		description = "";
	}
	
	String sourceHeader = request.getParameter("sourceHeader");
	if (sourceHeader == null) {
		sourceHeader = "";
	}
	
	String targetHeader = request.getParameter("targetHeader");
	if (targetHeader == null) {
		targetHeader = "";
	}
	
	String allColumnsName = request.getParameter("allColumnsName");
	if (allColumnsName == null){
		allColumnsName = "";
	}

	String allColumnsValue = request.getParameter("allColumnsValue");
	if (allColumnsValue == null){
		allColumnsValue = "";
	}
	
	String showGroupStr = request.getParameter("showGroup");
	boolean showGroup = showGroupStr != null && showGroupStr.equals("true");
 
%>


<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
	<%
	if(description != null && description.length() > 0) { 
	%>
	<tr height="20">
		<td colspan="4"><span class="SMALLTEXT"><%=description%></span></td>
	</tr>
	<%
	}
	%>
  <tr height="20" >
				<td colspan="4"><span class="SMALLTEXT"><%=sourceHeader%></span></td>
			</tr>
	<tr >
		<td  width="210" >
		<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
			
			<tr >
				<td valign="top">
				<%
				String listFromSuffix = "ListFrom" + suffix;
				String listToSuffix = "ListTo" + suffix;
				String initXML = "reports/agg/aggDefLogColumnsListXML.jsp?suffix=" + listFromSuffix + "&allColumnsName=" + allColumnsName + "&allColumnsId=" + allColumnsValue;				
				%>
				
				 <jsp:include page="../../widgets/grid/jsp/gridListIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="../../" />
<jsp:param name="initXML" value="<%=initXML%>" />
<jsp:param name="suffix" value="<%=listFromSuffix%>" />
<jsp:param name="multiSelect" value="true" />
<jsp:param name="width" value="180px" />
<jsp:param name="rows" value="7" />
</jsp:include>
				</td>
			</tr>
			<tr>
				<td></td>
			</tr>
		</table>
		</td>
		<td width="70" nowrap valign="top" style="padding-top:30">
		<table border="0" width="100%" cellspacing="0" cellpadding="5">
			<tr>
				<%
				String action =  "javascript:copySelectedRowsBetweenGrids(mygrid" + listFromSuffix + ",mygrid" + listToSuffix + ",true);makeChecked('" + suffix + "')"; 
				%>
				<jsp:include page="../../common/ctrlButton.jsp" flush="true">
						<jsp:param name="base_directory" value="../../"/>
						<jsp:param name="name" value="Add&gt;&gt;"/>
						<jsp:param name="action" value="<%=action%>"/>
						<jsp:param name="width" value="90"/> 
						<jsp:param name="buttonClass" value="BUTTON_LIST"/>						
						</jsp:include>		
								
			</tr>
			<tr style="padding-top:10">
			<%
				action =  "javascript:mygrid" + listToSuffix + ".deleteSelectedItem()"; 
				%>
				<jsp:include page="../../common/ctrlButton.jsp" flush="true">
						<jsp:param name="base_directory" value="../../"/>
						<jsp:param name="name" value="&lt;&lt;Remove"/>
						<jsp:param name="action" value="<%=action%>"/> 		
						<jsp:param name="width" value="90"/> 				
						<jsp:param name="buttonClass" value="BUTTON_LIST"/>
						</jsp:include>						
			</tr>
			<%if (showGroup){ %>
			<tr style="padding-top:20">
				<%
				action =  "javascript:copyGroupSelectedRowsBetweenGrids(mygrid" + listFromSuffix + ",mygrid" + listToSuffix + ",true);makeChecked('" + suffix + "')"; 
				%>
				<jsp:include page="../../common/ctrlButton.jsp" flush="true">
						<jsp:param name="base_directory" value="../../"/>
						<jsp:param name="name" value="Group&gt;&gt;"/>
						<jsp:param name="action" value="<%=action%>"/>
						<jsp:param name="width" value="90"/> 
						<jsp:param name="buttonClass" value="BUTTON_LIST"/>						
						</jsp:include>		
								
			</tr>
			<%}%>
		</table>
		</td>
		<td width="210" style="padding-left:20" valign="top">
		<table border="0" width="100%" cellspacing="0" cellpadding="0">			
			<tr>
				<td width="100%"><select class="TEXTBOX" multiple style="display: none"
					name="To_Select_column<%=suffix%>" id="To_Select_column<%=suffix%>">
			</select> 
			<%
			initXML = "reports/agg/aggDefLogColumnsListXML.jsp?suffix=" + listToSuffix + "&selectedType=" + suffix + "&allColumnsName=" + allColumnsName + "&allColumnsId=" + allColumnsValue;
			
			%>
			 <jsp:include page="../../widgets/grid/jsp/gridListIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="../../" />
<jsp:param name="initXML" value="<%=initXML%>" />
<jsp:param name="suffix" value="<%=listToSuffix%>" />
<jsp:param name="multiSelect" value="true" />
<jsp:param name="width" value="180px" />
<jsp:param name="rows" value="7" />
</jsp:include>
			</td>
			</tr>	
		</table>
		</td>		
		<td>&nbsp;</td>
	</tr>
</table>
