<%@ page language="java"%>

<%@page import="xpolog.eye.LogBrowsingManager"%>
<%@page import="java.util.*"%>
<%@page import="xpolog.eye.data.filters.*"%>
<%@page import="xpolog.eye.reports.agg.admin.*"%>

<%!static final int MAX_FILTER_SIZE = 40;%>
<%
	AggReportBuilder builder = (AggReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");
	if (builder == null) {
		return;
	}

	String suffix = request.getParameter("suffix");
	if (suffix == null) {
		suffix = "";
	}
	
	String description = request.getParameter("description");
	if(description == null) {
		description = "";
	}
	
	String sourceHeader = request.getParameter("sourceHeader");
	if (sourceHeader == null) {
		sourceHeader = "";
	}
	
	String targetHeader = request.getParameter("targetHeader");
	if (targetHeader == null) {
		targetHeader = "";
	}
	
	String allFilterName = request.getParameter("allFilterName");
	if (allFilterName == null){
		allFilterName = "";
	}

	String allFilterValue = request.getParameter("allFilterValue");
	if (allFilterValue == null){
		allFilterValue = "";
	}

	FilterManager flm = builder.getFilterManager();
	List filterList = new ArrayList();
	List dfsele = new ArrayList();
	if (flm != null) {	
		filterList = flm.getFilterCollections();
		
		String[] dataFilters = (String[]) request.getAttribute("filtersSel" + suffix);
		
		if (dataFilters != null) {
			for (int i = 0; i < dataFilters.length; i++) {
				if (allFilterName != null && allFilterName.length() > 0 && dataFilters[i].equals(allFilterValue)){					
					FilterCollection fc = new FilterCollection();
					fc.setId(allFilterValue);
					fc.setName(allFilterName);
					dfsele.add(fc);
				}else {
				  FilterCollection col = flm.getFilterCollectionById(dataFilters[i]);
				  if (col != null) {
					  dfsele.add(col);
				  }
				}
			}
		}
	}
%>



<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
	<%
	if(description != null && description.length() > 0) { 
	%>
	<tr height="20" >
		<td colspan="4"><span class="SMALLTEXT"><%=description%></span></td>
	</tr>
	<%
	}
	%>
  <tr height="20" >
				<td colspan="4"><span class="SMALLTEXT"><%=sourceHeader%></span></td>
			</tr>
	<tr >
		<td  width="210" >
		<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
			
			<tr >
				<td valign="top">
				<%
				String listFromSuffix = "ListFrom" + suffix;
				String listToSuffix = "ListTo" + suffix;			
				String initXML = "reports/agg/aggDefFilterListXML.jsp?suffix=" + listFromSuffix + "&allFilterName=" + allFilterName + "&allFilterId=" + allFilterValue; 
				%>
				
				 <jsp:include page="../../widgets/grid/jsp/gridListIncluder.jsp" flush="true" >
					<jsp:param name="baseDirectory" value="../../" />
					<jsp:param name="initXML" value="<%=initXML%>" />
					<jsp:param name="suffix" value="<%=listFromSuffix%>" />
					<jsp:param name="multiSelect" value="true" />
					<jsp:param name="width" value="180px" />
					<jsp:param name="rows" value="7" />
				</jsp:include>
				</td>
			</tr>
			<tr>
				<td></td>
			</tr>
		</table>
		</td>
		<td width="70" nowrap valign="top" style="padding-top:30px">
		<table border="0" width="100%" cellspacing="0" cellpadding="5">
			<tr>
				<%
				String action =  "javascript:copySelectedRowsBetweenGrids(mygrid" + listFromSuffix + ",mygrid" + listToSuffix + ",true);makeChecked('" + suffix + "')"; 
				%>
				<jsp:include page="../../common/ctrlButton.jsp" flush="true">
						<jsp:param name="base_directory" value="../../"/>
						<jsp:param name="name" value="Add&gt;&gt;"/>
						<jsp:param name="action" value="<%=action%>"/>
						<jsp:param name="width" value="90"/> 
						<jsp:param name="buttonClass" value="BUTTON_LIST"/>						
						</jsp:include>		
								
			</tr>
			<tr >
			
			<%
				action =  "javascript:mygrid" + listToSuffix + ".deleteSelectedItem()"; 
				%>
				<jsp:include page="../../common/ctrlButton.jsp" flush="true">
						<jsp:param name="base_directory" value="../../"/>
						<jsp:param name="name" value="&lt;&lt;Remove"/>
						<jsp:param name="action" value="<%=action%>"/> 		
						<jsp:param name="width" value="90"/> 				
						<jsp:param name="buttonClass" value="BUTTON_LIST"/>
						</jsp:include>						
			</tr>			
		</table>
		</td>
		<td width="210" style="padding-left:20" valign="top">
		<table border="0" width="100%" cellspacing="0" cellpadding="0">			
			<tr>
				<td width="100%"><select class="TEXTBOX" multiple style="display: none"
					name="To_Select_filters<%=suffix%>" id="To_Select_filters<%=suffix%>">
			</select> 
			<%			
			initXML = "reports/agg/aggDefFilterListXML.jsp?suffix=" + listToSuffix + "&selectedType=" + suffix+ "&allFilterName=" + allFilterName + "&allFilterId=" + allFilterValue; 
				%>
			 <jsp:include page="../../widgets/grid/jsp/gridListIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="../../" />
<jsp:param name="initXML" value="<%=initXML%>" />
<jsp:param name="suffix" value="<%=listToSuffix%>" />
<jsp:param name="multiSelect" value="true" />
<jsp:param name="width" value="180px" />
<jsp:param name="rows" value="7" />
</jsp:include>
			</td>
			</tr>	
		</table>
		</td>		
		<td>&nbsp;</td>
	</tr>
</table>