var selFuncIndex = -1;


function initFunctionTable(){
  if (document.getElementById('functionTableTD')){
    getFunctionsTable();
  }
}

var counter = new Date().getTime();
function getFunctionsTable(){
  document.getElementById('functionTableTD').style.display = "none";
  document.getElementById('functionTableTDLoading').style.display = "";
  
  counter++;    
  sendAjaxRequest("logFunctionFieldsExpressionsTable.jsp?counter=" + counter,function(req){
    result = req.responseText;
    document.getElementById('functionTableTD').innerHTML = result;            
    document.getElementById('functionTableTDLoading').style.display = "none";
    document.getElementById('functionTableTD').style.display = "";
  });
  
}


var functionEditReq;

function getFunctionsEdit(functionIndex){
  functionEditReq = GetXmlHttpObject();
  if (!functionEditReq) return;
  
  selFuncIndex = functionIndex;
  document.getElementById('adminGeneralIncludeTDfunction').innerHTML = "<span class='REGULARTEXT'>Loading...</span>";
  counter++;
  var url = "logFunctionFieldsExpressionEdit.jsp?counter=" + counter + "&functionIndex=" + functionIndex;  
  functionEditReq.onreadystatechange = showFunctionsEditResult;
  functionEditReq.open('GET', url, true); 
  functionEditReq.send(null);  
  
}

function showFunctionsEditResult() {
      if (functionEditReq.readyState == 4) {
         if (functionEditReq.status == 200) {
            result = functionEditReq.responseText;
            document.getElementById('adminGeneralIncludeTDfunction').innerHTML = result;            
         } else {
            alert('There was a problem with the request. - ' + functionEditReq.status);
         }
      }
   }
   
 var functionApplyReq;

function applyFunctionsOp(){
  functionApplyReq = GetXmlHttpObject();
  if (!functionApplyReq) return;
  
  var showOverTime = document.getElementById("showOverTime").checked ? "true" : "false";
  var parameters = "op=apply&functionIndex=" + selFuncIndex + "&funcName=" + encode( document.getElementById("funcName").value) + "&funcExpression=" + encode( document.getElementById("funcExpression").value)+ "&formatType=" + encode( document.getElementById("formatType").value)  + "&formatName=" + encode( document.getElementById("formatName").value) + "&showOverTime=" +  showOverTime + "&formatProp=" + encode( document.getElementById("formatProp").value);
  var url = "logFunctionFieldsExpressionsOperation.jsp";  
  functionApplyReq.onreadystatechange = showFunctionsApplyResult;
  functionApplyReq.open('POST', url, true);
  functionApplyReq.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  functionApplyReq.setRequestHeader("Content-length", parameters.length);
  functionApplyReq.setRequestHeader("Connection", "close");
  functionApplyReq.send(parameters);  
  
}

function showFunctionsApplyResult() {
      if (functionApplyReq.readyState == 4) {
         if (functionApplyReq.status == 200) {
            result = functionApplyReq.responseText;
            result = result.replace(/^\s+|\s+$/g, '') ;
            if (result == ""){
              closeFunction();
              getFunctionsTable();
            }else {
              alert(result);
            }
         } else {
            alert('There was a problem with the request. - ' + functionApplyReq.status);
         }
      }
   }
   
var functionRemoveReq;

function removeFunctionsOp(index){
  functionRemoveReq = GetXmlHttpObject();
  if (!functionRemoveReq) return;
  
  var parameters = "op=remove&functionIndex=" + index;
  var url = "logFunctionFieldsExpressionsOperation.jsp";  
  functionRemoveReq.onreadystatechange = showFunctionsRemoveResult;
  functionRemoveReq.open('POST', url, true);
  functionRemoveReq.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  functionRemoveReq.setRequestHeader("Content-length", parameters.length);
  functionRemoveReq.setRequestHeader("Connection", "close");
  functionRemoveReq.send(parameters);  
  
}

function showFunctionsRemoveResult() {
      if (functionRemoveReq.readyState == 4) {
         if (functionRemoveReq.status == 200) {
            result = functionRemoveReq.responseText;
            result = result.replace(/^\s+|\s+$/g, '') ;
            if (result == ""){
              getFunctionsTable();
            }else {
              alert(result);
            }
         } else {
            alert('There was a problem with the request. - ' + functionRemoveReq.status);
         }
      }
   }
   
   
function showFunctionDiv(divElem){    
  showHideLayerInMiddle(divElem,-1,10,true);
}


   
function addFunction(){
  getFunctionsEdit(-1);  
  //document.getElementById("predfinedTR").style.display="none";
  showHideGeneralAdminDiv("function");
    
}

function closeFunction(){
 hideGeneralAdminDiv("function");
}

function editFunction(functionIndex){
  getFunctionsEdit(functionIndex);  
  //document.getElementById("predfinedTR").style.display="none";
  showHideGeneralAdminDiv("function");
    
}

function removeFunction(functionIndex){
  removeFunctionsOp(functionIndex);  
    
}


var functionPredifinedApplyReq;

function addFunctionsPredefinedOp(combo){
  functionPredifinedApplyReq = GetXmlHttpObject();
  if (!functionPredifinedApplyReq) return;
  
  var dataKeys = "";
  var dataNames = "";
  var colsCombo = document.getElementById("logColumns");
  if (colsCombo.selectedIndex >= 0){
    for (var i = 0; i < colsCombo.options.length;i++){
      if (colsCombo[i].selected){
        dataKeys = dataKeys + colsCombo.options[i].value + ";";
        var name = colsCombo.options[i].name;
        if (!name || name == ""){
          name = " ";
        }
        dataNames = dataNames + name + ";";
      }
    }
  }else {
    alert("No column was selected.");
    return;
  }
  
  
  
  
  var templatesIds = "";
  if (combo.selectedIndex >= 0){
    for (var i = 0; i < combo.options.length;i++){
      if (combo[i].selected){
        templatesIds = templatesIds + combo.options[i].value + ";";
      }
    }
  }else {
    alert("No function was selected.");
    return;
  }
  
  
  
  var parameters = "type=log&op=addTemplate&functionIndex=-1&dataKeys=" + encode(dataKeys) + "&dataNames=" + encode(dataNames) + "&templatesIds=" + encode(templatesIds);
   
  var url = "logFunctionFieldsExpressionsOperation.jsp";  
  functionPredifinedApplyReq.onreadystatechange = showFunctionsPredefiniedApplyResult;
  functionPredifinedApplyReq.open('POST', url, true);
  functionPredifinedApplyReq.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  functionPredifinedApplyReq.setRequestHeader("Content-length", parameters.length);
  functionPredifinedApplyReq.setRequestHeader("Connection", "close");
  functionPredifinedApplyReq.send(parameters);  
  
}

function showFunctionsPredefiniedApplyResult() {
      if (functionPredifinedApplyReq.readyState == 4) {
         if (functionPredifinedApplyReq.status == 200) {
            result = functionPredifinedApplyReq.responseText;
            result = result.replace(/^\s+|\s+$/g, '') ;
            if (result == ""){
              getFunctionsTable();
            }else {
              alert(result);
            }
         } else {
            alert('There was a problem with the request. - ' + functionPredifinedApplyReq.status);
         }
      }
   }
   
   function addPredefined(){
      var combo = document.getElementById("logFunctions");
     if (combo.selectedIndex == -1){
       alert("Please select function.");
       return;
     }
     
     addFunctionsPredefinedOp(combo);
   }
   
   function formatTypeChanged(combo){
  if (combo.selectedIndex == -1){
    return;
  }

  document.getElementById("formatName").value = combo.options[combo.selectedIndex].getAttribute("formatName");
  document.getElementById("formatProp").value = combo.options[combo.selectedIndex].getAttribute("formatProp");
}
 