<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>

<%!
	static final String BASE_DIRECTORY = "../../";

%>

<%
  AggReportBuilder builder = (AggReportBuilder)  request.getSession().getAttribute("REPORT_BUILDER");
  
  
 if(builder == null){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("Session is not valid any more. Please try again");
    request.getSession().setAttribute("ERROR_OBJ",ermod);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
    return;
  }
  
  String id = request.getParameter("reportTypeId");
  boolean success = true;
  String message = "";
  if (id != null && id.length() > 0){
    try {
		  builder.removeReportTypeById(id);		
    }catch (Exception e){
  	  ErrorModel.log.error("Failed to remove report type with id " + id, e);
  	  success = false;
  	  message = e.getMessage();
    }
  }else {
  	success = false;
  	message = "No case was given, please refresh and try again";
  }
	
  String xml = GridModelActionsHelper.getResultXML(success, message);

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	
	out.write(xml);
	out.flush();

%>
