<%@ page language="java"%>

<%@ page import="xpolog.eye.reports.agg.admin.*"%>

<%!
static final String BASE_DIRECTORY = "../../";
static final int MAX_FILTER_SIZE = 40;
%>

<%
  AggReportBuilder builder = (AggReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");
	if (builder == null) {
		return;
	}
	
	for (int i = 0; i < builder.getReportTypesCount();i++){
	  builder.getReportTypeBuilderAt(i).init();
	}
	
	String type = request.getParameter("type");
	if (type == null){
		type = "";
	}
	
	String logId = builder == null ? "" : builder.getDefaultLogId();
	String noLogDivDisplay = "";
	String hasLogDivDisplay = "";
	if(logId == null || logId.length() == 0) {
		hasLogDivDisplay = "display:none";
	}else {
		noLogDivDisplay = "display:none";
	}
	
	String advancedSuffix = "ReportTypeAdvanced";
	
%>

<%@page import="xpolog.eye.reports.Report"%>
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/logAdministration.css" />
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/admin.js"></script>
<script>

var logId = "<%=builder.getDefaultLogId()%>";
 
  function addAllGridFiledToSelection(gridFrom,to){
     removeAllFiledFromSelection(to);     
     var selectedids = getAllRowsIds(gridFrom);     
  	 for (var i = 0; i < selectedids.length; i++){
        var frRow = gridFrom.getRowById(selectedids[i]);
  			if (!frRow) continue;
  			
  			var id = selectedids[i];
  			if (frRow.cells.length> 0){
  				var value = gridFrom.cells(id, 0).getValue();
  				var option0 = new Option(value,id);
      		to.options[to.options.length] = option0;      		
  			}
     }
  }
    
  function prepareFieldsForAdd(from,to){
    if (!from || !to) return;        
    addAllGridFiledToSelection(from,to);
    for(var t=0;t<to.options.length;++t){
       to.options[t].selected='true';
    }        
  }
  
  function prepareFiltersForAdd(suffix){ 		
    prepareFieldsForAdd(eval("mygridListTo" + suffix),document.getElementById("To_Select_filters" + suffix));
  }
  
  function prepareColumnsForAdd(suffix){
 // alert(eval("mygridListTo" + suffix) + " , " + document.getElementById("To_Select_column" + suffix));
    prepareFieldsForAdd(eval("mygridListTo" + suffix),document.getElementById("To_Select_column" + suffix));
  }
  
  function doReportTypesAdd(){    
    prepareFiltersForAdd("<%=AggReportBuilder.LOG_CASE_TYPE%>");
    prepareColumnsForAdd("<%=AggReportBuilder.LOG_DIMS_CASE_TYPE%>");
    prepareColumnsForAdd("<%=AggReportBuilder.LOG_SIMILARITY_CASE_TYPE%>");
    prepareFiltersForAdd("<%=advancedSuffix%>");
       
  }

</script>

<script>
function updateSourceForLogChange(id,name){  	
    if (id.indexOf("Log-") == 0){
      id = id.substring(4,id.length);
    }
    var selectedLog = id;
    
    sendAjaxRequest("updateLog.jsp?logId=" + selectedLog,function(req){
         
    		 
    		 
    		 
    		updateTableListFromlogAgg();
    		updateTableListTologAgg();
    		
    		updateTableListFromlogDimsAgg();
    		updateTableListTologDimsAgg();
    		
    		updateTableListFromlogSimilarityAgg();
    		updateTableListTologSimilarityAgg();
    		
    		updateTableListFromReportTypeAdvanced();
    		updateTableListToReportTypeAdvanced();
    		

    		
    		sendAjaxRequest("aggEditFunctionCase.jsp",function(req){
    		   	var result = req.responseText;	
				    result = result.replace(/^\s+|\s+$/g, '') ;
				    document.getElementById("reportTypeDiv<%=AggReportBuilder.LOG_FUNCTION_CASE_TYPE%>").innerHTML = result;
				    initFunctionTable();  
    		 });
    		
				var result = req.responseText;					
				       
         var noLogDiv = document.getElementById("noLogDiv");
		     var hasLogDiv = document.getElementById("hasLogDiv");
		     if(selectedLog == '') {
			     noLogDiv.style.display = "";
		      	hasLogDiv.style.display = "none";
				}else {
					noLogDiv.style.display = "none";
					hasLogDiv.style.display = "";
				}
  });	
}


	
	function addColumnsToSelection(source,target,specificId){
	  addFiledToSelection(source,target);
	  if (specificId && specificId != ""){
	    document.getElementById(specificId).checked = true;
	  }
	}
	
	function addAllColumnsToSelection(source,target,specificId){
	  addAllFiledToSelection(source,target);
	  if (specificId && specificId != ""){
	    document.getElementById(specificId).checked = true;
	  }
	  
	}
	
	
	
	
	function initReportTypes(){
	  initFunctionTable();
	}
	
	function makeChecked(suffix){
	  var chk = document.getElementById("reportTypeChk" + suffix);
	  if (chk){ 
	    chk.checked = true;
	  }
	}
	
	var reportTypesArr = new Array();
	
	function changeType(type){	
	  for (var i = 0; i < reportTypesArr.length;i++){
	    if (reportTypesArr[i] == type){
	    	document.getElementById("reportTypeTitle" + reportTypesArr[i]).style.fontWeight="bold";
	    	document.getElementById("reportTypesTitle").innerHTML = document.getElementById("reportTypeTitle" + reportTypesArr[i]).innerHTML;
	    	document.getElementById("reportTypeDiv" + reportTypesArr[i]).style.display = "";	   
	    }else {
	      document.getElementById("reportTypeTitle" + reportTypesArr[i]).style.fontWeight="";
	      document.getElementById("reportTypeDiv" + reportTypesArr[i]).style.display = "none";
	    }
	  }
	}
	
	function changeChk(chk,type){
		if (chk.checked){
		  changeType(type);
		}
	}
</script>



<script language="JavaScript" src="aggEditFunctions.js"></script>

<div id="noLogDiv" style="<%=noLogDivDisplay %>">
	    	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="padding:5px;">
					
					<tr>
						<td style="padding:10;padding-top:20"  valign="top">
							<span class="REGULARTEXT" style="color:#9E5B04">* No log is selected. </span><a class="LINK" href="javascript:showModuleTree()">Select a log</a>
						</td>
					</tr>
				</table>
	    </div>
	     <div id="hasLogDiv" style="<%=hasLogDivDisplay %>">

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="padding:5px;">
<tr height="20">
<td width="180px" align="center">	 <div id="ReportTypesErrorMsg"  class="ERROR_MSG">
								 </div></td>
<td style="padding-left:20px;padding-bottom:5px" valign="bottom"><span class="SECTION_HEADER" id="reportTypesTitle">Filters Summary</span></td>
</tr>
<tr>
<td width="180px">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
<tr height="10"><td width="20"  style="padding-left:10;padding-top:5" valign="top"><input type="checkbox" id="reportTypeChk<%=AggReportBuilder.LOG_CASE_TYPE%>" name="reportTypeChk<%=AggReportBuilder.LOG_CASE_TYPE%>" value="true" onClick="javascript:changeChk(this,'<%=AggReportBuilder.LOG_CASE_TYPE%>')" <%=builder.getCasesCount() > 0 ? "checked" : "" %>></td><td style="padding-left:5;padding-top:5;cursor:pointer" onClick="javascript:changeType('<%=AggReportBuilder.LOG_CASE_TYPE%>')"><span class="MEDIUMTEXT" style="font-weight:bold" id="reportTypeTitle<%=AggReportBuilder.LOG_CASE_TYPE%>">Filters Summary</span></td></tr>
<tr height="10"><td width="20"  style="padding-left:10;padding-top:10" valign="top"><input type="checkbox" id="reportTypeChk<%=AggReportBuilder.LOG_DIMS_CASE_TYPE%>" name="reportTypeChk<%=AggReportBuilder.LOG_DIMS_CASE_TYPE%>" value="true" onClick="javascript:changeChk(this,'<%=AggReportBuilder.LOG_DIMS_CASE_TYPE%>')" <%=builder.getDimsCount() > 0 ? "checked" : "" %>></td><td style="padding-left:5;padding-top:10;cursor:pointer" onClick="javascript:changeType('<%=AggReportBuilder.LOG_DIMS_CASE_TYPE%>')"><span class="MEDIUMTEXT" id="reportTypeTitle<%=AggReportBuilder.LOG_DIMS_CASE_TYPE%>" >Group by Columns</span></td></tr>
<tr height="10"><td width="20"  style="padding-left:10;padding-top:10" valign="top"><input type="checkbox" id="reportTypeChk<%=AggReportBuilder.LOG_KNOWLEDGE_CASE_TYPE%>" name="reportTypeChk<%=AggReportBuilder.LOG_KNOWLEDGE_CASE_TYPE%>" value="true" onClick="javascript:changeChk(this,'<%=AggReportBuilder.LOG_KNOWLEDGE_CASE_TYPE%>')" <%=builder.getKnowledgeCount() > 0 ? "checked" : "" %>></td><td style="padding-left:5;padding-top:10;cursor:pointer" onClick="javascript:changeType('<%=AggReportBuilder.LOG_KNOWLEDGE_CASE_TYPE%>')"><span class="MEDIUMTEXT" id="reportTypeTitle<%=AggReportBuilder.LOG_KNOWLEDGE_CASE_TYPE%>">Content Analysis</span></td></tr>
<tr height="10"><td width="20"  style="padding-left:10;padding-top:10" valign="top"><input type="checkbox" id="reportTypeChk<%=AggReportBuilder.LOG_SIMILARITY_CASE_TYPE%>" name="reportTypeChk<%=AggReportBuilder.LOG_SIMILARITY_CASE_TYPE%>" value="true" onClick="javascript:changeChk(this,'<%=AggReportBuilder.LOG_SIMILARITY_CASE_TYPE%>')" <%=builder.getSimilarityCount() > 0 ? "checked" : "" %>></td><td style="padding-left:5;padding-top:10;cursor:pointer" onClick="javascript:changeType('<%=AggReportBuilder.LOG_SIMILARITY_CASE_TYPE%>')"><span class="MEDIUMTEXT" id="reportTypeTitle<%=AggReportBuilder.LOG_SIMILARITY_CASE_TYPE%>">Unique Messages</span></td></tr>
<tr height="10"><td width="20"  style="padding-left:10;padding-top:10" valign="top"><input type="checkbox" id="reportTypeChk<%=AggReportBuilder.LOG_FUNCTION_CASE_TYPE%>" name="reportTypeChk<%=AggReportBuilder.LOG_FUNCTION_CASE_TYPE%>" value="true" onClick="javascript:changeChk(this,'<%=AggReportBuilder.LOG_FUNCTION_CASE_TYPE%>')" <%=builder.getFunctionCount() > 0 ? "checked" : "" %>></td><td style="padding-left:5;padding-top:10;cursor:pointer" onClick="javascript:changeType('<%=AggReportBuilder.LOG_FUNCTION_CASE_TYPE%>')"><span class="MEDIUMTEXT"id="reportTypeTitle<%=AggReportBuilder.LOG_FUNCTION_CASE_TYPE%>">Custom</span></td></tr>
<tr height="10"><td width="20"  style="padding-left:10;padding-top:20" valign="top">&nbsp;</td><td style="padding-left:5;padding-top:20;cursor:pointer" onClick="javascript:changeType('<%=advancedSuffix%>')"><span class="MEDIUMTEXT"id="reportTypeTitle<%=advancedSuffix%>">Advanced</span></td></tr>
<tr height="*"><td>&nbsp;</td></tr>
</table>
</td>
<td valign="top">
<table border="0" width="100%" cellspacing="0" height="200" cellpadding="0" >
<tr>
<td valign="top" >
<%
if (type.length() == 0 || type.equals(Report.LOG_TYPE)){

	%>
<div id="reportTypeDiv<%=AggReportBuilder.LOG_CASE_TYPE%>" style="height:100%">	
	<jsp:include page="aggEditFilterCase.jsp" flush="true"/>
</div>
	<script>reportTypesArr[reportTypesArr.length] = "<%=AggReportBuilder.LOG_CASE_TYPE%>";</script>
	<!--  Group by count section -->

	<% 
	}
	
	if (type.length() == 0 || type.equals(Report.LOG_TYPE)){
	%>
	<div id="reportTypeDiv<%=AggReportBuilder.LOG_DIMS_CASE_TYPE%>" style="display:none;height:100%">	
	<jsp:include page="aggEditDimsCase.jsp" flush="true"/>	
	</div>
	<script>reportTypesArr[reportTypesArr.length] = "<%=AggReportBuilder.LOG_DIMS_CASE_TYPE%>";</script>
	
	<!--  Knowledge section -->

	<% 
	}

	if (type.length() == 0 || type.equals(Report.LOG_TYPE)){		
	%>
	<div id="reportTypeDiv<%=AggReportBuilder.LOG_KNOWLEDGE_CASE_TYPE%>" style="display:none;height:100%">
	
	<jsp:include page="aggEditKnowledgeCase.jsp" flush="true"/>
	</div>
<script>reportTypesArr[reportTypesArr.length] = "<%=AggReportBuilder.LOG_KNOWLEDGE_CASE_TYPE%>";</script>	
	<!--  Function section -->

	<% 
	}
	if (type.length() == 0 || type.equals(Report.LOG_TYPE)){	
	%>	
	<div id="reportTypeDiv<%=AggReportBuilder.LOG_SIMILARITY_CASE_TYPE%>" style="display:none;height:100%">
	<jsp:include page="aggEditSimilarityCase.jsp" flush="true"/>
	</div>
	<!--  Similarity section -->
	<script>reportTypesArr[reportTypesArr.length] = "<%=AggReportBuilder.LOG_SIMILARITY_CASE_TYPE%>";</script>
	<% 
	}

	if (type.length() == 0 || type.equals(Report.LOG_TYPE)){
	
	%>
	<div id="reportTypeDiv<%=AggReportBuilder.LOG_FUNCTION_CASE_TYPE%>" style="display:none;height:100%">
	<jsp:include page="aggEditFunctionCase.jsp" flush="true"/>
	</div>
	<script>reportTypesArr[reportTypesArr.length] = "<%=AggReportBuilder.LOG_FUNCTION_CASE_TYPE%>";</script>
	<% }
	if (type.length() == 0 || type.equals(Report.LOG_TYPE)){
	%>	
	
	<div id="reportTypeDiv<%=advancedSuffix%>" style="display:none">
	<jsp:include page="aggEditAdvancedCase.jsp" flush="true"/>
	</div>
	<script>reportTypesArr[reportTypesArr.length] = "<%=advancedSuffix%>";</script>
	<%}%>
	
</td>
</tr>
</table>
</td>
<tr>
</tr>
</table>
</div>
