<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.scheduler.ui.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@page import="xpolog.eye.automation.tasks.mail.MailTask"%>
<%@page import="xpolog.eye.automation.tasks.XpoTask"%>

<%!static final String BASE_DIRECTORY = "../../";%>
<%
	String BUILDER = "CURRENT_LOG_BUILDER";
	String ERROR_OBJ = "ERROR_OBJ";

	AbstractReportBuilder builder = (AbstractReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");
	if (builder == null) {
		return;
	}

	String suffix = "ReportSched";
	String name = "reportScheduler";
	String id = "reportId_" + System.currentTimeMillis();

	XpoScheduledOperation schedOp = builder.getSchedOp();
	JobBuilder jobBuilder = new ReportJobBuilder();
	if (schedOp != null) {
		if (schedOp instanceof MultiScheduledOperation){
			List schedOps = ((MultiScheduledOperation)schedOp).getSchedOps();
			jobBuilder = new MultiJobBuilder(schedOps);
		}else{
			jobBuilder = new ReportJobBuilder(schedOp);
		}
		jobBuilder.updateFromOp();
		name = jobBuilder.getName();
		id = jobBuilder.getId();
	}
	request.setAttribute("CURRENT_JOB", jobBuilder);
	request.setAttribute("ONLY_SCHEDULING", "true");
	request.setAttribute("suffix", suffix);

	
%>



<input type="hidden" name="Name<%=suffix%>" value="<%=name%>">
<input type="hidden" name="Id<%=suffix%>" value="<%=id%>">
<input type="hidden" name="actionId<%=suffix%>" value="0">
<input type="hidden" name="State<%=suffix%>" value="<%=XpoScheduledOperation.STATE_ACTIVE%>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">

	<tr>
		<td style="padding:10px">
			<jsp:include page="../../scheduler/newScheduler.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="allowMulti" value="true" />
			</jsp:include>
		</td>
	</tr>


</table>

