<%@ page language="java"%>

<%@ page import="java.util.List"%>

<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisProperty"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisPropertyOption"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisReport"%>

<%!static final String BASE_DIRECTORY = "../../";
%>
<%
	AbstractReportBuilder builder = (AbstractReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");
	if (builder == null) {
		return;
	}
			
	EnvironmentAnalysisReport report = (EnvironmentAnalysisReport)request.getAttribute("report");
	List environmentAnalysisProperties = null;
	String environmentAnalysisDesc = "";
	boolean onlyTimeProperty = false;
	if (report != null) {
		environmentAnalysisProperties = report.getEnvironmentAnalysisProperties();
		if(environmentAnalysisProperties != null && environmentAnalysisProperties.size() == 1) {
			if(((EnvironmentAnalysisProperty)environmentAnalysisProperties.get(0)).getType().equals(EnvironmentAnalysisProperty.TYPE_TIME)) {
				onlyTimeProperty = true;
			}
		}
		environmentAnalysisDesc = report.getDescription();
	}

%>

<script>

	function propertySelectChange(id) {
		var propertySelect = document.getElementById(id);
		if(propertySelect) {
			var otherTextField = document.getElementById(id + 'Other');
			if(otherTextField) {
				if(propertySelect.value == 'other') {
					otherTextField.style.display = "";
				}else {
					otherTextField.style.display = "none";
				}
			}
		}
	}

</script>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>
		<td width="*" style="padding-left:10;padding-top:10" valign="top">
			<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
				<%
				if(environmentAnalysisProperties != null && environmentAnalysisProperties.size() > 0 && !onlyTimeProperty) {
				%>
				<tr height="10">
					<td>
						<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
							<tr>
								<td><span class="SECTION_HEADER">Environment Properties</span></td>
							</tr>
							<tr>
								<td style="padding-top:5"><span class="SMALLTEXT">Specity the defaut value of each property</td>
							</tr>
				<%
					EnvironmentAnalysisProperty environmentAnalysisProperty = null;
					List environmentAnalysisPropertyOptions = null;
					for(int i = 0; i < environmentAnalysisProperties.size(); i++) {
						environmentAnalysisProperty = (EnvironmentAnalysisProperty)environmentAnalysisProperties.get(i);
						if(!environmentAnalysisProperty.getType().equals(EnvironmentAnalysisProperty.TYPE_TIME)) {
				%>
							<tr>
								<td>
									<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
										<tr>
											<td style="width:120;padding-top:10">
												<span class="REGULARTEXT"><%=environmentAnalysisProperty.getName() %></span>
											</td>
				<%
							if(environmentAnalysisProperty.getType().equals(EnvironmentAnalysisProperty.TYPE_TEXT)) {
				%>
											<td style="padding-top:10" align="left">
												<input id="<%=environmentAnalysisProperty.getKey() %>" name="<%=environmentAnalysisProperty.getKey() %>" value="<%=environmentAnalysisProperty.getValue() %>" />
											</td>
				<%
							}else if(environmentAnalysisProperty.getType().equals(EnvironmentAnalysisProperty.TYPE_SELECT)) {
								environmentAnalysisPropertyOptions = environmentAnalysisProperty.getEnvironmentAnalysisPropertyOptions();
								if(environmentAnalysisPropertyOptions != null && environmentAnalysisPropertyOptions.size() > 0) {
				%>
											<td style="padding-top:10" align="left">
												<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
													<tr>
														<td style="width:120">
															<select id="<%=environmentAnalysisProperty.getKey() %>" name="<%=environmentAnalysisProperty.getKey() %>" size="1" onChange="javascript:propertySelectChange('<%=environmentAnalysisProperty.getKey() %>')">
				<%
									EnvironmentAnalysisPropertyOption environmentAnalysisPropertyOption = null;
									String environmentAnalysisPropertyOptionSelected = "";
									boolean foundOption = false;
									for(int j = 0; j < environmentAnalysisPropertyOptions.size(); j++) {
										environmentAnalysisPropertyOption = (EnvironmentAnalysisPropertyOption)environmentAnalysisPropertyOptions.get(j);
										if(environmentAnalysisPropertyOption.getId().equals(environmentAnalysisProperty.getValue())) {
											environmentAnalysisPropertyOptionSelected = "selected";
											foundOption = true;
										}else {
											environmentAnalysisPropertyOptionSelected = "";
										}
				%>
																<option value="<%=environmentAnalysisPropertyOption.getId() %>" <%=environmentAnalysisPropertyOptionSelected %>><%=environmentAnalysisPropertyOption.getText() %></option>
				<%
									}
									String displayOtherTextField = "none";
									String environmentAnalysisPropertyOtherValue = "";
									if(!foundOption) {
										environmentAnalysisPropertyOptionSelected = "selected";
										displayOtherTextField = "";
										environmentAnalysisPropertyOtherValue = environmentAnalysisProperty.getValue();
									}else {
										environmentAnalysisPropertyOptionSelected = "";
									}
				%>
																<option value="other" <%=environmentAnalysisPropertyOptionSelected %>>Other</option>
															</select>
														</td>
														<td style="padding-left:5">
															<input id="<%=environmentAnalysisProperty.getKey() %>Other" name="<%=environmentAnalysisProperty.getKey() %>Other" value="<%=environmentAnalysisPropertyOtherValue %>" style="display:<%=displayOtherTextField %>" />
														</td>
													</tr>
												</table>
											</td>
				<%
								}
							}else {
				%>
											<td style="padding-top:10" align="left">&nbsp;</td>
				<%
							}
				%>
										</tr>
									</table>
				<%
						}
				%>
								</td>
							</tr>
				<%
					}
				%>
						</table>
					</td>
				</tr>
				<tr height="10">
					<td>&nbsp;</td>
				</tr>
				<%
				}
				%>
				<tr height="10">
					<td>
						<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
							<tr>
								<td colspan="2"><span class="SECTION_HEADER">Environment Description</span></td>
							</tr>
							<tr>
								<td>
									<textarea id="reportDesc" name="reportDesc" rows="5" style="width:75%"><%=environmentAnalysisDesc %></textarea>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
						<td>&nbsp;</td>
				</tr>
			</table>												
		</td>
	</tr>
</table>

