<%@ page language="java"%>

<%@ page import="java.util.*"%>

<%@ page import="xpolog.eye.admin.wizards.common.scanner.WizardScannerViewControl"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisLocationInfo"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisReportBuilder"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.tools.XpologSystemInfo"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>


<%
	String PREFIX = "environmentAnalysisLocation";

	String scriptsOnlyStr = request.getParameter("scriptsOnly");
	boolean scriptsOnly = scriptsOnlyStr != null && scriptsOnlyStr.equals("true");
	
	String noScriptsStr = request.getParameter("noScripts");
	boolean noScripts = noScriptsStr != null && noScriptsStr.equals("true");
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String onlyUpdateStr = request.getParameter("onlyUpdate");
	boolean onlyUpdate = onlyUpdateStr != null && onlyUpdateStr.equals("true");
	
	String ERROR_OBJ = "ERROR_OBJ";
	String ENVIRONMENT_ANALYSIS_LOCATION_ID = "environmentAnalysisLocationId";
	String DUPLICATE = "DUPLICATE";
	String environmentAnalysisLocationId = request.getParameter(ENVIRONMENT_ANALYSIS_LOCATION_ID);
	String duplicateStr = request.getParameter(DUPLICATE);
	boolean duplicate = duplicateStr != null && duplicateStr.equals("true");
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	String locationType = "";
	String accountId = "";
	String dir = "";
	String filesToIncludeStr = "";
  String filesToExcludeStr = "";
  boolean includeDatelessLogs = true;
  int scanLevel = -1;
  int fileModificationFilterType;
  String fileModificationFilterTypeAllSelected = "";
  String fileModificationFilterTypeFilesSelected = "checked";
  String fileModificationFilterTypeFoldersAndFilesSelected = "";
  
	String displayAccDiv = "none";
	String displayLocationsDiv = "none";
	String locationsPathsStr = "empty";
	 
	EnvironmentAnalysisReportBuilder builder = (EnvironmentAnalysisReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");
	if (builder == null) {
		return;
	}
	
	List environmentAnalysisLocationInfos = builder.getEnvironmentAnalysisLocationInfos();
	EnvironmentAnalysisLocationInfo environmentAnalysisLocationInfo = null;
	if(environmentAnalysisLocationId != null){
		environmentAnalysisLocationInfo = builder.getEnvironmentAnalysisLocationInfo(environmentAnalysisLocationId);
	}else{
		environmentAnalysisLocationId = "";
	}
	if(environmentAnalysisLocationInfo != null){
		locationType = environmentAnalysisLocationInfo.getLocationType();
		if(locationType.equals("auth") || locationType.equals("ssh")) {
			displayAccDiv = "";
		}
		accountId = environmentAnalysisLocationInfo.getAccountId();
		dir = environmentAnalysisLocationInfo.getDir();
		if(dir != null && dir.length() > 0) {
			displayLocationsDiv = "";
			locationsPathsStr = dir;
		}
		filesToIncludeStr = environmentAnalysisLocationInfo.getFilesToInclude();
		filesToExcludeStr = environmentAnalysisLocationInfo.getFilesToExclude();
		includeDatelessLogs = environmentAnalysisLocationInfo.isIncludeDatelessLogs();
		scanLevel = environmentAnalysisLocationInfo.getSubdirsScanLevel();
		fileModificationFilterType = environmentAnalysisLocationInfo.getFileModificationFilterType();
		if(fileModificationFilterType == WizardScannerViewControl.FILE_MODIFICATION_FILTER_ALL) {
			fileModificationFilterTypeAllSelected = "checked";
			fileModificationFilterTypeFilesSelected = "";
		}else if(fileModificationFilterType == WizardScannerViewControl.FILE_MODIFICATION_FILTER_FILES_AFTER_FRAME) {
			fileModificationFilterTypeFilesSelected = "checked";
		}else if(fileModificationFilterType == WizardScannerViewControl.FILE_MODIFICATION_FILTER_FOLDERS_AND_FILES_AFTER_FRAME) {
			fileModificationFilterTypeFoldersAndFilesSelected = "checked";
			fileModificationFilterTypeFilesSelected = "";
		}
	}
	
	String displayAdvancedDiv = "none";
  if(!locationType.equals("") && !locationType.equals("none")) {
  	displayAdvancedDiv = "";
  }
	
%>
<%if (!noScripts){%>
<script>
      function doSave(){
        document.access.action ="taskExeAction.jsp";
        document.access.submit();
      }
      
      function goNew(){
      	path = "<%=BASE_DIRECTORY%>tools/addresses/accoutAction.jsp?ACCOUNT_TYPE=<%=TelnetAccount.TYPE_SSH%>";
				document.location = path;
  	  }

</script>
<%}%>

<%if (!scriptsOnly){%>
<%}%>
<%if (!onlyUpdate){%>
<input type="hidden" id="environmentAnalysisLocationId" name="environmentAnalysisLocationId" size="50" value="<%=duplicate ? "" : environmentAnalysisLocationId%>">
<%}%>
<%if (!onlyUpdate){%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
		<td id="<%=PREFIX%>DescriptionTD<%=suffix%>">
<%}%>  
		<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
 			<tr>
				<td style="padding-top:10;padding-bottom:10;padding-left:30px;background-color:#E4E4E4">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" >
					<tr>
						<td style="padding-top:10">
							<table border="0" cellpadding="0" cellspacing="0" width="100%" >
								<tr>
									<td>
										<div id="<%=PREFIX%>locationTypeDiv" style="visibility:"> 			                    			                   
										<table border="0" cellpadding="0" cellspacing="0" width="100%">
											<tr>
												<td width="25%" nowrap><span class="REGULARTEXT">Logs Location:</span></td>
												<td>
													<select class="TEXTBOX" id="<%=PREFIX%>locationType" name="<%=PREFIX%>locationType" onChange="javascript:changeLocationType('<%=PREFIX %>',this.name,'<%=BASE_DIRECTORY%>');">
														<option value="none" <%=locationType.equals("none") ? "selected" : "" %>>-- Select Location --</option>														
														<option value="local" <%=locationType.equals("local") ? "selected" : "" %>>Local</option>														
														<%if (XpologSystemInfo.isWindows()){%>														
														<option value="auth" <%=locationType.equals("auth") ? "selected" : "" %>>Windows Network</option>
														<%}%>
														<option value="ssh" <%=locationType.equals("ssh") ? "selected" : "" %>>Over SSH</option>
													</select>
												</td>
											</tr>
											<tr>
												<td colspan="2" style="padding-top:3">
													<div id="<%=PREFIX%>locationTypeErrorMsg" style="display:none;" class="ERROR_MSG">
													</div>
												</td>
											</tr>
										</table>
										</div>
									</td>
								<tr>
									<td colspan="2" style="padding-top:10">
										<div id="<%=PREFIX%>accountDiv" style="display:<%=displayAccDiv %>"> 			                   
										<table border="0" cellpadding="0" cellspacing="0" width="100%">                                        
											<tr>
												<td width="25%"><span class="REGULARTEXT">Connection Details:</span></td>
												<td>
													<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
														<tr>
															<td width="100px">
																<div id="<%=PREFIX %>accountsListDiv">
																	<%
																	String accountsListUrl = BASE_DIRECTORY + "common/accountsListCombo.jsp";
																	%>
																	<jsp:include flush="true" page="<%=accountsListUrl %>">
																		<jsp:param name="ACC_TYPE" value="<%=locationType%>"/>
																		<jsp:param name="ACC_ID" value="<%=accountId%>"/>
																		<jsp:param name="CHANGE_ACC_SELECTION" value="false"/>
																		<jsp:param name="PREFIX" value="<%=PREFIX%>"/>
																	</jsp:include> 																								
																</div>														                        
															</td>
															<%if (userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){%>
	 															<td style="padding-left:5">
																<div id="<%=PREFIX%>newAccountDiv">
																	<span class="SMALLTEXT"><a href="javascript:generalOpenNewAccountDiv('../../')" class="BUTTON_MEDIUMLINK">new</a></span>
																</div>	
															</td>
															<%} %>
															<td width="*">&nbsp;</td>
														</tr>
													</table>
												</td>
											</tr>
											<tr>
												<td colspan="2" style="padding-top:3">
													<div id="<%=PREFIX%>AccountIdErrorMsg" style="display:none;" class="ERROR_MSG">
													</div>
												</td>
											</tr>
										</table>
										</div>
									</td>
								</tr>
								<tr>
									<td colspan="2" style="padding-top:10">
										<div id="<%=PREFIX%>locationPathsDiv" style="display:<%=displayLocationsDiv%>"> 
											<jsp:include flush="true" page="locationPath.jsp">
												<jsp:param name="baseDirectory" value="" />
												<jsp:param name="LOCATIONS_CNTR" value="1"/>
												<jsp:param name="LOCATION_DESC0" value="Environment Logs Path:"/>
												<jsp:param name="LOCATIONS_PATH_ARR" value="<%=dir%>"/>
												<jsp:param name="PREFIX" value="<%=PREFIX%>"/>
											</jsp:include>	                      
										</div>
									</td>
								</tr>
								<tr>
									<td colspan="2" style="padding-top:10">
										<div id="<%=PREFIX%>advancedSettingsDiv" style="display:<%=displayAdvancedDiv%>">																				
											<table border="0" cellpadding="0" cellspacing="0" width="100%">
												<tr>
													<td>																										
														<table border="0" cellpadding="0" cellspacing="0" width="100%" class="ADV_SETTINGS_BAR_HEADER">
															<tr>
																<td>																										
																	<jsp:include page="../../common/adminSectionHeader.jsp" flush="true">
																		<jsp:param name="baseDirectory" value="../../" />
																		<jsp:param name="suffix" value="advancedSettings" />				
																		<jsp:param name="headerName" value="Advanced Settings" />
																		<jsp:param name="startOpen" value="false" />
																		<jsp:param name="showCheckBox" value="false" />
																		<jsp:param name="closeOthers" value="false" />
																		<jsp:param name="openOnClick" value="true" />
																	</jsp:include>
																</td>
															</tr>
														</table>
													</td>
												</tr>
												<tr>
													<td>
														<table border="0" id="adminHeaderContentadvancedSettings" cellpadding="0" cellspacing="0" style="display:none" width="100%" class="ADV_SETTINGS_TABLE">																				
															<tr valign="top">
																<!--<td style="padding-left:20;border-top:1 solid white">-->
																<td style="padding-left:13">
																	<div id="<%=PREFIX%>advFilesFilters">																				
																		<table border="0" cellpadding="0" cellspacing="0" width="100%">
																			<!--<tr>
																				<td>																										
																					<table border="0" cellpadding="0" cellspacing="0" width="100%" class="ADV_SETTINGS_BAR">
																						<tr>
																							<td>																										
																								<jsp:include page="../../common/adminSectionHeader.jsp" flush="true">
																									<jsp:param name="baseDirectory" value="../../" />
																									<jsp:param name="suffix" value="FilesFilters" />
																									<jsp:param name="level" value="1" />
																									<jsp:param name="headerName" value="Files Filters" />
																									<jsp:param name="startOpen" value="false" />
																									<jsp:param name="showCheckBox" value="false" />
																									<jsp:param name="closeOthers" value="false" />
																									<jsp:param name="openOnClick" value="true" />
																								</jsp:include>
																							</td>
																						</tr>
																					</table>
																				</td>
																			</tr>-->
																			<tr>
																				<td>																										
																					<table border="0" id="adminHeaderContentFilesFilters" cellpadding="0" cellspacing="0" width="100%" class="ADV_SETTINGS_TABLE">
																						<tr>
																							<td width="10" style="padding-top:5">&nbsp;</td>
																							<td width="100"><span class="REGULARTEXT">Include files:</span></td>
																							<td width="100">
																								<input class="TEXTBOX" type="text" id="includeFiles" name="includeFiles" size="30" value="<%=filesToIncludeStr%>">
																							</td>
																							<td width="*">&nbsp;<span class="SMALLTEXT">comma separated list</span></td>
																						</tr>
																						<tr>
																							<td>&nbsp;</td>
																							<td colspan="3" style="padding-top:5">
																								<table border="0" cellpadding="0" cellspacing="0" width="100%">
																									<tr>
																										<td><span class="REGULARTEXT">Include:</span></td>
																										<td>
																											<input type="radio" id="fileModificationFilterType" name="fileModificationFilterType" value="<%=WizardScannerViewControl.FILE_MODIFICATION_FILTER_ALL %>" <%=fileModificationFilterTypeAllSelected %>>&nbsp;<span class="REGULARTEXT">All folder and files, regardless of their modification time</span>
																										</td>
																									</tr>
																									<tr>
																										<td>&nbsp;</td>
																										<td>
																											<input type="radio" id="fileModificationFilterType" name="fileModificationFilterType" value="<%=WizardScannerViewControl.FILE_MODIFICATION_FILTER_FILES_AFTER_FRAME %>" <%=fileModificationFilterTypeFilesSelected %>>&nbsp;<span class="REGULARTEXT">Files that were updated after the given time filter</span>
																										</td>
																									</tr>
																									<tr>
																										<td>&nbsp;</td>
																										<td>
																											<input type="radio" id="fileModificationFilterType" name="fileModificationFilterType" value="<%=WizardScannerViewControl.FILE_MODIFICATION_FILTER_FOLDERS_AND_FILES_AFTER_FRAME %>" <%=fileModificationFilterTypeFoldersAndFilesSelected %>>&nbsp;<span class="REGULARTEXT">Folders and files that were updated after the given time filter</span>
																										</td>
																									</tr>
																								</table>
																							</td>
																						</tr>
																						<tr>
																							<td style="padding-top:15">&nbsp;</td>
																							<td colspan="3">
																								<input type="checkbox" id="includeDatelessLogs" name="includeDatelessLogs" value="true" <%if(includeDatelessLogs) { %>checked<%} %>>
																								<span class="REGULARTEXT">Include files whose records don't have a date column</span>
																							</td>
																						</tr>
																						<tr>
																							<td style="padding-top:15">&nbsp;</td>
																							<td><span class="REGULARTEXT">Exclude files:</span></td>
																							<td>
																								<input class="TEXTBOX" type="text" id="excludeFiles" name="excludeFiles" size="30" value="<%=filesToExcludeStr%>">
																							</td>
																							<td>&nbsp;<span class="SMALLTEXT">comma separated list</span></td>
																						</tr>
																						<tr>
																							<td style="padding-top:15">&nbsp;</td>
																							<td colspan="3">
																								<table border="0" cellpadding="0" cellspacing="0" width="100%">
																									<tr>
																										<td width="215"><span class="REGULARTEXT">Subdirectories levels to scan:</span></td>
																										<td width="50">
																											<select id="subDirLevel" name="subDirLevel" class="TEXT_BOX" size="1">
																												<option value="1000" selected>Unlimited</option>
																												<%
																												for(int i=1 ; i < 11 ; i++){
																													String selected = i == scanLevel ? "selected" : "";
																												%>
																													<option value="<%=String.valueOf(i)%>" <%=selected%>><%=String.valueOf(i)%></option>
																												<%
																												}
																												%>
																											</select>	
																										</td>
																										<td>&nbsp;</td>
																									</tr>
																								</table>
																							</td>
																						</tr>
																					</table>
																				</td>
																			</tr>																						
																		</table>			
																	</div>
																</td>													                      
															</tr>
														</table>
													</td>
												</tr>
											</table>
										</div>
									</td>
								</tr>
							</table>
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
<%if (!onlyUpdate){%>
		</td>
	</tr>
	<tr height="100%">
		<td>&nbsp;</td>
	</tr>
</table>
<%}%>