<%@ page language="java"%>

<%@ page import="java.util.ArrayList"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.eye.admin.wizards.common.scanner.WizardScannerViewControl"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisLocationInfo"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisReportBuilder"%>

<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	EnvironmentAnalysisReportBuilder builder = (EnvironmentAnalysisReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");
	if (builder == null) {
		return;
	}
	
	List environmentAnalysisLocationInfos = builder.getEnvironmentAnalysisLocationInfos();
	if(environmentAnalysisLocationInfos == null) {
		environmentAnalysisLocationInfos = new ArrayList();
	}
	
	String environmentAnalysisLocationId = request.getParameter("environmentAnalysisLocationId");
	EnvironmentAnalysisLocationInfo environmentAnalysisLocationInfo = builder.getEnvironmentAnalysisLocationInfo(environmentAnalysisLocationId);
	if(environmentAnalysisLocationInfo == null) {
		environmentAnalysisLocationInfo = new EnvironmentAnalysisLocationInfo();
		environmentAnalysisLocationId = String.valueOf(System.currentTimeMillis());
		environmentAnalysisLocationInfo.setId(environmentAnalysisLocationId);
		
		environmentAnalysisLocationInfos.add(environmentAnalysisLocationInfo);
	}
	
	String locationType = request.getParameter("environmentAnalysisLocationlocationType");
	if(locationType == null) {
		locationType = "none";
	}
	environmentAnalysisLocationInfo.setLocationType(locationType);
	
	String accountId = request.getParameter("environmentAnalysisLocationAccountsList");
	if(accountId == null || accountId.equals("none")) {
		accountId = "";
	}
	environmentAnalysisLocationInfo.setAccountId(accountId);
	
	String dir = request.getParameter("environmentAnalysisLocationfullPath_0");
	if(dir == null) {
		dir = "";
	}
	environmentAnalysisLocationInfo.setDir(dir);
	
	String filesToInclude = request.getParameter("includeFiles");
	if(filesToInclude == null) {
		filesToInclude = "";
	}
	environmentAnalysisLocationInfo.setFilesToInclude(filesToInclude);
	
	String fileModificationFilterTypeStr = request.getParameter("fileModificationFilterType");
	int fileModificationFilterType = WizardScannerViewControl.FILE_MODIFICATION_FILTER_FILES_AFTER_FRAME;
	try {
		fileModificationFilterType = Integer.parseInt(fileModificationFilterTypeStr);
	}catch(Exception e) {
		fileModificationFilterType = WizardScannerViewControl.FILE_MODIFICATION_FILTER_FILES_AFTER_FRAME;
	}
	environmentAnalysisLocationInfo.setFileModificationFilterType(fileModificationFilterType);
	
	String includeDatelessLogsStr = request.getParameter("includeDatelessLogs");
	boolean includeDatelessLogs = includeDatelessLogsStr != null && includeDatelessLogsStr.equals("true");
	environmentAnalysisLocationInfo.setIncludeDatelessLogs(includeDatelessLogs);
	
	String filesToExclude = request.getParameter("excludeFiles");
	if(filesToExclude == null) {
		filesToExclude = "";
	}
	environmentAnalysisLocationInfo.setFilesToExclude(filesToExclude);
	
	String subDirsScanLevelStr = request.getParameter("subDirLevel");
	int subDirsScanLevel = 1000;
	try {
		subDirsScanLevel = Integer.parseInt(subDirsScanLevelStr);
	}catch(Exception e) {
		subDirsScanLevel = 1000;
	}
	environmentAnalysisLocationInfo.setSubdirsScanLevel(subDirsScanLevel);
	
	builder.setEnvironmentAnalysisLocationInfos(environmentAnalysisLocationInfos);
	
	String resultStr = "ok#";
	
	response.setContentType("text/xml");
	out.write(resultStr.trim());
	out.flush();
%>