<%@page import="xpolog.eye.reports.group.ReportGroupRuntime"%>
<%@page import="xpolog.eye.reports.group.ReportGroup"%>
<%@page import="xpolog.eye.reports.agg.admin.LogAggCaseHelper"%>
<%@page import="xpolog.eye.data.RecordMask"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.agg.result.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.data.filters.*"%> 
<%@ page import="xpolog.eye.data.util.similarity.helpers.SimilarityLogHelper"%>
<%@ page import="xpolog.eye.knowledge.helpers.KnowledgeLogHelper"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
	String CURRENT_LOG = "CURRENT_LOG";
	String ERROR_OBJ = "ERROR_OBJ";
	ErrorModel errmodel = new ErrorModel();
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	String type = request.getParameter("type");
	String reportId = request.getParameter("reportId");
	String runtimeId = request.getParameter("reportRuntimeId");
	
	if (type == null || type.length() == 0){
		errmodel.addError("No type was supplied");
	}
	
	if (reportId == null || reportId.length() == 0){
		errmodel.addError("No report id supplied");
	}
	
	if (runtimeId == null || runtimeId.length() == 0){
		errmodel.addError("No report runtime id supplied");
	}
	
	if (errmodel.getErrorCount() > 0){
		request.getSession().setAttribute(ERROR_OBJ, errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
	}

	ReportsManager reportMgr = ReportsManager.getInstance();
	Report report = reportId == null ? null : reportMgr.getReportById(reportId, true);
	
	AggReportRuntime runtime = null;
	
	if (report != null && report instanceof ReportGroup){
		ReportGroupRuntime groupRuntime = (ReportGroupRuntime)report.getReportRuntimeById(runtimeId);		
		String childId = request.getParameter("childId");
		String childRuntimeId = request.getParameter("childRuntimeId");
		
		if (childId == null || reportId.length() == 0){
			errmodel.addError("No report child id supplied");
		}
		
		if (childRuntimeId == null || childRuntimeId.length() == 0){
			errmodel.addError("No report child runtime id supplied");
		}
		report = errmodel.getErrorCount() > 0 ? null : groupRuntime.getChildReport(reportMgr,new ReportRuntimeUnit(childId,childRuntimeId));
		runtime = errmodel.getErrorCount() > 0 ? null : (AggReportRuntime)groupRuntime.getChildReportRuntime(reportMgr,new ReportRuntimeUnit(childId,childRuntimeId));
	}else {
	  runtime = report == null ? null : (AggReportRuntime)report.getReportRuntimeById(runtimeId);			
	}
	
	if (runtime == null){
		errmodel.addError("No report runtime");
	}
	
	SiteManagment mgt = SiteManagment.getInstance();
	LogBrowsingManager lbm = null;
	RecordMask mask = null;
	long startTime = runtime.getStartTime();
	long endTime = runtime.getEndTime();
	
	if (errmodel.getErrorCount() > 0){
		request.getSession().setAttribute(ERROR_OBJ, errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
	}
	
	AggSubReportRuntime casesRuntime =  runtime.getAggSubReportRuntime();
	String indexStr = request.getParameter("caseIndex");
	int index = -1;
	String logId = null;
	String url = null;
	try {
		index = indexStr != null && indexStr.length() > 0 ? Integer.parseInt(indexStr) : -1;
	}catch (Exception e){}
	
	if (type.equals("case")){
		if (index >= 0){
			AggCaseResult result = casesRuntime.getReportTypeAt(index);
			if (result != null && result.getSourceInfo() != null){
				if (result.getSourceInfo().getSourceType().equals(AggSourceInfo.SOURCE_LOG_TYPE)){
  				logId = result.getSourceInfo().getSourceId();
				}
			}
		}
	}else if (type.equals("dims")){
		if (index >= 0){
			AggCaseResult result = casesRuntime.getReportTypeAt(index);
			if (result != null && result.getSourceInfo() != null){
				logId = result.getSourceInfo().getSourceId();
			}
		}
	}else if (type.equals("knowledge")){
		AggKnowledgeResult result = (AggKnowledgeResult)casesRuntime.getReportTypeAt(index);
		if (result != null && result.getSourceInfo() != null){
			logId = result.getSourceInfo().getSourceId();
			try{
				if (logId != null && logId.length() > 0){
		  		lbm = LogAggCaseHelper.getLogBrowsingManager(logId,report);
		  		if (lbm != null){
		  			mask = lbm.getRecordMask();
		  			String key = request.getParameter("key");
		  			String resultType = request.getParameter("resultType");
		  			if (key != null && key.length() > 0){
  		  			AggKnowledgeData data = result.getKnowledgeResultByKey(resultType,key);	
  		  			if (data != null){
  		  				FilterCollection col = KnowledgeLogHelper.getFilterForResult(data.getKnowledgeResult(), mask, startTime, endTime);
  		  				if (col != null){
  		  					lbm.getFilterManager().addFilterCollection(col);
  		  				}
  		  			}
		  			}
		  			request.getSession().setAttribute(CURRENT_LOG, lbm);
		  			String logIdParam = "logid=" + logId + "%26";
		  			if (lbm.isTemporary()){
		  				logIdParam = "";
		  			}
		  			url = BASE_DIRECTORY + "componentAction.jsp?selectedCompId=Xpolog&forward=loggers/logview.jsp?"+logIdParam+"opdirect=START%26addFilter=true%26calls=-1%26gotoMain=true%26timetamp=" + System.currentTimeMillis();
			  		//url = BASE_DIRECTORY + "loggers/logview.jsp?logid="+logId+"&gotoMain=true&opdirect=START&calls=-1&timetamp=" + System.currentTimeMillis();
		  		}
		  		
				}
			}catch(Exception e){
				errmodel.addError("Failed to get Log browsing manager for " + logId);
			}
		}
	}else if (type.equals("similarity")){
		AggSimilarityResult result = (AggSimilarityResult)casesRuntime.getReportTypeAt(index);
		if (result != null && result.getSourceInfo() != null){
			logId = result.getSourceInfo().getSourceId();
			try{
				if (logId != null && logId.length() > 0){
		  		lbm = LogAggCaseHelper.getLogBrowsingManager(logId,report);
		  		if (lbm != null){
		  			mask = lbm.getRecordMask();
		  			String key = request.getParameter("key");
		  			String resultType = request.getParameter("resultType");
		  			if (key != null && key.length() > 0){
  		  			AggSimilarityData data = result.getSimilarityResultByKey(resultType,key);	
  		  			if (data != null){
  		  				FilterCollection col = SimilarityLogHelper.getFilterForResult(data.getSimilarityResult(), mask, startTime, endTime);
  		  				if (col != null){
  		  					lbm.getFilterManager().addFilterCollection(col);
  		  				}
  		  			}
		  			}
		  			request.getSession().setAttribute(CURRENT_LOG, lbm);
		  			String logIdParam = "logid=" + logId + "%26";
		  			if (lbm.isTemporary()){
		  				logIdParam = "";
		  			}
		  			url = BASE_DIRECTORY + "componentAction.jsp?selectedCompId=Xpolog&forward=loggers/logview.jsp?"+logIdParam+"opdirect=START%26addFilter=true%26calls=-1%26gotoMain=true%26timetamp=" + System.currentTimeMillis();
			  		//url = BASE_DIRECTORY + "loggers/logview.jsp?logid="+logId+"&gotoMain=true&opdirect=START&calls=-1&timetamp=" + System.currentTimeMillis();
		  		}
		  		
				}
			}catch(Exception e){
				errmodel.addError("Failed to get Log browsing manager for " + logId);
			}
		}
	}
	
	
	if (url == null && errmodel.getErrorCount() == 0){
		errmodel.addError("Incorrect Parameters");
		errmodel.addError("It is possible that the target report was deleted");
	}
	
	if (errmodel.getErrorCount() > 0){
		request.getSession().setAttribute(ERROR_OBJ, errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
	}
	
	response.sendRedirect(url);
	
	%>