<%@ page language="java"%>

<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.reports.agg.transformer.AggCaseCSVFormatter"%>
<%@ page import="xpolog.eye.reports.agg.transformer.AggKnowledgeResultTextTransformer"%>
<%@ page import="xpolog.eye.reports.agg.transformer.AggSimilarityResultTextTransformer"%>
<%@ page import="xpolog.eye.reports.agg.result.AggKnowledgeResult"%>
<%@ page import="xpolog.eye.reports.agg.result.AggReportRuntime"%>
<%@ page import="xpolog.eye.reports.agg.result.AggSubReportRuntime"%>
<%@ page import="xpolog.eye.reports.agg.result.AggSimilarityResult"%>
<%@page import="xpolog.eye.reports.agg.admin.AggReportConstants"%>

<%@ page import="java.io.File"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
  ErrorModel errmodel = new ErrorModel();
  
  String reportId = request.getParameter("reportId");
  String reportRuntimeId = request.getParameter("reportRuntimeId");
  String aggCaseType = request.getParameter("caseType");
  String aggCaseIndexStr = request.getParameter("caseIndex");
  int aggCaseIndex = -1;
  if (aggCaseIndexStr != null && aggCaseIndexStr.length() > 0){
  	try{
  		aggCaseIndex = Integer.parseInt(aggCaseIndexStr);
  	}catch(Exception e){}
  }
	ReportsManager reportMgr = ReportsManager.getInstance();
	Report report = reportMgr.getReportById(reportId, true);
	if (reportId == null || reportId.trim().equals("")) {
		errmodel.addError("No Report id was supplied.");
	}
	if (reportRuntimeId == null || reportRuntimeId.trim().equals("")) {
		errmodel.addError("No Report runtime id was supplied.");
	}
  
	File f = null;
	try {
	AggReportRuntime runtime = (AggReportRuntime)report.getReportRuntimeById(reportRuntimeId);			
	AggSubReportRuntime casesRuntime =  runtime.getAggSubReportRuntime();
	if (aggCaseType != null && aggCaseType.equals(AggReportConstants.LOG_KNOWLEDGE_CASE_TYPE)){
		AggKnowledgeResult knowledgeResult = (AggKnowledgeResult)casesRuntime.getReportTypeAt(aggCaseIndex);
		if (knowledgeResult != null){
			AggKnowledgeResultTextTransformer transformer = new AggKnowledgeResultTextTransformer(knowledgeResult);
			AggCaseCSVFormatter formatter = new AggCaseCSVFormatter();
			transformer.setFormatter(formatter);
			transformer.transformResult();
			f = transformer.getExportFile();
		}
	}else if (aggCaseType != null && aggCaseType.equals(AggReportConstants.LOG_SIMILARITY_CASE_TYPE)){
		AggSimilarityResult similarityResult = (AggSimilarityResult)casesRuntime.getReportTypeAt(aggCaseIndex);
		if (similarityResult != null){
			AggSimilarityResultTextTransformer transformer = new AggSimilarityResultTextTransformer(similarityResult);
			AggCaseCSVFormatter formatter = new AggCaseCSVFormatter();
			transformer.setFormatter(formatter);
			transformer.transformResult();
			f = transformer.getExportFile();
						
		}
	}	
	}catch (Exception e){
		e.printStackTrace();
	}
	
	StringBuffer xml = new StringBuffer();
	xml.append("<result>");
	xml.append("<aggCaseExport");
	xml.append(" exportFile=\"" + (f != null ? f.getName() : "NA") + "\"");
	xml.append(" />");
	xml.append("</result>");

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	//System.out.println(xml.toString());
	out.write(xml.toString().trim());
	out.flush();

%>