<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>


<%
  String ERROR_OBJ = "ERROR_OBJ";

  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
   ErrorModel ermod = new ErrorModel();
   
   AggReportBuilder builder = (AggReportBuilder)  request.getSession().getAttribute("REPORT_BUILDER");
  
  
  if(builder == null){
    ermod.addError("Session is not valid any more. Please try again");
  }
  
  String statusRuleStr = request.getParameter("statusRule");
  AggCaseStatusRule statusRule = null;
  if (statusRuleStr != null && statusRuleStr.equalsIgnoreCase("ON")){
  	statusRule = new AggCaseStatusRule();
  	int ruleType = 0;
  	String ruleTypeStr = request.getParameter("ruleType");
  	if (ruleTypeStr != null && ruleTypeStr.length()>0){
  		try {
  			ruleType = Integer.parseInt(ruleTypeStr);
  		}catch (Exception e){
  			ermod.addError("Invalid rule type. Please try again");
  		}
  	}
  	statusRule.setRuleType(ruleType);
  	long amount = 0;
  	String amountStr = request.getParameter("amount");
  	if (amountStr != null && amountStr.length()>0){
  		try {
  			amount = Long.parseLong(amountStr);
  		}catch (Exception e){
  			ermod.addError("Amount is not valid number. Please try again");
  		}
  	}
  	statusRule.setAmount(amount);
  }
  
  if(ermod.getErrorCount() != 0){    
    request.getSession().setAttribute(ERROR_OBJ,ermod);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
    return;
  }
  
  
  	
  LogAggCaseBuilder caseBuilder = (LogAggCaseBuilder)builder.getCurrentCaseBuilder();
  LogAggregationConf conf = new LogAggregationConf();
  conf.setLogId(caseBuilder.getLogId());
  conf.setTotal(true);
  conf.setDayDis(false);
  conf.setHourDis(false);
  conf.setMinDis(false);
  
  String[] datafilterIds = request.getParameterValues("To_Select_datafilter");  
  boolean isTimeFilter = false;
  if(datafilterIds !=  null && datafilterIds.length > 0){
  	for(int i = 0; i < datafilterIds.length;i++){
  		if (datafilterIds[i].startsWith("*TimeFilter*")){
  			datafilterIds[i] = datafilterIds[i].substring(12);
  			isTimeFilter = true;
  		}
  	}
  	conf.setDataFilters(datafilterIds);
  }
  conf.setFilters(new String[]{""});
  conf.setFilters(true);
  caseBuilder.setAggConf(conf);
  caseBuilder.setDataFilters(datafilterIds);
  caseBuilder.setUseInMerge(!isTimeFilter);
  caseBuilder.setStatusRule(statusRule);
  
  AggBuilderHelper.updateAggCaseBuilderNames(caseBuilder);
  
  builder.addReportTypeBuilder(caseBuilder);
  try {
  	ModuleMember member = SiteManagment.getInstance().getModuleMember(caseBuilder.getLogId());
		if (member != null){
			builder.addModuleMember(member);
		}
  }catch (Exception e){
  	
  }
  response.sendRedirect("aggCasesView.jsp");
%>


