<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@page import="xpolog.eye.data.util.functions.*"%>
<%@page import="xpolog.eye.reports.agg.result.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!static final String BASE_DIRECTORY = "../../";

	%>
<%String ERROR_OBJ = "ERROR_OBJ";

			ErrorModel ermod = new ErrorModel();
			AggReportBuilder builder = (AggReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");

			if (builder == null) {
				ermod.addError("Session is not valid any more. Please try again");
			}

			if (ermod.getErrorCount() != 0) {
				request.getSession().setAttribute(ERROR_OBJ, ermod);
				response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
				return;
			}

			String type = request.getParameter("type");
			LogFunctionAggCaseBuilder caseBuilder = builder.getTempFunctionCaseBuilder();

			DataExpressionAggConf [] expressions = caseBuilder.getExpressionsAggConf();
			
      String functionIndexStr = request.getParameter("functionIndex");
			
			int functionIndex = -1;
			try {
				functionIndex = Integer.parseInt(functionIndexStr);
			}catch (Exception e){}
			
			DataExpressionAggConf selConf = functionIndex >= 0 && functionIndex < expressions.length ? expressions[functionIndex] : null;
			XpoLogFunctionFormat selFormat = null;
			String name = "";
			String expression = "";
			boolean showOverTime = true;
			if (selConf != null){
				expression = selConf.getExpression();
				String key = selConf.getResultKey();
				LogFunctionExpressionInfo info = caseBuilder.getFunctionInfo(key);
				if (info != null){
					name = info.getDisplayName();
					selFormat = info.getFormat();
					showOverTime = info.isShowOverTime();
				}
			}
			
			XpoLogFunctionFormat [] formats = XpoLogFunctionManager.getInstance().getFormats();
      if (formats.length > 1){
      	Arrays.sort(formats,XpoLogFunctionFormat.FORMAT_COMPARATOR);
      }
      
			
			String suffix = type != null && type.equals("routine") ? "Routine" : "";

			%>


<%@page import="xpolog.eye.data.util.functions.formats.XpoLogFunctionFormat"%>
<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
	<tr height="10">
		<td>
		<table border="0" cellpadding="0" cellspacing="0" width="100%">
			<tr>
				<td width="50"><span class="REGULARTEXT">Name</span></td>
				<td width="200"><input id="funcName" type="textbox" size="25" value="<%=name%>"></td>
				<td width="*" align="right" style="padding-right:50"><input id="showOverTime" <%=showOverTime ? "checked" : "" %> type="checkbox"  value="true"><span class="REGULARTEXT">Show result over time</span></td>
		</table>
		</td>
	</tr>

	<tr height="10" style="padding-top:2">
		<td><span class="REGULARTEXT">Function</span></td>
	</tr>
	<tr height="10">
		<td><textarea id="funcExpression" rows="4" cols="60" wrap="off"><%=expression%></textarea></td>
	</tr>
	
	<tr height="10">
		<td style="padding-top:10;padding-bottom:2">
		<table border="0" cellpadding="0" cellspacing="0" width="100%">
			<tr>
			<td width="30"><span class="REGULARTEXT"><nobr>Result Type </nobr></span></td>
				<td width="30" style="padding-left:5"><span class="REGULARTEXT">
				<select id="formatType" onChange="javascript:formatTypeChanged(this)">
				<%
				String formatName = "";
				String formatProp = "";
				for (int i = 0; i < formats.length;i++){ 
				  String displayName = formats[i].getDisplayName();
				  if (displayName == null || displayName.length() == 0){
				  	displayName = formats[i].getType();
				  }
				  
				  String selected = "";
				  if ((selFormat != null && selFormat.getType().equalsIgnoreCase(formats[i].getType())) || (selFormat == null && formats[i].getType().equalsIgnoreCase("simpleFormat"))){
				  	selected = "selected";
				  	formatName = selFormat == null ? formats[i].getName() : selFormat.getName();
				  	formatProp = selFormat == null ? formats[i].getPropertiesStr() : selFormat.getPropertiesStr();
				  }
				%>
				<option value="<%=formats[i].getType()%>" <%=selected%> formatName="<%=formats[i].getName() == null ? "Value" : formats[i].getName()%>"  formatProp="<%=formats[i].getPropertiesStr() == null ? "" : formats[i].getPropertiesStr()%>"><%=displayName%></option>
				<%} %>
				</select></span></td>
				<td width="10" style="padding-left:30"><span class="REGULARTEXT"><nobr> Graph Axis Name </nobr></span></td>
				<td width="10" style="padding-left:5;"><input id="formatName" type="textbox" size="15" value="<%=formatName%>"></td>				
				<td width="*" >&nbsp;</td>
				</tr>
				
		</table>
		</td>
	</tr>
	<tr height="10">
		<td style="padding-top:2;padding-bottom:2">
		<table border="0" cellpadding="0" cellspacing="0" width="100%">
		<tr>
				<td width="10" ><span class="REGULARTEXT"><nobr> Result Properties </nobr></span></td>
				<td width="100" style="padding-left:5"><input id="formatProp" type="textbox" size="60" value="<%=formatProp%>"></td>
				<td width="*" >&nbsp;</td>
				
				</tr>
		</table>		
		</td>
	</tr>
</table>

