<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.reports.agg.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.admin.*"%>
<%@ page import="xpolog.eye.data.aggregate.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@page import="xpolog.eye.data.util.functions.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!static final String BASE_DIRECTORY = "../../";

	%>
<%String ERROR_OBJ = "ERROR_OBJ";

			ErrorModel ermod = new ErrorModel();
			AggReportBuilder builder = (AggReportBuilder) request.getSession().getAttribute("REPORT_BUILDER");

			if (builder == null) {
				ermod.addError("Session is not valid any more. Please try again");
			}

			if (ermod.getErrorCount() != 0) {
				request.getSession().setAttribute(ERROR_OBJ, ermod);
				response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
				return;
			}

			LogFunctionAggCaseBuilder caseBuilder = (LogFunctionAggCaseBuilder) builder.getCurrentCaseBuilder();

			//site management  

			SiteManagment mgmt = SiteManagment.getInstance();
			SiteAdministrator admin = SiteManagment.getAdminInstance();

			LogAggregationConf conf = (LogAggregationConf) caseBuilder.getAggConf();

			LogBrowsingManager lbm = null;

			String lid = caseBuilder.getLogId();
			if ((lid != null) && !(lid.trim().equals(""))) {
				try {
					lbm = mgmt.getLogBrowserManager(lid,false,true,true);
				} catch (Exception e) {
				}
			} else {
				lid = conf.getLogId();
				try {
					lbm = mgmt.getLogBrowserManager(lid,false,true,true);
				} catch (Exception e) {
				}
			}

			if (lbm == null) {
				ermod.addError("Log couldn't created for logId " + lid);
			}

			if (ermod.getErrorCount() != 0) {
				request.getSession().setAttribute(ERROR_OBJ, ermod);
				response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=reports/reportsDefinitionView.jsp");
				return;
			}

			RecordMask mask = lbm.getRecordMask();
			MaskColumn[] cols = mask.getMaskColumns();
			
			int [] contentsColSel = caseBuilder.getColIndexes();
			
			String [] templates = caseBuilder.getTemplatesIds();
			if (templates == null){
				templates = new String[0];
			}
			
			HashSet tempatesSet = new HashSet();
			for(int i = 0; i < templates.length;i++){
				tempatesSet.add(templates[i]);
			}
			
			DataExpressionManager deMgr = DataExpressionManager.getInstance();
			DataExpressionTemplate [] deTemplates = deMgr.getTemplatesForGroup(DataExpressionConstants.LOG_DATA_GROUP);
			
			DataExpressionAggConf [] expressions = caseBuilder.getExpressionsAggConf();
			
			%>
<script>

var functionTableReq;
var selFuncIndex = -1;

var counter = <%=System.currentTimeMillis()%>;
function getFunctionsTable(){
  functionTableReq = GetXmlHttpObject();
  if (!functionTableReq) return;
  
  document.getElementById('functionTableTD').style.display = "none";
  document.getElementById('functionTableTDLoading').style.display = "";
  
  counter++;
  var url = "logFunctionFieldsExpressionsTable.jsp?counter=" + counter;  
  functionTableReq.onreadystatechange = showFunctionsTableResult;
  functionTableReq.open('GET', url, true);
  functionTableReq.send(null);  
  
}

function showFunctionsTableResult() {
      if (functionTableReq.readyState == 4) {
         if (functionTableReq.status == 200) {
            result = functionTableReq.responseText;
            document.getElementById('functionTableTD').innerHTML = result;            
            document.getElementById('functionTableTDLoading').style.display = "none";
            document.getElementById('functionTableTD').style.display = "";
         } else {
            alert('There was a problem with the request. - ' + functionTableReq.status);
         }
      }
   }
   
var functionEditReq;

function getFunctionsEdit(functionIndex){
  functionEditReq = GetXmlHttpObject();
  if (!functionEditReq) return;
  
  selFuncIndex = functionIndex;
  document.getElementById('innerFunctionDiv').innerHTML = "<span class='REGULARTEXT'>Loading...</span>";
  counter++;
  var url = "logFunctionFieldsExpressionEdit.jsp?counter=" + counter + "&functionIndex=" + functionIndex;  
  functionEditReq.onreadystatechange = showFunctionsEditResult;
  functionEditReq.open('GET', url, true); 
  functionEditReq.send(null);  
  
}

function showFunctionsEditResult() {
      if (functionEditReq.readyState == 4) {
         if (functionEditReq.status == 200) {
            result = functionEditReq.responseText;
            document.getElementById('innerFunctionDiv').innerHTML = result;            
         } else {
            alert('There was a problem with the request. - ' + functionEditReq.status);
         }
      }
   }
   
 var functionApplyReq;

function applyFunctionsOp(){
  functionApplyReq = GetXmlHttpObject();
  if (!functionApplyReq) return;
  
  var showOverTime = document.getElementById("showOverTime").checked ? "true" : "false";
  var parameters = "op=apply&functionIndex=" + selFuncIndex + "&funcName=" + encode( document.getElementById("funcName").value) + "&funcExpression=" + encode( document.getElementById("funcExpression").value)+ "&formatType=" + encode( document.getElementById("formatType").value)  + "&formatName=" + encode( document.getElementById("formatName").value) + "&showOverTime=" +  showOverTime + "&formatProp=" + encode( document.getElementById("formatProp").value);
  var url = "logFunctionFieldsExpressionsOperation.jsp";  
  functionApplyReq.onreadystatechange = showFunctionsApplyResult;
  functionApplyReq.open('POST', url, true);
  functionApplyReq.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  functionApplyReq.setRequestHeader("Content-length", parameters.length);
  functionApplyReq.setRequestHeader("Connection", "close");
  functionApplyReq.send(parameters);  
  
}

function showFunctionsApplyResult() {
      if (functionApplyReq.readyState == 4) {
         if (functionApplyReq.status == 200) {
            result = functionApplyReq.responseText;
            result = result.replace(/^\s+|\s+$/g, '') ;
            if (result == ""){
              closeFunction();
              getFunctionsTable();
            }else {
              alert(result);
            }
         } else {
            alert('There was a problem with the request. - ' + functionApplyReq.status);
         }
      }
   }
   
var functionRemoveReq;

function removeFunctionsOp(index){
  functionRemoveReq = GetXmlHttpObject();
  if (!functionRemoveReq) return;
  
  var parameters = "op=remove&functionIndex=" + index;
  var url = "logFunctionFieldsExpressionsOperation.jsp";  
  functionRemoveReq.onreadystatechange = showFunctionsRemoveResult;
  functionRemoveReq.open('POST', url, true);
  functionRemoveReq.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  functionRemoveReq.setRequestHeader("Content-length", parameters.length);
  functionRemoveReq.setRequestHeader("Connection", "close");
  functionRemoveReq.send(parameters);  
  
}

function showFunctionsRemoveResult() {
      if (functionRemoveReq.readyState == 4) {
         if (functionRemoveReq.status == 200) {
            result = functionRemoveReq.responseText;
            result = result.replace(/^\s+|\s+$/g, '') ;
            if (result == ""){
              getFunctionsTable();
            }else {
              alert(result);
            }
         } else {
            alert('There was a problem with the request. - ' + functionRemoveReq.status);
         }
      }
   }
   
   
function showFunctionDiv(divElem){    
  showHideLayerInMiddle(divElem,-1,220);
}
   
function addFunction(){
  getFunctionsEdit(-1);  
  showFunctionDiv("functionDiv");
    
}

function closeFunction(){
  var div = document.getElementById("functionDiv");  
  if (!div) return;  
  if(div.style.visibility == ""){
    showFunctionDiv("functionDiv");
  }   
}

function editFunction(functionIndex){
  getFunctionsEdit(functionIndex);  
  showFunctionDiv("functionDiv");
    
}

function removeFunction(functionIndex){
  removeFunctionsOp(functionIndex);  
    
}


var functionPredifinedApplyReq;

function addFunctionsPredefinedOp(combo){
  functionPredifinedApplyReq = GetXmlHttpObject();
  if (!functionPredifinedApplyReq) return;
  
  var dataKeys = "";
  var dataNames = "";
  var colsCombo = document.getElementById("logColumns");
  if (colsCombo.selectedIndex >= 0){
    for (var i = 0; i < colsCombo.options.length;i++){
      if (colsCombo[i].selected){
        dataKeys = dataKeys + colsCombo.options[i].value + ";";
        var name = colsCombo.options[i].name;
        if (!name || name == ""){
          name = " ";
        }
        dataNames = dataNames + name + ";";
      }
    }
  }else {
    alert("No column was selected.");
    return;
  }
  
  
  
  
  var templatesIds = "";
  if (combo.selectedIndex >= 0){
    for (var i = 0; i < combo.options.length;i++){
      if (combo[i].selected){
        templatesIds = templatesIds + combo.options[i].value + ";";
      }
    }
  }else {
    alert("No function was selected.");
    return;
  }
  
  
  
  var parameters = "type=<%=DataExpressionConstants.LOG_GROUP%>&op=addTemplate&functionIndex=-1&dataKeys=" + encode(dataKeys) + "&dataNames=" + encode(dataNames) + "&templatesIds=" + encode(templatesIds);
   
  var url = "logFunctionFieldsExpressionsOperation.jsp";  
  functionPredifinedApplyReq.onreadystatechange = showFunctionsPredefiniedApplyResult;
  functionPredifinedApplyReq.open('POST', url, true);
  functionPredifinedApplyReq.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  functionPredifinedApplyReq.setRequestHeader("Content-length", parameters.length);
  functionPredifinedApplyReq.setRequestHeader("Connection", "close");
  functionPredifinedApplyReq.send(parameters);  
  
}

function showFunctionsPredefiniedApplyResult() {
      if (functionPredifinedApplyReq.readyState == 4) {
         if (functionPredifinedApplyReq.status == 200) {
            result = functionPredifinedApplyReq.responseText;
            result = result.replace(/^\s+|\s+$/g, '') ;
            if (result == ""){
              getFunctionsTable();
            }else {
              alert(result);
            }
         } else {
            alert('There was a problem with the request. - ' + functionPredifinedApplyReq.status);
         }
      }
   }
   
   function addPredefined(){
      var combo = document.getElementById("logFunctions");
     if (combo.selectedIndex == -1){
       alert("Please select function.");
       return;
     }
     
     addFunctionsPredefinedOp(combo);
   }
   
   function formatTypeChanged(combo){
  if (combo.selectedIndex == -1){
    return;
  }
  
  document.getElementById("formatName").value = combo.options[combo.selectedIndex].formatName;
  document.getElementById("formatProp").value = combo.options[combo.selectedIndex].formatProp;
}
   
</script>

<div id="functionDiv" style="position:absolute;visibility:hidden;height:220;width:600">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid DBDFE2">
	<tr height="10">
		<td align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5"><span class="PROGRESSTEXT">Function</span></td>
	</tr>
	<tr>
		<td style="padding:5">
		<div id="innerFunctionDiv" style="overflow:auto;width:600;height:200">
		
		</div>
		</td>
	</tr>
	<tr height="10">
		<td>
				<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" >
						<tr>
							<td align="center" style="padding:2" width="10%">
									&nbsp;
							</td>
							<td align="center" style="padding:2" width="80%">
								<a class="LINK" href="javascript:closeFunction()">close</a>&nbsp;&nbsp;
								<a class="LINK" href="javascript:applyFunctionsOp()">apply</a>
							</td>			
							<td align="center" style="padding:2" width="10%">
								<a href=javascript:openHelp("<%=BASE_DIRECTORY%>","AddNewComputationFunction.htm") class="LINK">help</a>								
							</td>
						<tr>	
				</table>
		<td>
</table>
</div>

<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="53" style="visibility:visible">
	<tr>
		<td><span class="REGULARTEXT">Select the columns to be used in computation.</span></td>
	</tr>
	<tr>
		<td style="padding-top:5">
		<table border="0" width="600" cellspacing="0" cellpadding="0" height="100%">
			<tr>
				<td width="100">
				<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
					<tr><td style="padding-left:5;padding-bottom:2;padding-top:2"> <span class="REGULARTEXT">Columns</span></td></tr>
					<tr>
						<td>
						<%

			%> <select class="TEXTBOX" size="6" MULTIPLE name="logColumns" id="logColumns" style="font-size: 8pt; font-family: Verdana">
							<%for (int i = 0; i < cols.length; ++i) {
																																MaskColumn col = cols[i];
																																String colKey = DataExpressionHelper.getTypeForColumn(col) + (i + 1);

				%>
							<option value='<%=colKey%>' name='<%=col.getName()%>'>(<%=colKey%>) <%=col.getName()%></option>
							<%}

			%>
						</select></td>
					</tr>
					
				</table>
				</td>
				<td width="100" style="padding-left:10">
		<div id="lfDiv" >
		<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%">
		<tr><td style="padding-left:5;padding-bottom:2;padding-top:2"> <span class="REGULARTEXT">Functions</span></td></tr>
		<tr><td>
	<select class="TEXTBOX" MULTIPLE size="6" name="logFunctions" id="logFunctions" style="font-size: 8pt; font-family: Verdana">
							<%
							
							for (int i = 0; i < deTemplates.length; ++i) {
																																
				%>
							<option value='<%=deTemplates[i].getId()%>'><%=deTemplates[i].getShortName()%></option>
							<%}

			%>
						</select>
						</td></tr>
			</table>
			</div>
			</td>
			<td width="50">
		<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%">
		<tr><td style="padding-left:20;padding-bottom:2;padding-top:2"> <a class="LINK" href="javascript:addPredefined()">Add</a></td></tr>
		</table>
		</td>
			<td width="*">&nbsp;</td></tr>			
		</table>
		</td>
			</tr>

		
	<tr style="padding-top:5">
		<td><span class="REGULARTEXT"><a href="javascript:addFunction()" class="LINK">Add new function</a></span></td>
	</tr>

	<tr>
		<td id="functionTableTDLoading">
		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
			<tr class="TABLES_HEADERS">
				<td width="50"><span class="REGULARTEXT">Key</span></td>
				<td width="200"><span class="REGULARTEXT">Name</span></td>
				<td width="*"><span class="REGULARTEXT">Function</span></td>
				<td width="150" class="REGULARTEXT">&nbsp;</td>
			</tr>		
			<tr>
			<td colspan="4"><span class="REGULARTEXT">Loading...</span></td>
			</tr>
					</table>
		</td>
		<td id="functionTableTD" style="display:none">		
		</td>
	</tr>

	<tr>
		<td>&nbsp;</td>
	</tr>
</table>

