<%@ page language="java"%>

<%@ page import="java.util.List"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.reports.Report"%>
<%@ page import="xpolog.eye.reports.ReportsManager"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisProperty"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisReport"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
	
	String msSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator", ".");
	
	String PREFIX = "reportGenerationInputRequest";

	String DATE_MIN_FILTER_ACTIVE = "DateMinFilterActive";
	String DATE_MAX_FILTER_ACTIVE = "DateMaxFilterActive";
	String DATE_MINIMUM = "DateMinimum";
	String DATE_MAXIMUM = "DateMaximum";

	String BASE_DIR = "base_directory";
	String ERROR_OBJ = "ERROR_OBJ";
	ErrorModel errmodel = new ErrorModel();

  String baseDir = request.getParameter(BASE_DIR);
	if (baseDir == null || baseDir.equals("")) {
		baseDir = BASE_DIRECTORY;
	}
	
	String scriptsOnlyStr = request.getParameter("scriptsOnly");
	boolean scriptsOnly = scriptsOnlyStr != null && scriptsOnlyStr.equals("true");
	
	String noScriptsStr = request.getParameter("noScripts");
	boolean noScripts = noScriptsStr != null && noScriptsStr.equals("true");
	
	String reportId = request.getParameter("reportId");
  ReportsManager reportMgr = ReportsManager.getInstance();
  
  Report report = null;
  if(!scriptsOnly) {
  	report = reportId == null || reportId.length() == 0 ? null : reportMgr.getReportById(reportId);
  	if(report == null){
      errmodel.addError("No report was supplied");
    }
  }

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("../common/errorpage.jsp");
    return;
  }
  
  boolean isEnvironmentAnalysis = false;
  String divWidth = "500px";
  if(report != null && report instanceof EnvironmentAnalysisReport) {
  	isEnvironmentAnalysis = true;
  	request.setAttribute("report", report);
		List environmentAnalysisProperties = ((EnvironmentAnalysisReport)report).getEnvironmentAnalysisProperties();
		if(environmentAnalysisProperties != null) {
			request.setAttribute("environmentAnalysisProperties", environmentAnalysisProperties);
			
			EnvironmentAnalysisProperty environmentAnalysisProperty = null;
			for(int i = 0; i < environmentAnalysisProperties.size(); i++) {
				environmentAnalysisProperty = (EnvironmentAnalysisProperty)environmentAnalysisProperties.get(i);
				if(environmentAnalysisProperty.getType().equals(EnvironmentAnalysisProperty.TYPE_TIME)) {
					if(environmentAnalysisProperty.isRequired()) {
						divWidth = "850px";
					}
					break;
				}
			}
		}
  }
  
  String needsUserInputStr = request.getParameter("needsUserInput");
  boolean needsUserInput = needsUserInputStr != null && needsUserInputStr.equals("true");
	
  String executableStr = request.getParameter("executable");
	boolean executable = executableStr != null && executableStr.equals("true");
	
	String title = "Properties Values Required";
  
  String actionsNames = "";
  String actions = "";
  
  actionsNames += "Continue";
	actions += "javascript:continueReportGeneration('" + reportId + "', '" + isEnvironmentAnalysis + "', '" + executable + "')";
	
	actionsNames += "#Cancel";
	actions += "#javascript:cancelReportGeneration()";
	
	String selectedIndex = "1";
%>

<%if(scriptsOnly) { %>
<script>
	function shownHidediv(targetDiv){
		var d = document.getElementById(targetDiv);
	 	if (!d){
	  	return;
	  }      
	  show = d.style.display == "";
	  if(show){
	    d.style.display="none";   		
	  }else{
	    d.style.display="";
	  }
	}
	
	var selectedIndex = <%=selectedIndex%>;
	function changeTimeType(combo){
		shownHidediv("<%=PREFIX %>timeType" + selectedIndex + "Div");
	  var index = combo.selectedIndex;
	  if (index >= 0){ 
	    selectedIndex = index+1;
	    shownHidediv("<%=PREFIX %>timeType" + selectedIndex + "Div");
	  }
	  showFromInfo();
	}
	
	function showFromInfo(){
		if (selectedIndex == 3){
			if (document.reportGenerationForm.<%=PREFIX %>TimeUnit3.selectedIndex == 1){
				document.getElementById("<%=PREFIX %>fromLastDaysAtDiv").style.display = "";
			}
			document.getElementById("<%=PREFIX %>timeWindowSizeDiv").style.display = "";
		}else{
			document.getElementById("<%=PREFIX %>fromLastDaysAtDiv").style.display = "none";
			document.getElementById("<%=PREFIX %>timeWindowSizeDiv").style.display = "none";
		}
	}
	
	function updateGenerationTimeParams(){
		if (selectedIndex == 0){
			document.reportGenerationForm.<%=PREFIX %>TimeUnit.value = "days";
			document.reportGenerationForm.<%=PREFIX %>TimeText.value = "0";
		}else{
			document.reportGenerationForm.<%=PREFIX %>TimeUnit.value = eval("document.reportGenerationForm.<%=PREFIX %>TimeUnit"+selectedIndex).value;
			document.reportGenerationForm.<%=PREFIX %>TimeText.value = eval("document.reportGenerationForm.<%=PREFIX %>TimeText"+selectedIndex).value;
		}
		
		if (selectedIndex == 1){
			document.reportGenerationForm.<%=PREFIX %>TimeOpType.value = "1";
		}else if (selectedIndex == 2){
			document.reportGenerationForm.<%=PREFIX %>TimeOpType.value = "2";
		}else {
			document.reportGenerationForm.<%=PREFIX %>TimeOpType.value = "3";
		}
	}
	
	function checkDate(date_check_box, date_obj){
  	date_ok = "";
  	obj_name = date_check_box.name;
  	frames['<%=PREFIX %>dateValidationFrame'].location = "<%=baseDir%>calendar/dateValidation.jsp?dateStr="+date_obj.value+"&date_check_box="+obj_name;
  }
  
  function prepareGeneral(){          
  }
  
  function propertySelectChange(id) {
		var propertySelect = document.getElementById(id);
		if(propertySelect) {
			var otherTextField = document.getElementById(id + 'Other');
			if(otherTextField) {
				if(propertySelect.value == 'other') {
					otherTextField.style.display = "";
				}else {
					otherTextField.style.display = "none";
				}
			}
		}
	}
	
	function changeShow(){
	  var img = document.getElementById("showImage");
	  var val = "true";
	  if (img.src.indexOf("dont-show.gif") == -1){
	    img.src = "<%=baseDir%>images/portal/btns/wizard/dont-show.gif";
	    val = "false";
	  }else {
	    img.src = "<%=baseDir%>images/portal/btns/wizard/show.gif";
	  }
	  document.getElementById("<%=PREFIX %>needsUserInput").value = val;
	}
</script>
<%} %>
<%if(noScripts) { %>
<form AUTOCOMPLETE="OFF" id="reportGenerationForm" name="reportGenerationForm" style="margin:0px;padding:0px">
	<input type="hidden" id="reportId" name="reportId" value="<%=reportId %>">
	<input type="hidden" id="executable" name="executable" value="<%=executable %>">
	<jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
		<jsp:param name="baseDirectory" value="<%=baseDir%>"/> 
		<jsp:param name="title" value="<%=title%>"/> 
		<jsp:param name="suffix" value="reportGeneration"/>
		<jsp:param name="includePath" value="reports/reportGenerationInputRequest.jsp"/> 
		<jsp:param name="width" value="<%=divWidth %>"/> 
		<jsp:param name="height" value="350px"/>
		<jsp:param name="zIndex" value="400"/> 
		<jsp:param name="actionsNames" value="<%=actionsNames%>"/> 
		<jsp:param name="actions" value="<%=actions%>"/>
		<jsp:param name="prefix" value="<%=PREFIX%>"/>
		<jsp:param name="needsUserInput" value="<%=needsUserInput%>"/>
	</jsp:include>
</form>
<%} %>
<%if(scriptsOnly) { %>
<script language="JavaScript" src="<%=baseDir%>scripts/calendar/calendar2.js"></script>

<script>
	function openCal17(){
		document.reportGenerationForm.<%=PREFIX %><%=DATE_MIN_FILTER_ACTIVE%>.checked='true';
		if (!cal17){
			var cal17 = new calendar2("<%=baseDir%>",document.reportGenerationForm.<%=PREFIX %><%=DATE_MINIMUM%>,null,<%="/^\\-?\\d+(\\"+msSeperator+"\\d+)*$/"%>,"<%=msSeperator%>");
			cal17.year_scroll = true;
			cal17.time_comp = true;
			cal17.popup();
		}else{
			cal17.popup();
		}
	}
	function openCal18(){
		document.reportGenerationForm.<%=PREFIX %><%=DATE_MAX_FILTER_ACTIVE%>.checked='true';
		if(!cal18) {
			var cal18 = new calendar2("<%=baseDir%>",document.reportGenerationForm.<%=PREFIX %><%=DATE_MAXIMUM%>,null,<%="/^\\-?\\d+(\\"+msSeperator+"\\d+)*$/"%>,"<%=msSeperator%>");
			cal18.year_scroll = true;
			cal18.time_comp = true;
			cal18.popup();
		}else {
			cal18.popup();
		}
	}
</script>
<%} %>