<%@ page language="java"%>

<%@ page import="java.util.List"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.reports.Report"%>
<%@ page import="xpolog.eye.reports.ReportsManager"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisProperty"%>
<%@ page import="xpolog.eye.reports.environmentAnalysis.EnvironmentAnalysisReport"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
	
	String msSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator", ".");
	
	String BASE_DIR = "base_directory";
	String ERROR_OBJ = "ERROR_OBJ";
	ErrorModel errmodel = new ErrorModel();

  String baseDir = request.getParameter(BASE_DIR);
	if (baseDir == null || baseDir.equals("")) {
		baseDir = BASE_DIRECTORY;
	}
	
	String reportType = request.getParameter("reportType");
	int numberOfTypes = 0;
	String message = "";
	if(reportType != null && reportType.length() > 0) {
		ReportsManager reportMgr = ReportsManager.getInstance();
  	List templatesReports = reportMgr.getAllReportsTemplates(reportType);
  	numberOfTypes = templatesReports.size();
  	if(numberOfTypes == 1) {
  		String url = ((Report)templatesReports.get(0)).getUrl();
  		message = BASE_DIRECTORY + url;
  	}else if (numberOfTypes == 0) {
  		message = "Invalid type";
  	}
	}else {
		message = "Invalid type";
	}
	
	String titleType = request.getParameter("titleType");
	if(titleType == null || titleType.length() == 0) {
		titleType = "report";
	}
	
	response.setContentType("text/xml");
%>
<ReportTypeSelection>
<Result numberOfTypes="<%=numberOfTypes %>" titleType="<%=titleType %>">
<![CDATA[
<%
if(message.length() > 0) {
%>
	<%=message %>
<%
}else {
	String title = "Select the type of " + titleType + " to add";
  
  String actionsNames = "";
  String actions = "";
  
  actionsNames += "Continue";
	actions += "javascript:continueReportTypeSelection('" + reportType + "', '" + titleType + "')";
	
	actionsNames += "#Cancel";
	actions += "#javascript:cancelReportTypeSelection()";
%>
	<jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
		<jsp:param name="baseDirectory" value="<%=baseDir%>"/> 
		<jsp:param name="title" value="<%=title%>"/> 
		<jsp:param name="suffix" value="reportTypeSelection"/>
		<jsp:param name="includePath" value="reports/reportTypesList.jsp"/>
		<jsp:param name="reportType" value="<%=reportType %>"/> 
		<jsp:param name="width" value="400"/> 
		<jsp:param name="height" value="200px"/>
		<jsp:param name="zIndex" value="400"/> 
		<jsp:param name="actionsNames" value="<%=actionsNames%>"/> 
		<jsp:param name="actions" value="<%=actions%>"/>
	</jsp:include>

<%} %>
]]>
</Result>
</ReportTypeSelection>