<%@ page language="java"%>

<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@page import="xpolog.eye.managment.XpologApplicationComponent"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request,response,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION,true)){
  return;
}
UserContext userContext = UserEnvironment.getUserContext(request);

boolean isEdit = manager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.EDIT_REPORTS_PERMISSION);
boolean isExecute = manager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.EXECUTE_REPORTS_PERMISSION);

String lastSelectedRow = (String)request.getSession().getAttribute("lastSelectedReport");
if (lastSelectedRow == null){
	lastSelectedRow = "";
}

String isEnvironmentAnalysisStr = request.getParameter("isEnvironmentAnalysis");
boolean isEnvironmentAnalysis = isEnvironmentAnalysisStr != null && isEnvironmentAnalysisStr.equals("true");
boolean isTestingBuid = SiteManagment.getInstance().isTestingBuild();

UserEnvironment env = UserEnvironment.getUserEnvironment(request);
UserSecurity user = env.getUserContext().getUser();
XpologApplicationComponent selectedComp = (XpologApplicationComponent)env.getSelectedComponent(user);
boolean isTxExpo = selectedComp != null && selectedComp.getId().equals("TransactionExpo");


String typeText = "Report";
String typeTextLower = "report";
if(isEnvironmentAnalysis) {
	if(isTestingBuid) {
		typeText = "Testing Analysis";
		typeTextLower = "testing analysis";
	}else {
		typeText = "Environment Analysis";
		typeTextLower = "environment analysis";
	}
}else if (isTxExpo){
	
}

boolean showCompare = isEnvironmentAnalysis;

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>

<jsp:include page="../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
<jsp:param name="useTree" value="true" />
</jsp:include>
<%
boolean showMenu = isEdit || isExecute;
if(showMenu) {
	String menuIds = "generateReport,";
	String menuTexts = "Generate,";
	String menuHrefs = "javascript:generateReport0();,";
	if(isEnvironmentAnalysis) {
		menuIds += "viewResult,deleteResult,";
		menuTexts += "View,Delete,";
		menuHrefs += "javascript:viewResult0();,javascript:removeResult0();,";
	}else {
		menuIds += "viewReportResults,";
		menuTexts += "View Results,";
		menuHrefs += "javascript:viewReportResults0();,";
	}
	menuIds += "editReport,duplicateReport,removeReport";
	menuTexts += "Edit,Duplicate,Delete";
	menuHrefs += "javascript:editReport0();,javascript:duplicateReport0();,javascript:removeReport0();";
%>
<jsp:include page="../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		</jsp:include>
	<jsp:include page="../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	</jsp:include>
<%
}
%>

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";  
	
	function goNew(reportType){
		var titleType = "report";
		if(reportType == '<%=Report.ENVIRONMENT_ANALYSIS_LOG_GROUP_TYPE %>') {
			titleType = "environment";
		}
		var page = "reportTypeSelectionDiv.jsp?reportType=" + reportType + "&titleType=" + titleType;
		sendAjaxRequest(page,function(req){
			var xmlDoc = req.responseXML.documentElement;
			var resultElement = xmlDoc.getElementsByTagName("Result")[0];
			var result = "";
			if(document.all) {
				result = resultElement.childNodes[0].nodeValue;
			}else {
				result = resultElement.childNodes[1].nodeValue;
			}
			var numberOfTypesStr = resultElement.getAttribute("numberOfTypes");
			var numberOfTypes = parseInt(numberOfTypesStr);
			if(numberOfTypes > 1) {
				var reportTypeSelectionDivElem = document.getElementById("reportTypeSelectionDiv");
				if(reportTypeSelectionDivElem){
				  reportTypeSelectionDivElem.style.display = "";
				  reportTypeSelectionDivElem.innerHTML = result;
				}
				showGeneralAdminDiv("reportTypeSelection");
			}else if(numberOfTypes == 1) {
				document.location = result;
			}else {
				alert(result);
			} 
		});
  }
  
  function continueReportTypeSelection(reportType, titleType) {
  	var reortTypeErrorMsgElement = document.getElementById("reportTypeErrorMsg");
 		if(reortTypeErrorMsgElement) {
 			reortTypeErrorMsgElement.style.display ="none";
 		}
 		
	  var reportType = document.reportTypeSelectionForm.reportType;
	  var selectedType = "";
	  if(reportType) {
		  for(var i = 0; i < reportType.length; i++) {
	  		if(reportType[i].checked) {
		      selectedType = reportType[i].value;
	      }
	   	}
	  }

  	if(selectedType == "") {
  		if(reortTypeErrorMsgElement) {
  			reortTypeErrorMsgElement.style.display ="";
				reortTypeErrorMsgElement.innerHTML = "Type of " + titleType + "was not selected";
				return;
  		}
  	}
		document.location = selectedType;
  }
  
  function cancelReportTypeSelection() {
  	var reportTypeSelectionDivElem = document.getElementById("reportTypeSelectionDiv");
		if(reportTypeSelectionDivElem){
		  reportTypeSelectionDivElem.style.display = "none";
			reportTypeSelectionDivElem.innerHTML = "";
		}
  	hideGeneralAdminDiv("reportTypeSelection");
  }

  var deleteGroup = false;
  function doDelete(){   
    var reportId = mygrid.getSelectedRowId();
    if (reportId == "") {
      return;
    }
    if (reportId.indexOf(",") >= 0){
      doMembersDelete(reportId,reportId);
      return;
    }
    doDelete1(reportId);
  }

  function doMembersDelete(row,id){   
    var msgWriter = new messageWriter("mygridMessage","Report Delete Action","<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid"),50);
    msgWriter.addAction("Yes","javascript:hideLayer('mygridMessage');javascript:doMembersDelete0('" + row + "','" +  id + "')");
    msgWriter.addAction("No","javascript:hideLayer('mygridMessage')");  
    msgWriter.showMessage("<nobr>Are you sure you want to delete all selected reports</nobr>" + "?");
  }
  
  function doDelete1(reportId){   
    var name = mygrid.cells(reportId,0).getValue();
    var row = reportId;
    var isRuntime = mygrid.getUserData(reportId,"isRuntime");
    if(isRuntime && isRuntime == "true") {
    	doDeleteResult1(reportId);
    }else {
	    var isGroup = mygrid.getUserData(reportId,"isGroup");
	    var msgWriter = new messageWriter("mygridMessage","<%=typeText %> Delete Action","<%=BASE_DIRECTORY%>");
	    if (isGroup && isGroup == "true"){
	      deleteGroup = true;
	    }else {
	      deleteGroup = false;
	    }
	    msgWriter.setYParent(document.getElementById("mygrid"),50);
	    msgWriter.addAction("Yes","javascript:hideLayer('mygridMessage');javascript:doDelete0('" + row + "','" +  reportId + "')");
	    msgWriter.addAction("No","javascript:hideLayer('mygridMessage')");
	   	msgWriter.showMessage("<nobr>Are you sure you want to delete the <%=typeTextLower %> </nobr>" + name + "?");
		}
  }
  
  function doDelete0(row,id){  	
    lastSelectedRow = "";
  	deleteGridRow(mygrid,row,baseDirectory + "reports/removeReportAction.jsp?reportId=" + id + "&timestamp=" + new Date().getTime());
  }

  function doMembersDelete0(row,id){  	
  	deleteGridRow(mygrid,row,baseDirectory + "reports/removeReportAction.jsp?reportIds=" + id + "&timestamp=" + new Date().getTime());
  }
  
  function doExecute(){
    var reportId = getFirstSelectedRow(mygrid);
    if (reportId == "") {
     return;
    }
  	doExecute1(reportId);
  }
  
  function doExecute1(reportId){
  	var needsUserInput = mygrid.getUserData(reportId,"needsUserInput");
  	if(needsUserInput && needsUserInput == "true") {
  		var page = "reportGenerationDiv.jsp?reportId=" + reportId + "&noScripts=true&executable=true";
  		sendAjaxRequest(page,function(req){
				var result = req.responseText;	
				result = result.replace(/^\s+|\s+$/g, '') ;
				if (!result){
					alert("Could not open generation window!");
					return;
				}   
				var reportGenerationDivElem = document.getElementById("reportGenerationDiv");
				if(reportGenerationDivElem){
				  reportGenerationDivElem.style.display = "";
					reportGenerationDivElem.innerHTML = result;
				}
				showGeneralAdminDiv("reportGeneration");
			});
  	}else {
    	path = "reportRuntimeAction.jsp?reportId=" + reportId + "&executable=true";
  		document.location = path;
  	}
  }
  
  function continueReportGeneration(reportId, isEnvironmentAnalysis, executable) {
  	var prefix = 'reportGenerationInputRequest';
  	if(typeof updateGenerationTimeParams == 'function' && eval('document.reportGenerationForm.' + prefix + 'TimeUnit')) {
  		updateGenerationTimeParams();
  	}
  	var params = "reportId=" + reportId + "&prefix=reportGenerationInputRequest&";
  	params += getFormElementsQueryString(document.reportGenerationForm, prefix);
  	var page = "reportGenerationValidation.jsp?";
  	sendAjaxRequest(page,function(req){
			var xmldoc = req.responseXML.documentElement;
	    var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
	    if (result == "false"){
				var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
    		var msg = "<ul>";
    		var errs = message.split("*;*");
    		for (var i=0; i<errs.length; i++){
    			msg = msg + "<li>" + errs[i] + "</li>";
    		}
    		msg = msg + "</ul>"

		    var msgWriter = new messageWriter("reportDefinitionMessage","Generate Error","<%=BASE_DIRECTORY%>");
		    msgWriter.addAction("OK","javascript:hideLayer('reportDefinitionMessage')");
		    msgWriter.setStyle("left");  
		    msgWriter.showMessage(msg);
			}else {
				document.location = "<%=BASE_DIRECTORY %>reports/reportRuntimeGenerate.jsp&executable=" + executable;
			}
		},'POST',params);
  }
  
  function cancelReportGeneration() {
  	var reportGenerationDivElem = document.getElementById("reportGenerationDiv");
		if(reportGenerationDivElem){
		  reportGenerationDivElem.style.display = "none";
			reportGenerationDivElem.innerHTML = "";
		}
  	hideGeneralAdminDiv("reportGeneration");
  }
  
  function showResults(){
    var reportId = getFirstSelectedRow(mygrid);
    if (reportId == "") {
     return;
    }
    showResults1(reportId);
  }
  
  function showResults1(reportId){
    var viewUrl = mygrid.getUserData(reportId,"viewurl"); 
		if (!viewUrl || viewUrl == ""){
		  return;
		}
		var executable = mygrid.getUserData(reportId,"executable");
		if(viewUrl.indexOf("?") == -1) {
			viewUrl += "?";
		}
		viewUrl += "&executable=" + executable;
  	path = "<%=BASE_DIRECTORY%>" + viewUrl;
  	document.location = path;
  }
  
  function doDoubleClick(){
    var contextRowId = getFirstSelectedRow(mygrid);
    if (contextRowId == "") {
     return;
    }
    var isRuntime = mygrid.getUserData(contextRowId,"isRuntime");
    var isDummy = mygrid.getUserData(contextRowId,"isDummy");
    if(isRuntime && isRuntime == "true") {
    	viewResult1(contextRowId);
    }else if(isDummy && isDummy == "true") {
    	// do nothing
    }else {
    	doEdit1(contextRowId);
    }	
  }
  
  function doEdit(){
    var reportId = getFirstSelectedRow(mygrid);
    if (reportId == "") {
     return;
    }
    doEdit1(reportId);	
  }
  
  function doEdit1(reportId){
    var editUrl = mygrid.getUserData(reportId,"editurl"); 
		if (!editUrl || editUrl == ""){
		  return;
		}    
    path = "<%=BASE_DIRECTORY%>" + editUrl;
    var executable = mygrid.getUserData(reportId,"executable");
		if(path.indexOf("?") == -1) {
			path += "?";
		}
		path += "&executable=" + executable;
  	document.location = path;  	
  }
  
  function doDuplicate(){
   	var reportId = getFirstSelectedRow(mygrid);
    if (reportId == "") {
     return;
    }
    doDuplicate1(reportId);
  }
  
  function doDuplicate1(reportId){
   	var editUrl = mygrid.getUserData(reportId,"editurl"); 
		if (!editUrl || editUrl == ""){
		  return;
		}    
    path = "<%=BASE_DIRECTORY%>" + editUrl;
  	if (path.indexOf('?') != -1){
  		path += "&DUPLICATE=true";
  	}else{
  		path += "?DUPLICATE=true";
  	}
  	var executable = mygrid.getUserData(reportId,"executable");
		path += "&executable=" + executable;
  	document.location = path;
  }
  
  function viewReport(url){
  	path = "<%=BASE_DIRECTORY%>" + url;
  	document.location = path;
  }
  
  function goVerifier(id){
  	path = "<%=BASE_DIRECTORY%>verifiers/ReportVerifierSettings.jsp?reportId="+id;
  	document.location = path;
  }
  
  function showHideReports(id){
  	var repDiv = document.getElementById('md_'+id+'_div');
  	var im = document.getElementById('img_'+id);
  	if (repDiv){
  		if (repDiv.style.display == ""){
  			repDiv.style.display = "none";
  			if (im){
  				im.src = "<%=BASE_DIRECTORY%>images/tree/plus.gif";
  			}
  		}else{
  			repDiv.style.display = "";
  			if (im){
  				im.src = "<%=BASE_DIRECTORY%>images/tree/minus.gif";
  			}
  		}
  	}
  }
  
function showDesc(current,e,desc){
	var e = this.event || e;
	var tt = document.getElementById('reportDescDiv');
	var tableWidth = desc.length * 6;
	var reportDescTab = document.getElementById("reportDescTable");
	if (reportDescTab){
		reportDescTab.setAttribute("width",tableWidth);
	}
  var sizeArr = getWindowSize();
  var winWidth = 1280;
  var winHeight = 1024;
  if (sizeArr && sizeArr.length == 2){
  	winWidth = sizeArr[0];
  }
	
	x = (this.event ? document.body.scrollLeft + e.x : e.pageX);
  y = (this.event ? document.body.scrollTop +  e.y : e.pageY);
	tt.style.left = x < (winWidth-tableWidth-50) ? x + 50 : (x - tableWidth > 0 ? x - tableWidth : 0);
	tt.style.top = y;
	var desc_td = document.getElementById('descTD');
	if (document.all){
		desc_td.innerText = desc;
	}else{
		desc_td.textContent = desc;
	}
	tt.style.display = "";
}

function hideDesc(){
	var tt = document.getElementById('reportDescDiv');
	tt.style.display = "none";
}

//filter grid contnet based on values of two filter fields
   
  
    
    var actionReportReq;
	var rowId = "";
function doReportAction(url,id){
  rowId = "";
  actionReportReq = GetXmlHttpObject();
  if (!actionReportReq) return;
  rowId = id;  
  actionReportReq.onreadystatechange = showReportActionResult;
  actionReportReq.open('GET', url, true);
  actionReportReq.send(null);  
  
}

function showReportActionResult() {
      if (actionReportReq.readyState == 4) {
         if (actionReportReq.status == 200) {
            result = actionReportReq.responseText;
            if (rowId != ""){    
              mygrid.deleteRow(rowId);
            }        
         } else {
            alert('There was a problem with the request. - ' + actionReportReq.status);
         }
      }
   }
	
	function handleMenuItems(){
		var isRuntime = mygrid.getUserData(contextRowId,"isRuntime");
		var isDummy = mygrid.getUserData(contextRowId,"isDummy");
		var editable = mygrid.getUserData(contextRowId,"editable");
    if(isRuntime && isRuntime == "true") {
			<%if (isEdit){%>
 		    	aMenu.menu.showButtons("viewResult,deleteResult"); 
 			<%}else {%>
	 			  aMenu.menu.hideBar();
	 		<%}%>
		}else if(isDummy && isDummy == "true") {
			aMenu.menu.hideBar();
		}else {
			var executable = mygrid.getUserData(contextRowId,"executable");
			<%if(!isEnvironmentAnalysis) { %>
				aMenu.menu.showButtons("viewReportResults");
			<%}%>
			<%if (isEdit || isExecute){%>
			<%if(isExecute) {%>
			    if(executable && executable == "true") {
			    	aMenu.menu.showButtons("generateReport");
			    }		   
				<%}
				if(isEdit) {%>
					if(editable && editable == "true") {
			    	aMenu.menu.showButtons("editReport,removeReport");
			    }		   
		    	aMenu.menu.showButtons("duplicateReport");
				<%}
			}else {%>
				  aMenu.menu.hideBar();
			<%}%>
		}
  }
  
  function generateReport0(){
    if (contextRowId && contextRowId != ""){
      doExecute1(contextRowId);
    }
  }
  
  function viewReportResults0(){
    if (contextRowId && contextRowId != ""){
      showResults1(contextRowId);
    }
  }
  
  function editReport0(){
    if (contextRowId && contextRowId != ""){
      doEdit1(contextRowId);
    }
  }
  
  function duplicateReport0(){
    if (contextRowId && contextRowId != ""){
      doDuplicate1(contextRowId);
    }
  }
  
  function removeReport0(){
    if (contextRowId && contextRowId != ""){
      doDelete1(contextRowId);
    }
  }
  
  function viewResult0(){
    if (contextRowId && contextRowId != ""){
      viewResult1(contextRowId);
    }
  }
  
  function viewResult1(runtimeId){
    var viewUrl = mygrid.getUserData(runtimeId,"viewurl"); 
		if (!viewUrl || viewUrl == ""){
		  return;
		}  
  	path = "<%=BASE_DIRECTORY%>" + viewUrl;
  	document.location = path;
  }
  
  function removeResult0(){
    if (contextRowId && contextRowId != ""){
      doDeleteResult1(contextRowId);
    }
  }
  
  function doDeleteResult1(runtimeId){
    var reportId = mygrid.getUserData(runtimeId,"reportId");
    var name = mygrid.cells(runtimeId,0).getValue();
    var row = runtimeId;
   	var msgWriter = new messageWriter("mygridMessage","<%=typeText %> Runtime Delete Action","<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid"),50);
   	msgWriter.addAction("Yes","javascript:hideLayer('mygridMessage');javascript:doDeleteResult0('" + row + "','" + reportId + "','" + runtimeId +  "')");
    msgWriter.addAction("No","javascript:hideLayer('mygridMessage')"); 
 	  msgWriter.showMessage("<nobr>Are you sure you want to delete <%=typeTextLower %> runtime from </nobr>" + name + "?");
  }
  
  function doDeleteResult0(row,reportId,runtimeId){  	
  	deleteGridRow(mygrid,row,baseDirectory + "reports/removeReportRuntimeAction.jsp?reportId=" + reportId + "&reportRuntimeId=" + runtimeId + "&timestamp=" + new Date().getTime());
  }
  
  function viewCompare(){
    var arr = getSelectedRows(mygrid);
    if (!arr || arr.length < 1) {
     return;
    }
    var compareUrl = mygrid.getUserData(arr[0],"compareurl"); 
		if (!compareUrl || compareUrl == ""){
		  return;
		}
		currentCompareUrl = compareUrl;
		if(arr.length == 1) {
    	var isRuntime = mygrid.getUserData(arr[0],"isRuntime");
			if (!isRuntime){
			  isRuntime = "false";
			}
			var isDummy = mygrid.getUserData(arr[0],"isDummy");
		  if (!isDummy){
			  isDummy = "false";
			}
			var reportId;
			var runtimeId;
			if(isRuntime == "true" || isDummy == "true") {
				reportId = mygrid.getUserData(arr[0],"reportId");
				runtimeId = arr[0];
			}else {
				reportId = arr[0];
				runtimeId = "";
			}
			showCompareResultsSelection(reportId, runtimeId);
    }else {
	    var ids = getIdsFromArr(arr);
			viewCompare0(compareUrl, ids);
	  }
  }
  
  var compareResultsSelectionTree;
  var compareResultsSelectionTreeLoaded = false;
  function showCompareResultsSelection(reportId, reportRuntimeId) {
  	showGeneralAdminDiv("CompareResultsSelection");
  	if(!compareResultsSelectionTreeLoaded) {
  		initCompareResultsSelectionTree(reportId, reportRuntimeId);
  		compareResultsSelectionTreeLoaded = true;
  	}else {
  		compareResultsSelectionTree.deleteItem(compareResultsSelectionTree.htmlNode.childNodes[0].id);
  		compareResultsSelectionTree.loadXML("reportRuntimesCompareSelectionTreeXML.jsp?reportId=" + reportId + "&reportRuntimeId=" + reportRuntimeId);
  	}
  }
  
  function initCompareResultsSelectionTree(reportId, reportRuntimeId) {
  	compareResultsSelectionTree=new dhtmlXTreeObject("compareResultsSelectionTreeboxbox_tree","100%","100%","0");
  	compareResultsSelectionTree.enableTreeLines(false);
		compareResultsSelectionTree.setOnLoadingStart(startLoading);
		compareResultsSelectionTree.setOnLoadingEnd(endLoading);
		compareResultsSelectionTree.setImagePath("<%=BASE_DIRECTORY%>");
		compareResultsSelectionTree.setIconSize(13,13);
		compareResultsSelectionTree.enableCheckBoxes(1);
		compareResultsSelectionTree.enableThreeStateCheckboxes(true);
		compareResultsSelectionTree.loadingDivName = "loadingCompareResultsSelectionDiv";	
		compareResultsSelectionTree.setXMLAutoLoading("reportRuntimesCompareSelectionTreeXML.jsp");
		compareResultsSelectionTree.loadXML("reportRuntimesCompareSelectionTreeXML.jsp?reportId=" + reportId + "&reportRuntimeId=" + reportRuntimeId);
  }
  
  function doViewCompare() {
  	updateCompareResultsSelected();
  }
  
  var currentCompareUrl;
  function updateCompareResultsSelected(){
		var list = compareResultsSelectionTree.getAllCheckedAndPartiallyChecked();
		var arr = list.split(",");
		if(!arr || arr.length < 2) {
			var msgWriter = new messageWriter("compareResultsMessage","Compare Results Problem","<%=BASE_DIRECTORY%>");
	    msgWriter.setYParent(document.getElementById("mygrid"),50);
	    msgWriter.addAction("OK","javascript:hideLayer('compareResultsMessage')");  
	    msgWriter.showMessage("<nobr>At least two results should be selected</nobr>");
		}else {
			var ids = getIdsFromArr(arr);
	  	viewCompare0(currentCompareUrl, ids);
	  }
	}
	
	function getIdsFromArr(arr) {
		var ids = "";
		for (var i = 0; i < arr.length;i++){
		  if (i > 0){
		    ids =  ids + "|";
		  }
		  ids = ids + mygrid.getUserData(arr[i],"reportId") + "-" +arr[i];
		}
		return ids;
	}
  
  function viewCompare0(viewUrl, ids) {
  	viewUrl = viewUrl.replace("\[REPORT_ID\]","AggregationCompare");
		viewUrl = viewUrl.replace("\[REPORT_RUNTIME_ID\]",ids);		
  	var path = "<%=BASE_DIRECTORY%>" + viewUrl + "&isEnvironmentAnalysis=<%=isEnvironmentAnalysis%>";  	
  	document.location = path;
  }
  
  function hideCompareResultsSelection() {
  	hideGeneralAdminDiv("CompareResultsSelection");
  }

</script>

<jsp:include page="reportGenerationDiv.jsp" flush="true">
	<jsp:param name="base_directory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="scriptsOnly" value="true"/> 
</jsp:include>
<jsp:include page="../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

</head>

<%
String onLoadFunctions = "initTables();";
if(showMenu) {
	onLoadFunctions = "initMenus();" + onLoadFunctions;
}
%>
<body onLoad="<%=onLoadFunctions %>" onUnload="destroyTables()" style="margin:0;padding:0;overflow:auto;" >
<form AUTOCOMPLETE="OFF" id="reportTypeSelectionForm" name="reportTypeSelectionForm" style="margin:0px;padding:0px">
	<div id="reportTypeSelectionDiv" style="display:none">
	</div>
</form>
<div id="reportGenerationDiv" style="display:none">
</div>

<jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/>
	<jsp:param name="title" value="Select results to compare"/>
	<jsp:param name="suffix" value="CompareResultsSelection"/>
	<jsp:param name="width" value="500px"/>
	<jsp:param name="height" value="300px"/>
	<jsp:param name="zIndex" value="200"/>
	<jsp:param name="includePath" value="reports/reportRuntimesCompareSelectionDiv.jsp"/>
	<jsp:param name="actionsNames" value="Compare#Close"/>
	<jsp:param name="actions" value="javascript:doViewCompare()#javascript:hideCompareResultsSelection()"/>
</jsp:include>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td valign="top">
      <table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              
        <tr height="10">
          <td>
           <%
           String headerTitle = isEnvironmentAnalysis ? isTestingBuid ? "Testing Analyses" : "Environment Analyses" : "Reports";
           %>
           <jsp:include page="../common/pageMainHeader.jsp" flush="true">
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="headerTitle" value="<%=headerTitle %>" />
							</jsp:include>		
          </td>
         </tr>
         <tr>                
           <td valign="top"> 
            <% 

            String addName = isEdit ? "New Report#New Group" : "";
            String addLink = isEdit ? "javascript:goNew('" + Report.LOG_TYPE + "')#javascript:goNew('" + Report.LOG_GROUP_TYPE + "')" : "";
            if(isEnvironmentAnalysis) {
            	if(isTestingBuid) {
            		addName = isEdit ? "New Testing Analysis" : "";
            	}else {
            		addName = isEdit ? "New Environment Analysis" : "";
            	}
            	addLink = isEdit ? "javascript:goNew('" + Report.ENVIRONMENT_ANALYSIS_LOG_GROUP_TYPE + "')" : "";
            }else if (isTxExpo){
            	addName = isEdit ? "New Report" : "";
              addLink = isEdit ? "javascript:goNew('" + Report.TRANSACTION_TYPE + "')" : "";
            }
           
            String tableNames = isEdit ? "Edit#Duplicate#Delete" : "";
            String tableActions = isEdit ? "javascript:doEdit()#javascript:doDuplicate()#javascript:doDelete()" : "";
            String ids = isEdit ? "Edit#Duplicate#Delete" : "";
            String selectTypes = isEdit ? "2#2#3" : "";
            
            if (tableNames.length() > 0){
          		tableNames += "*;*";
          		tableActions += "*;*";
          		ids += "*;*";
          		selectTypes += "*;*";
          	}
            if (isExecute){                	
            	tableNames += "Generate#";
          		tableActions += "javascript:doExecute()#";
          		ids += "Execute#";
          		selectTypes += "2#";
            }
            if(isEnvironmentAnalysis) {
            	tableNames += "View Result#Compare Results";
          		tableActions += "javascript:doDoubleClick()#javascript:viewCompare()";
          		ids += "ShowResult#Compare";
          		selectTypes += "2#3";
             
            }else {
            	tableNames += "View Results";
         		tableActions += "javascript:showResults()";
         		ids += "ShowResults";
         		selectTypes += "2";
            }
            String menu = showMenu ? "aMenu" : "";
            
            String recordsText = isEnvironmentAnalysis ? isTestingBuid ? "Testing Analyses" : "Environment Analyses" : "Reports";
            
            String initXMLUrl = "reports/reportsDefinitionViewXML.jsp?isEnvironmentAnalysis=" + isEnvironmentAnalysis;
            String updateXMLUrl = "reports/reportsDefinitionViewXML.jsp?dataOnly=true&isEnvironmentAnalysis=" + isEnvironmentAnalysis;
            
            String doubleClickAction = "showResults";
            if(isEnvironmentAnalysis) {
            	doubleClickAction = "doDoubleClick";
            }
            %>
             <jsp:include page="../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="initXML" value="<%=initXMLUrl %>" />
							<jsp:param name="updateXML" value="<%=updateXMLUrl %>" />
							<jsp:param name="menu" value="<%=menu%>"/>
							<jsp:param name="newActionNames" value="<%=addName%>" />
							<jsp:param name="newActions" value="<%=addLink%>" />
							<jsp:param name="tableActionNames" value="<%=tableNames%>" />
							<jsp:param name="tableActions" value="<%=tableActions%>" />
							<jsp:param name="tableActionIds" value="<%=ids%>" />
							<jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
							<jsp:param name="recordsText" value="<%=recordsText %>" />
							<jsp:param name="style" value="main" />
							<jsp:param name="doubleClickAction" value="<%=doubleClickAction %>" />
							<jsp:param name="lastSelectedRow" value="<%=lastSelectedRow%>" />
						</jsp:include>
<script>
function updateButtonActivate(rowid,id,columnType,gridType){
	var editable = mygrid.getUserData(rowid,"editable");
	var executable = mygrid.getUserData(rowid,"executable");
	var isRuntime = mygrid.getUserData(rowid,"isRuntime");
	if (!isRuntime){
	  isRuntime = "false";
	}
	var isDummy = mygrid.getUserData(rowid,"isDummy");
  if (!isDummy){
	  isDummy = "false";
	}
	if (id == "Compare"){
		if (isDummy != "true"){
			var arr = getSelectedRows(mygrid);
		  if (!arr || arr.length < 1) {
		  	disableActionButton(id);
	     	return;
	    }
	    if(arr.length == 1) {
	    	enableActionButton(id);
	    	return;
	    }
	    for (var i = 0; i < arr.length;i++){
				var isRuntime = mygrid.getUserData(arr[i],"isRuntime");
			  if (!isRuntime || isRuntime == "false"){
			  	disableActionButton(id);
	     		return;
			  }
			}
			enableActionButton(id);
	  }else {
	  	var arr = getSelectedRows(mygrid);
	  	if (!arr || arr.length < 1) {
		  	disableActionButton(id);
	     	return;
	    }
	    if(arr.length == 1) {
	    	enableActionButton(id);
	    }else {
	  		disableActionButton(id);
	  	}
	  }
	}else if(id == "ShowResult") {
		if (isRuntime == "true"){
			var arr = getSelectedRows(mygrid);
		  if (arr && arr.length >= 2) {
		  	disableActionButton(id);
	     	return;
	    }
			enableActionButton(id);
		}else {
			disableActionButton(id);
		}
	}else if (isRuntime == "false" && isDummy == "false" && (id != "Execute" || executable == "true") && (gridType == columnType || (gridType == 2))){
		if ((id == "Edit" || id == "Delete" || id == "Permissions") && editable == "false"){
			disableActionButton(id);
		}else{
			enableActionButton(id);
		}
 	}else if (isRuntime == "true" && isDummy == "false" && id == "Delete" && (gridType == columnType || (gridType == 2))){
 	  enableActionButton(id); 	 
 	}else {
 	  disableActionButton(id);
 	}
}

function onAfterDelete(){	
	if (deleteGroup){
		updateTable();
	}			
}

function endLoad(){
    hideLoading();
    mygrid.setSizes();        
   
      if (lastSelectedRow && lastSelectedRow != ""){
      
     var arr = lastSelectedRow.split(",");     
     for (var i = 0; i < (arr.length - 1);i++){
       if (mygrid.doesRowExist(arr[i])){
         mygrid.selectRowById(arr[i],true,true,true);
       }
     }
     if (mygrid.doesRowExist(arr[arr.length - 1])){
       mygrid.selectRowById(arr[arr.length - 1],arr.length == 1 ? "" : true,true,true);
       mygrid.openItem(arr[arr.length - 1]);
       mygrid.showRow(arr[arr.length - 1]);
     }                    
  }

}
</script>
    	    </td>
  	    </tr>      
	    </table>
    </td>
  </tr>
</table>

</body>

</html>