<%@ page language="java"%>
<%@ page import="xpolog.eye.site.ui.grid.GridTable"%>
<%@ page import="xpolog.eye.site.ui.grid.models.ReportsGridTableModel"%>
<%@ page import="xpolog.eye.site.ui.grid.models.EnvironmentAnalysisGridTableModel"%>
<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@page import="xpolog.eye.managment.XpologApplicationComponent"%>
<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION, true)) {
		return;
	}

	String isFilterStr = request.getParameter("isFilter");
  boolean isFilter = isFilterStr != null && isFilterStr.equals("true"); 

	UserContext userContext = UserEnvironment.getUserContext(request);
	
	
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = "../";
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	UserSecurity user = env.getUserContext().getUser();
	XpologApplicationComponent selectedComp = (XpologApplicationComponent)env.getSelectedComponent(user);
	boolean isTxExpo = selectedComp != null && selectedComp.getId().equals("TransactionExpo");

	String isEnvironmentAnalysisStr = request.getParameter("isEnvironmentAnalysis");
	boolean isEnvironmentAnalysis = isEnvironmentAnalysisStr != null && isEnvironmentAnalysisStr.equals("true");
	
	ReportsGridTableModel model = null;
	String reportType = "";
	if(isTxExpo) {
		reportType = Report.TRANSACTION_TYPE;
		model = new ReportsGridTableModel();
	}else {
		if(isEnvironmentAnalysis) {
			reportType = Report.ENVIRONMENT_ANALYSIS_LOG_GROUP_TYPE;
			model = new EnvironmentAnalysisGridTableModel();
		}else {
			reportType = Report.LOG_TYPE + "|" + Report.LOG_GROUP_TYPE;
			model = new ReportsGridTableModel();
		}
	}
	
	model.setBaseDirectory(baseDirectory);
	model.setUserContext(userContext);
	model.setGridName("mygrid" + suffix);
	model.setReportType(reportType);
	
	model.init();
	GridTable table = new GridTable(model);
	request.setAttribute("gridTable" + suffix,table);
	
	request.getRequestDispatcher(baseDirectory + "widgets/grid/jsp/initTableXML.jsp").forward(request, response);	
%>