<%@ page language="java"%>

<%@ page import="java.util.HashSet"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.ModuleMember"%>
<%@ page import="xpolog.eye.managment.*" %>
<%@ page import="xpolog.eye.security.*" %>
<%@ page import="xpolog.eye.site.*" %>

<%

	 String query = request.getQueryString();
   if (query == null){
  	 query = "";
   }
   String loginUrl = query.length() == 0 ? "root.jsp" : "root.jsp?" + query;
   request.setAttribute("loginForwardURL",loginUrl);
   if (!xpolog.eye.security.WebSecurityManager.getInstance().checkForPermission(request,response,null,true)){
     return;
   }
   
	int keepAliveInterval = Configuration.getInstance().getPropertiesManager().getPropertyAsInt("keepAliveInterval",300000);
 
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  XpologApplicationComponent selectedComp = (XpologApplicationComponent)env.getSelectedComponent(user);
  
	UserContext userContext = UserEnvironment.getUserContext(request);;
	String folderId = request.getParameter("folderId");
	if (folderId != null){
		userContext.getIncludeMembersSet().clear();
		if (folderId.length() > 0){
			HashSet set = new HashSet();
			String foldersStr = "";
			String storageFoldersStr = "";
			if (folderId.indexOf(",") == -1){
        userContext.addIncludeMembersById(folderId);
        userContext.addIncludeMembersByName(folderId);
        
        if(folderId.indexOf(ModuleMember.STORAGE_SUFFIX) == -1) {
        	foldersStr = folderId;
        }else {
        	storageFoldersStr = folderId;
        }
			}else{
				String[] folders = folderId.split(",");
				for (int i=0; i<folders.length; i++){
					userContext.addIncludeMembersById(folders[i]);
			    userContext.addIncludeMembersByName(folders[i]);
			    
			    if(folders[i].indexOf(ModuleMember.STORAGE_SUFFIX) == -1) {
	        	if(foldersStr.indexOf(",") == -1) {
	        		foldersStr += ",";
	        	}
	        	foldersStr += folders[i];
	        }else {
	        	if(storageFoldersStr.indexOf(",") == -1) {
	        		storageFoldersStr += ",";
	        	}
	        	storageFoldersStr += folders[i];
	        }
				}
			}
			env.setGlobalAttribute("folderIdsToOpen", foldersStr);
			env.setGlobalAttribute("folderIdsToOpen" + ModuleMember.STORAGE_SUFFIX, storageFoldersStr);
		}
	}
	env.setUserContext(userContext);
	
   String mainPage = null; 
   String str = request.getParameter("mainPage"); 
   if (str != null && str.length() > 0){
				mainPage = str;
				/*System.out.println("mainPage1 = " + mainPage);
        String query = request.getQueryString();
        System.out.println("query1 = " + query);
        int index = query.indexOf("mainPage");
        System.out.println("index=" + index);
        query = query.substring(0,index) + query.substring(index + 9 + str.length(),query.length());
        System.out.println("query2 = " + query);
        if (query.startsWith("&")){
          query = query.substring(1,query.length());
        }
        if (query != null && !query.equals("")) {
	        mainPage += "?" + query;
        }
        System.out.println("mainPage2 = " + mainPage);*/
   }
   
  if (mainPage == null  && selectedComp != null){
  	String usePage = env.getUsePage();
  	if (false && usePage != null && usePage.length() > 0){
  		mainPage = usePage;
  	}else {  			
       mainPage = selectedComp.getMainPage();    
  	}
  }
  
  if (mainPage == null){
    mainPage = "logEyePortal.jsp";
  }
  
  String managementPage = request.getParameter("managementPage"); 
  if (managementPage != null && managementPage.length() == 0){
    managementPage = null;
  }
  
  if(selectedComp == null) {
	managementPage = "";
  }
  
  if (managementPage == null && selectedComp != null){  		
	  if (selectedComp.getComponentManagement() != null){
   		managementPage = selectedComp.getComponentManagement().getManagementPage();
	  }else {
		  managementPage="";
	  }
  }
  
  if (managementPage == null){
    managementPage = "management.jsp?proxyid=" + System.currentTimeMillis();
  }
  
  String hideManagementPageStr = request.getParameter("hideManagementPage");
  boolean hideManagementPage = hideManagementPageStr != null && hideManagementPageStr.equals("true");
  String managementTdDisplay = hideManagementPage ? "display:none" : ""; 
  
  env.removeSiteWizardController(); 
  ViewContext viewContext = env.getViewContext();
  String mngWidth = viewContext == null ? null : viewContext.managementWidth;
  if (mngWidth == null || mngWidth.length() == 0){
  	mngWidth = Configuration.getInstance().getPropertiesManager().getProperty("managementWidth","200");
    if (viewContext != null){
  	  viewContext.managementWidth = mngWidth;
    }
  }
 
  if(mngWidth.indexOf("px") == -1) {
  	mngWidth += "px";
  }
%> 

<html> 
<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">

<title>XpoLog Center</title> 
<link rel="stylesheet" type="text/css" href="css/mainproduct.css"/>

<script src="scripts/UIUtil.js" type="text/javascript"></script>
<script src="scripts/common/messages.js" type="text/javascript"></script>
<script  src="scripts/common/slidesOperations.js"></script>


<script>
var msgWriter;
function updateFrame(){
 //oCMenu.mout();
} 

function loadFrame(frmName){
  if(window.frames[frmName]){
    if (!window.frames[frmName].document.onmousedown){
      window.frames[frmName].document.onmousedown = updateFrame;
    }
  }
}

function updateManagement(){
  if(window.frames['treeframe'] && window.frames['treeframe'].mainLoaded){
    window.frames['treeframe'].mainLoaded();
  }
}

function showHideAllDiv(show){
  var d = document.getElementById("allDiv");
  if (d){
    if(show){       
      d.style.left = parseInt(document.getElementById("managementTD").style.width);
      d.style.top = findPosY(document.getElementById("managementTD"));
      d.style.height = document.getElementById("managementTD").clientHeight;
      d.style.visibility = "";     
    }else {
      d.style.visibility = "hidden";
    }
    updateFramesEvents(show);
  }
}

var lastFrm;
var lastLeft;
function getAbsolueFrameLeft(frm){
  if (lastFrm && lastFrm == frm){
    return lastLeft;
  }
  var left = 0;
  var tmp = frm;
  while (tmp.parent){
    if (tmp.name){
      var innerFrm = tmp.parent.document.getElementById(tmp.name);
      if (innerFrm){
        if (innerFrm.parentNode){
         left = left + findPosX(innerFrm.parentNode);
        }
      }
    }
    if (tmp == this){
      break;
    }
    tmp = tmp.parent;
  }
  lastFrm = frm;
  lastLeft = left;
  return left;
}


function FrmMouseEvt(frm){
  this.frm = frm;
}

scrollMouseMove=function(e){
  var frm;
  if (!e){
    if (lastFrm && lastFrm.event){
      frm = lastFrm;
    }else {
      var frms = getAllFrames(false);
      for(var i = 0; i < frms.length;i++){
        if (frms[i].event){
          frm = frms[i];
          break;
        }
      }
    }
  }
  
  if (e || !frm){
    return;
  }
  
  if (e){
    
    var left = e.pageX ;
    moveSplitterDivTo(left);
  }else {
    var left = getAbsolueFrameLeft(frm);
    left = left +  frm.event.x ;
    moveSplitterDivTo(left);
  }
  
}


FrmMouseEvt.prototype.updateFrameEvents=function(show){
  
  if (show){      
      this.origmouseup = this.frm.document.onmouseup;
     this.frm.document.onmouseup = hideScrollDrag;  
     //this.frm.document.onmouseup = scrollMouseMove;   
     //if (!document.all){
  			//window.captureEvents(Event.MOUSEDOWN | Event.MOUSEMOVE | Event.MOUSEUP);
     //} 
     
    }else {
      this.frm.document.onmouseup = this.origmouseup;     
    }
    
    if (show){      
      this.origmousemove = this.frm.document.onmousemove;
      this.frm.document.onmousemove = scrollMouseMove;        
    }else {
      this.frm.document.onmousemove = this.origmousemove;     
    }
}

var evts = new Array();

function updateFramesEvents(show){
  if (show){
    evts = new Array();
    var frms = getAllFrames(false);
    for(var i = 0; i < frms.length;i++){
      evts[i] = new FrmMouseEvt(frms[i]);
      evts[i].updateFrameEvents(show);
    }
  }else {
    for(var i = 0; i < evts.length;i++){
      evts[i].updateFrameEvents(show);
    }
    evts = new Array();
  }
  
 
}

function hideScrollDrag(){
  var w = document.getElementById("allDiv").style.left;
  showHideAllDiv(false);
  lastFrm = null;
  if(w.indexOf("px") == -1) {
		w += "px";
  }
  document.getElementById("managementTD").style.width = w;
  doBackgroundAction("contextAction.jsp?op=setMngWidth&mngWidth=" + w);
}


function moveSplitterDivTo(left){
	if (left > 100 && left < 500){
     document.getElementById("allDiv").style.left = left;
  }
}

function keepAliveBack(){
  doBackgroundAction("security/common/keepAliveBack.jsp");
  setTimeout("keepAliveBack()",<%=keepAliveInterval %>);
}

function openMsgWriter(id,title,actions,msg,baseDirectory,functions){
    msgWriter = new messageWriter(id,title,baseDirectory);
    var actionsArray = actions ? actions.split("#") : null;
    for(var i = 0 ;	actionsArray && i < actionsArray.length ; i++){
    	var nameAndaction = actionsArray[i] ? actionsArray[i].split("@") : null; 
    	if(nameAndaction && nameAndaction[0] && nameAndaction[1]){
			    msgWriter.addAction(nameAndaction[0],nameAndaction[1]);    	
    	}
    }
    if (functions){
      msgWriter.functions = functions;
    }
    msgWriter.setPosition(-1,-1);
    msgWriter.showMessage(msg);
}

function errorMsgWriter(id,errorMsg,baseDirectory){
  msgWriter = new messageWriter(id,"Error",baseDirectory);		
	msgWriter.addAction("Close","javascript:closeMsgWriter('" + id + "')");    	  	
  msgWriter.setPosition(-1,-1);
  msgWriter.showMessage(errorMsg);
}


function closeMsgWriter(id){
	msgWriter = null;
	hideLayer(id);
}

function openMainPage(url){
   var mainFrm = getFrameByName("main");
   if (mainFrm != null){
     mainFrm.location = url;
   }
}

//Open general div in root.jsp according url and params
function openTempDiv(suffix,params,width,height,func){
	var div = document.getElementById('tempDiv');
	if(div){
	    
			var page = "common/adminGeneralDiv.jsp?";
			sendAjaxRequest(page,function(req){
				var result = req.responseText;
				result = result.replace(/^\s+|\s+$/g, '') ;
				if(!result || result == "error"){
						alert("Could not open div!");			
						return;			
				}else{
					div.innerHTML = result;
					var innerDiv = document.getElementById('adminGeneralDiv' + suffix);
					if(innerDiv){				
						innerDiv.style.display = "";	
						width = width ? width : "300px";
						innerDiv.style.width = width;
						height = height ? height : "300px";
						innerDiv.style.height = height;
						if(func){
							func();
						}
						showLayerInMiddle('tempDiv', -1 , -1);	
					}
			  }		   
			},'POST',params);	
	}
}

//Open general div in root.jsp according url and params
function openGeneralDiv(infoPage,params,progressTitle,progressMsg){
	var div = document.getElementById('generalDiv');
	if(div){
	    if (progressTitle && progressTitle != "" && progressMsg && progressMsg != ""){
	      if (msgWriter && msgWriter != null){
          closeMsgWriter(msgWriter.messageDivId);
        }
	      msgWriter = new messageWriter("openGeneralMsgWriter",progressTitle,baseDirectory);		    	  	
        msgWriter.setPosition(-1,-1);
        msgWriter.showMessage(progressMsg);
	    }
	
	    if (div.style.visibility == ""){
	      div.style.visibility = "hidden"; 
	    }			
			sendAjaxRequest(infoPage,function(req){
				var xmldoc = req.responseXML.documentElement;
				var resultType = xmldoc.getElementsByTagName('resultType')[0].firstChild.nodeValue;
				if(resultType == "admin") { 
	        var width = xmldoc.getElementsByTagName('width')[0].firstChild.nodeValue;        
					var height = xmldoc.getElementsByTagName('height')[0].firstChild.nodeValue;
					
					var adminPageParams = xmldoc.getElementsByTagName('adminPageParams')[0].firstChild.nodeValue;
					adminPageParams = adminPageParams + "&height=" + height + "&width=" + width;
					var suffix = xmldoc.getElementsByTagName('suffix')[0].firstChild.nodeValue;
												 
				 var page = "common/adminGeneralDiv.jsp?";
					sendAjaxRequest(page,function(req){
					  if (msgWriter && msgWriter != null){
	            closeMsgWriter(msgWriter.messageDivId);
	          }
						var result = req.responseText;
						result = result.replace(/^\s+|\s+$/g, '') ;
						if(!result || result == "error"){
								alert("Could not open div!");			
								return;			
						}else{
							div.innerHTML = result;
							var innerDiv = document.getElementById('adminGeneralDiv' + suffix);
							if(innerDiv){
								innerDiv.style.display = "";	
								width = width ? width : "300px";
								innerDiv.style.width = width;
					      height = height ? height : "300px";
								innerDiv.style.height = height;					
								div.style.width = width;
								div.style.height = height;		
								showLayerInMiddle('generalDiv', -1 , -1);
				 			}			 			
					  }
					},'POST',adminPageParams);
				}else if(resultType == "message") {
					if (msgWriter && msgWriter != null){
	          closeMsgWriter(msgWriter.messageDivId);
	        }
					var suffix = xmldoc.getElementsByTagName('suffix')[0].firstChild.nodeValue;
					if(!suffix || suffix == "") {
						suffix = "generalDivMessage";
					}
					var title = xmldoc.getElementsByTagName('title')[0].firstChild.nodeValue;
					var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
					var actionNames = xmldoc.getElementsByTagName('actionNames')[0].firstChild.nodeValue;
					var actions = xmldoc.getElementsByTagName('actions')[0].firstChild.nodeValue;
					
					msgWriter = new messageWriter(suffix,title,baseDirectory);		    	  	
       	 	msgWriter.setPosition(-1,-1);
        	if(actionNames && actions) {
        		var actionNamesArr = actionNames.split("#");
        		var actionsArr = actions.split("#");
        		if(actionNamesArr.length == actionsArr.length) {
        			for(i = 0; i < actionNamesArr.length; i++) {
        				msgWriter.addAction(actionNamesArr[i],actionsArr[i]);
        			}
        		}
        	}
        	msgWriter.showMessage(message);
				}
			},'POST',params);	
	}
}

function closeTempDiv(){
	hideLayer('tempDiv');
}

function closeGenralDiv(){
	document.getElementById("generalDiv").style.visibility = "hidden";
}

function clearAndCloseGeneralDiv(){
  closeGenralDiv();
  handleInnerHTML(document.getElementById("generalDiv"),"",0);
}


setTimeout("keepAliveBack()",<%=keepAliveInterval%>);

function _selectToRemove(suffix,params,width,height){
var div = document.getElementById('tempDiv');
	if(div){			
			if((frames['selectSnapshotToRemovFrm'])){
				frames['selectSnapshotToRemovFrm'].location = "snapshot/selectSnapshotToRemoveInnerFrm.jsp";
				showLayerInMiddle('tempDiv', -1 , -1);	
			}else{
				var page = "common/adminGeneralDiv.jsp?";
				sendAjaxRequest(page,function(req){
					var result = req.responseText;
					result = result.replace(/^\s+|\s+$/g, '') ;
					if(!result || result == "error"){
							alert("Could not open div!");			
							return;			
					}else{
						div.innerHTML = result;
						var innerDiv = document.getElementById('adminGeneralDiv' + suffix);
						if(innerDiv){		
							innerDiv.style.display = "";	
							width = width ? width : "300px";
							innerDiv.style.width = width;
							height = height ? height : "300px";
							innerDiv.style.height = height;
							showLayerInMiddle('tempDiv', -1 , -1);	
	//						document.getElementById('selectSnapshotToRemovFrm').src = "snapshot/selectSnapshotToRemoveInnerFrm.jsp";
	//						alert(document.getElementById('selectSnapshotToRemovFrm').location);
						  frames['selectSnapshotToRemovFrm'].location = "snapshot/selectSnapshotToRemoveInnerFrm.jsp";		   
						}
				  }
				},'POST',params);	
			}
	}
}

	function removeSelectedSnapshot0(){
		var frm = frames['selectSnapshotToRemovFrm'];
		if(frm){
			frm._removeSelectedSnapshot0();
		}	
	}
	


</script>


</head>
<body topmargin=5 marginheight=2 rightmargin=2 leftmargin=2 scroll="NO">
<table width="100%" height="100%" cellspacing="0" cellpadding="0" border="0">
<tr>
<td colspan="1" height="18"><jsp:include page="topMenu.jsp" flush="true" /></td>
</tr>
<tr>
<td style="border-top:1px solid #dadbe6;">
<div id="allDiv" style="position:absolute;visibility:hidden;top:0;height:0;width:2">
<iframe frameborder="0" width="100%" height="100%"  src="iframebackground.html" width="100%" name="noneFrm"></iframe>
</div>
<div id="tempDiv" style="position:absolute;visibility:hidden;top:0;height:300px;width:300px;margin:0;padding:0">
</div>
<div id="generalDiv" style="position:absolute;visibility:hidden;top:0;height:300px;width:300px;margin:0;padding:0;z-index:50">
</div>
<table width="100%" height="100%" cellspacing="0" cellpadding="0" border="0" style="table-layout:fixed">
<tr>
<%if(managementPage != null && managementPage.length() != 0){%>
<td  style="width:<%=mngWidth%>;<%=managementTdDisplay%>" id="managementTD" ><IFRAME frameborder="0" width="100%" height="100%"  src="<%=managementPage%>" name="treeframe" target="main" onLoad="javascript:loadFrame('treeframe')"></IFRAME></td>
<td id="borderTD" style="width:2px;background-color:#FFFFFF;cursor:col-resize" onmousedown="showHideAllDiv(true)" onmouseup="showHideAllDiv(false)"></td>
<td style="border-top: 0 solid #C0C0C0" width="*" id="mainTD"><IFRAME frameborder="0" width="100%" height="100%"  SRC=<%=mainPage%> name="main" onLoad="javascript:loadFrame('main');updateManagement()" ></IFRAME></td>
<%}else {%>
<td style="border-top: 0 solid #C0C0C0" width="100%" id="mainTD"><IFRAME frameborder="0" width="100%" height="100%" SRC=<%=mainPage%> name="main" onLoad="javascript:loadFrame('main')"></IFRAME></td>
<%}%>
</tr>
</table>
</td></tr>
</table>

</body>
</HTML>
