<%@ page import="xpolog.eye.scheduler.ui.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>
<%
	JobBuilder myjob = (JobBuilder)request.getAttribute("CURRENT_JOB");
	if (myjob == null){
		myjob = (JobBuilder)request.getSession().getAttribute("CURRENT_JOB");
		request.getSession().removeAttribute("CURRENT_JOB");
	}
	String suffix = (String)request.getAttribute("suffix");
	if (suffix == null){
		suffix = request.getParameter("suffix");
	}
	String allowMultiStr = request.getParameter("allowMulti");
	boolean allowMulti = allowMultiStr != null && allowMultiStr.equals("true");
	String action = request.getParameter("action");
	boolean isAdd = action != null && action.equals("add");
	
	if (suffix == null){
	  suffix = "";
	}
	JobBuilder[] builders = null;
	if (myjob instanceof MultiJobBuilder){
		builders = ((MultiJobBuilder)myjob).getAllDiscreteExecutionJobBuilders();
		if (isAdd){
			JobBuilder builder = new JobBuilder();
			JobBuilder[] tmp = new JobBuilder[builders.length+1];
			System.arraycopy(builders,0,tmp,0,builders.length);
			tmp[tmp.length-1] = builder;
			builders = tmp;
		}
	}else{
		builders = new JobBuilder[]{myjob};
	}

%>
<div id="schedulerExecutions<%=suffix%>">
<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
<%
for (int i=0; i<builders.length; i++){
	request.setAttribute("CURRENT_JOB",builders[i]);
	boolean showAdd = allowMulti && (i == builders.length-1);
	boolean showRemove = allowMulti && i > 0;
%>
	<tr>
		<td>
			<jsp:include page="newSchedulerExecution.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="suffix" value="<%=suffix%>"/>
				<jsp:param name="id" value="<%=i%>" />
				<jsp:param name="showAdd" value="<%=showAdd%>" />
				<jsp:param name="showRemove" value="<%=showRemove%>" />
			</jsp:include>
		</td>
	</tr>
	<tr>
		<td style="font-size:1px" colspan="3">&nbsp;</td>
	</tr>
<%}%> 
</table>
</div>