function findPosX(obj)
{
	var curleft = 0;
	if (obj.offsetParent)
	{
		while (obj.offsetParent)
		{
			curleft += obj.offsetLeft
			obj = obj.offsetParent;
		}
	}
	else if (obj.x)
		curleft += obj.x;
	return curleft;
}

function findPosY(obj)
{
	var curtop = 0;
	if (obj.offsetParent)
	{
		while (obj.offsetParent)
		{
			curtop += (obj.offsetTop - obj.scrollTop);
			if (obj.parentNode && (obj.parentNode.tagName == "DIV") && obj.parentNode != obj.offsetParent){
			  curtop = curtop - obj.parentNode.scrollTop;
			} 
			obj = obj.offsetParent;			
		}
	}
	
	else if (obj.y){
		curtop += obj.y;
  }
	return curtop;
}

function hideLayer(id){
  var d = document.getElementById(id);
  if(d) {
	  d.style.visibility = "hidden";
  }
}

function showLayer(id){
  var d = document.getElementById(id);
  if(d) {
	  d.style.visibility = "";
  }
}

function hideDisplayLayer(id){
  var d = document.getElementById(id);
  if(d) {
	  d.style.display = "none";
  }
}

function showDisplayLayer(id){
  var d = document.getElementById(id);
  if(d) {
	  d.style.display = "";
  }
}

function showHideLayer(id){
  var d = document.getElementById(id);
  if (d.style.visibility == ""){
    d.style.visibility = "hidden";
  }
}

// use -1 for get the middle of x or y
function showHideLayerInMiddle(id,x,y,isDisplay){
  var d = document.getElementById(id);
  if(d) {
	  if (isDisplay){
	    if (d.style.display == ""){
	      d.style.display = "none";
	      return;
	    }
	  }else {
	    if (d.style.visibility == ""){
	      d.style.visibility = "hidden";
	      return;
	    }
	  }
	  var w = document.body.clientWidth/2;
	  var h = document.body.clientHeight/2;
	  if (x < 0){
	  	var wid = d.clientWidth <= 0 ?d.style.width : d.clientWidth;
	  	if (typeof(wid) == "string"){
	  	  if (wid.indexOf("px") > 0){  	  
	  	    wid = wid.substring(0,wid.indexOf("px"));
	  	  }else {
	  	    wid  = wid.length == 0 ? 0 : parseInt(wid);  	   
	  	  }
	  	}
	    x = w -  ((wid ) /2);
	    x += document.body.scrollLeft;
	    if (x < 0){
	      x = 0;
	    }    
	  }
	 
	  if (y < 0){
	    var height = d.clientHeight <= 0 ?d.style.height : d.clientHeight;
	  	if (typeof(height) == "string" && height.indexOf("px") > 0){
	  	if (height.indexOf("px") > 0){  	  
	  	    height = height.substring(0,height.indexOf("px"));
	  	  }else {
	  	    height  = height.length == 0 ? 0 : parseInt(height);  	   
	  	  }  	 
	  	}
	    y = h -  (height /2);
	    y += document.body.scrollTop;
	    if (y < 0){
	      y = 0;
	    }
	  }
	
	  d.style.position = "absolute";
	  d.style.left="" + x;
	  d.style.top="" + y;
	  
	
	  if (d.style.display == "none"){
	    d.style.display = "";
	  }else {
	    d.style.visibility = "";
	  }
  }
}

// use -1 for get the middle of x or y
function showHideLayerInMiddle2(id,x,y){
  var d = document.getElementById(id);
  if(d) {
	  if (d.style.display == ""){
	    d.style.display = "none";
	    return;
	  }
	  var w = document.body.clientWidth/2;
	  var h = document.body.clientHeight/2;
	
	  if (x < 0){
	  	var wid = d.clientWidth <= 0 ?d.style.width : d.clientWidth;
	  	if (typeof(wid) == "string" && wid.indexOf("px") > 0){  	  
	  	  wid = wid.substring(0,wid.indexOf("px"));
	  	}
	  	
	    x = w -  ((wid ) /2);
	    x += document.body.scrollLeft;
	    if (x < 0){
	      x = 0;
	    }
	  }
	  
	  if (y < 0){
	    var height = d.clientHeight <= 0 ?d.style.height : d.clientHeight;
	  	if (typeof(height) == "string" && height.indexOf("px") > 0){
	  	  height = height.substring(0,height.indexOf("px"));
	  	}
	    y = h -  (height /2);
	    y += document.body.scrollTop;
	    if (y < 0){
	      y = 0;
	    }
	  }
	
	  d.style.position = "absolute";
	  d.style.left="" + x;
	  d.style.top="" + y;
	  
	  if (d.style.display == "none"){
	    d.style.display = "";
	  }else {
	    d.style.visibility = "";
	  }
  }
}

function showHideElement(elementId,textElementId,showText,hideText){
	var e = document.getElementById(elementId);
	var t = document.getElementById(textElementId);
	if (e){
		if (e.style.display == ""){
			e.style.display = "none";
			if (t){
				t.innerHTML = showText ? showText : "show";
			}
		}else{
			e.style.display = "";
			if (t){
				t.innerHTML = hideText ? hideText : "hide";
			}
		}
	}
}




function showLayerInMiddle(id,x,y){
  var origY = y;
  var d = document.getElementById(id);
  if(d) {
	  var w = document.body.clientWidth/2;
	  var h = document.body.clientHeight/2;
	  if (x < 0){
	    x = w -  (d.clientWidth /2);
	    if (x < 0){
	      x = 0;
	    }
	  }
	  
	  if (y < 0){
	    y = h -  (d.clientHeight /2);
	    if (y < 0){
	      y = 0;
	    }
	  }
	  if(document.body && origY == -1) {
		y += document.body.scrollTop;
	  }

	  d.style.position = "absolute";
	  d.style.left="" + x;
	  d.style.top="" + y;
	  
	  if (d.style.display == "none"){
	    d.style.display = "";
	  }else {
	    d.style.visibility = "";
	  }
  }
}

// use this method to show or hide menu by the target component id and the menu name (string)
function showMenuPopupById(compId,menuName){ 
  var comp = document.getElementById(compId);
  if (compId){
    showMenuPopup(comp,menuName);
  }
}


//use this method to show or hide menu by the target component and the menu name (string).
//The document which use it must include the jsdomenu.js
function showMenuPopup(comp,menuName,id,extdata){  
   var exists;
   eval('exists = typeof ' + menuName);
   if ( exists == 'undefined' ){
     return;
   }

  var m = eval(menuName);
  if (!m){
    return;
  }
  if (m.isShow()){
    hideVisibleMenus();
  }else {
    var x = findPosX(comp);
    var menuWidth = 0;
    if(m.menuObj.style.width && m.menuObj.style.width.length > 2) {
    	menuWidth = parseInt(m.menuObj.style.width.substring(0, m.menuObj.style.width.length - 2));
    }
    if((x + menuWidth) > document.body.clientWidth) {
    	x = document.body.clientWidth - menuWidth - 10;
    }
    if(x < 0) {
    	x = 0;
    }
    var y = findPosY(comp) + comp.offsetHeight;
    m.moveTo(x,y);
    if (menuName == "logMenu"){
    	var addCollectionIndex = -1;
    	for (i=0; i<logMenu.menuObj.childNodes.length; i++){
	    	if(logMenu.menuObj.childNodes[i].childNodes[0].data == "Add Collection"){
	    		addCollectionIndex = i;
	    		break;
	    	}
    	} 
    	if (addCollectionIndex != -1){
	    	if (extdata == "noCollection"){
	    		logMenu.menuObj.childNodes[addCollectionIndex].style.display = "none";
	    	}else{
	    		logMenu.menuObj.childNodes[addCollectionIndex].style.display = "";
	    	}
    	}
    }else if(menuName == "snapshotMenu"){ 
    		//hide copy to clipboard enteries case no flash in firefox 
    		if((navigator.appName == 'Netscape') && !isFlashInstalledInBrowser()){
 		    	for (i=0; i<snapshotMenu.menuObj.childNodes.length; i++){
 		    		var data = snapshotMenu.menuObj.childNodes[i].childNodes[0].data;
			    	if(data == "Copy to Clipboard" || data == "Copy snapshot link"){
   		    		snapshotMenu.menuObj.childNodes[i].style.display = "none";
			    	}else{
			    		snapshotMenu.menuObj.childNodes[i].style.display = "";
			    	}
		    	}
    		}
    }
    setTimeout(menuName + ".show()",20);
  }
}

function setClassName(comp,className){
 comp.itemClass = className;
 comp.className = className;
}

function selectChilds(node,preffix){
	//uncheck case
	if (!node.checked){
		for (var i = 0; true; i++) {
			var n = document.getElementById(node.id + "_" + i);
			if(n == null){
				break;
			}
      n.checked = false;
      var c = document.getElementById(n.id + "_0");
      if(c != null){
      	c.checked = false;
      	selectChilds(n,node.id);
      }
  	}
  	var p = document.getElementById(preffix);
  	if(p == null){
  		return;
  	}
  	//checkUmarkForNode(p);
  	return;
  }
      
	//for check is true parent
	var p = document.getElementById(preffix);
	if(p != null){
		//p.checked = true;
		//markParentsToRoot(p);
	}
	//and childrens
	for (var i = 0; true; i++) {
		var n = document.getElementById(node.id + "_" + i);
		if(n == null){
			return;
		}
		n.checked = true;
		var c = document.getElementById(n.id + "_0");
		if(c != null){
			c.checked = true;
			selectChilds(n,node.id);
		}
	}
}

function checkUmarkForNode(node){
	if(node == null){
		return;
	}
	for (var i = 0; true; i++) {
		var c = document.getElementById(node.id + "_" + i);
		if(c == null){
			break;
		}
		if(c.checked == true){
			return;
		}
	}
	node.checked = false;
	var id = node.id;
	id = id.substring(0,id.lastIndexOf("_"));
	var n = document.getElementById(id);
	checkUmarkForNode(n); 
}
    
function markParentsToRoot(node){
	if(node == null){
		return;
	}
	var id = node.id;
	if(id == null){
		return;
	}
	id = id.substring(0,id.lastIndexOf("_"));
	var c = document.getElementById(id);
	if(c == null){
		return;
	}
	c.checked = true;
	markParentsToRoot(c);
}

function refreshMenus(nodeId,treeId,baseDir){
    var frm = getManagemtnFrame();
    if(frm!=null && frm.refreshMenu){
      frm.refreshMenu(nodeId,treeId,baseDir);
    }
}

function markItem(nodeId,treeId){
    var frm = getManagemtnFrame();
    if(frm!=null && frm.refreshMenu){
      frm.markItem(nodeId,treeId);
    }
}

function getManagemtnFrame(){
  var tmp = this;
  while(tmp && tmp != null){
    if (tmp.frames['treeframe']!=null){      
      return tmp.frames['treeframe'];
    }else {
      if (tmp == top){
        break;
      }
      tmp = tmp.parent;
    }
  }
  return null;
}

function getMainFrame(){
  var tmp = this;
  while(tmp && tmp != null){
    if (tmp.frames['main']!=null){      
      return tmp.frames['main'];
    }else {
      if (tmp == top){
        break;
      }
      tmp = tmp.parent;
    }
  }
  return null;
}

function setManageCustomSlides(id,name,url){
  var tmp = getManagemtnFrame();
  if (tmp != null && tmp.setCustom){
    tmp.setCustom(id,name,url);
  }
}


function hideManageCustomSlides(){
  var tmp = getManagemtnFrame();
  if (tmp != null && tmp.hideCustom){
    tmp.hideCustom();
  }
}

function showSlide(id,show){
  var tmp = getManagemtnFrame();
  if (tmp != null && tmp.showSlide){
    tmp.showSlide(id,show);
  }
}

function getAllFrames(onlyWithNames){
  var tmp = this;
  while(tmp){
    if (tmp.frames['main']!=null){      
      break;
    }else {
      tmp = tmp.parent;
    }
  }
  var frms = new Array();
  if (tmp){
    addFrames(tmp,frms,onlyWithNames);
  }
  return frms;
}

function getFrameByName(name){
  var tmp = this;
  while(tmp){
    if (tmp.frames[name]!=null){      
      break;
    }else {
      tmp = tmp.parent;
    }
  }
  
   if (tmp){
    return getFramebyName0(tmp,name);
  }
}

function getFramebyName0(frm,name){
  if(frm && frm.name == name){
    return frm;
  }
  
  for(var i = 0; i < frm.frames.length;i++){
    var result = getFramebyName0(frm.frames[i],name);
    if (result){
      return result;
    }
  }
}
  
  function GetXmlHttpObject()
{
var xmlHttp=null;
try
  {
  // Firefox, Opera 8.0+, Safari
  xmlHttp=new XMLHttpRequest();
  }
catch (e)
  {
  // Internet Explorer
  try
    {
    xmlHttp=new ActiveXObject("Msxml2.XMLHTTP");
    }
  catch (e)
    {
    xmlHttp=new ActiveXObject("Microsoft.XMLHTTP");
    }
  }
return xmlHttp;
}

function abortAjaxCalls(currentAjaxRequests) {
	if(typeof currentAjaxRequests == "object") {
		for(ajaxRequest in currentAjaxRequests) {
			currentAjaxRequests[ajaxRequest].abort();
			currentAjaxRequests[ajaxRequest] = null;
		}
		currentAjaxRequests = new Array();
	}
}

function sendAjaxRequest(page,resultFunc,method,parameters,requestsArray){
  sendAjaxRequest0(page,resultFunc,method,parameters,requestsArray,true,"UTF-8");
}


function sendAjaxRequest0(page,resultFunc,method,parameters,requestsArray,async,charset){
	if(!charset) {
		charset = "UTF-8";
	}
 var req = GetXmlHttpObject();
  if (!req) return;
  var m = method;
  if (!m){
    m = "GET";
  }
 
    req.onreadystatechange = function(){
      if (req.readyState == 4) {
        if (req.status == 200) { 
           if (resultFunc){          
             resultFunc(req);
             req = null;
           }  			              
   		  } else {
   			  if(req.status > 400 && req.status < 600) {
          	alert('There was a problem with the request. - ' + req.status);
          }
        }
      }
    };
   
  
  if (m == "GET" || m == "get"){
    var index = page.indexOf("?"); 
    var timestampParam = "";
    if (index == -1){
      timestampParam += "?";
    }else if (index < (page.length - 2)){
      timestampParam += "&";
    }
    timestampParam += "ajaxTimestamp=" + new Date().getTime();
    page += timestampParam;
  }
  req.open(m, page, async);
  if (m == "POST"){
    if (!parameters){
      parameters = "ajaxTimestamp=" + new Date().getTime();
    }else {
      if (parameters != ""){
        parameters += "&";
      }
      parameters += "ajaxTimestamp=" + new Date().getTime()
    }
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=' + charset);
    req.setRequestHeader("Content-length", parameters.length);
    req.setRequestHeader("Connection", "close");
    req.send(parameters);
  }else {
    req.send(null);
  }
  if (!async){
    if (req.readyState == 4) {
      if (req.status == 200) { 
         if (resultFunc){          
           resultFunc(req);
           req = null;
         }  			              
   		} else {
   			if(req.status > 400 && req.status < 600) {
        	alert('There was a problem with the request. - ' + req.status);
        }
      }
    }
  }
  
  if(requestsArray) {
	  requestsArray[requestsArray.length] = req;
	 }
}



function sendAjaxFormRequest(page,formElem,resultFunc){
  sendAjaxRequest(page,resultFunc,"POST",getFormElementsQueryString(formElem));
}

function sendAjaxPOSTRequest(page,parameters,resultFunc){
  sendAjaxRequest(page,resultFunc,"POST",parameters);
}

function getFormElementsQueryString(formElem,prefix) {
	var url = "";
	var element;
	
	if(formElem && formElem.elements) {
		for(var i = 0; i < formElem.elements.length; i++) {
			element = formElem.elements[i];		
			if (!prefix || (element.name && element.name.indexOf(prefix) != -1)){
				if(element.name && element.name != ''){
					if (element.multiple && element.options){
					  for (var j = 0; j < element.options.length;j++){			  
					    if (element.options[j].selected){			      
					      url += "&";
						    url += element.name;
						    url += "=";
						    url += encode(element.options[j].value);
					    }
					    
					  }
					}else if (element.value) {
					  if(element.type == "checkbox" || element.type == "radio") {
						  if(element.checked == true) {
							  url += "&";
							  url += element.name;
							  url += "=";
							  url += element.value;
						  }			
					  }else {
					  	url += "&";
						  url += element.name;
						  url += "=";					  
						  url += encode(element.value);					  		  
					  }
					}else if (element.type && (element.type == "text" || element.type == "textarea" || element.type == "hidden"  || element.type == "password")){
					    url += "&";
						  url += element.name;
						  url += "=";				  	
					}
				}
			}
		}
	}
	return url;
}


function addFrames(curr,frms,onlyWithNames){
  if (!onlyWithNames || (curr.name && curr.name != "")){
    frms[frms.length] = curr;
  }
  
  for(var i = 0; i < curr.frames.length;i++){
    addFrames(curr.frames[i],frms,onlyWithNames);
  }
}


function showHideManagement(){
  if (parent && parent.document){  
    var td = parent.document.getElementById("managementTD");
    if (td != null){
      if (td.style.display == ""){
        td.style.display = "none";
        return false;
      }else {
        td.style.display = "";
      }
    }
  }
  return true;
}

function isManagementVisible(){
  if (parent && parent.document){  
    var td = parent.document.getElementById("managementTD");
    if (td != null){
      if (td.style.display == ""){
        return true;
      }
    }
  }
  return false;
}

function doBackgroundAction(url){
  var req;
  if (typeof XMLHttpRequest != "undefined") {
       req = new XMLHttpRequest();
   } else if (window.ActiveXObject) {
       req = new ActiveXObject("Microsoft.XMLHTTP");
   }
   req.open("GET", url, true);
   req.send(null);
}

function isNumeric(sText)
{   
    if (!sText || sText.length == 0){
      return;
    }
   var ValidChars = "0123456789";
   var IsNumber=true;
   var Char;

 
   for (var i = 0; i < sText.length && IsNumber == true; i++) 
      { 
      Char = sText.charAt(i); 
      if (ValidChars.indexOf(Char) == -1) 
         {
         IsNumber = false;
         break;
      }
   }   		
   if (!IsNumber){
     alert("Invalid number " + sText);
     return false;
   }
   return true;
   
}


function isStringValide(sText,InvalideChars)
{   
    if (!sText || sText.length == 0){
      return;
    }
   if(!InvalideChars || InvalideChars.length == 0){
			InvalidChars = "&^%$)(";   
   }
   var IsValide=true;
   var Char;

 
   for (var i = 0; i < sText.length && IsValide == true; i++) 
      { 
      Char = sText.charAt(i); 
      if (InvalidChars.indexOf(Char) > -1) 
         {
         IsValide = false;
         break;
      }
   }   		
   if (!IsValide){
     return false;
   }
   return true;   
}


function getWindowSize(){
	var winW = 1280, winH = 1024;
	if (parseInt(navigator.appVersion)>3) {
		if (navigator.appName=="Netscape") {
			winW = window.innerWidth;
			winH = window.innerHeight;
		}
		if (navigator.appName.indexOf("Microsoft")!=-1) {
			winW = document.body.offsetWidth;
			winH = document.body.offsetHeight;
		}
	}
	var arr = new Array();
	arr[0] = winW;
	arr[1] = winH;
	return arr;
}

function getLogViewFrm(){
	  var frm = getFrameByName("main");
    if (frm){
      frm = getFramebyName0(frm,"logRecordsView");
      if (frm){
        frm = frm.parent;
      }
    }
    return frm;
	}

function encode(uri){
  var result = encodeURI(uri);
  if (result){
    result = result.replace(/\+/g, "%2B") ;
    result = result.replace(/\&/g, "%26") ;
    result = result.replace(/\#/g, "%23") ;
  }
  return result;
}

function addBaseDirectoryToUrl() {
	return navigator.appName.indexOf("Microsoft")!=-1 || isFirefoxHighVersion();
}

function isFirefoxHighVersion() {
	var isFirefoxHighVersion = false;
	var userAgent = navigator.userAgent;
	var firefoxUserAgentPattern = /Firefox\/(.*)/;
	var matches = userAgent.match(firefoxUserAgentPattern);
	if(matches.length > 1) {
		var firefoxVersion = matches[1];
		var numberPattern = /\d+/;
		var versionNumbers = new Array();
		var index = 0;
		var arr = numberPattern.exec(firefoxVersion);
		while(arr && arr.length > 0 && firefoxVersion.length > 0) {
			versionNumbers[index++] = arr[0];
			if(arr[0].length + 1 < firefoxVersion.length) {
				firefoxVersion = firefoxVersion.substring(arr[0].length + 1);
			}else {
				firefoxVersion = firefoxVersion.substring(arr[0].length);
			}
			arr = numberPattern.exec(firefoxVersion);
		}
		
		var firefoxVersionLimit = [2, 0, 0, 12];
		var count = Math.min(versionNumbers.length, firefoxVersionLimit.length);
		for(var i = 0; i < count; i++) {
			if(versionNumbers[i] > firefoxVersionLimit[i]) {
				isFirefoxHighVersion = true;
				break;
			}else if(versionNumbers[i] < firefoxVersionLimit[i]) {
				isFirefoxHighVersion = false;
				break;
			}
		}
	}
	
	return isFirefoxHighVersion;
}

function getFirefoxVersion() {
 	//test for Firefox/x.x or Firefox x.x (ignoring remaining digits);
 	if (/Firefox[\/\s](\d+\.\d+)/.test(navigator.userAgent)){
		var ffversion = new Number(RegExp.$1) // capture x.x portion and store as a number
		return ffversion;
	}else {
		return -1;
	}
}

function getIEVersion() {
 	//test for MSIE/x.x or MSIE x.x (ignoring remaining digits);
 	if (/MSIE[\/\s](\d+\.\d+)/.test(navigator.userAgent)){
		var ieversion = new Number(RegExp.$1) // capture x.x portion and store as a number
		return ieversion;
	}else {
		return -1;
	}
}

function getPosition(e) {
    e = e || window.event;
    var cursor = {x:0, y:0};
    if (e.pageX || e.pageY) {
        cursor.x = e.pageX;
        cursor.y = e.pageY;
    } 
    else {
        var de = document.documentElement;
        var b = document.body;
        cursor.x = e.clientX + 
            (de.scrollLeft || b.scrollLeft) - (de.clientLeft || 0);
        cursor.y = e.clientY + 
            (de.scrollTop || b.scrollTop) - (de.clientTop || 0);
    }
    return cursor;
}

function isValidPath(path) {
 	var agt=navigator.userAgent.toLowerCase();
	var is_win   = ( (agt.indexOf("win")!=-1) || (agt.indexOf("16bit")!=-1) );
	var regx_dir = /^[a-zA-Z]\:+\\/;
	if(path.search(regx_dir)== 0 || (!is_win && path.indexOf("/") == 0) || path.indexOf("\\") == 0){
		return true;
	}else {
		return false;
	}
 }
 
 function setSessionParam(baseDir,key,value){
  var url = baseDir + " common/backgroundActions.jsp?" + key + "=" + value;
  doBackgroundAction(url);
}

function setUserProperty(baseDir,key,value){
  var url = baseDir + " common/userPropActions.jsp?propKey=" + key + "&propValue=" + value;
  doBackgroundAction(url);
}

function showGeneralAdminDiv(suffix,x,y) {
	var id = "adminGeneralDiv" + suffix;
	var divElem = document.getElementById(id);
	id = "adminGeneralDivFrame" + suffix;
	var divFrameElem = document.getElementById(id);
	if(divElem && divFrameElem){
		if (!x) x = -1;
		if (!y) y = -1;
		showHideLayerInMiddle(divElem.id,x,y,true);
		showHideLayerInMiddle(divFrameElem.id,x,y,true);
	}
}

function showHideGeneralAdminDiv(suffix) {
	var id = "adminGeneralDiv" + suffix;
	var divElem = document.getElementById(id);
	id = "adminGeneralDivFrame" + suffix;
	var divFrameElem = document.getElementById(id);
	if(divElem && divFrameElem){
			if(divElem.style.display == "none"){
			   showHideLayerInMiddle(divElem.id,-1,-1,true);
				 showHideLayerInMiddle(divFrameElem.id,-1,-1,true);
			}else{
				divElem.style.display = "none";
				divFrameElem.style.display = "none";			
			}
	}
}

function hideGeneralAdminDiv(suffix) {
	var id = "adminGeneralDiv" + suffix;
	var divElem = document.getElementById(id);
	id = "adminGeneralDivFrame" + suffix;
	var divFrameElem = document.getElementById(id);
	if(divElem && divFrameElem){			
		divElem.style.display = "none";
		divFrameElem.style.display = "none";			
	}
}

function updateGeneralAdminDiv(suffix,innerHtmlResult){
	var id = "adminGeneralIncludeTD" + suffix;
	var divElem = document.getElementById(id);
	divElem.innerHTML = innerHtmlResult;
}

function hideAllGeneralAdminDiv(exclude) {
	var divArr = document.getElementsByTagName("div");
	for (var i=0; i<divArr.length; i++){
		if (divArr[i].id && divArr[i].id.indexOf("adminGeneralDiv") == 0 && (!exclude || divArr[i].id != "adminGeneralDiv"+exclude)){
			var suffix = divArr[i].id.substring(15);
			//alert(suffix);
			hideGeneralAdminDiv(suffix);
		}
	}
}

function trim(stringToTrim) {
	return stringToTrim.replace(/^\s+|\s+$/g,"");
}

function ltrim(stringToTrim) {
	return stringToTrim.replace(/^\s+/,"");
}

function rtrim(stringToTrim) {
	return stringToTrim.replace(/\s+$/,"");
}

String.prototype.startsWith = function(str) {
	return (this.match("^"+str)==str);
}

String.prototype.endsWith = function(str) {
	return (this.match(str+"$") == str);
}

function resetBgColor(elem,cls){
	if (elem){
		if (cls && cls != ""){
			elem.className = cls;
		}else{
			elem.className = 'TEXTBOX';
		}
	}
}

function getDocumentWidth(){
var myWidth = 0;
  if( typeof( window.innerWidth ) == 'number' ) {
    //Non-IE
    myWidth = window.innerWidth;
  } else if( document.documentElement && ( document.documentElement.clientWidth) ) {
    //IE 6+ in 'standards compliant mode'
    myWidth = document.documentElement.clientWidth;
 
  } else if( document.body && ( document.body.clientWidth) ) {
    //IE 4 compatible
    myWidth = document.body.clientWidth;
  }
  return myWidth;
}

function handleInnerHTMLJQuery(id, innerHtml) {
	var jqueryelement = $('#' + id);
	if(jqueryelement) {
		jqueryelement.empty();
		jqueryelement.html(innerHtml);
	}else {
		alert(id + " not found");
	}
}

function handleInnerHTML(element, html, type) {
	if(type == 0) {
		deleteChildren(element);
		element.innerHTML = html;
	}else if(type == 1) {
		replaceHTML(element, html);
	}
}

function deleteChildren(node) {
	if(node){
		for(var x = node.childNodes.length - 1; x >= 0; x--){
			var childNode = node.childNodes[x];
			if(childNode.hasChildNodes()){
				deleteChildren(childNode);
			}
			removeNodeEventListeners(childNode);
			node.removeChild(childNode);
			if(childNode.outerHTML){
				childNode.outerHTML = '';
			}
			childNode=null;   
		}
		node=null;
	}
}

function removeNodeEventListeners(node) {
	try {
		removeNodeEventListener(node, "click");
		removeNodeEventListener(node, "mouseover");
		removeNodeEventListener(node, "mouseout");
		removeNodeEventListener(node, "change");
	}catch(err) {
	}
}

function removeNodeEventListener(node, event) {
	/*
	if(childNode.onclick) {
		if(document.all) {
			childNode.detachEvent("onclick", childNode.onclick);
		}else {
			childNode.removeEventListener("click", childNode.onclick, false);
		}
	}
	*/
	if(eval("node.on" + event)) {
		if(document.all) {
			node.detachEvent("on" + event, eval("node.on" + event));
		}else {
			node.removeEventListener(event, eval("node.on" + event), false);
		}
	}
}

function replaceHTML(el, html) {
	var oldEl = (typeof el === "string" ? document.getElementById(el) : el);
	var newEl = document.createElement(oldEl.nodeName);
	// Preserve the element's id, class and style (other properties are lost)
	newEl.id = oldEl.id;
	newEl.className = oldEl.className;
	//newEl.style.display = oldEl.style.display;
	newEl.style.cssText = oldEl.style.cssText;
	// Replace the old with the new
	newEl.innerHTML = html;
	oldEl.parentNode.replaceChild(newEl, oldEl);
	/* Since we just removed the old element from the DOM, return a reference
	to the new element, which can be used to restore variable references. */
	return newEl;
}

function getUserSelection(){
  var userSelection;
  var selectionText = "";
	if (window.getSelection) {
  	userSelection = window.getSelection();
  	selectionText = userSelection.getRangeAt(0);
	}else if (document.selection) { // should come last; Opera!
  	userSelection = document.selection.createRange();
  	selectionText = userSelection.text;
	}
	return selectionText;
}

function disableButton(buttonId,cls){
	var btn = document.getElementById(buttonId);
	if (btn){
		if (cls){
			btn.className = cls;
		}else{
			btn.className = "BUTTON_DISABLED";
		}
	}
}

function enableButton(buttonId,cls){
	var btn = document.getElementById(buttonId);
	if (btn){
		if (cls){
			btn.className = cls;
		}else{
			btn.className = "BUTTON";
		}
	}
}

function isFlashInstalledInBrowser(){
	if (navigator.plugins && navigator.plugins.length) {
	    for (x = 0; x <navigator.plugins.length; x++) {
	        if (navigator.plugins[x].name.indexOf('Shockwave Flash') != -1) {
						return true;
	        }
	
	    }
	}
	return false;
}

function getXMLElementValue(element) {
	var elementValue = "";
	if(element.childNodes.length > 0) {
		if(document.all || element.childNodes.length == 1) {
			elementValue = element.childNodes[0].nodeValue;
		}else {
			elementValue = element.childNodes[1].nodeValue;
		}
	}
	return elementValue;
}

function hideElementIfClickedOutside(e, id, ignoreIds, hideIds) {
	var target = (e && e.target) || (event && event.srcElement);
	var obj = document.getElementById(id);
	if(obj) {
		if(checkParentClick(target, id, ignoreIds)) {
			obj.style.display = "none";
			if(hideIds) {
				for(var i = 0; i < hideIds.length; i++) {
					var elementToHide = document.getElementById(hideIds[i]);
					if(elementToHide) {
						elementToHide.style.display = "none";
					}
				}
				
			}
		}
	}
}

function checkParentClick(t, id, ignoreIds) {
	if(t == document.getElementById(id)) {
		return false
	}
	if(ignoreIds) {
		var i = 0;
		for(i; i < ignoreIds.length; i++) {
			if(t.id && t.id.indexOf(ignoreIds[i]) != -1) {
				return false;
			}else if(t.className && t.className.indexOf(ignoreIds[i]) != -1) {
				return false;
			}
		}
	}
	if(t.parentNode) {
		return checkParentClick(t.parentNode, id, ignoreIds);
	}else {
		return true;
	}
}

function showTooltip(message) {
	 Tip(message, BALLOON, true, ABOVE, true, OFFSETX, -17, PADDING, 8);
}

function hideTooltip() {
	UnTip();
}

function getWidthAndHeight() {	
	var winW = 1280, winH = 1024;
	if (parseInt(navigator.appVersion)>3) {
		if (navigator.appName=="Netscape") {
			winW = parent.window.innerWidth;
			winH = parent.window.innerHeight;
		}
		if (navigator.appName.indexOf("Microsoft")!=-1) {
			winW = parent.document.body.offsetWidth;
			winH = parent.document.body.offsetHeight;
		}
	}
	var size = new Array();
	size[0] = winW;
	size[1] = winH;
	return size;
}

function isChrome() {
	return navigator.userAgent.toLowerCase().indexOf('chrome') > -1;
}

function updateAjaxResponseScript(responseText) {
    var search = responseText;
    var script;
    while(script = search.match(/(<script\s*>\s*(<!--)?)/i)) {
      search = search.substr(search.indexOf(RegExp.$1) + RegExp.$1.length);
      
      if (!(endscript = search.match(/((-->)?\s*<\/script>)/))) break;
      
      block = search.substr(0, search.indexOf(RegExp.$1));
      search = search.substring(block.length + RegExp.$1.length);
      
      var oScript = document.createElement('script');
      oScript.text = block;
      document.getElementsByTagName("head").item(0).appendChild(oScript);
    }
}

function getCaretPosition (element) {
	var caretPosition = 0;	// IE Support
	if (document.selection) {
		element.focus ();
		var Sel = document.selection.createRange ();
		Sel.moveStart ('character', -element.value.length);
		caretPosition = Sel.text.length;
	}
	// Firefox support
	else if (element.selectionStart || element.selectionStart == '0') {
		caretPosition = element.selectionStart;
	}
	return (caretPosition	);
}

function setCaretPosition (element, position) {
   // IE Support
   if (document.selection) { 
     // Set focus on the element
	 element.focus ();
     // Create empty selection range
     var oSel = document.selection.createRange ();
     // Move selection start and end to 0 position
     oSel.moveStart ('character', -element.value.length);
     // Move selection start and end to desired position
     oSel.moveStart ('character', position);
     oSel.moveEnd ('character', 0);
     oSel.select ();
   }
   // Firefox support
   else if (element.selectionStart || element.selectionStart == '0') {
	   element.selectionStart = position;
	   element.selectionEnd = position;
	   element.focus ();
   }
}

function doLogJsError(baseDirectory, message) {
	message = "An unexpected javascript error was detected: " + message;
	var postParams = "message=" + encodeURIComponent(message);
	sendAjaxRequest(baseDirectory + "common/jsErrorLogger.jsp", function(req){
	}, 'POST', postParams);
}

function handleAutoCompleteSelect(suggestion, data, element) {
	if(typeof data != "undefined") {
		element.val(data);
	}
}