
var ACCOUNT_TYPE = '';
var ACCOUNTS_LIST_NAME = 'AccountsList';
var ACCOUNTS_LIST_NAME_TO_UPDATE = null;
var ACCOUNTS_PREFIX = '';
var ACCOUNT_TYPE_SELECT_NAME = 'LogType';

function openNewAccDiv(divId,accountType,accountId,op,accountsListName,base_directory,accountsListNameToUpdate,divHeight){
	ACCOUNT_TYPE = accountType;
	ACCOUNTS_LIST_NAME = accountsListName;
	if(accountsListNameToUpdate && accountsListNameToUpdate != '') {
		ACCOUNTS_LIST_NAME_TO_UPDATE = accountsListNameToUpdate;
	}else {
		ACCOUNTS_LIST_NAME_TO_UPDATE = null;
	}
	//alert("divId = " + divId + ", accountType = " + accountType + ", accountId = " + accountId);
	if(!divHeight) {
		divHeight = "";
	}
	var page = BASE_DIRECTORY + "tools/addresses/addAccountDiv.jsp?";
	var params = "tstmp=" + date.getTime() + "&ACC_TYPE=" + accountType + "&ACC_DIV=" + divId + "&ACC_ID=" + accountId + "&OP=" + op + "&divHeight=" + divHeight;
	if(base_directory && base_directory != '') {
		params += "&base_directory=" + base_directory;
	}
	sendAjaxRequest(page,function(req){
		var result = req.responseText;	
		result = result.replace(/^\s+|\s+$/g, '') ;
		if (!result){
			alert("Could not open add account window!");
			return;
		}   
		var accDivElem = document.getElementById("addAccDiv");
		if (!accDivElem){
			accDivElem = document.getElementById(divId);
		}
		if(accDivElem){
		  accDivElem.style.display = "";
			accDivElem.innerHTML = result;
		}
		showGeneralAdminDiv("addAccount");
	},'POST',params);
}

function updateAccountsList(accountsPrefix,accountTypeSelectName, baseDirectory){
		if(accountsPrefix) {
			ACCOUNTS_PREFIX = accountsPrefix;
		}else {
			ACCOUNTS_PREFIX = '';
		}
		if(accountTypeSelectName) {
			ACCOUNT_TYPE_SELECT_NAME = accountTypeSelectName;
		}else {
			ACCOUNT_TYPE_SELECT_NAME = '';
		}
	  
	  var params = getUpdateAccountsListParameters();
		var page = baseDirectory + "common/accountsListCombo.jsp?";
		sendAjaxRequest(page,function(req){
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if (!result){
				alert("Could not get accounts list!");
				return;
			}   
			var accListElem = document.getElementById(ACCOUNTS_PREFIX+"accountsListDiv");
			if(accListElem){
				if(result == "none"){
					result = "";
				}
				accListElem.innerHTML = result;
			}				
			showHideLocationsPath();
			openAccountDivIfNeeded(ACCOUNT_TYPE_SELECT_NAME, ACCOUNTS_PREFIX+"AccountsList", baseDirectory, accountsPrefix);
		},'POST',params);
}

function getUpdateAccountsListParameters(){
	var param = "tstmp=" + date.getTime() + "&PREFIX=" + ACCOUNTS_PREFIX;
	param += "&ACC_TYPE=";
	param +=  eval("document.access." + ACCOUNT_TYPE_SELECT_NAME).value;
	param += "&IS_ACC_CHANGED=" + true;
	return param;
}

function clearAccountsList(accountsPrefix) {
	var accountsElem = document.getElementById(accountsPrefix+"AccountsList");
	if(accountsElem){
		accountsElem.options.length = 0;
	}
}

function changeAccTypeFilter(){
	var accType = document.account.accountsFilter.value;
	var url = BASE_DIRECTORY + "tools/addresses/addAccountDiv.jsp?";
	var params = "tstmp=" + date.getTime() + "&ACC_TYPE=" + accType;
	sendAjaxRequest(url,function(req){
		var result = req.responseText;
		if (result){	
			result = result.replace(/^\s+|\s+$/g, '');
		}
		var accDivElem = document.getElementById("addAccDiv");
		if(accDivElem){
			accDivElem.innerHTML = result;
			showGeneralAdminDiv("addAccount");
		}
	}, "POST", params);
}

function cancelAddAccDiv(divId){
	hideAddAccDiv(divId);
}

function hideAddAccDiv(divId){
	if (!divId){
		divId = "addAccDiv";
	}
  var accDivElem = document.getElementById(divId);
  if(accDivElem){
	  accDivElem.style.display = "none";;
  }
  hideGeneralAdminDiv("addAccount");	
	hideGeneralAdminDiv("uploadDriver");	
}

function addNewAcc(action,accountId,verifyBeforeSave){
	updateVerifyAccMsgDiv("Please wait...");
	var page = BASE_DIRECTORY + "tools/addresses/addAccountAction.jsp?";
	var params = getNewAccountParameters(action,verifyBeforeSave);
	sendAjaxRequest(page,function(req){
		var result = req.responseText;	
		result = result.replace(/^\s+|\s+$/g, '') ;
		if(!result){
			alert("Could not save new account!");
			return;			
		}
		var resultArr = result.split("@#");
		if(resultArr && resultArr[0] && resultArr[0] == "ok"){
			var accountType = resultArr[1];							
			var actionType = resultArr[2];		
			if(actionType && actionType == "save"){
					var accName  = resultArr[3];
					var _accId  = resultArr[4];
					if(_accId == "null") {
						_accId = "";
					}
					var op = resultArr[5];
					var verified;
					if(verifyBeforeSave && verifyBeforeSave == "true") {
						verified = resultArr[6];
					}
					if((verified && verified == "true") || (verifyBeforeSave && verifyBeforeSave == "false")) {
						eval("document.access." + ACCOUNTS_LIST_NAME).options[eval("document.access." + ACCOUNTS_LIST_NAME).options.length] = new Option(accName,_accId);
						eval("document.access." + ACCOUNTS_LIST_NAME).selectedIndex = (eval("document.access." + ACCOUNTS_LIST_NAME).options.length - 1);
						
						if(ACCOUNTS_LIST_NAME_TO_UPDATE && ACCOUNTS_LIST_NAME_TO_UPDATE != null) {
							eval("document.access." + ACCOUNTS_LIST_NAME_TO_UPDATE).options[eval("document.access." + ACCOUNTS_LIST_NAME_TO_UPDATE).options.length] = new Option(accName,_accId);
						}
						if(typeof showHideLocationsPath == 'function') {
							showHideLocationsPath();
						}
						hideAddAccDiv();
					}else {
						updateVerifyAccMsgDiv('');
						var msgWriter = new messageWriter("verificationFailedMessage","Account Verification Failed",BASE_DIRECTORY);
						msgWriter.addAction("Save anyway","javascript:hideLayer('verificationFailedMessage');addNewAcc('"+action+"','"+_accId+"','false')");
			    	msgWriter.addAction("Edit account details","javascript:hideLayer('verificationFailedMessage');");  
	    			msgWriter.showMessage("Account verification has failed.<br>What do you wish to do?");
					}
					newAccountAdded();
					return;											
			}else if(actionType && actionType == "verify"){
					var verifyMsg  = resultArr[3];
					updateVerifyAccMsgDiv(verifyMsg);
			}
		}else if(resultArr && resultArr[0] && resultArr[0] == "error"){
			var errorMsg = resultArr[1];
			updateVerifyAccMsgDiv(errorMsg);
			return;
		}
	},'POST',params);
}

function newAccountAdded(){
}

function getNewAccountParameters(actionType, verifyBeforeSave){
	var param = "";
	param += "isEmbeded=true&tstmp=" + date.getTime() + "&ACC_TYPE=" + ACCOUNT_TYPE + "&ACTION_TYPE=" + actionType;
	if(actionType == 'save' && verifyBeforeSave) {
		param += "&verifyBeforeSave=" + verifyBeforeSave;
	}
	param += getFormElementsQueryString(document.account);
	return param;
}


function updateVerifyAccMsgDiv(msg){
	var msgElem = document.getElementById("verifyMsgDiv");
	if(msgElem){
		msgElem.innerHTML = "";
		msgElem.style.display = "";
		msgElem.innerHTML = msg;
	}
}

function updateVerifyUploadMsgDiv(msg){
	var msgElem = document.getElementById("verifyUploadMsgDiv");
	if(msgElem){
		//msgElem.innerHTML = "";
		msgElem.style.display = "";
		//msgElem.innerHTML = msg;
		handleInnerHTML(msgElem, msg, 1);
	}
}

function clearParamDiv(){
	updateVerifyAccMsgDiv("");
	updateVerifyUploadMsgDiv("");
}

//DATABASE ACCOUNT FUNCTION
var prevDriverType;
function changeDriversType(){
	clearParamDiv();
	var driverType = document.account.driversType.value;
	if(driverType.length > 0 && driverType != "other") {
		document.account.Name.value = driverType; 
	}else{
		document.account.Name.value = ""; 	
	}
	var url = BASE_DIRECTORY + "tools/addresses/db/general/accountDbDivAction.jsp?DRIVER_TYPE="+driverType;
	contextreq = GetXmlHttpObject();
	contextreq.open('POST', url, true);
	contextreq.onreadystatechange = changeDriversTypeCallback;
  contextreq.send(null);  		
}

function changeDriversTypeCallback(){
	if (contextreq.readyState == 4) {
			if (contextreq.status == 200) {
				var result = contextreq.responseText;	
				result = result.replace(/^\s+|\s+$/g, '') ;
				if(!result){
					alert("Could not get driver!");
					return;			
				}
				var resultArr = result.split("@#");
				if(resultArr && resultArr[0] && resultArr[0] == "ok"){
						var driverParamElem = document.getElementById("driverParamDiv");
						if(driverParamElem){
							driverParamElem.innerHTML = "";
							driverParamElem.style.display = "";
							var htmlDiv = resultArr[1];
							driverParamElem.innerHTML = htmlDiv;
						}				
				}else	if(resultArr && resultArr[0] && resultArr[0] == "error"){
					updateVerifyAccMsgDiv(resultArr[1]);
				}else{
						var driverParamElem = document.getElementById("driverParamDiv");
						if(driverParamElem){
							driverParamElem.innerHTML = "";
							driverParamElem.style.display = "";
							driverParamElem.innerHTML = result;
						}				
				}		
		}
	}
}
//UPLOAD DRIVER
function showHideUploadDriverLink(){
		showGeneralAdminDiv("uploadDriver");
}

function hideUploadDriver(){
  hideGeneralAdminDiv("uploadDriver");
}

var selectedDriverType= "";


function goUploadDriver(){
		updateVerifyUploadMsgDiv("Uploading...");
		selectedDriverType = document.account.driversType.value;		
		var uploadFormElem = document.getElementById("fileUploadForm");
		var file = uploadFormElem.archivePath.value;
		var path = BASE_DIRECTORY + "tools/addresses/db/uploadDriverAction.jsp?ARCHIVE_PATH=" + file;
  	path = path + "&isEmbedded=true";
	 	uploadFormElem.action = path;
		uploadFormElem.submit();
}


function initUploadForm(){
	var uploadDriverElem = document.getElementById("adminGeneralDivuploadDriver");
	if(uploadDriverElem && uploadDriverElem.style.display == ""){
		if(selectedDriverType == document.account.driversType.value){
			var uploadFormElem = document.getElementById("fileUploadForm");
			var iframe = document.getElementById("uploadTargetIFrame") ;
			var iframeDoc = null;
			if (iframe.contentDocument) {
				iframeDoc = iframe.contentDocument;
			}
			else if (iframe.contentWindow) {
				iframeDoc = iframe.contentWindow.document;
			}
			else if (window.frames[iframe.name]) {
				iframeDoc = window.frames[iframe.name].document;
			}
			if (iframeDoc) {
				var resultElem = iframeDoc.getElementById("uploadResultDivId");
				if(resultElem){
					var result = resultElem.innerHTML;
					result = result.replace(/^\s+|\s+$/g, '') ;
					if(result == "OK"){		
							hideUploadDriver();
							updateVerifyUploadMsgDiv("Finished Uploading");		
							changeDriversType();		
					}else{
						updateVerifyUploadMsgDiv(result);		
					}
				}
			}
		}
	}
}

var hasAddressBookPermissions = true;
function openAccountDivIfNeeded(typeId, accountsElementId, baseDirectory, accountsPrefix) {
	if(hasAddressBookPermissions == true) {
		var accountsElement = document.getElementById(accountsElementId);
		if(accountsElement) {
			var numberOfAccounts = accountsElement.length - 1;
			if(numberOfAccounts == 0) {
				var typeElement = document.getElementById(typeId);
				if(typeElement) {
					var type = typeElement.value;
					if(type == 'auth' || type == 'ssh' || type == 'db' || type == 'ftp' || type == 'http' || type == 'remote') {
						generalOpenNewAccountDiv(baseDirectory,accountsPrefix);
					}
				}
			}
		}
	}
}

function changeAcc(elementId, errorElementId){
	if(clearFormError){ //check if function exist (other js)
		clearFormError(elementId, errorElementId);
	}
	showHideLocationsPath();
}