function showFormError(elementId, errorElementId, errorMessage) {
	highlightBgColor(elementId);
	updateErrorDiv(errorMessage, errorElementId);
}

function updateErrorDiv(msg,id){
	var msgElem = document.getElementById(id);
	if(msgElem){
		msgElem.innerHTML = "";
		msgElem.style.display = "";
		msgElem.innerHTML = msg;
	}
}

function clearFormError(elementId, errorElementId){
	clearBgColor(elementId);
	var errorElement = document.getElementById(errorElementId);
	if(errorElement){
		errorElement.style.display ="none";
		errorElement.innerHTML = "";
	}
}

function highlightBgColor(id) {
	var element = document.getElementById(id);
	if(element) {
		element.className = 'ERROR_MSG_BACKGROUNDCOLOR';
	}
}

function clearBgColor(id){
	var element = document.getElementById(id);
	if(element) {
		element.className = 'TEXTBOX';
	}
}