var contextreq;		
//for ajax timestemp param
var date = new Date();

var previousLocationType = "";

function clearFormErrors() {
	clearFormError(PREFIX + "locationType", PREFIX+"locationTypeErrorMsg");
	clearFormError(PREFIX + "AccountsList", PREFIX+"AccountIdErrorMsg");
	clearFormError(PREFIX + "fullPath_0", PREFIX+"Location0ErrorMsg");
	clearFormError(PREFIX + "fullPath_1", PREFIX+"Location0ErrorMsg");
}

function generalOpenNewAccountDiv(baseDirectory){
	var accType = eval("document.access." + PREFIX + "locationType").value;
	openNewAccDiv('addAccDiv',accType,'','new',PREFIX + 'AccountsList',baseDirectory);
}

function checkWizardParams(wizardType){
	var isOk = true;
	
	if(wizardType == 'application' || wizardType == 'scanner') {
		var locationType = document.getElementById(PREFIX + "locationType");
		if(locationType.value == "" || locationType.value == "none"){
			var errorMessage = "Application location was not selected";
			if(wizardType == 'scanner') {
				errorMessage = "Directory location was not selected";
			}
			showFormError(PREFIX + "locationType", PREFIX+"locationTypeErrorMsg", errorMessage);
			isOk = false;
		}else if(locationType.value == "auth" || locationType.value == "ssh") {
			var accountsList = document.getElementById(PREFIX + "AccountsList");
			if(accountsList.value == "" || accountsList.value == "none"){
				showFormError(PREFIX + "AccountsList", PREFIX+"AccountIdErrorMsg", "Account was not selected");
				isOk = false;
			}
			var locationPath = document.getElementById(PREFIX + "fullPath_0");
			if(locationPath.value == "") {
				var errorMessage = "Application path was not specified"
				if(wizardType == 'scanner') {
					errorMessage = "Directory was not selected";
				}
				showFormError(PREFIX + "fullPath_0", PREFIX+"Location0ErrorMsg", errorMessage);
				isOk = false;
			}
		}else {
			var locationPath = document.getElementById(PREFIX + "fullPath_0");
			if(locationPath.value == "") {
				var errorMessage = "Application path was not specified"
				if(wizardType == 'scanner') {
					errorMessage = "Directory was not selected";
				}
				showFormError(PREFIX + "fullPath_0", PREFIX+"Location0ErrorMsg", errorMessage);
				isOk = false;
			}
		}
	}else if(wizardType == 'configurationFile') {
		var locationType = document.getElementById(PREFIX + "locationType");
		if(locationType.value == "" || locationType.value == "none"){
			showFormError(PREFIX + "locationType", PREFIX+"locationTypeErrorMsg", "Configuration location was not selected");
			isOk = false;
		}else if(locationType.value == "ssh") {
			var accountsList = document.getElementById(PREFIX + "AccountsList");
			if(accountsList.value == "" || accountsList.value == "none"){
				showFormError(PREFIX + "AccountsList", PREFIX+"AccountIdErrorMsg", "Account was not selected");
				isOk = false;
			}
			var locationPath = document.getElementById(PREFIX + "fullPath_0");
			if(locationPath.value == "") {
				showFormError(PREFIX + "fullPath_0", PREFIX+"Location0ErrorMsg", "Configuration file path was not specified");
				isOk = false;
			}
		}else {
			var locationPath = document.getElementById(PREFIX + "fullPath_0");
			if(locationPath.value == "") {
				showFormError(PREFIX + "fullPath_0", PREFIX+"Location0ErrorMsg", "Configuration file path was not specified");
				isOk = false;
			}
		}
	}
	
	return isOk;
}

function checkListParams(){
	var isOk = true;
	
	var selectedIds = document.getElementById("selectedIds");
	if(selectedIds.value == "") {
		showFormError("", "selectedIdsErrorMsg", "No folders and logs were selected");
		isOk = false;
	}
	
	var parentModule = document.getElementById("MODULE_ID");
	if(parentModule.value == "") {
		showFormError("", "parentModuleErrorMsg", "Parent folder was not selected");
		isOk = false;
	}
	
	return isOk;
}

function changeLocationType(accountsPrefix,accountTypeSelectName,baseDirectory){
	clearFormError(PREFIX + "locationType", PREFIX+"locationTypeErrorMsg");
	var locationType = eval("document.access." + PREFIX + "locationType").value;
	var accountsElem = document.getElementById(PREFIX+"accountDiv");
	var locationsDiv = document.getElementById(PREFIX+"locationPathsDiv");
	var advancedSettingsDiv = document.getElementById(PREFIX+"advancedSettingsDiv");
	if(locationType == "none"){
		accountsElem.style.display = "none";
		clearAccountsList(accountsPrefix);
		locationsDiv.style.display = "none";
		if(advancedSettingsDiv) {
			advancedSettingsDiv.style.display = "none";
		}
	}else if(locationType == "local"){		
		accountsElem.style.display = "none";		
		clearAccountsList(accountsPrefix);		
		locationsDiv.style.display = "";
		if(advancedSettingsDiv) {
			advancedSettingsDiv.style.display = "";
		}				
	}else{
		accountsElem.style.display = "";
		if(advancedSettingsDiv) {
			advancedSettingsDiv.style.display = "";
		}
		updateAccountsList(accountsPrefix,accountTypeSelectName,baseDirectory);
	}
	if(previousLocationType == "local") {
		if(locationType == "ssh") {
			clearLocations();
		}
	}else if(previousLocationType == "auth") {
		if(locationType == "ssh") {
			clearLocations();
		}
	}else if(previousLocationType == "ssh") {
		if(locationType == "local" || locationType == "auth") {
			clearLocations();
		}
	}
	if(locationType != "none") {
		previousLocationType = locationType;
	}
}

function validateAccount() {
	var isOk = true;
	var locationType = document.getElementById(PREFIX + "locationType");
	if(locationType.value == "ssh") {
		var accountsList = document.getElementById(PREFIX + "AccountsList");
		if(accountsList.value == "" || accountsList.value == "none"){
			showFormError(PREFIX + "AccountsList", PREFIX+"AccountIdErrorMsg", "Account was not selected");
			isOk = false;
		}
	}
	
	return isOk;
}

function showHideLocationsPath(){
	var locationType = eval("document.access." + PREFIX + "locationType").value;
	var locationsDiv = document.getElementById(PREFIX+"locationPathsDiv");
	if(locationsDiv){
		locationsDiv.style.display = "";
	}
}

//ADVANCE SETTINGS FUNCTIONS
function showAdvanceSettings(settingsName){
	var imgId = PREFIX+"img" + settingsName;
	var tblId = PREFIX+"tbl" + settingsName;
	var imgElem = document.getElementById(imgId);
	var tblElem = document.getElementById(tblId);
	if(imgElem && tblElem){
		if(tblElem.style.display == "none"){
			tblElem.style.display = ""
			imgElem.src = BASE_DIRECTORY + "images/slides/openTabArrow.gif"			
		}else{
			tblElem.style.display = "none"		
			imgElem.src = BASE_DIRECTORY + "images/slides/closeTabArrow.gif"			
		}	
	}
}