<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.DateUtil"%>

<%!
	static final String BASE_DIRECTORY = "../../";
	static final String STATUS_OK = "0";
%>

<%
WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request,response,SearchEnginePermissionConstants.AdministrationPermissions.ADMINISTRATION_PERMISSION,true)){
  return;
}
UserContext userContext = UserEnvironment.getUserContext(request);

boolean isEdit = manager.isHavePermission(userContext,SearchEnginePermissionConstants.AdministrationPermissions.ADMINISTRATION_PERMISSION);

String lastSelectedRow = (String)request.getSession().getAttribute("lastSelectedSavedSearch");
if (lastSelectedRow == null){
	lastSelectedRow = "";
}

String suffix = "savedSearches";

boolean printExtraDataOnError = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("ui.js.printExtraDataOnError", false);

%>

<html>

<head>
<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=UTF-8">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxCalendar/codebase/dhtmlxcalendar.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/dhtmlxCalendar.css" />

<script src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>

<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/jquery/jquery.js"></script>

<script type="text/javascript" src="<%=BASE_DIRECTORY%>search/common/searchFunctions.js"></script>
<script type="text/javascript" src="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxCalendar/codebase/dhtmlxcommon.js"></script>
<script type="text/javascript" src="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxCalendar/codebase/dhtmlxcalendar.js"></script>
<script type="text/javascript" src="<%=BASE_DIRECTORY%>search/common/searchCalendarFunctions.js"></script>
<script type="text/javascript" src="<%=BASE_DIRECTORY%>search/common/savedSearchesFunctions.js"></script>
<script type="text/javascript" src="<%=BASE_DIRECTORY%>search/common/searchTooltips.js"></script>

<jsp:include page="../../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<jsp:include page="../../common/constants.jsp" flush="true"/>											

<%
boolean showMenu = isEdit;
if(showMenu) {
	String menuIds = "runSavedSearch,editSavedSearch,removeSavedSearch";
	String menuTexts = "Run Search,Edit,Delete";
	String menuHrefs = "javascript:runSavedSearch0();,javascript:editSavedSearch0();,javascript:removeSavedSearch0();";
%>
<jsp:include page="../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	<jsp:param name="suffix" value="<%=suffix %>" />
</jsp:include>
<jsp:include page="../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
  <jsp:param name="showMenu" value="<%=showMenu%>" />
  <jsp:param name="menuIds" value="<%=menuIds%>" />
  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	<jsp:param name="suffix" value="<%=suffix %>" />
</jsp:include>
<%
}
%>

<script>
	var BASE_DIRECTORY = "<%=BASE_DIRECTORY%>";  
	var STATUS_OK = "<%=STATUS_OK %>";
	var FIXED_INTERVAL_CUSTOM = "<%=DateUtil.FIXED_INTERVAL_CUSTOM %>"

	var printExtraDataOnError = <%=printExtraDataOnError %>;

	<%
	if(userContext != null && userContext.getUser() != null && userContext.getUser().getUser() != null &&
		 userContext.getUser().getUser().getDisplayName() != null && userContext.getUser().getUser().getDisplayName().length() > 0) {
	%>
	var CURRENT_USER_DISPLAY_NAME = "<%=userContext.getUser().getUser().getDisplayName() %>";
	<%
	}
	%>
	
	function init() {
		loadCalendar();
	}
	
  function goNew(){
	  initSaveSearchDiv('', '', '', '', '', '', '', '', '');
	  hideSavedSearchErrorMessageDiv();
	  showSaveSearchDiv();
  }
  
  
  function doRun(){
    var savedSearchId = getFirstSelectedRow(mygrid<%=suffix %>);
    if (savedSearchId == "") {
     return;
    }
    
    doRun1(savedSearchId);
  }
  
  function doRun1(savedSearchId){
	  var savedSearchName = mygrid<%=suffix %>.getUserData(savedSearchId,"name");
	  parent.document.location.href = BASE_DIRECTORY + "search/view/loadSearchModel.jsp?searchQuery=search." + savedSearchName + "&isSavedSearchActivation=true";
  }
  
  
  function doEdit(){
    var savedSearchId = getFirstSelectedRow(mygrid<%=suffix %>);
    if (savedSearchId == "") {
     return;
    }
    
    doEdit1(savedSearchId);
  }
  
  function doEdit1(savedSearchId){
	  var savedSearchName = mygrid<%=suffix %>.getUserData(savedSearchId,"origName");
	  var savedSearchTerm = mygrid<%=suffix %>.getUserData(savedSearchId,"searchTerm");
	  var savedSearchDescription = mygrid<%=suffix %>.getUserData(savedSearchId,"description");
	  var savedSearchFixedInterval = mygrid<%=suffix %>.getUserData(savedSearchId,"fixedInterval");
	  var savedSearchFixedIntervalStr = mygrid<%=suffix %>.getUserData(savedSearchId,"fixedIntervalStr");
	  var savedSearchSeverity = mygrid<%=suffix %>.getUserData(savedSearchId,"savedSearchSeverity");
	  var savedSearchSeverityType = mygrid<%=suffix %>.getUserData(savedSearchId,"savedSearchSeverityType");
	  var savedSearchVisibility = mygrid<%=suffix %>.getUserData(savedSearchId,"savedSearchVisibility");
		
	  initSaveSearchDiv(savedSearchId, savedSearchName, savedSearchTerm, savedSearchDescription, savedSearchFixedInterval, savedSearchFixedIntervalStr, savedSearchSeverity, savedSearchSeverityType, savedSearchVisibility);
	  hideSavedSearchErrorMessageDiv();
	  showSaveSearchDiv();
  }
  
  function doDelete(){
	  var savedSearchId = getFirstSelectedRow(mygrid<%=suffix %>);
	    if (savedSearchId == "") {
	     return;
	    }
	    
    doDelete1(savedSearchId);
  }
  
  function doDelete1(savedSearchId){
    var name = mygrid<%=suffix %>.cells(savedSearchId,0).getValue();
   	var row = savedSearchId;
    var msgWriter = new messageWriter("mygrid<%=suffix %>Message","Saved Search Delete Action","<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid<%=suffix %>"),50);
    msgWriter.addAction("Yes","javascript:hideLayer('mygrid<%=suffix %>Message');javascript:doDelete0('" + row + "')");
    msgWriter.addAction("No","javascript:hideLayer('mygrid<%=suffix %>Message')");  
    msgWriter.showMessage("<nobr>Are you sure you want to delete the saved search </nobr>" + name + "?");
  }
  
  function doDelete0(row){
  	deleteGridRow(mygrid<%=suffix %>,row,BASE_DIRECTORY + "search/common/removeSavedSearchAction.jsp?savedSearchId=" + row + "&timestamp=" + new Date().getTime());
  }
	
	function handleMenuItems<%=suffix %>(){
 		<% if (isEdit){%>
			aMenu<%=suffix %>.menu.showButtons("runSavedSearch,editSavedSearch,removeSavedSearch");
 		<%}else {%>
 			aMenu<%=suffix %>.menu.hideBar();
 		<%}%>
  }
	  
  function runSavedSearch0(){
    if (contextRowId<%=suffix %> && contextRowId<%=suffix %> != ""){
      doRun1(contextRowId<%=suffix %>);
    }
  }
  
  function editSavedSearch0(){
    if (contextRowId<%=suffix %> && contextRowId<%=suffix %> != ""){
      doEdit1(contextRowId<%=suffix %>);
    }
  }
  
  function removeSavedSearch0(){
    if (contextRowId<%=suffix %> && contextRowId<%=suffix %> != ""){
      doDelete1(contextRowId<%=suffix %>);
    }
  }

</script>
</head>

<%
String onLoadFunctions = "initTables();init()";
if(showMenu) {
	onLoadFunctions = "initMenus" + suffix + "();" + onLoadFunctions;
}
%>
<body onLoad="<%=onLoadFunctions %>" onUnload="destroyTables()" style="margin:0;padding:0;overflow:auto;" >
<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/tooltip/wz_tooltip.js"></script>
<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/tooltip/tip_balloon.js"></script>

<div id="searchCalendarDiv" class="XPOLOG_DHTMLX_CALENDAR_DIV">
	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
		<tr>
			<td id="searchCalendarTd"></td>
		</tr>
		<tr>
			<td>
				<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
					<tr height="10px">
						<td class="XPOLOG_DHTMLX_CALENDAR_DATE_CELL_TEXT XPOLOG_DHTMLX_CALENDAR_START_DATE_CELL">Start Date:</td>
						<td class="XPOLOG_DHTMLX_CALENDAR_DATE_LABEL" id="searchCalendarStartDateTd"></td>
						<td class="XPOLOG_DHTMLX_CALENDAR_DATE_CELL_TEXT XPOLOG_DHTMLX_CALENDAR_END_DATE_CELL">End Date:</td>
						<td class="XPOLOG_DHTMLX_CALENDAR_DATE_LABEL" id="searchCalendarEndDateTd"></td>
					</tr>
					<tr height="10px">
						<td class="XPOLOG_DHTMLX_CALENDAR_TIME_CELL_TEXT XPOLOG_DHTMLX_CALENDAR_START_TIME_CELL">Start Time:</td>
						<td class="XPOLOG_DHTMLX_CALENDAR_TIME_INPUT_CELL"><input type="text" id="calendarStartTime" name="calendarStartTime" maxlength="8" class="XPOLOG_DHTMLX_CALENDAR_TIME_INPUT" onChange="javascript:validateTimeFormat('calendarStartTime', 'Start Time')"></td>
						<td class="XPOLOG_DHTMLX_CALENDAR_TIME_CELL_TEXT XPOLOG_DHTMLX_CALENDAR_END_TIME_CELL">End Time:</td>
						<td class="XPOLOG_DHTMLX_CALENDAR_TIME_INPUT_CELL"><input type="text" id="calendarEndTime" name="calendarEndTime" maxlength="8" class="XPOLOG_DHTMLX_CALENDAR_TIME_INPUT" onChange="javascript:validateTimeFormat('calendarEndTime', 'End Time')"></td>
					</tr>
					<tr height="10px">
						<td id="searchCalendarErrorTd" class="XPOLOG_DHTMLX_CALENDAR_ERROR_CELL" colspan="4">&nbsp;</td>
					</tr>
				</table>
			</td>
		</tr>
		<tr>
			<td class="XPOLOG_DHTMLX_CALENDAR_BUTTONS_CELL">
				<a id="goSearchCalendarLink" href="javascript:goSearchCalendar('0')"><img src="<%=BASE_DIRECTORY %>images/search/header/calendarGo.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/calendarGoOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/calendarGo.gif')"></a>
				<a href="javascript:closeSearchCalendar()"><img src="<%=BASE_DIRECTORY %>images/search/header/calendarClose.gif" border="0" onMouseOver="javascript:setImageSource(this, 'header/calendarCloseOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/calendarClose.gif')"></a>
			</td>
		</tr>
	</table>
</div>

<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="title" value="Save Search"/> 
	<jsp:param name="suffix" value="saveSearch"/>
	<jsp:param name="width" value="650px"/> 
	<jsp:param name="height" value="345px"/> 
	<jsp:param name="includePath" value="search/common/saveSearchDiv.jsp"/> 
	<jsp:param name="actionsNames" value="Save#Cancel"/> 
	<jsp:param name="actions" value="javascript:doSaveSearch('1')#javascript:hideSaveSearchDiv()"/> 
</jsp:include>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td valign="top">
      <table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              
        <tr height="10">
          <td>
	          <jsp:include page="../../common/pageMainHeader.jsp" flush="true">
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="headerTitle" value="Saved Searches" />
						</jsp:include>
         	</td>
        </tr>
        <tr>                
          <td valign="top"> 
            <% 
            String addName = isEdit ? "New Saved Search" : "";
            String addLink = isEdit ? "javascript:goNew()" : "";
            
            String tableNames = isEdit ? "Edit#Delete" : "";
            String tableActions = isEdit ? "javascript:doEdit()#javascript:doDelete()" : "";
            String ids = isEdit ? "Edit#Delete" : "";
            String selectTypes = isEdit ? "2#2" : "";
            
            if (tableNames.length() > 0){
          		tableNames += "*;*";
          		tableActions += "*;*";
          		ids += "*;*";
          		selectTypes += "*;*";
          	}
            
            tableNames += "Run Search";
         		tableActions += "javascript:doRun()";
         		ids += "*Run Search*";
         		selectTypes += "2";
            
         		String menu = showMenu ? "aMenu" + suffix : "";
            
            %>                               
						<jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="initXML" value="search/admin/savedSearchesXML.jsp" />
							<jsp:param name="updateXML" value="search/admin/savedSearchesXML.jsp?dataOnly=true" />									
							<jsp:param name="menu" value="<%=menu%>"/>
							<jsp:param name="newActionNames" value="<%=addName%>" />
							<jsp:param name="newActions" value="<%=addLink%>" />
							<jsp:param name="tableActionNames" value="<%=tableNames%>" />
							<jsp:param name="tableActions" value="<%=tableActions%>" />
							<jsp:param name="tableActionIds" value="<%=ids%>" />
							<jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
							<jsp:param name="recordsText" value="Saved Searches" />
							<jsp:param name="style" value="main" />
							<jsp:param name="doubleClickAction" value="doEdit" />
							<jsp:param name="lastSelectedRow" value="<%=lastSelectedRow%>" />
							<jsp:param name="showSelectedRowOnLoad" value="true" />
							<jsp:param name="suffix" value="<%=suffix %>" />
						</jsp:include>
	    		</td>
	  		</tr>
			</table>
	   </td>
	 </tr>
</table>

<script>
	function updateButtonActivate(rowid,id,columnType,gridType){
	  if (!id || id == "") return;
	  enableActionButton(id);
	}
</script>

</body>

</html>