<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.SearchEngineAdminHelper"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.scheduler.ui.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.remote.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.data.index.adapters.*"%>
<%@ page import="xpolog.eye.data.index.*"%>


<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>

<%! 
  String getTreeDiv(Module node,UserContext userContext,HashMap modules,HashMap logs, 
  		boolean usingIndex, boolean textIndexed, boolean all, boolean searchEngineManagement) throws IOException{
  		 return getTreeDiv(node,userContext,modules,logs,usingIndex,textIndexed,all,searchEngineManagement,false) ;
  }
  
  String getTreeDiv(Module node,UserContext userContext,HashMap modules,HashMap logs, 
  		boolean usingIndex, boolean textIndexed, boolean all, boolean searchEngineManagement,boolean showIndexingInfo) throws IOException{
    StringBuffer buffer = new StringBuffer();
    buffer.append("<link rel=\"stylesheet\" type=\"text/css\" href=\"../css/components.css\"/>");
	  buffer.append("<script  src=\"../scripts/comps/modulesTree.js\"></script>");
	  buffer.append("<script>");
	  buffer.append("baseDirectory = \"../\";");	  
    if (node != null){
      addChildsNodeDiv(buffer,node,"node",userContext,modules,logs,usingIndex,textIndexed,all,searchEngineManagement,showIndexingInfo ? SearchEngineManager.getInstance().getDefaultIndexAdapter() : null, showIndexingInfo);
      buffer.append("\ntree.writeTree();");
    }
    buffer.append("</script>");
    return buffer.toString();
  }
  
  void addChildsNodeDiv(StringBuffer buffer,
  		ModuleMember node, String parentKey,UserContext userContext,
			HashMap modules,HashMap logs,boolean usingIndex,boolean textIndexed,boolean all,boolean searchEngineManagement,IndexAdapter indexer,boolean showIndexingInfo) throws IOException{
  	Module mod = null;
  	UserSecurity user = null;
  	if (userContext != null){
  		user = userContext.getUser();
  	}
  	if(node.getType().equals(Module.MODULE_TYPE)){
  		try{
  			mod = SiteManagment.getInstance().getModuleFromId(node.getId());
  			if (mod == null){
  				return;
  			}
  			if (!all && !SearchEngineAdminHelper.checkModuleIndex(mod,userContext,usingIndex,textIndexed)){
  				return;
  			}
  		}catch(Exception e){
  			return;
  		}
  	}else{
  		return;
  	}
  	List children = mod.getModuleMembers(userContext);
  	SiteManagment mgmt = SiteManagment.getInstance();
  	String type = null;
  	LogBrowsingManager lbm = null;
    for (int i = 0; i < children.size(); i++) {
      ModuleMember child = (ModuleMember)children.get(i);
      if (child == null){
      	continue;
      }
      //if it is a log - finding the type in order not to include db,http,merge.
      if(child.getType() != null && child.getType().equals("Log")) {        
        if(!SearchEngineAdminHelper.checkLogIndex(child,userContext,usingIndex,textIndexed)){
        	continue;
        }        
      }
      else if (child.getType() != null && child.getType().equals(Module.MODULE_TYPE) &&
      		!all && !SearchEngineAdminHelper.checkModuleIndex(child,userContext,usingIndex,textIndexed)) {
      	continue;
      }
      
      String key = child.getId();
      String treeKey = parentKey + "_" + i;
      String parentNode = parentKey.equals("node") ? "tree.root" : parentKey;
      
      String extraText = "";
      if (showIndexingInfo && indexer != null){
        IndexInformation info = indexer.getIndexInformation(new IndexedObject(child.getId()));
        if (info != null){
          if (info.isInProgress()){
             extraText = "In Progress";
          }else if (info.isIndexed()){
            extraText = "Indexed (" + DateUtil.formatDate(info.getLastIndexed(),"MM/dd/yyyy HH:mm:ss") + ")";
          }else if (info.isInterrupted()){
          	extraText = "Interrupted";
          }
					        
        }
      }
      if (extraText.length() > 0){
					extraText = "<span class=\"SMALLTEXT\"> &nbsp; - &nbsp; <b>" + extraText + "</b></span>";
      }
      boolean selected = false;
      String chkKey = "logs";
      if(child.getType().equals(Module.MODULE_TYPE)){
        selected = modules == null || modules.containsKey(child.getId());
        chkKey = "modules";
      }else {
        selected = logs == null || logs.containsKey(child.getId());
      } 
      
      buffer.append("\nvar " + treeKey + " = tree.addNode(" + parentNode + ",\"" + chkKey +"\",\"" + child.getId() + "\",\"" + child.getName() + "\",\"" + child.getDescription() + "\",'" + extraText + "'," + selected + ",false);");
      
      addChildsNodeDiv(buffer,child,treeKey,userContext,modules,logs,usingIndex,textIndexed,all,searchEngineManagement,indexer,showIndexingInfo);
    }
  }
  
%>
