<%@ page language="java"%>

<%@ page import="java.util.*"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.admin.helpers.SearchEngineAdminHelper"%>
<%@ page import="xpolog.eye.data.filters.FilterCollection"%>
<%@ page import="xpolog.eye.data.index.*"%>
<%@ page import="xpolog.eye.data.index.adapters.*"%>
<%@ page import="xpolog.eye.data.index.adapters.defaultadapter.*"%>
<%@ page import="xpolog.eye.site.ui.tree.ModuleMemberRenderer"%>
<%@ page import="xpolog.eye.admin.builders.MergedLogBrowserBuilder"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.cloud.*"%>
<%@ page import="xpolog.eye.site.portal.*"%>


<%!
	static final String BASE_DIRECTORY = "../";
	static final int NUMBER_OF_PAGE_LINKS = 20;
%>

<%!
	String getPagesList(String[] pagesList, int currentPage){
	if (pagesList == null || pagesList.length == 0 || currentPage == -1){
		return "";
	}
		StringBuffer sb = new StringBuffer();
		int firstPage = Math.max(currentPage-NUMBER_OF_PAGE_LINKS/2-1,0);
		int lastPage = Math.min(currentPage+NUMBER_OF_PAGE_LINKS/2,pagesList.length);
		if (firstPage == lastPage-1){
			return "<tr><td>&nbsp;</td></tr>";
		}
		sb.append("<tr>");
		sb.append("<td align=\"center\"><table border=\"0\"><tr>");
		if (currentPage > 0){
			sb.append("<td><a class=\"BUTTON_LINK\" href=\"javascript:doPrev()\">prev</a></td>");
			sb.append("<td><a class=\"BUTTON_LINK\" href=\"javascript:doPrev()\"></a></td>");
		}
		sb.append("<td align=\"center\">");
		for (int i=firstPage; i<lastPage; i++){
			if (Integer.parseInt(pagesList[i]) != currentPage+1){
				sb.append("<a class=\"BUTTON_LINK\" href=\"javascript:goToPage("+(pagesList[i])+")\">"+pagesList[i]+"</a>&nbsp;</nobr>");
			}else{
				sb.append("<b><span class=\"REGULARTEXT\">"+pagesList[i]+"</span></b>&nbsp;");
			}
		}
		sb.append("</td>");
		if (currentPage < pagesList.length-1){
			sb.append("<td>&nbsp;<a class=\"BUTTON_LINK\" href=\"javascript:doNext()\"></a></td>");
			sb.append("<td><a class=\"BUTTON_LINK\" href=\"javascript:doNext()\">next</a></td>");
		}
		sb.append("</tr></table></td>");
		sb.append("</tr>");		
		return sb.toString();
	}
%>


<%

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request, response, null, true)) {
	  return;
  }
  //constants
  String ERROR_OBJ = "ERROR_OBJ";
	String charset = "UTF-8";
	response.setContentType("text/html; charset=" + charset);
	request.setCharacterEncoding(charset);
	
	

  //site management
	final UserEnvironment env = UserEnvironment.getUserEnvironment(request);  	
  SiteManagment mgmt = SiteManagment.getInstance();
  SearchEngineConfiguration searchEngineConfig = SearchEngineManager.getInstance().getConfiguration();

  env.setUsePage("search/search.jsp");
  
  //UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
  HashMap modulesMap = new HashMap();
  HashMap logsMap = new HashMap();
  Properties prop = Configuration.getInstance().getUIData();

  String img = BASE_DIRECTORY+"/"+prop.getProperty("search.xplgsearchlarge.image");

	UserSearches userSearches = env.getUserSearches();
	UserSearch userSearch = null;
	String userSearchId = request.getParameter("SEARCH_ID");
	String searchTerm = "";
	String orgSearchTerm = "";
	String searchIn = "";
	String[] logsArr = null;
	String[] modulesArr = null;
	String[]  hosts = null;
	boolean onlyIndexed = false;
	String findResults = "";
	String reformattedSearchTerm = "";
	String matchWholeWordsOnlyStr = request.getParameter("matchWholeWordsOnlyStr");
	boolean matchWholeWordsOnly = true; 

  searchTerm = request.getParameter("searchTerm");
  orgSearchTerm = searchTerm;
  
	if (userSearchId != null && !userSearchId.equals("")){
		userSearch = userSearches.getUserSearch(userSearchId);
		if (userSearch != null){
			searchTerm = userSearch.getSearchString();
			orgSearchTerm = userSearch.getOrgSearchString();
			onlyIndexed = userSearch.isOnlyIndexed();
			logsArr = userSearch.getLogs();
			modulesArr = userSearch.getModules();
			findResults = userSearch.isFindAllWords() ? "allWords" : "";
			hosts = userSearch.getHosts();
			matchWholeWordsOnly = userSearch.isMatchWholeWordsOnly();
		} else {
			userSearchId = "";
			userSearch = null;
		}
	}
	if (userSearchId == null || userSearchId.equals("")) {
		userSearchId = "";
	  if (searchTerm == null){
	  	searchTerm = "";
	  }
	  searchIn = request.getParameter("searchIn");
	  if (searchIn == null){
	  	searchIn = "";
	  }
		onlyIndexed = searchIn.equals("only selected logs");
		matchWholeWordsOnly = matchWholeWordsOnlyStr==null || matchWholeWordsOnlyStr.equals("true");
	}
	reformattedSearchTerm = searchTerm.replaceAll("&quot;","\"");	
	
	if (findResults == null || findResults.equals("")){
		findResults = request.getParameter("findResults");
	}
	if (findResults == null){
		findResults = "";
	}

	String treeCode = null;
	if (onlyIndexed || treeCode == null){
	 	String logsList = request.getParameter("logs");
	 	if (logsList != null && logsList.length() > 0){
	 		logsArr = logsList.split(",");
	 	}
	  if (logsArr != null){
	    for (int i = 0;i< logsArr.length;i++){
	      logsMap.put(logsArr[i],logsArr[i]);
	    }
	  }

	  String [] modsArr = null;
	  String modsList = request.getParameter("mods");
	  if (modsList != null && modsList.length() > 0){
	  	modsArr = modsList.split(",");
	  }
	  if (modsArr != null){
	    for (int i = 0;i< modsArr.length;i++){
	    	if (!modsArr[i].endsWith("*")){
	    		modulesMap.put(modsArr[i],modsArr[i]);
	    	}
	    }
	  }
	  boolean logsMapUpdated = false;
	  if (modsArr != null){
	  	HashSet logTypesToIgnore = new HashSet();
	  	logTypesToIgnore.add(MergedLogBrowserBuilder.MERGE_LOG_TYPE);
	    for (int i = 0;i< modsArr.length;i++){
	    	String id = modsArr[i];
	    	if (modsArr[i].endsWith("*")){
	    		id = id.substring(0,id.length()-1);
	    		ModuleMemberRenderer.addAllModuleChildren(id,modulesMap,logsMap,logTypesToIgnore);
	    		logsMapUpdated = true;
	    	}
	    	modulesMap.put(id,id);
	    }
	  }
	  if (logsMap != null && logsMapUpdated){
	  	List list = new LinkedList();
	  	Iterator it = logsMap.keySet().iterator();
	  	ModuleMember logMember = null;
	  	while (it.hasNext()){
	  		String logId = (String)it.next(); 
	  		logMember = mgmt.getModuleMember(logId);
	  		if (logMember != null && logMember.isTextIndexed() && logMember.isUseIndexing()){
		  		list.add(logId);
	  		}
	  	}
  		logsArr = (String[])list.toArray(new String[list.size()]);
	  }
	  
	  request.getSession().setAttribute("searchLogs",logsMap);
	  request.getSession().setAttribute("searchModules",modulesMap);
  }
  
  if (hosts == null){
    hosts = request.getParameterValues("hosts");
  }
  
  CloudMgr cmg =	SiteManagment.getInstance().getCloudMgr();
  XplgNode[] enterpriseNodes = CloudUtil.sortArrayByName(cmg.getAllXplgNodes());
  
  if (hosts == null){
  	boolean markEnterpriseNodes = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("search.markEnterpriseNodes",false);
  	if (markEnterpriseNodes){
  		List l = new LinkedList();
  		l.add("localhost");
  		for (int i=0; i<enterpriseNodes.length; i++){
  			l.add(enterpriseNodes[i].getId());
  		}
  		hosts = (String[])l.toArray(new String[l.size()]);
  	}else{
    	hosts = new String[] {"localhost"};
  	}
  }
  
  String[] listOfPages = null;
  String pagesCode = "";
	int currentPage = 1;
	
  HashSet selLogs = new HashSet();
  
	SearchQuery searchQuery = null;
	SearchResults results = null;
	
	String goToPageStr = request.getParameter("goToPage");
	int goToPage = -1;
	if (goToPageStr != null){
		try {
			goToPage = Integer.parseInt(goToPageStr);
		}catch (NumberFormatException e){}
	}
	
	
	String lastSearchTerm = userSearches.getLastSearchedTerm();
	int totalResults = 0;
  int resultsPerPage = searchEngineConfig.getResultsPerPage();
  int resultFrom = 0;
  int resultTo = 0;
  
  String refreshMenuStr = request.getParameter("refreshMenu");
  boolean refreshMenu = refreshMenuStr != null && refreshMenuStr.equals("true");
	String resultsPerPageStr = request.getParameter("resultsPerPage");
	if (resultsPerPageStr != null && !resultsPerPageStr.equals("")){
		try{
			resultsPerPage = Integer.parseInt(resultsPerPageStr.trim());
			if (resultsPerPage == 0){
				resultsPerPage = searchEngineConfig.getResultsPerPage();
			}
		}catch(Exception e){
			resultsPerPage = searchEngineConfig.getResultsPerPage();
		}
  }
  float searchTime = 0;
  
	String op = request.getParameter("op");
	boolean isOpExists = op != null && op.length() > 0;
	
	if (!isOpExists){
		op = "CURRENT";
	}
	
	if (!searchTerm.equals("")){
		if (userSearch != null){
			results = userSearch.getResults();
		}
		else {
			userSearch = userSearches.getLastSearch();
			if ((isOpExists || goToPage!=-1) && userSearch != null && userSearch.getOrgSearchString().equals(searchTerm) &&
					(!userSearch.isOnlyIndexed() && !onlyIndexed ||
					(userSearch.isOnlyIndexed() && onlyIndexed && Arrays.equals(userSearch.getLogs(),logsArr))) &&
					userSearch.isFindAllWords() == findResults.equals("allWords") && userSearch.isMatchWholeWordsOnly() == matchWholeWordsOnly
				){
				userSearch = userSearches.getLastSearch();				
			} else {
				UserSearch uSearch = userSearches.getUserSearchBySearchTerm(searchTerm);
				if (uSearch != null){
					userSearches.removeSearch(uSearch.getId());
				}		
				userSearch = new UserSearch();
				userSearch.setSearchString(reformattedSearchTerm);
				userSearch.setUserContext(userContext);
				userSearch.setLogs(logsArr);
				userSearch.setOnlyIndexed(onlyIndexed);
				userSearch.setFindAllWords(findResults.equals("allWords"));
				userSearch.setHosts(hosts);
				userSearch.setMatchWholeWordsOnly(matchWholeWordsOnly);
				userSearch.updateSearchTerm();
				searchTerm = userSearch.getSearchString();
				if (searchTerm != null && searchTerm.length() > 0){
					userSearch.doSearch();
					userSearches.addUserSearch(userSearch.getId(), userSearch);
					userSearches.setLastSearchedTerm(searchTerm);
					refreshMenu = true;
				}
			}
			
			results = userSearch.getResults();
		  searchTime = userSearch.getSearchTime();
		}

		AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
				userContext, AuditConstants.CHANGE, "execute user search", AuditConstants.USER_PORTAL_SEARCH, "Search " + userSearch.getSearchString() + " completed in " + userSearch.getSearchTime() + " ms");

	  String[] pages = results.getPagesList(resultsPerPage);

		userSearches.setLastSearch(userSearch);
	  totalResults = results.length();
		if (goToPage != -1){
			results = userSearch.getResults().getResultsAtPage(goToPage,resultsPerPage);
		}
		else if (op.equals("CURRENT")){
			results = userSearch.getResults().getCurrentResults(resultsPerPage);
		} else if (op.equals("NEXT")){
			results = userSearch.getResults().getNextResults(resultsPerPage);
		} else if (op.equals("PREV")){
			results = userSearch.getResults().getPrevResults(resultsPerPage);
		} else if (op.equals("FIRST")){
			results = userSearch.getResults().getFirstResults(resultsPerPage);
		} else if (op.equals("LAST")){
			results = userSearch.getResults().getLastResults(resultsPerPage);
		}
	  resultFrom = userSearch.getResults().getFirstResultPosition();
	  resultTo = userSearch.getResults().getLastResultPosition();
	  currentPage = userSearch.getResults().getCurrentPage(resultsPerPage);
	  pagesCode = getPagesList(pages,currentPage);
	}

  String searchTermForLogview = SearchEngineAdminHelper.parseSearchTerm(searchTerm);
  String searchRegExp = "";
  if (searchTerm.indexOf(" ")!=-1 || searchTerm.indexOf("*")!=-1 || searchTerm.indexOf("?")!=-1){
  	searchRegExp = "&searchRegExp=true";
  }
  HashSet selectedHosts = new HashSet();
  for(int i = 0;i < hosts.length;i++){
    selectedHosts.add(hosts[i]);
  }
  String searchString = orgSearchTerm != null && orgSearchTerm.length() > 0 ? orgSearchTerm : searchTerm;
  boolean isSiteDemo = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("isSiteDemo",false);
%>
<html>

<head>
<meta http-equiv="Content-Language" content="text/html; charset=<%=charset%>">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/portal.css" />
<script src="<%=BASE_DIRECTORY%>scripts/tree/rightClickMenu.js"></script>
<jsp:include page="../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script>
	function showLogs(){
	  showGeneralAdminDiv("LogSelection");
		document.getElementById("modTree").style.display  = "";
		document.getElementById("defShowLink").style.display="none";    		
	}
	
	function showHideLine(){
		show = document.getElementById("onlyIndexed").checked == true;
		if(show){
			document.getElementById("modTree").style.display  = "none";
			document.getElementById("defShowLink").style.display="";			
		}else{
			document.getElementById("modTree").style.display  = "none";
			document.getElementById("defShowLink").style.display="none";
			hideGeneralAdminDiv("LogSelection");
			
		}
	}
	
	function showHideAdvanced(){
		show = document.getElementById("advanced").style.display == "";
		if(show){
			document.getElementById("advanced").style.display  = "none";
			document.getElementById("advancedLink").style.display  = "";
			document.getElementById("topSearchTD").style.borderBottomWidth  = "4px";									
		}else{
		document.getElementById("advancedLink").style.display  = "none";
			document.getElementById("advanced").style.display = "";
			document.getElementById("advanced").style.display = "";			
			document.getElementById("topSearchTD").style.borderBottomWidth  = "0px";
		}
		showHideLine();
	}
	
	function showHideTips(){
		show = document.getElementById("tips").style.display == "";
		if(show){
			document.getElementById("tips").style.display  = "none";
		}else{
			document.getElementById("tips").style.display = "";
			document.getElementById("tips").style.display = "";
		}
		showHideLine();
	}
	
	function go(){
		formatQuery();
		if (document.access.matchWholeWordsOnly.checked == true){
			document.access.matchWholeWordsOnlyStr.value = "true";
		}else{
			document.access.matchWholeWordsOnlyStr.value = "false";
		}
		updateSelected();
		document.access.submit();
	}
	
	
	
	function init(){
		<%if (onlyIndexed){%>
			document.getElementById("searchIn").selectedIndex = 1;
			showHideLine();
		<%}%>
		<%if (refreshMenu){%>
			refreshMenus("","UserSearch","<%=BASE_DIRECTORY%>");
		<%}%>
	}
	
	function doNext(){
		formatQuery();
		document.access.op.value = "NEXT";
		updateSelected();
		document.access.submit();
	}
	
	function doPrev(){
		formatQuery();
		document.access.op.value = "PREV";
		updateSelected();
		document.access.submit();
	}
	
	function doFirst(){
		formatQuery();
		document.access.op.value = "FIRST";
		updateSelected();
		document.access.submit();
	}
	
	function doLast(){
		formatQuery();
		document.access.op.value = "LAST";
		updateSelected();
		document.access.submit();
	}
	
	function goToPage(page){
		formatQuery();
		document.access.goToPage.value = page;
		updateSelected();
		document.access.submit();
	}
	
	function doCheckSearch(e){
		var result = doCheck(e);
		if (!result){
			formatQuery();
			go();
		}
		return result;
  }

	function doCheck(e){
		if (!e) var e = window.event;
		if (e.keyCode) code = e.keyCode;
		else if (e.which) code = e.which;
		if (code == 13){
		  return false;
		}
		return true;
  }
  
  function formatQuery(){
  	//while(document.access.searchTerm.value.indexOf('"')!=-1){
	  	//document.access.searchTerm.value = document.access.searchTerm.value.replace(/"/,"&quot;");
	  //}
  }
  
  function selectAllNodes(){
  	for (var i=0; i<=<%=(enterpriseNodes!=null?enterpriseNodes.length:0)%>; i++){
  		document.access.hosts[i].checked = true;
  	}
  }
  
  function clearAllNodes(){
  	for (var i=0; i<=<%=(enterpriseNodes!=null?enterpriseNodes.length:0)%>; i++){
  		document.access.hosts[i].checked = false;
  	}
  }
  
  function showToByTime(){
  	    formatQuery();
		document.access.op.value = "BYTIME";
		document.access.action="searchByTime.jsp?SEARCH_ID=" + '<%=userSearchId%>';
		document.access.submit();
  }
  
  function showHideMergeWindow(){

		show = document.getElementById("merge").style.display == "";
		if(show){
			document.getElementById("merge").style.display  = "none";
			document.getElementById("hideMerge").style.display  = "none";
			document.getElementById("showMerge").style.display  = "";
		}else{
		  document.getElementById("merge").style.display = "";
			document.getElementById("hideMerge").style.display  = "";
		  document.getElementById("showMerge").style.display  = "none";
			document.getElementById("merge").innerHTML = "<iframe width='100%' height='500' src='searchMergeAdmin.jsp?SEARCH_ID=' + '<%=userSearchId%>'></iframe>";
		}
		//showHideLine();
  	
  }
  
	function updateSelected(){
		list = tree.getAllCheckedAndPartiallyChecked();
		arr = list.split(",");
	  var selectedLogsCombo = document.getElementById("logs");
	  var selectedModulesCombo = document.getElementById("modules");
	  var logsStr = "";
	  var modsStr = "";
		for (var i=0; i<arr.length; i++){
			s = arr[i];
			ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				type = s.substring(0,ind);
				id = s.substring(ind+1,s.length);
				if (type == "<%=XpoLogObjectTypes.MODULE_TYPE%>"){
					if (modsStr != ""){
						modsStr += ",";
					}
					modsStr += id;
					if (tree.hasChildren(s) && (tree.hasChildren(s)+"") == "true"){
	 				modsStr += "*";
					}
				}else{
					if (logsStr != ""){
						logsStr += ",";
					}
					logsStr += id;
				}
			}
		}
		document.access.mods.value = modsStr;
		document.access.logs.value = logsStr;
	}

  function hideLogSelection(){
		hideGeneralAdminDiv("LogSelection");
		document.getElementById("defShowLink").style.display=""; 
	}
	
	function hideMergeSelection(){
		hideGeneralAdminDiv("MergeSelection");
	}
	
	var isFirst = true;
	function showMerge(){
	  if (isFirst){
	    initMergeTree();
	  }	
	  isFirst = false;
	  showGeneralAdminDiv('MergeSelection')
	}
	
  
  
</script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>

</head>
<body onLoad="javascript:init()" style="margin:0;padding:0;overflow:auto">
<form AUTOCOMPLETE="OFF" id="access" name="access" METHOD="POST" ACTION="search.jsp" style="padding:0px;margin:0px">
<input type="hidden" name="op">
<input type="hidden" name="goToPage">
<input type="hidden" name="matchWholeWordsOnlyStr" value="<%=matchWholeWordsOnly%>">
<input type="hidden" name="mods">
<input type="hidden" name="logs">
<jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
			<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
			<jsp:param name="title" value="Logs Selection"/> 
			<jsp:param name="suffix" value="LogSelection"/> 
			<jsp:param name="includePath" value="search/searchLogSelection.jsp"/> 			
			<jsp:param name="width" value="500px"/> 
			<jsp:param name="height" value="300px"/>
			<jsp:param name="zIndex" value="300"/> 
			<jsp:param name="actionsNames" value="Close"/> 
			<jsp:param name="actions" value="javascript:hideLogSelection()"/> 
			</jsp:include> 
			
<jsp:include page="../common/adminGeneralDiv.jsp" flush="true">
			<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
			<jsp:param name="title" value="Logs to Merge"/> 
			<jsp:param name="suffix" value="MergeSelection"/> 
			<jsp:param name="includePath" value="search/searchMergeAdminInner.jsp"/> 			
			<jsp:param name="width" value="500px"/> 
			<jsp:param name="height" value="300px"/>
			<jsp:param name="zIndex" value="200"/>
			<jsp:param name="SEARCH_ID" value="<%=userSearchId%>"/>			
			<jsp:param name="actionsNames" value="View#Close"/> 
			<jsp:param name="actions" value="javascript:doView()#javascript:hideMergeSelection()"/> 
			</jsp:include> 			
			
<!--<input type="hidden" name="SEARCH_ID" value="<%=userSearchId%>">-->
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="100%">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%"  height="100%">
            	                        
              <tr>                
                <td width="100%" colspan="2" height="100%" <%=searchTerm.equals("")?"align=\"center\"":""%>>
                <table border="0" width="100%" cellpadding="0" cellspacing="0" style="border-collapse: collapse" <%=searchTerm.equals("")?"align=\"center\"":""%>  height="100%">
                  <tr height="53">
                    <td>
                      <table border="0" width="100%" cellpadding="0" cellspacing="0">
                      
                     
                      <tr height="52"><td background="<%=BASE_DIRECTORY%>images/portal/grid/titleBackground.gif" style="background-repeat:repeat">
												<span style="padding-left:30" class="PORTAL_TITLE_TEXT">
												<%if(isSiteDemo) { %>
												XpoSearch &nbsp;&nbsp;<a href="http://www.xplg.com/home/downloads/index.jsp" class="HELP_HEADER_LINK" target="_target">Download free trial from www.xplg.com</a>
												<%}else { %>
												XpoSearch
												<%} %>
												</span>
											</td></tr>
                      <tr height="4"><td style="font-size:2">&nbsp;</td></tr>
                      
                        <tr>
                          <td align="center" id="topSearchTD" height="126" background="<%=BASE_DIRECTORY%>images/portal/grid/searchTopBackground.gif" style="background-repeat:repeat-x;border-bottom:4px solid #5a6279" >
												    <table border="0" width="600" cellpadding="0" cellspacing="0">
												     
                      
															<tr>
																<td width="80" valign="bottom">
			                          	<span class="REGULARTEXT" style="font-weight: bold;font-size:12pt"><nobr>Search:</nobr></span>
																</td>
																<td width="100" valign="bottom">
			                          	<input class="TEXTBOX" style="border-width:0px;height:20px;padding-left:2;padding-top:2" type="text" id="searchTerm" name="searchTerm" size="60" value="<%=xpolog.eye.util.XpologUtil.replaceAll(searchString,"\"","&quot;")%>" onKeyPress="return doCheckSearch(event)">
																</td>
																<td width="45" style="padding-top:1;padding-bottom:1">
																<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%" bgcolor="#ffaa3b">
																<tr>
																<td align="center"  onClick="javascript:go()" style="cursor:pointer;padding-bottom:3" valign="top">																
		  	                        	<span  class="REGULARTEXT" style="font-weight:bold">go</span>
																</td>
																</tr></table>
																</td>
																<td width="100" valign="bottom" >
																  <table border="0" width="100%" cellspacing="0" cellpadding="0">
																  <tr><td align="left" style="padding-left:20">
		  	                        	<a href="javascript:showHideAdvanced()" class="BUTTON_SMALLLINK" id="advancedLink">Advanced</a>
		  	                        	</td></tr>
																  
		    	                      	</table>
																</td>
															</tr>			
															<tr>
																<td>&nbsp;</td>
																<td><input type="checkbox" name="matchWholeWordsOnly" id="matchWholeWordsOnly" <%=matchWholeWordsOnly?"checked":""%>> <span class="SMALLTEXT" >search whole words only</span></td>
																<td colspan="2">&nbsp;</td>
															</tr>
											      </table>
                          </td>
                        </tr>
                        <tr height="5">
                        	<td colspan="3" style="font-size:2pt">&nbsp;</td>
                        </tr>
                       
						
			                  <tr height="5">
			                    <td>
			                    	<div id="advanced" style="display:none;padding-bottom:10">
			                    	<table width="100%" border="0"  cellpadding="0" cellspacing="0"  bgcolor="#e1e1e1">
			                    	<tr><td align="center" style="padding-left:155;padding-top:10;padding-bottom:10;border-bottom:2px solid #5a6279">
				                    	<table width="600" height="100%" border="0"  cellpadding="0" cellspacing="0">
				                    	<tr height="5">
			                        	<td align="right" valign="bottom"><span class="REGULARTEXT">
			                        	<a href="javascript:showHideAdvanced()" class="BUTTON_SMALLLINK">Close Advanced Search [-]</a> 
			                        	</span></td>
			                        </tr>					                       			                        
			                        <tr>
			                        	<td><span class="REGULARTEXT">
			                        	Results per page: <input type="text" name="resultsPerPage" value="<%=resultsPerPage%>" size="3">
			                        	</span></td>
			                        </tr>			                        
			                        <tr>
			                        	<td>
				                        	<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
					                        	<tr>
						                        	<td width="110" style="vertical-align:top" ><span class="REGULARTEXT">Find results: </span></td>
						                        	<td>
						                        		<table  width="100%" height="100%" border="0" cellpadding="0" cellspacing="0">
							                        		<tr>
								                        		<td class="REGULARTEXT" valign="bottom">
								                        			<input type="radio" name="findResults" id="allWords" value="allWords" <%=findResults.equals("allWords")?"checked":""%>>with all of the words</input><nobr>
								                        		</td>
							                        		</tr>
							                        		<tr>
								                        		<td class="REGULARTEXT" valign="bottom">
								                        			<input type="radio" name="findResults" id="atLeastOneWord" value="atLeastOneWord" <%=!findResults.equals("allWords")?"checked":""%>>with at least one of the words</input>
								                        		</td>
							                        		</tr>
						                        		</table>
						                        	</td>
					                        	</tr>
				                        	</table>
			                        	</td>
			                        </tr>			    			                        
			                         <tr>
			                        	<td>
				                        	<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
					                        	<tr>
						                        	<td width="110" style="vertical-align:top"><span class="REGULARTEXT">Search in: </span></td>
						                        	<td>
						                        		<table width="100%" height="100%"  border="0" cellpadding="0" cellspacing="0">
							                        		<tr>
								                        		<td class="REGULARTEXT" valign="bottom" colspan="2">
								                        			<input type="radio" name="searchIn" id="all" value="all indexed logs" <%=onlyIndexed?"":"checked"%> onclick="javascript:showHideLine()">all indexed logs <nobr>
								                        		</td>
							                        		</tr>
							                        		<tr>
								                        		<td class="REGULARTEXT" valign="bottom" width="150">
								                        			<input type="radio" name="searchIn" id="onlyIndexed" value="only selected logs" <%=onlyIndexed?"checked":""%> onclick="javascript:showHideLine()"><nobr>only selected logs</nobr>
								                        		</td>
								                        		<td  style="padding-left:10">
						                        						<div id="defShowLink" style="display:none"><a href="javascript:showLogs()" class="BUTTON_SMALLLINK">Select</a></div>
					                        					</td>
							                        		</tr>
							                        		
						                        		</table>
						                        	</td>
					                        	</tr>
				                        	</table>
			                        	</td>
			                        </tr>			    
			                        
			                        <!-- 
			                                            
			                        <tr>
			                        	<td><span class="REGULARTEXT">Search in:</span></td>
			                        </tr>			                        
			                        <tr>
			                        	<td>
			                        		<table border="0" cellpadding="0" cellspacing="0">
				                        		<tr>
					                        		<td class="REGULARTEXT" valign="bottom">
					                        			<input type="radio" name="searchIn" id="all" value="all indexed logs" <%=onlyIndexed?"":"checked"%> onclick="javascript:showHideLine()">all indexed logs </input><nobr>
					                        			<input type="radio" name="searchIn" id="onlyIndexed" value="only selected logs" <%=onlyIndexed?"checked":""%> onclick="javascript:showHideLine()">only selected logs</input>
					                        		</td>
					                        		<td>&nbsp;&nbsp;</td>
					                        		<td valign="bottom">
						                        		<a href="javascript:showHideLogs()" class="LINK"><div id="defShowLink" style="display:none">Select indexed logs</div><div id="defHideLink" style="display:none">Hide selected logs</div></a>
					                        		</td>
				                        		</tr>
																		<tr>
																			<td valign="top">
																				<div id="loadingDiv" style="display:none">
																					<span class="REGULARTEXT">Loading...</span>
																				</div>
																			</td>
																		</tr>
							                    	<tr>
							                    		<td colspan="3" class="REGULARTEXT">
										                    <div id="modTree" style="display:none">
																					<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
																						<tr>
																							<td valign="top">
																								<div id="treeboxbox_tree"></div>
																							</td>
																						</tr>
																					</table>
										                    </div>
							                    		</td>
								                    </tr>																		
			                        		</table>
																</td>
			                        </tr>
			                        -->
			                        <%if (false && enterpriseNodes != null && enterpriseNodes.length > 0){		%>																  
			                        <tr>
			                        	<td>
																	<table border="0" cellpadding="0" cellspacing="0">
																	<tr>
																	<td><span class="REGULARTEXT"><b>Search on: </b></span></td>
																	<td width="10">&nbsp;</td>
																	<td><a href="javascript:selectAllNodes()" class="SMALLLINK">select all</a></td>
																	<td width="10">&nbsp;</td>
																	<td><a href="javascript:clearAllNodes()" class="SMALLLINK">clear all</a></td>
																	</tr>
																	</table>
			                        	<td>
			                        </tr>
			                        <tr>
			                        	<td>
			                        		<table border="0" cellpadding="0" cellspacing="0">
				                        		<tr>
					                        		<td class="REGULARTEXT" >
			                         
																		
				                        		<tr colspan="3">
					                        		<td class="REGULARTEXT" valign="bottom">
					                        			<input type="checkbox" name="hosts" id="localhost" value="localhost"  <%=selectedHosts.contains("localhost")?"checked" : ""%>>Local Host					                        			
					                        		</td>
				                        		</tr>
				                        		<% for (int i = 0; i < enterpriseNodes.length;i++){%>
				                        		<tr>
							                    		<td colspan="3">
										                    <input type="checkbox" name="hosts" id="<%=enterpriseNodes[i].getId()%>" value="<%=enterpriseNodes[i].getId()%>"  <%=selectedHosts.contains(enterpriseNodes[i].getId())?"checked" : ""%>><nobr><span class="REGULARTEXT"><%=enterpriseNodes[i].getName()%></span></nobr>
							                    		</td>
								                    </tr>
																		<%}%>
																		</table>
																</td>
			                        </tr>
			                        <%}%>
					                    </table>
					                    </td></tr>
					                    </table>
				                    </div>
				                    
			                    </td>
			                  </tr>
			                
                      </table>
                    </td>
                  </tr>
                 
                  <%
                  if (results != null){
                  	HashMap resultsMap = new HashMap();
                  %>
                  <tr>
                  	<td style="padding-left:10;padding-right:10"">
                  		<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">
                  		<tr height="10">
                  				<td style="padding-bottom:2" nowrap>
                  				<table border="0" width="100%" cellpadding="0" cellspacing="0" height="100%">
                  					<tr>
                  						<td style="padding-left:10"><a id="showMerge" href="javascript:showMerge()" class="BUTTON_LINK" >Merge results<nobr></a><a id="hideMerge" href="javascript:showHideMergeWindow()" class="BUTTON_LINK" style="display:none">hide Merge results</a></td>
                  						<td>&nbsp;</td>
															<td width="*" align="right">                  				
			                  				<span style="padding-right:5;font-size:10pt">
			                  					results <b><%=resultTo>0?resultFrom+1:0%></b> - <b><%=resultTo%></b> of <b><%=totalResults%></b>
			                  					<span style="font-size:10pt;vertical-align:middle">(<b><%=searchTime%></b> seconds)</span>
			                  				</span>
			                  			</td>
			                  		<tr>
			                  	</table>
                  				</td>
                  			</tr>
                  			<tr height="10">
                  				<td class="SEARCHRESULT" nowrap>
                  				<table border="0" width="100%" cellpadding="0" cellspacing="0" height="100%">
                  					<tr>
                  						<td style="padding-top:3;padding-bottom:3;padding-left:10"><span class="MEDIUMTEXT">Searched term: <%=searchTerm%></span></td>
															
			                  		<tr>
			                  	</table>
                  				</td>
                  			</tr>
									      <tr height="10">
									        <td valign="bottom" >
									        <table border="0" width="100%" cellpadding="0" cellspacing="0" height="10">
									          <tr>
									            <td width="45%">&nbsp;</td>
									            <td width="10%" align="center">
									              <table border="0" width="100%" cellpadding="0" cellspacing="0" height="100%">
									                <%=pagesCode%>
									              </table>
									            </td>
									            <td width="45%">&nbsp;</td>
									          </tr>
									        </table>
									        </td>
									      </tr>
									      
		 									<tr height="10"><td style="padding-left:20"><table border="0" width="100%" cellpadding="0" cellspacing="0" height="100%">
                  			<%
                  			for (int i=0; i<results.length(); i++){
                  				LogSearchResult result = (LogSearchResult)results.getResult(i);
                  				String logId = result.getLogId();
                  				String logName = result.getLogName();
                  				long lastIndexed0 = result.getIndexingDate();
                  				//Date lastIndexed = new Date(lastIndexed0);
                  				String lastIndexed = DateUtil.formatDate(lastIndexed0,"dd/MM/yyyy HH:mm:ss");
                  				String hostId = result.getHostId();
                  				XplgNode node = null;
                  				if (hostId != null && hostId.length() > 0){
                   					node = cmg.getNodeById(hostId);
                   				}
                  				String parentModule = result.getParentModuleName();
                  				String logSearchTerm = xpolog.eye.util.XpologUtil.replaceAll(orgSearchTerm,"%","%25"); 
                  				logSearchTerm = xpolog.eye.util.XpologUtil.replaceAll(logSearchTerm,"&","%26"); 
													 logSearchTerm = xpolog.eye.util.XpologUtil.replaceAll(logSearchTerm,"#","%23"); 
													 logSearchTerm = xpolog.eye.util.XpologUtil.replaceAll(logSearchTerm,"+","%2B"); 
                  				 logSearchTerm = xpolog.eye.util.XpologUtil.replaceAll(logSearchTerm,"&quot;","\\&quot;"); 
						 							logSearchTerm = xpolog.eye.util.XpologUtil.replaceAll(logSearchTerm,"\"","\\&quot;"); 
                  				String logPath = "loggers/logview.jsp?gotoMain=true&opdirect=START&logid=" + logId + "&searchEngineSearchTerm=" + logSearchTerm + "&searchEngineAllWords=" + findResults + "&matchWholeWordsOnly="+matchWholeWordsOnly;
                  				String target = null;
                  				if (node != null){
                  				  logPath = "componentAction.jsp?selectedCompId=Xpolog%26forward=loggers/logview.jsp%3FgotoMain=true%2526logid=" + logId + "%2526searchEngineSearchTerm=" + logSearchTerm + "%2526searchEngineAllWords=" + findResults;
                  				  logPath = "cloud/cloudAction.jsp?NODE_ID=" + node.getId() + "&sucUrl=" + logPath + "&FailUrl=javascript:history.go(-1)&externalRef=true";
                  				  target = node.getId();
                  				}
                  				logPath = BASE_DIRECTORY + logPath;
                  			%>
                  			<tr height="5">
                  			  <td width="30" valign="bottom"><span class="REGULARTEXT" style="color:#4660c5"><%=(i+resultFrom+1)+". "%></span></td>
                  				<td>
                  					<!--<span class="REGULARTEXT"><a href="<%=BASE_DIRECTORY%>loggers/logview.jsp?logid=<%=logId%>&search=<%=searchTermForLogview%><%=searchRegExp%>" class="LINK" ><%=(i+resultFrom+1)+". "+logName%></a></span>-->                  					
                  					<span class="REGULARTEXT"><a href="<%=logPath%>" class="BUTTON_LINK"  <%=target != null ? "target=\"" + target + "\"" : ""%> target="LogView"><%=logName%></a></span>
                  					<span class="SMALLTEXT">&nbsp;&nbsp(<b>lastIndexed: <%=lastIndexed%></b>)</span>
                  				</td>
                  			</tr>
             						<tr height="5"><td></td><td class="SMALLTEXT">Folder: <%=parentModule%></td></tr>
             						<tr height="5"><td></td><td class="SMALLTEXT"><%=result.getDataSourcesAsString()%></td></tr>
             						<% if (node != null){ %>
             						<tr height="5"><td></td><td class="SMALLTEXT">
             						  Host: <a href="<%=BASE_DIRECTORY%>cloud/cloudAction.jsp?NODE_ID=<%=node.getId()%>&externalRef=true" class="SMALLLINK" <%=target != null ? "target=\"" + target + "\"" : ""%>><%=node.getName()%></a>
             						 </td></tr>
             						<%}%>
             						<tr><td>&nbsp;</td></tr>
                  			<%} //end for%>                   			
                  			<%if (results.length()==0){%>
             						<tr height="10"><td class="REGULARTEXT">No logs were found containing <b><%=searchTerm%></b></td></tr>
                  			<%}%>
                  			</table>
                  			</td></tr>   
                  			<tr><td>&nbsp;</td></tr>               			
                  		</table>
                  	</td>
                  </tr>
                  <%} else {//end if
                  	WebSecurityManager securityManager = WebSecurityManager.getInstance();
                    UserSecurity user = securityManager.getUserSecurity(request);
                    
                  	boolean isPermittedAddLog = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_LOG_PERMISSION);
                  	boolean isPermittedAddModule = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_MODULE_PERMISSION);
                  	boolean allowIndexing = securityManager.checkForPermission(request,response,SearchEnginePermissionConstants.IndexingPermissions.INDEXING_PERMISSION,false);
                  	
                  	boolean valid = SiteManagment.getInstance().getXpologManagment().isValidToBeActive();
                  	 
                  	List linksList = new ArrayList();
                  	if (valid){
                      if (isPermittedAddLog){
                      	linksList.add(new PortalItem("Add Log for index","loggers/admin/logAdminGate.jsp","Add Log"));
                        if (isPermittedAddModule){
                        	linksList.add(new PortalItem("Add Logs Directory for index","wizards/common/wizardStarter.jsp?wizardPath=scanner","Add Log Directory"));              
                        }
                      }
                      if (allowIndexing){
                      	linksList.add(new PortalItem("Indexing Status","search/searchEngineIndexing.jsp","Indexing Status"));
                      }
                  	}
                  	
                  
                  
                  %>
                  
                   
                   
                   <tr height="*"><td>
<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
<tr>
<td style="padding-right:41;padding-left:41" width="400">
<% if (linksList != null && linksList.size() > 0){ %>
<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
<tr height="25"><td style="font-size:2">&nbsp;</td></tr>
<tr height="18"><td background="<%=BASE_DIRECTORY%>images/portal/grid/linksHeaderBackground.gif" style="background-repeat:repeat">
<span style="padding-left:19" class="LINKS_HEADER_TEXT">More Actions</span>
</td></tr>
<tr height="10"><td>&nbsp;</td></tr>
<tr height="10"><td >

<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
<% for ( int i = 0; i < linksList.size();i++){
	PortalItem item = (PortalItem)linksList.get(i); %>
<tr height="20">
<td width="30" align="right" ><img src="<%=BASE_DIRECTORY%>images/portal/btns/icon.gif" border="0"></td>
<td style="padding-left:10"><a href="<%=BASE_DIRECTORY + item.getLink() %>" class="LINKS_LINE"><%=item.getName()%></a></td></tr>
<%} %>
</table>
</td></tr>
<tr><td>&nbsp;</td></tr>

</table>
<%} %>
</td>
<td >&nbsp;
</td>
<jsp:include page="../portal/portalHelp.jsp" flush="true"/>
</tr>
</table>
</td></tr>
<tr height="4"><td style="font-size:2" bgcolor="#5a6279">&nbsp;</td></tr>
                   
                   
                   
                  
                  <%} //end of else %>
                                   
                 
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      
    </table>
    </td>
  </tr>
</table>
</form>

<form AUTOCOMPLETE="OFF" id="mergeAccess" name="mergeAccess" method="POST" target="LogViewer" style="padding:0px;margin:0px">
<input type="hidden" id="searchEngineSearchTerm" name="searchEngineSearchTerm" size="1" value="<%=searchTerm%>">
<input type="hidden" id="searchEngineAllWords" name="searchEngineAllWords" size="1" value="<%=findResults%>">
<input type="hidden" id=matchWholeWordsOnly name="matchWholeWordsOnly" size="1" value="<%=matchWholeWordsOnly%>">
<input type="hidden" id="searchRegExp" name="searchRegExp" size="1" value="<%=searchRegExp%>">
<input type="hidden" id="logs" name="logs">
</form>
<script>
	tree=new dhtmlXTreeObject("treeboxbox_tree","100%","100%","0");
	tree.enableTreeLines(false);
	tree.setOnLoadingStart(startLoading);
	tree.setOnLoadingEnd(endLoading);
	tree.setImagePath("<%=BASE_DIRECTORY%>");
	tree.setIconSize(13,13);
	tree.enableCheckBoxes(1);
	tree.enableThreeStateCheckboxes(true);
	tree.setXMLAutoLoading("searchEngineModuleTreeXML.jsp?callingPage=search&usingIndex=true&textIndexed=true");
	tree.loadXML("searchEngineModuleTreeXML.jsp?callingPage=search&usingIndex=true&textIndexed=true");
</script>
</body>

</html>