<%@ page language="java"%>

<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.automation.*"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.indexing.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.index.*"%>

<%@ page import="java.util.*"%>
<%
  final String BASE_DIRECTORY = "../";
%>
<% 
	String ID = "ID";
	String ERROR_OBJ = "ERROR_OBJ";
  String SEARCH_ENG_MGR = "SEARCH_ENG_MGR";
  
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  SearchEngineConfiguration searchEngineConfig = SearchEngineManager.getInstance().getConfiguration();
  
	int resultsPerPage = searchEngineConfig.getResultsPerPage();
	String jobId = searchEngineConfig.getIncrementalIndexingJobId();
	String name = "";
	String description = "";
	String actionId = "";


	ActionJobBuilder job = null;
	boolean isActive = true;
	boolean useIfIndex = true;
 	if(jobId != null){
 		SchedulingMgr smgr = XpoLogScheduleFactory.getSchdulingManager();
 		XpoScheduledOperation op = smgr.getScheduedOp(jobId);
 		if (op != null){
 		  isActive = op.isActive();
 		}
		job = new ActionJobBuilder(op);
 		job.updateFromOp();
 		name = job.getName();
 		description = job.getDescription();
 		jobId = job.getId();
 		actionId = job.getActionId();
 		SearchEngineIndexingTask task = (SearchEngineIndexingTask)XpoTaskManager.getInstance().getXpoTaskById(actionId);
 		if (task != null){
 		  useIfIndex = task.isUseIfIndex();
 		}
 	}else{
 		job = new ActionJobBuilder();
 	}
 	String state = job.getState();
 
	request.setAttribute("CURRENT_JOB",job);
	request.setAttribute("CURRENT_ID",jobId);
	request.setAttribute("IntervalHeader","<span class=\"HEADER>Incremental Indexing Information</span>");
	request.setAttribute("suffix","Delta");
	request.setAttribute("isInUsed","true");
	request.setAttribute("ignoreState","true");
%>


<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse;padding-left:5;padding-top:5;" width="100%" >
 <tr>
   <td><span class="HEADER"> Incremental Indexing Schedule Information</span></td>
 </tr>
 <tr>
   <td><span class="SMALLTEXT">Use scheduling information below to run incremental log indexing of selected logs<br>
   only logs which changes sufficiently will be indexed</span></td>
 </tr>
 <tr>
    <td ><input type="checkbox" name="DeltaSchedEnable" <%=isActive ? "checked" : ""%> ><span class="SMALLTEXT">Enable delta indexing scheduler.</span> </td>
  </tr>
  <tr>
    <td ><input type="checkbox" name="useIfIndex" <%=useIfIndex ? "checked" : ""%> ><span class="SMALLTEXT">Update indexing only after log was indexed for the first time.</span> </td>
  </tr>
  <tr>
    <td width="15%"> <span class="SMALLRTEXT">&nbsp;</span></td>
  </tr>
 <tr>
  <td><span class="REGULARTEXT"><%@ include file="../scheduler/schedule.jsp"%></span></td>
 </tr>
 <tr>
  <td ><font size="2">&nbsp; </font></td>
 </tr>                
</table>