<%@ page language="java"%>

<%@ page import="java.util.*"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.helpers.SearchEngineAdminHelper"%>
<%@ page import="xpolog.eye.data.index.*"%>
<%@ page import="xpolog.eye.data.index.adapters.*"%>
<%@ page import="xpolog.eye.data.index.adapters.defaultadapter.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.*"%>

<%!static final String BASE_DIRECTORY = "../";

	//if coming from the pop up menu with a module Id then mark this modules logs and sub-modules.
	void selectModuleLogs(Module mod, HashMap mods, HashMap logs) {
		if(mod == null) {
			return;
		}
		mods.put(mod.getId(),mod.getId());
		List mem = mod.getModuleMembers();
		ModuleMember[] members = (ModuleMember[]) mem.toArray(new ModuleMember[mem.size()]);

		Module current = null;
		for (int i = 0; i < members.length; i++) {
			if (members[i].getType().equals(Module.MODULE_TYPE)) {
				try {
					current = SiteManagment.getInstance().getModuleFromId(members[i].getId());
				} catch (Exception e) {
					return;
				}
				selectModuleLogs(current, mods, logs);
			} else {
				logs.put(members[i].getId(), members[i].getId());
			}
		}
	}

	%>



<%@ include file="moduleTree.jsp"%>

<%//constants
			String ERROR_OBJ = "ERROR_OBJ";

			//site management
			final UserEnvironment env = UserEnvironment.getUserEnvironment(request);
			SiteManagment mgmt = SiteManagment.getInstance();
			//UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
			UserContext userContext = UserEnvironment.getUserContext(request);
			Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
			HashMap modulesMap = new HashMap();
			HashMap logsMap = new HashMap();

			LogsIndexerRunner runner = SearchEngineManager.getInstance().getCustomIndexerRunner();
			boolean isRunning = runner.isRunning();
			String status = isRunning ? runner.getStatus().getCurrentStatus(): null;
			if (isRunning && status == null) {
				status = "Indexing started running";
			}

			//appropriate messages
			String runMessage = "<span class=REGULARTEXT>To <b>run indexing</b>, please check the logs you would like to run indexing on, and click run</span>";
			String stopMessage = "<span class=REGULARTEXT>To <b>stop indexing</b>, click stop</span><br><span class=SMALLTEXT>Note: by clicking stop - all the logs which have an 'In Progress' status will be stopped being 	indexed</span>";

			//if coming from the pop up menu with a module Id then mark this modules logs.
			String moduleId = request.getParameter("MODULE_ID");
			if (moduleId != null) {
				Module mod = mgmt.getModuleFromId(moduleId);
				if (mod != null) {
					selectModuleLogs(mod, modulesMap, logsMap);
				}
			}

			%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/tree/rightClickMenu.js"></script>
<jsp:include page="../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script>

function run(){
	updateSelected();
  document.access.submit();
}

function refresh(){
  this.location = this.location;
}

function refreshStatus(){
  frames['statusFrame'].document.location = frames['statusFrame'].document.location;
}

function updateStaus(){
  <% if (status != null) {%>
  var frm = frames['statusFrame'];
  if (frm){
	  var message = frm.msg;
	  if (message){
	  	var statMsg = document.getElementById("statusMsg");
	  	if (statMsg){
		    statMsg.innerHTML = "Status: " + message;
	  	}
	    setTimeout('refreshStatus()',2000); 
	  }else {
	    refresh();
	  }
  }
  <%}%>
}

	function updateSelected(){
		list = tree.getAllChecked();
		arr = list.split(",");
	  var logsStr = "";
	  var modsStr = "";
		for (var i=0; i<arr.length; i++){
			s = arr[i];
			ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				type = s.substring(0,ind);
				id = s.substring(ind+1,s.length);
				if (type == "<%=XpoLogObjectTypes.MODULE_TYPE%>"){
					if (modsStr != ""){
						modsStr += ",";
					}
					modsStr += id;
					if (tree.hasChildren(s) && tree.hasChildren(s)==true){
	 				modsStr += "*";
					}
				}else{
					if (logsStr != ""){
						logsStr += ",";
					}
					logsStr += id;
				}
			}
		}
		document.access.mods.value = modsStr;
		document.access.logs.value = logsStr;
	}

</script>
</head>
<body style="padding:0px;margin:0px">

<form AUTOCOMPLETE="OFF" id="access" name="access" METHOD="POST" ACTION="searchEngineIndexingAction.jsp" style="padding:0px;margin:0px">
<input type="hidden" name="op" value="<%=!isRunning ? "run" : "stop"%>">
<input type="hidden" name="mods">
<input type="hidden" name="logs">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
              <tr>
                <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="53%" class="TOPBORDER" height="0">
                <span class="PAGEHEADER">Search Engine Indexing</span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <%if (status != null) {%>
                   <tr>
                    <td>
                    <span id="statusMsg" class="INFORMATIONMESSAGE">Status: <%=status%></span>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%"><a href="javascript:refresh()" class="LINK">refresh</a></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <%}%>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Indexed Logs</span><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td>                    
                    <%if (!isRunning) {%>
                    	<%=runMessage%>
                    <%} else {%>
											<%=stopMessage%>
										<%}%>
                    </td>
                  </tr>
                  
                  <tr>
                    <td>
                    <span class="REGULARTEXT"></span>
                    </td>
                  </tr>
									<tr>
										<td valign="top">
											<div id="loadingDiv" style="display:none">
												<span class="REGULARTEXT">Loading...</span>
											</div>
										</td>
									</tr>
                  <tr>
                    <td width="15%">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
											<tr>
												<td valign="top">
													<div id="treeboxbox_tree"></div>
												</td>
											</tr>
										</table>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                  
                  <tr>
                    <td>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="30%">&nbsp;</td>
            <td width="31%" align="center">
              <table border="0" width="109%">
                <tr>
                  <td width="24%"><a href="<%=BASE_DIRECTORY%>search/view/search.jsp" class="LINK">cancel</a></td>                  
                  <td width="40%"><a href="javascript:run()" class="LINK"><%=!isRunning ? "run" : "stop"%></a></td>
                  <td width="36%"><a href=javascript:openHelp('<%=BASE_DIRECTORY%>',"SearchEngineAdmin.htm") class="LINK">help</a></td>
                </tr>
              </table>
            </td>
            <td width="39%">&nbsp;<iframe name="statusFrame" style="visibility:hidden" onload="javascript:updateStaus();" src="indexingStatus.jsp" width="0" height="0" ></iframe>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>

</form>
<script>
	tree=new dhtmlXTreeObject("treeboxbox_tree","100%","100%","0");
	tree.setImagePath("<%=BASE_DIRECTORY%>");
	tree.setIconSize(13,13);
	tree.enableTreeLines(false);
	tree.setOnLoadingStart(startLoading);
	tree.setOnLoadingEnd(endLoading);
	tree.enableCheckBoxes(1);
	tree.enableThreeStateCheckboxes(true);
	tree.setXMLAutoLoading("searchEngineModuleTreeXML.jsp?usingIndex=true&showIndexingInfo=true");
	tree.loadXML("searchEngineModuleTreeXML.jsp?usingIndex=true&showIndexingInfo=true");
</script>
</body>

</html>