<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.SearchEngineAdminHelper"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.scheduler.ui.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.remote.*"%>

<%@ page import="java.util.*"%>

<%! 
	static final String BASE_DIRECTORY = "../";
%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  
  boolean execute = false;
  
  String title = "Search Engine Management";
  boolean allowLogSelection = manager.checkForPermission(request,response,SearchEnginePermissionConstants.AdministrationPermissions.LOGS_SELECTION_PERMISSION,false);
  boolean allowAdminSettings = manager.checkForPermission(request,response,SearchEnginePermissionConstants.AdministrationPermissions.ADMIN_SETTINGS_PERMISSION,false);

 
%>


<html>

<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<meta http-equiv="Content-Language" content="en-us">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/tree/rightClickMenu.js"></script>
<jsp:include page="../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<script src="<%=BASE_DIRECTORY%>scripts/comps/divsTabs.js" type="text/javascript"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script>
	function doNext(operation){
		updateSelected();
		document.access.action = "searchEngineManagerAction.jsp";
		document.access.submit();
	}
	
	function updateSelected(){
		list = tree.getAllChecked();
		arr = list.split(",");
	  var logsStr = "";
	  var modsStr = "";
		for (var i=0; i<arr.length; i++){
			s = arr[i];
			ind = s.indexOf("-");
			if (ind == -1){
				continue;
			}else{
				type = s.substring(0,ind);
				id = s.substring(ind+1,s.length);
				if (type == "<%=XpoLogObjectTypes.MODULE_TYPE%>"){
					if (modsStr != ""){
						modsStr += ",";
					}
					modsStr += id;
					if (tree.hasChildren(s) && (tree.hasChildren(s)+"") == "true"){
	 					modsStr += "*";
					}
				}else{
					if (logsStr != ""){
						logsStr += ",";
					}
					logsStr += id;
				}
			}
		}
		document.access.mods.value = modsStr;
		document.access.logs.value = logsStr;
	}
	
	function showHideIdexingPathAdvanced(){
		show = document.getElementById("advanced").style.display == "";
		if(show){
			document.getElementById("advanced").style.display  = "none";
			document.getElementById("advancedLink").style.display  = "";
			document.getElementById("hideAdvancedLink").style.display  = "none";
		}else{
			document.getElementById("advancedLink").style.display  = "none";
			document.getElementById("advanced").style.display = "";
			document.getElementById("hideAdvancedLink").style.display = "";
		}
	}
	
	
	
	
</script>
</head>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="POST">
<input type="hidden" name="mods">
<input type="hidden" name="logs">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
              <tr>
                <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="53%" class="TOPBORDER" height="0">
                <span class="PAGEHEADER"><%=title%></span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr><td>&nbsp;</td></tr>
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">                
                <script>
                  var applicationTabs = createDefaultApplicationTabs("searchEngineTabs");
                  <%if (allowLogSelection){%>
                  applicationTabs.addTab("Logs","<nobr>Logs Selection</nobr>","logsSelectionDiv");
                  <%}%>
                  <%if (allowAdminSettings){%>
                  applicationTabs.addTab("scheduler","<nobr>Global Scheduler</nobr>","schedulerDiv");
                  applicationTabs.addTab("deltaScheduler","<nobr>Delta Scheduler</nobr>","deltaSchedulerDiv");
                  applicationTabs.addTab("general","<nobr>General</nobr>","generalDiv");
                  <%}%>
                 </script>     
                  <tr>
                    <td width="100%">  
                    <%if (allowLogSelection || allowAdminSettings) {%>
                    <script>applicationTabs.writeTabs();</script> 
                    <%}%>
                     </td>
                   </tr>  
                   <tr>
                   <td width="100%" >   
                     <div id="logsSelectionDiv" style="display:none">
                     		<jsp:include page="searchEngineLogsIndexing.jsp" flush="true" />
                     </div>
                     <div id="schedulerDiv" style="display:none">
                     		<jsp:include page="searchEngineScheduler.jsp" flush="true" />
                     </div>
                     <div id="deltaSchedulerDiv" style="display:none">
                     		<jsp:include page="searchEngineIncrScheduler.jsp" flush="true" />
                     </div>
                     <div id="generalDiv" style="display:none">
                     		<jsp:include page="searchEngineGeneral.jsp" flush="true" />
                     </div>
                    </td>
                    </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                   <script>                 
                  applicationTabs.selectTabByIndex(0);
                  </script>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="101%" id="AutoNumber17">
                      <tr>
                        <td width="14%">&nbsp;</td>
                        <td width="13%">
                        <p align="center">&nbsp;</td>
                        <td width="11%"><a href="<%=BASE_DIRECTORY%>search/view/search.jsp" class="LINK">cancel</a></td>                        
                        
                        <td width="11%"><a href="javascript:doNext('save')" class="LINK">save</a></td>
                        
                        <td width="35%"><a href=javascript:openHelp('<%=BASE_DIRECTORY%>',"SearchEngineAdmin.htm") class="LINK">help</a></td>
                        <td width="35%">&nbsp;</td>
                      </tr>
                    </table>
        </td>
      </tr>
      
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>

</body>
</html>