<%@ page language="java"%>
<%@page import="xpolog.eye.data.index.adapters.defaultadapter.*"%>
<%@page import="xpolog.eye.data.index.*"%>
<%@ page import="xpolog.eye.data.index.adapters.IndexAdapter"%>
<%@ page import="xpolog.eye.site.ui.tree.*"%>
<%@ page import="xpolog.eye.data.index.SearchEngineManager"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.util.*"%>

<%
	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	SiteAdministrator admin = SiteManagment.getAdminInstance();
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
	
  SearchEngineManager searchEngineMgr = SearchEngineManager.getInstance();
	HashMap logsMap = (HashMap)request.getSession().getAttribute("searchLogs");
	HashMap modulesMap = (HashMap)request.getSession().getAttribute("searchModules");
	
  boolean usingIndex = true;
  boolean textIndexed = true;
	boolean all = true;
	String searchEngineManagementStr = request.getParameter("searchEngineManagement");
	boolean searchEngineManagement = searchEngineManagementStr != null && searchEngineManagementStr.equals("true");
	String showIndexingInfoStr = request.getParameter("showIndexingInfo");
	boolean showIndexingInfo = showIndexingInfoStr != null && showIndexingInfoStr.equals("true");
	boolean treeNodeExists = false;

	if (searchEngineManagement){
		logsMap = searchEngineMgr.getLogs();
		modulesMap = searchEngineMgr.getModules();
	}
	HashMap selectedLogs = new HashMap();
	
	String treeXml = ""; 
  String id = request.getParameter("id");
  if (id != null){
  	String modid = id;
  	int ind = id.indexOf("-");
  	if (ind != -1){
  		modid = id.substring(ind+1);
  	}
		curmod = SiteManagment.getInstance().getModuleFromId(modid);
		treeNodeExists = true;
  }
  
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);  	
	UserSearches userSearches = env.getUserSearches();
	SearchResults results = null;
	UserSearch userSearch = userSearches.getLastSearch();
	if (userSearch != null){
		results = userSearch.getResults();
  }
    
  for (int i=0; results!= null && i< results.length(); i++){
    LogSearchResult result = (LogSearchResult)results.getResult(i);
    String logId = result.getLogId();
    if (logsMap == null){
    	logsMap = new HashMap();
    }
    logsMap.put(logId,logId);
    Module member = null;
    if (modulesMap == null){
    	modulesMap = new HashMap();
    }
    try {
    	member = mgmt.getParentModule(logId);
    	while(member != null){
    		if (modulesMap.containsKey(member)){
    			break;
    		}
    		modulesMap.put(member.getId(),member.getId());
    		member = mgmt.getParentModule(member.getId());
    	}
    }catch (Exception e){}
  }
  
	
	if (curmod != null){
		SearchEngineModuleMemberRenderer renderer = new SearchEngineModuleMemberRenderer(curmod, userContext, modulesMap, logsMap, true, false, treeNodeExists);
		//treeXml = SearchEngineAdminHelper.getTreeXML(
		//		curmod, userContext, modulesMap, logsMap, true, false, treeNodeExists, null, null, usingIndex, textIndexed, all, searchEngineManagement, showIndexingInfo);
		renderer.setShowRootModule(false);
	//renderer.setSelectedModules(modulesMap);
		if (selectedLogs.size() > 0){
			renderer.setSelectedLogs(selectedLogs);
		}
		IndexAdapter indexer = SearchEngineManager.getInstance().getDefaultIndexAdapter();
		renderer.setIndexer(indexer);
		renderer.setUsingIndex(usingIndex);
		renderer.setTextIndexed(textIndexed);
		renderer.setAll(all);
		renderer.setSearchEngineManagement(searchEngineManagement);
		renderer.setShowIndexingInfo(showIndexingInfo);
		treeXml = renderer.getTreeXML();
	}
	
	response.setContentType("text/xml");
	out.write(treeXml);
	out.flush();
%>