<%@ page language="java"%>

<%@ page import="java.text.NumberFormat"%>
<%@ page import="java.util.ArrayList"%>

<%@ page import="xpolog.eye.search.SearchModel"%>
<%@ page import="xpolog.eye.search.SearchResult"%>
<%@ page import="xpolog.eye.search.SearchResultLogInfo"%>
<%@ page import="xpolog.eye.search.ui.SearchResultElement"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
String SEARCH_MODEL = "SearchModel";

SearchModel model = (SearchModel)session.getAttribute(SEARCH_MODEL);

String isEmbededStr = request.getParameter("isEmbeded");
boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");

SearchResult currentResult = (SearchResult)request.getAttribute("currentResult");
SearchResultElement rootNodeResultElement = (SearchResultElement)request.getAttribute("rootNodeResultElement");
ArrayList resultElements = rootNodeResultElement.getResultElements();
long numOfResults = resultElements.size();
String name = "Matching Log Events";
String tooltipHeaderDateString = (String)request.getAttribute("tooltipHeaderDateString");
String startDateString = (String)request.getAttribute("startDateString");
startDateString += ":00";
String endDateString = (String)request.getAttribute("endDateString");
endDateString += ":00";
String bgSuffix = (String)request.getAttribute("bgSuffix");

Long rootTotalEventsLong = (Long)request.getAttribute("rootTotalEvents");
long rootTotalEvents = -1;
if(rootTotalEventsLong != null) {
	rootTotalEvents = rootTotalEventsLong.longValue();
	if(rootTotalEvents == -1) {
		rootTotalEvents = 0;
	}
}

NumberFormat numberFormat = NumberFormat.getNumberInstance();
numberFormat.setMaximumFractionDigits(2);

if(isEmbeded) {
	out.print("<![CDATA[");
}
%>

<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%" id="dashboardGraphTooltipTable">
	<tr height="6px">
		<td class="SEARCH_GRAPH_TOOLTIP_HEADER_LEFT_CELL_BG_<%=bgSuffix %>"></td>
		<td class="SEARCH_GRAPH_TOOLTIP_TOP_FILLER_CELL_BG_<%=bgSuffix %>"></td>
		<td class="SEARCH_GRAPH_TOOLTIP_HEADER_RIGHT_CELL_BG_<%=bgSuffix %>"></td>
	</tr>
	<tr height="10px">
		<td class="SEARCH_GRAPH_TOOLTIP_LEFT_FILLER_CELL_BG_<%=bgSuffix %>"></td>
		<td class="SEARCH_GRAPH_TOOLTIP_FILLER_CELL_BG_<%=bgSuffix %> SEARCH_GRAPH_TOOLTIP_HEADER_CELL">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr>
					<td class="SEARCH_GRAPH_TOOLTIP_HEADER"><%=name %></td>
				</tr>
				<tr>
					<td class="SEARCH_GRAPH_TOOLTIP_HEADER"><%=tooltipHeaderDateString.toString() %></td>
				</tr>
			</table>
		</td>
		<td class="SEARCH_GRAPH_TOOLTIP_RIGHT_FILLER_CELL_BG_<%=bgSuffix %>"></td>
	</tr>
	<tr height="*">
		<td class="SEARCH_GRAPH_TOOLTIP_LEFT_FILLER_CELL_BG_<%=bgSuffix %>"></td>
		<td class="SEARCH_GRAPH_TOOLTIP_BODY_CENTER_CELL_BG_<%=bgSuffix %> SEARCH_GRAPH_TOOLTIP_BODY_CELL">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr height="10px">
					<td class="SEARCH_GRAPH_TOOLTIP_BODY_TABLE_CELL SEARCH_GRAPH_TOOLTIP_BODY_HEADER_CELL">Log</td>
					<td class="SEARCH_GRAPH_TOOLTIP_BODY_TABLE_CELL SEARCH_GRAPH_TOOLTIP_BODY_HEADER_CELL">Matching Events</td>
					<td class="SEARCH_GRAPH_TOOLTIP_BODY_TABLE_CELL SEARCH_GRAPH_TOOLTIP_BODY_HEADER_CELL"></td>
				</tr>
				<%
				String memberId, memberIdForJavaScript = null, memberName, memberType;
				String memberLink = null, zoomInMmouseActionsString = null, zoomInMmouseActionsStringMessage = null;
				long memberTotal;
				String rowClassName = null;
				
				SearchResultElement resultElement = null;
				if(numOfResults > 0) {
					for(int i = 0; i < numOfResults; i++) {
						resultElement = (SearchResultElement)resultElements.get(i);
						
						memberId = resultElement.getId();
						memberIdForJavaScript = memberId;
						memberIdForJavaScript = XpologUtil.updateAsHtmlString(memberIdForJavaScript);
						memberIdForJavaScript = XpologUtil.replaceAll(memberIdForJavaScript, "'", "\\'");
						memberName = resultElement.getName();
						memberName = XpologUtil.updateAsHtmlString(memberName);
						//memberName = HealthViewHelper.adjustTooltipName(memberName);
						memberType = resultElement.getType();
						
						String rowId = "tooltipRow_" + i;
						
						SearchResultLogInfo logInfo = currentResult.getLogInfo(memberId);
						String searchString = logInfo.getSearchString();
						searchString = XpologUtil.updateAsHtmlString(searchString);
						searchString = XpologUtil.replaceAll(searchString, "'", "\\'");
						
						memberLink = "javascript:openLogFromSearch('" + BASE_DIRECTORY + "','" + memberId + "', '" + searchString + "', 'true', document.getElementById('" + rowId + "'), false, '', '" + startDateString + "', '" + endDateString + "')";
						zoomInMmouseActionsStringMessage = "searchTooltips['showLog']";
						zoomInMmouseActionsString = "onMouseOver=\"javascript:showTooltip(" + zoomInMmouseActionsStringMessage + ")\" onMouseOut=\"javascript:hideTooltip()\"";
						
						memberTotal = resultElement.getSearchTermFrequency();
						
						if(i % 2 == 0) {
							rowClassName = "SEARCH_GRAPH_TOOLTIP_BODY_COLORED_ROW";
						}else {
							rowClassName = "SEARCH_GRAPH_TOOLTIP_BODY_REGULAR_ROW";
						}
				%>
					<tr class="<%=rowClassName %>" height="10px" id="<%=rowId%>">
						<td class="SEARCH_GRAPH_TOOLTIP_BODY_TABLE_CELL SEARCH_GRAPH_TOOLTIP_BODY_TABLE_NAME_CELL">
				<%
							if(memberLink != null) {
				%>
							<a href="<%=memberLink %>" class="SEARCH_GRAPH_TOOLTIP_BODY_TABLE_CELL_LINK" <%=zoomInMmouseActionsString %>>
				<%
							}
				%>
							<%=memberName %>
				<%
							if(memberLink != null) {
				%>
							</a>
				<%
							}
				%>
						</td>
						<td class="SEARCH_GRAPH_TOOLTIP_BODY_TABLE_CELL"><%=memberTotal %></td>
						<td class="SEARCH_GRAPH_TOOLTIP_BODY_TABLE_CELL">
				<%
							if(memberLink != null) {
				%>
							<a href="<%=memberLink %>" <%=zoomInMmouseActionsString %>><img src="<%=BASE_DIRECTORY %>images/search/graph/tooltipZoom.gif" border="0" onMouseOver="javascript:setImageSource(this, 'graph/tooltipZoomOver.gif')" onMouseOut="javascript:setImageSource(this, 'graph/tooltipZoom.gif')"></a>
				<%
							}
				%>
						</td>
					</tr>
				<%
					}
				}
				%>
				<tr>
					<td class="empty">&nbsp;</td>
				</tr>
			</table>
		</td>
		<td class="SEARCH_GRAPH_TOOLTIP_RIGHT_FILLER_CELL_BG_<%=bgSuffix %>"></td>
	</tr>
	<tr height="6px">
		<td class="SEARCH_GRAPH_TOOLTIP_FOOTER_LEFT_CELL_BG_<%=bgSuffix %>"></td>
		<td class="SEARCH_GRAPH_TOOLTIP_BOTTOM_FILLER_CELL_BG_<%=bgSuffix %>">&nbsp;</td>
		<td class="SEARCH_GRAPH_TOOLTIP_FOOTER_RIGHT_CELL_BG_<%=bgSuffix %>"></td>
	</tr>
</table>
<%
if(isEmbeded) {
	out.print("]]>");
}
%>