function openLogFromSearch(baseDirectory,lbmId, searchString, newWindow, obj, hideDashboardButton, dataReference, searchMinDateFullStr, searchMaxDateFullStr) {
	openLogFromSearch0(baseDirectory,lbmId, searchString, searchMinDateFullStr, searchMaxDateFullStr, newWindow, obj, hideDashboardButton, dataReference);
}

function openLogFromSearch0(baseDirectory,lbmId, searchString, startTime, endTime, newWindow, obj, hideDashboardButton, dataReference) {
	var y = -1;
	if (obj){
		y = findPosY(obj);
		if (y <= 0){
			y = -1;
		}else {
			y = y - 60;
		}
	}

	if (searchString == ""){
		searchString = "NO_FILTER";
	}
	var ind = lbmId.indexOf("@");
	if (ind != -1){
		lbmId = lbmId.substring(ind + 1, lbmId.length);
	}

	var msgWriter = new messageWriter("mygridShowLogMessage","Log View",baseDirectory);
	msgWriter.setYParent(document.getElementById("mygrid"),50);
	msgWriter.width = 200;
	msgWriter.height = 60;
	msgWriter.setPosition(-1,y);
	msgWriter.showMessage("Loading Log...");     
	
	var filterName = "search: " + searchString;
	
	var opdirect = "ZOOM_IN_WITH_FILTER";
	if(!dataReference || dataReference == '') {
		opdirect = "START";
	}

	var params = "lbmId=" + encode(lbmId) + "&searchString=" + encode(searchString) + "&filterName=" + filterName + "&startTimeFullStr=" +encode(startTime) + "&endTimeFullStr=" + encode(endTime) + "&hideDashboardButton=" + hideDashboardButton + "&opdirect=" + opdirect + "&zoomInKey=" + dataReference;
	var page = baseDirectory + "common/showLogByQuery.jsp";
	sendAjaxRequest(page,function(req){
		hideLayer('mygridShowLogMessage');
		var xmldoc = req.responseXML.documentElement;
		if(xmldoc) {
			var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
			var message = xmldoc.getElementsByTagName('message')[0].text;
			if (result == "true"){			  
				var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
	
				openShowLogWindow(baseDirectory + message,true,baseDirectory,y);        						              
			}else if (xmldoc.getElementsByTagName('message')[0].firstChild){
				var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
				msgWriter = new messageWriter("mygridShowLogMessage","Log View",baseDirectory);
				msgWriter.addAction("OK","javascript:hideLayer('mygridShowLogMessage')");    	  	
				msgWriter.setMsgClass("ERRORMESSAGE_LIGHT");
				msgWriter.setPosition(-1,y);
				msgWriter.showMessage(message);	                
			}
		}
	},'POST',params,true);
}


function openShowLogWindow(url,showMessage,baseDirectory,y){
	var winW = 1280, winH = 1024;
	var size = getWidthAndHeight();
	if (size && size.length == 2){
		winW = size[0];
		winH = size[1];
	}
	
	var windowName = isChrome() ? "" : "_new";
	newWindow = window.open(url,windowName,"height="+winH+",width="+winW+",resizable=yes,scrollbars=yes,status=yes,left=20,top=20");
	
	if(showMessage) {
		PopupWarning.init(baseDirectory);
		setTimeout("popupWait('" + url + "'," + showMessage + ",'" + baseDirectory + "'," + y + ")", 500);
	}else {
		afterPopupWait(url,showMessage,baseDirectory,y);
	}
	
}

function popupWait(url,showMessage,baseDirectory,y) {
	if(PopupWarning.is_running()) {
		setTimeout("popupWait('" + url + "'," + showMessage + ",'" + baseDirectory + "'," + y + ")", 500);
	}else {
		afterPopupWait(url,showMessage,baseDirectory,y);
	}
}

function afterPopupWait(url,showMessage,baseDirectory,y) {
	if(PopupWarning.is_blocked() && showMessage) {
		var message = "Pop-up blocked. To see this pop-up click Continue.";
		msgWriter = new messageWriter("mygridShowLogMessage","Log View",baseDirectory);
		msgWriter.addAction("Continue","javascript:openShowLogWindowContinue('" + url + "','" + baseDirectory + "'," + y + ")");
		msgWriter.addAction("Close","javascript:hideLayer('mygridShowLogMessage')");
		msgWriter.setMsgClass("ERRORMESSAGE_LIGHT");
		msgWriter.setPosition(-1,y);
		msgWriter.showMessage(message);
	}else {
		newWindow.focus();
	}
}

function openShowLogWindowContinue(url,baseDirectory,y){
	hideLayer('mygridShowLogMessage');
	openShowLogWindow(url,false,baseDirectory,y);
}

function openDashboardFromSearch(baseDirectory, objectType, objectId, startTime, endTime) {
	var selectedCompId = "Analytics";
	if (analyticsComponentId){
		selectedCompId = analyticsComponentId;
	}
	var url = baseDirectory + "componentAction.jsp?selectedCompId=" + selectedCompId + "&forward=root.jsp?mainPage=dashboard/view/loadObjectDashboardModel.jsp%253F";
	
	var params = "";
	params += ("objectType=" + objectType);
	params += ("&objectId=" + objectId);
	params += ("&startTime=" + startTime);
	params += ("&endTime=" + endTime);
	params = params.replace(/&/gi, "%26");
	params = params.replace(/%/gi, "%25");
	
	url += params;
	
	parent.document.location = url;
}