<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.search.SearchContext"%>
<%@ page import="xpolog.eye.search.SearchHistory"%>
<%@ page import="xpolog.eye.search.SearchModel"%>
<%@ page import="xpolog.eye.security.SearchEnginePermissionConstants"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.util.WebUtil"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>

<%!
static final String BASE_DIRECTORY = "../../";

%>

<%
int maxCurrentNodeNameLength = 20;
int MAX_SEARCHES_TO_DISPLAY = Configuration.getInstance().getPropertiesManager().getPropertyAsInt("xpolog.eye.search.ui.widget.maxSearchesToDisplay", 10);

String SEARCH_MODEL = "SearchModel";

SearchModel model = (SearchModel) session.getAttribute(SEARCH_MODEL);

String viewBy = model.getViewBy();

String windowWidthStr = request.getParameter("windowWidth");
int windowWidth = windowWidthStr != null && windowWidthStr.length() > 0 ? Integer.parseInt(windowWidthStr) : -1;

String currentNodeName = model.getCurrentNodeName();
String currentNodeTooltip = null;
String currentNodeToolipCluase = "";
if(currentNodeName.length() > maxCurrentNodeNameLength && windowWidth != -1 && windowWidth < 1100) {
	currentNodeTooltip = currentNodeName;
	currentNodeToolipCluase = "onMouseOver=\"javascript:showTooltip('" + currentNodeTooltip + "')\" onMouseOut=\"hideTooltip()\"";
	currentNodeName = currentNodeName.substring(0, maxCurrentNodeNameLength);
	currentNodeName += "...";
}

boolean isRoot = model.getCurrentNode().getId().equals(SearchContext.ROOT_NODE_ID);
boolean enableFoldersAndLogs = isRoot || viewBy.equals(SearchContext.VIEW_BY_FOLDERS);
boolean enableApplications = isRoot || viewBy.equals(SearchContext.VIEW_BY_APPLICATIONS);
boolean enableServers = isRoot || viewBy.equals(SearchContext.VIEW_BY_SERVERS);

boolean showZoomOut = model.getZoomInDateFilters().size() > 0;

String searchTerm = model.getSearchTerm();
if(searchTerm == null) {
	searchTerm = "";
}
searchTerm = WebUtil.doHTMLEncoding(searchTerm);

boolean isEmptySearch = searchTerm.length() == 0;

boolean allowSaveSearches = WebSecurityManager.getInstance().checkForPermission(request,response,SearchEnginePermissionConstants.AdministrationPermissions.SAVE_SEARCHES_PERMISSION,false);

response.setContentType("text/html; charset=UTF-8");
%>

<form AUTOCOMPLETE="OFF" id="searchHeaderForm" name="searchHeaderForm" method="POST" class="SEARCH_FORM">
<div id="searchHeaderParentDiv" style="height:100%; width:100%;">
<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
	<tr>
		<td>
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr height="10px">
					<td id="searchHeaderCell">
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td class="SEARCH_HEADER_TITLE">
									<span class="SEARCH_HEADER_TITLE_BOLD">XpoLog Center</span> Search Engine
								</td>
								<td class="sep">&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
				
				<tr height="10px">
					<td>
						<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							<tr>
								<td class="SEARCH_HEADER_LEFT_CELL">&nbsp;</td>
								<td class="SEARCH_HEADER_MAIN_CELL">
									<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
										<tr>
											<td class="SEARCH_HEADER_LEFT_PADDER_CELL">&nbsp;</td>
											<td>
												<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
													<tr><td>&nbsp;</td></tr>
													<tr height="26px">
														<td id="searchHeaderTextBoxCell" class="SEARCH_HEADER_TEXT_BOX_CELL">
															<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
																<tr>
																	<td class="SEARCH_HEADER_TEXT_BOX_PROGRESS_INDICATOR_CELL">
																		<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
																			<tr>
																				<td id="searchInProgressTd" style="display:none;padding-top:2px;"><img id="searchInProgressImage" src="<%=BASE_DIRECTORY %>images/search/header/searchInProgress.gif" border="0" onMouseOver="javascript:showTooltip(searchTooltips['searchInProgress'])" onMouseOut="javascript:hideTooltip()"></td>
																				<td id="searchCompletedTd" style="display:none;padding-top:2px;"><img src="<%=BASE_DIRECTORY %>images/search/header/searchCompleted.gif" border="0" onMouseOver="javascript:showTooltip(searchTooltips['searchCompleted'])" onMouseOut="javascript:hideTooltip()"></td>
																			</tr>
																		</table>
																	</td>
																	<td class="SEARCH_HEADER_TEXT_BOX_TEXT_CELL">
																		<input class="SEARCH_HEADER_TEXT_BOX" type="text" id="searchTerm" name="searchTerm" value="<%=searchTerm%>" onKeyPress="javascript: hideFloatingDiv('searchErrorQueryDiv'); return doCheckSearch(event)">
																	</td>
																	<td class="SEARCH_HEADER_TEXT_BOX_SAVED_SEARCHES_CELL">
																		<%if(allowSaveSearches) { %>
																		<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
																			<tr>
																				<td class="SEARCH_HEADER_TEXT_BOX_SAVE_SEARCH_CELL">
																					<%if(searchTerm.length() == 0 || model.isErrorQuery()) { %>
																						<img src="<%=BASE_DIRECTORY %>images/search/header/buttonSaveSearch.gif" border="0"></img>
																					<%}else { %>
																						<a href="javascript:showSaveSearchDiv()" onMouseOver="javascript:showTooltip(searchTooltips['saveSearch'])" onMouseOut="javascript:hideTooltip()"><img src="<%=BASE_DIRECTORY %>images/search/header/buttonSaveSearch.gif" onMouseOver="javascript:setImageSource(this, 'header/buttonSaveSearchOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/buttonSaveSearch.gif')" border="0"></img></a>
																					<%} %>
																				</td>
																			</tr>
																		</table>
																		<%} %>
																	</td>
																	<td class="SEARCH_HEADER_SAVED_SEARCHES_ARROW_CELL">
																		<a id="searchDivsLink" href="javascript:openSearchDivs('<%=isEmptySearch %>')" style="padding-bottom: 3px;"><img src="<%=BASE_DIRECTORY %>images/search/header/fixedIntervalsOpen.gif" border="0" onMouseOver="javascript:showTooltip(searchTooltips['openSavedSearchesList'])" onMouseOut="javascript:hideTooltip()"></a>
																	</td>
																</tr>
															</table>
															<div id="searchDivsContainer" class="SEARCH_DIVS_CONTAINER" style="display:none">
															<div style="padding:2px;">
																<ul class="SEARCH_DIVS_TABS">
																	<li id="searchHistoryDivLink"><a href="#searchHistoryDiv">Search History</a></li>
																  <li id="savedSearchesDivLink"><a href="#savedSearchesDiv">Saved Searches</a></li>
																  <li id="searchSyntaxDivLink"><a href="#searchSyntaxDiv">Simple Search Syntax</a></li>
																  <li id="complexSyntaxDivLink"><a href="#complexSyntaxDiv">Complex Search Syntax</a></li>
																</ul>
																<div class="SEARCH_DIVS_TAB_CONTAINER">
															    <div id="searchHistoryDiv" class="SEARCH_DIVS_TAB_CONTENT">
															       <table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
																			<tr height="10px">
																				<jsp:include page="searchHistoryWidget.jsp" flush="true">
																					<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
																					<jsp:param name="sortBy" value="<%=SearchHistory.SORT_BY_TIMESTAMP %>" />
																					<jsp:param name="maxSearchesToDisplay" value="<%=MAX_SEARCHES_TO_DISPLAY %>" />
																				</jsp:include>
																			</tr>
																			<tr height="10px">
																				<jsp:include page="searchHistoryWidget.jsp" flush="true">
																					<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
																					<jsp:param name="sortBy" value="<%=SearchHistory.SORT_BY_EXECUTIONS %>" />
																					<jsp:param name="maxSearchesToDisplay" value="<%=MAX_SEARCHES_TO_DISPLAY %>" />
																				</jsp:include>
																			</tr>
																		</table>
															    </div>
															    <div id="savedSearchesDiv" class="SEARCH_DIVS_TAB_CONTENT">
															      <jsp:include page="savedSearchesDivContent.jsp" flush="true" />
															    </div>
															    <div id="searchSyntaxDiv" class="SEARCH_DIVS_TAB_CONTENT">
															    	<jsp:include page="searchSyntax.html" flush="true" />
															    </div>
															    <div id="complexSyntaxDiv" class="SEARCH_DIVS_TAB_CONTENT">
															    	<jsp:include page="complexSyntax.html" flush="true" />
															    </div>
																</div>
															</div>
															</div>
														</td>
													</tr>
													<tr><td>&nbsp;</td></tr>
												</table>
											</td>
											<td class="SEARCH_HEADER_PADDER_CELL">&nbsp;</td>
											<td class="SEARCH_HEADER_CALENDAR_CELL">
												<jsp:include page="searchCalendar.jsp" flush="true" />
											</td>
											<td class="SEARCH_HEADER_PADDER_CELL">&nbsp;</td>
											<td class="SEARCH_HEADER_GO_BUTTON_CELL">
												<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
													<tr><td>&nbsp;</td></tr>
													<tr>
														<td class="SEARCH_HEADER_GO_BUTTON_INNER_CELL">
															<a href="javascript:doSearch()"><img src="../../images/search/header/buttonGoSearch.gif" onMouseOver="javascript:setImageSource(this, 'header/buttonGoSearchOver.gif')" onMouseOut="javascript:setImageSource(this, 'header/buttonGoSearch.gif')" border="0"></img></a>
														</td>
													</tr>
													<tr><td>&nbsp;</td></tr>
												</table>
											</td>
											<td class="SEARCH_HEADER_RIGHT_PADDER_CELL">&nbsp;</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
</table>
</div>
</form>