<%@ page language="java"%>

<%@ page import="java.util.Date"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.eye.search.SearchHistory"%>
<%@ page import="xpolog.eye.search.SearchHistoryManager"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.util.DateUtil"%>
<%@ page import="xpolog.eye.util.WebUtil"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>

<%
String baseDirectory = request.getParameter("baseDirectory");
if(baseDirectory == null) {
	baseDirectory = BASE_DIRECTORY;
}

String sortBy = request.getParameter("sortBy");
if(sortBy == null || sortBy.length() == 0) {
	sortBy = SearchHistory.SORT_BY_TIMESTAMP;
}

String maxSearchesToDisplayStr = request.getParameter("maxSearchesToDisplay");
int maxSearchesToDisplay = 5;
try {
	maxSearchesToDisplay = Integer.parseInt(maxSearchesToDisplayStr);
}catch(Exception e) {
	maxSearchesToDisplay = 5;
}

UserContext userContext = UserEnvironment.getUserContext(request);
SearchHistoryManager searchHistoryManager = SearchHistoryManager.getInstance();
List searchHistoryList = null;
if(sortBy.equals(SearchHistory.SORT_BY_TIMESTAMP)) {
	searchHistoryList = searchHistoryManager.getSearchHistoryListByTimestamp(userContext);
}else if(sortBy.equals(SearchHistory.SORT_BY_EXECUTIONS)) {
	searchHistoryList = searchHistoryManager.getSearchHistoryListByExecutions(userContext);
}

final int SEARCH_TERM_MAX_LENGTH = 50;

response.setContentType("text/html; charset=UTF-8");
%>

<td class="SEARCH_HISTORY_WIDGET_TOP_CELL">
	<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
		<tr height="10px">
			<td>
				<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
					<%
					String widgetTitle = "Recent Searches";
					if(sortBy.equals(SearchHistory.SORT_BY_EXECUTIONS)) {
						widgetTitle = "Popular Searches";
					}
					%>
					<tr height="10px">
						<td class="SEARCH_WIDGET_SUB_TITLE_CELL"><%=widgetTitle %></td>
					</tr>
					<tr>
						<td>
							<hr class="SEARCH_WIDGET_SUB_TITLE_LINE"></hr>
						</td>
					</tr>
					<%if(searchHistoryList != null && searchHistoryList.size() > 0) { %>
					<tr>
						<td class="SEARCH_HISTORY_WIDGET_TABLE_CELL">
							<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
								<%
								String rowId = "";
								
								SearchHistory searchHistory = null;
								String searchTerm = null, scriptSearchTerm = null;
								for(int i = 0; i < searchHistoryList.size() && i < maxSearchesToDisplay; i++) {
									searchHistory = (SearchHistory)searchHistoryList.get(i);
									
									searchTerm = searchHistory.getSearchTerm();
									/*if(searchTerm.length() > SEARCH_TERM_MAX_LENGTH) {
										searchTerm = searchTerm.substring(0, SEARCH_TERM_MAX_LENGTH);
										searchTerm += "...";
									}*/
									searchTerm = WebUtil.doHTMLEncoding(searchTerm);
									scriptSearchTerm = searchTerm;
									scriptSearchTerm = XpologUtil.replaceAll(scriptSearchTerm, "\\", "\\\\");
									scriptSearchTerm = XpologUtil.replaceAll(scriptSearchTerm, "'", "\\'");
									
									rowId = sortBy + "topMessagesRow_" + i;
								%>
								<tr id="<%=rowId %>" height="10px">
									<td class="SEARCH_HISTORY_WIDGET_GENERAL_CELL">
										<a class="SEARCH_HISTORY_WIDGET_LINK" href="javascript:doSearchHistory('<%=scriptSearchTerm %>')"><%=searchTerm %></a>
									</td>
								</tr>
								<%
								}
								%>
								<tr>
									<td colspan="2">&nbsp;</td>
								</tr>
							</table>
						</td>
					</tr>
					<%}else { %>
					<tr height="10px">
						<td class="SEARCH_HISTORY_WIDGET_CELL">
							<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
								<tr>
									<td class="SEARCH_HISTORY_WIDGET_GENERAL_CELL SEARCH_HISTORY_WIDGET_HEADER_CELL">No searches were found</td>
								</tr>
								<tr>
									<td>&nbsp;</td>
								</tr>
							</table>
						</td>
					</tr>
					<tr>
						<td style="font-size: 0px; height: 0px;"></td>
					</tr>
					<%} %>
				</table>
			</td>
		</tr>
	</table>
</td>