<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.cert.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="java.security.cert.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
			if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.ToolsPermissions.EDIT_CERTIFICATES_PERMISSION,true)){
			    return;
			}
			String CERT_PATH = "certPath";
			String KEY_PATH = "keyPath";
			String ID = "id";
			String NAME = "name";
			String DESC = "desc";
			String PRIVATE_KEY_PWD = "pkpwd";
			String CERT_ALIAS = "certAlias";
			String PRV_KEY_ALIAS = "prvKeyAlias";
			String PKCS12PWD = "pkcs12pwd";
			String CURRENT_X509 = "currentX509";
			

			String ERROR_OBJ = "ERROR_OBJ";

			CertificatesManager cmgr = CertificatesManager.getInstance();
			String id = request.getParameter(ID);
			String name = request.getParameter(NAME);
			String desc = request.getParameter(DESC);
			String pkpwd = request.getParameter(PRIVATE_KEY_PWD);

			String pkcs12pwd = request.getParameter(PKCS12PWD);//cert.getPKCS12Password();
    		String prvKeyAlias = request.getParameter(PRV_KEY_ALIAS);//cert.getPrivateKeyAlias();
    		String certAlias = request.getParameter(CERT_ALIAS);//cert.getCertAlias();
    		
			//verify data
			ErrorModel errmodel = new ErrorModel();
			if (name == null || name.trim().equals("")) {
				errmodel.addError("Please provide a name for the certificate.");
			}
			if (pkpwd == null || pkpwd.trim().equals("")) {
				errmodel.addError("No Privtae key Password was supplied.");
			}
			if (pkcs12pwd == null || pkcs12pwd.trim().equals("")) {
				errmodel.addError("No key store Password was supplied.");
			}
			if (certAlias == null || certAlias.trim().equals("")) {
				errmodel.addError("Please provide certificate alias.");
			}
			if (prvKeyAlias == null || prvKeyAlias.trim().equals("")) {
				errmodel.addError("No Privtae key alais was supplied.");
			}
			
			
			if(desc == null){
				desc = "";
			}
		
			if (errmodel.getErrorCount() > 0) {
				request.getSession().setAttribute(ERROR_OBJ, errmodel);
				response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
				return;
			}
			
			
			XPLG509Certificate xplg509cert = null;
			if(id != null){
				xplg509cert = cmgr.getXPLG509CertificateById(id);
			}
			if(xplg509cert == null){
				xplg509cert = new XPLG509Certificate();
				xplg509cert.setId(id);
			}
			xplg509cert.setName(name);
			xplg509cert.setDescription(desc);
			xplg509cert.setKeyPassword(pkpwd);
			xplg509cert.setPKCS12Password(pkcs12pwd);
			xplg509cert.setPrivateKeyAlias(prvKeyAlias);
			xplg509cert.setCertAlias(certAlias);
			
			
			request.getSession().setAttribute(CURRENT_X509,xplg509cert);
			response.sendRedirect("certKeysAdmin.jsp");
		%>


