<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.SecurityPermissions.GENERAL_USER_SETTINGS_PERMISSION,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  String username = request.getParameter("username");
  ErrorModel errmodel = new ErrorModel();

  XpologUser user = null;
  if(username == null || username.trim().equals("")){
    errmodel.addError("No username was supplied.");
  }else {
    user = manager.getUser(security,username);
    if (user == null){
      errmodel.addError("No user with the same user name exists in the system.");
    }
  }

  String password = request.getParameter("password");
  if (password == null || password.trim().equals("")){
    password = null;
  }

  String displayName = request.getParameter("displayName");
  if (displayName == null || displayName.trim().equals("")){
    errmodel.addError("No Display Name was supplied.");
  }

  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			userContext, AuditConstants.CHANGE, "edit user details", AuditConstants.SECURITY, "edit user details " + displayName);	 	 	


   manager.fillXpologPrincipalParameters(user,username,displayName,"");
   manager.setUser(security,user,password);
   response.sendRedirect("addopok.jsp?managementType=userGeneral");

%>