<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.SecurityPermissions.EDIT_POLICIES_PERMISSION,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);

  XpologPolicy [] policies = XpologSecurityHelper.getPoliciesFromUser(security,true,true,true);
  Collection groupsCol = XpologSecurityHelper.getGroupsCollectionFromUser(security);
  HashSet groupsIds = new HashSet();
  if (groupsCol != null){
  	Iterator it = groupsCol.iterator();
  	while (it.hasNext()){
  		XpologGroup g = (XpologGroup)it.next();
  		groupsIds.add(g.getName());
  	}
  }

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>

function doDelete(name){
   this.location = "removeopcheck.jsp?managementType=policy&name="+name;
}
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access" style="padding:0;margin:0">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Policies</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>

                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td colspan="3">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr>
                        <td width="*" ><span class="HEADER">Policies</span></td>
                        <td width="150"  class="REGULARTEXT"><a href="policySettings.jsp" class="LINK">Add Policy</a></td>
                      </tr>
                      <tr>
                       <td colspan="2">&nbsp;</td>
                       </tr>
                      <tr class="TABLES_HEADERS">
                        <td width="*"><span class="REGULARTEXT">Name</span></td>
                        <td width="150" class="REGULARTEXT">&nbsp;</td>
                      </tr>
                      <tr>
                        <td width="*" class="SMALLTEXT">&nbsp;</td>
                        <td width="150" class="SMALLTEXT">&nbsp;</td>
                      </tr>
                      <%
			  String clas = "UNMARKITEM";
                          for(int i=0;i<policies.length;++i){
                            if((i%2) == 0){
                              clas = "UNMARKITEM";
                            }else{
                              clas = "MARKITEM";
                            }
                          %>
                            <tr class="<%=clas%>">



			  <td width="*"><span class="REGULARTEXT"><%=policies[i].getDisplayName()%></span></td>
                           <td width="150">
                          <%
	                        XpologPolicy policy = policies[i];
                          HashSet associatedGroupsIds = policy.getAssociatedGroups();
                          boolean policyOk = security.getUser().isAdmin();
                          if (!policyOk){
                          	HashSet set = (HashSet)groupsIds.clone();
                          	set.retainAll(associatedGroupsIds);
                          	policyOk = !set.isEmpty();
                          }	
                          	
                          if (policies[i].isEditable() && policyOk){
                          %>
                              <a href="policySettings.jsp?policyname=<%=policies[i].getName()%>" class="LINK">edit</a><span class="REGULARTEXT">&nbsp;&nbsp;</span>
                          <%}else{%>
                              <a href="policySettings.jsp?isViewOnly=true&policyname=<%=policies[i].getName()%>" class="LINK">View</a><span class="REGULARTEXT">&nbsp;&nbsp;</span>
                          <%}

                           if (policies[i].isDeletable() && policyOk){%>
                              <a href='javascript:doDelete("<%=policies[i].getName()%>")' class="LINK">delete</a>
                           <%}%>
                          </td>
                       </tr>
                      <%}%>
                    </table>
                   </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>
</html>