<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>

<%!


  String getTreeDiv(XpologSecurityManager.XpologPermissionGroup permissions,Collection actions, Collection availableActions){
    ArrayList list = new ArrayList();
    StringBuffer buffer = new StringBuffer();
    if (permissions != null){
      addChildseDiv(permissions,buffer,"0",actions,availableActions);
    }
    return buffer.toString();
  }

  void addChildseDiv(XpologSecurityManager.XpologPermissionGroup permissions,StringBuffer buffer, String parentKey,Collection actions,Collection availableActions){
    for (int i = 0; i < permissions.getPermissionsChildsCount(); i++) {
      XpologSecurityManager.XpologPermissionGroup child = permissions.getPermissionChildAt(i);
      String comp = child.getComponent();
      if (comp != null && comp.length() > 0){
        if (!SiteManagment.getInstance().getXpologManagment().isComponentLicenseValid(comp)){
          continue;
        }
      }
      if (availableActions != null && !child.getName().equals("All") && 
      		!containsAction(child,availableActions) && !parentContainsAction(child,availableActions)){
      	continue;
      }
      String key = parentKey + "_" + i;
      int num = child.getLevel() == 1 ? 0 : 20;
      buffer.append("\n<DIV style=\"margin-top:10px;margin-bottom:10px;margin-left:" + num + "pt\" id=\"PermissionDiv_");
      buffer.append(key);
      buffer.append("\">");
      buffer.append("<input type=\"checkbox\" name=\"PermissionIndex_" + key + "\" id=\"PermissionIndex_" + key + "\"" + (actions.contains(child.getName())?"checked":"") + " onClick=\"javascript:selectNode(this,'PermissionIndex_')\">");
      buffer.append("&nbsp;" + child.getDisplayName());
      addChildseDiv(child,buffer,key,actions,availableActions);
      buffer.append("\n</DIV>");
    }
  }
  
  boolean containsAction(XpologSecurityManager.XpologPermissionGroup permissions, Collection availableActions){
  	if (availableActions.contains(permissions.getName())){
  		return true;
  	}else{
  		for (int i = 0; i < permissions.getPermissionsChildsCount(); i++) {
  			XpologSecurityManager.XpologPermissionGroup child = permissions.getPermissionChildAt(i);
  			if (containsAction(child,availableActions)){
  				return true;
  			}
  		}
  	}
  	return false;
  }

  boolean parentContainsAction(XpologSecurityManager.XpologPermissionGroup permissions, Collection availableActions){
  	if (availableActions.contains(permissions.getName())){
  		return true;
  	}else{
  		XpologSecurityManager.XpologPermissionGroup parent = permissions.getParent();
  		if (parent == null){
  			return false;
  		}else{
  			return parentContainsAction(parent,availableActions);
  		}
  	}
  }


  String getTreeScript(XpologSecurityManager.XpologPermissionGroup permissions){
    ArrayList list = new ArrayList();
    StringBuffer buffer = new StringBuffer();
    if (permissions != null){
      addChildsScript(permissions,buffer,"0");
    }
    return buffer.toString();
  }

  void addChildsScript(XpologSecurityManager.XpologPermissionGroup permissions,StringBuffer buffer, String parentKey){
    for (int i = 0; i < permissions.getPermissionsChildsCount(); i++) {
      XpologSecurityManager.XpologPermissionGroup child = permissions.getPermissionChildAt(i);
      String key = parentKey + "_" + i;
      buffer.append("  NodesList[NodesList.length] = \"" + key + "\";\n");
      addChildsScript(child,buffer,key);
    }
  }


%>
<%
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.SecurityPermissions.EDIT_POLICIES_PERMISSION,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);
  boolean isAdmin = security.getUser().isAdmin();

  XpologSecurityManager.XpologPermissionGroup root = XpologSecurityManager.getInstance().getPermissionsRootGroup();

  String policyStr = request.getParameter("policyname");
  Collection actions = new HashSet();
  Collection availableActions = null;
  String policyname = "";
  String displayName = "";
  String description = "";
  boolean isEditMode = false;
  if (policyStr != null && policyStr.length() > 0){
    XpologPolicy policy = manager.getPolicy(security,policyStr);
    if (policy != null){
      isEditMode = true;
      policyname = policy.getName();
      displayName = policy.getDisplayName();
      description = policy.getDescription();
      actions = policy.getActions();
    }
  }
  if (!isAdmin){
  	XpologPolicy policy = XpologSecurityHelper.getMergedPolicyFromUser(security,true,true,false);
  	if (policy != null){
  		availableActions = policy.getActions();
  	}
  }

  String isViewOnlyStr = request.getParameter("isViewOnly");
  boolean isViewOnly = isViewOnlyStr != null && isViewOnlyStr.equals("true");

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>

  var NodesList = new Array();


<%=getTreeScript(root)%>


    function selectNode(node,preffix){
	selectChilds(node,preffix);
        if (!node.checked){
          selectParents(node,preffix);
        }
    }

    function selectChilds(node,preffix){
      var key = node.id.substring(preffix.length,node.id.length);
      for (var i = 0; i < NodesList.length; i++) {
        if (NodesList[i].indexOf(key) == 0){
          var n = document.getElementById(preffix + NodesList[i]);
          if (n){
	          n.checked = node.checked;
	        }
        }
      }

    }

    function selectParents(node,preffix){
      var key = node.id.substring(preffix.length,node.id.length);
      for (var i = 0; i < NodesList.length; i++) {
        if (key.indexOf(NodesList[i]) == 0){
          var n = document.getElementById(preffix + NodesList[i]);
          if (n){
	          n.checked = node.checked;
	        }
        }
      }

    }

    function init(){
       for (var i = NodesList.length; --i >= 0 ;) {
         var n = document.getElementById("PermissionIndex_" + NodesList[i]);
         if (n && n.checked){
            selectNode(n,"PermissionIndex_");
         }
       }
    }

function doSave(){
  document.access.submit();
}

function doReset(){
  this.location = "policySettings.jsp<%=isEditMode ? "?policyname=" + policyStr : ""%>";
}

function doCancel(){
  this.location = "policiesView.jsp";
}
</script>
</head>
<body onload="javascript:init();">
<form AUTOCOMPLETE="OFF" id="access" name="access" action="policySettingsAction.jsp" method="post" style="padding:0;margin:0">
<input type="hidden" name="isEditMode" value="<%=isEditMode%>">
<%if (isEditMode){%>
  <input type="hidden" name="policyname" value="<%=policyname%>">
<%}%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
              <tr>
                <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="53%" class="TOPBORDER" height="0">
                <span class="PAGEHEADER">Policy Settings</span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;</td>
                <td width="43%" height="100%">&nbsp;</td>
                <td width="50%" height="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">

			<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%"  height="100%">
                   <tr>
                   <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                                    <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Global</span><b>&nbsp;</b></td>
                  </tr>
 			<tr>
                    <td>
                    <font size="2">&nbsp;</font>
                    </td>
                  </tr>

                  <tr>
                    <td width="100%" height="18">
                      <table border="0" width="300">
                        <tr>
                          <td width="150"><span class="REGULARTEXT">Policy name:</span></td>
                          <td width="150">
                            <input type="text" class="TEXTBOX" name="policyname" size="20" value="<%=policyname%>" <%=isEditMode?"disabled":""%>>
                          </td>
                          </tr>
                         <tr>
                          <td width="150"><span class="REGULARTEXT">Display Name:</span></td>
                          <td width="150">
                            <input type="text" class="TEXTBOX" name="displayName" size="20" value="<%=displayName%>">
                          </td>
                          </tr>
                         <tr>
                          <td width="150"><span class="REGULARTEXT">Description:</span></td>
                          <td width="150">
                            <input type="text" class="TEXTBOX" name="description" size="20" value="<%=description%>">
                          </td>
                          </tr>


                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Permissions List</span><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td>
                    <font size="2">&nbsp;</font>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    <span class="REGULARTEXT">Select the actions to have permissions for the current policy: </span>
                    </td>
                  </tr>
                  <tr>
                    <td width="100%" colspan="2">

                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">

                      <tr>
                        <td >&nbsp;</td>
                      </tr>
                      <tr>
                            <td class="REGULARTEXT">


<%=getTreeDiv(root,actions,availableActions)%>
                          </td>
                      </tr>

                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                                   <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;&nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="30%">&nbsp;</td>
            <td width="31%" align="center">
             <table border="0" width="225">
                <tr>
                  <td width="33%"><a href="javascript:<%=!isViewOnly?"doSave()" : "void(0)"%>" class="LINK" <%=isViewOnly? "disabled" : ""%>>Save</a></td>
                  <td width="33%"><a href="javascript:<%=!isViewOnly?"doReset()" : "void(0)"%>" class="LINK" <%=isViewOnly? "disabled" : ""%>>Reset</a></td>
                  <td width="33%"><a href="javascript:doCancel()" class="LINK">Cancel</a></td>
                </tr>
              </table>
            </td>
            <td width="39%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>

</body>
</html>