<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.SecurityPermissions.EDIT_GROUPS_PERMISSION,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  String groupname = request.getParameter("name");
  ErrorModel errmodel = new ErrorModel();

  if(groupname == null || groupname.trim().equals("")){
    errmodel.addError("No groupname was supplied.");
  }


  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;

  }
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  			userContext, AuditConstants.CHANGE, "remove group", AuditConstants.SECURITY, "remove group " + groupname);	 	 	

  
  if (security.getUser().isAdmin()){
   manager.removeGroup(security,groupname);
  }else{
  	XpologSecurityHelper.removeVisibleGroupsFromGroup(security,groupname);  	
  }
   response.sendRedirect("removeopok.jsp?managementType=group");

%>

