<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.entities.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,ActionsPermissionConstants.SecurityPermissions.EDIT_USERS_PERMISSION,true)){
    return;
  }
  UserSecurity security = manager.getUserSecurity(request);
  UserContext userContext = UserEnvironment.getUserContext(request);

  String username = request.getParameter("name");
  ErrorModel errmodel = new ErrorModel();

  if(username == null || username.trim().equals("")){
    errmodel.addError("No username was supplied.");
  }else if (username.equals(security.getUser().getName())){
    errmodel.addError("User cann't delete itself");
  }


  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;

  }
  
  //audit  
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
			userContext, AuditConstants.CHANGE, "remove user", AuditConstants.SECURITY, "remove user " + username);	 	 	
  
  if (security.getUser().isAdmin()){
   manager.removeUser(security,username);
  }else{
  	XpologSecurityHelper.removeVisibleGroupsFromUser(security,username);
  }
   response.sendRedirect("removeopok.jsp?managementType=user");

%>