<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.jaas.*"%>
<%@ page import="xpolog.eye.jaas.base.*"%>
<%@ page import="xpolog.eye.jaas.search.*"%>
<%@ page import="xpolog.eye.jaas.db.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.db.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>

<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)){
    return;
  }
  
  
  PrincipalSearcherFactory searcherFactory = XpologSecurityManager.getInstance().getSearcherFactory();
  MultiPrincipalSearcherFactory multiSearcherFactory = searcherFactory != null && searcherFactory instanceof MultiPrincipalSearcherFactory ? (MultiPrincipalSearcherFactory)searcherFactory : null;
  DBPrincipalSearcherConfiguration dbConf = null;
  if (searcherFactory != null){
  	DBPrincipalSearcherFactory dbFactory = (DBPrincipalSearcherFactory)multiSearcherFactory.getSearcherFactoryById("db");
	  if (dbFactory != null ){
	  	dbConf = DBPrincipalSearcherConfiguration.createDBConf(dbFactory.getConfPath());
	  }	  
  }
  List list = AddressBook.getInstance().getAccountsByFilter(new DBAccountFilter());
  
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>  
  function doSave(){
    
    document.access.action="dbSettingsAction.jsp";
    document.access.submit();
  }
  



</script>
</head>

<body >
<form AUTOCOMPLETE="OFF" name="access" id="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">  
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Database Searching settings</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="97%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0"  width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="100%" height="18"><span class="HEADER">General</span></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">&nbsp;</span></td>
                  </tr>
                  <tr>
                    <td>

                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Database Account</span></td>
                        <td width="80%"><select size="1" class="TEXTBOX" name="DatabaseAccount" id="DatabaseAccount">
                        <option value="">--- Select db account ---</option>
                            <%
                            	String accselected = "selected";
                            	String accunselected = "";
                            	String toGo = accunselected;
                            	Account account = null;
                            	String accId = dbConf != null && dbConf.getDbAccount() != null ? dbConf.getDbAccount().getId() : "";
                            	for(int i=0;i<list.size();++i){
                            		account = (Account)list.get(i);
                            		if(account.getId().equals(accId)){
                            			toGo = accselected;
                            		}else{
                            			toGo = accunselected;
                            		}
                            %>
                            <option class="TEXTBOX" <%=toGo%> value=<%=account.getId()%>><%=account.getAccountName()%></option>
                            <%
                            	}
                            %>
                        </select></td>
                      </tr> 
                      <tr>
                    		<td colspan="2"><span class="SMALLTEXT">&nbsp;</span></td>
                 		 </tr>
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">SQL</span></td>
                        <td width="80%"><textarea class="TEXTBOX" rows="3" id="sql" name="sql" cols="100" style="font-size: 8pt"><%=dbConf == null || dbConf.getSql() == null ? "" : dbConf.getSql()%></textarea></td>
                      </tr>   
                      <tr>
                    		<td width="20%"><span class="SMALLTEXT">&nbsp;</span></td>
                    		 <td width="80%"><span class="SMALLTEXT">
													(select Column1 as xplgName,Column2 as xplgDisplayName from Table1 where Column1 like ''{0}'' or Column2 like ''{0}'')</span></td>
                 		 </tr>                  
                    </table>

                    </td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">&nbsp;</span></td>
                  </tr>
                  
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="35%">&nbsp;</td>
                <td width="11%" align="center"><a href="javascript:window.close();" class="LINK">
                cancel</a></td>
                <td width="7%" align="center"><a href="javascript:doSave()" class="LINK">save</a></td>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>