<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.jaas.*"%>
<%@ page import="xpolog.eye.jaas.base.*"%>
<%@ page import="xpolog.eye.jaas.ldap.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>

<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)){
    return;
  }
  
  
  AuthenticatorFactory factory = XpologSecurityManager.getInstance().getAuthenticatorFactory();
  XpologAuthenticatorFactory xpologFactory = factory != null && factory instanceof XpologAuthenticatorFactory ? (XpologAuthenticatorFactory) factory : null;
  ValidatorFactory [] factories = null;
  LdapConfiguration ldapConf = null;
  if (xpologFactory != null){
	  LdapValidatorFactory ldapFactory = (LdapValidatorFactory)xpologFactory.getValidatorById("ldap");
	  if (ldapFactory != null ){
	  	ldapConf = LdapConfiguration.createLdapConf(ldapFactory.getLdapConfPath());
	  }	  
  }
  
  Properties initProp = ldapConf == null ? null : ldapConf.getInitProp();
  Properties userProp = ldapConf == null ? new Properties() : ldapConf.getUserProp();
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>  
  function doSave(){
    
    document.access.action="ldapSettingsAction.jsp";
    document.access.submit();
  }
  



</script>
</head>

<body >
<form AUTOCOMPLETE="OFF" name="access" id="access" style="padding:0;margin:0">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">  
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">LDAP settings</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="97%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0"  width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="100%" height="18"><span class="HEADER">General</span></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">&nbsp;</span></td>
                  </tr>
                  <tr>
                    <td>

                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Initial context factory</span></td>
                        <td width="80%"><input type="text" name="java.naming.factory.initial" class="TEXTBOX" size="50" value="<%=userProp.getProperty("java.naming.factory.initial","com.sun.jndi.ldap.LdapCtxFactory")%>"><span class="SMALLTEXT">
													(example: com.sun.jndi.ldap.LdapCtxFactory)</span></td>
                      </tr>
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Provider url</span></td>
                        <td width="80%"><input type="text" name="java.naming.provider.url" class="TEXTBOX" size="50" value="<%=userProp.getProperty("java.naming.provider.url","ldap://localhost:389/")%>"><span class="SMALLTEXT">
                          (example: ldap://localhost:389/)</span>
                        </td>
                      </tr>
                    </table>

                    </td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">&nbsp;</span></td>
                  </tr>
                  <tr>
                    <td width="100%" height="18"><span class="HEADER">Manager Settings</span></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">&nbsp;</span></td>
                  </tr>
                  <tr>
                    <td>

                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Manager path</span></td>
                        <td width="80%"><input type="text" name="manager.java.naming.security.principal" class="TEXTBOX" size="50" value="<%=(initProp == null ? "" : initProp.getProperty("java.naming.security.principal",""))%>"><span class="SMALLTEXT">
													(Empty for no authentication)</span></td>
                      </tr>
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Manager password</span></td>
                        <td width="80%"><input type="text" name="manager.java.naming.security.credentials" class="TEXTBOX" size="50" value=""><span class="SMALLTEXT">
                          (Empty for no password authentication)</span>
                        </td>
                      </tr>
                    </table>

                    </td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">&nbsp;</span></td>
                  </tr>
                  
                  <tr>
                    <td width="100%" height="18"><span class="HEADER">Search Settings</span></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">&nbsp;</span></td>
                  </tr>
                  <tr>
                    <td>

                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Root path</span></td>
                        <td width="80%"><input type="text" name="rootPath" class="TEXTBOX" size="50" value="<%=(ldapConf == null || ldapConf.getRootPath() == null? "" : ldapConf.getRootPath())%>"><span class="SMALLTEXT">
													(Empty for top root path)</span></td>
                      </tr>
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Search filter</span></td>
                        <td width="80%"><input type="text" name="searchFilter" class="TEXTBOX" size="50" value="<%=(ldapConf == null || ldapConf.getSearchFilter() == null? "" : ldapConf.getSearchFilter())%>"><span class="SMALLTEXT">
                          (Empty for no search. example: uid={0} ,where {0} will be replaced with username)</span>
                        </td>
                      </tr>
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">User path</span></td>
                        <td width="80%"><input type="text" name="userPath" class="TEXTBOX" size="50" value="<%=(ldapConf == null || ldapConf.getUserPath() == null? "" : ldapConf.getUserPath())%>"><span class="SMALLTEXT">
													(Empty for no user path)</span></td>
                      </tr>
                      <tr>
                   		 <td><span class="SMALLTEXT">&nbsp;</span></td>
                  		</tr>
                  		<tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Unique id attribute</span></td>
                        <td width="80%"><input type="text" name="searchUidAtt" class="TEXTBOX" size="50" value="<%=(ldapConf == null || ldapConf.getSearchUid() == null? "" : ldapConf.getSearchUid())%>"><span class="SMALLTEXT">
                          (Empty for no search users. example: uid)</span>
                        </td>
                      </tr>
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Display name attribute</span></td>
                        <td width="80%" ><input type="text" name="searchDisplayNameAtt" class="TEXTBOX" size="50" value="<%=(ldapConf == null || ldapConf.getSearchDisplayName() == null? "" : ldapConf.getSearchDisplayName())%>"><span class="SMALLTEXT">
													(Empty for no display name attribute)</span></td>
                      </tr>
                    </table>

                    </td>
                  </tr>
                  
                  <tr>
                    <td><span class="SMALLTEXT">&nbsp;</span></td>
                  </tr>
                  
                  <tr>
                    <td width="100%" height="18"><span class="HEADER">Further Settings</span></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">&nbsp;</span></td>
                  </tr>
                  <tr>
                    <td>

                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Group id pattern</span></td>
                        <td width="80%"><input type="text" name="groupIdPattern" class="TEXTBOX" size="50" value="<%=(ldapConf == null || ldapConf.getGroupIdPattern() == null? "" : ldapConf.getGroupIdPattern())%>"><span class="SMALLTEXT">
													(Empty for no group id. example: cn={0} ,where {0} will be replaced with group id)</span></td>
                      </tr>
                    </table>
                  	</td>
                  </tr>

									<tr>
                    <td><span class="SMALLTEXT">&nbsp;</span></td>
                  </tr>
                  <tr>
                    <td>

                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Groups attribute</span></td>
                        <td width="80%"><input type="text" name="groupsAttribute" class="TEXTBOX" size="50" value="<%=(ldapConf == null || ldapConf.getGroupsAttribute() == null? "" : ldapConf.getGroupsAttribute())%>"><span class="SMALLTEXT">
													(group members attribute. example: memberOf)</span></td>
                      </tr>
                    </table>
                  	</td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">&nbsp;</span></td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="35%">&nbsp;</td>
                <td width="11%" align="center"><a href="javascript:window.close();" class="LINK">
                cancel</a></td>
                <td width="7%" align="center"><a href="javascript:doSave()" class="LINK">save</a></td>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>