<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.jaas.*"%>
<%@ page import="xpolog.eye.jaas.base.*"%>
<%@ page import="xpolog.eye.jaas.webseal.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>

<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)){
    return;
  }
  
  
  AuthenticatorFactory factory = XpologSecurityManager.getInstance().getAuthenticatorFactory();
  XpologAuthenticatorFactory xpologFactory = factory != null && factory instanceof XpologAuthenticatorFactory ? (XpologAuthenticatorFactory) factory : null;
  ValidatorFactory [] factories = null;
  WebSealConfiguration websealConf = null;
  if (xpologFactory != null){
  	WebSealValidatorFactory websealFactory = (WebSealValidatorFactory)xpologFactory.getValidatorById("webseal");
	  if (websealFactory != null ){
	  	websealConf = WebSealConfiguration.createWebSealConf(websealFactory.getWebSealConfPath());
	  }	  
  }
  
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>  
  function doSave(){
    
    document.access.action="websealSettingsAction.jsp";
    document.access.submit();
  }
  
  function toggleLtpaAuthentication() {
    if(document.getElementById("ltpaEnc").checked == true) {
    	LtpaAuthnticationDiv.style.display = "";
    }else {
      LtpaAuthnticationDiv.style.display = "none";
      document.getElementById("ltpa3DESKey").value = "";
      document.getElementById("ltpaPassword").value = "";
    }
  }


</script>
</head>

<body >
<form AUTOCOMPLETE="OFF" name="access" id="access" style="padding:0;margin:0">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">  
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">WebSEAL settings</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="97%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0"  width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="100%" height="18"><span class="HEADER">General</span></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">&nbsp;</span></td>
                  </tr>
                  <tr>
                    <td>

                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">User header key</span></td>
                        <td width="80%"><input type="text" name="userHeaderKey" class="TEXTBOX" size="50" value="<%=websealConf == null || websealConf.getUserHeaderKey() == null? "" : websealConf.getUserHeaderKey()%>"><span class="SMALLTEXT">
													(example: HTTP_IV_USER)</span></td>
                      </tr> 
                      <tr><td colspan="2">&nbsp;</td></tr>                     
                      <tr><td colspan="2">&nbsp;</td></tr>          
                       <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">User header display name</span></td>
                        <td width="80%"><input type="text" name="displayNameHeaderKey" class="TEXTBOX" size="50" value="<%=websealConf == null || websealConf.getDisplayNameHeaderKey() == null? "" : websealConf.getDisplayNameHeaderKey()%>"><span class="SMALLTEXT">
                          (example: HTTP_IV_USER_L)</span></td>
                      </tr> 
                      <tr><td colspan="2">&nbsp;</td></tr>
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Cookie name</span></td>
                        <td width="80%"><input type="text" name="cookieName" class="TEXTBOX" size="50" value="<%=websealConf == null || websealConf.getCookieName() == null? "" : websealConf.getCookieName()%>"><span class="SMALLTEXT">
                          (example: LTPA Token)</span></td>
                      </tr> 
                      <tr><td colspan="2">&nbsp;</td></tr>     
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Cookie user pattern</span></td>
                        <td width="80%"><input type="text" name="cookieUserKey" class="TEXTBOX" size="50" value="<%=websealConf == null || websealConf.getCookieUserKey() == null? "" : websealConf.getCookieUserKey()%>">
                        <span class="SMALLTEXT">(example: u:{0}\{1})</span></td>
                      </tr>                 
                      <tr><td colspan="2">&nbsp;</td></tr>                     
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Protected URLs</span></td>
                        <td width="80%"><input type="text" name="protectedUrls" class="TEXTBOX" size="50" value="<%=websealConf == null || websealConf.getProtectedUrls() == null? "" : websealConf.getProtectedUrls()%>"></td>
                      </tr> 
                      <tr>
                        <td width="20%">&nbsp;</td>
                        <td width="80%"><span class="SMALLTEXT">URL's which are protected by the web agent, seperated by ','<br>wildcards are allowed</span>
                        </td>
                      </tr> 
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Group header key</span></td>
                        <td width="80%"><input type="text" name="groupHeaderKey" class="TEXTBOX" size="50" value="<%=websealConf == null || websealConf.getGroupHeaderKey() == null? "" : websealConf.getGroupHeaderKey()%>"></td>
                      </tr> 
                      <tr><td colspan="2">&nbsp;</td></tr>                     
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">Group id pattern</span></td>
                        <td width="80%"><input type="text" name="groupIdPattern" class="TEXTBOX" size="50" value="<%=websealConf == null || websealConf.getGroupIdPattern() == null? "" : websealConf.getGroupIdPattern()%>">
                        <span class="SMALLTEXT">(example: c={0} ,where {0} will be replaced with group id)</span></td>
                      </tr> 
                      <tr><td colspan="2">&nbsp;</td></tr>                     
                      <tr>
                        <td width="20%" valign="top" nowrap><span class="REGULARTEXT">User HTTP request key</span></td>
                        <td width="80%"><input type="text" name="userHttpRequestKey" class="TEXTBOX" size="50" value="<%=websealConf == null || websealConf.getUserHttpRequestKey() == null? "" : websealConf.getUserHttpRequestKey()%>"></td>
                      </tr> 
                      
                      <tr>
                <td style="padding-top:15" colspan="2">
                  <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
                    <tr>
                      <td>
                        <input type="checkbox" id="ltpaEnc" name="ltpaEnc" onClick="javascript:toggleLtpaAuthentication()" <%=websealConf == null || !websealConf.isEncryptedToken() ? "" : "checked" %> value="true">
                        <span class="REGULARTEXT">Use Ltpa Authentication</span>
                      </td>
                    </tr>
                    <tr>
                      <td style="padding-left:20px;padding-top:10px">
                      <div id="LtpaAuthnticationDiv" style="display:<%=websealConf == null || !websealConf.isEncryptedToken()? "none" : "" %>">
                        <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
                          <tr>
                            <td width="20%" nowrap><span class="REGULARTEXT">Ltpa 3DESKey</span></td>
                            <td width="80%" style="padding-top:5"><input type="text" id="ltpa3DESKey" name="ltpa3DESKey" class="TEXTBOX" size="24" value="<%=websealConf == null || websealConf.getLtpa3DESKey() == null? "" : websealConf.getLtpa3DESKey()%>"></td>
                          </tr>
                          <tr>
                            <td width="20%" nowrap><span class="REGULARTEXT">Ltpa Password</span></td>
                            <td width="80%" style="padding-top:5"><input type="password" id="ltpaPassword" name="ltpaPassword" class="TEXTBOX" size="24" value="<%=websealConf == null || websealConf.getLtpaPassword() == null ? "" : websealConf.getLtpaPassword()%>"></td>
                          </tr>
                        </table>
                      </div>
                      </td>
                    </tr>
                  </table>
                </td>
              </tr>
                    </table>

                    </td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">&nbsp;</span></td>
                  </tr>
                  
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="35%">&nbsp;</td>
                <td width="11%" align="center"><a href="javascript:window.close();" class="LINK">
                cancel</a></td>
                <td width="7%" align="center"><a href="javascript:doSave()" class="LINK">save</a></td>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>