<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.audit.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.SYSTEM_AUDIT_SETTINGS_PERMISSION,true)){
    return;
  }
  
  AuditManager mgr = AuditManager.getInstance();
  boolean isAuditEnbaled = mgr.isEnabled();

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>
  function doSave(){
    document.access.action="auditSettingsAction.jsp";
    document.access.submit();
  }
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" name="access" id="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">System Audit settings</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0"  width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="100%" height="18" colspan="2"><span class="HEADER">Enable/Disable System Audit</span></td>
                  </tr>
                   <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>                              
                  <tr>
                        <td width="100"><span class="REGULARTEXT">System Audit</span></td>
                        <td><input type="checkbox" name="auditEnabled" id="auditEnabled" <%=isAuditEnbaled?"checked" : ""%>><span class="SMALLTEXT">
                          When checked - the system will generate audit reports</span></td>
                      </tr>                 
                  <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
                  
                  </table>
                    </td>
                  </tr>
                  <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0"  width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="100%" height="18" colspan="2"><span class="HEADER">Audit Settings</span></td>
                  </tr>
                   <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>                
                  <tr>
                        <td width="20%"><span class="REGULARTEXT">Select Audit Level</span></td>
                        <td width="85%">
                        <select size="1" name="auditLevel" id="auditLevel">
                            <%
                            	int selectedLevel = mgr.getAuditLevel();
	                            String basicSelected="";
    	                    	String mediumSelected = "";
        	                	String detailedSelected = "";
            	            	if(selectedLevel==AuditConstants.BASIC_AUDIT_LEVEL){
                	        		basicSelected = "selected=true";
                    	    	}else if(selectedLevel==AuditConstants.MEDIUM_AUDIT_LEVEL){
                        			mediumSelected = "selected=true";
                        		}else {
                        			detailedSelected = "selected=true";
                        		}
                            %>                                                        
                              <option value="<%=AuditConstants.BASIC_AUDIT_LEVEL%>" <%=basicSelected%>>Basic Audit</option>
                              <option value="<%=AuditConstants.MEDIUM_AUDIT_LEVEL%>" <%=mediumSelected%>>Medium Audit</option>
                              <option value="<%=AuditConstants.DETAILED_AUDIT_LEVEL%>" <%=detailedSelected%>>Detailed Audit</option>                            
                          </select>
                          <span class="SMALLTEXT"><br>set the level of audit the system will generate. Default level is basic audit.</span></td>
                      </tr>
                      <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                        <td colspan="2" width="20%"><span class="REGULARTEXT">Audit Types</span>
                        <span class="SMALLTEXT"><br>set the types of audit reports. Leave empty or check all to include all audit reports types.</span></td>
                  </tr>
                  <tr>
                        <td style="padding-left:25;padding-top:15" colspan="2" width="85%">
                        	<table>
                        	<tr>
                        		<td><input type="checkbox" name="typeLogin" id="typeLogin" <%=mgr.isTypeIncluded(AuditConstants.LOGIN)?"checked" : ""%>><span class="SMALLTEXT"></td>
                        		<td><span class="REGULARTEXT">Logins/Logouts</span></td>
                        	</tr>
                        	<tr>
                        		<td><input type="checkbox" name="typeView" id="typeView" <%=mgr.isTypeIncluded(AuditConstants.VIEW)?"checked" : ""%>><span class="SMALLTEXT"></td>
                        		<td><span class="REGULARTEXT">View system components</span></td>                        		
                        	</tr>
                        	<tr>
                        		<td><input type="checkbox" name="typeChange" id="typeChange" <%=mgr.isTypeIncluded(AuditConstants.CHANGE)?"checked" : ""%>><span class="SMALLTEXT"></td>
                        		<td><span class="REGULARTEXT">Change system components</span></td>                        		
                        	</tr>                        	                                                                  
                        </td>
                      </tr>                                  
                  <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
                  
                  </table>
                    </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="35%">&nbsp;</td>
                <td width="11%" align="center"><a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK">
                cancel</a></td>
                <td width="7%" align="center"><a href="javascript:doSave()" class="LINK">save</a></td>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>