<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)){
    return;
  }
  UserContext userContext = UserEnvironment.getUserContext(request);
  
  String ENABLE_DISABLE_AUDIT = "auditEnabled";
  String AUDIT_LEVEL = "auditLevel";
  String AUDIT_TYPE_LOGIN = "typeLogin";
  String AUDIT_TYPE_VIEW = "typeView";
  String AUDIT_TYPE_CHANGE = "typeChange";    
  
  
  String enableDisable = request.getParameter(ENABLE_DISABLE_AUDIT);
  String auditLevel = request.getParameter(AUDIT_LEVEL);
  String auditTypeLogin = request.getParameter(AUDIT_TYPE_LOGIN);
  String auditTypeView = request.getParameter(AUDIT_TYPE_VIEW);
  String auditTypeChange = request.getParameter(AUDIT_TYPE_CHANGE);

  AuditManager mgr = AuditManager.getInstance();
  
  //enabel or disable audit
  if(enableDisable != null && enableDisable.equals("on")) {
	  mgr.setEnabled(true);  
  }else {
	  mgr.setEnabled(false);
  }
  
  //set the level of audit
  int level = -1;
  if(auditLevel != null) {
	level = Integer.parseInt(auditLevel);
  }
  mgr.setAuditLevel(level);
  
  //types settings
  //login
  if(auditTypeLogin != null && auditTypeLogin.equals("on")) {
	  mgr.addType(AuditConstants.LOGIN);  
  }else {
	  mgr.removeType(AuditConstants.LOGIN);
  }
  //view
  if(auditTypeView != null && auditTypeView.equals("on")) {
	  mgr.addType(AuditConstants.VIEW);  
  }else {
	  mgr.removeType(AuditConstants.VIEW);
  }
  //change
  if(auditTypeChange != null && auditTypeChange.equals("on")) {
	  mgr.addType(AuditConstants.CHANGE);  
  }else {
	  mgr.removeType(AuditConstants.CHANGE);
  }
  //if all types are selected - save it empty
  if(mgr.isTypeIncluded(AuditConstants.LOGIN)&&mgr.isTypeIncluded(AuditConstants.VIEW)&&mgr.isTypeIncluded(AuditConstants.CHANGE)) {
	  mgr.clearTypes();
  }
  mgr.saveAuditSettings();
  mgr.reload();
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
   			userContext, AuditConstants.CHANGE, "edit system audit configuration", AuditConstants.CONFIGURATION, "edit system audit configuration");	 	 	

  response.sendRedirect("saveopok.jsp");
%>
