<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.config.env.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>

<%

	if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.ENV_VARS_PERMISSION,true)){
    	return;
  	}
  String ERROR_OBJ = "ERROR_OBJ";
  ErrorModel errmodel = new ErrorModel();
  SiteManagment mgmt = SiteManagment.getInstance();

  UserContext userContext = UserEnvironment.getUserContext(request);
  XpologEnvironmentManager envMgr = XpologEnvironmentManager.getInstance();
  Properties envVariables = envMgr.getAllEnvParams(userContext);
  int numberOfEnvVars = envVariables == null ? 0 : envVariables.size();
  
%>

<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script  src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";
  
  function doSave(){
  	document.access.submit();
  }
  
	function addNewProp(){
		document.getElementById("NewPropTableHeader").style.display = "";
		var ni = document.getElementById("newProps");
		var numi = document.getElementById("numberOfEnvVars");
		var num = (document.getElementById("numberOfEnvVars").value -1)+ 2;
		numi.value = num;
		var divIdName = "newProp"+num+"Div";
		var newdiv = document.createElement('div');
		newdiv.setAttribute("id",divIdName);
		//newdiv.innerHTML = "Element Number "+num+" has been added! <a href=\"javascript:;\" onclick=\"removeEvent(\'"+divIdName+"\')\">Remove the div &quot;"+divIdName+"&quot;</a>";
		newdiv.innerHTML = "<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">"+
                       "<tr><td width=\"20%\" valign=\"top\" nowrap><span class=\"REGULARTEXT\">"+
                       "<input type=\"text\" name=\"key_"+num+"\" id=\"key_"+num+"\" size=\"20\">"+
                       "</span></td>"+
                       "<td width=\"80%\">"+
	                     "<input type=\"text\" name=\"value_"+num+"\" id=\"value_"+num+"\" size=\"20\">"+
	                     "&nbsp;<span class=\"LINK\"><a href=\"javascript:;\" onclick=\"removeEvent(\'"+divIdName+"\')\">&nbsp;remove</a></link>"+
                       "</td></tr></table>";
		ni.appendChild(newdiv);
	}

	function removeEvent(divNum){
		var d = document.getElementById('newProps');
		var olddiv = document.getElementById(divNum);
		d.removeChild(olddiv);
		num = document.access.numberOfEnvVars.value;
		if (!document.getElementById("newProp"+num+"Div")){
			document.getElementById("NewPropTableHeader").style.display = "none";
		}
	}

</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" name="access" id="access" method="post" action="envAdminAction.jsp">
<input type="hidden" value="<%=numberOfEnvVars%>" id="numberOfEnvVars" name="numberOfEnvVars"/>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">XpoLog environment settings</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td colspan="3">&nbsp;</td>
              </tr>
              <tr>
                <td colspan="3">
                <table border="0" cellpadding="0" cellspacing="0"  width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="100%" height="18"><span class="HEADER">Environment variables</span></td>
                  </tr>
				          <tr>
				            <td width="100%">&nbsp;</td>
				          </tr>
                  <tr>
                    <td>
                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                      <tr>
	                      <td>
	                      <div id="newProps">
	                      <%if (envVariables != null){
		                      	List list = new LinkedList(envVariables.keySet());
		                      	Collections.sort(list);
		                      	Iterator it = list.iterator();
		                      	int i = 1;
		                      	while (it.hasNext()){
			                      	String key = (String)it.next();
			                      	String value = envVariables.getProperty(key,"");
	                      %>
	                      	<div id="newProp<%=i%>Div">
													<table border="0" width="100%" cellspacing="0" cellpadding="0">
			                      <tr><td><span style="font-size:2px">&nbsp;<span></td></tr>
														<tr>
															<td width="20%" valign="top" nowrap>
																<span class="REGULARTEXT"><%=key%></span>
																<input type="hidden" name="key_<%=i%>" id="key_<%=i%>" value="<%=key%>">
															</td>
															<td width="*" style="padding-left:5px">
																<input type="text" name="value_<%=i%>" id="value_<%=i%>" value="<%=value%>" size="20">
																&nbsp;<span class="LINK"><a href="javascript:;" onclick="removeEvent('newProp<%=i%>Div')">&nbsp;remove</a>
															</td>
														</tr>
													</table>
													</div>
													<%
													i++;
													}
												}%>
													<table border="0" width="100%" cellspacing="0" cellpadding="0">
			                      <tr><td>&nbsp;</td></tr>
			                      <tr><td><a href="javascript:addNewProp()" class="LINK">add new environment variable</a></td></tr>
														<tr>
															<td>
																<table id="NewPropTableHeader" border="0" width="100%" cellspacing="0" cellpadding="0" style="display:none">
						                      <tr><td colspan="2"><span style="font-size:2px">&nbsp;<span></td></tr>
																	<tr class="TABLES_HEADERS">
																		<td width="20%" valign="top">
																			<span class="REGULARTEXT">&nbsp;name</span>
																		</td>
																		<td width="80%" valign="top" style="padding:left:5px">
																			<span class="REGULARTEXT">&nbsp;value</span>
																		</td>
																	</tr>
						                      <tr><td colspan="2"><span style="font-size:2px">&nbsp;<span></td></tr>
																</table>
															</td>
														</tr>
													</table>
	                      </div>
	                      </td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="35%">&nbsp;</td>
                <td width="11%" align="center"><a href="<%=BASE_DIRECTORY%>common/actions/cancelAction.jsp?forward=logEyePortal.jsp" class="LINK">
                cancel</a></td>
                <td width="7%" align="center"><a href="javascript:doSave()" class="LINK">save</a></td>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</body>

</html>