<%@ page language="java"%>

<%@page import="xpolog.config.Configuration"%>
<%@page import="xpolog.eye.jaas.AuthenticatorFactory"%>
<%@page import="xpolog.eye.security.XpologSecurityManager"%>
<%@page import="xpolog.eye.jaas.base.XpologAuthenticatorFactory"%>
<%@page import="xpolog.eye.jaas.ValidatorFactory"%>

<%
	XpologSecurityManager secure = (XpologSecurityManager)xpolog.config.Configuration.getInstance().getSecurityConfigurator();
	String sestimeout = "";
	if(!Configuration.isWar()){
	 sestimeout = secure.getSessionTimeout();
	}

	String issecurecheck = secure.isEnabled() ? "checked" : "";
	String issslcheck = secure.isStartSSL() ? "checked" : "";
  
  //Authentication
 	AuthenticatorFactory factory = XpologSecurityManager.getInstance().getAuthenticatorFactory();
	XpologAuthenticatorFactory xpologFactory = factory != null && factory instanceof XpologAuthenticatorFactory ? (XpologAuthenticatorFactory) factory : null;
	ValidatorFactory [] factories = null;
	if (xpologFactory != null){
	  factories = xpologFactory.getValidatorsFactory();
	} 
	int []  selectedIndexes = null;
  if (factories != null){                  	
  	selectedIndexes = xpologFactory.getSelectedIndexes();
  }

%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>
		<td style="padding-left:10px">
			<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
								 <tr>
                    <td>&nbsp;</td>                        
                 </tr>
                 <tr>
                        <td width="20%"><span class="HEADER">Security</span></td>
                        <td width="85%"></td>
                 </tr>
                 <tr>
                        <td width="20%"><span class="REGULARTEXT">Activate Security&nbsp;&nbsp;</span></td>
                        <td width="85%"><input type="checkbox" name="activeSecurity" value="true" <%=issecurecheck%> >
                        <span class="SMALLTEXT">(a login will be required to enter XpoLog)</span></td>
                  </tr>
                  <%
                      if(!Configuration.isWar()){
                  %>
                  <tr>
                        <td width="20%"><span class="REGULARTEXT">Session time out</span></td>
                        <td width="85%"><select size="1" name="SessionTimeOut">
                         <%
                         int[] values = new int[]{1,2,3,4,5,6,7,8,9,10,15,20,25,30,40,50,60,70,80,90};
                              String addch = "";
                              String vals = "";
                              for(int i=0;i < values.length;i++){
                                vals = String.valueOf(values[i]);
                                addch = "";
                                if(vals.equals(sestimeout)){
                                  addch = "selected=true";
                                }
                           %>
                             <option <%=addch%> > <%=vals%> </option>
                           <%
                              }
                            %>
	                          </select>
  	                        <span class="SMALLTEXT">(default: 30 minutes)</span></td>
                   </tr>
                        <%
    			                }
          				      %>
									 <tr>
	                    <td>&nbsp;</td>                        
	                 </tr>
                   <tr>
                        <td width="20%"><span class="REGULARTEXT">Login URL&nbsp;&nbsp;</span></td>
                        <td width="85%"><input type="text" size="75" name="loginUrl" value="<%=secure.getLoginURL()%>">
                        <br><span class="SMALLTEXT">(every user will be redirected to this URL to validate login)</span>
                        </td>
                    </tr>
	<!-- Authentication  -->
									 <tr>
                    <td>&nbsp;</td>                        
                 </tr>
                 <tr>
                        <td width="20%"><span class="HEADER">Authentication</span></td>
                        <td width="85%"></td>
                  </tr>
                  <tr>
                     <td width="100%" colspan="2">
	                      <table border="0" width="100%" cellspacing="0" cellpadding="0">
  		                     <tr>
      				              <td>
						                    <span class="REGULARTEXT">Select the authentication types to be used:</span>
				                    </td>
  				                </tr>
          				        <tr>
					                    <td height="100%">&nbsp;</td>
				                  </tr>
        				          <tr>
					                    <td width="100%" height="18">
          						            <table border="0" width="500">
						                        <tr>
								                    	  <td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Available Types</span></td>
																			  <td width="100" height="18">&nbsp;</td>
																			  <td width="200" height="18" align="center"><span class="REGULARTEXT" style="font-weight:bold">Selected Types</span></td>
									                 	</tr>
						                        <tr>
							                          <td width="150">
							                            <select size="5" style="width:200" name="availableValidatorMembersList" id="availableValidatorMembersList" multiple onChange="showDesc(this);">
							                               <%for (int i = 0; i < factories.length; i++) {
							                              	  String id = factories[i].getId();
							                                  String name = factories[i].getName();
							                                  if (name == null || name.length() == 0){
							                                  	name = id;
							                                  }
							                                  
							                                 %>
							                                <option value="<%=id%>" class="TEXTBOX" name="<%=id%>"><%=name%></option>
							                                <%}%>
							                              </select>
																 				  </td>
	                  						        <td width="100">
								                            <table border="0" width="100">
                										             <tr>
                										            	 <td align="center"><a href="javascript:doValidatorMembersAdd()" class="LINK">Add</a></td>
                										             </tr>
																								 <tr>
																								     <td align="center"><a href="javascript:doValidatorMembersRemove()" class="LINK">Remove</a></td>
																								 </tr>
												                     </table>
											                  </td>   
							                          <td width="150">
                                              <select size="5" style="width:200" name="selectedValidatorMembersList" id="selectedValidatorMembersList" multiple onChange="showDetails(this);showDesc(this);">
						                                    <%for (int i = 0; i < selectedIndexes.length; i++) {
						                                    	String id = factories[selectedIndexes[i]].getId();
						                                      String name = factories[selectedIndexes[i]].getName();
						                                      String selected = i == 0? "selected" : "";
								                                 %>
								                                <option value="<%=id%>" class="TEXTBOX" name="<%=id%>" <%=selected%>><%=name%></option>
								                                <%}%>
								                              </select>
																 				  </td>
														 				     <td width="100">
									                            <table border="0" width="100">
                  										           <tr>
                  										           		<td align="center"><a href="javascript:void(0);" class="SMALLLINK" disabled target="" id="detailsLink">Configuration</a></td>
               										           		 </tr>
										                          </table>
										                      </td>    		    
					                          </tr>
																		<tr>
										                    <td colspan="4"><span class="SMALLTEXT" id="authDesc"></span></td>
									                  </tr>
				                      </table>
        			            </td>
              		    </tr>									
									</table>                          
                 </td>                      
                </tr>
	
	
	<!--  End Authentication -->

                  <tr height="100%">
		                    <td>
		                    &nbsp;                    
		                    </td>
		                </tr>                 
			</table>
		</td>
	</tr>
</table>			