<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.logview.*" %>
<%@ page import="xpolog.eye.menu.*" %>
<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)){
    return;
  }
  UserContext userContext = UserEnvironment.getUserContext(request);
  
  String SEARCH_AND_FILTER_DEF = "searchAndFilterDefStr";
  String TAIL_REFRESH_RATE_DEF = "tailRefreshRateDefStr";
  String TAIL_NUMBER_OF_RECORDS_DEF = "tailNumberOfRecrodsDefStr";
  
  ErrorModel err = new ErrorModel();
  String defaulSearchAndFilterDefStr = Configuration.getInstance().getPropertiesManager().getProperty("searchAndFilterDef","START");
  //reading the refresh rate as milliseconds and switching to seconds.
  String tmpDefaulTailRefreshRateDefStr = Configuration.getInstance().getPropertiesManager().getProperty("tailRefreshRateDef","2000");
  String defaulTailRefreshRateDefStr = String.valueOf(Integer.parseInt(tmpDefaulTailRefreshRateDefStr)/1000);
  String defaulTailNumberOfRecrodsDefStr = Configuration.getInstance().getPropertiesManager().getProperty("tailNumberOfRecrodsDef","500");
  
  String pageSearchAndFilterDefStr = request.getParameter(SEARCH_AND_FILTER_DEF);
  String tailRefreshRateDefStr = request.getParameter(TAIL_REFRESH_RATE_DEF);
  String tailNumberOfRecrodsDefStr = request.getParameter(TAIL_NUMBER_OF_RECORDS_DEF);

  if(pageSearchAndFilterDefStr != null && pageSearchAndFilterDefStr.equals("on")) {
	pageSearchAndFilterDefStr = "START";
  }else {
	pageSearchAndFilterDefStr = "CURRENT";
  }
  //search definitions
  if(!defaulSearchAndFilterDefStr.equals(pageSearchAndFilterDefStr)){
	if(defaulSearchAndFilterDefStr.equals("START")) {
		Configuration.getInstance().getPropertiesManager().setProperty("searchAndFilterDef","CURRENT");
	}else {
	  	Configuration.getInstance().getPropertiesManager().setProperty("searchAndFilterDef","START");
	}
	//Configuration.getInstance().getPropertiesManager().saveProperties();
  }
  
  //tail definitions
  if(!defaulTailRefreshRateDefStr.equals(tailRefreshRateDefStr)){
  		String refreshRatetoSave = String.valueOf(Integer.parseInt(tailRefreshRateDefStr)*1000);
	  	Configuration.getInstance().getPropertiesManager().setProperty("tailRefreshRateDef",refreshRatetoSave);
  }
  if(!defaulTailNumberOfRecrodsDefStr.equals(tailNumberOfRecrodsDefStr)){
	  	Configuration.getInstance().getPropertiesManager().setProperty("tailNumberOfRecrodsDef",tailNumberOfRecrodsDefStr);	  	
  }
  Configuration.getInstance().getPropertiesManager().saveProperties();
  
  LogContextMenu context = new LogContextMenu();
  int count = 0;
  int total = 0;
  PopupMenues menues = context.getPopupMenues();

  if (menues != null){
    PopupMenu menu = menues.getPopupById("logDataCM");
    String col = request.getParameter("contextSearchCol0");
    boolean clearSearchItem = true;
    while (col != null && col.length() > 0){
  	  String name = request.getParameter("contextSearchName" + count);
      String path = request.getParameter("contextSearchPath" + count);
      if (name == null || name.length() == 0 || path == null || path.length() == 0){
    	  count++;
    	  col = request.getParameter("contextSearchCol" + count);
    	  continue;
      }
    
      MenuItem item = new MenuItem();
      item.id = "defaultSearch" + total++;
      item.name = name;
      item.link = path;
    	item.target = "_new";
    	item.componentsMask = MenuItem.ALL_MASK;
    	
    	MenuGroup group = new MenuGroup();
    	if (menu == null){
      	menu = new PopupMenu();
      	menu.setPopupId("logDataCM");
      	group.id = "search";
      	group.name = "Search";
      	group.componentsMask = MenuItem.ALL_MASK;
      	menu.addItem(group);
    	}else {
    		group = (MenuGroup)menu.getItem("search");
    	}
      if (clearSearchItem){
      	group.items.clear();
      	clearSearchItem = false;
      }
    	if (group != null){
    		group.items.add(item);
    	}
    
  		count++;
  		col = request.getParameter("contextSearchCol" + count);
  	}
  	menues.removePopupMenu("logDataCM");
   	if (menu != null){
  		 menues.addPopup(menu);
   	}
   	context.savePopups();
  }
   
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
   			userContext, AuditConstants.CHANGE, "edit log viewer settings", AuditConstants.CONFIGURATION, "edit log viewer settings");	 	 	

  response.sendRedirect("saveopok.jsp");
%>
