<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.upgrade.UpgradeActions"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.LICENSE_PERMISSION,true)){
    return;
  }
  UserContext userContext = UserEnvironment.getUserContext(request);

  String LICENSE_SETTINGS_MAP = "LICENSE_SETTINGS_MAP";
  Map map = (Map)request.getSession().getAttribute(LICENSE_SETTINGS_MAP);
  SiteManagment mgmt = SiteManagment.getInstance();
  XpologLicenseManager man = XpologLicenseManager.getInstance();
  boolean suc = man.saveNewLicense(map);
  XpologManagment xman = mgmt.getXpologManagment();
  xman.updateProperties();


  if(!suc){
    ErrorModel ermod = new ErrorModel();
    ermod.addError("XpoLog failed to save license.");
    ermod.addError("Please check your license parameters.");
    request.getSession().setAttribute("ERROR_OBJ",ermod);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
 			userContext, AuditConstants.CHANGE, "save license configuration", AuditConstants.CONFIGURATION, "save license configuration");	 	 	
  
  if(xman.isLicenseValid()) {
  	UpgradeActions upgradeActions = new UpgradeActions();
		upgradeActions.doUpgradeActions(false);
  }
  
  response.sendRedirect("saveopok.jsp?refresh=true");
%>