<%@ page language="java"%>

<%@ page import="java.util.*"%>

<%@ page import="xpolog.eye.automation.tasks.snmp.*"%>
<%@ page import="xpolog.eye.media.snmp.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>


<%
	String ERROR_OBJ = "ERROR_OBJ";
	SNMPConfiguration snmpConfig = new SNMPConfiguration();
	snmpConfig.loadPredefinedSnmpTaskVariables();
	SNMPTaskVariable[] snmpTaskVariables = snmpConfig.getPredefinedSnmpTaskVariables();
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
		var snmpTaskVariablesTypesValues = new Array();
		snmpTaskVariablesTypesValues = ['-1', '<%=SNMPTask.VARIABLE_TRAP_TIME_TYPE %>', '<%=SNMPTask.VARIABLE_LOG_TIME_TYPE %>', '<%=SNMPTask.VARIABLE_TIME_TYPE %>', '<%=SNMPTask.VARIABLE_TEXT_TYPE %>', '<%=SNMPTask.VARIABLE_INTEGER_TYPE %>', '<%=SNMPTask.VARIABLE_UNSIGNED_INTEGER_TYPE %>', '<%=SNMPTask.VARIABLE_IP_ADDRESS_TYPE %>', '<%=SNMPTask.VARIABLE_STATUS_TYPE %>', '<%=SNMPTask.VARIABLE_COUNTER_32_TYPE %>', '<%=SNMPTask.VARIABLE_COUNTER_64_TYPE %>', '<%=SNMPTask.VARIABLE_GAUGE_32_TYPE %>', '<%=SNMPTask.VARIABLE_SMI_ADDRESS_TYPE %>', '<%=SNMPTask.VARIABLE_TCP_ADDRESS_TYPE %>', '<%=SNMPTask.VARIABLE_TIME_TICKS_TYPE %>', '<%=SNMPTask.VARIABLE_UDP_ADDRESS_TYPE %>'];
		var snmpTaskVariablesTypesTexts = new Array();
		snmpTaskVariablesTypesTexts = ['--- Select type ---', 'Trap Time', 'Log Time', 'Time', 'Text', 'Integer 32', 'Unsigned Integer 32', 'IP Address', 'Status', 'Counter 32', 'Counter 64', 'Gauge 32', 'SMI Address', 'TCP Address', 'Time ticks', 'UDP Address'];

    function doSave() {
      document.access.action ="snmpVarsAction.jsp";
      document.access.submit();
    }
		
		function addNewVariable() {
			if(document.getElementById("newVariableOid").value == "") {
				alert("OID was not specified");
				return;
			}else if(document.getElementById("newVariableName").value == "") {
				alert("Name was not specified");
				return;
			}else if(document.getElementById("newVariableType").selectedIndex == 0) {
				alert("Type was not specified");
				return;
			}
		
			var numOfVariables = document.getElementById("numOfVariables");
			num = parseInt(numOfVariables.value) + 1;
			var maxVariableIndex = document.getElementById("maxVariableIndex");
			max = parseInt(maxVariableIndex.value) + 1;
			
			var newDiv = document.createElement('div');
			newDiv.setAttribute("id", "variable" + max + "Div");
			
			var html = '  <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >' + 
				         '    <tr>' + 
				         '    <input type="hidden" name="variable' + max + 'Visible" value="true">' +
								 '      <td width="18%"><input class="TEXTBOX" type="text" name="variableOid' + max + '" size="25" value="' + document.getElementById("newVariableOid").value + '">' + 
								 '      <td width="18%"><input class="TEXTBOX" type="text" name="variableName' + max + '" size="25" value="' + document.getElementById("newVariableName").value + '">' + 
								 '      <td width="18%"><input class="TEXTBOX" type="text" name="variableDescription' + max + '" size="25" value="' + document.getElementById("newVariableDescription").value + '">' + 
								 '			<td width="18%">' +
				         '	     	<select class="TEXTBOX" name="variableType' + max + '" size="1">';
			var selectedType = document.getElementById("newVariableType").value;
			for(i = 0; i < snmpTaskVariablesTypesValues.length; i++) {
				var selected = "";
				if(selectedType == snmpTaskVariablesTypesValues[i]) {
					selected = "selected";
				}else {
					selected = "";
				}
				html +=  '               		<option value="' + snmpTaskVariablesTypesValues[i] + '" ' + selected + '>' + snmpTaskVariablesTypesTexts[i] + '</option>';
			}
			html +=    '               	</select>' +
				         '               </td>' +
								 '      <td width="18%"><input class="TEXTBOX" type="text" name="variableMessage' + max + '" size="25" value="' + document.getElementById("newVariableMessage").value + '">' + 
								 '      <td width="10%"><a href="javascript:removeVariable(' + max + ')" class="LINK">Remove</a></td>' + 
								 '    </tr>' + 
				         '  </table>'; 
			newDiv.innerHTML = html;
			var variablesDiv = document.getElementById("variablesDiv");
			variablesDiv.appendChild(newDiv);
			
			numOfVariables.value = num;
			maxVariableIndex.value = max;
		}
		
		function removeVariable(index) {
			var variableDiv = document.getElementById("variable" + index + "Div");
			variableDiv.style.display = "none";
			
			var numOfVariables = document.getElementById("numOfVariables");
			num = parseInt(numOfVariables.value) - 1;
			numOfVariables.value = num;
			
			var variableVisible = document.getElementById("variable" + index + "Visible");
			variableVisible.value = "false";
		}

</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<input type="hidden" id="numOfVariables" name="numOfVariables" value="<%=(snmpTaskVariables != null) ? snmpTaskVariables.length : 0 %>">
<input type="hidden" id="maxVariableIndex" name="maxVariableIndex" value="<%=(snmpTaskVariables != null) ? snmpTaskVariables.length : 0 %>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="33%" class="TOPBORDER">
                <span class="PAGEHEADER">Predefined SNMP Trap Variables</span> </td>
                <td width="44%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%" >&nbsp;</td>
                <td colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
                  <tr>
                  	<td>
                			<table border="0" width="100%" cellspacing="0" cellpadding="0">
	                      <tr>
				                	<td width="15%" height="18"><span class="REGULARTEXT" style="font-weight:bold">Add New Variables</span></td>
				                </tr>
				                <tr>
				                  <td width="15%" height="5"></td>
				                </tr>
	                      <tr>
			                  	<td colspan="2" width="100%">
			                  		<table border="0" width="100%" cellspacing="0" cellpadding="0">
	                      			<tr>
				                        <td width="18%"><span class="REGULARTEXT">OID</span></td>
				                        <td width="18%"><span class="REGULARTEXT">Name</span></td>
				                        <td width="18%"><span class="REGULARTEXT">Description</span></td>
				                        <td width="18%"><span class="REGULARTEXT">Type</span></td>
				                        <td width="18%"><span class="REGULARTEXT">Message</span></td>
				                        <td width="10%"></td>
				                      </tr>
				                      <tr>
				                        <td><input class="TEXTBOX" type="text" name="newVariableOid" size="25" value="">
				                        <td><input class="TEXTBOX" type="text" name="newVariableName" size="25" value="">
				                        <td><input class="TEXTBOX" type="text" name="newVariableDescription" size="25" value="">
				                        <td>
				                        	<select class="TEXTBOX" name="newVariableType" size="1">
				                        	<script>
																	for(i = 0; i < snmpTaskVariablesTypesValues.length; i++) {
																		document.write('<option value="' + snmpTaskVariablesTypesValues[i] + '">' + snmpTaskVariablesTypesTexts[i] + '</option>');
																	}
																	</script>
				                        	</select>
				                        </td>
				                        <td><input class="TEXTBOX" type="text" name="newVariableMessage" size="25" value="">
				                        <td width="10%"><a href="javascript:addNewVariable()" class="LINK">Add</a></td>
				                      </tr>
				                    </table>
				                  </td>
	                      </tr>
											</table>
                  	</td>
                  </tr>
                  <tr>
                  	<td width="100%">
                  			<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
                  				<tr>
				                    <td width="15%" height="5"></td>
				                  </tr>
				                  <tr>
				                  	<td>
				                  		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
					                      <tr>
					                      	<td><span class="SMALLTEXT">The following variable types are available:</span></td>
					                      </tr>
					                      <tr>
					                      	<td><span class="SMALLTEXT"><b>Trap Time:</b> the time of the SNMP trap. Specify the date format in the Message column, or leave empty for default date format (MM/dd/yyyy HH:mm:ss)</span></td>
					                      </tr>
					                      <tr>
					                      	<td><span class="SMALLTEXT"><b>Log Time:</b> the time of the event. Specify the date format in the Message column, or leave empty for default date format (MM/dd/yyyy HH:mm:ss)</span></td>
					                      </tr>
					                      <tr>
					                      	<td><span class="SMALLTEXT"><b>Time:</b> the value of a date column from the event. Specify the column name in square brackets. Add the date format after the column name (i.e: [Date;MM/dd/yyyy]) or leave empty for default date format (as configured in the log)</span></td>
					                      </tr>
					                      <tr>
					                      	<td><span class="SMALLTEXT"><b>Text:</b> free text or the value of any column from the event. Specify the column name in square brackets</span></td>
					                      </tr>
					                      <tr>
					                      	<td><span class="SMALLTEXT"><b>Status:</b> the status of the event</span></td>
					                      </tr>
					                      <tr>
					                      	<td><span class="SMALLTEXT"><b>Other Types:</b> the value of a column from the event (choose the type matching the data in the event, i.e. Integer 32 for a numeric value and IP Address for an IP address). Specify the column name in square brackets</span></td>
					                      </tr>
					                    </table>
				                  	</td>
				                  </tr>
                  				<tr>
				                    <td width="15%" height="18"></td>
				                  </tr>
				                  <tr>
				                    <td width="15%" height="18"><span class="REGULARTEXT" style="font-weight:bold">Existing Variables</span></td>
				                  </tr>
				                  <tr>
				                    <td width="15%" height="5"></td>
				                  </tr>
				                  <tr>
					                  <td width="15%" >
					                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
					                      <tr>
					                        <td width="18%"><span class="REGULARTEXT">OID</span></td>
					                        <td width="18%"><span class="REGULARTEXT">Name</span></td>
					                        <td width="18%"><span class="REGULARTEXT">Description</span></td>
					                        <td width="18%"><span class="REGULARTEXT">Type</span></td>
					                        <td width="18%"><span class="REGULARTEXT">Message</span></td>
					                        <td width="10%"></td>
					                      </tr>
					                    </table>
					                  </td>
					                </tr>
				                  <tr>
				                  	<td width="15%">
				                  		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
				                  		  <tr>
								                  <td width="15%">
								              			<div id="variablesDiv">
				                  		    	<%
				                  					if(snmpTaskVariables != null && snmpTaskVariables.length > 0) {
				                  						SNMPTaskVariable snmpTaskVariable = null;
				                  						for(int i = 1; i <= snmpTaskVariables.length; i++) {
				                  							snmpTaskVariable = snmpTaskVariables[i - 1];
				                 		 				%>
					                  					<div id="variable<%=i %>Div">
										                     <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
					                  						 	<tr>
					                  						 		<input type="hidden" name="variable<%=i %>Visible" value="true">
										                        <td width="18%"><input class="TEXTBOX" type="text" name="variableOid<%=i %>" size="25" value="<%=snmpTaskVariable.getOid()%>">
										                        <td width="18%"><input class="TEXTBOX" type="text" name="variableName<%=i %>" size="25" value="<%=snmpTaskVariable.getName()%>">
										                        <td width="18%"><input class="TEXTBOX" type="text" name="variableDescription<%=i %>" size="25" value="<%=snmpTaskVariable.getDescription()%>">
										                        
										                        <td width="18%">
																							<select class="TEXTBOX" name="variableType<%=i %>" size="1" onchange="javascript:handleTimeType(this, document.access.variableMessage<%=i %>)">
				         															<script>
				         															var selected = "";
				         															for(i = 0; i < snmpTaskVariablesTypesValues.length; i++) {
																								if(snmpTaskVariablesTypesValues[i] == '<%=snmpTaskVariable.getType() %>') {
																									selected = "selected";
																								}else {
																									selected = "";
																								}
																								document.write('<option value="' + snmpTaskVariablesTypesValues[i] + '" ' + selected + '>' + snmpTaskVariablesTypesTexts[i] + '</option>');
																							}
																							</script>
																							</select>
																						</td>
										                        <td width="18%"><input class="TEXTBOX" type="text" name="variableMessage<%=i %>" size="25" value="<%=snmpTaskVariable.getMessage()%>">
										                        <td width="10%"><a href="javascript:removeVariable(<%=i %>)" class="LINK">Remove</a></td>
										                      </tr>
						                  					</table>
						                  				</div>
				                  					<%
				                  						}
				                  					}
				                  					%>
				                  					</div>
								                	</td>
				                  			</tr>
				                  		</table>
				                  	</td>
				                  </tr>
                  			</table>
                  	</td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td>
                    <font size="2">&nbsp; </font>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    &nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="101%" >
                      <tr>
                        <td width="25%">&nbsp;</td>
                        <td width="13%">
                        <p align="center">&nbsp;</td>
                        <td width="11%"><a href="javascript:history.go(-1)" class="LINK">cancel</a></td>
                        <td width="11%"><a href="javascript:doSave()" class="LINK">save</a></td>
                        <td width="35%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>