<%@page import="xpolog.eye.media.snmp.SNMPConfiguration"%>
<%@page import="xpolog.eye.media.snmp.SNMPAccount"%>
<%@page import="xpolog.eye.media.AddressBook"%>
<%@page import="xpolog.eye.media.MediaManager"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.snmp.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	
	String numOfVariablesStr = request.getParameter("numOfVariables");
	int numOfVariables = Integer.parseInt(numOfVariablesStr);
	String maxVariableIndexStr = request.getParameter("maxVariableIndex");
	int maxVariableIndex = Integer.parseInt(maxVariableIndexStr);
	SNMPTaskVariable[] snmpTaskVariables = null;
	SNMPTaskVariable snmpTaskVariable = null;
	if(numOfVariables > 0) {
		String variableVisibleStr, oid, name, description, type, message;
		boolean variableVisible;
		snmpTaskVariables = new SNMPTaskVariable[numOfVariables];
		int index = 0;
		for(int i = 1; i <= maxVariableIndex; i++) {
			variableVisibleStr = request.getParameter("variable" + i + "Visible");
			variableVisible = new Boolean(variableVisibleStr).booleanValue();
			if(variableVisible) {
				oid = request.getParameter("variableOid" + i);
				name = request.getParameter("variableName" + i);
				description = request.getParameter("variableDescription" + i);
				type = request.getParameter("variableType" + i);
				message = request.getParameter("variableMessage" + i);
				
				snmpTaskVariable = new SNMPTaskVariable();
				snmpTaskVariable.setOid(oid);
				snmpTaskVariable.setName(name);
				snmpTaskVariable.setDescription(description);
				snmpTaskVariable.setType(type);
				snmpTaskVariable.setMessage(message);
				
				snmpTaskVariables[index++] = snmpTaskVariable;
			}
		}
	}

	ErrorModel errmodel = new ErrorModel(); 
	
 	if(snmpTaskVariables != null && snmpTaskVariables.length > 0) {
 		String error = "";
 		for(int i = 0; i < snmpTaskVariables.length; i++) {
 			error = "";
 			snmpTaskVariable = snmpTaskVariables[i];
 			if(snmpTaskVariable != null) {
	 			if(snmpTaskVariable.getOid() == null || snmpTaskVariable.getOid().length() == 0) {
	 				error += "OID was not specified, ";
	 			}
	 			if(snmpTaskVariable.getName() == null || snmpTaskVariable.getName().length() == 0) {
	 				error += "Name was not specified, ";
	 			}
	 			if(snmpTaskVariable.getType() == null || snmpTaskVariable.getType().equals("-1")) {
	 				error += "Type was not specified, ";
	 			}
	 			if(error.length() > 0) {
	 				error = error.substring(0, error.length() - 2);
		 			errmodel.addError("Variable #" + (i + 1) + " is missing the following details: " + error);
	 			}
 			}
 		}
 	}

 	if(errmodel.getErrorCount() != 0){
   	request.getSession().setAttribute(ERROR_OBJ,errmodel);
   	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
   	return;
 	}
	
 	SNMPConfiguration snmpConfig = new SNMPConfiguration();
 	snmpConfig.savePredefinedSnmpTaskVariables(snmpTaskVariables);

 	//audit
	//AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	//   			userContext, AuditConstants.CHANGE, "task added/edited", AuditConstants.TASKS, "snmp task added/edited " + Name);

	response.sendRedirect("snmpVars.jsp");
%>