<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.controllers.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>
<%
  

  String MODULE_ID = "MODULE_ID";
  String CURRENT_MODULE = "CURRENT_MODULE";
  String ERROR_OBJ = "ERROR_OBJ";  

  SiteManagment mgmt = SiteManagment.getInstance();

  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  SiteWizardController control = env.getSiteWizardController();

  Module[] mdarr = mgmt.getAllModules(userContext,true);
  if (mdarr == null){
  	mdarr = new Module[0];
  }

  String parentModuleId = null;
  parentModuleId = request.getParameter("PARENT_MODULE");
  
  String parentModuleName = null;  
  

  boolean firstVisit = control == null || !control.getAttributes().containsKey("rootModuleFirstVisit");
  String modName = "";
  if (control != null && firstVisit){
  	ControllerItem item = control.getCurrentItem();
  	if (item != null){
  		UIControllerItem uiItem = item.getUiItem();
  		modName = uiItem == null ? null : uiItem.getProp().getProperty("defaultModuleName");  	
  		if (modName == null){
  			modName = "";
  		}
  		
  		if (modName.length() > 0){
    		for (int i = 0; i < mdarr. length;i++){
    		  if (modName.equals(mdarr[i].getName())){
    		  	parentModuleId = mdarr[i].getId();
    		  	modName = "";
    		  }
    		}
  		}
  		
  		if (parentModuleId == null || parentModuleId.length() == 0){
  		  String pModId = uiItem == null ? null : uiItem.getProp().getProperty("parentModuleId");  	
  		  if (pModId != null && pModId.length() > 0){
  		  	parentModuleId = pModId;
  		  }
  		  
  		  String pModName = uiItem == null ? null : uiItem.getProp().getProperty("parentModuleName");  	
  		  if (pModName != null && pModName.length() > 0){
  		  	parentModuleName = pModName;
  		  }
  		}
  	}
  }
  
  if (parentModuleId == null || parentModuleId.length() == 0){
    Module pmod = (Module)request.getSession().getAttribute(CURRENT_MODULE);
    if (pmod != null){
      parentModuleId = pmod.getId();
    }else {
      parentModuleId = null;
    }
  }

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="POST" action="setupRootModuleDefAction.jsp">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">  
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Root Folder Definition</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">General</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">

                     
                      <tr>
                        <td width="20%"><span class="REGULARTEXT">Parent folder</span></td>
                        <td width="80%">

                        <select size="1" class="TEXTBOX" name="parentModule">
                          <%
                            String selected = "";
                            for(int i=0;i<mdarr.length;++i){                              
                              if((parentModuleId != null && mdarr[i].getId().equals(parentModuleId)) || (parentModuleName != null && mdarr[i].getName().equalsIgnoreCase(parentModuleName))){
                                selected = "selected=\"true\"";
                              }else{
                                selected = "";
                              }
                            %>
                            <option class="TEXTBOX" value="<%=mdarr[i].getId()%>" <%=selected%>><%=mdarr[i].getName()%></option>
                          <%}%>
                        </select></td>                        
                      </tr>                     
                      <tr style="padding-top:10">
                        <td width="20%"><span class="REGULARTEXT"><nobr>New folder name:</nobr></span></td>
                        <td width="80%">
                        <input type="text" name="moduleName" size="30" value="<%=modName%>" class="TEXTBOX">
                        </td>                        
                      </tr>
                      <tr style="padding-top:10">
                        <td colspan="2" width="*">                        
			                  		<span class="SMALLTEXT">
			                  		Enter here the name of a new folder to be created under the selected parent folder<br>
			                  		or leave this field empty to use only the selected parent folder
			                  		</span>			                  		
			                  	</td>
                      </tr>                      
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>                 
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%" class="REGULARTEXT">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">           
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="35%">&nbsp;</td>
                    <td width="11%" align="center"><a href="javascript:document.access.submit()" class="LINK">
                    next</a></td>                    
                    <td width="*">&nbsp;</td>
                  </tr>
                </table>             
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>