<%@ page import="omega.ui.models.tree.*" %>
<%@ page import="omega.ui.html.tree.*" %>
<%@ page import="xpolog.eye.*" %>
<%@ page import="xpolog.eye.verifiers.*" %>
<%@ page import="xpolog.eye.security.*" %>
<%@ page import="xpolog.eye.managment.*" %>
<%@ page import="xpolog.eye.menu.*" %>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.menu.*" %>
<%@ page import="xpolog.config.*"%>
<%@ page import="java.util.*" %>
<%!
	static final String BASE_DIRECTORY = "";
%>
<%
  
  
 
  SiteManagment mgmt = SiteManagment.getInstance();
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  ViewContext viewContext = env.getViewContext();
  
  XpologApplicationComponent selectedComp = (XpologApplicationComponent)env.getSelectedComponent(user);
  MenuManager manager = null;
  if (selectedComp != null){
    ComponentManagement compManage = selectedComp.getComponentManagement();
    manager = compManage.getMenuManager();
  }else {
    manager = new MenuManager(null);
  }
  
  OTreeModel model = manager.getTreeMenuModel(user,env);
  ODefaultMutableTreeNode root = (ODefaultMutableTreeNode)model.getRoot();

  String frameWidth = viewContext == null ? null : viewContext.managementWidth;
  if(frameWidth == null){
  	frameWidth = Configuration.getInstance().getPropertiesManager().getProperty("managementWidth","200");
  }  

	final boolean ALLOW_EMBEDED_FLASH = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("snapshot.allowEmbededFlash",true);

%>

<html>

<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/menus.css"/>
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/jsdomenu.css" />

<script src="scripts/UIUtil.js" type="text/javascript"></script>

<script  src="scripts/comps/jsdomenu.js"></script>
<script  src="scripts/tree/rightClickMenu.js"></script>
<script>
  base_directory = "<%=BASE_DIRECTORY%>";
</script>

<script src="<%=BASE_DIRECTORY%>scripts/tree/rightClickMenu.js"></script>
<jsp:include page="widgets/xtree/jsp/treeIncluder.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<jsp:include page="slides/slidesIncluder.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>


<script type="text/javascript">

function selectNode(id){
		var extData = this.treeNod.getUserData(id,"extData");
		if (extData && extData.indexOf("openItem") != -1){
			if (this.treeNod.getOpenState(id) != 1){
				this.treeNod.openItem(id);
			}else{
				this.treeNod.closeItem(id);
			}
		}
		if (this.treeNod.getUserData(id,"link")){
			document.access.action = this.treeNod.getUserData(id,"link");
			document.access.submit();
		}
	}

	function rightClickNode(e){
		hideVisibleMenus(); 
		var id = this.childNodes[0].parentObject.id;
		var menuId = this.childNodes[0].parentObject.treeNod.getUserData(id,"popupKey");
		var htmlNode = document.getElementById(id);
		openPopupMenu(htmlNode,menuId);
		return false;
	}
	
	function openNode(id,mode){
		var add = mode == 1 ? "false" : "true";
	  doBackgroundAction("<%=BASE_DIRECTORY%>tree/openTreeNodeAction.jsp?add="+add+"&id="+id);
	}

	function openNodeLink(link){
	  if(parent != null){
	    if(link.indexOf("help/helpIndex")>-1){	
	    	help = window.open(link,"help",'width=750,height=550,status=no,scrollbars=yes,resizable=yes,top=100,left=100,dependent=yes,alwaysRaised=yes');
				help.focus();
	    }else{
		    var mainFrm = getFrameByName("main");
		    if (mainFrm != null){
		      mainFrm.location = link;
		    }
	    }
	  }
	}
	
	function getCssClassforId(id){
		if(id == selecedFolderId || id == selecedFolderNodeId){
			return "clsModuleSelected";
		}else if(id == selectedLogId || id == selectedLogFolderId){
			return "clsLogSelected";
		}else if(id == selectedMultiVerifierId){
			return "clsMultiVerifierSelected";
		}else if(id == selectedLogVerifierId){
			return "clsLogVerifierSelected";
		}else if (id == selectedSessionRuntimeId){
			return "clsSessionRuntimeSelected";
		}else{
			return "clsTreeNode";
		}
	}

	var t1,t2,t3;	
	var loadingImg = "images/tree/loading.gif";
	function startLoading(t,nodeId){
		if (nodeId && nodeId != null && nodeId != "0"){
      t1=t.getItemImage(nodeId,0);
      t2=t.getItemImage(nodeId,1);
      t3=t.getItemImage(nodeId,2);
      t.setItemImage2(nodeId, loadingImg, loadingImg, loadingImg);
		}else{
			document.getElementById(this.parentObject.id + "Div").style.display="";
			document.getElementById(this.parentObject.id).style.display="none";
		}
	}
			
	function endLoading(t,nodeId){
		if (nodeId && nodeId != null && nodeId != "0"){
			t.setItemImage2(nodeId, t1, t2, t3);
		}else{
		  
			document.getElementById(this.parentObject.id + "Div").style.display="none";				
			document.getElementById(this.parentObject.id).style.display="";
		}
	}
	
	function update(){
	  for (var i = 0; i < updateList.length;i++){
	    eval(updateList[i]);
	  }
	}

	function slideResize(){
	  if(headersList == null){
				return;
			}
			var ids = headersList.split(',');
			var table;
			for(var i = 0 ; i < ids.length ; i++){			
				table = document.getElementById("headerTable_" + ids[i]);
				if(table){
					table.style.width = (document.body.clientWidth - 15 );				
				}			
			}			
	}
	
	var updateList = new Array();


///////		Snapshot node part
var mygridsnapshot;
var flash_installed = (navigator.appName == 'Netscape') ? isFlashInstalledInBrowser() : true;
var isAllowEmbededFlash = '<%=ALLOW_EMBEDED_FLASH%>';
var showCopyAction = ((isAllowEmbededFlash == "true") && flash_installed) || (navigator.appName != 'Netscape');

  function getMainViewFrame(){
  	var mgmtFrm = getManagemtnFrame();
	  if(mgmtFrm && mgmtFrm.parent && mgmtFrm.parent.frames['main']) {
	    var frm =  mgmtFrm.parent.frames['main'];
	    if (frm.location && frm.location.href && frm.location.href.indexOf("mainView.jsp") != -1){
	      return frm;
	    }
	  }
  }


	var snapshotMsgWriterId = "snapshotMsgWriterId";
	function showMsgSnapshot(){
		var nodeId = "";
		if(getPopupSelectedNodeId){
			nodeId = getPopupSelectedNodeId();
		}
		var functions = new Array();
		functions[0] = removeSnapshotFromSlide;
		if (parent.parent.openMsgWriter){
			var title = "Snapshot Delete Action";
			var actions = "Yes@javascript:msgWriter.functions[0]('"+ nodeId + "')#No@javascript:closeMsgWriter('" + snapshotMsgWriterId + "')";
			var msg = "<nobr>Are you sure you want to delete the selected snapshot</nobr>" + "?";
			parent.parent.openMsgWriter(snapshotMsgWriterId,title,actions,msg,"",functions);
		}
	}
	
	
	function selectToRemove(){
		var divId = 'snapshot';
		var params = "baseDirectory=&actionsNames=Remove#Cancel&actions=javascript:removeSelectedSnapshot0()#javascript:closeTempDiv()&title=Remove Snapshots&suffix=" + divId;
		params += "&includePath=snapshot/selectSnapshotToRemoveFrm.jsp";
		parent.parent._selectToRemove(divId,params,'500px','280px');
	}

	function editSnapshot(){
		var nodeId = "";
		if(getPopupSelectedNodeId){
			nodeId = getPopupSelectedNodeId();
		}	
		var divId = 'editSnapshot';
		var params = "baseDirectory=&actionsNames=Apply#Cancel&actions=javascript:editSnapshot0()#javascript:closeTempDiv()&title=Edit Snapshot&suffix=" + divId;
		var innerParams = "snapshotId=" + nodeId;
		params += "&includePath=snapshot/createSnapshotDiv.jsp?" + encode(innerParams);
		parent.parent.openTempDiv(divId,params);
	}
	
	
	function removeSnapshotFromSlide(id){
		var page = base_directory + "snapshot/snapshotRemoveAction.jsp?SNAPSHOT_ID=" +id;
				sendAjaxRequest(page,function(req){
				var result = req.responseText;
				result = result.replace(/^\s+|\s+$/g, '') ;
				if(!result){
					var msg = "<nobr>Problem removing selected snapshot!</nobr>"
					parent.parent.errorMsgWriter(snapshotMsgWriterId,msg,"");							
					return;			
				}else{
					var resultArr = result.split("#");
					if(!resultArr || resultArr[0] != "ok"){
						var msg = resultArr[1];
						msg = !msg  || msg == "" ? "<nobr>Problem removing selected snapshot!</nobr> " : msg;
						parent.parent.errorMsgWriter(snapshotMsgWriterId,msg,"");							
						return;								
					}else{
						var refreshMenusId = ""; 
						if(resultArr.length > 2){
						 	refreshMenusId = resultArr[2]; 						
						}
						refreshMenus("",refreshMenusId,base_directory);
						parent.parent.closeMsgWriter(snapshotMsgWriterId);
						var refresh = resultArr[1];
						//remove removed tab by refreshing the view .
						if(refresh == "true"){
							 var path ="<%=BASE_DIRECTORY + env.getUsePage()%>";
							 frm = getMainViewFrame();
							 if (frm){
								 	frm.location = path;
							 }	
						}
					}
				}
			});	
	}
	
	function copySnapyToClipboard(){
		var id = nodeId; // Get nodeId from openPopupMenu()...
		var page = base_directory + "common/getLbmRecordsArr.jsp?SNAPSHOT_ID=" +id;
				sendAjaxRequest(page,function(req){
				var result = req.responseText;
				result = result.replace(/^\s+|\s+$/g, '') ;
				if(!result || result == "error"){
					var msg = "<nobr>Problem copying selected snapshot to clipboard!</nobr>"
					parent.parent.errorMsgWriter(snapshotMsgWriterId,msg,"");							
					return;			
				}else if(result == "ActionDenied"){
					var msg = "<nobr>Another user is using this snapshot</nobr>"
					parent.parent.errorMsgWriter(snapshotMsgWriterId,msg,"");							
					return;							
				}else{
					var dataToCopy = "";
					var resultArr = result.split("#@#@");
					for(var i = 0 ; resultArr && i < resultArr.length ; i++){
						dataToCopy += resultArr[i] + "\n";
					}
					copyToClipboard(dataToCopy);
				}
			});	
	}
	
	function copySnapyLinkToClipboard(){
		var timestamp = '<%=System.currentTimeMillis()%>';
		var id = nodeId; // Get nodeId from openPopupMenu()...
		var applicationRoot = '<%=SiteUtil.getApplicationRoot(request)%>';		
		var link = applicationRoot + "componentAction.jsp?selectedCompId=XpoLog&forward=root.jsp?mainPage=snapshot/snapshotView.jsp%3FSNAPSHOT_ID=" + id;
		copyToClipboard(link);
	}
	
	
	function copyToClipboard(dataToCopy){
		if(window.clipboardData){
			window.clipboardData.setData('text', dataToCopy);
		}else if(showCopyAction){
	     var clipboarddiv=document.getElementById('divclipboardswf');  
			 if(clipboarddiv==null){  
	        clipboarddiv=document.createElement('div');  
	        clipboarddiv.setAttribute("name", "divclipboardswf");  
	        clipboarddiv.setAttribute("id", "divclipboardswf");  
	        document.body.appendChild(clipboarddiv);  
	     }  
	     clipboarddiv.innerHTML='<embed src="common/clipboard.swf" FlashVars="clipboard='+  
			 encodeURIComponent(dataToCopy)+'" width="0" height="0" type="application/x-shockwave-flash"></embed>';  			    	
		}else{
			var msg = "<nobr>Problem copying selected snapshot to clipboard!</nobr>"
			parent.parent.errorMsgWriter(snapshotMsgWriterId,msg,"");							
			return;			
		}	
	}
	
	function openGeneralDiv(page,params,progressTitle,progressMsg){			  
		if (parent.parent.openGeneralDiv){
		  var re = new RegExp ("[[]ID]", 'gi') ;
      params = params.replace(re,nodeId);
			parent.parent.openGeneralDiv(page,params,progressTitle,progressMsg);
		}
	}
	
	//folder collection
	var folderMsgWriterId = "folderMsgWriterId";
	function showMsgCollection(){
		var nodeId = "";
		if(getPopupSelectedNodeId){
			nodeId = getPopupSelectedNodeId();
		}
		var functions = new Array();
		functions[0] = addFolderCollection;
		if (parent.parent.openMsgWriter){
			var title = "Folder Collection";
			var actions = "Yes@javascript:msgWriter.functions[0]('"+ nodeId + "')#No@javascript:closeMsgWriter('" + folderMsgWriterId + "')";
			var msg = "<nobr>Create collectors for all logs of the selected folder using default settings</nobr>" + "?";
			parent.parent.openMsgWriter(folderMsgWriterId,title,actions,msg,"",functions);
		}
	}
	
	function addFolderCollection(id){
		var page = base_directory + "logcollection/admin/log/folderCollectionDefinitionAction.jsp?folderId=" +id;
		var title = "Folder Collection";
		var msg = "<nobr>Creating collectors for selected folder. Please wait...</nobr>";
		parent.parent.openMsgWriter(folderMsgWriterId,title,"",msg,"","");
		sendAjaxRequest(page,function(req){

	    var xmldoc = req.responseXML.documentElement;
      var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
      var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
      if (result == "false"){
      	hideDisplayLayer("saveMessage");
	    	var msg = "";
    		msg = "<ul>";
    		var errs = message.split("*;*");
    		for (var i=0; i<errs.length; i++){
    			msg = msg + "<li>" + errs[i] + "</li>";
    		}
    		msg = msg + "</ul>"
				parent.parent.errorMsgWriter(folderMsgWriterId,msg,"");							
      }else{
      	refreshMenus();
				parent.parent.closeMsgWriter(folderMsgWriterId);
				var title = "Folder Collection";
				var actions = "Open Collectors Console@javascript:closeMsgWriter('" + folderMsgWriterId + "');openMainPage('logcollection/logCollectionsView.jsp')#Close@javascript:closeMsgWriter('" + folderMsgWriterId + "')";
				var msg = "<nobr>" + message + " collectors created</nobr>";
				parent.parent.openMsgWriter(folderMsgWriterId,title,actions,msg,"","");
      }
		});	
	}
	
</script>

<style>
form {
padding:0px;
margin:0px;
}
</style>
</head>
<body topmargin="0"  leftmargin="2" rightmargin="2" style="overflow-x:hidden;overflow-y:auto;margin:0px;padding:0px" onResize="javascript:slideResize()">
<form AUTOCOMPLETE="OFF" name="access" method="post" target="main" >
</form>
<table height="100%" width="100%" border="0" cellpadding="0" cellspacing="0" background="images/slides/manageBg.gif">
<%
		
    Enumeration e = root.children();
		StringBuffer headersNames = new StringBuffer();
	  for (;e.hasMoreElements();) {
	  	ODefaultMutableTreeNode node = (ODefaultMutableTreeNode)e.nextElement();
	  	boolean isOpen = viewContext.isSlideOpen(node.getId());
	  	String slideURL = node.getSlideURL();
	  	if (slideURL == null || slideURL.length() == 0){
	  		slideURL = "slides/slide.jsp";
	  	}
	  	slideURL = BASE_DIRECTORY + slideURL;
	  	boolean isVisible = node.isVisible();
	  	String popupKey = node.getPopupKey();
	  	if (popupKey == null){
	  		popupKey = "";
	  	}
	  	if (headersNames.length() > 0){
	  		headersNames.append(",");
	  	}
	  	headersNames.append(node.getId());
	  %>
	  <%if (node.showHeader()){%>
	  <tr height="10" id="<%=node.getId()%>Header" style="display:<%=isVisible? "" : "none"%>"><td >
	  
	  <table width="100%" border="0" cellpadding="0" cellspacing="0">
	  <jsp:include page="slides/slideHeaderIncluder.jsp" flush="true">
      <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
      <jsp:param name="name" value="<%=node.getName()%>" />
      <jsp:param name="id" value="<%=node.getId()%>" />
      <jsp:param name="open" value="<%=String.valueOf(isOpen)%>" />
      <jsp:param name="popupKey" value="<%=popupKey%>" />     
      <jsp:param name="frameWidth" value="<%=frameWidth%>" />     
    </jsp:include>
    </table>
		</td></tr>
		<tr height="10"  id="<%=node.getId()%>" style="padding-bottom:5;<%=isOpen ? "" : "display:none" %>"><td>
	  <table width="100%" border="0" cellpadding="0" cellspacing="0">
	  <jsp:include page="<%=slideURL%>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="id" value="<%=node.getId()%>" />				
			</jsp:include>
			</table>
			</td></tr>
		<%} else {%>		
		<tr height="10" id="<%=node.getId()%>" style="display:<%=isVisible? "" : "none"%>"><td >
	  
	  <jsp:include page="<%=slideURL%>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="id" value="<%=node.getId()%>" />
			</jsp:include>
			
			</td></tr>
	  <%} %>
	 
	<% }%>
	<tr height="*"><td>&nbsp;</td></tr>
	</table>
<script>
var headersList = "<%=headersNames%>";
<jsp:include page="treePopups.jsp" flush="true" />
</script>
	</body>
</html>