<%@page import="xpolog.eye.error.ErrorModel"%>
<%@page import="xpolog.eye.util.WebUtil"%>
<%@page import="xpolog.eye.data.DataConstants"%>
<%@page import="xpolog.eye.logview.LogViewQueryInfo"%>
<%@ page language="java" %> 
<%@page import="java.util.Iterator"%>
<%@page import="java.util.Collections"%>
<%@page import="java.util.LinkedList"%>
<%@page import="java.util.List"%>
<%@page import="xpolog.eye.data.Record"%>
<%@page import="xpolog.eye.data.RecordsMaskTableModel"%>
<%@page import="xpolog.eye.logview.LogViewContext"%>
<%@page import="xpolog.eye.LogBrowsingManager"%>
<%@page import="xpolog.eye.snapshot.Snapshot"%>

<%@page import="xpolog.eye.snapshot.SnapshotManager"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.site.UserContext"%>


<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
		String ACTIVE_SNAPSHOT_ID = "ACTIVE_SNAPSHOT_ID";
		String ACTIVE_SNAPSHOT_MODE = "ACTIVE_SNAPSHOT_MODE";

		UserContext userContext = UserEnvironment.getUserContext(request);
		LogViewContext logcontext = (LogViewContext)request.getSession().getAttribute(LogViewContext.LOG_CONTEXT);
		LogBrowsingManager lbm = logcontext == null ? null : logcontext.lbm;
	  LogViewQueryInfo queryInfo = logcontext == null ? null : logcontext.query;
	  int leapsize =  queryInfo == null ? 25 : queryInfo.leapsize;
		SnapshotManager smgr = SnapshotManager.getInstance();
		Snapshot snapshot = null;
		String errorMsg = "";
		String isNewStr = request.getParameter("isNew");
		boolean isNew = isNewStr != null && isNewStr.equals("true");
		String selectedRowIndexStr = request.getParameter("selectedRowIndexArr");
		String[] selectedRowIndexArr = selectedRowIndexStr == null ? null : selectedRowIndexStr.split("#");
		List selectedRowIndexes = new LinkedList();
		for(int i = 0 ; selectedRowIndexArr != null && i < selectedRowIndexArr.length ; i++){
			int rowIndx = -1;
			try{
					rowIndx = Integer.parseInt(selectedRowIndexArr[i]);
					selectedRowIndexes.add(new Integer(rowIndx));
			}catch(Exception e){
				rowIndx = -1;
			}			
		}
		Collections.sort(selectedRowIndexes);
		if(selectedRowIndexes.isEmpty()){
			errorMsg = "No record was selected";
		}
		//Getting the row original data part
//		Object originalDataObj = 	null;
		

	  List recList = new LinkedList();;
	  Record rec = null;
		if(lbm == null ){
			errorMsg = "No log was selected";
		}
		
		String name = request.getParameter("name");

		if(name == null || name.length() == 0){
			errorMsg = "No name was specified";
		}else if(WebUtil.isContainSpecialCharecter(name)){	
			errorMsg = "The following charecters are prohibited in the name field: "+ WebUtil.doHTMLEncoding(WebUtil.getSpecialCharectersList());
		}else if(smgr.isSnapshotNameExist(name)){
			errorMsg = "A snapshot with the same name alredy exists";
		}
		
		if(errorMsg.length() == 0){
			try{
				RecordsMaskTableModel RMModel = null;
				boolean isOriginalData = lbm.isAddOrigDataToResult();
				//Check if original data is realy in record
				if(isOriginalData){
					rec = lbm.getLogEyeModel() == null ? null : lbm.getLogEyeModel().getRecordAt(0);
					if(rec == null || rec.getOriginalData() == null){
						isOriginalData = false;
					}
				}
				if(!isOriginalData){
					lbm.setAddOrigDataToResult(true);
					RMModel = lbm.getCurrentEntries(leapsize);
					lbm.getLogEyeModel().setRecordMaskModel(RMModel);
					request.getSession().setAttribute(ACTIVE_SNAPSHOT_MODE,"true");
				}else{
					RMModel = lbm.getLogEyeModel() == null ? null : lbm.getLogEyeModel().getRecordsMaskTableModel() ; 
				}
			  if(RMModel != null && RMModel.getRowCount() > 0){
					Iterator it = selectedRowIndexes.iterator();
					while(it.hasNext()){
						Integer selectedRowIndx = (Integer)it.next();
				  	rec = RMModel.getRecordAt(selectedRowIndx.intValue());
				  	if(rec != null && rec.getOriginalData() != null){
				  		recList.add(rec);
				  	}else{
				  		errorMsg = "Failed to get data from record";
				  	}
					}
			  }
			}catch(Exception e){
				ErrorModel.log.error("Failed to get records to add, lbmId=" + (lbm == null ? "N/A" : lbm.getId()), e);
	  		errorMsg = "An error occured, please try again";				
			}
		}
		
		if(errorMsg.length() == 0){	
			//Create new snapshot
			if(isNew){
				String description = request.getParameter("description");
				if(description == null){
					description = "";
				}
				snapshot = new Snapshot();
				snapshot.setName(name);
				snapshot.setDescription(description);
				snapshot = smgr.addSnapshot(snapshot,userContext);				
				smgr.updateActiveSnapshotInfo(snapshot.getId(),userContext);
			}else{ //Exist snapshot
				snapshot = smgr.getSnapshot(name);// If snapshot is not new, name param is snap id.
				if(snapshot == null){
					errorMsg = "The selected snapshot does not exist";					
				}else	if(!smgr.isSnapshotLocked(snapshot.getId(),userContext)){
					smgr.updateActiveSnapshotInfo(snapshot.getId(),userContext);
				}else{
					errorMsg = "The selected snapshot is currently used by another user and cannot be changed";
				}

			}
		}
		if(errorMsg.length() == 0 && snapshot != null && recList  != null && !recList.isEmpty()){
			//Dispose old snapshot.
			String activeSnapshotId = (String)request.getSession().getAttribute(ACTIVE_SNAPSHOT_ID);
			if(activeSnapshotId != null && activeSnapshotId.length() > 0 && !activeSnapshotId.equalsIgnoreCase(snapshot.getId())){
				Snapshot oldSnapshot = SnapshotManager.getInstance().getSnapshot(activeSnapshotId);				
				if(oldSnapshot != null){
					smgr.removeSnapshotFromMap(oldSnapshot.getId(),userContext);
					oldSnapshot.dispose();
				}		
			}
			try{
				snapshot.addToSnapshot(lbm,recList);
			  request.getSession().setAttribute(ACTIVE_SNAPSHOT_ID,snapshot.getId());
				out.write("ok#" + snapshot.getId()+ "#" + snapshot.getName());
				out.flush();
				return;
			}catch(Exception e){
				errorMsg = "Failed to add recored(s) to snapshot";
				out.write(errorMsg);
				out.flush();
				return;							
			}
		}else{
			out.write(errorMsg);
			out.flush();
			return;							
		}
%>