<%@ page language="java" %> 
<%@page import="xpolog.eye.site.UserEnvironment"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
	String initXML = "snapshot/snapshotListXML.jsp?suffix=snapshot";
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);

%>
<html> 
<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT=0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/logview.css" />

<jsp:include page="../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<jsp:include page="../widgets/grid/jsp/gridListIncluder.jsp" flush="true" >
	<jsp:param name="suffix" value="snapshot" />
	<jsp:param name="multiSelect" value="true" />
	<jsp:param name="scriptsOnly" value="true" />
	<jsp:param name="initXmlUrl" value="snapshot/snapshotListXML.jsp" />														
</jsp:include>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>

<script>

function onLoadSnapshotFrm(){
	clearErrorMsg();
	_initTablesnapshot();
}

	function _initTablesnapshot(){
	var elem = document.getElementById("gridboxsnapshot")
  if (!elem){
    return;
  }
  mygridsnapshot = new dhtmlXGridObject(elem);
	mygridsnapshot.setImagePath(baseDirectory + "dhtmlxSuite/dhtmlxGrid/codebase/imgs/");
  mygridsnapshot.enableKeyboardSupport(true);   
  mygridsnapshot.enableColumnAutoSize(false);
  mygridsnapshot.setNoHeader(true);
  mygridsnapshot.setSkin("xplglistskin");
  mygridsnapshot.attachEvent("onRowSelect",_doOnRowSelectedsnapshot);
  mygridsnapshot.attachEvent("onRowDblClicked",_doOnRowDblClickedsnapshot);
  mygridsnapshot.setMultiselect("true");  
	mygridsnapshot.attachEvent("onXLE",endLoadsnapshot);
  mygridsnapshot.objBox.style.overflowY = "scroll";
  mygridsnapshot.objBox.style.overflowX = "hidden";
 
   mygridsnapshot.init(); 
 
	 showLoadingsnapshot();
   mygridsnapshot.loadXML("snapshotListXML.jsp");
	}

	function _doOnRowSelectedsnapshot(){}

	function _doOnRowDblClickedsnapshot(){
//		_removeSelectedSnapshot0();
	}

function updateSnapshotList(e){
	if(!mygridsnapshot){
		return;		
	}
	var name = document.getElementById('selectSnapshot').value;
	name = updateSnapshotName(name,e)	;
	mygridsnapshot.filterBy(0,name);	
	mygridsnapshot.sortRows(0,"str");		
}

function updateSnapshotName(name,e){
	var keynum;
	var keychar;
	var numcheck;
	
	if(window.event){
		  keynum = e.keyCode;
	  }else if(e.which){
		  keynum = e.which;
	 }
	 if (keynum == 13 || keynum==59 || keynum == 8){
	  if(keynum == 8 && name.length > 0){
	  	name = name.substring(0,(name.length - 1));
	  }
	 }else{	 
			if(keynum == 189){	 
				keychar = '-';
			}else{
				keychar = String.fromCharCode(keynum);
			}			
			name = name + keychar;
		}

 	return name;
}

function showErrorMsg(msg){
		document.getElementById('SelectSnapshotErrorMsgTR').style.display = ""; 	
		document.getElementById('SelectSnapshotErrorMsgTD').innerHTML = msg;
}

function clearErrorMsg(){
		document.getElementById('SelectSnapshotErrorMsgTR').style.display = "none"; 	
		document.getElementById('SelectSnapshotErrorMsgTD').innerHTML = "";
}

function _removeSelectedSnapshot0(){
 if(mygridsnapshot){
	 	var selectedSnapIds = mygridsnapshot.getSelectedId();
	 	if(!selectedSnapIds || selectedSnapIds.length == 0){
				showErrorMsg("Please select snapshot to remove first");							
				return;				 	
	 	}
 			var page = "snapshotRemoveAction.jsp?SNAPSHOT_IDS=" + selectedSnapIds;
			sendAjaxRequest(page,function(req){
			var result = req.responseText;
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result){
				var msg = "<nobr>Problem removing selected snapshot(s)!</nobr>"
				showErrorMsg(msg);							
				return;			
			}else{
				var refreshMenusId = ""; 
				parent.closeTempDiv();
				var resultArr = result.split("#");
				if(!resultArr || resultArr[0] != "ok"){
					var msg = resultArr[1];
					msg = !msg  || msg == "" ? "<nobr>Problem removing selected snapshot!</nobr> " : msg;
					showErrorMsg(msg);							
					if(resultArr.length > 3){
					 	refreshMenusId = resultArr[3]; 						
					}
					refreshMenus("",refreshMenusId);
					var refresh = resultArr[2];
					//remove removed tab by refreshing the view .
					if(refresh == "true"){
						 var path ="<%=BASE_DIRECTORY + env.getUsePage()%>";
					 frm = getMainViewFrame();
					 if (frm){
						 	frm.location = path;
					 }	
					}
				}else{
					if(resultArr.length > 2){
					 	refreshMenusId = resultArr[2]; 						
					}
					refreshMenus("",refreshMenusId);
					var refresh = resultArr[1];
					//remove removed tab by refreshing the view .
					if(refresh == "true"){
						 var path ="<%=BASE_DIRECTORY + env.getUsePage()%>";
					 frm = getMainViewFrame();
					 if (frm){
						 	frm.location = path;
					 }	
					}
				}
			}
		});	
	 }
}

</script>
</head>
<body style="margin:0;padding:0" onLoad="javascript:onLoadSnapshotFrm()">

<table border="0" cellpadding="0" cellspacing="0" style="padding-top:0px;padding-left:50px;" width="100%" height="100%">
	<tr>		
		<td>
<!-- Text Box part -->
			<div id="selectSnapshotTextbox" style="display:">
			<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="100%">
				<tr style="padding-top:0px;" align="left">	
					<td width="70px" valign="middle">
						<span class="SMALLTEXT">Name Filter:</span>
					</td>	
					<td style="padding-left:3px">
					      <input type="TEXTBOX" class="TEXTBOX" name="selectSnapshot" id="selectSnapshot" onKeyDown="javascript:updateSnapshotList(event);" size="29">                  
					</td>
					<td width="*">&nbsp;</td>
				</tr>
			</table>	
		</div>			
		</td>
	</tr>
	<tr>
			<td>
<!-- Snapshots list grid part -->
			<div id="snapshotListGridDiv" style="display:">
			<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
				<tr style="padding-top:0px;">		
					<td>
						 <jsp:include page="../widgets/grid/jsp/gridListIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="../" />
							<jsp:param name="initXML" value="<%=initXML%>" />
							<jsp:param name="suffix" value="snapshot" />
							<jsp:param name="multiSelect" value="true" />
							<jsp:param name="width" value="266px"/>
							<jsp:param name="height" value="100px"/>
							<jsp:param name="rows" value="7" />
						</jsp:include>
					</td>
				</tr>
			</table>		
			</div>
		</td>
	</tr>
	<tr  style="display:none;" id="SelectSnapshotErrorMsgTR" height="10">
			<td id="SelectSnapshotErrorMsgTD" style="padding-left:50px;padding-top:5px" class="ERROR_MSG"><span>Please Select Snapshot First</span></td>
	</tr>																                      
	
</table>	
</body>
</html>