<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@page import="java.util.Arrays"%>
<%@page import="java.util.List"%>
<%@page import="java.util.LinkedList"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.snapshot.Snapshot"%>
<%@page import="xpolog.eye.site.main.MainViewTabModel"%>
<%@page import="xpolog.eye.site.main.MainViewModel"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@ page language="java" %> 

<%@page import="xpolog.eye.snapshot.SnapshotManager"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
		String SNAPSHOT_ID = "SNAPSHOT_ID";
		String SNAPSHOT_IDS = "SNAPSHOT_IDS";
		String ACTIVE_SNAPSHOT_ID = "ACTIVE_SNAPSHOT_ID";
	  String CURRENT_LOG = "CURRENT_LOG";
		String errorMsg = "";
		String lbmID  = "";
		boolean refresh = false;
		boolean emptySnapList = false;
		String okAction = "ok#";
		List lockedSnapshots = new LinkedList();
		List idsToRemove = new LinkedList();
		String idsStr = request.getParameter(SNAPSHOT_IDS);
		if(idsStr != null && idsStr.length() > 0){
			String [] ids = idsStr.split(",");
			if(ids != null || ids.length > 0){
				idsToRemove = Arrays.asList(ids);
			}			
		}else{		
			String snapId = request.getParameter(SNAPSHOT_ID);
			if(snapId != null && snapId.length() > 0){
				idsToRemove.add(snapId);
			}
			
		}
		UserEnvironment env = UserEnvironment.getUserEnvironment(request);
		UserContext userContext = UserEnvironment.getUserContext(request);

		//Snapshots lock check
		SnapshotManager snapMgr = SnapshotManager.getInstance();
		for(int j = 0 ; j < idsToRemove.size() ; j++){
			String id = (String)idsToRemove.get(j);
			if(snapMgr.isSnapshotLocked(id,userContext)){
	//			errorMsg = "This snapshot is currently used by another user and cannot be removed";
				Snapshot snap = snapMgr.getSnapshot(id);
				if(snap != null){
					lockedSnapshots.add(snap.getName());
				}
			}else if (id != null){
				try{
				SnapshotManager mgr = SnapshotManager.getInstance();
				Snapshot snapshot = SnapshotManager.getInstance().getSnapshot(id);
				if(snapshot != null){
					if(snapshot.getLogView() != null){
						lbmID = snapshot.getLogView().getId();
					}
					snapshot.dispose();
				}
				mgr.removeSnapshot(id);
				//Remove tab issues
				if(lbmID != null && lbmID.length() > 0){
					MainViewModel model = env.getMainViewModel();
					MainViewTabModel tab = model.getOnlineTabByDataId(lbmID);
					if (tab != null){
						refresh = true;
				  	model.removeTab(tab);
					}
				}
				if(mgr.getSnapshotsMap() != null && mgr.getSnapshotsMap().isEmpty()){
					emptySnapList = true;
				}
				String activeSnapshotId = (String)request.getSession().getAttribute(ACTIVE_SNAPSHOT_ID);
				if(activeSnapshotId != null && activeSnapshotId.length() > 0 && activeSnapshotId.equalsIgnoreCase(id)){
					request.getSession().setAttribute(ACTIVE_SNAPSHOT_ID,"");
				  request.getSession().removeAttribute(CURRENT_LOG);
	
				}
				}catch(Exception e){
					errorMsg = "An error occured, please try again";
				}
			}
		}
		okAction += refresh ? "true#" : "false#";
		okAction += emptySnapList ?  "" : "Snapshot";			
		if(lockedSnapshots != null && lockedSnapshots.size() > 0){
			String names = "";
			if(lockedSnapshots.size() > 1){
				for(int i = 0; i < lockedSnapshots.size() ; i++){
					if(i < 1){
						names += ", ";
					}
					names += (String)lockedSnapshots.get(i);					
				}
				errorMsg = "The following snapshot(s) are currently used by another user and cannot be removed: <br>" + names;
			}else{
				errorMsg = "The snapshot " + (String)lockedSnapshots.get(0) + " is currently used by another user and cannot be removed";
			}	
			//errorMsg += refresh ? "#true#" : "#false#";
			//errorMsg += emptySnapList ?  "" : "Snapshot";			
		}

		String result = "";
		String getAsXMLStr = request.getParameter("getAsXML");
		boolean getAsXML = getAsXMLStr != null && getAsXMLStr.equals("true");
		if(getAsXML){
			boolean success = errorMsg.length() == 0;
			result = GridModelActionsHelper.getResultXML(success,errorMsg);
			response.setContentType("text/xml");
			response.setHeader("Pragma-Control", "no-cache");
			response.setHeader("Cache-Control", "no-cache");
			response.setHeader("Expires", "0");
		}else{
			result = errorMsg.length() > 0 ? "error#" + errorMsg : okAction;
		}
 		
		out.write(result);
		out.flush();
		return;
%>