<%@ page language="java"%>

<%@page import="xpolog.eye.site.startup.ui.*"%>

<%!
	static final String BASE_DIRECTORY = "../";
	static final String IMAGES_BASE_DIRECTORY = BASE_DIRECTORY + "images/startup/";
%>

<%
	StartupUIController startupUIController = (StartupUIController)session.getAttribute(StartupUIController.STARTUP_UI_CONTROLLER_TYPE);
	if(startupUIController == null) {
		startupUIController = new StartupUIController();
		session.setAttribute(StartupUIController.STARTUP_UI_CONTROLLER_TYPE, startupUIController);
	}else {
		String clearController = request.getParameter("clearController");
		if(clearController != null) {
			startupUIController = new StartupUIController();
			session.setAttribute(StartupUIController.STARTUP_UI_CONTROLLER_TYPE, startupUIController);
		}
	}
	StartupUIPage startupUIPage = startupUIController.getCurrentPage();
	String topImage = null;
	String headerButton1Image = null;
	String headerButton1Text = null;
	String headerButton2Image = null;
	String headerButton2Text = null;
	String headerButton3Image = null;
	String headerButton3Text = null;
	boolean showAdvancedLink = false;
	String advancedPageName = null;
	String mainPageName = null;
	String footerButton1Image = null;
	String footerButton2Image = null;
	String footerButton3Image = null;
	String actionPage = null;
	if(startupUIPage != null) {
		topImage = startupUIPage.getTopImage();
		headerButton1Image = startupUIPage.getHeaderButton1Image();
		headerButton1Text = startupUIPage.getHeaderButton1Text();
		headerButton2Image = startupUIPage.getHeaderButton2Image();
		headerButton2Text = startupUIPage.getHeaderButton2Text();
		headerButton3Image = startupUIPage.getHeaderButton3Image();
		headerButton3Text = startupUIPage.getHeaderButton3Text();
		showAdvancedLink = startupUIPage.isShowAdvancedLink();
		advancedPageName = "advanced";//startupUIPage.getAdvancedPageName();
		mainPageName = startupUIPage.getMainPageName();
		footerButton1Image = startupUIPage.getFooterButton1Image();
		footerButton2Image = startupUIPage.getFooterButton2Image();
		footerButton3Image = startupUIPage.getFooterButton3Image();
		actionPage = startupUIPage.getActionPage();
	}
%>

<html>

<head>
	<meta http-equiv="Content-Language" content="en-us">
	<meta http-equiv="CACHE-CONTROL" content="NO-CACHE">
	<meta http-equiv="PRAGMA" content="NO-CACHE">
	<meta http-equiv="EXPIRES" content="0">
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/startup.css" />
	
	<script>
	
	function updateProgress(percentage, message) {
		if(parseInt(percentage) == 0) {
			document.getElementById("progressBar").width = "10%";
			document.getElementById("progressBackground").width = "90%";
		}else if(parseInt(percentage) == 100) {
			document.getElementById("progressBar").width = "99%";
			document.getElementById("progressBackground").width = "1%";
		}else {
			document.getElementById("progressBar").width = (percentage + "%");
			document.getElementById("progressBackground").width = ((100 - percentage) + "%");
		}
		document.getElementById("progressText").innerHTML = message;
	}
	
	function hideShowHostApplication(hostNum) {
		var hostApplicationsDiv = document.getElementById("network" + hostNum + "ApplicationsDiv");
		var hostApplicationsDivLink = document.getElementById("showNetwork" + hostNum + "Applications");
		var display = hostApplicationsDiv.style.display;
		if(display == "") {
			hostApplicationsDiv.style.display = "none";
			hostApplicationsDivLink.innerText = "Show Applications";
		}else {
			hostApplicationsDiv.style.display = "";
			hostApplicationsDivLink.innerText = "Hide Applications";
		}
	}
	
	function changeButtonLayout(image, action, name) {
		if(action == "over") {
			image.src = "<%=IMAGES_BASE_DIRECTORY %>" + name + "ButtonClicked.gif";
		}else {
			image.src = "<%=IMAGES_BASE_DIRECTORY %>" + name + "ButtonEnabled.gif";
		}
	}
	
	function doSubmit(image, command) {
		image.src = "<%=IMAGES_BASE_DIRECTORY %>" + command + "ButtonClicked.gif";
		document.access.command.value = command;
		document.access.submit();
	}
	
	</script>

</head>

<body style="margin:0">

<form AUTOCOMPLETE="OFF" id="access" name="access" action="<%=actionPage %>">
<input type="hidden" name="command">
<table border="0" height="100%" width="100%" cellspacing="0" cellpadding="0">
  <tr valign="top">
    <td valign="top" align="center">
    	<table border="0" width="100%" cellspacing="0" cellpadding="0">
      	<tr>
      		<td align="center" width="600">
        		<table border="0" width="100%" cellspacing="0" cellpadding="0">
	        		<tr height="317">
	        			<td align="center">
	        				<img border="0" src="<%=IMAGES_BASE_DIRECTORY + topImage %>">
	        			</td>
	        		</tr>
	        		<tr>
	        			<td align="center" background="<%=IMAGES_BASE_DIRECTORY %>titleBackground.gif">
	        				<table border="0" width="100%" cellspacing="0" cellpadding="0">
	        					<tr>
	        						<td width="3%">&nbsp;</td>
	        						<td width="16" style="padding-left:5">
	        							<img src="<%=IMAGES_BASE_DIRECTORY + headerButton1Image %>" align="middle">
	        						</td>
	        						<td width="80" align="left" valign="center" style="padding-left:3">
	        							<span class="STARTUP_STEP_TITLE_TEXT"><%=headerButton1Text %></span>
	        						</td>
	        						<td width="16" style="padding-left:15">
	        							<img src="<%=IMAGES_BASE_DIRECTORY + headerButton2Image %>" align="middle">
	        						</td>
	        						<td width="90" align="left" valign="center" style="padding-left:3">
	        							<span class="STARTUP_STEP_TITLE_TEXT"><%=headerButton2Text %></span>
	        						</td>
	        						<td width="16" style="padding-left:15">
	        							<img src="<%=IMAGES_BASE_DIRECTORY + headerButton3Image %>" align="middle">
	        						</td>
	        						<td width="80" align="left" valign="center" style="padding-left:3;">
	        							<span class="STARTUP_STEP_TITLE_TEXT"><%=headerButton3Text %></span>
	        						</td>
	        						<td width="*">&nbsp;</td>
	        					</tr>
	        				</table>
	        			</td>
	        		</tr>
	        		<tr>
	        			<td>
	        				<iframe src="startupTemplateBody.jsp" scrolling="auto" height="100%" width="100%">
	        					<table>
	        						<tr>
						        		<jsp:include flush="true" page="<%=mainPageName %>">
						        			<jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY %>"/>
						        			<jsp:param name="actionPage" value="<%=actionPage %>"/>
						        		</jsp:include>
						        	</tr>
						        </table>
						      </iframe>
						    </td>
						  </tr>
	        		<tr height="*"></tr>
	        		<tr height="20" valign="bottom">
	        			<td align="center">
	        				<table border="0" width="100%" cellspacing="0" cellpadding="0">
	        					<hr size="1" width="94%">
	        					<tr>
	        						<td width="3%">&nbsp;</td>
	        						<td align="left" valign="center" width="50"><img src="<%=IMAGES_BASE_DIRECTORY %>xplgLogo.gif"></td>
	        						<td><span class="STARTUP_FOOTER_TEXT" valign="center" style="padding-left:2">Go to <a href="http://www.xplg.com" class="STARTUP_FOOTER_LINK" target="_blank">XPLG web site</a> for more add ons</span></td>
	        						<td align="right" valign="center" width="50">
	        							<%
	        							if(footerButton1Image != null && !footerButton1Image.equals("")) {
	        							%>
	        								<img id="button1" valign="center" src="<%=IMAGES_BASE_DIRECTORY + footerButton1Image %>" onmouseover="changeButtonLayout(this, 'over', 'back')" onmouseout="changeButtonLayout(this, 'out', 'back')" onclick="doSubmit(this, 'back');">
	        							<%
	        							}
	        							%>
	        						</td>
	        						<td align="right" valign="center" width="50">
	        							<%
	        							if(footerButton2Image != null && !footerButton2Image.equals("")) {
	        							%>
	        								<img id="button2" valign="center" src="<%=IMAGES_BASE_DIRECTORY + footerButton2Image %>" onmouseover="changeButtonLayout(this, 'over', 'next')" onmouseout="changeButtonLayout(this, 'out', 'next')" onclick="doSubmit(this, 'next');">
	        							<%
	        							}
	        							%>
	        						</td>
	        						<td align="right" valign="center" width="50" style="padding-right:5">
	        							<%
	        							if(footerButton3Image != null && !footerButton3Image.equals("")) {
	        							%>
	        								<img id="button3" valign="center" src="<%=IMAGES_BASE_DIRECTORY + footerButton3Image %>" onmouseover="changeButtonLayout(this, 'over', 'done')" onmouseout="changeButtonLayout('this, out', 'done')" onclick="doSubmit(this, 'done');">
	        							<%
	        							}
	        							%>
	        						</td>
	        						<td width="3%">&nbsp;</td>
	        					</tr>
	        				</table>
	        			</td>
	        		</tr>
	        	</table>
        	</td>
        </tr>
      </table>
    </td>
  </tr>
</table>
</form>
</body>
</html>