<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.media.Account"%>
<%@ page import="xpolog.eye.media.auth.win.WinAuthenticationAccount"%>
<%@ page import="xpolog.eye.media.telsh.TelnetAccount"%>
<%@ page import="xpolog.eye.site.startup.*"%>
<%@ page import="xpolog.eye.util.Constants"%>

<%@ page import="java.text.SimpleDateFormat"%>
<%@ page import="java.util.*"%>

<%!

String dateFormat = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat", "MM/dd/yyyy HH:mm:ss");
String msSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator", ".");
String defaultDashboardDays = Configuration.getInstance().getPropertiesManager().getProperty("wizard.defaultDashboardDays", "30");
String dateFormatMS = dateFormat + msSeperator + "SSS";
String timeFormat = "HH:mm:ss";

private String getAccountDetail(Account account, String detailId) {
	if(account == null) {
		return "";
	}
	if(account instanceof WinAuthenticationAccount) {
		WinAuthenticationAccount winAccount = (WinAuthenticationAccount)account;
		if(detailId != null) {
			if(detailId.equals("port")) {
				return "";
			}else if(detailId.equals("username")) {
				return winAccount.getUser() + "";
			}else if(detailId.equals("password")) {
				if(winAccount.getPassword() != null && !winAccount.getPassword().equals("")) {
					return "********";
				}
			}
		}
	}else {
		TelnetAccount sshAccount = (TelnetAccount)account;
		if(detailId != null) {
			if(detailId.equals("port")) {
				return Integer.toString(sshAccount.getPort());
			}else if(detailId.equals("username")) {
				return sshAccount.getUserName();
			}else if(detailId.equals("password")) {
				return "********";
			}
		}
	}
	return "";
}

public String transformDateToString(Date d, long timeDiff) {
	if (d == null) {
		return null;
	}
	if (timeDiff != 0) {
		long time = d.getTime();
		d = ((Date) d.clone());
		d.setTime(time + timeDiff);
	}
	//01/31/2003 01:42:34
	String format = "";
	if (d.getTime() % 1000 == 0) {
		format = dateFormat;
	} else {
		format = dateFormatMS;
	}
	String str = new SimpleDateFormat(format).format(d);
	return str;
}

%>

<%
String BASE_DIRECTORY = request.getParameter("BASE_DIRECTORY");
String IMAGES_BASE_DIRECTORY = BASE_DIRECTORY + "images/startup/";
String actionPage = request.getParameter("actionPage");
String heightStr = request.getParameter("height");
String bottomHeightStr = "120";
int topHeight = Integer.parseInt(heightStr) - Integer.parseInt(bottomHeightStr); //247

StartupViewHelper helper = (StartupViewHelper)request.getSession().getAttribute(StartupViewHelper.STARTUP_HELPER_TYPE);
ArrayList localApps = helper.getSelectedLocalApps();
ArrayList networkHosts = helper.getSelectedNetworkHosts();

String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);

String DATE_FILTER = "DateFilter";
String DATE_MIN_FILTER_ACTIVE = "DateMinFilterActive";
String DATE_MAX_FILTER_ACTIVE = "DateMaxFilterActive";
String DATE_MIN_FILTER_ACTIVE_PARAM = "DATE_MIN_FILTER_ACTIVE_PARAM";
String DATE_MAX_FILTER_ACTIVE_PARAM = "DATE_MAX_FILTER_ACTIVE_PARAM";
String DATE_MINIMUM = "DateMinimum";
String DATE_MAXIMUM = "DateMaximum";
String DATE_FILTER_MINIMUM_PARAM = "DATE_FILTER_MINIMUM_PARAM";
String DATE_FILTER_MAXIMUM_PARAM = "DATE_FILTER_MAXIMUM_PARAM";

Date minDate = null;
Date maxDate = null;
String minDateStr = "";
String maxDateStr = "";
String minStat = "";
String maxStat = "";
String timeunit = "";
String isTimeLim = "";
String daystatsel1 = "";
String minstatsel1 = "";
String hourstatsel1 = "";
String monthstatsel2 = "";
String weekstatsel2 = "";
String daystatsel2 = "";
String daystatsel3 = "selected";
String hourstatsel3 = "";
String istoday = "";
String islast = "";
String isprevious = "";
String isfrom = "";
String selectedIndex = "1";
long timeDiff = 0;
String fromlastdaysat = "";
String timeWindowSize = "0";
String dayswindowsizesel = "";
String hourswindowsizesel = "";

FilterCollection fc = null;
DateFilter datefl = new DateFilter();
datefl.setColIndex(0);
NumberFilter numberfl = new NumberFilter();
numberfl.setColIndex(1);

fc = helper.getFilterCollection();
if (fc != null && fc.getByName(DATE_FILTER) != null && fc.getByName(DATE_FILTER).size() > 0) {
	datefl = (DateFilter) fc.getByName(DATE_FILTER).get(0);
	if (datefl.getTimeType() == -1) {
		minDate = datefl.getMinDate();
		maxDate = datefl.getMaxDate();
	} else if (datefl.getTimeOpType() == 1) {
		isTimeLim = "checked";
		islast = "selected";
		selectedIndex = "1";
		timeunit = String.valueOf(datefl.getTimeGap());
		if (datefl.isDays()) {
			daystatsel1 = "selected";
			if (datefl.getTimeGap() == 0) {
				istoday = "selected";
				selectedIndex = "0";
			}
		} else if (datefl.isHours()) {
			hourstatsel1 = "selected";
		} else {
			minstatsel1 = "selected";
		}
	} else if (datefl.getTimeOpType() == 2) {
		selectedIndex = "2";
		isTimeLim = "checked";
		isprevious = "selected";
		timeunit = String.valueOf(datefl.getTimeGap());					
		if (datefl.isDays()) {
			daystatsel2 = "selected";
		} else if (datefl.isWeeks()) {
			weekstatsel2 = "selected";
		} else if (datefl.isMonths()) {
			monthstatsel2 = "selected";
		}
	} else if (datefl.getTimeOpType() == 3) {
		selectedIndex = "3";
		isTimeLim = "checked";
		isfrom = "selected";
		timeunit = String.valueOf(datefl.getTimeGap());
		if (datefl.isDays()) {
			daystatsel3 = "selected";
			hourstatsel3 = "";
		} else if (datefl.isMonths()) {
			hourstatsel3 = "selected";
		}
	}
}else {
	isTimeLim = "checked";
	islast = "selected";
	selectedIndex = "1";
	timeunit = defaultDashboardDays;
	daystatsel1 = "selected";
}

Date at = new Date(datefl.getFromGap());
SimpleDateFormat simpleFormat = new SimpleDateFormat(timeFormat);
simpleFormat.setTimeZone(TimeZone.getTimeZone("GMT"));
fromlastdaysat = simpleFormat.format(at);

long windowSize = 0;
if (datefl.getTimeWindowSize() == 0 || datefl.getTimeWindowSize() % (24 * 60 * 60 * 100) == 0) {
	windowSize = datefl.getTimeWindowSize() / (24 * 60 * 60 * 1000);
	dayswindowsizesel = "selected";
} else {
	windowSize = datefl.getTimeWindowSize() / (60 * 60 * 1000);
	hourswindowsizesel = "selected";
}
timeWindowSize = String.valueOf(windowSize);

timeDiff = Long.parseLong(defaultDashboardDays);
long minTimeDiff = timeDiff;
if (minDate == null) {
	minDate = new Date();
	long t = minDate.getTime();
	minDate.setTime(t - (t % 1000) - (minTimeDiff * 24 * 60 * 60 * 1000));
	minTimeDiff = 0;
} else {
	minStat = "checked";
}

long maxTimeDiff = timeDiff;
if (maxDate == null) {
	maxDate = new Date();
	long t = maxDate.getTime();
	maxDate.setTime(t - (t % 1000));
	maxTimeDiff = 0;
} else {
	maxStat = "checked";
}
minDateStr = transformDateToString(minDate, minTimeDiff);
maxDateStr = transformDateToString(maxDate, maxTimeDiff);
%>

<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/calendar/calendar2.js"></script>

<script>
var selectedIndex = <%=selectedIndex%>;

function shownHideAdvanced() {
	var advancedScroller = document.getElementById("advancedScroller");
	var display = document.getElementById("advancedScroller").style.display;
	if(display == ""){
		advancedScroller.style.display  = "none";
	}else{
		advancedScroller.style.display  = "";
	}	
}

function shownHidediv(targetDiv){
 var d = document.getElementById(targetDiv);
 if(!d) {
   return;
  }      
  show = d.style.display == "";
  if(show) {
    d.style.display="none";   		
  }else {
    d.style.display="";
  }	
}

function changeDates(radio) {
	var timeLimMin = document.getElementById('TimeLimMin');
	var timeLimMax = document.getElementById('TimeLimMax');
	if(radio.id == 'TimeLimRadio') {
		timeLimMin.checked = true;
		timeLimMax.checked = true;
	}else {
		timeLimMin.checked = false;
		timeLimMax.checked = false;
	}
}

function changeTimeType(combo){
  shownHidediv("timeType" + selectedIndex + "Div");
  var index = combo.selectedIndex;
  if (index >= 0){ 
    selectedIndex = index+1;
    shownHidediv("timeType" + selectedIndex + "Div");
  }
  //showFromInfo();
  updateTimeParams();
}

function showFromInfo(){
	if (selectedIndex == 3){
		if (document.access.TimeUnit3.selectedIndex == 1){
			document.getElementById("fromLastDaysAtDiv").style.display = "";
		}
		document.getElementById("timeWindowSizeDiv").style.display = "";
	}else{
		document.getElementById("fromLastDaysAtDiv").style.display = "none";
		document.getElementById("timeWindowSizeDiv").style.display = "none";
	}
}

function updateTimeParams(){
	if (selectedIndex == 0){
		document.access.TimeUnit.value = "days";
		document.access.TimeText.value = "0";
	}else{
		document.access.TimeUnit.value = eval("document.access.TimeUnit"+selectedIndex).value;
		document.access.TimeText.value = eval("document.access.TimeText"+selectedIndex).value;
	}
	if (selectedIndex == 1){
		document.access.TimeOpType.value = "1";
	}else if (selectedIndex == 2){
		document.access.TimeOpType.value = "2";
	}else {
		document.access.TimeOpType.value = "3";
	}
}

function checkDate(date_check_box, date_obj){
 	date_ok = "";
 	obj_name = date_check_box.name;
 	frames['dateValidationFrame'].location = "<%=BASE_DIRECTORY%>calendar/dateValidation.jsp?dateStr="+date_obj.value+"&date_check_box="+obj_name;
 }
</script>

<input type="hidden" name="TimeUnit" value="days">
<input type="hidden" name="TimeText" value="<%=defaultDashboardDays %>">
<input type="hidden" name="TimeOpType" value="1">

<td align="center" valign="top">
	<div id="scroller" style="overflow:auto; width:100%; height:<%=topHeight %>;"> 
	<table border="0" width="100%" cellspacing="0" cellpadding="0">
		<tr height="5">
			<td width="3%"></td>
			<td width="550"></td>
			<td width="14"></td>
	  	<td width="3%"></td>
	  </tr>
		<tr height="20">
			<td width="3%">&nbsp;</td>
			<td width="550"align="left" style="padding-left:5" background="<%=IMAGES_BASE_DIRECTORY %>step2Background.gif"><span class="STARTUP_BODY_TITLE_TEXT">Local Applications' Configuration Status</span></td>
			<td width="14" align="left" style="padding-right:5" background="<%=IMAGES_BASE_DIRECTORY %>step2Background.gif"><a id="showLocalApplications" href="javascript:hideShowLocalApplications()" class="STARTUP_TABLE_TEXT_LINK">Hide</a></td>
			<td width="3%">&nbsp;</td>
		</tr>
		<tr style="padding-top:2">
			<td width="3%">&nbsp;</td>
      <td colspan="2">
      	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
        	<tr>
	       		<td>
	       		<div id="localApplicationsDiv">
		       		<table border="0" cellpadding="0" cellspacing="0" width="100%">
       		<%
       			StartupApplication app = null;
	       		if(helper.getLocalApps().size() == 0) {
	       	%>
				       	<tr>
			         		<td width="170" style="padding-left:5"><span class="STARTUP_BODY_TABLE_TEXT">No applications were found</span></td>
									<td width="380"></td>
			 		      	<td width="*"></td>
			          </tr>
	       	<%
	       		}else if(localApps.size() == 0) {
       		%>
			        	<tr>
			         		<td width="170" style="padding-left:5"><span class="STARTUP_BODY_TABLE_TEXT">No applications were selected</span></td>
									<td width="380"></td>
			 		      	<td width="*"></td>
			          </tr>
          <%
         		}else {
          		for(int i = 0; i < localApps.size(); i++) {
								app = (StartupApplication)localApps.get(i);
								if(app.isSelected()) {
         	%>
			       	 	<tr <%=i % 2 == 1 ? "class=\"STARTUP_TABLE_COLORED_ROW\"" : "" %>>
			        		<td width="170" style="padding-left:5"><span class="STARTUP_BODY_TABLE_TEXT"><%=app.getName()%></span></td>
									<td width="380"><span class="STARTUP_BODY_TABLE_TEXT"><%=app.getConfMessage()%></span></td>
			          	<td width="*"></td>
			        	</tr>
        	<%
								}
         			}
        		}
       		%>
       				</table>
	       		</div>
       			</td>
       		</tr>
        </table>
      </td>
      <td width="3%">&nbsp;</td>
    </tr>
    <tr height="5">
			<td width="3%"></td>
			<td width="550"></td>
			<td width="14"></td>
	  	<td width="3%"></td>
	  </tr>
		<tr height="20">
			<td width="3%">&nbsp;</td>
			<td width="550"align="left" style="padding-left:5" background="<%=IMAGES_BASE_DIRECTORY %>step2Background.gif"><span class="STARTUP_BODY_TITLE_TEXT">Network Applications' Configuration Status</span></td>
			<td width="14" align="left" style="padding-right:5" background="<%=IMAGES_BASE_DIRECTORY %>step2Background.gif"><a id="showNetworkApplications" href="javascript:hideShowNetworkApplications(true)" class="STARTUP_TABLE_TEXT_LINK">Hide</a></td>
			<td width="3%">&nbsp;</td>
		</tr>
		<tr style="padding-top:2">
			<td width="3%">&nbsp;</td>
      <td colspan="2">
       	<div id="networkApplicationsDiv">
       	<table border="0" width="100%" cellspacing="0" cellpadding="0">
     		<%
     			if(helper.getNumberOfHosts() == 0) {
     		%>
     			<tr class="STARTUP_BODY_TABLE_TEXT">
		    		<td width="5"></td>
		    		<td width="500">No hosts were added</td>
		    		<td width="14"></td>
		    	</tr>
		    <%
     			}else if(networkHosts.size() == 0) {
     		%>
     			<tr class="STARTUP_BODY_TABLE_TEXT">
		    		<td width="5"></td>
		    		<td width="500">No hosts were selected</td>
		    		<td width="14"></td>
		    	</tr>
		    <%
     			}else {
		    %>
		    	<tr>
		    		<td colspan="3">
					    <table border="0" width="100%" cellspacing="0" cellpadding="0">
		    <%
		    		NetworkHost networkHost = null;
		    		ArrayList networkHostApps = null;
		    		app = null;
		    		for(int i = 0; i < networkHosts.size(); i++) {
		    			networkHost = (NetworkHost)networkHosts.get(i);
		    			if(networkHost.isSelected()) {
			    			networkHostApps = networkHost.getSelectedNetworkApps();
		    %>
					    	<tr>
					    		<td>
					    			<table border="0" width="100%" cellspacing="0" cellpadding="0">
					    				<tr <%=i % 2 == 1 ? "class=\"STARTUP_TABLE_COLORED_ROW\"" : "" %>>
								    		<td width="5"></td>
								    		<td width="500" class="STARTUP_BODY_TABLE_TEXT">Host: <%=networkHost.getHost() %>, OS Type: <%=networkHost.getOsType() %><%=!getAccountDetail(networkHost.getAccount(), "username").equals("") ? ", Username: " + getAccountDetail(networkHost.getAccount(), "username") : "" %></td>
								    		<td width="14" align="left" style="padding-right:2"><a id="showNetwork<%=networkHost.getIndex() %>Applications" href="javascript:hideShowHostApplications(<%=networkHost.getIndex() %>)" class="STARTUP_TABLE_TEXT_LINK">Hide</a></td>
								    	</tr>
								    	<tr>
								    		<td colspan="3">
								    		<div id="network<%=networkHost.getIndex() %>ApplicationsDiv">
								    			<table border="0" width="100%" cellspacing="0" cellpadding="0">
		    <%
			    			if(networkHostApps.size() == 0) {
		    %>
								    				<tr>
															<td width="5"></td>
															<td width="500" style="padding-left:10"><span class="STARTUP_BODY_TABLE_TEXT">No applications were found</span></td>
															<td width="14"></td>
														</tr>
		    <%
			    			}else {
			    				for(int j = 0; j < networkHostApps.size(); j++) {
			    					app = (StartupApplication)networkHostApps.get(j);
			    					if(app.isSelected()) {
		    %>
								    				<tr <%=j % 2 == 1 ? "class=\"STARTUP_TABLE_COLORED_ROW\"" : "" %>>
								    					<td width="167" style="padding-left:10"><span class="STARTUP_BODY_TABLE_TEXT"><%=app.getName() %></span></td>
								    					<td width="380"><span class="STARTUP_BODY_TABLE_TEXT"><%=app.getConfMessage() %></span></td>
								    					<td width="*"></td>
								    				</tr>
		    <%
			    					}
			    				}
		    				}
		    %>
		    									</table>
		    								</div>
		    							</tr>
		    						</table>
		    					</td>
		    				</tr>
		    <%
		    			}
		    		}
		    %>
		    			</table>
		    		</td>
		    	</tr>
		    <%
		    	}
		    %>
		    </table>
		    </div>
		   </td>
		   <td width="3%">&nbsp;</td>
    </tr>
	</table>
	</div>
	<div id="wrapperDiv" style="overflow:auto; width:100%; height:<%=bottomHeightStr %>;">
	<div id="advancedScroller" style="display:none; overflow:auto; width:100%; height:120;"> 
	<table border="0" width="100%" cellspacing="0" cellpadding="0">
		<tr class="STARTUP_TABLE_HEADER" background="<%=IMAGES_BASE_DIRECTORY %>titleBackground.gif" height="10">
			<td width="3%">&nbsp;</td>
      <td width="94%">
      	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
        	<tr>
        		<td width="100%" class="STARTUP_BODY_TABLE_HEADER"><%=analyticsH %> Time Rule</td>
	       	</tr>
	      </table>
	    </td>
	    <td width="3%">&nbsp;</td>
	  </tr>
		<tr>
      <td width="3%">&nbsp;</td>
			<td>
			   <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
         	<!--<tr>
          	<td><span class="STARTUP_BODY_TITLE_TEXT">Time Filter</span></td>
          </tr>-->
					<tr>
						<td width="100%" valign="top">
						<div id="filtersDiv" style="">
							<table border="0" width="100%" cellspacing="0" cellpadding="0">
								<tr>
									<td width="20"><input type="radio" id="TimeLimRadio" checked name="Dates" value="TimeLimRadio" onclick="javascript:changeDates(this)"></td>
									<td width="100%">&nbsp;<span class="STARTUP_BODY_TABLE_TEXT">Dates limit&nbsp;(<%=dateFormat%>)</span></td>
								</tr>
								<tr>
									<td width="20">&nbsp;<iframe name="dateValidationFrame" style="visibility:hidden" width="0" height="0"></iframe></td>
									<td width="100%">
										<table border="0" width="100%">
											<tr>
												<td width="20" valign="bottom"><input class="STARTUP_BODY_TABLE_TEXT" type="checkbox" id="TimeLimMin" name="<%=DATE_MIN_FILTER_ACTIVE%>" <%=minStat%>></td>
												<td width="60%"><span class="STARTUP_BODY_TABLE_TEXT"><b>From</b>&nbsp;</span> <input class="TEXT_BOX" type="text" size="25" onChange="javascript:checkDate(document.access.<%=DATE_MIN_FILTER_ACTIVE%>,document.access.<%=DATE_MINIMUM%>)" name="<%=DATE_MINIMUM%>" value="<%=minDateStr%>" style="font-size: 8pt"
														onchange="this.checked='true'" onclick="document.access.TimeLimRadio.checked='true'">&nbsp;<a href="javascript:openCal7();" onclick="document.access.TimeLimRadio.checked='true'" class="STARTUP_TABLE_TEXT_LINK">calendar</a></td>
												<td>&nbsp;</td>
											</tr>
											<tr>
												<td width="20" valign="bottom"><input class="STARTUP_BODY_TABLE_TEXT" type="checkbox" id="TimeLimMax" name="<%=DATE_MAX_FILTER_ACTIVE%>" <%=maxStat%>></td>
												<td width="60%"><span class="STARTUP_BODY_TABLE_TEXT"><b>to</b>&nbsp;</span> <input class="TEXT_BOX" type="text" size="25" onChange="javascript:checkDate(document.access.<%=DATE_MAX_FILTER_ACTIVE%>,document.access.<%=DATE_MAXIMUM%>)" name="<%=DATE_MAXIMUM%>" value="<%=maxDateStr%>" style="font-size: 8pt"
														onchange="this.checked='true'" onclick="document.access.TimeLimRadio.checked='true'">&nbsp;<a href="javascript:openCal8();" onclick="document.access.TimeLimRadio.checked='true'" class="STARTUP_TABLE_TEXT_LINK">calendar</a></td>
												<td>&nbsp;</td>
											</tr>
										</table>
									</td>
								</tr>
								<tr>
									<td width="20"><input type="radio" id="TimeUnitRadio" name="Dates" <%=isTimeLim%> value="TimeUnitRadio" onclick="javascript:changeDates(this)"></td>
									<td width="100%">
										<table border="0" width="100%">
											<tr>
												<td width="41%">&nbsp;<span class="STARTUP_BODY_TABLE_TEXT">Show records </span> 
													<nobr><select class="TEXT_BOX" size="1" name="TimeType" onfocus="document.access.TimeUnitRadio.checked=true" onchange="javascript:changeTimeType(this)" style="font-size: 8pt">
														<option value="1" <%=islast%>>from the last</option>
														<option value="2" <%=isprevious%>>from the previous</option>
													</select></nobr>
												</td>
												<td width="59%">
												<div id="timeType1Div" <%=(datefl.getTimeOpType() == 1)?"":"style=\"display:none\""%>>
													<input class="TEXT_BOX" type="text" name="TimeText1" size="3" value="<%=timeunit%>" onfocus="document.access.TimeUnitRadio.checked=true" style="font-size: 8pt"> 
													<select class="TEXT_BOX" size="1" name="TimeUnit1" onfocus="document.access.TimeUnitRadio.checked=true" style="font-size: 8pt">
														<option value="minutes" <%=minstatsel1%>>minutes</option>
														<option value="hours" <%=hourstatsel1%>>hours</option>
														<option value="days" <%=daystatsel1%>>days</option>
													</select>
												</div>
												<div id="timeType2Div" <%=(datefl.getTimeOpType() == 2)?"":"style=\"display:none\""%>>
													<input class="TEXT_BOX" type="text" name="TimeText2" size="3" value="<%=timeunit%>" onfocus="document.access.TimeUnitRadio.checked=true" style="font-size: 8pt">
													<select class="TEXT_BOX" size="1" name="TimeUnit2" onfocus="document.access.TimeUnitRadio.checked=true" style="font-size: 8pt">
														<option value="days" <%=daystatsel2%>>days</option>
														<option value="weeks" <%=weekstatsel2%>>weeks</option>
														<option value="months" <%=monthstatsel2%>>months</option>
													</select>
												</div>
												</td>
											</tr>
										</table>
									</td>
								</tr>
							</table>
						</div>
						</td>
					</tr>
        </table>
       </td>
       <td width="3%">&nbsp;</td>
		</tr>
  </table>
  </div>
  </div>
</td>

<script language="JavaScript">
<!-- // create calendar object(s) just after form tag closed
	 // note: you can have as many calendar objects as you need for your application
	var cal7 = new calendar2("<%=BASE_DIRECTORY%>",document.access.<%=DATE_MINIMUM%>,null,<%="/^\\-?\\d+(\\"+msSeperator+"\\d+)*$/"%>,"<%=msSeperator%>");
	cal7.year_scroll = true;
	cal7.time_comp = true;
	var cal8 = new calendar2("<%=BASE_DIRECTORY%>",document.access.<%=DATE_MAXIMUM%>,null,<%="/^\\-?\\d+(\\"+msSeperator+"\\d+)*$/"%>,"<%=msSeperator%>");
	cal8.year_scroll = true;
	cal8.time_comp = true;

	function openCal7(){
		document.access.<%=DATE_MIN_FILTER_ACTIVE%>.checked='true';
		cal7.popup();
	}
	function openCal8(){
		document.access.<%=DATE_MAX_FILTER_ACTIVE%>.checked='true';
		cal8.popup();
	}

//-->
</script>