<%@ page language="java"%>

<%@page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.startup.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
	
	private String buildStatusXml(StartupViewHelper helper) {
		StringBuffer xml = new StringBuffer();
		int numberOfLocalAppsToDetect = helper.getNumberOfLocalAppsToDetect();
		int numberOfLocalAppsCompleted = helper.getNumberOfLocalAppsCompleted();
		int numberOfLocalAppsFound = helper.getNumberOfLocalAppsFound();
		
		xml.append("<process>");
		xml.append("<status finished=\"");
		if(helper.isStopped()) {
			xml.append("true");
		}else {
			xml.append(helper.isLocalDetectionCompleted());
		}
		xml.append("\"/>");
		xml.append("<progressStatus numberOfLocalAppsToDetect=\"");
		xml.append(numberOfLocalAppsToDetect);
		xml.append("\" numberOfLocalAppsCompleted=\"");
		xml.append(numberOfLocalAppsCompleted);		
		xml.append("\" numberOfLocalAppsFound=\"");
		xml.append(numberOfLocalAppsFound);		
		xml.append("\"/>");
		xml.append("</process>");
		
		return xml.toString();
	}
	
	private String buildErrorXml(String error) {
		StringBuffer xml = new StringBuffer();
		
		xml.append("<process>");
		xml.append("<status finished=\"true\"/>");
		xml.append("<error message=\"");
		xml.append("errorMessage:");
		xml.append(error);
		xml.append("\"/>");
		xml.append("</process>");
		
		return xml.toString();
	}
%>

<%
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	final UserContext userContext = env.getUserContext();
	StartupViewHelper helper = null;
	String xml = null;
	boolean valid = SiteManagment.getInstance().getXpologManagment().isValidToBeActive();
	
	if(valid) {
		if(userContext != null) {
			Object obj = request.getSession().getAttribute(StartupViewHelper.STARTUP_HELPER_TYPE);
			if(obj != null) {
				helper = (StartupViewHelper)obj;
			}
		}
		if(helper != null) {
			xml = buildStatusXml(helper);
		}else {
			xml = buildErrorXml("An error occured while detecting local applications. Please reopen the browser window");
		}
	}else {
		xml = buildErrorXml("The Automatic Configuration Wizard cannot run because the license is invalid");
	}
	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	out.write(xml);
	out.flush();
%>
