<%@ page language="java"%>

<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.startup.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
	
	private String buildStatusXml(StartupViewHelper helper) {
		StringBuffer xml = new StringBuffer();
		
		xml.append("<process>");
		xml.append("<status finished=\"");
		if(helper.isStopped()) {
			xml.append("true");
		}else {
			xml.append(helper.isHealthGenerationFinished() && helper.isReportsGenerationFinished());
		}
		xml.append("\"/>");
		xml.append("<progressStatus currentApplication=\"");
		if(helper.getCurrentApplicationName() != null) {
			xml.append(helper.getCurrentApplicationName());
		}
		xml.append("\" currentHost=\"");
		if(helper.getCurrentHostName() != null) {
			xml.append(helper.getCurrentHostName());
		}
		xml.append("\" numberOfAppsReportsCreated=\"");
		/*if(helper.getNumberOfAppsReportsCreated() < (helper.getNumberOfSelectedLocalApps() + helper.getNumberOfSelectedNetworkApps())) {
			xml.append(helper.getNumberOfAppsReportsCreated() + 1);
		}else {
			xml.append(helper.getNumberOfAppsReportsCreated());
		}*/
		xml.append(helper.getNumberOfAppsReportsCreated());
		xml.append("\" numberOfSelectedApps=\"");
		xml.append(helper.getNumberOfSelectedLocalApps() + helper.getNumberOfSelectedNetworkApps());		
		xml.append("\" numberOfCurrentAppReportsGenerated=\"");
		xml.append(helper.getNumberOfCurrentAppReportsGenerated());		
		xml.append("\" numberOfCurrentAppReportsCreated=\"");
		xml.append(helper.getNumberOfCurrentAppReportsCreated());		
		xml.append("\" reportsGenerationFinished=\"");
		xml.append(helper.isReportsGenerationFinished());
		xml.append("\" systemHelthStatus=\"");
		xml.append(helper.getSystemHealthStatus());
		xml.append("\" systemHealthPercent=\"");
		xml.append(helper.getSystemHealthExecutionPercent());
		xml.append("\"/>");
		xml.append("</process>");
		
		return xml.toString();
	}
	
	private String buildErrorXml(String error) {
		StringBuffer xml = new StringBuffer();
		
		xml.append("<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">");
		xml.append("<tr>");
		xml.append("<td width=\"3%\"></td>");
		xml.append("<td width=\"60%\"><span class=\"STARTUP_BODY_TABLE_TEXT\">");
		xml.append(error);
		xml.append("</span></td>");
		xml.append("<td width=\"37%\"></td>");
		xml.append("</tr>");
		xml.append("</table>");
		
		return xml.toString();
	}
%>

<%
	Object obj = request.getSession().getAttribute(StartupViewHelper.STARTUP_HELPER_TYPE);
	StartupViewHelper helper = null;
	if(obj != null) {
		helper = (StartupViewHelper)obj;
	}
	String xml = null;
	
	if(helper != null) {
		xml = buildStatusXml(helper);
	}else {
		xml = buildErrorXml("An error occured while creating dashboard's data");
	}
	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	out.write(xml);
	out.flush();
%>
