<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>


<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%

  String baseDirectory = request.getParameter("baseDirectory");
  if (baseDirectory == null){
  	baseDirectory = BASE_DIRECTORY;
  }
  
  String clusterNode = request.getParameter("clusterNode");
  if (clusterNode == null){
  	clusterNode = "";
  }

	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,null,true)){
		return;
	}
	
	
	
	UserContext user = UserEnvironment.getUserContext(request);
	if (user != null && user.getUser() != null && !user.getUser().isAdmin()){
		response.sendRedirect(BASE_DIRECTORY + "security/common/accessDenied.jsp");
		return;
	}
  SiteManagment mgmt = SiteManagment.getInstance();
  
  UserContext userContext = UserEnvironment.getUserContext(request);
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL, userContext, AuditConstants.VIEW, "view support", AuditConstants.SUPPORT_CONSOLE, "view activity support");
%>


               
<%@page import="java.util.ArrayList"%><div id="processesDiv" style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr><td style="padding:10">
								<jsp:include page="processesInformation.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
                <jsp:param name="clusterNode" value="<%=clusterNode%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>	
							<div id="threadsDiv" style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr><td style="padding:10">
								<jsp:include page="threadsInformation.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
                <jsp:param name="clusterNode" value="<%=clusterNode%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<div id="sshConnectionsDiv" style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
							<tr><td style="padding:10">
								<jsp:include page="sshConnectionsInformation.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
                <jsp:param name="clusterNode" value="<%=clusterNode%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>	
              <div id="jobsDiv" style="display:none;height:100%;width:100%;overflow:auto" >
              <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
              <tr><td style="padding:10">
                <jsp:include page="jobsInformation.jsp" flush="true">
                <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
                <jsp:param name="clusterNode" value="<%=clusterNode%>" />
                </jsp:include>
                </td></tr>
                </table>
              </div>  		
              <div id="httpSessionsDiv" style="display:none;height:100%;width:100%;overflow:auto" >
              <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
              <tr><td style="padding:10">
                <jsp:include page="httpSessionsInformation.jsp" flush="true">
                <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
                <jsp:param name="clusterNode" value="<%=clusterNode%>" />
                </jsp:include>
                </td></tr>
                </table>
              </div>  		
              <%
               ArrayList idsList = new ArrayList();
          	   ArrayList namesList = new ArrayList();
          	   ArrayList widthsList = new ArrayList();
          	   idsList.add("processesDiv");
          	   namesList.add("Processes");
          	   widthsList.add("120");
               
          	   idsList.add("threadsDiv");
        	     namesList.add("Threads");
        	     widthsList.add("120");
             
        	     idsList.add("sshConnectionsDiv");
          	   namesList.add("SSH Connections");
          	   widthsList.add("150");
               
          	   idsList.add("jobsDiv");
        	     namesList.add("Jobs");
        	     widthsList.add("120");
             
          	   idsList.add("httpSessionsDiv");
        	     namesList.add("HTTP Sessions");
        	     widthsList.add("120");
             
               
          	  String [] tabIds = (String [])idsList.toArray(new String[idsList.size()]);
          	  String [] tabNames = (String [])namesList.toArray(new String[namesList.size()]);
          	  String [] tabWidths = (String [])widthsList.toArray(new String[widthsList.size()]);
          	  
          	  request.setAttribute("tabIds",tabIds);
          	  request.setAttribute("tabNames",tabNames);
          	  request.setAttribute("tabWidths",tabWidths);
              
              %>			
							<jsp:include page="../../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />							
							</jsp:include>																		
