<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.ui.grid.GridTable"%>
<%@ page import="xpolog.eye.site.ui.grid.models.support.SystemHTTPSessionsGridTableModel"%>

<%!static final String BASE_DIRECTORY = "../../";%>

<%

	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, ActionsPermissionConstants.AutomationPermissions.TASKS_PERMISSION, true)) {
		return;
	}

	
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = "../../";
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
  
	String clusterNode = request.getParameter("clusterNode");
	if (clusterNode == null){
	  clusterNode = "";
	}	
	
	SystemHTTPSessionsGridTableModel model = new SystemHTTPSessionsGridTableModel();
	model.setBaseDirectory(baseDirectory);
	model.setUserContext(userContext);
	model.setGridName("mygrid" + suffix);
	model.setClusterNode(clusterNode);
  
	model.init();
	GridTable table = new GridTable(model);
	request.setAttribute("gridTable" + suffix,table);
	
	request.getRequestDispatcher(BASE_DIRECTORY + "widgets/grid/jsp/initTableXML.jsp").forward(request, response);	
%>