<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@page import="xpolog.config.Configuration"%>

<%!static final String BASE_DIRECTORY = "../../";%>
<%

String baseDirectory = request.getParameter("baseDirectory");
if (baseDirectory == null){
   baseDirectory = BASE_DIRECTORY;
}
String clusterNode = request.getParameter("clusterNode");
if (clusterNode == null){
  clusterNode = "";
}	
boolean isCurrentNode = clusterNode == null || clusterNode.length() == 0 || clusterNode.equals("all") || clusterNode.equals(Configuration.getMachineNameUid());

String suffix = "_jobs";

boolean showMenu = isCurrentNode;
if(showMenu) {
	String menuIds = "stop";
	String menuTexts = "Stop";
	String menuHrefs = "javascript:stopJobs();";
%>
<jsp:include page="../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
		</jsp:include>

	<jsp:include page="../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	 <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	</jsp:include>
<%
}
%>
<script>
function stopJobs(){
	 var id = mygrid_jobs.getSelectedRowId();
	    if (id == "") {
	       return;
	    }
	    if (id.indexOf(",") >= 0){
	      doJobsMembersStop(id,id);
	      return;
	    }
	    stopMemberJob(id);
}

function doJobsMembersStop(id){
    showActionMessage("Job Stop Action","mygrid_jobs","doStopJob('" + id + "','" +  id + "')","<nobr>Are you sure you want to stop all selected jobs</nobr>" + "?");   
   }

   function stopMemberJob(id){
     var name = mygrid_jobs.cells(id,0).getValue();
     showActionMessage("Job Stop Action","mygrid_jobs","doStopJobs('" + id + "','" +  id + "')","<nobr>Are you sure you want to stop job </nobr>" + name + "?");   
   }

   function doStopJob(row,id){
     showMessage("Job","mygrid_jobs","Stopping",200,60);
     workingSupportData("_jobs",baseDirectory + "support/activity/jobsActions.jsp","action=stop&jobIds=" + id + "&timestamp=" + new Date().getTime());
   }

function handleMenuItems_jobs(){
  aMenu_jobs.menu.showButtons("stop");	
}

function initJobs(){
		//refreshTableInterval = setInterval("refreshJobInfo()",10000);
	}
	
var refreshJobsTableInterval;
	function doJobsRefresh(){
		refreshJobsTableInterval = setInterval("refreshJobInfo()",10000);
	}
	
	function refreshJobInfo(){
		var t = applicationTabs.tabs[applicationTabs.selectedTabIndex];
		if (t && t.id == "Jobs"){
			updateTable_jobs();
		}
	}
	
	function stopRefreshing(){
		if (refreshTableInterval){
			clearInterval(refreshTableInterval);
		}
	}
	
  function refreshSupportTable_jobs(){
    disableActionButton("stopTableJobs");
    updateTable_jobs();  
  }

  initMenus<%=suffix %>();
</script>
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
		<tr valign="top">
			<td width="100%">
			<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
				<tr>
					<td valign="top" height="100%" style="padding-top:10px">
					<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              								
						<tr height="*">
							<td valign="top"> 
							<% 
							String tableNames = "Stop#Refresh";
							String tableActions = "javascript:stopJobs()#javascript:updateTable_jobs()";
							String ids = "stopTableJobs#refreshJobs";
							String selectTypes = isCurrentNode ? "3#1" : "0#1";
							String initXML = "support/activity/jobsViewXML.jsp?suffix=jobs&clusterNode=" + clusterNode + "&baseDirectory=" + baseDirectory;
							String updateXML = "support/activity/jobsViewXML.jsp?suffix=jobs&clusterNode=" + clusterNode + "&dataOnly=true&baseDirectory=" + baseDirectory;
              String menu = showMenu ? "aMenu_jobs" : "";
							%>                               
							<jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />								
							<jsp:param name="initXML" value="<%=initXML%>" />									
							<jsp:param name="updateXML" value="<%=updateXML%>" />									
							<jsp:param name="menu" value="<%=menu%>" />
							<jsp:param name="suffix" value="<%=suffix %>" />
							<jsp:param name="recordsText" value="Jobs" />
							<jsp:param name="style" value="main" />
							<jsp:param name="height" value="100%" />
							<jsp:param name="autoHeight" value="-1" />
							<jsp:param name="rowsNumPerPage" value="-1" />
              <jsp:param name="tableActionNames" value="<%=tableNames%>" />
              <jsp:param name="tableActions" value="<%=tableActions%>" />
              <jsp:param name="tableActionIds" value="<%=ids%>" />
              <jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
							</jsp:include>													
							</td>
						</tr>								
					</table>
					</td>
				</tr>
			</table>
			</td>
		</tr>
	</table>	
	