<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@page import="xpolog.eye.system.XpoLogSystemProcess"%>
<%@page import="xpolog.eye.audit.event.ProcessSystemAuditEvent"%>
<%@page import="xpolog.eye.system.XpoLogSystemProcessInfo"%>
<%@page import="xpolog.eye.system.XpoLogSystemMnager"%>
<%@page import="xpolog.eye.audit.AuditConstants"%>
<%@page import="xpolog.eye.audit.AuditManager"%>
<%@page import="xpolog.eye.SiteManagment"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@page import="xpolog.eye.error.ErrorModel"%>

<%!
  static final String BASE_DIRECTORY = "../../";
	static final String DELIMITER = ",";
 %>
<%
	if (!WebSecurityManager.getInstance().checkForPermission(request,response, ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)) {
		return;
	}
  UserContext userContext = UserEnvironment.getUserContext(request);
  boolean success = true;
  String message = "";  
  String childrenIdsList = null;
  String action = request.getParameter("action");
  String processIds = request.getParameter("processIds");
  if (processIds != null && processIds.length() > 0){
  	StringTokenizer indexedLogsIdsList = new StringTokenizer(processIds,DELIMITER);
  	if (action.equalsIgnoreCase("stop")){
  		XpoLogSystemMnager manager = XpoLogSystemMnager.getInstance();
  		int processesCount = manager.getProcesses().length;
	    while (indexedLogsIdsList.hasMoreTokens()) {
		    String id = indexedLogsIdsList.nextToken();
		    String name = "";
        try {      		        	
        	XpoLogSystemProcessInfo processInfo = manager.getSystemProcess(id);
          if (processInfo != null){
            name =  processInfo.getObjectName() + "(" + processInfo.getObjectId() + "_" + processInfo.getObjectId() + ")";
            
            XpoLogSystemProcess process = processInfo.getProcess();
         		if (process != null){
         			//audit
           		AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL, userContext, AuditConstants.STOP_PROCESS, "stop process manually", processInfo.getType(), "stop process " + processInfo.getName());
           		ProcessSystemAuditEvent auditEvent = new ProcessSystemAuditEvent(false, processInfo,processesCount);
         	   	String auditMessage = "stop process (" + processInfo.getId() + ") - "  + processInfo.getDesc();
         			auditEvent.setAction("stop process");
         			auditEvent.setMessage(auditMessage);
         			AuditManager.getInstance().write(auditEvent);
         			process.stop();
         			XpologUtil.stopThread(processInfo.getThreadName());
            }
          }  		    
        }catch (Exception e){
        	ErrorModel.log.error("Failed to stop process " + id+ " for entity " + name, e);
		      success = false;
		      message = e.getMessage(); 
        }
      }	
  	}
  }else {
    message = "No process selected, please refresh and try again";
  }
  String xml = GridModelActionsHelper.getResultXML(success, message, "", childrenIdsList);

  response.setContentType("text/xml");
  response.setHeader("Pragma-Control", "no-cache");
  response.setHeader("Cache-Control", "no-cache");
  response.setHeader("Expires", "0");
  
  out.write(xml);
  out.flush();
%>