<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@page import="xpolog.config.Configuration"%>

<%!static final String BASE_DIRECTORY = "../../";%>
<%

String baseDirectory = request.getParameter("baseDirectory");
if (baseDirectory == null){
   baseDirectory = BASE_DIRECTORY;
}
String clusterNode = request.getParameter("clusterNode");
if (clusterNode == null){
  clusterNode = "";
}
boolean isCurrentNode = clusterNode == null || clusterNode.length() == 0 || clusterNode.equals("all") || clusterNode.equals(Configuration.getMachineNameUid());

String suffix = "_sshConnections";

boolean showMenu = isCurrentNode;
if(showMenu) {
	String menuIds = "terminate";
	String menuTexts = "Terminate";
	String menuHrefs = "javascript:destroyPool();";
%>
<jsp:include page="../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
		</jsp:include>

	<jsp:include page="../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	 <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	</jsp:include>
<%
}
%>
<script>
function destroyPool(){
     var id = mygrid_sshConnections.getSelectedRowId();
        if (id == "") {
           return;
        }
        if (id.indexOf(",") >= 0){
          doSSHConnectionMembersDestroy(id,id);
          return;
        }
        destroyMemberSSHConnection(id);
  }

  function doSSHConnectionMembersDestroy(id){
     showActionMessage("SSH Connection Destroy Action","mygrid_sshConnections","doDestroySSHConnection('" + id + "','" +  id + "')","<nobr>Are you sure you want to terminate all selected pool connections</nobr>" + "? This will close all open connections!");   
    }

    function destroyMemberSSHConnection(id){
      var name = mygrid_sshConnections.cells(id,0).getValue();
      showActionMessage("SSH Connection Destroy Action","mygrid_sshConnections","doDestroySSHConnection('" + id + "','" +  id + "')","<nobr>Are you sure you want to terminate the pool </nobr>" + name + "? This will close all open connections!");   
    }

    function doDestroySSHConnection(row,id){
      showMessage("SSH Connection","mygrid_sshConnections","Destroying",200,60);
      workingSupportData("_sshConnections",baseDirectory + "support/activity/sshConnectionActions.jsp","action=destroy&poolAccountIds=" + id + "&timestamp=" + new Date().getTime());
    }


function handleMenuItems_sshConnections(){
  aMenu_sshConnections.menu.showButtons("terminate");	
}

		
	function refreshSshConnectionsInfo(){
		var t = applicationTabs.tabs[applicationTabs.selectedTabIndex];
		if (t && t.id == "SSH Connections"){
			updateTable_sshConnections();
		}
	}

	function refreshSupportTable_sshConnections(){
		disableActionButton("destroyTableSSHConnection");
		updateTable_sshConnections();  
	}

	initMenus<%=suffix %>();
</script>
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
		<tr valign="top">
			<td width="100%">
			<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
				<tr>
					<td valign="top" height="100%" style="padding-top:10px">
					<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              								
						<tr height="*">
							<td valign="top"> 
							<%
							String tableNames = "Terminate#Refresh";
							String tableActions = "javascript:destroyPool()#javascript:refreshSupportTable_sshConnections()";
							String ids = "destroyTableSSHConnection#refreshSSHConnections";
							String selectTypes = isCurrentNode ? "3#1": "0#1";
              
							String initXML = "support/activity/sshConnectionsViewXML.jsp?suffix=sshConnections&clusterNode=" + clusterNode + "&baseDirectory=" + baseDirectory;
							String updateXML = "support/activity/sshConnectionsViewXML.jsp?suffix=sshConnections&clusterNode=" + clusterNode + "&dataOnly=true&baseDirectory=" + baseDirectory;
              String menu = showMenu ? "aMenu_sshConnections" : "";
							%>                               
							<jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />								
							<jsp:param name="initXML" value="<%=initXML%>" />	
							<jsp:param name="updateXML" value="<%=updateXML%>" />																		
							<jsp:param name="menu" value="<%=menu%>" />
							<jsp:param name="suffix" value="<%=suffix %>" />
							<jsp:param name="recordsText" value="SSH Connections" />
							<jsp:param name="style" value="main" />
							<jsp:param name="height" value="100%" />
							<jsp:param name="autoHeight" value="-1" />
							<jsp:param name="rowsNumPerPage" value="-1" />
							<jsp:param name="multiline" value="true" />
              <jsp:param name="tableActionNames" value="<%=tableNames%>" />
              <jsp:param name="tableActions" value="<%=tableActions%>" />
              <jsp:param name="tableActionIds" value="<%=ids%>" />
              <jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
            
							</jsp:include>													
							</td>
						</tr>								
					</table>
					</td>
				</tr>
			</table>
			</td>
		</tr>
	</table>		
