<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@page import="xpolog.config.Configuration"%>

<%!static final String BASE_DIRECTORY = "../../";%>
<%

String baseDirectory = request.getParameter("baseDirectory");
if (baseDirectory == null){
   baseDirectory = BASE_DIRECTORY;
}
String clusterNode = request.getParameter("clusterNode");
if (clusterNode == null){
  clusterNode = "";
}	
boolean isCurrentNode = clusterNode == null || clusterNode.length() == 0 || clusterNode.equals("all") || clusterNode.equals(Configuration.getMachineNameUid());

String suffix = "_threads";

boolean showMenu = isCurrentNode;
if(showMenu) {
	String menuIds = "interrupt";
	String menuTexts = "Interrupt";
	String menuHrefs = "javascript:interruptThread();";
%>
<jsp:include page="../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
		</jsp:include>
	
<jsp:include page="../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	 <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	</jsp:include>
<%
}
%>
<script>
function interruptThread(){
   var id = mygrid_threads.getSelectedRowId();
      if (id == "") {
         return;
      }
      if (id.indexOf(",") >= 0){
        doThreadMembersInterrupt(id,id);
        return;
      }
      interruptMemberThread(id);
}

function doThreadMembersInterrupt(id){
   showActionMessage("Thread Interrupt Action","mygrid_threads","doInterruptThread('" + id + "','" +  id + "')","<nobr>Are you sure you want to interrupt all selected threads</nobr>" + "?");   
  }

  function interruptMemberThread(id){
    var name = mygrid_threads.cells(id,0).getValue();
    showActionMessage("Thread Interrupt Action","mygrid_threads","doInterruptThread('" + id + "','" +  id + "')","<nobr>Are you sure you want to interrupt thread </nobr>" + name + "?");   
  }

  function doInterruptThread(row,id){
    showMessage("Thread","mygrid_threads","Interrupting",200,60);
    workingSupportData("_threads",baseDirectory + "support/activity/threadActions.jsp","action=interrupt&threadIds=" + id + "&timestamp=" + new Date().getTime());
  }

  function dumpThreads(){
	  showMessage("Thread","mygrid_threads","Dumping Threads",200,60);
	  workingSupportData("_threads",baseDirectory + "support/activity/threadActions.jsp","action=dump&timestamp=" + new Date().getTime());
	}


function handleMenuItems_threads(){
  aMenu_threads.menu.showButtons("interrupt");	
}

function refreshSupportTable_threads(){
	disableActionButton("interruptTableThread");
	updateTable_threads();  
}

		
	function refreshThreadsInfo(){
		var t = applicationTabs.tabs[applicationTabs.selectedTabIndex];
		if (t && t.id == "Threads"){
			updateTable_threads();
		}
	}

	initMenus<%=suffix %>();
</script>
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
		<tr valign="top">
			<td width="100%">
			<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
				<tr>
					<td valign="top" height="100%" style="padding-top:10px">
					<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              								
						<tr height="*">
							<td valign="top"> 
							<% 
              
							String tableNames = "Interrupt#Refresh";
							String tableActions = "javascript:interruptThread()#javascript:refreshSupportTable_threads()";
							String ids = "interruptTableThread#refreshThreads";
							String selectTypes = isCurrentNode ? "3#1" : "0#1";
							
							boolean showDumpThreads = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("support.showDumpThreads", false);
              if(showDumpThreads) {
								tableNames += "*;*Dump Threads";
								tableActions += "*;*javascript:dumpThreads()";
								ids += "*;*dumpThreads";
								selectTypes += "*;*1";
							}
              
							String initXML = "support/activity/threadsViewXML.jsp?suffix=threads&baseDirectory=" + baseDirectory + "&clusterNode=" + clusterNode;
							String updateXML = "support/activity/threadsViewXML.jsp?suffix=threads&dataOnly=true&baseDirectory=" + baseDirectory+ "&clusterNode=" + clusterNode;
              String menu = showMenu ? "aMenu_threads" : "";
							%>                               
							<jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />								
							<jsp:param name="initXML" value="<%=initXML%>" />	
							<jsp:param name="updateXML" value="<%=updateXML%>" />																		
							<jsp:param name="menu" value="<%=menu%>" />
							<jsp:param name="suffix" value="<%=suffix %>" />
							<jsp:param name="recordsText" value="Threads" />
							<jsp:param name="style" value="main" />
							<jsp:param name="height" value="100%" />
							<jsp:param name="autoHeight" value="-1" />
							<jsp:param name="rowsNumPerPage" value="-1" />
							<jsp:param name="multiline" value="true" />
              <jsp:param name="tableActionNames" value="<%=tableNames%>" />
              <jsp:param name="tableActions" value="<%=tableActions%>" />
              <jsp:param name="tableActionIds" value="<%=ids%>" />
              <jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
							</jsp:include>													
							</td>
						</tr>								
					</table>
					</td>
				</tr>
			</table>
			</td>
		</tr>
	</table>		
