<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>


<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,null,true)){
		return;
	}
	
	UserContext user = UserEnvironment.getUserContext(request);
	if (user != null && user.getUser() != null && !user.getUser().isAdmin()){
		response.sendRedirect(BASE_DIRECTORY + "security/common/accessDenied.jsp");
		return;
	}
  SiteManagment mgmt = SiteManagment.getInstance();
  
	String selectedTabId = request.getParameter("selectedTabId");
	if (selectedTabId == null || selectedTabId.length() == 0){
		selectedTabId = "0";
	}
%>

<html>

<head>
<title>XpoLog Center Support</title>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script src="<%=BASE_DIRECTORY%>scripts/comps/divsTabs.js"	type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js"	type="text/javascript"></script>
<script>
	
	function exit(){
		document.access.action = "<%=BASE_DIRECTORY%>componentAction.jsp?selecedCompId=XpoLog";
		document.access.submit();
	}
	function refresh(tabNum){
		document.access.selectedTabId.value= tabNum;
		document.access.action = "index.jsp";
		document.access.target = "";
		document.access.submit();
	}
	
	function saveProp(){
		document.access.action = "propertiesAction.jsp";
		document.access.target = "";
		document.access.submit();
	}
	
	function saveAlg(){	
		document.access.action = "algorithmAction.jsp";
		document.access.target = "";
		document.access.submit();
	}
</script>
	
	
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" name="access" id="access" method="post" action="">
<input	type="hidden" name="selectedTabId">

<table border="0" width="100%" cellspacing="0" height="100%"
	cellpadding="0">
	<tr valign="top">
		<td width="100%">
		<table border="0" width="100%" cellspacing="0" cellpadding="0">
			<tr>
				<td valign="top" height="100%">
				<table border="0" cellpadding="0" cellspacing="0"
					style="border-collapse: collapse" width="100%" id="AutoNumber1">
					<tr>
						<td width="100%">
						<table border="0" cellpadding="0" cellspacing="0"
							style="border-collapse: collapse" width="100%" id="AutoNumber2">
							<tr>
								<td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
								<td width="90%" class="TOPBORDER"><span class="PAGEHEADER">Advanced Settings</span></td>
								<td width="9%" class="TOPRIGHTBORDER">&nbsp;</td>
							</tr>
							<tr>
								<td width="3%">&nbsp;</td>
								<td width="24%">&nbsp;</td>
								<td width="100%">&nbsp;</td>
							</tr>
							<tr>
								<td width="3%" height="100%">&nbsp;&nbsp;&nbsp;</td>
								<td width="93%" colspan="2" height="100%">
								<table border="0" cellpadding="0" cellspacing="0"
									style="border-collapse: collapse" width="100%" id="AutoNumber3"
									height="53">
									
									<tr>
										<td width="100%"><script>
										 var applicationTabs = createDefaultApplicationTabs("advSecurityMembersTabs");
		                  applicationTabs.addTab("Properties","<nobr>Properties</nobr>","propertiesDiv");
		                  applicationTabs.addTab("ResourceMgr","<nobr>Resource Manager</nobr>","resourceMgrDiv");                          
		                  applicationTabs.addTab("Algorithm","<nobr>Algorithm</nobr>","algorithmDiv");
		                 	tabsInLine = 3;
                    	applicationTabs.writeTabs();
                    </script></td>
									</tr>
									<tr>
										<td width="100%">
										<div id="propertiesDiv" style="display:none"><jsp:include page="properties.jsp" flush="true"/></div>
										<div id="resourceMgrDiv" style="display:none"><jsp:include page="resourceMgr.jsp" flush="true" /></div>
										<div id="algorithmDiv" style="display:none"><jsp:include page="algorithm.jsp" flush="true" /></div>
										</td>
									</tr>
									<tr>
										<td height="100%">&nbsp;</td>
									</tr>
									
									<tr>
										<td></td>
									</tr>
								</table>
								</td>
							</tr>
						</table>
						</td>
					</tr>
					<tr>
						<td width="100%">&nbsp;</td>
					</tr>
					<tr>
						<td width="100%">&nbsp;</td>
					</tr>
					<tr>
						<td width="100%" height="100%">&nbsp;</td>
					</tr>

				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
	<tr>
		<td>
		<table border="0" cellpadding="0" cellspacing="0" width="100%">
			<tr>
				<td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
				<td class="BOTTOMBORDER" width="33%">&nbsp;</td>
				<td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
			</tr>
		</table>

		</td>
	</tr>
</table>
</form>
<script>                 
                  applicationTabs.selectTabByIndex(<%=selectedTabId%>);
                  </script>
</body>

</html>
