<%@ page language="java"%>

<%@ page import="java.util.HashMap"%>
<%@ page import="java.util.List"%>

<%@ page import="xpolog.eye.util.XpologUtil"%>

<%!
String getLogInfoXmlString(HashMap logInfo) {
	if(logInfo == null) {
		return "";
	}
	StringBuffer buffer = new StringBuffer();
	
	buffer.append("<LogInfo");
	buffer.append(" logId=\"");
	buffer.append(logInfo.get("logId"));
	buffer.append("\" logName=\"");
	buffer.append(logInfo.get("logName"));
	buffer.append("\" host=\"");
	buffer.append(logInfo.get("host"));
	buffer.append("\" size=\"");
	long size = ((Long)logInfo.get("size")).longValue();
	buffer.append(XpologUtil.formatSize(size));
	buffer.append("\" />");
	
	return buffer.toString();
}
%>

<%
final String LOG_INFOS = "LOG_INFOS";

HashMap logInfos = (HashMap)session.getAttribute(LOG_INFOS);
boolean isRunning = false;
int numberOfLogs = 0;
int numberOfLogsProcessed = 0;
String errorMessage = "";
List logInfosList = null;
long totalSize = 0;
if(logInfos != null) {
	logInfosList = (List)logInfos.get("logInfosList");
	
	isRunning = ((Boolean)logInfos.get("running")).booleanValue();
	numberOfLogs = ((Integer)logInfos.get("numberOfLogs")).intValue();
	if(logInfosList != null) {
		numberOfLogsProcessed = logInfosList.size();
	}
	errorMessage = (String)logInfos.get("errorMessage");
	
	long size = 0;
	HashMap logInfo = null;
	for(int i = 0; i < logInfosList.size(); i++) {
		logInfo = (HashMap)logInfosList.get(i);
		size = ((Long)logInfo.get("size")).longValue();
		if(size > 0) {
			totalSize += size;
		}
	}
}

response.setContentType("text/xml; charset=UTF-8");
%>

<LogSizesActionStatusResponse>
	<Response isRunning="<%=isRunning %>" numberOfLogs="<%=numberOfLogs %>" numberOfLogsProcessed="<%=numberOfLogsProcessed %>" totalSize="<%=XpologUtil.formatSize(totalSize) %>" errorMessage="<%=errorMessage %>">
<%
HashMap logInfo = null;
for(int i = 0; i < logInfosList.size(); i++) {
	logInfo = (HashMap)logInfosList.get(i);
%>
	<%=getLogInfoXmlString(logInfo) %>
<%
}
%>
	</Response>
</LogSizesActionStatusResponse>