<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="java.util.HashMap"%>
<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.util.resource.ResourceManager"%>

<%!static final String BASE_DIRECTORY = "../../";%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, null, true)) {
		return;
	}
	
	ResourceManager resourceMgr = ResourceManager.getInstance();
	if(resourceMgr == null ){
		return;
	}
	HashMap resourceLimitationsMap = resourceMgr.getResourceLimitations();
	//HashMap hostResourceLimitationsMap = resourceMgr.getHostsResourceLimitations();
	if(resourceLimitationsMap == null){
		resourceLimitationsMap = new HashMap();
	}
	/*if(hostResourceLimitationsMap == null){
		hostResourceLimitationsMap = new HashMap();
	}*/

	String errorMsg = "";
	if(/*hostResourceLimitationsMap.isEmpty() && */resourceLimitationsMap.isEmpty()){
		errorMsg = "No Resource were found.";
	}
%>

<script>
		var contextreq;
		var runnerNode;
		var hosts;
		var newHosts;
		var type;
		var consumer;

		function GetXmlHttpObject()
		{
			var contextreq=null;
			try {
				  // Firefox, Opera 8.0+, Safari
				  contextreq=new XMLHttpRequest();
			}catch (e)		  {
			  // Internet Explorer
		  	try{
			    contextreq=new ActiveXObject("Msxml2.XMLHTTP");
			    }catch (e)			    {
				    contextreq=new ActiveXObject("Microsoft.XMLHTTP");
			    }
			  }
			return contextreq;
		}


	function editResource(hosts,type,consumer,runnerNode){
			var url = "resourceMgrEdit.jsp";
			var params = "hosts=" + hosts + "&type=" + type + "&consumer=" + consumer + "&runnerNode=" + runnerNode;
			contextreq = GetXmlHttpObject();
			contextreq.open('POST', url, true);
			contextreq.onreadystatechange = editResourceCallback;
			contextreq.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		  contextreq.setRequestHeader("Content-length", params.length);
		  contextreq.setRequestHeader("Connection", "close");
		  contextreq.send(params);  						
	}
	
	function editResourceCallback(){
		if (contextreq.readyState == 4) {
					if (contextreq.status == 200) {
					var xmlDoc = contextreq.responseXML.documentElement;
					updateEditDiv(xmlDoc);
			}
		}
	}

	function updateEditDiv(xmlDoc){
//	alert(xmlDoc);
		var resourcesListElement = xmlDoc.getElementsByTagName("resourcesList")[0];
		var resourcesListStr = getElementValue(resourcesListElement);
		if(resourcesListStr){
			runnerNode = resourcesListElement.getAttribute("runnerNode");
			hosts = resourcesListElement.getAttribute("resourceHosts");
			type = resourcesListElement.getAttribute("resourceType");
			consumer = resourcesListElement.getAttribute("resourceConsumer");
			var trId = resourcesListElement.getAttribute("trId");
			var trData = resourcesListElement.getAttribute("trData");
			var editDivElement = document.getElementById("editResourcesDiv");
			var editDivTDElement = document.getElementById("resourcesDataId");
			editDivTDElement.innerHTML = 	resourcesListStr;
			editDivElement.style.display = "";
		}	
	}

	function getElementValue(element) {
		var elementValue = "";
		if(document.all) {
			elementValue = element.childNodes[0].nodeValue;
		}else {
			elementValue = element.childNodes[1].nodeValue;
		}
		return elementValue;
	}
	
	
	function deleteResource(hosts,type,consumer,runnerNode){
			var url = "resourceMgrDelete.jsp";
			var params = "hosts=" + hosts + "&type=" + type + "&consumer=" + consumer + "&runnerNode=" + runnerNode;
			contextreq = GetXmlHttpObject();
			contextreq.open('POST', url, true);
			contextreq.onreadystatechange = deleteResourceCallback;
			contextreq.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		  contextreq.setRequestHeader("Content-length", params.length);
		  contextreq.setRequestHeader("Connection", "close");
		  contextreq.send(params);  						
	}
	
	function deleteResourceCallback(){
		if (contextreq.readyState == 4) {
					if (contextreq.status == 200) {
					var result = contextreq.responseText;	
					deleteRes(result);
			}
		}
	}
	
	function deleteRes(result){
		updateResourcesTable(result);
	}
	

	function AddNewResorce(){
		var newResDivElement = document.getElementById("addNewResourcesDiv");
		newResDivElement.style.display = "";	
	}
	
	
	function updateResourcesTable(result){
			result = result.replace(/^\s+|\s+$/g, '') ;
			if (!result){
					alert("Could not update resources list!.");
					return;
			}
			 
			if (result != "OK"){
					alert(result);
					return;
			}
			 
			var d = new Date();
			var url = "resourcesList.jsp?tstmp=" + d.getTime();
			contextreq = GetXmlHttpObject();
			contextreq.open('GET', url, true);
			contextreq.onreadystatechange = updateResourcesTableCallback;
			contextreq.send(null);		  
	}
	

	function updateResourcesTableCallback(){
		if (contextreq.readyState == 4) {
			if (contextreq.status == 200) {
				var result = contextreq.responseText;	
				result = result.replace(/^\s+|\s+$/g, '') ;
				if (!result){
					alert("Could not update resources list!.");
				}   
				var resListTblElem = document.getElementById("resorcesListDiv");
				if(resListTblElem){
					resListTblElem.innerHTML = result;
				}
			}
		}
	}

</script>
	<jsp:include page="../../support/advanced/resourceMgrEditDiv.jsp" flush="true">
	<jsp:param name="base_directory" value="<%=BASE_DIRECTORY%>"/> 
	</jsp:include>
	<jsp:include page="../../support/advanced/addNewResDiv.jsp" flush="true">
	<jsp:param name="base_directory" value="<%=BASE_DIRECTORY%>"/> 
	</jsp:include>


<table border="0" width="100%" cellspacing="defaultroot/logeye/groups""0" height="100%"	cellpadding="0">
	<tr>
		<td>&nbsp;</td>
	</tr>
	<tr>
		<td>
				<table border="0" width="100%" cellspacing="0" height="100%"	cellpadding="0">
					<tr>
						<td width="100%">
						<table border="0" cellpadding="0" cellspacing="0"	width="100%" id="AutoNumber2">
							<tr>
								<td width="15%" height="28" colspan="3"><span	class="HEADER">Resource Manager Settings (current node is <%=Configuration.getInstance().getMachineNameUid() %>)</span></td>
							</tr>	
						</table>	
						</td>
					</tr>
				</table>	
		</td>
	</tr>
	<tr>
		<td>
				<table border="0" width="100%" cellspacing="0" height="100%"	cellpadding="0">
					<tr>
						<td width="100%">
						<table border="0" cellpadding="0" cellspacing="0"	width="100%" id="AutoNumber2">
							<tr>
								<td width="15%"><a href="javascript:AddNewResorce()"	class="LINK">Add New Resource</a></td>
								<td width="*">&nbsp;</td>
							</tr>	
						</table>	
						</td>
					</tr>
				</table>	
		</td>
	</tr>
	<%if(errorMsg.length() > 0){ %>
			<tr>
					<td width="100%">
						<table border="0" cellpadding="0" cellspacing="0"	width="100%" id="AutoNumber2">
							<tr>
								<td width="15%" height="28" colspan="3"><span	class="HEADER">errorMsg</span></td>
							</tr>	
						</table>	
					</td>
			</tr>
	<%}else{%>
	<tr>
		<td>&nbsp;</td>
	</tr>
	<tr>
		<td>
			<div id="resorcesListDiv" style="dispaly:">
			<jsp:include flush="true" page="resourcesList.jsp">
			<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/>
			</jsp:include> 
			</div>
		</td>
	</tr>
	<%} %>
</table>	
