<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@page import="java.util.HashSet"%>
<%@page import="java.util.HashMap"%>
<%@page import="java.util.Iterator"%>
<%@page import="xpolog.eye.util.resource.ThreadsResourceLimitation"%>
<%@page import="xpolog.eye.util.resource.ResourceLimitation"%>
<%@page import="xpolog.eye.util.resource.ResourceManager"%>

<%!
	static final String BASE_DIRECTORY = "../../";%>
<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, null, true)) {
		return;
	}
	
	ResourceManager resourceMgr = ResourceManager.getInstance();
	if(resourceMgr == null ){
		return;
	}
	HashMap resourceLimitationsMap = resourceMgr.getResourceLimitations();
	HashMap extraResourceLimitationsMap = resourceMgr.getExtraResourceLimitations();
	HashMap defaultResMap = resourceMgr.getDefaultResourceIdsSet();
	if(resourceLimitationsMap == null){
		resourceLimitationsMap = new HashMap();
	}
	if(extraResourceLimitationsMap == null){
		extraResourceLimitationsMap = new HashMap();
	}

//	HashSet systemResSet = resourceMgr.getSystemResourceSet();
//	HashSet userResSet = resourceMgr.getUserResourceSet();
	String errorMsg = "";
	if(extraResourceLimitationsMap.isEmpty() && resourceLimitationsMap.isEmpty()){
		errorMsg = "No Resource were found.";
	}
%>

<%@page import="java.util.List"%>
<table border="0" width="100%" cellspacing="0" height="100%"	cellpadding="0">
	<tr>
		<td colspan="13">&nbsp;</td>
	</tr>
	<tr class="TABLES_HEADERS">
								<td width="20px">&nbsp;</td>
								<td width="240px"><span class="REGULARTEXT"><b>Resource Type</b></span></td>
								<td width="20px">&nbsp;</td>
								<td width="150px"><span class="REGULARTEXT"><b>Consumer</b></span></td>
								<td width="20px">&nbsp;</td>
								<td width="150px"><span class="REGULARTEXT"><b>Runner Node</b></span></td>
								<td width="20px">&nbsp;</td>
								<td width="200px"><span class="REGULARTEXT"><b>Hosts</b></span></td>
								<td width="20px">&nbsp;</td>
								<td width="430px"><span class="REGULARTEXT"><b>Data</b></span></td>
								<td width="20px">&nbsp;</td>
								<td width="50px">&nbsp;</td>
								<td width="20px">&nbsp;</td>
								<td width="100px">&nbsp;</td>
								<td width="*"">&nbsp;</td>										
	</tr>
	<tr>
		<td colspan="13">&nbsp;</td>
	</tr>
	
	<!-- Start hosted resources  -->
	
	<%
	boolean isDefaultRes = false;
	String type="",consumer="",hosts="",runnerNode="",data="",typeId="",fullData="";
//Iterator _it = resourceLimitationsMap.keySet().iterator();
	List list = resourceMgr.sortMap(resourceLimitationsMap);
	String key = "";
	for(int i=0 ; list != null && i < list.size() ; i++){
		key = (String)list.get(i);
//	while(_it.hasNext()){
//	String key = (String)_it.next();
		if(key != null && key.length() > 0){
			ResourceLimitation resLimitation = (ResourceLimitation)resourceLimitationsMap.get(key);
			if(resLimitation != null && resLimitation instanceof ThreadsResourceLimitation){
				ThreadsResourceLimitation threadResLimitation = (ThreadsResourceLimitation)resLimitation;
				type = "Threads Resource Limitation";
				typeId = "THREADS";
				hosts = threadResLimitation.getHost() == null ? "" : threadResLimitation.getHost();
				runnerNode = threadResLimitation.getRunnerNode() == null ? "" : threadResLimitation.getRunnerNode();
				consumer = threadResLimitation.getConsumerType();
				fullData = threadResLimitation.getDataAsString();
				data = fullData.length() < 80 ? fullData : fullData.substring(0,37) + "..." + fullData.substring(fullData.length() - 40,fullData.length());
				isDefaultRes = defaultResMap.containsKey(key);

			}

	%>
	<tr>
								<td>&nbsp;</td>
								<td><span class="REGULARTEXT"><%=type%></span></td>
								<td>&nbsp;</td>
								<td><span class="REGULARTEXT"><%=consumer%></span></td>
								<td>&nbsp;</td>
								<td><span class="REGULARTEXT"><%=runnerNode%></span></td>
								<td>&nbsp;</td>
								<td><span class="REGULARTEXT"><%=hosts.length() == 0 ? "*" : hosts%></span></td>
								<td>&nbsp;</td>
								<td title="<%=fullData.replaceAll("<b>","").replaceAll("</b>","") %>"><span class="REGULARTEXT"><%=data%></span></td>
								<td>&nbsp;</td>
								<td><a href="javascript:editResource('<%=hosts%>','<%=typeId %>','<%=consumer%>','<%=runnerNode%>')"	class="LINK">edit</a></td>
								<td>&nbsp;</td>
								<%if(isDefaultRes){%>
								<td>&nbsp;</td>
								<%}else{ %>
								<td><a href="javascript:deleteResource('<%=hosts%>','<%=typeId %>','<%=consumer%>','<%=runnerNode%>')"	class="LINK">delete</a></td>								
								<%}%>
								<td>&nbsp;</td>										
	</tr>
	<tr>
		<td colspan="13">&nbsp;</td>
	</tr>					
  <%

		}		
	}	
	%>
	
	<!-- end hosted resources  -->
	
	<%

//	Iterator it = hostResourceLimitationsMap.keySet().iterator();
//	while(it.hasNext()){
//		String key = (String)it.next();
	list = resourceMgr.sortMap(extraResourceLimitationsMap);
	for(int i=0 ; list != null && i < list.size() ; i++){
		key = (String)list.get(i);
		HashMap resourceLimitationsMapByHost = new HashMap();
		if(key != null && key.length() > 0){
			resourceLimitationsMapByHost = (HashMap)extraResourceLimitationsMap.get(key);
			if(resourceLimitationsMapByHost	!= null && !resourceLimitationsMapByHost.isEmpty()){
				Iterator iter = resourceLimitationsMapByHost.keySet().iterator();
				while(iter.hasNext()){
					String _key = (String)iter.next();
					ResourceLimitation resLimitation = (ResourceLimitation)resourceLimitationsMapByHost.get(_key);
					if(resLimitation != null && resLimitation instanceof ThreadsResourceLimitation){
						ThreadsResourceLimitation threadResLimitation = (ThreadsResourceLimitation)resLimitation;
						type = "Threads Resource Limitation";
						typeId = "THREADS";
						hosts = threadResLimitation.getHost();
						runnerNode = threadResLimitation.getRunnerNode() == null ? "" : threadResLimitation.getRunnerNode();
						consumer = threadResLimitation.getConsumerType();
						fullData = threadResLimitation.getDataAsString();
						data = fullData.length() < 80 ? fullData : fullData.substring(0,37) + "..." + fullData.substring(fullData.length() - 40,fullData.length());
						isDefaultRes = defaultResMap.containsKey(_key+"#"+hosts);
					}

	
	%>
	<tr>
								<td>&nbsp;</td>
								<td><span class="REGULARTEXT"><%=type%></span></td>
								<td>&nbsp;</td>
								<td><span class="REGULARTEXT"><%=consumer%></span></td>
								<td>&nbsp;</td>
								<td><span class="REGULARTEXT"><%=runnerNode%></span></td>
								<td>&nbsp;</td>
								<td><span class="REGULARTEXT"><%=hosts.length() == 0 ? "*" : hosts %></span></td>
								<td>&nbsp;</td>
								<td title="<%=fullData.replaceAll("<b>","").replaceAll("</b>","") %>"><span class="REGULARTEXT"><%=data%></span></td>
								<td>&nbsp;</td>
								<td><a href="javascript:editResource('<%=hosts%>','<%=typeId %>','<%=consumer%>','<%=runnerNode%>')"	class="LINK">edit</a></td>
								<td>&nbsp;</td>
								<%if(isDefaultRes){%>
								<td>&nbsp;</td>
								<%}else{ %>
								<td><a href="javascript:deleteResource('<%=hosts%>','<%=typeId %>','<%=consumer%>','<%=runnerNode%>')"	class="LINK">delete</a></td>								
								<%}%>
								<td>&nbsp;</td>										
	</tr>
	<tr>
		<td colspan="13">&nbsp;</td>
	</tr>
  <%
				}
			}
		}
	}
	%>		
  <!-- end threads resources  -->
</table>	
