<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%!static final String BASE_DIRECTORY = "../../";%>
<%

String baseDirectory = request.getParameter("baseDirectory");
if (baseDirectory == null){
   baseDirectory = BASE_DIRECTORY;
}
	
String suffix = "_resources";

boolean showMenu = true;
if(showMenu) {
	String menuIds = "resourceyEdit,resourceDelete";
	String menuTexts = "Edit,Delete";
	String menuHrefs = "javascript:resourceEdit(),javascript:resourceDelete()";
%>
<jsp:include page="../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
		</jsp:include>

	<jsp:include page="../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	 <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	</jsp:include>
<%
}
%>
<script>
function resourceEdit(){
     var id = mygrid_resources.getSelectedRowId();
        if (id == "") {
           return;
        }
        openResourceEdit(id);
}

function openResourceEdit(id){
    var isDefault =  false;
    var type = "";
    var runnerNode = "";
    var hosts = "";
    var maxThreads = "";
    var maxThreadsPerHost = "";
    if (id != ""){
    	isDefault = mygrid_resources.getUserData(id,"isDefault");
      type = mygrid_resources.cells(id,0).getValue();
      runnerNode = mygrid_resources.cells(id,1).getValue();
      hosts = mygrid_resources.cells(id,2).getValue();
      if (hosts == "*"){
          hosts = "";
      }
      maxThreads = mygrid_resources.cells(id,3).getValue();
      maxThreadsPerHost = mygrid_resources.cells(id,4).getValue();
    }    

      
      if (document.getElementById("resourceEditKey")){
          document.getElementById("resourceEditKey").value = id;
      }
      if (document.getElementById("resourceIsDefault")){
          document.getElementById("resourceIsDefault").value = isDefault;
      }
      if (document.getElementById("resourceHostsOrig")){
          document.getElementById("resourceHostsOrig").value = hosts;
      }
      if (document.getElementById("resourceType")){
          document.getElementById("resourceType").value = type;      
        }
      if (document.getElementById("resourceRunnerNode")){
          document.getElementById("resourceRunnerNode").value = runnerNode;
        }
      if (document.getElementById("resourceMaxThreadsPerHost")){     
          document.getElementById("resourceMaxThreadsPerHost").value = maxThreadsPerHost;
        }      
      if (id != "" && hosts == ""){
    	  document.getElementById("resourceType").classKey="DISABLED_TEXTBOX";
    	  document.getElementById("resourceHostsTD").style.display="none";
    	  document.getElementById("resourceMaxThreadsTD").style.display="";
    	  if (document.getElementById("resourceMaxThreads")){     
            document.getElementById("resourceMaxThreads").value = maxThreads;
         }
      }else {
    	  document.getElementById("resourceType").classKey="";
    	  document.getElementById("resourceHostsTD").style.display="";
    	  document.getElementById("resourceMaxThreadsTD").style.display="none";
    	  if (document.getElementById("resourceHosts")){     
           document.getElementById("resourceHosts").value = hosts;
        }
      }
                
      showGeneralAdminDiv("editResource",-1,100);
      document.getElementById("resourceMaxThreadsPerHost").focus();     
   
}

function hideResource(){
	showGeneralAdminDiv('editResource'); 
}

function saveResource(){
     var key = document.getElementById("resourceEditKey").value;
    var isDefault = document.getElementById("resourceIsDefault").value;
    var hosts = document.getElementById("resourceHostsOrig").value;     
	  var consumer = document.getElementById("resourceType").value;
	  var runnerNode = document.getElementById("resourceRunnerNode").value;
	  var maxThreadsPerHost = document.getElementById("resourceMaxThreadsPerHost").value;
    var params = "isDefault=" + isDefault + "&consumer=" + consumer + "&runnerNode=" + runnerNode + "&maxThreadsPerHost=" + maxThreadsPerHost + "&hosts=" + hosts;    
    if (isDefault && isDefault == "true"){
      params += "&maxThreads=" + document.getElementById("resourceMaxThreads").value;
    }else {
    	params += "&newHosts=" + document.getElementById("resourceHosts").value;
    	params += "&maxThreads=" + maxThreadsPerHost;
    }
	  hideResource();
    showMessage("Resources","mygrid_resources","Saving",200,60);
    workingSupportData("_resources",baseDirectory + "support/advancedSettings/resourcesActions.jsp","action=save&" + params  + "&timestamp=" + new Date().getTime());
  }


function resourceDelete(){
     var id = mygrid_resources.getSelectedRowId();
        if (id == "") {
           return;
        }
        var name = mygrid_resources.cells(id,0).getValue();
        showActionMessage("Resource Delete Action","mygrid_resources","doDeleteResource('" + id + "','" +  id + "')","<nobr>Are you sure you want to delete resource </nobr>" + name + "?");
  }



    function doDeleteResource(row,id){
      showMessage("Resources","mygrid_resources","Delete",200,60);
      var consumer = mygrid_resources.cells(id,0).getValue();
      var hosts = mygrid_resources.cells(id,2).getValue();
      var isDefault = mygrid_resources.getUserData(id,"isDefault");
      workingSupportData("_resources",baseDirectory + "support/advancedSettings/resourcesActions.jsp","action=delete&consumer=" + consumer + "&hosts=" + hosts + "&isDefault=" + isDefault +  "&timestamp=" + new Date().getTime());
    }


function handleMenuItems_resources(){
  aMenu_resources.menu.showButtons("resourceEdit");
  aMenu_resources.menu.showButtons("resourceDelete");	
}

function refreshSupportTable_resources(){
	disableActionButton("resourceEdit");
	disableActionButton("resourceDelete");
	updateTable_resources();  
}

		
	function refreshResourcesInfo(){
		var t = applicationTabs.tabs[applicationTabs.selectedTabIndex];
		if (t && t.id == "ResourceManager"){
			updateTable_resources();
		}
	}

	initMenus<%=suffix %>();
</script>
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
		<tr valign="top">
			<td width="100%">
      <jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
      <jsp:param name="baseDirectory" value="<%=baseDirectory%>"/> 
      <jsp:param name="title" value="Resource Edit"/> 
      <jsp:param name="suffix" value="editResource"/> 
      <jsp:param name="includePath" value="support/advancedSettings/resourceEdit.jsp"/>      
      <jsp:param name="width" value="600px"/> 
      <jsp:param name="height" value="300px"/>
      <jsp:param name="zIndex" value="300"/>  
      <jsp:param name="actionsNames" value="Save#Cancel"/> 
      <jsp:param name="actions" value="javascript:saveResource()#javascript:hideResource()"/> 
      </jsp:include>
			<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
				<tr>
					<td valign="top" height="100%" style="padding-top:10px">
					<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              								
						<tr height="*">
							<td valign="top"> 
							<% 
							String tableNames = "New#Edit#Delete";
							String tableActions = "javascript:openResourceEdit('')#javascript:resourceEdit()#javascript:resourceDelete()";
							String ids = "resourceNewTable#resourceTableEdit#resourceTableDelete";
							String selectTypes = "1#2#2";
              
							String initXML = "support/advancedSettings/resourcesViewXML.jsp?suffix=resources&baseDirectory=" + baseDirectory;
							String updateXML = "support/advancedSettings/resourcesViewXML.jsp?suffix=resources&dataOnly=true&baseDirectory=" + baseDirectory;
              String menu = showMenu ? "aMenu_resources" : "";
							%>                               
							<jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />								
							<jsp:param name="initXML" value="<%=initXML%>" />	
							<jsp:param name="updateXML" value="<%=updateXML%>" />																		
							<jsp:param name="menu" value="<%=menu%>" />
							<jsp:param name="suffix" value="<%=suffix %>" />
							<jsp:param name="recordsText" value="Resources" />
							<jsp:param name="style" value="main" />
							<jsp:param name="height" value="100%" />
							<jsp:param name="autoHeight" value="-1" />
							<jsp:param name="rowsNumPerPage" value="-1" />
							<jsp:param name="multiline" value="true" />
              <jsp:param name="tableActionNames" value="<%=tableNames%>" />
              <jsp:param name="tableActions" value="<%=tableActions%>" />
              <jsp:param name="tableActionIds" value="<%=ids%>" />
              <jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
							</jsp:include>													
							</td>
						</tr>								
					</table>
					</td>
				</tr>
			</table>
			</td>
		</tr>
	</table>		
<script>
function updateButtonActivate_resources(rowid,id,columnType,gridType){
     if (!rowid || !mygrid_resources.doesRowExist(rowid) || (gridType == 3 && columnType != 3)){
      
       disableActionButton(id);
       return;
     }   

     if (gridType == 2 && id == "resourceTableDelete"){     
      var isDefault = mygrid_resources.getUserData(rowid,"isDefault");
      if (isDefault == "true"){
    	  disableActionButton(id);        
      }else {
    	  enableActionButton(id);
      }       
     }else {
      if (gridType == columnType || (gridType == 2)){
         enableActionButton(id);
      }else {
         disableActionButton(id);
      }
     }
}
</script>