<%!

	static final String CONF_DIRECTORY = Configuration.XPOLOG_ROOT_PATH		+ "conf/systemlogs/";
	static final String BASE_DIRECTORY = "../";
	static final int  OP_TYPE = 1;
	static final String EXPORT_FLOW = "EXPORT_FLOW";	
	
	public ExportModuleFlow createExportFlow(HttpServletRequest request){
	UserContext userContext = UserEnvironment.getUserContext(request);

	  HashMap logs = new HashMap();
	  List membersList = new ArrayList();
	  String [] logsArr = request.getParameterValues("supportLogsCheckBoxList");  
	  if (logsArr != null){
	    for (int i = 0;i< logsArr.length;i++){
	      logs.put(logsArr[i],logsArr[i]);
	      ModuleMember mem = new ModuleMember();
	      mem.setId(logsArr[i]);
	      mem.setName(logsArr[i]);
	      mem.setType("Log");
	      mem.setDescription("");
	      membersList.add(mem);
	    }
	  }

	  Module curmod = new Module();
	  curmod.setName("supportLogs");
	  curmod.setType("Module");
	  curmod.setId("supportLogs");
	  curmod.setDescription("selected logs zip root folder");  
	  curmod.setMembers(membersList);
	 
		//	audit
	  	String Name = "";
	  	if(curmod != null) {
	  		Name = curmod.getName();
	  	}
	  	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	  		  			userContext, AuditConstants.CHANGE, "Test", AuditConstants.CONFIGURATION, "Test " + Name);


	  ExportFlow fl = (ExportFlow)request.getSession().getAttribute(EXPORT_FLOW);
	  ExportModuleFlow flow = null;
	  if (fl == null || !(fl instanceof ExportModuleFlow)){
	    flow = new ExportModuleFlow();
	  }else{
	  	flow = (ExportModuleFlow)fl;
	  }
	  flow.setOperationType(OP_TYPE);
	  flow.setActionURL(null);
	  flow.setLogModulesMap(logs,null);
	  flow.setModule(curmod);
	  
	  return flow;
	}	
	 
%>
