<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%!static final String BASE_DIRECTORY = "../../";%>
<%

String baseDirectory = request.getParameter("baseDirectory");
if (baseDirectory == null){
   baseDirectory = BASE_DIRECTORY;
}
	
String suffix = "_collections";

boolean showMenu = true;
if(showMenu) {
	String menuIds = "deleteCollection,deleteCollectionData";
	String menuTexts = "Delete Collection,Delete Data";
	String menuHrefs = "javascript:deleteCollection(),javascript:deleteCollectionData()";
%>

<jsp:include page="../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
		</jsp:include>

	<jsp:include page="../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	 <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	</jsp:include>
<%
}
%>
<script>
function deleteCollectionData(){
    var id = mygrid_collections.getSelectedRowId();
    if (id == "") {
       return;
    }
    if (id.indexOf(",") >= 0){
      doCollectionDataMembersDelete(id,id);
      return;
    }
    deleteMemberCollectionData(id);
 }

 function doCollectionDataMembersDelete(id){
	   var hasFileWriters = true;
	   var msg = "<nobr>Are you sure you want to delete data for all selected collections</nobr>" + "?";
	   var title = "Collection Data Delete Action";
	   var tableName = "mygrid_collections";
	   var yesFunction = "doDeleteCollectionData('" + id + "','" +  id + "')";
	   if (hasFileWriters && hasFileWriters == "true"){
		   showCollectionWritersMessage(title,tableName,yesFunction,msg);
	   }else {
	     showActionMessage(title,tableName,yesFunction,msg);
	   }   
	   
 }

 function deleteMemberCollectionData(id){
   var name = mygrid_collections.cells(id,0).getValue();
   var hasFileWriters = mygrid_collections.getUserData(id,"hasFileWriters");
   var msg = "<nobr>Are you sure you want to delete data for log collection</nobr>" + name + "?";
   var title = "Collection Data Delete Action";
   var tableName = "mygrid_collections";
   var yesFunction = "doDeleteCollectionData('" + id + "','" +  id + "')";
   if (hasFileWriters && hasFileWriters == "true"){
	   showCollectionWritersMessage(title,tableName,yesFunction,msg);
   }else {
     showActionMessage(title,tableName,yesFunction,msg);
   }   
  
 }

 function doDeleteCollectionData(row,id){   
   var delParam = document.getElementById("deleteStorageLog");
   var deleteStorageLog = "false"; 
 	 if(delParam && delParam){
 		 deleteStorageLog = "true";
 	 }
 	 delParam = document.getElementById("deleteCollectedData");
   var deleteCollectedData = "false";
 	 if(delParam && delParam.checked){
 		 deleteCollectedData = "true";
 	 }
   showMessage("Collection","mygrid_collections","Deleting data",200,60);
   workingSupportData("_collections",baseDirectory + "support/data/collectionActions.jsp","action=deleteData&collectionIds=" + id + "&deleteStorageLog=" + deleteStorageLog + "&deleteCollectedData=" + deleteCollectedData + "&timestamp=" + new Date().getTime());
 }

 function deleteCollection(){
     var id = mygrid_collections.getSelectedRowId();
     if (id == "") {
        return;
     }
     if (id.indexOf(",") >= 0){
       doCollectionMembersDelete(id,id);
       return;
     }
     deleteMemberCollection(id);
  }

  function doCollectionMembersDelete(id){
	    var hasFileWriters = true;
	    var msg = "<nobr>Are you sure you want to delete all selected collections</nobr>" + "?";
	    var title = "Collection Delete Action";
	    var tableName = "mygrid_collections";
	    var yesFunction = "doDeleteCollection('" + id + "','" +  id + "')";
	    if (hasFileWriters && hasFileWriters == "true"){
	    	showCollectionWritersMessage(title,tableName,yesFunction,msg);
	    }else {
	      showActionMessage(title,tableName,yesFunction,msg);
	    }   	    
  }

  function deleteMemberCollection(id){
    var name = mygrid_collections.cells(id,0).getValue();    
    var hasFileWriters = mygrid_collections.getUserData(id,"hasFileWriters");
    var msg = "<nobr>Are you sure you want to delete collection </nobr>" + name + "?";
    var title = "Collection Delete Action";
    var tableName = "mygrid_collections";
    var yesFunction = "doDeleteCollection('" + id + "','" +  id + "')";
    if (hasFileWriters && hasFileWriters == "true"){
    	showCollectionWritersMessage(title,tableName,yesFunction,msg);
    }else {
      showActionMessage(title,tableName,yesFunction,msg);
    }   
  }

  function doDeleteCollection(row,id,hasFileWriters){    
    var delParam = document.getElementById("deleteStorageLog");
    var deleteStorageLog = "false"; 
  	if(delParam && delParam){
  		deleteStorageLog = "true";
  	}
  	delParam = document.getElementById("deleteCollectedData");
    var deleteCollectedData = "false";
  	if(delParam && delParam.checked){
  		deleteCollectedData = "true";
  	}
  	showMessage("Collection","mygrid_collections","Deleting collection",200,60);
    workingSupportData("_collections",baseDirectory + "support/data/collectionActions.jsp","action=delete&collectionIds=" + id + "&timestamp=" + new Date().getTime() + "&deleteStorageLog=" + deleteStorageLog + "&deleteCollectedData=" + deleteCollectedData);
  }

  function showCollectionWritersMessage(title,tableName,yesFunction,msg){
	  var msgWriter = createActionMessage(title,tableName,yesFunction);
	  msgWriter.addChbox("Delete storage log","deleteStorageLog","true");  
	  msgWriter.addChbox("Delete collected data","deleteCollectedData","true");
	  msgWriter.showMessage(msg);
  }

function handleMenuItems_collections(){
	aMenu_collections.menu.showButtons("deleteCollection");
  aMenu_collections.menu.showButtons("deleteCollectionData");	
}



	function refreshCollectionInfo(){
		var t = applicationTabs.tabs[applicationTabs.selectedTabIndex];
		if (t && t.id == "Collection"){
			updateTable_collections();
		}
	}

	function refreshSupportTable_collections(){
		disableActionButton("deleteTableCollection");
		updateTable_collections();  
	}

	initMenus<%=suffix %>();
</script>
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
		<tr valign="top">
			<td width="100%">
			<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
				<tr>
					<td valign="top" height="100%" style="padding-top:10px">
					<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              								
						<tr height="*">
							<td valign="top"> 
							<% 
							String tableNames = "Delete Collection#Delete Collection Data";
							String tableActions = "javascript:deleteCollection()#javascript:deleteCollectionData()";
							String ids = "deleteTableCollection#deleteTableCollectionData";
							String selectTypes = "3#3";
                
							String initXML = "support/data/collectionsViewXML.jsp?suffix=collections&baseDirectory=" + baseDirectory;
							String updateXML = "support/data/collectionsViewXML.jsp?suffix=collections&dataOnly=true&baseDirectory=" + baseDirectory;
              				String menu = showMenu ? "aMenu_collections" : "";              				
							%>                               
							<jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />								
							<jsp:param name="initXML" value="<%=initXML%>" />	
							<jsp:param name="updateXML" value="<%=updateXML%>" />																		
							<jsp:param name="menu" value="<%=menu%>" />
							<jsp:param name="suffix" value="<%=suffix %>" />
							<jsp:param name="recordsText" value="Collections" />
							<jsp:param name="style" value="main" />
							<jsp:param name="height" value="100%" />
							<jsp:param name="autoHeight" value="-1" />
							<jsp:param name="rowsNumPerPage" value="-1" />
							<jsp:param name="multiline" value="true" />
              <jsp:param name="tableActionNames" value="<%=tableNames%>" />
              <jsp:param name="tableActions" value="<%=tableActions%>" />
              <jsp:param name="tableActionIds" value="<%=ids%>" />
              <jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />      
							</jsp:include>													
							</td>
						</tr>								
					</table>
					</td>
				</tr>
			</table>
			</td>
		</tr>
	</table>		
