<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.Constants"%>

<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>

<%!static final String BASE_DIRECTORY = "../../";%>
<%

String baseDirectory = request.getParameter("baseDirectory");
if (baseDirectory == null){
   baseDirectory = BASE_DIRECTORY;
}

String analytics = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_DISPLAY_NAME);
String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);
	
String suffix = "_dashboardLogs";

boolean showMenu = true;
if(showMenu) {
	String menuIds = "deleteDashboardLogsData";
	String menuTexts = "Delete";
	String menuHrefs = "javascript:deleteDashboardLogsData();";
%>
<jsp:include page="../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
		</jsp:include>

	<jsp:include page="../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	 <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	</jsp:include>
<%
}
%>
<script>

function deleteDashboardLogsData(){
   var id = mygrid_dashboardLogs.getSelectedRowId();
   if (id == "") {
      return;
   }
   if (id.indexOf(",") >= 0){
     doDashboardLogsMembersDelete(id,id);
     return;
   }
   deleteMemberDashboardLogs(id);
}

function doDashboardLogsMembersDelete(id){
 showActionMessage("<%=analyticsH%> Logs Delete Action","mygrid_dashboardLogs","doDeleteDashboardLogs('" + id + "','" +  id + "')","<nobr>Are you sure you want to delete <%=analytics%> data for all selected logs</nobr>" + "?");   
}

function deleteMemberDashboardLogs(id){
  var name = mygrid_dashboardLogs.cells(id,0).getValue();
  showActionMessage("<%=analyticsH%> Logs Delete Action","mygrid_dashboardLogs","doDeleteDashboardLogs('" + id + "','" +  id + "')","<nobr>Are you sure you want to delete <%=analytics%> data for log </nobr>" + name + "?");   
}

function doDeleteDashboardLogs(row,id){
  showMessage("<%=analyticsH%> Logs","mygrid_dashboardLogs","Deleting",200,60);
  workingSupportData("_dashboardLogs",baseDirectory + "support/data/dashboardActions.jsp","action=delete&computationType=logs&computationIds=" + id + "&timestamp=" + new Date().getTime());
}


function handleMenuItems_dashboardLogs(){
  aMenu_dashboardLogs.menu.showButtons("deleteDashboardLogsData");	
}

		
	function refreshDashboardLogsInfo(){
		var t = applicationTabs.tabs[applicationTabs.selectedTabIndex];
		if (t && t.id == "<%=analyticsH%> Logs"){
			updateTable_dashboardLogs();
		}
	}

	initMenus<%=suffix %>();
</script>
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
		<tr valign="top">
			<td width="100%">
			<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
				<tr>
					<td valign="top" height="100%" style="padding-top:10px">
					<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              								
						<tr height="*">
							<td valign="top"> 
							<% 
              
							String tableNames = "Delete Data";
						  String tableActions = "javascript:deleteDashboardLogsData()";
						  String ids = "deleteTableDashboardLogsData";
						  String selectTypes = "3";
							String initXML = "support/data/dashboardLogsViewXML.jsp?suffix=dashboardLogs&baseDirectory=" + baseDirectory;
							String updateXML = "support/data/dashboardLogsViewXML.jsp?suffix=dashboardLogs&dataOnly=true&baseDirectory=" + baseDirectory;
              				String menu = showMenu ? "aMenu_dashboardLogs" : "";              				
							%>                               
							<jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />								
							<jsp:param name="initXML" value="<%=initXML%>" />	
							<jsp:param name="updateXML" value="<%=updateXML%>" />																		
							<jsp:param name="menu" value="<%=menu%>" />
							<jsp:param name="suffix" value="<%=suffix %>" />
							<jsp:param name="recordsText" value="Logs" />
							<jsp:param name="style" value="main" />
							<jsp:param name="height" value="100%" />
							<jsp:param name="autoHeight" value="-1" />
							<jsp:param name="rowsNumPerPage" value="-1" />
							<jsp:param name="multiline" value="true" />
              <jsp:param name="tableActionNames" value="<%=tableNames%>" />
              <jsp:param name="tableActions" value="<%=tableActions%>" />
              <jsp:param name="tableActionIds" value="<%=ids%>" />
              <jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
              
							</jsp:include>													
							</td>
						</tr>								
					</table>
					</td>
				</tr>
			</table>
			</td>
		</tr>
	</table>		
