<%@page import="xpolog.eye.data.index.IndexedObject"%>
<%@page import="xpolog.eye.data.index.adapters.IndexAdapter"%>

<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.data.index.adapters.defaultadapter.LogsIndexerRunner"%>
<%@page import="xpolog.eye.data.index.SearchEngineManager"%>
<%@page import="xpolog.eye.data.index.adapters.defaultadapter.LogIndexerRunner"%><%@ page language="java"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.data.index.adapters.defaultadapter.DefaultIndexingHelper"%>
<%@page import="xpolog.eye.error.ErrorModel"%>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>

<%!static final String BASE_DIRECTORY = "../../";
	static final String DELIMITER = ",";
	static final String CONF_DIRECTORY = Configuration.XPOLOG_ROOT_PATH
			+ "conf/systemlogs/";
	static final String SEARCH_ENGINE_TAB_INDX = "2";%>
<%
	if (!WebSecurityManager.getInstance().checkForPermission(request,response, ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)) {
		return;
	}
  UserContext userContext = UserEnvironment.getUserContext(request);
  boolean success = true;
  String message = "";  
  String childrenIdsList = null;
	String path = DefaultIndexingHelper.getIndexDirectory();
  String action = request.getParameter("action");
	String indexedLogsIds = request.getParameter("indexedIds");
  if (action == null || action.length() == 0){
    success = false;
    message = "No action was selected";
  } else if (indexedLogsIds != null && indexedLogsIds.length() > 0){
  	StringTokenizer indexedLogsIdsList = new StringTokenizer(indexedLogsIds,DELIMITER);
  	if (action.equalsIgnoreCase("delete")){
  	  IndexAdapter indexer = SearchEngineManager.getInstance().getDefaultIndexAdapter();       
	    while (indexedLogsIdsList.hasMoreTokens()) {
		    String indexedogId = indexedLogsIdsList.nextToken(); 
	      indexer.removeIndex(new IndexedObject(indexedogId));

				/*
		    File rootIndexDir = new File(path + "/" + indexedogId);
        try {      		
		      if (rootIndexDir.isDirectory()) {
			      FileUtil.deleteFile(rootIndexDir);
		      }
        }catch (Exception e){
    	    ErrorModel.log.error("Failed to delete index " + rootIndexDir, e);
		      success = false;
		      message = e.getMessage(); 
        }
        */
      }
  	}else if (action.equalsIgnoreCase("index")){
  		LogsIndexerRunner runner = SearchEngineManager.getInstance().getCustomIndexerRunner();
      ArrayList list = new ArrayList();
      while (indexedLogsIdsList.hasMoreTokens()) {
        String indexedogId = indexedLogsIdsList.nextToken();      
        list.add(indexedogId);
      }
      String [] logsArr = (String [])list.toArray(new String[list.size()]);
      boolean sucToRun = runner.executeIndexing(logsArr,userContext,"Support indexing");
      if (!sucToRun){
        success = false;
        message = "Manual indexing is already running, please wait until it will finish";
      }
    }	else if (action.equalsIgnoreCase("reindex")){
  		LogsIndexerRunner runner = SearchEngineManager.getInstance().getCustomIndexerRunner();
      if (runner.isRunning()){
    	  success = false;
        message = "Manual indexing is already running, please wait until it will finish";
      }else {
    	  IndexAdapter indexer = SearchEngineManager.getInstance().getDefaultIndexAdapter();
        ArrayList list = new ArrayList();
        while (indexedLogsIdsList.hasMoreTokens()) {
          String indexedogId = indexedLogsIdsList.nextToken();
          indexer.removeIndex(new IndexedObject(indexedogId));  
          list.add(indexedogId);
        }
        Thread.sleep(2000);
        String [] logsArr = (String [])list.toArray(new String[list.size()]);
        boolean sucToRun = runner.executeIndexing(logsArr,userContext,"Support indexing");
        if (!sucToRun){
          success = false;
          message = "Manual indexing is already running, please wait until it will finish";
        }
      }
    }	
  }else {
    message = "No log selected, please refresh and try again";
  }
  String xml = GridModelActionsHelper.getResultXML(success, message, "", childrenIdsList);

  response.setContentType("text/xml");
  response.setHeader("Pragma-Control", "no-cache");
  response.setHeader("Cache-Control", "no-cache");
  response.setHeader("Expires", "0");
  
  out.write(xml);
  out.flush();
%>