
<%@page import="xpolog.eye.audit.AuditConstants"%>
<%@page import="xpolog.eye.audit.AuditManager"%>
<%@page import="xpolog.eye.verifiers.Verifier"%>
<%@page import="xpolog.eye.SiteManagment"%>
<%@page import="xpolog.eye.verifiers.VerifierManager"%><%@page import="xpolog.eye.reports.health.ui.DashboardDataManager"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.data.index.SearchEngineManager"%>
<%@page import="xpolog.eye.data.index.adapters.defaultadapter.LogIndexerRunner"%><%@ page language="java"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.data.index.adapters.defaultadapter.DefaultIndexingHelper"%>
<%@page import="xpolog.eye.error.ErrorModel"%>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>

<%!
  static final String BASE_DIRECTORY = "../../";
	static final String DELIMITER = ",";
 %>
<%
	if (!WebSecurityManager.getInstance().checkForPermission(request,response, ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)) {
		return;
	}
  UserContext userContext = UserEnvironment.getUserContext(request);
  boolean success = true;
  String message = "";  
  String childrenIdsList = null;
	String path = DefaultIndexingHelper.getIndexDirectory();
  String action = request.getParameter("action");
  String monitorIds = request.getParameter("monitorIds");
  if (monitorIds != null && monitorIds.length() > 0){
  	StringTokenizer indexedLogsIdsList = new StringTokenizer(monitorIds,DELIMITER);
  	if (action.equalsIgnoreCase("delete")){
  		VerifierManager verMgr = SiteManagment.getInstance().getVerifierManager();
	    while (indexedLogsIdsList.hasMoreTokens()) {
		    String id = indexedLogsIdsList.nextToken();
		    String name = "";
        try {      		        	
        	Verifier monitor = verMgr.getVerfierFromId(id);  		    
  		    if (monitor != null) {
  			    name = monitor.getName();
  		    }
  		    //audit
  		    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL, userContext,AuditConstants.CHANGE, "remove monitor",AuditConstants.VERIFIERS, "remove monitor " + name);
    		  verMgr.removeVerifier(id, userContext, false);
        }catch (Exception e){
        	ErrorModel.log.error("Failed to remove monitor " + name+ " with id " + id, e);
		      success = false;
		      message = e.getMessage(); 
        }
      }	
  	}	else if (action.equalsIgnoreCase("reset")){
      VerifierManager verMgr = SiteManagment.getInstance().getVerifierManager();
      while (indexedLogsIdsList.hasMoreTokens()) {
        String id = indexedLogsIdsList.nextToken();
        String name = "";
        try {                   
          Verifier monitor = verMgr.getVerfierFromId(id);         
          if (monitor != null) {
            name = monitor.getName();
          }
          //audit
          AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL, userContext,AuditConstants.CHANGE, "reset monitor",AuditConstants.VERIFIERS, "reset monitor " + name);
          verMgr.removeVerifierTempDir(id);
        }catch (Exception e){
          ErrorModel.log.error("Failed to reset monitor " + name+ " with id " + id, e);
          success = false;
          message = e.getMessage(); 
        }
      } 
    }
  }else {
    message = "No monitor selected, please refresh and try again";
  }
  String xml = GridModelActionsHelper.getResultXML(success, message, "", childrenIdsList);

  response.setContentType("text/xml");
  response.setHeader("Pragma-Control", "no-cache");
  response.setHeader("Cache-Control", "no-cache");
  response.setHeader("Expires", "0");
  
  out.write(xml);
  out.flush();
%>