<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%!static final String BASE_DIRECTORY = "../../";%>
<%

String baseDirectory = request.getParameter("baseDirectory");
if (baseDirectory == null){
   baseDirectory = BASE_DIRECTORY;
}
	
String suffix = "_monitors";

boolean showMenu = true;
if(showMenu) {
	String menuIds = "deleteMonitor,resetMonitor";
	String menuTexts = "Delete Monitor,Reset Monitor";
	String menuHrefs = "javascript:deleteMonitor(),javascript:resetMonitor()";
%>
<jsp:include page="../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
		</jsp:include>

	<jsp:include page="../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	 <jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
		<jsp:param name="suffix" value="<%=suffix %>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	</jsp:include>
<%
}
%>
<script>
function resetMonitor(){
    var id = mygrid_monitors.getSelectedRowId();
    if (id == "") {
       return;
    }
    if (id.indexOf(",") >= 0){
      doMonitorMembersReset(id,id);
      return;
    }
    resetMemberMonitor(id);
    
  }


function doMonitorMembersReset(id){
     showActionMessage("Monitor Reset Action","mygrid_monitors","doResetMonitor('" + id + "','" +  id + "')","<nobr>Are you sure you want to reset all selected monitors</nobr>" + "?");   
    }

    function resetMemberMonitor(id){
      var name = mygrid_monitors.cells(id,0).getValue();
      showActionMessage("Monitor Reset Action","mygrid_monitors","doResetMonitor('" + id + "','" +  id + "')","<nobr>Are you sure you want to reset monitor </nobr>" + name + "?");   
    }

    function doResetMonitor(row,id){
      showMessage("Monitor","mygrid_monitors","Reseting",200,60);
      workingSupportData("_monitors",baseDirectory + "support/data/monitorActions.jsp","action=reset&monitorIds=" + id + "&timestamp=" + new Date().getTime());
    }


function deleteMonitor(){
     var id = mygrid_monitors.getSelectedRowId();
     if (id == "") {
        return;
     }
     if (id.indexOf(",") >= 0){
       doMonitorMembersDelete(id,id);
       return;
     }
     deleteMemberMonitor(id);
  }

  function doMonitorMembersDelete(id){
   showActionMessage("Monitor Delete Action","mygrid_monitors","doDeleteMonitor('" + id + "','" +  id + "')","<nobr>Are you sure you want to delete all selected monitors</nobr>" + "?");   
  }

  function deleteMemberMonitor(id){
    var name = mygrid_monitors.cells(id,0).getValue();
    showActionMessage("Monitor Delete Action","mygrid_monitors","doDeleteMonitor('" + id + "','" +  id + "')","<nobr>Are you sure you want to delete monitor </nobr>" + name + "?");   
  }

  function doDeleteMonitor(row,id){
    showMessage("Monitor","mygrid_monitors","Deleting",200,60);
    workingSupportData("_monitors",baseDirectory + "support/data/monitorActions.jsp","action=delete&monitorIds=" + id + "&timestamp=" + new Date().getTime());
  }


function handleMenuItems_monitors(){
	aMenu_monitors.menu.showButtons("deleteMonitor");
  aMenu_monitors.menu.showButtons("resetMonitor");	
}

		
	function refreshMonitorsInfo(){
		var t = applicationTabs.tabs[applicationTabs.selectedTabIndex];
		if (t && t.id == "Monitors"){
			updateTable_monitors();
		}
	}

	initMenus<%=suffix %>();
</script>
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
		<tr valign="top">
			<td width="100%">
			<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
				<tr>
					<td valign="top" height="100%" style="padding-top:10px">
					<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              								
						<tr height="*">
							<td valign="top"> 
							<% 
              
							String tableNames = "Delete Monitor#Reset Monitor";
							  String tableActions = "javascript:deleteMonitor()#javascript:resetMonitor()";
							  String ids = "deleteTableMonitor#resetTablemonitor";
							  String selectTypes = "3#3";
							String initXML = "support/data/monitorsViewXML.jsp?suffix=monitors&baseDirectory=" + baseDirectory;
							String updateXML = "support/data/monitorsViewXML.jsp?suffix=monitors&dataOnly=true&baseDirectory=" + baseDirectory;
              				String menu = showMenu ? "aMenu_monitors" : "";              				
							%>                               
							<jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />								
							<jsp:param name="initXML" value="<%=initXML%>" />	
							<jsp:param name="updateXML" value="<%=updateXML%>" />																		
							<jsp:param name="menu" value="<%=menu%>" />
							<jsp:param name="suffix" value="<%=suffix %>" />
							<jsp:param name="recordsText" value="Monitors" />
							<jsp:param name="style" value="main" />
							<jsp:param name="height" value="100%" />
							<jsp:param name="autoHeight" value="-1" />
							<jsp:param name="rowsNumPerPage" value="-1" />
							<jsp:param name="multiline" value="true" />
              <jsp:param name="tableActionNames" value="<%=tableNames%>" />
              <jsp:param name="tableActions" value="<%=tableActions%>" />
              <jsp:param name="tableActionIds" value="<%=ids%>" />
              <jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />              
							</jsp:include>													
							</td>
						</tr>								
					</table>
					</td>
				</tr>
			</table>
			</td>
		</tr>
	</table>		
