
<%@page import="xpolog.eye.reports.Report"%>
<%@page import="xpolog.eye.reports.ReportsManager"%>
<%@page import="xpolog.eye.audit.AuditConstants"%>
<%@page import="xpolog.eye.audit.AuditManager"%>
<%@page import="xpolog.eye.verifiers.Verifier"%>
<%@page import="xpolog.eye.SiteManagment"%>
<%@page import="xpolog.eye.verifiers.VerifierManager"%><%@page import="xpolog.eye.reports.health.ui.DashboardDataManager"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.data.index.SearchEngineManager"%>
<%@page import="xpolog.eye.data.index.adapters.defaultadapter.LogIndexerRunner"%><%@ page language="java"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.data.index.adapters.defaultadapter.DefaultIndexingHelper"%>
<%@page import="xpolog.eye.error.ErrorModel"%>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>

<%!
  static final String BASE_DIRECTORY = "../../";
	static final String DELIMITER = ",";
 %>
<%
	if (!WebSecurityManager.getInstance().checkForPermission(request,response, ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)) {
		return;
	}
  UserContext userContext = UserEnvironment.getUserContext(request);
  boolean success = true;
  String message = "";  
  String childrenIdsList = null;
	String path = DefaultIndexingHelper.getIndexDirectory();
  String action = request.getParameter("action");
  String reportIds = request.getParameter("reportIds");
  if (reportIds != null && reportIds.length() > 0){
  	StringTokenizer indexedLogsIdsList = new StringTokenizer(reportIds,DELIMITER);
  	if (action.equalsIgnoreCase("delete")){
  		ReportsManager reportMgr = ReportsManager.getInstance();
	    while (indexedLogsIdsList.hasMoreTokens()) {
		    String id = indexedLogsIdsList.nextToken();
		    String name = "";
        try {      		        	
        	Report report = reportMgr.getReportById(id, true);  		    
  		    if (report != null) {
  			    name = report.getReportName();
  		    }
  		    //audit
  		    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL, userContext,AuditConstants.CHANGE, "remove report",AuditConstants.REPORTS, "remove report " + name + " (" + id + ")");
  		    reportMgr.removeReport(id, userContext);
        }catch (Exception e){
        	ErrorModel.log.error("Failed to remove report " + name+ " with id " + id, e);
		      success = false;
		      message = e.getMessage(); 
        }
      }	
  	}	else if (action.equalsIgnoreCase("deleteData")){
  		ReportsManager reportMgr = ReportsManager.getInstance();
      while (indexedLogsIdsList.hasMoreTokens()) {
        String id = indexedLogsIdsList.nextToken();
        String name = "";
        try {                   
        	Report report = reportMgr.getReportById(id, true);  		    
  		    if (report != null) {
  			    name = report.getReportName();
  		    }
          //audit
           AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL, userContext,AuditConstants.CHANGE, "remove report data",AuditConstants.REPORTS, "remove data for report" + name + " (" + id + ")");
           reportMgr.removeAllReportRuntimes(id);
        }catch (Exception e){
          ErrorModel.log.error("Failed to remove report " + name+ " with id " + id, e);
          success = false;
          message = e.getMessage(); 
        }
      } 
    } else if (action.equalsIgnoreCase("keepLast")){
      ReportsManager reportMgr = ReportsManager.getInstance();
      String amountStr = request.getParameter("amount");
      int amount = 0;
      try {
       amount = Integer.parseInt(amountStr); 
      }catch (Exception e){}
        while (amount > 0 && indexedLogsIdsList.hasMoreTokens()) {
          String id = indexedLogsIdsList.nextToken();
          String name = "";
          try {                   
            Report report = reportMgr.getReportById(id, true);          
            if (report != null) {
              name = report.getReportName();
            }
            //audit
             AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL, userContext,AuditConstants.CHANGE, "keep last report data",AuditConstants.REPORTS, "keep last " + amount + " results for report" + name + " (" + id + ")");
             reportMgr.keepLastReportRuntimes(id,amount);
          }catch (Exception e){
            ErrorModel.log.error("Failed to keep last results for report " + name+ " with id " + id + " and amount " + amount, e);
            success = false;
            message = e.getMessage(); 
          }
        } 
      } 
  }else {
    message = "No report selected, please refresh and try again";
  }
  String xml = GridModelActionsHelper.getResultXML(success, message, "", childrenIdsList);

  response.setContentType("text/xml");
  response.setHeader("Pragma-Control", "no-cache");
  response.setHeader("Cache-Control", "no-cache");
  response.setHeader("Expires", "0");
  
  out.write(xml);
  out.flush();
%>