<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.audit.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.support.SupportQueryExecuter"%>
<%@ page import="xpolog.eye.support.handlers.XpologLogsInfoHandler"%>
<%@ page import="xpolog.eye.util.XMLUtil"%>
<%@ page import="xpolog.support.*"%>
<%@ page import="xpolog.support.index.IndexStatusQuery"%>

<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>

<%@ page import="org.w3c.dom.Document"%>
<%@ page import="org.w3c.dom.Element"%>

<%!
		String ERROR_OBJ = "ERROR_OBJ";
    String BASE_DIRECTORY = "../";
%>
<%
	
	ErrorModel errmodel = new ErrorModel(); 


	String showBackStr = request.getParameter("showBack");
	boolean showBack = showBackStr == null || !showBackStr.equals("false");

	String[] queriesKeys = {"xpologInfo","systemLogs","indexInfo","enititiesCounter","basicInformation","systemEnvironment","txExpo","computation","processesInfo","sshConnectionsInfo"};
	if (queriesKeys == null || queriesKeys.length == 0){
		errmodel.addError("No support queries were selected");
	}
	String[] logsArr = { "xpologlog", "events", "audit","systemaudit", "Console","ServletContainer", "Ant.out", "ssh", "XpoLogConsole","XpoLogMemory","localhostCpu","localhostMemory","localhostDiskSpace"};
	String[] logsWarArr = { "xpologlog", "events", "audit","systemaudit","XpoLogMemory","localhostCpu","localhostMemory","localhostDiskSpace"};
	if (Configuration.isWar()){
		logsArr = logsWarArr;
	}
	HashSet lbmsIds = new HashSet();
	for (int i=0; i<logsArr.length; i++){
		lbmsIds.add(logsArr[i]);
	}
	HashMap systemLogsMap = new HashMap();
	systemLogsMap.put(XpologLogsInfoHandler.LBMS_IDS_ATT,lbmsIds);
	HashMap queriesData = new HashMap();
	queriesData.put("systemLogs",systemLogsMap);
	queriesData.put(IndexStatusQuery.READ_INFO_FROM_INDEX_DOCS,"true");
	
	SupportQueryExecuter queryExec = new SupportQueryExecuter(null, queriesKeys, queriesData);
 	SupportQuery supportQuery = queryExec.getSupportQuery();
	SupportManager mgr = SupportManager.getInstance();
	SupportQueryHandler handler = mgr.getSupportHandlerByQuery(supportQuery);
	MultiSupportResult result= null;
	if (handler != null){
		handler.process(supportQuery);
		result = (MultiSupportResult)handler.getQueryResult();		
	}	

	Document doc = XMLUtil.buildXml();
	Element resultElem = null;
	if(result != null){
		resultElem = result.getAsXML(doc);
		doc.appendChild(resultElem);
	}

	String zipFilePath = "";
	try{
		HashMap logs = new HashMap();
		  List membersList = new ArrayList();
		  if (logsArr != null){
		    for (int i = 0;i< logsArr.length;i++){
		      logs.put(logsArr[i],logsArr[i]);
		      ModuleMember mem = new ModuleMember();
		      mem.setId(logsArr[i]);
		      mem.setName(logsArr[i]);
		      mem.setType("Log");
		      mem.setDescription("");
		      membersList.add(mem);
		    }
		  }

		  Module curmod = new Module();
		  curmod.setName("supportLogs");
		  curmod.setType("Module");
		  curmod.setId("supportLogs");
		  curmod.setDescription("selected logs zip root folder");  
		  curmod.setMembers(membersList);
		 
		  ExportFlow fl = (ExportFlow)request.getSession().getAttribute("EXPORT_FLOW");
		  ExportModuleFlow flow = null;
		  if (fl == null || !(fl instanceof ExportModuleFlow)){
		    flow = new ExportModuleFlow();
		  }else{
		  	flow = (ExportModuleFlow)fl;
		  }
		  flow.setOperationType(1);
		  flow.setActionURL(null);
		  flow.setLogModulesMap(logs,null);
		  flow.setModule(curmod);
		  
		
		File zipFile = flow.execute(null,doc);
	  zipFilePath = zipFile.getName();
	}catch(Exception e){
		errmodel.addError("Could not create zip file" + e);
	}
  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY+"common/errorpage.jsp");
    return;
  }

	
%>

<html>
<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css"
	href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
</head>

<body>
<table border="0" width="100%" cellspacing="0" height="100%"
	cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
	<tr>
		<td width="100%" height="100%" valign="top">
		<table border="0" width="100%" cellspacing="0" height="90%"
			cellpadding="0">
			<tr>
				<td valign="top" height="90%">
				<table border="0" cellpadding="0" cellspacing="0"
					style="border-collapse: collapse" width="100%" id="AutoNumber1">
					<tr>
						<td width="100%">
						<table border="0" cellpadding="0" cellspacing="0"
							style="border-collapse: collapse" width="100%" id="AutoNumber2"
							height="100%">
							<tr>
								<td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
								<td width="53%" class="TOPBORDER" height="0"><span
									class="PAGEHEADER">Zip Status</span></td>
								<td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
							</tr>
							<tr>
								<td width="3%" height="100%">&nbsp;</td>
								<td width="43%" height="100%">&nbsp;</td>
								<td width="50%" height="100%">&nbsp;</td>
							</tr>
							<tr>
								<td width="3%" height="100%">&nbsp;&nbsp;&nbsp;</td>
								<td width="93%" colspan="2" height="100%">
								<table border="0" cellpadding="0" cellspacing="0"
									style="border-collapse: collapse" width="100%" id="AutoNumber3"
									height="53">
									<tr>
										<td width="15%" height="18"><span class="REGULARTEXT">The
										zip was created successfully.&nbsp;</span></td>
									</tr>
									<tr>
										<td>&nbsp;</td>
									</tr>
								</table>
								</td>
							</tr>
						</table>
						</td>
					</tr>
				</table>
				</td>
			</tr>
			<%if (showBack){ %>
			<tr>
				<td valign="bottom" height="10%">
				<table border="0" width="100%">
					<tr>
						<td width="33%"></td>
						<td width="33%" align="center"><a href="index.jsp"
							class="LINK">back</a></td>
						<td width="34%"></td>
					</tr>
				</table>
				</td>
			</tr>
			<%} %>
			<tr>
				<td valign="bottom" height="10%">
				<table border="0" cellpadding="0" cellspacing="0" width="100%">
					<tr>
						<td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
						<td class="BOTTOMBORDER" width="33%">&nbsp;</td>
						<td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
</table>

<script>
 self.location = "<%=BASE_DIRECTORY + "temp/"+zipFilePath%>"; 
</script>
</body>
</html>
