<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.support.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.support.SupportQueryExecuter"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.common.JobStatus"%>
<%@ page import="xpolog.eye.site.SiteConstants"%>
<%@ page import="xpolog.eye.site.ProgressRunner"%>
<%@ page import="xpolog.eye.pack.ArchiveService"%>

<%@ page import="java.io.File"%>
<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../";

%>

<%
	String ERROR_OBJ = "ERROR_OBJ";

	final String xplgNodeId = request.getParameter("xplgNodeId");
	final String[] xplgNodes = request.getParameterValues("xplgNode");
	String closeWindowStr = request.getParameter("closeWindow");
	boolean closeWindow = closeWindowStr == null || closeWindowStr.equals("true");
	ErrorModel errmodel = new ErrorModel(); 
	if ((xplgNodeId == null || xplgNodeId.length() == 0) && xplgNodes == null){
		errmodel.addError("No Xplg Entereprise Nodes queries were selected");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY+"common/errorpage.jsp");
    return;
	}
	
	String queryKey = request.getParameter("queryKey");
	final SupportQueryExecuter queryExec = (SupportQueryExecuter)request.getSession().getAttribute("SupportQueryExecuter");;
	if (queryExec == null){
		errmodel.addError("No support query executer found");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY+"common/errorpage.jsp");
    return;
	}
	final HashMap results = queryExec.getResults();
	
	final UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, queryExec.getStatus());
	
	ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "support/exportSupportStatus.jsp") {
	  public void run(HttpServletRequest request){
			HashMap queryResults = new HashMap();
			if (xplgNodeId != null && xplgNodeId.length() > 0){
			  MultiSupportResult multiResult = (MultiSupportResult)results.get(xplgNodeId);
			  queryResults.put(xplgNodeId,multiResult);
			}else if (xplgNodes != null){
				for (int i=0; i<xplgNodes.length; i++){
				  MultiSupportResult multiResult = (MultiSupportResult)results.get(xplgNodes[i]);
				  queryResults.put(xplgNodes[i],multiResult);
				}
			}
			File file = null;
			try{
			  file = queryExec.exportResultsSeperately();
			}catch(Exception e){
			}
			env.setTempAttribute("SupportExportFile",file.getName());
	  }
	};
	env.setProgressRunner(runner);
%>

<jsp:include page="../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Processing"/>
 <jsp:param name="useStatus" value="true"/>
</jsp:include>
