<%@ page language="java"%>


<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.support.*"%>
<%@ page import="xpolog.eye.support.handlers.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.support.basic.*"%>
<%@ page import="java.util.Date.*"%>
<%@ page import="java.text.DateFormat"%>
<%@ page import="xpolog.eye.support.*"%>
<%@page import="java.text.SimpleDateFormat"%>

<%!static final String BASE_DIRECTORY = "../";%>

<%
	long ONE_HOUR_UNIT = 1000 * 60 * 60 * 1;
	//the logs list
	String[] logsArr = { "xpologlog", "events", "audit","systemaudit", "Console",
			"ServletContainer", "Ant.out", "MergeLogs" ,"ssh", "XpoLogConsole","XpoLogMemory","localhostCpu","localhostMemory","localhostDiskSpace"};
	String[] logsWarArr = { "xpologlog", "events", "audit","systemaudit", "MergeLogs" ,"XpoLogMemory","localhostCpu","localhostMemory","localhostDiskSpace"};
	if (Configuration.isWar()){
		logsArr = logsWarArr;
	}
	HashSet lbmsIds = new HashSet();
	for (int i = 0; i < logsArr.length; i++) {
		lbmsIds.add(logsArr[i]);
	}
	HashMap queryData = new HashMap();
	queryData.put(XpologLogsInfoHandler.LBMS_IDS_ATT, lbmsIds);

	XpologLogResultData result = null;
	SupportQuery supportQuery = new SupportQuery("systemLogs", queryData);
	SupportManager mgr = SupportManager.getInstance();
	SupportQueryHandler handler = mgr.getSupportHandlerByQuery(supportQuery);
	if (handler != null) {
		handler.process(supportQuery);
		result = (XpologLogResultData) handler.getQueryResult().getData();
	}

	SimpleDateFormat dateFormat = new SimpleDateFormat(Configuration
			.getInstance().getPropertiesManager().getProperty(
			"htmlInputDateFormat", "MM/dd/yyyy HH:mm:ss"));

	int numOfLogs = logsArr.length;
	
	boolean showResourceLogs = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("support.showResourceLogs", false);
%>

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";

  function selectAllLogs(){
  	for (var i=0; i<<%=numOfLogs%>; i++){
  		document.access.supportLogsCheckBoxList<%=logsArr.length > 1 ? "[i]" : ""%>.checked = true;
  	}
  }
  
  function clearAllLogs(){
  	for (var i=0; i<<%=numOfLogs%>; i++){
  		document.access.supportLogsCheckBoxList<%=logsArr.length > 1 ? "[i]" : ""%>.checked = false;
  	}
  }

	

	function exportLogs(logName){
		document.access.target = "";
		document.access.action = "exportLogsAction.jsp";
		document.access.submit();
	}

	function openLogViewSelction(logName){
		var newWindow = window.open("../empty.html","LogSelected","height=600,width=800,resizable=yes,scrollbars=yes,status=yes,left=300,top=200");
		document.access.target = "LogSelected";
		document.access.logName.value = logName;				
		document.access.action = "logSelectionAction.jsp";
		document.access.submit();
	  newWindow.focus();	  
	}	
	

		
</script>

<table border="0" width="100%" cellspacing="0" height="100%"
	cellpadding="0">
	<tr>
		<td width="100%">
		<table border="0" width="100%" cellspacing="0" height="100%"
			cellpadding="0">
			<tr>
				<td>
				<table border="0" cellpadding="0" cellspacing="0"
					style="border-collapse: collapse" width="100%" id="AutoNumber1">
					<tr>
						<td width="100%">
						<table border="0" cellpadding="0" cellspacing="0"
							style="border-collapse: collapse" width="100%" id="AutoNumber2">
							<tr>
								<td width="15%" height="28" colspan="3"><span
									class="HEADER">Logs Information</span></td>
							</tr>
							<tr>
								<td>&nbsp;</td>
							</tr>
							<tr>
								<td><a class="LINK" href="javascript:exportLogs()">export
								logs</a>&nbsp;</td>
							</tr>
							<tr>
								<td>&nbsp;</td>
							</tr>
							<tr>
								<td width="15%" height="28" colspan="3"><span
									class="REGULARTEXT"><b>Time limits</b></span></td>
							</tr>

							<tr>
								<td><%@ include file="quickDateFilter.jsp"%></td>
							</tr>
							<tr>
								<td>&nbsp;</td>
							</tr>
							<tr>
								<td>
								<table border="0" cellpadding="0" cellspacing="0"
									style="border-collapse: collapse" width="100%">
									<tr class="TABLES_HEADERS">
										<td width="15%"><span class="REGULARTEXT"><b>Name</b></span></td>
										<td width="15%"><span class="REGULARTEXT"><b>Size</b></span></td>
										<td width="15%"><span class="REGULARTEXT"><b>Last
										Update</b></span></td>
										<td width="15%"><span class="REGULARTEXT"><b>Num
										Of Files</b></span></td>
									</tr>
									<%
										HashMap logsMap = result == null ? null : result.getLogsData();
										if (logsMap == null) {
											return;
										}
										boolean showLog = false;
										String key;
										XpologLogInfo logInfo;
										Iterator it = logsMap.keySet().iterator();
										while (it.hasNext()) {
											key = (String) it.next();
											logInfo = (XpologLogInfo) logsMap.get(key);

											//if is war stat and this is servletContainer log, don't show it.
											showLog = (Configuration.isWar() && key.equals("ServletContainer")) ? false : true;
											
											boolean isHidden = !showResourceLogs && (key.equals("XpoLogMemory") || key.equals("localhostCpu") ||key.equals("localhostMemory") || key.equals("localhostDiskSpace"));
									%>
									<tr <%=isHidden ? "style=\"display:none\"" : ""%>>
										<%
										if (showLog) {
										%>
										<td width="15%"><span class="REGULARTEXT"><input
											type=CHECKBOX checked=true name="supportLogsCheckBoxList"
											value="<%=key%>"><a
											href="javascript:openLogViewSelction('<%=key%>')"
											class="LINK"> <%=key%></a></span></td>
										<td width="15%"><span class="REGULARTEXT"><%=SupportHelper.convertSize(logInfo.getSize())%></span></td>
										<%
													String lastUpdate = "";
													String color = "";
													long logLastUpdate = logInfo.getLastUpdated();
													if(logLastUpdate  > 0){
													Date date = new Date();
													long timeDifference = date.getTime() - logLastUpdate;
													color = (ONE_HOUR_UNIT > timeDifference) ? "RED" : "";
													lastUpdate = dateFormat.format(new Date(logLastUpdate));
													}else{
														lastUpdate = "";
													}
										%>
										<td width="15%"><span class="REGULARTEXT"><font
											color="<%=color%>"><%=lastUpdate%></font></span></td>
										<td width="15%" algin="center"><span class="REGULARTEXT"><%=logInfo.getNumOfLogFiles()%></span></td>
									</tr>

									<%
										}
										}//end if && logsArr loop
									%>
								</table>
								</td>
							</tr>
							<tr>
								<td>&nbsp;</td>
							</tr>
							<tr>
								<td>
								<table border="0" cellpadding="0" cellspacing="0">
									<tr>
										<td><a href="javascript:selectAllLogs()"
											class="SMALLLINK">select all</a></td>
										<td width="10">&nbsp;</td>
										<td><a href="javascript:clearAllLogs()" class="SMALLLINK">clear
										all</a></td>
									</tr>
								</table>
								</td>
							</tr>

						</table>
						</td>
					</tr>

				</table>
				</td>
			</tr>

		</table>
		</td>
	</tr>

</table>
