<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>


<%@ include file="../tools/sandf/dateFilterAction.jsp"%>

<%!
	static final String BASE_DIRECTORY = "../";
	static final String DELIMITER = ",";
	static final String CONF_DIRECTORY = Configuration.XPOLOG_ROOT_PATH 	+ "conf/systemlogs/";
	static final String OP_DIRECT ="LAST";
	static final String CALLS ="-1";
%>
<%
			RecordMask mask = new RecordMask();
			DateMask dateMask = new DateMask("MM/dd/yyyy HH:mm:ss");
			MaskColumn[] cols = {dateMask};
			mask.setColumns(cols);
			boolean filterSelected = (request.getParameter("Dates") != null) ? true : false;
			FilterCollection fc = null;
			if(filterSelected){
			//create the date and number filter
			DateFilter dfilter = createDateFilter(request,response,mask);
		 	if(fc == null) {
	  		fc = new FilterCollection();
	  		String timeOpType = request.getParameter("TimeOpType");
	  		String opType = (timeOpType != null && timeOpType.equals("1"))? "Last" : "Previous";
	  		String timeAmount = request.getParameter("TimeText");
	  		String timeUnit = request.getParameter("TimeUnit");
	  		fc.setName(opType + "_" + timeAmount + "_" + timeUnit);
		    fc.setId(System.currentTimeMillis()+"_fc");
	  	}
	  	if(dfilter != null) {
	  		fc.addFilter(dfilter);
	  	}
			}

			if (!WebSecurityManager.getInstance().checkForPermission(request,response,
			ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,
			true)) {
		return;
	}


	ErrorModel errmodel = new ErrorModel();
	String ERROR_OBJ = "ERROR_OBJ";
	
	String logName = request.getParameter("logName");
	if (logName != null && logName.length() > 0) {

		String CURRENT_LOG = "CURRENT_LOG";
		String LOG_FULL_PATH = CONF_DIRECTORY + logName + ".xml";
		//load the log
		LogBrowsingManager lbm = SiteManagment.getInstance().getLogBrowserFromFile(new File(LOG_FULL_PATH));
		if (lbm == null) {
			errmodel.addError("Failed to load the log");
		}

		if (errmodel.getErrorCount() > 0) {
			response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
			request.getSession().setAttribute(ERROR_OBJ, errmodel);
			return;
		}
	
		lbm.setTemporary(true);			
	
		if(filterSelected){
		FilterManager fm = lbm.getFilterManager();
		if (fm != null){
			fm.addFilterCollection(fc);
		}
		}

		//	set the log on session
		request.getSession().setAttribute(CURRENT_LOG, lbm);

		response.sendRedirect(BASE_DIRECTORY + "loggers/logview.jsp?gotoMain=true&firstTime=true&opdirect=" + OP_DIRECT + "&calls=" + CALLS);

	} else
		errmodel.addError("Log name error");
%>
