<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.support.*"%>
<%@ page import="xpolog.eye.support.handlers.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.support.basic.*"%>
<%@ page import="xpolog.support.index.*"%>
<%@ page import="java.util.Date.*"%>
<%@ page import="java.text.DateFormat"%>
<%@ page import="xpolog.eye.support.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.data.index.adapters.defaultadapter.DefaultIndexingHelper"%>

<%!static final String BASE_DIRECTORY = "../";

%>
<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,null,true)){
		return;
	}

	SiteManagment smng = SiteManagment.getInstance();
 
	HashSet lbmsIds = new HashSet();
	HashMap queryData = new HashMap();
	queryData.put(IndexInfoHandler.LBMS_TO_CHECK_ATT,lbmsIds);
	
	IndexStatusResultData result = null;
	IndexStatusQuery query = new IndexStatusQuery();
	SupportManager mgr = SupportManager.getInstance();
	SupportQueryHandler handler = mgr.getSupportHandlerByQuery(query);
	if (handler != null){
		handler.process(query);
		result = (IndexStatusResultData)handler.getQueryResult().getData();		
	}
	
	HashMap logsIndxInfoMap = result.getIndexInfoMap();
	if(logsIndxInfoMap == null){
		return;
	}
	LogIndexInfo logIndxInfo = null;
	List indexedLogsArr = new ArrayList(); 
	List notIndexedLogsArr = new ArrayList();
	String key;
	Iterator it = logsIndxInfoMap.keySet().iterator();
	while(it.hasNext()){
		key = (String)it.next();
		logIndxInfo = (LogIndexInfo)logsIndxInfoMap.get(key);
		Module parentMod = smng.getParentModule(logIndxInfo.getLogId());
		String parentName = (parentMod != null) ? parentMod.getName() : "NA";
		logIndxInfo.setParentName(parentName);
		if(logIndxInfo.isIndexed() || logIndxInfo.isInProgress()){
			indexedLogsArr.add(logIndxInfo);

		}else{
			notIndexedLogsArr.add(logIndxInfo);
		}
	}
	Comparator comparator = new Comparator(){
		public int compare(Object o1, Object o2){
			if (o1 == null){
				return -1;
			}else if (o2== null){
				return 1;
			}else{
				LogIndexInfo ln1 = (LogIndexInfo)o1;
				LogIndexInfo ln2 = (LogIndexInfo)o2;
				return ln1.getLogId().compareTo(ln2.getLogId());
			}
		}
	};
	Collections.sort(indexedLogsArr, comparator);
	Collections.sort(notIndexedLogsArr, comparator);

%>
<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";

	function removeAllSelectedLogsInexes(){
		var newWindow = window.open("../empty.html","VerificationPage","height=400,width=600,resizable=yes,scrollbars=yes,status=yes,left=300,top=200");		
		document.access.target = "VerificationPage";
		document.access.action = "verificationPage.jsp";
		document.access.submit();
	}
	function showHideUnIndexed(){
		show = document.getElementById("unindexed").style.display == "";
		if(show){
			document.getElementById("unindexed").style.display  = "none";
		}else{
			document.getElementById("unindexed").style.display = "";
		}
	
	}
	<%if (indexedLogsArr != null){%>
  function selectAllIndexed(){
  	for (var i=0; i<<%=indexedLogsArr.size()%>; i++){
  		document.access.indexedLogsList<%=indexedLogsArr.size() > 1 ? "[i]" : ""%>.checked = true;
  	}
  }
  
  function clearAllIndexed(){
  	for (var i=0; i<<%=indexedLogsArr.size() %>; i++){
  		document.access.indexedLogsList<%=indexedLogsArr.size() > 1 ? "[i]" : ""%>.checked = false;
  	}
  }
  <%}%>
</script>

<table border="0" width="100%" cellspacing="0" height="100%"
	cellpadding="0">
	<tr>
		<td width="100%">
		<table border="0" width="100%" cellspacing="0" height="100%"
			cellpadding="0">
			<tr>
				<td>
				<table border="0" cellpadding="0" cellspacing="0"
					style="border-collapse: collapse" width="100%" id="AutoNumber1">
					<tr>
						<td width="100%">
						<table border="0" cellpadding="0" cellspacing="0"
							style="border-collapse: collapse" width="100%" id="AutoNumber2">
							<tr>
								<td width="15%" height="28" colspan="3"><span
									class="HEADER">Search Engine Information</span></td>
							</tr>
							<tr>
								<td>&nbsp;</td>
							</tr>
							<tr>
								<td><a class="LINK"
									href="javascript:removeAllSelectedLogsInexes()">remove all
								selected indexes</a>&nbsp;</td>
							</tr>
							<tr>
								<td>&nbsp;</td>
							</tr>
							<tr>
								<td><span class="REGULARTEXT"><b>Indexed/In
								Progress Logs</b></span></td>
							</tr>
							<tr>
								<td>
								<table border="0" cellpadding="0" cellspacing="0"
									style="border-collapse: collapse" width="100%">
									<tr class="TABLES_HEADERS">
										<td width="15%"><span class="REGULARTEXT"><b>Name</b></span></td>
										<td width="15%"><span class="REGULARTEXT"><b>Parent
										Folder</b></span></td>
										<td width="15%"><span class="REGULARTEXT"><b>Use
										Index</b></span></td>
										<td width="15%"><span class="REGULARTEXT"><b>Index
										Size</b></span></td>
										<td width="15%"><span class="REGULARTEXT"><b>Status</b></span></td>
										<td width="15%"><span class="REGULARTEXT"><b>Last
										Update</b></span></td>
									</tr>
									<%
										LogIndexInfo indxInfo = null;
										for(int i=0 ; i < indexedLogsArr.size() ; i++){
											indxInfo = (LogIndexInfo)indexedLogsArr.get(i);
									%>
									<tr>
										<td width="15%"><span class="REGULARTEXT"><input
											type=CHECKBOX checked=true name="indexedLogsList"
											value="<%=indxInfo.getLogId()%>"><%=indxInfo.getLogName() %></span></td>
										<td width="15%"><span class="REGULARTEXT"><%=indxInfo.getParentName()%></span></td>
										<td width="15%"><span class="REGULARTEXT"><%=indxInfo.isUsingIndex()%></span></td>
										<td width="15%"><span class="REGULARTEXT"><%=SupportHelper.convertSize(indxInfo.getIndexSize())%></span></td>
										<td width="15%"><span class="REGULARTEXT"><%=indxInfo.getStatus() %></span></td>
										<%										
										String lastUpdate = (indxInfo.getLastIndexed() == -1) ? "NA" :DateFormat.getDateTimeInstance(DateFormat.SHORT,DateFormat.SHORT).format(new Date(indxInfo.getLastIndexed())); %>
										<td width="15%"><span class="REGULARTEXT"><%=lastUpdate %></span></td>
									</tr>

									<%
									}//end of for loop
									%>
								</table>
								</td>
							</tr>
							<tr>
								<td>
								<table border="0" cellpadding="0" cellspacing="0">
									<tr>
										<td><a href="javascript:selectAllIndexed()"
											class="SMALLLINK">select all</a></td>
										<td width="10">&nbsp;</td>
										<td><a href="javascript:clearAllIndexed()"
											class="SMALLLINK">clear all</a></td>
									</tr>
								</table>
								</td>
							</tr>

							<tr>
								<td>&nbsp;</td>
							</tr>
							<tr>
								<td align="left" colspan="2"><a
									href="javascript:showHideUnIndexed()" class="LINK">show /
								hide unindexed logs</a></td>
							</tr>
							<tr>
								<td>&nbsp;</td>
							</tr>

							<tr>
								<td>

								<div id="unindexed" style="display:none">

								<table border="0" cellpadding="2" cellspacing="0"
									style="border-collapse: collapse" width="100%">

									<tr class="TABLES_HEADERS">
										<td width="15%"><span class="REGULARTEXT"><b>Name</b></span></td>
										<td width="15%"><span class="REGULARTEXT"><b>Parent
										Folder</b></span></td>
										<td width="15%"><span class="REGULARTEXT"><b>Use
										Index</b></span></td>
										<td width="15%"><span class="REGULARTEXT"><b>Index
										Size</b></span></td>
										<td width="15%"><span class="REGULARTEXT"><b>Status</b></span></td>
										<td width="15%"><span class="REGULARTEXT"><b>Last
										Update</b></span></td>
									</tr>
									<%
										indxInfo = null;
										for(int j=0 ; j < notIndexedLogsArr.size() ; j++){
											indxInfo = (LogIndexInfo)notIndexedLogsArr.get(j);
									%>
									<tr>
										<td width="15%"><span class="REGULARTEXT"><%=indxInfo.getLogName() %></span></td>
										<td width="15%"><span class="REGULARTEXT"><%=indxInfo.getParentName()%></span></td>
										<td width="15%"><span class="REGULARTEXT"><%=indxInfo.isUsingIndex()%></span></td>
										<td width="15%"><span class="REGULARTEXT"><%=SupportHelper.convertSize(indxInfo.getIndexSize())%></span></td>
										<td width="15%"><span class="REGULARTEXT"><%=indxInfo.getStatus() %></span></td>
										<%										
										String lastUpdate = (indxInfo.getLastIndexed() == -1) ? "NA" :DateFormat.getDateTimeInstance(DateFormat.SHORT,DateFormat.SHORT).format(new Date(indxInfo.getLastIndexed())); %>
										<td width="15%"><span class="REGULARTEXT"><%=lastUpdate %></span></td>
									</tr>

									<%
									}//end of for loop
									%>

								</table>
								</div>
								</td>
							</tr>
						</table>
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
</table>
