<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.cloud.*"%>
<%@ page import="xpolog.support.*"%>

<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../";

%>

<%
	String ERROR_OBJ = "ERROR_OBJ";

	String xplgNodeId = request.getParameter("xplgNodeId");
	String xplgNodes[] = request.getParameterValues("xplgNode");
	ErrorModel errmodel = new ErrorModel(); 
	if (xplgNodes == null){
		if (xplgNodeId != null && xplgNodeId.length() > 0){
			xplgNodes = new String[]{xplgNodeId};
		}else{
			errmodel.addError("No Xplg Entereprise Nodes queries were selected");
	    request.getSession().setAttribute(ERROR_OBJ,errmodel);
	    response.sendRedirect(BASE_DIRECTORY+"common/errorpage.jsp?closeWindow=true");
	    return;
		}
	}
	String queryKey = request.getParameter("queryKey");
	SupportQueryExecuter queryExec = (SupportQueryExecuter)request.getSession().getAttribute("SupportQueryExecuter");;
	if (queryExec == null){
		errmodel.addError("No support query executer found");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY+"common/errorpage.jsp?closeWindow=true");
    return;
	}
	HashMap results = queryExec.getResults();
	
	SupportManager supportMgr = SupportManager.getInstance();
	SupportQueryHandlerGroup root = supportMgr.getRootHandler();

	SiteManagment mgmt = SiteManagment.getInstance();
  CloudMgr cmgr = mgmt.getCloudMgr();
  XplgNode xplgNode = null;
  MultiSupportResult multiResult = null;
%>
<%@page import="xpolog.eye.support.SupportQueryExecuter"%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script  src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script>
	function exportToXml(){
	  document.location = "exportSupportStatusAction.jsp<%=xplgNodeId != null ? "?xplgNodeId="+xplgNodeId+(queryKey != null ? "&queryKey="+queryKey : "") : ""%>";
	}
</script>

</head>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" METHOD="POST" ACTION="xplgNodesStatusReport.jsp">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
              <tr>
                <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="53%" class="TOPBORDER" height="0">
                <span class="PAGEHEADER">Support Report</span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;</td>
                <td width="43%" height="100%">&nbsp;</td>
                <td width="50%" height="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Support Query result for <%=(xplgNode != null ? "Xplg Enterprise Node " + xplgNode.getName() : " all nodes")%></span></td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                  	<td>
                  		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
			                  <%
			                	for (int i=0; i<xplgNodes.length; i++){
			                		String nodeId = xplgNodes[i];
			                		if (xplgNodeId == null || (xplgNodeId.length() > 0 && xplgNodeId.equals(nodeId))){
				                		xplgNode = cmgr.getNodeById(nodeId);
				                		%>
					                  <tr>
					                  	<td><span class="REGULARTEXT"><b><%=xplgNode.getName()%></b></td>
					                  </tr>
					                  <%
				                		multiResult = (MultiSupportResult)results.get(nodeId);
					                  SupportResult[] rs = multiResult.getAllResults();
					                  SupportResult result = null;
					                  for (int j=0; j<rs.length; j++){
					                  	result = rs[j];
					                  	if (queryKey == null || result.getKey().equals(queryKey)){
					                  		String queryName = result.getQueryName() != null ? result.getQueryName() : result.getKey();
					                  %>
					                  <tr>
					                  	<td><span class="REGULARTEXT"><b><%=queryName%></b></td>
					                  </tr>
					                  <tr>
					                  	<td><span class="REGULARTEXT"><%=result.toHtml()%></td>
					                  </tr>
					                  <tr><td>&nbsp;</td></tr>
					                  <%}
				                		}
				                	}
				                }%>
                  		</table>
                  	</td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="30%">&nbsp;</td>
            <td width="31%" align="center">
              <table border="0" width="109%">
                <tr>
                  <td width="24%"></td>
                  <td width="40%"><a href="javascript:exportToXml()" class="LINK">export</a></td>
                  <td width="46%"><a href="javascript:window.close()" class="LINK">close</a></td>
                </tr>
              </table>
            </td>
            <td width="39%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
<iframe name="nodeAddFrame" style="visibility:hidden" width="0" height="0"></iframe>
</body>

</html>