<%@ page language="java"%>

<%@ page import="xpolog.eye.media.telsh.TelnetAccountPolicy"%>
<%@ page import="xpolog.eye.media.telsh.TelShMediaPool"%>
<%@ page import="xpolog.eye.media.telsh.TelShMediaPoolManager"%>
<%@ page import="xpolog.eye.security.*"%>

<%@ page import="java.util.*"%>

<%!static final String BASE_DIRECTORY = "../";%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, null, true)) {
		return;
	}
	
	String errorMsg = "";
	TelShMediaPoolManager telShMediaPoolManager = TelShMediaPoolManager.getInstance();
	if(telShMediaPoolManager.getNumberOfPools() == 0){
		errorMsg = "No pooled SSH connections are currently open";
	}
%>

<script>

	function destroyPool(poolAccountId, poolAccountName, tabNum) {
		if(confirm("Are you sure you want to terminate the pool " + poolAccountName + "? This will close all open connections!")) {
			document.access.selectedTabId.value = tabNum;
			document.access.poolAccountId.value = poolAccountId;
			document.access.action = "destroySshPool.jsp";
			document.access.target = "";
			document.access.submit();
		}
	}

</script>

<input type="hidden" id="poolAccountId" name="poolAccountId">

<table border="0" width="100%" cellspacing="defaultroot/logeye/groups""0" height="100%"	cellpadding="0">
	<tr>
		<td>
				<table border="0" width="100%" cellspacing="0" height="100%"	cellpadding="0">
					<tr>
						<td width="100%">
						<table border="0" cellpadding="0" cellspacing="0"	width="100%" id="AutoNumber2">
							<tr>
								<td width="15%" height="28" colspan="3"><span	class="HEADER">SSH Connections Status</span></td>
							</tr>	
						</table>	
						</td>
					</tr>
				</table>	
		</td>
	</tr>
<%
if(errorMsg.length() > 0){
%>
	<tr>
			<td width="100%">
				<table border="0" cellpadding="0" cellspacing="0"	width="100%" id="AutoNumber2">
					<tr>
						<td width="15%" height="28" colspan="3"><span	class="REGULARTEXT"><%=errorMsg %></span></td>
					</tr>	
				</table>	
			</td>
	</tr>
<%
}else{
%>
	<tr>
		<td>&nbsp;</td>
	</tr>
	<tr>
		<td>
			<table border="0" cellpadding="0" cellspacing="0"	width="100%">
				<tr class="TABLES_HEADERS">
					<td width="20px">&nbsp;</td>
					<td width="150px"><span class="REGULARTEXT"><b>Account name</b></span></td>
					<td width="20px">&nbsp;</td>
					<td width="180px"><span class="REGULARTEXT"><b>Allowed connections</b></span></td>
					<td width="20px">&nbsp;</td>
					<td width="150px"><span class="REGULARTEXT"><b>Open connections</b></span></td>
					<td width="20px">&nbsp;</td>
					<td width="170px"><span class="REGULARTEXT"><b>Obsolete connections</b></span></td>
					<td width="20px">&nbsp;</td>
					<td width="315px"><span class="REGULARTEXT"><b>Allowed sesseions per connection</b></span></td>
					<td width="20px">&nbsp;</td>
					<td width="120px"><span class="REGULARTEXT"><b>Open sessions</b></span></td>
					<td width="20px">&nbsp;</td>
					<td width="90px"><span class="REGULARTEXT"><b>Consumers</b></span></td>
					<td width="*">&nbsp;</td>
				</tr>
<%
	HashMap mediaPools = telShMediaPoolManager.getMediaPools();
	List mediaPoolsList = new ArrayList();
	mediaPoolsList.addAll(mediaPools.values());
	Collections.sort(mediaPoolsList, new Comparator() {
		public int compare(Object o1, Object o2) {
			if(o1 == null || o2 == null) {
				return 0;
			}
			TelShMediaPool p1 = (TelShMediaPool)o1;
			TelShMediaPool p2 = (TelShMediaPool)o2;
			return p1.getAccount().getAccountName().toLowerCase().compareTo(p2.getAccount().getAccountName().toLowerCase());
		}
	});
	
	TelShMediaPool mediaPool = null;
	String accountName;
	TelnetAccountPolicy accountPolicy = null;
	for(int i = 0; i < mediaPoolsList.size(); i++) {
		mediaPool = (TelShMediaPool)mediaPoolsList.get(i);
		
		accountName = mediaPool.getAccount().getAccountName();
		accountPolicy = (TelnetAccountPolicy)mediaPool.getAccount().getAccountPolicy();
%>
				<tr>
					<td></td>
					<td><span class="REGULARTEXT"><%=accountName %></span></td>
					<td></td>
					<td><span class="REGULARTEXT"><%=accountPolicy.getMaxConnections() == -1 ? "Unlimited" : accountPolicy.getMaxConnections()+"" %></span></td>
					<td></td>
					<td><span class="REGULARTEXT"><%=mediaPool.getNumberOfProxyMedias() %></span></td>
					<td></td>
					<td><span class="REGULARTEXT"><%=mediaPool.getNumberOfOldProxyMedias() %></span></td>
					<td></td>
					<td><span class="REGULARTEXT"><%=accountPolicy.getMaxSessionsPerConnection() %></span></td>
					<td></td>
					<td><span class="REGULARTEXT"><%=mediaPool.getNumberOfSessions() %></span></td>
					<td></td>
					<td><span class="REGULARTEXT"><%=mediaPool.getNumberOfClientMedias() %></span></td>
					<td style="padding-right:20"><a href="javascript:destroyPool('<%=mediaPool.getAccount().getId() %>', '<%=mediaPool.getAccount().getAccountName() %>', applicationTabs.selectedTabIndex)" class="SMALLLINK">Terminate</a></td>
				</tr>
<%
	}
%>
			</table>
		</td>
	</tr>
<%
}
%>
</table>	
