<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%!static final String BASE_DIRECTORY = "../";%>
<%
	String ERROR_OBJ = "ERROR_OBJ";

	TelnetAccountFilter filter = new TelnetAccountFilter();
	AddressBook adbook = AddressBook.getInstance();
	List list = adbook.getAccountsByFilter(filter);
	if (list.size() == 0) {
		//No accounts defined in system
		ErrorModel errmodel = new ErrorModel();
		errmodel
				.addError("There is no SSH account defined, Please <a href=\""
				+ BASE_DIRECTORY
				+ "tools/addresses/ssh/accountSsh.jsp\">create SSH account</a> first.");
		request.getSession().setAttribute(ERROR_OBJ, errmodel);
		response.sendRedirect("../errorpage.jsp");
		return;
	}

	String accountId = request.getParameter("accountId");
	if (accountId == null) {
		accountId = "";
	}

	String sshCommand = request.getParameter("sshCommand");
	if (sshCommand == null) {
		sshCommand = "";
	}
	
	StringBuffer information = new StringBuffer();
	boolean doCommand = (request.getParameter("command") != null && ((String)request.getParameter("command")).compareTo("true") == 0);
	if (doCommand) {
		System.out.println("Executing command");
		final UserEnvironment env = UserEnvironment.getUserEnvironment(request);
		
		//verify data
		ErrorModel errmodel = new ErrorModel();

		//error handling
		if (accountId == null || accountId.trim().equals("")) {
			errmodel.addError("Ssh account was not supplied.");
		}

		if (errmodel.getErrorCount() > 0) {
			env.setTempAttribute(SiteConstants.ERROR_OBJ_ATTRIBUTE,
			errmodel);
			response.sendRedirect(SiteConstants.COMMON_ERROR_URL);
			return;
		}

		//		create temp ftp account
		final TelnetAccount account = (TelnetAccount)AddressBook.getInstance().getAccountById(accountId);
		//media
		MediaManager medm = MediaManager.newInstace();
		final TelShManager media = (TelShManager)medm.getMediaByAccount(account);
		System.out.println("Connecting");
		boolean isConnected = media.connect(account);
		System.out.println("Connected");
		if(isConnected) {
			System.out.println("Getting session");
			TelShSession telShSession = media.getSession();
			System.out.println("Got session");
			OutputStream output = null;
			output = telShSession.getOutputStream();
			BufferedReader reader = new BufferedReader(new InputStreamReader(telShSession.getInputStream()));
			String currentLine = "";
			
			if(media.requestPseudoTerminal(telShSession, "dumb", 5000, 100)) {
				if(media.startShell(telShSession)) {
					String command = (sshCommand.compareTo("") == 0 ? "set" : sshCommand);
					System.out.println("Writing command " + command);
					output.write((command + " ; echo endSshInformation").getBytes());
					output.flush();
					System.out.println("Reading input");
					currentLine = reader.readLine();
					while(currentLine != null && currentLine.compareTo("endSshInformation") != 0) {
						System.out.println(currentLine);
						information.append(currentLine);
						information.append("\n");
						currentLine = reader.readLine();
					}
					System.out.println("Finished reading");
					System.out.println(information.toString());
				}
			}
		}


	}
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
      function doTest(){
        document.access.action="sshInformation.jsp";
        document.access.command.value="true";
    	document.access.submit();
      }
      
      function goNew(){
		path = "<%=BASE_DIRECTORY%>tools/addresses/accoutAction.jsp?ACCOUNT_TYPE=ssh";
  		document.location = path;
  	  }

</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<input type="hidden" name="command" value="">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="33%" class="TOPBORDER">
                <span class="PAGEHEADER">SSH Information</span> </td>
                <td width="44%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%" >&nbsp;</td>
                <td colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">SSH details</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">SSH Account</span></td>
                        <td width="69%">
                        
                        <select class="TEXTBOX" size="1" name="accountId">
                        <option value="">--- Select ssh account ---</option>
                        <%
                        		for (int i = 0; i < list.size(); ++i) {
                        		Account acc = (Account)list.get(i);
                        %>
                        <option value="<%=acc.getId()%>" <%if(acc.getId().compareTo(accountId) == 0) {%>selected<%}%>><%=acc.getAccountName()%></option>
                        <%
                        }
                        %>
                        </select>&nbsp; <a href="javascript:goNew()" class="LINK">new</a>
                        
                        
                        </td>
                      </tr>
                      <tr>
                        <td width="11%" valign="top"><span class="REGULARTEXT">Command</span></td>
                        <td width="69%">
                        <input class="TEXTBOX" type="text" name="sshCommand" size="50" value="<%=sshCommand%>"></td>
                      </tr>
                      <tr>
                        <td width="11%"></td>
                        <td width="69%">
                        </td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td width="15%" height="21">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td><font size="2">&nbsp;&nbsp;</font></td>
                  </tr>
                  <tr>
                    <td>
                    <font size="2">&nbsp; </font>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    &nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="101%" id="AutoNumber17">
                      <tr>
                        <td width="25%">&nbsp;</td>
                        <td width="13%">
                        <p align="center">&nbsp;</td>
                        <td width="11%"><a href="javascript:history.go(-1)" class="LINK">previous</a></td>
                        <td width="11%"><a href="javascript:doTest()" class="LINK">test</a></td>
                        <td width="35%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>