<%@ page language="java"%>


<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.managment.XpologManagment"%>
<%@ page import="xpolog.eye.support.*"%>
<%@ page import="xpolog.eye.support.handlers.*"%>
<%@ page import="xpolog.eye.util.Constants"%>
<%@ page import="xpolog.support.*"%>
<%@ page import="xpolog.support.basic.*"%>
<%@ page import="xpolog.support.computation.ComputationInfo"%>
<%@ page import="xpolog.support.computation.ComputationResultData"%>

<%@ page import="java.util.*"%>
<%@ page import="java.util.Date.*"%>
<%@ page import="java.text.DateFormat"%>
<%@ page import="java.text.SimpleDateFormat"%>

<%!static final String BASE_DIRECTORY = "../";%>

<%
	long ONE_HOUR_UNIT = 1000 * 60 * 60 * 1;
	HashMap queryData = new HashMap();

	ComputationResultData result = null;
	SupportQuery supportQuery = new SupportQuery("computation", queryData);
	SupportManager mgr = SupportManager.getInstance();
	SupportQueryHandler handler = mgr.getSupportHandlerByQuery(supportQuery);
	if (handler != null) {
		handler.process(supportQuery);
		result = (ComputationResultData)handler.getQueryResult().getData();
	}

	SimpleDateFormat dateFormat = new SimpleDateFormat(Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat", "MM/dd/yyyy HH:mm:ss"));
	String[] logsArr = null;
	if (result != null){
		logsArr = result.getLogIds();
	}
	if (logsArr == null){
		logsArr = new String[0];
	}
	int numOfLogs = logsArr.length;
	
	String[] hosts = null;
	if (result != null){
		hosts = result.getHosts();
	}
	if (hosts == null){
		hosts = new String[0];
	}

	String analytics = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_DISPLAY_NAME);
	String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);

%>

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";

	function removeAllSelectedDashboardLogs(){
		var newWindow = window.open("../empty.html","VerificationComputationPage","height=400,width=600,resizable=yes,scrollbars=yes,status=yes,left=300,top=200");		
		document.access.target = "VerificationComputationPage";
		document.access.computationType.value = "logs";
		document.access.action = "verificationComputationPage.jsp";
		document.access.submit();
	}
	
	<%if (logsArr != null){%>
  function selectAllComputationLogs(){
  	for (var i=0; i<<%=logsArr.length%>; i++){
  		document.access.computationLogsList<%=logsArr.length > 1 ? "[i]" : ""%>.checked = true;
  	}
  }
  
  function clearAllComputationLogs(){
  	for (var i=0; i<<%=logsArr.length %>; i++){
  		document.access.computationLogsList<%=logsArr.length > 1 ? "[i]" : ""%>.checked = false;
  	}
  }
  
 
	
	<%}%>
	
	function removeAllSelectedDashboardHosts(){
		var newWindow = window.open("../empty.html","VerificationComputationPage","height=400,width=600,resizable=yes,scrollbars=yes,status=yes,left=300,top=200");		
		document.access.target = "VerificationComputationPage";
		document.access.computationType.value = "hosts";
		document.access.action = "verificationComputationPage.jsp";
		document.access.submit();
	}
	<%
	if (hosts != null){%>
	
	 
	
  function selectAllComputationHosts(){
  	for (var i=0; i<<%=hosts.length%>; i++){
  		document.access.computationHostsList<%=hosts.length > 1 ? "[i]" : ""%>.checked = true;
  	}
  }
  
  function clearAllComputationHosts(){
  	for (var i=0; i<<%=hosts.length %>; i++){
  		document.access.computationHostsList<%=hosts.length > 1 ? "[i]" : ""%>.checked = false;
  	}
  }
  <%}%>

</script>

<table border="0" width="100%" cellspacing="0" height="100%"
	cellpadding="0">
	<tr>
		<td width="100%">
		<table border="0" width="100%" cellspacing="0" height="100%"
			cellpadding="0">
			<tr>
				<td>
				<table border="0" cellpadding="0" cellspacing="0"
					style="border-collapse: collapse" width="100%" id="AutoNumber1">
					<tr>
						<td width="100%">
						<table border="0" cellpadding="0" cellspacing="0"
							style="border-collapse: collapse" width="100%" id="AutoNumber2">
							<tr>
								<td width="15%" height="28" colspan="3"><span
									class="HEADER"><%=analyticsH %> Logs Information</span></td>
							</tr>
							<tr>
								<td><a class="LINK"
									href="javascript:removeAllSelectedDashboardLogs()">remove all
								selected <%=analytics %> logs</a>&nbsp;</td>
							</tr>
							<tr>
								<td>
								<table border="0" cellpadding="0" cellspacing="0"
									style="border-collapse: collapse" width="100%">
									<tr class="TABLES_HEADERS">
										<td width="15%"><span class="REGULARTEXT"><b>Name</b></span></td>
										<td width="15%"><span class="REGULARTEXT"><b>Parent Folder</b></span></td>
										<td width="15%"><span class="REGULARTEXT"><b>Min Computation Date</b></span></td>
										<td width="15%"><span class="REGULARTEXT"><b>Max Computation Date</b></span></td>
									</tr>
									<%
										HashMap logsMap = result == null ? null : result.getLogsData();
										if (logsMap != null) {
											boolean showLog = false;
											String key = null;
											ComputationInfo computationInfo;
											Iterator it = logsMap.keySet().iterator();
											for (int i=0; i<logsArr.length; i++) {
												key = logsArr[i];
												computationInfo = (ComputationInfo)logsMap.get(key);
									%>
									<tr>
										<td><span class="REGULARTEXT"><input
											type=CHECKBOX checked=true name="computationLogsList"
											value="<%=computationInfo.getLogId()%>"><%=computationInfo.getLogName()%></span></td>
										<%
													String minComputationDate = "";
													String maxComputationDate = "";
													String color = "";
													long logMinComputationDate = computationInfo.getMinComputationDate();
													if(logMinComputationDate > 0){
														Date date = new Date();
														long timeDifference = date.getTime() - logMinComputationDate;
														//color = (ONE_HOUR_UNIT > timeDifference) ? "RED" : "";
														minComputationDate = dateFormat.format(new Date(logMinComputationDate));
													}else{
														minComputationDate = "N/A";
													}
													
													long logMaxComputationDate = computationInfo.getMaxComputationDate();
													if(logMaxComputationDate > 0){
														Date date = new Date();
														long timeDifference = date.getTime() - logMaxComputationDate;
														//color = (ONE_HOUR_UNIT > timeDifference) ? "RED" : "";
														maxComputationDate = dateFormat.format(new Date(logMaxComputationDate));
													}else{
														maxComputationDate = "N/A";
													}
										%>
										<td><span class="REGULARTEXT"><%=computationInfo.getModuleName()%></span></td>
										<td><span class="REGULARTEXT"><font color="<%=color%>"><%=minComputationDate%></font></span></td>
										<td><span class="REGULARTEXT"><font color="<%=color%>"><%=maxComputationDate%></font></span></td>
									</tr>

									<%
											}}//end if && logsArr loop
											%>										
																		</table>
								</td>
							</tr>
							
							<tr>
								<td>
								<table border="0" cellpadding="0" cellspacing="0">
									<tr>
										<td><a href="javascript:selectAllComputationLogs()"
											class="SMALLLINK">select all <%=analytics %> logs</a></td>
										<td width="10">&nbsp;</td>
										<td><a href="javascript:clearAllComputationLogs()"
											class="SMALLLINK">clear all <%=analytics %> logs</a></td>
									</tr>
								</table>
								</td>
							</tr>
							
							<tr>
								<td>&nbsp;</td>
							</tr>	
							<tr>
								<td width="15%" height="28" colspan="3"><span
									class="HEADER"><%=analyticsH %> Hosts Information</span></td>
							</tr>
							<tr>
								<td><a class="LINK"
									href="javascript:removeAllSelectedDashboardHosts()">remove all
								selected <%=analytics %> hosts</a>&nbsp;</td>
							</tr>						
							<tr>
								<td>
								<table border="0" cellpadding="0" cellspacing="0"
									style="border-collapse: collapse" width="100%">
									<tr class="TABLES_HEADERS">
										<td width="30%"><span class="REGULARTEXT"><b>Name</b></span></td>
										<td width="15%"><span class="REGULARTEXT"><b>Min Computation Date</b></span></td>
										<td width="15%"><span class="REGULARTEXT"><b>Max Computation Date</b></span></td>
									</tr>									
										<%
										HashMap hostsMap = result == null ? null : result.getHostsData();
										if (hostsMap != null) {
											String key = null;
											ComputationInfo computationInfo;
											for (int i=0; i<hosts.length; i++) {
												key = hosts[i];
												computationInfo = (ComputationInfo)hostsMap.get(key);
									%>
									<tr>
										<td><span class="REGULARTEXT"><input
											type=CHECKBOX checked=true name="computationHostsList"
											value="<%=computationInfo.getHost()%>"><%=computationInfo.getHost()%></span></td>
										<%
													String minComputationDate = "";
													String maxComputationDate = "";
													String color = "";
													long logMinComputationDate = computationInfo.getMinComputationDate();
													if(logMinComputationDate > 0){
														Date date = new Date();
														long timeDifference = date.getTime() - logMinComputationDate;
														//color = (ONE_HOUR_UNIT > timeDifference) ? "RED" : "";
														minComputationDate = dateFormat.format(new Date(logMinComputationDate));
													}else{
														minComputationDate = "N/A";
													}
													
													long logMaxComputationDate = computationInfo.getMaxComputationDate();
													if(logMaxComputationDate > 0){
														Date date = new Date();
														long timeDifference = date.getTime() - logMaxComputationDate;
														//color = (ONE_HOUR_UNIT > timeDifference) ? "RED" : "";
														maxComputationDate = dateFormat.format(new Date(logMaxComputationDate));
													}else{
														maxComputationDate = "N/A";
													}
										%>
										<td><span class="REGULARTEXT"><font color="<%=color%>"><%=minComputationDate%></font></span></td>
										<td><span class="REGULARTEXT"><font color="<%=color%>"><%=maxComputationDate%></font></span></td>
									</tr>

									<%
											}}//end if && hosts loop
											%>
																		</table>
								</td>
							</tr>
							<tr>
								<td>
								<table border="0" cellpadding="0" cellspacing="0">
									<tr>
										<td><a href="javascript:selectAllComputationHosts()"
											class="SMALLLINK">select all <%=analytics %> hosts</a></td>
										<td width="10">&nbsp;</td>
										<td><a href="javascript:clearAllComputationHosts()"
											class="SMALLLINK">clear all <%=analytics %> hosts</a></td>
									</tr>
								</table>
								</td>
							</tr>
							
							
						</table>
						</td>
					</tr>

				</table>
				</td>
			</tr>

		</table>
		</td>
	</tr>

</table>
