<%@ page language="java"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.patch.*"%>
<%@ page import="xpolog.eye.cloud.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../";

  String getTreeDiv(SupportQueryHandlerGroup root){
    ArrayList list = new ArrayList();
    StringBuffer buffer = new StringBuffer();
    
    if (root != null){
    	SupportQueryHandler[] handlers = root.getHandlers();
    	if (handlers == null || handlers.length == 0){
    		return "";
    	}
      boolean selected = false;
      String treeKey = "node" + root.getKey() + "_0";
      String chkKey = "queryGroupKey";
      buffer.append("\nvar " + treeKey + " = tree.addNode(tree.root,\"" + chkKey + "\",\"" + root.getKey() + "\",\"" + root.getName() + "\",\"\",''," + selected + ",true);");
      addChildsNodeDiv(root,buffer,treeKey);
    }
    return buffer.toString();
  }

  void addChildsNodeDiv(SupportQueryHandler node,StringBuffer buffer, String parentKey){
  	SupportQueryHandlerGroup group = null;
  	if(node instanceof SupportQueryHandlerGroup){
  			group = (SupportQueryHandlerGroup)node;
  	}else{
  		return;
  	}
  	SupportQueryHandler[] children = group.getHandlers();
    for (int i = 0; i < children.length; i++) {
      SupportQueryHandler child = children[i];
      String treeKey = parentKey + "_" + i;
      String parentNode = parentKey.equals("node") ? "tree.root" : parentKey;
      String extraText = "";
      
      boolean selected = false;
      String chkKey = "queryKey";
      if (child instanceof SupportQueryHandlerGroup){
        chkKey = "queryGroupKey";
     		SupportQueryHandlerGroup g = (SupportQueryHandlerGroup)child;
  			SupportQueryHandler[] hs = g.getHandlers();
   			if (hs == null || hs.length == 0){
   				continue;
   			}
      } 
      buffer.append("\nvar " + treeKey + " = tree.addNode(" + parentNode + ",\"" + chkKey +"\",\"" + child.getKey() + "\",\"" + child.getName() + "\",\"\",'" + extraText + "'," + selected + ",false);");
      addChildsNodeDiv(child,buffer,treeKey);
    }
  }

%>

<%
	
	SupportManager supportMgr = SupportManager.getInstance();
	SupportQueryHandlerGroup root = supportMgr.getRootHandler();
	String treeCode = getTreeDiv(root);

	SiteManagment mgmt = SiteManagment.getInstance();
  CloudMgr cmgr = mgmt.getCloudMgr();
  XplgNode[] list = cmgr.getAllXplgNodes();
  list = CloudUtil.sortArrayByName(list);
  Set set = new HashSet();
%>
<%@page import="xpolog.support.SupportQueryHandler"%>
<%@page import="xpolog.support.SupportQueryHandlerGroup"%>
<%@page import="xpolog.support.SupportManager"%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script  src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script>

  baseDirectory = "<%=BASE_DIRECTORY%>";

	function refresh(){
	  this.location = this.location;
	}

	function run(){
		document.access.submit();
	}
	
	<%if (list != null){%>
  function selectAllNodes(){
  	for (var i=0; i<<%=list.length%>; i++){
  		document.access.xplgNode<%=list.length > 1 ? "[i]" : ""%>.checked = true;
  	}
  }
  
  function clearAllNodes(){
  	for (var i=0; i<<%=list.length%>; i++){
  		document.access.xplgNode<%=list.length > 1 ? "[i]" : ""%>.checked = false;
  	}
  }
	<%}%>
	
</script>

</head>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" METHOD="POST" ACTION="xplgNodesStatusReport.jsp">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
              <tr>
                <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="53%" class="TOPBORDER" height="0">
                <span class="PAGEHEADER">Support Report</span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;</td>
                <td width="43%" height="100%">&nbsp;</td>
                <td width="50%" height="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Support Queries&nbsp;</span></td>
                  </tr>
                  <tr>
                    <td>
                    &nbsp;
                    </td>
                  </tr>
                  <tr>
                    <td width="15%">
                    <span class="REGULARTEXT">Select support queries you want to execute</span></td>
                  </tr>
                  <tr>
                    <td width="15%">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr>
                        <td class="REGULARTEXT">
	                        <script>
	                         <%=treeCode%>
	                         tree.onSelectMarkParents = false;
													 tree.onSelectMarkChilds = true;
	                         tree.writeTree();
	                        </script>
                         </td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  
				          <tr>
				            <td width="100%">
				            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
				              <tr>
				                <td colspan="3">&nbsp;</td>
				              </tr>
				              <tr>
				                <td colspan="3">&nbsp;</td>
				              </tr>
				              <tr>
				                <td colspan="3"><span class="HEADER">XpoLog Enterprise Nodes</span></td>
				              </tr>
				              <tr>
				                <td colspan="3" height="18">&nbsp;</td>
				              </tr>
				              <tr>
				                <td colspan="3"><span class="REGULARTEXT">
				                Select the XpoLog Enterprise Nodes you to get support info of
				                </span></td>
				              </tr>
				            </table>
				            </td>
				          </tr>
	                <tr>
	                	<td>
											<table border="0" cellpadding="0" cellspacing="0">
												<tr>
													<td><a href="javascript:selectAllNodes()" class="SMALLLINK">select all</a></td>
													<td width="10">&nbsp;</td>
													<td><a href="javascript:clearAllNodes()" class="SMALLLINK">clear all</a></td>
												</tr>
											</table>
	                	<td>
	                </tr>
				          <tr>
				            <td>
				            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="53">
				              <tr>
				                <td>
				                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
						              <%for(int t=0;t<list.length;t++) {
						              	  String checked = "";
						              	  if (set != null){
							              	  if (set.contains(list[t].getId())){
							              	  	checked = "checked";
							              	  }
						              	  }
						              	  String xplgName = list[t].getName();
						              %>
														<tr>
															<td><input type="checkbox" id="<%=list[t].getId()%>" name="xplgNode" value="<%=list[t].getId()%>" <%=checked%>>
															<span class="REGULARTEXT"><%=xplgName%></span>
															</td>
														</tr> 
						              <%}%>
				                </table>
				               </td>
				              </tr>
				            </table>
				            </td>
				          </tr>

                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;&nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="30%">&nbsp;</td>
            <td width="31%" align="center">
              <table border="0" width="109%">
                <tr>
                  <td width="24%"></td>
                  <td width="40%"><a href="javascript:history.go(-1)" class="LINK">cancel</a></td>
                  <td width="46%"><a href="javascript:run()" class="LINK">run</a></td>
                </tr>
              </table>
            </td>
            <td width="39%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
<iframe name="nodeAddFrame" style="visibility:hidden" width="0" height="0"></iframe>
</body>

</html>