<%@ page language="java"%>

<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.support.SupportQueryExecuter"%>
<%@ page import="xpolog.eye.cloud.XplgNode"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.cloud.CloudMgr"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.computation.conf.HealthThreshold"%>
<%@ page import="xpolog.support.*"%>

<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
	String ERROR_OBJ = "ERROR_OBJ";
	SiteManagment mgmt = SiteManagment.getInstance();
	CloudMgr cmgr = mgmt.getCloudMgr();
  
	ErrorModel errmodel = new ErrorModel(); 

	String[] queriesKeys = request.getParameterValues("queryKey");
	if (queriesKeys == null || queriesKeys.length == 0){
		errmodel.addError("No support queries were selected");
	}
	String[] xplgNodeIds = request.getParameterValues("xplgNode");
	if (xplgNodeIds == null || xplgNodeIds.length == 0){
		errmodel.addError("No Xplg Entereprise Nodes queries were selected");
	}
  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY+"common/errorpage.jsp");
    return;
  }
	
	SupportQueryExecuter queryExec = new SupportQueryExecuter(xplgNodeIds, queriesKeys);
	queryExec.executeQuery();
	HashMap results = queryExec.getResults();
	request.getSession().setAttribute("SupportQueryExecuter",queryExec);
	SupportQueryHandler[] handlers = queryExec.getExecutableHandlers();
	
%>

<html>
<head>
	<script>
		function openXplgNodeStatus(xplgNodeId, queryKey){
			var param = "";
			if (xplgNodeId && xplgNodeId != ""){
				param = "?xplgNodeId="+xplgNodeId;
			}
			if (queryKey && queryKey != ""){
				param += "&queryKey="+queryKey;
			}
		  newWindow = window.open("showSupportStatus.jsp"+param,"detailsStatusWindow","height=600,width=800,resizable=yes,scrollbars=yes,status=yes,left=300,top=200");
		  newWindow.focus();	
		}

		function openSelectedXplgNodesStatus(){
			document.access.action = "showSupportStatus.jsp";
			document.access.target = "detailsStatusWindow";
			document.access.submit();
		}
		
		function selectAllNodes(){
			for (var i=0; i<<%=xplgNodeIds.length%>; i++){
				document.access.xplgNode<%=xplgNodeIds.length > 1 ? "[i]" : ""%>.checked = true;
			}
		}
		
		function clearAllNodes(){
			for (var i=0; i<<%=xplgNodeIds.length%>; i++){
				document.access.xplgNode<%=xplgNodeIds.length > 1 ? "[i]" : ""%>.checked = false;
			}
		}
		
		function exportToXml(){
			document.access.closeWindow.value = "false";
			document.access.action = "exportSupportStatusAction.jsp";
			document.access.target = "_self";
			document.access.submit();
		}
		

	</script>
	<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
</head>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<input type="hidden" name="closeWindow">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Xplg Enterprise Nodes Support Status Report</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
              	<td colspan="3">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" id="AutoNumber3" height="53" width="100%">
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" id="AutoNumber6" width="100%">
                      <tr class="TABLES_HEADERS">
                        <td width="10%" align="center" style="padding-right-5" ><span class="REGULARTEXT">Xplg Node</span></td>
                        <td width="10%" align="center" style="padding-left:5;padding-right-5" ><span class="REGULARTEXT">Connection</span></td>
                        <td width="10%" align="center" style="padding-left:5;padding-right-5" ><span class="REGULARTEXT">Status</span></td>
                        <%for (int i=0; i<handlers.length; i++){%>
                        <td style="padding-left:5;padding-right-5" align="center"><span class="REGULARTEXT"><%=handlers[i].getName()%></span></td>
                        <%}%>
                      </tr>
                      <tr>
                      	<td style="font-size:2px">&nbsp;</td>
                      </tr>
                      <%
                     	Iterator it = results.keySet().iterator(); 
                      String nodeId;
                      XplgNode node;
                      MultiSupportResult multi;
                      SupportResult result;
                      int healthState = -1;
                      HealthThreshold healthThreshold;
                      String weightImage;
                      boolean queryFailed = false;
                      String connImage;
                      String totalWeightImage;
	                    while (it.hasNext()){
	                    	nodeId = (String)it.next();
	                    	node = cmgr.getNodeById(nodeId);
	                    	multi = (MultiSupportResult)results.get(nodeId);
	                    	queryFailed = multi.isFailed();
	                    	if (queryFailed){
	                    		connImage = "images\\dashboard\\bullet_ball_red_small.gif";
	                    	}else{
	                    		connImage = "images\\dashboard\\bullet_ball_green_small.gif";
	                    	}
                        ComputationConfiguration computationConf = ComputationConfiguration.getInstance();
	                    	int totalHealthState = queryFailed ? 10 : multi.getHealthState();
                      	healthThreshold = computationConf.getHealthThresholdByThreshold(totalHealthState);
                      	if (healthThreshold != null){
                      		totalWeightImage = healthThreshold.getImagePath();
                      	}else{
                      		totalWeightImage = "";
                      	}
                      %>
                      <tr>
                        <td>
                        	<%if (queryFailed){%>
                        	<span class="REGULARTEXT" style="padding-left:26"><%=node.getName()%></span>
                        	<%}else{%>
                        	<input type="checkbox" name="xplgNode" value="<%=node.getId()%>"><nobr>
                        	<a class="LINK" href="javascript:openXplgNodeStatus('<%=node.getId()%>')"><%=node.getName()%></a>
                        	<%}%>
                        </td>
                        <td align="center">
                        <span class="REPORT_TABLE_TEXT"><nobr>
													<img border="0" src="<%=BASE_DIRECTORY+connImage%>">
												</nobr></span>
                        </td>
												<td style="padding-left:3;padding-right-3" align="center" valign="center"><span class="REPORT_TABLE_TEXT"><nobr>
												<%if (totalWeightImage == null){%>
													<%=totalHealthState%>
												<%}else{%>
													<img border="0" src="<%=BASE_DIRECTORY+totalWeightImage%>">
												<%} %>
                        <%
                        for (int i=0; i<handlers.length; i++){
                        	result = multi.getResultByKey(handlers[i].getKey());
                        	if (result == null){
                        		result = new SupportResult();
                        		result.setHealthState(10);
                        	}
                        	healthState = result.getHealthState();
                        	healthThreshold = computationConf.getHealthThresholdByThreshold(healthState);
                        	if (healthThreshold != null){
	                        	weightImage = healthThreshold.getImagePath();
                        	}else{
                        		weightImage = "";
                        	}
                        %>

												<td style="padding-left:3;padding-right-3" align="center" valign="center"><span class="REPORT_TABLE_TEXT"><nobr>
												<%if (weightImage == null){%>
													<%=healthState%>
												<%}else{%>
													<img border="0" src="<%=BASE_DIRECTORY+weightImage%>">
												<%} %>
												</nobr></span>
										 		</td>
                        <%}%>
                      </tr>
                      
                      <%}%>
                    </table>
                   </td>
                  </tr>
                  <tr>
                  	<td>&nbsp;</td>
                  </tr>
	                <tr>
	                	<td>
											<table border="0" cellpadding="0" cellspacing="0">
												<tr>
													<td><a href="javascript:selectAllNodes()" class="SMALLLINK">select all</a></td>
													<td width="10">&nbsp;</td>
													<td><a href="javascript:clearAllNodes()" class="SMALLLINK">clear all</a></td>
												</tr>
											</table>
	                	<td>
	                </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              	<tr>
									<td width="23%">&nbsp;</td>
									<td width="14%" align="center"><a href="javascript:openSelectedXplgNodesStatus()" class="LINK">show details</a></td>
									<td width="10%" align="center"><a href="javascript:exportToXml()" class="LINK">export</a></td>
									<td width="8%" align="center"><a href="javascript:history.go(-1)" class="LINK">back</a></td>
								  <td width="5%" align="center"><a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK">cancel</a></td>
								  <td width="20%">&nbsp;</td>
								  <td width="20%">&nbsp;</td>
								</tr>
							</table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>

</body>
</html>