<%@ page language="java"%>

<%@ page import="java.util.*"%>

<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.exe.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.WebUtil"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>


<%
	String PREFIX = "exe_";
	
	String scriptsOnlyStr = request.getParameter("scriptsOnly");
	boolean scriptsOnly = scriptsOnlyStr != null && scriptsOnlyStr.equals("true");
	
	String noScriptsStr = request.getParameter("noScripts");
	boolean noScripts = noScriptsStr != null && noScriptsStr.equals("true");
	
	String embeddedStr = request.getParameter("embedded");
	boolean embedded = embeddedStr != null && embeddedStr.equals("true");
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String exeTaskLabel = request.getParameter("exeTaskLabel");
	if (exeTaskLabel == null || exeTaskLabel.length() == 0){
		exeTaskLabel = "Batch Execution Task";
	}
	String existingTasksLabel = request.getParameter("existingTasksLabel");
	if (existingTasksLabel == null || existingTasksLabel.length() == 0){
		existingTasksLabel = "Existing Batch Tasks";
	}
	
	String existingTasksNote = request.getParameter("existingTasksNote");
	if (existingTasksLabel == null || existingTasksLabel.length() == 0){
		existingTasksNote = "copy details from existing batch task";
	}
	
	String exeTasksListStr = (String)request.getParameter("tasks");
	String[] exeTasks = null;
	if (exeTasksListStr != null){
		exeTasks = exeTasksListStr.split("#");
	}
	
	String onlyUpdateStr = request.getParameter("onlyUpdate");
	boolean onlyUpdate = onlyUpdateStr != null && onlyUpdateStr.equals("true");
	
	String ERROR_OBJ = "ERROR_OBJ";
	String TASK_ID = "ID";
	String IS_SSH = "IsSsh";
	String DUPLICATE = "DUPLICATE";
	String id = request.getParameter(TASK_ID);
	String isSshStr = request.getParameter(IS_SSH);
	boolean isSsh = (isSshStr != null && isSshStr.equals("true"));
	String duplicateStr = request.getParameter(DUPLICATE);
	boolean duplicate = duplicateStr != null && duplicateStr.equals("true");
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	String exePath = "";
	String name = "";
	String description = "";
	String exeArgs = "";
	
	String exeEnvVar = "";
	String exeWorkDir = "";
	
	String accountId = "";
	String exeOutputTargetFile = "";
	boolean addOptionalParams = true;
	 
	XpoTask sessionTask = (XpoTask)request.getSession().getAttribute("XpoTask");
	request.getSession().removeAttribute("XpoTask");
	ExeTask task = null;
	if (sessionTask instanceof ExeTask){
		task = (ExeTask)sessionTask;
	}
	if(id != null){
		XpoTaskManager taskmgr = XpoTaskManager.getInstance();
		task = (ExeTask)taskmgr.getXpoTaskById(id); 
	}else{
		id = "";
	}
	if(task != null){
	  if(!duplicate) {
			name = task.getName();
	  }
		description = task.getDescription();
		exePath = task.getExePath();
		exePath = WebUtil.doHTMLEncoding(exePath);
		exeArgs = task.getExeArgs();
		exeArgs = WebUtil.doHTMLEncoding(exeArgs);
		exeEnvVar = task.getExeEnvp();		
		exeEnvVar = WebUtil.doHTMLEncoding(exeEnvVar);
		exeOutputTargetFile = task.getExeOutputTargetFile();
		exeOutputTargetFile = WebUtil.doHTMLEncoding(exeOutputTargetFile);
		addOptionalParams = task.isAddOptionalParams();
		if (isSsh){
			accountId = task.getAccountId();
		}else {
			exeWorkDir = task.getExeDir();
			exeWorkDir = WebUtil.doHTMLEncoding(exeWorkDir);
		}
		id = task.getId();
	}
	
	List list = null;
  if(isSsh) {
		AddressBook adbook = AddressBook.getInstance();
	  AddressFilter filter = new TelnetAccountFilter();
	  list = adbook.getAccountsByFilter(filter);
		if(list.size() == 0) {
	  	//No accounts defined in system
	  	ErrorModel errmodel = new ErrorModel();
	  	errmodel.addError("There is no Ssh account defined, Please <a href=\"../tools/addresses/ssh/accountSsh.jsp\">create a Ssh account</a> first.");
	  	request.getSession().setAttribute(ERROR_OBJ,errmodel);
	    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
	    return;
		}
  }
	
%>

<%if (!embedded){%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<%} %>

<%if (!noScripts){%>
<script>
      function doSave(){
        document.access.action ="taskExeAction.jsp";
        document.access.submit();
      }
      
      function goNew(){
      	path = "<%=BASE_DIRECTORY%>tools/addresses/accoutAction.jsp?ACCOUNT_TYPE=<%=TelnetAccount.TYPE_SSH%>";
				document.location = path;
  	  }

</script>
<%}%>
<%if (!embedded){%>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<%}%>
<%if (!scriptsOnly){%>
<input type="hidden" name="<%=IS_SSH%><%=suffix%>" value="<%=isSsh%>">
<%if (!onlyUpdate){%>
<input type="hidden" name="taskId<%=suffix%>" size="50" value="<%=duplicate ? "" : id%>">
<%}%>
<%if (!onlyUpdate){%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
		<td id="taskDescriptionTD<%=suffix%>">
<%}%>  
		<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
			<%if (!embedded){%>
			<tr>
				<td style="padding-bottom:10;"><span class="REGULARTEXT"><%=exeTaskLabel%></span></td>
			</tr>
			<%}%>
			<%if (exeTasks != null){%>
			<tr>
				<td>
					<span class="REGULARTEXT">
						<%=existingTasksLabel%>: 
						<select id="exeTasks" name="exeTasks" onChange="updateFromExeTask()">
							<option value="">-- Select Alert --</option>
							<%
							String t,tId,tName;
							int ind;
							for (int i=0; i<exeTasks.length; i++){
								t = exeTasks[i];
								ind = t.indexOf("^");
								if (ind != -1){
									tId = t.substring(0,ind);
									tName = t.substring(ind+1);
								}else{
									continue;
								}
							%>
							<option value="<%=tId%>"><%=tName%></option>
							<%}%>
						</select>
					</span>
				</td>
			</tr>
			<tr>
				<td style="padding-bottom:10;"><span class="SMALLTEXT"><%=existingTasksNote%></span></td>
			</tr>
			<%} %>

 			<tr>
				<td style="padding-top:10;padding-bottom:10;padding-left:30px;background-color:#E4E4E4">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" >
					<tr>
						<td>
							<span class="REGULARTEXT">Batch Execution Details</span>
						</td>
					</tr>
					<tr>
						<td style="padding-top:15px">
							<table border="0" cellpadding="0" cellspacing="0" width="100%" >
								<tr>
									<td width="100" nowrap><span class="REGULARTEXT">Name</span></td>
									<td width="*">
										<input class="TEXTBOX" type="text" name="name<%=suffix%>" size="50" value="<%=name%>">
									</td>
								</tr>
								<tr>
									<td nowrap><span class="REGULARTEXT">Description</span></td>
									<td>
										<input class="TEXTBOX" type="text" name="description<%=suffix%>" size="50" value="<%=description%>">
									</td>
								</tr>
								<%if (isSsh){%>
								<tr>
									<td nowrap><span class="REGULARTEXT">Ssh Account</span></td>
									<td width="150">
									<table border="0" cellpadding="0" cellspacing="0" width="100%">
										<tr>
											<td width="150">
												<div id="accountsListDiv">
												<jsp:include flush="true" page="../../common/accountsListCombo.jsp">
													<jsp:param name="ACC_TYPE" value="ssh"/>
													<jsp:param name="ACC_ID" value="<%=accountId%>"/>
													<jsp:param name="CHANGE_ACC_SELECTION" value="false"/>
													<jsp:param name="PREFIX" value="<%=PREFIX%>"/>
													<jsp:param name="noScripts" value="true"/>
												</jsp:include> 																								
											</div>
											<input type="hidden" id="sshAccountId<%=suffix%>" name="sshAccountId<%=suffix%>" value="<%=accountId%>">
											</td>
											<%if (userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){%>
			    						<td align="left" style="padding-left:10"><a href="javascript:jmsNewAccount();" class="BUTTON_MEDIUMLINK">new</a></td>
			    						<%} %>
										</tr>
									</table>
								  </td>
								</tr>
								<%} %>
								<tr>
									<td nowrap><span class="REGULARTEXT">Program/Script path&nbsp;</span></td>
									<td>
										<input class="TEXTBOX" type="text" name="exePath<%=suffix%>" size="50" value="<%=exePath%>">
									</td>
								</tr>
								<tr>
									<td nowrap><span class="REGULARTEXT">Arguments</span></td>
									<td><input class="TEXTBOX" type="text" name="exeArgs<%=suffix%>" size="50" value="<%=exeArgs%>"></td>
								</tr>
								<tr>
									<td nowrap><span class="REGULARTEXT">Environment variables&nbsp;</span></td>
									<td><input class="TEXTBOX" type="text" name="exeEnvVar<%=suffix%>" size="50" value="<%=exeEnvVar%>"></td>
								</tr>
								<%if (!isSsh){%>
								<tr>
									<td nowrap><span class="REGULARTEXT">Working directory</span></td>
									<td><input class="TEXTBOX" type="text" name="exeWorkDir<%=suffix%>" size="50" value="<%=exeWorkDir%>"></td>
								</tr>
								<%}%>
								<tr>
									<td nowrap><span class="REGULARTEXT">Output target file</span></td>
									<td><input class="TEXTBOX" type="text" name="exeOutputTargetFile<%=suffix%>" size="50" value="<%=exeOutputTargetFile%>"></td>
								</tr>
								<tr>
									<td nowrap><span class="REGULARTEXT">Add optional params</span></td>
									<td><input type="checkbox" name="addOptionalParams<%=suffix%>" <%=addOptionalParams ? "checked" : "" %>><span class="SMALLTEXT">when checked the output file will contain the date, account name, host name and username</span></td>
								</tr>
							</table>
						</td>
					</tr>
					<%if (!embedded){ %>
					<tr>
						<td>
						<table border="0" cellpadding="0" cellspacing="0" width="101%" >
							<tr>
								<td width="25%">&nbsp;</td>
								<td width="13%">
								<p align="center">&nbsp;</td>
								<td width="11%"><a href="javascript:history.go(-1)" class="LINK">cancel</a></td>
								<td width="11%"><a href="javascript:doSave()" class="LINK">save</a></td>
								<td width="35%">&nbsp;</td>
							</tr>
						</table>
						</td>
					</tr>
					<%} %>
				</table>
				</td>
			</tr>
		</table>
<%if (!onlyUpdate){%>
		</td>
	</tr>
	<tr height="100%">
		<td>&nbsp;</td>
	</tr>
</table>
<%}%>
<%}%>
<%if (!embedded){%>
</form>
</body>
</html>
<%}%>