<%@ page language="java"%>

<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.exe.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	String IS_SSH = "IsSsh";
	
	String Name,Description,exePath ,Id,exeArgs,exeEnvVar,exeWorkDir,accountId,exeOutputTargetFile;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	exeArgs = request.getParameter("exeArgs");
	exePath = request.getParameter("exePath");
	Id = request.getParameter("Id");
	exeEnvVar = request.getParameter("exeEnvVar");
	exeWorkDir = request.getParameter("exeWorkDir");
	String isSshStr = request.getParameter(IS_SSH);
	boolean isSsh = (isSshStr != null && isSshStr.equals("true"));
	accountId = request.getParameter("accountId");
	exeOutputTargetFile = request.getParameter("exeOutputTargetFile");
	String addOptionalParamsStr = request.getParameter("addOptionalParams");
	boolean addOptionalParams = (addOptionalParamsStr != null && addOptionalParamsStr.equals("on"));
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
   	errmodel.addError("Name was not supplied");
 	}
	if(isSsh && (accountId == null || accountId.equals(""))){
   	errmodel.addError("SSH account was not supplied");
 	}
 	if(exePath == null || exePath.equals("")){
   	errmodel.addError("Program/Script path was not supplied");
 	}

 	if(errmodel.getErrorCount() != 0){
   	request.getSession().setAttribute(ERROR_OBJ,errmodel);
   	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=tasks/xpotasksview.jsp");
   	return;
 	}
	
	ExeTask task = null; 
	XpoTaskManager taskmgr = XpoTaskManager.getInstance();
	if(Id != null){
		task = (ExeTask)taskmgr.getXpoTaskById(Id);
		
	}
	if(task == null){
		task = new ExeTask();
	}
	
	task.setName(Name);
	task.setDescription(Description);
	task.setExePath(exePath);
	task.setExeArgs(exeArgs);
	task.setExeEnvp(exeEnvVar);
	task.setExeOutputTargetFile(exeOutputTargetFile);
	task.setAddOptionalParams(addOptionalParams);
	if (isSsh){
		task.setAccountId(accountId);
	}else {
		task.setExeDir(exeWorkDir);
	}
	
	taskmgr.addXpoTask(task,userContext);
	taskmgr.saveXpoTasks();
	
    //audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "task added/edited", AuditConstants.TASKS, "exe task added/edited " + Name);

  if (isSsh){
		response.sendRedirect(BASE_DIRECTORY + "tasks/xpotasksview.jsp?taskType=sshExe");
  }else{
		response.sendRedirect(BASE_DIRECTORY + "tasks/xpotasksview.jsp?taskType=exe");
  }
%>	