<%@ page language="java"%>

<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.automation.tasks.jms.*"%>

<%@ page import="xpolog.eye.error.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	
	String Name,Description,jmsMsg,jmsUsr,jmsPwd,topicName,queueName ,Id,accId ;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	jmsMsg = request.getParameter("jmsMsg");
	accId = request.getParameter("jmsAccountId");
	Id = request.getParameter("Id");
	topicName = request.getParameter("topicName");
	queueName = request.getParameter("queueName");
	
	ErrorModel errmodel = new ErrorModel(); 
		if(Name == null || Name.equals("")){
    	errmodel.addError("No Name was supplied.");
  	}

  	if(jmsMsg == null || jmsMsg.equals("")){
    	errmodel.addError("JMS message was not supplied.");
  	}
  	
  	if((topicName == null || topicName.equals("")) && (queueName == null || queueName.equals(""))){
    	errmodel.addError("JMS task must get either a Topic or a Queue as message target.");
  	}
  	
  	if(accId == null || accId.equals("")){
    	errmodel.addError("JMS account was not selected.");
  	}

  	if(errmodel.getErrorCount() != 0){
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
  	}
	
	JMSTask task = null; 
	XpoTaskManager taskmgr = XpoTaskManager.getInstance();
	if(Id != null && Id.length() > 0){
		task = (JMSTask)taskmgr.getXpoTaskById(Id);
		
	}
	if(task == null){
		task = new JMSTask();
	}
	
	task.setName(Name);
	task.setDescription(Description);
	task.setJmsMsgStr(jmsMsg);
	task.setJmsAccountId(accId);
	task.setTopicName(topicName);
	task.setQueueName(queueName);
	
	taskmgr.addXpoTask(task,userContext);
	taskmgr.saveXpoTasks();
	
	//	audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "task added/edited", AuditConstants.TASKS, "jms task added/edited " + Name);
		
	response.sendRedirect(BASE_DIRECTORY + "tasks/xpotasksview.jsp?taskType=JmsTask");
%>