<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.config.MailConfig"%>
<%@ page import="xpolog.eye.automation.tasks.mail.MailTask"%>
<%@ page import="xpolog.eye.automation.tasks.XpoTask"%>
<%@ page import="xpolog.eye.automation.tasks.XpoTaskManager"%>
<%@ page import="xpolog.eye.media.AddressBook"%>
<%@ page import="xpolog.eye.media.mail.MailAccount"%>
<%
  
  String BASE_DIR = "base_directory";
	String baseDir = request.getParameter(BASE_DIR);
	if (baseDir == null || baseDir.equals("")) {
		baseDir = "";
	}
	String taskDivBaseDirectory = request.getParameter("taskDivBaseDirectory");
	if(taskDivBaseDirectory == null) {
		taskDivBaseDirectory = "";
	}
	String mailTasksListStr = (String)request.getParameter("tasks");
	String[] mailTasks = null;
	if (mailTasksListStr != null){
		mailTasks = mailTasksListStr.split("#");
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String prefix = request.getParameter("prefix");
	if (prefix == null){
		prefix = "";
	}
	
	XpoTask sessionTask = (XpoTask)request.getSession().getAttribute("XpoTask");
	request.getSession().removeAttribute("XpoTask");
	MailTask task = null;
	if (sessionTask instanceof MailTask){
		task = (MailTask)sessionTask;
	}
	String taskId = request.getParameter("taskId");
	if (task == null){
		XpoTaskManager xpoTaskMgr = XpoTaskManager.getInstance();
		task = (MailTask)xpoTaskMgr.getXpoTaskById(taskId);
	}
	
	String id = task != null ? task.getId() : "";
	String name = task != null && task.getName() != null ? task.getName() : "";
	String subject = task != null && task.getSubject() != null ? task.getSubject() : "";
	String body = task != null && task.getBody() != null ? task.getBody() : "";
	String fromId = task != null ? task.getFromId() : "";
	String toId = task != null ? task.getToId() : "";
	AddressBook adrBook = AddressBook.getInstance();
	MailAccount fromAccount = fromId != null ? (MailAccount)adrBook.getAccountById(fromId) : null;
	MailAccount toAccount = toId != null ? (MailAccount)adrBook.getAccountById(toId) : null;
	String from = fromAccount != null ? fromAccount.getMailAddress() : "";
	String to = toAccount != null ? toAccount.getMailAddress() : "";
  String dataFormat = task != null ? task.getDataFormat() : null;
  String hasDataFormat = task != null && task.isTransformData() ? "checked" : "";
  if (task == null || !task.isTransformData()){
  	dataFormat = null;
  }
  boolean sendEventSummary = task != null ? task.isSendEventSummary() : true;
  String sendEventSummarySelected = sendEventSummary ? "checked" : "";
	
	String saveMailTaskFunction = request.getParameter("saveMailTaskFunction");
	if (saveMailTaskFunction == null || saveMailTaskFunction.length() == 0){
		saveMailTaskFunction = "saveMailTaskDiv('"+suffix+"')";
	}	
	
	String scriptsOnlyStr = request.getParameter("scriptsOnly");
	boolean scriptsOnly = scriptsOnlyStr != null && scriptsOnlyStr.equals("true");
	
	String noScriptsStr = request.getParameter("noScripts");
	boolean noScripts = noScriptsStr != null && noScriptsStr.equals("true");
	
	String embeddedStr = request.getParameter("embedded");
	boolean embedded = embeddedStr != null && embeddedStr.equals("true");
	
	String showNameStr = request.getParameter("showName");
	boolean showName = showNameStr == null || showNameStr.equals("true");
	
	String showFromStr = request.getParameter("showFrom");
	boolean showFrom = showFromStr == null || showFromStr.equals("true");
	
	String showAdvancedStr = request.getParameter("showAdvanced");
	boolean showAdvanced = showAdvancedStr != null && showAdvancedStr.equals("true");
	
	String divStyle = request.getParameter("divStyle");
	if (divStyle == null || divStyle.length() == 0){
		divStyle = "position:absolute;width:400px;height:300px;display:none;z-index:110;border:solid 2px #DBDFE2"; 
	}
	
	String onlyUpdateStr = request.getParameter("onlyUpdate");
	boolean onlyUpdate = onlyUpdateStr != null && onlyUpdateStr.equals("true");
	
	String showSaveLinkStr = request.getParameter("showSaveLink");
	boolean showSaveLink = showSaveLinkStr == null || showSaveLinkStr.equals("true");
	String saveLinkName = request.getParameter("saveLinkName");
	if (saveLinkName == null || saveLinkName.length() == 0){
		saveLinkName = "save";
	}
	
	String showCloseLinkStr = request.getParameter("showCloseLink");
	boolean showCloseLink = showCloseLinkStr == null || showCloseLinkStr.equals("true");
	String closeLinkName = request.getParameter("closeLinkName");
	if (closeLinkName == null || closeLinkName.length() == 0){
		closeLinkName = "close";
	}
	
	String emailTaskLabel = request.getParameter("emailTaskLabel");
	if (emailTaskLabel == null || emailTaskLabel.length() == 0){
		emailTaskLabel = "Email Task";
	}
	String existingTasksLabel = request.getParameter("existingTasksLabel");
	if (existingTasksLabel == null || existingTasksLabel.length() == 0){
		existingTasksLabel = "Existing Email Tasks";
	}
	
	String existingTasksNote = request.getParameter("existingTasksNote");
	if (existingTasksLabel == null || existingTasksLabel.length() == 0){
		existingTasksNote = "copy details from existing email task";
	}
	
	String isMultiStr = request.getParameter("isMulti");
	boolean isMulti = isMultiStr != null && isMultiStr.equals("true");
	
	boolean mailEnabled = true;
	Configuration conf = Configuration.getInstance();
	MailConfig mail = conf.getMailConfigurationManager();
	String host = mail.getSmtpHost();
	if(host.equals(MailConfig.DEF_SMTP_ADDRESS)){ 
		mailEnabled = false;
	}
  String port = String.valueOf(mail.getSmtpPort());
  String sysAddress = mail.getSystemMailAddress();
	
%>
<%if (!noScripts && !onlyUpdate){%>
<script>
	var contextreq;				
	function GetXmlHttpObject(){
		var contextreq=null;
		try {
		  // Firefox, Opera 8.0+, Safari
		  contextreq=new XMLHttpRequest();
		}catch (e){
			// Internet Explorer
			try{
				contextreq=new ActiveXObject("Msxml2.XMLHTTP");
			}catch (e){
				contextreq=new ActiveXObject("Microsoft.XMLHTTP");
			}
		}
		return contextreq;
	}
		
	function closeMailTaskDiv(suffix){
		document.getElementById("mailTaskDiv_"+suffix).style.display = "none";
		document.getElementById("mailTaskFrame_"+suffix).style.display = "none";
		clearTaskInfo(suffix);
	}
	
	function saveMailTaskDiv(_suffix){
		var params = buildParametersStr(_suffix);
		if(params == "falseInput"){
			return;
		}
		params += "&suffix=" + _suffix;
		
		var url = "<%=baseDir%>tasks/mail/newMailTaskDivAction.jsp?" + params;
		contextreq = GetXmlHttpObject();
		contextreq.open('POST', url, true);
		contextreq.onreadystatechange = saveMailTaskCallback;
		contextreq.send(null);  			  				
	}
		
	function saveMailTaskCallback(){
		if (contextreq.readyState == 4) {
			if (contextreq.status == 200) {
				var val = contextreq.responseText;					
				if (!val || val == "errorWhileSave"){
					alert("Failed to save new task.");
					return;
				}
				val = val.replace(/^\s+|\s+$/g, '') ;
				var arr = val.split("*");
				var taskId = "";
				var taskName = "";
				var suffix = "";
				if(arr != null && arr[0] != null){
					taskName = arr[0]
				}
				if(arr != null && arr[1] != null){
					taskId = arr[1]
				}
				if(arr != null && arr[2] != null){
					suffix = arr[2];
				}
				var sucFromElem = document.getElementById("From_Task_Suc" + suffix);
				if(sucFromElem){
					sucFromElem.options[sucFromElem.options.length] = new Option(taskName,taskId);
				}
				var failFromElem = document.getElementById("From_Fail" + suffix);
				if(failFromElem){
					failFromElem.options[failFromElem.options.length] = new Option(taskName,taskId);
				}
				if(taskType == "suc"){
					var sucToElem = document.getElementById("To_Suc" + suffix);								
					if(sucToElem){
							sucToElem.options[sucToElem.options.length] = new Option(taskName,taskId);
					}
				}else if(taskType == "fail"){
					var failToElem = document.getElementById("To_Fail" + suffix);
					if(failToElem){
						failToElem.options[failToElem.options.length] = new Option(taskName,taskId);
					}
				}					
				closeMailTaskDiv(suffix)
			}
		}
	}
	
	function buildParametersStr(suffix){
			var parameters;
			var taskId = document.getElementById("taskId"+suffix).value;
			var taskName = document.getElementById("taskName"+suffix).value;			
			if(taskName == ""){
				alert("Email task name was not supplied.");
				return "falseInput";
			}
			parameters = "taskId=" + taskId + "&taskName=" + taskName;
			<%if(showFrom){%>
			var from = document.getElementById("from"+suffix).value;			
			if(from == ""){
				alert("eMail address 'from' was not supplied.");
				return "falseInput";
			}
			parameters += "&from=" + from;
			<%}%>
			var to = document.getElementById("to"+suffix).value;
			if(to == ""){
				alert("eMail address 'to' was not supplied.");
				return "falseInput";
			}
			parameters += "&to=" + to;
			parameters += "&subject=" + document.getElementById("subject"+suffix).value;
			parameters += "&body=" + document.getElementById("body"+suffix).value;
			<%if (!mailEnabled){%>
				parameters += "&SMTPHost=" + document.getElementById("SMTPHost").value;
				parameters += "&SMTPProt=" + document.getElementById("SMTPProt").value;
				parameters += "&systemMailAddress=" + document.getElementById("systemMailAddress").value;
			<%}%>
			return parameters;		

	}
	
	function clearTaskInfo(suffix){
		document.getElementById("task"+suffix).value = "";
		document.getElementById("subject"+suffix).value = "";
		document.getElementById("body"+suffix).value = "";
		document.getElementById("from"+suffix).value = "";				
		document.getElementById("to"+suffix).value = "";
	}
	
	function updateFromMailTask(){
	}
	
</script>
<%}%>
<%if (!scriptsOnly){%>
<%if (!onlyUpdate){%>
<input type="hidden" name="taskId<%=suffix%>" id="taskId<%=suffix%>" value="<%=id%>">
<%}%>
<%if (!onlyUpdate){%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" bgcolor="white">
  <tr>
		<td style="padding-right:30" id="taskDescriptionTD<%=suffix%>">
<%}%>  
		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="100%">
			<%if (!embedded){%>
			<tr>
				<td style="padding-bottom:30"><span class="REGULARTEXT"><%=emailTaskLabel%></span></td>
			</tr>
			<%}%>
			<%if (mailTasks != null){%>
			<tr>
				<td>
					<span class="REGULARTEXT">
						<%=existingTasksLabel%>: 
						<select id="mailTasks" name="mailTasks" onChange="updateFromMailTask()">
							<option value="">-- Select Alert --</option>
							<%
							String t,tId,tName;
							int ind;
							for (int i=0; i<mailTasks.length; i++){
								t = mailTasks[i];
								ind = t.indexOf("^");
								if (ind != -1){
									tId = t.substring(0,ind);
									tName = t.substring(ind+1);
								}else{
									continue;
								}
							%>
								<option value="<%=tId%>"><%=tName%></option>
							<%}%>
						</select>
					</span>
				</td>
			</tr>
			<tr>
				<td style="padding-bottom:10;"><span class="SMALLTEXT"><%=existingTasksNote%></span></td>
			</tr>
			<%} %>
			<tr>
				<td style="padding-top:10;padding-bottom:10;padding-right:15px;padding-left:15px;background-color:#E4E4E4">
				<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
				  <tr>
						<td>	
						<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" >
						<tr>
							<td width="5px">&nbsp;</td>
							<td>
								<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" >
									<tr height="6px" style="font-size:1">
										<td width="100%" colspan="3">&nbsp;</td>			 	 			 	 	  		
									</tr>
									<%if (showName){ %>
									<tr>
										<td width="10%"><span class="REGULARTEXT">Name&nbsp;</span></td>
										<td width="30%">
											<input class="TEXTBOX" type="text" name="taskName<%=suffix%>" id="taskName<%=suffix%>" size="30" value="<%=name%>">
										</td>
										<td width="11%">&nbsp;</td>  
									</tr>
									<%}%>
									<%if (showFrom){ %>
									<tr>
										<td width="10%"><span class="REGULARTEXT">From&nbsp;</span></td>
										<td width="30%">
											<input class="TEXTBOX" type="text" name="from<%=suffix%>" id="from<%=suffix%>" size="30" value="<%=from%>">
										</td>
										<td width="11%">&nbsp;</td>  
									</tr>
									<%}%>
									<tr>
										<td width="10%"><span class="REGULARTEXT">To&nbsp;</span></td>
										<td colspan="2">
											<input class="TEXTBOX" type="text" name="to<%=suffix%>" id="to<%=suffix%>" size="30" value="<%=to%>"> <span class="SMALLTEXT">semicolon separated list</span>
										</td>
									</tr>
									<tr height="3px" style="font-size:1">
										<td width="100%" colspan="3">&nbsp;</td>			 	 			 	 	  		
									</tr>
									<tr>
										<td width="10%"><span class="REGULARTEXT">Subject&nbsp;</span></td>
										<td width="30%">
											<input class="TEXTBOX" type="text" name="subject<%=suffix%>" id="subject<%=suffix%>" size="40" value="<%=subject%>">
										</td>
										<td width="11%">&nbsp;</td>  
									</tr>  
									<tr height="3px" style="font-size:1">
										<td width="100%" colspan="3">&nbsp;</td>			 	 			 	 	  		
									</tr>
									<tr>
										<td width="10%" valign="top"><span class="REGULARTEXT">Body</span></td>
										<td width="30%">
											<textarea class="TEXTBOX" rows="7" name="body<%=suffix%>" id="body<%=suffix%>" cols="40"><%=body%></textarea>
										</td>
										<td width="11%">&nbsp;</td>  
									</tr>
									<%if (showAdvanced){
										String pageUrl = "../../common/adminSectionHeader.jsp";
									%>
									<tr>
										<td colspan="3" style="padding-top:10px">																										
											<div id="advancedSettingsDiv">																				
												<table border="0" cellpadding="0" cellspacing="0" width="100%">
													<tr>
														<td>																										
															<table border="0" cellpadding="0" cellspacing="0" width="100%" class="ADV_SETTINGS_BAR">
																<tr>
																	<td>																										
																		<jsp:include page="<%=pageUrl%>" flush="true">
																			<jsp:param name="baseDirectory" value="<%=baseDir%>" />
																			<jsp:param name="suffix" value="advancedSettings" />				
																			<jsp:param name="headerName" value="Advanced Settings" />
																			<jsp:param name="startOpen" value="false" />
																			<jsp:param name="showCheckBox" value="false" />
																			<jsp:param name="closeOthers" value="false" />
																			<jsp:param name="openOnClick" value="true" />
																		</jsp:include>
																	</td>
																</tr>
															</table>
														</td>
													</tr>
													<tr>
														<td>																										
															<table border="0" id="adminHeaderContentadvancedSettings" cellpadding="0" cellspacing="0" style="display:none" width="100%" class="ADV_SETTINGS_TABLE">
																<%
																if(!isMulti) {
																%>
																<tr valign="top">
																	<td style="padding-left:20;border-top:1 solid white">
																		<div id="eventsData">																				
																			<table border="0" cellpadding="0" cellspacing="0" width="100%">
																				<tr>
																					<td>																										
																						<table border="0" cellpadding="0" cellspacing="0" width="100%" class="ADV_SETTINGS_BAR">
																							<tr>
																								<td>																										
																									<jsp:include page="../../common/adminSectionHeader.jsp" flush="true">
																										<jsp:param name="baseDirectory" value="../" />
																										<jsp:param name="suffix" value="EventsData" />
																										<jsp:param name="level" value="1" />
																										<jsp:param name="headerName" value="Data Attachment" />
																										<jsp:param name="startOpen" value="false" />
																										<jsp:param name="showCheckBox" value="false" />
																										<jsp:param name="closeOthers" value="false" />
																										<jsp:param name="openOnClick" value="true" />
																									</jsp:include>
																								</td>
																							</tr>
																						</table>
																					</td>
																				</tr>
																				<tr>
																					<td style="padding-left:20px">																										
																						<table border="0" id="adminHeaderContentEventsData" cellpadding="0" cellspacing="0" style="display:none" width="100%" class="ADV_SETTINGS_TABLE">
																							<tr style="font-size:1">
																								<td width="100%" colspan="3" style="padding-top:10px">&nbsp;</td>			 	 			 	 	  		
																							</tr>
																							<tr>
																								<td colspan="2">
																									<span class="REGULARTEXT"><input type="checkbox" name="sendEventSummary<%=suffix%>" value="true" <%=sendEventSummarySelected%>>&nbsp;Append event to end of email body</span>
																								</td>
																								<td width="11%">&nbsp;</td>  
																							</tr>
																							<tr>
																								<td colspan="3">
																									<input type="hidden" name="useAttachResultPar<%=suffix%>" value="true">
																									<span class="REGULARTEXT"><input type="checkbox" name="attachResult<%=suffix%>" value="true" <%=hasDataFormat%>>&nbsp;Attach matched events as </span>
																	          			<select size="1" name="DataType<%=suffix%>">
																	            			<option class="TEXTBOX" value="XML" <%=(dataFormat != null && dataFormat.equals("XML")) ? "selected":""%>>XML</option>
																	            			<option class="TEXTBOX" value="CSV" <%=(dataFormat != null && dataFormat.equals("CSV")) ? "selected":""%>>CSV</option>
																	            			<option class="TEXTBOX" value="TAB" <%=((task == null || dataFormat == null) || dataFormat.equals("TAB")) ? "selected":""%>>TAB Delimited</option>                        
																	          			</select>
																			        	</td>
																							</tr>
																						</table>
																					</td>
																				</tr>
																			</table>
																		</div>
																	</td>
																</tr>
																<%
																}
																%>
																<tr valign="top">
																	<td style="padding-left:20;border-top:1 solid white">
																		<div id="advancedMailSettings">																				
																			<table border="0" cellpadding="0" cellspacing="0" width="100%">
																				<tr>
																					<td>																										
																						<table border="0" cellpadding="0" cellspacing="0" width="100%" class="ADV_SETTINGS_BAR">
																							<tr>
																								<td>																										
																									<jsp:include page="../../common/adminSectionHeader.jsp" flush="true">
																										<jsp:param name="baseDirectory" value="../" />
																										<jsp:param name="suffix" value="AdvancedMailSettings" />
																										<jsp:param name="level" value="1" />
																										<jsp:param name="headerName" value="From Email Address" />
																										<jsp:param name="startOpen" value="false" />
																										<jsp:param name="showCheckBox" value="false" />
																										<jsp:param name="closeOthers" value="false" />
																										<jsp:param name="openOnClick" value="true" />
																									</jsp:include>
																								</td>
																							</tr>
																						</table>
																					</td>
																				</tr>
																				<tr>
																					<td style="padding-left:20px">																										
																						<table border="0" id="adminHeaderContentAdvancedMailSettings" cellpadding="0" cellspacing="0" style="display:none" width="100%" class="ADV_SETTINGS_TABLE">
																							<%
																							boolean isSystem = fromId == null || fromId.equals("") || fromId.equals(MailTask.SYSTEM_ADDRESS_ID);
																							%>
																							<tr>
																								<td>
																									<input type="radio" id="mailFrom<%=suffix %>" name="mailFrom<%=suffix %>" value="<%=MailTask.SYSTEM_ADDRESS_ID %>" <%=isSystem ? "checked" : "" %> onClick="javascript:toggleFrom(true, '<%=suffix%>')"><span class="REGULARTEXT">System Email Address</span></input>
																								</td>
																							</tr>
																							<tr>
																								<td>
																									<input type="radio" id="mailFrom<%=suffix %>" name="mailFrom<%=suffix %>" value="CUSTOM" <%=isSystem ? "" : "checked" %> onClick="javascript:toggleFrom(false, '<%=suffix%>')"><span class="REGULARTEXT">Custom</span></input>&nbsp;&nbsp;
																									<input class="TEXTBOX" type="text" name="fromCustom<%=suffix%>" id="fromCustom<%=suffix%>" size="30" value="<%=from%>" <%=isSystem ? "disabled" : "" %>>
																								</td>
																							</tr>
																						</table>
																					</td>
																				</tr>
																			</table>
																		</div>
																	</td>
																</tr>
															</table>
														</td>
													</tr>
												</table>
											</div>
										</td>
									</tr>
									<%}%>             
									<tr height="*">
										<td colspan="3">&nbsp;</td>
									</tr>                                
								</table>
								</td>				
							</tr>
						</table>
						</td>
					</tr>
				</table>
				</td>
			</tr>
			<%if (!embedded){ %>
		  <tr>
				<td>
				<table border="0" cellpadding="0" cellspacing="0" align="center" width="100%">
					<tr>		
						<td width="40%">&nbsp;</td>	
						<%if (showSaveLink){%>
						<td width="10%" align="center">
							<a class="PROGRESSLINK" href="javascript:<%=saveMailTaskFunction%>;"><%=saveLinkName%></a>&nbsp;<nobr>
						</td>	 	 	  		
						<%}%>
						<%if (showCloseLink){%>
						<td width="10%" align="center">
							<a class="PROGRESSLINK" href="javascript:closeMailTaskDiv('<%=suffix%>');"><%=closeLinkName%></a>&nbsp;<nobr>
						</td>
						<%}%>
						<td width="40%" align="center">&nbsp;</td>				 	 	
					</tr>
					<tr height="11px" style="font-size:1">
						<td colspan="4">&nbsp;</td>			 	 			 	 	  		
					</tr>
				</table>
				</td>
		  </tr>
		  <%} %>
		</table>
<%if (!onlyUpdate){%>		
		</td>
	</tr>
	<tr height="100%">
		<td>&nbsp;</td>
	</tr>
</table>
<%}%>
<%}%>