<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.config.MailConfig"%>
<%
  
  String BASE_DIR = "base_directory";
	String baseDir = request.getParameter(BASE_DIR);
	if (baseDir == null || baseDir.equals("")) {
		baseDir = "";
	}
	String taskDivBaseDirectory = request.getParameter("taskDivBaseDirectory");
	if(taskDivBaseDirectory == null) {
		taskDivBaseDirectory = "";
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String saveMailTaskFunction = request.getParameter("saveMailTaskFunction");
	if (saveMailTaskFunction == null || saveMailTaskFunction.length() == 0){
		saveMailTaskFunction = "saveMailTaskDiv('"+suffix+"')";
	}	
	
	String scriptsOnlyStr = request.getParameter("scriptsOnly");
	boolean scriptsOnly = scriptsOnlyStr != null && scriptsOnlyStr.equals("true");
	
	String noScriptsStr = request.getParameter("noScripts");
	boolean noScripts = noScriptsStr != null && noScriptsStr.equals("true");
	
	String showTableHeaderStr = request.getParameter("showTableHeader");
	boolean showTableHeader = showTableHeaderStr == null || showTableHeaderStr.equals("true");
	
	String showFromStr = request.getParameter("showFrom");
	boolean showFrom = showFromStr == null || showFromStr.equals("true");
	
	String divStyle = request.getParameter("divStyle");
	if (divStyle == null || divStyle.length() == 0){
		divStyle = "position:absolute;width:400px;height:300px;display:none;z-index:110;border:solid 2px #DBDFE2"; 
	}
	
	String showSaveLinkStr = request.getParameter("showSaveLink");
	boolean showSaveLink = showSaveLinkStr == null || showSaveLinkStr.equals("true");
	String saveLinkName = request.getParameter("saveLinkName");
	if (saveLinkName == null || saveLinkName.length() == 0){
		saveLinkName = "save";
	}
	
	String showCloseLinkStr = request.getParameter("showCloseLink");
	boolean showCloseLink = showCloseLinkStr == null || showCloseLinkStr.equals("true");
	String closeLinkName = request.getParameter("closeLinkName");
	if (closeLinkName == null || closeLinkName.length() == 0){
		closeLinkName = "close";
	}
	
	boolean mailEnabled = true;
	Configuration conf = Configuration.getInstance();
	MailConfig mail = conf.getMailConfigurationManager();
	String host = mail.getSmtpHost();
	if(host.equals(MailConfig.DEF_SMTP_ADDRESS)){ 
		mailEnabled = false;
	}
  String port = String.valueOf(mail.getSmtpPort());
  String sysAddress = mail.getSystemMailAddress();
  String adminMail = mail.getAdminMail();
	
%>
<%if (!noScripts){%>
<script>
	var contextreq;				
	function GetXmlHttpObject(){
		var contextreq=null;
		try {
		  // Firefox, Opera 8.0+, Safari
		  contextreq=new XMLHttpRequest();
		}catch (e){
			// Internet Explorer
			try{
				contextreq=new ActiveXObject("Msxml2.XMLHTTP");
			}catch (e){
				contextreq=new ActiveXObject("Microsoft.XMLHTTP");
			}
		}
		return contextreq;
	}
		
	function closeMailTaskDiv(suffix){
		document.getElementById("mailTaskDiv_"+suffix).style.display = "none";
		document.getElementById("mailTaskFrame_"+suffix).style.display = "none";
		clearTaskInfo(suffix);
	}
	
	function saveMailTaskDiv(_suffix){
		var params = buildParametersStr(_suffix);
		if(params == "falseInput"){
			return;
		}
		params += "&suffix=" + _suffix;
		
		var url = "<%=baseDir%>tasks/mail/newMailTaskDivAction.jsp?" + params;
		contextreq = GetXmlHttpObject();
		contextreq.open('POST', url, true);
		contextreq.onreadystatechange = saveMailTaskCallback;
		contextreq.send(null);  			  				
	}
		
	function saveMailTaskCallback(){
		if (contextreq.readyState == 4) {
			if (contextreq.status == 200) {
				var val = contextreq.responseText;					
				if (!val || val == "errorWhileSave"){
					alert("Failed to save new task.");
					return;
				}
				val = val.replace(/^\s+|\s+$/g, '') ;
				var arr = val.split("*");
				var taskId = "";
				var taskName = "";
				var suffix = "";
				if(arr != null && arr[0] != null){
					taskName = arr[0]
				}
				if(arr != null && arr[1] != null){
					taskId = arr[1]
				}
				if(arr != null && arr[2] != null){
					suffix = arr[2];
				}
				var sucFromElem = document.getElementById("From_Task_Suc" + suffix);
				if(sucFromElem){
					sucFromElem.options[sucFromElem.options.length] = new Option(taskName,taskId);
				}
				var failFromElem = document.getElementById("From_Fail" + suffix);
				if(failFromElem){
					failFromElem.options[failFromElem.options.length] = new Option(taskName,taskId);
				}
				if(taskType == "suc"){
					var sucToElem = document.getElementById("To_Suc" + suffix);								
					if(sucToElem){
							sucToElem.options[sucToElem.options.length] = new Option(taskName,taskId);
					}
				}else if(taskType == "fail"){
					var failToElem = document.getElementById("To_Fail" + suffix);
					if(failToElem){
						failToElem.options[failToElem.options.length] = new Option(taskName,taskId);
					}
				}					
				closeMailTaskDiv(suffix)
			}
		}
	}
	
	function buildParametersStr(suffix){
			var parameters;			
			var taskNameId = document.getElementById("taskNameId_"+suffix).value;			
			if(taskNameId == ""){
				alert("eMail task name was not supplied.");
				return "falseInput";
			}
			parameters = "taskNameId=" + taskNameId;
			<%if(showFrom){%>
			var fromId = document.getElementById("fromId_"+suffix).value;			
			if(fromId == ""){
				alert("eMail address 'from' was not supplied.");
				return "falseInput";
			}
			parameters += "&fromId=" + fromId;
			<%}%>
			var toId = document.getElementById("toId_"+suffix).value;
			if(toId == ""){
				alert("eMail address 'to' was not supplied.");
				return "falseInput";
			}
			parameters += "&toId=" + toId;
			parameters += "&subjectId=" + document.getElementById("subjectId_"+suffix).value;
			parameters += "&bodyId=" + document.getElementById("bodyId_"+suffix).value;
			<%if (!mailEnabled){%>
				parameters += "&SMTPHost=" + document.getElementById("SMTPHost").value;
				parameters += "&SMTPProt=" + document.getElementById("SMTPProt").value;
				parameters += "&systemMailAddress=" + document.getElementById("systemMailAddress").value;
			<%}%>
			return parameters;		

	}
	
	function clearTaskInfo(suffix){
		document.getElementById("taskNameId_"+suffix).value = "";
		document.getElementById("subjectId_"+suffix).value = "";
		document.getElementById("bodyId_"+suffix).value = "";
		document.getElementById("fromId_"+suffix).value = "";				
		document.getElementById("toId_"+suffix).value = "";
	}
	
</script>
<%}%>
<%if (!scriptsOnly){%>
<div id="mailTaskDiv_<%=suffix%>" style="<%=divStyle%>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" bgcolor="white">
	<%if (showTableHeader){%>
	<tr>
		<td>
		<table border="0" cellpadding="0" cellspacing="0" width="100%">
			<tr>
				<td align="center" height="25" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
					<span class="PROGRESSTEXT">New Mail Task</span>
				</td>
			</tr>
		</table>
		</td>
  </tr>
  <%}%>
  <tr>
		<td>	
		<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" >
		<tr>
			<td width="5px">&nbsp;</td>
			<td>
				<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" >
					<tr height="6px" style="font-size:1">
						<td width="100%" colspan="3">&nbsp;</td>			 	 			 	 	  		
					</tr>
					<%if (!mailEnabled){%>
					<tr>
						<td colspan="3">
							<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" >
								<tr>
									<td>
									<table border="0" width="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td nowrap style="padding-top:5"><span class="REGULARTEXT">SMTP host</span></td>
											<td width="80%">
												<input type="text" name="SMTPHost" class="TEXTBOX" size="24" value="<%=host%>">
												<span class="SMALLTEXT">(example: mail.mydomain.com)</span>
											</td>
										</tr>
										<tr>
											<td nowrap style="padding-top:5"><span class="REGULARTEXT">SMTP port&nbsp;</span></td>
											<td width="80%">
												<input type="text" name="SMTPProt" class="TEXTBOX" size="24" value="<%=port%>">
												<span class="SMALLTEXT">(default:25)</span>
											</td>
										</tr>
										<tr>
											<td nowrap style="padding-top:5"><span class="REGULARTEXT">System Mail address&nbsp;</span></td>
											<td width="80%">
												<input type="text" name="systemMailAddress" class="TEXTBOX" size="24" value="<%=sysAddress%>">
												<span class="SMALLTEXT">(example:system@mydomain.com)</span>
											</td>
										</tr>
			            	<tr>
				              <td nowrap style="padding-top:5"><span class="REGULARTEXT">Administrator Email Address</span></td>
			              	<td style="padding-top:5"><input type="text" name="adminMail" class="TEXTBOX" size="24" value="<%=adminMail%>"></td>
			            	</tr>
									</table>
									</td>
								</tr>
							</table>
						</td>
					</tr>
					<tr>
						<td colspan="3">&nbsp;</td>
					</tr>
					<%}%>
					
					<tr>
						<td width="25%"><span class="REGULARTEXT">Name&nbsp;</span></td>
						<td width="30%">
							<input class="TEXTBOX" type="text" name="taskNameId_<%=suffix%>" id="taskNameId_<%=suffix%>" size="30" value="">
						</td>
						<td width="11%">&nbsp;</td>  
					</tr>
					<%if (showFrom){ %>
					<tr>
						<td width="25%"><span class="REGULARTEXT">From&nbsp;</span></td>
						<td width="30%">
							<input class="TEXTBOX" type="text" name="fromId_<%=suffix%>" id="fromId_<%=suffix%>" size="30" value="">
						</td>
						<td width="11%">&nbsp;</td>  
					</tr>
					<%}%>
					<tr>
						<td width="25%"><span class="REGULARTEXT">To&nbsp;</span></td>
						<td width="30%">
							<input class="TEXTBOX" type="text" name="toId_<%=suffix%>" id="toId_<%=suffix%>" size="30" value="">
						</td>
						<td width="11%">&nbsp;</td>  
					</tr>
					<tr height="3px" style="font-size:1">
						<td width="100%" colspan="3">&nbsp;</td>			 	 			 	 	  		
					</tr>
					<tr>
						<td width="25%"><span class="REGULARTEXT">Subject&nbsp;</span></td>
						<td width="30%">
							<input class="TEXTBOX" type="text" name="subjectId_<%=suffix%>" id="subjectId_<%=suffix%>" size="40" value="">
						</td>
						<td width="11%">&nbsp;</td>  
					</tr>  
					<tr height="3px" style="font-size:1">
						<td width="100%" colspan="3">&nbsp;</td>			 	 			 	 	  		
					</tr>
					<tr>
						<td width="25%" valign="top"><span class="REGULARTEXT">Body</span></td>
						<td width="30%">
							<textarea class="TEXTBOX" rows="7" name="bodyId_<%=suffix%>" id="bodyId_<%=suffix%>" cols="40"></textarea>
						</td>
						<td width="11%">&nbsp;</td>  
					</tr>                
					<tr height="*">
						<td colspan="3">&nbsp;</td>
					</tr>                                
				</table>
			</td>				
		</tr>
	</table>
  </td>
  </tr>
  <tr>
		<td>
		<table border="0" cellpadding="0" cellspacing="0" align="center" width="100%">
			<tr>		
				<td width="40%">&nbsp;</td>	
				<%if (showSaveLink){%>
				<td width="10%" align="center">
					<a class="PROGRESSLINK" href="javascript:<%=saveMailTaskFunction%>;"><%=saveLinkName%></a>&nbsp;<nobr>
				</td>	 	 	  		
				<%}%>
				<%if (showCloseLink){%>
				<td width="10%" align="center">
					<a class="PROGRESSLINK" href="javascript:closeMailTaskDiv('<%=suffix%>');"><%=closeLinkName%></a>&nbsp;<nobr>
				</td>
				<%}%>
				<td width="40%" align="center">&nbsp;</td>				 	 	
			</tr>
			<tr height="11px" style="font-size:1">
				<td colspan="4">&nbsp;</td>			 	 			 	 	  		
			</tr>
		</table>
		</td>
  </tr>
</table>
</div>
<iframe id="mailTaskFrame_<%=suffix%>" src="<%=baseDir%>empty.html"  style="position:absolute;width:400px;height:300px;display:none;z-index:100" ></iframe> 
<%}%>