<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.mail.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.mail.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.WebUtil"%>

<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	String ACCOUNT_TYPE = "accountType";

  String subject = "", body = "", fromId = "", toId = "", dataFormat="";
  
	UserContext userContext = UserEnvironment.getUserContext(request);
  
	String baseDirectory = request.getParameter("baseDirectory");
	if(baseDirectory == null) {
		baseDirectory = BASE_DIRECTORY;
	}
	
  MailTask task = (MailTask)request.getAttribute("CURRENT_TASK");
	String accountType = request.getParameter(ACCOUNT_TYPE);
	if(task != null){
		fromId = task.getFromId();
  	toId = task.getToId();
  	subject = WebUtil.doHTMLEncoding(task.getSubject());
  	body = task.body;
  	dataFormat = task.getDataFormat();
	}
  
  String R0,R1,R2;
  if(dataFormat == null || dataFormat.length() == 0 || (dataFormat != null &&  dataFormat.equals("NONE"))){
   R0 = "checked";
   R1 = "";
   R2 = "";
  }else if(dataFormat != null &&  dataFormat.equals("PLAIN")){
   R0 = "";
   R1 = "checked";
   R2 = "";
  }else {
   R0 = "";
   R1 = "";
   R2 = "checked";
  }
  
  Configuration conf = Configuration.getInstance();
	MailConfig mail = conf.getMailConfigurationManager();
	String host = mail.getSmtpHost();
	boolean showMailSettings = host.length() == 0 || host.equals(MailConfig.DEF_SMTP_ADDRESS); 
%>

<% if (showMailSettings){ %>

<script>
	function saveMailSettings() {
		var smtpHost = document.getElementById("SMTPHost").value;
		if(smtpHost == '') {
			alert("SMTP host cannot be empty");
			return;
		}else if(smtpHost == 'my.domain.com') {
			alert("SMTP host cannot be my.domain.com");
			return;
		}
	
		var params = "";
		params += "SMTPHost=" + document.getElementById("SMTPHost").value;
		params += "&SMTPProt=" + document.getElementById("SMTPProt").value;
		params += "&systemMailAddress=" + document.getElementById("systemMailAddress").value;
		params += "&adminMail=" + document.getElementById("adminMail").value;
		sendAjaxRequest("<%=baseDirectory %>tasks/mail/mailSettingsAction.jsp?"+params,function(req){
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result){
				alert("Saving mail setting failed");
				return;			
			}
			if(result.indexOf("ok") != -1) {
				document.getElementById("adminGeneralDivMailSettings").style.display = "none";
				document.getElementById("MailDetails").style.display = "";
			}
		});
	}
</script>

<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=baseDirectory%>"/> 
	<jsp:param name="suffix" value="MailSettings"/> 
	<jsp:param name="width" value="570px"/> 
	<jsp:param name="height" value="275px"/>
	<jsp:param name="left" value="50px"/>
	<jsp:param name="top" value="5px"/>
	<jsp:param name="includePath" value="tasks/mail/mailSettings.jsp?isShort=true"/>	
	<jsp:param name="title" value="Mail Settings"/> 
	<jsp:param name="message" value="Please specify the following mail settings before adding an email task:"/> 
	<jsp:param name="position" value="relative"/>
	<jsp:param name="display" value=""/>
	<jsp:param name="actionsNames" value="Save"/> 
	<jsp:param name="actions" value="javascript:saveMailSettings()"/> 
</jsp:include>
<%} %>

<script>
	function updateTaskDetails() {
		if(document.getElementById("adminGeneralDivMailSettings") && document.getElementById("adminGeneralDivMailSettings").style.display == "") {
			return "Mail settings were not saved";
		}
		return "";
	}

	function openNewAccountDiv(accountsListName, accountsListNameToUpdate){
		openNewAccDiv('addAccDiv','<%=accountType %>','','new',accountsListName,'../',accountsListNameToUpdate);
	}
  	  
  function selectRadio(radioName) {
   	if(radioName=='R0') {
   		document.access.R0.checked="true";
   		document.access.R1.checked="";
   		document.access.R2.checked="";
   	}else if(radioName=='R1'){
   		document.access.R0.checked="";
   		document.access.R1.checked="true";
   		document.access.R2.checked="";
   	}else {
   		document.access.R0.checked="";
   		document.access.R1.checked="";
   		document.access.R2.checked="true";
   	}
  }
</script>

<div style="display:<%=showMailSettings ? "none" : ""%>" id="MailDetails">
<input type="hidden" id="fullTask" name="fullTask" value="true">

<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
	<tr>
		<td style="padding-left:15;padding-top:10">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr height="10">
			  	<td width="12%"><span class="REGULARTEXT">From *</span></td>
			    <td width="69%">
						<%
						String accountsListUrl = BASE_DIRECTORY + "common/accountsListCombo.jsp";
						%>
						<jsp:include flush="true" page="<%=accountsListUrl %>">
							<jsp:param name="ACC_TYPE" value="<%=accountType%>"/>
							<jsp:param name="ACC_ID" value="<%=fromId%>"/>
							<jsp:param name="ACC_LIST_ID" value="fromId"/>
							<jsp:param name="CHANGE_ACC_SELECTION" value="false"/>
							<jsp:param name="PREFIX" value="from"/>
						</jsp:include>
			    <%
			    if (userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){
			    %>
			    <span class="SMALLTEXT"><a href="javascript:openNewAccountDiv('fromId', 'toId')" class="BUTTON_MEDIUMLINK">new</a></span>
			    <%}%>
			    </td>
			  </tr>
			  <tr height="10">
			  	<td style="padding-top:10"><span class="REGULARTEXT">To *</span></td>
			    <td>
						<jsp:include flush="true" page="<%=accountsListUrl %>">
							<jsp:param name="ACC_TYPE" value="<%=accountType%>"/>
							<jsp:param name="ACC_ID" value="<%=toId%>"/>
							<jsp:param name="ACC_LIST_ID" value="toId"/>
							<jsp:param name="CHANGE_ACC_SELECTION" value="false"/>
							<jsp:param name="PREFIX" value="to"/>
						</jsp:include>
			    <%
			    if (userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){
			    %>
			    <span class="SMALLTEXT"><a href="javascript:openNewAccountDiv('toId', 'fromId')" class="BUTTON_MEDIUMLINK">new</a></span>
			    <%}%>
			    </td>
			  </tr>
			  <tr height="10">
        	<td style="padding-top:10"><span class="REGULARTEXT">Subject *</span></td>
          <td>
          	<input class="TEXTBOX" type="text" name="subject" size="50" value="<%=subject%>"></td>
        </tr>
        <tr height="10">
        	<td style="padding-top:10">&nbsp;</td>
          <td>
          &nbsp;</td>
        </tr>
        <tr height="10">
        	<td style="padding-top:10" valign="top"><span class="REGULARTEXT">Body</span></td>
          <td>
          	<textarea class="TEXTBOX" rows="7" name="body" cols="60"><%=body%></textarea>
          </td>
        </tr>
        <tr height="10">
        	<td style="padding-top:10">&nbsp;</td>
          <td>
          &nbsp;</td>
        </tr>
        <tr height="10">
        	<td colspan="2"><span class="HEADER">Data Export Format</span></td>
        </tr>
        <tr height="10">
        	<td colspan="2"><span class="SMALLTEXT">
             XpoLog can export the filtered data in several formats. XpoLog will attach a file with the transformed data (if found) after applying the filter.<br>
             In order not to export any data with the email, choose the first option. 
            </span>
          </td>
        </tr>
        <tr height="10">
        	<td colspan="2" >&nbsp;</td>
        </tr>
        <tr height="10">
        	<td colspan="2">
          	<p>
          	<input type="radio" id="R0" name="R0" <%=R0%> onclick="javascript:selectRadio('R0')"> <span class="REGULARTEXT">Send an email alert without any data attached</span><br>
          	<input type="radio" id="R1" name="R1" <%=R1%> onclick="javascript:selectRadio('R1')"> <span class="REGULARTEXT">Attach the log together with its configuration, to enable future import</span><br>
          	<input type="radio" id="R2" name="R2" <%=R2%> onclick="javascript:selectRadio('R2')">
          		<span class="REGULARTEXT">Transform the data and attach to mail as:</span>
          			<select size="1" name="DataType" onclick="javascript:selectRadio('R2')" onchange="javascript:selectRadio('R2')">
									<option class="TEXTBOX" value="">--- Select Export Format ---</option>                     
            			<option class="TEXTBOX" value="XML" <%=(dataFormat != null && dataFormat.equals("XML")) ? "selected":""%>>XML</option>
            			<option class="TEXTBOX" value="CSV" <%=(dataFormat != null && dataFormat.equals("CSV")) ? "selected":""%>>CSV</option>
            			<option class="TEXTBOX" value="TAB" <%=(dataFormat != null && dataFormat.equals("TAB")) ? "selected":""%>>TAB Delimited</option>                        
          			</select></p>
        	</td>
        </tr>
			  <tr height="10">
          <td style="padding-top:20" colspan="2">
          	<span class="SMALLTEXT">* marks a manadatory field</span>
          </td>
        </tr>
			  <tr>
			  	<td>&nbsp;</td>
			  </tr>
			</table>
		</td>
	</tr>
</table>
</div>