<%@ page language="java"%>

<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.mail.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String XPOTASK_ID = "ID";
	String ERROR_OBJ = "ERROR_OBJ";
	
	String Name, Description, Subject, Body, fromId, toId, Id, dataFormatExport, dataFormat="";
	String R0=null,R1=null,R2=null;
	
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	Subject = request.getParameter("Subject");
	Body = request.getParameter("Body");
	fromId = request.getParameter("fromId");
	toId = request.getParameter("toId");
	R0 = request.getParameter("R0");
	R1 = request.getParameter("R1");
	R2 = request.getParameter("R2");
	dataFormatExport = request.getParameter("DataType");
	Id = request.getParameter(XPOTASK_ID);
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
    	errmodel.addError("No Name was supplied.");
  	}
  
  	if(Subject == null || Subject.equals("")){
    	errmodel.addError("eMail subject was not supplied.");
  	}
  	
  	if(fromId == null || fromId.equals("")){
    	errmodel.addError("eMail address 'from' was not supplied.");
  	}
  	
  	if(toId == null || toId.equals("")) {
  		errmodel.addError("eMail address 'to' was not supplied.");
  	}
  	
  	if (R0 != null && R0.equals("on")) {
  		dataFormat = "NONE";
  	}else if(R1 != null && R1.equals("on")) {
  		dataFormat = "PLAIN";
  	}else {
  		dataFormat = dataFormatExport;
  	}
  	//making sure
  	if(dataFormat == null || dataFormat.length() == 0) {
  		dataFormat = "NONE";
  	}
  	
  	
  	if(errmodel.getErrorCount() != 0){
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
  	}
	
	MailTask task = null;
	XpoTaskManager taskmgr = XpoTaskManager.getInstance();
	if(Id != null && Id.length() > 0){
		task = (MailTask)taskmgr.getXpoTaskById(Id);
	}
	if(task == null){
		task = new MailTask();
	}
	
	task.setName(Name);
	task.setDescription(Description);
	task.setSubject(Subject);
	task.setBody(Body);
	task.setFromId(fromId);
	task.setToId(toId);
	task.setDataFormat(dataFormat);
	
	taskmgr.addXpoTask(task,userContext);
	taskmgr.saveXpoTasks();
	
    //audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "task added/edited", AuditConstants.TASKS, "mail task added/edited " + Name);

	response.sendRedirect(BASE_DIRECTORY + "tasks/xpotasksview.jsp?taskType=email");
%>