<%@ page language="java"%>

<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.pop.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	
	String Name,Description,exePath ,Id,popUrl;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	popUrl = request.getParameter("popUrl");
	Id = request.getParameter("Id");

	ErrorModel errmodel = new ErrorModel(); 
		if(Name == null || Name.equals("")){
    	errmodel.addError("No Name was supplied.");
  	}

  	if(popUrl == null || popUrl.equals("")){
    	errmodel.addError("PopUp URL was not supplied.");
  	}

  	if(errmodel.getErrorCount() != 0){
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
  	}
	
	PopUpTask task = null; 
	XpoTaskManager taskmgr = XpoTaskManager.getInstance();
	if(Id != null){
		task = (PopUpTask)taskmgr.getXpoTaskById(Id);
		
	}
	if(task == null){
		task = new PopUpTask();
	}
	
	task.setName(Name);
	task.setDescription(Description);
	task.setPopUrl(popUrl);
	
	taskmgr.addXpoTask(task,userContext);
	taskmgr.saveXpoTasks();
	
	   //audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "task added/edited", AuditConstants.TASKS, "pop task added/edited " + Name);

	response.sendRedirect(BASE_DIRECTORY + "tasks/xpotasksview.jsp?taskType=pop");
%>