<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.reports.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.reports.*"%>

<%!
  static final String BASE_DIRECTORY = "../../";
%>

<%
  //constants
  String TEXT = "TEXT";
  String CURRENT_LOG = "CURRENT_LOG"; 
  String SUBJECT = "SUBJECT";
  String ERROR_OBJ = "ERROR_OBJ";
  String TASK_ID = "ID";
  String DUPLICATE = "DUPLICATE";
	
  String name = "", description = "";
  boolean runReportVeriferTasks = true;

  String id = request.getParameter(TASK_ID);
  String duplicateStr = request.getParameter(DUPLICATE);
	boolean duplicate = duplicateStr != null && duplicateStr.equals("true");
	
   UserContext userContext = UserEnvironment.getUserContext(request);
   
   Configuration conf = Configuration.getInstance();
  
   ReportsManager mgr = ReportsManager.getInstance();
   List list = mgr.getAllBasicReports(userContext,false);
   ArrayList idlist = null;
   if(id != null) {
   	 XpoTaskManager taskmgr = XpoTaskManager.getInstance();
   	 ReportTask mt = (ReportTask)taskmgr.getXpoTaskById(id);
   	 if(!duplicate) {
	   	 name = mt.getName();
   	 }
   	 description = mt.getDescription();
   	 idlist = mt.getReportsIds();
   	 runReportVeriferTasks = mt.isRunVerifierTasks();
   }
   
   if(idlist == null){
   	idlist = new ArrayList();
   }
  
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
      function doSave(){
        document.access.action ="taskReportsGenAction.jsp";
        addAllFiledToSelection(document.access.To_Ses,document.access.To_Select_Ses);
        for(var t=0;t<document.access.To_Select_Ses.options.length;++t){
          document.access.To_Select_Ses.options[t].selected='true';
        }
        document.access.submit();
      }
      
      function refreshProjects(){
		workspaceId = document.access.workspace.options[document.access.workspace.selectedIndex].value;
		path = "workspaceId="+workspaceId;   
	    frames['dataFrame'].location = "taskProjects.jsp?"+ path;
	}
</script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access">
<input type="hidden"  name="ID" id="ID" value="<%=duplicate ? "" : id%>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="33%" class="TOPBORDER">
                <span class="PAGEHEADER">General Reports Task</span> </td>
                <td width="44%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <tr>
              
                <td width="1%" >&nbsp;</td>
                <td colspan="2">
             <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Task Details</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18">
                      <table border="0" width="100%" cellspacing="1" cellpadding="0">
                        <tr>
                          <td width="10%" nowrap><span class="REGULARTEXT">Name </span></td>
                          <td width="33%">
                    <input class="TEXTBOX" type="text" name="Name" size="50" value="<%=name%>"></td>
                          <td width="57%"></td>
                        </tr>
                        <tr>
                          <td width="10%" nowrap><span class="REGULARTEXT">Description </span>
                          </td>
                          <td width="33%">
                    		<input class="TEXTBOX" type="text" name="Description" size="50" value="<%=description%>"></td>
                          <td width="57%"></td>
                        </tr>
                        
                      </table>
                    </td>
                  </tr>
               	  <tr>
                    <td width="15%" height="18">&nbsp;</td>
                  </tr>
                  <tr>
                    <td width="15%" height="22">
                    
                    
                   <table border="0" width="600" cellspacing="0" cellpadding="0">
  <tr>
	<td>
		<table border="0" width="86" cellspacing="0" cellpadding="0">
			<tr>
			  <td width="40%"><span class="SMALLTEXT">Reports</span></td>
			</tr>
			<tr>
			  <td width="40%">
				  <select class="TEXTBOX" size="6" name="From_Ses" style="font-size: 8pt; font-family: Verdana" >
                                  <%
                                    for(int i=0;i<list.size();++i){
                                  %>
					<option value='<%=((Report)list.get(i)).getId()%>'><%=((Report)list.get(i)).getReportName()%></option>
                                  <%
                                    }
                                  %>
				  </select>
				</td>
			  </tr>
			  <tr>
				  <td width="40%"></td>
			  </tr>
		</table>
	  </td>
	  <td width="100" nowrap>
		  <table border="0" width="100%" cellspacing="0" cellpadding="0">
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:addFiledToSelection(document.access.From_Ses,document.access.To_Ses)" class="SMALLLINK">add</a></td>
			</tr>
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:addAllFiledToSelection(document.access.From_Ses,document.access.To_Ses)" class="SMALLLINK">add all</a></td>
			</tr>
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:removeFiledFromSelection(document.access.To_Ses)" class="SMALLLINK">remove</a></td>
			</tr>
			<tr>
			  <td width="100%" align="center" nowrap><a href="javascript:removeAllFiledFromSelection(document.access.To_Ses)" class="SMALLLINK">remove all</a></td>
			</tr>
		  </table>
	  </td>
	  <td width="286">
		  <table border="0" width="100%" cellspacing="0" cellpadding="0">
			<tr>
			  <td width="100%"><span class="SMALLTEXT">Reports to Run</span></td>
			</tr>
			<tr>
			  <td width="100%">
                                <select class="TEXTBOX" multiple type="hidden"  style="visibility:hidden; display:none" name="To_Select_Ses" id="To_Select_Ses">
                                </select>
				<select class="TEXTBOX" size="6" name="To_Ses" style="font-size: 8pt; font-family: Verdana">
                                <%
                                  if(idlist != null){
                                    for(int y=0;y<idlist.size();++y){
                                    Report d = mgr.getReportById((String)idlist.get(y));
                                    if (d == null || (userContext != null && !userContext.isVisible(d.getPermissions()))){
                                    	continue;
                                    }
                                %>
				    <option value='<%=d.getId()%>'><%=d.getReportName()%></option>
                                <%
                                    }
                                  }
                                %>
				</select></td>
			</tr>
			<tr>
			  <td width="40%"></td>
			</tr>
		  </table>
	  </td>
	  <td width="100" nowrap>
		<table border="0" width="100%" cellspacing="0" cellpadding="0">
		  <tr>
			<td width="100%" align="center"></td>
		  </tr>
		  <tr>
			<td width="100%" align="center"><font size="1"><!--<a href="javascript:alert('holla')">move up</a>--></font></td>
		  </tr>
		  <tr>
			<td width="100%" align="center"><font size="1"><!--<a href="javascript:alert('holla')">move down</a>--></font></td>
		  </tr>
		  <tr>
			<td width="100%" align="center"></td>
		  </tr>
		</table>
	  </td>
  </tr>
</table>                    </td>
                  </tr>
                  <tr>
                    <td width="15%" height="21">&nbsp;</td>
                  </tr>
                  <!--
                  <tr>
                    <td><b><i>Log context pattern</i></b></td>
                  </tr>-->
                  <tr>
                  	<td class="REGULARTEXT"><input type="checkbox" name="runReportVeriferTasks" value="true" <%=runReportVeriferTasks?"checked":""%>>
                  	run report monitor tasks
                  	</td>
                  </tr>
                  <tr>
                    <td><font size="2">&nbsp;&nbsp;</font></td>
                  </tr>
                  <tr>
                    <td>
                    <font size="2">&nbsp; </font>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    &nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
                      <tr>
                        <td width="25%">&nbsp;</td>
                        <td width="13%">
                        <p align="center">&nbsp;</td>
                        <td width="11%"><a href="javascript:history.go(-1)" class="LINK">cancel</a></td>
                        <td width="11%"><a href="javascript:doSave()" class="LINK">save</a></td>
                        <td width="35%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>
</html>