<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.mail.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.net.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.mail.*"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.logic.session.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.automation.tasks.reports.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String XPOTASK_ID = "ID";
	String ERROR_OBJ = "ERROR_OBJ";
	
	String Name, Description, Id;
	ArrayList idList = null;
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	String runReportVeriferTasksStr = request.getParameter("runReportVeriferTasks");
	boolean runReportVeriferTasks = (runReportVeriferTasksStr != null && runReportVeriferTasksStr.equals("true"));
	String[] ses = request.getParameterValues("To_Select_Ses");
	if(ses != null){
		idList = new ArrayList(Arrays.asList(ses));
	}
	Id = request.getParameter(XPOTASK_ID);
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
    	errmodel.addError("No Name was supplied.");
  	}

  	if(ses == null || ses.equals("")){
    	errmodel.addError("Please select reprots to run.");
  	}
  	
  	if(errmodel.getErrorCount() != 0){
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
  	}
	
	ReportTask task = null;
	XpoTaskManager taskmgr = XpoTaskManager.getInstance();
	if(Id != null && Id.length() > 0){
		task = (ReportTask)taskmgr.getXpoTaskById(Id);
	}
	if(task == null){
		task = new ReportTask();
	}
	
	task.setName(Name);
	task.setDescription(Description);
	task.setReportsIds(idList);
	task.setRunVerifierTasks(runReportVeriferTasks);
	
	taskmgr.addXpoTask(task,userContext);
	taskmgr.saveXpoTasks();
	
    //	audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "task added/edited", AuditConstants.TASKS, "report generation task added/edited " + Name);

	response.sendRedirect(BASE_DIRECTORY + "tasks/xpotasksview.jsp?taskType=report");
%>