<%@ page language="java"%>

<%@ page import="xpolog.eye.site.*" %>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.audit.AuditManager"%>
<%@ page import="xpolog.eye.audit.AuditConstants"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
	SimpleDateFormat format = new SimpleDateFormat("MM/dd/yyyy HH:mm:ss");
%>

<%
   //update menu tree
	final UserEnvironment env = UserEnvironment.getUserEnvironment(request);

	String taskId = request.getParameter("TASK_ID");
	
	String useProgressRunnerStr = request.getParameter("useProgressRunner");
	boolean useProgressRunner = useProgressRunnerStr != null && useProgressRunnerStr.equals("true");
	
	XpoTaskManager taskmgr = XpoTaskManager.getInstance();
	XpoTask task = null;
	if (taskId != null && taskId.length() > 0){
		task = taskmgr.getXpoTaskById(taskId); 
	}
	
	if (useProgressRunner){
		final XpoTask finalTask = task;
		ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "/monitor/monitorsView.jsp") {
		  public void run(HttpServletRequest request){
		  	if (finalTask != null){
		  		//audit
					AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
							env.getUserContext(), AuditConstants.CHANGE, "execute task", AuditConstants.TASKS, "execute task " + finalTask.getName() + " manually");
		  		try{
		  			finalTask.execute();
		  		}catch(Exception e){
		  			errmodel.addError("Failed to execute task " + finalTask.getName() + ":");
		  			errmodel.addError(e.getMessage());
		  			createErrorRedirect(request,BASE_DIRECTORY);
		  		}
		  	}
		  }
		};
		env.setProgressRunner(runner);
	}else{
		if(task != null) {
			//audit
			AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
					env.getUserContext(), AuditConstants.CHANGE, "execute task", AuditConstants.TASKS, "execute task " + task.getName() + " manually");
  		task.execute();
		}
	}
	
	
%>

<% if (useProgressRunner){ %>
<jsp:include page="../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Running monitor"/>
</jsp:include>
<%}%>