<%@ page language="java"%>

<%@ page import="java.util.*"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.Module"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.admin.wizards.common.scanner.WizardScannerViewControl"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.scan.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.WebUtil"%>
<%@ page import="xpolog.tools.XpologSystemInfo"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>


<%
	String PREFIX = "taskScan_";
	String ACCOUNT_TYPE = "accountType";
	String IS_SSH = "IsSsh";
	
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = BASE_DIRECTORY;
	}
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	String locationTypeDesc = "Connection Type";
	String locationType = "none";
	String displayAccDiv = "none";
	String confFileChecked = "checked";
	String directoryPathChecked = "";
  Account account = null;
  String accountId = "";
  if(account != null) {
  	accountId = account.getId();
  	displayAccDiv = "";
  }
  if(locationType.equals("auth") || locationType.equals("ssh")) {
  	displayAccDiv = "";
  }
  
  String displayLocationsDiv = "none";
  int locationsCntr = 1;
  String locationDesc = "Directory Path";
  String locationsPathsStr = "";

	String scanConfigurationFilePath = "";	
	String parentModuleId = "";
	
  String displayAdvancedDiv = "none";
  
  String filesToIncludeStr = "";
  String filesToExcludeStr = "";
  
  int scanLevel = -1;
  int scanMethod = Configuration.getInstance().getPropertiesManager().getPropertyAsInt("xpolog.eye.admin.wizards.common.scanner.scanMethodDefault",WizardScannerViewControl.SCAN_METHOD_ALL);
  int namePatternLogic = Configuration.getInstance().getPropertiesManager().getPropertyAsInt("xpolog.eye.admin.wizards.common.scanner.namePatternLogicDefault",WizardScannerViewControl.NAME_PATTERN_LOGIC_AUTO);
  
	ScanTask task = (ScanTask)request.getAttribute("CURRENT_TASK");
	String accountType = request.getParameter(ACCOUNT_TYPE);
	String isSshStr = request.getParameter(IS_SSH);
	boolean isSsh = isSshStr != null && isSshStr.equals("true");
	if(task != null){
		ScanConfiguration scanConf = task.getScanConf();
		scanConfigurationFilePath = task.getScanConfigurationFilePath();
		if (scanConfigurationFilePath == null){
			scanConfigurationFilePath = "";
		}
		locationsPathsStr = task.getScanPath();
		if (locationsPathsStr == null){
			locationsPathsStr = "";
		}
		if (scanConfigurationFilePath != null && scanConfigurationFilePath.length() > 0){
			confFileChecked = "checked";
			directoryPathChecked = "";
		}else{
			confFileChecked = "";
			directoryPathChecked = "checked";
		}
		parentModuleId = task.getParentModuleId();
		accountId = task.getAccountId();
		if (accountId != null){
			Account acc = AddressBook.getInstance().getAccountById(accountId);
			if (acc != null){
				locationType = acc.getType();
				displayAccDiv = "";
			}
		}else if (locationsPathsStr != null && locationsPathsStr.length() > 0){
			locationType = "local";
		}
		displayLocationsDiv = "";
		if (scanConf != null){
		 	filesToIncludeStr = scanConf.getFilesToInclude();
		 	if(filesToIncludeStr == null) {
		 		filesToIncludeStr = "";
		 	}
		 	filesToExcludeStr = scanConf.getFilesToExclude();
		 	if(filesToExcludeStr == null) {
		 		filesToExcludeStr = "";
		 	}
		 	scanLevel = scanConf.getSubdirsScanLevel();
	 		scanMethod = scanConf.getScanMethod();
	 		namePatternLogic = scanConf.getNamePatternLogic();
		}
	}
  if(!locationType.equals("none")) {
  	displayAdvancedDiv = "";
  }
	
	String accountListId = request.getParameter("accountListId");
	if(accountListId == null) {
		accountListId = "";
	}
	if (parentModuleId == null){
		parentModuleId = "";
	}
	
	SiteManagment mgmt = SiteManagment.getInstance();
	Module pmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
	boolean allowNewFolder = true;
	
  
	boolean hideSSHType = false;
	
%>

<script>
	var BASE_DIRECTORY = "<%=baseDirectory%>";
	var PREFIX = "<%=PREFIX%>";
	var LOCATIONS_CNTR = <%=locationsCntr%>;
	var ON_CHANGE_ACTION = "updateHostFromAccount()";
	var DISPLAY_ACCOUNTS_DIV = "<%=displayAccDiv%>";
	var ACCOUNT_ID = "<%=accountId == null ? "" : accountId %>";
	
	function openNewAccountDiv(baseDirectory){
		var accType = eval("document.access." + PREFIX + "locationType").value;
		openNewAccDiv('addAccDiv',accType,'','new',PREFIX + 'AccountsList','../');
	}
	
	function checkScannerType(type){
		if (type == 'scanConfType'){		
			document.access.scanConfType[0].checked = true;
		}else{
			document.access.scanConfType[1].checked = true;
		}
	}
	
</script>

<input type="hidden" name="MODULE_ID">
<input type="hidden" name="prefix" value="<%=PREFIX%>">

<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
	<tr>
		<td style="padding-left:15;padding-top:10">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
				<tr>
				  <td>
				  	<span class="REGULARTEXT">Enter scanner configuration file path or directory location: </span>
				  </td>
				</tr>
				<tr>
				  <td style="padding-top:10">
				  	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">	
				  		<tr>
						  	<td width="30"><input type="radio" name="scanConfType" value="configurationFile" <%=confFileChecked%>></td>
						  	<td><span class="REGULARTEXT">Enter scanner configuration file full location path</span></td>
				  		</tr>
				  	</table>
				  </td>
				</tr>
				<tr>
				  <td style="padding-top:5px">
				  	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">	
				  		<tr>
						  	<td width="30">&nbsp;</td>
						  	<td>
							    <table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
							      <!-- <tr>
							        <td><span class="REGULARTEXT">Path</span></td>
							        <td style="padding-left:5px"><input class="TEXTBOX" type="file" id="scannerConfFilePath" name="scannerConfFilePath" size="60" onClick="javascript:checkScannerType('scanConfType')"></td>
							        <td width="100%"></td>
							      </tr>-->
							      <tr>
											<td style="padding-top:2px">
												<table>
													<tr>
														<td>
															<input type="text" class="TEXTBOX"  name="<%=PREFIX%>fullPath_1" value="<%=scanConfigurationFilePath%>" id="<%=PREFIX%>fullPath_1" onKeyPress="javascript:clearFormError('<%=PREFIX%>fullPath_1', '<%=PREFIX%>Location1ErrorMsg');doOpenBrowser('<%=PREFIX%>fullPath_1','1',event,'');" size="70" value="" onClick="javascript:clearBgColor('<%=PREFIX%>fullPath_1');">
															<input type=button id="<%=PREFIX%>fileBrowseButton_1" value="Browse" onClick="clearFormError('<%=PREFIX%>fullPath_1', '<%=PREFIX%>Location1ErrorMsg');if(validateAccount()) {openBrowser('<%=PREFIX%>fullPath_1','1','')}">
														</td>
													</tr>
													<tr>
														<td style="padding-top:3">
															<div id="<%=PREFIX%>Location1ErrorMsg" style="display:none;" class="ERROR_MSG">
															</div>			        			        
														</td>
													</tr>
												</table>
											</td>
										</tr>
							      
							    </table>
								</td>
				  		</tr>
				  	</table>
				  </td>
				</tr>
				<!-- Start scanPath -->
				<tr>
				  <td style="padding-top:10px">
				  	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">	
				  		<tr>
						  	<td width="30"><input type="radio" name="scanConfType" value="directoryPath" <%=directoryPathChecked%>></td>
						  	<td><span class="REGULARTEXT">Enter location of directory</span></td>
				  		</tr>
				  	</table>
				  </td>
				</tr>
				<tr>
				  <td style="padding-top:5px">
				  	<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">	
				  		<tr>
						  	<td width="30">&nbsp;</td>
						  	<td>
							    <table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
										<tr>				
											<td>
												<div id="<%=PREFIX%>locationTypeDiv"> 			                    			                   
												<table border="0" cellpadding="0" cellspacing="0" width="100%">
													<tr>
														<td width="13%"><span class="REGULARTEXT"><%=locationTypeDesc %></span></td>
														<td width="87%">
															<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
																<tr>
																	<td>
																		<select class="TEXTBOX" id="<%=PREFIX%>locationType" name="<%=PREFIX%>locationType" onChange="javascript:changeLocationType('<%=PREFIX %>',this.name,'<%=baseDirectory%>');javascript:checkScannerType('directoryPath')">
																			<option value="none" <%=locationType.equals("none") ? "selected" : "" %>>-- Select Location --</option>														
																			<option value="local" <%=locationType.equals("local") ? "selected" : "" %>>Local</option>
																			<%if (XpologSystemInfo.isWindows()){%>														
																			<option value="auth" <%=locationType.equals("auth") ? "selected" : "" %>>Windows Network</option>
																			<%}%>
																			<%if (!hideSSHType){%>														
																			<option value="ssh" <%=locationType.equals("ssh") ? "selected" : "" %>>Over SSH</option>
																			<%}%>
																		</select>			
																	</td>
																</tr>																																															
															</table>
														</td>
													</tr>
													<tr>
														<td colspan="2" style="padding-top:3">
															<div id="<%=PREFIX%>locationTypeErrorMsg" style="display:none;" class="ERROR_MSG">
															</div>
														</td>
													</tr>
												</table>
												</div>
											</td>
										</tr>
										
										<tr>
											<td style="padding-top:3px">
												<div id="<%=PREFIX%>accountDiv" style="display:<%=displayAccDiv %>"> 			                   
												<table border="0" cellpadding="0" cellspacing="0" width="100%">                                        
													<tr>
														<td width="13%"><span class="REGULARTEXT">Connection Details</span></td>
														<td width="87%">
															<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
																<tr>
																	<td width="100px">
																		<div id="<%=PREFIX%>accountsListDiv">
																			<%
																			String accountsListUrl = BASE_DIRECTORY + "common/accountsListCombo.jsp";
																			%>
																			<jsp:include flush="true" page="<%=accountsListUrl %>">
																				<jsp:param name="ACC_TYPE" value="<%=locationType%>"/>
																				<jsp:param name="ACC_ID" value="<%=accountId%>"/>
																				<jsp:param name="CHANGE_ACC_SELECTION" value="false"/>
																				<jsp:param name="PREFIX" value="<%=PREFIX%>"/>
																			</jsp:include> 																								
																		</div>														                        
																	</td>
																	<%if(userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)) { %>
																	<td style="padding-left:5">
																		<div id="<%=PREFIX%>newAccountDiv">
																			<span class="SMALLTEXT"><a href="javascript:openNewAccountDiv('../')" class="BUTTON_MEDIUMLINK">new</a></span>
																		</div>	
																	</td>
																	<%} %>
																	<td width="*">&nbsp;</td>
																</tr>
															</table>
														</td>
													</tr>
													<tr>
														<td colspan="2" style="padding-top:2px">
															<div id="<%=PREFIX%>AccountIdErrorMsg" style="display:none;" class="ERROR_MSG">
															</div>
														</td>
													</tr>
												</table>
												</div>  
											</td>
										</tr>
										
										<tr>
											<td style="padding-top:2px">
												<div id="<%=PREFIX%>locationPathsDiv" style="display:<%=displayLocationsDiv%>">
													<%
													String locationPathUrl = BASE_DIRECTORY + "common/accountsListCombo.jsp";
													%> 
													<jsp:include flush="true" page="locationPath.jsp">
														<jsp:param name="baseDirectory" value="" />
														<jsp:param name="LOCATIONS_CNTR" value="<%=locationsCntr%>"/>
														<jsp:param name="LOCATION_DESC0" value="<%=locationDesc%>"/>
														<jsp:param name="LOCATIONS_PATH_ARR" value="<%=locationsPathsStr%>"/>
														<jsp:param name="PREFIX" value="<%=PREFIX%>"/>										
														<jsp:param name="FILE_FILTER0" value="dirOnly"/>										
													</jsp:include>	                      
												</div>
											</td>
										</tr>
										<!-- End scanPath -->
							    </table>
								</td>
				  		</tr>
				  	</table>
				  </td>
				</tr>

				<tr>
					<td width="15%" height="18" style="padding-top:10">
						<jsp:include page="../../common/selectParentModule.jsp" flush="true">
						<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
						<jsp:param name="PARENT_MODULE_ID" value="<%=parentModuleId%>" />
						<jsp:param name="allowNewFolder" value="<%=allowNewFolder %>" />
						<jsp:param name="titleColWidth" value="10%" />
						<jsp:param name="height" value="500px"/>
						</jsp:include>
					</td>
				</tr>
				
				
				<!-- Advanced start -->
				<tr>
					<td style="padding-top:30">
						<div id="<%=PREFIX%>advancedSettingsDiv">																				
							<table border="0" cellpadding="0" cellspacing="0" width="100%">
								<tr>
									<td>																										
										<table border="0" cellpadding="0" cellspacing="0" width="100%" class="ADV_SETTINGS_BAR_HEADER">
											<tr>
												<td>																										
													<jsp:include page="../../common/adminSectionHeader.jsp" flush="true">
														<jsp:param name="baseDirectory" value="<%=baseDirectory %>" />
														<jsp:param name="suffix" value="advancedSettings" />				
														<jsp:param name="headerName" value="Advanced Settings" />
														<jsp:param name="startOpen" value="false" />
														<jsp:param name="showCheckBox" value="false" />
														<jsp:param name="closeOthers" value="false" />
														<jsp:param name="openOnClick" value="true" />
													</jsp:include>
												</td>
											</tr>
										</table>
									</td>
								</tr>
								<tr>
									<td>
										<table border="0" id="adminHeaderContentadvancedSettings" cellpadding="0" cellspacing="0" style="display:none" width="100%" class="ADV_SETTINGS_TABLE">																				
											<tr valign="top">
												<td style="padding-left:20;border-top:1 solid white">
													<div id="<%=PREFIX%>advFilesFilters">																				
														<table border="0" cellpadding="0" cellspacing="0" width="100%">
															<tr>
																<td>																										
																	<table border="0" cellpadding="0" cellspacing="0" width="100%" class="ADV_SETTINGS_BAR">
																		<tr>
																			<td>																										
																				<jsp:include page="../../common/adminSectionHeader.jsp" flush="true">
																					<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
																					<jsp:param name="suffix" value="FilesFilters" />
																					<jsp:param name="level" value="1" />
																					<jsp:param name="headerName" value="Files Filters" />
																					<jsp:param name="startOpen" value="false" />
																					<jsp:param name="showCheckBox" value="false" />
																					<jsp:param name="closeOthers" value="false" />
																					<jsp:param name="openOnClick" value="true" />
																				</jsp:include>
																			</td>
																		</tr>
																	</table>
																</td>
															</tr>
															<tr>
																<td>																										
																	<table border="0" id="adminHeaderContentFilesFilters" cellpadding="0" cellspacing="0" style="display:none" width="100%" class="ADV_SETTINGS_TABLE">
																		<tr>
																			<td width="24" style="padding-top:5">&nbsp;</td>
																			<td width="200"><span class="REGULARTEXT">Include files:</span></td>
																			<td width="200">
																				<input class="TEXTBOX" type="text" id="includeFiles" name="includeFiles" size="30" value="<%=filesToIncludeStr%>">
																			</td>
																			<td width="*">&nbsp;<span class="SMALLTEXT">comma separated list</span></td>
																		</tr>
																		<tr>
																			<td style="padding-top:5">&nbsp;</td>
																			<td><span class="REGULARTEXT">Exclude files:</span></td>
																			<td>
																				<input class="TEXTBOX" type="text" id="excludeFiles" name="excludeFiles" size="30" value="<%=filesToExcludeStr%>">
																			</td>
																			<td>&nbsp;<span class="SMALLTEXT">comma separated list</span></td>
																		</tr>
																		<tr>
																			<td style="padding-top:5">&nbsp;</td>
																			<td><span class="REGULARTEXT">Subdirectories levels to scan:</span></td>
																			<td>
																				<select id="subDirLevel" name="subDirLevel" class="TEXT_BOX" size="1">
																					<option value="1000" selected>Unlimited</option>
																					<%
																					for(int i=1 ; i < 11 ; i++){
																						String selected = i == scanLevel ? "selected" : "";
																					%>
																						<option value="<%=String.valueOf(i)%>" <%=selected%>><%=String.valueOf(i)%></option>
																					<%
																					}
																					%>
																				</select>	
																			</td>
																			<td>&nbsp;</td>
																		</tr>
																	</table>
																</td>
															</tr>																						
														</table>			
													</div>
												</td>													                      
											</tr>
											
											<tr valign="top">
												<td style="padding-left:20;border-top:1 solid white">
													<div id="<%=PREFIX%>advScanMethod">																				
														<table border="0" cellpadding="0" cellspacing="0" width="100%">
															<tr>
																<td>																										
																	<table border="0" cellpadding="0" cellspacing="0" width="100%" class="ADV_SETTINGS_BAR">
																		<tr>
																			<td>																										
																				<jsp:include page="../../common/adminSectionHeader.jsp" flush="true">
																					<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
																					<jsp:param name="suffix" value="ScanMethod" />
																					<jsp:param name="level" value="1" />
																					<jsp:param name="headerName" value="Scan Method" />
																					<jsp:param name="startOpen" value="false" />
																					<jsp:param name="showCheckBox" value="false" />
																					<jsp:param name="closeOthers" value="false" />
																					<jsp:param name="openOnClick" value="true" />
																				</jsp:include>
																			</td>
																		</tr>
																	</table>
																</td>
															</tr>
															<tr>
																<td>																										
																	<table border="0" id="adminHeaderContentScanMethod" cellpadding="0" cellspacing="0" style="display:none" width="100%" class="ADV_SETTINGS_TABLE">
																		<tr>
																			<td width="24">&nbsp;</td>
																			<td width="*">
																				<input id="scanMethod" name="scanMethod" type="radio" value="<%=WizardScannerViewControl.SCAN_METHOD_ALL %>" <%=scanMethod == WizardScannerViewControl.SCAN_METHOD_ALL ? "checked" : "" %>><span class="REGULARTEXT">Use existing configuration (file names and content) and automatic matching</span>
																			</td>
																		</tr>
																		<tr>
																			<td width="24">&nbsp;</td>
																			<td width="*">
																				<input id="scanMethod" name="scanMethod" type="radio" value="<%=WizardScannerViewControl.SCAN_METHOD_ONLY_TEMPLATES %>" <%=scanMethod == WizardScannerViewControl.SCAN_METHOD_ONLY_TEMPLATES ? "checked" : "" %>><span class="REGULARTEXT">Use existing configuration (file names and content)</span>
																			</td>
																		</tr>
																		<tr>
																			<td width="24">&nbsp;</td>
																			<td width="*">
																				<input id="scanMethod" name="scanMethod" type="radio" value="<%=WizardScannerViewControl.SCAN_METHOD_ONLY_FILE_NAME %>" <%=scanMethod == WizardScannerViewControl.SCAN_METHOD_ONLY_FILE_NAME ? "checked" : "" %>><span class="REGULARTEXT">Use existing configuration (file names only)</span>
																			</td>
																		</tr>
																	</table>
																</td>
															</tr>																						
														</table>			
													</div>
												</td>													                      
											</tr>
											
											
											
											
											<tr valign="top">
												<td style="padding-left:20;border-top:1 solid white">
													<div id="<%=PREFIX%>advNamePattern">																				
														<table border="0" cellpadding="0" cellspacing="0" width="100%">
															<tr>
																<td>																										
																	<table border="0" cellpadding="0" cellspacing="0" width="100%" class="ADV_SETTINGS_BAR">
																		<tr>
																			<td>																										
																				<jsp:include page="../../common/adminSectionHeader.jsp" flush="true">
																					<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
																					<jsp:param name="suffix" value="NamePattern" />
																					<jsp:param name="level" value="1" />
																					<jsp:param name="headerName" value="Files Name Pattern" />
																					<jsp:param name="startOpen" value="false" />
																					<jsp:param name="showCheckBox" value="false" />
																					<jsp:param name="closeOthers" value="false" />
																					<jsp:param name="openOnClick" value="true" />
																				</jsp:include>
																			</td>
																		</tr>
																	</table>
																</td>
															</tr>
															<tr>
																<td>																										
																	<table border="0" id="adminHeaderContentNamePattern" cellpadding="0" cellspacing="0" style="display:none" width="100%" class="ADV_SETTINGS_TABLE">
																		<tr>
																			<td width="24">&nbsp;</td>
																			<td width="*">
																				<input id="namePatternLogic" name="namePatternLogic" type="radio" value="<%=WizardScannerViewControl.NAME_PATTERN_LOGIC_AUTO %>" <%=namePatternLogic == WizardScannerViewControl.NAME_PATTERN_LOGIC_AUTO ? "checked" : "" %>><span class="REGULARTEXT">Unite files with similar names (apply name pattern automatically)</span>
																			</td>
																		</tr>
																		<tr>
																			<td width="24">&nbsp;</td>
																			<td width="*">
																				<input id="namePatternLogic" name="namePatternLogic" type="radio" value="<%=WizardScannerViewControl.NAME_PATTERN_LOGIC_NONE %>" <%=namePatternLogic == WizardScannerViewControl.NAME_PATTERN_LOGIC_NONE ? "checked" : "" %>><span class="REGULARTEXT">Capture each file separately &nbsp;(without name pattern)</span>
																			</td>
																		</tr>																											
																	</table>
																</td>
															</tr>																						
														</table>			
													</div>
												</td>													                      
											</tr>
											
											
										</table>
									</td>
								</tr>
							</table>
						</div>
					</td>
				</tr>
				<!-- Advanced end -->

			  <!--<tr height="10">
          <td style="padding-top:20" colspan="2">
          	<span class="SMALLTEXT">* marks a manadatory field</span>
          </td>
        </tr>-->
			  <tr height="100%">
			  	<td>&nbsp;</td>
			  </tr>
			</table>
		</td>
	</tr>
</table>