<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.automation.tasks.logic.session.SessionResultTask"%>
<%@ page import="xpolog.eye.automation.tasks.XpoTaskManager"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.logic.ConfigMgr"%>
<%@ page import="xpolog.logic.ui.ctrl.CtrlMgr"%>
<%@ page import="xpolog.logic.ui.ctrl.RootWorkspace"%>
<%@ page import="xpolog.logic.ui.ctrl.Workspace"%>
<%@ page import="xpolog.logic.ui.util.WorkspaceRenderer"%>

<%@ page import="java.util.*"%>


<%

	String	TYPE_WORKSPACE = "Workspace";
	String TYPE_PROJECT = "DataSession";

	SiteManagment mgmt = SiteManagment.getInstance();
	UserContext userContext = UserEnvironment.getUserContext(request);
	CtrlMgr ctrlMgr = ConfigMgr.getInstance().getCtrlMgr();
	
  RootWorkspace rootWorkspace = new RootWorkspace();
  rootWorkspace.setName("Workspaces");
  rootWorkspace.setId("Workspaces");
  Workspace[] workspaces = ctrlMgr.getWorkspaces(userContext);
  for (int i=0; i<workspaces.length; i++){
  	rootWorkspace.addDataSessionId(workspaces[i].getId());
  }

  HashMap selectedWsMap = null;
  HashMap selectedProjMap =  null;
  
  SessionResultTask task = null;
  String taskId = request.getParameter("taskId");
  if(taskId != null && taskId.length() > 0) {
  	XpoTaskManager taskmgr = XpoTaskManager.getInstance();
		task = (SessionResultTask)taskmgr.getXpoTaskById(taskId); 
  }
  if(task != null) {
  	selectedWsMap = new HashMap();
  	selectedWsMap.put(task.getWorkspaceId(), task.getWorkspaceId());
  	
    selectedProjMap =  new HashMap();
    List sessionIds = task.getSessionsIds();
    for(int i = 0; i < sessionIds.size(); i++) {
    	selectedProjMap.put(sessionIds.get(i), sessionIds.get(i));
    }
  }
  String rootId = request.getParameter("rootId");
  if (rootId == null){
  	rootId = "0";  	
  }
	
	WorkspaceRenderer renderer = new WorkspaceRenderer(userContext, selectedWsMap,selectedProjMap,null, rootId);
	renderer.setProjectSelectOnly(true);
	renderer.setShowTransactions(false);
	renderer.setShowMonitorWS(false);
	
	String type = "";
	String treeXml = ""; 
  String id = request.getParameter("id");
  if (id != null){
  	String objid = id;
  	int ind = id.indexOf("-");
  	if (ind != -1){
  		objid = id.substring(ind+1);
  		type = id.substring(0,ind);
			if(type.equals(TYPE_WORKSPACE)){
				Workspace currWorkspace = ctrlMgr.getWorkspaceById(objid);
				if(currWorkspace != null){
				renderer.setWorkspace(currWorkspace);
				treeXml = renderer.getWorkspaceTreeXML();
				}else{
					treeXml = "";
				}
			}
			/*if(type.equals(TYPE_PROJECT)){
				DataSession currProject = ctrlMgr.getDataSessionById(objid);
				renderer.setProject(currProject);
				treeXml = renderer.getProjectTreeXML();
			}*/	
  	}

  }else{ //roootWS
  	renderer.setRootWorkspace(rootWorkspace);
  	treeXml = renderer.getRootTreeXML();
  }
	response.setContentType("text/xml");
	out.write(treeXml);
	out.flush();

%>
