<%@ page language="java"%>

<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.sms.*"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.sms.*"%>
<%!
  static final String BASE_DIRECTORY = "../../";
%>


<%
	String TASK_ID = "ID";
	String DUPLICATE = "DUPLICATE";
	String ERROR_OBJ = "ERROR_OBJ";
	String id = request.getParameter(TASK_ID);
	String duplicateStr = request.getParameter(DUPLICATE);
	boolean duplicate = duplicateStr != null && duplicateStr.equals("true");
	
	String sms_acc_id = "";
	String name = "";
	String description = "";
	String port = "22";
	String user = "";
	String password = "";
	String smsMess = "";
	
	if(id != null){
		XpoTaskManager taskmgr = XpoTaskManager.getInstance();
	  SmsTask task = (SmsTask)taskmgr.getXpoTaskById(id);
	  if(!duplicate) {
			name = task.getName();
	  }
		description = task.getDescription();
		sms_acc_id = task.getSmsAccountId();
		smsMess = task.getSmsMessage();
	}else{
		id = "";
	}

    SmsAccountFilter filter = new SmsAccountFilter();
    AddressBook adbook = AddressBook.getInstance();
    List list = adbook.getAccountsByFilter(filter);
	if(list.size() == 0) {
	  	//No accounts defined in system
	  	ErrorModel errmodel = new ErrorModel();
	  	errmodel.addError("There is no Sms account defined, Please <a href=\"" + BASE_DIRECTORY + "tools/addresses/sms/accountSms.jsp\">create Sms account</a> first.");
	  	request.getSession().setAttribute(ERROR_OBJ,errmodel);
	    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
	    return;
  	}
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
      function doSave(){
        document.access.action ="taskSmsAction.jsp";
        document.access.submit();
      }

</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="33%" class="TOPBORDER">
                <span class="PAGEHEADER">SMS </span> <span class="PAGEHEADER">Task</span> </td>
                <td width="44%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%" >&nbsp;</td>
                <td colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">SMS </span><span class="HEADER">details</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" >
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" >
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">Name</span></td>
                        <td width="69%">
                        <input class="TEXTBOX" type="text" name="Name" size="50" value="<%=name%>"></td>
                      </tr>
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">Description</span></td>
                        <td width="69%">
                        <input class="TEXTBOX" type="text" name="Description" size="50" value="<%=description%>"></td>
                      </tr>
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">SMS Account</span></td>
                        <td width="69%">
                        <select class="TEXTBOX" size="1" name="SmsAccountId">
                        <% 
                        	for(int i=0;i<list.size();++i){
                        		Account acc = (Account)list.get(i);
                        		String accSelected = acc.getId().equals(sms_acc_id) ? " selected" : "";
                        %> 
                        <option value="<%=acc.getId()%>"<%=accSelected%>><%=acc.getAccountName()%></option>
                        <% 
                        	}
                        %>
                        </select> <a href="javascript:goNew()" class="LINK">new</a></td>
                      </tr>
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">Message</span></td>
                        <td width="69%"><input class="TEXTBOX" type="hidden" name="Id" size="10" value="<%=duplicate ? "" : id%>"><input class="TEXTBOX" type="text" name="SmsMessage" size="50" value="<%=smsMess%>"></td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td width="15%" height="21">
                    &nbsp;</td>
                  </tr>
                  <!--
                  <tr>
                    <td><b><i>Log context pattern</i></b></td>
                  </tr>-->
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td>
                    <font size="2">&nbsp; </font>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    &nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="101%" >
                      <tr>
                        <td width="25%">&nbsp;</td>
                        <td width="13%">
                        <p align="center">&nbsp;</td>
                        <td width="11%"><a href="javascript:history.go(-1)" class="LINK">cancel</a></td>
                        <td width="11%"><a href="javascript:doSave()" class="LINK">save</a></td>
                        <td width="35%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>