
var snmpAlertSuffix = "SNMPAlert";
var SNMP_PREFIX = "snmp_";

var snmpTaskVariablesTypesValues = new Array();
snmpTaskVariablesTypesValues = ['-1', 'TRAP_TIME', 'LOG_TIME', 'TIME', 'TEXT', 'INTEGER', 'UNSIGNED_INTEGER', 'IP_ADDRESS', 'STATUS', 'COUNTER_32', 'COUNTER_64', 'GAUGE_32', 'SMI_ADDRESS', 'TCP_ADDRESS', 'TIME_TICKS', 'UDP_ADDRESS'];
var snmpTaskVariablesTypesTexts = new Array();
snmpTaskVariablesTypesTexts = ['--- Select type ---', 'Trap Time', 'Log Time', 'Time', 'Text', 'Integer 32', 'Unsigned Integer 32', 'IP Address', 'Status', 'Counter 32', 'Counter 64', 'Gauge 32', 'SMI Address', 'TCP Address', 'Time ticks', 'UDP Address'];

function snmpNewAccount(){
	openNewAccDiv('addAccDiv','snmp','','new',SNMP_PREFIX + 'AccountsList','../');
}

function doSaveSnmpTask() {
  document.access.action = "taskSnmpAction.jsp";
  document.access.submit();
}
  
function showHideAddNewVariables(index) {
	var addNewVariablesDiv = document.getElementById("addNewVariablesDiv" + snmpAlertSuffix);
	var addNewVariablesLink = document.getElementById("newVariablesLink" + snmpAlertSuffix);
	var display = addNewVariablesDiv.style.display;
	if(display == "none"){
		addNewVariablesDiv.style.display  = "";
		addNewVariablesLink.innerHTML = "Hide"; 
	}else {
		addNewVariablesDiv.style.display  = "none";
		addNewVariablesLink.innerHTML = "Add new variables"; 
	}
}

function changeVariable(index) {
	document.getElementById("newVariableSelectionTypePredefined" + snmpAlertSuffix).checked = true;
	document.getElementById("newVariableSelectionTypeCustom" + snmpAlertSuffix).checked = false;
	if(index == 0) {
		document.getElementById("newVariableOid" + snmpAlertSuffix).value = "";
		document.getElementById("newVariableName" + snmpAlertSuffix).value = "";
		document.getElementById("newVariableDescription" + snmpAlertSuffix).value = "";
		document.getElementById("newVariableType" + snmpAlertSuffix).selectedIndex = 0;
		document.getElementById("newVariableMessage" + snmpAlertSuffix).value = "";
	}else {
		document.getElementById("newVariableOid" + snmpAlertSuffix).value = predefinedSnmpTaskVariablesOids[index - 1];
		document.getElementById("newVariableName" + snmpAlertSuffix).value = predefinedSnmpTaskVariablesNames[index - 1];
		document.getElementById("newVariableDescription" + snmpAlertSuffix).value = predefinedSnmpTaskVariablesDescriptions[index - 1];
		for(var i = 1; i < document.getElementById("newVariableType" + snmpAlertSuffix).options.length; i++) {
			if(document.getElementById("newVariableType" + snmpAlertSuffix).options[i].value == predefinedSnmpTaskVariablesTypes[index - 1]) {
				document.getElementById("newVariableType" + snmpAlertSuffix).selectedIndex = i;
				break;
			}
		}
		document.getElementById("newVariableMessage" + snmpAlertSuffix).value = predefinedSnmpTaskVariablesMessages[index - 1];
	}
	handleTimeType(document.getElementById("newVariableType" + snmpAlertSuffix), document.getElementById("newVariableMessage" + snmpAlertSuffix));
}

function handleTimeType(select, text) {
	/*if(select.value == 0) {
		text.value = "[TRAP_TIME]";
		text.readOnly = true;
	}else if(select.value == 1) {
		text.value = "[LOG_TIME]";
		text.readOnly = true;
	}else {
		text.value = "";
		text.readOnly = false;
	}*/
}

function addNewVariable() {
	if(document.getElementById("newVariableOid" + snmpAlertSuffix).value == "") {
		alert("OID was not specified");
		return;
	}else if(document.getElementById("newVariableName" + snmpAlertSuffix).value == "") {
		alert("Name was not specified");
		return;
	}else if(document.getElementById("newVariableType" + snmpAlertSuffix).selectedIndex == 0) {
		alert("Type was not specified");
		return;
	}

	var numOfVariables = document.getElementById("numOfVariables" + snmpAlertSuffix);
	num = parseInt(numOfVariables.value) + 1;
	var maxVariableIndex = document.getElementById("maxVariableIndex" + snmpAlertSuffix);
	max = parseInt(maxVariableIndex.value) + 1;
	
	var newDiv = document.createElement('div');
	newDiv.setAttribute("id", "variable" + max + "Div" + snmpAlertSuffix);
	
	var html = '  <table border="0" cellpadding="0" cellspacing="0" width="100%" >' + 
		         '    <tr>' + 
		         '    <input type="hidden" name="variable' + max + 'Visible' + snmpAlertSuffix + '" value="true">' +
						 '      <td width="110"><input class="TEXTBOX" type="text" name="variableOid' + max + snmpAlertSuffix + '" size="15" value="' + document.getElementById("newVariableOid" + snmpAlertSuffix).value + '">' + 
						 '      <td width="110"><input class="TEXTBOX" type="text" name="variableName' + max + snmpAlertSuffix + '" size="15" value="' + document.getElementById("newVariableName" + snmpAlertSuffix).value + '">' + 
						 '      <td width="110"><input class="TEXTBOX" type="text" name="variableDescription' + max + snmpAlertSuffix + '" size="15" value="' + document.getElementById("newVariableDescription" + snmpAlertSuffix).value + '">' + 
						 '			<td width="160">' +
		         '	     	<select class="TEXTBOX" name="variableType' + max + snmpAlertSuffix + '" size="1">';
	var selectedType = document.getElementById("newVariableType" + snmpAlertSuffix).value;
	for(var i = 0; i < snmpTaskVariablesTypesValues.length; i++) {
		var selected = "";
		if(selectedType == snmpTaskVariablesTypesValues[i]) {
			selected = "selected";
		}else {
			selected = "";
		}
		html +=  '               		<option value="' + snmpTaskVariablesTypesValues[i] + '" ' + selected + '>' + snmpTaskVariablesTypesTexts[i] + '</option>';
	}
	html +=    '               	</select>' +
		         '               </td>' +
						 '      <td width="110"><input class="TEXTBOX" type="text" name="variableMessage' + max + snmpAlertSuffix + '" size="15" value="' + document.getElementById("newVariableMessage" + snmpAlertSuffix).value + '">' + 
						 '      <td width="*" style="padding-left:5px"><a href="javascript:removeVariable(' + max + ')" class="LINK">Remove</a></td>' + 
						 '    </tr>' + 
		         '  </table>'; 
	newDiv.innerHTML = html;
	var variablesDiv = document.getElementById("variablesDiv" + snmpAlertSuffix);
	variablesDiv.appendChild(newDiv);
	
	numOfVariables.value = num;
	maxVariableIndex.value = max;
}

function removeVariable(index) {
	var variableDiv = document.getElementById("variable" + index + "Div" + snmpAlertSuffix);
	variableDiv.style.display = "none";
	
	var numOfVariables = document.getElementById("numOfVariables" + snmpAlertSuffix);
	num = parseInt(numOfVariables.value) - 1;
	numOfVariables.value = num;
	
	var variableVisible = document.getElementById("variable" + index + "Visible" + snmpAlertSuffix);
	variableVisible.value = "false";
}

function updateFromSNMPTask(){
}