<%@ page language="java"%>

<%@ page import="java.util.*"%>

<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.snmp.*"%>
<%@ page import="xpolog.eye.media.snmp.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%!
  static final String BASE_DIRECTORY = "../../";
%>


<%

	String PREFIX = "snmp_";

	String scriptsOnlyStr = request.getParameter("scriptsOnly");
	boolean scriptsOnly = scriptsOnlyStr != null && scriptsOnlyStr.equals("true");
	
	String noScriptsStr = request.getParameter("noScripts");
	boolean noScripts = noScriptsStr != null && noScriptsStr.equals("true");
	
	String embeddedStr = request.getParameter("embedded");
	boolean embedded = embeddedStr != null && embeddedStr.equals("true");
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String snmpTaskLabel = request.getParameter("snmpTaskLabel");
	if (snmpTaskLabel == null || snmpTaskLabel.length() == 0){
		snmpTaskLabel = "SNMP Trap Task";
	}
	String existingTasksLabel = request.getParameter("existingTasksLabel");
	if (existingTasksLabel == null || existingTasksLabel.length() == 0){
		existingTasksLabel = "Existing SNMP Tasks";
	}
	
	String existingTasksNote = request.getParameter("existingTasksNote");
	if (existingTasksLabel == null || existingTasksLabel.length() == 0){
		existingTasksNote = "copy details from existing SNMP Trap task";
	}
	String snmpTasksListStr = (String)request.getParameter("tasks");
	String[] snmpTasks = null;
	if (snmpTasksListStr != null){
		snmpTasks = snmpTasksListStr.split("#");
	}
	
	String onlyUpdateStr = request.getParameter("onlyUpdate");
	boolean onlyUpdate = onlyUpdateStr != null && onlyUpdateStr.equals("true");
	
	String TASK_ID = "ID";
	String DUPLICATE = "DUPLICATE";
	String ERROR_OBJ = "ERROR_OBJ";
	String id = request.getParameter(TASK_ID);
	String duplicateStr = request.getParameter(DUPLICATE);
	boolean duplicate = duplicateStr != null && duplicateStr.equals("true");
	
	String name = "";
	String description = "";
	String snmpAccId = "";
	String snmpOid = "";
	String snmpCommunity = "";
	
	SNMPTaskVariable[] snmpTaskVariables = null, predefinedSnmpTaskVariables = null;
	
	XpoTask sessionTask = (XpoTask)request.getSession().getAttribute("XpoTask");
	request.getSession().removeAttribute("XpoTask");
	SNMPTask task = null;
	if (sessionTask instanceof SNMPTask){
		task = (SNMPTask)sessionTask;
	}
	if(id != null){
		XpoTaskManager taskmgr = XpoTaskManager.getInstance();
		task = (SNMPTask)taskmgr.getXpoTaskById(id); 
	}else{
		id = "";
	}
	if (task != null){
		if(!duplicate) {
			name = task.getName();
		}
		description = task.getDescription() != null ? task.getDescription() : "";
		snmpAccId = task.getSnmpAccountId();
		snmpOid = task.getSnmpOid() != null ? task.getSnmpOid() : "";
		snmpCommunity = task.getSnmpCommunity() != null ? task.getSnmpCommunity() : "";
		snmpTaskVariables = task.getSnmpTaskVariables();
		id = task.getId();
	}
	
	SNMPConfiguration snmpConfig = new SNMPConfiguration();
	snmpConfig.loadPredefinedSnmpTaskVariables();
	predefinedSnmpTaskVariables = snmpConfig.getPredefinedSnmpTaskVariables();
	String predefinedSnmpTaskVariablesOids = "", predefinedSnmpTaskVariablesNames = "", predefinedSnmpTaskVariablesDescriptions = "", predefinedSnmpTaskVariablesTypes = "", predefinedSnmpTaskVariablesMessages = "";
	if(predefinedSnmpTaskVariables != null && predefinedSnmpTaskVariables.length > 0) {
		for(int i = 0; i < predefinedSnmpTaskVariables.length; i++) {
			predefinedSnmpTaskVariablesOids += ("\"" + predefinedSnmpTaskVariables[i].getOid() + "\"");
			predefinedSnmpTaskVariablesNames += ("\"" + predefinedSnmpTaskVariables[i].getName() + "\"");
			predefinedSnmpTaskVariablesDescriptions += ("\"" + predefinedSnmpTaskVariables[i].getDescription() + "\"");
			predefinedSnmpTaskVariablesTypes += ("\"" + predefinedSnmpTaskVariables[i].getType() + "\"");
			predefinedSnmpTaskVariablesMessages += ("\"" + predefinedSnmpTaskVariables[i].getMessage() + "\"");
			if(i < predefinedSnmpTaskVariables.length - 1) {
				predefinedSnmpTaskVariablesOids += ", ";
				predefinedSnmpTaskVariablesNames += ", ";
				predefinedSnmpTaskVariablesDescriptions += ", ";
				predefinedSnmpTaskVariablesTypes += ", ";
				predefinedSnmpTaskVariablesMessages += ", ";
			}
		}
		predefinedSnmpTaskVariablesOids = "[" + predefinedSnmpTaskVariablesOids + "]";
		predefinedSnmpTaskVariablesNames = "[" + predefinedSnmpTaskVariablesNames + "]";
		predefinedSnmpTaskVariablesDescriptions = "[" + predefinedSnmpTaskVariablesDescriptions + "]";
		predefinedSnmpTaskVariablesTypes = "[" + predefinedSnmpTaskVariablesTypes + "]";
		predefinedSnmpTaskVariablesMessages = "[" + predefinedSnmpTaskVariablesMessages + "]";
	}
	
	SNMPAccountFilter filter = new SNMPAccountFilter();
  AddressBook adbook = AddressBook.getInstance();
  List list = adbook.getAccountsByFilter(filter);
	/*if(list.size() == 0) {
	  	//No accounts defined in system
	  	ErrorModel errmodel = new ErrorModel();
	  	errmodel.addError("There is no SNMP account defined, Please <a href=\"../tools/addresses/snmp/accountSnmp.jsp\">create SNMP account</a> first.");
	  	request.getSession().setAttribute(ERROR_OBJ,errmodel);
	    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
	    return;
  	}*/
	
	String[] snmpTaskVariablesTypesValues = new String[]{"-1", SNMPTask.VARIABLE_TRAP_TIME_TYPE, 
			SNMPTask.VARIABLE_LOG_TIME_TYPE, SNMPTask.VARIABLE_TIME_TYPE, SNMPTask.VARIABLE_TEXT_TYPE, 
			SNMPTask.VARIABLE_INTEGER_TYPE, SNMPTask.VARIABLE_UNSIGNED_INTEGER_TYPE, 
			SNMPTask.VARIABLE_IP_ADDRESS_TYPE, SNMPTask.VARIABLE_STATUS_TYPE, SNMPTask.VARIABLE_COUNTER_32_TYPE, 
			SNMPTask.VARIABLE_COUNTER_64_TYPE, SNMPTask.VARIABLE_GAUGE_32_TYPE, SNMPTask.VARIABLE_SMI_ADDRESS_TYPE, 
			SNMPTask.VARIABLE_TCP_ADDRESS_TYPE, SNMPTask.VARIABLE_TIME_TICKS_TYPE, SNMPTask.VARIABLE_UDP_ADDRESS_TYPE
			};
	
	String[] snmpTaskVariablesTypesTexts = new String[]{"--- Select type ---", "Trap Time", "Log Time", "Time",
			"Text", "Integer 32", "Unsigned Integer 32", "IP Address", "Status", "Counter 32", "Counter 64",
			"Gauge 32", "SMI Address", "TCP Address", "Time ticks", "UDP Address"
			};

  UserContext userContext = UserEnvironment.getUserContext(request);
%>

<%if (!embedded){%>
<html>
<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<%} %>

<script>
		
		var predefinedSnmpTaskVariablesOids = new Array();
		var predefinedSnmpTaskVariablesNames = new Array();
		var predefinedSnmpTaskVariablesDescriptions = new Array();
		var predefinedSnmpTaskVariablesTypes = new Array();
		var predefinedSnmpTaskVariablesMessages = new Array();
		<%
		if(predefinedSnmpTaskVariables != null && predefinedSnmpTaskVariables.length > 0) {
			//for(int i = 0; i < predefinedSnmpTaskVariables.length; i++) {
		%>
			predefinedSnmpTaskVariablesOids = <%=predefinedSnmpTaskVariablesOids %>;
			predefinedSnmpTaskVariablesNames = <%=predefinedSnmpTaskVariablesNames %>;
			predefinedSnmpTaskVariablesDescriptions = <%=predefinedSnmpTaskVariablesDescriptions %>;
			predefinedSnmpTaskVariablesTypes = <%=predefinedSnmpTaskVariablesTypes %>;
			predefinedSnmpTaskVariablesMessages = <%=predefinedSnmpTaskVariablesMessages %>;
		<%
			//}
		}
		%>

</script>

<%if (!embedded){%>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<%}%>
<%if (!scriptsOnly){%>
<%if (!onlyUpdate){%>
<input type="hidden" name="taskId<%=suffix%>" size="50" value="<%=duplicate ? "" : id%>">
<%}%>
<%if (!onlyUpdate){%>
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
		<td id="taskDescriptionTD<%=suffix%>">
<%}%>  
<input type="hidden" id="numOfVariables<%=suffix%>" name="numOfVariables<%=suffix%>" value="<%=(snmpTaskVariables != null) ? snmpTaskVariables.length : 0 %>">
<input type="hidden" id="maxVariableIndex<%=suffix%>" name="maxVariableIndex<%=suffix%>" value="<%=(snmpTaskVariables != null) ? snmpTaskVariables.length : 0 %>">
		<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
			<%if (!embedded){%>
			<tr>
				<td style="padding-bottom:10;"><span class="REGULARTEXT"><%=snmpTaskLabel%></span></td>
			</tr>
			<%}%>
			<%if (snmpTasks != null){%>
			<tr>
				<td>
					<span class="REGULARTEXT">
						<%=existingTasksLabel%>: 
						<select id="snmpTasks" name="snmpTasks" onChange="updateFromSNMPTask()">
							<option value="">-- Select Alert --</option>
							<%
							String t,tId,tName;
							int ind;
							for (int i=0; i<snmpTasks.length; i++){
								t = snmpTasks[i];
								ind = t.indexOf("^");
								if (ind != -1){
									tId = t.substring(0,ind);
									tName = t.substring(ind+1);
								}else{
									continue;
								}
							%>
							<option value="<%=tId%>"><%=tName%></option>
							<%}%>
						</select>
					</span>
				</td>
			</tr>
			<tr>
				<td style="padding-bottom:10;"><span class="SMALLTEXT"><%=existingTasksNote%></span></td>
			</tr>
			<%} %>
			<tr>
				<td style="padding-top:10;padding-bottom:10;padding-left:30px;background-color:#E4E4E4">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" >
					<tr>
						<td>
							<span class="REGULARTEXT"><b>SNMP Trap Details</b></span>
						</td>
					</tr>
					<tr>
						<td style="padding-top:15px">
							<table border="0" cellpadding="0" cellspacing="0" width="100%" >
								<tr>
									<td width="150" nowrap><span class="REGULARTEXT"><b>Name</b></span></td>
									<td width="150">
										<input class="TEXTBOX" type="text" name="name<%=suffix%>" size="30" value="<%=name%>">
									</td>
									<td>&nbsp;</td>
								</tr>
								<tr>
									<td><span class="REGULARTEXT">Description</span></td>
									<td>
										<input class="TEXTBOX" type="text" name="description<%=suffix%>" size="30" value="<%=description%>">
									</td>
									<td>&nbsp;</td>
								</tr>
								<tr>
									<td colspan="3" style="padding-top:15;font-size:1">&nbsp;</td>
								</tr>
								<tr>
									<td>
										<span class="REGULARTEXT"><b>Connection Details</b></span>
									</td>
									<td width="150">
										<table border="0" cellpadding="0" cellspacing="0" width="100%">
						  				<tr>
						  					<td width="150">
						  						<div id="accountsListDiv">
														<jsp:include flush="true" page="../../common/accountsListCombo.jsp">
															<jsp:param name="ACC_TYPE" value="snmp"/>
															<jsp:param name="ACC_ID" value="<%=snmpAccId%>"/>
															<jsp:param name="CHANGE_ACC_SELECTION" value="false"/>
															<jsp:param name="PREFIX" value="<%=PREFIX%>"/>
															<jsp:param name="noScripts" value="true"/>
														</jsp:include> 																								
													</div>
													<input type="hidden" id="snmpAccountId<%=suffix%>" name="snmpAccountId<%=suffix%>" value="<%=snmpAccId %>">
						  					</td>
						  					<%if (userContext == null || userContext.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){%>
			    							<td align="left" style="padding-left:10"><a href="javascript:snmpNewAccount();" class="BUTTON_MEDIUMLINK">new</a></td>
			    							<%} %>
						  				</tr>
						  			</table>
                  </td>
								<td>&nbsp;</td>
							</tr>
							<tr>
							  <td>
						  		<span class="REGULARTEXT">SNMP Trap OID</span>
						  	</td>
						  	<td>
							  	<table border="0" cellpadding="0" cellspacing="0" width="100%">
						  			<tr>
							  			<td width="150">
									  		<input class="TEXTBOX" type="text" name="snmpOid<%=suffix%>" size="30" value="<%=snmpOid%>"> 
						  				</td>
						  				<td width="250" style="padding-left:3px" align="left">
										  	<span class="SMALLTEXT"><nobr>Mandatory when using SNMP Version 2</nobr></span>
						  				</td>
						  				<td width="*">&nbsp;</td>
						  			</tr>
						  		</table>
						  	</td>
								<td>&nbsp;</td>
							</tr>
							<tr>
							  <td>
						  		<span class="REGULARTEXT">SNMP Community</span>
						  	</td>
						  	<td>
							  	<table border="0" cellpadding="0" cellspacing="0" width="100%">
						  			<tr>
							  			<td width="150">
									  		<input class="TEXTBOX" type="text" name="snmpCommunity<%=suffix%>" size="30" value="<%=snmpCommunity%>"> 
						  				</td>
						  				<td width="250" style="padding-left:3px" align="left">
										  	<span class="SMALLTEXT"><nobr>Default is public</nobr></span>
						  				</td>
						  				<td width="*">&nbsp;</td>
						  			</tr>
						  		</table>
						  	</td>
								<td>&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
  <tr>
  	<td style="font-size:3">&nbsp;</td>
  </tr>
  <tr>
		<td style="padding-top:10px;padding-left:30px;background-color:#F8F8F8">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" >
				<tr>
					<td><span class="REGULARTEXT"><b>SNMP Trap Variables</b></span></td>
				</tr>
				<tr>
					<td style="padding-top:10px">
						<a id="newVariablesLink<%=suffix%>" href="javascript:showHideAddNewVariables()" class="LINK">Add new variables</a>
					</td>
				</tr>
				<tr>
					<td style="padding-top:5px">
						<div id="addNewVariablesDiv<%=suffix%>" style="display:none">
						<table border="0" width="100%" cellspacing="0" cellpadding="0">
							<tr>
								<td width="21%"><input type="radio" id="newVariableSelectionTypePredefined<%=suffix%>" name="newVariableSelectionType<%=suffix%>" value="predefined" checked><span class="REGULARTEXT">Select predefined:</span>
									<select id="predefinedVariables<%=suffix%>" class="TEXTBOX" onchange="javascript:changeVariable(this.selectedIndex)">
									<option value="0">--- Select variable ---</option>
									<%
									if(predefinedSnmpTaskVariables != null && predefinedSnmpTaskVariables.length > 0) {
										for(int i = 0; i < predefinedSnmpTaskVariables.length; i++) {
									%>
									<option value="<%=predefinedSnmpTaskVariables[i].getOid() %>"><%=predefinedSnmpTaskVariables[i].getName() %></option>
									<%
										}
									} 
									%>
									</select>
								</td>
							</tr>
							<tr>
								<td><input type="radio" id="newVariableSelectionTypeCustom<%=suffix%>" name="newVariableSelectionType<%=suffix%>" value="custom"><span class="REGULARTEXT">Create a custom variable:</span></td>
							</tr>
							<tr>
								<td style="padding-top:10px;">
									<table border="0" width="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td width="110"><span class="REGULARTEXT">OID</span></td>
											<td width="110" style="padding-left:2"><span class="REGULARTEXT">Name</span></td>
											<td width="110" style="padding-left:2"><span class="REGULARTEXT">Description</span></td>
											<td width="160" style="padding-left:2"><span class="REGULARTEXT">Type</span></td>
											<td width="110" style="padding-left:2"><span class="REGULARTEXT">Message</span></td>
											<td width="*">&nbsp;</td>
										</tr>
										<tr>
											<td width="110"><input class="TEXTBOX" type="text" id="newVariableOid<%=suffix%>" name="newVariableOid<%=suffix%>" size="15" value=""></td>
											<td width="110"><input class="TEXTBOX" type="text" id="newVariableName<%=suffix%>" name="newVariableName<%=suffix%>" size="15" value=""></td>
											<td width="110"><input class="TEXTBOX" type="text" id="newVariableDescription<%=suffix%>" name="newVariableDescription<%=suffix%>" size="15" value=""></td>
											<td width="160">
												<select class="TEXTBOX" id="newVariableType<%=suffix%>" name="newVariableType<%=suffix%>" size="1" onchange="javascript:handleTimeType(this, document.access.newVariableMessage<%=suffix%>)">
												<% for(int i = 0; i < snmpTaskVariablesTypesValues.length; i++) {%>
													<option value="<%=snmpTaskVariablesTypesValues[i]%>"><%=snmpTaskVariablesTypesTexts[i]%></option>
												<% }%>
												</select>
											</td>
											<td width="110"><input class="TEXTBOX" type="text" id="newVariableMessage<%=suffix%>" name="newVariableMessage<%=suffix%>" size="15" value=""></td>
											<td align="left" style="padding-left:5px"><a href="javascript:addNewVariable()" class="LINK">Add</a></td>
										</tr>
									</table>
									</td>
								</tr>
								<!--  <tr>
									<td colspan="2">
									<table border="0" cellpadding="0" cellspacing="0" width="100%" >
										<tr>
											<td><span class="SMALLTEXT">The following variable types are available:</span></td>
										</tr>
										<tr>
											<td><span class="SMALLTEXT"><b>Trap Time:</b> the time of the SNMP trap. Specify the date format in the Message column, or leave empty for default date format (MM/dd/yyyy HH:mm:ss)</span></td>
										</tr>
										<tr>
											<td><span class="SMALLTEXT"><b>Log Time:</b> the time of the event. Specify the date format in the Message column, or leave empty for default date format (MM/dd/yyyy HH:mm:ss)</span></td>
										</tr>
										<tr>
											<td><span class="SMALLTEXT"><b>Time:</b> the value of a date column from the event. Specify the column name in square brackets. Add the date format after the column name (i.e: [Date;MM/dd/yyyy]) or leave empty for default date format (as configured in the log)</span></td>
										</tr>
										<tr>
											<td><span class="SMALLTEXT"><b>Text:</b> free text or the value of any column from the event. Specify the column name in square brackets</span></td>
										</tr>
										<tr>
											<td><span class="SMALLTEXT"><b>Status:</b> the status of the event</span></td>
										</tr>
										<tr>
											<td><span class="SMALLTEXT"><b>Other Types:</b> the value of a column from the event (choose the type matching the data in the event, i.e. Integer 32 for a numeric value and IP Address for an IP address). Specify the column name in square brackets</span></td>
										</tr>
									</table>
									</td>
								</tr>-->
							</table>
							</div>
						</td>
					</tr>
					<tr>
						<td width="100%" style="padding-top:10">
						<table border="0" cellpadding="0" cellspacing="0" width="100%" >
							<tr>
								<td><span class="REGULARTEXT" style="font-weight:bold">Existing Variables</span></td>
							</tr>
							<tr>
								<td>
									<table border="0" cellpadding="0" cellspacing="0" width="100%" >
										<tr>
											<td>
												<table border="0" cellpadding="0" cellspacing="0" width="100%" >
													<tr>
														<td width="110"><span class="REGULARTEXT">OID</span></td>
														<td width="110" style="padding-left:2"><span class="REGULARTEXT">Name</span></td>
														<td width="110" style="padding-left:2"><span class="REGULARTEXT">Description</span></td>
														<td width="160" style="padding-left:2"><span class="REGULARTEXT">Type</span></td>
														<td width="110" style="padding-left:2"><span class="REGULARTEXT">Message</span></td>
														<td width="*">&nbsp;</td>
													</tr>
												</table>
											</td>
										</tr>
										<tr>
											<td>
												<table border="0" cellpadding="0" cellspacing="0" width="100%" >
													<tr>
														<td>
															<div id="variablesDiv<%=suffix%>">
																<%
																if(snmpTaskVariables != null && snmpTaskVariables.length > 0) {
																	SNMPTaskVariable snmpTaskVariable = null;
																	for(int i = 1; i <= snmpTaskVariables.length; i++) {
																		snmpTaskVariable = snmpTaskVariables[i - 1];
																		if (snmpTaskVariable == null){
																			continue;
																		}
																%>
																<div id="variable<%=i %>Div<%=suffix%>">
																	<table border="0" cellpadding="0" cellspacing="0" width="100%" >
																		<tr>
																			<td width="110">
																				<input type="hidden" id="variable<%=i %>Visible<%=suffix%>" name="variable<%=i %>Visible<%=suffix%>" value="true">
																				<input class="TEXTBOX" type="text" id="variableOid<%=i %><%=suffix%>" name="variableOid<%=i %><%=suffix%>" size="15" value="<%=snmpTaskVariable.getOid()%>">
																			</td>
																			<td width="110">
																				<input class="TEXTBOX" type="text" id="variableName<%=i %><%=suffix%>" name="variableName<%=i %><%=suffix%>" size="15" value="<%=snmpTaskVariable.getName()%>">
																			</td>
																			<td width="110">
																				<input class="TEXTBOX" type="text" id="variableDescription<%=i %><%=suffix%>" name="variableDescription<%=i %><%=suffix%>" size="15" value="<%=snmpTaskVariable.getDescription()%>">
																			</td>
																			<td width="160">
																				<select class="TEXTBOX" id="variableType<%=i %><%=suffix%>" name="variableType<%=i %><%=suffix%>" size="1" onchange="javascript:handleTimeType(this, document.access.variableMessage<%=i %><%=suffix%>)">
																				<%
																				String selected = "";
																				for(int j = 0; j < snmpTaskVariablesTypesValues.length; j++) {
																					if(snmpTaskVariablesTypesValues[j].equals(snmpTaskVariable.getType())) {
																						selected = "selected";
																					}else {
																						selected = "";
																					}
																				%>
																					<option value="<%=snmpTaskVariablesTypesValues[j]%>" <%=selected%>><%=snmpTaskVariablesTypesTexts[j]%></option>
																				<%}%>
																				</select>
																			</td>
																			<td width="110">
																				<input class="TEXTBOX" type="text" id="variableMessage<%=i %><%=suffix%>" name="variableMessage<%=i %><%=suffix%>" size="15" value="<%=snmpTaskVariable.getMessage()%>">
																			</td>
																			<td width="*" style="padding-left:5px">
																				<a href="javascript:removeVariable(<%=i %>)" class="LINK">Remove</a>
																			</td>
																		</tr>
																	</table>
																</div>
																<%}
																}
																%>
															</div>
														</td>
													</tr>
												</table>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
						</td>
					</tr>
					<%if (!embedded){ %>
					<tr>
						<td>
						<table border="0" cellpadding="0" cellspacing="0" width="100%" >
							<tr>
								<td width="25%">&nbsp;</td>
								<td width="13%">
								<p align="center">&nbsp;</td>
								<td width="11%"><a href="javascript:history.go(-1)" class="LINK">cancel</a></td>
								<td width="11%"><a href="javascript:doSave()" class="LINK">save</a></td>
								<td width="35%">&nbsp;</td>
							</tr>
						</table>
						</td>
					</tr>
					<%} %>
				</table>
				</td>
			</tr>
		</table>
<%if (!onlyUpdate){%>		
		</td>
	</tr>
	<tr height="100%">
		<td>&nbsp;</td>
	</tr>
</table>
<%}%>
<%}%>
<%if (!embedded){%>
</form>
</body>
</html>
<%}%>