<%@ page language="java"%>

<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);	
	String ERROR_OBJ = "ERROR_OBJ";
	
	XpoTaskManager taskmgr = XpoTaskManager.getInstance();
	
	String id = null;
	String type = null;
	
	id = request.getParameter("ID");
	type = request.getParameter("TYPE");
	
	ErrorModel errmodel = new ErrorModel();
	
	
	if(id == null){
		errmodel.addError("Please supply Id for Account to delete.");
	}
	
	XpoTask task = taskmgr.getXpoTaskById(id);
	if (task == null){
	  errmodel.addError("No task exists. It might have been deleted by another user");
	}

	if(errmodel.getErrorCount() > 0){
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		return;
	}

	String Name = task.getName();
	//	audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "task removed", AuditConstants.TASKS, "remove task" + Name);

	taskmgr.removeTask(id,userContext);
	
	response.sendRedirect("viewxpotasksaction.jsp?TYPE="+type);
%>
