<%@ page language="java"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%@page import="xpolog.eye.automation.tasks.XpoTaskManager"%>
<%@page import="xpolog.eye.automation.tasks.XpoTask"%>
<%@page import="xpolog.eye.common.JobStatus"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%	
    UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	final UserEnvironment env = UserEnvironment.getUserEnvironment(request);	 
	final String id = request.getParameter("ID");

	XpoTaskManager mgr = XpoTaskManager.getInstance();
	final XpoTask task	=	mgr.getXpoTaskById(id);
	
	ErrorModel errmodel = new ErrorModel();

	if(id == null){
		errmodel.addError("Please supply Id for Operation to run.");
	}else if(task == null){
		errmodel.addError("Can't run the selected task.");
	}
	if(errmodel.getErrorCount() > 0){
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		return;
	}
	
	 //audit
	 String auditName = task.getName();
	
	 AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		  			userContext, AuditConstants.CHANGE, "execute task manually", AuditConstants.JOBS, "execute task manually " + auditName);

			JobStatus status = task.getStatus();
		  env.setTempAttribute(SiteConstants.STATUS_ATTRIBUTE, status);


	 
		ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "tasks/xpotasksview.jsp") {
			public void run(HttpServletRequest request) {
				 try{
  				long start = System.currentTimeMillis();
	    		 task.execute();
	 	    	long end = System.currentTimeMillis();
		    	if (end-start < 1000){
		    		try{
		    			Thread.sleep(500);
		    		}catch(Exception e){
		    		}
		    	}
				 }catch(Exception e){
					 errmodel.addError("Failed run job manually.");
						errmodel.addError(e.getMessage());
		        createErrorRedirect(request, BASE_DIRECTORY);		 
				 }
			}
		};
	  env.setProgressRunner(runner);
	
%>
<jsp:include page="../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Running task"/>
  <jsp:param name="useStatus" value="true"/>
</jsp:include>	