<%@ page language="java"%>

<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.meta.MetaDataManager"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.meta.MetaData"%>
<%@ page import="xpolog.eye.XpoLogObjectTypes"%>

<%!
	static final String BASE_DIRECTORY = "../";
%>

<%
WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request,response,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION,true)){
  return;
}
UserContext userContext = UserEnvironment.getUserContext(request);

String selectOnlyStr = request.getParameter("selectOnly");
boolean selectOnly = selectOnlyStr != null && selectOnlyStr.equals("true"); 
String selectOnlyParam = selectOnly ? "selectOnly=true" : "";

%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>

<jsp:include page="../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";  
	
  function goEdit(id){
  	path = "taskAction.jsp?ID="+id;
  	document.location = path;
  }
  
  function goNew(){
  	path = "tasksTypesList.jsp";
  	document.location = path;
  }
  
  function doDelete(row,id,name){   
    var msgWriter = new messageWriter("mygridMessage","Delete Task","<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid"),50);
    msgWriter.addAction("Yes","javascript:hideLayer('mygridMessage');javascript:doDelete0(" + row + ",'" +  id + "')");
    msgWriter.addAction("No","javascript:hideLayer('mygridMessage')");  
    msgWriter.showMessage("<nobr>Are you sure you want to delete task </nobr>" + name + "?");
  }
  
  function doDelete0(row,id){  	
  	deleteGridRow(mygrid,row,baseDirectory + "tasks/taskReportAction.jsp?ID=" + id + "&timestamp=" + new Date().getTime());
  }
  
  function doRun(id){
  	path = "taskRunAction.jsp?ID=" + id;
  	document.location = path;
  }
  
  function doDuplicate(id) {
  	path = "taskAction.jsp?ID="+id+"&DUPLICATE=true";
  	document.location = path;
  }
  
  
  function showHideReports(id){
  	var repDiv = document.getElementById('md_'+id+'_div');
  	var im = document.getElementById('img_'+id);
  	if (repDiv){
  		if (repDiv.style.display == ""){
  			repDiv.style.display = "none";
  			if (im){
  				im.src = "<%=BASE_DIRECTORY%>images/tree/plus.gif";
  			}
  		}else{
  			repDiv.style.display = "";
  			if (im){
  				im.src = "<%=BASE_DIRECTORY%>images/tree/minus.gif";
  			}
  		}
  	}
  }
  
	function showDesc(current,e,desc){
		var e = this.event || e;
		var tt = document.getElementById('reportDescDiv');
		var tableWidth = desc.length * 6;
		var reportDescTab = document.getElementById("reportDescTable");
		if (reportDescTab){
			reportDescTab.setAttribute("width",tableWidth);
		}
	  var sizeArr = getWindowSize();
	  var winWidth = 1280;
	  var winHeight = 1024;
	  if (sizeArr && sizeArr.length == 2){
	  	winWidth = sizeArr[0];
	  }
		
		x = (this.event ? document.body.scrollLeft + e.x : e.pageX);
	  y = (this.event ? document.body.scrollTop +  e.y : e.pageY);
		tt.style.left = x < (winWidth-tableWidth-50) ? x + 50 : (x - tableWidth > 0 ? x - tableWidth : 0);
		tt.style.top = y;
		var desc_td = document.getElementById('descTD');
		if (document.all){
			desc_td.innerText = desc;
		}else{
			desc_td.textContent = desc;
		}
		tt.style.display = "";
	}
	
	function hideDesc(){
		var tt = document.getElementById('reportDescDiv');
		tt.style.display = "none";
	}

	var actionReportReq;
	var rowId = "";
	function doReportAction(url,id){
	  rowId = "";
	  actionReportReq = GetXmlHttpObject();
	  if (!actionReportReq) return;
	  rowId = id;  
	  actionReportReq.onreadystatechange = showReportActionResult;
	  actionReportReq.open('GET', url, true);
	  actionReportReq.send(null);  
	  
	}
	
	function showReportActionResult() {
      if (actionReportReq.readyState == 4) {
         if (actionReportReq.status == 200) {
            result = actionReportReq.responseText;
            if (rowId != ""){    
              mygrid.deleteRow(rowId);
            }        
         } else {
            alert('There was a problem with the request. - ' + actionReportReq.status);
         }
      }
   }

</script>
</head>

<body onLoad="initTables()" onUnload="destroyTables()">
	<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
		<tr valign="top">
			<td width="100%">
			<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
				<tr>
					<td valign="top" height="100%">
					<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="100%" id="AutoNumber1">
						<tr>
							<td width="100%">
							<table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              
								<tr height="30">
									<td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
									<td width="55%" class="TOPBORDER">
										<span class="PAGEHEADER">XpoLog Tasks </span></td>
									<td width="44%" class="TOPRIGHTBORDER">&nbsp;</td>
								</tr>
								<tr height="*">
									<td width="3%">&nbsp;</td>
									<td width="97%" colspan="2" valign="top"> 
									<% 
									String addName = "Add new Task";
									String addLink = "javascript:goNew()";
									String initXML = "tasks/tasksDefinitionViewXML.jsp?" + selectOnlyParam;
									%>                               
									<jsp:include page="../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
									<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
									<jsp:param name="initXML" value="<%=initXML%>" />
									<jsp:param name="addNewName" value="<%=addName%>" />
									<jsp:param name="addNewLink" value="<%=addLink%>" />
									<jsp:param name="suffix" value="_tasks" />
									<jsp:param name="recordsText" value="Tasks" />
									</jsp:include>
									</td>
								</tr>
								<tr valign="bottom" height="10">
									<td valign="bottom" height="10" colspan="3">
									<table border="0" cellpadding="0" cellspacing="0" width="100%">
										<tr>
											<td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
											<td class="BOTTOMBORDER" width="33%">&nbsp;</td>
											<td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
										</tr>
									</table>
									</td>
								</tr>
							</table>
							</td>
						</tr>      
					</table>
					</td>
				</tr>
			</table>
			</td>
		</tr>
	</table>	
</body>

</html>