<%@ page language="java"%>
<%@ page import="xpolog.eye.site.ui.grid.GridTable"%>
<%@ page import="xpolog.eye.site.ui.grid.models.TasksGridTableModel"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.managment.XpologApplicationComponent"%>
<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request, response, ActionsPermissionConstants.AutomationPermissions.VIEW_TASK_PERMISSION, true)) {
		return;
	}

	String isFilterStr = request.getParameter("isFilter");
  boolean isFilter = isFilterStr != null && isFilterStr.equals("true"); 

	UserContext userContext = UserEnvironment.getUserContext(request);
	
	
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = "../";
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	XpologApplicationComponent selectedComp = (XpologApplicationComponent)env.getSelectedComponent(user);
	boolean isTxExpo = selectedComp != null && selectedComp.getId().equals("TransactionExpo");

	
	TasksGridTableModel model = new TasksGridTableModel();
	model.setBaseDirectory(baseDirectory);
	model.setUserContext(userContext);
	model.setGridName("mygrid" + suffix);
	
	model.init();
	GridTable table = new GridTable(model);
	request.setAttribute("gridTable" + suffix,table);
	
	request.getRequestDispatcher(baseDirectory + "widgets/grid/jsp/initTableXML.jsp").forward(request, response);	
%>