<%@ page language="java"%>

<%@ page import="xpolog.eye.automation.tasks.export.ExportModuleTask"%>
<%@ page import="xpolog.eye.automation.tasks.jms.JMSTask"%>
<%@ page import="xpolog.eye.automation.tasks.logic.session.SessionResultTask"%>
<%@ page import="xpolog.eye.automation.tasks.mail.MailTask"%>
<%@ page import="xpolog.eye.automation.tasks.pop.PopUpTask"%>
<%@ page import="xpolog.eye.automation.tasks.scan.ScanTask"%>
<%@ page import="xpolog.eye.automation.tasks.sms.SmsTask"%>
<%@ page import="xpolog.eye.automation.tasks.snmp.SNMPTask"%>
<%@ page import="xpolog.eye.automation.tasks.url.URLTask"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="xpolog.eye.automation.tasks.*"%>
<%@ page import="xpolog.eye.automation.tasks.exe.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>


<%
	String TASK_TYPE = "TASK_TYPE";
	String TASK_ID = "ID";
	String DUPLICATE = "DUPLICATE";
	String taskType = request.getParameter(TASK_TYPE);
  String id = request.getParameter(TASK_ID);
	String duplicateStr = request.getParameter(DUPLICATE);
	boolean duplicate = duplicateStr != null && duplicateStr.equals("true");
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	
	String name = "";
	String description = "";
	 
	if(id != null){
		XpoTaskManager taskmgr = XpoTaskManager.getInstance();
		XpoTask task = taskmgr.getXpoTaskById(request.getParameter(TASK_ID)); 
	  if(task != null) {
		  if(!duplicate) {
				name = task.getName();
		  }
			description = task.getDescription();
			
			request.setAttribute("CURRENT_TASK", task);
			request.getSession().setAttribute("lastSelectedTask",task.getId());
	  }
	}else{
		id = "";
		request.getSession().removeAttribute("lastSelectedTask");
	}
  
  String headerTitle = "";
	String taskGeneralPage = ""; 
	String accountType = "";
	String accountListId = "";
  if(taskType.equals(ExeTask.TYPE_EXE)) {
  	headerTitle = "Batch Execution Task";
  	taskGeneralPage = "execute/taskExe.jsp";
	}else if(taskType.equals(ExeTask.TYPE_SSH_EXE)) {
		headerTitle = "SSH Execution Task";
		accountListId = "sshAccountId";
		taskGeneralPage = "execute/taskExe.jsp?IsSsh=true&accountListId=" + accountListId;
		accountType = "ssh";
	}else if(taskType.equals(PopUpTask.TYPE_POP)) {
		headerTitle = "POP3 Task";
		taskGeneralPage = "pop/taskPop.jsp";
	}else if(taskType.equals(URLTask.TYPE_URL)) {
		headerTitle = "URL Task";
		accountListId = "HttpAccountId";
		taskGeneralPage = "url/taskURL.jsp?accountListId=" + accountListId;
		accountType = "http";
	}else if(taskType.equals(MailTask.TYPE_MAIL)) {
		headerTitle = "Email Task";
		taskGeneralPage = "mail/taskMail.jsp";
		accountType = "email";
	}else if(taskType.equals(SmsTask.TYPE_SMS)) {
		headerTitle = "SMS Task";
		taskGeneralPage = "sms/taskSms.jsp";
		accountType = "sms";
	}else if(taskType.equals(ExportModuleTask.TYPE_EXPORT_MODULE)) {
		headerTitle = "Export Folder Task";
		taskGeneralPage = "export/taskExportModuleRedirect.jsp";
	}else if(taskType.equals(JMSTask.TYPE_JMS_TASK)) {
		headerTitle = "JMS Message Task";
		accountListId = "jmsAccountId";
		taskGeneralPage = "jms/taskJms.jsp?accountListId=" + accountListId;
		accountType = "jms";
	}else if(taskType.equals(SNMPTask.SNMP_TASK_TYPE)) {
		headerTitle = "SNMP Trap Task";
		accountListId = "snmpAccountId";
		taskGeneralPage = "snmp/taskSnmp.jsp?accountListId=" + accountListId;
		accountType = "snmp";
	}else if(taskType.equals(SessionResultTask.TYPE_SESSION_TASK)) {
		headerTitle = "Transaction Execution Task";
		taskGeneralPage = "session/taskSession.jsp";
	}else if(taskType.equals(ScanTask.TYPE_SCAN)) {
		headerTitle = "Add Logs Directory Task";
		taskGeneralPage = "scan/taskScan.jsp";
	}
  
%>

<%@page import="xpolog.eye.XpoLogObjectTypes"%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/UIUtil.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/accounts.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/messages.js"></script>
<script LANGUAGE="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/locations.js"></script>
<script LANGUAGE="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/admin.js"></script>
<script LANGUAGE="JavaScript" src="<%=BASE_DIRECTORY%>scripts/common/errors.js"></script>

<script>
	var BASE_DIRECTORY = "<%=BASE_DIRECTORY%>";
	var date = new Date();

	function generalOpenNewAccountDiv(){
		var accType = '<%=accountType %>';
		if(accType == '' && PREFIX && eval("document.access." + PREFIX + "locationType")) {
			accType = eval("document.access." + PREFIX + "locationType").value;
		}
		openNewAccDiv('addAccDiv',accType,'','new','<%=accountListId %>','../');
	}

	function updateTaskDetails() {
		// to be overriden by task pages
		return "";
	}

	function saveTask(){
		var message = updateTaskDetails();
		if(!message || message == "") {
		  if (typeof updateParentModule == "function"){
		  	updateParentModule(tree,"MODULE_ID");
    	}
		  var q = getFormElementsQueryString(document.access);
		  var url = "xpotaskDefinitionAction.jsp?" + q;
		  sendAjaxRequest(url,function(req){
		    var xmldoc = req.responseXML.documentElement;
	      var result = xmldoc.getElementsByTagName('result')[0].firstChild.nodeValue;
	      if (result == "false"){
	      	var msgWriter = new messageWriter("mygridMessage","Save Task Error","<%=BASE_DIRECTORY%>");
	    		msgWriter.setYParent(document.getElementById("mygrid"),50);
	    		msgWriter.addAction("OK","javascript:hideLayer('mygridMessage')");  
	    		var message = xmldoc.getElementsByTagName('message')[0].firstChild.nodeValue;
	    		var msg = "<ul>";
	    		var errs = message.split("*;*");
	    		for (var i=0; i<errs.length; i++){
	    			msg = msg + "<li>" + errs[i] + "</li>";
	    		}
	    		msg = msg + "</ul>"
	    		msgWriter.setStyle("left");
	    		msgWriter.showMessage(msg);
	      }else{
	      	document.location = "xpotasksview.jsp";
	      }
		  });
		}else {
			var msgWriter = new messageWriter("mygridMessage","Save Task Error","<%=BASE_DIRECTORY%>");
    		msgWriter.setYParent(document.getElementById("mygrid"),50);
    		msgWriter.addAction("OK","javascript:hideLayer('mygridMessage')");
    		msgWriter.showMessage(message);
		}
	}
      
  function goNew(){
  	path = "<%=BASE_DIRECTORY%>tools/addresses/accoutAction.jsp?ACCOUNT_TYPE=<%=TelnetAccount.TYPE_SSH%>";
		document.location = path;
  }
  

</script>
</head>

<jsp:include page="../widgets/tabs/jsp/tabsHeaderIncluder.jsp" flush="true">
  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<div id="addAccDiv" style="display:none">
</div>

<jsp:include page="../common/sysFilesBrowser.jsp" flush="true">
	<jsp:param name="base_directory" value="<%=BASE_DIRECTORY%>"/> 
</jsp:include>
			
<jsp:include page="../common/addAccount.jsp" flush="true">
	<jsp:param name="base_directory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="accDiv" value="<%=accountListId %>"/> 
</jsp:include>

<jsp:include page="../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>

<body onLoad="javascript:initTabs()" style="margin:0;padding:0;overflow:auto;">
<form AUTOCOMPLETE="OFF" id="access" name="access" action="xpotaskDefinitionAction" style="margin:0;padding:0" method="POST">
<input type="hidden" name="taskId" value="<%=duplicate ? "" : id %>">
<input type="hidden" name="taskType" value="<%=taskType %>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="margin:0;padding:0">
	<tr height="1">
		<td>
			<jsp:include page="../common/pageHeader.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="<%=headerTitle%>" />
			</jsp:include>											
		</td>
	</tr>
	<tr>
		<td width="100%" height="100%" valign="top">
		<table class="ADMIN_TABLE_DIV" border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
			<tr>
				<td class="ADMIN_MAIN_TD" valign="top" height="100%">
				<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">																
					<tr height="1">
						<td>&nbsp;</td>
					</tr>
					<tr height="1">
						<td>
						<table class="ADMIN_SECTION_DIV" border="0" cellpadding="0" cellspacing="0" width="100%">
							<tr>
								<td style="padding-left:20">
									<table border="0" cellpadding="0" cellspacing="0">
										<tr>
											<td colspan="3">&nbsp;</td>
										</tr>
										<tr>
											<td width="150"><span class="REGULARTEXT">Name</span></td>
											<td width="150">
												<input type="text" class="TEXTBOX" name="name" size="30" value="<%=name%>" onClick="resetBgColor(this)"> 
											</td>
											<td width="150">&nbsp;</td>
										</tr>
										<tr>
											<td colspan="3"><span style="font-size:5">&nbsp;</span></td>
										</tr>
										<tr>
											<td><span class="REGULARTEXT">Description</span></td>
											<td>
												<input type="text" class="TEXTBOX" name="description" size="30" value="<%=description%>"> 
											</td>
											<td>&nbsp;</td>
										</tr>
										<tr>
											<td colspan="3"><span style="font-size:7">&nbsp;</span></td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
						</td>
					</tr>
					<tr style="padding-top:15;background-color:#A4A4A4">
						<td style="padding:8">
							<div id="tabbarDiv" style="width:100%;height:100%;background-color:#a4a4a4" ></div>
							<div id="generalDiv"  style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
								<tr><td style="padding:10px" valign="top">							
								<jsp:include page="<%=taskGeneralPage%>" flush="true">
									<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
									<jsp:param name="accountType" value="<%=accountType%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<div id="schedulerDiv"  style="display:none;height:100%;width:100%;overflow:auto" >
							<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
								<tr><td style="padding-left:10px">							
								<jsp:include page="xpotaskDefinitionSched.jsp" flush="true">
									<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								</jsp:include>
								</td></tr>
								</table>
							</div>
							<jsp:include page="../widgets/tabs/jsp/tabsIncluder.jsp" flush="true">
								<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
								<jsp:param name="id.1" value="generalDiv" />
								<jsp:param name="name.1" value="Details" />
								<jsp:param name="id.2" value="schedulerDiv" />
								<jsp:param name="name.2" value="Schedule" />
							</jsp:include>
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
	<tr>
		<td style="padding-top:20">
			<jsp:include page="../common/buttonsFooter.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="Save#Back to Tasks" />
				<jsp:param name="actions" value="javascript:saveTask()#tasks/xpotasksview.jsp" />
			</jsp:include>											
		</td>
	</tr>
</table>
</form>
</body>
</html>