<%@ page language="java"%>

<%@ page import="xpolog.eye.automation.tasks.XpoTask"%>
<%@ page import="xpolog.eye.scheduler.*"%>
<%@ page import="xpolog.eye.scheduler.ui.*"%>


<%!static final String BASE_DIRECTORY = "../";
%>
<%

	XpoTask task = (XpoTask)request.getAttribute("CURRENT_TASK");
	
	String suffix = "XpoTaskSched";
	String name = "xpotaskScheduler";
	String id = "taskId_" + System.currentTimeMillis();
	
	XpoScheduledOperation schedOp = task == null ? null : task.getSchedOp();
	ActionJobBuilder jobBuilder = new ActionJobBuilder();
	if (schedOp != null){
	  jobBuilder = new ActionJobBuilder(schedOp);
	  jobBuilder.updateFromOp();
	  name = jobBuilder.getName();
	  id = jobBuilder.getId();
	}			
	request.setAttribute("CURRENT_JOB",jobBuilder);
	request.setAttribute("ONLY_SCHEDULING","true");
	request.setAttribute("suffix",suffix);
	
%>

<input type="hidden" name="Name<%=suffix%>" value="<%=name%>">
<input type="hidden" name="Id<%=suffix%>" value="<%=id%>">
<input type="hidden" name="actionId<%=suffix%>" value="0">
<input type="hidden" name="State<%=suffix%>" value="<%=XpoScheduledOperation.STATE_ACTIVE%>">
<input type="hidden" name="schedulerSuffix" value="<%=suffix %>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<tr>
		<td style="padding-top:20px;padding-right:10px">
			<jsp:include page="../scheduler/newScheduler.jsp" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
			</jsp:include>
		</td>
	</tr>
</table>
