<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.template.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
	static final String BASE_DIRECTORY = "../";
%>
<%

  String ARCHIVE_PATH = "ARCHIVE_PATH";
  String ERROR_OBJ = "ERROR_OBJ";

  SiteManagment mgmt = SiteManagment.getInstance();
  UserContext userContext = UserEnvironment.getUserContext(request);
  String[] ids  = request.getParameterValues("TOEXPORT");

  //verify data
  ErrorModel errmodel = new ErrorModel();
  //here we will use xpolog builder for import -

  File zipFile = null;
  try{
   if(ids != null && ids.length>0){
    TemplateManager tm = new TemplateManager();
    zipFile = tm.exportTemplates(ids);
   }
  }catch(Exception e){
    ErrorModel errmod = new ErrorModel();
    errmod.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,errmod);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "export templates", AuditConstants.CONFIGURATION, "export templates");

  if(zipFile != null){
    String zipFilePath = zipFile.getName();
    response.sendRedirect(BASE_DIRECTORY + "temp/"+zipFilePath);
    return;
  }else{
    response.sendRedirect("exportTemplate.jsp");
  }
%>