<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.auth.win.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	
	String Name,Description,isDef,Domain,User,Pwd,Id;
	String forwardURL = request.getParameter("forwardURL");

	String errorMsg = "";
	String result = "";
	String isEmbededStr = request.getParameter("isEmbeded");
	boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	isDef = request.getParameter("isDefault");
	Domain = request.getParameter("Domain");
	User = request.getParameter("User");
	Pwd = request.getParameter("Pwd");
	Id = request.getParameter("Id");
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
   	errmodel.addError("Name was not supplied");
   	if(isEmbeded){
   		errorMsg += "Name was not supplied<br>";
   	}
 	}
	if(User == null || User.equals("")){
   	errmodel.addError("Username was not supplied");
   	if(isEmbeded){
   		errorMsg += "Username was not supplied<br>";
   	}
 	}
 	if(Pwd == null){
  	Pwd = "";
 	}

 	if(errmodel.getErrorCount() != 0){
 		if(!isEmbeded){
 	 		request.getSession().setAttribute(ERROR_OBJ,errmodel);
 	  	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=tools/addresses/addressview.jsp");
 	 	}else{
 			result += "error@#" + errorMsg;
 			out.write(result);
 			out.flush();
 		}
   	return;
 	}

 	if(Domain != null && Domain.length() > 0) {
 		User = User + "@" + Domain;
 	}
 	
  AddressBook adbok = AddressBook.getInstance();
	WinAuthenticationAccount ac = (WinAuthenticationAccount)adbok.getAccountById(Id);
	
	if(Id != null){
		ac = (WinAuthenticationAccount)adbok.getAccountById(Id);
		
	}
	if(ac == null){
		ac = new WinAuthenticationAccount();
	}
	
	ac.setAccountName(Name);
	ac.setPassword(Pwd);
	ac.setUser(User);
	ac.setDescription(Description);
	
	if(isDef != null){
		//this account was not default
		if(!ac.isDefault()){
			//reset all win auth accounts so no duplicate defaults
			List l = adbok.getAccountsByFilter(new WinAuthenticationAccountFilter());
			for(int i=0;i<l.size();i++){
				((WinAuthenticationAccount)l.get(i)).setDefault(false);
			}
		}
		// do it any way
		ac.setDefault(true);
	}else{
		ac.setDefault(false);
	}

	adbok.addAccount(ac,userContext);
	adbok.saveAddressBook();
	
	if(!isEmbeded) {
		request.getSession().setAttribute("lastSelectedAccount",ac.getId());
	}
	
	//	audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		  			userContext, AuditConstants.CHANGE, "add/edit account", AuditConstants.CONFIGURATION, "add/edit Auth account " + Name);

	if(isEmbeded){
		response.setContentType("text/xml");
		//result: action type + acc type + action result status + 
		//        error msg OR new acc name + new acc Id
		result += "ok@#";
		result += "auth@#";		
		result += "save@#";
		result += ac.getAccountName() + "@#";
		result += ac.getId() + "@#";;
		result += Id != null && Id.length() > 0 ? "edit" : "new";
		out.write(result);
		out.flush();
	}else{
		forwardURL = request.getParameter("forwardURL");
		if (forwardURL != null && !forwardURL.startsWith("http")){
			forwardURL = BASE_DIRECTORY + forwardURL;
		}
		if (forwardURL != null){
			forwardURL += (forwardURL.indexOf("?") == -1 ? "?" : "&") + "accountId=" + ac.getId();
			response.sendRedirect(forwardURL);
		}else{
			response.sendRedirect(BASE_DIRECTORY + "tools/addresses/addressview.jsp?addressType=auth");
		}
	}
%>

