<%@ page language="java"%>
	
<%@ page import="xpolog.eye.media.db.admin.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
	static final String BASE_DIRECTORY = "../../../../";
%>
<%
	
	String ERROR_OBJ = "ERROR_OBJ";
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	String Name, Description, dataSourceName,Id, dbType,envPath;
	
	Id = request.getParameter("Id");
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	dataSourceName = request.getParameter("dataSourceName");
	dbType = request.getParameter("DBType");
	envPath = request.getParameter("envPath");
	String skipSave = request.getParameter("skipSave");
	boolean doSave = skipSave == null || !skipSave.equals("true");
	String accountBuilderName = request.getParameter("accountBuilderName");
	if (accountBuilderName == null || accountBuilderName.length() == 0){
		accountBuilderName = "AccountBuilder";
	}
	String txExpoAccountStr = request.getParameter("txExpoAccount");
	boolean isTxExpoAccount = txExpoAccountStr != null && txExpoAccountStr.equals("true");
	String txExpoOnlineAccountStr = request.getParameter("txExpoOnlineAccount");
	boolean isTxExpoOnlineAccount = txExpoOnlineAccountStr != null && txExpoOnlineAccountStr.equals("true");
	String forwardUrl = request.getParameter("forwardUrl");
	String defaultAccountStr = request.getParameter("defaultAccount");
	boolean defaultAccount = defaultAccountStr != null && defaultAccountStr.equals("true");
	
	DBAccountBuilder builder = (DBAccountBuilder)request.getSession().getAttribute(accountBuilderName);
	if (forwardUrl != null && forwardUrl.length() > 0){
		builder.setForwardUrl(forwardUrl);
	}
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name != null && Name.equals("")){
	   	errmodel.addError("Name was not supplied");
	}
  if(dataSourceName == null || dataSourceName.trim().equals("")){
   	errmodel.addError("JNDI name was not supplied");
  }

 	if(errmodel.getErrorCount() != 0){
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=tools/addresses/addressview.jsp");
    	return;
  	}
	
	
	builder.setTxExpoAccount(isTxExpoAccount);
	builder.setTxExpoOnlineAccount(isTxExpoOnlineAccount);

	builder.setXpoName(Name);
	builder.setXpoDesc(Description);
	builder.setDbDriverName("");
	builder.setUserName("");
	builder.setPassword("");
	builder.setDbDriverType("datasource");
	builder.setDatabaseType(dbType);
	builder.setDataSourceName(dataSourceName);
	builder.setDataSourceEnvPath(envPath);
  builder.setDefaultAccount(defaultAccount);
	
	if (doSave){
		builder.saveAccount();
		
		String lastSelectedAccountId = builder.getId();
		if(lastSelectedAccountId == null) {
			lastSelectedAccountId = builder.getDbAccount().getId();
		}
		if(lastSelectedAccountId != null && lastSelectedAccountId.length() > 0) {
			request.getSession().setAttribute("lastSelectedAccount",lastSelectedAccountId);
		}
	}
		
	String forward = builder.getForwardUrl();
	if (forward == null || forward.length() == 0){
		forward = "tools/addresses/addressview.jsp?addressType=db";
	}

		//audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "add/edit account", AuditConstants.CONFIGURATION, "add/edit db account " + Name);
	
	response.sendRedirect(BASE_DIRECTORY + forward);
%>