<%@ page language="java"%>

<%@page import="java.util.List"%>
<%@page import="xpolog.eye.media.db.XpoDriversManager"%>
<%@page import="xpolog.eye.media.db.XpoDriverInfo"%>
<%@page import="xpolog.eye.media.AddressBook"%>
<%@page import="xpolog.eye.media.Account"%>
<%@page import="xpolog.eye.media.db.DBAccount"%>
<%@page import="xpolog.eye.media.db.admin.DBAccountBuilder"%>
<%@page import="xpolog.eye.media.db.admin.DBAccountBuilderFactory"%>
<%@page import="xpolog.eye.error.ErrorModel"%>

<%!
	static final String BASE_DIRECTORY = "../../../../";
%>
<%
	String ACC_ID = "ACC_ID";

	XpoDriversManager driverMgr = XpoDriversManager.getInstance();
	List list = driverMgr.getAllDriversList();
	String accId = request.getParameter(ACC_ID);
	if(accId == null){
		accId = "";
	}  
	String driverType = "none";
	DBAccount dbAcc  = null;
	if(accId.length() > 0){
		AddressBook adbook = AddressBook.getInstance();
		Account acc = adbook.getAccountById(accId);
		if(acc != null && acc instanceof DBAccount){
			dbAcc = (DBAccount)acc;
			driverType = dbAcc.getDriverType();
		}  	
	}


%>

<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
<tr>
		<td>				
				<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
					<tr>
	            <td width="30%"><span class="REGULARTEXT">Driver Type</span></td>
	            <td>
									<select class="TEXTBOX" size="1" id="driversType" name="driversType" onchange="javascript:changeDriversType()">
											<option value="none">--  driver type -- </option>
	             			  <% for(int t=0;t<list.size();t++){
	                      	XpoDriverInfo driverInfo = (XpoDriverInfo)list.get(t);                      	
	                     %>
	                        <option value="<%=driverInfo.getType()%>" <%=driverInfo.getType().equals(driverType) ? " selected" : ""%>><%=driverInfo.getType()%></option>           			
	           					<%} %>
	            			</select>
	            </td>
	        </tr>
	       </table>
	  </td>
</tr>	        
        <tr style="font-size:1px" height="3">
						<td>&nbsp;</td>
				</tr>                    
<tr>
		<td>				
				<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">		
					<tr  height="3">
							<td>
									<div id="driverParamDiv" style="display:">
									 <% 									 
									 if (driverType == null || driverType.equals("none") || dbAcc ==  null){ %>
											  <jsp:include flush="true" page="accountDbDivAction.jsp">
											  <jsp:param name="DRIVER_TYPE" value="<%=driverType%>"/>
											  </jsp:include>
										<%} else {
											boolean found = false;
											XpoDriverInfo driverInfo = null;
										  for(int i = 0 ; !found && i < list.size() ; i ++){
										  	driverInfo = (XpoDriverInfo)list.get(i);      										  	
										  	found = (driverInfo != null && driverInfo.getType().equals(driverType));
										  }  										  
										  if(driverInfo != null){
										  	long tstmp = System.currentTimeMillis();  
										  	String pageUrl = "";
										  	String url = driverInfo.getUrl();  	
										  	String type = driverInfo.getType();
											  url = url == null || url.length() == 0 ? "n/a" : url ;
											  boolean driverAvailable = false;
											  try {
											  	driverAvailable = driverMgr.checkDriver(driverInfo.getDriverName());  
											  }catch (Throwable e){
											  	ErrorModel.log.error("Failed to load driver " + driverInfo.getDriverName(),e);
											  }
										    if(!driverAvailable && !driverType.equals("other") && !driverType.equals("datasource")){
										  	   
												  pageUrl = BASE_DIRECTORY + "tools/addresses/db/general/driverHandler.jsp";												
										    }else{			
										  	  DBAccountBuilder builder = DBAccountBuilderFactory.createDBAccountBuilder(driverInfo);
										  	  builder.updateFromAccount(dbAcc);
										  	  request.setAttribute("AccountBuilder",builder);
										  	  request.getSession().setAttribute("AccountBuilder",builder);
//												response.sendRedirect(BASE_DIRECTORY + "tools/addresses/db/" + driverType + "/" +  "accountDbDiv.jsp?tstmp=" + tstmp);
											  	pageUrl = BASE_DIRECTORY + "tools/addresses/db/general/accountDbParamDiv.jsp";
										    }													   
										%>
										 <jsp:include flush="true" page="<%=pageUrl%>">
											  <jsp:param name="type" value="<%=type%>"/>
											  <jsp:param name="url" value="<%=url%>"/>
											  <jsp:param name="tstmp" value="<%=tstmp%>"/>
											  </jsp:include>
										<%} }%> 																								
									</div>
							</td>
					</tr>       
				</table>
		</td>
</tr>							
</table>