<%@page import="xpolog.eye.error.ErrorModel"%>
<%@page import="xpolog.eye.media.db.admin.DBAccountBuilderFactory"%>
<%@page import="xpolog.eye.media.db.admin.DBAccountBuilder"%>
<%@page import="xpolog.eye.media.db.XpoDriverInfo"%>
<%@page import="java.util.List"%>
<%@page import="xpolog.eye.media.db.XpoDriversManager"%>
<%@ page language="java"%>

<%!
	static final String BASE_DIRECTORY = "../../../../";
%>
<%
	String DRIVER_TYPE = "DRIVER_TYPE";
	String errorMsg = "";
	StringBuffer result = new StringBuffer();
	String driverType = request.getParameter(DRIVER_TYPE);	
	if(driverType == null || driverType.length() == 0){
		errorMsg = "<b>Problems checking driver availability!</b>";
		result.append("error@#" + errorMsg);
		out.write(result.toString());
		out.flush();
		return;
	}
	
	if(driverType.equals("none")){
		return;		// add new db account, driver was not selected yet.
	}
	XpoDriversManager driverMgr = XpoDriversManager.getInstance();
  List list = driverMgr.getAllDriversList();
	boolean found = false;
	XpoDriverInfo driverInfo = null;
  for(int i = 0 ; !found && i < list.size() ; i ++){
  	driverInfo = (XpoDriverInfo)list.get(i);                      	
  	found = (driverInfo != null && driverInfo.getType().equals(driverType));
  }
  if(driverInfo == null){
		errorMsg = "<b>Problems checking driver availability!</b>";
		result.append("error@#" + errorMsg);
		out.write(result.toString());
		out.flush();
		return;  	
  }
	long tstmp = System.currentTimeMillis();  
  boolean driverAvailable = false;
  try {
  	driverAvailable = driverMgr.checkDriver(driverInfo.getDriverName());
  }catch (Throwable e){
  	ErrorModel.log.error("Failed to load driver " + driverInfo.getDriverName(),e);
  }
  if(!driverAvailable && !driverType.equals("other") && !driverType.equals("datasource")){
  	String url = driverInfo.getUrl();  	
		url = url == null || url.length() == 0 ? "n/a" : url ; 
		response.sendRedirect(BASE_DIRECTORY + "tools/addresses/db/general/driverHandler.jsp?tstmp=" + tstmp + "&url=" + url + "&type=" + driverInfo.getType());
		return;
  }else{			
  	DBAccountBuilder builder = DBAccountBuilderFactory.createDBAccountBuilder(driverInfo);
  	request.getSession().setAttribute("AccountBuilder",builder);
//		response.sendRedirect(BASE_DIRECTORY + "tools/addresses/db/" + driverType + "/" +  "accountDbDiv.jsp?tstmp=" + tstmp);
		response.sendRedirect(BASE_DIRECTORY + "tools/addresses/db/general/accountDbParamDiv.jsp?tstmp=" + tstmp + "&type=" + driverInfo.getType());
  }
%>