<%@page import="xpolog.eye.media.db.XpoDriversManager"%>
<%@page import="java.util.List"%>
<%@page import="xpolog.eye.media.db.XpoDBType"%>
<%@page import="xpolog.eye.media.db.admin.DBAccountBuilder"%>
<%@page import="xpolog.eye.media.db.admin.DBAccountBuilderFactory"%>
<%@page import="xpolog.eye.media.db.XpoDriverInfo"%>

<%
  XpoDriversManager driverMgr = XpoDriversManager.getInstance();
  List dbTypes = driverMgr.getDBTypesList();
	DBAccountBuilder builder = (DBAccountBuilder)request.getAttribute("AccountBuilder");
	
	String driverType = request.getParameter("type");	
	if(driverType == null){
			driverType = "";
	}
	if (builder == null){
		List list = driverMgr.getAllDriversList();
		boolean found = false;
		XpoDriverInfo driverInfo = null;
	  for(int i = 0 ; !found && i < list.size() ; i ++){
	  	driverInfo = (XpoDriverInfo)list.get(i);                      	
	  	found = (driverInfo != null && driverInfo.getType().equals(driverType));
	  }  
		builder = driverInfo == null ? null : DBAccountBuilderFactory.createDBAccountBuilder(driverInfo);
	}
	String driverName = "" , port = "", machineAddress = "", userName = "",charSet="",connString="",dbName="",passwd="",envPath="",dsName="";	
	boolean showConnectionString = true;
	boolean showPort = true;
	boolean showTypeList = false;
	boolean isDefault = false;
	if(driverType.equals("mysql")){
		driverName = "com.mysql.jdbc.Driver";
		port = "3306";
		machineAddress = "localhost"; 
		userName = "root";
	}else if(driverType.equals("hsql")){
		driverName = "org.hsqldb.jdbcDriver";
		port = "9001";
		machineAddress = "localhost"; 
		userName = "sa";
	}else if(driverType.equals("postgresql")){
		driverName = "org.postgresql.Driver";
		port = "5432";
		machineAddress = "localhost"; 
	}else if(driverType.equals("interbase")){
		driverName = "interbase.interclient.Driver";
		port = "3050";
		machineAddress = "localhost"; 
		userName = "sysdba";
	}else if(driverType.equals("odbc")){
		driverName = "sun.jdbc.odbc.JdbcOdbcDriver";
		machineAddress = "localhost"; 
		showConnectionString = false;
		showPort = false;
	}else if(driverType.equals("sqlserver")){
		driverName = "com.microsoft.jdbc.sqlserver.SQLServerDriver";
		port = "1433";
		machineAddress = "localhost"; 
		userName = "sa";
		showConnectionString = false;		
	}else if(driverType.equals("db2")){
		driverName = "COM.ibm.db2.jdbc.app.DB2Driver";
		machineAddress = "localhost"; 
		showConnectionString = false;
		showPort = false;
	}else if(driverType.equals("oracle")){
		driverName = "oracle.jdbc.driver.OracleDriver";
		port = "1521";
		machineAddress = "localhost"; 
		userName = "root";
		showConnectionString = false;
	}else if(driverType.equals("sybase")){
		driverName = "com.extendedsystems.jdbc.advantage.ADSDriver";
		port = "5000";
		machineAddress = "localhost"; 
		userName = "adssys";
		showConnectionString = false;
	}else if(driverType.equals("datasource")){
		showConnectionString = false;
		showPort = false;
		showTypeList = true;
	}else{
		showConnectionString = false;
		showPort = false;
		showTypeList = true;
		isDefault = true;
	}
	if (builder != null){
		if (builder.getDbDriverName() != null && builder.getDbDriverName().length() > 0){
		  driverName = builder.getDbDriverName();
		}
		port = builder.getPort();
		if (builder.getPort() != null && builder.getPort().length() > 0){
		  port = builder.getPort();
		}
		machineAddress = builder.getHost();
		if (builder.getHost() != null && builder.getHost().length() > 0){
			machineAddress = builder.getHost();
		}
		userName = builder.getUserName();
		if (builder.getUserName() != null && builder.getUserName().length() > 0){
			userName = builder.getUserName();
		}
		
		charSet = builder.getCharset();
		if (charSet == null){
			charSet = "";
		}
		connString = builder.getConnectionString();
		if (connString == null){
			connString = "";
		}
		dbName = builder.getDbName();
		if (dbName == null){
			dbName = "";
		}
		passwd = builder.getPassword();
		if (passwd == null){
			passwd = "";
		}
		envPath = builder.getDataSourceEnvPath();
		if (envPath == null){
			envPath = "";
		}
		dsName = builder.getDataSourceName();
		if (dsName == null){
			dsName = "";
		}
	}
%>

<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
         <tr style="font-size:1px" height="6">
				 			<td>&nbsp;</td>
				 </tr>																			                  
         <%if(driverType.equals("datasource")){ %>
          <tr>
            <td width="30%"><span class="REGULARTEXT">JNDI Name</span></td>
            <td>
            <input class="TEXTBOX" type="text" name="dataSourceName" size="55" value="<%=dsName%>"></td>
          </tr>
          <tr>
            <td width="30%">&nbsp;</td>
            <td>
            <span class="SMALLTEXT">Mandatory, no default value.
            </span></td>
          </tr>  
          <tr>
            <td width="30%"><span class="REGULARTEXT">Environment Properties</span></td>
            <td>
            <input class="TEXTBOX" type="text" name="envPath" size="55" value="<%=envPath%>"></td>
          </tr>
          <tr>
            <td width="30%">&nbsp;</td>
            <td>
            <span class="SMALLTEXT">May be null.</span></td>
          </tr>                                      
         <%}else{ %>
          <tr>
            <td width="30%"><span class="REGULARTEXT">Driver Name</span></td>
            <td>
            <input class="TEXTBOX" type="text" name="DriverName" size="55" value="<%=driverName%>"></td>
          </tr>
          <tr>
            <td width="30%">&nbsp;</td>
            <td>
            <span class="SMALLTEXT">
            Loaded automatically.
        	</span></td>
          </tr>                      
         	<tr style="font-size:1px" height="3">
				 			<td>&nbsp;</td>
				 </tr>																			         
          <tr>
            <td width="30%"><span class="REGULARTEXT">
            Username</span></td>
            <td>
            <input class="TEXTBOX" type="text" name="UserName" size="55" value="<%=userName %>"></td>
          </tr>
          <tr>
            <td width="30%">&nbsp;</td>
            <td>
            <span class="SMALLTEXT">Default value 'root'. </span></td>
          </tr>
         	<tr style="font-size:1px" height="3">
				 			<td>&nbsp;</td>
				 </tr>																			         
          <tr>
            <td width="30%"><span class="REGULARTEXT">
            Password</span></td>
            <td>
            <input class="TEXTBOX" type="password" name="Password" size="55" value="<%=passwd%>"></td>
          </tr>
          <tr>
            <td width="30%">&nbsp;</td>
            <td>
            <span class="SMALLTEXT">
            May be null if the user specified does not require a 
            password.
        	</span></td>
          </tr>                      
         	<tr style="font-size:1px" height="3">
				 			<td>&nbsp;</td>
				 </tr>																			         
          <tr>
            <td width="30%"><span class="REGULARTEXT">
            Database Name</span></td>
            <td>
            <input class="TEXTBOX" type="text" name="DBName" size="55" value="<%=dbName%>"></td>
          </tr>                      
          <tr>
            <td width="30%" ></td>
            <td >
            <span class="SMALLTEXT">
            Mandatory, no default value.
        	</span></td>
          </tr>
         	<tr style="font-size:1px" height="3">
				 			<td>&nbsp;</td>
				 </tr>																			               
         <%if(isDefault){ %>
         <tr>
          <td width="30%"><span class="REGULARTEXT">Connection String</span></td>
          <td>
          <input class="TEXTBOX" type="text" name="ConnectionString" size="55" value="<%=connString%>"></td>
        </tr>  
        <tr>
          <td width="30%">&nbsp;</td>
          <td><input class="TEXTBOX" type="hidden" name="Id" size="10">
          <span class="SMALLTEXT">Mandatory, no default value.
          </span></td>
        </tr>             
         <%}else{ %>
          <tr>
            <td width="30%" ><span class="REGULARTEXT">
            Machine Address</span></td>
            <td >
            <input class="TEXTBOX" type="text" name="MachineAddress" size="55" value="<%=machineAddress%>"></td>
          </tr>
          <tr>
            <td width="30%">&nbsp;</td>
            <td>
            <span class="SMALLTEXT">
            Default value is 'localhost'.
        	</span></td>
          </tr>
          <%}%>
         	<tr style="font-size:1px" height="3">
				 			<td>&nbsp;</td>
				 </tr>				 
				 <%if(showPort){%>																		               
           <tr>
             <td width="30%"><span class="REGULARTEXT">
             Port</span></td>
             <td>
             <input class="TEXTBOX" type="text" name="Port" size="55" value="<%=port%>"></td>
           </tr>
           <tr>
             <td width="30%" ></td>
             <td ><span class="SMALLTEXT">
             Default value is '<%=port%>'.
         	</span><input class="TEXTBOX" type="hidden" name="Id" size="10">
             </td>
           </tr>      
          <%}%> 
         	<tr style="font-size:1px" height="3">
				 			<td>&nbsp;</td>
				 </tr>																			               
           <%if(showConnectionString){%>
           <tr>
             <td width="30%"><span class="REGULARTEXT">
             Connection string params</span></td>
             <td>
             <input class="TEXTBOX" type="text" name="CharSet" size="55" value="<%=charSet%>"></td>
           </tr>
           <tr>
             <td width="30%" ></td>
             <td ><span class="SMALLTEXT">
             example: useUnicode=true&amp;characterEncoding=ISO8859_8
         	</span><input class="TEXTBOX" type="hidden" name="Id" size="10">
             </td>
           </tr>      
         	<tr style="font-size:1px" height="3">
				 			<td>&nbsp;</td>
				 </tr>		
				 <%}} %>
				 
				 		
         <% if (showTypeList && dbTypes != null && dbTypes.size() > 0) {%>
         <tr>
          <td width="30%"><span class="REGULARTEXT">
          Database Type</span></td>
          <td>
          <select  size="1" class="TEXTBOX" name="DBType" >
          <%
              String selected = "";                           
              for(int i=0;i<dbTypes.size();++i){
                XpoDBType dbType = (XpoDBType)dbTypes.get(i);
              %>
              <option value="<%=dbType.getId()%>" class="TEXTBOX"><%=dbType.getName()%></option>
                <%}%>
          </select>                      
          </td>
        </tr> 
        <tr>
          <td width="30%">&nbsp;</td>
          <td>
          <span class="SMALLTEXT">Select Other for unknown database.</span></td>
        </tr>
        <% }%>
															               
 
 </table>