<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="xpolog.eye.media.db.admin.DBAccountBuilder"%>
<%@ page import="xpolog.eye.media.db.admin.DBAccountBuilderFactory"%>

<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../../";
%>
<%
	String ACCOUT_ID = "ID";
	String TYPE = "type";
	String DRIVER_NAME = "DriverName";
	
	String id = request.getParameter(ACCOUT_ID);
	//String driverName = request.getParameter(DRIVER_NAME);
	String type = request.getParameter(TYPE);
	String isEmbededStr = request.getParameter("isEmbeded");
	boolean isEmbeded = (isEmbededStr != null && isEmbededStr.equals("true"));
	String hideSetAsDefaultStr = request.getParameter("hideDefault");
	boolean hideSetAsDefault = true || hideSetAsDefaultStr != null && hideSetAsDefaultStr.equals("true");

	String driverName = "";
	String connectionString = "";
	String name = "";
	String description = "";
	String userName="";
	String password="";
	String selectedDbType = "";
	if (type == null || type.trim().length() == 0){
	  type = "other";
	}
	
	String accountBuilderName = request.getParameter("accountBuilderName");
	boolean isTxExpoAccount = false;
	boolean isTxExpoOnlineAccount = false;
	if (accountBuilderName == null || accountBuilderName.length() == 0){
		accountBuilderName = "AccountBuilder";
	}
	if (accountBuilderName.equals("TxExpoAccountBuilder")){
		isTxExpoAccount = true;
	}else if (accountBuilderName.equals("TxExpoOnlineAccountBuilder")){
		isTxExpoOnlineAccount = true;
	}
	String forwardUrl = request.getParameter("forwardUrl");
	boolean defaultAccount = false;

	XpoDriversManager driverMgr = XpoDriversManager.getInstance();
	DBAccountBuilder builder = (DBAccountBuilder)request.getSession().getAttribute(accountBuilderName);
	if (builder == null || (builder.getDbDriverType() != null && !builder.getDbDriverType().equals(type))){
  	XpoDriverInfo driverInfo = driverMgr.getDriverById(type);
	  builder =  DBAccountBuilderFactory.createDBAccountBuilder(driverInfo);
	}
	if (forwardUrl != null && forwardUrl.length() > 0){
		builder.setForwardUrl(forwardUrl);
	}

	if(id != null){
		AddressBook adbok = AddressBook.getInstance();
		DBAccount acc = (DBAccount)adbok.getAccountById(id);
		name = acc.getAccountName();
		description = acc.getDescription();
		driverName = acc.getDriverName();
		connectionString = acc.getConnectionString();
		userName = acc.getUserName();
		password = acc.getPassword();		
		selectedDbType = acc.getDatabaseType();
		
		request.getSession().setAttribute("lastSelectedAccount",acc.getId());
	}else{
		id = "";
		request.getSession().removeAttribute("lastSelectedAccount");
	}
	
  List dbTypes = driverMgr.getDBTypesList();
	if (isEmbeded){
		name = null;
		description = null;
	}
  
	request.getSession().setAttribute(accountBuilderName,builder);

	
%>

<%if (!isEmbeded) {%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
      function doSave(){
        document.access.action ="accountDbAction.jsp";
        document.access.submit();
      }

</script>
</head>

<body style="margin:0;padding:0">

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" style="margin:0;padding:0">
<%} %>
<input class="TEXTBOX" type="hidden" name="Id" size="10" value="<%=id%>">
<input type="hidden" name="type" value="<%=type%>">

<table border="0" cellpadding="0" cellspacing="0"	style="border-collapse:collapse" width="100%" height="100%">
	<%if (!isEmbeded) {%>
	<tr height="10">
		<td>
			<%
			String headerUrl = BASE_DIRECTORY + "common/pageHeader.jsp";
			%>
			<jsp:include page="<%=headerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="Database Account" />
			</jsp:include>
		</td>
	</tr>
	<%}%>
	<tr valign="top">
		<td>
			<table class="ADMIN_TABLE_DIV" width="100%">
				<tr>
					<td class="ADMIN_MAIN_TD">
						<table width="100%">
							<tr>
								<td style="padding-top:15">
									<table class="ADMIN_SECTION_DIV" cellpadding="0" cellspacing="0" width="100%">
										<tr>
											<td class="ADMIN_SECTION_MAIN_TD">
												<table border="0" cellpadding="0" cellspacing="0" width="100%">
		                      <%if (name != null){%>
		                      <tr>
		                        <td width="11%"><span class="REGULARTEXT">Name *</span></td>
		                        <td width="69%">
		                        <input class="TEXTBOX" type="text" name="Name" size="50" value="<%=name%>"></td>
		                      </tr>
		                      <%}%>
		                      <%if (description != null){%>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Description</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="Description" size="50" value="<%=description%>"></td>
		                      </tr>
		                      <%}%>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Driver Name *</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="DriverName" size="50" value="<%=driverName%>"></td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Connection String *</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="ConnectionString" size="100" value="<%=connectionString%>"></td>
		                      </tr>  
		                      <tr>
		                        <td style="padding-top:10" height="19"><span class="REGULARTEXT">
		                        Username</span></td>
		                        <td height="19">
		                        <input class="TEXTBOX" type="text" name="UserName" size="50" value="<%=userName%>"></td>
		                      </tr>                  
		                      <tr>
		                        <td style="padding-top:10" height="19"><span class="REGULARTEXT">
		                        Password</span></td>
		                        <td height="19">
		                        <input class="TEXTBOX" type="password" name="Password" size="50" value="<%=password%>"></td>
		                      </tr> 
		                      <% if (dbTypes != null && dbTypes.size() > 0) {%>
		                       <tr>
		                        <td style="padding-top:10" height="19"><span class="REGULARTEXT">
		                        Database Type</span></td>
		                        <td height="19">
		                        <select  size="1" class="TEXTBOX" name="DBType" >
		                        <%
		                            String selected = "";                           
		                            for(int i=0;i<dbTypes.size();++i){
		                              XpoDBType dbType = (XpoDBType)dbTypes.get(i);
		                              if(dbType.getId().equals(selectedDbType)){
		                                selected = "selected=\"true\"";
		                              }else{
		                                selected = "";
		                              }
		                            %>
		                            <option value="<%=dbType.getId()%>" class="TEXTBOX" <%=selected%>><%=dbType.getName()%></option>
		                              <%}%>
		                        </select>                      
		                        </td>
		                      </tr> 
		                      <tr>
		                        <td>&nbsp;</td>
		                        <td>
		                        <span class="SMALLTEXT">Select Other for unknown database</span></td>
		                      </tr>
		                      <% }%>
		                      <tr>
		                        <td style="padding-top:20" colspan="2">
		                        	<span class="SMALLTEXT">* marks a manadatory field</span>
		                        </td>
		                      </tr>
		                    </table>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<%if (!isEmbeded) {%>
	<tr height="10">
		<td>
			<%
			String footerUrl = BASE_DIRECTORY + "common/buttonsFooter.jsp";
			String cancelAction = "common/actions/cancelAction.jsp?forward=tools/addresses/addressview.jsp";
			
			String actions = "javascript:doSave()#" + cancelAction;
			%>
			<jsp:include page="<%=footerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="Save#Back to Address Book" />
				<jsp:param name="actions" value="<%=actions %>" />
			</jsp:include>
		</td>
	</tr>
	<%}%>
</table>
<%if (!isEmbeded) {%>
</form>
</body>
</html>
<%}%>
