<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="xpolog.eye.media.db.admin.DBAccountBuilder"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>	 
<%!
	static final String BASE_DIRECTORY = "../../../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	
	String Name, Description, DriverName, ConnectionString, Id, userName, password,type;

	String actionType = request.getParameter("ACTION_TYPE");
	if(actionType == null || actionType.length() == 0 ){
		actionType = "save";
	}
	String verifyBeforeSaveStr = request.getParameter("verifyBeforeSave");
	boolean verifyBeforeSave = verifyBeforeSaveStr != null && verifyBeforeSaveStr.equals("true");
	String verifyMsg = "";
	String errorMsg = "";
	String result = "";
	String isEmbededStr = request.getParameter("isEmbeded");
	boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");

	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	DriverName = request.getParameter("DriverName");
	ConnectionString = request.getParameter("ConnectionString");
	Id = request.getParameter("Id");
	userName = request.getParameter("UserName");
	password = request.getParameter("Password");
	type = request.getParameter("type");
	String dbType = request.getParameter("DBType");
	String skipSave = request.getParameter("skipSave");
	boolean doSave = skipSave == null || !skipSave.equals("true");
	String accountBuilderName = request.getParameter("accountBuilderName");
	if (accountBuilderName == null || accountBuilderName.length() == 0){
		accountBuilderName = "AccountBuilder";
	}
	String txExpoAccountStr = request.getParameter("txExpoAccount");
	boolean isTxExpoAccount = txExpoAccountStr != null && txExpoAccountStr.equals("true");
	String txExpoOnlineAccountStr = request.getParameter("txExpoOnlineAccount");
	boolean isTxExpoOnlineAccount = txExpoOnlineAccountStr != null && txExpoOnlineAccountStr.equals("true");
	String forwardUrl = request.getParameter("forwardUrl");
	
	ErrorModel errmodel = new ErrorModel(); 
	DBAccountBuilder builder = (DBAccountBuilder)request.getSession().getAttribute(accountBuilderName);
	
	if (builder != null){
		if (forwardUrl != null && forwardUrl.length() > 0){
			builder.setForwardUrl(forwardUrl);
		}
	}

	if(Name != null && Name.equals("")){
   	errmodel.addError("Name was not supplied");
    if(isEmbeded){
    	errorMsg += "Name was not supplied<br>";
    }
 	}
 	if(DriverName == null || DriverName.equals("")){
   	errmodel.addError("Driver name was not supplied");
    if(isEmbeded){
    	errorMsg += "Driver name was not supplied<br>";
    }
	}
 	if(ConnectionString == null || ConnectionString.equals("")){
   	errmodel.addError("Connection string was not supplied");
    if(isEmbeded){
    	errorMsg += "Connection string was not supplied<br>";
    }
 	}

 	if(errmodel.getErrorCount() != 0){
   	request.getSession().setAttribute(ERROR_OBJ,errmodel);
   	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=tools/addresses/addressview.jsp");
   	return;
  }
 	
 	if (builder != null){
 		builder.setTxExpoAccount(isTxExpoAccount);
 		builder.setTxExpoOnlineAccount(isTxExpoOnlineAccount);
 		if (Name != null){
 	  	builder.setXpoName(Name);
 	  }
 		if (Description != null){
 	  	builder.setXpoDesc(Description);
 	  }
 		if (DriverName != null){
 	  	builder.setDbDriverName(DriverName);
 	  }
 		if (ConnectionString != null){
 	  	builder.setConnectionString(ConnectionString);
 	  }
 		if (userName != null){
			builder.setUserName(userName);
 		}
 		if (password != null){
			builder.setPassword(password);
 		}
 		if (type != null){
			builder.setDbDriverType(dbType);
 		}

 	}
	
	if (doSave){
		DBAccount dbac = null;
		AddressBook adbok = AddressBook.getInstance();
		if(Id != null){
			dbac = (DBAccount)adbok.getAccountById(Id);
			
		}
		if(dbac == null){
			dbac = new DBAccount();
		}
		dbac.setAccountName(Name);
		dbac.setDescription(Description);
		dbac.setDriverName(DriverName);
		dbac.setConnectionString(ConnectionString);
		dbac.setUserName(userName);
		dbac.setPassword(password);
		dbac.setDriverType(type);
		adbok.addAccount(dbac);
		dbac.setDatabaseType(dbType);
		adbok.saveAddressBook();
		
		request.getSession().setAttribute("lastSelectedAccount",dbac.getId());
		
		
		//	audit
		AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		  			userContext, AuditConstants.CHANGE, "add/edit account", AuditConstants.CONFIGURATION, "add/edit db account " + Name);
	}
	
	String forward = builder != null ? builder.getForwardUrl() : null;
	if (forward == null || forward.length() == 0){
	  forward = "tools/addresses/addressview.jsp?addressType=db";
	}


	response.sendRedirect(BASE_DIRECTORY + forward);
%>

