<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.net.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
	static final String BASE_DIRECTORY = "../../../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	
	String Name, Description, DriverName, userName, password, dbName, machineAddress, port, ConnectionString, Id;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	DriverName = request.getParameter("DriverName");
	userName = request.getParameter("UserName");
	password = request.getParameter("Password");
	dbName = request.getParameter("DBName");
	machineAddress = request.getParameter("MachineAddress");
	port = request.getParameter("Port");
	ConnectionString = request.getParameter("ConnectionString");
	Id = request.getParameter("Id");
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
    	errmodel.addError("No Name was supplied.");
  	}

  	if(DriverName == null || DriverName.equals("")){
  		//incase someone has deleted the driver name and clicked save.
    	errmodel.addError("No Driver Name was supplied.");
  	}
  
  	if(userName == null || userName.equals("")){
    	userName="Administrator";
  	}
  	
  	if(dbName == null || dbName.equals("")){
    	errmodel.addError("Database Name was not supplied.");
  	}
  	
  	if(machineAddress == null || machineAddress.equals("")){
    	machineAddress = "localhost";
  	}
  	
  	if(port == null || port.equals("")){
    	port = "1433";
  	}
  	
  	try{
  		int p = Math.abs(Integer.parseInt(port));
  	}catch(Exception e) {
  		errmodel.addError("Port must be a valid number.");
  	}

 	if(errmodel.getErrorCount() != 0){
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
  	}
	
	
	
	DBAccount dbac = null;
	AddressBook adbok = AddressBook.getInstance();
	if(Id != null){
		dbac = (DBAccount)adbok.getAccountById(Id);
	}
	if(dbac == null){
		dbac = new DBAccount();
	}
	
	dbac.setAccountName(Name);
	dbac.setDescription(Description);
	dbac.setDriverName(DriverName);
	dbac.setUserName(userName);
	dbac.setPassword(password);
	ConnectionString = "jdbc:microsoft:sqlserver://"+machineAddress+":"+port+";DatabaseName="+dbName;
	dbac.setConnectionString(ConnectionString);
	dbac.setDriverType("sqlserver");
	adbok.addAccount(dbac);
	adbok.saveAddressBook();

	//	audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	  			userContext, AuditConstants.CHANGE, "add/edit account", AuditConstants.CONFIGURATION, "add/edit db account " + Name);


	response.sendRedirect(BASE_DIRECTORY + "tools/addresses/addressview.jsp?addressType=db");
%>

