<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.fs.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	
	String charset = "UTF-8";
	request.setCharacterEncoding(charset);

	String Name,Description,strUrl,Port,User,Pwd,Id;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	strUrl = request.getParameter("Url");
	Id = request.getParameter("Id");
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
   	errmodel.addError("Name was not supplied");
 	}
 	if(strUrl == null || strUrl.equals("")){
   	errmodel.addError("Path was not supplied");
 	}
  	
 	if(errmodel.getErrorCount() != 0){
   	request.getSession().setAttribute(ERROR_OBJ,errmodel);
   	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=tools/addresses/addressview.jsp");
   	return;
 	}
	
	FSAccount ftac = null;
	AddressBook adbok = AddressBook.getInstance();
	if(Id != null){
		ftac = (FSAccount)adbok.getAccountById(Id);
		
	}
	if(ftac == null){
		ftac = new FSAccount();
	}
	
	ftac.setAccountName(Name);
	ftac.setLocation(strUrl);
	ftac.setDescription(Description);
	
	adbok.addAccount(ftac,userContext);
	adbok.saveAddressBook();
	
	request.getSession().setAttribute("lastSelectedAccount",ftac.getId());
	
	//	audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	  			userContext, AuditConstants.CHANGE, "add/edit account", AuditConstants.CONFIGURATION, "add/edit fs account " + Name);
	
	response.sendRedirect(BASE_DIRECTORY + "tools/addresses/addressview.jsp?addressType=fs");
%>	