<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.http.*"%>
<%@ page import="java.net.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	
	String Name,Description,strUrl,Port,User,Pwd,Id;
	String errorMsg = "";
	String result = "";
	String isEmbededStr = request.getParameter("isEmbeded");
	boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	strUrl = request.getParameter("Url");
	Id = request.getParameter("Id");
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
    errmodel.addError("Name was not supplied");
    if(isEmbeded){
   		errorMsg += "Name was not supplied<br>";
   	}
 	}
 	URL url = null;
 	if(strUrl == null || strUrl.equals("")){
   	errmodel.addError("Host URL was not supplied");
   	if(isEmbeded){
   		errorMsg += "Host URL was not supplied<br>";
   	}
 	}else {
  	try{
  		url = new URL(strUrl);
  	}catch(Exception e){
  		errmodel.addError("Invalid URL - " + e.getMessage());
  		if(isEmbeded){
    		errorMsg += "Invalid URL - <br>" + e.getMessage();
    	}
  	}
 	}
 	
 	if(errmodel.getErrorCount() != 0){
 		if(!isEmbeded){
 	 		request.getSession().setAttribute(ERROR_OBJ,errmodel);
 	 		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=tools/addresses/addressview.jsp");
 	 	}else{
 			result += "error@#" + errorMsg;
 			out.write(result);
 			out.flush();
 		}
   	return;
 	}
	
	HttpAccount htac = null;
	AddressBook adbok = AddressBook.getInstance();
	if(Id != null){
		htac = (HttpAccount)adbok.getAccountById(Id);
		
	}
	if(htac == null){
		htac = new HttpAccount();
	}
	
	htac.setAccountName(Name);
	htac.setUrl(url);
	htac.setDescription(Description);
	
	adbok.addAccount(htac,userContext);
	adbok.saveAddressBook();
	
	if(!isEmbeded) {
		request.getSession().setAttribute("lastSelectedAccount",htac.getId());
	}
	
	//	audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		  			userContext, AuditConstants.CHANGE, "add/edit account", AuditConstants.CONFIGURATION, "add/edit http account " + Name);

	if(isEmbeded){
		response.setContentType("text/xml");
		//result: action type + acc type + action result status + 
		//        error msg OR new acc name + new acc Id
		result += "ok@#";
		result += "http@#";
		result += "save@#";
		result += htac.getAccountName() + "@#";
		result += htac.getId() + "@#";
		result += Id != null && Id.length() > 0 ? "edit" : "new";
		out.write(result);
		out.flush();
	}else{
		response.sendRedirect(BASE_DIRECTORY + "tools/addresses/addressview.jsp?addressType=http");
	}
%>