<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.jms.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%

	String ACC_ID = "ACC_ID";
	String accId = request.getParameter(ACC_ID);
	if(accId == null){
		accId = "";
	}
	
	String jndiProviderUrl = JMSAccount.JNDI_DEF_PROVIDER_URL;
	String jndiContextFactory = JMSAccount.JNDI_DEF_CONTEXT;

	//JMS Topic connection factory settings
	String topicConectionFactoryKey = JMSAccount.JNDI_DEF_TOPIC_FACTORY;
	
	//JMS Queue connection factory settings
	String queueConectionFactoryKey = JMSAccount.JNDI_DEF_QUEUE_FACTORY;

	//JMS Security if needed
	String userName = "";
	String password = "";		

	if(accId.length() > 0){
		AddressBook adbok = AddressBook.getInstance();
		JMSAccount acc = (JMSAccount)adbok.getAccountById(accId);
		userName = acc.getUserName();
		password = acc.getPassword();		
		jndiProviderUrl = acc.getJndiProviderUrl();
		jndiContextFactory = acc.getJndiContextFactory();
		topicConectionFactoryKey = acc.getTopicConectionFactoryKey();
		queueConectionFactoryKey = acc.getQueueConectionFactoryKey();
	}
	
%>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="30%"><span class="REGULARTEXT">JNDI Context</span></td>
    <td>
    	<input class="TEXTBOX" type="text" id="jndiContextFactory" name="jndiContextFactory" size="50" value="<%=jndiContextFactory%>">
    </td>
  </tr>
  <tr>
    <td>&nbsp;</td>
    <td><span class="SMALLTEXT">Enter the full path to the JNDI context. Mandatory.</span></td>
  </tr>
   <tr>
    <td><span class="REGULARTEXT">JNDI Provider URL</span></td>
    <td>
    	<input class="TEXTBOX" type="text" id="jndiProviderUrl" name="jndiProviderUrl" size="50" value="<%=jndiProviderUrl%>">
    </td>
  </tr>
  <tr>
    <td>&nbsp;</td>
    <td>
    <span class="SMALLTEXT">Mandatory.
    </span></td>
  </tr>
   <tr>
    <td><span class="REGULARTEXT">Username</span></td>
    <td>
    	<input class="TEXTBOX" type="text" id="userName" name="userName" size="50" value="<%=userName%>">
    </td>
  </tr>
  <tr>
    <td>&nbsp;</td>
    <td>
    <span class="SMALLTEXT">May be null.
    </span></td>
  </tr>
   <tr>
    <td><span class="REGULARTEXT">Password</span></td>
    <td>
    	<input class="TEXTBOX" type="password" id="password" name="password" size="50" value="<%=password%>">
    </td>
  </tr>
  <tr>
    <td>&nbsp;</td>
    <td>
    <span class="SMALLTEXT">May be null.
    </span></td>
  </tr>                 
  <tr>
    <td><span class="REGULARTEXT">JMS Topic Factory</span></td>
    <td>
    	<input class="TEXTBOX" type="text" id="topicConectionFactoryKey" name="topicConectionFactoryKey" size="50" value="<%=topicConectionFactoryKey%>">
    </td>
  </tr>
  <tr>
    <td>&nbsp;</td>
    <td>
    <span class="SMALLTEXT">Mandatory.
    </span></td>
  </tr>
   <tr>
    <td><span class="REGULARTEXT">JMS Queue Factory</span></td>
    <td>
    	<input class="TEXTBOX" type="text" id="queueConectionFactoryKey" name="queueConectionFactoryKey" size="50" value="<%=queueConectionFactoryKey%>">
    </td>
  </tr>
  <tr>
    <td>&nbsp;</td>
    <td>
    <span class="SMALLTEXT">Mandatory.
    </span></td>
  </tr>                      
  <tr>
    <td>&nbsp;</td>
    <td>
    	<input class="TEXTBOX" type="hidden" name="Id" size="10" value="<%=accId%>">
   	</td>
  </tr>
</table>