<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.media.auth.AuthenticationAccount"%>
<%@ page import="xpolog.eye.media.auth.win.WinAuthenticationAccount"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="xpolog.eye.media.fs.FSAccount"%>
<%@ page import="xpolog.eye.media.ftp.FTPAccount"%>
<%@ page import="xpolog.eye.media.http.HttpAccount"%>
<%@ page import="xpolog.eye.media.jms.JMSAccount"%>
<%@ page import="xpolog.eye.media.mail.MailAccount"%>
<%@ page import="xpolog.eye.media.remote.RemoteXplgAccount"%>
<%@ page import="xpolog.eye.media.sms.SmsAccount"%>
<%@ page import="xpolog.eye.media.snmp.SNMPAccount"%>
<%@ page import="xpolog.eye.media.telsh.TelnetAccount"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>
<%@ page import="xpolog.tools.XpologSystemInfo"%>

<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<% 
	String accountTypesList = request.getParameter("accountTypes");
	String[] accountTypesArr = accountTypesList == null ? null : accountTypesList.split(",");
	HashSet accountTypes = null;
	if (accountTypesArr != null){
		accountTypes = new HashSet();
		for (int i=0; i<accountTypesArr.length; i++){
			accountTypes.add(accountTypesArr[i]);
		}
	}
	boolean showDb = accountTypes == null || accountTypes.contains(DBAccount.TYPE_DB);
	boolean showFs = accountTypes == null || accountTypes.contains(FSAccount.TYPE_FS);
	boolean showFtp = accountTypes == null || accountTypes.contains(FTPAccount.TYPE_FTP);
	boolean showHttp = accountTypes == null || accountTypes.contains(HttpAccount.TYPE_HTTP);
	boolean showJms = accountTypes == null || accountTypes.contains(JMSAccount.TYPE_JMS);
	boolean showMail = accountTypes == null || accountTypes.contains(MailAccount.TYPE_MAIL);
	boolean showSms = accountTypes == null || accountTypes.contains(SmsAccount.TYPE_SMS);
	boolean showSnmp = accountTypes == null || accountTypes.contains(SNMPAccount.TYPE_SNMP);
	boolean showSsh = accountTypes == null || accountTypes.contains(TelnetAccount.TYPE_SSH);
	boolean showRemote = accountTypes == null || accountTypes.contains(RemoteXplgAccount.TYPE_REMOTE);
	boolean showAuth = XpologSystemInfo.isWindows() && (accountTypes == null || accountTypes.contains(AuthenticationAccount.TYPE_AUTH) || accountTypes.contains(WinAuthenticationAccount.TYPE_WIN_AUTHENTICATION));
	
	String forwardURL = request.getParameter("forwardURL");
  if (forwardURL != null && forwardURL.length() > 0){
  	forwardURL = XpologUtil.replaceAll(forwardURL,"?","%3f"); 
  	forwardURL = XpologUtil.replaceAll(forwardURL,"&","%26"); 
  	forwardURL = "?forwardURL="+forwardURL;
  }else{
  	forwardURL = "";
  }
%>

<form AUTOCOMPLETE="OFF" name="accountTypeForm" style="padding:0;margin:0">
<table border="0" cellpadding="0" cellspacing="0" width="100%" height="90%">
<%if (showDb){%>
	<tr height="10">
		<td width="30"><input name="accountType" type="radio" value="db"></td>
		<td class="REGULARTEXT" align="left">Database Account</td>
	</tr>
<%}%>
<%if (showMail){%>
	<tr height="10">
		<td style="padding-top:5"><input name="accountType" type="radio" value="email"></td>
		<td style="padding-top:5" class="REGULARTEXT">Email Account</td>
	</tr>
<%}%>
<%if (showFs){%>
	<tr height="10">
		<td style="padding-top:5"><input name="accountType" type="radio" value="fs"></td>
		<td style="padding-top:5" class="REGULARTEXT">File System Account</td>
	</tr>
<%}%>
<%if (showFtp){%>
	<tr height="10">
		<td style="padding-top:5"><input name="accountType" type="radio" value="ftp"></td>
		<td style="padding-top:5" class="REGULARTEXT">FTP Account</td>
	</tr>
<%}%>
<%if (showHttp){%>
	<tr height="10">
		<td style="padding-top:5"><input name="accountType" type="radio" value="http"></td>
		<td style="padding-top:5" class="REGULARTEXT">HTTP Account</td>
	</tr>
<%}%>
<%if (showJms){%>
	<tr height="10">
		<td style="padding-top:5"><input name="accountType" type="radio" value="jms"></td>
		<td style="padding-top:5" class="REGULARTEXT">JMS Account</td>
	</tr>
<%}%>
<%if (showRemote){%>
	<tr height="10">
		<td style="padding-top:5"><input name="accountType" type="radio" value="remote"></td>
		<td style="padding-top:5" class="REGULARTEXT">Remote XpoLog Account</td>
	</tr>
<%}%>
<!--
	<tr height="10">
		<td style="padding-top:5"><input name="accountType" type="radio" value="sms"></td>
		<td style="padding-top:5" class="REGULARTEXT">SMS Account</td>
	</tr>
-->
<%if (showSnmp){%>
	<tr height="10">
		<td style="padding-top:5"><input name="accountType" type="radio" value="snmp"></td>
		<td style="padding-top:5" class="REGULARTEXT">SNMP Account</td>
	</tr>
<%}%>
<%if (showSsh){%>
	<tr height="10">
		<td style="padding-top:5"><input name="accountType" type="radio" value="ssh"></td>
		<td style="padding-top:5" class="REGULARTEXT">SSH Account</td>
	</tr>
<%}%>
<%if (showAuth){%>
	<tr height="10">
		<td style="padding-top:5"><input name="accountType" type="radio" value="winAuthentication"></td>
		<td style="padding-top:5" class="REGULARTEXT">Windows Authentication Account</td>
	</tr>
<%}%>
	<tr>
		<td>&nbsp;</td>
	</tr>
</table>
</form>
<table border="0" cellpadding="0" cellspacing="0" width="100%" height="10%">
	<tr>
		<td align="left">
			<div id="accountTypeErrorMsg" style="display:none;" class="ERROR_MSG">
			</div>
		</td>
	</tr>		
</table>