<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.security.cert.*"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>
<%@ page import="xpolog.config.*"%>

<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION,true)){
    return;
  }
	String ACCOUT_ID = "ID";
	String id = request.getParameter(ACCOUT_ID);
	
	String name = "";
	String description = "";
	String host = "";
	String protocol = "http";
	String port = "30303";
	String context = "logeye";
	String user = "";
	String password = "";
	boolean isAutoLogin = false;
	String conType = RemoteXplgAccount.TYPE_REMOTE;
	
	if(id != null){
		AddressBook adbok = AddressBook.getInstance();
		RemoteXplgAccount acc = (RemoteXplgAccount)adbok.getAccountById(id);
		name = acc.getAccountName();
		description = acc.getDescription();
		port = acc.getHttpPort();
		password = acc.getPassword();
		user = acc.getUserName();
		conType = acc.getConType();
		context = acc.getContext();
		isAutoLogin = acc.isAutoLoging();
		host = acc.getHostName();
		
		request.getSession().setAttribute("lastSelectedAccount",acc.getId());
	}else{
		id = "";
		request.getSession().removeAttribute("lastSelectedAccount");
	}
	
	String forwardURL = request.getParameter("forwardURL");
	
	 
%>

<%@page import="xpolog.eye.media.remote.RemoteXplgAccount"%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
      function doSave(){
        document.access.action ="accountRemoteXplgAction.jsp";
        document.access.submit();
      }
      
     
      function shownHideAdv(){
		var vis = document.getElementById("advancedDiv").style.display == "";
		if(vis){
			document.getElementById("advancedDiv").style.display  = "none";		
		}else{
			document.getElementById("advancedDiv").style.display  = "";
		}	
	}
      
      

</script>
</head>

<body style="margin:0;padding:0">

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" style="margin:0;padding:0">
<input class="TEXTBOX" type="hidden" name="Id" size="10" value="<%=id%>">
<%if (forwardURL != null && forwardURL.length() > 0){ %>
<input type="hidden" name="forwardURL" value="<%=forwardURL%>">
<%}%>

<table border="0" cellpadding="0" cellspacing="0"	style="border-collapse:collapse" width="100%" height="100%">
	<tr height="10">
		<td>
			<%
			String headerUrl = BASE_DIRECTORY + "common/pageHeader.jsp";
			%>
			<jsp:include page="<%=headerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="Remote XpoLog Account" />
			</jsp:include>
		</td>
	</tr>
	<tr valign="top">
		<td>
			<table class="ADMIN_TABLE_DIV" width="100%">
				<tr>
					<td class="ADMIN_MAIN_TD">
						<table width="100%">
							<tr>
								<td style="padding-top:15">
									<table class="ADMIN_SECTION_DIV" cellpadding="0" cellspacing="0" width="100%">
										<tr>
											<td class="ADMIN_SECTION_MAIN_TD">
												<table border="0" cellpadding="0" cellspacing="0" width="100%">
		                      <tr>
		                        <td width="11%"><span class="REGULARTEXT">Name *</span></td>
		                        <td width="69%">
		                        <input class="TEXTBOX" type="text" name="Name" size="50" value="<%=name%>"></td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Description</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="Description" size="50" value="<%=description%>"></td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Host Address *</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="hostAddress" size="50" value="<%=host%>">
		                        </td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Protocol *</span></td>
		                        <td>
														<select size="1" class="TEXTBOX" name="conType" id="conType">
		                          <option class="TEXTBOX" value="http" <%=conType.equalsIgnoreCase("HTTP")?"selected" : ""%>>HTTP</option>
		                          <option class="TEXTBOX" value="https" <%=conType.equalsIgnoreCase("HTTPS")?"selected" : ""%>>HTTPS</option>
		                        </select>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">URL Context</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="context" size="50" value="<%=context%>">
		                        </td>
		                      </tr>
													<tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Port *</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="Port" size="50" value="<%=port%>"></td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Username</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="User" size="50" value="<%=user%>">
		                        </td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Password</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="password" name="Pwd" size="50" value="<%=password == null ? "" : password%>">
		                        </td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:20" colspan="2">
		                        	<span class="SMALLTEXT">* marks a manadatory field</span>
		                        </td>
		                      </tr>
		                    </table>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr height="10">
		<td>
			<%
			String footerUrl = BASE_DIRECTORY + "common/buttonsFooter.jsp";
			String cancelAction = "common/actions/cancelAction.jsp?forward=tools/addresses/addressview.jsp";
			
			String actions = "javascript:doSave()#" + cancelAction;
			%>
			<jsp:include page="<%=footerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="Save#Back to Address Book" />
				<jsp:param name="actions" value="<%=actions %>" />
			</jsp:include>
		</td>
	</tr>
</table>
</form>
<iframe id="resultFrame" name="resultFrame" style="display:none">
</body>
</html>