<%@ page language="java"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);
	//do whatever needed to remove the account
	String accountId = request.getParameter("accountId");
	boolean success = true;
	String message = "";
	if (accountId != null) {
		AddressBook adbok = AddressBook.getInstance();
		Account acc = adbok.getAccountById(accountId);
		String name = "";
		if (acc != null) {
			name = acc.getAccountName();
		}
		//audit
		AuditManager.getInstance().write(
				AuditConstants.BASIC_AUDIT_LEVEL, userContext,
				AuditConstants.CHANGE, "remove account",
				AuditConstants.ACCOUNTS, "remove account " + name);

		try {
			adbok.removeAccount(accountId,userContext);
			success = true;
		} catch (Exception e) {
			ErrorModel.log.error("Failed to remove account " + name
					+ " with id " + accountId, e);
			success = false;
			message = e.getMessage();
		}
	}else {
		message = "No account was given, please refresh and try again";
	}
	String xml = GridModelActionsHelper.getResultXML(success, message);

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	
	out.write(xml);
	out.flush();
%>
