<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.sms.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.net.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	
	String ERROR_OBJ = "ERROR_OBJ";
	UserContext userContext = UserEnvironment.getUserContext(request);

	String Name,Description,number,Port,User,Pwd,Id;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	number = request.getParameter("SmsNumber");
	Id = request.getParameter("Id");
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
    	errmodel.addError("No Name was supplied.");
  	}
  	if(number == null || number.equals("")){
    	errmodel.addError("Target SMS number was not supplied.");
  	}
 
  	if(errmodel.getErrorCount() != 0){
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
  	}
	
	
	SmsAccount htac = null;
	AddressBook adbok = AddressBook.getInstance();
	if(Id != null){
		htac = (SmsAccount )adbok.getAccountById(Id);
		
	}
	if(htac == null){
		htac = new SmsAccount();
	}
	
	htac.setAccountName(Name);
	htac.setNumber(number);
	htac.setDescription(Description);
	
	adbok.addAccount(htac,userContext);
	adbok.saveAddressBook();
	
	//	audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		  			userContext, AuditConstants.CHANGE, "add/edit account", AuditConstants.CONFIGURATION, "add/edit sms account " + Name);

	response.sendRedirect(BASE_DIRECTORY + "tools/addresses/addressview.jsp?addressType=sms");
%>

