<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.security.cert.*"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.site.TelShActivityManager"%>

<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION,true)){
    return;
  }
	String ACCOUT_ID = "ID";
	String id = request.getParameter(ACCOUT_ID);
	
	String ftpUrl = "";
	String name = "";
	String description = "";
	String port = "22";
	String user = "";
	String password = "";
	String conType = TelnetAccount.TYPE_SFTP;
	boolean isPublicKey = false;
	String privateKeyPath = "";
	String adminEmail = "";
	boolean enabled = true;
	
	String certificateId = "";
	boolean isCertificateAuth = false;
	TelnetAccountPolicy telnetAccountPolicy = null;
  if(id != null){
		AddressBook adbok = AddressBook.getInstance();
		TelnetAccount acc = (TelnetAccount)adbok.getAccountById(id);
		name = acc.getAccountName();
		description = acc.getDescription();
		ftpUrl = acc.getNetAddress();
		port = String.valueOf(acc.getPort());
		password = acc.getPassword();
		user = acc.getUserName();
		conType = acc.getTypeOfConnecion();
		certificateId = acc.getCertificateId(); 
		isCertificateAuth = acc.isCertificate();
		isPublicKey = acc.isPublicKey();
		privateKeyPath = acc.getPrivateKeyPath();
		telnetAccountPolicy = (TelnetAccountPolicy)acc.getAccountPolicy();
		adminEmail = acc.getAdminEmail();
		if (adminEmail == null){
			adminEmail = "";
		}
		enabled = acc.isEnabled();
		
		request.getSession().setAttribute("lastSelectedAccount",acc.getId());
	}else{
		id = "";
		request.getSession().removeAttribute("lastSelectedAccount");
	}
	
	CertificatesManager cmgr = CertificatesManager.getInstance();
	List list = cmgr.getAllXPLG509Certificates();
	String forwardURL = request.getParameter("forwardURL");
	
	boolean showX509 = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("media.ssh.ext.x509.show",false);
	
	//account policy
	if(telnetAccountPolicy == null) {
  	telnetAccountPolicy = TelShActivityManager.getInstance().getDefaultTelnetAccountPolicy();
	}
  long sshPoolTimeoutInterval = -1, sshSessionTimeoutInterval = -1;
  String sshPoolTimeoutIntervalValueType = "", sshSessionTimeoutIntervalValueType = "";
  int sshMaxConnections = -1, sshMaxSessionsPerConnection = -1;
  if(telnetAccountPolicy != null) {
  	sshPoolTimeoutInterval = telnetAccountPolicy.getPoolTimeoutInterval();
  	sshPoolTimeoutIntervalValueType = telnetAccountPolicy.getPoolTimeoutIntervalValueType();
  	if(sshPoolTimeoutIntervalValueType.equals("min")) {
  		sshPoolTimeoutInterval = sshPoolTimeoutInterval / 1000 / 60;
  	}else if(sshPoolTimeoutIntervalValueType.equals("hour")) {
  		sshPoolTimeoutInterval = sshPoolTimeoutInterval / 1000 / 60 / 60;
  	}
  	sshSessionTimeoutInterval = telnetAccountPolicy.getSessionTimeoutInterval();
  	sshSessionTimeoutIntervalValueType = telnetAccountPolicy.getSessionTimeoutIntervalValueType();
  	if(sshSessionTimeoutInterval != -1) {
	  	if(sshSessionTimeoutIntervalValueType.equals("min")) {
	  		sshSessionTimeoutInterval = sshSessionTimeoutInterval / 1000 / 60;
	  	}else if(sshSessionTimeoutIntervalValueType.equals("hour")) {
	  		sshSessionTimeoutInterval = sshSessionTimeoutInterval / 1000 / 60 / 60;
	  	}
  	}
  	sshMaxConnections = telnetAccountPolicy.getMaxConnections();
  	sshMaxSessionsPerConnection = telnetAccountPolicy.getMaxSessionsPerConnection();
  }
  
	Configuration conf = Configuration.getInstance();
	MailConfig mail = conf.getMailConfigurationManager();
	String host = mail.getSmtpHost();
	boolean showMailSettings = host.length() == 0 || host.equals(MailConfig.DEF_SMTP_ADDRESS); 

%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>

<script>
	var mailSettingsOk = <%=!showMailSettings%> 
      function doSave(){
      	if (!mailSettingsOk){
      		if (document.access.adminEmail.value != ""){
	      		document.getElementById("adminGeneralDivMailSettings").style.display = "";
	      		return;
      		}
      	}
        document.access.action ="accountSshAction.jsp";
        document.access.submit();
      }
      
      function certificateChecked(onLoad){
        <%if (showX509){%>
        if(document.access.useCert.checked) {        
        	document.access.Pwd.disabled=true;
        }else {        	
        	document.access.Pwd.disabled=false;
        }
        <%}%>
      }
      
      function showHideAdminDiv(baseDir,suffix,closeOthers,checkOnOpen){
			  if (document.getElementById("adminHeaderContent" +suffix).style.display == "none"){
			    showAdminDiv(baseDir,suffix,closeOthers,checkOnOpen);
			  }else {
			    hideAdminDiv(baseDir,suffix);
			  }
			}
			
			var suffixes = new Array();
			function showAdminDiv(baseDir,suffix,closeOthers,checkOnOpen){
			  var exist = false;
			  for (var i = 0;i < suffixes.length;i++){
			    if (suffixes[i] == suffix){
			      exist = true;
			    }else {
			      if (closeOthers){
			        hideAdminDiv(baseDir,suffixes[i]);
			      }
			    }
			  }
			  if (!exist){
			    suffixes[suffixes.length] = suffix;
			  }
			  document.getElementById("adminHeaderImg" +suffix).src = baseDir + "images/common/adminHeaderOpenArrow.gif";
			  document.getElementById("adminHeaderContent" +suffix).style.display = "";
			  if (checkOnOpen){
			    document.getElementById("headerCheckbox" +suffix).checked = true;
			  }
			}
			
			function hideAdminDiv(baseDir,suffix){
			  if (!document.getElementById("adminHeaderContent" +suffix)) return;
			  
			  document.getElementById("adminHeaderImg" +suffix).src = baseDir + "images/common/adminHeaderCloseArrow.gif";
			  document.getElementById("adminHeaderContent" +suffix).style.display = "none";
			}
      
      function toggleAccountPolicy(type) {
      	if(type == 'default') {
      		enableAccountPolicyElements(true);
      	}else {
      		enableAccountPolicyElements(false);
      	}
      }
      
      function enableAccountPolicyElements(disabled) {
      	document.getElementById("sshPoolTimeoutInterval").disabled = disabled;
      	document.getElementById("sshPoolTimeoutIntervalValueType").disabled = disabled;
      	document.getElementById("sshSessionTimeoutInterval").disabled = disabled;
      	document.getElementById("sshSessionTimeoutIntervalValueType").disabled = disabled;
      	document.getElementById("sshMaxConnections").disabled = disabled;
      	document.getElementById("sshMaxSessionsPerConnection").disabled = disabled;
      }
      
		<% if (showMailSettings){ %>
		function saveMailSettings() {
				var smtpHost = document.getElementById("SMTPHost").value;
				if(smtpHost == '') {
					alert("SMTP host cannot be empty");
					return;
				}else if(smtpHost == 'my.domain.com') {
					alert("SMTP host cannot be my.domain.com");
					return;
				}
			
				var params = "";
				params += "SMTPHost=" + document.getElementById("SMTPHost").value;
				params += "&SMTPProt=" + document.getElementById("SMTPProt").value;
				params += "&systemMailAddress=" + document.getElementById("systemMailAddress").value;
				params += "&adminMail=" + document.getElementById("adminMail").value;
				sendAjaxRequest("../../../tasks/mail/mailSettingsAction.jsp?"+params,function(req){
					var result = req.responseText;	
					result = result.replace(/^\s+|\s+$/g, '') ;
					if(!result){
						alert("Saving mail setting failed");
						return;			
					}
					if(result.indexOf("ok") != -1) {
						//document.getElementById("adminGeneralDivMailSettings").style.display = "none";
						mailSettingsOk = true;
						doSave();
					}
				});
			}
		<%}%>
</script>

<% if (showMailSettings){ %>
<jsp:include page="../../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="suffix" value="MailSettings"/> 
	<jsp:param name="width" value="570px"/> 
	<jsp:param name="height" value="245px"/>
	<jsp:param name="left" value="100px"/>
	<jsp:param name="top" value="50px"/>
	<jsp:param name="zIndex" value="200"/>
	<jsp:param name="includePath" value="tasks/mail/mailSettings.jsp?isShort=true"/>	
	<jsp:param name="title" value="Mail Settings"/> 
	<jsp:param name="message" value="Please specify the following mail settings before adding a report email:"/> 
	<jsp:param name="display" value="none"/>
	<jsp:param name="actionsNames" value="Save"/> 
	<jsp:param name="actions" value="javascript:saveMailSettings()"/> 
</jsp:include>
<%} %>

</head>

<body style="margin:0;padding:0">

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" style="margin:0;padding:0">
<input class="TEXTBOX" type="hidden" name="Id" size="10" value="<%=id%>">
<%if (forwardURL != null && forwardURL.length() > 0){ %>
<input type="hidden" name="forwardURL" value="<%=forwardURL%>">
<%}%>

<table border="0" cellpadding="0" cellspacing="0"	style="border-collapse:collapse" width="100%" height="100%">
	<tr height="10">
		<td>
			<%
			String headerUrl = BASE_DIRECTORY + "common/pageHeader.jsp";
			%>
			<jsp:include page="<%=headerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="headerTitle" value="SSH Account" />
			</jsp:include>
		</td>
	</tr>
	<tr valign="top">
		<td>
			<table class="ADMIN_TABLE_DIV" width="100%">
				<tr>
					<td class="ADMIN_MAIN_TD">
						<table width="100%">
							<tr>
								<td style="padding-top:15">
									<table class="ADMIN_SECTION_DIV" cellpadding="0" cellspacing="0" width="100%">
										<tr>
											<td class="ADMIN_SECTION_MAIN_TD">
												<table border="0" cellpadding="0" cellspacing="0" width="100%">
		                      <tr>
		                        <td width="11%"><span class="REGULARTEXT">Name *</span></td>
		                        <td width="69%">
		                        <input class="TEXTBOX" type="text" name="Name" size="50" value="<%=name%>"></td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Description</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="Description" size="50" value="<%=description%>"></td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Host Address *</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="Url" size="50" value="<%=ftpUrl%>"></td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Port *</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="Port" size="50" value="<%=port%>"></td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Username *</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="text" name="User" size="50" value="<%=user%>"></td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Password *</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="password" name="Pwd" size="50" value="<%=password%>"></td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:10"><span class="REGULARTEXT">Enabled</span></td>
		                        <td>
		                        <input class="TEXTBOX" type="checkbox" name="enabled"value="true" <%=enabled ? " checked" : "" %>></td>
		                      </tr>
		                      <tr>
		                        <td style="padding-top:20" colspan="2">
		                        	<span class="SMALLTEXT">* marks a manadatory field</span>
		                        </td>
		                      </tr>
		                      <tr>
														<td style="padding-top:30" colspan="2">
															<div id="advancedSettingsDiv">																				
																<table border="0" cellpadding="0" cellspacing="0" width="100%">
																	<tr>
																		<td>																										
																			<table border="0" cellpadding="0" cellspacing="0" width="100%" class="ADV_SETTINGS_BAR_HEADER">
																				<tr>
																					<td>																										
																						<jsp:include page="../../../common/adminSectionHeader.jsp" flush="true">
																							<jsp:param name="baseDirectory" value="../../../" />
																							<jsp:param name="suffix" value="advancedSettings" />				
																							<jsp:param name="headerName" value="Advanced Settings" />
																							<jsp:param name="startOpen" value="false" />
																							<jsp:param name="showCheckBox" value="false" />
																							<jsp:param name="closeOthers" value="false" />
																							<jsp:param name="openOnClick" value="true" />
																						</jsp:include>
																					</td>
																				</tr>
																			</table>
																		</td>
																	</tr>
																	<tr>
																		<td>
																			<table border="0" id="adminHeaderContentadvancedSettings" cellpadding="0" cellspacing="0" style="display:none" width="100%" class="ADV_SETTINGS_TABLE">																				
																				<tr valign="top">
																					<td style="padding-left:20;border-top:1 solid white">
																						<div id="advGeneral">																				
																							<table border="0" cellpadding="0" cellspacing="0" width="100%">
																								<tr>
																									<td>																										
																										<table border="0" cellpadding="0" cellspacing="0" width="100%" class="ADV_SETTINGS_BAR">
																											<tr>
																												<td>																										
																													<jsp:include page="../../../common/adminSectionHeader.jsp" flush="true">
																														<jsp:param name="baseDirectory" value="../../../" />
																														<jsp:param name="suffix" value="General" />
																														<jsp:param name="level" value="1" />
																														<jsp:param name="headerName" value="General" />
																														<jsp:param name="startOpen" value="false" />
																														<jsp:param name="showCheckBox" value="false" />
																														<jsp:param name="closeOthers" value="false" />
																														<jsp:param name="openOnClick" value="true" />
																													</jsp:include>
																												</td>
																											</tr>
																										</table>
																									</td>
																								</tr>
																								<tr>
																									<td>																										
																										<table border="0" id="adminHeaderContentGeneral" cellpadding="0" cellspacing="0" style="display:none" width="100%" class="ADV_SETTINGS_TABLE">
																											<tr>
																                        <td width="24">&nbsp;</td>
																												<td width="120"><span class="REGULARTEXT">Private Key Path</span></td>
																                        <td style="padding-left:3px">
																                        <input class="TEXTBOX" type="text" name="privateKeyPath" size="50" value="<%=privateKeyPath%>">&nbsp;<span class="SMALLTEXT">(Used for public key authentication)</span></td>
																                      </tr>
																                      <tr>
																                        <td style="padding-top:15">&nbsp;</td>
																												<td><span class="REGULARTEXT"><input type="checkbox" name="conType" value="conType" <%=conType.equals(TelnetAccount.TYPE_SCP) ? "checked" : ""%>>SCP</span></td>
																                        <td nowrap style="padding-left:3px"><span class="REGULARTEXT">Use Secure Copy (SCP) for file transfer<span> <span class="SMALLTEXT">(default is SFTP)</span></td>
																                      </tr>
																											<tr>
																                        <td width="24">&nbsp;</td>
																												<td width="120"><span class="REGULARTEXT"><nobr>Administrator Email Address</nobr></span></td>
																                        <td style="padding-left:3px">
																                        <input class="TEXTBOX" type="text" name="adminEmail" size="50" value="<%=adminEmail%>">&nbsp;<span class="SMALLTEXT">(Used to send notification upon connection failure)</span></td>
																                      </tr>
																										</table>
																									</td>
																								</tr>																						
																							</table>			
																						</div>
																					</td>													                      
																				</tr>
																				
																				<tr valign="top">
																					<td style="padding-left:20;border-top:1 solid white">
																						<div id="advAccountPolicy">																				
																							<table border="0" cellpadding="0" cellspacing="0" width="100%">
																								<tr>
																									<td>																										
																										<table border="0" cellpadding="0" cellspacing="0" width="100%" class="ADV_SETTINGS_BAR">
																											<tr>
																												<td>																										
																													<jsp:include page="../../../common/adminSectionHeader.jsp" flush="true">
																														<jsp:param name="baseDirectory" value="../../../" />
																														<jsp:param name="suffix" value="AccountPolicy" />
																														<jsp:param name="level" value="1" />
																														<jsp:param name="headerName" value="Account Policy" />
																														<jsp:param name="startOpen" value="false" />
																														<jsp:param name="showCheckBox" value="false" />
																														<jsp:param name="closeOthers" value="false" />
																														<jsp:param name="openOnClick" value="true" />
																													</jsp:include>
																												</td>
																											</tr>
																										</table>
																									</td>
																								</tr>
																								<tr>
																									<td>																										
																										<table border="0" id="adminHeaderContentAccountPolicy" cellpadding="0" cellspacing="0" style="display:none" width="100%" class="ADV_SETTINGS_TABLE">
																											<tr>
																												<td width="24">&nbsp;</td>
																												<td>
																													<input type="radio" id="accountPolicyType" name="accountPolicyType" value="default" onClick="javascript:toggleAccountPolicy('default')" <%=telnetAccountPolicy.isDefault() ? "checked" : "" %>><span class="REGULARTEXT">Use default policy</span>
																												</td>
																											</tr>
																											<tr>
																												<td style="padding-top:15">&nbsp;</td>
																												<td>
																													<input type="radio" id="accountPolicyType" name="accountPolicyType" value="custom" onClick="javascript:toggleAccountPolicy('custom')" <%=telnetAccountPolicy.isDefault() ? "" : "checked" %>><span class="REGULARTEXT">Define a custom policy</span>
																												</td>
																											</tr>
																											<tr>
																												<td style="padding-top:15">&nbsp;</td>
																												<td style="padding-left:20">
																													<table border="0" width="100%" cellspacing="0" cellpadding="0">
																														<tr>
																															<td style="padding-top:10">
																																<span class="REGULARTEXT">Connection pool timeout interval  
																																	<input type="text" id="sshPoolTimeoutInterval" name="sshPoolTimeoutInterval" value="<%=String.valueOf(sshPoolTimeoutInterval)%>" size="5" <%=telnetAccountPolicy.isDefault() ? "disabled" : "" %>>
																																</span>
																																<select id="sshPoolTimeoutIntervalValueType" name="sshPoolTimeoutIntervalValueType" size="1" <%=telnetAccountPolicy.isDefault() ? "disabled" : "" %>>
																																	<option value="min" <%=sshPoolTimeoutIntervalValueType.equals("min") ? "selected" : "" %>>minutes</option>
																																	<option value="hour" <%=sshPoolTimeoutIntervalValueType.equals("hour") ? "selected" : "" %>>hours</option>
																																</select>
																															</td>
																														</tr>
																														<tr>
																															<td>
																																<span class="SMALLTEXT"> the allowed period of connections inactivity before a pool is closed; type -1 to close the pool as soon as possible</span>
																															</td>
																														</tr>
																														<tr>
																															<td style="padding-top:10">
																																<span class="REGULARTEXT">User session timeout interval  
																																	<input type="text" id="sshSessionTimeoutInterval" name="sshSessionTimeoutInterval" value="<%=sshSessionTimeoutInterval == -1 ? "" : String.valueOf(sshSessionTimeoutInterval)%>" size="5" <%=telnetAccountPolicy.isDefault() ? "disabled" : "" %>>
																																</span>
																																<select id="sshSessionTimeoutIntervalValueType" name="sshSessionTimeoutIntervalValueType" size="1" <%=telnetAccountPolicy.isDefault() ? "disabled" : "" %>>
																																	<option value="min" <%=sshSessionTimeoutIntervalValueType.equals("min") ? "selected" : "" %>>minutes</option>
																																	<option value="hour" <%=sshSessionTimeoutIntervalValueType.equals("hour") ? "selected" : "" %>>hours</option>
																																</select>
																															</td>
																														</tr>
																														<tr>
																															<td>
																																<span class="SMALLTEXT"> the allowed period of user inactivity before a log is closed. leave blank for unlimited inactivity period</span>
																															</td>
																														</tr>
																														<tr>
																															<td style="padding-top:10">
																																<span class="REGULARTEXT">Number of connections allowed to remote machine  
																																	<input type="text" id="sshMaxConnections" name="sshMaxConnections" value="<%=sshMaxConnections == -1 ? "" : String.valueOf(sshMaxConnections)%>" size="5" <%=telnetAccountPolicy.isDefault() ? "disabled" : "" %>>
																																</span>
																															</td>
																														</tr>
																														<tr>
																															<td>
																																<span class="SMALLTEXT"> the allowed number of connections to a remote machine. leave blank for unlimited number of connections</span>
																															</td>
																														</tr>
																														<tr>
																															<td style="padding-top:10">
																																<span class="REGULARTEXT">Number of sessions allowed per connection
																																	<select id="sshMaxSessionsPerConnection" name="sshMaxSessionsPerConnection" size="1" <%=telnetAccountPolicy.isDefault() ? "disabled" : "" %>>
																																		<option value="2" <%=sshMaxSessionsPerConnection == 2 ? "selected" : "" %>>2</option>
																																		<option value="3" <%=sshMaxSessionsPerConnection == 3 ? "selected" : "" %>>3</option>
																																		<option value="4" <%=sshMaxSessionsPerConnection == 4 ? "selected" : "" %>>4</option>
																																		<option value="5" <%=sshMaxSessionsPerConnection == 5 ? "selected" : "" %>>5</option>
																																		<option value="6" <%=sshMaxSessionsPerConnection == 6 ? "selected" : "" %>>6</option>
																																		<option value="7" <%=sshMaxSessionsPerConnection == 7 ? "selected" : "" %>>7</option>
																																	</select>  
																																</span>
																															</td>
																														</tr>
																														<tr>
																															<td>
																																<span class="SMALLTEXT"> the number of sessions that can be opened using the same connection</span>
																															</td>
																														</tr>
																													</table>
																												</td>
																											</tr>
																										</table>
																									</td>
																								</tr>																						
																							</table>			
																						</div>
																					</td>													                      
																				</tr>
																				
																				<%if (showX509){ %>
																				<tr valign="top">
																					<td style="padding-left:20;border-top:1 solid white">
																						<div id="advX509">																				
																							<table border="0" cellpadding="0" cellspacing="0" width="100%">
																								<tr>
																									<td>																										
																										<table border="0" cellpadding="0" cellspacing="0" width="100%" class="ADV_SETTINGS_BAR">
																											<tr>
																												<td>																										
																													<jsp:include page="../../../common/adminSectionHeader.jsp" flush="true">
																														<jsp:param name="baseDirectory" value="../../../" />
																														<jsp:param name="suffix" value="X509" />
																														<jsp:param name="level" value="1" />
																														<jsp:param name="headerName" value="X.509 Settings" />
																														<jsp:param name="startOpen" value="false" />
																														<jsp:param name="showCheckBox" value="false" />
																														<jsp:param name="closeOthers" value="false" />
																														<jsp:param name="openOnClick" value="true" />
																													</jsp:include>
																												</td>
																											</tr>
																										</table>
																									</td>
																								</tr>
																								<tr>
																									<td>																										
																										<table border="0" id="adminHeaderContentX509" cellpadding="0" cellspacing="0" style="display:none" width="100%" class="ADV_SETTINGS_TABLE">
																											<tr>
																                      <%
																                      String certSel = "";
																                      	if(isCertificateAuth){
																                      		certSel = "checked";
																                      	}
																                      %>
																                        <td colspan="2"><input type="checkbox" name="useCert" value="useCert" <%=certSel%> onClick="javascript:certificateChecked(false)"><span class="REGULARTEXT">&nbsp;Use X.509 certificate for authentication</span></td>                        
																                      </tr>
																										</table>
																									</td>
																								</tr>																						
																							</table>			
																						</div>
																					</td>													                      
																				</tr>
																				<%} %>
																			</table>
																		</td>
																	</tr>
																</table>
															</div>
														</td>
													</tr>
		                    </table>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr height="10">
		<td>
			<%
			String footerUrl = BASE_DIRECTORY + "common/buttonsFooter.jsp";
			String cancelAction = "common/actions/cancelAction.jsp?forward=tools/addresses/addressview.jsp";
			
			String actions = "javascript:doSave()#" + cancelAction;
			%>
			<jsp:include page="<%=footerUrl %>" flush="true">
				<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
				<jsp:param name="align" value="right" />
				<jsp:param name="actionNames" value="Save#Back to Address Book" />
				<jsp:param name="actions" value="<%=actions %>" />
			</jsp:include>
		</td>
	</tr>
</table>
</form>
<iframe id="resultFrame" name="resultFrame" style="display:none">
</body>
</html>