<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.data.log.external.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.image.*"%>
<%! 
	static final String BASE_DIRECTORY = "../../";
%>
     
<%
  String ERROR_OBJ = "ERROR_OBJ";
	String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";
  
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION,true)){
    return;
  }
  
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  UserContext userContext = UserEnvironment.getUserContext(request);
	
	ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute(CONF_IMG_BUILDER);
	
	ErrorModel errmodel = new ErrorModel(); 
	
 	List allAccountsList = AddressBook.getInstance().getAccountsByFilter(null,userContext);
 	if(allAccountsList == null) {
 		allAccountsList = new ArrayList();
 	}
 	ArrayList logListFromConfigurationImg = new ArrayList(builder.getLogsToExp().values());
 	if(logListFromConfigurationImg == null) {
 		logListFromConfigurationImg = new ArrayList();
 	}
 	HashSet relevantAccounts = new HashSet();
 	
 	for(int j=0;j<logListFromConfigurationImg.size();++j) {
		LogBrowsingManager lbm = mgmt.getLogBrowserManager((String)logListFromConfigurationImg.get(j));
		if (lbm == null){
			continue;
		}
		try {
  		LinearDataSource dc = lbm.getDefaultLinearDataBuilder().getLinearDataSource();
	  	if(dc instanceof IntervalDataSource) {
		  	String accRelevantId = IntervalAdminHelper.getAccount(lbm).getId();
		  	relevantAccounts.add(accRelevantId);
		  }
		  HashMap accounts = builder.getAccountsToExp();
		  if (accounts != null){
			  Iterator it = accounts.keySet().iterator();
			  while (it.hasNext()){
				  String acc = (String)it.next();
      	  relevantAccounts.add(acc);
			  }
		  }
		}finally {
  		lbm.dispose();
		}
  }
	WizardUIController uiCtrl = builder.getUiController();
	uiCtrl.updatePageId("tools/confImage/confImageAccounts.jsp");
	String forwardUrl = uiCtrl.getForwardPage();
	String backwardUrl = uiCtrl.getBackwardPage();
	String cancelUrl = uiCtrl.getCancelUrl();
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
	  baseDirectory = "<%=BASE_DIRECTORY%>";
     
	  function doNext(){
        document.access.action ="<%=BASE_DIRECTORY+forwardUrl%>";
        document.access.submit();
      }
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="56%" class="TOPLEFTBORDER" colspan="2">
                <span class="PAGEHEADER">&nbsp;&nbsp;&nbsp;Configuration Image Accounts</span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <tr>
                <td width="15%" height="18"><span class="HEADER">XpoLog Accounts</span></td>
              </tr>
              <tr>
                <td width="100%" height="18"><span class="SMALLTEXT">The checked accounts are accounts that were found associated to the selected logs of this configuration image.</span></td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <%for(int i=0;i<allAccountsList.size();++i) {
              	  String checked = "";
              	  Account acc = (Account)allAccountsList.get(i);
              	  if(relevantAccounts.contains(acc.getId())) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }	
              %>
               <tr>
                    <td><input id="<%=acc.getId()%>" name="<%=acc.getId()%>" type="checkbox"  <%=checked%>><span class="REGULARTEXT"><%=acc.getAccountName()%> - <span class="SMALLTEXT">(Type: <%=acc.getType()%>, Description: <%=acc.getDescription()%>)</span></span></td>
                  </tr> 
              <%}%>
          
         <tr><td colspan="3">&nbsp;</td></tr>
         <tr><td colspan="3">&nbsp;</td></tr>
          <tr>
             <td width="*" colspan="3" align="center"><a href="<%=backwardUrl!=null ? (BASE_DIRECTORY+backwardUrl) :"javascript:history.go(-1)"%>" class="LINK">previous</a>&nbsp;&nbsp;
             <a href="javascript:doNext()" class="LINK">next</a>&nbsp;&nbsp;
             <a href="<%=BASE_DIRECTORY+cancelUrl%>" class="LINK">cancel</a></td>
          </tr>
          <tr><td colspan="3">&nbsp;</td></tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
       <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>