<%@ page language="java"%>

<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.config.image.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
	String ERROR_OBJ = "ERROR_OBJ";
	String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";

	ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute("CONF_IMG_BUILDER");
	
	ErrorModel errmodel = new ErrorModel(); 
 	HashMap logs = builder.getLogsToExp();
 	HashMap checkedAccounts = new HashMap();
 	
 	//check which of the accounts was checked and add it to map.
 	List allAccountsList = AddressBook.getInstance().getAllAccountList();
 	if(allAccountsList == null) {
 		allAccountsList = new ArrayList();
 	}
 	Account acc = null;
 	boolean accountChecked = false;
 	String accountStr = null;
 	for(int i=0;i<allAccountsList.size();++i) {
 		acc = (Account)allAccountsList.get(i);
 		accountStr = request.getParameter(acc.getId());
 		accountChecked = accountStr != null && accountStr.equalsIgnoreCase("on");
 		if(accountChecked) {
 			checkedAccounts.put(acc.getId(),acc.getId());
 		}
 	}
    
	//verify that the conf image is not empty.
	if(checkedAccounts.size() == 0 && (logs == null || logs.size() == 0)) {
		errmodel.addError("You cannot save an empty configuration image. Please choose logs or accounts to save in this configuration.");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
	}
	
	builder.setAccountsToExp(checkedAccounts);
    
	WizardUIController uiCtrl = builder.getUiController();
	uiCtrl.updatePageId("tools/confImage/confImageAccountsAction.jsp");
	String forwardUrl = uiCtrl.getForwardPage();
	response.sendRedirect(BASE_DIRECTORY + forwardUrl);
%>

