<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.data.log.external.*"%>
<%@ page import="xpolog.eye.admin.builders.SimpleLogBrowserBuilder"%>
<%@ page import="xpolog.eye.admin.builders.XMLLogBrowserBuilder"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.image.*"%>
<%@page import="xpolog.eye.meta.MetaDataManager"%>
<%@page import="xpolog.eye.admin.builders.SshSimpleBuilder"%>

<%! 
	static final String BASE_DIRECTORY = "../../";
%>
     
<%
  String ERROR_OBJ = "ERROR_OBJ";
	String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";
	if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.ConfigurationPermissions.CONF_IMAGE_PERMISSION,true)){
    return;
  }
  SiteManagment mgmt = SiteManagment.getInstance();
	ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute("CONF_IMG_BUILDER");
	
	ConfigurationPublisher publisher = builder == null ? null : builder.getCurrentPublisher();
	
	ErrorModel errmodel = new ErrorModel(); 
	if(publisher == null){
		errmodel.addError("No Publisher was saved on session.");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
  }
	
	HashMap logs = builder.getLogsToExp();
	HashSet logsToAdd = new HashSet();
	
	
	
	HashMap metaDatas = builder.getMetaDataToExp();
	if(metaDatas != null && metaDatas.size() > 0){
		MetaDataManager metaDataMgr = SiteManagment.getInstance().getMetaDataMgr();
		Iterator it = builder.getMetaDataToExp().keySet().iterator();
		while(it.hasNext()){
			String metaId = (String)it.next();
			if(metaId == null){
				continue;
			}
			String[] members = metaDataMgr.getXplgObjectsByMetaData(metaId);
			if(members == null){
				continue;
			}
			for(int i=0 ; i<members.length;i++){
				int indx = members[i].indexOf('-');
				if(indx == -1){
					continue;
				}else{
					String type = members[i].substring(0,indx);
					String id = members[i].substring(indx+1, members[i].length());
					if(type.equals(XpoLogObjectTypes.MODULE_TYPE)){
							//get module's logs
							Module m = SiteManagment.getInstance().getModuleFromId(id);
							if(m != null){
								HashSet logsIds = m.getAllChildren(null,true,false);
								if(logsIds != null){
									Iterator iter = logsIds.iterator();
									while(iter.hasNext()){
										String logId = (String)iter.next();
										if(builder.getLogsToExp() != null && !builder.getLogsToExp().containsKey(logId)){
											logsToAdd.add(logId);
										}
									
									}
								}
							}
					}else if(type.equals(XpoLogObjectTypes.LOG_TYPE)){
						if(builder.getLogsToExp() != null && !builder.getLogsToExp().containsKey(id)){
							logsToAdd.add(id);
						}
					}
				}
			}
			
		}
	
	}

	
	
	
	
	ArrayList logsList = null;
	if(logs != null) {
		logsList = new ArrayList(logs.values());
		if(logsToAdd != null && logsToAdd.size() > 0){
			logsList.addAll(logsToAdd);
		}
		Collections.sort(logsList);
	}else {
		logsList = new ArrayList();
	}
	ConfigurationPublisher oldPublisher = builder.getConfigurationPublisher(publisher.getId());
	Properties oldProperties = oldPublisher == null ? null : oldPublisher.getProperties();

	WizardUIController uiCtrl = builder.getPublisherUiController();
	uiCtrl.updatePageId("tools/confImage/confImageLogsPaths.jsp");
	String forwardUrl = uiCtrl.getForwardPage();
	String backwardUrl = uiCtrl.getBackwardPage();
	String cancelUrl = uiCtrl.getCancelUrl();
	
	int numOfGlobalVariables = Configuration.getInstance().getPropertiesManager().getPropertyAsInt("configImage.publisher.numOfGlobalVariables",1);
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
  baseDirectory = "<%=BASE_DIRECTORY%>";
 
  function doNext(){
    document.access.action ="<%=BASE_DIRECTORY + forwardUrl%>";
    updateTargetPaths();
    document.access.submit();
  }
  
  function goUpdateIdentical(logSeqNum){
  	lpath = eval("document.access.localpath_"+logSeqNum);
  	tpath = eval("document.access.targetpath_"+logSeqNum);
  	if (!lpath || !tpath){
  		return false;
  	}
  	for (var i=0; i<<%=logsList.size()%>; i++){
  		lpath1 = eval("document.access.localpath_"+i);
  		tpath1 = eval("document.access.targetpath_"+i);
  		if (lpath1 && tpath1 && lpath1.value == lpath.value){
  			tpath1.value = tpath.value;
  		}
  	}
  }
  
  function updateTargetPaths(){
 		var paths = "";
  	for (var i=0; i<<%=logsList.size()%>; i++){
  	number_of_locations = eval("document.access.logid_size_"+i);
  	for(j = 0 ; number_of_locations && j < number_of_locations.value ; j++){
  		logid = eval("document.access.logid_"+i+"_"+j); 		
  		lpath = eval("document.access.localpath_"+i+"_"+j); 		
   		tpath = eval("document.access.targetpath_"+i+"_"+j);
 			if (logid && lpath && lpath.value!="" && tpath && tpath.value!=""){
	 			paths += (paths==""?"":"|")+("<%=ConfigurationImage.LOG_ENTRY_IN_PROPERTIES%>_"+logid.value+"="+lpath.value + "*" +tpath.value);
	 		}
  	}
  	}
  	document.access.targetPaths.value = paths;
  }
  
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<input type="hidden" name="targetPaths">
<table border="0" width="100%" cellspacing="0" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="5" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="56%" class="TOPLEFTBORDER">
                <span class="PAGEHEADER">&nbsp;Configuration Image logs paths</span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td colspan="2">&nbsp;</td>
              </tr>
              <tr>
                <td colspan="2" height="18"><span class="HEADER">Log paths</span></td>
              </tr>
              <tr>
                <td colspan="2" height="18"><span class="SMALLTEXT">Please specify for each log the destination path that it will have in the target machine.</span></td>
              </tr>
              <tr><td colspan="2">&nbsp;</td></tr>
            </table>
            </td>
          </tr>
     			<tr>
          	<td>
            <table border="0" cellpadding="2" cellspacing="0"  width="100%">
            	<tr>
                <td width="25%" align="left"><span class="HEADER">Global</span></td>
                <td width="25%" align="center"><span class="HEADER">Local path</td>
                <td width="25%" align="center"><span class="HEADER">Target path</td>
                <td width="25%" align="center">&nbsp;</td>
              </tr>
              <%
                String globalPathSource = "";
                String globalPathTarget = "";
                Properties prop = oldProperties;
                for (int i = 1; i < 1000;i++){
                  globalPathSource =  prop == null ? null : prop.getProperty(ConfigurationImage.GLOBAL_LOG_ENTRY_KEY_PROPERTIES+"_"+i);                  
       						if (globalPathSource != null && globalPathSource.length() > 0){          
				            globalPathTarget = prop.getProperty(ConfigurationImage.GLOBAL_LOG_ENTRY_VALUE_PROPERTIES+"_"+i);           
          			  }else {
          			    globalPathSource = "";
          			    globalPathTarget = "";
          			    if (i > numOfGlobalVariables){
          			      break;
          			    }
          			  }
              %>
              <tr>
	              <td width="25%"><span class="SMALLTEXT"><b><%=i%>.</b></span></td>
	              <td width="25%"><input type="text" name="globalpathSource_<%=i%>" size="50" value="<%=globalPathSource%>"></td>
	              <td width="25%"><input type="text" name="globalpathTarget_<%=i%>" size="50" value="<%=globalPathTarget%>"></td>
	              <td width="25%">&nbsp;</td>
	            </tr>
	            <%}%>
	            </table>
	          </td>
	        </tr>
          <tr>
          	<td>
            <table border="0" cellpadding="2" cellspacing="0"  width="100%">
            	<tr>
                <td width="25%" align="left"><span class="HEADER">Log Name</span></td>
                <td width="25%" align="center"><span class="HEADER">Local path</td>
                <td width="25%" align="center"><span class="HEADER">Target path</td>
                <td width="25%" align="center">&nbsp;</td>
              </tr>
             
              <%
              for(int i=0;i<logsList.size();++i) {
      	  			String logId = (String)logsList.get(i);
      	  			LogBrowsingManager lbm = mgmt.getLogBrowserManager(logId);
      	  			String name = "";
      	  			String localDirPath = "";
      	  			String targetDirPath = "";
      	  			ArrayList localDirPathList = new ArrayList();
      	  			ArrayList targetDirPathList = new ArrayList();

      	  			try {
        	  			if(lbm == null ) {
        	  				continue;
        	  			}
        	  			
				  		    String type = lbm.getType();
					  	    if (type != null && type.length() > 0){
	      	    			if (type.equals(SimpleLogBrowserBuilder.SIMPLE_LOG_TYPE)){
	      	    				localDirPathList = LogAdminHelper.getLogDirectoryList(lbm);
	      	  		  	} else if (type.equals(XMLLogBrowserBuilder.XML_LOG_TYPE)){
	      	  			  	localDirPathList = XMLLogAdminHelper.getLogDirectoryList(lbm);
	      	  			  } else if (type.equals(SshSimpleBuilder.SSH_LOG_TYPE)){
	      	  			  	if(lbm.getDefaultLinearDataBuilder().getLinearDataSource() instanceof IntervalDataSource) {
	      	  			  		localDirPathList = IntervalAdminHelper.getSourceDirLocationList(lbm);
	          	  			}else{
	          	  				localDirPathList = LogAdminHelper.getLogDirectoryList(lbm);
	          	  			}
	      	  			  }
	      	    			
      	  			  }
      	  			  
      	  			  if (oldProperties != null){
	      	  			  targetDirPath = oldProperties.getProperty(ConfigurationImage.LOG_ENTRY_IN_PROPERTIES+"_"+logId);
	      	  			  if (targetDirPath == null){
	      	  				  targetDirPath = "";
	      	  			  }
      	  			  }
//      	  			  if (localDirPath == null || localDirPath.equals("")){
       	  			  if (localDirPathList == null || localDirPathList.size() == 0){      	  			  	
      	  				  continue;
      	  			  }
      	  			  name = lbm.getName();
      	  			}finally {
      	  				if (lbm != null){
      	  					lbm.dispose();
      	  				}
      	  			}
      		  	%>
      		  		            
							<%for(int j = 0 ; j < localDirPathList.size() ; j++){ %>        
	            <tr>
	            <%if(j == 0){ %>
	              <td width="25%"><span class="SMALLTEXT"><b><%=name%></b></span></td>
	             <%}else{ %>
	              <td width="25%">&nbsp;</td>
	              <%}%>
	              <td width="25%"><input type="text" name="localpath_<%=i%>_<%=j%>" size="50" value="<%=(String)localDirPathList.get(j)%>" readonly>
	              	<input type="hidden" name="logid_<%=i%>_<%=j%>" value="<%=logId%>">
	              	<%if(j==0){ %>
	              	<input type="hidden" name="logid_size_<%=i%>" value="<%=localDirPathList.size()%>">
	              	<%} %>
	              </td>
	              <td width="25%"><input type="text" name="targetpath_<%=i%>_<%=j%>" size="50" value="<%=targetDirPathList.size() == 0 ? "" : (String)targetDirPathList.get(0) %>"></td>
	              <td width="25%"><a href="javascript:goUpdateIdentical('<%=i%>_<%=j%>')" class="SMALLLINK">update identical</a></td>
	            </tr>
              <% }%>
              <tr><td>&nbsp;</td></tr>
              <%} %>
	            <tr>
	              <td width="25%"></td>
	              <td width="25%"></td>
	              <td width="25%"><span class="SMALLTEXT">leave target path blank to use local path</span></td>
	              <td width="25%"></td>
	            </tr>
          	</table>
		        </td>
    		  </tr>
    		</table>
    		</td>
    	</tr>
      <tr>
				<td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
					<tr><td colspan="3">&nbsp;</td></tr>
					<tr><td colspan="3">&nbsp;</td></tr>
          <tr>
             <td width="*" colspan="3" align="center"><a href="<%=backwardUrl!=null ? (BASE_DIRECTORY+backwardUrl) :"javascript:history.go(-1)"%>" class="LINK">previous</a>&nbsp;&nbsp;
             <a href="javascript:doNext()" class="LINK">next</a>&nbsp;&nbsp;
             <a href="<%=BASE_DIRECTORY + cancelUrl%>" class="LINK">cancel</a></td>
          </tr>
          <tr><td colspan="3">&nbsp;</td></tr>
       		<tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>