<%@ page language="java"%>

<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.config.image.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
	final UserContext userContext = UserEnvironment.getUserContext(request);
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);

	String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";
	
  final ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute("CONF_IMG_BUILDER");
	
  HashSet set = new HashSet();
  String[] publishersSelected = request.getParameterValues("publishers");
  if (publishersSelected != null){
	  for (int i=0; i<publishersSelected.length; i++){
	    set.add(publishersSelected[i]);
	  }
  }
  ConfigurationPublisher [] publishers = builder.getAllConfigurationPublishers();
  for (int i=0; i<publishers.length; i++){
    publishers[i].setSelected(set.contains(publishers[i].getId()));
  }
  
	ProgressRunner runner = new ProgressRunner(BASE_DIRECTORY + "tools/confImage/confImageView.jsp") {
		public void run(HttpServletRequest request) {
		try {
			Thread.sleep(500);
		}catch (Exception e){}
		  ConfigurationImageManager confMgr = ConfigurationImageManager.getInstance();
		  builder.update();
		  ArrayList errorList = builder.getErrorMessagesList();
		  if(errorList != null && errorList.size() > 0){
				for(int i = 0; i < errorList.size() ; i++){
		  		errmodel.addError((String)errorList.get(i));
				}
		  }
			ConfigurationImage confImg = builder.getConfImage();
			confMgr.addConfigurationImage(confImg,userContext);
		    
		    //	audit
			String Name = "";
			if(confImg != null) {
				Name = confImg.getName();
			}
			AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
				  			userContext, AuditConstants.CHANGE, "add/edit configuration image", AuditConstants.CONFIGURATION, "add/edit configuration image " + Name);
				
			if(errmodel != null && errmodel.getErrorCount() > 0){
				createErrorRedirect(request, BASE_DIRECTORY);
		    return;
			}else {
			String doPublish = request.getParameter("publish");
			if (doPublish != null && doPublish.equals("true")){
				setRedirectUrl(BASE_DIRECTORY + "tools/confImage/presentConfImagePublishStatusAction.jsp?ignorePublishers=true&ID="+confImg.getId());
			} else {
				String redirectUrl = (String)request.getSession().getAttribute("redirectURL");
				if (redirectUrl != null && redirectUrl.length() > 0){
					request.getSession().removeAttribute("redirectURL");
					setRedirectUrl(BASE_DIRECTORY + redirectUrl);
				}else{
					setRedirectUrl(BASE_DIRECTORY + "tools/confImage/confImageView.jsp");
				}
			}
			}
		}		
	};
	
	env.setProgressRunner(runner);

%>
<jsp:include page="../../common/actionProgress.jsp" flush="true">
 <jsp:param name="BASE_DIRECTORY" value="<%=BASE_DIRECTORY%>"/>
 <jsp:param name="message" value="Saving configuration"/>
</jsp:include>	

