<%@ page language="java"%>

<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.config.image.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
	String ERROR_OBJ = "ERROR_OBJ";
	String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";

	ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute(CONF_IMG_BUILDER);
	
  ConfigurationPublisher publisher = builder == null ? null : builder.getCurrentPublisher();
	
	ErrorModel errmodel = new ErrorModel(); 
	if(publisher == null){
		errmodel.addError("No Publisher was saved on session.");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		return;
  }

	String publishToLocalMachine = request.getParameter("publishToLocalHost");
	publisher.setLocalMachine(publishToLocalMachine != null && publishToLocalMachine.equals("true"));
	HashMap xplgNodes = new HashMap();
  String[] nodes = request.getParameterValues("xplgNode");
  if (nodes != null){
	  for (int i=0; i<nodes.length; i++){
	  	xplgNodes.put(nodes[i],nodes[i]);
	  }
  }

	publisher.setXplgNodes(xplgNodes);
	builder.addPublisher(publisher);

	WizardUIController uiCtrl = builder.getPublisherUiController();
	uiCtrl.updatePageId("tools/confImage/confImageXplgNodesAction.jsp");
	String forwardUrl = uiCtrl.getForwardPage();
	if (forwardUrl == null){
		forwardUrl = "tools/confImage/publishersSetView.jsp";
	}
	response.sendRedirect(BASE_DIRECTORY + forwardUrl);
	
%>

