<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="java.util.*"%>

<%!final String BASE_DIRECTORY = "../../"; %>     
<%
	String ACCOUNTS_OBJ = "ACCOUNTS_OBJ";
	String XPLG_NODES_OBJ = "NODES_OBJ";
	String IMPORT_STATUS_OBJ = "IMPORT_STATUS_OBJ";
	
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION,true)){
    return;
  }
  String redirectUrl = request.getParameter("redirectURL");
  String importOk = (String)request.getSession().getAttribute(IMPORT_STATUS_OBJ); 
 	HashMap accountsToCheck = (HashMap)request.getSession().getAttribute(ACCOUNTS_OBJ); 	
  AddressBook adbook = AddressBook.getInstance();
 	String accId = "";
	Account acc = null;
	boolean isRemoveAllAcc = (accountsToCheck == null || accountsToCheck.size() == 0);
 	if(accountsToCheck != null && accountsToCheck.size() == 1){
 		Iterator iterat = accountsToCheck.keySet().iterator();
 		while (iterat.hasNext()){
			accId = (String)iterat.next();
			acc = adbook.getAccountById(accId);
			if(acc != null){
				if(!acc.getPassword().equals("")){
					isRemoveAllAcc = true;
				}
			}
 		}
 	}
 	
 	HashMap xplgNodesToCheck = (HashMap)request.getSession().getAttribute(XPLG_NODES_OBJ); 	
 	CloudMgr cmgr = SiteManagment.getInstance().getCloudMgr();
  	String nodeId = "";
 	XplgNode node = null;
 	boolean isRemoveAllNodes = (xplgNodesToCheck == null || xplgNodesToCheck.size() == 0);;
  	if(xplgNodesToCheck != null && xplgNodesToCheck.size() == 1){
  		Iterator iterat = xplgNodesToCheck.keySet().iterator();
  		while (iterat.hasNext()){
  			nodeId = (String)iterat.next();
 			node = cmgr.getNodeById(nodeId);
 			if(node != null){
 				if(!node.getPassword().equals("")){
 					isRemoveAllNodes = true;
 				}
 			}
  		}
  	}
 	
 	
	String url = "";
	if(importOk.equals("true")) {
		url = "importOk.jsp";
	} else if(redirectUrl != null && redirectUrl.length() > 0){
		url = BASE_DIRECTORY + redirectUrl;
	} else{
	  url = BASE_DIRECTORY + "logEyePortal.jsp";
	}
	if(isRemoveAllAcc && isRemoveAllNodes){
		  response.sendRedirect(url);
	}
		
 		
	
//	String msg1 = "No More Accounts To Check.";
//	String msg2 = "Those Accounts Has No Passwords! Please Set new Passwords.";
//	String title = isRemoveAllAcc ? msg1 : msg2;
%>
<%@page import="xpolog.eye.cloud.CloudMgr"%>
<%@page import="xpolog.eye.SiteManagment"%>
<%@page import="xpolog.eye.cloud.XplgNode"%>
<html>

<head>
<meta http-equiv="Content-Language" content="text/html;" >
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
  baseDirectory = "<%=BASE_DIRECTORY%>";
    function doOk(){
		path = "<%=url%>";
  	document.location = path;
  }
  
  
  function goEditAcc(id){
  	path = baseDirectory + "/tools/addresses/accoutAction.jsp?ID="+id+"&forwardURL=/tools/confImage/illegalPasswords.jsp";  	
  	document.location = path;
  }
  function goEditNode(id){
  	path = baseDirectory + "/cloud/nodeHttp.jsp?id="+id+"&forwardURL=tools/confImage/illegalPasswords.jsp";  	  	
  	document.location = path;
  }
	
  
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<table width="100%" border="0"> 
	<tr>
	<td>&nbsp;</td>
	</tr>
	<tr>
    	<td>
        	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
				 <tr>
	                 <td width="15%" height="18"><span class="HEADER">Please Notice.</span></td>
	             </tr>
	              <%if(!isRemoveAllAcc){ %> 
                 <tr>
	                 <td width="33%">&nbsp;</td>                
                 </tr>    
                 <tr>
	                 <td width="100%" height="18"><span class="SMALLTEXT">The following accounts have no passwords! Please set new passwords.</span></td>
                 </tr>                                         
                 <tr>
			         <td>
				       <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">					       
					        <tr class="TABLES_HEADERS">
						        <td width="18%"><span class="REGULARTEXT"><b>Name</b></span></td>                
						        <td width="18%"><span class="REGULARTEXT"><b>Type</b></span></td>                
						        <td width="18%"><span class="REGULARTEXT"><b>Description</b></span></td>                               
					        </tr>        
					        <% if (accountsToCheck != null){
					      		Iterator it = accountsToCheck.keySet().iterator();
					      		while (it.hasNext()){
					      			accId = (String)it.next();
					      			acc = adbook.getAccountById(accId);
					      			if(acc == null){
					      				continue;
					      			}
					      			if(!acc.getPassword().equals("")){
					        			it.remove();        			        		
					      				continue;
					      			}      		
				         	%>
        				   <tr>
	   	                   		<td>&nbsp;</td>
		  				   </tr>         
					       <tr>     
								<td width="18%"><a href="javascript:goEditAcc('<%=acc.getId()%>')" class="LINK"> <%=acc.getAccountName()%></a></td>                
						        <td width="18%"><span class="REGULARTEXT"><%=acc.getType()%></span></td>                
							    <td width="18%"><span class="REGULARTEXT"><%=acc.getDescription()%></span></td>                
					        </tr>        
					       <%}
						   		request.getSession().setAttribute(ACCOUNTS_OBJ,accountsToCheck);
				      		}%>
			        </table>
		        </td>
        	</tr> 
        	<%}if(!isRemoveAllNodes){ %>  
	          	 <tr>
	                 <td width="33%">&nbsp;</td>                
                 </tr>          	 
                 <tr>
	                 <td width="100%" height="18"><span class="SMALLTEXT">Those Xplg Nodes Has No Passwords! Please Set new Passwords.</span></td>
                 </tr>
                 
		   <tr>
			     <td>
				       <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
					        <tr class="TABLES_HEADERS">
						        <td width="18%"><span class="REGULARTEXT"><b>Name</b></span></td>                				        
						        <td width="18%"><span class="REGULARTEXT"><b>Description</b></span></td>                               
						        <td width="18%">&nbsp;</td>                               
					        </tr>        
					        <% if (xplgNodesToCheck != null){
					      		Iterator it = xplgNodesToCheck.keySet().iterator();
					      		while (it.hasNext()){
					      			nodeId = (String)it.next();
					      			node = cmgr.getNodeById(nodeId);
					      			if(node == null){
					      				continue;
					      			}
					      			if(!node.getPassword().equals("")){
					        			it.remove();        			        		
					      				continue;
					      			}      		
				         	%>
        				   <tr>
	   	                   		<td>&nbsp;</td>
		  				   </tr>         
					       <tr>     
								<td width="18%"><a href="javascript:goEditNode('<%=node.getId()%>')" class="LINK"> <%=node.getName()%></a></td>                       
							    <td width="18%"><span class="REGULARTEXT"><%=node.getDescription()%></span></td>                
						        <td width="18%">&nbsp;</td>                               							    
					        </tr>        
					       <%}
						   		request.getSession().setAttribute(XPLG_NODES_OBJ,xplgNodesToCheck);
				      		}%>
			        </table>
		        </td>
        	</tr> 
        	
        	<%}%>           
       </table>
      </td>
   </tr>
   <tr>
		<td>&nbsp;</td>
   </tr>
   <tr>
        <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
   	          <tr>
				<td>&nbsp;</td>
	    	  </tr>
              <tr>
                <td width="35%">&nbsp;</td>
                <td width="11%" align="center"><a href="confImageView.jsp" class="LINK">cancel</a></td>
                <td width="7%" align="center"><a href="javascript:doOk()" class="LINK">ok</a></td>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
          </td>
    </tr>
 	<tr>
	<td>&nbsp;</td>
	</tr>  
</table>      
				
</form>
</body>

</html>