<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.image.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
	UserContext userContext = UserEnvironment.getUserContext(request);

  String ARCHIVE_PATH = "ARCHIVE_PATH";
  String ERROR_OBJ = "ERROR_OBJ";
  String CURRENT_LOG = "CURRENT_LOG";
  String ACCOUNTS_OBJ = "ACCOUNTS_OBJ";
  String XPLG_NODES_OBJ = "NODES_OBJ";
	String IMPORT_STATUS_OBJ = "IMPORT_STATUS_OBJ";
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  String arch_file  = request.getParameter(ARCHIVE_PATH);
  String redirectUrl = request.getParameter("redirectURL");
  String forwardUrl = "";
  //verify data
  ErrorModel errmodel = new ErrorModel();
  if(arch_file == null || arch_file.trim().equals("")){
    errmodel.addError("No archive file was supplied.");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    forwardUrl = "errorpage.jsp";
    return;
  }

  //here we will use xpolog builder for import -
  File arch = new File(arch_file);
  boolean importOk = false;	
  ImportFlow iml = new ImportFlow();
  try{
		arch = UploadHelper.uploadFile(request,arch);
		iml.setFile(arch);
		iml.setOverrideConfImage(true);
		Module parent = SiteManagment.getInstance().getModuleFromId(Module.ROOT_MODULE_ID);
		//ConfigurationImagePackingUnit cipu = new ConfigurationImagePackingUnit();
		importOk = iml.executeImportConfigurationImage(parent,true);		
  }catch(Exception e){ 
    ErrorModel errmod = new ErrorModel();
    errmod.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,errmod);
    forwardUrl = "errorpage.jsp";
    return;
  }
  	//	audit
  	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  		  			userContext, AuditConstants.CHANGE, "import configuration image", AuditConstants.CONFIGURATION, "import configuration image");
	if(iml != null && (iml.getAccountsToCheck().size() > 0 || iml.getXplgNodesToCheck().size() > 0)){
		if(iml.getAccountsToCheck().size() > 0){
			request.getSession().setAttribute(ACCOUNTS_OBJ,iml.getAccountsToCheck());
		}
		if( iml.getXplgNodesToCheck().size() > 0){
			request.getSession().setAttribute(XPLG_NODES_OBJ,iml.getXplgNodesToCheck());
		}
		String importStatus = importOk ? "true" : "false";
		request.getSession().setAttribute(IMPORT_STATUS_OBJ,importStatus);
		forwardUrl = "illegalPasswords.jsp?redirectURL=" + redirectUrl;
	}else{  	
		if(importOk) {
			forwardUrl = "importOk.jsp" + (redirectUrl != null && redirectUrl.length() > 0 ? "?redirectUrl="+redirectUrl : "");
		} else if(redirectUrl != null && redirectUrl.length() > 0){
			forwardUrl = (BASE_DIRECTORY + redirectUrl);
		} else{
		  forwardUrl = BASE_DIRECTORY + "logEyePortal.jsp";
		}
	}
%>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access">
<input type="hidden" id="forwardUrl" name="forwardUrl" value="<%=forwardUrl%>">
</form>
</body>


