<%@ page language="java"%>

<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.data.log.external.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.config.image.*"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.security.UserSecurity"%>

<%!
	static final String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";
%>
     
<%
  String ERROR_OBJ = "ERROR_OBJ";

   WebSecurityManager securityManager = WebSecurityManager.getInstance();
  if (!securityManager.checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION,true)){
    return;
  }
  ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute(CONF_IMG_BUILDER);
	UserContext userContext = UserEnvironment.getUserContext(request);
	UserSecurity user = securityManager.getUserSecurity(request);
  List allAccountsList = AddressBook.getInstance().getAccountsByFilter(null,userContext);
  if(allAccountsList == null) {
  	allAccountsList = new ArrayList();
  }
	HashSet relevantAccounts = new HashSet();
	HashMap accounts = builder.getAccountsToExp();
	HashMap accountsToOverride = builder.getAccountsToOverride();
	if (accounts != null){
		Iterator it = accounts.keySet().iterator();
		while (it.hasNext()){
			String acc = (String)it.next();
  			relevantAccounts.add(acc);
		}
	}
  String style = allAccountsList.size() > 1 ? "" : "visibility: hidden;";
 	
%>

<script>
  function CheckAccounts(){
	  if(document.access.checkedAllAcc.checked == true){
	  	for (var i=0; i<<%=allAccountsList.size()%>; i++){
  			document.access.checkAccList<%=allAccountsList.size() > 1 ? "[i]" : ""%>.checked = true;
	  	}  	
	  }else{
	  	for (var i=0; i<<%=allAccountsList.size()%>; i++){
  			document.access.checkAccList<%=allAccountsList.size() > 1 ? "[i]" : ""%>.checked = false;
  		}
	  }
  }
  
  function CheckOverrideAccounts(){
   if(document.access.checkOverrideAccounts.checked == true){
	  	for (var i=0; i<<%=allAccountsList.size()%>; i++){
  			document.access.checkOverrideAccList<%=allAccountsList.size() > 1 ? "[i]" : ""%>.checked = true;
	  	}  	
	  }else{
	  	for (var i=0; i<<%=allAccountsList.size()%>; i++){
  			document.access.checkOverrideAccList<%=allAccountsList.size() > 1 ? "[i]" : ""%>.checked = false;
  		}
	  }
  }
</script>

<table width="100%" border="0"> 
	<tr>
	<td>&nbsp;</td>
	</tr>
  <tr>
     	<td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
 <tr>
                <td width="15%" height="18"><span class="HEADER">XpoLog Accounts</span></td>
              </tr>
              <tr>
                <td width="100%" height="18"><span class="SMALLTEXT">Please check the accounts you want to save in this configuration image.</span></td>
              </tr>
              <tr>
                <td width="33%">&nbsp;</td>                
              </tr>
               <tr>
     	<td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
        <tr class="TABLES_HEADERS">
        <td width="18%"><span class="REGULARTEXT"><b>Name</b></span></td>                
        <td width="18%"><span class="REGULARTEXT"><b>Type</b></span></td>                
        <td width="18%"><span class="REGULARTEXT"><b>Description</b></span></td>                
        <td width="18%"><span class="REGULARTEXT"><b>Overwrite</b></span></td>                
        </tr>        
        <%for(int i=0;i<allAccountsList.size();i++) {
              	  String checked = "";
              	String override = "";
              	  Account acc = (Account)allAccountsList.get(i);
              	  if(relevantAccounts.contains(acc.getId())) {
              	  	  checked = "checked";
              	  	  if(accountsToOverride.containsKey(acc.getId())){
              	  		  override = "checked";
              	  	  }
              	  }else {
              	      checked = "";
              	  }	

              %>
         <tr>     
		<td width="18%"><input id="<%=acc.getId()%>" name="checkAccList" value="<%=acc.getId()%>" type="checkbox"   <%=checked%>><span class="REGULARTEXT"><%=acc.getAccountName()%></span></td>                
        <td width="18%"><span class="REGULARTEXT"><%=acc.getType()%></span></td>                
        <td width="18%"><span class="REGULARTEXT"><%=acc.getDescription()%></span></td>                
        <td width="18%"><input id="override_<%=acc.getId()%>" name="checkOverrideAccList" value="<%=acc.getId()%>" type="checkbox"   <%=override%>></td>            
        </tr>
        <%} %>
        <tr>
	<td>&nbsp;</td>
	</tr>  
	    <tr class="TABLES_HEADERS"   style="<%=style%>">
		<td width="18%"><input name="checkedAllAcc" type="checkbox" onClick="CheckAccounts()"><span class="REGULARTEXT"><b>Check All</b></span></td>                
        <td width="18%">&nbsp;</td>                
        <td width="18%">&nbsp;</td>                
        <td width="18%"><input name="checkOverrideAccounts" type="checkbox" onClick="CheckOverrideAccounts()"><span class="REGULARTEXT"><b>Check All</b></span></td>           
        </tr>
        </table>
        </td>
        </tr>           
       </table>
      </td>
   </tr>
 	<tr>
	<td>&nbsp;</td>
	</tr>  
</table>      
				
