<%@ page language="java"%>

<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.security.UserSecurity"%>
<%@ page import="xpolog.config.image.ConfigurationImageBuilder"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>

<%!
	static final String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";
%>

<%
	WebSecurityManager securityManager = WebSecurityManager.getInstance();
	if (!securityManager.checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.METADATA_PERMISSION,true)){
		return;
	}
	UserContext userContext = UserEnvironment.getUserContext(request);
	SiteManagment mgmt = SiteManagment.getInstance();
	UserSecurity user = securityManager.getUserSecurity(request);
	ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute(CONF_IMG_BUILDER);
	MetaDataManager metaDataMgr = SiteManagment.getInstance().getMetaDataMgr();
	MetaData[] systemMetaDatas = metaDataMgr.getAllSystemMetaDatas(userContext);
	
	HashSet selectedMetaData = new HashSet();
	HashMap metadatas = builder.getMetaDataToExp();
	if (metadatas != null){
		Iterator it = metadatas.keySet().iterator();
		while (it.hasNext()){
			String metaData = (String)it.next();
			selectedMetaData.add(metaData);
		}
	}
%>

<script>
  function selectAllMetaData(){
  	for (var i=0; i<<%=systemMetaDatas.length%>; i++){
  		document.access.checkMetaDataList<%=systemMetaDatas.length > 1 ? "[i]" : ""%>.checked = true;
  	}
  }
  
  function clearAllMetaData(){
  	for (var i=0; i<<%=systemMetaDatas.length%>; i++){
  		document.access.checkMetaDataList<%=systemMetaDatas.length > 1 ? "[i]" : ""%>.checked = false;
  	}
  }
</script>

<table width="100%" border="0"> 
	<tr>
	<td>&nbsp;</td>
	</tr>
  <tr>
     	<td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="15%" height="28" colspan="3"><span class="HEADER">XpoLog Applications</span></td>
              </tr>
                     <tr>
                <td width="100%" height="18"><span class="SMALLTEXT">Please check the applications you want to save in this configuration image.</span></td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <%for(int i=0;i<systemMetaDatas.length;++i) {
              	  String checked = "";
              	  MetaData metaData = (MetaData)systemMetaDatas[i];              	
              	  String desc = metaData.getDescription() != null && metaData.getDescription().length() > 0 ? " (" + metaData.getDescription() + ")" : "";
            	  if(selectedMetaData.contains(metaData.getId())) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }
              %>
							<tr>
								<td colspan="3"><input type="checkbox" id="<%=metaData.getId()%>" name="checkMetaDataList" value="<%=metaData.getId()%>" <%=checked%> ><span class="REGULARTEXT"><%=metaData.getName()%></span><span class="SMALLTEXT"><%=desc%></span></td>
							</tr> 
              <%}%>
          	</table>
        		</td>
   </tr>
 	<tr>
	<td>&nbsp;</td>
	</tr>  
	<%if(systemMetaDatas  != null && systemMetaDatas.length > 0){ %>
	<tr>
								<td>
								<table border="0" cellpadding="0" cellspacing="0">
									<tr>
										<td><a href="javascript:selectAllMetaData()"
											class="SMALLLINK">select all</a></td>
										<td width="10">&nbsp;</td>
										<td><a href="javascript:clearAllMetaData()" class="SMALLLINK">clear
										all</a></td>
									</tr>
								</table>
								</td>
							</tr>
							<%}%>
</table>      
				
