<%@ page language="java"%>

<%@ page import="java.util.*"%>
<%@page import="xpolog.eye.reports.Report"%>
<%@page import="xpolog.eye.reports.ReportsManager"%>     

<%@page import="xpolog.eye.security.WebSecurityManager"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.SiteManagment"%>
<%@page import="xpolog.eye.security.UserSecurity"%>
<%@page import="xpolog.config.image.ConfigurationImageBuilder"%>
<%@page import="xpolog.eye.security.ActionsPermissionConstants"%>

<%!
	static final String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";
%>

<%
	WebSecurityManager securityManager = WebSecurityManager.getInstance();
	if (!securityManager.checkForPermission(request,response,ActionsPermissionConstants.ToolsPermissions.REPORTS_PERMISSION,true)){
		return;
  }
	UserContext userContext = UserEnvironment.getUserContext(request);
	SiteManagment mgmt = SiteManagment.getInstance();
	UserSecurity user = securityManager.getUserSecurity(request);
	ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute(CONF_IMG_BUILDER);

	ReportsManager reportMgr = ReportsManager.getInstance();
	String reportType = Report.LOG_TYPE + "|" + Report.LOG_GROUP_TYPE;
	List reportsList = reportMgr.getAllBasicReports(userContext,false,reportType);
	
	  
	HashSet selectedReports = new HashSet();
	HashMap reports = builder.getReportsToExp();
	if (reports != null){
		Iterator it = reports.keySet().iterator();
		while (it.hasNext()){
			String repo = (String)it.next();
			selectedReports.add(repo);
		}
	}
	
%>

<script>
  function selectAllRep(){
  	for (var i=0; i<<%=reportsList.size()%>; i++){
  		document.access.checkReportList<%=reportsList.size() > 1 ? "[i]" : ""%>.checked = true;
  	}
  }
  
  function clearAllRep(){
  	for (var i=0; i<<%=reportsList.size()%>; i++){
  		document.access.checkReportList<%=reportsList.size() > 1 ? "[i]" : ""%>.checked = false;
  	}
  }
</script>

<table width="100%" border="0"> 
	<tr>
	<td>&nbsp;</td>
	</tr>
  <tr>
     	<td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="15%" height="28" colspan="3"><span class="HEADER">XpoLog Reports</span></td>
              </tr>
                     <tr>
                <td width="100%" height="18"><span class="SMALLTEXT">Please check the reports you want to save in this configuration image.</span></td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <%for(int i=0;i<reportsList.size();++i) {
              	  String checked = "";
            	  Report rep = (Report)reportsList.get(i);              	
              	  String desc = rep.getDescription() != null && rep.getDescription().length() > 0 ? " (" + rep.getDescription() + ")" : "";
            	  if(selectedReports.contains(rep.getId())) {
              	  	  checked = "checked";
              	  }else {
              	      checked = "";
              	  }
              %>
							<tr>
								<td colspan="3"><input type="checkbox" id="<%=rep.getId()%>" name="checkReportList" value="<%=rep.getId()%>" <%=checked%> ><span class="REGULARTEXT"><%=rep.getReportName()%></span><span class="SMALLTEXT"><%=desc%></span></td>
							</tr> 
              <%}%>
          	</table>
        		</td>
   </tr>
 	<tr>
	<td>&nbsp;</td>
	</tr>  
	<%if(reportsList  != null && reportsList.size() > 0){ %>
	<tr>
								<td>
								<table border="0" cellpadding="0" cellspacing="0">
									<tr>
										<td><a href="javascript:selectAllRep()"
											class="SMALLLINK">select all</a></td>
										<td width="10">&nbsp;</td>
										<td><a href="javascript:clearAllRep()" class="SMALLLINK">clear
										all</a></td>
									</tr>
								</table>
								</td>
							</tr>
							<%}%>
</table>      
				
