<%@ page language="java"%>


<%@ page import="java.util.*"%>
<%@page import="xpolog.eye.automation.tasks.XpoTask"%>
<%@page import="xpolog.eye.scheduler.SchedulingMgr"%>
<%@page import="xpolog.eye.scheduler.XpoLogScheduleFactory"%>
<%@page import="xpolog.eye.scheduler.XpoScheduledOperation"%>
<%@page import="xpolog.eye.scheduler.XpoJobDetails"%>
<%@page import="xpolog.eye.security.WebSecurityManager"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.SiteManagment"%>
<%@page import="xpolog.config.image.ConfigurationImageBuilder"%>
<%@page import="xpolog.eye.security.UserSecurity"%>

<%!
	static final String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";
%>

<%
	WebSecurityManager securityManager = WebSecurityManager.getInstance();
	if (!securityManager.checkForPermission(request,response,null,true)){
		return;
	}
	UserContext userContext = UserEnvironment.getUserContext(request);
	SiteManagment mgmt = SiteManagment.getInstance();
	UserSecurity user = securityManager.getUserSecurity(request);
	ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute(CONF_IMG_BUILDER);

	SchedulingMgr schmgr = XpoLogScheduleFactory.getSchdulingManager();
	List schedList = schmgr.getXpoOpslByFilter(null,userContext);	  
	  
		HashSet selectedScedulers = new HashSet();
		HashMap Scedulers = builder.getSchedulersToExp();
		HashMap schedToOverride = builder.getSchedulersToOverride();
		if (Scedulers != null){
			Iterator it = Scedulers.keySet().iterator();
			while (it.hasNext()){
				String sch = (String)it.next();
				selectedScedulers.add(sch);
			}
		}

		  String style2 = schedList.size() > 1 ? "" : "visibility: hidden;";
	
%>
<script>
  function CheckSchedulers(){
	  if(document.access.checkedAllSchedulers.checked == true){
	  	for (var i=0; i<<%=schedList.size()%>; i++){
  			document.access.checkSchedulersList<%=schedList.size() > 1 ? "[i]" : ""%>.checked = true;
	  	}  	
	  }else{
	  	for (var i=0; i<<%=schedList.size()%>; i++){
  			document.access.checkSchedulersList<%=schedList.size() > 1 ? "[i]" : ""%>.checked = false;
  		}
	  }
  }
  
  function CheckOverrideSchedulers(){
   if(document.access.checkOverrideSchedulers.checked == true){
	  	for (var i=0; i<<%=schedList.size()%>; i++){
  			document.access.checkOverrideSchedulersList<%=schedList.size() > 1 ? "[i]" : ""%>.checked = true;
	  	}  	
	  }else{
	  	for (var i=0; i<<%=schedList.size()%>; i++){
  			document.access.checkOverrideSchedulersList<%=schedList.size() > 1 ? "[i]" : ""%>.checked = false;
  		}
	  }
  }
</script>
<table width="100%" border="0"> 
		<tr>
				<td>&nbsp;</td>
		</tr>
  	<tr>
     		<td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
        	      <tr>
          		      <td width="15%" height="28" colspan="3"><span class="HEADER">XpoLog Schedulers</span></td>
              	</tr>
                <tr>
                		<td width="100%" height="18"><span class="SMALLTEXT">Please check the schedulers you want to save in this configuration image.</span></td>
		           </tr>           
			         <tr>
       		         <td width="33%">&nbsp;</td>                
               </tr>
               <tr>
							     	<td>
									        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
											        <tr class="TABLES_HEADERS">
														        <td width="18%"><span class="REGULARTEXT"><b>Name</b></span></td>                
																	  <td width="18%"><span class="REGULARTEXT"><b>Type</b></span></td>                
															      <td width="18%"><span class="REGULARTEXT"><b>Description</b></span></td>                
															      <td width="18%"><span class="REGULARTEXT"><b>Overwrite</b></span></td>                
											        </tr>        
										          <%for(int i=0;i<schedList.size();++i) {
										              	  String checked = "";
										              	  String override = "";
										              	  XpoScheduledOperation sop = ((XpoScheduledOperation)schedList.get(i));
										                  XpoJobDetails det = sop.getDetails();
										              	  String desc = det.getDescription() != null && det.getDescription().length() > 0 ? " - (" + det.getDescription() + ")" : "";
										            	  if(selectedScedulers.contains(det.getId())) {
										              	  	  checked = "checked";
										              	   	  if(schedToOverride.containsKey(det.getId())){
										              	  		  override = "checked";
										              	  	  }
										              	  }else {
										              	      checked = "";
										              	  }														              	
									             %>
											         <tr>     
																		<td width="18%"><input id="<%=det.getId()%>" name="checkSchedulersList" value="<%=det.getId()%>" type="checkbox"   <%=checked%>><span class="REGULARTEXT"><%=det.getPresName()%></span></td>                
														        <td width="18%"><span class="REGULARTEXT"><%=det.getType()%></span></td>                
														        <td width="18%"><span class="REGULARTEXT"><%=det.getDescription()%></span></td>                
														        <td width="18%"><input id="override_<%=det.getId()%>" name="checkOverrideSchedulersList" value="<%=det.getId()%>" type="checkbox"   <%=override%>></td>            
												       </tr>
															<%}%>
                 							<tr>
																		<td>&nbsp;</td>
															</tr>  
													    <tr class="TABLES_HEADERS"   style="<%=style2%>">
																	<td width="18%"><input name="checkedAllSchedulers" type="checkbox" onClick="CheckSchedulers()"><span class="REGULARTEXT"><b>Check All</b></span></td>                
													        <td width="18%">&nbsp;</td>                
													        <td width="18%">&nbsp;</td>                
													        <td width="18%"><input name="checkOverrideSchedulers" type="checkbox" onClick="CheckOverrideSchedulers()"><span class="REGULARTEXT"><b>Check All</b></span></td>           
												      </tr>
								        </table>
        					</td>
			        </tr>           
       </table>
      </td>
   </tr>
</table>
