<%@ page language="java"%>

<%@ page import="java.util.*"%>
<%@ page import="xpolog.config.image.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>
<%
	UserContext userContext = UserEnvironment.getUserContext(request);

	String ERROR_OBJ = "ERROR_OBJ";
	String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";
	
	String publisherId = request.getParameter("publisherId");
	ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute(CONF_IMG_BUILDER);
	ConfigurationPublisher publisher = builder == null || publisherId == null? null : builder.getConfigurationPublisher(publisherId);
	
	ErrorModel errmodel = new ErrorModel();
	
	if(publisher == null){
		errmodel.addError("No publisher found to delete.");
		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		return;
	}
	
	builder.removePublisher(publisherId);
	//	audit
	String Name = "";
	if(publisher != null) {
		Name = publisher.getName();
	}
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		  			userContext, AuditConstants.CHANGE, "duplicate publisher", AuditConstants.CONFIGURATION, "duplicate publisher " + Name);

	response.sendRedirect("publishersSetView.jsp");
%>