<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.config.image.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<% 
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.ConfigurationPermissions.CONF_IMAGE_PERMISSION,true)){
    return;
  }
  String ERROR_OBJ = "ERROR_OBJ";
	String CONF_IMG_BUILDER = "CONF_IMG_BUILDER";
  
  SiteManagment mgmt = SiteManagment.getInstance();
  //ask the list of conf from conf mgr
  String id = request.getParameter("CONF_IMAGE_ID");
  
  ConfigurationImageManager confMgr = ConfigurationImageManager.getInstance();
	ConfigurationImageBuilder builder = (ConfigurationImageBuilder)request.getSession().getAttribute("CONF_IMG_BUILDER");
  ConfigurationImage confImg = null;
  boolean inEdit = true;
  String inEditStr = request.getParameter("inEdit");
  if (inEditStr != null && inEditStr.length()>0){
  	inEdit = inEditStr.equals("true");
  }
  
 	confImg = builder.getConfImage();

  boolean isNew = confImg.getId() == null || confImg.getId().length() == 0;
  ConfigurationPublisher [] publishers = builder.getAllConfigurationPublishers();
	WizardUIController uiCtrl = builder.getUiController();
	uiCtrl.updatePageId("tools/confImage/publishersSetView.jsp");
	String forwardUrl = uiCtrl.getForwardPage();
	String backwardUrl = uiCtrl.getBackwardPage();
	String cancelUrl = uiCtrl.getCancelUrl();
	
	WizardUIController publishersUiCtrl = builder.getPublisherUiController();
	publishersUiCtrl.updatePageId("tools/confImage/publishersSetView.jsp");
	String publishersForwardUrl = publishersUiCtrl.getForwardPage();
  
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script>
  
  function goNext(id){
  	path = "<%=BASE_DIRECTORY+publishersForwardUrl%>?publisherId=" + id;
  	document.location = path;
  }
  
  function doDelete(id){
  	path = "publisherRemoveAction.jsp?publisherId="+id;
  	document.location = path;
  }
  
  function doDuplicate(id){
  	path = "publisherDuplicateAction.jsp?publisherId="+id;
  	document.location = path;
  }
  
  function publish(){
  	document.access.action = "presentConfImagePublishStatusAction.jsp";
  	document.access.submit();
  }
  
  function doSave(pub){
    document.access.action ="<%=BASE_DIRECTORY+forwardUrl%>";
    document.access.publish.value = pub;
    document.access.submit();
	}
  

</script>
</head>

<body >

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<input type="hidden" name="publish">

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="98%" class="TOPBORDER">
                <span class="PAGEHEADER">Publishers Set</span></td>
                <td width="1%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td><span class="REGULARTEXT"><a href="javascript:goNext()" class="LINK">Add new Publisher</a></span></td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr class="TABLES_HEADERS">
                        <td><span class="REGULARTEXT"></span></td>
                        <td><span class="REGULARTEXT">Name</span></td>
                        <td colspan="3">&nbsp;</td>
                      </tr>
                     <%
                      for(int i=0;i<publishers.length;i++){
                        ConfigurationPublisher publisher = publishers[i];
                     %>
                      <tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
                          <td width="20"><input type="checkbox" name="publishers" value="<%=publisher.getId()%>" <%=publisher.isSelected() ? "checked" : ""%>></td>
			  									<td width="*"><a href="javascript:goNext('<%=publisher.getId()%>')" class="LINK"><%=publisher.getName()%></a></td>
                          <td width="50" align="center" nowrap style="padding-left:10"><a href="javascript:goNext('<%=publisher.getId()%>')" class="LINK">edit</a></td>
                          <td width="50" align="center" nowrap style="padding-left:10"><a href="javascript:doDelete('<%=publisher.getId()%>')" class="LINK">delete</a></td>
                          <td width="50" align="center" nowrap style="padding-left:10"><a href="javascript:doDuplicate('<%=publisher.getId()%>')" class="LINK">duplicate</a></td>
                       </tr>
                      <%
                        }
                      %>
                        <tr>
                         <td colspan="5"></td>
                       </tr>
                    </table>
                   </td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="100">&nbsp;</td>
                    <td width="400" align="center"><nobr>
                    <%if (inEdit){%>
                    &nbsp;&nbsp;<a href="<%=backwardUrl!=null ? (BASE_DIRECTORY+backwardUrl) :"javascript:history.go(-1)"%>" class="LINK">previous</a>
                    <%}%>
                    <%if (!isNew){%>
                    &nbsp;&nbsp;<a href="javascript:publish()" class="LINK">publish</a>
                    <%}%>
				            &nbsp;&nbsp;<a href="javascript:doSave('false')" class="LINK">save</a>
				             <%if (inEdit && isNew){%>
                    &nbsp;&nbsp;<a href="javascript:doSave('true')" class="LINK">publish and save</a>
                    <%}%>
                    &nbsp;&nbsp;<a href="<%=BASE_DIRECTORY+cancelUrl%>" class="LINK">cancel</a>
                    </nobr></td>
                    <td width="*">&nbsp;</td>
                  </tr>
                </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>