<%@ page language="java"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.transform.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.db.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	String ERROR_OBJ = "ERROR_OBJ";
	String ACCOUNT_ID = "ACCOUNT_ID";
	String TABLE_NAME = "TABLE_NAME";
	String SHOW_DESC = "SHOW_DESC";
	String CURRENT_LOG = "CURRENT_LOG";
	String ACT = "ACT";
	String XPOLOG_SEL_COLS = "XPOLOG_SEL_COLS";
	String SQL_SEL_COLS = "SQL_SEL_COLS";
	String TABLE_NAME_TO_USE = "TABLE_NAME_TO_USE";
	String TYPE_EXP = "TYPE_EXP";
	String CREATE_TBL_CHECKED = "CREATE_TBL_CHECKED";
	String DB_MANAGER = "DB_MANAGER";
	String exportType = request.getParameter(TYPE_EXP);
  
  //verify data
 	ErrorModel errmodel = new ErrorModel();

	DBAccountFilter filter = new DBAccountFilter();
	AddressBook adbook = AddressBook.getInstance();
	List list = adbook.getAccountsByFilter(filter);
	if (list == null || list.isEmpty()) {
		errmodel.addError("No databases accounts available. Please define accounts first");
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
		response.sendRedirect("errorpage.jsp");
		return;
	}
	String acc_id = request.getParameter(ACCOUNT_ID);
	String table_name = request.getParameter(TABLE_NAME);
	String tableNameToUse = request.getParameter(TABLE_NAME_TO_USE);
	String create_table = request.getParameter(CREATE_TBL_CHECKED);
	String showTblDescStr = request.getParameter(SHOW_DESC);
  String xpologSelCols = request.getParameter(XPOLOG_SEL_COLS);
	String sqlSelCols = request.getParameter(SQL_SEL_COLS);
  String create_table_checked = "";
	/*
	if (acc_id == null || acc_id.equals("")) {
		acc_id = ((Account)list.get(0)).getId();
	}
	*/
	boolean showTblDesc = false;
	if (showTblDescStr != null) {
		showTblDesc = showTblDescStr.equals("true");
	}
	  
	SiteManagment mgmt = SiteManagment.getInstance();
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
	LogBrowsingManager lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
	if (tableNameToUse == null || tableNameToUse.equals("")){
		if (table_name != null) tableNameToUse = table_name;
		else tableNameToUse = "";
	}
	SQLTransformer trans = (SQLTransformer)TransformationFactory.getTransformaerByType(TransformationFactory.TRAN_TYPE_SQL);
	DBMedia dbmed = new DBMedia();
	DBAccount dbac = (DBAccount)AddressBook.getInstance().getAccountById(acc_id);
	//String[][] logColumns = dbman.getColumnTypes();
  RecordMask mask = null;
  CustomizationManager cuman = null;

  if(lbm != null && lbm.getId() != null){
		cuman = lbm.getCustomizationManager();
    mask = lbm.getRecordMask();
    request.getSession().setAttribute(CURRENT_LOG,lbm);
  }else{
  	ErrorModel ermod = new ErrorModel();
		ermod.addError("You must select a log first.");
		request.getSession().setAttribute(ERROR_OBJ,ermod);
		response.sendRedirect("errorpage.jsp");
		return;
  }
	int[] xpologColumnMap = null;
	StringBuffer xpologSelColsPattern = new StringBuffer();
	StringBuffer sqlSelColsPattern = new StringBuffer();
  if (xpologSelCols != null && !xpologSelCols.equals("")){
   	String[] colMapArr = xpologSelCols.split(",");
		xpologColumnMap = new int[colMapArr.length];
		xpologSelColsPattern.append('(');
		for (int i=0; i<colMapArr.length; i++) {
			xpologColumnMap[i] = Integer.parseInt(colMapArr[i]);
			if (i>0) xpologSelColsPattern.append(", ");
			xpologSelColsPattern.append("{"+colMapArr[i]+"}");
		}
		xpologSelColsPattern.append(')');
  }
	if (xpologColumnMap == null) {
		xpologColumnMap = new int[mask.getCulomnsNumber()];
		xpologSelColsPattern.append('(');
		for (int i=0; i<mask.getCulomnsNumber(); i++) {
			int ic = cuman.getIndexFromCustomizedCol(i);
			xpologColumnMap[i] = ic;
			if (ic >= 0) {
				if (i>0) xpologSelColsPattern.append(", ");
				xpologSelColsPattern.append("{"+String.valueOf(ic)+"}");
			}
		}
		xpologSelColsPattern.append(')');
	}

	String[][] dbTblDesc = null;
	//DBMedia dbmedia = new DBMedia();
	int[] sqlColumnMap = (int[])request.getSession().getAttribute(SQL_SEL_COLS);
	if (!dbmed.connect(dbac)){
		errmodel.addError("Could not connect to database. Check Database account definitions");
	}
	else {
		dbTblDesc = dbmed.getTableDescription(table_name);
		if (dbTblDesc != null) {
		    if (sqlSelCols != null && !sqlSelCols.equals("")){
  			  	String[] colMapArr = sqlSelCols.split(",");
				sqlColumnMap = new int[colMapArr.length];
				sqlSelColsPattern.append('(');
				for (int i=0; i<colMapArr.length; i++) {
					sqlColumnMap[i] = Integer.parseInt(colMapArr[i]);
					if (i>0) sqlSelColsPattern.append(", ");
					sqlSelColsPattern.append("{"+colMapArr[i]+"}");
				}
				sqlSelColsPattern.append(')');
		    }
			if (sqlColumnMap == null){
				sqlColumnMap = new int[dbTblDesc[0].length];
				sqlSelColsPattern.append('(');
				for (int i=0; i<dbTblDesc[0].length; i++) {
					sqlColumnMap[i] = i;
					if (i>0) sqlSelColsPattern.append(", ");
					sqlSelColsPattern.append("{"+String.valueOf(i)+"}");
				}
				sqlSelColsPattern.append(')');
			}
		}
	}
	
	String queryPattern = "INSERT INTO {0} {1}VALUES {2}";
	String createPattern = "CREATE TABLE {0} ({2})";
	String stmtIntoColumns = "";
	if (sqlSelCols != null && dbTblDesc != null)
		stmtIntoColumns = MessageFormat.format(sqlSelColsPattern.toString(),dbTblDesc[0]);
	Object[] arrInsert = {tableNameToUse, stmtIntoColumns, xpologSelColsPattern.toString()};
	String insert = MessageFormat.format(queryPattern, arrInsert);
	DBManager dbman = new DBManager();
	dbman.setMedia(dbmed);
	dbman.setTrans(trans);
	dbman.setLogBrowsingManager(lbm);
	dbman.updateTransformer();
	String query = dbman.createInsertStatement(insert);
	String createStmt = dbman.createCreateStatement(insert);
	request.getSession().setAttribute(DB_MANAGER, dbman);
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
 	var selReal = "";
 	var selCust = "";

	function doNext(){
		document.access.action = "exportLogDBAction.jsp";
		arr = document.access.sqlInsert.value.match(/\S+/gi);
		tbl = arr[2];
		create = "true";
		if (document.access.createTable.checked == true){
			for (var i=0; i<document.access.DB_TABLE.options.length; i++){
				if (tbl == document.access.DB_TABLE.options[i].value){
					create = "false";
				}
			}
		}
		else
			create = "false";
		document.access.CREATE_NEW_TABLE.value = create;
		if (checkParam(tbl)){
			document.access.submit();
		}
	}
	
	function checkParam(tbl){
		reserved = new Array("insert","into","values");
		if (tbl.search(/^\(/) != -1){
			alert("Table name is missing. Please check again the insert statement");
			return false;
		}
		for (var i=0; i<reserved.length; i++){
			if (arr[2].toLowerCase() == reserved[i]){
				alert("Table name is missing. Please check again the insert statement");
				return false;
			}
		}
		if (document.access.addressId.selectedIndex == 0){
			alert("Please select an account");
			return false;
		}
		return true;
	}
	
	function goNew(){
		document.access.submit();
	}
  		
	function getTables() {
		document.showAccountTables.ACCOUNT_ID.value = document.access.addressId.options[document.access.addressId.selectedIndex].value;
		document.showAccountTables.submit();
	}
  		
	function init() {
		dbTableName = document.access.DB_TABLE.options[document.access.DB_TABLE.selectedIndex].value;
		updateMessageString('Xpolog');
		updateMessageString('Sql');
	}
  		
	function changeTable() {
		document.access.createTable.checked = false;
		updateStmt('false');
	}

	function updateStmt(sameTable) {
		document.tableDesc.ACCOUNT_ID.value = document.access.addressId.options[document.access.addressId.selectedIndex].value;
		document.tableDesc.TABLE_NAME.value = document.access.DB_TABLE.options[document.access.DB_TABLE.selectedIndex].value;
		if (sameTable == 'true')
			document.tableDesc.TABLE_NAME_TO_USE.value = document.access.tableNameToUse.value;
		else
			document.tableDesc.TABLE_NAME_TO_USE.value = "";
		selXpolog = ""
		for (var i=0; i<document.access.CustXpologColSelect.options.length; i++) {
			if (i>0) selXpolog = selXpolog + ",";
			selXpolog = selXpolog + document.access.CustXpologColSelect.options[i].value;
		}
		selSql = "";
		if (document.access.CustSqlColSelect){
			for (var i=0; i<document.access.CustSqlColSelect.options.length; i++) {
				if (i>0) selSql = selSql + ",";
				selSql = selSql + document.access.CustSqlColSelect.options[i].value;
			}
		}
		document.tableDesc.XPOLOG_SEL_COLS.value = selXpolog;
		if (sameTable == 'true') document.tableDesc.SQL_SEL_COLS.value = selSql;
		document.tableDesc.CREATE_TBL_CHECKED.value = (document.access.createTable.checked == true ? "true" : "");
		document.tableDesc.submit();
	}

  function addToCust(type){
		selCust = "document.access.Cust" + type + "ColSelect";
		selReal = "document.access.Real" + type + "ColSelect";
    if(eval(selReal).selectedIndex == -1){
      return;
    }
    var name = eval(selReal).options[eval(selReal).selectedIndex].text;
    var value = eval(selReal).options[eval(selReal).selectedIndex].value;
    for(var i=0;i<eval(selCust).options.length;i++){
      if(eval(selCust).options[i].value == value){
				alert("You can not add a column twice!");
        return;
      }
    }
    var option0 = new Option(name,value);
    eval(selCust).options[eval(selCust).options.length] = option0;
    updateMessageString(type);
		updateStmt('true');
  }

	function removeFromCust(type){
		selCust = "document.access.Cust" + type + "ColSelect";
		if(eval(selCust).selectedIndex == -1){
			return;
		}
		eval(selCust).options[eval(selCust).selectedIndex] = null;
		updateMessageString(type);
		updateStmt('true');
	}

	function moveUpinCust(type){
		selCust = "document.access.Cust" + type + "ColSelect";
		if(eval(selCust).selectedIndex == -1){
			return;
		}
		index = eval(selCust).selectedIndex;
		if(index == 0){
			return;
		}
		eval(selCust).selectedIndex = index - 1;
		moveDowninCust(type);
		eval(selCust).selectedIndex = index;
		//updateMessageString(type);
		//updateStmt('true');
	}

	function moveDowninCust(type){
		selCust = "document.access.Cust" + type + "ColSelect";
		if(eval(selCust).selectedIndex == -1){
			return;
		}
		index = eval(selCust).selectedIndex;
		if(index == (eval(selCust).options.length-1) || eval(selCust).options.length == 1){
			return;
		}
		var options = new Array();
		for(var i=0;i<eval(selCust).options.length;i++){
			if(i == index){
				var option0 = new Option(eval(selCust).options[i+1].text,eval(selCust).options[i+1].value);
				options[i] = option0;
				option0 = new Option(eval(selCust).options[i].text,eval(selCust).options[i].value);
				options[i+1] = option0;
				i = i+1;
			}else{
				var option0 = new Option(eval(selCust).options[i].text,eval(selCust).options[i].value);
				options[i] = option0;
			}
		}
		for(var i=0;i<options.length;i++){
			eval(selCust).options[i] = null;
		}
		for(var i=0;i<options.length;i++){
			eval(selCust).options[i] = options[i];
		}
		eval(selCust).selectedIndex = index + 1;
		updateMessageString(type);
		updateStmt('true');
	}
	
	function updateMessageString(type) {
		var result = "(";
		selCust = "document.access.Cust" + type + "ColSelect";
		if (eval(selCust)){
			for(var i=0;i<eval(selCust).options.length;i++){
				result = result + "{" + eval(selCust).options[i].value + "}";
				if (i<eval(selCust).options.length-1) 
					result = result + ",";
			}
		}
		result = result + ")";
		<%if (dbTblDesc != null && dbTblDesc[0].length > 0){%>showArrows();<%}%>
	}
	
	function showArrows() {
		num = 0;
		if (document.access.CustXpologColSelect)
			num = document.access.CustXpologColSelect.options.length;
		for (var i=0; i<9; i++) {
			if (i<num){
				document.getElementById("arrow"+i).style.visibility = "visible";
			}
			else 
				document.getElementById("arrow"+i).style.visibility = "hidden";
		}
	}
	
	function showCreateStatement(){
		if (document.access.createTable.checked == true)
			document.getElementById("createStatement").style.display = "block";
		else
			document.getElementById("createStatement").style.display = "none";
	}
	
	function setCreateTable(){
		checkTableExists();
		document.access.createTable.checked = true;
	}
	
	function checkTableExists(){
		if (document.access.DB_TABLE.options){
			for (var i=0; i<document.access.DB_TABLE.options.length;i++){
				if (document.access.DB_TABLE.options[i].value == document.access.tableNameToUse.value)
					alert("Table already exists. Please selecte table from combo box");
			}
		}
	}
	
</script>
</head>
<body onload="javascript:init()">
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" action="<%=BASE_DIRECTORY%>tools/addresses/accoutAction.jsp" style="margin:0;padding:0">
<input type="hidden" name="ACCOUNT_TYPE" value="db">
<input type="hidden" name="NEW_TABLE_NAME" value="">
<input type="hidden" name="CREATE_NEW_TABLE">
<input type="hidden" name="TYPE_EXP" value="<%=exportType%>">
<input type="hidden" name="ACCOUNT_ID" value="<%=acc_id%>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="66%" class="TOPBORDER">
                <span class="PAGEHEADER">export log &quot;<%=lbm.getName()%>&quot; to database table</span> </td>
                <td width="11%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="66%">&nbsp;</td>
                <td width="11%">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%" >&nbsp;</td>
                <td colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
                  <tr>
                    <td width="40%" height="18"><span class="HEADER">Database details</span></td>
                  </tr>
                  <tr>
                    <td width="40%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">Database</span></td>
                        <td width="69%">
                        
                        <select class="TEXTBOX" size="1" name="addressId" onchange="javascript:getTables()">
                        <option value="">--- Select db account ---</option>
                        <%
                        	for(int i=0;i<list.size();++i){
                        		Account acc = (Account)list.get(i);
                        		String accSelected = acc.getId().equals(acc_id) ? " selected" : "";
                        %>
                        <option value="<%=acc.getId()%>"<%=accSelected%>><%=acc.getAccountName()%></option>
                        <%}%>
                        </select>
                        <% 
                        if (user == null || user.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){
                        %>
                        <a href="javascript:goNew()" class="LINK">new</a>
                        <%}if (!dbmed.connect(dbac)){%>
                        &nbsp;<span class="ERRORMESSAGE">[Database is not connected]</span>
                        <%}%>
                        </td>
                      </tr>
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">Table</span></td>
                        <td width="69%">
                        <select class="TEXTBOX" size="1" name="DB_TABLE" onchange="javascript:changeTable()">
                        <option value="">--- Select database table ---</option>
                        <%
                        	String[] dbtables = {""};
                        	if (dbmed.connect(dbac)) {
                        		dbtables = dbmed.getDBTablesNames();
				if (dbtables  == null){
	 			  dbtables = new String[]{""};
				}
                        	}
                        	else {
												    errmodel.addError("Could not connect to database. Check Database account definitions");
												    request.getSession().setAttribute(ERROR_OBJ,errmodel);
												    //response.sendRedirect("errorpage.jsp");
												    //return;
                        	}
                        	for(int i=0;i<dbtables.length;++i){
                        		String table = dbtables[i];
                        		String tblSelected = table.equals(table_name) ? " selected" : "";
	                        %>
  		                      <option value="<%=table%>"<%=tblSelected%>><%=table%></option>
      	                  <%}%>
                        </select>
                        </td>
                      </tr>
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">Table name to use</span></td>
                        <%if (create_table != null && !create_table.equals("")) create_table_checked = "checked";%> 
                        <td width="69%"><input type="text" class="TEXTBOX" name="tableNameToUse" size="20" value="<%=tableNameToUse%>" onchange="setCreateTable();updateStmt('true')">
                        &nbsp;&nbsp;<input type="checkbox" name="createTable" value="true" <%=create_table_checked%> onclick="javascript:showCreateStatement()">
                        <span class="REGULARTEXT">create table if it does not exist in database</span>
                        </td>
                      </tr>
                      <tr>
                        <td width="11%">&nbsp;</td>
                        <td width="69%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" id="AutoNumber19">
											<tr>
												<td height="20" colspan="3" align="center" valign="top"><span class="HEADER">Log columns</span></td>
												<%if (dbTblDesc != null && dbTblDesc[0].length > 0){%>
												<td width="30">&nbsp;</td>
												<td height="20" colspan="3" align="center" valign="top"><span class="HEADER">DB table columns</span></td>
												<%}%>
											</tr>
		                  <!-- Log columns -->
                      <tr>
                        <td>
                        <select size="7" name="RealXpologColSelect" id="RealXpologColSelect" style="width: 78; height: 156">
												<%
												String name = null;
												String value = null;
												for(int i=0;i<mask.getCulomnsNumber();++i){
													name = mask.getMaskColumn(i).getName();
													value = String.valueOf(i);
												%>
												<option class="TEXTBOX" value="<%=value%>" name="<%=name%>"><%=name%></option>
												<%
												}
												%>
                        </select>
                        </td>
                        <td>
                        	<table border="0" cellpadding="2" cellspacing="0" style="border-collapse: collapse" id="AutoNumber21">
                          <tr>
                            <td width="100%" align="center">
                            <a href="javascript:addToCust('Xpolog')" class="SMALLLINK">add ---&gt;</a> </td>
                          </tr>
													<tr>
														<td>&nbsp;</td>
													</tr>
                          <tr>
                            <td width="100%" align="center">
                            <a href="javascript:removeFromCust('Xpolog')" class="SMALLLINK">remove</a></td>
                          </tr>
                          <tr>
                            <td width="100%" align="center">
                           <a href="javascript:moveUpinCust('Xpolog')" class="SMALLLINK">Move up</a></td>
                          </tr>
                          <tr>
                            <td width="100%" align="center">
                            <a href="javascript:moveDowninCust('Xpolog')" class="SMALLLINK">&nbsp;Move down</a></td>
                          </tr>
                         </table>
                        </td>
                        <td>
                        <select size="7" name="CustXpologColSelect" id="CustXpologColSelect" style="width:78; height:156;">
                        <%
												name = null;
												value = null;
												int ci = -1;
												for(int i=0;i<xpologColumnMap.length;++i){
													//ci = cuman.getIndexFromCustomizedCol(i);
													ci = xpologColumnMap[i];
													if(ci == -1){
													continue;
												}
												name = mask.getMaskColumn(ci).getName();
												value = String.valueOf(ci);
												%>
												<option  class="TEXTBOX" value="<%=value%>" name="<%=name%>"><%=name%></option>
												<%
												}
												%>
												</select></td>
												<%if (dbTblDesc != null && dbTblDesc[0].length > 0){%>
												<td valign="top">
													<table>
													<% for (int i=0; i<9; i++) {%>
														<tr><td style="line-height:12px; visibility:hidden" id="arrow<%=i%>">---&gt</td></tr>
													<%}%>
													</table>
												</td>
												<!-- DB table columns -->
												<td>
												<select size="7" name="CustSqlColSelect" id="CustSqlColSelect" style="width: 78; height: 156">
												<%
												name = null;
												value = null;
												ci = -1;
												for(int i=0;i<sqlColumnMap.length;++i){
													ci = sqlColumnMap[i];
													//if(ci == -1){
													//	continue;
													//}
													name = dbTblDesc[0][ci];
													value = String.valueOf(ci);
												%>
													<option  class="TEXTBOX" value="<%=value%>" name="<%=name%>"><%=name%></option>
												<%
												}
												%>
												</select>
                        </td>
                        <td>
                        	<table border="0" cellpadding="2" cellspacing="0" style="border-collapse: collapse" id="AutoNumber20">
                          <tr>
                            <td width="100%" align="center">
                            <a href="javascript:addToCust('Sql')" class="SMALLLINK">&lt;--- add</a> </td>
                          </tr>
													<tr>
														<td>&nbsp;</td>
													</tr>
                          <tr>
                            <td width="100%" align="center">
                            <a href="javascript:removeFromCust('Sql')" class="SMALLLINK">remove</a></td>
                          </tr>
                          <tr>
                            <td width="100%" align="center">
                           <a href="javascript:moveUpinCust('Sql')" class="SMALLLINK">Move up</a></td>
                          </tr>
                          <tr>
                            <td width="100%" align="center">
                            <a href="javascript:moveDowninCust('Sql')" class="SMALLLINK">Move down&nbsp;</a></td>
                          </tr>
                         </table>
                        </td>
                        <td>
												<select size="7" name="RealSqlColSelect" id="RealSqlColSelect" style="width: 78; height: 156">
												<% 
												name = null;
												value = null;
												for(int i=0;i<dbTblDesc[0].length;++i){
													name = dbTblDesc[0][i];
													value = String.valueOf(i);
												%>
                          <option class="TEXTBOX" value="<%=value%>" name="<%=name%>"><%=name%></option>
                        <%
                           }
                        %>
                        </select>

                        </td>
												<%}%>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
	                  <td>
	                  <table id="createStatement" <%if (!create_table_checked.equals("checked")){%>style="display:none"<%}%>>
		                  <tr>
		                    <td>&nbsp;</td>
		                  </tr>
		                  <tr>
		                    <td><span class="HEADER">Create table statement</span></td>
		                  </tr>
		                  <tr>
		                    <td><span class="SMALLTEXT">Here you need to specify the sql create statement you
		                    want XpoLog to execute</span></td>
		                  </tr>
		                  <tr>
		                    <td><textarea class="TEXTBOX" rows="3" id="sqlCreate" name="sqlCreate" cols="120" style="font-size: 8pt"><%=createStmt%></textarea></td>
		                  </tr>
		                  <tr>
		                    <td><span class="SMALLTEXT">example:
		                            CREATE TABLE <i>TableName</i>(column_1 dataType_1,...,column_n dataType_n))</span></td>
		                  </tr>
	                  </table>
	                  </td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
	                  <td>
	                  <table>
		                  <tr>
		                    <td><span class="HEADER">Insert statement</span></td>
		                  </tr>
		                  <tr>
		                    <td><span class="SMALLTEXT">Here you need to specify the query you 
		                    want XpoLog to execute on the table listed above</span></td>
		                  </tr>
		                  <tr>
		                    <td><textarea class="TEXTBOX" rows="3" id="sqlInsert" name="sqlInsert" cols="120" style="font-size: 8pt"><%=query%></textarea></td>
		                  </tr>
		                  <tr>
		                    <td><span class="SMALLTEXT">example:
		                            INSERT INTO TABLE (column_1,...,column_n) VALUES ({field_i<span style="font-size:8px">1</span>},,,{field_i<span style="font-size:8px">n</span>})<!--&nbsp;&nbsp;&nbsp;<a href=javascript:openHelp('<%=BASE_DIRECTORY%>',"Pattern.htm") class="SMALLLINK">help</a>--></span></td>
		                  </tr>
		                </table>
		                </td>
	                </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="101%" id="AutoNumber17">
                      <tr>
                        <td width="25%">&nbsp;</td>
                        <td width="13%">
                        <p align="center">&nbsp;</td>
                        <td width="11%"><a href="javascript:history.go(-1)" class="LINK">previous</a></td>
                        <td width="11%"><a href="javascript:doNext()" class="LINK">next</a></td>
                        <td width="35%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>

<form name="showAccountTables" method="post" action="exportLogDB.jsp">
	<input type="hidden" name="ACCOUNT_ID">
	<input type="hidden" name="TYPE_EXP" value="<%=exportType%>">
</form>

<form name="tableDesc" method="post" action="exportLogDB.jsp">
	<input type="hidden" name="ACCOUNT_ID">
	<input type="hidden" name="TABLE_NAME">
	<input type="hidden" name="TABLE_NAME_TO_USE">
	<input type="hidden" name="SHOW_DESC">
	<input type="hidden" name="XPOLOG_SEL_COLS">
	<input type="hidden" name="SQL_SEL_COLS">
	<input type="hidden" name="CREATE_TBL_CHECKED">
	<input type="hidden" name="TYPE_EXP" value="<%=exportType%>">
</form>

</body>

</html>