<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.pack.*"%>


<%! 
	static final String BASE_DIRECTORY = "../../../";
%>

<%
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
	String moduleId = request.getParameter("MODULE_ID");
  Module curmod = null;
  if (moduleId != null && moduleId.length() > 0){
  	curmod = mgmt.getModuleFromId(moduleId);
  }
  String selectedModuleId = null;
  if (curmod == null){
  	curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
  }else{
  	selectedModuleId = curmod.getId();
  }
  
  String operation = request.getParameter("op");
  String actionURL = request.getParameter("actionURL");
  
  boolean execute = false;
  
  if (operation == null || operation.trim().length() == 0){
    operation = String.valueOf(ExportFlow.EXECUTE_TYPE);
    execute = true;
  } 
  
  if (actionURL == null){
    actionURL = "";
  }else{
    actionURL = BASE_DIRECTORY + actionURL;
  }
    
  String title = "Export Folder";
  String listTitle = "Export hirarchy";
  String listDesc = "Select the folders and logs to export:";
  
  String moduleTreeXMLParams = operation != null ? "?op=" + operation : "";
  if (selectedModuleId != null){
  	moduleTreeXMLParams += (moduleTreeXMLParams.length() > 0 ? "&" : "?");
  	moduleTreeXMLParams += "MODULE_ID=" + selectedModuleId;
  }
  
 
%>


<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script src="<%=BASE_DIRECTORY%>scripts/tree/rightClickMenu.js"></script>
<jsp:include page="../../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<script>
    baseDirectory = "<%=BASE_DIRECTORY%>";
    
    
    function doNext(){
      updateSelected();
      document.access.action = "exportModuleAction.jsp";
      document.access.submit();
    }
    
    function updateSelected(){
    	list = tree.getAllCheckedAndPartiallyChecked();
    	arr = list.split(",");
      var logsStr = "";
      var modsStr = "";
    	for (var i=0; i<arr.length; i++){
    		s = arr[i];
    		ind = s.indexOf("-");
    		if (ind == -1){
    			continue;
    		}else{
    			type = s.substring(0,ind);
    			id = s.substring(ind+1,s.length);
    			if (type == "<%=XpoLogObjectTypes.MODULE_TYPE%>"){
    				if (modsStr != ""){
    					modsStr += ",";
    				}
    				modsStr += id;
    				if (tree.hasChildren(s) && (tree.hasChildren(s)+"") == "true"){
	    				modsStr += "*";
    				}
    			}else{
    				if (logsStr != ""){
    					logsStr += ",";
    				}
    				logsStr += id;
    			}
    		}
    	}
    	document.access.mods.value = modsStr;
    	document.access.logs.value = logsStr;
    }
    
    function markTreeNodeForExport(node){
	nodeCbx = document.getElementById("CheckBox_" + node.tree.name + "_" + node.index);
	if (!nodeCbx) return;
	if (node.selected == nodeCbx.checked) return;
	
	var selected = nodeCbx.checked;	
  if (this.onSelectMarkChilds){
    markNodeChilds(node,selected);  
  }else {
    node.selected = selected;
  }
  
  if (this.onSelectMarkParents  && selected){
    markNodeParentsToRoot(node.parent,selected);  
  }
}
</script>
</head>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="POST" style="margin:0;padding:0">
<input type="hidden" name="op" value="<%=operation%>">
<input type="hidden" name="actionURL" value="<%=actionURL%>">
<input type="hidden" name="modid" value="<%=curmod == null?"" : curmod.getId()%>">
<input type="hidden" name="mods">
<input type="hidden" name="logs">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
              <tr>
                <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="53%" class="TOPBORDER" height="0">
                <span class="PAGEHEADER"><%=title%></span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER"><%=listTitle%></span><b>&nbsp;</b></td>
                  </tr>
                  <tr>
                    <td>
                    <span class="REGULARTEXT"><%=listDesc%></span>
                    </td>
                  </tr>
                  <tr>
                  	<td>
                    <span style="font-size:5">&nbsp;</span>
                    </td>
                  </tr>
									<tr>
										<td valign="top">
											<div id="loadingDiv" style="display:none">
												<span class="REGULARTEXT">Loading...</span>
											</div>
										</td>
									</tr>
                  <tr>
                    <td width="15%">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
											<tr>
												<td valign="top">
													<div id="treeboxbox_tree"></div>
												</td>
											</tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="30%">&nbsp;</td>
            <td width="31%" align="center">
              <table border="0" width="109%">
                <tr>
                  <td width="24%"><a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK">cancel</a></td>
                  <td width="40%">
                    <p align="center"><a href="javascript:history.go(-1)" class="LINK">previous</a></td>
                  <td width="46%"><a href="javascript:doNext()" class="LINK">next</a></td>
                </tr>
              </table>
            </td>
            <td width="39%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>

</table>
</form>
<script>
	tree=new dhtmlXTreeObject("treeboxbox_tree","100%","100%","0");
	tree.enableTreeLines(false);
	tree.setOnLoadingStart(startLoading);
	tree.setOnLoadingEnd(endLoading);
	tree.setImagePath("<%=BASE_DIRECTORY%>");
	tree.setIconSize(13,13);
	tree.enableCheckBoxes(1);
	tree.enableThreeStateCheckboxes(true);
	tree.setXMLAutoLoading("exportModuleTreeXML.jsp");
	tree.loadXML("exportModuleTreeXML.jsp<%=moduleTreeXMLParams%>");
</script>

</body>
</html>