<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.site.ui.tree.ModuleMemberRenderer"%>
<%@ page import="java.util.*"%>

<%
    if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.EXPORT_MODULE_PERMISSION,true)){
    return;
  }

  String ERROR_OBJ = "ERROR_OBJ";
  String LOG4J_BUILDER = "LOG4J_BUILDER";
  String CURRENT_MODULE = "CURRENT_MODULE";

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  UserContext userContext = UserEnvironment.getUserContext(request);

  String operation = request.getParameter("op");
  String actionURL = request.getParameter("actionURL");
  if (actionURL != null && actionURL.trim().length() == 0){
    actionURL = null;
  } 
  
  int op = Integer.parseInt(operation);
  String modid = request.getParameter("modid");
  if (modid != null && modid.trim().length() == 0){
    modid = Module.ROOT_MODULE_ID;
  }  
  
  HashMap logs = new HashMap();
  HashMap mods = new HashMap();
  
  String [] logsArr = null;
	String logsList = request.getParameter("logs");
	if (logsList != null && logsList.length() > 0){
		logsArr = logsList.split(",");
	}
  
  if (logsArr != null){
    for (int i = 0;i< logsArr.length;i++){
      logs.put(logsArr[i],logsArr[i]);
    }
  }
  String [] modsArr = null;
 	String modsList = request.getParameter("mods");
 	if (modsList != null && modsList.length() > 0){
 		modsArr = modsList.split(",");
 	}
  if (modsArr != null){
    for (int i = 0;i< modsArr.length;i++){
    	if (!modsArr[i].endsWith("*")){
      	mods.put(modsArr[i],modsArr[i]);
    	}
    }
  }
  if (modsArr != null){
    for (int i = 0;i< modsArr.length;i++){
    	String id = modsArr[i];
    	if (modsArr[i].endsWith("*")){
    		id = id.substring(0,id.length()-1);
    		ModuleMemberRenderer.addAllModuleChildren(id,mods,logs);
    	}
      mods.put(id,id);
    }
  }
  
  String EXPORT_FLOW = "EXPORT_FLOW";
  
  Module curmod = mgmt.getModuleFromId(modid);
 
	//	audit
  	String Name = "";
  	if(curmod != null) {
  		Name = curmod.getName();
  	}
  	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
  		  	userContext, AuditConstants.CHANGE, "export folder", AuditConstants.CONFIGURATION, "export folder " + Name);


  ExportModuleFlow flow = (ExportModuleFlow)request.getSession().getAttribute(EXPORT_FLOW);
  if (flow == null){
    flow = new ExportModuleFlow();
  }
  flow.setOperationType(op);
  flow.setActionURL(actionURL);
  flow.setLogModulesMap(logs,mods);
  flow.setModule(curmod);
  request.getSession().setAttribute(EXPORT_FLOW,flow);
  response.sendRedirect("mediaSelect.jsp");
%>

