<%@ page language="java"%>

<%@ page import="xpolog.eye.pack.ExportModuleFlow"%>
<%@ page import="xpolog.eye.pack.ExportFlow"%>
<%@ page import="xpolog.eye.site.ui.tree.ModuleMemberRenderer"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.util.*"%>

<%
	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
	
	String operation = request.getParameter("op");
	
	boolean execute = false;
	
	if (operation == null || operation.trim().length() == 0){
	  operation = String.valueOf(ExportFlow.EXECUTE_TYPE);
	  execute = true;
	} else if (operation.equals(String.valueOf(ExportFlow.EXECUTE_TYPE))){
		execute = true;
	}
	
	String EXPORT_FLOW = "EXPORT_FLOW";
	ExportFlow flow = (ExportFlow)request.getSession().getAttribute(EXPORT_FLOW);
	HashMap logsMap = null;
	HashMap modulesMap = new HashMap();
	HashMap selectedModules = new HashMap();
	if (execute || flow == null || !(flow instanceof ExportModuleFlow)){
	  flow = new ExportModuleFlow();
	  request.getSession().setAttribute(EXPORT_FLOW,flow);
	  String modid = request.getParameter("MODULE_ID");
	  if (modid != null){
	  	modulesMap.put(modid,modid);
		  selectedModules.put(modid,modid);
	  }
	  ModuleMemberRenderer.addModuleMemberParents(modulesMap, logsMap);
	  if (modid != null && modid.length() > 0){
	     try {
	       curmod = SiteManagment.getInstance().getModuleFromId(Module.ROOT_MODULE_ID);
	     }catch (Exception e){
	     }
	  }
	}else {
	  ExportModuleFlow mflow = (ExportModuleFlow)flow;
	  logsMap = mflow.getLogsToExp();
	  modulesMap = mflow.getModsToExp();
	  curmod = mflow.getModule();
	}
	
	boolean treeNodeExists = false;
	boolean showDefaultTree = true;
	boolean showStorageTree = true;
	
	String treeXml = ""; 
  String id = request.getParameter("id");
  if (id != null){
  	String modid = id;
  	int ind = id.indexOf("-");
  	if (ind != -1){
  		modid = id.substring(ind+1);
  	}
		curmod = SiteManagment.getInstance().getModuleFromId(modid);
		treeNodeExists = true;
  }
  
	
	if (curmod != null){
		ModuleMemberRenderer renderer = new ModuleMemberRenderer(curmod, userContext, modulesMap, logsMap, true, false, treeNodeExists);
		renderer.setSelectedModules(selectedModules);
		treeXml = renderer.getTreeXML(showDefaultTree,showStorageTree);
	}
	
	//System.out.println(treeXml);
	response.setContentType("text/xml");
	out.write(treeXml);
	out.flush();
%>