  <%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.data.xml.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.data.log.files.*"%>
<%@ page import="xpolog.eye.admin.global.custom.*"%>

<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.ConfigurationPermissions.GLOBAL_CUSTOM_PERMISSION,true)){
    return;
  }
  //constants
  String LOG_ID = "LOG_ID";
  String SET_ID = "ID";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_NAME = "LOG_NAME";
  String LOG_DESCRIPTION = "LOG_DESCRIPTION";
  String MODULE_ID = "MODULE_ID";
  String ERROR_OBJ = "ERROR_OBJ";

  String COLOR_PRIOR_NAME = "COLOR_PRIOR_NAME_";
  String COLOR_PARAM = "COLOR_PARAM_";

  //page data
  LogBrowsingManager lbm = null;
  String logname    = "";
  boolean updateLinesNumber = false;
  boolean toCheckLineNumbers = false;
  boolean toCheckUseIndexing = false;
  boolean useIndexing = false;
  
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  UserContext userContext = UserEnvironment.getUserContext(request);
  
  String cusId = request.getParameter(SET_ID);
  GlobalCustomization glm = GlobalCustomization.getInstance();
  
  CustomizationSet cusSet = null;
  CustomizationManager cuman = null;
  RecordMask mask = null;
  
  if(cusId != null){
    cusSet = glm.getCustomizationSetById(cusId);
  	cuman = cusSet.custMgr;
  	mask = cusSet.recordMask; 
  }else{
	 	cusSet = new CustomizationSet();
	 	cusSet.name = "new customization";
	 	cusSet.description = "";
	 	cusSet.id = "";
  }
  ModuleMember[] mmarr = null;
 
  // trying to create customization and mask form log.
  if(cuman == null){
  	mmarr = mgmt.getAllLogBrowsersIds(userContext, false);
    String lid = request.getParameter(LOG_ID);
    if((lid != null) && !(lid.trim().equals(""))){
     try{
      lbm = mgmt.getLogBrowserManager(lid,false,false,true);
     }catch(Exception e){}
    }else{
      lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
    }
    if((lbm == null) && (mmarr.length > 0)){
   	 lbm = mgmt.getLogBrowserManager(mmarr[0].getId(),false,false,true);
    }
    if(lbm != null && lbm.getId() != null){
      logname = lbm.getName();
      cuman = lbm.getCustomizationManager();
      mask = lbm.getRecordMask();
    }
   }//created mask and customization form log.
    
    
    if(cuman == null){
      ErrorModel ermod = new ErrorModel();
      ermod.addError("Error in creating a global customization set please conatct tech support.");
      request.getSession().setAttribute(ERROR_OBJ,ermod);
      response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
      return;
    }
    
    //search and filter issue
   	String searchAndFilterDef = Configuration.getInstance().getPropertiesManager().getProperty("searchAndFilterDef","START");

    
    String[] priorities = null;
    int cnum = mask != null ? mask.getCulomnsNumber() : 0;
    for(int i=0;i<cnum;++i){
      if((mask.getMaskColumn(i) instanceof PriorityMask)){
        priorities = ((PriorityMask)mask.getMaskColumn(i)).getPriorities();
      }
    }
    HashMap p2c = cuman.getPriorityColorMap();

    String startOperation = cuman.getStartOperation();
    if (startOperation == null || startOperation.length() == 0){
      startOperation = "CURRENT";
    }
    boolean showIndexing = SiteManagment.getInstance().getXpologManagment().isComponentLicenseValid(XpologManagment.SEARCH_ENGINE_COMPONENT) && !XpologLicenseManager.getInstance().isDemo() && toCheckUseIndexing;
 
%>


<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>
  function doApply(){
    var path = "customAction.jsp?";
    //name
	path = path + "customName=" + document.access.customName.value + "&";
	//description
	path = path + "customDesc=" + document.access.customDesc.value + "&";
	//id
	path = path + "customId=" + document.access.customId.value + "&";
	<%if(lbm != null){%>
		logId = document.access.logbrowser.options[document.access.logbrowser.selectedIndex].value;
		path = path + "logbrowser=" + logId + "&";
	<%}%>

    var val = "";
    for(var i=0;i<document.access.CustomizedColSelect.options.length;i++){
      val = document.access.CustomizedColSelect.options[i].value;
      path = path + "COL_INDEX_" + val + "=" + i;
      if(i == document.access.CustomizedColSelect.options.length-1){
        continue;
      }
      path = path +"&";
    }

    <%
      if(priorities != null){
    %>
      var usePriorityColorsStr = document.access.usePriorityColors.checked;
      path = path + "&usePriorityColors=" + usePriorityColorsStr;
      numI = <%=String.valueOf(priorities.length)%>;
      for(var i=0;i<numI;++i){
        path = path + "&<%=COLOR_PARAM%>" + i +"="+ eval("document.access.<%=COLOR_PRIOR_NAME%>"+i+".value");
      }
    <%
      }
    %>
     var op = "CURRENT";
     for(var i=0;i<document.access.startOperation.length;++i){
       if (document.access.startOperation[i].checked){
         op = document.access.startOperation[i].value;
         break;
       }
     }
     path = path + "&startOperation=" + op;
      <%
      	if(toCheckLineNumbers) {
      %>
		if (document.access.updateLinesNumberStr.checked){
           var linesNumber = document.access.updateLinesNumberStr.value;
           path = path + "&updateLinesNumberStr=" + linesNumber;
       }
	  <%
	    }
	  %>
		if (document.access.searchAndFilterDefStr.checked){
           var searchAndFilterDef = document.access.searchAndFilterDefStr.value;
           path = path + "&searchAndFilterDefStr=" + searchAndFilterDef;
       }
    
      var indexing = document.access.useIndexingStr.checked;
      path = path + "&useIndexingStr=" + indexing;
    document.location = path;
  }

  function addToCust(){
    if(document.access.RealColSelect.selectedIndex == -1){
      return;
    }
    var name = document.access.RealColSelect.options[document.access.RealColSelect.selectedIndex].text;
    var value = document.access.RealColSelect.options[document.access.RealColSelect.selectedIndex].value;
    for(var i=0;i<document.access.CustomizedColSelect.options.length;i++){
      if(document.access.CustomizedColSelect.options[i].value == value){
	alert("You can not add a column twice!");
        return;
      }
    }
    var option0 = new Option(name,value);
    document.access.CustomizedColSelect.options[document.access.CustomizedColSelect.options.length] = option0;
  }

  function removeFromCust(){
    if(document.access.CustomizedColSelect.selectedIndex == -1){
      return;
    }
    document.access.CustomizedColSelect.options[document.access.CustomizedColSelect.selectedIndex] = null;
  }

  function moveUpinCust(){
      if(document.access.CustomizedColSelect.selectedIndex == -1){
        return;
      }
      index = document.access.CustomizedColSelect.selectedIndex;
      if(index == 0){
      	return;
      }
      document.access.CustomizedColSelect.selectedIndex = index - 1;
      moveDowninCust();
      document.access.CustomizedColSelect.selectedIndex = index;
    }

	function moveDowninCust(){
      if(document.access.CustomizedColSelect.selectedIndex == -1){
        return;
      }
      index = document.access.CustomizedColSelect.selectedIndex;
      if(index == (document.access.CustomizedColSelect.options.length-1) || document.access.CustomizedColSelect.options.length == 1){
        return;
      }
	   var options = new Array();
	   for(var i=0;i<document.access.CustomizedColSelect.options.length;i++){
      	  if(i == index){
      	  	var option0 = new Option(document.access.CustomizedColSelect.options[i+1].text,document.access.CustomizedColSelect.options[i+1].value);
      		options[i] = option0;
      		var option0 = new Option(document.access.CustomizedColSelect.options[i].text,document.access.CustomizedColSelect.options[i].value);
      		options[i+1] = option0;
      		i = i+1;
      	  }else{
      	    option0 = new Option(document.access.CustomizedColSelect.options[i].text,document.access.CustomizedColSelect.options[i].value);
      		 options[i] = option0;
      	  }
       }
       for(var i=0;i<options.length;i++){
      	   document.access.CustomizedColSelect.options[i] = null;
       }
       for(var i=0;i<options.length;i++){
      	  document.access.CustomizedColSelect.options[i] = options[i];
       }

       document.access.CustomizedColSelect.selectedIndex = index + 1;
    }


   function openColorSelector(name){
    window.open('<%=BASE_DIRECTORY%>colorchooser/ColorChooser.jsp?TEXT_NAME=' + name,'color','width=300,height=300,status=no,resizable=no,top=200,left=400,dependent=yes,alwaysRaised=yes');
  }
  
  function reloadScr(){
    index = document.access.logbrowser.selectedIndex;
    id = document.access.logbrowser.options[index].value;
    document.location = "customAdmin.jsp?LOG_ID=" + id;
  
  }
</script>
</head>
<body>
<form AUTOCOMPLETE="OFF" id="access" name="access">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="53%" class="TOPBORDER" height="0">
                <span class="PAGEHEADER">Global Customization&nbsp;</span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="43%">&nbsp;</td>
                <td width="30%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18">
                      <table border="0" width="100%" cellspacing="0" cellpadding="0">
                        <tr>
                          <td width="17%"><span class="REGULARTEXT">Name</span></td>
                          <td width="33%"><input type="text" class="TEXTBOX" name="customName" value="<%=cusSet.name%>" size="20"><input type="hidden" class="TEXTBOX" name="customId" value="<%=cusSet.id%>" size="1">
                          </td>
                          <td width="34%">&nbsp;</td>
                        </tr>
                        <tr>
                          <td width="17%"><span class="REGULARTEXT">Description </span></td>
                          <td width="33%"><input type="text" class="TEXTBOX" name="customDesc" value="<%=cusSet.description%>" size="57">
                          </td>
                          <td width="34%">&nbsp;</td>
                        </tr>
                        <%if(lbm != null){%>
                        <tr>
                          <td width="17%"><span class="REGULARTEXT">Selected Log</span></td>
                          
                          <td width="33%">
                          <select size="1" name="logBrowser" id="logbrowser" style="height:20" onchange="javascript:reloadScr()">
							<%
                          		String lid = lbm.getId();
                           		for(int i=0;i<mmarr.length;++i){
                           			String sel = lid.equals(mmarr[i].getId()) ? "selected" : "";
                          	%>
                             	<option  class="TEXTBOX" value="<%=mmarr[i].getId()%>" <%=sel%>><%=mmarr[i].getName()%></option>
                         	<%
                            	}
                          	%>

                         	</select>
                         	</td>
                          <td width="34%">&nbsp;</td>
                        </tr>
                         <%}%>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Table customization</span></td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber19">
                      <tr>
                        <td width="17%">


                        <select size="7" name="RealColSelect" id="RealColSelect" style="width: 250; height: 156">

                          <%
                            String name = null;
                            String value = null;
                            for(int i=0;i<mask.getCulomnsNumber();++i){
                              name = mask.getMaskColumn(i).getName();
                              value = String.valueOf(i);
                          %>
                          <option class="TEXTBOX" value="<%=value%>" alt="<%=name%>" title="<%=name%>" name="<%=name%>"><%=name%></option>
                          <%
                            }
                          %>
                        </select>


                        </td>
                        <td width="10%" style="padding-left:5;padding-right:5">
                        	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="77%" id="AutoNumber20">
                          <tr>
                            <td width="100%" align="center">
                            <a href="javascript:addToCust()" class="SMALLLINK">add</a> </td>
                          </tr>
                          <tr>
                            <td width="100%" align="center">
                            <a href="javascript:removeFromCust()" class="SMALLLINK">remove</a></td>
                          </tr>
                         </table>

                        </td>
                        <td width="14%">
                         <select size="7" name="CustomizedColSelect" id="CustomizedColSelect" style="width: 250; height: 156">

                         <%
                            name = null;
                            value = null;
                            int ci = -1;
                            for(int i=0;i<mask.getCulomnsNumber();++i){
                              ci = cuman.getIndexFromCustomizedCol(i);
                              if(ci == -1){
                                continue;
                              }
                              name = mask.getMaskColumn(ci).getName();
                              value = String.valueOf(ci);
                          %>
                          <option  class="TEXTBOX" value="<%=value%>" alt="<%=name%>" title="<%=name%>" name="<%=name%>"><%=name%></option>
                          <%
                            }
                          %>

                         </select></td>
                        <td width="14%" style="padding-left:5;padding-right:5">
                        	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber21">
                          <tr>
                            <td width="100%" align="center">
                           <a href="javascript:moveUpinCust()" class="SMALLLINK"><nobr>Move up</nobr></a></td>
                          </tr>
                          <tr>
                            <td width="100%" align="center">
                            <a href="javascript:moveDowninCust()" class="SMALLLINK"><nobr>Move down</nobr></a></td>
                          </tr>
                        </table>
                        </td>
                        <td width="20%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td width="15%">
                    &nbsp;</td>
                  </tr>
                  <%
                      if(priorities != null){
                      	boolean usePriorityColors = cuman.isUsePriorityBgColor();
                        String priorName = "";
                  %>
                  <tr>
                    <td><span class="HEADER">Priority color selection</span></td>
                  </tr>
                  <tr>
                    <td><input id="usePriorityColors" name="usePriorityColors" type="checkbox" <%=usePriorityColors?"checked" : ""%> value="true"><span class="REGULARTEXT">Use priority colors</span></td>
                  </tr>                 
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber18">
                        <%
                          String val = "";
                          String[] defcol = null;
                          if(p2c.size() == 0){
                            DefaultColorConfig colm = Configuration.getInstance().getDefColorMgr();
                            defcol = colm.getPriorColorsForNumber(priorities.length);
                          }
                          for (int i=0;i<priorities.length;++i){
                            priorName = priorities[i];
                            val = (String)p2c.get(priorities[i]);
                            if(val == null){
                              if(defcol != null){
                                val = defcol[i];
                              }else{
                                val = "";
                              }
                            }
                        %>
                      <tr>
                        <td width="20%"><span class="REGULARTEXT">&nbsp;<%=priorName%> &nbsp;paint in </span></td>
                        <td width="80%">
                          <input type="text" class="TEXTBOX" name="<%=COLOR_PRIOR_NAME + String.valueOf(i)%>" value="<%=val%>">
                          <a href="javascript:openColorSelector('<%=COLOR_PRIOR_NAME + String.valueOf(i)%>')" class="SMALLLINK">pick color</a>
                        </td>
                      </tr>
                      <%
                        }
                      %>
                      </table>

                    </td>
                  </tr>

                  <%
                     }
                  %>
                  <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
                  <%
                  if(toCheckLineNumbers) {
                  %>
                   <tr>
                    <td><span class="HEADER">Log View Settings</span></td>
                  </tr>                  
                  <tr>
                    <td><input id="updateLinesNumberStr" name="updateLinesNumberStr" type="checkbox"  <%=updateLinesNumber?"checked" : ""%>><span class="SMALLTEXT">Show lines number - when this option is checked you will be able to see the lines number <br>&nbsp;&nbsp;&nbsp;(Note: unchecking this option will improve performance on browsing to the end of the log) </span></td>
                  </tr>                 
                  <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
                  <%
                    }
                  %>
                   <tr>
                    <td><span class="HEADER">Log Search Settings</span></td>
                  </tr>                  
                  <tr>
                    <td><input id="searchAndFilterDefStr" name="searchAndFilterDefStr" type="checkbox"  <%=searchAndFilterDef.equals("START")?"checked" : ""%>><span class="SMALLTEXT">When checked - a search and filter result will be presented from the beginning of the log<br>&nbsp;&nbsp;&nbsp;(Note: when unchecked the result is on current view) </span></td>
                  </tr>                 
                  <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
                   <tr>
                    <td><span class="HEADER">Log Start Operation</span></td>
                  </tr>
                  <tr>
                    <td><span class="SMALLTEXT">When viewing a log that compound of several files,<br>
					you may choose from which file to start your view.</span></td>
                  </tr>
				  <tr><td><span class="SMALLTEXT">&nbsp;</span></td></tr>
                  <tr>
                    <td>
                     <input type="radio" value="CURRENT" name="startOperation" <%=startOperation.equals("CURRENT")? "checked" : ""%>><span class="REGULARTEXT">View from the beginning of the most updated file</span><br>
                     <input class="REGULARTEXT" type="radio" value="START" name="startOperation" <%=startOperation.equals("START")? "checked" : ""%>><span class="REGULARTEXT">View from the beginning of the oldest file</span><br>
                     <input class="REGULARTEXT" type="radio" value="LAST" name="startOperation" <%=startOperation.equals("LAST")? "checked" : ""%>><span class="REGULARTEXT">View from the end of the most updated file</span><br>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    &nbsp;</td>
                  </tr>                  
                 
                  <tr <%=showIndexing ? "" : "style=\"visibility:hidden\""%>>
                    <td><span class="HEADER">Indexing settings</span></td>
                  </tr>                  
                  <tr <%=showIndexing ? "" : "style=\"visibility:hidden\""%>>
                    <td><input id="useIndexingStr" name="useIndexingStr" type="checkbox" <%=useIndexing?"checked" : ""%>><span class="REGULARTEXT">Use indexing</span><br><span class="SMALLTEXT">&nbsp;&nbsp;&nbsp;using log indexing enables rapid search and filtering; indexed logged can be used in Xpolog Search Engine </span></td>
                  </tr>                 
                  <tr>
                    <td><b>&nbsp;</b></td>
                  </tr>
                 


                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber17" height="14">
                      <tr>
                        <td width="21%">&nbsp;</td>
                        <td width="13%" align="center">
                        &nbsp;</td>
                        <td width="4%" align="center">
                        <a href="globalCustom.jsp" class="LINK">cancel</a>&nbsp;&nbsp;
                        </td>
                        <td width="17%" align="center">
                        <p align="left">
                        &nbsp;<a href="javascript:doApply()" class="LINK">save</a></p>
                        </td>
                        <td width="30%"></td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>