  <%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>
<%@ page import="xpolog.eye.computation.conf.HealthConfig"%>
<%@ page import="xpolog.eye.computation.impl.FilterComputationDefUnit"%>
<%@ page import="xpolog.eye.data.source.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.data.log.files.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.admin.global.filters.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%!
  static final String BASE_DIRECTORY = "../../../";

  String dateFormat = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
  String millisecondsSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator",".");
  String dateFormatMS = dateFormat+millisecondsSeperator+"SSS";

  public String transformDateToString(Date d,long timeDiff){
    if(d == null){
      return null;
    }
    if (timeDiff != 0){
       long time = d.getTime();
    	 d = ((Date)d.clone());
    	 d.setTime(time + timeDiff); 
    }
    //01/31/2003 01:42:34
    String format = "";
    if (d.getTime() % 1000 == 0){
	    format = dateFormat;
    } else {
	    format = dateFormatMS;
    }
    String str = new SimpleDateFormat(format).format(d);
    return str;
  }

  boolean showHealth = Configuration.getInstance().getPropertiesManager().getProperty("log.filter.showHealthSettings","false").equals("true");

%>
<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.ConfigurationPermissions.GLOBAL_FILTERS_PERMISSION,true)){
	return;
  }
  //constants
  String LOG_ID = "LOG_ID";
  String SET_ID = "ID";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_NAME = "LOG_NAME";
  String LOG_DESCRIPTION = "LOG_DESCRIPTION";
  String MODULE_ID = "MODULE_ID";
  String ERROR_OBJ = "ERROR_OBJ";

//constants
  String EDIT_FILTER_ID = "EDIT_FILTER_ID";
  String OP = "OP";
  String ADD = "ADD";

  String STRING_FILTER = "StringFilter";
  String PRIORITY_FILTER = "PriorityFilter";
  String DATE_FILTER = "DateFilter";
  String CHOICE_FILTER = "ChoiceFilter";
  String MULTI_FILTER = "MultiFilter";
  String NUMBER_FILTER = "NumberFilter";
  String SHOW_ONLY_VISIBLE_FIELDS = "ShowOnlyVisibleFields";

  String FILTER_VALUE_PARAM  = "StringFilterValue_";
  String FILTER_CHECK_PARAM  = "StringFilterCheck_";
  String FILTER_OP_PARAM     = "StringFilterOp_";
	String FILTER_CASE_SENSITIVE_PARAM = "StringFilterCaseSensitive_";
	String FILTER_REG_EXP_PARAM = "StringFilterRegExp_";
	String FILTER_MATCH_WHOLE_WORDS_PARAM = "StringFilterMatchWholeWords_";
  int STR_FILTER_NUMBER = 4;

  String PRIOR_CHECK_NAME = "PriorityCheck_";
  String PRIOR_SPEC_VAL = "PRIOR_SPEC_VAL_";

  String DATE_MIN_FILTER_ACTIVE = "DateMinFilterActive";
  String DATE_MAX_FILTER_ACTIVE = "DateMaxFilterActive";
  String DATE_MIN_FILTER_ACTIVE_PARAM = "DATE_MIN_FILTER_ACTIVE_PARAM";
  String DATE_MAX_FILTER_ACTIVE_PARAM = "DATE_MAX_FILTER_ACTIVE_PARAM";
  String DATE_MINIMUM = "DateMinimum";
  String DATE_MAXIMUM = "DateMaximum";
  String DATE_FILTER_MINIMUM_PARAM = "DATE_FILTER_MINIMUM_PARAM";
  String DATE_FILTER_MAXIMUM_PARAM = "DATE_FILTER_MAXIMUM_PARAM";

  //page data
  
  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  UserContext userContext = UserEnvironment.getUserContext(request);
  
  String cusId = request.getParameter(SET_ID);
  GlobalFilters glm = GlobalFilters.getInstance();
  
  LogBrowsingManager lbm = null;
  String logname    = "";
  String filterDesc = "";
  FilterSet cusSet = null;
  FilterManager fman = null;
  RecordMask mask = null;
  CustomizationManager cust = null;
  
  if(cusId != null){
    cusSet = glm.getFilterSetById(cusId);
  	fman = cusSet.filterMgr;
  	mask = cusSet.recordMask; 
  }else{
	 	cusSet = new FilterSet();
	 	cusSet.name = "new filter";
	 	cusSet.description = "";
	 	cusSet.id = "";
  }
  ModuleMember[] lbarr = mgmt.getAllLogBrowsersIds(userContext, false);;
 
  // trying to create customization and mask form log.
  if(fman == null){
    String lid = request.getParameter(LOG_ID);
    if((lid != null) && !(lid.trim().equals(""))){
			try{
				lbm = mgmt.getLogBrowserManager(lid,false,false,true);
			}catch(Exception e){}
		}else{
		  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
		}
    if((lbm == null) && (lbarr.length > 0)){
    	 lbm = mgmt.getLogBrowserManager(lbarr[0].getId(),false,false,true);
     }
    if(lbm != null && lbm.getId() != null){
      logname = lbm.getName();
      if (lbm.isHavingLastFilterView()){
    		fman = lbm.getLastFilterManager();
  		}else {
    		fman = lbm.getFilterManager();
  		}
      mask = lbm.getRecordMask();
    }
   }//created mask and customization form log.
    
    
  PriorityFilter prtfl = null;
  DateFilter datefl = null;


  String filterId = request.getParameter(EDIT_FILTER_ID);
  if(cusId == null && filterId == null){
  	filterId = "none";
  }
  
  if(filterId == null){

		List filters = fman.getFilterCollections();
		for (int i = 0; i < filters.size(); i++) {
			FilterCollection afc =((FilterCollection)filters.get(i));
			 List isMulti = afc.getByName(MULTI_FILTER);
      		if(isMulti == null || isMulti.size()== 0){
				filterId = afc.getId();
				//maybe bug since set on reference from lbm.
				fman.setActiveFilterId(filterId);
				break;
			}
		}
 	}
  
  int numFilterc = 0;
  if(fman != null){
    numFilterc = fman.getFilterCollections().size();
  }
  String filterName = "GenFilterName_" + String.valueOf(numFilterc);
  String ADDparamToPass = "";
  String EDITparamToPass = "";
  FilterCollection fc = null;
  if(filterId != null && !(filterId.equals("none"))){
      fman.setActiveFilterId(filterId);
      fc = fman.getFilterCollectionById(filterId);
      EDITparamToPass = filterId;
      if(fc != null){
      	String op = request.getParameter(OP);
      	if (op != null && op.equals("duplicate")){
      		fc = (FilterCollection)fc.clone();
      		fc.setId(null);
      		fc.setName("copy of "+fc.getName());
		      EDITparamToPass = "";
      	}
        filterName = fc.getName();        
        filterName = filterName.replaceAll("\"", "&quot;");
        filterDesc = fc.getDescription();
      }

  }else{
    fc = new FilterCollection();
    ADDparamToPass = "ADD";
  }

  //extracting the filters for data
  List strfl  = fc.getByName(STRING_FILTER);
  if(strfl == null){
    strfl = new LinkedList();
  }

  String[] priorities = null;
  int cnum = mask != null ? mask.getCulomnsNumber() : 0;
  ArrayList choiceList = new ArrayList();
  ArrayList choiceFilters = new ArrayList();
  HashMap choiceMap = new HashMap();
  LinkedList numberMaskFields = new LinkedList();
  HashMap numberMap = new HashMap();
  HashMap reverseNumberMap = new HashMap();
  boolean choiceMaskExsit = false;
  boolean dateMaskExsit = false;
  boolean numberMaskExists = false;
  int choiceNum = 0;
  int numberMaskNum = 0;
  long timeDiff = 0;

  for(int i=0;i<cnum;++i){
    if((mask.getMaskColumn(i) instanceof PriorityMask)){
      priorities = ((PriorityMask)mask.getMaskColumn(i)).getPriorities();
    }else if((mask.getMaskColumn(i) instanceof DateMask)){
      dateMaskExsit = true;
      if (i == mask.getDateColumnIndex()){
        timeDiff = ((DateMask)mask.getMaskColumn(i)).getTimeDiff();
      }
    }else if(mask.getMaskColumn(i) instanceof ChoiceMask){
      choiceList.add(mask.getMaskColumn(i));
      choiceMap.put(new Integer(i),new Integer(choiceNum++));
    }else if(mask.getMaskColumn(i) instanceof NumberMask){
    	numberMaskFields.add(mask.getMaskColumn(i));
    	numberMap.put(new Integer(i),new Integer(numberMaskNum));
    	reverseNumberMap.put(new Integer(numberMaskNum),new Integer(i));
    	numberMaskNum++;
    }
  }
  ChoiceFilter[] choice_filters = new ChoiceFilter[choiceList.size()];
  if(choiceList.size()>0){
    choiceMaskExsit = true;
  }

  choiceNum = choiceList.size();
  if(fc.getByName(CHOICE_FILTER) != null && fc.getByName(CHOICE_FILTER).size() > 0){
    List chlf = fc.getByName(CHOICE_FILTER);
    ChoiceFilter cf = null;
    for(int i=0;i<chlf.size();++i){
      cf = (ChoiceFilter)chlf.get(i);
      Integer index = (Integer)choiceMap.get(new Integer(cf.getColIndex()));
      choice_filters[index.intValue()] = cf;
      cf = null;
    }
  }

  NumberFilter[] number_filters = new NumberFilter[numberMaskFields.size()];
  if(numberMaskFields.size()>0){
    numberMaskExists = true;
  }

  numberMaskNum = numberMaskFields.size();
  if(fc.getByName(NUMBER_FILTER) != null && fc.getByName(NUMBER_FILTER).size() > 0){
    List numlf = fc.getByName(NUMBER_FILTER);
    NumberFilter nf = null;
    for(int i=0;i<numlf.size();++i){
      nf = (NumberFilter)numlf.get(i);
      Integer index = (Integer)numberMap.get(new Integer(nf.getColIndex()));
      number_filters[index.intValue()] = nf;
      nf = null;
    }
  }



  if(fc.getByName(PRIORITY_FILTER) != null && fc.getByName(PRIORITY_FILTER).size() > 0){
    List l = fc.getByName(PRIORITY_FILTER);
    if((l != null) && (l.size() > 0)){
      prtfl = (PriorityFilter)l.get(0);
    }
  }

  Date minDate = null;
  Date maxDate = null;
  String minDateStr = "";
  String maxDateStr = "";
  String minStat = "";
  String maxStat = "";
  String timeunit = "";
  String isTimeLim = "";
  String daystatsel = "";
  String minstatsel = "";
  String hourstatsel = "selected";
  String weekstatsel = "";
  String monthstatsel = "";
  boolean isLast = true;

  if(fc.getByName(DATE_FILTER) != null && fc.getByName(DATE_FILTER).size() > 0){
   datefl = (DateFilter)fc.getByName(DATE_FILTER).get(0);
    if(datefl.getTimeType() == -1){
      minDate = datefl.getMinDate();
      maxDate = datefl.getMaxDate();      
    }else{
      hourstatsel = "";
      isLast = datefl.isLastOpType();
      isTimeLim = "checked";
      timeunit = String.valueOf(datefl.getTimeGap());
      if(datefl.isMonths()){
        monthstatsel = "selected";
      } else if(datefl.isWeeks()){
        weekstatsel = "selected";
      } else if(datefl.isDays()){
        daystatsel = "selected";      
      }else if(datefl.isHours()){
        hourstatsel = "selected";
      }else if(datefl.isMinutes()){
        minstatsel = "selected";
      }else {
        hourstatsel = "selected";
      }
    }
  }

  long minTimeDiff = timeDiff;
  if(minDate == null){
    minDate = new Date();
    long t = minDate.getTime();
    minDate.setTime(t-(t%1000));
    minTimeDiff = 0;
  }else{
    minStat = "checked";
  }

  long maxTimeDiff = timeDiff;
  if(maxDate == null){
   maxDate = new Date();
    long t = maxDate.getTime();
    maxDate.setTime(t-(t%1000));
    maxTimeDiff = 0;
  }else{
    maxStat = "checked";
  }
  minDateStr = transformDateToString(minDate,minTimeDiff);
  maxDateStr = transformDateToString(maxDate,maxTimeDiff);
  
  boolean isIndexing = false;
  String showOnlyVisibleFieldsStr = request.getParameter(SHOW_ONLY_VISIBLE_FIELDS);
  boolean showOnlyVisibleFields = (showOnlyVisibleFieldsStr != null && showOnlyVisibleFieldsStr.equals("true"));
  
  //filter list.
  List flist = null;
  if(lbm != null){
  	flist = new ArrayList();
    FilterCollection newFilter = new FilterCollection();
    newFilter.setId("none");
    newFilter.setName("--- select filter ---");
  	flist.add(newFilter);
	  FilterManager tfm = lbm.getFilterManager();
	  tfm.setUseGlobal(false);
	  List myFlist = tfm.getFilterCollections();
	  for(int i=0;i<myFlist.size();i++){
	  	FilterCollection ffc = (FilterCollection)myFlist.get(i);
			List m = ffc.getByName(MultiFilter.MULTI_FILTER_NAME);
			if(m == null || m.size() ==0){
				flist.add(ffc);
			}
	  }
	  tfm.setUseGlobal(true);
  }
  
  ComputationConfiguration computeConf = ComputationConfiguration.getInstance();
  boolean displaySystemHealth = showHealth;
%>


<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>
  
  function reloadScr(){
    index = document.access.logbrowser.selectedIndex;
    id = document.access.logbrowser.options[index].value;
    document.location = "filterAdmin.jsp?LOG_ID=" + id;
  
  }
  
  function reloadScrFilter(){
  	if(document.access.logfilter.options.length == 0){
  		return;
  	}
    index = document.access.logbrowser.selectedIndex;
    id = document.access.logbrowser.options[index].value;
    fi = document.access.logfilter.selectedIndex;
    fid = document.access.logfilter.options[fi].value;
    document.location = "filterAdmin.jsp?LOG_ID=" + id +"&EDIT_FILTER_ID="+fid;
  }

  function doApply(){

    <%
      if(priorities != null){
    %>
      addAllFiledToSelection(document.access.To,document.access.ToSelect);
      for(var i=0;i<document.access.ToSelect.options.length;++i){
        document.access.ToSelect.options[i].selected='true';
      }
    <%
      }
    %>

    <%
      if(choiceMaskExsit){
    %>
      var choicenumber = <%=String.valueOf(choiceNum)%>;
      for(var i=0;i<choicenumber;++i){
        selToH = eval("document.access.To_Select_"+i);
        selTo = eval("document.access.To_"+i);
        addAllFiledToSelection(selTo,selToH);
        for(var t=0;t<selToH.options.length;++t){
          selToH.options[t].selected='true';
        }
      }
    <%
      }
    %>

    document.access.action="filterAction.jsp";
    document.access.submit();
  }

  function markStringCheck(filed,tocheck){
  	//filed.value = trim(filed.value);
  	if(filed.value == ""){
  		tocheck.checked = false;
  		return;
  	}
  	tocheck.checked = true;
  }

  function trim(a){
	while(''+a.charAt(a.length-1)==' '){
	 a=a.substring(0,a.length-1);
	}
  	return a;
  }

  function checkDate(date_check_box, date_obj){
  	date_ok = "";
  	obj_name = date_check_box.name;
  	frames['dateValidationFrame'].location = "<%=BASE_DIRECTORY%>calendar/dateValidation.jsp?dateStr="+date_obj.value+"&date_check_box="+obj_name;
  }

</script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>

<title></title>
</head>
<!-- American format mm/dd/yyyy -->
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/calendar/calendar2.js"></script><!-- Date only with year scrolling -->
<body style="font-size: 8pt">
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<input type="hidden" name="OP" value="<%=ADDparamToPass%>">
<input type="hidden" name="EDIT_FILTER_ID" value="<%=EDITparamToPass%>">
<input type="hidden" name="forward" value="">
<input type="hidden" name="filterSetId" value="<%=cusSet.id%>">

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">

  <tr>
    <td width="100%" height="100%" valign="top">
    	<table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      		<tr>
        		<td valign="top" height="84%">
        			<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          			<tr>
            				<td width="100%">
            					<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              					<tr>
                				  <td width="3%" class="TOPLEFTBORDER"></td>
                				  <td width="50%" class="TOPBORDER"><span class="PAGEHEADER">Global Filter definition</span></td>
                				  <td width="47%" class="TOPRIGHTBORDER"></td>
              					</tr>
              					<tr>
                				  <td width="100%" colspan="3">
                                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td width="100%">
                        								<table border="0">
												                  <tr>
												                    <td colspan="3" height="18"><span class="HEADER" style="vertical-align:middle">General</span></td>
												                  </tr>
		                                      <tr>
		                                        <td width="150"><span class="REGULARTEXT">Name</span></td>
		                                        <td><input class="REGULARTEXT" type="text" name="filterName" size="30" value="<%=filterName%>"></td>
		                                        <td>&nbsp;</td>
		                                      </tr>
		                                       <tr>
		                                        <td width="150"><span class="REGULARTEXT">Description</span></td>
		                                        <td><input class="REGULARTEXT" type="text" name="filterDesc" size="75" value="<%=filterDesc%>"></td>
		                                        <td>&nbsp;</td>
		                                      </tr>
												         					<%if(lbm != null){%>
                        									<tr>
                          									<td width="150"><span class="REGULARTEXT">Log </span></td>
                          									<td width="33%">
                          										<select size="1" name="logbrowser" id="logbrowser" style="height:20" onchange="javascript:reloadScr()">
										                           	<option  class="TEXTBOX" value="0">--- select log ---</option>
																								<%
										                          		String lid = lbm != null ? lbm.getId() : null;
										                           		for(int i=0;lbarr != null && i<lbarr.length;++i){
										                           			String sel = lid != null && lid.equals(lbarr[i].getId()) ? "selected" : "";
										                          	%>
										                             	<option  class="TEXTBOX" value="<%=lbarr[i].getId()%>" <%=sel%>><%=lbarr[i].getName()%></option>
											                         	<%
										                            	}
										                          	%>
									
										                         	</select>
										                         </td>
										                         <td width="*">&nbsp;</td>
										                        </tr>
										                        
										                        <tr>
	                          									<td width="150"><span class="REGULARTEXT">Filter </span></td>
	                          									<td width="33%">
	                          										<%if(flist != null && flist.size() > 0){%>
	                          										<select size="1" name="logfilter" id="logfilter" style="height:20" onchange="javascript:reloadScrFilter()">
																								<%
									                           		for(int i=0;i<flist.size();++i){
									                           			FilterCollection ftc = (FilterCollection)flist.get(i);
									                           			String sel = "";
									                           			if(filterId != null || i==0){
									                           				sel = filterId.equals(ftc.getId()) ? "selected" : "";
									                           			}
										                          	%>
										                             	<option  class="TEXTBOX" value="<%=ftc.getId()%>" <%=sel%>><%=ftc.getName()%></option>
											                         	<%
									                            	}
										                          	%>
										
											                         	</select>
											                         	<%}else{%><span class="SMALLTEXT">(N/A)</span><%}%>
											                        </td>
											                        <td width="*">&nbsp;</td>
											                      </tr>
									                        <%}%>
										                      </table>
																				</td>
                                      </tr>
                                      <tr>
                                        <td width="100%">&nbsp;</td>
                                      </tr>
                                      <tr>
                                        <td width="100%">
                                          <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                          <%
                                            if(priorities != null){
                                          %>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER">Priorities</span></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="../../sandf/priorityFilter.jsp"%></td>
                                            </tr>
                                           <%
                                           	 }
                                           %>

                                           <%
                                           	 if(dateMaskExsit){
                                           %>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER">Date and Time</span></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="../../sandf/dateFilter.jsp"%></td>
                                            </tr>
                                           <%
                                           	 }
                                           %>
                                            <%
                                           	 if(choiceMaskExsit){
                                                  String colName = "";
                                                  String[] allChoice = null;
                                                  ChoiceMask chmask = null;
                                                  ChoiceFilter chFilter = null;
                                                  List fsele = null;

                                                  for(int t=0;t<choiceList.size();++t){
                                                    chmask = (ChoiceMask)choiceList.get(t);
                                                    colName = chmask.getName();
                                                    allChoice = chmask.getChoices();
                                                    chFilter = choice_filters[t];
                                                    fsele = null;
                                                    if(chFilter != null){
                                                      fsele = chFilter.getFilteredValues();
                                                    }
                                            %>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER"><%=colName%></span></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="../../sandf/choiceFilter.jsp"%></td>
                                            </tr>
                                            <%
                                              }//for
                                             }
                                            %>
                                            <%
                                           	 if(numberMaskExists){
                                            %>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER">Number</span></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="../../sandf/numberFilter.jsp"%></td>
                                            </tr>
                                            <%
                                             }
                                            %>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER">Text</span></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="../../sandf/stringFilter.jsp"%></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><input type="hidden" id="AllColumns" value="Columns"></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
																						<% 
																						HealthConfig [] healthConfigs = computeConf.getHealthConfigs();
																						if (healthConfigs != null && healthConfigs.length > 0){
																						%>
                                            <tr style="<%=displaySystemHealth ? "" : "display:none" %>">
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER">System Health</span></td>
                                            </tr>
                                            <%
                                            for(int j = 0; j < healthConfigs.length ; j++){
                                            	String type = healthConfigs[j].getType();
                                            	FilterComputationDefUnit defUnit = fc == null ? null : fc.getDefUnit(type);
                                            	
                                            %>
                                            <tr style="padding-top:5" style="<%=displaySystemHealth ? "" : "display:none" %>">
                                              <td width="20">&nbsp;</td>
                                              <td width="98%">
                                              <table brder="0" cellspacing="0" cellpadding="0">
                                              <tr>
																								<td nowrap width="150"><span class="REGULARTEXT"><%=healthConfigs[j].getName()%> Weight: &nbsp;</span></td>
																								<td width="20">
																								<select name="healthWeight<%=type%>">
																								<option value="-1">None</option>
																								<%
																								for (int i = 1; i <= 10;i++){
																								%>
																								<option value="<%=String.valueOf(i)%>" <%=(defUnit != null && defUnit.getWeight() == i ?"selected" : "")%>><%=String.valueOf(i)%></option>
																								<%
																								}
																								%>
																								
																								</select>
																								</td>
																								<td width="20"><span class="REGULARTEXT"><nobr>&nbsp;if there are&nbsp;</nobr></span></td>
																								<td nowrap>
																									<span class="REGULARTEXT">
																									<select name="healthAmountType<%=type%>">
																										<option value="1" <%=(defUnit != null && defUnit.getAmountType() == 1 ? "selected" : "")%>>More Than</option>
																										<option value="2" <%=(defUnit != null && defUnit.getAmountType() == 2 ? "selected" : "")%>>Less Than</option>
																										<option value="3" <%=(defUnit != null && defUnit.getAmountType() == 3 ? "selected" : "")%>>Equals</option>
																										<option value="4" <%=(defUnit != null && defUnit.getAmountType() == 4 ? "selected" : "")%>>Not Equals</option>
																									</select>
																									</span>
																								</td>
																								<td width="10"></td>
																								<td width="10">
																									<input type="text" name="healthAmount<%=type%>" value="<%=(defUnit == null ? "0" : String.valueOf(defUnit.getAmount()))%>" size="4">
																								</td>		
																								<td width="20" ><span class="REGULARTEXT"><nobr>&nbsp;records in a time frame of 5 minutes. </nobr></span></td>	
																							</tr>
                                              </table>
                                              </td>
                                            </tr>
																							<%} %>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                         <%
                                         }
                                         %>
                                         

																					</table>
                                        </td>
                                      </tr>
                                      <tr>
                                        <td width="100%">
                                          <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                            <tr>
                                              <td width="33%">&nbsp;</td>
                                              <td width="33%">
                                                <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                                  <tr>
                                                    <td width="33%"><a href="javascript:doApply()" class="LINK">save</a></td>
                                                    <td width="33%"><a href="globalFilters.jsp" class="LINK">cancel</a></td>
                                                    <td width="34%"><a href="javascript:openHelp('<%=BASE_DIRECTORY%>','Filter.htm')" class="LINK">help</a></td>
                                                  </tr>
                                                </table>
                                              </td>
                                              <td width="34%">&nbsp;</td>
                                            </tr>
                                          </table>
                                        </td>
                                      </tr>
                                    </table>
                                  </td>
              					</tr>
              					<tr>
                				  <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                				  <td width="50%" class="TOPBORDER"></td>
                				  <td width="47%" class="TOPRIGHTBORDER">&nbsp;</td>
              					</tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
    </table>
</form>
<%
  if(dateMaskExsit){
%>
<script language="JavaScript">
		<!-- // create calendar object(s) just after form tag closed
			 // note: you can have as many calendar objects as you need for your application
			var cal7 = new calendar2("<%=BASE_DIRECTORY%>",document.access.<%=DATE_MINIMUM%>,null,<%="/^\\-?\\d+(\\"+millisecondsSeperator+"\\d+)*$/"%>,"<%=millisecondsSeperator%>");
			cal7.year_scroll = true;
			cal7.time_comp = true;
			var cal8 = new calendar2("<%=BASE_DIRECTORY%>",document.access.<%=DATE_MAXIMUM%>,null,<%="/^\\-?\\d+(\\"+millisecondsSeperator+"\\d+)*$/"%>,"<%=millisecondsSeperator%>");
			cal8.year_scroll = true;
			cal8.time_comp = true;

			function openCal7(){
				document.access.<%=DATE_MIN_FILTER_ACTIVE%>.checked='true';
				cal7.popup();
			}
			function openCal8(){
				document.access.<%=DATE_MAX_FILTER_ACTIVE%>.checked='true';
				cal8.popup();
			}


		//-->
		</script>
<%
  }
%>
</table>
</body>
</html>