<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.admin.global.filters.*"%>
<%@ page import="xpolog.eye.computation.conf.HealthConfig"%>
<%@ page import="xpolog.eye.computation.impl.FilterComputationDefUnit"%>
<%@ page import="xpolog.eye.computation.conf.ComputationConfiguration"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
  boolean showHealth = Configuration.getInstance().getPropertiesManager().getProperty("log.filter.showHealthSettings","false").equals("true");
%>

<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.ConfigurationPermissions.GLOBAL_FILTERS_PERMISSION,true)){
    return;
  }
  
  //constants
  String EDIT_FILTER_ID = "EDIT_FILTER_ID";
  String OP = "OP";
  String ADD = "ADD";
  String LOG_ID = "LOG_ID";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_NAME = "LOG_NAME";
  String ERROR_OBJ = "ERROR_OBJ";
  String DATE_FILTER = "DateFilter";
  String MULTI_FILTER = "MultiFilter";
  String FILTER_COL_IDS = "FilterCollectionIds";
  String SET_ID = "ID";
  String NEGATE = "Negate";

  //page data
  LogBrowsingManager lbm = null;
  String logname    = "";
  FilterManager fman = null;

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  String fsetId = request.getParameter(SET_ID);
  GlobalFilters glm = GlobalFilters.getInstance();
  FilterSet fSet = null;
  FilterCollection fc = null;
  String filterId = fsetId;

  
  if(fsetId != null){
    fSet = glm.getFilterSetById(fsetId);
  	fman = fSet.filterMgr;
  	fc = (FilterCollection)fman.getFilterCollections().get(0);
  	//this is here because the filterset fm dont search in the global filters
  	fman = new FilterManager();
  }else{
 	fSet = new FilterSet();
 	fSet.name = "new filter";
 	fSet.description = "";
 	fSet.id = "";
 	fman = new FilterManager();
 	fSet.filterMgr = fman;
  }
  
  int numFilterc = glm.getSortedFilterList().size();
  
  String filterName = "GenMultiFilterName_" + String.valueOf(numFilterc);
  String paramToPass = "";
  
  filterName = fSet.name;
  String filterDesc= fSet.description;
  

  
  String op = request.getParameter(ADD);
  List filters = null;
  if(fc != null){
    filters = fc.getByName(MULTI_FILTER);
  }else{
    filters = new ArrayList();
  }

  MultiFilter multiFilter = null;
  List filterCollectionIds = null;
  
  List allcol = glm.getSortedFilterList();

  String negateStr = request.getParameter(NEGATE);
  boolean negate = (negateStr != null && negateStr.equals("true"));
  
  if(!negate && allcol.size() < 2){
    ErrorModel erm = new ErrorModel();
    erm.addError("There must be at least two exsiting filters in order to create a Multi Filter.");
    request.getSession().setAttribute(ERROR_OBJ,erm);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }
  
  
  ArrayList fcl = new ArrayList();
  for(int i=0;i<allcol.size();i++){
  	FilterSet fstmp = (FilterSet)allcol.get(i);
  	List filterList = fstmp.filterMgr.getFilterCollections();
  	fcl.addAll(filterList);
  }
  if (fc != null){
  	fcl.remove(fc);
  }
  //the list of filter collection from the filter set.
  allcol = fcl;
  
  if(filters != null && filters.size()>0){
    multiFilter = (MultiFilter)filters.get(0);
    filterCollectionIds = multiFilter.getFilterCollectionList();
  }else{
    multiFilter = new MultiFilter(fman);
    filterCollectionIds = new ArrayList();
  }
  negate = negate || (multiFilter != null && multiFilter.isNegateFilter());

  String orselected="",andselected="";
  if(multiFilter.isBooleanOpOR()){
    orselected = "selected";
  }else{
    andselected = "selected";
  }

  //UserSecurity security = WebSecurityManager.getInstance().getUserSecurity(request);
  //boolean isEditable = security == null || security.isModuleMemberEditable(lbm.getId());

  ComputationConfiguration computeConf = ComputationConfiguration.getInstance();
  boolean displaySystemHealth = showHealth;
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
  function doApply(){
    //path = "multiFilterAction.jsp?";
    for(var i=0;i<document.access.ToUse.options.length;i++){
      document.access.ToUse.options[i].selected = true;
      //path = path + "<%=FILTER_COL_IDS%>" + "=" + val;
      //path = path +"&";
      
    }
    var filterName = document.access.filterName.value;
    var re1 = new RegExp("[&]", 'gi');
  	filterName = filterName.replace(re1,"%26");
  	document.access.filterName.value = filterName;
    //path = path + "filterName=" + filterName;
    
    //path = path + "<%=paramToPass%>";
    //path = path +"&LogicalOp=" + document.access.LogicalOp.options[document.access.LogicalOp.selectedIndex].value;
    <%if (negate){%>
    //path = path +"&Negate=" + (document.access.Negate.checked ? "true" : "false");
    <%}%>
    //document.location = path;
    document.access.submit();
  }

  function trim(a){
      while(''+a.charAt(a.length-1)==' '){
       a=a.substring(0,a.length-1);
      }
      return a;
  }


</script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>

<title></title>
</head>
<body style="font-size: 8pt">
<form AUTOCOMPLETE="OFF" id="access" name="access" action="globalMultiFilterAction.jsp">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%" height="100%" valign="top">
    	<table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      		<tr>
        		<td valign="top" height="84%">
        			<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          			<tr>
            				<td width="100%">
            					<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              					<tr>
                				  <td width="3%" class="TOPLEFTBORDER"></td>
                				  <td width="50%" class="TOPBORDER"><span class="PAGEHEADER">Global Multi Filter</span></td>
                				  <td width="47%" class="TOPRIGHTBORDER"></td>
              					</tr>
              					<tr>
                				  <td width="100%" colspan="3">
                                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td width="100%"><font size="1">&nbsp;</font></td>
                                      </tr>
                                      <tr>
                                        <td width="100%"><span class="HEADER">Name </span><input class="TEXTBOX" type="text" name="filterName" size="30" value="<%=filterName%>"></td>
                                      </tr>
                                      <tr>
                                        <td width="100%"><span class="HEADER">Description </span><input class="TEXTBOX" type="text" name="filterDesc" size="30" value="<%=filterDesc%>"></td>
                                      </tr>
                                      <tr>
                                        <td width="100%"><input class="TEXTBOX" type="hidden" name="filterSetId" id="filterSetId" size="30" value="<%=fSet.id%>"></td>
                                      </tr>
                                      <tr>
                                        <td width="100%">
                                          <table border="0" width="100%" cellspacing="0" cellpadding="0">

                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER">Filters</span></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="../../sandf/filterSelect.jsp"%></td>
                                            </tr>
					    															<tr>
                                              <td width="20" class="REGULARTEXT">&nbsp;</td>
                                              <td width="98%" class="REGULARTEXT">&nbsp;</td>
                                            </tr>
                                            <tr>
                                              <td width="20"></td>
                                              <td width="98%"><span class="REGULARTEXT">Logical operation between filters</span>
                                                <select class="TEXTBOX" size="1" name="LogicalOp">
                                                  <option <%=orselected%> value="OR">OR</option>
                                                  <option <%=andselected%> value="AND">AND</option>
                                                </select></td>
                                            </tr>
                                            <%if (negate){ %>
																				    <tr>
                                              <td width="20" class="REGULARTEXT">&nbsp;</td>
                                              <td width="98%" class="REGULARTEXT">&nbsp;</td>
                                            </tr>
                                            <tr>
                                              <td width="20"></td>
                                              <td width="98%"><input type="checkbox" name="Negate" value="true" checked><span class="REGULARTEXT"> negate filter</span>
                                              </td>
                                            </tr>
																				    <tr>
                                              <td width="20" class="REGULARTEXT">&nbsp;</td>
                                              <td width="98%" class="SMALLTEXT">Click this option in order to negate the result of the filter (e.g. (A AND B) => (NOT A OR NOT B))</td>
                                            </tr>
                                            <%}%>
                                            <% 
		                                        HealthConfig [] healthConfigs = computeConf.getHealthConfigs();
		                                        if (healthConfigs != null && healthConfigs.length > 0){
		                                        %>
                                            <tr style="<%=displaySystemHealth ? "" : "display:none" %>">
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER">System Health</span></td>
                                            </tr>
                                            <%
                                            for(int j = 0; j < healthConfigs.length ; j++){
                                            	String type = healthConfigs[j].getType();
                                            	FilterComputationDefUnit defUnit = fc == null ? null : fc.getDefUnit(type);
                                            	
                                            %>
                                            <tr style="padding-top:5" style="<%=displaySystemHealth ? "" : "display:none" %>">
                                              <td width="20">&nbsp;</td>
                                              <td width="98%">
                                              <table brder="0" cellspacing="0" cellpadding="0">
                                              <tr>
																								<td nowrap width="150"><span class="REGULARTEXT"><%=healthConfigs[j].getName()%> Weight: &nbsp;</span></td>
																								<td width="20">
																								<select name="healthWeight<%=type%>">
																								<option value="-1">None</option>
																								<%
																								for (int i = 1; i <= 10;i++){
																								%>
																								<option value="<%=String.valueOf(i)%>" <%=(defUnit != null && defUnit.getWeight() == i ?"selected" : "")%>><%=String.valueOf(i)%></option>
																								<%
																								}
																								%>
																								
																								</select>
																								</td>
																								<td width="20"><span class="REGULARTEXT"><nobr>&nbsp;if there are&nbsp;</nobr></span></td>
																								<td nowrap>
																									<span class="REGULARTEXT">
																									<select name="healthAmountType<%=type%>">
																										<option value="1" <%=(defUnit != null && defUnit.getAmountType() == 1 ? "selected" : "")%>>More Than</option>
																										<option value="2" <%=(defUnit != null && defUnit.getAmountType() == 2 ? "selected" : "")%>>Less Than</option>
																										<option value="3" <%=(defUnit != null && defUnit.getAmountType() == 3 ? "selected" : "")%>>Equals</option>
																										<option value="4" <%=(defUnit != null && defUnit.getAmountType() == 4 ? "selected" : "")%>>Not Equals</option>
																									</select>
																									</span>
																								</td>
																								<td width="10"></td>
																								<td width="10">
																									<input type="text" name="healthAmount<%=type%>" value="<%=(defUnit == null ? "0" : String.valueOf(defUnit.getAmount()))%>" size="4">
																								</td>		
																								<td width="20" ><span class="REGULARTEXT"><nobr>&nbsp;records in a time frame of 5 minutes. </nobr></span></td>	
																							</tr>
                                              </table>
                                              </td>
                                            </tr>
																							<%}%>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                         <%
                                         }
                                         %>
                                          </table>
                                        </td>
                                      </tr>
                                      <tr>
                                        <td width="100%">
                                          <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                            <tr>
                                              <td width="33%">&nbsp;</td>
                                              <td width="33%">
                                                <table border="0" width="100%" cellspacing="0" cellpadding="0">
																								  <tr>&nbsp;</tr>
																								  <tr>&nbsp;</tr>
																								  <tr>&nbsp;</tr>
																								  <tr>&nbsp;</tr>
                                                  <tr>
                                                    <td width="33%"><a href="javascript:doApply()" class="LINK">save</a></td>
                                                    <td width="33%"><a href="javascript:history.go(-1)" class="LINK">cancel</a></td>
                                                    <td width="34%"><a href="javascript:openHelp('<%=BASE_DIRECTORY%>','Filter.htm')" class="LINK">help</a></td>
                                                  </tr>
                                                </table>
                                              </td>
                                              <td width="34%">&nbsp;</td>
                                            </tr>
                                          </table>
                                        </td>
                                      </tr>
                                    </table>
                                  </td>
              					</tr>
              					<tr>
                				  <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                				  <td width="50%" class="TOPBORDER"></td>
                				  <td width="47%" class="TOPRIGHTBORDER">&nbsp;</td>
              					</tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
    </table>
</form>
</table>
</body>

