<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%

WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request,response,null,true)){
	return;
}

UserContext user = UserEnvironment.getUserContext(request);
if (user != null && user.getUser() != null && !user.getUser().isAdmin()){
	response.sendRedirect(BASE_DIRECTORY + "security/common/accessDenied.jsp");
	return;
}

  String ARCHIVE_PATH = "archivePath";
  String ERROR_OBJ = "ERROR_OBJ";
  String CURRENT_LOG = "CURRENT_LOG";
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  String arch_file  = request.getParameter(ARCHIVE_PATH);

  //verify data
  ErrorModel errmodel = new ErrorModel();
  if(arch_file == null || arch_file.trim().equals("")){
    errmodel.addError("No archive file was supplied.");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }

  //here we will use xpolog builder for import -
  LogBrowsingManager lbm = null;
  arch_file = arch_file.replaceAll("\\\\\\\\","/");
  arch_file = arch_file.replaceAll("\\\\","/");
  File arch = new File(arch_file);
  try{
   ImportFlow iml = new ImportFlow();
   File f = new File(arch_file).getCanonicalFile();
   if (!f.exists()){
     arch = UploadHelper.uploadFile(request,arch);
   }else {
  	 arch = f;
   }
   iml.setFile(arch);
   iml.executeGeneralImport(true,false);   
 
  }catch(Exception e){
    e.printStackTrace();
    ErrorModel errmod = new ErrorModel();
    errmod.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,errmod);
    response.sendRedirect("errorpage.jsp");
    return;
  }

  response.sendRedirect(BASE_DIRECTORY + "root.jsp");
%>


