<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%

  String ARCHIVE_PATH = "archivePath";
  String ERROR_OBJ = "ERROR_OBJ";
  String IMPORT_FLOW = "IMPORT_FLOW";

  String arch_file  = request.getParameter(ARCHIVE_PATH);
  
  //verify data
  ErrorModel errmodel = new ErrorModel();
  if(arch_file == null || arch_file.trim().equals("")){
    errmodel.addError("No archive file was supplied.");
  }
  String PARENT_MODULE = "ParentModule";
  String modid  = request.getParameter(PARENT_MODULE);

  if(errmodel.getErrorCount() > 0){
  	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("../errorpage.jsp");
    return;
  }

  //here we will use xpolog builder for import -
  File arch = new File(arch_file);
  try{
   ImportFlow iml = new ImportFlow();
   arch = UploadHelper.uploadFile(request,arch);
   iml.setFile(arch);
   request.getSession().setAttribute(IMPORT_FLOW,iml);
  }catch(Exception e){
    ErrorModel errmod = new ErrorModel();
    errmod.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,errmod);
    response.sendRedirect("../errorpage.jsp");
    return;
  }
  if (modid == null || modid.length() == 0){
    response.sendRedirect("importModList.jsp");
  }else {
    response.sendRedirect("importModListAction.jsp?" + PARENT_MODULE + "=" + modid);
  }
%>


