<%@page import="xpolog.eye.audit.AuditConstants"%>
<%@page import="xpolog.eye.audit.AuditManager"%>
<%@page import="xpolog.eye.issuetracking.ui.DefaultIssueUpdateHandler"%>
<%@page import="xpolog.eye.issuetracking.ui.IssueTrackingUIElement"%>
<%@page import="java.util.HashMap"%>
<%@page import="java.util.List"%>
<%@page import="xpolog.eye.issuetracking.util.IssueTrackingClientActionRequest"%>
<%@page import="java.util.Enumeration"%>
<%@page import="xpolog.eye.issuetracking.util.IssueTrackingClientActionResult"%>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@page import="xpolog.eye.issuetracking.*"%>
<%@page import="xpolog.eye.site.*"%>
<%
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);


	String action = request.getParameter("action");
	if (action == null || action.length() == 0){
		action = "update";
	}

	boolean success = false;
	String message = "";
	String params = null;
	
	IssueTracking tracker = env.getIssueTracking();
	List l = null;
	if (tracker != null){
		IssueTrackingManager issueTrackingManager = IssueTrackingManager.getInstance();
		if(tracker != null && issueTrackingManager.getIssueTrackingById(tracker.getId()) == null) {
			tracker.dispose();
			env.setIssueTracking(null);
			message = "No bug tracking system was supplied";
		}else {
			HashMap map = new HashMap();
			l = tracker.getClient().getCurrentActionElements();
			if (l != null){
				for (int i = 0; i < l.size();i++){
					IssueTrackingUIElement uiElement = (IssueTrackingUIElement) l.get(i);
					map.put(uiElement.getKey(),uiElement);
				}
			}
			
			Enumeration e = request.getParameterNames();
			for (;e.hasMoreElements();){
				String key = (String)e.nextElement();
				if (key.startsWith("issue")){
				  String value = request.getParameter(key);
				  key = key.substring(5);
				  IssueTrackingUIElement uiElement = (IssueTrackingUIElement)map.get(key);
				  if (uiElement != null){
				  	uiElement.setValue(value);
				  //	System.out.println("set ui element " + key + " with value " + value);
				  }
				}
			}
			DefaultIssueUpdateHandler handler = (DefaultIssueUpdateHandler)env.getGlobalAttribute("issueTrackingHandler");
			if (handler != null){
				String doAttachStr = request.getParameter("doAttach");
				boolean doAttach = doAttachStr != null && doAttachStr.equals("true");
				handler.setAddDataAsAttachments(doAttach);
				
				String includeDataInDescStr = request.getParameter("includeDataInDesc");
				boolean includeDataInDesc = includeDataInDescStr != null && includeDataInDescStr.equals("true");
				handler.setAddDataToDescription(includeDataInDesc);
			}
			success = true;
			
			if (success && action != null && action.equals("save")){
			
				if (handler != null){
					handler.addIssue(tracker);
					IssueTrackingClientActionResult r = handler.getResult();
					if(r == null) {
						success = false;
						message = "An error occured, please try again";
					}else {
						success = r.isSuccessful();
						if (!success){
							String [] errors = r.getErrorModel().getErrors();
							for (int i = 0; i < errors.length;i++){
								if (i > 0){
									message+= "<br>";
								}
								message += errors[i];
							}
						}else {
							String key = r.getIssueKey();
							
							UserContext userContext = UserEnvironment.getUserContext(request);
							AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
					  			userContext, AuditConstants.CHANGE, "add/edit issue", AuditConstants.ISSUE_TRACKING, "new issue was created in " + tracker.getName() + " (" + key + ")");
							
		
							if (key != null & key.length() > 0){
								message = "Bug " + key + " was created";
							}else {
							  message = "Bug was created successfully";
							}
							String gotoUrl = r.getGotoURL();
							if (gotoUrl != null && gotoUrl.length() > 0){
								params = gotoUrl;
							}
						}
					}
				}else {
					success = false;
					message = "No action handler was supplied";
				}
			}else if (success && l != null && tracker != null){
				IssueTrackingClientActionRequest req = new IssueTrackingClientActionRequest();
				req.setActionType(IssueTrackingClient.ACTION_TYPE_REFRESH_VIEW);
				
				IssueTrackingClientActionResult r =  tracker.getClient().getActionElements(req);
				success = r.isSuccessful();
				if (!success){				
					String [] errors = r.getErrorModel().getErrors();
					for (int i = 0; i < errors.length;i++){
						if (i > 0){
							message+= "<br>";
						}
						message += errors[i];
					}
				}else {
				  l = r.getActionElements();		  
			  }
				env.setTempAttribute("IssueTrackingElements",l);
			}
		}
	}else {
		message = "No bug tracking system was supplied";
	}

   
	
	
	String xml = GridModelActionsHelper.getResultXML(success,message,params);
  response.setContentType("text/xml");
  response.setHeader("Pragma-Control", "no-cache");
  response.setHeader("Cache-Control", "no-cache");
  response.setHeader("Expires", "0");

	
  out.write(xml);
	out.flush();
%>