<%@page import="xpolog.eye.security.WebSecurityManager"%>
<%@page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@page import="xpolog.eye.issuetracking.ui.DefaultIssueUpdateHandler"%>
<%@page import="xpolog.eye.issuetracking.ui.IssueTrackingUIElement"%>
<%@page import="java.util.List"%>
<%@page import="xpolog.eye.issuetracking.util.*"%>
<%@page import="xpolog.eye.issuetracking.*"%>
<%@page import="xpolog.eye.site.*"%>
<%

	UserEnvironment env = UserEnvironment.getUserEnvironment(request);


	String id = request.getParameter("ISSUE_TRACKING_ID");
  String xml = "";
  IssueTracking tracker = env.getIssueTracking();
  IssueTrackingManager issueTrackingManager = IssueTrackingManager.getInstance();
	if(tracker != null && issueTrackingManager.getIssueTrackingById(tracker.getId()) == null) {
		tracker.dispose();
		env.setIssueTracking(null);
		tracker = null;
	}
	if (tracker == null || (id != null && id.length() > 0 && !id.equals(tracker.getId()))){
		  if (tracker != null && (id == null || !id.equals("NEW"))){
		  	tracker.dispose();
		  }
		  if (id != null && id.length() > 0){
		  	tracker = issueTrackingManager.getIssueTrackingById(id);
		  }
		  if (tracker == null){
			  IssueTrackingManager mgr = issueTrackingManager;
			  IssueTracking [] trackers = mgr.getIssueTrackingList();
			  if (trackers != null && trackers.length > 0){
			  	if (trackers.length == 1){
				    tracker = trackers[0];
				    env.setIssueTracking(tracker);
			  	}else {
			  		String heightStr = String.valueOf(150 + 30*trackers.length) + "px";
			  		xml = SiteUtil.getGeneralAdminResultXML("issueTrackerType","baseDirectory=&title=Select a bug tracking system","common/generalAdminFrm.jsp?id=selectIssueTrackingFrm&src=tools/issuetracking/listOfIssueTrackingFrm.jsp", "450px",heightStr);  		
			  	}
			  }else {
			  	if(WebSecurityManager.getInstance().isHavePermission(UserEnvironment.getUserContext(request),ActionsPermissionConstants.IssueTraqckingPermissions.ISSUE_TRACKING_SETTINGS_PERMISSION)) {
			  		IssueTracking [] trackersTemplates = issueTrackingManager.getIssueTrackingTemplates();
					  String heightStr = String.valueOf(150 + 30*trackersTemplates.length) + "px";
					  xml = SiteUtil.getGeneralAdminResultXML("issueTrackerType","baseDirectory=&title=Select the type of bug tracking system to add","common/generalAdminFrm.jsp?id=issueLoginFrm&src=tools/issuetracking/listOfIssueTrackingTemplatesFrm.jsp", "450px",heightStr);
			  	}else {
			  		xml = SiteUtil.getGeneralMessageResultXML("issueTrackerError", "Open Bug Error", "No bug tracking system found", "OK", "javascript:closeMsgWriter('issueTrackerError')");
			  	}
			  }
		  }else {
		  	env.setIssueTracking(tracker);
		  }
	}

	if (tracker != null && !tracker.isConnected()){
		if (tracker.isLoginNeeded()){
			String title = tracker.getName() + " Login";
		  xml = SiteUtil.getGeneralAdminResultXML("addIssueLogin","baseDirectory=&title=" + title,"common/generalAdminFrm.jsp?id=issueLoginFrm&src=tools/issuetracking/issueLoginInnerFrm.jsp", "400px","220px");
		}else {
			tracker.getClient().init();
			tracker.getClient().login();
		}
	}
	
	DefaultIssueUpdateHandler handler = (DefaultIssueUpdateHandler)env.getGlobalAttribute("issueTrackingHandler");
	if (tracker != null && tracker.isConnected()){
		IssueTrackingClientActionRequest req = new IssueTrackingClientActionRequest();
		req.setActionType(IssueTrackingClient.ACTION_TYPE_CREATE_ISSUE);
		
		IssueTrackingClientActionResult result =  tracker.getClient().getActionElements(req);
		
		List list = result.getActionElements();
		int height = 120;
		for (int i = 0; list != null && i < list.size(); i++) {
			IssueTrackingUIElement uiElement = (IssueTrackingUIElement) list.get(i);
			height += 30;
			if (uiElement.getType().equals(IssueTrackingUIElement.TYPE_TEXT_AREA)){
				height += 50;
			}
			
			if (uiElement.getKey().equals("description") && handler != null && handler.getDescriptionTemplate() != null & handler.getDescriptionTemplate().length() > 0){
				uiElement.setValue(handler.getDescriptionTemplate());
			}
		}
		
		if (list != null & list.size() > 0){			
			if (handler != null){
				if (handler.isAtachmentsEnabled()){
					height += 15;
				}
				
				if (handler.isAddDataAsAttachments()){
					height += 15;
				}
			}
		}
		env.setTempAttribute("IssueTrackingElements",list);
		xml = SiteUtil.getGeneralAdminResultXML("addIssue","baseDirectory=&title=Open a bug in " + tracker.getName(),"common/generalAdminFrm.jsp?id=addIssueFrm&src=tools/issuetracking/addIssueInnerFrm.jsp", "600px",height + "px");
	}
  

  response.setContentType("text/xml");
  response.setHeader("Pragma-Control", "no-cache");
  response.setHeader("Cache-Control", "no-cache");
  response.setHeader("Expires", "0");

	
  out.write(xml);
	out.flush();

%>