<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.issuetracking.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION,true)){
  return;
}
UserContext userContext = UserEnvironment.getUserContext(request);

boolean isEdit = manager.isHavePermission(userContext,ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION);



String lastSelectedRow = (String)request.getSession().getAttribute("lastSelectedIssueTracker");
if (lastSelectedRow == null){
	lastSelectedRow = "";
}


String refreshMenusStr = request.getParameter("refreshMenus");
boolean refreshMenus = refreshMenusStr != null && refreshMenusStr.equals("true");

String openIssueTrackerTypeStr = request.getParameter("openIssueTrackerType");
boolean openIssueTrackerType = openIssueTrackerTypeStr != null && openIssueTrackerTypeStr.equals("true");

IssueTracking [] trackersTemplates = IssueTrackingManager.getInstance().getIssueTrackingTemplates();
boolean isJavaValid = IssueTrackingManager.getInstance().isTemplatesValid();

%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>

<script>
<%
if(refreshMenus) {
%>
refreshMenus();
<%
}
%>
</script>

<jsp:include page="../../widgets/grid/jsp/gridHeaderIncluder.jsp" flush="true" >
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<%
boolean showMenu = isEdit;
if(showMenu) {
	String menuIds = "verifyIssueTracker,editIssueTracker,removeIssueTracker";
	String menuTexts = "Verify,Edit,Delete";
	String menuHrefs = "javascript:verifyIssueTracker0();,javascript:editIssueTracker0();,javascript:removeIssueTracker0();";
%>
<jsp:include page="../../widgets/menu/jsp/menuHeaderIncluder.jsp" flush="true">
		  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
		</jsp:include>
	<jsp:include page="../../widgets/menu/jsp/menuIncluder.jsp" flush="true">
	  <jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
	  <jsp:param name="showMenu" value="<%=showMenu%>" />
	  <jsp:param name="menuIds" value="<%=menuIds%>" />
	  <jsp:param name="menuTexts" value="<%=menuTexts%>" />
	  <jsp:param name="menuHrefs" value="<%=menuHrefs%>" />
	</jsp:include>
<%
}
%>

<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";  
	
	function init() {
		<%
		if(openIssueTrackerType) {
		%>
			goNew();
		<%
		}
		%>
	}
	
  function goNew(){
    var issueTrackerTypeErrorMsgElement = document.getElementById("issueTrackerTypeErrorMsg");
 		if(issueTrackerTypeErrorMsgElement) { 			
			issueTrackerTypeErrorMsgElement.innerHTML = "&nbsp;";			
 		}
  	showGeneralAdminDiv("issueTrackerType", -1, 100);
  }
  
  function goNewIssueTracker() {
  	var issueTrackerTypeErrorMsgElement = document.getElementById("issueTrackerTypeErrorMsg");
 		if(issueTrackerTypeErrorMsgElement) { 			
			issueTrackerTypeErrorMsgElement.innerHTML = "&nbsp;";
			
 		}
 		
	  var issueTrackerType = document.issueTrackerTypeForm.issueTrackerType;
	  var selectedURL = "";
	  if(issueTrackerType) {
		  for(var i = 0; i < issueTrackerType.length; i++) {
	  		if(issueTrackerType[i].checked) {
		      selectedURL = issueTrackerType[i].value;
	      }
	   	}
	  }

  	if(selectedURL == "") {
  		if(issueTrackerTypeErrorMsgElement) {  			
				issueTrackerTypeErrorMsgElement.innerHTML = "Bug tracking system type was not selected";
				return;
  		}
  	}
  
  	var path = "<%=BASE_DIRECTORY%>" + selectedURL;  	
  	document.location = path;  	  	
  }
  
  function closeIssueTrackerTypeDiv() {
		showHideGeneralAdminDiv("issueTrackerType");
	}
  
  function doEdit(){
    var issueTrackerId = getFirstSelectedRow(mygrid);
    if (issueTrackerId == "") {
     return;
    }
    doEdit1(issueTrackerId);
  }
  
  function doEdit1(issueTrackerId){
    path = "issueTrackingAction.jsp?ID=" + issueTrackerId;
  	document.location = path;
  }
  
  function doDelete(){
    var issueTrackerId = getFirstSelectedRow(mygrid);
    if (issueTrackerId == "") {
      return;
    }
    doDelete1(issueTrackerId);
  }
  
  function doDelete1(issueTrackerId){
    var name = mygrid.cells(issueTrackerId,0).getValue();
    var type = mygrid.cells(issueTrackerId,1).getValue();
    var row = issueTrackerId;
    var msgWriter = new messageWriter("mygridMessage","Bug Tracking System Delete Action","<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid"),50);
    msgWriter.addAction("Yes","javascript:hideLayer('mygridMessage');javascript:doDelete0('" + row + "','" +  issueTrackerId + "','" +  type + "')");
    msgWriter.addAction("No","javascript:hideLayer('mygridMessage')");  
    msgWriter.showMessage("<nobr>Are you sure you want to delete the bug tracking system </nobr>" + name + "?");
  }
  
  function doDelete0(row,id,type){
  	deleteGridRow(mygrid,row,baseDirectory + "tools/issuetracking/removeIssueTrackingAction.jsp?id=" + id + "&timestamp=" + new Date().getTime());
  	refreshMenus();
  }
  
  function doVerify() {
	  var issueTrackerId = getFirstSelectedRow(mygrid);
    if (issueTrackerId == "") {
      return;
    }
		doVerify1(issueTrackerId);
  }
  
  function doVerify1(issueTrackerId) {
	  var msgWriter = new messageWriter("verificationWaitMessage","Bug Tracking System Verification",baseDirectory);
		msgWriter.showMessage("Please wait...");
  	var page = baseDirectory + "tools/issuetracking/verifyIssueTracking.jsp?";
		var params = "id=" + issueTrackerId + "&isEmbeded=true";
		sendAjaxRequest(page,function(req){
			var result = req.responseText;	
			result = result.replace(/^\s+|\s+$/g, '') ;
			if(!result){
				alert("Cannot verify IssueTracking");
				return;			
			}
			var resultArr = result.split("@#");
			if(resultArr) {
				var resultType = resultArr[0];
				var resultMessage = resultArr[1];
				hideLayer('verificationWaitMessage');
				msgWriter = new messageWriter("verificationMessage","Bug Tracking System Verification",baseDirectory);
				msgWriter.addAction("OK","javascript:hideLayer('verificationMessage');");
				msg = resultMessage;
				if(resultType == "error") {
					msgWriter.setMsgClass("ERRORMESSAGE_LIGHT");
					msgWriter.setStyle("left");
					msg = "<ul>";
	    		var errs = resultMessage.split("*;*");
	    		for (var i=0; i<errs.length; i++){
	    			msg = msg + "<li>" + errs[i] + "</li>";
	      	}
	    		msg = msg + "</ul>"
				}
	    	msgWriter.showMessage(msg);
			}else {
				
			}
		},'POST',params);
  }
	
	function handleMenuItems(){
 		var isVerifiable = mygrid.getUserData(contextRowId,"isVerifiable");
    <% if (isEdit){%>
    	if(isVerifiable && isVerifiable == "true") {
    		aMenu.menu.showButtons("verifyIssueTracker");
    	}
	    aMenu.menu.showButtons("editIssueTracker,removeIssueTracker");
 		<%}else {%>
		  aMenu.menu.hideBar();
 		<%}%>
  }
  
  function verifyIssueTracker0(){
    if (contextRowId && contextRowId != ""){
      doVerify1(contextRowId);
    }
  }
  
  function editIssueTracker0(){
    if (contextRowId && contextRowId != ""){
      doEdit1(contextRowId);
    }
  }
  
  function removeIssueTracker0(){
    if (contextRowId && contextRowId != ""){
      doDelete1(contextRowId);
    }
  }

</script>
</head>

<%
String onLoadFunctions = "initTables();init()";
if(showMenu) {
	onLoadFunctions = "initMenus();" + onLoadFunctions;
}

String heightStr = String.valueOf(130 + 20*trackersTemplates.length) + "px";
%>
<body onLoad="<%=onLoadFunctions %>" onUnload="destroyTables()" style="margin:0;padding:0;overflow:auto;" >

<%if (isJavaValid){ %>
<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="title" value="Select the type of bug tracking system to add"/> 
	<jsp:param name="suffix" value="issueTrackerType"/> 
	<jsp:param name="width" value="450px"/> 
	<jsp:param name="height" value="<%=heightStr%>"/> 
	<jsp:param name="includePath" value="tools/issuetracking/listOfIssueTrackingTemplates.jsp"/> 
	<jsp:param name="actionsNames" value="Continue#Cancel"/> 
	<jsp:param name="actions" value="javascript:goNewIssueTracker()#javascript:closeIssueTrackerTypeDiv()"/> 
</jsp:include>

<%}else { %>
<jsp:include page="../../common/adminGeneralDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>"/> 
	<jsp:param name="title" value="Select the type of bug tracking system to add"/> 
	<jsp:param name="suffix" value="issueTrackerType"/> 
	<jsp:param name="width" value="450px"/> 
	<jsp:param name="height" value="<%=heightStr%>"/> 
	<jsp:param name="includePath" value="tools/issuetracking/listOfIssueTrackingTemplates.jsp"/> 
	<jsp:param name="actionsNames" value="Close"/> 
	<jsp:param name="actions" value="javascript:closeIssueTrackerTypeDiv()"/> 
</jsp:include>
<%} %>


<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td valign="top">
      <table border="0" cellpadding="0" cellspacing="0"  width="100%" height="100%" id="AutoNumber2">              
        <tr height="10">
          <td>
	          <jsp:include page="../../common/pageMainHeader.jsp" flush="true">
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="headerTitle" value="Bug Tracking Systems" />
						</jsp:include>		
         	</td>
        </tr>
        <tr>                
          <td valign="top"> 
	          <% 
	          String addName = isEdit ? "New Bug Tracking System" : "";
	          String addLink = isEdit ? "javascript:goNew()" : "";
	          
	          String tableNames = isEdit ? "Edit#Delete" : "";
	          String tableActions = isEdit ? "javascript:doEdit()#javascript:doDelete()" : "";
	          String ids = isEdit ? "Edit#Delete" : "";
	          String selectTypes = isEdit ? "2#2" : "";
	          
	          if (tableNames.length() > 0){
	        		tableNames += "*;*";
	        		tableActions += "*;*";
	        		ids += "*;*";
	        		selectTypes += "*;*";
	        	}             	
	         	tableNames += "Verify#";
	       		tableActions += "javascript:doVerify()#";
	       		ids += "Verify#";
	       		selectTypes += "2#";
	          
	       		String menu = showMenu ? "aMenu" : "";
	          
	          %>                               
						<jsp:include page="../../widgets/grid/jsp/gridTableIncluder.jsp" flush="true" >
							<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
							<jsp:param name="initXML" value="tools/issuetracking/issueTrackingViewXML.jsp" />
							<jsp:param name="menu" value="<%=menu%>"/>
							<jsp:param name="newActionNames" value="<%=addName%>" />
							<jsp:param name="newActions" value="<%=addLink%>" />
							<jsp:param name="tableActionNames" value="<%=tableNames%>" />
							<jsp:param name="tableActions" value="<%=tableActions%>" />
							<jsp:param name="tableActionIds" value="<%=ids%>" />
							<jsp:param name="tableActionSelectedType" value="<%=selectTypes%>" />
							<jsp:param name="recordsText" value="Bug Tracking Systems" />
							<jsp:param name="style" value="main" />
							<jsp:param name="doubleClickAction" value="doEdit" />
							<jsp:param name="lastSelectedRow" value="<%=lastSelectedRow%>" />
							<jsp:param name="showSelectedRowOnLoad" value="true" />
						</jsp:include>
        	</td>
      	</tr>      
    	</table>
    </td>
  </tr>
</table>



</body>

</html>