<%@ page language="java"%>

<%@ page import="xpolog.eye.issuetracking.*"%>
<%@ page import="xpolog.eye.audit.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
  UserContext userContext = UserEnvironment.getUserContext(request);

  String id = request.getParameter("id");
  
  IssueTrackingManager mgr = IssueTrackingManager.getInstance();
  boolean success = true;
	String message = "";
	if (id != null){
  	IssueTracking tracker = mgr.getIssueTrackingById(id);

  	if (tracker != null){
  		//audit
			AuditManager.getInstance().write(
					AuditConstants.BASIC_AUDIT_LEVEL, userContext,
					AuditConstants.CHANGE, "remove issue tracking",
					AuditConstants.ISSUE_TRACKING, "remove issue tracking " + tracker.getName());
  		try {
  			UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  			IssueTracking currTracker = env.getIssueTracking();
  			if (currTracker != null && currTracker.getId() != null && currTracker.getId().equals(id)){
  				currTracker.dispose();
  				env.setIssueTracking(null);
  			}
  			mgr.removeIssueTracking(id);
  			success = true;
  		}catch (Exception e){
  			ErrorModel.log.error("Failed to remove issue tracking " + tracker.getName()
					+ " with id " + tracker.getId(), e);
				success = false;
				message = e.getMessage();
  		}
  	
  	}else {
  		message = "No issue tracking was given, please refresh and try again";
  	}
  } else {
  	message = "No issue tracking was given, please refresh and try again";
  }
  String xml = GridModelActionsHelper.getResultXML(success, message);

  response.setContentType("text/xml");
  response.setHeader("Pragma-Control", "no-cache");
  response.setHeader("Cache-Control", "no-cache");
  response.setHeader("Expires", "0");
  
  	
  out.write(xml);
 	out.flush();

%>