<%@ page language="java"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.patch.*"%>
<%@ page import="xpolog.eye.cloud.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";
%>

<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.ABOUT_PERMISSION,true)){
    return;
  }
  String publishPatchStr = request.getParameter("publishPatch");
  boolean publishPatch = publishPatchStr != null && publishPatchStr.equals("true");
  if (publishPatch && !WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ENTERPRISE_PERMISSION,true)){
  	return;
  }
  PatchPublisherRunner runner = PatchPublisherRunner.getInstance();
	boolean isRunning = runner.isRunning();
	String status = isRunning ? runner.getStatus().getCurrentStatus() : null;
	if (isRunning && status == null) {
		status = "Started publishing";
	}
	String op = !isRunning ? "run" : "stop";
  
	//appropriate messages
	String runMessage = "<span class=REGULARTEXT>To <b>start publishing</b>, select the file name of the patch to publish,<br> check the XpoLog nodes you would like to publish it to and click next</span>";
	String stopMessage = "<span class=REGULARTEXT>To <b>stop publishing</b>, click stop</span>";

  SiteManagment mgmt = SiteManagment.getInstance();
  CloudMgr cmgr = mgmt.getCloudMgr();
  XplgNode[] list = cmgr.getAllXplgNodes();
  list = CloudUtil.sortArrayByName(list);
  Set set = new HashSet();
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>

	function refresh(){
	  this.location = this.location;
	}

	function run(){
		if (document.getElementById("nodeAddFrame")){
			document.access.target = "nodeAddFrame";
			document.access.action = "importPatchSetNodesAction.jsp";
			document.access.encoding = "application/x-www-form-urlencoded";
			document.access.submit();
		}
	}
	
	function run2(){
	  var path ="importPatchAction.jsp?PATCH_PATH=" + document.access.archivePath.value;
	  path = path + "&publishPatch=<%=publishPatch%>" + "&op=<%=op%>";
		document.access.target = "_self";
		document.access.encoding = "multipart/form-data";
	  document.access.action = path;
	  document.access.submit();
	}


	<%if (list != null){%>
  function selectAllNodes(){
  	for (var i=0; i<<%=list.length%>; i++){
  		document.access.xplgNode<%=list.length > 1 ? "[i]" : ""%>.checked = true;
  	}
  }
  
  function clearAllNodes(){
  	for (var i=0; i<<%=list.length%>; i++){
  		document.access.xplgNode<%=list.length > 1 ? "[i]" : ""%>.checked = false;
  	}
  }
	<%}%>
	
	function refreshStatus(){
	  frames['statusFrame'].document.location = frames['statusFrame'].document.location;
	}
	
	function updateStaus(){
	  <% if (status != null) {%>
	  var message = frames['statusFrame'].msg;
	  if (message){
	    document.getElementById("statusMsg").innerHTML = "Status: " + message;
	    setTimeout('refreshStatus()',2000); 
	  }else {
	    refresh();
	  }
	  <%}%>
	}

</script>

</head>
<body>
<iframe name="statusFrame" style="visibility:hidden" onload="javascript:updateStaus();" src="publishingStatus.jsp" width="0" height="0"></iframe>
<form AUTOCOMPLETE="OFF" id="access" name="access" METHOD="POST" ACTION="importPatchAction.jsp" ENCTYPE="multipart/form-data" target="_self">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">
              <tr>
                <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="53%" class="TOPBORDER" height="0">
                <span class="PAGEHEADER">Update from patch</span> </td>
                <td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;</td>
                <td width="43%" height="100%">&nbsp;</td>
                <td width="50%" height="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <%if (publishPatch){%>
                  <%if (status != null) {%>
                   <tr>
                    <td>
                    <span id="statusMsg" class="INFORMATIONMESSAGE">Status: <%=status%></span>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%"><a href="javascript:refresh()" class="LINK">refresh</a></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <%}%>
                  <tr>
                    <td>                    
                    <%if (!isRunning) {%>
                    	<%=runMessage%>
                    <%} else {%>
											<%=stopMessage%>
										<%}%>
                    </td>
                  </tr>
                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <%}%>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">Location&nbsp;</span></td>
                  </tr>
                  <tr>
                    <td>
                    &nbsp;
                    </td>
                  </tr>
                  <tr>
                    <td width="15%">
                    <span class="REGULARTEXT">Please specify XpoLog patch file full location path</span></td>
                  </tr>
                  <tr>
                    <td>
                      <table border="0" width="106%">
                        <tr>
                          <td width="10%"><span class="REGULARTEXT">Path</span></td>
                          <td width="58%"><input class="TEXTBOX" type="file" id="archivePath" name="patchPath" size="60"></td>
                          <td width="38%"></td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                  
                  <%if(publishPatch){%>
				          <tr>
				            <td width="100%">
				            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
				              <tr>
				                <td colspan="3">&nbsp;</td>
				              </tr>
				              <tr>
				                <td colspan="3">&nbsp;</td>
				              </tr>
				              <tr>
				                <td colspan="3"><span class="HEADER">XpoLog Enterprise Nodes</span></td>
				              </tr>
				              <tr>
				                <td colspan="3" height="18">&nbsp;</td>
				              </tr>
				              <tr>
				                <td colspan="3"><span class="SMALLTEXT">
				                Select the XpoLog Enterprise Nodes you want to publish the patch to<br>
				                Displayed next to each node is it's status from the last publishing
				                </span></td>
				              </tr>
				            </table>
				            </td>
				          </tr>
	                <tr>
	                	<td>
											<table border="0" cellpadding="0" cellspacing="0">
												<tr>
													<td><a href="javascript:selectAllNodes()" class="SMALLLINK">select all</a></td>
													<td width="10">&nbsp;</td>
													<td><a href="javascript:clearAllNodes()" class="SMALLLINK">clear all</a></td>
												</tr>
											</table>
	                	<td>
	                </tr>
				          <tr>
				            <td>
				            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" height="53">
				              <tr>
				                <td>
				                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
				                		<!--
														<tr>
															<td><input type="checkbox" id="publishToLocalHost" name="publishToLocalHost" value="true"><span class="REGULARTEXT">local Xpolog Node</span></td>
														</tr> 
														<tr>
															<td><hr></td>
														</tr>
														-->
						              <%for(int t=0;t<list.length;t++) {
						              	  String checked = "";
						              	  if (set != null){
							              	  if (set.contains(list[t].getId())){
							              	  	checked = "checked";
							              	  }
						              	  }
						              	  String xplgName = list[t].getName();
						              	  String stat = runner.getStatusForXplgNode(list[t].getId());
						              	  if (stat != null && stat.length() > 0){
						              	  	stat = " - " + stat;
						              	  }
						              %>
														<tr>
															<td><input type="checkbox" id="<%=list[t].getId()%>" name="xplgNode" value="<%=list[t].getId()%>" <%=checked%>>
															<span class="REGULARTEXT"><%=xplgName + stat%></span>
															</td>
														</tr> 
						              <%}%>
				                </table>
				               </td>
				              </tr>
				            </table>
				            </td>
				          </tr>
                  <%}%>

                  <tr>
                    <td>&nbsp;</td>
                  </tr>
                  <tr>
                    <td height="100%">
                    &nbsp;&nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="30%">&nbsp;</td>
            <td width="31%" align="center">
              <table border="0" width="109%">
                <tr>
                  <td width="24%"></td>
                  <td width="40%">
                  	<%if(!isRunning){%>
										<a href="javascript:history.go(-1)" class="LINK">cancel</a>
										<%}else{%>
										&nbsp;
										<%}%>
                   </td>
                  <!--<td width="46%"><a href="javascript:doNext()" class="LINK">next</a></td>-->
                  <td width="46%"><a href="javascript:run<%=isRunning || !publishPatch? "2" : ""%>()" class="LINK"><%=!isRunning ? "run" : "stop"%></a></td>
                </tr>
              </table>
            </td>
            <td width="39%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="100%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
<iframe name="nodeAddFrame" style="visibility:hidden" width="0" height="0"></iframe>
</body>

</html>