<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.patch.*"%>
<%@ page import="xpolog.eye.security.*"%>

<%@ page import="java.io.FileInputStream"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";

  String dateFormat = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
  

  public String transformDateToString(Date d,long timeDiff){
    if(d == null){
      return null;
    }
    if (timeDiff != 0){
       long time = d.getTime();
    	 d = ((Date)d.clone());
    	 d.setTime(time + timeDiff); 
    }
    //01/31/2003 01:42:34
    String format = "";
    format = dateFormat;
    String str = new SimpleDateFormat(format).format(d);
    return str;
  }
%>
<%
  String ERROR_OBJ = "ERROR_OBJ";
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.ABOUT_PERMISSION,true)){
    return;
  }
  SiteManagment mgmt = SiteManagment.getInstance();
  PatchManager pmg = new PatchManager();
  PatchDescriptor[] pdescarr = pmg.getPatchDescriptors();
  
  String ignore = request.getParameter("ignoreLinks");
  boolean ignoreLinks = (ignore != null && ignore.equals("true")) ? true : false;
  
  Configuration conf = xpolog.config.Configuration.getInstance();
  String availableVersion = conf.getAvailableVersion();
  boolean checkOk = true;
  boolean isNewer = false;
  if(availableVersion == null){
    checkOk = false;
    availableVersion = "Check Failed";
  }else{
  	isNewer = conf.isNewerVersion(availableVersion);
  }
  
  boolean isWar = Configuration.isWar();
  String build = null;
  String buildString = "";
  FileInputStream fis = null;
  try {
  	fis = new FileInputStream(Configuration.XPOLOG_ROOT_PATH + "conf/ui/strings/info.properties");
  	Properties prop = new Properties();
  	prop.load(fis);
  	build = prop.getProperty("build");
  	if(build != null && build.length() > 0) {
  		buildString = "." + build;
  	}
  }catch(Exception e) {
  }finally {
  	if(fis != null) {
  		try {
  			fis.close();
  		}catch(Exception e) {
  		}
  	}
  }
  
  String[] logsArr = { "xpologlog", "events", "audit","systemaudit", "Console",
			"ServletContainer", "Ant.out", "MergeLogs" ,"ssh", "XpoLogConsole","XpoLogMemory","localhostCpu","localhostMemory","localhostDiskSpace"};
	String[] logsWarArr = { "xpologlog", "events", "audit","systemaudit", "MergeLogs" ,"XpoLogMemory","localhostCpu","localhostMemory","localhostDiskSpace"};
	if (isWar){
		logsArr = logsWarArr;
	}
	String supportLogsCheckBoxList = "";
	for(int i = 0; i < logsArr.length; i++) {
		supportLogsCheckBoxList += ("&supportLogsCheckBoxList=" + logsArr[i]);
	}
  
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/messages.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>scripts/common/progress.js" type="text/javascript"></script>
<script src="<%=BASE_DIRECTORY%>support/supportExport.js" type="text/javascript"></script>
<script>
baseDirectory = "<%=BASE_DIRECTORY%>";

function exportAll(){
  runExportAction("");
}
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">About XpoLog Center</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td><span class="HEADER">Version Information</span></td>
                  </tr>
                  <tr>
                  	<td>
                  		<table border="0" cellpadding="0" cellspacing="0" width="100%">
                  			<tr>
                  				<td style="padding-top:10"><span class="REGULARTEXT">Installed Version: <%= Configuration.xpologTypeVersion%><%=buildString %></span></td>
                  			</tr>
                  			<tr>
                  				<td style="padding-top:5">
                  					<span class="REGULARTEXT">Available Version: </span>
                  					<%
                  					if(checkOk) {
                  					%>
                  						<span class="REGULARTEXT"><%= availableVersion%></span>
                    				<%	
                  					}else {
                  					%>
                  						<span class="REGULARTEXT" style="color:#FF0000"><%= availableVersion%></span>
                  					<%
                  					}
                  					%>
                  				</td>
                  			</tr>
                  			<%
                  			if(checkOk) {
                  			%>
                  				<tr>
	                        <td style="padding-top:5">
	                        	<span class="REGULARTEXT">Get latest version at </span><a href="http://www.xplg.com/home/downloads/index.jsp" class="LINK" target="_XPLG">XpoLog Website</a>
	                        </td>
	                      </tr>
                  			
                  			<%
                  			}
                  			%>
                  <tr>
                    <td style="padding-top:10"><span class="HEADER">Support Information</span></td>
                  </tr>
      
                  			<tr>
	                        <td style="padding-top:10">
	                        	<a href="<%=BASE_DIRECTORY%>support/index.jsp" class="LINK" target="XpoLogSupportConsole">Open XpoLog Center Support Portal</a>
	                        </td>
	                      </tr>
	                      
	                      <tr>
	                        <td style="padding-top:5">
	                        	<a href="javascript:exportAll()" class="LINK" >Export System Report</a>
	                        </td>
	                      </tr>
	                      
                  		
                  		</table>
                  	</td>
                  </tr>
                  <% if (!isWar){ %>
                  <tr><td>&nbsp;</td></tr>
                  <tr>
                    <td><span class="HEADER">Patches</span></td>
                  </tr>
                  <tr><td></td></tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr class="TABLES_HEADERS">
                        <td width="80"><span class="REGULARTEXT">Version</span></td>
                        <td width="120"><span class="REGULARTEXT">Build</span></td>
                        <td width="180"><span class="REGULARTEXT">Deployment date</span></td>
                        <td width="*" align="left"><span class="REGULARTEXT">Description</span></td>
                      </tr>
                     <%
                      for(int i=pdescarr.length - 1;i>= 0;i--){
											  String dateStr = transformDateToString(new Date(pdescarr[i].getDate()),0);
                     %>
                      <tr>
											  <td width="80"><span class="REGULARTEXT"><%=pdescarr[i].getVersion()%></span></td>
											  <td width="120"><span class="REGULARTEXT"><%=pdescarr[i].getBuild()%></span></td>
											  <td width="180"><span class="REGULARTEXT"><%=dateStr%></span></td>
											  <td width="*%"><span class="REGULARTEXT" align="left"><%=pdescarr[i].getDescription()%></span></td>
                       </tr>
                      <%
                        }
                      %>
                    </table>
                   </td>
                  </tr>
                  <%} %>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>                  
          <tr>
            <td width="100%">
             <%if(ignoreLinks){ %>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="32%">&nbsp;</td>
                    <td width="10%" align="center">&nbsp;</td>
                    <td width="16%" align="center"><a href="javascript:window.close()" class="LINK">ok</a></td>
                    <td width="10%" align="center">&nbsp;</td>
                    <td width="32%">&nbsp;</td>
                  </tr>
                </table>
                  <%}else{ %>
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="*">&nbsp;</td>
                    <% if (!isWar){ %>
                    <td width="100" align="center"><a href="importPatch.jsp" class="LINK">add patch</a></td>
                    <td width="100" align="center"><a href="importPatch.jsp?publishPatch=true" class="LINK">publish patch</a></td>
                    <%}%>                     
                    <td width="50" align="center"><a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK">ok</a></td>
                    <td width="*">&nbsp;</td>
                  </tr>
                </table>
                <% }%>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
<form name="downloadFile">
</form>
</body>

</html>