<%!
  public Date transformStringToDate(String str,long timeDiff) throws Exception{
    if(str == null){
      return null;
    }
    //01/31/2003 01:42:34
    String format = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
    String formatMilliseconds = format+Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator",".")+"SSS";
    Date d = null;
    SimpleDateFormat dateFormat = null;
    try{
      d = new SimpleDateFormat(formatMilliseconds).parse(str);
    }catch(Exception e){
    	try{
	      d = new SimpleDateFormat(format).parse(str);	      
    	}catch(Exception e1){
    		throw e1;
    	}
    }
    if (timeDiff != 0){
       long time = d.getTime();
    	 d = ((Date)d.clone());
    	 d.setTime(time - timeDiff); 
    }
    return d;
  }
%>

<%!
	public long transformTimeToLong(String timeStr) throws Exception{
		if (timeStr == null || timeStr.length() == 0){
			return 0;
		}
    String format = "HH:mm:ss";
    Date d = null;
    SimpleDateFormat dateFormat = null;
    	SimpleDateFormat simpleFormat = new SimpleDateFormat(format);
    	simpleFormat.setTimeZone(TimeZone.getTimeZone("GMT"));
      d = simpleFormat.parse(timeStr);
      return d.getTime();
    
	}
%>
<%!
  public DateFilter createDateFilter(HttpServletRequest request,HttpServletResponse response,RecordMask mask) throws Exception{
		String prefix = request.getParameter("prefix");
		if (prefix == null){
			prefix = "";
		}
    String DATE_FILTER = prefix+"DateFilter";
    //all the date filter stuff    
    String DATE_MIN_FILTER_ACTIVE = prefix+"DateMinFilterActive";
    String DATE_MAX_FILTER_ACTIVE = prefix+"DateMaxFilterActive";
    String DATE_MINIMUM = prefix+"DateMinimum";
    String DATE_MAXIMUM = prefix+"DateMaximum";
    String TIME_AMMOUNT = prefix+"TimeText";
    String IS_TIME_UNIT = prefix+"Dates";
    String IS_TIME_LIM = prefix+"Dates";
    String TIME_TYPE = prefix+"TimeUnit";
    String TIME_UNIT_MINUTES = prefix+"minutes";
    String TIME_UNIT_HOURS = prefix+"hours";
    String TIME_UNIT_DAYS = prefix+"days";
    String TIME_UNIT_WEEKS = prefix+"weeks";
    String TIME_UNIT_MONTHS = prefix+"months";
    String TIME_OP_TYPE = prefix+"TimeOpType";
    String FROM_LAST_DAYS_AT = prefix+"fromLastDaysAt";
    String TIME_WINDOW_TEXT = prefix+"TimeWindowText";
    String TIME_WINDOW_UNIT = prefix+"TimeWindowUnit";

    String minActive = request.getParameter(DATE_MIN_FILTER_ACTIVE);
    String maxActive = request.getParameter(DATE_MAX_FILTER_ACTIVE);
    String minValue = request.getParameter(DATE_MINIMUM);
    String maxValue = request.getParameter(DATE_MAXIMUM);
    String isTimeLim = request.getParameter(IS_TIME_LIM);
    String isTimeUnit = request.getParameter(IS_TIME_UNIT);
    String timeAmount = request.getParameter(TIME_AMMOUNT);
    String timeType = request.getParameter(TIME_TYPE);
    String timeOpType = request.getParameter(TIME_OP_TYPE);
    String fromLastDaysAt = request.getParameter(FROM_LAST_DAYS_AT);
    String timeWindowText = request.getParameter(TIME_WINDOW_TEXT);
    String timeWindowUnit = request.getParameter(TIME_WINDOW_UNIT);
    
    boolean isQuick = request.getParameter("quickDateFilter") == null ? false : request.getParameter("quickDateFilter").equals("true");

    DateFilter datefilter = null;
    int dindex = mask.getDateColumnIndex();
    if(dindex < 0){
      return null;
    }
    if ((isTimeLim != null) && (isTimeLim.equalsIgnoreCase("true") || isTimeLim.equals("1") || isTimeLim.equalsIgnoreCase("TimeLimRadio"))){
        DateMask dateMask = (DateMask)mask.getMaskColumn(dindex);
        long timeDiff = dateMask.getTimeDiff();
        if ((isQuick && minValue != null && minValue.trim().length() > 0) || ((minActive != null) && (minActive.equalsIgnoreCase("true") || minActive.equals("1") || minActive.equalsIgnoreCase("ON") ))){
          if(datefilter == null){
            datefilter = new DateFilter(mask,dindex);
          }
          Date tempDate = null;
          try{
            tempDate = transformStringToDate(minValue.trim(),timeDiff);
          }catch(Exception e){
            throw new Exception("The 'from' date entered is in a wrong format. It should be similar to this format - MM/dd/yyyy HH:mm:ss");
          }
          datefilter.setMinDate(tempDate);
        }
        if((isQuick && maxValue != null && maxValue.trim().length() > 0) || ((maxActive != null) && (maxActive.equalsIgnoreCase("true") || maxActive.equals("1") || maxActive.equalsIgnoreCase("ON")))){
          
          if(datefilter == null){
            datefilter = new DateFilter(mask,dindex);
          }
          Date tempDate = null;
          try{
            tempDate = transformStringToDate(maxValue.trim(),timeDiff);
          }catch(Exception e){
            throw new Exception("The 'to' date is in a wrong format. It should be similar to this format - MM/dd/yyyy HH:mm:ss");
          }
          datefilter.setMaxDate(tempDate);
        }
        if (datefilter != null && datefilter.getMinDate() != null && datefilter.getMaxDate() != null && datefilter.getMinDate().getTime() > datefilter.getMaxDate().getTime()){
        	throw new Exception("The 'from' date is bigger than the 'to' date.");
        }
      }else if ((isTimeUnit != null) && (isTimeUnit.equalsIgnoreCase("true") || isTimeUnit.equals("1") || isTimeUnit.equalsIgnoreCase("TimeUnitRadio"))){
        if(datefilter == null){
            datefilter = new DateFilter(mask,dindex);
        }

        if(timeAmount == null || (timeAmount.trim().equals(""))){
        	timeAmount = "0";
        }
        timeAmount = timeAmount.trim();
        long time = -1;
        try{
          time = Long.parseLong(timeAmount);
          if(time <= 0){
            throw new Exception("The time must be a possitive number");
          }
        }catch(Exception e){
          throw new Exception("The time must be a valid number");
        }

        datefilter.setTimeGap(time);
        if (fromLastDaysAt != null){
	        long fromGap = transformTimeToLong(fromLastDaysAt);
	        datefilter.setFromGap(fromGap);
	      }
	      if (timeWindowUnit != null && timeWindowText != null){
	      	long timeWindow = Long.parseLong(timeWindowText);
	      	if (timeWindowUnit.equalsIgnoreCase(TIME_UNIT_HOURS)){
	      		timeWindow = timeWindow * (60*60*1000);
	      	}else if (timeWindowUnit.equalsIgnoreCase(TIME_UNIT_DAYS)){
	      		timeWindow = timeWindow * (24*60*60*1000);
	      	}
	      	datefilter.setTimeWindowSize(timeWindow);
	      }
        if(timeOpType != null && timeOpType.equals("0")){
			timeOpType = String.valueOf(DateFilter.PREVIOUS);
        	datefilter.setTimeTypeDays();
        }else if(timeType.equalsIgnoreCase(TIME_UNIT_MINUTES)){
          datefilter.setTimeTypeMinutes();
        }else if (timeType.equalsIgnoreCase(TIME_UNIT_HOURS)){
          datefilter.setTimeTypeHours();
        }else if (timeType.equalsIgnoreCase(TIME_UNIT_DAYS)){
          datefilter.setTimeTypeDays();
        }else if (timeType.equalsIgnoreCase(TIME_UNIT_WEEKS)){
          datefilter.setTimeTypeWeeks();
        }else if (timeType.equalsIgnoreCase(TIME_UNIT_MONTHS)){
          datefilter.setTimeTypeMonths();
        }
        try{
	        if (timeOpType != null){
	        	datefilter.setTimeOpType(Integer.parseInt(timeOpType));
	        }
	      }catch(Exception e){
	      }
      }
     return datefilter;
    }
%>