<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";

  String millisecondsSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator",".");

  String calendarDateFormat = "MM/dd/yyyy HH:mm:ss";
  String calendarDateFormatMS = calendarDateFormat+millisecondsSeperator+"SSS";

  String xpologDateFormat = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
  String xpologDateFormatMS = xpologDateFormat+millisecondsSeperator+"SSS";

  public String transformToCalendarDate(String date){
  	if (date==null || date.length()==0){
  		return null;
  	}
  	Date d;
  	SimpleDateFormat sdf = new SimpleDateFormat(xpologDateFormatMS);
  	try{
  		d = sdf.parse(date);
	  	sdf.applyPattern(calendarDateFormatMS);
	  	return (sdf.format(d));
  	}catch(Exception e){
  		sdf.applyPattern(xpologDateFormat);
  		try{
	  		d = sdf.parse(date);
		  	sdf.applyPattern(calendarDateFormat);
		  	return (sdf.format(d));
  		}catch(Exception e2){
  			return null;
  		}
  	}
  }

  public String transformToXpologDate(String date){
  	if (date==null || date.length()==0){
  		return null;
  	}
  	Date d;
  	SimpleDateFormat sdf = new SimpleDateFormat(calendarDateFormatMS);
  	try{
  		d = sdf.parse(date);
	  	sdf.applyPattern(xpologDateFormatMS);
	  	return (sdf.format(d));
  	}catch(Exception e){
  		sdf.applyPattern(calendarDateFormat);
  		try{
	  		d = sdf.parse(date);
		  	sdf.applyPattern(xpologDateFormat);
		  	return (sdf.format(d));
  		}catch(Exception e2){
  			return null;
  		}
  	}
  }

%>



<%
	String onLoadCall = request.getParameter("onLoadCall");
	String fromDateStr = request.getParameter("fromDate");
	String toDateStr = request.getParameter("toDate");
	if (fromDateStr != null){
		fromDateStr = transformToCalendarDate(fromDateStr);
	}else{
		fromDateStr = "";
	}
	if (toDateStr != null){
		toDateStr = transformToCalendarDate(toDateStr);
	}else{
		toDateStr = "";
	}
	String calendarDateStr = request.getParameter("calendarDate");
	if (calendarDateStr != null){
		calendarDateStr = transformToXpologDate(calendarDateStr);
	}else{
		calendarDateStr = "";
	}
	

	String openerMinDate = request.getParameter("openerMinDate");
	String openerMaxDate = request.getParameter("openerMaxDate");
%>

<html>
<head>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/calendar/calendar2.js"></script><!-- Date only with year scrolling -->
</script>
<script language="JavaScript">
			var cal7;
			var cal8;
			updateMinDateFunc = updateMinDate;
			updateMaxDateFunc = updateMaxDate;
			
			function openCal7(){
				cal7 = new calendar2("<%=BASE_DIRECTORY%>",document.access.fromDate,null,<%="/^\\-?\\d+(\\"+millisecondsSeperator+"\\d+)*$/"%>,"<%=millisecondsSeperator%>",updateMinDateFunc);
				cal7.year_scroll = true;
				cal7.time_comp = true;
				cal7.popup();
			}
			
			function openCal8(){
				cal8 = new calendar2("<%=BASE_DIRECTORY%>",document.access.toDate,null,<%="/^\\-?\\d+(\\"+millisecondsSeperator+"\\d+)*$/"%>,"<%=millisecondsSeperator%>",updateMaxDateFunc);
				cal8.year_scroll = true;
				cal8.time_comp = true;
				cal8.popup();
			}
			
			function updateMinDate(){
				document.access.calendarDate.value = document.access.fromDate.value;
				document.access.onLoadCall.value = "updateMinDateInOpener()";
				document.access.submit();
			}

			function updateMinDateInOpener(){
				opener.<%=openerMinDate%>.value = document.access.calendarDate.value;
				window.close();
			}

			function updateMaxDate(){
				document.access.calendarDate.value = document.access.toDate.value;
				document.access.onLoadCall.value = "updateMaxDateInOpener()";
				document.access.submit();
			}

			function updateMaxDateInOpener(){
				opener.<%=openerMaxDate%>.value = document.access.calendarDate.value;
				window.close();
			}

			
			
		//-->
</script>

</head>
<body onload="<%=onLoadCall%>">
	<form AUTOCOMPLETE="OFF" name="access" action="dateFormatConverter.jsp" method="post">
	  <input type="hidden" name="fromDate" value="<%=fromDateStr%>">
	  <input type="hidden" name="toDate" value="<%=toDateStr%>">
	  <input type="hidden" name="openerMinDate" value="<%=openerMinDate%>">
	  <input type="hidden" name="openerMaxDate" value="<%=openerMaxDate%>">
	  <input type="hidden" name="calendarDate" value="<%=calendarDateStr%>">
	  <input type="hidden" name="onLoadCall">
	</form>
</body>
</html>

