<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.masks.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.computation.impl.*" %>
<%@ page import="xpolog.eye.computation.conf.*" %>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.util.Constants"%>
<%@ page import="xpolog.eye.util.WebUtil"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!
	static final String BASE_DIRECTORY = "../../";

  String dateFormat = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormat","MM/dd/yyyy HH:mm:ss");
  String millisecondsSeperator = Configuration.getInstance().getPropertiesManager().getProperty("htmlInputDateFormatMillisecondsSeperator",".");
  String dateFormatMS = dateFormat+millisecondsSeperator+"SSS";
  boolean showHealth = Configuration.getInstance().getPropertiesManager().getProperty("log.filter.showHealthSettings","false").equals("true");

  public String transformDateToString(Date d,long timeDiff){
    if(d == null){
      return null;
    }
    if (timeDiff != 0){
       long time = d.getTime();
    	 d = ((Date)d.clone());
    	 d.setTime(time + timeDiff); 
    }
    //01/31/2003 01:42:34
    String format = "";
    if (d.getTime() % 1000 == 0){
	    format = dateFormat;
    } else {
	    format = dateFormatMS;
    }
    String str = new SimpleDateFormat(format).format(d);
    return str;
  }
%>
<%
  //constants
  String EDIT_FILTER_ID = "EDIT_FILTER_ID";
  String OP = "OP";
  String ADD = "ADD";



  String LOG_ID = "LOG_ID";
  String CURRENT_LOG = "CURRENT_LOG";
  String LOG_NAME = "LOG_NAME";
  String ERROR_OBJ = "ERROR_OBJ";
  String STRING_FILTER = "StringFilter";
  String PRIORITY_FILTER = "PriorityFilter";
  String DATE_FILTER = "DateFilter";
  String CHOICE_FILTER = "ChoiceFilter";
  String MULTI_FILTER = "MultiFilter";
  String NUMBER_FILTER = "NumberFilter";
  String QUERY_FILTER = "QueryFilter";
  String SHOW_ONLY_VISIBLE_FIELDS = "ShowOnlyVisibleFields";

  String FILTER_VALUE_PARAM  = "StringFilterValue_";
  String FILTER_CHECK_PARAM  = "StringFilterCheck_";
  String FILTER_OP_PARAM     = "StringFilterOp_";
	String FILTER_CASE_SENSITIVE_PARAM = "StringFilterCaseSensitive_";
	String FILTER_REG_EXP_PARAM = "StringFilterRegExp_";
	String FILTER_MATCH_WHOLE_WORDS_PARAM = "StringFilterMatchWholeWords_";
  int STR_FILTER_NUMBER = 4;

  String PRIOR_CHECK_NAME = "PriorityCheck_";
  String PRIOR_SPEC_VAL = "PRIOR_SPEC_VAL_";

  String DATE_MIN_FILTER_ACTIVE = "DateMinFilterActive";
  String DATE_MAX_FILTER_ACTIVE = "DateMaxFilterActive";
  String DATE_MIN_FILTER_ACTIVE_PARAM = "DATE_MIN_FILTER_ACTIVE_PARAM";
  String DATE_MAX_FILTER_ACTIVE_PARAM = "DATE_MAX_FILTER_ACTIVE_PARAM";
  String DATE_MINIMUM = "DateMinimum";
  String DATE_MAXIMUM = "DateMaximum";
  String DATE_FILTER_MINIMUM_PARAM = "DATE_FILTER_MINIMUM_PARAM";
  String DATE_FILTER_MAXIMUM_PARAM = "DATE_FILTER_MAXIMUM_PARAM";




  //page data
  LogBrowsingManager lbm = null;
  String logname    = "";
  FilterManager fman = null;

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  //check state
  lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  if(lbm == null || lbm.getId() == null){
    ErrorModel ermo = new ErrorModel();
    ermo.addError("You must select a log first.");
    request.getSession().setAttribute(ERROR_OBJ,ermo);
    response.sendRedirect(BASE_DIRECTORY + "loggers/admin/errorpage.jsp");
    return;
  }
  PriorityFilter prtfl = null;
  DateFilter datefl = null;
  if (lbm.isHavingLastFilterView()){
    fman = lbm.getLastFilterManager();
  }else {
    fman = lbm.getFilterManager();
  }

  String showOnlyVisibleFieldsStr = request.getParameter(SHOW_ONLY_VISIBLE_FIELDS);
  boolean showOnlyVisibleFields = (showOnlyVisibleFieldsStr != null && showOnlyVisibleFieldsStr.equals("true"));
  showOnlyVisibleFields = true;

  String filterId = request.getParameter(EDIT_FILTER_ID);
  int numFilterc = 0;
  if(fman != null){
    numFilterc = fman.getFilterCollections().size();
  }
  String filterName = "GenFilterName_" + String.valueOf(numFilterc);
  String filterDescription = "";
  String ADDparamToPass = "";
  String EDITparamToPass = "";
  FilterCollection fc = null;
  if(filterId != null && !(filterId.equals("none"))){
      fman.setActiveFilterId(filterId);
      fc = fman.getFilterCollectionById(filterId);
      List isMulti = fc.getByName(MULTI_FILTER);
      if(isMulti != null && isMulti.size()>0){
        String path = "multiFilter.jsp?"+EDIT_FILTER_ID+"=" + filterId;
        response.sendRedirect(path);
        return;

      }
      List list = fc.getByName("TimeEventsFilter");
      if(list != null && list.size()>0){
        String path = "eventsTimeFilter.jsp?"+EDIT_FILTER_ID+"=" + filterId;
        response.sendRedirect(path);
        return;

      }
      EDITparamToPass = filterId;
      if(fc != null){
      	String op = request.getParameter(OP);
      	if (op != null && op.equals("duplicate")){
      		fc = (FilterCollection)fc.clone();
      		fc.setId(null);
      		fc.setName("copy of "+fc.getName());
		      EDITparamToPass = "";
      	}
        filterName = fc.getName();        
        filterName = WebUtil.doHTMLEncoding(filterName);
        filterDescription = fc.getDescription();
        if (filterDescription != null){
        	filterDescription = WebUtil.doHTMLEncoding(filterDescription);
        }
      }

  }else{
    fc = new FilterCollection();
    ADDparamToPass = "ADD";
  }

  //extracting the filters for data
  List strfl  = fc.getByName(STRING_FILTER);
  if(strfl == null){
    strfl = new LinkedList();
  }
  int strFilterNumber = Math.max(strfl.size(),STR_FILTER_NUMBER);

  RecordMask mask = lbm.getRecordMask();
  CustomizationManager cust = lbm.getCustomizationManager();
  String[] priorities = null;
  int cnum = mask.getCulomnsNumber();
  ArrayList choiceList = new ArrayList();
  ArrayList choiceFilters = new ArrayList();
  HashMap choiceMap = new HashMap();
  LinkedList numberMaskFields = new LinkedList();
  HashMap numberMap = new HashMap();
  HashMap reverseNumberMap = new HashMap();
  boolean choiceMaskExsit = false;
  boolean dateMaskExsit = false;
  boolean numberMaskExists = false;
  int choiceNum = 0;
  int numberMaskNum = 0;
  long timeDiff = 0;

  for(int i=0;i<cnum;++i){
    if((mask.getMaskColumn(i) instanceof PriorityMask)){
      priorities = ((PriorityMask)mask.getMaskColumn(i)).getPriorities();
    }else if((mask.getMaskColumn(i) instanceof DateMask)){
      dateMaskExsit = true;
      if (i == mask.getDateColumnIndex()){
        timeDiff = ((DateMask)mask.getMaskColumn(i)).getTimeDiff();
      }
    }else if(mask.getMaskColumn(i) instanceof ChoiceMask){
      choiceList.add(mask.getMaskColumn(i));
      choiceMap.put(new Integer(i),new Integer(choiceNum++));
    }else if(mask.getMaskColumn(i) instanceof NumberMask){
    	numberMaskFields.add(mask.getMaskColumn(i));
    	numberMap.put(new Integer(i),new Integer(numberMaskNum));
    	reverseNumberMap.put(new Integer(numberMaskNum),new Integer(i));
    	numberMaskNum++;
    }
  }
  ChoiceFilter[] choice_filters = new ChoiceFilter[choiceList.size()];
  if(choiceList.size()>0){
    choiceMaskExsit = true;
  }

  choiceNum = choiceList.size();
  if(fc.getByName(CHOICE_FILTER) != null && fc.getByName(CHOICE_FILTER).size() > 0){
    List chlf = fc.getByName(CHOICE_FILTER);
    ChoiceFilter cf = null;
    for(int i=0;i<chlf.size();++i){
      cf = (ChoiceFilter)chlf.get(i);
      Integer index = (Integer)choiceMap.get(new Integer(cf.getColIndex()));
      if (index != null){
        choice_filters[index.intValue()] = cf;
      }
      cf = null;
    }
  }

  NumberFilter[] number_filters = new NumberFilter[numberMaskFields.size()];
  if(numberMaskFields.size()>0){
    numberMaskExists = true;
  }
  if (showOnlyVisibleFields && cust!=null){
    numberMaskExists = false;
		for(int t=0;t<numberMaskFields.size();++t){
			int actualIndex = ((Integer)reverseNumberMap.get(new Integer(t))).intValue();
			if (cust.getCustomizedColFromIndex(actualIndex) != -1){
		    numberMaskExists = true;
		    break;
			}
		}
  }
  

  numberMaskNum = numberMaskFields.size();
  if(fc.getByName(NUMBER_FILTER) != null && fc.getByName(NUMBER_FILTER).size() > 0){
    List numlf = fc.getByName(NUMBER_FILTER);
    NumberFilter nf = null;
    for(int i=0;i<numlf.size();++i){
      nf = (NumberFilter)numlf.get(i);
      Integer index = (Integer)numberMap.get(new Integer(nf.getColIndex()));
      if(index != null) {
      	number_filters[index.intValue()] = nf;
      }
      nf = null;
    }
  }



  if(fc.getByName(PRIORITY_FILTER) != null && fc.getByName(PRIORITY_FILTER).size() > 0){
    List l = fc.getByName(PRIORITY_FILTER);
    if((l != null) && (l.size() > 0)){
      prtfl = (PriorityFilter)l.get(0);
    }
  }

  Date minDate = null;
  Date maxDate = null;
  String minDateStr = "";
  String maxDateStr = "";
  String minStat = "";
  String maxStat = "";
  String timeunit = "";
  String isTimeLim = "";
  String daystatsel = "";
  String minstatsel = "";
  String hourstatsel = "selected";
  String weekstatsel = "";
  String monthstatsel = "";
  boolean isLast = true;

  if(fc.getByName(DATE_FILTER) != null && fc.getByName(DATE_FILTER).size() > 0){
   datefl = (DateFilter)fc.getByName(DATE_FILTER).get(0);
    if(datefl.getTimeType() == -1){
      minDate = datefl.getMinDate();
      maxDate = datefl.getMaxDate();      
    }else{
      hourstatsel = "";
      isLast = datefl.isLastOpType();
      isTimeLim = "checked";
      timeunit = String.valueOf(datefl.getTimeGap());
      if(datefl.isMonths()){
        monthstatsel = "selected";
      } else if(datefl.isWeeks()){
        weekstatsel = "selected";
      } else if(datefl.isDays()){
        daystatsel = "selected";      
      }else if(datefl.isHours()){
        hourstatsel = "selected";
      }else if(datefl.isMinutes()){
        minstatsel = "selected";
      }else {
        hourstatsel = "selected";
      }
    }
  }

  long minTimeDiff = timeDiff;
  if(minDate == null){
    minDate = new Date();
    long t = minDate.getTime();
    minDate.setTime(t-(t%1000));
    minTimeDiff = 0;
  }else{
    minStat = "checked";
  }

  long maxTimeDiff = timeDiff;
  if(maxDate == null){
   maxDate = new Date();
    long t = maxDate.getTime();
    maxDate.setTime(t-(t%1000));
    maxTimeDiff = 0;
  }else{
    maxStat = "checked";
  }
  minDateStr = transformDateToString(minDate,minTimeDiff);
  maxDateStr = transformDateToString(maxDate,maxTimeDiff);
  
  String query = "";
  if(fc.getByName(QUERY_FILTER) != null && fc.getByName(QUERY_FILTER).size() > 0){
	   QueryFilter queryFilter = (QueryFilter)fc.getByName(QUERY_FILTER).get(0);
	   query = queryFilter.getQuery();
     if (query == null){
      query = ""; 
     }
     query = WebUtil.doHTMLEncoding(query);
  }

  UserSecurity security = WebSecurityManager.getInstance().getUserSecurity(request);
  boolean isEditable = security == null || security.isModuleMemberEditable(lbm.getId());
  
  String charset = lbm.getCharset();
  if(charset == null) {
		charset = Configuration.getInstance().getPropertiesManager().getProperty("logview.defaultCharecterEncoding", null);
		if(charset != null && charset.length() == 0) {
			charset = null;
		}
	}
  if (charset != null){
  	if (charset.startsWith("UTF-16")){
			charset = "UTF-8";
		}
    response.setContentType("text/html; charset=" + charset);
	}
	boolean isIndexing = true;
  	if(lbm != null){
  		isIndexing = lbm.isUseIndexing();
 	}
	
  String forward = request.getParameter("forward");
  ComputationConfiguration computeConf = ComputationConfiguration.getInstance();
  boolean displaySystemHealth = showHealth;
%>
<%@page import="xpolog.eye.reports.health.ui.HealthViewRiskModel"%>
<html>

<head>
<%if (charset != null){ %>
  <meta http-equiv="Content-Type" content="text/html; charset=<%=charset%>">
<%}else{ %>
  <meta http-equiv="Content-Language" content="en-us">
<%}%>
  <META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
  <META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
  <META HTTP-EQUIV="EXPIRES" CONTENT="0">
  
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<script>
 	var date_ok = "";
  function doApply(){

    if(document.access.SpecificColumns.checked && document.getElementById("allColDiv").style.display != "none"){
      addAllFiledToSelection(document.access.ToCol,document.access.ToCol_Select);
      for(var i=0;i<document.access.ToCol_Select.options.length;++i){
        document.access.ToCol_Select.options[i].selected='true';
      }
    }
    
    if(document.access.SpecificColumnsInd.checked && document.getElementById("indexColDiv").style.display != "none"){
      addAllFiledToSelection(document.access.ToColInd,document.access.ToColInd_Select);
      for(var i=0;i<document.access.ToColInd_Select.options.length;++i){
        document.access.ToColInd_Select.options[i].selected='true';
      }
    }

    <%
      if(priorities != null){
    %>
      addAllFiledToSelection(document.access.To,document.access.ToSelect);
      for(var i=0;i<document.access.ToSelect.options.length;++i){
        document.access.ToSelect.options[i].selected='true';
      }
    <%
      }
    %>

    <%
      if(choiceMaskExsit){
    %>
      var choicenumber = <%=String.valueOf(choiceNum)%>;
      for(var i=0;i<choicenumber;++i){
        selToH = eval("document.access.To_Select_"+i);
        selTo = eval("document.access.To_"+i);
        addAllFiledToSelection(selTo,selToH);
        for(var t=0;t<selToH.options.length;++t){
          selToH.options[t].selected='true';
        }
      }
    <%
      }
    %>

    document.access.action="searchAndFilterAction.jsp";
    document.access.submit();
  }

  function markStringCheck(filed,tocheck){
  	//filed.value = trim(filed.value);
  	if(filed.value == ""){
  		tocheck.checked = false;
  		return;
  	}
  	tocheck.checked = true;
  }

  function trim(a){
	while(''+a.charAt(a.length-1)==' '){
	 a=a.substring(0,a.length-1);
	}
  	return a;
  }
  
  function checkDate(date_check_box, date_obj){
  	date_ok = "";
  	obj_name = date_check_box.name;
  	frames['dateValidationFrame'].location = "<%=BASE_DIRECTORY%>calendar/dateValidation.jsp?dateStr="+date_obj.value+"&date_check_box="+obj_name;
  }
  
  function useIndexChanged(){
  	<%if (mask.isUseIgnoreColIndex()){%>
  	   var indChk = document.getElementById("filterUsesIndexing");
  	   if (indChk){
  	     var allDiv = document.getElementById("allColDiv");
  	     var indDiv = document.getElementById("indexColDiv");
  	     if (!allDiv || !indDiv) return;
  	     
  	     if (indChk.checked){
  	       allDiv.style.display="none";
  	       indDiv.style.display="";
  	     }else {
  	       allDiv.style.display="";
  	       indDiv.style.display="none";
  	     }
  	   }
  	<%}%>
  }


</script>
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/filters/fromto.js"></script>

<title></title>
</head>
<!-- American format mm/dd/yyyy -->
<script language="JavaScript" src="<%=BASE_DIRECTORY%>scripts/calendar/calendar2.js"></script><!-- Date only with year scrolling -->



<body style="font-size: 8pt">
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post" style="margin:0;padding:0">
<input type="hidden" name="OP" value="<%=ADDparamToPass%>">
<input type="hidden" name="EDIT_FILTER_ID" value="<%=EDITparamToPass%>">
<input type="hidden" name="forward" value="<%=(forward!=null?forward:"")%>">
<input type="hidden" name="enc" value="<%=charset == null? "" : charset%>">
<input type="hidden" name="strFilterNumber"value="<%=strFilterNumber%>">

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">

  <tr>
    <td width="100%" height="100%" valign="top">
    	<table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      		<tr>
        		<td valign="top" height="84%">
        			<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          			<tr>
            				<td width="100%">
            					<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              					<tr>
                				  <td width="3%" class="TOPLEFTBORDER"></td>
                				  <td width="50%" class="TOPBORDER"><span class="PAGEHEADER">Filter definition</span></td>
                				  <td width="47%" class="TOPRIGHTBORDER"></td>
              					</tr>
              					<tr>
                				  <td width="100%" colspan="3">
                                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                      <tr>
                                        <td><font size="1">&nbsp;</font></td>
                                      </tr>
                                      <tr>
                                        <td style="padding-left:20"><span class="HEADER">Name</span></td><td><input class="REGULARTEXT" type="text" name="filterName" size="30" value="<%=filterName%>">
                                      
                                      <%if (isIndexing){
                                      	boolean filterUsesIndexing = fc.isUseIndexing();
                                      	String checked = filterUsesIndexing ? " checked" : "";
                                      %>
                                        <input type="checkbox" id="filterUsesIndexing" name="filterUsesIndexing" value="true" <%=checked%> style="margin-left:40" onClick="javascript:useIndexChanged()"><span class="REGULARTEXT"> use search engine</span>
                                      <%}else{%>
                                        <input type="hidden" name="filterUsesIndexing" value="true">
                                      <%}%>
                                      </td>
                                      </tr>
                                      <tr>
                                        <td style="padding-left:20"><span class="HEADER">Description</span></td><td><input class="REGULARTEXT" type="text" name="filterDescription" size="75" value="<%=filterDescription%>">
                                        </td>
                                        </tr>
                                      <tr>
                                        <td colspan="2" width="100%"></td>
                                      </tr>
                                      <tr >
                                        <td colspan="2" width="100%">
                                          <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                          <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER">Query</span></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="queryFilter.jsp"%></td>
                                            </tr>
                                         <%
                                            if(priorities != null){
                                          %>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER">Priorities</span></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="priorityFilter.jsp"%></td>
                                            </tr>
                                           <%
                                           	 }
                                           %>

                                           <%
                                           	 if(dateMaskExsit){
                                           %>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER">Date and Time</span></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="dateFilter.jsp"%></td>
                                            </tr>
                                           <%
                                           	 }
                                           %>
                                            <%
                                           	 if(choiceMaskExsit){
                                                  String colName = "";
                                                  String[] allChoice = null;
                                                  ChoiceMask chmask = null;
                                                  ChoiceFilter chFilter = null;
                                                  List fsele = null;

                                                  for(int t=0;t<choiceList.size();++t){
                                                    chmask = (ChoiceMask)choiceList.get(t);
                                                    colName = chmask.getName();
                                                    allChoice = chmask.getChoices();
                                                    chFilter = choice_filters[t];
                                                    fsele = null;
                                                    if(chFilter != null){
                                                      fsele = chFilter.getFilteredValues();
                                                    }
                                            %>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER"><%=colName%></span></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="choiceFilter.jsp"%></td>
                                            </tr>
                                            <%
                                              }//for
                                             }
                                            %>
                                            <%
                                           	 if(numberMaskExists){
                                            %>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER">Number</span></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="numberFilter.jsp"%></td>
                                            </tr>
                                            <%
                                             }
                                            %>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER">Text</span></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="stringFilter.jsp"%></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><%@ include file="columnSelect.jsp"%></td>
                                            </tr>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                            <% 
                                         String analytics = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_DISPLAY_NAME);
                                         String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);
                                         HealthConfig [] healthConfigs = computeConf.getHealthConfigs();
                                         if (healthConfigs != null && healthConfigs.length > 0 && SiteManagment.getInstance().getXpologManagment().isDashboardValidAndComponentExists()){
                                         %>
                                            <tr style="<%=displaySystemHealth ? "" : "display:none" %>">
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><hr><span class="HEADER"><%=analyticsH %></span></td>
                                            </tr>
                                            
                                            <tr style="<%=displaySystemHealth ? "" : "display:none" %>">
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"><span class="MEDIUMTEXT">Set the severity of this filter rule if you wish the <%=analytics %> to analyze and monitor it. Leave none otherwise.</span></td>
                                            </tr>
                                            <%
                                            for(int j = 0; j < healthConfigs.length ; j++){
                                            	String type = healthConfigs[j].getType();
                                            	FilterComputationDefUnit defUnit = fc == null ? null : fc.getDefUnit(type);
                                            	
                                            %>
                                            <tr style="padding-top:5" style="<%=displaySystemHealth ? "" : "display:none" %>">
                                              <td width="20">&nbsp;</td>
                                              <td width="98%">
                                              <table brder="0" cellspacing="0" cellpadding="0">
                                              <tr>
																								<td nowrap width="150"><span class="REGULARTEXT">Filter Rule Severity: &nbsp;</span></td>
																								<td width="20">
																								<select name="healthWeight<%=type%>">
																								<option value="-1">None</option>
																								<%
																								HealthViewRiskModel riskModel = HealthViewRiskModel.getInstance();
																								int riskType = -1;
																								if (defUnit != null && defUnit.getWeight() > 0){
																									riskType = riskModel.getRiskType(defUnit.getWeight());
																								}
																								int  [] values = riskModel.getRiskValues();
																								for (int i = 1; values != null && i < values.length;i++){
																									if (values[i] <= 0) continue;
																									
																									String name = riskModel.getRiskName(values[i]);
																								%>
																								<option value="<%=String.valueOf(values[i])%>" <%=(riskType == i ?"selected" : "")%>><%=name%></option>
																								<%
																								}
																								%>
																								
																								</select>
																								<input type="hidden" name="healthAmountType<%=type%>" value="1"> 
																								<input type="hidden" name="healthAmount<%=type%>" value="0">
																								</td>																								
																								<td width="*" >&nbsp;</td>	
																							</tr>
                                              </table>
                                              </td>
                                            </tr>
																							<%} %>
                                            <tr>
                                              <td width="20">&nbsp;</td>
                                              <td width="98%"></td>
                                            </tr>
                                         <%
                                         }
                                         %>
                                         
                                          </table>
                                        </td>
                                      </tr>
                                      <tr>
                                        <td colspan="2" width="100%">
                                          <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                            <tr>
                                              <td width="33%">&nbsp;</td>
                                              <td width="33%">
                                                <table border="0" width="100%" cellspacing="0" cellpadding="0">
                                                  <tr>
                                                    <td width="33%"><a href="javascript:doApply()" class="LINK"><%=isEditable?"save" : "apply"%></a></td>
                                                    <td width="33%"><a href="<%=BASE_DIRECTORY+(forward!=null?forward+"&":"loggers/logview.jsp?")%>refreshMenu=false" class="LINK">cancel</a></td>
                                                    <td width="34%"><a href="javascript:openHelp('<%=BASE_DIRECTORY%>','Filter.htm')" class="LINK">help</a></td>
                                                  </tr>
                                                </table>
                                              </td>
                                              <td width="34%">&nbsp;</td>
                                            </tr>
                                          </table>
                                        </td>
                                      </tr>
                                    </table>
                                  </td>
              					</tr>
              					<tr>
                				  <td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
                				  <td width="50%" class="TOPBORDER"></td>
                				  <td width="47%" class="TOPRIGHTBORDER">&nbsp;</td>
              					</tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
    </table>
</form>
<%
  if(dateMaskExsit){
%>
<script language="JavaScript">
		<!-- // create calendar object(s) just after form tag closed
			 // note: you can have as many calendar objects as you need for your application
			var cal7 = new calendar2("<%=BASE_DIRECTORY%>",document.access.<%=DATE_MINIMUM%>,null,<%="/^\\-?\\d+(\\"+millisecondsSeperator+"\\d+)*$/"%>,"<%=millisecondsSeperator%>");
			cal7.year_scroll = true;
			cal7.time_comp = true;
			var cal8 = new calendar2("<%=BASE_DIRECTORY%>",document.access.<%=DATE_MAXIMUM%>,null,<%="/^\\-?\\d+(\\"+millisecondsSeperator+"\\d+)*$/"%>,"<%=millisecondsSeperator%>");
			cal8.year_scroll = true;
			cal8.time_comp = true;

			function openCal7(dateObj){
				document.access.<%=DATE_MIN_FILTER_ACTIVE%>.checked='true';
				//document.dateForm.fromDate.value = dateObj.value;
				//document.dateForm.onLoadCall.value = "openCal7()";
				//pw = window.open("empty.html","dateWindow","width=100,height=100");
				//pw.focus();
				//document.dateForm.submit();
				cal7.popup();
			}
			function openCal8(dateObj){
				document.access.<%=DATE_MAX_FILTER_ACTIVE%>.checked='true';
				//document.dateForm.toDate.value = dateObj.value;
				//document.dateForm.onLoadCall.value = "openCal8()";
				//pw = window.open("empty.html","dateWindow","width=100,height=100");
				//pw.focus();
				//document.dateForm.submit();
				cal8.popup();
			}


		//-->
</script>
<form AUTOCOMPLETE="OFF" name="dateForm" action="dateFormatConverter.jsp" method="post" target="dateWindow" style="margin:0;padding:0">
	<input type="hidden" name="xpologDateFormat" value="<%=dateFormat%>">
	<input type="hidden" name="xpologDateFormatMS" value="<%=dateFormatMS%>">
	<input type="hidden" name="openerMinDate" value="access.<%=DATE_MINIMUM%>">
	<input type="hidden" name="openerMaxDate" value="access.<%=DATE_MAXIMUM%>">
	<input type="hidden" name="fromDate">
	<input type="hidden" name="toDate">
	<input type="hidden" name="onLoadCall">
</form>
		
<%
  }
%>
</table>
</body>

