<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.fs.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>

<%@ page import="java.util.*"%>
<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION,true)){
    return;
  }
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
  
  String ERROR_OBJ = "ERROR_OBJ";
  String TEMPLATE_ID = "ID";
  String id = request.getParameter(TEMPLATE_ID);
	
  String name = "";
  String description = "";
  String overWrite = "checked";
  boolean isOverWrite = true;
  FSAccount fsacc = null;

	
	if(id != null){
		TemplateBook templateBook = TemplateBook.getInstance();
		FSManager med = (FSManager)templateBook.getTemplateById(id);
		name = med.getMediaName();
		description = med.getDescription();
		isOverWrite = med.isOverwrite();
		if(isOverWrite) {
			overWrite = "checked";
		}else {
			overWrite = "unchecked";
		}
		fsacc = med.getAccount();
		
	}else{
		id = "";
	}
	
	FSAccountFilter filter = new FSAccountFilter();
    AddressBook adbook = AddressBook.getInstance();
    List list = adbook.getAccountsByFilter(filter);
	if(list.size() == 0) {
	  //No accounts defined in system
	  ErrorModel errmodel = new ErrorModel();
	  errmodel.addError("There is no fs account defined, Please <a href=\"" + BASE_DIRECTORY + "tools/addresses/fs/accountFs.jsp\">create fs account</a> first.");
	  request.getSession().setAttribute(ERROR_OBJ,errmodel);
	  response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
	  return;
	}
	
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
      function doSave(){
        document.access.action ="templateFsAction.jsp";
        document.access.submit();
      }
      
      function goNew(){
		path = "<%=BASE_DIRECTORY%>tools/addresses/accoutAction.jsp?ACCOUNT_TYPE=fs";
  		document.location = path;
  	  }

</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER">&nbsp;</td>
                <td width="33%" class="TOPBORDER">
                <span class="PAGEHEADER">File System Alert Template</span> </td>
                <td width="44%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
                <td width="33%">&nbsp;</td>
              </tr>
              <tr>
                <td width="1%" >&nbsp;</td>
                <td colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">File System
                      details</span></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="22">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber4">
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">Name</span></td>
                        <td width="69%">
                        <input class="TEXTBOX" type="text" name="Name" size="50" value="<%=name%>"></td>
                      </tr>
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">Description</span></td>
                        <td width="69%">
                        <input class="TEXTBOX" type="text" name="Description" size="50" value="<%=description%>"></td>
                      </tr>
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">FS Details</span></td>
                        <td width="69%">
                        <select class="TEXTBOX" size="1" name="fsAccount">
                        <option value="">--- Select fs account ---</option>
                        <%
                        	String accselected = "selected";
                            String accunselected = "";
                            String toGo = accunselected;
                            Account acc = null;
                            
                            for(int i=0;i<list.size();++i){
                            	acc = (Account)list.get(i);
                            	if(fsacc != null && acc.getId().equals(fsacc.getId())){
                            			toGo = accselected;
                            		}else{
                            			toGo = accunselected;
                            		}
                        %>
                               <option <%=toGo%> value="<%=acc.getId()%>"><%=acc.getAccountName()%></option>
                        <%
                        	}
                        %></select>
                        <%
                        if (user == null || user.isHavePermission(ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION)){
                        %>
                        <span class="SMALLTEXT"><a href="javascript:goNew()" class="LINK">new</a></span>
                        <%}%>
                        </td>
                      </tr>
                      <tr>
                        <td width="11%"><span class="REGULARTEXT">Overwrite</span></td>
                        <td width="69%">
                        <input type="checkbox" name="FSOverWrite" <%=overWrite%>>
                        &nbsp;<span class="SMALLTEXT">(When unchecked XpoLog will create
                        a new unique file name)</span></td>
                      </tr>
                      <tr>
                        <td width="11%">&nbsp;</td>
                        <td width="69%"><input class="TEXTBOX" type="hidden" name="Id" size="10" value="<%=id%>">
                        &nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td width="15%" height="21">
                    &nbsp;</td>
                  </tr>
                  <!--
                  <tr>
                    <td><b><i>Log context pattern</i></b></td>
                  </tr>-->
                  <tr>
                    <td><font size="2">&nbsp;&nbsp;</font></td>
                  </tr>
                  <tr>
                    <td>
                    <font size="2">&nbsp; </font>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    &nbsp;&nbsp;</td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="101%" id="AutoNumber17">
                      <tr>
                        <td width="25%">&nbsp;</td>
                        <td width="13%">
                        <p align="center">&nbsp;</td>
                        <td width="11%"><a href="javascript:history.go(-1)" class="LINK">cancel</a></td>
                        <td width="11%"><a href="javascript:doSave()" class="LINK">save</a></td>
                        <td width="35%">&nbsp;</td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="5%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>