<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.fs.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
  UserContext userContext = UserEnvironment.getUserContext(request);

	String ERROR_OBJ = "ERROR_OBJ";
	String FS_ACC = "fsAccount";
	String FS_OVERWRITE = "FSOverWrite";
	
	String Name = "", Description = "", Id = "", fsAccount = "";
	boolean fs_ovw = true;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	Id = request.getParameter("Id");
	String fs_ovw_str = request.getParameter(FS_OVERWRITE);
  	//should be checked in export log fs action how it get the over write
  	// param.
  	if(fs_ovw_str != null && fs_ovw_str.trim().equals("on")) {
  		fs_ovw = true;
  	}else {
  		fs_ovw = false;
  	}
  	fsAccount = request.getParameter(FS_ACC);
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
    	errmodel.addError("No Name was supplied.");
  	}
  
  	if(fsAccount == null || fsAccount.trim().equals("")){
    	errmodel.addError("No FS Account was not supplied.");
  	}
  	  	
  	if(errmodel.getErrorCount() != 0){
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
  	}
	
	AddressBook adbook = AddressBook.getInstance();
    FSAccount fsacc = (FSAccount)adbook.getAccountById(fsAccount);
	
	
	
	FSManager med = null;
	TemplateBook templateBook = TemplateBook.getInstance();
	if(Id != null){
		med = (FSManager)templateBook.getTemplateById(Id);
		
	}
	if(med == null){
		med = new FSManager();
	}
	
	med.setMediaName(Name);
	med.setDescription(Description);
	med.setOverwrite(fs_ovw);
	med.setAccount(fsacc);
	
	templateBook.addTemplate(med);
	templateBook.saveTemplateBook();

	//audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   			userContext, AuditConstants.CHANGE, "add/edit template", AuditConstants.CONFIGURATION, "add/edit fs template " + Name);	 	 	

	response.sendRedirect(BASE_DIRECTORY + "tools/templates/templateview.jsp?addressType=FSMedia");
%>
