<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.ftp.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
 UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	String FTP_ACC = "ftpAccount";
	
	String Name,Description,ftpDir,Id, ftpAccount;
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	ftpDir = request.getParameter("ftpDirectory");
	Id = request.getParameter("Id");
	ftpAccount = request.getParameter(FTP_ACC);
	
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
    	errmodel.addError("No Name was supplied.");
  	}
  	
  	if(ftpDir == null || ftpDir.equals("")){
    	errmodel.addError("FTP Directory was not supplied.");
  	}

  	if(ftpAccount == null || ftpAccount.trim().equals("")){
    	errmodel.addError("No FTP Account was not supplied.");
  	}
	
  	if(errmodel.getErrorCount() != 0){
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
  	}
	AddressBook adbook = AddressBook.getInstance();
    FTPAccount ftpacc = (FTPAccount)adbook.getAccountById(ftpAccount);
	
	
	FTPManager med = null;
	TemplateBook templateBook = TemplateBook.getInstance();
	if(Id != null){
		med = (FTPManager)templateBook.getTemplateById(Id);
	}
	if(med == null){
		med = new FTPManager();
	}
	
	med.setMediaName(Name);
	med.setDescription(Description);
	med.setFTPDirectory(ftpDir);
	med.setAccount(ftpacc);
	
	templateBook.addTemplate(med);
	templateBook.saveTemplateBook();

	//audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		   			userContext, AuditConstants.CHANGE, "add/edit template", AuditConstants.CONFIGURATION, "add/edit ftp template " + Name);	 	 	

	response.sendRedirect(BASE_DIRECTORY + "tools/templates/templateview.jsp?templateType=FtpMedia");
%>

