<%@ page language="java"%>

<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.mail.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>

<%!
	static final String BASE_DIRECTORY = "../";
%>
<%
  UserContext userContext = UserEnvironment.getUserContext(request);

	String ERROR_OBJ = "ERROR_OBJ";
	String FROM = "fromId";
	String TO = "toId";
	
	String name, description, from, to, subject, message, Id;
	
	name = request.getParameter("name");
	description = request.getParameter("Description");
	from = request.getParameter(FROM);
	to = request.getParameter(TO);
	subject = request.getParameter("subject");
	message = request.getParameter("message");
	Id = request.getParameter("Id");
	
	ErrorModel errmodel = new ErrorModel(); 
	if(name == null || name.equals("")){
    	errmodel.addError("No Name was supplied.");
  	}
  	if(from == null || from.trim().equals("")){
    	errmodel.addError("eMail from address was not supplied.");
  	}
  	if(to == null || to.trim().equals("")){
    	errmodel.addError("eMail to address was not supplied.");
  	}
  	if(subject == null || subject.equals("")){
    	errmodel.addError("eMail subject was not supplied.");
  	}
  	if(errmodel.getErrorCount() != 0){
    	request.getSession().setAttribute(ERROR_OBJ,errmodel);
    	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    	return;
  	}
	
	AddressBook adbook = AddressBook.getInstance();
    MailAccount mafrom = (MailAccount)adbook.getAccountById(from);
    MailAccount mato = (MailAccount)adbook.getAccountById(to);
	
	
	PostOffice med = null;
	TemplateBook templateBook = TemplateBook.getInstance();
	if(Id != null){
		med = (PostOffice)templateBook.getTemplateById(Id);
	}
	if(med == null){
		med = new PostOffice();
	}
	
	med.setMediaName(name);
	med.setDescription(description);
	med.setInfo(mafrom, mato, subject, message);
	
	templateBook.addTemplate(med);
	templateBook.saveTemplateBook();

	//audit
	AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
		   			userContext, AuditConstants.CHANGE, "add/edit template", AuditConstants.CONFIGURATION, "add/edit mail template " + name);	 	 	

	response.sendRedirect(BASE_DIRECTORY + "tools/templates/templateview.jsp?templateType=MailMedia");
%>

