<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.mail.*"%>
<%@ page import="xpolog.eye.media.fs.*"%>
<%@ page import="xpolog.eye.media.ftp.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%//@ page import="xpolog.eye.media.sms.*"%>

<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../";
%>
<% 
  String ERROR_OBJ = "ERROR_OBJ";
  String FILTER_TYPE = "templateType";
  String filterstr = request.getParameter(FILTER_TYPE);
  String ftpselect = "", sshselect = "", fsselect = "",emailselect = "",smsselect = "";
  
  MediaFilter filter = null;
  if(filterstr != null){
	  if(filterstr.equals("FtpMedia")){
	  	filter = new FtpMediaFilter();
	  	ftpselect = "selected";
	  }else if(filterstr.equals("SshMedia")){
	  	filter = new TelShMediaFilter();
	  	sshselect = "selected";
	  }else if(filterstr.equals("FSMedia")){
	  	filter = new FSMediaFilter();
	  	fsselect = "selected";
	  }else if(filterstr.equals("MailMedia")){
	  	filter = new MailMediaFilter();
	  	emailselect = "selected";
	  }else if(filterstr.equals("sms")){
	  	//filter = new SmsMediaFilter();
	  	smsselect = "selected";
	  }
  }

  SiteManagment mgmt = SiteManagment.getInstance();
  TemplateBook templateBook = TemplateBook.getInstance();
  List list = templateBook.getAccountsByFilter(filter);
  
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
  function filterType(){
  	document.access.action = "templateview.jsp";
  	document.access.submit();
  }
  
  function goEdit(id){
  	path = "templateAction.jsp?ID="+id;
  	document.location = path;
  }
  
  function goNew(){
  	type = document.access.templateType.options[document.access.templateType.selectedIndex].value;
	if(type == "all") {
		path = "templateAction.jsp?NO_TEMPLATE=noTemplate";	
  		document.location = path;
	}else {
		path = "templateAction.jsp?TEMPLATE_TYPE=" + type;	
  		document.location = path;
  	};
  }
  
  function doDelete(id){
  	type = document.access.templateType.options[document.access.templateType.selectedIndex].value;
  	path = "templateRemoveAction.jsp?ID=" + id + "&TYPE=" + type;
  	document.location = path;
  }
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
  <!--    <tr>
        <td valign="top" style="border-left: 1px solid #FF9900; border-right-width: 1; border-top-width: 1; border-bottom-width: 1" height="1">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="TOPLEFTBORDER " width="33%"  height="2"></td>
            <td class="TOPBORDER" width="33%" height="2"></td>
            <td class="TOPRIGHTBORDER"  width="34%" height="2"></td>
          </tr>
        </table>
        </td>
      </tr>-->
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Template Book</span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td><span class="REGULARTEXT">View Templates from type <span class="REGULARTEXT">
                    <select class="TEXTBOX" size="1" name="templateType" onchange="javascript:filterType()">
                        <option value="all">All</option>
                        <option value="FtpMedia" <%=ftpselect%>>Ftp</option>
                        <option value="SshMedia" <%=sshselect%>>Ssh</option>
                        <option value="FSMedia" <%=fsselect%>>File System</option>
                        <option value="MailMedia" <%=emailselect%>>eMail</option>
                        <!--<option value="sms" <%=smsselect%>>SMS</option>-->

                      </select></td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td><span class="REGULARTEXT"><a href="javascript:goNew()" class="LINK">Add new Template</a></span></td>
                  </tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr class="TABLES_HEADERS"> 
                        <td width="18%"><span class="REGULARTEXT">Name</span></td>
                        <td width="50%"><span class="REGULARTEXT">Description</span></td>
                        <td width="15%"><span class="REGULARTEXT">Type</span></td>
                        <td width="20%">&nbsp;</td>
                        <td width="3%"></td>
                      </tr>
                     <%
                      for(int t=0;t<list.size();t++){
                     %>
                      <tr>
			  <td width="16%"><a href="javascript:goEdit('<%=((Media)list.get(t)).getId()%>')" class="LINK"><%=((Media)list.get(t)).getMediaName()%></a></td>
			  			  <td width="50%"><span class="REGULARTEXT"><%=((Media)list.get(t)).getDescription()%></span></td>
                          <td width="15%"><span class="REGULARTEXT"><%=((Media)list.get(t)).getType()%></span></td>
                          <td width="20%" nowrap>&nbsp;<a href="javascript:goEdit('<%=((Media)list.get(t)).getId()%>')" class="LINK">edit</a>
                            <a href="javascript:doDelete('<%=((Media)list.get(t)).getId()%>')" class="LINK">delete</a></td>
                        <td width="10%"></td>
                       </tr>
                      <%
                        }
                      %>
                        <tr>
			  <td width="16%">&nbsp;</td>
                          <td width="50%"></td>
                          <td width="24%"></td>
                         <td width="10%"></td>
                       </tr>
                    </table>
                   </td>
                  </tr>
                  <tr>
                    <td></td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
                  <tr>
                    <td width="35%">&nbsp;</td>
                    <td width="13%" align="center"><a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK">
                    cancel</a></td>
                    <td width="5%" align="center"></td>
                    <td width="27%">&nbsp;</td>
                    <td width="20%">&nbsp;</td>
                  </tr>
                </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>