<%@ page import="xpolog.config.*" %>
<%@ page import="xpolog.eye.*" %>
<%@ page import="xpolog.eye.managment.*" %>
<%@ page import="xpolog.eye.menu.*" %>
<%@ page import="xpolog.eye.security.*" %>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.site.portal.UserPortalManager"%>
<%@ page import="xpolog.eye.site.widgets.view.WidgetsView"%>
<%@ page import="xpolog.eye.site.widgets.XpoLogWidgetsManager"%>
<%@ page import="xpolog.eye.util.ui.html.HtmlDisplayItem"%>
<%@ page import="xpolog.eye.util.ui.html.HtmlDisplayItemRepresentationRequest"%>
<%@ page import="xpolog.eye.util.ui.html.ScriptItem"%>
<%@ page import="xpolog.eye.util.XpologUtil"%>

<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>

<%!
	static final String BASE_DIRECTORY = "";
%>
<%  
  
	WebSecurityManager manager = WebSecurityManager.getInstance();
  UserSecurity user = manager.getUserSecurity(request);
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  ApplicationComponent selectedComp = env.getSelectedComponent(user);
  String selectedCompId = selectedComp == null? "" : selectedComp.getId();
  String selectedCompName = selectedComp == null? "" : selectedComp.getName();
  ComponentMenu model = ComponentMenu.getInstance(selectedComp.getTopMenu().getFilePath());
  List groups = model.getMenuGroupList(user);
  int number  = groups.size();
  List comps = SiteManagment.getInstance().getApplicationComponentsManager().getVisibleApplicationComponents(user);
  boolean showComps = comps.size() > 1;
  
  boolean hasDashboardsPermission = manager.checkForPermission(request,response,ActionsPermissionConstants.DashboardsPermissions.DASHBOARDS_PERMISSION,false);
  boolean hasViewDashboardsPermission = manager.checkForPermission(request,response,ActionsPermissionConstants.DashboardsPermissions.VIEW_DASHBOARDS_PERMISSION,false);
  boolean hasEditDashboardPermission = manager.checkForPermission(request,response,ActionsPermissionConstants.DashboardsPermissions.EDIT_DASHBOARD_PERMISSION,false);
  boolean dashboardsValid = SiteManagment.getInstance().getXpologManagment().isDashboardsValid();
  
  boolean secureActive = false;
	if (user != null && user.isShowLogout()) {
		secureActive = true;
	}
	
	String homeStr = request.getParameter("showHome");
	boolean showHome = homeStr == null || !homeStr.equals("false");
	
	String helpStr = request.getParameter("showHelp");
	boolean showHelp = false && (helpStr == null || !helpStr.equals("false"));
	boolean valid = SiteManagment.getInstance().getXpologManagment().isValidToBeActive();	
	boolean isDemo = XpologLicenseManager.getInstance().isDemo();
	boolean userMessageEnabled = !Configuration.isWar() &&  (isDemo || Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("userMessage.enable",false));
	
	boolean showUserMessages = request.getSession().getAttribute("showUserMessages") != null;
	
	UserPortalManager userPortalMgr = UserPortalManager.getInstance();
	HtmlDisplayItemRepresentationRequest repRequest = new HtmlDisplayItemRepresentationRequest();
	UserContext userContext = UserEnvironment.getUserContext(request);
	repRequest.setUserContext(userContext);
	String mainSelectionHtml = userPortalMgr.getMainSelectionItemHtml(repRequest);
	ScriptItem[] scripts = userPortalMgr.getAllScriptItems();
	
%>

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/menus.css"/>
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css"/>
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/portal.css" />
<script type="text/javascript" src="<%=BASE_DIRECTORY%>scripts/help/help.js"></script>
<%
if (scripts != null && scripts.length > 0){
	for (int i = 0; i < scripts.length; i++){
%>
<script type="text/javascript" src="<%=BASE_DIRECTORY + scripts[i].getSrc()%>"></script>
<%}
}%>

<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxMenu/codebase/skins/dhtmlxmenu_dhx_skyblue.css">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxMenu/codebase/xplgdhtmlxmenu.css">
<script type="text/javascript" src="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxMenu/codebase/dhtmlxcommon.js"></script>
<script type="text/javascript" src="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxMenu/codebase/dhtmlxmenu.js"></script>
<script type="text/javascript" src="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxMenu/codebase/ext/dhtmlxmenu_ext.js"></script>
<script type="text/javascript" src="<%=BASE_DIRECTORY%>dhtmlxSuite/dhtmlxMenu/codebase/xplgMenus.js"></script>

<script>

	function logOut(){
  	document.location="<%=BASE_DIRECTORY%>security/auth/logoutAction.jsp";
	}
	
	function openUserSearchDiv(page,params,progressTitle,progressMsg){
		openGeneralDiv(page,params,progressTitle,progressMsg);			  
	}

<%
String homePage = request.getParameter("homePage");
boolean isHome = false;
if(homePage != null && homePage.equals("homePage")) {
  isHome = true;
}

String dashboardsUrlBase = "";
String dashboardTarget = "";
if(isHome) {
	dashboardsUrlBase = "componentAction.jsp?selectedCompId=XpoLog&forward=root.jsp%3FhideManagementPage=true%26mainPage=portal/widgets/view/widgetsPortalView.jsp?fullPage=true";
}else {
	dashboardsUrlBase = "portal/widgets/view/widgetsPortalView.jsp?fullPage=true";
	dashboardTarget = "main";
}
%>
		
</script>

<script src="scripts/common/messages.js" type="text/javascript"></script>
<script src="scripts/common/progress.js" type="text/javascript"></script>
<% if (userMessageEnabled){ 
  String messagesDiffTime = Configuration.getInstance().getPropertiesManager().getProperty("userMessage.messagesDiffTime","60000");
  String timeBetweenMessages = Configuration.getInstance().getPropertiesManager().getProperty("userMessage.timeBetweenMessages","2000");
  String initFirstMessageTime = Configuration.getInstance().getPropertiesManager().getProperty("userMessage.initFirstMessageTime","5000");

%>
<jsp:include page="widgets/balloon/jsp/balloonHeaderIncluder.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<jsp:include page="portal/userMessagesDiv.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<script>
var showMessages = false;
var rssXMLMessage; 
function showRSSMessage(){
  try {
    window.clearTimeout(showRSSMessage);
  }catch (err){}
  try {
    window.clearTimeout(waitForHide);
  }catch (err){}
  if (document.getElementById("userMessagesDiv").style.display == ""){
    setTimeout("showRSSMessage()",<%=timeBetweenMessages%>);
    return;
  }
  var params = "";
	var page = "common/systemMessagesRSS.jsp?newOnly=true&max=1&useTips=true&addResult=true&relative=true";
	sendAjaxRequest(page,function(req){
		 var xmldoc = req.responseXML.documentElement;
		 if (!xmldoc) {
		   setTimeout("showRSSMessage()",<%=messagesDiffTime%>);
		   return;
		 }
		  
		   var rssXML = xmldoc;	
		   var resultArr = xmldoc.getElementsByTagName('Result');		  
		   if (resultArr && resultArr.length > 0){
		      var showMsgArr = resultArr[0].getElementsByTagName('showUserMessages');		  
		      if (showMsgArr && showMsgArr.length > 0){
		        showMessages = showMsgArr[0].firstChild.nodeValue == "true";
		      }
		     rssXML = xmldoc.getElementsByTagName('rss')[0];
		   }   				  
		   	  
		   if (rssXML){
        var channelXMLArr = rssXML.getElementsByTagName('channel');
 			  var channelXML;
  			if (channelXMLArr && channelXMLArr.length > 0){
    			
    	    rssXMLMessage =  buildRSSMessage(rssXML);    	    
    	    if (rssXMLMessage && rssXMLMessage != ""){
    	      document.getElementById("feedImage").style.display="";    	          	      
    	      showRSSMessage0(); 	
    	      window.setTimeout("waitForHide()",<%=timeBetweenMessages%>);
    	    }else {     	         	     
    	      setTimeout("showRSSMessage()",<%=messagesDiffTime%>);
    	    }
  			}         
			}	
		  	  		         
			//setTimeout("showRSSMessage0()",10000);
	},'POST',params); 
}




function fireEvent(obj,evt){

var fireOnThis = obj;
if( document.createEvent ) {
var evObj = document.createEvent('MouseEvents');
evObj.initEvent( evt, true, false );
fireOnThis.dispatchEvent(evObj);
} else if( document.createEventObject ) {
fireOnThis.fireEvent('on'+evt);
}
}


var doShowBalloon = false;
function showRSSMessage0(){
  doShowBalloon = true;
  fireEvent(document.getElementById("feedImage"),"click");
}

function showBalloon(event){
  var x = document.body.clientWidth - 100;
  var y = 10;
  hideAllTooltips(); 
	if(doShowBalloon){
	  doShowBalloon = false;    
    whiteBalloon.absoluteX =  x; 
    whiteBalloon.absoluteY = y;
    if (rssXMLMessage && rssXMLMessage != ""){     
      whiteBalloon.showTooltip(event,rssXMLMessage,false);
    }
  }else {
    x = x - parseInt(document.getElementById("userMessagesDiv").style.width) - 10;
    y = y + 10; 
    getUserMessages(x,y);
  }
  //rssXML = null;
}

function waitForHide(){ 
  var el = document.getElementById("balloon");
  if (el && el.style.display == "none"){
    onHide();
  }else {
    window.setTimeout("waitForHide()",<%=timeBetweenMessages%>);
  }
}

function onHide(){ 
 if (!showMessages){
   document.getElementById("feedImage").style.display="none";
 }
 setTimeout("showRSSMessage()",<%=timeBetweenMessages%>);
}

setTimeout("showRSSMessage()",<%=initFirstMessageTime%>);
</script>
<%}%>

<table width="100%" height="100%" cellspacing="0" cellpadding="0" border="0">
<tr height="20">
<td width="100%" align="left" style="padding-left:10">
<iframe name="keepalive" style="display:none" width="0" height="0" src="<%=BASE_DIRECTORY%>security/common/keepAlive.jsp"></iframe>
<table width="100%" height="100%" cellspacing="0" cellpadding="0" border="0">
<tr>
<%
for(int j=0;j< comps.size();j++){
   ApplicationComponent comp = (ApplicationComponent)comps.get(j);
   if (!comp.isVisible()){
     continue;
   }   
   String compId = comp.getId();
   boolean isEnable = comp.isValid(user);
   boolean isSelected = comp.getId().equals(selectedCompId);
   String link = BASE_DIRECTORY+"componentAction.jsp?selectedCompId=" + compId + "&timestamp=" + System.currentTimeMillis();
   String img = comp.getCompImage();
   if(isSelected && !isHome) {
	   img = BASE_DIRECTORY + comp.getSelectedCompImage();
   }else if(!isEnable) {
	   img = BASE_DIRECTORY + comp.getCompDisabledImg();
   }
   %>
   <%if (valid){%>
   <td valign="bottom" width="20" height="20"><a href="<%=link%>"><img src=<%=img%> border="0"></a></td>
   <%} %>
<%
  }	
%>
<%if (mainSelectionHtml != null){%>
<td style="padding-left:15">
<%=mainSelectionHtml%>
</td>
<%}%>
<td align="right"  width="*" style="padding-right:15;ont-size:2pt">&nbsp;</td>
<td  width="20" align="right"  width="*" style="padding-right:15;padding-top:3" ><img id="feedImage" src="images/ui/feed-icon.png" onClick="showBalloon(event)" height="19" border="0" onmouseover="this.style.cursor='pointer'" style="display:<%=showUserMessages? "" : "none"%>"></td>
<td width="40" align="right"  width="*" style="padding-right:15"><a href="http://www.xplg.com" target="XPLG"><img src="images/tabs/xplg_logo.gif" height="19" border="0"></a></td>
</tr>
</table>
</td>
</tr>
<tr bgcolor="#7E89DC" height="7"><td valign="top" ></td></tr>
<tr >
<td>
<table width="100%" cellspacing="0" cellpadding="0" border="0">
<tr>
<td style="width:70%">
<div id="main_menu"></div>
</td>
<td style="width:30%">
<div id="secondary_menu"></div>
</td>
</tr>
</table>
</td>
</tr>
</table>
<script> 
        //init menu
        
        
        <%
        String prevId = selectedCompName.equalsIgnoreCase("xpolog") ? "dashboards" : "dashboardsSeparator";
        if (valid){%>
	        menuObject=new dhtmlXMenuObject('main_menu');
	        menuObject.setIconsPath("dhtmlxSuite/dhtmlxMenu/codebase/imgs/dhxmenu_dhx_web/");
	        menuObject._doOnClick = xplgDoOnClick;
	        
	        secondaryMenuObject=new dhtmlXMenuObject('secondary_menu');
	        secondaryMenuObject.setIconsPath("dhtmlxSuite/dhtmlxMenu/codebase/imgs/dhxmenu_dhx_web/");
	        secondaryMenuObject.setAlign("right");
			    
	        <%
	        boolean showWidgetsMenu = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("widgets.showMenu",true);
	        
	        if (dashboardsValid && showWidgetsMenu && (hasViewDashboardsPermission || hasEditDashboardPermission)){%>
	        	menuObject.addNewSibling(null, "dashboards", "Dashboards", false);
	        	var position = 0;
						<%
						WidgetsView[] views = XpoLogWidgetsManager.getIntsance().getWidgetsViewList(request,WidgetsView.PORTAL_VIEW_TYPE);
						for (int i = 0; hasViewDashboardsPermission && i < views.length;i++){
							int maxDashboardNameLength = 50;
							String dashboardName = XpologUtil.replaceAll(views[i].getName(), "'", "\\'");
							if(dashboardName.length() > maxDashboardNameLength) {
								dashboardName = dashboardName.substring(0, maxDashboardNameLength);
								dashboardName += "...";
							}
							String dashboardLink = isHome ?
									dashboardsUrlBase + "%2526selectedView=" + views[i].getId() : 
									dashboardsUrlBase + "&selectedView=" + views[i].getId();
						%>
							menuObject.addNewChild("dashboards", position++, "subdashboards<%=views[i].getId() %>", "<%=dashboardName %>");
							menuObject.setHref("subdashboards<%=views[i].getId() %>", "<%=dashboardLink %>", "<%=dashboardTarget %>");
						<%
						}
						if(views.length > 0) {
						%>
							menuObject.addNewSeparator("subdashboards<%=views[views.length - 1].getId() %>");
							position++;
						<%
						}
						if (hasEditDashboardPermission){
			      	String addNewDashboardLink = isHome ?
									dashboardsUrlBase + "%2526addNewDashboard=true" : 
									dashboardsUrlBase + "&addNewDashboard=true";
			      %>
			        	menuObject.addNewChild("dashboards", position++, "subdashboardsAdd", "Add New Dashboard");
			        	menuObject.setHref("subdashboardsAdd", "<%=addNewDashboardLink %>", "<%=dashboardTarget %>");
			      <%
			      }
						if (hasViewDashboardsPermission){
							String manageDashboardsLink = isHome ?
									"componentAction.jsp?selectedCompId=XpoLog&forward=root.jsp%3FhideManagementPage=true%26mainPage=portal/widgets/admin/portalViews.jsp?fullPage=true" :  
									"portal/widgets/admin/portalViews.jsp?fullPage=true";
						%>
			        	menuObject.addNewChild("dashboards", position++, "subdashboardsManage", "Manage Dashboards");
			        	menuObject.setHref("subdashboardsManage", "<%=manageDashboardsLink %>", "<%=dashboardTarget %>");
			        <%}%>
		        
		        <%
		        if(!isHome && !selectedCompName.equalsIgnoreCase("xpolog")) {
		        %>
		        	menuObject.addNewSeparator("dashboards", "dashboardsSeparator");
		        <%
		        }
	        }else {
	        	prevId = null;
            
          }
        }
        if (!isHome && valid){
	        
	        for(int i=0;i<number;i++){
	        	MenuGroup grp = (MenuGroup)groups.get(i);
			      String name = grp.name;
			      String id = grp.id;
			      String target = grp.target == null ? "main" : grp.target;
			      String link = grp.link == null || grp.link.length() == 0 ? "" : BASE_DIRECTORY + grp.link;
						int entries = grp.items.size();
			      %>
			      	//create menu item
			      	menuObject.addNewSibling(<%=prevId == null ? "null" : "\"" + prevId + "\""%>, "<%=id%>", "<%=name%>", false);
			      <%
			      if(link.length() > 0) {
			      %>
			      	menuObject.setHref("<%=id%>", "<%=link %>", "<%=target %>");
						<%
	        	}
							prevId = id;
							if (entries > 0){
								MenuItem it = null;
								for(int t=0;t < entries;t++){
									it = (MenuItem)grp.items.get(t);
									String itemId = it.id;
									String itemName = it.name;
									String itemLink = BASE_DIRECTORY + it.link;
									String itemTarget = it.target == null ? "main" : it.target;
								%>
									menuObject.addNewChild("<%=id %>", <%=t %>, "<%=itemId %>", "<%=itemName %>");
									menuObject.setHref("<%=itemId %>", "<%=itemLink %>", "<%=itemTarget %>");
								<%
								}
							}
							// Add divider between log actions and administration
							if (id.equalsIgnoreCase("LogActions")){
							%>
								menuObject.addNewSeparator("LogActions", "logactionsSeparator");
							<%
								prevId = "logactionsSeparator";
							}
	        	}
		    }
		    
        String username = null;
				if(user != null && user.getUser() != null) {
					username = user.getUser().getDisplayName();
				}
				String previousId = null;
				if(username != null) {
				%>
					secondaryMenuObject.addNewSibling(<%=previousId == null ? null : "\"" + previousId + "\"" %>, "username", "Logged in as <%=username %>", true);
        <%
        	previousId = "username";
        	if(showHome || showHelp || secureActive) {
        		// show the divider line only if there is another entry in the menu
        %>
        	secondaryMenuObject.addNewSeparator(<%=previousId == null ? null : "\"" + previousId + "\"" %>, "usernameSeparator");
				<%
					previousId = "usernameSeparator";
        	}
				}
				if (showHome){
				%>
					secondaryMenuObject.addNewSibling(<%=previousId == null ? null : "\"" + previousId + "\"" %>, "home", "Home", false);
					secondaryMenuObject.setHref("home", "home.jsp");
				<%
					previousId = "home";
				}
				if (showHelp){
				%>
					secondaryMenuObject.addNewSibling(<%=previousId == null ? null : "\"" + previousId + "\"" %>, "help", "Help", false);
				<%
					previousId = "help";
				} 
				if(secureActive) { 
				%>
					secondaryMenuObject.addNewSibling(<%=previousId == null ? null : "\"" + previousId + "\"" %>, "logout", "Logout", false);
					secondaryMenuObject.setHref("logout", "javascript:logOut()");
				<%} %>
		     
</script>

