<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="java.util.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>
<%
	if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)){
    return;
    }
    
	//the page title
	String headerTitle = "CSS Definition";
	String footerTitle = "&nbsp;";
	//site management
    HeadersAndFootersManager headersAndFootersManager = Configuration.uiResourcesManager.getHeadersAndFootersManager();
    
    UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
    
	//get the saved path of the header and footer.
	String savedHeaderPath = headersAndFootersManager.getSavedHeaderPath(user);
	String savedFooterPath = headersAndFootersManager.getSavedFooterPath(user);
%>      
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
</head>

<body>
<form AUTOCOMPLETE="OFF" name="access" id="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
       <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="181">
              <tr>
              <td>
                  <jsp:include page="<%=savedHeaderPath%>" flush="true">
				    <jsp:param name="headerTitle" value="<%=headerTitle%>" />
			      </jsp:include>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="17"></td>
                <td width="124%" colspan="2" height="17">
                <span class="REGULARTEXT">The cascading style sheet file of 
                XpoLog defines the backgrounds, the html tables properties, the menus and 
                the font's properties.</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><span class="REGULARTEXT">You may edit these files 
                according to the explanations in this page or replace them with 
                your own css files.</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18">
                <span class="REGULARTEXT">You can find the css files under the 
                following path:  
                \XpoLog\defaultroot\logeye\css\.<br> Before editing the css files, don't forget to make copies of the default definitions files.</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18">
                <span class="SMALLTEXT">Note: you will find several css files under the css directory <br>
                mainproduct.css - this is the main file that effects the product's screens.<br>
                menus.css - this is the file that effects the menus on the left side of XpoLog's screen.<br>
                progressBar.css - this is the file that effects the progressBar when it displayed on continuous actions.<br>
                jsdomenu.css - this is the file that effects on the filter menu in the log viewer.<br>
                 </span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><span class="HEADER">CSS Functions</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="16"></td>
                <td width="124%" colspan="2" height="16"><span class="REGULARTEXT">&quot;body&quot; - This function 
                represents the properties of the html body. Editing this 
                function will effect all the pages in XpoLog.</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><span class="REGULARTEXT">&quot;TOPLEFTRIGHTBORDER&quot;, &quot;TOPBORDER&quot;, 
                &quot;TOPLEFTBORDER&quot;, &quot;TOPRIGHTBORDER&quot; - These functions represent 
                the properties of the header of each page.</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><span class="REGULARTEXT">&quot;BOTTOMBORDER&quot;, &quot;BOTTOMLEFTBORDER&quot;, 
                &quot;BOTTOMRIGHTBORDER&quot; - These functions represent the properties 
                of the footer of each page.</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><span class="PAGEHEADER">&quot;PAGEHEADER&quot;</span><span class="REGULARTEXT"> - This 
                function represents the font's properties of the String which is 
                planted in the header of each page in XpoLog.</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><span class="HEADER">&quot;HEADER&quot;</span><span class="REGULARTEXT"> - This 
                function represents the font's properties of the titles in 
                XpoLog.</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><span class="REGULARTEXT">&quot;REGULARTEXT&quot; - This 
                function represents the font's properties of regular text in 
                XpoLog (mostly used!).</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><span class="SMALLTEXT">&quot;SMALLTEXT&quot;</span><span class="REGULARTEXT"> - This 
                function represents the font's properties of the small text in 
                XpoLog..</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><span class="REGULARTEXT">&quot;TEXTBOX&quot; - This 
                function represents the font's properties of the text in text 
                boxes and text areas.</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><span class="ERRORMESSAGE">&quot;ERRORMESSAGE&quot;</span><span class="REGULARTEXT"> - This 
                function represents the font's properties of Error messages in XpoLog.</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><span class="OKMESSAGE">&quot;OKMESSAGE&quot;</span><span class="REGULARTEXT"> - This 
                function represents the font's properties of text that indicates of a valid code in XpoLog.</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><a class="LINK" href="editcss.jsp">&quot;LINK&quot;</a><span class="REGULARTEXT"> - This 
                function represents the font's properties of a regular link's text in XpoLog.</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><a class="MEDIUMLINK" href="editcss.jsp">&quot;MEDIUMLINK&quot;</a><span class="REGULARTEXT"> - This 
                function represents the font's properties of a medium link's text in XpoLog.</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><a class="SMALLLINK" href="editcss.jsp">&quot;SMALLLINK&quot;</a><span class="REGULARTEXT"> - This 
                function represents the font's properties of a small link's text in XpoLog.</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><span class="LICENSEMESSAGE">&quot;LICENSEMESSAGE&quot;</span><span class="REGULARTEXT"> - This 
                function represents the font's properties of license related messages.</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><span class="LOGVIEWTABLEHEADER">&quot;LOGVIEWTABLEHEADER&quot;</span><span class="REGULARTEXT"> - This 
                function represents the font's properties of the columns titles in the log view table of XpoLog.</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><span class="REGULARTEXT">&quot;a:link&quot;,  
                &quot;a:visited&quot;, &quot;a:hover&quot;, &quot;a:active&quot; - These 
                functions represent the behavior of links in&nbsp; XpoLog (How 
                will links appear after being visited, when hovered on and 
                general).</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="35%">&nbsp;</td>
                <td width="18%" align="center">
                <a class="LINK" href="uisetcenter.jsp">Back to the UI Center</a></td>
                <td width="27%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
          <jsp:include page="<%=savedFooterPath%>" flush="true">
		      <jsp:param name="footerTitle" value="<%=footerTitle%>" />
			</jsp:include>
            
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>
</html>