<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.security.*"%>

<%@ page import="java.util.*"%>
<%@ page import="java.text.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)){
    return;
  }

  Properties prop = Configuration.getInstance().getUIData();
  Enumeration keyenum = prop.keys();
  ArrayList list = new ArrayList();
  while(keyenum.hasMoreElements()){
	list.add((String)keyenum.nextElement());
  }
  Object[] keysArr = list.toArray();
  Arrays.sort(keysArr);
  
  //the page title
  String headerTitle = "UI Data Settings";
  String footerTitle = "&nbsp;";
  //site management
  HeadersAndFootersManager headersAndFootersManager = Configuration.uiResourcesManager.getHeadersAndFootersManager();
 
  UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
    
  //get the saved path of the header and footer.
  String savedHeaderPath = headersAndFootersManager.getSavedHeaderPath(user);
  String savedFooterPath = headersAndFootersManager.getSavedFooterPath(user);
%>

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script>
  function doSave(){
    document.access.action="imagessetAction.jsp";
    document.access.submit();
  }
</script>
</head>

<body>
<form AUTOCOMPLETE="OFF" name="access" id="access" method="post">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
              <tr>
                <jsp:include page="<%=savedHeaderPath%>" flush="true">
				  <jsp:param name="headerTitle" value="<%=headerTitle%>" />
			  </jsp:include>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="24%">&nbsp;</td>
                <td width="100%">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0"  width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"><span class="HEADER">UI Data Properties</span></td>
                  </tr>
                  <tr>
                    <td>

                    &nbsp;

                    </td>
                  </tr>
                  <tr>
                    <td>

                    <table border="0" width="100%" cellspacing="1">
                      <tr>
                        <td width="20%" align="center"><span class="REGULARTEXT"><b>Property</b></span></td>
                        <td width="20%" align="center"><span class="REGULARTEXT"><b>Value</b></td>
                        <td width="20%" align="center"><span class="REGULARTEXT"><b>New Value</b></td>
                        <td width="20%" align="center"><span class="REGULARTEXT"><b>Visualization</b></td>
                        <td></td>
                      </tr>
                      <%
                        String key = null;
                        String value = null;
                        String color = "";
                        String img = "";
                        for(int t=0;t<keysArr.length;++t){
                          String description = "";
                          String tmpDescription = "";
                          img = "";
                          color = "";
                          key = (String)keysArr[t];
                          if (key.startsWith("xpolog.app")){
                            continue;
                          }
                          value = prop.getProperty(key);
                          tmpDescription = prop.getProperty(key+".description");
                          if(key.endsWith("description")) {
                          	continue;
                          }else if(tmpDescription != null){
                          	description = "<b>Description: </b>"+tmpDescription;
                          }else{
                          	description = "&nbsp;";
                          }
                          if(key.endsWith("image")){
                            img = "<img src=\"" + BASE_DIRECTORY + value +"\">";
                          }else if(key.endsWith("color") || key.endsWith("bgcolor")){
                            color = "bgColor=\"" + value +"\"";
                          }  
                      %>
                        <tr>
                          <td width="20%"><span class="SMALLTEXT"><b><%=key%></b></span></td>
                          <td width="20%"><span class="SMALLTEXT"><%=value%></span></td>
                          <td width="20%"><input type="text" name="<%=key%>" id="<%=key%>" size="25"></td>
                          <td width="20%" <%=color%> >&nbsp;<%=img%></td>
                          <td></td>
                        </tr>
                        <tr>
                           <td colspan="4"><span class="SMALLTEXT"><%=description%></span></td>
                        </tr>
                      <%
                        }
                      %>
                      <tr>
                        <td width="20%"></td>
                        <td width="20%"></td>
                        <td width="20%"></td>
                        <td width="20%"></td>
                        <td></td>
                      </tr>
                      <tr>
                        <td width="20%"></td>
                        <td width="20%"></td>
                        <td width="20%"></td>
                        <td width="20%"></td>
                        <td></td>
                      </tr>
                    </table>

                    </td>
                  </tr>

                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="25%">&nbsp;</td>
                <td width="13%" align="center">
                <p align="left"><a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK">
                cancel</a></td>
                <td width="11%" align="center">
                <p align="left"><a href="javascript:doSave()" class="LINK">save</a></td>
                <td width="31%"><a href="uisetcenter.jsp" class="LINK">back to UI center</a></td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <jsp:include page="<%=savedFooterPath%>" flush="true">
	<jsp:param name="footerTitle" value="<%=footerTitle%>" />
</jsp:include>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>