<%@ page language="java"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.logview.*"%>
<%@ page import="omega.ui.models.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="omega.ui.html.table.OHtmlTable"%>


<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%!
  static final String BASE_DIRECTORY = "../";
%>
<%
	if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.UI_SETTINGS_PERMISSION,true)){
    return;
    }
    
	//the page title
	String headerTitle = "UI Settings Center";
	String footerTitle = "&nbsp;";
	
    //site management
    HeadersAndFootersManager headersAndFootersManager = Configuration.uiResourcesManager.getHeadersAndFootersManager();
    
    UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
    
	//get the saved path of the header and footer.
	String savedHeaderPath = headersAndFootersManager.getSavedHeaderPath(user);
	String savedFooterPath = headersAndFootersManager.getSavedFooterPath(user);
%>
<html>
<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

</head>

<body>
<form AUTOCOMPLETE="OFF" name="access" id="access" method="post">
<input type="hidden" name="copyToTmp" value="on">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
       <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="183">
              <tr>
                <td>
                  <jsp:include page="<%=savedHeaderPath%>" flush="true">
				    <jsp:param name="headerTitle" value="<%=headerTitle%>" />
			      </jsp:include>
                </td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="17"></td>
                <td width="124%" colspan="2" height="17"><span class="REGULARTEXT">Welcome 
                to XpoLog's UI center. In this page you will find explanations 
                and examples of how to edit XpoLog's skin.</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><span class="REGULARTEXT">You have 
                the following options:</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><span class="SMALLTEXT">Note: If 
                you choose not to edit some or all of the above, XpoLog will use 
                it's default definitions.</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18">
                <span class="HEADER">CSS definition</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18">
                <span class="REGULARTEXT">In this section you can edit the css 
                files of XpoLog.<br>
                If you wish to edit the CSS, follow this link: 
                <a href="editcss.jsp" class="LINK">Edit CSS File</a></span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><span class="HEADER">Images Settings</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18">
                <span class="REGULARTEXT">In this section you can replace 
                XpoLog's images.<br>
                If you wish to edit the images definitions, follow this link:
                <a class="LINK" href="imagesset.jsp">Edit Images</a></span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <!--<tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><span class="HEADER">Headers and Footers 
                Settings</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18">
                <span class="REGULARTEXT">In this section you can create a 
                header and/or a footer to XpoLog's skins.<br>
                If you wish to edit the Header and/or Footer, follow this 
                link: <a href="headersandfootersset.jsp?COPY_TO_TMP=copy" class="LINK">Edit 
                Headers and Footers</a></span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><span class="HEADER">
                Strings</span></td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"><span class="REGULARTEXT">
                In this section you can edit some of the strings used in XpoLog.<br>
                If you wish to edit the strings, follow this link:
                <a class="LINK" href="editstrings.jsp">Edit Strings</a></span></td>
              </tr>-->
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18">
                <p></p>
                <p></p>
                <p></p>
                <p></p>
                <p></p>
                <p></p>
                <p></p>
                <p></p>
                <p></p>
                <p><br>
                <br>
&nbsp;</p>
                <p></p>
                <p></p>
                <p></p>
                <p></p>
                <p><br>
                <br>
                <br>
                <br>
                <br>
                <br>
                <br>
                <br>
                <br>
&nbsp;</td>
              </tr>
              <tr>
                <td width="3%" height="18"></td>
                <td width="124%" colspan="2" height="18"></td>
              </tr>
              </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" height="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber7">
              <tr>
                <td width="35%">&nbsp;</td>
                <td width="21%" align="center">
                <a class="LINK" href="<%=BASE_DIRECTORY%>logEyePortal.jsp">Back to XpoLog</a></td>
                <td width="24%">&nbsp;</td>
                <td width="20%">&nbsp;</td>
              </tr>
            </table>
            </td>
          </tr>
        </table>
        </td>
      </tr>
      <tr valign="bottom">
        <td valign="bottom" height="10%">
           <jsp:include page="<%=savedFooterPath%>" flush="true">
		      <jsp:param name="footerTitle" value="<%=footerTitle%>" />
			</jsp:include>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>