<%@page import="xpolog.eye.admin.builders.OnlineDBSimpleLogBuilder"%>
<%@page import="omega.ui.models.tree.ODefaultMutableTreeNode"%>
<%@page import="xpolog.eye.menu.ModulesMenuLoader"%>
<%@page import="omega.ui.html.tree.ODefaultTreeCellRenderer"%>
<%@page import="xpolog.eye.error.ErrorModel"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.verifiers.LogVerifier"%>
<%@ page import="xpolog.eye.verifiers.VerifierManager"%>
<%@ page import="xpolog.eye.site.ui.tree.ModuleMemberRenderer"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.util.*"%>

<%
	String VERIFIER_ID = "VERIFIER_ID";
	String LOG_ID = "LOG_ID";

	//site management
	SiteManagment mgmt = SiteManagment.getInstance();
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);

	LogVerifier verifier = new LogVerifier();
	String verId = request.getParameter(VERIFIER_ID);
	String logId = request.getParameter(LOG_ID);
	
	VerifierManager verManager = SiteManagment.getInstance().getVerifierManager();
	LogBrowsingManager lbm = new LogBrowsingManager();
	String selectedLogId = "";
	String selectedFilterId = "";
	
	if (logId != null && logId.length() > 0){
		selectedLogId = logId;
	}
	if (verId != null && verId.length() > 0){
	  verifier = (LogVerifier)verManager.getVerfierFromId(verId);
	  if (logId == null || logId.equals(""))
			selectedLogId = verifier.getLogId();
	}

	if (verId != null && verId.length() > 0){
		selectedFilterId = verifier.getLogFilterId();
	}
	
	Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
	HashMap logsMap = null;
	HashMap modulesMap = null;
	HashMap filtersMap = null;
	if (selectedLogId != null){
		logsMap = new HashMap();
		logsMap.put(selectedLogId,selectedLogId);
		modulesMap = new HashMap();
		ModuleMemberRenderer.addModuleMemberParents(modulesMap, logsMap);		
		if (selectedFilterId != null){
			filtersMap = new HashMap();
			filtersMap.put(selectedFilterId,selectedFilterId);
		}
	}
	
	boolean treeNodeExists = false;
	String treeXml = ""; 
  String id = request.getParameter("id");
  String type = null;
  if (id != null){
  	int ind = id.indexOf("-");
  	if (ind != -1){
  		type = id.substring(0,ind);
  		id = id.substring(ind+1);
  	}
  	if (type != null){
  		if (type.equals(XpoLogObjectTypes.MODULE_TYPE)){
  			try{
  			curmod = SiteManagment.getInstance().getModuleFromId(id);
  			treeNodeExists = true;
  			}catch(Exception e){
  				ErrorModel.log.error("Failed to load folders tree for folder " + id,e);
  			}
  		}else if (type.equals(XpoLogObjectTypes.LOG_TYPE)){
  			try{
	  			lbm = mgmt.getLogBrowserManager(id,true,false,true);
  			}catch(Exception e){
  				ErrorModel.log.error("Failed to load folders tree for log " + id,e);
  			}
  		}
  	}
  }
  
	String [] ignoreTypes = {OnlineDBSimpleLogBuilder.ONLINE_DB_CACHE_LOG_TYPE};
	if (type != null && type.equals(XpoLogObjectTypes.LOG_TYPE) && lbm != null){
		ODefaultTreeCellRenderer cr = new ODefaultTreeCellRenderer();
		ModulesMenuLoader modMenuLoader = new ModulesMenuLoader();
		modMenuLoader.setShowFilters(true);		
		ODefaultMutableTreeNode node = (ODefaultMutableTreeNode)modMenuLoader.createMutableNodeFromLog(lbm,userContext,env);
		treeXml = cr.renderNode(node,true,false);
	}else if (curmod != null){
		ModuleMemberRenderer renderer = new ModuleMemberRenderer(curmod, userContext, modulesMap, logsMap, true, false, treeNodeExists);
		renderer.setLogsMapOnlyOpen(true);
		renderer.setShowFilters(true);
		renderer.setFiltersRadio(true);
		renderer.setLogTypesToIgnore(ignoreTypes);
		renderer.setFilters(filtersMap);
		treeXml = renderer.getTreeXML();
	}
	response.setContentType("text/xml");
	out.write(treeXml);
	out.flush();
%>