<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.verifiers.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%
  final String BASE_DIRECTORY = "../";
%>

<%!
	static final String [] rulesNames = {"at least one monitor failed", "all monitors failed"};
%>

<%
  String ERROR_OBJ = "ERROR_OBJ";
  SiteManagment mgmt = SiteManagment.getInstance();
  WebSecurityManager manager = WebSecurityManager.getInstance();
  if (!manager.checkForPermission(request,response,null,true)){
     return;
  }
  UserContext userContext = UserEnvironment.getUserContext(request);
	
	MultiVerifier verifier = new MultiVerifier();
	String verId = request.getParameter("VERIFIER_ID");
	
	VerifierManager verManager = SiteManagment.getInstance().getVerifierManager();
	if (verId != null && verId.length() > 0){
	   verifier = (MultiVerifier)verManager.getVerfierFromId(verId);
	}else {
	  verId = null;
	}
	
	HashSet set = new HashSet();
	set.add(Verifier.ROOT_VERIFIER_ID);
	set.add("CSMultiVerifier");
	
	Verifier[] varr = verManager.getAllPossibleChildsVerifiers(userContext,verId,set,false);
	Arrays.sort(varr,VerifierManager.verNameComp);
	
	if(varr == null || varr.length<2) {
		  ErrorModel errmodel = new ErrorModel();
		  errmodel.addError("No available monitors were found");
		  errmodel.addError("You must have at least 2 monitors in order to add a multi monitor");
		  request.getSession().setAttribute(ERROR_OBJ,errmodel);
		  response.sendRedirect(BASE_DIRECTORY+"/common/errorpage.jsp");
		  return;
	}
	
	boolean isRoot = verifier.getId().equals(Verifier.ROOT_VERIFIER_ID);
	request.setAttribute("CUREENT_VERIFIER",verifier);
%>

<html>
	<head>
		<meta http-equiv="Content-Language" content="en-us">
		<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
		<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
		<META HTTP-EQUIV="EXPIRES" CONTENT="0">
		<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css">
		<title></title>
		
<script>

function doVerifierAdd(){
  if(document.access.availableVerifiersList.selectedIndex == -1){
    return;
  }
  for(var j=0;j<document.access.availableVerifiersList.options.length;j++){
    if (document.access.availableVerifiersList.options[j].selected){
      var name = document.access.availableVerifiersList.options[j].text;
      var value = document.access.availableVerifiersList.options[j].value;
      var found = false;
      for(var i=0;i<document.access.SelectedVerifiersList.options.length;i++){
        if(document.access.SelectedVerifiersList.options[i].value == value){
          found = true;
        }
      }
      if (!found){
        var option0 = new Option(name,value);
        document.access.SelectedVerifiersList.options[document.access.SelectedVerifiersList.options.length] = option0;
      }
    }
  }
}

function doVerifierRemove(){
  if(document.access.SelectedVerifiersList.selectedIndex == -1){
    return;
  }

  for(var i= document.access.SelectedVerifiersList.options.length ; --i >= 0;){
    if(document.access.SelectedVerifiersList.options[i].selected){
       document.access.SelectedVerifiersList.options[i] = null;
    }
  }
}

function doSave(){
  <% if (!isRoot){ %>
   for(var j=0;j<document.access.SelectedVerifiersList.options.length;j++){
    document.access.SelectedVerifiersList.options[j].selected = true;
  }
	<% } %>
	doTasks();
	document.access.submit();
}

function doReset(){
   this.location = "MultiVerifiersSettings.jsp?VERIFIER_ID=<%=verifier.getId()%>";
}

</script>
	</head>
	<body>
		<form AUTOCOMPLETE="OFF" id="access" name="access" action="MultiVerifiersSettingsAction.jsp">
			<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style=
			"border-collapse: collapse" bordercolor="#111111">
			   <input type="hidden"  name="id" value="<%=verifier.getId()%>">
				<tr>
					<td width="100%" height="100%" valign="top">
						<table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
							<tr>
								<td valign="top" height="90%">
									<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse"
									width="100%" id="AutoNumber1">
										<tr>
											<td width="100%">
												<table border="0" cellpadding="0" cellspacing="0" style=
												"border-collapse: collapse" width="100%" id="AutoNumber2" height=
												"100%">
													<tr>
														<td width="3%" class="TOPLEFTBORDER">&nbsp;</td>
														<td width="53%" class="TOPBORDER" height="0">
															<span class="PAGEHEADER">Multi Monitors Settings</span> 
														</td>
														<td width="30%" class="TOPRIGHTBORDER">&nbsp;</td>
													</tr>
													<tr>
														<td colspan="3">&nbsp;</td>
													</tr>
												</table>

												<table border="0" cellpadding="0" cellspacing="0" style=
												"border-collapse: collapse" width="100%" height="100%">
													<tr>
														<td width="3%" height="100%">&nbsp;&nbsp;&nbsp;</td>
														<td width="93%" colspan="2" height="100%">
															<table border="0" cellpadding="0" cellspacing="0" style=
															"border-collapse: collapse" width="100%" id="AutoNumber3"
															height="53">
																<tr>
																	<td width="15%" ></td>
																</tr>
																<tr>
																	<td width="15%" >
																		<span class="HEADER">Global</span><b>&nbsp;</b>
																	</td>
																</tr>
																<tr>
																	<td>
																		
																	</td>
																</tr>

																<tr>
																	<td width="100%" >
																		<table border="0" width="300">
																			<tr>
																				<td width="150">
																					<span class=
																					"REGULARTEXT">Name:</span> 
																				</td>
																				<td width="150">
																					<input type="text" class="TEXTBOX" name="name" size="20" value="<%=verifier.getName()%>">
																				</td>
																			</tr>
																		</table>
																	</td>
																</tr>
                                			
																
																<tr>
																	<td width="15%"></td>
																</tr>
																
																<% if (!isRoot){ %>
																<tr>
																	<td width="15%">
																		<span class="HEADER">Settings</span><b>&nbsp;</b> 
																	</td>
																</tr>
																<tr>
																	<td>
																		
																	</td>
																</tr>
																<tr>
																	<td>
																		<span class="REGULARTEXT">Select the monitors
																		to be used:</span> 
																	</td>
																</tr>
																<tr>
																	<td height="100%"></td>
																</tr>
																<tr >
																	<td width="100%">

																		<table border="0" width="500">
																			<tr>
																				<td width="200" height="18" align=
																				"center">
																					<span class="REGULARTEXT" style=
																					"font-weight:bold">Available Monitors</span>
																				</td>
																				<td width="100" >&nbsp;</td>
																				<td width="200"  align="center">
																					<span class="REGULARTEXT" style=
																					"font-weight:bold">Selected Monitors</span>
																				</td>
																			</tr>
																			<tr>
																				<td width="200">
																					<select size="5" style="width:200" name="availableVerifiersList" id="availableVerifiersList" multiple>
																					  <%for (int i = 0; i < varr.length; i++){ %>
																						<option value="<%=varr[i].getId()%>" class="TEXTBOX" name="<%=varr[i].getId()%>"><%=varr[i].getName()%></option>
																						<%}%>
																					
																					</select>
																				</td>
																				<td width="100">

																					<table border="0" width="100">
																						<tr>
																							<td align="center">
																								<a href=
																								"javascript:doVerifierAdd()"
																								 class="SMALLLINK">Add</a>
																							</td>
																						</tr>
																						<tr>
																							<td align="center">
																								<a href=
																								"javascript:doVerifierRemove()"
																								 class=
																								"SMALLLINK">Remove</a>
																							</td>
																						</tr>
																					</table>
																				</td>
																				<td width="200">
																					<select size="5" style="width:200" name="SelectedVerifiersList" id="SelectedVerifiersList" multiple>
																					   <% 
																						 String [] ids = verifier.getVerifiersIds();
																						 for (int i = 0; i < ids.length; i++){ 
																							  String name = null;
																								for (int j = 0; j < varr.length; j++){
																									 if (ids[i].equals(varr[j].getId())){
																									   name = varr[j].getName();
																										 break;
																									 }
																								}
																								if (name != null){ 
																								%>
																						  <option value="<%=ids[i]%>" class="TEXTBOX" name="<%=ids[i]%>"><%=name%></option>
																							<%} }%>
																					</select>
																				</td>
																			</tr>
																		</table>
																	</td>
																</tr>
																<tr>
																	<td>
																		
																	</td>
																</tr>
																<%}%>
																<tr>
																	<td width="15%" >
																		<span class="HEADER">Rules:</span><b>&nbsp;</b>
																	</td>
																</tr>
																<tr>
																	<td>
																		
																	</td>
																</tr>
																<tr>
																	<td>
																		<span class="REGULARTEXT">Select the rules for
																		this monitor:</span> 
																	</td>
																</tr>
																<tr>
																	<td height="100%"></td>
																</tr>

																<tr>
																	<td>
																		<span class="REGULARTEXT">&nbsp;Failure means that  &nbsp;</span> 
																		<select size="1" name="rulesType" id="rulesType">
																			 <% for (int i = 0; i < rulesNames.length; i++){%>
																						<option class="REGULARTEXT" value="<%=String.valueOf(i)%>"  <%=verifier.getRuleType() == i? "selected" : ""%>><%=rulesNames[i]%></option>
																						<%}%>                     
																		</select>																			
																	</td>
																</tr>
																<tr>
																	<td width="100%"></td>
																</tr>
																<tr>
																	<td width="100%"><span class="HEADER">Actions</span></td>
																</tr>
																<tr><td width="100%" >
																	<jsp:include flush="true" page="tasksVerifier.jsp"/>
																</td></tr>
																<tr>
																	<td width="100%">&nbsp;</td>
																</tr>
															</table>
														</td>
													</tr>

													<tr>
														<td>
															<font size="2">&nbsp;</font> 
														</td>
													</tr>
												</table>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td valign="bottom" height="10%">
						<table border="0" width="100%">
							<tr>
								<td width="30%">&nbsp;</td>
								<td width="31%" align="center">
									<table border="0" width="225">
										<tr>
											<td width="33%">
												<a href="javascript:doSave()" class="LINK">save</a>
											</td>
											<td width="33%">
												<a href="javascript:doReset()" class="LINK">reset</a>
											</td>
											<td width="33%">
												<a href="<%=BASE_DIRECTORY%>logEyePortal.jsp" class="LINK">cancel</a>
											</td>
										</tr>
									</table>
								</td>
								<td width="39%">&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td valign="bottom" height="10%">
						<table border="0" cellpadding="0" cellspacing="0" width="100%">
							<tr>
								<td class="BOTTOMLEFTBORDER" width="100%">&nbsp;</td><td class="BOTTOMBORDER" width=
								"100%">&nbsp;</td><td class="BOTTOMRIGHTBORDER" width="100%">&nbsp;</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</form>
	</body>
</html>
