<%@ page import="xpolog.eye.verifiers.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>

<%!
public boolean createTasksForVerifier(HttpServletRequest request,HttpServletResponse response,Verifier ver) throws Exception{
	return createTasksForVerifier(request, response, ver,"");
}


public boolean createTasksForVerifier(HttpServletRequest request,HttpServletResponse response,Verifier ver,String suffix) throws Exception{
  
	if (suffix == null){
		suffix = "";
	}
	boolean hasData = false;
  String SUCESS_TASKS = "To_Select_Suc";
  String FAIL_TASKS = "To_Select_Fail";
  String CLEARING_TASKS = "To_Select_Clear";
  VerifierTasksListener listener = new VerifierTasksListener();
  ver.clearAllListeners();
  //success
  String[] sucTaskIds = request.getParameterValues(SUCESS_TASKS+suffix);
  if(sucTaskIds != null){
	  for(int i=0;i<sucTaskIds.length;++i){
	  	listener.addTaskOnSuccess(sucTaskIds[i]);
	  	if (!hasData){
	  		hasData = true;
	  	}
	  }
  }
  //failure
  String[] failTaskIds = request.getParameterValues(FAIL_TASKS+suffix);
  if(failTaskIds != null){
	  for(int i=0;i<failTaskIds.length;++i){
	  	listener.addTaskOnFail(failTaskIds[i]);
	  	if (!hasData){
	  		hasData = true;
	  	}
	  }
  }
  //clearing
  String[] clearingTaskIds = request.getParameterValues(CLEARING_TASKS+suffix);
  if(clearingTaskIds != null){
	  for(int i=0;i<clearingTaskIds.length;++i){
	  	listener.addTaskOnClearing(clearingTaskIds[i]);
	  }
  }
  String failCountForAggTasksStr = request.getParameter("failCountForAggTasks"+suffix);
  String eventExecution = request.getParameter("eventExecution"+suffix);
  String posAlertIntervalStr = request.getParameter("posAlertInterval"+suffix);
  String timeUnitStr = request.getParameter("timeUnit"+suffix);
  int failCountForAggTasks = -1;
  try{
  	failCountForAggTasks = (failCountForAggTasksStr != null && failCountForAggTasksStr.length() > 0) ? Integer.parseInt(failCountForAggTasksStr) : -1;
  }catch(Exception e){
  	throw new Exception ("Failed to parse number of failures");
  }
  
  
  int posAlertInterval = -1;
  try{
  	posAlertInterval = (posAlertIntervalStr != null && posAlertIntervalStr.length() > 0) ? Integer.parseInt(posAlertIntervalStr) : -1;
  }catch(Exception e){
  	throw new Exception ("Failed to parse number of executions for positive alert");
  }
  int timeUnit = (timeUnitStr != null && timeUnitStr.length() > 0 && !timeUnitStr.equals("0")) ? Integer.parseInt(timeUnitStr) : -1;
	listener.setFailCountForAggregationTasks(failCountForAggTasks);
	listener.setEventExecution(eventExecution);
 	listener.setPositiveAlertInterval(posAlertInterval);
 	listener.setIntervalTimeUnit(timeUnit);
  ver.addListener(listener);
  return hasData;
 }
%>