
<%@page import="java.io.BufferedReader"%>
<%@page import="java.io.File"%>
<%@page import="java.io.FileInputStream"%>
<%@page import="java.io.InputStreamReader"%>

<%@page import="xpolog.eye.error.ErrorModel"%>
<%@page import="xpolog.eye.security.*"%>
<%@page import="xpolog.eye.site.helpers.SiteLogHelper"%>
<%@page import="xpolog.eye.site.SiteConstants"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.site.ProgressRunner"%>
<%@page import="xpolog.eye.site.SiteUtil"%>
<%@page import="xpolog.eye.site.widgets.actions.WidgetActionResponse"%>
<%@page import="xpolog.eye.site.widgets.actions.WidgetActionRequest"%>
<%@page import="xpolog.eye.site.widgets.actions.WidgetActionExecuter"%>
<%@page import="xpolog.eye.site.widgets.XpoLogWidgetsManager"%><%@ page language="java"%>
<%@page import="xpolog.eye.util.XMLUtil"%>

<%!
  static final String BASE_DIRECTORY = "../../";
%>

<%
	
	String query = request.getQueryString();
	if (query == null){
		 query = "";
	}
	String loginUrl = "view/api/widgetAPI.jsp" + (query.length() == 0 ? "" : "?") + query;
	request.setAttribute("loginForwardURL",loginUrl);
	WebSecurityManager manager = WebSecurityManager.getInstance();
		if (!manager.checkForPermission(request, response, null, true)) {
		return;
	}
	
  String widgetId = request.getParameter("widgetId");
  if (widgetId == null || widgetId.length() == 0){
    return;
  }
  
	final WidgetActionExecuter executer = XpoLogWidgetsManager.getIntsance().createActionExecuter(widgetId);
	final WidgetActionRequest req = new WidgetActionRequest();
  req.getParams().putAll(SiteLogHelper.createParametersMapFromRequest(request.getParameterMap()));
  req.setResultType(WidgetActionRequest.XML_TYPE);
  req.setContext(UserEnvironment.getUserContext(request));
  req.setBaseUrl(SiteUtil.getApplicationRoot(request));
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  String message = "";
  String url = "";
  String state = "Fail";
  String data = "";
  if(executer == null) {
  	message = "A configuration problem prevents the widget " + widgetId + " from being executed";
  }else {
	  try {
			WidgetActionResponse res = executer.executeAction(req);
			  if (res != null){
			   url = res.getRedirectPage();
	       
	       if (res.getActionStatus() == WidgetActionResponse.FAIL_STATUS && res.getErrorMessage() != null && res.getErrorMessage().length() > 0){        
	   		   message = res.getErrorMessage();         
	       }else {
	        state = "OK"; 
	       }
	       if (url == null){
	          url = "";
	       }
	       if (res.getData() != null && res.getData() instanceof File){
	         File f = (File)res.getData();
	         if (f.exists()){
	           StringBuffer buffer = new StringBuffer();
	           BufferedReader reader = null;
	           try {
	        	   reader = new BufferedReader(new InputStreamReader(new FileInputStream(f)));
	             String line = null;
	             while ((line = reader.readLine()) != null){
	               if (line.startsWith("<?xml")){
	            	   continue;
	               }
	               buffer.append(line);
	             }
	           }catch (Exception e){
	            e.printStackTrace(); 
	           }finally {
	             if (reader != null){
	              reader.close(); 
	             }
	           }
	           data = buffer.toString();
	         }
	       }
			  }else {
	        message = "no response";   
	      }
		}catch (Exception e) {
	    ErrorModel.log.error("Failed to execute widget action " + widgetId,e);
			message = e.getMessage();
		}
  }
  
	response.setContentType("text/xml; charset=UTF-8");
	
%>
<APIResult>
  <Status state="<%=state%>">
    <Url><%=url%></Url>
    <Message><%=message%></Message>
  </Status>
  <Data><%=data%></Data>
</APIResult>
