<%@ page language="java"%>

<%@page import="xpolog.eye.site.ui.charts.view.image.XpoLogChartImageView"%>
<%@page import="xpolog.eye.site.ui.charts.view.flash.XpoLogChartFlashView"%>
<%@page import="xpolog.eye.site.ui.charts.view.XpoLogChartBuilderFactory"%>
<%@page import="xpolog.eye.site.ui.charts.view.XpoLogChartView"%>
<%@page import="xpolog.eye.site.ui.charts.view.XpoLogChartImageQuery"%>
<%@page import="xpolog.eye.site.ui.charts.XpoLogChartModel"%>
<%@page import="xpolog.eye.site.ui.charts.view.XpoLogChartQuery"%>
<%@page import="xpolog.eye.site.ui.charts.view.XpoLogChartBuilder"%>
<%@page import="xpolog.eye.error.ErrorModel"%>


<%!static final String BASE_DIRECTORY = "../../../";
static final int WIDE_GRAPH_WIDTH = 1000;
static final int NARROW_GRAPH_WIDTH = 850;
static final int STEP_GRAPH_WIDTH = 1024;
static final int TALL_GRAPH_HEIGHT = 220;
//static final int SHORT_GRAPH_HEIGHT = 180;
static final int SHORT_GRAPH_HEIGHT = 220; // leave height same as in high resolution for now
static final int STEP_GRAPH_HEIGHT = 768;

%>

<%
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null) {
		baseDirectory = BASE_DIRECTORY;
	}

	String suffix = request.getParameter("suffix");
	if (suffix == null) {
		suffix = "";
	}

	String chartViewType = (String)request.getAttribute("xplg_chartViewType");
	if (chartViewType == null) {
		chartViewType = request.getParameter("xplg_chartViewType");
  }
	if (chartViewType == null) {
		chartViewType = XpoLogChartBuilder.FLASH_BUILDER_TYPE;
	}
  
	String windowWidthStr = request.getParameter("windowWidth");
	int windowWidth = windowWidthStr != null && windowWidthStr.length() > 0 ? Integer.parseInt(windowWidthStr) : -1;
	//int graphWidth = windowWidth != -1 && windowWidth <= STEP_GRAPH_WIDTH ? NARROW_GRAPH_WIDTH : WIDE_GRAPH_WIDTH;
	int graphWidth = windowWidth != -1 ? windowWidth : NARROW_GRAPH_WIDTH;
	String windowHeightStr = request.getParameter("windowHeight");
	int windowHeight = windowHeightStr != null && windowHeightStr.length() > 0 ? Integer.parseInt(windowHeightStr) : -1;
	int graphHeight = windowHeight != -1 && windowHeight <= STEP_GRAPH_HEIGHT ? SHORT_GRAPH_HEIGHT : TALL_GRAPH_HEIGHT;

  
	XpoLogChartQuery query = (XpoLogChartQuery)request.getAttribute("chartQuery");
  if (query == null){
	  XpoLogChartModel chartModel = (XpoLogChartModel)request.getAttribute("chartModel");
    if (chartViewType.equalsIgnoreCase(XpoLogChartBuilder.FLASH_BUILDER_TYPE)){
      query = new XpoLogChartQuery(chartModel);
    }else {
    	String graphMapName = "graphMap";
    	XpoLogChartImageQuery imageQuery = new XpoLogChartImageQuery(chartModel);
    	imageQuery.setImageMapName(graphMapName);
      query = imageQuery;
    }
    query.setHeight(graphHeight);
    query.setWidth(graphWidth);
    query.setChartViewType(chartViewType);
  }
  XpoLogChartView view =  null;
  if (query != null){
  try {		
   XpoLogChartBuilder builder = XpoLogChartBuilderFactory.createChartBuilder(query.getChartViewType());      
   if (builder != null){ 	  
     view = (XpoLogChartView)builder.createChartView(query); 
   }
   
	 }catch (Exception e){
	    ErrorModel.log.error("Failed to create chart view",e);
	  }
  }
		try {
%>

<% if (view instanceof XpoLogChartFlashView){ 
  String graphResultXML = view == null ? "" : ((XpoLogChartFlashView)view).getXml();    
response.setContentType("text/xml; charset=UTF-8");
//System.out.println("graphResultXML = " + graphResultXML);

 %> 
 <%=graphResultXML%>
 
<%} else if (view instanceof XpoLogChartImageView){
	XpoLogChartImageView imageView = (XpoLogChartImageView)view;
	String graphMap = imageView.getMapStr();
	String graphMapName = ((XpoLogChartImageQuery)query).getImageMapName();
  
%>
<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
<% if (imageView.getImagePath() != null && imageView.getImagePath().length() > 0){%>
  <tr>
    <td class="SEARCH_GRAPH_OUTER_CELL" style="padding:10">
      <table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">       
        <tr height="<%=graphHeight%>px">
          <td>
            <img border="0" id="graphImage" src="<%=baseDirectory + imageView.getImagePath()%>" usemap="#<%=graphMapName%>">
          </td>
        </tr>
      </table>
    </td>
  </tr>
 <% }else {
  String message = "No matching log events were found"; 
%>
        <tr>
          <td class="SEARCH_MAIN_TABLE_GENERAL_CELL SEARCH_MAIN_TABLE_HEADER_CELL" colspan="3"><%=message %></td>
        </tr>
<%
}%>
</table>

<%
}
	} catch (Throwable e) {
		ErrorModel.log.error("Failed to init chart view " + request.getParameterMap(),e);
	}
%>