<%@ page language="java"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = BASE_DIRECTORY;
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
  String height = request.getParameter("height");
  if (height == null || height.length() == 0){
  	height = "30px";
  }
  
  String[] actionsNamesArr = null;
  String[] actionsArr = null;
  String[] ids = null;
  
  String actionsNamesStr = request.getParameter("actionNames");
  if (actionsNamesStr != null && actionsNamesStr.length() > 0){
  	actionsNamesArr = actionsNamesStr.split("#");
  }
  String actionsStr = request.getParameter("actions");
  if (actionsStr != null && actionsStr.length() > 0){
  	actionsArr = actionsStr.split("#");
  }
  
  String idsStr = request.getParameter("ids");
  if (idsStr != null && idsStr.length() > 0){
  	ids = idsStr.split("#");
  }
  
  String bgClass = request.getParameter("bgClass");
  if (bgClass == null || bgClass.length() == 0){
  	bgClass = "BUTTONS_BG";
  }

  String buttonClass = request.getParameter("buttonClass");
  if (buttonClass == null || buttonClass.length() == 0){
  	buttonClass = "BUTTON_GRID_GROUP";
  }
  
  String align = request.getParameter("align");
  if (align == null || align.length() == 0){
  	align="center";
  }
  
  String padding = request.getParameter("padding");
  if (padding == null || padding.length() == 0){
  	padding="15";
  }
  String disableStr = request.getParameter("disable");
  boolean disable = disableStr != null && disableStr.equals("true");
 
  
  
%>
<%
if (actionsArr != null && actionsNamesArr != null){
%>
	<table border="0" cellspacing="0" height="20px" >
		<tr>
			<td align="<%=align%>" style="padding-left:<%=padding %>;padding-right:<%=padding %>; width:50px;">
				<table border="0" width="50" cellspacing="0" height="100%" cellpadding="0">
					<tr>
						<td style="padding-left:5;padding-right:5" width="10">
							<table border="0" width="100%" cellspacing="0" height="23" cellpadding="0">
								<tr>
									<td width="6">
										<table border="0" width="6" cellspacing="0" height="23" cellpadding="0" background="<%=baseDirectory%>images/grid/btnGroupLeft.gif">
											<tr>
												<td></td>
											</tr>
										</table>
									</td>
									<td width="3">
										<table border="0" width="3" cellspacing="0" height="23" cellpadding="0" background="<%=baseDirectory%>images/grid/btnGroupMiddle.gif">
											<tr>
<%
	String action = null;					
	for(int i = 0; actionsNamesArr != null && i < actionsNamesArr.length ; i++){
		if (i >= actionsArr.length){
			break;
		}
		action = actionsArr[i];
		if (!action.toLowerCase().startsWith("javascript:")){
			action = baseDirectory + action;
		}
		String name = actionsNamesArr[i];
		
		String idStr = ids == null ? "" : "id=\"" + ids[i] + "\"";
		String idDisableStr = ids == null ? "" : "id=\"" + ids[i] + "Disable\"";
%>
												<td style="padding-left:5;padding-right:5;padding-bottom:4;padding-top:0">
													<a href="<%=action%>" <%=idStr%> class="<%=buttonClass%>"  <%=disable ? "style=\"display:none\"" : ""%>><nobr><%=name%></nobr></a>					
													<span <%=idDisableStr%> class="<%=buttonClass%>_DISABLE" <%=!disable ? "style=\"display:none\"" : ""%>><nobr><%=name%></nobr></span>
												</td>
<%
		if (i < (actionsNamesArr.length - 1)){
%>
												<td width="1">
													<table border="0" width="1" cellspacing="0" height="23" cellpadding="0" background="<%=baseDirectory%>images/grid/btnGroupSep.gif">
														<tr>
															<td></td>
														</tr>
													</table>
												</td>
<%
		}
	}
%>
											</tr>
										</table>
									</td>
									<td width="6">
										<table border="0" width="6" cellspacing="0" height="23" cellpadding="0" background="<%=baseDirectory%>images//grid/btnGroupRight.gif">
											<tr>
												<td></td>
											</tr>
										</table>
									</td>
								</tr>
							</table>
						</td>
					</tr>	
				</table>												
			</td>				
		</tr>
	</table>
<%}%>