<%@ page language="java"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
  
	String baseDirectory = request.getParameter("baseDirectory");
	if (baseDirectory == null){
		baseDirectory = BASE_DIRECTORY;
	}
	
	String suffix = request.getParameter("suffix");
	if (suffix == null){
		suffix = "";
	}
	
	String initXmlUrl = request.getParameter("initXML");
	if (initXmlUrl == null || initXmlUrl.length() == 0){
		initXmlUrl = null;
	}	else {
		initXmlUrl = baseDirectory + initXmlUrl;
		
	}
	
	
	String xmlParse = request.getParameter("xmlParse");
	if (xmlParse != null && xmlParse.length() == 0){
		xmlParse = null;
	}	
	
	String updateXmlUrl = request.getParameter("updateXML");
	if (updateXmlUrl == null || updateXmlUrl.length() == 0){
		updateXmlUrl = initXmlUrl;
	}	else {
		updateXmlUrl = baseDirectory + updateXmlUrl;
	}	
	
	String rowsNumStr = request.getParameter("rows");
	int rowsNum = 5;
	try {
		if (rowsNumStr != null && rowsNumStr.length() > 0){
			rowsNum = Integer.parseInt(rowsNumStr);
		}
	}catch (Exception e){}
	
	
	String scriptsOnlyStr = request.getParameter("scriptsOnly");	
	boolean scriptsOnly = scriptsOnlyStr != null && scriptsOnlyStr.equals("true");
	
	String width = request.getParameter("width");
	if (width == null || width.length() == 0){
		width = "100%";
	}
	
	String height = request.getParameter("height");
	if (height == null || height.length() == 0){
		height = String.valueOf(rowsNum*20 + 2);
	}
	
	String autoHeight = request.getParameter("autoHeight");
	if (autoHeight == null || autoHeight.length() == 0){
		autoHeight = "-1";
	}
	
	String noScriptsStr = request.getParameter("noScripts");	
	boolean noScripts = noScriptsStr != null && noScriptsStr.equals("true");
	
	String multilStr = request.getParameter("multiSelect");	
	boolean multiSelect = multilStr != null && multilStr.equals("true");
	
	
	String treeXmlUrl = request.getParameter("treeXML");
	if (treeXmlUrl == null || treeXmlUrl.length() == 0){
		treeXmlUrl = null;
	}	else {
		treeXmlUrl = baseDirectory + treeXmlUrl;
	}	
	
	String dragAndDropStr = request.getParameter("dragAndDrop");	
	boolean dragAndDrop = dragAndDropStr != null && dragAndDropStr.equals("true");
	
	String dragAndDropGridsCopyStr = request.getParameter("dragAndDropGridsCopy");	
	boolean dragAndDropGridsCopy = dragAndDropGridsCopyStr != null && dragAndDropGridsCopyStr.equals("true");
	
	
	String doubleClickAction = request.getParameter("doubleClickAction");	
%>




<%
if (!scriptsOnly){

%>	
	

<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%"  height="53">
										<tr>
											<td valign="top">
												<div id="gridLoadingDiv<%=suffix%>" style="display:none">
													<span class="REGULARTEXT">Loading...</span>
												</div>
											</td>
										</tr>
										 <tr height="*" id="test">
                    <td style="padding-top:5" valign="top">
                    <div id="gridbox<%=suffix%>" width="<%=width%>" height="<%=height%>" style="background-color:white;border:1px solid #909090"></div>
                              
	                   </td>
	                  </tr>	                 
</table>        

<%
}%>      

<%if (!noScripts){%>     
<script>

function updateTable<%=suffix%>(){
  mygrid<%=suffix%>.clearAll()
  mygrid<%=suffix%>.loadXML("<%=updateXmlUrl%>");  
}

function refreshTable<%=suffix%>(){
  mygrid<%=suffix%>.updateFromXML("<%=updateXmlUrl%>");  
}

function endLoad<%=suffix%>(){
  hideLoading<%=suffix%>();
  mygrid<%=suffix%>.setSizes();
}

function initTable<%=suffix%>(){
  if (!document.getElementById("gridbox<%=suffix%>")){
    return;
  }
 
  mygrid<%=suffix%> = new dhtmlXGridObject('gridbox<%=suffix%>');
	mygrid<%=suffix%>.setImagePath(baseDirectory + "dhtmlxSuite/dhtmlxGrid/codebase/imgs/");
 // mygrid<%=suffix%>.enableLightMouseNavigation(true);
  mygrid<%=suffix%>.enableKeyboardSupport(true);   
  <% if (!autoHeight.equals("-1")){%>
    mygrid<%=suffix%>.enableAutoHeigth(true,"<%=autoHeight%>");
  <% }%>      
  mygrid<%=suffix%>.enableColumnAutoSize(false);
  mygrid<%=suffix%>.setNoHeader(true);
  mygrid<%=suffix%>.setSkin("xplglistskin");
  mygrid<%=suffix%>.attachEvent("onRowSelect",doOnRowSelected<%=suffix%>);
  mygrid<%=suffix%>.attachEvent("onRowDblClicked",doOnRowDblClicked<%=suffix%>);
  mygrid<%=suffix%>.setMultiselect(<%=multiSelect ? "true" : "false"%>);
 
  
	mygrid<%=suffix%>.attachEvent("onXLE",endLoad<%=suffix%>);
	<% if (doubleClickAction != null && doubleClickAction.length() > 0){%>
  mygrid<%=suffix%>.obj.ondblclick = <%=doubleClickAction%>;
  <%}%>  
  mygrid<%=suffix%>.objBox.style.overflowY = "scroll";
  mygrid<%=suffix%>.objBox.style.overflowX = "hidden";
 // mygrid<%=suffix%>.objBox.className = "objbox_xplglistskin";
  
 mygrid<%=suffix%>.init(); 
 
 <% if (dragAndDrop){%>
   mygrid<%=suffix%>.enableDragAndDrop(true);
   <% if (dragAndDropGridsCopy){%>
     mygrid<%=suffix%>.enableMercyDrag(true);
 <%}}%> 
	<% if (treeXmlUrl != null){%>
	mygrid<%=suffix%>.kidsXmlFile="<%=treeXmlUrl%>";
	<%}%> 
	
	showLoading<%=suffix%>();
  <%if (xmlParse == null){%>
  <%if (initXmlUrl != null){%>
  mygrid<%=suffix%>.loadXML("<%=initXmlUrl%>");
  <%}
  }else {%>
  mygrid<%=suffix%>.parse(document.getElementById('<%=xmlParse%>').value);
  mygrid<%=suffix%>.setSizes();
  <%}%>
 
	}

function destroyTable<%=suffix%>(){
  if (mygrid<%=suffix%>){
    mygrid<%=suffix%>.destructor();    
  }  
}

function showLoading<%=suffix%>(){
	var e = document.getElementById("gridLoadingDiv<%=suffix%>");
	if (e){
		e.style.display = "";
	}
	e = document.getElementById("gridbox<%=suffix%>");
	if (e){
		e.style.visibility = "hidden";
	}
}

function hideLoading<%=suffix%>(){
	var e = document.getElementById("gridLoadingDiv<%=suffix%>");
	if (e){
		e.style.display = "none";
	}
	e = document.getElementById("gridbox<%=suffix%>");
	if (e){
		e.style.visibility = "";
	}
}


function doOnRowSelected<%=suffix%>(id){
}

function doOnRowDblClicked<%=suffix%>(id){
}


addInitFunction("initTable<%=suffix%>()");
addDestroyFunction("destroyTable<%=suffix%>()");
</script>
<%}%>