<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.tools.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.ConfigurationPermissions.IMPORT_WIZARDS_PERMISSION,true)){
    return;
  }
  UserContext userContext = UserEnvironment.getUserContext(request);

  String ARCHIVE_PATH = "ARCHIVE_PATH";
  String ERROR_OBJ = "ERROR_OBJ";

  SiteManagment mgmt = SiteManagment.getInstance();

  String arch_file  = request.getParameter(ARCHIVE_PATH);

  //verify data
  ErrorModel errmodel = new ErrorModel();
  if(arch_file == null || arch_file.trim().equals("")){
    errmodel.addError("No archive file was supplied.");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect("errorpage.jsp");
    return;
  }

  //here we will use xpolog builder for import -

  File arch = new File(arch_file);
  try{
   arch = UploadHelper.uploadFile(request,arch);
   WizardManager wm = mgmt.getWizardManager(xpolog.eye.site.SiteUtil.getBaseDirectory(request));
   wm.importWizard(arch);
  }catch(Exception e){
    ErrorModel errmod = new ErrorModel();
    errmod.addError(e.getMessage());
    request.getSession().setAttribute(ERROR_OBJ,errmod);
    response.sendRedirect("errorpage.jsp");
    return;
  }
  
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
    	 			userContext, AuditConstants.CHANGE, "import wizard", AuditConstants.CONFIGURATION, "import wizard");	 	 	

  
  response.sendRedirect("wizardaddopok.jsp");
%>


