<%@ page language="java"%>

<%@ page import="xpolog.eye.admin.wizards.common.controlers.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.site.*" %>

<%@ page import="java.io.*"%>

<%!static final String BASE_DIRECTORY = "../../";%>

<%

  String ERROR_OBJ = "ERROR_OBJ";
  String PREFIX = "prefix";
  String LOCATION_TYPE = "locationType";
	String CONFIGURATION_FILE = "configurationFile";
  String ROOT_DIR = "rootDir";
  String ACCOUNT_ID = "accountId";

  int position = Integer.parseInt(request.getParameter(WizardConstants.VIEW_CONTROL_POSITION_PARAM));
  DefaultWizardBuilder builder =  (DefaultWizardBuilder)request.getSession().getAttribute(WizardConstants.WIZARD_BUILDER_SESSION_ATT);
  WizardConfigurationViewControl view = (WizardConfigurationViewControl)builder.getControler().getWizardViewControlByPosition(position,true);
  
  String prefix = request.getParameter(PREFIX);
  if(prefix == null) {
  	prefix = "";
  }
  String locationType = request.getParameter(prefix + LOCATION_TYPE);
  String configurationFile  = request.getParameter(CONFIGURATION_FILE);
  String rootDir = request.getParameter(ROOT_DIR);
  String accountId = request.getParameter(ACCOUNT_ID);
 	Account acc = AddressBook.getInstance().getAccountById(accountId);
	
 	view.setAccount(acc);
  view.setLocationType(locationType);
  view.setConfigurationFile(configurationFile);
  if (rootDir != null && rootDir.trim().length() > 0){
     view.setRootDirectory(rootDir.trim());
  }else {
     view.setRootDirectory((File)null);
  }
  
  
  String isEmbededStr = request.getParameter("isEmbeded");
  boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");
	String parentModuleId = request.getParameter("parentModuleId");
	if (parentModuleId == null){
		parentModuleId = "";
	}

	if (!isEmbeded){
	  boolean suc = view.doNext();
	  if (!suc){
	    request.getSession().setAttribute(ERROR_OBJ,view.getErrorModel());
	    response.sendRedirect(view.getErrorURL(true));
	  }else {
	 		response.sendRedirect(view.getNext().getViewURL());
	  }
	}else{
		UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	  WizardInfo info = builder.getWizardInfo();
		env.setTempAttribute("WIZARD_INFO",info);
	}

%>

<%if (isEmbeded) {%>
<html>
<head>
<script language="javascript">
function display(){
  if (opener){
  	opener.addConfigurationWizard("<%=configurationFile%>","<%=parentModuleId%>");
  }
  window.close();
}		
</script>
</head>
<body onLoad="display()">
</body>
</html>

<%} %>
