<%@ page language="java"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.controlers.*"%>
<%@ page import="xpolog.eye.site.controllers.*" %>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.audit.*" %>
<%!
  static final String BASE_DIRECTORY = "../../";
%>

<%

  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);

  int position = Integer.parseInt(request.getParameter(WizardConstants.VIEW_CONTROL_POSITION_PARAM));
  DefaultWizardBuilder builder =  (DefaultWizardBuilder)request.getSession().getAttribute(WizardConstants.WIZARD_BUILDER_SESSION_ATT);
  WizardViewControl view = builder.getControler().getWizardViewControlByPosition(position,true);
  String title = view.getProperty("title","Operation done.");
  String message = view.getProperty("message","Wizard operation ended successfully.");

  String CURRENT_LOG = "CURRENT_LOG";
  request.getSession().removeAttribute(CURRENT_LOG);
  
  SiteWizardController control = env.getSiteWizardController();
  
  String name = "";
  WizardInfo info = null;
  WizardControler cont = builder.getControler();
  if(cont != null) {
	  info = cont.getInfo();
  }
  if(info != null) {
	  name = info.getName();
  }
  //audit
  AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
    	 			userContext, AuditConstants.CHANGE, "run wizard", AuditConstants.LOGS, "run wizard " + name);	 	 	

  
  if (control != null){  	
  	response.sendRedirect(BASE_DIRECTORY + "common/actions/nextAction.jsp");
  	return;
  }


%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js" type="text/javascript"></script>
<script>
  function init(){
  	refreshMenus();
    var path ="<%=BASE_DIRECTORY%>view/mainView.jsp";
    document.location = path;
  }
</script>
</head>

<body onload="javascript:init()">

</body>
</html>