<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.wizards.generator.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.nodes.WizardModuleNode"%>


<%@ page import="java.util.*"%>

<%! 
	static final String BASE_DIRECTORY = "../../../";

  String getTreeDiv(Module node,UserContext userContext,HashMap modules,HashMap logs){
    ArrayList list = new ArrayList();
    StringBuffer buffer = new StringBuffer();
    
    if (node != null){
    	List children = node.getModuleMembers(userContext);
    	if (children == null || children.size() == 0){
    		return "";
    	}
      boolean selected = modules == null || modules.containsKey(node.getId());
      String treeKey = "node" + node.getId() + "_0";
      String chkKey = node.getId().equals(Module.ROOT_MODULE_ID) ? "root" : "modules";
      buffer.append("\nvar " + treeKey + " = tree.addNode(tree.root,\"" + chkKey + "\",\"" + node.getId() + "\",\"" + node.getName() + "\",\"" + node.getDescription() + "\",''," + selected + ",true);");
      addChildsNodeDiv(node,buffer,treeKey,userContext,modules,logs);
    }
    return buffer.toString();
  }

  void addChildsNodeDiv(ModuleMember node,StringBuffer buffer, String parentKey,UserContext userContext,HashMap modules,HashMap logs){
  	Module mod = null;
  	if(node.getType().equals(Module.MODULE_TYPE)){
  		try{
  			mod = SiteManagment.getInstance().getModuleFromId(node.getId());
  		}catch(Exception e){
  			return;
  		}
  	}else{
  		return;
  	}
  	List children = mod.getModuleMembers(userContext);
  	SiteManagment mgmt = SiteManagment.getInstance();
  	String type = null;
    for (int i = 0; i < children.size(); i++) {
      ModuleMember child = (ModuleMember)children.get(i);
      //if it is a log - finding the type in order not to include db,http,merge.
      if(child.getType() != null && child.getType().equals("Log")) {
        try{
        	type = mgmt.getLogBrowserManager(child.getId(), true).getType();
        }catch (Exception e) {
        	continue;
        }
      }
			String key = child.getId();
      String treeKey = parentKey + "_" + i;
      String parentNode = parentKey.equals("node") ? "tree.root" : parentKey;
      
      String extraText = "";
      
      boolean selected = false;
      String chkKey = "logs";
      if(child.getType().equals(Module.MODULE_TYPE)){
      	try{
      		Module m = SiteManagment.getInstance().getModuleFromId(key);
      		if (m != null){
      			List l = m.getModuleMembers(userContext);
      			if (l == null ||l.size() == 0){
      				continue;
      			}
      		}
      	}catch(Exception e){
      	}
        selected = modules == null || modules.containsKey(child.getId());
        chkKey = "modules";
      }else {
        selected = logs == null || logs.containsKey(child.getId());
				if (logs != null && logs.size() == 0){
          selected = true;
				  logs.put(child.getId(),child);
				}
      } 
      buffer.append("\nvar " + treeKey + " = tree.addNode(" + parentNode + ",\"" + chkKey +"\",\"" + child.getId() + "\",\"" + child.getName() + "\",\"" + child.getDescription() + "\",'" + extraText + "'," + selected + ",false);");
      addChildsNodeDiv(child,buffer,treeKey,userContext,modules,logs);
    }
  }

%>

<%
  String ERROR_OBJ = "ERROR_OBJ";
  String LOG4J_BUILDER = "LOG4J_BUILDER";

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();

  UserContext userContext = UserEnvironment.getUserContext(request);
  Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
  
  HashMap logsMap = new HashMap();
  HashMap modulesMap = new HashMap();
 
  String treeCode = getTreeDiv(curmod,userContext,modulesMap,logsMap);
  
	WizardGeneratorBuilder builder = (WizardGeneratorBuilder)request.getSession().getAttribute(WizardGeneratorBuilder.WIZARD_GENERATOR_BUILDER_TAG);
  WizardNode[] wizNodeArr = builder.getWizardModuleNodes();
	String parentWizardNodeId = request.getParameter("parentId");

  String logSelectionStr = request.getParameter("logSelection");
  boolean logSelection = logSelectionStr != null && logSelectionStr.equals("true");
  
  String repLogStr = request.getParameter("repLog");
  boolean repLog = repLogStr != null && repLogStr.equals("true");
  
	String title = logSelection ? "Log selection" : "Folder selection";
	String title2 = logSelection ? "select log" : "select folder";
  
%>


<html>

<head>
<title> <%=title%> </title>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script  src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<%if (logSelection){ %>
<script  src="logSelection.js"></script>
<%}else{ %>
<script  src="moduleSelection.js"></script>
<%} %>
<script>

    baseDirectory = "<%=BASE_DIRECTORY%>";
    var firstTime = true;

   function doOK(){
			document.access.action="dsSelectionAction.jsp";
    	document.access.submit();
   }
    

</script>
</head>
<body>

<form AUTOCOMPLETE="OFF" id="access" name="access" method="POST" >
<input type="hidden" name="logSelection" value="<%=logSelection%>">
<input type="hidden" name="repLog" value="<%=repLog%>">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2" height="100%">              
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER"><%=title%></span><b>&nbsp;</b></td>
                  </tr>
                  
                  <tr>
                    <td>
                    <span class="REGULARTEXT"><%=title2%></span>
                    </td>
                  </tr>

	               	<%if (!repLog && wizNodeArr != null && (wizNodeArr.length > 1 || (wizNodeArr.length == 1 && !wizNodeArr[0].getID().equals("ROOT")))){ %>
									<tr>
										<td>
			                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
			                  <tr>
													<td width="30%"><span class="REGULARTEXT">Parent wizard node&nbsp;&nbsp;</span></td>
													<td width="70%">
													<select size="1" class="TEXTBOX" name="parentModuleId">
													<%
													String selected = "";
													for(int i=0;i<wizNodeArr.length;++i){
														if((parentWizardNodeId != null && wizNodeArr[i].getID().equals(parentWizardNodeId))){
															selected = "selected=\"true\"";
														}else{
															selected = "";
														}
													%>
													<option class="TEXTBOX" value="<%=wizNodeArr[i].getID()%>" <%=selected%>><%=wizNodeArr[i].getName()%></option>
													<%}%>
													</select>
													</td>
												</tr>
											</table>
										</td>
									</tr>
									<%}else{%>
									<tr><td>&nbsp;</td></tr>
									<%}%>
                  <tr>
                    <td width="15%">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr>
                        <td class="REGULARTEXT">
	                        <script>
	                         <%=treeCode%>
	                         tree.onSelectMarkParents = false;
													 tree.onSelectMarkChilds = false;
	                         tree.writeTree();
	                        </script>
                         </td>
                      </tr>
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%">&nbsp;</td>
                  </tr>
                  <%if (repLog){%>
                  <tr>
                    <td>
                    	<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse">
                    		<tr>
                    			<td><span class="REGULARTEXT">Repository log id:&nbsp;&nbsp;</span></td>
                    			<td><span class="REGULARTEXT"><input type="text" name="repLogId" size="20"></span></td>
                    		</tr>
                    		<tr>
                    			<td><span class="REGULARTEXT">name: </span></td>
                    			<td><span class="REGULARTEXT"><input type="text" name="repLogName" size="20"></span></td>
                    		</tr>
                    		<tr>
                    			<td><span class="REGULARTEXT">version: </span></td>
                    			<td><span class="REGULARTEXT"><input type="text" name="repLogVersion" size="20"></span></td>
                    		</tr>
                    		<tr>
                    			<td><span class="REGULARTEXT">build: </span></td>
                    			<td><span class="REGULARTEXT"><input type="text" name="repLogBuild" size="20"></span></td>
                    		</tr>
                    	</table>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%">&nbsp;</td>
                  </tr>
                  <%}%>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="30%">&nbsp;</td>
            <td width="150" align="center">
              <table border="0" width="100%">
                <tr>
                  <td width="40%"><a href="javascript:window.close()" class="LINK">cancel</a></td>
                  <td width="40%">
                    <p align="center"><a href="javascript:doOK()" class="LINK">ok</a></td>
                  <td width="*">&nbsp;</td>
                </tr>
              </table>
            </td>
            <td width="20%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>

</body>
</html>