<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.pack.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.wizards.generator.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.nodes.WizardModuleNode"%>
<%@ page import="xpolog.eye.repository.*"%>


<%@ page import="java.util.*"%>

<%! 
	static final String BASE_DIRECTORY = "../../../";
%>

<%
  String ERROR_OBJ = "ERROR_OBJ";
  String LOG4J_BUILDER = "LOG4J_BUILDER";

  //site management
  SiteManagment mgmt = SiteManagment.getInstance();
//  SiteAdministrator admin = SiteManagment.getAdminInstance();

  UserContext userContext = UserEnvironment.getUserContext(request);
//  Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
 
  WizardGeneratorBuilder builder = (WizardGeneratorBuilder)request.getSession().getAttribute(WizardGeneratorBuilder.WIZARD_GENERATOR_BUILDER_TAG);
  WizardNode[] wizNodeArr = builder.getWizardModuleNodes();
  String parentWizardNodeId = request.getParameter("parentId");

  RepositoryInfo[] repInfos = builder.getAllRepositoryInfos();
  
  String title1 = "Select Repository Log";
  String title2 = "select log";
%>


<html>

<head>
<title> Select Repository Log </title>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/components.css" />
<script  src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script>

    baseDirectory = "<%=BASE_DIRECTORY%>";
    var firstTime = true;

   function doOK(){
		document.access.action="repLogSelectionAction.jsp";
    	document.access.submit();
   }
    

</script>
</head>
<body>

<form AUTOCOMPLETE="OFF" id="access" name="access" method="POST" >
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0" style="border-collapse: collapse" bordercolor="#111111">
  <tr>
    <td width="100%" height="100%" valign="top">
    <table border="0" width="100%" cellspacing="0" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0" width="100%" id="AutoNumber2" height="100%">              
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" width="100%" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"><span class="HEADER"><%=title1%></span><b>&nbsp;</b></td>
                  </tr>                  
                  <tr>
                    <td>
                    <span class="REGULARTEXT"><%=title2%></span>
                    </td>
                  </tr>	 
                  
	               	<%if (wizNodeArr != null && (wizNodeArr.length > 1 || (wizNodeArr.length == 1 && !wizNodeArr[0].getID().equals("ROOT")))){ %>
									<tr>
										<td>
			                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
			                  <tr>
													<td width="30%"><span class="REGULARTEXT">Parent wizard node&nbsp;&nbsp;</span></td>
													<td width="70%">
													<select size="1" class="TEXTBOX" name="parentModuleId">
													<%
													String selected = "";
													for(int i=0;i<wizNodeArr.length;++i){
														if((parentWizardNodeId != null && wizNodeArr[i].getID().equals(parentWizardNodeId))){
															selected = "selected=\"true\"";
														}else{
															selected = "";
														}
													%>
													<option class="TEXTBOX" value="<%=wizNodeArr[i].getID()%>" <%=selected%>><%=wizNodeArr[i].getName()%></option>
													<%}%>
													</select>
													</td>
												</tr>
											</table>
										</td>
									</tr>
									<%}else{%>
									<tr><td>&nbsp;</td></tr>
									<%}%>              	               
                  <tr>
                    <td width="15%">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                     <%for(int i=0; i < repInfos.length; i++ ){%>
                       <tr>
                         <td width="15%"><span class="REGULARTEXT"><input type=CHECKBOX name="repLogsCheckBoxList" value="<%=repInfos[i].getId()%>">&nbsp;<%=repInfos[i].getName()%></span></td>                     
                       </tr> 
                     
                     <%}%>
                      
                    </table>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  <tr>
                    <td height="100%">&nbsp;</td>
                  </tr>
                  
                  <tr>
                    <td height="100%">&nbsp;</td>
                  </tr>
                  
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="30%">&nbsp;</td>
            <td width="150" align="center">
              <table border="0" width="100%">
                <tr>
                  <td width="40%"><a href="javascript:window.close()" class="LINK">cancel</a></td>
                  <td width="40%">
                    <p align="center"><a href="javascript:doOK()" class="LINK">ok</a></td>
                  <td width="*">&nbsp;</td>
                </tr>
              </table>
            </td>
            <td width="20%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>

</body>
</html>