<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.WizardNode"%>
<%@ page import="xpolog.eye.admin.wizards.common.nodes.*"%>
<%@ page import="xpolog.eye.admin.wizards.generator.WizardGeneratorBuilder"%>


<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>

<%! 
	String getTreeDiv(WizardGeneratorBuilder builder,HashMap nodes, boolean addTypeToId, String treeName){
		return getTreeDiv(builder, builder.getWizardRootModuleNode(true), nodes, addTypeToId, treeName, false);
	}


	String getTreeDiv(WizardGeneratorBuilder builder, WizardNode node, HashMap nodes, boolean addTypeToId, String treeName, boolean disable){
	  StringBuffer buffer = new StringBuffer();
	  String type = addTypeToId ? WizardModuleNode.WIZARD_MODULE_NODE_TYPE+"," : "";
	  if (treeName == null || treeName.length() == 0) treeName = "tree";
	  if (node != null){
	    boolean selected = false;
	    String treeKey = "node" + node.getID() + "_0";
	    String chkKey = "nodes";
	    buffer.append("\nvar " + treeKey + " = "+treeName+".addNode("+treeName+".root,\"" + chkKey + "\",\"" + type+node.getID() + "\",\"" + node.getName() + "\",\"" + node.getDescription() + "\",''," + selected + ",true,"+disable+");");
	    addChildsNodeDiv(builder,node,buffer,treeKey,nodes,addTypeToId,treeName);
	  }
	  return buffer.toString();
	}
	
	void addChildsNodeDiv(WizardGeneratorBuilder builder, WizardNode node, StringBuffer buffer, String parentKey, HashMap nodes, boolean addTypeToId, String treeName){
		List children = node.getChilds();
	  for (int i = 0; i < children.size(); i++) {
	    WizardNode child = (WizardNode)children.get(i);
    	if (child.isInternal()){
    		continue;
    	}
	   	String key = child.getID();
	    String treeKey = parentKey + "_" + i;
	    String parentNode = parentKey.equals("node") ? "tree.root" : parentKey;
	    String type = addTypeToId ? child.getType()+"," : "";
	    String extraText = "";
	    
	    boolean selected = false;
	    String chkKey = "nodes";
	    buffer.append("\nvar " + treeKey + " = "+treeName+".addNode(" + parentNode + ",\"" + chkKey +"\",\"" + type+child.getID() + "\",\"" + child.getName() + "\",\"" + child.getDescription() + "\",'" + extraText + "'," + selected + ",true,false);");
	    addChildsNodeDiv(builder,child,buffer,treeKey,nodes,addTypeToId,treeName);
	  }
	}
%>
