<%@ page language="java"%>

<%@ page import="xpolog.eye.reports.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.admin.wizards.generator.WizardGeneratorBuilder"%>
<%@ page import="xpolog.eye.admin.wizards.common.WizardNode"%>
<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION,true)){
	  return;
	}
	UserContext userContext = UserEnvironment.getUserContext(request);
	ReportsManager reportMgr = ReportsManager.getInstance();
	List reportsList = reportMgr.getAllBasicReports(userContext,false);
	WizardGeneratorBuilder builder = (WizardGeneratorBuilder)request.getSession().getAttribute(WizardGeneratorBuilder.WIZARD_GENERATOR_BUILDER_TAG);
  WizardNode[] wizNodeArr = builder.getWizardModuleNodes();
	String parentWizardNodeId = request.getParameter("parentId");

%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css" />

<script>
  function doSelect(id){
  	document.access.reportId.value = id;
		document.access.action="wizardReportLogsToRepository.jsp";
		document.access.submit();
	}
   
	function showParentDiv(show){
		if (show){
			document.getElementById("parentDiv").style.display = "";
		}else{
			document.getElementById("parentDiv").style.display = "none";
		}
	}
</script>
</head>

<body>

<form AUTOCOMPLETE="OFF" id="access" name="access" method="post">
<input type="hidden" name="reportId">
<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
  <tr valign="top">
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="0">
      <tr>
        <td valign="top" height="100%">
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
            <table border="0" cellpadding="0" cellspacing="0"  width="100%" id="AutoNumber2">              
	      
              <tr>
                <td width="1%" class="TOPLEFTBORDER ">&nbsp;</td>
                <td width="55%" class="TOPBORDER">
                <span class="PAGEHEADER">Reports Definition </span></td>
                <td width="100%" class="TOPRIGHTBORDER">&nbsp;</td>
              </tr>
              <tr>
                <td width="3%">&nbsp;</td>
                <td width="147%" colspan="2">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
								  <tr><td >&nbsp;</td></tr>
                  <tr>
                    <td>
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber6">
                      <tr class="TABLES_HEADERS">
                        <td width="30%"><span class="REGULARTEXT">Name</span></td>
                        <td width="30%"><span class="REGULARTEXT">Description</span></td>
                        <td width="20%"></td>                       
                      </tr>
                     <%
                      for(int i=0;i<reportsList.size();i++){
  											Report rep = (Report)reportsList.get(i);
                        String id = rep.getId();
												String viewUrl = rep.getViewUrl();
												if (viewUrl != null){
												  viewUrl = viewUrl.replaceAll("\\[REPORT_ID\\]",id);
												}
											%>
                      <tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
											  <td width="30%" height="20"><span class="REGULARTEXT"><nobr><%=rep.getReportName()%></nobr></span></td>
                        <td width="30%"><span class="REGULARTEXT"><%=((Report)reportsList.get(i)).getDescription()%></span></td>
                        <td width="20%" align="right" style="padding-right:10"><a href="javascript:doSelect('<%=id%>')" class="LINK">select</a></td>
                      </tr>
                      <%
                      }
                      %>
                      <tr>
											  <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                      </tr>
                    </table>
                   </td>
                  </tr>
                  <tr>
                  	<td height="50">&nbsp;</td>
                  </tr>
                  
                  <tr>
                  	<td><span class="HEADER">Logs to use:</span></td>
                  </tr>
                  <tr>
                  	<td height="30" valign="bottom"><span class="REGULARTEXT"><input type="radio" name="useLogReports" value="false" checked onclick="javascript:showParentDiv(false)">Dynamically</span></td>
                  </tr>
                  <tr>
                  	<td height="25"><span class="REGULARTEXT"><input type="radio" name="useLogReports" value="true" onclick="javascript:showParentDiv(true)">Add reports logs to wizard</span></td>
                  </tr>
                  
									<tr>
										<td>
											<div id="parentDiv" style="display:none">
			                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber3" height="53">
			                  <tr>
													<td width="30%"><span class="REGULARTEXT">Parent wizard node&nbsp;&nbsp;</span></td>
													<td width="70%">
													<select size="1" class="TEXTBOX" name="parentModuleId">
													<%
													String selected = "";
													for(int i=0;i<wizNodeArr.length;++i){
														if((parentWizardNodeId != null && wizNodeArr[i].getID().equals(parentWizardNodeId))){
															selected = "selected=\"true\"";
														}else{
															selected = "";
														}
													%>
													<option class="TEXTBOX" value="<%=wizNodeArr[i].getID()%>" <%=selected%>><%=wizNodeArr[i].getName()%></option>
													<%}%>
													</select>
													</td>
												</tr>
											</table>
											</div>
										</td>
									</tr>
                  
                  <tr>
                    <td width="100%" >
										  <table border="0" width="100%" cellspacing="0" cellpadding="0">
										    <tr>
										      <td width="33%">&nbsp;</td>
										      <td width="33%">
										        <table border="0" width="100%" cellspacing="0" cellpadding="0">
										          <tr>
										            <td width="33%">&nbsp;</td>
										            <td width="33%"><a href="javascript:window.close()" class="LINK">cancel</a></td>
										            <td width="34%">&nbsp;</td>
										          </tr>
										        </table>
										      </td>
										      <td width="34%">&nbsp;</td>
										    </tr>
										  </table>
										</td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    </td>
                  </tr>
                </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%">&nbsp;</td>
          </tr>
          <tr valign="bottom">
        <td valign="bottom" height="10%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%">
          <tr>
            <td class="BOTTOMLEFTBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMBORDER" width="33%">&nbsp;</td>
            <td class="BOTTOMRIGHTBORDER" width="34%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
        </table>
        </td>
      </tr>      
    </table>
    </td>
  </tr>
</table>
</form>
</body>

</html>