<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.wizards.generator.WizardGeneratorBuilder"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.nodes.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.signatures.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.site.*"%>

<%@ page import="java.util.*"%>
<%@ page import="xpolog.eye.security.*"%>

<%@ include file="metaDataCreatorAction.jsp" %>
<%!
  static final String BASE_DIRECTORY = "../../";
%>
<%
  if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.ConfigurationPermissions.WIZARD_GENERATION_PERMISSION,true)){
    return;
  }

  String ERROR_OBJ = "ERROR_OBJ";
  
  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  WizardGeneratorBuilder builder = (WizardGeneratorBuilder)request.getSession().getAttribute(WizardGeneratorBuilder.WIZARD_GENERATOR_BUILDER_TAG);

  String selectedTabId = request.getParameter("selectedTabId");
  if (selectedTabId == null){
  	selectedTabId = "";
  }
  //general data
  String appName = request.getParameter("appName");
  String appDesc = request.getParameter("appDesc");
  builder.setApplicationName(appName);
  builder.setDesc(appDesc);
  //signatures
  /*HashMap signatures = new HashMap();
  //windows
  String machineName = request.getParameter("winSigMachineName");
  String type = request.getParameter("winSigType");
  String regPath = request.getParameter("winSigRegPath");
  String regKey = request.getParameter("winSigRegKey");
  String regRegexp = request.getParameter("winSigRegRegexp");
	String defaultPath = request.getParameter("winSigDefaultPath");
	String useRegexpOnDefaultPathStr = request.getParameter("winSigUseRegexpOnDefaultPath");
	boolean useRegexpOnDefaultPath = (useRegexpOnDefaultPathStr != null && useRegexpOnDefaultPathStr.equals("true") ? true : false);
	String defaultPathRegexp = request.getParameter("winSigDefaultPathRegexp");
  WindowsSignature winSig = new WindowsSignature(machineName, type, regPath, regKey, regRegexp, defaultPath, useRegexpOnDefaultPath, defaultPathRegexp);
  signatures.put(winSig.getType() != null && !winSig.getType().equals("") && !winSig.getType().equals(winSig.getDefaultType()) ? winSig.getType() : winSig.getDefaultType(),winSig);
	//linux
  machineName = request.getParameter("linuxSigMachineName");
  type = request.getParameter("linuxSigType");
  String searchInstallationCommand = request.getParameter("linuxSigSearchInstallationCommand");
  String searchInstallationRegexp = request.getParameter("linuxSigSearchInstallationRegexp");
  String searchPathCommand = request.getParameter("linuxSigSearchPathCommand");
	String searchPathRegexp = request.getParameter("linuxSigSearchPathRegexp");
	String searchPathGrepTerm = request.getParameter("linuxSigSearchPathGrepTerm");
	String searchTerm = request.getParameter("linuxSigSearchTerm");
	defaultPath = request.getParameter("linuxSigDefaultPath");
	UnixSignature unixSig = new LinuxSignature(machineName, type, searchInstallationCommand, searchInstallationRegexp, searchPathCommand, searchPathRegexp, searchPathGrepTerm, searchTerm, defaultPath);	
	signatures.put(unixSig.getType() != null && !unixSig.getType().equals("") && !unixSig.getType().equals(unixSig.getDefaultType()) ? unixSig.getType() : unixSig.getDefaultType(),unixSig);
  //solaris
  machineName = request.getParameter("solarisSigMachineName");
  type = request.getParameter("solarisSigType");
  searchInstallationCommand = request.getParameter("solarisSigSearchInstallationCommand");
  searchInstallationRegexp = request.getParameter("solarisSigSearchInstallationRegexp");
  searchPathCommand = request.getParameter("solarisSigSearchPathCommand");
	searchPathRegexp = request.getParameter("solarisSigSearchPathRegexp");
	searchPathGrepTerm = request.getParameter("solarisSigSearchPathGrepTerm");
	searchTerm = request.getParameter("solarisSigSearchTerm");
	defaultPath = request.getParameter("solarisSigDefaultPath");
	unixSig = new SolarisSignature(machineName, type, searchInstallationCommand, searchInstallationRegexp, searchPathCommand, searchPathRegexp, searchPathGrepTerm, searchTerm, defaultPath);	
	signatures.put(unixSig.getType() != null && !unixSig.getType().equals("") && !unixSig.getType().equals(unixSig.getDefaultType()) ? unixSig.getType() : unixSig.getDefaultType(),unixSig);
  
  builder.setWizardSignatures(signatures);
  */
  //meta data
  MetaData metaData = createMetaData(request,response);
  builder.setMetaData(metaData);
  request.getSession().setAttribute(WizardGeneratorBuilder.WIZARD_GENERATOR_BUILDER_META_DATA_TAG,metaData);
  
  //module
  String parentModuleId = request.getParameter("parentModId");
  //existing module
  String modId = request.getParameter("modId");
  if (modId != null && modId.length() > 0){
  	builder.addModule(modId,parentModuleId);
  }
  //new module
  String modName = request.getParameter("modName");
  String modDesc = request.getParameter("modDesc");
  if (modName != null && modName.length() > 0){
  	builder.addNewModule(modName,modDesc,parentModuleId);
  }
  
  //log
  String logId = request.getParameter("logId");
  String useTemplateStr = request.getParameter("useTemplate");
  boolean useTemplate = useTemplateStr != null && useTemplateStr.equals("true");
  if (parentModuleId != null && parentModuleId.length() > 0 &&  logId != null && logId.length() > 0){
  	if (useTemplate){
	  	builder.addLogTemplate(logId,parentModuleId);
  	}else{
	  	builder.addLog(logId,parentModuleId);
  	}
  }
  //rep logs
  String repLogs = request.getParameter("repLogs");
  if (repLogs != null && repLogs.length() > 0 && parentModuleId != null && parentModuleId.length() > 0){
  	builder.addLogsFromRep(repLogs,parentModuleId); 	
  }
  //scanner node
  String className = request.getParameter("className");
  String fullClassPath = request.getParameter("fullClassPath");
  String rootClassPath = request.getParameter("rootClassPath");
  if(className != null && className.length() >0 && fullClassPath != null && fullClassPath.length()>0 &&
		  rootClassPath != null && rootClassPath.length()>0){
	  builder.addScannerNode(className,fullClassPath,parentModuleId,rootClassPath);
  }
		  
  
  //repository log
  String objectId = request.getParameter("objectId");
  String repInfoType = request.getParameter("xplgObjectType");
  String repInfoId = request.getParameter("repInfoId");
  String repInfoName = request.getParameter("repInfoName");
  String repInfoDesc = request.getParameter("repInfoDesc");
  String repInfoVersion = request.getParameter("repInfoVersion");
  String repInfoBuildStr = request.getParameter("repInfoBuild");
  int repInfoBuild = 0;
  try{
  	repInfoBuild = Integer.parseInt(repInfoBuildStr);
  }catch(Exception e){
  }
  int matchingLevel = 1; //only filters
  if (repInfoId != null && repInfoId.length() > 0){
	  builder.addRepositoryInfo(objectId,repInfoType,repInfoId,repInfoName,repInfoDesc,repInfoVersion,repInfoBuild,matchingLevel);
  }
  
  //configuration wizard
  WizardInfo info = (WizardInfo)env.getTempAttribute("WIZARD_INFO");
  String wizConfigFile = request.getParameter("wizConfigFile");
  if (info != null && wizConfigFile != null && wizConfigFile.length() > 0){
  	builder.addConfigurationWizard(info,wizConfigFile,parentModuleId);
  }
  
  //remove node
  String nodeToDeleteId = request.getParameter("nodeToDelete");
  if (nodeToDeleteId != null && nodeToDeleteId.length() > 0){
  	builder.removeWizardNode(nodeToDeleteId);
  }
  
  //remove rep log
  String repIdToDelete = request.getParameter("repIdToDelete");
  if (repIdToDelete != null && repIdToDelete.length() > 0){
  	builder.removeRepositoryInfo(repIdToDelete);
  }
  
  //reload rep log
  String repIdToReload = request.getParameter("repIdToReload");
  if (repIdToReload != null && repIdToReload.length() > 0){
  	builder.reloadRepositoryInfo(repIdToReload);
  }
  
  //properties
	String numWizPropsStr = request.getParameter("numberOfWizProps");
	int numWizProps = (numWizPropsStr == null || numWizPropsStr.length() == 0) ? 0 : Integer.parseInt(numWizPropsStr);
	Properties newWizProps = new Properties();
	String key,value;
	for (int i=1; i<=numWizProps; i++){
		key = request.getParameter("wiz_key_"+i);
		value = request.getParameter("wiz_value_"+i);
		if (key != null && value != null && key.length() > 0 && value.length() > 0){
			newWizProps.setProperty(key,value);
		}
	}
	builder.setProperties(newWizProps);
	
	//add report
	String reportId = request.getParameter("reportId");
	String useReportLogsStr = request.getParameter("useReportLogs");
	boolean useReportLogs = useReportLogsStr != null && useReportLogsStr.equals("true");
	String lbmToRepIdsStr = request.getParameter("lbmToRepIds");
	HashMap lbmToRepIds = new HashMap();
	if (lbmToRepIdsStr != null && lbmToRepIdsStr.length() > 0){
		String[] entries = lbmToRepIdsStr.split(",");
		String e, lbmId, repId;
		String[] values;
		for (int i=0; i<entries.length; i++){
			e = entries[i];
			values = e.split("=");
			if (values != null && values.length == 2){
				lbmToRepIds.put(values[0],values[1]);
			}
		}
	}
	if (reportId != null && reportId.length() > 0){
		builder.addReportbyId(reportId,parentModuleId,useReportLogs,lbmToRepIds);
	}
	
	//delete report
	String reportIdToDelete = request.getParameter("reportIdToDelete");
	if (reportIdToDelete != null && reportIdToDelete.length() > 0){
		builder.removeReport(reportIdToDelete);
	}
	
	//save
	String doSaveStr = request.getParameter("doSave");
	boolean doSave = doSaveStr != null && doSaveStr.equals("true");
	if (doSave){
		builder.generateWizard();
		response.sendRedirect(BASE_DIRECTORY+"common/opok.jsp?okUrl=wizards/wizardsview.jsp&message=wizard saved successfully");
		return;
	}

  

  response.sendRedirect("wizardGeneratorAdmin.jsp?selectedTabId="+selectedTabId);
	
%>
