<%@ page language="java"%>

<%@ page import="xpolog.eye.admin.wizards.generator.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.data.filters.*"%>
<%@ page import="xpolog.eye.reports.*"%>

<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY = "../../";
%>
     
<%
	
	WizardGeneratorBuilder builder = (WizardGeneratorBuilder)request.getSession().getAttribute(WizardGeneratorBuilder.WIZARD_GENERATOR_BUILDER_TAG);
	String parentWizardNodeId = request.getParameter("parentWizardNodeId");
	if (parentWizardNodeId == null){
		parentWizardNodeId = "";
	}
	WizardNode parentWizardNode = builder.getWizardNodeById(parentWizardNodeId);
	
	Report[] reports = builder.getAllReports();
%>

<script src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script src="nodes/moduleOrLogSelection.js"></script>
<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";

	function openReportSelection(){
		var param = "?logSelection=true&repLog=true"; 
		var id = getSelectedNodeId(true);
		if (id != ""){
			param = param + (param == "" ? "?" : "&") + "parentId=" + id;
		}
	  newWindow = window.open("reports/reportSelection.jsp"+param,"ReportSelection","height=400,width=600,resizable=yes,scrollbars=yes,status=yes,left=300,top=200");
	  newWindow.focus();	
	}
	
	function removeReport(id){
		document.access.reportIdToDelete.value = id;
		updateGenerator();
	}
	
	function reloadReport(id){
		document.access.reportId.value = id;
		updateGenerator();
	}
	
</script>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<input type="hidden" name="reportId">
	<input type="hidden" name="reportIdToDelete">
	<input type="hidden" name="useReportLogs">
	<input type="hidden" name="lbmToRepIds">
  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
	            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
	              <tr>
	                <td width="15%" height="28" colspan="3"><span class="HEADER">Reports</span></td>
	              </tr>
	              <tr>
	              	<td>&nbsp;</td>
	              </tr>
	              <tr>
	              	<td>
				            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
				            	<tr>
				            		<td><a href="javascript:openReportSelection()" class="LINK"> add report</a></td>
				            	</tr>
				            	<tr><td>&nbsp;</td></tr>
	              		</table>
	              	</td>
	              </tr>
	              <tr>
	              	<td>
	              		<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
                      <tr class="TABLES_HEADERS">
                        <td width="25%"><span class="REGULARTEXT">Name</span></td>
                        <td width="25%"><span class="REGULARTEXT">Id</span></td>
                        <td width="25%"><span class="REGULARTEXT">Description</span></td>
                        <td width="25%">&nbsp;</td>
                      </tr>
	              			<%
	              			Report report = null;
	              			for (int i=0; i<reports.length; i++){
	              				report = reports[i];
	              				if (report == null){
	              					continue;
	              				}
		              			String reportId = report.getId();
	              				String type = report.getType();
	              				if (type == null){
	              					type = "";
	              				}
	              				String name = report.getReportName();
	              				String desc = report.getDescription();
	              			%>
	              				<tr onMouseOver="javascript:this.className='MARKITEM'" onMouseOut ="javascript:this.className='UNMARKITEM'" class="UNMARKITEM">
	              					<td><span class="REGULARTEXT"><%=name%></span>
	              					<td><span class="REGULARTEXT"><%=reportId%></span></td>
	              					<td><span class="REGULARTEXT"><%=desc%></span></td>
	              					<td align="right">
	              						<a class="LINK" href="javascript:removeReport('<%=reportId%>')">remove</a>&nbsp;
	              						<a class="LINK" href="javascript:reloadReport('<%=reportId%>')">reload</a>
	              					</td>
	              				</tr>
	              			<%
	              			}%>
	              		</table>
	              	</td>
	              </tr>
	          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		

<div id="addReportDiv" style="position:absolute;visibility:hidden;height:80">
	<table border="0" width="350" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
		<tr height="10">
			<td colspan="3" align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
				<span class="PROGRESSTEXT">Add log</span>
			</td>
		</tr>
		<tr height="20">
			<td align="center" style="padding:5">
				<a class="PROGRESSLINK" href="javascript:hideLayer('addRepLogDiv');">cancel</a>&nbsp;
			</td>
			<td align="center" style="padding:5">
				<a class="PROGRESSLINK" href="javascript:openRepDSSelction('true');hideLayer('addRepLogDiv');">select report</a>&nbsp;
			</td>
		</tr>
	</table>
</div>
