<%@ page language="java"%>

<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.admin.wizards.generator.*"%>
<%@ page import="xpolog.eye.repository.*"%>
<%@ page import="java.util.*"%>
<%! 
	static final String BASE_DIRECTORY = "../../";
%>
     
<%@ include file="nodes/wizardModuleTree.jsp"%>

<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.DataSupportPermissions.ENTERPRISE_PERMISSION,true)){
		return;
	}
	
	String ERROR_OBJ = "ERROR_OBJ";
	
	WizardGeneratorBuilder builder = (WizardGeneratorBuilder)request.getSession().getAttribute(WizardGeneratorBuilder.WIZARD_GENERATOR_BUILDER_TAG);
	String parentWizardNodeId = request.getParameter("parentWizardNodeId");
	if (parentWizardNodeId == null){
		parentWizardNodeId = "";
	}
	WizardNode parentWizardNode = builder.getWizardNodeById(parentWizardNodeId);
	HashMap modulesAndLogs = builder.getWizardNodes();
  String treeCode = getTreeDiv(builder, modulesAndLogs, true, "wizardModuleTree");
	
  boolean isRepositoryLogs = (builder.getAllRepositoryInfos().length > 0);	
%>

<script src="<%=BASE_DIRECTORY%>scripts/comps/modulesTree.js"></script>
<script src="nodes/moduleOrLogSelection.js"></script>
<script>
	baseDirectory = "<%=BASE_DIRECTORY%>";

	function showModuleAddMenu(){
		hideLayer('addLogDiv');
		showHideLayerInMiddle('addModuleDiv',-1,120);
	}

	function openDSSelction(isLogSelection){
		var param = (isLogSelection == "true" ? "?logSelection=true" : ""); 
		var id = getSelectedNodeId(true);
		if (id != ""){
			param = param + (param == "" ? "?" : "&") + "parentId=" + id;
		}
	  newWindow = window.open("nodes/dsSelection.jsp"+param,"DataSourceSelection","height=400,width=600,resizable=yes,scrollbars=yes,status=yes,left=300,top=200");
	  newWindow.focus();	
	}
	function openRepLogSelction(){
		var param = ""; 
		var id = getSelectedNodeId(true);
		if (id != ""){
			param = param + (param == "" ? "?" : "&") + "parentId=" + id;
		}
	  newWindow = window.open("nodes/repLogSelection.jsp"+param,"RepLogSelection","height=400,width=600,resizable=yes,scrollbars=yes,status=yes,left=300,top=200");
	  newWindow.focus();	
	}
	
	function addNewModule(){
		var param = "";
		var id = getSelectedNodeId(true);
		if (id != ""){
			param = "?parentId=" + id;
		}
	  newWindow = window.open("nodes/wizardModuleNodeAdmin.jsp"+param,"NewWizardModule","height=400,width=600,resizable=yes,scrollbars=yes,status=yes,left=300,top=200");
	  newWindow.focus();	
	}
	
	function showLogAddMenu(){
		hideLayer('addModuleDiv');
		showHideLayerInMiddle('addLogDiv',-1,120);
	}
	
	function selectLogFromTemplate(){
		var param = "";
		var id = getSelectedNodeId(true);
		if (id != ""){
			param = "?parentId=" + id;
		}
	  newWindow = window.open("nodes/logTemplateSelection.jsp"+param,"LogTemplateSelection","height=400,width=600,resizable=yes,scrollbars=yes,status=yes,left=300,top=200");
	  newWindow.focus();	
		
	}
	
	function removeWizardNode(){
		var id = getSelectedNodeId();
		//alert(id);
		document.access.nodeToDelete.value = id;
		updateGenerator();
	}
	
	function selectWizard(){
		var param = "";
		var id = getSelectedNodeId(true);
		if (id != ""){
			param = "?parentId=" + id;
		}
	  newWindow = window.open("nodes/wizardImportNode.jsp"+param,"WizardSelection","height=400,width=600,resizable=yes,scrollbars=yes,status=yes,left=300,top=200");
	  newWindow.focus();	
	}
	function selectApplicationClass(){
		var param = "";
		var id = getSelectedNodeId(true);
		if (id != ""){
			param = "?parentId=" + id;
			}
	  newWindow = window.open("nodes/scannerNodeSelection.jsp"+param,"scannerNodeSelection","height=400,width=600,resizable=yes,scrollbars=yes,status=yes,left=300,top=200");
	  newWindow.focus();	
	}
</script>

<table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
	<input type="hidden" name="logId">
	<input type="hidden" name="modId">
	<input type="hidden" name="parentModId">
	<input type="hidden" name="modName">
	<input type="hidden" name="modDesc">
	<input type="hidden" name="useTemplate">
	<input type="hidden" name="nodeToDelete">
	<input type="hidden" name="wizId">
	<input type="hidden" name="wizConfigFile">
	<input type="hidden" name="fullClassPath">
	<input type="hidden" name="rootClassPath">
	<input type="hidden" name="className">
	<input type="hidden" name="repLogs">

  <tr>
    <td width="100%">
    <table border="0" width="100%" cellspacing="0" height="100%" cellpadding="0">
      <tr>
        <td>
        <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber1">
          <tr>
            <td width="100%">
	            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%" id="AutoNumber2">
	              <tr>
	                <td width="15%" height="28" colspan="3"><span class="HEADER">Wizard Folders</span></td>
	              </tr>
	              <tr>
	              	<td>&nbsp;</td>
	              </tr>
	              <tr>
	              	<td>
				            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="100%">
				            	<tr>
				            		<td colspan="4">
				            		<a href="javascript:showModuleAddMenu()" class="LINK"> add wizard folder</a>&nbsp;&nbsp;
				            		<a href="javascript:showLogAddMenu()" class="LINK"> add wizard log</a>&nbsp;&nbsp;
				            		<a href="javascript:selectWizard()" class="LINK"> add wizard</a>&nbsp;&nbsp;
				            		<a href="javascript:selectApplicationClass()" class="LINK"> add application class</a>&nbsp;&nbsp;
				            		<a href="javascript:removeWizardNode()" class="LINK"> remove wizard node</a>
				            		</td>
				            	</tr>
											<tr>
												<td class="REGULARTEXT">
													<script>
														 var wizardModuleTree = createTree("wizardModuleTree");
														 <%=treeCode%>
														 wizardModuleTree.onSelectMarkChilds = false;
														 wizardModuleTree.writeTree();
													</script>
												</td>
											</tr>
	              		</table>
	              	</td>
	              </tr>
	          	</table>
        		</td>
	      	</tr>
  		  </table>
    		</td>
			</tr>
		</table>
		</td>
	</tr>
</table>		

<div id="addModuleDiv" style="position:absolute;visibility:hidden;height:80">
	<table border="0" width="350" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
		<tr height="10">
			<td colspan="3" align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
				<span class="PROGRESSTEXT">Add folder</span>
			</td>
		</tr>
		<tr height="20">
			<td align="center" style="padding:5">
				<a class="PROGRESSLINK" href="javascript:hideLayer('addModuleDiv');">cancel</a>&nbsp;
			</td>
			<td align="center" style="padding:5">
				<a class="PROGRESSLINK" href="javascript:addNewModule();hideLayer('addModuleDiv');">new folder</a>&nbsp;
			</td>
			<td align="center" style="padding:5">
				<a class="PROGRESSLINK" href="javascript:openDSSelction('false');hideLayer('addModuleDiv');">select existing folder</a>&nbsp;
			</td>
		</tr>
	</table>
</div>

<div id="addLogDiv" style="position:absolute;visibility:hidden;height:80">
<%int size = isRepositoryLogs ? 450 : 350; %>
	<table border="0" width="<%=size%>" cellspacing="0" height="100%" cellpadding="0" style="background:white;border:2px solid #DBDFE2">
		<tr height="10">
			<td colspan="<%=isRepositoryLogs ? "4" : "3"%>" align="center" style="border-bottom:solid 2px #DBDFE2" bgcolor="#EEF2F5">
				<span class="PROGRESSTEXT" align="center">Add log</span>
			</td>
		</tr>
		<tr height="20">
			<td align="center" style="padding:5">
				<a class="PROGRESSLINK" href="javascript:hideLayer('addLogDiv');">cancel</a>&nbsp;
			</td>
			<td align="center" style="padding:5">
				<a class="PROGRESSLINK" href="javascript:selectLogFromTemplate();hideLayer('addLogDiv');">select log template</a>&nbsp;
			</td>
			<td align="center" style="padding:5">
				<a class="PROGRESSLINK" href="javascript:openDSSelction('true');hideLayer('addLogDiv');">select existing log</a>&nbsp;
			</td>
			<%if(isRepositoryLogs){ %>
			<td align="center" style="padding:5">
				<a class="PROGRESSLINK" href="javascript:openRepLogSelction();hideLayer('addLogDiv');">select repository log</a>&nbsp;
			</td>
			<%} %>
		</tr>
	</table>
</div>
