<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.nodes.*"%>
<%@ page import="xpolog.eye.admin.wizards.common.controlers.*"%>

<%!
  static final String BASE_DIRECTORY = "../../../../";
%>
<%

  String ERROR_OBJ = "ERROR_OBJ";
  String MODULE_ID = "MODULE_ID";
  
  SiteManagment mgmt = SiteManagment.getInstance();
  
  int position = Integer.parseInt(request.getParameter(WizardConstants.VIEW_CONTROL_POSITION_PARAM));
  DefaultWizardBuilder builder =  (DefaultWizardBuilder)request.getSession().getAttribute(WizardConstants.WIZARD_BUILDER_SESSION_ATT);
  WizardListViewControl view = (WizardListViewControl)builder.getControler().getWizardViewControlByPosition(position,true);
  WizardNode rootNode = view.getRootNode();
  /*
  List nodesList = new ArrayList();
  if (rootNode != null){
     nodesList = WizardUtil.getNodesAsList(rootNode);
  }
  */

  String modid = request.getParameter(MODULE_ID);

  if(modid == null || modid.trim().equals("")){
    ErrorModel errmodel = new ErrorModel();
    errmodel.addError("No parent folder was selected. If no folder is available please check your permissions");
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;
  }
  Module parent = mgmt.getModuleFromId(modid);
  rootNode.setValue(parent);
  boolean suc = view.doNext();
  if (!suc){
    request.getSession().setAttribute(ERROR_OBJ,view.getErrorModel());
    response.sendRedirect(view.getErrorURL(true));
  }else {
 		response.sendRedirect(view.getNext().getViewURL());
  }

%>



